#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 9318
#define LARGE_STATE_COUNT 2186
#define SYMBOL_COUNT 269
#define ALIAS_COUNT 1
#define TOKEN_COUNT 127
#define EXTERNAL_TOKEN_COUNT 7
#define FIELD_COUNT 14
#define MAX_ALIAS_SEQUENCE_LENGTH 14
#define PRODUCTION_ID_COUNT 70

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_LBRACE = 2,
  anon_sym_RBRACE = 3,
  anon_sym_package = 4,
  anon_sym_foreign = 5,
  anon_sym_import = 6,
  anon_sym_COMMA = 7,
  anon_sym_COLON_COLON = 8,
  anon_sym_proc = 9,
  anon_sym_DASH_GT = 10,
  anon_sym_where = 11,
  anon_sym_DQUOTEodin_DQUOTE = 12,
  anon_sym_DQUOTEcontextless_DQUOTE = 13,
  anon_sym_DQUOTEstdcall_DQUOTE = 14,
  anon_sym_DQUOTEstd_DQUOTE = 15,
  anon_sym_DQUOTEcdecl_DQUOTE = 16,
  anon_sym_DQUOTEc_DQUOTE = 17,
  anon_sym_DQUOTEfastcall_DQUOTE = 18,
  anon_sym_DQUOTEfast_DQUOTE = 19,
  anon_sym_DQUOTEnone_DQUOTE = 20,
  anon_sym_DQUOTEsystem_DQUOTE = 21,
  anon_sym_struct = 22,
  anon_sym_using = 23,
  anon_sym_enum = 24,
  anon_sym_EQ = 25,
  anon_sym_union = 26,
  anon_sym_bit_field = 27,
  anon_sym_COLON = 28,
  anon_sym_PIPE = 29,
  anon_sym_COLON_EQ = 30,
  anon_sym_POUNDtype = 31,
  anon_sym_AT = 32,
  anon_sym_LPAREN = 33,
  anon_sym_RPAREN = 34,
  anon_sym_DOLLAR = 35,
  anon_sym_PLUS_EQ = 36,
  anon_sym_DASH_EQ = 37,
  anon_sym_STAR_EQ = 38,
  anon_sym_SLASH_EQ = 39,
  anon_sym_PERCENT_EQ = 40,
  anon_sym_AMP_EQ = 41,
  anon_sym_PIPE_EQ = 42,
  anon_sym_CARET_EQ = 43,
  anon_sym_LT_LT_EQ = 44,
  anon_sym_GT_GT_EQ = 45,
  anon_sym_PIPE_PIPE_EQ = 46,
  anon_sym_AMP_AMP_EQ = 47,
  anon_sym_AMP_TILDE_EQ = 48,
  anon_sym_if = 49,
  anon_sym_SEMI = 50,
  anon_sym_do = 51,
  anon_sym_else = 52,
  anon_sym_when = 53,
  anon_sym_for = 54,
  anon_sym_in = 55,
  anon_sym_switch = 56,
  anon_sym_case = 57,
  anon_sym_defer = 58,
  anon_sym_break = 59,
  anon_sym_continue = 60,
  sym_fallthrough_statement = 61,
  anon_sym_return = 62,
  anon_sym_QMARK = 63,
  anon_sym_PLUS = 64,
  anon_sym_DASH = 65,
  anon_sym_TILDE = 66,
  anon_sym_BANG = 67,
  anon_sym_AMP = 68,
  anon_sym_PIPE_PIPE = 69,
  anon_sym_or_else = 70,
  anon_sym_AMP_AMP = 71,
  anon_sym_GT = 72,
  anon_sym_GT_EQ = 73,
  anon_sym_LT_EQ = 74,
  anon_sym_LT = 75,
  anon_sym_EQ_EQ = 76,
  anon_sym_BANG_EQ = 77,
  anon_sym_TILDE_EQ = 78,
  anon_sym_AMP_TILDE = 79,
  anon_sym_LT_LT = 80,
  anon_sym_GT_GT = 81,
  anon_sym_STAR = 82,
  anon_sym_SLASH = 83,
  anon_sym_PERCENT = 84,
  anon_sym_PERCENT_PERCENT = 85,
  anon_sym_DOT = 86,
  anon_sym_LBRACK = 87,
  anon_sym_RBRACK = 88,
  anon_sym_DOT_DOT_EQ = 89,
  anon_sym_DOT_DOT_LT = 90,
  anon_sym_cast = 91,
  anon_sym_transmute = 92,
  anon_sym_auto_cast = 93,
  anon_sym_not_in = 94,
  anon_sym_DOT_DOT = 95,
  anon_sym_or_return = 96,
  anon_sym_or_continue = 97,
  anon_sym_or_break = 98,
  anon_sym_CARET = 99,
  anon_sym_DOT_DOT_DOT = 100,
  anon_sym_dynamic = 101,
  anon_sym_map = 102,
  anon_sym_bit_set = 103,
  anon_sym_matrix = 104,
  anon_sym_DOT2 = 105,
  anon_sym_distinct = 106,
  sym_number = 107,
  anon_sym_DQUOTE = 108,
  anon_sym_BQUOTE = 109,
  anon_sym_SQUOTE = 110,
  aux_sym_character_token1 = 111,
  sym_string_content = 112,
  sym__raw_string_content = 113,
  aux_sym__escape_sequence_token1 = 114,
  sym_escape_sequence = 115,
  anon_sym_true = 116,
  anon_sym_false = 117,
  anon_sym_nil = 118,
  sym_uninitialized = 119,
  sym_tag = 120,
  sym_comment = 121,
  sym__newline = 122,
  sym__backslash = 123,
  sym__nl_comma = 124,
  sym_float = 125,
  sym_block_comment = 126,
  sym_source_file = 127,
  sym_block = 128,
  sym_tagged_block = 129,
  sym_declaration = 130,
  sym_package_declaration = 131,
  sym_import_declaration = 132,
  sym_procedure_declaration = 133,
  sym_procedure = 134,
  sym_where_clause = 135,
  sym_calling_convention = 136,
  sym_overloaded_procedure_declaration = 137,
  sym_struct_declaration = 138,
  sym_enum_declaration = 139,
  sym_union_declaration = 140,
  sym_bit_field_declaration = 141,
  sym_variable_declaration = 142,
  sym_const_declaration = 143,
  sym_const_type_declaration = 144,
  sym_foreign_block = 145,
  sym_attributes = 146,
  sym_attribute = 147,
  sym_parameters = 148,
  sym_parameter = 149,
  sym_default_parameter = 150,
  sym_polymorphic_parameters = 151,
  sym_field = 152,
  sym_statement = 153,
  sym_assignment_statement = 154,
  sym_update_statement = 155,
  sym_if_statement = 156,
  sym_else_if_clause = 157,
  sym_else_clause = 158,
  sym_when_statement = 159,
  sym_else_when_clause = 160,
  sym_for_statement = 161,
  sym__for_in_expression = 162,
  sym__simple_assignment_statement = 163,
  sym_switch_statement = 164,
  sym_switch_case = 165,
  sym_defer_statement = 166,
  sym_break_statement = 167,
  sym_continue_statement = 168,
  sym_var_declaration = 169,
  sym_return_statement = 170,
  sym_label_statement = 171,
  sym_using_statement = 172,
  sym_expression = 173,
  sym__expression_no_tag = 174,
  sym_unary_expression = 175,
  sym_binary_expression = 176,
  sym_ternary_expression = 177,
  sym_call_expression = 178,
  sym_selector_call_expression = 179,
  sym_member_expression = 180,
  sym_index_expression = 181,
  sym_slice_expression = 182,
  sym_range_expression = 183,
  sym_cast_expression = 184,
  sym_in_expression = 185,
  sym_variadic_expression = 186,
  sym_parenthesized_expression = 187,
  sym_or_return_expression = 188,
  sym_or_continue_expression = 189,
  sym_or_break_expression = 190,
  sym_address = 191,
  sym_type = 192,
  sym_pointer_type = 193,
  sym_variadic_type = 194,
  sym_array_type = 195,
  sym_map_type = 196,
  sym_union_type = 197,
  sym_bit_set_type = 198,
  sym_matrix_type = 199,
  sym_field_type = 200,
  sym_tuple_type = 201,
  sym_struct_type = 202,
  sym__struct_members = 203,
  sym_struct_member = 204,
  sym_enum_type = 205,
  sym_bit_field_type = 206,
  sym_named_type = 207,
  sym_default_type = 208,
  sym_constant_type = 209,
  sym_specialized_type = 210,
  sym__procedure_type = 211,
  sym_distinct_type = 212,
  sym_empty_type = 213,
  sym_polymorphic_type = 214,
  sym_conditional_type = 215,
  sym_literal = 216,
  sym_struct = 217,
  sym_map = 218,
  sym_bit_set = 219,
  sym_matrix = 220,
  sym_struct_field = 221,
  sym_string = 222,
  sym__string_literal = 223,
  sym__raw_string_literal = 224,
  sym_character = 225,
  sym_boolean = 226,
  sym_nil = 227,
  sym_field_identifier = 228,
  sym__separator = 229,
  aux_sym_source_file_repeat1 = 230,
  aux_sym_block_repeat1 = 231,
  aux_sym_import_declaration_repeat1 = 232,
  aux_sym_where_clause_repeat1 = 233,
  aux_sym_overloaded_procedure_declaration_repeat1 = 234,
  aux_sym_struct_declaration_repeat1 = 235,
  aux_sym_struct_declaration_repeat2 = 236,
  aux_sym_enum_declaration_repeat1 = 237,
  aux_sym_union_declaration_repeat1 = 238,
  aux_sym_bit_field_declaration_repeat1 = 239,
  aux_sym_variable_declaration_repeat1 = 240,
  aux_sym_const_declaration_repeat1 = 241,
  aux_sym_attributes_repeat1 = 242,
  aux_sym_attribute_repeat1 = 243,
  aux_sym_parameters_repeat1 = 244,
  aux_sym_parameter_repeat1 = 245,
  aux_sym_polymorphic_parameters_repeat1 = 246,
  aux_sym_polymorphic_parameters_repeat2 = 247,
  aux_sym_field_repeat1 = 248,
  aux_sym_if_statement_repeat1 = 249,
  aux_sym_when_statement_repeat1 = 250,
  aux_sym__simple_assignment_statement_repeat1 = 251,
  aux_sym_switch_statement_repeat1 = 252,
  aux_sym_switch_case_repeat1 = 253,
  aux_sym_return_statement_repeat1 = 254,
  aux_sym_call_expression_repeat1 = 255,
  aux_sym_field_type_repeat1 = 256,
  aux_sym_tuple_type_repeat1 = 257,
  aux_sym_struct_type_repeat1 = 258,
  aux_sym_struct_type_repeat2 = 259,
  aux_sym__struct_members_repeat1 = 260,
  aux_sym_struct_member_repeat1 = 261,
  aux_sym_polymorphic_type_repeat1 = 262,
  aux_sym_struct_repeat1 = 263,
  aux_sym_struct_repeat2 = 264,
  aux_sym_map_repeat1 = 265,
  aux_sym__string_literal_repeat1 = 266,
  aux_sym__raw_string_literal_repeat1 = 267,
  aux_sym_field_identifier_repeat1 = 268,
  alias_sym_procedure_type = 269,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_package] = "package",
  [anon_sym_foreign] = "foreign",
  [anon_sym_import] = "import",
  [anon_sym_COMMA] = ",",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_proc] = "proc",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_where] = "where",
  [anon_sym_DQUOTEodin_DQUOTE] = "\"odin\"",
  [anon_sym_DQUOTEcontextless_DQUOTE] = "\"contextless\"",
  [anon_sym_DQUOTEstdcall_DQUOTE] = "\"stdcall\"",
  [anon_sym_DQUOTEstd_DQUOTE] = "\"std\"",
  [anon_sym_DQUOTEcdecl_DQUOTE] = "\"cdecl\"",
  [anon_sym_DQUOTEc_DQUOTE] = "\"c\"",
  [anon_sym_DQUOTEfastcall_DQUOTE] = "\"fastcall\"",
  [anon_sym_DQUOTEfast_DQUOTE] = "\"fast\"",
  [anon_sym_DQUOTEnone_DQUOTE] = "\"none\"",
  [anon_sym_DQUOTEsystem_DQUOTE] = "\"system\"",
  [anon_sym_struct] = "struct",
  [anon_sym_using] = "using",
  [anon_sym_enum] = "enum",
  [anon_sym_EQ] = "=",
  [anon_sym_union] = "union",
  [anon_sym_bit_field] = "bit_field",
  [anon_sym_COLON] = ":",
  [anon_sym_PIPE] = "|",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_POUNDtype] = "tag",
  [anon_sym_AT] = "@",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_AMP_TILDE_EQ] = "&~=",
  [anon_sym_if] = "if",
  [anon_sym_SEMI] = ";",
  [anon_sym_do] = "do",
  [anon_sym_else] = "else",
  [anon_sym_when] = "when",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_defer] = "defer",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [sym_fallthrough_statement] = "fallthrough_statement",
  [anon_sym_return] = "return",
  [anon_sym_QMARK] = "\?",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_TILDE] = "~",
  [anon_sym_BANG] = "!",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_or_else] = "or_else",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_TILDE_EQ] = "~=",
  [anon_sym_AMP_TILDE] = "&~",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PERCENT_PERCENT] = "%%",
  [anon_sym_DOT] = ".",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOT_DOT_EQ] = "..=",
  [anon_sym_DOT_DOT_LT] = "..<",
  [anon_sym_cast] = "cast",
  [anon_sym_transmute] = "transmute",
  [anon_sym_auto_cast] = "auto_cast",
  [anon_sym_not_in] = "not_in",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_or_return] = "or_return",
  [anon_sym_or_continue] = "or_continue",
  [anon_sym_or_break] = "or_break",
  [anon_sym_CARET] = "^",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_dynamic] = "dynamic",
  [anon_sym_map] = "map",
  [anon_sym_bit_set] = "bit_set",
  [anon_sym_matrix] = "matrix",
  [anon_sym_DOT2] = ".",
  [anon_sym_distinct] = "distinct",
  [sym_number] = "number",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_character_token1] = "character_token1",
  [sym_string_content] = "string_content",
  [sym__raw_string_content] = "string_content",
  [aux_sym__escape_sequence_token1] = "_escape_sequence_token1",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_nil] = "nil",
  [sym_uninitialized] = "uninitialized",
  [sym_tag] = "tag",
  [sym_comment] = "comment",
  [sym__newline] = "_newline",
  [sym__backslash] = "_backslash",
  [sym__nl_comma] = ",",
  [sym_float] = "float",
  [sym_block_comment] = "block_comment",
  [sym_source_file] = "source_file",
  [sym_block] = "block",
  [sym_tagged_block] = "tagged_block",
  [sym_declaration] = "declaration",
  [sym_package_declaration] = "package_declaration",
  [sym_import_declaration] = "import_declaration",
  [sym_procedure_declaration] = "procedure_declaration",
  [sym_procedure] = "procedure",
  [sym_where_clause] = "where_clause",
  [sym_calling_convention] = "calling_convention",
  [sym_overloaded_procedure_declaration] = "overloaded_procedure_declaration",
  [sym_struct_declaration] = "struct_declaration",
  [sym_enum_declaration] = "enum_declaration",
  [sym_union_declaration] = "union_declaration",
  [sym_bit_field_declaration] = "bit_field_declaration",
  [sym_variable_declaration] = "variable_declaration",
  [sym_const_declaration] = "const_declaration",
  [sym_const_type_declaration] = "const_type_declaration",
  [sym_foreign_block] = "foreign_block",
  [sym_attributes] = "attributes",
  [sym_attribute] = "attribute",
  [sym_parameters] = "parameters",
  [sym_parameter] = "parameter",
  [sym_default_parameter] = "default_parameter",
  [sym_polymorphic_parameters] = "polymorphic_parameters",
  [sym_field] = "field",
  [sym_statement] = "statement",
  [sym_assignment_statement] = "assignment_statement",
  [sym_update_statement] = "update_statement",
  [sym_if_statement] = "if_statement",
  [sym_else_if_clause] = "else_if_clause",
  [sym_else_clause] = "else_clause",
  [sym_when_statement] = "when_statement",
  [sym_else_when_clause] = "else_when_clause",
  [sym_for_statement] = "for_statement",
  [sym__for_in_expression] = "_for_in_expression",
  [sym__simple_assignment_statement] = "assignment_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_case] = "switch_case",
  [sym_defer_statement] = "defer_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_var_declaration] = "var_declaration",
  [sym_return_statement] = "return_statement",
  [sym_label_statement] = "label_statement",
  [sym_using_statement] = "using_statement",
  [sym_expression] = "expression",
  [sym__expression_no_tag] = "_expression_no_tag",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_ternary_expression] = "ternary_expression",
  [sym_call_expression] = "call_expression",
  [sym_selector_call_expression] = "selector_call_expression",
  [sym_member_expression] = "member_expression",
  [sym_index_expression] = "index_expression",
  [sym_slice_expression] = "slice_expression",
  [sym_range_expression] = "range_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_in_expression] = "in_expression",
  [sym_variadic_expression] = "variadic_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_or_return_expression] = "or_return_expression",
  [sym_or_continue_expression] = "or_continue_expression",
  [sym_or_break_expression] = "or_break_expression",
  [sym_address] = "address",
  [sym_type] = "type",
  [sym_pointer_type] = "pointer_type",
  [sym_variadic_type] = "variadic_type",
  [sym_array_type] = "array_type",
  [sym_map_type] = "map_type",
  [sym_union_type] = "union_type",
  [sym_bit_set_type] = "bit_set_type",
  [sym_matrix_type] = "matrix_type",
  [sym_field_type] = "field_type",
  [sym_tuple_type] = "tuple_type",
  [sym_struct_type] = "struct_type",
  [sym__struct_members] = "_struct_members",
  [sym_struct_member] = "struct_member",
  [sym_enum_type] = "enum_type",
  [sym_bit_field_type] = "bit_field_type",
  [sym_named_type] = "named_type",
  [sym_default_type] = "default_type",
  [sym_constant_type] = "constant_type",
  [sym_specialized_type] = "specialized_type",
  [sym__procedure_type] = "_procedure_type",
  [sym_distinct_type] = "distinct_type",
  [sym_empty_type] = "empty_type",
  [sym_polymorphic_type] = "polymorphic_type",
  [sym_conditional_type] = "conditional_type",
  [sym_literal] = "literal",
  [sym_struct] = "struct",
  [sym_map] = "map",
  [sym_bit_set] = "bit_set",
  [sym_matrix] = "matrix",
  [sym_struct_field] = "struct_field",
  [sym_string] = "string",
  [sym__string_literal] = "_string_literal",
  [sym__raw_string_literal] = "_raw_string_literal",
  [sym_character] = "character",
  [sym_boolean] = "boolean",
  [sym_nil] = "nil",
  [sym_field_identifier] = "field_identifier",
  [sym__separator] = "_separator",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_block_repeat1] = "block_repeat1",
  [aux_sym_import_declaration_repeat1] = "import_declaration_repeat1",
  [aux_sym_where_clause_repeat1] = "where_clause_repeat1",
  [aux_sym_overloaded_procedure_declaration_repeat1] = "overloaded_procedure_declaration_repeat1",
  [aux_sym_struct_declaration_repeat1] = "struct_declaration_repeat1",
  [aux_sym_struct_declaration_repeat2] = "struct_declaration_repeat2",
  [aux_sym_enum_declaration_repeat1] = "enum_declaration_repeat1",
  [aux_sym_union_declaration_repeat1] = "union_declaration_repeat1",
  [aux_sym_bit_field_declaration_repeat1] = "bit_field_declaration_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_const_declaration_repeat1] = "const_declaration_repeat1",
  [aux_sym_attributes_repeat1] = "attributes_repeat1",
  [aux_sym_attribute_repeat1] = "attribute_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_parameter_repeat1] = "parameter_repeat1",
  [aux_sym_polymorphic_parameters_repeat1] = "polymorphic_parameters_repeat1",
  [aux_sym_polymorphic_parameters_repeat2] = "polymorphic_parameters_repeat2",
  [aux_sym_field_repeat1] = "field_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_when_statement_repeat1] = "when_statement_repeat1",
  [aux_sym__simple_assignment_statement_repeat1] = "_simple_assignment_statement_repeat1",
  [aux_sym_switch_statement_repeat1] = "switch_statement_repeat1",
  [aux_sym_switch_case_repeat1] = "switch_case_repeat1",
  [aux_sym_return_statement_repeat1] = "return_statement_repeat1",
  [aux_sym_call_expression_repeat1] = "call_expression_repeat1",
  [aux_sym_field_type_repeat1] = "field_type_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_struct_type_repeat1] = "struct_type_repeat1",
  [aux_sym_struct_type_repeat2] = "struct_type_repeat2",
  [aux_sym__struct_members_repeat1] = "_struct_members_repeat1",
  [aux_sym_struct_member_repeat1] = "struct_member_repeat1",
  [aux_sym_polymorphic_type_repeat1] = "polymorphic_type_repeat1",
  [aux_sym_struct_repeat1] = "struct_repeat1",
  [aux_sym_struct_repeat2] = "struct_repeat2",
  [aux_sym_map_repeat1] = "map_repeat1",
  [aux_sym__string_literal_repeat1] = "_string_literal_repeat1",
  [aux_sym__raw_string_literal_repeat1] = "_raw_string_literal_repeat1",
  [aux_sym_field_identifier_repeat1] = "field_identifier_repeat1",
  [alias_sym_procedure_type] = "procedure_type",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_package] = anon_sym_package,
  [anon_sym_foreign] = anon_sym_foreign,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_proc] = anon_sym_proc,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_DQUOTEodin_DQUOTE] = anon_sym_DQUOTEodin_DQUOTE,
  [anon_sym_DQUOTEcontextless_DQUOTE] = anon_sym_DQUOTEcontextless_DQUOTE,
  [anon_sym_DQUOTEstdcall_DQUOTE] = anon_sym_DQUOTEstdcall_DQUOTE,
  [anon_sym_DQUOTEstd_DQUOTE] = anon_sym_DQUOTEstd_DQUOTE,
  [anon_sym_DQUOTEcdecl_DQUOTE] = anon_sym_DQUOTEcdecl_DQUOTE,
  [anon_sym_DQUOTEc_DQUOTE] = anon_sym_DQUOTEc_DQUOTE,
  [anon_sym_DQUOTEfastcall_DQUOTE] = anon_sym_DQUOTEfastcall_DQUOTE,
  [anon_sym_DQUOTEfast_DQUOTE] = anon_sym_DQUOTEfast_DQUOTE,
  [anon_sym_DQUOTEnone_DQUOTE] = anon_sym_DQUOTEnone_DQUOTE,
  [anon_sym_DQUOTEsystem_DQUOTE] = anon_sym_DQUOTEsystem_DQUOTE,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_bit_field] = anon_sym_bit_field,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_POUNDtype] = sym_tag,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_AMP_TILDE_EQ] = anon_sym_AMP_TILDE_EQ,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_when] = anon_sym_when,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_defer] = anon_sym_defer,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [sym_fallthrough_statement] = sym_fallthrough_statement,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_or_else] = anon_sym_or_else,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_TILDE_EQ] = anon_sym_TILDE_EQ,
  [anon_sym_AMP_TILDE] = anon_sym_AMP_TILDE,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PERCENT_PERCENT] = anon_sym_PERCENT_PERCENT,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DOT_DOT_EQ] = anon_sym_DOT_DOT_EQ,
  [anon_sym_DOT_DOT_LT] = anon_sym_DOT_DOT_LT,
  [anon_sym_cast] = anon_sym_cast,
  [anon_sym_transmute] = anon_sym_transmute,
  [anon_sym_auto_cast] = anon_sym_auto_cast,
  [anon_sym_not_in] = anon_sym_not_in,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_or_return] = anon_sym_or_return,
  [anon_sym_or_continue] = anon_sym_or_continue,
  [anon_sym_or_break] = anon_sym_or_break,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_dynamic] = anon_sym_dynamic,
  [anon_sym_map] = anon_sym_map,
  [anon_sym_bit_set] = anon_sym_bit_set,
  [anon_sym_matrix] = anon_sym_matrix,
  [anon_sym_DOT2] = anon_sym_DOT,
  [anon_sym_distinct] = anon_sym_distinct,
  [sym_number] = sym_number,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_character_token1] = aux_sym_character_token1,
  [sym_string_content] = sym_string_content,
  [sym__raw_string_content] = sym_string_content,
  [aux_sym__escape_sequence_token1] = aux_sym__escape_sequence_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_nil] = anon_sym_nil,
  [sym_uninitialized] = sym_uninitialized,
  [sym_tag] = sym_tag,
  [sym_comment] = sym_comment,
  [sym__newline] = sym__newline,
  [sym__backslash] = sym__backslash,
  [sym__nl_comma] = anon_sym_COMMA,
  [sym_float] = sym_float,
  [sym_block_comment] = sym_block_comment,
  [sym_source_file] = sym_source_file,
  [sym_block] = sym_block,
  [sym_tagged_block] = sym_tagged_block,
  [sym_declaration] = sym_declaration,
  [sym_package_declaration] = sym_package_declaration,
  [sym_import_declaration] = sym_import_declaration,
  [sym_procedure_declaration] = sym_procedure_declaration,
  [sym_procedure] = sym_procedure,
  [sym_where_clause] = sym_where_clause,
  [sym_calling_convention] = sym_calling_convention,
  [sym_overloaded_procedure_declaration] = sym_overloaded_procedure_declaration,
  [sym_struct_declaration] = sym_struct_declaration,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_union_declaration] = sym_union_declaration,
  [sym_bit_field_declaration] = sym_bit_field_declaration,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_const_declaration] = sym_const_declaration,
  [sym_const_type_declaration] = sym_const_type_declaration,
  [sym_foreign_block] = sym_foreign_block,
  [sym_attributes] = sym_attributes,
  [sym_attribute] = sym_attribute,
  [sym_parameters] = sym_parameters,
  [sym_parameter] = sym_parameter,
  [sym_default_parameter] = sym_default_parameter,
  [sym_polymorphic_parameters] = sym_polymorphic_parameters,
  [sym_field] = sym_field,
  [sym_statement] = sym_statement,
  [sym_assignment_statement] = sym_assignment_statement,
  [sym_update_statement] = sym_update_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_else_if_clause] = sym_else_if_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_when_statement] = sym_when_statement,
  [sym_else_when_clause] = sym_else_when_clause,
  [sym_for_statement] = sym_for_statement,
  [sym__for_in_expression] = sym__for_in_expression,
  [sym__simple_assignment_statement] = sym_assignment_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_switch_case] = sym_switch_case,
  [sym_defer_statement] = sym_defer_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_var_declaration] = sym_var_declaration,
  [sym_return_statement] = sym_return_statement,
  [sym_label_statement] = sym_label_statement,
  [sym_using_statement] = sym_using_statement,
  [sym_expression] = sym_expression,
  [sym__expression_no_tag] = sym__expression_no_tag,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_selector_call_expression] = sym_selector_call_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_slice_expression] = sym_slice_expression,
  [sym_range_expression] = sym_range_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_in_expression] = sym_in_expression,
  [sym_variadic_expression] = sym_variadic_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_or_return_expression] = sym_or_return_expression,
  [sym_or_continue_expression] = sym_or_continue_expression,
  [sym_or_break_expression] = sym_or_break_expression,
  [sym_address] = sym_address,
  [sym_type] = sym_type,
  [sym_pointer_type] = sym_pointer_type,
  [sym_variadic_type] = sym_variadic_type,
  [sym_array_type] = sym_array_type,
  [sym_map_type] = sym_map_type,
  [sym_union_type] = sym_union_type,
  [sym_bit_set_type] = sym_bit_set_type,
  [sym_matrix_type] = sym_matrix_type,
  [sym_field_type] = sym_field_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_struct_type] = sym_struct_type,
  [sym__struct_members] = sym__struct_members,
  [sym_struct_member] = sym_struct_member,
  [sym_enum_type] = sym_enum_type,
  [sym_bit_field_type] = sym_bit_field_type,
  [sym_named_type] = sym_named_type,
  [sym_default_type] = sym_default_type,
  [sym_constant_type] = sym_constant_type,
  [sym_specialized_type] = sym_specialized_type,
  [sym__procedure_type] = sym__procedure_type,
  [sym_distinct_type] = sym_distinct_type,
  [sym_empty_type] = sym_empty_type,
  [sym_polymorphic_type] = sym_polymorphic_type,
  [sym_conditional_type] = sym_conditional_type,
  [sym_literal] = sym_literal,
  [sym_struct] = sym_struct,
  [sym_map] = sym_map,
  [sym_bit_set] = sym_bit_set,
  [sym_matrix] = sym_matrix,
  [sym_struct_field] = sym_struct_field,
  [sym_string] = sym_string,
  [sym__string_literal] = sym__string_literal,
  [sym__raw_string_literal] = sym__raw_string_literal,
  [sym_character] = sym_character,
  [sym_boolean] = sym_boolean,
  [sym_nil] = sym_nil,
  [sym_field_identifier] = sym_field_identifier,
  [sym__separator] = sym__separator,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_block_repeat1] = aux_sym_block_repeat1,
  [aux_sym_import_declaration_repeat1] = aux_sym_import_declaration_repeat1,
  [aux_sym_where_clause_repeat1] = aux_sym_where_clause_repeat1,
  [aux_sym_overloaded_procedure_declaration_repeat1] = aux_sym_overloaded_procedure_declaration_repeat1,
  [aux_sym_struct_declaration_repeat1] = aux_sym_struct_declaration_repeat1,
  [aux_sym_struct_declaration_repeat2] = aux_sym_struct_declaration_repeat2,
  [aux_sym_enum_declaration_repeat1] = aux_sym_enum_declaration_repeat1,
  [aux_sym_union_declaration_repeat1] = aux_sym_union_declaration_repeat1,
  [aux_sym_bit_field_declaration_repeat1] = aux_sym_bit_field_declaration_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_const_declaration_repeat1] = aux_sym_const_declaration_repeat1,
  [aux_sym_attributes_repeat1] = aux_sym_attributes_repeat1,
  [aux_sym_attribute_repeat1] = aux_sym_attribute_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_parameter_repeat1] = aux_sym_parameter_repeat1,
  [aux_sym_polymorphic_parameters_repeat1] = aux_sym_polymorphic_parameters_repeat1,
  [aux_sym_polymorphic_parameters_repeat2] = aux_sym_polymorphic_parameters_repeat2,
  [aux_sym_field_repeat1] = aux_sym_field_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_when_statement_repeat1] = aux_sym_when_statement_repeat1,
  [aux_sym__simple_assignment_statement_repeat1] = aux_sym__simple_assignment_statement_repeat1,
  [aux_sym_switch_statement_repeat1] = aux_sym_switch_statement_repeat1,
  [aux_sym_switch_case_repeat1] = aux_sym_switch_case_repeat1,
  [aux_sym_return_statement_repeat1] = aux_sym_return_statement_repeat1,
  [aux_sym_call_expression_repeat1] = aux_sym_call_expression_repeat1,
  [aux_sym_field_type_repeat1] = aux_sym_field_type_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_struct_type_repeat1] = aux_sym_struct_type_repeat1,
  [aux_sym_struct_type_repeat2] = aux_sym_struct_type_repeat2,
  [aux_sym__struct_members_repeat1] = aux_sym__struct_members_repeat1,
  [aux_sym_struct_member_repeat1] = aux_sym_struct_member_repeat1,
  [aux_sym_polymorphic_type_repeat1] = aux_sym_polymorphic_type_repeat1,
  [aux_sym_struct_repeat1] = aux_sym_struct_repeat1,
  [aux_sym_struct_repeat2] = aux_sym_struct_repeat2,
  [aux_sym_map_repeat1] = aux_sym_map_repeat1,
  [aux_sym__string_literal_repeat1] = aux_sym__string_literal_repeat1,
  [aux_sym__raw_string_literal_repeat1] = aux_sym__raw_string_literal_repeat1,
  [aux_sym_field_identifier_repeat1] = aux_sym_field_identifier_repeat1,
  [alias_sym_procedure_type] = alias_sym_procedure_type,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_package] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foreign] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_proc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTEodin_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTEcontextless_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTEstdcall_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTEstd_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTEcdecl_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTEc_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTEfastcall_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTEfast_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTEnone_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTEsystem_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bit_field] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUNDtype] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_TILDE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [sym_fallthrough_statement] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_transmute] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_auto_cast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dynamic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_map] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bit_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_matrix] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_distinct] = {
    .visible = true,
    .named = false,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_character_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym__raw_string_content] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__escape_sequence_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nil] = {
    .visible = true,
    .named = false,
  },
  [sym_uninitialized] = {
    .visible = true,
    .named = true,
  },
  [sym_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__backslash] = {
    .visible = false,
    .named = true,
  },
  [sym__nl_comma] = {
    .visible = true,
    .named = false,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_tagged_block] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_package_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_procedure_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_procedure] = {
    .visible = true,
    .named = true,
  },
  [sym_where_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_calling_convention] = {
    .visible = true,
    .named = true,
  },
  [sym_overloaded_procedure_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_union_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_bit_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_const_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_const_type_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_foreign_block] = {
    .visible = true,
    .named = true,
  },
  [sym_attributes] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_polymorphic_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_update_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_when_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_when_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_in_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_defer_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_var_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_label_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_using_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__expression_no_tag] = {
    .visible = false,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_selector_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_in_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_or_return_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_or_continue_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_or_break_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_address] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_map_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_bit_set_type] = {
    .visible = true,
    .named = true,
  },
  [sym_matrix_type] = {
    .visible = true,
    .named = true,
  },
  [sym_field_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_type] = {
    .visible = true,
    .named = true,
  },
  [sym__struct_members] = {
    .visible = false,
    .named = true,
  },
  [sym_struct_member] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_type] = {
    .visible = true,
    .named = true,
  },
  [sym_bit_field_type] = {
    .visible = true,
    .named = true,
  },
  [sym_named_type] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_type] = {
    .visible = true,
    .named = true,
  },
  [sym_specialized_type] = {
    .visible = true,
    .named = true,
  },
  [sym__procedure_type] = {
    .visible = false,
    .named = true,
  },
  [sym_distinct_type] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_type] = {
    .visible = true,
    .named = true,
  },
  [sym_polymorphic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_literal] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_struct] = {
    .visible = true,
    .named = true,
  },
  [sym_map] = {
    .visible = true,
    .named = true,
  },
  [sym_bit_set] = {
    .visible = true,
    .named = true,
  },
  [sym_matrix] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_field] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__string_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__raw_string_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_character] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__separator] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_where_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_overloaded_procedure_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_union_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_bit_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_const_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_polymorphic_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_polymorphic_parameters_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_when_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__simple_assignment_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_return_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_call_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_type_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__struct_members_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_member_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_polymorphic_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_map_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__raw_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_identifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_procedure_type] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_condition = 4,
  field_consequence = 5,
  field_end = 6,
  field_function = 7,
  field_initializer = 8,
  field_label = 9,
  field_left = 10,
  field_operator = 11,
  field_post = 12,
  field_right = 13,
  field_start = 14,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_end] = "end",
  [field_function] = "function",
  [field_initializer] = "initializer",
  [field_label] = "label",
  [field_left] = "left",
  [field_operator] = "operator",
  [field_post] = "post",
  [field_right] = "right",
  [field_start] = "start",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 2},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 1},
  [5] = {.index = 4, .length = 3},
  [6] = {.index = 7, .length = 1},
  [7] = {.index = 8, .length = 1},
  [8] = {.index = 9, .length = 1},
  [9] = {.index = 10, .length = 2},
  [10] = {.index = 12, .length = 2},
  [11] = {.index = 14, .length = 2},
  [12] = {.index = 16, .length = 1},
  [13] = {.index = 17, .length = 2},
  [14] = {.index = 19, .length = 1},
  [15] = {.index = 20, .length = 3},
  [16] = {.index = 23, .length = 2},
  [17] = {.index = 25, .length = 3},
  [18] = {.index = 28, .length = 1},
  [19] = {.index = 29, .length = 1},
  [20] = {.index = 30, .length = 1},
  [21] = {.index = 31, .length = 3},
  [22] = {.index = 34, .length = 2},
  [23] = {.index = 36, .length = 2},
  [24] = {.index = 38, .length = 1},
  [25] = {.index = 39, .length = 2},
  [26] = {.index = 41, .length = 2},
  [27] = {.index = 43, .length = 2},
  [28] = {.index = 45, .length = 3},
  [29] = {.index = 48, .length = 1},
  [30] = {.index = 49, .length = 4},
  [31] = {.index = 53, .length = 2},
  [32] = {.index = 55, .length = 2},
  [33] = {.index = 57, .length = 2},
  [34] = {.index = 59, .length = 3},
  [35] = {.index = 62, .length = 2},
  [36] = {.index = 64, .length = 2},
  [37] = {.index = 66, .length = 3},
  [38] = {.index = 69, .length = 3},
  [39] = {.index = 72, .length = 2},
  [40] = {.index = 74, .length = 3},
  [41] = {.index = 77, .length = 3},
  [42] = {.index = 80, .length = 3},
  [43] = {.index = 83, .length = 1},
  [44] = {.index = 84, .length = 2},
  [45] = {.index = 86, .length = 3},
  [46] = {.index = 89, .length = 2},
  [47] = {.index = 91, .length = 3},
  [48] = {.index = 94, .length = 3},
  [49] = {.index = 97, .length = 3},
  [50] = {.index = 100, .length = 3},
  [51] = {.index = 103, .length = 3},
  [52] = {.index = 106, .length = 3},
  [53] = {.index = 109, .length = 3},
  [54] = {.index = 112, .length = 4},
  [55] = {.index = 116, .length = 4},
  [56] = {.index = 120, .length = 2},
  [57] = {.index = 122, .length = 2},
  [58] = {.index = 124, .length = 2},
  [59] = {.index = 126, .length = 3},
  [60] = {.index = 129, .length = 4},
  [61] = {.index = 133, .length = 3},
  [62] = {.index = 136, .length = 4},
  [63] = {.index = 140, .length = 4},
  [64] = {.index = 144, .length = 4},
  [65] = {.index = 148, .length = 4},
  [66] = {.index = 152, .length = 3},
  [67] = {.index = 155, .length = 5},
  [68] = {.index = 160, .length = 3},
  [69] = {.index = 163, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_argument, 1},
    {field_operator, 0},
  [2] =
    {field_alias, 1},
  [3] =
    {field_function, 0},
  [4] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [7] =
    {field_label, 2},
  [8] =
    {field_consequence, 1},
  [9] =
    {field_alias, 2},
  [10] =
    {field_argument, 2},
    {field_function, 0},
  [12] =
    {field_function, 0},
    {field_function, 1},
  [14] =
    {field_condition, 1},
    {field_consequence, 2},
  [16] =
    {field_consequence, 2},
  [17] =
    {field_consequence, 1},
    {field_consequence, 2},
  [19] =
    {field_argument, 1},
  [20] =
    {field_argument, 2},
    {field_argument, 3, .inherited = true},
    {field_function, 0},
  [23] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [25] =
    {field_argument, 3},
    {field_function, 0},
    {field_function, 1},
  [28] =
    {field_alias, 3},
  [29] =
    {field_end, 3},
  [30] =
    {field_start, 2},
  [31] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [34] =
    {field_condition, 2},
    {field_consequence, 3},
  [36] =
    {field_condition, 1},
    {field_consequence, 3},
  [38] =
    {field_consequence, 3},
  [39] =
    {field_consequence, 2},
    {field_consequence, 3},
  [41] =
    {field_consequence, 3},
    {field_post, 2},
  [43] =
    {field_consequence, 3},
    {field_initializer, 1},
  [45] =
    {field_condition, 1},
    {field_consequence, 2},
    {field_consequence, 3},
  [48] =
    {field_condition, 1},
  [49] =
    {field_argument, 3},
    {field_argument, 4, .inherited = true},
    {field_function, 0},
    {field_function, 1},
  [53] =
    {field_end, 4},
    {field_start, 2},
  [55] =
    {field_condition, 3},
    {field_consequence, 4},
  [57] =
    {field_condition, 2},
    {field_consequence, 4},
  [59] =
    {field_condition, 3},
    {field_consequence, 4},
    {field_initializer, 1},
  [62] =
    {field_consequence, 3},
    {field_consequence, 4},
  [64] =
    {field_consequence, 4},
    {field_post, 3},
  [66] =
    {field_consequence, 3},
    {field_consequence, 4},
    {field_post, 2},
  [69] =
    {field_condition, 2},
    {field_consequence, 3},
    {field_consequence, 4},
  [72] =
    {field_consequence, 4},
    {field_initializer, 1},
  [74] =
    {field_consequence, 3},
    {field_consequence, 4},
    {field_initializer, 1},
  [77] =
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [80] =
    {field_condition, 1},
    {field_consequence, 4},
    {field_post, 3},
  [83] =
    {field_condition, 2},
  [84] =
    {field_condition, 1},
    {field_condition, 2},
  [86] =
    {field_argument, 2},
    {field_argument, 5, .inherited = true},
    {field_function, 0},
  [89] =
    {field_condition, 3},
    {field_consequence, 5},
  [91] =
    {field_condition, 4},
    {field_consequence, 5},
    {field_initializer, 1},
  [94] =
    {field_condition, 3},
    {field_consequence, 5},
    {field_initializer, 1},
  [97] =
    {field_consequence, 4},
    {field_consequence, 5},
    {field_post, 3},
  [100] =
    {field_condition, 2},
    {field_consequence, 4},
    {field_consequence, 5},
  [103] =
    {field_condition, 2},
    {field_consequence, 5},
    {field_post, 4},
  [106] =
    {field_consequence, 4},
    {field_consequence, 5},
    {field_initializer, 1},
  [109] =
    {field_consequence, 5},
    {field_initializer, 1},
    {field_post, 4},
  [112] =
    {field_condition, 3},
    {field_consequence, 4},
    {field_consequence, 5},
    {field_initializer, 1},
  [116] =
    {field_condition, 1},
    {field_consequence, 4},
    {field_consequence, 5},
    {field_post, 3},
  [120] =
    {field_condition, 1},
    {field_condition, 2, .inherited = true},
  [122] =
    {field_condition, 0, .inherited = true},
    {field_condition, 1, .inherited = true},
  [124] =
    {field_condition, 2},
    {field_condition, 3},
  [126] =
    {field_condition, 1},
    {field_condition, 2},
    {field_condition, 3},
  [129] =
    {field_argument, 3},
    {field_argument, 6, .inherited = true},
    {field_function, 0},
    {field_function, 1},
  [133] =
    {field_condition, 4},
    {field_consequence, 6},
    {field_initializer, 1},
  [136] =
    {field_condition, 2},
    {field_consequence, 5},
    {field_consequence, 6},
    {field_post, 4},
  [140] =
    {field_consequence, 5},
    {field_consequence, 6},
    {field_initializer, 1},
    {field_post, 4},
  [144] =
    {field_condition, 3},
    {field_consequence, 5},
    {field_consequence, 6},
    {field_initializer, 1},
  [148] =
    {field_condition, 3},
    {field_consequence, 6},
    {field_initializer, 1},
    {field_post, 5},
  [152] =
    {field_condition, 2},
    {field_condition, 3},
    {field_condition, 4},
  [155] =
    {field_condition, 3},
    {field_consequence, 6},
    {field_consequence, 7},
    {field_initializer, 1},
    {field_post, 5},
  [160] =
    {field_condition, 4},
    {field_consequence, 5},
    {field_initializer, 2},
  [163] =
    {field_condition, 4},
    {field_consequence, 6},
    {field_initializer, 2},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_procedure_type,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_procedure, 2,
    sym_procedure,
    alias_sym_procedure_type,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 2,
  [5] = 5,
  [6] = 2,
  [7] = 2,
  [8] = 2,
  [9] = 2,
  [10] = 2,
  [11] = 11,
  [12] = 12,
  [13] = 2,
  [14] = 2,
  [15] = 2,
  [16] = 2,
  [17] = 2,
  [18] = 2,
  [19] = 19,
  [20] = 2,
  [21] = 2,
  [22] = 2,
  [23] = 2,
  [24] = 24,
  [25] = 25,
  [26] = 24,
  [27] = 25,
  [28] = 24,
  [29] = 29,
  [30] = 25,
  [31] = 24,
  [32] = 25,
  [33] = 24,
  [34] = 25,
  [35] = 24,
  [36] = 25,
  [37] = 29,
  [38] = 24,
  [39] = 25,
  [40] = 40,
  [41] = 41,
  [42] = 41,
  [43] = 43,
  [44] = 43,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 43,
  [49] = 49,
  [50] = 43,
  [51] = 51,
  [52] = 51,
  [53] = 51,
  [54] = 51,
  [55] = 51,
  [56] = 51,
  [57] = 51,
  [58] = 51,
  [59] = 51,
  [60] = 51,
  [61] = 51,
  [62] = 51,
  [63] = 51,
  [64] = 51,
  [65] = 51,
  [66] = 51,
  [67] = 51,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 77,
  [81] = 81,
  [82] = 72,
  [83] = 25,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 76,
  [90] = 24,
  [91] = 75,
  [92] = 92,
  [93] = 68,
  [94] = 94,
  [95] = 73,
  [96] = 96,
  [97] = 97,
  [98] = 71,
  [99] = 25,
  [100] = 24,
  [101] = 101,
  [102] = 79,
  [103] = 96,
  [104] = 74,
  [105] = 97,
  [106] = 106,
  [107] = 70,
  [108] = 108,
  [109] = 88,
  [110] = 110,
  [111] = 81,
  [112] = 112,
  [113] = 106,
  [114] = 110,
  [115] = 108,
  [116] = 69,
  [117] = 101,
  [118] = 84,
  [119] = 94,
  [120] = 85,
  [121] = 86,
  [122] = 87,
  [123] = 123,
  [124] = 124,
  [125] = 25,
  [126] = 24,
  [127] = 24,
  [128] = 25,
  [129] = 24,
  [130] = 25,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 25,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 29,
  [141] = 24,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 24,
  [147] = 25,
  [148] = 148,
  [149] = 149,
  [150] = 29,
  [151] = 138,
  [152] = 142,
  [153] = 134,
  [154] = 29,
  [155] = 143,
  [156] = 136,
  [157] = 25,
  [158] = 24,
  [159] = 139,
  [160] = 137,
  [161] = 137,
  [162] = 139,
  [163] = 142,
  [164] = 136,
  [165] = 143,
  [166] = 25,
  [167] = 134,
  [168] = 138,
  [169] = 24,
  [170] = 142,
  [171] = 134,
  [172] = 24,
  [173] = 25,
  [174] = 138,
  [175] = 24,
  [176] = 25,
  [177] = 139,
  [178] = 136,
  [179] = 137,
  [180] = 143,
  [181] = 181,
  [182] = 148,
  [183] = 136,
  [184] = 134,
  [185] = 143,
  [186] = 137,
  [187] = 149,
  [188] = 145,
  [189] = 139,
  [190] = 181,
  [191] = 142,
  [192] = 138,
  [193] = 144,
  [194] = 25,
  [195] = 29,
  [196] = 24,
  [197] = 139,
  [198] = 136,
  [199] = 199,
  [200] = 200,
  [201] = 200,
  [202] = 199,
  [203] = 134,
  [204] = 138,
  [205] = 142,
  [206] = 137,
  [207] = 143,
  [208] = 208,
  [209] = 209,
  [210] = 139,
  [211] = 134,
  [212] = 134,
  [213] = 136,
  [214] = 137,
  [215] = 142,
  [216] = 136,
  [217] = 142,
  [218] = 143,
  [219] = 137,
  [220] = 139,
  [221] = 138,
  [222] = 138,
  [223] = 143,
  [224] = 137,
  [225] = 139,
  [226] = 136,
  [227] = 142,
  [228] = 134,
  [229] = 137,
  [230] = 142,
  [231] = 136,
  [232] = 138,
  [233] = 134,
  [234] = 138,
  [235] = 139,
  [236] = 143,
  [237] = 143,
  [238] = 134,
  [239] = 138,
  [240] = 142,
  [241] = 139,
  [242] = 136,
  [243] = 143,
  [244] = 137,
  [245] = 138,
  [246] = 137,
  [247] = 134,
  [248] = 136,
  [249] = 143,
  [250] = 142,
  [251] = 139,
  [252] = 136,
  [253] = 134,
  [254] = 143,
  [255] = 142,
  [256] = 138,
  [257] = 139,
  [258] = 137,
  [259] = 139,
  [260] = 136,
  [261] = 142,
  [262] = 134,
  [263] = 138,
  [264] = 137,
  [265] = 143,
  [266] = 143,
  [267] = 139,
  [268] = 134,
  [269] = 138,
  [270] = 134,
  [271] = 143,
  [272] = 142,
  [273] = 136,
  [274] = 136,
  [275] = 138,
  [276] = 139,
  [277] = 142,
  [278] = 137,
  [279] = 137,
  [280] = 134,
  [281] = 139,
  [282] = 142,
  [283] = 136,
  [284] = 143,
  [285] = 138,
  [286] = 137,
  [287] = 287,
  [288] = 287,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 293,
  [296] = 296,
  [297] = 293,
  [298] = 293,
  [299] = 293,
  [300] = 294,
  [301] = 293,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 305,
  [308] = 308,
  [309] = 303,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 311,
  [315] = 312,
  [316] = 313,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 303,
  [323] = 303,
  [324] = 320,
  [325] = 325,
  [326] = 326,
  [327] = 318,
  [328] = 311,
  [329] = 329,
  [330] = 317,
  [331] = 304,
  [332] = 310,
  [333] = 333,
  [334] = 310,
  [335] = 319,
  [336] = 304,
  [337] = 329,
  [338] = 306,
  [339] = 313,
  [340] = 333,
  [341] = 305,
  [342] = 313,
  [343] = 306,
  [344] = 310,
  [345] = 306,
  [346] = 333,
  [347] = 310,
  [348] = 333,
  [349] = 304,
  [350] = 329,
  [351] = 312,
  [352] = 311,
  [353] = 318,
  [354] = 306,
  [355] = 313,
  [356] = 312,
  [357] = 326,
  [358] = 318,
  [359] = 303,
  [360] = 312,
  [361] = 312,
  [362] = 312,
  [363] = 305,
  [364] = 303,
  [365] = 312,
  [366] = 313,
  [367] = 305,
  [368] = 326,
  [369] = 318,
  [370] = 311,
  [371] = 329,
  [372] = 304,
  [373] = 310,
  [374] = 333,
  [375] = 306,
  [376] = 305,
  [377] = 305,
  [378] = 313,
  [379] = 306,
  [380] = 304,
  [381] = 326,
  [382] = 333,
  [383] = 319,
  [384] = 320,
  [385] = 326,
  [386] = 317,
  [387] = 310,
  [388] = 304,
  [389] = 329,
  [390] = 311,
  [391] = 318,
  [392] = 304,
  [393] = 326,
  [394] = 394,
  [395] = 312,
  [396] = 318,
  [397] = 303,
  [398] = 333,
  [399] = 329,
  [400] = 312,
  [401] = 304,
  [402] = 402,
  [403] = 303,
  [404] = 310,
  [405] = 405,
  [406] = 329,
  [407] = 317,
  [408] = 303,
  [409] = 326,
  [410] = 318,
  [411] = 325,
  [412] = 311,
  [413] = 321,
  [414] = 414,
  [415] = 320,
  [416] = 319,
  [417] = 311,
  [418] = 329,
  [419] = 313,
  [420] = 310,
  [421] = 333,
  [422] = 333,
  [423] = 319,
  [424] = 306,
  [425] = 394,
  [426] = 306,
  [427] = 305,
  [428] = 313,
  [429] = 320,
  [430] = 303,
  [431] = 317,
  [432] = 318,
  [433] = 326,
  [434] = 313,
  [435] = 326,
  [436] = 311,
  [437] = 313,
  [438] = 305,
  [439] = 313,
  [440] = 305,
  [441] = 318,
  [442] = 306,
  [443] = 313,
  [444] = 313,
  [445] = 333,
  [446] = 414,
  [447] = 312,
  [448] = 319,
  [449] = 326,
  [450] = 329,
  [451] = 305,
  [452] = 303,
  [453] = 320,
  [454] = 308,
  [455] = 394,
  [456] = 326,
  [457] = 317,
  [458] = 318,
  [459] = 311,
  [460] = 311,
  [461] = 394,
  [462] = 313,
  [463] = 304,
  [464] = 329,
  [465] = 329,
  [466] = 304,
  [467] = 303,
  [468] = 311,
  [469] = 310,
  [470] = 306,
  [471] = 333,
  [472] = 306,
  [473] = 310,
  [474] = 305,
  [475] = 333,
  [476] = 402,
  [477] = 318,
  [478] = 313,
  [479] = 326,
  [480] = 313,
  [481] = 329,
  [482] = 313,
  [483] = 312,
  [484] = 394,
  [485] = 405,
  [486] = 394,
  [487] = 304,
  [488] = 303,
  [489] = 310,
  [490] = 326,
  [491] = 312,
  [492] = 318,
  [493] = 311,
  [494] = 329,
  [495] = 304,
  [496] = 310,
  [497] = 333,
  [498] = 306,
  [499] = 305,
  [500] = 500,
  [501] = 501,
  [502] = 501,
  [503] = 501,
  [504] = 501,
  [505] = 501,
  [506] = 506,
  [507] = 501,
  [508] = 508,
  [509] = 501,
  [510] = 501,
  [511] = 501,
  [512] = 501,
  [513] = 501,
  [514] = 501,
  [515] = 501,
  [516] = 501,
  [517] = 501,
  [518] = 501,
  [519] = 501,
  [520] = 501,
  [521] = 501,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 535,
  [537] = 537,
  [538] = 537,
  [539] = 533,
  [540] = 533,
  [541] = 535,
  [542] = 537,
  [543] = 533,
  [544] = 535,
  [545] = 535,
  [546] = 537,
  [547] = 533,
  [548] = 537,
  [549] = 533,
  [550] = 535,
  [551] = 533,
  [552] = 535,
  [553] = 537,
  [554] = 533,
  [555] = 535,
  [556] = 533,
  [557] = 537,
  [558] = 533,
  [559] = 559,
  [560] = 537,
  [561] = 535,
  [562] = 535,
  [563] = 533,
  [564] = 537,
  [565] = 537,
  [566] = 533,
  [567] = 535,
  [568] = 537,
  [569] = 535,
  [570] = 570,
  [571] = 533,
  [572] = 533,
  [573] = 535,
  [574] = 537,
  [575] = 533,
  [576] = 537,
  [577] = 535,
  [578] = 535,
  [579] = 533,
  [580] = 537,
  [581] = 581,
  [582] = 533,
  [583] = 537,
  [584] = 537,
  [585] = 535,
  [586] = 537,
  [587] = 533,
  [588] = 535,
  [589] = 537,
  [590] = 533,
  [591] = 537,
  [592] = 535,
  [593] = 537,
  [594] = 535,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 533,
  [599] = 535,
  [600] = 537,
  [601] = 601,
  [602] = 533,
  [603] = 603,
  [604] = 604,
  [605] = 537,
  [606] = 606,
  [607] = 535,
  [608] = 608,
  [609] = 535,
  [610] = 537,
  [611] = 559,
  [612] = 601,
  [613] = 533,
  [614] = 535,
  [615] = 595,
  [616] = 596,
  [617] = 617,
  [618] = 533,
  [619] = 597,
  [620] = 620,
  [621] = 603,
  [622] = 534,
  [623] = 604,
  [624] = 533,
  [625] = 620,
  [626] = 626,
  [627] = 533,
  [628] = 537,
  [629] = 606,
  [630] = 537,
  [631] = 631,
  [632] = 535,
  [633] = 535,
  [634] = 606,
  [635] = 604,
  [636] = 620,
  [637] = 570,
  [638] = 533,
  [639] = 537,
  [640] = 603,
  [641] = 537,
  [642] = 534,
  [643] = 608,
  [644] = 535,
  [645] = 535,
  [646] = 537,
  [647] = 537,
  [648] = 597,
  [649] = 533,
  [650] = 533,
  [651] = 535,
  [652] = 596,
  [653] = 537,
  [654] = 601,
  [655] = 570,
  [656] = 535,
  [657] = 533,
  [658] = 595,
  [659] = 659,
  [660] = 533,
  [661] = 533,
  [662] = 537,
  [663] = 559,
  [664] = 664,
  [665] = 537,
  [666] = 535,
  [667] = 608,
  [668] = 535,
  [669] = 669,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 670,
  [674] = 670,
  [675] = 675,
  [676] = 670,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 670,
  [681] = 681,
  [682] = 682,
  [683] = 670,
  [684] = 684,
  [685] = 670,
  [686] = 686,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 670,
  [691] = 691,
  [692] = 670,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 696,
  [697] = 670,
  [698] = 698,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 670,
  [703] = 703,
  [704] = 670,
  [705] = 705,
  [706] = 706,
  [707] = 670,
  [708] = 708,
  [709] = 709,
  [710] = 708,
  [711] = 711,
  [712] = 712,
  [713] = 713,
  [714] = 714,
  [715] = 715,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 716,
  [724] = 724,
  [725] = 717,
  [726] = 718,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 720,
  [731] = 721,
  [732] = 722,
  [733] = 716,
  [734] = 717,
  [735] = 718,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 720,
  [742] = 721,
  [743] = 722,
  [744] = 716,
  [745] = 737,
  [746] = 717,
  [747] = 718,
  [748] = 748,
  [749] = 749,
  [750] = 737,
  [751] = 751,
  [752] = 752,
  [753] = 720,
  [754] = 721,
  [755] = 755,
  [756] = 722,
  [757] = 716,
  [758] = 758,
  [759] = 717,
  [760] = 760,
  [761] = 718,
  [762] = 762,
  [763] = 721,
  [764] = 720,
  [765] = 765,
  [766] = 766,
  [767] = 737,
  [768] = 718,
  [769] = 736,
  [770] = 717,
  [771] = 716,
  [772] = 722,
  [773] = 721,
  [774] = 720,
  [775] = 721,
  [776] = 722,
  [777] = 716,
  [778] = 751,
  [779] = 717,
  [780] = 718,
  [781] = 720,
  [782] = 720,
  [783] = 783,
  [784] = 752,
  [785] = 737,
  [786] = 718,
  [787] = 717,
  [788] = 760,
  [789] = 716,
  [790] = 765,
  [791] = 722,
  [792] = 792,
  [793] = 721,
  [794] = 783,
  [795] = 737,
  [796] = 796,
  [797] = 720,
  [798] = 721,
  [799] = 722,
  [800] = 716,
  [801] = 720,
  [802] = 802,
  [803] = 803,
  [804] = 717,
  [805] = 718,
  [806] = 766,
  [807] = 737,
  [808] = 737,
  [809] = 718,
  [810] = 810,
  [811] = 717,
  [812] = 716,
  [813] = 722,
  [814] = 721,
  [815] = 720,
  [816] = 816,
  [817] = 718,
  [818] = 717,
  [819] = 716,
  [820] = 755,
  [821] = 722,
  [822] = 737,
  [823] = 721,
  [824] = 720,
  [825] = 825,
  [826] = 826,
  [827] = 718,
  [828] = 749,
  [829] = 717,
  [830] = 716,
  [831] = 722,
  [832] = 721,
  [833] = 720,
  [834] = 834,
  [835] = 835,
  [836] = 718,
  [837] = 717,
  [838] = 716,
  [839] = 722,
  [840] = 721,
  [841] = 720,
  [842] = 718,
  [843] = 717,
  [844] = 716,
  [845] = 722,
  [846] = 721,
  [847] = 720,
  [848] = 848,
  [849] = 718,
  [850] = 717,
  [851] = 716,
  [852] = 721,
  [853] = 720,
  [854] = 854,
  [855] = 718,
  [856] = 717,
  [857] = 716,
  [858] = 721,
  [859] = 720,
  [860] = 860,
  [861] = 718,
  [862] = 716,
  [863] = 721,
  [864] = 718,
  [865] = 718,
  [866] = 748,
  [867] = 716,
  [868] = 721,
  [869] = 720,
  [870] = 718,
  [871] = 716,
  [872] = 721,
  [873] = 737,
  [874] = 720,
  [875] = 875,
  [876] = 718,
  [877] = 737,
  [878] = 736,
  [879] = 879,
  [880] = 783,
  [881] = 716,
  [882] = 882,
  [883] = 765,
  [884] = 721,
  [885] = 720,
  [886] = 751,
  [887] = 736,
  [888] = 720,
  [889] = 889,
  [890] = 716,
  [891] = 737,
  [892] = 755,
  [893] = 752,
  [894] = 721,
  [895] = 720,
  [896] = 896,
  [897] = 718,
  [898] = 898,
  [899] = 716,
  [900] = 749,
  [901] = 737,
  [902] = 721,
  [903] = 739,
  [904] = 738,
  [905] = 905,
  [906] = 737,
  [907] = 720,
  [908] = 718,
  [909] = 716,
  [910] = 729,
  [911] = 678,
  [912] = 714,
  [913] = 721,
  [914] = 720,
  [915] = 915,
  [916] = 718,
  [917] = 719,
  [918] = 714,
  [919] = 719,
  [920] = 920,
  [921] = 921,
  [922] = 783,
  [923] = 716,
  [924] = 924,
  [925] = 765,
  [926] = 721,
  [927] = 720,
  [928] = 928,
  [929] = 751,
  [930] = 736,
  [931] = 718,
  [932] = 716,
  [933] = 714,
  [934] = 721,
  [935] = 729,
  [936] = 755,
  [937] = 681,
  [938] = 938,
  [939] = 752,
  [940] = 720,
  [941] = 941,
  [942] = 718,
  [943] = 716,
  [944] = 721,
  [945] = 945,
  [946] = 749,
  [947] = 947,
  [948] = 948,
  [949] = 949,
  [950] = 739,
  [951] = 720,
  [952] = 718,
  [953] = 738,
  [954] = 738,
  [955] = 740,
  [956] = 716,
  [957] = 720,
  [958] = 718,
  [959] = 716,
  [960] = 720,
  [961] = 729,
  [962] = 718,
  [963] = 716,
  [964] = 714,
  [965] = 720,
  [966] = 966,
  [967] = 967,
  [968] = 968,
  [969] = 969,
  [970] = 970,
  [971] = 719,
  [972] = 739,
  [973] = 973,
  [974] = 974,
  [975] = 749,
  [976] = 783,
  [977] = 977,
  [978] = 978,
  [979] = 979,
  [980] = 980,
  [981] = 981,
  [982] = 982,
  [983] = 983,
  [984] = 984,
  [985] = 835,
  [986] = 765,
  [987] = 987,
  [988] = 988,
  [989] = 989,
  [990] = 990,
  [991] = 751,
  [992] = 736,
  [993] = 993,
  [994] = 994,
  [995] = 995,
  [996] = 688,
  [997] = 997,
  [998] = 755,
  [999] = 999,
  [1000] = 752,
  [1001] = 1001,
  [1002] = 915,
  [1003] = 1003,
  [1004] = 752,
  [1005] = 749,
  [1006] = 755,
  [1007] = 1007,
  [1008] = 739,
  [1009] = 721,
  [1010] = 738,
  [1011] = 755,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 1015,
  [1016] = 729,
  [1017] = 691,
  [1018] = 714,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 1021,
  [1022] = 719,
  [1023] = 1023,
  [1024] = 1024,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 783,
  [1028] = 751,
  [1029] = 1029,
  [1030] = 736,
  [1031] = 765,
  [1032] = 1032,
  [1033] = 1033,
  [1034] = 751,
  [1035] = 736,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 721,
  [1039] = 752,
  [1040] = 755,
  [1041] = 1041,
  [1042] = 752,
  [1043] = 722,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 749,
  [1048] = 1048,
  [1049] = 1049,
  [1050] = 739,
  [1051] = 739,
  [1052] = 696,
  [1053] = 738,
  [1054] = 751,
  [1055] = 1055,
  [1056] = 716,
  [1057] = 722,
  [1058] = 729,
  [1059] = 1059,
  [1060] = 714,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 765,
  [1064] = 1064,
  [1065] = 1065,
  [1066] = 719,
  [1067] = 783,
  [1068] = 719,
  [1069] = 1069,
  [1070] = 1070,
  [1071] = 783,
  [1072] = 1072,
  [1073] = 783,
  [1074] = 765,
  [1075] = 1075,
  [1076] = 1076,
  [1077] = 1077,
  [1078] = 751,
  [1079] = 736,
  [1080] = 803,
  [1081] = 1081,
  [1082] = 1082,
  [1083] = 714,
  [1084] = 755,
  [1085] = 719,
  [1086] = 752,
  [1087] = 678,
  [1088] = 1088,
  [1089] = 729,
  [1090] = 1090,
  [1091] = 749,
  [1092] = 729,
  [1093] = 681,
  [1094] = 739,
  [1095] = 703,
  [1096] = 1096,
  [1097] = 738,
  [1098] = 738,
  [1099] = 1099,
  [1100] = 1100,
  [1101] = 1101,
  [1102] = 688,
  [1103] = 729,
  [1104] = 1104,
  [1105] = 714,
  [1106] = 691,
  [1107] = 739,
  [1108] = 738,
  [1109] = 719,
  [1110] = 1110,
  [1111] = 1111,
  [1112] = 749,
  [1113] = 1113,
  [1114] = 783,
  [1115] = 1115,
  [1116] = 1116,
  [1117] = 765,
  [1118] = 1118,
  [1119] = 1119,
  [1120] = 1120,
  [1121] = 751,
  [1122] = 736,
  [1123] = 1123,
  [1124] = 696,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 752,
  [1128] = 755,
  [1129] = 749,
  [1130] = 719,
  [1131] = 703,
  [1132] = 752,
  [1133] = 755,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 749,
  [1141] = 1141,
  [1142] = 1142,
  [1143] = 739,
  [1144] = 1144,
  [1145] = 738,
  [1146] = 736,
  [1147] = 1147,
  [1148] = 1148,
  [1149] = 1149,
  [1150] = 1150,
  [1151] = 716,
  [1152] = 1152,
  [1153] = 729,
  [1154] = 1154,
  [1155] = 714,
  [1156] = 718,
  [1157] = 1157,
  [1158] = 1158,
  [1159] = 719,
  [1160] = 721,
  [1161] = 714,
  [1162] = 1162,
  [1163] = 1163,
  [1164] = 1164,
  [1165] = 1165,
  [1166] = 729,
  [1167] = 751,
  [1168] = 783,
  [1169] = 1169,
  [1170] = 1170,
  [1171] = 720,
  [1172] = 765,
  [1173] = 721,
  [1174] = 1174,
  [1175] = 718,
  [1176] = 751,
  [1177] = 736,
  [1178] = 720,
  [1179] = 716,
  [1180] = 915,
  [1181] = 915,
  [1182] = 1182,
  [1183] = 755,
  [1184] = 915,
  [1185] = 752,
  [1186] = 915,
  [1187] = 765,
  [1188] = 915,
  [1189] = 915,
  [1190] = 765,
  [1191] = 1191,
  [1192] = 749,
  [1193] = 1193,
  [1194] = 915,
  [1195] = 739,
  [1196] = 718,
  [1197] = 738,
  [1198] = 783,
  [1199] = 915,
  [1200] = 915,
  [1201] = 915,
  [1202] = 729,
  [1203] = 738,
  [1204] = 915,
  [1205] = 714,
  [1206] = 915,
  [1207] = 915,
  [1208] = 915,
  [1209] = 915,
  [1210] = 719,
  [1211] = 1211,
  [1212] = 719,
  [1213] = 1213,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 783,
  [1217] = 1217,
  [1218] = 714,
  [1219] = 765,
  [1220] = 915,
  [1221] = 915,
  [1222] = 751,
  [1223] = 915,
  [1224] = 915,
  [1225] = 717,
  [1226] = 736,
  [1227] = 915,
  [1228] = 915,
  [1229] = 915,
  [1230] = 1230,
  [1231] = 755,
  [1232] = 739,
  [1233] = 752,
  [1234] = 915,
  [1235] = 915,
  [1236] = 915,
  [1237] = 729,
  [1238] = 749,
  [1239] = 915,
  [1240] = 1240,
  [1241] = 915,
  [1242] = 739,
  [1243] = 1243,
  [1244] = 738,
  [1245] = 1245,
  [1246] = 737,
  [1247] = 915,
  [1248] = 1248,
  [1249] = 1249,
  [1250] = 1249,
  [1251] = 1251,
  [1252] = 1252,
  [1253] = 1253,
  [1254] = 1254,
  [1255] = 1255,
  [1256] = 1256,
  [1257] = 1257,
  [1258] = 1258,
  [1259] = 1258,
  [1260] = 1257,
  [1261] = 1256,
  [1262] = 1255,
  [1263] = 1248,
  [1264] = 1248,
  [1265] = 1249,
  [1266] = 1251,
  [1267] = 1253,
  [1268] = 1252,
  [1269] = 1253,
  [1270] = 1255,
  [1271] = 1256,
  [1272] = 1257,
  [1273] = 1258,
  [1274] = 1248,
  [1275] = 1249,
  [1276] = 1251,
  [1277] = 705,
  [1278] = 1252,
  [1279] = 1248,
  [1280] = 701,
  [1281] = 1252,
  [1282] = 1251,
  [1283] = 698,
  [1284] = 1253,
  [1285] = 1255,
  [1286] = 1251,
  [1287] = 1256,
  [1288] = 1257,
  [1289] = 1249,
  [1290] = 1258,
  [1291] = 693,
  [1292] = 687,
  [1293] = 1248,
  [1294] = 617,
  [1295] = 1248,
  [1296] = 705,
  [1297] = 1249,
  [1298] = 1251,
  [1299] = 679,
  [1300] = 701,
  [1301] = 1252,
  [1302] = 677,
  [1303] = 1303,
  [1304] = 1253,
  [1305] = 1255,
  [1306] = 1256,
  [1307] = 1257,
  [1308] = 1258,
  [1309] = 1257,
  [1310] = 1256,
  [1311] = 1255,
  [1312] = 1258,
  [1313] = 1313,
  [1314] = 1253,
  [1315] = 664,
  [1316] = 659,
  [1317] = 698,
  [1318] = 1248,
  [1319] = 1249,
  [1320] = 1251,
  [1321] = 693,
  [1322] = 1252,
  [1323] = 1253,
  [1324] = 1255,
  [1325] = 1256,
  [1326] = 1257,
  [1327] = 1252,
  [1328] = 1258,
  [1329] = 1248,
  [1330] = 1249,
  [1331] = 1251,
  [1332] = 1252,
  [1333] = 1253,
  [1334] = 687,
  [1335] = 1251,
  [1336] = 1255,
  [1337] = 1256,
  [1338] = 1249,
  [1339] = 1257,
  [1340] = 1258,
  [1341] = 1341,
  [1342] = 1248,
  [1343] = 1248,
  [1344] = 1249,
  [1345] = 1251,
  [1346] = 1249,
  [1347] = 1252,
  [1348] = 1348,
  [1349] = 1253,
  [1350] = 1255,
  [1351] = 1255,
  [1352] = 1256,
  [1353] = 1256,
  [1354] = 1257,
  [1355] = 1258,
  [1356] = 679,
  [1357] = 1248,
  [1358] = 1358,
  [1359] = 1249,
  [1360] = 1251,
  [1361] = 677,
  [1362] = 1252,
  [1363] = 1253,
  [1364] = 1255,
  [1365] = 1257,
  [1366] = 1256,
  [1367] = 1257,
  [1368] = 1258,
  [1369] = 1258,
  [1370] = 1251,
  [1371] = 1313,
  [1372] = 1252,
  [1373] = 1313,
  [1374] = 1313,
  [1375] = 1258,
  [1376] = 1313,
  [1377] = 1257,
  [1378] = 1256,
  [1379] = 1255,
  [1380] = 1253,
  [1381] = 1313,
  [1382] = 1258,
  [1383] = 1257,
  [1384] = 1256,
  [1385] = 1255,
  [1386] = 1313,
  [1387] = 1313,
  [1388] = 1313,
  [1389] = 1389,
  [1390] = 1252,
  [1391] = 1251,
  [1392] = 1313,
  [1393] = 1249,
  [1394] = 1248,
  [1395] = 1313,
  [1396] = 1252,
  [1397] = 1313,
  [1398] = 1313,
  [1399] = 1399,
  [1400] = 1400,
  [1401] = 604,
  [1402] = 1402,
  [1403] = 606,
  [1404] = 620,
  [1405] = 534,
  [1406] = 597,
  [1407] = 596,
  [1408] = 1408,
  [1409] = 1409,
  [1410] = 595,
  [1411] = 570,
  [1412] = 608,
  [1413] = 1413,
  [1414] = 1414,
  [1415] = 1408,
  [1416] = 603,
  [1417] = 1417,
  [1418] = 1418,
  [1419] = 604,
  [1420] = 606,
  [1421] = 1421,
  [1422] = 559,
  [1423] = 559,
  [1424] = 1408,
  [1425] = 1400,
  [1426] = 595,
  [1427] = 596,
  [1428] = 597,
  [1429] = 1429,
  [1430] = 603,
  [1431] = 1431,
  [1432] = 1432,
  [1433] = 1432,
  [1434] = 1434,
  [1435] = 1435,
  [1436] = 1436,
  [1437] = 1413,
  [1438] = 1414,
  [1439] = 1413,
  [1440] = 1432,
  [1441] = 1441,
  [1442] = 1413,
  [1443] = 1443,
  [1444] = 1414,
  [1445] = 1400,
  [1446] = 1429,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1414,
  [1450] = 1432,
  [1451] = 1413,
  [1452] = 1452,
  [1453] = 1414,
  [1454] = 1432,
  [1455] = 1455,
  [1456] = 1456,
  [1457] = 1457,
  [1458] = 1413,
  [1459] = 1447,
  [1460] = 1448,
  [1461] = 1461,
  [1462] = 1462,
  [1463] = 1414,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 1468,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 1471,
  [1472] = 1461,
  [1473] = 1465,
  [1474] = 1466,
  [1475] = 1467,
  [1476] = 1468,
  [1477] = 1469,
  [1478] = 1470,
  [1479] = 1479,
  [1480] = 1480,
  [1481] = 1481,
  [1482] = 1482,
  [1483] = 1483,
  [1484] = 1484,
  [1485] = 1485,
  [1486] = 1479,
  [1487] = 1480,
  [1488] = 1432,
  [1489] = 1481,
  [1490] = 1482,
  [1491] = 1483,
  [1492] = 1484,
  [1493] = 1485,
  [1494] = 620,
  [1495] = 534,
  [1496] = 1432,
  [1497] = 631,
  [1498] = 1498,
  [1499] = 1499,
  [1500] = 1500,
  [1501] = 1501,
  [1502] = 1408,
  [1503] = 1503,
  [1504] = 1504,
  [1505] = 1501,
  [1506] = 1499,
  [1507] = 1413,
  [1508] = 1508,
  [1509] = 1414,
  [1510] = 1432,
  [1511] = 1413,
  [1512] = 1414,
  [1513] = 1513,
  [1514] = 1413,
  [1515] = 1413,
  [1516] = 1516,
  [1517] = 1414,
  [1518] = 1432,
  [1519] = 1519,
  [1520] = 1400,
  [1521] = 1429,
  [1522] = 1504,
  [1523] = 1413,
  [1524] = 1414,
  [1525] = 1525,
  [1526] = 1432,
  [1527] = 1527,
  [1528] = 1528,
  [1529] = 1529,
  [1530] = 1530,
  [1531] = 1400,
  [1532] = 1432,
  [1533] = 1471,
  [1534] = 1534,
  [1535] = 1399,
  [1536] = 1536,
  [1537] = 1429,
  [1538] = 1538,
  [1539] = 1539,
  [1540] = 1540,
  [1541] = 1541,
  [1542] = 1528,
  [1543] = 1452,
  [1544] = 1544,
  [1545] = 1408,
  [1546] = 1504,
  [1547] = 1534,
  [1548] = 1399,
  [1549] = 570,
  [1550] = 1539,
  [1551] = 1540,
  [1552] = 1541,
  [1553] = 1541,
  [1554] = 1452,
  [1555] = 1534,
  [1556] = 1399,
  [1557] = 1447,
  [1558] = 1448,
  [1559] = 1432,
  [1560] = 1461,
  [1561] = 1561,
  [1562] = 1539,
  [1563] = 1540,
  [1564] = 1501,
  [1565] = 1499,
  [1566] = 1541,
  [1567] = 1528,
  [1568] = 1452,
  [1569] = 1569,
  [1570] = 1534,
  [1571] = 1399,
  [1572] = 1572,
  [1573] = 1465,
  [1574] = 1539,
  [1575] = 1575,
  [1576] = 1540,
  [1577] = 1414,
  [1578] = 1578,
  [1579] = 1541,
  [1580] = 1528,
  [1581] = 1452,
  [1582] = 1534,
  [1583] = 1399,
  [1584] = 1466,
  [1585] = 1539,
  [1586] = 1540,
  [1587] = 1413,
  [1588] = 1541,
  [1589] = 1528,
  [1590] = 1452,
  [1591] = 1534,
  [1592] = 1399,
  [1593] = 1467,
  [1594] = 1539,
  [1595] = 1540,
  [1596] = 1528,
  [1597] = 1528,
  [1598] = 1452,
  [1599] = 1534,
  [1600] = 1399,
  [1601] = 1468,
  [1602] = 1539,
  [1603] = 1540,
  [1604] = 1541,
  [1605] = 1605,
  [1606] = 1528,
  [1607] = 1452,
  [1608] = 1608,
  [1609] = 1605,
  [1610] = 1534,
  [1611] = 1469,
  [1612] = 1470,
  [1613] = 1539,
  [1614] = 1540,
  [1615] = 1541,
  [1616] = 1541,
  [1617] = 1452,
  [1618] = 1534,
  [1619] = 1399,
  [1620] = 1479,
  [1621] = 1528,
  [1622] = 1539,
  [1623] = 1540,
  [1624] = 1541,
  [1625] = 1528,
  [1626] = 1452,
  [1627] = 1480,
  [1628] = 1534,
  [1629] = 1399,
  [1630] = 1481,
  [1631] = 1539,
  [1632] = 1540,
  [1633] = 1541,
  [1634] = 1528,
  [1635] = 1452,
  [1636] = 1534,
  [1637] = 1541,
  [1638] = 1399,
  [1639] = 1482,
  [1640] = 1539,
  [1641] = 1540,
  [1642] = 1541,
  [1643] = 1528,
  [1644] = 1452,
  [1645] = 1534,
  [1646] = 1399,
  [1647] = 1483,
  [1648] = 1648,
  [1649] = 1484,
  [1650] = 1539,
  [1651] = 1485,
  [1652] = 1408,
  [1653] = 1447,
  [1654] = 1529,
  [1655] = 1448,
  [1656] = 1504,
  [1657] = 1501,
  [1658] = 1540,
  [1659] = 1499,
  [1660] = 1400,
  [1661] = 1429,
  [1662] = 1447,
  [1663] = 1541,
  [1664] = 1448,
  [1665] = 1461,
  [1666] = 1528,
  [1667] = 1503,
  [1668] = 1465,
  [1669] = 608,
  [1670] = 1466,
  [1671] = 1467,
  [1672] = 1468,
  [1673] = 1408,
  [1674] = 1469,
  [1675] = 1470,
  [1676] = 1485,
  [1677] = 1484,
  [1678] = 1483,
  [1679] = 1482,
  [1680] = 1481,
  [1681] = 1452,
  [1682] = 1480,
  [1683] = 1479,
  [1684] = 1470,
  [1685] = 1469,
  [1686] = 1468,
  [1687] = 1467,
  [1688] = 1466,
  [1689] = 1465,
  [1690] = 1461,
  [1691] = 1479,
  [1692] = 1480,
  [1693] = 1481,
  [1694] = 1541,
  [1695] = 1482,
  [1696] = 1483,
  [1697] = 1508,
  [1698] = 659,
  [1699] = 1484,
  [1700] = 1485,
  [1701] = 1456,
  [1702] = 1452,
  [1703] = 1703,
  [1704] = 1456,
  [1705] = 1456,
  [1706] = 664,
  [1707] = 1504,
  [1708] = 1456,
  [1709] = 1501,
  [1710] = 1499,
  [1711] = 617,
  [1712] = 1456,
  [1713] = 1456,
  [1714] = 1714,
  [1715] = 1400,
  [1716] = 1448,
  [1717] = 1541,
  [1718] = 1452,
  [1719] = 1447,
  [1720] = 1541,
  [1721] = 1452,
  [1722] = 1429,
  [1723] = 1575,
  [1724] = 1452,
  [1725] = 1432,
  [1726] = 1400,
  [1727] = 1727,
  [1728] = 1429,
  [1729] = 1729,
  [1730] = 1447,
  [1731] = 1448,
  [1732] = 1461,
  [1733] = 1465,
  [1734] = 1466,
  [1735] = 1467,
  [1736] = 1736,
  [1737] = 1468,
  [1738] = 1469,
  [1739] = 1714,
  [1740] = 1499,
  [1741] = 1470,
  [1742] = 1479,
  [1743] = 1480,
  [1744] = 1400,
  [1745] = 1429,
  [1746] = 1447,
  [1747] = 1448,
  [1748] = 1501,
  [1749] = 1540,
  [1750] = 1750,
  [1751] = 1561,
  [1752] = 1481,
  [1753] = 1429,
  [1754] = 1447,
  [1755] = 1448,
  [1756] = 1471,
  [1757] = 1413,
  [1758] = 1461,
  [1759] = 1465,
  [1760] = 1466,
  [1761] = 1467,
  [1762] = 1468,
  [1763] = 1469,
  [1764] = 1470,
  [1765] = 1479,
  [1766] = 1480,
  [1767] = 1481,
  [1768] = 1482,
  [1769] = 1471,
  [1770] = 1461,
  [1771] = 1465,
  [1772] = 1466,
  [1773] = 1467,
  [1774] = 1468,
  [1775] = 1469,
  [1776] = 1470,
  [1777] = 1479,
  [1778] = 1480,
  [1779] = 1481,
  [1780] = 1482,
  [1781] = 1483,
  [1782] = 1484,
  [1783] = 1485,
  [1784] = 1483,
  [1785] = 1484,
  [1786] = 1485,
  [1787] = 1481,
  [1788] = 1414,
  [1789] = 1504,
  [1790] = 1501,
  [1791] = 1499,
  [1792] = 1539,
  [1793] = 1461,
  [1794] = 1794,
  [1795] = 1795,
  [1796] = 1400,
  [1797] = 1482,
  [1798] = 1429,
  [1799] = 1447,
  [1800] = 1448,
  [1801] = 1461,
  [1802] = 1465,
  [1803] = 1483,
  [1804] = 1466,
  [1805] = 1467,
  [1806] = 1468,
  [1807] = 1469,
  [1808] = 1470,
  [1809] = 1479,
  [1810] = 1480,
  [1811] = 1484,
  [1812] = 1485,
  [1813] = 1481,
  [1814] = 1399,
  [1815] = 1482,
  [1816] = 1534,
  [1817] = 1483,
  [1818] = 1794,
  [1819] = 1794,
  [1820] = 1484,
  [1821] = 1504,
  [1822] = 1794,
  [1823] = 1794,
  [1824] = 1794,
  [1825] = 1485,
  [1826] = 1501,
  [1827] = 1504,
  [1828] = 1499,
  [1829] = 1829,
  [1830] = 1536,
  [1831] = 1794,
  [1832] = 1829,
  [1833] = 1504,
  [1834] = 1501,
  [1835] = 1794,
  [1836] = 1499,
  [1837] = 1829,
  [1838] = 1400,
  [1839] = 1794,
  [1840] = 1504,
  [1841] = 1829,
  [1842] = 1400,
  [1843] = 689,
  [1844] = 1429,
  [1845] = 675,
  [1846] = 1429,
  [1847] = 1447,
  [1848] = 1448,
  [1849] = 1499,
  [1850] = 1501,
  [1851] = 1447,
  [1852] = 1429,
  [1853] = 672,
  [1854] = 1501,
  [1855] = 1499,
  [1856] = 1465,
  [1857] = 1448,
  [1858] = 671,
  [1859] = 1575,
  [1860] = 1504,
  [1861] = 1466,
  [1862] = 1467,
  [1863] = 1468,
  [1864] = 1794,
  [1865] = 1414,
  [1866] = 1829,
  [1867] = 1794,
  [1868] = 1469,
  [1869] = 669,
  [1870] = 1470,
  [1871] = 1479,
  [1872] = 1829,
  [1873] = 1794,
  [1874] = 1485,
  [1875] = 1484,
  [1876] = 1483,
  [1877] = 1482,
  [1878] = 1481,
  [1879] = 1480,
  [1880] = 1479,
  [1881] = 1480,
  [1882] = 1470,
  [1883] = 1469,
  [1884] = 1468,
  [1885] = 1467,
  [1886] = 1466,
  [1887] = 1465,
  [1888] = 1461,
  [1889] = 1829,
  [1890] = 1829,
  [1891] = 1794,
  [1892] = 1481,
  [1893] = 1482,
  [1894] = 1448,
  [1895] = 1447,
  [1896] = 1429,
  [1897] = 1400,
  [1898] = 1829,
  [1899] = 1794,
  [1900] = 1829,
  [1901] = 1794,
  [1902] = 1829,
  [1903] = 1461,
  [1904] = 1465,
  [1905] = 1466,
  [1906] = 1467,
  [1907] = 1468,
  [1908] = 1469,
  [1909] = 1470,
  [1910] = 1794,
  [1911] = 1479,
  [1912] = 1480,
  [1913] = 1481,
  [1914] = 1482,
  [1915] = 1483,
  [1916] = 1483,
  [1917] = 1484,
  [1918] = 1485,
  [1919] = 1829,
  [1920] = 1399,
  [1921] = 1534,
  [1922] = 1922,
  [1923] = 1499,
  [1924] = 1501,
  [1925] = 1925,
  [1926] = 1504,
  [1927] = 1471,
  [1928] = 1413,
  [1929] = 1461,
  [1930] = 1465,
  [1931] = 1466,
  [1932] = 1467,
  [1933] = 1468,
  [1934] = 1469,
  [1935] = 1470,
  [1936] = 1479,
  [1937] = 1480,
  [1938] = 1484,
  [1939] = 1481,
  [1940] = 1485,
  [1941] = 1482,
  [1942] = 1483,
  [1943] = 1484,
  [1944] = 1485,
  [1945] = 1499,
  [1946] = 1501,
  [1947] = 1399,
  [1948] = 1504,
  [1949] = 1504,
  [1950] = 1504,
  [1951] = 1951,
  [1952] = 1501,
  [1953] = 1501,
  [1954] = 1499,
  [1955] = 1501,
  [1956] = 1499,
  [1957] = 1485,
  [1958] = 1484,
  [1959] = 1483,
  [1960] = 1499,
  [1961] = 1504,
  [1962] = 1482,
  [1963] = 1481,
  [1964] = 1400,
  [1965] = 1480,
  [1966] = 1479,
  [1967] = 1470,
  [1968] = 1469,
  [1969] = 1468,
  [1970] = 1467,
  [1971] = 1466,
  [1972] = 1465,
  [1973] = 1461,
  [1974] = 1448,
  [1975] = 1447,
  [1976] = 1429,
  [1977] = 1400,
  [1978] = 1794,
  [1979] = 1829,
  [1980] = 1485,
  [1981] = 1484,
  [1982] = 1483,
  [1983] = 1482,
  [1984] = 1481,
  [1985] = 1480,
  [1986] = 1479,
  [1987] = 1484,
  [1988] = 1447,
  [1989] = 1470,
  [1990] = 1469,
  [1991] = 1400,
  [1992] = 1429,
  [1993] = 1447,
  [1994] = 1448,
  [1995] = 1468,
  [1996] = 1467,
  [1997] = 1466,
  [1998] = 684,
  [1999] = 1465,
  [2000] = 1461,
  [2001] = 1448,
  [2002] = 1399,
  [2003] = 1534,
  [2004] = 1399,
  [2005] = 1534,
  [2006] = 1399,
  [2007] = 1534,
  [2008] = 1399,
  [2009] = 1534,
  [2010] = 1413,
  [2011] = 1432,
  [2012] = 617,
  [2013] = 1534,
  [2014] = 1414,
  [2015] = 1413,
  [2016] = 1471,
  [2017] = 1461,
  [2018] = 1465,
  [2019] = 1466,
  [2020] = 1467,
  [2021] = 1468,
  [2022] = 1469,
  [2023] = 1470,
  [2024] = 1479,
  [2025] = 1480,
  [2026] = 1481,
  [2027] = 1482,
  [2028] = 1483,
  [2029] = 1484,
  [2030] = 1485,
  [2031] = 1413,
  [2032] = 1448,
  [2033] = 1461,
  [2034] = 1447,
  [2035] = 1429,
  [2036] = 1400,
  [2037] = 1465,
  [2038] = 1485,
  [2039] = 1499,
  [2040] = 1466,
  [2041] = 669,
  [2042] = 1501,
  [2043] = 1504,
  [2044] = 1536,
  [2045] = 1485,
  [2046] = 1484,
  [2047] = 664,
  [2048] = 1484,
  [2049] = 1483,
  [2050] = 1482,
  [2051] = 1481,
  [2052] = 1480,
  [2053] = 1483,
  [2054] = 1479,
  [2055] = 1470,
  [2056] = 1469,
  [2057] = 1468,
  [2058] = 1467,
  [2059] = 1400,
  [2060] = 1466,
  [2061] = 1429,
  [2062] = 1465,
  [2063] = 1461,
  [2064] = 1447,
  [2065] = 1922,
  [2066] = 2066,
  [2067] = 1448,
  [2068] = 1448,
  [2069] = 1447,
  [2070] = 2070,
  [2071] = 1482,
  [2072] = 1429,
  [2073] = 1481,
  [2074] = 1480,
  [2075] = 1467,
  [2076] = 1468,
  [2077] = 1479,
  [2078] = 1469,
  [2079] = 1470,
  [2080] = 1470,
  [2081] = 1400,
  [2082] = 1504,
  [2083] = 1499,
  [2084] = 671,
  [2085] = 1501,
  [2086] = 1538,
  [2087] = 1504,
  [2088] = 1469,
  [2089] = 1485,
  [2090] = 659,
  [2091] = 1413,
  [2092] = 675,
  [2093] = 1468,
  [2094] = 1482,
  [2095] = 1483,
  [2096] = 1501,
  [2097] = 1499,
  [2098] = 1465,
  [2099] = 1467,
  [2100] = 1479,
  [2101] = 1466,
  [2102] = 1480,
  [2103] = 1461,
  [2104] = 1075,
  [2105] = 706,
  [2106] = 679,
  [2107] = 678,
  [2108] = 677,
  [2109] = 705,
  [2110] = 709,
  [2111] = 703,
  [2112] = 699,
  [2113] = 701,
  [2114] = 698,
  [2115] = 696,
  [2116] = 693,
  [2117] = 691,
  [2118] = 688,
  [2119] = 2119,
  [2120] = 681,
  [2121] = 711,
  [2122] = 675,
  [2123] = 672,
  [2124] = 671,
  [2125] = 669,
  [2126] = 889,
  [2127] = 988,
  [2128] = 848,
  [2129] = 999,
  [2130] = 854,
  [2131] = 860,
  [2132] = 938,
  [2133] = 948,
  [2134] = 1064,
  [2135] = 672,
  [2136] = 949,
  [2137] = 966,
  [2138] = 967,
  [2139] = 968,
  [2140] = 969,
  [2141] = 978,
  [2142] = 979,
  [2143] = 980,
  [2144] = 982,
  [2145] = 987,
  [2146] = 989,
  [2147] = 990,
  [2148] = 684,
  [2149] = 993,
  [2150] = 994,
  [2151] = 995,
  [2152] = 1001,
  [2153] = 682,
  [2154] = 1003,
  [2155] = 728,
  [2156] = 983,
  [2157] = 1007,
  [2158] = 1012,
  [2159] = 1013,
  [2160] = 1014,
  [2161] = 1019,
  [2162] = 1020,
  [2163] = 1021,
  [2164] = 727,
  [2165] = 758,
  [2166] = 1029,
  [2167] = 1032,
  [2168] = 1033,
  [2169] = 1036,
  [2170] = 1037,
  [2171] = 1044,
  [2172] = 1045,
  [2173] = 928,
  [2174] = 1076,
  [2175] = 1048,
  [2176] = 1055,
  [2177] = 687,
  [2178] = 715,
  [2179] = 689,
  [2180] = 1165,
  [2181] = 1072,
  [2182] = 1062,
  [2183] = 1065,
  [2184] = 682,
  [2185] = 706,
  [2186] = 2186,
  [2187] = 1245,
  [2188] = 1158,
  [2189] = 1157,
  [2190] = 1154,
  [2191] = 1152,
  [2192] = 1150,
  [2193] = 1113,
  [2194] = 2194,
  [2195] = 898,
  [2196] = 691,
  [2197] = 973,
  [2198] = 970,
  [2199] = 947,
  [2200] = 1149,
  [2201] = 1148,
  [2202] = 969,
  [2203] = 968,
  [2204] = 1147,
  [2205] = 1139,
  [2206] = 1142,
  [2207] = 945,
  [2208] = 941,
  [2209] = 1032,
  [2210] = 1015,
  [2211] = 1137,
  [2212] = 967,
  [2213] = 1136,
  [2214] = 938,
  [2215] = 1020,
  [2216] = 1134,
  [2217] = 1126,
  [2218] = 966,
  [2219] = 1123,
  [2220] = 1021,
  [2221] = 1120,
  [2222] = 1119,
  [2223] = 949,
  [2224] = 1118,
  [2225] = 1115,
  [2226] = 948,
  [2227] = 834,
  [2228] = 924,
  [2229] = 905,
  [2230] = 921,
  [2231] = 920,
  [2232] = 905,
  [2233] = 896,
  [2234] = 983,
  [2235] = 898,
  [2236] = 896,
  [2237] = 1029,
  [2238] = 978,
  [2239] = 1064,
  [2240] = 1158,
  [2241] = 848,
  [2242] = 1033,
  [2243] = 882,
  [2244] = 1019,
  [2245] = 688,
  [2246] = 1012,
  [2247] = 875,
  [2248] = 1007,
  [2249] = 1099,
  [2250] = 1003,
  [2251] = 920,
  [2252] = 921,
  [2253] = 816,
  [2254] = 1100,
  [2255] = 696,
  [2256] = 802,
  [2257] = 796,
  [2258] = 792,
  [2259] = 924,
  [2260] = 941,
  [2261] = 945,
  [2262] = 947,
  [2263] = 970,
  [2264] = 973,
  [2265] = 974,
  [2266] = 2186,
  [2267] = 882,
  [2268] = 997,
  [2269] = 1023,
  [2270] = 1024,
  [2271] = 703,
  [2272] = 1025,
  [2273] = 1026,
  [2274] = 1041,
  [2275] = 826,
  [2276] = 1001,
  [2277] = 559,
  [2278] = 595,
  [2279] = 879,
  [2280] = 1046,
  [2281] = 596,
  [2282] = 597,
  [2283] = 1049,
  [2284] = 1059,
  [2285] = 1061,
  [2286] = 1069,
  [2287] = 792,
  [2288] = 1070,
  [2289] = 1077,
  [2290] = 1082,
  [2291] = 1164,
  [2292] = 1090,
  [2293] = 979,
  [2294] = 1096,
  [2295] = 1099,
  [2296] = 758,
  [2297] = 1101,
  [2298] = 603,
  [2299] = 980,
  [2300] = 974,
  [2301] = 1110,
  [2302] = 1111,
  [2303] = 997,
  [2304] = 1023,
  [2305] = 1024,
  [2306] = 1113,
  [2307] = 982,
  [2308] = 604,
  [2309] = 728,
  [2310] = 1169,
  [2311] = 1062,
  [2312] = 1025,
  [2313] = 1026,
  [2314] = 1041,
  [2315] = 1217,
  [2316] = 1116,
  [2317] = 1046,
  [2318] = 606,
  [2319] = 1049,
  [2320] = 620,
  [2321] = 1125,
  [2322] = 1116,
  [2323] = 681,
  [2324] = 1088,
  [2325] = 534,
  [2326] = 1059,
  [2327] = 1101,
  [2328] = 1061,
  [2329] = 1069,
  [2330] = 1135,
  [2331] = 1138,
  [2332] = 1164,
  [2333] = 570,
  [2334] = 1141,
  [2335] = 715,
  [2336] = 1162,
  [2337] = 1163,
  [2338] = 1144,
  [2339] = 1170,
  [2340] = 1243,
  [2341] = 1182,
  [2342] = 1191,
  [2343] = 854,
  [2344] = 1193,
  [2345] = 1211,
  [2346] = 1213,
  [2347] = 608,
  [2348] = 984,
  [2349] = 762,
  [2350] = 1214,
  [2351] = 879,
  [2352] = 1215,
  [2353] = 999,
  [2354] = 1230,
  [2355] = 1096,
  [2356] = 2186,
  [2357] = 1240,
  [2358] = 1245,
  [2359] = 678,
  [2360] = 1243,
  [2361] = 1217,
  [2362] = 1169,
  [2363] = 2186,
  [2364] = 1165,
  [2365] = 1144,
  [2366] = 1170,
  [2367] = 1150,
  [2368] = 1081,
  [2369] = 1157,
  [2370] = 1154,
  [2371] = 1152,
  [2372] = 995,
  [2373] = 1055,
  [2374] = 2119,
  [2375] = 1149,
  [2376] = 1148,
  [2377] = 1147,
  [2378] = 1139,
  [2379] = 1142,
  [2380] = 2186,
  [2381] = 1015,
  [2382] = 1137,
  [2383] = 2186,
  [2384] = 2186,
  [2385] = 2186,
  [2386] = 1104,
  [2387] = 1136,
  [2388] = 2186,
  [2389] = 2186,
  [2390] = 1134,
  [2391] = 1126,
  [2392] = 1123,
  [2393] = 2393,
  [2394] = 1120,
  [2395] = 1119,
  [2396] = 1118,
  [2397] = 1115,
  [2398] = 2186,
  [2399] = 1070,
  [2400] = 1077,
  [2401] = 1082,
  [2402] = 796,
  [2403] = 802,
  [2404] = 1048,
  [2405] = 2186,
  [2406] = 1240,
  [2407] = 1230,
  [2408] = 1215,
  [2409] = 1214,
  [2410] = 1213,
  [2411] = 1211,
  [2412] = 1193,
  [2413] = 987,
  [2414] = 988,
  [2415] = 2186,
  [2416] = 834,
  [2417] = 889,
  [2418] = 989,
  [2419] = 983,
  [2420] = 889,
  [2421] = 990,
  [2422] = 727,
  [2423] = 993,
  [2424] = 994,
  [2425] = 1191,
  [2426] = 1182,
  [2427] = 848,
  [2428] = 810,
  [2429] = 1045,
  [2430] = 1090,
  [2431] = 854,
  [2432] = 860,
  [2433] = 988,
  [2434] = 816,
  [2435] = 999,
  [2436] = 928,
  [2437] = 1014,
  [2438] = 928,
  [2439] = 825,
  [2440] = 1044,
  [2441] = 826,
  [2442] = 990,
  [2443] = 2443,
  [2444] = 1029,
  [2445] = 1111,
  [2446] = 1076,
  [2447] = 1037,
  [2448] = 1013,
  [2449] = 1019,
  [2450] = 1075,
  [2451] = 724,
  [2452] = 1013,
  [2453] = 1036,
  [2454] = 1072,
  [2455] = 875,
  [2456] = 938,
  [2457] = 2186,
  [2458] = 1065,
  [2459] = 949,
  [2460] = 1036,
  [2461] = 989,
  [2462] = 1163,
  [2463] = 2186,
  [2464] = 2186,
  [2465] = 2186,
  [2466] = 1162,
  [2467] = 1064,
  [2468] = 810,
  [2469] = 1033,
  [2470] = 1032,
  [2471] = 825,
  [2472] = 1076,
  [2473] = 966,
  [2474] = 1141,
  [2475] = 1021,
  [2476] = 1020,
  [2477] = 1075,
  [2478] = 1062,
  [2479] = 1138,
  [2480] = 1014,
  [2481] = 1135,
  [2482] = 1072,
  [2483] = 715,
  [2484] = 1125,
  [2485] = 1012,
  [2486] = 1007,
  [2487] = 1003,
  [2488] = 1001,
  [2489] = 995,
  [2490] = 1065,
  [2491] = 1055,
  [2492] = 1110,
  [2493] = 994,
  [2494] = 993,
  [2495] = 948,
  [2496] = 987,
  [2497] = 1048,
  [2498] = 1037,
  [2499] = 982,
  [2500] = 980,
  [2501] = 979,
  [2502] = 978,
  [2503] = 1045,
  [2504] = 969,
  [2505] = 968,
  [2506] = 1044,
  [2507] = 860,
  [2508] = 967,
  [2509] = 687,
  [2510] = 659,
  [2511] = 679,
  [2512] = 664,
  [2513] = 677,
  [2514] = 2514,
  [2515] = 705,
  [2516] = 617,
  [2517] = 701,
  [2518] = 693,
  [2519] = 682,
  [2520] = 698,
  [2521] = 879,
  [2522] = 1170,
  [2523] = 974,
  [2524] = 1046,
  [2525] = 689,
  [2526] = 678,
  [2527] = 1096,
  [2528] = 1164,
  [2529] = 826,
  [2530] = 810,
  [2531] = 1025,
  [2532] = 1069,
  [2533] = 1061,
  [2534] = 1059,
  [2535] = 1024,
  [2536] = 669,
  [2537] = 2537,
  [2538] = 1049,
  [2539] = 2539,
  [2540] = 1116,
  [2541] = 2541,
  [2542] = 1041,
  [2543] = 2543,
  [2544] = 997,
  [2545] = 1026,
  [2546] = 703,
  [2547] = 696,
  [2548] = 691,
  [2549] = 1023,
  [2550] = 688,
  [2551] = 2551,
  [2552] = 2443,
  [2553] = 671,
  [2554] = 672,
  [2555] = 1144,
  [2556] = 2556,
  [2557] = 2557,
  [2558] = 675,
  [2559] = 834,
  [2560] = 681,
  [2561] = 860,
  [2562] = 1036,
  [2563] = 679,
  [2564] = 983,
  [2565] = 1013,
  [2566] = 1064,
  [2567] = 715,
  [2568] = 1072,
  [2569] = 854,
  [2570] = 1014,
  [2571] = 1012,
  [2572] = 1075,
  [2573] = 687,
  [2574] = 928,
  [2575] = 848,
  [2576] = 1007,
  [2577] = 1019,
  [2578] = 1020,
  [2579] = 889,
  [2580] = 693,
  [2581] = 1021,
  [2582] = 1003,
  [2583] = 698,
  [2584] = 701,
  [2585] = 1001,
  [2586] = 705,
  [2587] = 999,
  [2588] = 995,
  [2589] = 1062,
  [2590] = 1065,
  [2591] = 994,
  [2592] = 677,
  [2593] = 993,
  [2594] = 1037,
  [2595] = 1076,
  [2596] = 990,
  [2597] = 1044,
  [2598] = 706,
  [2599] = 989,
  [2600] = 682,
  [2601] = 987,
  [2602] = 982,
  [2603] = 1029,
  [2604] = 980,
  [2605] = 1055,
  [2606] = 979,
  [2607] = 1032,
  [2608] = 978,
  [2609] = 1033,
  [2610] = 728,
  [2611] = 758,
  [2612] = 1045,
  [2613] = 684,
  [2614] = 969,
  [2615] = 968,
  [2616] = 967,
  [2617] = 966,
  [2618] = 1048,
  [2619] = 949,
  [2620] = 988,
  [2621] = 938,
  [2622] = 948,
  [2623] = 1110,
  [2624] = 945,
  [2625] = 1191,
  [2626] = 1193,
  [2627] = 1211,
  [2628] = 1144,
  [2629] = 825,
  [2630] = 1096,
  [2631] = 1164,
  [2632] = 1059,
  [2633] = 1116,
  [2634] = 1170,
  [2635] = 1049,
  [2636] = 1069,
  [2637] = 1046,
  [2638] = 1041,
  [2639] = 1061,
  [2640] = 1026,
  [2641] = 1023,
  [2642] = 1101,
  [2643] = 1213,
  [2644] = 1214,
  [2645] = 727,
  [2646] = 1025,
  [2647] = 810,
  [2648] = 826,
  [2649] = 1215,
  [2650] = 1230,
  [2651] = 879,
  [2652] = 792,
  [2653] = 796,
  [2654] = 802,
  [2655] = 1240,
  [2656] = 816,
  [2657] = 1182,
  [2658] = 1245,
  [2659] = 875,
  [2660] = 1163,
  [2661] = 882,
  [2662] = 1024,
  [2663] = 834,
  [2664] = 834,
  [2665] = 896,
  [2666] = 898,
  [2667] = 905,
  [2668] = 920,
  [2669] = 921,
  [2670] = 924,
  [2671] = 941,
  [2672] = 1141,
  [2673] = 947,
  [2674] = 970,
  [2675] = 973,
  [2676] = 1243,
  [2677] = 1169,
  [2678] = 1165,
  [2679] = 1158,
  [2680] = 1118,
  [2681] = 1115,
  [2682] = 675,
  [2683] = 2683,
  [2684] = 1157,
  [2685] = 1154,
  [2686] = 1152,
  [2687] = 1150,
  [2688] = 659,
  [2689] = 1162,
  [2690] = 997,
  [2691] = 1070,
  [2692] = 1077,
  [2693] = 1082,
  [2694] = 974,
  [2695] = 682,
  [2696] = 684,
  [2697] = 1148,
  [2698] = 1119,
  [2699] = 1120,
  [2700] = 1123,
  [2701] = 1126,
  [2702] = 1134,
  [2703] = 1136,
  [2704] = 1137,
  [2705] = 1090,
  [2706] = 1099,
  [2707] = 1111,
  [2708] = 1113,
  [2709] = 1015,
  [2710] = 1142,
  [2711] = 1139,
  [2712] = 1147,
  [2713] = 1217,
  [2714] = 669,
  [2715] = 1149,
  [2716] = 617,
  [2717] = 664,
  [2718] = 671,
  [2719] = 1125,
  [2720] = 1135,
  [2721] = 1138,
  [2722] = 727,
  [2723] = 1069,
  [2724] = 682,
  [2725] = 834,
  [2726] = 1164,
  [2727] = 834,
  [2728] = 1116,
  [2729] = 2537,
  [2730] = 672,
  [2731] = 1061,
  [2732] = 1059,
  [2733] = 706,
  [2734] = 1049,
  [2735] = 1046,
  [2736] = 1041,
  [2737] = 1026,
  [2738] = 1025,
  [2739] = 1024,
  [2740] = 1023,
  [2741] = 1165,
  [2742] = 1096,
  [2743] = 997,
  [2744] = 974,
  [2745] = 1144,
  [2746] = 879,
  [2747] = 826,
  [2748] = 810,
  [2749] = 2539,
  [2750] = 2514,
  [2751] = 2551,
  [2752] = 2556,
  [2753] = 2557,
  [2754] = 2543,
  [2755] = 2541,
  [2756] = 1170,
  [2757] = 1113,
  [2758] = 1148,
  [2759] = 1026,
  [2760] = 1041,
  [2761] = 1046,
  [2762] = 1049,
  [2763] = 1059,
  [2764] = 1061,
  [2765] = 1069,
  [2766] = 1070,
  [2767] = 1077,
  [2768] = 1082,
  [2769] = 1164,
  [2770] = 1090,
  [2771] = 860,
  [2772] = 1023,
  [2773] = 1037,
  [2774] = 1096,
  [2775] = 848,
  [2776] = 1036,
  [2777] = 834,
  [2778] = 1024,
  [2779] = 1044,
  [2780] = 997,
  [2781] = 2781,
  [2782] = 889,
  [2783] = 659,
  [2784] = 974,
  [2785] = 1099,
  [2786] = 1101,
  [2787] = 1110,
  [2788] = 1111,
  [2789] = 2781,
  [2790] = 617,
  [2791] = 973,
  [2792] = 792,
  [2793] = 970,
  [2794] = 796,
  [2795] = 947,
  [2796] = 945,
  [2797] = 1116,
  [2798] = 941,
  [2799] = 802,
  [2800] = 1033,
  [2801] = 664,
  [2802] = 2802,
  [2803] = 1019,
  [2804] = 948,
  [2805] = 949,
  [2806] = 966,
  [2807] = 1032,
  [2808] = 810,
  [2809] = 967,
  [2810] = 1125,
  [2811] = 1135,
  [2812] = 1138,
  [2813] = 1141,
  [2814] = 1162,
  [2815] = 1163,
  [2816] = 1144,
  [2817] = 1170,
  [2818] = 816,
  [2819] = 968,
  [2820] = 825,
  [2821] = 969,
  [2822] = 1182,
  [2823] = 1191,
  [2824] = 928,
  [2825] = 978,
  [2826] = 979,
  [2827] = 980,
  [2828] = 826,
  [2829] = 875,
  [2830] = 879,
  [2831] = 882,
  [2832] = 1193,
  [2833] = 1211,
  [2834] = 1213,
  [2835] = 1214,
  [2836] = 1215,
  [2837] = 1230,
  [2838] = 1240,
  [2839] = 1245,
  [2840] = 987,
  [2841] = 834,
  [2842] = 1029,
  [2843] = 1243,
  [2844] = 1217,
  [2845] = 1169,
  [2846] = 854,
  [2847] = 982,
  [2848] = 988,
  [2849] = 896,
  [2850] = 898,
  [2851] = 989,
  [2852] = 1064,
  [2853] = 1158,
  [2854] = 1157,
  [2855] = 1154,
  [2856] = 1152,
  [2857] = 1150,
  [2858] = 990,
  [2859] = 1149,
  [2860] = 1025,
  [2861] = 993,
  [2862] = 994,
  [2863] = 1147,
  [2864] = 1139,
  [2865] = 1142,
  [2866] = 1045,
  [2867] = 1015,
  [2868] = 1137,
  [2869] = 995,
  [2870] = 1136,
  [2871] = 999,
  [2872] = 1134,
  [2873] = 1126,
  [2874] = 924,
  [2875] = 1123,
  [2876] = 1001,
  [2877] = 1120,
  [2878] = 1119,
  [2879] = 1003,
  [2880] = 1118,
  [2881] = 1115,
  [2882] = 1007,
  [2883] = 1012,
  [2884] = 983,
  [2885] = 1076,
  [2886] = 1075,
  [2887] = 938,
  [2888] = 921,
  [2889] = 920,
  [2890] = 1048,
  [2891] = 1021,
  [2892] = 1013,
  [2893] = 905,
  [2894] = 1055,
  [2895] = 2802,
  [2896] = 1020,
  [2897] = 1062,
  [2898] = 1014,
  [2899] = 1065,
  [2900] = 1072,
  [2901] = 715,
  [2902] = 617,
  [2903] = 595,
  [2904] = 603,
  [2905] = 631,
  [2906] = 687,
  [2907] = 608,
  [2908] = 631,
  [2909] = 604,
  [2910] = 606,
  [2911] = 684,
  [2912] = 597,
  [2913] = 596,
  [2914] = 595,
  [2915] = 620,
  [2916] = 534,
  [2917] = 681,
  [2918] = 679,
  [2919] = 689,
  [2920] = 669,
  [2921] = 691,
  [2922] = 678,
  [2923] = 693,
  [2924] = 559,
  [2925] = 677,
  [2926] = 559,
  [2927] = 696,
  [2928] = 698,
  [2929] = 701,
  [2930] = 703,
  [2931] = 570,
  [2932] = 688,
  [2933] = 570,
  [2934] = 705,
  [2935] = 2935,
  [2936] = 675,
  [2937] = 608,
  [2938] = 534,
  [2939] = 620,
  [2940] = 2940,
  [2941] = 659,
  [2942] = 608,
  [2943] = 570,
  [2944] = 664,
  [2945] = 606,
  [2946] = 2935,
  [2947] = 604,
  [2948] = 672,
  [2949] = 603,
  [2950] = 2940,
  [2951] = 671,
  [2952] = 597,
  [2953] = 596,
  [2954] = 534,
  [2955] = 620,
  [2956] = 606,
  [2957] = 604,
  [2958] = 603,
  [2959] = 597,
  [2960] = 596,
  [2961] = 595,
  [2962] = 559,
  [2963] = 597,
  [2964] = 848,
  [2965] = 1104,
  [2966] = 608,
  [2967] = 570,
  [2968] = 1100,
  [2969] = 711,
  [2970] = 1065,
  [2971] = 699,
  [2972] = 709,
  [2973] = 1070,
  [2974] = 1077,
  [2975] = 1082,
  [2976] = 1088,
  [2977] = 1090,
  [2978] = 1064,
  [2979] = 1033,
  [2980] = 834,
  [2981] = 928,
  [2982] = 1032,
  [2983] = 758,
  [2984] = 1099,
  [2985] = 1101,
  [2986] = 1110,
  [2987] = 1111,
  [2988] = 1113,
  [2989] = 705,
  [2990] = 703,
  [2991] = 701,
  [2992] = 698,
  [2993] = 1072,
  [2994] = 696,
  [2995] = 1021,
  [2996] = 608,
  [2997] = 693,
  [2998] = 691,
  [2999] = 999,
  [3000] = 1125,
  [3001] = 1135,
  [3002] = 1138,
  [3003] = 1141,
  [3004] = 1162,
  [3005] = 1163,
  [3006] = 689,
  [3007] = 559,
  [3008] = 762,
  [3009] = 709,
  [3010] = 595,
  [3011] = 1014,
  [3012] = 1182,
  [3013] = 1191,
  [3014] = 688,
  [3015] = 596,
  [3016] = 597,
  [3017] = 687,
  [3018] = 715,
  [3019] = 681,
  [3020] = 988,
  [3021] = 679,
  [3022] = 1193,
  [3023] = 1211,
  [3024] = 1213,
  [3025] = 1214,
  [3026] = 1215,
  [3027] = 1230,
  [3028] = 1240,
  [3029] = 1245,
  [3030] = 983,
  [3031] = 3031,
  [3032] = 1012,
  [3033] = 1243,
  [3034] = 1217,
  [3035] = 1169,
  [3036] = 1165,
  [3037] = 982,
  [3038] = 1062,
  [3039] = 620,
  [3040] = 678,
  [3041] = 1003,
  [3042] = 1158,
  [3043] = 1157,
  [3044] = 1154,
  [3045] = 1152,
  [3046] = 1150,
  [3047] = 677,
  [3048] = 1149,
  [3049] = 1148,
  [3050] = 1001,
  [3051] = 995,
  [3052] = 1147,
  [3053] = 1139,
  [3054] = 1142,
  [3055] = 1055,
  [3056] = 1015,
  [3057] = 1137,
  [3058] = 994,
  [3059] = 1136,
  [3060] = 993,
  [3061] = 1134,
  [3062] = 1126,
  [3063] = 559,
  [3064] = 1123,
  [3065] = 990,
  [3066] = 1120,
  [3067] = 1119,
  [3068] = 987,
  [3069] = 1118,
  [3070] = 1115,
  [3071] = 595,
  [3072] = 1048,
  [3073] = 596,
  [3074] = 597,
  [3075] = 699,
  [3076] = 980,
  [3077] = 979,
  [3078] = 978,
  [3079] = 682,
  [3080] = 684,
  [3081] = 1045,
  [3082] = 969,
  [3083] = 968,
  [3084] = 603,
  [3085] = 1044,
  [3086] = 967,
  [3087] = 603,
  [3088] = 1037,
  [3089] = 966,
  [3090] = 1036,
  [3091] = 949,
  [3092] = 604,
  [3093] = 945,
  [3094] = 604,
  [3095] = 1007,
  [3096] = 792,
  [3097] = 606,
  [3098] = 620,
  [3099] = 534,
  [3100] = 1076,
  [3101] = 728,
  [3102] = 1075,
  [3103] = 796,
  [3104] = 802,
  [3105] = 570,
  [3106] = 608,
  [3107] = 606,
  [3108] = 682,
  [3109] = 816,
  [3110] = 825,
  [3111] = 875,
  [3112] = 706,
  [3113] = 711,
  [3114] = 882,
  [3115] = 534,
  [3116] = 948,
  [3117] = 860,
  [3118] = 896,
  [3119] = 898,
  [3120] = 669,
  [3121] = 1081,
  [3122] = 905,
  [3123] = 706,
  [3124] = 559,
  [3125] = 920,
  [3126] = 921,
  [3127] = 631,
  [3128] = 924,
  [3129] = 938,
  [3130] = 941,
  [3131] = 534,
  [3132] = 620,
  [3133] = 606,
  [3134] = 889,
  [3135] = 604,
  [3136] = 595,
  [3137] = 672,
  [3138] = 973,
  [3139] = 947,
  [3140] = 570,
  [3141] = 596,
  [3142] = 970,
  [3143] = 603,
  [3144] = 671,
  [3145] = 854,
  [3146] = 675,
  [3147] = 681,
  [3148] = 596,
  [3149] = 1025,
  [3150] = 1026,
  [3151] = 1041,
  [3152] = 1046,
  [3153] = 1049,
  [3154] = 1059,
  [3155] = 1061,
  [3156] = 1069,
  [3157] = 1070,
  [3158] = 1077,
  [3159] = 1082,
  [3160] = 1164,
  [3161] = 1090,
  [3162] = 1062,
  [3163] = 1096,
  [3164] = 659,
  [3165] = 691,
  [3166] = 1014,
  [3167] = 1026,
  [3168] = 691,
  [3169] = 1013,
  [3170] = 1099,
  [3171] = 1101,
  [3172] = 1110,
  [3173] = 1111,
  [3174] = 1113,
  [3175] = 696,
  [3176] = 715,
  [3177] = 3177,
  [3178] = 664,
  [3179] = 1116,
  [3180] = 762,
  [3181] = 688,
  [3182] = 1012,
  [3183] = 1007,
  [3184] = 1003,
  [3185] = 1041,
  [3186] = 1001,
  [3187] = 1046,
  [3188] = 999,
  [3189] = 995,
  [3190] = 1125,
  [3191] = 1135,
  [3192] = 1138,
  [3193] = 1141,
  [3194] = 1162,
  [3195] = 1163,
  [3196] = 1144,
  [3197] = 1170,
  [3198] = 1049,
  [3199] = 1055,
  [3200] = 688,
  [3201] = 1182,
  [3202] = 1191,
  [3203] = 994,
  [3204] = 993,
  [3205] = 990,
  [3206] = 989,
  [3207] = 1059,
  [3208] = 988,
  [3209] = 987,
  [3210] = 1193,
  [3211] = 1211,
  [3212] = 1213,
  [3213] = 1214,
  [3214] = 1215,
  [3215] = 1230,
  [3216] = 1240,
  [3217] = 1245,
  [3218] = 1048,
  [3219] = 724,
  [3220] = 983,
  [3221] = 1243,
  [3222] = 1217,
  [3223] = 1169,
  [3224] = 1165,
  [3225] = 924,
  [3226] = 980,
  [3227] = 979,
  [3228] = 978,
  [3229] = 1023,
  [3230] = 1158,
  [3231] = 1157,
  [3232] = 1154,
  [3233] = 1152,
  [3234] = 1150,
  [3235] = 1045,
  [3236] = 1149,
  [3237] = 1148,
  [3238] = 969,
  [3239] = 968,
  [3240] = 1147,
  [3241] = 1139,
  [3242] = 1142,
  [3243] = 1044,
  [3244] = 1015,
  [3245] = 1137,
  [3246] = 967,
  [3247] = 1136,
  [3248] = 1037,
  [3249] = 1134,
  [3250] = 1126,
  [3251] = 966,
  [3252] = 1123,
  [3253] = 1036,
  [3254] = 1120,
  [3255] = 1119,
  [3256] = 949,
  [3257] = 1118,
  [3258] = 1115,
  [3259] = 948,
  [3260] = 617,
  [3261] = 997,
  [3262] = 974,
  [3263] = 973,
  [3264] = 1013,
  [3265] = 984,
  [3266] = 989,
  [3267] = 1029,
  [3268] = 1019,
  [3269] = 1061,
  [3270] = 1069,
  [3271] = 1025,
  [3272] = 970,
  [3273] = 681,
  [3274] = 608,
  [3275] = 570,
  [3276] = 534,
  [3277] = 620,
  [3278] = 606,
  [3279] = 604,
  [3280] = 947,
  [3281] = 3177,
  [3282] = 1029,
  [3283] = 597,
  [3284] = 1024,
  [3285] = 848,
  [3286] = 595,
  [3287] = 945,
  [3288] = 941,
  [3289] = 1076,
  [3290] = 559,
  [3291] = 1088,
  [3292] = 974,
  [3293] = 703,
  [3294] = 696,
  [3295] = 678,
  [3296] = 834,
  [3297] = 1020,
  [3298] = 681,
  [3299] = 854,
  [3300] = 1075,
  [3301] = 678,
  [3302] = 1096,
  [3303] = 703,
  [3304] = 1072,
  [3305] = 727,
  [3306] = 1116,
  [3307] = 984,
  [3308] = 1144,
  [3309] = 603,
  [3310] = 860,
  [3311] = 1021,
  [3312] = 938,
  [3313] = 1019,
  [3314] = 728,
  [3315] = 1170,
  [3316] = 696,
  [3317] = 1065,
  [3318] = 997,
  [3319] = 1020,
  [3320] = 724,
  [3321] = 691,
  [3322] = 1023,
  [3323] = 727,
  [3324] = 1104,
  [3325] = 137,
  [3326] = 136,
  [3327] = 758,
  [3328] = 139,
  [3329] = 142,
  [3330] = 139,
  [3331] = 134,
  [3332] = 137,
  [3333] = 138,
  [3334] = 1164,
  [3335] = 136,
  [3336] = 134,
  [3337] = 138,
  [3338] = 143,
  [3339] = 1024,
  [3340] = 896,
  [3341] = 142,
  [3342] = 143,
  [3343] = 889,
  [3344] = 921,
  [3345] = 920,
  [3346] = 879,
  [3347] = 928,
  [3348] = 703,
  [3349] = 826,
  [3350] = 905,
  [3351] = 678,
  [3352] = 792,
  [3353] = 982,
  [3354] = 688,
  [3355] = 796,
  [3356] = 802,
  [3357] = 810,
  [3358] = 810,
  [3359] = 816,
  [3360] = 825,
  [3361] = 1100,
  [3362] = 1064,
  [3363] = 826,
  [3364] = 875,
  [3365] = 1081,
  [3366] = 879,
  [3367] = 882,
  [3368] = 1033,
  [3369] = 1032,
  [3370] = 898,
  [3371] = 603,
  [3372] = 696,
  [3373] = 671,
  [3374] = 134,
  [3375] = 678,
  [3376] = 672,
  [3377] = 689,
  [3378] = 693,
  [3379] = 138,
  [3380] = 698,
  [3381] = 675,
  [3382] = 711,
  [3383] = 669,
  [3384] = 559,
  [3385] = 687,
  [3386] = 687,
  [3387] = 142,
  [3388] = 608,
  [3389] = 687,
  [3390] = 677,
  [3391] = 705,
  [3392] = 570,
  [3393] = 534,
  [3394] = 620,
  [3395] = 606,
  [3396] = 604,
  [3397] = 678,
  [3398] = 699,
  [3399] = 597,
  [3400] = 596,
  [3401] = 595,
  [3402] = 709,
  [3403] = 559,
  [3404] = 682,
  [3405] = 684,
  [3406] = 679,
  [3407] = 688,
  [3408] = 659,
  [3409] = 693,
  [3410] = 701,
  [3411] = 705,
  [3412] = 136,
  [3413] = 677,
  [3414] = 691,
  [3415] = 664,
  [3416] = 689,
  [3417] = 677,
  [3418] = 679,
  [3419] = 706,
  [3420] = 595,
  [3421] = 137,
  [3422] = 701,
  [3423] = 143,
  [3424] = 617,
  [3425] = 696,
  [3426] = 596,
  [3427] = 597,
  [3428] = 705,
  [3429] = 603,
  [3430] = 604,
  [3431] = 606,
  [3432] = 620,
  [3433] = 534,
  [3434] = 701,
  [3435] = 570,
  [3436] = 679,
  [3437] = 608,
  [3438] = 679,
  [3439] = 681,
  [3440] = 698,
  [3441] = 701,
  [3442] = 139,
  [3443] = 703,
  [3444] = 681,
  [3445] = 687,
  [3446] = 703,
  [3447] = 677,
  [3448] = 688,
  [3449] = 705,
  [3450] = 3450,
  [3451] = 698,
  [3452] = 698,
  [3453] = 693,
  [3454] = 691,
  [3455] = 693,
  [3456] = 1049,
  [3457] = 664,
  [3458] = 1123,
  [3459] = 679,
  [3460] = 1120,
  [3461] = 1119,
  [3462] = 1118,
  [3463] = 1115,
  [3464] = 1125,
  [3465] = 1075,
  [3466] = 1090,
  [3467] = 1164,
  [3468] = 1082,
  [3469] = 1077,
  [3470] = 1070,
  [3471] = 1069,
  [3472] = 1061,
  [3473] = 1059,
  [3474] = 1046,
  [3475] = 1064,
  [3476] = 834,
  [3477] = 1041,
  [3478] = 1026,
  [3479] = 1025,
  [3480] = 834,
  [3481] = 1024,
  [3482] = 1023,
  [3483] = 1135,
  [3484] = 997,
  [3485] = 974,
  [3486] = 973,
  [3487] = 970,
  [3488] = 947,
  [3489] = 945,
  [3490] = 941,
  [3491] = 728,
  [3492] = 1138,
  [3493] = 689,
  [3494] = 671,
  [3495] = 1141,
  [3496] = 664,
  [3497] = 669,
  [3498] = 617,
  [3499] = 1014,
  [3500] = 1162,
  [3501] = 727,
  [3502] = 924,
  [3503] = 1163,
  [3504] = 1144,
  [3505] = 1126,
  [3506] = 1076,
  [3507] = 1134,
  [3508] = 664,
  [3509] = 1012,
  [3510] = 1007,
  [3511] = 1096,
  [3512] = 1136,
  [3513] = 921,
  [3514] = 698,
  [3515] = 1137,
  [3516] = 1015,
  [3517] = 834,
  [3518] = 1003,
  [3519] = 1142,
  [3520] = 617,
  [3521] = 1139,
  [3522] = 659,
  [3523] = 1001,
  [3524] = 889,
  [3525] = 1170,
  [3526] = 1062,
  [3527] = 1147,
  [3528] = 995,
  [3529] = 659,
  [3530] = 1021,
  [3531] = 1065,
  [3532] = 1148,
  [3533] = 848,
  [3534] = 677,
  [3535] = 1149,
  [3536] = 758,
  [3537] = 854,
  [3538] = 1116,
  [3539] = 1029,
  [3540] = 762,
  [3541] = 920,
  [3542] = 1150,
  [3543] = 979,
  [3544] = 994,
  [3545] = 705,
  [3546] = 993,
  [3547] = 715,
  [3548] = 990,
  [3549] = 1152,
  [3550] = 905,
  [3551] = 1154,
  [3552] = 1182,
  [3553] = 1157,
  [3554] = 1158,
  [3555] = 3450,
  [3556] = 860,
  [3557] = 693,
  [3558] = 988,
  [3559] = 987,
  [3560] = 1099,
  [3561] = 1081,
  [3562] = 1104,
  [3563] = 1101,
  [3564] = 1020,
  [3565] = 675,
  [3566] = 3566,
  [3567] = 728,
  [3568] = 1165,
  [3569] = 671,
  [3570] = 1019,
  [3571] = 1191,
  [3572] = 1055,
  [3573] = 983,
  [3574] = 999,
  [3575] = 898,
  [3576] = 896,
  [3577] = 671,
  [3578] = 675,
  [3579] = 1072,
  [3580] = 672,
  [3581] = 1169,
  [3582] = 984,
  [3583] = 1217,
  [3584] = 1243,
  [3585] = 1113,
  [3586] = 669,
  [3587] = 982,
  [3588] = 701,
  [3589] = 617,
  [3590] = 928,
  [3591] = 882,
  [3592] = 1048,
  [3593] = 1088,
  [3594] = 980,
  [3595] = 879,
  [3596] = 875,
  [3597] = 826,
  [3598] = 825,
  [3599] = 1032,
  [3600] = 669,
  [3601] = 938,
  [3602] = 816,
  [3603] = 810,
  [3604] = 989,
  [3605] = 675,
  [3606] = 1013,
  [3607] = 687,
  [3608] = 1110,
  [3609] = 1045,
  [3610] = 802,
  [3611] = 978,
  [3612] = 1033,
  [3613] = 796,
  [3614] = 969,
  [3615] = 659,
  [3616] = 1245,
  [3617] = 1044,
  [3618] = 1240,
  [3619] = 1230,
  [3620] = 758,
  [3621] = 1215,
  [3622] = 1037,
  [3623] = 968,
  [3624] = 967,
  [3625] = 1214,
  [3626] = 792,
  [3627] = 1036,
  [3628] = 1213,
  [3629] = 1211,
  [3630] = 1193,
  [3631] = 966,
  [3632] = 1100,
  [3633] = 1111,
  [3634] = 948,
  [3635] = 949,
  [3636] = 724,
  [3637] = 983,
  [3638] = 982,
  [3639] = 688,
  [3640] = 995,
  [3641] = 994,
  [3642] = 993,
  [3643] = 990,
  [3644] = 848,
  [3645] = 999,
  [3646] = 1001,
  [3647] = 1003,
  [3648] = 989,
  [3649] = 988,
  [3650] = 987,
  [3651] = 136,
  [3652] = 1007,
  [3653] = 948,
  [3654] = 681,
  [3655] = 691,
  [3656] = 715,
  [3657] = 1072,
  [3658] = 1013,
  [3659] = 854,
  [3660] = 928,
  [3661] = 1055,
  [3662] = 669,
  [3663] = 678,
  [3664] = 684,
  [3665] = 137,
  [3666] = 758,
  [3667] = 1062,
  [3668] = 1048,
  [3669] = 691,
  [3670] = 1075,
  [3671] = 1019,
  [3672] = 938,
  [3673] = 860,
  [3674] = 703,
  [3675] = 1012,
  [3676] = 1065,
  [3677] = 1014,
  [3678] = 1020,
  [3679] = 1021,
  [3680] = 1076,
  [3681] = 671,
  [3682] = 1029,
  [3683] = 143,
  [3684] = 980,
  [3685] = 979,
  [3686] = 1032,
  [3687] = 978,
  [3688] = 672,
  [3689] = 1033,
  [3690] = 1064,
  [3691] = 949,
  [3692] = 889,
  [3693] = 672,
  [3694] = 1036,
  [3695] = 688,
  [3696] = 966,
  [3697] = 681,
  [3698] = 678,
  [3699] = 139,
  [3700] = 1037,
  [3701] = 138,
  [3702] = 967,
  [3703] = 631,
  [3704] = 675,
  [3705] = 703,
  [3706] = 728,
  [3707] = 1044,
  [3708] = 134,
  [3709] = 1045,
  [3710] = 672,
  [3711] = 968,
  [3712] = 969,
  [3713] = 142,
  [3714] = 696,
  [3715] = 696,
  [3716] = 684,
  [3717] = 889,
  [3718] = 982,
  [3719] = 1037,
  [3720] = 715,
  [3721] = 727,
  [3722] = 1012,
  [3723] = 1007,
  [3724] = 1076,
  [3725] = 1003,
  [3726] = 966,
  [3727] = 1001,
  [3728] = 701,
  [3729] = 999,
  [3730] = 995,
  [3731] = 1072,
  [3732] = 1036,
  [3733] = 949,
  [3734] = 705,
  [3735] = 701,
  [3736] = 698,
  [3737] = 705,
  [3738] = 693,
  [3739] = 687,
  [3740] = 679,
  [3741] = 677,
  [3742] = 711,
  [3743] = 1076,
  [3744] = 137,
  [3745] = 1072,
  [3746] = 136,
  [3747] = 706,
  [3748] = 1065,
  [3749] = 983,
  [3750] = 1075,
  [3751] = 948,
  [3752] = 1033,
  [3753] = 1032,
  [3754] = 928,
  [3755] = 1014,
  [3756] = 1062,
  [3757] = 1065,
  [3758] = 693,
  [3759] = 967,
  [3760] = 1021,
  [3761] = 1020,
  [3762] = 1075,
  [3763] = 979,
  [3764] = 1062,
  [3765] = 1064,
  [3766] = 1064,
  [3767] = 1013,
  [3768] = 715,
  [3769] = 1033,
  [3770] = 1012,
  [3771] = 1007,
  [3772] = 1032,
  [3773] = 1044,
  [3774] = 134,
  [3775] = 1003,
  [3776] = 706,
  [3777] = 1076,
  [3778] = 860,
  [3779] = 1001,
  [3780] = 138,
  [3781] = 1021,
  [3782] = 938,
  [3783] = 995,
  [3784] = 889,
  [3785] = 1014,
  [3786] = 559,
  [3787] = 595,
  [3788] = 596,
  [3789] = 994,
  [3790] = 597,
  [3791] = 603,
  [3792] = 604,
  [3793] = 993,
  [3794] = 990,
  [3795] = 989,
  [3796] = 142,
  [3797] = 987,
  [3798] = 1048,
  [3799] = 980,
  [3800] = 606,
  [3801] = 979,
  [3802] = 978,
  [3803] = 848,
  [3804] = 1045,
  [3805] = 969,
  [3806] = 968,
  [3807] = 1044,
  [3808] = 687,
  [3809] = 1055,
  [3810] = 1037,
  [3811] = 983,
  [3812] = 966,
  [3813] = 1036,
  [3814] = 949,
  [3815] = 948,
  [3816] = 620,
  [3817] = 534,
  [3818] = 1029,
  [3819] = 1075,
  [3820] = 570,
  [3821] = 1062,
  [3822] = 608,
  [3823] = 938,
  [3824] = 1019,
  [3825] = 967,
  [3826] = 928,
  [3827] = 834,
  [3828] = 1014,
  [3829] = 928,
  [3830] = 982,
  [3831] = 1072,
  [3832] = 715,
  [3833] = 1055,
  [3834] = 860,
  [3835] = 682,
  [3836] = 994,
  [3837] = 993,
  [3838] = 631,
  [3839] = 854,
  [3840] = 727,
  [3841] = 1012,
  [3842] = 1007,
  [3843] = 968,
  [3844] = 1003,
  [3845] = 1001,
  [3846] = 999,
  [3847] = 995,
  [3848] = 969,
  [3849] = 142,
  [3850] = 143,
  [3851] = 988,
  [3852] = 138,
  [3853] = 134,
  [3854] = 990,
  [3855] = 136,
  [3856] = 137,
  [3857] = 139,
  [3858] = 1065,
  [3859] = 854,
  [3860] = 1055,
  [3861] = 848,
  [3862] = 848,
  [3863] = 854,
  [3864] = 143,
  [3865] = 987,
  [3866] = 889,
  [3867] = 994,
  [3868] = 978,
  [3869] = 993,
  [3870] = 990,
  [3871] = 988,
  [3872] = 987,
  [3873] = 142,
  [3874] = 136,
  [3875] = 137,
  [3876] = 1048,
  [3877] = 698,
  [3878] = 983,
  [3879] = 1165,
  [3880] = 982,
  [3881] = 980,
  [3882] = 979,
  [3883] = 978,
  [3884] = 1045,
  [3885] = 969,
  [3886] = 968,
  [3887] = 1064,
  [3888] = 1045,
  [3889] = 1044,
  [3890] = 659,
  [3891] = 711,
  [3892] = 664,
  [3893] = 617,
  [3894] = 967,
  [3895] = 679,
  [3896] = 938,
  [3897] = 1037,
  [3898] = 966,
  [3899] = 138,
  [3900] = 1036,
  [3901] = 659,
  [3902] = 134,
  [3903] = 664,
  [3904] = 949,
  [3905] = 948,
  [3906] = 682,
  [3907] = 860,
  [3908] = 139,
  [3909] = 1048,
  [3910] = 139,
  [3911] = 617,
  [3912] = 1033,
  [3913] = 1165,
  [3914] = 980,
  [3915] = 999,
  [3916] = 143,
  [3917] = 988,
  [3918] = 1021,
  [3919] = 677,
  [3920] = 1032,
  [3921] = 924,
  [3922] = 1029,
  [3923] = 1116,
  [3924] = 1134,
  [3925] = 796,
  [3926] = 1126,
  [3927] = 1116,
  [3928] = 921,
  [3929] = 1169,
  [3930] = 1123,
  [3931] = 1182,
  [3932] = 724,
  [3933] = 989,
  [3934] = 1142,
  [3935] = 1139,
  [3936] = 1147,
  [3937] = 1154,
  [3938] = 970,
  [3939] = 973,
  [3940] = 974,
  [3941] = 997,
  [3942] = 1125,
  [3943] = 1217,
  [3944] = 1135,
  [3945] = 1243,
  [3946] = 1138,
  [3947] = 1023,
  [3948] = 699,
  [3949] = 1125,
  [3950] = 1135,
  [3951] = 1138,
  [3952] = 1141,
  [3953] = 709,
  [3954] = 559,
  [3955] = 1141,
  [3956] = 1157,
  [3957] = 595,
  [3958] = 596,
  [3959] = 597,
  [3960] = 603,
  [3961] = 706,
  [3962] = 1120,
  [3963] = 1119,
  [3964] = 3964,
  [3965] = 1113,
  [3966] = 604,
  [3967] = 1162,
  [3968] = 1163,
  [3969] = 1144,
  [3970] = 1170,
  [3971] = 1111,
  [3972] = 606,
  [3973] = 620,
  [3974] = 534,
  [3975] = 675,
  [3976] = 570,
  [3977] = 608,
  [3978] = 1024,
  [3979] = 920,
  [3980] = 1025,
  [3981] = 1113,
  [3982] = 1111,
  [3983] = 1041,
  [3984] = 659,
  [3985] = 1110,
  [3986] = 1046,
  [3987] = 1049,
  [3988] = 1059,
  [3989] = 1029,
  [3990] = 1061,
  [3991] = 1158,
  [3992] = 1110,
  [3993] = 3993,
  [3994] = 1182,
  [3995] = 1162,
  [3996] = 1163,
  [3997] = 1191,
  [3998] = 1144,
  [3999] = 1170,
  [4000] = 1118,
  [4001] = 989,
  [4002] = 1115,
  [4003] = 1193,
  [4004] = 671,
  [4005] = 1101,
  [4006] = 1099,
  [4007] = 1013,
  [4008] = 834,
  [4009] = 898,
  [4010] = 1096,
  [4011] = 792,
  [4012] = 1136,
  [4013] = 905,
  [4014] = 143,
  [4015] = 724,
  [4016] = 796,
  [4017] = 802,
  [4018] = 1193,
  [4019] = 924,
  [4020] = 711,
  [4021] = 810,
  [4022] = 816,
  [4023] = 825,
  [4024] = 142,
  [4025] = 1211,
  [4026] = 1213,
  [4027] = 1137,
  [4028] = 3993,
  [4029] = 1020,
  [4030] = 138,
  [4031] = 689,
  [4032] = 826,
  [4033] = 875,
  [4034] = 879,
  [4035] = 2194,
  [4036] = 882,
  [4037] = 810,
  [4038] = 816,
  [4039] = 882,
  [4040] = 1015,
  [4041] = 134,
  [4042] = 1214,
  [4043] = 879,
  [4044] = 1025,
  [4045] = 896,
  [4046] = 898,
  [4047] = 905,
  [4048] = 1215,
  [4049] = 920,
  [4050] = 921,
  [4051] = 684,
  [4052] = 1101,
  [4053] = 136,
  [4054] = 137,
  [4055] = 1099,
  [4056] = 834,
  [4057] = 1020,
  [4058] = 1013,
  [4059] = 1019,
  [4060] = 139,
  [4061] = 941,
  [4062] = 792,
  [4063] = 945,
  [4064] = 1069,
  [4065] = 689,
  [4066] = 1240,
  [4067] = 1245,
  [4068] = 1240,
  [4069] = 1096,
  [4070] = 705,
  [4071] = 703,
  [4072] = 701,
  [4073] = 1070,
  [4074] = 669,
  [4075] = 1077,
  [4076] = 684,
  [4077] = 1115,
  [4078] = 1118,
  [4079] = 682,
  [4080] = 698,
  [4081] = 696,
  [4082] = 1119,
  [4083] = 825,
  [4084] = 693,
  [4085] = 671,
  [4086] = 1211,
  [4087] = 1120,
  [4088] = 691,
  [4089] = 672,
  [4090] = 1213,
  [4091] = 688,
  [4092] = 1123,
  [4093] = 1230,
  [4094] = 1214,
  [4095] = 687,
  [4096] = 675,
  [4097] = 947,
  [4098] = 617,
  [4099] = 834,
  [4100] = 1215,
  [4101] = 1230,
  [4102] = 681,
  [4103] = 1126,
  [4104] = 1243,
  [4105] = 1134,
  [4106] = 1217,
  [4107] = 679,
  [4108] = 896,
  [4109] = 1169,
  [4110] = 669,
  [4111] = 802,
  [4112] = 678,
  [4113] = 677,
  [4114] = 1136,
  [4115] = 1152,
  [4116] = 664,
  [4117] = 1158,
  [4118] = 1157,
  [4119] = 1154,
  [4120] = 1152,
  [4121] = 1150,
  [4122] = 1148,
  [4123] = 1150,
  [4124] = 1082,
  [4125] = 1164,
  [4126] = 1149,
  [4127] = 1026,
  [4128] = 1090,
  [4129] = 1090,
  [4130] = 947,
  [4131] = 1164,
  [4132] = 1082,
  [4133] = 1149,
  [4134] = 970,
  [4135] = 1148,
  [4136] = 973,
  [4137] = 1077,
  [4138] = 1147,
  [4139] = 1139,
  [4140] = 974,
  [4141] = 1137,
  [4142] = 669,
  [4143] = 1142,
  [4144] = 1019,
  [4145] = 1015,
  [4146] = 1070,
  [4147] = 1069,
  [4148] = 1061,
  [4149] = 997,
  [4150] = 875,
  [4151] = 826,
  [4152] = 1245,
  [4153] = 671,
  [4154] = 1059,
  [4155] = 1049,
  [4156] = 1046,
  [4157] = 672,
  [4158] = 1191,
  [4159] = 1041,
  [4160] = 1026,
  [4161] = 941,
  [4162] = 1023,
  [4163] = 945,
  [4164] = 675,
  [4165] = 1024,
  [4166] = 1164,
  [4167] = 758,
  [4168] = 1082,
  [4169] = 4169,
  [4170] = 1012,
  [4171] = 1007,
  [4172] = 1003,
  [4173] = 1001,
  [4174] = 999,
  [4175] = 995,
  [4176] = 1077,
  [4177] = 994,
  [4178] = 993,
  [4179] = 990,
  [4180] = 989,
  [4181] = 984,
  [4182] = 988,
  [4183] = 987,
  [4184] = 1070,
  [4185] = 727,
  [4186] = 982,
  [4187] = 980,
  [4188] = 979,
  [4189] = 978,
  [4190] = 1013,
  [4191] = 1090,
  [4192] = 969,
  [4193] = 968,
  [4194] = 928,
  [4195] = 967,
  [4196] = 1014,
  [4197] = 966,
  [4198] = 1075,
  [4199] = 949,
  [4200] = 948,
  [4201] = 1019,
  [4202] = 938,
  [4203] = 1021,
  [4204] = 1029,
  [4205] = 1069,
  [4206] = 974,
  [4207] = 1061,
  [4208] = 860,
  [4209] = 1032,
  [4210] = 1033,
  [4211] = 1088,
  [4212] = 948,
  [4213] = 938,
  [4214] = 949,
  [4215] = 1100,
  [4216] = 1036,
  [4217] = 1059,
  [4218] = 2194,
  [4219] = 142,
  [4220] = 966,
  [4221] = 928,
  [4222] = 1037,
  [4223] = 967,
  [4224] = 1044,
  [4225] = 968,
  [4226] = 969,
  [4227] = 792,
  [4228] = 1045,
  [4229] = 854,
  [4230] = 1096,
  [4231] = 978,
  [4232] = 979,
  [4233] = 980,
  [4234] = 982,
  [4235] = 983,
  [4236] = 999,
  [4237] = 1048,
  [4238] = 1049,
  [4239] = 987,
  [4240] = 848,
  [4241] = 1046,
  [4242] = 1041,
  [4243] = 1026,
  [4244] = 1025,
  [4245] = 990,
  [4246] = 993,
  [4247] = 988,
  [4248] = 994,
  [4249] = 1055,
  [4250] = 1024,
  [4251] = 706,
  [4252] = 1023,
  [4253] = 995,
  [4254] = 1001,
  [4255] = 889,
  [4256] = 796,
  [4257] = 997,
  [4258] = 143,
  [4259] = 802,
  [4260] = 1003,
  [4261] = 1007,
  [4262] = 1012,
  [4263] = 724,
  [4264] = 715,
  [4265] = 4265,
  [4266] = 1014,
  [4267] = 860,
  [4268] = 1062,
  [4269] = 1099,
  [4270] = 4270,
  [4271] = 1020,
  [4272] = 1021,
  [4273] = 1101,
  [4274] = 854,
  [4275] = 810,
  [4276] = 1032,
  [4277] = 848,
  [4278] = 1033,
  [4279] = 816,
  [4280] = 825,
  [4281] = 1064,
  [4282] = 889,
  [4283] = 1110,
  [4284] = 134,
  [4285] = 1036,
  [4286] = 826,
  [4287] = 875,
  [4288] = 1037,
  [4289] = 1044,
  [4290] = 973,
  [4291] = 1045,
  [4292] = 728,
  [4293] = 711,
  [4294] = 711,
  [4295] = 2514,
  [4296] = 1048,
  [4297] = 682,
  [4298] = 1104,
  [4299] = 1081,
  [4300] = 758,
  [4301] = 1055,
  [4302] = 1065,
  [4303] = 970,
  [4304] = 728,
  [4305] = 1111,
  [4306] = 715,
  [4307] = 1072,
  [4308] = 727,
  [4309] = 947,
  [4310] = 1062,
  [4311] = 1020,
  [4312] = 1075,
  [4313] = 945,
  [4314] = 1076,
  [4315] = 941,
  [4316] = 1029,
  [4317] = 1019,
  [4318] = 1013,
  [4319] = 989,
  [4320] = 834,
  [4321] = 1113,
  [4322] = 1064,
  [4323] = 1115,
  [4324] = 1118,
  [4325] = 1119,
  [4326] = 1120,
  [4327] = 1123,
  [4328] = 834,
  [4329] = 672,
  [4330] = 924,
  [4331] = 1126,
  [4332] = 1134,
  [4333] = 1136,
  [4334] = 138,
  [4335] = 1137,
  [4336] = 1015,
  [4337] = 1142,
  [4338] = 1139,
  [4339] = 1147,
  [4340] = 1076,
  [4341] = 4341,
  [4342] = 1148,
  [4343] = 139,
  [4344] = 1149,
  [4345] = 137,
  [4346] = 1150,
  [4347] = 136,
  [4348] = 1152,
  [4349] = 1154,
  [4350] = 921,
  [4351] = 134,
  [4352] = 920,
  [4353] = 138,
  [4354] = 1157,
  [4355] = 143,
  [4356] = 142,
  [4357] = 1158,
  [4358] = 905,
  [4359] = 724,
  [4360] = 882,
  [4361] = 1165,
  [4362] = 1169,
  [4363] = 1217,
  [4364] = 1243,
  [4365] = 983,
  [4366] = 1245,
  [4367] = 1240,
  [4368] = 1230,
  [4369] = 1215,
  [4370] = 1214,
  [4371] = 1213,
  [4372] = 1211,
  [4373] = 1072,
  [4374] = 1193,
  [4375] = 762,
  [4376] = 1165,
  [4377] = 1191,
  [4378] = 1182,
  [4379] = 1065,
  [4380] = 699,
  [4381] = 709,
  [4382] = 1170,
  [4383] = 1144,
  [4384] = 1163,
  [4385] = 1162,
  [4386] = 1141,
  [4387] = 1138,
  [4388] = 1135,
  [4389] = 879,
  [4390] = 1125,
  [4391] = 896,
  [4392] = 1116,
  [4393] = 898,
  [4394] = 989,
  [4395] = 1072,
  [4396] = 1119,
  [4397] = 949,
  [4398] = 1118,
  [4399] = 1123,
  [4400] = 1120,
  [4401] = 1162,
  [4402] = 2119,
  [4403] = 1020,
  [4404] = 948,
  [4405] = 984,
  [4406] = 1141,
  [4407] = 1138,
  [4408] = 1135,
  [4409] = 1125,
  [4410] = 995,
  [4411] = 1001,
  [4412] = 1003,
  [4413] = 1113,
  [4414] = 1211,
  [4415] = 1007,
  [4416] = 1012,
  [4417] = 1116,
  [4418] = 138,
  [4419] = 1110,
  [4420] = 1193,
  [4421] = 987,
  [4422] = 1111,
  [4423] = 938,
  [4424] = 1115,
  [4425] = 990,
  [4426] = 993,
  [4427] = 134,
  [4428] = 928,
  [4429] = 1101,
  [4430] = 1099,
  [4431] = 1013,
  [4432] = 999,
  [4433] = 1215,
  [4434] = 1045,
  [4435] = 1213,
  [4436] = 988,
  [4437] = 1014,
  [4438] = 994,
  [4439] = 941,
  [4440] = 834,
  [4441] = 1096,
  [4442] = 2537,
  [4443] = 1243,
  [4444] = 1064,
  [4445] = 1134,
  [4446] = 1090,
  [4447] = 1217,
  [4448] = 1164,
  [4449] = 1082,
  [4450] = 1019,
  [4451] = 1029,
  [4452] = 989,
  [4453] = 1077,
  [4454] = 1070,
  [4455] = 1069,
  [4456] = 1013,
  [4457] = 1061,
  [4458] = 682,
  [4459] = 1059,
  [4460] = 1169,
  [4461] = 1049,
  [4462] = 1046,
  [4463] = 1041,
  [4464] = 982,
  [4465] = 980,
  [4466] = 1026,
  [4467] = 979,
  [4468] = 1025,
  [4469] = 978,
  [4470] = 1158,
  [4471] = 1024,
  [4472] = 1157,
  [4473] = 1154,
  [4474] = 1230,
  [4475] = 1150,
  [4476] = 139,
  [4477] = 1240,
  [4478] = 966,
  [4479] = 1126,
  [4480] = 1023,
  [4481] = 1036,
  [4482] = 860,
  [4483] = 792,
  [4484] = 997,
  [4485] = 1191,
  [4486] = 1152,
  [4487] = 1076,
  [4488] = 810,
  [4489] = 825,
  [4490] = 826,
  [4491] = 879,
  [4492] = 974,
  [4493] = 973,
  [4494] = 137,
  [4495] = 970,
  [4496] = 2514,
  [4497] = 947,
  [4498] = 1182,
  [4499] = 945,
  [4500] = 854,
  [4501] = 1163,
  [4502] = 1075,
  [4503] = 1062,
  [4504] = 1149,
  [4505] = 1144,
  [4506] = 715,
  [4507] = 136,
  [4508] = 727,
  [4509] = 848,
  [4510] = 1245,
  [4511] = 1214,
  [4512] = 1044,
  [4513] = 1065,
  [4514] = 1055,
  [4515] = 879,
  [4516] = 983,
  [4517] = 2551,
  [4518] = 143,
  [4519] = 796,
  [4520] = 802,
  [4521] = 2539,
  [4522] = 142,
  [4523] = 1148,
  [4524] = 834,
  [4525] = 974,
  [4526] = 997,
  [4527] = 969,
  [4528] = 889,
  [4529] = 968,
  [4530] = 2556,
  [4531] = 2557,
  [4532] = 1147,
  [4533] = 1023,
  [4534] = 1024,
  [4535] = 1048,
  [4536] = 724,
  [4537] = 1139,
  [4538] = 1019,
  [4539] = 1020,
  [4540] = 834,
  [4541] = 2543,
  [4542] = 1021,
  [4543] = 924,
  [4544] = 1142,
  [4545] = 810,
  [4546] = 921,
  [4547] = 1037,
  [4548] = 816,
  [4549] = 1170,
  [4550] = 920,
  [4551] = 826,
  [4552] = 875,
  [4553] = 905,
  [4554] = 2541,
  [4555] = 898,
  [4556] = 896,
  [4557] = 1025,
  [4558] = 1015,
  [4559] = 1170,
  [4560] = 1029,
  [4561] = 1137,
  [4562] = 1144,
  [4563] = 1116,
  [4564] = 1026,
  [4565] = 1041,
  [4566] = 882,
  [4567] = 1046,
  [4568] = 1049,
  [4569] = 1059,
  [4570] = 1032,
  [4571] = 1096,
  [4572] = 1033,
  [4573] = 967,
  [4574] = 1164,
  [4575] = 1069,
  [4576] = 1061,
  [4577] = 1136,
  [4578] = 1024,
  [4579] = 682,
  [4580] = 834,
  [4581] = 2556,
  [4582] = 682,
  [4583] = 834,
  [4584] = 142,
  [4585] = 139,
  [4586] = 2557,
  [4587] = 2539,
  [4588] = 706,
  [4589] = 1170,
  [4590] = 1144,
  [4591] = 1116,
  [4592] = 1096,
  [4593] = 1164,
  [4594] = 134,
  [4595] = 879,
  [4596] = 834,
  [4597] = 138,
  [4598] = 4598,
  [4599] = 1069,
  [4600] = 1061,
  [4601] = 1059,
  [4602] = 1049,
  [4603] = 2551,
  [4604] = 684,
  [4605] = 1046,
  [4606] = 1041,
  [4607] = 4607,
  [4608] = 136,
  [4609] = 1026,
  [4610] = 834,
  [4611] = 1025,
  [4612] = 2541,
  [4613] = 826,
  [4614] = 137,
  [4615] = 143,
  [4616] = 4616,
  [4617] = 2537,
  [4618] = 711,
  [4619] = 997,
  [4620] = 1023,
  [4621] = 810,
  [4622] = 974,
  [4623] = 2543,
  [4624] = 2514,
  [4625] = 2543,
  [4626] = 1152,
  [4627] = 1077,
  [4628] = 1137,
  [4629] = 810,
  [4630] = 1163,
  [4631] = 139,
  [4632] = 1070,
  [4633] = 826,
  [4634] = 1069,
  [4635] = 1158,
  [4636] = 1136,
  [4637] = 1134,
  [4638] = 4638,
  [4639] = 1182,
  [4640] = 1126,
  [4641] = 1191,
  [4642] = 4638,
  [4643] = 1061,
  [4644] = 4638,
  [4645] = 1123,
  [4646] = 1059,
  [4647] = 1120,
  [4648] = 1144,
  [4649] = 1119,
  [4650] = 1116,
  [4651] = 1118,
  [4652] = 142,
  [4653] = 2541,
  [4654] = 2539,
  [4655] = 2537,
  [4656] = 1049,
  [4657] = 1046,
  [4658] = 1041,
  [4659] = 875,
  [4660] = 1026,
  [4661] = 1115,
  [4662] = 1025,
  [4663] = 1024,
  [4664] = 834,
  [4665] = 143,
  [4666] = 1023,
  [4667] = 1193,
  [4668] = 136,
  [4669] = 724,
  [4670] = 1211,
  [4671] = 137,
  [4672] = 1213,
  [4673] = 136,
  [4674] = 1170,
  [4675] = 134,
  [4676] = 974,
  [4677] = 1015,
  [4678] = 1157,
  [4679] = 1113,
  [4680] = 137,
  [4681] = 1099,
  [4682] = 1111,
  [4683] = 1164,
  [4684] = 1110,
  [4685] = 792,
  [4686] = 796,
  [4687] = 1214,
  [4688] = 802,
  [4689] = 1090,
  [4690] = 2557,
  [4691] = 2556,
  [4692] = 810,
  [4693] = 1162,
  [4694] = 816,
  [4695] = 143,
  [4696] = 825,
  [4697] = 1154,
  [4698] = 1082,
  [4699] = 1230,
  [4700] = 826,
  [4701] = 1165,
  [4702] = 1240,
  [4703] = 1101,
  [4704] = 879,
  [4705] = 1245,
  [4706] = 882,
  [4707] = 973,
  [4708] = 1169,
  [4709] = 1217,
  [4710] = 711,
  [4711] = 1150,
  [4712] = 2551,
  [4713] = 970,
  [4714] = 1243,
  [4715] = 947,
  [4716] = 1142,
  [4717] = 879,
  [4718] = 142,
  [4719] = 1139,
  [4720] = 945,
  [4721] = 4638,
  [4722] = 1138,
  [4723] = 1135,
  [4724] = 711,
  [4725] = 4638,
  [4726] = 727,
  [4727] = 974,
  [4728] = 997,
  [4729] = 1023,
  [4730] = 1024,
  [4731] = 1025,
  [4732] = 1026,
  [4733] = 1041,
  [4734] = 898,
  [4735] = 905,
  [4736] = 1147,
  [4737] = 920,
  [4738] = 1046,
  [4739] = 1148,
  [4740] = 1049,
  [4741] = 1059,
  [4742] = 1061,
  [4743] = 921,
  [4744] = 834,
  [4745] = 1069,
  [4746] = 1164,
  [4747] = 1215,
  [4748] = 834,
  [4749] = 1096,
  [4750] = 1116,
  [4751] = 1096,
  [4752] = 1144,
  [4753] = 1170,
  [4754] = 143,
  [4755] = 941,
  [4756] = 134,
  [4757] = 4270,
  [4758] = 4265,
  [4759] = 1125,
  [4760] = 138,
  [4761] = 139,
  [4762] = 924,
  [4763] = 134,
  [4764] = 896,
  [4765] = 834,
  [4766] = 2194,
  [4767] = 138,
  [4768] = 138,
  [4769] = 997,
  [4770] = 1141,
  [4771] = 1149,
  [4772] = 4772,
  [4773] = 4773,
  [4774] = 4773,
  [4775] = 4772,
  [4776] = 4773,
  [4777] = 4777,
  [4778] = 4777,
  [4779] = 4772,
  [4780] = 4777,
  [4781] = 4773,
  [4782] = 4270,
  [4783] = 4777,
  [4784] = 4772,
  [4785] = 4772,
  [4786] = 4777,
  [4787] = 4773,
  [4788] = 4777,
  [4789] = 4773,
  [4790] = 4777,
  [4791] = 4777,
  [4792] = 4773,
  [4793] = 4777,
  [4794] = 4772,
  [4795] = 4772,
  [4796] = 4772,
  [4797] = 4797,
  [4798] = 724,
  [4799] = 4773,
  [4800] = 4773,
  [4801] = 139,
  [4802] = 4772,
  [4803] = 4777,
  [4804] = 4772,
  [4805] = 4777,
  [4806] = 4777,
  [4807] = 4772,
  [4808] = 136,
  [4809] = 4265,
  [4810] = 4777,
  [4811] = 4773,
  [4812] = 4773,
  [4813] = 4777,
  [4814] = 4777,
  [4815] = 4772,
  [4816] = 4773,
  [4817] = 4772,
  [4818] = 4773,
  [4819] = 4777,
  [4820] = 4773,
  [4821] = 4821,
  [4822] = 4777,
  [4823] = 4773,
  [4824] = 4773,
  [4825] = 4772,
  [4826] = 4772,
  [4827] = 4772,
  [4828] = 4828,
  [4829] = 142,
  [4830] = 137,
  [4831] = 4772,
  [4832] = 4773,
  [4833] = 4833,
  [4834] = 4834,
  [4835] = 4835,
  [4836] = 4836,
  [4837] = 4837,
  [4838] = 4838,
  [4839] = 4839,
  [4840] = 4840,
  [4841] = 4841,
  [4842] = 4842,
  [4843] = 4843,
  [4844] = 4844,
  [4845] = 4845,
  [4846] = 4846,
  [4847] = 4847,
  [4848] = 4848,
  [4849] = 4849,
  [4850] = 4850,
  [4851] = 4851,
  [4852] = 4852,
  [4853] = 4850,
  [4854] = 4851,
  [4855] = 4855,
  [4856] = 4855,
  [4857] = 4855,
  [4858] = 4858,
  [4859] = 682,
  [4860] = 4860,
  [4861] = 4852,
  [4862] = 4860,
  [4863] = 4850,
  [4864] = 4851,
  [4865] = 4851,
  [4866] = 4866,
  [4867] = 4860,
  [4868] = 4860,
  [4869] = 4850,
  [4870] = 4852,
  [4871] = 4855,
  [4872] = 4851,
  [4873] = 4860,
  [4874] = 4858,
  [4875] = 4850,
  [4876] = 4852,
  [4877] = 4852,
  [4878] = 4850,
  [4879] = 4855,
  [4880] = 4852,
  [4881] = 4860,
  [4882] = 4855,
  [4883] = 4855,
  [4884] = 4851,
  [4885] = 4855,
  [4886] = 3450,
  [4887] = 4855,
  [4888] = 4860,
  [4889] = 4852,
  [4890] = 4850,
  [4891] = 4850,
  [4892] = 4855,
  [4893] = 4860,
  [4894] = 4860,
  [4895] = 4850,
  [4896] = 4852,
  [4897] = 4860,
  [4898] = 4860,
  [4899] = 4852,
  [4900] = 4852,
  [4901] = 4860,
  [4902] = 4860,
  [4903] = 4855,
  [4904] = 4852,
  [4905] = 4855,
  [4906] = 4855,
  [4907] = 4851,
  [4908] = 4908,
  [4909] = 4909,
  [4910] = 4851,
  [4911] = 4911,
  [4912] = 4850,
  [4913] = 4858,
  [4914] = 4860,
  [4915] = 4915,
  [4916] = 4858,
  [4917] = 4852,
  [4918] = 4858,
  [4919] = 4860,
  [4920] = 4860,
  [4921] = 4850,
  [4922] = 4858,
  [4923] = 4850,
  [4924] = 4855,
  [4925] = 4852,
  [4926] = 4926,
  [4927] = 4852,
  [4928] = 4850,
  [4929] = 4860,
  [4930] = 4851,
  [4931] = 4852,
  [4932] = 4932,
  [4933] = 2194,
  [4934] = 4852,
  [4935] = 4855,
  [4936] = 4850,
  [4937] = 4850,
  [4938] = 4858,
  [4939] = 4851,
  [4940] = 4855,
  [4941] = 4852,
  [4942] = 4850,
  [4943] = 4943,
  [4944] = 4852,
  [4945] = 4858,
  [4946] = 4851,
  [4947] = 4858,
  [4948] = 4948,
  [4949] = 4850,
  [4950] = 4858,
  [4951] = 4855,
  [4952] = 4860,
  [4953] = 4858,
  [4954] = 4954,
  [4955] = 4858,
  [4956] = 4956,
  [4957] = 4860,
  [4958] = 4855,
  [4959] = 4851,
  [4960] = 4852,
  [4961] = 4850,
  [4962] = 4860,
  [4963] = 4855,
  [4964] = 4852,
  [4965] = 4855,
  [4966] = 4852,
  [4967] = 4967,
  [4968] = 4850,
  [4969] = 4851,
  [4970] = 4858,
  [4971] = 4860,
  [4972] = 4858,
  [4973] = 4860,
  [4974] = 4974,
  [4975] = 4860,
  [4976] = 4850,
  [4977] = 4852,
  [4978] = 4978,
  [4979] = 4855,
  [4980] = 4850,
  [4981] = 4855,
  [4982] = 4852,
  [4983] = 4850,
  [4984] = 4852,
  [4985] = 4851,
  [4986] = 4860,
  [4987] = 4858,
  [4988] = 4860,
  [4989] = 4850,
  [4990] = 4990,
  [4991] = 4860,
  [4992] = 4850,
  [4993] = 4852,
  [4994] = 2194,
  [4995] = 4995,
  [4996] = 4855,
  [4997] = 4855,
  [4998] = 4851,
  [4999] = 4858,
  [5000] = 4850,
  [5001] = 4852,
  [5002] = 4860,
  [5003] = 4855,
  [5004] = 4850,
  [5005] = 4850,
  [5006] = 4850,
  [5007] = 4860,
  [5008] = 4852,
  [5009] = 4855,
  [5010] = 4855,
  [5011] = 4855,
  [5012] = 4852,
  [5013] = 4850,
  [5014] = 4851,
  [5015] = 4855,
  [5016] = 4860,
  [5017] = 4850,
  [5018] = 4850,
  [5019] = 4852,
  [5020] = 4860,
  [5021] = 4855,
  [5022] = 4855,
  [5023] = 4858,
  [5024] = 4852,
  [5025] = 4852,
  [5026] = 4860,
  [5027] = 4851,
  [5028] = 5028,
  [5029] = 5029,
  [5030] = 5030,
  [5031] = 5031,
  [5032] = 5032,
  [5033] = 5033,
  [5034] = 5033,
  [5035] = 5035,
  [5036] = 5036,
  [5037] = 5037,
  [5038] = 5030,
  [5039] = 5031,
  [5040] = 5040,
  [5041] = 5035,
  [5042] = 5042,
  [5043] = 5043,
  [5044] = 5044,
  [5045] = 5033,
  [5046] = 5046,
  [5047] = 5035,
  [5048] = 5033,
  [5049] = 5049,
  [5050] = 5050,
  [5051] = 5029,
  [5052] = 5030,
  [5053] = 5031,
  [5054] = 5029,
  [5055] = 5055,
  [5056] = 5042,
  [5057] = 5057,
  [5058] = 5040,
  [5059] = 5033,
  [5060] = 5043,
  [5061] = 5035,
  [5062] = 5032,
  [5063] = 5031,
  [5064] = 5064,
  [5065] = 5065,
  [5066] = 5030,
  [5067] = 5035,
  [5068] = 5033,
  [5069] = 5069,
  [5070] = 5070,
  [5071] = 5035,
  [5072] = 5030,
  [5073] = 5031,
  [5074] = 5074,
  [5075] = 5075,
  [5076] = 5031,
  [5077] = 5077,
  [5078] = 5030,
  [5079] = 5042,
  [5080] = 5080,
  [5081] = 5069,
  [5082] = 5035,
  [5083] = 5033,
  [5084] = 5084,
  [5085] = 5032,
  [5086] = 5035,
  [5087] = 5031,
  [5088] = 5030,
  [5089] = 5036,
  [5090] = 5090,
  [5091] = 5035,
  [5092] = 5033,
  [5093] = 5030,
  [5094] = 5094,
  [5095] = 5030,
  [5096] = 5031,
  [5097] = 5042,
  [5098] = 5098,
  [5099] = 5030,
  [5100] = 879,
  [5101] = 5030,
  [5102] = 5033,
  [5103] = 826,
  [5104] = 810,
  [5105] = 5035,
  [5106] = 5030,
  [5107] = 5030,
  [5108] = 5077,
  [5109] = 5043,
  [5110] = 5110,
  [5111] = 5030,
  [5112] = 5031,
  [5113] = 5113,
  [5114] = 5030,
  [5115] = 5030,
  [5116] = 5030,
  [5117] = 5043,
  [5118] = 5042,
  [5119] = 5050,
  [5120] = 5120,
  [5121] = 5033,
  [5122] = 5122,
  [5123] = 5035,
  [5124] = 5028,
  [5125] = 5030,
  [5126] = 5070,
  [5127] = 5030,
  [5128] = 5030,
  [5129] = 5031,
  [5130] = 5042,
  [5131] = 5077,
  [5132] = 5033,
  [5133] = 5077,
  [5134] = 5032,
  [5135] = 5035,
  [5136] = 5032,
  [5137] = 5070,
  [5138] = 5084,
  [5139] = 5139,
  [5140] = 5084,
  [5141] = 5084,
  [5142] = 5036,
  [5143] = 5050,
  [5144] = 5043,
  [5145] = 5030,
  [5146] = 5084,
  [5147] = 5031,
  [5148] = 5070,
  [5149] = 5149,
  [5150] = 5042,
  [5151] = 5029,
  [5152] = 5152,
  [5153] = 5153,
  [5154] = 5033,
  [5155] = 5070,
  [5156] = 5156,
  [5157] = 5157,
  [5158] = 5035,
  [5159] = 5159,
  [5160] = 5160,
  [5161] = 5161,
  [5162] = 5094,
  [5163] = 5040,
  [5164] = 5030,
  [5165] = 5043,
  [5166] = 5030,
  [5167] = 5031,
  [5168] = 5042,
  [5169] = 5070,
  [5170] = 997,
  [5171] = 5171,
  [5172] = 5065,
  [5173] = 5033,
  [5174] = 5077,
  [5175] = 5035,
  [5176] = 5050,
  [5177] = 5077,
  [5178] = 5032,
  [5179] = 5070,
  [5180] = 5180,
  [5181] = 5032,
  [5182] = 5030,
  [5183] = 5031,
  [5184] = 5042,
  [5185] = 3450,
  [5186] = 5029,
  [5187] = 5065,
  [5188] = 5074,
  [5189] = 5043,
  [5190] = 5084,
  [5191] = 5057,
  [5192] = 5032,
  [5193] = 5074,
  [5194] = 5070,
  [5195] = 834,
  [5196] = 5036,
  [5197] = 5077,
  [5198] = 5069,
  [5199] = 5199,
  [5200] = 5033,
  [5201] = 5032,
  [5202] = 5043,
  [5203] = 5036,
  [5204] = 5029,
  [5205] = 5035,
  [5206] = 5069,
  [5207] = 5069,
  [5208] = 5028,
  [5209] = 974,
  [5210] = 5040,
  [5211] = 1170,
  [5212] = 1023,
  [5213] = 5030,
  [5214] = 5036,
  [5215] = 5065,
  [5216] = 5031,
  [5217] = 1024,
  [5218] = 5042,
  [5219] = 5032,
  [5220] = 1025,
  [5221] = 1026,
  [5222] = 1041,
  [5223] = 5074,
  [5224] = 5029,
  [5225] = 5065,
  [5226] = 5074,
  [5227] = 5069,
  [5228] = 1046,
  [5229] = 5229,
  [5230] = 5065,
  [5231] = 5029,
  [5232] = 5043,
  [5233] = 5032,
  [5234] = 5070,
  [5235] = 5036,
  [5236] = 5028,
  [5237] = 5077,
  [5238] = 1049,
  [5239] = 1059,
  [5240] = 1061,
  [5241] = 5043,
  [5242] = 5242,
  [5243] = 5069,
  [5244] = 5070,
  [5245] = 5036,
  [5246] = 5032,
  [5247] = 5077,
  [5248] = 1069,
  [5249] = 5033,
  [5250] = 1164,
  [5251] = 5035,
  [5252] = 5050,
  [5253] = 1096,
  [5254] = 1116,
  [5255] = 1144,
  [5256] = 5032,
  [5257] = 5070,
  [5258] = 5030,
  [5259] = 5031,
  [5260] = 5260,
  [5261] = 5069,
  [5262] = 5262,
  [5263] = 5042,
  [5264] = 5264,
  [5265] = 5065,
  [5266] = 5074,
  [5267] = 834,
  [5268] = 5029,
  [5269] = 5031,
  [5270] = 5270,
  [5271] = 5084,
  [5272] = 5077,
  [5273] = 5065,
  [5274] = 5029,
  [5275] = 5036,
  [5276] = 5028,
  [5277] = 5065,
  [5278] = 5032,
  [5279] = 5043,
  [5280] = 5050,
  [5281] = 5065,
  [5282] = 5029,
  [5283] = 5074,
  [5284] = 5040,
  [5285] = 5065,
  [5286] = 5032,
  [5287] = 5069,
  [5288] = 5042,
  [5289] = 5032,
  [5290] = 5043,
  [5291] = 5074,
  [5292] = 5077,
  [5293] = 5029,
  [5294] = 5069,
  [5295] = 5032,
  [5296] = 5029,
  [5297] = 5070,
  [5298] = 5036,
  [5299] = 5077,
  [5300] = 5074,
  [5301] = 5043,
  [5302] = 5032,
  [5303] = 5065,
  [5304] = 5029,
  [5305] = 5070,
  [5306] = 5032,
  [5307] = 5036,
  [5308] = 5070,
  [5309] = 5077,
  [5310] = 5077,
  [5311] = 5043,
  [5312] = 5032,
  [5313] = 5036,
  [5314] = 5314,
  [5315] = 5077,
  [5316] = 5316,
  [5317] = 5036,
  [5318] = 5070,
  [5319] = 5043,
  [5320] = 5320,
  [5321] = 5321,
  [5322] = 5050,
  [5323] = 5321,
  [5324] = 5036,
  [5325] = 5077,
  [5326] = 5077,
  [5327] = 5032,
  [5328] = 5077,
  [5329] = 5084,
  [5330] = 5036,
  [5331] = 5043,
  [5332] = 2539,
  [5333] = 2514,
  [5334] = 5084,
  [5335] = 5050,
  [5336] = 5070,
  [5337] = 5084,
  [5338] = 5043,
  [5339] = 5040,
  [5340] = 5156,
  [5341] = 5050,
  [5342] = 5153,
  [5343] = 5043,
  [5344] = 5074,
  [5345] = 5074,
  [5346] = 5069,
  [5347] = 5040,
  [5348] = 5036,
  [5349] = 5349,
  [5350] = 5065,
  [5351] = 5029,
  [5352] = 5262,
  [5353] = 5070,
  [5354] = 5065,
  [5355] = 5036,
  [5356] = 5077,
  [5357] = 5043,
  [5358] = 5070,
  [5359] = 5036,
  [5360] = 5077,
  [5361] = 5043,
  [5362] = 5070,
  [5363] = 5036,
  [5364] = 5036,
  [5365] = 5070,
  [5366] = 5032,
  [5367] = 5077,
  [5368] = 2537,
  [5369] = 5070,
  [5370] = 2541,
  [5371] = 5036,
  [5372] = 5077,
  [5373] = 5084,
  [5374] = 5084,
  [5375] = 5077,
  [5376] = 5084,
  [5377] = 5065,
  [5378] = 2543,
  [5379] = 5028,
  [5380] = 5069,
  [5381] = 5029,
  [5382] = 5152,
  [5383] = 5065,
  [5384] = 5043,
  [5385] = 5084,
  [5386] = 5070,
  [5387] = 5028,
  [5388] = 5040,
  [5389] = 5389,
  [5390] = 5070,
  [5391] = 5040,
  [5392] = 5032,
  [5393] = 5043,
  [5394] = 5032,
  [5395] = 5029,
  [5396] = 5029,
  [5397] = 5397,
  [5398] = 5036,
  [5399] = 5043,
  [5400] = 5032,
  [5401] = 5040,
  [5402] = 5077,
  [5403] = 5084,
  [5404] = 5042,
  [5405] = 5320,
  [5406] = 5065,
  [5407] = 5043,
  [5408] = 5077,
  [5409] = 5070,
  [5410] = 5032,
  [5411] = 5036,
  [5412] = 5032,
  [5413] = 5032,
  [5414] = 5077,
  [5415] = 5033,
  [5416] = 5050,
  [5417] = 5036,
  [5418] = 5035,
  [5419] = 5070,
  [5420] = 5043,
  [5421] = 5029,
  [5422] = 5422,
  [5423] = 5074,
  [5424] = 5065,
  [5425] = 5042,
  [5426] = 5069,
  [5427] = 5077,
  [5428] = 5030,
  [5429] = 5031,
  [5430] = 5043,
  [5431] = 5030,
  [5432] = 5042,
  [5433] = 5028,
  [5434] = 5084,
  [5435] = 5065,
  [5436] = 5042,
  [5437] = 5077,
  [5438] = 5036,
  [5439] = 5065,
  [5440] = 5029,
  [5441] = 5029,
  [5442] = 5036,
  [5443] = 5040,
  [5444] = 5040,
  [5445] = 5042,
  [5446] = 5149,
  [5447] = 5065,
  [5448] = 5028,
  [5449] = 5030,
  [5450] = 5180,
  [5451] = 5069,
  [5452] = 5070,
  [5453] = 5453,
  [5454] = 5040,
  [5455] = 5077,
  [5456] = 5074,
  [5457] = 5457,
  [5458] = 5458,
  [5459] = 5036,
  [5460] = 5050,
  [5461] = 5028,
  [5462] = 5070,
  [5463] = 5040,
  [5464] = 5070,
  [5465] = 5029,
  [5466] = 5036,
  [5467] = 5040,
  [5468] = 5065,
  [5469] = 5050,
  [5470] = 5043,
  [5471] = 5471,
  [5472] = 5040,
  [5473] = 5036,
  [5474] = 5028,
  [5475] = 5152,
  [5476] = 5050,
  [5477] = 4828,
  [5478] = 5478,
  [5479] = 5040,
  [5480] = 5040,
  [5481] = 5094,
  [5482] = 5042,
  [5483] = 5030,
  [5484] = 5262,
  [5485] = 5152,
  [5486] = 5094,
  [5487] = 5152,
  [5488] = 5488,
  [5489] = 5149,
  [5490] = 5094,
  [5491] = 5491,
  [5492] = 5040,
  [5493] = 5152,
  [5494] = 5149,
  [5495] = 5094,
  [5496] = 5050,
  [5497] = 5028,
  [5498] = 5028,
  [5499] = 5043,
  [5500] = 5029,
  [5501] = 5040,
  [5502] = 5028,
  [5503] = 5040,
  [5504] = 5152,
  [5505] = 5065,
  [5506] = 5149,
  [5507] = 5507,
  [5508] = 5040,
  [5509] = 5509,
  [5510] = 5028,
  [5511] = 5028,
  [5512] = 5094,
  [5513] = 5077,
  [5514] = 5040,
  [5515] = 2551,
  [5516] = 5516,
  [5517] = 5036,
  [5518] = 5152,
  [5519] = 5149,
  [5520] = 5094,
  [5521] = 5042,
  [5522] = 5522,
  [5523] = 5262,
  [5524] = 5050,
  [5525] = 5029,
  [5526] = 5149,
  [5527] = 5152,
  [5528] = 5040,
  [5529] = 5040,
  [5530] = 5262,
  [5531] = 5065,
  [5532] = 682,
  [5533] = 5533,
  [5534] = 5043,
  [5535] = 5262,
  [5536] = 5040,
  [5537] = 5537,
  [5538] = 5074,
  [5539] = 5094,
  [5540] = 5180,
  [5541] = 2557,
  [5542] = 5262,
  [5543] = 5070,
  [5544] = 5069,
  [5545] = 5057,
  [5546] = 5152,
  [5547] = 5149,
  [5548] = 5152,
  [5549] = 5065,
  [5550] = 5040,
  [5551] = 5029,
  [5552] = 2556,
  [5553] = 5149,
  [5554] = 5094,
  [5555] = 5152,
  [5556] = 5149,
  [5557] = 5057,
  [5558] = 5029,
  [5559] = 5028,
  [5560] = 5065,
  [5561] = 5040,
  [5562] = 5029,
  [5563] = 5094,
  [5564] = 5180,
  [5565] = 5040,
  [5566] = 5180,
  [5567] = 5094,
  [5568] = 5057,
  [5569] = 5084,
  [5570] = 5065,
  [5571] = 5032,
  [5572] = 5043,
  [5573] = 5149,
  [5574] = 5029,
  [5575] = 5152,
  [5576] = 5152,
  [5577] = 5120,
  [5578] = 5578,
  [5579] = 5033,
  [5580] = 5040,
  [5581] = 5149,
  [5582] = 5094,
  [5583] = 5065,
  [5584] = 5032,
  [5585] = 5065,
  [5586] = 5077,
  [5587] = 5040,
  [5588] = 5065,
  [5589] = 5029,
  [5590] = 5180,
  [5591] = 5057,
  [5592] = 5149,
  [5593] = 5040,
  [5594] = 5152,
  [5595] = 5070,
  [5596] = 5029,
  [5597] = 5180,
  [5598] = 5057,
  [5599] = 5599,
  [5600] = 5600,
  [5601] = 5601,
  [5602] = 5599,
  [5603] = 5603,
  [5604] = 5604,
  [5605] = 5604,
  [5606] = 5601,
  [5607] = 5604,
  [5608] = 5604,
  [5609] = 5603,
  [5610] = 5610,
  [5611] = 5611,
  [5612] = 5601,
  [5613] = 5610,
  [5614] = 5599,
  [5615] = 5604,
  [5616] = 5603,
  [5617] = 5599,
  [5618] = 5603,
  [5619] = 5611,
  [5620] = 5601,
  [5621] = 5601,
  [5622] = 5603,
  [5623] = 5599,
  [5624] = 5604,
  [5625] = 5611,
  [5626] = 5603,
  [5627] = 5611,
  [5628] = 5603,
  [5629] = 5601,
  [5630] = 5604,
  [5631] = 5599,
  [5632] = 5604,
  [5633] = 5604,
  [5634] = 5604,
  [5635] = 5603,
  [5636] = 5611,
  [5637] = 5611,
  [5638] = 5601,
  [5639] = 5599,
  [5640] = 5604,
  [5641] = 5599,
  [5642] = 5599,
  [5643] = 5643,
  [5644] = 5603,
  [5645] = 5601,
  [5646] = 5611,
  [5647] = 5611,
  [5648] = 5601,
  [5649] = 5611,
  [5650] = 5599,
  [5651] = 5604,
  [5652] = 5603,
  [5653] = 5603,
  [5654] = 5611,
  [5655] = 5601,
  [5656] = 5603,
  [5657] = 5601,
  [5658] = 5599,
  [5659] = 5604,
  [5660] = 5611,
  [5661] = 5604,
  [5662] = 5603,
  [5663] = 5611,
  [5664] = 5601,
  [5665] = 5599,
  [5666] = 5604,
  [5667] = 5603,
  [5668] = 5599,
  [5669] = 5599,
  [5670] = 5599,
  [5671] = 5600,
  [5672] = 5611,
  [5673] = 5600,
  [5674] = 3450,
  [5675] = 5601,
  [5676] = 5599,
  [5677] = 5599,
  [5678] = 5604,
  [5679] = 5603,
  [5680] = 5611,
  [5681] = 5601,
  [5682] = 5601,
  [5683] = 5599,
  [5684] = 5601,
  [5685] = 5604,
  [5686] = 5600,
  [5687] = 5601,
  [5688] = 5611,
  [5689] = 5603,
  [5690] = 5611,
  [5691] = 5603,
  [5692] = 5601,
  [5693] = 5601,
  [5694] = 5694,
  [5695] = 5604,
  [5696] = 5599,
  [5697] = 5599,
  [5698] = 5604,
  [5699] = 5600,
  [5700] = 5603,
  [5701] = 5611,
  [5702] = 5601,
  [5703] = 5599,
  [5704] = 5704,
  [5705] = 5611,
  [5706] = 5604,
  [5707] = 5603,
  [5708] = 5599,
  [5709] = 5611,
  [5710] = 5600,
  [5711] = 5711,
  [5712] = 5601,
  [5713] = 5601,
  [5714] = 5599,
  [5715] = 5604,
  [5716] = 5603,
  [5717] = 5599,
  [5718] = 5611,
  [5719] = 5611,
  [5720] = 5603,
  [5721] = 5601,
  [5722] = 5722,
  [5723] = 5604,
  [5724] = 5603,
  [5725] = 5611,
  [5726] = 5600,
  [5727] = 5601,
  [5728] = 5599,
  [5729] = 5729,
  [5730] = 5601,
  [5731] = 5603,
  [5732] = 5604,
  [5733] = 5611,
  [5734] = 5734,
  [5735] = 5601,
  [5736] = 5599,
  [5737] = 5737,
  [5738] = 5599,
  [5739] = 5600,
  [5740] = 5603,
  [5741] = 5611,
  [5742] = 5601,
  [5743] = 5743,
  [5744] = 5604,
  [5745] = 5745,
  [5746] = 5746,
  [5747] = 5604,
  [5748] = 5611,
  [5749] = 5611,
  [5750] = 5599,
  [5751] = 5611,
  [5752] = 5603,
  [5753] = 5600,
  [5754] = 5611,
  [5755] = 5604,
  [5756] = 5604,
  [5757] = 5601,
  [5758] = 5599,
  [5759] = 5603,
  [5760] = 5604,
  [5761] = 5600,
  [5762] = 5601,
  [5763] = 5599,
  [5764] = 5601,
  [5765] = 5765,
  [5766] = 5599,
  [5767] = 5604,
  [5768] = 5600,
  [5769] = 5601,
  [5770] = 5610,
  [5771] = 5611,
  [5772] = 5604,
  [5773] = 5603,
  [5774] = 5603,
  [5775] = 5611,
  [5776] = 5603,
  [5777] = 5603,
  [5778] = 5603,
  [5779] = 5599,
  [5780] = 5600,
  [5781] = 5604,
  [5782] = 5600,
  [5783] = 5611,
  [5784] = 5601,
  [5785] = 5603,
  [5786] = 5786,
  [5787] = 5787,
  [5788] = 5788,
  [5789] = 5788,
  [5790] = 5788,
  [5791] = 4846,
  [5792] = 5792,
  [5793] = 834,
  [5794] = 5788,
  [5795] = 5786,
  [5796] = 5792,
  [5797] = 5788,
  [5798] = 5798,
  [5799] = 5788,
  [5800] = 834,
  [5801] = 5792,
  [5802] = 834,
  [5803] = 5786,
  [5804] = 5804,
  [5805] = 834,
  [5806] = 5786,
  [5807] = 5807,
  [5808] = 5786,
  [5809] = 834,
  [5810] = 5786,
  [5811] = 5811,
  [5812] = 834,
  [5813] = 5813,
  [5814] = 4848,
  [5815] = 5788,
  [5816] = 834,
  [5817] = 834,
  [5818] = 5786,
  [5819] = 5786,
  [5820] = 5798,
  [5821] = 5786,
  [5822] = 5807,
  [5823] = 5788,
  [5824] = 5792,
  [5825] = 5786,
  [5826] = 5792,
  [5827] = 5813,
  [5828] = 5788,
  [5829] = 834,
  [5830] = 5792,
  [5831] = 5786,
  [5832] = 5788,
  [5833] = 5786,
  [5834] = 834,
  [5835] = 834,
  [5836] = 5788,
  [5837] = 5786,
  [5838] = 834,
  [5839] = 5788,
  [5840] = 5788,
  [5841] = 834,
  [5842] = 5788,
  [5843] = 5843,
  [5844] = 5788,
  [5845] = 834,
  [5846] = 834,
  [5847] = 5788,
  [5848] = 5788,
  [5849] = 834,
  [5850] = 5788,
  [5851] = 834,
  [5852] = 5852,
  [5853] = 5853,
  [5854] = 3450,
  [5855] = 5855,
  [5856] = 5856,
  [5857] = 5857,
  [5858] = 5858,
  [5859] = 5853,
  [5860] = 5860,
  [5861] = 5855,
  [5862] = 5862,
  [5863] = 5862,
  [5864] = 5864,
  [5865] = 5858,
  [5866] = 5866,
  [5867] = 5867,
  [5868] = 4837,
  [5869] = 5869,
  [5870] = 5855,
  [5871] = 4848,
  [5872] = 5853,
  [5873] = 5864,
  [5874] = 5862,
  [5875] = 5853,
  [5876] = 5858,
  [5877] = 5877,
  [5878] = 4844,
  [5879] = 5877,
  [5880] = 5880,
  [5881] = 5877,
  [5882] = 5855,
  [5883] = 5867,
  [5884] = 5884,
  [5885] = 5877,
  [5886] = 4847,
  [5887] = 5864,
  [5888] = 5853,
  [5889] = 5864,
  [5890] = 5858,
  [5891] = 5862,
  [5892] = 5877,
  [5893] = 5893,
  [5894] = 5862,
  [5895] = 5858,
  [5896] = 5855,
  [5897] = 5862,
  [5898] = 5853,
  [5899] = 4841,
  [5900] = 5867,
  [5901] = 5853,
  [5902] = 4846,
  [5903] = 5903,
  [5904] = 4834,
  [5905] = 5862,
  [5906] = 5858,
  [5907] = 5867,
  [5908] = 5858,
  [5909] = 5864,
  [5910] = 5864,
  [5911] = 5867,
  [5912] = 4836,
  [5913] = 5913,
  [5914] = 5855,
  [5915] = 4843,
  [5916] = 5853,
  [5917] = 5862,
  [5918] = 5864,
  [5919] = 5919,
  [5920] = 5862,
  [5921] = 5853,
  [5922] = 5855,
  [5923] = 4839,
  [5924] = 5867,
  [5925] = 5864,
  [5926] = 5858,
  [5927] = 5927,
  [5928] = 4835,
  [5929] = 5877,
  [5930] = 5855,
  [5931] = 5853,
  [5932] = 5866,
  [5933] = 5867,
  [5934] = 5867,
  [5935] = 5855,
  [5936] = 5936,
  [5937] = 5858,
  [5938] = 5867,
  [5939] = 5858,
  [5940] = 5864,
  [5941] = 5855,
  [5942] = 5867,
  [5943] = 5864,
  [5944] = 5858,
  [5945] = 5864,
  [5946] = 5946,
  [5947] = 5877,
  [5948] = 5862,
  [5949] = 5877,
  [5950] = 5855,
  [5951] = 5858,
  [5952] = 5864,
  [5953] = 5864,
  [5954] = 5853,
  [5955] = 5855,
  [5956] = 5956,
  [5957] = 5877,
  [5958] = 5855,
  [5959] = 5862,
  [5960] = 5867,
  [5961] = 5961,
  [5962] = 5864,
  [5963] = 5963,
  [5964] = 5877,
  [5965] = 5853,
  [5966] = 5864,
  [5967] = 5877,
  [5968] = 5858,
  [5969] = 711,
  [5970] = 5853,
  [5971] = 5862,
  [5972] = 5853,
  [5973] = 5877,
  [5974] = 5853,
  [5975] = 5864,
  [5976] = 5852,
  [5977] = 5867,
  [5978] = 5877,
  [5979] = 5979,
  [5980] = 5857,
  [5981] = 5864,
  [5982] = 5862,
  [5983] = 5853,
  [5984] = 5867,
  [5985] = 5853,
  [5986] = 5860,
  [5987] = 5987,
  [5988] = 5988,
  [5989] = 5989,
  [5990] = 5990,
  [5991] = 5987,
  [5992] = 5987,
  [5993] = 682,
  [5994] = 682,
  [5995] = 724,
  [5996] = 5996,
  [5997] = 5997,
  [5998] = 5998,
  [5999] = 5987,
  [6000] = 5987,
  [6001] = 682,
  [6002] = 682,
  [6003] = 6003,
  [6004] = 6004,
  [6005] = 6005,
  [6006] = 6006,
  [6007] = 5987,
  [6008] = 6008,
  [6009] = 5987,
  [6010] = 5987,
  [6011] = 5987,
  [6012] = 6012,
  [6013] = 6013,
  [6014] = 682,
  [6015] = 6015,
  [6016] = 682,
  [6017] = 5987,
  [6018] = 6018,
  [6019] = 6019,
  [6020] = 682,
  [6021] = 5987,
  [6022] = 682,
  [6023] = 682,
  [6024] = 6024,
  [6025] = 682,
  [6026] = 6008,
  [6027] = 6027,
  [6028] = 5987,
  [6029] = 5987,
  [6030] = 5987,
  [6031] = 682,
  [6032] = 6032,
  [6033] = 5987,
  [6034] = 682,
  [6035] = 6019,
  [6036] = 5987,
  [6037] = 5987,
  [6038] = 4909,
  [6039] = 682,
  [6040] = 6040,
  [6041] = 682,
  [6042] = 6042,
  [6043] = 6043,
  [6044] = 682,
  [6045] = 6045,
  [6046] = 6046,
  [6047] = 6047,
  [6048] = 6048,
  [6049] = 6049,
  [6050] = 6049,
  [6051] = 6051,
  [6052] = 6052,
  [6053] = 6053,
  [6054] = 6054,
  [6055] = 6055,
  [6056] = 6047,
  [6057] = 6048,
  [6058] = 6058,
  [6059] = 6049,
  [6060] = 6051,
  [6061] = 6048,
  [6062] = 6062,
  [6063] = 6055,
  [6064] = 6047,
  [6065] = 6053,
  [6066] = 6047,
  [6067] = 6048,
  [6068] = 6049,
  [6069] = 6051,
  [6070] = 6058,
  [6071] = 6046,
  [6072] = 6055,
  [6073] = 6051,
  [6074] = 6053,
  [6075] = 6046,
  [6076] = 6047,
  [6077] = 6058,
  [6078] = 6054,
  [6079] = 6058,
  [6080] = 6048,
  [6081] = 6055,
  [6082] = 6082,
  [6083] = 6083,
  [6084] = 6048,
  [6085] = 6051,
  [6086] = 6049,
  [6087] = 6055,
  [6088] = 6051,
  [6089] = 6053,
  [6090] = 6053,
  [6091] = 6049,
  [6092] = 6055,
  [6093] = 6047,
  [6094] = 6047,
  [6095] = 6048,
  [6096] = 6049,
  [6097] = 6051,
  [6098] = 6049,
  [6099] = 6055,
  [6100] = 6100,
  [6101] = 6048,
  [6102] = 6083,
  [6103] = 6103,
  [6104] = 6082,
  [6105] = 6048,
  [6106] = 6047,
  [6107] = 6048,
  [6108] = 6049,
  [6109] = 6058,
  [6110] = 6110,
  [6111] = 6111,
  [6112] = 6051,
  [6113] = 6047,
  [6114] = 6054,
  [6115] = 6055,
  [6116] = 6047,
  [6117] = 6048,
  [6118] = 6100,
  [6119] = 6049,
  [6120] = 6055,
  [6121] = 6047,
  [6122] = 6051,
  [6123] = 6053,
  [6124] = 6051,
  [6125] = 6125,
  [6126] = 6046,
  [6127] = 6055,
  [6128] = 6047,
  [6129] = 6048,
  [6130] = 6049,
  [6131] = 6053,
  [6132] = 6048,
  [6133] = 6049,
  [6134] = 6055,
  [6135] = 6047,
  [6136] = 6055,
  [6137] = 6053,
  [6138] = 6051,
  [6139] = 6049,
  [6140] = 6055,
  [6141] = 6048,
  [6142] = 6083,
  [6143] = 6143,
  [6144] = 6103,
  [6145] = 6047,
  [6146] = 6048,
  [6147] = 6049,
  [6148] = 6100,
  [6149] = 6047,
  [6150] = 6150,
  [6151] = 6082,
  [6152] = 6055,
  [6153] = 6051,
  [6154] = 6083,
  [6155] = 6055,
  [6156] = 6125,
  [6157] = 6047,
  [6158] = 6082,
  [6159] = 6048,
  [6160] = 6049,
  [6161] = 6051,
  [6162] = 6053,
  [6163] = 6052,
  [6164] = 6051,
  [6165] = 6150,
  [6166] = 6103,
  [6167] = 6053,
  [6168] = 6143,
  [6169] = 6052,
  [6170] = 6170,
  [6171] = 6055,
  [6172] = 6049,
  [6173] = 6045,
  [6174] = 6055,
  [6175] = 6046,
  [6176] = 6046,
  [6177] = 6047,
  [6178] = 6103,
  [6179] = 6143,
  [6180] = 6143,
  [6181] = 6051,
  [6182] = 6048,
  [6183] = 6100,
  [6184] = 6150,
  [6185] = 6047,
  [6186] = 6049,
  [6187] = 6052,
  [6188] = 6051,
  [6189] = 6058,
  [6190] = 6049,
  [6191] = 6191,
  [6192] = 6150,
  [6193] = 6054,
  [6194] = 6110,
  [6195] = 6047,
  [6196] = 6048,
  [6197] = 6053,
  [6198] = 6055,
  [6199] = 6052,
  [6200] = 6055,
  [6201] = 6049,
  [6202] = 6046,
  [6203] = 6111,
  [6204] = 6047,
  [6205] = 6083,
  [6206] = 6150,
  [6207] = 6048,
  [6208] = 6082,
  [6209] = 6046,
  [6210] = 6052,
  [6211] = 6049,
  [6212] = 6051,
  [6213] = 6051,
  [6214] = 6150,
  [6215] = 6051,
  [6216] = 6046,
  [6217] = 6046,
  [6218] = 6082,
  [6219] = 6083,
  [6220] = 6053,
  [6221] = 6170,
  [6222] = 6150,
  [6223] = 6047,
  [6224] = 6051,
  [6225] = 6055,
  [6226] = 6052,
  [6227] = 6046,
  [6228] = 6047,
  [6229] = 6049,
  [6230] = 6048,
  [6231] = 6082,
  [6232] = 6055,
  [6233] = 6082,
  [6234] = 6083,
  [6235] = 6049,
  [6236] = 6051,
  [6237] = 6083,
  [6238] = 6054,
  [6239] = 6083,
  [6240] = 6082,
  [6241] = 6048,
  [6242] = 6049,
  [6243] = 6046,
  [6244] = 6150,
  [6245] = 6048,
  [6246] = 6055,
  [6247] = 6049,
  [6248] = 6058,
  [6249] = 6125,
  [6250] = 6083,
  [6251] = 6082,
  [6252] = 6103,
  [6253] = 6143,
  [6254] = 6054,
  [6255] = 6047,
  [6256] = 6048,
  [6257] = 6055,
  [6258] = 6055,
  [6259] = 6049,
  [6260] = 6054,
  [6261] = 6048,
  [6262] = 6082,
  [6263] = 6048,
  [6264] = 6083,
  [6265] = 6054,
  [6266] = 6047,
  [6267] = 6049,
  [6268] = 6103,
  [6269] = 6047,
  [6270] = 6052,
  [6271] = 6053,
  [6272] = 6047,
  [6273] = 6143,
  [6274] = 6051,
  [6275] = 6051,
  [6276] = 6082,
  [6277] = 6046,
  [6278] = 6083,
  [6279] = 6051,
  [6280] = 6046,
  [6281] = 6049,
  [6282] = 6100,
  [6283] = 6100,
  [6284] = 6051,
  [6285] = 6055,
  [6286] = 6100,
  [6287] = 6143,
  [6288] = 6046,
  [6289] = 6150,
  [6290] = 6290,
  [6291] = 6100,
  [6292] = 6083,
  [6293] = 6100,
  [6294] = 6143,
  [6295] = 6103,
  [6296] = 6082,
  [6297] = 6100,
  [6298] = 6082,
  [6299] = 6100,
  [6300] = 6083,
  [6301] = 6047,
  [6302] = 6055,
  [6303] = 6046,
  [6304] = 6100,
  [6305] = 6100,
  [6306] = 6125,
  [6307] = 6103,
  [6308] = 6100,
  [6309] = 6054,
  [6310] = 6125,
  [6311] = 6055,
  [6312] = 6054,
  [6313] = 6051,
  [6314] = 6046,
  [6315] = 6100,
  [6316] = 6125,
  [6317] = 6111,
  [6318] = 6100,
  [6319] = 6047,
  [6320] = 6046,
  [6321] = 6125,
  [6322] = 6111,
  [6323] = 6048,
  [6324] = 6082,
  [6325] = 6083,
  [6326] = 6046,
  [6327] = 6100,
  [6328] = 6045,
  [6329] = 6046,
  [6330] = 6046,
  [6331] = 6150,
  [6332] = 6055,
  [6333] = 6125,
  [6334] = 6046,
  [6335] = 6111,
  [6336] = 6110,
  [6337] = 6048,
  [6338] = 6051,
  [6339] = 6046,
  [6340] = 6100,
  [6341] = 6048,
  [6342] = 6045,
  [6343] = 6046,
  [6344] = 6125,
  [6345] = 6111,
  [6346] = 6110,
  [6347] = 6055,
  [6348] = 6054,
  [6349] = 6052,
  [6350] = 6150,
  [6351] = 6049,
  [6352] = 6049,
  [6353] = 6055,
  [6354] = 6354,
  [6355] = 6103,
  [6356] = 6100,
  [6357] = 6045,
  [6358] = 6125,
  [6359] = 6143,
  [6360] = 6047,
  [6361] = 6100,
  [6362] = 6111,
  [6363] = 6290,
  [6364] = 6110,
  [6365] = 6055,
  [6366] = 6290,
  [6367] = 6048,
  [6368] = 6143,
  [6369] = 6103,
  [6370] = 6100,
  [6371] = 6143,
  [6372] = 6045,
  [6373] = 6051,
  [6374] = 6103,
  [6375] = 6125,
  [6376] = 6046,
  [6377] = 6290,
  [6378] = 6046,
  [6379] = 6111,
  [6380] = 6047,
  [6381] = 6052,
  [6382] = 6082,
  [6383] = 6083,
  [6384] = 6110,
  [6385] = 6054,
  [6386] = 6049,
  [6387] = 6290,
  [6388] = 6100,
  [6389] = 6048,
  [6390] = 6290,
  [6391] = 6049,
  [6392] = 6150,
  [6393] = 6290,
  [6394] = 6049,
  [6395] = 6083,
  [6396] = 6083,
  [6397] = 6100,
  [6398] = 6045,
  [6399] = 6082,
  [6400] = 6125,
  [6401] = 6111,
  [6402] = 6110,
  [6403] = 6048,
  [6404] = 6083,
  [6405] = 6082,
  [6406] = 6100,
  [6407] = 6045,
  [6408] = 6125,
  [6409] = 6051,
  [6410] = 6111,
  [6411] = 6110,
  [6412] = 6054,
  [6413] = 6082,
  [6414] = 6150,
  [6415] = 6046,
  [6416] = 6416,
  [6417] = 6100,
  [6418] = 6418,
  [6419] = 6047,
  [6420] = 6046,
  [6421] = 6045,
  [6422] = 6051,
  [6423] = 6125,
  [6424] = 6046,
  [6425] = 6111,
  [6426] = 6110,
  [6427] = 6051,
  [6428] = 6143,
  [6429] = 6110,
  [6430] = 6111,
  [6431] = 6100,
  [6432] = 6055,
  [6433] = 6045,
  [6434] = 6052,
  [6435] = 6125,
  [6436] = 6045,
  [6437] = 6103,
  [6438] = 6125,
  [6439] = 6052,
  [6440] = 6100,
  [6441] = 6143,
  [6442] = 6103,
  [6443] = 6045,
  [6444] = 6111,
  [6445] = 6111,
  [6446] = 6110,
  [6447] = 6110,
  [6448] = 6100,
  [6449] = 6111,
  [6450] = 6047,
  [6451] = 6052,
  [6452] = 6100,
  [6453] = 6100,
  [6454] = 6170,
  [6455] = 6150,
  [6456] = 6150,
  [6457] = 6046,
  [6458] = 6458,
  [6459] = 6125,
  [6460] = 6110,
  [6461] = 6045,
  [6462] = 6462,
  [6463] = 6463,
  [6464] = 6464,
  [6465] = 6465,
  [6466] = 6466,
  [6467] = 6467,
  [6468] = 6468,
  [6469] = 6469,
  [6470] = 6469,
  [6471] = 6468,
  [6472] = 6472,
  [6473] = 6468,
  [6474] = 6469,
  [6475] = 6468,
  [6476] = 6468,
  [6477] = 6469,
  [6478] = 6468,
  [6479] = 6468,
  [6480] = 6469,
  [6481] = 6468,
  [6482] = 6469,
  [6483] = 6468,
  [6484] = 6468,
  [6485] = 6469,
  [6486] = 6486,
  [6487] = 6468,
  [6488] = 6488,
  [6489] = 6468,
  [6490] = 6468,
  [6491] = 6491,
  [6492] = 6491,
  [6493] = 6493,
  [6494] = 6494,
  [6495] = 570,
  [6496] = 631,
  [6497] = 570,
  [6498] = 570,
  [6499] = 608,
  [6500] = 608,
  [6501] = 6501,
  [6502] = 608,
  [6503] = 604,
  [6504] = 631,
  [6505] = 6505,
  [6506] = 6506,
  [6507] = 570,
  [6508] = 6508,
  [6509] = 534,
  [6510] = 620,
  [6511] = 603,
  [6512] = 597,
  [6513] = 620,
  [6514] = 6506,
  [6515] = 6506,
  [6516] = 6505,
  [6517] = 604,
  [6518] = 606,
  [6519] = 6506,
  [6520] = 6506,
  [6521] = 606,
  [6522] = 6508,
  [6523] = 534,
  [6524] = 595,
  [6525] = 603,
  [6526] = 597,
  [6527] = 6505,
  [6528] = 597,
  [6529] = 596,
  [6530] = 595,
  [6531] = 606,
  [6532] = 6532,
  [6533] = 6508,
  [6534] = 604,
  [6535] = 620,
  [6536] = 559,
  [6537] = 6505,
  [6538] = 534,
  [6539] = 603,
  [6540] = 559,
  [6541] = 570,
  [6542] = 6506,
  [6543] = 608,
  [6544] = 596,
  [6545] = 595,
  [6546] = 559,
  [6547] = 608,
  [6548] = 6508,
  [6549] = 6508,
  [6550] = 6505,
  [6551] = 6508,
  [6552] = 6505,
  [6553] = 596,
  [6554] = 604,
  [6555] = 559,
  [6556] = 559,
  [6557] = 620,
  [6558] = 534,
  [6559] = 620,
  [6560] = 595,
  [6561] = 596,
  [6562] = 534,
  [6563] = 597,
  [6564] = 709,
  [6565] = 631,
  [6566] = 595,
  [6567] = 597,
  [6568] = 6568,
  [6569] = 597,
  [6570] = 606,
  [6571] = 603,
  [6572] = 606,
  [6573] = 699,
  [6574] = 606,
  [6575] = 570,
  [6576] = 608,
  [6577] = 534,
  [6578] = 604,
  [6579] = 596,
  [6580] = 603,
  [6581] = 709,
  [6582] = 699,
  [6583] = 984,
  [6584] = 1029,
  [6585] = 699,
  [6586] = 596,
  [6587] = 570,
  [6588] = 1019,
  [6589] = 1020,
  [6590] = 1019,
  [6591] = 989,
  [6592] = 984,
  [6593] = 1013,
  [6594] = 1029,
  [6595] = 1013,
  [6596] = 534,
  [6597] = 709,
  [6598] = 620,
  [6599] = 606,
  [6600] = 1020,
  [6601] = 604,
  [6602] = 989,
  [6603] = 597,
  [6604] = 603,
  [6605] = 608,
  [6606] = 559,
  [6607] = 595,
  [6608] = 608,
  [6609] = 620,
  [6610] = 595,
  [6611] = 596,
  [6612] = 603,
  [6613] = 604,
  [6614] = 984,
  [6615] = 6615,
  [6616] = 1020,
  [6617] = 989,
  [6618] = 1029,
  [6619] = 6619,
  [6620] = 1013,
  [6621] = 570,
  [6622] = 631,
  [6623] = 1019,
  [6624] = 6624,
  [6625] = 559,
  [6626] = 608,
  [6627] = 6627,
  [6628] = 6627,
  [6629] = 6627,
  [6630] = 6627,
  [6631] = 6627,
  [6632] = 570,
  [6633] = 559,
  [6634] = 595,
  [6635] = 6627,
  [6636] = 596,
  [6637] = 6627,
  [6638] = 597,
  [6639] = 6627,
  [6640] = 6627,
  [6641] = 6627,
  [6642] = 6627,
  [6643] = 570,
  [6644] = 603,
  [6645] = 6627,
  [6646] = 604,
  [6647] = 570,
  [6648] = 6627,
  [6649] = 6627,
  [6650] = 6627,
  [6651] = 6627,
  [6652] = 6627,
  [6653] = 608,
  [6654] = 570,
  [6655] = 6627,
  [6656] = 6627,
  [6657] = 631,
  [6658] = 6627,
  [6659] = 6627,
  [6660] = 6627,
  [6661] = 6627,
  [6662] = 6662,
  [6663] = 608,
  [6664] = 6664,
  [6665] = 631,
  [6666] = 6627,
  [6667] = 6667,
  [6668] = 534,
  [6669] = 6627,
  [6670] = 608,
  [6671] = 6627,
  [6672] = 6627,
  [6673] = 620,
  [6674] = 6627,
  [6675] = 570,
  [6676] = 606,
  [6677] = 608,
  [6678] = 6627,
  [6679] = 6627,
  [6680] = 6627,
  [6681] = 620,
  [6682] = 596,
  [6683] = 603,
  [6684] = 608,
  [6685] = 559,
  [6686] = 534,
  [6687] = 6687,
  [6688] = 603,
  [6689] = 699,
  [6690] = 559,
  [6691] = 534,
  [6692] = 606,
  [6693] = 595,
  [6694] = 534,
  [6695] = 604,
  [6696] = 606,
  [6697] = 620,
  [6698] = 604,
  [6699] = 570,
  [6700] = 596,
  [6701] = 620,
  [6702] = 603,
  [6703] = 606,
  [6704] = 559,
  [6705] = 597,
  [6706] = 604,
  [6707] = 597,
  [6708] = 596,
  [6709] = 604,
  [6710] = 595,
  [6711] = 6711,
  [6712] = 597,
  [6713] = 6713,
  [6714] = 606,
  [6715] = 595,
  [6716] = 596,
  [6717] = 597,
  [6718] = 559,
  [6719] = 603,
  [6720] = 620,
  [6721] = 709,
  [6722] = 620,
  [6723] = 604,
  [6724] = 603,
  [6725] = 596,
  [6726] = 595,
  [6727] = 6727,
  [6728] = 559,
  [6729] = 534,
  [6730] = 595,
  [6731] = 534,
  [6732] = 606,
  [6733] = 597,
  [6734] = 559,
  [6735] = 1029,
  [6736] = 1020,
  [6737] = 989,
  [6738] = 699,
  [6739] = 1029,
  [6740] = 984,
  [6741] = 1020,
  [6742] = 1019,
  [6743] = 595,
  [6744] = 596,
  [6745] = 1019,
  [6746] = 597,
  [6747] = 709,
  [6748] = 603,
  [6749] = 604,
  [6750] = 606,
  [6751] = 699,
  [6752] = 1013,
  [6753] = 1013,
  [6754] = 620,
  [6755] = 534,
  [6756] = 989,
  [6757] = 709,
  [6758] = 1019,
  [6759] = 984,
  [6760] = 6760,
  [6761] = 6761,
  [6762] = 1029,
  [6763] = 989,
  [6764] = 1019,
  [6765] = 1020,
  [6766] = 1019,
  [6767] = 6767,
  [6768] = 1029,
  [6769] = 6769,
  [6770] = 989,
  [6771] = 1019,
  [6772] = 1013,
  [6773] = 6773,
  [6774] = 1020,
  [6775] = 6775,
  [6776] = 1020,
  [6777] = 984,
  [6778] = 6778,
  [6779] = 6779,
  [6780] = 6780,
  [6781] = 6781,
  [6782] = 691,
  [6783] = 1029,
  [6784] = 688,
  [6785] = 1013,
  [6786] = 989,
  [6787] = 703,
  [6788] = 678,
  [6789] = 6789,
  [6790] = 6790,
  [6791] = 1020,
  [6792] = 1029,
  [6793] = 989,
  [6794] = 1013,
  [6795] = 1013,
  [6796] = 681,
  [6797] = 696,
  [6798] = 677,
  [6799] = 6799,
  [6800] = 6800,
  [6801] = 6801,
  [6802] = 6802,
  [6803] = 6803,
  [6804] = 6804,
  [6805] = 6805,
  [6806] = 6806,
  [6807] = 6807,
  [6808] = 6808,
  [6809] = 701,
  [6810] = 6810,
  [6811] = 6811,
  [6812] = 6812,
  [6813] = 983,
  [6814] = 6814,
  [6815] = 6815,
  [6816] = 6816,
  [6817] = 6817,
  [6818] = 6818,
  [6819] = 6819,
  [6820] = 6820,
  [6821] = 679,
  [6822] = 6822,
  [6823] = 6823,
  [6824] = 698,
  [6825] = 6825,
  [6826] = 6826,
  [6827] = 6827,
  [6828] = 854,
  [6829] = 693,
  [6830] = 848,
  [6831] = 889,
  [6832] = 6832,
  [6833] = 6833,
  [6834] = 6834,
  [6835] = 6835,
  [6836] = 6836,
  [6837] = 6837,
  [6838] = 6838,
  [6839] = 687,
  [6840] = 6840,
  [6841] = 6841,
  [6842] = 6842,
  [6843] = 6843,
  [6844] = 705,
  [6845] = 6845,
  [6846] = 860,
  [6847] = 6847,
  [6848] = 6848,
  [6849] = 6849,
  [6850] = 6850,
  [6851] = 6823,
  [6852] = 6803,
  [6853] = 6845,
  [6854] = 6805,
  [6855] = 6855,
  [6856] = 6837,
  [6857] = 6857,
  [6858] = 664,
  [6859] = 6859,
  [6860] = 617,
  [6861] = 6861,
  [6862] = 6862,
  [6863] = 6799,
  [6864] = 6864,
  [6865] = 6833,
  [6866] = 6866,
  [6867] = 6819,
  [6868] = 671,
  [6869] = 6869,
  [6870] = 6826,
  [6871] = 6871,
  [6872] = 6872,
  [6873] = 659,
  [6874] = 6491,
  [6875] = 6800,
  [6876] = 6801,
  [6877] = 6814,
  [6878] = 6815,
  [6879] = 6879,
  [6880] = 6880,
  [6881] = 6881,
  [6882] = 6882,
  [6883] = 6883,
  [6884] = 6884,
  [6885] = 6825,
  [6886] = 6886,
  [6887] = 6806,
  [6888] = 6822,
  [6889] = 6807,
  [6890] = 6890,
  [6891] = 6810,
  [6892] = 6892,
  [6893] = 6893,
  [6894] = 6894,
  [6895] = 669,
  [6896] = 6896,
  [6897] = 6897,
  [6898] = 675,
  [6899] = 6811,
  [6900] = 6900,
  [6901] = 6804,
  [6902] = 6817,
  [6903] = 6903,
  [6904] = 6836,
  [6905] = 6905,
  [6906] = 6906,
  [6907] = 6907,
  [6908] = 6908,
  [6909] = 6909,
  [6910] = 6910,
  [6911] = 1029,
  [6912] = 6912,
  [6913] = 1020,
  [6914] = 1019,
  [6915] = 6773,
  [6916] = 6916,
  [6917] = 6917,
  [6918] = 6918,
  [6919] = 6919,
  [6920] = 6920,
  [6921] = 672,
  [6922] = 6922,
  [6923] = 1013,
  [6924] = 6760,
  [6925] = 989,
  [6926] = 6926,
  [6927] = 6491,
  [6928] = 6928,
  [6929] = 6929,
  [6930] = 6930,
  [6931] = 6931,
  [6932] = 987,
  [6933] = 1037,
  [6934] = 6934,
  [6935] = 1033,
  [6936] = 988,
  [6937] = 6937,
  [6938] = 6938,
  [6939] = 860,
  [6940] = 1029,
  [6941] = 6941,
  [6942] = 6942,
  [6943] = 6943,
  [6944] = 6944,
  [6945] = 983,
  [6946] = 6946,
  [6947] = 6947,
  [6948] = 6948,
  [6949] = 6949,
  [6950] = 6950,
  [6951] = 6951,
  [6952] = 6952,
  [6953] = 6951,
  [6954] = 6954,
  [6955] = 6955,
  [6956] = 6956,
  [6957] = 6957,
  [6958] = 1045,
  [6959] = 966,
  [6960] = 6960,
  [6961] = 6961,
  [6962] = 999,
  [6963] = 990,
  [6964] = 1044,
  [6965] = 6965,
  [6966] = 6966,
  [6967] = 6967,
  [6968] = 6949,
  [6969] = 6969,
  [6970] = 6949,
  [6971] = 6971,
  [6972] = 928,
  [6973] = 6973,
  [6974] = 6974,
  [6975] = 938,
  [6976] = 6949,
  [6977] = 1048,
  [6978] = 6978,
  [6979] = 6979,
  [6980] = 1055,
  [6981] = 1003,
  [6982] = 6951,
  [6983] = 715,
  [6984] = 6949,
  [6985] = 6985,
  [6986] = 6986,
  [6987] = 6987,
  [6988] = 6988,
  [6989] = 6989,
  [6990] = 6951,
  [6991] = 6991,
  [6992] = 6992,
  [6993] = 6993,
  [6994] = 6994,
  [6995] = 6995,
  [6996] = 6996,
  [6997] = 6997,
  [6998] = 6998,
  [6999] = 6999,
  [7000] = 7000,
  [7001] = 7001,
  [7002] = 7002,
  [7003] = 7003,
  [7004] = 948,
  [7005] = 949,
  [7006] = 7006,
  [7007] = 7007,
  [7008] = 7008,
  [7009] = 967,
  [7010] = 7010,
  [7011] = 7011,
  [7012] = 968,
  [7013] = 7013,
  [7014] = 7014,
  [7015] = 969,
  [7016] = 6951,
  [7017] = 7017,
  [7018] = 7018,
  [7019] = 7019,
  [7020] = 978,
  [7021] = 7021,
  [7022] = 7022,
  [7023] = 7023,
  [7024] = 7024,
  [7025] = 7025,
  [7026] = 7026,
  [7027] = 7027,
  [7028] = 7028,
  [7029] = 7029,
  [7030] = 6949,
  [7031] = 7031,
  [7032] = 979,
  [7033] = 7033,
  [7034] = 7034,
  [7035] = 980,
  [7036] = 7036,
  [7037] = 7037,
  [7038] = 7038,
  [7039] = 7039,
  [7040] = 6949,
  [7041] = 6951,
  [7042] = 7042,
  [7043] = 982,
  [7044] = 6491,
  [7045] = 7045,
  [7046] = 7046,
  [7047] = 983,
  [7048] = 1013,
  [7049] = 854,
  [7050] = 7050,
  [7051] = 7051,
  [7052] = 989,
  [7053] = 860,
  [7054] = 6949,
  [7055] = 7055,
  [7056] = 7056,
  [7057] = 7057,
  [7058] = 7058,
  [7059] = 7059,
  [7060] = 7060,
  [7061] = 7061,
  [7062] = 6949,
  [7063] = 7063,
  [7064] = 1062,
  [7065] = 6951,
  [7066] = 1072,
  [7067] = 7067,
  [7068] = 889,
  [7069] = 989,
  [7070] = 7070,
  [7071] = 7071,
  [7072] = 7072,
  [7073] = 7073,
  [7074] = 7074,
  [7075] = 7075,
  [7076] = 7076,
  [7077] = 993,
  [7078] = 6949,
  [7079] = 6949,
  [7080] = 7080,
  [7081] = 848,
  [7082] = 7082,
  [7083] = 7083,
  [7084] = 994,
  [7085] = 7085,
  [7086] = 7086,
  [7087] = 6951,
  [7088] = 7088,
  [7089] = 7089,
  [7090] = 995,
  [7091] = 1001,
  [7092] = 6951,
  [7093] = 7093,
  [7094] = 1064,
  [7095] = 7095,
  [7096] = 6951,
  [7097] = 7097,
  [7098] = 7098,
  [7099] = 7099,
  [7100] = 7100,
  [7101] = 7101,
  [7102] = 7102,
  [7103] = 1007,
  [7104] = 7104,
  [7105] = 7105,
  [7106] = 1012,
  [7107] = 7107,
  [7108] = 7108,
  [7109] = 7109,
  [7110] = 7110,
  [7111] = 7111,
  [7112] = 7112,
  [7113] = 7113,
  [7114] = 7114,
  [7115] = 1065,
  [7116] = 7116,
  [7117] = 7117,
  [7118] = 7118,
  [7119] = 1036,
  [7120] = 6951,
  [7121] = 7121,
  [7122] = 1013,
  [7123] = 7123,
  [7124] = 1076,
  [7125] = 7125,
  [7126] = 7126,
  [7127] = 7127,
  [7128] = 7128,
  [7129] = 7129,
  [7130] = 6951,
  [7131] = 7131,
  [7132] = 7132,
  [7133] = 7133,
  [7134] = 7134,
  [7135] = 1014,
  [7136] = 6951,
  [7137] = 7137,
  [7138] = 7138,
  [7139] = 7139,
  [7140] = 7140,
  [7141] = 7141,
  [7142] = 7142,
  [7143] = 7143,
  [7144] = 7144,
  [7145] = 7145,
  [7146] = 6949,
  [7147] = 7147,
  [7148] = 7148,
  [7149] = 7149,
  [7150] = 7150,
  [7151] = 7151,
  [7152] = 1075,
  [7153] = 6949,
  [7154] = 7154,
  [7155] = 7155,
  [7156] = 7156,
  [7157] = 7157,
  [7158] = 7158,
  [7159] = 7159,
  [7160] = 7160,
  [7161] = 7161,
  [7162] = 7162,
  [7163] = 6951,
  [7164] = 1032,
  [7165] = 7165,
  [7166] = 7166,
  [7167] = 7167,
  [7168] = 6949,
  [7169] = 848,
  [7170] = 7170,
  [7171] = 7171,
  [7172] = 7172,
  [7173] = 7173,
  [7174] = 7174,
  [7175] = 7175,
  [7176] = 7176,
  [7177] = 6949,
  [7178] = 7178,
  [7179] = 854,
  [7180] = 7180,
  [7181] = 7181,
  [7182] = 7182,
  [7183] = 6949,
  [7184] = 7184,
  [7185] = 7185,
  [7186] = 6951,
  [7187] = 7187,
  [7188] = 7188,
  [7189] = 1019,
  [7190] = 1020,
  [7191] = 6951,
  [7192] = 7192,
  [7193] = 7193,
  [7194] = 6949,
  [7195] = 7195,
  [7196] = 1029,
  [7197] = 7197,
  [7198] = 7198,
  [7199] = 1020,
  [7200] = 1019,
  [7201] = 1021,
  [7202] = 7202,
  [7203] = 7203,
  [7204] = 7204,
  [7205] = 7205,
  [7206] = 7206,
  [7207] = 6951,
  [7208] = 7208,
  [7209] = 7209,
  [7210] = 7210,
  [7211] = 7211,
  [7212] = 7212,
  [7213] = 7213,
  [7214] = 7211,
  [7215] = 7211,
  [7216] = 7216,
  [7217] = 1019,
  [7218] = 1020,
  [7219] = 1029,
  [7220] = 7220,
  [7221] = 999,
  [7222] = 7222,
  [7223] = 7211,
  [7224] = 6781,
  [7225] = 7225,
  [7226] = 889,
  [7227] = 7227,
  [7228] = 7228,
  [7229] = 7229,
  [7230] = 7230,
  [7231] = 7209,
  [7232] = 7229,
  [7233] = 928,
  [7234] = 7234,
  [7235] = 7230,
  [7236] = 7236,
  [7237] = 7237,
  [7238] = 7238,
  [7239] = 7229,
  [7240] = 7209,
  [7241] = 7238,
  [7242] = 7237,
  [7243] = 7209,
  [7244] = 7244,
  [7245] = 7238,
  [7246] = 7230,
  [7247] = 6790,
  [7248] = 7216,
  [7249] = 7237,
  [7250] = 7250,
  [7251] = 6869,
  [7252] = 7230,
  [7253] = 7209,
  [7254] = 7209,
  [7255] = 7229,
  [7256] = 7238,
  [7257] = 7211,
  [7258] = 989,
  [7259] = 1013,
  [7260] = 7216,
  [7261] = 7237,
  [7262] = 7211,
  [7263] = 938,
  [7264] = 7264,
  [7265] = 6769,
  [7266] = 7266,
  [7267] = 7229,
  [7268] = 7230,
  [7269] = 7269,
  [7270] = 7270,
  [7271] = 7271,
  [7272] = 7272,
  [7273] = 7273,
  [7274] = 7274,
  [7275] = 7238,
  [7276] = 7276,
  [7277] = 7209,
  [7278] = 7229,
  [7279] = 7279,
  [7280] = 7280,
  [7281] = 7281,
  [7282] = 7238,
  [7283] = 7211,
  [7284] = 7211,
  [7285] = 7229,
  [7286] = 7230,
  [7287] = 7237,
  [7288] = 7238,
  [7289] = 7289,
  [7290] = 7237,
  [7291] = 7209,
  [7292] = 7292,
  [7293] = 7209,
  [7294] = 7209,
  [7295] = 7216,
  [7296] = 7237,
  [7297] = 7209,
  [7298] = 7209,
  [7299] = 6775,
  [7300] = 7237,
  [7301] = 7230,
  [7302] = 7237,
  [7303] = 7229,
  [7304] = 7229,
  [7305] = 7305,
  [7306] = 7306,
  [7307] = 7307,
  [7308] = 7211,
  [7309] = 7209,
  [7310] = 7310,
  [7311] = 6760,
  [7312] = 7312,
  [7313] = 7313,
  [7314] = 7230,
  [7315] = 984,
  [7316] = 7238,
  [7317] = 7237,
  [7318] = 7318,
  [7319] = 7238,
  [7320] = 7211,
  [7321] = 7321,
  [7322] = 7216,
  [7323] = 7229,
  [7324] = 988,
  [7325] = 7230,
  [7326] = 7230,
  [7327] = 7230,
  [7328] = 7209,
  [7329] = 7237,
  [7330] = 727,
  [7331] = 7238,
  [7332] = 7238,
  [7333] = 7237,
  [7334] = 7229,
  [7335] = 7335,
  [7336] = 7238,
  [7337] = 7337,
  [7338] = 7237,
  [7339] = 7230,
  [7340] = 7229,
  [7341] = 7341,
  [7342] = 7230,
  [7343] = 7229,
  [7344] = 7238,
  [7345] = 7238,
  [7346] = 7211,
  [7347] = 7237,
  [7348] = 7237,
  [7349] = 7211,
  [7350] = 7230,
  [7351] = 7229,
  [7352] = 7238,
  [7353] = 7230,
  [7354] = 7229,
  [7355] = 7216,
  [7356] = 7209,
  [7357] = 7209,
  [7358] = 7237,
  [7359] = 7211,
  [7360] = 7209,
  [7361] = 7361,
  [7362] = 7238,
  [7363] = 7216,
  [7364] = 7211,
  [7365] = 7230,
  [7366] = 7229,
  [7367] = 7367,
  [7368] = 7368,
  [7369] = 7216,
  [7370] = 7237,
  [7371] = 7230,
  [7372] = 7372,
  [7373] = 7373,
  [7374] = 6773,
  [7375] = 7216,
  [7376] = 7229,
  [7377] = 7216,
  [7378] = 7211,
  [7379] = 7211,
  [7380] = 7238,
  [7381] = 7381,
  [7382] = 7216,
  [7383] = 7211,
  [7384] = 7384,
  [7385] = 7385,
  [7386] = 7386,
  [7387] = 7387,
  [7388] = 7388,
  [7389] = 7389,
  [7390] = 7384,
  [7391] = 7388,
  [7392] = 7392,
  [7393] = 7393,
  [7394] = 7394,
  [7395] = 7395,
  [7396] = 7396,
  [7397] = 7386,
  [7398] = 7387,
  [7399] = 7392,
  [7400] = 7395,
  [7401] = 7394,
  [7402] = 7402,
  [7403] = 7387,
  [7404] = 7394,
  [7405] = 7386,
  [7406] = 7384,
  [7407] = 7395,
  [7408] = 7395,
  [7409] = 7409,
  [7410] = 7384,
  [7411] = 7411,
  [7412] = 7394,
  [7413] = 7387,
  [7414] = 7386,
  [7415] = 7392,
  [7416] = 7416,
  [7417] = 7386,
  [7418] = 7418,
  [7419] = 7387,
  [7420] = 7409,
  [7421] = 7387,
  [7422] = 7394,
  [7423] = 7386,
  [7424] = 7424,
  [7425] = 7387,
  [7426] = 7395,
  [7427] = 7386,
  [7428] = 7396,
  [7429] = 7386,
  [7430] = 7396,
  [7431] = 7409,
  [7432] = 7384,
  [7433] = 7433,
  [7434] = 7395,
  [7435] = 7435,
  [7436] = 7387,
  [7437] = 7437,
  [7438] = 7424,
  [7439] = 7439,
  [7440] = 7384,
  [7441] = 7441,
  [7442] = 6907,
  [7443] = 7388,
  [7444] = 7395,
  [7445] = 7388,
  [7446] = 7446,
  [7447] = 7394,
  [7448] = 7409,
  [7449] = 7395,
  [7450] = 7395,
  [7451] = 7394,
  [7452] = 7394,
  [7453] = 7453,
  [7454] = 7388,
  [7455] = 7455,
  [7456] = 7456,
  [7457] = 7384,
  [7458] = 7441,
  [7459] = 6903,
  [7460] = 7460,
  [7461] = 7461,
  [7462] = 7392,
  [7463] = 7387,
  [7464] = 7386,
  [7465] = 7388,
  [7466] = 7466,
  [7467] = 7394,
  [7468] = 7384,
  [7469] = 7395,
  [7470] = 7470,
  [7471] = 7394,
  [7472] = 7472,
  [7473] = 7392,
  [7474] = 7384,
  [7475] = 7461,
  [7476] = 7409,
  [7477] = 7384,
  [7478] = 7478,
  [7479] = 7479,
  [7480] = 7480,
  [7481] = 6491,
  [7482] = 7482,
  [7483] = 7392,
  [7484] = 7484,
  [7485] = 7387,
  [7486] = 7386,
  [7487] = 7392,
  [7488] = 7488,
  [7489] = 7424,
  [7490] = 7392,
  [7491] = 7394,
  [7492] = 7395,
  [7493] = 7493,
  [7494] = 7494,
  [7495] = 7395,
  [7496] = 7384,
  [7497] = 7497,
  [7498] = 7498,
  [7499] = 7499,
  [7500] = 7387,
  [7501] = 7386,
  [7502] = 7384,
  [7503] = 7394,
  [7504] = 7388,
  [7505] = 7396,
  [7506] = 7506,
  [7507] = 7394,
  [7508] = 7508,
  [7509] = 7509,
  [7510] = 7510,
  [7511] = 7395,
  [7512] = 7512,
  [7513] = 7424,
  [7514] = 7396,
  [7515] = 7515,
  [7516] = 7409,
  [7517] = 7517,
  [7518] = 7409,
  [7519] = 7519,
  [7520] = 7484,
  [7521] = 7461,
  [7522] = 7409,
  [7523] = 7388,
  [7524] = 7409,
  [7525] = 7384,
  [7526] = 7392,
  [7527] = 7384,
  [7528] = 7461,
  [7529] = 7387,
  [7530] = 7387,
  [7531] = 7386,
  [7532] = 7384,
  [7533] = 7533,
  [7534] = 7386,
  [7535] = 7535,
  [7536] = 7536,
  [7537] = 7394,
  [7538] = 7395,
  [7539] = 7539,
  [7540] = 7388,
  [7541] = 7388,
  [7542] = 7387,
  [7543] = 7461,
  [7544] = 7392,
  [7545] = 7386,
  [7546] = 7519,
  [7547] = 7424,
  [7548] = 7409,
  [7549] = 7395,
  [7550] = 7392,
  [7551] = 7551,
  [7552] = 7394,
  [7553] = 7396,
  [7554] = 7394,
  [7555] = 7395,
  [7556] = 7424,
  [7557] = 7392,
  [7558] = 7558,
  [7559] = 7409,
  [7560] = 7394,
  [7561] = 7395,
  [7562] = 7562,
  [7563] = 7392,
  [7564] = 7564,
  [7565] = 7565,
  [7566] = 7566,
  [7567] = 7384,
  [7568] = 7384,
  [7569] = 7384,
  [7570] = 7570,
  [7571] = 7388,
  [7572] = 7387,
  [7573] = 7493,
  [7574] = 7574,
  [7575] = 7575,
  [7576] = 7386,
  [7577] = 7577,
  [7578] = 7388,
  [7579] = 7461,
  [7580] = 7580,
  [7581] = 7387,
  [7582] = 7409,
  [7583] = 7461,
  [7584] = 7387,
  [7585] = 7409,
  [7586] = 7586,
  [7587] = 7386,
  [7588] = 7588,
  [7589] = 7388,
  [7590] = 7590,
  [7591] = 7386,
  [7592] = 7480,
  [7593] = 7593,
  [7594] = 7594,
  [7595] = 7595,
  [7596] = 7596,
  [7597] = 7597,
  [7598] = 7598,
  [7599] = 7599,
  [7600] = 7600,
  [7601] = 7601,
  [7602] = 7602,
  [7603] = 7603,
  [7604] = 7604,
  [7605] = 7605,
  [7606] = 7606,
  [7607] = 7604,
  [7608] = 7608,
  [7609] = 7609,
  [7610] = 7610,
  [7611] = 7611,
  [7612] = 7612,
  [7613] = 7613,
  [7614] = 7614,
  [7615] = 7615,
  [7616] = 7616,
  [7617] = 7617,
  [7618] = 7618,
  [7619] = 7619,
  [7620] = 7620,
  [7621] = 7621,
  [7622] = 7622,
  [7623] = 7623,
  [7624] = 7624,
  [7625] = 7625,
  [7626] = 7626,
  [7627] = 7599,
  [7628] = 7628,
  [7629] = 7618,
  [7630] = 7616,
  [7631] = 7620,
  [7632] = 7632,
  [7633] = 7604,
  [7634] = 7619,
  [7635] = 7608,
  [7636] = 7609,
  [7637] = 7613,
  [7638] = 7600,
  [7639] = 7611,
  [7640] = 7614,
  [7641] = 7615,
  [7642] = 7601,
  [7643] = 7610,
  [7644] = 7610,
  [7645] = 7602,
  [7646] = 7646,
  [7647] = 7604,
  [7648] = 7599,
  [7649] = 7625,
  [7650] = 7650,
  [7651] = 7614,
  [7652] = 7652,
  [7653] = 7653,
  [7654] = 7653,
  [7655] = 7599,
  [7656] = 7653,
  [7657] = 7657,
  [7658] = 7658,
  [7659] = 7625,
  [7660] = 7626,
  [7661] = 7653,
  [7662] = 7615,
  [7663] = 7663,
  [7664] = 7653,
  [7665] = 7595,
  [7666] = 7653,
  [7667] = 7609,
  [7668] = 7653,
  [7669] = 7608,
  [7670] = 7623,
  [7671] = 7653,
  [7672] = 7616,
  [7673] = 7663,
  [7674] = 7653,
  [7675] = 7608,
  [7676] = 7609,
  [7677] = 7653,
  [7678] = 7621,
  [7679] = 7653,
  [7680] = 7618,
  [7681] = 7621,
  [7682] = 7653,
  [7683] = 7620,
  [7684] = 7684,
  [7685] = 7615,
  [7686] = 7619,
  [7687] = 7613,
  [7688] = 7595,
  [7689] = 7605,
  [7690] = 7653,
  [7691] = 7628,
  [7692] = 7653,
  [7693] = 7597,
  [7694] = 7603,
  [7695] = 7653,
  [7696] = 7597,
  [7697] = 7628,
  [7698] = 7698,
  [7699] = 7653,
  [7700] = 7594,
  [7701] = 7652,
  [7702] = 7702,
  [7703] = 7646,
  [7704] = 7704,
  [7705] = 7625,
  [7706] = 7626,
  [7707] = 7611,
  [7708] = 7602,
  [7709] = 7709,
  [7710] = 7646,
  [7711] = 7711,
  [7712] = 7658,
  [7713] = 7605,
  [7714] = 7714,
  [7715] = 7626,
  [7716] = 7625,
  [7717] = 7600,
  [7718] = 7718,
  [7719] = 7663,
  [7720] = 7608,
  [7721] = 7609,
  [7722] = 7601,
  [7723] = 7657,
  [7724] = 7724,
  [7725] = 7725,
  [7726] = 7726,
  [7727] = 7727,
  [7728] = 7603,
  [7729] = 7729,
  [7730] = 7615,
  [7731] = 7652,
  [7732] = 7652,
  [7733] = 7595,
  [7734] = 7734,
  [7735] = 7735,
  [7736] = 7652,
  [7737] = 7615,
  [7738] = 7698,
  [7739] = 7596,
  [7740] = 7698,
  [7741] = 7741,
  [7742] = 7594,
  [7743] = 7743,
  [7744] = 7623,
  [7745] = 7609,
  [7746] = 7608,
  [7747] = 7709,
  [7748] = 7610,
  [7749] = 7614,
  [7750] = 7646,
  [7751] = 7751,
  [7752] = 7752,
  [7753] = 7743,
  [7754] = 7754,
  [7755] = 7755,
  [7756] = 7756,
  [7757] = 7698,
  [7758] = 7758,
  [7759] = 7752,
  [7760] = 7760,
  [7761] = 7596,
  [7762] = 7608,
  [7763] = 7609,
  [7764] = 7741,
  [7765] = 7758,
  [7766] = 7766,
  [7767] = 7597,
  [7768] = 7760,
  [7769] = 7597,
  [7770] = 7663,
  [7771] = 7771,
  [7772] = 7615,
  [7773] = 7773,
  [7774] = 7601,
  [7775] = 7775,
  [7776] = 7776,
  [7777] = 7597,
  [7778] = 7778,
  [7779] = 7779,
  [7780] = 7780,
  [7781] = 7781,
  [7782] = 7743,
  [7783] = 7752,
  [7784] = 7773,
  [7785] = 7773,
  [7786] = 7646,
  [7787] = 7787,
  [7788] = 7619,
  [7789] = 7597,
  [7790] = 7780,
  [7791] = 7595,
  [7792] = 7628,
  [7793] = 7778,
  [7794] = 7594,
  [7795] = 7795,
  [7796] = 7743,
  [7797] = 7698,
  [7798] = 7619,
  [7799] = 7799,
  [7800] = 7800,
  [7801] = 7758,
  [7802] = 7600,
  [7803] = 7758,
  [7804] = 7608,
  [7805] = 7609,
  [7806] = 7752,
  [7807] = 7597,
  [7808] = 7779,
  [7809] = 7596,
  [7810] = 7741,
  [7811] = 7601,
  [7812] = 7741,
  [7813] = 7597,
  [7814] = 7615,
  [7815] = 7596,
  [7816] = 7597,
  [7817] = 7817,
  [7818] = 7795,
  [7819] = 7711,
  [7820] = 7820,
  [7821] = 7603,
  [7822] = 7779,
  [7823] = 7605,
  [7824] = 7780,
  [7825] = 7825,
  [7826] = 7778,
  [7827] = 7775,
  [7828] = 7780,
  [7829] = 7597,
  [7830] = 7601,
  [7831] = 7594,
  [7832] = 7743,
  [7833] = 7623,
  [7834] = 7600,
  [7835] = 7758,
  [7836] = 7628,
  [7837] = 7752,
  [7838] = 7838,
  [7839] = 7621,
  [7840] = 7780,
  [7841] = 7623,
  [7842] = 7842,
  [7843] = 7743,
  [7844] = 7597,
  [7845] = 7845,
  [7846] = 7608,
  [7847] = 7609,
  [7848] = 7599,
  [7849] = 7760,
  [7850] = 7741,
  [7851] = 7596,
  [7852] = 7657,
  [7853] = 7604,
  [7854] = 7616,
  [7855] = 7855,
  [7856] = 7615,
  [7857] = 7610,
  [7858] = 7658,
  [7859] = 7711,
  [7860] = 6882,
  [7861] = 7603,
  [7862] = 7614,
  [7863] = 7605,
  [7864] = 7864,
  [7865] = 7625,
  [7866] = 6881,
  [7867] = 7775,
  [7868] = 7623,
  [7869] = 7616,
  [7870] = 7618,
  [7871] = 7724,
  [7872] = 7872,
  [7873] = 7873,
  [7874] = 7618,
  [7875] = 7752,
  [7876] = 7621,
  [7877] = 7597,
  [7878] = 7878,
  [7879] = 7709,
  [7880] = 7880,
  [7881] = 7881,
  [7882] = 7599,
  [7883] = 7604,
  [7884] = 7758,
  [7885] = 7779,
  [7886] = 7709,
  [7887] = 7887,
  [7888] = 7608,
  [7889] = 7609,
  [7890] = 7620,
  [7891] = 7610,
  [7892] = 7892,
  [7893] = 7709,
  [7894] = 7894,
  [7895] = 7619,
  [7896] = 7614,
  [7897] = 7615,
  [7898] = 7613,
  [7899] = 7899,
  [7900] = 7900,
  [7901] = 7901,
  [7902] = 7616,
  [7903] = 7618,
  [7904] = 7618,
  [7905] = 7601,
  [7906] = 7906,
  [7907] = 7907,
  [7908] = 7620,
  [7909] = 7611,
  [7910] = 7760,
  [7911] = 7613,
  [7912] = 7597,
  [7913] = 7913,
  [7914] = 7724,
  [7915] = 7611,
  [7916] = 7600,
  [7917] = 7917,
  [7918] = 7594,
  [7919] = 7602,
  [7920] = 7775,
  [7921] = 7778,
  [7922] = 7602,
  [7923] = 7621,
  [7924] = 7616,
  [7925] = 7652,
  [7926] = 7608,
  [7927] = 7609,
  [7928] = 7907,
  [7929] = 7652,
  [7930] = 7646,
  [7931] = 7780,
  [7932] = 7646,
  [7933] = 7779,
  [7934] = 7663,
  [7935] = 7615,
  [7936] = 7743,
  [7937] = 7775,
  [7938] = 7595,
  [7939] = 7626,
  [7940] = 7663,
  [7941] = 7907,
  [7942] = 7698,
  [7943] = 7625,
  [7944] = 7779,
  [7945] = 7773,
  [7946] = 7778,
  [7947] = 7595,
  [7948] = 7948,
  [7949] = 7605,
  [7950] = 7698,
  [7951] = 7614,
  [7952] = 7597,
  [7953] = 7595,
  [7954] = 7698,
  [7955] = 7615,
  [7956] = 7594,
  [7957] = 7609,
  [7958] = 7907,
  [7959] = 7613,
  [7960] = 7603,
  [7961] = 7663,
  [7962] = 7628,
  [7963] = 7594,
  [7964] = 7780,
  [7965] = 7965,
  [7966] = 7795,
  [7967] = 7709,
  [7968] = 7628,
  [7969] = 7611,
  [7970] = 7646,
  [7971] = 7907,
  [7972] = 7597,
  [7973] = 7652,
  [7974] = 7609,
  [7975] = 7608,
  [7976] = 7775,
  [7977] = 7609,
  [7978] = 7760,
  [7979] = 6905,
  [7980] = 7980,
  [7981] = 7760,
  [7982] = 7663,
  [7983] = 7597,
  [7984] = 7709,
  [7985] = 7597,
  [7986] = 7760,
  [7987] = 7597,
  [7988] = 7988,
  [7989] = 7989,
  [7990] = 7758,
  [7991] = 7752,
  [7992] = 7724,
  [7993] = 7596,
  [7994] = 7994,
  [7995] = 7773,
  [7996] = 7698,
  [7997] = 7610,
  [7998] = 7602,
  [7999] = 7775,
  [8000] = 7778,
  [8001] = 7779,
  [8002] = 8002,
  [8003] = 8003,
  [8004] = 6907,
  [8005] = 8005,
  [8006] = 7743,
  [8007] = 7663,
  [8008] = 7780,
  [8009] = 8009,
  [8010] = 8010,
  [8011] = 7773,
  [8012] = 8012,
  [8013] = 7758,
  [8014] = 7752,
  [8015] = 7743,
  [8016] = 7741,
  [8017] = 7741,
  [8018] = 8018,
  [8019] = 8019,
  [8020] = 8020,
  [8021] = 7775,
  [8022] = 7760,
  [8023] = 7778,
  [8024] = 7597,
  [8025] = 7741,
  [8026] = 7596,
  [8027] = 7595,
  [8028] = 7596,
  [8029] = 7603,
  [8030] = 7603,
  [8031] = 8031,
  [8032] = 7605,
  [8033] = 8033,
  [8034] = 7605,
  [8035] = 7603,
  [8036] = 7621,
  [8037] = 7773,
  [8038] = 7658,
  [8039] = 8039,
  [8040] = 7773,
  [8041] = 7623,
  [8042] = 7626,
  [8043] = 7779,
  [8044] = 7778,
  [8045] = 7709,
  [8046] = 7779,
  [8047] = 8047,
  [8048] = 8048,
  [8049] = 7599,
  [8050] = 7604,
  [8051] = 7605,
  [8052] = 7610,
  [8053] = 7709,
  [8054] = 7795,
  [8055] = 8055,
  [8056] = 8056,
  [8057] = 7614,
  [8058] = 8058,
  [8059] = 7604,
  [8060] = 7616,
  [8061] = 7618,
  [8062] = 7601,
  [8063] = 8063,
  [8064] = 7621,
  [8065] = 7620,
  [8066] = 7619,
  [8067] = 8067,
  [8068] = 8068,
  [8069] = 7599,
  [8070] = 8070,
  [8071] = 7780,
  [8072] = 7613,
  [8073] = 7600,
  [8074] = 7611,
  [8075] = 7623,
  [8076] = 7602,
  [8077] = 7599,
  [8078] = 7604,
  [8079] = 7758,
  [8080] = 7628,
  [8081] = 7838,
  [8082] = 7610,
  [8083] = 7608,
  [8084] = 7752,
  [8085] = 7594,
  [8086] = 7907,
  [8087] = 7698,
  [8088] = 8088,
  [8089] = 8089,
  [8090] = 8090,
  [8091] = 8033,
  [8092] = 7614,
  [8093] = 7609,
  [8094] = 7597,
  [8095] = 8095,
  [8096] = 8096,
  [8097] = 7652,
  [8098] = 7743,
  [8099] = 7646,
  [8100] = 7617,
  [8101] = 7616,
  [8102] = 7698,
  [8103] = 7698,
  [8104] = 8104,
  [8105] = 8105,
  [8106] = 7602,
  [8107] = 7618,
  [8108] = 7632,
  [8109] = 7778,
  [8110] = 7595,
  [8111] = 7760,
  [8112] = 7620,
  [8113] = 7597,
  [8114] = 7611,
  [8115] = 7698,
  [8116] = 7795,
  [8117] = 7594,
  [8118] = 7741,
  [8119] = 7613,
  [8120] = 8120,
  [8121] = 7741,
  [8122] = 7596,
  [8123] = 7620,
  [8124] = 8124,
  [8125] = 7775,
  [8126] = 8126,
  [8127] = 8068,
  [8128] = 8128,
  [8129] = 7657,
  [8130] = 7619,
  [8131] = 7709,
  [8132] = 7600,
  [8133] = 7605,
  [8134] = 8134,
  [8135] = 7711,
  [8136] = 7663,
  [8137] = 8137,
  [8138] = 7760,
  [8139] = 7601,
  [8140] = 7619,
  [8141] = 7620,
  [8142] = 8142,
  [8143] = 6880,
  [8144] = 7760,
  [8145] = 7618,
  [8146] = 7616,
  [8147] = 7614,
  [8148] = 7610,
  [8149] = 7780,
  [8150] = 7604,
  [8151] = 7599,
  [8152] = 7773,
  [8153] = 7758,
  [8154] = 7597,
  [8155] = 7752,
  [8156] = 7698,
  [8157] = 7779,
  [8158] = 7619,
  [8159] = 7603,
  [8160] = 8160,
  [8161] = 8161,
  [8162] = 7600,
  [8163] = 7773,
  [8164] = 7778,
  [8165] = 7775,
  [8166] = 7758,
  [8167] = 7623,
  [8168] = 7613,
  [8169] = 7775,
  [8170] = 8170,
  [8171] = 7621,
  [8172] = 7778,
  [8173] = 7611,
  [8174] = 7602,
  [8175] = 8175,
  [8176] = 7621,
  [8177] = 7773,
  [8178] = 7779,
  [8179] = 7780,
  [8180] = 7623,
  [8181] = 8088,
  [8182] = 8182,
  [8183] = 7758,
  [8184] = 7752,
  [8185] = 7752,
  [8186] = 8186,
  [8187] = 7594,
  [8188] = 8188,
  [8189] = 6908,
  [8190] = 7599,
  [8191] = 7646,
  [8192] = 7604,
  [8193] = 7652,
  [8194] = 7605,
  [8195] = 7743,
  [8196] = 7698,
  [8197] = 7743,
  [8198] = 7610,
  [8199] = 7741,
  [8200] = 7614,
  [8201] = 7616,
  [8202] = 7618,
  [8203] = 7628,
  [8204] = 6855,
  [8205] = 8205,
  [8206] = 7596,
  [8207] = 6883,
  [8208] = 7907,
  [8209] = 8209,
  [8210] = 7597,
  [8211] = 7601,
  [8212] = 7758,
  [8213] = 7603,
  [8214] = 7620,
  [8215] = 7619,
  [8216] = 8216,
  [8217] = 7603,
  [8218] = 7613,
  [8219] = 7600,
  [8220] = 7602,
  [8221] = 7741,
  [8222] = 7711,
  [8223] = 7658,
  [8224] = 7605,
  [8225] = 7709,
  [8226] = 7657,
  [8227] = 7614,
  [8228] = 7610,
  [8229] = 7594,
  [8230] = 7621,
  [8231] = 8231,
  [8232] = 7596,
  [8233] = 7628,
  [8234] = 7780,
  [8235] = 8235,
  [8236] = 6896,
  [8237] = 8237,
  [8238] = 6906,
  [8239] = 8239,
  [8240] = 7626,
  [8241] = 7596,
  [8242] = 6872,
  [8243] = 7741,
  [8244] = 7615,
  [8245] = 7743,
  [8246] = 7621,
  [8247] = 8247,
  [8248] = 7611,
  [8249] = 7594,
  [8250] = 7752,
  [8251] = 7743,
  [8252] = 7602,
  [8253] = 7628,
  [8254] = 7752,
  [8255] = 7773,
  [8256] = 7698,
  [8257] = 7758,
  [8258] = 8258,
  [8259] = 7760,
  [8260] = 7780,
  [8261] = 6903,
  [8262] = 8262,
  [8263] = 7623,
  [8264] = 7597,
  [8265] = 7773,
  [8266] = 7628,
  [8267] = 7657,
  [8268] = 7599,
  [8269] = 7795,
  [8270] = 7597,
  [8271] = 7760,
  [8272] = 7604,
  [8273] = 7652,
  [8274] = 7646,
  [8275] = 7658,
  [8276] = 7628,
  [8277] = 7610,
  [8278] = 6886,
  [8279] = 7594,
  [8280] = 8280,
  [8281] = 7779,
  [8282] = 7698,
  [8283] = 7620,
  [8284] = 7663,
  [8285] = 7724,
  [8286] = 7614,
  [8287] = 7595,
  [8288] = 7773,
  [8289] = 7778,
  [8290] = 7602,
  [8291] = 8291,
  [8292] = 7711,
  [8293] = 7775,
  [8294] = 6893,
  [8295] = 7614,
  [8296] = 7610,
  [8297] = 7595,
  [8298] = 7616,
  [8299] = 8299,
  [8300] = 7621,
  [8301] = 7597,
  [8302] = 7760,
  [8303] = 7779,
  [8304] = 7743,
  [8305] = 7628,
  [8306] = 7618,
  [8307] = 699,
  [8308] = 8308,
  [8309] = 7603,
  [8310] = 7752,
  [8311] = 7620,
  [8312] = 7698,
  [8313] = 7724,
  [8314] = 7758,
  [8315] = 7605,
  [8316] = 7619,
  [8317] = 7628,
  [8318] = 7773,
  [8319] = 7613,
  [8320] = 7709,
  [8321] = 7601,
  [8322] = 7611,
  [8323] = 8323,
  [8324] = 8324,
  [8325] = 7597,
  [8326] = 7760,
  [8327] = 7594,
  [8328] = 7600,
  [8329] = 7601,
  [8330] = 8330,
  [8331] = 6871,
  [8332] = 7600,
  [8333] = 7602,
  [8334] = 7594,
  [8335] = 7621,
  [8336] = 7602,
  [8337] = 7594,
  [8338] = 7758,
  [8339] = 7709,
  [8340] = 8340,
  [8341] = 7621,
  [8342] = 7602,
  [8343] = 7623,
  [8344] = 7752,
  [8345] = 7698,
  [8346] = 7614,
  [8347] = 709,
  [8348] = 7610,
  [8349] = 7599,
  [8350] = 8350,
  [8351] = 7621,
  [8352] = 7595,
  [8353] = 6879,
  [8354] = 7663,
  [8355] = 8355,
  [8356] = 8356,
  [8357] = 7610,
  [8358] = 7743,
  [8359] = 8359,
  [8360] = 7614,
  [8361] = 7646,
  [8362] = 7652,
  [8363] = 7619,
  [8364] = 7616,
  [8365] = 7752,
  [8366] = 7628,
  [8367] = 7758,
  [8368] = 7618,
  [8369] = 7778,
  [8370] = 7652,
  [8371] = 7646,
  [8372] = 7773,
  [8373] = 7600,
  [8374] = 7601,
  [8375] = 7775,
  [8376] = 8137,
  [8377] = 7653,
  [8378] = 7597,
  [8379] = 7760,
  [8380] = 7611,
  [8381] = 7760,
  [8382] = 6862,
  [8383] = 8383,
  [8384] = 7597,
  [8385] = 8385,
  [8386] = 7620,
  [8387] = 7613,
  [8388] = 7604,
  [8389] = 7663,
  [8390] = 8390,
  [8391] = 7743,
  [8392] = 7613,
  [8393] = 7628,
  [8394] = 7623,
  [8395] = 7773,
  [8396] = 7611,
  [8397] = 7602,
  [8398] = 7602,
  [8399] = 8399,
  [8400] = 7614,
  [8401] = 7610,
  [8402] = 7621,
  [8403] = 8403,
  [8404] = 8404,
  [8405] = 8405,
  [8406] = 8406,
  [8407] = 8406,
  [8408] = 8405,
  [8409] = 8404,
  [8410] = 8410,
  [8411] = 8411,
  [8412] = 8412,
  [8413] = 8413,
  [8414] = 8414,
  [8415] = 8415,
  [8416] = 8404,
  [8417] = 8417,
  [8418] = 8411,
  [8419] = 8406,
  [8420] = 8405,
  [8421] = 8421,
  [8422] = 8410,
  [8423] = 8421,
  [8424] = 8411,
  [8425] = 8414,
  [8426] = 8415,
  [8427] = 8406,
  [8428] = 8405,
  [8429] = 8411,
  [8430] = 8417,
  [8431] = 8410,
  [8432] = 8406,
  [8433] = 8404,
  [8434] = 8417,
  [8435] = 8415,
  [8436] = 8405,
  [8437] = 8410,
  [8438] = 8404,
  [8439] = 8421,
  [8440] = 8406,
  [8441] = 8405,
  [8442] = 8411,
  [8443] = 8411,
  [8444] = 8404,
  [8445] = 8421,
  [8446] = 8415,
  [8447] = 8415,
  [8448] = 8448,
  [8449] = 8417,
  [8450] = 8450,
  [8451] = 8414,
  [8452] = 8417,
  [8453] = 8406,
  [8454] = 8405,
  [8455] = 8410,
  [8456] = 8456,
  [8457] = 8410,
  [8458] = 8458,
  [8459] = 8459,
  [8460] = 8421,
  [8461] = 8415,
  [8462] = 8411,
  [8463] = 8406,
  [8464] = 8405,
  [8465] = 8417,
  [8466] = 8466,
  [8467] = 8467,
  [8468] = 8415,
  [8469] = 8421,
  [8470] = 8404,
  [8471] = 8410,
  [8472] = 8417,
  [8473] = 8405,
  [8474] = 8410,
  [8475] = 8406,
  [8476] = 8410,
  [8477] = 8477,
  [8478] = 8404,
  [8479] = 8411,
  [8480] = 8480,
  [8481] = 8481,
  [8482] = 8482,
  [8483] = 8417,
  [8484] = 8484,
  [8485] = 8414,
  [8486] = 8421,
  [8487] = 8415,
  [8488] = 8411,
  [8489] = 8489,
  [8490] = 8490,
  [8491] = 8406,
  [8492] = 8411,
  [8493] = 8414,
  [8494] = 8415,
  [8495] = 8411,
  [8496] = 8496,
  [8497] = 8497,
  [8498] = 8498,
  [8499] = 8405,
  [8500] = 8500,
  [8501] = 8501,
  [8502] = 8502,
  [8503] = 8421,
  [8504] = 8405,
  [8505] = 8417,
  [8506] = 8404,
  [8507] = 8507,
  [8508] = 8406,
  [8509] = 8509,
  [8510] = 8510,
  [8511] = 8405,
  [8512] = 8410,
  [8513] = 8415,
  [8514] = 8411,
  [8515] = 8421,
  [8516] = 8516,
  [8517] = 8517,
  [8518] = 8518,
  [8519] = 8519,
  [8520] = 8410,
  [8521] = 8521,
  [8522] = 8404,
  [8523] = 8421,
  [8524] = 8524,
  [8525] = 8525,
  [8526] = 8415,
  [8527] = 8417,
  [8528] = 8421,
  [8529] = 8414,
  [8530] = 8530,
  [8531] = 8406,
  [8532] = 8404,
  [8533] = 8404,
  [8534] = 8414,
  [8535] = 8535,
  [8536] = 8536,
  [8537] = 8411,
  [8538] = 8538,
  [8539] = 8417,
  [8540] = 8536,
  [8541] = 8404,
  [8542] = 8542,
  [8543] = 762,
  [8544] = 8411,
  [8545] = 8411,
  [8546] = 8411,
  [8547] = 8405,
  [8548] = 8406,
  [8549] = 8411,
  [8550] = 8406,
  [8551] = 8415,
  [8552] = 8536,
  [8553] = 6922,
  [8554] = 8535,
  [8555] = 8404,
  [8556] = 8411,
  [8557] = 8557,
  [8558] = 8405,
  [8559] = 8415,
  [8560] = 8410,
  [8561] = 8561,
  [8562] = 8415,
  [8563] = 8421,
  [8564] = 8417,
  [8565] = 8411,
  [8566] = 8536,
  [8567] = 8535,
  [8568] = 8568,
  [8569] = 8414,
  [8570] = 8570,
  [8571] = 8410,
  [8572] = 8572,
  [8573] = 8421,
  [8574] = 8404,
  [8575] = 8536,
  [8576] = 8417,
  [8577] = 8414,
  [8578] = 8411,
  [8579] = 8535,
  [8580] = 8417,
  [8581] = 8411,
  [8582] = 8410,
  [8583] = 8583,
  [8584] = 8417,
  [8585] = 8585,
  [8586] = 8417,
  [8587] = 8587,
  [8588] = 8536,
  [8589] = 8411,
  [8590] = 8535,
  [8591] = 8411,
  [8592] = 8411,
  [8593] = 8404,
  [8594] = 8594,
  [8595] = 8595,
  [8596] = 8404,
  [8597] = 8417,
  [8598] = 8535,
  [8599] = 8536,
  [8600] = 8536,
  [8601] = 8535,
  [8602] = 8411,
  [8603] = 8414,
  [8604] = 8604,
  [8605] = 8605,
  [8606] = 8414,
  [8607] = 8607,
  [8608] = 8411,
  [8609] = 8535,
  [8610] = 8610,
  [8611] = 8405,
  [8612] = 8612,
  [8613] = 8613,
  [8614] = 8536,
  [8615] = 8535,
  [8616] = 8406,
  [8617] = 8617,
  [8618] = 8411,
  [8619] = 8619,
  [8620] = 8411,
  [8621] = 8535,
  [8622] = 8410,
  [8623] = 8536,
  [8624] = 8415,
  [8625] = 8410,
  [8626] = 8411,
  [8627] = 8536,
  [8628] = 8414,
  [8629] = 8535,
  [8630] = 8630,
  [8631] = 8405,
  [8632] = 8421,
  [8633] = 8406,
  [8634] = 8634,
  [8635] = 8421,
  [8636] = 8411,
  [8637] = 8536,
  [8638] = 8535,
  [8639] = 8415,
  [8640] = 8415,
  [8641] = 8421,
  [8642] = 8414,
  [8643] = 8410,
  [8644] = 8421,
  [8645] = 8411,
  [8646] = 8406,
  [8647] = 8536,
  [8648] = 8535,
  [8649] = 8405,
  [8650] = 8650,
  [8651] = 8651,
  [8652] = 8652,
  [8653] = 8653,
  [8654] = 8654,
  [8655] = 8655,
  [8656] = 8651,
  [8657] = 8652,
  [8658] = 8658,
  [8659] = 8658,
  [8660] = 8653,
  [8661] = 8654,
  [8662] = 8662,
  [8663] = 8663,
  [8664] = 8662,
  [8665] = 8652,
  [8666] = 8666,
  [8667] = 8667,
  [8668] = 8658,
  [8669] = 8662,
  [8670] = 8670,
  [8671] = 8654,
  [8672] = 8651,
  [8673] = 8652,
  [8674] = 8653,
  [8675] = 8654,
  [8676] = 8653,
  [8677] = 8677,
  [8678] = 8651,
  [8679] = 8662,
  [8680] = 8658,
  [8681] = 8663,
  [8682] = 8655,
  [8683] = 8658,
  [8684] = 8650,
  [8685] = 8677,
  [8686] = 8654,
  [8687] = 8653,
  [8688] = 8652,
  [8689] = 8689,
  [8690] = 8662,
  [8691] = 8651,
  [8692] = 8650,
  [8693] = 8651,
  [8694] = 8652,
  [8695] = 8653,
  [8696] = 8654,
  [8697] = 8697,
  [8698] = 8697,
  [8699] = 8662,
  [8700] = 8700,
  [8701] = 8658,
  [8702] = 8702,
  [8703] = 8703,
  [8704] = 8704,
  [8705] = 8705,
  [8706] = 8706,
  [8707] = 8704,
  [8708] = 8689,
  [8709] = 8662,
  [8710] = 8677,
  [8711] = 8677,
  [8712] = 8651,
  [8713] = 8652,
  [8714] = 8653,
  [8715] = 8654,
  [8716] = 8705,
  [8717] = 8670,
  [8718] = 8689,
  [8719] = 8705,
  [8720] = 8658,
  [8721] = 8670,
  [8722] = 8704,
  [8723] = 8723,
  [8724] = 8705,
  [8725] = 8725,
  [8726] = 8650,
  [8727] = 8670,
  [8728] = 8662,
  [8729] = 8689,
  [8730] = 8705,
  [8731] = 8651,
  [8732] = 8652,
  [8733] = 8653,
  [8734] = 8654,
  [8735] = 8689,
  [8736] = 8704,
  [8737] = 8677,
  [8738] = 8670,
  [8739] = 8658,
  [8740] = 8670,
  [8741] = 8663,
  [8742] = 8663,
  [8743] = 8704,
  [8744] = 8697,
  [8745] = 8677,
  [8746] = 8650,
  [8747] = 8662,
  [8748] = 8650,
  [8749] = 8697,
  [8750] = 8651,
  [8751] = 8652,
  [8752] = 8653,
  [8753] = 8654,
  [8754] = 8689,
  [8755] = 8704,
  [8756] = 8663,
  [8757] = 8689,
  [8758] = 8658,
  [8759] = 8705,
  [8760] = 8663,
  [8761] = 8689,
  [8762] = 8677,
  [8763] = 8763,
  [8764] = 8670,
  [8765] = 8655,
  [8766] = 8662,
  [8767] = 8705,
  [8768] = 8768,
  [8769] = 8651,
  [8770] = 8652,
  [8771] = 8653,
  [8772] = 8654,
  [8773] = 8650,
  [8774] = 8697,
  [8775] = 8663,
  [8776] = 8776,
  [8777] = 8658,
  [8778] = 8704,
  [8779] = 8779,
  [8780] = 8763,
  [8781] = 8705,
  [8782] = 8704,
  [8783] = 8677,
  [8784] = 8784,
  [8785] = 8662,
  [8786] = 8670,
  [8787] = 8663,
  [8788] = 8651,
  [8789] = 8652,
  [8790] = 8653,
  [8791] = 8654,
  [8792] = 8655,
  [8793] = 8666,
  [8794] = 8650,
  [8795] = 8697,
  [8796] = 8658,
  [8797] = 8650,
  [8798] = 8697,
  [8799] = 8650,
  [8800] = 8704,
  [8801] = 8697,
  [8802] = 8705,
  [8803] = 8689,
  [8804] = 8662,
  [8805] = 8805,
  [8806] = 8651,
  [8807] = 8652,
  [8808] = 8653,
  [8809] = 8654,
  [8810] = 8704,
  [8811] = 8658,
  [8812] = 8812,
  [8813] = 8704,
  [8814] = 8763,
  [8815] = 8670,
  [8816] = 8662,
  [8817] = 8705,
  [8818] = 8651,
  [8819] = 8652,
  [8820] = 8653,
  [8821] = 8654,
  [8822] = 8677,
  [8823] = 8658,
  [8824] = 8655,
  [8825] = 8663,
  [8826] = 8704,
  [8827] = 8650,
  [8828] = 8662,
  [8829] = 8651,
  [8830] = 8652,
  [8831] = 8653,
  [8832] = 8654,
  [8833] = 8658,
  [8834] = 8697,
  [8835] = 8704,
  [8836] = 8689,
  [8837] = 8705,
  [8838] = 8662,
  [8839] = 8651,
  [8840] = 8652,
  [8841] = 8653,
  [8842] = 8654,
  [8843] = 8658,
  [8844] = 8689,
  [8845] = 8677,
  [8846] = 8677,
  [8847] = 8670,
  [8848] = 8653,
  [8849] = 8658,
  [8850] = 8670,
  [8851] = 8851,
  [8852] = 8653,
  [8853] = 8658,
  [8854] = 8689,
  [8855] = 8763,
  [8856] = 8653,
  [8857] = 8658,
  [8858] = 8697,
  [8859] = 8859,
  [8860] = 8653,
  [8861] = 8658,
  [8862] = 8862,
  [8863] = 8650,
  [8864] = 8653,
  [8865] = 8658,
  [8866] = 8704,
  [8867] = 8705,
  [8868] = 8653,
  [8869] = 8658,
  [8870] = 8689,
  [8871] = 8670,
  [8872] = 8653,
  [8873] = 8658,
  [8874] = 8650,
  [8875] = 8670,
  [8876] = 8653,
  [8877] = 8658,
  [8878] = 8650,
  [8879] = 8704,
  [8880] = 8653,
  [8881] = 8658,
  [8882] = 8705,
  [8883] = 8653,
  [8884] = 8658,
  [8885] = 8705,
  [8886] = 8653,
  [8887] = 8658,
  [8888] = 8689,
  [8889] = 8653,
  [8890] = 8658,
  [8891] = 8670,
  [8892] = 8892,
  [8893] = 8650,
  [8894] = 8663,
  [8895] = 8704,
  [8896] = 8677,
  [8897] = 8897,
  [8898] = 8705,
  [8899] = 8689,
  [8900] = 8663,
  [8901] = 8689,
  [8902] = 8653,
  [8903] = 8903,
  [8904] = 8670,
  [8905] = 8650,
  [8906] = 8704,
  [8907] = 8705,
  [8908] = 8700,
  [8909] = 8689,
  [8910] = 8658,
  [8911] = 8911,
  [8912] = 8705,
  [8913] = 8670,
  [8914] = 8914,
  [8915] = 8915,
  [8916] = 8650,
  [8917] = 8763,
  [8918] = 8655,
  [8919] = 8919,
  [8920] = 8658,
  [8921] = 8704,
  [8922] = 8705,
  [8923] = 8697,
  [8924] = 8689,
  [8925] = 8650,
  [8926] = 8670,
  [8927] = 8927,
  [8928] = 8928,
  [8929] = 8650,
  [8930] = 8704,
  [8931] = 8705,
  [8932] = 8654,
  [8933] = 8655,
  [8934] = 8934,
  [8935] = 8653,
  [8936] = 8658,
  [8937] = 8652,
  [8938] = 8651,
  [8939] = 8670,
  [8940] = 8663,
  [8941] = 8941,
  [8942] = 8662,
  [8943] = 8650,
  [8944] = 8944,
  [8945] = 8700,
  [8946] = 8704,
  [8947] = 8700,
  [8948] = 8670,
  [8949] = 8705,
  [8950] = 8689,
  [8951] = 8650,
  [8952] = 8700,
  [8953] = 8670,
  [8954] = 8677,
  [8955] = 8700,
  [8956] = 8650,
  [8957] = 8704,
  [8958] = 8700,
  [8959] = 8705,
  [8960] = 8689,
  [8961] = 8700,
  [8962] = 8697,
  [8963] = 8700,
  [8964] = 8670,
  [8965] = 8666,
  [8966] = 8689,
  [8967] = 8967,
  [8968] = 8968,
  [8969] = 8700,
  [8970] = 8650,
  [8971] = 8971,
  [8972] = 8704,
  [8973] = 8973,
  [8974] = 8700,
  [8975] = 8705,
  [8976] = 8689,
  [8977] = 8670,
  [8978] = 8700,
  [8979] = 8650,
  [8980] = 8704,
  [8981] = 8700,
  [8982] = 8689,
  [8983] = 8670,
  [8984] = 8700,
  [8985] = 8985,
  [8986] = 8705,
  [8987] = 8650,
  [8988] = 8700,
  [8989] = 8704,
  [8990] = 8705,
  [8991] = 8689,
  [8992] = 8670,
  [8993] = 8993,
  [8994] = 8670,
  [8995] = 8650,
  [8996] = 8911,
  [8997] = 8700,
  [8998] = 8677,
  [8999] = 8705,
  [9000] = 8704,
  [9001] = 9001,
  [9002] = 8689,
  [9003] = 8704,
  [9004] = 8705,
  [9005] = 8689,
  [9006] = 8704,
  [9007] = 8763,
  [9008] = 9008,
  [9009] = 9009,
  [9010] = 8670,
  [9011] = 8663,
  [9012] = 8911,
  [9013] = 8700,
  [9014] = 8705,
  [9015] = 8704,
  [9016] = 8689,
  [9017] = 8670,
  [9018] = 8934,
  [9019] = 8655,
  [9020] = 8655,
  [9021] = 8662,
  [9022] = 8697,
  [9023] = 8892,
  [9024] = 8763,
  [9025] = 8897,
  [9026] = 9026,
  [9027] = 8704,
  [9028] = 8700,
  [9029] = 8903,
  [9030] = 8911,
  [9031] = 8700,
  [9032] = 8911,
  [9033] = 8650,
  [9034] = 8702,
  [9035] = 8892,
  [9036] = 8706,
  [9037] = 8897,
  [9038] = 8697,
  [9039] = 8663,
  [9040] = 8903,
  [9041] = 8903,
  [9042] = 8654,
  [9043] = 8650,
  [9044] = 8655,
  [9045] = 8705,
  [9046] = 8653,
  [9047] = 8892,
  [9048] = 8911,
  [9049] = 8897,
  [9050] = 8700,
  [9051] = 8851,
  [9052] = 8985,
  [9053] = 8903,
  [9054] = 8677,
  [9055] = 9055,
  [9056] = 9055,
  [9057] = 8655,
  [9058] = 8985,
  [9059] = 8892,
  [9060] = 8689,
  [9061] = 8897,
  [9062] = 8851,
  [9063] = 8663,
  [9064] = 8851,
  [9065] = 8903,
  [9066] = 8652,
  [9067] = 8702,
  [9068] = 8663,
  [9069] = 8911,
  [9070] = 8651,
  [9071] = 8892,
  [9072] = 8700,
  [9073] = 8897,
  [9074] = 8763,
  [9075] = 8689,
  [9076] = 8677,
  [9077] = 8903,
  [9078] = 8934,
  [9079] = 8650,
  [9080] = 9055,
  [9081] = 8697,
  [9082] = 8985,
  [9083] = 8892,
  [9084] = 8851,
  [9085] = 8897,
  [9086] = 8702,
  [9087] = 8911,
  [9088] = 8700,
  [9089] = 8903,
  [9090] = 8897,
  [9091] = 8934,
  [9092] = 9092,
  [9093] = 8892,
  [9094] = 9055,
  [9095] = 8897,
  [9096] = 8677,
  [9097] = 8704,
  [9098] = 8985,
  [9099] = 8903,
  [9100] = 8700,
  [9101] = 8763,
  [9102] = 8702,
  [9103] = 8892,
  [9104] = 8911,
  [9105] = 8897,
  [9106] = 8700,
  [9107] = 8663,
  [9108] = 8670,
  [9109] = 8903,
  [9110] = 8670,
  [9111] = 8934,
  [9112] = 8705,
  [9113] = 8892,
  [9114] = 8677,
  [9115] = 8897,
  [9116] = 9116,
  [9117] = 9055,
  [9118] = 8677,
  [9119] = 8903,
  [9120] = 8689,
  [9121] = 8985,
  [9122] = 9122,
  [9123] = 8892,
  [9124] = 8851,
  [9125] = 8897,
  [9126] = 8677,
  [9127] = 8697,
  [9128] = 8670,
  [9129] = 8903,
  [9130] = 8677,
  [9131] = 8702,
  [9132] = 8911,
  [9133] = 8892,
  [9134] = 8700,
  [9135] = 8897,
  [9136] = 9055,
  [9137] = 8677,
  [9138] = 8934,
  [9139] = 8903,
  [9140] = 9140,
  [9141] = 8677,
  [9142] = 8892,
  [9143] = 8663,
  [9144] = 8903,
  [9145] = 8689,
  [9146] = 8689,
  [9147] = 8892,
  [9148] = 9055,
  [9149] = 8903,
  [9150] = 8670,
  [9151] = 9151,
  [9152] = 8903,
  [9153] = 8677,
  [9154] = 8705,
  [9155] = 8903,
  [9156] = 8985,
  [9157] = 9157,
  [9158] = 8903,
  [9159] = 8903,
  [9160] = 8903,
  [9161] = 8903,
  [9162] = 8903,
  [9163] = 8903,
  [9164] = 8903,
  [9165] = 8903,
  [9166] = 8903,
  [9167] = 8903,
  [9168] = 8903,
  [9169] = 8903,
  [9170] = 8705,
  [9171] = 9171,
  [9172] = 9172,
  [9173] = 8851,
  [9174] = 8903,
  [9175] = 8677,
  [9176] = 8702,
  [9177] = 8763,
  [9178] = 8677,
  [9179] = 8779,
  [9180] = 8704,
  [9181] = 8911,
  [9182] = 8700,
  [9183] = 8670,
  [9184] = 9092,
  [9185] = 8934,
  [9186] = 8934,
  [9187] = 9187,
  [9188] = 9188,
  [9189] = 9171,
  [9190] = 9172,
  [9191] = 9092,
  [9192] = 8702,
  [9193] = 9055,
  [9194] = 9171,
  [9195] = 9172,
  [9196] = 9092,
  [9197] = 8650,
  [9198] = 8911,
  [9199] = 9171,
  [9200] = 9172,
  [9201] = 9092,
  [9202] = 8763,
  [9203] = 8702,
  [9204] = 9171,
  [9205] = 9172,
  [9206] = 9092,
  [9207] = 8704,
  [9208] = 8985,
  [9209] = 9171,
  [9210] = 9172,
  [9211] = 9092,
  [9212] = 8851,
  [9213] = 9213,
  [9214] = 9171,
  [9215] = 9172,
  [9216] = 9092,
  [9217] = 9171,
  [9218] = 9172,
  [9219] = 9092,
  [9220] = 9171,
  [9221] = 9172,
  [9222] = 9092,
  [9223] = 9171,
  [9224] = 9172,
  [9225] = 9092,
  [9226] = 9171,
  [9227] = 9172,
  [9228] = 9092,
  [9229] = 9171,
  [9230] = 9172,
  [9231] = 9092,
  [9232] = 9172,
  [9233] = 9092,
  [9234] = 9172,
  [9235] = 9092,
  [9236] = 9092,
  [9237] = 9092,
  [9238] = 8662,
  [9239] = 8851,
  [9240] = 8985,
  [9241] = 8677,
  [9242] = 8655,
  [9243] = 9172,
  [9244] = 8776,
  [9245] = 8862,
  [9246] = 9008,
  [9247] = 8911,
  [9248] = 8862,
  [9249] = 9008,
  [9250] = 8700,
  [9251] = 8862,
  [9252] = 9008,
  [9253] = 9055,
  [9254] = 8862,
  [9255] = 9008,
  [9256] = 8663,
  [9257] = 8862,
  [9258] = 9008,
  [9259] = 8934,
  [9260] = 8862,
  [9261] = 9008,
  [9262] = 8697,
  [9263] = 8862,
  [9264] = 8862,
  [9265] = 8862,
  [9266] = 8862,
  [9267] = 8862,
  [9268] = 8862,
  [9269] = 8862,
  [9270] = 8862,
  [9271] = 8862,
  [9272] = 8862,
  [9273] = 9171,
  [9274] = 8650,
  [9275] = 8892,
  [9276] = 9055,
  [9277] = 8662,
  [9278] = 8677,
  [9279] = 9279,
  [9280] = 8985,
  [9281] = 8677,
  [9282] = 8851,
  [9283] = 8702,
  [9284] = 8655,
  [9285] = 9285,
  [9286] = 8934,
  [9287] = 8911,
  [9288] = 8700,
  [9289] = 8700,
  [9290] = 8934,
  [9291] = 8911,
  [9292] = 8677,
  [9293] = 8851,
  [9294] = 8985,
  [9295] = 8702,
  [9296] = 9055,
  [9297] = 9009,
  [9298] = 9055,
  [9299] = 9009,
  [9300] = 8985,
  [9301] = 9009,
  [9302] = 8851,
  [9303] = 9009,
  [9304] = 8702,
  [9305] = 9009,
  [9306] = 8911,
  [9307] = 9009,
  [9308] = 8700,
  [9309] = 8934,
  [9310] = 9055,
  [9311] = 8985,
  [9312] = 8851,
  [9313] = 8702,
  [9314] = 8911,
  [9315] = 8700,
  [9316] = 8934,
  [9317] = 9317,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6},
  {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377}, {0x37b, 0x37d},
  {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f},
  {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f}, {0x671, 0x6d3},
  {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f}, {0x74d, 0x7a5},
  {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824}, {0x828, 0x828},
  {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d}, {0x950, 0x950},
  {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a}, {0xa0f, 0xa10},
  {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa72, 0xa74},
  {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd}, {0xad0, 0xad0},
  {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39},
  {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95},
  {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0}, {0xc05, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61}, {0xc80, 0xc80},
  {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde}, {0xce0, 0xce1},
  {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56}, {0xd5f, 0xd61},
  {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30}, {0xe32, 0xe32},
  {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0}, {0xeb2, 0xeb2},
  {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf88, 0xf8c},
  {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070}, {0x1075, 0x1081},
  {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd},
  {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731}, {0x1740, 0x1751},
  {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x18a8}, {0x18aa, 0x18aa},
  {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16}, {0x1a20, 0x1a54},
  {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f},
  {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa},
  {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x2102, 0x2102},
  {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25},
  {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6},
  {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007}, {0x3021, 0x3029}, {0x3031, 0x3035},
  {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa640, 0xa66e},
  {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9},
  {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb},
  {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef},
  {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1},
  {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4}, {0xab01, 0xab06},
  {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xac00, 0xd7a3},
  {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28},
  {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d},
  {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf},
  {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d},
  {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375}, {0x10380, 0x1039d},
  {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563},
  {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc},
  {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808},
  {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5},
  {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27},
  {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072}, {0x11075, 0x11075}, {0x11083, 0x110af},
  {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176}, {0x11183, 0x111b2}, {0x111c1, 0x111c4},
  {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x1123f, 0x11240}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d},
  {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333},
  {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461}, {0x11480, 0x114af},
  {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa}, {0x116b8, 0x116b8},
  {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916},
  {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3}, {0x11a00, 0x11a00},
  {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e},
  {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68},
  {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11f02, 0x11f02}, {0x11f04, 0x11f10}, {0x11f12, 0x11f33}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399},
  {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13441, 0x13446}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e},
  {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a},
  {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3},
  {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb},
  {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2},
  {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514},
  {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0},
  {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8},
  {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e030, 0x1e06d}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e},
  {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e4d0, 0x1e4eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4},
  {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32},
  {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f},
  {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62},
  {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b},
  {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0},
  {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xb7, 0xb7}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x300, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481},
  {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf}, {0x5c1, 0x5c2},
  {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669}, {0x66e, 0x6d3}, {0x6d5, 0x6dc},
  {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5}, {0x7fa, 0x7fa}, {0x7fd, 0x7fd},
  {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1}, {0x8e3, 0x963}, {0x966, 0x96f},
  {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bc, 0x9c4},
  {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1}, {0x9fc, 0x9fc}, {0x9fe, 0x9fe},
  {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39},
  {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa66, 0xa75},
  {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabc, 0xac5},
  {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff}, {0xb01, 0xb03}, {0xb05, 0xb0c},
  {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44}, {0xb47, 0xb48}, {0xb4b, 0xb4d},
  {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90},
  {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbbe, 0xbc2},
  {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28},
  {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc63},
  {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbc, 0xcc4},
  {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef}, {0xcf1, 0xcf3}, {0xd00, 0xd0c},
  {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63}, {0xd66, 0xd6f}, {0xd7a, 0xd7f},
  {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xdca, 0xdca}, {0xdcf, 0xdd4},
  {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e}, {0xe50, 0xe59}, {0xe81, 0xe82},
  {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xec8, 0xece},
  {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35}, {0xf37, 0xf37}, {0xf39, 0xf39},
  {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6}, {0x1000, 0x1049}, {0x1050, 0x109d},
  {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258},
  {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5},
  {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371}, {0x1380, 0x138f}, {0x13a0, 0x13f5},
  {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1715}, {0x171f, 0x1734},
  {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dd}, {0x17e0, 0x17e9},
  {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b}, {0x1930, 0x193b},
  {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c},
  {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59}, {0x1b6b, 0x1b73},
  {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2},
  {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x200c, 0x200d}, {0x203f, 0x2040}, {0x2054, 0x2054}, {0x2071, 0x2071},
  {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113},
  {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149},
  {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67},
  {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce},
  {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096},
  {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf},
  {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1}, {0xa717, 0xa71f},
  {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c}, {0xa840, 0xa873},
  {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c}, {0xa980, 0xa9c0},
  {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2}, {0xaadb, 0xaadd},
  {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a},
  {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d},
  {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41},
  {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe00, 0xfe0f},
  {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff65, 0xffbe}, {0xffc2, 0xffc7},
  {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d},
  {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0}, {0x10300, 0x1031f},
  {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104a0, 0x104a9},
  {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595},
  {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785},
  {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855},
  {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf},
  {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a}, {0x10a3f, 0x10a3f}, {0x10a60, 0x10a7c},
  {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48},
  {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac}, {0x10eb0, 0x10eb1}, {0x10efd, 0x10f1c},
  {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046}, {0x11066, 0x11075}, {0x1107f, 0x110ba},
  {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147}, {0x11150, 0x11173}, {0x11176, 0x11176},
  {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237}, {0x1123e, 0x11241}, {0x11280, 0x11286},
  {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9}, {0x11300, 0x11303}, {0x11305, 0x1130c},
  {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344}, {0x11347, 0x11348}, {0x1134b, 0x1134d},
  {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a}, {0x11450, 0x11459}, {0x1145e, 0x11461},
  {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd}, {0x11600, 0x11640}, {0x11644, 0x11644},
  {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739}, {0x11740, 0x11746}, {0x11800, 0x1183a},
  {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935}, {0x11937, 0x11938}, {0x1193b, 0x11943},
  {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e}, {0x11a47, 0x11a47}, {0x11a50, 0x11a99},
  {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59}, {0x11c72, 0x11c8f}, {0x11c92, 0x11ca7},
  {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d}, {0x11d3f, 0x11d47}, {0x11d50, 0x11d59},
  {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9}, {0x11ee0, 0x11ef6}, {0x11f00, 0x11f10},
  {0x11f12, 0x11f3a}, {0x11f3e, 0x11f42}, {0x11f50, 0x11f59}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0},
  {0x13000, 0x1342f}, {0x13440, 0x13455}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69}, {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9},
  {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f},
  {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1}, {0x17000, 0x187f7}, {0x18800, 0x18cd5},
  {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155},
  {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1bc9d, 0x1bc9e}, {0x1cf00, 0x1cf2d},
  {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad}, {0x1d242, 0x1d244}, {0x1d400, 0x1d454},
  {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3},
  {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546},
  {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e},
  {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff}, {0x1da00, 0x1da36}, {0x1da3b, 0x1da6c},
  {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e000, 0x1e006}, {0x1e008, 0x1e018},
  {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e030, 0x1e06d}, {0x1e08f, 0x1e08f}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d}, {0x1e140, 0x1e149},
  {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e4d0, 0x1e4f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe},
  {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24},
  {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49},
  {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d},
  {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e},
  {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739},
  {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 152,
        '"', 207,
        '#', 56,
        '$', 124,
        '%', 180,
        '&', 154,
        '\'', 209,
        '(', 122,
        ')', 123,
        '*', 176,
        '+', 141,
        ',', 99,
        '-', 142,
        '.', 199,
        '/', 178,
        '0', 202,
        ':', 115,
        ';', 138,
        '<', 164,
        '=', 113,
        '>', 160,
        '?', 139,
        '@', 121,
        '[', 187,
        '\\', 26,
        ']', 188,
        '^', 196,
        '`', 208,
        '{', 97,
        '|', 117,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(77);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(205);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '!', 151,
        '"', 207,
        '#', 56,
        '&', 153,
        '\'', 209,
        '(', 122,
        '+', 140,
        '-', 144,
        '.', 184,
        '/', 20,
        '0', 202,
        '?', 139,
        '[', 187,
        '^', 195,
        '`', 208,
        '{', 97,
        '~', 149,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(205);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(207);
      if (lookahead == '/') ADVANCE(214);
      if (lookahead == '\\') ADVANCE(27);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(213);
      if (lookahead != 0) ADVANCE(216);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(107);
      if (lookahead == 'd') ADVANCE(35);
      if (lookahead == 'o') ADVANCE(48);
      END_STATE();
    case 4:
      if (lookahead == '"') ADVANCE(105);
      if (lookahead == 'c') ADVANCE(29);
      END_STATE();
    case 5:
      if (lookahead == '"') ADVANCE(109);
      if (lookahead == 'c') ADVANCE(30);
      END_STATE();
    case 6:
      if (lookahead == '"') ADVANCE(110);
      END_STATE();
    case 7:
      if (lookahead == '"') ADVANCE(102);
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(106);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(111);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(104);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(108);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(103);
      END_STATE();
    case 13:
      if (lookahead == '(') ADVANCE(122);
      if (lookahead == ')') ADVANCE(123);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '.') ADVANCE(198);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead == '{') ADVANCE(97);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14);
      END_STATE();
    case 14:
      if (lookahead == '(') ADVANCE(122);
      if (lookahead == ')') ADVANCE(123);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '.') ADVANCE(182);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead == '{') ADVANCE(97);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14);
      END_STATE();
    case 15:
      if (lookahead == '(') ADVANCE(122);
      if (lookahead == ')') ADVANCE(123);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '.') ADVANCE(182);
      if (lookahead == '/') ADVANCE(20);
      if (lookahead == '{') ADVANCE(97);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(15);
      END_STATE();
    case 16:
      if (lookahead == ')') ADVANCE(229);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(16);
      END_STATE();
    case 17:
      if (lookahead == '-') ADVANCE(18);
      if (lookahead == '0') ADVANCE(202);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(205);
      END_STATE();
    case 18:
      if (lookahead == '-') ADVANCE(228);
      END_STATE();
    case 19:
      if (lookahead == '.') ADVANCE(192);
      END_STATE();
    case 20:
      if (lookahead == '/') ADVANCE(235);
      END_STATE();
    case 21:
      if (lookahead == '/') ADVANCE(218);
      if (lookahead == '`') ADVANCE(208);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(217);
      if (lookahead != 0) ADVANCE(220);
      END_STATE();
    case 22:
      if (lookahead == '/') ADVANCE(211);
      if (lookahead == '\\') ADVANCE(27);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(212);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(210);
      END_STATE();
    case 23:
      if (lookahead == '<') ADVANCE(190);
      if (lookahead == '=') ADVANCE(189);
      END_STATE();
    case 24:
      if (lookahead == '=') ADVANCE(167);
      END_STATE();
    case 25:
      if (lookahead == '=') ADVANCE(166);
      END_STATE();
    case 26:
      if (lookahead == 'U') ADVANCE(223);
      if (lookahead == 'u') ADVANCE(63);
      if (lookahead == 'x') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(222);
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == '?' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(224);
      if (lookahead != 0) ADVANCE(221);
      END_STATE();
    case 27:
      if (lookahead == 'U') ADVANCE(227);
      if (lookahead == 'u') ADVANCE(63);
      if (lookahead == 'x') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(226);
      if (lookahead != 0) ADVANCE(224);
      END_STATE();
    case 28:
      if (lookahead == 'a') ADVANCE(52);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(45);
      END_STATE();
    case 30:
      if (lookahead == 'a') ADVANCE(46);
      END_STATE();
    case 31:
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'f') ADVANCE(28);
      if (lookahead == 'n') ADVANCE(51);
      if (lookahead == 'o') ADVANCE(33);
      if (lookahead == 's') ADVANCE(57);
      END_STATE();
    case 32:
      if (lookahead == 'c') ADVANCE(41);
      END_STATE();
    case 33:
      if (lookahead == 'd') ADVANCE(40);
      END_STATE();
    case 34:
      if (lookahead == 'd') ADVANCE(4);
      END_STATE();
    case 35:
      if (lookahead == 'e') ADVANCE(32);
      END_STATE();
    case 36:
      if (lookahead == 'e') ADVANCE(6);
      END_STATE();
    case 37:
      if (lookahead == 'e') ADVANCE(62);
      END_STATE();
    case 38:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 39:
      if (lookahead == 'e') ADVANCE(53);
      END_STATE();
    case 40:
      if (lookahead == 'i') ADVANCE(50);
      END_STATE();
    case 41:
      if (lookahead == 'l') ADVANCE(8);
      END_STATE();
    case 42:
      if (lookahead == 'l') ADVANCE(39);
      END_STATE();
    case 43:
      if (lookahead == 'l') ADVANCE(10);
      END_STATE();
    case 44:
      if (lookahead == 'l') ADVANCE(11);
      END_STATE();
    case 45:
      if (lookahead == 'l') ADVANCE(43);
      END_STATE();
    case 46:
      if (lookahead == 'l') ADVANCE(44);
      END_STATE();
    case 47:
      if (lookahead == 'm') ADVANCE(9);
      END_STATE();
    case 48:
      if (lookahead == 'n') ADVANCE(59);
      END_STATE();
    case 49:
      if (lookahead == 'n') ADVANCE(36);
      END_STATE();
    case 50:
      if (lookahead == 'n') ADVANCE(7);
      END_STATE();
    case 51:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 52:
      if (lookahead == 's') ADVANCE(58);
      END_STATE();
    case 53:
      if (lookahead == 's') ADVANCE(54);
      END_STATE();
    case 54:
      if (lookahead == 's') ADVANCE(12);
      END_STATE();
    case 55:
      if (lookahead == 's') ADVANCE(61);
      END_STATE();
    case 56:
      if (lookahead == 't') ADVANCE(232);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(233);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(34);
      if (lookahead == 'y') ADVANCE(55);
      END_STATE();
    case 58:
      if (lookahead == 't') ADVANCE(5);
      END_STATE();
    case 59:
      if (lookahead == 't') ADVANCE(37);
      END_STATE();
    case 60:
      if (lookahead == 't') ADVANCE(42);
      END_STATE();
    case 61:
      if (lookahead == 't') ADVANCE(38);
      END_STATE();
    case 62:
      if (lookahead == 'x') ADVANCE(60);
      END_STATE();
    case 63:
      if (lookahead == '{') ADVANCE(69);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 64:
      if (lookahead == '}') ADVANCE(224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 65:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(203);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(204);
      END_STATE();
    case 67:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(70);
      END_STATE();
    case 68:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(224);
      END_STATE();
    case 69:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 70:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(68);
      END_STATE();
    case 71:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 72:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(71);
      END_STATE();
    case 73:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(72);
      END_STATE();
    case 74:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(73);
      END_STATE();
    case 75:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(206);
      END_STATE();
    case 76:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(233);
      END_STATE();
    case 77:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 152,
        '"', 207,
        '#', 56,
        '$', 124,
        '%', 180,
        '&', 154,
        '\'', 209,
        '(', 122,
        ')', 123,
        '*', 176,
        '+', 141,
        ',', 99,
        '-', 142,
        '.', 183,
        '/', 178,
        '0', 202,
        ':', 115,
        ';', 138,
        '<', 164,
        '=', 113,
        '>', 160,
        '?', 139,
        '@', 121,
        '[', 187,
        ']', 188,
        '^', 196,
        '`', 208,
        '{', 97,
        '|', 117,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(77);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(205);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 78:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 152,
        '"', 207,
        '#', 56,
        '%', 179,
        '&', 155,
        '\'', 209,
        '(', 122,
        '*', 175,
        '+', 140,
        ',', 99,
        '-', 143,
        '.', 185,
        '/', 177,
        '0', 202,
        ';', 138,
        '<', 165,
        '=', 25,
        '>', 161,
        '?', 139,
        '[', 187,
        '^', 195,
        '`', 208,
        '{', 97,
        '|', 118,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(78);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(205);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 79:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 152,
        '"', 207,
        '#', 76,
        '$', 124,
        '%', 179,
        '&', 155,
        '(', 122,
        ')', 123,
        '*', 175,
        '+', 140,
        ',', 99,
        '-', 146,
        '.', 183,
        '/', 177,
        ':', 115,
        ';', 138,
        '<', 165,
        '=', 113,
        '>', 161,
        '?', 139,
        '[', 187,
        ']', 188,
        '^', 195,
        '`', 208,
        '{', 97,
        '|', 118,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(79);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 80:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 152,
        '"', 207,
        '#', 76,
        '%', 180,
        '&', 154,
        '\'', 209,
        '(', 122,
        '*', 176,
        '+', 141,
        ',', 99,
        '-', 142,
        '.', 185,
        '/', 178,
        '0', 202,
        ':', 115,
        ';', 138,
        '<', 164,
        '=', 113,
        '>', 160,
        '?', 139,
        '@', 121,
        '[', 187,
        '^', 196,
        '`', 208,
        '{', 97,
        '|', 117,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(80);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(205);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 81:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 152,
        '"', 207,
        '#', 76,
        '%', 179,
        '&', 155,
        '\'', 209,
        '(', 122,
        ')', 123,
        '*', 175,
        '+', 140,
        ',', 99,
        '-', 143,
        '.', 185,
        '/', 177,
        '0', 202,
        ':', 115,
        ';', 138,
        '<', 165,
        '=', 113,
        '>', 161,
        '?', 139,
        '[', 187,
        ']', 188,
        '^', 195,
        '`', 208,
        '{', 97,
        '|', 118,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(81);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(205);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 82:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 152,
        '"', 31,
        '#', 76,
        '$', 124,
        '%', 180,
        '&', 154,
        '(', 122,
        '*', 176,
        '+', 141,
        ',', 99,
        '-', 145,
        '.', 183,
        '/', 178,
        ':', 115,
        ';', 138,
        '<', 164,
        '=', 113,
        '>', 160,
        '?', 139,
        '[', 187,
        '^', 196,
        '{', 97,
        '|', 117,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(82);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 83:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 152,
        '#', 76,
        '$', 124,
        '%', 180,
        '&', 154,
        '(', 122,
        '*', 176,
        '+', 141,
        ',', 99,
        '-', 147,
        '.', 183,
        '/', 178,
        ':', 115,
        ';', 138,
        '<', 164,
        '=', 113,
        '>', 160,
        '?', 139,
        '[', 187,
        '^', 196,
        '{', 97,
        '|', 117,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(83);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 84:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 152,
        '#', 76,
        '$', 124,
        '%', 179,
        '&', 155,
        '(', 122,
        ')', 123,
        '*', 175,
        '+', 140,
        ',', 99,
        '-', 148,
        '.', 183,
        '/', 177,
        ':', 115,
        ';', 138,
        '<', 165,
        '=', 113,
        '>', 161,
        '?', 139,
        '[', 187,
        ']', 188,
        '^', 195,
        '{', 97,
        '|', 118,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(84);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 85:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 151,
        '"', 207,
        '#', 76,
        '$', 124,
        '&', 153,
        '\'', 209,
        '(', 122,
        ')', 123,
        '+', 140,
        ',', 99,
        '-', 143,
        '.', 184,
        '/', 177,
        '0', 202,
        ':', 114,
        ';', 138,
        '=', 112,
        '?', 139,
        '@', 121,
        '[', 187,
        ']', 188,
        '^', 195,
        '`', 208,
        '{', 97,
        '|', 116,
        '}', 98,
        '~', 149,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(85);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(205);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 86:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 151,
        '"', 207,
        '#', 76,
        '$', 124,
        '\'', 209,
        '(', 122,
        ')', 123,
        ',', 99,
        '-', 17,
        '.', 19,
        '/', 177,
        '0', 202,
        ':', 114,
        ';', 138,
        '=', 112,
        '[', 187,
        ']', 188,
        '^', 195,
        '`', 208,
        '{', 97,
        '|', 116,
        '}', 98,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(86);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(205);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 87:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 24,
        '"', 207,
        '#', 76,
        '%', 180,
        '&', 154,
        '(', 122,
        ')', 123,
        '*', 176,
        '+', 141,
        ',', 99,
        '-', 145,
        '.', 200,
        '/', 178,
        ':', 115,
        ';', 138,
        '<', 164,
        '=', 113,
        '>', 160,
        '?', 139,
        '[', 187,
        ']', 188,
        '^', 196,
        '`', 208,
        '{', 97,
        '|', 117,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(88);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 88:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 24,
        '"', 207,
        '#', 76,
        '%', 180,
        '&', 154,
        '(', 122,
        ')', 123,
        '*', 176,
        '+', 141,
        ',', 99,
        '-', 145,
        '.', 186,
        '/', 178,
        ':', 115,
        ';', 138,
        '<', 164,
        '=', 113,
        '>', 160,
        '?', 139,
        '[', 187,
        ']', 188,
        '^', 196,
        '`', 208,
        '{', 97,
        '|', 117,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(88);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 89:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 24,
        '"', 207,
        '#', 76,
        '%', 179,
        '&', 155,
        '(', 122,
        ')', 123,
        '*', 175,
        '+', 140,
        ',', 99,
        '-', 146,
        '.', 200,
        '/', 177,
        ':', 115,
        ';', 138,
        '<', 165,
        '=', 113,
        '>', 161,
        '?', 139,
        '[', 187,
        ']', 188,
        '^', 195,
        '`', 208,
        '{', 97,
        '|', 118,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(90);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 90:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 24,
        '"', 207,
        '#', 76,
        '%', 179,
        '&', 155,
        '(', 122,
        ')', 123,
        '*', 175,
        '+', 140,
        ',', 99,
        '-', 146,
        '.', 186,
        '/', 177,
        ':', 115,
        ';', 138,
        '<', 165,
        '=', 113,
        '>', 161,
        '?', 139,
        '[', 187,
        ']', 188,
        '^', 195,
        '`', 208,
        '{', 97,
        '|', 118,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(90);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 91:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 24,
        '#', 76,
        '%', 180,
        '&', 154,
        '(', 122,
        '*', 176,
        '+', 141,
        ',', 99,
        '-', 145,
        '.', 186,
        '/', 178,
        ':', 115,
        ';', 138,
        '<', 164,
        '=', 113,
        '>', 160,
        '?', 139,
        '[', 187,
        '^', 196,
        '{', 97,
        '|', 117,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(91);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 92:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 24,
        '%', 180,
        '&', 154,
        '(', 122,
        '*', 176,
        '+', 141,
        ',', 99,
        '-', 147,
        '.', 200,
        '/', 178,
        ':', 115,
        ';', 138,
        '<', 164,
        '=', 113,
        '>', 160,
        '?', 139,
        '[', 187,
        '^', 196,
        '{', 97,
        '|', 117,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(93);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 93:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 24,
        '%', 180,
        '&', 154,
        '(', 122,
        '*', 176,
        '+', 141,
        ',', 99,
        '-', 147,
        '.', 186,
        '/', 178,
        ':', 115,
        ';', 138,
        '<', 164,
        '=', 113,
        '>', 160,
        '?', 139,
        '[', 187,
        '^', 196,
        '{', 97,
        '|', 117,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(93);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 94:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 24,
        '%', 179,
        '&', 155,
        '(', 122,
        ')', 123,
        '*', 175,
        '+', 140,
        ',', 99,
        '-', 148,
        '.', 200,
        '/', 177,
        ':', 115,
        ';', 138,
        '<', 165,
        '=', 113,
        '>', 161,
        '?', 139,
        '[', 187,
        ']', 188,
        '^', 195,
        '{', 97,
        '|', 118,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(95);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 95:
      if (eof) ADVANCE(96);
      ADVANCE_MAP(
        '!', 24,
        '%', 179,
        '&', 155,
        '(', 122,
        ')', 123,
        '*', 175,
        '+', 140,
        ',', 99,
        '-', 148,
        '.', 186,
        '/', 177,
        ':', 115,
        ';', 138,
        '<', 165,
        '=', 113,
        '>', 161,
        '?', 139,
        '[', 187,
        ']', 188,
        '^', 195,
        '{', 97,
        '|', 118,
        '}', 98,
        '~', 150,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(95);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(234);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_DQUOTEodin_DQUOTE);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DQUOTEcontextless_DQUOTE);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_DQUOTEstdcall_DQUOTE);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_DQUOTEstd_DQUOTE);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_DQUOTEcdecl_DQUOTE);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_DQUOTEc_DQUOTE);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_DQUOTEfastcall_DQUOTE);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_DQUOTEfast_DQUOTE);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_DQUOTEnone_DQUOTE);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_DQUOTEsystem_DQUOTE);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(166);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(100);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(131);
      if (lookahead == '|') ADVANCE(157);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(156);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_POUNDtype);
      if (lookahead == '(') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(233);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_AMP_TILDE_EQ);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(125);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(18);
      if (lookahead == '0') ADVANCE(202);
      if (lookahead == '=') ADVANCE(126);
      if (lookahead == '>') ADVANCE(101);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(205);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(18);
      if (lookahead == '0') ADVANCE(202);
      if (lookahead == '>') ADVANCE(101);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(205);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(18);
      if (lookahead == '0') ADVANCE(202);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(205);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(18);
      if (lookahead == '=') ADVANCE(126);
      if (lookahead == '>') ADVANCE(101);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(18);
      if (lookahead == '>') ADVANCE(101);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(126);
      if (lookahead == '>') ADVANCE(101);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(101);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '=') ADVANCE(168);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(167);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(159);
      if (lookahead == '=') ADVANCE(130);
      if (lookahead == '~') ADVANCE(170);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(158);
      if (lookahead == '~') ADVANCE(169);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(135);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(136);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(162);
      if (lookahead == '>') ADVANCE(174);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(162);
      if (lookahead == '>') ADVANCE(173);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(172);
      if (lookahead == '=') ADVANCE(163);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(171);
      if (lookahead == '=') ADVANCE(163);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_TILDE_EQ);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_AMP_TILDE);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_AMP_TILDE);
      if (lookahead == '=') ADVANCE(137);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(133);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(134);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(127);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(235);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(235);
      if (lookahead == '=') ADVANCE(128);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '%') ADVANCE(181);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '%') ADVANCE(181);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_PERCENT_PERCENT);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(193);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(191);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(194);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(23);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_EQ);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_LT);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(197);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(197);
      if (lookahead == '<') ADVANCE(190);
      if (lookahead == '=') ADVANCE(189);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '<') ADVANCE(190);
      if (lookahead == '=') ADVANCE(189);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(132);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_DOT2);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_DOT2);
      if (lookahead == '.') ADVANCE(193);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_DOT2);
      if (lookahead == '.') ADVANCE(23);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'b') ADVANCE(65);
      if (lookahead == 'o') ADVANCE(66);
      if (lookahead == 'h' ||
          lookahead == 'x') ADVANCE(75);
      if (('i' <= lookahead && lookahead <= 'k')) ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(205);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(203);
      if (('i' <= lookahead && lookahead <= 'k')) ADVANCE(201);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_number);
      if (('i' <= lookahead && lookahead <= 'k')) ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(204);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym_number);
      if (('i' <= lookahead && lookahead <= 'k')) ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(205);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_number);
      if (('i' <= lookahead && lookahead <= 'k')) ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(206);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(aux_sym_character_token1);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(aux_sym_character_token1);
      if (lookahead == '/') ADVANCE(235);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(aux_sym_character_token1);
      if (lookahead == '/') ADVANCE(211);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(212);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(210);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == '/') ADVANCE(214);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(213);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(216);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == '/') ADVANCE(215);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(216);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(216);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(215);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym_string_content);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(216);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym__raw_string_content);
      if (lookahead == '/') ADVANCE(218);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(217);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(220);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym__raw_string_content);
      if (lookahead == '/') ADVANCE(219);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(220);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym__raw_string_content);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(220);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(219);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym__raw_string_content);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(220);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(225);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(aux_sym__escape_sequence_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(74);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(224);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(225);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(74);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_uninitialized);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_tag);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_tag);
      if (lookahead == '(') ADVANCE(16);
      if (lookahead == 'e') ADVANCE(120);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(233);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_tag);
      if (lookahead == '(') ADVANCE(16);
      if (lookahead == 'p') ADVANCE(230);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(233);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_tag);
      if (lookahead == '(') ADVANCE(16);
      if (lookahead == 'y') ADVANCE(231);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(233);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_tag);
      if (lookahead == '(') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(233);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_identifier);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(234);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(235);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'a', 1,
        'b', 2,
        'c', 3,
        'd', 4,
        'e', 5,
        'f', 6,
        'i', 7,
        'm', 8,
        'n', 9,
        'o', 10,
        'p', 11,
        'r', 12,
        's', 13,
        't', 14,
        'u', 15,
        'w', 16,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'u') ADVANCE(17);
      END_STATE();
    case 2:
      if (lookahead == 'i') ADVANCE(18);
      if (lookahead == 'r') ADVANCE(19);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(20);
      if (lookahead == 'o') ADVANCE(21);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(22);
      if (lookahead == 'i') ADVANCE(23);
      if (lookahead == 'o') ADVANCE(24);
      if (lookahead == 'y') ADVANCE(25);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(26);
      if (lookahead == 'n') ADVANCE(27);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(30);
      if (lookahead == 'm') ADVANCE(31);
      if (lookahead == 'n') ADVANCE(32);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(33);
      END_STATE();
    case 9:
      if (lookahead == 'i') ADVANCE(34);
      if (lookahead == 'o') ADVANCE(35);
      END_STATE();
    case 10:
      if (lookahead == 'r') ADVANCE(36);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(37);
      if (lookahead == 'r') ADVANCE(38);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(39);
      END_STATE();
    case 13:
      if (lookahead == 't') ADVANCE(40);
      if (lookahead == 'w') ADVANCE(41);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(42);
      END_STATE();
    case 15:
      if (lookahead == 'n') ADVANCE(43);
      if (lookahead == 's') ADVANCE(44);
      END_STATE();
    case 16:
      if (lookahead == 'h') ADVANCE(45);
      END_STATE();
    case 17:
      if (lookahead == 't') ADVANCE(46);
      END_STATE();
    case 18:
      if (lookahead == 't') ADVANCE(47);
      END_STATE();
    case 19:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 20:
      if (lookahead == 's') ADVANCE(49);
      END_STATE();
    case 21:
      if (lookahead == 'n') ADVANCE(50);
      END_STATE();
    case 22:
      if (lookahead == 'f') ADVANCE(51);
      END_STATE();
    case 23:
      if (lookahead == 's') ADVANCE(52);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 25:
      if (lookahead == 'n') ADVANCE(53);
      END_STATE();
    case 26:
      if (lookahead == 's') ADVANCE(54);
      END_STATE();
    case 27:
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 28:
      if (lookahead == 'l') ADVANCE(56);
      END_STATE();
    case 29:
      if (lookahead == 'r') ADVANCE(57);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 31:
      if (lookahead == 'p') ADVANCE(58);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 33:
      if (lookahead == 'p') ADVANCE(59);
      if (lookahead == 't') ADVANCE(60);
      END_STATE();
    case 34:
      if (lookahead == 'l') ADVANCE(61);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(62);
      END_STATE();
    case 36:
      if (lookahead == '_') ADVANCE(63);
      END_STATE();
    case 37:
      if (lookahead == 'c') ADVANCE(64);
      END_STATE();
    case 38:
      if (lookahead == 'o') ADVANCE(65);
      END_STATE();
    case 39:
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 40:
      if (lookahead == 'r') ADVANCE(67);
      END_STATE();
    case 41:
      if (lookahead == 'i') ADVANCE(68);
      END_STATE();
    case 42:
      if (lookahead == 'a') ADVANCE(69);
      if (lookahead == 'u') ADVANCE(70);
      END_STATE();
    case 43:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 44:
      if (lookahead == 'i') ADVANCE(72);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(73);
      END_STATE();
    case 46:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 47:
      if (lookahead == '_') ADVANCE(75);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(76);
      END_STATE();
    case 49:
      if (lookahead == 'e') ADVANCE(77);
      if (lookahead == 't') ADVANCE(78);
      END_STATE();
    case 50:
      if (lookahead == 't') ADVANCE(79);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(80);
      END_STATE();
    case 52:
      if (lookahead == 't') ADVANCE(81);
      END_STATE();
    case 53:
      if (lookahead == 'a') ADVANCE(82);
      END_STATE();
    case 54:
      if (lookahead == 'e') ADVANCE(83);
      END_STATE();
    case 55:
      if (lookahead == 'm') ADVANCE(84);
      END_STATE();
    case 56:
      if (lookahead == 'l') ADVANCE(85);
      if (lookahead == 's') ADVANCE(86);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == 'e') ADVANCE(87);
      END_STATE();
    case 58:
      if (lookahead == 'o') ADVANCE(88);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_map);
      END_STATE();
    case 60:
      if (lookahead == 'r') ADVANCE(89);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_nil);
      END_STATE();
    case 62:
      if (lookahead == '_') ADVANCE(90);
      END_STATE();
    case 63:
      if (lookahead == 'b') ADVANCE(91);
      if (lookahead == 'c') ADVANCE(92);
      if (lookahead == 'e') ADVANCE(93);
      if (lookahead == 'r') ADVANCE(94);
      END_STATE();
    case 64:
      if (lookahead == 'k') ADVANCE(95);
      END_STATE();
    case 65:
      if (lookahead == 'c') ADVANCE(96);
      END_STATE();
    case 66:
      if (lookahead == 'u') ADVANCE(97);
      END_STATE();
    case 67:
      if (lookahead == 'u') ADVANCE(98);
      END_STATE();
    case 68:
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 69:
      if (lookahead == 'n') ADVANCE(100);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(101);
      END_STATE();
    case 71:
      if (lookahead == 'o') ADVANCE(102);
      END_STATE();
    case 72:
      if (lookahead == 'n') ADVANCE(103);
      END_STATE();
    case 73:
      if (lookahead == 'n') ADVANCE(104);
      if (lookahead == 'r') ADVANCE(105);
      END_STATE();
    case 74:
      if (lookahead == '_') ADVANCE(106);
      END_STATE();
    case 75:
      if (lookahead == 'f') ADVANCE(107);
      if (lookahead == 's') ADVANCE(108);
      END_STATE();
    case 76:
      if (lookahead == 'k') ADVANCE(109);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_cast);
      END_STATE();
    case 79:
      if (lookahead == 'i') ADVANCE(110);
      END_STATE();
    case 80:
      if (lookahead == 'r') ADVANCE(111);
      END_STATE();
    case 81:
      if (lookahead == 'i') ADVANCE(112);
      END_STATE();
    case 82:
      if (lookahead == 'm') ADVANCE(113);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 85:
      if (lookahead == 't') ADVANCE(114);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(115);
      END_STATE();
    case 87:
      if (lookahead == 'i') ADVANCE(116);
      END_STATE();
    case 88:
      if (lookahead == 'r') ADVANCE(117);
      END_STATE();
    case 89:
      if (lookahead == 'i') ADVANCE(118);
      END_STATE();
    case 90:
      if (lookahead == 'i') ADVANCE(119);
      END_STATE();
    case 91:
      if (lookahead == 'r') ADVANCE(120);
      END_STATE();
    case 92:
      if (lookahead == 'o') ADVANCE(121);
      END_STATE();
    case 93:
      if (lookahead == 'l') ADVANCE(122);
      END_STATE();
    case 94:
      if (lookahead == 'e') ADVANCE(123);
      END_STATE();
    case 95:
      if (lookahead == 'a') ADVANCE(124);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_proc);
      END_STATE();
    case 97:
      if (lookahead == 'r') ADVANCE(125);
      END_STATE();
    case 98:
      if (lookahead == 'c') ADVANCE(126);
      END_STATE();
    case 99:
      if (lookahead == 'c') ADVANCE(127);
      END_STATE();
    case 100:
      if (lookahead == 's') ADVANCE(128);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 102:
      if (lookahead == 'n') ADVANCE(129);
      END_STATE();
    case 103:
      if (lookahead == 'g') ADVANCE(130);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(131);
      END_STATE();
    case 106:
      if (lookahead == 'c') ADVANCE(132);
      END_STATE();
    case 107:
      if (lookahead == 'i') ADVANCE(133);
      END_STATE();
    case 108:
      if (lookahead == 'e') ADVANCE(134);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 110:
      if (lookahead == 'n') ADVANCE(135);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_defer);
      END_STATE();
    case 112:
      if (lookahead == 'n') ADVANCE(136);
      END_STATE();
    case 113:
      if (lookahead == 'i') ADVANCE(137);
      END_STATE();
    case 114:
      if (lookahead == 'h') ADVANCE(138);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 116:
      if (lookahead == 'g') ADVANCE(139);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 118:
      if (lookahead == 'x') ADVANCE(141);
      END_STATE();
    case 119:
      if (lookahead == 'n') ADVANCE(142);
      END_STATE();
    case 120:
      if (lookahead == 'e') ADVANCE(143);
      END_STATE();
    case 121:
      if (lookahead == 'n') ADVANCE(144);
      END_STATE();
    case 122:
      if (lookahead == 's') ADVANCE(145);
      END_STATE();
    case 123:
      if (lookahead == 't') ADVANCE(146);
      END_STATE();
    case 124:
      if (lookahead == 'g') ADVANCE(147);
      END_STATE();
    case 125:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 126:
      if (lookahead == 't') ADVANCE(149);
      END_STATE();
    case 127:
      if (lookahead == 'h') ADVANCE(150);
      END_STATE();
    case 128:
      if (lookahead == 'm') ADVANCE(151);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 132:
      if (lookahead == 'a') ADVANCE(152);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 134:
      if (lookahead == 't') ADVANCE(154);
      END_STATE();
    case 135:
      if (lookahead == 'u') ADVANCE(155);
      END_STATE();
    case 136:
      if (lookahead == 'c') ADVANCE(156);
      END_STATE();
    case 137:
      if (lookahead == 'c') ADVANCE(157);
      END_STATE();
    case 138:
      if (lookahead == 'r') ADVANCE(158);
      END_STATE();
    case 139:
      if (lookahead == 'n') ADVANCE(159);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_matrix);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_not_in);
      END_STATE();
    case 143:
      if (lookahead == 'a') ADVANCE(160);
      END_STATE();
    case 144:
      if (lookahead == 't') ADVANCE(161);
      END_STATE();
    case 145:
      if (lookahead == 'e') ADVANCE(162);
      END_STATE();
    case 146:
      if (lookahead == 'u') ADVANCE(163);
      END_STATE();
    case 147:
      if (lookahead == 'e') ADVANCE(164);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 151:
      if (lookahead == 'u') ADVANCE(165);
      END_STATE();
    case 152:
      if (lookahead == 's') ADVANCE(166);
      END_STATE();
    case 153:
      if (lookahead == 'l') ADVANCE(167);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_bit_set);
      END_STATE();
    case 155:
      if (lookahead == 'e') ADVANCE(168);
      END_STATE();
    case 156:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_dynamic);
      END_STATE();
    case 158:
      if (lookahead == 'o') ADVANCE(170);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_foreign);
      END_STATE();
    case 160:
      if (lookahead == 'k') ADVANCE(171);
      END_STATE();
    case 161:
      if (lookahead == 'i') ADVANCE(172);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_or_else);
      END_STATE();
    case 163:
      if (lookahead == 'r') ADVANCE(173);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_package);
      END_STATE();
    case 165:
      if (lookahead == 't') ADVANCE(174);
      END_STATE();
    case 166:
      if (lookahead == 't') ADVANCE(175);
      END_STATE();
    case 167:
      if (lookahead == 'd') ADVANCE(176);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_distinct);
      END_STATE();
    case 170:
      if (lookahead == 'u') ADVANCE(177);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_or_break);
      END_STATE();
    case 172:
      if (lookahead == 'n') ADVANCE(178);
      END_STATE();
    case 173:
      if (lookahead == 'n') ADVANCE(179);
      END_STATE();
    case 174:
      if (lookahead == 'e') ADVANCE(180);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_auto_cast);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_bit_field);
      END_STATE();
    case 177:
      if (lookahead == 'g') ADVANCE(181);
      END_STATE();
    case 178:
      if (lookahead == 'u') ADVANCE(182);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_or_return);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_transmute);
      END_STATE();
    case 181:
      if (lookahead == 'h') ADVANCE(183);
      END_STATE();
    case 182:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_fallthrough_statement);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_or_continue);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 85, .external_lex_state = 2},
  [2] = {.lex_state = 80, .external_lex_state = 2},
  [3] = {.lex_state = 80, .external_lex_state = 2},
  [4] = {.lex_state = 80, .external_lex_state = 2},
  [5] = {.lex_state = 80, .external_lex_state = 2},
  [6] = {.lex_state = 80, .external_lex_state = 2},
  [7] = {.lex_state = 80, .external_lex_state = 2},
  [8] = {.lex_state = 80, .external_lex_state = 2},
  [9] = {.lex_state = 80, .external_lex_state = 2},
  [10] = {.lex_state = 80, .external_lex_state = 2},
  [11] = {.lex_state = 80, .external_lex_state = 2},
  [12] = {.lex_state = 80, .external_lex_state = 2},
  [13] = {.lex_state = 80, .external_lex_state = 2},
  [14] = {.lex_state = 80, .external_lex_state = 2},
  [15] = {.lex_state = 80, .external_lex_state = 2},
  [16] = {.lex_state = 80, .external_lex_state = 2},
  [17] = {.lex_state = 80, .external_lex_state = 2},
  [18] = {.lex_state = 80, .external_lex_state = 2},
  [19] = {.lex_state = 80, .external_lex_state = 2},
  [20] = {.lex_state = 80, .external_lex_state = 2},
  [21] = {.lex_state = 80, .external_lex_state = 2},
  [22] = {.lex_state = 80, .external_lex_state = 2},
  [23] = {.lex_state = 80, .external_lex_state = 2},
  [24] = {.lex_state = 80, .external_lex_state = 3},
  [25] = {.lex_state = 80, .external_lex_state = 3},
  [26] = {.lex_state = 80, .external_lex_state = 3},
  [27] = {.lex_state = 80, .external_lex_state = 3},
  [28] = {.lex_state = 80, .external_lex_state = 3},
  [29] = {.lex_state = 80, .external_lex_state = 3},
  [30] = {.lex_state = 80, .external_lex_state = 3},
  [31] = {.lex_state = 80, .external_lex_state = 2},
  [32] = {.lex_state = 80, .external_lex_state = 2},
  [33] = {.lex_state = 80, .external_lex_state = 2},
  [34] = {.lex_state = 80, .external_lex_state = 2},
  [35] = {.lex_state = 80, .external_lex_state = 2},
  [36] = {.lex_state = 80, .external_lex_state = 2},
  [37] = {.lex_state = 80, .external_lex_state = 2},
  [38] = {.lex_state = 80, .external_lex_state = 2},
  [39] = {.lex_state = 80, .external_lex_state = 2},
  [40] = {.lex_state = 85, .external_lex_state = 3},
  [41] = {.lex_state = 80, .external_lex_state = 2},
  [42] = {.lex_state = 80, .external_lex_state = 2},
  [43] = {.lex_state = 85, .external_lex_state = 2},
  [44] = {.lex_state = 85, .external_lex_state = 2},
  [45] = {.lex_state = 85, .external_lex_state = 2},
  [46] = {.lex_state = 85, .external_lex_state = 2},
  [47] = {.lex_state = 85, .external_lex_state = 2},
  [48] = {.lex_state = 85, .external_lex_state = 2},
  [49] = {.lex_state = 85, .external_lex_state = 2},
  [50] = {.lex_state = 85, .external_lex_state = 2},
  [51] = {.lex_state = 85, .external_lex_state = 2},
  [52] = {.lex_state = 85, .external_lex_state = 2},
  [53] = {.lex_state = 85, .external_lex_state = 2},
  [54] = {.lex_state = 85, .external_lex_state = 2},
  [55] = {.lex_state = 85, .external_lex_state = 2},
  [56] = {.lex_state = 85, .external_lex_state = 2},
  [57] = {.lex_state = 85, .external_lex_state = 2},
  [58] = {.lex_state = 85, .external_lex_state = 2},
  [59] = {.lex_state = 85, .external_lex_state = 2},
  [60] = {.lex_state = 85, .external_lex_state = 2},
  [61] = {.lex_state = 85, .external_lex_state = 2},
  [62] = {.lex_state = 85, .external_lex_state = 2},
  [63] = {.lex_state = 85, .external_lex_state = 2},
  [64] = {.lex_state = 85, .external_lex_state = 2},
  [65] = {.lex_state = 85, .external_lex_state = 2},
  [66] = {.lex_state = 85, .external_lex_state = 2},
  [67] = {.lex_state = 85, .external_lex_state = 2},
  [68] = {.lex_state = 85, .external_lex_state = 2},
  [69] = {.lex_state = 85, .external_lex_state = 2},
  [70] = {.lex_state = 85, .external_lex_state = 2},
  [71] = {.lex_state = 85, .external_lex_state = 2},
  [72] = {.lex_state = 85, .external_lex_state = 2},
  [73] = {.lex_state = 85, .external_lex_state = 2},
  [74] = {.lex_state = 85, .external_lex_state = 2},
  [75] = {.lex_state = 85, .external_lex_state = 2},
  [76] = {.lex_state = 85, .external_lex_state = 2},
  [77] = {.lex_state = 85, .external_lex_state = 2},
  [78] = {.lex_state = 85, .external_lex_state = 2},
  [79] = {.lex_state = 85, .external_lex_state = 2},
  [80] = {.lex_state = 85, .external_lex_state = 2},
  [81] = {.lex_state = 85, .external_lex_state = 2},
  [82] = {.lex_state = 85, .external_lex_state = 2},
  [83] = {.lex_state = 81, .external_lex_state = 2},
  [84] = {.lex_state = 85, .external_lex_state = 2},
  [85] = {.lex_state = 85, .external_lex_state = 2},
  [86] = {.lex_state = 85, .external_lex_state = 2},
  [87] = {.lex_state = 85, .external_lex_state = 2},
  [88] = {.lex_state = 85, .external_lex_state = 2},
  [89] = {.lex_state = 85, .external_lex_state = 2},
  [90] = {.lex_state = 81, .external_lex_state = 2},
  [91] = {.lex_state = 85, .external_lex_state = 2},
  [92] = {.lex_state = 85, .external_lex_state = 2},
  [93] = {.lex_state = 85, .external_lex_state = 2},
  [94] = {.lex_state = 85, .external_lex_state = 2},
  [95] = {.lex_state = 85, .external_lex_state = 2},
  [96] = {.lex_state = 85, .external_lex_state = 2},
  [97] = {.lex_state = 85, .external_lex_state = 2},
  [98] = {.lex_state = 85, .external_lex_state = 2},
  [99] = {.lex_state = 81, .external_lex_state = 3},
  [100] = {.lex_state = 81, .external_lex_state = 3},
  [101] = {.lex_state = 85, .external_lex_state = 2},
  [102] = {.lex_state = 85, .external_lex_state = 2},
  [103] = {.lex_state = 85, .external_lex_state = 2},
  [104] = {.lex_state = 85, .external_lex_state = 2},
  [105] = {.lex_state = 85, .external_lex_state = 2},
  [106] = {.lex_state = 85, .external_lex_state = 2},
  [107] = {.lex_state = 85, .external_lex_state = 2},
  [108] = {.lex_state = 85, .external_lex_state = 2},
  [109] = {.lex_state = 85, .external_lex_state = 2},
  [110] = {.lex_state = 85, .external_lex_state = 2},
  [111] = {.lex_state = 85, .external_lex_state = 2},
  [112] = {.lex_state = 85, .external_lex_state = 2},
  [113] = {.lex_state = 85, .external_lex_state = 2},
  [114] = {.lex_state = 85, .external_lex_state = 2},
  [115] = {.lex_state = 85, .external_lex_state = 2},
  [116] = {.lex_state = 85, .external_lex_state = 2},
  [117] = {.lex_state = 85, .external_lex_state = 2},
  [118] = {.lex_state = 85, .external_lex_state = 2},
  [119] = {.lex_state = 85, .external_lex_state = 2},
  [120] = {.lex_state = 85, .external_lex_state = 2},
  [121] = {.lex_state = 85, .external_lex_state = 2},
  [122] = {.lex_state = 85, .external_lex_state = 2},
  [123] = {.lex_state = 78, .external_lex_state = 3},
  [124] = {.lex_state = 78, .external_lex_state = 3},
  [125] = {.lex_state = 81, .external_lex_state = 2},
  [126] = {.lex_state = 81, .external_lex_state = 1},
  [127] = {.lex_state = 81, .external_lex_state = 3},
  [128] = {.lex_state = 81, .external_lex_state = 3},
  [129] = {.lex_state = 81, .external_lex_state = 2},
  [130] = {.lex_state = 81, .external_lex_state = 1},
  [131] = {.lex_state = 78, .external_lex_state = 3},
  [132] = {.lex_state = 78, .external_lex_state = 3},
  [133] = {.lex_state = 81, .external_lex_state = 1},
  [134] = {.lex_state = 82, .external_lex_state = 4},
  [135] = {.lex_state = 81, .external_lex_state = 1},
  [136] = {.lex_state = 82, .external_lex_state = 4},
  [137] = {.lex_state = 82, .external_lex_state = 4},
  [138] = {.lex_state = 82, .external_lex_state = 4},
  [139] = {.lex_state = 82, .external_lex_state = 4},
  [140] = {.lex_state = 81, .external_lex_state = 1},
  [141] = {.lex_state = 81, .external_lex_state = 1},
  [142] = {.lex_state = 82, .external_lex_state = 4},
  [143] = {.lex_state = 82, .external_lex_state = 4},
  [144] = {.lex_state = 81, .external_lex_state = 3},
  [145] = {.lex_state = 81, .external_lex_state = 3},
  [146] = {.lex_state = 81, .external_lex_state = 3},
  [147] = {.lex_state = 81, .external_lex_state = 3},
  [148] = {.lex_state = 81, .external_lex_state = 3},
  [149] = {.lex_state = 81, .external_lex_state = 3},
  [150] = {.lex_state = 81, .external_lex_state = 3},
  [151] = {.lex_state = 83, .external_lex_state = 4},
  [152] = {.lex_state = 83, .external_lex_state = 4},
  [153] = {.lex_state = 83, .external_lex_state = 4},
  [154] = {.lex_state = 81, .external_lex_state = 2},
  [155] = {.lex_state = 83, .external_lex_state = 4},
  [156] = {.lex_state = 83, .external_lex_state = 4},
  [157] = {.lex_state = 81, .external_lex_state = 2},
  [158] = {.lex_state = 81, .external_lex_state = 2},
  [159] = {.lex_state = 83, .external_lex_state = 4},
  [160] = {.lex_state = 83, .external_lex_state = 4},
  [161] = {.lex_state = 83, .external_lex_state = 5},
  [162] = {.lex_state = 83, .external_lex_state = 5},
  [163] = {.lex_state = 83, .external_lex_state = 5},
  [164] = {.lex_state = 83, .external_lex_state = 5},
  [165] = {.lex_state = 83, .external_lex_state = 5},
  [166] = {.lex_state = 81, .external_lex_state = 2},
  [167] = {.lex_state = 83, .external_lex_state = 5},
  [168] = {.lex_state = 83, .external_lex_state = 5},
  [169] = {.lex_state = 81, .external_lex_state = 2},
  [170] = {.lex_state = 82, .external_lex_state = 6},
  [171] = {.lex_state = 82, .external_lex_state = 6},
  [172] = {.lex_state = 81, .external_lex_state = 2},
  [173] = {.lex_state = 81, .external_lex_state = 2},
  [174] = {.lex_state = 82, .external_lex_state = 6},
  [175] = {.lex_state = 81, .external_lex_state = 2},
  [176] = {.lex_state = 81, .external_lex_state = 2},
  [177] = {.lex_state = 82, .external_lex_state = 6},
  [178] = {.lex_state = 82, .external_lex_state = 6},
  [179] = {.lex_state = 82, .external_lex_state = 6},
  [180] = {.lex_state = 82, .external_lex_state = 6},
  [181] = {.lex_state = 81, .external_lex_state = 2},
  [182] = {.lex_state = 81, .external_lex_state = 2},
  [183] = {.lex_state = 83, .external_lex_state = 6},
  [184] = {.lex_state = 83, .external_lex_state = 6},
  [185] = {.lex_state = 83, .external_lex_state = 6},
  [186] = {.lex_state = 83, .external_lex_state = 6},
  [187] = {.lex_state = 81, .external_lex_state = 2},
  [188] = {.lex_state = 81, .external_lex_state = 2},
  [189] = {.lex_state = 83, .external_lex_state = 6},
  [190] = {.lex_state = 81, .external_lex_state = 2},
  [191] = {.lex_state = 83, .external_lex_state = 6},
  [192] = {.lex_state = 83, .external_lex_state = 6},
  [193] = {.lex_state = 81, .external_lex_state = 2},
  [194] = {.lex_state = 81, .external_lex_state = 2},
  [195] = {.lex_state = 81, .external_lex_state = 2},
  [196] = {.lex_state = 81, .external_lex_state = 2},
  [197] = {.lex_state = 83, .external_lex_state = 7},
  [198] = {.lex_state = 83, .external_lex_state = 7},
  [199] = {.lex_state = 81, .external_lex_state = 2},
  [200] = {.lex_state = 81, .external_lex_state = 2},
  [201] = {.lex_state = 81, .external_lex_state = 2},
  [202] = {.lex_state = 81, .external_lex_state = 2},
  [203] = {.lex_state = 83, .external_lex_state = 7},
  [204] = {.lex_state = 83, .external_lex_state = 7},
  [205] = {.lex_state = 83, .external_lex_state = 7},
  [206] = {.lex_state = 83, .external_lex_state = 7},
  [207] = {.lex_state = 83, .external_lex_state = 7},
  [208] = {.lex_state = 85, .external_lex_state = 2},
  [209] = {.lex_state = 85, .external_lex_state = 2},
  [210] = {.lex_state = 79, .external_lex_state = 6},
  [211] = {.lex_state = 79, .external_lex_state = 4},
  [212] = {.lex_state = 79, .external_lex_state = 6},
  [213] = {.lex_state = 79, .external_lex_state = 4},
  [214] = {.lex_state = 79, .external_lex_state = 4},
  [215] = {.lex_state = 79, .external_lex_state = 4},
  [216] = {.lex_state = 79, .external_lex_state = 6},
  [217] = {.lex_state = 79, .external_lex_state = 6},
  [218] = {.lex_state = 79, .external_lex_state = 6},
  [219] = {.lex_state = 79, .external_lex_state = 6},
  [220] = {.lex_state = 79, .external_lex_state = 4},
  [221] = {.lex_state = 79, .external_lex_state = 4},
  [222] = {.lex_state = 79, .external_lex_state = 6},
  [223] = {.lex_state = 79, .external_lex_state = 4},
  [224] = {.lex_state = 79, .external_lex_state = 8},
  [225] = {.lex_state = 79, .external_lex_state = 8},
  [226] = {.lex_state = 84, .external_lex_state = 6},
  [227] = {.lex_state = 84, .external_lex_state = 6},
  [228] = {.lex_state = 84, .external_lex_state = 6},
  [229] = {.lex_state = 84, .external_lex_state = 6},
  [230] = {.lex_state = 79, .external_lex_state = 8},
  [231] = {.lex_state = 79, .external_lex_state = 8},
  [232] = {.lex_state = 84, .external_lex_state = 6},
  [233] = {.lex_state = 79, .external_lex_state = 8},
  [234] = {.lex_state = 79, .external_lex_state = 8},
  [235] = {.lex_state = 84, .external_lex_state = 6},
  [236] = {.lex_state = 79, .external_lex_state = 8},
  [237] = {.lex_state = 84, .external_lex_state = 6},
  [238] = {.lex_state = 84, .external_lex_state = 4},
  [239] = {.lex_state = 84, .external_lex_state = 4},
  [240] = {.lex_state = 84, .external_lex_state = 4},
  [241] = {.lex_state = 84, .external_lex_state = 4},
  [242] = {.lex_state = 84, .external_lex_state = 4},
  [243] = {.lex_state = 84, .external_lex_state = 4},
  [244] = {.lex_state = 84, .external_lex_state = 4},
  [245] = {.lex_state = 84, .external_lex_state = 7},
  [246] = {.lex_state = 84, .external_lex_state = 7},
  [247] = {.lex_state = 84, .external_lex_state = 5},
  [248] = {.lex_state = 84, .external_lex_state = 7},
  [249] = {.lex_state = 84, .external_lex_state = 5},
  [250] = {.lex_state = 84, .external_lex_state = 5},
  [251] = {.lex_state = 84, .external_lex_state = 7},
  [252] = {.lex_state = 84, .external_lex_state = 5},
  [253] = {.lex_state = 84, .external_lex_state = 7},
  [254] = {.lex_state = 84, .external_lex_state = 7},
  [255] = {.lex_state = 84, .external_lex_state = 7},
  [256] = {.lex_state = 84, .external_lex_state = 5},
  [257] = {.lex_state = 84, .external_lex_state = 5},
  [258] = {.lex_state = 84, .external_lex_state = 5},
  [259] = {.lex_state = 84, .external_lex_state = 8},
  [260] = {.lex_state = 84, .external_lex_state = 8},
  [261] = {.lex_state = 84, .external_lex_state = 8},
  [262] = {.lex_state = 84, .external_lex_state = 8},
  [263] = {.lex_state = 84, .external_lex_state = 8},
  [264] = {.lex_state = 84, .external_lex_state = 8},
  [265] = {.lex_state = 84, .external_lex_state = 8},
  [266] = {.lex_state = 84, .external_lex_state = 9},
  [267] = {.lex_state = 79, .external_lex_state = 10},
  [268] = {.lex_state = 84, .external_lex_state = 9},
  [269] = {.lex_state = 79, .external_lex_state = 10},
  [270] = {.lex_state = 79, .external_lex_state = 10},
  [271] = {.lex_state = 79, .external_lex_state = 10},
  [272] = {.lex_state = 79, .external_lex_state = 10},
  [273] = {.lex_state = 79, .external_lex_state = 10},
  [274] = {.lex_state = 84, .external_lex_state = 9},
  [275] = {.lex_state = 84, .external_lex_state = 9},
  [276] = {.lex_state = 84, .external_lex_state = 9},
  [277] = {.lex_state = 84, .external_lex_state = 9},
  [278] = {.lex_state = 84, .external_lex_state = 9},
  [279] = {.lex_state = 79, .external_lex_state = 10},
  [280] = {.lex_state = 79, .external_lex_state = 6},
  [281] = {.lex_state = 79, .external_lex_state = 6},
  [282] = {.lex_state = 79, .external_lex_state = 6},
  [283] = {.lex_state = 79, .external_lex_state = 6},
  [284] = {.lex_state = 79, .external_lex_state = 6},
  [285] = {.lex_state = 79, .external_lex_state = 6},
  [286] = {.lex_state = 79, .external_lex_state = 6},
  [287] = {.lex_state = 85, .external_lex_state = 2},
  [288] = {.lex_state = 85, .external_lex_state = 2},
  [289] = {.lex_state = 1, .external_lex_state = 2},
  [290] = {.lex_state = 1, .external_lex_state = 2},
  [291] = {.lex_state = 85, .external_lex_state = 3},
  [292] = {.lex_state = 85, .external_lex_state = 3},
  [293] = {.lex_state = 85, .external_lex_state = 2},
  [294] = {.lex_state = 85, .external_lex_state = 2},
  [295] = {.lex_state = 85, .external_lex_state = 2},
  [296] = {.lex_state = 85, .external_lex_state = 3},
  [297] = {.lex_state = 85, .external_lex_state = 2},
  [298] = {.lex_state = 85, .external_lex_state = 2},
  [299] = {.lex_state = 85, .external_lex_state = 2},
  [300] = {.lex_state = 85, .external_lex_state = 2},
  [301] = {.lex_state = 85, .external_lex_state = 2},
  [302] = {.lex_state = 85, .external_lex_state = 3},
  [303] = {.lex_state = 85, .external_lex_state = 2},
  [304] = {.lex_state = 85, .external_lex_state = 2},
  [305] = {.lex_state = 85, .external_lex_state = 2},
  [306] = {.lex_state = 85, .external_lex_state = 2},
  [307] = {.lex_state = 85, .external_lex_state = 2},
  [308] = {.lex_state = 85, .external_lex_state = 2},
  [309] = {.lex_state = 85, .external_lex_state = 2},
  [310] = {.lex_state = 85, .external_lex_state = 2},
  [311] = {.lex_state = 85, .external_lex_state = 2},
  [312] = {.lex_state = 85, .external_lex_state = 2},
  [313] = {.lex_state = 85, .external_lex_state = 2},
  [314] = {.lex_state = 85, .external_lex_state = 2},
  [315] = {.lex_state = 85, .external_lex_state = 2},
  [316] = {.lex_state = 85, .external_lex_state = 2},
  [317] = {.lex_state = 85, .external_lex_state = 2},
  [318] = {.lex_state = 85, .external_lex_state = 2},
  [319] = {.lex_state = 85, .external_lex_state = 2},
  [320] = {.lex_state = 85, .external_lex_state = 2},
  [321] = {.lex_state = 85, .external_lex_state = 2},
  [322] = {.lex_state = 85, .external_lex_state = 2},
  [323] = {.lex_state = 85, .external_lex_state = 2},
  [324] = {.lex_state = 85, .external_lex_state = 2},
  [325] = {.lex_state = 85, .external_lex_state = 2},
  [326] = {.lex_state = 85, .external_lex_state = 2},
  [327] = {.lex_state = 85, .external_lex_state = 2},
  [328] = {.lex_state = 85, .external_lex_state = 2},
  [329] = {.lex_state = 85, .external_lex_state = 2},
  [330] = {.lex_state = 85, .external_lex_state = 2},
  [331] = {.lex_state = 85, .external_lex_state = 2},
  [332] = {.lex_state = 85, .external_lex_state = 2},
  [333] = {.lex_state = 85, .external_lex_state = 2},
  [334] = {.lex_state = 85, .external_lex_state = 2},
  [335] = {.lex_state = 85, .external_lex_state = 2},
  [336] = {.lex_state = 85, .external_lex_state = 2},
  [337] = {.lex_state = 85, .external_lex_state = 2},
  [338] = {.lex_state = 85, .external_lex_state = 2},
  [339] = {.lex_state = 85, .external_lex_state = 2},
  [340] = {.lex_state = 85, .external_lex_state = 2},
  [341] = {.lex_state = 85, .external_lex_state = 2},
  [342] = {.lex_state = 85, .external_lex_state = 2},
  [343] = {.lex_state = 85, .external_lex_state = 2},
  [344] = {.lex_state = 85, .external_lex_state = 2},
  [345] = {.lex_state = 85, .external_lex_state = 2},
  [346] = {.lex_state = 85, .external_lex_state = 2},
  [347] = {.lex_state = 85, .external_lex_state = 2},
  [348] = {.lex_state = 85, .external_lex_state = 2},
  [349] = {.lex_state = 85, .external_lex_state = 2},
  [350] = {.lex_state = 85, .external_lex_state = 2},
  [351] = {.lex_state = 85, .external_lex_state = 2},
  [352] = {.lex_state = 85, .external_lex_state = 2},
  [353] = {.lex_state = 85, .external_lex_state = 2},
  [354] = {.lex_state = 85, .external_lex_state = 2},
  [355] = {.lex_state = 85, .external_lex_state = 2},
  [356] = {.lex_state = 85, .external_lex_state = 2},
  [357] = {.lex_state = 85, .external_lex_state = 2},
  [358] = {.lex_state = 85, .external_lex_state = 2},
  [359] = {.lex_state = 85, .external_lex_state = 2},
  [360] = {.lex_state = 85, .external_lex_state = 2},
  [361] = {.lex_state = 85, .external_lex_state = 2},
  [362] = {.lex_state = 85, .external_lex_state = 2},
  [363] = {.lex_state = 85, .external_lex_state = 2},
  [364] = {.lex_state = 85, .external_lex_state = 2},
  [365] = {.lex_state = 85, .external_lex_state = 2},
  [366] = {.lex_state = 85, .external_lex_state = 2},
  [367] = {.lex_state = 85, .external_lex_state = 2},
  [368] = {.lex_state = 85, .external_lex_state = 2},
  [369] = {.lex_state = 85, .external_lex_state = 2},
  [370] = {.lex_state = 85, .external_lex_state = 2},
  [371] = {.lex_state = 85, .external_lex_state = 2},
  [372] = {.lex_state = 85, .external_lex_state = 2},
  [373] = {.lex_state = 85, .external_lex_state = 2},
  [374] = {.lex_state = 85, .external_lex_state = 2},
  [375] = {.lex_state = 85, .external_lex_state = 2},
  [376] = {.lex_state = 85, .external_lex_state = 2},
  [377] = {.lex_state = 85, .external_lex_state = 2},
  [378] = {.lex_state = 85, .external_lex_state = 2},
  [379] = {.lex_state = 85, .external_lex_state = 2},
  [380] = {.lex_state = 85, .external_lex_state = 2},
  [381] = {.lex_state = 85, .external_lex_state = 2},
  [382] = {.lex_state = 85, .external_lex_state = 2},
  [383] = {.lex_state = 85, .external_lex_state = 2},
  [384] = {.lex_state = 85, .external_lex_state = 2},
  [385] = {.lex_state = 85, .external_lex_state = 2},
  [386] = {.lex_state = 85, .external_lex_state = 2},
  [387] = {.lex_state = 85, .external_lex_state = 2},
  [388] = {.lex_state = 85, .external_lex_state = 2},
  [389] = {.lex_state = 85, .external_lex_state = 2},
  [390] = {.lex_state = 85, .external_lex_state = 2},
  [391] = {.lex_state = 85, .external_lex_state = 2},
  [392] = {.lex_state = 85, .external_lex_state = 2},
  [393] = {.lex_state = 85, .external_lex_state = 2},
  [394] = {.lex_state = 85, .external_lex_state = 2},
  [395] = {.lex_state = 85, .external_lex_state = 2},
  [396] = {.lex_state = 85, .external_lex_state = 2},
  [397] = {.lex_state = 85, .external_lex_state = 2},
  [398] = {.lex_state = 85, .external_lex_state = 2},
  [399] = {.lex_state = 85, .external_lex_state = 2},
  [400] = {.lex_state = 85, .external_lex_state = 2},
  [401] = {.lex_state = 85, .external_lex_state = 2},
  [402] = {.lex_state = 85, .external_lex_state = 2},
  [403] = {.lex_state = 85, .external_lex_state = 2},
  [404] = {.lex_state = 85, .external_lex_state = 2},
  [405] = {.lex_state = 85, .external_lex_state = 2},
  [406] = {.lex_state = 85, .external_lex_state = 2},
  [407] = {.lex_state = 85, .external_lex_state = 2},
  [408] = {.lex_state = 85, .external_lex_state = 2},
  [409] = {.lex_state = 85, .external_lex_state = 2},
  [410] = {.lex_state = 85, .external_lex_state = 2},
  [411] = {.lex_state = 85, .external_lex_state = 2},
  [412] = {.lex_state = 85, .external_lex_state = 2},
  [413] = {.lex_state = 85, .external_lex_state = 2},
  [414] = {.lex_state = 85, .external_lex_state = 2},
  [415] = {.lex_state = 85, .external_lex_state = 2},
  [416] = {.lex_state = 85, .external_lex_state = 2},
  [417] = {.lex_state = 85, .external_lex_state = 2},
  [418] = {.lex_state = 85, .external_lex_state = 2},
  [419] = {.lex_state = 85, .external_lex_state = 2},
  [420] = {.lex_state = 85, .external_lex_state = 2},
  [421] = {.lex_state = 85, .external_lex_state = 2},
  [422] = {.lex_state = 85, .external_lex_state = 2},
  [423] = {.lex_state = 85, .external_lex_state = 2},
  [424] = {.lex_state = 85, .external_lex_state = 2},
  [425] = {.lex_state = 85, .external_lex_state = 2},
  [426] = {.lex_state = 85, .external_lex_state = 2},
  [427] = {.lex_state = 85, .external_lex_state = 2},
  [428] = {.lex_state = 85, .external_lex_state = 2},
  [429] = {.lex_state = 85, .external_lex_state = 2},
  [430] = {.lex_state = 85, .external_lex_state = 2},
  [431] = {.lex_state = 85, .external_lex_state = 2},
  [432] = {.lex_state = 85, .external_lex_state = 2},
  [433] = {.lex_state = 85, .external_lex_state = 2},
  [434] = {.lex_state = 85, .external_lex_state = 2},
  [435] = {.lex_state = 85, .external_lex_state = 2},
  [436] = {.lex_state = 85, .external_lex_state = 2},
  [437] = {.lex_state = 85, .external_lex_state = 2},
  [438] = {.lex_state = 85, .external_lex_state = 2},
  [439] = {.lex_state = 85, .external_lex_state = 2},
  [440] = {.lex_state = 85, .external_lex_state = 2},
  [441] = {.lex_state = 85, .external_lex_state = 2},
  [442] = {.lex_state = 85, .external_lex_state = 2},
  [443] = {.lex_state = 85, .external_lex_state = 2},
  [444] = {.lex_state = 85, .external_lex_state = 2},
  [445] = {.lex_state = 85, .external_lex_state = 2},
  [446] = {.lex_state = 85, .external_lex_state = 2},
  [447] = {.lex_state = 85, .external_lex_state = 2},
  [448] = {.lex_state = 85, .external_lex_state = 2},
  [449] = {.lex_state = 85, .external_lex_state = 2},
  [450] = {.lex_state = 85, .external_lex_state = 2},
  [451] = {.lex_state = 85, .external_lex_state = 2},
  [452] = {.lex_state = 85, .external_lex_state = 2},
  [453] = {.lex_state = 85, .external_lex_state = 2},
  [454] = {.lex_state = 85, .external_lex_state = 2},
  [455] = {.lex_state = 85, .external_lex_state = 2},
  [456] = {.lex_state = 85, .external_lex_state = 2},
  [457] = {.lex_state = 85, .external_lex_state = 2},
  [458] = {.lex_state = 85, .external_lex_state = 2},
  [459] = {.lex_state = 85, .external_lex_state = 2},
  [460] = {.lex_state = 85, .external_lex_state = 2},
  [461] = {.lex_state = 85, .external_lex_state = 2},
  [462] = {.lex_state = 85, .external_lex_state = 2},
  [463] = {.lex_state = 85, .external_lex_state = 2},
  [464] = {.lex_state = 85, .external_lex_state = 2},
  [465] = {.lex_state = 85, .external_lex_state = 2},
  [466] = {.lex_state = 85, .external_lex_state = 2},
  [467] = {.lex_state = 85, .external_lex_state = 2},
  [468] = {.lex_state = 85, .external_lex_state = 2},
  [469] = {.lex_state = 85, .external_lex_state = 2},
  [470] = {.lex_state = 85, .external_lex_state = 2},
  [471] = {.lex_state = 85, .external_lex_state = 2},
  [472] = {.lex_state = 85, .external_lex_state = 2},
  [473] = {.lex_state = 85, .external_lex_state = 2},
  [474] = {.lex_state = 85, .external_lex_state = 2},
  [475] = {.lex_state = 85, .external_lex_state = 2},
  [476] = {.lex_state = 85, .external_lex_state = 2},
  [477] = {.lex_state = 85, .external_lex_state = 2},
  [478] = {.lex_state = 85, .external_lex_state = 2},
  [479] = {.lex_state = 85, .external_lex_state = 2},
  [480] = {.lex_state = 85, .external_lex_state = 2},
  [481] = {.lex_state = 85, .external_lex_state = 2},
  [482] = {.lex_state = 85, .external_lex_state = 2},
  [483] = {.lex_state = 85, .external_lex_state = 2},
  [484] = {.lex_state = 85, .external_lex_state = 2},
  [485] = {.lex_state = 85, .external_lex_state = 2},
  [486] = {.lex_state = 85, .external_lex_state = 2},
  [487] = {.lex_state = 85, .external_lex_state = 2},
  [488] = {.lex_state = 85, .external_lex_state = 2},
  [489] = {.lex_state = 85, .external_lex_state = 2},
  [490] = {.lex_state = 85, .external_lex_state = 2},
  [491] = {.lex_state = 85, .external_lex_state = 2},
  [492] = {.lex_state = 85, .external_lex_state = 2},
  [493] = {.lex_state = 85, .external_lex_state = 2},
  [494] = {.lex_state = 85, .external_lex_state = 2},
  [495] = {.lex_state = 85, .external_lex_state = 2},
  [496] = {.lex_state = 85, .external_lex_state = 2},
  [497] = {.lex_state = 85, .external_lex_state = 2},
  [498] = {.lex_state = 85, .external_lex_state = 2},
  [499] = {.lex_state = 85, .external_lex_state = 2},
  [500] = {.lex_state = 85, .external_lex_state = 2},
  [501] = {.lex_state = 85, .external_lex_state = 2},
  [502] = {.lex_state = 85, .external_lex_state = 2},
  [503] = {.lex_state = 85, .external_lex_state = 2},
  [504] = {.lex_state = 85, .external_lex_state = 2},
  [505] = {.lex_state = 85, .external_lex_state = 2},
  [506] = {.lex_state = 85, .external_lex_state = 2},
  [507] = {.lex_state = 85, .external_lex_state = 2},
  [508] = {.lex_state = 85, .external_lex_state = 2},
  [509] = {.lex_state = 85, .external_lex_state = 2},
  [510] = {.lex_state = 85, .external_lex_state = 2},
  [511] = {.lex_state = 85, .external_lex_state = 2},
  [512] = {.lex_state = 85, .external_lex_state = 2},
  [513] = {.lex_state = 85, .external_lex_state = 2},
  [514] = {.lex_state = 85, .external_lex_state = 2},
  [515] = {.lex_state = 85, .external_lex_state = 2},
  [516] = {.lex_state = 85, .external_lex_state = 2},
  [517] = {.lex_state = 85, .external_lex_state = 2},
  [518] = {.lex_state = 85, .external_lex_state = 2},
  [519] = {.lex_state = 85, .external_lex_state = 2},
  [520] = {.lex_state = 85, .external_lex_state = 2},
  [521] = {.lex_state = 85, .external_lex_state = 2},
  [522] = {.lex_state = 85, .external_lex_state = 3},
  [523] = {.lex_state = 85, .external_lex_state = 3},
  [524] = {.lex_state = 85, .external_lex_state = 3},
  [525] = {.lex_state = 85, .external_lex_state = 3},
  [526] = {.lex_state = 1, .external_lex_state = 2},
  [527] = {.lex_state = 85, .external_lex_state = 2},
  [528] = {.lex_state = 85, .external_lex_state = 2},
  [529] = {.lex_state = 85, .external_lex_state = 2},
  [530] = {.lex_state = 1, .external_lex_state = 2},
  [531] = {.lex_state = 1, .external_lex_state = 2},
  [532] = {.lex_state = 85, .external_lex_state = 2},
  [533] = {.lex_state = 85, .external_lex_state = 2},
  [534] = {.lex_state = 91, .external_lex_state = 4},
  [535] = {.lex_state = 85, .external_lex_state = 2},
  [536] = {.lex_state = 85, .external_lex_state = 2},
  [537] = {.lex_state = 85, .external_lex_state = 2},
  [538] = {.lex_state = 85, .external_lex_state = 2},
  [539] = {.lex_state = 85, .external_lex_state = 2},
  [540] = {.lex_state = 85, .external_lex_state = 2},
  [541] = {.lex_state = 85, .external_lex_state = 2},
  [542] = {.lex_state = 85, .external_lex_state = 2},
  [543] = {.lex_state = 85, .external_lex_state = 2},
  [544] = {.lex_state = 85, .external_lex_state = 2},
  [545] = {.lex_state = 85, .external_lex_state = 2},
  [546] = {.lex_state = 85, .external_lex_state = 2},
  [547] = {.lex_state = 85, .external_lex_state = 2},
  [548] = {.lex_state = 85, .external_lex_state = 2},
  [549] = {.lex_state = 85, .external_lex_state = 2},
  [550] = {.lex_state = 85, .external_lex_state = 2},
  [551] = {.lex_state = 85, .external_lex_state = 2},
  [552] = {.lex_state = 85, .external_lex_state = 2},
  [553] = {.lex_state = 85, .external_lex_state = 2},
  [554] = {.lex_state = 85, .external_lex_state = 2},
  [555] = {.lex_state = 85, .external_lex_state = 2},
  [556] = {.lex_state = 85, .external_lex_state = 2},
  [557] = {.lex_state = 85, .external_lex_state = 2},
  [558] = {.lex_state = 85, .external_lex_state = 2},
  [559] = {.lex_state = 91, .external_lex_state = 4},
  [560] = {.lex_state = 85, .external_lex_state = 2},
  [561] = {.lex_state = 85, .external_lex_state = 2},
  [562] = {.lex_state = 85, .external_lex_state = 2},
  [563] = {.lex_state = 85, .external_lex_state = 2},
  [564] = {.lex_state = 85, .external_lex_state = 2},
  [565] = {.lex_state = 85, .external_lex_state = 2},
  [566] = {.lex_state = 85, .external_lex_state = 2},
  [567] = {.lex_state = 85, .external_lex_state = 2},
  [568] = {.lex_state = 85, .external_lex_state = 2},
  [569] = {.lex_state = 85, .external_lex_state = 2},
  [570] = {.lex_state = 91, .external_lex_state = 4},
  [571] = {.lex_state = 85, .external_lex_state = 2},
  [572] = {.lex_state = 85, .external_lex_state = 2},
  [573] = {.lex_state = 85, .external_lex_state = 2},
  [574] = {.lex_state = 85, .external_lex_state = 2},
  [575] = {.lex_state = 85, .external_lex_state = 2},
  [576] = {.lex_state = 85, .external_lex_state = 2},
  [577] = {.lex_state = 85, .external_lex_state = 2},
  [578] = {.lex_state = 85, .external_lex_state = 2},
  [579] = {.lex_state = 85, .external_lex_state = 2},
  [580] = {.lex_state = 85, .external_lex_state = 2},
  [581] = {.lex_state = 85, .external_lex_state = 2},
  [582] = {.lex_state = 85, .external_lex_state = 2},
  [583] = {.lex_state = 85, .external_lex_state = 2},
  [584] = {.lex_state = 85, .external_lex_state = 2},
  [585] = {.lex_state = 85, .external_lex_state = 2},
  [586] = {.lex_state = 85, .external_lex_state = 2},
  [587] = {.lex_state = 85, .external_lex_state = 2},
  [588] = {.lex_state = 85, .external_lex_state = 2},
  [589] = {.lex_state = 85, .external_lex_state = 2},
  [590] = {.lex_state = 85, .external_lex_state = 2},
  [591] = {.lex_state = 85, .external_lex_state = 2},
  [592] = {.lex_state = 85, .external_lex_state = 2},
  [593] = {.lex_state = 85, .external_lex_state = 2},
  [594] = {.lex_state = 85, .external_lex_state = 2},
  [595] = {.lex_state = 91, .external_lex_state = 4},
  [596] = {.lex_state = 91, .external_lex_state = 4},
  [597] = {.lex_state = 91, .external_lex_state = 4},
  [598] = {.lex_state = 85, .external_lex_state = 2},
  [599] = {.lex_state = 85, .external_lex_state = 2},
  [600] = {.lex_state = 85, .external_lex_state = 2},
  [601] = {.lex_state = 85, .external_lex_state = 2},
  [602] = {.lex_state = 85, .external_lex_state = 2},
  [603] = {.lex_state = 91, .external_lex_state = 4},
  [604] = {.lex_state = 91, .external_lex_state = 4},
  [605] = {.lex_state = 85, .external_lex_state = 2},
  [606] = {.lex_state = 91, .external_lex_state = 4},
  [607] = {.lex_state = 85, .external_lex_state = 2},
  [608] = {.lex_state = 91, .external_lex_state = 4},
  [609] = {.lex_state = 85, .external_lex_state = 2},
  [610] = {.lex_state = 85, .external_lex_state = 2},
  [611] = {.lex_state = 91, .external_lex_state = 4},
  [612] = {.lex_state = 85, .external_lex_state = 2},
  [613] = {.lex_state = 85, .external_lex_state = 2},
  [614] = {.lex_state = 85, .external_lex_state = 2},
  [615] = {.lex_state = 91, .external_lex_state = 4},
  [616] = {.lex_state = 91, .external_lex_state = 4},
  [617] = {.lex_state = 87, .external_lex_state = 4},
  [618] = {.lex_state = 85, .external_lex_state = 2},
  [619] = {.lex_state = 91, .external_lex_state = 4},
  [620] = {.lex_state = 91, .external_lex_state = 4},
  [621] = {.lex_state = 91, .external_lex_state = 4},
  [622] = {.lex_state = 91, .external_lex_state = 4},
  [623] = {.lex_state = 91, .external_lex_state = 4},
  [624] = {.lex_state = 85, .external_lex_state = 2},
  [625] = {.lex_state = 91, .external_lex_state = 4},
  [626] = {.lex_state = 85, .external_lex_state = 2},
  [627] = {.lex_state = 85, .external_lex_state = 2},
  [628] = {.lex_state = 85, .external_lex_state = 2},
  [629] = {.lex_state = 91, .external_lex_state = 4},
  [630] = {.lex_state = 85, .external_lex_state = 2},
  [631] = {.lex_state = 87, .external_lex_state = 4},
  [632] = {.lex_state = 85, .external_lex_state = 2},
  [633] = {.lex_state = 85, .external_lex_state = 2},
  [634] = {.lex_state = 91, .external_lex_state = 4},
  [635] = {.lex_state = 91, .external_lex_state = 4},
  [636] = {.lex_state = 91, .external_lex_state = 4},
  [637] = {.lex_state = 91, .external_lex_state = 4},
  [638] = {.lex_state = 85, .external_lex_state = 2},
  [639] = {.lex_state = 85, .external_lex_state = 2},
  [640] = {.lex_state = 91, .external_lex_state = 4},
  [641] = {.lex_state = 85, .external_lex_state = 2},
  [642] = {.lex_state = 91, .external_lex_state = 4},
  [643] = {.lex_state = 91, .external_lex_state = 4},
  [644] = {.lex_state = 85, .external_lex_state = 2},
  [645] = {.lex_state = 85, .external_lex_state = 2},
  [646] = {.lex_state = 85, .external_lex_state = 2},
  [647] = {.lex_state = 85, .external_lex_state = 2},
  [648] = {.lex_state = 91, .external_lex_state = 4},
  [649] = {.lex_state = 85, .external_lex_state = 2},
  [650] = {.lex_state = 85, .external_lex_state = 2},
  [651] = {.lex_state = 85, .external_lex_state = 2},
  [652] = {.lex_state = 91, .external_lex_state = 4},
  [653] = {.lex_state = 85, .external_lex_state = 2},
  [654] = {.lex_state = 85, .external_lex_state = 2},
  [655] = {.lex_state = 91, .external_lex_state = 4},
  [656] = {.lex_state = 85, .external_lex_state = 2},
  [657] = {.lex_state = 85, .external_lex_state = 2},
  [658] = {.lex_state = 91, .external_lex_state = 4},
  [659] = {.lex_state = 87, .external_lex_state = 4},
  [660] = {.lex_state = 85, .external_lex_state = 2},
  [661] = {.lex_state = 85, .external_lex_state = 2},
  [662] = {.lex_state = 85, .external_lex_state = 2},
  [663] = {.lex_state = 91, .external_lex_state = 4},
  [664] = {.lex_state = 87, .external_lex_state = 4},
  [665] = {.lex_state = 85, .external_lex_state = 2},
  [666] = {.lex_state = 85, .external_lex_state = 2},
  [667] = {.lex_state = 91, .external_lex_state = 4},
  [668] = {.lex_state = 85, .external_lex_state = 2},
  [669] = {.lex_state = 91, .external_lex_state = 4},
  [670] = {.lex_state = 85, .external_lex_state = 2},
  [671] = {.lex_state = 91, .external_lex_state = 4},
  [672] = {.lex_state = 87, .external_lex_state = 4},
  [673] = {.lex_state = 85, .external_lex_state = 2},
  [674] = {.lex_state = 85, .external_lex_state = 2},
  [675] = {.lex_state = 91, .external_lex_state = 4},
  [676] = {.lex_state = 85, .external_lex_state = 2},
  [677] = {.lex_state = 91, .external_lex_state = 4},
  [678] = {.lex_state = 91, .external_lex_state = 4},
  [679] = {.lex_state = 91, .external_lex_state = 4},
  [680] = {.lex_state = 85, .external_lex_state = 2},
  [681] = {.lex_state = 91, .external_lex_state = 4},
  [682] = {.lex_state = 91, .external_lex_state = 4},
  [683] = {.lex_state = 85, .external_lex_state = 2},
  [684] = {.lex_state = 91, .external_lex_state = 4},
  [685] = {.lex_state = 85, .external_lex_state = 2},
  [686] = {.lex_state = 85, .external_lex_state = 2},
  [687] = {.lex_state = 91, .external_lex_state = 4},
  [688] = {.lex_state = 91, .external_lex_state = 4},
  [689] = {.lex_state = 91, .external_lex_state = 4},
  [690] = {.lex_state = 85, .external_lex_state = 2},
  [691] = {.lex_state = 91, .external_lex_state = 4},
  [692] = {.lex_state = 85, .external_lex_state = 2},
  [693] = {.lex_state = 91, .external_lex_state = 4},
  [694] = {.lex_state = 85, .external_lex_state = 2},
  [695] = {.lex_state = 85, .external_lex_state = 2},
  [696] = {.lex_state = 91, .external_lex_state = 4},
  [697] = {.lex_state = 85, .external_lex_state = 2},
  [698] = {.lex_state = 91, .external_lex_state = 4},
  [699] = {.lex_state = 91, .external_lex_state = 4},
  [700] = {.lex_state = 85, .external_lex_state = 2},
  [701] = {.lex_state = 91, .external_lex_state = 4},
  [702] = {.lex_state = 85, .external_lex_state = 2},
  [703] = {.lex_state = 91, .external_lex_state = 4},
  [704] = {.lex_state = 85, .external_lex_state = 2},
  [705] = {.lex_state = 91, .external_lex_state = 4},
  [706] = {.lex_state = 91, .external_lex_state = 4},
  [707] = {.lex_state = 85, .external_lex_state = 2},
  [708] = {.lex_state = 85, .external_lex_state = 2},
  [709] = {.lex_state = 91, .external_lex_state = 4},
  [710] = {.lex_state = 85, .external_lex_state = 2},
  [711] = {.lex_state = 91, .external_lex_state = 4},
  [712] = {.lex_state = 85, .external_lex_state = 2},
  [713] = {.lex_state = 85, .external_lex_state = 2},
  [714] = {.lex_state = 85, .external_lex_state = 2},
  [715] = {.lex_state = 91, .external_lex_state = 4},
  [716] = {.lex_state = 85, .external_lex_state = 2},
  [717] = {.lex_state = 85, .external_lex_state = 2},
  [718] = {.lex_state = 85, .external_lex_state = 2},
  [719] = {.lex_state = 85, .external_lex_state = 2},
  [720] = {.lex_state = 85, .external_lex_state = 2},
  [721] = {.lex_state = 85, .external_lex_state = 2},
  [722] = {.lex_state = 85, .external_lex_state = 2},
  [723] = {.lex_state = 85, .external_lex_state = 2},
  [724] = {.lex_state = 91, .external_lex_state = 4},
  [725] = {.lex_state = 85, .external_lex_state = 2},
  [726] = {.lex_state = 85, .external_lex_state = 2},
  [727] = {.lex_state = 91, .external_lex_state = 4},
  [728] = {.lex_state = 91, .external_lex_state = 4},
  [729] = {.lex_state = 85, .external_lex_state = 2},
  [730] = {.lex_state = 85, .external_lex_state = 2},
  [731] = {.lex_state = 85, .external_lex_state = 2},
  [732] = {.lex_state = 85, .external_lex_state = 2},
  [733] = {.lex_state = 85, .external_lex_state = 2},
  [734] = {.lex_state = 85, .external_lex_state = 2},
  [735] = {.lex_state = 85, .external_lex_state = 2},
  [736] = {.lex_state = 85, .external_lex_state = 2},
  [737] = {.lex_state = 85, .external_lex_state = 2},
  [738] = {.lex_state = 85, .external_lex_state = 2},
  [739] = {.lex_state = 85, .external_lex_state = 2},
  [740] = {.lex_state = 85, .external_lex_state = 2},
  [741] = {.lex_state = 85, .external_lex_state = 2},
  [742] = {.lex_state = 85, .external_lex_state = 2},
  [743] = {.lex_state = 85, .external_lex_state = 2},
  [744] = {.lex_state = 85, .external_lex_state = 2},
  [745] = {.lex_state = 85, .external_lex_state = 2},
  [746] = {.lex_state = 85, .external_lex_state = 2},
  [747] = {.lex_state = 85, .external_lex_state = 2},
  [748] = {.lex_state = 85, .external_lex_state = 2},
  [749] = {.lex_state = 85, .external_lex_state = 2},
  [750] = {.lex_state = 85, .external_lex_state = 2},
  [751] = {.lex_state = 85, .external_lex_state = 2},
  [752] = {.lex_state = 85, .external_lex_state = 2},
  [753] = {.lex_state = 85, .external_lex_state = 2},
  [754] = {.lex_state = 85, .external_lex_state = 2},
  [755] = {.lex_state = 85, .external_lex_state = 2},
  [756] = {.lex_state = 85, .external_lex_state = 2},
  [757] = {.lex_state = 85, .external_lex_state = 2},
  [758] = {.lex_state = 91, .external_lex_state = 4},
  [759] = {.lex_state = 85, .external_lex_state = 2},
  [760] = {.lex_state = 85, .external_lex_state = 2},
  [761] = {.lex_state = 85, .external_lex_state = 2},
  [762] = {.lex_state = 91, .external_lex_state = 4},
  [763] = {.lex_state = 85, .external_lex_state = 2},
  [764] = {.lex_state = 85, .external_lex_state = 2},
  [765] = {.lex_state = 85, .external_lex_state = 2},
  [766] = {.lex_state = 85, .external_lex_state = 2},
  [767] = {.lex_state = 85, .external_lex_state = 2},
  [768] = {.lex_state = 85, .external_lex_state = 2},
  [769] = {.lex_state = 85, .external_lex_state = 2},
  [770] = {.lex_state = 85, .external_lex_state = 2},
  [771] = {.lex_state = 85, .external_lex_state = 2},
  [772] = {.lex_state = 85, .external_lex_state = 2},
  [773] = {.lex_state = 85, .external_lex_state = 2},
  [774] = {.lex_state = 85, .external_lex_state = 2},
  [775] = {.lex_state = 85, .external_lex_state = 2},
  [776] = {.lex_state = 85, .external_lex_state = 2},
  [777] = {.lex_state = 85, .external_lex_state = 2},
  [778] = {.lex_state = 85, .external_lex_state = 2},
  [779] = {.lex_state = 85, .external_lex_state = 2},
  [780] = {.lex_state = 85, .external_lex_state = 2},
  [781] = {.lex_state = 85, .external_lex_state = 2},
  [782] = {.lex_state = 85, .external_lex_state = 2},
  [783] = {.lex_state = 85, .external_lex_state = 2},
  [784] = {.lex_state = 85, .external_lex_state = 2},
  [785] = {.lex_state = 85, .external_lex_state = 2},
  [786] = {.lex_state = 85, .external_lex_state = 2},
  [787] = {.lex_state = 85, .external_lex_state = 2},
  [788] = {.lex_state = 85, .external_lex_state = 2},
  [789] = {.lex_state = 85, .external_lex_state = 2},
  [790] = {.lex_state = 85, .external_lex_state = 2},
  [791] = {.lex_state = 85, .external_lex_state = 2},
  [792] = {.lex_state = 91, .external_lex_state = 4},
  [793] = {.lex_state = 85, .external_lex_state = 2},
  [794] = {.lex_state = 85, .external_lex_state = 2},
  [795] = {.lex_state = 85, .external_lex_state = 2},
  [796] = {.lex_state = 91, .external_lex_state = 4},
  [797] = {.lex_state = 85, .external_lex_state = 2},
  [798] = {.lex_state = 85, .external_lex_state = 2},
  [799] = {.lex_state = 85, .external_lex_state = 2},
  [800] = {.lex_state = 85, .external_lex_state = 2},
  [801] = {.lex_state = 85, .external_lex_state = 2},
  [802] = {.lex_state = 91, .external_lex_state = 4},
  [803] = {.lex_state = 85, .external_lex_state = 2},
  [804] = {.lex_state = 85, .external_lex_state = 2},
  [805] = {.lex_state = 85, .external_lex_state = 2},
  [806] = {.lex_state = 85, .external_lex_state = 2},
  [807] = {.lex_state = 85, .external_lex_state = 2},
  [808] = {.lex_state = 85, .external_lex_state = 2},
  [809] = {.lex_state = 85, .external_lex_state = 2},
  [810] = {.lex_state = 91, .external_lex_state = 4},
  [811] = {.lex_state = 85, .external_lex_state = 2},
  [812] = {.lex_state = 85, .external_lex_state = 2},
  [813] = {.lex_state = 85, .external_lex_state = 2},
  [814] = {.lex_state = 85, .external_lex_state = 2},
  [815] = {.lex_state = 85, .external_lex_state = 2},
  [816] = {.lex_state = 91, .external_lex_state = 4},
  [817] = {.lex_state = 85, .external_lex_state = 2},
  [818] = {.lex_state = 85, .external_lex_state = 2},
  [819] = {.lex_state = 85, .external_lex_state = 2},
  [820] = {.lex_state = 85, .external_lex_state = 2},
  [821] = {.lex_state = 85, .external_lex_state = 2},
  [822] = {.lex_state = 85, .external_lex_state = 2},
  [823] = {.lex_state = 85, .external_lex_state = 2},
  [824] = {.lex_state = 85, .external_lex_state = 2},
  [825] = {.lex_state = 91, .external_lex_state = 4},
  [826] = {.lex_state = 91, .external_lex_state = 4},
  [827] = {.lex_state = 85, .external_lex_state = 2},
  [828] = {.lex_state = 85, .external_lex_state = 2},
  [829] = {.lex_state = 85, .external_lex_state = 2},
  [830] = {.lex_state = 85, .external_lex_state = 2},
  [831] = {.lex_state = 85, .external_lex_state = 2},
  [832] = {.lex_state = 85, .external_lex_state = 2},
  [833] = {.lex_state = 85, .external_lex_state = 2},
  [834] = {.lex_state = 91, .external_lex_state = 4},
  [835] = {.lex_state = 85, .external_lex_state = 2},
  [836] = {.lex_state = 85, .external_lex_state = 2},
  [837] = {.lex_state = 85, .external_lex_state = 2},
  [838] = {.lex_state = 85, .external_lex_state = 2},
  [839] = {.lex_state = 85, .external_lex_state = 2},
  [840] = {.lex_state = 85, .external_lex_state = 2},
  [841] = {.lex_state = 85, .external_lex_state = 2},
  [842] = {.lex_state = 85, .external_lex_state = 2},
  [843] = {.lex_state = 85, .external_lex_state = 2},
  [844] = {.lex_state = 85, .external_lex_state = 2},
  [845] = {.lex_state = 85, .external_lex_state = 2},
  [846] = {.lex_state = 85, .external_lex_state = 2},
  [847] = {.lex_state = 85, .external_lex_state = 2},
  [848] = {.lex_state = 91, .external_lex_state = 4},
  [849] = {.lex_state = 85, .external_lex_state = 2},
  [850] = {.lex_state = 85, .external_lex_state = 2},
  [851] = {.lex_state = 85, .external_lex_state = 2},
  [852] = {.lex_state = 85, .external_lex_state = 2},
  [853] = {.lex_state = 85, .external_lex_state = 2},
  [854] = {.lex_state = 91, .external_lex_state = 4},
  [855] = {.lex_state = 85, .external_lex_state = 2},
  [856] = {.lex_state = 85, .external_lex_state = 2},
  [857] = {.lex_state = 85, .external_lex_state = 2},
  [858] = {.lex_state = 85, .external_lex_state = 2},
  [859] = {.lex_state = 85, .external_lex_state = 2},
  [860] = {.lex_state = 91, .external_lex_state = 4},
  [861] = {.lex_state = 85, .external_lex_state = 2},
  [862] = {.lex_state = 85, .external_lex_state = 2},
  [863] = {.lex_state = 85, .external_lex_state = 2},
  [864] = {.lex_state = 85, .external_lex_state = 2},
  [865] = {.lex_state = 85, .external_lex_state = 2},
  [866] = {.lex_state = 85, .external_lex_state = 2},
  [867] = {.lex_state = 85, .external_lex_state = 2},
  [868] = {.lex_state = 85, .external_lex_state = 2},
  [869] = {.lex_state = 85, .external_lex_state = 2},
  [870] = {.lex_state = 85, .external_lex_state = 2},
  [871] = {.lex_state = 85, .external_lex_state = 2},
  [872] = {.lex_state = 85, .external_lex_state = 2},
  [873] = {.lex_state = 85, .external_lex_state = 2},
  [874] = {.lex_state = 85, .external_lex_state = 2},
  [875] = {.lex_state = 91, .external_lex_state = 4},
  [876] = {.lex_state = 85, .external_lex_state = 2},
  [877] = {.lex_state = 85, .external_lex_state = 2},
  [878] = {.lex_state = 85, .external_lex_state = 2},
  [879] = {.lex_state = 91, .external_lex_state = 4},
  [880] = {.lex_state = 85, .external_lex_state = 2},
  [881] = {.lex_state = 85, .external_lex_state = 2},
  [882] = {.lex_state = 91, .external_lex_state = 4},
  [883] = {.lex_state = 85, .external_lex_state = 2},
  [884] = {.lex_state = 85, .external_lex_state = 2},
  [885] = {.lex_state = 85, .external_lex_state = 2},
  [886] = {.lex_state = 85, .external_lex_state = 2},
  [887] = {.lex_state = 85, .external_lex_state = 2},
  [888] = {.lex_state = 85, .external_lex_state = 2},
  [889] = {.lex_state = 91, .external_lex_state = 4},
  [890] = {.lex_state = 85, .external_lex_state = 2},
  [891] = {.lex_state = 85, .external_lex_state = 2},
  [892] = {.lex_state = 85, .external_lex_state = 2},
  [893] = {.lex_state = 85, .external_lex_state = 2},
  [894] = {.lex_state = 85, .external_lex_state = 2},
  [895] = {.lex_state = 85, .external_lex_state = 2},
  [896] = {.lex_state = 91, .external_lex_state = 4},
  [897] = {.lex_state = 85, .external_lex_state = 2},
  [898] = {.lex_state = 91, .external_lex_state = 4},
  [899] = {.lex_state = 85, .external_lex_state = 2},
  [900] = {.lex_state = 85, .external_lex_state = 2},
  [901] = {.lex_state = 85, .external_lex_state = 2},
  [902] = {.lex_state = 85, .external_lex_state = 2},
  [903] = {.lex_state = 85, .external_lex_state = 2},
  [904] = {.lex_state = 85, .external_lex_state = 2},
  [905] = {.lex_state = 91, .external_lex_state = 4},
  [906] = {.lex_state = 85, .external_lex_state = 2},
  [907] = {.lex_state = 85, .external_lex_state = 2},
  [908] = {.lex_state = 85, .external_lex_state = 2},
  [909] = {.lex_state = 85, .external_lex_state = 2},
  [910] = {.lex_state = 85, .external_lex_state = 2},
  [911] = {.lex_state = 91, .external_lex_state = 4},
  [912] = {.lex_state = 85, .external_lex_state = 2},
  [913] = {.lex_state = 85, .external_lex_state = 2},
  [914] = {.lex_state = 85, .external_lex_state = 2},
  [915] = {.lex_state = 85, .external_lex_state = 2},
  [916] = {.lex_state = 85, .external_lex_state = 2},
  [917] = {.lex_state = 85, .external_lex_state = 2},
  [918] = {.lex_state = 85, .external_lex_state = 2},
  [919] = {.lex_state = 85, .external_lex_state = 2},
  [920] = {.lex_state = 91, .external_lex_state = 4},
  [921] = {.lex_state = 91, .external_lex_state = 4},
  [922] = {.lex_state = 85, .external_lex_state = 2},
  [923] = {.lex_state = 85, .external_lex_state = 2},
  [924] = {.lex_state = 91, .external_lex_state = 4},
  [925] = {.lex_state = 85, .external_lex_state = 2},
  [926] = {.lex_state = 85, .external_lex_state = 2},
  [927] = {.lex_state = 85, .external_lex_state = 2},
  [928] = {.lex_state = 91, .external_lex_state = 4},
  [929] = {.lex_state = 85, .external_lex_state = 2},
  [930] = {.lex_state = 85, .external_lex_state = 2},
  [931] = {.lex_state = 85, .external_lex_state = 2},
  [932] = {.lex_state = 85, .external_lex_state = 2},
  [933] = {.lex_state = 85, .external_lex_state = 2},
  [934] = {.lex_state = 85, .external_lex_state = 2},
  [935] = {.lex_state = 85, .external_lex_state = 2},
  [936] = {.lex_state = 85, .external_lex_state = 2},
  [937] = {.lex_state = 91, .external_lex_state = 4},
  [938] = {.lex_state = 91, .external_lex_state = 4},
  [939] = {.lex_state = 85, .external_lex_state = 2},
  [940] = {.lex_state = 85, .external_lex_state = 2},
  [941] = {.lex_state = 91, .external_lex_state = 4},
  [942] = {.lex_state = 85, .external_lex_state = 2},
  [943] = {.lex_state = 85, .external_lex_state = 2},
  [944] = {.lex_state = 85, .external_lex_state = 2},
  [945] = {.lex_state = 91, .external_lex_state = 4},
  [946] = {.lex_state = 85, .external_lex_state = 2},
  [947] = {.lex_state = 91, .external_lex_state = 4},
  [948] = {.lex_state = 91, .external_lex_state = 4},
  [949] = {.lex_state = 91, .external_lex_state = 4},
  [950] = {.lex_state = 85, .external_lex_state = 2},
  [951] = {.lex_state = 85, .external_lex_state = 2},
  [952] = {.lex_state = 85, .external_lex_state = 2},
  [953] = {.lex_state = 85, .external_lex_state = 2},
  [954] = {.lex_state = 85, .external_lex_state = 2},
  [955] = {.lex_state = 85, .external_lex_state = 2},
  [956] = {.lex_state = 85, .external_lex_state = 2},
  [957] = {.lex_state = 85, .external_lex_state = 2},
  [958] = {.lex_state = 85, .external_lex_state = 2},
  [959] = {.lex_state = 85, .external_lex_state = 2},
  [960] = {.lex_state = 85, .external_lex_state = 2},
  [961] = {.lex_state = 85, .external_lex_state = 2},
  [962] = {.lex_state = 85, .external_lex_state = 2},
  [963] = {.lex_state = 85, .external_lex_state = 2},
  [964] = {.lex_state = 85, .external_lex_state = 2},
  [965] = {.lex_state = 85, .external_lex_state = 2},
  [966] = {.lex_state = 91, .external_lex_state = 4},
  [967] = {.lex_state = 91, .external_lex_state = 4},
  [968] = {.lex_state = 91, .external_lex_state = 4},
  [969] = {.lex_state = 91, .external_lex_state = 4},
  [970] = {.lex_state = 91, .external_lex_state = 4},
  [971] = {.lex_state = 85, .external_lex_state = 2},
  [972] = {.lex_state = 85, .external_lex_state = 2},
  [973] = {.lex_state = 91, .external_lex_state = 4},
  [974] = {.lex_state = 91, .external_lex_state = 4},
  [975] = {.lex_state = 85, .external_lex_state = 2},
  [976] = {.lex_state = 85, .external_lex_state = 2},
  [977] = {.lex_state = 85, .external_lex_state = 2},
  [978] = {.lex_state = 91, .external_lex_state = 4},
  [979] = {.lex_state = 91, .external_lex_state = 4},
  [980] = {.lex_state = 91, .external_lex_state = 4},
  [981] = {.lex_state = 85, .external_lex_state = 2},
  [982] = {.lex_state = 91, .external_lex_state = 4},
  [983] = {.lex_state = 91, .external_lex_state = 4},
  [984] = {.lex_state = 91, .external_lex_state = 4},
  [985] = {.lex_state = 85, .external_lex_state = 2},
  [986] = {.lex_state = 85, .external_lex_state = 2},
  [987] = {.lex_state = 91, .external_lex_state = 4},
  [988] = {.lex_state = 91, .external_lex_state = 4},
  [989] = {.lex_state = 91, .external_lex_state = 4},
  [990] = {.lex_state = 91, .external_lex_state = 4},
  [991] = {.lex_state = 85, .external_lex_state = 2},
  [992] = {.lex_state = 85, .external_lex_state = 2},
  [993] = {.lex_state = 91, .external_lex_state = 4},
  [994] = {.lex_state = 91, .external_lex_state = 4},
  [995] = {.lex_state = 91, .external_lex_state = 4},
  [996] = {.lex_state = 91, .external_lex_state = 4},
  [997] = {.lex_state = 91, .external_lex_state = 4},
  [998] = {.lex_state = 85, .external_lex_state = 2},
  [999] = {.lex_state = 91, .external_lex_state = 4},
  [1000] = {.lex_state = 85, .external_lex_state = 2},
  [1001] = {.lex_state = 91, .external_lex_state = 4},
  [1002] = {.lex_state = 85, .external_lex_state = 2},
  [1003] = {.lex_state = 91, .external_lex_state = 4},
  [1004] = {.lex_state = 85, .external_lex_state = 2},
  [1005] = {.lex_state = 85, .external_lex_state = 2},
  [1006] = {.lex_state = 85, .external_lex_state = 2},
  [1007] = {.lex_state = 91, .external_lex_state = 4},
  [1008] = {.lex_state = 85, .external_lex_state = 2},
  [1009] = {.lex_state = 85, .external_lex_state = 2},
  [1010] = {.lex_state = 85, .external_lex_state = 2},
  [1011] = {.lex_state = 85, .external_lex_state = 2},
  [1012] = {.lex_state = 91, .external_lex_state = 4},
  [1013] = {.lex_state = 91, .external_lex_state = 4},
  [1014] = {.lex_state = 91, .external_lex_state = 4},
  [1015] = {.lex_state = 91, .external_lex_state = 4},
  [1016] = {.lex_state = 85, .external_lex_state = 2},
  [1017] = {.lex_state = 91, .external_lex_state = 4},
  [1018] = {.lex_state = 85, .external_lex_state = 2},
  [1019] = {.lex_state = 91, .external_lex_state = 4},
  [1020] = {.lex_state = 91, .external_lex_state = 4},
  [1021] = {.lex_state = 91, .external_lex_state = 4},
  [1022] = {.lex_state = 85, .external_lex_state = 2},
  [1023] = {.lex_state = 91, .external_lex_state = 4},
  [1024] = {.lex_state = 91, .external_lex_state = 4},
  [1025] = {.lex_state = 91, .external_lex_state = 4},
  [1026] = {.lex_state = 91, .external_lex_state = 4},
  [1027] = {.lex_state = 85, .external_lex_state = 2},
  [1028] = {.lex_state = 85, .external_lex_state = 2},
  [1029] = {.lex_state = 91, .external_lex_state = 4},
  [1030] = {.lex_state = 85, .external_lex_state = 2},
  [1031] = {.lex_state = 85, .external_lex_state = 2},
  [1032] = {.lex_state = 91, .external_lex_state = 4},
  [1033] = {.lex_state = 91, .external_lex_state = 4},
  [1034] = {.lex_state = 85, .external_lex_state = 2},
  [1035] = {.lex_state = 85, .external_lex_state = 2},
  [1036] = {.lex_state = 91, .external_lex_state = 4},
  [1037] = {.lex_state = 91, .external_lex_state = 4},
  [1038] = {.lex_state = 85, .external_lex_state = 2},
  [1039] = {.lex_state = 85, .external_lex_state = 2},
  [1040] = {.lex_state = 85, .external_lex_state = 2},
  [1041] = {.lex_state = 91, .external_lex_state = 4},
  [1042] = {.lex_state = 85, .external_lex_state = 2},
  [1043] = {.lex_state = 85, .external_lex_state = 2},
  [1044] = {.lex_state = 91, .external_lex_state = 4},
  [1045] = {.lex_state = 91, .external_lex_state = 4},
  [1046] = {.lex_state = 91, .external_lex_state = 4},
  [1047] = {.lex_state = 85, .external_lex_state = 2},
  [1048] = {.lex_state = 91, .external_lex_state = 4},
  [1049] = {.lex_state = 91, .external_lex_state = 4},
  [1050] = {.lex_state = 85, .external_lex_state = 2},
  [1051] = {.lex_state = 85, .external_lex_state = 2},
  [1052] = {.lex_state = 91, .external_lex_state = 4},
  [1053] = {.lex_state = 85, .external_lex_state = 2},
  [1054] = {.lex_state = 85, .external_lex_state = 2},
  [1055] = {.lex_state = 91, .external_lex_state = 4},
  [1056] = {.lex_state = 85, .external_lex_state = 2},
  [1057] = {.lex_state = 85, .external_lex_state = 2},
  [1058] = {.lex_state = 85, .external_lex_state = 2},
  [1059] = {.lex_state = 91, .external_lex_state = 4},
  [1060] = {.lex_state = 85, .external_lex_state = 2},
  [1061] = {.lex_state = 91, .external_lex_state = 4},
  [1062] = {.lex_state = 91, .external_lex_state = 4},
  [1063] = {.lex_state = 85, .external_lex_state = 2},
  [1064] = {.lex_state = 91, .external_lex_state = 4},
  [1065] = {.lex_state = 91, .external_lex_state = 4},
  [1066] = {.lex_state = 85, .external_lex_state = 2},
  [1067] = {.lex_state = 85, .external_lex_state = 2},
  [1068] = {.lex_state = 85, .external_lex_state = 2},
  [1069] = {.lex_state = 91, .external_lex_state = 4},
  [1070] = {.lex_state = 91, .external_lex_state = 4},
  [1071] = {.lex_state = 85, .external_lex_state = 2},
  [1072] = {.lex_state = 91, .external_lex_state = 4},
  [1073] = {.lex_state = 85, .external_lex_state = 2},
  [1074] = {.lex_state = 85, .external_lex_state = 2},
  [1075] = {.lex_state = 91, .external_lex_state = 4},
  [1076] = {.lex_state = 91, .external_lex_state = 4},
  [1077] = {.lex_state = 91, .external_lex_state = 4},
  [1078] = {.lex_state = 85, .external_lex_state = 2},
  [1079] = {.lex_state = 85, .external_lex_state = 2},
  [1080] = {.lex_state = 85, .external_lex_state = 2},
  [1081] = {.lex_state = 91, .external_lex_state = 4},
  [1082] = {.lex_state = 91, .external_lex_state = 4},
  [1083] = {.lex_state = 85, .external_lex_state = 2},
  [1084] = {.lex_state = 85, .external_lex_state = 2},
  [1085] = {.lex_state = 85, .external_lex_state = 2},
  [1086] = {.lex_state = 85, .external_lex_state = 2},
  [1087] = {.lex_state = 91, .external_lex_state = 4},
  [1088] = {.lex_state = 91, .external_lex_state = 4},
  [1089] = {.lex_state = 85, .external_lex_state = 2},
  [1090] = {.lex_state = 91, .external_lex_state = 4},
  [1091] = {.lex_state = 85, .external_lex_state = 2},
  [1092] = {.lex_state = 85, .external_lex_state = 2},
  [1093] = {.lex_state = 91, .external_lex_state = 4},
  [1094] = {.lex_state = 85, .external_lex_state = 2},
  [1095] = {.lex_state = 91, .external_lex_state = 4},
  [1096] = {.lex_state = 91, .external_lex_state = 4},
  [1097] = {.lex_state = 85, .external_lex_state = 2},
  [1098] = {.lex_state = 85, .external_lex_state = 2},
  [1099] = {.lex_state = 91, .external_lex_state = 4},
  [1100] = {.lex_state = 91, .external_lex_state = 4},
  [1101] = {.lex_state = 91, .external_lex_state = 4},
  [1102] = {.lex_state = 91, .external_lex_state = 4},
  [1103] = {.lex_state = 85, .external_lex_state = 2},
  [1104] = {.lex_state = 91, .external_lex_state = 4},
  [1105] = {.lex_state = 85, .external_lex_state = 2},
  [1106] = {.lex_state = 91, .external_lex_state = 4},
  [1107] = {.lex_state = 85, .external_lex_state = 2},
  [1108] = {.lex_state = 85, .external_lex_state = 2},
  [1109] = {.lex_state = 85, .external_lex_state = 2},
  [1110] = {.lex_state = 91, .external_lex_state = 4},
  [1111] = {.lex_state = 91, .external_lex_state = 4},
  [1112] = {.lex_state = 85, .external_lex_state = 2},
  [1113] = {.lex_state = 91, .external_lex_state = 4},
  [1114] = {.lex_state = 85, .external_lex_state = 2},
  [1115] = {.lex_state = 91, .external_lex_state = 4},
  [1116] = {.lex_state = 91, .external_lex_state = 4},
  [1117] = {.lex_state = 85, .external_lex_state = 2},
  [1118] = {.lex_state = 91, .external_lex_state = 4},
  [1119] = {.lex_state = 91, .external_lex_state = 4},
  [1120] = {.lex_state = 91, .external_lex_state = 4},
  [1121] = {.lex_state = 85, .external_lex_state = 2},
  [1122] = {.lex_state = 85, .external_lex_state = 2},
  [1123] = {.lex_state = 91, .external_lex_state = 4},
  [1124] = {.lex_state = 91, .external_lex_state = 4},
  [1125] = {.lex_state = 91, .external_lex_state = 4},
  [1126] = {.lex_state = 91, .external_lex_state = 4},
  [1127] = {.lex_state = 85, .external_lex_state = 2},
  [1128] = {.lex_state = 85, .external_lex_state = 2},
  [1129] = {.lex_state = 85, .external_lex_state = 2},
  [1130] = {.lex_state = 85, .external_lex_state = 2},
  [1131] = {.lex_state = 91, .external_lex_state = 4},
  [1132] = {.lex_state = 85, .external_lex_state = 2},
  [1133] = {.lex_state = 85, .external_lex_state = 2},
  [1134] = {.lex_state = 91, .external_lex_state = 4},
  [1135] = {.lex_state = 91, .external_lex_state = 4},
  [1136] = {.lex_state = 91, .external_lex_state = 4},
  [1137] = {.lex_state = 91, .external_lex_state = 4},
  [1138] = {.lex_state = 91, .external_lex_state = 4},
  [1139] = {.lex_state = 91, .external_lex_state = 4},
  [1140] = {.lex_state = 85, .external_lex_state = 2},
  [1141] = {.lex_state = 91, .external_lex_state = 4},
  [1142] = {.lex_state = 91, .external_lex_state = 4},
  [1143] = {.lex_state = 85, .external_lex_state = 2},
  [1144] = {.lex_state = 91, .external_lex_state = 4},
  [1145] = {.lex_state = 85, .external_lex_state = 2},
  [1146] = {.lex_state = 85, .external_lex_state = 2},
  [1147] = {.lex_state = 91, .external_lex_state = 4},
  [1148] = {.lex_state = 91, .external_lex_state = 4},
  [1149] = {.lex_state = 91, .external_lex_state = 4},
  [1150] = {.lex_state = 91, .external_lex_state = 4},
  [1151] = {.lex_state = 85, .external_lex_state = 2},
  [1152] = {.lex_state = 91, .external_lex_state = 4},
  [1153] = {.lex_state = 85, .external_lex_state = 2},
  [1154] = {.lex_state = 91, .external_lex_state = 4},
  [1155] = {.lex_state = 85, .external_lex_state = 2},
  [1156] = {.lex_state = 85, .external_lex_state = 2},
  [1157] = {.lex_state = 91, .external_lex_state = 4},
  [1158] = {.lex_state = 91, .external_lex_state = 4},
  [1159] = {.lex_state = 85, .external_lex_state = 2},
  [1160] = {.lex_state = 85, .external_lex_state = 2},
  [1161] = {.lex_state = 85, .external_lex_state = 2},
  [1162] = {.lex_state = 91, .external_lex_state = 4},
  [1163] = {.lex_state = 91, .external_lex_state = 4},
  [1164] = {.lex_state = 91, .external_lex_state = 4},
  [1165] = {.lex_state = 91, .external_lex_state = 4},
  [1166] = {.lex_state = 85, .external_lex_state = 2},
  [1167] = {.lex_state = 85, .external_lex_state = 2},
  [1168] = {.lex_state = 85, .external_lex_state = 2},
  [1169] = {.lex_state = 91, .external_lex_state = 4},
  [1170] = {.lex_state = 91, .external_lex_state = 4},
  [1171] = {.lex_state = 85, .external_lex_state = 2},
  [1172] = {.lex_state = 85, .external_lex_state = 2},
  [1173] = {.lex_state = 85, .external_lex_state = 2},
  [1174] = {.lex_state = 85, .external_lex_state = 2},
  [1175] = {.lex_state = 85, .external_lex_state = 2},
  [1176] = {.lex_state = 85, .external_lex_state = 2},
  [1177] = {.lex_state = 85, .external_lex_state = 2},
  [1178] = {.lex_state = 85, .external_lex_state = 2},
  [1179] = {.lex_state = 85, .external_lex_state = 2},
  [1180] = {.lex_state = 85, .external_lex_state = 2},
  [1181] = {.lex_state = 85, .external_lex_state = 2},
  [1182] = {.lex_state = 91, .external_lex_state = 4},
  [1183] = {.lex_state = 85, .external_lex_state = 2},
  [1184] = {.lex_state = 85, .external_lex_state = 2},
  [1185] = {.lex_state = 85, .external_lex_state = 2},
  [1186] = {.lex_state = 85, .external_lex_state = 2},
  [1187] = {.lex_state = 85, .external_lex_state = 2},
  [1188] = {.lex_state = 85, .external_lex_state = 2},
  [1189] = {.lex_state = 85, .external_lex_state = 2},
  [1190] = {.lex_state = 85, .external_lex_state = 2},
  [1191] = {.lex_state = 91, .external_lex_state = 4},
  [1192] = {.lex_state = 85, .external_lex_state = 2},
  [1193] = {.lex_state = 91, .external_lex_state = 4},
  [1194] = {.lex_state = 85, .external_lex_state = 2},
  [1195] = {.lex_state = 85, .external_lex_state = 2},
  [1196] = {.lex_state = 85, .external_lex_state = 2},
  [1197] = {.lex_state = 85, .external_lex_state = 2},
  [1198] = {.lex_state = 85, .external_lex_state = 2},
  [1199] = {.lex_state = 85, .external_lex_state = 2},
  [1200] = {.lex_state = 85, .external_lex_state = 2},
  [1201] = {.lex_state = 85, .external_lex_state = 2},
  [1202] = {.lex_state = 85, .external_lex_state = 2},
  [1203] = {.lex_state = 85, .external_lex_state = 2},
  [1204] = {.lex_state = 85, .external_lex_state = 2},
  [1205] = {.lex_state = 85, .external_lex_state = 2},
  [1206] = {.lex_state = 85, .external_lex_state = 2},
  [1207] = {.lex_state = 85, .external_lex_state = 2},
  [1208] = {.lex_state = 85, .external_lex_state = 2},
  [1209] = {.lex_state = 85, .external_lex_state = 2},
  [1210] = {.lex_state = 85, .external_lex_state = 2},
  [1211] = {.lex_state = 91, .external_lex_state = 4},
  [1212] = {.lex_state = 85, .external_lex_state = 2},
  [1213] = {.lex_state = 91, .external_lex_state = 4},
  [1214] = {.lex_state = 91, .external_lex_state = 4},
  [1215] = {.lex_state = 91, .external_lex_state = 4},
  [1216] = {.lex_state = 85, .external_lex_state = 2},
  [1217] = {.lex_state = 91, .external_lex_state = 4},
  [1218] = {.lex_state = 85, .external_lex_state = 2},
  [1219] = {.lex_state = 85, .external_lex_state = 2},
  [1220] = {.lex_state = 85, .external_lex_state = 2},
  [1221] = {.lex_state = 85, .external_lex_state = 2},
  [1222] = {.lex_state = 85, .external_lex_state = 2},
  [1223] = {.lex_state = 85, .external_lex_state = 2},
  [1224] = {.lex_state = 85, .external_lex_state = 2},
  [1225] = {.lex_state = 85, .external_lex_state = 2},
  [1226] = {.lex_state = 85, .external_lex_state = 2},
  [1227] = {.lex_state = 85, .external_lex_state = 2},
  [1228] = {.lex_state = 85, .external_lex_state = 2},
  [1229] = {.lex_state = 85, .external_lex_state = 2},
  [1230] = {.lex_state = 91, .external_lex_state = 4},
  [1231] = {.lex_state = 85, .external_lex_state = 2},
  [1232] = {.lex_state = 85, .external_lex_state = 2},
  [1233] = {.lex_state = 85, .external_lex_state = 2},
  [1234] = {.lex_state = 85, .external_lex_state = 2},
  [1235] = {.lex_state = 85, .external_lex_state = 2},
  [1236] = {.lex_state = 85, .external_lex_state = 2},
  [1237] = {.lex_state = 85, .external_lex_state = 2},
  [1238] = {.lex_state = 85, .external_lex_state = 2},
  [1239] = {.lex_state = 85, .external_lex_state = 2},
  [1240] = {.lex_state = 91, .external_lex_state = 4},
  [1241] = {.lex_state = 85, .external_lex_state = 2},
  [1242] = {.lex_state = 85, .external_lex_state = 2},
  [1243] = {.lex_state = 91, .external_lex_state = 4},
  [1244] = {.lex_state = 85, .external_lex_state = 2},
  [1245] = {.lex_state = 91, .external_lex_state = 4},
  [1246] = {.lex_state = 85, .external_lex_state = 2},
  [1247] = {.lex_state = 85, .external_lex_state = 2},
  [1248] = {.lex_state = 85, .external_lex_state = 2},
  [1249] = {.lex_state = 85, .external_lex_state = 2},
  [1250] = {.lex_state = 85, .external_lex_state = 2},
  [1251] = {.lex_state = 85, .external_lex_state = 2},
  [1252] = {.lex_state = 85, .external_lex_state = 2},
  [1253] = {.lex_state = 85, .external_lex_state = 2},
  [1254] = {.lex_state = 85, .external_lex_state = 2},
  [1255] = {.lex_state = 85, .external_lex_state = 2},
  [1256] = {.lex_state = 85, .external_lex_state = 2},
  [1257] = {.lex_state = 85, .external_lex_state = 2},
  [1258] = {.lex_state = 85, .external_lex_state = 2},
  [1259] = {.lex_state = 85, .external_lex_state = 2},
  [1260] = {.lex_state = 85, .external_lex_state = 2},
  [1261] = {.lex_state = 85, .external_lex_state = 2},
  [1262] = {.lex_state = 85, .external_lex_state = 2},
  [1263] = {.lex_state = 85, .external_lex_state = 2},
  [1264] = {.lex_state = 85, .external_lex_state = 2},
  [1265] = {.lex_state = 85, .external_lex_state = 2},
  [1266] = {.lex_state = 85, .external_lex_state = 2},
  [1267] = {.lex_state = 85, .external_lex_state = 2},
  [1268] = {.lex_state = 85, .external_lex_state = 2},
  [1269] = {.lex_state = 85, .external_lex_state = 2},
  [1270] = {.lex_state = 85, .external_lex_state = 2},
  [1271] = {.lex_state = 85, .external_lex_state = 2},
  [1272] = {.lex_state = 85, .external_lex_state = 2},
  [1273] = {.lex_state = 85, .external_lex_state = 2},
  [1274] = {.lex_state = 85, .external_lex_state = 2},
  [1275] = {.lex_state = 85, .external_lex_state = 2},
  [1276] = {.lex_state = 85, .external_lex_state = 2},
  [1277] = {.lex_state = 91, .external_lex_state = 4},
  [1278] = {.lex_state = 85, .external_lex_state = 2},
  [1279] = {.lex_state = 85, .external_lex_state = 2},
  [1280] = {.lex_state = 91, .external_lex_state = 4},
  [1281] = {.lex_state = 85, .external_lex_state = 2},
  [1282] = {.lex_state = 85, .external_lex_state = 2},
  [1283] = {.lex_state = 91, .external_lex_state = 4},
  [1284] = {.lex_state = 85, .external_lex_state = 2},
  [1285] = {.lex_state = 85, .external_lex_state = 2},
  [1286] = {.lex_state = 85, .external_lex_state = 2},
  [1287] = {.lex_state = 85, .external_lex_state = 2},
  [1288] = {.lex_state = 85, .external_lex_state = 2},
  [1289] = {.lex_state = 85, .external_lex_state = 2},
  [1290] = {.lex_state = 85, .external_lex_state = 2},
  [1291] = {.lex_state = 91, .external_lex_state = 4},
  [1292] = {.lex_state = 91, .external_lex_state = 4},
  [1293] = {.lex_state = 85, .external_lex_state = 2},
  [1294] = {.lex_state = 92, .external_lex_state = 4},
  [1295] = {.lex_state = 85, .external_lex_state = 2},
  [1296] = {.lex_state = 91, .external_lex_state = 4},
  [1297] = {.lex_state = 85, .external_lex_state = 2},
  [1298] = {.lex_state = 85, .external_lex_state = 2},
  [1299] = {.lex_state = 91, .external_lex_state = 4},
  [1300] = {.lex_state = 91, .external_lex_state = 4},
  [1301] = {.lex_state = 85, .external_lex_state = 2},
  [1302] = {.lex_state = 91, .external_lex_state = 4},
  [1303] = {.lex_state = 85, .external_lex_state = 2},
  [1304] = {.lex_state = 85, .external_lex_state = 2},
  [1305] = {.lex_state = 85, .external_lex_state = 2},
  [1306] = {.lex_state = 85, .external_lex_state = 2},
  [1307] = {.lex_state = 85, .external_lex_state = 2},
  [1308] = {.lex_state = 85, .external_lex_state = 2},
  [1309] = {.lex_state = 85, .external_lex_state = 2},
  [1310] = {.lex_state = 85, .external_lex_state = 2},
  [1311] = {.lex_state = 85, .external_lex_state = 2},
  [1312] = {.lex_state = 85, .external_lex_state = 2},
  [1313] = {.lex_state = 85, .external_lex_state = 2},
  [1314] = {.lex_state = 85, .external_lex_state = 2},
  [1315] = {.lex_state = 92, .external_lex_state = 4},
  [1316] = {.lex_state = 92, .external_lex_state = 4},
  [1317] = {.lex_state = 91, .external_lex_state = 4},
  [1318] = {.lex_state = 85, .external_lex_state = 2},
  [1319] = {.lex_state = 85, .external_lex_state = 2},
  [1320] = {.lex_state = 85, .external_lex_state = 2},
  [1321] = {.lex_state = 91, .external_lex_state = 4},
  [1322] = {.lex_state = 85, .external_lex_state = 2},
  [1323] = {.lex_state = 85, .external_lex_state = 2},
  [1324] = {.lex_state = 85, .external_lex_state = 2},
  [1325] = {.lex_state = 85, .external_lex_state = 2},
  [1326] = {.lex_state = 85, .external_lex_state = 2},
  [1327] = {.lex_state = 85, .external_lex_state = 2},
  [1328] = {.lex_state = 85, .external_lex_state = 2},
  [1329] = {.lex_state = 85, .external_lex_state = 2},
  [1330] = {.lex_state = 85, .external_lex_state = 2},
  [1331] = {.lex_state = 85, .external_lex_state = 2},
  [1332] = {.lex_state = 85, .external_lex_state = 2},
  [1333] = {.lex_state = 85, .external_lex_state = 2},
  [1334] = {.lex_state = 91, .external_lex_state = 4},
  [1335] = {.lex_state = 85, .external_lex_state = 2},
  [1336] = {.lex_state = 85, .external_lex_state = 2},
  [1337] = {.lex_state = 85, .external_lex_state = 2},
  [1338] = {.lex_state = 85, .external_lex_state = 2},
  [1339] = {.lex_state = 85, .external_lex_state = 2},
  [1340] = {.lex_state = 85, .external_lex_state = 2},
  [1341] = {.lex_state = 85, .external_lex_state = 2},
  [1342] = {.lex_state = 85, .external_lex_state = 2},
  [1343] = {.lex_state = 85, .external_lex_state = 2},
  [1344] = {.lex_state = 85, .external_lex_state = 2},
  [1345] = {.lex_state = 85, .external_lex_state = 2},
  [1346] = {.lex_state = 85, .external_lex_state = 2},
  [1347] = {.lex_state = 85, .external_lex_state = 2},
  [1348] = {.lex_state = 85, .external_lex_state = 2},
  [1349] = {.lex_state = 85, .external_lex_state = 2},
  [1350] = {.lex_state = 85, .external_lex_state = 2},
  [1351] = {.lex_state = 85, .external_lex_state = 2},
  [1352] = {.lex_state = 85, .external_lex_state = 2},
  [1353] = {.lex_state = 85, .external_lex_state = 2},
  [1354] = {.lex_state = 85, .external_lex_state = 2},
  [1355] = {.lex_state = 85, .external_lex_state = 2},
  [1356] = {.lex_state = 91, .external_lex_state = 4},
  [1357] = {.lex_state = 85, .external_lex_state = 2},
  [1358] = {.lex_state = 85, .external_lex_state = 2},
  [1359] = {.lex_state = 85, .external_lex_state = 2},
  [1360] = {.lex_state = 85, .external_lex_state = 2},
  [1361] = {.lex_state = 91, .external_lex_state = 4},
  [1362] = {.lex_state = 85, .external_lex_state = 2},
  [1363] = {.lex_state = 85, .external_lex_state = 2},
  [1364] = {.lex_state = 85, .external_lex_state = 2},
  [1365] = {.lex_state = 85, .external_lex_state = 2},
  [1366] = {.lex_state = 85, .external_lex_state = 2},
  [1367] = {.lex_state = 85, .external_lex_state = 2},
  [1368] = {.lex_state = 85, .external_lex_state = 2},
  [1369] = {.lex_state = 85, .external_lex_state = 2},
  [1370] = {.lex_state = 85, .external_lex_state = 2},
  [1371] = {.lex_state = 85, .external_lex_state = 2},
  [1372] = {.lex_state = 85, .external_lex_state = 2},
  [1373] = {.lex_state = 85, .external_lex_state = 2},
  [1374] = {.lex_state = 85, .external_lex_state = 2},
  [1375] = {.lex_state = 85, .external_lex_state = 2},
  [1376] = {.lex_state = 85, .external_lex_state = 2},
  [1377] = {.lex_state = 85, .external_lex_state = 2},
  [1378] = {.lex_state = 85, .external_lex_state = 2},
  [1379] = {.lex_state = 85, .external_lex_state = 2},
  [1380] = {.lex_state = 85, .external_lex_state = 2},
  [1381] = {.lex_state = 85, .external_lex_state = 2},
  [1382] = {.lex_state = 85, .external_lex_state = 2},
  [1383] = {.lex_state = 85, .external_lex_state = 2},
  [1384] = {.lex_state = 85, .external_lex_state = 2},
  [1385] = {.lex_state = 85, .external_lex_state = 2},
  [1386] = {.lex_state = 85, .external_lex_state = 2},
  [1387] = {.lex_state = 85, .external_lex_state = 2},
  [1388] = {.lex_state = 85, .external_lex_state = 2},
  [1389] = {.lex_state = 85, .external_lex_state = 2},
  [1390] = {.lex_state = 85, .external_lex_state = 2},
  [1391] = {.lex_state = 85, .external_lex_state = 2},
  [1392] = {.lex_state = 85, .external_lex_state = 2},
  [1393] = {.lex_state = 85, .external_lex_state = 2},
  [1394] = {.lex_state = 85, .external_lex_state = 2},
  [1395] = {.lex_state = 85, .external_lex_state = 2},
  [1396] = {.lex_state = 85, .external_lex_state = 2},
  [1397] = {.lex_state = 85, .external_lex_state = 2},
  [1398] = {.lex_state = 85, .external_lex_state = 2},
  [1399] = {.lex_state = 85, .external_lex_state = 2},
  [1400] = {.lex_state = 85, .external_lex_state = 2},
  [1401] = {.lex_state = 91, .external_lex_state = 6},
  [1402] = {.lex_state = 85, .external_lex_state = 2},
  [1403] = {.lex_state = 91, .external_lex_state = 6},
  [1404] = {.lex_state = 91, .external_lex_state = 6},
  [1405] = {.lex_state = 91, .external_lex_state = 6},
  [1406] = {.lex_state = 91, .external_lex_state = 6},
  [1407] = {.lex_state = 91, .external_lex_state = 6},
  [1408] = {.lex_state = 85, .external_lex_state = 2},
  [1409] = {.lex_state = 85, .external_lex_state = 2},
  [1410] = {.lex_state = 91, .external_lex_state = 6},
  [1411] = {.lex_state = 91, .external_lex_state = 6},
  [1412] = {.lex_state = 91, .external_lex_state = 6},
  [1413] = {.lex_state = 85, .external_lex_state = 2},
  [1414] = {.lex_state = 85, .external_lex_state = 2},
  [1415] = {.lex_state = 85, .external_lex_state = 2},
  [1416] = {.lex_state = 91, .external_lex_state = 6},
  [1417] = {.lex_state = 85, .external_lex_state = 2},
  [1418] = {.lex_state = 85, .external_lex_state = 2},
  [1419] = {.lex_state = 91, .external_lex_state = 6},
  [1420] = {.lex_state = 91, .external_lex_state = 6},
  [1421] = {.lex_state = 85, .external_lex_state = 2},
  [1422] = {.lex_state = 91, .external_lex_state = 6},
  [1423] = {.lex_state = 91, .external_lex_state = 6},
  [1424] = {.lex_state = 85, .external_lex_state = 2},
  [1425] = {.lex_state = 85, .external_lex_state = 2},
  [1426] = {.lex_state = 91, .external_lex_state = 6},
  [1427] = {.lex_state = 91, .external_lex_state = 6},
  [1428] = {.lex_state = 91, .external_lex_state = 6},
  [1429] = {.lex_state = 85, .external_lex_state = 2},
  [1430] = {.lex_state = 91, .external_lex_state = 6},
  [1431] = {.lex_state = 85, .external_lex_state = 2},
  [1432] = {.lex_state = 85, .external_lex_state = 2},
  [1433] = {.lex_state = 85, .external_lex_state = 2},
  [1434] = {.lex_state = 85, .external_lex_state = 2},
  [1435] = {.lex_state = 85, .external_lex_state = 2},
  [1436] = {.lex_state = 85, .external_lex_state = 2},
  [1437] = {.lex_state = 85, .external_lex_state = 2},
  [1438] = {.lex_state = 85, .external_lex_state = 2},
  [1439] = {.lex_state = 85, .external_lex_state = 2},
  [1440] = {.lex_state = 85, .external_lex_state = 2},
  [1441] = {.lex_state = 85, .external_lex_state = 2},
  [1442] = {.lex_state = 85, .external_lex_state = 2},
  [1443] = {.lex_state = 85, .external_lex_state = 2},
  [1444] = {.lex_state = 85, .external_lex_state = 2},
  [1445] = {.lex_state = 85, .external_lex_state = 2},
  [1446] = {.lex_state = 85, .external_lex_state = 2},
  [1447] = {.lex_state = 85, .external_lex_state = 2},
  [1448] = {.lex_state = 85, .external_lex_state = 2},
  [1449] = {.lex_state = 85, .external_lex_state = 2},
  [1450] = {.lex_state = 85, .external_lex_state = 2},
  [1451] = {.lex_state = 85, .external_lex_state = 2},
  [1452] = {.lex_state = 85, .external_lex_state = 2},
  [1453] = {.lex_state = 85, .external_lex_state = 2},
  [1454] = {.lex_state = 85, .external_lex_state = 2},
  [1455] = {.lex_state = 85, .external_lex_state = 2},
  [1456] = {.lex_state = 85, .external_lex_state = 2},
  [1457] = {.lex_state = 85, .external_lex_state = 2},
  [1458] = {.lex_state = 85, .external_lex_state = 2},
  [1459] = {.lex_state = 85, .external_lex_state = 2},
  [1460] = {.lex_state = 85, .external_lex_state = 2},
  [1461] = {.lex_state = 85, .external_lex_state = 2},
  [1462] = {.lex_state = 85, .external_lex_state = 2},
  [1463] = {.lex_state = 85, .external_lex_state = 2},
  [1464] = {.lex_state = 85, .external_lex_state = 2},
  [1465] = {.lex_state = 85, .external_lex_state = 2},
  [1466] = {.lex_state = 85, .external_lex_state = 2},
  [1467] = {.lex_state = 85, .external_lex_state = 2},
  [1468] = {.lex_state = 85, .external_lex_state = 2},
  [1469] = {.lex_state = 85, .external_lex_state = 2},
  [1470] = {.lex_state = 85, .external_lex_state = 2},
  [1471] = {.lex_state = 85, .external_lex_state = 2},
  [1472] = {.lex_state = 85, .external_lex_state = 2},
  [1473] = {.lex_state = 85, .external_lex_state = 2},
  [1474] = {.lex_state = 85, .external_lex_state = 2},
  [1475] = {.lex_state = 85, .external_lex_state = 2},
  [1476] = {.lex_state = 85, .external_lex_state = 2},
  [1477] = {.lex_state = 85, .external_lex_state = 2},
  [1478] = {.lex_state = 85, .external_lex_state = 2},
  [1479] = {.lex_state = 85, .external_lex_state = 2},
  [1480] = {.lex_state = 85, .external_lex_state = 2},
  [1481] = {.lex_state = 85, .external_lex_state = 2},
  [1482] = {.lex_state = 85, .external_lex_state = 2},
  [1483] = {.lex_state = 85, .external_lex_state = 2},
  [1484] = {.lex_state = 85, .external_lex_state = 2},
  [1485] = {.lex_state = 85, .external_lex_state = 2},
  [1486] = {.lex_state = 85, .external_lex_state = 2},
  [1487] = {.lex_state = 85, .external_lex_state = 2},
  [1488] = {.lex_state = 85, .external_lex_state = 2},
  [1489] = {.lex_state = 85, .external_lex_state = 2},
  [1490] = {.lex_state = 85, .external_lex_state = 2},
  [1491] = {.lex_state = 85, .external_lex_state = 2},
  [1492] = {.lex_state = 85, .external_lex_state = 2},
  [1493] = {.lex_state = 85, .external_lex_state = 2},
  [1494] = {.lex_state = 91, .external_lex_state = 6},
  [1495] = {.lex_state = 91, .external_lex_state = 6},
  [1496] = {.lex_state = 85, .external_lex_state = 2},
  [1497] = {.lex_state = 87, .external_lex_state = 6},
  [1498] = {.lex_state = 85, .external_lex_state = 2},
  [1499] = {.lex_state = 85, .external_lex_state = 2},
  [1500] = {.lex_state = 85, .external_lex_state = 2},
  [1501] = {.lex_state = 85, .external_lex_state = 2},
  [1502] = {.lex_state = 85, .external_lex_state = 2},
  [1503] = {.lex_state = 85, .external_lex_state = 2},
  [1504] = {.lex_state = 85, .external_lex_state = 2},
  [1505] = {.lex_state = 85, .external_lex_state = 2},
  [1506] = {.lex_state = 85, .external_lex_state = 2},
  [1507] = {.lex_state = 85, .external_lex_state = 2},
  [1508] = {.lex_state = 85, .external_lex_state = 2},
  [1509] = {.lex_state = 85, .external_lex_state = 2},
  [1510] = {.lex_state = 85, .external_lex_state = 2},
  [1511] = {.lex_state = 85, .external_lex_state = 2},
  [1512] = {.lex_state = 85, .external_lex_state = 2},
  [1513] = {.lex_state = 85, .external_lex_state = 2},
  [1514] = {.lex_state = 85, .external_lex_state = 2},
  [1515] = {.lex_state = 85, .external_lex_state = 2},
  [1516] = {.lex_state = 85, .external_lex_state = 2},
  [1517] = {.lex_state = 85, .external_lex_state = 2},
  [1518] = {.lex_state = 85, .external_lex_state = 2},
  [1519] = {.lex_state = 85, .external_lex_state = 2},
  [1520] = {.lex_state = 85, .external_lex_state = 2},
  [1521] = {.lex_state = 85, .external_lex_state = 2},
  [1522] = {.lex_state = 85, .external_lex_state = 2},
  [1523] = {.lex_state = 85, .external_lex_state = 2},
  [1524] = {.lex_state = 85, .external_lex_state = 2},
  [1525] = {.lex_state = 85, .external_lex_state = 2},
  [1526] = {.lex_state = 85, .external_lex_state = 2},
  [1527] = {.lex_state = 85, .external_lex_state = 2},
  [1528] = {.lex_state = 85, .external_lex_state = 2},
  [1529] = {.lex_state = 85, .external_lex_state = 2},
  [1530] = {.lex_state = 85, .external_lex_state = 2},
  [1531] = {.lex_state = 85, .external_lex_state = 2},
  [1532] = {.lex_state = 85, .external_lex_state = 2},
  [1533] = {.lex_state = 85, .external_lex_state = 2},
  [1534] = {.lex_state = 85, .external_lex_state = 2},
  [1535] = {.lex_state = 85, .external_lex_state = 2},
  [1536] = {.lex_state = 85, .external_lex_state = 2},
  [1537] = {.lex_state = 85, .external_lex_state = 2},
  [1538] = {.lex_state = 85, .external_lex_state = 2},
  [1539] = {.lex_state = 85, .external_lex_state = 2},
  [1540] = {.lex_state = 85, .external_lex_state = 2},
  [1541] = {.lex_state = 85, .external_lex_state = 2},
  [1542] = {.lex_state = 85, .external_lex_state = 2},
  [1543] = {.lex_state = 85, .external_lex_state = 2},
  [1544] = {.lex_state = 85, .external_lex_state = 2},
  [1545] = {.lex_state = 85, .external_lex_state = 2},
  [1546] = {.lex_state = 85, .external_lex_state = 2},
  [1547] = {.lex_state = 85, .external_lex_state = 2},
  [1548] = {.lex_state = 85, .external_lex_state = 2},
  [1549] = {.lex_state = 91, .external_lex_state = 6},
  [1550] = {.lex_state = 85, .external_lex_state = 2},
  [1551] = {.lex_state = 85, .external_lex_state = 2},
  [1552] = {.lex_state = 85, .external_lex_state = 2},
  [1553] = {.lex_state = 85, .external_lex_state = 2},
  [1554] = {.lex_state = 85, .external_lex_state = 2},
  [1555] = {.lex_state = 85, .external_lex_state = 2},
  [1556] = {.lex_state = 85, .external_lex_state = 2},
  [1557] = {.lex_state = 85, .external_lex_state = 2},
  [1558] = {.lex_state = 85, .external_lex_state = 2},
  [1559] = {.lex_state = 85, .external_lex_state = 2},
  [1560] = {.lex_state = 85, .external_lex_state = 2},
  [1561] = {.lex_state = 85, .external_lex_state = 2},
  [1562] = {.lex_state = 85, .external_lex_state = 2},
  [1563] = {.lex_state = 85, .external_lex_state = 2},
  [1564] = {.lex_state = 85, .external_lex_state = 2},
  [1565] = {.lex_state = 85, .external_lex_state = 2},
  [1566] = {.lex_state = 85, .external_lex_state = 2},
  [1567] = {.lex_state = 85, .external_lex_state = 2},
  [1568] = {.lex_state = 85, .external_lex_state = 2},
  [1569] = {.lex_state = 85, .external_lex_state = 2},
  [1570] = {.lex_state = 85, .external_lex_state = 2},
  [1571] = {.lex_state = 85, .external_lex_state = 2},
  [1572] = {.lex_state = 85, .external_lex_state = 2},
  [1573] = {.lex_state = 85, .external_lex_state = 2},
  [1574] = {.lex_state = 85, .external_lex_state = 2},
  [1575] = {.lex_state = 85, .external_lex_state = 2},
  [1576] = {.lex_state = 85, .external_lex_state = 2},
  [1577] = {.lex_state = 85, .external_lex_state = 2},
  [1578] = {.lex_state = 85, .external_lex_state = 2},
  [1579] = {.lex_state = 85, .external_lex_state = 2},
  [1580] = {.lex_state = 85, .external_lex_state = 2},
  [1581] = {.lex_state = 85, .external_lex_state = 2},
  [1582] = {.lex_state = 85, .external_lex_state = 2},
  [1583] = {.lex_state = 85, .external_lex_state = 2},
  [1584] = {.lex_state = 85, .external_lex_state = 2},
  [1585] = {.lex_state = 85, .external_lex_state = 2},
  [1586] = {.lex_state = 85, .external_lex_state = 2},
  [1587] = {.lex_state = 85, .external_lex_state = 2},
  [1588] = {.lex_state = 85, .external_lex_state = 2},
  [1589] = {.lex_state = 85, .external_lex_state = 2},
  [1590] = {.lex_state = 85, .external_lex_state = 2},
  [1591] = {.lex_state = 85, .external_lex_state = 2},
  [1592] = {.lex_state = 85, .external_lex_state = 2},
  [1593] = {.lex_state = 85, .external_lex_state = 2},
  [1594] = {.lex_state = 85, .external_lex_state = 2},
  [1595] = {.lex_state = 85, .external_lex_state = 2},
  [1596] = {.lex_state = 85, .external_lex_state = 2},
  [1597] = {.lex_state = 85, .external_lex_state = 2},
  [1598] = {.lex_state = 85, .external_lex_state = 2},
  [1599] = {.lex_state = 85, .external_lex_state = 2},
  [1600] = {.lex_state = 85, .external_lex_state = 2},
  [1601] = {.lex_state = 85, .external_lex_state = 2},
  [1602] = {.lex_state = 85, .external_lex_state = 2},
  [1603] = {.lex_state = 85, .external_lex_state = 2},
  [1604] = {.lex_state = 85, .external_lex_state = 2},
  [1605] = {.lex_state = 85, .external_lex_state = 2},
  [1606] = {.lex_state = 85, .external_lex_state = 2},
  [1607] = {.lex_state = 85, .external_lex_state = 2},
  [1608] = {.lex_state = 85, .external_lex_state = 2},
  [1609] = {.lex_state = 85, .external_lex_state = 2},
  [1610] = {.lex_state = 85, .external_lex_state = 2},
  [1611] = {.lex_state = 85, .external_lex_state = 2},
  [1612] = {.lex_state = 85, .external_lex_state = 2},
  [1613] = {.lex_state = 85, .external_lex_state = 2},
  [1614] = {.lex_state = 85, .external_lex_state = 2},
  [1615] = {.lex_state = 85, .external_lex_state = 2},
  [1616] = {.lex_state = 85, .external_lex_state = 2},
  [1617] = {.lex_state = 85, .external_lex_state = 2},
  [1618] = {.lex_state = 85, .external_lex_state = 2},
  [1619] = {.lex_state = 85, .external_lex_state = 2},
  [1620] = {.lex_state = 85, .external_lex_state = 2},
  [1621] = {.lex_state = 85, .external_lex_state = 2},
  [1622] = {.lex_state = 85, .external_lex_state = 2},
  [1623] = {.lex_state = 85, .external_lex_state = 2},
  [1624] = {.lex_state = 85, .external_lex_state = 2},
  [1625] = {.lex_state = 85, .external_lex_state = 2},
  [1626] = {.lex_state = 85, .external_lex_state = 2},
  [1627] = {.lex_state = 85, .external_lex_state = 2},
  [1628] = {.lex_state = 85, .external_lex_state = 2},
  [1629] = {.lex_state = 85, .external_lex_state = 2},
  [1630] = {.lex_state = 85, .external_lex_state = 2},
  [1631] = {.lex_state = 85, .external_lex_state = 2},
  [1632] = {.lex_state = 85, .external_lex_state = 2},
  [1633] = {.lex_state = 85, .external_lex_state = 2},
  [1634] = {.lex_state = 85, .external_lex_state = 2},
  [1635] = {.lex_state = 85, .external_lex_state = 2},
  [1636] = {.lex_state = 85, .external_lex_state = 2},
  [1637] = {.lex_state = 85, .external_lex_state = 2},
  [1638] = {.lex_state = 85, .external_lex_state = 2},
  [1639] = {.lex_state = 85, .external_lex_state = 2},
  [1640] = {.lex_state = 85, .external_lex_state = 2},
  [1641] = {.lex_state = 85, .external_lex_state = 2},
  [1642] = {.lex_state = 85, .external_lex_state = 2},
  [1643] = {.lex_state = 85, .external_lex_state = 2},
  [1644] = {.lex_state = 85, .external_lex_state = 2},
  [1645] = {.lex_state = 85, .external_lex_state = 2},
  [1646] = {.lex_state = 85, .external_lex_state = 2},
  [1647] = {.lex_state = 85, .external_lex_state = 2},
  [1648] = {.lex_state = 85, .external_lex_state = 2},
  [1649] = {.lex_state = 85, .external_lex_state = 2},
  [1650] = {.lex_state = 85, .external_lex_state = 2},
  [1651] = {.lex_state = 85, .external_lex_state = 2},
  [1652] = {.lex_state = 85, .external_lex_state = 2},
  [1653] = {.lex_state = 85, .external_lex_state = 2},
  [1654] = {.lex_state = 85, .external_lex_state = 2},
  [1655] = {.lex_state = 85, .external_lex_state = 2},
  [1656] = {.lex_state = 85, .external_lex_state = 2},
  [1657] = {.lex_state = 85, .external_lex_state = 2},
  [1658] = {.lex_state = 85, .external_lex_state = 2},
  [1659] = {.lex_state = 85, .external_lex_state = 2},
  [1660] = {.lex_state = 85, .external_lex_state = 2},
  [1661] = {.lex_state = 85, .external_lex_state = 2},
  [1662] = {.lex_state = 85, .external_lex_state = 2},
  [1663] = {.lex_state = 85, .external_lex_state = 2},
  [1664] = {.lex_state = 85, .external_lex_state = 2},
  [1665] = {.lex_state = 85, .external_lex_state = 2},
  [1666] = {.lex_state = 85, .external_lex_state = 2},
  [1667] = {.lex_state = 85, .external_lex_state = 2},
  [1668] = {.lex_state = 85, .external_lex_state = 2},
  [1669] = {.lex_state = 91, .external_lex_state = 6},
  [1670] = {.lex_state = 85, .external_lex_state = 2},
  [1671] = {.lex_state = 85, .external_lex_state = 2},
  [1672] = {.lex_state = 85, .external_lex_state = 2},
  [1673] = {.lex_state = 85, .external_lex_state = 2},
  [1674] = {.lex_state = 85, .external_lex_state = 2},
  [1675] = {.lex_state = 85, .external_lex_state = 2},
  [1676] = {.lex_state = 85, .external_lex_state = 2},
  [1677] = {.lex_state = 85, .external_lex_state = 2},
  [1678] = {.lex_state = 85, .external_lex_state = 2},
  [1679] = {.lex_state = 85, .external_lex_state = 2},
  [1680] = {.lex_state = 85, .external_lex_state = 2},
  [1681] = {.lex_state = 85, .external_lex_state = 2},
  [1682] = {.lex_state = 85, .external_lex_state = 2},
  [1683] = {.lex_state = 85, .external_lex_state = 2},
  [1684] = {.lex_state = 85, .external_lex_state = 2},
  [1685] = {.lex_state = 85, .external_lex_state = 2},
  [1686] = {.lex_state = 85, .external_lex_state = 2},
  [1687] = {.lex_state = 85, .external_lex_state = 2},
  [1688] = {.lex_state = 85, .external_lex_state = 2},
  [1689] = {.lex_state = 85, .external_lex_state = 2},
  [1690] = {.lex_state = 85, .external_lex_state = 2},
  [1691] = {.lex_state = 85, .external_lex_state = 2},
  [1692] = {.lex_state = 85, .external_lex_state = 2},
  [1693] = {.lex_state = 85, .external_lex_state = 2},
  [1694] = {.lex_state = 85, .external_lex_state = 2},
  [1695] = {.lex_state = 85, .external_lex_state = 2},
  [1696] = {.lex_state = 85, .external_lex_state = 2},
  [1697] = {.lex_state = 85, .external_lex_state = 2},
  [1698] = {.lex_state = 87, .external_lex_state = 6},
  [1699] = {.lex_state = 85, .external_lex_state = 2},
  [1700] = {.lex_state = 85, .external_lex_state = 2},
  [1701] = {.lex_state = 85, .external_lex_state = 2},
  [1702] = {.lex_state = 85, .external_lex_state = 2},
  [1703] = {.lex_state = 85, .external_lex_state = 2},
  [1704] = {.lex_state = 85, .external_lex_state = 2},
  [1705] = {.lex_state = 85, .external_lex_state = 2},
  [1706] = {.lex_state = 87, .external_lex_state = 6},
  [1707] = {.lex_state = 85, .external_lex_state = 2},
  [1708] = {.lex_state = 85, .external_lex_state = 2},
  [1709] = {.lex_state = 85, .external_lex_state = 2},
  [1710] = {.lex_state = 85, .external_lex_state = 2},
  [1711] = {.lex_state = 87, .external_lex_state = 6},
  [1712] = {.lex_state = 85, .external_lex_state = 2},
  [1713] = {.lex_state = 85, .external_lex_state = 2},
  [1714] = {.lex_state = 85, .external_lex_state = 2},
  [1715] = {.lex_state = 85, .external_lex_state = 2},
  [1716] = {.lex_state = 85, .external_lex_state = 2},
  [1717] = {.lex_state = 85, .external_lex_state = 2},
  [1718] = {.lex_state = 85, .external_lex_state = 2},
  [1719] = {.lex_state = 85, .external_lex_state = 2},
  [1720] = {.lex_state = 85, .external_lex_state = 2},
  [1721] = {.lex_state = 85, .external_lex_state = 2},
  [1722] = {.lex_state = 85, .external_lex_state = 2},
  [1723] = {.lex_state = 85, .external_lex_state = 2},
  [1724] = {.lex_state = 85, .external_lex_state = 2},
  [1725] = {.lex_state = 85, .external_lex_state = 2},
  [1726] = {.lex_state = 85, .external_lex_state = 2},
  [1727] = {.lex_state = 85, .external_lex_state = 2},
  [1728] = {.lex_state = 85, .external_lex_state = 2},
  [1729] = {.lex_state = 85, .external_lex_state = 2},
  [1730] = {.lex_state = 85, .external_lex_state = 2},
  [1731] = {.lex_state = 85, .external_lex_state = 2},
  [1732] = {.lex_state = 85, .external_lex_state = 2},
  [1733] = {.lex_state = 85, .external_lex_state = 2},
  [1734] = {.lex_state = 85, .external_lex_state = 2},
  [1735] = {.lex_state = 85, .external_lex_state = 2},
  [1736] = {.lex_state = 85, .external_lex_state = 2},
  [1737] = {.lex_state = 85, .external_lex_state = 2},
  [1738] = {.lex_state = 85, .external_lex_state = 2},
  [1739] = {.lex_state = 85, .external_lex_state = 2},
  [1740] = {.lex_state = 85, .external_lex_state = 2},
  [1741] = {.lex_state = 85, .external_lex_state = 2},
  [1742] = {.lex_state = 85, .external_lex_state = 2},
  [1743] = {.lex_state = 85, .external_lex_state = 2},
  [1744] = {.lex_state = 85, .external_lex_state = 2},
  [1745] = {.lex_state = 85, .external_lex_state = 2},
  [1746] = {.lex_state = 85, .external_lex_state = 2},
  [1747] = {.lex_state = 85, .external_lex_state = 2},
  [1748] = {.lex_state = 85, .external_lex_state = 2},
  [1749] = {.lex_state = 85, .external_lex_state = 2},
  [1750] = {.lex_state = 85, .external_lex_state = 2},
  [1751] = {.lex_state = 85, .external_lex_state = 2},
  [1752] = {.lex_state = 85, .external_lex_state = 2},
  [1753] = {.lex_state = 85, .external_lex_state = 2},
  [1754] = {.lex_state = 85, .external_lex_state = 2},
  [1755] = {.lex_state = 85, .external_lex_state = 2},
  [1756] = {.lex_state = 85, .external_lex_state = 2},
  [1757] = {.lex_state = 85, .external_lex_state = 2},
  [1758] = {.lex_state = 85, .external_lex_state = 2},
  [1759] = {.lex_state = 85, .external_lex_state = 2},
  [1760] = {.lex_state = 85, .external_lex_state = 2},
  [1761] = {.lex_state = 85, .external_lex_state = 2},
  [1762] = {.lex_state = 85, .external_lex_state = 2},
  [1763] = {.lex_state = 85, .external_lex_state = 2},
  [1764] = {.lex_state = 85, .external_lex_state = 2},
  [1765] = {.lex_state = 85, .external_lex_state = 2},
  [1766] = {.lex_state = 85, .external_lex_state = 2},
  [1767] = {.lex_state = 85, .external_lex_state = 2},
  [1768] = {.lex_state = 85, .external_lex_state = 2},
  [1769] = {.lex_state = 85, .external_lex_state = 2},
  [1770] = {.lex_state = 85, .external_lex_state = 2},
  [1771] = {.lex_state = 85, .external_lex_state = 2},
  [1772] = {.lex_state = 85, .external_lex_state = 2},
  [1773] = {.lex_state = 85, .external_lex_state = 2},
  [1774] = {.lex_state = 85, .external_lex_state = 2},
  [1775] = {.lex_state = 85, .external_lex_state = 2},
  [1776] = {.lex_state = 85, .external_lex_state = 2},
  [1777] = {.lex_state = 85, .external_lex_state = 2},
  [1778] = {.lex_state = 85, .external_lex_state = 2},
  [1779] = {.lex_state = 85, .external_lex_state = 2},
  [1780] = {.lex_state = 85, .external_lex_state = 2},
  [1781] = {.lex_state = 85, .external_lex_state = 2},
  [1782] = {.lex_state = 85, .external_lex_state = 2},
  [1783] = {.lex_state = 85, .external_lex_state = 2},
  [1784] = {.lex_state = 85, .external_lex_state = 2},
  [1785] = {.lex_state = 85, .external_lex_state = 2},
  [1786] = {.lex_state = 85, .external_lex_state = 2},
  [1787] = {.lex_state = 85, .external_lex_state = 2},
  [1788] = {.lex_state = 85, .external_lex_state = 2},
  [1789] = {.lex_state = 85, .external_lex_state = 2},
  [1790] = {.lex_state = 85, .external_lex_state = 2},
  [1791] = {.lex_state = 85, .external_lex_state = 2},
  [1792] = {.lex_state = 85, .external_lex_state = 2},
  [1793] = {.lex_state = 85, .external_lex_state = 2},
  [1794] = {.lex_state = 85, .external_lex_state = 2},
  [1795] = {.lex_state = 85, .external_lex_state = 2},
  [1796] = {.lex_state = 85, .external_lex_state = 2},
  [1797] = {.lex_state = 85, .external_lex_state = 2},
  [1798] = {.lex_state = 85, .external_lex_state = 2},
  [1799] = {.lex_state = 85, .external_lex_state = 2},
  [1800] = {.lex_state = 85, .external_lex_state = 2},
  [1801] = {.lex_state = 85, .external_lex_state = 2},
  [1802] = {.lex_state = 85, .external_lex_state = 2},
  [1803] = {.lex_state = 85, .external_lex_state = 2},
  [1804] = {.lex_state = 85, .external_lex_state = 2},
  [1805] = {.lex_state = 85, .external_lex_state = 2},
  [1806] = {.lex_state = 85, .external_lex_state = 2},
  [1807] = {.lex_state = 85, .external_lex_state = 2},
  [1808] = {.lex_state = 85, .external_lex_state = 2},
  [1809] = {.lex_state = 85, .external_lex_state = 2},
  [1810] = {.lex_state = 85, .external_lex_state = 2},
  [1811] = {.lex_state = 85, .external_lex_state = 2},
  [1812] = {.lex_state = 85, .external_lex_state = 2},
  [1813] = {.lex_state = 85, .external_lex_state = 2},
  [1814] = {.lex_state = 85, .external_lex_state = 2},
  [1815] = {.lex_state = 85, .external_lex_state = 2},
  [1816] = {.lex_state = 85, .external_lex_state = 2},
  [1817] = {.lex_state = 85, .external_lex_state = 2},
  [1818] = {.lex_state = 85, .external_lex_state = 2},
  [1819] = {.lex_state = 85, .external_lex_state = 2},
  [1820] = {.lex_state = 85, .external_lex_state = 2},
  [1821] = {.lex_state = 85, .external_lex_state = 2},
  [1822] = {.lex_state = 85, .external_lex_state = 2},
  [1823] = {.lex_state = 85, .external_lex_state = 2},
  [1824] = {.lex_state = 85, .external_lex_state = 2},
  [1825] = {.lex_state = 85, .external_lex_state = 2},
  [1826] = {.lex_state = 85, .external_lex_state = 2},
  [1827] = {.lex_state = 85, .external_lex_state = 2},
  [1828] = {.lex_state = 85, .external_lex_state = 2},
  [1829] = {.lex_state = 85, .external_lex_state = 2},
  [1830] = {.lex_state = 85, .external_lex_state = 2},
  [1831] = {.lex_state = 85, .external_lex_state = 2},
  [1832] = {.lex_state = 85, .external_lex_state = 2},
  [1833] = {.lex_state = 85, .external_lex_state = 2},
  [1834] = {.lex_state = 85, .external_lex_state = 2},
  [1835] = {.lex_state = 85, .external_lex_state = 2},
  [1836] = {.lex_state = 85, .external_lex_state = 2},
  [1837] = {.lex_state = 85, .external_lex_state = 2},
  [1838] = {.lex_state = 85, .external_lex_state = 2},
  [1839] = {.lex_state = 85, .external_lex_state = 2},
  [1840] = {.lex_state = 85, .external_lex_state = 2},
  [1841] = {.lex_state = 85, .external_lex_state = 2},
  [1842] = {.lex_state = 85, .external_lex_state = 2},
  [1843] = {.lex_state = 93, .external_lex_state = 4},
  [1844] = {.lex_state = 85, .external_lex_state = 2},
  [1845] = {.lex_state = 93, .external_lex_state = 4},
  [1846] = {.lex_state = 85, .external_lex_state = 2},
  [1847] = {.lex_state = 85, .external_lex_state = 2},
  [1848] = {.lex_state = 85, .external_lex_state = 2},
  [1849] = {.lex_state = 85, .external_lex_state = 2},
  [1850] = {.lex_state = 85, .external_lex_state = 2},
  [1851] = {.lex_state = 85, .external_lex_state = 2},
  [1852] = {.lex_state = 85, .external_lex_state = 2},
  [1853] = {.lex_state = 92, .external_lex_state = 4},
  [1854] = {.lex_state = 85, .external_lex_state = 2},
  [1855] = {.lex_state = 85, .external_lex_state = 2},
  [1856] = {.lex_state = 85, .external_lex_state = 2},
  [1857] = {.lex_state = 85, .external_lex_state = 2},
  [1858] = {.lex_state = 93, .external_lex_state = 4},
  [1859] = {.lex_state = 85, .external_lex_state = 2},
  [1860] = {.lex_state = 85, .external_lex_state = 2},
  [1861] = {.lex_state = 85, .external_lex_state = 2},
  [1862] = {.lex_state = 85, .external_lex_state = 2},
  [1863] = {.lex_state = 85, .external_lex_state = 2},
  [1864] = {.lex_state = 85, .external_lex_state = 2},
  [1865] = {.lex_state = 85, .external_lex_state = 2},
  [1866] = {.lex_state = 85, .external_lex_state = 2},
  [1867] = {.lex_state = 85, .external_lex_state = 2},
  [1868] = {.lex_state = 85, .external_lex_state = 2},
  [1869] = {.lex_state = 93, .external_lex_state = 4},
  [1870] = {.lex_state = 85, .external_lex_state = 2},
  [1871] = {.lex_state = 85, .external_lex_state = 2},
  [1872] = {.lex_state = 85, .external_lex_state = 2},
  [1873] = {.lex_state = 85, .external_lex_state = 2},
  [1874] = {.lex_state = 85, .external_lex_state = 2},
  [1875] = {.lex_state = 85, .external_lex_state = 2},
  [1876] = {.lex_state = 85, .external_lex_state = 2},
  [1877] = {.lex_state = 85, .external_lex_state = 2},
  [1878] = {.lex_state = 85, .external_lex_state = 2},
  [1879] = {.lex_state = 85, .external_lex_state = 2},
  [1880] = {.lex_state = 85, .external_lex_state = 2},
  [1881] = {.lex_state = 85, .external_lex_state = 2},
  [1882] = {.lex_state = 85, .external_lex_state = 2},
  [1883] = {.lex_state = 85, .external_lex_state = 2},
  [1884] = {.lex_state = 85, .external_lex_state = 2},
  [1885] = {.lex_state = 85, .external_lex_state = 2},
  [1886] = {.lex_state = 85, .external_lex_state = 2},
  [1887] = {.lex_state = 85, .external_lex_state = 2},
  [1888] = {.lex_state = 85, .external_lex_state = 2},
  [1889] = {.lex_state = 85, .external_lex_state = 2},
  [1890] = {.lex_state = 85, .external_lex_state = 2},
  [1891] = {.lex_state = 85, .external_lex_state = 2},
  [1892] = {.lex_state = 85, .external_lex_state = 2},
  [1893] = {.lex_state = 85, .external_lex_state = 2},
  [1894] = {.lex_state = 85, .external_lex_state = 2},
  [1895] = {.lex_state = 85, .external_lex_state = 2},
  [1896] = {.lex_state = 85, .external_lex_state = 2},
  [1897] = {.lex_state = 85, .external_lex_state = 2},
  [1898] = {.lex_state = 85, .external_lex_state = 2},
  [1899] = {.lex_state = 85, .external_lex_state = 2},
  [1900] = {.lex_state = 85, .external_lex_state = 2},
  [1901] = {.lex_state = 85, .external_lex_state = 2},
  [1902] = {.lex_state = 85, .external_lex_state = 2},
  [1903] = {.lex_state = 85, .external_lex_state = 2},
  [1904] = {.lex_state = 85, .external_lex_state = 2},
  [1905] = {.lex_state = 85, .external_lex_state = 2},
  [1906] = {.lex_state = 85, .external_lex_state = 2},
  [1907] = {.lex_state = 85, .external_lex_state = 2},
  [1908] = {.lex_state = 85, .external_lex_state = 2},
  [1909] = {.lex_state = 85, .external_lex_state = 2},
  [1910] = {.lex_state = 85, .external_lex_state = 2},
  [1911] = {.lex_state = 85, .external_lex_state = 2},
  [1912] = {.lex_state = 85, .external_lex_state = 2},
  [1913] = {.lex_state = 85, .external_lex_state = 2},
  [1914] = {.lex_state = 85, .external_lex_state = 2},
  [1915] = {.lex_state = 85, .external_lex_state = 2},
  [1916] = {.lex_state = 85, .external_lex_state = 2},
  [1917] = {.lex_state = 85, .external_lex_state = 2},
  [1918] = {.lex_state = 85, .external_lex_state = 2},
  [1919] = {.lex_state = 85, .external_lex_state = 2},
  [1920] = {.lex_state = 85, .external_lex_state = 2},
  [1921] = {.lex_state = 85, .external_lex_state = 2},
  [1922] = {.lex_state = 85, .external_lex_state = 2},
  [1923] = {.lex_state = 85, .external_lex_state = 2},
  [1924] = {.lex_state = 85, .external_lex_state = 2},
  [1925] = {.lex_state = 85, .external_lex_state = 2},
  [1926] = {.lex_state = 85, .external_lex_state = 2},
  [1927] = {.lex_state = 85, .external_lex_state = 2},
  [1928] = {.lex_state = 85, .external_lex_state = 2},
  [1929] = {.lex_state = 85, .external_lex_state = 2},
  [1930] = {.lex_state = 85, .external_lex_state = 2},
  [1931] = {.lex_state = 85, .external_lex_state = 2},
  [1932] = {.lex_state = 85, .external_lex_state = 2},
  [1933] = {.lex_state = 85, .external_lex_state = 2},
  [1934] = {.lex_state = 85, .external_lex_state = 2},
  [1935] = {.lex_state = 85, .external_lex_state = 2},
  [1936] = {.lex_state = 85, .external_lex_state = 2},
  [1937] = {.lex_state = 85, .external_lex_state = 2},
  [1938] = {.lex_state = 85, .external_lex_state = 2},
  [1939] = {.lex_state = 85, .external_lex_state = 2},
  [1940] = {.lex_state = 85, .external_lex_state = 2},
  [1941] = {.lex_state = 85, .external_lex_state = 2},
  [1942] = {.lex_state = 85, .external_lex_state = 2},
  [1943] = {.lex_state = 85, .external_lex_state = 2},
  [1944] = {.lex_state = 85, .external_lex_state = 2},
  [1945] = {.lex_state = 85, .external_lex_state = 2},
  [1946] = {.lex_state = 85, .external_lex_state = 2},
  [1947] = {.lex_state = 85, .external_lex_state = 2},
  [1948] = {.lex_state = 85, .external_lex_state = 2},
  [1949] = {.lex_state = 85, .external_lex_state = 2},
  [1950] = {.lex_state = 85, .external_lex_state = 2},
  [1951] = {.lex_state = 85, .external_lex_state = 2},
  [1952] = {.lex_state = 85, .external_lex_state = 2},
  [1953] = {.lex_state = 85, .external_lex_state = 2},
  [1954] = {.lex_state = 85, .external_lex_state = 2},
  [1955] = {.lex_state = 85, .external_lex_state = 2},
  [1956] = {.lex_state = 85, .external_lex_state = 2},
  [1957] = {.lex_state = 85, .external_lex_state = 2},
  [1958] = {.lex_state = 85, .external_lex_state = 2},
  [1959] = {.lex_state = 85, .external_lex_state = 2},
  [1960] = {.lex_state = 85, .external_lex_state = 2},
  [1961] = {.lex_state = 85, .external_lex_state = 2},
  [1962] = {.lex_state = 85, .external_lex_state = 2},
  [1963] = {.lex_state = 85, .external_lex_state = 2},
  [1964] = {.lex_state = 85, .external_lex_state = 2},
  [1965] = {.lex_state = 85, .external_lex_state = 2},
  [1966] = {.lex_state = 85, .external_lex_state = 2},
  [1967] = {.lex_state = 85, .external_lex_state = 2},
  [1968] = {.lex_state = 85, .external_lex_state = 2},
  [1969] = {.lex_state = 85, .external_lex_state = 2},
  [1970] = {.lex_state = 85, .external_lex_state = 2},
  [1971] = {.lex_state = 85, .external_lex_state = 2},
  [1972] = {.lex_state = 85, .external_lex_state = 2},
  [1973] = {.lex_state = 85, .external_lex_state = 2},
  [1974] = {.lex_state = 85, .external_lex_state = 2},
  [1975] = {.lex_state = 85, .external_lex_state = 2},
  [1976] = {.lex_state = 85, .external_lex_state = 2},
  [1977] = {.lex_state = 85, .external_lex_state = 2},
  [1978] = {.lex_state = 85, .external_lex_state = 2},
  [1979] = {.lex_state = 85, .external_lex_state = 2},
  [1980] = {.lex_state = 85, .external_lex_state = 2},
  [1981] = {.lex_state = 85, .external_lex_state = 2},
  [1982] = {.lex_state = 85, .external_lex_state = 2},
  [1983] = {.lex_state = 85, .external_lex_state = 2},
  [1984] = {.lex_state = 85, .external_lex_state = 2},
  [1985] = {.lex_state = 85, .external_lex_state = 2},
  [1986] = {.lex_state = 85, .external_lex_state = 2},
  [1987] = {.lex_state = 85, .external_lex_state = 2},
  [1988] = {.lex_state = 85, .external_lex_state = 2},
  [1989] = {.lex_state = 85, .external_lex_state = 2},
  [1990] = {.lex_state = 85, .external_lex_state = 2},
  [1991] = {.lex_state = 85, .external_lex_state = 2},
  [1992] = {.lex_state = 85, .external_lex_state = 2},
  [1993] = {.lex_state = 85, .external_lex_state = 2},
  [1994] = {.lex_state = 85, .external_lex_state = 2},
  [1995] = {.lex_state = 85, .external_lex_state = 2},
  [1996] = {.lex_state = 85, .external_lex_state = 2},
  [1997] = {.lex_state = 85, .external_lex_state = 2},
  [1998] = {.lex_state = 93, .external_lex_state = 4},
  [1999] = {.lex_state = 85, .external_lex_state = 2},
  [2000] = {.lex_state = 85, .external_lex_state = 2},
  [2001] = {.lex_state = 85, .external_lex_state = 2},
  [2002] = {.lex_state = 85, .external_lex_state = 2},
  [2003] = {.lex_state = 85, .external_lex_state = 2},
  [2004] = {.lex_state = 85, .external_lex_state = 2},
  [2005] = {.lex_state = 85, .external_lex_state = 2},
  [2006] = {.lex_state = 85, .external_lex_state = 2},
  [2007] = {.lex_state = 85, .external_lex_state = 2},
  [2008] = {.lex_state = 85, .external_lex_state = 2},
  [2009] = {.lex_state = 85, .external_lex_state = 2},
  [2010] = {.lex_state = 85, .external_lex_state = 2},
  [2011] = {.lex_state = 85, .external_lex_state = 2},
  [2012] = {.lex_state = 92, .external_lex_state = 5},
  [2013] = {.lex_state = 85, .external_lex_state = 2},
  [2014] = {.lex_state = 85, .external_lex_state = 2},
  [2015] = {.lex_state = 85, .external_lex_state = 2},
  [2016] = {.lex_state = 85, .external_lex_state = 2},
  [2017] = {.lex_state = 85, .external_lex_state = 2},
  [2018] = {.lex_state = 85, .external_lex_state = 2},
  [2019] = {.lex_state = 85, .external_lex_state = 2},
  [2020] = {.lex_state = 85, .external_lex_state = 2},
  [2021] = {.lex_state = 85, .external_lex_state = 2},
  [2022] = {.lex_state = 85, .external_lex_state = 2},
  [2023] = {.lex_state = 85, .external_lex_state = 2},
  [2024] = {.lex_state = 85, .external_lex_state = 2},
  [2025] = {.lex_state = 85, .external_lex_state = 2},
  [2026] = {.lex_state = 85, .external_lex_state = 2},
  [2027] = {.lex_state = 85, .external_lex_state = 2},
  [2028] = {.lex_state = 85, .external_lex_state = 2},
  [2029] = {.lex_state = 85, .external_lex_state = 2},
  [2030] = {.lex_state = 85, .external_lex_state = 2},
  [2031] = {.lex_state = 85, .external_lex_state = 2},
  [2032] = {.lex_state = 85, .external_lex_state = 2},
  [2033] = {.lex_state = 85, .external_lex_state = 2},
  [2034] = {.lex_state = 85, .external_lex_state = 2},
  [2035] = {.lex_state = 85, .external_lex_state = 2},
  [2036] = {.lex_state = 85, .external_lex_state = 2},
  [2037] = {.lex_state = 85, .external_lex_state = 2},
  [2038] = {.lex_state = 85, .external_lex_state = 2},
  [2039] = {.lex_state = 85, .external_lex_state = 2},
  [2040] = {.lex_state = 85, .external_lex_state = 2},
  [2041] = {.lex_state = 93, .external_lex_state = 4},
  [2042] = {.lex_state = 85, .external_lex_state = 2},
  [2043] = {.lex_state = 85, .external_lex_state = 2},
  [2044] = {.lex_state = 85, .external_lex_state = 2},
  [2045] = {.lex_state = 85, .external_lex_state = 2},
  [2046] = {.lex_state = 85, .external_lex_state = 2},
  [2047] = {.lex_state = 92, .external_lex_state = 5},
  [2048] = {.lex_state = 85, .external_lex_state = 2},
  [2049] = {.lex_state = 85, .external_lex_state = 2},
  [2050] = {.lex_state = 85, .external_lex_state = 2},
  [2051] = {.lex_state = 85, .external_lex_state = 2},
  [2052] = {.lex_state = 85, .external_lex_state = 2},
  [2053] = {.lex_state = 85, .external_lex_state = 2},
  [2054] = {.lex_state = 85, .external_lex_state = 2},
  [2055] = {.lex_state = 85, .external_lex_state = 2},
  [2056] = {.lex_state = 85, .external_lex_state = 2},
  [2057] = {.lex_state = 85, .external_lex_state = 2},
  [2058] = {.lex_state = 85, .external_lex_state = 2},
  [2059] = {.lex_state = 85, .external_lex_state = 2},
  [2060] = {.lex_state = 85, .external_lex_state = 2},
  [2061] = {.lex_state = 85, .external_lex_state = 2},
  [2062] = {.lex_state = 85, .external_lex_state = 2},
  [2063] = {.lex_state = 85, .external_lex_state = 2},
  [2064] = {.lex_state = 85, .external_lex_state = 2},
  [2065] = {.lex_state = 85, .external_lex_state = 2},
  [2066] = {.lex_state = 85, .external_lex_state = 2},
  [2067] = {.lex_state = 85, .external_lex_state = 2},
  [2068] = {.lex_state = 85, .external_lex_state = 2},
  [2069] = {.lex_state = 85, .external_lex_state = 2},
  [2070] = {.lex_state = 85, .external_lex_state = 2},
  [2071] = {.lex_state = 85, .external_lex_state = 2},
  [2072] = {.lex_state = 85, .external_lex_state = 2},
  [2073] = {.lex_state = 85, .external_lex_state = 2},
  [2074] = {.lex_state = 85, .external_lex_state = 2},
  [2075] = {.lex_state = 85, .external_lex_state = 2},
  [2076] = {.lex_state = 85, .external_lex_state = 2},
  [2077] = {.lex_state = 85, .external_lex_state = 2},
  [2078] = {.lex_state = 85, .external_lex_state = 2},
  [2079] = {.lex_state = 85, .external_lex_state = 2},
  [2080] = {.lex_state = 85, .external_lex_state = 2},
  [2081] = {.lex_state = 85, .external_lex_state = 2},
  [2082] = {.lex_state = 85, .external_lex_state = 2},
  [2083] = {.lex_state = 85, .external_lex_state = 2},
  [2084] = {.lex_state = 93, .external_lex_state = 4},
  [2085] = {.lex_state = 85, .external_lex_state = 2},
  [2086] = {.lex_state = 85, .external_lex_state = 2},
  [2087] = {.lex_state = 85, .external_lex_state = 2},
  [2088] = {.lex_state = 85, .external_lex_state = 2},
  [2089] = {.lex_state = 85, .external_lex_state = 2},
  [2090] = {.lex_state = 92, .external_lex_state = 5},
  [2091] = {.lex_state = 85, .external_lex_state = 2},
  [2092] = {.lex_state = 93, .external_lex_state = 4},
  [2093] = {.lex_state = 85, .external_lex_state = 2},
  [2094] = {.lex_state = 85, .external_lex_state = 2},
  [2095] = {.lex_state = 85, .external_lex_state = 2},
  [2096] = {.lex_state = 85, .external_lex_state = 2},
  [2097] = {.lex_state = 85, .external_lex_state = 2},
  [2098] = {.lex_state = 85, .external_lex_state = 2},
  [2099] = {.lex_state = 85, .external_lex_state = 2},
  [2100] = {.lex_state = 85, .external_lex_state = 2},
  [2101] = {.lex_state = 85, .external_lex_state = 2},
  [2102] = {.lex_state = 85, .external_lex_state = 2},
  [2103] = {.lex_state = 85, .external_lex_state = 2},
  [2104] = {.lex_state = 93, .external_lex_state = 4},
  [2105] = {.lex_state = 93, .external_lex_state = 5},
  [2106] = {.lex_state = 91, .external_lex_state = 6},
  [2107] = {.lex_state = 91, .external_lex_state = 6},
  [2108] = {.lex_state = 91, .external_lex_state = 6},
  [2109] = {.lex_state = 91, .external_lex_state = 6},
  [2110] = {.lex_state = 91, .external_lex_state = 6},
  [2111] = {.lex_state = 91, .external_lex_state = 6},
  [2112] = {.lex_state = 91, .external_lex_state = 6},
  [2113] = {.lex_state = 91, .external_lex_state = 6},
  [2114] = {.lex_state = 91, .external_lex_state = 6},
  [2115] = {.lex_state = 91, .external_lex_state = 6},
  [2116] = {.lex_state = 91, .external_lex_state = 6},
  [2117] = {.lex_state = 91, .external_lex_state = 6},
  [2118] = {.lex_state = 91, .external_lex_state = 6},
  [2119] = {.lex_state = 93, .external_lex_state = 4},
  [2120] = {.lex_state = 91, .external_lex_state = 6},
  [2121] = {.lex_state = 91, .external_lex_state = 6},
  [2122] = {.lex_state = 91, .external_lex_state = 6},
  [2123] = {.lex_state = 87, .external_lex_state = 6},
  [2124] = {.lex_state = 91, .external_lex_state = 6},
  [2125] = {.lex_state = 91, .external_lex_state = 6},
  [2126] = {.lex_state = 93, .external_lex_state = 4},
  [2127] = {.lex_state = 93, .external_lex_state = 4},
  [2128] = {.lex_state = 93, .external_lex_state = 4},
  [2129] = {.lex_state = 93, .external_lex_state = 4},
  [2130] = {.lex_state = 93, .external_lex_state = 4},
  [2131] = {.lex_state = 93, .external_lex_state = 4},
  [2132] = {.lex_state = 93, .external_lex_state = 4},
  [2133] = {.lex_state = 93, .external_lex_state = 4},
  [2134] = {.lex_state = 93, .external_lex_state = 4},
  [2135] = {.lex_state = 92, .external_lex_state = 5},
  [2136] = {.lex_state = 93, .external_lex_state = 4},
  [2137] = {.lex_state = 93, .external_lex_state = 4},
  [2138] = {.lex_state = 93, .external_lex_state = 4},
  [2139] = {.lex_state = 93, .external_lex_state = 4},
  [2140] = {.lex_state = 93, .external_lex_state = 4},
  [2141] = {.lex_state = 93, .external_lex_state = 4},
  [2142] = {.lex_state = 93, .external_lex_state = 4},
  [2143] = {.lex_state = 93, .external_lex_state = 4},
  [2144] = {.lex_state = 93, .external_lex_state = 4},
  [2145] = {.lex_state = 93, .external_lex_state = 4},
  [2146] = {.lex_state = 93, .external_lex_state = 4},
  [2147] = {.lex_state = 93, .external_lex_state = 4},
  [2148] = {.lex_state = 91, .external_lex_state = 6},
  [2149] = {.lex_state = 93, .external_lex_state = 4},
  [2150] = {.lex_state = 93, .external_lex_state = 4},
  [2151] = {.lex_state = 93, .external_lex_state = 4},
  [2152] = {.lex_state = 93, .external_lex_state = 4},
  [2153] = {.lex_state = 91, .external_lex_state = 6},
  [2154] = {.lex_state = 93, .external_lex_state = 4},
  [2155] = {.lex_state = 93, .external_lex_state = 4},
  [2156] = {.lex_state = 93, .external_lex_state = 4},
  [2157] = {.lex_state = 93, .external_lex_state = 4},
  [2158] = {.lex_state = 93, .external_lex_state = 4},
  [2159] = {.lex_state = 93, .external_lex_state = 4},
  [2160] = {.lex_state = 93, .external_lex_state = 4},
  [2161] = {.lex_state = 93, .external_lex_state = 4},
  [2162] = {.lex_state = 93, .external_lex_state = 4},
  [2163] = {.lex_state = 93, .external_lex_state = 4},
  [2164] = {.lex_state = 93, .external_lex_state = 4},
  [2165] = {.lex_state = 93, .external_lex_state = 4},
  [2166] = {.lex_state = 93, .external_lex_state = 4},
  [2167] = {.lex_state = 93, .external_lex_state = 4},
  [2168] = {.lex_state = 93, .external_lex_state = 4},
  [2169] = {.lex_state = 93, .external_lex_state = 4},
  [2170] = {.lex_state = 93, .external_lex_state = 4},
  [2171] = {.lex_state = 93, .external_lex_state = 4},
  [2172] = {.lex_state = 93, .external_lex_state = 4},
  [2173] = {.lex_state = 93, .external_lex_state = 4},
  [2174] = {.lex_state = 93, .external_lex_state = 4},
  [2175] = {.lex_state = 93, .external_lex_state = 4},
  [2176] = {.lex_state = 93, .external_lex_state = 4},
  [2177] = {.lex_state = 91, .external_lex_state = 6},
  [2178] = {.lex_state = 93, .external_lex_state = 4},
  [2179] = {.lex_state = 91, .external_lex_state = 6},
  [2180] = {.lex_state = 93, .external_lex_state = 4},
  [2181] = {.lex_state = 93, .external_lex_state = 4},
  [2182] = {.lex_state = 93, .external_lex_state = 4},
  [2183] = {.lex_state = 93, .external_lex_state = 4},
  [2184] = {.lex_state = 93, .external_lex_state = 5},
  [2185] = {.lex_state = 91, .external_lex_state = 6},
  [2186] = {.lex_state = 86, .external_lex_state = 2},
  [2187] = {.lex_state = 93, .external_lex_state = 5},
  [2188] = {.lex_state = 93, .external_lex_state = 5},
  [2189] = {.lex_state = 93, .external_lex_state = 5},
  [2190] = {.lex_state = 93, .external_lex_state = 5},
  [2191] = {.lex_state = 93, .external_lex_state = 5},
  [2192] = {.lex_state = 93, .external_lex_state = 5},
  [2193] = {.lex_state = 93, .external_lex_state = 5},
  [2194] = {.lex_state = 93, .external_lex_state = 4},
  [2195] = {.lex_state = 91, .external_lex_state = 6},
  [2196] = {.lex_state = 91, .external_lex_state = 6},
  [2197] = {.lex_state = 93, .external_lex_state = 5},
  [2198] = {.lex_state = 93, .external_lex_state = 5},
  [2199] = {.lex_state = 93, .external_lex_state = 5},
  [2200] = {.lex_state = 93, .external_lex_state = 5},
  [2201] = {.lex_state = 93, .external_lex_state = 5},
  [2202] = {.lex_state = 93, .external_lex_state = 5},
  [2203] = {.lex_state = 93, .external_lex_state = 5},
  [2204] = {.lex_state = 93, .external_lex_state = 5},
  [2205] = {.lex_state = 93, .external_lex_state = 5},
  [2206] = {.lex_state = 93, .external_lex_state = 5},
  [2207] = {.lex_state = 93, .external_lex_state = 5},
  [2208] = {.lex_state = 93, .external_lex_state = 5},
  [2209] = {.lex_state = 93, .external_lex_state = 5},
  [2210] = {.lex_state = 93, .external_lex_state = 5},
  [2211] = {.lex_state = 93, .external_lex_state = 5},
  [2212] = {.lex_state = 93, .external_lex_state = 5},
  [2213] = {.lex_state = 93, .external_lex_state = 5},
  [2214] = {.lex_state = 93, .external_lex_state = 5},
  [2215] = {.lex_state = 93, .external_lex_state = 5},
  [2216] = {.lex_state = 93, .external_lex_state = 5},
  [2217] = {.lex_state = 93, .external_lex_state = 5},
  [2218] = {.lex_state = 93, .external_lex_state = 5},
  [2219] = {.lex_state = 93, .external_lex_state = 5},
  [2220] = {.lex_state = 93, .external_lex_state = 5},
  [2221] = {.lex_state = 93, .external_lex_state = 5},
  [2222] = {.lex_state = 93, .external_lex_state = 5},
  [2223] = {.lex_state = 93, .external_lex_state = 5},
  [2224] = {.lex_state = 93, .external_lex_state = 5},
  [2225] = {.lex_state = 93, .external_lex_state = 5},
  [2226] = {.lex_state = 93, .external_lex_state = 5},
  [2227] = {.lex_state = 93, .external_lex_state = 5},
  [2228] = {.lex_state = 93, .external_lex_state = 5},
  [2229] = {.lex_state = 91, .external_lex_state = 6},
  [2230] = {.lex_state = 93, .external_lex_state = 5},
  [2231] = {.lex_state = 93, .external_lex_state = 5},
  [2232] = {.lex_state = 93, .external_lex_state = 5},
  [2233] = {.lex_state = 91, .external_lex_state = 6},
  [2234] = {.lex_state = 93, .external_lex_state = 5},
  [2235] = {.lex_state = 93, .external_lex_state = 5},
  [2236] = {.lex_state = 93, .external_lex_state = 5},
  [2237] = {.lex_state = 93, .external_lex_state = 5},
  [2238] = {.lex_state = 93, .external_lex_state = 5},
  [2239] = {.lex_state = 93, .external_lex_state = 5},
  [2240] = {.lex_state = 91, .external_lex_state = 6},
  [2241] = {.lex_state = 93, .external_lex_state = 5},
  [2242] = {.lex_state = 93, .external_lex_state = 5},
  [2243] = {.lex_state = 93, .external_lex_state = 5},
  [2244] = {.lex_state = 93, .external_lex_state = 5},
  [2245] = {.lex_state = 91, .external_lex_state = 6},
  [2246] = {.lex_state = 93, .external_lex_state = 5},
  [2247] = {.lex_state = 93, .external_lex_state = 5},
  [2248] = {.lex_state = 93, .external_lex_state = 5},
  [2249] = {.lex_state = 93, .external_lex_state = 5},
  [2250] = {.lex_state = 93, .external_lex_state = 5},
  [2251] = {.lex_state = 91, .external_lex_state = 6},
  [2252] = {.lex_state = 91, .external_lex_state = 6},
  [2253] = {.lex_state = 93, .external_lex_state = 5},
  [2254] = {.lex_state = 91, .external_lex_state = 6},
  [2255] = {.lex_state = 91, .external_lex_state = 6},
  [2256] = {.lex_state = 93, .external_lex_state = 5},
  [2257] = {.lex_state = 93, .external_lex_state = 5},
  [2258] = {.lex_state = 93, .external_lex_state = 5},
  [2259] = {.lex_state = 91, .external_lex_state = 6},
  [2260] = {.lex_state = 91, .external_lex_state = 6},
  [2261] = {.lex_state = 91, .external_lex_state = 6},
  [2262] = {.lex_state = 91, .external_lex_state = 6},
  [2263] = {.lex_state = 91, .external_lex_state = 6},
  [2264] = {.lex_state = 91, .external_lex_state = 6},
  [2265] = {.lex_state = 91, .external_lex_state = 6},
  [2266] = {.lex_state = 86, .external_lex_state = 2},
  [2267] = {.lex_state = 91, .external_lex_state = 6},
  [2268] = {.lex_state = 91, .external_lex_state = 6},
  [2269] = {.lex_state = 91, .external_lex_state = 6},
  [2270] = {.lex_state = 91, .external_lex_state = 6},
  [2271] = {.lex_state = 91, .external_lex_state = 6},
  [2272] = {.lex_state = 91, .external_lex_state = 6},
  [2273] = {.lex_state = 91, .external_lex_state = 6},
  [2274] = {.lex_state = 91, .external_lex_state = 6},
  [2275] = {.lex_state = 93, .external_lex_state = 5},
  [2276] = {.lex_state = 93, .external_lex_state = 5},
  [2277] = {.lex_state = 91, .external_lex_state = 6},
  [2278] = {.lex_state = 91, .external_lex_state = 6},
  [2279] = {.lex_state = 93, .external_lex_state = 5},
  [2280] = {.lex_state = 91, .external_lex_state = 6},
  [2281] = {.lex_state = 91, .external_lex_state = 6},
  [2282] = {.lex_state = 91, .external_lex_state = 6},
  [2283] = {.lex_state = 91, .external_lex_state = 6},
  [2284] = {.lex_state = 91, .external_lex_state = 6},
  [2285] = {.lex_state = 91, .external_lex_state = 6},
  [2286] = {.lex_state = 91, .external_lex_state = 6},
  [2287] = {.lex_state = 91, .external_lex_state = 6},
  [2288] = {.lex_state = 91, .external_lex_state = 6},
  [2289] = {.lex_state = 91, .external_lex_state = 6},
  [2290] = {.lex_state = 91, .external_lex_state = 6},
  [2291] = {.lex_state = 91, .external_lex_state = 6},
  [2292] = {.lex_state = 91, .external_lex_state = 6},
  [2293] = {.lex_state = 93, .external_lex_state = 5},
  [2294] = {.lex_state = 91, .external_lex_state = 6},
  [2295] = {.lex_state = 91, .external_lex_state = 6},
  [2296] = {.lex_state = 91, .external_lex_state = 6},
  [2297] = {.lex_state = 91, .external_lex_state = 6},
  [2298] = {.lex_state = 91, .external_lex_state = 6},
  [2299] = {.lex_state = 93, .external_lex_state = 5},
  [2300] = {.lex_state = 93, .external_lex_state = 5},
  [2301] = {.lex_state = 91, .external_lex_state = 6},
  [2302] = {.lex_state = 91, .external_lex_state = 6},
  [2303] = {.lex_state = 93, .external_lex_state = 5},
  [2304] = {.lex_state = 93, .external_lex_state = 5},
  [2305] = {.lex_state = 93, .external_lex_state = 5},
  [2306] = {.lex_state = 91, .external_lex_state = 6},
  [2307] = {.lex_state = 93, .external_lex_state = 5},
  [2308] = {.lex_state = 91, .external_lex_state = 6},
  [2309] = {.lex_state = 91, .external_lex_state = 6},
  [2310] = {.lex_state = 93, .external_lex_state = 5},
  [2311] = {.lex_state = 93, .external_lex_state = 5},
  [2312] = {.lex_state = 93, .external_lex_state = 5},
  [2313] = {.lex_state = 93, .external_lex_state = 5},
  [2314] = {.lex_state = 93, .external_lex_state = 5},
  [2315] = {.lex_state = 93, .external_lex_state = 5},
  [2316] = {.lex_state = 91, .external_lex_state = 6},
  [2317] = {.lex_state = 93, .external_lex_state = 5},
  [2318] = {.lex_state = 91, .external_lex_state = 6},
  [2319] = {.lex_state = 93, .external_lex_state = 5},
  [2320] = {.lex_state = 91, .external_lex_state = 6},
  [2321] = {.lex_state = 91, .external_lex_state = 6},
  [2322] = {.lex_state = 93, .external_lex_state = 5},
  [2323] = {.lex_state = 91, .external_lex_state = 6},
  [2324] = {.lex_state = 91, .external_lex_state = 6},
  [2325] = {.lex_state = 91, .external_lex_state = 6},
  [2326] = {.lex_state = 93, .external_lex_state = 5},
  [2327] = {.lex_state = 93, .external_lex_state = 5},
  [2328] = {.lex_state = 93, .external_lex_state = 5},
  [2329] = {.lex_state = 93, .external_lex_state = 5},
  [2330] = {.lex_state = 91, .external_lex_state = 6},
  [2331] = {.lex_state = 91, .external_lex_state = 6},
  [2332] = {.lex_state = 93, .external_lex_state = 5},
  [2333] = {.lex_state = 91, .external_lex_state = 6},
  [2334] = {.lex_state = 91, .external_lex_state = 6},
  [2335] = {.lex_state = 93, .external_lex_state = 5},
  [2336] = {.lex_state = 91, .external_lex_state = 6},
  [2337] = {.lex_state = 91, .external_lex_state = 6},
  [2338] = {.lex_state = 91, .external_lex_state = 6},
  [2339] = {.lex_state = 91, .external_lex_state = 6},
  [2340] = {.lex_state = 93, .external_lex_state = 5},
  [2341] = {.lex_state = 91, .external_lex_state = 6},
  [2342] = {.lex_state = 91, .external_lex_state = 6},
  [2343] = {.lex_state = 93, .external_lex_state = 5},
  [2344] = {.lex_state = 91, .external_lex_state = 6},
  [2345] = {.lex_state = 91, .external_lex_state = 6},
  [2346] = {.lex_state = 91, .external_lex_state = 6},
  [2347] = {.lex_state = 91, .external_lex_state = 6},
  [2348] = {.lex_state = 91, .external_lex_state = 6},
  [2349] = {.lex_state = 91, .external_lex_state = 6},
  [2350] = {.lex_state = 91, .external_lex_state = 6},
  [2351] = {.lex_state = 91, .external_lex_state = 6},
  [2352] = {.lex_state = 91, .external_lex_state = 6},
  [2353] = {.lex_state = 93, .external_lex_state = 5},
  [2354] = {.lex_state = 91, .external_lex_state = 6},
  [2355] = {.lex_state = 93, .external_lex_state = 5},
  [2356] = {.lex_state = 86, .external_lex_state = 2},
  [2357] = {.lex_state = 91, .external_lex_state = 6},
  [2358] = {.lex_state = 91, .external_lex_state = 6},
  [2359] = {.lex_state = 91, .external_lex_state = 6},
  [2360] = {.lex_state = 91, .external_lex_state = 6},
  [2361] = {.lex_state = 91, .external_lex_state = 6},
  [2362] = {.lex_state = 91, .external_lex_state = 6},
  [2363] = {.lex_state = 86, .external_lex_state = 2},
  [2364] = {.lex_state = 91, .external_lex_state = 6},
  [2365] = {.lex_state = 93, .external_lex_state = 5},
  [2366] = {.lex_state = 93, .external_lex_state = 5},
  [2367] = {.lex_state = 91, .external_lex_state = 6},
  [2368] = {.lex_state = 91, .external_lex_state = 6},
  [2369] = {.lex_state = 91, .external_lex_state = 6},
  [2370] = {.lex_state = 91, .external_lex_state = 6},
  [2371] = {.lex_state = 91, .external_lex_state = 6},
  [2372] = {.lex_state = 93, .external_lex_state = 5},
  [2373] = {.lex_state = 93, .external_lex_state = 5},
  [2374] = {.lex_state = 93, .external_lex_state = 5},
  [2375] = {.lex_state = 91, .external_lex_state = 6},
  [2376] = {.lex_state = 91, .external_lex_state = 6},
  [2377] = {.lex_state = 91, .external_lex_state = 6},
  [2378] = {.lex_state = 91, .external_lex_state = 6},
  [2379] = {.lex_state = 91, .external_lex_state = 6},
  [2380] = {.lex_state = 86, .external_lex_state = 2},
  [2381] = {.lex_state = 91, .external_lex_state = 6},
  [2382] = {.lex_state = 91, .external_lex_state = 6},
  [2383] = {.lex_state = 86, .external_lex_state = 2},
  [2384] = {.lex_state = 86, .external_lex_state = 2},
  [2385] = {.lex_state = 86, .external_lex_state = 2},
  [2386] = {.lex_state = 91, .external_lex_state = 6},
  [2387] = {.lex_state = 91, .external_lex_state = 6},
  [2388] = {.lex_state = 86, .external_lex_state = 2},
  [2389] = {.lex_state = 86, .external_lex_state = 2},
  [2390] = {.lex_state = 91, .external_lex_state = 6},
  [2391] = {.lex_state = 91, .external_lex_state = 6},
  [2392] = {.lex_state = 91, .external_lex_state = 6},
  [2393] = {.lex_state = 86, .external_lex_state = 2},
  [2394] = {.lex_state = 91, .external_lex_state = 6},
  [2395] = {.lex_state = 91, .external_lex_state = 6},
  [2396] = {.lex_state = 91, .external_lex_state = 6},
  [2397] = {.lex_state = 91, .external_lex_state = 6},
  [2398] = {.lex_state = 86, .external_lex_state = 2},
  [2399] = {.lex_state = 93, .external_lex_state = 5},
  [2400] = {.lex_state = 93, .external_lex_state = 5},
  [2401] = {.lex_state = 93, .external_lex_state = 5},
  [2402] = {.lex_state = 91, .external_lex_state = 6},
  [2403] = {.lex_state = 91, .external_lex_state = 6},
  [2404] = {.lex_state = 93, .external_lex_state = 5},
  [2405] = {.lex_state = 86, .external_lex_state = 2},
  [2406] = {.lex_state = 93, .external_lex_state = 5},
  [2407] = {.lex_state = 93, .external_lex_state = 5},
  [2408] = {.lex_state = 93, .external_lex_state = 5},
  [2409] = {.lex_state = 93, .external_lex_state = 5},
  [2410] = {.lex_state = 93, .external_lex_state = 5},
  [2411] = {.lex_state = 93, .external_lex_state = 5},
  [2412] = {.lex_state = 93, .external_lex_state = 5},
  [2413] = {.lex_state = 93, .external_lex_state = 5},
  [2414] = {.lex_state = 93, .external_lex_state = 5},
  [2415] = {.lex_state = 86, .external_lex_state = 2},
  [2416] = {.lex_state = 91, .external_lex_state = 6},
  [2417] = {.lex_state = 91, .external_lex_state = 6},
  [2418] = {.lex_state = 93, .external_lex_state = 5},
  [2419] = {.lex_state = 91, .external_lex_state = 6},
  [2420] = {.lex_state = 93, .external_lex_state = 5},
  [2421] = {.lex_state = 93, .external_lex_state = 5},
  [2422] = {.lex_state = 91, .external_lex_state = 6},
  [2423] = {.lex_state = 93, .external_lex_state = 5},
  [2424] = {.lex_state = 93, .external_lex_state = 5},
  [2425] = {.lex_state = 93, .external_lex_state = 5},
  [2426] = {.lex_state = 93, .external_lex_state = 5},
  [2427] = {.lex_state = 91, .external_lex_state = 6},
  [2428] = {.lex_state = 91, .external_lex_state = 6},
  [2429] = {.lex_state = 93, .external_lex_state = 5},
  [2430] = {.lex_state = 93, .external_lex_state = 5},
  [2431] = {.lex_state = 91, .external_lex_state = 6},
  [2432] = {.lex_state = 91, .external_lex_state = 6},
  [2433] = {.lex_state = 91, .external_lex_state = 6},
  [2434] = {.lex_state = 91, .external_lex_state = 6},
  [2435] = {.lex_state = 91, .external_lex_state = 6},
  [2436] = {.lex_state = 91, .external_lex_state = 6},
  [2437] = {.lex_state = 93, .external_lex_state = 5},
  [2438] = {.lex_state = 93, .external_lex_state = 5},
  [2439] = {.lex_state = 91, .external_lex_state = 6},
  [2440] = {.lex_state = 93, .external_lex_state = 5},
  [2441] = {.lex_state = 91, .external_lex_state = 6},
  [2442] = {.lex_state = 91, .external_lex_state = 6},
  [2443] = {.lex_state = 93, .external_lex_state = 5},
  [2444] = {.lex_state = 91, .external_lex_state = 6},
  [2445] = {.lex_state = 93, .external_lex_state = 5},
  [2446] = {.lex_state = 93, .external_lex_state = 5},
  [2447] = {.lex_state = 93, .external_lex_state = 5},
  [2448] = {.lex_state = 93, .external_lex_state = 5},
  [2449] = {.lex_state = 91, .external_lex_state = 6},
  [2450] = {.lex_state = 93, .external_lex_state = 5},
  [2451] = {.lex_state = 91, .external_lex_state = 6},
  [2452] = {.lex_state = 91, .external_lex_state = 6},
  [2453] = {.lex_state = 93, .external_lex_state = 5},
  [2454] = {.lex_state = 93, .external_lex_state = 5},
  [2455] = {.lex_state = 91, .external_lex_state = 6},
  [2456] = {.lex_state = 91, .external_lex_state = 6},
  [2457] = {.lex_state = 86, .external_lex_state = 2},
  [2458] = {.lex_state = 93, .external_lex_state = 5},
  [2459] = {.lex_state = 91, .external_lex_state = 6},
  [2460] = {.lex_state = 91, .external_lex_state = 6},
  [2461] = {.lex_state = 91, .external_lex_state = 6},
  [2462] = {.lex_state = 93, .external_lex_state = 5},
  [2463] = {.lex_state = 86, .external_lex_state = 2},
  [2464] = {.lex_state = 86, .external_lex_state = 2},
  [2465] = {.lex_state = 86, .external_lex_state = 2},
  [2466] = {.lex_state = 93, .external_lex_state = 5},
  [2467] = {.lex_state = 91, .external_lex_state = 6},
  [2468] = {.lex_state = 93, .external_lex_state = 5},
  [2469] = {.lex_state = 91, .external_lex_state = 6},
  [2470] = {.lex_state = 91, .external_lex_state = 6},
  [2471] = {.lex_state = 93, .external_lex_state = 5},
  [2472] = {.lex_state = 91, .external_lex_state = 6},
  [2473] = {.lex_state = 91, .external_lex_state = 6},
  [2474] = {.lex_state = 93, .external_lex_state = 5},
  [2475] = {.lex_state = 91, .external_lex_state = 6},
  [2476] = {.lex_state = 91, .external_lex_state = 6},
  [2477] = {.lex_state = 91, .external_lex_state = 6},
  [2478] = {.lex_state = 91, .external_lex_state = 6},
  [2479] = {.lex_state = 93, .external_lex_state = 5},
  [2480] = {.lex_state = 91, .external_lex_state = 6},
  [2481] = {.lex_state = 93, .external_lex_state = 5},
  [2482] = {.lex_state = 91, .external_lex_state = 6},
  [2483] = {.lex_state = 91, .external_lex_state = 6},
  [2484] = {.lex_state = 93, .external_lex_state = 5},
  [2485] = {.lex_state = 91, .external_lex_state = 6},
  [2486] = {.lex_state = 91, .external_lex_state = 6},
  [2487] = {.lex_state = 91, .external_lex_state = 6},
  [2488] = {.lex_state = 91, .external_lex_state = 6},
  [2489] = {.lex_state = 91, .external_lex_state = 6},
  [2490] = {.lex_state = 91, .external_lex_state = 6},
  [2491] = {.lex_state = 91, .external_lex_state = 6},
  [2492] = {.lex_state = 93, .external_lex_state = 5},
  [2493] = {.lex_state = 91, .external_lex_state = 6},
  [2494] = {.lex_state = 91, .external_lex_state = 6},
  [2495] = {.lex_state = 91, .external_lex_state = 6},
  [2496] = {.lex_state = 91, .external_lex_state = 6},
  [2497] = {.lex_state = 91, .external_lex_state = 6},
  [2498] = {.lex_state = 91, .external_lex_state = 6},
  [2499] = {.lex_state = 91, .external_lex_state = 6},
  [2500] = {.lex_state = 91, .external_lex_state = 6},
  [2501] = {.lex_state = 91, .external_lex_state = 6},
  [2502] = {.lex_state = 91, .external_lex_state = 6},
  [2503] = {.lex_state = 91, .external_lex_state = 6},
  [2504] = {.lex_state = 91, .external_lex_state = 6},
  [2505] = {.lex_state = 91, .external_lex_state = 6},
  [2506] = {.lex_state = 91, .external_lex_state = 6},
  [2507] = {.lex_state = 93, .external_lex_state = 5},
  [2508] = {.lex_state = 91, .external_lex_state = 6},
  [2509] = {.lex_state = 91, .external_lex_state = 6},
  [2510] = {.lex_state = 92, .external_lex_state = 6},
  [2511] = {.lex_state = 91, .external_lex_state = 6},
  [2512] = {.lex_state = 92, .external_lex_state = 6},
  [2513] = {.lex_state = 91, .external_lex_state = 6},
  [2514] = {.lex_state = 93, .external_lex_state = 4},
  [2515] = {.lex_state = 91, .external_lex_state = 6},
  [2516] = {.lex_state = 92, .external_lex_state = 6},
  [2517] = {.lex_state = 91, .external_lex_state = 6},
  [2518] = {.lex_state = 91, .external_lex_state = 6},
  [2519] = {.lex_state = 93, .external_lex_state = 5},
  [2520] = {.lex_state = 91, .external_lex_state = 6},
  [2521] = {.lex_state = 93, .external_lex_state = 5},
  [2522] = {.lex_state = 93, .external_lex_state = 5},
  [2523] = {.lex_state = 93, .external_lex_state = 5},
  [2524] = {.lex_state = 93, .external_lex_state = 5},
  [2525] = {.lex_state = 93, .external_lex_state = 6},
  [2526] = {.lex_state = 91, .external_lex_state = 6},
  [2527] = {.lex_state = 93, .external_lex_state = 5},
  [2528] = {.lex_state = 93, .external_lex_state = 5},
  [2529] = {.lex_state = 93, .external_lex_state = 5},
  [2530] = {.lex_state = 93, .external_lex_state = 5},
  [2531] = {.lex_state = 93, .external_lex_state = 5},
  [2532] = {.lex_state = 93, .external_lex_state = 5},
  [2533] = {.lex_state = 93, .external_lex_state = 5},
  [2534] = {.lex_state = 93, .external_lex_state = 5},
  [2535] = {.lex_state = 93, .external_lex_state = 5},
  [2536] = {.lex_state = 93, .external_lex_state = 6},
  [2537] = {.lex_state = 93, .external_lex_state = 5},
  [2538] = {.lex_state = 93, .external_lex_state = 5},
  [2539] = {.lex_state = 93, .external_lex_state = 5},
  [2540] = {.lex_state = 93, .external_lex_state = 5},
  [2541] = {.lex_state = 93, .external_lex_state = 5},
  [2542] = {.lex_state = 93, .external_lex_state = 5},
  [2543] = {.lex_state = 93, .external_lex_state = 5},
  [2544] = {.lex_state = 93, .external_lex_state = 5},
  [2545] = {.lex_state = 93, .external_lex_state = 5},
  [2546] = {.lex_state = 91, .external_lex_state = 6},
  [2547] = {.lex_state = 91, .external_lex_state = 6},
  [2548] = {.lex_state = 91, .external_lex_state = 6},
  [2549] = {.lex_state = 93, .external_lex_state = 5},
  [2550] = {.lex_state = 91, .external_lex_state = 6},
  [2551] = {.lex_state = 93, .external_lex_state = 5},
  [2552] = {.lex_state = 93, .external_lex_state = 5},
  [2553] = {.lex_state = 93, .external_lex_state = 6},
  [2554] = {.lex_state = 92, .external_lex_state = 6},
  [2555] = {.lex_state = 93, .external_lex_state = 5},
  [2556] = {.lex_state = 93, .external_lex_state = 5},
  [2557] = {.lex_state = 93, .external_lex_state = 5},
  [2558] = {.lex_state = 93, .external_lex_state = 6},
  [2559] = {.lex_state = 93, .external_lex_state = 5},
  [2560] = {.lex_state = 91, .external_lex_state = 6},
  [2561] = {.lex_state = 93, .external_lex_state = 6},
  [2562] = {.lex_state = 93, .external_lex_state = 6},
  [2563] = {.lex_state = 91, .external_lex_state = 6},
  [2564] = {.lex_state = 93, .external_lex_state = 6},
  [2565] = {.lex_state = 93, .external_lex_state = 6},
  [2566] = {.lex_state = 93, .external_lex_state = 6},
  [2567] = {.lex_state = 93, .external_lex_state = 6},
  [2568] = {.lex_state = 93, .external_lex_state = 6},
  [2569] = {.lex_state = 93, .external_lex_state = 6},
  [2570] = {.lex_state = 93, .external_lex_state = 6},
  [2571] = {.lex_state = 93, .external_lex_state = 6},
  [2572] = {.lex_state = 93, .external_lex_state = 6},
  [2573] = {.lex_state = 91, .external_lex_state = 6},
  [2574] = {.lex_state = 93, .external_lex_state = 6},
  [2575] = {.lex_state = 93, .external_lex_state = 6},
  [2576] = {.lex_state = 93, .external_lex_state = 6},
  [2577] = {.lex_state = 93, .external_lex_state = 6},
  [2578] = {.lex_state = 93, .external_lex_state = 6},
  [2579] = {.lex_state = 93, .external_lex_state = 6},
  [2580] = {.lex_state = 91, .external_lex_state = 6},
  [2581] = {.lex_state = 93, .external_lex_state = 6},
  [2582] = {.lex_state = 93, .external_lex_state = 6},
  [2583] = {.lex_state = 91, .external_lex_state = 6},
  [2584] = {.lex_state = 91, .external_lex_state = 6},
  [2585] = {.lex_state = 93, .external_lex_state = 6},
  [2586] = {.lex_state = 91, .external_lex_state = 6},
  [2587] = {.lex_state = 93, .external_lex_state = 6},
  [2588] = {.lex_state = 93, .external_lex_state = 6},
  [2589] = {.lex_state = 93, .external_lex_state = 6},
  [2590] = {.lex_state = 93, .external_lex_state = 6},
  [2591] = {.lex_state = 93, .external_lex_state = 6},
  [2592] = {.lex_state = 91, .external_lex_state = 6},
  [2593] = {.lex_state = 93, .external_lex_state = 6},
  [2594] = {.lex_state = 93, .external_lex_state = 6},
  [2595] = {.lex_state = 93, .external_lex_state = 6},
  [2596] = {.lex_state = 93, .external_lex_state = 6},
  [2597] = {.lex_state = 93, .external_lex_state = 6},
  [2598] = {.lex_state = 93, .external_lex_state = 6},
  [2599] = {.lex_state = 93, .external_lex_state = 6},
  [2600] = {.lex_state = 93, .external_lex_state = 6},
  [2601] = {.lex_state = 93, .external_lex_state = 6},
  [2602] = {.lex_state = 93, .external_lex_state = 6},
  [2603] = {.lex_state = 93, .external_lex_state = 6},
  [2604] = {.lex_state = 93, .external_lex_state = 6},
  [2605] = {.lex_state = 93, .external_lex_state = 6},
  [2606] = {.lex_state = 93, .external_lex_state = 6},
  [2607] = {.lex_state = 93, .external_lex_state = 6},
  [2608] = {.lex_state = 93, .external_lex_state = 6},
  [2609] = {.lex_state = 93, .external_lex_state = 6},
  [2610] = {.lex_state = 93, .external_lex_state = 6},
  [2611] = {.lex_state = 93, .external_lex_state = 6},
  [2612] = {.lex_state = 93, .external_lex_state = 6},
  [2613] = {.lex_state = 93, .external_lex_state = 6},
  [2614] = {.lex_state = 93, .external_lex_state = 6},
  [2615] = {.lex_state = 93, .external_lex_state = 6},
  [2616] = {.lex_state = 93, .external_lex_state = 6},
  [2617] = {.lex_state = 93, .external_lex_state = 6},
  [2618] = {.lex_state = 93, .external_lex_state = 6},
  [2619] = {.lex_state = 93, .external_lex_state = 6},
  [2620] = {.lex_state = 93, .external_lex_state = 6},
  [2621] = {.lex_state = 93, .external_lex_state = 6},
  [2622] = {.lex_state = 93, .external_lex_state = 6},
  [2623] = {.lex_state = 93, .external_lex_state = 6},
  [2624] = {.lex_state = 93, .external_lex_state = 6},
  [2625] = {.lex_state = 93, .external_lex_state = 6},
  [2626] = {.lex_state = 93, .external_lex_state = 6},
  [2627] = {.lex_state = 93, .external_lex_state = 6},
  [2628] = {.lex_state = 93, .external_lex_state = 6},
  [2629] = {.lex_state = 93, .external_lex_state = 6},
  [2630] = {.lex_state = 93, .external_lex_state = 6},
  [2631] = {.lex_state = 93, .external_lex_state = 6},
  [2632] = {.lex_state = 93, .external_lex_state = 6},
  [2633] = {.lex_state = 93, .external_lex_state = 6},
  [2634] = {.lex_state = 93, .external_lex_state = 6},
  [2635] = {.lex_state = 93, .external_lex_state = 6},
  [2636] = {.lex_state = 93, .external_lex_state = 6},
  [2637] = {.lex_state = 93, .external_lex_state = 6},
  [2638] = {.lex_state = 93, .external_lex_state = 6},
  [2639] = {.lex_state = 93, .external_lex_state = 6},
  [2640] = {.lex_state = 93, .external_lex_state = 6},
  [2641] = {.lex_state = 93, .external_lex_state = 6},
  [2642] = {.lex_state = 93, .external_lex_state = 6},
  [2643] = {.lex_state = 93, .external_lex_state = 6},
  [2644] = {.lex_state = 93, .external_lex_state = 6},
  [2645] = {.lex_state = 93, .external_lex_state = 6},
  [2646] = {.lex_state = 93, .external_lex_state = 6},
  [2647] = {.lex_state = 93, .external_lex_state = 6},
  [2648] = {.lex_state = 93, .external_lex_state = 6},
  [2649] = {.lex_state = 93, .external_lex_state = 6},
  [2650] = {.lex_state = 93, .external_lex_state = 6},
  [2651] = {.lex_state = 93, .external_lex_state = 6},
  [2652] = {.lex_state = 93, .external_lex_state = 6},
  [2653] = {.lex_state = 93, .external_lex_state = 6},
  [2654] = {.lex_state = 93, .external_lex_state = 6},
  [2655] = {.lex_state = 93, .external_lex_state = 6},
  [2656] = {.lex_state = 93, .external_lex_state = 6},
  [2657] = {.lex_state = 93, .external_lex_state = 6},
  [2658] = {.lex_state = 93, .external_lex_state = 6},
  [2659] = {.lex_state = 93, .external_lex_state = 6},
  [2660] = {.lex_state = 93, .external_lex_state = 6},
  [2661] = {.lex_state = 93, .external_lex_state = 6},
  [2662] = {.lex_state = 93, .external_lex_state = 6},
  [2663] = {.lex_state = 93, .external_lex_state = 6},
  [2664] = {.lex_state = 93, .external_lex_state = 6},
  [2665] = {.lex_state = 93, .external_lex_state = 6},
  [2666] = {.lex_state = 93, .external_lex_state = 6},
  [2667] = {.lex_state = 93, .external_lex_state = 6},
  [2668] = {.lex_state = 93, .external_lex_state = 6},
  [2669] = {.lex_state = 93, .external_lex_state = 6},
  [2670] = {.lex_state = 93, .external_lex_state = 6},
  [2671] = {.lex_state = 93, .external_lex_state = 6},
  [2672] = {.lex_state = 93, .external_lex_state = 6},
  [2673] = {.lex_state = 93, .external_lex_state = 6},
  [2674] = {.lex_state = 93, .external_lex_state = 6},
  [2675] = {.lex_state = 93, .external_lex_state = 6},
  [2676] = {.lex_state = 93, .external_lex_state = 6},
  [2677] = {.lex_state = 93, .external_lex_state = 6},
  [2678] = {.lex_state = 93, .external_lex_state = 6},
  [2679] = {.lex_state = 93, .external_lex_state = 6},
  [2680] = {.lex_state = 93, .external_lex_state = 6},
  [2681] = {.lex_state = 93, .external_lex_state = 6},
  [2682] = {.lex_state = 93, .external_lex_state = 6},
  [2683] = {.lex_state = 93, .external_lex_state = 6},
  [2684] = {.lex_state = 93, .external_lex_state = 6},
  [2685] = {.lex_state = 93, .external_lex_state = 6},
  [2686] = {.lex_state = 93, .external_lex_state = 6},
  [2687] = {.lex_state = 93, .external_lex_state = 6},
  [2688] = {.lex_state = 92, .external_lex_state = 7},
  [2689] = {.lex_state = 93, .external_lex_state = 6},
  [2690] = {.lex_state = 93, .external_lex_state = 6},
  [2691] = {.lex_state = 93, .external_lex_state = 6},
  [2692] = {.lex_state = 93, .external_lex_state = 6},
  [2693] = {.lex_state = 93, .external_lex_state = 6},
  [2694] = {.lex_state = 93, .external_lex_state = 6},
  [2695] = {.lex_state = 93, .external_lex_state = 6},
  [2696] = {.lex_state = 93, .external_lex_state = 6},
  [2697] = {.lex_state = 93, .external_lex_state = 6},
  [2698] = {.lex_state = 93, .external_lex_state = 6},
  [2699] = {.lex_state = 93, .external_lex_state = 6},
  [2700] = {.lex_state = 93, .external_lex_state = 6},
  [2701] = {.lex_state = 93, .external_lex_state = 6},
  [2702] = {.lex_state = 93, .external_lex_state = 6},
  [2703] = {.lex_state = 93, .external_lex_state = 6},
  [2704] = {.lex_state = 93, .external_lex_state = 6},
  [2705] = {.lex_state = 93, .external_lex_state = 6},
  [2706] = {.lex_state = 93, .external_lex_state = 6},
  [2707] = {.lex_state = 93, .external_lex_state = 6},
  [2708] = {.lex_state = 93, .external_lex_state = 6},
  [2709] = {.lex_state = 93, .external_lex_state = 6},
  [2710] = {.lex_state = 93, .external_lex_state = 6},
  [2711] = {.lex_state = 93, .external_lex_state = 6},
  [2712] = {.lex_state = 93, .external_lex_state = 6},
  [2713] = {.lex_state = 93, .external_lex_state = 6},
  [2714] = {.lex_state = 93, .external_lex_state = 6},
  [2715] = {.lex_state = 93, .external_lex_state = 6},
  [2716] = {.lex_state = 92, .external_lex_state = 7},
  [2717] = {.lex_state = 92, .external_lex_state = 7},
  [2718] = {.lex_state = 93, .external_lex_state = 6},
  [2719] = {.lex_state = 93, .external_lex_state = 6},
  [2720] = {.lex_state = 93, .external_lex_state = 6},
  [2721] = {.lex_state = 93, .external_lex_state = 6},
  [2722] = {.lex_state = 93, .external_lex_state = 6},
  [2723] = {.lex_state = 93, .external_lex_state = 6},
  [2724] = {.lex_state = 93, .external_lex_state = 7},
  [2725] = {.lex_state = 93, .external_lex_state = 6},
  [2726] = {.lex_state = 93, .external_lex_state = 6},
  [2727] = {.lex_state = 93, .external_lex_state = 6},
  [2728] = {.lex_state = 93, .external_lex_state = 6},
  [2729] = {.lex_state = 93, .external_lex_state = 6},
  [2730] = {.lex_state = 92, .external_lex_state = 7},
  [2731] = {.lex_state = 93, .external_lex_state = 6},
  [2732] = {.lex_state = 93, .external_lex_state = 6},
  [2733] = {.lex_state = 93, .external_lex_state = 7},
  [2734] = {.lex_state = 93, .external_lex_state = 6},
  [2735] = {.lex_state = 93, .external_lex_state = 6},
  [2736] = {.lex_state = 93, .external_lex_state = 6},
  [2737] = {.lex_state = 93, .external_lex_state = 6},
  [2738] = {.lex_state = 93, .external_lex_state = 6},
  [2739] = {.lex_state = 93, .external_lex_state = 6},
  [2740] = {.lex_state = 93, .external_lex_state = 6},
  [2741] = {.lex_state = 93, .external_lex_state = 6},
  [2742] = {.lex_state = 93, .external_lex_state = 6},
  [2743] = {.lex_state = 93, .external_lex_state = 6},
  [2744] = {.lex_state = 93, .external_lex_state = 6},
  [2745] = {.lex_state = 93, .external_lex_state = 6},
  [2746] = {.lex_state = 93, .external_lex_state = 6},
  [2747] = {.lex_state = 93, .external_lex_state = 6},
  [2748] = {.lex_state = 93, .external_lex_state = 6},
  [2749] = {.lex_state = 93, .external_lex_state = 6},
  [2750] = {.lex_state = 93, .external_lex_state = 6},
  [2751] = {.lex_state = 93, .external_lex_state = 6},
  [2752] = {.lex_state = 93, .external_lex_state = 6},
  [2753] = {.lex_state = 93, .external_lex_state = 6},
  [2754] = {.lex_state = 93, .external_lex_state = 6},
  [2755] = {.lex_state = 93, .external_lex_state = 6},
  [2756] = {.lex_state = 93, .external_lex_state = 6},
  [2757] = {.lex_state = 93, .external_lex_state = 7},
  [2758] = {.lex_state = 93, .external_lex_state = 7},
  [2759] = {.lex_state = 93, .external_lex_state = 7},
  [2760] = {.lex_state = 93, .external_lex_state = 7},
  [2761] = {.lex_state = 93, .external_lex_state = 7},
  [2762] = {.lex_state = 93, .external_lex_state = 7},
  [2763] = {.lex_state = 93, .external_lex_state = 7},
  [2764] = {.lex_state = 93, .external_lex_state = 7},
  [2765] = {.lex_state = 93, .external_lex_state = 7},
  [2766] = {.lex_state = 93, .external_lex_state = 7},
  [2767] = {.lex_state = 93, .external_lex_state = 7},
  [2768] = {.lex_state = 93, .external_lex_state = 7},
  [2769] = {.lex_state = 93, .external_lex_state = 7},
  [2770] = {.lex_state = 93, .external_lex_state = 7},
  [2771] = {.lex_state = 93, .external_lex_state = 7},
  [2772] = {.lex_state = 93, .external_lex_state = 7},
  [2773] = {.lex_state = 93, .external_lex_state = 7},
  [2774] = {.lex_state = 93, .external_lex_state = 7},
  [2775] = {.lex_state = 93, .external_lex_state = 7},
  [2776] = {.lex_state = 93, .external_lex_state = 7},
  [2777] = {.lex_state = 93, .external_lex_state = 7},
  [2778] = {.lex_state = 93, .external_lex_state = 7},
  [2779] = {.lex_state = 93, .external_lex_state = 7},
  [2780] = {.lex_state = 93, .external_lex_state = 7},
  [2781] = {.lex_state = 93, .external_lex_state = 6},
  [2782] = {.lex_state = 93, .external_lex_state = 7},
  [2783] = {.lex_state = 89, .external_lex_state = 6},
  [2784] = {.lex_state = 93, .external_lex_state = 7},
  [2785] = {.lex_state = 93, .external_lex_state = 7},
  [2786] = {.lex_state = 93, .external_lex_state = 7},
  [2787] = {.lex_state = 93, .external_lex_state = 7},
  [2788] = {.lex_state = 93, .external_lex_state = 7},
  [2789] = {.lex_state = 93, .external_lex_state = 6},
  [2790] = {.lex_state = 89, .external_lex_state = 6},
  [2791] = {.lex_state = 93, .external_lex_state = 7},
  [2792] = {.lex_state = 93, .external_lex_state = 7},
  [2793] = {.lex_state = 93, .external_lex_state = 7},
  [2794] = {.lex_state = 93, .external_lex_state = 7},
  [2795] = {.lex_state = 93, .external_lex_state = 7},
  [2796] = {.lex_state = 93, .external_lex_state = 7},
  [2797] = {.lex_state = 93, .external_lex_state = 7},
  [2798] = {.lex_state = 93, .external_lex_state = 7},
  [2799] = {.lex_state = 93, .external_lex_state = 7},
  [2800] = {.lex_state = 93, .external_lex_state = 7},
  [2801] = {.lex_state = 89, .external_lex_state = 6},
  [2802] = {.lex_state = 93, .external_lex_state = 6},
  [2803] = {.lex_state = 93, .external_lex_state = 7},
  [2804] = {.lex_state = 93, .external_lex_state = 7},
  [2805] = {.lex_state = 93, .external_lex_state = 7},
  [2806] = {.lex_state = 93, .external_lex_state = 7},
  [2807] = {.lex_state = 93, .external_lex_state = 7},
  [2808] = {.lex_state = 93, .external_lex_state = 7},
  [2809] = {.lex_state = 93, .external_lex_state = 7},
  [2810] = {.lex_state = 93, .external_lex_state = 7},
  [2811] = {.lex_state = 93, .external_lex_state = 7},
  [2812] = {.lex_state = 93, .external_lex_state = 7},
  [2813] = {.lex_state = 93, .external_lex_state = 7},
  [2814] = {.lex_state = 93, .external_lex_state = 7},
  [2815] = {.lex_state = 93, .external_lex_state = 7},
  [2816] = {.lex_state = 93, .external_lex_state = 7},
  [2817] = {.lex_state = 93, .external_lex_state = 7},
  [2818] = {.lex_state = 93, .external_lex_state = 7},
  [2819] = {.lex_state = 93, .external_lex_state = 7},
  [2820] = {.lex_state = 93, .external_lex_state = 7},
  [2821] = {.lex_state = 93, .external_lex_state = 7},
  [2822] = {.lex_state = 93, .external_lex_state = 7},
  [2823] = {.lex_state = 93, .external_lex_state = 7},
  [2824] = {.lex_state = 93, .external_lex_state = 7},
  [2825] = {.lex_state = 93, .external_lex_state = 7},
  [2826] = {.lex_state = 93, .external_lex_state = 7},
  [2827] = {.lex_state = 93, .external_lex_state = 7},
  [2828] = {.lex_state = 93, .external_lex_state = 7},
  [2829] = {.lex_state = 93, .external_lex_state = 7},
  [2830] = {.lex_state = 93, .external_lex_state = 7},
  [2831] = {.lex_state = 93, .external_lex_state = 7},
  [2832] = {.lex_state = 93, .external_lex_state = 7},
  [2833] = {.lex_state = 93, .external_lex_state = 7},
  [2834] = {.lex_state = 93, .external_lex_state = 7},
  [2835] = {.lex_state = 93, .external_lex_state = 7},
  [2836] = {.lex_state = 93, .external_lex_state = 7},
  [2837] = {.lex_state = 93, .external_lex_state = 7},
  [2838] = {.lex_state = 93, .external_lex_state = 7},
  [2839] = {.lex_state = 93, .external_lex_state = 7},
  [2840] = {.lex_state = 93, .external_lex_state = 7},
  [2841] = {.lex_state = 93, .external_lex_state = 7},
  [2842] = {.lex_state = 93, .external_lex_state = 7},
  [2843] = {.lex_state = 93, .external_lex_state = 7},
  [2844] = {.lex_state = 93, .external_lex_state = 7},
  [2845] = {.lex_state = 93, .external_lex_state = 7},
  [2846] = {.lex_state = 93, .external_lex_state = 7},
  [2847] = {.lex_state = 93, .external_lex_state = 7},
  [2848] = {.lex_state = 93, .external_lex_state = 7},
  [2849] = {.lex_state = 93, .external_lex_state = 7},
  [2850] = {.lex_state = 93, .external_lex_state = 7},
  [2851] = {.lex_state = 93, .external_lex_state = 7},
  [2852] = {.lex_state = 93, .external_lex_state = 7},
  [2853] = {.lex_state = 93, .external_lex_state = 7},
  [2854] = {.lex_state = 93, .external_lex_state = 7},
  [2855] = {.lex_state = 93, .external_lex_state = 7},
  [2856] = {.lex_state = 93, .external_lex_state = 7},
  [2857] = {.lex_state = 93, .external_lex_state = 7},
  [2858] = {.lex_state = 93, .external_lex_state = 7},
  [2859] = {.lex_state = 93, .external_lex_state = 7},
  [2860] = {.lex_state = 93, .external_lex_state = 7},
  [2861] = {.lex_state = 93, .external_lex_state = 7},
  [2862] = {.lex_state = 93, .external_lex_state = 7},
  [2863] = {.lex_state = 93, .external_lex_state = 7},
  [2864] = {.lex_state = 93, .external_lex_state = 7},
  [2865] = {.lex_state = 93, .external_lex_state = 7},
  [2866] = {.lex_state = 93, .external_lex_state = 7},
  [2867] = {.lex_state = 93, .external_lex_state = 7},
  [2868] = {.lex_state = 93, .external_lex_state = 7},
  [2869] = {.lex_state = 93, .external_lex_state = 7},
  [2870] = {.lex_state = 93, .external_lex_state = 7},
  [2871] = {.lex_state = 93, .external_lex_state = 7},
  [2872] = {.lex_state = 93, .external_lex_state = 7},
  [2873] = {.lex_state = 93, .external_lex_state = 7},
  [2874] = {.lex_state = 93, .external_lex_state = 7},
  [2875] = {.lex_state = 93, .external_lex_state = 7},
  [2876] = {.lex_state = 93, .external_lex_state = 7},
  [2877] = {.lex_state = 93, .external_lex_state = 7},
  [2878] = {.lex_state = 93, .external_lex_state = 7},
  [2879] = {.lex_state = 93, .external_lex_state = 7},
  [2880] = {.lex_state = 93, .external_lex_state = 7},
  [2881] = {.lex_state = 93, .external_lex_state = 7},
  [2882] = {.lex_state = 93, .external_lex_state = 7},
  [2883] = {.lex_state = 93, .external_lex_state = 7},
  [2884] = {.lex_state = 93, .external_lex_state = 7},
  [2885] = {.lex_state = 93, .external_lex_state = 7},
  [2886] = {.lex_state = 93, .external_lex_state = 7},
  [2887] = {.lex_state = 93, .external_lex_state = 7},
  [2888] = {.lex_state = 93, .external_lex_state = 7},
  [2889] = {.lex_state = 93, .external_lex_state = 7},
  [2890] = {.lex_state = 93, .external_lex_state = 7},
  [2891] = {.lex_state = 93, .external_lex_state = 7},
  [2892] = {.lex_state = 93, .external_lex_state = 7},
  [2893] = {.lex_state = 93, .external_lex_state = 7},
  [2894] = {.lex_state = 93, .external_lex_state = 7},
  [2895] = {.lex_state = 93, .external_lex_state = 6},
  [2896] = {.lex_state = 93, .external_lex_state = 7},
  [2897] = {.lex_state = 93, .external_lex_state = 7},
  [2898] = {.lex_state = 93, .external_lex_state = 7},
  [2899] = {.lex_state = 93, .external_lex_state = 7},
  [2900] = {.lex_state = 93, .external_lex_state = 7},
  [2901] = {.lex_state = 93, .external_lex_state = 7},
  [2902] = {.lex_state = 89, .external_lex_state = 4},
  [2903] = {.lex_state = 90, .external_lex_state = 4},
  [2904] = {.lex_state = 90, .external_lex_state = 6},
  [2905] = {.lex_state = 89, .external_lex_state = 4},
  [2906] = {.lex_state = 90, .external_lex_state = 6},
  [2907] = {.lex_state = 90, .external_lex_state = 6},
  [2908] = {.lex_state = 89, .external_lex_state = 6},
  [2909] = {.lex_state = 90, .external_lex_state = 6},
  [2910] = {.lex_state = 90, .external_lex_state = 6},
  [2911] = {.lex_state = 90, .external_lex_state = 6},
  [2912] = {.lex_state = 90, .external_lex_state = 6},
  [2913] = {.lex_state = 90, .external_lex_state = 6},
  [2914] = {.lex_state = 90, .external_lex_state = 6},
  [2915] = {.lex_state = 90, .external_lex_state = 6},
  [2916] = {.lex_state = 90, .external_lex_state = 6},
  [2917] = {.lex_state = 90, .external_lex_state = 6},
  [2918] = {.lex_state = 90, .external_lex_state = 6},
  [2919] = {.lex_state = 90, .external_lex_state = 6},
  [2920] = {.lex_state = 90, .external_lex_state = 6},
  [2921] = {.lex_state = 90, .external_lex_state = 6},
  [2922] = {.lex_state = 90, .external_lex_state = 6},
  [2923] = {.lex_state = 90, .external_lex_state = 6},
  [2924] = {.lex_state = 90, .external_lex_state = 4},
  [2925] = {.lex_state = 90, .external_lex_state = 6},
  [2926] = {.lex_state = 90, .external_lex_state = 6},
  [2927] = {.lex_state = 90, .external_lex_state = 6},
  [2928] = {.lex_state = 90, .external_lex_state = 6},
  [2929] = {.lex_state = 90, .external_lex_state = 6},
  [2930] = {.lex_state = 90, .external_lex_state = 6},
  [2931] = {.lex_state = 90, .external_lex_state = 4},
  [2932] = {.lex_state = 90, .external_lex_state = 6},
  [2933] = {.lex_state = 90, .external_lex_state = 6},
  [2934] = {.lex_state = 90, .external_lex_state = 6},
  [2935] = {.lex_state = 93, .external_lex_state = 6},
  [2936] = {.lex_state = 90, .external_lex_state = 6},
  [2937] = {.lex_state = 90, .external_lex_state = 4},
  [2938] = {.lex_state = 90, .external_lex_state = 4},
  [2939] = {.lex_state = 90, .external_lex_state = 4},
  [2940] = {.lex_state = 93, .external_lex_state = 6},
  [2941] = {.lex_state = 89, .external_lex_state = 4},
  [2942] = {.lex_state = 90, .external_lex_state = 6},
  [2943] = {.lex_state = 90, .external_lex_state = 6},
  [2944] = {.lex_state = 89, .external_lex_state = 4},
  [2945] = {.lex_state = 90, .external_lex_state = 4},
  [2946] = {.lex_state = 93, .external_lex_state = 6},
  [2947] = {.lex_state = 90, .external_lex_state = 4},
  [2948] = {.lex_state = 89, .external_lex_state = 6},
  [2949] = {.lex_state = 90, .external_lex_state = 4},
  [2950] = {.lex_state = 93, .external_lex_state = 6},
  [2951] = {.lex_state = 90, .external_lex_state = 6},
  [2952] = {.lex_state = 90, .external_lex_state = 4},
  [2953] = {.lex_state = 90, .external_lex_state = 4},
  [2954] = {.lex_state = 90, .external_lex_state = 6},
  [2955] = {.lex_state = 90, .external_lex_state = 6},
  [2956] = {.lex_state = 90, .external_lex_state = 6},
  [2957] = {.lex_state = 90, .external_lex_state = 6},
  [2958] = {.lex_state = 90, .external_lex_state = 6},
  [2959] = {.lex_state = 90, .external_lex_state = 6},
  [2960] = {.lex_state = 90, .external_lex_state = 6},
  [2961] = {.lex_state = 90, .external_lex_state = 6},
  [2962] = {.lex_state = 90, .external_lex_state = 6},
  [2963] = {.lex_state = 90, .external_lex_state = 6},
  [2964] = {.lex_state = 90, .external_lex_state = 6},
  [2965] = {.lex_state = 90, .external_lex_state = 6},
  [2966] = {.lex_state = 90, .external_lex_state = 6},
  [2967] = {.lex_state = 90, .external_lex_state = 6},
  [2968] = {.lex_state = 90, .external_lex_state = 6},
  [2969] = {.lex_state = 90, .external_lex_state = 6},
  [2970] = {.lex_state = 90, .external_lex_state = 6},
  [2971] = {.lex_state = 90, .external_lex_state = 6},
  [2972] = {.lex_state = 90, .external_lex_state = 6},
  [2973] = {.lex_state = 90, .external_lex_state = 6},
  [2974] = {.lex_state = 90, .external_lex_state = 6},
  [2975] = {.lex_state = 90, .external_lex_state = 6},
  [2976] = {.lex_state = 90, .external_lex_state = 6},
  [2977] = {.lex_state = 90, .external_lex_state = 6},
  [2978] = {.lex_state = 90, .external_lex_state = 6},
  [2979] = {.lex_state = 90, .external_lex_state = 6},
  [2980] = {.lex_state = 90, .external_lex_state = 6},
  [2981] = {.lex_state = 90, .external_lex_state = 6},
  [2982] = {.lex_state = 90, .external_lex_state = 6},
  [2983] = {.lex_state = 90, .external_lex_state = 6},
  [2984] = {.lex_state = 90, .external_lex_state = 6},
  [2985] = {.lex_state = 90, .external_lex_state = 6},
  [2986] = {.lex_state = 90, .external_lex_state = 6},
  [2987] = {.lex_state = 90, .external_lex_state = 6},
  [2988] = {.lex_state = 90, .external_lex_state = 6},
  [2989] = {.lex_state = 90, .external_lex_state = 4},
  [2990] = {.lex_state = 90, .external_lex_state = 4},
  [2991] = {.lex_state = 90, .external_lex_state = 4},
  [2992] = {.lex_state = 90, .external_lex_state = 4},
  [2993] = {.lex_state = 90, .external_lex_state = 6},
  [2994] = {.lex_state = 90, .external_lex_state = 4},
  [2995] = {.lex_state = 90, .external_lex_state = 6},
  [2996] = {.lex_state = 90, .external_lex_state = 4},
  [2997] = {.lex_state = 90, .external_lex_state = 4},
  [2998] = {.lex_state = 90, .external_lex_state = 4},
  [2999] = {.lex_state = 90, .external_lex_state = 6},
  [3000] = {.lex_state = 90, .external_lex_state = 6},
  [3001] = {.lex_state = 90, .external_lex_state = 6},
  [3002] = {.lex_state = 90, .external_lex_state = 6},
  [3003] = {.lex_state = 90, .external_lex_state = 6},
  [3004] = {.lex_state = 90, .external_lex_state = 6},
  [3005] = {.lex_state = 90, .external_lex_state = 6},
  [3006] = {.lex_state = 90, .external_lex_state = 4},
  [3007] = {.lex_state = 90, .external_lex_state = 4},
  [3008] = {.lex_state = 90, .external_lex_state = 6},
  [3009] = {.lex_state = 90, .external_lex_state = 4},
  [3010] = {.lex_state = 90, .external_lex_state = 4},
  [3011] = {.lex_state = 90, .external_lex_state = 6},
  [3012] = {.lex_state = 90, .external_lex_state = 6},
  [3013] = {.lex_state = 90, .external_lex_state = 6},
  [3014] = {.lex_state = 90, .external_lex_state = 4},
  [3015] = {.lex_state = 90, .external_lex_state = 4},
  [3016] = {.lex_state = 90, .external_lex_state = 4},
  [3017] = {.lex_state = 90, .external_lex_state = 4},
  [3018] = {.lex_state = 90, .external_lex_state = 6},
  [3019] = {.lex_state = 90, .external_lex_state = 4},
  [3020] = {.lex_state = 90, .external_lex_state = 6},
  [3021] = {.lex_state = 90, .external_lex_state = 4},
  [3022] = {.lex_state = 90, .external_lex_state = 6},
  [3023] = {.lex_state = 90, .external_lex_state = 6},
  [3024] = {.lex_state = 90, .external_lex_state = 6},
  [3025] = {.lex_state = 90, .external_lex_state = 6},
  [3026] = {.lex_state = 90, .external_lex_state = 6},
  [3027] = {.lex_state = 90, .external_lex_state = 6},
  [3028] = {.lex_state = 90, .external_lex_state = 6},
  [3029] = {.lex_state = 90, .external_lex_state = 6},
  [3030] = {.lex_state = 90, .external_lex_state = 6},
  [3031] = {.lex_state = 93, .external_lex_state = 7},
  [3032] = {.lex_state = 90, .external_lex_state = 6},
  [3033] = {.lex_state = 90, .external_lex_state = 6},
  [3034] = {.lex_state = 90, .external_lex_state = 6},
  [3035] = {.lex_state = 90, .external_lex_state = 6},
  [3036] = {.lex_state = 90, .external_lex_state = 6},
  [3037] = {.lex_state = 90, .external_lex_state = 6},
  [3038] = {.lex_state = 90, .external_lex_state = 6},
  [3039] = {.lex_state = 90, .external_lex_state = 4},
  [3040] = {.lex_state = 90, .external_lex_state = 4},
  [3041] = {.lex_state = 90, .external_lex_state = 6},
  [3042] = {.lex_state = 90, .external_lex_state = 6},
  [3043] = {.lex_state = 90, .external_lex_state = 6},
  [3044] = {.lex_state = 90, .external_lex_state = 6},
  [3045] = {.lex_state = 90, .external_lex_state = 6},
  [3046] = {.lex_state = 90, .external_lex_state = 6},
  [3047] = {.lex_state = 90, .external_lex_state = 4},
  [3048] = {.lex_state = 90, .external_lex_state = 6},
  [3049] = {.lex_state = 90, .external_lex_state = 6},
  [3050] = {.lex_state = 90, .external_lex_state = 6},
  [3051] = {.lex_state = 90, .external_lex_state = 6},
  [3052] = {.lex_state = 90, .external_lex_state = 6},
  [3053] = {.lex_state = 90, .external_lex_state = 6},
  [3054] = {.lex_state = 90, .external_lex_state = 6},
  [3055] = {.lex_state = 90, .external_lex_state = 6},
  [3056] = {.lex_state = 90, .external_lex_state = 6},
  [3057] = {.lex_state = 90, .external_lex_state = 6},
  [3058] = {.lex_state = 90, .external_lex_state = 6},
  [3059] = {.lex_state = 90, .external_lex_state = 6},
  [3060] = {.lex_state = 90, .external_lex_state = 6},
  [3061] = {.lex_state = 90, .external_lex_state = 6},
  [3062] = {.lex_state = 90, .external_lex_state = 6},
  [3063] = {.lex_state = 90, .external_lex_state = 4},
  [3064] = {.lex_state = 90, .external_lex_state = 6},
  [3065] = {.lex_state = 90, .external_lex_state = 6},
  [3066] = {.lex_state = 90, .external_lex_state = 6},
  [3067] = {.lex_state = 90, .external_lex_state = 6},
  [3068] = {.lex_state = 90, .external_lex_state = 6},
  [3069] = {.lex_state = 90, .external_lex_state = 6},
  [3070] = {.lex_state = 90, .external_lex_state = 6},
  [3071] = {.lex_state = 90, .external_lex_state = 4},
  [3072] = {.lex_state = 90, .external_lex_state = 6},
  [3073] = {.lex_state = 90, .external_lex_state = 4},
  [3074] = {.lex_state = 90, .external_lex_state = 4},
  [3075] = {.lex_state = 90, .external_lex_state = 4},
  [3076] = {.lex_state = 90, .external_lex_state = 6},
  [3077] = {.lex_state = 90, .external_lex_state = 6},
  [3078] = {.lex_state = 90, .external_lex_state = 6},
  [3079] = {.lex_state = 90, .external_lex_state = 4},
  [3080] = {.lex_state = 90, .external_lex_state = 4},
  [3081] = {.lex_state = 90, .external_lex_state = 6},
  [3082] = {.lex_state = 90, .external_lex_state = 6},
  [3083] = {.lex_state = 90, .external_lex_state = 6},
  [3084] = {.lex_state = 90, .external_lex_state = 4},
  [3085] = {.lex_state = 90, .external_lex_state = 6},
  [3086] = {.lex_state = 90, .external_lex_state = 6},
  [3087] = {.lex_state = 90, .external_lex_state = 4},
  [3088] = {.lex_state = 90, .external_lex_state = 6},
  [3089] = {.lex_state = 90, .external_lex_state = 6},
  [3090] = {.lex_state = 90, .external_lex_state = 6},
  [3091] = {.lex_state = 90, .external_lex_state = 6},
  [3092] = {.lex_state = 90, .external_lex_state = 4},
  [3093] = {.lex_state = 90, .external_lex_state = 6},
  [3094] = {.lex_state = 90, .external_lex_state = 4},
  [3095] = {.lex_state = 90, .external_lex_state = 6},
  [3096] = {.lex_state = 90, .external_lex_state = 6},
  [3097] = {.lex_state = 90, .external_lex_state = 4},
  [3098] = {.lex_state = 90, .external_lex_state = 4},
  [3099] = {.lex_state = 90, .external_lex_state = 4},
  [3100] = {.lex_state = 90, .external_lex_state = 6},
  [3101] = {.lex_state = 90, .external_lex_state = 6},
  [3102] = {.lex_state = 90, .external_lex_state = 6},
  [3103] = {.lex_state = 90, .external_lex_state = 6},
  [3104] = {.lex_state = 90, .external_lex_state = 6},
  [3105] = {.lex_state = 90, .external_lex_state = 4},
  [3106] = {.lex_state = 90, .external_lex_state = 4},
  [3107] = {.lex_state = 90, .external_lex_state = 4},
  [3108] = {.lex_state = 90, .external_lex_state = 6},
  [3109] = {.lex_state = 90, .external_lex_state = 6},
  [3110] = {.lex_state = 90, .external_lex_state = 6},
  [3111] = {.lex_state = 90, .external_lex_state = 6},
  [3112] = {.lex_state = 90, .external_lex_state = 4},
  [3113] = {.lex_state = 90, .external_lex_state = 4},
  [3114] = {.lex_state = 90, .external_lex_state = 6},
  [3115] = {.lex_state = 90, .external_lex_state = 4},
  [3116] = {.lex_state = 90, .external_lex_state = 6},
  [3117] = {.lex_state = 90, .external_lex_state = 6},
  [3118] = {.lex_state = 90, .external_lex_state = 6},
  [3119] = {.lex_state = 90, .external_lex_state = 6},
  [3120] = {.lex_state = 90, .external_lex_state = 4},
  [3121] = {.lex_state = 90, .external_lex_state = 6},
  [3122] = {.lex_state = 90, .external_lex_state = 6},
  [3123] = {.lex_state = 90, .external_lex_state = 6},
  [3124] = {.lex_state = 90, .external_lex_state = 6},
  [3125] = {.lex_state = 90, .external_lex_state = 6},
  [3126] = {.lex_state = 90, .external_lex_state = 6},
  [3127] = {.lex_state = 89, .external_lex_state = 8},
  [3128] = {.lex_state = 90, .external_lex_state = 6},
  [3129] = {.lex_state = 90, .external_lex_state = 6},
  [3130] = {.lex_state = 90, .external_lex_state = 6},
  [3131] = {.lex_state = 90, .external_lex_state = 6},
  [3132] = {.lex_state = 90, .external_lex_state = 6},
  [3133] = {.lex_state = 90, .external_lex_state = 6},
  [3134] = {.lex_state = 90, .external_lex_state = 6},
  [3135] = {.lex_state = 90, .external_lex_state = 6},
  [3136] = {.lex_state = 90, .external_lex_state = 6},
  [3137] = {.lex_state = 89, .external_lex_state = 4},
  [3138] = {.lex_state = 90, .external_lex_state = 6},
  [3139] = {.lex_state = 90, .external_lex_state = 6},
  [3140] = {.lex_state = 90, .external_lex_state = 4},
  [3141] = {.lex_state = 90, .external_lex_state = 6},
  [3142] = {.lex_state = 90, .external_lex_state = 6},
  [3143] = {.lex_state = 90, .external_lex_state = 6},
  [3144] = {.lex_state = 90, .external_lex_state = 4},
  [3145] = {.lex_state = 90, .external_lex_state = 6},
  [3146] = {.lex_state = 90, .external_lex_state = 4},
  [3147] = {.lex_state = 90, .external_lex_state = 4},
  [3148] = {.lex_state = 90, .external_lex_state = 8},
  [3149] = {.lex_state = 90, .external_lex_state = 4},
  [3150] = {.lex_state = 90, .external_lex_state = 4},
  [3151] = {.lex_state = 90, .external_lex_state = 4},
  [3152] = {.lex_state = 90, .external_lex_state = 4},
  [3153] = {.lex_state = 90, .external_lex_state = 4},
  [3154] = {.lex_state = 90, .external_lex_state = 4},
  [3155] = {.lex_state = 90, .external_lex_state = 4},
  [3156] = {.lex_state = 90, .external_lex_state = 4},
  [3157] = {.lex_state = 90, .external_lex_state = 4},
  [3158] = {.lex_state = 90, .external_lex_state = 4},
  [3159] = {.lex_state = 90, .external_lex_state = 4},
  [3160] = {.lex_state = 90, .external_lex_state = 4},
  [3161] = {.lex_state = 90, .external_lex_state = 4},
  [3162] = {.lex_state = 90, .external_lex_state = 4},
  [3163] = {.lex_state = 90, .external_lex_state = 4},
  [3164] = {.lex_state = 89, .external_lex_state = 8},
  [3165] = {.lex_state = 90, .external_lex_state = 6},
  [3166] = {.lex_state = 90, .external_lex_state = 4},
  [3167] = {.lex_state = 90, .external_lex_state = 6},
  [3168] = {.lex_state = 90, .external_lex_state = 6},
  [3169] = {.lex_state = 90, .external_lex_state = 4},
  [3170] = {.lex_state = 90, .external_lex_state = 4},
  [3171] = {.lex_state = 90, .external_lex_state = 4},
  [3172] = {.lex_state = 90, .external_lex_state = 4},
  [3173] = {.lex_state = 90, .external_lex_state = 4},
  [3174] = {.lex_state = 90, .external_lex_state = 4},
  [3175] = {.lex_state = 90, .external_lex_state = 6},
  [3176] = {.lex_state = 90, .external_lex_state = 4},
  [3177] = {.lex_state = 93, .external_lex_state = 7},
  [3178] = {.lex_state = 89, .external_lex_state = 8},
  [3179] = {.lex_state = 90, .external_lex_state = 4},
  [3180] = {.lex_state = 90, .external_lex_state = 4},
  [3181] = {.lex_state = 90, .external_lex_state = 6},
  [3182] = {.lex_state = 90, .external_lex_state = 4},
  [3183] = {.lex_state = 90, .external_lex_state = 4},
  [3184] = {.lex_state = 90, .external_lex_state = 4},
  [3185] = {.lex_state = 90, .external_lex_state = 6},
  [3186] = {.lex_state = 90, .external_lex_state = 4},
  [3187] = {.lex_state = 90, .external_lex_state = 6},
  [3188] = {.lex_state = 90, .external_lex_state = 4},
  [3189] = {.lex_state = 90, .external_lex_state = 4},
  [3190] = {.lex_state = 90, .external_lex_state = 4},
  [3191] = {.lex_state = 90, .external_lex_state = 4},
  [3192] = {.lex_state = 90, .external_lex_state = 4},
  [3193] = {.lex_state = 90, .external_lex_state = 4},
  [3194] = {.lex_state = 90, .external_lex_state = 4},
  [3195] = {.lex_state = 90, .external_lex_state = 4},
  [3196] = {.lex_state = 90, .external_lex_state = 4},
  [3197] = {.lex_state = 90, .external_lex_state = 4},
  [3198] = {.lex_state = 90, .external_lex_state = 6},
  [3199] = {.lex_state = 90, .external_lex_state = 4},
  [3200] = {.lex_state = 90, .external_lex_state = 6},
  [3201] = {.lex_state = 90, .external_lex_state = 4},
  [3202] = {.lex_state = 90, .external_lex_state = 4},
  [3203] = {.lex_state = 90, .external_lex_state = 4},
  [3204] = {.lex_state = 90, .external_lex_state = 4},
  [3205] = {.lex_state = 90, .external_lex_state = 4},
  [3206] = {.lex_state = 90, .external_lex_state = 4},
  [3207] = {.lex_state = 90, .external_lex_state = 6},
  [3208] = {.lex_state = 90, .external_lex_state = 4},
  [3209] = {.lex_state = 90, .external_lex_state = 4},
  [3210] = {.lex_state = 90, .external_lex_state = 4},
  [3211] = {.lex_state = 90, .external_lex_state = 4},
  [3212] = {.lex_state = 90, .external_lex_state = 4},
  [3213] = {.lex_state = 90, .external_lex_state = 4},
  [3214] = {.lex_state = 90, .external_lex_state = 4},
  [3215] = {.lex_state = 90, .external_lex_state = 4},
  [3216] = {.lex_state = 90, .external_lex_state = 4},
  [3217] = {.lex_state = 90, .external_lex_state = 4},
  [3218] = {.lex_state = 90, .external_lex_state = 4},
  [3219] = {.lex_state = 90, .external_lex_state = 6},
  [3220] = {.lex_state = 90, .external_lex_state = 4},
  [3221] = {.lex_state = 90, .external_lex_state = 4},
  [3222] = {.lex_state = 90, .external_lex_state = 4},
  [3223] = {.lex_state = 90, .external_lex_state = 4},
  [3224] = {.lex_state = 90, .external_lex_state = 4},
  [3225] = {.lex_state = 90, .external_lex_state = 4},
  [3226] = {.lex_state = 90, .external_lex_state = 4},
  [3227] = {.lex_state = 90, .external_lex_state = 4},
  [3228] = {.lex_state = 90, .external_lex_state = 4},
  [3229] = {.lex_state = 90, .external_lex_state = 4},
  [3230] = {.lex_state = 90, .external_lex_state = 4},
  [3231] = {.lex_state = 90, .external_lex_state = 4},
  [3232] = {.lex_state = 90, .external_lex_state = 4},
  [3233] = {.lex_state = 90, .external_lex_state = 4},
  [3234] = {.lex_state = 90, .external_lex_state = 4},
  [3235] = {.lex_state = 90, .external_lex_state = 4},
  [3236] = {.lex_state = 90, .external_lex_state = 4},
  [3237] = {.lex_state = 90, .external_lex_state = 4},
  [3238] = {.lex_state = 90, .external_lex_state = 4},
  [3239] = {.lex_state = 90, .external_lex_state = 4},
  [3240] = {.lex_state = 90, .external_lex_state = 4},
  [3241] = {.lex_state = 90, .external_lex_state = 4},
  [3242] = {.lex_state = 90, .external_lex_state = 4},
  [3243] = {.lex_state = 90, .external_lex_state = 4},
  [3244] = {.lex_state = 90, .external_lex_state = 4},
  [3245] = {.lex_state = 90, .external_lex_state = 4},
  [3246] = {.lex_state = 90, .external_lex_state = 4},
  [3247] = {.lex_state = 90, .external_lex_state = 4},
  [3248] = {.lex_state = 90, .external_lex_state = 4},
  [3249] = {.lex_state = 90, .external_lex_state = 4},
  [3250] = {.lex_state = 90, .external_lex_state = 4},
  [3251] = {.lex_state = 90, .external_lex_state = 4},
  [3252] = {.lex_state = 90, .external_lex_state = 4},
  [3253] = {.lex_state = 90, .external_lex_state = 4},
  [3254] = {.lex_state = 90, .external_lex_state = 4},
  [3255] = {.lex_state = 90, .external_lex_state = 4},
  [3256] = {.lex_state = 90, .external_lex_state = 4},
  [3257] = {.lex_state = 90, .external_lex_state = 4},
  [3258] = {.lex_state = 90, .external_lex_state = 4},
  [3259] = {.lex_state = 90, .external_lex_state = 4},
  [3260] = {.lex_state = 89, .external_lex_state = 8},
  [3261] = {.lex_state = 90, .external_lex_state = 4},
  [3262] = {.lex_state = 90, .external_lex_state = 4},
  [3263] = {.lex_state = 90, .external_lex_state = 4},
  [3264] = {.lex_state = 90, .external_lex_state = 6},
  [3265] = {.lex_state = 90, .external_lex_state = 4},
  [3266] = {.lex_state = 90, .external_lex_state = 6},
  [3267] = {.lex_state = 90, .external_lex_state = 6},
  [3268] = {.lex_state = 90, .external_lex_state = 6},
  [3269] = {.lex_state = 90, .external_lex_state = 6},
  [3270] = {.lex_state = 90, .external_lex_state = 6},
  [3271] = {.lex_state = 90, .external_lex_state = 6},
  [3272] = {.lex_state = 90, .external_lex_state = 4},
  [3273] = {.lex_state = 90, .external_lex_state = 6},
  [3274] = {.lex_state = 90, .external_lex_state = 8},
  [3275] = {.lex_state = 90, .external_lex_state = 8},
  [3276] = {.lex_state = 90, .external_lex_state = 8},
  [3277] = {.lex_state = 90, .external_lex_state = 8},
  [3278] = {.lex_state = 90, .external_lex_state = 8},
  [3279] = {.lex_state = 90, .external_lex_state = 8},
  [3280] = {.lex_state = 90, .external_lex_state = 4},
  [3281] = {.lex_state = 93, .external_lex_state = 7},
  [3282] = {.lex_state = 90, .external_lex_state = 4},
  [3283] = {.lex_state = 90, .external_lex_state = 8},
  [3284] = {.lex_state = 90, .external_lex_state = 4},
  [3285] = {.lex_state = 90, .external_lex_state = 4},
  [3286] = {.lex_state = 90, .external_lex_state = 8},
  [3287] = {.lex_state = 90, .external_lex_state = 4},
  [3288] = {.lex_state = 90, .external_lex_state = 4},
  [3289] = {.lex_state = 90, .external_lex_state = 4},
  [3290] = {.lex_state = 90, .external_lex_state = 8},
  [3291] = {.lex_state = 90, .external_lex_state = 4},
  [3292] = {.lex_state = 90, .external_lex_state = 6},
  [3293] = {.lex_state = 90, .external_lex_state = 6},
  [3294] = {.lex_state = 90, .external_lex_state = 6},
  [3295] = {.lex_state = 90, .external_lex_state = 6},
  [3296] = {.lex_state = 90, .external_lex_state = 4},
  [3297] = {.lex_state = 90, .external_lex_state = 4},
  [3298] = {.lex_state = 90, .external_lex_state = 6},
  [3299] = {.lex_state = 90, .external_lex_state = 4},
  [3300] = {.lex_state = 90, .external_lex_state = 4},
  [3301] = {.lex_state = 90, .external_lex_state = 6},
  [3302] = {.lex_state = 90, .external_lex_state = 6},
  [3303] = {.lex_state = 90, .external_lex_state = 4},
  [3304] = {.lex_state = 90, .external_lex_state = 4},
  [3305] = {.lex_state = 90, .external_lex_state = 6},
  [3306] = {.lex_state = 90, .external_lex_state = 6},
  [3307] = {.lex_state = 90, .external_lex_state = 6},
  [3308] = {.lex_state = 90, .external_lex_state = 6},
  [3309] = {.lex_state = 90, .external_lex_state = 8},
  [3310] = {.lex_state = 90, .external_lex_state = 4},
  [3311] = {.lex_state = 90, .external_lex_state = 4},
  [3312] = {.lex_state = 90, .external_lex_state = 4},
  [3313] = {.lex_state = 90, .external_lex_state = 4},
  [3314] = {.lex_state = 90, .external_lex_state = 4},
  [3315] = {.lex_state = 90, .external_lex_state = 6},
  [3316] = {.lex_state = 90, .external_lex_state = 4},
  [3317] = {.lex_state = 90, .external_lex_state = 4},
  [3318] = {.lex_state = 90, .external_lex_state = 6},
  [3319] = {.lex_state = 90, .external_lex_state = 6},
  [3320] = {.lex_state = 90, .external_lex_state = 4},
  [3321] = {.lex_state = 90, .external_lex_state = 4},
  [3322] = {.lex_state = 90, .external_lex_state = 6},
  [3323] = {.lex_state = 90, .external_lex_state = 4},
  [3324] = {.lex_state = 90, .external_lex_state = 4},
  [3325] = {.lex_state = 86, .external_lex_state = 4},
  [3326] = {.lex_state = 86, .external_lex_state = 4},
  [3327] = {.lex_state = 90, .external_lex_state = 4},
  [3328] = {.lex_state = 86, .external_lex_state = 4},
  [3329] = {.lex_state = 86, .external_lex_state = 4},
  [3330] = {.lex_state = 86, .external_lex_state = 8},
  [3331] = {.lex_state = 86, .external_lex_state = 4},
  [3332] = {.lex_state = 86, .external_lex_state = 8},
  [3333] = {.lex_state = 86, .external_lex_state = 4},
  [3334] = {.lex_state = 90, .external_lex_state = 6},
  [3335] = {.lex_state = 86, .external_lex_state = 8},
  [3336] = {.lex_state = 86, .external_lex_state = 8},
  [3337] = {.lex_state = 86, .external_lex_state = 8},
  [3338] = {.lex_state = 86, .external_lex_state = 4},
  [3339] = {.lex_state = 90, .external_lex_state = 6},
  [3340] = {.lex_state = 90, .external_lex_state = 4},
  [3341] = {.lex_state = 86, .external_lex_state = 8},
  [3342] = {.lex_state = 86, .external_lex_state = 8},
  [3343] = {.lex_state = 90, .external_lex_state = 4},
  [3344] = {.lex_state = 90, .external_lex_state = 4},
  [3345] = {.lex_state = 90, .external_lex_state = 4},
  [3346] = {.lex_state = 90, .external_lex_state = 6},
  [3347] = {.lex_state = 90, .external_lex_state = 4},
  [3348] = {.lex_state = 90, .external_lex_state = 6},
  [3349] = {.lex_state = 90, .external_lex_state = 6},
  [3350] = {.lex_state = 90, .external_lex_state = 4},
  [3351] = {.lex_state = 90, .external_lex_state = 4},
  [3352] = {.lex_state = 90, .external_lex_state = 4},
  [3353] = {.lex_state = 90, .external_lex_state = 4},
  [3354] = {.lex_state = 90, .external_lex_state = 4},
  [3355] = {.lex_state = 90, .external_lex_state = 4},
  [3356] = {.lex_state = 90, .external_lex_state = 4},
  [3357] = {.lex_state = 90, .external_lex_state = 6},
  [3358] = {.lex_state = 90, .external_lex_state = 4},
  [3359] = {.lex_state = 90, .external_lex_state = 4},
  [3360] = {.lex_state = 90, .external_lex_state = 4},
  [3361] = {.lex_state = 90, .external_lex_state = 4},
  [3362] = {.lex_state = 90, .external_lex_state = 4},
  [3363] = {.lex_state = 90, .external_lex_state = 4},
  [3364] = {.lex_state = 90, .external_lex_state = 4},
  [3365] = {.lex_state = 90, .external_lex_state = 4},
  [3366] = {.lex_state = 90, .external_lex_state = 4},
  [3367] = {.lex_state = 90, .external_lex_state = 4},
  [3368] = {.lex_state = 90, .external_lex_state = 4},
  [3369] = {.lex_state = 90, .external_lex_state = 4},
  [3370] = {.lex_state = 90, .external_lex_state = 4},
  [3371] = {.lex_state = 90, .external_lex_state = 8},
  [3372] = {.lex_state = 90, .external_lex_state = 8},
  [3373] = {.lex_state = 90, .external_lex_state = 8},
  [3374] = {.lex_state = 86, .external_lex_state = 6},
  [3375] = {.lex_state = 90, .external_lex_state = 4},
  [3376] = {.lex_state = 89, .external_lex_state = 8},
  [3377] = {.lex_state = 90, .external_lex_state = 8},
  [3378] = {.lex_state = 90, .external_lex_state = 6},
  [3379] = {.lex_state = 86, .external_lex_state = 6},
  [3380] = {.lex_state = 90, .external_lex_state = 6},
  [3381] = {.lex_state = 90, .external_lex_state = 8},
  [3382] = {.lex_state = 90, .external_lex_state = 8},
  [3383] = {.lex_state = 90, .external_lex_state = 8},
  [3384] = {.lex_state = 90, .external_lex_state = 8},
  [3385] = {.lex_state = 90, .external_lex_state = 4},
  [3386] = {.lex_state = 90, .external_lex_state = 6},
  [3387] = {.lex_state = 86, .external_lex_state = 6},
  [3388] = {.lex_state = 90, .external_lex_state = 8},
  [3389] = {.lex_state = 90, .external_lex_state = 6},
  [3390] = {.lex_state = 90, .external_lex_state = 4},
  [3391] = {.lex_state = 90, .external_lex_state = 6},
  [3392] = {.lex_state = 90, .external_lex_state = 8},
  [3393] = {.lex_state = 90, .external_lex_state = 8},
  [3394] = {.lex_state = 90, .external_lex_state = 8},
  [3395] = {.lex_state = 90, .external_lex_state = 8},
  [3396] = {.lex_state = 90, .external_lex_state = 8},
  [3397] = {.lex_state = 90, .external_lex_state = 8},
  [3398] = {.lex_state = 90, .external_lex_state = 8},
  [3399] = {.lex_state = 90, .external_lex_state = 8},
  [3400] = {.lex_state = 90, .external_lex_state = 8},
  [3401] = {.lex_state = 90, .external_lex_state = 8},
  [3402] = {.lex_state = 90, .external_lex_state = 8},
  [3403] = {.lex_state = 90, .external_lex_state = 8},
  [3404] = {.lex_state = 90, .external_lex_state = 8},
  [3405] = {.lex_state = 90, .external_lex_state = 8},
  [3406] = {.lex_state = 90, .external_lex_state = 6},
  [3407] = {.lex_state = 90, .external_lex_state = 4},
  [3408] = {.lex_state = 94, .external_lex_state = 6},
  [3409] = {.lex_state = 90, .external_lex_state = 6},
  [3410] = {.lex_state = 90, .external_lex_state = 6},
  [3411] = {.lex_state = 90, .external_lex_state = 6},
  [3412] = {.lex_state = 86, .external_lex_state = 6},
  [3413] = {.lex_state = 90, .external_lex_state = 6},
  [3414] = {.lex_state = 90, .external_lex_state = 4},
  [3415] = {.lex_state = 94, .external_lex_state = 6},
  [3416] = {.lex_state = 95, .external_lex_state = 6},
  [3417] = {.lex_state = 90, .external_lex_state = 6},
  [3418] = {.lex_state = 90, .external_lex_state = 6},
  [3419] = {.lex_state = 90, .external_lex_state = 8},
  [3420] = {.lex_state = 90, .external_lex_state = 8},
  [3421] = {.lex_state = 86, .external_lex_state = 6},
  [3422] = {.lex_state = 90, .external_lex_state = 6},
  [3423] = {.lex_state = 86, .external_lex_state = 6},
  [3424] = {.lex_state = 94, .external_lex_state = 6},
  [3425] = {.lex_state = 90, .external_lex_state = 4},
  [3426] = {.lex_state = 90, .external_lex_state = 8},
  [3427] = {.lex_state = 90, .external_lex_state = 8},
  [3428] = {.lex_state = 90, .external_lex_state = 4},
  [3429] = {.lex_state = 90, .external_lex_state = 8},
  [3430] = {.lex_state = 90, .external_lex_state = 8},
  [3431] = {.lex_state = 90, .external_lex_state = 8},
  [3432] = {.lex_state = 90, .external_lex_state = 8},
  [3433] = {.lex_state = 90, .external_lex_state = 8},
  [3434] = {.lex_state = 90, .external_lex_state = 4},
  [3435] = {.lex_state = 90, .external_lex_state = 8},
  [3436] = {.lex_state = 90, .external_lex_state = 4},
  [3437] = {.lex_state = 90, .external_lex_state = 8},
  [3438] = {.lex_state = 90, .external_lex_state = 8},
  [3439] = {.lex_state = 90, .external_lex_state = 4},
  [3440] = {.lex_state = 90, .external_lex_state = 8},
  [3441] = {.lex_state = 90, .external_lex_state = 8},
  [3442] = {.lex_state = 86, .external_lex_state = 6},
  [3443] = {.lex_state = 90, .external_lex_state = 4},
  [3444] = {.lex_state = 90, .external_lex_state = 8},
  [3445] = {.lex_state = 90, .external_lex_state = 8},
  [3446] = {.lex_state = 90, .external_lex_state = 8},
  [3447] = {.lex_state = 90, .external_lex_state = 8},
  [3448] = {.lex_state = 90, .external_lex_state = 8},
  [3449] = {.lex_state = 90, .external_lex_state = 8},
  [3450] = {.lex_state = 93, .external_lex_state = 7},
  [3451] = {.lex_state = 90, .external_lex_state = 6},
  [3452] = {.lex_state = 90, .external_lex_state = 4},
  [3453] = {.lex_state = 90, .external_lex_state = 4},
  [3454] = {.lex_state = 90, .external_lex_state = 8},
  [3455] = {.lex_state = 90, .external_lex_state = 8},
  [3456] = {.lex_state = 90, .external_lex_state = 8},
  [3457] = {.lex_state = 94, .external_lex_state = 4},
  [3458] = {.lex_state = 90, .external_lex_state = 8},
  [3459] = {.lex_state = 90, .external_lex_state = 4},
  [3460] = {.lex_state = 90, .external_lex_state = 8},
  [3461] = {.lex_state = 90, .external_lex_state = 8},
  [3462] = {.lex_state = 90, .external_lex_state = 8},
  [3463] = {.lex_state = 90, .external_lex_state = 8},
  [3464] = {.lex_state = 90, .external_lex_state = 8},
  [3465] = {.lex_state = 90, .external_lex_state = 8},
  [3466] = {.lex_state = 90, .external_lex_state = 8},
  [3467] = {.lex_state = 90, .external_lex_state = 8},
  [3468] = {.lex_state = 90, .external_lex_state = 8},
  [3469] = {.lex_state = 90, .external_lex_state = 8},
  [3470] = {.lex_state = 90, .external_lex_state = 8},
  [3471] = {.lex_state = 90, .external_lex_state = 8},
  [3472] = {.lex_state = 90, .external_lex_state = 8},
  [3473] = {.lex_state = 90, .external_lex_state = 8},
  [3474] = {.lex_state = 90, .external_lex_state = 8},
  [3475] = {.lex_state = 90, .external_lex_state = 8},
  [3476] = {.lex_state = 90, .external_lex_state = 8},
  [3477] = {.lex_state = 90, .external_lex_state = 8},
  [3478] = {.lex_state = 90, .external_lex_state = 8},
  [3479] = {.lex_state = 90, .external_lex_state = 8},
  [3480] = {.lex_state = 90, .external_lex_state = 4},
  [3481] = {.lex_state = 90, .external_lex_state = 8},
  [3482] = {.lex_state = 90, .external_lex_state = 8},
  [3483] = {.lex_state = 90, .external_lex_state = 8},
  [3484] = {.lex_state = 90, .external_lex_state = 8},
  [3485] = {.lex_state = 90, .external_lex_state = 8},
  [3486] = {.lex_state = 90, .external_lex_state = 8},
  [3487] = {.lex_state = 90, .external_lex_state = 8},
  [3488] = {.lex_state = 90, .external_lex_state = 8},
  [3489] = {.lex_state = 90, .external_lex_state = 8},
  [3490] = {.lex_state = 90, .external_lex_state = 8},
  [3491] = {.lex_state = 90, .external_lex_state = 8},
  [3492] = {.lex_state = 90, .external_lex_state = 8},
  [3493] = {.lex_state = 95, .external_lex_state = 4},
  [3494] = {.lex_state = 95, .external_lex_state = 4},
  [3495] = {.lex_state = 90, .external_lex_state = 8},
  [3496] = {.lex_state = 94, .external_lex_state = 7},
  [3497] = {.lex_state = 95, .external_lex_state = 6},
  [3498] = {.lex_state = 94, .external_lex_state = 7},
  [3499] = {.lex_state = 90, .external_lex_state = 8},
  [3500] = {.lex_state = 90, .external_lex_state = 8},
  [3501] = {.lex_state = 90, .external_lex_state = 8},
  [3502] = {.lex_state = 90, .external_lex_state = 8},
  [3503] = {.lex_state = 90, .external_lex_state = 8},
  [3504] = {.lex_state = 90, .external_lex_state = 8},
  [3505] = {.lex_state = 90, .external_lex_state = 8},
  [3506] = {.lex_state = 90, .external_lex_state = 8},
  [3507] = {.lex_state = 90, .external_lex_state = 8},
  [3508] = {.lex_state = 94, .external_lex_state = 5},
  [3509] = {.lex_state = 90, .external_lex_state = 8},
  [3510] = {.lex_state = 90, .external_lex_state = 8},
  [3511] = {.lex_state = 90, .external_lex_state = 8},
  [3512] = {.lex_state = 90, .external_lex_state = 8},
  [3513] = {.lex_state = 90, .external_lex_state = 8},
  [3514] = {.lex_state = 90, .external_lex_state = 4},
  [3515] = {.lex_state = 90, .external_lex_state = 8},
  [3516] = {.lex_state = 90, .external_lex_state = 8},
  [3517] = {.lex_state = 90, .external_lex_state = 8},
  [3518] = {.lex_state = 90, .external_lex_state = 8},
  [3519] = {.lex_state = 90, .external_lex_state = 8},
  [3520] = {.lex_state = 94, .external_lex_state = 4},
  [3521] = {.lex_state = 90, .external_lex_state = 8},
  [3522] = {.lex_state = 94, .external_lex_state = 4},
  [3523] = {.lex_state = 90, .external_lex_state = 8},
  [3524] = {.lex_state = 90, .external_lex_state = 8},
  [3525] = {.lex_state = 90, .external_lex_state = 8},
  [3526] = {.lex_state = 90, .external_lex_state = 8},
  [3527] = {.lex_state = 90, .external_lex_state = 8},
  [3528] = {.lex_state = 90, .external_lex_state = 8},
  [3529] = {.lex_state = 94, .external_lex_state = 7},
  [3530] = {.lex_state = 90, .external_lex_state = 8},
  [3531] = {.lex_state = 90, .external_lex_state = 8},
  [3532] = {.lex_state = 90, .external_lex_state = 8},
  [3533] = {.lex_state = 90, .external_lex_state = 8},
  [3534] = {.lex_state = 90, .external_lex_state = 4},
  [3535] = {.lex_state = 90, .external_lex_state = 8},
  [3536] = {.lex_state = 90, .external_lex_state = 8},
  [3537] = {.lex_state = 90, .external_lex_state = 8},
  [3538] = {.lex_state = 90, .external_lex_state = 8},
  [3539] = {.lex_state = 90, .external_lex_state = 8},
  [3540] = {.lex_state = 90, .external_lex_state = 8},
  [3541] = {.lex_state = 90, .external_lex_state = 8},
  [3542] = {.lex_state = 90, .external_lex_state = 8},
  [3543] = {.lex_state = 90, .external_lex_state = 8},
  [3544] = {.lex_state = 90, .external_lex_state = 8},
  [3545] = {.lex_state = 90, .external_lex_state = 4},
  [3546] = {.lex_state = 90, .external_lex_state = 8},
  [3547] = {.lex_state = 90, .external_lex_state = 8},
  [3548] = {.lex_state = 90, .external_lex_state = 8},
  [3549] = {.lex_state = 90, .external_lex_state = 8},
  [3550] = {.lex_state = 90, .external_lex_state = 8},
  [3551] = {.lex_state = 90, .external_lex_state = 8},
  [3552] = {.lex_state = 90, .external_lex_state = 8},
  [3553] = {.lex_state = 90, .external_lex_state = 8},
  [3554] = {.lex_state = 90, .external_lex_state = 8},
  [3555] = {.lex_state = 93, .external_lex_state = 7},
  [3556] = {.lex_state = 90, .external_lex_state = 8},
  [3557] = {.lex_state = 90, .external_lex_state = 4},
  [3558] = {.lex_state = 90, .external_lex_state = 8},
  [3559] = {.lex_state = 90, .external_lex_state = 8},
  [3560] = {.lex_state = 90, .external_lex_state = 8},
  [3561] = {.lex_state = 90, .external_lex_state = 8},
  [3562] = {.lex_state = 90, .external_lex_state = 8},
  [3563] = {.lex_state = 90, .external_lex_state = 8},
  [3564] = {.lex_state = 90, .external_lex_state = 8},
  [3565] = {.lex_state = 95, .external_lex_state = 4},
  [3566] = {.lex_state = 93, .external_lex_state = 7},
  [3567] = {.lex_state = 95, .external_lex_state = 6},
  [3568] = {.lex_state = 90, .external_lex_state = 8},
  [3569] = {.lex_state = 95, .external_lex_state = 6},
  [3570] = {.lex_state = 90, .external_lex_state = 8},
  [3571] = {.lex_state = 90, .external_lex_state = 8},
  [3572] = {.lex_state = 90, .external_lex_state = 8},
  [3573] = {.lex_state = 90, .external_lex_state = 8},
  [3574] = {.lex_state = 90, .external_lex_state = 8},
  [3575] = {.lex_state = 90, .external_lex_state = 8},
  [3576] = {.lex_state = 90, .external_lex_state = 8},
  [3577] = {.lex_state = 95, .external_lex_state = 6},
  [3578] = {.lex_state = 95, .external_lex_state = 6},
  [3579] = {.lex_state = 90, .external_lex_state = 8},
  [3580] = {.lex_state = 94, .external_lex_state = 6},
  [3581] = {.lex_state = 90, .external_lex_state = 8},
  [3582] = {.lex_state = 90, .external_lex_state = 8},
  [3583] = {.lex_state = 90, .external_lex_state = 8},
  [3584] = {.lex_state = 90, .external_lex_state = 8},
  [3585] = {.lex_state = 90, .external_lex_state = 8},
  [3586] = {.lex_state = 95, .external_lex_state = 6},
  [3587] = {.lex_state = 90, .external_lex_state = 8},
  [3588] = {.lex_state = 90, .external_lex_state = 4},
  [3589] = {.lex_state = 94, .external_lex_state = 5},
  [3590] = {.lex_state = 90, .external_lex_state = 8},
  [3591] = {.lex_state = 90, .external_lex_state = 8},
  [3592] = {.lex_state = 90, .external_lex_state = 8},
  [3593] = {.lex_state = 90, .external_lex_state = 8},
  [3594] = {.lex_state = 90, .external_lex_state = 8},
  [3595] = {.lex_state = 90, .external_lex_state = 8},
  [3596] = {.lex_state = 90, .external_lex_state = 8},
  [3597] = {.lex_state = 90, .external_lex_state = 8},
  [3598] = {.lex_state = 90, .external_lex_state = 8},
  [3599] = {.lex_state = 90, .external_lex_state = 8},
  [3600] = {.lex_state = 95, .external_lex_state = 4},
  [3601] = {.lex_state = 90, .external_lex_state = 8},
  [3602] = {.lex_state = 90, .external_lex_state = 8},
  [3603] = {.lex_state = 90, .external_lex_state = 8},
  [3604] = {.lex_state = 90, .external_lex_state = 8},
  [3605] = {.lex_state = 95, .external_lex_state = 6},
  [3606] = {.lex_state = 90, .external_lex_state = 8},
  [3607] = {.lex_state = 90, .external_lex_state = 4},
  [3608] = {.lex_state = 90, .external_lex_state = 8},
  [3609] = {.lex_state = 90, .external_lex_state = 8},
  [3610] = {.lex_state = 90, .external_lex_state = 8},
  [3611] = {.lex_state = 90, .external_lex_state = 8},
  [3612] = {.lex_state = 90, .external_lex_state = 8},
  [3613] = {.lex_state = 90, .external_lex_state = 8},
  [3614] = {.lex_state = 90, .external_lex_state = 8},
  [3615] = {.lex_state = 94, .external_lex_state = 5},
  [3616] = {.lex_state = 90, .external_lex_state = 8},
  [3617] = {.lex_state = 90, .external_lex_state = 8},
  [3618] = {.lex_state = 90, .external_lex_state = 8},
  [3619] = {.lex_state = 90, .external_lex_state = 8},
  [3620] = {.lex_state = 95, .external_lex_state = 6},
  [3621] = {.lex_state = 90, .external_lex_state = 8},
  [3622] = {.lex_state = 90, .external_lex_state = 8},
  [3623] = {.lex_state = 90, .external_lex_state = 8},
  [3624] = {.lex_state = 90, .external_lex_state = 8},
  [3625] = {.lex_state = 90, .external_lex_state = 8},
  [3626] = {.lex_state = 90, .external_lex_state = 8},
  [3627] = {.lex_state = 90, .external_lex_state = 8},
  [3628] = {.lex_state = 90, .external_lex_state = 8},
  [3629] = {.lex_state = 90, .external_lex_state = 8},
  [3630] = {.lex_state = 90, .external_lex_state = 8},
  [3631] = {.lex_state = 90, .external_lex_state = 8},
  [3632] = {.lex_state = 90, .external_lex_state = 8},
  [3633] = {.lex_state = 90, .external_lex_state = 8},
  [3634] = {.lex_state = 90, .external_lex_state = 8},
  [3635] = {.lex_state = 90, .external_lex_state = 8},
  [3636] = {.lex_state = 90, .external_lex_state = 8},
  [3637] = {.lex_state = 95, .external_lex_state = 6},
  [3638] = {.lex_state = 95, .external_lex_state = 6},
  [3639] = {.lex_state = 90, .external_lex_state = 8},
  [3640] = {.lex_state = 95, .external_lex_state = 6},
  [3641] = {.lex_state = 95, .external_lex_state = 6},
  [3642] = {.lex_state = 95, .external_lex_state = 6},
  [3643] = {.lex_state = 95, .external_lex_state = 6},
  [3644] = {.lex_state = 95, .external_lex_state = 6},
  [3645] = {.lex_state = 95, .external_lex_state = 6},
  [3646] = {.lex_state = 95, .external_lex_state = 6},
  [3647] = {.lex_state = 95, .external_lex_state = 6},
  [3648] = {.lex_state = 95, .external_lex_state = 6},
  [3649] = {.lex_state = 95, .external_lex_state = 6},
  [3650] = {.lex_state = 95, .external_lex_state = 6},
  [3651] = {.lex_state = 86, .external_lex_state = 5},
  [3652] = {.lex_state = 95, .external_lex_state = 6},
  [3653] = {.lex_state = 95, .external_lex_state = 6},
  [3654] = {.lex_state = 90, .external_lex_state = 8},
  [3655] = {.lex_state = 90, .external_lex_state = 8},
  [3656] = {.lex_state = 95, .external_lex_state = 6},
  [3657] = {.lex_state = 95, .external_lex_state = 6},
  [3658] = {.lex_state = 95, .external_lex_state = 6},
  [3659] = {.lex_state = 95, .external_lex_state = 6},
  [3660] = {.lex_state = 95, .external_lex_state = 6},
  [3661] = {.lex_state = 95, .external_lex_state = 6},
  [3662] = {.lex_state = 95, .external_lex_state = 4},
  [3663] = {.lex_state = 90, .external_lex_state = 8},
  [3664] = {.lex_state = 95, .external_lex_state = 6},
  [3665] = {.lex_state = 86, .external_lex_state = 5},
  [3666] = {.lex_state = 95, .external_lex_state = 4},
  [3667] = {.lex_state = 95, .external_lex_state = 6},
  [3668] = {.lex_state = 95, .external_lex_state = 6},
  [3669] = {.lex_state = 90, .external_lex_state = 8},
  [3670] = {.lex_state = 95, .external_lex_state = 6},
  [3671] = {.lex_state = 95, .external_lex_state = 6},
  [3672] = {.lex_state = 95, .external_lex_state = 6},
  [3673] = {.lex_state = 95, .external_lex_state = 6},
  [3674] = {.lex_state = 90, .external_lex_state = 8},
  [3675] = {.lex_state = 95, .external_lex_state = 6},
  [3676] = {.lex_state = 95, .external_lex_state = 6},
  [3677] = {.lex_state = 95, .external_lex_state = 6},
  [3678] = {.lex_state = 95, .external_lex_state = 6},
  [3679] = {.lex_state = 95, .external_lex_state = 6},
  [3680] = {.lex_state = 95, .external_lex_state = 6},
  [3681] = {.lex_state = 95, .external_lex_state = 4},
  [3682] = {.lex_state = 95, .external_lex_state = 6},
  [3683] = {.lex_state = 86, .external_lex_state = 5},
  [3684] = {.lex_state = 95, .external_lex_state = 6},
  [3685] = {.lex_state = 95, .external_lex_state = 6},
  [3686] = {.lex_state = 95, .external_lex_state = 6},
  [3687] = {.lex_state = 95, .external_lex_state = 6},
  [3688] = {.lex_state = 94, .external_lex_state = 7},
  [3689] = {.lex_state = 95, .external_lex_state = 6},
  [3690] = {.lex_state = 95, .external_lex_state = 6},
  [3691] = {.lex_state = 95, .external_lex_state = 6},
  [3692] = {.lex_state = 95, .external_lex_state = 6},
  [3693] = {.lex_state = 94, .external_lex_state = 4},
  [3694] = {.lex_state = 95, .external_lex_state = 6},
  [3695] = {.lex_state = 90, .external_lex_state = 8},
  [3696] = {.lex_state = 95, .external_lex_state = 6},
  [3697] = {.lex_state = 90, .external_lex_state = 8},
  [3698] = {.lex_state = 90, .external_lex_state = 8},
  [3699] = {.lex_state = 86, .external_lex_state = 5},
  [3700] = {.lex_state = 95, .external_lex_state = 6},
  [3701] = {.lex_state = 86, .external_lex_state = 5},
  [3702] = {.lex_state = 95, .external_lex_state = 6},
  [3703] = {.lex_state = 89, .external_lex_state = 10},
  [3704] = {.lex_state = 95, .external_lex_state = 4},
  [3705] = {.lex_state = 90, .external_lex_state = 8},
  [3706] = {.lex_state = 95, .external_lex_state = 4},
  [3707] = {.lex_state = 95, .external_lex_state = 6},
  [3708] = {.lex_state = 86, .external_lex_state = 5},
  [3709] = {.lex_state = 95, .external_lex_state = 6},
  [3710] = {.lex_state = 94, .external_lex_state = 5},
  [3711] = {.lex_state = 95, .external_lex_state = 6},
  [3712] = {.lex_state = 95, .external_lex_state = 6},
  [3713] = {.lex_state = 86, .external_lex_state = 5},
  [3714] = {.lex_state = 90, .external_lex_state = 8},
  [3715] = {.lex_state = 90, .external_lex_state = 8},
  [3716] = {.lex_state = 95, .external_lex_state = 4},
  [3717] = {.lex_state = 95, .external_lex_state = 7},
  [3718] = {.lex_state = 95, .external_lex_state = 5},
  [3719] = {.lex_state = 95, .external_lex_state = 7},
  [3720] = {.lex_state = 95, .external_lex_state = 7},
  [3721] = {.lex_state = 95, .external_lex_state = 4},
  [3722] = {.lex_state = 95, .external_lex_state = 5},
  [3723] = {.lex_state = 95, .external_lex_state = 5},
  [3724] = {.lex_state = 95, .external_lex_state = 5},
  [3725] = {.lex_state = 95, .external_lex_state = 5},
  [3726] = {.lex_state = 95, .external_lex_state = 5},
  [3727] = {.lex_state = 95, .external_lex_state = 5},
  [3728] = {.lex_state = 90, .external_lex_state = 8},
  [3729] = {.lex_state = 95, .external_lex_state = 5},
  [3730] = {.lex_state = 95, .external_lex_state = 5},
  [3731] = {.lex_state = 95, .external_lex_state = 5},
  [3732] = {.lex_state = 95, .external_lex_state = 7},
  [3733] = {.lex_state = 95, .external_lex_state = 5},
  [3734] = {.lex_state = 90, .external_lex_state = 8},
  [3735] = {.lex_state = 90, .external_lex_state = 8},
  [3736] = {.lex_state = 90, .external_lex_state = 8},
  [3737] = {.lex_state = 90, .external_lex_state = 8},
  [3738] = {.lex_state = 90, .external_lex_state = 8},
  [3739] = {.lex_state = 90, .external_lex_state = 8},
  [3740] = {.lex_state = 90, .external_lex_state = 8},
  [3741] = {.lex_state = 90, .external_lex_state = 8},
  [3742] = {.lex_state = 90, .external_lex_state = 8},
  [3743] = {.lex_state = 95, .external_lex_state = 4},
  [3744] = {.lex_state = 86, .external_lex_state = 7},
  [3745] = {.lex_state = 95, .external_lex_state = 4},
  [3746] = {.lex_state = 86, .external_lex_state = 7},
  [3747] = {.lex_state = 95, .external_lex_state = 5},
  [3748] = {.lex_state = 95, .external_lex_state = 4},
  [3749] = {.lex_state = 95, .external_lex_state = 4},
  [3750] = {.lex_state = 95, .external_lex_state = 4},
  [3751] = {.lex_state = 95, .external_lex_state = 5},
  [3752] = {.lex_state = 95, .external_lex_state = 4},
  [3753] = {.lex_state = 95, .external_lex_state = 4},
  [3754] = {.lex_state = 95, .external_lex_state = 5},
  [3755] = {.lex_state = 95, .external_lex_state = 5},
  [3756] = {.lex_state = 95, .external_lex_state = 7},
  [3757] = {.lex_state = 95, .external_lex_state = 5},
  [3758] = {.lex_state = 90, .external_lex_state = 8},
  [3759] = {.lex_state = 95, .external_lex_state = 5},
  [3760] = {.lex_state = 95, .external_lex_state = 4},
  [3761] = {.lex_state = 95, .external_lex_state = 4},
  [3762] = {.lex_state = 95, .external_lex_state = 5},
  [3763] = {.lex_state = 95, .external_lex_state = 5},
  [3764] = {.lex_state = 95, .external_lex_state = 4},
  [3765] = {.lex_state = 95, .external_lex_state = 4},
  [3766] = {.lex_state = 95, .external_lex_state = 5},
  [3767] = {.lex_state = 95, .external_lex_state = 4},
  [3768] = {.lex_state = 95, .external_lex_state = 4},
  [3769] = {.lex_state = 95, .external_lex_state = 7},
  [3770] = {.lex_state = 95, .external_lex_state = 4},
  [3771] = {.lex_state = 95, .external_lex_state = 4},
  [3772] = {.lex_state = 95, .external_lex_state = 7},
  [3773] = {.lex_state = 95, .external_lex_state = 7},
  [3774] = {.lex_state = 86, .external_lex_state = 7},
  [3775] = {.lex_state = 95, .external_lex_state = 4},
  [3776] = {.lex_state = 95, .external_lex_state = 7},
  [3777] = {.lex_state = 95, .external_lex_state = 7},
  [3778] = {.lex_state = 95, .external_lex_state = 5},
  [3779] = {.lex_state = 95, .external_lex_state = 4},
  [3780] = {.lex_state = 86, .external_lex_state = 7},
  [3781] = {.lex_state = 95, .external_lex_state = 7},
  [3782] = {.lex_state = 95, .external_lex_state = 7},
  [3783] = {.lex_state = 95, .external_lex_state = 4},
  [3784] = {.lex_state = 95, .external_lex_state = 4},
  [3785] = {.lex_state = 95, .external_lex_state = 4},
  [3786] = {.lex_state = 90, .external_lex_state = 10},
  [3787] = {.lex_state = 90, .external_lex_state = 10},
  [3788] = {.lex_state = 90, .external_lex_state = 10},
  [3789] = {.lex_state = 95, .external_lex_state = 4},
  [3790] = {.lex_state = 90, .external_lex_state = 10},
  [3791] = {.lex_state = 90, .external_lex_state = 10},
  [3792] = {.lex_state = 90, .external_lex_state = 10},
  [3793] = {.lex_state = 95, .external_lex_state = 4},
  [3794] = {.lex_state = 95, .external_lex_state = 4},
  [3795] = {.lex_state = 95, .external_lex_state = 4},
  [3796] = {.lex_state = 86, .external_lex_state = 7},
  [3797] = {.lex_state = 95, .external_lex_state = 4},
  [3798] = {.lex_state = 95, .external_lex_state = 4},
  [3799] = {.lex_state = 95, .external_lex_state = 4},
  [3800] = {.lex_state = 90, .external_lex_state = 10},
  [3801] = {.lex_state = 95, .external_lex_state = 4},
  [3802] = {.lex_state = 95, .external_lex_state = 4},
  [3803] = {.lex_state = 95, .external_lex_state = 7},
  [3804] = {.lex_state = 95, .external_lex_state = 4},
  [3805] = {.lex_state = 95, .external_lex_state = 4},
  [3806] = {.lex_state = 95, .external_lex_state = 4},
  [3807] = {.lex_state = 95, .external_lex_state = 4},
  [3808] = {.lex_state = 90, .external_lex_state = 8},
  [3809] = {.lex_state = 95, .external_lex_state = 4},
  [3810] = {.lex_state = 95, .external_lex_state = 4},
  [3811] = {.lex_state = 95, .external_lex_state = 5},
  [3812] = {.lex_state = 95, .external_lex_state = 4},
  [3813] = {.lex_state = 95, .external_lex_state = 4},
  [3814] = {.lex_state = 95, .external_lex_state = 4},
  [3815] = {.lex_state = 95, .external_lex_state = 4},
  [3816] = {.lex_state = 90, .external_lex_state = 10},
  [3817] = {.lex_state = 90, .external_lex_state = 10},
  [3818] = {.lex_state = 95, .external_lex_state = 4},
  [3819] = {.lex_state = 95, .external_lex_state = 7},
  [3820] = {.lex_state = 90, .external_lex_state = 10},
  [3821] = {.lex_state = 95, .external_lex_state = 5},
  [3822] = {.lex_state = 90, .external_lex_state = 10},
  [3823] = {.lex_state = 95, .external_lex_state = 4},
  [3824] = {.lex_state = 95, .external_lex_state = 4},
  [3825] = {.lex_state = 95, .external_lex_state = 4},
  [3826] = {.lex_state = 95, .external_lex_state = 4},
  [3827] = {.lex_state = 90, .external_lex_state = 6},
  [3828] = {.lex_state = 95, .external_lex_state = 7},
  [3829] = {.lex_state = 95, .external_lex_state = 7},
  [3830] = {.lex_state = 95, .external_lex_state = 4},
  [3831] = {.lex_state = 95, .external_lex_state = 7},
  [3832] = {.lex_state = 95, .external_lex_state = 5},
  [3833] = {.lex_state = 95, .external_lex_state = 7},
  [3834] = {.lex_state = 95, .external_lex_state = 4},
  [3835] = {.lex_state = 95, .external_lex_state = 7},
  [3836] = {.lex_state = 95, .external_lex_state = 5},
  [3837] = {.lex_state = 95, .external_lex_state = 5},
  [3838] = {.lex_state = 89, .external_lex_state = 6},
  [3839] = {.lex_state = 95, .external_lex_state = 5},
  [3840] = {.lex_state = 95, .external_lex_state = 6},
  [3841] = {.lex_state = 95, .external_lex_state = 7},
  [3842] = {.lex_state = 95, .external_lex_state = 7},
  [3843] = {.lex_state = 95, .external_lex_state = 5},
  [3844] = {.lex_state = 95, .external_lex_state = 7},
  [3845] = {.lex_state = 95, .external_lex_state = 7},
  [3846] = {.lex_state = 95, .external_lex_state = 7},
  [3847] = {.lex_state = 95, .external_lex_state = 7},
  [3848] = {.lex_state = 95, .external_lex_state = 5},
  [3849] = {.lex_state = 86, .external_lex_state = 10},
  [3850] = {.lex_state = 86, .external_lex_state = 10},
  [3851] = {.lex_state = 95, .external_lex_state = 5},
  [3852] = {.lex_state = 86, .external_lex_state = 10},
  [3853] = {.lex_state = 86, .external_lex_state = 10},
  [3854] = {.lex_state = 95, .external_lex_state = 5},
  [3855] = {.lex_state = 86, .external_lex_state = 10},
  [3856] = {.lex_state = 86, .external_lex_state = 10},
  [3857] = {.lex_state = 86, .external_lex_state = 10},
  [3858] = {.lex_state = 95, .external_lex_state = 7},
  [3859] = {.lex_state = 95, .external_lex_state = 4},
  [3860] = {.lex_state = 95, .external_lex_state = 5},
  [3861] = {.lex_state = 95, .external_lex_state = 4},
  [3862] = {.lex_state = 95, .external_lex_state = 5},
  [3863] = {.lex_state = 95, .external_lex_state = 7},
  [3864] = {.lex_state = 86, .external_lex_state = 7},
  [3865] = {.lex_state = 95, .external_lex_state = 5},
  [3866] = {.lex_state = 95, .external_lex_state = 5},
  [3867] = {.lex_state = 95, .external_lex_state = 7},
  [3868] = {.lex_state = 95, .external_lex_state = 5},
  [3869] = {.lex_state = 95, .external_lex_state = 7},
  [3870] = {.lex_state = 95, .external_lex_state = 7},
  [3871] = {.lex_state = 95, .external_lex_state = 7},
  [3872] = {.lex_state = 95, .external_lex_state = 7},
  [3873] = {.lex_state = 86, .external_lex_state = 4},
  [3874] = {.lex_state = 86, .external_lex_state = 4},
  [3875] = {.lex_state = 86, .external_lex_state = 4},
  [3876] = {.lex_state = 95, .external_lex_state = 5},
  [3877] = {.lex_state = 90, .external_lex_state = 8},
  [3878] = {.lex_state = 95, .external_lex_state = 7},
  [3879] = {.lex_state = 95, .external_lex_state = 6},
  [3880] = {.lex_state = 95, .external_lex_state = 7},
  [3881] = {.lex_state = 95, .external_lex_state = 7},
  [3882] = {.lex_state = 95, .external_lex_state = 7},
  [3883] = {.lex_state = 95, .external_lex_state = 7},
  [3884] = {.lex_state = 95, .external_lex_state = 5},
  [3885] = {.lex_state = 95, .external_lex_state = 7},
  [3886] = {.lex_state = 95, .external_lex_state = 7},
  [3887] = {.lex_state = 95, .external_lex_state = 7},
  [3888] = {.lex_state = 95, .external_lex_state = 7},
  [3889] = {.lex_state = 95, .external_lex_state = 5},
  [3890] = {.lex_state = 89, .external_lex_state = 10},
  [3891] = {.lex_state = 90, .external_lex_state = 4},
  [3892] = {.lex_state = 89, .external_lex_state = 10},
  [3893] = {.lex_state = 89, .external_lex_state = 10},
  [3894] = {.lex_state = 95, .external_lex_state = 7},
  [3895] = {.lex_state = 90, .external_lex_state = 8},
  [3896] = {.lex_state = 95, .external_lex_state = 5},
  [3897] = {.lex_state = 95, .external_lex_state = 5},
  [3898] = {.lex_state = 95, .external_lex_state = 7},
  [3899] = {.lex_state = 86, .external_lex_state = 4},
  [3900] = {.lex_state = 95, .external_lex_state = 5},
  [3901] = {.lex_state = 94, .external_lex_state = 8},
  [3902] = {.lex_state = 86, .external_lex_state = 4},
  [3903] = {.lex_state = 94, .external_lex_state = 8},
  [3904] = {.lex_state = 95, .external_lex_state = 7},
  [3905] = {.lex_state = 95, .external_lex_state = 7},
  [3906] = {.lex_state = 95, .external_lex_state = 5},
  [3907] = {.lex_state = 95, .external_lex_state = 7},
  [3908] = {.lex_state = 86, .external_lex_state = 7},
  [3909] = {.lex_state = 95, .external_lex_state = 7},
  [3910] = {.lex_state = 86, .external_lex_state = 4},
  [3911] = {.lex_state = 94, .external_lex_state = 8},
  [3912] = {.lex_state = 95, .external_lex_state = 5},
  [3913] = {.lex_state = 95, .external_lex_state = 4},
  [3914] = {.lex_state = 95, .external_lex_state = 5},
  [3915] = {.lex_state = 95, .external_lex_state = 4},
  [3916] = {.lex_state = 86, .external_lex_state = 4},
  [3917] = {.lex_state = 95, .external_lex_state = 4},
  [3918] = {.lex_state = 95, .external_lex_state = 5},
  [3919] = {.lex_state = 90, .external_lex_state = 8},
  [3920] = {.lex_state = 95, .external_lex_state = 5},
  [3921] = {.lex_state = 95, .external_lex_state = 7},
  [3922] = {.lex_state = 95, .external_lex_state = 7},
  [3923] = {.lex_state = 95, .external_lex_state = 7},
  [3924] = {.lex_state = 95, .external_lex_state = 5},
  [3925] = {.lex_state = 95, .external_lex_state = 5},
  [3926] = {.lex_state = 95, .external_lex_state = 5},
  [3927] = {.lex_state = 95, .external_lex_state = 5},
  [3928] = {.lex_state = 95, .external_lex_state = 5},
  [3929] = {.lex_state = 95, .external_lex_state = 5},
  [3930] = {.lex_state = 95, .external_lex_state = 5},
  [3931] = {.lex_state = 95, .external_lex_state = 5},
  [3932] = {.lex_state = 90, .external_lex_state = 8},
  [3933] = {.lex_state = 95, .external_lex_state = 5},
  [3934] = {.lex_state = 95, .external_lex_state = 5},
  [3935] = {.lex_state = 95, .external_lex_state = 5},
  [3936] = {.lex_state = 95, .external_lex_state = 5},
  [3937] = {.lex_state = 95, .external_lex_state = 5},
  [3938] = {.lex_state = 95, .external_lex_state = 5},
  [3939] = {.lex_state = 95, .external_lex_state = 5},
  [3940] = {.lex_state = 95, .external_lex_state = 5},
  [3941] = {.lex_state = 95, .external_lex_state = 5},
  [3942] = {.lex_state = 95, .external_lex_state = 5},
  [3943] = {.lex_state = 95, .external_lex_state = 5},
  [3944] = {.lex_state = 95, .external_lex_state = 5},
  [3945] = {.lex_state = 95, .external_lex_state = 5},
  [3946] = {.lex_state = 95, .external_lex_state = 5},
  [3947] = {.lex_state = 95, .external_lex_state = 5},
  [3948] = {.lex_state = 90, .external_lex_state = 10},
  [3949] = {.lex_state = 95, .external_lex_state = 7},
  [3950] = {.lex_state = 95, .external_lex_state = 7},
  [3951] = {.lex_state = 95, .external_lex_state = 7},
  [3952] = {.lex_state = 95, .external_lex_state = 7},
  [3953] = {.lex_state = 90, .external_lex_state = 10},
  [3954] = {.lex_state = 90, .external_lex_state = 6},
  [3955] = {.lex_state = 95, .external_lex_state = 5},
  [3956] = {.lex_state = 95, .external_lex_state = 5},
  [3957] = {.lex_state = 90, .external_lex_state = 6},
  [3958] = {.lex_state = 90, .external_lex_state = 6},
  [3959] = {.lex_state = 90, .external_lex_state = 6},
  [3960] = {.lex_state = 90, .external_lex_state = 6},
  [3961] = {.lex_state = 90, .external_lex_state = 10},
  [3962] = {.lex_state = 95, .external_lex_state = 5},
  [3963] = {.lex_state = 95, .external_lex_state = 5},
  [3964] = {.lex_state = 95, .external_lex_state = 4},
  [3965] = {.lex_state = 95, .external_lex_state = 5},
  [3966] = {.lex_state = 90, .external_lex_state = 6},
  [3967] = {.lex_state = 95, .external_lex_state = 7},
  [3968] = {.lex_state = 95, .external_lex_state = 7},
  [3969] = {.lex_state = 95, .external_lex_state = 7},
  [3970] = {.lex_state = 95, .external_lex_state = 7},
  [3971] = {.lex_state = 95, .external_lex_state = 5},
  [3972] = {.lex_state = 90, .external_lex_state = 6},
  [3973] = {.lex_state = 90, .external_lex_state = 6},
  [3974] = {.lex_state = 90, .external_lex_state = 6},
  [3975] = {.lex_state = 95, .external_lex_state = 8},
  [3976] = {.lex_state = 90, .external_lex_state = 6},
  [3977] = {.lex_state = 90, .external_lex_state = 6},
  [3978] = {.lex_state = 95, .external_lex_state = 5},
  [3979] = {.lex_state = 95, .external_lex_state = 5},
  [3980] = {.lex_state = 95, .external_lex_state = 5},
  [3981] = {.lex_state = 95, .external_lex_state = 7},
  [3982] = {.lex_state = 95, .external_lex_state = 7},
  [3983] = {.lex_state = 95, .external_lex_state = 5},
  [3984] = {.lex_state = 94, .external_lex_state = 9},
  [3985] = {.lex_state = 95, .external_lex_state = 7},
  [3986] = {.lex_state = 95, .external_lex_state = 5},
  [3987] = {.lex_state = 95, .external_lex_state = 5},
  [3988] = {.lex_state = 95, .external_lex_state = 5},
  [3989] = {.lex_state = 95, .external_lex_state = 5},
  [3990] = {.lex_state = 95, .external_lex_state = 5},
  [3991] = {.lex_state = 95, .external_lex_state = 5},
  [3992] = {.lex_state = 95, .external_lex_state = 5},
  [3993] = {.lex_state = 86, .external_lex_state = 6},
  [3994] = {.lex_state = 95, .external_lex_state = 7},
  [3995] = {.lex_state = 95, .external_lex_state = 5},
  [3996] = {.lex_state = 95, .external_lex_state = 5},
  [3997] = {.lex_state = 95, .external_lex_state = 7},
  [3998] = {.lex_state = 95, .external_lex_state = 5},
  [3999] = {.lex_state = 95, .external_lex_state = 5},
  [4000] = {.lex_state = 95, .external_lex_state = 5},
  [4001] = {.lex_state = 95, .external_lex_state = 7},
  [4002] = {.lex_state = 95, .external_lex_state = 5},
  [4003] = {.lex_state = 95, .external_lex_state = 5},
  [4004] = {.lex_state = 95, .external_lex_state = 8},
  [4005] = {.lex_state = 95, .external_lex_state = 5},
  [4006] = {.lex_state = 95, .external_lex_state = 5},
  [4007] = {.lex_state = 95, .external_lex_state = 5},
  [4008] = {.lex_state = 95, .external_lex_state = 7},
  [4009] = {.lex_state = 95, .external_lex_state = 5},
  [4010] = {.lex_state = 95, .external_lex_state = 5},
  [4011] = {.lex_state = 95, .external_lex_state = 7},
  [4012] = {.lex_state = 95, .external_lex_state = 5},
  [4013] = {.lex_state = 95, .external_lex_state = 5},
  [4014] = {.lex_state = 86, .external_lex_state = 6},
  [4015] = {.lex_state = 90, .external_lex_state = 4},
  [4016] = {.lex_state = 95, .external_lex_state = 7},
  [4017] = {.lex_state = 95, .external_lex_state = 7},
  [4018] = {.lex_state = 95, .external_lex_state = 7},
  [4019] = {.lex_state = 95, .external_lex_state = 5},
  [4020] = {.lex_state = 90, .external_lex_state = 10},
  [4021] = {.lex_state = 95, .external_lex_state = 7},
  [4022] = {.lex_state = 95, .external_lex_state = 7},
  [4023] = {.lex_state = 95, .external_lex_state = 7},
  [4024] = {.lex_state = 86, .external_lex_state = 6},
  [4025] = {.lex_state = 95, .external_lex_state = 7},
  [4026] = {.lex_state = 95, .external_lex_state = 7},
  [4027] = {.lex_state = 95, .external_lex_state = 5},
  [4028] = {.lex_state = 86, .external_lex_state = 6},
  [4029] = {.lex_state = 95, .external_lex_state = 5},
  [4030] = {.lex_state = 86, .external_lex_state = 6},
  [4031] = {.lex_state = 90, .external_lex_state = 10},
  [4032] = {.lex_state = 95, .external_lex_state = 7},
  [4033] = {.lex_state = 95, .external_lex_state = 7},
  [4034] = {.lex_state = 95, .external_lex_state = 7},
  [4035] = {.lex_state = 95, .external_lex_state = 8},
  [4036] = {.lex_state = 95, .external_lex_state = 7},
  [4037] = {.lex_state = 95, .external_lex_state = 5},
  [4038] = {.lex_state = 95, .external_lex_state = 5},
  [4039] = {.lex_state = 95, .external_lex_state = 5},
  [4040] = {.lex_state = 95, .external_lex_state = 5},
  [4041] = {.lex_state = 86, .external_lex_state = 6},
  [4042] = {.lex_state = 95, .external_lex_state = 7},
  [4043] = {.lex_state = 95, .external_lex_state = 5},
  [4044] = {.lex_state = 95, .external_lex_state = 7},
  [4045] = {.lex_state = 95, .external_lex_state = 7},
  [4046] = {.lex_state = 95, .external_lex_state = 7},
  [4047] = {.lex_state = 95, .external_lex_state = 7},
  [4048] = {.lex_state = 95, .external_lex_state = 7},
  [4049] = {.lex_state = 95, .external_lex_state = 7},
  [4050] = {.lex_state = 95, .external_lex_state = 7},
  [4051] = {.lex_state = 95, .external_lex_state = 8},
  [4052] = {.lex_state = 95, .external_lex_state = 7},
  [4053] = {.lex_state = 86, .external_lex_state = 6},
  [4054] = {.lex_state = 86, .external_lex_state = 6},
  [4055] = {.lex_state = 95, .external_lex_state = 7},
  [4056] = {.lex_state = 95, .external_lex_state = 5},
  [4057] = {.lex_state = 95, .external_lex_state = 7},
  [4058] = {.lex_state = 95, .external_lex_state = 7},
  [4059] = {.lex_state = 95, .external_lex_state = 7},
  [4060] = {.lex_state = 86, .external_lex_state = 6},
  [4061] = {.lex_state = 95, .external_lex_state = 7},
  [4062] = {.lex_state = 95, .external_lex_state = 5},
  [4063] = {.lex_state = 95, .external_lex_state = 7},
  [4064] = {.lex_state = 95, .external_lex_state = 5},
  [4065] = {.lex_state = 95, .external_lex_state = 8},
  [4066] = {.lex_state = 95, .external_lex_state = 7},
  [4067] = {.lex_state = 95, .external_lex_state = 7},
  [4068] = {.lex_state = 95, .external_lex_state = 5},
  [4069] = {.lex_state = 95, .external_lex_state = 7},
  [4070] = {.lex_state = 90, .external_lex_state = 10},
  [4071] = {.lex_state = 90, .external_lex_state = 10},
  [4072] = {.lex_state = 90, .external_lex_state = 10},
  [4073] = {.lex_state = 95, .external_lex_state = 5},
  [4074] = {.lex_state = 95, .external_lex_state = 8},
  [4075] = {.lex_state = 95, .external_lex_state = 5},
  [4076] = {.lex_state = 90, .external_lex_state = 10},
  [4077] = {.lex_state = 95, .external_lex_state = 7},
  [4078] = {.lex_state = 95, .external_lex_state = 7},
  [4079] = {.lex_state = 90, .external_lex_state = 10},
  [4080] = {.lex_state = 90, .external_lex_state = 10},
  [4081] = {.lex_state = 90, .external_lex_state = 10},
  [4082] = {.lex_state = 95, .external_lex_state = 7},
  [4083] = {.lex_state = 95, .external_lex_state = 5},
  [4084] = {.lex_state = 90, .external_lex_state = 10},
  [4085] = {.lex_state = 95, .external_lex_state = 8},
  [4086] = {.lex_state = 95, .external_lex_state = 5},
  [4087] = {.lex_state = 95, .external_lex_state = 7},
  [4088] = {.lex_state = 90, .external_lex_state = 10},
  [4089] = {.lex_state = 94, .external_lex_state = 8},
  [4090] = {.lex_state = 95, .external_lex_state = 5},
  [4091] = {.lex_state = 90, .external_lex_state = 10},
  [4092] = {.lex_state = 95, .external_lex_state = 7},
  [4093] = {.lex_state = 95, .external_lex_state = 7},
  [4094] = {.lex_state = 95, .external_lex_state = 5},
  [4095] = {.lex_state = 90, .external_lex_state = 10},
  [4096] = {.lex_state = 95, .external_lex_state = 8},
  [4097] = {.lex_state = 95, .external_lex_state = 7},
  [4098] = {.lex_state = 94, .external_lex_state = 9},
  [4099] = {.lex_state = 95, .external_lex_state = 7},
  [4100] = {.lex_state = 95, .external_lex_state = 5},
  [4101] = {.lex_state = 95, .external_lex_state = 5},
  [4102] = {.lex_state = 90, .external_lex_state = 10},
  [4103] = {.lex_state = 95, .external_lex_state = 7},
  [4104] = {.lex_state = 95, .external_lex_state = 7},
  [4105] = {.lex_state = 95, .external_lex_state = 7},
  [4106] = {.lex_state = 95, .external_lex_state = 7},
  [4107] = {.lex_state = 90, .external_lex_state = 10},
  [4108] = {.lex_state = 95, .external_lex_state = 5},
  [4109] = {.lex_state = 95, .external_lex_state = 7},
  [4110] = {.lex_state = 95, .external_lex_state = 8},
  [4111] = {.lex_state = 95, .external_lex_state = 5},
  [4112] = {.lex_state = 90, .external_lex_state = 10},
  [4113] = {.lex_state = 90, .external_lex_state = 10},
  [4114] = {.lex_state = 95, .external_lex_state = 7},
  [4115] = {.lex_state = 95, .external_lex_state = 5},
  [4116] = {.lex_state = 94, .external_lex_state = 9},
  [4117] = {.lex_state = 95, .external_lex_state = 7},
  [4118] = {.lex_state = 95, .external_lex_state = 7},
  [4119] = {.lex_state = 95, .external_lex_state = 7},
  [4120] = {.lex_state = 95, .external_lex_state = 7},
  [4121] = {.lex_state = 95, .external_lex_state = 7},
  [4122] = {.lex_state = 95, .external_lex_state = 5},
  [4123] = {.lex_state = 95, .external_lex_state = 5},
  [4124] = {.lex_state = 95, .external_lex_state = 5},
  [4125] = {.lex_state = 95, .external_lex_state = 5},
  [4126] = {.lex_state = 95, .external_lex_state = 5},
  [4127] = {.lex_state = 95, .external_lex_state = 5},
  [4128] = {.lex_state = 95, .external_lex_state = 5},
  [4129] = {.lex_state = 95, .external_lex_state = 7},
  [4130] = {.lex_state = 95, .external_lex_state = 5},
  [4131] = {.lex_state = 95, .external_lex_state = 7},
  [4132] = {.lex_state = 95, .external_lex_state = 7},
  [4133] = {.lex_state = 95, .external_lex_state = 7},
  [4134] = {.lex_state = 95, .external_lex_state = 7},
  [4135] = {.lex_state = 95, .external_lex_state = 7},
  [4136] = {.lex_state = 95, .external_lex_state = 7},
  [4137] = {.lex_state = 95, .external_lex_state = 7},
  [4138] = {.lex_state = 95, .external_lex_state = 7},
  [4139] = {.lex_state = 95, .external_lex_state = 7},
  [4140] = {.lex_state = 95, .external_lex_state = 7},
  [4141] = {.lex_state = 95, .external_lex_state = 7},
  [4142] = {.lex_state = 90, .external_lex_state = 10},
  [4143] = {.lex_state = 95, .external_lex_state = 7},
  [4144] = {.lex_state = 95, .external_lex_state = 5},
  [4145] = {.lex_state = 95, .external_lex_state = 7},
  [4146] = {.lex_state = 95, .external_lex_state = 7},
  [4147] = {.lex_state = 95, .external_lex_state = 7},
  [4148] = {.lex_state = 95, .external_lex_state = 7},
  [4149] = {.lex_state = 95, .external_lex_state = 7},
  [4150] = {.lex_state = 95, .external_lex_state = 5},
  [4151] = {.lex_state = 95, .external_lex_state = 5},
  [4152] = {.lex_state = 95, .external_lex_state = 5},
  [4153] = {.lex_state = 90, .external_lex_state = 10},
  [4154] = {.lex_state = 95, .external_lex_state = 7},
  [4155] = {.lex_state = 95, .external_lex_state = 7},
  [4156] = {.lex_state = 95, .external_lex_state = 7},
  [4157] = {.lex_state = 89, .external_lex_state = 10},
  [4158] = {.lex_state = 95, .external_lex_state = 5},
  [4159] = {.lex_state = 95, .external_lex_state = 7},
  [4160] = {.lex_state = 95, .external_lex_state = 7},
  [4161] = {.lex_state = 95, .external_lex_state = 5},
  [4162] = {.lex_state = 95, .external_lex_state = 7},
  [4163] = {.lex_state = 95, .external_lex_state = 5},
  [4164] = {.lex_state = 90, .external_lex_state = 10},
  [4165] = {.lex_state = 95, .external_lex_state = 7},
  [4166] = {.lex_state = 90, .external_lex_state = 10},
  [4167] = {.lex_state = 95, .external_lex_state = 8},
  [4168] = {.lex_state = 90, .external_lex_state = 10},
  [4169] = {.lex_state = 86, .external_lex_state = 5},
  [4170] = {.lex_state = 90, .external_lex_state = 10},
  [4171] = {.lex_state = 90, .external_lex_state = 10},
  [4172] = {.lex_state = 90, .external_lex_state = 10},
  [4173] = {.lex_state = 90, .external_lex_state = 10},
  [4174] = {.lex_state = 95, .external_lex_state = 8},
  [4175] = {.lex_state = 90, .external_lex_state = 10},
  [4176] = {.lex_state = 90, .external_lex_state = 10},
  [4177] = {.lex_state = 90, .external_lex_state = 10},
  [4178] = {.lex_state = 90, .external_lex_state = 10},
  [4179] = {.lex_state = 90, .external_lex_state = 10},
  [4180] = {.lex_state = 95, .external_lex_state = 8},
  [4181] = {.lex_state = 90, .external_lex_state = 10},
  [4182] = {.lex_state = 95, .external_lex_state = 8},
  [4183] = {.lex_state = 90, .external_lex_state = 10},
  [4184] = {.lex_state = 90, .external_lex_state = 10},
  [4185] = {.lex_state = 95, .external_lex_state = 8},
  [4186] = {.lex_state = 90, .external_lex_state = 10},
  [4187] = {.lex_state = 90, .external_lex_state = 10},
  [4188] = {.lex_state = 90, .external_lex_state = 10},
  [4189] = {.lex_state = 90, .external_lex_state = 10},
  [4190] = {.lex_state = 95, .external_lex_state = 8},
  [4191] = {.lex_state = 90, .external_lex_state = 10},
  [4192] = {.lex_state = 90, .external_lex_state = 10},
  [4193] = {.lex_state = 90, .external_lex_state = 10},
  [4194] = {.lex_state = 95, .external_lex_state = 8},
  [4195] = {.lex_state = 90, .external_lex_state = 10},
  [4196] = {.lex_state = 90, .external_lex_state = 10},
  [4197] = {.lex_state = 90, .external_lex_state = 10},
  [4198] = {.lex_state = 95, .external_lex_state = 8},
  [4199] = {.lex_state = 90, .external_lex_state = 10},
  [4200] = {.lex_state = 90, .external_lex_state = 10},
  [4201] = {.lex_state = 95, .external_lex_state = 8},
  [4202] = {.lex_state = 95, .external_lex_state = 8},
  [4203] = {.lex_state = 90, .external_lex_state = 10},
  [4204] = {.lex_state = 95, .external_lex_state = 8},
  [4205] = {.lex_state = 90, .external_lex_state = 10},
  [4206] = {.lex_state = 90, .external_lex_state = 10},
  [4207] = {.lex_state = 90, .external_lex_state = 10},
  [4208] = {.lex_state = 95, .external_lex_state = 8},
  [4209] = {.lex_state = 90, .external_lex_state = 10},
  [4210] = {.lex_state = 90, .external_lex_state = 10},
  [4211] = {.lex_state = 90, .external_lex_state = 10},
  [4212] = {.lex_state = 95, .external_lex_state = 8},
  [4213] = {.lex_state = 90, .external_lex_state = 10},
  [4214] = {.lex_state = 95, .external_lex_state = 8},
  [4215] = {.lex_state = 90, .external_lex_state = 10},
  [4216] = {.lex_state = 90, .external_lex_state = 10},
  [4217] = {.lex_state = 90, .external_lex_state = 10},
  [4218] = {.lex_state = 95, .external_lex_state = 4},
  [4219] = {.lex_state = 86, .external_lex_state = 5},
  [4220] = {.lex_state = 95, .external_lex_state = 8},
  [4221] = {.lex_state = 90, .external_lex_state = 10},
  [4222] = {.lex_state = 90, .external_lex_state = 10},
  [4223] = {.lex_state = 95, .external_lex_state = 8},
  [4224] = {.lex_state = 90, .external_lex_state = 10},
  [4225] = {.lex_state = 95, .external_lex_state = 8},
  [4226] = {.lex_state = 95, .external_lex_state = 8},
  [4227] = {.lex_state = 90, .external_lex_state = 10},
  [4228] = {.lex_state = 90, .external_lex_state = 10},
  [4229] = {.lex_state = 95, .external_lex_state = 8},
  [4230] = {.lex_state = 90, .external_lex_state = 10},
  [4231] = {.lex_state = 95, .external_lex_state = 8},
  [4232] = {.lex_state = 95, .external_lex_state = 8},
  [4233] = {.lex_state = 95, .external_lex_state = 8},
  [4234] = {.lex_state = 95, .external_lex_state = 8},
  [4235] = {.lex_state = 90, .external_lex_state = 10},
  [4236] = {.lex_state = 90, .external_lex_state = 10},
  [4237] = {.lex_state = 90, .external_lex_state = 10},
  [4238] = {.lex_state = 90, .external_lex_state = 10},
  [4239] = {.lex_state = 95, .external_lex_state = 8},
  [4240] = {.lex_state = 95, .external_lex_state = 8},
  [4241] = {.lex_state = 90, .external_lex_state = 10},
  [4242] = {.lex_state = 90, .external_lex_state = 10},
  [4243] = {.lex_state = 90, .external_lex_state = 10},
  [4244] = {.lex_state = 90, .external_lex_state = 10},
  [4245] = {.lex_state = 95, .external_lex_state = 8},
  [4246] = {.lex_state = 95, .external_lex_state = 8},
  [4247] = {.lex_state = 90, .external_lex_state = 10},
  [4248] = {.lex_state = 95, .external_lex_state = 8},
  [4249] = {.lex_state = 90, .external_lex_state = 10},
  [4250] = {.lex_state = 90, .external_lex_state = 10},
  [4251] = {.lex_state = 95, .external_lex_state = 9},
  [4252] = {.lex_state = 90, .external_lex_state = 10},
  [4253] = {.lex_state = 95, .external_lex_state = 8},
  [4254] = {.lex_state = 95, .external_lex_state = 8},
  [4255] = {.lex_state = 95, .external_lex_state = 8},
  [4256] = {.lex_state = 90, .external_lex_state = 10},
  [4257] = {.lex_state = 90, .external_lex_state = 10},
  [4258] = {.lex_state = 86, .external_lex_state = 5},
  [4259] = {.lex_state = 90, .external_lex_state = 10},
  [4260] = {.lex_state = 95, .external_lex_state = 8},
  [4261] = {.lex_state = 95, .external_lex_state = 8},
  [4262] = {.lex_state = 95, .external_lex_state = 8},
  [4263] = {.lex_state = 90, .external_lex_state = 10},
  [4264] = {.lex_state = 90, .external_lex_state = 10},
  [4265] = {.lex_state = 86, .external_lex_state = 5},
  [4266] = {.lex_state = 95, .external_lex_state = 8},
  [4267] = {.lex_state = 90, .external_lex_state = 10},
  [4268] = {.lex_state = 90, .external_lex_state = 10},
  [4269] = {.lex_state = 90, .external_lex_state = 10},
  [4270] = {.lex_state = 86, .external_lex_state = 5},
  [4271] = {.lex_state = 95, .external_lex_state = 8},
  [4272] = {.lex_state = 95, .external_lex_state = 8},
  [4273] = {.lex_state = 90, .external_lex_state = 10},
  [4274] = {.lex_state = 90, .external_lex_state = 10},
  [4275] = {.lex_state = 90, .external_lex_state = 10},
  [4276] = {.lex_state = 95, .external_lex_state = 8},
  [4277] = {.lex_state = 90, .external_lex_state = 10},
  [4278] = {.lex_state = 95, .external_lex_state = 8},
  [4279] = {.lex_state = 90, .external_lex_state = 10},
  [4280] = {.lex_state = 90, .external_lex_state = 10},
  [4281] = {.lex_state = 90, .external_lex_state = 10},
  [4282] = {.lex_state = 90, .external_lex_state = 10},
  [4283] = {.lex_state = 90, .external_lex_state = 10},
  [4284] = {.lex_state = 86, .external_lex_state = 5},
  [4285] = {.lex_state = 95, .external_lex_state = 8},
  [4286] = {.lex_state = 90, .external_lex_state = 10},
  [4287] = {.lex_state = 90, .external_lex_state = 10},
  [4288] = {.lex_state = 95, .external_lex_state = 8},
  [4289] = {.lex_state = 95, .external_lex_state = 8},
  [4290] = {.lex_state = 90, .external_lex_state = 10},
  [4291] = {.lex_state = 95, .external_lex_state = 8},
  [4292] = {.lex_state = 95, .external_lex_state = 8},
  [4293] = {.lex_state = 90, .external_lex_state = 6},
  [4294] = {.lex_state = 90, .external_lex_state = 6},
  [4295] = {.lex_state = 95, .external_lex_state = 8},
  [4296] = {.lex_state = 95, .external_lex_state = 8},
  [4297] = {.lex_state = 95, .external_lex_state = 9},
  [4298] = {.lex_state = 90, .external_lex_state = 10},
  [4299] = {.lex_state = 90, .external_lex_state = 10},
  [4300] = {.lex_state = 90, .external_lex_state = 10},
  [4301] = {.lex_state = 95, .external_lex_state = 8},
  [4302] = {.lex_state = 90, .external_lex_state = 10},
  [4303] = {.lex_state = 90, .external_lex_state = 10},
  [4304] = {.lex_state = 90, .external_lex_state = 10},
  [4305] = {.lex_state = 90, .external_lex_state = 10},
  [4306] = {.lex_state = 95, .external_lex_state = 8},
  [4307] = {.lex_state = 90, .external_lex_state = 10},
  [4308] = {.lex_state = 90, .external_lex_state = 10},
  [4309] = {.lex_state = 90, .external_lex_state = 10},
  [4310] = {.lex_state = 95, .external_lex_state = 8},
  [4311] = {.lex_state = 90, .external_lex_state = 10},
  [4312] = {.lex_state = 90, .external_lex_state = 10},
  [4313] = {.lex_state = 90, .external_lex_state = 10},
  [4314] = {.lex_state = 90, .external_lex_state = 10},
  [4315] = {.lex_state = 90, .external_lex_state = 10},
  [4316] = {.lex_state = 90, .external_lex_state = 10},
  [4317] = {.lex_state = 90, .external_lex_state = 10},
  [4318] = {.lex_state = 90, .external_lex_state = 10},
  [4319] = {.lex_state = 90, .external_lex_state = 10},
  [4320] = {.lex_state = 90, .external_lex_state = 10},
  [4321] = {.lex_state = 90, .external_lex_state = 10},
  [4322] = {.lex_state = 95, .external_lex_state = 8},
  [4323] = {.lex_state = 90, .external_lex_state = 10},
  [4324] = {.lex_state = 90, .external_lex_state = 10},
  [4325] = {.lex_state = 90, .external_lex_state = 10},
  [4326] = {.lex_state = 90, .external_lex_state = 10},
  [4327] = {.lex_state = 90, .external_lex_state = 10},
  [4328] = {.lex_state = 90, .external_lex_state = 10},
  [4329] = {.lex_state = 94, .external_lex_state = 9},
  [4330] = {.lex_state = 90, .external_lex_state = 10},
  [4331] = {.lex_state = 90, .external_lex_state = 10},
  [4332] = {.lex_state = 90, .external_lex_state = 10},
  [4333] = {.lex_state = 90, .external_lex_state = 10},
  [4334] = {.lex_state = 86, .external_lex_state = 5},
  [4335] = {.lex_state = 90, .external_lex_state = 10},
  [4336] = {.lex_state = 90, .external_lex_state = 10},
  [4337] = {.lex_state = 90, .external_lex_state = 10},
  [4338] = {.lex_state = 90, .external_lex_state = 10},
  [4339] = {.lex_state = 90, .external_lex_state = 10},
  [4340] = {.lex_state = 95, .external_lex_state = 8},
  [4341] = {.lex_state = 86, .external_lex_state = 5},
  [4342] = {.lex_state = 90, .external_lex_state = 10},
  [4343] = {.lex_state = 86, .external_lex_state = 6},
  [4344] = {.lex_state = 90, .external_lex_state = 10},
  [4345] = {.lex_state = 86, .external_lex_state = 6},
  [4346] = {.lex_state = 90, .external_lex_state = 10},
  [4347] = {.lex_state = 86, .external_lex_state = 6},
  [4348] = {.lex_state = 90, .external_lex_state = 10},
  [4349] = {.lex_state = 90, .external_lex_state = 10},
  [4350] = {.lex_state = 90, .external_lex_state = 10},
  [4351] = {.lex_state = 86, .external_lex_state = 6},
  [4352] = {.lex_state = 90, .external_lex_state = 10},
  [4353] = {.lex_state = 86, .external_lex_state = 6},
  [4354] = {.lex_state = 90, .external_lex_state = 10},
  [4355] = {.lex_state = 86, .external_lex_state = 6},
  [4356] = {.lex_state = 86, .external_lex_state = 6},
  [4357] = {.lex_state = 90, .external_lex_state = 10},
  [4358] = {.lex_state = 90, .external_lex_state = 10},
  [4359] = {.lex_state = 90, .external_lex_state = 6},
  [4360] = {.lex_state = 90, .external_lex_state = 10},
  [4361] = {.lex_state = 90, .external_lex_state = 10},
  [4362] = {.lex_state = 90, .external_lex_state = 10},
  [4363] = {.lex_state = 90, .external_lex_state = 10},
  [4364] = {.lex_state = 90, .external_lex_state = 10},
  [4365] = {.lex_state = 95, .external_lex_state = 8},
  [4366] = {.lex_state = 90, .external_lex_state = 10},
  [4367] = {.lex_state = 90, .external_lex_state = 10},
  [4368] = {.lex_state = 90, .external_lex_state = 10},
  [4369] = {.lex_state = 90, .external_lex_state = 10},
  [4370] = {.lex_state = 90, .external_lex_state = 10},
  [4371] = {.lex_state = 90, .external_lex_state = 10},
  [4372] = {.lex_state = 90, .external_lex_state = 10},
  [4373] = {.lex_state = 95, .external_lex_state = 8},
  [4374] = {.lex_state = 90, .external_lex_state = 10},
  [4375] = {.lex_state = 90, .external_lex_state = 10},
  [4376] = {.lex_state = 95, .external_lex_state = 8},
  [4377] = {.lex_state = 90, .external_lex_state = 10},
  [4378] = {.lex_state = 90, .external_lex_state = 10},
  [4379] = {.lex_state = 95, .external_lex_state = 8},
  [4380] = {.lex_state = 90, .external_lex_state = 6},
  [4381] = {.lex_state = 90, .external_lex_state = 6},
  [4382] = {.lex_state = 90, .external_lex_state = 10},
  [4383] = {.lex_state = 90, .external_lex_state = 10},
  [4384] = {.lex_state = 90, .external_lex_state = 10},
  [4385] = {.lex_state = 90, .external_lex_state = 10},
  [4386] = {.lex_state = 90, .external_lex_state = 10},
  [4387] = {.lex_state = 90, .external_lex_state = 10},
  [4388] = {.lex_state = 90, .external_lex_state = 10},
  [4389] = {.lex_state = 90, .external_lex_state = 10},
  [4390] = {.lex_state = 90, .external_lex_state = 10},
  [4391] = {.lex_state = 90, .external_lex_state = 10},
  [4392] = {.lex_state = 90, .external_lex_state = 10},
  [4393] = {.lex_state = 90, .external_lex_state = 10},
  [4394] = {.lex_state = 95, .external_lex_state = 9},
  [4395] = {.lex_state = 95, .external_lex_state = 9},
  [4396] = {.lex_state = 95, .external_lex_state = 9},
  [4397] = {.lex_state = 95, .external_lex_state = 9},
  [4398] = {.lex_state = 95, .external_lex_state = 9},
  [4399] = {.lex_state = 95, .external_lex_state = 9},
  [4400] = {.lex_state = 95, .external_lex_state = 9},
  [4401] = {.lex_state = 95, .external_lex_state = 9},
  [4402] = {.lex_state = 95, .external_lex_state = 4},
  [4403] = {.lex_state = 90, .external_lex_state = 6},
  [4404] = {.lex_state = 95, .external_lex_state = 9},
  [4405] = {.lex_state = 90, .external_lex_state = 6},
  [4406] = {.lex_state = 95, .external_lex_state = 9},
  [4407] = {.lex_state = 95, .external_lex_state = 9},
  [4408] = {.lex_state = 95, .external_lex_state = 9},
  [4409] = {.lex_state = 95, .external_lex_state = 9},
  [4410] = {.lex_state = 95, .external_lex_state = 9},
  [4411] = {.lex_state = 95, .external_lex_state = 9},
  [4412] = {.lex_state = 95, .external_lex_state = 9},
  [4413] = {.lex_state = 95, .external_lex_state = 9},
  [4414] = {.lex_state = 95, .external_lex_state = 9},
  [4415] = {.lex_state = 95, .external_lex_state = 9},
  [4416] = {.lex_state = 95, .external_lex_state = 9},
  [4417] = {.lex_state = 95, .external_lex_state = 9},
  [4418] = {.lex_state = 86, .external_lex_state = 6},
  [4419] = {.lex_state = 95, .external_lex_state = 9},
  [4420] = {.lex_state = 95, .external_lex_state = 9},
  [4421] = {.lex_state = 95, .external_lex_state = 9},
  [4422] = {.lex_state = 95, .external_lex_state = 9},
  [4423] = {.lex_state = 95, .external_lex_state = 9},
  [4424] = {.lex_state = 95, .external_lex_state = 9},
  [4425] = {.lex_state = 95, .external_lex_state = 9},
  [4426] = {.lex_state = 95, .external_lex_state = 9},
  [4427] = {.lex_state = 86, .external_lex_state = 6},
  [4428] = {.lex_state = 95, .external_lex_state = 9},
  [4429] = {.lex_state = 95, .external_lex_state = 9},
  [4430] = {.lex_state = 95, .external_lex_state = 9},
  [4431] = {.lex_state = 95, .external_lex_state = 9},
  [4432] = {.lex_state = 95, .external_lex_state = 9},
  [4433] = {.lex_state = 95, .external_lex_state = 9},
  [4434] = {.lex_state = 95, .external_lex_state = 9},
  [4435] = {.lex_state = 95, .external_lex_state = 9},
  [4436] = {.lex_state = 95, .external_lex_state = 9},
  [4437] = {.lex_state = 95, .external_lex_state = 9},
  [4438] = {.lex_state = 95, .external_lex_state = 9},
  [4439] = {.lex_state = 95, .external_lex_state = 9},
  [4440] = {.lex_state = 95, .external_lex_state = 9},
  [4441] = {.lex_state = 95, .external_lex_state = 9},
  [4442] = {.lex_state = 95, .external_lex_state = 9},
  [4443] = {.lex_state = 95, .external_lex_state = 9},
  [4444] = {.lex_state = 95, .external_lex_state = 9},
  [4445] = {.lex_state = 95, .external_lex_state = 9},
  [4446] = {.lex_state = 95, .external_lex_state = 9},
  [4447] = {.lex_state = 95, .external_lex_state = 9},
  [4448] = {.lex_state = 95, .external_lex_state = 9},
  [4449] = {.lex_state = 95, .external_lex_state = 9},
  [4450] = {.lex_state = 90, .external_lex_state = 6},
  [4451] = {.lex_state = 90, .external_lex_state = 6},
  [4452] = {.lex_state = 90, .external_lex_state = 6},
  [4453] = {.lex_state = 95, .external_lex_state = 9},
  [4454] = {.lex_state = 95, .external_lex_state = 9},
  [4455] = {.lex_state = 95, .external_lex_state = 9},
  [4456] = {.lex_state = 90, .external_lex_state = 6},
  [4457] = {.lex_state = 95, .external_lex_state = 9},
  [4458] = {.lex_state = 95, .external_lex_state = 5},
  [4459] = {.lex_state = 95, .external_lex_state = 9},
  [4460] = {.lex_state = 95, .external_lex_state = 9},
  [4461] = {.lex_state = 95, .external_lex_state = 9},
  [4462] = {.lex_state = 95, .external_lex_state = 9},
  [4463] = {.lex_state = 95, .external_lex_state = 9},
  [4464] = {.lex_state = 95, .external_lex_state = 9},
  [4465] = {.lex_state = 95, .external_lex_state = 9},
  [4466] = {.lex_state = 95, .external_lex_state = 9},
  [4467] = {.lex_state = 95, .external_lex_state = 9},
  [4468] = {.lex_state = 95, .external_lex_state = 9},
  [4469] = {.lex_state = 95, .external_lex_state = 9},
  [4470] = {.lex_state = 95, .external_lex_state = 9},
  [4471] = {.lex_state = 95, .external_lex_state = 9},
  [4472] = {.lex_state = 95, .external_lex_state = 9},
  [4473] = {.lex_state = 95, .external_lex_state = 9},
  [4474] = {.lex_state = 95, .external_lex_state = 9},
  [4475] = {.lex_state = 95, .external_lex_state = 9},
  [4476] = {.lex_state = 86, .external_lex_state = 6},
  [4477] = {.lex_state = 95, .external_lex_state = 9},
  [4478] = {.lex_state = 95, .external_lex_state = 9},
  [4479] = {.lex_state = 95, .external_lex_state = 9},
  [4480] = {.lex_state = 95, .external_lex_state = 9},
  [4481] = {.lex_state = 95, .external_lex_state = 9},
  [4482] = {.lex_state = 95, .external_lex_state = 9},
  [4483] = {.lex_state = 95, .external_lex_state = 9},
  [4484] = {.lex_state = 95, .external_lex_state = 9},
  [4485] = {.lex_state = 95, .external_lex_state = 9},
  [4486] = {.lex_state = 95, .external_lex_state = 9},
  [4487] = {.lex_state = 95, .external_lex_state = 9},
  [4488] = {.lex_state = 90, .external_lex_state = 6},
  [4489] = {.lex_state = 95, .external_lex_state = 9},
  [4490] = {.lex_state = 90, .external_lex_state = 6},
  [4491] = {.lex_state = 90, .external_lex_state = 6},
  [4492] = {.lex_state = 95, .external_lex_state = 9},
  [4493] = {.lex_state = 95, .external_lex_state = 9},
  [4494] = {.lex_state = 86, .external_lex_state = 6},
  [4495] = {.lex_state = 95, .external_lex_state = 9},
  [4496] = {.lex_state = 95, .external_lex_state = 4},
  [4497] = {.lex_state = 95, .external_lex_state = 9},
  [4498] = {.lex_state = 95, .external_lex_state = 9},
  [4499] = {.lex_state = 95, .external_lex_state = 9},
  [4500] = {.lex_state = 95, .external_lex_state = 9},
  [4501] = {.lex_state = 95, .external_lex_state = 9},
  [4502] = {.lex_state = 95, .external_lex_state = 9},
  [4503] = {.lex_state = 95, .external_lex_state = 9},
  [4504] = {.lex_state = 95, .external_lex_state = 9},
  [4505] = {.lex_state = 95, .external_lex_state = 9},
  [4506] = {.lex_state = 95, .external_lex_state = 9},
  [4507] = {.lex_state = 86, .external_lex_state = 6},
  [4508] = {.lex_state = 90, .external_lex_state = 6},
  [4509] = {.lex_state = 95, .external_lex_state = 9},
  [4510] = {.lex_state = 95, .external_lex_state = 9},
  [4511] = {.lex_state = 95, .external_lex_state = 9},
  [4512] = {.lex_state = 95, .external_lex_state = 9},
  [4513] = {.lex_state = 95, .external_lex_state = 9},
  [4514] = {.lex_state = 95, .external_lex_state = 9},
  [4515] = {.lex_state = 95, .external_lex_state = 9},
  [4516] = {.lex_state = 95, .external_lex_state = 9},
  [4517] = {.lex_state = 95, .external_lex_state = 9},
  [4518] = {.lex_state = 86, .external_lex_state = 6},
  [4519] = {.lex_state = 95, .external_lex_state = 9},
  [4520] = {.lex_state = 95, .external_lex_state = 9},
  [4521] = {.lex_state = 95, .external_lex_state = 9},
  [4522] = {.lex_state = 86, .external_lex_state = 6},
  [4523] = {.lex_state = 95, .external_lex_state = 9},
  [4524] = {.lex_state = 90, .external_lex_state = 6},
  [4525] = {.lex_state = 90, .external_lex_state = 6},
  [4526] = {.lex_state = 90, .external_lex_state = 6},
  [4527] = {.lex_state = 95, .external_lex_state = 9},
  [4528] = {.lex_state = 95, .external_lex_state = 9},
  [4529] = {.lex_state = 95, .external_lex_state = 9},
  [4530] = {.lex_state = 95, .external_lex_state = 9},
  [4531] = {.lex_state = 95, .external_lex_state = 9},
  [4532] = {.lex_state = 95, .external_lex_state = 9},
  [4533] = {.lex_state = 90, .external_lex_state = 6},
  [4534] = {.lex_state = 90, .external_lex_state = 6},
  [4535] = {.lex_state = 95, .external_lex_state = 9},
  [4536] = {.lex_state = 90, .external_lex_state = 6},
  [4537] = {.lex_state = 95, .external_lex_state = 9},
  [4538] = {.lex_state = 95, .external_lex_state = 9},
  [4539] = {.lex_state = 95, .external_lex_state = 9},
  [4540] = {.lex_state = 95, .external_lex_state = 9},
  [4541] = {.lex_state = 95, .external_lex_state = 9},
  [4542] = {.lex_state = 95, .external_lex_state = 9},
  [4543] = {.lex_state = 95, .external_lex_state = 9},
  [4544] = {.lex_state = 95, .external_lex_state = 9},
  [4545] = {.lex_state = 95, .external_lex_state = 9},
  [4546] = {.lex_state = 95, .external_lex_state = 9},
  [4547] = {.lex_state = 95, .external_lex_state = 9},
  [4548] = {.lex_state = 95, .external_lex_state = 9},
  [4549] = {.lex_state = 95, .external_lex_state = 9},
  [4550] = {.lex_state = 95, .external_lex_state = 9},
  [4551] = {.lex_state = 95, .external_lex_state = 9},
  [4552] = {.lex_state = 95, .external_lex_state = 9},
  [4553] = {.lex_state = 95, .external_lex_state = 9},
  [4554] = {.lex_state = 95, .external_lex_state = 9},
  [4555] = {.lex_state = 95, .external_lex_state = 9},
  [4556] = {.lex_state = 95, .external_lex_state = 9},
  [4557] = {.lex_state = 90, .external_lex_state = 6},
  [4558] = {.lex_state = 95, .external_lex_state = 9},
  [4559] = {.lex_state = 90, .external_lex_state = 6},
  [4560] = {.lex_state = 95, .external_lex_state = 9},
  [4561] = {.lex_state = 95, .external_lex_state = 9},
  [4562] = {.lex_state = 90, .external_lex_state = 6},
  [4563] = {.lex_state = 90, .external_lex_state = 6},
  [4564] = {.lex_state = 90, .external_lex_state = 6},
  [4565] = {.lex_state = 90, .external_lex_state = 6},
  [4566] = {.lex_state = 95, .external_lex_state = 9},
  [4567] = {.lex_state = 90, .external_lex_state = 6},
  [4568] = {.lex_state = 90, .external_lex_state = 6},
  [4569] = {.lex_state = 90, .external_lex_state = 6},
  [4570] = {.lex_state = 95, .external_lex_state = 9},
  [4571] = {.lex_state = 90, .external_lex_state = 6},
  [4572] = {.lex_state = 95, .external_lex_state = 9},
  [4573] = {.lex_state = 95, .external_lex_state = 9},
  [4574] = {.lex_state = 90, .external_lex_state = 6},
  [4575] = {.lex_state = 90, .external_lex_state = 6},
  [4576] = {.lex_state = 90, .external_lex_state = 6},
  [4577] = {.lex_state = 95, .external_lex_state = 9},
  [4578] = {.lex_state = 95, .external_lex_state = 5},
  [4579] = {.lex_state = 95, .external_lex_state = 7},
  [4580] = {.lex_state = 95, .external_lex_state = 5},
  [4581] = {.lex_state = 95, .external_lex_state = 5},
  [4582] = {.lex_state = 95, .external_lex_state = 6},
  [4583] = {.lex_state = 95, .external_lex_state = 5},
  [4584] = {.lex_state = 86, .external_lex_state = 11},
  [4585] = {.lex_state = 86, .external_lex_state = 11},
  [4586] = {.lex_state = 95, .external_lex_state = 5},
  [4587] = {.lex_state = 95, .external_lex_state = 5},
  [4588] = {.lex_state = 95, .external_lex_state = 6},
  [4589] = {.lex_state = 95, .external_lex_state = 5},
  [4590] = {.lex_state = 95, .external_lex_state = 5},
  [4591] = {.lex_state = 95, .external_lex_state = 5},
  [4592] = {.lex_state = 95, .external_lex_state = 5},
  [4593] = {.lex_state = 95, .external_lex_state = 5},
  [4594] = {.lex_state = 86, .external_lex_state = 11},
  [4595] = {.lex_state = 95, .external_lex_state = 5},
  [4596] = {.lex_state = 95, .external_lex_state = 5},
  [4597] = {.lex_state = 86, .external_lex_state = 11},
  [4598] = {.lex_state = 95, .external_lex_state = 4},
  [4599] = {.lex_state = 95, .external_lex_state = 5},
  [4600] = {.lex_state = 95, .external_lex_state = 5},
  [4601] = {.lex_state = 95, .external_lex_state = 5},
  [4602] = {.lex_state = 95, .external_lex_state = 5},
  [4603] = {.lex_state = 95, .external_lex_state = 5},
  [4604] = {.lex_state = 95, .external_lex_state = 6},
  [4605] = {.lex_state = 95, .external_lex_state = 5},
  [4606] = {.lex_state = 95, .external_lex_state = 5},
  [4607] = {.lex_state = 95, .external_lex_state = 4},
  [4608] = {.lex_state = 86, .external_lex_state = 11},
  [4609] = {.lex_state = 95, .external_lex_state = 5},
  [4610] = {.lex_state = 90, .external_lex_state = 6},
  [4611] = {.lex_state = 95, .external_lex_state = 5},
  [4612] = {.lex_state = 95, .external_lex_state = 5},
  [4613] = {.lex_state = 95, .external_lex_state = 5},
  [4614] = {.lex_state = 86, .external_lex_state = 11},
  [4615] = {.lex_state = 86, .external_lex_state = 11},
  [4616] = {.lex_state = 95, .external_lex_state = 5},
  [4617] = {.lex_state = 95, .external_lex_state = 5},
  [4618] = {.lex_state = 90, .external_lex_state = 10},
  [4619] = {.lex_state = 95, .external_lex_state = 5},
  [4620] = {.lex_state = 95, .external_lex_state = 5},
  [4621] = {.lex_state = 95, .external_lex_state = 5},
  [4622] = {.lex_state = 95, .external_lex_state = 5},
  [4623] = {.lex_state = 95, .external_lex_state = 5},
  [4624] = {.lex_state = 95, .external_lex_state = 6},
  [4625] = {.lex_state = 95, .external_lex_state = 7},
  [4626] = {.lex_state = 95, .external_lex_state = 6},
  [4627] = {.lex_state = 95, .external_lex_state = 6},
  [4628] = {.lex_state = 95, .external_lex_state = 6},
  [4629] = {.lex_state = 95, .external_lex_state = 7},
  [4630] = {.lex_state = 95, .external_lex_state = 6},
  [4631] = {.lex_state = 86, .external_lex_state = 7},
  [4632] = {.lex_state = 95, .external_lex_state = 6},
  [4633] = {.lex_state = 95, .external_lex_state = 7},
  [4634] = {.lex_state = 95, .external_lex_state = 6},
  [4635] = {.lex_state = 95, .external_lex_state = 6},
  [4636] = {.lex_state = 95, .external_lex_state = 6},
  [4637] = {.lex_state = 95, .external_lex_state = 6},
  [4638] = {.lex_state = 95, .external_lex_state = 6},
  [4639] = {.lex_state = 95, .external_lex_state = 6},
  [4640] = {.lex_state = 95, .external_lex_state = 6},
  [4641] = {.lex_state = 95, .external_lex_state = 6},
  [4642] = {.lex_state = 95, .external_lex_state = 6},
  [4643] = {.lex_state = 95, .external_lex_state = 6},
  [4644] = {.lex_state = 95, .external_lex_state = 6},
  [4645] = {.lex_state = 95, .external_lex_state = 6},
  [4646] = {.lex_state = 95, .external_lex_state = 6},
  [4647] = {.lex_state = 95, .external_lex_state = 6},
  [4648] = {.lex_state = 95, .external_lex_state = 6},
  [4649] = {.lex_state = 95, .external_lex_state = 6},
  [4650] = {.lex_state = 95, .external_lex_state = 6},
  [4651] = {.lex_state = 95, .external_lex_state = 6},
  [4652] = {.lex_state = 86, .external_lex_state = 7},
  [4653] = {.lex_state = 95, .external_lex_state = 7},
  [4654] = {.lex_state = 95, .external_lex_state = 7},
  [4655] = {.lex_state = 95, .external_lex_state = 7},
  [4656] = {.lex_state = 95, .external_lex_state = 6},
  [4657] = {.lex_state = 95, .external_lex_state = 6},
  [4658] = {.lex_state = 95, .external_lex_state = 6},
  [4659] = {.lex_state = 95, .external_lex_state = 6},
  [4660] = {.lex_state = 95, .external_lex_state = 6},
  [4661] = {.lex_state = 95, .external_lex_state = 6},
  [4662] = {.lex_state = 95, .external_lex_state = 6},
  [4663] = {.lex_state = 95, .external_lex_state = 6},
  [4664] = {.lex_state = 95, .external_lex_state = 7},
  [4665] = {.lex_state = 86, .external_lex_state = 7},
  [4666] = {.lex_state = 95, .external_lex_state = 6},
  [4667] = {.lex_state = 95, .external_lex_state = 6},
  [4668] = {.lex_state = 86, .external_lex_state = 7},
  [4669] = {.lex_state = 90, .external_lex_state = 10},
  [4670] = {.lex_state = 95, .external_lex_state = 6},
  [4671] = {.lex_state = 86, .external_lex_state = 7},
  [4672] = {.lex_state = 95, .external_lex_state = 6},
  [4673] = {.lex_state = 86, .external_lex_state = 7},
  [4674] = {.lex_state = 95, .external_lex_state = 6},
  [4675] = {.lex_state = 86, .external_lex_state = 7},
  [4676] = {.lex_state = 95, .external_lex_state = 6},
  [4677] = {.lex_state = 95, .external_lex_state = 6},
  [4678] = {.lex_state = 95, .external_lex_state = 6},
  [4679] = {.lex_state = 95, .external_lex_state = 6},
  [4680] = {.lex_state = 86, .external_lex_state = 7},
  [4681] = {.lex_state = 95, .external_lex_state = 6},
  [4682] = {.lex_state = 95, .external_lex_state = 6},
  [4683] = {.lex_state = 95, .external_lex_state = 6},
  [4684] = {.lex_state = 95, .external_lex_state = 6},
  [4685] = {.lex_state = 95, .external_lex_state = 6},
  [4686] = {.lex_state = 95, .external_lex_state = 6},
  [4687] = {.lex_state = 95, .external_lex_state = 6},
  [4688] = {.lex_state = 95, .external_lex_state = 6},
  [4689] = {.lex_state = 95, .external_lex_state = 6},
  [4690] = {.lex_state = 95, .external_lex_state = 7},
  [4691] = {.lex_state = 95, .external_lex_state = 7},
  [4692] = {.lex_state = 95, .external_lex_state = 6},
  [4693] = {.lex_state = 95, .external_lex_state = 6},
  [4694] = {.lex_state = 95, .external_lex_state = 6},
  [4695] = {.lex_state = 86, .external_lex_state = 7},
  [4696] = {.lex_state = 95, .external_lex_state = 6},
  [4697] = {.lex_state = 95, .external_lex_state = 6},
  [4698] = {.lex_state = 95, .external_lex_state = 6},
  [4699] = {.lex_state = 95, .external_lex_state = 6},
  [4700] = {.lex_state = 95, .external_lex_state = 6},
  [4701] = {.lex_state = 95, .external_lex_state = 6},
  [4702] = {.lex_state = 95, .external_lex_state = 6},
  [4703] = {.lex_state = 95, .external_lex_state = 6},
  [4704] = {.lex_state = 95, .external_lex_state = 6},
  [4705] = {.lex_state = 95, .external_lex_state = 6},
  [4706] = {.lex_state = 95, .external_lex_state = 6},
  [4707] = {.lex_state = 95, .external_lex_state = 6},
  [4708] = {.lex_state = 95, .external_lex_state = 6},
  [4709] = {.lex_state = 95, .external_lex_state = 6},
  [4710] = {.lex_state = 90, .external_lex_state = 6},
  [4711] = {.lex_state = 95, .external_lex_state = 6},
  [4712] = {.lex_state = 95, .external_lex_state = 7},
  [4713] = {.lex_state = 95, .external_lex_state = 6},
  [4714] = {.lex_state = 95, .external_lex_state = 6},
  [4715] = {.lex_state = 95, .external_lex_state = 6},
  [4716] = {.lex_state = 95, .external_lex_state = 6},
  [4717] = {.lex_state = 95, .external_lex_state = 7},
  [4718] = {.lex_state = 86, .external_lex_state = 7},
  [4719] = {.lex_state = 95, .external_lex_state = 6},
  [4720] = {.lex_state = 95, .external_lex_state = 6},
  [4721] = {.lex_state = 95, .external_lex_state = 6},
  [4722] = {.lex_state = 95, .external_lex_state = 6},
  [4723] = {.lex_state = 95, .external_lex_state = 6},
  [4724] = {.lex_state = 90, .external_lex_state = 6},
  [4725] = {.lex_state = 95, .external_lex_state = 6},
  [4726] = {.lex_state = 95, .external_lex_state = 6},
  [4727] = {.lex_state = 95, .external_lex_state = 7},
  [4728] = {.lex_state = 95, .external_lex_state = 7},
  [4729] = {.lex_state = 95, .external_lex_state = 7},
  [4730] = {.lex_state = 95, .external_lex_state = 7},
  [4731] = {.lex_state = 95, .external_lex_state = 7},
  [4732] = {.lex_state = 95, .external_lex_state = 7},
  [4733] = {.lex_state = 95, .external_lex_state = 7},
  [4734] = {.lex_state = 95, .external_lex_state = 6},
  [4735] = {.lex_state = 95, .external_lex_state = 6},
  [4736] = {.lex_state = 95, .external_lex_state = 6},
  [4737] = {.lex_state = 95, .external_lex_state = 6},
  [4738] = {.lex_state = 95, .external_lex_state = 7},
  [4739] = {.lex_state = 95, .external_lex_state = 6},
  [4740] = {.lex_state = 95, .external_lex_state = 7},
  [4741] = {.lex_state = 95, .external_lex_state = 7},
  [4742] = {.lex_state = 95, .external_lex_state = 7},
  [4743] = {.lex_state = 95, .external_lex_state = 6},
  [4744] = {.lex_state = 95, .external_lex_state = 6},
  [4745] = {.lex_state = 95, .external_lex_state = 7},
  [4746] = {.lex_state = 95, .external_lex_state = 7},
  [4747] = {.lex_state = 95, .external_lex_state = 6},
  [4748] = {.lex_state = 95, .external_lex_state = 6},
  [4749] = {.lex_state = 95, .external_lex_state = 7},
  [4750] = {.lex_state = 95, .external_lex_state = 7},
  [4751] = {.lex_state = 95, .external_lex_state = 6},
  [4752] = {.lex_state = 95, .external_lex_state = 7},
  [4753] = {.lex_state = 95, .external_lex_state = 7},
  [4754] = {.lex_state = 86, .external_lex_state = 7},
  [4755] = {.lex_state = 95, .external_lex_state = 6},
  [4756] = {.lex_state = 86, .external_lex_state = 7},
  [4757] = {.lex_state = 86, .external_lex_state = 7},
  [4758] = {.lex_state = 86, .external_lex_state = 7},
  [4759] = {.lex_state = 95, .external_lex_state = 6},
  [4760] = {.lex_state = 86, .external_lex_state = 7},
  [4761] = {.lex_state = 86, .external_lex_state = 7},
  [4762] = {.lex_state = 95, .external_lex_state = 6},
  [4763] = {.lex_state = 86, .external_lex_state = 7},
  [4764] = {.lex_state = 95, .external_lex_state = 6},
  [4765] = {.lex_state = 95, .external_lex_state = 7},
  [4766] = {.lex_state = 95, .external_lex_state = 6},
  [4767] = {.lex_state = 86, .external_lex_state = 7},
  [4768] = {.lex_state = 86, .external_lex_state = 7},
  [4769] = {.lex_state = 95, .external_lex_state = 6},
  [4770] = {.lex_state = 95, .external_lex_state = 6},
  [4771] = {.lex_state = 95, .external_lex_state = 6},
  [4772] = {.lex_state = 86, .external_lex_state = 7},
  [4773] = {.lex_state = 86, .external_lex_state = 7},
  [4774] = {.lex_state = 86, .external_lex_state = 7},
  [4775] = {.lex_state = 86, .external_lex_state = 7},
  [4776] = {.lex_state = 86, .external_lex_state = 7},
  [4777] = {.lex_state = 86, .external_lex_state = 7},
  [4778] = {.lex_state = 86, .external_lex_state = 7},
  [4779] = {.lex_state = 86, .external_lex_state = 7},
  [4780] = {.lex_state = 86, .external_lex_state = 7},
  [4781] = {.lex_state = 86, .external_lex_state = 7},
  [4782] = {.lex_state = 86, .external_lex_state = 7},
  [4783] = {.lex_state = 86, .external_lex_state = 7},
  [4784] = {.lex_state = 86, .external_lex_state = 7},
  [4785] = {.lex_state = 86, .external_lex_state = 7},
  [4786] = {.lex_state = 86, .external_lex_state = 7},
  [4787] = {.lex_state = 86, .external_lex_state = 7},
  [4788] = {.lex_state = 86, .external_lex_state = 7},
  [4789] = {.lex_state = 86, .external_lex_state = 7},
  [4790] = {.lex_state = 86, .external_lex_state = 7},
  [4791] = {.lex_state = 86, .external_lex_state = 7},
  [4792] = {.lex_state = 86, .external_lex_state = 7},
  [4793] = {.lex_state = 86, .external_lex_state = 7},
  [4794] = {.lex_state = 86, .external_lex_state = 7},
  [4795] = {.lex_state = 86, .external_lex_state = 7},
  [4796] = {.lex_state = 86, .external_lex_state = 7},
  [4797] = {.lex_state = 95, .external_lex_state = 9},
  [4798] = {.lex_state = 90, .external_lex_state = 6},
  [4799] = {.lex_state = 86, .external_lex_state = 7},
  [4800] = {.lex_state = 86, .external_lex_state = 7},
  [4801] = {.lex_state = 86, .external_lex_state = 7},
  [4802] = {.lex_state = 86, .external_lex_state = 7},
  [4803] = {.lex_state = 86, .external_lex_state = 7},
  [4804] = {.lex_state = 86, .external_lex_state = 7},
  [4805] = {.lex_state = 86, .external_lex_state = 7},
  [4806] = {.lex_state = 86, .external_lex_state = 7},
  [4807] = {.lex_state = 86, .external_lex_state = 7},
  [4808] = {.lex_state = 86, .external_lex_state = 7},
  [4809] = {.lex_state = 86, .external_lex_state = 7},
  [4810] = {.lex_state = 86, .external_lex_state = 7},
  [4811] = {.lex_state = 86, .external_lex_state = 7},
  [4812] = {.lex_state = 86, .external_lex_state = 7},
  [4813] = {.lex_state = 86, .external_lex_state = 7},
  [4814] = {.lex_state = 86, .external_lex_state = 7},
  [4815] = {.lex_state = 86, .external_lex_state = 7},
  [4816] = {.lex_state = 86, .external_lex_state = 7},
  [4817] = {.lex_state = 86, .external_lex_state = 7},
  [4818] = {.lex_state = 86, .external_lex_state = 7},
  [4819] = {.lex_state = 86, .external_lex_state = 7},
  [4820] = {.lex_state = 86, .external_lex_state = 7},
  [4821] = {.lex_state = 95, .external_lex_state = 9},
  [4822] = {.lex_state = 86, .external_lex_state = 7},
  [4823] = {.lex_state = 86, .external_lex_state = 7},
  [4824] = {.lex_state = 86, .external_lex_state = 7},
  [4825] = {.lex_state = 86, .external_lex_state = 7},
  [4826] = {.lex_state = 86, .external_lex_state = 7},
  [4827] = {.lex_state = 86, .external_lex_state = 7},
  [4828] = {.lex_state = 95, .external_lex_state = 5},
  [4829] = {.lex_state = 86, .external_lex_state = 7},
  [4830] = {.lex_state = 86, .external_lex_state = 7},
  [4831] = {.lex_state = 86, .external_lex_state = 7},
  [4832] = {.lex_state = 86, .external_lex_state = 7},
  [4833] = {.lex_state = 95, .external_lex_state = 5},
  [4834] = {.lex_state = 95, .external_lex_state = 5},
  [4835] = {.lex_state = 95, .external_lex_state = 5},
  [4836] = {.lex_state = 95, .external_lex_state = 5},
  [4837] = {.lex_state = 95, .external_lex_state = 5},
  [4838] = {.lex_state = 95, .external_lex_state = 5},
  [4839] = {.lex_state = 95, .external_lex_state = 5},
  [4840] = {.lex_state = 95, .external_lex_state = 5},
  [4841] = {.lex_state = 95, .external_lex_state = 5},
  [4842] = {.lex_state = 95, .external_lex_state = 9},
  [4843] = {.lex_state = 95, .external_lex_state = 5},
  [4844] = {.lex_state = 95, .external_lex_state = 5},
  [4845] = {.lex_state = 95, .external_lex_state = 5},
  [4846] = {.lex_state = 95, .external_lex_state = 5},
  [4847] = {.lex_state = 95, .external_lex_state = 5},
  [4848] = {.lex_state = 95, .external_lex_state = 5},
  [4849] = {.lex_state = 86, .external_lex_state = 7},
  [4850] = {.lex_state = 86, .external_lex_state = 7},
  [4851] = {.lex_state = 86, .external_lex_state = 7},
  [4852] = {.lex_state = 86, .external_lex_state = 7},
  [4853] = {.lex_state = 86, .external_lex_state = 7},
  [4854] = {.lex_state = 86, .external_lex_state = 7},
  [4855] = {.lex_state = 86, .external_lex_state = 7},
  [4856] = {.lex_state = 86, .external_lex_state = 7},
  [4857] = {.lex_state = 86, .external_lex_state = 7},
  [4858] = {.lex_state = 86, .external_lex_state = 7},
  [4859] = {.lex_state = 95, .external_lex_state = 6},
  [4860] = {.lex_state = 86, .external_lex_state = 7},
  [4861] = {.lex_state = 86, .external_lex_state = 7},
  [4862] = {.lex_state = 86, .external_lex_state = 7},
  [4863] = {.lex_state = 86, .external_lex_state = 7},
  [4864] = {.lex_state = 86, .external_lex_state = 7},
  [4865] = {.lex_state = 86, .external_lex_state = 7},
  [4866] = {.lex_state = 86, .external_lex_state = 7},
  [4867] = {.lex_state = 86, .external_lex_state = 7},
  [4868] = {.lex_state = 86, .external_lex_state = 7},
  [4869] = {.lex_state = 86, .external_lex_state = 7},
  [4870] = {.lex_state = 86, .external_lex_state = 7},
  [4871] = {.lex_state = 86, .external_lex_state = 7},
  [4872] = {.lex_state = 86, .external_lex_state = 7},
  [4873] = {.lex_state = 86, .external_lex_state = 7},
  [4874] = {.lex_state = 86, .external_lex_state = 7},
  [4875] = {.lex_state = 86, .external_lex_state = 7},
  [4876] = {.lex_state = 86, .external_lex_state = 7},
  [4877] = {.lex_state = 86, .external_lex_state = 7},
  [4878] = {.lex_state = 86, .external_lex_state = 7},
  [4879] = {.lex_state = 86, .external_lex_state = 7},
  [4880] = {.lex_state = 86, .external_lex_state = 7},
  [4881] = {.lex_state = 86, .external_lex_state = 7},
  [4882] = {.lex_state = 86, .external_lex_state = 7},
  [4883] = {.lex_state = 86, .external_lex_state = 7},
  [4884] = {.lex_state = 86, .external_lex_state = 7},
  [4885] = {.lex_state = 86, .external_lex_state = 7},
  [4886] = {.lex_state = 95, .external_lex_state = 5},
  [4887] = {.lex_state = 86, .external_lex_state = 7},
  [4888] = {.lex_state = 86, .external_lex_state = 7},
  [4889] = {.lex_state = 86, .external_lex_state = 7},
  [4890] = {.lex_state = 86, .external_lex_state = 7},
  [4891] = {.lex_state = 86, .external_lex_state = 7},
  [4892] = {.lex_state = 86, .external_lex_state = 7},
  [4893] = {.lex_state = 86, .external_lex_state = 7},
  [4894] = {.lex_state = 86, .external_lex_state = 7},
  [4895] = {.lex_state = 86, .external_lex_state = 7},
  [4896] = {.lex_state = 86, .external_lex_state = 7},
  [4897] = {.lex_state = 86, .external_lex_state = 7},
  [4898] = {.lex_state = 86, .external_lex_state = 7},
  [4899] = {.lex_state = 86, .external_lex_state = 7},
  [4900] = {.lex_state = 86, .external_lex_state = 7},
  [4901] = {.lex_state = 86, .external_lex_state = 7},
  [4902] = {.lex_state = 86, .external_lex_state = 7},
  [4903] = {.lex_state = 86, .external_lex_state = 7},
  [4904] = {.lex_state = 86, .external_lex_state = 7},
  [4905] = {.lex_state = 86, .external_lex_state = 7},
  [4906] = {.lex_state = 86, .external_lex_state = 7},
  [4907] = {.lex_state = 86, .external_lex_state = 7},
  [4908] = {.lex_state = 86, .external_lex_state = 7},
  [4909] = {.lex_state = 95, .external_lex_state = 5},
  [4910] = {.lex_state = 86, .external_lex_state = 7},
  [4911] = {.lex_state = 86, .external_lex_state = 7},
  [4912] = {.lex_state = 86, .external_lex_state = 7},
  [4913] = {.lex_state = 86, .external_lex_state = 7},
  [4914] = {.lex_state = 86, .external_lex_state = 7},
  [4915] = {.lex_state = 86, .external_lex_state = 7},
  [4916] = {.lex_state = 86, .external_lex_state = 7},
  [4917] = {.lex_state = 86, .external_lex_state = 7},
  [4918] = {.lex_state = 86, .external_lex_state = 7},
  [4919] = {.lex_state = 86, .external_lex_state = 7},
  [4920] = {.lex_state = 86, .external_lex_state = 7},
  [4921] = {.lex_state = 86, .external_lex_state = 7},
  [4922] = {.lex_state = 86, .external_lex_state = 7},
  [4923] = {.lex_state = 86, .external_lex_state = 7},
  [4924] = {.lex_state = 86, .external_lex_state = 7},
  [4925] = {.lex_state = 86, .external_lex_state = 7},
  [4926] = {.lex_state = 86, .external_lex_state = 6},
  [4927] = {.lex_state = 86, .external_lex_state = 7},
  [4928] = {.lex_state = 86, .external_lex_state = 7},
  [4929] = {.lex_state = 86, .external_lex_state = 7},
  [4930] = {.lex_state = 86, .external_lex_state = 7},
  [4931] = {.lex_state = 86, .external_lex_state = 7},
  [4932] = {.lex_state = 95, .external_lex_state = 5},
  [4933] = {.lex_state = 95, .external_lex_state = 6},
  [4934] = {.lex_state = 86, .external_lex_state = 7},
  [4935] = {.lex_state = 86, .external_lex_state = 7},
  [4936] = {.lex_state = 86, .external_lex_state = 7},
  [4937] = {.lex_state = 86, .external_lex_state = 7},
  [4938] = {.lex_state = 86, .external_lex_state = 7},
  [4939] = {.lex_state = 86, .external_lex_state = 7},
  [4940] = {.lex_state = 86, .external_lex_state = 7},
  [4941] = {.lex_state = 86, .external_lex_state = 7},
  [4942] = {.lex_state = 86, .external_lex_state = 7},
  [4943] = {.lex_state = 86, .external_lex_state = 7},
  [4944] = {.lex_state = 86, .external_lex_state = 7},
  [4945] = {.lex_state = 86, .external_lex_state = 7},
  [4946] = {.lex_state = 86, .external_lex_state = 7},
  [4947] = {.lex_state = 86, .external_lex_state = 7},
  [4948] = {.lex_state = 86, .external_lex_state = 7},
  [4949] = {.lex_state = 86, .external_lex_state = 7},
  [4950] = {.lex_state = 86, .external_lex_state = 7},
  [4951] = {.lex_state = 86, .external_lex_state = 7},
  [4952] = {.lex_state = 86, .external_lex_state = 7},
  [4953] = {.lex_state = 86, .external_lex_state = 7},
  [4954] = {.lex_state = 95, .external_lex_state = 5},
  [4955] = {.lex_state = 86, .external_lex_state = 7},
  [4956] = {.lex_state = 86, .external_lex_state = 6},
  [4957] = {.lex_state = 86, .external_lex_state = 7},
  [4958] = {.lex_state = 86, .external_lex_state = 7},
  [4959] = {.lex_state = 86, .external_lex_state = 7},
  [4960] = {.lex_state = 86, .external_lex_state = 7},
  [4961] = {.lex_state = 86, .external_lex_state = 7},
  [4962] = {.lex_state = 86, .external_lex_state = 7},
  [4963] = {.lex_state = 86, .external_lex_state = 7},
  [4964] = {.lex_state = 86, .external_lex_state = 7},
  [4965] = {.lex_state = 86, .external_lex_state = 7},
  [4966] = {.lex_state = 86, .external_lex_state = 7},
  [4967] = {.lex_state = 86, .external_lex_state = 6},
  [4968] = {.lex_state = 86, .external_lex_state = 7},
  [4969] = {.lex_state = 86, .external_lex_state = 7},
  [4970] = {.lex_state = 86, .external_lex_state = 7},
  [4971] = {.lex_state = 86, .external_lex_state = 7},
  [4972] = {.lex_state = 86, .external_lex_state = 7},
  [4973] = {.lex_state = 86, .external_lex_state = 7},
  [4974] = {.lex_state = 86, .external_lex_state = 7},
  [4975] = {.lex_state = 86, .external_lex_state = 7},
  [4976] = {.lex_state = 86, .external_lex_state = 7},
  [4977] = {.lex_state = 86, .external_lex_state = 7},
  [4978] = {.lex_state = 86, .external_lex_state = 7},
  [4979] = {.lex_state = 86, .external_lex_state = 7},
  [4980] = {.lex_state = 86, .external_lex_state = 7},
  [4981] = {.lex_state = 86, .external_lex_state = 7},
  [4982] = {.lex_state = 86, .external_lex_state = 7},
  [4983] = {.lex_state = 86, .external_lex_state = 7},
  [4984] = {.lex_state = 86, .external_lex_state = 7},
  [4985] = {.lex_state = 86, .external_lex_state = 7},
  [4986] = {.lex_state = 86, .external_lex_state = 7},
  [4987] = {.lex_state = 86, .external_lex_state = 7},
  [4988] = {.lex_state = 86, .external_lex_state = 7},
  [4989] = {.lex_state = 86, .external_lex_state = 7},
  [4990] = {.lex_state = 95, .external_lex_state = 6},
  [4991] = {.lex_state = 86, .external_lex_state = 7},
  [4992] = {.lex_state = 86, .external_lex_state = 7},
  [4993] = {.lex_state = 86, .external_lex_state = 7},
  [4994] = {.lex_state = 95, .external_lex_state = 6},
  [4995] = {.lex_state = 86, .external_lex_state = 7},
  [4996] = {.lex_state = 86, .external_lex_state = 7},
  [4997] = {.lex_state = 86, .external_lex_state = 7},
  [4998] = {.lex_state = 86, .external_lex_state = 7},
  [4999] = {.lex_state = 86, .external_lex_state = 7},
  [5000] = {.lex_state = 86, .external_lex_state = 7},
  [5001] = {.lex_state = 86, .external_lex_state = 7},
  [5002] = {.lex_state = 86, .external_lex_state = 7},
  [5003] = {.lex_state = 86, .external_lex_state = 7},
  [5004] = {.lex_state = 86, .external_lex_state = 7},
  [5005] = {.lex_state = 86, .external_lex_state = 7},
  [5006] = {.lex_state = 86, .external_lex_state = 7},
  [5007] = {.lex_state = 86, .external_lex_state = 7},
  [5008] = {.lex_state = 86, .external_lex_state = 7},
  [5009] = {.lex_state = 86, .external_lex_state = 7},
  [5010] = {.lex_state = 86, .external_lex_state = 7},
  [5011] = {.lex_state = 86, .external_lex_state = 7},
  [5012] = {.lex_state = 86, .external_lex_state = 7},
  [5013] = {.lex_state = 86, .external_lex_state = 7},
  [5014] = {.lex_state = 86, .external_lex_state = 7},
  [5015] = {.lex_state = 86, .external_lex_state = 7},
  [5016] = {.lex_state = 86, .external_lex_state = 7},
  [5017] = {.lex_state = 86, .external_lex_state = 7},
  [5018] = {.lex_state = 86, .external_lex_state = 7},
  [5019] = {.lex_state = 86, .external_lex_state = 7},
  [5020] = {.lex_state = 86, .external_lex_state = 7},
  [5021] = {.lex_state = 86, .external_lex_state = 7},
  [5022] = {.lex_state = 86, .external_lex_state = 7},
  [5023] = {.lex_state = 86, .external_lex_state = 7},
  [5024] = {.lex_state = 86, .external_lex_state = 7},
  [5025] = {.lex_state = 86, .external_lex_state = 7},
  [5026] = {.lex_state = 86, .external_lex_state = 7},
  [5027] = {.lex_state = 86, .external_lex_state = 7},
  [5028] = {.lex_state = 86, .external_lex_state = 7},
  [5029] = {.lex_state = 86, .external_lex_state = 7},
  [5030] = {.lex_state = 86, .external_lex_state = 7},
  [5031] = {.lex_state = 86, .external_lex_state = 7},
  [5032] = {.lex_state = 86, .external_lex_state = 7},
  [5033] = {.lex_state = 86, .external_lex_state = 7},
  [5034] = {.lex_state = 86, .external_lex_state = 7},
  [5035] = {.lex_state = 86, .external_lex_state = 7},
  [5036] = {.lex_state = 86, .external_lex_state = 7},
  [5037] = {.lex_state = 86, .external_lex_state = 7},
  [5038] = {.lex_state = 86, .external_lex_state = 7},
  [5039] = {.lex_state = 86, .external_lex_state = 7},
  [5040] = {.lex_state = 86, .external_lex_state = 7},
  [5041] = {.lex_state = 86, .external_lex_state = 7},
  [5042] = {.lex_state = 86, .external_lex_state = 7},
  [5043] = {.lex_state = 86, .external_lex_state = 7},
  [5044] = {.lex_state = 86, .external_lex_state = 7},
  [5045] = {.lex_state = 86, .external_lex_state = 7},
  [5046] = {.lex_state = 86, .external_lex_state = 7},
  [5047] = {.lex_state = 86, .external_lex_state = 7},
  [5048] = {.lex_state = 86, .external_lex_state = 7},
  [5049] = {.lex_state = 86, .external_lex_state = 7},
  [5050] = {.lex_state = 86, .external_lex_state = 7},
  [5051] = {.lex_state = 86, .external_lex_state = 7},
  [5052] = {.lex_state = 86, .external_lex_state = 7},
  [5053] = {.lex_state = 86, .external_lex_state = 7},
  [5054] = {.lex_state = 86, .external_lex_state = 7},
  [5055] = {.lex_state = 86, .external_lex_state = 7},
  [5056] = {.lex_state = 86, .external_lex_state = 7},
  [5057] = {.lex_state = 86, .external_lex_state = 7},
  [5058] = {.lex_state = 86, .external_lex_state = 7},
  [5059] = {.lex_state = 86, .external_lex_state = 7},
  [5060] = {.lex_state = 86, .external_lex_state = 7},
  [5061] = {.lex_state = 86, .external_lex_state = 7},
  [5062] = {.lex_state = 86, .external_lex_state = 7},
  [5063] = {.lex_state = 86, .external_lex_state = 7},
  [5064] = {.lex_state = 86, .external_lex_state = 7},
  [5065] = {.lex_state = 86, .external_lex_state = 7},
  [5066] = {.lex_state = 86, .external_lex_state = 7},
  [5067] = {.lex_state = 86, .external_lex_state = 7},
  [5068] = {.lex_state = 86, .external_lex_state = 7},
  [5069] = {.lex_state = 86, .external_lex_state = 7},
  [5070] = {.lex_state = 86, .external_lex_state = 7},
  [5071] = {.lex_state = 86, .external_lex_state = 7},
  [5072] = {.lex_state = 86, .external_lex_state = 7},
  [5073] = {.lex_state = 86, .external_lex_state = 7},
  [5074] = {.lex_state = 86, .external_lex_state = 7},
  [5075] = {.lex_state = 86, .external_lex_state = 7},
  [5076] = {.lex_state = 86, .external_lex_state = 7},
  [5077] = {.lex_state = 86, .external_lex_state = 7},
  [5078] = {.lex_state = 86, .external_lex_state = 7},
  [5079] = {.lex_state = 86, .external_lex_state = 7},
  [5080] = {.lex_state = 86, .external_lex_state = 7},
  [5081] = {.lex_state = 86, .external_lex_state = 7},
  [5082] = {.lex_state = 86, .external_lex_state = 7},
  [5083] = {.lex_state = 86, .external_lex_state = 7},
  [5084] = {.lex_state = 86, .external_lex_state = 7},
  [5085] = {.lex_state = 86, .external_lex_state = 7},
  [5086] = {.lex_state = 86, .external_lex_state = 7},
  [5087] = {.lex_state = 86, .external_lex_state = 7},
  [5088] = {.lex_state = 86, .external_lex_state = 7},
  [5089] = {.lex_state = 86, .external_lex_state = 7},
  [5090] = {.lex_state = 86, .external_lex_state = 7},
  [5091] = {.lex_state = 86, .external_lex_state = 7},
  [5092] = {.lex_state = 86, .external_lex_state = 7},
  [5093] = {.lex_state = 86, .external_lex_state = 7},
  [5094] = {.lex_state = 86, .external_lex_state = 7},
  [5095] = {.lex_state = 86, .external_lex_state = 7},
  [5096] = {.lex_state = 86, .external_lex_state = 7},
  [5097] = {.lex_state = 86, .external_lex_state = 7},
  [5098] = {.lex_state = 86, .external_lex_state = 7},
  [5099] = {.lex_state = 86, .external_lex_state = 7},
  [5100] = {.lex_state = 95, .external_lex_state = 6},
  [5101] = {.lex_state = 86, .external_lex_state = 7},
  [5102] = {.lex_state = 86, .external_lex_state = 7},
  [5103] = {.lex_state = 95, .external_lex_state = 6},
  [5104] = {.lex_state = 95, .external_lex_state = 6},
  [5105] = {.lex_state = 86, .external_lex_state = 7},
  [5106] = {.lex_state = 86, .external_lex_state = 7},
  [5107] = {.lex_state = 86, .external_lex_state = 7},
  [5108] = {.lex_state = 86, .external_lex_state = 7},
  [5109] = {.lex_state = 86, .external_lex_state = 7},
  [5110] = {.lex_state = 86, .external_lex_state = 7},
  [5111] = {.lex_state = 86, .external_lex_state = 7},
  [5112] = {.lex_state = 86, .external_lex_state = 7},
  [5113] = {.lex_state = 86, .external_lex_state = 7},
  [5114] = {.lex_state = 86, .external_lex_state = 7},
  [5115] = {.lex_state = 86, .external_lex_state = 7},
  [5116] = {.lex_state = 86, .external_lex_state = 7},
  [5117] = {.lex_state = 86, .external_lex_state = 7},
  [5118] = {.lex_state = 86, .external_lex_state = 7},
  [5119] = {.lex_state = 86, .external_lex_state = 7},
  [5120] = {.lex_state = 86, .external_lex_state = 7},
  [5121] = {.lex_state = 86, .external_lex_state = 7},
  [5122] = {.lex_state = 86, .external_lex_state = 7},
  [5123] = {.lex_state = 86, .external_lex_state = 7},
  [5124] = {.lex_state = 86, .external_lex_state = 7},
  [5125] = {.lex_state = 86, .external_lex_state = 7},
  [5126] = {.lex_state = 86, .external_lex_state = 7},
  [5127] = {.lex_state = 86, .external_lex_state = 7},
  [5128] = {.lex_state = 86, .external_lex_state = 7},
  [5129] = {.lex_state = 86, .external_lex_state = 7},
  [5130] = {.lex_state = 86, .external_lex_state = 7},
  [5131] = {.lex_state = 86, .external_lex_state = 7},
  [5132] = {.lex_state = 86, .external_lex_state = 7},
  [5133] = {.lex_state = 86, .external_lex_state = 7},
  [5134] = {.lex_state = 86, .external_lex_state = 7},
  [5135] = {.lex_state = 86, .external_lex_state = 7},
  [5136] = {.lex_state = 86, .external_lex_state = 7},
  [5137] = {.lex_state = 86, .external_lex_state = 7},
  [5138] = {.lex_state = 86, .external_lex_state = 7},
  [5139] = {.lex_state = 86, .external_lex_state = 7},
  [5140] = {.lex_state = 86, .external_lex_state = 7},
  [5141] = {.lex_state = 86, .external_lex_state = 7},
  [5142] = {.lex_state = 86, .external_lex_state = 7},
  [5143] = {.lex_state = 86, .external_lex_state = 7},
  [5144] = {.lex_state = 86, .external_lex_state = 7},
  [5145] = {.lex_state = 86, .external_lex_state = 7},
  [5146] = {.lex_state = 86, .external_lex_state = 7},
  [5147] = {.lex_state = 86, .external_lex_state = 7},
  [5148] = {.lex_state = 86, .external_lex_state = 7},
  [5149] = {.lex_state = 86, .external_lex_state = 7},
  [5150] = {.lex_state = 86, .external_lex_state = 7},
  [5151] = {.lex_state = 86, .external_lex_state = 7},
  [5152] = {.lex_state = 86, .external_lex_state = 7},
  [5153] = {.lex_state = 86, .external_lex_state = 7},
  [5154] = {.lex_state = 86, .external_lex_state = 7},
  [5155] = {.lex_state = 86, .external_lex_state = 7},
  [5156] = {.lex_state = 86, .external_lex_state = 7},
  [5157] = {.lex_state = 86, .external_lex_state = 7},
  [5158] = {.lex_state = 86, .external_lex_state = 7},
  [5159] = {.lex_state = 86, .external_lex_state = 7},
  [5160] = {.lex_state = 86, .external_lex_state = 7},
  [5161] = {.lex_state = 86, .external_lex_state = 7},
  [5162] = {.lex_state = 86, .external_lex_state = 7},
  [5163] = {.lex_state = 86, .external_lex_state = 7},
  [5164] = {.lex_state = 86, .external_lex_state = 7},
  [5165] = {.lex_state = 86, .external_lex_state = 7},
  [5166] = {.lex_state = 86, .external_lex_state = 7},
  [5167] = {.lex_state = 86, .external_lex_state = 7},
  [5168] = {.lex_state = 86, .external_lex_state = 7},
  [5169] = {.lex_state = 86, .external_lex_state = 7},
  [5170] = {.lex_state = 95, .external_lex_state = 6},
  [5171] = {.lex_state = 86, .external_lex_state = 7},
  [5172] = {.lex_state = 86, .external_lex_state = 7},
  [5173] = {.lex_state = 86, .external_lex_state = 7},
  [5174] = {.lex_state = 86, .external_lex_state = 7},
  [5175] = {.lex_state = 86, .external_lex_state = 7},
  [5176] = {.lex_state = 86, .external_lex_state = 7},
  [5177] = {.lex_state = 86, .external_lex_state = 7},
  [5178] = {.lex_state = 86, .external_lex_state = 7},
  [5179] = {.lex_state = 86, .external_lex_state = 7},
  [5180] = {.lex_state = 86, .external_lex_state = 7},
  [5181] = {.lex_state = 86, .external_lex_state = 7},
  [5182] = {.lex_state = 86, .external_lex_state = 7},
  [5183] = {.lex_state = 86, .external_lex_state = 7},
  [5184] = {.lex_state = 86, .external_lex_state = 7},
  [5185] = {.lex_state = 95, .external_lex_state = 7},
  [5186] = {.lex_state = 86, .external_lex_state = 7},
  [5187] = {.lex_state = 86, .external_lex_state = 7},
  [5188] = {.lex_state = 86, .external_lex_state = 7},
  [5189] = {.lex_state = 86, .external_lex_state = 7},
  [5190] = {.lex_state = 86, .external_lex_state = 7},
  [5191] = {.lex_state = 86, .external_lex_state = 7},
  [5192] = {.lex_state = 86, .external_lex_state = 7},
  [5193] = {.lex_state = 86, .external_lex_state = 7},
  [5194] = {.lex_state = 86, .external_lex_state = 7},
  [5195] = {.lex_state = 95, .external_lex_state = 6},
  [5196] = {.lex_state = 86, .external_lex_state = 7},
  [5197] = {.lex_state = 86, .external_lex_state = 7},
  [5198] = {.lex_state = 86, .external_lex_state = 7},
  [5199] = {.lex_state = 86, .external_lex_state = 7},
  [5200] = {.lex_state = 86, .external_lex_state = 7},
  [5201] = {.lex_state = 86, .external_lex_state = 7},
  [5202] = {.lex_state = 86, .external_lex_state = 7},
  [5203] = {.lex_state = 86, .external_lex_state = 7},
  [5204] = {.lex_state = 86, .external_lex_state = 7},
  [5205] = {.lex_state = 86, .external_lex_state = 7},
  [5206] = {.lex_state = 86, .external_lex_state = 7},
  [5207] = {.lex_state = 86, .external_lex_state = 7},
  [5208] = {.lex_state = 86, .external_lex_state = 7},
  [5209] = {.lex_state = 95, .external_lex_state = 6},
  [5210] = {.lex_state = 86, .external_lex_state = 7},
  [5211] = {.lex_state = 95, .external_lex_state = 6},
  [5212] = {.lex_state = 95, .external_lex_state = 6},
  [5213] = {.lex_state = 86, .external_lex_state = 7},
  [5214] = {.lex_state = 86, .external_lex_state = 7},
  [5215] = {.lex_state = 86, .external_lex_state = 7},
  [5216] = {.lex_state = 86, .external_lex_state = 7},
  [5217] = {.lex_state = 95, .external_lex_state = 6},
  [5218] = {.lex_state = 86, .external_lex_state = 7},
  [5219] = {.lex_state = 86, .external_lex_state = 7},
  [5220] = {.lex_state = 95, .external_lex_state = 6},
  [5221] = {.lex_state = 95, .external_lex_state = 6},
  [5222] = {.lex_state = 95, .external_lex_state = 6},
  [5223] = {.lex_state = 86, .external_lex_state = 7},
  [5224] = {.lex_state = 86, .external_lex_state = 7},
  [5225] = {.lex_state = 86, .external_lex_state = 7},
  [5226] = {.lex_state = 86, .external_lex_state = 7},
  [5227] = {.lex_state = 86, .external_lex_state = 7},
  [5228] = {.lex_state = 95, .external_lex_state = 6},
  [5229] = {.lex_state = 86, .external_lex_state = 7},
  [5230] = {.lex_state = 86, .external_lex_state = 7},
  [5231] = {.lex_state = 86, .external_lex_state = 7},
  [5232] = {.lex_state = 86, .external_lex_state = 7},
  [5233] = {.lex_state = 86, .external_lex_state = 7},
  [5234] = {.lex_state = 86, .external_lex_state = 7},
  [5235] = {.lex_state = 86, .external_lex_state = 7},
  [5236] = {.lex_state = 86, .external_lex_state = 7},
  [5237] = {.lex_state = 86, .external_lex_state = 7},
  [5238] = {.lex_state = 95, .external_lex_state = 6},
  [5239] = {.lex_state = 95, .external_lex_state = 6},
  [5240] = {.lex_state = 95, .external_lex_state = 6},
  [5241] = {.lex_state = 86, .external_lex_state = 7},
  [5242] = {.lex_state = 86, .external_lex_state = 7},
  [5243] = {.lex_state = 86, .external_lex_state = 7},
  [5244] = {.lex_state = 86, .external_lex_state = 7},
  [5245] = {.lex_state = 86, .external_lex_state = 7},
  [5246] = {.lex_state = 86, .external_lex_state = 7},
  [5247] = {.lex_state = 86, .external_lex_state = 7},
  [5248] = {.lex_state = 95, .external_lex_state = 6},
  [5249] = {.lex_state = 86, .external_lex_state = 7},
  [5250] = {.lex_state = 95, .external_lex_state = 6},
  [5251] = {.lex_state = 86, .external_lex_state = 7},
  [5252] = {.lex_state = 86, .external_lex_state = 7},
  [5253] = {.lex_state = 95, .external_lex_state = 6},
  [5254] = {.lex_state = 95, .external_lex_state = 6},
  [5255] = {.lex_state = 95, .external_lex_state = 6},
  [5256] = {.lex_state = 86, .external_lex_state = 7},
  [5257] = {.lex_state = 86, .external_lex_state = 7},
  [5258] = {.lex_state = 86, .external_lex_state = 7},
  [5259] = {.lex_state = 86, .external_lex_state = 7},
  [5260] = {.lex_state = 86, .external_lex_state = 7},
  [5261] = {.lex_state = 86, .external_lex_state = 7},
  [5262] = {.lex_state = 86, .external_lex_state = 7},
  [5263] = {.lex_state = 86, .external_lex_state = 7},
  [5264] = {.lex_state = 86, .external_lex_state = 7},
  [5265] = {.lex_state = 86, .external_lex_state = 7},
  [5266] = {.lex_state = 86, .external_lex_state = 7},
  [5267] = {.lex_state = 95, .external_lex_state = 6},
  [5268] = {.lex_state = 86, .external_lex_state = 7},
  [5269] = {.lex_state = 86, .external_lex_state = 7},
  [5270] = {.lex_state = 95, .external_lex_state = 7},
  [5271] = {.lex_state = 86, .external_lex_state = 7},
  [5272] = {.lex_state = 86, .external_lex_state = 7},
  [5273] = {.lex_state = 86, .external_lex_state = 7},
  [5274] = {.lex_state = 86, .external_lex_state = 7},
  [5275] = {.lex_state = 86, .external_lex_state = 7},
  [5276] = {.lex_state = 86, .external_lex_state = 7},
  [5277] = {.lex_state = 86, .external_lex_state = 7},
  [5278] = {.lex_state = 86, .external_lex_state = 7},
  [5279] = {.lex_state = 86, .external_lex_state = 7},
  [5280] = {.lex_state = 86, .external_lex_state = 7},
  [5281] = {.lex_state = 86, .external_lex_state = 7},
  [5282] = {.lex_state = 86, .external_lex_state = 7},
  [5283] = {.lex_state = 86, .external_lex_state = 7},
  [5284] = {.lex_state = 86, .external_lex_state = 7},
  [5285] = {.lex_state = 86, .external_lex_state = 7},
  [5286] = {.lex_state = 86, .external_lex_state = 7},
  [5287] = {.lex_state = 86, .external_lex_state = 7},
  [5288] = {.lex_state = 86, .external_lex_state = 7},
  [5289] = {.lex_state = 86, .external_lex_state = 7},
  [5290] = {.lex_state = 86, .external_lex_state = 7},
  [5291] = {.lex_state = 86, .external_lex_state = 7},
  [5292] = {.lex_state = 86, .external_lex_state = 7},
  [5293] = {.lex_state = 86, .external_lex_state = 7},
  [5294] = {.lex_state = 86, .external_lex_state = 7},
  [5295] = {.lex_state = 86, .external_lex_state = 7},
  [5296] = {.lex_state = 86, .external_lex_state = 7},
  [5297] = {.lex_state = 86, .external_lex_state = 7},
  [5298] = {.lex_state = 86, .external_lex_state = 7},
  [5299] = {.lex_state = 86, .external_lex_state = 7},
  [5300] = {.lex_state = 86, .external_lex_state = 7},
  [5301] = {.lex_state = 86, .external_lex_state = 7},
  [5302] = {.lex_state = 86, .external_lex_state = 7},
  [5303] = {.lex_state = 86, .external_lex_state = 7},
  [5304] = {.lex_state = 86, .external_lex_state = 7},
  [5305] = {.lex_state = 86, .external_lex_state = 7},
  [5306] = {.lex_state = 86, .external_lex_state = 7},
  [5307] = {.lex_state = 86, .external_lex_state = 7},
  [5308] = {.lex_state = 86, .external_lex_state = 7},
  [5309] = {.lex_state = 86, .external_lex_state = 7},
  [5310] = {.lex_state = 86, .external_lex_state = 7},
  [5311] = {.lex_state = 86, .external_lex_state = 7},
  [5312] = {.lex_state = 86, .external_lex_state = 7},
  [5313] = {.lex_state = 86, .external_lex_state = 7},
  [5314] = {.lex_state = 86, .external_lex_state = 7},
  [5315] = {.lex_state = 86, .external_lex_state = 7},
  [5316] = {.lex_state = 86, .external_lex_state = 7},
  [5317] = {.lex_state = 86, .external_lex_state = 7},
  [5318] = {.lex_state = 86, .external_lex_state = 7},
  [5319] = {.lex_state = 86, .external_lex_state = 7},
  [5320] = {.lex_state = 86, .external_lex_state = 7},
  [5321] = {.lex_state = 86, .external_lex_state = 7},
  [5322] = {.lex_state = 86, .external_lex_state = 7},
  [5323] = {.lex_state = 86, .external_lex_state = 7},
  [5324] = {.lex_state = 86, .external_lex_state = 7},
  [5325] = {.lex_state = 86, .external_lex_state = 7},
  [5326] = {.lex_state = 86, .external_lex_state = 7},
  [5327] = {.lex_state = 86, .external_lex_state = 7},
  [5328] = {.lex_state = 86, .external_lex_state = 7},
  [5329] = {.lex_state = 86, .external_lex_state = 7},
  [5330] = {.lex_state = 86, .external_lex_state = 7},
  [5331] = {.lex_state = 86, .external_lex_state = 7},
  [5332] = {.lex_state = 95, .external_lex_state = 6},
  [5333] = {.lex_state = 95, .external_lex_state = 6},
  [5334] = {.lex_state = 86, .external_lex_state = 7},
  [5335] = {.lex_state = 86, .external_lex_state = 7},
  [5336] = {.lex_state = 86, .external_lex_state = 7},
  [5337] = {.lex_state = 86, .external_lex_state = 7},
  [5338] = {.lex_state = 86, .external_lex_state = 7},
  [5339] = {.lex_state = 86, .external_lex_state = 7},
  [5340] = {.lex_state = 86, .external_lex_state = 7},
  [5341] = {.lex_state = 86, .external_lex_state = 7},
  [5342] = {.lex_state = 86, .external_lex_state = 7},
  [5343] = {.lex_state = 86, .external_lex_state = 7},
  [5344] = {.lex_state = 86, .external_lex_state = 7},
  [5345] = {.lex_state = 86, .external_lex_state = 7},
  [5346] = {.lex_state = 86, .external_lex_state = 7},
  [5347] = {.lex_state = 86, .external_lex_state = 7},
  [5348] = {.lex_state = 86, .external_lex_state = 7},
  [5349] = {.lex_state = 86, .external_lex_state = 7},
  [5350] = {.lex_state = 86, .external_lex_state = 7},
  [5351] = {.lex_state = 86, .external_lex_state = 7},
  [5352] = {.lex_state = 86, .external_lex_state = 7},
  [5353] = {.lex_state = 86, .external_lex_state = 7},
  [5354] = {.lex_state = 86, .external_lex_state = 7},
  [5355] = {.lex_state = 86, .external_lex_state = 7},
  [5356] = {.lex_state = 86, .external_lex_state = 7},
  [5357] = {.lex_state = 86, .external_lex_state = 7},
  [5358] = {.lex_state = 86, .external_lex_state = 7},
  [5359] = {.lex_state = 86, .external_lex_state = 7},
  [5360] = {.lex_state = 86, .external_lex_state = 7},
  [5361] = {.lex_state = 86, .external_lex_state = 7},
  [5362] = {.lex_state = 86, .external_lex_state = 7},
  [5363] = {.lex_state = 86, .external_lex_state = 7},
  [5364] = {.lex_state = 86, .external_lex_state = 7},
  [5365] = {.lex_state = 86, .external_lex_state = 7},
  [5366] = {.lex_state = 86, .external_lex_state = 7},
  [5367] = {.lex_state = 86, .external_lex_state = 7},
  [5368] = {.lex_state = 95, .external_lex_state = 6},
  [5369] = {.lex_state = 86, .external_lex_state = 7},
  [5370] = {.lex_state = 95, .external_lex_state = 6},
  [5371] = {.lex_state = 86, .external_lex_state = 7},
  [5372] = {.lex_state = 86, .external_lex_state = 7},
  [5373] = {.lex_state = 86, .external_lex_state = 7},
  [5374] = {.lex_state = 86, .external_lex_state = 7},
  [5375] = {.lex_state = 86, .external_lex_state = 7},
  [5376] = {.lex_state = 86, .external_lex_state = 7},
  [5377] = {.lex_state = 86, .external_lex_state = 7},
  [5378] = {.lex_state = 95, .external_lex_state = 6},
  [5379] = {.lex_state = 86, .external_lex_state = 7},
  [5380] = {.lex_state = 86, .external_lex_state = 7},
  [5381] = {.lex_state = 86, .external_lex_state = 7},
  [5382] = {.lex_state = 86, .external_lex_state = 7},
  [5383] = {.lex_state = 86, .external_lex_state = 7},
  [5384] = {.lex_state = 86, .external_lex_state = 7},
  [5385] = {.lex_state = 86, .external_lex_state = 7},
  [5386] = {.lex_state = 86, .external_lex_state = 7},
  [5387] = {.lex_state = 86, .external_lex_state = 7},
  [5388] = {.lex_state = 86, .external_lex_state = 7},
  [5389] = {.lex_state = 86, .external_lex_state = 7},
  [5390] = {.lex_state = 86, .external_lex_state = 7},
  [5391] = {.lex_state = 86, .external_lex_state = 7},
  [5392] = {.lex_state = 86, .external_lex_state = 7},
  [5393] = {.lex_state = 86, .external_lex_state = 7},
  [5394] = {.lex_state = 86, .external_lex_state = 7},
  [5395] = {.lex_state = 86, .external_lex_state = 7},
  [5396] = {.lex_state = 86, .external_lex_state = 7},
  [5397] = {.lex_state = 86, .external_lex_state = 7},
  [5398] = {.lex_state = 86, .external_lex_state = 7},
  [5399] = {.lex_state = 86, .external_lex_state = 7},
  [5400] = {.lex_state = 86, .external_lex_state = 7},
  [5401] = {.lex_state = 86, .external_lex_state = 7},
  [5402] = {.lex_state = 86, .external_lex_state = 7},
  [5403] = {.lex_state = 86, .external_lex_state = 7},
  [5404] = {.lex_state = 86, .external_lex_state = 7},
  [5405] = {.lex_state = 86, .external_lex_state = 7},
  [5406] = {.lex_state = 86, .external_lex_state = 7},
  [5407] = {.lex_state = 86, .external_lex_state = 7},
  [5408] = {.lex_state = 86, .external_lex_state = 7},
  [5409] = {.lex_state = 86, .external_lex_state = 7},
  [5410] = {.lex_state = 86, .external_lex_state = 7},
  [5411] = {.lex_state = 86, .external_lex_state = 7},
  [5412] = {.lex_state = 86, .external_lex_state = 7},
  [5413] = {.lex_state = 86, .external_lex_state = 7},
  [5414] = {.lex_state = 86, .external_lex_state = 7},
  [5415] = {.lex_state = 86, .external_lex_state = 7},
  [5416] = {.lex_state = 86, .external_lex_state = 7},
  [5417] = {.lex_state = 86, .external_lex_state = 7},
  [5418] = {.lex_state = 86, .external_lex_state = 7},
  [5419] = {.lex_state = 86, .external_lex_state = 7},
  [5420] = {.lex_state = 86, .external_lex_state = 7},
  [5421] = {.lex_state = 86, .external_lex_state = 7},
  [5422] = {.lex_state = 86, .external_lex_state = 7},
  [5423] = {.lex_state = 86, .external_lex_state = 7},
  [5424] = {.lex_state = 86, .external_lex_state = 7},
  [5425] = {.lex_state = 86, .external_lex_state = 7},
  [5426] = {.lex_state = 86, .external_lex_state = 7},
  [5427] = {.lex_state = 86, .external_lex_state = 7},
  [5428] = {.lex_state = 86, .external_lex_state = 7},
  [5429] = {.lex_state = 86, .external_lex_state = 7},
  [5430] = {.lex_state = 86, .external_lex_state = 7},
  [5431] = {.lex_state = 86, .external_lex_state = 7},
  [5432] = {.lex_state = 86, .external_lex_state = 7},
  [5433] = {.lex_state = 86, .external_lex_state = 7},
  [5434] = {.lex_state = 86, .external_lex_state = 7},
  [5435] = {.lex_state = 86, .external_lex_state = 7},
  [5436] = {.lex_state = 86, .external_lex_state = 7},
  [5437] = {.lex_state = 86, .external_lex_state = 7},
  [5438] = {.lex_state = 86, .external_lex_state = 7},
  [5439] = {.lex_state = 86, .external_lex_state = 7},
  [5440] = {.lex_state = 86, .external_lex_state = 7},
  [5441] = {.lex_state = 86, .external_lex_state = 7},
  [5442] = {.lex_state = 86, .external_lex_state = 7},
  [5443] = {.lex_state = 86, .external_lex_state = 7},
  [5444] = {.lex_state = 86, .external_lex_state = 7},
  [5445] = {.lex_state = 86, .external_lex_state = 7},
  [5446] = {.lex_state = 86, .external_lex_state = 7},
  [5447] = {.lex_state = 86, .external_lex_state = 7},
  [5448] = {.lex_state = 86, .external_lex_state = 7},
  [5449] = {.lex_state = 86, .external_lex_state = 7},
  [5450] = {.lex_state = 86, .external_lex_state = 7},
  [5451] = {.lex_state = 86, .external_lex_state = 7},
  [5452] = {.lex_state = 86, .external_lex_state = 7},
  [5453] = {.lex_state = 86, .external_lex_state = 7},
  [5454] = {.lex_state = 86, .external_lex_state = 7},
  [5455] = {.lex_state = 86, .external_lex_state = 7},
  [5456] = {.lex_state = 86, .external_lex_state = 7},
  [5457] = {.lex_state = 86, .external_lex_state = 7},
  [5458] = {.lex_state = 86, .external_lex_state = 7},
  [5459] = {.lex_state = 86, .external_lex_state = 7},
  [5460] = {.lex_state = 86, .external_lex_state = 7},
  [5461] = {.lex_state = 86, .external_lex_state = 7},
  [5462] = {.lex_state = 86, .external_lex_state = 7},
  [5463] = {.lex_state = 86, .external_lex_state = 7},
  [5464] = {.lex_state = 86, .external_lex_state = 7},
  [5465] = {.lex_state = 86, .external_lex_state = 7},
  [5466] = {.lex_state = 86, .external_lex_state = 7},
  [5467] = {.lex_state = 86, .external_lex_state = 7},
  [5468] = {.lex_state = 86, .external_lex_state = 7},
  [5469] = {.lex_state = 86, .external_lex_state = 7},
  [5470] = {.lex_state = 86, .external_lex_state = 7},
  [5471] = {.lex_state = 86, .external_lex_state = 7},
  [5472] = {.lex_state = 86, .external_lex_state = 7},
  [5473] = {.lex_state = 86, .external_lex_state = 7},
  [5474] = {.lex_state = 86, .external_lex_state = 7},
  [5475] = {.lex_state = 86, .external_lex_state = 7},
  [5476] = {.lex_state = 86, .external_lex_state = 7},
  [5477] = {.lex_state = 95, .external_lex_state = 7},
  [5478] = {.lex_state = 86, .external_lex_state = 7},
  [5479] = {.lex_state = 86, .external_lex_state = 7},
  [5480] = {.lex_state = 86, .external_lex_state = 7},
  [5481] = {.lex_state = 86, .external_lex_state = 7},
  [5482] = {.lex_state = 86, .external_lex_state = 7},
  [5483] = {.lex_state = 86, .external_lex_state = 7},
  [5484] = {.lex_state = 86, .external_lex_state = 7},
  [5485] = {.lex_state = 86, .external_lex_state = 7},
  [5486] = {.lex_state = 86, .external_lex_state = 7},
  [5487] = {.lex_state = 86, .external_lex_state = 7},
  [5488] = {.lex_state = 86, .external_lex_state = 7},
  [5489] = {.lex_state = 86, .external_lex_state = 7},
  [5490] = {.lex_state = 86, .external_lex_state = 7},
  [5491] = {.lex_state = 86, .external_lex_state = 7},
  [5492] = {.lex_state = 86, .external_lex_state = 7},
  [5493] = {.lex_state = 86, .external_lex_state = 7},
  [5494] = {.lex_state = 86, .external_lex_state = 7},
  [5495] = {.lex_state = 86, .external_lex_state = 7},
  [5496] = {.lex_state = 86, .external_lex_state = 7},
  [5497] = {.lex_state = 86, .external_lex_state = 7},
  [5498] = {.lex_state = 86, .external_lex_state = 7},
  [5499] = {.lex_state = 86, .external_lex_state = 7},
  [5500] = {.lex_state = 86, .external_lex_state = 7},
  [5501] = {.lex_state = 86, .external_lex_state = 7},
  [5502] = {.lex_state = 86, .external_lex_state = 7},
  [5503] = {.lex_state = 86, .external_lex_state = 7},
  [5504] = {.lex_state = 86, .external_lex_state = 7},
  [5505] = {.lex_state = 86, .external_lex_state = 7},
  [5506] = {.lex_state = 86, .external_lex_state = 7},
  [5507] = {.lex_state = 86, .external_lex_state = 7},
  [5508] = {.lex_state = 86, .external_lex_state = 7},
  [5509] = {.lex_state = 86, .external_lex_state = 7},
  [5510] = {.lex_state = 86, .external_lex_state = 7},
  [5511] = {.lex_state = 86, .external_lex_state = 7},
  [5512] = {.lex_state = 86, .external_lex_state = 7},
  [5513] = {.lex_state = 86, .external_lex_state = 7},
  [5514] = {.lex_state = 86, .external_lex_state = 7},
  [5515] = {.lex_state = 95, .external_lex_state = 6},
  [5516] = {.lex_state = 86, .external_lex_state = 7},
  [5517] = {.lex_state = 86, .external_lex_state = 7},
  [5518] = {.lex_state = 86, .external_lex_state = 7},
  [5519] = {.lex_state = 86, .external_lex_state = 7},
  [5520] = {.lex_state = 86, .external_lex_state = 7},
  [5521] = {.lex_state = 86, .external_lex_state = 7},
  [5522] = {.lex_state = 86, .external_lex_state = 7},
  [5523] = {.lex_state = 86, .external_lex_state = 7},
  [5524] = {.lex_state = 86, .external_lex_state = 7},
  [5525] = {.lex_state = 86, .external_lex_state = 7},
  [5526] = {.lex_state = 86, .external_lex_state = 7},
  [5527] = {.lex_state = 86, .external_lex_state = 7},
  [5528] = {.lex_state = 86, .external_lex_state = 7},
  [5529] = {.lex_state = 86, .external_lex_state = 7},
  [5530] = {.lex_state = 86, .external_lex_state = 7},
  [5531] = {.lex_state = 86, .external_lex_state = 7},
  [5532] = {.lex_state = 95, .external_lex_state = 7},
  [5533] = {.lex_state = 86, .external_lex_state = 7},
  [5534] = {.lex_state = 86, .external_lex_state = 7},
  [5535] = {.lex_state = 86, .external_lex_state = 7},
  [5536] = {.lex_state = 86, .external_lex_state = 7},
  [5537] = {.lex_state = 86, .external_lex_state = 7},
  [5538] = {.lex_state = 86, .external_lex_state = 7},
  [5539] = {.lex_state = 86, .external_lex_state = 7},
  [5540] = {.lex_state = 86, .external_lex_state = 7},
  [5541] = {.lex_state = 95, .external_lex_state = 6},
  [5542] = {.lex_state = 86, .external_lex_state = 7},
  [5543] = {.lex_state = 86, .external_lex_state = 7},
  [5544] = {.lex_state = 86, .external_lex_state = 7},
  [5545] = {.lex_state = 86, .external_lex_state = 7},
  [5546] = {.lex_state = 86, .external_lex_state = 7},
  [5547] = {.lex_state = 86, .external_lex_state = 7},
  [5548] = {.lex_state = 86, .external_lex_state = 7},
  [5549] = {.lex_state = 86, .external_lex_state = 7},
  [5550] = {.lex_state = 86, .external_lex_state = 7},
  [5551] = {.lex_state = 86, .external_lex_state = 7},
  [5552] = {.lex_state = 95, .external_lex_state = 6},
  [5553] = {.lex_state = 86, .external_lex_state = 7},
  [5554] = {.lex_state = 86, .external_lex_state = 7},
  [5555] = {.lex_state = 86, .external_lex_state = 7},
  [5556] = {.lex_state = 86, .external_lex_state = 7},
  [5557] = {.lex_state = 86, .external_lex_state = 7},
  [5558] = {.lex_state = 86, .external_lex_state = 7},
  [5559] = {.lex_state = 86, .external_lex_state = 7},
  [5560] = {.lex_state = 86, .external_lex_state = 7},
  [5561] = {.lex_state = 86, .external_lex_state = 7},
  [5562] = {.lex_state = 86, .external_lex_state = 7},
  [5563] = {.lex_state = 86, .external_lex_state = 7},
  [5564] = {.lex_state = 86, .external_lex_state = 7},
  [5565] = {.lex_state = 86, .external_lex_state = 7},
  [5566] = {.lex_state = 86, .external_lex_state = 7},
  [5567] = {.lex_state = 86, .external_lex_state = 7},
  [5568] = {.lex_state = 86, .external_lex_state = 7},
  [5569] = {.lex_state = 86, .external_lex_state = 7},
  [5570] = {.lex_state = 86, .external_lex_state = 7},
  [5571] = {.lex_state = 86, .external_lex_state = 7},
  [5572] = {.lex_state = 86, .external_lex_state = 7},
  [5573] = {.lex_state = 86, .external_lex_state = 7},
  [5574] = {.lex_state = 86, .external_lex_state = 7},
  [5575] = {.lex_state = 86, .external_lex_state = 7},
  [5576] = {.lex_state = 86, .external_lex_state = 7},
  [5577] = {.lex_state = 86, .external_lex_state = 7},
  [5578] = {.lex_state = 86, .external_lex_state = 7},
  [5579] = {.lex_state = 86, .external_lex_state = 7},
  [5580] = {.lex_state = 86, .external_lex_state = 7},
  [5581] = {.lex_state = 86, .external_lex_state = 7},
  [5582] = {.lex_state = 86, .external_lex_state = 7},
  [5583] = {.lex_state = 86, .external_lex_state = 7},
  [5584] = {.lex_state = 86, .external_lex_state = 7},
  [5585] = {.lex_state = 86, .external_lex_state = 7},
  [5586] = {.lex_state = 86, .external_lex_state = 7},
  [5587] = {.lex_state = 86, .external_lex_state = 7},
  [5588] = {.lex_state = 86, .external_lex_state = 7},
  [5589] = {.lex_state = 86, .external_lex_state = 7},
  [5590] = {.lex_state = 86, .external_lex_state = 7},
  [5591] = {.lex_state = 86, .external_lex_state = 7},
  [5592] = {.lex_state = 86, .external_lex_state = 7},
  [5593] = {.lex_state = 86, .external_lex_state = 7},
  [5594] = {.lex_state = 86, .external_lex_state = 7},
  [5595] = {.lex_state = 86, .external_lex_state = 7},
  [5596] = {.lex_state = 86, .external_lex_state = 7},
  [5597] = {.lex_state = 86, .external_lex_state = 7},
  [5598] = {.lex_state = 86, .external_lex_state = 7},
  [5599] = {.lex_state = 95, .external_lex_state = 7},
  [5600] = {.lex_state = 95, .external_lex_state = 7},
  [5601] = {.lex_state = 95, .external_lex_state = 7},
  [5602] = {.lex_state = 95, .external_lex_state = 7},
  [5603] = {.lex_state = 95, .external_lex_state = 7},
  [5604] = {.lex_state = 95, .external_lex_state = 7},
  [5605] = {.lex_state = 95, .external_lex_state = 7},
  [5606] = {.lex_state = 95, .external_lex_state = 7},
  [5607] = {.lex_state = 95, .external_lex_state = 7},
  [5608] = {.lex_state = 95, .external_lex_state = 7},
  [5609] = {.lex_state = 95, .external_lex_state = 7},
  [5610] = {.lex_state = 95, .external_lex_state = 7},
  [5611] = {.lex_state = 95, .external_lex_state = 7},
  [5612] = {.lex_state = 95, .external_lex_state = 7},
  [5613] = {.lex_state = 95, .external_lex_state = 7},
  [5614] = {.lex_state = 95, .external_lex_state = 7},
  [5615] = {.lex_state = 95, .external_lex_state = 7},
  [5616] = {.lex_state = 95, .external_lex_state = 7},
  [5617] = {.lex_state = 95, .external_lex_state = 7},
  [5618] = {.lex_state = 95, .external_lex_state = 7},
  [5619] = {.lex_state = 95, .external_lex_state = 7},
  [5620] = {.lex_state = 95, .external_lex_state = 7},
  [5621] = {.lex_state = 95, .external_lex_state = 7},
  [5622] = {.lex_state = 95, .external_lex_state = 7},
  [5623] = {.lex_state = 95, .external_lex_state = 7},
  [5624] = {.lex_state = 95, .external_lex_state = 7},
  [5625] = {.lex_state = 95, .external_lex_state = 7},
  [5626] = {.lex_state = 95, .external_lex_state = 7},
  [5627] = {.lex_state = 95, .external_lex_state = 7},
  [5628] = {.lex_state = 95, .external_lex_state = 7},
  [5629] = {.lex_state = 95, .external_lex_state = 7},
  [5630] = {.lex_state = 95, .external_lex_state = 7},
  [5631] = {.lex_state = 95, .external_lex_state = 7},
  [5632] = {.lex_state = 95, .external_lex_state = 7},
  [5633] = {.lex_state = 95, .external_lex_state = 7},
  [5634] = {.lex_state = 95, .external_lex_state = 7},
  [5635] = {.lex_state = 95, .external_lex_state = 7},
  [5636] = {.lex_state = 95, .external_lex_state = 7},
  [5637] = {.lex_state = 95, .external_lex_state = 7},
  [5638] = {.lex_state = 95, .external_lex_state = 7},
  [5639] = {.lex_state = 95, .external_lex_state = 7},
  [5640] = {.lex_state = 95, .external_lex_state = 7},
  [5641] = {.lex_state = 95, .external_lex_state = 7},
  [5642] = {.lex_state = 95, .external_lex_state = 7},
  [5643] = {.lex_state = 95, .external_lex_state = 7},
  [5644] = {.lex_state = 95, .external_lex_state = 7},
  [5645] = {.lex_state = 95, .external_lex_state = 7},
  [5646] = {.lex_state = 95, .external_lex_state = 7},
  [5647] = {.lex_state = 95, .external_lex_state = 7},
  [5648] = {.lex_state = 95, .external_lex_state = 7},
  [5649] = {.lex_state = 95, .external_lex_state = 7},
  [5650] = {.lex_state = 95, .external_lex_state = 7},
  [5651] = {.lex_state = 95, .external_lex_state = 7},
  [5652] = {.lex_state = 95, .external_lex_state = 7},
  [5653] = {.lex_state = 95, .external_lex_state = 7},
  [5654] = {.lex_state = 95, .external_lex_state = 7},
  [5655] = {.lex_state = 95, .external_lex_state = 7},
  [5656] = {.lex_state = 95, .external_lex_state = 7},
  [5657] = {.lex_state = 95, .external_lex_state = 7},
  [5658] = {.lex_state = 95, .external_lex_state = 7},
  [5659] = {.lex_state = 95, .external_lex_state = 7},
  [5660] = {.lex_state = 95, .external_lex_state = 7},
  [5661] = {.lex_state = 95, .external_lex_state = 7},
  [5662] = {.lex_state = 95, .external_lex_state = 7},
  [5663] = {.lex_state = 95, .external_lex_state = 7},
  [5664] = {.lex_state = 95, .external_lex_state = 7},
  [5665] = {.lex_state = 95, .external_lex_state = 7},
  [5666] = {.lex_state = 95, .external_lex_state = 7},
  [5667] = {.lex_state = 95, .external_lex_state = 7},
  [5668] = {.lex_state = 95, .external_lex_state = 7},
  [5669] = {.lex_state = 95, .external_lex_state = 7},
  [5670] = {.lex_state = 95, .external_lex_state = 7},
  [5671] = {.lex_state = 95, .external_lex_state = 7},
  [5672] = {.lex_state = 95, .external_lex_state = 7},
  [5673] = {.lex_state = 95, .external_lex_state = 7},
  [5674] = {.lex_state = 95, .external_lex_state = 7},
  [5675] = {.lex_state = 95, .external_lex_state = 7},
  [5676] = {.lex_state = 95, .external_lex_state = 7},
  [5677] = {.lex_state = 95, .external_lex_state = 7},
  [5678] = {.lex_state = 95, .external_lex_state = 7},
  [5679] = {.lex_state = 95, .external_lex_state = 7},
  [5680] = {.lex_state = 95, .external_lex_state = 7},
  [5681] = {.lex_state = 95, .external_lex_state = 7},
  [5682] = {.lex_state = 95, .external_lex_state = 7},
  [5683] = {.lex_state = 95, .external_lex_state = 7},
  [5684] = {.lex_state = 95, .external_lex_state = 7},
  [5685] = {.lex_state = 95, .external_lex_state = 7},
  [5686] = {.lex_state = 95, .external_lex_state = 7},
  [5687] = {.lex_state = 95, .external_lex_state = 7},
  [5688] = {.lex_state = 95, .external_lex_state = 7},
  [5689] = {.lex_state = 95, .external_lex_state = 7},
  [5690] = {.lex_state = 95, .external_lex_state = 7},
  [5691] = {.lex_state = 95, .external_lex_state = 7},
  [5692] = {.lex_state = 95, .external_lex_state = 7},
  [5693] = {.lex_state = 95, .external_lex_state = 7},
  [5694] = {.lex_state = 95, .external_lex_state = 7},
  [5695] = {.lex_state = 95, .external_lex_state = 7},
  [5696] = {.lex_state = 95, .external_lex_state = 7},
  [5697] = {.lex_state = 95, .external_lex_state = 7},
  [5698] = {.lex_state = 95, .external_lex_state = 7},
  [5699] = {.lex_state = 95, .external_lex_state = 7},
  [5700] = {.lex_state = 95, .external_lex_state = 7},
  [5701] = {.lex_state = 95, .external_lex_state = 7},
  [5702] = {.lex_state = 95, .external_lex_state = 7},
  [5703] = {.lex_state = 95, .external_lex_state = 7},
  [5704] = {.lex_state = 95, .external_lex_state = 5},
  [5705] = {.lex_state = 95, .external_lex_state = 7},
  [5706] = {.lex_state = 95, .external_lex_state = 7},
  [5707] = {.lex_state = 95, .external_lex_state = 7},
  [5708] = {.lex_state = 95, .external_lex_state = 7},
  [5709] = {.lex_state = 95, .external_lex_state = 7},
  [5710] = {.lex_state = 95, .external_lex_state = 7},
  [5711] = {.lex_state = 95, .external_lex_state = 6},
  [5712] = {.lex_state = 95, .external_lex_state = 7},
  [5713] = {.lex_state = 95, .external_lex_state = 7},
  [5714] = {.lex_state = 95, .external_lex_state = 7},
  [5715] = {.lex_state = 95, .external_lex_state = 7},
  [5716] = {.lex_state = 95, .external_lex_state = 7},
  [5717] = {.lex_state = 95, .external_lex_state = 7},
  [5718] = {.lex_state = 95, .external_lex_state = 7},
  [5719] = {.lex_state = 95, .external_lex_state = 7},
  [5720] = {.lex_state = 95, .external_lex_state = 7},
  [5721] = {.lex_state = 95, .external_lex_state = 7},
  [5722] = {.lex_state = 95, .external_lex_state = 5},
  [5723] = {.lex_state = 95, .external_lex_state = 7},
  [5724] = {.lex_state = 95, .external_lex_state = 7},
  [5725] = {.lex_state = 95, .external_lex_state = 7},
  [5726] = {.lex_state = 95, .external_lex_state = 7},
  [5727] = {.lex_state = 95, .external_lex_state = 7},
  [5728] = {.lex_state = 95, .external_lex_state = 7},
  [5729] = {.lex_state = 95, .external_lex_state = 7},
  [5730] = {.lex_state = 95, .external_lex_state = 7},
  [5731] = {.lex_state = 95, .external_lex_state = 7},
  [5732] = {.lex_state = 95, .external_lex_state = 7},
  [5733] = {.lex_state = 95, .external_lex_state = 7},
  [5734] = {.lex_state = 95, .external_lex_state = 7},
  [5735] = {.lex_state = 95, .external_lex_state = 7},
  [5736] = {.lex_state = 95, .external_lex_state = 7},
  [5737] = {.lex_state = 95, .external_lex_state = 5},
  [5738] = {.lex_state = 95, .external_lex_state = 7},
  [5739] = {.lex_state = 95, .external_lex_state = 7},
  [5740] = {.lex_state = 95, .external_lex_state = 7},
  [5741] = {.lex_state = 95, .external_lex_state = 7},
  [5742] = {.lex_state = 95, .external_lex_state = 7},
  [5743] = {.lex_state = 95, .external_lex_state = 5},
  [5744] = {.lex_state = 95, .external_lex_state = 7},
  [5745] = {.lex_state = 95, .external_lex_state = 5},
  [5746] = {.lex_state = 95, .external_lex_state = 5},
  [5747] = {.lex_state = 95, .external_lex_state = 7},
  [5748] = {.lex_state = 95, .external_lex_state = 7},
  [5749] = {.lex_state = 95, .external_lex_state = 7},
  [5750] = {.lex_state = 95, .external_lex_state = 7},
  [5751] = {.lex_state = 95, .external_lex_state = 7},
  [5752] = {.lex_state = 95, .external_lex_state = 7},
  [5753] = {.lex_state = 95, .external_lex_state = 7},
  [5754] = {.lex_state = 95, .external_lex_state = 7},
  [5755] = {.lex_state = 95, .external_lex_state = 7},
  [5756] = {.lex_state = 95, .external_lex_state = 7},
  [5757] = {.lex_state = 95, .external_lex_state = 7},
  [5758] = {.lex_state = 95, .external_lex_state = 7},
  [5759] = {.lex_state = 95, .external_lex_state = 7},
  [5760] = {.lex_state = 95, .external_lex_state = 7},
  [5761] = {.lex_state = 95, .external_lex_state = 7},
  [5762] = {.lex_state = 95, .external_lex_state = 7},
  [5763] = {.lex_state = 95, .external_lex_state = 7},
  [5764] = {.lex_state = 95, .external_lex_state = 7},
  [5765] = {.lex_state = 95, .external_lex_state = 6},
  [5766] = {.lex_state = 95, .external_lex_state = 7},
  [5767] = {.lex_state = 95, .external_lex_state = 7},
  [5768] = {.lex_state = 95, .external_lex_state = 7},
  [5769] = {.lex_state = 95, .external_lex_state = 7},
  [5770] = {.lex_state = 95, .external_lex_state = 7},
  [5771] = {.lex_state = 95, .external_lex_state = 7},
  [5772] = {.lex_state = 95, .external_lex_state = 7},
  [5773] = {.lex_state = 95, .external_lex_state = 7},
  [5774] = {.lex_state = 95, .external_lex_state = 7},
  [5775] = {.lex_state = 95, .external_lex_state = 7},
  [5776] = {.lex_state = 95, .external_lex_state = 7},
  [5777] = {.lex_state = 95, .external_lex_state = 7},
  [5778] = {.lex_state = 95, .external_lex_state = 7},
  [5779] = {.lex_state = 95, .external_lex_state = 7},
  [5780] = {.lex_state = 95, .external_lex_state = 7},
  [5781] = {.lex_state = 95, .external_lex_state = 7},
  [5782] = {.lex_state = 95, .external_lex_state = 7},
  [5783] = {.lex_state = 95, .external_lex_state = 7},
  [5784] = {.lex_state = 95, .external_lex_state = 7},
  [5785] = {.lex_state = 95, .external_lex_state = 7},
  [5786] = {.lex_state = 95, .external_lex_state = 7},
  [5787] = {.lex_state = 95, .external_lex_state = 6},
  [5788] = {.lex_state = 95, .external_lex_state = 7},
  [5789] = {.lex_state = 95, .external_lex_state = 7},
  [5790] = {.lex_state = 95, .external_lex_state = 7},
  [5791] = {.lex_state = 95, .external_lex_state = 6},
  [5792] = {.lex_state = 95, .external_lex_state = 7},
  [5793] = {.lex_state = 95, .external_lex_state = 7},
  [5794] = {.lex_state = 95, .external_lex_state = 7},
  [5795] = {.lex_state = 95, .external_lex_state = 7},
  [5796] = {.lex_state = 95, .external_lex_state = 7},
  [5797] = {.lex_state = 95, .external_lex_state = 7},
  [5798] = {.lex_state = 95, .external_lex_state = 7},
  [5799] = {.lex_state = 95, .external_lex_state = 7},
  [5800] = {.lex_state = 95, .external_lex_state = 7},
  [5801] = {.lex_state = 95, .external_lex_state = 7},
  [5802] = {.lex_state = 95, .external_lex_state = 7},
  [5803] = {.lex_state = 95, .external_lex_state = 7},
  [5804] = {.lex_state = 95, .external_lex_state = 7},
  [5805] = {.lex_state = 95, .external_lex_state = 7},
  [5806] = {.lex_state = 95, .external_lex_state = 7},
  [5807] = {.lex_state = 95, .external_lex_state = 7},
  [5808] = {.lex_state = 95, .external_lex_state = 7},
  [5809] = {.lex_state = 95, .external_lex_state = 7},
  [5810] = {.lex_state = 95, .external_lex_state = 7},
  [5811] = {.lex_state = 95, .external_lex_state = 6},
  [5812] = {.lex_state = 95, .external_lex_state = 7},
  [5813] = {.lex_state = 95, .external_lex_state = 6},
  [5814] = {.lex_state = 95, .external_lex_state = 6},
  [5815] = {.lex_state = 95, .external_lex_state = 7},
  [5816] = {.lex_state = 95, .external_lex_state = 7},
  [5817] = {.lex_state = 95, .external_lex_state = 7},
  [5818] = {.lex_state = 95, .external_lex_state = 7},
  [5819] = {.lex_state = 95, .external_lex_state = 7},
  [5820] = {.lex_state = 95, .external_lex_state = 7},
  [5821] = {.lex_state = 95, .external_lex_state = 7},
  [5822] = {.lex_state = 95, .external_lex_state = 7},
  [5823] = {.lex_state = 95, .external_lex_state = 7},
  [5824] = {.lex_state = 95, .external_lex_state = 7},
  [5825] = {.lex_state = 95, .external_lex_state = 7},
  [5826] = {.lex_state = 95, .external_lex_state = 7},
  [5827] = {.lex_state = 95, .external_lex_state = 6},
  [5828] = {.lex_state = 95, .external_lex_state = 7},
  [5829] = {.lex_state = 95, .external_lex_state = 7},
  [5830] = {.lex_state = 95, .external_lex_state = 7},
  [5831] = {.lex_state = 95, .external_lex_state = 7},
  [5832] = {.lex_state = 95, .external_lex_state = 7},
  [5833] = {.lex_state = 95, .external_lex_state = 7},
  [5834] = {.lex_state = 95, .external_lex_state = 7},
  [5835] = {.lex_state = 95, .external_lex_state = 7},
  [5836] = {.lex_state = 95, .external_lex_state = 7},
  [5837] = {.lex_state = 95, .external_lex_state = 7},
  [5838] = {.lex_state = 95, .external_lex_state = 7},
  [5839] = {.lex_state = 95, .external_lex_state = 7},
  [5840] = {.lex_state = 95, .external_lex_state = 7},
  [5841] = {.lex_state = 95, .external_lex_state = 7},
  [5842] = {.lex_state = 95, .external_lex_state = 7},
  [5843] = {.lex_state = 95, .external_lex_state = 6},
  [5844] = {.lex_state = 95, .external_lex_state = 7},
  [5845] = {.lex_state = 95, .external_lex_state = 7},
  [5846] = {.lex_state = 95, .external_lex_state = 7},
  [5847] = {.lex_state = 95, .external_lex_state = 7},
  [5848] = {.lex_state = 95, .external_lex_state = 7},
  [5849] = {.lex_state = 95, .external_lex_state = 7},
  [5850] = {.lex_state = 95, .external_lex_state = 7},
  [5851] = {.lex_state = 95, .external_lex_state = 7},
  [5852] = {.lex_state = 95, .external_lex_state = 6},
  [5853] = {.lex_state = 95, .external_lex_state = 7},
  [5854] = {.lex_state = 95, .external_lex_state = 6},
  [5855] = {.lex_state = 95, .external_lex_state = 7},
  [5856] = {.lex_state = 95, .external_lex_state = 7},
  [5857] = {.lex_state = 95, .external_lex_state = 6},
  [5858] = {.lex_state = 95, .external_lex_state = 7},
  [5859] = {.lex_state = 95, .external_lex_state = 7},
  [5860] = {.lex_state = 95, .external_lex_state = 6},
  [5861] = {.lex_state = 95, .external_lex_state = 7},
  [5862] = {.lex_state = 95, .external_lex_state = 7},
  [5863] = {.lex_state = 95, .external_lex_state = 7},
  [5864] = {.lex_state = 95, .external_lex_state = 7},
  [5865] = {.lex_state = 95, .external_lex_state = 7},
  [5866] = {.lex_state = 95, .external_lex_state = 6},
  [5867] = {.lex_state = 95, .external_lex_state = 7},
  [5868] = {.lex_state = 95, .external_lex_state = 7},
  [5869] = {.lex_state = 95, .external_lex_state = 7},
  [5870] = {.lex_state = 95, .external_lex_state = 7},
  [5871] = {.lex_state = 95, .external_lex_state = 7},
  [5872] = {.lex_state = 95, .external_lex_state = 7},
  [5873] = {.lex_state = 95, .external_lex_state = 7},
  [5874] = {.lex_state = 95, .external_lex_state = 7},
  [5875] = {.lex_state = 95, .external_lex_state = 7},
  [5876] = {.lex_state = 95, .external_lex_state = 7},
  [5877] = {.lex_state = 95, .external_lex_state = 7},
  [5878] = {.lex_state = 95, .external_lex_state = 7},
  [5879] = {.lex_state = 95, .external_lex_state = 7},
  [5880] = {.lex_state = 95, .external_lex_state = 6},
  [5881] = {.lex_state = 95, .external_lex_state = 7},
  [5882] = {.lex_state = 95, .external_lex_state = 7},
  [5883] = {.lex_state = 95, .external_lex_state = 7},
  [5884] = {.lex_state = 95, .external_lex_state = 7},
  [5885] = {.lex_state = 95, .external_lex_state = 7},
  [5886] = {.lex_state = 95, .external_lex_state = 7},
  [5887] = {.lex_state = 95, .external_lex_state = 7},
  [5888] = {.lex_state = 95, .external_lex_state = 7},
  [5889] = {.lex_state = 95, .external_lex_state = 7},
  [5890] = {.lex_state = 95, .external_lex_state = 7},
  [5891] = {.lex_state = 95, .external_lex_state = 7},
  [5892] = {.lex_state = 95, .external_lex_state = 7},
  [5893] = {.lex_state = 95, .external_lex_state = 7},
  [5894] = {.lex_state = 95, .external_lex_state = 7},
  [5895] = {.lex_state = 95, .external_lex_state = 7},
  [5896] = {.lex_state = 95, .external_lex_state = 7},
  [5897] = {.lex_state = 95, .external_lex_state = 7},
  [5898] = {.lex_state = 95, .external_lex_state = 7},
  [5899] = {.lex_state = 95, .external_lex_state = 7},
  [5900] = {.lex_state = 95, .external_lex_state = 7},
  [5901] = {.lex_state = 95, .external_lex_state = 7},
  [5902] = {.lex_state = 95, .external_lex_state = 7},
  [5903] = {.lex_state = 95, .external_lex_state = 7},
  [5904] = {.lex_state = 95, .external_lex_state = 7},
  [5905] = {.lex_state = 95, .external_lex_state = 7},
  [5906] = {.lex_state = 95, .external_lex_state = 7},
  [5907] = {.lex_state = 95, .external_lex_state = 7},
  [5908] = {.lex_state = 95, .external_lex_state = 7},
  [5909] = {.lex_state = 95, .external_lex_state = 7},
  [5910] = {.lex_state = 95, .external_lex_state = 7},
  [5911] = {.lex_state = 95, .external_lex_state = 7},
  [5912] = {.lex_state = 95, .external_lex_state = 7},
  [5913] = {.lex_state = 85, .external_lex_state = 2},
  [5914] = {.lex_state = 95, .external_lex_state = 7},
  [5915] = {.lex_state = 95, .external_lex_state = 7},
  [5916] = {.lex_state = 95, .external_lex_state = 7},
  [5917] = {.lex_state = 95, .external_lex_state = 7},
  [5918] = {.lex_state = 95, .external_lex_state = 7},
  [5919] = {.lex_state = 95, .external_lex_state = 7},
  [5920] = {.lex_state = 95, .external_lex_state = 7},
  [5921] = {.lex_state = 95, .external_lex_state = 7},
  [5922] = {.lex_state = 95, .external_lex_state = 7},
  [5923] = {.lex_state = 95, .external_lex_state = 7},
  [5924] = {.lex_state = 95, .external_lex_state = 7},
  [5925] = {.lex_state = 95, .external_lex_state = 7},
  [5926] = {.lex_state = 95, .external_lex_state = 7},
  [5927] = {.lex_state = 95, .external_lex_state = 7},
  [5928] = {.lex_state = 95, .external_lex_state = 7},
  [5929] = {.lex_state = 95, .external_lex_state = 7},
  [5930] = {.lex_state = 95, .external_lex_state = 7},
  [5931] = {.lex_state = 95, .external_lex_state = 7},
  [5932] = {.lex_state = 95, .external_lex_state = 6},
  [5933] = {.lex_state = 95, .external_lex_state = 7},
  [5934] = {.lex_state = 95, .external_lex_state = 7},
  [5935] = {.lex_state = 95, .external_lex_state = 7},
  [5936] = {.lex_state = 95, .external_lex_state = 7},
  [5937] = {.lex_state = 95, .external_lex_state = 7},
  [5938] = {.lex_state = 95, .external_lex_state = 7},
  [5939] = {.lex_state = 95, .external_lex_state = 7},
  [5940] = {.lex_state = 95, .external_lex_state = 7},
  [5941] = {.lex_state = 95, .external_lex_state = 7},
  [5942] = {.lex_state = 95, .external_lex_state = 7},
  [5943] = {.lex_state = 95, .external_lex_state = 7},
  [5944] = {.lex_state = 95, .external_lex_state = 7},
  [5945] = {.lex_state = 95, .external_lex_state = 7},
  [5946] = {.lex_state = 95, .external_lex_state = 7},
  [5947] = {.lex_state = 95, .external_lex_state = 7},
  [5948] = {.lex_state = 95, .external_lex_state = 7},
  [5949] = {.lex_state = 95, .external_lex_state = 7},
  [5950] = {.lex_state = 95, .external_lex_state = 7},
  [5951] = {.lex_state = 95, .external_lex_state = 7},
  [5952] = {.lex_state = 95, .external_lex_state = 7},
  [5953] = {.lex_state = 95, .external_lex_state = 7},
  [5954] = {.lex_state = 95, .external_lex_state = 7},
  [5955] = {.lex_state = 95, .external_lex_state = 7},
  [5956] = {.lex_state = 95, .external_lex_state = 7},
  [5957] = {.lex_state = 95, .external_lex_state = 7},
  [5958] = {.lex_state = 95, .external_lex_state = 7},
  [5959] = {.lex_state = 95, .external_lex_state = 7},
  [5960] = {.lex_state = 95, .external_lex_state = 7},
  [5961] = {.lex_state = 95, .external_lex_state = 6},
  [5962] = {.lex_state = 95, .external_lex_state = 7},
  [5963] = {.lex_state = 95, .external_lex_state = 7},
  [5964] = {.lex_state = 95, .external_lex_state = 7},
  [5965] = {.lex_state = 95, .external_lex_state = 7},
  [5966] = {.lex_state = 95, .external_lex_state = 7},
  [5967] = {.lex_state = 95, .external_lex_state = 7},
  [5968] = {.lex_state = 95, .external_lex_state = 7},
  [5969] = {.lex_state = 95, .external_lex_state = 6},
  [5970] = {.lex_state = 95, .external_lex_state = 7},
  [5971] = {.lex_state = 95, .external_lex_state = 7},
  [5972] = {.lex_state = 95, .external_lex_state = 7},
  [5973] = {.lex_state = 95, .external_lex_state = 7},
  [5974] = {.lex_state = 95, .external_lex_state = 7},
  [5975] = {.lex_state = 95, .external_lex_state = 7},
  [5976] = {.lex_state = 95, .external_lex_state = 6},
  [5977] = {.lex_state = 95, .external_lex_state = 7},
  [5978] = {.lex_state = 95, .external_lex_state = 7},
  [5979] = {.lex_state = 95, .external_lex_state = 6},
  [5980] = {.lex_state = 95, .external_lex_state = 6},
  [5981] = {.lex_state = 95, .external_lex_state = 7},
  [5982] = {.lex_state = 95, .external_lex_state = 7},
  [5983] = {.lex_state = 95, .external_lex_state = 7},
  [5984] = {.lex_state = 95, .external_lex_state = 7},
  [5985] = {.lex_state = 95, .external_lex_state = 7},
  [5986] = {.lex_state = 95, .external_lex_state = 6},
  [5987] = {.lex_state = 95, .external_lex_state = 7},
  [5988] = {.lex_state = 95, .external_lex_state = 7},
  [5989] = {.lex_state = 95, .external_lex_state = 7},
  [5990] = {.lex_state = 95, .external_lex_state = 7},
  [5991] = {.lex_state = 95, .external_lex_state = 7},
  [5992] = {.lex_state = 95, .external_lex_state = 7},
  [5993] = {.lex_state = 95, .external_lex_state = 7},
  [5994] = {.lex_state = 95, .external_lex_state = 7},
  [5995] = {.lex_state = 95, .external_lex_state = 6},
  [5996] = {.lex_state = 95, .external_lex_state = 7},
  [5997] = {.lex_state = 95, .external_lex_state = 7},
  [5998] = {.lex_state = 95, .external_lex_state = 7},
  [5999] = {.lex_state = 95, .external_lex_state = 7},
  [6000] = {.lex_state = 95, .external_lex_state = 7},
  [6001] = {.lex_state = 95, .external_lex_state = 7},
  [6002] = {.lex_state = 95, .external_lex_state = 7},
  [6003] = {.lex_state = 95, .external_lex_state = 7},
  [6004] = {.lex_state = 95, .external_lex_state = 7},
  [6005] = {.lex_state = 85, .external_lex_state = 2},
  [6006] = {.lex_state = 95, .external_lex_state = 6},
  [6007] = {.lex_state = 95, .external_lex_state = 7},
  [6008] = {.lex_state = 95, .external_lex_state = 6},
  [6009] = {.lex_state = 95, .external_lex_state = 7},
  [6010] = {.lex_state = 95, .external_lex_state = 7},
  [6011] = {.lex_state = 95, .external_lex_state = 7},
  [6012] = {.lex_state = 85, .external_lex_state = 2},
  [6013] = {.lex_state = 95, .external_lex_state = 7},
  [6014] = {.lex_state = 95, .external_lex_state = 7},
  [6015] = {.lex_state = 95, .external_lex_state = 7},
  [6016] = {.lex_state = 95, .external_lex_state = 7},
  [6017] = {.lex_state = 95, .external_lex_state = 7},
  [6018] = {.lex_state = 95, .external_lex_state = 7},
  [6019] = {.lex_state = 95, .external_lex_state = 7},
  [6020] = {.lex_state = 95, .external_lex_state = 7},
  [6021] = {.lex_state = 95, .external_lex_state = 7},
  [6022] = {.lex_state = 95, .external_lex_state = 7},
  [6023] = {.lex_state = 95, .external_lex_state = 7},
  [6024] = {.lex_state = 95, .external_lex_state = 6},
  [6025] = {.lex_state = 95, .external_lex_state = 7},
  [6026] = {.lex_state = 95, .external_lex_state = 6},
  [6027] = {.lex_state = 95, .external_lex_state = 6},
  [6028] = {.lex_state = 95, .external_lex_state = 7},
  [6029] = {.lex_state = 95, .external_lex_state = 7},
  [6030] = {.lex_state = 95, .external_lex_state = 7},
  [6031] = {.lex_state = 95, .external_lex_state = 7},
  [6032] = {.lex_state = 95, .external_lex_state = 7},
  [6033] = {.lex_state = 95, .external_lex_state = 7},
  [6034] = {.lex_state = 95, .external_lex_state = 7},
  [6035] = {.lex_state = 95, .external_lex_state = 7},
  [6036] = {.lex_state = 95, .external_lex_state = 7},
  [6037] = {.lex_state = 95, .external_lex_state = 7},
  [6038] = {.lex_state = 95, .external_lex_state = 7},
  [6039] = {.lex_state = 95, .external_lex_state = 7},
  [6040] = {.lex_state = 95, .external_lex_state = 7},
  [6041] = {.lex_state = 95, .external_lex_state = 7},
  [6042] = {.lex_state = 95, .external_lex_state = 7},
  [6043] = {.lex_state = 95, .external_lex_state = 7},
  [6044] = {.lex_state = 95, .external_lex_state = 7},
  [6045] = {.lex_state = 95, .external_lex_state = 7},
  [6046] = {.lex_state = 95, .external_lex_state = 7},
  [6047] = {.lex_state = 95, .external_lex_state = 7},
  [6048] = {.lex_state = 95, .external_lex_state = 7},
  [6049] = {.lex_state = 95, .external_lex_state = 7},
  [6050] = {.lex_state = 95, .external_lex_state = 7},
  [6051] = {.lex_state = 95, .external_lex_state = 7},
  [6052] = {.lex_state = 95, .external_lex_state = 7},
  [6053] = {.lex_state = 95, .external_lex_state = 7},
  [6054] = {.lex_state = 95, .external_lex_state = 7},
  [6055] = {.lex_state = 95, .external_lex_state = 7},
  [6056] = {.lex_state = 95, .external_lex_state = 7},
  [6057] = {.lex_state = 95, .external_lex_state = 7},
  [6058] = {.lex_state = 95, .external_lex_state = 7},
  [6059] = {.lex_state = 95, .external_lex_state = 7},
  [6060] = {.lex_state = 95, .external_lex_state = 7},
  [6061] = {.lex_state = 95, .external_lex_state = 7},
  [6062] = {.lex_state = 95, .external_lex_state = 7},
  [6063] = {.lex_state = 95, .external_lex_state = 7},
  [6064] = {.lex_state = 95, .external_lex_state = 7},
  [6065] = {.lex_state = 95, .external_lex_state = 7},
  [6066] = {.lex_state = 95, .external_lex_state = 7},
  [6067] = {.lex_state = 95, .external_lex_state = 7},
  [6068] = {.lex_state = 95, .external_lex_state = 7},
  [6069] = {.lex_state = 95, .external_lex_state = 7},
  [6070] = {.lex_state = 95, .external_lex_state = 7},
  [6071] = {.lex_state = 95, .external_lex_state = 7},
  [6072] = {.lex_state = 95, .external_lex_state = 7},
  [6073] = {.lex_state = 95, .external_lex_state = 7},
  [6074] = {.lex_state = 95, .external_lex_state = 7},
  [6075] = {.lex_state = 95, .external_lex_state = 7},
  [6076] = {.lex_state = 95, .external_lex_state = 7},
  [6077] = {.lex_state = 95, .external_lex_state = 7},
  [6078] = {.lex_state = 95, .external_lex_state = 7},
  [6079] = {.lex_state = 95, .external_lex_state = 7},
  [6080] = {.lex_state = 95, .external_lex_state = 7},
  [6081] = {.lex_state = 95, .external_lex_state = 7},
  [6082] = {.lex_state = 95, .external_lex_state = 7},
  [6083] = {.lex_state = 95, .external_lex_state = 7},
  [6084] = {.lex_state = 95, .external_lex_state = 7},
  [6085] = {.lex_state = 95, .external_lex_state = 7},
  [6086] = {.lex_state = 95, .external_lex_state = 7},
  [6087] = {.lex_state = 95, .external_lex_state = 7},
  [6088] = {.lex_state = 95, .external_lex_state = 7},
  [6089] = {.lex_state = 95, .external_lex_state = 7},
  [6090] = {.lex_state = 95, .external_lex_state = 7},
  [6091] = {.lex_state = 95, .external_lex_state = 7},
  [6092] = {.lex_state = 95, .external_lex_state = 7},
  [6093] = {.lex_state = 95, .external_lex_state = 7},
  [6094] = {.lex_state = 95, .external_lex_state = 7},
  [6095] = {.lex_state = 95, .external_lex_state = 7},
  [6096] = {.lex_state = 95, .external_lex_state = 7},
  [6097] = {.lex_state = 95, .external_lex_state = 7},
  [6098] = {.lex_state = 95, .external_lex_state = 7},
  [6099] = {.lex_state = 95, .external_lex_state = 7},
  [6100] = {.lex_state = 95, .external_lex_state = 7},
  [6101] = {.lex_state = 95, .external_lex_state = 7},
  [6102] = {.lex_state = 95, .external_lex_state = 7},
  [6103] = {.lex_state = 95, .external_lex_state = 7},
  [6104] = {.lex_state = 95, .external_lex_state = 7},
  [6105] = {.lex_state = 95, .external_lex_state = 7},
  [6106] = {.lex_state = 95, .external_lex_state = 7},
  [6107] = {.lex_state = 95, .external_lex_state = 7},
  [6108] = {.lex_state = 95, .external_lex_state = 7},
  [6109] = {.lex_state = 95, .external_lex_state = 7},
  [6110] = {.lex_state = 95, .external_lex_state = 7},
  [6111] = {.lex_state = 95, .external_lex_state = 7},
  [6112] = {.lex_state = 95, .external_lex_state = 7},
  [6113] = {.lex_state = 95, .external_lex_state = 7},
  [6114] = {.lex_state = 95, .external_lex_state = 7},
  [6115] = {.lex_state = 95, .external_lex_state = 7},
  [6116] = {.lex_state = 95, .external_lex_state = 7},
  [6117] = {.lex_state = 95, .external_lex_state = 7},
  [6118] = {.lex_state = 95, .external_lex_state = 7},
  [6119] = {.lex_state = 95, .external_lex_state = 7},
  [6120] = {.lex_state = 95, .external_lex_state = 7},
  [6121] = {.lex_state = 95, .external_lex_state = 7},
  [6122] = {.lex_state = 95, .external_lex_state = 7},
  [6123] = {.lex_state = 95, .external_lex_state = 7},
  [6124] = {.lex_state = 95, .external_lex_state = 7},
  [6125] = {.lex_state = 95, .external_lex_state = 7},
  [6126] = {.lex_state = 95, .external_lex_state = 7},
  [6127] = {.lex_state = 95, .external_lex_state = 7},
  [6128] = {.lex_state = 95, .external_lex_state = 7},
  [6129] = {.lex_state = 95, .external_lex_state = 7},
  [6130] = {.lex_state = 95, .external_lex_state = 7},
  [6131] = {.lex_state = 95, .external_lex_state = 7},
  [6132] = {.lex_state = 95, .external_lex_state = 7},
  [6133] = {.lex_state = 95, .external_lex_state = 7},
  [6134] = {.lex_state = 95, .external_lex_state = 7},
  [6135] = {.lex_state = 95, .external_lex_state = 7},
  [6136] = {.lex_state = 95, .external_lex_state = 7},
  [6137] = {.lex_state = 95, .external_lex_state = 7},
  [6138] = {.lex_state = 95, .external_lex_state = 7},
  [6139] = {.lex_state = 95, .external_lex_state = 7},
  [6140] = {.lex_state = 95, .external_lex_state = 7},
  [6141] = {.lex_state = 95, .external_lex_state = 7},
  [6142] = {.lex_state = 95, .external_lex_state = 7},
  [6143] = {.lex_state = 95, .external_lex_state = 7},
  [6144] = {.lex_state = 95, .external_lex_state = 7},
  [6145] = {.lex_state = 95, .external_lex_state = 7},
  [6146] = {.lex_state = 95, .external_lex_state = 7},
  [6147] = {.lex_state = 95, .external_lex_state = 7},
  [6148] = {.lex_state = 95, .external_lex_state = 7},
  [6149] = {.lex_state = 95, .external_lex_state = 7},
  [6150] = {.lex_state = 95, .external_lex_state = 7},
  [6151] = {.lex_state = 95, .external_lex_state = 7},
  [6152] = {.lex_state = 95, .external_lex_state = 7},
  [6153] = {.lex_state = 95, .external_lex_state = 7},
  [6154] = {.lex_state = 95, .external_lex_state = 7},
  [6155] = {.lex_state = 95, .external_lex_state = 7},
  [6156] = {.lex_state = 95, .external_lex_state = 7},
  [6157] = {.lex_state = 95, .external_lex_state = 7},
  [6158] = {.lex_state = 95, .external_lex_state = 7},
  [6159] = {.lex_state = 95, .external_lex_state = 7},
  [6160] = {.lex_state = 95, .external_lex_state = 7},
  [6161] = {.lex_state = 95, .external_lex_state = 7},
  [6162] = {.lex_state = 95, .external_lex_state = 7},
  [6163] = {.lex_state = 95, .external_lex_state = 7},
  [6164] = {.lex_state = 95, .external_lex_state = 7},
  [6165] = {.lex_state = 95, .external_lex_state = 7},
  [6166] = {.lex_state = 95, .external_lex_state = 7},
  [6167] = {.lex_state = 95, .external_lex_state = 7},
  [6168] = {.lex_state = 95, .external_lex_state = 7},
  [6169] = {.lex_state = 95, .external_lex_state = 7},
  [6170] = {.lex_state = 95, .external_lex_state = 7},
  [6171] = {.lex_state = 95, .external_lex_state = 7},
  [6172] = {.lex_state = 95, .external_lex_state = 7},
  [6173] = {.lex_state = 95, .external_lex_state = 7},
  [6174] = {.lex_state = 95, .external_lex_state = 7},
  [6175] = {.lex_state = 95, .external_lex_state = 7},
  [6176] = {.lex_state = 95, .external_lex_state = 7},
  [6177] = {.lex_state = 95, .external_lex_state = 7},
  [6178] = {.lex_state = 95, .external_lex_state = 7},
  [6179] = {.lex_state = 95, .external_lex_state = 7},
  [6180] = {.lex_state = 95, .external_lex_state = 7},
  [6181] = {.lex_state = 95, .external_lex_state = 7},
  [6182] = {.lex_state = 95, .external_lex_state = 7},
  [6183] = {.lex_state = 95, .external_lex_state = 7},
  [6184] = {.lex_state = 95, .external_lex_state = 7},
  [6185] = {.lex_state = 95, .external_lex_state = 7},
  [6186] = {.lex_state = 95, .external_lex_state = 7},
  [6187] = {.lex_state = 95, .external_lex_state = 7},
  [6188] = {.lex_state = 95, .external_lex_state = 7},
  [6189] = {.lex_state = 95, .external_lex_state = 7},
  [6190] = {.lex_state = 95, .external_lex_state = 7},
  [6191] = {.lex_state = 95, .external_lex_state = 7},
  [6192] = {.lex_state = 95, .external_lex_state = 7},
  [6193] = {.lex_state = 95, .external_lex_state = 7},
  [6194] = {.lex_state = 95, .external_lex_state = 7},
  [6195] = {.lex_state = 95, .external_lex_state = 7},
  [6196] = {.lex_state = 95, .external_lex_state = 7},
  [6197] = {.lex_state = 95, .external_lex_state = 7},
  [6198] = {.lex_state = 95, .external_lex_state = 7},
  [6199] = {.lex_state = 95, .external_lex_state = 7},
  [6200] = {.lex_state = 95, .external_lex_state = 7},
  [6201] = {.lex_state = 95, .external_lex_state = 7},
  [6202] = {.lex_state = 95, .external_lex_state = 7},
  [6203] = {.lex_state = 95, .external_lex_state = 7},
  [6204] = {.lex_state = 95, .external_lex_state = 7},
  [6205] = {.lex_state = 95, .external_lex_state = 7},
  [6206] = {.lex_state = 95, .external_lex_state = 7},
  [6207] = {.lex_state = 95, .external_lex_state = 7},
  [6208] = {.lex_state = 95, .external_lex_state = 7},
  [6209] = {.lex_state = 95, .external_lex_state = 7},
  [6210] = {.lex_state = 95, .external_lex_state = 7},
  [6211] = {.lex_state = 95, .external_lex_state = 7},
  [6212] = {.lex_state = 95, .external_lex_state = 7},
  [6213] = {.lex_state = 95, .external_lex_state = 7},
  [6214] = {.lex_state = 95, .external_lex_state = 7},
  [6215] = {.lex_state = 95, .external_lex_state = 7},
  [6216] = {.lex_state = 95, .external_lex_state = 7},
  [6217] = {.lex_state = 95, .external_lex_state = 7},
  [6218] = {.lex_state = 95, .external_lex_state = 7},
  [6219] = {.lex_state = 95, .external_lex_state = 7},
  [6220] = {.lex_state = 95, .external_lex_state = 7},
  [6221] = {.lex_state = 95, .external_lex_state = 7},
  [6222] = {.lex_state = 95, .external_lex_state = 7},
  [6223] = {.lex_state = 95, .external_lex_state = 7},
  [6224] = {.lex_state = 95, .external_lex_state = 7},
  [6225] = {.lex_state = 95, .external_lex_state = 7},
  [6226] = {.lex_state = 95, .external_lex_state = 7},
  [6227] = {.lex_state = 95, .external_lex_state = 7},
  [6228] = {.lex_state = 95, .external_lex_state = 7},
  [6229] = {.lex_state = 95, .external_lex_state = 7},
  [6230] = {.lex_state = 95, .external_lex_state = 7},
  [6231] = {.lex_state = 95, .external_lex_state = 7},
  [6232] = {.lex_state = 95, .external_lex_state = 7},
  [6233] = {.lex_state = 95, .external_lex_state = 7},
  [6234] = {.lex_state = 95, .external_lex_state = 7},
  [6235] = {.lex_state = 95, .external_lex_state = 7},
  [6236] = {.lex_state = 95, .external_lex_state = 7},
  [6237] = {.lex_state = 95, .external_lex_state = 7},
  [6238] = {.lex_state = 95, .external_lex_state = 7},
  [6239] = {.lex_state = 95, .external_lex_state = 7},
  [6240] = {.lex_state = 95, .external_lex_state = 7},
  [6241] = {.lex_state = 95, .external_lex_state = 7},
  [6242] = {.lex_state = 95, .external_lex_state = 7},
  [6243] = {.lex_state = 95, .external_lex_state = 7},
  [6244] = {.lex_state = 95, .external_lex_state = 7},
  [6245] = {.lex_state = 95, .external_lex_state = 7},
  [6246] = {.lex_state = 95, .external_lex_state = 7},
  [6247] = {.lex_state = 95, .external_lex_state = 7},
  [6248] = {.lex_state = 95, .external_lex_state = 7},
  [6249] = {.lex_state = 95, .external_lex_state = 7},
  [6250] = {.lex_state = 95, .external_lex_state = 7},
  [6251] = {.lex_state = 95, .external_lex_state = 7},
  [6252] = {.lex_state = 95, .external_lex_state = 7},
  [6253] = {.lex_state = 95, .external_lex_state = 7},
  [6254] = {.lex_state = 95, .external_lex_state = 7},
  [6255] = {.lex_state = 95, .external_lex_state = 7},
  [6256] = {.lex_state = 95, .external_lex_state = 7},
  [6257] = {.lex_state = 95, .external_lex_state = 7},
  [6258] = {.lex_state = 95, .external_lex_state = 7},
  [6259] = {.lex_state = 95, .external_lex_state = 7},
  [6260] = {.lex_state = 95, .external_lex_state = 7},
  [6261] = {.lex_state = 95, .external_lex_state = 7},
  [6262] = {.lex_state = 95, .external_lex_state = 7},
  [6263] = {.lex_state = 95, .external_lex_state = 7},
  [6264] = {.lex_state = 95, .external_lex_state = 7},
  [6265] = {.lex_state = 95, .external_lex_state = 7},
  [6266] = {.lex_state = 95, .external_lex_state = 7},
  [6267] = {.lex_state = 95, .external_lex_state = 7},
  [6268] = {.lex_state = 95, .external_lex_state = 7},
  [6269] = {.lex_state = 95, .external_lex_state = 7},
  [6270] = {.lex_state = 95, .external_lex_state = 7},
  [6271] = {.lex_state = 95, .external_lex_state = 7},
  [6272] = {.lex_state = 95, .external_lex_state = 7},
  [6273] = {.lex_state = 95, .external_lex_state = 7},
  [6274] = {.lex_state = 95, .external_lex_state = 7},
  [6275] = {.lex_state = 95, .external_lex_state = 7},
  [6276] = {.lex_state = 95, .external_lex_state = 7},
  [6277] = {.lex_state = 95, .external_lex_state = 7},
  [6278] = {.lex_state = 95, .external_lex_state = 7},
  [6279] = {.lex_state = 95, .external_lex_state = 7},
  [6280] = {.lex_state = 95, .external_lex_state = 7},
  [6281] = {.lex_state = 95, .external_lex_state = 7},
  [6282] = {.lex_state = 95, .external_lex_state = 7},
  [6283] = {.lex_state = 95, .external_lex_state = 7},
  [6284] = {.lex_state = 95, .external_lex_state = 7},
  [6285] = {.lex_state = 95, .external_lex_state = 7},
  [6286] = {.lex_state = 95, .external_lex_state = 7},
  [6287] = {.lex_state = 95, .external_lex_state = 7},
  [6288] = {.lex_state = 95, .external_lex_state = 7},
  [6289] = {.lex_state = 95, .external_lex_state = 7},
  [6290] = {.lex_state = 95, .external_lex_state = 7},
  [6291] = {.lex_state = 95, .external_lex_state = 7},
  [6292] = {.lex_state = 95, .external_lex_state = 7},
  [6293] = {.lex_state = 95, .external_lex_state = 7},
  [6294] = {.lex_state = 95, .external_lex_state = 7},
  [6295] = {.lex_state = 95, .external_lex_state = 7},
  [6296] = {.lex_state = 95, .external_lex_state = 7},
  [6297] = {.lex_state = 95, .external_lex_state = 7},
  [6298] = {.lex_state = 95, .external_lex_state = 7},
  [6299] = {.lex_state = 95, .external_lex_state = 7},
  [6300] = {.lex_state = 95, .external_lex_state = 7},
  [6301] = {.lex_state = 95, .external_lex_state = 7},
  [6302] = {.lex_state = 95, .external_lex_state = 7},
  [6303] = {.lex_state = 95, .external_lex_state = 7},
  [6304] = {.lex_state = 95, .external_lex_state = 7},
  [6305] = {.lex_state = 95, .external_lex_state = 7},
  [6306] = {.lex_state = 95, .external_lex_state = 7},
  [6307] = {.lex_state = 95, .external_lex_state = 7},
  [6308] = {.lex_state = 95, .external_lex_state = 7},
  [6309] = {.lex_state = 95, .external_lex_state = 7},
  [6310] = {.lex_state = 95, .external_lex_state = 7},
  [6311] = {.lex_state = 95, .external_lex_state = 7},
  [6312] = {.lex_state = 95, .external_lex_state = 7},
  [6313] = {.lex_state = 95, .external_lex_state = 7},
  [6314] = {.lex_state = 95, .external_lex_state = 7},
  [6315] = {.lex_state = 95, .external_lex_state = 7},
  [6316] = {.lex_state = 95, .external_lex_state = 7},
  [6317] = {.lex_state = 95, .external_lex_state = 7},
  [6318] = {.lex_state = 95, .external_lex_state = 7},
  [6319] = {.lex_state = 95, .external_lex_state = 7},
  [6320] = {.lex_state = 95, .external_lex_state = 7},
  [6321] = {.lex_state = 95, .external_lex_state = 7},
  [6322] = {.lex_state = 95, .external_lex_state = 7},
  [6323] = {.lex_state = 95, .external_lex_state = 7},
  [6324] = {.lex_state = 95, .external_lex_state = 7},
  [6325] = {.lex_state = 95, .external_lex_state = 7},
  [6326] = {.lex_state = 95, .external_lex_state = 7},
  [6327] = {.lex_state = 95, .external_lex_state = 7},
  [6328] = {.lex_state = 95, .external_lex_state = 7},
  [6329] = {.lex_state = 95, .external_lex_state = 7},
  [6330] = {.lex_state = 95, .external_lex_state = 7},
  [6331] = {.lex_state = 95, .external_lex_state = 7},
  [6332] = {.lex_state = 95, .external_lex_state = 7},
  [6333] = {.lex_state = 95, .external_lex_state = 7},
  [6334] = {.lex_state = 95, .external_lex_state = 7},
  [6335] = {.lex_state = 95, .external_lex_state = 7},
  [6336] = {.lex_state = 95, .external_lex_state = 7},
  [6337] = {.lex_state = 95, .external_lex_state = 7},
  [6338] = {.lex_state = 95, .external_lex_state = 7},
  [6339] = {.lex_state = 95, .external_lex_state = 7},
  [6340] = {.lex_state = 95, .external_lex_state = 7},
  [6341] = {.lex_state = 95, .external_lex_state = 7},
  [6342] = {.lex_state = 95, .external_lex_state = 7},
  [6343] = {.lex_state = 95, .external_lex_state = 7},
  [6344] = {.lex_state = 95, .external_lex_state = 7},
  [6345] = {.lex_state = 95, .external_lex_state = 7},
  [6346] = {.lex_state = 95, .external_lex_state = 7},
  [6347] = {.lex_state = 95, .external_lex_state = 7},
  [6348] = {.lex_state = 95, .external_lex_state = 7},
  [6349] = {.lex_state = 95, .external_lex_state = 7},
  [6350] = {.lex_state = 95, .external_lex_state = 7},
  [6351] = {.lex_state = 95, .external_lex_state = 7},
  [6352] = {.lex_state = 95, .external_lex_state = 7},
  [6353] = {.lex_state = 95, .external_lex_state = 7},
  [6354] = {.lex_state = 95, .external_lex_state = 6},
  [6355] = {.lex_state = 95, .external_lex_state = 7},
  [6356] = {.lex_state = 95, .external_lex_state = 7},
  [6357] = {.lex_state = 95, .external_lex_state = 7},
  [6358] = {.lex_state = 95, .external_lex_state = 7},
  [6359] = {.lex_state = 95, .external_lex_state = 7},
  [6360] = {.lex_state = 95, .external_lex_state = 7},
  [6361] = {.lex_state = 95, .external_lex_state = 7},
  [6362] = {.lex_state = 95, .external_lex_state = 7},
  [6363] = {.lex_state = 95, .external_lex_state = 7},
  [6364] = {.lex_state = 95, .external_lex_state = 7},
  [6365] = {.lex_state = 95, .external_lex_state = 7},
  [6366] = {.lex_state = 95, .external_lex_state = 7},
  [6367] = {.lex_state = 95, .external_lex_state = 7},
  [6368] = {.lex_state = 95, .external_lex_state = 7},
  [6369] = {.lex_state = 95, .external_lex_state = 7},
  [6370] = {.lex_state = 95, .external_lex_state = 7},
  [6371] = {.lex_state = 95, .external_lex_state = 7},
  [6372] = {.lex_state = 95, .external_lex_state = 7},
  [6373] = {.lex_state = 95, .external_lex_state = 7},
  [6374] = {.lex_state = 95, .external_lex_state = 7},
  [6375] = {.lex_state = 95, .external_lex_state = 7},
  [6376] = {.lex_state = 95, .external_lex_state = 7},
  [6377] = {.lex_state = 95, .external_lex_state = 7},
  [6378] = {.lex_state = 95, .external_lex_state = 7},
  [6379] = {.lex_state = 95, .external_lex_state = 7},
  [6380] = {.lex_state = 95, .external_lex_state = 7},
  [6381] = {.lex_state = 95, .external_lex_state = 7},
  [6382] = {.lex_state = 95, .external_lex_state = 7},
  [6383] = {.lex_state = 95, .external_lex_state = 7},
  [6384] = {.lex_state = 95, .external_lex_state = 7},
  [6385] = {.lex_state = 95, .external_lex_state = 7},
  [6386] = {.lex_state = 95, .external_lex_state = 7},
  [6387] = {.lex_state = 95, .external_lex_state = 7},
  [6388] = {.lex_state = 95, .external_lex_state = 7},
  [6389] = {.lex_state = 95, .external_lex_state = 7},
  [6390] = {.lex_state = 95, .external_lex_state = 7},
  [6391] = {.lex_state = 95, .external_lex_state = 7},
  [6392] = {.lex_state = 95, .external_lex_state = 7},
  [6393] = {.lex_state = 95, .external_lex_state = 7},
  [6394] = {.lex_state = 95, .external_lex_state = 7},
  [6395] = {.lex_state = 95, .external_lex_state = 7},
  [6396] = {.lex_state = 95, .external_lex_state = 7},
  [6397] = {.lex_state = 95, .external_lex_state = 7},
  [6398] = {.lex_state = 95, .external_lex_state = 7},
  [6399] = {.lex_state = 95, .external_lex_state = 7},
  [6400] = {.lex_state = 95, .external_lex_state = 7},
  [6401] = {.lex_state = 95, .external_lex_state = 7},
  [6402] = {.lex_state = 95, .external_lex_state = 7},
  [6403] = {.lex_state = 95, .external_lex_state = 7},
  [6404] = {.lex_state = 95, .external_lex_state = 7},
  [6405] = {.lex_state = 95, .external_lex_state = 7},
  [6406] = {.lex_state = 95, .external_lex_state = 7},
  [6407] = {.lex_state = 95, .external_lex_state = 7},
  [6408] = {.lex_state = 95, .external_lex_state = 7},
  [6409] = {.lex_state = 95, .external_lex_state = 7},
  [6410] = {.lex_state = 95, .external_lex_state = 7},
  [6411] = {.lex_state = 95, .external_lex_state = 7},
  [6412] = {.lex_state = 95, .external_lex_state = 7},
  [6413] = {.lex_state = 95, .external_lex_state = 7},
  [6414] = {.lex_state = 95, .external_lex_state = 7},
  [6415] = {.lex_state = 95, .external_lex_state = 7},
  [6416] = {.lex_state = 95, .external_lex_state = 7},
  [6417] = {.lex_state = 95, .external_lex_state = 7},
  [6418] = {.lex_state = 95, .external_lex_state = 7},
  [6419] = {.lex_state = 95, .external_lex_state = 7},
  [6420] = {.lex_state = 95, .external_lex_state = 7},
  [6421] = {.lex_state = 95, .external_lex_state = 7},
  [6422] = {.lex_state = 95, .external_lex_state = 7},
  [6423] = {.lex_state = 95, .external_lex_state = 7},
  [6424] = {.lex_state = 95, .external_lex_state = 7},
  [6425] = {.lex_state = 95, .external_lex_state = 7},
  [6426] = {.lex_state = 95, .external_lex_state = 7},
  [6427] = {.lex_state = 95, .external_lex_state = 7},
  [6428] = {.lex_state = 95, .external_lex_state = 7},
  [6429] = {.lex_state = 95, .external_lex_state = 7},
  [6430] = {.lex_state = 95, .external_lex_state = 7},
  [6431] = {.lex_state = 95, .external_lex_state = 7},
  [6432] = {.lex_state = 95, .external_lex_state = 7},
  [6433] = {.lex_state = 95, .external_lex_state = 7},
  [6434] = {.lex_state = 95, .external_lex_state = 7},
  [6435] = {.lex_state = 95, .external_lex_state = 7},
  [6436] = {.lex_state = 95, .external_lex_state = 7},
  [6437] = {.lex_state = 95, .external_lex_state = 7},
  [6438] = {.lex_state = 95, .external_lex_state = 7},
  [6439] = {.lex_state = 95, .external_lex_state = 7},
  [6440] = {.lex_state = 95, .external_lex_state = 7},
  [6441] = {.lex_state = 95, .external_lex_state = 7},
  [6442] = {.lex_state = 95, .external_lex_state = 7},
  [6443] = {.lex_state = 95, .external_lex_state = 7},
  [6444] = {.lex_state = 95, .external_lex_state = 7},
  [6445] = {.lex_state = 95, .external_lex_state = 7},
  [6446] = {.lex_state = 95, .external_lex_state = 7},
  [6447] = {.lex_state = 95, .external_lex_state = 7},
  [6448] = {.lex_state = 95, .external_lex_state = 7},
  [6449] = {.lex_state = 95, .external_lex_state = 7},
  [6450] = {.lex_state = 95, .external_lex_state = 7},
  [6451] = {.lex_state = 95, .external_lex_state = 7},
  [6452] = {.lex_state = 95, .external_lex_state = 7},
  [6453] = {.lex_state = 95, .external_lex_state = 7},
  [6454] = {.lex_state = 95, .external_lex_state = 7},
  [6455] = {.lex_state = 95, .external_lex_state = 7},
  [6456] = {.lex_state = 95, .external_lex_state = 7},
  [6457] = {.lex_state = 95, .external_lex_state = 7},
  [6458] = {.lex_state = 95, .external_lex_state = 6},
  [6459] = {.lex_state = 95, .external_lex_state = 7},
  [6460] = {.lex_state = 95, .external_lex_state = 7},
  [6461] = {.lex_state = 95, .external_lex_state = 7},
  [6462] = {.lex_state = 85, .external_lex_state = 2},
  [6463] = {.lex_state = 85, .external_lex_state = 2},
  [6464] = {.lex_state = 85, .external_lex_state = 2},
  [6465] = {.lex_state = 85, .external_lex_state = 2},
  [6466] = {.lex_state = 85, .external_lex_state = 2},
  [6467] = {.lex_state = 95, .external_lex_state = 7},
  [6468] = {.lex_state = 0, .external_lex_state = 2},
  [6469] = {.lex_state = 0, .external_lex_state = 2},
  [6470] = {.lex_state = 0, .external_lex_state = 2},
  [6471] = {.lex_state = 0, .external_lex_state = 2},
  [6472] = {.lex_state = 0, .external_lex_state = 2},
  [6473] = {.lex_state = 0, .external_lex_state = 2},
  [6474] = {.lex_state = 0, .external_lex_state = 2},
  [6475] = {.lex_state = 0, .external_lex_state = 2},
  [6476] = {.lex_state = 0, .external_lex_state = 2},
  [6477] = {.lex_state = 0, .external_lex_state = 2},
  [6478] = {.lex_state = 0, .external_lex_state = 2},
  [6479] = {.lex_state = 0, .external_lex_state = 2},
  [6480] = {.lex_state = 0, .external_lex_state = 2},
  [6481] = {.lex_state = 0, .external_lex_state = 2},
  [6482] = {.lex_state = 0, .external_lex_state = 2},
  [6483] = {.lex_state = 0, .external_lex_state = 2},
  [6484] = {.lex_state = 0, .external_lex_state = 2},
  [6485] = {.lex_state = 0, .external_lex_state = 2},
  [6486] = {.lex_state = 0, .external_lex_state = 2},
  [6487] = {.lex_state = 0, .external_lex_state = 2},
  [6488] = {.lex_state = 0, .external_lex_state = 2},
  [6489] = {.lex_state = 0, .external_lex_state = 2},
  [6490] = {.lex_state = 0, .external_lex_state = 2},
  [6491] = {.lex_state = 0, .external_lex_state = 7},
  [6492] = {.lex_state = 0, .external_lex_state = 7},
  [6493] = {.lex_state = 0, .external_lex_state = 7},
  [6494] = {.lex_state = 0, .external_lex_state = 7},
  [6495] = {.lex_state = 85, .external_lex_state = 4},
  [6496] = {.lex_state = 87, .external_lex_state = 8},
  [6497] = {.lex_state = 85, .external_lex_state = 8},
  [6498] = {.lex_state = 85, .external_lex_state = 4},
  [6499] = {.lex_state = 85, .external_lex_state = 8},
  [6500] = {.lex_state = 85, .external_lex_state = 4},
  [6501] = {.lex_state = 0, .external_lex_state = 7},
  [6502] = {.lex_state = 85, .external_lex_state = 4},
  [6503] = {.lex_state = 85, .external_lex_state = 4},
  [6504] = {.lex_state = 87, .external_lex_state = 4},
  [6505] = {.lex_state = 85, .external_lex_state = 7},
  [6506] = {.lex_state = 85, .external_lex_state = 7},
  [6507] = {.lex_state = 85, .external_lex_state = 6},
  [6508] = {.lex_state = 85, .external_lex_state = 7},
  [6509] = {.lex_state = 85, .external_lex_state = 4},
  [6510] = {.lex_state = 85, .external_lex_state = 4},
  [6511] = {.lex_state = 85, .external_lex_state = 4},
  [6512] = {.lex_state = 85, .external_lex_state = 8},
  [6513] = {.lex_state = 85, .external_lex_state = 8},
  [6514] = {.lex_state = 85, .external_lex_state = 7},
  [6515] = {.lex_state = 85, .external_lex_state = 7},
  [6516] = {.lex_state = 85, .external_lex_state = 7},
  [6517] = {.lex_state = 85, .external_lex_state = 4},
  [6518] = {.lex_state = 85, .external_lex_state = 4},
  [6519] = {.lex_state = 85, .external_lex_state = 7},
  [6520] = {.lex_state = 85, .external_lex_state = 7},
  [6521] = {.lex_state = 85, .external_lex_state = 4},
  [6522] = {.lex_state = 85, .external_lex_state = 7},
  [6523] = {.lex_state = 85, .external_lex_state = 8},
  [6524] = {.lex_state = 85, .external_lex_state = 8},
  [6525] = {.lex_state = 85, .external_lex_state = 4},
  [6526] = {.lex_state = 85, .external_lex_state = 4},
  [6527] = {.lex_state = 85, .external_lex_state = 7},
  [6528] = {.lex_state = 85, .external_lex_state = 4},
  [6529] = {.lex_state = 85, .external_lex_state = 4},
  [6530] = {.lex_state = 85, .external_lex_state = 4},
  [6531] = {.lex_state = 85, .external_lex_state = 8},
  [6532] = {.lex_state = 0, .external_lex_state = 7},
  [6533] = {.lex_state = 85, .external_lex_state = 7},
  [6534] = {.lex_state = 85, .external_lex_state = 8},
  [6535] = {.lex_state = 85, .external_lex_state = 4},
  [6536] = {.lex_state = 85, .external_lex_state = 8},
  [6537] = {.lex_state = 85, .external_lex_state = 7},
  [6538] = {.lex_state = 85, .external_lex_state = 4},
  [6539] = {.lex_state = 85, .external_lex_state = 8},
  [6540] = {.lex_state = 85, .external_lex_state = 4},
  [6541] = {.lex_state = 85, .external_lex_state = 6},
  [6542] = {.lex_state = 85, .external_lex_state = 7},
  [6543] = {.lex_state = 85, .external_lex_state = 6},
  [6544] = {.lex_state = 85, .external_lex_state = 4},
  [6545] = {.lex_state = 85, .external_lex_state = 4},
  [6546] = {.lex_state = 85, .external_lex_state = 4},
  [6547] = {.lex_state = 85, .external_lex_state = 6},
  [6548] = {.lex_state = 85, .external_lex_state = 7},
  [6549] = {.lex_state = 85, .external_lex_state = 7},
  [6550] = {.lex_state = 85, .external_lex_state = 7},
  [6551] = {.lex_state = 85, .external_lex_state = 7},
  [6552] = {.lex_state = 85, .external_lex_state = 7},
  [6553] = {.lex_state = 85, .external_lex_state = 8},
  [6554] = {.lex_state = 85, .external_lex_state = 6},
  [6555] = {.lex_state = 85, .external_lex_state = 6},
  [6556] = {.lex_state = 85, .external_lex_state = 6},
  [6557] = {.lex_state = 85, .external_lex_state = 6},
  [6558] = {.lex_state = 85, .external_lex_state = 6},
  [6559] = {.lex_state = 85, .external_lex_state = 6},
  [6560] = {.lex_state = 85, .external_lex_state = 6},
  [6561] = {.lex_state = 85, .external_lex_state = 6},
  [6562] = {.lex_state = 85, .external_lex_state = 6},
  [6563] = {.lex_state = 85, .external_lex_state = 6},
  [6564] = {.lex_state = 85, .external_lex_state = 4},
  [6565] = {.lex_state = 87, .external_lex_state = 6},
  [6566] = {.lex_state = 85, .external_lex_state = 6},
  [6567] = {.lex_state = 85, .external_lex_state = 8},
  [6568] = {.lex_state = 85, .external_lex_state = 7},
  [6569] = {.lex_state = 85, .external_lex_state = 6},
  [6570] = {.lex_state = 85, .external_lex_state = 6},
  [6571] = {.lex_state = 85, .external_lex_state = 6},
  [6572] = {.lex_state = 85, .external_lex_state = 8},
  [6573] = {.lex_state = 85, .external_lex_state = 4},
  [6574] = {.lex_state = 85, .external_lex_state = 6},
  [6575] = {.lex_state = 85, .external_lex_state = 4},
  [6576] = {.lex_state = 85, .external_lex_state = 4},
  [6577] = {.lex_state = 85, .external_lex_state = 8},
  [6578] = {.lex_state = 85, .external_lex_state = 6},
  [6579] = {.lex_state = 85, .external_lex_state = 6},
  [6580] = {.lex_state = 85, .external_lex_state = 6},
  [6581] = {.lex_state = 85, .external_lex_state = 8},
  [6582] = {.lex_state = 85, .external_lex_state = 8},
  [6583] = {.lex_state = 85, .external_lex_state = 4},
  [6584] = {.lex_state = 85, .external_lex_state = 4},
  [6585] = {.lex_state = 85, .external_lex_state = 6},
  [6586] = {.lex_state = 85, .external_lex_state = 4},
  [6587] = {.lex_state = 85, .external_lex_state = 8},
  [6588] = {.lex_state = 85, .external_lex_state = 4},
  [6589] = {.lex_state = 85, .external_lex_state = 4},
  [6590] = {.lex_state = 85, .external_lex_state = 8},
  [6591] = {.lex_state = 85, .external_lex_state = 4},
  [6592] = {.lex_state = 85, .external_lex_state = 8},
  [6593] = {.lex_state = 85, .external_lex_state = 8},
  [6594] = {.lex_state = 85, .external_lex_state = 8},
  [6595] = {.lex_state = 85, .external_lex_state = 4},
  [6596] = {.lex_state = 85, .external_lex_state = 4},
  [6597] = {.lex_state = 85, .external_lex_state = 6},
  [6598] = {.lex_state = 85, .external_lex_state = 4},
  [6599] = {.lex_state = 85, .external_lex_state = 4},
  [6600] = {.lex_state = 85, .external_lex_state = 8},
  [6601] = {.lex_state = 85, .external_lex_state = 4},
  [6602] = {.lex_state = 85, .external_lex_state = 8},
  [6603] = {.lex_state = 85, .external_lex_state = 4},
  [6604] = {.lex_state = 85, .external_lex_state = 4},
  [6605] = {.lex_state = 85, .external_lex_state = 8},
  [6606] = {.lex_state = 85, .external_lex_state = 4},
  [6607] = {.lex_state = 85, .external_lex_state = 4},
  [6608] = {.lex_state = 85, .external_lex_state = 10},
  [6609] = {.lex_state = 85, .external_lex_state = 8},
  [6610] = {.lex_state = 85, .external_lex_state = 8},
  [6611] = {.lex_state = 85, .external_lex_state = 8},
  [6612] = {.lex_state = 85, .external_lex_state = 8},
  [6613] = {.lex_state = 85, .external_lex_state = 8},
  [6614] = {.lex_state = 85, .external_lex_state = 6},
  [6615] = {.lex_state = 85, .external_lex_state = 7},
  [6616] = {.lex_state = 85, .external_lex_state = 6},
  [6617] = {.lex_state = 85, .external_lex_state = 6},
  [6618] = {.lex_state = 85, .external_lex_state = 6},
  [6619] = {.lex_state = 82, .external_lex_state = 6},
  [6620] = {.lex_state = 85, .external_lex_state = 6},
  [6621] = {.lex_state = 85, .external_lex_state = 10},
  [6622] = {.lex_state = 87, .external_lex_state = 10},
  [6623] = {.lex_state = 85, .external_lex_state = 6},
  [6624] = {.lex_state = 82, .external_lex_state = 6},
  [6625] = {.lex_state = 85, .external_lex_state = 8},
  [6626] = {.lex_state = 85, .external_lex_state = 6},
  [6627] = {.lex_state = 82, .external_lex_state = 7},
  [6628] = {.lex_state = 82, .external_lex_state = 7},
  [6629] = {.lex_state = 82, .external_lex_state = 7},
  [6630] = {.lex_state = 82, .external_lex_state = 7},
  [6631] = {.lex_state = 82, .external_lex_state = 7},
  [6632] = {.lex_state = 85, .external_lex_state = 10},
  [6633] = {.lex_state = 85, .external_lex_state = 10},
  [6634] = {.lex_state = 85, .external_lex_state = 10},
  [6635] = {.lex_state = 82, .external_lex_state = 7},
  [6636] = {.lex_state = 85, .external_lex_state = 10},
  [6637] = {.lex_state = 82, .external_lex_state = 7},
  [6638] = {.lex_state = 85, .external_lex_state = 10},
  [6639] = {.lex_state = 82, .external_lex_state = 7},
  [6640] = {.lex_state = 82, .external_lex_state = 7},
  [6641] = {.lex_state = 82, .external_lex_state = 7},
  [6642] = {.lex_state = 82, .external_lex_state = 7},
  [6643] = {.lex_state = 85, .external_lex_state = 6},
  [6644] = {.lex_state = 85, .external_lex_state = 10},
  [6645] = {.lex_state = 82, .external_lex_state = 7},
  [6646] = {.lex_state = 85, .external_lex_state = 10},
  [6647] = {.lex_state = 85, .external_lex_state = 6},
  [6648] = {.lex_state = 82, .external_lex_state = 7},
  [6649] = {.lex_state = 82, .external_lex_state = 7},
  [6650] = {.lex_state = 82, .external_lex_state = 7},
  [6651] = {.lex_state = 82, .external_lex_state = 7},
  [6652] = {.lex_state = 82, .external_lex_state = 7},
  [6653] = {.lex_state = 85, .external_lex_state = 6},
  [6654] = {.lex_state = 85, .external_lex_state = 6},
  [6655] = {.lex_state = 82, .external_lex_state = 7},
  [6656] = {.lex_state = 82, .external_lex_state = 7},
  [6657] = {.lex_state = 87, .external_lex_state = 6},
  [6658] = {.lex_state = 82, .external_lex_state = 7},
  [6659] = {.lex_state = 82, .external_lex_state = 7},
  [6660] = {.lex_state = 82, .external_lex_state = 7},
  [6661] = {.lex_state = 82, .external_lex_state = 7},
  [6662] = {.lex_state = 85, .external_lex_state = 7},
  [6663] = {.lex_state = 85, .external_lex_state = 10},
  [6664] = {.lex_state = 85, .external_lex_state = 7},
  [6665] = {.lex_state = 87, .external_lex_state = 6},
  [6666] = {.lex_state = 82, .external_lex_state = 7},
  [6667] = {.lex_state = 85, .external_lex_state = 7},
  [6668] = {.lex_state = 85, .external_lex_state = 10},
  [6669] = {.lex_state = 82, .external_lex_state = 7},
  [6670] = {.lex_state = 85, .external_lex_state = 6},
  [6671] = {.lex_state = 82, .external_lex_state = 7},
  [6672] = {.lex_state = 82, .external_lex_state = 7},
  [6673] = {.lex_state = 85, .external_lex_state = 10},
  [6674] = {.lex_state = 82, .external_lex_state = 7},
  [6675] = {.lex_state = 85, .external_lex_state = 6},
  [6676] = {.lex_state = 85, .external_lex_state = 10},
  [6677] = {.lex_state = 85, .external_lex_state = 6},
  [6678] = {.lex_state = 82, .external_lex_state = 7},
  [6679] = {.lex_state = 82, .external_lex_state = 7},
  [6680] = {.lex_state = 82, .external_lex_state = 7},
  [6681] = {.lex_state = 85, .external_lex_state = 6},
  [6682] = {.lex_state = 85, .external_lex_state = 10},
  [6683] = {.lex_state = 85, .external_lex_state = 10},
  [6684] = {.lex_state = 85, .external_lex_state = 6},
  [6685] = {.lex_state = 85, .external_lex_state = 6},
  [6686] = {.lex_state = 85, .external_lex_state = 6},
  [6687] = {.lex_state = 85, .external_lex_state = 7},
  [6688] = {.lex_state = 85, .external_lex_state = 6},
  [6689] = {.lex_state = 85, .external_lex_state = 10},
  [6690] = {.lex_state = 85, .external_lex_state = 10},
  [6691] = {.lex_state = 85, .external_lex_state = 6},
  [6692] = {.lex_state = 85, .external_lex_state = 6},
  [6693] = {.lex_state = 85, .external_lex_state = 6},
  [6694] = {.lex_state = 85, .external_lex_state = 6},
  [6695] = {.lex_state = 85, .external_lex_state = 6},
  [6696] = {.lex_state = 85, .external_lex_state = 6},
  [6697] = {.lex_state = 85, .external_lex_state = 6},
  [6698] = {.lex_state = 85, .external_lex_state = 6},
  [6699] = {.lex_state = 85, .external_lex_state = 6},
  [6700] = {.lex_state = 85, .external_lex_state = 6},
  [6701] = {.lex_state = 85, .external_lex_state = 6},
  [6702] = {.lex_state = 85, .external_lex_state = 6},
  [6703] = {.lex_state = 85, .external_lex_state = 6},
  [6704] = {.lex_state = 85, .external_lex_state = 6},
  [6705] = {.lex_state = 85, .external_lex_state = 6},
  [6706] = {.lex_state = 85, .external_lex_state = 6},
  [6707] = {.lex_state = 85, .external_lex_state = 10},
  [6708] = {.lex_state = 85, .external_lex_state = 6},
  [6709] = {.lex_state = 85, .external_lex_state = 10},
  [6710] = {.lex_state = 85, .external_lex_state = 6},
  [6711] = {.lex_state = 85, .external_lex_state = 7},
  [6712] = {.lex_state = 85, .external_lex_state = 6},
  [6713] = {.lex_state = 85, .external_lex_state = 7},
  [6714] = {.lex_state = 85, .external_lex_state = 10},
  [6715] = {.lex_state = 85, .external_lex_state = 10},
  [6716] = {.lex_state = 85, .external_lex_state = 6},
  [6717] = {.lex_state = 85, .external_lex_state = 6},
  [6718] = {.lex_state = 85, .external_lex_state = 6},
  [6719] = {.lex_state = 85, .external_lex_state = 6},
  [6720] = {.lex_state = 85, .external_lex_state = 6},
  [6721] = {.lex_state = 85, .external_lex_state = 10},
  [6722] = {.lex_state = 85, .external_lex_state = 10},
  [6723] = {.lex_state = 85, .external_lex_state = 6},
  [6724] = {.lex_state = 85, .external_lex_state = 6},
  [6725] = {.lex_state = 85, .external_lex_state = 6},
  [6726] = {.lex_state = 85, .external_lex_state = 6},
  [6727] = {.lex_state = 85, .external_lex_state = 7},
  [6728] = {.lex_state = 85, .external_lex_state = 6},
  [6729] = {.lex_state = 85, .external_lex_state = 10},
  [6730] = {.lex_state = 85, .external_lex_state = 6},
  [6731] = {.lex_state = 85, .external_lex_state = 6},
  [6732] = {.lex_state = 85, .external_lex_state = 6},
  [6733] = {.lex_state = 85, .external_lex_state = 6},
  [6734] = {.lex_state = 85, .external_lex_state = 6},
  [6735] = {.lex_state = 85, .external_lex_state = 10},
  [6736] = {.lex_state = 85, .external_lex_state = 10},
  [6737] = {.lex_state = 0, .external_lex_state = 5},
  [6738] = {.lex_state = 85, .external_lex_state = 6},
  [6739] = {.lex_state = 0, .external_lex_state = 5},
  [6740] = {.lex_state = 85, .external_lex_state = 10},
  [6741] = {.lex_state = 0, .external_lex_state = 5},
  [6742] = {.lex_state = 0, .external_lex_state = 5},
  [6743] = {.lex_state = 85, .external_lex_state = 6},
  [6744] = {.lex_state = 85, .external_lex_state = 6},
  [6745] = {.lex_state = 85, .external_lex_state = 10},
  [6746] = {.lex_state = 85, .external_lex_state = 6},
  [6747] = {.lex_state = 85, .external_lex_state = 6},
  [6748] = {.lex_state = 85, .external_lex_state = 6},
  [6749] = {.lex_state = 85, .external_lex_state = 6},
  [6750] = {.lex_state = 85, .external_lex_state = 6},
  [6751] = {.lex_state = 85, .external_lex_state = 6},
  [6752] = {.lex_state = 0, .external_lex_state = 5},
  [6753] = {.lex_state = 85, .external_lex_state = 10},
  [6754] = {.lex_state = 85, .external_lex_state = 6},
  [6755] = {.lex_state = 85, .external_lex_state = 6},
  [6756] = {.lex_state = 85, .external_lex_state = 10},
  [6757] = {.lex_state = 85, .external_lex_state = 6},
  [6758] = {.lex_state = 0, .external_lex_state = 4},
  [6759] = {.lex_state = 85, .external_lex_state = 6},
  [6760] = {.lex_state = 0, .external_lex_state = 4},
  [6761] = {.lex_state = 0, .external_lex_state = 4},
  [6762] = {.lex_state = 0, .external_lex_state = 7},
  [6763] = {.lex_state = 0, .external_lex_state = 7},
  [6764] = {.lex_state = 85, .external_lex_state = 6},
  [6765] = {.lex_state = 0, .external_lex_state = 7},
  [6766] = {.lex_state = 0, .external_lex_state = 7},
  [6767] = {.lex_state = 0, .external_lex_state = 4},
  [6768] = {.lex_state = 85, .external_lex_state = 6},
  [6769] = {.lex_state = 0, .external_lex_state = 5},
  [6770] = {.lex_state = 85, .external_lex_state = 6},
  [6771] = {.lex_state = 85, .external_lex_state = 6},
  [6772] = {.lex_state = 85, .external_lex_state = 6},
  [6773] = {.lex_state = 0, .external_lex_state = 4},
  [6774] = {.lex_state = 0, .external_lex_state = 4},
  [6775] = {.lex_state = 0, .external_lex_state = 5},
  [6776] = {.lex_state = 85, .external_lex_state = 6},
  [6777] = {.lex_state = 85, .external_lex_state = 6},
  [6778] = {.lex_state = 0, .external_lex_state = 5},
  [6779] = {.lex_state = 0, .external_lex_state = 5},
  [6780] = {.lex_state = 0, .external_lex_state = 5},
  [6781] = {.lex_state = 0, .external_lex_state = 5},
  [6782] = {.lex_state = 85, .external_lex_state = 10},
  [6783] = {.lex_state = 85, .external_lex_state = 6},
  [6784] = {.lex_state = 85, .external_lex_state = 10},
  [6785] = {.lex_state = 0, .external_lex_state = 4},
  [6786] = {.lex_state = 0, .external_lex_state = 4},
  [6787] = {.lex_state = 85, .external_lex_state = 10},
  [6788] = {.lex_state = 85, .external_lex_state = 10},
  [6789] = {.lex_state = 0, .external_lex_state = 5},
  [6790] = {.lex_state = 0, .external_lex_state = 5},
  [6791] = {.lex_state = 85, .external_lex_state = 6},
  [6792] = {.lex_state = 0, .external_lex_state = 4},
  [6793] = {.lex_state = 85, .external_lex_state = 6},
  [6794] = {.lex_state = 85, .external_lex_state = 6},
  [6795] = {.lex_state = 0, .external_lex_state = 7},
  [6796] = {.lex_state = 85, .external_lex_state = 10},
  [6797] = {.lex_state = 85, .external_lex_state = 10},
  [6798] = {.lex_state = 0, .external_lex_state = 10},
  [6799] = {.lex_state = 0, .external_lex_state = 5},
  [6800] = {.lex_state = 0, .external_lex_state = 5},
  [6801] = {.lex_state = 0, .external_lex_state = 5},
  [6802] = {.lex_state = 0, .external_lex_state = 11},
  [6803] = {.lex_state = 0, .external_lex_state = 5},
  [6804] = {.lex_state = 0, .external_lex_state = 5},
  [6805] = {.lex_state = 0, .external_lex_state = 5},
  [6806] = {.lex_state = 0, .external_lex_state = 5},
  [6807] = {.lex_state = 0, .external_lex_state = 5},
  [6808] = {.lex_state = 0, .external_lex_state = 11},
  [6809] = {.lex_state = 0, .external_lex_state = 10},
  [6810] = {.lex_state = 0, .external_lex_state = 5},
  [6811] = {.lex_state = 0, .external_lex_state = 5},
  [6812] = {.lex_state = 0, .external_lex_state = 9},
  [6813] = {.lex_state = 0, .external_lex_state = 5},
  [6814] = {.lex_state = 0, .external_lex_state = 5},
  [6815] = {.lex_state = 0, .external_lex_state = 5},
  [6816] = {.lex_state = 0, .external_lex_state = 9},
  [6817] = {.lex_state = 0, .external_lex_state = 5},
  [6818] = {.lex_state = 0, .external_lex_state = 11},
  [6819] = {.lex_state = 0, .external_lex_state = 5},
  [6820] = {.lex_state = 87, .external_lex_state = 7},
  [6821] = {.lex_state = 0, .external_lex_state = 10},
  [6822] = {.lex_state = 0, .external_lex_state = 5},
  [6823] = {.lex_state = 0, .external_lex_state = 5},
  [6824] = {.lex_state = 0, .external_lex_state = 10},
  [6825] = {.lex_state = 0, .external_lex_state = 5},
  [6826] = {.lex_state = 0, .external_lex_state = 5},
  [6827] = {.lex_state = 13, .external_lex_state = 6},
  [6828] = {.lex_state = 0, .external_lex_state = 5},
  [6829] = {.lex_state = 0, .external_lex_state = 10},
  [6830] = {.lex_state = 0, .external_lex_state = 5},
  [6831] = {.lex_state = 0, .external_lex_state = 5},
  [6832] = {.lex_state = 0, .external_lex_state = 11},
  [6833] = {.lex_state = 0, .external_lex_state = 5},
  [6834] = {.lex_state = 0, .external_lex_state = 9},
  [6835] = {.lex_state = 0, .external_lex_state = 5},
  [6836] = {.lex_state = 0, .external_lex_state = 5},
  [6837] = {.lex_state = 0, .external_lex_state = 5},
  [6838] = {.lex_state = 0, .external_lex_state = 9},
  [6839] = {.lex_state = 0, .external_lex_state = 10},
  [6840] = {.lex_state = 0, .external_lex_state = 9},
  [6841] = {.lex_state = 0, .external_lex_state = 11},
  [6842] = {.lex_state = 0, .external_lex_state = 11},
  [6843] = {.lex_state = 0, .external_lex_state = 11},
  [6844] = {.lex_state = 0, .external_lex_state = 10},
  [6845] = {.lex_state = 0, .external_lex_state = 5},
  [6846] = {.lex_state = 0, .external_lex_state = 5},
  [6847] = {.lex_state = 0, .external_lex_state = 11},
  [6848] = {.lex_state = 0, .external_lex_state = 11},
  [6849] = {.lex_state = 0, .external_lex_state = 5},
  [6850] = {.lex_state = 0, .external_lex_state = 5},
  [6851] = {.lex_state = 0, .external_lex_state = 5},
  [6852] = {.lex_state = 0, .external_lex_state = 5},
  [6853] = {.lex_state = 0, .external_lex_state = 5},
  [6854] = {.lex_state = 0, .external_lex_state = 5},
  [6855] = {.lex_state = 0, .external_lex_state = 5},
  [6856] = {.lex_state = 0, .external_lex_state = 5},
  [6857] = {.lex_state = 0, .external_lex_state = 5},
  [6858] = {.lex_state = 87, .external_lex_state = 11},
  [6859] = {.lex_state = 0, .external_lex_state = 5},
  [6860] = {.lex_state = 87, .external_lex_state = 11},
  [6861] = {.lex_state = 0, .external_lex_state = 5},
  [6862] = {.lex_state = 0, .external_lex_state = 5},
  [6863] = {.lex_state = 0, .external_lex_state = 5},
  [6864] = {.lex_state = 0, .external_lex_state = 5},
  [6865] = {.lex_state = 0, .external_lex_state = 5},
  [6866] = {.lex_state = 0, .external_lex_state = 5},
  [6867] = {.lex_state = 0, .external_lex_state = 5},
  [6868] = {.lex_state = 0, .external_lex_state = 10},
  [6869] = {.lex_state = 0, .external_lex_state = 4},
  [6870] = {.lex_state = 0, .external_lex_state = 5},
  [6871] = {.lex_state = 0, .external_lex_state = 5},
  [6872] = {.lex_state = 0, .external_lex_state = 5},
  [6873] = {.lex_state = 87, .external_lex_state = 11},
  [6874] = {.lex_state = 0, .external_lex_state = 5},
  [6875] = {.lex_state = 0, .external_lex_state = 5},
  [6876] = {.lex_state = 0, .external_lex_state = 5},
  [6877] = {.lex_state = 0, .external_lex_state = 5},
  [6878] = {.lex_state = 0, .external_lex_state = 5},
  [6879] = {.lex_state = 0, .external_lex_state = 5},
  [6880] = {.lex_state = 0, .external_lex_state = 5},
  [6881] = {.lex_state = 0, .external_lex_state = 5},
  [6882] = {.lex_state = 0, .external_lex_state = 5},
  [6883] = {.lex_state = 0, .external_lex_state = 5},
  [6884] = {.lex_state = 0, .external_lex_state = 5},
  [6885] = {.lex_state = 0, .external_lex_state = 5},
  [6886] = {.lex_state = 0, .external_lex_state = 5},
  [6887] = {.lex_state = 0, .external_lex_state = 5},
  [6888] = {.lex_state = 0, .external_lex_state = 5},
  [6889] = {.lex_state = 0, .external_lex_state = 5},
  [6890] = {.lex_state = 0, .external_lex_state = 5},
  [6891] = {.lex_state = 0, .external_lex_state = 5},
  [6892] = {.lex_state = 0, .external_lex_state = 5},
  [6893] = {.lex_state = 0, .external_lex_state = 5},
  [6894] = {.lex_state = 0, .external_lex_state = 5},
  [6895] = {.lex_state = 0, .external_lex_state = 10},
  [6896] = {.lex_state = 0, .external_lex_state = 5},
  [6897] = {.lex_state = 0, .external_lex_state = 5},
  [6898] = {.lex_state = 0, .external_lex_state = 10},
  [6899] = {.lex_state = 0, .external_lex_state = 5},
  [6900] = {.lex_state = 0, .external_lex_state = 9},
  [6901] = {.lex_state = 0, .external_lex_state = 5},
  [6902] = {.lex_state = 0, .external_lex_state = 5},
  [6903] = {.lex_state = 0, .external_lex_state = 5},
  [6904] = {.lex_state = 0, .external_lex_state = 5},
  [6905] = {.lex_state = 0, .external_lex_state = 5},
  [6906] = {.lex_state = 0, .external_lex_state = 5},
  [6907] = {.lex_state = 0, .external_lex_state = 5},
  [6908] = {.lex_state = 0, .external_lex_state = 5},
  [6909] = {.lex_state = 0, .external_lex_state = 10},
  [6910] = {.lex_state = 0, .external_lex_state = 5},
  [6911] = {.lex_state = 0, .external_lex_state = 6},
  [6912] = {.lex_state = 87, .external_lex_state = 7},
  [6913] = {.lex_state = 0, .external_lex_state = 6},
  [6914] = {.lex_state = 0, .external_lex_state = 6},
  [6915] = {.lex_state = 0, .external_lex_state = 6},
  [6916] = {.lex_state = 0, .external_lex_state = 10},
  [6917] = {.lex_state = 85, .external_lex_state = 6},
  [6918] = {.lex_state = 87, .external_lex_state = 7},
  [6919] = {.lex_state = 0, .external_lex_state = 5},
  [6920] = {.lex_state = 15, .external_lex_state = 6},
  [6921] = {.lex_state = 87, .external_lex_state = 11},
  [6922] = {.lex_state = 0, .external_lex_state = 5},
  [6923] = {.lex_state = 0, .external_lex_state = 6},
  [6924] = {.lex_state = 0, .external_lex_state = 6},
  [6925] = {.lex_state = 0, .external_lex_state = 6},
  [6926] = {.lex_state = 0, .external_lex_state = 5},
  [6927] = {.lex_state = 0, .external_lex_state = 7},
  [6928] = {.lex_state = 85, .external_lex_state = 6},
  [6929] = {.lex_state = 0, .external_lex_state = 10},
  [6930] = {.lex_state = 0, .external_lex_state = 5},
  [6931] = {.lex_state = 0, .external_lex_state = 5},
  [6932] = {.lex_state = 0, .external_lex_state = 11},
  [6933] = {.lex_state = 0, .external_lex_state = 11},
  [6934] = {.lex_state = 0, .external_lex_state = 5},
  [6935] = {.lex_state = 0, .external_lex_state = 11},
  [6936] = {.lex_state = 0, .external_lex_state = 11},
  [6937] = {.lex_state = 0, .external_lex_state = 5},
  [6938] = {.lex_state = 0, .external_lex_state = 5},
  [6939] = {.lex_state = 0, .external_lex_state = 7},
  [6940] = {.lex_state = 0, .external_lex_state = 11},
  [6941] = {.lex_state = 0, .external_lex_state = 5},
  [6942] = {.lex_state = 0, .external_lex_state = 5},
  [6943] = {.lex_state = 0, .external_lex_state = 5},
  [6944] = {.lex_state = 0, .external_lex_state = 5},
  [6945] = {.lex_state = 0, .external_lex_state = 7},
  [6946] = {.lex_state = 0, .external_lex_state = 5},
  [6947] = {.lex_state = 0, .external_lex_state = 10},
  [6948] = {.lex_state = 0, .external_lex_state = 11},
  [6949] = {.lex_state = 0, .external_lex_state = 7},
  [6950] = {.lex_state = 0, .external_lex_state = 5},
  [6951] = {.lex_state = 85, .external_lex_state = 6},
  [6952] = {.lex_state = 0, .external_lex_state = 5},
  [6953] = {.lex_state = 85, .external_lex_state = 6},
  [6954] = {.lex_state = 0, .external_lex_state = 5},
  [6955] = {.lex_state = 0, .external_lex_state = 5},
  [6956] = {.lex_state = 0, .external_lex_state = 5},
  [6957] = {.lex_state = 0, .external_lex_state = 5},
  [6958] = {.lex_state = 0, .external_lex_state = 11},
  [6959] = {.lex_state = 0, .external_lex_state = 11},
  [6960] = {.lex_state = 0, .external_lex_state = 11},
  [6961] = {.lex_state = 0, .external_lex_state = 5},
  [6962] = {.lex_state = 0, .external_lex_state = 11},
  [6963] = {.lex_state = 0, .external_lex_state = 11},
  [6964] = {.lex_state = 0, .external_lex_state = 11},
  [6965] = {.lex_state = 0, .external_lex_state = 5},
  [6966] = {.lex_state = 0, .external_lex_state = 5},
  [6967] = {.lex_state = 0, .external_lex_state = 5},
  [6968] = {.lex_state = 0, .external_lex_state = 7},
  [6969] = {.lex_state = 0, .external_lex_state = 5},
  [6970] = {.lex_state = 0, .external_lex_state = 7},
  [6971] = {.lex_state = 0, .external_lex_state = 5},
  [6972] = {.lex_state = 0, .external_lex_state = 11},
  [6973] = {.lex_state = 0, .external_lex_state = 5},
  [6974] = {.lex_state = 0, .external_lex_state = 11},
  [6975] = {.lex_state = 0, .external_lex_state = 11},
  [6976] = {.lex_state = 0, .external_lex_state = 7},
  [6977] = {.lex_state = 0, .external_lex_state = 11},
  [6978] = {.lex_state = 0, .external_lex_state = 5},
  [6979] = {.lex_state = 87, .external_lex_state = 7},
  [6980] = {.lex_state = 0, .external_lex_state = 11},
  [6981] = {.lex_state = 0, .external_lex_state = 11},
  [6982] = {.lex_state = 85, .external_lex_state = 6},
  [6983] = {.lex_state = 0, .external_lex_state = 11},
  [6984] = {.lex_state = 0, .external_lex_state = 7},
  [6985] = {.lex_state = 0, .external_lex_state = 5},
  [6986] = {.lex_state = 0, .external_lex_state = 5},
  [6987] = {.lex_state = 0, .external_lex_state = 5},
  [6988] = {.lex_state = 0, .external_lex_state = 5},
  [6989] = {.lex_state = 0, .external_lex_state = 5},
  [6990] = {.lex_state = 85, .external_lex_state = 6},
  [6991] = {.lex_state = 0, .external_lex_state = 5},
  [6992] = {.lex_state = 0, .external_lex_state = 5},
  [6993] = {.lex_state = 0, .external_lex_state = 5},
  [6994] = {.lex_state = 0, .external_lex_state = 5},
  [6995] = {.lex_state = 0, .external_lex_state = 5},
  [6996] = {.lex_state = 0, .external_lex_state = 5},
  [6997] = {.lex_state = 0, .external_lex_state = 5},
  [6998] = {.lex_state = 0, .external_lex_state = 5},
  [6999] = {.lex_state = 0, .external_lex_state = 5},
  [7000] = {.lex_state = 0, .external_lex_state = 5},
  [7001] = {.lex_state = 0, .external_lex_state = 5},
  [7002] = {.lex_state = 0, .external_lex_state = 5},
  [7003] = {.lex_state = 0, .external_lex_state = 11},
  [7004] = {.lex_state = 0, .external_lex_state = 11},
  [7005] = {.lex_state = 0, .external_lex_state = 11},
  [7006] = {.lex_state = 0, .external_lex_state = 5},
  [7007] = {.lex_state = 0, .external_lex_state = 5},
  [7008] = {.lex_state = 0, .external_lex_state = 11},
  [7009] = {.lex_state = 0, .external_lex_state = 11},
  [7010] = {.lex_state = 0, .external_lex_state = 5},
  [7011] = {.lex_state = 0, .external_lex_state = 5},
  [7012] = {.lex_state = 0, .external_lex_state = 11},
  [7013] = {.lex_state = 0, .external_lex_state = 10},
  [7014] = {.lex_state = 0, .external_lex_state = 5},
  [7015] = {.lex_state = 0, .external_lex_state = 11},
  [7016] = {.lex_state = 85, .external_lex_state = 6},
  [7017] = {.lex_state = 0, .external_lex_state = 11},
  [7018] = {.lex_state = 0, .external_lex_state = 5},
  [7019] = {.lex_state = 0, .external_lex_state = 5},
  [7020] = {.lex_state = 0, .external_lex_state = 11},
  [7021] = {.lex_state = 0, .external_lex_state = 5},
  [7022] = {.lex_state = 0, .external_lex_state = 5},
  [7023] = {.lex_state = 0, .external_lex_state = 5},
  [7024] = {.lex_state = 0, .external_lex_state = 5},
  [7025] = {.lex_state = 0, .external_lex_state = 7},
  [7026] = {.lex_state = 0, .external_lex_state = 5},
  [7027] = {.lex_state = 0, .external_lex_state = 5},
  [7028] = {.lex_state = 0, .external_lex_state = 5},
  [7029] = {.lex_state = 0, .external_lex_state = 5},
  [7030] = {.lex_state = 0, .external_lex_state = 7},
  [7031] = {.lex_state = 0, .external_lex_state = 5},
  [7032] = {.lex_state = 0, .external_lex_state = 11},
  [7033] = {.lex_state = 0, .external_lex_state = 5},
  [7034] = {.lex_state = 0, .external_lex_state = 5},
  [7035] = {.lex_state = 0, .external_lex_state = 11},
  [7036] = {.lex_state = 0, .external_lex_state = 5},
  [7037] = {.lex_state = 0, .external_lex_state = 5},
  [7038] = {.lex_state = 0, .external_lex_state = 10},
  [7039] = {.lex_state = 87, .external_lex_state = 7},
  [7040] = {.lex_state = 0, .external_lex_state = 7},
  [7041] = {.lex_state = 85, .external_lex_state = 6},
  [7042] = {.lex_state = 0, .external_lex_state = 5},
  [7043] = {.lex_state = 0, .external_lex_state = 11},
  [7044] = {.lex_state = 0, .external_lex_state = 7},
  [7045] = {.lex_state = 0, .external_lex_state = 5},
  [7046] = {.lex_state = 0, .external_lex_state = 5},
  [7047] = {.lex_state = 0, .external_lex_state = 11},
  [7048] = {.lex_state = 0, .external_lex_state = 7},
  [7049] = {.lex_state = 0, .external_lex_state = 11},
  [7050] = {.lex_state = 0, .external_lex_state = 5},
  [7051] = {.lex_state = 0, .external_lex_state = 5},
  [7052] = {.lex_state = 0, .external_lex_state = 7},
  [7053] = {.lex_state = 0, .external_lex_state = 11},
  [7054] = {.lex_state = 0, .external_lex_state = 7},
  [7055] = {.lex_state = 0, .external_lex_state = 5},
  [7056] = {.lex_state = 0, .external_lex_state = 5},
  [7057] = {.lex_state = 0, .external_lex_state = 7},
  [7058] = {.lex_state = 0, .external_lex_state = 5},
  [7059] = {.lex_state = 0, .external_lex_state = 5},
  [7060] = {.lex_state = 0, .external_lex_state = 5},
  [7061] = {.lex_state = 0, .external_lex_state = 5},
  [7062] = {.lex_state = 0, .external_lex_state = 7},
  [7063] = {.lex_state = 0, .external_lex_state = 5},
  [7064] = {.lex_state = 0, .external_lex_state = 11},
  [7065] = {.lex_state = 85, .external_lex_state = 6},
  [7066] = {.lex_state = 0, .external_lex_state = 11},
  [7067] = {.lex_state = 0, .external_lex_state = 5},
  [7068] = {.lex_state = 0, .external_lex_state = 11},
  [7069] = {.lex_state = 0, .external_lex_state = 11},
  [7070] = {.lex_state = 0, .external_lex_state = 5},
  [7071] = {.lex_state = 0, .external_lex_state = 5},
  [7072] = {.lex_state = 0, .external_lex_state = 5},
  [7073] = {.lex_state = 0, .external_lex_state = 5},
  [7074] = {.lex_state = 0, .external_lex_state = 5},
  [7075] = {.lex_state = 0, .external_lex_state = 5},
  [7076] = {.lex_state = 0, .external_lex_state = 7},
  [7077] = {.lex_state = 0, .external_lex_state = 11},
  [7078] = {.lex_state = 0, .external_lex_state = 7},
  [7079] = {.lex_state = 0, .external_lex_state = 7},
  [7080] = {.lex_state = 0, .external_lex_state = 5},
  [7081] = {.lex_state = 0, .external_lex_state = 11},
  [7082] = {.lex_state = 0, .external_lex_state = 5},
  [7083] = {.lex_state = 0, .external_lex_state = 5},
  [7084] = {.lex_state = 0, .external_lex_state = 11},
  [7085] = {.lex_state = 0, .external_lex_state = 5},
  [7086] = {.lex_state = 0, .external_lex_state = 5},
  [7087] = {.lex_state = 85, .external_lex_state = 6},
  [7088] = {.lex_state = 0, .external_lex_state = 5},
  [7089] = {.lex_state = 0, .external_lex_state = 5},
  [7090] = {.lex_state = 0, .external_lex_state = 11},
  [7091] = {.lex_state = 0, .external_lex_state = 11},
  [7092] = {.lex_state = 85, .external_lex_state = 6},
  [7093] = {.lex_state = 0, .external_lex_state = 5},
  [7094] = {.lex_state = 0, .external_lex_state = 11},
  [7095] = {.lex_state = 15, .external_lex_state = 6},
  [7096] = {.lex_state = 85, .external_lex_state = 6},
  [7097] = {.lex_state = 0, .external_lex_state = 5},
  [7098] = {.lex_state = 0, .external_lex_state = 5},
  [7099] = {.lex_state = 0, .external_lex_state = 11},
  [7100] = {.lex_state = 0, .external_lex_state = 5},
  [7101] = {.lex_state = 0, .external_lex_state = 5},
  [7102] = {.lex_state = 0, .external_lex_state = 5},
  [7103] = {.lex_state = 0, .external_lex_state = 11},
  [7104] = {.lex_state = 0, .external_lex_state = 5},
  [7105] = {.lex_state = 0, .external_lex_state = 7},
  [7106] = {.lex_state = 0, .external_lex_state = 11},
  [7107] = {.lex_state = 0, .external_lex_state = 5},
  [7108] = {.lex_state = 0, .external_lex_state = 5},
  [7109] = {.lex_state = 0, .external_lex_state = 5},
  [7110] = {.lex_state = 0, .external_lex_state = 5},
  [7111] = {.lex_state = 0, .external_lex_state = 5},
  [7112] = {.lex_state = 0, .external_lex_state = 5},
  [7113] = {.lex_state = 0, .external_lex_state = 5},
  [7114] = {.lex_state = 0, .external_lex_state = 5},
  [7115] = {.lex_state = 0, .external_lex_state = 11},
  [7116] = {.lex_state = 0, .external_lex_state = 5},
  [7117] = {.lex_state = 0, .external_lex_state = 5},
  [7118] = {.lex_state = 0, .external_lex_state = 5},
  [7119] = {.lex_state = 0, .external_lex_state = 11},
  [7120] = {.lex_state = 85, .external_lex_state = 6},
  [7121] = {.lex_state = 0, .external_lex_state = 5},
  [7122] = {.lex_state = 0, .external_lex_state = 11},
  [7123] = {.lex_state = 0, .external_lex_state = 5},
  [7124] = {.lex_state = 0, .external_lex_state = 11},
  [7125] = {.lex_state = 0, .external_lex_state = 7},
  [7126] = {.lex_state = 0, .external_lex_state = 5},
  [7127] = {.lex_state = 0, .external_lex_state = 11},
  [7128] = {.lex_state = 0, .external_lex_state = 11},
  [7129] = {.lex_state = 0, .external_lex_state = 5},
  [7130] = {.lex_state = 85, .external_lex_state = 6},
  [7131] = {.lex_state = 0, .external_lex_state = 5},
  [7132] = {.lex_state = 0, .external_lex_state = 5},
  [7133] = {.lex_state = 0, .external_lex_state = 5},
  [7134] = {.lex_state = 0, .external_lex_state = 5},
  [7135] = {.lex_state = 0, .external_lex_state = 11},
  [7136] = {.lex_state = 85, .external_lex_state = 6},
  [7137] = {.lex_state = 0, .external_lex_state = 5},
  [7138] = {.lex_state = 0, .external_lex_state = 11},
  [7139] = {.lex_state = 0, .external_lex_state = 5},
  [7140] = {.lex_state = 0, .external_lex_state = 5},
  [7141] = {.lex_state = 0, .external_lex_state = 5},
  [7142] = {.lex_state = 0, .external_lex_state = 5},
  [7143] = {.lex_state = 0, .external_lex_state = 5},
  [7144] = {.lex_state = 0, .external_lex_state = 5},
  [7145] = {.lex_state = 0, .external_lex_state = 5},
  [7146] = {.lex_state = 0, .external_lex_state = 7},
  [7147] = {.lex_state = 0, .external_lex_state = 5},
  [7148] = {.lex_state = 0, .external_lex_state = 5},
  [7149] = {.lex_state = 0, .external_lex_state = 5},
  [7150] = {.lex_state = 0, .external_lex_state = 5},
  [7151] = {.lex_state = 0, .external_lex_state = 5},
  [7152] = {.lex_state = 0, .external_lex_state = 11},
  [7153] = {.lex_state = 0, .external_lex_state = 7},
  [7154] = {.lex_state = 0, .external_lex_state = 5},
  [7155] = {.lex_state = 0, .external_lex_state = 5},
  [7156] = {.lex_state = 0, .external_lex_state = 5},
  [7157] = {.lex_state = 0, .external_lex_state = 5},
  [7158] = {.lex_state = 0, .external_lex_state = 5},
  [7159] = {.lex_state = 0, .external_lex_state = 5},
  [7160] = {.lex_state = 0, .external_lex_state = 5},
  [7161] = {.lex_state = 0, .external_lex_state = 5},
  [7162] = {.lex_state = 0, .external_lex_state = 5},
  [7163] = {.lex_state = 85, .external_lex_state = 6},
  [7164] = {.lex_state = 0, .external_lex_state = 11},
  [7165] = {.lex_state = 0, .external_lex_state = 5},
  [7166] = {.lex_state = 0, .external_lex_state = 5},
  [7167] = {.lex_state = 0, .external_lex_state = 5},
  [7168] = {.lex_state = 0, .external_lex_state = 7},
  [7169] = {.lex_state = 0, .external_lex_state = 7},
  [7170] = {.lex_state = 0, .external_lex_state = 5},
  [7171] = {.lex_state = 0, .external_lex_state = 5},
  [7172] = {.lex_state = 87, .external_lex_state = 7},
  [7173] = {.lex_state = 0, .external_lex_state = 7},
  [7174] = {.lex_state = 0, .external_lex_state = 5},
  [7175] = {.lex_state = 0, .external_lex_state = 5},
  [7176] = {.lex_state = 0, .external_lex_state = 5},
  [7177] = {.lex_state = 0, .external_lex_state = 7},
  [7178] = {.lex_state = 0, .external_lex_state = 5},
  [7179] = {.lex_state = 0, .external_lex_state = 7},
  [7180] = {.lex_state = 0, .external_lex_state = 5},
  [7181] = {.lex_state = 0, .external_lex_state = 5},
  [7182] = {.lex_state = 0, .external_lex_state = 5},
  [7183] = {.lex_state = 0, .external_lex_state = 7},
  [7184] = {.lex_state = 0, .external_lex_state = 5},
  [7185] = {.lex_state = 0, .external_lex_state = 5},
  [7186] = {.lex_state = 85, .external_lex_state = 6},
  [7187] = {.lex_state = 0, .external_lex_state = 5},
  [7188] = {.lex_state = 0, .external_lex_state = 5},
  [7189] = {.lex_state = 0, .external_lex_state = 11},
  [7190] = {.lex_state = 0, .external_lex_state = 11},
  [7191] = {.lex_state = 85, .external_lex_state = 6},
  [7192] = {.lex_state = 0, .external_lex_state = 5},
  [7193] = {.lex_state = 0, .external_lex_state = 5},
  [7194] = {.lex_state = 0, .external_lex_state = 7},
  [7195] = {.lex_state = 0, .external_lex_state = 5},
  [7196] = {.lex_state = 0, .external_lex_state = 7},
  [7197] = {.lex_state = 0, .external_lex_state = 5},
  [7198] = {.lex_state = 0, .external_lex_state = 5},
  [7199] = {.lex_state = 0, .external_lex_state = 7},
  [7200] = {.lex_state = 0, .external_lex_state = 7},
  [7201] = {.lex_state = 0, .external_lex_state = 11},
  [7202] = {.lex_state = 0, .external_lex_state = 5},
  [7203] = {.lex_state = 0, .external_lex_state = 7},
  [7204] = {.lex_state = 0, .external_lex_state = 5},
  [7205] = {.lex_state = 0, .external_lex_state = 5},
  [7206] = {.lex_state = 0, .external_lex_state = 5},
  [7207] = {.lex_state = 85, .external_lex_state = 6},
  [7208] = {.lex_state = 0, .external_lex_state = 5},
  [7209] = {.lex_state = 0, .external_lex_state = 5},
  [7210] = {.lex_state = 0, .external_lex_state = 5},
  [7211] = {.lex_state = 0, .external_lex_state = 5},
  [7212] = {.lex_state = 87, .external_lex_state = 7},
  [7213] = {.lex_state = 0, .external_lex_state = 7},
  [7214] = {.lex_state = 0, .external_lex_state = 5},
  [7215] = {.lex_state = 0, .external_lex_state = 5},
  [7216] = {.lex_state = 0, .external_lex_state = 7},
  [7217] = {.lex_state = 0, .external_lex_state = 7},
  [7218] = {.lex_state = 0, .external_lex_state = 7},
  [7219] = {.lex_state = 0, .external_lex_state = 7},
  [7220] = {.lex_state = 85, .external_lex_state = 7},
  [7221] = {.lex_state = 0, .external_lex_state = 7},
  [7222] = {.lex_state = 85, .external_lex_state = 7},
  [7223] = {.lex_state = 0, .external_lex_state = 5},
  [7224] = {.lex_state = 0, .external_lex_state = 7},
  [7225] = {.lex_state = 0, .external_lex_state = 7},
  [7226] = {.lex_state = 0, .external_lex_state = 7},
  [7227] = {.lex_state = 0, .external_lex_state = 7},
  [7228] = {.lex_state = 85, .external_lex_state = 7},
  [7229] = {.lex_state = 0, .external_lex_state = 5},
  [7230] = {.lex_state = 0, .external_lex_state = 5},
  [7231] = {.lex_state = 0, .external_lex_state = 5},
  [7232] = {.lex_state = 0, .external_lex_state = 5},
  [7233] = {.lex_state = 0, .external_lex_state = 7},
  [7234] = {.lex_state = 85, .external_lex_state = 7},
  [7235] = {.lex_state = 0, .external_lex_state = 5},
  [7236] = {.lex_state = 85, .external_lex_state = 7},
  [7237] = {.lex_state = 0, .external_lex_state = 7},
  [7238] = {.lex_state = 0, .external_lex_state = 7},
  [7239] = {.lex_state = 0, .external_lex_state = 5},
  [7240] = {.lex_state = 0, .external_lex_state = 5},
  [7241] = {.lex_state = 0, .external_lex_state = 7},
  [7242] = {.lex_state = 0, .external_lex_state = 7},
  [7243] = {.lex_state = 0, .external_lex_state = 5},
  [7244] = {.lex_state = 0, .external_lex_state = 5},
  [7245] = {.lex_state = 0, .external_lex_state = 7},
  [7246] = {.lex_state = 0, .external_lex_state = 5},
  [7247] = {.lex_state = 0, .external_lex_state = 7},
  [7248] = {.lex_state = 0, .external_lex_state = 7},
  [7249] = {.lex_state = 0, .external_lex_state = 7},
  [7250] = {.lex_state = 0, .external_lex_state = 5},
  [7251] = {.lex_state = 0, .external_lex_state = 6},
  [7252] = {.lex_state = 0, .external_lex_state = 5},
  [7253] = {.lex_state = 0, .external_lex_state = 5},
  [7254] = {.lex_state = 0, .external_lex_state = 5},
  [7255] = {.lex_state = 0, .external_lex_state = 5},
  [7256] = {.lex_state = 0, .external_lex_state = 7},
  [7257] = {.lex_state = 0, .external_lex_state = 5},
  [7258] = {.lex_state = 0, .external_lex_state = 7},
  [7259] = {.lex_state = 0, .external_lex_state = 7},
  [7260] = {.lex_state = 0, .external_lex_state = 7},
  [7261] = {.lex_state = 0, .external_lex_state = 7},
  [7262] = {.lex_state = 0, .external_lex_state = 5},
  [7263] = {.lex_state = 0, .external_lex_state = 7},
  [7264] = {.lex_state = 85, .external_lex_state = 7},
  [7265] = {.lex_state = 0, .external_lex_state = 7},
  [7266] = {.lex_state = 0, .external_lex_state = 7},
  [7267] = {.lex_state = 0, .external_lex_state = 5},
  [7268] = {.lex_state = 0, .external_lex_state = 5},
  [7269] = {.lex_state = 0, .external_lex_state = 5},
  [7270] = {.lex_state = 85, .external_lex_state = 6},
  [7271] = {.lex_state = 85, .external_lex_state = 6},
  [7272] = {.lex_state = 85, .external_lex_state = 6},
  [7273] = {.lex_state = 0, .external_lex_state = 11},
  [7274] = {.lex_state = 85, .external_lex_state = 7},
  [7275] = {.lex_state = 0, .external_lex_state = 7},
  [7276] = {.lex_state = 85, .external_lex_state = 6},
  [7277] = {.lex_state = 0, .external_lex_state = 5},
  [7278] = {.lex_state = 0, .external_lex_state = 5},
  [7279] = {.lex_state = 0, .external_lex_state = 5},
  [7280] = {.lex_state = 85, .external_lex_state = 7},
  [7281] = {.lex_state = 0, .external_lex_state = 5},
  [7282] = {.lex_state = 0, .external_lex_state = 7},
  [7283] = {.lex_state = 0, .external_lex_state = 5},
  [7284] = {.lex_state = 0, .external_lex_state = 5},
  [7285] = {.lex_state = 0, .external_lex_state = 5},
  [7286] = {.lex_state = 0, .external_lex_state = 5},
  [7287] = {.lex_state = 0, .external_lex_state = 7},
  [7288] = {.lex_state = 0, .external_lex_state = 7},
  [7289] = {.lex_state = 0, .external_lex_state = 11},
  [7290] = {.lex_state = 0, .external_lex_state = 7},
  [7291] = {.lex_state = 0, .external_lex_state = 5},
  [7292] = {.lex_state = 0, .external_lex_state = 7},
  [7293] = {.lex_state = 0, .external_lex_state = 5},
  [7294] = {.lex_state = 0, .external_lex_state = 5},
  [7295] = {.lex_state = 0, .external_lex_state = 7},
  [7296] = {.lex_state = 0, .external_lex_state = 7},
  [7297] = {.lex_state = 0, .external_lex_state = 5},
  [7298] = {.lex_state = 0, .external_lex_state = 5},
  [7299] = {.lex_state = 0, .external_lex_state = 7},
  [7300] = {.lex_state = 0, .external_lex_state = 7},
  [7301] = {.lex_state = 0, .external_lex_state = 5},
  [7302] = {.lex_state = 0, .external_lex_state = 7},
  [7303] = {.lex_state = 0, .external_lex_state = 5},
  [7304] = {.lex_state = 0, .external_lex_state = 5},
  [7305] = {.lex_state = 0, .external_lex_state = 7},
  [7306] = {.lex_state = 0, .external_lex_state = 7},
  [7307] = {.lex_state = 0, .external_lex_state = 7},
  [7308] = {.lex_state = 0, .external_lex_state = 5},
  [7309] = {.lex_state = 0, .external_lex_state = 5},
  [7310] = {.lex_state = 0, .external_lex_state = 11},
  [7311] = {.lex_state = 0, .external_lex_state = 6},
  [7312] = {.lex_state = 85, .external_lex_state = 7},
  [7313] = {.lex_state = 0, .external_lex_state = 11},
  [7314] = {.lex_state = 0, .external_lex_state = 5},
  [7315] = {.lex_state = 0, .external_lex_state = 7},
  [7316] = {.lex_state = 0, .external_lex_state = 7},
  [7317] = {.lex_state = 0, .external_lex_state = 7},
  [7318] = {.lex_state = 85, .external_lex_state = 7},
  [7319] = {.lex_state = 0, .external_lex_state = 7},
  [7320] = {.lex_state = 0, .external_lex_state = 5},
  [7321] = {.lex_state = 0, .external_lex_state = 7},
  [7322] = {.lex_state = 0, .external_lex_state = 7},
  [7323] = {.lex_state = 0, .external_lex_state = 5},
  [7324] = {.lex_state = 0, .external_lex_state = 7},
  [7325] = {.lex_state = 0, .external_lex_state = 5},
  [7326] = {.lex_state = 0, .external_lex_state = 5},
  [7327] = {.lex_state = 0, .external_lex_state = 5},
  [7328] = {.lex_state = 0, .external_lex_state = 5},
  [7329] = {.lex_state = 0, .external_lex_state = 7},
  [7330] = {.lex_state = 0, .external_lex_state = 6},
  [7331] = {.lex_state = 0, .external_lex_state = 7},
  [7332] = {.lex_state = 0, .external_lex_state = 7},
  [7333] = {.lex_state = 0, .external_lex_state = 7},
  [7334] = {.lex_state = 0, .external_lex_state = 5},
  [7335] = {.lex_state = 0, .external_lex_state = 11},
  [7336] = {.lex_state = 0, .external_lex_state = 7},
  [7337] = {.lex_state = 87, .external_lex_state = 7},
  [7338] = {.lex_state = 0, .external_lex_state = 7},
  [7339] = {.lex_state = 0, .external_lex_state = 5},
  [7340] = {.lex_state = 0, .external_lex_state = 5},
  [7341] = {.lex_state = 0, .external_lex_state = 7},
  [7342] = {.lex_state = 0, .external_lex_state = 5},
  [7343] = {.lex_state = 0, .external_lex_state = 5},
  [7344] = {.lex_state = 0, .external_lex_state = 7},
  [7345] = {.lex_state = 0, .external_lex_state = 7},
  [7346] = {.lex_state = 0, .external_lex_state = 5},
  [7347] = {.lex_state = 0, .external_lex_state = 7},
  [7348] = {.lex_state = 0, .external_lex_state = 7},
  [7349] = {.lex_state = 0, .external_lex_state = 5},
  [7350] = {.lex_state = 0, .external_lex_state = 5},
  [7351] = {.lex_state = 0, .external_lex_state = 5},
  [7352] = {.lex_state = 0, .external_lex_state = 7},
  [7353] = {.lex_state = 0, .external_lex_state = 5},
  [7354] = {.lex_state = 0, .external_lex_state = 5},
  [7355] = {.lex_state = 0, .external_lex_state = 7},
  [7356] = {.lex_state = 0, .external_lex_state = 5},
  [7357] = {.lex_state = 0, .external_lex_state = 5},
  [7358] = {.lex_state = 0, .external_lex_state = 7},
  [7359] = {.lex_state = 0, .external_lex_state = 5},
  [7360] = {.lex_state = 0, .external_lex_state = 5},
  [7361] = {.lex_state = 0, .external_lex_state = 11},
  [7362] = {.lex_state = 0, .external_lex_state = 7},
  [7363] = {.lex_state = 0, .external_lex_state = 7},
  [7364] = {.lex_state = 0, .external_lex_state = 5},
  [7365] = {.lex_state = 0, .external_lex_state = 5},
  [7366] = {.lex_state = 0, .external_lex_state = 5},
  [7367] = {.lex_state = 85, .external_lex_state = 7},
  [7368] = {.lex_state = 0, .external_lex_state = 11},
  [7369] = {.lex_state = 0, .external_lex_state = 7},
  [7370] = {.lex_state = 0, .external_lex_state = 7},
  [7371] = {.lex_state = 0, .external_lex_state = 5},
  [7372] = {.lex_state = 85, .external_lex_state = 6},
  [7373] = {.lex_state = 85, .external_lex_state = 6},
  [7374] = {.lex_state = 0, .external_lex_state = 6},
  [7375] = {.lex_state = 0, .external_lex_state = 7},
  [7376] = {.lex_state = 0, .external_lex_state = 5},
  [7377] = {.lex_state = 0, .external_lex_state = 7},
  [7378] = {.lex_state = 0, .external_lex_state = 5},
  [7379] = {.lex_state = 0, .external_lex_state = 5},
  [7380] = {.lex_state = 0, .external_lex_state = 7},
  [7381] = {.lex_state = 0, .external_lex_state = 5},
  [7382] = {.lex_state = 0, .external_lex_state = 7},
  [7383] = {.lex_state = 0, .external_lex_state = 5},
  [7384] = {.lex_state = 0, .external_lex_state = 7},
  [7385] = {.lex_state = 0, .external_lex_state = 7},
  [7386] = {.lex_state = 85, .external_lex_state = 6},
  [7387] = {.lex_state = 85, .external_lex_state = 6},
  [7388] = {.lex_state = 2, .external_lex_state = 11},
  [7389] = {.lex_state = 0, .external_lex_state = 7},
  [7390] = {.lex_state = 0, .external_lex_state = 7},
  [7391] = {.lex_state = 2, .external_lex_state = 11},
  [7392] = {.lex_state = 0, .external_lex_state = 7},
  [7393] = {.lex_state = 0, .external_lex_state = 6},
  [7394] = {.lex_state = 0, .external_lex_state = 7},
  [7395] = {.lex_state = 85, .external_lex_state = 6},
  [7396] = {.lex_state = 0, .external_lex_state = 7},
  [7397] = {.lex_state = 85, .external_lex_state = 6},
  [7398] = {.lex_state = 85, .external_lex_state = 6},
  [7399] = {.lex_state = 0, .external_lex_state = 7},
  [7400] = {.lex_state = 85, .external_lex_state = 6},
  [7401] = {.lex_state = 0, .external_lex_state = 7},
  [7402] = {.lex_state = 0, .external_lex_state = 5},
  [7403] = {.lex_state = 85, .external_lex_state = 6},
  [7404] = {.lex_state = 0, .external_lex_state = 7},
  [7405] = {.lex_state = 85, .external_lex_state = 6},
  [7406] = {.lex_state = 0, .external_lex_state = 7},
  [7407] = {.lex_state = 85, .external_lex_state = 6},
  [7408] = {.lex_state = 85, .external_lex_state = 6},
  [7409] = {.lex_state = 2, .external_lex_state = 11},
  [7410] = {.lex_state = 0, .external_lex_state = 7},
  [7411] = {.lex_state = 0, .external_lex_state = 7},
  [7412] = {.lex_state = 0, .external_lex_state = 7},
  [7413] = {.lex_state = 85, .external_lex_state = 6},
  [7414] = {.lex_state = 85, .external_lex_state = 6},
  [7415] = {.lex_state = 0, .external_lex_state = 7},
  [7416] = {.lex_state = 0, .external_lex_state = 5},
  [7417] = {.lex_state = 85, .external_lex_state = 6},
  [7418] = {.lex_state = 0, .external_lex_state = 7},
  [7419] = {.lex_state = 85, .external_lex_state = 6},
  [7420] = {.lex_state = 2, .external_lex_state = 11},
  [7421] = {.lex_state = 85, .external_lex_state = 6},
  [7422] = {.lex_state = 0, .external_lex_state = 7},
  [7423] = {.lex_state = 85, .external_lex_state = 6},
  [7424] = {.lex_state = 0, .external_lex_state = 7},
  [7425] = {.lex_state = 85, .external_lex_state = 6},
  [7426] = {.lex_state = 85, .external_lex_state = 6},
  [7427] = {.lex_state = 85, .external_lex_state = 6},
  [7428] = {.lex_state = 0, .external_lex_state = 7},
  [7429] = {.lex_state = 85, .external_lex_state = 6},
  [7430] = {.lex_state = 0, .external_lex_state = 7},
  [7431] = {.lex_state = 2, .external_lex_state = 11},
  [7432] = {.lex_state = 0, .external_lex_state = 7},
  [7433] = {.lex_state = 0, .external_lex_state = 7},
  [7434] = {.lex_state = 85, .external_lex_state = 6},
  [7435] = {.lex_state = 0, .external_lex_state = 7},
  [7436] = {.lex_state = 85, .external_lex_state = 6},
  [7437] = {.lex_state = 0, .external_lex_state = 7},
  [7438] = {.lex_state = 0, .external_lex_state = 7},
  [7439] = {.lex_state = 0, .external_lex_state = 6},
  [7440] = {.lex_state = 0, .external_lex_state = 7},
  [7441] = {.lex_state = 0, .external_lex_state = 6},
  [7442] = {.lex_state = 0, .external_lex_state = 6},
  [7443] = {.lex_state = 2, .external_lex_state = 11},
  [7444] = {.lex_state = 85, .external_lex_state = 6},
  [7445] = {.lex_state = 2, .external_lex_state = 11},
  [7446] = {.lex_state = 0, .external_lex_state = 7},
  [7447] = {.lex_state = 0, .external_lex_state = 7},
  [7448] = {.lex_state = 2, .external_lex_state = 11},
  [7449] = {.lex_state = 85, .external_lex_state = 6},
  [7450] = {.lex_state = 85, .external_lex_state = 6},
  [7451] = {.lex_state = 0, .external_lex_state = 7},
  [7452] = {.lex_state = 0, .external_lex_state = 7},
  [7453] = {.lex_state = 85, .external_lex_state = 6},
  [7454] = {.lex_state = 2, .external_lex_state = 11},
  [7455] = {.lex_state = 0, .external_lex_state = 7},
  [7456] = {.lex_state = 0, .external_lex_state = 7},
  [7457] = {.lex_state = 0, .external_lex_state = 7},
  [7458] = {.lex_state = 0, .external_lex_state = 6},
  [7459] = {.lex_state = 0, .external_lex_state = 6},
  [7460] = {.lex_state = 0, .external_lex_state = 7},
  [7461] = {.lex_state = 15, .external_lex_state = 6},
  [7462] = {.lex_state = 0, .external_lex_state = 7},
  [7463] = {.lex_state = 85, .external_lex_state = 6},
  [7464] = {.lex_state = 85, .external_lex_state = 6},
  [7465] = {.lex_state = 2, .external_lex_state = 11},
  [7466] = {.lex_state = 0, .external_lex_state = 7},
  [7467] = {.lex_state = 0, .external_lex_state = 7},
  [7468] = {.lex_state = 0, .external_lex_state = 7},
  [7469] = {.lex_state = 85, .external_lex_state = 6},
  [7470] = {.lex_state = 0, .external_lex_state = 6},
  [7471] = {.lex_state = 0, .external_lex_state = 7},
  [7472] = {.lex_state = 0, .external_lex_state = 7},
  [7473] = {.lex_state = 0, .external_lex_state = 7},
  [7474] = {.lex_state = 0, .external_lex_state = 7},
  [7475] = {.lex_state = 15, .external_lex_state = 6},
  [7476] = {.lex_state = 2, .external_lex_state = 11},
  [7477] = {.lex_state = 0, .external_lex_state = 7},
  [7478] = {.lex_state = 0, .external_lex_state = 7},
  [7479] = {.lex_state = 0, .external_lex_state = 5},
  [7480] = {.lex_state = 0, .external_lex_state = 6},
  [7481] = {.lex_state = 0, .external_lex_state = 6},
  [7482] = {.lex_state = 15, .external_lex_state = 6},
  [7483] = {.lex_state = 0, .external_lex_state = 7},
  [7484] = {.lex_state = 0, .external_lex_state = 7},
  [7485] = {.lex_state = 85, .external_lex_state = 6},
  [7486] = {.lex_state = 85, .external_lex_state = 6},
  [7487] = {.lex_state = 0, .external_lex_state = 7},
  [7488] = {.lex_state = 0, .external_lex_state = 7},
  [7489] = {.lex_state = 0, .external_lex_state = 7},
  [7490] = {.lex_state = 0, .external_lex_state = 7},
  [7491] = {.lex_state = 0, .external_lex_state = 7},
  [7492] = {.lex_state = 85, .external_lex_state = 6},
  [7493] = {.lex_state = 0, .external_lex_state = 7},
  [7494] = {.lex_state = 0, .external_lex_state = 7},
  [7495] = {.lex_state = 85, .external_lex_state = 6},
  [7496] = {.lex_state = 0, .external_lex_state = 7},
  [7497] = {.lex_state = 85, .external_lex_state = 6},
  [7498] = {.lex_state = 0, .external_lex_state = 7},
  [7499] = {.lex_state = 0, .external_lex_state = 7},
  [7500] = {.lex_state = 85, .external_lex_state = 6},
  [7501] = {.lex_state = 85, .external_lex_state = 6},
  [7502] = {.lex_state = 0, .external_lex_state = 7},
  [7503] = {.lex_state = 0, .external_lex_state = 7},
  [7504] = {.lex_state = 2, .external_lex_state = 11},
  [7505] = {.lex_state = 0, .external_lex_state = 7},
  [7506] = {.lex_state = 0, .external_lex_state = 7},
  [7507] = {.lex_state = 0, .external_lex_state = 7},
  [7508] = {.lex_state = 2, .external_lex_state = 11},
  [7509] = {.lex_state = 85, .external_lex_state = 7},
  [7510] = {.lex_state = 0, .external_lex_state = 5},
  [7511] = {.lex_state = 85, .external_lex_state = 6},
  [7512] = {.lex_state = 0, .external_lex_state = 7},
  [7513] = {.lex_state = 0, .external_lex_state = 7},
  [7514] = {.lex_state = 0, .external_lex_state = 7},
  [7515] = {.lex_state = 0, .external_lex_state = 7},
  [7516] = {.lex_state = 2, .external_lex_state = 11},
  [7517] = {.lex_state = 0, .external_lex_state = 7},
  [7518] = {.lex_state = 2, .external_lex_state = 11},
  [7519] = {.lex_state = 0, .external_lex_state = 7},
  [7520] = {.lex_state = 0, .external_lex_state = 7},
  [7521] = {.lex_state = 15, .external_lex_state = 6},
  [7522] = {.lex_state = 2, .external_lex_state = 11},
  [7523] = {.lex_state = 2, .external_lex_state = 11},
  [7524] = {.lex_state = 2, .external_lex_state = 11},
  [7525] = {.lex_state = 0, .external_lex_state = 7},
  [7526] = {.lex_state = 0, .external_lex_state = 7},
  [7527] = {.lex_state = 0, .external_lex_state = 7},
  [7528] = {.lex_state = 15, .external_lex_state = 6},
  [7529] = {.lex_state = 85, .external_lex_state = 6},
  [7530] = {.lex_state = 85, .external_lex_state = 6},
  [7531] = {.lex_state = 85, .external_lex_state = 6},
  [7532] = {.lex_state = 0, .external_lex_state = 7},
  [7533] = {.lex_state = 0, .external_lex_state = 7},
  [7534] = {.lex_state = 85, .external_lex_state = 6},
  [7535] = {.lex_state = 0, .external_lex_state = 7},
  [7536] = {.lex_state = 0, .external_lex_state = 7},
  [7537] = {.lex_state = 0, .external_lex_state = 7},
  [7538] = {.lex_state = 85, .external_lex_state = 6},
  [7539] = {.lex_state = 0, .external_lex_state = 7},
  [7540] = {.lex_state = 2, .external_lex_state = 11},
  [7541] = {.lex_state = 2, .external_lex_state = 11},
  [7542] = {.lex_state = 85, .external_lex_state = 6},
  [7543] = {.lex_state = 15, .external_lex_state = 6},
  [7544] = {.lex_state = 0, .external_lex_state = 7},
  [7545] = {.lex_state = 85, .external_lex_state = 6},
  [7546] = {.lex_state = 0, .external_lex_state = 7},
  [7547] = {.lex_state = 0, .external_lex_state = 7},
  [7548] = {.lex_state = 2, .external_lex_state = 11},
  [7549] = {.lex_state = 85, .external_lex_state = 6},
  [7550] = {.lex_state = 0, .external_lex_state = 7},
  [7551] = {.lex_state = 85, .external_lex_state = 6},
  [7552] = {.lex_state = 0, .external_lex_state = 7},
  [7553] = {.lex_state = 0, .external_lex_state = 7},
  [7554] = {.lex_state = 0, .external_lex_state = 7},
  [7555] = {.lex_state = 85, .external_lex_state = 6},
  [7556] = {.lex_state = 0, .external_lex_state = 7},
  [7557] = {.lex_state = 0, .external_lex_state = 7},
  [7558] = {.lex_state = 0, .external_lex_state = 6},
  [7559] = {.lex_state = 2, .external_lex_state = 11},
  [7560] = {.lex_state = 0, .external_lex_state = 7},
  [7561] = {.lex_state = 85, .external_lex_state = 6},
  [7562] = {.lex_state = 0, .external_lex_state = 5},
  [7563] = {.lex_state = 0, .external_lex_state = 7},
  [7564] = {.lex_state = 0, .external_lex_state = 6},
  [7565] = {.lex_state = 0, .external_lex_state = 7},
  [7566] = {.lex_state = 0, .external_lex_state = 7},
  [7567] = {.lex_state = 0, .external_lex_state = 7},
  [7568] = {.lex_state = 0, .external_lex_state = 7},
  [7569] = {.lex_state = 0, .external_lex_state = 7},
  [7570] = {.lex_state = 0, .external_lex_state = 6},
  [7571] = {.lex_state = 2, .external_lex_state = 11},
  [7572] = {.lex_state = 85, .external_lex_state = 6},
  [7573] = {.lex_state = 0, .external_lex_state = 7},
  [7574] = {.lex_state = 0, .external_lex_state = 7},
  [7575] = {.lex_state = 0, .external_lex_state = 7},
  [7576] = {.lex_state = 85, .external_lex_state = 6},
  [7577] = {.lex_state = 0, .external_lex_state = 7},
  [7578] = {.lex_state = 2, .external_lex_state = 11},
  [7579] = {.lex_state = 15, .external_lex_state = 6},
  [7580] = {.lex_state = 0, .external_lex_state = 7},
  [7581] = {.lex_state = 85, .external_lex_state = 6},
  [7582] = {.lex_state = 2, .external_lex_state = 11},
  [7583] = {.lex_state = 15, .external_lex_state = 6},
  [7584] = {.lex_state = 85, .external_lex_state = 6},
  [7585] = {.lex_state = 2, .external_lex_state = 11},
  [7586] = {.lex_state = 0, .external_lex_state = 7},
  [7587] = {.lex_state = 85, .external_lex_state = 6},
  [7588] = {.lex_state = 0, .external_lex_state = 7},
  [7589] = {.lex_state = 2, .external_lex_state = 11},
  [7590] = {.lex_state = 0, .external_lex_state = 7},
  [7591] = {.lex_state = 85, .external_lex_state = 6},
  [7592] = {.lex_state = 0, .external_lex_state = 6},
  [7593] = {.lex_state = 15, .external_lex_state = 6},
  [7594] = {.lex_state = 0, .external_lex_state = 7},
  [7595] = {.lex_state = 0, .external_lex_state = 7},
  [7596] = {.lex_state = 0, .external_lex_state = 7},
  [7597] = {.lex_state = 0, .external_lex_state = 7},
  [7598] = {.lex_state = 0, .external_lex_state = 7},
  [7599] = {.lex_state = 0, .external_lex_state = 7},
  [7600] = {.lex_state = 0, .external_lex_state = 7},
  [7601] = {.lex_state = 0, .external_lex_state = 7},
  [7602] = {.lex_state = 0, .external_lex_state = 7},
  [7603] = {.lex_state = 0, .external_lex_state = 7},
  [7604] = {.lex_state = 0, .external_lex_state = 7},
  [7605] = {.lex_state = 0, .external_lex_state = 7},
  [7606] = {.lex_state = 0, .external_lex_state = 7},
  [7607] = {.lex_state = 0, .external_lex_state = 7},
  [7608] = {.lex_state = 0, .external_lex_state = 6},
  [7609] = {.lex_state = 0, .external_lex_state = 7},
  [7610] = {.lex_state = 0, .external_lex_state = 7},
  [7611] = {.lex_state = 0, .external_lex_state = 7},
  [7612] = {.lex_state = 0, .external_lex_state = 7},
  [7613] = {.lex_state = 0, .external_lex_state = 7},
  [7614] = {.lex_state = 0, .external_lex_state = 7},
  [7615] = {.lex_state = 0, .external_lex_state = 6},
  [7616] = {.lex_state = 0, .external_lex_state = 7},
  [7617] = {.lex_state = 0, .external_lex_state = 6},
  [7618] = {.lex_state = 0, .external_lex_state = 7},
  [7619] = {.lex_state = 0, .external_lex_state = 7},
  [7620] = {.lex_state = 0, .external_lex_state = 7},
  [7621] = {.lex_state = 0, .external_lex_state = 7},
  [7622] = {.lex_state = 0, .external_lex_state = 7},
  [7623] = {.lex_state = 0, .external_lex_state = 7},
  [7624] = {.lex_state = 0, .external_lex_state = 7},
  [7625] = {.lex_state = 0, .external_lex_state = 6},
  [7626] = {.lex_state = 0, .external_lex_state = 6},
  [7627] = {.lex_state = 0, .external_lex_state = 7},
  [7628] = {.lex_state = 0, .external_lex_state = 7},
  [7629] = {.lex_state = 0, .external_lex_state = 7},
  [7630] = {.lex_state = 0, .external_lex_state = 7},
  [7631] = {.lex_state = 0, .external_lex_state = 7},
  [7632] = {.lex_state = 0, .external_lex_state = 6},
  [7633] = {.lex_state = 0, .external_lex_state = 7},
  [7634] = {.lex_state = 0, .external_lex_state = 7},
  [7635] = {.lex_state = 0, .external_lex_state = 6},
  [7636] = {.lex_state = 0, .external_lex_state = 7},
  [7637] = {.lex_state = 0, .external_lex_state = 7},
  [7638] = {.lex_state = 0, .external_lex_state = 7},
  [7639] = {.lex_state = 0, .external_lex_state = 7},
  [7640] = {.lex_state = 0, .external_lex_state = 7},
  [7641] = {.lex_state = 0, .external_lex_state = 6},
  [7642] = {.lex_state = 0, .external_lex_state = 7},
  [7643] = {.lex_state = 0, .external_lex_state = 7},
  [7644] = {.lex_state = 0, .external_lex_state = 7},
  [7645] = {.lex_state = 0, .external_lex_state = 7},
  [7646] = {.lex_state = 0, .external_lex_state = 7},
  [7647] = {.lex_state = 0, .external_lex_state = 7},
  [7648] = {.lex_state = 0, .external_lex_state = 7},
  [7649] = {.lex_state = 0, .external_lex_state = 6},
  [7650] = {.lex_state = 0, .external_lex_state = 7},
  [7651] = {.lex_state = 0, .external_lex_state = 7},
  [7652] = {.lex_state = 21, .external_lex_state = 7},
  [7653] = {.lex_state = 0, .external_lex_state = 6},
  [7654] = {.lex_state = 0, .external_lex_state = 6},
  [7655] = {.lex_state = 0, .external_lex_state = 7},
  [7656] = {.lex_state = 0, .external_lex_state = 6},
  [7657] = {.lex_state = 0, .external_lex_state = 7},
  [7658] = {.lex_state = 0, .external_lex_state = 7},
  [7659] = {.lex_state = 0, .external_lex_state = 6},
  [7660] = {.lex_state = 0, .external_lex_state = 6},
  [7661] = {.lex_state = 0, .external_lex_state = 6},
  [7662] = {.lex_state = 0, .external_lex_state = 6},
  [7663] = {.lex_state = 21, .external_lex_state = 7},
  [7664] = {.lex_state = 0, .external_lex_state = 6},
  [7665] = {.lex_state = 0, .external_lex_state = 7},
  [7666] = {.lex_state = 0, .external_lex_state = 6},
  [7667] = {.lex_state = 0, .external_lex_state = 7},
  [7668] = {.lex_state = 0, .external_lex_state = 6},
  [7669] = {.lex_state = 0, .external_lex_state = 6},
  [7670] = {.lex_state = 0, .external_lex_state = 7},
  [7671] = {.lex_state = 0, .external_lex_state = 6},
  [7672] = {.lex_state = 0, .external_lex_state = 7},
  [7673] = {.lex_state = 21, .external_lex_state = 7},
  [7674] = {.lex_state = 0, .external_lex_state = 6},
  [7675] = {.lex_state = 0, .external_lex_state = 6},
  [7676] = {.lex_state = 0, .external_lex_state = 7},
  [7677] = {.lex_state = 0, .external_lex_state = 6},
  [7678] = {.lex_state = 0, .external_lex_state = 7},
  [7679] = {.lex_state = 0, .external_lex_state = 6},
  [7680] = {.lex_state = 0, .external_lex_state = 7},
  [7681] = {.lex_state = 0, .external_lex_state = 7},
  [7682] = {.lex_state = 0, .external_lex_state = 6},
  [7683] = {.lex_state = 0, .external_lex_state = 7},
  [7684] = {.lex_state = 0, .external_lex_state = 7},
  [7685] = {.lex_state = 0, .external_lex_state = 6},
  [7686] = {.lex_state = 0, .external_lex_state = 7},
  [7687] = {.lex_state = 0, .external_lex_state = 7},
  [7688] = {.lex_state = 0, .external_lex_state = 7},
  [7689] = {.lex_state = 0, .external_lex_state = 7},
  [7690] = {.lex_state = 0, .external_lex_state = 6},
  [7691] = {.lex_state = 0, .external_lex_state = 7},
  [7692] = {.lex_state = 0, .external_lex_state = 6},
  [7693] = {.lex_state = 0, .external_lex_state = 7},
  [7694] = {.lex_state = 0, .external_lex_state = 7},
  [7695] = {.lex_state = 0, .external_lex_state = 6},
  [7696] = {.lex_state = 0, .external_lex_state = 7},
  [7697] = {.lex_state = 0, .external_lex_state = 7},
  [7698] = {.lex_state = 0, .external_lex_state = 7},
  [7699] = {.lex_state = 0, .external_lex_state = 6},
  [7700] = {.lex_state = 0, .external_lex_state = 7},
  [7701] = {.lex_state = 21, .external_lex_state = 7},
  [7702] = {.lex_state = 0, .external_lex_state = 7},
  [7703] = {.lex_state = 0, .external_lex_state = 7},
  [7704] = {.lex_state = 0, .external_lex_state = 7},
  [7705] = {.lex_state = 0, .external_lex_state = 6},
  [7706] = {.lex_state = 0, .external_lex_state = 6},
  [7707] = {.lex_state = 0, .external_lex_state = 7},
  [7708] = {.lex_state = 0, .external_lex_state = 7},
  [7709] = {.lex_state = 0, .external_lex_state = 7},
  [7710] = {.lex_state = 0, .external_lex_state = 7},
  [7711] = {.lex_state = 0, .external_lex_state = 7},
  [7712] = {.lex_state = 0, .external_lex_state = 7},
  [7713] = {.lex_state = 0, .external_lex_state = 7},
  [7714] = {.lex_state = 85, .external_lex_state = 6},
  [7715] = {.lex_state = 0, .external_lex_state = 6},
  [7716] = {.lex_state = 0, .external_lex_state = 6},
  [7717] = {.lex_state = 0, .external_lex_state = 7},
  [7718] = {.lex_state = 0, .external_lex_state = 7},
  [7719] = {.lex_state = 21, .external_lex_state = 7},
  [7720] = {.lex_state = 0, .external_lex_state = 6},
  [7721] = {.lex_state = 0, .external_lex_state = 7},
  [7722] = {.lex_state = 0, .external_lex_state = 7},
  [7723] = {.lex_state = 0, .external_lex_state = 7},
  [7724] = {.lex_state = 0, .external_lex_state = 7},
  [7725] = {.lex_state = 85, .external_lex_state = 6},
  [7726] = {.lex_state = 0, .external_lex_state = 7},
  [7727] = {.lex_state = 0, .external_lex_state = 7},
  [7728] = {.lex_state = 0, .external_lex_state = 7},
  [7729] = {.lex_state = 0, .external_lex_state = 7},
  [7730] = {.lex_state = 0, .external_lex_state = 6},
  [7731] = {.lex_state = 21, .external_lex_state = 7},
  [7732] = {.lex_state = 21, .external_lex_state = 7},
  [7733] = {.lex_state = 0, .external_lex_state = 7},
  [7734] = {.lex_state = 0, .external_lex_state = 7},
  [7735] = {.lex_state = 0, .external_lex_state = 7},
  [7736] = {.lex_state = 21, .external_lex_state = 7},
  [7737] = {.lex_state = 0, .external_lex_state = 6},
  [7738] = {.lex_state = 0, .external_lex_state = 7},
  [7739] = {.lex_state = 0, .external_lex_state = 7},
  [7740] = {.lex_state = 0, .external_lex_state = 7},
  [7741] = {.lex_state = 0, .external_lex_state = 7},
  [7742] = {.lex_state = 0, .external_lex_state = 7},
  [7743] = {.lex_state = 0, .external_lex_state = 7},
  [7744] = {.lex_state = 0, .external_lex_state = 7},
  [7745] = {.lex_state = 0, .external_lex_state = 7},
  [7746] = {.lex_state = 0, .external_lex_state = 6},
  [7747] = {.lex_state = 0, .external_lex_state = 7},
  [7748] = {.lex_state = 0, .external_lex_state = 7},
  [7749] = {.lex_state = 0, .external_lex_state = 7},
  [7750] = {.lex_state = 0, .external_lex_state = 7},
  [7751] = {.lex_state = 0, .external_lex_state = 7},
  [7752] = {.lex_state = 0, .external_lex_state = 7},
  [7753] = {.lex_state = 0, .external_lex_state = 7},
  [7754] = {.lex_state = 0, .external_lex_state = 7},
  [7755] = {.lex_state = 0, .external_lex_state = 5},
  [7756] = {.lex_state = 0, .external_lex_state = 7},
  [7757] = {.lex_state = 0, .external_lex_state = 7},
  [7758] = {.lex_state = 0, .external_lex_state = 7},
  [7759] = {.lex_state = 0, .external_lex_state = 7},
  [7760] = {.lex_state = 0, .external_lex_state = 7},
  [7761] = {.lex_state = 0, .external_lex_state = 7},
  [7762] = {.lex_state = 0, .external_lex_state = 6},
  [7763] = {.lex_state = 0, .external_lex_state = 7},
  [7764] = {.lex_state = 0, .external_lex_state = 7},
  [7765] = {.lex_state = 0, .external_lex_state = 7},
  [7766] = {.lex_state = 0, .external_lex_state = 7},
  [7767] = {.lex_state = 0, .external_lex_state = 7},
  [7768] = {.lex_state = 0, .external_lex_state = 7},
  [7769] = {.lex_state = 0, .external_lex_state = 7},
  [7770] = {.lex_state = 21, .external_lex_state = 7},
  [7771] = {.lex_state = 0, .external_lex_state = 6},
  [7772] = {.lex_state = 0, .external_lex_state = 6},
  [7773] = {.lex_state = 0, .external_lex_state = 7},
  [7774] = {.lex_state = 0, .external_lex_state = 7},
  [7775] = {.lex_state = 0, .external_lex_state = 7},
  [7776] = {.lex_state = 0, .external_lex_state = 7},
  [7777] = {.lex_state = 0, .external_lex_state = 7},
  [7778] = {.lex_state = 0, .external_lex_state = 7},
  [7779] = {.lex_state = 0, .external_lex_state = 7},
  [7780] = {.lex_state = 0, .external_lex_state = 7},
  [7781] = {.lex_state = 0, .external_lex_state = 7},
  [7782] = {.lex_state = 0, .external_lex_state = 7},
  [7783] = {.lex_state = 0, .external_lex_state = 7},
  [7784] = {.lex_state = 0, .external_lex_state = 7},
  [7785] = {.lex_state = 0, .external_lex_state = 7},
  [7786] = {.lex_state = 0, .external_lex_state = 7},
  [7787] = {.lex_state = 0, .external_lex_state = 5},
  [7788] = {.lex_state = 0, .external_lex_state = 7},
  [7789] = {.lex_state = 0, .external_lex_state = 7},
  [7790] = {.lex_state = 0, .external_lex_state = 7},
  [7791] = {.lex_state = 0, .external_lex_state = 7},
  [7792] = {.lex_state = 0, .external_lex_state = 7},
  [7793] = {.lex_state = 0, .external_lex_state = 7},
  [7794] = {.lex_state = 0, .external_lex_state = 7},
  [7795] = {.lex_state = 0, .external_lex_state = 7},
  [7796] = {.lex_state = 0, .external_lex_state = 7},
  [7797] = {.lex_state = 0, .external_lex_state = 7},
  [7798] = {.lex_state = 0, .external_lex_state = 7},
  [7799] = {.lex_state = 0, .external_lex_state = 7},
  [7800] = {.lex_state = 0, .external_lex_state = 7},
  [7801] = {.lex_state = 0, .external_lex_state = 7},
  [7802] = {.lex_state = 0, .external_lex_state = 7},
  [7803] = {.lex_state = 0, .external_lex_state = 7},
  [7804] = {.lex_state = 0, .external_lex_state = 6},
  [7805] = {.lex_state = 0, .external_lex_state = 7},
  [7806] = {.lex_state = 0, .external_lex_state = 7},
  [7807] = {.lex_state = 0, .external_lex_state = 7},
  [7808] = {.lex_state = 0, .external_lex_state = 7},
  [7809] = {.lex_state = 0, .external_lex_state = 7},
  [7810] = {.lex_state = 0, .external_lex_state = 7},
  [7811] = {.lex_state = 0, .external_lex_state = 7},
  [7812] = {.lex_state = 0, .external_lex_state = 7},
  [7813] = {.lex_state = 0, .external_lex_state = 7},
  [7814] = {.lex_state = 0, .external_lex_state = 6},
  [7815] = {.lex_state = 0, .external_lex_state = 7},
  [7816] = {.lex_state = 0, .external_lex_state = 7},
  [7817] = {.lex_state = 0, .external_lex_state = 7},
  [7818] = {.lex_state = 0, .external_lex_state = 7},
  [7819] = {.lex_state = 0, .external_lex_state = 7},
  [7820] = {.lex_state = 0, .external_lex_state = 7},
  [7821] = {.lex_state = 0, .external_lex_state = 7},
  [7822] = {.lex_state = 0, .external_lex_state = 7},
  [7823] = {.lex_state = 0, .external_lex_state = 7},
  [7824] = {.lex_state = 0, .external_lex_state = 7},
  [7825] = {.lex_state = 0, .external_lex_state = 7},
  [7826] = {.lex_state = 0, .external_lex_state = 7},
  [7827] = {.lex_state = 0, .external_lex_state = 7},
  [7828] = {.lex_state = 0, .external_lex_state = 7},
  [7829] = {.lex_state = 0, .external_lex_state = 7},
  [7830] = {.lex_state = 0, .external_lex_state = 7},
  [7831] = {.lex_state = 0, .external_lex_state = 7},
  [7832] = {.lex_state = 0, .external_lex_state = 7},
  [7833] = {.lex_state = 0, .external_lex_state = 7},
  [7834] = {.lex_state = 0, .external_lex_state = 7},
  [7835] = {.lex_state = 0, .external_lex_state = 7},
  [7836] = {.lex_state = 0, .external_lex_state = 7},
  [7837] = {.lex_state = 0, .external_lex_state = 7},
  [7838] = {.lex_state = 0, .external_lex_state = 6},
  [7839] = {.lex_state = 0, .external_lex_state = 7},
  [7840] = {.lex_state = 0, .external_lex_state = 7},
  [7841] = {.lex_state = 0, .external_lex_state = 7},
  [7842] = {.lex_state = 0, .external_lex_state = 7},
  [7843] = {.lex_state = 0, .external_lex_state = 7},
  [7844] = {.lex_state = 0, .external_lex_state = 7},
  [7845] = {.lex_state = 0, .external_lex_state = 7},
  [7846] = {.lex_state = 0, .external_lex_state = 6},
  [7847] = {.lex_state = 0, .external_lex_state = 7},
  [7848] = {.lex_state = 0, .external_lex_state = 7},
  [7849] = {.lex_state = 0, .external_lex_state = 7},
  [7850] = {.lex_state = 0, .external_lex_state = 7},
  [7851] = {.lex_state = 0, .external_lex_state = 7},
  [7852] = {.lex_state = 0, .external_lex_state = 7},
  [7853] = {.lex_state = 0, .external_lex_state = 7},
  [7854] = {.lex_state = 0, .external_lex_state = 7},
  [7855] = {.lex_state = 0, .external_lex_state = 7},
  [7856] = {.lex_state = 0, .external_lex_state = 6},
  [7857] = {.lex_state = 0, .external_lex_state = 7},
  [7858] = {.lex_state = 0, .external_lex_state = 7},
  [7859] = {.lex_state = 0, .external_lex_state = 7},
  [7860] = {.lex_state = 0, .external_lex_state = 7},
  [7861] = {.lex_state = 0, .external_lex_state = 7},
  [7862] = {.lex_state = 0, .external_lex_state = 7},
  [7863] = {.lex_state = 0, .external_lex_state = 7},
  [7864] = {.lex_state = 0, .external_lex_state = 7},
  [7865] = {.lex_state = 0, .external_lex_state = 6},
  [7866] = {.lex_state = 0, .external_lex_state = 7},
  [7867] = {.lex_state = 0, .external_lex_state = 7},
  [7868] = {.lex_state = 0, .external_lex_state = 7},
  [7869] = {.lex_state = 0, .external_lex_state = 7},
  [7870] = {.lex_state = 0, .external_lex_state = 7},
  [7871] = {.lex_state = 0, .external_lex_state = 7},
  [7872] = {.lex_state = 0, .external_lex_state = 7},
  [7873] = {.lex_state = 85, .external_lex_state = 7},
  [7874] = {.lex_state = 0, .external_lex_state = 7},
  [7875] = {.lex_state = 0, .external_lex_state = 7},
  [7876] = {.lex_state = 0, .external_lex_state = 7},
  [7877] = {.lex_state = 0, .external_lex_state = 7},
  [7878] = {.lex_state = 0, .external_lex_state = 7},
  [7879] = {.lex_state = 0, .external_lex_state = 7},
  [7880] = {.lex_state = 0, .external_lex_state = 7},
  [7881] = {.lex_state = 0, .external_lex_state = 7},
  [7882] = {.lex_state = 0, .external_lex_state = 7},
  [7883] = {.lex_state = 0, .external_lex_state = 7},
  [7884] = {.lex_state = 0, .external_lex_state = 7},
  [7885] = {.lex_state = 0, .external_lex_state = 7},
  [7886] = {.lex_state = 0, .external_lex_state = 7},
  [7887] = {.lex_state = 0, .external_lex_state = 7},
  [7888] = {.lex_state = 0, .external_lex_state = 6},
  [7889] = {.lex_state = 0, .external_lex_state = 7},
  [7890] = {.lex_state = 0, .external_lex_state = 7},
  [7891] = {.lex_state = 0, .external_lex_state = 7},
  [7892] = {.lex_state = 0, .external_lex_state = 7},
  [7893] = {.lex_state = 0, .external_lex_state = 7},
  [7894] = {.lex_state = 0, .external_lex_state = 7},
  [7895] = {.lex_state = 0, .external_lex_state = 7},
  [7896] = {.lex_state = 0, .external_lex_state = 7},
  [7897] = {.lex_state = 0, .external_lex_state = 6},
  [7898] = {.lex_state = 0, .external_lex_state = 7},
  [7899] = {.lex_state = 0, .external_lex_state = 7},
  [7900] = {.lex_state = 0, .external_lex_state = 7},
  [7901] = {.lex_state = 0, .external_lex_state = 7},
  [7902] = {.lex_state = 0, .external_lex_state = 7},
  [7903] = {.lex_state = 0, .external_lex_state = 7},
  [7904] = {.lex_state = 0, .external_lex_state = 7},
  [7905] = {.lex_state = 0, .external_lex_state = 7},
  [7906] = {.lex_state = 0, .external_lex_state = 7},
  [7907] = {.lex_state = 0, .external_lex_state = 7},
  [7908] = {.lex_state = 0, .external_lex_state = 7},
  [7909] = {.lex_state = 0, .external_lex_state = 7},
  [7910] = {.lex_state = 0, .external_lex_state = 7},
  [7911] = {.lex_state = 0, .external_lex_state = 7},
  [7912] = {.lex_state = 0, .external_lex_state = 7},
  [7913] = {.lex_state = 0, .external_lex_state = 7},
  [7914] = {.lex_state = 0, .external_lex_state = 7},
  [7915] = {.lex_state = 0, .external_lex_state = 7},
  [7916] = {.lex_state = 0, .external_lex_state = 7},
  [7917] = {.lex_state = 0, .external_lex_state = 7},
  [7918] = {.lex_state = 0, .external_lex_state = 7},
  [7919] = {.lex_state = 0, .external_lex_state = 7},
  [7920] = {.lex_state = 0, .external_lex_state = 7},
  [7921] = {.lex_state = 0, .external_lex_state = 7},
  [7922] = {.lex_state = 0, .external_lex_state = 7},
  [7923] = {.lex_state = 0, .external_lex_state = 7},
  [7924] = {.lex_state = 0, .external_lex_state = 7},
  [7925] = {.lex_state = 21, .external_lex_state = 7},
  [7926] = {.lex_state = 0, .external_lex_state = 6},
  [7927] = {.lex_state = 0, .external_lex_state = 7},
  [7928] = {.lex_state = 0, .external_lex_state = 7},
  [7929] = {.lex_state = 21, .external_lex_state = 7},
  [7930] = {.lex_state = 0, .external_lex_state = 7},
  [7931] = {.lex_state = 0, .external_lex_state = 7},
  [7932] = {.lex_state = 0, .external_lex_state = 7},
  [7933] = {.lex_state = 0, .external_lex_state = 7},
  [7934] = {.lex_state = 21, .external_lex_state = 7},
  [7935] = {.lex_state = 0, .external_lex_state = 6},
  [7936] = {.lex_state = 0, .external_lex_state = 7},
  [7937] = {.lex_state = 0, .external_lex_state = 7},
  [7938] = {.lex_state = 0, .external_lex_state = 7},
  [7939] = {.lex_state = 0, .external_lex_state = 6},
  [7940] = {.lex_state = 21, .external_lex_state = 7},
  [7941] = {.lex_state = 0, .external_lex_state = 7},
  [7942] = {.lex_state = 0, .external_lex_state = 7},
  [7943] = {.lex_state = 0, .external_lex_state = 6},
  [7944] = {.lex_state = 0, .external_lex_state = 7},
  [7945] = {.lex_state = 0, .external_lex_state = 7},
  [7946] = {.lex_state = 0, .external_lex_state = 7},
  [7947] = {.lex_state = 0, .external_lex_state = 7},
  [7948] = {.lex_state = 0, .external_lex_state = 7},
  [7949] = {.lex_state = 0, .external_lex_state = 7},
  [7950] = {.lex_state = 0, .external_lex_state = 7},
  [7951] = {.lex_state = 0, .external_lex_state = 7},
  [7952] = {.lex_state = 0, .external_lex_state = 7},
  [7953] = {.lex_state = 0, .external_lex_state = 7},
  [7954] = {.lex_state = 0, .external_lex_state = 7},
  [7955] = {.lex_state = 0, .external_lex_state = 6},
  [7956] = {.lex_state = 0, .external_lex_state = 7},
  [7957] = {.lex_state = 0, .external_lex_state = 7},
  [7958] = {.lex_state = 0, .external_lex_state = 7},
  [7959] = {.lex_state = 0, .external_lex_state = 7},
  [7960] = {.lex_state = 0, .external_lex_state = 7},
  [7961] = {.lex_state = 21, .external_lex_state = 7},
  [7962] = {.lex_state = 0, .external_lex_state = 7},
  [7963] = {.lex_state = 0, .external_lex_state = 7},
  [7964] = {.lex_state = 0, .external_lex_state = 7},
  [7965] = {.lex_state = 0, .external_lex_state = 7},
  [7966] = {.lex_state = 0, .external_lex_state = 7},
  [7967] = {.lex_state = 0, .external_lex_state = 7},
  [7968] = {.lex_state = 0, .external_lex_state = 7},
  [7969] = {.lex_state = 0, .external_lex_state = 7},
  [7970] = {.lex_state = 0, .external_lex_state = 7},
  [7971] = {.lex_state = 0, .external_lex_state = 7},
  [7972] = {.lex_state = 0, .external_lex_state = 7},
  [7973] = {.lex_state = 21, .external_lex_state = 7},
  [7974] = {.lex_state = 0, .external_lex_state = 7},
  [7975] = {.lex_state = 0, .external_lex_state = 6},
  [7976] = {.lex_state = 0, .external_lex_state = 7},
  [7977] = {.lex_state = 0, .external_lex_state = 7},
  [7978] = {.lex_state = 0, .external_lex_state = 7},
  [7979] = {.lex_state = 0, .external_lex_state = 7},
  [7980] = {.lex_state = 85, .external_lex_state = 6},
  [7981] = {.lex_state = 0, .external_lex_state = 7},
  [7982] = {.lex_state = 21, .external_lex_state = 7},
  [7983] = {.lex_state = 0, .external_lex_state = 7},
  [7984] = {.lex_state = 0, .external_lex_state = 7},
  [7985] = {.lex_state = 0, .external_lex_state = 7},
  [7986] = {.lex_state = 0, .external_lex_state = 7},
  [7987] = {.lex_state = 0, .external_lex_state = 7},
  [7988] = {.lex_state = 0, .external_lex_state = 7},
  [7989] = {.lex_state = 0, .external_lex_state = 7},
  [7990] = {.lex_state = 0, .external_lex_state = 7},
  [7991] = {.lex_state = 0, .external_lex_state = 7},
  [7992] = {.lex_state = 0, .external_lex_state = 7},
  [7993] = {.lex_state = 0, .external_lex_state = 7},
  [7994] = {.lex_state = 0, .external_lex_state = 7},
  [7995] = {.lex_state = 0, .external_lex_state = 7},
  [7996] = {.lex_state = 0, .external_lex_state = 7},
  [7997] = {.lex_state = 0, .external_lex_state = 7},
  [7998] = {.lex_state = 0, .external_lex_state = 7},
  [7999] = {.lex_state = 0, .external_lex_state = 7},
  [8000] = {.lex_state = 0, .external_lex_state = 7},
  [8001] = {.lex_state = 0, .external_lex_state = 7},
  [8002] = {.lex_state = 0, .external_lex_state = 7},
  [8003] = {.lex_state = 0, .external_lex_state = 6},
  [8004] = {.lex_state = 0, .external_lex_state = 7},
  [8005] = {.lex_state = 0, .external_lex_state = 7},
  [8006] = {.lex_state = 0, .external_lex_state = 7},
  [8007] = {.lex_state = 21, .external_lex_state = 7},
  [8008] = {.lex_state = 0, .external_lex_state = 7},
  [8009] = {.lex_state = 0, .external_lex_state = 7},
  [8010] = {.lex_state = 0, .external_lex_state = 7},
  [8011] = {.lex_state = 0, .external_lex_state = 7},
  [8012] = {.lex_state = 0, .external_lex_state = 7},
  [8013] = {.lex_state = 0, .external_lex_state = 7},
  [8014] = {.lex_state = 0, .external_lex_state = 7},
  [8015] = {.lex_state = 0, .external_lex_state = 7},
  [8016] = {.lex_state = 0, .external_lex_state = 7},
  [8017] = {.lex_state = 0, .external_lex_state = 7},
  [8018] = {.lex_state = 0, .external_lex_state = 7},
  [8019] = {.lex_state = 0, .external_lex_state = 7},
  [8020] = {.lex_state = 85, .external_lex_state = 6},
  [8021] = {.lex_state = 0, .external_lex_state = 7},
  [8022] = {.lex_state = 0, .external_lex_state = 7},
  [8023] = {.lex_state = 0, .external_lex_state = 7},
  [8024] = {.lex_state = 0, .external_lex_state = 7},
  [8025] = {.lex_state = 0, .external_lex_state = 7},
  [8026] = {.lex_state = 0, .external_lex_state = 7},
  [8027] = {.lex_state = 0, .external_lex_state = 7},
  [8028] = {.lex_state = 0, .external_lex_state = 7},
  [8029] = {.lex_state = 0, .external_lex_state = 7},
  [8030] = {.lex_state = 0, .external_lex_state = 7},
  [8031] = {.lex_state = 0, .external_lex_state = 7},
  [8032] = {.lex_state = 0, .external_lex_state = 7},
  [8033] = {.lex_state = 0, .external_lex_state = 6},
  [8034] = {.lex_state = 0, .external_lex_state = 7},
  [8035] = {.lex_state = 0, .external_lex_state = 7},
  [8036] = {.lex_state = 0, .external_lex_state = 7},
  [8037] = {.lex_state = 0, .external_lex_state = 7},
  [8038] = {.lex_state = 0, .external_lex_state = 7},
  [8039] = {.lex_state = 15, .external_lex_state = 6},
  [8040] = {.lex_state = 0, .external_lex_state = 7},
  [8041] = {.lex_state = 0, .external_lex_state = 7},
  [8042] = {.lex_state = 0, .external_lex_state = 6},
  [8043] = {.lex_state = 0, .external_lex_state = 7},
  [8044] = {.lex_state = 0, .external_lex_state = 7},
  [8045] = {.lex_state = 0, .external_lex_state = 7},
  [8046] = {.lex_state = 0, .external_lex_state = 7},
  [8047] = {.lex_state = 0, .external_lex_state = 7},
  [8048] = {.lex_state = 0, .external_lex_state = 7},
  [8049] = {.lex_state = 0, .external_lex_state = 7},
  [8050] = {.lex_state = 0, .external_lex_state = 7},
  [8051] = {.lex_state = 0, .external_lex_state = 7},
  [8052] = {.lex_state = 0, .external_lex_state = 7},
  [8053] = {.lex_state = 0, .external_lex_state = 7},
  [8054] = {.lex_state = 0, .external_lex_state = 7},
  [8055] = {.lex_state = 0, .external_lex_state = 7},
  [8056] = {.lex_state = 0, .external_lex_state = 5},
  [8057] = {.lex_state = 0, .external_lex_state = 7},
  [8058] = {.lex_state = 0, .external_lex_state = 7},
  [8059] = {.lex_state = 0, .external_lex_state = 7},
  [8060] = {.lex_state = 0, .external_lex_state = 7},
  [8061] = {.lex_state = 0, .external_lex_state = 7},
  [8062] = {.lex_state = 0, .external_lex_state = 7},
  [8063] = {.lex_state = 0, .external_lex_state = 7},
  [8064] = {.lex_state = 0, .external_lex_state = 7},
  [8065] = {.lex_state = 0, .external_lex_state = 7},
  [8066] = {.lex_state = 0, .external_lex_state = 7},
  [8067] = {.lex_state = 0, .external_lex_state = 7},
  [8068] = {.lex_state = 0, .external_lex_state = 6},
  [8069] = {.lex_state = 0, .external_lex_state = 7},
  [8070] = {.lex_state = 0, .external_lex_state = 7},
  [8071] = {.lex_state = 0, .external_lex_state = 7},
  [8072] = {.lex_state = 0, .external_lex_state = 7},
  [8073] = {.lex_state = 0, .external_lex_state = 7},
  [8074] = {.lex_state = 0, .external_lex_state = 7},
  [8075] = {.lex_state = 0, .external_lex_state = 7},
  [8076] = {.lex_state = 0, .external_lex_state = 7},
  [8077] = {.lex_state = 0, .external_lex_state = 7},
  [8078] = {.lex_state = 0, .external_lex_state = 7},
  [8079] = {.lex_state = 0, .external_lex_state = 7},
  [8080] = {.lex_state = 0, .external_lex_state = 7},
  [8081] = {.lex_state = 0, .external_lex_state = 6},
  [8082] = {.lex_state = 0, .external_lex_state = 7},
  [8083] = {.lex_state = 0, .external_lex_state = 6},
  [8084] = {.lex_state = 0, .external_lex_state = 7},
  [8085] = {.lex_state = 0, .external_lex_state = 7},
  [8086] = {.lex_state = 0, .external_lex_state = 7},
  [8087] = {.lex_state = 0, .external_lex_state = 7},
  [8088] = {.lex_state = 0, .external_lex_state = 6},
  [8089] = {.lex_state = 0, .external_lex_state = 7},
  [8090] = {.lex_state = 0, .external_lex_state = 6},
  [8091] = {.lex_state = 0, .external_lex_state = 6},
  [8092] = {.lex_state = 0, .external_lex_state = 7},
  [8093] = {.lex_state = 0, .external_lex_state = 7},
  [8094] = {.lex_state = 0, .external_lex_state = 7},
  [8095] = {.lex_state = 0, .external_lex_state = 6},
  [8096] = {.lex_state = 0, .external_lex_state = 7},
  [8097] = {.lex_state = 21, .external_lex_state = 7},
  [8098] = {.lex_state = 0, .external_lex_state = 7},
  [8099] = {.lex_state = 0, .external_lex_state = 7},
  [8100] = {.lex_state = 0, .external_lex_state = 6},
  [8101] = {.lex_state = 0, .external_lex_state = 7},
  [8102] = {.lex_state = 0, .external_lex_state = 7},
  [8103] = {.lex_state = 0, .external_lex_state = 7},
  [8104] = {.lex_state = 0, .external_lex_state = 7},
  [8105] = {.lex_state = 0, .external_lex_state = 7},
  [8106] = {.lex_state = 0, .external_lex_state = 7},
  [8107] = {.lex_state = 0, .external_lex_state = 7},
  [8108] = {.lex_state = 0, .external_lex_state = 6},
  [8109] = {.lex_state = 0, .external_lex_state = 7},
  [8110] = {.lex_state = 0, .external_lex_state = 7},
  [8111] = {.lex_state = 0, .external_lex_state = 7},
  [8112] = {.lex_state = 0, .external_lex_state = 7},
  [8113] = {.lex_state = 0, .external_lex_state = 7},
  [8114] = {.lex_state = 0, .external_lex_state = 7},
  [8115] = {.lex_state = 0, .external_lex_state = 7},
  [8116] = {.lex_state = 0, .external_lex_state = 7},
  [8117] = {.lex_state = 0, .external_lex_state = 7},
  [8118] = {.lex_state = 0, .external_lex_state = 7},
  [8119] = {.lex_state = 0, .external_lex_state = 7},
  [8120] = {.lex_state = 0, .external_lex_state = 7},
  [8121] = {.lex_state = 0, .external_lex_state = 7},
  [8122] = {.lex_state = 0, .external_lex_state = 7},
  [8123] = {.lex_state = 0, .external_lex_state = 7},
  [8124] = {.lex_state = 0, .external_lex_state = 7},
  [8125] = {.lex_state = 0, .external_lex_state = 7},
  [8126] = {.lex_state = 85, .external_lex_state = 6},
  [8127] = {.lex_state = 0, .external_lex_state = 6},
  [8128] = {.lex_state = 0, .external_lex_state = 7},
  [8129] = {.lex_state = 0, .external_lex_state = 7},
  [8130] = {.lex_state = 0, .external_lex_state = 7},
  [8131] = {.lex_state = 0, .external_lex_state = 7},
  [8132] = {.lex_state = 0, .external_lex_state = 7},
  [8133] = {.lex_state = 0, .external_lex_state = 7},
  [8134] = {.lex_state = 0, .external_lex_state = 7},
  [8135] = {.lex_state = 0, .external_lex_state = 7},
  [8136] = {.lex_state = 21, .external_lex_state = 7},
  [8137] = {.lex_state = 0, .external_lex_state = 6},
  [8138] = {.lex_state = 0, .external_lex_state = 7},
  [8139] = {.lex_state = 0, .external_lex_state = 7},
  [8140] = {.lex_state = 0, .external_lex_state = 7},
  [8141] = {.lex_state = 0, .external_lex_state = 7},
  [8142] = {.lex_state = 0, .external_lex_state = 7},
  [8143] = {.lex_state = 0, .external_lex_state = 7},
  [8144] = {.lex_state = 0, .external_lex_state = 7},
  [8145] = {.lex_state = 0, .external_lex_state = 7},
  [8146] = {.lex_state = 0, .external_lex_state = 7},
  [8147] = {.lex_state = 0, .external_lex_state = 7},
  [8148] = {.lex_state = 0, .external_lex_state = 7},
  [8149] = {.lex_state = 0, .external_lex_state = 7},
  [8150] = {.lex_state = 0, .external_lex_state = 7},
  [8151] = {.lex_state = 0, .external_lex_state = 7},
  [8152] = {.lex_state = 0, .external_lex_state = 7},
  [8153] = {.lex_state = 0, .external_lex_state = 7},
  [8154] = {.lex_state = 0, .external_lex_state = 7},
  [8155] = {.lex_state = 0, .external_lex_state = 7},
  [8156] = {.lex_state = 0, .external_lex_state = 7},
  [8157] = {.lex_state = 0, .external_lex_state = 7},
  [8158] = {.lex_state = 0, .external_lex_state = 7},
  [8159] = {.lex_state = 0, .external_lex_state = 7},
  [8160] = {.lex_state = 0, .external_lex_state = 7},
  [8161] = {.lex_state = 0, .external_lex_state = 7},
  [8162] = {.lex_state = 0, .external_lex_state = 7},
  [8163] = {.lex_state = 0, .external_lex_state = 7},
  [8164] = {.lex_state = 0, .external_lex_state = 7},
  [8165] = {.lex_state = 0, .external_lex_state = 7},
  [8166] = {.lex_state = 0, .external_lex_state = 7},
  [8167] = {.lex_state = 0, .external_lex_state = 7},
  [8168] = {.lex_state = 0, .external_lex_state = 7},
  [8169] = {.lex_state = 0, .external_lex_state = 7},
  [8170] = {.lex_state = 0, .external_lex_state = 7},
  [8171] = {.lex_state = 0, .external_lex_state = 7},
  [8172] = {.lex_state = 0, .external_lex_state = 7},
  [8173] = {.lex_state = 0, .external_lex_state = 7},
  [8174] = {.lex_state = 0, .external_lex_state = 7},
  [8175] = {.lex_state = 0, .external_lex_state = 7},
  [8176] = {.lex_state = 0, .external_lex_state = 7},
  [8177] = {.lex_state = 0, .external_lex_state = 7},
  [8178] = {.lex_state = 0, .external_lex_state = 7},
  [8179] = {.lex_state = 0, .external_lex_state = 7},
  [8180] = {.lex_state = 0, .external_lex_state = 7},
  [8181] = {.lex_state = 0, .external_lex_state = 6},
  [8182] = {.lex_state = 0, .external_lex_state = 7},
  [8183] = {.lex_state = 0, .external_lex_state = 7},
  [8184] = {.lex_state = 0, .external_lex_state = 7},
  [8185] = {.lex_state = 0, .external_lex_state = 7},
  [8186] = {.lex_state = 0, .external_lex_state = 7},
  [8187] = {.lex_state = 0, .external_lex_state = 7},
  [8188] = {.lex_state = 0, .external_lex_state = 7},
  [8189] = {.lex_state = 0, .external_lex_state = 7},
  [8190] = {.lex_state = 0, .external_lex_state = 7},
  [8191] = {.lex_state = 0, .external_lex_state = 7},
  [8192] = {.lex_state = 0, .external_lex_state = 7},
  [8193] = {.lex_state = 21, .external_lex_state = 7},
  [8194] = {.lex_state = 0, .external_lex_state = 7},
  [8195] = {.lex_state = 0, .external_lex_state = 7},
  [8196] = {.lex_state = 0, .external_lex_state = 7},
  [8197] = {.lex_state = 0, .external_lex_state = 7},
  [8198] = {.lex_state = 0, .external_lex_state = 7},
  [8199] = {.lex_state = 0, .external_lex_state = 7},
  [8200] = {.lex_state = 0, .external_lex_state = 7},
  [8201] = {.lex_state = 0, .external_lex_state = 7},
  [8202] = {.lex_state = 0, .external_lex_state = 7},
  [8203] = {.lex_state = 0, .external_lex_state = 7},
  [8204] = {.lex_state = 0, .external_lex_state = 7},
  [8205] = {.lex_state = 0, .external_lex_state = 7},
  [8206] = {.lex_state = 0, .external_lex_state = 7},
  [8207] = {.lex_state = 0, .external_lex_state = 7},
  [8208] = {.lex_state = 0, .external_lex_state = 7},
  [8209] = {.lex_state = 0, .external_lex_state = 7},
  [8210] = {.lex_state = 0, .external_lex_state = 7},
  [8211] = {.lex_state = 0, .external_lex_state = 7},
  [8212] = {.lex_state = 0, .external_lex_state = 7},
  [8213] = {.lex_state = 0, .external_lex_state = 7},
  [8214] = {.lex_state = 0, .external_lex_state = 7},
  [8215] = {.lex_state = 0, .external_lex_state = 7},
  [8216] = {.lex_state = 0, .external_lex_state = 7},
  [8217] = {.lex_state = 0, .external_lex_state = 7},
  [8218] = {.lex_state = 0, .external_lex_state = 7},
  [8219] = {.lex_state = 0, .external_lex_state = 7},
  [8220] = {.lex_state = 0, .external_lex_state = 7},
  [8221] = {.lex_state = 0, .external_lex_state = 7},
  [8222] = {.lex_state = 0, .external_lex_state = 7},
  [8223] = {.lex_state = 0, .external_lex_state = 7},
  [8224] = {.lex_state = 0, .external_lex_state = 7},
  [8225] = {.lex_state = 0, .external_lex_state = 7},
  [8226] = {.lex_state = 0, .external_lex_state = 7},
  [8227] = {.lex_state = 0, .external_lex_state = 7},
  [8228] = {.lex_state = 0, .external_lex_state = 7},
  [8229] = {.lex_state = 0, .external_lex_state = 7},
  [8230] = {.lex_state = 0, .external_lex_state = 7},
  [8231] = {.lex_state = 85, .external_lex_state = 6},
  [8232] = {.lex_state = 0, .external_lex_state = 7},
  [8233] = {.lex_state = 0, .external_lex_state = 7},
  [8234] = {.lex_state = 0, .external_lex_state = 7},
  [8235] = {.lex_state = 0, .external_lex_state = 7},
  [8236] = {.lex_state = 0, .external_lex_state = 7},
  [8237] = {.lex_state = 0, .external_lex_state = 7},
  [8238] = {.lex_state = 0, .external_lex_state = 7},
  [8239] = {.lex_state = 0, .external_lex_state = 7},
  [8240] = {.lex_state = 0, .external_lex_state = 6},
  [8241] = {.lex_state = 0, .external_lex_state = 7},
  [8242] = {.lex_state = 0, .external_lex_state = 7},
  [8243] = {.lex_state = 0, .external_lex_state = 7},
  [8244] = {.lex_state = 0, .external_lex_state = 6},
  [8245] = {.lex_state = 0, .external_lex_state = 7},
  [8246] = {.lex_state = 0, .external_lex_state = 7},
  [8247] = {.lex_state = 0, .external_lex_state = 7},
  [8248] = {.lex_state = 0, .external_lex_state = 7},
  [8249] = {.lex_state = 0, .external_lex_state = 7},
  [8250] = {.lex_state = 0, .external_lex_state = 7},
  [8251] = {.lex_state = 0, .external_lex_state = 7},
  [8252] = {.lex_state = 0, .external_lex_state = 7},
  [8253] = {.lex_state = 0, .external_lex_state = 7},
  [8254] = {.lex_state = 0, .external_lex_state = 7},
  [8255] = {.lex_state = 0, .external_lex_state = 7},
  [8256] = {.lex_state = 0, .external_lex_state = 7},
  [8257] = {.lex_state = 0, .external_lex_state = 7},
  [8258] = {.lex_state = 0, .external_lex_state = 7},
  [8259] = {.lex_state = 0, .external_lex_state = 7},
  [8260] = {.lex_state = 0, .external_lex_state = 7},
  [8261] = {.lex_state = 0, .external_lex_state = 7},
  [8262] = {.lex_state = 0, .external_lex_state = 5},
  [8263] = {.lex_state = 0, .external_lex_state = 7},
  [8264] = {.lex_state = 0, .external_lex_state = 7},
  [8265] = {.lex_state = 0, .external_lex_state = 7},
  [8266] = {.lex_state = 0, .external_lex_state = 7},
  [8267] = {.lex_state = 0, .external_lex_state = 7},
  [8268] = {.lex_state = 0, .external_lex_state = 7},
  [8269] = {.lex_state = 0, .external_lex_state = 7},
  [8270] = {.lex_state = 0, .external_lex_state = 7},
  [8271] = {.lex_state = 0, .external_lex_state = 7},
  [8272] = {.lex_state = 0, .external_lex_state = 7},
  [8273] = {.lex_state = 21, .external_lex_state = 7},
  [8274] = {.lex_state = 0, .external_lex_state = 7},
  [8275] = {.lex_state = 0, .external_lex_state = 7},
  [8276] = {.lex_state = 0, .external_lex_state = 7},
  [8277] = {.lex_state = 0, .external_lex_state = 7},
  [8278] = {.lex_state = 0, .external_lex_state = 7},
  [8279] = {.lex_state = 0, .external_lex_state = 7},
  [8280] = {.lex_state = 0, .external_lex_state = 7},
  [8281] = {.lex_state = 0, .external_lex_state = 7},
  [8282] = {.lex_state = 0, .external_lex_state = 7},
  [8283] = {.lex_state = 0, .external_lex_state = 7},
  [8284] = {.lex_state = 21, .external_lex_state = 7},
  [8285] = {.lex_state = 0, .external_lex_state = 7},
  [8286] = {.lex_state = 0, .external_lex_state = 7},
  [8287] = {.lex_state = 0, .external_lex_state = 7},
  [8288] = {.lex_state = 0, .external_lex_state = 7},
  [8289] = {.lex_state = 0, .external_lex_state = 7},
  [8290] = {.lex_state = 0, .external_lex_state = 7},
  [8291] = {.lex_state = 0, .external_lex_state = 7},
  [8292] = {.lex_state = 0, .external_lex_state = 7},
  [8293] = {.lex_state = 0, .external_lex_state = 7},
  [8294] = {.lex_state = 0, .external_lex_state = 7},
  [8295] = {.lex_state = 0, .external_lex_state = 7},
  [8296] = {.lex_state = 0, .external_lex_state = 7},
  [8297] = {.lex_state = 0, .external_lex_state = 7},
  [8298] = {.lex_state = 0, .external_lex_state = 7},
  [8299] = {.lex_state = 85, .external_lex_state = 6},
  [8300] = {.lex_state = 0, .external_lex_state = 7},
  [8301] = {.lex_state = 0, .external_lex_state = 7},
  [8302] = {.lex_state = 0, .external_lex_state = 7},
  [8303] = {.lex_state = 0, .external_lex_state = 7},
  [8304] = {.lex_state = 0, .external_lex_state = 7},
  [8305] = {.lex_state = 0, .external_lex_state = 7},
  [8306] = {.lex_state = 0, .external_lex_state = 7},
  [8307] = {.lex_state = 0, .external_lex_state = 6},
  [8308] = {.lex_state = 21, .external_lex_state = 7},
  [8309] = {.lex_state = 0, .external_lex_state = 7},
  [8310] = {.lex_state = 0, .external_lex_state = 7},
  [8311] = {.lex_state = 0, .external_lex_state = 7},
  [8312] = {.lex_state = 0, .external_lex_state = 7},
  [8313] = {.lex_state = 0, .external_lex_state = 7},
  [8314] = {.lex_state = 0, .external_lex_state = 7},
  [8315] = {.lex_state = 0, .external_lex_state = 7},
  [8316] = {.lex_state = 0, .external_lex_state = 7},
  [8317] = {.lex_state = 0, .external_lex_state = 7},
  [8318] = {.lex_state = 0, .external_lex_state = 7},
  [8319] = {.lex_state = 0, .external_lex_state = 7},
  [8320] = {.lex_state = 0, .external_lex_state = 7},
  [8321] = {.lex_state = 0, .external_lex_state = 7},
  [8322] = {.lex_state = 0, .external_lex_state = 7},
  [8323] = {.lex_state = 0, .external_lex_state = 7},
  [8324] = {.lex_state = 0, .external_lex_state = 7},
  [8325] = {.lex_state = 0, .external_lex_state = 7},
  [8326] = {.lex_state = 0, .external_lex_state = 7},
  [8327] = {.lex_state = 0, .external_lex_state = 7},
  [8328] = {.lex_state = 0, .external_lex_state = 7},
  [8329] = {.lex_state = 0, .external_lex_state = 7},
  [8330] = {.lex_state = 0, .external_lex_state = 7},
  [8331] = {.lex_state = 0, .external_lex_state = 7},
  [8332] = {.lex_state = 0, .external_lex_state = 7},
  [8333] = {.lex_state = 0, .external_lex_state = 7},
  [8334] = {.lex_state = 0, .external_lex_state = 7},
  [8335] = {.lex_state = 0, .external_lex_state = 7},
  [8336] = {.lex_state = 0, .external_lex_state = 7},
  [8337] = {.lex_state = 0, .external_lex_state = 7},
  [8338] = {.lex_state = 0, .external_lex_state = 7},
  [8339] = {.lex_state = 0, .external_lex_state = 7},
  [8340] = {.lex_state = 0, .external_lex_state = 7},
  [8341] = {.lex_state = 0, .external_lex_state = 7},
  [8342] = {.lex_state = 0, .external_lex_state = 7},
  [8343] = {.lex_state = 0, .external_lex_state = 7},
  [8344] = {.lex_state = 0, .external_lex_state = 7},
  [8345] = {.lex_state = 0, .external_lex_state = 7},
  [8346] = {.lex_state = 0, .external_lex_state = 7},
  [8347] = {.lex_state = 0, .external_lex_state = 6},
  [8348] = {.lex_state = 0, .external_lex_state = 7},
  [8349] = {.lex_state = 0, .external_lex_state = 7},
  [8350] = {.lex_state = 0, .external_lex_state = 7},
  [8351] = {.lex_state = 0, .external_lex_state = 7},
  [8352] = {.lex_state = 0, .external_lex_state = 7},
  [8353] = {.lex_state = 0, .external_lex_state = 7},
  [8354] = {.lex_state = 21, .external_lex_state = 7},
  [8355] = {.lex_state = 0, .external_lex_state = 7},
  [8356] = {.lex_state = 0, .external_lex_state = 6},
  [8357] = {.lex_state = 0, .external_lex_state = 7},
  [8358] = {.lex_state = 0, .external_lex_state = 7},
  [8359] = {.lex_state = 0, .external_lex_state = 5},
  [8360] = {.lex_state = 0, .external_lex_state = 7},
  [8361] = {.lex_state = 0, .external_lex_state = 7},
  [8362] = {.lex_state = 21, .external_lex_state = 7},
  [8363] = {.lex_state = 0, .external_lex_state = 7},
  [8364] = {.lex_state = 0, .external_lex_state = 7},
  [8365] = {.lex_state = 0, .external_lex_state = 7},
  [8366] = {.lex_state = 0, .external_lex_state = 7},
  [8367] = {.lex_state = 0, .external_lex_state = 7},
  [8368] = {.lex_state = 0, .external_lex_state = 7},
  [8369] = {.lex_state = 0, .external_lex_state = 7},
  [8370] = {.lex_state = 21, .external_lex_state = 7},
  [8371] = {.lex_state = 0, .external_lex_state = 7},
  [8372] = {.lex_state = 0, .external_lex_state = 7},
  [8373] = {.lex_state = 0, .external_lex_state = 7},
  [8374] = {.lex_state = 0, .external_lex_state = 7},
  [8375] = {.lex_state = 0, .external_lex_state = 7},
  [8376] = {.lex_state = 0, .external_lex_state = 6},
  [8377] = {.lex_state = 0, .external_lex_state = 6},
  [8378] = {.lex_state = 0, .external_lex_state = 7},
  [8379] = {.lex_state = 0, .external_lex_state = 7},
  [8380] = {.lex_state = 0, .external_lex_state = 7},
  [8381] = {.lex_state = 0, .external_lex_state = 7},
  [8382] = {.lex_state = 0, .external_lex_state = 7},
  [8383] = {.lex_state = 0, .external_lex_state = 7},
  [8384] = {.lex_state = 0, .external_lex_state = 7},
  [8385] = {.lex_state = 0, .external_lex_state = 7},
  [8386] = {.lex_state = 0, .external_lex_state = 7},
  [8387] = {.lex_state = 0, .external_lex_state = 7},
  [8388] = {.lex_state = 0, .external_lex_state = 7},
  [8389] = {.lex_state = 21, .external_lex_state = 7},
  [8390] = {.lex_state = 0, .external_lex_state = 7},
  [8391] = {.lex_state = 0, .external_lex_state = 7},
  [8392] = {.lex_state = 0, .external_lex_state = 7},
  [8393] = {.lex_state = 0, .external_lex_state = 7},
  [8394] = {.lex_state = 0, .external_lex_state = 7},
  [8395] = {.lex_state = 0, .external_lex_state = 7},
  [8396] = {.lex_state = 0, .external_lex_state = 7},
  [8397] = {.lex_state = 0, .external_lex_state = 7},
  [8398] = {.lex_state = 0, .external_lex_state = 7},
  [8399] = {.lex_state = 0, .external_lex_state = 7},
  [8400] = {.lex_state = 0, .external_lex_state = 7},
  [8401] = {.lex_state = 0, .external_lex_state = 7},
  [8402] = {.lex_state = 0, .external_lex_state = 7},
  [8403] = {.lex_state = 0, .external_lex_state = 7},
  [8404] = {.lex_state = 0, .external_lex_state = 7},
  [8405] = {.lex_state = 0, .external_lex_state = 7},
  [8406] = {.lex_state = 0, .external_lex_state = 7},
  [8407] = {.lex_state = 0, .external_lex_state = 7},
  [8408] = {.lex_state = 0, .external_lex_state = 7},
  [8409] = {.lex_state = 0, .external_lex_state = 7},
  [8410] = {.lex_state = 0, .external_lex_state = 7},
  [8411] = {.lex_state = 0, .external_lex_state = 7},
  [8412] = {.lex_state = 0, .external_lex_state = 7},
  [8413] = {.lex_state = 0, .external_lex_state = 7},
  [8414] = {.lex_state = 0, .external_lex_state = 7},
  [8415] = {.lex_state = 0, .external_lex_state = 7},
  [8416] = {.lex_state = 0, .external_lex_state = 7},
  [8417] = {.lex_state = 0, .external_lex_state = 7},
  [8418] = {.lex_state = 0, .external_lex_state = 7},
  [8419] = {.lex_state = 0, .external_lex_state = 7},
  [8420] = {.lex_state = 0, .external_lex_state = 7},
  [8421] = {.lex_state = 0, .external_lex_state = 7},
  [8422] = {.lex_state = 0, .external_lex_state = 7},
  [8423] = {.lex_state = 0, .external_lex_state = 7},
  [8424] = {.lex_state = 0, .external_lex_state = 7},
  [8425] = {.lex_state = 0, .external_lex_state = 7},
  [8426] = {.lex_state = 0, .external_lex_state = 7},
  [8427] = {.lex_state = 0, .external_lex_state = 7},
  [8428] = {.lex_state = 0, .external_lex_state = 7},
  [8429] = {.lex_state = 0, .external_lex_state = 7},
  [8430] = {.lex_state = 0, .external_lex_state = 7},
  [8431] = {.lex_state = 0, .external_lex_state = 7},
  [8432] = {.lex_state = 0, .external_lex_state = 7},
  [8433] = {.lex_state = 0, .external_lex_state = 7},
  [8434] = {.lex_state = 0, .external_lex_state = 7},
  [8435] = {.lex_state = 0, .external_lex_state = 7},
  [8436] = {.lex_state = 0, .external_lex_state = 7},
  [8437] = {.lex_state = 0, .external_lex_state = 7},
  [8438] = {.lex_state = 0, .external_lex_state = 7},
  [8439] = {.lex_state = 0, .external_lex_state = 7},
  [8440] = {.lex_state = 0, .external_lex_state = 7},
  [8441] = {.lex_state = 0, .external_lex_state = 7},
  [8442] = {.lex_state = 0, .external_lex_state = 7},
  [8443] = {.lex_state = 0, .external_lex_state = 7},
  [8444] = {.lex_state = 0, .external_lex_state = 7},
  [8445] = {.lex_state = 0, .external_lex_state = 7},
  [8446] = {.lex_state = 0, .external_lex_state = 7},
  [8447] = {.lex_state = 0, .external_lex_state = 7},
  [8448] = {.lex_state = 0, .external_lex_state = 7},
  [8449] = {.lex_state = 0, .external_lex_state = 7},
  [8450] = {.lex_state = 0, .external_lex_state = 7},
  [8451] = {.lex_state = 0, .external_lex_state = 7},
  [8452] = {.lex_state = 0, .external_lex_state = 7},
  [8453] = {.lex_state = 0, .external_lex_state = 7},
  [8454] = {.lex_state = 0, .external_lex_state = 7},
  [8455] = {.lex_state = 0, .external_lex_state = 7},
  [8456] = {.lex_state = 85, .external_lex_state = 6},
  [8457] = {.lex_state = 0, .external_lex_state = 7},
  [8458] = {.lex_state = 0, .external_lex_state = 7},
  [8459] = {.lex_state = 0, .external_lex_state = 7},
  [8460] = {.lex_state = 0, .external_lex_state = 7},
  [8461] = {.lex_state = 0, .external_lex_state = 7},
  [8462] = {.lex_state = 0, .external_lex_state = 7},
  [8463] = {.lex_state = 0, .external_lex_state = 7},
  [8464] = {.lex_state = 0, .external_lex_state = 7},
  [8465] = {.lex_state = 0, .external_lex_state = 7},
  [8466] = {.lex_state = 0, .external_lex_state = 7},
  [8467] = {.lex_state = 0, .external_lex_state = 7},
  [8468] = {.lex_state = 0, .external_lex_state = 7},
  [8469] = {.lex_state = 0, .external_lex_state = 7},
  [8470] = {.lex_state = 0, .external_lex_state = 7},
  [8471] = {.lex_state = 0, .external_lex_state = 7},
  [8472] = {.lex_state = 0, .external_lex_state = 7},
  [8473] = {.lex_state = 0, .external_lex_state = 7},
  [8474] = {.lex_state = 0, .external_lex_state = 7},
  [8475] = {.lex_state = 0, .external_lex_state = 7},
  [8476] = {.lex_state = 0, .external_lex_state = 7},
  [8477] = {.lex_state = 0, .external_lex_state = 7},
  [8478] = {.lex_state = 0, .external_lex_state = 7},
  [8479] = {.lex_state = 0, .external_lex_state = 7},
  [8480] = {.lex_state = 0, .external_lex_state = 7},
  [8481] = {.lex_state = 0, .external_lex_state = 7},
  [8482] = {.lex_state = 0, .external_lex_state = 7},
  [8483] = {.lex_state = 0, .external_lex_state = 7},
  [8484] = {.lex_state = 0, .external_lex_state = 7},
  [8485] = {.lex_state = 0, .external_lex_state = 7},
  [8486] = {.lex_state = 0, .external_lex_state = 7},
  [8487] = {.lex_state = 0, .external_lex_state = 7},
  [8488] = {.lex_state = 0, .external_lex_state = 7},
  [8489] = {.lex_state = 0, .external_lex_state = 7},
  [8490] = {.lex_state = 0, .external_lex_state = 7},
  [8491] = {.lex_state = 0, .external_lex_state = 7},
  [8492] = {.lex_state = 0, .external_lex_state = 7},
  [8493] = {.lex_state = 0, .external_lex_state = 7},
  [8494] = {.lex_state = 0, .external_lex_state = 7},
  [8495] = {.lex_state = 0, .external_lex_state = 7},
  [8496] = {.lex_state = 0, .external_lex_state = 7},
  [8497] = {.lex_state = 0, .external_lex_state = 7},
  [8498] = {.lex_state = 0, .external_lex_state = 7},
  [8499] = {.lex_state = 0, .external_lex_state = 7},
  [8500] = {.lex_state = 85, .external_lex_state = 6},
  [8501] = {.lex_state = 0, .external_lex_state = 7},
  [8502] = {.lex_state = 0, .external_lex_state = 7},
  [8503] = {.lex_state = 0, .external_lex_state = 7},
  [8504] = {.lex_state = 0, .external_lex_state = 7},
  [8505] = {.lex_state = 0, .external_lex_state = 7},
  [8506] = {.lex_state = 0, .external_lex_state = 7},
  [8507] = {.lex_state = 0, .external_lex_state = 7},
  [8508] = {.lex_state = 0, .external_lex_state = 7},
  [8509] = {.lex_state = 0, .external_lex_state = 7},
  [8510] = {.lex_state = 0, .external_lex_state = 7},
  [8511] = {.lex_state = 0, .external_lex_state = 7},
  [8512] = {.lex_state = 0, .external_lex_state = 7},
  [8513] = {.lex_state = 0, .external_lex_state = 7},
  [8514] = {.lex_state = 0, .external_lex_state = 7},
  [8515] = {.lex_state = 0, .external_lex_state = 7},
  [8516] = {.lex_state = 0, .external_lex_state = 7},
  [8517] = {.lex_state = 0, .external_lex_state = 7},
  [8518] = {.lex_state = 0, .external_lex_state = 7},
  [8519] = {.lex_state = 0, .external_lex_state = 7},
  [8520] = {.lex_state = 0, .external_lex_state = 7},
  [8521] = {.lex_state = 0, .external_lex_state = 7},
  [8522] = {.lex_state = 0, .external_lex_state = 7},
  [8523] = {.lex_state = 0, .external_lex_state = 7},
  [8524] = {.lex_state = 0, .external_lex_state = 7},
  [8525] = {.lex_state = 0, .external_lex_state = 7},
  [8526] = {.lex_state = 0, .external_lex_state = 7},
  [8527] = {.lex_state = 0, .external_lex_state = 7},
  [8528] = {.lex_state = 0, .external_lex_state = 7},
  [8529] = {.lex_state = 0, .external_lex_state = 7},
  [8530] = {.lex_state = 0, .external_lex_state = 7},
  [8531] = {.lex_state = 0, .external_lex_state = 7},
  [8532] = {.lex_state = 0, .external_lex_state = 7},
  [8533] = {.lex_state = 0, .external_lex_state = 7},
  [8534] = {.lex_state = 0, .external_lex_state = 7},
  [8535] = {.lex_state = 22, .external_lex_state = 7},
  [8536] = {.lex_state = 0, .external_lex_state = 6},
  [8537] = {.lex_state = 0, .external_lex_state = 7},
  [8538] = {.lex_state = 0, .external_lex_state = 7},
  [8539] = {.lex_state = 0, .external_lex_state = 7},
  [8540] = {.lex_state = 0, .external_lex_state = 6},
  [8541] = {.lex_state = 0, .external_lex_state = 7},
  [8542] = {.lex_state = 0, .external_lex_state = 7},
  [8543] = {.lex_state = 0, .external_lex_state = 7},
  [8544] = {.lex_state = 0, .external_lex_state = 7},
  [8545] = {.lex_state = 0, .external_lex_state = 7},
  [8546] = {.lex_state = 0, .external_lex_state = 7},
  [8547] = {.lex_state = 0, .external_lex_state = 7},
  [8548] = {.lex_state = 0, .external_lex_state = 7},
  [8549] = {.lex_state = 0, .external_lex_state = 7},
  [8550] = {.lex_state = 0, .external_lex_state = 7},
  [8551] = {.lex_state = 0, .external_lex_state = 7},
  [8552] = {.lex_state = 0, .external_lex_state = 6},
  [8553] = {.lex_state = 0, .external_lex_state = 7},
  [8554] = {.lex_state = 22, .external_lex_state = 7},
  [8555] = {.lex_state = 0, .external_lex_state = 7},
  [8556] = {.lex_state = 0, .external_lex_state = 7},
  [8557] = {.lex_state = 0, .external_lex_state = 7},
  [8558] = {.lex_state = 0, .external_lex_state = 7},
  [8559] = {.lex_state = 0, .external_lex_state = 7},
  [8560] = {.lex_state = 0, .external_lex_state = 7},
  [8561] = {.lex_state = 0, .external_lex_state = 7},
  [8562] = {.lex_state = 0, .external_lex_state = 7},
  [8563] = {.lex_state = 0, .external_lex_state = 7},
  [8564] = {.lex_state = 0, .external_lex_state = 7},
  [8565] = {.lex_state = 0, .external_lex_state = 7},
  [8566] = {.lex_state = 0, .external_lex_state = 6},
  [8567] = {.lex_state = 22, .external_lex_state = 7},
  [8568] = {.lex_state = 0, .external_lex_state = 7},
  [8569] = {.lex_state = 0, .external_lex_state = 7},
  [8570] = {.lex_state = 0, .external_lex_state = 7},
  [8571] = {.lex_state = 0, .external_lex_state = 7},
  [8572] = {.lex_state = 0, .external_lex_state = 7},
  [8573] = {.lex_state = 0, .external_lex_state = 7},
  [8574] = {.lex_state = 0, .external_lex_state = 7},
  [8575] = {.lex_state = 0, .external_lex_state = 6},
  [8576] = {.lex_state = 0, .external_lex_state = 7},
  [8577] = {.lex_state = 0, .external_lex_state = 7},
  [8578] = {.lex_state = 0, .external_lex_state = 7},
  [8579] = {.lex_state = 22, .external_lex_state = 7},
  [8580] = {.lex_state = 0, .external_lex_state = 7},
  [8581] = {.lex_state = 0, .external_lex_state = 7},
  [8582] = {.lex_state = 0, .external_lex_state = 7},
  [8583] = {.lex_state = 0, .external_lex_state = 6},
  [8584] = {.lex_state = 0, .external_lex_state = 7},
  [8585] = {.lex_state = 0, .external_lex_state = 7},
  [8586] = {.lex_state = 0, .external_lex_state = 7},
  [8587] = {.lex_state = 0, .external_lex_state = 6},
  [8588] = {.lex_state = 0, .external_lex_state = 6},
  [8589] = {.lex_state = 0, .external_lex_state = 7},
  [8590] = {.lex_state = 22, .external_lex_state = 7},
  [8591] = {.lex_state = 0, .external_lex_state = 7},
  [8592] = {.lex_state = 0, .external_lex_state = 7},
  [8593] = {.lex_state = 0, .external_lex_state = 7},
  [8594] = {.lex_state = 0, .external_lex_state = 7},
  [8595] = {.lex_state = 85, .external_lex_state = 6},
  [8596] = {.lex_state = 0, .external_lex_state = 7},
  [8597] = {.lex_state = 0, .external_lex_state = 7},
  [8598] = {.lex_state = 22, .external_lex_state = 7},
  [8599] = {.lex_state = 0, .external_lex_state = 6},
  [8600] = {.lex_state = 0, .external_lex_state = 6},
  [8601] = {.lex_state = 22, .external_lex_state = 7},
  [8602] = {.lex_state = 0, .external_lex_state = 7},
  [8603] = {.lex_state = 0, .external_lex_state = 7},
  [8604] = {.lex_state = 0, .external_lex_state = 7},
  [8605] = {.lex_state = 0, .external_lex_state = 7},
  [8606] = {.lex_state = 0, .external_lex_state = 7},
  [8607] = {.lex_state = 0, .external_lex_state = 7},
  [8608] = {.lex_state = 0, .external_lex_state = 7},
  [8609] = {.lex_state = 22, .external_lex_state = 7},
  [8610] = {.lex_state = 0, .external_lex_state = 7},
  [8611] = {.lex_state = 0, .external_lex_state = 7},
  [8612] = {.lex_state = 0, .external_lex_state = 7},
  [8613] = {.lex_state = 0, .external_lex_state = 7},
  [8614] = {.lex_state = 0, .external_lex_state = 6},
  [8615] = {.lex_state = 22, .external_lex_state = 7},
  [8616] = {.lex_state = 0, .external_lex_state = 7},
  [8617] = {.lex_state = 0, .external_lex_state = 7},
  [8618] = {.lex_state = 0, .external_lex_state = 7},
  [8619] = {.lex_state = 0, .external_lex_state = 7},
  [8620] = {.lex_state = 0, .external_lex_state = 7},
  [8621] = {.lex_state = 22, .external_lex_state = 7},
  [8622] = {.lex_state = 0, .external_lex_state = 7},
  [8623] = {.lex_state = 0, .external_lex_state = 6},
  [8624] = {.lex_state = 0, .external_lex_state = 7},
  [8625] = {.lex_state = 0, .external_lex_state = 7},
  [8626] = {.lex_state = 0, .external_lex_state = 7},
  [8627] = {.lex_state = 0, .external_lex_state = 6},
  [8628] = {.lex_state = 0, .external_lex_state = 7},
  [8629] = {.lex_state = 22, .external_lex_state = 7},
  [8630] = {.lex_state = 0, .external_lex_state = 7},
  [8631] = {.lex_state = 0, .external_lex_state = 7},
  [8632] = {.lex_state = 0, .external_lex_state = 7},
  [8633] = {.lex_state = 0, .external_lex_state = 7},
  [8634] = {.lex_state = 0, .external_lex_state = 7},
  [8635] = {.lex_state = 0, .external_lex_state = 7},
  [8636] = {.lex_state = 0, .external_lex_state = 7},
  [8637] = {.lex_state = 0, .external_lex_state = 6},
  [8638] = {.lex_state = 22, .external_lex_state = 7},
  [8639] = {.lex_state = 0, .external_lex_state = 7},
  [8640] = {.lex_state = 0, .external_lex_state = 7},
  [8641] = {.lex_state = 0, .external_lex_state = 7},
  [8642] = {.lex_state = 0, .external_lex_state = 7},
  [8643] = {.lex_state = 0, .external_lex_state = 7},
  [8644] = {.lex_state = 0, .external_lex_state = 7},
  [8645] = {.lex_state = 0, .external_lex_state = 7},
  [8646] = {.lex_state = 0, .external_lex_state = 7},
  [8647] = {.lex_state = 0, .external_lex_state = 6},
  [8648] = {.lex_state = 22, .external_lex_state = 7},
  [8649] = {.lex_state = 0, .external_lex_state = 7},
  [8650] = {.lex_state = 0, .external_lex_state = 7},
  [8651] = {.lex_state = 0, .external_lex_state = 6},
  [8652] = {.lex_state = 0, .external_lex_state = 6},
  [8653] = {.lex_state = 0, .external_lex_state = 7},
  [8654] = {.lex_state = 0, .external_lex_state = 7},
  [8655] = {.lex_state = 0, .external_lex_state = 7},
  [8656] = {.lex_state = 0, .external_lex_state = 6},
  [8657] = {.lex_state = 0, .external_lex_state = 6},
  [8658] = {.lex_state = 0, .external_lex_state = 7},
  [8659] = {.lex_state = 0, .external_lex_state = 7},
  [8660] = {.lex_state = 0, .external_lex_state = 7},
  [8661] = {.lex_state = 0, .external_lex_state = 7},
  [8662] = {.lex_state = 0, .external_lex_state = 7},
  [8663] = {.lex_state = 0, .external_lex_state = 7},
  [8664] = {.lex_state = 0, .external_lex_state = 7},
  [8665] = {.lex_state = 0, .external_lex_state = 6},
  [8666] = {.lex_state = 0, .external_lex_state = 7},
  [8667] = {.lex_state = 0, .external_lex_state = 7},
  [8668] = {.lex_state = 0, .external_lex_state = 7},
  [8669] = {.lex_state = 0, .external_lex_state = 7},
  [8670] = {.lex_state = 0, .external_lex_state = 7},
  [8671] = {.lex_state = 0, .external_lex_state = 7},
  [8672] = {.lex_state = 0, .external_lex_state = 6},
  [8673] = {.lex_state = 0, .external_lex_state = 6},
  [8674] = {.lex_state = 0, .external_lex_state = 7},
  [8675] = {.lex_state = 0, .external_lex_state = 7},
  [8676] = {.lex_state = 0, .external_lex_state = 7},
  [8677] = {.lex_state = 0, .external_lex_state = 7},
  [8678] = {.lex_state = 0, .external_lex_state = 6},
  [8679] = {.lex_state = 0, .external_lex_state = 7},
  [8680] = {.lex_state = 0, .external_lex_state = 7},
  [8681] = {.lex_state = 0, .external_lex_state = 7},
  [8682] = {.lex_state = 0, .external_lex_state = 7},
  [8683] = {.lex_state = 0, .external_lex_state = 7},
  [8684] = {.lex_state = 0, .external_lex_state = 7},
  [8685] = {.lex_state = 0, .external_lex_state = 7},
  [8686] = {.lex_state = 0, .external_lex_state = 7},
  [8687] = {.lex_state = 0, .external_lex_state = 7},
  [8688] = {.lex_state = 0, .external_lex_state = 6},
  [8689] = {.lex_state = 0, .external_lex_state = 7},
  [8690] = {.lex_state = 0, .external_lex_state = 7},
  [8691] = {.lex_state = 0, .external_lex_state = 6},
  [8692] = {.lex_state = 0, .external_lex_state = 7},
  [8693] = {.lex_state = 0, .external_lex_state = 6},
  [8694] = {.lex_state = 0, .external_lex_state = 6},
  [8695] = {.lex_state = 0, .external_lex_state = 7},
  [8696] = {.lex_state = 0, .external_lex_state = 7},
  [8697] = {.lex_state = 0, .external_lex_state = 7},
  [8698] = {.lex_state = 0, .external_lex_state = 7},
  [8699] = {.lex_state = 0, .external_lex_state = 7},
  [8700] = {.lex_state = 0, .external_lex_state = 7},
  [8701] = {.lex_state = 0, .external_lex_state = 7},
  [8702] = {.lex_state = 0, .external_lex_state = 6},
  [8703] = {.lex_state = 0, .external_lex_state = 7},
  [8704] = {.lex_state = 0, .external_lex_state = 7},
  [8705] = {.lex_state = 0, .external_lex_state = 7},
  [8706] = {.lex_state = 0, .external_lex_state = 7},
  [8707] = {.lex_state = 0, .external_lex_state = 7},
  [8708] = {.lex_state = 0, .external_lex_state = 7},
  [8709] = {.lex_state = 0, .external_lex_state = 7},
  [8710] = {.lex_state = 0, .external_lex_state = 7},
  [8711] = {.lex_state = 0, .external_lex_state = 7},
  [8712] = {.lex_state = 0, .external_lex_state = 6},
  [8713] = {.lex_state = 0, .external_lex_state = 6},
  [8714] = {.lex_state = 0, .external_lex_state = 7},
  [8715] = {.lex_state = 0, .external_lex_state = 7},
  [8716] = {.lex_state = 0, .external_lex_state = 7},
  [8717] = {.lex_state = 0, .external_lex_state = 7},
  [8718] = {.lex_state = 0, .external_lex_state = 7},
  [8719] = {.lex_state = 0, .external_lex_state = 7},
  [8720] = {.lex_state = 0, .external_lex_state = 7},
  [8721] = {.lex_state = 0, .external_lex_state = 7},
  [8722] = {.lex_state = 0, .external_lex_state = 7},
  [8723] = {.lex_state = 0, .external_lex_state = 6},
  [8724] = {.lex_state = 0, .external_lex_state = 7},
  [8725] = {.lex_state = 0, .external_lex_state = 6},
  [8726] = {.lex_state = 0, .external_lex_state = 7},
  [8727] = {.lex_state = 0, .external_lex_state = 7},
  [8728] = {.lex_state = 0, .external_lex_state = 7},
  [8729] = {.lex_state = 0, .external_lex_state = 7},
  [8730] = {.lex_state = 0, .external_lex_state = 7},
  [8731] = {.lex_state = 0, .external_lex_state = 6},
  [8732] = {.lex_state = 0, .external_lex_state = 6},
  [8733] = {.lex_state = 0, .external_lex_state = 7},
  [8734] = {.lex_state = 0, .external_lex_state = 7},
  [8735] = {.lex_state = 0, .external_lex_state = 7},
  [8736] = {.lex_state = 0, .external_lex_state = 7},
  [8737] = {.lex_state = 0, .external_lex_state = 7},
  [8738] = {.lex_state = 0, .external_lex_state = 7},
  [8739] = {.lex_state = 0, .external_lex_state = 7},
  [8740] = {.lex_state = 0, .external_lex_state = 7},
  [8741] = {.lex_state = 0, .external_lex_state = 7},
  [8742] = {.lex_state = 0, .external_lex_state = 7},
  [8743] = {.lex_state = 0, .external_lex_state = 7},
  [8744] = {.lex_state = 0, .external_lex_state = 7},
  [8745] = {.lex_state = 0, .external_lex_state = 7},
  [8746] = {.lex_state = 0, .external_lex_state = 7},
  [8747] = {.lex_state = 0, .external_lex_state = 7},
  [8748] = {.lex_state = 0, .external_lex_state = 7},
  [8749] = {.lex_state = 0, .external_lex_state = 7},
  [8750] = {.lex_state = 0, .external_lex_state = 6},
  [8751] = {.lex_state = 0, .external_lex_state = 6},
  [8752] = {.lex_state = 0, .external_lex_state = 7},
  [8753] = {.lex_state = 0, .external_lex_state = 7},
  [8754] = {.lex_state = 0, .external_lex_state = 7},
  [8755] = {.lex_state = 0, .external_lex_state = 7},
  [8756] = {.lex_state = 0, .external_lex_state = 7},
  [8757] = {.lex_state = 0, .external_lex_state = 7},
  [8758] = {.lex_state = 0, .external_lex_state = 7},
  [8759] = {.lex_state = 0, .external_lex_state = 7},
  [8760] = {.lex_state = 0, .external_lex_state = 7},
  [8761] = {.lex_state = 0, .external_lex_state = 7},
  [8762] = {.lex_state = 0, .external_lex_state = 7},
  [8763] = {.lex_state = 0, .external_lex_state = 7},
  [8764] = {.lex_state = 0, .external_lex_state = 7},
  [8765] = {.lex_state = 0, .external_lex_state = 7},
  [8766] = {.lex_state = 0, .external_lex_state = 7},
  [8767] = {.lex_state = 0, .external_lex_state = 7},
  [8768] = {.lex_state = 0, .external_lex_state = 7},
  [8769] = {.lex_state = 0, .external_lex_state = 6},
  [8770] = {.lex_state = 0, .external_lex_state = 6},
  [8771] = {.lex_state = 0, .external_lex_state = 7},
  [8772] = {.lex_state = 0, .external_lex_state = 7},
  [8773] = {.lex_state = 0, .external_lex_state = 7},
  [8774] = {.lex_state = 0, .external_lex_state = 7},
  [8775] = {.lex_state = 0, .external_lex_state = 7},
  [8776] = {.lex_state = 0, .external_lex_state = 7},
  [8777] = {.lex_state = 0, .external_lex_state = 7},
  [8778] = {.lex_state = 0, .external_lex_state = 7},
  [8779] = {.lex_state = 0, .external_lex_state = 7},
  [8780] = {.lex_state = 0, .external_lex_state = 7},
  [8781] = {.lex_state = 0, .external_lex_state = 7},
  [8782] = {.lex_state = 0, .external_lex_state = 7},
  [8783] = {.lex_state = 0, .external_lex_state = 7},
  [8784] = {.lex_state = 0, .external_lex_state = 7},
  [8785] = {.lex_state = 0, .external_lex_state = 7},
  [8786] = {.lex_state = 0, .external_lex_state = 7},
  [8787] = {.lex_state = 0, .external_lex_state = 7},
  [8788] = {.lex_state = 0, .external_lex_state = 6},
  [8789] = {.lex_state = 0, .external_lex_state = 6},
  [8790] = {.lex_state = 0, .external_lex_state = 7},
  [8791] = {.lex_state = 0, .external_lex_state = 7},
  [8792] = {.lex_state = 0, .external_lex_state = 7},
  [8793] = {.lex_state = 0, .external_lex_state = 7},
  [8794] = {.lex_state = 0, .external_lex_state = 7},
  [8795] = {.lex_state = 0, .external_lex_state = 7},
  [8796] = {.lex_state = 0, .external_lex_state = 7},
  [8797] = {.lex_state = 0, .external_lex_state = 7},
  [8798] = {.lex_state = 0, .external_lex_state = 7},
  [8799] = {.lex_state = 0, .external_lex_state = 7},
  [8800] = {.lex_state = 0, .external_lex_state = 7},
  [8801] = {.lex_state = 0, .external_lex_state = 7},
  [8802] = {.lex_state = 0, .external_lex_state = 7},
  [8803] = {.lex_state = 0, .external_lex_state = 7},
  [8804] = {.lex_state = 0, .external_lex_state = 7},
  [8805] = {.lex_state = 0, .external_lex_state = 7},
  [8806] = {.lex_state = 0, .external_lex_state = 6},
  [8807] = {.lex_state = 0, .external_lex_state = 6},
  [8808] = {.lex_state = 0, .external_lex_state = 7},
  [8809] = {.lex_state = 0, .external_lex_state = 7},
  [8810] = {.lex_state = 0, .external_lex_state = 7},
  [8811] = {.lex_state = 0, .external_lex_state = 7},
  [8812] = {.lex_state = 0, .external_lex_state = 7},
  [8813] = {.lex_state = 0, .external_lex_state = 7},
  [8814] = {.lex_state = 0, .external_lex_state = 7},
  [8815] = {.lex_state = 0, .external_lex_state = 7},
  [8816] = {.lex_state = 0, .external_lex_state = 7},
  [8817] = {.lex_state = 0, .external_lex_state = 7},
  [8818] = {.lex_state = 0, .external_lex_state = 6},
  [8819] = {.lex_state = 0, .external_lex_state = 6},
  [8820] = {.lex_state = 0, .external_lex_state = 7},
  [8821] = {.lex_state = 0, .external_lex_state = 7},
  [8822] = {.lex_state = 0, .external_lex_state = 7},
  [8823] = {.lex_state = 0, .external_lex_state = 7},
  [8824] = {.lex_state = 0, .external_lex_state = 7},
  [8825] = {.lex_state = 0, .external_lex_state = 7},
  [8826] = {.lex_state = 0, .external_lex_state = 7},
  [8827] = {.lex_state = 0, .external_lex_state = 7},
  [8828] = {.lex_state = 0, .external_lex_state = 7},
  [8829] = {.lex_state = 0, .external_lex_state = 6},
  [8830] = {.lex_state = 0, .external_lex_state = 6},
  [8831] = {.lex_state = 0, .external_lex_state = 7},
  [8832] = {.lex_state = 0, .external_lex_state = 7},
  [8833] = {.lex_state = 0, .external_lex_state = 7},
  [8834] = {.lex_state = 0, .external_lex_state = 7},
  [8835] = {.lex_state = 0, .external_lex_state = 7},
  [8836] = {.lex_state = 0, .external_lex_state = 7},
  [8837] = {.lex_state = 0, .external_lex_state = 7},
  [8838] = {.lex_state = 0, .external_lex_state = 7},
  [8839] = {.lex_state = 0, .external_lex_state = 6},
  [8840] = {.lex_state = 0, .external_lex_state = 6},
  [8841] = {.lex_state = 0, .external_lex_state = 7},
  [8842] = {.lex_state = 0, .external_lex_state = 7},
  [8843] = {.lex_state = 0, .external_lex_state = 7},
  [8844] = {.lex_state = 0, .external_lex_state = 7},
  [8845] = {.lex_state = 0, .external_lex_state = 7},
  [8846] = {.lex_state = 0, .external_lex_state = 7},
  [8847] = {.lex_state = 0, .external_lex_state = 7},
  [8848] = {.lex_state = 0, .external_lex_state = 7},
  [8849] = {.lex_state = 0, .external_lex_state = 7},
  [8850] = {.lex_state = 0, .external_lex_state = 7},
  [8851] = {.lex_state = 0, .external_lex_state = 6},
  [8852] = {.lex_state = 0, .external_lex_state = 7},
  [8853] = {.lex_state = 0, .external_lex_state = 7},
  [8854] = {.lex_state = 0, .external_lex_state = 7},
  [8855] = {.lex_state = 0, .external_lex_state = 7},
  [8856] = {.lex_state = 0, .external_lex_state = 7},
  [8857] = {.lex_state = 0, .external_lex_state = 7},
  [8858] = {.lex_state = 0, .external_lex_state = 7},
  [8859] = {.lex_state = 0, .external_lex_state = 7},
  [8860] = {.lex_state = 0, .external_lex_state = 7},
  [8861] = {.lex_state = 0, .external_lex_state = 7},
  [8862] = {.lex_state = 0, .external_lex_state = 7},
  [8863] = {.lex_state = 0, .external_lex_state = 7},
  [8864] = {.lex_state = 0, .external_lex_state = 7},
  [8865] = {.lex_state = 0, .external_lex_state = 7},
  [8866] = {.lex_state = 0, .external_lex_state = 7},
  [8867] = {.lex_state = 0, .external_lex_state = 7},
  [8868] = {.lex_state = 0, .external_lex_state = 7},
  [8869] = {.lex_state = 0, .external_lex_state = 7},
  [8870] = {.lex_state = 0, .external_lex_state = 7},
  [8871] = {.lex_state = 0, .external_lex_state = 7},
  [8872] = {.lex_state = 0, .external_lex_state = 7},
  [8873] = {.lex_state = 0, .external_lex_state = 7},
  [8874] = {.lex_state = 0, .external_lex_state = 7},
  [8875] = {.lex_state = 0, .external_lex_state = 7},
  [8876] = {.lex_state = 0, .external_lex_state = 7},
  [8877] = {.lex_state = 0, .external_lex_state = 7},
  [8878] = {.lex_state = 0, .external_lex_state = 7},
  [8879] = {.lex_state = 0, .external_lex_state = 7},
  [8880] = {.lex_state = 0, .external_lex_state = 7},
  [8881] = {.lex_state = 0, .external_lex_state = 7},
  [8882] = {.lex_state = 0, .external_lex_state = 7},
  [8883] = {.lex_state = 0, .external_lex_state = 7},
  [8884] = {.lex_state = 0, .external_lex_state = 7},
  [8885] = {.lex_state = 0, .external_lex_state = 7},
  [8886] = {.lex_state = 0, .external_lex_state = 7},
  [8887] = {.lex_state = 0, .external_lex_state = 7},
  [8888] = {.lex_state = 0, .external_lex_state = 7},
  [8889] = {.lex_state = 0, .external_lex_state = 7},
  [8890] = {.lex_state = 0, .external_lex_state = 7},
  [8891] = {.lex_state = 0, .external_lex_state = 7},
  [8892] = {.lex_state = 0, .external_lex_state = 7},
  [8893] = {.lex_state = 0, .external_lex_state = 7},
  [8894] = {.lex_state = 0, .external_lex_state = 7},
  [8895] = {.lex_state = 0, .external_lex_state = 7},
  [8896] = {.lex_state = 0, .external_lex_state = 7},
  [8897] = {.lex_state = 0, .external_lex_state = 7},
  [8898] = {.lex_state = 0, .external_lex_state = 7},
  [8899] = {.lex_state = 0, .external_lex_state = 7},
  [8900] = {.lex_state = 0, .external_lex_state = 7},
  [8901] = {.lex_state = 0, .external_lex_state = 7},
  [8902] = {.lex_state = 0, .external_lex_state = 7},
  [8903] = {.lex_state = 0, .external_lex_state = 7},
  [8904] = {.lex_state = 0, .external_lex_state = 7},
  [8905] = {.lex_state = 0, .external_lex_state = 7},
  [8906] = {.lex_state = 0, .external_lex_state = 7},
  [8907] = {.lex_state = 0, .external_lex_state = 7},
  [8908] = {.lex_state = 0, .external_lex_state = 7},
  [8909] = {.lex_state = 0, .external_lex_state = 7},
  [8910] = {.lex_state = 0, .external_lex_state = 7},
  [8911] = {.lex_state = 0, .external_lex_state = 7},
  [8912] = {.lex_state = 0, .external_lex_state = 7},
  [8913] = {.lex_state = 0, .external_lex_state = 7},
  [8914] = {.lex_state = 0, .external_lex_state = 7},
  [8915] = {.lex_state = 0, .external_lex_state = 7},
  [8916] = {.lex_state = 0, .external_lex_state = 7},
  [8917] = {.lex_state = 0, .external_lex_state = 7},
  [8918] = {.lex_state = 0, .external_lex_state = 7},
  [8919] = {.lex_state = 0, .external_lex_state = 7},
  [8920] = {.lex_state = 0, .external_lex_state = 7},
  [8921] = {.lex_state = 0, .external_lex_state = 7},
  [8922] = {.lex_state = 0, .external_lex_state = 7},
  [8923] = {.lex_state = 0, .external_lex_state = 7},
  [8924] = {.lex_state = 0, .external_lex_state = 7},
  [8925] = {.lex_state = 0, .external_lex_state = 7},
  [8926] = {.lex_state = 0, .external_lex_state = 7},
  [8927] = {.lex_state = 0, .external_lex_state = 7},
  [8928] = {.lex_state = 0, .external_lex_state = 7},
  [8929] = {.lex_state = 0, .external_lex_state = 7},
  [8930] = {.lex_state = 0, .external_lex_state = 7},
  [8931] = {.lex_state = 0, .external_lex_state = 7},
  [8932] = {.lex_state = 0, .external_lex_state = 7},
  [8933] = {.lex_state = 0, .external_lex_state = 7},
  [8934] = {.lex_state = 0, .external_lex_state = 7},
  [8935] = {.lex_state = 0, .external_lex_state = 7},
  [8936] = {.lex_state = 0, .external_lex_state = 7},
  [8937] = {.lex_state = 0, .external_lex_state = 6},
  [8938] = {.lex_state = 0, .external_lex_state = 6},
  [8939] = {.lex_state = 0, .external_lex_state = 7},
  [8940] = {.lex_state = 0, .external_lex_state = 7},
  [8941] = {.lex_state = 0, .external_lex_state = 6},
  [8942] = {.lex_state = 0, .external_lex_state = 7},
  [8943] = {.lex_state = 0, .external_lex_state = 7},
  [8944] = {.lex_state = 0, .external_lex_state = 6},
  [8945] = {.lex_state = 0, .external_lex_state = 7},
  [8946] = {.lex_state = 0, .external_lex_state = 7},
  [8947] = {.lex_state = 0, .external_lex_state = 7},
  [8948] = {.lex_state = 0, .external_lex_state = 7},
  [8949] = {.lex_state = 0, .external_lex_state = 7},
  [8950] = {.lex_state = 0, .external_lex_state = 7},
  [8951] = {.lex_state = 0, .external_lex_state = 7},
  [8952] = {.lex_state = 0, .external_lex_state = 7},
  [8953] = {.lex_state = 0, .external_lex_state = 7},
  [8954] = {.lex_state = 0, .external_lex_state = 7},
  [8955] = {.lex_state = 0, .external_lex_state = 7},
  [8956] = {.lex_state = 0, .external_lex_state = 7},
  [8957] = {.lex_state = 0, .external_lex_state = 7},
  [8958] = {.lex_state = 0, .external_lex_state = 7},
  [8959] = {.lex_state = 0, .external_lex_state = 7},
  [8960] = {.lex_state = 0, .external_lex_state = 7},
  [8961] = {.lex_state = 0, .external_lex_state = 7},
  [8962] = {.lex_state = 0, .external_lex_state = 7},
  [8963] = {.lex_state = 0, .external_lex_state = 7},
  [8964] = {.lex_state = 0, .external_lex_state = 7},
  [8965] = {.lex_state = 0, .external_lex_state = 7},
  [8966] = {.lex_state = 0, .external_lex_state = 7},
  [8967] = {.lex_state = 0, .external_lex_state = 7},
  [8968] = {.lex_state = 0, .external_lex_state = 7},
  [8969] = {.lex_state = 0, .external_lex_state = 7},
  [8970] = {.lex_state = 0, .external_lex_state = 7},
  [8971] = {.lex_state = 0, .external_lex_state = 7},
  [8972] = {.lex_state = 0, .external_lex_state = 7},
  [8973] = {.lex_state = 0, .external_lex_state = 7},
  [8974] = {.lex_state = 0, .external_lex_state = 7},
  [8975] = {.lex_state = 0, .external_lex_state = 7},
  [8976] = {.lex_state = 0, .external_lex_state = 7},
  [8977] = {.lex_state = 0, .external_lex_state = 7},
  [8978] = {.lex_state = 0, .external_lex_state = 7},
  [8979] = {.lex_state = 0, .external_lex_state = 7},
  [8980] = {.lex_state = 0, .external_lex_state = 7},
  [8981] = {.lex_state = 0, .external_lex_state = 7},
  [8982] = {.lex_state = 0, .external_lex_state = 7},
  [8983] = {.lex_state = 0, .external_lex_state = 7},
  [8984] = {.lex_state = 0, .external_lex_state = 7},
  [8985] = {.lex_state = 0, .external_lex_state = 6},
  [8986] = {.lex_state = 0, .external_lex_state = 7},
  [8987] = {.lex_state = 0, .external_lex_state = 7},
  [8988] = {.lex_state = 0, .external_lex_state = 7},
  [8989] = {.lex_state = 0, .external_lex_state = 7},
  [8990] = {.lex_state = 0, .external_lex_state = 7},
  [8991] = {.lex_state = 0, .external_lex_state = 7},
  [8992] = {.lex_state = 0, .external_lex_state = 7},
  [8993] = {.lex_state = 0, .external_lex_state = 7},
  [8994] = {.lex_state = 0, .external_lex_state = 7},
  [8995] = {.lex_state = 0, .external_lex_state = 7},
  [8996] = {.lex_state = 0, .external_lex_state = 7},
  [8997] = {.lex_state = 0, .external_lex_state = 7},
  [8998] = {.lex_state = 0, .external_lex_state = 7},
  [8999] = {.lex_state = 0, .external_lex_state = 7},
  [9000] = {.lex_state = 0, .external_lex_state = 7},
  [9001] = {.lex_state = 0, .external_lex_state = 7},
  [9002] = {.lex_state = 0, .external_lex_state = 7},
  [9003] = {.lex_state = 0, .external_lex_state = 7},
  [9004] = {.lex_state = 0, .external_lex_state = 7},
  [9005] = {.lex_state = 0, .external_lex_state = 7},
  [9006] = {.lex_state = 0, .external_lex_state = 7},
  [9007] = {.lex_state = 0, .external_lex_state = 7},
  [9008] = {.lex_state = 0, .external_lex_state = 7},
  [9009] = {.lex_state = 0, .external_lex_state = 7},
  [9010] = {.lex_state = 0, .external_lex_state = 7},
  [9011] = {.lex_state = 0, .external_lex_state = 7},
  [9012] = {.lex_state = 0, .external_lex_state = 7},
  [9013] = {.lex_state = 0, .external_lex_state = 7},
  [9014] = {.lex_state = 0, .external_lex_state = 7},
  [9015] = {.lex_state = 0, .external_lex_state = 7},
  [9016] = {.lex_state = 0, .external_lex_state = 7},
  [9017] = {.lex_state = 0, .external_lex_state = 7},
  [9018] = {.lex_state = 0, .external_lex_state = 7},
  [9019] = {.lex_state = 0, .external_lex_state = 7},
  [9020] = {.lex_state = 0, .external_lex_state = 7},
  [9021] = {.lex_state = 0, .external_lex_state = 7},
  [9022] = {.lex_state = 0, .external_lex_state = 7},
  [9023] = {.lex_state = 0, .external_lex_state = 7},
  [9024] = {.lex_state = 0, .external_lex_state = 7},
  [9025] = {.lex_state = 0, .external_lex_state = 7},
  [9026] = {.lex_state = 0, .external_lex_state = 7},
  [9027] = {.lex_state = 0, .external_lex_state = 7},
  [9028] = {.lex_state = 0, .external_lex_state = 7},
  [9029] = {.lex_state = 0, .external_lex_state = 7},
  [9030] = {.lex_state = 0, .external_lex_state = 7},
  [9031] = {.lex_state = 0, .external_lex_state = 7},
  [9032] = {.lex_state = 0, .external_lex_state = 7},
  [9033] = {.lex_state = 0, .external_lex_state = 7},
  [9034] = {.lex_state = 0, .external_lex_state = 6},
  [9035] = {.lex_state = 0, .external_lex_state = 7},
  [9036] = {.lex_state = 0, .external_lex_state = 7},
  [9037] = {.lex_state = 0, .external_lex_state = 7},
  [9038] = {.lex_state = 0, .external_lex_state = 7},
  [9039] = {.lex_state = 0, .external_lex_state = 7},
  [9040] = {.lex_state = 0, .external_lex_state = 7},
  [9041] = {.lex_state = 0, .external_lex_state = 7},
  [9042] = {.lex_state = 0, .external_lex_state = 7},
  [9043] = {.lex_state = 0, .external_lex_state = 7},
  [9044] = {.lex_state = 0, .external_lex_state = 7},
  [9045] = {.lex_state = 0, .external_lex_state = 7},
  [9046] = {.lex_state = 0, .external_lex_state = 7},
  [9047] = {.lex_state = 0, .external_lex_state = 7},
  [9048] = {.lex_state = 0, .external_lex_state = 7},
  [9049] = {.lex_state = 0, .external_lex_state = 7},
  [9050] = {.lex_state = 0, .external_lex_state = 7},
  [9051] = {.lex_state = 0, .external_lex_state = 6},
  [9052] = {.lex_state = 0, .external_lex_state = 6},
  [9053] = {.lex_state = 0, .external_lex_state = 7},
  [9054] = {.lex_state = 0, .external_lex_state = 7},
  [9055] = {.lex_state = 0, .external_lex_state = 6},
  [9056] = {.lex_state = 0, .external_lex_state = 6},
  [9057] = {.lex_state = 0, .external_lex_state = 7},
  [9058] = {.lex_state = 0, .external_lex_state = 6},
  [9059] = {.lex_state = 0, .external_lex_state = 7},
  [9060] = {.lex_state = 0, .external_lex_state = 7},
  [9061] = {.lex_state = 0, .external_lex_state = 7},
  [9062] = {.lex_state = 0, .external_lex_state = 6},
  [9063] = {.lex_state = 0, .external_lex_state = 7},
  [9064] = {.lex_state = 0, .external_lex_state = 6},
  [9065] = {.lex_state = 0, .external_lex_state = 7},
  [9066] = {.lex_state = 0, .external_lex_state = 6},
  [9067] = {.lex_state = 0, .external_lex_state = 6},
  [9068] = {.lex_state = 0, .external_lex_state = 7},
  [9069] = {.lex_state = 0, .external_lex_state = 7},
  [9070] = {.lex_state = 0, .external_lex_state = 6},
  [9071] = {.lex_state = 0, .external_lex_state = 7},
  [9072] = {.lex_state = 0, .external_lex_state = 7},
  [9073] = {.lex_state = 0, .external_lex_state = 7},
  [9074] = {.lex_state = 0, .external_lex_state = 7},
  [9075] = {.lex_state = 0, .external_lex_state = 7},
  [9076] = {.lex_state = 0, .external_lex_state = 7},
  [9077] = {.lex_state = 0, .external_lex_state = 7},
  [9078] = {.lex_state = 0, .external_lex_state = 7},
  [9079] = {.lex_state = 0, .external_lex_state = 7},
  [9080] = {.lex_state = 0, .external_lex_state = 6},
  [9081] = {.lex_state = 0, .external_lex_state = 7},
  [9082] = {.lex_state = 0, .external_lex_state = 6},
  [9083] = {.lex_state = 0, .external_lex_state = 7},
  [9084] = {.lex_state = 0, .external_lex_state = 6},
  [9085] = {.lex_state = 0, .external_lex_state = 7},
  [9086] = {.lex_state = 0, .external_lex_state = 6},
  [9087] = {.lex_state = 0, .external_lex_state = 7},
  [9088] = {.lex_state = 0, .external_lex_state = 7},
  [9089] = {.lex_state = 0, .external_lex_state = 7},
  [9090] = {.lex_state = 0, .external_lex_state = 7},
  [9091] = {.lex_state = 0, .external_lex_state = 7},
  [9092] = {.lex_state = 0, .external_lex_state = 7},
  [9093] = {.lex_state = 0, .external_lex_state = 7},
  [9094] = {.lex_state = 0, .external_lex_state = 6},
  [9095] = {.lex_state = 0, .external_lex_state = 7},
  [9096] = {.lex_state = 0, .external_lex_state = 7},
  [9097] = {.lex_state = 0, .external_lex_state = 7},
  [9098] = {.lex_state = 0, .external_lex_state = 6},
  [9099] = {.lex_state = 0, .external_lex_state = 7},
  [9100] = {.lex_state = 0, .external_lex_state = 7},
  [9101] = {.lex_state = 0, .external_lex_state = 7},
  [9102] = {.lex_state = 0, .external_lex_state = 6},
  [9103] = {.lex_state = 0, .external_lex_state = 7},
  [9104] = {.lex_state = 0, .external_lex_state = 7},
  [9105] = {.lex_state = 0, .external_lex_state = 7},
  [9106] = {.lex_state = 0, .external_lex_state = 7},
  [9107] = {.lex_state = 0, .external_lex_state = 7},
  [9108] = {.lex_state = 0, .external_lex_state = 7},
  [9109] = {.lex_state = 0, .external_lex_state = 7},
  [9110] = {.lex_state = 0, .external_lex_state = 7},
  [9111] = {.lex_state = 0, .external_lex_state = 7},
  [9112] = {.lex_state = 0, .external_lex_state = 7},
  [9113] = {.lex_state = 0, .external_lex_state = 7},
  [9114] = {.lex_state = 0, .external_lex_state = 7},
  [9115] = {.lex_state = 0, .external_lex_state = 7},
  [9116] = {.lex_state = 0, .external_lex_state = 6},
  [9117] = {.lex_state = 0, .external_lex_state = 6},
  [9118] = {.lex_state = 0, .external_lex_state = 7},
  [9119] = {.lex_state = 0, .external_lex_state = 7},
  [9120] = {.lex_state = 0, .external_lex_state = 7},
  [9121] = {.lex_state = 0, .external_lex_state = 6},
  [9122] = {.lex_state = 0, .external_lex_state = 7},
  [9123] = {.lex_state = 0, .external_lex_state = 7},
  [9124] = {.lex_state = 0, .external_lex_state = 6},
  [9125] = {.lex_state = 0, .external_lex_state = 7},
  [9126] = {.lex_state = 0, .external_lex_state = 7},
  [9127] = {.lex_state = 0, .external_lex_state = 7},
  [9128] = {.lex_state = 0, .external_lex_state = 7},
  [9129] = {.lex_state = 0, .external_lex_state = 7},
  [9130] = {.lex_state = 0, .external_lex_state = 7},
  [9131] = {.lex_state = 0, .external_lex_state = 6},
  [9132] = {.lex_state = 0, .external_lex_state = 7},
  [9133] = {.lex_state = 0, .external_lex_state = 7},
  [9134] = {.lex_state = 0, .external_lex_state = 7},
  [9135] = {.lex_state = 0, .external_lex_state = 7},
  [9136] = {.lex_state = 0, .external_lex_state = 6},
  [9137] = {.lex_state = 0, .external_lex_state = 7},
  [9138] = {.lex_state = 0, .external_lex_state = 7},
  [9139] = {.lex_state = 0, .external_lex_state = 7},
  [9140] = {.lex_state = 0, .external_lex_state = 7},
  [9141] = {.lex_state = 0, .external_lex_state = 7},
  [9142] = {.lex_state = 0, .external_lex_state = 7},
  [9143] = {.lex_state = 0, .external_lex_state = 7},
  [9144] = {.lex_state = 0, .external_lex_state = 7},
  [9145] = {.lex_state = 0, .external_lex_state = 7},
  [9146] = {.lex_state = 0, .external_lex_state = 7},
  [9147] = {.lex_state = 0, .external_lex_state = 7},
  [9148] = {.lex_state = 0, .external_lex_state = 6},
  [9149] = {.lex_state = 0, .external_lex_state = 7},
  [9150] = {.lex_state = 0, .external_lex_state = 7},
  [9151] = {.lex_state = 0, .external_lex_state = 6},
  [9152] = {.lex_state = 0, .external_lex_state = 7},
  [9153] = {.lex_state = 0, .external_lex_state = 7},
  [9154] = {.lex_state = 0, .external_lex_state = 7},
  [9155] = {.lex_state = 0, .external_lex_state = 7},
  [9156] = {.lex_state = 0, .external_lex_state = 6},
  [9157] = {.lex_state = 0, .external_lex_state = 6},
  [9158] = {.lex_state = 0, .external_lex_state = 7},
  [9159] = {.lex_state = 0, .external_lex_state = 7},
  [9160] = {.lex_state = 0, .external_lex_state = 7},
  [9161] = {.lex_state = 0, .external_lex_state = 7},
  [9162] = {.lex_state = 0, .external_lex_state = 7},
  [9163] = {.lex_state = 0, .external_lex_state = 7},
  [9164] = {.lex_state = 0, .external_lex_state = 7},
  [9165] = {.lex_state = 0, .external_lex_state = 7},
  [9166] = {.lex_state = 0, .external_lex_state = 7},
  [9167] = {.lex_state = 0, .external_lex_state = 7},
  [9168] = {.lex_state = 0, .external_lex_state = 7},
  [9169] = {.lex_state = 0, .external_lex_state = 7},
  [9170] = {.lex_state = 0, .external_lex_state = 7},
  [9171] = {.lex_state = 0, .external_lex_state = 7},
  [9172] = {.lex_state = 0, .external_lex_state = 7},
  [9173] = {.lex_state = 0, .external_lex_state = 6},
  [9174] = {.lex_state = 0, .external_lex_state = 7},
  [9175] = {.lex_state = 0, .external_lex_state = 7},
  [9176] = {.lex_state = 0, .external_lex_state = 6},
  [9177] = {.lex_state = 0, .external_lex_state = 7},
  [9178] = {.lex_state = 0, .external_lex_state = 7},
  [9179] = {.lex_state = 0, .external_lex_state = 7},
  [9180] = {.lex_state = 0, .external_lex_state = 7},
  [9181] = {.lex_state = 0, .external_lex_state = 7},
  [9182] = {.lex_state = 0, .external_lex_state = 7},
  [9183] = {.lex_state = 0, .external_lex_state = 7},
  [9184] = {.lex_state = 0, .external_lex_state = 7},
  [9185] = {.lex_state = 0, .external_lex_state = 7},
  [9186] = {.lex_state = 0, .external_lex_state = 7},
  [9187] = {.lex_state = 0, .external_lex_state = 7},
  [9188] = {.lex_state = 0, .external_lex_state = 7},
  [9189] = {.lex_state = 0, .external_lex_state = 7},
  [9190] = {.lex_state = 0, .external_lex_state = 7},
  [9191] = {.lex_state = 0, .external_lex_state = 7},
  [9192] = {.lex_state = 0, .external_lex_state = 6},
  [9193] = {.lex_state = 0, .external_lex_state = 6},
  [9194] = {.lex_state = 0, .external_lex_state = 7},
  [9195] = {.lex_state = 0, .external_lex_state = 7},
  [9196] = {.lex_state = 0, .external_lex_state = 7},
  [9197] = {.lex_state = 0, .external_lex_state = 7},
  [9198] = {.lex_state = 0, .external_lex_state = 7},
  [9199] = {.lex_state = 0, .external_lex_state = 7},
  [9200] = {.lex_state = 0, .external_lex_state = 7},
  [9201] = {.lex_state = 0, .external_lex_state = 7},
  [9202] = {.lex_state = 0, .external_lex_state = 7},
  [9203] = {.lex_state = 0, .external_lex_state = 6},
  [9204] = {.lex_state = 0, .external_lex_state = 7},
  [9205] = {.lex_state = 0, .external_lex_state = 7},
  [9206] = {.lex_state = 0, .external_lex_state = 7},
  [9207] = {.lex_state = 0, .external_lex_state = 7},
  [9208] = {.lex_state = 0, .external_lex_state = 6},
  [9209] = {.lex_state = 0, .external_lex_state = 7},
  [9210] = {.lex_state = 0, .external_lex_state = 7},
  [9211] = {.lex_state = 0, .external_lex_state = 7},
  [9212] = {.lex_state = 0, .external_lex_state = 6},
  [9213] = {.lex_state = 0, .external_lex_state = 7},
  [9214] = {.lex_state = 0, .external_lex_state = 7},
  [9215] = {.lex_state = 0, .external_lex_state = 7},
  [9216] = {.lex_state = 0, .external_lex_state = 7},
  [9217] = {.lex_state = 0, .external_lex_state = 7},
  [9218] = {.lex_state = 0, .external_lex_state = 7},
  [9219] = {.lex_state = 0, .external_lex_state = 7},
  [9220] = {.lex_state = 0, .external_lex_state = 7},
  [9221] = {.lex_state = 0, .external_lex_state = 7},
  [9222] = {.lex_state = 0, .external_lex_state = 7},
  [9223] = {.lex_state = 0, .external_lex_state = 7},
  [9224] = {.lex_state = 0, .external_lex_state = 7},
  [9225] = {.lex_state = 0, .external_lex_state = 7},
  [9226] = {.lex_state = 0, .external_lex_state = 7},
  [9227] = {.lex_state = 0, .external_lex_state = 7},
  [9228] = {.lex_state = 0, .external_lex_state = 7},
  [9229] = {.lex_state = 0, .external_lex_state = 7},
  [9230] = {.lex_state = 0, .external_lex_state = 7},
  [9231] = {.lex_state = 0, .external_lex_state = 7},
  [9232] = {.lex_state = 0, .external_lex_state = 7},
  [9233] = {.lex_state = 0, .external_lex_state = 7},
  [9234] = {.lex_state = 0, .external_lex_state = 7},
  [9235] = {.lex_state = 0, .external_lex_state = 7},
  [9236] = {.lex_state = 0, .external_lex_state = 7},
  [9237] = {.lex_state = 0, .external_lex_state = 7},
  [9238] = {.lex_state = 0, .external_lex_state = 7},
  [9239] = {.lex_state = 0, .external_lex_state = 6},
  [9240] = {.lex_state = 0, .external_lex_state = 6},
  [9241] = {.lex_state = 0, .external_lex_state = 7},
  [9242] = {.lex_state = 0, .external_lex_state = 7},
  [9243] = {.lex_state = 0, .external_lex_state = 7},
  [9244] = {.lex_state = 0, .external_lex_state = 7},
  [9245] = {.lex_state = 0, .external_lex_state = 7},
  [9246] = {.lex_state = 0, .external_lex_state = 7},
  [9247] = {.lex_state = 0, .external_lex_state = 7},
  [9248] = {.lex_state = 0, .external_lex_state = 7},
  [9249] = {.lex_state = 0, .external_lex_state = 7},
  [9250] = {.lex_state = 0, .external_lex_state = 7},
  [9251] = {.lex_state = 0, .external_lex_state = 7},
  [9252] = {.lex_state = 0, .external_lex_state = 7},
  [9253] = {.lex_state = 0, .external_lex_state = 6},
  [9254] = {.lex_state = 0, .external_lex_state = 7},
  [9255] = {.lex_state = 0, .external_lex_state = 7},
  [9256] = {.lex_state = 0, .external_lex_state = 7},
  [9257] = {.lex_state = 0, .external_lex_state = 7},
  [9258] = {.lex_state = 0, .external_lex_state = 7},
  [9259] = {.lex_state = 0, .external_lex_state = 7},
  [9260] = {.lex_state = 0, .external_lex_state = 7},
  [9261] = {.lex_state = 0, .external_lex_state = 7},
  [9262] = {.lex_state = 0, .external_lex_state = 7},
  [9263] = {.lex_state = 0, .external_lex_state = 7},
  [9264] = {.lex_state = 0, .external_lex_state = 7},
  [9265] = {.lex_state = 0, .external_lex_state = 7},
  [9266] = {.lex_state = 0, .external_lex_state = 7},
  [9267] = {.lex_state = 0, .external_lex_state = 7},
  [9268] = {.lex_state = 0, .external_lex_state = 7},
  [9269] = {.lex_state = 0, .external_lex_state = 7},
  [9270] = {.lex_state = 0, .external_lex_state = 7},
  [9271] = {.lex_state = 0, .external_lex_state = 7},
  [9272] = {.lex_state = 0, .external_lex_state = 7},
  [9273] = {.lex_state = 0, .external_lex_state = 7},
  [9274] = {.lex_state = 0, .external_lex_state = 7},
  [9275] = {.lex_state = 0, .external_lex_state = 7},
  [9276] = {.lex_state = 0, .external_lex_state = 6},
  [9277] = {.lex_state = 0, .external_lex_state = 7},
  [9278] = {.lex_state = 0, .external_lex_state = 7},
  [9279] = {.lex_state = 0, .external_lex_state = 7},
  [9280] = {.lex_state = 0, .external_lex_state = 6},
  [9281] = {.lex_state = 0, .external_lex_state = 7},
  [9282] = {.lex_state = 0, .external_lex_state = 6},
  [9283] = {.lex_state = 0, .external_lex_state = 6},
  [9284] = {.lex_state = 0, .external_lex_state = 7},
  [9285] = {.lex_state = 0, .external_lex_state = 7},
  [9286] = {.lex_state = 0, .external_lex_state = 7},
  [9287] = {.lex_state = 0, .external_lex_state = 7},
  [9288] = {.lex_state = 0, .external_lex_state = 7},
  [9289] = {.lex_state = 0, .external_lex_state = 7},
  [9290] = {.lex_state = 0, .external_lex_state = 7},
  [9291] = {.lex_state = 0, .external_lex_state = 7},
  [9292] = {.lex_state = 0, .external_lex_state = 7},
  [9293] = {.lex_state = 0, .external_lex_state = 6},
  [9294] = {.lex_state = 0, .external_lex_state = 6},
  [9295] = {.lex_state = 0, .external_lex_state = 6},
  [9296] = {.lex_state = 0, .external_lex_state = 6},
  [9297] = {.lex_state = 0, .external_lex_state = 7},
  [9298] = {.lex_state = 0, .external_lex_state = 6},
  [9299] = {.lex_state = 0, .external_lex_state = 7},
  [9300] = {.lex_state = 0, .external_lex_state = 6},
  [9301] = {.lex_state = 0, .external_lex_state = 7},
  [9302] = {.lex_state = 0, .external_lex_state = 6},
  [9303] = {.lex_state = 0, .external_lex_state = 7},
  [9304] = {.lex_state = 0, .external_lex_state = 6},
  [9305] = {.lex_state = 0, .external_lex_state = 7},
  [9306] = {.lex_state = 0, .external_lex_state = 7},
  [9307] = {.lex_state = 0, .external_lex_state = 7},
  [9308] = {.lex_state = 0, .external_lex_state = 7},
  [9309] = {.lex_state = 0, .external_lex_state = 7},
  [9310] = {.lex_state = 0, .external_lex_state = 6},
  [9311] = {.lex_state = 0, .external_lex_state = 6},
  [9312] = {.lex_state = 0, .external_lex_state = 6},
  [9313] = {.lex_state = 0, .external_lex_state = 6},
  [9314] = {.lex_state = 0, .external_lex_state = 7},
  [9315] = {.lex_state = 0, .external_lex_state = 7},
  [9316] = {.lex_state = 0, .external_lex_state = 7},
  [9317] = {.lex_state = 0, .external_lex_state = 7},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_package] = ACTIONS(1),
    [anon_sym_foreign] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_proc] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_bit_field] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_POUNDtype] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_defer] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [sym_fallthrough_statement] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_or_else] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_TILDE_EQ] = ACTIONS(1),
    [anon_sym_AMP_TILDE] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_LT] = ACTIONS(1),
    [anon_sym_cast] = ACTIONS(1),
    [anon_sym_transmute] = ACTIONS(1),
    [anon_sym_auto_cast] = ACTIONS(1),
    [anon_sym_not_in] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_or_return] = ACTIONS(1),
    [anon_sym_or_continue] = ACTIONS(1),
    [anon_sym_or_break] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_dynamic] = ACTIONS(1),
    [anon_sym_map] = ACTIONS(1),
    [anon_sym_bit_set] = ACTIONS(1),
    [anon_sym_matrix] = ACTIONS(1),
    [anon_sym_DOT2] = ACTIONS(1),
    [anon_sym_distinct] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [aux_sym__escape_sequence_token1] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_nil] = ACTIONS(1),
    [sym_uninitialized] = ACTIONS(1),
    [sym_tag] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(1),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym_block_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(9187),
    [sym_declaration] = STATE(7402),
    [sym_package_declaration] = STATE(7755),
    [sym_import_declaration] = STATE(7755),
    [sym_procedure_declaration] = STATE(7755),
    [sym_overloaded_procedure_declaration] = STATE(7755),
    [sym_struct_declaration] = STATE(7755),
    [sym_enum_declaration] = STATE(7755),
    [sym_union_declaration] = STATE(7755),
    [sym_bit_field_declaration] = STATE(7755),
    [sym_variable_declaration] = STATE(7755),
    [sym_const_declaration] = STATE(7755),
    [sym_const_type_declaration] = STATE(7755),
    [sym_foreign_block] = STATE(7755),
    [sym_attributes] = STATE(700),
    [sym_attribute] = STATE(6005),
    [sym_when_statement] = STATE(7755),
    [sym_var_declaration] = STATE(7755),
    [sym_expression] = STATE(5643),
    [sym__expression_no_tag] = STATE(4616),
    [sym_unary_expression] = STATE(4616),
    [sym_binary_expression] = STATE(4616),
    [sym_ternary_expression] = STATE(4616),
    [sym_call_expression] = STATE(4616),
    [sym_selector_call_expression] = STATE(4616),
    [sym_member_expression] = STATE(4616),
    [sym_index_expression] = STATE(4616),
    [sym_slice_expression] = STATE(4616),
    [sym_range_expression] = STATE(4616),
    [sym_cast_expression] = STATE(4616),
    [sym_in_expression] = STATE(4616),
    [sym_variadic_expression] = STATE(4616),
    [sym_parenthesized_expression] = STATE(4616),
    [sym_or_return_expression] = STATE(4616),
    [sym_or_continue_expression] = STATE(4616),
    [sym_or_break_expression] = STATE(4616),
    [sym_address] = STATE(4616),
    [sym_map_type] = STATE(4616),
    [sym_matrix_type] = STATE(4616),
    [sym_distinct_type] = STATE(4616),
    [sym_literal] = STATE(4616),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [aux_sym_source_file_repeat1] = STATE(208),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7376),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(67),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [3] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7033),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [4] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7323),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [5] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6991),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [6] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7304),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [7] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7255),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [8] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7366),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [9] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7267),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7229),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [11] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6969),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [12] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6997),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [13] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7239),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [14] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7340),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7278),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [16] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7351),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [17] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7334),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [18] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7303),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [19] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7510),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [20] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7354),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [21] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7232),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [22] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7343),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [23] = {
    [sym_block] = STATE(7416),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7285),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(63),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [24] = {
    [sym_expression] = STATE(1096),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_RBRACE] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_where] = ACTIONS(133),
    [anon_sym_EQ] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(129),
    [anon_sym_DASH_EQ] = ACTIONS(129),
    [anon_sym_STAR_EQ] = ACTIONS(129),
    [anon_sym_SLASH_EQ] = ACTIONS(129),
    [anon_sym_PERCENT_EQ] = ACTIONS(129),
    [anon_sym_AMP_EQ] = ACTIONS(129),
    [anon_sym_PIPE_EQ] = ACTIONS(129),
    [anon_sym_CARET_EQ] = ACTIONS(129),
    [anon_sym_LT_LT_EQ] = ACTIONS(129),
    [anon_sym_GT_GT_EQ] = ACTIONS(129),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(129),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_else] = ACTIONS(133),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(133),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(141),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(133),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(129),
    [sym_tag] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(129),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [25] = {
    [sym_expression] = STATE(1164),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_COLON_COLON] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_where] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_COLON] = ACTIONS(167),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_PLUS_EQ] = ACTIONS(163),
    [anon_sym_DASH_EQ] = ACTIONS(163),
    [anon_sym_STAR_EQ] = ACTIONS(163),
    [anon_sym_SLASH_EQ] = ACTIONS(163),
    [anon_sym_PERCENT_EQ] = ACTIONS(163),
    [anon_sym_AMP_EQ] = ACTIONS(163),
    [anon_sym_PIPE_EQ] = ACTIONS(163),
    [anon_sym_CARET_EQ] = ACTIONS(163),
    [anon_sym_LT_LT_EQ] = ACTIONS(163),
    [anon_sym_GT_GT_EQ] = ACTIONS(163),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(163),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(163),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(163),
    [anon_sym_else] = ACTIONS(167),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_case] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(167),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(167),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(167),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_GT_GT] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(141),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [26] = {
    [sym_expression] = STATE(2355),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_RBRACE] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(129),
    [anon_sym_DASH_EQ] = ACTIONS(129),
    [anon_sym_STAR_EQ] = ACTIONS(129),
    [anon_sym_SLASH_EQ] = ACTIONS(129),
    [anon_sym_PERCENT_EQ] = ACTIONS(129),
    [anon_sym_AMP_EQ] = ACTIONS(129),
    [anon_sym_PIPE_EQ] = ACTIONS(129),
    [anon_sym_CARET_EQ] = ACTIONS(129),
    [anon_sym_LT_LT_EQ] = ACTIONS(129),
    [anon_sym_GT_GT_EQ] = ACTIONS(129),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(129),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_else] = ACTIONS(133),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(133),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(189),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(133),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(129),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [27] = {
    [sym_expression] = STATE(2332),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_COLON_COLON] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_COLON] = ACTIONS(167),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_PLUS_EQ] = ACTIONS(163),
    [anon_sym_DASH_EQ] = ACTIONS(163),
    [anon_sym_STAR_EQ] = ACTIONS(163),
    [anon_sym_SLASH_EQ] = ACTIONS(163),
    [anon_sym_PERCENT_EQ] = ACTIONS(163),
    [anon_sym_AMP_EQ] = ACTIONS(163),
    [anon_sym_PIPE_EQ] = ACTIONS(163),
    [anon_sym_CARET_EQ] = ACTIONS(163),
    [anon_sym_LT_LT_EQ] = ACTIONS(163),
    [anon_sym_GT_GT_EQ] = ACTIONS(163),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(163),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(163),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(163),
    [anon_sym_else] = ACTIONS(167),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_case] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(183),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(183),
    [anon_sym_BANG] = ACTIONS(183),
    [anon_sym_AMP] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(167),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(167),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(167),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_GT_GT] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(189),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [28] = {
    [sym_expression] = STATE(2527),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_RBRACE] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(129),
    [anon_sym_DASH_EQ] = ACTIONS(129),
    [anon_sym_STAR_EQ] = ACTIONS(129),
    [anon_sym_SLASH_EQ] = ACTIONS(129),
    [anon_sym_PERCENT_EQ] = ACTIONS(129),
    [anon_sym_AMP_EQ] = ACTIONS(129),
    [anon_sym_PIPE_EQ] = ACTIONS(129),
    [anon_sym_CARET_EQ] = ACTIONS(129),
    [anon_sym_LT_LT_EQ] = ACTIONS(129),
    [anon_sym_GT_GT_EQ] = ACTIONS(129),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(129),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(133),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(133),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(129),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [29] = {
    [sym_expression] = STATE(2527),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_RBRACE] = ACTIONS(201),
    [anon_sym_COMMA] = ACTIONS(201),
    [anon_sym_COLON_COLON] = ACTIONS(201),
    [anon_sym_DASH_GT] = ACTIONS(201),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(203),
    [anon_sym_PIPE] = ACTIONS(203),
    [anon_sym_COLON_EQ] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_PLUS_EQ] = ACTIONS(201),
    [anon_sym_DASH_EQ] = ACTIONS(201),
    [anon_sym_STAR_EQ] = ACTIONS(201),
    [anon_sym_SLASH_EQ] = ACTIONS(201),
    [anon_sym_PERCENT_EQ] = ACTIONS(201),
    [anon_sym_AMP_EQ] = ACTIONS(201),
    [anon_sym_PIPE_EQ] = ACTIONS(201),
    [anon_sym_CARET_EQ] = ACTIONS(201),
    [anon_sym_LT_LT_EQ] = ACTIONS(201),
    [anon_sym_GT_GT_EQ] = ACTIONS(201),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(201),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(201),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_SEMI] = ACTIONS(201),
    [anon_sym_when] = ACTIONS(203),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_QMARK] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(203),
    [anon_sym_or_else] = ACTIONS(203),
    [anon_sym_AMP_AMP] = ACTIONS(203),
    [anon_sym_GT] = ACTIONS(203),
    [anon_sym_GT_EQ] = ACTIONS(201),
    [anon_sym_LT_EQ] = ACTIONS(201),
    [anon_sym_LT] = ACTIONS(203),
    [anon_sym_EQ_EQ] = ACTIONS(201),
    [anon_sym_BANG_EQ] = ACTIONS(201),
    [anon_sym_TILDE_EQ] = ACTIONS(201),
    [anon_sym_AMP_TILDE] = ACTIONS(203),
    [anon_sym_LT_LT] = ACTIONS(203),
    [anon_sym_GT_GT] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(203),
    [anon_sym_SLASH] = ACTIONS(203),
    [anon_sym_PERCENT] = ACTIONS(203),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(201),
    [anon_sym_DOT] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(201),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(201),
    [anon_sym_DOT_DOT_LT] = ACTIONS(201),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(203),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(203),
    [anon_sym_or_continue] = ACTIONS(203),
    [anon_sym_or_break] = ACTIONS(203),
    [anon_sym_CARET] = ACTIONS(203),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(201),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [30] = {
    [sym_expression] = STATE(2528),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_COLON_COLON] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_COLON] = ACTIONS(167),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_PLUS_EQ] = ACTIONS(163),
    [anon_sym_DASH_EQ] = ACTIONS(163),
    [anon_sym_STAR_EQ] = ACTIONS(163),
    [anon_sym_SLASH_EQ] = ACTIONS(163),
    [anon_sym_PERCENT_EQ] = ACTIONS(163),
    [anon_sym_AMP_EQ] = ACTIONS(163),
    [anon_sym_PIPE_EQ] = ACTIONS(163),
    [anon_sym_CARET_EQ] = ACTIONS(163),
    [anon_sym_LT_LT_EQ] = ACTIONS(163),
    [anon_sym_GT_GT_EQ] = ACTIONS(163),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(163),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(163),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(163),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_case] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(95),
    [anon_sym_AMP] = ACTIONS(95),
    [anon_sym_PIPE_PIPE] = ACTIONS(167),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(167),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(167),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_GT_GT] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(105),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [31] = {
    [sym_expression] = STATE(2294),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_where] = ACTIONS(133),
    [anon_sym_EQ] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(129),
    [anon_sym_DASH_EQ] = ACTIONS(129),
    [anon_sym_STAR_EQ] = ACTIONS(129),
    [anon_sym_SLASH_EQ] = ACTIONS(129),
    [anon_sym_PERCENT_EQ] = ACTIONS(129),
    [anon_sym_AMP_EQ] = ACTIONS(129),
    [anon_sym_PIPE_EQ] = ACTIONS(129),
    [anon_sym_CARET_EQ] = ACTIONS(129),
    [anon_sym_LT_LT_EQ] = ACTIONS(129),
    [anon_sym_GT_GT_EQ] = ACTIONS(129),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(129),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(133),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(133),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(217),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(133),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(129),
    [sym_tag] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [32] = {
    [sym_expression] = STATE(2291),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_COLON_COLON] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_where] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_COLON] = ACTIONS(167),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_PLUS_EQ] = ACTIONS(163),
    [anon_sym_DASH_EQ] = ACTIONS(163),
    [anon_sym_STAR_EQ] = ACTIONS(163),
    [anon_sym_SLASH_EQ] = ACTIONS(163),
    [anon_sym_PERCENT_EQ] = ACTIONS(163),
    [anon_sym_AMP_EQ] = ACTIONS(163),
    [anon_sym_PIPE_EQ] = ACTIONS(163),
    [anon_sym_CARET_EQ] = ACTIONS(163),
    [anon_sym_LT_LT_EQ] = ACTIONS(163),
    [anon_sym_GT_GT_EQ] = ACTIONS(163),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(163),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(163),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(163),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(211),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(211),
    [anon_sym_BANG] = ACTIONS(211),
    [anon_sym_AMP] = ACTIONS(211),
    [anon_sym_PIPE_PIPE] = ACTIONS(167),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(167),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(167),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_GT_GT] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(217),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [33] = {
    [sym_expression] = STATE(2630),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(129),
    [anon_sym_DASH_EQ] = ACTIONS(129),
    [anon_sym_STAR_EQ] = ACTIONS(129),
    [anon_sym_SLASH_EQ] = ACTIONS(129),
    [anon_sym_PERCENT_EQ] = ACTIONS(129),
    [anon_sym_AMP_EQ] = ACTIONS(129),
    [anon_sym_PIPE_EQ] = ACTIONS(129),
    [anon_sym_CARET_EQ] = ACTIONS(129),
    [anon_sym_LT_LT_EQ] = ACTIONS(129),
    [anon_sym_GT_GT_EQ] = ACTIONS(129),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(129),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(133),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(133),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(259),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(133),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [34] = {
    [sym_expression] = STATE(2631),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_COLON] = ACTIONS(167),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_PLUS_EQ] = ACTIONS(163),
    [anon_sym_DASH_EQ] = ACTIONS(163),
    [anon_sym_STAR_EQ] = ACTIONS(163),
    [anon_sym_SLASH_EQ] = ACTIONS(163),
    [anon_sym_PERCENT_EQ] = ACTIONS(163),
    [anon_sym_AMP_EQ] = ACTIONS(163),
    [anon_sym_PIPE_EQ] = ACTIONS(163),
    [anon_sym_CARET_EQ] = ACTIONS(163),
    [anon_sym_LT_LT_EQ] = ACTIONS(163),
    [anon_sym_GT_GT_EQ] = ACTIONS(163),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(163),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(163),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(163),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(253),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(253),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_AMP] = ACTIONS(253),
    [anon_sym_PIPE_PIPE] = ACTIONS(167),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(167),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(167),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_GT_GT] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(259),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [35] = {
    [sym_expression] = STATE(2742),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(129),
    [anon_sym_DASH_EQ] = ACTIONS(129),
    [anon_sym_STAR_EQ] = ACTIONS(129),
    [anon_sym_SLASH_EQ] = ACTIONS(129),
    [anon_sym_PERCENT_EQ] = ACTIONS(129),
    [anon_sym_AMP_EQ] = ACTIONS(129),
    [anon_sym_PIPE_EQ] = ACTIONS(129),
    [anon_sym_CARET_EQ] = ACTIONS(129),
    [anon_sym_LT_LT_EQ] = ACTIONS(129),
    [anon_sym_GT_GT_EQ] = ACTIONS(129),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(129),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_do] = ACTIONS(133),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(133),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(299),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(133),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [36] = {
    [sym_expression] = STATE(2726),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_COLON] = ACTIONS(167),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_PLUS_EQ] = ACTIONS(163),
    [anon_sym_DASH_EQ] = ACTIONS(163),
    [anon_sym_STAR_EQ] = ACTIONS(163),
    [anon_sym_SLASH_EQ] = ACTIONS(163),
    [anon_sym_PERCENT_EQ] = ACTIONS(163),
    [anon_sym_AMP_EQ] = ACTIONS(163),
    [anon_sym_PIPE_EQ] = ACTIONS(163),
    [anon_sym_CARET_EQ] = ACTIONS(163),
    [anon_sym_LT_LT_EQ] = ACTIONS(163),
    [anon_sym_GT_GT_EQ] = ACTIONS(163),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(163),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(163),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(167),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(167),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(167),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_GT_GT] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(299),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [37] = {
    [sym_expression] = STATE(5253),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_COMMA] = ACTIONS(201),
    [anon_sym_DASH_GT] = ACTIONS(201),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(203),
    [anon_sym_PIPE] = ACTIONS(203),
    [anon_sym_COLON_EQ] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_PLUS_EQ] = ACTIONS(201),
    [anon_sym_DASH_EQ] = ACTIONS(201),
    [anon_sym_STAR_EQ] = ACTIONS(201),
    [anon_sym_SLASH_EQ] = ACTIONS(201),
    [anon_sym_PERCENT_EQ] = ACTIONS(201),
    [anon_sym_AMP_EQ] = ACTIONS(201),
    [anon_sym_PIPE_EQ] = ACTIONS(201),
    [anon_sym_CARET_EQ] = ACTIONS(201),
    [anon_sym_LT_LT_EQ] = ACTIONS(201),
    [anon_sym_GT_GT_EQ] = ACTIONS(201),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(201),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(201),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_when] = ACTIONS(203),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_QMARK] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(311),
    [anon_sym_AMP] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(203),
    [anon_sym_or_else] = ACTIONS(203),
    [anon_sym_AMP_AMP] = ACTIONS(203),
    [anon_sym_GT] = ACTIONS(203),
    [anon_sym_GT_EQ] = ACTIONS(201),
    [anon_sym_LT_EQ] = ACTIONS(201),
    [anon_sym_LT] = ACTIONS(203),
    [anon_sym_EQ_EQ] = ACTIONS(201),
    [anon_sym_BANG_EQ] = ACTIONS(201),
    [anon_sym_TILDE_EQ] = ACTIONS(201),
    [anon_sym_AMP_TILDE] = ACTIONS(203),
    [anon_sym_LT_LT] = ACTIONS(203),
    [anon_sym_GT_GT] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(203),
    [anon_sym_SLASH] = ACTIONS(203),
    [anon_sym_PERCENT] = ACTIONS(203),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(201),
    [anon_sym_DOT] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(201),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(201),
    [anon_sym_DOT_DOT_LT] = ACTIONS(201),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_not_in] = ACTIONS(203),
    [anon_sym_DOT_DOT] = ACTIONS(317),
    [anon_sym_or_return] = ACTIONS(203),
    [anon_sym_or_continue] = ACTIONS(203),
    [anon_sym_or_break] = ACTIONS(203),
    [anon_sym_CARET] = ACTIONS(203),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [38] = {
    [sym_expression] = STATE(2774),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_PLUS_EQ] = ACTIONS(129),
    [anon_sym_DASH_EQ] = ACTIONS(129),
    [anon_sym_STAR_EQ] = ACTIONS(129),
    [anon_sym_SLASH_EQ] = ACTIONS(129),
    [anon_sym_PERCENT_EQ] = ACTIONS(129),
    [anon_sym_AMP_EQ] = ACTIONS(129),
    [anon_sym_PIPE_EQ] = ACTIONS(129),
    [anon_sym_CARET_EQ] = ACTIONS(129),
    [anon_sym_LT_LT_EQ] = ACTIONS(129),
    [anon_sym_GT_GT_EQ] = ACTIONS(129),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(129),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(133),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(345),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(133),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(133),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(351),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(133),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [39] = {
    [sym_expression] = STATE(2769),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_COLON_COLON] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_COLON] = ACTIONS(167),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_PLUS_EQ] = ACTIONS(163),
    [anon_sym_DASH_EQ] = ACTIONS(163),
    [anon_sym_STAR_EQ] = ACTIONS(163),
    [anon_sym_SLASH_EQ] = ACTIONS(163),
    [anon_sym_PERCENT_EQ] = ACTIONS(163),
    [anon_sym_AMP_EQ] = ACTIONS(163),
    [anon_sym_PIPE_EQ] = ACTIONS(163),
    [anon_sym_CARET_EQ] = ACTIONS(163),
    [anon_sym_LT_LT_EQ] = ACTIONS(163),
    [anon_sym_GT_GT_EQ] = ACTIONS(163),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(163),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(163),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(345),
    [anon_sym_BANG] = ACTIONS(345),
    [anon_sym_AMP] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(167),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(167),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(167),
    [anon_sym_LT_LT] = ACTIONS(167),
    [anon_sym_GT_GT] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(351),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [40] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7562),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(385),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(383),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [41] = {
    [sym_expression] = STATE(5866),
    [sym__expression_no_tag] = STATE(5195),
    [sym_unary_expression] = STATE(5195),
    [sym_binary_expression] = STATE(5195),
    [sym_ternary_expression] = STATE(5195),
    [sym_call_expression] = STATE(5195),
    [sym_selector_call_expression] = STATE(5195),
    [sym_member_expression] = STATE(5195),
    [sym_index_expression] = STATE(5195),
    [sym_slice_expression] = STATE(5195),
    [sym_range_expression] = STATE(5195),
    [sym_cast_expression] = STATE(5195),
    [sym_in_expression] = STATE(5195),
    [sym_variadic_expression] = STATE(5195),
    [sym_parenthesized_expression] = STATE(5195),
    [sym_or_return_expression] = STATE(5195),
    [sym_or_continue_expression] = STATE(5195),
    [sym_or_break_expression] = STATE(5195),
    [sym_address] = STATE(5195),
    [sym_map_type] = STATE(5195),
    [sym_matrix_type] = STATE(5195),
    [sym_distinct_type] = STATE(5195),
    [sym_literal] = STATE(5195),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(311),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(317),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [42] = {
    [sym_expression] = STATE(5932),
    [sym__expression_no_tag] = STATE(5195),
    [sym_unary_expression] = STATE(5195),
    [sym_binary_expression] = STATE(5195),
    [sym_ternary_expression] = STATE(5195),
    [sym_call_expression] = STATE(5195),
    [sym_selector_call_expression] = STATE(5195),
    [sym_member_expression] = STATE(5195),
    [sym_index_expression] = STATE(5195),
    [sym_slice_expression] = STATE(5195),
    [sym_range_expression] = STATE(5195),
    [sym_cast_expression] = STATE(5195),
    [sym_in_expression] = STATE(5195),
    [sym_variadic_expression] = STATE(5195),
    [sym_parenthesized_expression] = STATE(5195),
    [sym_or_return_expression] = STATE(5195),
    [sym_or_continue_expression] = STATE(5195),
    [sym_or_break_expression] = STATE(5195),
    [sym_address] = STATE(5195),
    [sym_map_type] = STATE(5195),
    [sym_matrix_type] = STATE(5195),
    [sym_distinct_type] = STATE(5195),
    [sym_literal] = STATE(5195),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(311),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(317),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [43] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7308),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3031),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_struct_field] = STATE(7970),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [44] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7308),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3031),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_struct_field] = STATE(8274),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [45] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7071),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(403),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(405),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [46] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7019),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(409),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(411),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [47] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7144),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(417),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(419),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [48] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7308),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3031),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_struct_field] = STATE(7646),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [49] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7028),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(409),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(411),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(423),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [50] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7308),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3031),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_struct_field] = STATE(8361),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [51] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7359),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(427),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [52] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7214),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(431),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [53] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7284),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(435),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [54] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7262),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(439),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [55] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7349),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(443),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [56] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7364),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(447),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(449),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [57] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7257),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(451),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [58] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7346),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(457),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [59] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7383),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(461),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [60] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7378),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(465),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [61] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7211),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(467),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [62] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7308),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(471),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [63] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7320),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(473),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(475),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [64] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7283),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(477),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [65] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7223),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(483),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [66] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7215),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(485),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(487),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [67] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7379),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_RBRACE] = ACTIONS(489),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(491),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [68] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7171),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [69] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7010),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [70] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7149),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [71] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7202),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [72] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6807),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [73] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7188),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [74] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7063),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [75] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6799),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [76] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6804),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [77] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6817),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [78] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7059),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [79] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7182),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [80] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6902),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [81] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6995),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [82] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6889),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [83] = {
    [sym_expression] = STATE(3334),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_COLON_COLON] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_where] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_COLON] = ACTIONS(167),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(163),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_else] = ACTIONS(167),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(517),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_AMP] = ACTIONS(517),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(527),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [84] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7089),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [85] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7110),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [86] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6943),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [87] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6952),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [88] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7154),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [89] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6901),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [90] = {
    [sym_expression] = STATE(3302),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_RBRACE] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_where] = ACTIONS(133),
    [anon_sym_EQ] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(133),
    [anon_sym_else] = ACTIONS(133),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_RBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(527),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(129),
    [sym_tag] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [91] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6863),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [92] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7024),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [93] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7171),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6888),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [95] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7188),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [96] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6987),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [97] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7167),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [98] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7202),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [99] = {
    [sym_expression] = STATE(3160),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_COLON_COLON] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_where] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_COLON] = ACTIONS(167),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(163),
    [anon_sym_else] = ACTIONS(167),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_case] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(561),
    [anon_sym_BANG] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [100] = {
    [sym_expression] = STATE(3163),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_RBRACE] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_where] = ACTIONS(133),
    [anon_sym_EQ] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_else] = ACTIONS(133),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(129),
    [sym_tag] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(129),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [101] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7093),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [102] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7182),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [103] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6987),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [104] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7063),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [105] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7167),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [106] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7187),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [107] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7149),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [108] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7072),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [109] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7154),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [110] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7074),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [111] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6995),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [112] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7116),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [113] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7187),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3177),
    [sym__expression_no_tag] = STATE(2552),
    [sym_unary_expression] = STATE(2552),
    [sym_binary_expression] = STATE(2552),
    [sym_ternary_expression] = STATE(2552),
    [sym_call_expression] = STATE(2552),
    [sym_selector_call_expression] = STATE(2552),
    [sym_member_expression] = STATE(2552),
    [sym_index_expression] = STATE(2552),
    [sym_slice_expression] = STATE(2552),
    [sym_range_expression] = STATE(2552),
    [sym_cast_expression] = STATE(2552),
    [sym_in_expression] = STATE(2552),
    [sym_variadic_expression] = STATE(2552),
    [sym_parenthesized_expression] = STATE(2552),
    [sym_or_return_expression] = STATE(2552),
    [sym_or_continue_expression] = STATE(2552),
    [sym_or_break_expression] = STATE(2552),
    [sym_address] = STATE(2552),
    [sym_map_type] = STATE(2552),
    [sym_matrix_type] = STATE(2552),
    [sym_distinct_type] = STATE(2552),
    [sym_literal] = STATE(2552),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_when] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(83),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(93),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [114] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7074),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [115] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7072),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [116] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7010),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [117] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7093),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [118] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7089),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6822),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [120] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(7110),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6943),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [122] = {
    [sym_block] = STATE(6954),
    [sym_tagged_block] = STATE(6954),
    [sym_import_declaration] = STATE(6954),
    [sym_procedure_declaration] = STATE(6954),
    [sym_overloaded_procedure_declaration] = STATE(6954),
    [sym_struct_declaration] = STATE(6954),
    [sym_enum_declaration] = STATE(6954),
    [sym_union_declaration] = STATE(6954),
    [sym_bit_field_declaration] = STATE(6954),
    [sym_const_declaration] = STATE(6954),
    [sym_foreign_block] = STATE(6954),
    [sym_attributes] = STATE(695),
    [sym_attribute] = STATE(6005),
    [sym_statement] = STATE(6952),
    [sym_assignment_statement] = STATE(6954),
    [sym_update_statement] = STATE(6954),
    [sym_if_statement] = STATE(6954),
    [sym_when_statement] = STATE(6954),
    [sym_for_statement] = STATE(6954),
    [sym_switch_statement] = STATE(6954),
    [sym_defer_statement] = STATE(6954),
    [sym_break_statement] = STATE(6954),
    [sym_continue_statement] = STATE(6954),
    [sym_var_declaration] = STATE(6954),
    [sym_return_statement] = STATE(6954),
    [sym_label_statement] = STATE(6954),
    [sym_using_statement] = STATE(6954),
    [sym_expression] = STATE(3281),
    [sym__expression_no_tag] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_ternary_expression] = STATE(2443),
    [sym_call_expression] = STATE(2443),
    [sym_selector_call_expression] = STATE(2443),
    [sym_member_expression] = STATE(2443),
    [sym_index_expression] = STATE(2443),
    [sym_slice_expression] = STATE(2443),
    [sym_range_expression] = STATE(2443),
    [sym_cast_expression] = STATE(2443),
    [sym_in_expression] = STATE(2443),
    [sym_variadic_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_or_return_expression] = STATE(2443),
    [sym_or_continue_expression] = STATE(2443),
    [sym_or_break_expression] = STATE(2443),
    [sym_address] = STATE(2443),
    [sym_map_type] = STATE(2443),
    [sym_matrix_type] = STATE(2443),
    [sym_distinct_type] = STATE(2443),
    [sym_literal] = STATE(2443),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(69),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_defer] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(85),
    [anon_sym_continue] = ACTIONS(87),
    [sym_fallthrough_statement] = ACTIONS(89),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_QMARK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [123] = {
    [sym_procedure] = STATE(7022),
    [sym_expression] = STATE(4833),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_pointer_type] = STATE(6850),
    [sym_array_type] = STATE(6850),
    [sym_map_type] = STATE(4596),
    [sym_bit_set_type] = STATE(6850),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(67),
    [sym_identifier] = ACTIONS(595),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_POUNDtype] = ACTIONS(599),
    [anon_sym_LPAREN] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(607),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(613),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(615),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(67),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [124] = {
    [sym_procedure] = STATE(6978),
    [sym_expression] = STATE(4840),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_pointer_type] = STATE(6890),
    [sym_array_type] = STATE(6890),
    [sym_map_type] = STATE(4596),
    [sym_bit_set_type] = STATE(6890),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(67),
    [sym_identifier] = ACTIONS(595),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_POUNDtype] = ACTIONS(619),
    [anon_sym_LPAREN] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(607),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(613),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(615),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(67),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [125] = {
    [sym_expression] = STATE(4131),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_COLON_COLON] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_COLON] = ACTIONS(167),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(163),
    [anon_sym_else] = ACTIONS(167),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AMP] = ACTIONS(631),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [126] = {
    [sym_expression] = STATE(3511),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_RBRACE] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_where] = ACTIONS(133),
    [anon_sym_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_else] = ACTIONS(133),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(667),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(129),
    [sym_tag] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(129),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(129),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [127] = {
    [sym_expression] = STATE(4010),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_COLON] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_else] = ACTIONS(133),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(695),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(129),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [128] = {
    [sym_expression] = STATE(4125),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_COLON_COLON] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_COLON] = ACTIONS(167),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(163),
    [anon_sym_else] = ACTIONS(167),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_case] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(29),
    [anon_sym_BANG] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(29),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(695),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [129] = {
    [sym_expression] = STATE(4069),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_else] = ACTIONS(133),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(631),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_RBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(641),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [130] = {
    [sym_expression] = STATE(3467),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_where] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(163),
    [anon_sym_else] = ACTIONS(167),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_case] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(667),
    [anon_sym_BANG] = ACTIONS(667),
    [anon_sym_AMP] = ACTIONS(667),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(673),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(163),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [131] = {
    [sym_expression] = STATE(4838),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_pointer_type] = STATE(6897),
    [sym_array_type] = STATE(6897),
    [sym_map_type] = STATE(4596),
    [sym_bit_set_type] = STATE(6897),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(67),
    [sym_identifier] = ACTIONS(595),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_POUNDtype] = ACTIONS(715),
    [anon_sym_LPAREN] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(607),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(613),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(615),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(67),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [132] = {
    [sym_expression] = STATE(4840),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_pointer_type] = STATE(6890),
    [sym_array_type] = STATE(6890),
    [sym_map_type] = STATE(4596),
    [sym_bit_set_type] = STATE(6890),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(67),
    [sym_identifier] = ACTIONS(595),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_POUNDtype] = ACTIONS(619),
    [anon_sym_LPAREN] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(607),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(613),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(615),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(67),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [133] = {
    [sym_procedure] = STATE(4444),
    [sym_expression] = STATE(4797),
    [sym__expression_no_tag] = STATE(4440),
    [sym_unary_expression] = STATE(4440),
    [sym_binary_expression] = STATE(4440),
    [sym_ternary_expression] = STATE(4440),
    [sym_call_expression] = STATE(4440),
    [sym_selector_call_expression] = STATE(4440),
    [sym_member_expression] = STATE(4440),
    [sym_index_expression] = STATE(4440),
    [sym_slice_expression] = STATE(4440),
    [sym_range_expression] = STATE(4440),
    [sym_cast_expression] = STATE(4440),
    [sym_in_expression] = STATE(4440),
    [sym_variadic_expression] = STATE(4440),
    [sym_parenthesized_expression] = STATE(4440),
    [sym_or_return_expression] = STATE(4440),
    [sym_or_continue_expression] = STATE(4440),
    [sym_or_break_expression] = STATE(4440),
    [sym_address] = STATE(4440),
    [sym_map_type] = STATE(4440),
    [sym_matrix_type] = STATE(4440),
    [sym__procedure_type] = STATE(6840),
    [sym_distinct_type] = STATE(4440),
    [sym_literal] = STATE(4440),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [ts_builtin_sym_end] = ACTIONS(717),
    [sym_identifier] = ACTIONS(719),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_RBRACE] = ACTIONS(717),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_proc] = ACTIONS(723),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(717),
    [anon_sym_else] = ACTIONS(727),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_case] = ACTIONS(727),
    [anon_sym_QMARK] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(743),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(717),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(67),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [134] = {
    [sym_procedure] = STATE(1064),
    [sym_type] = STATE(854),
    [sym_pointer_type] = STATE(1032),
    [sym_variadic_type] = STATE(1032),
    [sym_array_type] = STATE(1032),
    [sym_map_type] = STATE(1032),
    [sym_union_type] = STATE(1032),
    [sym_bit_set_type] = STATE(1032),
    [sym_matrix_type] = STATE(1032),
    [sym_field_type] = STATE(1032),
    [sym_tuple_type] = STATE(1032),
    [sym_struct_type] = STATE(1032),
    [sym_enum_type] = STATE(1032),
    [sym_bit_field_type] = STATE(1032),
    [sym_constant_type] = STATE(1032),
    [sym_specialized_type] = STATE(1032),
    [sym__procedure_type] = STATE(1032),
    [sym_distinct_type] = STATE(1032),
    [sym_empty_type] = STATE(1032),
    [sym_polymorphic_type] = STATE(1032),
    [sym_conditional_type] = STATE(1032),
    [ts_builtin_sym_end] = ACTIONS(767),
    [sym_identifier] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_COLON_COLON] = ACTIONS(767),
    [anon_sym_proc] = ACTIONS(771),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_where] = ACTIONS(773),
    [anon_sym_struct] = ACTIONS(775),
    [anon_sym_enum] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_union] = ACTIONS(779),
    [anon_sym_bit_field] = ACTIONS(781),
    [anon_sym_COLON] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_COLON_EQ] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(783),
    [anon_sym_DOLLAR] = ACTIONS(786),
    [anon_sym_PLUS_EQ] = ACTIONS(767),
    [anon_sym_DASH_EQ] = ACTIONS(767),
    [anon_sym_STAR_EQ] = ACTIONS(767),
    [anon_sym_SLASH_EQ] = ACTIONS(767),
    [anon_sym_PERCENT_EQ] = ACTIONS(767),
    [anon_sym_AMP_EQ] = ACTIONS(767),
    [anon_sym_PIPE_EQ] = ACTIONS(767),
    [anon_sym_CARET_EQ] = ACTIONS(767),
    [anon_sym_LT_LT_EQ] = ACTIONS(767),
    [anon_sym_GT_GT_EQ] = ACTIONS(767),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(767),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_else] = ACTIONS(773),
    [anon_sym_when] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(773),
    [anon_sym_case] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(788),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_or_else] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(773),
    [anon_sym_LT_LT] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(790),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(793),
    [anon_sym_or_return] = ACTIONS(773),
    [anon_sym_or_continue] = ACTIONS(773),
    [anon_sym_or_break] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(798),
    [anon_sym_map] = ACTIONS(800),
    [anon_sym_bit_set] = ACTIONS(802),
    [anon_sym_matrix] = ACTIONS(804),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_uninitialized] = ACTIONS(767),
    [sym_tag] = ACTIONS(806),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(767),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [135] = {
    [sym_expression] = STATE(4448),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(163),
    [anon_sym_else] = ACTIONS(167),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_case] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(733),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(743),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(163),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [136] = {
    [sym_procedure] = STATE(1064),
    [sym_type] = STATE(988),
    [sym_pointer_type] = STATE(1032),
    [sym_variadic_type] = STATE(1032),
    [sym_array_type] = STATE(1032),
    [sym_map_type] = STATE(1032),
    [sym_union_type] = STATE(1032),
    [sym_bit_set_type] = STATE(1032),
    [sym_matrix_type] = STATE(1032),
    [sym_field_type] = STATE(1032),
    [sym_tuple_type] = STATE(1032),
    [sym_struct_type] = STATE(1032),
    [sym_enum_type] = STATE(1032),
    [sym_bit_field_type] = STATE(1032),
    [sym_constant_type] = STATE(1032),
    [sym_specialized_type] = STATE(1032),
    [sym__procedure_type] = STATE(1032),
    [sym_distinct_type] = STATE(1032),
    [sym_empty_type] = STATE(1032),
    [sym_polymorphic_type] = STATE(1032),
    [sym_conditional_type] = STATE(1032),
    [ts_builtin_sym_end] = ACTIONS(815),
    [sym_identifier] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_COLON_COLON] = ACTIONS(815),
    [anon_sym_proc] = ACTIONS(771),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_where] = ACTIONS(818),
    [anon_sym_struct] = ACTIONS(775),
    [anon_sym_enum] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_union] = ACTIONS(779),
    [anon_sym_bit_field] = ACTIONS(781),
    [anon_sym_COLON] = ACTIONS(818),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_COLON_EQ] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(821),
    [anon_sym_DOLLAR] = ACTIONS(786),
    [anon_sym_PLUS_EQ] = ACTIONS(815),
    [anon_sym_DASH_EQ] = ACTIONS(815),
    [anon_sym_STAR_EQ] = ACTIONS(815),
    [anon_sym_SLASH_EQ] = ACTIONS(815),
    [anon_sym_PERCENT_EQ] = ACTIONS(815),
    [anon_sym_AMP_EQ] = ACTIONS(815),
    [anon_sym_PIPE_EQ] = ACTIONS(815),
    [anon_sym_CARET_EQ] = ACTIONS(815),
    [anon_sym_LT_LT_EQ] = ACTIONS(815),
    [anon_sym_GT_GT_EQ] = ACTIONS(815),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(815),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_else] = ACTIONS(818),
    [anon_sym_when] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(818),
    [anon_sym_case] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(818),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(788),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(818),
    [anon_sym_or_else] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(818),
    [anon_sym_LT_LT] = ACTIONS(818),
    [anon_sym_GT_GT] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(818),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(825),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(818),
    [anon_sym_DOT_DOT] = ACTIONS(793),
    [anon_sym_or_return] = ACTIONS(818),
    [anon_sym_or_continue] = ACTIONS(818),
    [anon_sym_or_break] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(798),
    [anon_sym_map] = ACTIONS(800),
    [anon_sym_bit_set] = ACTIONS(802),
    [anon_sym_matrix] = ACTIONS(804),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_uninitialized] = ACTIONS(815),
    [sym_tag] = ACTIONS(833),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [137] = {
    [sym_procedure] = STATE(1064),
    [sym_type] = STATE(999),
    [sym_pointer_type] = STATE(1032),
    [sym_variadic_type] = STATE(1032),
    [sym_array_type] = STATE(1032),
    [sym_map_type] = STATE(1032),
    [sym_union_type] = STATE(1032),
    [sym_bit_set_type] = STATE(1032),
    [sym_matrix_type] = STATE(1032),
    [sym_field_type] = STATE(1032),
    [sym_tuple_type] = STATE(1032),
    [sym_struct_type] = STATE(1032),
    [sym_enum_type] = STATE(1032),
    [sym_bit_field_type] = STATE(1032),
    [sym_constant_type] = STATE(1032),
    [sym_specialized_type] = STATE(1032),
    [sym__procedure_type] = STATE(1032),
    [sym_distinct_type] = STATE(1032),
    [sym_empty_type] = STATE(1032),
    [sym_polymorphic_type] = STATE(1032),
    [sym_conditional_type] = STATE(1032),
    [ts_builtin_sym_end] = ACTIONS(837),
    [sym_identifier] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_COLON_COLON] = ACTIONS(837),
    [anon_sym_proc] = ACTIONS(771),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_where] = ACTIONS(840),
    [anon_sym_struct] = ACTIONS(775),
    [anon_sym_enum] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(840),
    [anon_sym_union] = ACTIONS(779),
    [anon_sym_bit_field] = ACTIONS(781),
    [anon_sym_COLON] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COLON_EQ] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(843),
    [anon_sym_DOLLAR] = ACTIONS(786),
    [anon_sym_PLUS_EQ] = ACTIONS(837),
    [anon_sym_DASH_EQ] = ACTIONS(837),
    [anon_sym_STAR_EQ] = ACTIONS(837),
    [anon_sym_SLASH_EQ] = ACTIONS(837),
    [anon_sym_PERCENT_EQ] = ACTIONS(837),
    [anon_sym_AMP_EQ] = ACTIONS(837),
    [anon_sym_PIPE_EQ] = ACTIONS(837),
    [anon_sym_CARET_EQ] = ACTIONS(837),
    [anon_sym_LT_LT_EQ] = ACTIONS(837),
    [anon_sym_GT_GT_EQ] = ACTIONS(837),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(837),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_when] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_case] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(788),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(840),
    [anon_sym_or_else] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(840),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_TILDE_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE] = ACTIONS(840),
    [anon_sym_LT_LT] = ACTIONS(840),
    [anon_sym_GT_GT] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(847),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_DOT_DOT_LT] = ACTIONS(837),
    [anon_sym_not_in] = ACTIONS(840),
    [anon_sym_DOT_DOT] = ACTIONS(793),
    [anon_sym_or_return] = ACTIONS(840),
    [anon_sym_or_continue] = ACTIONS(840),
    [anon_sym_or_break] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(798),
    [anon_sym_map] = ACTIONS(800),
    [anon_sym_bit_set] = ACTIONS(802),
    [anon_sym_matrix] = ACTIONS(804),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_uninitialized] = ACTIONS(837),
    [sym_tag] = ACTIONS(855),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(837),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [138] = {
    [sym_procedure] = STATE(1064),
    [sym_type] = STATE(848),
    [sym_pointer_type] = STATE(1032),
    [sym_variadic_type] = STATE(1032),
    [sym_array_type] = STATE(1032),
    [sym_map_type] = STATE(1032),
    [sym_union_type] = STATE(1032),
    [sym_bit_set_type] = STATE(1032),
    [sym_matrix_type] = STATE(1032),
    [sym_field_type] = STATE(1032),
    [sym_tuple_type] = STATE(1032),
    [sym_struct_type] = STATE(1032),
    [sym_enum_type] = STATE(1032),
    [sym_bit_field_type] = STATE(1032),
    [sym_constant_type] = STATE(1032),
    [sym_specialized_type] = STATE(1032),
    [sym__procedure_type] = STATE(1032),
    [sym_distinct_type] = STATE(1032),
    [sym_empty_type] = STATE(1032),
    [sym_polymorphic_type] = STATE(1032),
    [sym_conditional_type] = STATE(1032),
    [ts_builtin_sym_end] = ACTIONS(859),
    [sym_identifier] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(859),
    [anon_sym_proc] = ACTIONS(771),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_where] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(775),
    [anon_sym_enum] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_union] = ACTIONS(779),
    [anon_sym_bit_field] = ACTIONS(781),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(863),
    [anon_sym_DOLLAR] = ACTIONS(786),
    [anon_sym_PLUS_EQ] = ACTIONS(859),
    [anon_sym_DASH_EQ] = ACTIONS(859),
    [anon_sym_STAR_EQ] = ACTIONS(859),
    [anon_sym_SLASH_EQ] = ACTIONS(859),
    [anon_sym_PERCENT_EQ] = ACTIONS(859),
    [anon_sym_AMP_EQ] = ACTIONS(859),
    [anon_sym_PIPE_EQ] = ACTIONS(859),
    [anon_sym_CARET_EQ] = ACTIONS(859),
    [anon_sym_LT_LT_EQ] = ACTIONS(859),
    [anon_sym_GT_GT_EQ] = ACTIONS(859),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(859),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_else] = ACTIONS(861),
    [anon_sym_when] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_case] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(861),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(788),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_or_else] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(861),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(866),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(861),
    [anon_sym_DOT_DOT] = ACTIONS(793),
    [anon_sym_or_return] = ACTIONS(861),
    [anon_sym_or_continue] = ACTIONS(861),
    [anon_sym_or_break] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(798),
    [anon_sym_map] = ACTIONS(800),
    [anon_sym_bit_set] = ACTIONS(802),
    [anon_sym_matrix] = ACTIONS(804),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_uninitialized] = ACTIONS(859),
    [sym_tag] = ACTIONS(872),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(859),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [139] = {
    [sym_procedure] = STATE(1064),
    [sym_type] = STATE(928),
    [sym_pointer_type] = STATE(1032),
    [sym_variadic_type] = STATE(1032),
    [sym_array_type] = STATE(1032),
    [sym_map_type] = STATE(1032),
    [sym_union_type] = STATE(1032),
    [sym_bit_set_type] = STATE(1032),
    [sym_matrix_type] = STATE(1032),
    [sym_field_type] = STATE(1032),
    [sym_tuple_type] = STATE(1032),
    [sym_struct_type] = STATE(1032),
    [sym_enum_type] = STATE(1032),
    [sym_bit_field_type] = STATE(1032),
    [sym_constant_type] = STATE(1032),
    [sym_specialized_type] = STATE(1032),
    [sym__procedure_type] = STATE(1032),
    [sym_distinct_type] = STATE(1032),
    [sym_empty_type] = STATE(1032),
    [sym_polymorphic_type] = STATE(1032),
    [sym_conditional_type] = STATE(1032),
    [ts_builtin_sym_end] = ACTIONS(875),
    [sym_identifier] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(875),
    [anon_sym_proc] = ACTIONS(771),
    [anon_sym_DASH_GT] = ACTIONS(875),
    [anon_sym_where] = ACTIONS(877),
    [anon_sym_struct] = ACTIONS(775),
    [anon_sym_enum] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_union] = ACTIONS(779),
    [anon_sym_bit_field] = ACTIONS(781),
    [anon_sym_COLON] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_COLON_EQ] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(786),
    [anon_sym_PLUS_EQ] = ACTIONS(875),
    [anon_sym_DASH_EQ] = ACTIONS(875),
    [anon_sym_STAR_EQ] = ACTIONS(875),
    [anon_sym_SLASH_EQ] = ACTIONS(875),
    [anon_sym_PERCENT_EQ] = ACTIONS(875),
    [anon_sym_AMP_EQ] = ACTIONS(875),
    [anon_sym_PIPE_EQ] = ACTIONS(875),
    [anon_sym_CARET_EQ] = ACTIONS(875),
    [anon_sym_LT_LT_EQ] = ACTIONS(875),
    [anon_sym_GT_GT_EQ] = ACTIONS(875),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(875),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(875),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_else] = ACTIONS(877),
    [anon_sym_when] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_case] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(788),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(877),
    [anon_sym_or_else] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(877),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_TILDE_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE] = ACTIONS(877),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_GT_GT] = ACTIONS(877),
    [anon_sym_STAR] = ACTIONS(877),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(882),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(875),
    [anon_sym_DOT_DOT_LT] = ACTIONS(875),
    [anon_sym_not_in] = ACTIONS(877),
    [anon_sym_DOT_DOT] = ACTIONS(793),
    [anon_sym_or_return] = ACTIONS(877),
    [anon_sym_or_continue] = ACTIONS(877),
    [anon_sym_or_break] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(798),
    [anon_sym_map] = ACTIONS(800),
    [anon_sym_bit_set] = ACTIONS(802),
    [anon_sym_matrix] = ACTIONS(804),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_uninitialized] = ACTIONS(875),
    [sym_tag] = ACTIONS(888),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(875),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [140] = {
    [sym_expression] = STATE(4441),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [ts_builtin_sym_end] = ACTIONS(201),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_RBRACE] = ACTIONS(201),
    [anon_sym_COMMA] = ACTIONS(201),
    [anon_sym_DASH_GT] = ACTIONS(201),
    [anon_sym_PIPE] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_SEMI] = ACTIONS(201),
    [anon_sym_else] = ACTIONS(203),
    [anon_sym_when] = ACTIONS(203),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_QMARK] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_DASH] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(201),
    [anon_sym_or_else] = ACTIONS(203),
    [anon_sym_AMP_AMP] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(203),
    [anon_sym_GT_EQ] = ACTIONS(201),
    [anon_sym_LT_EQ] = ACTIONS(201),
    [anon_sym_LT] = ACTIONS(203),
    [anon_sym_EQ_EQ] = ACTIONS(201),
    [anon_sym_BANG_EQ] = ACTIONS(201),
    [anon_sym_TILDE_EQ] = ACTIONS(201),
    [anon_sym_AMP_TILDE] = ACTIONS(201),
    [anon_sym_LT_LT] = ACTIONS(201),
    [anon_sym_GT_GT] = ACTIONS(201),
    [anon_sym_STAR] = ACTIONS(201),
    [anon_sym_SLASH] = ACTIONS(203),
    [anon_sym_PERCENT] = ACTIONS(203),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(201),
    [anon_sym_DOT] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(201),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(201),
    [anon_sym_DOT_DOT_LT] = ACTIONS(201),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_not_in] = ACTIONS(203),
    [anon_sym_DOT_DOT] = ACTIONS(743),
    [anon_sym_or_return] = ACTIONS(203),
    [anon_sym_or_continue] = ACTIONS(203),
    [anon_sym_or_break] = ACTIONS(203),
    [anon_sym_CARET] = ACTIONS(201),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(201),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(201),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [141] = {
    [sym_expression] = STATE(4441),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_RBRACE] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_else] = ACTIONS(133),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(733),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(743),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(129),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(129),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [142] = {
    [sym_procedure] = STATE(1064),
    [sym_type] = STATE(889),
    [sym_pointer_type] = STATE(1032),
    [sym_variadic_type] = STATE(1032),
    [sym_array_type] = STATE(1032),
    [sym_map_type] = STATE(1032),
    [sym_union_type] = STATE(1032),
    [sym_bit_set_type] = STATE(1032),
    [sym_matrix_type] = STATE(1032),
    [sym_field_type] = STATE(1032),
    [sym_tuple_type] = STATE(1032),
    [sym_struct_type] = STATE(1032),
    [sym_enum_type] = STATE(1032),
    [sym_bit_field_type] = STATE(1032),
    [sym_constant_type] = STATE(1032),
    [sym_specialized_type] = STATE(1032),
    [sym__procedure_type] = STATE(1032),
    [sym_distinct_type] = STATE(1032),
    [sym_empty_type] = STATE(1032),
    [sym_polymorphic_type] = STATE(1032),
    [sym_conditional_type] = STATE(1032),
    [ts_builtin_sym_end] = ACTIONS(891),
    [sym_identifier] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [anon_sym_proc] = ACTIONS(771),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(894),
    [anon_sym_struct] = ACTIONS(775),
    [anon_sym_enum] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_union] = ACTIONS(779),
    [anon_sym_bit_field] = ACTIONS(781),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COLON_EQ] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(897),
    [anon_sym_DOLLAR] = ACTIONS(786),
    [anon_sym_PLUS_EQ] = ACTIONS(891),
    [anon_sym_DASH_EQ] = ACTIONS(891),
    [anon_sym_STAR_EQ] = ACTIONS(891),
    [anon_sym_SLASH_EQ] = ACTIONS(891),
    [anon_sym_PERCENT_EQ] = ACTIONS(891),
    [anon_sym_AMP_EQ] = ACTIONS(891),
    [anon_sym_PIPE_EQ] = ACTIONS(891),
    [anon_sym_CARET_EQ] = ACTIONS(891),
    [anon_sym_LT_LT_EQ] = ACTIONS(891),
    [anon_sym_GT_GT_EQ] = ACTIONS(891),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(891),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_when] = ACTIONS(894),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_case] = ACTIONS(894),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(788),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(894),
    [anon_sym_or_else] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(894),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(901),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(793),
    [anon_sym_or_return] = ACTIONS(894),
    [anon_sym_or_continue] = ACTIONS(894),
    [anon_sym_or_break] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(798),
    [anon_sym_map] = ACTIONS(800),
    [anon_sym_bit_set] = ACTIONS(802),
    [anon_sym_matrix] = ACTIONS(804),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_uninitialized] = ACTIONS(891),
    [sym_tag] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(891),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [143] = {
    [sym_procedure] = STATE(1064),
    [sym_type] = STATE(983),
    [sym_pointer_type] = STATE(1032),
    [sym_variadic_type] = STATE(1032),
    [sym_array_type] = STATE(1032),
    [sym_map_type] = STATE(1032),
    [sym_union_type] = STATE(1032),
    [sym_bit_set_type] = STATE(1032),
    [sym_matrix_type] = STATE(1032),
    [sym_field_type] = STATE(1032),
    [sym_tuple_type] = STATE(1032),
    [sym_struct_type] = STATE(1032),
    [sym_enum_type] = STATE(1032),
    [sym_bit_field_type] = STATE(1032),
    [sym_constant_type] = STATE(1032),
    [sym_specialized_type] = STATE(1032),
    [sym__procedure_type] = STATE(1032),
    [sym_distinct_type] = STATE(1032),
    [sym_empty_type] = STATE(1032),
    [sym_polymorphic_type] = STATE(1032),
    [sym_conditional_type] = STATE(1032),
    [ts_builtin_sym_end] = ACTIONS(913),
    [sym_identifier] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_COLON_COLON] = ACTIONS(913),
    [anon_sym_proc] = ACTIONS(771),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_where] = ACTIONS(915),
    [anon_sym_struct] = ACTIONS(775),
    [anon_sym_enum] = ACTIONS(777),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_union] = ACTIONS(779),
    [anon_sym_bit_field] = ACTIONS(781),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_COLON_EQ] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(917),
    [anon_sym_DOLLAR] = ACTIONS(786),
    [anon_sym_PLUS_EQ] = ACTIONS(913),
    [anon_sym_DASH_EQ] = ACTIONS(913),
    [anon_sym_STAR_EQ] = ACTIONS(913),
    [anon_sym_SLASH_EQ] = ACTIONS(913),
    [anon_sym_PERCENT_EQ] = ACTIONS(913),
    [anon_sym_AMP_EQ] = ACTIONS(913),
    [anon_sym_PIPE_EQ] = ACTIONS(913),
    [anon_sym_CARET_EQ] = ACTIONS(913),
    [anon_sym_LT_LT_EQ] = ACTIONS(913),
    [anon_sym_GT_GT_EQ] = ACTIONS(913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(913),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_else] = ACTIONS(915),
    [anon_sym_when] = ACTIONS(915),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_case] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(788),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(915),
    [anon_sym_or_else] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(915),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(920),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(793),
    [anon_sym_or_return] = ACTIONS(915),
    [anon_sym_or_continue] = ACTIONS(915),
    [anon_sym_or_break] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(923),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(798),
    [anon_sym_map] = ACTIONS(800),
    [anon_sym_bit_set] = ACTIONS(802),
    [anon_sym_matrix] = ACTIONS(804),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_uninitialized] = ACTIONS(913),
    [sym_tag] = ACTIONS(926),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(913),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [144] = {
    [sym_procedure] = STATE(6881),
    [sym_expression] = STATE(4844),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(67),
    [sym_identifier] = ACTIONS(595),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_AMP] = ACTIONS(605),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(613),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(67),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [145] = {
    [sym_procedure] = STATE(6908),
    [sym_expression] = STATE(4835),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(67),
    [sym_identifier] = ACTIONS(595),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_AMP] = ACTIONS(605),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(613),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(67),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [146] = {
    [sym_expression] = STATE(4592),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_else] = ACTIONS(133),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_case] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(613),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(129),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [147] = {
    [sym_expression] = STATE(4593),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(163),
    [anon_sym_else] = ACTIONS(167),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_case] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_AMP] = ACTIONS(605),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(613),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(163),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [148] = {
    [sym_procedure] = STATE(6896),
    [sym_expression] = STATE(4841),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(67),
    [sym_identifier] = ACTIONS(595),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_AMP] = ACTIONS(605),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(613),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(67),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [149] = {
    [sym_procedure] = STATE(6879),
    [sym_expression] = STATE(4836),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(67),
    [sym_identifier] = ACTIONS(595),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(601),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_AMP] = ACTIONS(605),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(613),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(67),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [150] = {
    [sym_expression] = STATE(4592),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(201),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_RBRACE] = ACTIONS(201),
    [anon_sym_COMMA] = ACTIONS(201),
    [anon_sym_DASH_GT] = ACTIONS(201),
    [anon_sym_PIPE] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_SEMI] = ACTIONS(201),
    [anon_sym_else] = ACTIONS(203),
    [anon_sym_when] = ACTIONS(203),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(203),
    [anon_sym_QMARK] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_DASH] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_AMP] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(201),
    [anon_sym_or_else] = ACTIONS(203),
    [anon_sym_AMP_AMP] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(203),
    [anon_sym_GT_EQ] = ACTIONS(201),
    [anon_sym_LT_EQ] = ACTIONS(201),
    [anon_sym_LT] = ACTIONS(203),
    [anon_sym_EQ_EQ] = ACTIONS(201),
    [anon_sym_BANG_EQ] = ACTIONS(201),
    [anon_sym_TILDE_EQ] = ACTIONS(201),
    [anon_sym_AMP_TILDE] = ACTIONS(201),
    [anon_sym_LT_LT] = ACTIONS(201),
    [anon_sym_GT_GT] = ACTIONS(201),
    [anon_sym_STAR] = ACTIONS(201),
    [anon_sym_SLASH] = ACTIONS(203),
    [anon_sym_PERCENT] = ACTIONS(203),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(201),
    [anon_sym_DOT] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(201),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(201),
    [anon_sym_DOT_DOT_LT] = ACTIONS(201),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_not_in] = ACTIONS(203),
    [anon_sym_DOT_DOT] = ACTIONS(613),
    [anon_sym_or_return] = ACTIONS(203),
    [anon_sym_or_continue] = ACTIONS(203),
    [anon_sym_or_break] = ACTIONS(203),
    [anon_sym_CARET] = ACTIONS(201),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(201),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [151] = {
    [sym_procedure] = STATE(2134),
    [sym_type] = STATE(2128),
    [sym_pointer_type] = STATE(2167),
    [sym_variadic_type] = STATE(2167),
    [sym_array_type] = STATE(2167),
    [sym_map_type] = STATE(2167),
    [sym_union_type] = STATE(2167),
    [sym_bit_set_type] = STATE(2167),
    [sym_matrix_type] = STATE(2167),
    [sym_field_type] = STATE(2167),
    [sym_tuple_type] = STATE(2167),
    [sym_struct_type] = STATE(2167),
    [sym_enum_type] = STATE(2167),
    [sym_bit_field_type] = STATE(2167),
    [sym_constant_type] = STATE(2167),
    [sym_specialized_type] = STATE(2167),
    [sym__procedure_type] = STATE(2167),
    [sym_distinct_type] = STATE(2167),
    [sym_empty_type] = STATE(2167),
    [sym_polymorphic_type] = STATE(2167),
    [sym_conditional_type] = STATE(2167),
    [ts_builtin_sym_end] = ACTIONS(859),
    [sym_identifier] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(859),
    [anon_sym_proc] = ACTIONS(941),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(943),
    [anon_sym_enum] = ACTIONS(945),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_union] = ACTIONS(947),
    [anon_sym_bit_field] = ACTIONS(949),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(951),
    [anon_sym_DOLLAR] = ACTIONS(954),
    [anon_sym_PLUS_EQ] = ACTIONS(859),
    [anon_sym_DASH_EQ] = ACTIONS(859),
    [anon_sym_STAR_EQ] = ACTIONS(859),
    [anon_sym_SLASH_EQ] = ACTIONS(859),
    [anon_sym_PERCENT_EQ] = ACTIONS(859),
    [anon_sym_AMP_EQ] = ACTIONS(859),
    [anon_sym_PIPE_EQ] = ACTIONS(859),
    [anon_sym_CARET_EQ] = ACTIONS(859),
    [anon_sym_LT_LT_EQ] = ACTIONS(859),
    [anon_sym_GT_GT_EQ] = ACTIONS(859),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(859),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_else] = ACTIONS(861),
    [anon_sym_when] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_case] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(861),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(956),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_or_else] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(861),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(958),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(861),
    [anon_sym_DOT_DOT] = ACTIONS(961),
    [anon_sym_or_return] = ACTIONS(861),
    [anon_sym_or_continue] = ACTIONS(861),
    [anon_sym_or_break] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(963),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(966),
    [anon_sym_map] = ACTIONS(968),
    [anon_sym_bit_set] = ACTIONS(970),
    [anon_sym_matrix] = ACTIONS(972),
    [anon_sym_distinct] = ACTIONS(974),
    [sym_tag] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(859),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [152] = {
    [sym_procedure] = STATE(2134),
    [sym_type] = STATE(2126),
    [sym_pointer_type] = STATE(2167),
    [sym_variadic_type] = STATE(2167),
    [sym_array_type] = STATE(2167),
    [sym_map_type] = STATE(2167),
    [sym_union_type] = STATE(2167),
    [sym_bit_set_type] = STATE(2167),
    [sym_matrix_type] = STATE(2167),
    [sym_field_type] = STATE(2167),
    [sym_tuple_type] = STATE(2167),
    [sym_struct_type] = STATE(2167),
    [sym_enum_type] = STATE(2167),
    [sym_bit_field_type] = STATE(2167),
    [sym_constant_type] = STATE(2167),
    [sym_specialized_type] = STATE(2167),
    [sym__procedure_type] = STATE(2167),
    [sym_distinct_type] = STATE(2167),
    [sym_empty_type] = STATE(2167),
    [sym_polymorphic_type] = STATE(2167),
    [sym_conditional_type] = STATE(2167),
    [ts_builtin_sym_end] = ACTIONS(891),
    [sym_identifier] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [anon_sym_proc] = ACTIONS(941),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_struct] = ACTIONS(943),
    [anon_sym_enum] = ACTIONS(945),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_union] = ACTIONS(947),
    [anon_sym_bit_field] = ACTIONS(949),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COLON_EQ] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(978),
    [anon_sym_DOLLAR] = ACTIONS(954),
    [anon_sym_PLUS_EQ] = ACTIONS(891),
    [anon_sym_DASH_EQ] = ACTIONS(891),
    [anon_sym_STAR_EQ] = ACTIONS(891),
    [anon_sym_SLASH_EQ] = ACTIONS(891),
    [anon_sym_PERCENT_EQ] = ACTIONS(891),
    [anon_sym_AMP_EQ] = ACTIONS(891),
    [anon_sym_PIPE_EQ] = ACTIONS(891),
    [anon_sym_CARET_EQ] = ACTIONS(891),
    [anon_sym_LT_LT_EQ] = ACTIONS(891),
    [anon_sym_GT_GT_EQ] = ACTIONS(891),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(891),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_when] = ACTIONS(894),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_case] = ACTIONS(894),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(956),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(894),
    [anon_sym_or_else] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(894),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(982),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(961),
    [anon_sym_or_return] = ACTIONS(894),
    [anon_sym_or_continue] = ACTIONS(894),
    [anon_sym_or_break] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(966),
    [anon_sym_map] = ACTIONS(968),
    [anon_sym_bit_set] = ACTIONS(970),
    [anon_sym_matrix] = ACTIONS(972),
    [anon_sym_distinct] = ACTIONS(974),
    [sym_tag] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(891),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [153] = {
    [sym_procedure] = STATE(2134),
    [sym_type] = STATE(2130),
    [sym_pointer_type] = STATE(2167),
    [sym_variadic_type] = STATE(2167),
    [sym_array_type] = STATE(2167),
    [sym_map_type] = STATE(2167),
    [sym_union_type] = STATE(2167),
    [sym_bit_set_type] = STATE(2167),
    [sym_matrix_type] = STATE(2167),
    [sym_field_type] = STATE(2167),
    [sym_tuple_type] = STATE(2167),
    [sym_struct_type] = STATE(2167),
    [sym_enum_type] = STATE(2167),
    [sym_bit_field_type] = STATE(2167),
    [sym_constant_type] = STATE(2167),
    [sym_specialized_type] = STATE(2167),
    [sym__procedure_type] = STATE(2167),
    [sym_distinct_type] = STATE(2167),
    [sym_empty_type] = STATE(2167),
    [sym_polymorphic_type] = STATE(2167),
    [sym_conditional_type] = STATE(2167),
    [ts_builtin_sym_end] = ACTIONS(767),
    [sym_identifier] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_COLON_COLON] = ACTIONS(767),
    [anon_sym_proc] = ACTIONS(941),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_struct] = ACTIONS(943),
    [anon_sym_enum] = ACTIONS(945),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_union] = ACTIONS(947),
    [anon_sym_bit_field] = ACTIONS(949),
    [anon_sym_COLON] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_COLON_EQ] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(990),
    [anon_sym_DOLLAR] = ACTIONS(954),
    [anon_sym_PLUS_EQ] = ACTIONS(767),
    [anon_sym_DASH_EQ] = ACTIONS(767),
    [anon_sym_STAR_EQ] = ACTIONS(767),
    [anon_sym_SLASH_EQ] = ACTIONS(767),
    [anon_sym_PERCENT_EQ] = ACTIONS(767),
    [anon_sym_AMP_EQ] = ACTIONS(767),
    [anon_sym_PIPE_EQ] = ACTIONS(767),
    [anon_sym_CARET_EQ] = ACTIONS(767),
    [anon_sym_LT_LT_EQ] = ACTIONS(767),
    [anon_sym_GT_GT_EQ] = ACTIONS(767),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(767),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_else] = ACTIONS(773),
    [anon_sym_when] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(773),
    [anon_sym_case] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(956),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_or_else] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(773),
    [anon_sym_LT_LT] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(993),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(961),
    [anon_sym_or_return] = ACTIONS(773),
    [anon_sym_or_continue] = ACTIONS(773),
    [anon_sym_or_break] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(996),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(966),
    [anon_sym_map] = ACTIONS(968),
    [anon_sym_bit_set] = ACTIONS(970),
    [anon_sym_matrix] = ACTIONS(972),
    [anon_sym_distinct] = ACTIONS(974),
    [sym_tag] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(767),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [154] = {
    [sym_expression] = STATE(4749),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(201),
    [anon_sym_COLON_COLON] = ACTIONS(201),
    [anon_sym_DASH_GT] = ACTIONS(201),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(203),
    [anon_sym_PIPE] = ACTIONS(203),
    [anon_sym_COLON_EQ] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_SEMI] = ACTIONS(201),
    [anon_sym_when] = ACTIONS(203),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_QMARK] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_DASH] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(201),
    [anon_sym_or_else] = ACTIONS(203),
    [anon_sym_AMP_AMP] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(203),
    [anon_sym_GT_EQ] = ACTIONS(201),
    [anon_sym_LT_EQ] = ACTIONS(201),
    [anon_sym_LT] = ACTIONS(203),
    [anon_sym_EQ_EQ] = ACTIONS(201),
    [anon_sym_BANG_EQ] = ACTIONS(201),
    [anon_sym_TILDE_EQ] = ACTIONS(201),
    [anon_sym_AMP_TILDE] = ACTIONS(201),
    [anon_sym_LT_LT] = ACTIONS(201),
    [anon_sym_GT_GT] = ACTIONS(201),
    [anon_sym_STAR] = ACTIONS(201),
    [anon_sym_SLASH] = ACTIONS(203),
    [anon_sym_PERCENT] = ACTIONS(203),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(201),
    [anon_sym_DOT] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(201),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(201),
    [anon_sym_DOT_DOT_LT] = ACTIONS(201),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_not_in] = ACTIONS(203),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym_or_return] = ACTIONS(203),
    [anon_sym_or_continue] = ACTIONS(203),
    [anon_sym_or_break] = ACTIONS(203),
    [anon_sym_CARET] = ACTIONS(201),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [155] = {
    [sym_procedure] = STATE(2134),
    [sym_type] = STATE(2156),
    [sym_pointer_type] = STATE(2167),
    [sym_variadic_type] = STATE(2167),
    [sym_array_type] = STATE(2167),
    [sym_map_type] = STATE(2167),
    [sym_union_type] = STATE(2167),
    [sym_bit_set_type] = STATE(2167),
    [sym_matrix_type] = STATE(2167),
    [sym_field_type] = STATE(2167),
    [sym_tuple_type] = STATE(2167),
    [sym_struct_type] = STATE(2167),
    [sym_enum_type] = STATE(2167),
    [sym_bit_field_type] = STATE(2167),
    [sym_constant_type] = STATE(2167),
    [sym_specialized_type] = STATE(2167),
    [sym__procedure_type] = STATE(2167),
    [sym_distinct_type] = STATE(2167),
    [sym_empty_type] = STATE(2167),
    [sym_polymorphic_type] = STATE(2167),
    [sym_conditional_type] = STATE(2167),
    [ts_builtin_sym_end] = ACTIONS(913),
    [sym_identifier] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_COLON_COLON] = ACTIONS(913),
    [anon_sym_proc] = ACTIONS(941),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_struct] = ACTIONS(943),
    [anon_sym_enum] = ACTIONS(945),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_union] = ACTIONS(947),
    [anon_sym_bit_field] = ACTIONS(949),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_COLON_EQ] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(1009),
    [anon_sym_DOLLAR] = ACTIONS(954),
    [anon_sym_PLUS_EQ] = ACTIONS(913),
    [anon_sym_DASH_EQ] = ACTIONS(913),
    [anon_sym_STAR_EQ] = ACTIONS(913),
    [anon_sym_SLASH_EQ] = ACTIONS(913),
    [anon_sym_PERCENT_EQ] = ACTIONS(913),
    [anon_sym_AMP_EQ] = ACTIONS(913),
    [anon_sym_PIPE_EQ] = ACTIONS(913),
    [anon_sym_CARET_EQ] = ACTIONS(913),
    [anon_sym_LT_LT_EQ] = ACTIONS(913),
    [anon_sym_GT_GT_EQ] = ACTIONS(913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(913),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_else] = ACTIONS(915),
    [anon_sym_when] = ACTIONS(915),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_case] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(956),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(915),
    [anon_sym_or_else] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(915),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(1012),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(961),
    [anon_sym_or_return] = ACTIONS(915),
    [anon_sym_or_continue] = ACTIONS(915),
    [anon_sym_or_break] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(1015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(966),
    [anon_sym_map] = ACTIONS(968),
    [anon_sym_bit_set] = ACTIONS(970),
    [anon_sym_matrix] = ACTIONS(972),
    [anon_sym_distinct] = ACTIONS(974),
    [sym_tag] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(913),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [156] = {
    [sym_procedure] = STATE(2134),
    [sym_type] = STATE(2127),
    [sym_pointer_type] = STATE(2167),
    [sym_variadic_type] = STATE(2167),
    [sym_array_type] = STATE(2167),
    [sym_map_type] = STATE(2167),
    [sym_union_type] = STATE(2167),
    [sym_bit_set_type] = STATE(2167),
    [sym_matrix_type] = STATE(2167),
    [sym_field_type] = STATE(2167),
    [sym_tuple_type] = STATE(2167),
    [sym_struct_type] = STATE(2167),
    [sym_enum_type] = STATE(2167),
    [sym_bit_field_type] = STATE(2167),
    [sym_constant_type] = STATE(2167),
    [sym_specialized_type] = STATE(2167),
    [sym__procedure_type] = STATE(2167),
    [sym_distinct_type] = STATE(2167),
    [sym_empty_type] = STATE(2167),
    [sym_polymorphic_type] = STATE(2167),
    [sym_conditional_type] = STATE(2167),
    [ts_builtin_sym_end] = ACTIONS(815),
    [sym_identifier] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_COLON_COLON] = ACTIONS(815),
    [anon_sym_proc] = ACTIONS(941),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(943),
    [anon_sym_enum] = ACTIONS(945),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_union] = ACTIONS(947),
    [anon_sym_bit_field] = ACTIONS(949),
    [anon_sym_COLON] = ACTIONS(818),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_COLON_EQ] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_DOLLAR] = ACTIONS(954),
    [anon_sym_PLUS_EQ] = ACTIONS(815),
    [anon_sym_DASH_EQ] = ACTIONS(815),
    [anon_sym_STAR_EQ] = ACTIONS(815),
    [anon_sym_SLASH_EQ] = ACTIONS(815),
    [anon_sym_PERCENT_EQ] = ACTIONS(815),
    [anon_sym_AMP_EQ] = ACTIONS(815),
    [anon_sym_PIPE_EQ] = ACTIONS(815),
    [anon_sym_CARET_EQ] = ACTIONS(815),
    [anon_sym_LT_LT_EQ] = ACTIONS(815),
    [anon_sym_GT_GT_EQ] = ACTIONS(815),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(815),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_else] = ACTIONS(818),
    [anon_sym_when] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(818),
    [anon_sym_case] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(818),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(956),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(818),
    [anon_sym_or_else] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(818),
    [anon_sym_LT_LT] = ACTIONS(818),
    [anon_sym_GT_GT] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(818),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(1022),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(818),
    [anon_sym_DOT_DOT] = ACTIONS(961),
    [anon_sym_or_return] = ACTIONS(818),
    [anon_sym_or_continue] = ACTIONS(818),
    [anon_sym_or_break] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(1026),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(966),
    [anon_sym_map] = ACTIONS(968),
    [anon_sym_bit_set] = ACTIONS(970),
    [anon_sym_matrix] = ACTIONS(972),
    [anon_sym_distinct] = ACTIONS(974),
    [sym_tag] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [157] = {
    [sym_expression] = STATE(4746),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_COLON_COLON] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_COLON] = ACTIONS(167),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(163),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [158] = {
    [sym_expression] = STATE(4749),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_COLON_COLON] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(133),
    [anon_sym_COLON] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [159] = {
    [sym_procedure] = STATE(2134),
    [sym_type] = STATE(2173),
    [sym_pointer_type] = STATE(2167),
    [sym_variadic_type] = STATE(2167),
    [sym_array_type] = STATE(2167),
    [sym_map_type] = STATE(2167),
    [sym_union_type] = STATE(2167),
    [sym_bit_set_type] = STATE(2167),
    [sym_matrix_type] = STATE(2167),
    [sym_field_type] = STATE(2167),
    [sym_tuple_type] = STATE(2167),
    [sym_struct_type] = STATE(2167),
    [sym_enum_type] = STATE(2167),
    [sym_bit_field_type] = STATE(2167),
    [sym_constant_type] = STATE(2167),
    [sym_specialized_type] = STATE(2167),
    [sym__procedure_type] = STATE(2167),
    [sym_distinct_type] = STATE(2167),
    [sym_empty_type] = STATE(2167),
    [sym_polymorphic_type] = STATE(2167),
    [sym_conditional_type] = STATE(2167),
    [ts_builtin_sym_end] = ACTIONS(875),
    [sym_identifier] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(875),
    [anon_sym_proc] = ACTIONS(941),
    [anon_sym_DASH_GT] = ACTIONS(875),
    [anon_sym_struct] = ACTIONS(943),
    [anon_sym_enum] = ACTIONS(945),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_union] = ACTIONS(947),
    [anon_sym_bit_field] = ACTIONS(949),
    [anon_sym_COLON] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_COLON_EQ] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1038),
    [anon_sym_DOLLAR] = ACTIONS(954),
    [anon_sym_PLUS_EQ] = ACTIONS(875),
    [anon_sym_DASH_EQ] = ACTIONS(875),
    [anon_sym_STAR_EQ] = ACTIONS(875),
    [anon_sym_SLASH_EQ] = ACTIONS(875),
    [anon_sym_PERCENT_EQ] = ACTIONS(875),
    [anon_sym_AMP_EQ] = ACTIONS(875),
    [anon_sym_PIPE_EQ] = ACTIONS(875),
    [anon_sym_CARET_EQ] = ACTIONS(875),
    [anon_sym_LT_LT_EQ] = ACTIONS(875),
    [anon_sym_GT_GT_EQ] = ACTIONS(875),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(875),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(875),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_else] = ACTIONS(877),
    [anon_sym_when] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_case] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(956),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(877),
    [anon_sym_or_else] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(877),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_TILDE_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE] = ACTIONS(877),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_GT_GT] = ACTIONS(877),
    [anon_sym_STAR] = ACTIONS(877),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(1041),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(875),
    [anon_sym_DOT_DOT_LT] = ACTIONS(875),
    [anon_sym_not_in] = ACTIONS(877),
    [anon_sym_DOT_DOT] = ACTIONS(961),
    [anon_sym_or_return] = ACTIONS(877),
    [anon_sym_or_continue] = ACTIONS(877),
    [anon_sym_or_break] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(966),
    [anon_sym_map] = ACTIONS(968),
    [anon_sym_bit_set] = ACTIONS(970),
    [anon_sym_matrix] = ACTIONS(972),
    [anon_sym_distinct] = ACTIONS(974),
    [sym_tag] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(875),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [160] = {
    [sym_procedure] = STATE(2134),
    [sym_type] = STATE(2129),
    [sym_pointer_type] = STATE(2167),
    [sym_variadic_type] = STATE(2167),
    [sym_array_type] = STATE(2167),
    [sym_map_type] = STATE(2167),
    [sym_union_type] = STATE(2167),
    [sym_bit_set_type] = STATE(2167),
    [sym_matrix_type] = STATE(2167),
    [sym_field_type] = STATE(2167),
    [sym_tuple_type] = STATE(2167),
    [sym_struct_type] = STATE(2167),
    [sym_enum_type] = STATE(2167),
    [sym_bit_field_type] = STATE(2167),
    [sym_constant_type] = STATE(2167),
    [sym_specialized_type] = STATE(2167),
    [sym__procedure_type] = STATE(2167),
    [sym_distinct_type] = STATE(2167),
    [sym_empty_type] = STATE(2167),
    [sym_polymorphic_type] = STATE(2167),
    [sym_conditional_type] = STATE(2167),
    [ts_builtin_sym_end] = ACTIONS(837),
    [sym_identifier] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_COLON_COLON] = ACTIONS(837),
    [anon_sym_proc] = ACTIONS(941),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_struct] = ACTIONS(943),
    [anon_sym_enum] = ACTIONS(945),
    [anon_sym_EQ] = ACTIONS(840),
    [anon_sym_union] = ACTIONS(947),
    [anon_sym_bit_field] = ACTIONS(949),
    [anon_sym_COLON] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COLON_EQ] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(1047),
    [anon_sym_DOLLAR] = ACTIONS(954),
    [anon_sym_PLUS_EQ] = ACTIONS(837),
    [anon_sym_DASH_EQ] = ACTIONS(837),
    [anon_sym_STAR_EQ] = ACTIONS(837),
    [anon_sym_SLASH_EQ] = ACTIONS(837),
    [anon_sym_PERCENT_EQ] = ACTIONS(837),
    [anon_sym_AMP_EQ] = ACTIONS(837),
    [anon_sym_PIPE_EQ] = ACTIONS(837),
    [anon_sym_CARET_EQ] = ACTIONS(837),
    [anon_sym_LT_LT_EQ] = ACTIONS(837),
    [anon_sym_GT_GT_EQ] = ACTIONS(837),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(837),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_when] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_case] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(956),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(840),
    [anon_sym_or_else] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(840),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_TILDE_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE] = ACTIONS(840),
    [anon_sym_LT_LT] = ACTIONS(840),
    [anon_sym_GT_GT] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_DOT_DOT_LT] = ACTIONS(837),
    [anon_sym_not_in] = ACTIONS(840),
    [anon_sym_DOT_DOT] = ACTIONS(961),
    [anon_sym_or_return] = ACTIONS(840),
    [anon_sym_or_continue] = ACTIONS(840),
    [anon_sym_or_break] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(1055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(966),
    [anon_sym_map] = ACTIONS(968),
    [anon_sym_bit_set] = ACTIONS(970),
    [anon_sym_matrix] = ACTIONS(972),
    [anon_sym_distinct] = ACTIONS(974),
    [sym_tag] = ACTIONS(976),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(837),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [161] = {
    [sym_procedure] = STATE(2239),
    [sym_type] = STATE(2353),
    [sym_pointer_type] = STATE(2209),
    [sym_variadic_type] = STATE(2209),
    [sym_array_type] = STATE(2209),
    [sym_map_type] = STATE(2209),
    [sym_union_type] = STATE(2209),
    [sym_bit_set_type] = STATE(2209),
    [sym_matrix_type] = STATE(2209),
    [sym_field_type] = STATE(2209),
    [sym_tuple_type] = STATE(2209),
    [sym_struct_type] = STATE(2209),
    [sym_enum_type] = STATE(2209),
    [sym_bit_field_type] = STATE(2209),
    [sym_constant_type] = STATE(2209),
    [sym_specialized_type] = STATE(2209),
    [sym__procedure_type] = STATE(2209),
    [sym_distinct_type] = STATE(2209),
    [sym_empty_type] = STATE(2209),
    [sym_polymorphic_type] = STATE(2209),
    [sym_conditional_type] = STATE(2209),
    [ts_builtin_sym_end] = ACTIONS(837),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_COLON_COLON] = ACTIONS(837),
    [anon_sym_proc] = ACTIONS(1061),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_struct] = ACTIONS(1063),
    [anon_sym_enum] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(840),
    [anon_sym_union] = ACTIONS(1067),
    [anon_sym_bit_field] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COLON_EQ] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [anon_sym_PLUS_EQ] = ACTIONS(837),
    [anon_sym_DASH_EQ] = ACTIONS(837),
    [anon_sym_STAR_EQ] = ACTIONS(837),
    [anon_sym_SLASH_EQ] = ACTIONS(837),
    [anon_sym_PERCENT_EQ] = ACTIONS(837),
    [anon_sym_AMP_EQ] = ACTIONS(837),
    [anon_sym_PIPE_EQ] = ACTIONS(837),
    [anon_sym_CARET_EQ] = ACTIONS(837),
    [anon_sym_LT_LT_EQ] = ACTIONS(837),
    [anon_sym_GT_GT_EQ] = ACTIONS(837),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(837),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_when] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_case] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(840),
    [anon_sym_or_else] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(840),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_TILDE_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE] = ACTIONS(840),
    [anon_sym_LT_LT] = ACTIONS(840),
    [anon_sym_GT_GT] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(1079),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_DOT_DOT_LT] = ACTIONS(837),
    [anon_sym_not_in] = ACTIONS(840),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_or_return] = ACTIONS(840),
    [anon_sym_or_continue] = ACTIONS(840),
    [anon_sym_or_break] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(1085),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_map] = ACTIONS(1091),
    [anon_sym_bit_set] = ACTIONS(1093),
    [anon_sym_matrix] = ACTIONS(1095),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_tag] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(837),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [162] = {
    [sym_procedure] = STATE(2239),
    [sym_type] = STATE(2438),
    [sym_pointer_type] = STATE(2209),
    [sym_variadic_type] = STATE(2209),
    [sym_array_type] = STATE(2209),
    [sym_map_type] = STATE(2209),
    [sym_union_type] = STATE(2209),
    [sym_bit_set_type] = STATE(2209),
    [sym_matrix_type] = STATE(2209),
    [sym_field_type] = STATE(2209),
    [sym_tuple_type] = STATE(2209),
    [sym_struct_type] = STATE(2209),
    [sym_enum_type] = STATE(2209),
    [sym_bit_field_type] = STATE(2209),
    [sym_constant_type] = STATE(2209),
    [sym_specialized_type] = STATE(2209),
    [sym__procedure_type] = STATE(2209),
    [sym_distinct_type] = STATE(2209),
    [sym_empty_type] = STATE(2209),
    [sym_polymorphic_type] = STATE(2209),
    [sym_conditional_type] = STATE(2209),
    [ts_builtin_sym_end] = ACTIONS(875),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(875),
    [anon_sym_proc] = ACTIONS(1061),
    [anon_sym_DASH_GT] = ACTIONS(875),
    [anon_sym_struct] = ACTIONS(1063),
    [anon_sym_enum] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_union] = ACTIONS(1067),
    [anon_sym_bit_field] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_COLON_EQ] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [anon_sym_PLUS_EQ] = ACTIONS(875),
    [anon_sym_DASH_EQ] = ACTIONS(875),
    [anon_sym_STAR_EQ] = ACTIONS(875),
    [anon_sym_SLASH_EQ] = ACTIONS(875),
    [anon_sym_PERCENT_EQ] = ACTIONS(875),
    [anon_sym_AMP_EQ] = ACTIONS(875),
    [anon_sym_PIPE_EQ] = ACTIONS(875),
    [anon_sym_CARET_EQ] = ACTIONS(875),
    [anon_sym_LT_LT_EQ] = ACTIONS(875),
    [anon_sym_GT_GT_EQ] = ACTIONS(875),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(875),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(875),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_else] = ACTIONS(877),
    [anon_sym_when] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_case] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(877),
    [anon_sym_or_else] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(877),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_TILDE_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE] = ACTIONS(877),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_GT_GT] = ACTIONS(877),
    [anon_sym_STAR] = ACTIONS(877),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(875),
    [anon_sym_DOT_DOT_LT] = ACTIONS(875),
    [anon_sym_not_in] = ACTIONS(877),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_or_return] = ACTIONS(877),
    [anon_sym_or_continue] = ACTIONS(877),
    [anon_sym_or_break] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(1105),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_map] = ACTIONS(1091),
    [anon_sym_bit_set] = ACTIONS(1093),
    [anon_sym_matrix] = ACTIONS(1095),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_tag] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(875),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [163] = {
    [sym_procedure] = STATE(2239),
    [sym_type] = STATE(2420),
    [sym_pointer_type] = STATE(2209),
    [sym_variadic_type] = STATE(2209),
    [sym_array_type] = STATE(2209),
    [sym_map_type] = STATE(2209),
    [sym_union_type] = STATE(2209),
    [sym_bit_set_type] = STATE(2209),
    [sym_matrix_type] = STATE(2209),
    [sym_field_type] = STATE(2209),
    [sym_tuple_type] = STATE(2209),
    [sym_struct_type] = STATE(2209),
    [sym_enum_type] = STATE(2209),
    [sym_bit_field_type] = STATE(2209),
    [sym_constant_type] = STATE(2209),
    [sym_specialized_type] = STATE(2209),
    [sym__procedure_type] = STATE(2209),
    [sym_distinct_type] = STATE(2209),
    [sym_empty_type] = STATE(2209),
    [sym_polymorphic_type] = STATE(2209),
    [sym_conditional_type] = STATE(2209),
    [ts_builtin_sym_end] = ACTIONS(891),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [anon_sym_proc] = ACTIONS(1061),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_struct] = ACTIONS(1063),
    [anon_sym_enum] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_union] = ACTIONS(1067),
    [anon_sym_bit_field] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COLON_EQ] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(1108),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [anon_sym_PLUS_EQ] = ACTIONS(891),
    [anon_sym_DASH_EQ] = ACTIONS(891),
    [anon_sym_STAR_EQ] = ACTIONS(891),
    [anon_sym_SLASH_EQ] = ACTIONS(891),
    [anon_sym_PERCENT_EQ] = ACTIONS(891),
    [anon_sym_AMP_EQ] = ACTIONS(891),
    [anon_sym_PIPE_EQ] = ACTIONS(891),
    [anon_sym_CARET_EQ] = ACTIONS(891),
    [anon_sym_LT_LT_EQ] = ACTIONS(891),
    [anon_sym_GT_GT_EQ] = ACTIONS(891),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(891),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_when] = ACTIONS(894),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_case] = ACTIONS(894),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(894),
    [anon_sym_or_else] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(894),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(1112),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_or_return] = ACTIONS(894),
    [anon_sym_or_continue] = ACTIONS(894),
    [anon_sym_or_break] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(1116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_map] = ACTIONS(1091),
    [anon_sym_bit_set] = ACTIONS(1093),
    [anon_sym_matrix] = ACTIONS(1095),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_tag] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(891),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [164] = {
    [sym_procedure] = STATE(2239),
    [sym_type] = STATE(2414),
    [sym_pointer_type] = STATE(2209),
    [sym_variadic_type] = STATE(2209),
    [sym_array_type] = STATE(2209),
    [sym_map_type] = STATE(2209),
    [sym_union_type] = STATE(2209),
    [sym_bit_set_type] = STATE(2209),
    [sym_matrix_type] = STATE(2209),
    [sym_field_type] = STATE(2209),
    [sym_tuple_type] = STATE(2209),
    [sym_struct_type] = STATE(2209),
    [sym_enum_type] = STATE(2209),
    [sym_bit_field_type] = STATE(2209),
    [sym_constant_type] = STATE(2209),
    [sym_specialized_type] = STATE(2209),
    [sym__procedure_type] = STATE(2209),
    [sym_distinct_type] = STATE(2209),
    [sym_empty_type] = STATE(2209),
    [sym_polymorphic_type] = STATE(2209),
    [sym_conditional_type] = STATE(2209),
    [ts_builtin_sym_end] = ACTIONS(815),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_COLON_COLON] = ACTIONS(815),
    [anon_sym_proc] = ACTIONS(1061),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(1063),
    [anon_sym_enum] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_union] = ACTIONS(1067),
    [anon_sym_bit_field] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(818),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_COLON_EQ] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(1120),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [anon_sym_PLUS_EQ] = ACTIONS(815),
    [anon_sym_DASH_EQ] = ACTIONS(815),
    [anon_sym_STAR_EQ] = ACTIONS(815),
    [anon_sym_SLASH_EQ] = ACTIONS(815),
    [anon_sym_PERCENT_EQ] = ACTIONS(815),
    [anon_sym_AMP_EQ] = ACTIONS(815),
    [anon_sym_PIPE_EQ] = ACTIONS(815),
    [anon_sym_CARET_EQ] = ACTIONS(815),
    [anon_sym_LT_LT_EQ] = ACTIONS(815),
    [anon_sym_GT_GT_EQ] = ACTIONS(815),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(815),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_else] = ACTIONS(818),
    [anon_sym_when] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(818),
    [anon_sym_case] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(818),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(818),
    [anon_sym_or_else] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(818),
    [anon_sym_LT_LT] = ACTIONS(818),
    [anon_sym_GT_GT] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(818),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(1124),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(818),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_or_return] = ACTIONS(818),
    [anon_sym_or_continue] = ACTIONS(818),
    [anon_sym_or_break] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(1128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_map] = ACTIONS(1091),
    [anon_sym_bit_set] = ACTIONS(1093),
    [anon_sym_matrix] = ACTIONS(1095),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_tag] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [165] = {
    [sym_procedure] = STATE(2239),
    [sym_type] = STATE(2234),
    [sym_pointer_type] = STATE(2209),
    [sym_variadic_type] = STATE(2209),
    [sym_array_type] = STATE(2209),
    [sym_map_type] = STATE(2209),
    [sym_union_type] = STATE(2209),
    [sym_bit_set_type] = STATE(2209),
    [sym_matrix_type] = STATE(2209),
    [sym_field_type] = STATE(2209),
    [sym_tuple_type] = STATE(2209),
    [sym_struct_type] = STATE(2209),
    [sym_enum_type] = STATE(2209),
    [sym_bit_field_type] = STATE(2209),
    [sym_constant_type] = STATE(2209),
    [sym_specialized_type] = STATE(2209),
    [sym__procedure_type] = STATE(2209),
    [sym_distinct_type] = STATE(2209),
    [sym_empty_type] = STATE(2209),
    [sym_polymorphic_type] = STATE(2209),
    [sym_conditional_type] = STATE(2209),
    [ts_builtin_sym_end] = ACTIONS(913),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_COLON_COLON] = ACTIONS(913),
    [anon_sym_proc] = ACTIONS(1061),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_struct] = ACTIONS(1063),
    [anon_sym_enum] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_union] = ACTIONS(1067),
    [anon_sym_bit_field] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_COLON_EQ] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(1132),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [anon_sym_PLUS_EQ] = ACTIONS(913),
    [anon_sym_DASH_EQ] = ACTIONS(913),
    [anon_sym_STAR_EQ] = ACTIONS(913),
    [anon_sym_SLASH_EQ] = ACTIONS(913),
    [anon_sym_PERCENT_EQ] = ACTIONS(913),
    [anon_sym_AMP_EQ] = ACTIONS(913),
    [anon_sym_PIPE_EQ] = ACTIONS(913),
    [anon_sym_CARET_EQ] = ACTIONS(913),
    [anon_sym_LT_LT_EQ] = ACTIONS(913),
    [anon_sym_GT_GT_EQ] = ACTIONS(913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(913),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_else] = ACTIONS(915),
    [anon_sym_when] = ACTIONS(915),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_case] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(915),
    [anon_sym_or_else] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(915),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_or_return] = ACTIONS(915),
    [anon_sym_or_continue] = ACTIONS(915),
    [anon_sym_or_break] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(1138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_map] = ACTIONS(1091),
    [anon_sym_bit_set] = ACTIONS(1093),
    [anon_sym_matrix] = ACTIONS(1095),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_tag] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(913),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [166] = {
    [sym_expression] = STATE(4683),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_COLON_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_SEMI] = ACTIONS(163),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1149),
    [anon_sym_BANG] = ACTIONS(1149),
    [anon_sym_AMP] = ACTIONS(1149),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(1159),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [167] = {
    [sym_procedure] = STATE(2239),
    [sym_type] = STATE(2343),
    [sym_pointer_type] = STATE(2209),
    [sym_variadic_type] = STATE(2209),
    [sym_array_type] = STATE(2209),
    [sym_map_type] = STATE(2209),
    [sym_union_type] = STATE(2209),
    [sym_bit_set_type] = STATE(2209),
    [sym_matrix_type] = STATE(2209),
    [sym_field_type] = STATE(2209),
    [sym_tuple_type] = STATE(2209),
    [sym_struct_type] = STATE(2209),
    [sym_enum_type] = STATE(2209),
    [sym_bit_field_type] = STATE(2209),
    [sym_constant_type] = STATE(2209),
    [sym_specialized_type] = STATE(2209),
    [sym__procedure_type] = STATE(2209),
    [sym_distinct_type] = STATE(2209),
    [sym_empty_type] = STATE(2209),
    [sym_polymorphic_type] = STATE(2209),
    [sym_conditional_type] = STATE(2209),
    [ts_builtin_sym_end] = ACTIONS(767),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_COLON_COLON] = ACTIONS(767),
    [anon_sym_proc] = ACTIONS(1061),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_struct] = ACTIONS(1063),
    [anon_sym_enum] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_union] = ACTIONS(1067),
    [anon_sym_bit_field] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_COLON_EQ] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [anon_sym_PLUS_EQ] = ACTIONS(767),
    [anon_sym_DASH_EQ] = ACTIONS(767),
    [anon_sym_STAR_EQ] = ACTIONS(767),
    [anon_sym_SLASH_EQ] = ACTIONS(767),
    [anon_sym_PERCENT_EQ] = ACTIONS(767),
    [anon_sym_AMP_EQ] = ACTIONS(767),
    [anon_sym_PIPE_EQ] = ACTIONS(767),
    [anon_sym_CARET_EQ] = ACTIONS(767),
    [anon_sym_LT_LT_EQ] = ACTIONS(767),
    [anon_sym_GT_GT_EQ] = ACTIONS(767),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(767),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_else] = ACTIONS(773),
    [anon_sym_when] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(773),
    [anon_sym_case] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_or_else] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(773),
    [anon_sym_LT_LT] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(1166),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_or_return] = ACTIONS(773),
    [anon_sym_or_continue] = ACTIONS(773),
    [anon_sym_or_break] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(1169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_map] = ACTIONS(1091),
    [anon_sym_bit_set] = ACTIONS(1093),
    [anon_sym_matrix] = ACTIONS(1095),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_tag] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(767),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [168] = {
    [sym_procedure] = STATE(2239),
    [sym_type] = STATE(2241),
    [sym_pointer_type] = STATE(2209),
    [sym_variadic_type] = STATE(2209),
    [sym_array_type] = STATE(2209),
    [sym_map_type] = STATE(2209),
    [sym_union_type] = STATE(2209),
    [sym_bit_set_type] = STATE(2209),
    [sym_matrix_type] = STATE(2209),
    [sym_field_type] = STATE(2209),
    [sym_tuple_type] = STATE(2209),
    [sym_struct_type] = STATE(2209),
    [sym_enum_type] = STATE(2209),
    [sym_bit_field_type] = STATE(2209),
    [sym_constant_type] = STATE(2209),
    [sym_specialized_type] = STATE(2209),
    [sym__procedure_type] = STATE(2209),
    [sym_distinct_type] = STATE(2209),
    [sym_empty_type] = STATE(2209),
    [sym_polymorphic_type] = STATE(2209),
    [sym_conditional_type] = STATE(2209),
    [ts_builtin_sym_end] = ACTIONS(859),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(859),
    [anon_sym_proc] = ACTIONS(1061),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(1063),
    [anon_sym_enum] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_union] = ACTIONS(1067),
    [anon_sym_bit_field] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(1172),
    [anon_sym_DOLLAR] = ACTIONS(1075),
    [anon_sym_PLUS_EQ] = ACTIONS(859),
    [anon_sym_DASH_EQ] = ACTIONS(859),
    [anon_sym_STAR_EQ] = ACTIONS(859),
    [anon_sym_SLASH_EQ] = ACTIONS(859),
    [anon_sym_PERCENT_EQ] = ACTIONS(859),
    [anon_sym_AMP_EQ] = ACTIONS(859),
    [anon_sym_PIPE_EQ] = ACTIONS(859),
    [anon_sym_CARET_EQ] = ACTIONS(859),
    [anon_sym_LT_LT_EQ] = ACTIONS(859),
    [anon_sym_GT_GT_EQ] = ACTIONS(859),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(859),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_else] = ACTIONS(861),
    [anon_sym_when] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_case] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(861),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_or_else] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(861),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1175),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(861),
    [anon_sym_DOT_DOT] = ACTIONS(1083),
    [anon_sym_or_return] = ACTIONS(861),
    [anon_sym_or_continue] = ACTIONS(861),
    [anon_sym_or_break] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(1178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1089),
    [anon_sym_map] = ACTIONS(1091),
    [anon_sym_bit_set] = ACTIONS(1093),
    [anon_sym_matrix] = ACTIONS(1095),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_tag] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(859),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [169] = {
    [sym_expression] = STATE(4751),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_COLON_EQ] = ACTIONS(129),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_do] = ACTIONS(133),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(1149),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(1159),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [170] = {
    [sym_procedure] = STATE(2467),
    [sym_type] = STATE(2417),
    [sym_pointer_type] = STATE(2470),
    [sym_variadic_type] = STATE(2470),
    [sym_array_type] = STATE(2470),
    [sym_map_type] = STATE(2470),
    [sym_union_type] = STATE(2470),
    [sym_bit_set_type] = STATE(2470),
    [sym_matrix_type] = STATE(2470),
    [sym_field_type] = STATE(2470),
    [sym_tuple_type] = STATE(2470),
    [sym_struct_type] = STATE(2470),
    [sym_enum_type] = STATE(2470),
    [sym_bit_field_type] = STATE(2470),
    [sym_constant_type] = STATE(2470),
    [sym_specialized_type] = STATE(2470),
    [sym__procedure_type] = STATE(2470),
    [sym_distinct_type] = STATE(2470),
    [sym_empty_type] = STATE(2470),
    [sym_polymorphic_type] = STATE(2470),
    [sym_conditional_type] = STATE(2470),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [anon_sym_proc] = ACTIONS(1183),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(894),
    [anon_sym_struct] = ACTIONS(1185),
    [anon_sym_enum] = ACTIONS(1187),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_bit_field] = ACTIONS(1191),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COLON_EQ] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(1193),
    [anon_sym_DOLLAR] = ACTIONS(1197),
    [anon_sym_PLUS_EQ] = ACTIONS(891),
    [anon_sym_DASH_EQ] = ACTIONS(891),
    [anon_sym_STAR_EQ] = ACTIONS(891),
    [anon_sym_SLASH_EQ] = ACTIONS(891),
    [anon_sym_PERCENT_EQ] = ACTIONS(891),
    [anon_sym_AMP_EQ] = ACTIONS(891),
    [anon_sym_PIPE_EQ] = ACTIONS(891),
    [anon_sym_CARET_EQ] = ACTIONS(891),
    [anon_sym_LT_LT_EQ] = ACTIONS(891),
    [anon_sym_GT_GT_EQ] = ACTIONS(891),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(891),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_do] = ACTIONS(894),
    [anon_sym_when] = ACTIONS(894),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(894),
    [anon_sym_or_else] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(894),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(1201),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym_or_return] = ACTIONS(894),
    [anon_sym_or_continue] = ACTIONS(894),
    [anon_sym_or_break] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1211),
    [anon_sym_map] = ACTIONS(1213),
    [anon_sym_bit_set] = ACTIONS(1215),
    [anon_sym_matrix] = ACTIONS(1217),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_uninitialized] = ACTIONS(891),
    [sym_tag] = ACTIONS(1219),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [171] = {
    [sym_procedure] = STATE(2467),
    [sym_type] = STATE(2431),
    [sym_pointer_type] = STATE(2470),
    [sym_variadic_type] = STATE(2470),
    [sym_array_type] = STATE(2470),
    [sym_map_type] = STATE(2470),
    [sym_union_type] = STATE(2470),
    [sym_bit_set_type] = STATE(2470),
    [sym_matrix_type] = STATE(2470),
    [sym_field_type] = STATE(2470),
    [sym_tuple_type] = STATE(2470),
    [sym_struct_type] = STATE(2470),
    [sym_enum_type] = STATE(2470),
    [sym_bit_field_type] = STATE(2470),
    [sym_constant_type] = STATE(2470),
    [sym_specialized_type] = STATE(2470),
    [sym__procedure_type] = STATE(2470),
    [sym_distinct_type] = STATE(2470),
    [sym_empty_type] = STATE(2470),
    [sym_polymorphic_type] = STATE(2470),
    [sym_conditional_type] = STATE(2470),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_COLON_COLON] = ACTIONS(767),
    [anon_sym_proc] = ACTIONS(1183),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_where] = ACTIONS(773),
    [anon_sym_struct] = ACTIONS(1185),
    [anon_sym_enum] = ACTIONS(1187),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_bit_field] = ACTIONS(1191),
    [anon_sym_COLON] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_COLON_EQ] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(1223),
    [anon_sym_DOLLAR] = ACTIONS(1197),
    [anon_sym_PLUS_EQ] = ACTIONS(767),
    [anon_sym_DASH_EQ] = ACTIONS(767),
    [anon_sym_STAR_EQ] = ACTIONS(767),
    [anon_sym_SLASH_EQ] = ACTIONS(767),
    [anon_sym_PERCENT_EQ] = ACTIONS(767),
    [anon_sym_AMP_EQ] = ACTIONS(767),
    [anon_sym_PIPE_EQ] = ACTIONS(767),
    [anon_sym_CARET_EQ] = ACTIONS(767),
    [anon_sym_LT_LT_EQ] = ACTIONS(767),
    [anon_sym_GT_GT_EQ] = ACTIONS(767),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(767),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_do] = ACTIONS(773),
    [anon_sym_when] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_or_else] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(773),
    [anon_sym_LT_LT] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym_or_return] = ACTIONS(773),
    [anon_sym_or_continue] = ACTIONS(773),
    [anon_sym_or_break] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(1229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1211),
    [anon_sym_map] = ACTIONS(1213),
    [anon_sym_bit_set] = ACTIONS(1215),
    [anon_sym_matrix] = ACTIONS(1217),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_uninitialized] = ACTIONS(767),
    [sym_tag] = ACTIONS(1232),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [172] = {
    [sym_expression] = STATE(4571),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_where] = ACTIONS(133),
    [anon_sym_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_RPAREN] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(129),
    [sym_tag] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [173] = {
    [sym_expression] = STATE(4574),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_where] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [174] = {
    [sym_procedure] = STATE(2467),
    [sym_type] = STATE(2427),
    [sym_pointer_type] = STATE(2470),
    [sym_variadic_type] = STATE(2470),
    [sym_array_type] = STATE(2470),
    [sym_map_type] = STATE(2470),
    [sym_union_type] = STATE(2470),
    [sym_bit_set_type] = STATE(2470),
    [sym_matrix_type] = STATE(2470),
    [sym_field_type] = STATE(2470),
    [sym_tuple_type] = STATE(2470),
    [sym_struct_type] = STATE(2470),
    [sym_enum_type] = STATE(2470),
    [sym_bit_field_type] = STATE(2470),
    [sym_constant_type] = STATE(2470),
    [sym_specialized_type] = STATE(2470),
    [sym__procedure_type] = STATE(2470),
    [sym_distinct_type] = STATE(2470),
    [sym_empty_type] = STATE(2470),
    [sym_polymorphic_type] = STATE(2470),
    [sym_conditional_type] = STATE(2470),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(859),
    [anon_sym_proc] = ACTIONS(1183),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_where] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(1185),
    [anon_sym_enum] = ACTIONS(1187),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_bit_field] = ACTIONS(1191),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(1255),
    [anon_sym_DOLLAR] = ACTIONS(1197),
    [anon_sym_PLUS_EQ] = ACTIONS(859),
    [anon_sym_DASH_EQ] = ACTIONS(859),
    [anon_sym_STAR_EQ] = ACTIONS(859),
    [anon_sym_SLASH_EQ] = ACTIONS(859),
    [anon_sym_PERCENT_EQ] = ACTIONS(859),
    [anon_sym_AMP_EQ] = ACTIONS(859),
    [anon_sym_PIPE_EQ] = ACTIONS(859),
    [anon_sym_CARET_EQ] = ACTIONS(859),
    [anon_sym_LT_LT_EQ] = ACTIONS(859),
    [anon_sym_GT_GT_EQ] = ACTIONS(859),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(859),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(861),
    [anon_sym_when] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(861),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_or_else] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(861),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1258),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(861),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym_or_return] = ACTIONS(861),
    [anon_sym_or_continue] = ACTIONS(861),
    [anon_sym_or_break] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1211),
    [anon_sym_map] = ACTIONS(1213),
    [anon_sym_bit_set] = ACTIONS(1215),
    [anon_sym_matrix] = ACTIONS(1217),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_uninitialized] = ACTIONS(859),
    [sym_tag] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [175] = {
    [sym_expression] = STATE(4230),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_RBRACE] = ACTIONS(129),
    [anon_sym_COMMA] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_where] = ACTIONS(133),
    [anon_sym_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(129),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(129),
    [sym_tag] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [176] = {
    [sym_expression] = STATE(4166),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_where] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1269),
    [anon_sym_BANG] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [177] = {
    [sym_procedure] = STATE(2467),
    [sym_type] = STATE(2436),
    [sym_pointer_type] = STATE(2470),
    [sym_variadic_type] = STATE(2470),
    [sym_array_type] = STATE(2470),
    [sym_map_type] = STATE(2470),
    [sym_union_type] = STATE(2470),
    [sym_bit_set_type] = STATE(2470),
    [sym_matrix_type] = STATE(2470),
    [sym_field_type] = STATE(2470),
    [sym_tuple_type] = STATE(2470),
    [sym_struct_type] = STATE(2470),
    [sym_enum_type] = STATE(2470),
    [sym_bit_field_type] = STATE(2470),
    [sym_constant_type] = STATE(2470),
    [sym_specialized_type] = STATE(2470),
    [sym__procedure_type] = STATE(2470),
    [sym_distinct_type] = STATE(2470),
    [sym_empty_type] = STATE(2470),
    [sym_polymorphic_type] = STATE(2470),
    [sym_conditional_type] = STATE(2470),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(875),
    [anon_sym_proc] = ACTIONS(1183),
    [anon_sym_DASH_GT] = ACTIONS(875),
    [anon_sym_where] = ACTIONS(877),
    [anon_sym_struct] = ACTIONS(1185),
    [anon_sym_enum] = ACTIONS(1187),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_bit_field] = ACTIONS(1191),
    [anon_sym_COLON] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_COLON_EQ] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1311),
    [anon_sym_DOLLAR] = ACTIONS(1197),
    [anon_sym_PLUS_EQ] = ACTIONS(875),
    [anon_sym_DASH_EQ] = ACTIONS(875),
    [anon_sym_STAR_EQ] = ACTIONS(875),
    [anon_sym_SLASH_EQ] = ACTIONS(875),
    [anon_sym_PERCENT_EQ] = ACTIONS(875),
    [anon_sym_AMP_EQ] = ACTIONS(875),
    [anon_sym_PIPE_EQ] = ACTIONS(875),
    [anon_sym_CARET_EQ] = ACTIONS(875),
    [anon_sym_LT_LT_EQ] = ACTIONS(875),
    [anon_sym_GT_GT_EQ] = ACTIONS(875),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(875),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(875),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_do] = ACTIONS(877),
    [anon_sym_when] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(877),
    [anon_sym_or_else] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(877),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_TILDE_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE] = ACTIONS(877),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_GT_GT] = ACTIONS(877),
    [anon_sym_STAR] = ACTIONS(877),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(1314),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(875),
    [anon_sym_DOT_DOT_LT] = ACTIONS(875),
    [anon_sym_not_in] = ACTIONS(877),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym_or_return] = ACTIONS(877),
    [anon_sym_or_continue] = ACTIONS(877),
    [anon_sym_or_break] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(1317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1211),
    [anon_sym_map] = ACTIONS(1213),
    [anon_sym_bit_set] = ACTIONS(1215),
    [anon_sym_matrix] = ACTIONS(1217),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_uninitialized] = ACTIONS(875),
    [sym_tag] = ACTIONS(1320),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [178] = {
    [sym_procedure] = STATE(2467),
    [sym_type] = STATE(2433),
    [sym_pointer_type] = STATE(2470),
    [sym_variadic_type] = STATE(2470),
    [sym_array_type] = STATE(2470),
    [sym_map_type] = STATE(2470),
    [sym_union_type] = STATE(2470),
    [sym_bit_set_type] = STATE(2470),
    [sym_matrix_type] = STATE(2470),
    [sym_field_type] = STATE(2470),
    [sym_tuple_type] = STATE(2470),
    [sym_struct_type] = STATE(2470),
    [sym_enum_type] = STATE(2470),
    [sym_bit_field_type] = STATE(2470),
    [sym_constant_type] = STATE(2470),
    [sym_specialized_type] = STATE(2470),
    [sym__procedure_type] = STATE(2470),
    [sym_distinct_type] = STATE(2470),
    [sym_empty_type] = STATE(2470),
    [sym_polymorphic_type] = STATE(2470),
    [sym_conditional_type] = STATE(2470),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_COLON_COLON] = ACTIONS(815),
    [anon_sym_proc] = ACTIONS(1183),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_where] = ACTIONS(818),
    [anon_sym_struct] = ACTIONS(1185),
    [anon_sym_enum] = ACTIONS(1187),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_bit_field] = ACTIONS(1191),
    [anon_sym_COLON] = ACTIONS(818),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_COLON_EQ] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(1323),
    [anon_sym_DOLLAR] = ACTIONS(1197),
    [anon_sym_PLUS_EQ] = ACTIONS(815),
    [anon_sym_DASH_EQ] = ACTIONS(815),
    [anon_sym_STAR_EQ] = ACTIONS(815),
    [anon_sym_SLASH_EQ] = ACTIONS(815),
    [anon_sym_PERCENT_EQ] = ACTIONS(815),
    [anon_sym_AMP_EQ] = ACTIONS(815),
    [anon_sym_PIPE_EQ] = ACTIONS(815),
    [anon_sym_CARET_EQ] = ACTIONS(815),
    [anon_sym_LT_LT_EQ] = ACTIONS(815),
    [anon_sym_GT_GT_EQ] = ACTIONS(815),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(815),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_do] = ACTIONS(818),
    [anon_sym_when] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(818),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(818),
    [anon_sym_or_else] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(818),
    [anon_sym_LT_LT] = ACTIONS(818),
    [anon_sym_GT_GT] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(818),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(1327),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(818),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym_or_return] = ACTIONS(818),
    [anon_sym_or_continue] = ACTIONS(818),
    [anon_sym_or_break] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(1331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1211),
    [anon_sym_map] = ACTIONS(1213),
    [anon_sym_bit_set] = ACTIONS(1215),
    [anon_sym_matrix] = ACTIONS(1217),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_uninitialized] = ACTIONS(815),
    [sym_tag] = ACTIONS(1335),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [179] = {
    [sym_procedure] = STATE(2467),
    [sym_type] = STATE(2435),
    [sym_pointer_type] = STATE(2470),
    [sym_variadic_type] = STATE(2470),
    [sym_array_type] = STATE(2470),
    [sym_map_type] = STATE(2470),
    [sym_union_type] = STATE(2470),
    [sym_bit_set_type] = STATE(2470),
    [sym_matrix_type] = STATE(2470),
    [sym_field_type] = STATE(2470),
    [sym_tuple_type] = STATE(2470),
    [sym_struct_type] = STATE(2470),
    [sym_enum_type] = STATE(2470),
    [sym_bit_field_type] = STATE(2470),
    [sym_constant_type] = STATE(2470),
    [sym_specialized_type] = STATE(2470),
    [sym__procedure_type] = STATE(2470),
    [sym_distinct_type] = STATE(2470),
    [sym_empty_type] = STATE(2470),
    [sym_polymorphic_type] = STATE(2470),
    [sym_conditional_type] = STATE(2470),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_COLON_COLON] = ACTIONS(837),
    [anon_sym_proc] = ACTIONS(1183),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_where] = ACTIONS(840),
    [anon_sym_struct] = ACTIONS(1185),
    [anon_sym_enum] = ACTIONS(1187),
    [anon_sym_EQ] = ACTIONS(840),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_bit_field] = ACTIONS(1191),
    [anon_sym_COLON] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COLON_EQ] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(1339),
    [anon_sym_DOLLAR] = ACTIONS(1197),
    [anon_sym_PLUS_EQ] = ACTIONS(837),
    [anon_sym_DASH_EQ] = ACTIONS(837),
    [anon_sym_STAR_EQ] = ACTIONS(837),
    [anon_sym_SLASH_EQ] = ACTIONS(837),
    [anon_sym_PERCENT_EQ] = ACTIONS(837),
    [anon_sym_AMP_EQ] = ACTIONS(837),
    [anon_sym_PIPE_EQ] = ACTIONS(837),
    [anon_sym_CARET_EQ] = ACTIONS(837),
    [anon_sym_LT_LT_EQ] = ACTIONS(837),
    [anon_sym_GT_GT_EQ] = ACTIONS(837),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(837),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(840),
    [anon_sym_when] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(840),
    [anon_sym_or_else] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(840),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_TILDE_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE] = ACTIONS(840),
    [anon_sym_LT_LT] = ACTIONS(840),
    [anon_sym_GT_GT] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(1343),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_DOT_DOT_LT] = ACTIONS(837),
    [anon_sym_not_in] = ACTIONS(840),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym_or_return] = ACTIONS(840),
    [anon_sym_or_continue] = ACTIONS(840),
    [anon_sym_or_break] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(1347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1211),
    [anon_sym_map] = ACTIONS(1213),
    [anon_sym_bit_set] = ACTIONS(1215),
    [anon_sym_matrix] = ACTIONS(1217),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_uninitialized] = ACTIONS(837),
    [sym_tag] = ACTIONS(1351),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [180] = {
    [sym_procedure] = STATE(2467),
    [sym_type] = STATE(2419),
    [sym_pointer_type] = STATE(2470),
    [sym_variadic_type] = STATE(2470),
    [sym_array_type] = STATE(2470),
    [sym_map_type] = STATE(2470),
    [sym_union_type] = STATE(2470),
    [sym_bit_set_type] = STATE(2470),
    [sym_matrix_type] = STATE(2470),
    [sym_field_type] = STATE(2470),
    [sym_tuple_type] = STATE(2470),
    [sym_struct_type] = STATE(2470),
    [sym_enum_type] = STATE(2470),
    [sym_bit_field_type] = STATE(2470),
    [sym_constant_type] = STATE(2470),
    [sym_specialized_type] = STATE(2470),
    [sym__procedure_type] = STATE(2470),
    [sym_distinct_type] = STATE(2470),
    [sym_empty_type] = STATE(2470),
    [sym_polymorphic_type] = STATE(2470),
    [sym_conditional_type] = STATE(2470),
    [sym_identifier] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_COLON_COLON] = ACTIONS(913),
    [anon_sym_proc] = ACTIONS(1183),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_where] = ACTIONS(915),
    [anon_sym_struct] = ACTIONS(1185),
    [anon_sym_enum] = ACTIONS(1187),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_union] = ACTIONS(1189),
    [anon_sym_bit_field] = ACTIONS(1191),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_COLON_EQ] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(1355),
    [anon_sym_DOLLAR] = ACTIONS(1197),
    [anon_sym_PLUS_EQ] = ACTIONS(913),
    [anon_sym_DASH_EQ] = ACTIONS(913),
    [anon_sym_STAR_EQ] = ACTIONS(913),
    [anon_sym_SLASH_EQ] = ACTIONS(913),
    [anon_sym_PERCENT_EQ] = ACTIONS(913),
    [anon_sym_AMP_EQ] = ACTIONS(913),
    [anon_sym_PIPE_EQ] = ACTIONS(913),
    [anon_sym_CARET_EQ] = ACTIONS(913),
    [anon_sym_LT_LT_EQ] = ACTIONS(913),
    [anon_sym_GT_GT_EQ] = ACTIONS(913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(913),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_do] = ACTIONS(915),
    [anon_sym_when] = ACTIONS(915),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(915),
    [anon_sym_or_else] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(915),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(1358),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym_or_return] = ACTIONS(915),
    [anon_sym_or_continue] = ACTIONS(915),
    [anon_sym_or_break] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(1361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1211),
    [anon_sym_map] = ACTIONS(1213),
    [anon_sym_bit_set] = ACTIONS(1215),
    [anon_sym_matrix] = ACTIONS(1217),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_uninitialized] = ACTIONS(913),
    [sym_tag] = ACTIONS(1364),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [181] = {
    [sym_expression] = STATE(5820),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(1369),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [182] = {
    [sym_procedure] = STATE(8236),
    [sym_expression] = STATE(5899),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(1369),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [183] = {
    [sym_procedure] = STATE(2566),
    [sym_type] = STATE(2620),
    [sym_pointer_type] = STATE(2607),
    [sym_variadic_type] = STATE(2607),
    [sym_array_type] = STATE(2607),
    [sym_map_type] = STATE(2607),
    [sym_union_type] = STATE(2607),
    [sym_bit_set_type] = STATE(2607),
    [sym_matrix_type] = STATE(2607),
    [sym_field_type] = STATE(2607),
    [sym_tuple_type] = STATE(2607),
    [sym_struct_type] = STATE(2607),
    [sym_enum_type] = STATE(2607),
    [sym_bit_field_type] = STATE(2607),
    [sym_constant_type] = STATE(2607),
    [sym_specialized_type] = STATE(2607),
    [sym__procedure_type] = STATE(2607),
    [sym_distinct_type] = STATE(2607),
    [sym_empty_type] = STATE(2607),
    [sym_polymorphic_type] = STATE(2607),
    [sym_conditional_type] = STATE(2607),
    [sym_identifier] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_COLON_COLON] = ACTIONS(815),
    [anon_sym_proc] = ACTIONS(1377),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(1379),
    [anon_sym_enum] = ACTIONS(1381),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_union] = ACTIONS(1383),
    [anon_sym_bit_field] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(818),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_COLON_EQ] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_DOLLAR] = ACTIONS(1391),
    [anon_sym_PLUS_EQ] = ACTIONS(815),
    [anon_sym_DASH_EQ] = ACTIONS(815),
    [anon_sym_STAR_EQ] = ACTIONS(815),
    [anon_sym_SLASH_EQ] = ACTIONS(815),
    [anon_sym_PERCENT_EQ] = ACTIONS(815),
    [anon_sym_AMP_EQ] = ACTIONS(815),
    [anon_sym_PIPE_EQ] = ACTIONS(815),
    [anon_sym_CARET_EQ] = ACTIONS(815),
    [anon_sym_LT_LT_EQ] = ACTIONS(815),
    [anon_sym_GT_GT_EQ] = ACTIONS(815),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(815),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_do] = ACTIONS(818),
    [anon_sym_when] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(818),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(818),
    [anon_sym_or_else] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(818),
    [anon_sym_LT_LT] = ACTIONS(818),
    [anon_sym_GT_GT] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(818),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(818),
    [anon_sym_DOT_DOT] = ACTIONS(1399),
    [anon_sym_or_return] = ACTIONS(818),
    [anon_sym_or_continue] = ACTIONS(818),
    [anon_sym_or_break] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(1401),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1405),
    [anon_sym_map] = ACTIONS(1407),
    [anon_sym_bit_set] = ACTIONS(1409),
    [anon_sym_matrix] = ACTIONS(1411),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_tag] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [184] = {
    [sym_procedure] = STATE(2566),
    [sym_type] = STATE(2569),
    [sym_pointer_type] = STATE(2607),
    [sym_variadic_type] = STATE(2607),
    [sym_array_type] = STATE(2607),
    [sym_map_type] = STATE(2607),
    [sym_union_type] = STATE(2607),
    [sym_bit_set_type] = STATE(2607),
    [sym_matrix_type] = STATE(2607),
    [sym_field_type] = STATE(2607),
    [sym_tuple_type] = STATE(2607),
    [sym_struct_type] = STATE(2607),
    [sym_enum_type] = STATE(2607),
    [sym_bit_field_type] = STATE(2607),
    [sym_constant_type] = STATE(2607),
    [sym_specialized_type] = STATE(2607),
    [sym__procedure_type] = STATE(2607),
    [sym_distinct_type] = STATE(2607),
    [sym_empty_type] = STATE(2607),
    [sym_polymorphic_type] = STATE(2607),
    [sym_conditional_type] = STATE(2607),
    [sym_identifier] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_COLON_COLON] = ACTIONS(767),
    [anon_sym_proc] = ACTIONS(1377),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_struct] = ACTIONS(1379),
    [anon_sym_enum] = ACTIONS(1381),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_union] = ACTIONS(1383),
    [anon_sym_bit_field] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_COLON_EQ] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_DOLLAR] = ACTIONS(1391),
    [anon_sym_PLUS_EQ] = ACTIONS(767),
    [anon_sym_DASH_EQ] = ACTIONS(767),
    [anon_sym_STAR_EQ] = ACTIONS(767),
    [anon_sym_SLASH_EQ] = ACTIONS(767),
    [anon_sym_PERCENT_EQ] = ACTIONS(767),
    [anon_sym_AMP_EQ] = ACTIONS(767),
    [anon_sym_PIPE_EQ] = ACTIONS(767),
    [anon_sym_CARET_EQ] = ACTIONS(767),
    [anon_sym_LT_LT_EQ] = ACTIONS(767),
    [anon_sym_GT_GT_EQ] = ACTIONS(767),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(767),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_do] = ACTIONS(773),
    [anon_sym_when] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_or_else] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(773),
    [anon_sym_LT_LT] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(1418),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(1399),
    [anon_sym_or_return] = ACTIONS(773),
    [anon_sym_or_continue] = ACTIONS(773),
    [anon_sym_or_break] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(1421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1405),
    [anon_sym_map] = ACTIONS(1407),
    [anon_sym_bit_set] = ACTIONS(1409),
    [anon_sym_matrix] = ACTIONS(1411),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_tag] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [185] = {
    [sym_procedure] = STATE(2566),
    [sym_type] = STATE(2564),
    [sym_pointer_type] = STATE(2607),
    [sym_variadic_type] = STATE(2607),
    [sym_array_type] = STATE(2607),
    [sym_map_type] = STATE(2607),
    [sym_union_type] = STATE(2607),
    [sym_bit_set_type] = STATE(2607),
    [sym_matrix_type] = STATE(2607),
    [sym_field_type] = STATE(2607),
    [sym_tuple_type] = STATE(2607),
    [sym_struct_type] = STATE(2607),
    [sym_enum_type] = STATE(2607),
    [sym_bit_field_type] = STATE(2607),
    [sym_constant_type] = STATE(2607),
    [sym_specialized_type] = STATE(2607),
    [sym__procedure_type] = STATE(2607),
    [sym_distinct_type] = STATE(2607),
    [sym_empty_type] = STATE(2607),
    [sym_polymorphic_type] = STATE(2607),
    [sym_conditional_type] = STATE(2607),
    [sym_identifier] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_COLON_COLON] = ACTIONS(913),
    [anon_sym_proc] = ACTIONS(1377),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_struct] = ACTIONS(1379),
    [anon_sym_enum] = ACTIONS(1381),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_union] = ACTIONS(1383),
    [anon_sym_bit_field] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_COLON_EQ] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(1424),
    [anon_sym_DOLLAR] = ACTIONS(1391),
    [anon_sym_PLUS_EQ] = ACTIONS(913),
    [anon_sym_DASH_EQ] = ACTIONS(913),
    [anon_sym_STAR_EQ] = ACTIONS(913),
    [anon_sym_SLASH_EQ] = ACTIONS(913),
    [anon_sym_PERCENT_EQ] = ACTIONS(913),
    [anon_sym_AMP_EQ] = ACTIONS(913),
    [anon_sym_PIPE_EQ] = ACTIONS(913),
    [anon_sym_CARET_EQ] = ACTIONS(913),
    [anon_sym_LT_LT_EQ] = ACTIONS(913),
    [anon_sym_GT_GT_EQ] = ACTIONS(913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(913),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_do] = ACTIONS(915),
    [anon_sym_when] = ACTIONS(915),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(915),
    [anon_sym_or_else] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(915),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(1399),
    [anon_sym_or_return] = ACTIONS(915),
    [anon_sym_or_continue] = ACTIONS(915),
    [anon_sym_or_break] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(1430),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1405),
    [anon_sym_map] = ACTIONS(1407),
    [anon_sym_bit_set] = ACTIONS(1409),
    [anon_sym_matrix] = ACTIONS(1411),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_tag] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [186] = {
    [sym_procedure] = STATE(2566),
    [sym_type] = STATE(2587),
    [sym_pointer_type] = STATE(2607),
    [sym_variadic_type] = STATE(2607),
    [sym_array_type] = STATE(2607),
    [sym_map_type] = STATE(2607),
    [sym_union_type] = STATE(2607),
    [sym_bit_set_type] = STATE(2607),
    [sym_matrix_type] = STATE(2607),
    [sym_field_type] = STATE(2607),
    [sym_tuple_type] = STATE(2607),
    [sym_struct_type] = STATE(2607),
    [sym_enum_type] = STATE(2607),
    [sym_bit_field_type] = STATE(2607),
    [sym_constant_type] = STATE(2607),
    [sym_specialized_type] = STATE(2607),
    [sym__procedure_type] = STATE(2607),
    [sym_distinct_type] = STATE(2607),
    [sym_empty_type] = STATE(2607),
    [sym_polymorphic_type] = STATE(2607),
    [sym_conditional_type] = STATE(2607),
    [sym_identifier] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_COLON_COLON] = ACTIONS(837),
    [anon_sym_proc] = ACTIONS(1377),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_struct] = ACTIONS(1379),
    [anon_sym_enum] = ACTIONS(1381),
    [anon_sym_EQ] = ACTIONS(840),
    [anon_sym_union] = ACTIONS(1383),
    [anon_sym_bit_field] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COLON_EQ] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_DOLLAR] = ACTIONS(1391),
    [anon_sym_PLUS_EQ] = ACTIONS(837),
    [anon_sym_DASH_EQ] = ACTIONS(837),
    [anon_sym_STAR_EQ] = ACTIONS(837),
    [anon_sym_SLASH_EQ] = ACTIONS(837),
    [anon_sym_PERCENT_EQ] = ACTIONS(837),
    [anon_sym_AMP_EQ] = ACTIONS(837),
    [anon_sym_PIPE_EQ] = ACTIONS(837),
    [anon_sym_CARET_EQ] = ACTIONS(837),
    [anon_sym_LT_LT_EQ] = ACTIONS(837),
    [anon_sym_GT_GT_EQ] = ACTIONS(837),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(837),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(840),
    [anon_sym_when] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(840),
    [anon_sym_or_else] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(840),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_TILDE_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE] = ACTIONS(840),
    [anon_sym_LT_LT] = ACTIONS(840),
    [anon_sym_GT_GT] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_DOT_DOT_LT] = ACTIONS(837),
    [anon_sym_not_in] = ACTIONS(840),
    [anon_sym_DOT_DOT] = ACTIONS(1399),
    [anon_sym_or_return] = ACTIONS(840),
    [anon_sym_or_continue] = ACTIONS(840),
    [anon_sym_or_break] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(1441),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1405),
    [anon_sym_map] = ACTIONS(1407),
    [anon_sym_bit_set] = ACTIONS(1409),
    [anon_sym_matrix] = ACTIONS(1411),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_tag] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [187] = {
    [sym_procedure] = STATE(8353),
    [sym_expression] = STATE(5912),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(1369),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [188] = {
    [sym_procedure] = STATE(8189),
    [sym_expression] = STATE(5928),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(1369),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [189] = {
    [sym_procedure] = STATE(2566),
    [sym_type] = STATE(2574),
    [sym_pointer_type] = STATE(2607),
    [sym_variadic_type] = STATE(2607),
    [sym_array_type] = STATE(2607),
    [sym_map_type] = STATE(2607),
    [sym_union_type] = STATE(2607),
    [sym_bit_set_type] = STATE(2607),
    [sym_matrix_type] = STATE(2607),
    [sym_field_type] = STATE(2607),
    [sym_tuple_type] = STATE(2607),
    [sym_struct_type] = STATE(2607),
    [sym_enum_type] = STATE(2607),
    [sym_bit_field_type] = STATE(2607),
    [sym_constant_type] = STATE(2607),
    [sym_specialized_type] = STATE(2607),
    [sym__procedure_type] = STATE(2607),
    [sym_distinct_type] = STATE(2607),
    [sym_empty_type] = STATE(2607),
    [sym_polymorphic_type] = STATE(2607),
    [sym_conditional_type] = STATE(2607),
    [sym_identifier] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(875),
    [anon_sym_proc] = ACTIONS(1377),
    [anon_sym_DASH_GT] = ACTIONS(875),
    [anon_sym_struct] = ACTIONS(1379),
    [anon_sym_enum] = ACTIONS(1381),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_union] = ACTIONS(1383),
    [anon_sym_bit_field] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_COLON_EQ] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1445),
    [anon_sym_DOLLAR] = ACTIONS(1391),
    [anon_sym_PLUS_EQ] = ACTIONS(875),
    [anon_sym_DASH_EQ] = ACTIONS(875),
    [anon_sym_STAR_EQ] = ACTIONS(875),
    [anon_sym_SLASH_EQ] = ACTIONS(875),
    [anon_sym_PERCENT_EQ] = ACTIONS(875),
    [anon_sym_AMP_EQ] = ACTIONS(875),
    [anon_sym_PIPE_EQ] = ACTIONS(875),
    [anon_sym_CARET_EQ] = ACTIONS(875),
    [anon_sym_LT_LT_EQ] = ACTIONS(875),
    [anon_sym_GT_GT_EQ] = ACTIONS(875),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(875),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(875),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_do] = ACTIONS(877),
    [anon_sym_when] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(877),
    [anon_sym_or_else] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(877),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_TILDE_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE] = ACTIONS(877),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_GT_GT] = ACTIONS(877),
    [anon_sym_STAR] = ACTIONS(877),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(1448),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(875),
    [anon_sym_DOT_DOT_LT] = ACTIONS(875),
    [anon_sym_not_in] = ACTIONS(877),
    [anon_sym_DOT_DOT] = ACTIONS(1399),
    [anon_sym_or_return] = ACTIONS(877),
    [anon_sym_or_continue] = ACTIONS(877),
    [anon_sym_or_break] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(1451),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1405),
    [anon_sym_map] = ACTIONS(1407),
    [anon_sym_bit_set] = ACTIONS(1409),
    [anon_sym_matrix] = ACTIONS(1411),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_tag] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [190] = {
    [sym_expression] = STATE(5798),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(1369),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [191] = {
    [sym_procedure] = STATE(2566),
    [sym_type] = STATE(2579),
    [sym_pointer_type] = STATE(2607),
    [sym_variadic_type] = STATE(2607),
    [sym_array_type] = STATE(2607),
    [sym_map_type] = STATE(2607),
    [sym_union_type] = STATE(2607),
    [sym_bit_set_type] = STATE(2607),
    [sym_matrix_type] = STATE(2607),
    [sym_field_type] = STATE(2607),
    [sym_tuple_type] = STATE(2607),
    [sym_struct_type] = STATE(2607),
    [sym_enum_type] = STATE(2607),
    [sym_bit_field_type] = STATE(2607),
    [sym_constant_type] = STATE(2607),
    [sym_specialized_type] = STATE(2607),
    [sym__procedure_type] = STATE(2607),
    [sym_distinct_type] = STATE(2607),
    [sym_empty_type] = STATE(2607),
    [sym_polymorphic_type] = STATE(2607),
    [sym_conditional_type] = STATE(2607),
    [sym_identifier] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [anon_sym_proc] = ACTIONS(1377),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_struct] = ACTIONS(1379),
    [anon_sym_enum] = ACTIONS(1381),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_union] = ACTIONS(1383),
    [anon_sym_bit_field] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COLON_EQ] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(1454),
    [anon_sym_DOLLAR] = ACTIONS(1391),
    [anon_sym_PLUS_EQ] = ACTIONS(891),
    [anon_sym_DASH_EQ] = ACTIONS(891),
    [anon_sym_STAR_EQ] = ACTIONS(891),
    [anon_sym_SLASH_EQ] = ACTIONS(891),
    [anon_sym_PERCENT_EQ] = ACTIONS(891),
    [anon_sym_AMP_EQ] = ACTIONS(891),
    [anon_sym_PIPE_EQ] = ACTIONS(891),
    [anon_sym_CARET_EQ] = ACTIONS(891),
    [anon_sym_LT_LT_EQ] = ACTIONS(891),
    [anon_sym_GT_GT_EQ] = ACTIONS(891),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(891),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_do] = ACTIONS(894),
    [anon_sym_when] = ACTIONS(894),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(894),
    [anon_sym_or_else] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(894),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(1399),
    [anon_sym_or_return] = ACTIONS(894),
    [anon_sym_or_continue] = ACTIONS(894),
    [anon_sym_or_break] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(1462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1405),
    [anon_sym_map] = ACTIONS(1407),
    [anon_sym_bit_set] = ACTIONS(1409),
    [anon_sym_matrix] = ACTIONS(1411),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_tag] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [192] = {
    [sym_procedure] = STATE(2566),
    [sym_type] = STATE(2575),
    [sym_pointer_type] = STATE(2607),
    [sym_variadic_type] = STATE(2607),
    [sym_array_type] = STATE(2607),
    [sym_map_type] = STATE(2607),
    [sym_union_type] = STATE(2607),
    [sym_bit_set_type] = STATE(2607),
    [sym_matrix_type] = STATE(2607),
    [sym_field_type] = STATE(2607),
    [sym_tuple_type] = STATE(2607),
    [sym_struct_type] = STATE(2607),
    [sym_enum_type] = STATE(2607),
    [sym_bit_field_type] = STATE(2607),
    [sym_constant_type] = STATE(2607),
    [sym_specialized_type] = STATE(2607),
    [sym__procedure_type] = STATE(2607),
    [sym_distinct_type] = STATE(2607),
    [sym_empty_type] = STATE(2607),
    [sym_polymorphic_type] = STATE(2607),
    [sym_conditional_type] = STATE(2607),
    [sym_identifier] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(859),
    [anon_sym_proc] = ACTIONS(1377),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(1379),
    [anon_sym_enum] = ACTIONS(1381),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_union] = ACTIONS(1383),
    [anon_sym_bit_field] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(1466),
    [anon_sym_DOLLAR] = ACTIONS(1391),
    [anon_sym_PLUS_EQ] = ACTIONS(859),
    [anon_sym_DASH_EQ] = ACTIONS(859),
    [anon_sym_STAR_EQ] = ACTIONS(859),
    [anon_sym_SLASH_EQ] = ACTIONS(859),
    [anon_sym_PERCENT_EQ] = ACTIONS(859),
    [anon_sym_AMP_EQ] = ACTIONS(859),
    [anon_sym_PIPE_EQ] = ACTIONS(859),
    [anon_sym_CARET_EQ] = ACTIONS(859),
    [anon_sym_LT_LT_EQ] = ACTIONS(859),
    [anon_sym_GT_GT_EQ] = ACTIONS(859),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(859),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(861),
    [anon_sym_when] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(861),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_or_else] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(861),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1469),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(861),
    [anon_sym_DOT_DOT] = ACTIONS(1399),
    [anon_sym_or_return] = ACTIONS(861),
    [anon_sym_or_continue] = ACTIONS(861),
    [anon_sym_or_break] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(1472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1405),
    [anon_sym_map] = ACTIONS(1407),
    [anon_sym_bit_set] = ACTIONS(1409),
    [anon_sym_matrix] = ACTIONS(1411),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_tag] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [193] = {
    [sym_procedure] = STATE(7866),
    [sym_expression] = STATE(5878),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(1369),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_BANG] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [194] = {
    [sym_expression] = STATE(5250),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_PIPE] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(167),
    [anon_sym_do] = ACTIONS(167),
    [anon_sym_when] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(311),
    [anon_sym_BANG] = ACTIONS(311),
    [anon_sym_AMP] = ACTIONS(311),
    [anon_sym_PIPE_PIPE] = ACTIONS(163),
    [anon_sym_or_else] = ACTIONS(167),
    [anon_sym_AMP_AMP] = ACTIONS(163),
    [anon_sym_GT] = ACTIONS(167),
    [anon_sym_GT_EQ] = ACTIONS(163),
    [anon_sym_LT_EQ] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(167),
    [anon_sym_EQ_EQ] = ACTIONS(163),
    [anon_sym_BANG_EQ] = ACTIONS(163),
    [anon_sym_TILDE_EQ] = ACTIONS(163),
    [anon_sym_AMP_TILDE] = ACTIONS(163),
    [anon_sym_LT_LT] = ACTIONS(163),
    [anon_sym_GT_GT] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_PERCENT] = ACTIONS(167),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(163),
    [anon_sym_DOT_DOT_LT] = ACTIONS(163),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_not_in] = ACTIONS(167),
    [anon_sym_DOT_DOT] = ACTIONS(317),
    [anon_sym_or_return] = ACTIONS(167),
    [anon_sym_or_continue] = ACTIONS(167),
    [anon_sym_or_break] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [195] = {
    [sym_expression] = STATE(5253),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_DASH_GT] = ACTIONS(201),
    [anon_sym_PIPE] = ACTIONS(203),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(203),
    [anon_sym_do] = ACTIONS(203),
    [anon_sym_when] = ACTIONS(203),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_QMARK] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_DASH] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [anon_sym_BANG] = ACTIONS(311),
    [anon_sym_AMP] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(201),
    [anon_sym_or_else] = ACTIONS(203),
    [anon_sym_AMP_AMP] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(203),
    [anon_sym_GT_EQ] = ACTIONS(201),
    [anon_sym_LT_EQ] = ACTIONS(201),
    [anon_sym_LT] = ACTIONS(203),
    [anon_sym_EQ_EQ] = ACTIONS(201),
    [anon_sym_BANG_EQ] = ACTIONS(201),
    [anon_sym_TILDE_EQ] = ACTIONS(201),
    [anon_sym_AMP_TILDE] = ACTIONS(201),
    [anon_sym_LT_LT] = ACTIONS(201),
    [anon_sym_GT_GT] = ACTIONS(201),
    [anon_sym_STAR] = ACTIONS(201),
    [anon_sym_SLASH] = ACTIONS(203),
    [anon_sym_PERCENT] = ACTIONS(203),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(201),
    [anon_sym_DOT] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(201),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(201),
    [anon_sym_DOT_DOT_LT] = ACTIONS(201),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_not_in] = ACTIONS(203),
    [anon_sym_DOT_DOT] = ACTIONS(317),
    [anon_sym_or_return] = ACTIONS(203),
    [anon_sym_or_continue] = ACTIONS(203),
    [anon_sym_or_break] = ACTIONS(203),
    [anon_sym_CARET] = ACTIONS(201),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [196] = {
    [sym_expression] = STATE(5253),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_DASH_GT] = ACTIONS(129),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_LPAREN] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(133),
    [anon_sym_do] = ACTIONS(133),
    [anon_sym_when] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(133),
    [anon_sym_QMARK] = ACTIONS(129),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(133),
    [anon_sym_TILDE] = ACTIONS(133),
    [anon_sym_BANG] = ACTIONS(311),
    [anon_sym_AMP] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(129),
    [anon_sym_or_else] = ACTIONS(133),
    [anon_sym_AMP_AMP] = ACTIONS(129),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_EQ] = ACTIONS(129),
    [anon_sym_LT_EQ] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(133),
    [anon_sym_EQ_EQ] = ACTIONS(129),
    [anon_sym_BANG_EQ] = ACTIONS(129),
    [anon_sym_TILDE_EQ] = ACTIONS(129),
    [anon_sym_AMP_TILDE] = ACTIONS(129),
    [anon_sym_LT_LT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(129),
    [anon_sym_STAR] = ACTIONS(129),
    [anon_sym_SLASH] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(133),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(129),
    [anon_sym_DOT] = ACTIONS(133),
    [anon_sym_LBRACK] = ACTIONS(129),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(129),
    [anon_sym_DOT_DOT_LT] = ACTIONS(129),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_not_in] = ACTIONS(133),
    [anon_sym_DOT_DOT] = ACTIONS(317),
    [anon_sym_or_return] = ACTIONS(133),
    [anon_sym_or_continue] = ACTIONS(133),
    [anon_sym_or_break] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(129),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [197] = {
    [sym_procedure] = STATE(2852),
    [sym_type] = STATE(2824),
    [sym_pointer_type] = STATE(2807),
    [sym_variadic_type] = STATE(2807),
    [sym_array_type] = STATE(2807),
    [sym_map_type] = STATE(2807),
    [sym_union_type] = STATE(2807),
    [sym_bit_set_type] = STATE(2807),
    [sym_matrix_type] = STATE(2807),
    [sym_field_type] = STATE(2807),
    [sym_tuple_type] = STATE(2807),
    [sym_struct_type] = STATE(2807),
    [sym_enum_type] = STATE(2807),
    [sym_bit_field_type] = STATE(2807),
    [sym_constant_type] = STATE(2807),
    [sym_specialized_type] = STATE(2807),
    [sym__procedure_type] = STATE(2807),
    [sym_distinct_type] = STATE(2807),
    [sym_empty_type] = STATE(2807),
    [sym_polymorphic_type] = STATE(2807),
    [sym_conditional_type] = STATE(2807),
    [sym_identifier] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(875),
    [anon_sym_proc] = ACTIONS(1485),
    [anon_sym_DASH_GT] = ACTIONS(875),
    [anon_sym_struct] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1489),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_union] = ACTIONS(1491),
    [anon_sym_bit_field] = ACTIONS(1493),
    [anon_sym_COLON] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_COLON_EQ] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_PLUS_EQ] = ACTIONS(875),
    [anon_sym_DASH_EQ] = ACTIONS(875),
    [anon_sym_STAR_EQ] = ACTIONS(875),
    [anon_sym_SLASH_EQ] = ACTIONS(875),
    [anon_sym_PERCENT_EQ] = ACTIONS(875),
    [anon_sym_AMP_EQ] = ACTIONS(875),
    [anon_sym_PIPE_EQ] = ACTIONS(875),
    [anon_sym_CARET_EQ] = ACTIONS(875),
    [anon_sym_LT_LT_EQ] = ACTIONS(875),
    [anon_sym_GT_GT_EQ] = ACTIONS(875),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(875),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(875),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_when] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(877),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(877),
    [anon_sym_or_else] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(877),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_TILDE_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE] = ACTIONS(877),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_GT_GT] = ACTIONS(877),
    [anon_sym_STAR] = ACTIONS(877),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(1502),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(875),
    [anon_sym_DOT_DOT_LT] = ACTIONS(875),
    [anon_sym_not_in] = ACTIONS(877),
    [anon_sym_DOT_DOT] = ACTIONS(1505),
    [anon_sym_or_return] = ACTIONS(877),
    [anon_sym_or_continue] = ACTIONS(877),
    [anon_sym_or_break] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(1507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1510),
    [anon_sym_map] = ACTIONS(1512),
    [anon_sym_bit_set] = ACTIONS(1514),
    [anon_sym_matrix] = ACTIONS(1516),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_tag] = ACTIONS(1518),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [198] = {
    [sym_procedure] = STATE(2852),
    [sym_type] = STATE(2848),
    [sym_pointer_type] = STATE(2807),
    [sym_variadic_type] = STATE(2807),
    [sym_array_type] = STATE(2807),
    [sym_map_type] = STATE(2807),
    [sym_union_type] = STATE(2807),
    [sym_bit_set_type] = STATE(2807),
    [sym_matrix_type] = STATE(2807),
    [sym_field_type] = STATE(2807),
    [sym_tuple_type] = STATE(2807),
    [sym_struct_type] = STATE(2807),
    [sym_enum_type] = STATE(2807),
    [sym_bit_field_type] = STATE(2807),
    [sym_constant_type] = STATE(2807),
    [sym_specialized_type] = STATE(2807),
    [sym__procedure_type] = STATE(2807),
    [sym_distinct_type] = STATE(2807),
    [sym_empty_type] = STATE(2807),
    [sym_polymorphic_type] = STATE(2807),
    [sym_conditional_type] = STATE(2807),
    [sym_identifier] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_COLON_COLON] = ACTIONS(815),
    [anon_sym_proc] = ACTIONS(1485),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1489),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_union] = ACTIONS(1491),
    [anon_sym_bit_field] = ACTIONS(1493),
    [anon_sym_COLON] = ACTIONS(818),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_COLON_EQ] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(1520),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_PLUS_EQ] = ACTIONS(815),
    [anon_sym_DASH_EQ] = ACTIONS(815),
    [anon_sym_STAR_EQ] = ACTIONS(815),
    [anon_sym_SLASH_EQ] = ACTIONS(815),
    [anon_sym_PERCENT_EQ] = ACTIONS(815),
    [anon_sym_AMP_EQ] = ACTIONS(815),
    [anon_sym_PIPE_EQ] = ACTIONS(815),
    [anon_sym_CARET_EQ] = ACTIONS(815),
    [anon_sym_LT_LT_EQ] = ACTIONS(815),
    [anon_sym_GT_GT_EQ] = ACTIONS(815),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(815),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_when] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(818),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(818),
    [anon_sym_or_else] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(818),
    [anon_sym_LT_LT] = ACTIONS(818),
    [anon_sym_GT_GT] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(818),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(818),
    [anon_sym_DOT_DOT] = ACTIONS(1505),
    [anon_sym_or_return] = ACTIONS(818),
    [anon_sym_or_continue] = ACTIONS(818),
    [anon_sym_or_break] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(1528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1510),
    [anon_sym_map] = ACTIONS(1512),
    [anon_sym_bit_set] = ACTIONS(1514),
    [anon_sym_matrix] = ACTIONS(1516),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_tag] = ACTIONS(1518),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [199] = {
    [sym_expression] = STATE(5860),
    [sym__expression_no_tag] = STATE(5195),
    [sym_unary_expression] = STATE(5195),
    [sym_binary_expression] = STATE(5195),
    [sym_ternary_expression] = STATE(5195),
    [sym_call_expression] = STATE(5195),
    [sym_selector_call_expression] = STATE(5195),
    [sym_member_expression] = STATE(5195),
    [sym_index_expression] = STATE(5195),
    [sym_slice_expression] = STATE(5195),
    [sym_range_expression] = STATE(5195),
    [sym_cast_expression] = STATE(5195),
    [sym_in_expression] = STATE(5195),
    [sym_variadic_expression] = STATE(5195),
    [sym_parenthesized_expression] = STATE(5195),
    [sym_or_return_expression] = STATE(5195),
    [sym_or_continue_expression] = STATE(5195),
    [sym_or_break_expression] = STATE(5195),
    [sym_address] = STATE(5195),
    [sym_map_type] = STATE(5195),
    [sym_matrix_type] = STATE(5195),
    [sym_distinct_type] = STATE(5195),
    [sym_literal] = STATE(5195),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(1532),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(1534),
    [anon_sym_do] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(311),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(317),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [200] = {
    [sym_expression] = STATE(5976),
    [sym__expression_no_tag] = STATE(5195),
    [sym_unary_expression] = STATE(5195),
    [sym_binary_expression] = STATE(5195),
    [sym_ternary_expression] = STATE(5195),
    [sym_call_expression] = STATE(5195),
    [sym_selector_call_expression] = STATE(5195),
    [sym_member_expression] = STATE(5195),
    [sym_index_expression] = STATE(5195),
    [sym_slice_expression] = STATE(5195),
    [sym_range_expression] = STATE(5195),
    [sym_cast_expression] = STATE(5195),
    [sym_in_expression] = STATE(5195),
    [sym_variadic_expression] = STATE(5195),
    [sym_parenthesized_expression] = STATE(5195),
    [sym_or_return_expression] = STATE(5195),
    [sym_or_continue_expression] = STATE(5195),
    [sym_or_break_expression] = STATE(5195),
    [sym_address] = STATE(5195),
    [sym_map_type] = STATE(5195),
    [sym_matrix_type] = STATE(5195),
    [sym_distinct_type] = STATE(5195),
    [sym_literal] = STATE(5195),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(1532),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(1534),
    [anon_sym_do] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(311),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(317),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [201] = {
    [sym_expression] = STATE(5852),
    [sym__expression_no_tag] = STATE(5195),
    [sym_unary_expression] = STATE(5195),
    [sym_binary_expression] = STATE(5195),
    [sym_ternary_expression] = STATE(5195),
    [sym_call_expression] = STATE(5195),
    [sym_selector_call_expression] = STATE(5195),
    [sym_member_expression] = STATE(5195),
    [sym_index_expression] = STATE(5195),
    [sym_slice_expression] = STATE(5195),
    [sym_range_expression] = STATE(5195),
    [sym_cast_expression] = STATE(5195),
    [sym_in_expression] = STATE(5195),
    [sym_variadic_expression] = STATE(5195),
    [sym_parenthesized_expression] = STATE(5195),
    [sym_or_return_expression] = STATE(5195),
    [sym_or_continue_expression] = STATE(5195),
    [sym_or_break_expression] = STATE(5195),
    [sym_address] = STATE(5195),
    [sym_map_type] = STATE(5195),
    [sym_matrix_type] = STATE(5195),
    [sym_distinct_type] = STATE(5195),
    [sym_literal] = STATE(5195),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(1532),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(1534),
    [anon_sym_do] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(311),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(317),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [202] = {
    [sym_expression] = STATE(5986),
    [sym__expression_no_tag] = STATE(5195),
    [sym_unary_expression] = STATE(5195),
    [sym_binary_expression] = STATE(5195),
    [sym_ternary_expression] = STATE(5195),
    [sym_call_expression] = STATE(5195),
    [sym_selector_call_expression] = STATE(5195),
    [sym_member_expression] = STATE(5195),
    [sym_index_expression] = STATE(5195),
    [sym_slice_expression] = STATE(5195),
    [sym_range_expression] = STATE(5195),
    [sym_cast_expression] = STATE(5195),
    [sym_in_expression] = STATE(5195),
    [sym_variadic_expression] = STATE(5195),
    [sym_parenthesized_expression] = STATE(5195),
    [sym_or_return_expression] = STATE(5195),
    [sym_or_continue_expression] = STATE(5195),
    [sym_or_break_expression] = STATE(5195),
    [sym_address] = STATE(5195),
    [sym_map_type] = STATE(5195),
    [sym_matrix_type] = STATE(5195),
    [sym_distinct_type] = STATE(5195),
    [sym_literal] = STATE(5195),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(1532),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(1534),
    [anon_sym_do] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_BANG] = ACTIONS(311),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(67),
    [anon_sym_GT_GT] = ACTIONS(67),
    [anon_sym_STAR] = ACTIONS(67),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_DOT_DOT] = ACTIONS(317),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(67),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [203] = {
    [sym_procedure] = STATE(2852),
    [sym_type] = STATE(2846),
    [sym_pointer_type] = STATE(2807),
    [sym_variadic_type] = STATE(2807),
    [sym_array_type] = STATE(2807),
    [sym_map_type] = STATE(2807),
    [sym_union_type] = STATE(2807),
    [sym_bit_set_type] = STATE(2807),
    [sym_matrix_type] = STATE(2807),
    [sym_field_type] = STATE(2807),
    [sym_tuple_type] = STATE(2807),
    [sym_struct_type] = STATE(2807),
    [sym_enum_type] = STATE(2807),
    [sym_bit_field_type] = STATE(2807),
    [sym_constant_type] = STATE(2807),
    [sym_specialized_type] = STATE(2807),
    [sym__procedure_type] = STATE(2807),
    [sym_distinct_type] = STATE(2807),
    [sym_empty_type] = STATE(2807),
    [sym_polymorphic_type] = STATE(2807),
    [sym_conditional_type] = STATE(2807),
    [sym_identifier] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_COLON_COLON] = ACTIONS(767),
    [anon_sym_proc] = ACTIONS(1485),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_struct] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1489),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_union] = ACTIONS(1491),
    [anon_sym_bit_field] = ACTIONS(1493),
    [anon_sym_COLON] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_COLON_EQ] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(1536),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_PLUS_EQ] = ACTIONS(767),
    [anon_sym_DASH_EQ] = ACTIONS(767),
    [anon_sym_STAR_EQ] = ACTIONS(767),
    [anon_sym_SLASH_EQ] = ACTIONS(767),
    [anon_sym_PERCENT_EQ] = ACTIONS(767),
    [anon_sym_AMP_EQ] = ACTIONS(767),
    [anon_sym_PIPE_EQ] = ACTIONS(767),
    [anon_sym_CARET_EQ] = ACTIONS(767),
    [anon_sym_LT_LT_EQ] = ACTIONS(767),
    [anon_sym_GT_GT_EQ] = ACTIONS(767),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(767),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_when] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_or_else] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(773),
    [anon_sym_LT_LT] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(1539),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(1505),
    [anon_sym_or_return] = ACTIONS(773),
    [anon_sym_or_continue] = ACTIONS(773),
    [anon_sym_or_break] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(1542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1510),
    [anon_sym_map] = ACTIONS(1512),
    [anon_sym_bit_set] = ACTIONS(1514),
    [anon_sym_matrix] = ACTIONS(1516),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_tag] = ACTIONS(1518),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [204] = {
    [sym_procedure] = STATE(2852),
    [sym_type] = STATE(2775),
    [sym_pointer_type] = STATE(2807),
    [sym_variadic_type] = STATE(2807),
    [sym_array_type] = STATE(2807),
    [sym_map_type] = STATE(2807),
    [sym_union_type] = STATE(2807),
    [sym_bit_set_type] = STATE(2807),
    [sym_matrix_type] = STATE(2807),
    [sym_field_type] = STATE(2807),
    [sym_tuple_type] = STATE(2807),
    [sym_struct_type] = STATE(2807),
    [sym_enum_type] = STATE(2807),
    [sym_bit_field_type] = STATE(2807),
    [sym_constant_type] = STATE(2807),
    [sym_specialized_type] = STATE(2807),
    [sym__procedure_type] = STATE(2807),
    [sym_distinct_type] = STATE(2807),
    [sym_empty_type] = STATE(2807),
    [sym_polymorphic_type] = STATE(2807),
    [sym_conditional_type] = STATE(2807),
    [sym_identifier] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(859),
    [anon_sym_proc] = ACTIONS(1485),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1489),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_union] = ACTIONS(1491),
    [anon_sym_bit_field] = ACTIONS(1493),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_PLUS_EQ] = ACTIONS(859),
    [anon_sym_DASH_EQ] = ACTIONS(859),
    [anon_sym_STAR_EQ] = ACTIONS(859),
    [anon_sym_SLASH_EQ] = ACTIONS(859),
    [anon_sym_PERCENT_EQ] = ACTIONS(859),
    [anon_sym_AMP_EQ] = ACTIONS(859),
    [anon_sym_PIPE_EQ] = ACTIONS(859),
    [anon_sym_CARET_EQ] = ACTIONS(859),
    [anon_sym_LT_LT_EQ] = ACTIONS(859),
    [anon_sym_GT_GT_EQ] = ACTIONS(859),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(859),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_when] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(861),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_or_else] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(861),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(861),
    [anon_sym_DOT_DOT] = ACTIONS(1505),
    [anon_sym_or_return] = ACTIONS(861),
    [anon_sym_or_continue] = ACTIONS(861),
    [anon_sym_or_break] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(1551),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1510),
    [anon_sym_map] = ACTIONS(1512),
    [anon_sym_bit_set] = ACTIONS(1514),
    [anon_sym_matrix] = ACTIONS(1516),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_tag] = ACTIONS(1518),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [205] = {
    [sym_procedure] = STATE(2852),
    [sym_type] = STATE(2782),
    [sym_pointer_type] = STATE(2807),
    [sym_variadic_type] = STATE(2807),
    [sym_array_type] = STATE(2807),
    [sym_map_type] = STATE(2807),
    [sym_union_type] = STATE(2807),
    [sym_bit_set_type] = STATE(2807),
    [sym_matrix_type] = STATE(2807),
    [sym_field_type] = STATE(2807),
    [sym_tuple_type] = STATE(2807),
    [sym_struct_type] = STATE(2807),
    [sym_enum_type] = STATE(2807),
    [sym_bit_field_type] = STATE(2807),
    [sym_constant_type] = STATE(2807),
    [sym_specialized_type] = STATE(2807),
    [sym__procedure_type] = STATE(2807),
    [sym_distinct_type] = STATE(2807),
    [sym_empty_type] = STATE(2807),
    [sym_polymorphic_type] = STATE(2807),
    [sym_conditional_type] = STATE(2807),
    [sym_identifier] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [anon_sym_proc] = ACTIONS(1485),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_struct] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1489),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_union] = ACTIONS(1491),
    [anon_sym_bit_field] = ACTIONS(1493),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COLON_EQ] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(1554),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_PLUS_EQ] = ACTIONS(891),
    [anon_sym_DASH_EQ] = ACTIONS(891),
    [anon_sym_STAR_EQ] = ACTIONS(891),
    [anon_sym_SLASH_EQ] = ACTIONS(891),
    [anon_sym_PERCENT_EQ] = ACTIONS(891),
    [anon_sym_AMP_EQ] = ACTIONS(891),
    [anon_sym_PIPE_EQ] = ACTIONS(891),
    [anon_sym_CARET_EQ] = ACTIONS(891),
    [anon_sym_LT_LT_EQ] = ACTIONS(891),
    [anon_sym_GT_GT_EQ] = ACTIONS(891),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(891),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_when] = ACTIONS(894),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(894),
    [anon_sym_or_else] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(894),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(1558),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(1505),
    [anon_sym_or_return] = ACTIONS(894),
    [anon_sym_or_continue] = ACTIONS(894),
    [anon_sym_or_break] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(1562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1510),
    [anon_sym_map] = ACTIONS(1512),
    [anon_sym_bit_set] = ACTIONS(1514),
    [anon_sym_matrix] = ACTIONS(1516),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_tag] = ACTIONS(1518),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [206] = {
    [sym_procedure] = STATE(2852),
    [sym_type] = STATE(2871),
    [sym_pointer_type] = STATE(2807),
    [sym_variadic_type] = STATE(2807),
    [sym_array_type] = STATE(2807),
    [sym_map_type] = STATE(2807),
    [sym_union_type] = STATE(2807),
    [sym_bit_set_type] = STATE(2807),
    [sym_matrix_type] = STATE(2807),
    [sym_field_type] = STATE(2807),
    [sym_tuple_type] = STATE(2807),
    [sym_struct_type] = STATE(2807),
    [sym_enum_type] = STATE(2807),
    [sym_bit_field_type] = STATE(2807),
    [sym_constant_type] = STATE(2807),
    [sym_specialized_type] = STATE(2807),
    [sym__procedure_type] = STATE(2807),
    [sym_distinct_type] = STATE(2807),
    [sym_empty_type] = STATE(2807),
    [sym_polymorphic_type] = STATE(2807),
    [sym_conditional_type] = STATE(2807),
    [sym_identifier] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_COLON_COLON] = ACTIONS(837),
    [anon_sym_proc] = ACTIONS(1485),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_struct] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1489),
    [anon_sym_EQ] = ACTIONS(840),
    [anon_sym_union] = ACTIONS(1491),
    [anon_sym_bit_field] = ACTIONS(1493),
    [anon_sym_COLON] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COLON_EQ] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(1566),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_PLUS_EQ] = ACTIONS(837),
    [anon_sym_DASH_EQ] = ACTIONS(837),
    [anon_sym_STAR_EQ] = ACTIONS(837),
    [anon_sym_SLASH_EQ] = ACTIONS(837),
    [anon_sym_PERCENT_EQ] = ACTIONS(837),
    [anon_sym_AMP_EQ] = ACTIONS(837),
    [anon_sym_PIPE_EQ] = ACTIONS(837),
    [anon_sym_CARET_EQ] = ACTIONS(837),
    [anon_sym_LT_LT_EQ] = ACTIONS(837),
    [anon_sym_GT_GT_EQ] = ACTIONS(837),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(837),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_when] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(840),
    [anon_sym_or_else] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(840),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_TILDE_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE] = ACTIONS(840),
    [anon_sym_LT_LT] = ACTIONS(840),
    [anon_sym_GT_GT] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(1570),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_DOT_DOT_LT] = ACTIONS(837),
    [anon_sym_not_in] = ACTIONS(840),
    [anon_sym_DOT_DOT] = ACTIONS(1505),
    [anon_sym_or_return] = ACTIONS(840),
    [anon_sym_or_continue] = ACTIONS(840),
    [anon_sym_or_break] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(1574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1510),
    [anon_sym_map] = ACTIONS(1512),
    [anon_sym_bit_set] = ACTIONS(1514),
    [anon_sym_matrix] = ACTIONS(1516),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_tag] = ACTIONS(1518),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [207] = {
    [sym_procedure] = STATE(2852),
    [sym_type] = STATE(2884),
    [sym_pointer_type] = STATE(2807),
    [sym_variadic_type] = STATE(2807),
    [sym_array_type] = STATE(2807),
    [sym_map_type] = STATE(2807),
    [sym_union_type] = STATE(2807),
    [sym_bit_set_type] = STATE(2807),
    [sym_matrix_type] = STATE(2807),
    [sym_field_type] = STATE(2807),
    [sym_tuple_type] = STATE(2807),
    [sym_struct_type] = STATE(2807),
    [sym_enum_type] = STATE(2807),
    [sym_bit_field_type] = STATE(2807),
    [sym_constant_type] = STATE(2807),
    [sym_specialized_type] = STATE(2807),
    [sym__procedure_type] = STATE(2807),
    [sym_distinct_type] = STATE(2807),
    [sym_empty_type] = STATE(2807),
    [sym_polymorphic_type] = STATE(2807),
    [sym_conditional_type] = STATE(2807),
    [sym_identifier] = ACTIONS(1483),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_COLON_COLON] = ACTIONS(913),
    [anon_sym_proc] = ACTIONS(1485),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_struct] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1489),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_union] = ACTIONS(1491),
    [anon_sym_bit_field] = ACTIONS(1493),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_COLON_EQ] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(1578),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_PLUS_EQ] = ACTIONS(913),
    [anon_sym_DASH_EQ] = ACTIONS(913),
    [anon_sym_STAR_EQ] = ACTIONS(913),
    [anon_sym_SLASH_EQ] = ACTIONS(913),
    [anon_sym_PERCENT_EQ] = ACTIONS(913),
    [anon_sym_AMP_EQ] = ACTIONS(913),
    [anon_sym_PIPE_EQ] = ACTIONS(913),
    [anon_sym_CARET_EQ] = ACTIONS(913),
    [anon_sym_LT_LT_EQ] = ACTIONS(913),
    [anon_sym_GT_GT_EQ] = ACTIONS(913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(913),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_when] = ACTIONS(915),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(1500),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(915),
    [anon_sym_or_else] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(915),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(1581),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(1505),
    [anon_sym_or_return] = ACTIONS(915),
    [anon_sym_or_continue] = ACTIONS(915),
    [anon_sym_or_break] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(1584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1510),
    [anon_sym_map] = ACTIONS(1512),
    [anon_sym_bit_set] = ACTIONS(1514),
    [anon_sym_matrix] = ACTIONS(1516),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_tag] = ACTIONS(1518),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [208] = {
    [sym_declaration] = STATE(7479),
    [sym_package_declaration] = STATE(7755),
    [sym_import_declaration] = STATE(7755),
    [sym_procedure_declaration] = STATE(7755),
    [sym_overloaded_procedure_declaration] = STATE(7755),
    [sym_struct_declaration] = STATE(7755),
    [sym_enum_declaration] = STATE(7755),
    [sym_union_declaration] = STATE(7755),
    [sym_bit_field_declaration] = STATE(7755),
    [sym_variable_declaration] = STATE(7755),
    [sym_const_declaration] = STATE(7755),
    [sym_const_type_declaration] = STATE(7755),
    [sym_foreign_block] = STATE(7755),
    [sym_attributes] = STATE(700),
    [sym_attribute] = STATE(6005),
    [sym_when_statement] = STATE(7755),
    [sym_var_declaration] = STATE(7755),
    [sym_expression] = STATE(5643),
    [sym__expression_no_tag] = STATE(4616),
    [sym_unary_expression] = STATE(4616),
    [sym_binary_expression] = STATE(4616),
    [sym_ternary_expression] = STATE(4616),
    [sym_call_expression] = STATE(4616),
    [sym_selector_call_expression] = STATE(4616),
    [sym_member_expression] = STATE(4616),
    [sym_index_expression] = STATE(4616),
    [sym_slice_expression] = STATE(4616),
    [sym_range_expression] = STATE(4616),
    [sym_cast_expression] = STATE(4616),
    [sym_in_expression] = STATE(4616),
    [sym_variadic_expression] = STATE(4616),
    [sym_parenthesized_expression] = STATE(4616),
    [sym_or_return_expression] = STATE(4616),
    [sym_or_continue_expression] = STATE(4616),
    [sym_or_break_expression] = STATE(4616),
    [sym_address] = STATE(4616),
    [sym_map_type] = STATE(4616),
    [sym_matrix_type] = STATE(4616),
    [sym_distinct_type] = STATE(4616),
    [sym_literal] = STATE(4616),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [aux_sym_source_file_repeat1] = STATE(209),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [ts_builtin_sym_end] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_foreign] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_using] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_when] = ACTIONS(23),
    [anon_sym_QMARK] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [209] = {
    [sym_declaration] = STATE(8262),
    [sym_package_declaration] = STATE(7755),
    [sym_import_declaration] = STATE(7755),
    [sym_procedure_declaration] = STATE(7755),
    [sym_overloaded_procedure_declaration] = STATE(7755),
    [sym_struct_declaration] = STATE(7755),
    [sym_enum_declaration] = STATE(7755),
    [sym_union_declaration] = STATE(7755),
    [sym_bit_field_declaration] = STATE(7755),
    [sym_variable_declaration] = STATE(7755),
    [sym_const_declaration] = STATE(7755),
    [sym_const_type_declaration] = STATE(7755),
    [sym_foreign_block] = STATE(7755),
    [sym_attributes] = STATE(700),
    [sym_attribute] = STATE(6005),
    [sym_when_statement] = STATE(7755),
    [sym_var_declaration] = STATE(7755),
    [sym_expression] = STATE(5643),
    [sym__expression_no_tag] = STATE(4616),
    [sym_unary_expression] = STATE(4616),
    [sym_binary_expression] = STATE(4616),
    [sym_ternary_expression] = STATE(4616),
    [sym_call_expression] = STATE(4616),
    [sym_selector_call_expression] = STATE(4616),
    [sym_member_expression] = STATE(4616),
    [sym_index_expression] = STATE(4616),
    [sym_slice_expression] = STATE(4616),
    [sym_range_expression] = STATE(4616),
    [sym_cast_expression] = STATE(4616),
    [sym_in_expression] = STATE(4616),
    [sym_variadic_expression] = STATE(4616),
    [sym_parenthesized_expression] = STATE(4616),
    [sym_or_return_expression] = STATE(4616),
    [sym_or_continue_expression] = STATE(4616),
    [sym_or_break_expression] = STATE(4616),
    [sym_address] = STATE(4616),
    [sym_map_type] = STATE(4616),
    [sym_matrix_type] = STATE(4616),
    [sym_distinct_type] = STATE(4616),
    [sym_literal] = STATE(4616),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [aux_sym_source_file_repeat1] = STATE(209),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [ts_builtin_sym_end] = ACTIONS(1589),
    [sym_identifier] = ACTIONS(1591),
    [anon_sym_LBRACE] = ACTIONS(1594),
    [anon_sym_package] = ACTIONS(1597),
    [anon_sym_foreign] = ACTIONS(1600),
    [anon_sym_import] = ACTIONS(1603),
    [anon_sym_using] = ACTIONS(1606),
    [anon_sym_AT] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1612),
    [anon_sym_when] = ACTIONS(1615),
    [anon_sym_QMARK] = ACTIONS(1618),
    [anon_sym_PLUS] = ACTIONS(1621),
    [anon_sym_DASH] = ACTIONS(1624),
    [anon_sym_TILDE] = ACTIONS(1621),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_DOT] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1630),
    [anon_sym_cast] = ACTIONS(1633),
    [anon_sym_transmute] = ACTIONS(1633),
    [anon_sym_auto_cast] = ACTIONS(1636),
    [anon_sym_DOT_DOT] = ACTIONS(1639),
    [anon_sym_map] = ACTIONS(1642),
    [anon_sym_bit_set] = ACTIONS(1645),
    [anon_sym_matrix] = ACTIONS(1648),
    [anon_sym_distinct] = ACTIONS(1651),
    [sym_number] = ACTIONS(1654),
    [anon_sym_DQUOTE] = ACTIONS(1657),
    [anon_sym_BQUOTE] = ACTIONS(1660),
    [anon_sym_SQUOTE] = ACTIONS(1663),
    [anon_sym_true] = ACTIONS(1666),
    [anon_sym_false] = ACTIONS(1666),
    [anon_sym_nil] = ACTIONS(1669),
    [sym_uninitialized] = ACTIONS(1654),
    [sym_tag] = ACTIONS(1672),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1654),
    [sym_block_comment] = ACTIONS(3),
  },
  [210] = {
    [sym_procedure] = STATE(2978),
    [sym_type] = STATE(2981),
    [sym_pointer_type] = STATE(2982),
    [sym_variadic_type] = STATE(2982),
    [sym_array_type] = STATE(2982),
    [sym_map_type] = STATE(2982),
    [sym_union_type] = STATE(2982),
    [sym_bit_set_type] = STATE(2982),
    [sym_matrix_type] = STATE(2982),
    [sym_field_type] = STATE(2982),
    [sym_tuple_type] = STATE(2982),
    [sym_struct_type] = STATE(2982),
    [sym_enum_type] = STATE(2982),
    [sym_bit_field_type] = STATE(2982),
    [sym_constant_type] = STATE(2982),
    [sym_specialized_type] = STATE(2982),
    [sym__procedure_type] = STATE(2982),
    [sym_distinct_type] = STATE(2982),
    [sym_empty_type] = STATE(2982),
    [sym_polymorphic_type] = STATE(2982),
    [sym_conditional_type] = STATE(2982),
    [sym_identifier] = ACTIONS(1675),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(875),
    [anon_sym_proc] = ACTIONS(1677),
    [anon_sym_DASH_GT] = ACTIONS(875),
    [anon_sym_where] = ACTIONS(877),
    [anon_sym_struct] = ACTIONS(1679),
    [anon_sym_enum] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_union] = ACTIONS(1683),
    [anon_sym_bit_field] = ACTIONS(1685),
    [anon_sym_COLON] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_COLON_EQ] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1687),
    [anon_sym_RPAREN] = ACTIONS(875),
    [anon_sym_DOLLAR] = ACTIONS(1690),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_do] = ACTIONS(877),
    [anon_sym_else] = ACTIONS(877),
    [anon_sym_when] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(1692),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_or_else] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_TILDE_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(1694),
    [anon_sym_RBRACK] = ACTIONS(875),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(875),
    [anon_sym_DOT_DOT_LT] = ACTIONS(875),
    [anon_sym_not_in] = ACTIONS(877),
    [anon_sym_DOT_DOT] = ACTIONS(1697),
    [anon_sym_or_return] = ACTIONS(877),
    [anon_sym_or_continue] = ACTIONS(877),
    [anon_sym_or_break] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1702),
    [anon_sym_map] = ACTIONS(1704),
    [anon_sym_bit_set] = ACTIONS(1706),
    [anon_sym_matrix] = ACTIONS(1708),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_uninitialized] = ACTIONS(875),
    [sym_tag] = ACTIONS(1710),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [211] = {
    [sym_procedure] = STATE(3362),
    [sym_type] = STATE(3299),
    [sym_pointer_type] = STATE(3369),
    [sym_variadic_type] = STATE(3369),
    [sym_array_type] = STATE(3369),
    [sym_map_type] = STATE(3369),
    [sym_union_type] = STATE(3369),
    [sym_bit_set_type] = STATE(3369),
    [sym_matrix_type] = STATE(3369),
    [sym_field_type] = STATE(3369),
    [sym_tuple_type] = STATE(3369),
    [sym_struct_type] = STATE(3369),
    [sym_enum_type] = STATE(3369),
    [sym_bit_field_type] = STATE(3369),
    [sym_constant_type] = STATE(3369),
    [sym_specialized_type] = STATE(3369),
    [sym__procedure_type] = STATE(3369),
    [sym_distinct_type] = STATE(3369),
    [sym_empty_type] = STATE(3369),
    [sym_polymorphic_type] = STATE(3369),
    [sym_conditional_type] = STATE(3369),
    [ts_builtin_sym_end] = ACTIONS(767),
    [sym_identifier] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_COLON_COLON] = ACTIONS(767),
    [anon_sym_proc] = ACTIONS(1715),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_where] = ACTIONS(773),
    [anon_sym_struct] = ACTIONS(1717),
    [anon_sym_enum] = ACTIONS(1719),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_union] = ACTIONS(1721),
    [anon_sym_bit_field] = ACTIONS(1723),
    [anon_sym_COLON] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_COLON_EQ] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(1725),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_else] = ACTIONS(773),
    [anon_sym_when] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(773),
    [anon_sym_case] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(1730),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(767),
    [anon_sym_or_else] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(767),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(1732),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(1735),
    [anon_sym_or_return] = ACTIONS(773),
    [anon_sym_or_continue] = ACTIONS(773),
    [anon_sym_or_break] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(1737),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1740),
    [anon_sym_map] = ACTIONS(1742),
    [anon_sym_bit_set] = ACTIONS(1744),
    [anon_sym_matrix] = ACTIONS(1746),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_uninitialized] = ACTIONS(767),
    [sym_tag] = ACTIONS(1748),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(767),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [212] = {
    [sym_procedure] = STATE(2978),
    [sym_type] = STATE(3145),
    [sym_pointer_type] = STATE(2982),
    [sym_variadic_type] = STATE(2982),
    [sym_array_type] = STATE(2982),
    [sym_map_type] = STATE(2982),
    [sym_union_type] = STATE(2982),
    [sym_bit_set_type] = STATE(2982),
    [sym_matrix_type] = STATE(2982),
    [sym_field_type] = STATE(2982),
    [sym_tuple_type] = STATE(2982),
    [sym_struct_type] = STATE(2982),
    [sym_enum_type] = STATE(2982),
    [sym_bit_field_type] = STATE(2982),
    [sym_constant_type] = STATE(2982),
    [sym_specialized_type] = STATE(2982),
    [sym__procedure_type] = STATE(2982),
    [sym_distinct_type] = STATE(2982),
    [sym_empty_type] = STATE(2982),
    [sym_polymorphic_type] = STATE(2982),
    [sym_conditional_type] = STATE(2982),
    [sym_identifier] = ACTIONS(1675),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_COLON_COLON] = ACTIONS(767),
    [anon_sym_proc] = ACTIONS(1677),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_where] = ACTIONS(773),
    [anon_sym_struct] = ACTIONS(1679),
    [anon_sym_enum] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_union] = ACTIONS(1683),
    [anon_sym_bit_field] = ACTIONS(1685),
    [anon_sym_COLON] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_COLON_EQ] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_RPAREN] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(1690),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_do] = ACTIONS(773),
    [anon_sym_else] = ACTIONS(773),
    [anon_sym_when] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(1692),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(767),
    [anon_sym_or_else] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(767),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(1754),
    [anon_sym_RBRACK] = ACTIONS(767),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(1697),
    [anon_sym_or_return] = ACTIONS(773),
    [anon_sym_or_continue] = ACTIONS(773),
    [anon_sym_or_break] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(1757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1702),
    [anon_sym_map] = ACTIONS(1704),
    [anon_sym_bit_set] = ACTIONS(1706),
    [anon_sym_matrix] = ACTIONS(1708),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_uninitialized] = ACTIONS(767),
    [sym_tag] = ACTIONS(1760),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [213] = {
    [sym_procedure] = STATE(3362),
    [sym_type] = STATE(3208),
    [sym_pointer_type] = STATE(3369),
    [sym_variadic_type] = STATE(3369),
    [sym_array_type] = STATE(3369),
    [sym_map_type] = STATE(3369),
    [sym_union_type] = STATE(3369),
    [sym_bit_set_type] = STATE(3369),
    [sym_matrix_type] = STATE(3369),
    [sym_field_type] = STATE(3369),
    [sym_tuple_type] = STATE(3369),
    [sym_struct_type] = STATE(3369),
    [sym_enum_type] = STATE(3369),
    [sym_bit_field_type] = STATE(3369),
    [sym_constant_type] = STATE(3369),
    [sym_specialized_type] = STATE(3369),
    [sym__procedure_type] = STATE(3369),
    [sym_distinct_type] = STATE(3369),
    [sym_empty_type] = STATE(3369),
    [sym_polymorphic_type] = STATE(3369),
    [sym_conditional_type] = STATE(3369),
    [ts_builtin_sym_end] = ACTIONS(815),
    [sym_identifier] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_COLON_COLON] = ACTIONS(815),
    [anon_sym_proc] = ACTIONS(1715),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_where] = ACTIONS(818),
    [anon_sym_struct] = ACTIONS(1717),
    [anon_sym_enum] = ACTIONS(1719),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_union] = ACTIONS(1721),
    [anon_sym_bit_field] = ACTIONS(1723),
    [anon_sym_COLON] = ACTIONS(818),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_COLON_EQ] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(1763),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_else] = ACTIONS(818),
    [anon_sym_when] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(818),
    [anon_sym_case] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(1730),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_or_else] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(1767),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(818),
    [anon_sym_DOT_DOT] = ACTIONS(1735),
    [anon_sym_or_return] = ACTIONS(818),
    [anon_sym_or_continue] = ACTIONS(818),
    [anon_sym_or_break] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(1771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1740),
    [anon_sym_map] = ACTIONS(1742),
    [anon_sym_bit_set] = ACTIONS(1744),
    [anon_sym_matrix] = ACTIONS(1746),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_uninitialized] = ACTIONS(815),
    [sym_tag] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [214] = {
    [sym_procedure] = STATE(3362),
    [sym_type] = STATE(3188),
    [sym_pointer_type] = STATE(3369),
    [sym_variadic_type] = STATE(3369),
    [sym_array_type] = STATE(3369),
    [sym_map_type] = STATE(3369),
    [sym_union_type] = STATE(3369),
    [sym_bit_set_type] = STATE(3369),
    [sym_matrix_type] = STATE(3369),
    [sym_field_type] = STATE(3369),
    [sym_tuple_type] = STATE(3369),
    [sym_struct_type] = STATE(3369),
    [sym_enum_type] = STATE(3369),
    [sym_bit_field_type] = STATE(3369),
    [sym_constant_type] = STATE(3369),
    [sym_specialized_type] = STATE(3369),
    [sym__procedure_type] = STATE(3369),
    [sym_distinct_type] = STATE(3369),
    [sym_empty_type] = STATE(3369),
    [sym_polymorphic_type] = STATE(3369),
    [sym_conditional_type] = STATE(3369),
    [ts_builtin_sym_end] = ACTIONS(837),
    [sym_identifier] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_COLON_COLON] = ACTIONS(837),
    [anon_sym_proc] = ACTIONS(1715),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_where] = ACTIONS(840),
    [anon_sym_struct] = ACTIONS(1717),
    [anon_sym_enum] = ACTIONS(1719),
    [anon_sym_EQ] = ACTIONS(840),
    [anon_sym_union] = ACTIONS(1721),
    [anon_sym_bit_field] = ACTIONS(1723),
    [anon_sym_COLON] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COLON_EQ] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_when] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_case] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(1730),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_or_else] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_TILDE_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_STAR] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_DOT_DOT_LT] = ACTIONS(837),
    [anon_sym_not_in] = ACTIONS(840),
    [anon_sym_DOT_DOT] = ACTIONS(1735),
    [anon_sym_or_return] = ACTIONS(840),
    [anon_sym_or_continue] = ACTIONS(840),
    [anon_sym_or_break] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(1787),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1740),
    [anon_sym_map] = ACTIONS(1742),
    [anon_sym_bit_set] = ACTIONS(1744),
    [anon_sym_matrix] = ACTIONS(1746),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_uninitialized] = ACTIONS(837),
    [sym_tag] = ACTIONS(1791),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(837),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [215] = {
    [sym_procedure] = STATE(3362),
    [sym_type] = STATE(3343),
    [sym_pointer_type] = STATE(3369),
    [sym_variadic_type] = STATE(3369),
    [sym_array_type] = STATE(3369),
    [sym_map_type] = STATE(3369),
    [sym_union_type] = STATE(3369),
    [sym_bit_set_type] = STATE(3369),
    [sym_matrix_type] = STATE(3369),
    [sym_field_type] = STATE(3369),
    [sym_tuple_type] = STATE(3369),
    [sym_struct_type] = STATE(3369),
    [sym_enum_type] = STATE(3369),
    [sym_bit_field_type] = STATE(3369),
    [sym_constant_type] = STATE(3369),
    [sym_specialized_type] = STATE(3369),
    [sym__procedure_type] = STATE(3369),
    [sym_distinct_type] = STATE(3369),
    [sym_empty_type] = STATE(3369),
    [sym_polymorphic_type] = STATE(3369),
    [sym_conditional_type] = STATE(3369),
    [ts_builtin_sym_end] = ACTIONS(891),
    [sym_identifier] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [anon_sym_proc] = ACTIONS(1715),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(894),
    [anon_sym_struct] = ACTIONS(1717),
    [anon_sym_enum] = ACTIONS(1719),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_union] = ACTIONS(1721),
    [anon_sym_bit_field] = ACTIONS(1723),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COLON_EQ] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_when] = ACTIONS(894),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_case] = ACTIONS(894),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(1730),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_or_else] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_GT_GT] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(1735),
    [anon_sym_or_return] = ACTIONS(894),
    [anon_sym_or_continue] = ACTIONS(894),
    [anon_sym_or_break] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(1803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1740),
    [anon_sym_map] = ACTIONS(1742),
    [anon_sym_bit_set] = ACTIONS(1744),
    [anon_sym_matrix] = ACTIONS(1746),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_uninitialized] = ACTIONS(891),
    [sym_tag] = ACTIONS(1807),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(891),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [216] = {
    [sym_procedure] = STATE(2978),
    [sym_type] = STATE(3020),
    [sym_pointer_type] = STATE(2982),
    [sym_variadic_type] = STATE(2982),
    [sym_array_type] = STATE(2982),
    [sym_map_type] = STATE(2982),
    [sym_union_type] = STATE(2982),
    [sym_bit_set_type] = STATE(2982),
    [sym_matrix_type] = STATE(2982),
    [sym_field_type] = STATE(2982),
    [sym_tuple_type] = STATE(2982),
    [sym_struct_type] = STATE(2982),
    [sym_enum_type] = STATE(2982),
    [sym_bit_field_type] = STATE(2982),
    [sym_constant_type] = STATE(2982),
    [sym_specialized_type] = STATE(2982),
    [sym__procedure_type] = STATE(2982),
    [sym_distinct_type] = STATE(2982),
    [sym_empty_type] = STATE(2982),
    [sym_polymorphic_type] = STATE(2982),
    [sym_conditional_type] = STATE(2982),
    [sym_identifier] = ACTIONS(1675),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_COLON_COLON] = ACTIONS(815),
    [anon_sym_proc] = ACTIONS(1677),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_where] = ACTIONS(818),
    [anon_sym_struct] = ACTIONS(1679),
    [anon_sym_enum] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_union] = ACTIONS(1683),
    [anon_sym_bit_field] = ACTIONS(1685),
    [anon_sym_COLON] = ACTIONS(818),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_COLON_EQ] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(1811),
    [anon_sym_RPAREN] = ACTIONS(815),
    [anon_sym_DOLLAR] = ACTIONS(1690),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_do] = ACTIONS(818),
    [anon_sym_else] = ACTIONS(818),
    [anon_sym_when] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(1692),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_or_else] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(1815),
    [anon_sym_RBRACK] = ACTIONS(815),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(818),
    [anon_sym_DOT_DOT] = ACTIONS(1697),
    [anon_sym_or_return] = ACTIONS(818),
    [anon_sym_or_continue] = ACTIONS(818),
    [anon_sym_or_break] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(1819),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1702),
    [anon_sym_map] = ACTIONS(1704),
    [anon_sym_bit_set] = ACTIONS(1706),
    [anon_sym_matrix] = ACTIONS(1708),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_uninitialized] = ACTIONS(815),
    [sym_tag] = ACTIONS(1823),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [217] = {
    [sym_procedure] = STATE(2978),
    [sym_type] = STATE(3134),
    [sym_pointer_type] = STATE(2982),
    [sym_variadic_type] = STATE(2982),
    [sym_array_type] = STATE(2982),
    [sym_map_type] = STATE(2982),
    [sym_union_type] = STATE(2982),
    [sym_bit_set_type] = STATE(2982),
    [sym_matrix_type] = STATE(2982),
    [sym_field_type] = STATE(2982),
    [sym_tuple_type] = STATE(2982),
    [sym_struct_type] = STATE(2982),
    [sym_enum_type] = STATE(2982),
    [sym_bit_field_type] = STATE(2982),
    [sym_constant_type] = STATE(2982),
    [sym_specialized_type] = STATE(2982),
    [sym__procedure_type] = STATE(2982),
    [sym_distinct_type] = STATE(2982),
    [sym_empty_type] = STATE(2982),
    [sym_polymorphic_type] = STATE(2982),
    [sym_conditional_type] = STATE(2982),
    [sym_identifier] = ACTIONS(1675),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [anon_sym_proc] = ACTIONS(1677),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(894),
    [anon_sym_struct] = ACTIONS(1679),
    [anon_sym_enum] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_union] = ACTIONS(1683),
    [anon_sym_bit_field] = ACTIONS(1685),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COLON_EQ] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_DOLLAR] = ACTIONS(1690),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_do] = ACTIONS(894),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_when] = ACTIONS(894),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(1692),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_or_else] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_GT_GT] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(1831),
    [anon_sym_RBRACK] = ACTIONS(891),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(1697),
    [anon_sym_or_return] = ACTIONS(894),
    [anon_sym_or_continue] = ACTIONS(894),
    [anon_sym_or_break] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1702),
    [anon_sym_map] = ACTIONS(1704),
    [anon_sym_bit_set] = ACTIONS(1706),
    [anon_sym_matrix] = ACTIONS(1708),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_uninitialized] = ACTIONS(891),
    [sym_tag] = ACTIONS(1839),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [218] = {
    [sym_procedure] = STATE(2978),
    [sym_type] = STATE(3030),
    [sym_pointer_type] = STATE(2982),
    [sym_variadic_type] = STATE(2982),
    [sym_array_type] = STATE(2982),
    [sym_map_type] = STATE(2982),
    [sym_union_type] = STATE(2982),
    [sym_bit_set_type] = STATE(2982),
    [sym_matrix_type] = STATE(2982),
    [sym_field_type] = STATE(2982),
    [sym_tuple_type] = STATE(2982),
    [sym_struct_type] = STATE(2982),
    [sym_enum_type] = STATE(2982),
    [sym_bit_field_type] = STATE(2982),
    [sym_constant_type] = STATE(2982),
    [sym_specialized_type] = STATE(2982),
    [sym__procedure_type] = STATE(2982),
    [sym_distinct_type] = STATE(2982),
    [sym_empty_type] = STATE(2982),
    [sym_polymorphic_type] = STATE(2982),
    [sym_conditional_type] = STATE(2982),
    [sym_identifier] = ACTIONS(1675),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_COLON_COLON] = ACTIONS(913),
    [anon_sym_proc] = ACTIONS(1677),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_where] = ACTIONS(915),
    [anon_sym_struct] = ACTIONS(1679),
    [anon_sym_enum] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_union] = ACTIONS(1683),
    [anon_sym_bit_field] = ACTIONS(1685),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_COLON_EQ] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(1843),
    [anon_sym_RPAREN] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(1690),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_do] = ACTIONS(915),
    [anon_sym_else] = ACTIONS(915),
    [anon_sym_when] = ACTIONS(915),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(1692),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(913),
    [anon_sym_or_else] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(1846),
    [anon_sym_RBRACK] = ACTIONS(913),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(1697),
    [anon_sym_or_return] = ACTIONS(915),
    [anon_sym_or_continue] = ACTIONS(915),
    [anon_sym_or_break] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(1849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1702),
    [anon_sym_map] = ACTIONS(1704),
    [anon_sym_bit_set] = ACTIONS(1706),
    [anon_sym_matrix] = ACTIONS(1708),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_uninitialized] = ACTIONS(913),
    [sym_tag] = ACTIONS(1852),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [219] = {
    [sym_procedure] = STATE(2978),
    [sym_type] = STATE(2999),
    [sym_pointer_type] = STATE(2982),
    [sym_variadic_type] = STATE(2982),
    [sym_array_type] = STATE(2982),
    [sym_map_type] = STATE(2982),
    [sym_union_type] = STATE(2982),
    [sym_bit_set_type] = STATE(2982),
    [sym_matrix_type] = STATE(2982),
    [sym_field_type] = STATE(2982),
    [sym_tuple_type] = STATE(2982),
    [sym_struct_type] = STATE(2982),
    [sym_enum_type] = STATE(2982),
    [sym_bit_field_type] = STATE(2982),
    [sym_constant_type] = STATE(2982),
    [sym_specialized_type] = STATE(2982),
    [sym__procedure_type] = STATE(2982),
    [sym_distinct_type] = STATE(2982),
    [sym_empty_type] = STATE(2982),
    [sym_polymorphic_type] = STATE(2982),
    [sym_conditional_type] = STATE(2982),
    [sym_identifier] = ACTIONS(1675),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_COLON_COLON] = ACTIONS(837),
    [anon_sym_proc] = ACTIONS(1677),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_where] = ACTIONS(840),
    [anon_sym_struct] = ACTIONS(1679),
    [anon_sym_enum] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(840),
    [anon_sym_union] = ACTIONS(1683),
    [anon_sym_bit_field] = ACTIONS(1685),
    [anon_sym_COLON] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COLON_EQ] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(1855),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOLLAR] = ACTIONS(1690),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(840),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_when] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(1692),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_or_else] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_TILDE_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_STAR] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_RBRACK] = ACTIONS(837),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_DOT_DOT_LT] = ACTIONS(837),
    [anon_sym_not_in] = ACTIONS(840),
    [anon_sym_DOT_DOT] = ACTIONS(1697),
    [anon_sym_or_return] = ACTIONS(840),
    [anon_sym_or_continue] = ACTIONS(840),
    [anon_sym_or_break] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(1863),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1702),
    [anon_sym_map] = ACTIONS(1704),
    [anon_sym_bit_set] = ACTIONS(1706),
    [anon_sym_matrix] = ACTIONS(1708),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_uninitialized] = ACTIONS(837),
    [sym_tag] = ACTIONS(1867),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [220] = {
    [sym_procedure] = STATE(3362),
    [sym_type] = STATE(3347),
    [sym_pointer_type] = STATE(3369),
    [sym_variadic_type] = STATE(3369),
    [sym_array_type] = STATE(3369),
    [sym_map_type] = STATE(3369),
    [sym_union_type] = STATE(3369),
    [sym_bit_set_type] = STATE(3369),
    [sym_matrix_type] = STATE(3369),
    [sym_field_type] = STATE(3369),
    [sym_tuple_type] = STATE(3369),
    [sym_struct_type] = STATE(3369),
    [sym_enum_type] = STATE(3369),
    [sym_bit_field_type] = STATE(3369),
    [sym_constant_type] = STATE(3369),
    [sym_specialized_type] = STATE(3369),
    [sym__procedure_type] = STATE(3369),
    [sym_distinct_type] = STATE(3369),
    [sym_empty_type] = STATE(3369),
    [sym_polymorphic_type] = STATE(3369),
    [sym_conditional_type] = STATE(3369),
    [ts_builtin_sym_end] = ACTIONS(875),
    [sym_identifier] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(875),
    [anon_sym_proc] = ACTIONS(1715),
    [anon_sym_DASH_GT] = ACTIONS(875),
    [anon_sym_where] = ACTIONS(877),
    [anon_sym_struct] = ACTIONS(1717),
    [anon_sym_enum] = ACTIONS(1719),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_union] = ACTIONS(1721),
    [anon_sym_bit_field] = ACTIONS(1723),
    [anon_sym_COLON] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_COLON_EQ] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_else] = ACTIONS(877),
    [anon_sym_when] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_case] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(1730),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_or_else] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_TILDE_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(1874),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(875),
    [anon_sym_DOT_DOT_LT] = ACTIONS(875),
    [anon_sym_not_in] = ACTIONS(877),
    [anon_sym_DOT_DOT] = ACTIONS(1735),
    [anon_sym_or_return] = ACTIONS(877),
    [anon_sym_or_continue] = ACTIONS(877),
    [anon_sym_or_break] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(1877),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1740),
    [anon_sym_map] = ACTIONS(1742),
    [anon_sym_bit_set] = ACTIONS(1744),
    [anon_sym_matrix] = ACTIONS(1746),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_uninitialized] = ACTIONS(875),
    [sym_tag] = ACTIONS(1880),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(875),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [221] = {
    [sym_procedure] = STATE(3362),
    [sym_type] = STATE(3285),
    [sym_pointer_type] = STATE(3369),
    [sym_variadic_type] = STATE(3369),
    [sym_array_type] = STATE(3369),
    [sym_map_type] = STATE(3369),
    [sym_union_type] = STATE(3369),
    [sym_bit_set_type] = STATE(3369),
    [sym_matrix_type] = STATE(3369),
    [sym_field_type] = STATE(3369),
    [sym_tuple_type] = STATE(3369),
    [sym_struct_type] = STATE(3369),
    [sym_enum_type] = STATE(3369),
    [sym_bit_field_type] = STATE(3369),
    [sym_constant_type] = STATE(3369),
    [sym_specialized_type] = STATE(3369),
    [sym__procedure_type] = STATE(3369),
    [sym_distinct_type] = STATE(3369),
    [sym_empty_type] = STATE(3369),
    [sym_polymorphic_type] = STATE(3369),
    [sym_conditional_type] = STATE(3369),
    [ts_builtin_sym_end] = ACTIONS(859),
    [sym_identifier] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(859),
    [anon_sym_proc] = ACTIONS(1715),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_where] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(1717),
    [anon_sym_enum] = ACTIONS(1719),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_union] = ACTIONS(1721),
    [anon_sym_bit_field] = ACTIONS(1723),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(1883),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_else] = ACTIONS(861),
    [anon_sym_when] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_case] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(1730),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or_else] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1886),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(861),
    [anon_sym_DOT_DOT] = ACTIONS(1735),
    [anon_sym_or_return] = ACTIONS(861),
    [anon_sym_or_continue] = ACTIONS(861),
    [anon_sym_or_break] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(1889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1740),
    [anon_sym_map] = ACTIONS(1742),
    [anon_sym_bit_set] = ACTIONS(1744),
    [anon_sym_matrix] = ACTIONS(1746),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_uninitialized] = ACTIONS(859),
    [sym_tag] = ACTIONS(1892),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(859),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [222] = {
    [sym_procedure] = STATE(2978),
    [sym_type] = STATE(2964),
    [sym_pointer_type] = STATE(2982),
    [sym_variadic_type] = STATE(2982),
    [sym_array_type] = STATE(2982),
    [sym_map_type] = STATE(2982),
    [sym_union_type] = STATE(2982),
    [sym_bit_set_type] = STATE(2982),
    [sym_matrix_type] = STATE(2982),
    [sym_field_type] = STATE(2982),
    [sym_tuple_type] = STATE(2982),
    [sym_struct_type] = STATE(2982),
    [sym_enum_type] = STATE(2982),
    [sym_bit_field_type] = STATE(2982),
    [sym_constant_type] = STATE(2982),
    [sym_specialized_type] = STATE(2982),
    [sym__procedure_type] = STATE(2982),
    [sym_distinct_type] = STATE(2982),
    [sym_empty_type] = STATE(2982),
    [sym_polymorphic_type] = STATE(2982),
    [sym_conditional_type] = STATE(2982),
    [sym_identifier] = ACTIONS(1675),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(859),
    [anon_sym_proc] = ACTIONS(1677),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_where] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(1679),
    [anon_sym_enum] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_union] = ACTIONS(1683),
    [anon_sym_bit_field] = ACTIONS(1685),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(1895),
    [anon_sym_RPAREN] = ACTIONS(859),
    [anon_sym_DOLLAR] = ACTIONS(1690),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(861),
    [anon_sym_else] = ACTIONS(861),
    [anon_sym_when] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(1692),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or_else] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(1898),
    [anon_sym_RBRACK] = ACTIONS(859),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(861),
    [anon_sym_DOT_DOT] = ACTIONS(1697),
    [anon_sym_or_return] = ACTIONS(861),
    [anon_sym_or_continue] = ACTIONS(861),
    [anon_sym_or_break] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(1901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1702),
    [anon_sym_map] = ACTIONS(1704),
    [anon_sym_bit_set] = ACTIONS(1706),
    [anon_sym_matrix] = ACTIONS(1708),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_uninitialized] = ACTIONS(859),
    [sym_tag] = ACTIONS(1904),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [223] = {
    [sym_procedure] = STATE(3362),
    [sym_type] = STATE(3220),
    [sym_pointer_type] = STATE(3369),
    [sym_variadic_type] = STATE(3369),
    [sym_array_type] = STATE(3369),
    [sym_map_type] = STATE(3369),
    [sym_union_type] = STATE(3369),
    [sym_bit_set_type] = STATE(3369),
    [sym_matrix_type] = STATE(3369),
    [sym_field_type] = STATE(3369),
    [sym_tuple_type] = STATE(3369),
    [sym_struct_type] = STATE(3369),
    [sym_enum_type] = STATE(3369),
    [sym_bit_field_type] = STATE(3369),
    [sym_constant_type] = STATE(3369),
    [sym_specialized_type] = STATE(3369),
    [sym__procedure_type] = STATE(3369),
    [sym_distinct_type] = STATE(3369),
    [sym_empty_type] = STATE(3369),
    [sym_polymorphic_type] = STATE(3369),
    [sym_conditional_type] = STATE(3369),
    [ts_builtin_sym_end] = ACTIONS(913),
    [sym_identifier] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_COLON_COLON] = ACTIONS(913),
    [anon_sym_proc] = ACTIONS(1715),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_where] = ACTIONS(915),
    [anon_sym_struct] = ACTIONS(1717),
    [anon_sym_enum] = ACTIONS(1719),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_union] = ACTIONS(1721),
    [anon_sym_bit_field] = ACTIONS(1723),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_COLON_EQ] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(1907),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_else] = ACTIONS(915),
    [anon_sym_when] = ACTIONS(915),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_case] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(1730),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(913),
    [anon_sym_or_else] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(1910),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(1735),
    [anon_sym_or_return] = ACTIONS(915),
    [anon_sym_or_continue] = ACTIONS(915),
    [anon_sym_or_break] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(1913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1740),
    [anon_sym_map] = ACTIONS(1742),
    [anon_sym_bit_set] = ACTIONS(1744),
    [anon_sym_matrix] = ACTIONS(1746),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_uninitialized] = ACTIONS(913),
    [sym_tag] = ACTIONS(1916),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(913),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [224] = {
    [sym_procedure] = STATE(3475),
    [sym_type] = STATE(3574),
    [sym_pointer_type] = STATE(3599),
    [sym_variadic_type] = STATE(3599),
    [sym_array_type] = STATE(3599),
    [sym_map_type] = STATE(3599),
    [sym_union_type] = STATE(3599),
    [sym_bit_set_type] = STATE(3599),
    [sym_matrix_type] = STATE(3599),
    [sym_field_type] = STATE(3599),
    [sym_tuple_type] = STATE(3599),
    [sym_struct_type] = STATE(3599),
    [sym_enum_type] = STATE(3599),
    [sym_bit_field_type] = STATE(3599),
    [sym_constant_type] = STATE(3599),
    [sym_specialized_type] = STATE(3599),
    [sym__procedure_type] = STATE(3599),
    [sym_distinct_type] = STATE(3599),
    [sym_empty_type] = STATE(3599),
    [sym_polymorphic_type] = STATE(3599),
    [sym_conditional_type] = STATE(3599),
    [ts_builtin_sym_end] = ACTIONS(837),
    [sym_identifier] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_proc] = ACTIONS(1921),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_where] = ACTIONS(840),
    [anon_sym_struct] = ACTIONS(1923),
    [anon_sym_enum] = ACTIONS(1925),
    [anon_sym_EQ] = ACTIONS(840),
    [anon_sym_union] = ACTIONS(1927),
    [anon_sym_bit_field] = ACTIONS(1929),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_LPAREN] = ACTIONS(1931),
    [anon_sym_DOLLAR] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_when] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_case] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_or_else] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_TILDE_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_STAR] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(1939),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_DOT_DOT_LT] = ACTIONS(837),
    [anon_sym_not_in] = ACTIONS(840),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_or_return] = ACTIONS(840),
    [anon_sym_or_continue] = ACTIONS(840),
    [anon_sym_or_break] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(1945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1949),
    [anon_sym_map] = ACTIONS(1951),
    [anon_sym_bit_set] = ACTIONS(1953),
    [anon_sym_matrix] = ACTIONS(1955),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_uninitialized] = ACTIONS(837),
    [sym_tag] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(837),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(837),
    [sym_block_comment] = ACTIONS(3),
  },
  [225] = {
    [sym_procedure] = STATE(3475),
    [sym_type] = STATE(3590),
    [sym_pointer_type] = STATE(3599),
    [sym_variadic_type] = STATE(3599),
    [sym_array_type] = STATE(3599),
    [sym_map_type] = STATE(3599),
    [sym_union_type] = STATE(3599),
    [sym_bit_set_type] = STATE(3599),
    [sym_matrix_type] = STATE(3599),
    [sym_field_type] = STATE(3599),
    [sym_tuple_type] = STATE(3599),
    [sym_struct_type] = STATE(3599),
    [sym_enum_type] = STATE(3599),
    [sym_bit_field_type] = STATE(3599),
    [sym_constant_type] = STATE(3599),
    [sym_specialized_type] = STATE(3599),
    [sym__procedure_type] = STATE(3599),
    [sym_distinct_type] = STATE(3599),
    [sym_empty_type] = STATE(3599),
    [sym_polymorphic_type] = STATE(3599),
    [sym_conditional_type] = STATE(3599),
    [ts_builtin_sym_end] = ACTIONS(875),
    [sym_identifier] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_proc] = ACTIONS(1921),
    [anon_sym_DASH_GT] = ACTIONS(875),
    [anon_sym_where] = ACTIONS(877),
    [anon_sym_struct] = ACTIONS(1923),
    [anon_sym_enum] = ACTIONS(1925),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_union] = ACTIONS(1927),
    [anon_sym_bit_field] = ACTIONS(1929),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_DOLLAR] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_else] = ACTIONS(877),
    [anon_sym_when] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_case] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_or_else] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_TILDE_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(1964),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(875),
    [anon_sym_DOT_DOT_LT] = ACTIONS(875),
    [anon_sym_not_in] = ACTIONS(877),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_or_return] = ACTIONS(877),
    [anon_sym_or_continue] = ACTIONS(877),
    [anon_sym_or_break] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(1967),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1949),
    [anon_sym_map] = ACTIONS(1951),
    [anon_sym_bit_set] = ACTIONS(1953),
    [anon_sym_matrix] = ACTIONS(1955),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_uninitialized] = ACTIONS(875),
    [sym_tag] = ACTIONS(1970),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(875),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(875),
    [sym_block_comment] = ACTIONS(3),
  },
  [226] = {
    [sym_procedure] = STATE(3690),
    [sym_type] = STATE(3649),
    [sym_pointer_type] = STATE(3686),
    [sym_variadic_type] = STATE(3686),
    [sym_array_type] = STATE(3686),
    [sym_map_type] = STATE(3686),
    [sym_union_type] = STATE(3686),
    [sym_bit_set_type] = STATE(3686),
    [sym_matrix_type] = STATE(3686),
    [sym_field_type] = STATE(3686),
    [sym_tuple_type] = STATE(3686),
    [sym_struct_type] = STATE(3686),
    [sym_enum_type] = STATE(3686),
    [sym_bit_field_type] = STATE(3686),
    [sym_constant_type] = STATE(3686),
    [sym_specialized_type] = STATE(3686),
    [sym__procedure_type] = STATE(3686),
    [sym_distinct_type] = STATE(3686),
    [sym_empty_type] = STATE(3686),
    [sym_polymorphic_type] = STATE(3686),
    [sym_conditional_type] = STATE(3686),
    [sym_identifier] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_COLON_COLON] = ACTIONS(815),
    [anon_sym_proc] = ACTIONS(1975),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(1977),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_union] = ACTIONS(1981),
    [anon_sym_bit_field] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(818),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_COLON_EQ] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(1985),
    [anon_sym_RPAREN] = ACTIONS(815),
    [anon_sym_DOLLAR] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_do] = ACTIONS(818),
    [anon_sym_else] = ACTIONS(818),
    [anon_sym_when] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_or_else] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(1993),
    [anon_sym_RBRACK] = ACTIONS(815),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(818),
    [anon_sym_DOT_DOT] = ACTIONS(1997),
    [anon_sym_or_return] = ACTIONS(818),
    [anon_sym_or_continue] = ACTIONS(818),
    [anon_sym_or_break] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(1999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2003),
    [anon_sym_map] = ACTIONS(2005),
    [anon_sym_bit_set] = ACTIONS(2007),
    [anon_sym_matrix] = ACTIONS(2009),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_tag] = ACTIONS(2011),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [227] = {
    [sym_procedure] = STATE(3690),
    [sym_type] = STATE(3692),
    [sym_pointer_type] = STATE(3686),
    [sym_variadic_type] = STATE(3686),
    [sym_array_type] = STATE(3686),
    [sym_map_type] = STATE(3686),
    [sym_union_type] = STATE(3686),
    [sym_bit_set_type] = STATE(3686),
    [sym_matrix_type] = STATE(3686),
    [sym_field_type] = STATE(3686),
    [sym_tuple_type] = STATE(3686),
    [sym_struct_type] = STATE(3686),
    [sym_enum_type] = STATE(3686),
    [sym_bit_field_type] = STATE(3686),
    [sym_constant_type] = STATE(3686),
    [sym_specialized_type] = STATE(3686),
    [sym__procedure_type] = STATE(3686),
    [sym_distinct_type] = STATE(3686),
    [sym_empty_type] = STATE(3686),
    [sym_polymorphic_type] = STATE(3686),
    [sym_conditional_type] = STATE(3686),
    [sym_identifier] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [anon_sym_proc] = ACTIONS(1975),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_struct] = ACTIONS(1977),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_union] = ACTIONS(1981),
    [anon_sym_bit_field] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COLON_EQ] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_DOLLAR] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_do] = ACTIONS(894),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_when] = ACTIONS(894),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_or_else] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_GT_GT] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(891),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(1997),
    [anon_sym_or_return] = ACTIONS(894),
    [anon_sym_or_continue] = ACTIONS(894),
    [anon_sym_or_break] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(2021),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2003),
    [anon_sym_map] = ACTIONS(2005),
    [anon_sym_bit_set] = ACTIONS(2007),
    [anon_sym_matrix] = ACTIONS(2009),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_tag] = ACTIONS(2011),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [228] = {
    [sym_procedure] = STATE(3690),
    [sym_type] = STATE(3659),
    [sym_pointer_type] = STATE(3686),
    [sym_variadic_type] = STATE(3686),
    [sym_array_type] = STATE(3686),
    [sym_map_type] = STATE(3686),
    [sym_union_type] = STATE(3686),
    [sym_bit_set_type] = STATE(3686),
    [sym_matrix_type] = STATE(3686),
    [sym_field_type] = STATE(3686),
    [sym_tuple_type] = STATE(3686),
    [sym_struct_type] = STATE(3686),
    [sym_enum_type] = STATE(3686),
    [sym_bit_field_type] = STATE(3686),
    [sym_constant_type] = STATE(3686),
    [sym_specialized_type] = STATE(3686),
    [sym__procedure_type] = STATE(3686),
    [sym_distinct_type] = STATE(3686),
    [sym_empty_type] = STATE(3686),
    [sym_polymorphic_type] = STATE(3686),
    [sym_conditional_type] = STATE(3686),
    [sym_identifier] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_COLON_COLON] = ACTIONS(767),
    [anon_sym_proc] = ACTIONS(1975),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_struct] = ACTIONS(1977),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_union] = ACTIONS(1981),
    [anon_sym_bit_field] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_COLON_EQ] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(2025),
    [anon_sym_RPAREN] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_do] = ACTIONS(773),
    [anon_sym_else] = ACTIONS(773),
    [anon_sym_when] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(767),
    [anon_sym_or_else] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(767),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(2028),
    [anon_sym_RBRACK] = ACTIONS(767),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(1997),
    [anon_sym_or_return] = ACTIONS(773),
    [anon_sym_or_continue] = ACTIONS(773),
    [anon_sym_or_break] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2031),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2003),
    [anon_sym_map] = ACTIONS(2005),
    [anon_sym_bit_set] = ACTIONS(2007),
    [anon_sym_matrix] = ACTIONS(2009),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_tag] = ACTIONS(2011),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [229] = {
    [sym_procedure] = STATE(3690),
    [sym_type] = STATE(3645),
    [sym_pointer_type] = STATE(3686),
    [sym_variadic_type] = STATE(3686),
    [sym_array_type] = STATE(3686),
    [sym_map_type] = STATE(3686),
    [sym_union_type] = STATE(3686),
    [sym_bit_set_type] = STATE(3686),
    [sym_matrix_type] = STATE(3686),
    [sym_field_type] = STATE(3686),
    [sym_tuple_type] = STATE(3686),
    [sym_struct_type] = STATE(3686),
    [sym_enum_type] = STATE(3686),
    [sym_bit_field_type] = STATE(3686),
    [sym_constant_type] = STATE(3686),
    [sym_specialized_type] = STATE(3686),
    [sym__procedure_type] = STATE(3686),
    [sym_distinct_type] = STATE(3686),
    [sym_empty_type] = STATE(3686),
    [sym_polymorphic_type] = STATE(3686),
    [sym_conditional_type] = STATE(3686),
    [sym_identifier] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_COLON_COLON] = ACTIONS(837),
    [anon_sym_proc] = ACTIONS(1975),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_struct] = ACTIONS(1977),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_EQ] = ACTIONS(840),
    [anon_sym_union] = ACTIONS(1981),
    [anon_sym_bit_field] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COLON_EQ] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(2034),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOLLAR] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_do] = ACTIONS(840),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_when] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_or_else] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_TILDE_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_STAR] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(2038),
    [anon_sym_RBRACK] = ACTIONS(837),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_DOT_DOT_LT] = ACTIONS(837),
    [anon_sym_not_in] = ACTIONS(840),
    [anon_sym_DOT_DOT] = ACTIONS(1997),
    [anon_sym_or_return] = ACTIONS(840),
    [anon_sym_or_continue] = ACTIONS(840),
    [anon_sym_or_break] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(2042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2003),
    [anon_sym_map] = ACTIONS(2005),
    [anon_sym_bit_set] = ACTIONS(2007),
    [anon_sym_matrix] = ACTIONS(2009),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_tag] = ACTIONS(2011),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [230] = {
    [sym_procedure] = STATE(3475),
    [sym_type] = STATE(3524),
    [sym_pointer_type] = STATE(3599),
    [sym_variadic_type] = STATE(3599),
    [sym_array_type] = STATE(3599),
    [sym_map_type] = STATE(3599),
    [sym_union_type] = STATE(3599),
    [sym_bit_set_type] = STATE(3599),
    [sym_matrix_type] = STATE(3599),
    [sym_field_type] = STATE(3599),
    [sym_tuple_type] = STATE(3599),
    [sym_struct_type] = STATE(3599),
    [sym_enum_type] = STATE(3599),
    [sym_bit_field_type] = STATE(3599),
    [sym_constant_type] = STATE(3599),
    [sym_specialized_type] = STATE(3599),
    [sym__procedure_type] = STATE(3599),
    [sym_distinct_type] = STATE(3599),
    [sym_empty_type] = STATE(3599),
    [sym_polymorphic_type] = STATE(3599),
    [sym_conditional_type] = STATE(3599),
    [ts_builtin_sym_end] = ACTIONS(891),
    [sym_identifier] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_proc] = ACTIONS(1921),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(894),
    [anon_sym_struct] = ACTIONS(1923),
    [anon_sym_enum] = ACTIONS(1925),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_union] = ACTIONS(1927),
    [anon_sym_bit_field] = ACTIONS(1929),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_LPAREN] = ACTIONS(2046),
    [anon_sym_DOLLAR] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_when] = ACTIONS(894),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_case] = ACTIONS(894),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_or_else] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_GT_GT] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_or_return] = ACTIONS(894),
    [anon_sym_or_continue] = ACTIONS(894),
    [anon_sym_or_break] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(2054),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1949),
    [anon_sym_map] = ACTIONS(1951),
    [anon_sym_bit_set] = ACTIONS(1953),
    [anon_sym_matrix] = ACTIONS(1955),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_uninitialized] = ACTIONS(891),
    [sym_tag] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(891),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(891),
    [sym_block_comment] = ACTIONS(3),
  },
  [231] = {
    [sym_procedure] = STATE(3475),
    [sym_type] = STATE(3558),
    [sym_pointer_type] = STATE(3599),
    [sym_variadic_type] = STATE(3599),
    [sym_array_type] = STATE(3599),
    [sym_map_type] = STATE(3599),
    [sym_union_type] = STATE(3599),
    [sym_bit_set_type] = STATE(3599),
    [sym_matrix_type] = STATE(3599),
    [sym_field_type] = STATE(3599),
    [sym_tuple_type] = STATE(3599),
    [sym_struct_type] = STATE(3599),
    [sym_enum_type] = STATE(3599),
    [sym_bit_field_type] = STATE(3599),
    [sym_constant_type] = STATE(3599),
    [sym_specialized_type] = STATE(3599),
    [sym__procedure_type] = STATE(3599),
    [sym_distinct_type] = STATE(3599),
    [sym_empty_type] = STATE(3599),
    [sym_polymorphic_type] = STATE(3599),
    [sym_conditional_type] = STATE(3599),
    [ts_builtin_sym_end] = ACTIONS(815),
    [sym_identifier] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_proc] = ACTIONS(1921),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_where] = ACTIONS(818),
    [anon_sym_struct] = ACTIONS(1923),
    [anon_sym_enum] = ACTIONS(1925),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_union] = ACTIONS(1927),
    [anon_sym_bit_field] = ACTIONS(1929),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_LPAREN] = ACTIONS(2062),
    [anon_sym_DOLLAR] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_else] = ACTIONS(818),
    [anon_sym_when] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(818),
    [anon_sym_case] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_or_else] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(2066),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(818),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_or_return] = ACTIONS(818),
    [anon_sym_or_continue] = ACTIONS(818),
    [anon_sym_or_break] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(2070),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1949),
    [anon_sym_map] = ACTIONS(1951),
    [anon_sym_bit_set] = ACTIONS(1953),
    [anon_sym_matrix] = ACTIONS(1955),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_uninitialized] = ACTIONS(815),
    [sym_tag] = ACTIONS(2074),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(815),
    [sym_block_comment] = ACTIONS(3),
  },
  [232] = {
    [sym_procedure] = STATE(3690),
    [sym_type] = STATE(3644),
    [sym_pointer_type] = STATE(3686),
    [sym_variadic_type] = STATE(3686),
    [sym_array_type] = STATE(3686),
    [sym_map_type] = STATE(3686),
    [sym_union_type] = STATE(3686),
    [sym_bit_set_type] = STATE(3686),
    [sym_matrix_type] = STATE(3686),
    [sym_field_type] = STATE(3686),
    [sym_tuple_type] = STATE(3686),
    [sym_struct_type] = STATE(3686),
    [sym_enum_type] = STATE(3686),
    [sym_bit_field_type] = STATE(3686),
    [sym_constant_type] = STATE(3686),
    [sym_specialized_type] = STATE(3686),
    [sym__procedure_type] = STATE(3686),
    [sym_distinct_type] = STATE(3686),
    [sym_empty_type] = STATE(3686),
    [sym_polymorphic_type] = STATE(3686),
    [sym_conditional_type] = STATE(3686),
    [sym_identifier] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(859),
    [anon_sym_proc] = ACTIONS(1975),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(1977),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_union] = ACTIONS(1981),
    [anon_sym_bit_field] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(859),
    [anon_sym_DOLLAR] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(861),
    [anon_sym_else] = ACTIONS(861),
    [anon_sym_when] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or_else] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_RBRACK] = ACTIONS(859),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(861),
    [anon_sym_DOT_DOT] = ACTIONS(1997),
    [anon_sym_or_return] = ACTIONS(861),
    [anon_sym_or_continue] = ACTIONS(861),
    [anon_sym_or_break] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(2084),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2003),
    [anon_sym_map] = ACTIONS(2005),
    [anon_sym_bit_set] = ACTIONS(2007),
    [anon_sym_matrix] = ACTIONS(2009),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_tag] = ACTIONS(2011),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [233] = {
    [sym_procedure] = STATE(3475),
    [sym_type] = STATE(3537),
    [sym_pointer_type] = STATE(3599),
    [sym_variadic_type] = STATE(3599),
    [sym_array_type] = STATE(3599),
    [sym_map_type] = STATE(3599),
    [sym_union_type] = STATE(3599),
    [sym_bit_set_type] = STATE(3599),
    [sym_matrix_type] = STATE(3599),
    [sym_field_type] = STATE(3599),
    [sym_tuple_type] = STATE(3599),
    [sym_struct_type] = STATE(3599),
    [sym_enum_type] = STATE(3599),
    [sym_bit_field_type] = STATE(3599),
    [sym_constant_type] = STATE(3599),
    [sym_specialized_type] = STATE(3599),
    [sym__procedure_type] = STATE(3599),
    [sym_distinct_type] = STATE(3599),
    [sym_empty_type] = STATE(3599),
    [sym_polymorphic_type] = STATE(3599),
    [sym_conditional_type] = STATE(3599),
    [ts_builtin_sym_end] = ACTIONS(767),
    [sym_identifier] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_proc] = ACTIONS(1921),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_where] = ACTIONS(773),
    [anon_sym_struct] = ACTIONS(1923),
    [anon_sym_enum] = ACTIONS(1925),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_union] = ACTIONS(1927),
    [anon_sym_bit_field] = ACTIONS(1929),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2087),
    [anon_sym_DOLLAR] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_else] = ACTIONS(773),
    [anon_sym_when] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(773),
    [anon_sym_case] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(767),
    [anon_sym_or_else] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(767),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(2090),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_or_return] = ACTIONS(773),
    [anon_sym_or_continue] = ACTIONS(773),
    [anon_sym_or_break] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2093),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1949),
    [anon_sym_map] = ACTIONS(1951),
    [anon_sym_bit_set] = ACTIONS(1953),
    [anon_sym_matrix] = ACTIONS(1955),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_uninitialized] = ACTIONS(767),
    [sym_tag] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(767),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(767),
    [sym_block_comment] = ACTIONS(3),
  },
  [234] = {
    [sym_procedure] = STATE(3475),
    [sym_type] = STATE(3533),
    [sym_pointer_type] = STATE(3599),
    [sym_variadic_type] = STATE(3599),
    [sym_array_type] = STATE(3599),
    [sym_map_type] = STATE(3599),
    [sym_union_type] = STATE(3599),
    [sym_bit_set_type] = STATE(3599),
    [sym_matrix_type] = STATE(3599),
    [sym_field_type] = STATE(3599),
    [sym_tuple_type] = STATE(3599),
    [sym_struct_type] = STATE(3599),
    [sym_enum_type] = STATE(3599),
    [sym_bit_field_type] = STATE(3599),
    [sym_constant_type] = STATE(3599),
    [sym_specialized_type] = STATE(3599),
    [sym__procedure_type] = STATE(3599),
    [sym_distinct_type] = STATE(3599),
    [sym_empty_type] = STATE(3599),
    [sym_polymorphic_type] = STATE(3599),
    [sym_conditional_type] = STATE(3599),
    [ts_builtin_sym_end] = ACTIONS(859),
    [sym_identifier] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_proc] = ACTIONS(1921),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_where] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(1923),
    [anon_sym_enum] = ACTIONS(1925),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_union] = ACTIONS(1927),
    [anon_sym_bit_field] = ACTIONS(1929),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_LPAREN] = ACTIONS(2099),
    [anon_sym_DOLLAR] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_else] = ACTIONS(861),
    [anon_sym_when] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_case] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or_else] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(2102),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(861),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_or_return] = ACTIONS(861),
    [anon_sym_or_continue] = ACTIONS(861),
    [anon_sym_or_break] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(2105),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1949),
    [anon_sym_map] = ACTIONS(1951),
    [anon_sym_bit_set] = ACTIONS(1953),
    [anon_sym_matrix] = ACTIONS(1955),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_uninitialized] = ACTIONS(859),
    [sym_tag] = ACTIONS(2108),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(859),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(859),
    [sym_block_comment] = ACTIONS(3),
  },
  [235] = {
    [sym_procedure] = STATE(3690),
    [sym_type] = STATE(3660),
    [sym_pointer_type] = STATE(3686),
    [sym_variadic_type] = STATE(3686),
    [sym_array_type] = STATE(3686),
    [sym_map_type] = STATE(3686),
    [sym_union_type] = STATE(3686),
    [sym_bit_set_type] = STATE(3686),
    [sym_matrix_type] = STATE(3686),
    [sym_field_type] = STATE(3686),
    [sym_tuple_type] = STATE(3686),
    [sym_struct_type] = STATE(3686),
    [sym_enum_type] = STATE(3686),
    [sym_bit_field_type] = STATE(3686),
    [sym_constant_type] = STATE(3686),
    [sym_specialized_type] = STATE(3686),
    [sym__procedure_type] = STATE(3686),
    [sym_distinct_type] = STATE(3686),
    [sym_empty_type] = STATE(3686),
    [sym_polymorphic_type] = STATE(3686),
    [sym_conditional_type] = STATE(3686),
    [sym_identifier] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(875),
    [anon_sym_proc] = ACTIONS(1975),
    [anon_sym_DASH_GT] = ACTIONS(875),
    [anon_sym_struct] = ACTIONS(1977),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_union] = ACTIONS(1981),
    [anon_sym_bit_field] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_COLON_EQ] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_RPAREN] = ACTIONS(875),
    [anon_sym_DOLLAR] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_do] = ACTIONS(877),
    [anon_sym_else] = ACTIONS(877),
    [anon_sym_when] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_or_else] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_TILDE_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(2114),
    [anon_sym_RBRACK] = ACTIONS(875),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(875),
    [anon_sym_DOT_DOT_LT] = ACTIONS(875),
    [anon_sym_not_in] = ACTIONS(877),
    [anon_sym_DOT_DOT] = ACTIONS(1997),
    [anon_sym_or_return] = ACTIONS(877),
    [anon_sym_or_continue] = ACTIONS(877),
    [anon_sym_or_break] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(2117),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2003),
    [anon_sym_map] = ACTIONS(2005),
    [anon_sym_bit_set] = ACTIONS(2007),
    [anon_sym_matrix] = ACTIONS(2009),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_tag] = ACTIONS(2011),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [236] = {
    [sym_procedure] = STATE(3475),
    [sym_type] = STATE(3573),
    [sym_pointer_type] = STATE(3599),
    [sym_variadic_type] = STATE(3599),
    [sym_array_type] = STATE(3599),
    [sym_map_type] = STATE(3599),
    [sym_union_type] = STATE(3599),
    [sym_bit_set_type] = STATE(3599),
    [sym_matrix_type] = STATE(3599),
    [sym_field_type] = STATE(3599),
    [sym_tuple_type] = STATE(3599),
    [sym_struct_type] = STATE(3599),
    [sym_enum_type] = STATE(3599),
    [sym_bit_field_type] = STATE(3599),
    [sym_constant_type] = STATE(3599),
    [sym_specialized_type] = STATE(3599),
    [sym__procedure_type] = STATE(3599),
    [sym_distinct_type] = STATE(3599),
    [sym_empty_type] = STATE(3599),
    [sym_polymorphic_type] = STATE(3599),
    [sym_conditional_type] = STATE(3599),
    [ts_builtin_sym_end] = ACTIONS(913),
    [sym_identifier] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_proc] = ACTIONS(1921),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_where] = ACTIONS(915),
    [anon_sym_struct] = ACTIONS(1923),
    [anon_sym_enum] = ACTIONS(1925),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_union] = ACTIONS(1927),
    [anon_sym_bit_field] = ACTIONS(1929),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_LPAREN] = ACTIONS(2120),
    [anon_sym_DOLLAR] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_else] = ACTIONS(915),
    [anon_sym_when] = ACTIONS(915),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_case] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(913),
    [anon_sym_or_else] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(1943),
    [anon_sym_or_return] = ACTIONS(915),
    [anon_sym_or_continue] = ACTIONS(915),
    [anon_sym_or_break] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(2126),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1949),
    [anon_sym_map] = ACTIONS(1951),
    [anon_sym_bit_set] = ACTIONS(1953),
    [anon_sym_matrix] = ACTIONS(1955),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_uninitialized] = ACTIONS(913),
    [sym_tag] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(913),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(913),
    [sym_block_comment] = ACTIONS(3),
  },
  [237] = {
    [sym_procedure] = STATE(3690),
    [sym_type] = STATE(3637),
    [sym_pointer_type] = STATE(3686),
    [sym_variadic_type] = STATE(3686),
    [sym_array_type] = STATE(3686),
    [sym_map_type] = STATE(3686),
    [sym_union_type] = STATE(3686),
    [sym_bit_set_type] = STATE(3686),
    [sym_matrix_type] = STATE(3686),
    [sym_field_type] = STATE(3686),
    [sym_tuple_type] = STATE(3686),
    [sym_struct_type] = STATE(3686),
    [sym_enum_type] = STATE(3686),
    [sym_bit_field_type] = STATE(3686),
    [sym_constant_type] = STATE(3686),
    [sym_specialized_type] = STATE(3686),
    [sym__procedure_type] = STATE(3686),
    [sym_distinct_type] = STATE(3686),
    [sym_empty_type] = STATE(3686),
    [sym_polymorphic_type] = STATE(3686),
    [sym_conditional_type] = STATE(3686),
    [sym_identifier] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_COLON_COLON] = ACTIONS(913),
    [anon_sym_proc] = ACTIONS(1975),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_struct] = ACTIONS(1977),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_union] = ACTIONS(1981),
    [anon_sym_bit_field] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_COLON_EQ] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(2132),
    [anon_sym_RPAREN] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(1989),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_do] = ACTIONS(915),
    [anon_sym_else] = ACTIONS(915),
    [anon_sym_when] = ACTIONS(915),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(913),
    [anon_sym_or_else] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(2135),
    [anon_sym_RBRACK] = ACTIONS(913),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(1997),
    [anon_sym_or_return] = ACTIONS(915),
    [anon_sym_or_continue] = ACTIONS(915),
    [anon_sym_or_break] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(2138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2003),
    [anon_sym_map] = ACTIONS(2005),
    [anon_sym_bit_set] = ACTIONS(2007),
    [anon_sym_matrix] = ACTIONS(2009),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_tag] = ACTIONS(2011),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [238] = {
    [sym_procedure] = STATE(3765),
    [sym_type] = STATE(3859),
    [sym_pointer_type] = STATE(3753),
    [sym_variadic_type] = STATE(3753),
    [sym_array_type] = STATE(3753),
    [sym_map_type] = STATE(3753),
    [sym_union_type] = STATE(3753),
    [sym_bit_set_type] = STATE(3753),
    [sym_matrix_type] = STATE(3753),
    [sym_field_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_struct_type] = STATE(3753),
    [sym_enum_type] = STATE(3753),
    [sym_bit_field_type] = STATE(3753),
    [sym_constant_type] = STATE(3753),
    [sym_specialized_type] = STATE(3753),
    [sym__procedure_type] = STATE(3753),
    [sym_distinct_type] = STATE(3753),
    [sym_empty_type] = STATE(3753),
    [sym_polymorphic_type] = STATE(3753),
    [sym_conditional_type] = STATE(3753),
    [ts_builtin_sym_end] = ACTIONS(767),
    [sym_identifier] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_COLON_COLON] = ACTIONS(767),
    [anon_sym_proc] = ACTIONS(2143),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_struct] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2147),
    [anon_sym_union] = ACTIONS(2149),
    [anon_sym_bit_field] = ACTIONS(2151),
    [anon_sym_COLON] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_COLON_EQ] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(2153),
    [anon_sym_DOLLAR] = ACTIONS(2156),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_else] = ACTIONS(773),
    [anon_sym_when] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(773),
    [anon_sym_case] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(767),
    [anon_sym_or_else] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(767),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(2163),
    [anon_sym_or_return] = ACTIONS(773),
    [anon_sym_or_continue] = ACTIONS(773),
    [anon_sym_or_break] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2165),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2168),
    [anon_sym_map] = ACTIONS(2170),
    [anon_sym_bit_set] = ACTIONS(2172),
    [anon_sym_matrix] = ACTIONS(2174),
    [anon_sym_distinct] = ACTIONS(2176),
    [sym_tag] = ACTIONS(2178),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(767),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [239] = {
    [sym_procedure] = STATE(3765),
    [sym_type] = STATE(3861),
    [sym_pointer_type] = STATE(3753),
    [sym_variadic_type] = STATE(3753),
    [sym_array_type] = STATE(3753),
    [sym_map_type] = STATE(3753),
    [sym_union_type] = STATE(3753),
    [sym_bit_set_type] = STATE(3753),
    [sym_matrix_type] = STATE(3753),
    [sym_field_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_struct_type] = STATE(3753),
    [sym_enum_type] = STATE(3753),
    [sym_bit_field_type] = STATE(3753),
    [sym_constant_type] = STATE(3753),
    [sym_specialized_type] = STATE(3753),
    [sym__procedure_type] = STATE(3753),
    [sym_distinct_type] = STATE(3753),
    [sym_empty_type] = STATE(3753),
    [sym_polymorphic_type] = STATE(3753),
    [sym_conditional_type] = STATE(3753),
    [ts_builtin_sym_end] = ACTIONS(859),
    [sym_identifier] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(859),
    [anon_sym_proc] = ACTIONS(2143),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2147),
    [anon_sym_union] = ACTIONS(2149),
    [anon_sym_bit_field] = ACTIONS(2151),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(2180),
    [anon_sym_DOLLAR] = ACTIONS(2156),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_else] = ACTIONS(861),
    [anon_sym_when] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_case] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or_else] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(2183),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(861),
    [anon_sym_DOT_DOT] = ACTIONS(2163),
    [anon_sym_or_return] = ACTIONS(861),
    [anon_sym_or_continue] = ACTIONS(861),
    [anon_sym_or_break] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(2186),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2168),
    [anon_sym_map] = ACTIONS(2170),
    [anon_sym_bit_set] = ACTIONS(2172),
    [anon_sym_matrix] = ACTIONS(2174),
    [anon_sym_distinct] = ACTIONS(2176),
    [sym_tag] = ACTIONS(2178),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(859),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [240] = {
    [sym_procedure] = STATE(3765),
    [sym_type] = STATE(3784),
    [sym_pointer_type] = STATE(3753),
    [sym_variadic_type] = STATE(3753),
    [sym_array_type] = STATE(3753),
    [sym_map_type] = STATE(3753),
    [sym_union_type] = STATE(3753),
    [sym_bit_set_type] = STATE(3753),
    [sym_matrix_type] = STATE(3753),
    [sym_field_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_struct_type] = STATE(3753),
    [sym_enum_type] = STATE(3753),
    [sym_bit_field_type] = STATE(3753),
    [sym_constant_type] = STATE(3753),
    [sym_specialized_type] = STATE(3753),
    [sym__procedure_type] = STATE(3753),
    [sym_distinct_type] = STATE(3753),
    [sym_empty_type] = STATE(3753),
    [sym_polymorphic_type] = STATE(3753),
    [sym_conditional_type] = STATE(3753),
    [ts_builtin_sym_end] = ACTIONS(891),
    [sym_identifier] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [anon_sym_proc] = ACTIONS(2143),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_struct] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2147),
    [anon_sym_union] = ACTIONS(2149),
    [anon_sym_bit_field] = ACTIONS(2151),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COLON_EQ] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(2189),
    [anon_sym_DOLLAR] = ACTIONS(2156),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_when] = ACTIONS(894),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_case] = ACTIONS(894),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_or_else] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_GT_GT] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(2193),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(2163),
    [anon_sym_or_return] = ACTIONS(894),
    [anon_sym_or_continue] = ACTIONS(894),
    [anon_sym_or_break] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2168),
    [anon_sym_map] = ACTIONS(2170),
    [anon_sym_bit_set] = ACTIONS(2172),
    [anon_sym_matrix] = ACTIONS(2174),
    [anon_sym_distinct] = ACTIONS(2176),
    [sym_tag] = ACTIONS(2178),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(891),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [241] = {
    [sym_procedure] = STATE(3765),
    [sym_type] = STATE(3826),
    [sym_pointer_type] = STATE(3753),
    [sym_variadic_type] = STATE(3753),
    [sym_array_type] = STATE(3753),
    [sym_map_type] = STATE(3753),
    [sym_union_type] = STATE(3753),
    [sym_bit_set_type] = STATE(3753),
    [sym_matrix_type] = STATE(3753),
    [sym_field_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_struct_type] = STATE(3753),
    [sym_enum_type] = STATE(3753),
    [sym_bit_field_type] = STATE(3753),
    [sym_constant_type] = STATE(3753),
    [sym_specialized_type] = STATE(3753),
    [sym__procedure_type] = STATE(3753),
    [sym_distinct_type] = STATE(3753),
    [sym_empty_type] = STATE(3753),
    [sym_polymorphic_type] = STATE(3753),
    [sym_conditional_type] = STATE(3753),
    [ts_builtin_sym_end] = ACTIONS(875),
    [sym_identifier] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(875),
    [anon_sym_proc] = ACTIONS(2143),
    [anon_sym_DASH_GT] = ACTIONS(875),
    [anon_sym_struct] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2147),
    [anon_sym_union] = ACTIONS(2149),
    [anon_sym_bit_field] = ACTIONS(2151),
    [anon_sym_COLON] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_COLON_EQ] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(2201),
    [anon_sym_DOLLAR] = ACTIONS(2156),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_else] = ACTIONS(877),
    [anon_sym_when] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_case] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_or_else] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_TILDE_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(875),
    [anon_sym_DOT_DOT_LT] = ACTIONS(875),
    [anon_sym_not_in] = ACTIONS(877),
    [anon_sym_DOT_DOT] = ACTIONS(2163),
    [anon_sym_or_return] = ACTIONS(877),
    [anon_sym_or_continue] = ACTIONS(877),
    [anon_sym_or_break] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(2207),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2168),
    [anon_sym_map] = ACTIONS(2170),
    [anon_sym_bit_set] = ACTIONS(2172),
    [anon_sym_matrix] = ACTIONS(2174),
    [anon_sym_distinct] = ACTIONS(2176),
    [sym_tag] = ACTIONS(2178),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(875),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [242] = {
    [sym_procedure] = STATE(3765),
    [sym_type] = STATE(3917),
    [sym_pointer_type] = STATE(3753),
    [sym_variadic_type] = STATE(3753),
    [sym_array_type] = STATE(3753),
    [sym_map_type] = STATE(3753),
    [sym_union_type] = STATE(3753),
    [sym_bit_set_type] = STATE(3753),
    [sym_matrix_type] = STATE(3753),
    [sym_field_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_struct_type] = STATE(3753),
    [sym_enum_type] = STATE(3753),
    [sym_bit_field_type] = STATE(3753),
    [sym_constant_type] = STATE(3753),
    [sym_specialized_type] = STATE(3753),
    [sym__procedure_type] = STATE(3753),
    [sym_distinct_type] = STATE(3753),
    [sym_empty_type] = STATE(3753),
    [sym_polymorphic_type] = STATE(3753),
    [sym_conditional_type] = STATE(3753),
    [ts_builtin_sym_end] = ACTIONS(815),
    [sym_identifier] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_COLON_COLON] = ACTIONS(815),
    [anon_sym_proc] = ACTIONS(2143),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2147),
    [anon_sym_union] = ACTIONS(2149),
    [anon_sym_bit_field] = ACTIONS(2151),
    [anon_sym_COLON] = ACTIONS(818),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_COLON_EQ] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(2210),
    [anon_sym_DOLLAR] = ACTIONS(2156),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_else] = ACTIONS(818),
    [anon_sym_when] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(818),
    [anon_sym_case] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_or_else] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(818),
    [anon_sym_DOT_DOT] = ACTIONS(2163),
    [anon_sym_or_return] = ACTIONS(818),
    [anon_sym_or_continue] = ACTIONS(818),
    [anon_sym_or_break] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(2218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2168),
    [anon_sym_map] = ACTIONS(2170),
    [anon_sym_bit_set] = ACTIONS(2172),
    [anon_sym_matrix] = ACTIONS(2174),
    [anon_sym_distinct] = ACTIONS(2176),
    [sym_tag] = ACTIONS(2178),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [243] = {
    [sym_procedure] = STATE(3765),
    [sym_type] = STATE(3749),
    [sym_pointer_type] = STATE(3753),
    [sym_variadic_type] = STATE(3753),
    [sym_array_type] = STATE(3753),
    [sym_map_type] = STATE(3753),
    [sym_union_type] = STATE(3753),
    [sym_bit_set_type] = STATE(3753),
    [sym_matrix_type] = STATE(3753),
    [sym_field_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_struct_type] = STATE(3753),
    [sym_enum_type] = STATE(3753),
    [sym_bit_field_type] = STATE(3753),
    [sym_constant_type] = STATE(3753),
    [sym_specialized_type] = STATE(3753),
    [sym__procedure_type] = STATE(3753),
    [sym_distinct_type] = STATE(3753),
    [sym_empty_type] = STATE(3753),
    [sym_polymorphic_type] = STATE(3753),
    [sym_conditional_type] = STATE(3753),
    [ts_builtin_sym_end] = ACTIONS(913),
    [sym_identifier] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_COLON_COLON] = ACTIONS(913),
    [anon_sym_proc] = ACTIONS(2143),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_struct] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2147),
    [anon_sym_union] = ACTIONS(2149),
    [anon_sym_bit_field] = ACTIONS(2151),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_COLON_EQ] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(2222),
    [anon_sym_DOLLAR] = ACTIONS(2156),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_else] = ACTIONS(915),
    [anon_sym_when] = ACTIONS(915),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_case] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(913),
    [anon_sym_or_else] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(2225),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(2163),
    [anon_sym_or_return] = ACTIONS(915),
    [anon_sym_or_continue] = ACTIONS(915),
    [anon_sym_or_break] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(2228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2168),
    [anon_sym_map] = ACTIONS(2170),
    [anon_sym_bit_set] = ACTIONS(2172),
    [anon_sym_matrix] = ACTIONS(2174),
    [anon_sym_distinct] = ACTIONS(2176),
    [sym_tag] = ACTIONS(2178),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(913),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [244] = {
    [sym_procedure] = STATE(3765),
    [sym_type] = STATE(3915),
    [sym_pointer_type] = STATE(3753),
    [sym_variadic_type] = STATE(3753),
    [sym_array_type] = STATE(3753),
    [sym_map_type] = STATE(3753),
    [sym_union_type] = STATE(3753),
    [sym_bit_set_type] = STATE(3753),
    [sym_matrix_type] = STATE(3753),
    [sym_field_type] = STATE(3753),
    [sym_tuple_type] = STATE(3753),
    [sym_struct_type] = STATE(3753),
    [sym_enum_type] = STATE(3753),
    [sym_bit_field_type] = STATE(3753),
    [sym_constant_type] = STATE(3753),
    [sym_specialized_type] = STATE(3753),
    [sym__procedure_type] = STATE(3753),
    [sym_distinct_type] = STATE(3753),
    [sym_empty_type] = STATE(3753),
    [sym_polymorphic_type] = STATE(3753),
    [sym_conditional_type] = STATE(3753),
    [ts_builtin_sym_end] = ACTIONS(837),
    [sym_identifier] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_COLON_COLON] = ACTIONS(837),
    [anon_sym_proc] = ACTIONS(2143),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_struct] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2147),
    [anon_sym_union] = ACTIONS(2149),
    [anon_sym_bit_field] = ACTIONS(2151),
    [anon_sym_COLON] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COLON_EQ] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(2231),
    [anon_sym_DOLLAR] = ACTIONS(2156),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_when] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_case] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(2158),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_or_else] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_TILDE_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_STAR] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(2235),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_DOT_DOT_LT] = ACTIONS(837),
    [anon_sym_not_in] = ACTIONS(840),
    [anon_sym_DOT_DOT] = ACTIONS(2163),
    [anon_sym_or_return] = ACTIONS(840),
    [anon_sym_or_continue] = ACTIONS(840),
    [anon_sym_or_break] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(2239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2168),
    [anon_sym_map] = ACTIONS(2170),
    [anon_sym_bit_set] = ACTIONS(2172),
    [anon_sym_matrix] = ACTIONS(2174),
    [anon_sym_distinct] = ACTIONS(2176),
    [sym_tag] = ACTIONS(2178),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(837),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [245] = {
    [sym_procedure] = STATE(3887),
    [sym_type] = STATE(3803),
    [sym_pointer_type] = STATE(3772),
    [sym_variadic_type] = STATE(3772),
    [sym_array_type] = STATE(3772),
    [sym_map_type] = STATE(3772),
    [sym_union_type] = STATE(3772),
    [sym_bit_set_type] = STATE(3772),
    [sym_matrix_type] = STATE(3772),
    [sym_field_type] = STATE(3772),
    [sym_tuple_type] = STATE(3772),
    [sym_struct_type] = STATE(3772),
    [sym_enum_type] = STATE(3772),
    [sym_bit_field_type] = STATE(3772),
    [sym_constant_type] = STATE(3772),
    [sym_specialized_type] = STATE(3772),
    [sym__procedure_type] = STATE(3772),
    [sym_distinct_type] = STATE(3772),
    [sym_empty_type] = STATE(3772),
    [sym_polymorphic_type] = STATE(3772),
    [sym_conditional_type] = STATE(3772),
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(859),
    [anon_sym_proc] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_enum] = ACTIONS(2249),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_union] = ACTIONS(2251),
    [anon_sym_bit_field] = ACTIONS(2253),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(2255),
    [anon_sym_RPAREN] = ACTIONS(859),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_else] = ACTIONS(861),
    [anon_sym_when] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or_else] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_RBRACK] = ACTIONS(859),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(861),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_or_return] = ACTIONS(861),
    [anon_sym_or_continue] = ACTIONS(861),
    [anon_sym_or_break] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(2267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_map] = ACTIONS(2272),
    [anon_sym_bit_set] = ACTIONS(2274),
    [anon_sym_matrix] = ACTIONS(2276),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_tag] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [246] = {
    [sym_procedure] = STATE(3887),
    [sym_type] = STATE(3846),
    [sym_pointer_type] = STATE(3772),
    [sym_variadic_type] = STATE(3772),
    [sym_array_type] = STATE(3772),
    [sym_map_type] = STATE(3772),
    [sym_union_type] = STATE(3772),
    [sym_bit_set_type] = STATE(3772),
    [sym_matrix_type] = STATE(3772),
    [sym_field_type] = STATE(3772),
    [sym_tuple_type] = STATE(3772),
    [sym_struct_type] = STATE(3772),
    [sym_enum_type] = STATE(3772),
    [sym_bit_field_type] = STATE(3772),
    [sym_constant_type] = STATE(3772),
    [sym_specialized_type] = STATE(3772),
    [sym__procedure_type] = STATE(3772),
    [sym_distinct_type] = STATE(3772),
    [sym_empty_type] = STATE(3772),
    [sym_polymorphic_type] = STATE(3772),
    [sym_conditional_type] = STATE(3772),
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_COLON_COLON] = ACTIONS(837),
    [anon_sym_proc] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_enum] = ACTIONS(2249),
    [anon_sym_EQ] = ACTIONS(840),
    [anon_sym_union] = ACTIONS(2251),
    [anon_sym_bit_field] = ACTIONS(2253),
    [anon_sym_COLON] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COLON_EQ] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(2280),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_when] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_or_else] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_TILDE_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_STAR] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_RBRACK] = ACTIONS(837),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_DOT_DOT_LT] = ACTIONS(837),
    [anon_sym_not_in] = ACTIONS(840),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_or_return] = ACTIONS(840),
    [anon_sym_or_continue] = ACTIONS(840),
    [anon_sym_or_break] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(2288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_map] = ACTIONS(2272),
    [anon_sym_bit_set] = ACTIONS(2274),
    [anon_sym_matrix] = ACTIONS(2276),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_tag] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [247] = {
    [sym_procedure] = STATE(3766),
    [sym_type] = STATE(3839),
    [sym_pointer_type] = STATE(3920),
    [sym_variadic_type] = STATE(3920),
    [sym_array_type] = STATE(3920),
    [sym_map_type] = STATE(3920),
    [sym_union_type] = STATE(3920),
    [sym_bit_set_type] = STATE(3920),
    [sym_matrix_type] = STATE(3920),
    [sym_field_type] = STATE(3920),
    [sym_tuple_type] = STATE(3920),
    [sym_struct_type] = STATE(3920),
    [sym_enum_type] = STATE(3920),
    [sym_bit_field_type] = STATE(3920),
    [sym_constant_type] = STATE(3920),
    [sym_specialized_type] = STATE(3920),
    [sym__procedure_type] = STATE(3920),
    [sym_distinct_type] = STATE(3920),
    [sym_empty_type] = STATE(3920),
    [sym_polymorphic_type] = STATE(3920),
    [sym_conditional_type] = STATE(3920),
    [ts_builtin_sym_end] = ACTIONS(767),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_COLON_COLON] = ACTIONS(767),
    [anon_sym_proc] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_bit_field] = ACTIONS(2302),
    [anon_sym_COLON] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_COLON_EQ] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(2304),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_else] = ACTIONS(773),
    [anon_sym_when] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(773),
    [anon_sym_case] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(767),
    [anon_sym_or_else] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(767),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(2311),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(2314),
    [anon_sym_or_return] = ACTIONS(773),
    [anon_sym_or_continue] = ACTIONS(773),
    [anon_sym_or_break] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2316),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2319),
    [anon_sym_map] = ACTIONS(2321),
    [anon_sym_bit_set] = ACTIONS(2323),
    [anon_sym_matrix] = ACTIONS(2325),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_tag] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(767),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [248] = {
    [sym_procedure] = STATE(3887),
    [sym_type] = STATE(3871),
    [sym_pointer_type] = STATE(3772),
    [sym_variadic_type] = STATE(3772),
    [sym_array_type] = STATE(3772),
    [sym_map_type] = STATE(3772),
    [sym_union_type] = STATE(3772),
    [sym_bit_set_type] = STATE(3772),
    [sym_matrix_type] = STATE(3772),
    [sym_field_type] = STATE(3772),
    [sym_tuple_type] = STATE(3772),
    [sym_struct_type] = STATE(3772),
    [sym_enum_type] = STATE(3772),
    [sym_bit_field_type] = STATE(3772),
    [sym_constant_type] = STATE(3772),
    [sym_specialized_type] = STATE(3772),
    [sym__procedure_type] = STATE(3772),
    [sym_distinct_type] = STATE(3772),
    [sym_empty_type] = STATE(3772),
    [sym_polymorphic_type] = STATE(3772),
    [sym_conditional_type] = STATE(3772),
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_COLON_COLON] = ACTIONS(815),
    [anon_sym_proc] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_enum] = ACTIONS(2249),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_union] = ACTIONS(2251),
    [anon_sym_bit_field] = ACTIONS(2253),
    [anon_sym_COLON] = ACTIONS(818),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_COLON_EQ] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(2329),
    [anon_sym_RPAREN] = ACTIONS(815),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_else] = ACTIONS(818),
    [anon_sym_when] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_or_else] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(2333),
    [anon_sym_RBRACK] = ACTIONS(815),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(818),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_or_return] = ACTIONS(818),
    [anon_sym_or_continue] = ACTIONS(818),
    [anon_sym_or_break] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(2337),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_map] = ACTIONS(2272),
    [anon_sym_bit_set] = ACTIONS(2274),
    [anon_sym_matrix] = ACTIONS(2276),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_tag] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [249] = {
    [sym_procedure] = STATE(3766),
    [sym_type] = STATE(3811),
    [sym_pointer_type] = STATE(3920),
    [sym_variadic_type] = STATE(3920),
    [sym_array_type] = STATE(3920),
    [sym_map_type] = STATE(3920),
    [sym_union_type] = STATE(3920),
    [sym_bit_set_type] = STATE(3920),
    [sym_matrix_type] = STATE(3920),
    [sym_field_type] = STATE(3920),
    [sym_tuple_type] = STATE(3920),
    [sym_struct_type] = STATE(3920),
    [sym_enum_type] = STATE(3920),
    [sym_bit_field_type] = STATE(3920),
    [sym_constant_type] = STATE(3920),
    [sym_specialized_type] = STATE(3920),
    [sym__procedure_type] = STATE(3920),
    [sym_distinct_type] = STATE(3920),
    [sym_empty_type] = STATE(3920),
    [sym_polymorphic_type] = STATE(3920),
    [sym_conditional_type] = STATE(3920),
    [ts_builtin_sym_end] = ACTIONS(913),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_COLON_COLON] = ACTIONS(913),
    [anon_sym_proc] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_bit_field] = ACTIONS(2302),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_COLON_EQ] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_else] = ACTIONS(915),
    [anon_sym_when] = ACTIONS(915),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_case] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(913),
    [anon_sym_or_else] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(2344),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(2314),
    [anon_sym_or_return] = ACTIONS(915),
    [anon_sym_or_continue] = ACTIONS(915),
    [anon_sym_or_break] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(2347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2319),
    [anon_sym_map] = ACTIONS(2321),
    [anon_sym_bit_set] = ACTIONS(2323),
    [anon_sym_matrix] = ACTIONS(2325),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_tag] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(913),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [250] = {
    [sym_procedure] = STATE(3766),
    [sym_type] = STATE(3866),
    [sym_pointer_type] = STATE(3920),
    [sym_variadic_type] = STATE(3920),
    [sym_array_type] = STATE(3920),
    [sym_map_type] = STATE(3920),
    [sym_union_type] = STATE(3920),
    [sym_bit_set_type] = STATE(3920),
    [sym_matrix_type] = STATE(3920),
    [sym_field_type] = STATE(3920),
    [sym_tuple_type] = STATE(3920),
    [sym_struct_type] = STATE(3920),
    [sym_enum_type] = STATE(3920),
    [sym_bit_field_type] = STATE(3920),
    [sym_constant_type] = STATE(3920),
    [sym_specialized_type] = STATE(3920),
    [sym__procedure_type] = STATE(3920),
    [sym_distinct_type] = STATE(3920),
    [sym_empty_type] = STATE(3920),
    [sym_polymorphic_type] = STATE(3920),
    [sym_conditional_type] = STATE(3920),
    [ts_builtin_sym_end] = ACTIONS(891),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [anon_sym_proc] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_bit_field] = ACTIONS(2302),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COLON_EQ] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(2350),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_when] = ACTIONS(894),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_case] = ACTIONS(894),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_or_else] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_GT_GT] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(2314),
    [anon_sym_or_return] = ACTIONS(894),
    [anon_sym_or_continue] = ACTIONS(894),
    [anon_sym_or_break] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(2358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2319),
    [anon_sym_map] = ACTIONS(2321),
    [anon_sym_bit_set] = ACTIONS(2323),
    [anon_sym_matrix] = ACTIONS(2325),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_tag] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(891),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [251] = {
    [sym_procedure] = STATE(3887),
    [sym_type] = STATE(3829),
    [sym_pointer_type] = STATE(3772),
    [sym_variadic_type] = STATE(3772),
    [sym_array_type] = STATE(3772),
    [sym_map_type] = STATE(3772),
    [sym_union_type] = STATE(3772),
    [sym_bit_set_type] = STATE(3772),
    [sym_matrix_type] = STATE(3772),
    [sym_field_type] = STATE(3772),
    [sym_tuple_type] = STATE(3772),
    [sym_struct_type] = STATE(3772),
    [sym_enum_type] = STATE(3772),
    [sym_bit_field_type] = STATE(3772),
    [sym_constant_type] = STATE(3772),
    [sym_specialized_type] = STATE(3772),
    [sym__procedure_type] = STATE(3772),
    [sym_distinct_type] = STATE(3772),
    [sym_empty_type] = STATE(3772),
    [sym_polymorphic_type] = STATE(3772),
    [sym_conditional_type] = STATE(3772),
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(875),
    [anon_sym_proc] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(875),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_enum] = ACTIONS(2249),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_union] = ACTIONS(2251),
    [anon_sym_bit_field] = ACTIONS(2253),
    [anon_sym_COLON] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_COLON_EQ] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_RPAREN] = ACTIONS(875),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_else] = ACTIONS(877),
    [anon_sym_when] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_or_else] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_TILDE_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(2365),
    [anon_sym_RBRACK] = ACTIONS(875),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(875),
    [anon_sym_DOT_DOT_LT] = ACTIONS(875),
    [anon_sym_not_in] = ACTIONS(877),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_or_return] = ACTIONS(877),
    [anon_sym_or_continue] = ACTIONS(877),
    [anon_sym_or_break] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(2368),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_map] = ACTIONS(2272),
    [anon_sym_bit_set] = ACTIONS(2274),
    [anon_sym_matrix] = ACTIONS(2276),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_tag] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [252] = {
    [sym_procedure] = STATE(3766),
    [sym_type] = STATE(3851),
    [sym_pointer_type] = STATE(3920),
    [sym_variadic_type] = STATE(3920),
    [sym_array_type] = STATE(3920),
    [sym_map_type] = STATE(3920),
    [sym_union_type] = STATE(3920),
    [sym_bit_set_type] = STATE(3920),
    [sym_matrix_type] = STATE(3920),
    [sym_field_type] = STATE(3920),
    [sym_tuple_type] = STATE(3920),
    [sym_struct_type] = STATE(3920),
    [sym_enum_type] = STATE(3920),
    [sym_bit_field_type] = STATE(3920),
    [sym_constant_type] = STATE(3920),
    [sym_specialized_type] = STATE(3920),
    [sym__procedure_type] = STATE(3920),
    [sym_distinct_type] = STATE(3920),
    [sym_empty_type] = STATE(3920),
    [sym_polymorphic_type] = STATE(3920),
    [sym_conditional_type] = STATE(3920),
    [ts_builtin_sym_end] = ACTIONS(815),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_COLON_COLON] = ACTIONS(815),
    [anon_sym_proc] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_bit_field] = ACTIONS(2302),
    [anon_sym_COLON] = ACTIONS(818),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_COLON_EQ] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(2371),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_else] = ACTIONS(818),
    [anon_sym_when] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(818),
    [anon_sym_case] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_or_else] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(2375),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(818),
    [anon_sym_DOT_DOT] = ACTIONS(2314),
    [anon_sym_or_return] = ACTIONS(818),
    [anon_sym_or_continue] = ACTIONS(818),
    [anon_sym_or_break] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(2379),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2319),
    [anon_sym_map] = ACTIONS(2321),
    [anon_sym_bit_set] = ACTIONS(2323),
    [anon_sym_matrix] = ACTIONS(2325),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_tag] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [253] = {
    [sym_procedure] = STATE(3887),
    [sym_type] = STATE(3863),
    [sym_pointer_type] = STATE(3772),
    [sym_variadic_type] = STATE(3772),
    [sym_array_type] = STATE(3772),
    [sym_map_type] = STATE(3772),
    [sym_union_type] = STATE(3772),
    [sym_bit_set_type] = STATE(3772),
    [sym_matrix_type] = STATE(3772),
    [sym_field_type] = STATE(3772),
    [sym_tuple_type] = STATE(3772),
    [sym_struct_type] = STATE(3772),
    [sym_enum_type] = STATE(3772),
    [sym_bit_field_type] = STATE(3772),
    [sym_constant_type] = STATE(3772),
    [sym_specialized_type] = STATE(3772),
    [sym__procedure_type] = STATE(3772),
    [sym_distinct_type] = STATE(3772),
    [sym_empty_type] = STATE(3772),
    [sym_polymorphic_type] = STATE(3772),
    [sym_conditional_type] = STATE(3772),
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_COLON_COLON] = ACTIONS(767),
    [anon_sym_proc] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_enum] = ACTIONS(2249),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_union] = ACTIONS(2251),
    [anon_sym_bit_field] = ACTIONS(2253),
    [anon_sym_COLON] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_COLON_EQ] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(2383),
    [anon_sym_RPAREN] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_else] = ACTIONS(773),
    [anon_sym_when] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(767),
    [anon_sym_or_else] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(767),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(2386),
    [anon_sym_RBRACK] = ACTIONS(767),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_or_return] = ACTIONS(773),
    [anon_sym_or_continue] = ACTIONS(773),
    [anon_sym_or_break] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2389),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_map] = ACTIONS(2272),
    [anon_sym_bit_set] = ACTIONS(2274),
    [anon_sym_matrix] = ACTIONS(2276),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_tag] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [254] = {
    [sym_procedure] = STATE(3887),
    [sym_type] = STATE(3878),
    [sym_pointer_type] = STATE(3772),
    [sym_variadic_type] = STATE(3772),
    [sym_array_type] = STATE(3772),
    [sym_map_type] = STATE(3772),
    [sym_union_type] = STATE(3772),
    [sym_bit_set_type] = STATE(3772),
    [sym_matrix_type] = STATE(3772),
    [sym_field_type] = STATE(3772),
    [sym_tuple_type] = STATE(3772),
    [sym_struct_type] = STATE(3772),
    [sym_enum_type] = STATE(3772),
    [sym_bit_field_type] = STATE(3772),
    [sym_constant_type] = STATE(3772),
    [sym_specialized_type] = STATE(3772),
    [sym__procedure_type] = STATE(3772),
    [sym_distinct_type] = STATE(3772),
    [sym_empty_type] = STATE(3772),
    [sym_polymorphic_type] = STATE(3772),
    [sym_conditional_type] = STATE(3772),
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_COLON_COLON] = ACTIONS(913),
    [anon_sym_proc] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_enum] = ACTIONS(2249),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_union] = ACTIONS(2251),
    [anon_sym_bit_field] = ACTIONS(2253),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_COLON_EQ] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(2392),
    [anon_sym_RPAREN] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_else] = ACTIONS(915),
    [anon_sym_when] = ACTIONS(915),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(913),
    [anon_sym_or_else] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(2395),
    [anon_sym_RBRACK] = ACTIONS(913),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_or_return] = ACTIONS(915),
    [anon_sym_or_continue] = ACTIONS(915),
    [anon_sym_or_break] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(2398),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_map] = ACTIONS(2272),
    [anon_sym_bit_set] = ACTIONS(2274),
    [anon_sym_matrix] = ACTIONS(2276),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_tag] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [255] = {
    [sym_procedure] = STATE(3887),
    [sym_type] = STATE(3717),
    [sym_pointer_type] = STATE(3772),
    [sym_variadic_type] = STATE(3772),
    [sym_array_type] = STATE(3772),
    [sym_map_type] = STATE(3772),
    [sym_union_type] = STATE(3772),
    [sym_bit_set_type] = STATE(3772),
    [sym_matrix_type] = STATE(3772),
    [sym_field_type] = STATE(3772),
    [sym_tuple_type] = STATE(3772),
    [sym_struct_type] = STATE(3772),
    [sym_enum_type] = STATE(3772),
    [sym_bit_field_type] = STATE(3772),
    [sym_constant_type] = STATE(3772),
    [sym_specialized_type] = STATE(3772),
    [sym__procedure_type] = STATE(3772),
    [sym_distinct_type] = STATE(3772),
    [sym_empty_type] = STATE(3772),
    [sym_polymorphic_type] = STATE(3772),
    [sym_conditional_type] = STATE(3772),
    [sym_identifier] = ACTIONS(2243),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [anon_sym_proc] = ACTIONS(2245),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_enum] = ACTIONS(2249),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_union] = ACTIONS(2251),
    [anon_sym_bit_field] = ACTIONS(2253),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COLON_EQ] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(2401),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_when] = ACTIONS(894),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_or_else] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_GT_GT] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(2405),
    [anon_sym_RBRACK] = ACTIONS(891),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(2265),
    [anon_sym_or_return] = ACTIONS(894),
    [anon_sym_or_continue] = ACTIONS(894),
    [anon_sym_or_break] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(2409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2270),
    [anon_sym_map] = ACTIONS(2272),
    [anon_sym_bit_set] = ACTIONS(2274),
    [anon_sym_matrix] = ACTIONS(2276),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_tag] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [256] = {
    [sym_procedure] = STATE(3766),
    [sym_type] = STATE(3862),
    [sym_pointer_type] = STATE(3920),
    [sym_variadic_type] = STATE(3920),
    [sym_array_type] = STATE(3920),
    [sym_map_type] = STATE(3920),
    [sym_union_type] = STATE(3920),
    [sym_bit_set_type] = STATE(3920),
    [sym_matrix_type] = STATE(3920),
    [sym_field_type] = STATE(3920),
    [sym_tuple_type] = STATE(3920),
    [sym_struct_type] = STATE(3920),
    [sym_enum_type] = STATE(3920),
    [sym_bit_field_type] = STATE(3920),
    [sym_constant_type] = STATE(3920),
    [sym_specialized_type] = STATE(3920),
    [sym__procedure_type] = STATE(3920),
    [sym_distinct_type] = STATE(3920),
    [sym_empty_type] = STATE(3920),
    [sym_polymorphic_type] = STATE(3920),
    [sym_conditional_type] = STATE(3920),
    [ts_builtin_sym_end] = ACTIONS(859),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(859),
    [anon_sym_proc] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_bit_field] = ACTIONS(2302),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(2413),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_else] = ACTIONS(861),
    [anon_sym_when] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_case] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or_else] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(861),
    [anon_sym_DOT_DOT] = ACTIONS(2314),
    [anon_sym_or_return] = ACTIONS(861),
    [anon_sym_or_continue] = ACTIONS(861),
    [anon_sym_or_break] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(2419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2319),
    [anon_sym_map] = ACTIONS(2321),
    [anon_sym_bit_set] = ACTIONS(2323),
    [anon_sym_matrix] = ACTIONS(2325),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_tag] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(859),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [257] = {
    [sym_procedure] = STATE(3766),
    [sym_type] = STATE(3754),
    [sym_pointer_type] = STATE(3920),
    [sym_variadic_type] = STATE(3920),
    [sym_array_type] = STATE(3920),
    [sym_map_type] = STATE(3920),
    [sym_union_type] = STATE(3920),
    [sym_bit_set_type] = STATE(3920),
    [sym_matrix_type] = STATE(3920),
    [sym_field_type] = STATE(3920),
    [sym_tuple_type] = STATE(3920),
    [sym_struct_type] = STATE(3920),
    [sym_enum_type] = STATE(3920),
    [sym_bit_field_type] = STATE(3920),
    [sym_constant_type] = STATE(3920),
    [sym_specialized_type] = STATE(3920),
    [sym__procedure_type] = STATE(3920),
    [sym_distinct_type] = STATE(3920),
    [sym_empty_type] = STATE(3920),
    [sym_polymorphic_type] = STATE(3920),
    [sym_conditional_type] = STATE(3920),
    [ts_builtin_sym_end] = ACTIONS(875),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(875),
    [anon_sym_proc] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(875),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_bit_field] = ACTIONS(2302),
    [anon_sym_COLON] = ACTIONS(877),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_COLON_EQ] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(2422),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_else] = ACTIONS(877),
    [anon_sym_when] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_case] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_or_else] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_TILDE_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(875),
    [anon_sym_DOT_DOT_LT] = ACTIONS(875),
    [anon_sym_not_in] = ACTIONS(877),
    [anon_sym_DOT_DOT] = ACTIONS(2314),
    [anon_sym_or_return] = ACTIONS(877),
    [anon_sym_or_continue] = ACTIONS(877),
    [anon_sym_or_break] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(2428),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2319),
    [anon_sym_map] = ACTIONS(2321),
    [anon_sym_bit_set] = ACTIONS(2323),
    [anon_sym_matrix] = ACTIONS(2325),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_tag] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(875),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [258] = {
    [sym_procedure] = STATE(3766),
    [sym_type] = STATE(3729),
    [sym_pointer_type] = STATE(3920),
    [sym_variadic_type] = STATE(3920),
    [sym_array_type] = STATE(3920),
    [sym_map_type] = STATE(3920),
    [sym_union_type] = STATE(3920),
    [sym_bit_set_type] = STATE(3920),
    [sym_matrix_type] = STATE(3920),
    [sym_field_type] = STATE(3920),
    [sym_tuple_type] = STATE(3920),
    [sym_struct_type] = STATE(3920),
    [sym_enum_type] = STATE(3920),
    [sym_bit_field_type] = STATE(3920),
    [sym_constant_type] = STATE(3920),
    [sym_specialized_type] = STATE(3920),
    [sym__procedure_type] = STATE(3920),
    [sym_distinct_type] = STATE(3920),
    [sym_empty_type] = STATE(3920),
    [sym_polymorphic_type] = STATE(3920),
    [sym_conditional_type] = STATE(3920),
    [ts_builtin_sym_end] = ACTIONS(837),
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_COLON_COLON] = ACTIONS(837),
    [anon_sym_proc] = ACTIONS(2294),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_union] = ACTIONS(2300),
    [anon_sym_bit_field] = ACTIONS(2302),
    [anon_sym_COLON] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COLON_EQ] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(2431),
    [anon_sym_DOLLAR] = ACTIONS(2307),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_when] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_case] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_or_else] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_TILDE_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_STAR] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(2435),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_DOT_DOT_LT] = ACTIONS(837),
    [anon_sym_not_in] = ACTIONS(840),
    [anon_sym_DOT_DOT] = ACTIONS(2314),
    [anon_sym_or_return] = ACTIONS(840),
    [anon_sym_or_continue] = ACTIONS(840),
    [anon_sym_or_break] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(2439),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2319),
    [anon_sym_map] = ACTIONS(2321),
    [anon_sym_bit_set] = ACTIONS(2323),
    [anon_sym_matrix] = ACTIONS(2325),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_tag] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(837),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [259] = {
    [sym_procedure] = STATE(4322),
    [sym_type] = STATE(4194),
    [sym_pointer_type] = STATE(4276),
    [sym_variadic_type] = STATE(4276),
    [sym_array_type] = STATE(4276),
    [sym_map_type] = STATE(4276),
    [sym_union_type] = STATE(4276),
    [sym_bit_set_type] = STATE(4276),
    [sym_matrix_type] = STATE(4276),
    [sym_field_type] = STATE(4276),
    [sym_tuple_type] = STATE(4276),
    [sym_struct_type] = STATE(4276),
    [sym_enum_type] = STATE(4276),
    [sym_bit_field_type] = STATE(4276),
    [sym_constant_type] = STATE(4276),
    [sym_specialized_type] = STATE(4276),
    [sym__procedure_type] = STATE(4276),
    [sym_distinct_type] = STATE(4276),
    [sym_empty_type] = STATE(4276),
    [sym_polymorphic_type] = STATE(4276),
    [sym_conditional_type] = STATE(4276),
    [ts_builtin_sym_end] = ACTIONS(875),
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_proc] = ACTIONS(2445),
    [anon_sym_DASH_GT] = ACTIONS(875),
    [anon_sym_struct] = ACTIONS(2447),
    [anon_sym_enum] = ACTIONS(2449),
    [anon_sym_union] = ACTIONS(2451),
    [anon_sym_bit_field] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_LPAREN] = ACTIONS(2455),
    [anon_sym_DOLLAR] = ACTIONS(2458),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_else] = ACTIONS(877),
    [anon_sym_when] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_case] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_or_else] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_TILDE_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(875),
    [anon_sym_DOT_DOT_LT] = ACTIONS(875),
    [anon_sym_not_in] = ACTIONS(877),
    [anon_sym_DOT_DOT] = ACTIONS(2465),
    [anon_sym_or_return] = ACTIONS(877),
    [anon_sym_or_continue] = ACTIONS(877),
    [anon_sym_or_break] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(2467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2470),
    [anon_sym_map] = ACTIONS(2472),
    [anon_sym_bit_set] = ACTIONS(2474),
    [anon_sym_matrix] = ACTIONS(2476),
    [anon_sym_distinct] = ACTIONS(2478),
    [sym_tag] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(875),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(875),
    [sym_block_comment] = ACTIONS(3),
  },
  [260] = {
    [sym_procedure] = STATE(4322),
    [sym_type] = STATE(4182),
    [sym_pointer_type] = STATE(4276),
    [sym_variadic_type] = STATE(4276),
    [sym_array_type] = STATE(4276),
    [sym_map_type] = STATE(4276),
    [sym_union_type] = STATE(4276),
    [sym_bit_set_type] = STATE(4276),
    [sym_matrix_type] = STATE(4276),
    [sym_field_type] = STATE(4276),
    [sym_tuple_type] = STATE(4276),
    [sym_struct_type] = STATE(4276),
    [sym_enum_type] = STATE(4276),
    [sym_bit_field_type] = STATE(4276),
    [sym_constant_type] = STATE(4276),
    [sym_specialized_type] = STATE(4276),
    [sym__procedure_type] = STATE(4276),
    [sym_distinct_type] = STATE(4276),
    [sym_empty_type] = STATE(4276),
    [sym_polymorphic_type] = STATE(4276),
    [sym_conditional_type] = STATE(4276),
    [ts_builtin_sym_end] = ACTIONS(815),
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_proc] = ACTIONS(2445),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(2447),
    [anon_sym_enum] = ACTIONS(2449),
    [anon_sym_union] = ACTIONS(2451),
    [anon_sym_bit_field] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_LPAREN] = ACTIONS(2482),
    [anon_sym_DOLLAR] = ACTIONS(2458),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_else] = ACTIONS(818),
    [anon_sym_when] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(818),
    [anon_sym_case] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_or_else] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(2486),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(818),
    [anon_sym_DOT_DOT] = ACTIONS(2465),
    [anon_sym_or_return] = ACTIONS(818),
    [anon_sym_or_continue] = ACTIONS(818),
    [anon_sym_or_break] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(2490),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2470),
    [anon_sym_map] = ACTIONS(2472),
    [anon_sym_bit_set] = ACTIONS(2474),
    [anon_sym_matrix] = ACTIONS(2476),
    [anon_sym_distinct] = ACTIONS(2478),
    [sym_tag] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(815),
    [sym_block_comment] = ACTIONS(3),
  },
  [261] = {
    [sym_procedure] = STATE(4322),
    [sym_type] = STATE(4255),
    [sym_pointer_type] = STATE(4276),
    [sym_variadic_type] = STATE(4276),
    [sym_array_type] = STATE(4276),
    [sym_map_type] = STATE(4276),
    [sym_union_type] = STATE(4276),
    [sym_bit_set_type] = STATE(4276),
    [sym_matrix_type] = STATE(4276),
    [sym_field_type] = STATE(4276),
    [sym_tuple_type] = STATE(4276),
    [sym_struct_type] = STATE(4276),
    [sym_enum_type] = STATE(4276),
    [sym_bit_field_type] = STATE(4276),
    [sym_constant_type] = STATE(4276),
    [sym_specialized_type] = STATE(4276),
    [sym__procedure_type] = STATE(4276),
    [sym_distinct_type] = STATE(4276),
    [sym_empty_type] = STATE(4276),
    [sym_polymorphic_type] = STATE(4276),
    [sym_conditional_type] = STATE(4276),
    [ts_builtin_sym_end] = ACTIONS(891),
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_proc] = ACTIONS(2445),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_struct] = ACTIONS(2447),
    [anon_sym_enum] = ACTIONS(2449),
    [anon_sym_union] = ACTIONS(2451),
    [anon_sym_bit_field] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_LPAREN] = ACTIONS(2494),
    [anon_sym_DOLLAR] = ACTIONS(2458),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_when] = ACTIONS(894),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_case] = ACTIONS(894),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_or_else] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_GT_GT] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(2498),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(2465),
    [anon_sym_or_return] = ACTIONS(894),
    [anon_sym_or_continue] = ACTIONS(894),
    [anon_sym_or_break] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(2502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2470),
    [anon_sym_map] = ACTIONS(2472),
    [anon_sym_bit_set] = ACTIONS(2474),
    [anon_sym_matrix] = ACTIONS(2476),
    [anon_sym_distinct] = ACTIONS(2478),
    [sym_tag] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(891),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(891),
    [sym_block_comment] = ACTIONS(3),
  },
  [262] = {
    [sym_procedure] = STATE(4322),
    [sym_type] = STATE(4229),
    [sym_pointer_type] = STATE(4276),
    [sym_variadic_type] = STATE(4276),
    [sym_array_type] = STATE(4276),
    [sym_map_type] = STATE(4276),
    [sym_union_type] = STATE(4276),
    [sym_bit_set_type] = STATE(4276),
    [sym_matrix_type] = STATE(4276),
    [sym_field_type] = STATE(4276),
    [sym_tuple_type] = STATE(4276),
    [sym_struct_type] = STATE(4276),
    [sym_enum_type] = STATE(4276),
    [sym_bit_field_type] = STATE(4276),
    [sym_constant_type] = STATE(4276),
    [sym_specialized_type] = STATE(4276),
    [sym__procedure_type] = STATE(4276),
    [sym_distinct_type] = STATE(4276),
    [sym_empty_type] = STATE(4276),
    [sym_polymorphic_type] = STATE(4276),
    [sym_conditional_type] = STATE(4276),
    [ts_builtin_sym_end] = ACTIONS(767),
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_proc] = ACTIONS(2445),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_struct] = ACTIONS(2447),
    [anon_sym_enum] = ACTIONS(2449),
    [anon_sym_union] = ACTIONS(2451),
    [anon_sym_bit_field] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2458),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_else] = ACTIONS(773),
    [anon_sym_when] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(773),
    [anon_sym_case] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(767),
    [anon_sym_or_else] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(767),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(2509),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(2465),
    [anon_sym_or_return] = ACTIONS(773),
    [anon_sym_or_continue] = ACTIONS(773),
    [anon_sym_or_break] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2512),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2470),
    [anon_sym_map] = ACTIONS(2472),
    [anon_sym_bit_set] = ACTIONS(2474),
    [anon_sym_matrix] = ACTIONS(2476),
    [anon_sym_distinct] = ACTIONS(2478),
    [sym_tag] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(767),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(767),
    [sym_block_comment] = ACTIONS(3),
  },
  [263] = {
    [sym_procedure] = STATE(4322),
    [sym_type] = STATE(4240),
    [sym_pointer_type] = STATE(4276),
    [sym_variadic_type] = STATE(4276),
    [sym_array_type] = STATE(4276),
    [sym_map_type] = STATE(4276),
    [sym_union_type] = STATE(4276),
    [sym_bit_set_type] = STATE(4276),
    [sym_matrix_type] = STATE(4276),
    [sym_field_type] = STATE(4276),
    [sym_tuple_type] = STATE(4276),
    [sym_struct_type] = STATE(4276),
    [sym_enum_type] = STATE(4276),
    [sym_bit_field_type] = STATE(4276),
    [sym_constant_type] = STATE(4276),
    [sym_specialized_type] = STATE(4276),
    [sym__procedure_type] = STATE(4276),
    [sym_distinct_type] = STATE(4276),
    [sym_empty_type] = STATE(4276),
    [sym_polymorphic_type] = STATE(4276),
    [sym_conditional_type] = STATE(4276),
    [ts_builtin_sym_end] = ACTIONS(859),
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_proc] = ACTIONS(2445),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(2447),
    [anon_sym_enum] = ACTIONS(2449),
    [anon_sym_union] = ACTIONS(2451),
    [anon_sym_bit_field] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_LPAREN] = ACTIONS(2515),
    [anon_sym_DOLLAR] = ACTIONS(2458),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_else] = ACTIONS(861),
    [anon_sym_when] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_case] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or_else] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(2518),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(861),
    [anon_sym_DOT_DOT] = ACTIONS(2465),
    [anon_sym_or_return] = ACTIONS(861),
    [anon_sym_or_continue] = ACTIONS(861),
    [anon_sym_or_break] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(2521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2470),
    [anon_sym_map] = ACTIONS(2472),
    [anon_sym_bit_set] = ACTIONS(2474),
    [anon_sym_matrix] = ACTIONS(2476),
    [anon_sym_distinct] = ACTIONS(2478),
    [sym_tag] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(859),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(859),
    [sym_block_comment] = ACTIONS(3),
  },
  [264] = {
    [sym_procedure] = STATE(4322),
    [sym_type] = STATE(4174),
    [sym_pointer_type] = STATE(4276),
    [sym_variadic_type] = STATE(4276),
    [sym_array_type] = STATE(4276),
    [sym_map_type] = STATE(4276),
    [sym_union_type] = STATE(4276),
    [sym_bit_set_type] = STATE(4276),
    [sym_matrix_type] = STATE(4276),
    [sym_field_type] = STATE(4276),
    [sym_tuple_type] = STATE(4276),
    [sym_struct_type] = STATE(4276),
    [sym_enum_type] = STATE(4276),
    [sym_bit_field_type] = STATE(4276),
    [sym_constant_type] = STATE(4276),
    [sym_specialized_type] = STATE(4276),
    [sym__procedure_type] = STATE(4276),
    [sym_distinct_type] = STATE(4276),
    [sym_empty_type] = STATE(4276),
    [sym_polymorphic_type] = STATE(4276),
    [sym_conditional_type] = STATE(4276),
    [ts_builtin_sym_end] = ACTIONS(837),
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_proc] = ACTIONS(2445),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_struct] = ACTIONS(2447),
    [anon_sym_enum] = ACTIONS(2449),
    [anon_sym_union] = ACTIONS(2451),
    [anon_sym_bit_field] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_LPAREN] = ACTIONS(2524),
    [anon_sym_DOLLAR] = ACTIONS(2458),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_when] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_case] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_or_else] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_TILDE_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_STAR] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(2528),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_DOT_DOT_LT] = ACTIONS(837),
    [anon_sym_not_in] = ACTIONS(840),
    [anon_sym_DOT_DOT] = ACTIONS(2465),
    [anon_sym_or_return] = ACTIONS(840),
    [anon_sym_or_continue] = ACTIONS(840),
    [anon_sym_or_break] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(2532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2470),
    [anon_sym_map] = ACTIONS(2472),
    [anon_sym_bit_set] = ACTIONS(2474),
    [anon_sym_matrix] = ACTIONS(2476),
    [anon_sym_distinct] = ACTIONS(2478),
    [sym_tag] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(837),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(837),
    [sym_block_comment] = ACTIONS(3),
  },
  [265] = {
    [sym_procedure] = STATE(4322),
    [sym_type] = STATE(4365),
    [sym_pointer_type] = STATE(4276),
    [sym_variadic_type] = STATE(4276),
    [sym_array_type] = STATE(4276),
    [sym_map_type] = STATE(4276),
    [sym_union_type] = STATE(4276),
    [sym_bit_set_type] = STATE(4276),
    [sym_matrix_type] = STATE(4276),
    [sym_field_type] = STATE(4276),
    [sym_tuple_type] = STATE(4276),
    [sym_struct_type] = STATE(4276),
    [sym_enum_type] = STATE(4276),
    [sym_bit_field_type] = STATE(4276),
    [sym_constant_type] = STATE(4276),
    [sym_specialized_type] = STATE(4276),
    [sym__procedure_type] = STATE(4276),
    [sym_distinct_type] = STATE(4276),
    [sym_empty_type] = STATE(4276),
    [sym_polymorphic_type] = STATE(4276),
    [sym_conditional_type] = STATE(4276),
    [ts_builtin_sym_end] = ACTIONS(913),
    [sym_identifier] = ACTIONS(2443),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_proc] = ACTIONS(2445),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_struct] = ACTIONS(2447),
    [anon_sym_enum] = ACTIONS(2449),
    [anon_sym_union] = ACTIONS(2451),
    [anon_sym_bit_field] = ACTIONS(2453),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [anon_sym_DOLLAR] = ACTIONS(2458),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_else] = ACTIONS(915),
    [anon_sym_when] = ACTIONS(915),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_case] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(913),
    [anon_sym_or_else] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(2539),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(2465),
    [anon_sym_or_return] = ACTIONS(915),
    [anon_sym_or_continue] = ACTIONS(915),
    [anon_sym_or_break] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(2542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2470),
    [anon_sym_map] = ACTIONS(2472),
    [anon_sym_bit_set] = ACTIONS(2474),
    [anon_sym_matrix] = ACTIONS(2476),
    [anon_sym_distinct] = ACTIONS(2478),
    [sym_tag] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(913),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(913),
    [sym_block_comment] = ACTIONS(3),
  },
  [266] = {
    [sym_procedure] = STATE(4444),
    [sym_type] = STATE(4516),
    [sym_pointer_type] = STATE(4570),
    [sym_variadic_type] = STATE(4570),
    [sym_array_type] = STATE(4570),
    [sym_map_type] = STATE(4570),
    [sym_union_type] = STATE(4570),
    [sym_bit_set_type] = STATE(4570),
    [sym_matrix_type] = STATE(4570),
    [sym_field_type] = STATE(4570),
    [sym_tuple_type] = STATE(4570),
    [sym_struct_type] = STATE(4570),
    [sym_enum_type] = STATE(4570),
    [sym_bit_field_type] = STATE(4570),
    [sym_constant_type] = STATE(4570),
    [sym_specialized_type] = STATE(4570),
    [sym__procedure_type] = STATE(4570),
    [sym_distinct_type] = STATE(4570),
    [sym_empty_type] = STATE(4570),
    [sym_polymorphic_type] = STATE(4570),
    [sym_conditional_type] = STATE(4570),
    [ts_builtin_sym_end] = ACTIONS(913),
    [sym_identifier] = ACTIONS(2545),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_proc] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_struct] = ACTIONS(2549),
    [anon_sym_enum] = ACTIONS(2551),
    [anon_sym_union] = ACTIONS(2553),
    [anon_sym_bit_field] = ACTIONS(2555),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_LPAREN] = ACTIONS(2557),
    [anon_sym_DOLLAR] = ACTIONS(2560),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_else] = ACTIONS(915),
    [anon_sym_when] = ACTIONS(915),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_case] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(913),
    [anon_sym_or_else] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(2567),
    [anon_sym_or_return] = ACTIONS(915),
    [anon_sym_or_continue] = ACTIONS(915),
    [anon_sym_or_break] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(2569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2572),
    [anon_sym_map] = ACTIONS(2574),
    [anon_sym_bit_set] = ACTIONS(2576),
    [anon_sym_matrix] = ACTIONS(2578),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_tag] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(913),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(913),
    [sym_block_comment] = ACTIONS(3),
  },
  [267] = {
    [sym_procedure] = STATE(4281),
    [sym_type] = STATE(4221),
    [sym_pointer_type] = STATE(4209),
    [sym_variadic_type] = STATE(4209),
    [sym_array_type] = STATE(4209),
    [sym_map_type] = STATE(4209),
    [sym_union_type] = STATE(4209),
    [sym_bit_set_type] = STATE(4209),
    [sym_matrix_type] = STATE(4209),
    [sym_field_type] = STATE(4209),
    [sym_tuple_type] = STATE(4209),
    [sym_struct_type] = STATE(4209),
    [sym_enum_type] = STATE(4209),
    [sym_bit_field_type] = STATE(4209),
    [sym_constant_type] = STATE(4209),
    [sym_specialized_type] = STATE(4209),
    [sym__procedure_type] = STATE(4209),
    [sym_distinct_type] = STATE(4209),
    [sym_empty_type] = STATE(4209),
    [sym_polymorphic_type] = STATE(4209),
    [sym_conditional_type] = STATE(4209),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_proc] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(875),
    [anon_sym_where] = ACTIONS(877),
    [anon_sym_struct] = ACTIONS(2586),
    [anon_sym_enum] = ACTIONS(2588),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_union] = ACTIONS(2590),
    [anon_sym_bit_field] = ACTIONS(2592),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_LPAREN] = ACTIONS(2594),
    [anon_sym_DOLLAR] = ACTIONS(2597),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_when] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(2599),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_or_else] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_TILDE_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(2601),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(875),
    [anon_sym_DOT_DOT_LT] = ACTIONS(875),
    [anon_sym_not_in] = ACTIONS(877),
    [anon_sym_DOT_DOT] = ACTIONS(2604),
    [anon_sym_or_return] = ACTIONS(877),
    [anon_sym_or_continue] = ACTIONS(877),
    [anon_sym_or_break] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(2606),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2609),
    [anon_sym_map] = ACTIONS(2611),
    [anon_sym_bit_set] = ACTIONS(2613),
    [anon_sym_matrix] = ACTIONS(2615),
    [anon_sym_distinct] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(875),
    [anon_sym_BQUOTE] = ACTIONS(875),
    [sym_uninitialized] = ACTIONS(875),
    [sym_tag] = ACTIONS(2617),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [268] = {
    [sym_procedure] = STATE(4444),
    [sym_type] = STATE(4500),
    [sym_pointer_type] = STATE(4570),
    [sym_variadic_type] = STATE(4570),
    [sym_array_type] = STATE(4570),
    [sym_map_type] = STATE(4570),
    [sym_union_type] = STATE(4570),
    [sym_bit_set_type] = STATE(4570),
    [sym_matrix_type] = STATE(4570),
    [sym_field_type] = STATE(4570),
    [sym_tuple_type] = STATE(4570),
    [sym_struct_type] = STATE(4570),
    [sym_enum_type] = STATE(4570),
    [sym_bit_field_type] = STATE(4570),
    [sym_constant_type] = STATE(4570),
    [sym_specialized_type] = STATE(4570),
    [sym__procedure_type] = STATE(4570),
    [sym_distinct_type] = STATE(4570),
    [sym_empty_type] = STATE(4570),
    [sym_polymorphic_type] = STATE(4570),
    [sym_conditional_type] = STATE(4570),
    [ts_builtin_sym_end] = ACTIONS(767),
    [sym_identifier] = ACTIONS(2545),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_proc] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_struct] = ACTIONS(2549),
    [anon_sym_enum] = ACTIONS(2551),
    [anon_sym_union] = ACTIONS(2553),
    [anon_sym_bit_field] = ACTIONS(2555),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2620),
    [anon_sym_DOLLAR] = ACTIONS(2560),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_else] = ACTIONS(773),
    [anon_sym_when] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(773),
    [anon_sym_case] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(767),
    [anon_sym_or_else] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(767),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(2623),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(2567),
    [anon_sym_or_return] = ACTIONS(773),
    [anon_sym_or_continue] = ACTIONS(773),
    [anon_sym_or_break] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2572),
    [anon_sym_map] = ACTIONS(2574),
    [anon_sym_bit_set] = ACTIONS(2576),
    [anon_sym_matrix] = ACTIONS(2578),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_tag] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(767),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(767),
    [sym_block_comment] = ACTIONS(3),
  },
  [269] = {
    [sym_procedure] = STATE(4281),
    [sym_type] = STATE(4277),
    [sym_pointer_type] = STATE(4209),
    [sym_variadic_type] = STATE(4209),
    [sym_array_type] = STATE(4209),
    [sym_map_type] = STATE(4209),
    [sym_union_type] = STATE(4209),
    [sym_bit_set_type] = STATE(4209),
    [sym_matrix_type] = STATE(4209),
    [sym_field_type] = STATE(4209),
    [sym_tuple_type] = STATE(4209),
    [sym_struct_type] = STATE(4209),
    [sym_enum_type] = STATE(4209),
    [sym_bit_field_type] = STATE(4209),
    [sym_constant_type] = STATE(4209),
    [sym_specialized_type] = STATE(4209),
    [sym__procedure_type] = STATE(4209),
    [sym_distinct_type] = STATE(4209),
    [sym_empty_type] = STATE(4209),
    [sym_polymorphic_type] = STATE(4209),
    [sym_conditional_type] = STATE(4209),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_proc] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_where] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(2586),
    [anon_sym_enum] = ACTIONS(2588),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_union] = ACTIONS(2590),
    [anon_sym_bit_field] = ACTIONS(2592),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_LPAREN] = ACTIONS(2629),
    [anon_sym_DOLLAR] = ACTIONS(2597),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_when] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(2599),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or_else] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(861),
    [anon_sym_DOT_DOT] = ACTIONS(2604),
    [anon_sym_or_return] = ACTIONS(861),
    [anon_sym_or_continue] = ACTIONS(861),
    [anon_sym_or_break] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(2635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2609),
    [anon_sym_map] = ACTIONS(2611),
    [anon_sym_bit_set] = ACTIONS(2613),
    [anon_sym_matrix] = ACTIONS(2615),
    [anon_sym_distinct] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(859),
    [sym_uninitialized] = ACTIONS(859),
    [sym_tag] = ACTIONS(2638),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [270] = {
    [sym_procedure] = STATE(4281),
    [sym_type] = STATE(4274),
    [sym_pointer_type] = STATE(4209),
    [sym_variadic_type] = STATE(4209),
    [sym_array_type] = STATE(4209),
    [sym_map_type] = STATE(4209),
    [sym_union_type] = STATE(4209),
    [sym_bit_set_type] = STATE(4209),
    [sym_matrix_type] = STATE(4209),
    [sym_field_type] = STATE(4209),
    [sym_tuple_type] = STATE(4209),
    [sym_struct_type] = STATE(4209),
    [sym_enum_type] = STATE(4209),
    [sym_bit_field_type] = STATE(4209),
    [sym_constant_type] = STATE(4209),
    [sym_specialized_type] = STATE(4209),
    [sym__procedure_type] = STATE(4209),
    [sym_distinct_type] = STATE(4209),
    [sym_empty_type] = STATE(4209),
    [sym_polymorphic_type] = STATE(4209),
    [sym_conditional_type] = STATE(4209),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_proc] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_where] = ACTIONS(773),
    [anon_sym_struct] = ACTIONS(2586),
    [anon_sym_enum] = ACTIONS(2588),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_union] = ACTIONS(2590),
    [anon_sym_bit_field] = ACTIONS(2592),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(2641),
    [anon_sym_DOLLAR] = ACTIONS(2597),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_when] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(2599),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(767),
    [anon_sym_or_else] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(767),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(2644),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(2604),
    [anon_sym_or_return] = ACTIONS(773),
    [anon_sym_or_continue] = ACTIONS(773),
    [anon_sym_or_break] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2609),
    [anon_sym_map] = ACTIONS(2611),
    [anon_sym_bit_set] = ACTIONS(2613),
    [anon_sym_matrix] = ACTIONS(2615),
    [anon_sym_distinct] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [sym_uninitialized] = ACTIONS(767),
    [sym_tag] = ACTIONS(2650),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [271] = {
    [sym_procedure] = STATE(4281),
    [sym_type] = STATE(4235),
    [sym_pointer_type] = STATE(4209),
    [sym_variadic_type] = STATE(4209),
    [sym_array_type] = STATE(4209),
    [sym_map_type] = STATE(4209),
    [sym_union_type] = STATE(4209),
    [sym_bit_set_type] = STATE(4209),
    [sym_matrix_type] = STATE(4209),
    [sym_field_type] = STATE(4209),
    [sym_tuple_type] = STATE(4209),
    [sym_struct_type] = STATE(4209),
    [sym_enum_type] = STATE(4209),
    [sym_bit_field_type] = STATE(4209),
    [sym_constant_type] = STATE(4209),
    [sym_specialized_type] = STATE(4209),
    [sym__procedure_type] = STATE(4209),
    [sym_distinct_type] = STATE(4209),
    [sym_empty_type] = STATE(4209),
    [sym_polymorphic_type] = STATE(4209),
    [sym_conditional_type] = STATE(4209),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_proc] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_where] = ACTIONS(915),
    [anon_sym_struct] = ACTIONS(2586),
    [anon_sym_enum] = ACTIONS(2588),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_union] = ACTIONS(2590),
    [anon_sym_bit_field] = ACTIONS(2592),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_LPAREN] = ACTIONS(2653),
    [anon_sym_DOLLAR] = ACTIONS(2597),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_when] = ACTIONS(915),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(2599),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(913),
    [anon_sym_or_else] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(2604),
    [anon_sym_or_return] = ACTIONS(915),
    [anon_sym_or_continue] = ACTIONS(915),
    [anon_sym_or_break] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(2659),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2609),
    [anon_sym_map] = ACTIONS(2611),
    [anon_sym_bit_set] = ACTIONS(2613),
    [anon_sym_matrix] = ACTIONS(2615),
    [anon_sym_distinct] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_BQUOTE] = ACTIONS(913),
    [sym_uninitialized] = ACTIONS(913),
    [sym_tag] = ACTIONS(2662),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [272] = {
    [sym_procedure] = STATE(4281),
    [sym_type] = STATE(4282),
    [sym_pointer_type] = STATE(4209),
    [sym_variadic_type] = STATE(4209),
    [sym_array_type] = STATE(4209),
    [sym_map_type] = STATE(4209),
    [sym_union_type] = STATE(4209),
    [sym_bit_set_type] = STATE(4209),
    [sym_matrix_type] = STATE(4209),
    [sym_field_type] = STATE(4209),
    [sym_tuple_type] = STATE(4209),
    [sym_struct_type] = STATE(4209),
    [sym_enum_type] = STATE(4209),
    [sym_bit_field_type] = STATE(4209),
    [sym_constant_type] = STATE(4209),
    [sym_specialized_type] = STATE(4209),
    [sym__procedure_type] = STATE(4209),
    [sym_distinct_type] = STATE(4209),
    [sym_empty_type] = STATE(4209),
    [sym_polymorphic_type] = STATE(4209),
    [sym_conditional_type] = STATE(4209),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_proc] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(894),
    [anon_sym_struct] = ACTIONS(2586),
    [anon_sym_enum] = ACTIONS(2588),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_union] = ACTIONS(2590),
    [anon_sym_bit_field] = ACTIONS(2592),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_LPAREN] = ACTIONS(2665),
    [anon_sym_DOLLAR] = ACTIONS(2597),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_when] = ACTIONS(894),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(2599),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_or_else] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_GT_GT] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(2669),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(2604),
    [anon_sym_or_return] = ACTIONS(894),
    [anon_sym_or_continue] = ACTIONS(894),
    [anon_sym_or_break] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(2673),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2609),
    [anon_sym_map] = ACTIONS(2611),
    [anon_sym_bit_set] = ACTIONS(2613),
    [anon_sym_matrix] = ACTIONS(2615),
    [anon_sym_distinct] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(891),
    [anon_sym_BQUOTE] = ACTIONS(891),
    [sym_uninitialized] = ACTIONS(891),
    [sym_tag] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [273] = {
    [sym_procedure] = STATE(4281),
    [sym_type] = STATE(4247),
    [sym_pointer_type] = STATE(4209),
    [sym_variadic_type] = STATE(4209),
    [sym_array_type] = STATE(4209),
    [sym_map_type] = STATE(4209),
    [sym_union_type] = STATE(4209),
    [sym_bit_set_type] = STATE(4209),
    [sym_matrix_type] = STATE(4209),
    [sym_field_type] = STATE(4209),
    [sym_tuple_type] = STATE(4209),
    [sym_struct_type] = STATE(4209),
    [sym_enum_type] = STATE(4209),
    [sym_bit_field_type] = STATE(4209),
    [sym_constant_type] = STATE(4209),
    [sym_specialized_type] = STATE(4209),
    [sym__procedure_type] = STATE(4209),
    [sym_distinct_type] = STATE(4209),
    [sym_empty_type] = STATE(4209),
    [sym_polymorphic_type] = STATE(4209),
    [sym_conditional_type] = STATE(4209),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_proc] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_where] = ACTIONS(818),
    [anon_sym_struct] = ACTIONS(2586),
    [anon_sym_enum] = ACTIONS(2588),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_union] = ACTIONS(2590),
    [anon_sym_bit_field] = ACTIONS(2592),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_LPAREN] = ACTIONS(2681),
    [anon_sym_DOLLAR] = ACTIONS(2597),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_when] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(2599),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_or_else] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(818),
    [anon_sym_DOT_DOT] = ACTIONS(2604),
    [anon_sym_or_return] = ACTIONS(818),
    [anon_sym_or_continue] = ACTIONS(818),
    [anon_sym_or_break] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(2689),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2609),
    [anon_sym_map] = ACTIONS(2611),
    [anon_sym_bit_set] = ACTIONS(2613),
    [anon_sym_matrix] = ACTIONS(2615),
    [anon_sym_distinct] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(815),
    [anon_sym_BQUOTE] = ACTIONS(815),
    [sym_uninitialized] = ACTIONS(815),
    [sym_tag] = ACTIONS(2693),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [274] = {
    [sym_procedure] = STATE(4444),
    [sym_type] = STATE(4436),
    [sym_pointer_type] = STATE(4570),
    [sym_variadic_type] = STATE(4570),
    [sym_array_type] = STATE(4570),
    [sym_map_type] = STATE(4570),
    [sym_union_type] = STATE(4570),
    [sym_bit_set_type] = STATE(4570),
    [sym_matrix_type] = STATE(4570),
    [sym_field_type] = STATE(4570),
    [sym_tuple_type] = STATE(4570),
    [sym_struct_type] = STATE(4570),
    [sym_enum_type] = STATE(4570),
    [sym_bit_field_type] = STATE(4570),
    [sym_constant_type] = STATE(4570),
    [sym_specialized_type] = STATE(4570),
    [sym__procedure_type] = STATE(4570),
    [sym_distinct_type] = STATE(4570),
    [sym_empty_type] = STATE(4570),
    [sym_polymorphic_type] = STATE(4570),
    [sym_conditional_type] = STATE(4570),
    [ts_builtin_sym_end] = ACTIONS(815),
    [sym_identifier] = ACTIONS(2545),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_proc] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(2549),
    [anon_sym_enum] = ACTIONS(2551),
    [anon_sym_union] = ACTIONS(2553),
    [anon_sym_bit_field] = ACTIONS(2555),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_LPAREN] = ACTIONS(2697),
    [anon_sym_DOLLAR] = ACTIONS(2560),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_else] = ACTIONS(818),
    [anon_sym_when] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(818),
    [anon_sym_case] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_or_else] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(2701),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(818),
    [anon_sym_DOT_DOT] = ACTIONS(2567),
    [anon_sym_or_return] = ACTIONS(818),
    [anon_sym_or_continue] = ACTIONS(818),
    [anon_sym_or_break] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(2705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2572),
    [anon_sym_map] = ACTIONS(2574),
    [anon_sym_bit_set] = ACTIONS(2576),
    [anon_sym_matrix] = ACTIONS(2578),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_tag] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(815),
    [sym_block_comment] = ACTIONS(3),
  },
  [275] = {
    [sym_procedure] = STATE(4444),
    [sym_type] = STATE(4509),
    [sym_pointer_type] = STATE(4570),
    [sym_variadic_type] = STATE(4570),
    [sym_array_type] = STATE(4570),
    [sym_map_type] = STATE(4570),
    [sym_union_type] = STATE(4570),
    [sym_bit_set_type] = STATE(4570),
    [sym_matrix_type] = STATE(4570),
    [sym_field_type] = STATE(4570),
    [sym_tuple_type] = STATE(4570),
    [sym_struct_type] = STATE(4570),
    [sym_enum_type] = STATE(4570),
    [sym_bit_field_type] = STATE(4570),
    [sym_constant_type] = STATE(4570),
    [sym_specialized_type] = STATE(4570),
    [sym__procedure_type] = STATE(4570),
    [sym_distinct_type] = STATE(4570),
    [sym_empty_type] = STATE(4570),
    [sym_polymorphic_type] = STATE(4570),
    [sym_conditional_type] = STATE(4570),
    [ts_builtin_sym_end] = ACTIONS(859),
    [sym_identifier] = ACTIONS(2545),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_proc] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_struct] = ACTIONS(2549),
    [anon_sym_enum] = ACTIONS(2551),
    [anon_sym_union] = ACTIONS(2553),
    [anon_sym_bit_field] = ACTIONS(2555),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_LPAREN] = ACTIONS(2709),
    [anon_sym_DOLLAR] = ACTIONS(2560),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_else] = ACTIONS(861),
    [anon_sym_when] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_case] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or_else] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(2712),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(861),
    [anon_sym_DOT_DOT] = ACTIONS(2567),
    [anon_sym_or_return] = ACTIONS(861),
    [anon_sym_or_continue] = ACTIONS(861),
    [anon_sym_or_break] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(2715),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2572),
    [anon_sym_map] = ACTIONS(2574),
    [anon_sym_bit_set] = ACTIONS(2576),
    [anon_sym_matrix] = ACTIONS(2578),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_tag] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(859),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(859),
    [sym_block_comment] = ACTIONS(3),
  },
  [276] = {
    [sym_procedure] = STATE(4444),
    [sym_type] = STATE(4428),
    [sym_pointer_type] = STATE(4570),
    [sym_variadic_type] = STATE(4570),
    [sym_array_type] = STATE(4570),
    [sym_map_type] = STATE(4570),
    [sym_union_type] = STATE(4570),
    [sym_bit_set_type] = STATE(4570),
    [sym_matrix_type] = STATE(4570),
    [sym_field_type] = STATE(4570),
    [sym_tuple_type] = STATE(4570),
    [sym_struct_type] = STATE(4570),
    [sym_enum_type] = STATE(4570),
    [sym_bit_field_type] = STATE(4570),
    [sym_constant_type] = STATE(4570),
    [sym_specialized_type] = STATE(4570),
    [sym__procedure_type] = STATE(4570),
    [sym_distinct_type] = STATE(4570),
    [sym_empty_type] = STATE(4570),
    [sym_polymorphic_type] = STATE(4570),
    [sym_conditional_type] = STATE(4570),
    [ts_builtin_sym_end] = ACTIONS(875),
    [sym_identifier] = ACTIONS(2545),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_proc] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(875),
    [anon_sym_struct] = ACTIONS(2549),
    [anon_sym_enum] = ACTIONS(2551),
    [anon_sym_union] = ACTIONS(2553),
    [anon_sym_bit_field] = ACTIONS(2555),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_LPAREN] = ACTIONS(2718),
    [anon_sym_DOLLAR] = ACTIONS(2560),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_SEMI] = ACTIONS(875),
    [anon_sym_else] = ACTIONS(877),
    [anon_sym_when] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_case] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_or_else] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_TILDE_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(2721),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(875),
    [anon_sym_DOT_DOT_LT] = ACTIONS(875),
    [anon_sym_not_in] = ACTIONS(877),
    [anon_sym_DOT_DOT] = ACTIONS(2567),
    [anon_sym_or_return] = ACTIONS(877),
    [anon_sym_or_continue] = ACTIONS(877),
    [anon_sym_or_break] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(2724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2572),
    [anon_sym_map] = ACTIONS(2574),
    [anon_sym_bit_set] = ACTIONS(2576),
    [anon_sym_matrix] = ACTIONS(2578),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_tag] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(875),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(875),
    [sym_block_comment] = ACTIONS(3),
  },
  [277] = {
    [sym_procedure] = STATE(4444),
    [sym_type] = STATE(4528),
    [sym_pointer_type] = STATE(4570),
    [sym_variadic_type] = STATE(4570),
    [sym_array_type] = STATE(4570),
    [sym_map_type] = STATE(4570),
    [sym_union_type] = STATE(4570),
    [sym_bit_set_type] = STATE(4570),
    [sym_matrix_type] = STATE(4570),
    [sym_field_type] = STATE(4570),
    [sym_tuple_type] = STATE(4570),
    [sym_struct_type] = STATE(4570),
    [sym_enum_type] = STATE(4570),
    [sym_bit_field_type] = STATE(4570),
    [sym_constant_type] = STATE(4570),
    [sym_specialized_type] = STATE(4570),
    [sym__procedure_type] = STATE(4570),
    [sym_distinct_type] = STATE(4570),
    [sym_empty_type] = STATE(4570),
    [sym_polymorphic_type] = STATE(4570),
    [sym_conditional_type] = STATE(4570),
    [ts_builtin_sym_end] = ACTIONS(891),
    [sym_identifier] = ACTIONS(2545),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_proc] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_struct] = ACTIONS(2549),
    [anon_sym_enum] = ACTIONS(2551),
    [anon_sym_union] = ACTIONS(2553),
    [anon_sym_bit_field] = ACTIONS(2555),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_LPAREN] = ACTIONS(2727),
    [anon_sym_DOLLAR] = ACTIONS(2560),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(894),
    [anon_sym_when] = ACTIONS(894),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_case] = ACTIONS(894),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_or_else] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_GT_GT] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(2567),
    [anon_sym_or_return] = ACTIONS(894),
    [anon_sym_or_continue] = ACTIONS(894),
    [anon_sym_or_break] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(2735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2572),
    [anon_sym_map] = ACTIONS(2574),
    [anon_sym_bit_set] = ACTIONS(2576),
    [anon_sym_matrix] = ACTIONS(2578),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_tag] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(891),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(891),
    [sym_block_comment] = ACTIONS(3),
  },
  [278] = {
    [sym_procedure] = STATE(4444),
    [sym_type] = STATE(4432),
    [sym_pointer_type] = STATE(4570),
    [sym_variadic_type] = STATE(4570),
    [sym_array_type] = STATE(4570),
    [sym_map_type] = STATE(4570),
    [sym_union_type] = STATE(4570),
    [sym_bit_set_type] = STATE(4570),
    [sym_matrix_type] = STATE(4570),
    [sym_field_type] = STATE(4570),
    [sym_tuple_type] = STATE(4570),
    [sym_struct_type] = STATE(4570),
    [sym_enum_type] = STATE(4570),
    [sym_bit_field_type] = STATE(4570),
    [sym_constant_type] = STATE(4570),
    [sym_specialized_type] = STATE(4570),
    [sym__procedure_type] = STATE(4570),
    [sym_distinct_type] = STATE(4570),
    [sym_empty_type] = STATE(4570),
    [sym_polymorphic_type] = STATE(4570),
    [sym_conditional_type] = STATE(4570),
    [ts_builtin_sym_end] = ACTIONS(837),
    [sym_identifier] = ACTIONS(2545),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_proc] = ACTIONS(2547),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_struct] = ACTIONS(2549),
    [anon_sym_enum] = ACTIONS(2551),
    [anon_sym_union] = ACTIONS(2553),
    [anon_sym_bit_field] = ACTIONS(2555),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_LPAREN] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(2560),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_when] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_case] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_or_else] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_TILDE_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_STAR] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_DOT_DOT_LT] = ACTIONS(837),
    [anon_sym_not_in] = ACTIONS(840),
    [anon_sym_DOT_DOT] = ACTIONS(2567),
    [anon_sym_or_return] = ACTIONS(840),
    [anon_sym_or_continue] = ACTIONS(840),
    [anon_sym_or_break] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(2747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2572),
    [anon_sym_map] = ACTIONS(2574),
    [anon_sym_bit_set] = ACTIONS(2576),
    [anon_sym_matrix] = ACTIONS(2578),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_tag] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(837),
    [sym__backslash] = ACTIONS(3),
    [sym__nl_comma] = ACTIONS(837),
    [sym_block_comment] = ACTIONS(3),
  },
  [279] = {
    [sym_procedure] = STATE(4281),
    [sym_type] = STATE(4236),
    [sym_pointer_type] = STATE(4209),
    [sym_variadic_type] = STATE(4209),
    [sym_array_type] = STATE(4209),
    [sym_map_type] = STATE(4209),
    [sym_union_type] = STATE(4209),
    [sym_bit_set_type] = STATE(4209),
    [sym_matrix_type] = STATE(4209),
    [sym_field_type] = STATE(4209),
    [sym_tuple_type] = STATE(4209),
    [sym_struct_type] = STATE(4209),
    [sym_enum_type] = STATE(4209),
    [sym_bit_field_type] = STATE(4209),
    [sym_constant_type] = STATE(4209),
    [sym_specialized_type] = STATE(4209),
    [sym__procedure_type] = STATE(4209),
    [sym_distinct_type] = STATE(4209),
    [sym_empty_type] = STATE(4209),
    [sym_polymorphic_type] = STATE(4209),
    [sym_conditional_type] = STATE(4209),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_proc] = ACTIONS(2584),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_where] = ACTIONS(840),
    [anon_sym_struct] = ACTIONS(2586),
    [anon_sym_enum] = ACTIONS(2588),
    [anon_sym_EQ] = ACTIONS(840),
    [anon_sym_union] = ACTIONS(2590),
    [anon_sym_bit_field] = ACTIONS(2592),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_LPAREN] = ACTIONS(2751),
    [anon_sym_DOLLAR] = ACTIONS(2597),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_when] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(2599),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_or_else] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_TILDE_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_STAR] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_DOT_DOT_LT] = ACTIONS(837),
    [anon_sym_not_in] = ACTIONS(840),
    [anon_sym_DOT_DOT] = ACTIONS(2604),
    [anon_sym_or_return] = ACTIONS(840),
    [anon_sym_or_continue] = ACTIONS(840),
    [anon_sym_or_break] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2609),
    [anon_sym_map] = ACTIONS(2611),
    [anon_sym_bit_set] = ACTIONS(2613),
    [anon_sym_matrix] = ACTIONS(2615),
    [anon_sym_distinct] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(837),
    [anon_sym_BQUOTE] = ACTIONS(837),
    [sym_uninitialized] = ACTIONS(837),
    [sym_tag] = ACTIONS(2763),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [280] = {
    [sym_procedure] = STATE(2978),
    [sym_type] = STATE(3145),
    [sym_pointer_type] = STATE(2982),
    [sym_variadic_type] = STATE(2982),
    [sym_array_type] = STATE(2982),
    [sym_map_type] = STATE(2982),
    [sym_union_type] = STATE(2982),
    [sym_bit_set_type] = STATE(2982),
    [sym_matrix_type] = STATE(2982),
    [sym_field_type] = STATE(2982),
    [sym_tuple_type] = STATE(2982),
    [sym_struct_type] = STATE(2982),
    [sym_enum_type] = STATE(2982),
    [sym_bit_field_type] = STATE(2982),
    [sym_constant_type] = STATE(2982),
    [sym_specialized_type] = STATE(2982),
    [sym__procedure_type] = STATE(2982),
    [sym_distinct_type] = STATE(2982),
    [sym_empty_type] = STATE(2982),
    [sym_polymorphic_type] = STATE(2982),
    [sym_conditional_type] = STATE(2982),
    [sym_identifier] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_proc] = ACTIONS(2770),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_where] = ACTIONS(773),
    [anon_sym_struct] = ACTIONS(1679),
    [anon_sym_enum] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_union] = ACTIONS(1683),
    [anon_sym_bit_field] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_RPAREN] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(2772),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_when] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(773),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(1692),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(767),
    [anon_sym_or_else] = ACTIONS(773),
    [anon_sym_AMP_AMP] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(767),
    [anon_sym_LT_LT] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(2774),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(773),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_or_return] = ACTIONS(773),
    [anon_sym_or_continue] = ACTIONS(773),
    [anon_sym_or_break] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(2779),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1702),
    [anon_sym_map] = ACTIONS(2782),
    [anon_sym_bit_set] = ACTIONS(1706),
    [anon_sym_matrix] = ACTIONS(2784),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_uninitialized] = ACTIONS(767),
    [sym_tag] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [281] = {
    [sym_procedure] = STATE(2978),
    [sym_type] = STATE(2981),
    [sym_pointer_type] = STATE(2982),
    [sym_variadic_type] = STATE(2982),
    [sym_array_type] = STATE(2982),
    [sym_map_type] = STATE(2982),
    [sym_union_type] = STATE(2982),
    [sym_bit_set_type] = STATE(2982),
    [sym_matrix_type] = STATE(2982),
    [sym_field_type] = STATE(2982),
    [sym_tuple_type] = STATE(2982),
    [sym_struct_type] = STATE(2982),
    [sym_enum_type] = STATE(2982),
    [sym_bit_field_type] = STATE(2982),
    [sym_constant_type] = STATE(2982),
    [sym_specialized_type] = STATE(2982),
    [sym__procedure_type] = STATE(2982),
    [sym_distinct_type] = STATE(2982),
    [sym_empty_type] = STATE(2982),
    [sym_polymorphic_type] = STATE(2982),
    [sym_conditional_type] = STATE(2982),
    [sym_identifier] = ACTIONS(2789),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_COMMA] = ACTIONS(875),
    [anon_sym_proc] = ACTIONS(2770),
    [anon_sym_DASH_GT] = ACTIONS(875),
    [anon_sym_where] = ACTIONS(877),
    [anon_sym_struct] = ACTIONS(1679),
    [anon_sym_enum] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(877),
    [anon_sym_union] = ACTIONS(1683),
    [anon_sym_bit_field] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(877),
    [anon_sym_LPAREN] = ACTIONS(1687),
    [anon_sym_RPAREN] = ACTIONS(875),
    [anon_sym_DOLLAR] = ACTIONS(2772),
    [anon_sym_if] = ACTIONS(877),
    [anon_sym_when] = ACTIONS(877),
    [anon_sym_in] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_DASH] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_BANG] = ACTIONS(1692),
    [anon_sym_AMP] = ACTIONS(877),
    [anon_sym_PIPE_PIPE] = ACTIONS(875),
    [anon_sym_or_else] = ACTIONS(877),
    [anon_sym_AMP_AMP] = ACTIONS(875),
    [anon_sym_GT] = ACTIONS(877),
    [anon_sym_GT_EQ] = ACTIONS(875),
    [anon_sym_LT_EQ] = ACTIONS(875),
    [anon_sym_LT] = ACTIONS(877),
    [anon_sym_EQ_EQ] = ACTIONS(875),
    [anon_sym_BANG_EQ] = ACTIONS(875),
    [anon_sym_TILDE_EQ] = ACTIONS(875),
    [anon_sym_AMP_TILDE] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(875),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_STAR] = ACTIONS(875),
    [anon_sym_SLASH] = ACTIONS(877),
    [anon_sym_PERCENT] = ACTIONS(877),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(875),
    [anon_sym_DOT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(2792),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(875),
    [anon_sym_DOT_DOT_LT] = ACTIONS(875),
    [anon_sym_not_in] = ACTIONS(877),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_or_return] = ACTIONS(877),
    [anon_sym_or_continue] = ACTIONS(877),
    [anon_sym_or_break] = ACTIONS(877),
    [anon_sym_CARET] = ACTIONS(2795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1702),
    [anon_sym_map] = ACTIONS(2782),
    [anon_sym_bit_set] = ACTIONS(1706),
    [anon_sym_matrix] = ACTIONS(2784),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_uninitialized] = ACTIONS(875),
    [sym_tag] = ACTIONS(2798),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [282] = {
    [sym_procedure] = STATE(2978),
    [sym_type] = STATE(3134),
    [sym_pointer_type] = STATE(2982),
    [sym_variadic_type] = STATE(2982),
    [sym_array_type] = STATE(2982),
    [sym_map_type] = STATE(2982),
    [sym_union_type] = STATE(2982),
    [sym_bit_set_type] = STATE(2982),
    [sym_matrix_type] = STATE(2982),
    [sym_field_type] = STATE(2982),
    [sym_tuple_type] = STATE(2982),
    [sym_struct_type] = STATE(2982),
    [sym_enum_type] = STATE(2982),
    [sym_bit_field_type] = STATE(2982),
    [sym_constant_type] = STATE(2982),
    [sym_specialized_type] = STATE(2982),
    [sym__procedure_type] = STATE(2982),
    [sym_distinct_type] = STATE(2982),
    [sym_empty_type] = STATE(2982),
    [sym_polymorphic_type] = STATE(2982),
    [sym_conditional_type] = STATE(2982),
    [sym_identifier] = ACTIONS(2801),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_proc] = ACTIONS(2770),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(894),
    [anon_sym_struct] = ACTIONS(1679),
    [anon_sym_enum] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_union] = ACTIONS(1683),
    [anon_sym_bit_field] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_DOLLAR] = ACTIONS(2772),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_when] = ACTIONS(894),
    [anon_sym_in] = ACTIONS(894),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_BANG] = ACTIONS(1692),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_or_else] = ACTIONS(894),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_GT_GT] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(2805),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(894),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_or_return] = ACTIONS(894),
    [anon_sym_or_continue] = ACTIONS(894),
    [anon_sym_or_break] = ACTIONS(894),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1702),
    [anon_sym_map] = ACTIONS(2782),
    [anon_sym_bit_set] = ACTIONS(1706),
    [anon_sym_matrix] = ACTIONS(2784),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_uninitialized] = ACTIONS(891),
    [sym_tag] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [283] = {
    [sym_procedure] = STATE(2978),
    [sym_type] = STATE(3020),
    [sym_pointer_type] = STATE(2982),
    [sym_variadic_type] = STATE(2982),
    [sym_array_type] = STATE(2982),
    [sym_map_type] = STATE(2982),
    [sym_union_type] = STATE(2982),
    [sym_bit_set_type] = STATE(2982),
    [sym_matrix_type] = STATE(2982),
    [sym_field_type] = STATE(2982),
    [sym_tuple_type] = STATE(2982),
    [sym_struct_type] = STATE(2982),
    [sym_enum_type] = STATE(2982),
    [sym_bit_field_type] = STATE(2982),
    [sym_constant_type] = STATE(2982),
    [sym_specialized_type] = STATE(2982),
    [sym__procedure_type] = STATE(2982),
    [sym_distinct_type] = STATE(2982),
    [sym_empty_type] = STATE(2982),
    [sym_polymorphic_type] = STATE(2982),
    [sym_conditional_type] = STATE(2982),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_proc] = ACTIONS(2770),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_where] = ACTIONS(818),
    [anon_sym_struct] = ACTIONS(1679),
    [anon_sym_enum] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_union] = ACTIONS(1683),
    [anon_sym_bit_field] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_LPAREN] = ACTIONS(1811),
    [anon_sym_RPAREN] = ACTIONS(815),
    [anon_sym_DOLLAR] = ACTIONS(2772),
    [anon_sym_if] = ACTIONS(818),
    [anon_sym_when] = ACTIONS(818),
    [anon_sym_in] = ACTIONS(818),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_BANG] = ACTIONS(1692),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(815),
    [anon_sym_or_else] = ACTIONS(818),
    [anon_sym_AMP_AMP] = ACTIONS(815),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(2821),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(818),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_or_return] = ACTIONS(818),
    [anon_sym_or_continue] = ACTIONS(818),
    [anon_sym_or_break] = ACTIONS(818),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1702),
    [anon_sym_map] = ACTIONS(2782),
    [anon_sym_bit_set] = ACTIONS(1706),
    [anon_sym_matrix] = ACTIONS(2784),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_uninitialized] = ACTIONS(815),
    [sym_tag] = ACTIONS(2829),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [284] = {
    [sym_procedure] = STATE(2978),
    [sym_type] = STATE(3030),
    [sym_pointer_type] = STATE(2982),
    [sym_variadic_type] = STATE(2982),
    [sym_array_type] = STATE(2982),
    [sym_map_type] = STATE(2982),
    [sym_union_type] = STATE(2982),
    [sym_bit_set_type] = STATE(2982),
    [sym_matrix_type] = STATE(2982),
    [sym_field_type] = STATE(2982),
    [sym_tuple_type] = STATE(2982),
    [sym_struct_type] = STATE(2982),
    [sym_enum_type] = STATE(2982),
    [sym_bit_field_type] = STATE(2982),
    [sym_constant_type] = STATE(2982),
    [sym_specialized_type] = STATE(2982),
    [sym__procedure_type] = STATE(2982),
    [sym_distinct_type] = STATE(2982),
    [sym_empty_type] = STATE(2982),
    [sym_polymorphic_type] = STATE(2982),
    [sym_conditional_type] = STATE(2982),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_proc] = ACTIONS(2770),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_where] = ACTIONS(915),
    [anon_sym_struct] = ACTIONS(1679),
    [anon_sym_enum] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_union] = ACTIONS(1683),
    [anon_sym_bit_field] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_LPAREN] = ACTIONS(1843),
    [anon_sym_RPAREN] = ACTIONS(913),
    [anon_sym_DOLLAR] = ACTIONS(2772),
    [anon_sym_if] = ACTIONS(915),
    [anon_sym_when] = ACTIONS(915),
    [anon_sym_in] = ACTIONS(915),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_BANG] = ACTIONS(1692),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(913),
    [anon_sym_or_else] = ACTIONS(915),
    [anon_sym_AMP_AMP] = ACTIONS(913),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(913),
    [anon_sym_LT_LT] = ACTIONS(913),
    [anon_sym_GT_GT] = ACTIONS(913),
    [anon_sym_STAR] = ACTIONS(913),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(2836),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(915),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_or_return] = ACTIONS(915),
    [anon_sym_or_continue] = ACTIONS(915),
    [anon_sym_or_break] = ACTIONS(915),
    [anon_sym_CARET] = ACTIONS(2839),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1702),
    [anon_sym_map] = ACTIONS(2782),
    [anon_sym_bit_set] = ACTIONS(1706),
    [anon_sym_matrix] = ACTIONS(2784),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_uninitialized] = ACTIONS(913),
    [sym_tag] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [285] = {
    [sym_procedure] = STATE(2978),
    [sym_type] = STATE(2964),
    [sym_pointer_type] = STATE(2982),
    [sym_variadic_type] = STATE(2982),
    [sym_array_type] = STATE(2982),
    [sym_map_type] = STATE(2982),
    [sym_union_type] = STATE(2982),
    [sym_bit_set_type] = STATE(2982),
    [sym_matrix_type] = STATE(2982),
    [sym_field_type] = STATE(2982),
    [sym_tuple_type] = STATE(2982),
    [sym_struct_type] = STATE(2982),
    [sym_enum_type] = STATE(2982),
    [sym_bit_field_type] = STATE(2982),
    [sym_constant_type] = STATE(2982),
    [sym_specialized_type] = STATE(2982),
    [sym__procedure_type] = STATE(2982),
    [sym_distinct_type] = STATE(2982),
    [sym_empty_type] = STATE(2982),
    [sym_polymorphic_type] = STATE(2982),
    [sym_conditional_type] = STATE(2982),
    [sym_identifier] = ACTIONS(2845),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_proc] = ACTIONS(2770),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_where] = ACTIONS(861),
    [anon_sym_struct] = ACTIONS(1679),
    [anon_sym_enum] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_union] = ACTIONS(1683),
    [anon_sym_bit_field] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_LPAREN] = ACTIONS(1895),
    [anon_sym_RPAREN] = ACTIONS(859),
    [anon_sym_DOLLAR] = ACTIONS(2772),
    [anon_sym_if] = ACTIONS(861),
    [anon_sym_when] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_BANG] = ACTIONS(1692),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_or_else] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(2848),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(861),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_or_return] = ACTIONS(861),
    [anon_sym_or_continue] = ACTIONS(861),
    [anon_sym_or_break] = ACTIONS(861),
    [anon_sym_CARET] = ACTIONS(2851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1702),
    [anon_sym_map] = ACTIONS(2782),
    [anon_sym_bit_set] = ACTIONS(1706),
    [anon_sym_matrix] = ACTIONS(2784),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_uninitialized] = ACTIONS(859),
    [sym_tag] = ACTIONS(2854),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [286] = {
    [sym_procedure] = STATE(2978),
    [sym_type] = STATE(2999),
    [sym_pointer_type] = STATE(2982),
    [sym_variadic_type] = STATE(2982),
    [sym_array_type] = STATE(2982),
    [sym_map_type] = STATE(2982),
    [sym_union_type] = STATE(2982),
    [sym_bit_set_type] = STATE(2982),
    [sym_matrix_type] = STATE(2982),
    [sym_field_type] = STATE(2982),
    [sym_tuple_type] = STATE(2982),
    [sym_struct_type] = STATE(2982),
    [sym_enum_type] = STATE(2982),
    [sym_bit_field_type] = STATE(2982),
    [sym_constant_type] = STATE(2982),
    [sym_specialized_type] = STATE(2982),
    [sym__procedure_type] = STATE(2982),
    [sym_distinct_type] = STATE(2982),
    [sym_empty_type] = STATE(2982),
    [sym_polymorphic_type] = STATE(2982),
    [sym_conditional_type] = STATE(2982),
    [sym_identifier] = ACTIONS(2857),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_proc] = ACTIONS(2770),
    [anon_sym_DASH_GT] = ACTIONS(837),
    [anon_sym_where] = ACTIONS(840),
    [anon_sym_struct] = ACTIONS(1679),
    [anon_sym_enum] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(840),
    [anon_sym_union] = ACTIONS(1683),
    [anon_sym_bit_field] = ACTIONS(1685),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_LPAREN] = ACTIONS(1855),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_DOLLAR] = ACTIONS(2772),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_when] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(1692),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(837),
    [anon_sym_or_else] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_TILDE_EQ] = ACTIONS(837),
    [anon_sym_AMP_TILDE] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_STAR] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(840),
    [anon_sym_PERCENT] = ACTIONS(840),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(837),
    [anon_sym_DOT_DOT_LT] = ACTIONS(837),
    [anon_sym_not_in] = ACTIONS(840),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_or_return] = ACTIONS(840),
    [anon_sym_or_continue] = ACTIONS(840),
    [anon_sym_or_break] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(2865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1702),
    [anon_sym_map] = ACTIONS(2782),
    [anon_sym_bit_set] = ACTIONS(1706),
    [anon_sym_matrix] = ACTIONS(2784),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_uninitialized] = ACTIONS(837),
    [sym_tag] = ACTIONS(2869),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [287] = {
    [sym_block] = STATE(7002),
    [sym_attributes] = STATE(2066),
    [sym_attribute] = STATE(6005),
    [sym_assignment_statement] = STATE(9179),
    [sym_update_statement] = STATE(9179),
    [sym__for_in_expression] = STATE(8137),
    [sym_var_declaration] = STATE(9179),
    [sym_expression] = STATE(2789),
    [sym__expression_no_tag] = STATE(2663),
    [sym_unary_expression] = STATE(2663),
    [sym_binary_expression] = STATE(2663),
    [sym_ternary_expression] = STATE(2663),
    [sym_call_expression] = STATE(2663),
    [sym_selector_call_expression] = STATE(2663),
    [sym_member_expression] = STATE(2663),
    [sym_index_expression] = STATE(2663),
    [sym_slice_expression] = STATE(2663),
    [sym_range_expression] = STATE(2663),
    [sym_cast_expression] = STATE(2663),
    [sym_in_expression] = STATE(2663),
    [sym_variadic_expression] = STATE(2663),
    [sym_parenthesized_expression] = STATE(2663),
    [sym_or_return_expression] = STATE(2663),
    [sym_or_continue_expression] = STATE(2663),
    [sym_or_break_expression] = STATE(2663),
    [sym_address] = STATE(2663),
    [sym_map_type] = STATE(2663),
    [sym_matrix_type] = STATE(2663),
    [sym_distinct_type] = STATE(2663),
    [sym_literal] = STATE(2663),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(2875),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_in] = ACTIONS(2879),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [288] = {
    [sym_block] = STATE(7002),
    [sym_attributes] = STATE(2066),
    [sym_attribute] = STATE(6005),
    [sym_assignment_statement] = STATE(8779),
    [sym_update_statement] = STATE(8779),
    [sym__for_in_expression] = STATE(8376),
    [sym_var_declaration] = STATE(8779),
    [sym_expression] = STATE(2781),
    [sym__expression_no_tag] = STATE(2663),
    [sym_unary_expression] = STATE(2663),
    [sym_binary_expression] = STATE(2663),
    [sym_ternary_expression] = STATE(2663),
    [sym_call_expression] = STATE(2663),
    [sym_selector_call_expression] = STATE(2663),
    [sym_member_expression] = STATE(2663),
    [sym_index_expression] = STATE(2663),
    [sym_slice_expression] = STATE(2663),
    [sym_range_expression] = STATE(2663),
    [sym_cast_expression] = STATE(2663),
    [sym_in_expression] = STATE(2663),
    [sym_variadic_expression] = STATE(2663),
    [sym_parenthesized_expression] = STATE(2663),
    [sym_or_return_expression] = STATE(2663),
    [sym_or_continue_expression] = STATE(2663),
    [sym_or_break_expression] = STATE(2663),
    [sym_address] = STATE(2663),
    [sym_map_type] = STATE(2663),
    [sym_matrix_type] = STATE(2663),
    [sym_distinct_type] = STATE(2663),
    [sym_literal] = STATE(2663),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym_do] = ACTIONS(2889),
    [anon_sym_in] = ACTIONS(2879),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [289] = {
    [sym_procedure] = STATE(7022),
    [sym_expression] = STATE(4833),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_pointer_type] = STATE(6850),
    [sym_array_type] = STATE(6850),
    [sym_map_type] = STATE(4596),
    [sym_bit_set_type] = STATE(6850),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_proc] = ACTIONS(2891),
    [anon_sym_struct] = ACTIONS(2893),
    [anon_sym_enum] = ACTIONS(2895),
    [anon_sym_union] = ACTIONS(2897),
    [anon_sym_bit_field] = ACTIONS(2899),
    [anon_sym_POUNDtype] = ACTIONS(599),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_CARET] = ACTIONS(2905),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(615),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(2907),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [290] = {
    [sym_procedure] = STATE(7166),
    [sym_expression] = STATE(4845),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_pointer_type] = STATE(6894),
    [sym_array_type] = STATE(6894),
    [sym_map_type] = STATE(4596),
    [sym_bit_set_type] = STATE(6894),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_proc] = ACTIONS(2909),
    [anon_sym_struct] = ACTIONS(2911),
    [anon_sym_enum] = ACTIONS(2913),
    [anon_sym_union] = ACTIONS(2915),
    [anon_sym_bit_field] = ACTIONS(2917),
    [anon_sym_POUNDtype] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_CARET] = ACTIONS(2905),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(615),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(2921),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [291] = {
    [sym_procedure] = STATE(4444),
    [sym_expression] = STATE(4842),
    [sym__expression_no_tag] = STATE(4440),
    [sym_unary_expression] = STATE(4440),
    [sym_binary_expression] = STATE(4440),
    [sym_ternary_expression] = STATE(4440),
    [sym_call_expression] = STATE(4440),
    [sym_selector_call_expression] = STATE(4440),
    [sym_member_expression] = STATE(4440),
    [sym_index_expression] = STATE(4440),
    [sym_slice_expression] = STATE(4440),
    [sym_range_expression] = STATE(4440),
    [sym_cast_expression] = STATE(4440),
    [sym_in_expression] = STATE(4440),
    [sym_variadic_expression] = STATE(4440),
    [sym_parenthesized_expression] = STATE(4440),
    [sym_or_return_expression] = STATE(4440),
    [sym_or_continue_expression] = STATE(4440),
    [sym_or_break_expression] = STATE(4440),
    [sym_address] = STATE(4440),
    [sym_map_type] = STATE(4440),
    [sym_matrix_type] = STATE(4440),
    [sym__procedure_type] = STATE(6900),
    [sym_distinct_type] = STATE(4440),
    [sym_literal] = STATE(4440),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [ts_builtin_sym_end] = ACTIONS(2923),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [anon_sym_proc] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_else] = ACTIONS(2925),
    [anon_sym_case] = ACTIONS(2925),
    [anon_sym_QMARK] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2923),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [292] = {
    [sym_procedure] = STATE(4444),
    [sym_expression] = STATE(4821),
    [sym__expression_no_tag] = STATE(4440),
    [sym_unary_expression] = STATE(4440),
    [sym_binary_expression] = STATE(4440),
    [sym_ternary_expression] = STATE(4440),
    [sym_call_expression] = STATE(4440),
    [sym_selector_call_expression] = STATE(4440),
    [sym_member_expression] = STATE(4440),
    [sym_index_expression] = STATE(4440),
    [sym_slice_expression] = STATE(4440),
    [sym_range_expression] = STATE(4440),
    [sym_cast_expression] = STATE(4440),
    [sym_in_expression] = STATE(4440),
    [sym_variadic_expression] = STATE(4440),
    [sym_parenthesized_expression] = STATE(4440),
    [sym_or_return_expression] = STATE(4440),
    [sym_or_continue_expression] = STATE(4440),
    [sym_or_break_expression] = STATE(4440),
    [sym_address] = STATE(4440),
    [sym_map_type] = STATE(4440),
    [sym_matrix_type] = STATE(4440),
    [sym__procedure_type] = STATE(6834),
    [sym_distinct_type] = STATE(4440),
    [sym_literal] = STATE(4440),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [ts_builtin_sym_end] = ACTIONS(2929),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_RBRACE] = ACTIONS(2929),
    [anon_sym_proc] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym_else] = ACTIONS(2931),
    [anon_sym_case] = ACTIONS(2931),
    [anon_sym_QMARK] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(2933),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2929),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [293] = {
    [sym_procedure] = STATE(7396),
    [sym_expression] = STATE(5830),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7489),
    [sym_array_type] = STATE(7489),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7468),
    [sym__procedure_type] = STATE(9068),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2935),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [294] = {
    [sym_block] = STATE(7061),
    [sym_attributes] = STATE(1736),
    [sym_attribute] = STATE(6005),
    [sym_update_statement] = STATE(8068),
    [sym__simple_assignment_statement] = STATE(8068),
    [sym_expression] = STATE(2940),
    [sym__expression_no_tag] = STATE(2663),
    [sym_unary_expression] = STATE(2663),
    [sym_binary_expression] = STATE(2663),
    [sym_ternary_expression] = STATE(2663),
    [sym_call_expression] = STATE(2663),
    [sym_selector_call_expression] = STATE(2663),
    [sym_member_expression] = STATE(2663),
    [sym_index_expression] = STATE(2663),
    [sym_slice_expression] = STATE(2663),
    [sym_range_expression] = STATE(2663),
    [sym_cast_expression] = STATE(2663),
    [sym_in_expression] = STATE(2663),
    [sym_variadic_expression] = STATE(2663),
    [sym_parenthesized_expression] = STATE(2663),
    [sym_or_return_expression] = STATE(2663),
    [sym_or_continue_expression] = STATE(2663),
    [sym_or_break_expression] = STATE(2663),
    [sym_address] = STATE(2663),
    [sym_map_type] = STATE(2663),
    [sym_matrix_type] = STATE(2663),
    [sym_distinct_type] = STATE(2663),
    [sym_literal] = STATE(2663),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_do] = ACTIONS(2949),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [295] = {
    [sym_procedure] = STATE(7430),
    [sym_expression] = STATE(5796),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7424),
    [sym_array_type] = STATE(7424),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7406),
    [sym__procedure_type] = STATE(8760),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [296] = {
    [sym_procedure] = STATE(4444),
    [sym_expression] = STATE(4842),
    [sym__expression_no_tag] = STATE(4440),
    [sym_unary_expression] = STATE(4440),
    [sym_binary_expression] = STATE(4440),
    [sym_ternary_expression] = STATE(4440),
    [sym_call_expression] = STATE(4440),
    [sym_selector_call_expression] = STATE(4440),
    [sym_member_expression] = STATE(4440),
    [sym_index_expression] = STATE(4440),
    [sym_slice_expression] = STATE(4440),
    [sym_range_expression] = STATE(4440),
    [sym_cast_expression] = STATE(4440),
    [sym_in_expression] = STATE(4440),
    [sym_variadic_expression] = STATE(4440),
    [sym_parenthesized_expression] = STATE(4440),
    [sym_or_return_expression] = STATE(4440),
    [sym_or_continue_expression] = STATE(4440),
    [sym_or_break_expression] = STATE(4440),
    [sym_address] = STATE(4440),
    [sym_map_type] = STATE(4440),
    [sym_matrix_type] = STATE(4440),
    [sym__procedure_type] = STATE(6900),
    [sym_distinct_type] = STATE(4440),
    [sym_literal] = STATE(4440),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [ts_builtin_sym_end] = ACTIONS(2953),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_RBRACE] = ACTIONS(2953),
    [anon_sym_proc] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(2953),
    [anon_sym_else] = ACTIONS(2955),
    [anon_sym_case] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2953),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [297] = {
    [sym_procedure] = STATE(7505),
    [sym_expression] = STATE(5801),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7513),
    [sym_array_type] = STATE(7513),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7474),
    [sym__procedure_type] = STATE(8894),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2957),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [298] = {
    [sym_procedure] = STATE(7553),
    [sym_expression] = STATE(5826),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7556),
    [sym_array_type] = STATE(7556),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7502),
    [sym__procedure_type] = STATE(9039),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [299] = {
    [sym_procedure] = STATE(7514),
    [sym_expression] = STATE(5792),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7438),
    [sym_array_type] = STATE(7438),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7569),
    [sym__procedure_type] = STATE(8756),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2961),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [300] = {
    [sym_block] = STATE(7061),
    [sym_attributes] = STATE(1736),
    [sym_attribute] = STATE(6005),
    [sym_update_statement] = STATE(8127),
    [sym__simple_assignment_statement] = STATE(8127),
    [sym_expression] = STATE(2950),
    [sym__expression_no_tag] = STATE(2663),
    [sym_unary_expression] = STATE(2663),
    [sym_binary_expression] = STATE(2663),
    [sym_ternary_expression] = STATE(2663),
    [sym_call_expression] = STATE(2663),
    [sym_selector_call_expression] = STATE(2663),
    [sym_member_expression] = STATE(2663),
    [sym_index_expression] = STATE(2663),
    [sym_slice_expression] = STATE(2663),
    [sym_range_expression] = STATE(2663),
    [sym_cast_expression] = STATE(2663),
    [sym_in_expression] = STATE(2663),
    [sym_variadic_expression] = STATE(2663),
    [sym_parenthesized_expression] = STATE(2663),
    [sym_or_return_expression] = STATE(2663),
    [sym_or_continue_expression] = STATE(2663),
    [sym_or_break_expression] = STATE(2663),
    [sym_address] = STATE(2663),
    [sym_map_type] = STATE(2663),
    [sym_matrix_type] = STATE(2663),
    [sym_distinct_type] = STATE(2663),
    [sym_literal] = STATE(2663),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(2873),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_do] = ACTIONS(2965),
    [anon_sym_QMARK] = ACTIONS(2881),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [301] = {
    [sym_procedure] = STATE(7428),
    [sym_expression] = STATE(5824),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7547),
    [sym_array_type] = STATE(7547),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7527),
    [sym__procedure_type] = STATE(8756),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [302] = {
    [sym_procedure] = STATE(4444),
    [sym_expression] = STATE(4842),
    [sym__expression_no_tag] = STATE(4440),
    [sym_unary_expression] = STATE(4440),
    [sym_binary_expression] = STATE(4440),
    [sym_ternary_expression] = STATE(4440),
    [sym_call_expression] = STATE(4440),
    [sym_selector_call_expression] = STATE(4440),
    [sym_member_expression] = STATE(4440),
    [sym_index_expression] = STATE(4440),
    [sym_slice_expression] = STATE(4440),
    [sym_range_expression] = STATE(4440),
    [sym_cast_expression] = STATE(4440),
    [sym_in_expression] = STATE(4440),
    [sym_variadic_expression] = STATE(4440),
    [sym_parenthesized_expression] = STATE(4440),
    [sym_or_return_expression] = STATE(4440),
    [sym_or_continue_expression] = STATE(4440),
    [sym_or_break_expression] = STATE(4440),
    [sym_address] = STATE(4440),
    [sym_map_type] = STATE(4440),
    [sym_matrix_type] = STATE(4440),
    [sym__procedure_type] = STATE(6900),
    [sym_distinct_type] = STATE(4440),
    [sym_literal] = STATE(4440),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [ts_builtin_sym_end] = ACTIONS(2969),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_RBRACE] = ACTIONS(2969),
    [anon_sym_proc] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_SEMI] = ACTIONS(2969),
    [anon_sym_else] = ACTIONS(2971),
    [anon_sym_case] = ACTIONS(2971),
    [anon_sym_QMARK] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2969),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [303] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [304] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2975),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [305] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2977),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [306] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [307] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2981),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [308] = {
    [sym_attributes] = STATE(2066),
    [sym_attribute] = STATE(6005),
    [sym_assignment_statement] = STATE(9244),
    [sym_update_statement] = STATE(9244),
    [sym_var_declaration] = STATE(9244),
    [sym_expression] = STATE(2935),
    [sym__expression_no_tag] = STATE(2725),
    [sym_unary_expression] = STATE(2725),
    [sym_binary_expression] = STATE(2725),
    [sym_ternary_expression] = STATE(2725),
    [sym_call_expression] = STATE(2725),
    [sym_selector_call_expression] = STATE(2725),
    [sym_member_expression] = STATE(2725),
    [sym_index_expression] = STATE(2725),
    [sym_slice_expression] = STATE(2725),
    [sym_range_expression] = STATE(2725),
    [sym_cast_expression] = STATE(2725),
    [sym_in_expression] = STATE(2725),
    [sym_variadic_expression] = STATE(2725),
    [sym_parenthesized_expression] = STATE(2725),
    [sym_or_return_expression] = STATE(2725),
    [sym_or_continue_expression] = STATE(2725),
    [sym_or_break_expression] = STATE(2725),
    [sym_address] = STATE(2725),
    [sym_map_type] = STATE(2725),
    [sym_matrix_type] = STATE(2725),
    [sym_distinct_type] = STATE(2725),
    [sym_literal] = STATE(2725),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(2991),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [309] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [310] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2995),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [311] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2997),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [312] = {
    [sym_procedure] = STATE(7557),
    [sym_expression] = STATE(5808),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7557),
    [sym_array_type] = STATE(7557),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7557),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2999),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [313] = {
    [sym_procedure] = STATE(7568),
    [sym_expression] = STATE(5828),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7568),
    [sym_array_type] = STATE(7568),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7568),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [314] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3001),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [315] = {
    [sym_procedure] = STATE(7462),
    [sym_expression] = STATE(5831),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7462),
    [sym_array_type] = STATE(7462),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7462),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3003),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [316] = {
    [sym_procedure] = STATE(7569),
    [sym_expression] = STATE(5815),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7569),
    [sym_array_type] = STATE(7569),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7569),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2961),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [317] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3005),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [318] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [319] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3009),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [320] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3011),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [321] = {
    [sym_block] = STATE(7159),
    [sym_attributes] = STATE(1736),
    [sym_attribute] = STATE(6005),
    [sym_update_statement] = STATE(8181),
    [sym__simple_assignment_statement] = STATE(8181),
    [sym_expression] = STATE(3566),
    [sym__expression_no_tag] = STATE(2777),
    [sym_unary_expression] = STATE(2777),
    [sym_binary_expression] = STATE(2777),
    [sym_ternary_expression] = STATE(2777),
    [sym_call_expression] = STATE(2777),
    [sym_selector_call_expression] = STATE(2777),
    [sym_member_expression] = STATE(2777),
    [sym_index_expression] = STATE(2777),
    [sym_slice_expression] = STATE(2777),
    [sym_range_expression] = STATE(2777),
    [sym_cast_expression] = STATE(2777),
    [sym_in_expression] = STATE(2777),
    [sym_variadic_expression] = STATE(2777),
    [sym_parenthesized_expression] = STATE(2777),
    [sym_or_return_expression] = STATE(2777),
    [sym_or_continue_expression] = STATE(2777),
    [sym_or_break_expression] = STATE(2777),
    [sym_address] = STATE(2777),
    [sym_map_type] = STATE(2777),
    [sym_matrix_type] = STATE(2777),
    [sym_distinct_type] = STATE(2777),
    [sym_literal] = STATE(2777),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [322] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [323] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3025),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [324] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [325] = {
    [sym_block] = STATE(7170),
    [sym_attributes] = STATE(1736),
    [sym_attribute] = STATE(6005),
    [sym_update_statement] = STATE(8033),
    [sym__simple_assignment_statement] = STATE(8033),
    [sym_expression] = STATE(3566),
    [sym__expression_no_tag] = STATE(2777),
    [sym_unary_expression] = STATE(2777),
    [sym_binary_expression] = STATE(2777),
    [sym_ternary_expression] = STATE(2777),
    [sym_call_expression] = STATE(2777),
    [sym_selector_call_expression] = STATE(2777),
    [sym_member_expression] = STATE(2777),
    [sym_index_expression] = STATE(2777),
    [sym_slice_expression] = STATE(2777),
    [sym_range_expression] = STATE(2777),
    [sym_cast_expression] = STATE(2777),
    [sym_in_expression] = STATE(2777),
    [sym_variadic_expression] = STATE(2777),
    [sym_parenthesized_expression] = STATE(2777),
    [sym_or_return_expression] = STATE(2777),
    [sym_or_continue_expression] = STATE(2777),
    [sym_or_break_expression] = STATE(2777),
    [sym_address] = STATE(2777),
    [sym_map_type] = STATE(2777),
    [sym_matrix_type] = STATE(2777),
    [sym_distinct_type] = STATE(2777),
    [sym_literal] = STATE(2777),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(3029),
    [anon_sym_QMARK] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [326] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [327] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3033),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [328] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [329] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3037),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [330] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [331] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3041),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [332] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [333] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [334] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [335] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3049),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [336] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [337] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3053),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [338] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [339] = {
    [sym_procedure] = STATE(7532),
    [sym_expression] = STATE(5788),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7532),
    [sym_array_type] = STATE(7532),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7532),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3057),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [340] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [341] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3061),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [342] = {
    [sym_procedure] = STATE(7390),
    [sym_expression] = STATE(5790),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7390),
    [sym_array_type] = STATE(7390),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7390),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [343] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [344] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3065),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [345] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [346] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3069),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [347] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [348] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [349] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [350] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3077),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [351] = {
    [sym_procedure] = STATE(7415),
    [sym_expression] = STATE(5819),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7415),
    [sym_array_type] = STATE(7415),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7415),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3079),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [352] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3081),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [353] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3083),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [354] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3085),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [355] = {
    [sym_procedure] = STATE(7457),
    [sym_expression] = STATE(5840),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7457),
    [sym_array_type] = STATE(7457),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7457),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [356] = {
    [sym_procedure] = STATE(7487),
    [sym_expression] = STATE(5803),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7487),
    [sym_array_type] = STATE(7487),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7487),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [357] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [358] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3093),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [359] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [360] = {
    [sym_procedure] = STATE(7473),
    [sym_expression] = STATE(5837),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7473),
    [sym_array_type] = STATE(7473),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7473),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3097),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [361] = {
    [sym_procedure] = STATE(7399),
    [sym_expression] = STATE(5833),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7399),
    [sym_array_type] = STATE(7399),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7399),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [362] = {
    [sym_procedure] = STATE(7490),
    [sym_expression] = STATE(5818),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7490),
    [sym_array_type] = STATE(7490),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7490),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [363] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3103),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [364] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3105),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [365] = {
    [sym_procedure] = STATE(7526),
    [sym_expression] = STATE(5810),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7526),
    [sym_array_type] = STATE(7526),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7526),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [366] = {
    [sym_procedure] = STATE(7432),
    [sym_expression] = STATE(5799),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7432),
    [sym_array_type] = STATE(7432),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7432),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [367] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3111),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [368] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [369] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [370] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3117),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [371] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [372] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3121),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [373] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [374] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3125),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [375] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [376] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3129),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [377] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [378] = {
    [sym_procedure] = STATE(7384),
    [sym_expression] = STATE(5850),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7384),
    [sym_array_type] = STATE(7384),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7384),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3133),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [379] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3135),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [380] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3137),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [381] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [382] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3141),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [383] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3143),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [384] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3145),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [385] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3147),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [386] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3149),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [387] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3151),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [388] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3153),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [389] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3155),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [390] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3157),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [391] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3159),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [392] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3161),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [393] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [394] = {
    [sym_procedure] = STATE(7415),
    [sym_expression] = STATE(5819),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7415),
    [sym_array_type] = STATE(7415),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7415),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3167),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [395] = {
    [sym_procedure] = STATE(7483),
    [sym_expression] = STATE(5806),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7483),
    [sym_array_type] = STATE(7483),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7483),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3169),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [396] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [397] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3173),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [398] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3175),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [399] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3177),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [400] = {
    [sym_procedure] = STATE(7550),
    [sym_expression] = STATE(5821),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7550),
    [sym_array_type] = STATE(7550),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7550),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3179),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [401] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [402] = {
    [sym_block] = STATE(7184),
    [sym_attributes] = STATE(1736),
    [sym_attribute] = STATE(6005),
    [sym_update_statement] = STATE(8108),
    [sym__simple_assignment_statement] = STATE(8108),
    [sym_expression] = STATE(3566),
    [sym__expression_no_tag] = STATE(2777),
    [sym_unary_expression] = STATE(2777),
    [sym_binary_expression] = STATE(2777),
    [sym_ternary_expression] = STATE(2777),
    [sym_call_expression] = STATE(2777),
    [sym_selector_call_expression] = STATE(2777),
    [sym_member_expression] = STATE(2777),
    [sym_index_expression] = STATE(2777),
    [sym_slice_expression] = STATE(2777),
    [sym_range_expression] = STATE(2777),
    [sym_cast_expression] = STATE(2777),
    [sym_in_expression] = STATE(2777),
    [sym_variadic_expression] = STATE(2777),
    [sym_parenthesized_expression] = STATE(2777),
    [sym_or_return_expression] = STATE(2777),
    [sym_or_continue_expression] = STATE(2777),
    [sym_or_break_expression] = STATE(2777),
    [sym_address] = STATE(2777),
    [sym_map_type] = STATE(2777),
    [sym_matrix_type] = STATE(2777),
    [sym_distinct_type] = STATE(2777),
    [sym_literal] = STATE(2777),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(3183),
    [anon_sym_QMARK] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [403] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3185),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [404] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3187),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [405] = {
    [sym_block] = STATE(7206),
    [sym_attributes] = STATE(1736),
    [sym_attribute] = STATE(6005),
    [sym_update_statement] = STATE(8100),
    [sym__simple_assignment_statement] = STATE(8100),
    [sym_expression] = STATE(3566),
    [sym__expression_no_tag] = STATE(2777),
    [sym_unary_expression] = STATE(2777),
    [sym_binary_expression] = STATE(2777),
    [sym_ternary_expression] = STATE(2777),
    [sym_call_expression] = STATE(2777),
    [sym_selector_call_expression] = STATE(2777),
    [sym_member_expression] = STATE(2777),
    [sym_index_expression] = STATE(2777),
    [sym_slice_expression] = STATE(2777),
    [sym_range_expression] = STATE(2777),
    [sym_cast_expression] = STATE(2777),
    [sym_in_expression] = STATE(2777),
    [sym_variadic_expression] = STATE(2777),
    [sym_parenthesized_expression] = STATE(2777),
    [sym_or_return_expression] = STATE(2777),
    [sym_or_continue_expression] = STATE(2777),
    [sym_or_break_expression] = STATE(2777),
    [sym_address] = STATE(2777),
    [sym_map_type] = STATE(2777),
    [sym_matrix_type] = STATE(2777),
    [sym_distinct_type] = STATE(2777),
    [sym_literal] = STATE(2777),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(3189),
    [anon_sym_QMARK] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [406] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3191),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [407] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [408] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3195),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [409] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3197),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [410] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3199),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [411] = {
    [sym_block] = STATE(7170),
    [sym_attributes] = STATE(1736),
    [sym_attribute] = STATE(6005),
    [sym_update_statement] = STATE(8091),
    [sym__simple_assignment_statement] = STATE(8091),
    [sym_expression] = STATE(3566),
    [sym__expression_no_tag] = STATE(2777),
    [sym_unary_expression] = STATE(2777),
    [sym_binary_expression] = STATE(2777),
    [sym_ternary_expression] = STATE(2777),
    [sym_call_expression] = STATE(2777),
    [sym_selector_call_expression] = STATE(2777),
    [sym_member_expression] = STATE(2777),
    [sym_index_expression] = STATE(2777),
    [sym_slice_expression] = STATE(2777),
    [sym_range_expression] = STATE(2777),
    [sym_cast_expression] = STATE(2777),
    [sym_in_expression] = STATE(2777),
    [sym_variadic_expression] = STATE(2777),
    [sym_parenthesized_expression] = STATE(2777),
    [sym_or_return_expression] = STATE(2777),
    [sym_or_continue_expression] = STATE(2777),
    [sym_or_break_expression] = STATE(2777),
    [sym_address] = STATE(2777),
    [sym_map_type] = STATE(2777),
    [sym_matrix_type] = STATE(2777),
    [sym_distinct_type] = STATE(2777),
    [sym_literal] = STATE(2777),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(3201),
    [anon_sym_QMARK] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [412] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3203),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [413] = {
    [sym_block] = STATE(7159),
    [sym_attributes] = STATE(1736),
    [sym_attribute] = STATE(6005),
    [sym_update_statement] = STATE(8088),
    [sym__simple_assignment_statement] = STATE(8088),
    [sym_expression] = STATE(3566),
    [sym__expression_no_tag] = STATE(2777),
    [sym_unary_expression] = STATE(2777),
    [sym_binary_expression] = STATE(2777),
    [sym_ternary_expression] = STATE(2777),
    [sym_call_expression] = STATE(2777),
    [sym_selector_call_expression] = STATE(2777),
    [sym_member_expression] = STATE(2777),
    [sym_index_expression] = STATE(2777),
    [sym_slice_expression] = STATE(2777),
    [sym_range_expression] = STATE(2777),
    [sym_cast_expression] = STATE(2777),
    [sym_in_expression] = STATE(2777),
    [sym_variadic_expression] = STATE(2777),
    [sym_parenthesized_expression] = STATE(2777),
    [sym_or_return_expression] = STATE(2777),
    [sym_or_continue_expression] = STATE(2777),
    [sym_or_break_expression] = STATE(2777),
    [sym_address] = STATE(2777),
    [sym_map_type] = STATE(2777),
    [sym_matrix_type] = STATE(2777),
    [sym_distinct_type] = STATE(2777),
    [sym_literal] = STATE(2777),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(3205),
    [anon_sym_QMARK] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [414] = {
    [sym_block] = STATE(7046),
    [sym_attributes] = STATE(1736),
    [sym_attribute] = STATE(6005),
    [sym_update_statement] = STATE(8081),
    [sym__simple_assignment_statement] = STATE(8081),
    [sym_expression] = STATE(3566),
    [sym__expression_no_tag] = STATE(2777),
    [sym_unary_expression] = STATE(2777),
    [sym_binary_expression] = STATE(2777),
    [sym_ternary_expression] = STATE(2777),
    [sym_call_expression] = STATE(2777),
    [sym_selector_call_expression] = STATE(2777),
    [sym_member_expression] = STATE(2777),
    [sym_index_expression] = STATE(2777),
    [sym_slice_expression] = STATE(2777),
    [sym_range_expression] = STATE(2777),
    [sym_cast_expression] = STATE(2777),
    [sym_in_expression] = STATE(2777),
    [sym_variadic_expression] = STATE(2777),
    [sym_parenthesized_expression] = STATE(2777),
    [sym_or_return_expression] = STATE(2777),
    [sym_or_continue_expression] = STATE(2777),
    [sym_or_break_expression] = STATE(2777),
    [sym_address] = STATE(2777),
    [sym_map_type] = STATE(2777),
    [sym_matrix_type] = STATE(2777),
    [sym_distinct_type] = STATE(2777),
    [sym_literal] = STATE(2777),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(3207),
    [anon_sym_QMARK] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [415] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [416] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3211),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [417] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3213),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [418] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3215),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [419] = {
    [sym_procedure] = STATE(7567),
    [sym_expression] = STATE(5823),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7567),
    [sym_array_type] = STATE(7567),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7567),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3217),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [420] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3219),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [421] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3221),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [422] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3223),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [423] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3225),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [424] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3227),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [425] = {
    [sym_procedure] = STATE(7392),
    [sym_expression] = STATE(5795),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7392),
    [sym_array_type] = STATE(7392),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7392),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3229),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [426] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3231),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [427] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3233),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [428] = {
    [sym_procedure] = STATE(7468),
    [sym_expression] = STATE(5794),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7468),
    [sym_array_type] = STATE(7468),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7468),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2935),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [429] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3235),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [430] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3237),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [431] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3239),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [432] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3241),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [433] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3243),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [434] = {
    [sym_procedure] = STATE(7410),
    [sym_expression] = STATE(5844),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7410),
    [sym_array_type] = STATE(7410),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7410),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2961),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [435] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3245),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [436] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3247),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [437] = {
    [sym_procedure] = STATE(7440),
    [sym_expression] = STATE(5848),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7440),
    [sym_array_type] = STATE(7440),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7440),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3249),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [438] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3251),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [439] = {
    [sym_procedure] = STATE(7496),
    [sym_expression] = STATE(5836),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7496),
    [sym_array_type] = STATE(7496),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7496),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [440] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3253),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [441] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3255),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [442] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3257),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [443] = {
    [sym_procedure] = STATE(7527),
    [sym_expression] = STATE(5797),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7527),
    [sym_array_type] = STATE(7527),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7527),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [444] = {
    [sym_procedure] = STATE(7406),
    [sym_expression] = STATE(5839),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7406),
    [sym_array_type] = STATE(7406),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7406),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [445] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3259),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [446] = {
    [sym_block] = STATE(7046),
    [sym_attributes] = STATE(1736),
    [sym_attribute] = STATE(6005),
    [sym_update_statement] = STATE(7838),
    [sym__simple_assignment_statement] = STATE(7838),
    [sym_expression] = STATE(3566),
    [sym__expression_no_tag] = STATE(2777),
    [sym_unary_expression] = STATE(2777),
    [sym_binary_expression] = STATE(2777),
    [sym_ternary_expression] = STATE(2777),
    [sym_call_expression] = STATE(2777),
    [sym_selector_call_expression] = STATE(2777),
    [sym_member_expression] = STATE(2777),
    [sym_index_expression] = STATE(2777),
    [sym_slice_expression] = STATE(2777),
    [sym_range_expression] = STATE(2777),
    [sym_cast_expression] = STATE(2777),
    [sym_in_expression] = STATE(2777),
    [sym_variadic_expression] = STATE(2777),
    [sym_parenthesized_expression] = STATE(2777),
    [sym_or_return_expression] = STATE(2777),
    [sym_or_continue_expression] = STATE(2777),
    [sym_or_break_expression] = STATE(2777),
    [sym_address] = STATE(2777),
    [sym_map_type] = STATE(2777),
    [sym_matrix_type] = STATE(2777),
    [sym_distinct_type] = STATE(2777),
    [sym_literal] = STATE(2777),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(3261),
    [anon_sym_QMARK] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [447] = {
    [sym_procedure] = STATE(7563),
    [sym_expression] = STATE(5786),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7563),
    [sym_array_type] = STATE(7563),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7563),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3263),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [448] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3265),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [449] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3267),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [450] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3269),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [451] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3271),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [452] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3273),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [453] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3275),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [454] = {
    [sym_attributes] = STATE(2066),
    [sym_attribute] = STATE(6005),
    [sym_assignment_statement] = STATE(8776),
    [sym_update_statement] = STATE(8776),
    [sym_var_declaration] = STATE(8776),
    [sym_expression] = STATE(2946),
    [sym__expression_no_tag] = STATE(2725),
    [sym_unary_expression] = STATE(2725),
    [sym_binary_expression] = STATE(2725),
    [sym_ternary_expression] = STATE(2725),
    [sym_call_expression] = STATE(2725),
    [sym_selector_call_expression] = STATE(2725),
    [sym_member_expression] = STATE(2725),
    [sym_index_expression] = STATE(2725),
    [sym_slice_expression] = STATE(2725),
    [sym_range_expression] = STATE(2725),
    [sym_cast_expression] = STATE(2725),
    [sym_in_expression] = STATE(2725),
    [sym_variadic_expression] = STATE(2725),
    [sym_parenthesized_expression] = STATE(2725),
    [sym_or_return_expression] = STATE(2725),
    [sym_or_continue_expression] = STATE(2725),
    [sym_or_break_expression] = STATE(2725),
    [sym_address] = STATE(2725),
    [sym_map_type] = STATE(2725),
    [sym_matrix_type] = STATE(2725),
    [sym_distinct_type] = STATE(2725),
    [sym_literal] = STATE(2725),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_SEMI] = ACTIONS(3277),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(3279),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [455] = {
    [sym_procedure] = STATE(7550),
    [sym_expression] = STATE(5821),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7550),
    [sym_array_type] = STATE(7550),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7550),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(3281),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3283),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [456] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [457] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3287),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [458] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3289),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [459] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [460] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3293),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [461] = {
    [sym_procedure] = STATE(7399),
    [sym_expression] = STATE(5833),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7399),
    [sym_array_type] = STATE(7399),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7399),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(3295),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3297),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [462] = {
    [sym_procedure] = STATE(7474),
    [sym_expression] = STATE(5789),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7474),
    [sym_array_type] = STATE(7474),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7474),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2957),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [463] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3299),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [464] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3301),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [465] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3303),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [466] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3305),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [467] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3307),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [468] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3309),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [469] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3311),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [470] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3313),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [471] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3315),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [472] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3317),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [473] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3319),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [474] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3321),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [475] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3323),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [476] = {
    [sym_block] = STATE(7184),
    [sym_attributes] = STATE(1736),
    [sym_attribute] = STATE(6005),
    [sym_update_statement] = STATE(7632),
    [sym__simple_assignment_statement] = STATE(7632),
    [sym_expression] = STATE(3566),
    [sym__expression_no_tag] = STATE(2777),
    [sym_unary_expression] = STATE(2777),
    [sym_binary_expression] = STATE(2777),
    [sym_ternary_expression] = STATE(2777),
    [sym_call_expression] = STATE(2777),
    [sym_selector_call_expression] = STATE(2777),
    [sym_member_expression] = STATE(2777),
    [sym_index_expression] = STATE(2777),
    [sym_slice_expression] = STATE(2777),
    [sym_range_expression] = STATE(2777),
    [sym_cast_expression] = STATE(2777),
    [sym_in_expression] = STATE(2777),
    [sym_variadic_expression] = STATE(2777),
    [sym_parenthesized_expression] = STATE(2777),
    [sym_or_return_expression] = STATE(2777),
    [sym_or_continue_expression] = STATE(2777),
    [sym_or_break_expression] = STATE(2777),
    [sym_address] = STATE(2777),
    [sym_map_type] = STATE(2777),
    [sym_matrix_type] = STATE(2777),
    [sym_distinct_type] = STATE(2777),
    [sym_literal] = STATE(2777),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(3325),
    [anon_sym_QMARK] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [477] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3327),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [478] = {
    [sym_procedure] = STATE(7525),
    [sym_expression] = STATE(5832),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7525),
    [sym_array_type] = STATE(7525),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7525),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2957),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [479] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3329),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [480] = {
    [sym_procedure] = STATE(7477),
    [sym_expression] = STATE(5842),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7477),
    [sym_array_type] = STATE(7477),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7477),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3331),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [481] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3333),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [482] = {
    [sym_procedure] = STATE(7502),
    [sym_expression] = STATE(5847),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7502),
    [sym_array_type] = STATE(7502),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7502),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [483] = {
    [sym_procedure] = STATE(7544),
    [sym_expression] = STATE(5825),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7544),
    [sym_array_type] = STATE(7544),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7544),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3335),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [484] = {
    [sym_procedure] = STATE(7487),
    [sym_expression] = STATE(5803),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7487),
    [sym_array_type] = STATE(7487),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7487),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(3337),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3339),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [485] = {
    [sym_block] = STATE(7206),
    [sym_attributes] = STATE(1736),
    [sym_attribute] = STATE(6005),
    [sym_update_statement] = STATE(7617),
    [sym__simple_assignment_statement] = STATE(7617),
    [sym_expression] = STATE(3566),
    [sym__expression_no_tag] = STATE(2777),
    [sym_unary_expression] = STATE(2777),
    [sym_binary_expression] = STATE(2777),
    [sym_ternary_expression] = STATE(2777),
    [sym_call_expression] = STATE(2777),
    [sym_selector_call_expression] = STATE(2777),
    [sym_member_expression] = STATE(2777),
    [sym_index_expression] = STATE(2777),
    [sym_slice_expression] = STATE(2777),
    [sym_range_expression] = STATE(2777),
    [sym_cast_expression] = STATE(2777),
    [sym_in_expression] = STATE(2777),
    [sym_variadic_expression] = STATE(2777),
    [sym_parenthesized_expression] = STATE(2777),
    [sym_or_return_expression] = STATE(2777),
    [sym_or_continue_expression] = STATE(2777),
    [sym_or_break_expression] = STATE(2777),
    [sym_address] = STATE(2777),
    [sym_map_type] = STATE(2777),
    [sym_matrix_type] = STATE(2777),
    [sym_distinct_type] = STATE(2777),
    [sym_literal] = STATE(2777),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(3341),
    [anon_sym_QMARK] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [486] = {
    [sym_procedure] = STATE(7526),
    [sym_expression] = STATE(5810),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7526),
    [sym_array_type] = STATE(7526),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7526),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(3343),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3345),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [487] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3347),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [488] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3349),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [489] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [490] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3353),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [491] = {
    [sym_procedure] = STATE(7392),
    [sym_expression] = STATE(5795),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7392),
    [sym_array_type] = STATE(7392),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7392),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3355),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [492] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3357),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [493] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3359),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [494] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3361),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [495] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3363),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [496] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3365),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [497] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3367),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [498] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3369),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [499] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_RPAREN] = ACTIONS(3371),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [500] = {
    [sym_procedure] = STATE(7825),
    [sym_expression] = STATE(5927),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7825),
    [sym_array_type] = STATE(7825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_struct_type] = STATE(7825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [501] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6169),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(9039),
    [sym_array_type] = STATE(9039),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(9039),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [502] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6226),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(8756),
    [sym_array_type] = STATE(8756),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(8756),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [503] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6349),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(8775),
    [sym_array_type] = STATE(8775),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(8775),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [504] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6163),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(9107),
    [sym_array_type] = STATE(9107),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(9107),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [505] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6451),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(8663),
    [sym_array_type] = STATE(8663),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(8663),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [506] = {
    [sym_attributes] = STATE(2086),
    [sym_attribute] = STATE(6005),
    [sym_assignment_statement] = STATE(8359),
    [sym_expression] = STATE(5765),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(3373),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_in] = ACTIONS(3375),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [507] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6434),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(9143),
    [sym_array_type] = STATE(9143),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(9143),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [508] = {
    [sym_attributes] = STATE(1538),
    [sym_attribute] = STATE(6005),
    [sym_assignment_statement] = STATE(9317),
    [sym_expression] = STATE(4990),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(3381),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [509] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6381),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(9256),
    [sym_array_type] = STATE(9256),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(9256),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [510] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6199),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(8940),
    [sym_array_type] = STATE(8940),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(8940),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [511] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6187),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(8825),
    [sym_array_type] = STATE(8825),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(8825),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [512] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6163),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(8894),
    [sym_array_type] = STATE(8894),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(8894),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [513] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6169),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(9011),
    [sym_array_type] = STATE(9011),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(9011),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [514] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6226),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(8787),
    [sym_array_type] = STATE(8787),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(8787),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [515] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6270),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(8681),
    [sym_array_type] = STATE(8681),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(8681),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [516] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6451),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(8760),
    [sym_array_type] = STATE(8760),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(8760),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [517] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6052),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(9063),
    [sym_array_type] = STATE(9063),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(9063),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [518] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6270),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(8900),
    [sym_array_type] = STATE(8900),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(8900),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [519] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6439),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(8741),
    [sym_array_type] = STATE(8741),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(8741),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [520] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6210),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(9068),
    [sym_array_type] = STATE(9068),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(9068),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [521] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6434),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(8742),
    [sym_array_type] = STATE(8742),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(8742),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [522] = {
    [sym_procedure] = STATE(6922),
    [sym_expression] = STATE(4909),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(3383),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_SEMI] = ACTIONS(3383),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3383),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [523] = {
    [sym_procedure] = STATE(6922),
    [sym_expression] = STATE(4909),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(3385),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_SEMI] = ACTIONS(3385),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3385),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [524] = {
    [sym_procedure] = STATE(6922),
    [sym_expression] = STATE(4909),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(3387),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_SEMI] = ACTIONS(3387),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3387),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [525] = {
    [sym_procedure] = STATE(6922),
    [sym_expression] = STATE(4909),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(3389),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_SEMI] = ACTIONS(3389),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3389),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [526] = {
    [sym_expression] = STATE(4840),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_pointer_type] = STATE(6890),
    [sym_array_type] = STATE(6890),
    [sym_map_type] = STATE(4596),
    [sym_bit_set_type] = STATE(6890),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_POUNDtype] = ACTIONS(619),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_CARET] = ACTIONS(2905),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(615),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [527] = {
    [sym_attributes] = STATE(2086),
    [sym_attribute] = STATE(6005),
    [sym_assignment_statement] = STATE(8056),
    [sym_expression] = STATE(5711),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [aux_sym_attributes_repeat1] = STATE(6005),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_AT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [528] = {
    [sym_switch_case] = STATE(7533),
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8361),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [aux_sym_switch_statement_repeat1] = STATE(7533),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_case] = ACTIONS(3395),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [529] = {
    [sym_switch_case] = STATE(7590),
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8361),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [aux_sym_switch_statement_repeat1] = STATE(7590),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(3397),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_case] = ACTIONS(3395),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [530] = {
    [sym_expression] = STATE(4932),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_pointer_type] = STATE(6910),
    [sym_array_type] = STATE(6910),
    [sym_map_type] = STATE(4596),
    [sym_bit_set_type] = STATE(6910),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_POUNDtype] = ACTIONS(3399),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_CARET] = ACTIONS(2905),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(615),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [531] = {
    [sym_expression] = STATE(4833),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_pointer_type] = STATE(6850),
    [sym_array_type] = STATE(6850),
    [sym_map_type] = STATE(4596),
    [sym_bit_set_type] = STATE(6850),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_POUNDtype] = ACTIONS(599),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_CARET] = ACTIONS(2905),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(615),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(3401),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [532] = {
    [sym_switch_case] = STATE(7517),
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8361),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [aux_sym_switch_statement_repeat1] = STATE(7517),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(3403),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_case] = ACTIONS(3395),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [533] = {
    [sym_expression] = STATE(6256),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3405),
    [anon_sym_QMARK] = ACTIONS(3407),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3409),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3411),
    [anon_sym_dynamic] = ACTIONS(3413),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [534] = {
    [sym_block] = STATE(2176),
    [sym_where_clause] = STATE(996),
    [ts_builtin_sym_end] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_else] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(3427),
    [sym_tag] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3415),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [535] = {
    [sym_expression] = STATE(6409),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3431),
    [anon_sym_QMARK] = ACTIONS(3433),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3435),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3437),
    [anon_sym_dynamic] = ACTIONS(3439),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [536] = {
    [sym_expression] = STATE(6153),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3441),
    [anon_sym_QMARK] = ACTIONS(3443),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3445),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3447),
    [anon_sym_dynamic] = ACTIONS(3449),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [537] = {
    [sym_expression] = STATE(6160),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3451),
    [anon_sym_QMARK] = ACTIONS(3453),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3455),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3457),
    [anon_sym_dynamic] = ACTIONS(3459),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [538] = {
    [sym_expression] = STATE(6108),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3461),
    [anon_sym_QMARK] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3465),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3467),
    [anon_sym_dynamic] = ACTIONS(3469),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [539] = {
    [sym_expression] = STATE(6146),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3471),
    [anon_sym_QMARK] = ACTIONS(3473),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3475),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3477),
    [anon_sym_dynamic] = ACTIONS(3479),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [540] = {
    [sym_expression] = STATE(6182),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3481),
    [anon_sym_QMARK] = ACTIONS(3483),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3485),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3487),
    [anon_sym_dynamic] = ACTIONS(3489),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [541] = {
    [sym_expression] = STATE(6138),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3491),
    [anon_sym_QMARK] = ACTIONS(3493),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3495),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3497),
    [anon_sym_dynamic] = ACTIONS(3499),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [542] = {
    [sym_expression] = STATE(6147),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3501),
    [anon_sym_QMARK] = ACTIONS(3503),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3505),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_dynamic] = ACTIONS(3509),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [543] = {
    [sym_expression] = STATE(6129),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3511),
    [anon_sym_QMARK] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3515),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3517),
    [anon_sym_dynamic] = ACTIONS(3519),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [544] = {
    [sym_expression] = STATE(6124),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3521),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3525),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3527),
    [anon_sym_dynamic] = ACTIONS(3529),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [545] = {
    [sym_expression] = STATE(6161),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3531),
    [anon_sym_QMARK] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3535),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3537),
    [anon_sym_dynamic] = ACTIONS(3539),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [546] = {
    [sym_expression] = STATE(6133),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3541),
    [anon_sym_QMARK] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3545),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_dynamic] = ACTIONS(3549),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [547] = {
    [sym_expression] = STATE(6117),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_QMARK] = ACTIONS(3553),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3555),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3557),
    [anon_sym_dynamic] = ACTIONS(3559),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [548] = {
    [sym_expression] = STATE(6186),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3561),
    [anon_sym_QMARK] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3565),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3567),
    [anon_sym_dynamic] = ACTIONS(3569),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [549] = {
    [sym_expression] = STATE(6389),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3571),
    [anon_sym_QMARK] = ACTIONS(3573),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3575),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3577),
    [anon_sym_dynamic] = ACTIONS(3579),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [550] = {
    [sym_expression] = STATE(6188),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3581),
    [anon_sym_QMARK] = ACTIONS(3583),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3585),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_dynamic] = ACTIONS(3589),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [551] = {
    [sym_expression] = STATE(6337),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3591),
    [anon_sym_QMARK] = ACTIONS(3593),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3595),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3597),
    [anon_sym_dynamic] = ACTIONS(3599),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [552] = {
    [sym_expression] = STATE(6112),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3601),
    [anon_sym_QMARK] = ACTIONS(3603),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3605),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3607),
    [anon_sym_dynamic] = ACTIONS(3609),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [553] = {
    [sym_expression] = STATE(6119),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3611),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3615),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3617),
    [anon_sym_dynamic] = ACTIONS(3619),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [554] = {
    [sym_expression] = STATE(6107),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3621),
    [anon_sym_QMARK] = ACTIONS(3623),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3625),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3627),
    [anon_sym_dynamic] = ACTIONS(3629),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [555] = {
    [sym_expression] = STATE(6097),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3631),
    [anon_sym_QMARK] = ACTIONS(3633),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3637),
    [anon_sym_dynamic] = ACTIONS(3639),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [556] = {
    [sym_expression] = STATE(6207),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3641),
    [anon_sym_QMARK] = ACTIONS(3643),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3645),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3647),
    [anon_sym_dynamic] = ACTIONS(3649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [557] = {
    [sym_expression] = STATE(6059),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3655),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3657),
    [anon_sym_dynamic] = ACTIONS(3659),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [558] = {
    [sym_expression] = STATE(6095),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3661),
    [anon_sym_QMARK] = ACTIONS(3663),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3665),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3667),
    [anon_sym_dynamic] = ACTIONS(3669),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [559] = {
    [sym_block] = STATE(2440),
    [sym_where_clause] = STATE(1131),
    [ts_builtin_sym_end] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_DASH_GT] = ACTIONS(3671),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_PLUS_EQ] = ACTIONS(3671),
    [anon_sym_DASH_EQ] = ACTIONS(3671),
    [anon_sym_STAR_EQ] = ACTIONS(3671),
    [anon_sym_SLASH_EQ] = ACTIONS(3671),
    [anon_sym_PERCENT_EQ] = ACTIONS(3671),
    [anon_sym_AMP_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_CARET_EQ] = ACTIONS(3671),
    [anon_sym_LT_LT_EQ] = ACTIONS(3671),
    [anon_sym_GT_GT_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_if] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_else] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3671),
    [anon_sym_case] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_or_else] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_GT] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3671),
    [anon_sym_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_SLASH] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3671),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3671),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3671),
    [anon_sym_not_in] = ACTIONS(3671),
    [anon_sym_or_return] = ACTIONS(3671),
    [anon_sym_or_continue] = ACTIONS(3671),
    [anon_sym_or_break] = ACTIONS(3671),
    [anon_sym_CARET] = ACTIONS(3675),
    [sym_uninitialized] = ACTIONS(3677),
    [sym_tag] = ACTIONS(3679),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3671),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [560] = {
    [sym_expression] = STATE(6211),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3681),
    [anon_sym_QMARK] = ACTIONS(3683),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3685),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3687),
    [anon_sym_dynamic] = ACTIONS(3689),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [561] = {
    [sym_expression] = STATE(6088),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3691),
    [anon_sym_QMARK] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3695),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3697),
    [anon_sym_dynamic] = ACTIONS(3699),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [562] = {
    [sym_expression] = STATE(6215),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(3703),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3705),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3707),
    [anon_sym_dynamic] = ACTIONS(3709),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [563] = {
    [sym_expression] = STATE(6230),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3711),
    [anon_sym_QMARK] = ACTIONS(3713),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3715),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3717),
    [anon_sym_dynamic] = ACTIONS(3719),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [564] = {
    [sym_expression] = STATE(6096),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3721),
    [anon_sym_QMARK] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3725),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3727),
    [anon_sym_dynamic] = ACTIONS(3729),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [565] = {
    [sym_expression] = STATE(6267),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3731),
    [anon_sym_QMARK] = ACTIONS(3733),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3735),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3737),
    [anon_sym_dynamic] = ACTIONS(3739),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [566] = {
    [sym_expression] = STATE(6080),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3741),
    [anon_sym_QMARK] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3745),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3747),
    [anon_sym_dynamic] = ACTIONS(3749),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [567] = {
    [sym_expression] = STATE(6069),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3751),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3755),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3757),
    [anon_sym_dynamic] = ACTIONS(3759),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [568] = {
    [sym_expression] = STATE(6086),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3765),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3767),
    [anon_sym_dynamic] = ACTIONS(3769),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [569] = {
    [sym_expression] = STATE(6236),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3771),
    [anon_sym_QMARK] = ACTIONS(3773),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3775),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3777),
    [anon_sym_dynamic] = ACTIONS(3779),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [570] = {
    [sym_block] = STATE(2178),
    [sym_where_clause] = STATE(937),
    [ts_builtin_sym_end] = ACTIONS(3781),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3783),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(3785),
    [anon_sym_COLON] = ACTIONS(3785),
    [anon_sym_PIPE] = ACTIONS(3785),
    [anon_sym_COLON_EQ] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_else] = ACTIONS(3781),
    [anon_sym_when] = ACTIONS(3781),
    [anon_sym_in] = ACTIONS(3781),
    [anon_sym_case] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(3785),
    [anon_sym_PIPE_PIPE] = ACTIONS(3785),
    [anon_sym_or_else] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3785),
    [anon_sym_GT] = ACTIONS(3785),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3781),
    [anon_sym_LT] = ACTIONS(3785),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE] = ACTIONS(3785),
    [anon_sym_LT_LT] = ACTIONS(3785),
    [anon_sym_GT_GT] = ACTIONS(3785),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_SLASH] = ACTIONS(3785),
    [anon_sym_PERCENT] = ACTIONS(3785),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3781),
    [anon_sym_not_in] = ACTIONS(3781),
    [anon_sym_or_return] = ACTIONS(3781),
    [anon_sym_or_continue] = ACTIONS(3781),
    [anon_sym_or_break] = ACTIONS(3781),
    [anon_sym_CARET] = ACTIONS(3785),
    [sym_uninitialized] = ACTIONS(3787),
    [sym_tag] = ACTIONS(3789),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3781),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [571] = {
    [sym_expression] = STATE(6067),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3791),
    [anon_sym_QMARK] = ACTIONS(3793),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3795),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3797),
    [anon_sym_dynamic] = ACTIONS(3799),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [572] = {
    [sym_expression] = STATE(6261),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3801),
    [anon_sym_QMARK] = ACTIONS(3803),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3805),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3807),
    [anon_sym_dynamic] = ACTIONS(3809),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [573] = {
    [sym_expression] = STATE(6060),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3811),
    [anon_sym_QMARK] = ACTIONS(3813),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3815),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3817),
    [anon_sym_dynamic] = ACTIONS(3819),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [574] = {
    [sym_expression] = STATE(6068),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3821),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3825),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3827),
    [anon_sym_dynamic] = ACTIONS(3829),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [575] = {
    [sym_expression] = STATE(6057),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3831),
    [anon_sym_QMARK] = ACTIONS(3833),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3835),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3837),
    [anon_sym_dynamic] = ACTIONS(3839),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [576] = {
    [sym_expression] = STATE(6391),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3841),
    [anon_sym_QMARK] = ACTIONS(3843),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3845),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3847),
    [anon_sym_dynamic] = ACTIONS(3849),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [577] = {
    [sym_expression] = STATE(6275),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3851),
    [anon_sym_QMARK] = ACTIONS(3853),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3855),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3857),
    [anon_sym_dynamic] = ACTIONS(3859),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [578] = {
    [sym_expression] = STATE(6051),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3861),
    [anon_sym_QMARK] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3865),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3867),
    [anon_sym_dynamic] = ACTIONS(3869),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [579] = {
    [sym_expression] = STATE(6367),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3871),
    [anon_sym_QMARK] = ACTIONS(3873),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3875),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3877),
    [anon_sym_dynamic] = ACTIONS(3879),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [580] = {
    [sym_expression] = STATE(6049),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3881),
    [anon_sym_QMARK] = ACTIONS(3883),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3885),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3887),
    [anon_sym_dynamic] = ACTIONS(3889),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [581] = {
    [sym_expression] = STATE(5856),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(7606),
    [sym_array_type] = STATE(7606),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [582] = {
    [sym_expression] = STATE(6263),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3893),
    [anon_sym_QMARK] = ACTIONS(3895),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3897),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3899),
    [anon_sym_dynamic] = ACTIONS(3901),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [583] = {
    [sym_expression] = STATE(6386),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3903),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3907),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3909),
    [anon_sym_dynamic] = ACTIONS(3911),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [584] = {
    [sym_expression] = STATE(6281),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3913),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3917),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3919),
    [anon_sym_dynamic] = ACTIONS(3921),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [585] = {
    [sym_expression] = STATE(6279),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3923),
    [anon_sym_QMARK] = ACTIONS(3925),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3927),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3929),
    [anon_sym_dynamic] = ACTIONS(3931),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [586] = {
    [sym_expression] = STATE(6247),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3933),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3937),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3939),
    [anon_sym_dynamic] = ACTIONS(3941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [587] = {
    [sym_expression] = STATE(6048),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3943),
    [anon_sym_QMARK] = ACTIONS(3945),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3947),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3949),
    [anon_sym_dynamic] = ACTIONS(3951),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [588] = {
    [sym_expression] = STATE(6085),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3953),
    [anon_sym_QMARK] = ACTIONS(3955),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3957),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3959),
    [anon_sym_dynamic] = ACTIONS(3961),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [589] = {
    [sym_expression] = STATE(6098),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3963),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3967),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3969),
    [anon_sym_dynamic] = ACTIONS(3971),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [590] = {
    [sym_expression] = STATE(6101),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3973),
    [anon_sym_QMARK] = ACTIONS(3975),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3977),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3979),
    [anon_sym_dynamic] = ACTIONS(3981),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [591] = {
    [sym_expression] = STATE(6242),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3983),
    [anon_sym_QMARK] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3987),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3989),
    [anon_sym_dynamic] = ACTIONS(3991),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [592] = {
    [sym_expression] = STATE(6122),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3995),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(3997),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3999),
    [anon_sym_dynamic] = ACTIONS(4001),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [593] = {
    [sym_expression] = STATE(6130),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4007),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4009),
    [anon_sym_dynamic] = ACTIONS(4011),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [594] = {
    [sym_expression] = STATE(6313),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4013),
    [anon_sym_QMARK] = ACTIONS(4015),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4017),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4019),
    [anon_sym_dynamic] = ACTIONS(4021),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [595] = {
    [sym_block] = STATE(2429),
    [sym_where_clause] = STATE(1124),
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(4027),
    [sym_tag] = ACTIONS(4029),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4023),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [596] = {
    [sym_block] = STATE(2429),
    [sym_where_clause] = STATE(1124),
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(4027),
    [sym_tag] = ACTIONS(4031),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4023),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [597] = {
    [sym_block] = STATE(2429),
    [sym_where_clause] = STATE(1124),
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(4027),
    [sym_tag] = ACTIONS(4031),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4023),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [598] = {
    [sym_expression] = STATE(6132),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4033),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4037),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4039),
    [anon_sym_dynamic] = ACTIONS(4041),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [599] = {
    [sym_expression] = STATE(6422),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4045),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4047),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4049),
    [anon_sym_dynamic] = ACTIONS(4051),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [600] = {
    [sym_expression] = STATE(6259),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4053),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4057),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4059),
    [anon_sym_dynamic] = ACTIONS(4061),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [601] = {
    [sym_expression] = STATE(6221),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4063),
    [anon_sym_QMARK] = ACTIONS(4065),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4067),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4069),
    [anon_sym_dynamic] = ACTIONS(4071),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [602] = {
    [sym_expression] = STATE(6245),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4073),
    [anon_sym_QMARK] = ACTIONS(4075),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4077),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4079),
    [anon_sym_dynamic] = ACTIONS(4081),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [603] = {
    [sym_block] = STATE(2404),
    [sym_where_clause] = STATE(1106),
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(4087),
    [sym_tag] = ACTIONS(4089),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4083),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [604] = {
    [sym_block] = STATE(2404),
    [sym_where_clause] = STATE(1106),
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(4087),
    [sym_tag] = ACTIONS(4091),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4083),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [605] = {
    [sym_expression] = STATE(6139),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4093),
    [anon_sym_QMARK] = ACTIONS(4095),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4097),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4099),
    [anon_sym_dynamic] = ACTIONS(4101),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [606] = {
    [sym_block] = STATE(2404),
    [sym_where_clause] = STATE(1106),
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(4087),
    [sym_tag] = ACTIONS(4091),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4083),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [607] = {
    [sym_expression] = STATE(6427),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4103),
    [anon_sym_QMARK] = ACTIONS(4105),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4107),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4109),
    [anon_sym_dynamic] = ACTIONS(4111),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [608] = {
    [sym_block] = STATE(2182),
    [sym_where_clause] = STATE(911),
    [ts_builtin_sym_end] = ACTIONS(4113),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(4113),
    [anon_sym_COMMA] = ACTIONS(4113),
    [anon_sym_COLON_COLON] = ACTIONS(4113),
    [anon_sym_DASH_GT] = ACTIONS(4115),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4117),
    [anon_sym_COLON] = ACTIONS(4117),
    [anon_sym_PIPE] = ACTIONS(4117),
    [anon_sym_COLON_EQ] = ACTIONS(4113),
    [anon_sym_LPAREN] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4113),
    [anon_sym_DASH_EQ] = ACTIONS(4113),
    [anon_sym_STAR_EQ] = ACTIONS(4113),
    [anon_sym_SLASH_EQ] = ACTIONS(4113),
    [anon_sym_PERCENT_EQ] = ACTIONS(4113),
    [anon_sym_AMP_EQ] = ACTIONS(4113),
    [anon_sym_PIPE_EQ] = ACTIONS(4113),
    [anon_sym_CARET_EQ] = ACTIONS(4113),
    [anon_sym_LT_LT_EQ] = ACTIONS(4113),
    [anon_sym_GT_GT_EQ] = ACTIONS(4113),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4113),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4113),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4113),
    [anon_sym_if] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_else] = ACTIONS(4113),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_in] = ACTIONS(4113),
    [anon_sym_case] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4117),
    [anon_sym_DASH] = ACTIONS(4117),
    [anon_sym_TILDE] = ACTIONS(4117),
    [anon_sym_AMP] = ACTIONS(4117),
    [anon_sym_PIPE_PIPE] = ACTIONS(4117),
    [anon_sym_or_else] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4117),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4113),
    [anon_sym_TILDE_EQ] = ACTIONS(4113),
    [anon_sym_AMP_TILDE] = ACTIONS(4117),
    [anon_sym_LT_LT] = ACTIONS(4117),
    [anon_sym_GT_GT] = ACTIONS(4117),
    [anon_sym_STAR] = ACTIONS(4117),
    [anon_sym_SLASH] = ACTIONS(4117),
    [anon_sym_PERCENT] = ACTIONS(4117),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(4117),
    [anon_sym_LBRACK] = ACTIONS(4113),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4113),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4113),
    [anon_sym_not_in] = ACTIONS(4113),
    [anon_sym_or_return] = ACTIONS(4113),
    [anon_sym_or_continue] = ACTIONS(4113),
    [anon_sym_or_break] = ACTIONS(4113),
    [anon_sym_CARET] = ACTIONS(4117),
    [sym_uninitialized] = ACTIONS(4119),
    [sym_tag] = ACTIONS(4121),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4113),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [609] = {
    [sym_expression] = STATE(6284),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4123),
    [anon_sym_QMARK] = ACTIONS(4125),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4127),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4129),
    [anon_sym_dynamic] = ACTIONS(4131),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [610] = {
    [sym_expression] = STATE(6201),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4133),
    [anon_sym_QMARK] = ACTIONS(4135),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4137),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4139),
    [anon_sym_dynamic] = ACTIONS(4141),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [611] = {
    [sym_block] = STATE(1044),
    [sym_where_clause] = STATE(703),
    [ts_builtin_sym_end] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_DASH_GT] = ACTIONS(3671),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_PLUS_EQ] = ACTIONS(3671),
    [anon_sym_DASH_EQ] = ACTIONS(3671),
    [anon_sym_STAR_EQ] = ACTIONS(3671),
    [anon_sym_SLASH_EQ] = ACTIONS(3671),
    [anon_sym_PERCENT_EQ] = ACTIONS(3671),
    [anon_sym_AMP_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_CARET_EQ] = ACTIONS(3671),
    [anon_sym_LT_LT_EQ] = ACTIONS(3671),
    [anon_sym_GT_GT_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_if] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_else] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3671),
    [anon_sym_case] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_or_else] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_GT] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3671),
    [anon_sym_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_SLASH] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3671),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3671),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3671),
    [anon_sym_not_in] = ACTIONS(3671),
    [anon_sym_or_return] = ACTIONS(3671),
    [anon_sym_or_continue] = ACTIONS(3671),
    [anon_sym_or_break] = ACTIONS(3671),
    [anon_sym_CARET] = ACTIONS(3675),
    [sym_uninitialized] = ACTIONS(4145),
    [sym_tag] = ACTIONS(4147),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3671),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [612] = {
    [sym_expression] = STATE(6454),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4149),
    [anon_sym_QMARK] = ACTIONS(4151),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4153),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4155),
    [anon_sym_dynamic] = ACTIONS(4157),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [613] = {
    [sym_expression] = STATE(6323),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4159),
    [anon_sym_QMARK] = ACTIONS(4161),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4163),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4165),
    [anon_sym_dynamic] = ACTIONS(4167),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [614] = {
    [sym_expression] = STATE(6338),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4169),
    [anon_sym_QMARK] = ACTIONS(4171),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4173),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4175),
    [anon_sym_dynamic] = ACTIONS(4177),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [615] = {
    [sym_block] = STATE(1045),
    [sym_where_clause] = STATE(696),
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(4179),
    [sym_tag] = ACTIONS(4181),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4023),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [616] = {
    [sym_block] = STATE(1045),
    [sym_where_clause] = STATE(696),
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(4179),
    [sym_tag] = ACTIONS(4183),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4023),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [617] = {
    [aux_sym_field_type_repeat1] = STATE(664),
    [ts_builtin_sym_end] = ACTIONS(4185),
    [anon_sym_LBRACE] = ACTIONS(4185),
    [anon_sym_RBRACE] = ACTIONS(4185),
    [anon_sym_COMMA] = ACTIONS(4185),
    [anon_sym_COLON_COLON] = ACTIONS(4185),
    [anon_sym_DASH_GT] = ACTIONS(4185),
    [anon_sym_where] = ACTIONS(4185),
    [anon_sym_EQ] = ACTIONS(4187),
    [anon_sym_COLON] = ACTIONS(4187),
    [anon_sym_PIPE] = ACTIONS(4187),
    [anon_sym_COLON_EQ] = ACTIONS(4185),
    [anon_sym_LPAREN] = ACTIONS(4185),
    [anon_sym_PLUS_EQ] = ACTIONS(4185),
    [anon_sym_DASH_EQ] = ACTIONS(4185),
    [anon_sym_STAR_EQ] = ACTIONS(4185),
    [anon_sym_SLASH_EQ] = ACTIONS(4185),
    [anon_sym_PERCENT_EQ] = ACTIONS(4185),
    [anon_sym_AMP_EQ] = ACTIONS(4185),
    [anon_sym_PIPE_EQ] = ACTIONS(4185),
    [anon_sym_CARET_EQ] = ACTIONS(4185),
    [anon_sym_LT_LT_EQ] = ACTIONS(4185),
    [anon_sym_GT_GT_EQ] = ACTIONS(4185),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4185),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4185),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4185),
    [anon_sym_if] = ACTIONS(4185),
    [anon_sym_SEMI] = ACTIONS(4185),
    [anon_sym_else] = ACTIONS(4185),
    [anon_sym_when] = ACTIONS(4185),
    [anon_sym_in] = ACTIONS(4185),
    [anon_sym_case] = ACTIONS(4185),
    [anon_sym_QMARK] = ACTIONS(4185),
    [anon_sym_PLUS] = ACTIONS(4187),
    [anon_sym_DASH] = ACTIONS(4187),
    [anon_sym_TILDE] = ACTIONS(4187),
    [anon_sym_AMP] = ACTIONS(4187),
    [anon_sym_PIPE_PIPE] = ACTIONS(4187),
    [anon_sym_or_else] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4187),
    [anon_sym_GT] = ACTIONS(4187),
    [anon_sym_GT_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4185),
    [anon_sym_LT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4185),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_TILDE_EQ] = ACTIONS(4185),
    [anon_sym_AMP_TILDE] = ACTIONS(4187),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_STAR] = ACTIONS(4187),
    [anon_sym_SLASH] = ACTIONS(4187),
    [anon_sym_PERCENT] = ACTIONS(4187),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4185),
    [anon_sym_DOT] = ACTIONS(4187),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4185),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4185),
    [anon_sym_not_in] = ACTIONS(4185),
    [anon_sym_or_return] = ACTIONS(4185),
    [anon_sym_or_continue] = ACTIONS(4185),
    [anon_sym_or_break] = ACTIONS(4185),
    [anon_sym_CARET] = ACTIONS(4187),
    [anon_sym_DOT2] = ACTIONS(4189),
    [sym_uninitialized] = ACTIONS(4185),
    [sym_tag] = ACTIONS(4185),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4185),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [618] = {
    [sym_expression] = STATE(6341),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4191),
    [anon_sym_QMARK] = ACTIONS(4193),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4195),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4197),
    [anon_sym_dynamic] = ACTIONS(4199),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [619] = {
    [sym_block] = STATE(1045),
    [sym_where_clause] = STATE(696),
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(4179),
    [sym_tag] = ACTIONS(4183),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4023),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [620] = {
    [sym_block] = STATE(2373),
    [sym_where_clause] = STATE(1102),
    [ts_builtin_sym_end] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_else] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(4201),
    [sym_tag] = ACTIONS(4203),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3415),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [621] = {
    [sym_block] = STATE(1048),
    [sym_where_clause] = STATE(691),
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(4205),
    [sym_tag] = ACTIONS(4207),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4083),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [622] = {
    [sym_block] = STATE(2373),
    [sym_where_clause] = STATE(1102),
    [ts_builtin_sym_end] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_else] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(4201),
    [sym_tag] = ACTIONS(4203),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3415),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [623] = {
    [sym_block] = STATE(1048),
    [sym_where_clause] = STATE(691),
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(4205),
    [sym_tag] = ACTIONS(4209),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4083),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [624] = {
    [sym_expression] = STATE(6159),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4211),
    [anon_sym_QMARK] = ACTIONS(4213),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4215),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4217),
    [anon_sym_dynamic] = ACTIONS(4219),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [625] = {
    [sym_block] = STATE(2176),
    [sym_where_clause] = STATE(996),
    [ts_builtin_sym_end] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_else] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(3427),
    [sym_tag] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3415),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [626] = {
    [sym_expression] = STATE(6418),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4221),
    [anon_sym_QMARK] = ACTIONS(4223),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4225),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4227),
    [anon_sym_dynamic] = ACTIONS(4229),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [627] = {
    [sym_expression] = STATE(6403),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4231),
    [anon_sym_QMARK] = ACTIONS(4233),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4235),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4237),
    [anon_sym_dynamic] = ACTIONS(4239),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [628] = {
    [sym_expression] = STATE(6091),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4241),
    [anon_sym_QMARK] = ACTIONS(4243),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4245),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4247),
    [anon_sym_dynamic] = ACTIONS(4249),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [629] = {
    [sym_block] = STATE(2175),
    [sym_where_clause] = STATE(1017),
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(4251),
    [sym_tag] = ACTIONS(4253),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4083),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [630] = {
    [sym_expression] = STATE(6352),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4255),
    [anon_sym_QMARK] = ACTIONS(4257),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4259),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4261),
    [anon_sym_dynamic] = ACTIONS(4263),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [631] = {
    [aux_sym_field_type_repeat1] = STATE(664),
    [ts_builtin_sym_end] = ACTIONS(4185),
    [anon_sym_LBRACE] = ACTIONS(4185),
    [anon_sym_RBRACE] = ACTIONS(4185),
    [anon_sym_COMMA] = ACTIONS(4185),
    [anon_sym_COLON_COLON] = ACTIONS(4185),
    [anon_sym_DASH_GT] = ACTIONS(4185),
    [anon_sym_where] = ACTIONS(4185),
    [anon_sym_EQ] = ACTIONS(4187),
    [anon_sym_COLON] = ACTIONS(4265),
    [anon_sym_PIPE] = ACTIONS(4187),
    [anon_sym_COLON_EQ] = ACTIONS(4185),
    [anon_sym_LPAREN] = ACTIONS(4185),
    [anon_sym_PLUS_EQ] = ACTIONS(4185),
    [anon_sym_DASH_EQ] = ACTIONS(4185),
    [anon_sym_STAR_EQ] = ACTIONS(4185),
    [anon_sym_SLASH_EQ] = ACTIONS(4185),
    [anon_sym_PERCENT_EQ] = ACTIONS(4185),
    [anon_sym_AMP_EQ] = ACTIONS(4185),
    [anon_sym_PIPE_EQ] = ACTIONS(4185),
    [anon_sym_CARET_EQ] = ACTIONS(4185),
    [anon_sym_LT_LT_EQ] = ACTIONS(4185),
    [anon_sym_GT_GT_EQ] = ACTIONS(4185),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4185),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4185),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4185),
    [anon_sym_if] = ACTIONS(4185),
    [anon_sym_SEMI] = ACTIONS(4185),
    [anon_sym_else] = ACTIONS(4185),
    [anon_sym_when] = ACTIONS(4185),
    [anon_sym_in] = ACTIONS(4185),
    [anon_sym_case] = ACTIONS(4185),
    [anon_sym_QMARK] = ACTIONS(4185),
    [anon_sym_PLUS] = ACTIONS(4187),
    [anon_sym_DASH] = ACTIONS(4187),
    [anon_sym_TILDE] = ACTIONS(4187),
    [anon_sym_AMP] = ACTIONS(4187),
    [anon_sym_PIPE_PIPE] = ACTIONS(4187),
    [anon_sym_or_else] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4187),
    [anon_sym_GT] = ACTIONS(4187),
    [anon_sym_GT_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4185),
    [anon_sym_LT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4185),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_TILDE_EQ] = ACTIONS(4185),
    [anon_sym_AMP_TILDE] = ACTIONS(4187),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_STAR] = ACTIONS(4187),
    [anon_sym_SLASH] = ACTIONS(4187),
    [anon_sym_PERCENT] = ACTIONS(4187),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4185),
    [anon_sym_DOT] = ACTIONS(4187),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4185),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4185),
    [anon_sym_not_in] = ACTIONS(4185),
    [anon_sym_or_return] = ACTIONS(4185),
    [anon_sym_or_continue] = ACTIONS(4185),
    [anon_sym_or_break] = ACTIONS(4185),
    [anon_sym_CARET] = ACTIONS(4187),
    [anon_sym_DOT2] = ACTIONS(4189),
    [sym_uninitialized] = ACTIONS(4185),
    [sym_tag] = ACTIONS(4185),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4185),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [632] = {
    [sym_expression] = STATE(6373),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4267),
    [anon_sym_QMARK] = ACTIONS(4269),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4271),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4273),
    [anon_sym_dynamic] = ACTIONS(4275),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [633] = {
    [sym_expression] = STATE(6164),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4277),
    [anon_sym_QMARK] = ACTIONS(4279),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4281),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4283),
    [anon_sym_dynamic] = ACTIONS(4285),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [634] = {
    [sym_block] = STATE(1048),
    [sym_where_clause] = STATE(691),
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(4205),
    [sym_tag] = ACTIONS(4209),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4083),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [635] = {
    [sym_block] = STATE(2175),
    [sym_where_clause] = STATE(1017),
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(4251),
    [sym_tag] = ACTIONS(4253),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4083),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [636] = {
    [sym_block] = STATE(1055),
    [sym_where_clause] = STATE(688),
    [ts_builtin_sym_end] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_else] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(4287),
    [sym_tag] = ACTIONS(4289),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3415),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [637] = {
    [sym_block] = STATE(2335),
    [sym_where_clause] = STATE(1093),
    [ts_builtin_sym_end] = ACTIONS(3781),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(4291),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(3785),
    [anon_sym_COLON] = ACTIONS(3785),
    [anon_sym_PIPE] = ACTIONS(3785),
    [anon_sym_COLON_EQ] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_else] = ACTIONS(3781),
    [anon_sym_when] = ACTIONS(3781),
    [anon_sym_in] = ACTIONS(3781),
    [anon_sym_case] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(3785),
    [anon_sym_PIPE_PIPE] = ACTIONS(3785),
    [anon_sym_or_else] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3785),
    [anon_sym_GT] = ACTIONS(3785),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3781),
    [anon_sym_LT] = ACTIONS(3785),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE] = ACTIONS(3785),
    [anon_sym_LT_LT] = ACTIONS(3785),
    [anon_sym_GT_GT] = ACTIONS(3785),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_SLASH] = ACTIONS(3785),
    [anon_sym_PERCENT] = ACTIONS(3785),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3781),
    [anon_sym_not_in] = ACTIONS(3781),
    [anon_sym_or_return] = ACTIONS(3781),
    [anon_sym_or_continue] = ACTIONS(3781),
    [anon_sym_or_break] = ACTIONS(3781),
    [anon_sym_CARET] = ACTIONS(3785),
    [sym_uninitialized] = ACTIONS(4293),
    [sym_tag] = ACTIONS(4295),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3781),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [638] = {
    [sym_expression] = STATE(6061),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4297),
    [anon_sym_QMARK] = ACTIONS(4299),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4301),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4303),
    [anon_sym_dynamic] = ACTIONS(4305),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [639] = {
    [sym_expression] = STATE(6190),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4307),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4311),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_dynamic] = ACTIONS(4315),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [640] = {
    [sym_block] = STATE(2175),
    [sym_where_clause] = STATE(1017),
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(4251),
    [sym_tag] = ACTIONS(4317),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4083),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [641] = {
    [sym_expression] = STATE(6229),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4319),
    [anon_sym_QMARK] = ACTIONS(4321),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4323),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4325),
    [anon_sym_dynamic] = ACTIONS(4327),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [642] = {
    [sym_block] = STATE(1055),
    [sym_where_clause] = STATE(688),
    [ts_builtin_sym_end] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_else] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(4287),
    [sym_tag] = ACTIONS(4289),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3415),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [643] = {
    [sym_block] = STATE(2311),
    [sym_where_clause] = STATE(1087),
    [ts_builtin_sym_end] = ACTIONS(4113),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(4113),
    [anon_sym_COMMA] = ACTIONS(4113),
    [anon_sym_COLON_COLON] = ACTIONS(4113),
    [anon_sym_DASH_GT] = ACTIONS(4329),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4117),
    [anon_sym_COLON] = ACTIONS(4117),
    [anon_sym_PIPE] = ACTIONS(4117),
    [anon_sym_COLON_EQ] = ACTIONS(4113),
    [anon_sym_LPAREN] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4113),
    [anon_sym_DASH_EQ] = ACTIONS(4113),
    [anon_sym_STAR_EQ] = ACTIONS(4113),
    [anon_sym_SLASH_EQ] = ACTIONS(4113),
    [anon_sym_PERCENT_EQ] = ACTIONS(4113),
    [anon_sym_AMP_EQ] = ACTIONS(4113),
    [anon_sym_PIPE_EQ] = ACTIONS(4113),
    [anon_sym_CARET_EQ] = ACTIONS(4113),
    [anon_sym_LT_LT_EQ] = ACTIONS(4113),
    [anon_sym_GT_GT_EQ] = ACTIONS(4113),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4113),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4113),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4113),
    [anon_sym_if] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_else] = ACTIONS(4113),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_in] = ACTIONS(4113),
    [anon_sym_case] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4117),
    [anon_sym_DASH] = ACTIONS(4117),
    [anon_sym_TILDE] = ACTIONS(4117),
    [anon_sym_AMP] = ACTIONS(4117),
    [anon_sym_PIPE_PIPE] = ACTIONS(4117),
    [anon_sym_or_else] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4117),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4113),
    [anon_sym_TILDE_EQ] = ACTIONS(4113),
    [anon_sym_AMP_TILDE] = ACTIONS(4117),
    [anon_sym_LT_LT] = ACTIONS(4117),
    [anon_sym_GT_GT] = ACTIONS(4117),
    [anon_sym_STAR] = ACTIONS(4117),
    [anon_sym_SLASH] = ACTIONS(4117),
    [anon_sym_PERCENT] = ACTIONS(4117),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(4117),
    [anon_sym_LBRACK] = ACTIONS(4113),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4113),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4113),
    [anon_sym_not_in] = ACTIONS(4113),
    [anon_sym_or_return] = ACTIONS(4113),
    [anon_sym_or_continue] = ACTIONS(4113),
    [anon_sym_or_break] = ACTIONS(4113),
    [anon_sym_CARET] = ACTIONS(4117),
    [sym_uninitialized] = ACTIONS(4331),
    [sym_tag] = ACTIONS(4333),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4113),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [644] = {
    [sym_expression] = STATE(6212),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4063),
    [anon_sym_QMARK] = ACTIONS(4335),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4337),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4339),
    [anon_sym_dynamic] = ACTIONS(4341),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [645] = {
    [sym_expression] = STATE(6181),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4343),
    [anon_sym_QMARK] = ACTIONS(4345),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4347),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4349),
    [anon_sym_dynamic] = ACTIONS(4351),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [646] = {
    [sym_expression] = STATE(6050),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4353),
    [anon_sym_QMARK] = ACTIONS(4355),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4357),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4359),
    [anon_sym_dynamic] = ACTIONS(4361),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [647] = {
    [sym_expression] = STATE(6351),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4363),
    [anon_sym_QMARK] = ACTIONS(4365),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4367),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4369),
    [anon_sym_dynamic] = ACTIONS(4371),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [648] = {
    [sym_block] = STATE(2172),
    [sym_where_clause] = STATE(1052),
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(4373),
    [sym_tag] = ACTIONS(4375),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4023),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [649] = {
    [sym_expression] = STATE(6084),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4377),
    [anon_sym_QMARK] = ACTIONS(4379),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4381),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4383),
    [anon_sym_dynamic] = ACTIONS(4385),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [650] = {
    [sym_expression] = STATE(6196),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4387),
    [anon_sym_QMARK] = ACTIONS(4389),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4391),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4393),
    [anon_sym_dynamic] = ACTIONS(4395),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [651] = {
    [sym_expression] = STATE(6073),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4397),
    [anon_sym_QMARK] = ACTIONS(4399),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4401),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4403),
    [anon_sym_dynamic] = ACTIONS(4405),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [652] = {
    [sym_block] = STATE(2172),
    [sym_where_clause] = STATE(1052),
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(4373),
    [sym_tag] = ACTIONS(4375),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4023),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [653] = {
    [sym_expression] = STATE(6394),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4407),
    [anon_sym_QMARK] = ACTIONS(4409),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4411),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4413),
    [anon_sym_dynamic] = ACTIONS(4415),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [654] = {
    [sym_expression] = STATE(6170),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4343),
    [anon_sym_QMARK] = ACTIONS(4417),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4419),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4421),
    [anon_sym_dynamic] = ACTIONS(4423),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [655] = {
    [sym_block] = STATE(715),
    [sym_where_clause] = STATE(681),
    [ts_builtin_sym_end] = ACTIONS(3781),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(4425),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(3785),
    [anon_sym_COLON] = ACTIONS(3785),
    [anon_sym_PIPE] = ACTIONS(3785),
    [anon_sym_COLON_EQ] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_else] = ACTIONS(3781),
    [anon_sym_when] = ACTIONS(3781),
    [anon_sym_in] = ACTIONS(3781),
    [anon_sym_case] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(3785),
    [anon_sym_PIPE_PIPE] = ACTIONS(3785),
    [anon_sym_or_else] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3785),
    [anon_sym_GT] = ACTIONS(3785),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3781),
    [anon_sym_LT] = ACTIONS(3785),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE] = ACTIONS(3785),
    [anon_sym_LT_LT] = ACTIONS(3785),
    [anon_sym_GT_GT] = ACTIONS(3785),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_SLASH] = ACTIONS(3785),
    [anon_sym_PERCENT] = ACTIONS(3785),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3781),
    [anon_sym_not_in] = ACTIONS(3781),
    [anon_sym_or_return] = ACTIONS(3781),
    [anon_sym_or_continue] = ACTIONS(3781),
    [anon_sym_or_break] = ACTIONS(3781),
    [anon_sym_CARET] = ACTIONS(3785),
    [sym_uninitialized] = ACTIONS(4427),
    [sym_tag] = ACTIONS(4429),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3781),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [656] = {
    [sym_expression] = STATE(6274),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4431),
    [anon_sym_QMARK] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4435),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4437),
    [anon_sym_dynamic] = ACTIONS(4439),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [657] = {
    [sym_expression] = STATE(6105),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4441),
    [anon_sym_QMARK] = ACTIONS(4443),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4445),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4447),
    [anon_sym_dynamic] = ACTIONS(4449),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [658] = {
    [sym_block] = STATE(2172),
    [sym_where_clause] = STATE(1052),
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(4373),
    [sym_tag] = ACTIONS(4451),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4023),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [659] = {
    [aux_sym_field_type_repeat1] = STATE(659),
    [ts_builtin_sym_end] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_COLON_COLON] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_where] = ACTIONS(4453),
    [anon_sym_EQ] = ACTIONS(4455),
    [anon_sym_COLON] = ACTIONS(4455),
    [anon_sym_PIPE] = ACTIONS(4455),
    [anon_sym_COLON_EQ] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_PLUS_EQ] = ACTIONS(4453),
    [anon_sym_DASH_EQ] = ACTIONS(4453),
    [anon_sym_STAR_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_PERCENT_EQ] = ACTIONS(4453),
    [anon_sym_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_CARET_EQ] = ACTIONS(4453),
    [anon_sym_LT_LT_EQ] = ACTIONS(4453),
    [anon_sym_GT_GT_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4453),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4453),
    [anon_sym_if] = ACTIONS(4453),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_else] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_in] = ACTIONS(4453),
    [anon_sym_case] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4455),
    [anon_sym_DASH] = ACTIONS(4455),
    [anon_sym_TILDE] = ACTIONS(4455),
    [anon_sym_AMP] = ACTIONS(4455),
    [anon_sym_PIPE_PIPE] = ACTIONS(4455),
    [anon_sym_or_else] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4455),
    [anon_sym_GT] = ACTIONS(4455),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4455),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_TILDE_EQ] = ACTIONS(4453),
    [anon_sym_AMP_TILDE] = ACTIONS(4455),
    [anon_sym_LT_LT] = ACTIONS(4455),
    [anon_sym_GT_GT] = ACTIONS(4455),
    [anon_sym_STAR] = ACTIONS(4455),
    [anon_sym_SLASH] = ACTIONS(4455),
    [anon_sym_PERCENT] = ACTIONS(4455),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4455),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4453),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4453),
    [anon_sym_not_in] = ACTIONS(4453),
    [anon_sym_or_return] = ACTIONS(4453),
    [anon_sym_or_continue] = ACTIONS(4453),
    [anon_sym_or_break] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4455),
    [anon_sym_DOT2] = ACTIONS(4457),
    [sym_uninitialized] = ACTIONS(4453),
    [sym_tag] = ACTIONS(4453),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4453),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [660] = {
    [sym_expression] = STATE(6141),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4460),
    [anon_sym_QMARK] = ACTIONS(4462),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4464),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4466),
    [anon_sym_dynamic] = ACTIONS(4468),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [661] = {
    [sym_expression] = STATE(6241),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4470),
    [anon_sym_QMARK] = ACTIONS(4472),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4474),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4476),
    [anon_sym_dynamic] = ACTIONS(4478),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [662] = {
    [sym_expression] = STATE(6172),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4480),
    [anon_sym_QMARK] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4484),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4486),
    [anon_sym_dynamic] = ACTIONS(4488),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [663] = {
    [sym_block] = STATE(2171),
    [sym_where_clause] = STATE(1095),
    [ts_builtin_sym_end] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_DASH_GT] = ACTIONS(3671),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_PLUS_EQ] = ACTIONS(3671),
    [anon_sym_DASH_EQ] = ACTIONS(3671),
    [anon_sym_STAR_EQ] = ACTIONS(3671),
    [anon_sym_SLASH_EQ] = ACTIONS(3671),
    [anon_sym_PERCENT_EQ] = ACTIONS(3671),
    [anon_sym_AMP_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_CARET_EQ] = ACTIONS(3671),
    [anon_sym_LT_LT_EQ] = ACTIONS(3671),
    [anon_sym_GT_GT_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_if] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_else] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3671),
    [anon_sym_case] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_or_else] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_GT] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3671),
    [anon_sym_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_SLASH] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3671),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3671),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3671),
    [anon_sym_not_in] = ACTIONS(3671),
    [anon_sym_or_return] = ACTIONS(3671),
    [anon_sym_or_continue] = ACTIONS(3671),
    [anon_sym_or_break] = ACTIONS(3671),
    [anon_sym_CARET] = ACTIONS(3675),
    [sym_uninitialized] = ACTIONS(4490),
    [sym_tag] = ACTIONS(4492),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3671),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [664] = {
    [aux_sym_field_type_repeat1] = STATE(659),
    [ts_builtin_sym_end] = ACTIONS(4494),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_RBRACE] = ACTIONS(4494),
    [anon_sym_COMMA] = ACTIONS(4494),
    [anon_sym_COLON_COLON] = ACTIONS(4494),
    [anon_sym_DASH_GT] = ACTIONS(4494),
    [anon_sym_where] = ACTIONS(4494),
    [anon_sym_EQ] = ACTIONS(4496),
    [anon_sym_COLON] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4496),
    [anon_sym_COLON_EQ] = ACTIONS(4494),
    [anon_sym_LPAREN] = ACTIONS(4494),
    [anon_sym_PLUS_EQ] = ACTIONS(4494),
    [anon_sym_DASH_EQ] = ACTIONS(4494),
    [anon_sym_STAR_EQ] = ACTIONS(4494),
    [anon_sym_SLASH_EQ] = ACTIONS(4494),
    [anon_sym_PERCENT_EQ] = ACTIONS(4494),
    [anon_sym_AMP_EQ] = ACTIONS(4494),
    [anon_sym_PIPE_EQ] = ACTIONS(4494),
    [anon_sym_CARET_EQ] = ACTIONS(4494),
    [anon_sym_LT_LT_EQ] = ACTIONS(4494),
    [anon_sym_GT_GT_EQ] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4494),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4494),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4494),
    [anon_sym_if] = ACTIONS(4494),
    [anon_sym_SEMI] = ACTIONS(4494),
    [anon_sym_else] = ACTIONS(4494),
    [anon_sym_when] = ACTIONS(4494),
    [anon_sym_in] = ACTIONS(4494),
    [anon_sym_case] = ACTIONS(4494),
    [anon_sym_QMARK] = ACTIONS(4494),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_DASH] = ACTIONS(4496),
    [anon_sym_TILDE] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(4496),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_or_else] = ACTIONS(4494),
    [anon_sym_AMP_AMP] = ACTIONS(4496),
    [anon_sym_GT] = ACTIONS(4496),
    [anon_sym_GT_EQ] = ACTIONS(4494),
    [anon_sym_LT_EQ] = ACTIONS(4494),
    [anon_sym_LT] = ACTIONS(4496),
    [anon_sym_EQ_EQ] = ACTIONS(4494),
    [anon_sym_BANG_EQ] = ACTIONS(4494),
    [anon_sym_TILDE_EQ] = ACTIONS(4494),
    [anon_sym_AMP_TILDE] = ACTIONS(4496),
    [anon_sym_LT_LT] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4496),
    [anon_sym_STAR] = ACTIONS(4496),
    [anon_sym_SLASH] = ACTIONS(4496),
    [anon_sym_PERCENT] = ACTIONS(4496),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4494),
    [anon_sym_DOT] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4494),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4494),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4494),
    [anon_sym_not_in] = ACTIONS(4494),
    [anon_sym_or_return] = ACTIONS(4494),
    [anon_sym_or_continue] = ACTIONS(4494),
    [anon_sym_or_break] = ACTIONS(4494),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_DOT2] = ACTIONS(4189),
    [sym_uninitialized] = ACTIONS(4494),
    [sym_tag] = ACTIONS(4494),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4494),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [665] = {
    [sym_expression] = STATE(6235),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4498),
    [anon_sym_QMARK] = ACTIONS(4500),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4502),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4504),
    [anon_sym_dynamic] = ACTIONS(4506),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [666] = {
    [sym_expression] = STATE(6224),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4508),
    [anon_sym_QMARK] = ACTIONS(4510),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4512),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4514),
    [anon_sym_dynamic] = ACTIONS(4516),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [667] = {
    [sym_block] = STATE(1062),
    [sym_where_clause] = STATE(678),
    [ts_builtin_sym_end] = ACTIONS(4113),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(4113),
    [anon_sym_COMMA] = ACTIONS(4113),
    [anon_sym_COLON_COLON] = ACTIONS(4113),
    [anon_sym_DASH_GT] = ACTIONS(4518),
    [anon_sym_where] = ACTIONS(3419),
    [anon_sym_EQ] = ACTIONS(4117),
    [anon_sym_COLON] = ACTIONS(4117),
    [anon_sym_PIPE] = ACTIONS(4117),
    [anon_sym_COLON_EQ] = ACTIONS(4113),
    [anon_sym_LPAREN] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4113),
    [anon_sym_DASH_EQ] = ACTIONS(4113),
    [anon_sym_STAR_EQ] = ACTIONS(4113),
    [anon_sym_SLASH_EQ] = ACTIONS(4113),
    [anon_sym_PERCENT_EQ] = ACTIONS(4113),
    [anon_sym_AMP_EQ] = ACTIONS(4113),
    [anon_sym_PIPE_EQ] = ACTIONS(4113),
    [anon_sym_CARET_EQ] = ACTIONS(4113),
    [anon_sym_LT_LT_EQ] = ACTIONS(4113),
    [anon_sym_GT_GT_EQ] = ACTIONS(4113),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4113),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4113),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4113),
    [anon_sym_if] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_else] = ACTIONS(4113),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_in] = ACTIONS(4113),
    [anon_sym_case] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4117),
    [anon_sym_DASH] = ACTIONS(4117),
    [anon_sym_TILDE] = ACTIONS(4117),
    [anon_sym_AMP] = ACTIONS(4117),
    [anon_sym_PIPE_PIPE] = ACTIONS(4117),
    [anon_sym_or_else] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4117),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4113),
    [anon_sym_TILDE_EQ] = ACTIONS(4113),
    [anon_sym_AMP_TILDE] = ACTIONS(4117),
    [anon_sym_LT_LT] = ACTIONS(4117),
    [anon_sym_GT_GT] = ACTIONS(4117),
    [anon_sym_STAR] = ACTIONS(4117),
    [anon_sym_SLASH] = ACTIONS(4117),
    [anon_sym_PERCENT] = ACTIONS(4117),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(4117),
    [anon_sym_LBRACK] = ACTIONS(4113),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4113),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4113),
    [anon_sym_not_in] = ACTIONS(4113),
    [anon_sym_or_return] = ACTIONS(4113),
    [anon_sym_or_continue] = ACTIONS(4113),
    [anon_sym_or_break] = ACTIONS(4113),
    [anon_sym_CARET] = ACTIONS(4117),
    [sym_uninitialized] = ACTIONS(4520),
    [sym_tag] = ACTIONS(4522),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4113),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [668] = {
    [sym_expression] = STATE(6213),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4524),
    [anon_sym_QMARK] = ACTIONS(4526),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4528),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4530),
    [anon_sym_dynamic] = ACTIONS(4532),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [669] = {
    [aux_sym_struct_type_repeat2] = STATE(689),
    [ts_builtin_sym_end] = ACTIONS(4534),
    [anon_sym_LBRACE] = ACTIONS(4534),
    [anon_sym_RBRACE] = ACTIONS(4534),
    [anon_sym_COMMA] = ACTIONS(4534),
    [anon_sym_COLON_COLON] = ACTIONS(4534),
    [anon_sym_DASH_GT] = ACTIONS(4534),
    [anon_sym_where] = ACTIONS(4534),
    [anon_sym_EQ] = ACTIONS(4536),
    [anon_sym_COLON] = ACTIONS(4536),
    [anon_sym_PIPE] = ACTIONS(4536),
    [anon_sym_COLON_EQ] = ACTIONS(4534),
    [anon_sym_LPAREN] = ACTIONS(4534),
    [anon_sym_PLUS_EQ] = ACTIONS(4534),
    [anon_sym_DASH_EQ] = ACTIONS(4534),
    [anon_sym_STAR_EQ] = ACTIONS(4534),
    [anon_sym_SLASH_EQ] = ACTIONS(4534),
    [anon_sym_PERCENT_EQ] = ACTIONS(4534),
    [anon_sym_AMP_EQ] = ACTIONS(4534),
    [anon_sym_PIPE_EQ] = ACTIONS(4534),
    [anon_sym_CARET_EQ] = ACTIONS(4534),
    [anon_sym_LT_LT_EQ] = ACTIONS(4534),
    [anon_sym_GT_GT_EQ] = ACTIONS(4534),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4534),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4534),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4534),
    [anon_sym_if] = ACTIONS(4534),
    [anon_sym_SEMI] = ACTIONS(4534),
    [anon_sym_else] = ACTIONS(4534),
    [anon_sym_when] = ACTIONS(4534),
    [anon_sym_in] = ACTIONS(4534),
    [anon_sym_case] = ACTIONS(4534),
    [anon_sym_QMARK] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4536),
    [anon_sym_DASH] = ACTIONS(4536),
    [anon_sym_TILDE] = ACTIONS(4536),
    [anon_sym_AMP] = ACTIONS(4536),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_or_else] = ACTIONS(4534),
    [anon_sym_AMP_AMP] = ACTIONS(4536),
    [anon_sym_GT] = ACTIONS(4536),
    [anon_sym_GT_EQ] = ACTIONS(4534),
    [anon_sym_LT_EQ] = ACTIONS(4534),
    [anon_sym_LT] = ACTIONS(4536),
    [anon_sym_EQ_EQ] = ACTIONS(4534),
    [anon_sym_BANG_EQ] = ACTIONS(4534),
    [anon_sym_TILDE_EQ] = ACTIONS(4534),
    [anon_sym_AMP_TILDE] = ACTIONS(4536),
    [anon_sym_LT_LT] = ACTIONS(4536),
    [anon_sym_GT_GT] = ACTIONS(4536),
    [anon_sym_STAR] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(4536),
    [anon_sym_PERCENT] = ACTIONS(4536),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4534),
    [anon_sym_DOT] = ACTIONS(4536),
    [anon_sym_LBRACK] = ACTIONS(4534),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4534),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4534),
    [anon_sym_not_in] = ACTIONS(4534),
    [anon_sym_or_return] = ACTIONS(4534),
    [anon_sym_or_continue] = ACTIONS(4534),
    [anon_sym_or_break] = ACTIONS(4534),
    [anon_sym_CARET] = ACTIONS(4536),
    [sym_uninitialized] = ACTIONS(4534),
    [sym_tag] = ACTIONS(4534),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4534),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [670] = {
    [sym_expression] = STATE(6197),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4538),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4540),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4542),
    [anon_sym_dynamic] = ACTIONS(4544),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [671] = {
    [aux_sym_struct_type_repeat2] = STATE(689),
    [ts_builtin_sym_end] = ACTIONS(4546),
    [anon_sym_LBRACE] = ACTIONS(4546),
    [anon_sym_RBRACE] = ACTIONS(4546),
    [anon_sym_COMMA] = ACTIONS(4546),
    [anon_sym_COLON_COLON] = ACTIONS(4546),
    [anon_sym_DASH_GT] = ACTIONS(4546),
    [anon_sym_where] = ACTIONS(4546),
    [anon_sym_EQ] = ACTIONS(4548),
    [anon_sym_COLON] = ACTIONS(4548),
    [anon_sym_PIPE] = ACTIONS(4548),
    [anon_sym_COLON_EQ] = ACTIONS(4546),
    [anon_sym_LPAREN] = ACTIONS(4546),
    [anon_sym_PLUS_EQ] = ACTIONS(4546),
    [anon_sym_DASH_EQ] = ACTIONS(4546),
    [anon_sym_STAR_EQ] = ACTIONS(4546),
    [anon_sym_SLASH_EQ] = ACTIONS(4546),
    [anon_sym_PERCENT_EQ] = ACTIONS(4546),
    [anon_sym_AMP_EQ] = ACTIONS(4546),
    [anon_sym_PIPE_EQ] = ACTIONS(4546),
    [anon_sym_CARET_EQ] = ACTIONS(4546),
    [anon_sym_LT_LT_EQ] = ACTIONS(4546),
    [anon_sym_GT_GT_EQ] = ACTIONS(4546),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4546),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4546),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4546),
    [anon_sym_if] = ACTIONS(4546),
    [anon_sym_SEMI] = ACTIONS(4546),
    [anon_sym_else] = ACTIONS(4546),
    [anon_sym_when] = ACTIONS(4546),
    [anon_sym_in] = ACTIONS(4546),
    [anon_sym_case] = ACTIONS(4546),
    [anon_sym_QMARK] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(4548),
    [anon_sym_DASH] = ACTIONS(4548),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_AMP] = ACTIONS(4548),
    [anon_sym_PIPE_PIPE] = ACTIONS(4548),
    [anon_sym_or_else] = ACTIONS(4546),
    [anon_sym_AMP_AMP] = ACTIONS(4548),
    [anon_sym_GT] = ACTIONS(4548),
    [anon_sym_GT_EQ] = ACTIONS(4546),
    [anon_sym_LT_EQ] = ACTIONS(4546),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_EQ_EQ] = ACTIONS(4546),
    [anon_sym_BANG_EQ] = ACTIONS(4546),
    [anon_sym_TILDE_EQ] = ACTIONS(4546),
    [anon_sym_AMP_TILDE] = ACTIONS(4548),
    [anon_sym_LT_LT] = ACTIONS(4548),
    [anon_sym_GT_GT] = ACTIONS(4548),
    [anon_sym_STAR] = ACTIONS(4548),
    [anon_sym_SLASH] = ACTIONS(4548),
    [anon_sym_PERCENT] = ACTIONS(4548),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4546),
    [anon_sym_DOT] = ACTIONS(4548),
    [anon_sym_LBRACK] = ACTIONS(4546),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4546),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4546),
    [anon_sym_not_in] = ACTIONS(4546),
    [anon_sym_or_return] = ACTIONS(4546),
    [anon_sym_or_continue] = ACTIONS(4546),
    [anon_sym_or_break] = ACTIONS(4546),
    [anon_sym_CARET] = ACTIONS(4548),
    [sym_uninitialized] = ACTIONS(4546),
    [sym_tag] = ACTIONS(4546),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4546),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [672] = {
    [ts_builtin_sym_end] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_COLON_COLON] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_where] = ACTIONS(4453),
    [anon_sym_EQ] = ACTIONS(4455),
    [anon_sym_COLON] = ACTIONS(4455),
    [anon_sym_PIPE] = ACTIONS(4455),
    [anon_sym_COLON_EQ] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_PLUS_EQ] = ACTIONS(4453),
    [anon_sym_DASH_EQ] = ACTIONS(4453),
    [anon_sym_STAR_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_PERCENT_EQ] = ACTIONS(4453),
    [anon_sym_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_CARET_EQ] = ACTIONS(4453),
    [anon_sym_LT_LT_EQ] = ACTIONS(4453),
    [anon_sym_GT_GT_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4453),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4453),
    [anon_sym_if] = ACTIONS(4453),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_else] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_in] = ACTIONS(4453),
    [anon_sym_case] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4455),
    [anon_sym_DASH] = ACTIONS(4455),
    [anon_sym_TILDE] = ACTIONS(4455),
    [anon_sym_AMP] = ACTIONS(4455),
    [anon_sym_PIPE_PIPE] = ACTIONS(4455),
    [anon_sym_or_else] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4455),
    [anon_sym_GT] = ACTIONS(4455),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4455),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_TILDE_EQ] = ACTIONS(4453),
    [anon_sym_AMP_TILDE] = ACTIONS(4455),
    [anon_sym_LT_LT] = ACTIONS(4455),
    [anon_sym_GT_GT] = ACTIONS(4455),
    [anon_sym_STAR] = ACTIONS(4455),
    [anon_sym_SLASH] = ACTIONS(4455),
    [anon_sym_PERCENT] = ACTIONS(4455),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4455),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4453),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4453),
    [anon_sym_not_in] = ACTIONS(4453),
    [anon_sym_or_return] = ACTIONS(4453),
    [anon_sym_or_continue] = ACTIONS(4453),
    [anon_sym_or_break] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4455),
    [anon_sym_DOT2] = ACTIONS(4455),
    [sym_uninitialized] = ACTIONS(4453),
    [sym_tag] = ACTIONS(4453),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4453),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [673] = {
    [sym_expression] = STATE(6271),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4550),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4552),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4554),
    [anon_sym_dynamic] = ACTIONS(4556),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [674] = {
    [sym_expression] = STATE(6220),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4558),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4560),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4562),
    [anon_sym_dynamic] = ACTIONS(4564),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [675] = {
    [aux_sym_struct_type_repeat2] = STATE(689),
    [ts_builtin_sym_end] = ACTIONS(4566),
    [anon_sym_LBRACE] = ACTIONS(4566),
    [anon_sym_RBRACE] = ACTIONS(4566),
    [anon_sym_COMMA] = ACTIONS(4566),
    [anon_sym_COLON_COLON] = ACTIONS(4566),
    [anon_sym_DASH_GT] = ACTIONS(4566),
    [anon_sym_where] = ACTIONS(4566),
    [anon_sym_EQ] = ACTIONS(4568),
    [anon_sym_COLON] = ACTIONS(4568),
    [anon_sym_PIPE] = ACTIONS(4568),
    [anon_sym_COLON_EQ] = ACTIONS(4566),
    [anon_sym_LPAREN] = ACTIONS(4566),
    [anon_sym_PLUS_EQ] = ACTIONS(4566),
    [anon_sym_DASH_EQ] = ACTIONS(4566),
    [anon_sym_STAR_EQ] = ACTIONS(4566),
    [anon_sym_SLASH_EQ] = ACTIONS(4566),
    [anon_sym_PERCENT_EQ] = ACTIONS(4566),
    [anon_sym_AMP_EQ] = ACTIONS(4566),
    [anon_sym_PIPE_EQ] = ACTIONS(4566),
    [anon_sym_CARET_EQ] = ACTIONS(4566),
    [anon_sym_LT_LT_EQ] = ACTIONS(4566),
    [anon_sym_GT_GT_EQ] = ACTIONS(4566),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4566),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4566),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4566),
    [anon_sym_if] = ACTIONS(4566),
    [anon_sym_SEMI] = ACTIONS(4566),
    [anon_sym_else] = ACTIONS(4566),
    [anon_sym_when] = ACTIONS(4566),
    [anon_sym_in] = ACTIONS(4566),
    [anon_sym_case] = ACTIONS(4566),
    [anon_sym_QMARK] = ACTIONS(4566),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_DASH] = ACTIONS(4568),
    [anon_sym_TILDE] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [anon_sym_or_else] = ACTIONS(4566),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_GT] = ACTIONS(4568),
    [anon_sym_GT_EQ] = ACTIONS(4566),
    [anon_sym_LT_EQ] = ACTIONS(4566),
    [anon_sym_LT] = ACTIONS(4568),
    [anon_sym_EQ_EQ] = ACTIONS(4566),
    [anon_sym_BANG_EQ] = ACTIONS(4566),
    [anon_sym_TILDE_EQ] = ACTIONS(4566),
    [anon_sym_AMP_TILDE] = ACTIONS(4568),
    [anon_sym_LT_LT] = ACTIONS(4568),
    [anon_sym_GT_GT] = ACTIONS(4568),
    [anon_sym_STAR] = ACTIONS(4568),
    [anon_sym_SLASH] = ACTIONS(4568),
    [anon_sym_PERCENT] = ACTIONS(4568),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4566),
    [anon_sym_DOT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4566),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4566),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4566),
    [anon_sym_not_in] = ACTIONS(4566),
    [anon_sym_or_return] = ACTIONS(4566),
    [anon_sym_or_continue] = ACTIONS(4566),
    [anon_sym_or_break] = ACTIONS(4566),
    [anon_sym_CARET] = ACTIONS(4568),
    [sym_uninitialized] = ACTIONS(4566),
    [sym_tag] = ACTIONS(4566),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4566),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [676] = {
    [sym_expression] = STATE(6167),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4570),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4572),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4574),
    [anon_sym_dynamic] = ACTIONS(4576),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [677] = {
    [sym_block] = STATE(715),
    [ts_builtin_sym_end] = ACTIONS(3781),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [anon_sym_where] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3785),
    [anon_sym_COLON] = ACTIONS(3785),
    [anon_sym_PIPE] = ACTIONS(3785),
    [anon_sym_COLON_EQ] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_else] = ACTIONS(3781),
    [anon_sym_when] = ACTIONS(3781),
    [anon_sym_in] = ACTIONS(3781),
    [anon_sym_case] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(3785),
    [anon_sym_PIPE_PIPE] = ACTIONS(3785),
    [anon_sym_or_else] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3785),
    [anon_sym_GT] = ACTIONS(3785),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3781),
    [anon_sym_LT] = ACTIONS(3785),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE] = ACTIONS(3785),
    [anon_sym_LT_LT] = ACTIONS(3785),
    [anon_sym_GT_GT] = ACTIONS(3785),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_SLASH] = ACTIONS(3785),
    [anon_sym_PERCENT] = ACTIONS(3785),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3781),
    [anon_sym_not_in] = ACTIONS(3781),
    [anon_sym_or_return] = ACTIONS(3781),
    [anon_sym_or_continue] = ACTIONS(3781),
    [anon_sym_or_break] = ACTIONS(3781),
    [anon_sym_CARET] = ACTIONS(3785),
    [sym_uninitialized] = ACTIONS(4427),
    [sym_tag] = ACTIONS(3781),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3781),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [678] = {
    [sym_block] = STATE(715),
    [ts_builtin_sym_end] = ACTIONS(3781),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [anon_sym_where] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3785),
    [anon_sym_COLON] = ACTIONS(3785),
    [anon_sym_PIPE] = ACTIONS(3785),
    [anon_sym_COLON_EQ] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_else] = ACTIONS(3781),
    [anon_sym_when] = ACTIONS(3781),
    [anon_sym_in] = ACTIONS(3781),
    [anon_sym_case] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(3785),
    [anon_sym_PIPE_PIPE] = ACTIONS(3785),
    [anon_sym_or_else] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3785),
    [anon_sym_GT] = ACTIONS(3785),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3781),
    [anon_sym_LT] = ACTIONS(3785),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE] = ACTIONS(3785),
    [anon_sym_LT_LT] = ACTIONS(3785),
    [anon_sym_GT_GT] = ACTIONS(3785),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_SLASH] = ACTIONS(3785),
    [anon_sym_PERCENT] = ACTIONS(3785),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3781),
    [anon_sym_not_in] = ACTIONS(3781),
    [anon_sym_or_return] = ACTIONS(3781),
    [anon_sym_or_continue] = ACTIONS(3781),
    [anon_sym_or_break] = ACTIONS(3781),
    [anon_sym_CARET] = ACTIONS(3785),
    [sym_uninitialized] = ACTIONS(4427),
    [sym_tag] = ACTIONS(4429),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3781),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [679] = {
    [sym_block] = STATE(1055),
    [ts_builtin_sym_end] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(3415),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_else] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(4287),
    [sym_tag] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3415),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [680] = {
    [sym_expression] = STATE(6162),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4578),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4580),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4582),
    [anon_sym_dynamic] = ACTIONS(4584),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [681] = {
    [sym_block] = STATE(1055),
    [ts_builtin_sym_end] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(3415),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_else] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(4287),
    [sym_tag] = ACTIONS(4586),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3415),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [682] = {
    [ts_builtin_sym_end] = ACTIONS(67),
    [sym_identifier] = ACTIONS(4588),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_RBRACE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_where] = ACTIONS(71),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(4590),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(71),
    [anon_sym_when] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [sym_uninitialized] = ACTIONS(67),
    [sym_tag] = ACTIONS(67),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(67),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [683] = {
    [sym_expression] = STATE(6137),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4594),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4596),
    [anon_sym_dynamic] = ACTIONS(4598),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [684] = {
    [aux_sym_field_identifier_repeat1] = STATE(7482),
    [ts_builtin_sym_end] = ACTIONS(4600),
    [anon_sym_LBRACE] = ACTIONS(4602),
    [anon_sym_RBRACE] = ACTIONS(4600),
    [anon_sym_COMMA] = ACTIONS(4600),
    [anon_sym_COLON_COLON] = ACTIONS(4600),
    [anon_sym_DASH_GT] = ACTIONS(4600),
    [anon_sym_where] = ACTIONS(4600),
    [anon_sym_EQ] = ACTIONS(4605),
    [anon_sym_COLON] = ACTIONS(4605),
    [anon_sym_PIPE] = ACTIONS(4605),
    [anon_sym_COLON_EQ] = ACTIONS(4600),
    [anon_sym_LPAREN] = ACTIONS(4607),
    [anon_sym_PLUS_EQ] = ACTIONS(4600),
    [anon_sym_DASH_EQ] = ACTIONS(4600),
    [anon_sym_STAR_EQ] = ACTIONS(4600),
    [anon_sym_SLASH_EQ] = ACTIONS(4600),
    [anon_sym_PERCENT_EQ] = ACTIONS(4600),
    [anon_sym_AMP_EQ] = ACTIONS(4600),
    [anon_sym_PIPE_EQ] = ACTIONS(4600),
    [anon_sym_CARET_EQ] = ACTIONS(4600),
    [anon_sym_LT_LT_EQ] = ACTIONS(4600),
    [anon_sym_GT_GT_EQ] = ACTIONS(4600),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4600),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4600),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4600),
    [anon_sym_if] = ACTIONS(4600),
    [anon_sym_SEMI] = ACTIONS(4600),
    [anon_sym_else] = ACTIONS(4600),
    [anon_sym_when] = ACTIONS(4600),
    [anon_sym_in] = ACTIONS(4600),
    [anon_sym_case] = ACTIONS(4600),
    [anon_sym_QMARK] = ACTIONS(4600),
    [anon_sym_PLUS] = ACTIONS(4605),
    [anon_sym_DASH] = ACTIONS(4605),
    [anon_sym_TILDE] = ACTIONS(4605),
    [anon_sym_AMP] = ACTIONS(4605),
    [anon_sym_PIPE_PIPE] = ACTIONS(4605),
    [anon_sym_or_else] = ACTIONS(4600),
    [anon_sym_AMP_AMP] = ACTIONS(4605),
    [anon_sym_GT] = ACTIONS(4605),
    [anon_sym_GT_EQ] = ACTIONS(4600),
    [anon_sym_LT_EQ] = ACTIONS(4600),
    [anon_sym_LT] = ACTIONS(4605),
    [anon_sym_EQ_EQ] = ACTIONS(4600),
    [anon_sym_BANG_EQ] = ACTIONS(4600),
    [anon_sym_TILDE_EQ] = ACTIONS(4600),
    [anon_sym_AMP_TILDE] = ACTIONS(4605),
    [anon_sym_LT_LT] = ACTIONS(4605),
    [anon_sym_GT_GT] = ACTIONS(4605),
    [anon_sym_STAR] = ACTIONS(4605),
    [anon_sym_SLASH] = ACTIONS(4605),
    [anon_sym_PERCENT] = ACTIONS(4605),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4600),
    [anon_sym_DOT] = ACTIONS(4605),
    [anon_sym_LBRACK] = ACTIONS(4600),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4600),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4600),
    [anon_sym_not_in] = ACTIONS(4600),
    [anon_sym_or_return] = ACTIONS(4600),
    [anon_sym_or_continue] = ACTIONS(4600),
    [anon_sym_or_break] = ACTIONS(4600),
    [anon_sym_CARET] = ACTIONS(4605),
    [sym_uninitialized] = ACTIONS(4600),
    [sym_tag] = ACTIONS(4600),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4600),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [685] = {
    [sym_expression] = STATE(6123),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4610),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4612),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4614),
    [anon_sym_dynamic] = ACTIONS(4616),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [686] = {
    [sym_expression] = STATE(6018),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_pointer_type] = STATE(8516),
    [sym_array_type] = STATE(8516),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2943),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [687] = {
    [sym_block] = STATE(1048),
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(4083),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(4205),
    [sym_tag] = ACTIONS(4083),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4083),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [688] = {
    [sym_block] = STATE(1048),
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(4083),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(4205),
    [sym_tag] = ACTIONS(4207),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4083),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [689] = {
    [aux_sym_struct_type_repeat2] = STATE(689),
    [ts_builtin_sym_end] = ACTIONS(4618),
    [anon_sym_LBRACE] = ACTIONS(4620),
    [anon_sym_RBRACE] = ACTIONS(4618),
    [anon_sym_COMMA] = ACTIONS(4618),
    [anon_sym_COLON_COLON] = ACTIONS(4618),
    [anon_sym_DASH_GT] = ACTIONS(4618),
    [anon_sym_where] = ACTIONS(4618),
    [anon_sym_EQ] = ACTIONS(4623),
    [anon_sym_COLON] = ACTIONS(4623),
    [anon_sym_PIPE] = ACTIONS(4623),
    [anon_sym_COLON_EQ] = ACTIONS(4618),
    [anon_sym_LPAREN] = ACTIONS(4618),
    [anon_sym_PLUS_EQ] = ACTIONS(4618),
    [anon_sym_DASH_EQ] = ACTIONS(4618),
    [anon_sym_STAR_EQ] = ACTIONS(4618),
    [anon_sym_SLASH_EQ] = ACTIONS(4618),
    [anon_sym_PERCENT_EQ] = ACTIONS(4618),
    [anon_sym_AMP_EQ] = ACTIONS(4618),
    [anon_sym_PIPE_EQ] = ACTIONS(4618),
    [anon_sym_CARET_EQ] = ACTIONS(4618),
    [anon_sym_LT_LT_EQ] = ACTIONS(4618),
    [anon_sym_GT_GT_EQ] = ACTIONS(4618),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4618),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4618),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4618),
    [anon_sym_if] = ACTIONS(4618),
    [anon_sym_SEMI] = ACTIONS(4618),
    [anon_sym_else] = ACTIONS(4618),
    [anon_sym_when] = ACTIONS(4618),
    [anon_sym_in] = ACTIONS(4618),
    [anon_sym_case] = ACTIONS(4618),
    [anon_sym_QMARK] = ACTIONS(4618),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_DASH] = ACTIONS(4623),
    [anon_sym_TILDE] = ACTIONS(4623),
    [anon_sym_AMP] = ACTIONS(4623),
    [anon_sym_PIPE_PIPE] = ACTIONS(4623),
    [anon_sym_or_else] = ACTIONS(4618),
    [anon_sym_AMP_AMP] = ACTIONS(4623),
    [anon_sym_GT] = ACTIONS(4623),
    [anon_sym_GT_EQ] = ACTIONS(4618),
    [anon_sym_LT_EQ] = ACTIONS(4618),
    [anon_sym_LT] = ACTIONS(4623),
    [anon_sym_EQ_EQ] = ACTIONS(4618),
    [anon_sym_BANG_EQ] = ACTIONS(4618),
    [anon_sym_TILDE_EQ] = ACTIONS(4618),
    [anon_sym_AMP_TILDE] = ACTIONS(4623),
    [anon_sym_LT_LT] = ACTIONS(4623),
    [anon_sym_GT_GT] = ACTIONS(4623),
    [anon_sym_STAR] = ACTIONS(4623),
    [anon_sym_SLASH] = ACTIONS(4623),
    [anon_sym_PERCENT] = ACTIONS(4623),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4618),
    [anon_sym_DOT] = ACTIONS(4623),
    [anon_sym_LBRACK] = ACTIONS(4618),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4618),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4618),
    [anon_sym_not_in] = ACTIONS(4618),
    [anon_sym_or_return] = ACTIONS(4618),
    [anon_sym_or_continue] = ACTIONS(4618),
    [anon_sym_or_break] = ACTIONS(4618),
    [anon_sym_CARET] = ACTIONS(4623),
    [sym_uninitialized] = ACTIONS(4618),
    [sym_tag] = ACTIONS(4618),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4618),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [690] = {
    [sym_expression] = STATE(6089),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4625),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4627),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4629),
    [anon_sym_dynamic] = ACTIONS(4631),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [691] = {
    [sym_block] = STATE(1045),
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(4023),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(4179),
    [sym_tag] = ACTIONS(4181),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4023),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [692] = {
    [sym_expression] = STATE(6053),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4633),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4637),
    [anon_sym_dynamic] = ACTIONS(4639),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [693] = {
    [sym_block] = STATE(1045),
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(4023),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(4179),
    [sym_tag] = ACTIONS(4023),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4023),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [694] = {
    [sym_procedure] = STATE(7250),
    [sym_expression] = STATE(5746),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym__procedure_type] = STATE(8412),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(4641),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [695] = {
    [sym_expression] = STATE(5270),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_foreign] = ACTIONS(4643),
    [anon_sym_import] = ACTIONS(4645),
    [anon_sym_using] = ACTIONS(4647),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(4651),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [696] = {
    [sym_block] = STATE(1044),
    [ts_builtin_sym_end] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_DASH_GT] = ACTIONS(3671),
    [anon_sym_where] = ACTIONS(3671),
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_PLUS_EQ] = ACTIONS(3671),
    [anon_sym_DASH_EQ] = ACTIONS(3671),
    [anon_sym_STAR_EQ] = ACTIONS(3671),
    [anon_sym_SLASH_EQ] = ACTIONS(3671),
    [anon_sym_PERCENT_EQ] = ACTIONS(3671),
    [anon_sym_AMP_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_CARET_EQ] = ACTIONS(3671),
    [anon_sym_LT_LT_EQ] = ACTIONS(3671),
    [anon_sym_GT_GT_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_if] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_else] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3671),
    [anon_sym_case] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_or_else] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_GT] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3671),
    [anon_sym_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_SLASH] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3671),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3671),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3671),
    [anon_sym_not_in] = ACTIONS(3671),
    [anon_sym_or_return] = ACTIONS(3671),
    [anon_sym_or_continue] = ACTIONS(3671),
    [anon_sym_or_break] = ACTIONS(3671),
    [anon_sym_CARET] = ACTIONS(3675),
    [sym_uninitialized] = ACTIONS(4145),
    [sym_tag] = ACTIONS(4147),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3671),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [697] = {
    [sym_expression] = STATE(6065),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4653),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4655),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4657),
    [anon_sym_dynamic] = ACTIONS(4659),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [698] = {
    [sym_block] = STATE(1044),
    [ts_builtin_sym_end] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_DASH_GT] = ACTIONS(3671),
    [anon_sym_where] = ACTIONS(3671),
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_PLUS_EQ] = ACTIONS(3671),
    [anon_sym_DASH_EQ] = ACTIONS(3671),
    [anon_sym_STAR_EQ] = ACTIONS(3671),
    [anon_sym_SLASH_EQ] = ACTIONS(3671),
    [anon_sym_PERCENT_EQ] = ACTIONS(3671),
    [anon_sym_AMP_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_CARET_EQ] = ACTIONS(3671),
    [anon_sym_LT_LT_EQ] = ACTIONS(3671),
    [anon_sym_GT_GT_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_if] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_else] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3671),
    [anon_sym_case] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_or_else] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_GT] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3671),
    [anon_sym_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_SLASH] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3671),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3671),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3671),
    [anon_sym_not_in] = ACTIONS(3671),
    [anon_sym_or_return] = ACTIONS(3671),
    [anon_sym_or_continue] = ACTIONS(3671),
    [anon_sym_or_break] = ACTIONS(3671),
    [anon_sym_CARET] = ACTIONS(3675),
    [sym_uninitialized] = ACTIONS(4145),
    [sym_tag] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3671),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [699] = {
    [aux_sym_where_clause_repeat1] = STATE(709),
    [ts_builtin_sym_end] = ACTIONS(4661),
    [anon_sym_LBRACE] = ACTIONS(4661),
    [anon_sym_RBRACE] = ACTIONS(4661),
    [anon_sym_COMMA] = ACTIONS(4663),
    [anon_sym_COLON_COLON] = ACTIONS(4661),
    [anon_sym_DASH_GT] = ACTIONS(4661),
    [anon_sym_where] = ACTIONS(4661),
    [anon_sym_EQ] = ACTIONS(4665),
    [anon_sym_COLON] = ACTIONS(4665),
    [anon_sym_PIPE] = ACTIONS(4665),
    [anon_sym_COLON_EQ] = ACTIONS(4661),
    [anon_sym_LPAREN] = ACTIONS(4661),
    [anon_sym_PLUS_EQ] = ACTIONS(4661),
    [anon_sym_DASH_EQ] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4661),
    [anon_sym_SLASH_EQ] = ACTIONS(4661),
    [anon_sym_PERCENT_EQ] = ACTIONS(4661),
    [anon_sym_AMP_EQ] = ACTIONS(4661),
    [anon_sym_PIPE_EQ] = ACTIONS(4661),
    [anon_sym_CARET_EQ] = ACTIONS(4661),
    [anon_sym_LT_LT_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4661),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4661),
    [anon_sym_if] = ACTIONS(4661),
    [anon_sym_SEMI] = ACTIONS(4661),
    [anon_sym_else] = ACTIONS(4661),
    [anon_sym_when] = ACTIONS(4661),
    [anon_sym_in] = ACTIONS(4661),
    [anon_sym_case] = ACTIONS(4661),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_PLUS] = ACTIONS(4665),
    [anon_sym_DASH] = ACTIONS(4665),
    [anon_sym_TILDE] = ACTIONS(4665),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4665),
    [anon_sym_or_else] = ACTIONS(4661),
    [anon_sym_AMP_AMP] = ACTIONS(4665),
    [anon_sym_GT] = ACTIONS(4665),
    [anon_sym_GT_EQ] = ACTIONS(4661),
    [anon_sym_LT_EQ] = ACTIONS(4661),
    [anon_sym_LT] = ACTIONS(4665),
    [anon_sym_EQ_EQ] = ACTIONS(4661),
    [anon_sym_BANG_EQ] = ACTIONS(4661),
    [anon_sym_TILDE_EQ] = ACTIONS(4661),
    [anon_sym_AMP_TILDE] = ACTIONS(4665),
    [anon_sym_LT_LT] = ACTIONS(4665),
    [anon_sym_GT_GT] = ACTIONS(4665),
    [anon_sym_STAR] = ACTIONS(4665),
    [anon_sym_SLASH] = ACTIONS(4665),
    [anon_sym_PERCENT] = ACTIONS(4665),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4661),
    [anon_sym_DOT] = ACTIONS(4665),
    [anon_sym_LBRACK] = ACTIONS(4661),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4661),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4661),
    [anon_sym_not_in] = ACTIONS(4661),
    [anon_sym_or_return] = ACTIONS(4661),
    [anon_sym_or_continue] = ACTIONS(4661),
    [anon_sym_or_break] = ACTIONS(4661),
    [anon_sym_CARET] = ACTIONS(4665),
    [sym_uninitialized] = ACTIONS(4661),
    [sym_tag] = ACTIONS(4661),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4661),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [700] = {
    [sym_expression] = STATE(5694),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_foreign] = ACTIONS(4643),
    [anon_sym_import] = ACTIONS(4645),
    [anon_sym_using] = ACTIONS(4647),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [701] = {
    [sym_block] = STATE(1037),
    [ts_builtin_sym_end] = ACTIONS(4667),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(4667),
    [anon_sym_COMMA] = ACTIONS(4667),
    [anon_sym_COLON_COLON] = ACTIONS(4667),
    [anon_sym_DASH_GT] = ACTIONS(4667),
    [anon_sym_where] = ACTIONS(4667),
    [anon_sym_EQ] = ACTIONS(4669),
    [anon_sym_COLON] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4669),
    [anon_sym_COLON_EQ] = ACTIONS(4667),
    [anon_sym_LPAREN] = ACTIONS(4667),
    [anon_sym_PLUS_EQ] = ACTIONS(4667),
    [anon_sym_DASH_EQ] = ACTIONS(4667),
    [anon_sym_STAR_EQ] = ACTIONS(4667),
    [anon_sym_SLASH_EQ] = ACTIONS(4667),
    [anon_sym_PERCENT_EQ] = ACTIONS(4667),
    [anon_sym_AMP_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_CARET_EQ] = ACTIONS(4667),
    [anon_sym_LT_LT_EQ] = ACTIONS(4667),
    [anon_sym_GT_GT_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_if] = ACTIONS(4667),
    [anon_sym_SEMI] = ACTIONS(4667),
    [anon_sym_else] = ACTIONS(4667),
    [anon_sym_when] = ACTIONS(4667),
    [anon_sym_in] = ACTIONS(4667),
    [anon_sym_case] = ACTIONS(4667),
    [anon_sym_QMARK] = ACTIONS(4667),
    [anon_sym_PLUS] = ACTIONS(4669),
    [anon_sym_DASH] = ACTIONS(4669),
    [anon_sym_TILDE] = ACTIONS(4669),
    [anon_sym_AMP] = ACTIONS(4669),
    [anon_sym_PIPE_PIPE] = ACTIONS(4669),
    [anon_sym_or_else] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_GT] = ACTIONS(4669),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_LT_EQ] = ACTIONS(4667),
    [anon_sym_LT] = ACTIONS(4669),
    [anon_sym_EQ_EQ] = ACTIONS(4667),
    [anon_sym_BANG_EQ] = ACTIONS(4667),
    [anon_sym_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE] = ACTIONS(4669),
    [anon_sym_LT_LT] = ACTIONS(4669),
    [anon_sym_GT_GT] = ACTIONS(4669),
    [anon_sym_STAR] = ACTIONS(4669),
    [anon_sym_SLASH] = ACTIONS(4669),
    [anon_sym_PERCENT] = ACTIONS(4669),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4667),
    [anon_sym_DOT] = ACTIONS(4669),
    [anon_sym_LBRACK] = ACTIONS(4667),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4667),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4667),
    [anon_sym_not_in] = ACTIONS(4667),
    [anon_sym_or_return] = ACTIONS(4667),
    [anon_sym_or_continue] = ACTIONS(4667),
    [anon_sym_or_break] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [sym_uninitialized] = ACTIONS(4671),
    [sym_tag] = ACTIONS(4667),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4667),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [702] = {
    [sym_expression] = STATE(6074),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4673),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4675),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4677),
    [anon_sym_dynamic] = ACTIONS(4679),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [703] = {
    [sym_block] = STATE(1037),
    [ts_builtin_sym_end] = ACTIONS(4667),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(4667),
    [anon_sym_COMMA] = ACTIONS(4667),
    [anon_sym_COLON_COLON] = ACTIONS(4667),
    [anon_sym_DASH_GT] = ACTIONS(4667),
    [anon_sym_where] = ACTIONS(4667),
    [anon_sym_EQ] = ACTIONS(4669),
    [anon_sym_COLON] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4669),
    [anon_sym_COLON_EQ] = ACTIONS(4667),
    [anon_sym_LPAREN] = ACTIONS(4667),
    [anon_sym_PLUS_EQ] = ACTIONS(4667),
    [anon_sym_DASH_EQ] = ACTIONS(4667),
    [anon_sym_STAR_EQ] = ACTIONS(4667),
    [anon_sym_SLASH_EQ] = ACTIONS(4667),
    [anon_sym_PERCENT_EQ] = ACTIONS(4667),
    [anon_sym_AMP_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_CARET_EQ] = ACTIONS(4667),
    [anon_sym_LT_LT_EQ] = ACTIONS(4667),
    [anon_sym_GT_GT_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_if] = ACTIONS(4667),
    [anon_sym_SEMI] = ACTIONS(4667),
    [anon_sym_else] = ACTIONS(4667),
    [anon_sym_when] = ACTIONS(4667),
    [anon_sym_in] = ACTIONS(4667),
    [anon_sym_case] = ACTIONS(4667),
    [anon_sym_QMARK] = ACTIONS(4667),
    [anon_sym_PLUS] = ACTIONS(4669),
    [anon_sym_DASH] = ACTIONS(4669),
    [anon_sym_TILDE] = ACTIONS(4669),
    [anon_sym_AMP] = ACTIONS(4669),
    [anon_sym_PIPE_PIPE] = ACTIONS(4669),
    [anon_sym_or_else] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_GT] = ACTIONS(4669),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_LT_EQ] = ACTIONS(4667),
    [anon_sym_LT] = ACTIONS(4669),
    [anon_sym_EQ_EQ] = ACTIONS(4667),
    [anon_sym_BANG_EQ] = ACTIONS(4667),
    [anon_sym_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE] = ACTIONS(4669),
    [anon_sym_LT_LT] = ACTIONS(4669),
    [anon_sym_GT_GT] = ACTIONS(4669),
    [anon_sym_STAR] = ACTIONS(4669),
    [anon_sym_SLASH] = ACTIONS(4669),
    [anon_sym_PERCENT] = ACTIONS(4669),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4667),
    [anon_sym_DOT] = ACTIONS(4669),
    [anon_sym_LBRACK] = ACTIONS(4667),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4667),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4667),
    [anon_sym_not_in] = ACTIONS(4667),
    [anon_sym_or_return] = ACTIONS(4667),
    [anon_sym_or_continue] = ACTIONS(4667),
    [anon_sym_or_break] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [sym_uninitialized] = ACTIONS(4671),
    [sym_tag] = ACTIONS(4681),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4667),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [704] = {
    [sym_expression] = STATE(6131),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4683),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4685),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4687),
    [anon_sym_dynamic] = ACTIONS(4689),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [705] = {
    [sym_block] = STATE(1036),
    [ts_builtin_sym_end] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(4143),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [anon_sym_COMMA] = ACTIONS(4691),
    [anon_sym_COLON_COLON] = ACTIONS(4691),
    [anon_sym_DASH_GT] = ACTIONS(4691),
    [anon_sym_where] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_COLON] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_COLON_EQ] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_PLUS_EQ] = ACTIONS(4691),
    [anon_sym_DASH_EQ] = ACTIONS(4691),
    [anon_sym_STAR_EQ] = ACTIONS(4691),
    [anon_sym_SLASH_EQ] = ACTIONS(4691),
    [anon_sym_PERCENT_EQ] = ACTIONS(4691),
    [anon_sym_AMP_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_CARET_EQ] = ACTIONS(4691),
    [anon_sym_LT_LT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4691),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4691),
    [anon_sym_if] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_else] = ACTIONS(4691),
    [anon_sym_when] = ACTIONS(4691),
    [anon_sym_in] = ACTIONS(4691),
    [anon_sym_case] = ACTIONS(4691),
    [anon_sym_QMARK] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(4693),
    [anon_sym_AMP] = ACTIONS(4693),
    [anon_sym_PIPE_PIPE] = ACTIONS(4693),
    [anon_sym_or_else] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_GT_EQ] = ACTIONS(4691),
    [anon_sym_LT_EQ] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_EQ_EQ] = ACTIONS(4691),
    [anon_sym_BANG_EQ] = ACTIONS(4691),
    [anon_sym_TILDE_EQ] = ACTIONS(4691),
    [anon_sym_AMP_TILDE] = ACTIONS(4693),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(4693),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4693),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4691),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4691),
    [anon_sym_not_in] = ACTIONS(4691),
    [anon_sym_or_return] = ACTIONS(4691),
    [anon_sym_or_continue] = ACTIONS(4691),
    [anon_sym_or_break] = ACTIONS(4691),
    [anon_sym_CARET] = ACTIONS(4693),
    [sym_uninitialized] = ACTIONS(4695),
    [sym_tag] = ACTIONS(4691),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4691),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [706] = {
    [ts_builtin_sym_end] = ACTIONS(4697),
    [sym_identifier] = ACTIONS(4699),
    [anon_sym_LBRACE] = ACTIONS(4697),
    [anon_sym_RBRACE] = ACTIONS(4697),
    [anon_sym_COMMA] = ACTIONS(4697),
    [anon_sym_COLON_COLON] = ACTIONS(4697),
    [anon_sym_DASH_GT] = ACTIONS(4697),
    [anon_sym_where] = ACTIONS(4701),
    [anon_sym_EQ] = ACTIONS(4701),
    [anon_sym_COLON] = ACTIONS(4701),
    [anon_sym_PIPE] = ACTIONS(4701),
    [anon_sym_COLON_EQ] = ACTIONS(4697),
    [anon_sym_LPAREN] = ACTIONS(4697),
    [anon_sym_PLUS_EQ] = ACTIONS(4697),
    [anon_sym_DASH_EQ] = ACTIONS(4697),
    [anon_sym_STAR_EQ] = ACTIONS(4697),
    [anon_sym_SLASH_EQ] = ACTIONS(4697),
    [anon_sym_PERCENT_EQ] = ACTIONS(4697),
    [anon_sym_AMP_EQ] = ACTIONS(4697),
    [anon_sym_PIPE_EQ] = ACTIONS(4697),
    [anon_sym_CARET_EQ] = ACTIONS(4697),
    [anon_sym_LT_LT_EQ] = ACTIONS(4697),
    [anon_sym_GT_GT_EQ] = ACTIONS(4697),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4697),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4697),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4697),
    [anon_sym_if] = ACTIONS(4701),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_else] = ACTIONS(4701),
    [anon_sym_when] = ACTIONS(4701),
    [anon_sym_in] = ACTIONS(4701),
    [anon_sym_case] = ACTIONS(4701),
    [anon_sym_QMARK] = ACTIONS(4697),
    [anon_sym_PLUS] = ACTIONS(4701),
    [anon_sym_DASH] = ACTIONS(4701),
    [anon_sym_TILDE] = ACTIONS(4701),
    [anon_sym_AMP] = ACTIONS(4701),
    [anon_sym_PIPE_PIPE] = ACTIONS(4701),
    [anon_sym_or_else] = ACTIONS(4701),
    [anon_sym_AMP_AMP] = ACTIONS(4701),
    [anon_sym_GT] = ACTIONS(4701),
    [anon_sym_GT_EQ] = ACTIONS(4697),
    [anon_sym_LT_EQ] = ACTIONS(4697),
    [anon_sym_LT] = ACTIONS(4701),
    [anon_sym_EQ_EQ] = ACTIONS(4697),
    [anon_sym_BANG_EQ] = ACTIONS(4697),
    [anon_sym_TILDE_EQ] = ACTIONS(4697),
    [anon_sym_AMP_TILDE] = ACTIONS(4701),
    [anon_sym_LT_LT] = ACTIONS(4701),
    [anon_sym_GT_GT] = ACTIONS(4701),
    [anon_sym_STAR] = ACTIONS(4701),
    [anon_sym_SLASH] = ACTIONS(4701),
    [anon_sym_PERCENT] = ACTIONS(4701),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4697),
    [anon_sym_DOT] = ACTIONS(4701),
    [anon_sym_LBRACK] = ACTIONS(4697),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4697),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4697),
    [anon_sym_not_in] = ACTIONS(4701),
    [anon_sym_or_return] = ACTIONS(4701),
    [anon_sym_or_continue] = ACTIONS(4701),
    [anon_sym_or_break] = ACTIONS(4701),
    [anon_sym_CARET] = ACTIONS(4701),
    [sym_uninitialized] = ACTIONS(4697),
    [sym_tag] = ACTIONS(4697),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4697),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [707] = {
    [sym_expression] = STATE(6090),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4703),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(4705),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4707),
    [anon_sym_dynamic] = ACTIONS(4709),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [708] = {
    [sym_block] = STATE(7165),
    [sym_expression] = STATE(5813),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(4711),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(4713),
    [anon_sym_do] = ACTIONS(4715),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [709] = {
    [aux_sym_where_clause_repeat1] = STATE(709),
    [ts_builtin_sym_end] = ACTIONS(4717),
    [anon_sym_LBRACE] = ACTIONS(4717),
    [anon_sym_RBRACE] = ACTIONS(4717),
    [anon_sym_COMMA] = ACTIONS(4719),
    [anon_sym_COLON_COLON] = ACTIONS(4717),
    [anon_sym_DASH_GT] = ACTIONS(4717),
    [anon_sym_where] = ACTIONS(4717),
    [anon_sym_EQ] = ACTIONS(4722),
    [anon_sym_COLON] = ACTIONS(4722),
    [anon_sym_PIPE] = ACTIONS(4722),
    [anon_sym_COLON_EQ] = ACTIONS(4717),
    [anon_sym_LPAREN] = ACTIONS(4717),
    [anon_sym_PLUS_EQ] = ACTIONS(4717),
    [anon_sym_DASH_EQ] = ACTIONS(4717),
    [anon_sym_STAR_EQ] = ACTIONS(4717),
    [anon_sym_SLASH_EQ] = ACTIONS(4717),
    [anon_sym_PERCENT_EQ] = ACTIONS(4717),
    [anon_sym_AMP_EQ] = ACTIONS(4717),
    [anon_sym_PIPE_EQ] = ACTIONS(4717),
    [anon_sym_CARET_EQ] = ACTIONS(4717),
    [anon_sym_LT_LT_EQ] = ACTIONS(4717),
    [anon_sym_GT_GT_EQ] = ACTIONS(4717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4717),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4717),
    [anon_sym_if] = ACTIONS(4717),
    [anon_sym_SEMI] = ACTIONS(4717),
    [anon_sym_else] = ACTIONS(4717),
    [anon_sym_when] = ACTIONS(4717),
    [anon_sym_in] = ACTIONS(4717),
    [anon_sym_case] = ACTIONS(4717),
    [anon_sym_QMARK] = ACTIONS(4717),
    [anon_sym_PLUS] = ACTIONS(4722),
    [anon_sym_DASH] = ACTIONS(4722),
    [anon_sym_TILDE] = ACTIONS(4722),
    [anon_sym_AMP] = ACTIONS(4722),
    [anon_sym_PIPE_PIPE] = ACTIONS(4722),
    [anon_sym_or_else] = ACTIONS(4717),
    [anon_sym_AMP_AMP] = ACTIONS(4722),
    [anon_sym_GT] = ACTIONS(4722),
    [anon_sym_GT_EQ] = ACTIONS(4717),
    [anon_sym_LT_EQ] = ACTIONS(4717),
    [anon_sym_LT] = ACTIONS(4722),
    [anon_sym_EQ_EQ] = ACTIONS(4717),
    [anon_sym_BANG_EQ] = ACTIONS(4717),
    [anon_sym_TILDE_EQ] = ACTIONS(4717),
    [anon_sym_AMP_TILDE] = ACTIONS(4722),
    [anon_sym_LT_LT] = ACTIONS(4722),
    [anon_sym_GT_GT] = ACTIONS(4722),
    [anon_sym_STAR] = ACTIONS(4722),
    [anon_sym_SLASH] = ACTIONS(4722),
    [anon_sym_PERCENT] = ACTIONS(4722),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4717),
    [anon_sym_DOT] = ACTIONS(4722),
    [anon_sym_LBRACK] = ACTIONS(4717),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4717),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4717),
    [anon_sym_not_in] = ACTIONS(4717),
    [anon_sym_or_return] = ACTIONS(4717),
    [anon_sym_or_continue] = ACTIONS(4717),
    [anon_sym_or_break] = ACTIONS(4717),
    [anon_sym_CARET] = ACTIONS(4722),
    [sym_uninitialized] = ACTIONS(4717),
    [sym_tag] = ACTIONS(4717),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4717),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [710] = {
    [sym_block] = STATE(7165),
    [sym_expression] = STATE(5827),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(4711),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_SEMI] = ACTIONS(4724),
    [anon_sym_do] = ACTIONS(4726),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [711] = {
    [aux_sym_where_clause_repeat1] = STATE(699),
    [ts_builtin_sym_end] = ACTIONS(4728),
    [anon_sym_LBRACE] = ACTIONS(4728),
    [anon_sym_RBRACE] = ACTIONS(4728),
    [anon_sym_COMMA] = ACTIONS(4663),
    [anon_sym_COLON_COLON] = ACTIONS(4728),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(4728),
    [anon_sym_EQ] = ACTIONS(4732),
    [anon_sym_COLON] = ACTIONS(4732),
    [anon_sym_PIPE] = ACTIONS(4734),
    [anon_sym_COLON_EQ] = ACTIONS(4728),
    [anon_sym_LPAREN] = ACTIONS(4728),
    [anon_sym_PLUS_EQ] = ACTIONS(4728),
    [anon_sym_DASH_EQ] = ACTIONS(4728),
    [anon_sym_STAR_EQ] = ACTIONS(4728),
    [anon_sym_SLASH_EQ] = ACTIONS(4728),
    [anon_sym_PERCENT_EQ] = ACTIONS(4728),
    [anon_sym_AMP_EQ] = ACTIONS(4728),
    [anon_sym_PIPE_EQ] = ACTIONS(4728),
    [anon_sym_CARET_EQ] = ACTIONS(4728),
    [anon_sym_LT_LT_EQ] = ACTIONS(4728),
    [anon_sym_GT_GT_EQ] = ACTIONS(4728),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4728),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4728),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4728),
    [anon_sym_if] = ACTIONS(4728),
    [anon_sym_SEMI] = ACTIONS(4728),
    [anon_sym_else] = ACTIONS(4728),
    [anon_sym_when] = ACTIONS(4728),
    [anon_sym_in] = ACTIONS(4728),
    [anon_sym_case] = ACTIONS(4728),
    [anon_sym_QMARK] = ACTIONS(4728),
    [anon_sym_PLUS] = ACTIONS(4736),
    [anon_sym_DASH] = ACTIONS(4736),
    [anon_sym_TILDE] = ACTIONS(4738),
    [anon_sym_AMP] = ACTIONS(4740),
    [anon_sym_PIPE_PIPE] = ACTIONS(4742),
    [anon_sym_or_else] = ACTIONS(4744),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_GT] = ACTIONS(4748),
    [anon_sym_GT_EQ] = ACTIONS(4750),
    [anon_sym_LT_EQ] = ACTIONS(4750),
    [anon_sym_LT] = ACTIONS(4748),
    [anon_sym_EQ_EQ] = ACTIONS(4752),
    [anon_sym_BANG_EQ] = ACTIONS(4752),
    [anon_sym_TILDE_EQ] = ACTIONS(4752),
    [anon_sym_AMP_TILDE] = ACTIONS(4754),
    [anon_sym_LT_LT] = ACTIONS(4756),
    [anon_sym_GT_GT] = ACTIONS(4756),
    [anon_sym_STAR] = ACTIONS(4758),
    [anon_sym_SLASH] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4760),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(4728),
    [anon_sym_or_return] = ACTIONS(4768),
    [anon_sym_or_continue] = ACTIONS(4770),
    [anon_sym_or_break] = ACTIONS(4772),
    [anon_sym_CARET] = ACTIONS(4774),
    [sym_uninitialized] = ACTIONS(4728),
    [sym_tag] = ACTIONS(4728),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4728),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [712] = {
    [sym_procedure] = STATE(4444),
    [sym_expression] = STATE(4842),
    [sym__expression_no_tag] = STATE(4440),
    [sym_unary_expression] = STATE(4440),
    [sym_binary_expression] = STATE(4440),
    [sym_ternary_expression] = STATE(4440),
    [sym_call_expression] = STATE(4440),
    [sym_selector_call_expression] = STATE(4440),
    [sym_member_expression] = STATE(4440),
    [sym_index_expression] = STATE(4440),
    [sym_slice_expression] = STATE(4440),
    [sym_range_expression] = STATE(4440),
    [sym_cast_expression] = STATE(4440),
    [sym_in_expression] = STATE(4440),
    [sym_variadic_expression] = STATE(4440),
    [sym_parenthesized_expression] = STATE(4440),
    [sym_or_return_expression] = STATE(4440),
    [sym_or_continue_expression] = STATE(4440),
    [sym_or_break_expression] = STATE(4440),
    [sym_address] = STATE(4440),
    [sym_map_type] = STATE(4440),
    [sym_matrix_type] = STATE(4440),
    [sym__procedure_type] = STATE(6900),
    [sym_distinct_type] = STATE(4440),
    [sym_literal] = STATE(4440),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_proc] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(729),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [713] = {
    [sym_procedure] = STATE(3887),
    [sym_expression] = STATE(6003),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym__procedure_type] = STATE(8412),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [714] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7879),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4776),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [715] = {
    [ts_builtin_sym_end] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3415),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(3415),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_else] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(3415),
    [sym_tag] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3415),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [716] = {
    [sym_expression] = STATE(6093),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4778),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4780),
    [anon_sym_dynamic] = ACTIONS(4782),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [717] = {
    [sym_expression] = STATE(6037),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8541),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [718] = {
    [sym_expression] = STATE(6172),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4482),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4486),
    [anon_sym_dynamic] = ACTIONS(4488),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [719] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7710),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4786),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [720] = {
    [sym_expression] = STATE(6302),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4788),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4790),
    [anon_sym_dynamic] = ACTIONS(4792),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [721] = {
    [sym_expression] = STATE(6288),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9114),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [722] = {
    [sym_expression] = STATE(6414),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9096),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [723] = {
    [sym_expression] = STATE(6269),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4794),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4796),
    [anon_sym_dynamic] = ACTIONS(4798),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [724] = {
    [ts_builtin_sym_end] = ACTIONS(4717),
    [anon_sym_LBRACE] = ACTIONS(4717),
    [anon_sym_RBRACE] = ACTIONS(4717),
    [anon_sym_COMMA] = ACTIONS(4717),
    [anon_sym_COLON_COLON] = ACTIONS(4717),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(4717),
    [anon_sym_EQ] = ACTIONS(4722),
    [anon_sym_COLON] = ACTIONS(4722),
    [anon_sym_PIPE] = ACTIONS(4734),
    [anon_sym_COLON_EQ] = ACTIONS(4717),
    [anon_sym_LPAREN] = ACTIONS(4717),
    [anon_sym_PLUS_EQ] = ACTIONS(4717),
    [anon_sym_DASH_EQ] = ACTIONS(4717),
    [anon_sym_STAR_EQ] = ACTIONS(4717),
    [anon_sym_SLASH_EQ] = ACTIONS(4717),
    [anon_sym_PERCENT_EQ] = ACTIONS(4717),
    [anon_sym_AMP_EQ] = ACTIONS(4717),
    [anon_sym_PIPE_EQ] = ACTIONS(4717),
    [anon_sym_CARET_EQ] = ACTIONS(4717),
    [anon_sym_LT_LT_EQ] = ACTIONS(4717),
    [anon_sym_GT_GT_EQ] = ACTIONS(4717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4717),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4717),
    [anon_sym_if] = ACTIONS(4717),
    [anon_sym_SEMI] = ACTIONS(4717),
    [anon_sym_else] = ACTIONS(4717),
    [anon_sym_when] = ACTIONS(4717),
    [anon_sym_in] = ACTIONS(4717),
    [anon_sym_case] = ACTIONS(4717),
    [anon_sym_QMARK] = ACTIONS(4717),
    [anon_sym_PLUS] = ACTIONS(4736),
    [anon_sym_DASH] = ACTIONS(4736),
    [anon_sym_TILDE] = ACTIONS(4738),
    [anon_sym_AMP] = ACTIONS(4740),
    [anon_sym_PIPE_PIPE] = ACTIONS(4742),
    [anon_sym_or_else] = ACTIONS(4744),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_GT] = ACTIONS(4748),
    [anon_sym_GT_EQ] = ACTIONS(4750),
    [anon_sym_LT_EQ] = ACTIONS(4750),
    [anon_sym_LT] = ACTIONS(4748),
    [anon_sym_EQ_EQ] = ACTIONS(4752),
    [anon_sym_BANG_EQ] = ACTIONS(4752),
    [anon_sym_TILDE_EQ] = ACTIONS(4752),
    [anon_sym_AMP_TILDE] = ACTIONS(4754),
    [anon_sym_LT_LT] = ACTIONS(4756),
    [anon_sym_GT_GT] = ACTIONS(4756),
    [anon_sym_STAR] = ACTIONS(4758),
    [anon_sym_SLASH] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4760),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(4717),
    [anon_sym_or_return] = ACTIONS(4768),
    [anon_sym_or_continue] = ACTIONS(4770),
    [anon_sym_or_break] = ACTIONS(4772),
    [anon_sym_CARET] = ACTIONS(4774),
    [sym_uninitialized] = ACTIONS(4717),
    [sym_tag] = ACTIONS(4717),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4717),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [725] = {
    [sym_expression] = STATE(6000),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8409),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [726] = {
    [sym_expression] = STATE(6229),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4321),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4325),
    [anon_sym_dynamic] = ACTIONS(4327),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [727] = {
    [ts_builtin_sym_end] = ACTIONS(4800),
    [anon_sym_LBRACE] = ACTIONS(4802),
    [anon_sym_RBRACE] = ACTIONS(4800),
    [anon_sym_COMMA] = ACTIONS(4800),
    [anon_sym_COLON_COLON] = ACTIONS(4800),
    [anon_sym_DASH_GT] = ACTIONS(4800),
    [anon_sym_where] = ACTIONS(4800),
    [anon_sym_EQ] = ACTIONS(4804),
    [anon_sym_COLON] = ACTIONS(4804),
    [anon_sym_PIPE] = ACTIONS(4804),
    [anon_sym_COLON_EQ] = ACTIONS(4800),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(4800),
    [anon_sym_DASH_EQ] = ACTIONS(4800),
    [anon_sym_STAR_EQ] = ACTIONS(4800),
    [anon_sym_SLASH_EQ] = ACTIONS(4800),
    [anon_sym_PERCENT_EQ] = ACTIONS(4800),
    [anon_sym_AMP_EQ] = ACTIONS(4800),
    [anon_sym_PIPE_EQ] = ACTIONS(4800),
    [anon_sym_CARET_EQ] = ACTIONS(4800),
    [anon_sym_LT_LT_EQ] = ACTIONS(4800),
    [anon_sym_GT_GT_EQ] = ACTIONS(4800),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4800),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4800),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4800),
    [anon_sym_if] = ACTIONS(4800),
    [anon_sym_SEMI] = ACTIONS(4800),
    [anon_sym_else] = ACTIONS(4800),
    [anon_sym_when] = ACTIONS(4800),
    [anon_sym_in] = ACTIONS(4800),
    [anon_sym_case] = ACTIONS(4800),
    [anon_sym_QMARK] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4804),
    [anon_sym_DASH] = ACTIONS(4804),
    [anon_sym_TILDE] = ACTIONS(4804),
    [anon_sym_AMP] = ACTIONS(4804),
    [anon_sym_PIPE_PIPE] = ACTIONS(4804),
    [anon_sym_or_else] = ACTIONS(4800),
    [anon_sym_AMP_AMP] = ACTIONS(4804),
    [anon_sym_GT] = ACTIONS(4804),
    [anon_sym_GT_EQ] = ACTIONS(4800),
    [anon_sym_LT_EQ] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4804),
    [anon_sym_EQ_EQ] = ACTIONS(4800),
    [anon_sym_BANG_EQ] = ACTIONS(4800),
    [anon_sym_TILDE_EQ] = ACTIONS(4800),
    [anon_sym_AMP_TILDE] = ACTIONS(4804),
    [anon_sym_LT_LT] = ACTIONS(4804),
    [anon_sym_GT_GT] = ACTIONS(4804),
    [anon_sym_STAR] = ACTIONS(4804),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(4804),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4800),
    [anon_sym_DOT] = ACTIONS(4804),
    [anon_sym_LBRACK] = ACTIONS(4800),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4800),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4800),
    [anon_sym_not_in] = ACTIONS(4800),
    [anon_sym_or_return] = ACTIONS(4800),
    [anon_sym_or_continue] = ACTIONS(4800),
    [anon_sym_or_break] = ACTIONS(4800),
    [anon_sym_CARET] = ACTIONS(4804),
    [sym_uninitialized] = ACTIONS(4800),
    [sym_tag] = ACTIONS(4800),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4800),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [728] = {
    [ts_builtin_sym_end] = ACTIONS(4618),
    [anon_sym_LBRACE] = ACTIONS(4618),
    [anon_sym_RBRACE] = ACTIONS(4618),
    [anon_sym_COMMA] = ACTIONS(4618),
    [anon_sym_COLON_COLON] = ACTIONS(4618),
    [anon_sym_DASH_GT] = ACTIONS(4618),
    [anon_sym_where] = ACTIONS(4618),
    [anon_sym_EQ] = ACTIONS(4623),
    [anon_sym_COLON] = ACTIONS(4623),
    [anon_sym_PIPE] = ACTIONS(4623),
    [anon_sym_COLON_EQ] = ACTIONS(4618),
    [anon_sym_LPAREN] = ACTIONS(4618),
    [anon_sym_PLUS_EQ] = ACTIONS(4618),
    [anon_sym_DASH_EQ] = ACTIONS(4618),
    [anon_sym_STAR_EQ] = ACTIONS(4618),
    [anon_sym_SLASH_EQ] = ACTIONS(4618),
    [anon_sym_PERCENT_EQ] = ACTIONS(4618),
    [anon_sym_AMP_EQ] = ACTIONS(4618),
    [anon_sym_PIPE_EQ] = ACTIONS(4618),
    [anon_sym_CARET_EQ] = ACTIONS(4618),
    [anon_sym_LT_LT_EQ] = ACTIONS(4618),
    [anon_sym_GT_GT_EQ] = ACTIONS(4618),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4618),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4618),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4618),
    [anon_sym_if] = ACTIONS(4618),
    [anon_sym_SEMI] = ACTIONS(4618),
    [anon_sym_else] = ACTIONS(4618),
    [anon_sym_when] = ACTIONS(4618),
    [anon_sym_in] = ACTIONS(4618),
    [anon_sym_case] = ACTIONS(4618),
    [anon_sym_QMARK] = ACTIONS(4618),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_DASH] = ACTIONS(4623),
    [anon_sym_TILDE] = ACTIONS(4623),
    [anon_sym_AMP] = ACTIONS(4623),
    [anon_sym_PIPE_PIPE] = ACTIONS(4623),
    [anon_sym_or_else] = ACTIONS(4618),
    [anon_sym_AMP_AMP] = ACTIONS(4623),
    [anon_sym_GT] = ACTIONS(4623),
    [anon_sym_GT_EQ] = ACTIONS(4618),
    [anon_sym_LT_EQ] = ACTIONS(4618),
    [anon_sym_LT] = ACTIONS(4623),
    [anon_sym_EQ_EQ] = ACTIONS(4618),
    [anon_sym_BANG_EQ] = ACTIONS(4618),
    [anon_sym_TILDE_EQ] = ACTIONS(4618),
    [anon_sym_AMP_TILDE] = ACTIONS(4623),
    [anon_sym_LT_LT] = ACTIONS(4623),
    [anon_sym_GT_GT] = ACTIONS(4623),
    [anon_sym_STAR] = ACTIONS(4623),
    [anon_sym_SLASH] = ACTIONS(4623),
    [anon_sym_PERCENT] = ACTIONS(4623),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4618),
    [anon_sym_DOT] = ACTIONS(4623),
    [anon_sym_LBRACK] = ACTIONS(4618),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4618),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4618),
    [anon_sym_not_in] = ACTIONS(4618),
    [anon_sym_or_return] = ACTIONS(4618),
    [anon_sym_or_continue] = ACTIONS(4618),
    [anon_sym_or_break] = ACTIONS(4618),
    [anon_sym_CARET] = ACTIONS(4623),
    [sym_uninitialized] = ACTIONS(4618),
    [sym_tag] = ACTIONS(4618),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4618),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [729] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4806),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [730] = {
    [sym_expression] = STATE(6087),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4808),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4810),
    [anon_sym_dynamic] = ACTIONS(4812),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [731] = {
    [sym_expression] = STATE(6303),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9118),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [732] = {
    [sym_expression] = STATE(6456),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8954),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [733] = {
    [sym_expression] = STATE(6064),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4814),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4816),
    [anon_sym_dynamic] = ACTIONS(4818),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [734] = {
    [sym_expression] = STATE(6033),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8522),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [735] = {
    [sym_expression] = STATE(6050),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4355),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4359),
    [anon_sym_dynamic] = ACTIONS(4361),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [736] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8145),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4820),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [737] = {
    [sym_expression] = STATE(6317),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8890),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [738] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4822),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [739] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8149),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4822),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [740] = {
    [sym_expression] = STATE(6019),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8532),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [741] = {
    [sym_expression] = STATE(6258),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4824),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4826),
    [anon_sym_dynamic] = ACTIONS(4828),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [742] = {
    [sym_expression] = STATE(6243),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9096),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [743] = {
    [sym_expression] = STATE(6331),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9114),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [744] = {
    [sym_expression] = STATE(6301),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4830),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4832),
    [anon_sym_dynamic] = ACTIONS(4834),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [745] = {
    [sym_expression] = STATE(6322),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8884),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [746] = {
    [sym_expression] = STATE(6021),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8593),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [747] = {
    [sym_expression] = STATE(6351),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4365),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4369),
    [anon_sym_dynamic] = ACTIONS(4371),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [748] = {
    [sym_procedure] = STATE(7866),
    [sym_expression] = STATE(5878),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(4836),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [749] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8309),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4838),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [750] = {
    [sym_expression] = STATE(6335),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8873),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [751] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4840),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [752] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4838),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [753] = {
    [sym_expression] = STATE(6347),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4842),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4844),
    [anon_sym_dynamic] = ACTIONS(4846),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [754] = {
    [sym_expression] = STATE(6339),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9175),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [755] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4848),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [756] = {
    [sym_expression] = STATE(6455),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9175),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [757] = {
    [sym_expression] = STATE(6450),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4850),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4852),
    [anon_sym_dynamic] = ACTIONS(4854),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [758] = {
    [ts_builtin_sym_end] = ACTIONS(4856),
    [anon_sym_LBRACE] = ACTIONS(4856),
    [anon_sym_RBRACE] = ACTIONS(4856),
    [anon_sym_COMMA] = ACTIONS(4856),
    [anon_sym_COLON_COLON] = ACTIONS(4856),
    [anon_sym_DASH_GT] = ACTIONS(4856),
    [anon_sym_where] = ACTIONS(4856),
    [anon_sym_EQ] = ACTIONS(4858),
    [anon_sym_COLON] = ACTIONS(4858),
    [anon_sym_PIPE] = ACTIONS(4858),
    [anon_sym_COLON_EQ] = ACTIONS(4856),
    [anon_sym_LPAREN] = ACTIONS(4856),
    [anon_sym_PLUS_EQ] = ACTIONS(4856),
    [anon_sym_DASH_EQ] = ACTIONS(4856),
    [anon_sym_STAR_EQ] = ACTIONS(4856),
    [anon_sym_SLASH_EQ] = ACTIONS(4856),
    [anon_sym_PERCENT_EQ] = ACTIONS(4856),
    [anon_sym_AMP_EQ] = ACTIONS(4856),
    [anon_sym_PIPE_EQ] = ACTIONS(4856),
    [anon_sym_CARET_EQ] = ACTIONS(4856),
    [anon_sym_LT_LT_EQ] = ACTIONS(4856),
    [anon_sym_GT_GT_EQ] = ACTIONS(4856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4856),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4856),
    [anon_sym_if] = ACTIONS(4856),
    [anon_sym_SEMI] = ACTIONS(4856),
    [anon_sym_else] = ACTIONS(4856),
    [anon_sym_when] = ACTIONS(4856),
    [anon_sym_in] = ACTIONS(4856),
    [anon_sym_case] = ACTIONS(4856),
    [anon_sym_QMARK] = ACTIONS(4856),
    [anon_sym_PLUS] = ACTIONS(4858),
    [anon_sym_DASH] = ACTIONS(4858),
    [anon_sym_TILDE] = ACTIONS(4858),
    [anon_sym_AMP] = ACTIONS(4858),
    [anon_sym_PIPE_PIPE] = ACTIONS(4858),
    [anon_sym_or_else] = ACTIONS(4856),
    [anon_sym_AMP_AMP] = ACTIONS(4858),
    [anon_sym_GT] = ACTIONS(4858),
    [anon_sym_GT_EQ] = ACTIONS(4856),
    [anon_sym_LT_EQ] = ACTIONS(4856),
    [anon_sym_LT] = ACTIONS(4858),
    [anon_sym_EQ_EQ] = ACTIONS(4856),
    [anon_sym_BANG_EQ] = ACTIONS(4856),
    [anon_sym_TILDE_EQ] = ACTIONS(4856),
    [anon_sym_AMP_TILDE] = ACTIONS(4858),
    [anon_sym_LT_LT] = ACTIONS(4858),
    [anon_sym_GT_GT] = ACTIONS(4858),
    [anon_sym_STAR] = ACTIONS(4858),
    [anon_sym_SLASH] = ACTIONS(4858),
    [anon_sym_PERCENT] = ACTIONS(4858),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4856),
    [anon_sym_DOT] = ACTIONS(4858),
    [anon_sym_LBRACK] = ACTIONS(4856),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4856),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4856),
    [anon_sym_not_in] = ACTIONS(4856),
    [anon_sym_or_return] = ACTIONS(4856),
    [anon_sym_or_continue] = ACTIONS(4856),
    [anon_sym_or_break] = ACTIONS(4856),
    [anon_sym_CARET] = ACTIONS(4858),
    [sym_uninitialized] = ACTIONS(4856),
    [sym_tag] = ACTIONS(4856),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4856),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [759] = {
    [sym_expression] = STATE(6010),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8574),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [760] = {
    [sym_procedure] = STATE(6896),
    [sym_expression] = STATE(4841),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(4860),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [761] = {
    [sym_expression] = STATE(6247),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3939),
    [anon_sym_dynamic] = ACTIONS(3941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [762] = {
    [ts_builtin_sym_end] = ACTIONS(4862),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_RBRACE] = ACTIONS(4862),
    [anon_sym_COMMA] = ACTIONS(4862),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_DASH_GT] = ACTIONS(4862),
    [anon_sym_where] = ACTIONS(4862),
    [anon_sym_EQ] = ACTIONS(4864),
    [anon_sym_COLON] = ACTIONS(4864),
    [anon_sym_PIPE] = ACTIONS(4864),
    [anon_sym_COLON_EQ] = ACTIONS(4862),
    [anon_sym_LPAREN] = ACTIONS(4862),
    [anon_sym_PLUS_EQ] = ACTIONS(4862),
    [anon_sym_DASH_EQ] = ACTIONS(4862),
    [anon_sym_STAR_EQ] = ACTIONS(4862),
    [anon_sym_SLASH_EQ] = ACTIONS(4862),
    [anon_sym_PERCENT_EQ] = ACTIONS(4862),
    [anon_sym_AMP_EQ] = ACTIONS(4862),
    [anon_sym_PIPE_EQ] = ACTIONS(4862),
    [anon_sym_CARET_EQ] = ACTIONS(4862),
    [anon_sym_LT_LT_EQ] = ACTIONS(4862),
    [anon_sym_GT_GT_EQ] = ACTIONS(4862),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4862),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4862),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4862),
    [anon_sym_if] = ACTIONS(4862),
    [anon_sym_SEMI] = ACTIONS(4862),
    [anon_sym_else] = ACTIONS(4862),
    [anon_sym_when] = ACTIONS(4862),
    [anon_sym_in] = ACTIONS(4862),
    [anon_sym_case] = ACTIONS(4862),
    [anon_sym_QMARK] = ACTIONS(4862),
    [anon_sym_PLUS] = ACTIONS(4864),
    [anon_sym_DASH] = ACTIONS(4864),
    [anon_sym_TILDE] = ACTIONS(4864),
    [anon_sym_AMP] = ACTIONS(4864),
    [anon_sym_PIPE_PIPE] = ACTIONS(4864),
    [anon_sym_or_else] = ACTIONS(4862),
    [anon_sym_AMP_AMP] = ACTIONS(4864),
    [anon_sym_GT] = ACTIONS(4864),
    [anon_sym_GT_EQ] = ACTIONS(4862),
    [anon_sym_LT_EQ] = ACTIONS(4862),
    [anon_sym_LT] = ACTIONS(4864),
    [anon_sym_EQ_EQ] = ACTIONS(4862),
    [anon_sym_BANG_EQ] = ACTIONS(4862),
    [anon_sym_TILDE_EQ] = ACTIONS(4862),
    [anon_sym_AMP_TILDE] = ACTIONS(4864),
    [anon_sym_LT_LT] = ACTIONS(4864),
    [anon_sym_GT_GT] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4864),
    [anon_sym_SLASH] = ACTIONS(4864),
    [anon_sym_PERCENT] = ACTIONS(4864),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4862),
    [anon_sym_DOT] = ACTIONS(4864),
    [anon_sym_LBRACK] = ACTIONS(4862),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4862),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4862),
    [anon_sym_not_in] = ACTIONS(4862),
    [anon_sym_or_return] = ACTIONS(4862),
    [anon_sym_or_continue] = ACTIONS(4862),
    [anon_sym_or_break] = ACTIONS(4862),
    [anon_sym_CARET] = ACTIONS(4864),
    [sym_uninitialized] = ACTIONS(4862),
    [sym_tag] = ACTIONS(4862),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4862),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [763] = {
    [sym_expression] = STATE(6071),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8954),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [764] = {
    [sym_expression] = STATE(6232),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4866),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4868),
    [anon_sym_dynamic] = ACTIONS(4870),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [765] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4872),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [766] = {
    [sym_procedure] = STATE(6922),
    [sym_expression] = STATE(4909),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [767] = {
    [sym_expression] = STATE(6345),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8869),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [768] = {
    [sym_expression] = STATE(6259),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4055),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4059),
    [anon_sym_dynamic] = ACTIONS(4061),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [769] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8368),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4848),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [770] = {
    [sym_expression] = STATE(6007),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8596),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [771] = {
    [sym_expression] = STATE(6223),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4874),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4876),
    [anon_sym_dynamic] = ACTIONS(4878),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [772] = {
    [sym_expression] = STATE(6206),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9130),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [773] = {
    [sym_expression] = STATE(6280),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8745),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [774] = {
    [sym_expression] = STATE(6174),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4880),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4882),
    [anon_sym_dynamic] = ACTIONS(4884),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [775] = {
    [sym_expression] = STATE(6175),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8846),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [776] = {
    [sym_expression] = STATE(6392),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8846),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [777] = {
    [sym_expression] = STATE(6185),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4886),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4888),
    [anon_sym_dynamic] = ACTIONS(4890),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [778] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4892),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [779] = {
    [sym_expression] = STATE(5991),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8438),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [780] = {
    [sym_expression] = STATE(6201),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4135),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4139),
    [anon_sym_dynamic] = ACTIONS(4141),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [781] = {
    [sym_expression] = STATE(6198),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4894),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4896),
    [anon_sym_dynamic] = ACTIONS(4898),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [782] = {
    [sym_expression] = STATE(6155),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4900),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4902),
    [anon_sym_dynamic] = ACTIONS(4904),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [783] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4906),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [784] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4908),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [785] = {
    [sym_expression] = STATE(6362),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8861),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [786] = {
    [sym_expression] = STATE(6091),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4243),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4247),
    [anon_sym_dynamic] = ACTIONS(4249),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [787] = {
    [sym_expression] = STATE(6030),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8533),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [788] = {
    [sym_procedure] = STATE(8236),
    [sym_expression] = STATE(5899),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(4910),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [789] = {
    [sym_expression] = STATE(6121),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4912),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4914),
    [anon_sym_dynamic] = ACTIONS(4916),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [790] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4918),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [791] = {
    [sym_expression] = STATE(6289),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8998),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [792] = {
    [ts_builtin_sym_end] = ACTIONS(4920),
    [anon_sym_LBRACE] = ACTIONS(4920),
    [anon_sym_RBRACE] = ACTIONS(4920),
    [anon_sym_COMMA] = ACTIONS(4920),
    [anon_sym_COLON_COLON] = ACTIONS(4920),
    [anon_sym_DASH_GT] = ACTIONS(4920),
    [anon_sym_where] = ACTIONS(4920),
    [anon_sym_EQ] = ACTIONS(4922),
    [anon_sym_COLON] = ACTIONS(4922),
    [anon_sym_PIPE] = ACTIONS(4922),
    [anon_sym_COLON_EQ] = ACTIONS(4920),
    [anon_sym_LPAREN] = ACTIONS(4920),
    [anon_sym_PLUS_EQ] = ACTIONS(4920),
    [anon_sym_DASH_EQ] = ACTIONS(4920),
    [anon_sym_STAR_EQ] = ACTIONS(4920),
    [anon_sym_SLASH_EQ] = ACTIONS(4920),
    [anon_sym_PERCENT_EQ] = ACTIONS(4920),
    [anon_sym_AMP_EQ] = ACTIONS(4920),
    [anon_sym_PIPE_EQ] = ACTIONS(4920),
    [anon_sym_CARET_EQ] = ACTIONS(4920),
    [anon_sym_LT_LT_EQ] = ACTIONS(4920),
    [anon_sym_GT_GT_EQ] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4920),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4920),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4920),
    [anon_sym_if] = ACTIONS(4920),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_else] = ACTIONS(4920),
    [anon_sym_when] = ACTIONS(4920),
    [anon_sym_in] = ACTIONS(4920),
    [anon_sym_case] = ACTIONS(4920),
    [anon_sym_QMARK] = ACTIONS(4920),
    [anon_sym_PLUS] = ACTIONS(4922),
    [anon_sym_DASH] = ACTIONS(4922),
    [anon_sym_TILDE] = ACTIONS(4922),
    [anon_sym_AMP] = ACTIONS(4922),
    [anon_sym_PIPE_PIPE] = ACTIONS(4922),
    [anon_sym_or_else] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4922),
    [anon_sym_GT] = ACTIONS(4922),
    [anon_sym_GT_EQ] = ACTIONS(4920),
    [anon_sym_LT_EQ] = ACTIONS(4920),
    [anon_sym_LT] = ACTIONS(4922),
    [anon_sym_EQ_EQ] = ACTIONS(4920),
    [anon_sym_BANG_EQ] = ACTIONS(4920),
    [anon_sym_TILDE_EQ] = ACTIONS(4920),
    [anon_sym_AMP_TILDE] = ACTIONS(4922),
    [anon_sym_LT_LT] = ACTIONS(4922),
    [anon_sym_GT_GT] = ACTIONS(4922),
    [anon_sym_STAR] = ACTIONS(4922),
    [anon_sym_SLASH] = ACTIONS(4922),
    [anon_sym_PERCENT] = ACTIONS(4922),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4920),
    [anon_sym_DOT] = ACTIONS(4922),
    [anon_sym_LBRACK] = ACTIONS(4920),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4920),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4920),
    [anon_sym_not_in] = ACTIONS(4920),
    [anon_sym_or_return] = ACTIONS(4920),
    [anon_sym_or_continue] = ACTIONS(4920),
    [anon_sym_or_break] = ACTIONS(4920),
    [anon_sym_CARET] = ACTIONS(4922),
    [sym_uninitialized] = ACTIONS(4920),
    [sym_tag] = ACTIONS(4920),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4920),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [793] = {
    [sym_expression] = STATE(6209),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9126),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [794] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4924),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [795] = {
    [sym_expression] = STATE(6379),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8811),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [796] = {
    [ts_builtin_sym_end] = ACTIONS(4926),
    [anon_sym_LBRACE] = ACTIONS(4926),
    [anon_sym_RBRACE] = ACTIONS(4926),
    [anon_sym_COMMA] = ACTIONS(4926),
    [anon_sym_COLON_COLON] = ACTIONS(4926),
    [anon_sym_DASH_GT] = ACTIONS(4926),
    [anon_sym_where] = ACTIONS(4926),
    [anon_sym_EQ] = ACTIONS(4928),
    [anon_sym_COLON] = ACTIONS(4928),
    [anon_sym_PIPE] = ACTIONS(4928),
    [anon_sym_COLON_EQ] = ACTIONS(4926),
    [anon_sym_LPAREN] = ACTIONS(4926),
    [anon_sym_PLUS_EQ] = ACTIONS(4926),
    [anon_sym_DASH_EQ] = ACTIONS(4926),
    [anon_sym_STAR_EQ] = ACTIONS(4926),
    [anon_sym_SLASH_EQ] = ACTIONS(4926),
    [anon_sym_PERCENT_EQ] = ACTIONS(4926),
    [anon_sym_AMP_EQ] = ACTIONS(4926),
    [anon_sym_PIPE_EQ] = ACTIONS(4926),
    [anon_sym_CARET_EQ] = ACTIONS(4926),
    [anon_sym_LT_LT_EQ] = ACTIONS(4926),
    [anon_sym_GT_GT_EQ] = ACTIONS(4926),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4926),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4926),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4926),
    [anon_sym_if] = ACTIONS(4926),
    [anon_sym_SEMI] = ACTIONS(4926),
    [anon_sym_else] = ACTIONS(4926),
    [anon_sym_when] = ACTIONS(4926),
    [anon_sym_in] = ACTIONS(4926),
    [anon_sym_case] = ACTIONS(4926),
    [anon_sym_QMARK] = ACTIONS(4926),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_DASH] = ACTIONS(4928),
    [anon_sym_TILDE] = ACTIONS(4928),
    [anon_sym_AMP] = ACTIONS(4928),
    [anon_sym_PIPE_PIPE] = ACTIONS(4928),
    [anon_sym_or_else] = ACTIONS(4926),
    [anon_sym_AMP_AMP] = ACTIONS(4928),
    [anon_sym_GT] = ACTIONS(4928),
    [anon_sym_GT_EQ] = ACTIONS(4926),
    [anon_sym_LT_EQ] = ACTIONS(4926),
    [anon_sym_LT] = ACTIONS(4928),
    [anon_sym_EQ_EQ] = ACTIONS(4926),
    [anon_sym_BANG_EQ] = ACTIONS(4926),
    [anon_sym_TILDE_EQ] = ACTIONS(4926),
    [anon_sym_AMP_TILDE] = ACTIONS(4928),
    [anon_sym_LT_LT] = ACTIONS(4928),
    [anon_sym_GT_GT] = ACTIONS(4928),
    [anon_sym_STAR] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4928),
    [anon_sym_PERCENT] = ACTIONS(4928),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4926),
    [anon_sym_DOT] = ACTIONS(4928),
    [anon_sym_LBRACK] = ACTIONS(4926),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4926),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4926),
    [anon_sym_not_in] = ACTIONS(4926),
    [anon_sym_or_return] = ACTIONS(4926),
    [anon_sym_or_continue] = ACTIONS(4926),
    [anon_sym_or_break] = ACTIONS(4926),
    [anon_sym_CARET] = ACTIONS(4928),
    [sym_uninitialized] = ACTIONS(4926),
    [sym_tag] = ACTIONS(4926),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4926),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [797] = {
    [sym_expression] = STATE(6311),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4930),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4932),
    [anon_sym_dynamic] = ACTIONS(4934),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [798] = {
    [sym_expression] = STATE(6314),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8737),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [799] = {
    [sym_expression] = STATE(6184),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8737),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [800] = {
    [sym_expression] = STATE(6319),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4936),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4938),
    [anon_sym_dynamic] = ACTIONS(4940),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [801] = {
    [sym_expression] = STATE(6134),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4942),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4944),
    [anon_sym_dynamic] = ACTIONS(4946),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [802] = {
    [ts_builtin_sym_end] = ACTIONS(4948),
    [anon_sym_LBRACE] = ACTIONS(4948),
    [anon_sym_RBRACE] = ACTIONS(4948),
    [anon_sym_COMMA] = ACTIONS(4948),
    [anon_sym_COLON_COLON] = ACTIONS(4948),
    [anon_sym_DASH_GT] = ACTIONS(4948),
    [anon_sym_where] = ACTIONS(4948),
    [anon_sym_EQ] = ACTIONS(4950),
    [anon_sym_COLON] = ACTIONS(4950),
    [anon_sym_PIPE] = ACTIONS(4950),
    [anon_sym_COLON_EQ] = ACTIONS(4948),
    [anon_sym_LPAREN] = ACTIONS(4948),
    [anon_sym_PLUS_EQ] = ACTIONS(4948),
    [anon_sym_DASH_EQ] = ACTIONS(4948),
    [anon_sym_STAR_EQ] = ACTIONS(4948),
    [anon_sym_SLASH_EQ] = ACTIONS(4948),
    [anon_sym_PERCENT_EQ] = ACTIONS(4948),
    [anon_sym_AMP_EQ] = ACTIONS(4948),
    [anon_sym_PIPE_EQ] = ACTIONS(4948),
    [anon_sym_CARET_EQ] = ACTIONS(4948),
    [anon_sym_LT_LT_EQ] = ACTIONS(4948),
    [anon_sym_GT_GT_EQ] = ACTIONS(4948),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4948),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4948),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4948),
    [anon_sym_if] = ACTIONS(4948),
    [anon_sym_SEMI] = ACTIONS(4948),
    [anon_sym_else] = ACTIONS(4948),
    [anon_sym_when] = ACTIONS(4948),
    [anon_sym_in] = ACTIONS(4948),
    [anon_sym_case] = ACTIONS(4948),
    [anon_sym_QMARK] = ACTIONS(4948),
    [anon_sym_PLUS] = ACTIONS(4950),
    [anon_sym_DASH] = ACTIONS(4950),
    [anon_sym_TILDE] = ACTIONS(4950),
    [anon_sym_AMP] = ACTIONS(4950),
    [anon_sym_PIPE_PIPE] = ACTIONS(4950),
    [anon_sym_or_else] = ACTIONS(4948),
    [anon_sym_AMP_AMP] = ACTIONS(4950),
    [anon_sym_GT] = ACTIONS(4950),
    [anon_sym_GT_EQ] = ACTIONS(4948),
    [anon_sym_LT_EQ] = ACTIONS(4948),
    [anon_sym_LT] = ACTIONS(4950),
    [anon_sym_EQ_EQ] = ACTIONS(4948),
    [anon_sym_BANG_EQ] = ACTIONS(4948),
    [anon_sym_TILDE_EQ] = ACTIONS(4948),
    [anon_sym_AMP_TILDE] = ACTIONS(4950),
    [anon_sym_LT_LT] = ACTIONS(4950),
    [anon_sym_GT_GT] = ACTIONS(4950),
    [anon_sym_STAR] = ACTIONS(4950),
    [anon_sym_SLASH] = ACTIONS(4950),
    [anon_sym_PERCENT] = ACTIONS(4950),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4948),
    [anon_sym_DOT] = ACTIONS(4950),
    [anon_sym_LBRACK] = ACTIONS(4948),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4948),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4948),
    [anon_sym_not_in] = ACTIONS(4948),
    [anon_sym_or_return] = ACTIONS(4948),
    [anon_sym_or_continue] = ACTIONS(4948),
    [anon_sym_or_break] = ACTIONS(4948),
    [anon_sym_CARET] = ACTIONS(4950),
    [sym_uninitialized] = ACTIONS(4948),
    [sym_tag] = ACTIONS(4948),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4948),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [803] = {
    [sym_procedure] = STATE(8143),
    [sym_expression] = STATE(5915),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(4952),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [804] = {
    [sym_expression] = STATE(6028),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8532),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [805] = {
    [sym_expression] = STATE(6386),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3905),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3909),
    [anon_sym_dynamic] = ACTIONS(3911),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [806] = {
    [sym_procedure] = STATE(8553),
    [sym_expression] = STATE(6038),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [807] = {
    [sym_expression] = STATE(6401),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8777),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [808] = {
    [sym_expression] = STATE(6410),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8739),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [809] = {
    [sym_expression] = STATE(6242),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3985),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3989),
    [anon_sym_dynamic] = ACTIONS(3991),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [810] = {
    [ts_builtin_sym_end] = ACTIONS(4920),
    [anon_sym_LBRACE] = ACTIONS(4920),
    [anon_sym_RBRACE] = ACTIONS(4920),
    [anon_sym_COMMA] = ACTIONS(4920),
    [anon_sym_COLON_COLON] = ACTIONS(4920),
    [anon_sym_DASH_GT] = ACTIONS(4920),
    [anon_sym_where] = ACTIONS(4920),
    [anon_sym_EQ] = ACTIONS(4922),
    [anon_sym_COLON] = ACTIONS(4922),
    [anon_sym_PIPE] = ACTIONS(4922),
    [anon_sym_COLON_EQ] = ACTIONS(4920),
    [anon_sym_LPAREN] = ACTIONS(4920),
    [anon_sym_PLUS_EQ] = ACTIONS(4920),
    [anon_sym_DASH_EQ] = ACTIONS(4920),
    [anon_sym_STAR_EQ] = ACTIONS(4920),
    [anon_sym_SLASH_EQ] = ACTIONS(4920),
    [anon_sym_PERCENT_EQ] = ACTIONS(4920),
    [anon_sym_AMP_EQ] = ACTIONS(4920),
    [anon_sym_PIPE_EQ] = ACTIONS(4920),
    [anon_sym_CARET_EQ] = ACTIONS(4920),
    [anon_sym_LT_LT_EQ] = ACTIONS(4920),
    [anon_sym_GT_GT_EQ] = ACTIONS(4920),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4920),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4920),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4920),
    [anon_sym_if] = ACTIONS(4954),
    [anon_sym_SEMI] = ACTIONS(4920),
    [anon_sym_else] = ACTIONS(4920),
    [anon_sym_when] = ACTIONS(4954),
    [anon_sym_in] = ACTIONS(4920),
    [anon_sym_case] = ACTIONS(4920),
    [anon_sym_QMARK] = ACTIONS(4956),
    [anon_sym_PLUS] = ACTIONS(4922),
    [anon_sym_DASH] = ACTIONS(4922),
    [anon_sym_TILDE] = ACTIONS(4922),
    [anon_sym_AMP] = ACTIONS(4922),
    [anon_sym_PIPE_PIPE] = ACTIONS(4922),
    [anon_sym_or_else] = ACTIONS(4920),
    [anon_sym_AMP_AMP] = ACTIONS(4922),
    [anon_sym_GT] = ACTIONS(4922),
    [anon_sym_GT_EQ] = ACTIONS(4920),
    [anon_sym_LT_EQ] = ACTIONS(4920),
    [anon_sym_LT] = ACTIONS(4922),
    [anon_sym_EQ_EQ] = ACTIONS(4920),
    [anon_sym_BANG_EQ] = ACTIONS(4920),
    [anon_sym_TILDE_EQ] = ACTIONS(4920),
    [anon_sym_AMP_TILDE] = ACTIONS(4922),
    [anon_sym_LT_LT] = ACTIONS(4922),
    [anon_sym_GT_GT] = ACTIONS(4922),
    [anon_sym_STAR] = ACTIONS(4922),
    [anon_sym_SLASH] = ACTIONS(4922),
    [anon_sym_PERCENT] = ACTIONS(4922),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4920),
    [anon_sym_DOT] = ACTIONS(4922),
    [anon_sym_LBRACK] = ACTIONS(4920),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4920),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4920),
    [anon_sym_not_in] = ACTIONS(4920),
    [anon_sym_or_return] = ACTIONS(4920),
    [anon_sym_or_continue] = ACTIONS(4920),
    [anon_sym_or_break] = ACTIONS(4920),
    [anon_sym_CARET] = ACTIONS(4922),
    [sym_uninitialized] = ACTIONS(4920),
    [sym_tag] = ACTIONS(4920),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4920),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [811] = {
    [sym_expression] = STATE(6009),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8404),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [812] = {
    [sym_expression] = STATE(6272),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4958),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4960),
    [anon_sym_dynamic] = ACTIONS(4962),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [813] = {
    [sym_expression] = STATE(6244),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9292),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [814] = {
    [sym_expression] = STATE(6320),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9130),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [815] = {
    [sym_expression] = STATE(6285),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4964),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4966),
    [anon_sym_dynamic] = ACTIONS(4968),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [816] = {
    [ts_builtin_sym_end] = ACTIONS(4970),
    [anon_sym_LBRACE] = ACTIONS(4970),
    [anon_sym_RBRACE] = ACTIONS(4970),
    [anon_sym_COMMA] = ACTIONS(4970),
    [anon_sym_COLON_COLON] = ACTIONS(4970),
    [anon_sym_DASH_GT] = ACTIONS(4970),
    [anon_sym_where] = ACTIONS(4970),
    [anon_sym_EQ] = ACTIONS(4972),
    [anon_sym_COLON] = ACTIONS(4972),
    [anon_sym_PIPE] = ACTIONS(4972),
    [anon_sym_COLON_EQ] = ACTIONS(4970),
    [anon_sym_LPAREN] = ACTIONS(4970),
    [anon_sym_PLUS_EQ] = ACTIONS(4970),
    [anon_sym_DASH_EQ] = ACTIONS(4970),
    [anon_sym_STAR_EQ] = ACTIONS(4970),
    [anon_sym_SLASH_EQ] = ACTIONS(4970),
    [anon_sym_PERCENT_EQ] = ACTIONS(4970),
    [anon_sym_AMP_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_CARET_EQ] = ACTIONS(4970),
    [anon_sym_LT_LT_EQ] = ACTIONS(4970),
    [anon_sym_GT_GT_EQ] = ACTIONS(4970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4970),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4970),
    [anon_sym_if] = ACTIONS(4970),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_else] = ACTIONS(4970),
    [anon_sym_when] = ACTIONS(4970),
    [anon_sym_in] = ACTIONS(4970),
    [anon_sym_case] = ACTIONS(4970),
    [anon_sym_QMARK] = ACTIONS(4970),
    [anon_sym_PLUS] = ACTIONS(4972),
    [anon_sym_DASH] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [anon_sym_AMP] = ACTIONS(4972),
    [anon_sym_PIPE_PIPE] = ACTIONS(4972),
    [anon_sym_or_else] = ACTIONS(4970),
    [anon_sym_AMP_AMP] = ACTIONS(4972),
    [anon_sym_GT] = ACTIONS(4972),
    [anon_sym_GT_EQ] = ACTIONS(4970),
    [anon_sym_LT_EQ] = ACTIONS(4970),
    [anon_sym_LT] = ACTIONS(4972),
    [anon_sym_EQ_EQ] = ACTIONS(4970),
    [anon_sym_BANG_EQ] = ACTIONS(4970),
    [anon_sym_TILDE_EQ] = ACTIONS(4970),
    [anon_sym_AMP_TILDE] = ACTIONS(4972),
    [anon_sym_LT_LT] = ACTIONS(4972),
    [anon_sym_GT_GT] = ACTIONS(4972),
    [anon_sym_STAR] = ACTIONS(4972),
    [anon_sym_SLASH] = ACTIONS(4972),
    [anon_sym_PERCENT] = ACTIONS(4972),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4970),
    [anon_sym_DOT] = ACTIONS(4972),
    [anon_sym_LBRACK] = ACTIONS(4970),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4970),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4970),
    [anon_sym_not_in] = ACTIONS(4970),
    [anon_sym_or_return] = ACTIONS(4970),
    [anon_sym_or_continue] = ACTIONS(4970),
    [anon_sym_or_break] = ACTIONS(4970),
    [anon_sym_CARET] = ACTIONS(4972),
    [sym_uninitialized] = ACTIONS(4970),
    [sym_tag] = ACTIONS(4970),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4970),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [817] = {
    [sym_expression] = STATE(6391),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3843),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3847),
    [anon_sym_dynamic] = ACTIONS(3849),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [818] = {
    [sym_expression] = STATE(6036),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8506),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [819] = {
    [sym_expression] = STATE(6419),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4974),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4976),
    [anon_sym_dynamic] = ACTIONS(4978),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [820] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4980),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [821] = {
    [sym_expression] = STATE(6222),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8762),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [822] = {
    [sym_expression] = STATE(6425),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8658),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [823] = {
    [sym_expression] = STATE(6217),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9137),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [824] = {
    [sym_expression] = STATE(6432),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4982),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4984),
    [anon_sym_dynamic] = ACTIONS(4986),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [825] = {
    [ts_builtin_sym_end] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4988),
    [anon_sym_RBRACE] = ACTIONS(4988),
    [anon_sym_COMMA] = ACTIONS(4988),
    [anon_sym_COLON_COLON] = ACTIONS(4988),
    [anon_sym_DASH_GT] = ACTIONS(4988),
    [anon_sym_where] = ACTIONS(4988),
    [anon_sym_EQ] = ACTIONS(4990),
    [anon_sym_COLON] = ACTIONS(4990),
    [anon_sym_PIPE] = ACTIONS(4990),
    [anon_sym_COLON_EQ] = ACTIONS(4988),
    [anon_sym_LPAREN] = ACTIONS(4988),
    [anon_sym_PLUS_EQ] = ACTIONS(4988),
    [anon_sym_DASH_EQ] = ACTIONS(4988),
    [anon_sym_STAR_EQ] = ACTIONS(4988),
    [anon_sym_SLASH_EQ] = ACTIONS(4988),
    [anon_sym_PERCENT_EQ] = ACTIONS(4988),
    [anon_sym_AMP_EQ] = ACTIONS(4988),
    [anon_sym_PIPE_EQ] = ACTIONS(4988),
    [anon_sym_CARET_EQ] = ACTIONS(4988),
    [anon_sym_LT_LT_EQ] = ACTIONS(4988),
    [anon_sym_GT_GT_EQ] = ACTIONS(4988),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4988),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4988),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4988),
    [anon_sym_if] = ACTIONS(4988),
    [anon_sym_SEMI] = ACTIONS(4988),
    [anon_sym_else] = ACTIONS(4988),
    [anon_sym_when] = ACTIONS(4988),
    [anon_sym_in] = ACTIONS(4988),
    [anon_sym_case] = ACTIONS(4988),
    [anon_sym_QMARK] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_AMP] = ACTIONS(4990),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_or_else] = ACTIONS(4988),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_GT] = ACTIONS(4990),
    [anon_sym_GT_EQ] = ACTIONS(4988),
    [anon_sym_LT_EQ] = ACTIONS(4988),
    [anon_sym_LT] = ACTIONS(4990),
    [anon_sym_EQ_EQ] = ACTIONS(4988),
    [anon_sym_BANG_EQ] = ACTIONS(4988),
    [anon_sym_TILDE_EQ] = ACTIONS(4988),
    [anon_sym_AMP_TILDE] = ACTIONS(4990),
    [anon_sym_LT_LT] = ACTIONS(4990),
    [anon_sym_GT_GT] = ACTIONS(4990),
    [anon_sym_STAR] = ACTIONS(4990),
    [anon_sym_SLASH] = ACTIONS(4990),
    [anon_sym_PERCENT] = ACTIONS(4990),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4988),
    [anon_sym_DOT] = ACTIONS(4990),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4988),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4988),
    [anon_sym_not_in] = ACTIONS(4988),
    [anon_sym_or_return] = ACTIONS(4988),
    [anon_sym_or_continue] = ACTIONS(4988),
    [anon_sym_or_break] = ACTIONS(4988),
    [anon_sym_CARET] = ACTIONS(4990),
    [sym_uninitialized] = ACTIONS(4988),
    [sym_tag] = ACTIONS(4988),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4988),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [826] = {
    [ts_builtin_sym_end] = ACTIONS(4992),
    [anon_sym_LBRACE] = ACTIONS(4992),
    [anon_sym_RBRACE] = ACTIONS(4992),
    [anon_sym_COMMA] = ACTIONS(4992),
    [anon_sym_COLON_COLON] = ACTIONS(4992),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(4992),
    [anon_sym_EQ] = ACTIONS(4994),
    [anon_sym_COLON] = ACTIONS(4994),
    [anon_sym_PIPE] = ACTIONS(4994),
    [anon_sym_COLON_EQ] = ACTIONS(4992),
    [anon_sym_LPAREN] = ACTIONS(4992),
    [anon_sym_PLUS_EQ] = ACTIONS(4992),
    [anon_sym_DASH_EQ] = ACTIONS(4992),
    [anon_sym_STAR_EQ] = ACTIONS(4992),
    [anon_sym_SLASH_EQ] = ACTIONS(4992),
    [anon_sym_PERCENT_EQ] = ACTIONS(4992),
    [anon_sym_AMP_EQ] = ACTIONS(4992),
    [anon_sym_PIPE_EQ] = ACTIONS(4992),
    [anon_sym_CARET_EQ] = ACTIONS(4992),
    [anon_sym_LT_LT_EQ] = ACTIONS(4992),
    [anon_sym_GT_GT_EQ] = ACTIONS(4992),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4992),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4992),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4992),
    [anon_sym_if] = ACTIONS(4992),
    [anon_sym_SEMI] = ACTIONS(4992),
    [anon_sym_else] = ACTIONS(4992),
    [anon_sym_when] = ACTIONS(4992),
    [anon_sym_in] = ACTIONS(4992),
    [anon_sym_case] = ACTIONS(4992),
    [anon_sym_QMARK] = ACTIONS(4992),
    [anon_sym_PLUS] = ACTIONS(4994),
    [anon_sym_DASH] = ACTIONS(4994),
    [anon_sym_TILDE] = ACTIONS(4994),
    [anon_sym_AMP] = ACTIONS(4994),
    [anon_sym_PIPE_PIPE] = ACTIONS(4994),
    [anon_sym_or_else] = ACTIONS(4992),
    [anon_sym_AMP_AMP] = ACTIONS(4994),
    [anon_sym_GT] = ACTIONS(4994),
    [anon_sym_GT_EQ] = ACTIONS(4992),
    [anon_sym_LT_EQ] = ACTIONS(4992),
    [anon_sym_LT] = ACTIONS(4994),
    [anon_sym_EQ_EQ] = ACTIONS(4992),
    [anon_sym_BANG_EQ] = ACTIONS(4992),
    [anon_sym_TILDE_EQ] = ACTIONS(4992),
    [anon_sym_AMP_TILDE] = ACTIONS(4994),
    [anon_sym_LT_LT] = ACTIONS(4994),
    [anon_sym_GT_GT] = ACTIONS(4994),
    [anon_sym_STAR] = ACTIONS(4994),
    [anon_sym_SLASH] = ACTIONS(4994),
    [anon_sym_PERCENT] = ACTIONS(4994),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4992),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(4992),
    [anon_sym_or_return] = ACTIONS(4992),
    [anon_sym_or_continue] = ACTIONS(4992),
    [anon_sym_or_break] = ACTIONS(4992),
    [anon_sym_CARET] = ACTIONS(4994),
    [sym_uninitialized] = ACTIONS(4992),
    [sym_tag] = ACTIONS(4992),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4992),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [827] = {
    [sym_expression] = STATE(6394),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4409),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4413),
    [anon_sym_dynamic] = ACTIONS(4415),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [828] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8029),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4908),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [829] = {
    [sym_expression] = STATE(6029),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8555),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [830] = {
    [sym_expression] = STATE(6380),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4996),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4998),
    [anon_sym_dynamic] = ACTIONS(5000),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [831] = {
    [sym_expression] = STATE(6192),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8822),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [832] = {
    [sym_expression] = STATE(6126),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8998),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [833] = {
    [sym_expression] = STATE(6365),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5002),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5004),
    [anon_sym_dynamic] = ACTIONS(5006),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [834] = {
    [ts_builtin_sym_end] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_RBRACE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_where] = ACTIONS(67),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(4590),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(67),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(67),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_QMARK] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(67),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_not_in] = ACTIONS(67),
    [anon_sym_or_return] = ACTIONS(67),
    [anon_sym_or_continue] = ACTIONS(67),
    [anon_sym_or_break] = ACTIONS(67),
    [anon_sym_CARET] = ACTIONS(71),
    [sym_uninitialized] = ACTIONS(67),
    [sym_tag] = ACTIONS(67),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(67),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [835] = {
    [sym_procedure] = STATE(8353),
    [sym_expression] = STATE(5912),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_proc] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(5008),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [836] = {
    [sym_expression] = STATE(6267),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3733),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3737),
    [anon_sym_dynamic] = ACTIONS(3739),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [837] = {
    [sym_expression] = STATE(6017),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8444),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [838] = {
    [sym_expression] = STATE(6255),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5010),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5012),
    [anon_sym_dynamic] = ACTIONS(5014),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [839] = {
    [sym_expression] = STATE(6165),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9241),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [840] = {
    [sym_expression] = STATE(6329),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9153),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [841] = {
    [sym_expression] = STATE(6246),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5016),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5018),
    [anon_sym_dynamic] = ACTIONS(5020),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [842] = {
    [sym_expression] = STATE(6235),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4500),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4504),
    [anon_sym_dynamic] = ACTIONS(4506),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [843] = {
    [sym_expression] = STATE(5999),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8416),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [844] = {
    [sym_expression] = STATE(6228),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5022),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5024),
    [anon_sym_dynamic] = ACTIONS(5026),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [845] = {
    [sym_expression] = STATE(6150),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9178),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [846] = {
    [sym_expression] = STATE(6415),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9278),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [847] = {
    [sym_expression] = STATE(6225),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5028),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5030),
    [anon_sym_dynamic] = ACTIONS(5032),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [848] = {
    [ts_builtin_sym_end] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_COLON_COLON] = ACTIONS(913),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_where] = ACTIONS(913),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_COLON_EQ] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(913),
    [anon_sym_PLUS_EQ] = ACTIONS(913),
    [anon_sym_DASH_EQ] = ACTIONS(913),
    [anon_sym_STAR_EQ] = ACTIONS(913),
    [anon_sym_SLASH_EQ] = ACTIONS(913),
    [anon_sym_PERCENT_EQ] = ACTIONS(913),
    [anon_sym_AMP_EQ] = ACTIONS(913),
    [anon_sym_PIPE_EQ] = ACTIONS(913),
    [anon_sym_CARET_EQ] = ACTIONS(913),
    [anon_sym_LT_LT_EQ] = ACTIONS(913),
    [anon_sym_GT_GT_EQ] = ACTIONS(913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(913),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(913),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_else] = ACTIONS(913),
    [anon_sym_when] = ACTIONS(913),
    [anon_sym_in] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(913),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(915),
    [anon_sym_or_else] = ACTIONS(913),
    [anon_sym_AMP_AMP] = ACTIONS(915),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(913),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(913),
    [anon_sym_or_return] = ACTIONS(913),
    [anon_sym_or_continue] = ACTIONS(913),
    [anon_sym_or_break] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [sym_uninitialized] = ACTIONS(913),
    [sym_tag] = ACTIONS(913),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(913),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [849] = {
    [sym_expression] = STATE(6211),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3683),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3687),
    [anon_sym_dynamic] = ACTIONS(3689),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [850] = {
    [sym_expression] = STATE(5992),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8433),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [851] = {
    [sym_expression] = STATE(6204),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5034),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5036),
    [anon_sym_dynamic] = ACTIONS(5038),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [852] = {
    [sym_expression] = STATE(6277),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8896),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [853] = {
    [sym_expression] = STATE(6200),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5040),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5042),
    [anon_sym_dynamic] = ACTIONS(5044),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [854] = {
    [ts_builtin_sym_end] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(859),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_where] = ACTIONS(859),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_PLUS_EQ] = ACTIONS(859),
    [anon_sym_DASH_EQ] = ACTIONS(859),
    [anon_sym_STAR_EQ] = ACTIONS(859),
    [anon_sym_SLASH_EQ] = ACTIONS(859),
    [anon_sym_PERCENT_EQ] = ACTIONS(859),
    [anon_sym_AMP_EQ] = ACTIONS(859),
    [anon_sym_PIPE_EQ] = ACTIONS(859),
    [anon_sym_CARET_EQ] = ACTIONS(859),
    [anon_sym_LT_LT_EQ] = ACTIONS(859),
    [anon_sym_GT_GT_EQ] = ACTIONS(859),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(859),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_else] = ACTIONS(859),
    [anon_sym_when] = ACTIONS(859),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_case] = ACTIONS(859),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(861),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_or_else] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(861),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(859),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(859),
    [anon_sym_or_return] = ACTIONS(859),
    [anon_sym_or_continue] = ACTIONS(859),
    [anon_sym_or_break] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(861),
    [sym_uninitialized] = ACTIONS(859),
    [sym_tag] = ACTIONS(859),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(859),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [855] = {
    [sym_expression] = STATE(6186),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3563),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3567),
    [anon_sym_dynamic] = ACTIONS(3569),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [856] = {
    [sym_expression] = STATE(5987),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8478),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [857] = {
    [sym_expression] = STATE(6177),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5048),
    [anon_sym_dynamic] = ACTIONS(5050),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [858] = {
    [sym_expression] = STATE(6330),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9141),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [859] = {
    [sym_expression] = STATE(6171),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5052),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5054),
    [anon_sym_dynamic] = ACTIONS(5056),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [860] = {
    [ts_builtin_sym_end] = ACTIONS(5058),
    [anon_sym_LBRACE] = ACTIONS(5058),
    [anon_sym_RBRACE] = ACTIONS(5058),
    [anon_sym_COMMA] = ACTIONS(5058),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_DASH_GT] = ACTIONS(5058),
    [anon_sym_where] = ACTIONS(5058),
    [anon_sym_EQ] = ACTIONS(5060),
    [anon_sym_COLON] = ACTIONS(5060),
    [anon_sym_PIPE] = ACTIONS(5060),
    [anon_sym_COLON_EQ] = ACTIONS(5058),
    [anon_sym_LPAREN] = ACTIONS(5058),
    [anon_sym_PLUS_EQ] = ACTIONS(5058),
    [anon_sym_DASH_EQ] = ACTIONS(5058),
    [anon_sym_STAR_EQ] = ACTIONS(5058),
    [anon_sym_SLASH_EQ] = ACTIONS(5058),
    [anon_sym_PERCENT_EQ] = ACTIONS(5058),
    [anon_sym_AMP_EQ] = ACTIONS(5058),
    [anon_sym_PIPE_EQ] = ACTIONS(5058),
    [anon_sym_CARET_EQ] = ACTIONS(5058),
    [anon_sym_LT_LT_EQ] = ACTIONS(5058),
    [anon_sym_GT_GT_EQ] = ACTIONS(5058),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5058),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5058),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5058),
    [anon_sym_if] = ACTIONS(5058),
    [anon_sym_SEMI] = ACTIONS(5058),
    [anon_sym_else] = ACTIONS(5058),
    [anon_sym_when] = ACTIONS(5058),
    [anon_sym_in] = ACTIONS(5058),
    [anon_sym_case] = ACTIONS(5058),
    [anon_sym_QMARK] = ACTIONS(5058),
    [anon_sym_PLUS] = ACTIONS(5060),
    [anon_sym_DASH] = ACTIONS(5060),
    [anon_sym_TILDE] = ACTIONS(5060),
    [anon_sym_AMP] = ACTIONS(5060),
    [anon_sym_PIPE_PIPE] = ACTIONS(5060),
    [anon_sym_or_else] = ACTIONS(5058),
    [anon_sym_AMP_AMP] = ACTIONS(5060),
    [anon_sym_GT] = ACTIONS(5060),
    [anon_sym_GT_EQ] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(5058),
    [anon_sym_LT] = ACTIONS(5060),
    [anon_sym_EQ_EQ] = ACTIONS(5058),
    [anon_sym_BANG_EQ] = ACTIONS(5058),
    [anon_sym_TILDE_EQ] = ACTIONS(5058),
    [anon_sym_AMP_TILDE] = ACTIONS(5060),
    [anon_sym_LT_LT] = ACTIONS(5060),
    [anon_sym_GT_GT] = ACTIONS(5060),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5058),
    [anon_sym_DOT] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(5058),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5058),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5058),
    [anon_sym_not_in] = ACTIONS(5058),
    [anon_sym_or_return] = ACTIONS(5058),
    [anon_sym_or_continue] = ACTIONS(5058),
    [anon_sym_or_break] = ACTIONS(5058),
    [anon_sym_CARET] = ACTIONS(5060),
    [sym_uninitialized] = ACTIONS(5058),
    [sym_tag] = ACTIONS(5058),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5058),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [861] = {
    [sym_expression] = STATE(6160),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3453),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3457),
    [anon_sym_dynamic] = ACTIONS(3459),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [862] = {
    [sym_expression] = STATE(6157),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5062),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5064),
    [anon_sym_dynamic] = ACTIONS(5066),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [863] = {
    [sym_expression] = STATE(6424),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8685),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [864] = {
    [sym_expression] = STATE(6108),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3463),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3467),
    [anon_sym_dynamic] = ACTIONS(3469),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [865] = {
    [sym_expression] = STATE(6147),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3503),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3507),
    [anon_sym_dynamic] = ACTIONS(3509),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [866] = {
    [sym_procedure] = STATE(6881),
    [sym_expression] = STATE(4844),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(5068),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [867] = {
    [sym_expression] = STATE(6145),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5070),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5072),
    [anon_sym_dynamic] = ACTIONS(5074),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [868] = {
    [sym_expression] = STATE(6334),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9292),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [869] = {
    [sym_expression] = STATE(6140),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5076),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5078),
    [anon_sym_dynamic] = ACTIONS(5080),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [870] = {
    [sym_expression] = STATE(6133),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3543),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3547),
    [anon_sym_dynamic] = ACTIONS(3549),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [871] = {
    [sym_expression] = STATE(6128),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5082),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5084),
    [anon_sym_dynamic] = ACTIONS(5086),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [872] = {
    [sym_expression] = STATE(6376),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8710),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [873] = {
    [sym_expression] = STATE(6203),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8936),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [874] = {
    [sym_expression] = STATE(6127),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5088),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5090),
    [anon_sym_dynamic] = ACTIONS(5092),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [875] = {
    [ts_builtin_sym_end] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5094),
    [anon_sym_RBRACE] = ACTIONS(5094),
    [anon_sym_COMMA] = ACTIONS(5094),
    [anon_sym_COLON_COLON] = ACTIONS(5094),
    [anon_sym_DASH_GT] = ACTIONS(5094),
    [anon_sym_where] = ACTIONS(5094),
    [anon_sym_EQ] = ACTIONS(5096),
    [anon_sym_COLON] = ACTIONS(5096),
    [anon_sym_PIPE] = ACTIONS(5096),
    [anon_sym_COLON_EQ] = ACTIONS(5094),
    [anon_sym_LPAREN] = ACTIONS(5094),
    [anon_sym_PLUS_EQ] = ACTIONS(5094),
    [anon_sym_DASH_EQ] = ACTIONS(5094),
    [anon_sym_STAR_EQ] = ACTIONS(5094),
    [anon_sym_SLASH_EQ] = ACTIONS(5094),
    [anon_sym_PERCENT_EQ] = ACTIONS(5094),
    [anon_sym_AMP_EQ] = ACTIONS(5094),
    [anon_sym_PIPE_EQ] = ACTIONS(5094),
    [anon_sym_CARET_EQ] = ACTIONS(5094),
    [anon_sym_LT_LT_EQ] = ACTIONS(5094),
    [anon_sym_GT_GT_EQ] = ACTIONS(5094),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5094),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5094),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5094),
    [anon_sym_if] = ACTIONS(5094),
    [anon_sym_SEMI] = ACTIONS(5094),
    [anon_sym_else] = ACTIONS(5094),
    [anon_sym_when] = ACTIONS(5094),
    [anon_sym_in] = ACTIONS(5094),
    [anon_sym_case] = ACTIONS(5094),
    [anon_sym_QMARK] = ACTIONS(5094),
    [anon_sym_PLUS] = ACTIONS(5096),
    [anon_sym_DASH] = ACTIONS(5096),
    [anon_sym_TILDE] = ACTIONS(5096),
    [anon_sym_AMP] = ACTIONS(5096),
    [anon_sym_PIPE_PIPE] = ACTIONS(5096),
    [anon_sym_or_else] = ACTIONS(5094),
    [anon_sym_AMP_AMP] = ACTIONS(5096),
    [anon_sym_GT] = ACTIONS(5096),
    [anon_sym_GT_EQ] = ACTIONS(5094),
    [anon_sym_LT_EQ] = ACTIONS(5094),
    [anon_sym_LT] = ACTIONS(5096),
    [anon_sym_EQ_EQ] = ACTIONS(5094),
    [anon_sym_BANG_EQ] = ACTIONS(5094),
    [anon_sym_TILDE_EQ] = ACTIONS(5094),
    [anon_sym_AMP_TILDE] = ACTIONS(5096),
    [anon_sym_LT_LT] = ACTIONS(5096),
    [anon_sym_GT_GT] = ACTIONS(5096),
    [anon_sym_STAR] = ACTIONS(5096),
    [anon_sym_SLASH] = ACTIONS(5096),
    [anon_sym_PERCENT] = ACTIONS(5096),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5094),
    [anon_sym_DOT] = ACTIONS(5096),
    [anon_sym_LBRACK] = ACTIONS(5094),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5094),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5094),
    [anon_sym_not_in] = ACTIONS(5094),
    [anon_sym_or_return] = ACTIONS(5094),
    [anon_sym_or_continue] = ACTIONS(5094),
    [anon_sym_or_break] = ACTIONS(5094),
    [anon_sym_CARET] = ACTIONS(5096),
    [sym_uninitialized] = ACTIONS(5094),
    [sym_tag] = ACTIONS(5094),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5094),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [876] = {
    [sym_expression] = STATE(6119),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3613),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3617),
    [anon_sym_dynamic] = ACTIONS(3619),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [877] = {
    [sym_expression] = STATE(6444),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8720),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [878] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7903),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4980),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [879] = {
    [ts_builtin_sym_end] = ACTIONS(5098),
    [anon_sym_LBRACE] = ACTIONS(5098),
    [anon_sym_RBRACE] = ACTIONS(5098),
    [anon_sym_COMMA] = ACTIONS(5098),
    [anon_sym_COLON_COLON] = ACTIONS(5098),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5098),
    [anon_sym_EQ] = ACTIONS(5100),
    [anon_sym_COLON] = ACTIONS(5100),
    [anon_sym_PIPE] = ACTIONS(5100),
    [anon_sym_COLON_EQ] = ACTIONS(5098),
    [anon_sym_LPAREN] = ACTIONS(5098),
    [anon_sym_PLUS_EQ] = ACTIONS(5098),
    [anon_sym_DASH_EQ] = ACTIONS(5098),
    [anon_sym_STAR_EQ] = ACTIONS(5098),
    [anon_sym_SLASH_EQ] = ACTIONS(5098),
    [anon_sym_PERCENT_EQ] = ACTIONS(5098),
    [anon_sym_AMP_EQ] = ACTIONS(5098),
    [anon_sym_PIPE_EQ] = ACTIONS(5098),
    [anon_sym_CARET_EQ] = ACTIONS(5098),
    [anon_sym_LT_LT_EQ] = ACTIONS(5098),
    [anon_sym_GT_GT_EQ] = ACTIONS(5098),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5098),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5098),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5098),
    [anon_sym_if] = ACTIONS(5098),
    [anon_sym_SEMI] = ACTIONS(5098),
    [anon_sym_else] = ACTIONS(5098),
    [anon_sym_when] = ACTIONS(5098),
    [anon_sym_in] = ACTIONS(5098),
    [anon_sym_case] = ACTIONS(5098),
    [anon_sym_QMARK] = ACTIONS(5098),
    [anon_sym_PLUS] = ACTIONS(5100),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_TILDE] = ACTIONS(5100),
    [anon_sym_AMP] = ACTIONS(5100),
    [anon_sym_PIPE_PIPE] = ACTIONS(5100),
    [anon_sym_or_else] = ACTIONS(5098),
    [anon_sym_AMP_AMP] = ACTIONS(5100),
    [anon_sym_GT] = ACTIONS(5100),
    [anon_sym_GT_EQ] = ACTIONS(5098),
    [anon_sym_LT_EQ] = ACTIONS(5098),
    [anon_sym_LT] = ACTIONS(5100),
    [anon_sym_EQ_EQ] = ACTIONS(5098),
    [anon_sym_BANG_EQ] = ACTIONS(5098),
    [anon_sym_TILDE_EQ] = ACTIONS(5098),
    [anon_sym_AMP_TILDE] = ACTIONS(5100),
    [anon_sym_LT_LT] = ACTIONS(5100),
    [anon_sym_GT_GT] = ACTIONS(5100),
    [anon_sym_STAR] = ACTIONS(5100),
    [anon_sym_SLASH] = ACTIONS(5100),
    [anon_sym_PERCENT] = ACTIONS(5100),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5098),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5098),
    [anon_sym_or_return] = ACTIONS(5098),
    [anon_sym_or_continue] = ACTIONS(5098),
    [anon_sym_or_break] = ACTIONS(5098),
    [anon_sym_CARET] = ACTIONS(5100),
    [sym_uninitialized] = ACTIONS(5098),
    [sym_tag] = ACTIONS(5098),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5098),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [880] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5102),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [881] = {
    [sym_expression] = STATE(6116),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5104),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5106),
    [anon_sym_dynamic] = ACTIONS(5108),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [882] = {
    [ts_builtin_sym_end] = ACTIONS(5110),
    [anon_sym_LBRACE] = ACTIONS(5110),
    [anon_sym_RBRACE] = ACTIONS(5110),
    [anon_sym_COMMA] = ACTIONS(5110),
    [anon_sym_COLON_COLON] = ACTIONS(5110),
    [anon_sym_DASH_GT] = ACTIONS(5110),
    [anon_sym_where] = ACTIONS(5110),
    [anon_sym_EQ] = ACTIONS(5112),
    [anon_sym_COLON] = ACTIONS(5112),
    [anon_sym_PIPE] = ACTIONS(5112),
    [anon_sym_COLON_EQ] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(5110),
    [anon_sym_PLUS_EQ] = ACTIONS(5110),
    [anon_sym_DASH_EQ] = ACTIONS(5110),
    [anon_sym_STAR_EQ] = ACTIONS(5110),
    [anon_sym_SLASH_EQ] = ACTIONS(5110),
    [anon_sym_PERCENT_EQ] = ACTIONS(5110),
    [anon_sym_AMP_EQ] = ACTIONS(5110),
    [anon_sym_PIPE_EQ] = ACTIONS(5110),
    [anon_sym_CARET_EQ] = ACTIONS(5110),
    [anon_sym_LT_LT_EQ] = ACTIONS(5110),
    [anon_sym_GT_GT_EQ] = ACTIONS(5110),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5110),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5110),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5110),
    [anon_sym_if] = ACTIONS(5110),
    [anon_sym_SEMI] = ACTIONS(5110),
    [anon_sym_else] = ACTIONS(5110),
    [anon_sym_when] = ACTIONS(5110),
    [anon_sym_in] = ACTIONS(5110),
    [anon_sym_case] = ACTIONS(5110),
    [anon_sym_QMARK] = ACTIONS(5110),
    [anon_sym_PLUS] = ACTIONS(5112),
    [anon_sym_DASH] = ACTIONS(5112),
    [anon_sym_TILDE] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5112),
    [anon_sym_PIPE_PIPE] = ACTIONS(5112),
    [anon_sym_or_else] = ACTIONS(5110),
    [anon_sym_AMP_AMP] = ACTIONS(5112),
    [anon_sym_GT] = ACTIONS(5112),
    [anon_sym_GT_EQ] = ACTIONS(5110),
    [anon_sym_LT_EQ] = ACTIONS(5110),
    [anon_sym_LT] = ACTIONS(5112),
    [anon_sym_EQ_EQ] = ACTIONS(5110),
    [anon_sym_BANG_EQ] = ACTIONS(5110),
    [anon_sym_TILDE_EQ] = ACTIONS(5110),
    [anon_sym_AMP_TILDE] = ACTIONS(5112),
    [anon_sym_LT_LT] = ACTIONS(5112),
    [anon_sym_GT_GT] = ACTIONS(5112),
    [anon_sym_STAR] = ACTIONS(5112),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5110),
    [anon_sym_DOT] = ACTIONS(5112),
    [anon_sym_LBRACK] = ACTIONS(5110),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5110),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5110),
    [anon_sym_not_in] = ACTIONS(5110),
    [anon_sym_or_return] = ACTIONS(5110),
    [anon_sym_or_continue] = ACTIONS(5110),
    [anon_sym_or_break] = ACTIONS(5110),
    [anon_sym_CARET] = ACTIONS(5112),
    [sym_uninitialized] = ACTIONS(5110),
    [sym_tag] = ACTIONS(5110),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5110),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [883] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5114),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [884] = {
    [sym_expression] = STATE(6046),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8762),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [885] = {
    [sym_expression] = STATE(6115),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5116),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5118),
    [anon_sym_dynamic] = ACTIONS(5120),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [886] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5122),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [887] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8107),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5124),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [888] = {
    [sym_expression] = STATE(6257),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5126),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5128),
    [anon_sym_dynamic] = ACTIONS(5130),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [889] = {
    [ts_builtin_sym_end] = ACTIONS(5132),
    [anon_sym_LBRACE] = ACTIONS(5132),
    [anon_sym_RBRACE] = ACTIONS(5132),
    [anon_sym_COMMA] = ACTIONS(5132),
    [anon_sym_COLON_COLON] = ACTIONS(5132),
    [anon_sym_DASH_GT] = ACTIONS(5132),
    [anon_sym_where] = ACTIONS(5132),
    [anon_sym_EQ] = ACTIONS(5135),
    [anon_sym_COLON] = ACTIONS(5135),
    [anon_sym_PIPE] = ACTIONS(5135),
    [anon_sym_COLON_EQ] = ACTIONS(5132),
    [anon_sym_LPAREN] = ACTIONS(5132),
    [anon_sym_PLUS_EQ] = ACTIONS(5132),
    [anon_sym_DASH_EQ] = ACTIONS(5132),
    [anon_sym_STAR_EQ] = ACTIONS(5132),
    [anon_sym_SLASH_EQ] = ACTIONS(5132),
    [anon_sym_PERCENT_EQ] = ACTIONS(5132),
    [anon_sym_AMP_EQ] = ACTIONS(5132),
    [anon_sym_PIPE_EQ] = ACTIONS(5132),
    [anon_sym_CARET_EQ] = ACTIONS(5132),
    [anon_sym_LT_LT_EQ] = ACTIONS(5132),
    [anon_sym_GT_GT_EQ] = ACTIONS(5132),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5132),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5132),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5132),
    [anon_sym_if] = ACTIONS(5132),
    [anon_sym_SEMI] = ACTIONS(5132),
    [anon_sym_else] = ACTIONS(5132),
    [anon_sym_when] = ACTIONS(5132),
    [anon_sym_in] = ACTIONS(5132),
    [anon_sym_case] = ACTIONS(5132),
    [anon_sym_QMARK] = ACTIONS(5132),
    [anon_sym_PLUS] = ACTIONS(5135),
    [anon_sym_DASH] = ACTIONS(5135),
    [anon_sym_TILDE] = ACTIONS(5135),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_or_else] = ACTIONS(5132),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5135),
    [anon_sym_GT_EQ] = ACTIONS(5132),
    [anon_sym_LT_EQ] = ACTIONS(5132),
    [anon_sym_LT] = ACTIONS(5135),
    [anon_sym_EQ_EQ] = ACTIONS(5132),
    [anon_sym_BANG_EQ] = ACTIONS(5132),
    [anon_sym_TILDE_EQ] = ACTIONS(5132),
    [anon_sym_AMP_TILDE] = ACTIONS(5135),
    [anon_sym_LT_LT] = ACTIONS(5135),
    [anon_sym_GT_GT] = ACTIONS(5135),
    [anon_sym_STAR] = ACTIONS(5135),
    [anon_sym_SLASH] = ACTIONS(5135),
    [anon_sym_PERCENT] = ACTIONS(5135),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5132),
    [anon_sym_DOT] = ACTIONS(5135),
    [anon_sym_LBRACK] = ACTIONS(5132),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5132),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5132),
    [anon_sym_not_in] = ACTIONS(5132),
    [anon_sym_or_return] = ACTIONS(5132),
    [anon_sym_or_continue] = ACTIONS(5132),
    [anon_sym_or_break] = ACTIONS(5132),
    [anon_sym_CARET] = ACTIONS(5135),
    [sym_uninitialized] = ACTIONS(5132),
    [sym_tag] = ACTIONS(5132),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5132),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [890] = {
    [sym_expression] = STATE(6106),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5138),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5140),
    [anon_sym_dynamic] = ACTIONS(5142),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [891] = {
    [sym_expression] = STATE(6445),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8701),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [892] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5124),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [893] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5144),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [894] = {
    [sym_expression] = STATE(6227),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8822),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [895] = {
    [sym_expression] = STATE(6099),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5146),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5148),
    [anon_sym_dynamic] = ACTIONS(5150),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [896] = {
    [ts_builtin_sym_end] = ACTIONS(5152),
    [anon_sym_LBRACE] = ACTIONS(5152),
    [anon_sym_RBRACE] = ACTIONS(5152),
    [anon_sym_COMMA] = ACTIONS(5152),
    [anon_sym_COLON_COLON] = ACTIONS(5152),
    [anon_sym_DASH_GT] = ACTIONS(5152),
    [anon_sym_where] = ACTIONS(5152),
    [anon_sym_EQ] = ACTIONS(5154),
    [anon_sym_COLON] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5154),
    [anon_sym_COLON_EQ] = ACTIONS(5152),
    [anon_sym_LPAREN] = ACTIONS(5152),
    [anon_sym_PLUS_EQ] = ACTIONS(5152),
    [anon_sym_DASH_EQ] = ACTIONS(5152),
    [anon_sym_STAR_EQ] = ACTIONS(5152),
    [anon_sym_SLASH_EQ] = ACTIONS(5152),
    [anon_sym_PERCENT_EQ] = ACTIONS(5152),
    [anon_sym_AMP_EQ] = ACTIONS(5152),
    [anon_sym_PIPE_EQ] = ACTIONS(5152),
    [anon_sym_CARET_EQ] = ACTIONS(5152),
    [anon_sym_LT_LT_EQ] = ACTIONS(5152),
    [anon_sym_GT_GT_EQ] = ACTIONS(5152),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5152),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5152),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5152),
    [anon_sym_if] = ACTIONS(5152),
    [anon_sym_SEMI] = ACTIONS(5152),
    [anon_sym_else] = ACTIONS(5152),
    [anon_sym_when] = ACTIONS(5152),
    [anon_sym_in] = ACTIONS(5152),
    [anon_sym_case] = ACTIONS(5152),
    [anon_sym_QMARK] = ACTIONS(5152),
    [anon_sym_PLUS] = ACTIONS(5154),
    [anon_sym_DASH] = ACTIONS(5154),
    [anon_sym_TILDE] = ACTIONS(5154),
    [anon_sym_AMP] = ACTIONS(5154),
    [anon_sym_PIPE_PIPE] = ACTIONS(5154),
    [anon_sym_or_else] = ACTIONS(5152),
    [anon_sym_AMP_AMP] = ACTIONS(5154),
    [anon_sym_GT] = ACTIONS(5154),
    [anon_sym_GT_EQ] = ACTIONS(5152),
    [anon_sym_LT_EQ] = ACTIONS(5152),
    [anon_sym_LT] = ACTIONS(5154),
    [anon_sym_EQ_EQ] = ACTIONS(5152),
    [anon_sym_BANG_EQ] = ACTIONS(5152),
    [anon_sym_TILDE_EQ] = ACTIONS(5152),
    [anon_sym_AMP_TILDE] = ACTIONS(5154),
    [anon_sym_LT_LT] = ACTIONS(5154),
    [anon_sym_GT_GT] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5154),
    [anon_sym_SLASH] = ACTIONS(5154),
    [anon_sym_PERCENT] = ACTIONS(5154),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5152),
    [anon_sym_DOT] = ACTIONS(5154),
    [anon_sym_LBRACK] = ACTIONS(5152),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5152),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5152),
    [anon_sym_not_in] = ACTIONS(5152),
    [anon_sym_or_return] = ACTIONS(5152),
    [anon_sym_or_continue] = ACTIONS(5152),
    [anon_sym_or_break] = ACTIONS(5152),
    [anon_sym_CARET] = ACTIONS(5154),
    [sym_uninitialized] = ACTIONS(5152),
    [sym_tag] = ACTIONS(5152),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5152),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [897] = {
    [sym_expression] = STATE(6096),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3723),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3727),
    [anon_sym_dynamic] = ACTIONS(3729),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [898] = {
    [ts_builtin_sym_end] = ACTIONS(5156),
    [anon_sym_LBRACE] = ACTIONS(5156),
    [anon_sym_RBRACE] = ACTIONS(5156),
    [anon_sym_COMMA] = ACTIONS(5156),
    [anon_sym_COLON_COLON] = ACTIONS(5156),
    [anon_sym_DASH_GT] = ACTIONS(5156),
    [anon_sym_where] = ACTIONS(5156),
    [anon_sym_EQ] = ACTIONS(5158),
    [anon_sym_COLON] = ACTIONS(5158),
    [anon_sym_PIPE] = ACTIONS(5158),
    [anon_sym_COLON_EQ] = ACTIONS(5156),
    [anon_sym_LPAREN] = ACTIONS(5156),
    [anon_sym_PLUS_EQ] = ACTIONS(5156),
    [anon_sym_DASH_EQ] = ACTIONS(5156),
    [anon_sym_STAR_EQ] = ACTIONS(5156),
    [anon_sym_SLASH_EQ] = ACTIONS(5156),
    [anon_sym_PERCENT_EQ] = ACTIONS(5156),
    [anon_sym_AMP_EQ] = ACTIONS(5156),
    [anon_sym_PIPE_EQ] = ACTIONS(5156),
    [anon_sym_CARET_EQ] = ACTIONS(5156),
    [anon_sym_LT_LT_EQ] = ACTIONS(5156),
    [anon_sym_GT_GT_EQ] = ACTIONS(5156),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5156),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5156),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5156),
    [anon_sym_if] = ACTIONS(5156),
    [anon_sym_SEMI] = ACTIONS(5156),
    [anon_sym_else] = ACTIONS(5156),
    [anon_sym_when] = ACTIONS(5156),
    [anon_sym_in] = ACTIONS(5156),
    [anon_sym_case] = ACTIONS(5156),
    [anon_sym_QMARK] = ACTIONS(5156),
    [anon_sym_PLUS] = ACTIONS(5158),
    [anon_sym_DASH] = ACTIONS(5158),
    [anon_sym_TILDE] = ACTIONS(5158),
    [anon_sym_AMP] = ACTIONS(5158),
    [anon_sym_PIPE_PIPE] = ACTIONS(5158),
    [anon_sym_or_else] = ACTIONS(5156),
    [anon_sym_AMP_AMP] = ACTIONS(5158),
    [anon_sym_GT] = ACTIONS(5158),
    [anon_sym_GT_EQ] = ACTIONS(5156),
    [anon_sym_LT_EQ] = ACTIONS(5156),
    [anon_sym_LT] = ACTIONS(5158),
    [anon_sym_EQ_EQ] = ACTIONS(5156),
    [anon_sym_BANG_EQ] = ACTIONS(5156),
    [anon_sym_TILDE_EQ] = ACTIONS(5156),
    [anon_sym_AMP_TILDE] = ACTIONS(5158),
    [anon_sym_LT_LT] = ACTIONS(5158),
    [anon_sym_GT_GT] = ACTIONS(5158),
    [anon_sym_STAR] = ACTIONS(5158),
    [anon_sym_SLASH] = ACTIONS(5158),
    [anon_sym_PERCENT] = ACTIONS(5158),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5156),
    [anon_sym_DOT] = ACTIONS(5158),
    [anon_sym_LBRACK] = ACTIONS(5156),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5156),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5156),
    [anon_sym_not_in] = ACTIONS(5156),
    [anon_sym_or_return] = ACTIONS(5156),
    [anon_sym_or_continue] = ACTIONS(5156),
    [anon_sym_or_break] = ACTIONS(5156),
    [anon_sym_CARET] = ACTIONS(5158),
    [sym_uninitialized] = ACTIONS(5156),
    [sym_tag] = ACTIONS(5156),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5156),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [899] = {
    [sym_expression] = STATE(6094),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5160),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5162),
    [anon_sym_dynamic] = ACTIONS(5164),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [900] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8035),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5144),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [901] = {
    [sym_expression] = STATE(6449),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8668),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [902] = {
    [sym_expression] = STATE(6202),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8783),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [903] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7964),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5166),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [904] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5166),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [905] = {
    [ts_builtin_sym_end] = ACTIONS(5168),
    [anon_sym_LBRACE] = ACTIONS(5168),
    [anon_sym_RBRACE] = ACTIONS(5168),
    [anon_sym_COMMA] = ACTIONS(5168),
    [anon_sym_COLON_COLON] = ACTIONS(5168),
    [anon_sym_DASH_GT] = ACTIONS(5168),
    [anon_sym_where] = ACTIONS(5168),
    [anon_sym_EQ] = ACTIONS(5170),
    [anon_sym_COLON] = ACTIONS(5170),
    [anon_sym_PIPE] = ACTIONS(5170),
    [anon_sym_COLON_EQ] = ACTIONS(5168),
    [anon_sym_LPAREN] = ACTIONS(5168),
    [anon_sym_PLUS_EQ] = ACTIONS(5168),
    [anon_sym_DASH_EQ] = ACTIONS(5168),
    [anon_sym_STAR_EQ] = ACTIONS(5168),
    [anon_sym_SLASH_EQ] = ACTIONS(5168),
    [anon_sym_PERCENT_EQ] = ACTIONS(5168),
    [anon_sym_AMP_EQ] = ACTIONS(5168),
    [anon_sym_PIPE_EQ] = ACTIONS(5168),
    [anon_sym_CARET_EQ] = ACTIONS(5168),
    [anon_sym_LT_LT_EQ] = ACTIONS(5168),
    [anon_sym_GT_GT_EQ] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5168),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5168),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5168),
    [anon_sym_if] = ACTIONS(5168),
    [anon_sym_SEMI] = ACTIONS(5168),
    [anon_sym_else] = ACTIONS(5168),
    [anon_sym_when] = ACTIONS(5168),
    [anon_sym_in] = ACTIONS(5168),
    [anon_sym_case] = ACTIONS(5168),
    [anon_sym_QMARK] = ACTIONS(5168),
    [anon_sym_PLUS] = ACTIONS(5170),
    [anon_sym_DASH] = ACTIONS(5170),
    [anon_sym_TILDE] = ACTIONS(5170),
    [anon_sym_AMP] = ACTIONS(5170),
    [anon_sym_PIPE_PIPE] = ACTIONS(5170),
    [anon_sym_or_else] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5170),
    [anon_sym_GT] = ACTIONS(5170),
    [anon_sym_GT_EQ] = ACTIONS(5168),
    [anon_sym_LT_EQ] = ACTIONS(5168),
    [anon_sym_LT] = ACTIONS(5170),
    [anon_sym_EQ_EQ] = ACTIONS(5168),
    [anon_sym_BANG_EQ] = ACTIONS(5168),
    [anon_sym_TILDE_EQ] = ACTIONS(5168),
    [anon_sym_AMP_TILDE] = ACTIONS(5170),
    [anon_sym_LT_LT] = ACTIONS(5170),
    [anon_sym_GT_GT] = ACTIONS(5170),
    [anon_sym_STAR] = ACTIONS(5170),
    [anon_sym_SLASH] = ACTIONS(5170),
    [anon_sym_PERCENT] = ACTIONS(5170),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5168),
    [anon_sym_DOT] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(5168),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5168),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5168),
    [anon_sym_not_in] = ACTIONS(5168),
    [anon_sym_or_return] = ACTIONS(5168),
    [anon_sym_or_continue] = ACTIONS(5168),
    [anon_sym_or_break] = ACTIONS(5168),
    [anon_sym_CARET] = ACTIONS(5170),
    [sym_uninitialized] = ACTIONS(5168),
    [sym_tag] = ACTIONS(5168),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5168),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [906] = {
    [sym_expression] = STATE(6430),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8683),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [907] = {
    [sym_expression] = STATE(6092),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5172),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5174),
    [anon_sym_dynamic] = ACTIONS(5176),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [908] = {
    [sym_expression] = STATE(6086),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3763),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3767),
    [anon_sym_dynamic] = ACTIONS(3769),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [909] = {
    [sym_expression] = STATE(6076),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5178),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5180),
    [anon_sym_dynamic] = ACTIONS(5182),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [910] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5184),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [911] = {
    [sym_block] = STATE(2178),
    [ts_builtin_sym_end] = ACTIONS(3781),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3785),
    [anon_sym_COLON] = ACTIONS(3785),
    [anon_sym_PIPE] = ACTIONS(3785),
    [anon_sym_COLON_EQ] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_else] = ACTIONS(3781),
    [anon_sym_when] = ACTIONS(3781),
    [anon_sym_in] = ACTIONS(3781),
    [anon_sym_case] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(3785),
    [anon_sym_PIPE_PIPE] = ACTIONS(3785),
    [anon_sym_or_else] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3785),
    [anon_sym_GT] = ACTIONS(3785),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3781),
    [anon_sym_LT] = ACTIONS(3785),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE] = ACTIONS(3785),
    [anon_sym_LT_LT] = ACTIONS(3785),
    [anon_sym_GT_GT] = ACTIONS(3785),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_SLASH] = ACTIONS(3785),
    [anon_sym_PERCENT] = ACTIONS(3785),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3781),
    [anon_sym_not_in] = ACTIONS(3781),
    [anon_sym_or_return] = ACTIONS(3781),
    [anon_sym_or_continue] = ACTIONS(3781),
    [anon_sym_or_break] = ACTIONS(3781),
    [anon_sym_CARET] = ACTIONS(3785),
    [sym_uninitialized] = ACTIONS(3787),
    [sym_tag] = ACTIONS(3789),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3781),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [912] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7886),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5186),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [913] = {
    [sym_expression] = STATE(6420),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9281),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [914] = {
    [sym_expression] = STATE(6072),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5188),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5190),
    [anon_sym_dynamic] = ACTIONS(5192),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [915] = {
    [sym_expression] = STATE(6100),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8680),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [916] = {
    [sym_expression] = STATE(6068),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3823),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3827),
    [anon_sym_dynamic] = ACTIONS(3829),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [917] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7750),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5194),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [918] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8053),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5196),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [919] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7646),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5198),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [920] = {
    [ts_builtin_sym_end] = ACTIONS(5200),
    [anon_sym_LBRACE] = ACTIONS(5200),
    [anon_sym_RBRACE] = ACTIONS(5200),
    [anon_sym_COMMA] = ACTIONS(5200),
    [anon_sym_COLON_COLON] = ACTIONS(5200),
    [anon_sym_DASH_GT] = ACTIONS(5200),
    [anon_sym_where] = ACTIONS(5200),
    [anon_sym_EQ] = ACTIONS(5202),
    [anon_sym_COLON] = ACTIONS(5202),
    [anon_sym_PIPE] = ACTIONS(5202),
    [anon_sym_COLON_EQ] = ACTIONS(5200),
    [anon_sym_LPAREN] = ACTIONS(5200),
    [anon_sym_PLUS_EQ] = ACTIONS(5200),
    [anon_sym_DASH_EQ] = ACTIONS(5200),
    [anon_sym_STAR_EQ] = ACTIONS(5200),
    [anon_sym_SLASH_EQ] = ACTIONS(5200),
    [anon_sym_PERCENT_EQ] = ACTIONS(5200),
    [anon_sym_AMP_EQ] = ACTIONS(5200),
    [anon_sym_PIPE_EQ] = ACTIONS(5200),
    [anon_sym_CARET_EQ] = ACTIONS(5200),
    [anon_sym_LT_LT_EQ] = ACTIONS(5200),
    [anon_sym_GT_GT_EQ] = ACTIONS(5200),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5200),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5200),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5200),
    [anon_sym_if] = ACTIONS(5200),
    [anon_sym_SEMI] = ACTIONS(5200),
    [anon_sym_else] = ACTIONS(5200),
    [anon_sym_when] = ACTIONS(5200),
    [anon_sym_in] = ACTIONS(5200),
    [anon_sym_case] = ACTIONS(5200),
    [anon_sym_QMARK] = ACTIONS(5200),
    [anon_sym_PLUS] = ACTIONS(5202),
    [anon_sym_DASH] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [anon_sym_AMP] = ACTIONS(5202),
    [anon_sym_PIPE_PIPE] = ACTIONS(5202),
    [anon_sym_or_else] = ACTIONS(5200),
    [anon_sym_AMP_AMP] = ACTIONS(5202),
    [anon_sym_GT] = ACTIONS(5202),
    [anon_sym_GT_EQ] = ACTIONS(5200),
    [anon_sym_LT_EQ] = ACTIONS(5200),
    [anon_sym_LT] = ACTIONS(5202),
    [anon_sym_EQ_EQ] = ACTIONS(5200),
    [anon_sym_BANG_EQ] = ACTIONS(5200),
    [anon_sym_TILDE_EQ] = ACTIONS(5200),
    [anon_sym_AMP_TILDE] = ACTIONS(5202),
    [anon_sym_LT_LT] = ACTIONS(5202),
    [anon_sym_GT_GT] = ACTIONS(5202),
    [anon_sym_STAR] = ACTIONS(5202),
    [anon_sym_SLASH] = ACTIONS(5202),
    [anon_sym_PERCENT] = ACTIONS(5202),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5200),
    [anon_sym_DOT] = ACTIONS(5202),
    [anon_sym_LBRACK] = ACTIONS(5200),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5200),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5200),
    [anon_sym_not_in] = ACTIONS(5200),
    [anon_sym_or_return] = ACTIONS(5200),
    [anon_sym_or_continue] = ACTIONS(5200),
    [anon_sym_or_break] = ACTIONS(5200),
    [anon_sym_CARET] = ACTIONS(5202),
    [sym_uninitialized] = ACTIONS(5200),
    [sym_tag] = ACTIONS(5200),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5200),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [921] = {
    [ts_builtin_sym_end] = ACTIONS(5204),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5204),
    [anon_sym_COMMA] = ACTIONS(5204),
    [anon_sym_COLON_COLON] = ACTIONS(5204),
    [anon_sym_DASH_GT] = ACTIONS(5204),
    [anon_sym_where] = ACTIONS(5204),
    [anon_sym_EQ] = ACTIONS(5206),
    [anon_sym_COLON] = ACTIONS(5206),
    [anon_sym_PIPE] = ACTIONS(5206),
    [anon_sym_COLON_EQ] = ACTIONS(5204),
    [anon_sym_LPAREN] = ACTIONS(5204),
    [anon_sym_PLUS_EQ] = ACTIONS(5204),
    [anon_sym_DASH_EQ] = ACTIONS(5204),
    [anon_sym_STAR_EQ] = ACTIONS(5204),
    [anon_sym_SLASH_EQ] = ACTIONS(5204),
    [anon_sym_PERCENT_EQ] = ACTIONS(5204),
    [anon_sym_AMP_EQ] = ACTIONS(5204),
    [anon_sym_PIPE_EQ] = ACTIONS(5204),
    [anon_sym_CARET_EQ] = ACTIONS(5204),
    [anon_sym_LT_LT_EQ] = ACTIONS(5204),
    [anon_sym_GT_GT_EQ] = ACTIONS(5204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5204),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5204),
    [anon_sym_if] = ACTIONS(5204),
    [anon_sym_SEMI] = ACTIONS(5204),
    [anon_sym_else] = ACTIONS(5204),
    [anon_sym_when] = ACTIONS(5204),
    [anon_sym_in] = ACTIONS(5204),
    [anon_sym_case] = ACTIONS(5204),
    [anon_sym_QMARK] = ACTIONS(5204),
    [anon_sym_PLUS] = ACTIONS(5206),
    [anon_sym_DASH] = ACTIONS(5206),
    [anon_sym_TILDE] = ACTIONS(5206),
    [anon_sym_AMP] = ACTIONS(5206),
    [anon_sym_PIPE_PIPE] = ACTIONS(5206),
    [anon_sym_or_else] = ACTIONS(5204),
    [anon_sym_AMP_AMP] = ACTIONS(5206),
    [anon_sym_GT] = ACTIONS(5206),
    [anon_sym_GT_EQ] = ACTIONS(5204),
    [anon_sym_LT_EQ] = ACTIONS(5204),
    [anon_sym_LT] = ACTIONS(5206),
    [anon_sym_EQ_EQ] = ACTIONS(5204),
    [anon_sym_BANG_EQ] = ACTIONS(5204),
    [anon_sym_TILDE_EQ] = ACTIONS(5204),
    [anon_sym_AMP_TILDE] = ACTIONS(5206),
    [anon_sym_LT_LT] = ACTIONS(5206),
    [anon_sym_GT_GT] = ACTIONS(5206),
    [anon_sym_STAR] = ACTIONS(5206),
    [anon_sym_SLASH] = ACTIONS(5206),
    [anon_sym_PERCENT] = ACTIONS(5206),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5204),
    [anon_sym_DOT] = ACTIONS(5206),
    [anon_sym_LBRACK] = ACTIONS(5204),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5204),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5204),
    [anon_sym_not_in] = ACTIONS(5204),
    [anon_sym_or_return] = ACTIONS(5204),
    [anon_sym_or_continue] = ACTIONS(5204),
    [anon_sym_or_break] = ACTIONS(5204),
    [anon_sym_CARET] = ACTIONS(5206),
    [sym_uninitialized] = ACTIONS(5204),
    [sym_tag] = ACTIONS(5204),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5204),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [922] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5208),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [923] = {
    [sym_expression] = STATE(6066),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5210),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5212),
    [anon_sym_dynamic] = ACTIONS(5214),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [924] = {
    [ts_builtin_sym_end] = ACTIONS(5216),
    [anon_sym_LBRACE] = ACTIONS(5216),
    [anon_sym_RBRACE] = ACTIONS(5216),
    [anon_sym_COMMA] = ACTIONS(5216),
    [anon_sym_COLON_COLON] = ACTIONS(5216),
    [anon_sym_DASH_GT] = ACTIONS(5216),
    [anon_sym_where] = ACTIONS(5216),
    [anon_sym_EQ] = ACTIONS(5218),
    [anon_sym_COLON] = ACTIONS(5218),
    [anon_sym_PIPE] = ACTIONS(5218),
    [anon_sym_COLON_EQ] = ACTIONS(5216),
    [anon_sym_LPAREN] = ACTIONS(5216),
    [anon_sym_PLUS_EQ] = ACTIONS(5216),
    [anon_sym_DASH_EQ] = ACTIONS(5216),
    [anon_sym_STAR_EQ] = ACTIONS(5216),
    [anon_sym_SLASH_EQ] = ACTIONS(5216),
    [anon_sym_PERCENT_EQ] = ACTIONS(5216),
    [anon_sym_AMP_EQ] = ACTIONS(5216),
    [anon_sym_PIPE_EQ] = ACTIONS(5216),
    [anon_sym_CARET_EQ] = ACTIONS(5216),
    [anon_sym_LT_LT_EQ] = ACTIONS(5216),
    [anon_sym_GT_GT_EQ] = ACTIONS(5216),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5216),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5216),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5216),
    [anon_sym_if] = ACTIONS(5216),
    [anon_sym_SEMI] = ACTIONS(5216),
    [anon_sym_else] = ACTIONS(5216),
    [anon_sym_when] = ACTIONS(5216),
    [anon_sym_in] = ACTIONS(5216),
    [anon_sym_case] = ACTIONS(5216),
    [anon_sym_QMARK] = ACTIONS(5216),
    [anon_sym_PLUS] = ACTIONS(5218),
    [anon_sym_DASH] = ACTIONS(5218),
    [anon_sym_TILDE] = ACTIONS(5218),
    [anon_sym_AMP] = ACTIONS(5218),
    [anon_sym_PIPE_PIPE] = ACTIONS(5218),
    [anon_sym_or_else] = ACTIONS(5216),
    [anon_sym_AMP_AMP] = ACTIONS(5218),
    [anon_sym_GT] = ACTIONS(5218),
    [anon_sym_GT_EQ] = ACTIONS(5216),
    [anon_sym_LT_EQ] = ACTIONS(5216),
    [anon_sym_LT] = ACTIONS(5218),
    [anon_sym_EQ_EQ] = ACTIONS(5216),
    [anon_sym_BANG_EQ] = ACTIONS(5216),
    [anon_sym_TILDE_EQ] = ACTIONS(5216),
    [anon_sym_AMP_TILDE] = ACTIONS(5218),
    [anon_sym_LT_LT] = ACTIONS(5218),
    [anon_sym_GT_GT] = ACTIONS(5218),
    [anon_sym_STAR] = ACTIONS(5218),
    [anon_sym_SLASH] = ACTIONS(5218),
    [anon_sym_PERCENT] = ACTIONS(5218),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5216),
    [anon_sym_DOT] = ACTIONS(5218),
    [anon_sym_LBRACK] = ACTIONS(5216),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5216),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5216),
    [anon_sym_not_in] = ACTIONS(5216),
    [anon_sym_or_return] = ACTIONS(5216),
    [anon_sym_or_continue] = ACTIONS(5216),
    [anon_sym_or_break] = ACTIONS(5216),
    [anon_sym_CARET] = ACTIONS(5218),
    [sym_uninitialized] = ACTIONS(5216),
    [sym_tag] = ACTIONS(5216),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5216),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [925] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5220),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [926] = {
    [sym_expression] = STATE(6457),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9241),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [927] = {
    [sym_expression] = STATE(6063),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5222),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5224),
    [anon_sym_dynamic] = ACTIONS(5226),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [928] = {
    [ts_builtin_sym_end] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_COLON_COLON] = ACTIONS(767),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_where] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_COLON] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_COLON_EQ] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_PLUS_EQ] = ACTIONS(767),
    [anon_sym_DASH_EQ] = ACTIONS(767),
    [anon_sym_STAR_EQ] = ACTIONS(767),
    [anon_sym_SLASH_EQ] = ACTIONS(767),
    [anon_sym_PERCENT_EQ] = ACTIONS(767),
    [anon_sym_AMP_EQ] = ACTIONS(767),
    [anon_sym_PIPE_EQ] = ACTIONS(767),
    [anon_sym_CARET_EQ] = ACTIONS(767),
    [anon_sym_LT_LT_EQ] = ACTIONS(767),
    [anon_sym_GT_GT_EQ] = ACTIONS(767),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(767),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_else] = ACTIONS(767),
    [anon_sym_when] = ACTIONS(767),
    [anon_sym_in] = ACTIONS(767),
    [anon_sym_case] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_or_else] = ACTIONS(767),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(773),
    [anon_sym_LT_LT] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(767),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(767),
    [anon_sym_or_return] = ACTIONS(767),
    [anon_sym_or_continue] = ACTIONS(767),
    [anon_sym_or_break] = ACTIONS(767),
    [anon_sym_CARET] = ACTIONS(773),
    [sym_uninitialized] = ACTIONS(767),
    [sym_tag] = ACTIONS(767),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(767),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [929] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5228),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [930] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7680),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5230),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [931] = {
    [sym_expression] = STATE(6059),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3657),
    [anon_sym_dynamic] = ACTIONS(3659),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [932] = {
    [sym_expression] = STATE(6056),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5232),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5234),
    [anon_sym_dynamic] = ACTIONS(5236),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [933] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7893),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5238),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [934] = {
    [sym_expression] = STATE(6176),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8845),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [935] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5240),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [936] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5230),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [937] = {
    [sym_block] = STATE(2176),
    [ts_builtin_sym_end] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_else] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(3427),
    [sym_tag] = ACTIONS(5242),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3415),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [938] = {
    [ts_builtin_sym_end] = ACTIONS(5244),
    [anon_sym_LBRACE] = ACTIONS(5244),
    [anon_sym_RBRACE] = ACTIONS(5244),
    [anon_sym_COMMA] = ACTIONS(5244),
    [anon_sym_COLON_COLON] = ACTIONS(5244),
    [anon_sym_DASH_GT] = ACTIONS(5244),
    [anon_sym_where] = ACTIONS(5244),
    [anon_sym_EQ] = ACTIONS(5246),
    [anon_sym_COLON] = ACTIONS(5246),
    [anon_sym_PIPE] = ACTIONS(5246),
    [anon_sym_COLON_EQ] = ACTIONS(5244),
    [anon_sym_LPAREN] = ACTIONS(5244),
    [anon_sym_PLUS_EQ] = ACTIONS(5244),
    [anon_sym_DASH_EQ] = ACTIONS(5244),
    [anon_sym_STAR_EQ] = ACTIONS(5244),
    [anon_sym_SLASH_EQ] = ACTIONS(5244),
    [anon_sym_PERCENT_EQ] = ACTIONS(5244),
    [anon_sym_AMP_EQ] = ACTIONS(5244),
    [anon_sym_PIPE_EQ] = ACTIONS(5244),
    [anon_sym_CARET_EQ] = ACTIONS(5244),
    [anon_sym_LT_LT_EQ] = ACTIONS(5244),
    [anon_sym_GT_GT_EQ] = ACTIONS(5244),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5244),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5244),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5244),
    [anon_sym_if] = ACTIONS(5244),
    [anon_sym_SEMI] = ACTIONS(5244),
    [anon_sym_else] = ACTIONS(5244),
    [anon_sym_when] = ACTIONS(5244),
    [anon_sym_in] = ACTIONS(5244),
    [anon_sym_case] = ACTIONS(5244),
    [anon_sym_QMARK] = ACTIONS(5244),
    [anon_sym_PLUS] = ACTIONS(5246),
    [anon_sym_DASH] = ACTIONS(5246),
    [anon_sym_TILDE] = ACTIONS(5246),
    [anon_sym_AMP] = ACTIONS(5246),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_or_else] = ACTIONS(5244),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_GT] = ACTIONS(5246),
    [anon_sym_GT_EQ] = ACTIONS(5244),
    [anon_sym_LT_EQ] = ACTIONS(5244),
    [anon_sym_LT] = ACTIONS(5246),
    [anon_sym_EQ_EQ] = ACTIONS(5244),
    [anon_sym_BANG_EQ] = ACTIONS(5244),
    [anon_sym_TILDE_EQ] = ACTIONS(5244),
    [anon_sym_AMP_TILDE] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5246),
    [anon_sym_GT_GT] = ACTIONS(5246),
    [anon_sym_STAR] = ACTIONS(5246),
    [anon_sym_SLASH] = ACTIONS(5246),
    [anon_sym_PERCENT] = ACTIONS(5246),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5244),
    [anon_sym_DOT] = ACTIONS(5246),
    [anon_sym_LBRACK] = ACTIONS(5244),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5244),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5244),
    [anon_sym_not_in] = ACTIONS(5244),
    [anon_sym_or_return] = ACTIONS(5244),
    [anon_sym_or_continue] = ACTIONS(5244),
    [anon_sym_or_break] = ACTIONS(5244),
    [anon_sym_CARET] = ACTIONS(5246),
    [sym_uninitialized] = ACTIONS(5244),
    [sym_tag] = ACTIONS(5244),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5244),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [939] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5248),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [940] = {
    [sym_expression] = STATE(6055),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5250),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5252),
    [anon_sym_dynamic] = ACTIONS(5254),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [941] = {
    [ts_builtin_sym_end] = ACTIONS(5256),
    [anon_sym_LBRACE] = ACTIONS(5256),
    [anon_sym_RBRACE] = ACTIONS(5256),
    [anon_sym_COMMA] = ACTIONS(5256),
    [anon_sym_COLON_COLON] = ACTIONS(5256),
    [anon_sym_DASH_GT] = ACTIONS(5256),
    [anon_sym_where] = ACTIONS(5256),
    [anon_sym_EQ] = ACTIONS(5258),
    [anon_sym_COLON] = ACTIONS(5258),
    [anon_sym_PIPE] = ACTIONS(5258),
    [anon_sym_COLON_EQ] = ACTIONS(5256),
    [anon_sym_LPAREN] = ACTIONS(5256),
    [anon_sym_PLUS_EQ] = ACTIONS(5256),
    [anon_sym_DASH_EQ] = ACTIONS(5256),
    [anon_sym_STAR_EQ] = ACTIONS(5256),
    [anon_sym_SLASH_EQ] = ACTIONS(5256),
    [anon_sym_PERCENT_EQ] = ACTIONS(5256),
    [anon_sym_AMP_EQ] = ACTIONS(5256),
    [anon_sym_PIPE_EQ] = ACTIONS(5256),
    [anon_sym_CARET_EQ] = ACTIONS(5256),
    [anon_sym_LT_LT_EQ] = ACTIONS(5256),
    [anon_sym_GT_GT_EQ] = ACTIONS(5256),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5256),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5256),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5256),
    [anon_sym_if] = ACTIONS(5256),
    [anon_sym_SEMI] = ACTIONS(5256),
    [anon_sym_else] = ACTIONS(5256),
    [anon_sym_when] = ACTIONS(5256),
    [anon_sym_in] = ACTIONS(5256),
    [anon_sym_case] = ACTIONS(5256),
    [anon_sym_QMARK] = ACTIONS(5256),
    [anon_sym_PLUS] = ACTIONS(5258),
    [anon_sym_DASH] = ACTIONS(5258),
    [anon_sym_TILDE] = ACTIONS(5258),
    [anon_sym_AMP] = ACTIONS(5258),
    [anon_sym_PIPE_PIPE] = ACTIONS(5258),
    [anon_sym_or_else] = ACTIONS(5256),
    [anon_sym_AMP_AMP] = ACTIONS(5258),
    [anon_sym_GT] = ACTIONS(5258),
    [anon_sym_GT_EQ] = ACTIONS(5256),
    [anon_sym_LT_EQ] = ACTIONS(5256),
    [anon_sym_LT] = ACTIONS(5258),
    [anon_sym_EQ_EQ] = ACTIONS(5256),
    [anon_sym_BANG_EQ] = ACTIONS(5256),
    [anon_sym_TILDE_EQ] = ACTIONS(5256),
    [anon_sym_AMP_TILDE] = ACTIONS(5258),
    [anon_sym_LT_LT] = ACTIONS(5258),
    [anon_sym_GT_GT] = ACTIONS(5258),
    [anon_sym_STAR] = ACTIONS(5258),
    [anon_sym_SLASH] = ACTIONS(5258),
    [anon_sym_PERCENT] = ACTIONS(5258),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5256),
    [anon_sym_DOT] = ACTIONS(5258),
    [anon_sym_LBRACK] = ACTIONS(5256),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5256),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5256),
    [anon_sym_not_in] = ACTIONS(5256),
    [anon_sym_or_return] = ACTIONS(5256),
    [anon_sym_or_continue] = ACTIONS(5256),
    [anon_sym_or_break] = ACTIONS(5256),
    [anon_sym_CARET] = ACTIONS(5258),
    [sym_uninitialized] = ACTIONS(5256),
    [sym_tag] = ACTIONS(5256),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5256),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [942] = {
    [sym_expression] = STATE(6049),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3883),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3887),
    [anon_sym_dynamic] = ACTIONS(3889),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [943] = {
    [sym_expression] = STATE(6047),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5260),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5262),
    [anon_sym_dynamic] = ACTIONS(5264),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [944] = {
    [sym_expression] = STATE(6343),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9178),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [945] = {
    [ts_builtin_sym_end] = ACTIONS(5266),
    [anon_sym_LBRACE] = ACTIONS(5266),
    [anon_sym_RBRACE] = ACTIONS(5266),
    [anon_sym_COMMA] = ACTIONS(5266),
    [anon_sym_COLON_COLON] = ACTIONS(5266),
    [anon_sym_DASH_GT] = ACTIONS(5266),
    [anon_sym_where] = ACTIONS(5266),
    [anon_sym_EQ] = ACTIONS(5268),
    [anon_sym_COLON] = ACTIONS(5268),
    [anon_sym_PIPE] = ACTIONS(5268),
    [anon_sym_COLON_EQ] = ACTIONS(5266),
    [anon_sym_LPAREN] = ACTIONS(5266),
    [anon_sym_PLUS_EQ] = ACTIONS(5266),
    [anon_sym_DASH_EQ] = ACTIONS(5266),
    [anon_sym_STAR_EQ] = ACTIONS(5266),
    [anon_sym_SLASH_EQ] = ACTIONS(5266),
    [anon_sym_PERCENT_EQ] = ACTIONS(5266),
    [anon_sym_AMP_EQ] = ACTIONS(5266),
    [anon_sym_PIPE_EQ] = ACTIONS(5266),
    [anon_sym_CARET_EQ] = ACTIONS(5266),
    [anon_sym_LT_LT_EQ] = ACTIONS(5266),
    [anon_sym_GT_GT_EQ] = ACTIONS(5266),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5266),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5266),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5266),
    [anon_sym_if] = ACTIONS(5266),
    [anon_sym_SEMI] = ACTIONS(5266),
    [anon_sym_else] = ACTIONS(5266),
    [anon_sym_when] = ACTIONS(5266),
    [anon_sym_in] = ACTIONS(5266),
    [anon_sym_case] = ACTIONS(5266),
    [anon_sym_QMARK] = ACTIONS(5266),
    [anon_sym_PLUS] = ACTIONS(5268),
    [anon_sym_DASH] = ACTIONS(5268),
    [anon_sym_TILDE] = ACTIONS(5268),
    [anon_sym_AMP] = ACTIONS(5268),
    [anon_sym_PIPE_PIPE] = ACTIONS(5268),
    [anon_sym_or_else] = ACTIONS(5266),
    [anon_sym_AMP_AMP] = ACTIONS(5268),
    [anon_sym_GT] = ACTIONS(5268),
    [anon_sym_GT_EQ] = ACTIONS(5266),
    [anon_sym_LT_EQ] = ACTIONS(5266),
    [anon_sym_LT] = ACTIONS(5268),
    [anon_sym_EQ_EQ] = ACTIONS(5266),
    [anon_sym_BANG_EQ] = ACTIONS(5266),
    [anon_sym_TILDE_EQ] = ACTIONS(5266),
    [anon_sym_AMP_TILDE] = ACTIONS(5268),
    [anon_sym_LT_LT] = ACTIONS(5268),
    [anon_sym_GT_GT] = ACTIONS(5268),
    [anon_sym_STAR] = ACTIONS(5268),
    [anon_sym_SLASH] = ACTIONS(5268),
    [anon_sym_PERCENT] = ACTIONS(5268),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5266),
    [anon_sym_DOT] = ACTIONS(5268),
    [anon_sym_LBRACK] = ACTIONS(5266),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5266),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5266),
    [anon_sym_not_in] = ACTIONS(5266),
    [anon_sym_or_return] = ACTIONS(5266),
    [anon_sym_or_continue] = ACTIONS(5266),
    [anon_sym_or_break] = ACTIONS(5266),
    [anon_sym_CARET] = ACTIONS(5268),
    [sym_uninitialized] = ACTIONS(5266),
    [sym_tag] = ACTIONS(5266),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5266),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [946] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7603),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5248),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [947] = {
    [ts_builtin_sym_end] = ACTIONS(5270),
    [anon_sym_LBRACE] = ACTIONS(5270),
    [anon_sym_RBRACE] = ACTIONS(5270),
    [anon_sym_COMMA] = ACTIONS(5270),
    [anon_sym_COLON_COLON] = ACTIONS(5270),
    [anon_sym_DASH_GT] = ACTIONS(5270),
    [anon_sym_where] = ACTIONS(5270),
    [anon_sym_EQ] = ACTIONS(5272),
    [anon_sym_COLON] = ACTIONS(5272),
    [anon_sym_PIPE] = ACTIONS(5272),
    [anon_sym_COLON_EQ] = ACTIONS(5270),
    [anon_sym_LPAREN] = ACTIONS(5270),
    [anon_sym_PLUS_EQ] = ACTIONS(5270),
    [anon_sym_DASH_EQ] = ACTIONS(5270),
    [anon_sym_STAR_EQ] = ACTIONS(5270),
    [anon_sym_SLASH_EQ] = ACTIONS(5270),
    [anon_sym_PERCENT_EQ] = ACTIONS(5270),
    [anon_sym_AMP_EQ] = ACTIONS(5270),
    [anon_sym_PIPE_EQ] = ACTIONS(5270),
    [anon_sym_CARET_EQ] = ACTIONS(5270),
    [anon_sym_LT_LT_EQ] = ACTIONS(5270),
    [anon_sym_GT_GT_EQ] = ACTIONS(5270),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5270),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5270),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5270),
    [anon_sym_if] = ACTIONS(5270),
    [anon_sym_SEMI] = ACTIONS(5270),
    [anon_sym_else] = ACTIONS(5270),
    [anon_sym_when] = ACTIONS(5270),
    [anon_sym_in] = ACTIONS(5270),
    [anon_sym_case] = ACTIONS(5270),
    [anon_sym_QMARK] = ACTIONS(5270),
    [anon_sym_PLUS] = ACTIONS(5272),
    [anon_sym_DASH] = ACTIONS(5272),
    [anon_sym_TILDE] = ACTIONS(5272),
    [anon_sym_AMP] = ACTIONS(5272),
    [anon_sym_PIPE_PIPE] = ACTIONS(5272),
    [anon_sym_or_else] = ACTIONS(5270),
    [anon_sym_AMP_AMP] = ACTIONS(5272),
    [anon_sym_GT] = ACTIONS(5272),
    [anon_sym_GT_EQ] = ACTIONS(5270),
    [anon_sym_LT_EQ] = ACTIONS(5270),
    [anon_sym_LT] = ACTIONS(5272),
    [anon_sym_EQ_EQ] = ACTIONS(5270),
    [anon_sym_BANG_EQ] = ACTIONS(5270),
    [anon_sym_TILDE_EQ] = ACTIONS(5270),
    [anon_sym_AMP_TILDE] = ACTIONS(5272),
    [anon_sym_LT_LT] = ACTIONS(5272),
    [anon_sym_GT_GT] = ACTIONS(5272),
    [anon_sym_STAR] = ACTIONS(5272),
    [anon_sym_SLASH] = ACTIONS(5272),
    [anon_sym_PERCENT] = ACTIONS(5272),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5270),
    [anon_sym_DOT] = ACTIONS(5272),
    [anon_sym_LBRACK] = ACTIONS(5270),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5270),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5270),
    [anon_sym_not_in] = ACTIONS(5270),
    [anon_sym_or_return] = ACTIONS(5270),
    [anon_sym_or_continue] = ACTIONS(5270),
    [anon_sym_or_break] = ACTIONS(5270),
    [anon_sym_CARET] = ACTIONS(5272),
    [sym_uninitialized] = ACTIONS(5270),
    [sym_tag] = ACTIONS(5270),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5270),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [948] = {
    [ts_builtin_sym_end] = ACTIONS(5274),
    [anon_sym_LBRACE] = ACTIONS(5274),
    [anon_sym_RBRACE] = ACTIONS(5274),
    [anon_sym_COMMA] = ACTIONS(5274),
    [anon_sym_COLON_COLON] = ACTIONS(5274),
    [anon_sym_DASH_GT] = ACTIONS(5274),
    [anon_sym_where] = ACTIONS(5274),
    [anon_sym_EQ] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(5276),
    [anon_sym_PIPE] = ACTIONS(5276),
    [anon_sym_COLON_EQ] = ACTIONS(5274),
    [anon_sym_LPAREN] = ACTIONS(5274),
    [anon_sym_PLUS_EQ] = ACTIONS(5274),
    [anon_sym_DASH_EQ] = ACTIONS(5274),
    [anon_sym_STAR_EQ] = ACTIONS(5274),
    [anon_sym_SLASH_EQ] = ACTIONS(5274),
    [anon_sym_PERCENT_EQ] = ACTIONS(5274),
    [anon_sym_AMP_EQ] = ACTIONS(5274),
    [anon_sym_PIPE_EQ] = ACTIONS(5274),
    [anon_sym_CARET_EQ] = ACTIONS(5274),
    [anon_sym_LT_LT_EQ] = ACTIONS(5274),
    [anon_sym_GT_GT_EQ] = ACTIONS(5274),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5274),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5274),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5274),
    [anon_sym_if] = ACTIONS(5274),
    [anon_sym_SEMI] = ACTIONS(5274),
    [anon_sym_else] = ACTIONS(5274),
    [anon_sym_when] = ACTIONS(5274),
    [anon_sym_in] = ACTIONS(5274),
    [anon_sym_case] = ACTIONS(5274),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_PLUS] = ACTIONS(5276),
    [anon_sym_DASH] = ACTIONS(5276),
    [anon_sym_TILDE] = ACTIONS(5276),
    [anon_sym_AMP] = ACTIONS(5276),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_or_else] = ACTIONS(5274),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_GT] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5274),
    [anon_sym_LT_EQ] = ACTIONS(5274),
    [anon_sym_LT] = ACTIONS(5276),
    [anon_sym_EQ_EQ] = ACTIONS(5274),
    [anon_sym_BANG_EQ] = ACTIONS(5274),
    [anon_sym_TILDE_EQ] = ACTIONS(5274),
    [anon_sym_AMP_TILDE] = ACTIONS(5276),
    [anon_sym_LT_LT] = ACTIONS(5276),
    [anon_sym_GT_GT] = ACTIONS(5276),
    [anon_sym_STAR] = ACTIONS(5276),
    [anon_sym_SLASH] = ACTIONS(5276),
    [anon_sym_PERCENT] = ACTIONS(5276),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5274),
    [anon_sym_DOT] = ACTIONS(5276),
    [anon_sym_LBRACK] = ACTIONS(5274),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5274),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5274),
    [anon_sym_not_in] = ACTIONS(5274),
    [anon_sym_or_return] = ACTIONS(5274),
    [anon_sym_or_continue] = ACTIONS(5274),
    [anon_sym_or_break] = ACTIONS(5274),
    [anon_sym_CARET] = ACTIONS(5276),
    [sym_uninitialized] = ACTIONS(5274),
    [sym_tag] = ACTIONS(5274),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5274),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [949] = {
    [ts_builtin_sym_end] = ACTIONS(5278),
    [anon_sym_LBRACE] = ACTIONS(5278),
    [anon_sym_RBRACE] = ACTIONS(5278),
    [anon_sym_COMMA] = ACTIONS(5278),
    [anon_sym_COLON_COLON] = ACTIONS(5278),
    [anon_sym_DASH_GT] = ACTIONS(5278),
    [anon_sym_where] = ACTIONS(5278),
    [anon_sym_EQ] = ACTIONS(5280),
    [anon_sym_COLON] = ACTIONS(5280),
    [anon_sym_PIPE] = ACTIONS(5280),
    [anon_sym_COLON_EQ] = ACTIONS(5278),
    [anon_sym_LPAREN] = ACTIONS(5278),
    [anon_sym_PLUS_EQ] = ACTIONS(5278),
    [anon_sym_DASH_EQ] = ACTIONS(5278),
    [anon_sym_STAR_EQ] = ACTIONS(5278),
    [anon_sym_SLASH_EQ] = ACTIONS(5278),
    [anon_sym_PERCENT_EQ] = ACTIONS(5278),
    [anon_sym_AMP_EQ] = ACTIONS(5278),
    [anon_sym_PIPE_EQ] = ACTIONS(5278),
    [anon_sym_CARET_EQ] = ACTIONS(5278),
    [anon_sym_LT_LT_EQ] = ACTIONS(5278),
    [anon_sym_GT_GT_EQ] = ACTIONS(5278),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5278),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5278),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5278),
    [anon_sym_if] = ACTIONS(5278),
    [anon_sym_SEMI] = ACTIONS(5278),
    [anon_sym_else] = ACTIONS(5278),
    [anon_sym_when] = ACTIONS(5278),
    [anon_sym_in] = ACTIONS(5278),
    [anon_sym_case] = ACTIONS(5278),
    [anon_sym_QMARK] = ACTIONS(5278),
    [anon_sym_PLUS] = ACTIONS(5280),
    [anon_sym_DASH] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [anon_sym_AMP] = ACTIONS(5280),
    [anon_sym_PIPE_PIPE] = ACTIONS(5280),
    [anon_sym_or_else] = ACTIONS(5278),
    [anon_sym_AMP_AMP] = ACTIONS(5280),
    [anon_sym_GT] = ACTIONS(5280),
    [anon_sym_GT_EQ] = ACTIONS(5278),
    [anon_sym_LT_EQ] = ACTIONS(5278),
    [anon_sym_LT] = ACTIONS(5280),
    [anon_sym_EQ_EQ] = ACTIONS(5278),
    [anon_sym_BANG_EQ] = ACTIONS(5278),
    [anon_sym_TILDE_EQ] = ACTIONS(5278),
    [anon_sym_AMP_TILDE] = ACTIONS(5280),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_STAR] = ACTIONS(5280),
    [anon_sym_SLASH] = ACTIONS(5280),
    [anon_sym_PERCENT] = ACTIONS(5280),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5278),
    [anon_sym_DOT] = ACTIONS(5280),
    [anon_sym_LBRACK] = ACTIONS(5278),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5278),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5278),
    [anon_sym_not_in] = ACTIONS(5278),
    [anon_sym_or_return] = ACTIONS(5278),
    [anon_sym_or_continue] = ACTIONS(5278),
    [anon_sym_or_break] = ACTIONS(5278),
    [anon_sym_CARET] = ACTIONS(5280),
    [sym_uninitialized] = ACTIONS(5278),
    [sym_tag] = ACTIONS(5278),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5278),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [950] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7840),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5282),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [951] = {
    [sym_expression] = STATE(6081),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5284),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5286),
    [anon_sym_dynamic] = ACTIONS(5288),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [952] = {
    [sym_expression] = STATE(6098),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3965),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3969),
    [anon_sym_dynamic] = ACTIONS(3971),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [953] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5282),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [954] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5290),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [955] = {
    [sym_expression] = STATE(6035),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8470),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [956] = {
    [sym_expression] = STATE(6113),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5292),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5294),
    [anon_sym_dynamic] = ACTIONS(5296),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [957] = {
    [sym_expression] = STATE(6120),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5298),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5300),
    [anon_sym_dynamic] = ACTIONS(5302),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [958] = {
    [sym_expression] = STATE(6130),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4005),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4009),
    [anon_sym_dynamic] = ACTIONS(4011),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [959] = {
    [sym_expression] = STATE(6135),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5304),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5306),
    [anon_sym_dynamic] = ACTIONS(5308),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [960] = {
    [sym_expression] = STATE(6136),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5310),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5312),
    [anon_sym_dynamic] = ACTIONS(5314),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [961] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5316),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [962] = {
    [sym_expression] = STATE(6139),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4095),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4099),
    [anon_sym_dynamic] = ACTIONS(4101),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [963] = {
    [sym_expression] = STATE(6149),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5318),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5320),
    [anon_sym_dynamic] = ACTIONS(5322),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [964] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8225),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5324),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [965] = {
    [sym_expression] = STATE(6152),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5326),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5328),
    [anon_sym_dynamic] = ACTIONS(5330),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [966] = {
    [ts_builtin_sym_end] = ACTIONS(5332),
    [anon_sym_LBRACE] = ACTIONS(5332),
    [anon_sym_RBRACE] = ACTIONS(5332),
    [anon_sym_COMMA] = ACTIONS(5332),
    [anon_sym_COLON_COLON] = ACTIONS(5332),
    [anon_sym_DASH_GT] = ACTIONS(5332),
    [anon_sym_where] = ACTIONS(5332),
    [anon_sym_EQ] = ACTIONS(5334),
    [anon_sym_COLON] = ACTIONS(5334),
    [anon_sym_PIPE] = ACTIONS(5334),
    [anon_sym_COLON_EQ] = ACTIONS(5332),
    [anon_sym_LPAREN] = ACTIONS(5332),
    [anon_sym_PLUS_EQ] = ACTIONS(5332),
    [anon_sym_DASH_EQ] = ACTIONS(5332),
    [anon_sym_STAR_EQ] = ACTIONS(5332),
    [anon_sym_SLASH_EQ] = ACTIONS(5332),
    [anon_sym_PERCENT_EQ] = ACTIONS(5332),
    [anon_sym_AMP_EQ] = ACTIONS(5332),
    [anon_sym_PIPE_EQ] = ACTIONS(5332),
    [anon_sym_CARET_EQ] = ACTIONS(5332),
    [anon_sym_LT_LT_EQ] = ACTIONS(5332),
    [anon_sym_GT_GT_EQ] = ACTIONS(5332),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5332),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5332),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5332),
    [anon_sym_if] = ACTIONS(5332),
    [anon_sym_SEMI] = ACTIONS(5332),
    [anon_sym_else] = ACTIONS(5332),
    [anon_sym_when] = ACTIONS(5332),
    [anon_sym_in] = ACTIONS(5332),
    [anon_sym_case] = ACTIONS(5332),
    [anon_sym_QMARK] = ACTIONS(5332),
    [anon_sym_PLUS] = ACTIONS(5334),
    [anon_sym_DASH] = ACTIONS(5334),
    [anon_sym_TILDE] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(5334),
    [anon_sym_PIPE_PIPE] = ACTIONS(5334),
    [anon_sym_or_else] = ACTIONS(5332),
    [anon_sym_AMP_AMP] = ACTIONS(5334),
    [anon_sym_GT] = ACTIONS(5334),
    [anon_sym_GT_EQ] = ACTIONS(5332),
    [anon_sym_LT_EQ] = ACTIONS(5332),
    [anon_sym_LT] = ACTIONS(5334),
    [anon_sym_EQ_EQ] = ACTIONS(5332),
    [anon_sym_BANG_EQ] = ACTIONS(5332),
    [anon_sym_TILDE_EQ] = ACTIONS(5332),
    [anon_sym_AMP_TILDE] = ACTIONS(5334),
    [anon_sym_LT_LT] = ACTIONS(5334),
    [anon_sym_GT_GT] = ACTIONS(5334),
    [anon_sym_STAR] = ACTIONS(5334),
    [anon_sym_SLASH] = ACTIONS(5334),
    [anon_sym_PERCENT] = ACTIONS(5334),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5332),
    [anon_sym_DOT] = ACTIONS(5334),
    [anon_sym_LBRACK] = ACTIONS(5332),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5332),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5332),
    [anon_sym_not_in] = ACTIONS(5332),
    [anon_sym_or_return] = ACTIONS(5332),
    [anon_sym_or_continue] = ACTIONS(5332),
    [anon_sym_or_break] = ACTIONS(5332),
    [anon_sym_CARET] = ACTIONS(5334),
    [sym_uninitialized] = ACTIONS(5332),
    [sym_tag] = ACTIONS(5332),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5332),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [967] = {
    [ts_builtin_sym_end] = ACTIONS(5336),
    [anon_sym_LBRACE] = ACTIONS(5336),
    [anon_sym_RBRACE] = ACTIONS(5336),
    [anon_sym_COMMA] = ACTIONS(5336),
    [anon_sym_COLON_COLON] = ACTIONS(5336),
    [anon_sym_DASH_GT] = ACTIONS(5336),
    [anon_sym_where] = ACTIONS(5336),
    [anon_sym_EQ] = ACTIONS(5338),
    [anon_sym_COLON] = ACTIONS(5338),
    [anon_sym_PIPE] = ACTIONS(5338),
    [anon_sym_COLON_EQ] = ACTIONS(5336),
    [anon_sym_LPAREN] = ACTIONS(5336),
    [anon_sym_PLUS_EQ] = ACTIONS(5336),
    [anon_sym_DASH_EQ] = ACTIONS(5336),
    [anon_sym_STAR_EQ] = ACTIONS(5336),
    [anon_sym_SLASH_EQ] = ACTIONS(5336),
    [anon_sym_PERCENT_EQ] = ACTIONS(5336),
    [anon_sym_AMP_EQ] = ACTIONS(5336),
    [anon_sym_PIPE_EQ] = ACTIONS(5336),
    [anon_sym_CARET_EQ] = ACTIONS(5336),
    [anon_sym_LT_LT_EQ] = ACTIONS(5336),
    [anon_sym_GT_GT_EQ] = ACTIONS(5336),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5336),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5336),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5336),
    [anon_sym_if] = ACTIONS(5336),
    [anon_sym_SEMI] = ACTIONS(5336),
    [anon_sym_else] = ACTIONS(5336),
    [anon_sym_when] = ACTIONS(5336),
    [anon_sym_in] = ACTIONS(5336),
    [anon_sym_case] = ACTIONS(5336),
    [anon_sym_QMARK] = ACTIONS(5336),
    [anon_sym_PLUS] = ACTIONS(5338),
    [anon_sym_DASH] = ACTIONS(5338),
    [anon_sym_TILDE] = ACTIONS(5338),
    [anon_sym_AMP] = ACTIONS(5338),
    [anon_sym_PIPE_PIPE] = ACTIONS(5338),
    [anon_sym_or_else] = ACTIONS(5336),
    [anon_sym_AMP_AMP] = ACTIONS(5338),
    [anon_sym_GT] = ACTIONS(5338),
    [anon_sym_GT_EQ] = ACTIONS(5336),
    [anon_sym_LT_EQ] = ACTIONS(5336),
    [anon_sym_LT] = ACTIONS(5338),
    [anon_sym_EQ_EQ] = ACTIONS(5336),
    [anon_sym_BANG_EQ] = ACTIONS(5336),
    [anon_sym_TILDE_EQ] = ACTIONS(5336),
    [anon_sym_AMP_TILDE] = ACTIONS(5338),
    [anon_sym_LT_LT] = ACTIONS(5338),
    [anon_sym_GT_GT] = ACTIONS(5338),
    [anon_sym_STAR] = ACTIONS(5338),
    [anon_sym_SLASH] = ACTIONS(5338),
    [anon_sym_PERCENT] = ACTIONS(5338),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5336),
    [anon_sym_DOT] = ACTIONS(5338),
    [anon_sym_LBRACK] = ACTIONS(5336),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5336),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5336),
    [anon_sym_not_in] = ACTIONS(5336),
    [anon_sym_or_return] = ACTIONS(5336),
    [anon_sym_or_continue] = ACTIONS(5336),
    [anon_sym_or_break] = ACTIONS(5336),
    [anon_sym_CARET] = ACTIONS(5338),
    [sym_uninitialized] = ACTIONS(5336),
    [sym_tag] = ACTIONS(5336),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5336),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [968] = {
    [ts_builtin_sym_end] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(5340),
    [anon_sym_RBRACE] = ACTIONS(5340),
    [anon_sym_COMMA] = ACTIONS(5340),
    [anon_sym_COLON_COLON] = ACTIONS(5340),
    [anon_sym_DASH_GT] = ACTIONS(5340),
    [anon_sym_where] = ACTIONS(5340),
    [anon_sym_EQ] = ACTIONS(5342),
    [anon_sym_COLON] = ACTIONS(5342),
    [anon_sym_PIPE] = ACTIONS(5342),
    [anon_sym_COLON_EQ] = ACTIONS(5340),
    [anon_sym_LPAREN] = ACTIONS(5340),
    [anon_sym_PLUS_EQ] = ACTIONS(5340),
    [anon_sym_DASH_EQ] = ACTIONS(5340),
    [anon_sym_STAR_EQ] = ACTIONS(5340),
    [anon_sym_SLASH_EQ] = ACTIONS(5340),
    [anon_sym_PERCENT_EQ] = ACTIONS(5340),
    [anon_sym_AMP_EQ] = ACTIONS(5340),
    [anon_sym_PIPE_EQ] = ACTIONS(5340),
    [anon_sym_CARET_EQ] = ACTIONS(5340),
    [anon_sym_LT_LT_EQ] = ACTIONS(5340),
    [anon_sym_GT_GT_EQ] = ACTIONS(5340),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5340),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5340),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5340),
    [anon_sym_if] = ACTIONS(5340),
    [anon_sym_SEMI] = ACTIONS(5340),
    [anon_sym_else] = ACTIONS(5340),
    [anon_sym_when] = ACTIONS(5340),
    [anon_sym_in] = ACTIONS(5340),
    [anon_sym_case] = ACTIONS(5340),
    [anon_sym_QMARK] = ACTIONS(5340),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_DASH] = ACTIONS(5342),
    [anon_sym_TILDE] = ACTIONS(5342),
    [anon_sym_AMP] = ACTIONS(5342),
    [anon_sym_PIPE_PIPE] = ACTIONS(5342),
    [anon_sym_or_else] = ACTIONS(5340),
    [anon_sym_AMP_AMP] = ACTIONS(5342),
    [anon_sym_GT] = ACTIONS(5342),
    [anon_sym_GT_EQ] = ACTIONS(5340),
    [anon_sym_LT_EQ] = ACTIONS(5340),
    [anon_sym_LT] = ACTIONS(5342),
    [anon_sym_EQ_EQ] = ACTIONS(5340),
    [anon_sym_BANG_EQ] = ACTIONS(5340),
    [anon_sym_TILDE_EQ] = ACTIONS(5340),
    [anon_sym_AMP_TILDE] = ACTIONS(5342),
    [anon_sym_LT_LT] = ACTIONS(5342),
    [anon_sym_GT_GT] = ACTIONS(5342),
    [anon_sym_STAR] = ACTIONS(5342),
    [anon_sym_SLASH] = ACTIONS(5342),
    [anon_sym_PERCENT] = ACTIONS(5342),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5340),
    [anon_sym_DOT] = ACTIONS(5342),
    [anon_sym_LBRACK] = ACTIONS(5340),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5340),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5340),
    [anon_sym_not_in] = ACTIONS(5340),
    [anon_sym_or_return] = ACTIONS(5340),
    [anon_sym_or_continue] = ACTIONS(5340),
    [anon_sym_or_break] = ACTIONS(5340),
    [anon_sym_CARET] = ACTIONS(5342),
    [sym_uninitialized] = ACTIONS(5340),
    [sym_tag] = ACTIONS(5340),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5340),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [969] = {
    [ts_builtin_sym_end] = ACTIONS(5344),
    [anon_sym_LBRACE] = ACTIONS(5344),
    [anon_sym_RBRACE] = ACTIONS(5344),
    [anon_sym_COMMA] = ACTIONS(5344),
    [anon_sym_COLON_COLON] = ACTIONS(5344),
    [anon_sym_DASH_GT] = ACTIONS(5344),
    [anon_sym_where] = ACTIONS(5344),
    [anon_sym_EQ] = ACTIONS(5346),
    [anon_sym_COLON] = ACTIONS(5346),
    [anon_sym_PIPE] = ACTIONS(5346),
    [anon_sym_COLON_EQ] = ACTIONS(5344),
    [anon_sym_LPAREN] = ACTIONS(5344),
    [anon_sym_PLUS_EQ] = ACTIONS(5344),
    [anon_sym_DASH_EQ] = ACTIONS(5344),
    [anon_sym_STAR_EQ] = ACTIONS(5344),
    [anon_sym_SLASH_EQ] = ACTIONS(5344),
    [anon_sym_PERCENT_EQ] = ACTIONS(5344),
    [anon_sym_AMP_EQ] = ACTIONS(5344),
    [anon_sym_PIPE_EQ] = ACTIONS(5344),
    [anon_sym_CARET_EQ] = ACTIONS(5344),
    [anon_sym_LT_LT_EQ] = ACTIONS(5344),
    [anon_sym_GT_GT_EQ] = ACTIONS(5344),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5344),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5344),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5344),
    [anon_sym_if] = ACTIONS(5344),
    [anon_sym_SEMI] = ACTIONS(5344),
    [anon_sym_else] = ACTIONS(5344),
    [anon_sym_when] = ACTIONS(5344),
    [anon_sym_in] = ACTIONS(5344),
    [anon_sym_case] = ACTIONS(5344),
    [anon_sym_QMARK] = ACTIONS(5344),
    [anon_sym_PLUS] = ACTIONS(5346),
    [anon_sym_DASH] = ACTIONS(5346),
    [anon_sym_TILDE] = ACTIONS(5346),
    [anon_sym_AMP] = ACTIONS(5346),
    [anon_sym_PIPE_PIPE] = ACTIONS(5346),
    [anon_sym_or_else] = ACTIONS(5344),
    [anon_sym_AMP_AMP] = ACTIONS(5346),
    [anon_sym_GT] = ACTIONS(5346),
    [anon_sym_GT_EQ] = ACTIONS(5344),
    [anon_sym_LT_EQ] = ACTIONS(5344),
    [anon_sym_LT] = ACTIONS(5346),
    [anon_sym_EQ_EQ] = ACTIONS(5344),
    [anon_sym_BANG_EQ] = ACTIONS(5344),
    [anon_sym_TILDE_EQ] = ACTIONS(5344),
    [anon_sym_AMP_TILDE] = ACTIONS(5346),
    [anon_sym_LT_LT] = ACTIONS(5346),
    [anon_sym_GT_GT] = ACTIONS(5346),
    [anon_sym_STAR] = ACTIONS(5346),
    [anon_sym_SLASH] = ACTIONS(5346),
    [anon_sym_PERCENT] = ACTIONS(5346),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5344),
    [anon_sym_DOT] = ACTIONS(5346),
    [anon_sym_LBRACK] = ACTIONS(5344),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5344),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5344),
    [anon_sym_not_in] = ACTIONS(5344),
    [anon_sym_or_return] = ACTIONS(5344),
    [anon_sym_or_continue] = ACTIONS(5344),
    [anon_sym_or_break] = ACTIONS(5344),
    [anon_sym_CARET] = ACTIONS(5346),
    [sym_uninitialized] = ACTIONS(5344),
    [sym_tag] = ACTIONS(5344),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5344),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [970] = {
    [ts_builtin_sym_end] = ACTIONS(5348),
    [anon_sym_LBRACE] = ACTIONS(5348),
    [anon_sym_RBRACE] = ACTIONS(5348),
    [anon_sym_COMMA] = ACTIONS(5348),
    [anon_sym_COLON_COLON] = ACTIONS(5348),
    [anon_sym_DASH_GT] = ACTIONS(5348),
    [anon_sym_where] = ACTIONS(5348),
    [anon_sym_EQ] = ACTIONS(5350),
    [anon_sym_COLON] = ACTIONS(5350),
    [anon_sym_PIPE] = ACTIONS(5350),
    [anon_sym_COLON_EQ] = ACTIONS(5348),
    [anon_sym_LPAREN] = ACTIONS(5348),
    [anon_sym_PLUS_EQ] = ACTIONS(5348),
    [anon_sym_DASH_EQ] = ACTIONS(5348),
    [anon_sym_STAR_EQ] = ACTIONS(5348),
    [anon_sym_SLASH_EQ] = ACTIONS(5348),
    [anon_sym_PERCENT_EQ] = ACTIONS(5348),
    [anon_sym_AMP_EQ] = ACTIONS(5348),
    [anon_sym_PIPE_EQ] = ACTIONS(5348),
    [anon_sym_CARET_EQ] = ACTIONS(5348),
    [anon_sym_LT_LT_EQ] = ACTIONS(5348),
    [anon_sym_GT_GT_EQ] = ACTIONS(5348),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5348),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5348),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5348),
    [anon_sym_if] = ACTIONS(5348),
    [anon_sym_SEMI] = ACTIONS(5348),
    [anon_sym_else] = ACTIONS(5348),
    [anon_sym_when] = ACTIONS(5348),
    [anon_sym_in] = ACTIONS(5348),
    [anon_sym_case] = ACTIONS(5348),
    [anon_sym_QMARK] = ACTIONS(5348),
    [anon_sym_PLUS] = ACTIONS(5350),
    [anon_sym_DASH] = ACTIONS(5350),
    [anon_sym_TILDE] = ACTIONS(5350),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_PIPE_PIPE] = ACTIONS(5350),
    [anon_sym_or_else] = ACTIONS(5348),
    [anon_sym_AMP_AMP] = ACTIONS(5350),
    [anon_sym_GT] = ACTIONS(5350),
    [anon_sym_GT_EQ] = ACTIONS(5348),
    [anon_sym_LT_EQ] = ACTIONS(5348),
    [anon_sym_LT] = ACTIONS(5350),
    [anon_sym_EQ_EQ] = ACTIONS(5348),
    [anon_sym_BANG_EQ] = ACTIONS(5348),
    [anon_sym_TILDE_EQ] = ACTIONS(5348),
    [anon_sym_AMP_TILDE] = ACTIONS(5350),
    [anon_sym_LT_LT] = ACTIONS(5350),
    [anon_sym_GT_GT] = ACTIONS(5350),
    [anon_sym_STAR] = ACTIONS(5350),
    [anon_sym_SLASH] = ACTIONS(5350),
    [anon_sym_PERCENT] = ACTIONS(5350),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5348),
    [anon_sym_DOT] = ACTIONS(5350),
    [anon_sym_LBRACK] = ACTIONS(5348),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5348),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5348),
    [anon_sym_not_in] = ACTIONS(5348),
    [anon_sym_or_return] = ACTIONS(5348),
    [anon_sym_or_continue] = ACTIONS(5348),
    [anon_sym_or_break] = ACTIONS(5348),
    [anon_sym_CARET] = ACTIONS(5350),
    [sym_uninitialized] = ACTIONS(5348),
    [sym_tag] = ACTIONS(5348),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5348),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [971] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8371),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5352),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [972] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7780),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5290),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [973] = {
    [ts_builtin_sym_end] = ACTIONS(5354),
    [anon_sym_LBRACE] = ACTIONS(5354),
    [anon_sym_RBRACE] = ACTIONS(5354),
    [anon_sym_COMMA] = ACTIONS(5354),
    [anon_sym_COLON_COLON] = ACTIONS(5354),
    [anon_sym_DASH_GT] = ACTIONS(5354),
    [anon_sym_where] = ACTIONS(5354),
    [anon_sym_EQ] = ACTIONS(5356),
    [anon_sym_COLON] = ACTIONS(5356),
    [anon_sym_PIPE] = ACTIONS(5356),
    [anon_sym_COLON_EQ] = ACTIONS(5354),
    [anon_sym_LPAREN] = ACTIONS(5354),
    [anon_sym_PLUS_EQ] = ACTIONS(5354),
    [anon_sym_DASH_EQ] = ACTIONS(5354),
    [anon_sym_STAR_EQ] = ACTIONS(5354),
    [anon_sym_SLASH_EQ] = ACTIONS(5354),
    [anon_sym_PERCENT_EQ] = ACTIONS(5354),
    [anon_sym_AMP_EQ] = ACTIONS(5354),
    [anon_sym_PIPE_EQ] = ACTIONS(5354),
    [anon_sym_CARET_EQ] = ACTIONS(5354),
    [anon_sym_LT_LT_EQ] = ACTIONS(5354),
    [anon_sym_GT_GT_EQ] = ACTIONS(5354),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5354),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5354),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5354),
    [anon_sym_if] = ACTIONS(5354),
    [anon_sym_SEMI] = ACTIONS(5354),
    [anon_sym_else] = ACTIONS(5354),
    [anon_sym_when] = ACTIONS(5354),
    [anon_sym_in] = ACTIONS(5354),
    [anon_sym_case] = ACTIONS(5354),
    [anon_sym_QMARK] = ACTIONS(5354),
    [anon_sym_PLUS] = ACTIONS(5356),
    [anon_sym_DASH] = ACTIONS(5356),
    [anon_sym_TILDE] = ACTIONS(5356),
    [anon_sym_AMP] = ACTIONS(5356),
    [anon_sym_PIPE_PIPE] = ACTIONS(5356),
    [anon_sym_or_else] = ACTIONS(5354),
    [anon_sym_AMP_AMP] = ACTIONS(5356),
    [anon_sym_GT] = ACTIONS(5356),
    [anon_sym_GT_EQ] = ACTIONS(5354),
    [anon_sym_LT_EQ] = ACTIONS(5354),
    [anon_sym_LT] = ACTIONS(5356),
    [anon_sym_EQ_EQ] = ACTIONS(5354),
    [anon_sym_BANG_EQ] = ACTIONS(5354),
    [anon_sym_TILDE_EQ] = ACTIONS(5354),
    [anon_sym_AMP_TILDE] = ACTIONS(5356),
    [anon_sym_LT_LT] = ACTIONS(5356),
    [anon_sym_GT_GT] = ACTIONS(5356),
    [anon_sym_STAR] = ACTIONS(5356),
    [anon_sym_SLASH] = ACTIONS(5356),
    [anon_sym_PERCENT] = ACTIONS(5356),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5354),
    [anon_sym_DOT] = ACTIONS(5356),
    [anon_sym_LBRACK] = ACTIONS(5354),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5354),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5354),
    [anon_sym_not_in] = ACTIONS(5354),
    [anon_sym_or_return] = ACTIONS(5354),
    [anon_sym_or_continue] = ACTIONS(5354),
    [anon_sym_or_break] = ACTIONS(5354),
    [anon_sym_CARET] = ACTIONS(5356),
    [sym_uninitialized] = ACTIONS(5354),
    [sym_tag] = ACTIONS(5354),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5354),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [974] = {
    [ts_builtin_sym_end] = ACTIONS(5358),
    [anon_sym_LBRACE] = ACTIONS(5358),
    [anon_sym_RBRACE] = ACTIONS(5358),
    [anon_sym_COMMA] = ACTIONS(5358),
    [anon_sym_COLON_COLON] = ACTIONS(5358),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5358),
    [anon_sym_EQ] = ACTIONS(5360),
    [anon_sym_COLON] = ACTIONS(5360),
    [anon_sym_PIPE] = ACTIONS(5360),
    [anon_sym_COLON_EQ] = ACTIONS(5358),
    [anon_sym_LPAREN] = ACTIONS(5358),
    [anon_sym_PLUS_EQ] = ACTIONS(5358),
    [anon_sym_DASH_EQ] = ACTIONS(5358),
    [anon_sym_STAR_EQ] = ACTIONS(5358),
    [anon_sym_SLASH_EQ] = ACTIONS(5358),
    [anon_sym_PERCENT_EQ] = ACTIONS(5358),
    [anon_sym_AMP_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_CARET_EQ] = ACTIONS(5358),
    [anon_sym_LT_LT_EQ] = ACTIONS(5358),
    [anon_sym_GT_GT_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_if] = ACTIONS(5358),
    [anon_sym_SEMI] = ACTIONS(5358),
    [anon_sym_else] = ACTIONS(5358),
    [anon_sym_when] = ACTIONS(5358),
    [anon_sym_in] = ACTIONS(5358),
    [anon_sym_case] = ACTIONS(5358),
    [anon_sym_QMARK] = ACTIONS(5358),
    [anon_sym_PLUS] = ACTIONS(4736),
    [anon_sym_DASH] = ACTIONS(4736),
    [anon_sym_TILDE] = ACTIONS(4738),
    [anon_sym_AMP] = ACTIONS(4740),
    [anon_sym_PIPE_PIPE] = ACTIONS(5360),
    [anon_sym_or_else] = ACTIONS(5358),
    [anon_sym_AMP_AMP] = ACTIONS(5360),
    [anon_sym_GT] = ACTIONS(5360),
    [anon_sym_GT_EQ] = ACTIONS(5358),
    [anon_sym_LT_EQ] = ACTIONS(5358),
    [anon_sym_LT] = ACTIONS(5360),
    [anon_sym_EQ_EQ] = ACTIONS(5358),
    [anon_sym_BANG_EQ] = ACTIONS(5358),
    [anon_sym_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE] = ACTIONS(4754),
    [anon_sym_LT_LT] = ACTIONS(4756),
    [anon_sym_GT_GT] = ACTIONS(4756),
    [anon_sym_STAR] = ACTIONS(4758),
    [anon_sym_SLASH] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4760),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5358),
    [anon_sym_or_return] = ACTIONS(5358),
    [anon_sym_or_continue] = ACTIONS(5358),
    [anon_sym_or_break] = ACTIONS(5358),
    [anon_sym_CARET] = ACTIONS(5360),
    [sym_uninitialized] = ACTIONS(5358),
    [sym_tag] = ACTIONS(5358),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5358),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [975] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7694),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5362),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [976] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5364),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [977] = {
    [sym_procedure] = STATE(7210),
    [sym_expression] = STATE(5722),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [978] = {
    [ts_builtin_sym_end] = ACTIONS(5366),
    [anon_sym_LBRACE] = ACTIONS(5366),
    [anon_sym_RBRACE] = ACTIONS(5366),
    [anon_sym_COMMA] = ACTIONS(5366),
    [anon_sym_COLON_COLON] = ACTIONS(5366),
    [anon_sym_DASH_GT] = ACTIONS(5366),
    [anon_sym_where] = ACTIONS(5366),
    [anon_sym_EQ] = ACTIONS(5368),
    [anon_sym_COLON] = ACTIONS(5368),
    [anon_sym_PIPE] = ACTIONS(5368),
    [anon_sym_COLON_EQ] = ACTIONS(5366),
    [anon_sym_LPAREN] = ACTIONS(5366),
    [anon_sym_PLUS_EQ] = ACTIONS(5366),
    [anon_sym_DASH_EQ] = ACTIONS(5366),
    [anon_sym_STAR_EQ] = ACTIONS(5366),
    [anon_sym_SLASH_EQ] = ACTIONS(5366),
    [anon_sym_PERCENT_EQ] = ACTIONS(5366),
    [anon_sym_AMP_EQ] = ACTIONS(5366),
    [anon_sym_PIPE_EQ] = ACTIONS(5366),
    [anon_sym_CARET_EQ] = ACTIONS(5366),
    [anon_sym_LT_LT_EQ] = ACTIONS(5366),
    [anon_sym_GT_GT_EQ] = ACTIONS(5366),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5366),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5366),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5366),
    [anon_sym_if] = ACTIONS(5366),
    [anon_sym_SEMI] = ACTIONS(5366),
    [anon_sym_else] = ACTIONS(5366),
    [anon_sym_when] = ACTIONS(5366),
    [anon_sym_in] = ACTIONS(5366),
    [anon_sym_case] = ACTIONS(5366),
    [anon_sym_QMARK] = ACTIONS(5366),
    [anon_sym_PLUS] = ACTIONS(5368),
    [anon_sym_DASH] = ACTIONS(5368),
    [anon_sym_TILDE] = ACTIONS(5368),
    [anon_sym_AMP] = ACTIONS(5368),
    [anon_sym_PIPE_PIPE] = ACTIONS(5368),
    [anon_sym_or_else] = ACTIONS(5366),
    [anon_sym_AMP_AMP] = ACTIONS(5368),
    [anon_sym_GT] = ACTIONS(5368),
    [anon_sym_GT_EQ] = ACTIONS(5366),
    [anon_sym_LT_EQ] = ACTIONS(5366),
    [anon_sym_LT] = ACTIONS(5368),
    [anon_sym_EQ_EQ] = ACTIONS(5366),
    [anon_sym_BANG_EQ] = ACTIONS(5366),
    [anon_sym_TILDE_EQ] = ACTIONS(5366),
    [anon_sym_AMP_TILDE] = ACTIONS(5368),
    [anon_sym_LT_LT] = ACTIONS(5368),
    [anon_sym_GT_GT] = ACTIONS(5368),
    [anon_sym_STAR] = ACTIONS(5368),
    [anon_sym_SLASH] = ACTIONS(5368),
    [anon_sym_PERCENT] = ACTIONS(5368),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5366),
    [anon_sym_DOT] = ACTIONS(5368),
    [anon_sym_LBRACK] = ACTIONS(5366),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5366),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5366),
    [anon_sym_not_in] = ACTIONS(5366),
    [anon_sym_or_return] = ACTIONS(5366),
    [anon_sym_or_continue] = ACTIONS(5366),
    [anon_sym_or_break] = ACTIONS(5366),
    [anon_sym_CARET] = ACTIONS(5368),
    [sym_uninitialized] = ACTIONS(5366),
    [sym_tag] = ACTIONS(5366),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5366),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [979] = {
    [ts_builtin_sym_end] = ACTIONS(5370),
    [anon_sym_LBRACE] = ACTIONS(5370),
    [anon_sym_RBRACE] = ACTIONS(5370),
    [anon_sym_COMMA] = ACTIONS(5370),
    [anon_sym_COLON_COLON] = ACTIONS(5370),
    [anon_sym_DASH_GT] = ACTIONS(5370),
    [anon_sym_where] = ACTIONS(5370),
    [anon_sym_EQ] = ACTIONS(5372),
    [anon_sym_COLON] = ACTIONS(5372),
    [anon_sym_PIPE] = ACTIONS(5372),
    [anon_sym_COLON_EQ] = ACTIONS(5370),
    [anon_sym_LPAREN] = ACTIONS(5370),
    [anon_sym_PLUS_EQ] = ACTIONS(5370),
    [anon_sym_DASH_EQ] = ACTIONS(5370),
    [anon_sym_STAR_EQ] = ACTIONS(5370),
    [anon_sym_SLASH_EQ] = ACTIONS(5370),
    [anon_sym_PERCENT_EQ] = ACTIONS(5370),
    [anon_sym_AMP_EQ] = ACTIONS(5370),
    [anon_sym_PIPE_EQ] = ACTIONS(5370),
    [anon_sym_CARET_EQ] = ACTIONS(5370),
    [anon_sym_LT_LT_EQ] = ACTIONS(5370),
    [anon_sym_GT_GT_EQ] = ACTIONS(5370),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5370),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5370),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5370),
    [anon_sym_if] = ACTIONS(5370),
    [anon_sym_SEMI] = ACTIONS(5370),
    [anon_sym_else] = ACTIONS(5370),
    [anon_sym_when] = ACTIONS(5370),
    [anon_sym_in] = ACTIONS(5370),
    [anon_sym_case] = ACTIONS(5370),
    [anon_sym_QMARK] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_DASH] = ACTIONS(5372),
    [anon_sym_TILDE] = ACTIONS(5372),
    [anon_sym_AMP] = ACTIONS(5372),
    [anon_sym_PIPE_PIPE] = ACTIONS(5372),
    [anon_sym_or_else] = ACTIONS(5370),
    [anon_sym_AMP_AMP] = ACTIONS(5372),
    [anon_sym_GT] = ACTIONS(5372),
    [anon_sym_GT_EQ] = ACTIONS(5370),
    [anon_sym_LT_EQ] = ACTIONS(5370),
    [anon_sym_LT] = ACTIONS(5372),
    [anon_sym_EQ_EQ] = ACTIONS(5370),
    [anon_sym_BANG_EQ] = ACTIONS(5370),
    [anon_sym_TILDE_EQ] = ACTIONS(5370),
    [anon_sym_AMP_TILDE] = ACTIONS(5372),
    [anon_sym_LT_LT] = ACTIONS(5372),
    [anon_sym_GT_GT] = ACTIONS(5372),
    [anon_sym_STAR] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5372),
    [anon_sym_PERCENT] = ACTIONS(5372),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5370),
    [anon_sym_DOT] = ACTIONS(5372),
    [anon_sym_LBRACK] = ACTIONS(5370),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5370),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5370),
    [anon_sym_not_in] = ACTIONS(5370),
    [anon_sym_or_return] = ACTIONS(5370),
    [anon_sym_or_continue] = ACTIONS(5370),
    [anon_sym_or_break] = ACTIONS(5370),
    [anon_sym_CARET] = ACTIONS(5372),
    [sym_uninitialized] = ACTIONS(5370),
    [sym_tag] = ACTIONS(5370),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5370),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [980] = {
    [ts_builtin_sym_end] = ACTIONS(5374),
    [anon_sym_LBRACE] = ACTIONS(5374),
    [anon_sym_RBRACE] = ACTIONS(5374),
    [anon_sym_COMMA] = ACTIONS(5374),
    [anon_sym_COLON_COLON] = ACTIONS(5374),
    [anon_sym_DASH_GT] = ACTIONS(5374),
    [anon_sym_where] = ACTIONS(5374),
    [anon_sym_EQ] = ACTIONS(5376),
    [anon_sym_COLON] = ACTIONS(5376),
    [anon_sym_PIPE] = ACTIONS(5376),
    [anon_sym_COLON_EQ] = ACTIONS(5374),
    [anon_sym_LPAREN] = ACTIONS(5374),
    [anon_sym_PLUS_EQ] = ACTIONS(5374),
    [anon_sym_DASH_EQ] = ACTIONS(5374),
    [anon_sym_STAR_EQ] = ACTIONS(5374),
    [anon_sym_SLASH_EQ] = ACTIONS(5374),
    [anon_sym_PERCENT_EQ] = ACTIONS(5374),
    [anon_sym_AMP_EQ] = ACTIONS(5374),
    [anon_sym_PIPE_EQ] = ACTIONS(5374),
    [anon_sym_CARET_EQ] = ACTIONS(5374),
    [anon_sym_LT_LT_EQ] = ACTIONS(5374),
    [anon_sym_GT_GT_EQ] = ACTIONS(5374),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5374),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5374),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5374),
    [anon_sym_if] = ACTIONS(5374),
    [anon_sym_SEMI] = ACTIONS(5374),
    [anon_sym_else] = ACTIONS(5374),
    [anon_sym_when] = ACTIONS(5374),
    [anon_sym_in] = ACTIONS(5374),
    [anon_sym_case] = ACTIONS(5374),
    [anon_sym_QMARK] = ACTIONS(5374),
    [anon_sym_PLUS] = ACTIONS(5376),
    [anon_sym_DASH] = ACTIONS(5376),
    [anon_sym_TILDE] = ACTIONS(5376),
    [anon_sym_AMP] = ACTIONS(5376),
    [anon_sym_PIPE_PIPE] = ACTIONS(5376),
    [anon_sym_or_else] = ACTIONS(5374),
    [anon_sym_AMP_AMP] = ACTIONS(5376),
    [anon_sym_GT] = ACTIONS(5376),
    [anon_sym_GT_EQ] = ACTIONS(5374),
    [anon_sym_LT_EQ] = ACTIONS(5374),
    [anon_sym_LT] = ACTIONS(5376),
    [anon_sym_EQ_EQ] = ACTIONS(5374),
    [anon_sym_BANG_EQ] = ACTIONS(5374),
    [anon_sym_TILDE_EQ] = ACTIONS(5374),
    [anon_sym_AMP_TILDE] = ACTIONS(5376),
    [anon_sym_LT_LT] = ACTIONS(5376),
    [anon_sym_GT_GT] = ACTIONS(5376),
    [anon_sym_STAR] = ACTIONS(5376),
    [anon_sym_SLASH] = ACTIONS(5376),
    [anon_sym_PERCENT] = ACTIONS(5376),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5374),
    [anon_sym_DOT] = ACTIONS(5376),
    [anon_sym_LBRACK] = ACTIONS(5374),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5374),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5374),
    [anon_sym_not_in] = ACTIONS(5374),
    [anon_sym_or_return] = ACTIONS(5374),
    [anon_sym_or_continue] = ACTIONS(5374),
    [anon_sym_or_break] = ACTIONS(5374),
    [anon_sym_CARET] = ACTIONS(5376),
    [sym_uninitialized] = ACTIONS(5374),
    [sym_tag] = ACTIONS(5374),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5374),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [981] = {
    [sym_procedure] = STATE(7279),
    [sym_expression] = STATE(5743),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [982] = {
    [ts_builtin_sym_end] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(5378),
    [anon_sym_RBRACE] = ACTIONS(5378),
    [anon_sym_COMMA] = ACTIONS(5378),
    [anon_sym_COLON_COLON] = ACTIONS(5378),
    [anon_sym_DASH_GT] = ACTIONS(5378),
    [anon_sym_where] = ACTIONS(5378),
    [anon_sym_EQ] = ACTIONS(5380),
    [anon_sym_COLON] = ACTIONS(5380),
    [anon_sym_PIPE] = ACTIONS(5380),
    [anon_sym_COLON_EQ] = ACTIONS(5378),
    [anon_sym_LPAREN] = ACTIONS(5378),
    [anon_sym_PLUS_EQ] = ACTIONS(5378),
    [anon_sym_DASH_EQ] = ACTIONS(5378),
    [anon_sym_STAR_EQ] = ACTIONS(5378),
    [anon_sym_SLASH_EQ] = ACTIONS(5378),
    [anon_sym_PERCENT_EQ] = ACTIONS(5378),
    [anon_sym_AMP_EQ] = ACTIONS(5378),
    [anon_sym_PIPE_EQ] = ACTIONS(5378),
    [anon_sym_CARET_EQ] = ACTIONS(5378),
    [anon_sym_LT_LT_EQ] = ACTIONS(5378),
    [anon_sym_GT_GT_EQ] = ACTIONS(5378),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5378),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5378),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5378),
    [anon_sym_if] = ACTIONS(5378),
    [anon_sym_SEMI] = ACTIONS(5378),
    [anon_sym_else] = ACTIONS(5378),
    [anon_sym_when] = ACTIONS(5378),
    [anon_sym_in] = ACTIONS(5378),
    [anon_sym_case] = ACTIONS(5378),
    [anon_sym_QMARK] = ACTIONS(5378),
    [anon_sym_PLUS] = ACTIONS(5380),
    [anon_sym_DASH] = ACTIONS(5380),
    [anon_sym_TILDE] = ACTIONS(5380),
    [anon_sym_AMP] = ACTIONS(5380),
    [anon_sym_PIPE_PIPE] = ACTIONS(5380),
    [anon_sym_or_else] = ACTIONS(5378),
    [anon_sym_AMP_AMP] = ACTIONS(5380),
    [anon_sym_GT] = ACTIONS(5380),
    [anon_sym_GT_EQ] = ACTIONS(5378),
    [anon_sym_LT_EQ] = ACTIONS(5378),
    [anon_sym_LT] = ACTIONS(5380),
    [anon_sym_EQ_EQ] = ACTIONS(5378),
    [anon_sym_BANG_EQ] = ACTIONS(5378),
    [anon_sym_TILDE_EQ] = ACTIONS(5378),
    [anon_sym_AMP_TILDE] = ACTIONS(5380),
    [anon_sym_LT_LT] = ACTIONS(5380),
    [anon_sym_GT_GT] = ACTIONS(5380),
    [anon_sym_STAR] = ACTIONS(5380),
    [anon_sym_SLASH] = ACTIONS(5380),
    [anon_sym_PERCENT] = ACTIONS(5380),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5378),
    [anon_sym_DOT] = ACTIONS(5380),
    [anon_sym_LBRACK] = ACTIONS(5378),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5378),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5378),
    [anon_sym_not_in] = ACTIONS(5378),
    [anon_sym_or_return] = ACTIONS(5378),
    [anon_sym_or_continue] = ACTIONS(5378),
    [anon_sym_or_break] = ACTIONS(5378),
    [anon_sym_CARET] = ACTIONS(5380),
    [sym_uninitialized] = ACTIONS(5378),
    [sym_tag] = ACTIONS(5378),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5378),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [983] = {
    [ts_builtin_sym_end] = ACTIONS(5382),
    [anon_sym_LBRACE] = ACTIONS(5382),
    [anon_sym_RBRACE] = ACTIONS(5382),
    [anon_sym_COMMA] = ACTIONS(5382),
    [anon_sym_COLON_COLON] = ACTIONS(5382),
    [anon_sym_DASH_GT] = ACTIONS(5382),
    [anon_sym_where] = ACTIONS(5382),
    [anon_sym_EQ] = ACTIONS(5384),
    [anon_sym_COLON] = ACTIONS(5384),
    [anon_sym_PIPE] = ACTIONS(5384),
    [anon_sym_COLON_EQ] = ACTIONS(5382),
    [anon_sym_LPAREN] = ACTIONS(5382),
    [anon_sym_PLUS_EQ] = ACTIONS(5382),
    [anon_sym_DASH_EQ] = ACTIONS(5382),
    [anon_sym_STAR_EQ] = ACTIONS(5382),
    [anon_sym_SLASH_EQ] = ACTIONS(5382),
    [anon_sym_PERCENT_EQ] = ACTIONS(5382),
    [anon_sym_AMP_EQ] = ACTIONS(5382),
    [anon_sym_PIPE_EQ] = ACTIONS(5382),
    [anon_sym_CARET_EQ] = ACTIONS(5382),
    [anon_sym_LT_LT_EQ] = ACTIONS(5382),
    [anon_sym_GT_GT_EQ] = ACTIONS(5382),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5382),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5382),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5382),
    [anon_sym_if] = ACTIONS(5382),
    [anon_sym_SEMI] = ACTIONS(5382),
    [anon_sym_else] = ACTIONS(5382),
    [anon_sym_when] = ACTIONS(5382),
    [anon_sym_in] = ACTIONS(5382),
    [anon_sym_case] = ACTIONS(5382),
    [anon_sym_QMARK] = ACTIONS(5382),
    [anon_sym_PLUS] = ACTIONS(5384),
    [anon_sym_DASH] = ACTIONS(5384),
    [anon_sym_TILDE] = ACTIONS(5384),
    [anon_sym_AMP] = ACTIONS(5384),
    [anon_sym_PIPE_PIPE] = ACTIONS(5384),
    [anon_sym_or_else] = ACTIONS(5382),
    [anon_sym_AMP_AMP] = ACTIONS(5384),
    [anon_sym_GT] = ACTIONS(5384),
    [anon_sym_GT_EQ] = ACTIONS(5382),
    [anon_sym_LT_EQ] = ACTIONS(5382),
    [anon_sym_LT] = ACTIONS(5384),
    [anon_sym_EQ_EQ] = ACTIONS(5382),
    [anon_sym_BANG_EQ] = ACTIONS(5382),
    [anon_sym_TILDE_EQ] = ACTIONS(5382),
    [anon_sym_AMP_TILDE] = ACTIONS(5384),
    [anon_sym_LT_LT] = ACTIONS(5384),
    [anon_sym_GT_GT] = ACTIONS(5384),
    [anon_sym_STAR] = ACTIONS(5384),
    [anon_sym_SLASH] = ACTIONS(5384),
    [anon_sym_PERCENT] = ACTIONS(5384),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5382),
    [anon_sym_DOT] = ACTIONS(5384),
    [anon_sym_LBRACK] = ACTIONS(5382),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5382),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5382),
    [anon_sym_not_in] = ACTIONS(5382),
    [anon_sym_or_return] = ACTIONS(5382),
    [anon_sym_or_continue] = ACTIONS(5382),
    [anon_sym_or_break] = ACTIONS(5382),
    [anon_sym_CARET] = ACTIONS(5384),
    [sym_uninitialized] = ACTIONS(5382),
    [sym_tag] = ACTIONS(5382),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5382),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [984] = {
    [ts_builtin_sym_end] = ACTIONS(5386),
    [anon_sym_LBRACE] = ACTIONS(5386),
    [anon_sym_RBRACE] = ACTIONS(5386),
    [anon_sym_COMMA] = ACTIONS(5386),
    [anon_sym_COLON_COLON] = ACTIONS(5386),
    [anon_sym_DASH_GT] = ACTIONS(5386),
    [anon_sym_where] = ACTIONS(5386),
    [anon_sym_EQ] = ACTIONS(5388),
    [anon_sym_COLON] = ACTIONS(5390),
    [anon_sym_PIPE] = ACTIONS(5390),
    [anon_sym_COLON_EQ] = ACTIONS(5386),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(5386),
    [anon_sym_DASH_EQ] = ACTIONS(5386),
    [anon_sym_STAR_EQ] = ACTIONS(5386),
    [anon_sym_SLASH_EQ] = ACTIONS(5386),
    [anon_sym_PERCENT_EQ] = ACTIONS(5386),
    [anon_sym_AMP_EQ] = ACTIONS(5386),
    [anon_sym_PIPE_EQ] = ACTIONS(5386),
    [anon_sym_CARET_EQ] = ACTIONS(5386),
    [anon_sym_LT_LT_EQ] = ACTIONS(5386),
    [anon_sym_GT_GT_EQ] = ACTIONS(5386),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5386),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5386),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5386),
    [anon_sym_if] = ACTIONS(5386),
    [anon_sym_SEMI] = ACTIONS(5386),
    [anon_sym_else] = ACTIONS(5386),
    [anon_sym_when] = ACTIONS(5386),
    [anon_sym_in] = ACTIONS(5386),
    [anon_sym_case] = ACTIONS(5386),
    [anon_sym_QMARK] = ACTIONS(5386),
    [anon_sym_PLUS] = ACTIONS(5390),
    [anon_sym_DASH] = ACTIONS(5390),
    [anon_sym_TILDE] = ACTIONS(5390),
    [anon_sym_AMP] = ACTIONS(5390),
    [anon_sym_PIPE_PIPE] = ACTIONS(5390),
    [anon_sym_or_else] = ACTIONS(5386),
    [anon_sym_AMP_AMP] = ACTIONS(5390),
    [anon_sym_GT] = ACTIONS(5390),
    [anon_sym_GT_EQ] = ACTIONS(5386),
    [anon_sym_LT_EQ] = ACTIONS(5386),
    [anon_sym_LT] = ACTIONS(5390),
    [anon_sym_EQ_EQ] = ACTIONS(5386),
    [anon_sym_BANG_EQ] = ACTIONS(5386),
    [anon_sym_TILDE_EQ] = ACTIONS(5386),
    [anon_sym_AMP_TILDE] = ACTIONS(5390),
    [anon_sym_LT_LT] = ACTIONS(5390),
    [anon_sym_GT_GT] = ACTIONS(5390),
    [anon_sym_STAR] = ACTIONS(5390),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(5390),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5386),
    [anon_sym_DOT] = ACTIONS(5390),
    [anon_sym_LBRACK] = ACTIONS(5386),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5386),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5386),
    [anon_sym_not_in] = ACTIONS(5386),
    [anon_sym_or_return] = ACTIONS(5386),
    [anon_sym_or_continue] = ACTIONS(5386),
    [anon_sym_or_break] = ACTIONS(5386),
    [anon_sym_CARET] = ACTIONS(5390),
    [sym_uninitialized] = ACTIONS(5386),
    [sym_tag] = ACTIONS(5386),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5386),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [985] = {
    [sym_procedure] = STATE(6879),
    [sym_expression] = STATE(4836),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(5392),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [986] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5394),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [987] = {
    [ts_builtin_sym_end] = ACTIONS(5396),
    [anon_sym_LBRACE] = ACTIONS(5396),
    [anon_sym_RBRACE] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5396),
    [anon_sym_COLON_COLON] = ACTIONS(5396),
    [anon_sym_DASH_GT] = ACTIONS(5396),
    [anon_sym_where] = ACTIONS(5396),
    [anon_sym_EQ] = ACTIONS(5398),
    [anon_sym_COLON] = ACTIONS(5398),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_COLON_EQ] = ACTIONS(5396),
    [anon_sym_LPAREN] = ACTIONS(5396),
    [anon_sym_PLUS_EQ] = ACTIONS(5396),
    [anon_sym_DASH_EQ] = ACTIONS(5396),
    [anon_sym_STAR_EQ] = ACTIONS(5396),
    [anon_sym_SLASH_EQ] = ACTIONS(5396),
    [anon_sym_PERCENT_EQ] = ACTIONS(5396),
    [anon_sym_AMP_EQ] = ACTIONS(5396),
    [anon_sym_PIPE_EQ] = ACTIONS(5396),
    [anon_sym_CARET_EQ] = ACTIONS(5396),
    [anon_sym_LT_LT_EQ] = ACTIONS(5396),
    [anon_sym_GT_GT_EQ] = ACTIONS(5396),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5396),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5396),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5396),
    [anon_sym_if] = ACTIONS(5396),
    [anon_sym_SEMI] = ACTIONS(5396),
    [anon_sym_else] = ACTIONS(5396),
    [anon_sym_when] = ACTIONS(5396),
    [anon_sym_in] = ACTIONS(5396),
    [anon_sym_case] = ACTIONS(5396),
    [anon_sym_QMARK] = ACTIONS(5396),
    [anon_sym_PLUS] = ACTIONS(5398),
    [anon_sym_DASH] = ACTIONS(5398),
    [anon_sym_TILDE] = ACTIONS(5398),
    [anon_sym_AMP] = ACTIONS(5398),
    [anon_sym_PIPE_PIPE] = ACTIONS(5398),
    [anon_sym_or_else] = ACTIONS(5396),
    [anon_sym_AMP_AMP] = ACTIONS(5398),
    [anon_sym_GT] = ACTIONS(5398),
    [anon_sym_GT_EQ] = ACTIONS(5396),
    [anon_sym_LT_EQ] = ACTIONS(5396),
    [anon_sym_LT] = ACTIONS(5398),
    [anon_sym_EQ_EQ] = ACTIONS(5396),
    [anon_sym_BANG_EQ] = ACTIONS(5396),
    [anon_sym_TILDE_EQ] = ACTIONS(5396),
    [anon_sym_AMP_TILDE] = ACTIONS(5398),
    [anon_sym_LT_LT] = ACTIONS(5398),
    [anon_sym_GT_GT] = ACTIONS(5398),
    [anon_sym_STAR] = ACTIONS(5398),
    [anon_sym_SLASH] = ACTIONS(5398),
    [anon_sym_PERCENT] = ACTIONS(5398),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5396),
    [anon_sym_DOT] = ACTIONS(5398),
    [anon_sym_LBRACK] = ACTIONS(5396),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5396),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5396),
    [anon_sym_not_in] = ACTIONS(5396),
    [anon_sym_or_return] = ACTIONS(5396),
    [anon_sym_or_continue] = ACTIONS(5396),
    [anon_sym_or_break] = ACTIONS(5396),
    [anon_sym_CARET] = ACTIONS(5398),
    [sym_uninitialized] = ACTIONS(5396),
    [sym_tag] = ACTIONS(5396),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5396),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [988] = {
    [ts_builtin_sym_end] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(891),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COLON_EQ] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(891),
    [anon_sym_PLUS_EQ] = ACTIONS(891),
    [anon_sym_DASH_EQ] = ACTIONS(891),
    [anon_sym_STAR_EQ] = ACTIONS(891),
    [anon_sym_SLASH_EQ] = ACTIONS(891),
    [anon_sym_PERCENT_EQ] = ACTIONS(891),
    [anon_sym_AMP_EQ] = ACTIONS(891),
    [anon_sym_PIPE_EQ] = ACTIONS(891),
    [anon_sym_CARET_EQ] = ACTIONS(891),
    [anon_sym_LT_LT_EQ] = ACTIONS(891),
    [anon_sym_GT_GT_EQ] = ACTIONS(891),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(891),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(891),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(891),
    [anon_sym_when] = ACTIONS(891),
    [anon_sym_in] = ACTIONS(891),
    [anon_sym_case] = ACTIONS(891),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(894),
    [anon_sym_or_else] = ACTIONS(891),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(894),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(891),
    [anon_sym_or_return] = ACTIONS(891),
    [anon_sym_or_continue] = ACTIONS(891),
    [anon_sym_or_break] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(894),
    [sym_uninitialized] = ACTIONS(891),
    [sym_tag] = ACTIONS(891),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(891),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [989] = {
    [ts_builtin_sym_end] = ACTIONS(4800),
    [anon_sym_LBRACE] = ACTIONS(4800),
    [anon_sym_RBRACE] = ACTIONS(4800),
    [anon_sym_COMMA] = ACTIONS(4800),
    [anon_sym_COLON_COLON] = ACTIONS(4800),
    [anon_sym_DASH_GT] = ACTIONS(4800),
    [anon_sym_where] = ACTIONS(4800),
    [anon_sym_EQ] = ACTIONS(4804),
    [anon_sym_COLON] = ACTIONS(4804),
    [anon_sym_PIPE] = ACTIONS(4804),
    [anon_sym_COLON_EQ] = ACTIONS(4800),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(4800),
    [anon_sym_DASH_EQ] = ACTIONS(4800),
    [anon_sym_STAR_EQ] = ACTIONS(4800),
    [anon_sym_SLASH_EQ] = ACTIONS(4800),
    [anon_sym_PERCENT_EQ] = ACTIONS(4800),
    [anon_sym_AMP_EQ] = ACTIONS(4800),
    [anon_sym_PIPE_EQ] = ACTIONS(4800),
    [anon_sym_CARET_EQ] = ACTIONS(4800),
    [anon_sym_LT_LT_EQ] = ACTIONS(4800),
    [anon_sym_GT_GT_EQ] = ACTIONS(4800),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4800),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4800),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4800),
    [anon_sym_if] = ACTIONS(4800),
    [anon_sym_SEMI] = ACTIONS(4800),
    [anon_sym_else] = ACTIONS(4800),
    [anon_sym_when] = ACTIONS(4800),
    [anon_sym_in] = ACTIONS(4800),
    [anon_sym_case] = ACTIONS(4800),
    [anon_sym_QMARK] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4804),
    [anon_sym_DASH] = ACTIONS(4804),
    [anon_sym_TILDE] = ACTIONS(4804),
    [anon_sym_AMP] = ACTIONS(4804),
    [anon_sym_PIPE_PIPE] = ACTIONS(4804),
    [anon_sym_or_else] = ACTIONS(4800),
    [anon_sym_AMP_AMP] = ACTIONS(4804),
    [anon_sym_GT] = ACTIONS(4804),
    [anon_sym_GT_EQ] = ACTIONS(4800),
    [anon_sym_LT_EQ] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4804),
    [anon_sym_EQ_EQ] = ACTIONS(4800),
    [anon_sym_BANG_EQ] = ACTIONS(4800),
    [anon_sym_TILDE_EQ] = ACTIONS(4800),
    [anon_sym_AMP_TILDE] = ACTIONS(4804),
    [anon_sym_LT_LT] = ACTIONS(4804),
    [anon_sym_GT_GT] = ACTIONS(4804),
    [anon_sym_STAR] = ACTIONS(4804),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(4804),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4800),
    [anon_sym_DOT] = ACTIONS(4804),
    [anon_sym_LBRACK] = ACTIONS(4800),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4800),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4800),
    [anon_sym_not_in] = ACTIONS(4800),
    [anon_sym_or_return] = ACTIONS(4800),
    [anon_sym_or_continue] = ACTIONS(4800),
    [anon_sym_or_break] = ACTIONS(4800),
    [anon_sym_CARET] = ACTIONS(4804),
    [sym_uninitialized] = ACTIONS(4800),
    [sym_tag] = ACTIONS(4800),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4800),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [990] = {
    [ts_builtin_sym_end] = ACTIONS(5400),
    [anon_sym_LBRACE] = ACTIONS(5400),
    [anon_sym_RBRACE] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5400),
    [anon_sym_COLON_COLON] = ACTIONS(5400),
    [anon_sym_DASH_GT] = ACTIONS(5400),
    [anon_sym_where] = ACTIONS(5400),
    [anon_sym_EQ] = ACTIONS(5402),
    [anon_sym_COLON] = ACTIONS(5402),
    [anon_sym_PIPE] = ACTIONS(5402),
    [anon_sym_COLON_EQ] = ACTIONS(5400),
    [anon_sym_LPAREN] = ACTIONS(5400),
    [anon_sym_PLUS_EQ] = ACTIONS(5400),
    [anon_sym_DASH_EQ] = ACTIONS(5400),
    [anon_sym_STAR_EQ] = ACTIONS(5400),
    [anon_sym_SLASH_EQ] = ACTIONS(5400),
    [anon_sym_PERCENT_EQ] = ACTIONS(5400),
    [anon_sym_AMP_EQ] = ACTIONS(5400),
    [anon_sym_PIPE_EQ] = ACTIONS(5400),
    [anon_sym_CARET_EQ] = ACTIONS(5400),
    [anon_sym_LT_LT_EQ] = ACTIONS(5400),
    [anon_sym_GT_GT_EQ] = ACTIONS(5400),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5400),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5400),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5400),
    [anon_sym_if] = ACTIONS(5400),
    [anon_sym_SEMI] = ACTIONS(5400),
    [anon_sym_else] = ACTIONS(5400),
    [anon_sym_when] = ACTIONS(5400),
    [anon_sym_in] = ACTIONS(5400),
    [anon_sym_case] = ACTIONS(5400),
    [anon_sym_QMARK] = ACTIONS(5400),
    [anon_sym_PLUS] = ACTIONS(5402),
    [anon_sym_DASH] = ACTIONS(5402),
    [anon_sym_TILDE] = ACTIONS(5402),
    [anon_sym_AMP] = ACTIONS(5402),
    [anon_sym_PIPE_PIPE] = ACTIONS(5402),
    [anon_sym_or_else] = ACTIONS(5400),
    [anon_sym_AMP_AMP] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_GT_EQ] = ACTIONS(5400),
    [anon_sym_LT_EQ] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_EQ_EQ] = ACTIONS(5400),
    [anon_sym_BANG_EQ] = ACTIONS(5400),
    [anon_sym_TILDE_EQ] = ACTIONS(5400),
    [anon_sym_AMP_TILDE] = ACTIONS(5402),
    [anon_sym_LT_LT] = ACTIONS(5402),
    [anon_sym_GT_GT] = ACTIONS(5402),
    [anon_sym_STAR] = ACTIONS(5402),
    [anon_sym_SLASH] = ACTIONS(5402),
    [anon_sym_PERCENT] = ACTIONS(5402),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5400),
    [anon_sym_DOT] = ACTIONS(5402),
    [anon_sym_LBRACK] = ACTIONS(5400),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5400),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5400),
    [anon_sym_not_in] = ACTIONS(5400),
    [anon_sym_or_return] = ACTIONS(5400),
    [anon_sym_or_continue] = ACTIONS(5400),
    [anon_sym_or_break] = ACTIONS(5400),
    [anon_sym_CARET] = ACTIONS(5402),
    [sym_uninitialized] = ACTIONS(5400),
    [sym_tag] = ACTIONS(5400),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5400),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [991] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5404),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [992] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8306),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5406),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [993] = {
    [ts_builtin_sym_end] = ACTIONS(5408),
    [anon_sym_LBRACE] = ACTIONS(5408),
    [anon_sym_RBRACE] = ACTIONS(5408),
    [anon_sym_COMMA] = ACTIONS(5408),
    [anon_sym_COLON_COLON] = ACTIONS(5408),
    [anon_sym_DASH_GT] = ACTIONS(5408),
    [anon_sym_where] = ACTIONS(5408),
    [anon_sym_EQ] = ACTIONS(5410),
    [anon_sym_COLON] = ACTIONS(5410),
    [anon_sym_PIPE] = ACTIONS(5410),
    [anon_sym_COLON_EQ] = ACTIONS(5408),
    [anon_sym_LPAREN] = ACTIONS(5408),
    [anon_sym_PLUS_EQ] = ACTIONS(5408),
    [anon_sym_DASH_EQ] = ACTIONS(5408),
    [anon_sym_STAR_EQ] = ACTIONS(5408),
    [anon_sym_SLASH_EQ] = ACTIONS(5408),
    [anon_sym_PERCENT_EQ] = ACTIONS(5408),
    [anon_sym_AMP_EQ] = ACTIONS(5408),
    [anon_sym_PIPE_EQ] = ACTIONS(5408),
    [anon_sym_CARET_EQ] = ACTIONS(5408),
    [anon_sym_LT_LT_EQ] = ACTIONS(5408),
    [anon_sym_GT_GT_EQ] = ACTIONS(5408),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5408),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5408),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5408),
    [anon_sym_if] = ACTIONS(5408),
    [anon_sym_SEMI] = ACTIONS(5408),
    [anon_sym_else] = ACTIONS(5408),
    [anon_sym_when] = ACTIONS(5408),
    [anon_sym_in] = ACTIONS(5408),
    [anon_sym_case] = ACTIONS(5408),
    [anon_sym_QMARK] = ACTIONS(5408),
    [anon_sym_PLUS] = ACTIONS(5410),
    [anon_sym_DASH] = ACTIONS(5410),
    [anon_sym_TILDE] = ACTIONS(5410),
    [anon_sym_AMP] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE] = ACTIONS(5410),
    [anon_sym_or_else] = ACTIONS(5408),
    [anon_sym_AMP_AMP] = ACTIONS(5410),
    [anon_sym_GT] = ACTIONS(5410),
    [anon_sym_GT_EQ] = ACTIONS(5408),
    [anon_sym_LT_EQ] = ACTIONS(5408),
    [anon_sym_LT] = ACTIONS(5410),
    [anon_sym_EQ_EQ] = ACTIONS(5408),
    [anon_sym_BANG_EQ] = ACTIONS(5408),
    [anon_sym_TILDE_EQ] = ACTIONS(5408),
    [anon_sym_AMP_TILDE] = ACTIONS(5410),
    [anon_sym_LT_LT] = ACTIONS(5410),
    [anon_sym_GT_GT] = ACTIONS(5410),
    [anon_sym_STAR] = ACTIONS(5410),
    [anon_sym_SLASH] = ACTIONS(5410),
    [anon_sym_PERCENT] = ACTIONS(5410),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5408),
    [anon_sym_DOT] = ACTIONS(5410),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5408),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5408),
    [anon_sym_not_in] = ACTIONS(5408),
    [anon_sym_or_return] = ACTIONS(5408),
    [anon_sym_or_continue] = ACTIONS(5408),
    [anon_sym_or_break] = ACTIONS(5408),
    [anon_sym_CARET] = ACTIONS(5410),
    [sym_uninitialized] = ACTIONS(5408),
    [sym_tag] = ACTIONS(5408),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5408),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [994] = {
    [ts_builtin_sym_end] = ACTIONS(5412),
    [anon_sym_LBRACE] = ACTIONS(5412),
    [anon_sym_RBRACE] = ACTIONS(5412),
    [anon_sym_COMMA] = ACTIONS(5412),
    [anon_sym_COLON_COLON] = ACTIONS(5412),
    [anon_sym_DASH_GT] = ACTIONS(5412),
    [anon_sym_where] = ACTIONS(5412),
    [anon_sym_EQ] = ACTIONS(5414),
    [anon_sym_COLON] = ACTIONS(5414),
    [anon_sym_PIPE] = ACTIONS(5414),
    [anon_sym_COLON_EQ] = ACTIONS(5412),
    [anon_sym_LPAREN] = ACTIONS(5412),
    [anon_sym_PLUS_EQ] = ACTIONS(5412),
    [anon_sym_DASH_EQ] = ACTIONS(5412),
    [anon_sym_STAR_EQ] = ACTIONS(5412),
    [anon_sym_SLASH_EQ] = ACTIONS(5412),
    [anon_sym_PERCENT_EQ] = ACTIONS(5412),
    [anon_sym_AMP_EQ] = ACTIONS(5412),
    [anon_sym_PIPE_EQ] = ACTIONS(5412),
    [anon_sym_CARET_EQ] = ACTIONS(5412),
    [anon_sym_LT_LT_EQ] = ACTIONS(5412),
    [anon_sym_GT_GT_EQ] = ACTIONS(5412),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5412),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5412),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5412),
    [anon_sym_if] = ACTIONS(5412),
    [anon_sym_SEMI] = ACTIONS(5412),
    [anon_sym_else] = ACTIONS(5412),
    [anon_sym_when] = ACTIONS(5412),
    [anon_sym_in] = ACTIONS(5412),
    [anon_sym_case] = ACTIONS(5412),
    [anon_sym_QMARK] = ACTIONS(5412),
    [anon_sym_PLUS] = ACTIONS(5414),
    [anon_sym_DASH] = ACTIONS(5414),
    [anon_sym_TILDE] = ACTIONS(5414),
    [anon_sym_AMP] = ACTIONS(5414),
    [anon_sym_PIPE_PIPE] = ACTIONS(5414),
    [anon_sym_or_else] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5414),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_GT_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5412),
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5412),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_TILDE_EQ] = ACTIONS(5412),
    [anon_sym_AMP_TILDE] = ACTIONS(5414),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_STAR] = ACTIONS(5414),
    [anon_sym_SLASH] = ACTIONS(5414),
    [anon_sym_PERCENT] = ACTIONS(5414),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5412),
    [anon_sym_DOT] = ACTIONS(5414),
    [anon_sym_LBRACK] = ACTIONS(5412),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5412),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5412),
    [anon_sym_not_in] = ACTIONS(5412),
    [anon_sym_or_return] = ACTIONS(5412),
    [anon_sym_or_continue] = ACTIONS(5412),
    [anon_sym_or_break] = ACTIONS(5412),
    [anon_sym_CARET] = ACTIONS(5414),
    [sym_uninitialized] = ACTIONS(5412),
    [sym_tag] = ACTIONS(5412),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5412),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [995] = {
    [ts_builtin_sym_end] = ACTIONS(5416),
    [anon_sym_LBRACE] = ACTIONS(5416),
    [anon_sym_RBRACE] = ACTIONS(5416),
    [anon_sym_COMMA] = ACTIONS(5416),
    [anon_sym_COLON_COLON] = ACTIONS(5416),
    [anon_sym_DASH_GT] = ACTIONS(5416),
    [anon_sym_where] = ACTIONS(5416),
    [anon_sym_EQ] = ACTIONS(5418),
    [anon_sym_COLON] = ACTIONS(5418),
    [anon_sym_PIPE] = ACTIONS(5418),
    [anon_sym_COLON_EQ] = ACTIONS(5416),
    [anon_sym_LPAREN] = ACTIONS(5416),
    [anon_sym_PLUS_EQ] = ACTIONS(5416),
    [anon_sym_DASH_EQ] = ACTIONS(5416),
    [anon_sym_STAR_EQ] = ACTIONS(5416),
    [anon_sym_SLASH_EQ] = ACTIONS(5416),
    [anon_sym_PERCENT_EQ] = ACTIONS(5416),
    [anon_sym_AMP_EQ] = ACTIONS(5416),
    [anon_sym_PIPE_EQ] = ACTIONS(5416),
    [anon_sym_CARET_EQ] = ACTIONS(5416),
    [anon_sym_LT_LT_EQ] = ACTIONS(5416),
    [anon_sym_GT_GT_EQ] = ACTIONS(5416),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5416),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5416),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5416),
    [anon_sym_if] = ACTIONS(5416),
    [anon_sym_SEMI] = ACTIONS(5416),
    [anon_sym_else] = ACTIONS(5416),
    [anon_sym_when] = ACTIONS(5416),
    [anon_sym_in] = ACTIONS(5416),
    [anon_sym_case] = ACTIONS(5416),
    [anon_sym_QMARK] = ACTIONS(5416),
    [anon_sym_PLUS] = ACTIONS(5418),
    [anon_sym_DASH] = ACTIONS(5418),
    [anon_sym_TILDE] = ACTIONS(5418),
    [anon_sym_AMP] = ACTIONS(5418),
    [anon_sym_PIPE_PIPE] = ACTIONS(5418),
    [anon_sym_or_else] = ACTIONS(5416),
    [anon_sym_AMP_AMP] = ACTIONS(5418),
    [anon_sym_GT] = ACTIONS(5418),
    [anon_sym_GT_EQ] = ACTIONS(5416),
    [anon_sym_LT_EQ] = ACTIONS(5416),
    [anon_sym_LT] = ACTIONS(5418),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5416),
    [anon_sym_TILDE_EQ] = ACTIONS(5416),
    [anon_sym_AMP_TILDE] = ACTIONS(5418),
    [anon_sym_LT_LT] = ACTIONS(5418),
    [anon_sym_GT_GT] = ACTIONS(5418),
    [anon_sym_STAR] = ACTIONS(5418),
    [anon_sym_SLASH] = ACTIONS(5418),
    [anon_sym_PERCENT] = ACTIONS(5418),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(5418),
    [anon_sym_LBRACK] = ACTIONS(5416),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5416),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5416),
    [anon_sym_not_in] = ACTIONS(5416),
    [anon_sym_or_return] = ACTIONS(5416),
    [anon_sym_or_continue] = ACTIONS(5416),
    [anon_sym_or_break] = ACTIONS(5416),
    [anon_sym_CARET] = ACTIONS(5418),
    [sym_uninitialized] = ACTIONS(5416),
    [sym_tag] = ACTIONS(5416),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5416),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [996] = {
    [sym_block] = STATE(2175),
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(4251),
    [sym_tag] = ACTIONS(4317),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4083),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [997] = {
    [ts_builtin_sym_end] = ACTIONS(5420),
    [anon_sym_LBRACE] = ACTIONS(5420),
    [anon_sym_RBRACE] = ACTIONS(5420),
    [anon_sym_COMMA] = ACTIONS(5420),
    [anon_sym_COLON_COLON] = ACTIONS(5420),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5420),
    [anon_sym_EQ] = ACTIONS(5422),
    [anon_sym_COLON] = ACTIONS(5422),
    [anon_sym_PIPE] = ACTIONS(4734),
    [anon_sym_COLON_EQ] = ACTIONS(5420),
    [anon_sym_LPAREN] = ACTIONS(5420),
    [anon_sym_PLUS_EQ] = ACTIONS(5420),
    [anon_sym_DASH_EQ] = ACTIONS(5420),
    [anon_sym_STAR_EQ] = ACTIONS(5420),
    [anon_sym_SLASH_EQ] = ACTIONS(5420),
    [anon_sym_PERCENT_EQ] = ACTIONS(5420),
    [anon_sym_AMP_EQ] = ACTIONS(5420),
    [anon_sym_PIPE_EQ] = ACTIONS(5420),
    [anon_sym_CARET_EQ] = ACTIONS(5420),
    [anon_sym_LT_LT_EQ] = ACTIONS(5420),
    [anon_sym_GT_GT_EQ] = ACTIONS(5420),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5420),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5420),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5420),
    [anon_sym_if] = ACTIONS(5420),
    [anon_sym_SEMI] = ACTIONS(5420),
    [anon_sym_else] = ACTIONS(5420),
    [anon_sym_when] = ACTIONS(5420),
    [anon_sym_in] = ACTIONS(5424),
    [anon_sym_case] = ACTIONS(5420),
    [anon_sym_QMARK] = ACTIONS(5420),
    [anon_sym_PLUS] = ACTIONS(4736),
    [anon_sym_DASH] = ACTIONS(4736),
    [anon_sym_TILDE] = ACTIONS(4738),
    [anon_sym_AMP] = ACTIONS(4740),
    [anon_sym_PIPE_PIPE] = ACTIONS(4742),
    [anon_sym_or_else] = ACTIONS(4744),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_GT] = ACTIONS(4748),
    [anon_sym_GT_EQ] = ACTIONS(4750),
    [anon_sym_LT_EQ] = ACTIONS(4750),
    [anon_sym_LT] = ACTIONS(4748),
    [anon_sym_EQ_EQ] = ACTIONS(4752),
    [anon_sym_BANG_EQ] = ACTIONS(4752),
    [anon_sym_TILDE_EQ] = ACTIONS(4752),
    [anon_sym_AMP_TILDE] = ACTIONS(4754),
    [anon_sym_LT_LT] = ACTIONS(4756),
    [anon_sym_GT_GT] = ACTIONS(4756),
    [anon_sym_STAR] = ACTIONS(4758),
    [anon_sym_SLASH] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4760),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5424),
    [anon_sym_or_return] = ACTIONS(4768),
    [anon_sym_or_continue] = ACTIONS(4770),
    [anon_sym_or_break] = ACTIONS(4772),
    [anon_sym_CARET] = ACTIONS(4774),
    [sym_uninitialized] = ACTIONS(5420),
    [sym_tag] = ACTIONS(5420),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5420),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [998] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5406),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [999] = {
    [ts_builtin_sym_end] = ACTIONS(815),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_COLON_COLON] = ACTIONS(815),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_where] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_COLON] = ACTIONS(818),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_COLON_EQ] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(815),
    [anon_sym_PLUS_EQ] = ACTIONS(815),
    [anon_sym_DASH_EQ] = ACTIONS(815),
    [anon_sym_STAR_EQ] = ACTIONS(815),
    [anon_sym_SLASH_EQ] = ACTIONS(815),
    [anon_sym_PERCENT_EQ] = ACTIONS(815),
    [anon_sym_AMP_EQ] = ACTIONS(815),
    [anon_sym_PIPE_EQ] = ACTIONS(815),
    [anon_sym_CARET_EQ] = ACTIONS(815),
    [anon_sym_LT_LT_EQ] = ACTIONS(815),
    [anon_sym_GT_GT_EQ] = ACTIONS(815),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(815),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_else] = ACTIONS(815),
    [anon_sym_when] = ACTIONS(815),
    [anon_sym_in] = ACTIONS(815),
    [anon_sym_case] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(818),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(818),
    [anon_sym_or_else] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(818),
    [anon_sym_LT_LT] = ACTIONS(818),
    [anon_sym_GT_GT] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(818),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(815),
    [anon_sym_or_return] = ACTIONS(815),
    [anon_sym_or_continue] = ACTIONS(815),
    [anon_sym_or_break] = ACTIONS(815),
    [anon_sym_CARET] = ACTIONS(818),
    [sym_uninitialized] = ACTIONS(815),
    [sym_tag] = ACTIONS(815),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1000] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5426),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1001] = {
    [ts_builtin_sym_end] = ACTIONS(5428),
    [anon_sym_LBRACE] = ACTIONS(5428),
    [anon_sym_RBRACE] = ACTIONS(5428),
    [anon_sym_COMMA] = ACTIONS(5428),
    [anon_sym_COLON_COLON] = ACTIONS(5428),
    [anon_sym_DASH_GT] = ACTIONS(5428),
    [anon_sym_where] = ACTIONS(5428),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_COLON] = ACTIONS(5430),
    [anon_sym_PIPE] = ACTIONS(5430),
    [anon_sym_COLON_EQ] = ACTIONS(5428),
    [anon_sym_LPAREN] = ACTIONS(5428),
    [anon_sym_PLUS_EQ] = ACTIONS(5428),
    [anon_sym_DASH_EQ] = ACTIONS(5428),
    [anon_sym_STAR_EQ] = ACTIONS(5428),
    [anon_sym_SLASH_EQ] = ACTIONS(5428),
    [anon_sym_PERCENT_EQ] = ACTIONS(5428),
    [anon_sym_AMP_EQ] = ACTIONS(5428),
    [anon_sym_PIPE_EQ] = ACTIONS(5428),
    [anon_sym_CARET_EQ] = ACTIONS(5428),
    [anon_sym_LT_LT_EQ] = ACTIONS(5428),
    [anon_sym_GT_GT_EQ] = ACTIONS(5428),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5428),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5428),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5428),
    [anon_sym_if] = ACTIONS(5428),
    [anon_sym_SEMI] = ACTIONS(5428),
    [anon_sym_else] = ACTIONS(5428),
    [anon_sym_when] = ACTIONS(5428),
    [anon_sym_in] = ACTIONS(5428),
    [anon_sym_case] = ACTIONS(5428),
    [anon_sym_QMARK] = ACTIONS(5428),
    [anon_sym_PLUS] = ACTIONS(5430),
    [anon_sym_DASH] = ACTIONS(5430),
    [anon_sym_TILDE] = ACTIONS(5430),
    [anon_sym_AMP] = ACTIONS(5430),
    [anon_sym_PIPE_PIPE] = ACTIONS(5430),
    [anon_sym_or_else] = ACTIONS(5428),
    [anon_sym_AMP_AMP] = ACTIONS(5430),
    [anon_sym_GT] = ACTIONS(5430),
    [anon_sym_GT_EQ] = ACTIONS(5428),
    [anon_sym_LT_EQ] = ACTIONS(5428),
    [anon_sym_LT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(5428),
    [anon_sym_BANG_EQ] = ACTIONS(5428),
    [anon_sym_TILDE_EQ] = ACTIONS(5428),
    [anon_sym_AMP_TILDE] = ACTIONS(5430),
    [anon_sym_LT_LT] = ACTIONS(5430),
    [anon_sym_GT_GT] = ACTIONS(5430),
    [anon_sym_STAR] = ACTIONS(5430),
    [anon_sym_SLASH] = ACTIONS(5430),
    [anon_sym_PERCENT] = ACTIONS(5430),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5428),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_LBRACK] = ACTIONS(5428),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5428),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5428),
    [anon_sym_not_in] = ACTIONS(5428),
    [anon_sym_or_return] = ACTIONS(5428),
    [anon_sym_or_continue] = ACTIONS(5428),
    [anon_sym_or_break] = ACTIONS(5428),
    [anon_sym_CARET] = ACTIONS(5430),
    [sym_uninitialized] = ACTIONS(5428),
    [sym_tag] = ACTIONS(5428),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5428),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1002] = {
    [sym_expression] = STATE(6183),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8920),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1003] = {
    [ts_builtin_sym_end] = ACTIONS(5432),
    [anon_sym_LBRACE] = ACTIONS(5432),
    [anon_sym_RBRACE] = ACTIONS(5432),
    [anon_sym_COMMA] = ACTIONS(5432),
    [anon_sym_COLON_COLON] = ACTIONS(5432),
    [anon_sym_DASH_GT] = ACTIONS(5432),
    [anon_sym_where] = ACTIONS(5432),
    [anon_sym_EQ] = ACTIONS(5434),
    [anon_sym_COLON] = ACTIONS(5434),
    [anon_sym_PIPE] = ACTIONS(5434),
    [anon_sym_COLON_EQ] = ACTIONS(5432),
    [anon_sym_LPAREN] = ACTIONS(5432),
    [anon_sym_PLUS_EQ] = ACTIONS(5432),
    [anon_sym_DASH_EQ] = ACTIONS(5432),
    [anon_sym_STAR_EQ] = ACTIONS(5432),
    [anon_sym_SLASH_EQ] = ACTIONS(5432),
    [anon_sym_PERCENT_EQ] = ACTIONS(5432),
    [anon_sym_AMP_EQ] = ACTIONS(5432),
    [anon_sym_PIPE_EQ] = ACTIONS(5432),
    [anon_sym_CARET_EQ] = ACTIONS(5432),
    [anon_sym_LT_LT_EQ] = ACTIONS(5432),
    [anon_sym_GT_GT_EQ] = ACTIONS(5432),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5432),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5432),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5432),
    [anon_sym_if] = ACTIONS(5432),
    [anon_sym_SEMI] = ACTIONS(5432),
    [anon_sym_else] = ACTIONS(5432),
    [anon_sym_when] = ACTIONS(5432),
    [anon_sym_in] = ACTIONS(5432),
    [anon_sym_case] = ACTIONS(5432),
    [anon_sym_QMARK] = ACTIONS(5432),
    [anon_sym_PLUS] = ACTIONS(5434),
    [anon_sym_DASH] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [anon_sym_AMP] = ACTIONS(5434),
    [anon_sym_PIPE_PIPE] = ACTIONS(5434),
    [anon_sym_or_else] = ACTIONS(5432),
    [anon_sym_AMP_AMP] = ACTIONS(5434),
    [anon_sym_GT] = ACTIONS(5434),
    [anon_sym_GT_EQ] = ACTIONS(5432),
    [anon_sym_LT_EQ] = ACTIONS(5432),
    [anon_sym_LT] = ACTIONS(5434),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_BANG_EQ] = ACTIONS(5432),
    [anon_sym_TILDE_EQ] = ACTIONS(5432),
    [anon_sym_AMP_TILDE] = ACTIONS(5434),
    [anon_sym_LT_LT] = ACTIONS(5434),
    [anon_sym_GT_GT] = ACTIONS(5434),
    [anon_sym_STAR] = ACTIONS(5434),
    [anon_sym_SLASH] = ACTIONS(5434),
    [anon_sym_PERCENT] = ACTIONS(5434),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5432),
    [anon_sym_DOT] = ACTIONS(5434),
    [anon_sym_LBRACK] = ACTIONS(5432),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5432),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5432),
    [anon_sym_not_in] = ACTIONS(5432),
    [anon_sym_or_return] = ACTIONS(5432),
    [anon_sym_or_continue] = ACTIONS(5432),
    [anon_sym_or_break] = ACTIONS(5432),
    [anon_sym_CARET] = ACTIONS(5434),
    [sym_uninitialized] = ACTIONS(5432),
    [sym_tag] = ACTIONS(5432),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5432),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1004] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5362),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1005] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8217),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5426),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1006] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(4820),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1007] = {
    [ts_builtin_sym_end] = ACTIONS(5436),
    [anon_sym_LBRACE] = ACTIONS(5436),
    [anon_sym_RBRACE] = ACTIONS(5436),
    [anon_sym_COMMA] = ACTIONS(5436),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_DASH_GT] = ACTIONS(5436),
    [anon_sym_where] = ACTIONS(5436),
    [anon_sym_EQ] = ACTIONS(5438),
    [anon_sym_COLON] = ACTIONS(5438),
    [anon_sym_PIPE] = ACTIONS(5438),
    [anon_sym_COLON_EQ] = ACTIONS(5436),
    [anon_sym_LPAREN] = ACTIONS(5436),
    [anon_sym_PLUS_EQ] = ACTIONS(5436),
    [anon_sym_DASH_EQ] = ACTIONS(5436),
    [anon_sym_STAR_EQ] = ACTIONS(5436),
    [anon_sym_SLASH_EQ] = ACTIONS(5436),
    [anon_sym_PERCENT_EQ] = ACTIONS(5436),
    [anon_sym_AMP_EQ] = ACTIONS(5436),
    [anon_sym_PIPE_EQ] = ACTIONS(5436),
    [anon_sym_CARET_EQ] = ACTIONS(5436),
    [anon_sym_LT_LT_EQ] = ACTIONS(5436),
    [anon_sym_GT_GT_EQ] = ACTIONS(5436),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5436),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5436),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5436),
    [anon_sym_if] = ACTIONS(5436),
    [anon_sym_SEMI] = ACTIONS(5436),
    [anon_sym_else] = ACTIONS(5436),
    [anon_sym_when] = ACTIONS(5436),
    [anon_sym_in] = ACTIONS(5436),
    [anon_sym_case] = ACTIONS(5436),
    [anon_sym_QMARK] = ACTIONS(5436),
    [anon_sym_PLUS] = ACTIONS(5438),
    [anon_sym_DASH] = ACTIONS(5438),
    [anon_sym_TILDE] = ACTIONS(5438),
    [anon_sym_AMP] = ACTIONS(5438),
    [anon_sym_PIPE_PIPE] = ACTIONS(5438),
    [anon_sym_or_else] = ACTIONS(5436),
    [anon_sym_AMP_AMP] = ACTIONS(5438),
    [anon_sym_GT] = ACTIONS(5438),
    [anon_sym_GT_EQ] = ACTIONS(5436),
    [anon_sym_LT_EQ] = ACTIONS(5436),
    [anon_sym_LT] = ACTIONS(5438),
    [anon_sym_EQ_EQ] = ACTIONS(5436),
    [anon_sym_BANG_EQ] = ACTIONS(5436),
    [anon_sym_TILDE_EQ] = ACTIONS(5436),
    [anon_sym_AMP_TILDE] = ACTIONS(5438),
    [anon_sym_LT_LT] = ACTIONS(5438),
    [anon_sym_GT_GT] = ACTIONS(5438),
    [anon_sym_STAR] = ACTIONS(5438),
    [anon_sym_SLASH] = ACTIONS(5438),
    [anon_sym_PERCENT] = ACTIONS(5438),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5436),
    [anon_sym_DOT] = ACTIONS(5438),
    [anon_sym_LBRACK] = ACTIONS(5436),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5436),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5436),
    [anon_sym_not_in] = ACTIONS(5436),
    [anon_sym_or_return] = ACTIONS(5436),
    [anon_sym_or_continue] = ACTIONS(5436),
    [anon_sym_or_break] = ACTIONS(5436),
    [anon_sym_CARET] = ACTIONS(5438),
    [sym_uninitialized] = ACTIONS(5436),
    [sym_tag] = ACTIONS(5436),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5436),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1008] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8179),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5440),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1009] = {
    [sym_expression] = STATE(6075),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9054),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1010] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5440),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1011] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5442),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1012] = {
    [ts_builtin_sym_end] = ACTIONS(5444),
    [anon_sym_LBRACE] = ACTIONS(5444),
    [anon_sym_RBRACE] = ACTIONS(5444),
    [anon_sym_COMMA] = ACTIONS(5444),
    [anon_sym_COLON_COLON] = ACTIONS(5444),
    [anon_sym_DASH_GT] = ACTIONS(5444),
    [anon_sym_where] = ACTIONS(5444),
    [anon_sym_EQ] = ACTIONS(5446),
    [anon_sym_COLON] = ACTIONS(5446),
    [anon_sym_PIPE] = ACTIONS(5446),
    [anon_sym_COLON_EQ] = ACTIONS(5444),
    [anon_sym_LPAREN] = ACTIONS(5444),
    [anon_sym_PLUS_EQ] = ACTIONS(5444),
    [anon_sym_DASH_EQ] = ACTIONS(5444),
    [anon_sym_STAR_EQ] = ACTIONS(5444),
    [anon_sym_SLASH_EQ] = ACTIONS(5444),
    [anon_sym_PERCENT_EQ] = ACTIONS(5444),
    [anon_sym_AMP_EQ] = ACTIONS(5444),
    [anon_sym_PIPE_EQ] = ACTIONS(5444),
    [anon_sym_CARET_EQ] = ACTIONS(5444),
    [anon_sym_LT_LT_EQ] = ACTIONS(5444),
    [anon_sym_GT_GT_EQ] = ACTIONS(5444),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5444),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5444),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5444),
    [anon_sym_if] = ACTIONS(5444),
    [anon_sym_SEMI] = ACTIONS(5444),
    [anon_sym_else] = ACTIONS(5444),
    [anon_sym_when] = ACTIONS(5444),
    [anon_sym_in] = ACTIONS(5444),
    [anon_sym_case] = ACTIONS(5444),
    [anon_sym_QMARK] = ACTIONS(5444),
    [anon_sym_PLUS] = ACTIONS(5446),
    [anon_sym_DASH] = ACTIONS(5446),
    [anon_sym_TILDE] = ACTIONS(5446),
    [anon_sym_AMP] = ACTIONS(5446),
    [anon_sym_PIPE_PIPE] = ACTIONS(5446),
    [anon_sym_or_else] = ACTIONS(5444),
    [anon_sym_AMP_AMP] = ACTIONS(5446),
    [anon_sym_GT] = ACTIONS(5446),
    [anon_sym_GT_EQ] = ACTIONS(5444),
    [anon_sym_LT_EQ] = ACTIONS(5444),
    [anon_sym_LT] = ACTIONS(5446),
    [anon_sym_EQ_EQ] = ACTIONS(5444),
    [anon_sym_BANG_EQ] = ACTIONS(5444),
    [anon_sym_TILDE_EQ] = ACTIONS(5444),
    [anon_sym_AMP_TILDE] = ACTIONS(5446),
    [anon_sym_LT_LT] = ACTIONS(5446),
    [anon_sym_GT_GT] = ACTIONS(5446),
    [anon_sym_STAR] = ACTIONS(5446),
    [anon_sym_SLASH] = ACTIONS(5446),
    [anon_sym_PERCENT] = ACTIONS(5446),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5444),
    [anon_sym_DOT] = ACTIONS(5446),
    [anon_sym_LBRACK] = ACTIONS(5444),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5444),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5444),
    [anon_sym_not_in] = ACTIONS(5444),
    [anon_sym_or_return] = ACTIONS(5444),
    [anon_sym_or_continue] = ACTIONS(5444),
    [anon_sym_or_break] = ACTIONS(5444),
    [anon_sym_CARET] = ACTIONS(5446),
    [sym_uninitialized] = ACTIONS(5444),
    [sym_tag] = ACTIONS(5444),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5444),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1013] = {
    [ts_builtin_sym_end] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(5448),
    [anon_sym_RBRACE] = ACTIONS(5448),
    [anon_sym_COMMA] = ACTIONS(5448),
    [anon_sym_COLON_COLON] = ACTIONS(5448),
    [anon_sym_DASH_GT] = ACTIONS(5448),
    [anon_sym_where] = ACTIONS(5448),
    [anon_sym_EQ] = ACTIONS(5450),
    [anon_sym_COLON] = ACTIONS(5450),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_COLON_EQ] = ACTIONS(5448),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(5448),
    [anon_sym_DASH_EQ] = ACTIONS(5448),
    [anon_sym_STAR_EQ] = ACTIONS(5448),
    [anon_sym_SLASH_EQ] = ACTIONS(5448),
    [anon_sym_PERCENT_EQ] = ACTIONS(5448),
    [anon_sym_AMP_EQ] = ACTIONS(5448),
    [anon_sym_PIPE_EQ] = ACTIONS(5448),
    [anon_sym_CARET_EQ] = ACTIONS(5448),
    [anon_sym_LT_LT_EQ] = ACTIONS(5448),
    [anon_sym_GT_GT_EQ] = ACTIONS(5448),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5448),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5448),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5448),
    [anon_sym_if] = ACTIONS(5448),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym_else] = ACTIONS(5448),
    [anon_sym_when] = ACTIONS(5448),
    [anon_sym_in] = ACTIONS(5448),
    [anon_sym_case] = ACTIONS(5448),
    [anon_sym_QMARK] = ACTIONS(5448),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_TILDE] = ACTIONS(5450),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_PIPE_PIPE] = ACTIONS(5450),
    [anon_sym_or_else] = ACTIONS(5448),
    [anon_sym_AMP_AMP] = ACTIONS(5450),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_GT_EQ] = ACTIONS(5448),
    [anon_sym_LT_EQ] = ACTIONS(5448),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_EQ_EQ] = ACTIONS(5448),
    [anon_sym_BANG_EQ] = ACTIONS(5448),
    [anon_sym_TILDE_EQ] = ACTIONS(5448),
    [anon_sym_AMP_TILDE] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5450),
    [anon_sym_GT_GT] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5450),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(5450),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5448),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_LBRACK] = ACTIONS(5448),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5448),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5448),
    [anon_sym_not_in] = ACTIONS(5448),
    [anon_sym_or_return] = ACTIONS(5448),
    [anon_sym_or_continue] = ACTIONS(5448),
    [anon_sym_or_break] = ACTIONS(5448),
    [anon_sym_CARET] = ACTIONS(5450),
    [sym_uninitialized] = ACTIONS(5448),
    [sym_tag] = ACTIONS(5448),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5448),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1014] = {
    [ts_builtin_sym_end] = ACTIONS(5452),
    [anon_sym_LBRACE] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [anon_sym_where] = ACTIONS(5452),
    [anon_sym_EQ] = ACTIONS(5454),
    [anon_sym_COLON] = ACTIONS(5454),
    [anon_sym_PIPE] = ACTIONS(5454),
    [anon_sym_COLON_EQ] = ACTIONS(5452),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_PLUS_EQ] = ACTIONS(5452),
    [anon_sym_DASH_EQ] = ACTIONS(5452),
    [anon_sym_STAR_EQ] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5452),
    [anon_sym_PERCENT_EQ] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5452),
    [anon_sym_PIPE_EQ] = ACTIONS(5452),
    [anon_sym_CARET_EQ] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5452),
    [anon_sym_GT_GT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5452),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym_else] = ACTIONS(5452),
    [anon_sym_when] = ACTIONS(5452),
    [anon_sym_in] = ACTIONS(5452),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_DASH] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_PIPE_PIPE] = ACTIONS(5454),
    [anon_sym_or_else] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5454),
    [anon_sym_GT] = ACTIONS(5454),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_TILDE_EQ] = ACTIONS(5452),
    [anon_sym_AMP_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5454),
    [anon_sym_STAR] = ACTIONS(5454),
    [anon_sym_SLASH] = ACTIONS(5454),
    [anon_sym_PERCENT] = ACTIONS(5454),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5452),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5452),
    [anon_sym_not_in] = ACTIONS(5452),
    [anon_sym_or_return] = ACTIONS(5452),
    [anon_sym_or_continue] = ACTIONS(5452),
    [anon_sym_or_break] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5454),
    [sym_uninitialized] = ACTIONS(5452),
    [sym_tag] = ACTIONS(5452),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5452),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1015] = {
    [ts_builtin_sym_end] = ACTIONS(5456),
    [anon_sym_LBRACE] = ACTIONS(5456),
    [anon_sym_RBRACE] = ACTIONS(5456),
    [anon_sym_COMMA] = ACTIONS(5456),
    [anon_sym_COLON_COLON] = ACTIONS(5456),
    [anon_sym_DASH_GT] = ACTIONS(5456),
    [anon_sym_where] = ACTIONS(5456),
    [anon_sym_EQ] = ACTIONS(5458),
    [anon_sym_COLON] = ACTIONS(5458),
    [anon_sym_PIPE] = ACTIONS(5458),
    [anon_sym_COLON_EQ] = ACTIONS(5456),
    [anon_sym_LPAREN] = ACTIONS(5456),
    [anon_sym_PLUS_EQ] = ACTIONS(5456),
    [anon_sym_DASH_EQ] = ACTIONS(5456),
    [anon_sym_STAR_EQ] = ACTIONS(5456),
    [anon_sym_SLASH_EQ] = ACTIONS(5456),
    [anon_sym_PERCENT_EQ] = ACTIONS(5456),
    [anon_sym_AMP_EQ] = ACTIONS(5456),
    [anon_sym_PIPE_EQ] = ACTIONS(5456),
    [anon_sym_CARET_EQ] = ACTIONS(5456),
    [anon_sym_LT_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT_GT_EQ] = ACTIONS(5456),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5456),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5456),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5456),
    [anon_sym_if] = ACTIONS(5456),
    [anon_sym_SEMI] = ACTIONS(5456),
    [anon_sym_else] = ACTIONS(5456),
    [anon_sym_when] = ACTIONS(5456),
    [anon_sym_in] = ACTIONS(5456),
    [anon_sym_case] = ACTIONS(5456),
    [anon_sym_QMARK] = ACTIONS(5456),
    [anon_sym_PLUS] = ACTIONS(5458),
    [anon_sym_DASH] = ACTIONS(5458),
    [anon_sym_TILDE] = ACTIONS(5458),
    [anon_sym_AMP] = ACTIONS(5458),
    [anon_sym_PIPE_PIPE] = ACTIONS(5458),
    [anon_sym_or_else] = ACTIONS(5456),
    [anon_sym_AMP_AMP] = ACTIONS(5458),
    [anon_sym_GT] = ACTIONS(5458),
    [anon_sym_GT_EQ] = ACTIONS(5456),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_LT] = ACTIONS(5458),
    [anon_sym_EQ_EQ] = ACTIONS(5456),
    [anon_sym_BANG_EQ] = ACTIONS(5456),
    [anon_sym_TILDE_EQ] = ACTIONS(5456),
    [anon_sym_AMP_TILDE] = ACTIONS(5458),
    [anon_sym_LT_LT] = ACTIONS(5458),
    [anon_sym_GT_GT] = ACTIONS(5458),
    [anon_sym_STAR] = ACTIONS(5458),
    [anon_sym_SLASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5456),
    [anon_sym_DOT] = ACTIONS(5458),
    [anon_sym_LBRACK] = ACTIONS(5456),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5456),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5456),
    [anon_sym_not_in] = ACTIONS(5456),
    [anon_sym_or_return] = ACTIONS(5456),
    [anon_sym_or_continue] = ACTIONS(5456),
    [anon_sym_or_break] = ACTIONS(5456),
    [anon_sym_CARET] = ACTIONS(5458),
    [sym_uninitialized] = ACTIONS(5456),
    [sym_tag] = ACTIONS(5456),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5456),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1016] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5460),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1017] = {
    [sym_block] = STATE(2172),
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(4373),
    [sym_tag] = ACTIONS(4451),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4023),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1018] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8131),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5462),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1019] = {
    [ts_builtin_sym_end] = ACTIONS(5464),
    [anon_sym_LBRACE] = ACTIONS(5464),
    [anon_sym_RBRACE] = ACTIONS(5464),
    [anon_sym_COMMA] = ACTIONS(5464),
    [anon_sym_COLON_COLON] = ACTIONS(5464),
    [anon_sym_DASH_GT] = ACTIONS(5464),
    [anon_sym_where] = ACTIONS(5464),
    [anon_sym_EQ] = ACTIONS(5466),
    [anon_sym_COLON] = ACTIONS(5466),
    [anon_sym_PIPE] = ACTIONS(5466),
    [anon_sym_COLON_EQ] = ACTIONS(5464),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(5464),
    [anon_sym_DASH_EQ] = ACTIONS(5464),
    [anon_sym_STAR_EQ] = ACTIONS(5464),
    [anon_sym_SLASH_EQ] = ACTIONS(5464),
    [anon_sym_PERCENT_EQ] = ACTIONS(5464),
    [anon_sym_AMP_EQ] = ACTIONS(5464),
    [anon_sym_PIPE_EQ] = ACTIONS(5464),
    [anon_sym_CARET_EQ] = ACTIONS(5464),
    [anon_sym_LT_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT_GT_EQ] = ACTIONS(5464),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5464),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5464),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5464),
    [anon_sym_if] = ACTIONS(5464),
    [anon_sym_SEMI] = ACTIONS(5464),
    [anon_sym_else] = ACTIONS(5464),
    [anon_sym_when] = ACTIONS(5464),
    [anon_sym_in] = ACTIONS(5464),
    [anon_sym_case] = ACTIONS(5464),
    [anon_sym_QMARK] = ACTIONS(5464),
    [anon_sym_PLUS] = ACTIONS(5466),
    [anon_sym_DASH] = ACTIONS(5466),
    [anon_sym_TILDE] = ACTIONS(5466),
    [anon_sym_AMP] = ACTIONS(5466),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_or_else] = ACTIONS(5464),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_GT] = ACTIONS(5466),
    [anon_sym_GT_EQ] = ACTIONS(5464),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_LT] = ACTIONS(5466),
    [anon_sym_EQ_EQ] = ACTIONS(5464),
    [anon_sym_BANG_EQ] = ACTIONS(5464),
    [anon_sym_TILDE_EQ] = ACTIONS(5464),
    [anon_sym_AMP_TILDE] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5466),
    [anon_sym_GT_GT] = ACTIONS(5466),
    [anon_sym_STAR] = ACTIONS(5466),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(5466),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5464),
    [anon_sym_DOT] = ACTIONS(5466),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5464),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5464),
    [anon_sym_not_in] = ACTIONS(5464),
    [anon_sym_or_return] = ACTIONS(5464),
    [anon_sym_or_continue] = ACTIONS(5464),
    [anon_sym_or_break] = ACTIONS(5464),
    [anon_sym_CARET] = ACTIONS(5466),
    [sym_uninitialized] = ACTIONS(5464),
    [sym_tag] = ACTIONS(5464),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5464),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1020] = {
    [ts_builtin_sym_end] = ACTIONS(5468),
    [anon_sym_LBRACE] = ACTIONS(5468),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [anon_sym_COMMA] = ACTIONS(5468),
    [anon_sym_COLON_COLON] = ACTIONS(5468),
    [anon_sym_DASH_GT] = ACTIONS(5468),
    [anon_sym_where] = ACTIONS(5468),
    [anon_sym_EQ] = ACTIONS(5470),
    [anon_sym_COLON] = ACTIONS(5470),
    [anon_sym_PIPE] = ACTIONS(5470),
    [anon_sym_COLON_EQ] = ACTIONS(5468),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(5468),
    [anon_sym_DASH_EQ] = ACTIONS(5468),
    [anon_sym_STAR_EQ] = ACTIONS(5468),
    [anon_sym_SLASH_EQ] = ACTIONS(5468),
    [anon_sym_PERCENT_EQ] = ACTIONS(5468),
    [anon_sym_AMP_EQ] = ACTIONS(5468),
    [anon_sym_PIPE_EQ] = ACTIONS(5468),
    [anon_sym_CARET_EQ] = ACTIONS(5468),
    [anon_sym_LT_LT_EQ] = ACTIONS(5468),
    [anon_sym_GT_GT_EQ] = ACTIONS(5468),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5468),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5468),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5468),
    [anon_sym_if] = ACTIONS(5468),
    [anon_sym_SEMI] = ACTIONS(5468),
    [anon_sym_else] = ACTIONS(5468),
    [anon_sym_when] = ACTIONS(5468),
    [anon_sym_in] = ACTIONS(5468),
    [anon_sym_case] = ACTIONS(5468),
    [anon_sym_QMARK] = ACTIONS(5468),
    [anon_sym_PLUS] = ACTIONS(5470),
    [anon_sym_DASH] = ACTIONS(5470),
    [anon_sym_TILDE] = ACTIONS(5470),
    [anon_sym_AMP] = ACTIONS(5470),
    [anon_sym_PIPE_PIPE] = ACTIONS(5470),
    [anon_sym_or_else] = ACTIONS(5468),
    [anon_sym_AMP_AMP] = ACTIONS(5470),
    [anon_sym_GT] = ACTIONS(5470),
    [anon_sym_GT_EQ] = ACTIONS(5468),
    [anon_sym_LT_EQ] = ACTIONS(5468),
    [anon_sym_LT] = ACTIONS(5470),
    [anon_sym_EQ_EQ] = ACTIONS(5468),
    [anon_sym_BANG_EQ] = ACTIONS(5468),
    [anon_sym_TILDE_EQ] = ACTIONS(5468),
    [anon_sym_AMP_TILDE] = ACTIONS(5470),
    [anon_sym_LT_LT] = ACTIONS(5470),
    [anon_sym_GT_GT] = ACTIONS(5470),
    [anon_sym_STAR] = ACTIONS(5470),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(5470),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5468),
    [anon_sym_DOT] = ACTIONS(5470),
    [anon_sym_LBRACK] = ACTIONS(5468),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5468),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5468),
    [anon_sym_not_in] = ACTIONS(5468),
    [anon_sym_or_return] = ACTIONS(5468),
    [anon_sym_or_continue] = ACTIONS(5468),
    [anon_sym_or_break] = ACTIONS(5468),
    [anon_sym_CARET] = ACTIONS(5470),
    [sym_uninitialized] = ACTIONS(5468),
    [sym_tag] = ACTIONS(5468),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5468),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1021] = {
    [ts_builtin_sym_end] = ACTIONS(5472),
    [anon_sym_LBRACE] = ACTIONS(5472),
    [anon_sym_RBRACE] = ACTIONS(5472),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_COLON_COLON] = ACTIONS(5472),
    [anon_sym_DASH_GT] = ACTIONS(5472),
    [anon_sym_where] = ACTIONS(5472),
    [anon_sym_EQ] = ACTIONS(5474),
    [anon_sym_COLON] = ACTIONS(5474),
    [anon_sym_PIPE] = ACTIONS(5474),
    [anon_sym_COLON_EQ] = ACTIONS(5472),
    [anon_sym_LPAREN] = ACTIONS(5472),
    [anon_sym_PLUS_EQ] = ACTIONS(5472),
    [anon_sym_DASH_EQ] = ACTIONS(5472),
    [anon_sym_STAR_EQ] = ACTIONS(5472),
    [anon_sym_SLASH_EQ] = ACTIONS(5472),
    [anon_sym_PERCENT_EQ] = ACTIONS(5472),
    [anon_sym_AMP_EQ] = ACTIONS(5472),
    [anon_sym_PIPE_EQ] = ACTIONS(5472),
    [anon_sym_CARET_EQ] = ACTIONS(5472),
    [anon_sym_LT_LT_EQ] = ACTIONS(5472),
    [anon_sym_GT_GT_EQ] = ACTIONS(5472),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5472),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5472),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5472),
    [anon_sym_if] = ACTIONS(5472),
    [anon_sym_SEMI] = ACTIONS(5472),
    [anon_sym_else] = ACTIONS(5472),
    [anon_sym_when] = ACTIONS(5472),
    [anon_sym_in] = ACTIONS(5472),
    [anon_sym_case] = ACTIONS(5472),
    [anon_sym_QMARK] = ACTIONS(5472),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_DASH] = ACTIONS(5474),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_AMP] = ACTIONS(5474),
    [anon_sym_PIPE_PIPE] = ACTIONS(5474),
    [anon_sym_or_else] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5474),
    [anon_sym_GT] = ACTIONS(5474),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5472),
    [anon_sym_LT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5472),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_TILDE_EQ] = ACTIONS(5472),
    [anon_sym_AMP_TILDE] = ACTIONS(5474),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_STAR] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5474),
    [anon_sym_PERCENT] = ACTIONS(5474),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5472),
    [anon_sym_DOT] = ACTIONS(5474),
    [anon_sym_LBRACK] = ACTIONS(5472),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5472),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5472),
    [anon_sym_not_in] = ACTIONS(5472),
    [anon_sym_or_return] = ACTIONS(5472),
    [anon_sym_or_continue] = ACTIONS(5472),
    [anon_sym_or_break] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5474),
    [sym_uninitialized] = ACTIONS(5472),
    [sym_tag] = ACTIONS(5472),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5472),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1022] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8099),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5476),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1023] = {
    [ts_builtin_sym_end] = ACTIONS(5358),
    [anon_sym_LBRACE] = ACTIONS(5358),
    [anon_sym_RBRACE] = ACTIONS(5358),
    [anon_sym_COMMA] = ACTIONS(5358),
    [anon_sym_COLON_COLON] = ACTIONS(5358),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5358),
    [anon_sym_EQ] = ACTIONS(5360),
    [anon_sym_COLON] = ACTIONS(5360),
    [anon_sym_PIPE] = ACTIONS(5360),
    [anon_sym_COLON_EQ] = ACTIONS(5358),
    [anon_sym_LPAREN] = ACTIONS(5358),
    [anon_sym_PLUS_EQ] = ACTIONS(5358),
    [anon_sym_DASH_EQ] = ACTIONS(5358),
    [anon_sym_STAR_EQ] = ACTIONS(5358),
    [anon_sym_SLASH_EQ] = ACTIONS(5358),
    [anon_sym_PERCENT_EQ] = ACTIONS(5358),
    [anon_sym_AMP_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_CARET_EQ] = ACTIONS(5358),
    [anon_sym_LT_LT_EQ] = ACTIONS(5358),
    [anon_sym_GT_GT_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_if] = ACTIONS(5358),
    [anon_sym_SEMI] = ACTIONS(5358),
    [anon_sym_else] = ACTIONS(5358),
    [anon_sym_when] = ACTIONS(5358),
    [anon_sym_in] = ACTIONS(5358),
    [anon_sym_case] = ACTIONS(5358),
    [anon_sym_QMARK] = ACTIONS(5358),
    [anon_sym_PLUS] = ACTIONS(5360),
    [anon_sym_DASH] = ACTIONS(5360),
    [anon_sym_TILDE] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(5360),
    [anon_sym_PIPE_PIPE] = ACTIONS(5360),
    [anon_sym_or_else] = ACTIONS(5358),
    [anon_sym_AMP_AMP] = ACTIONS(5360),
    [anon_sym_GT] = ACTIONS(5360),
    [anon_sym_GT_EQ] = ACTIONS(5358),
    [anon_sym_LT_EQ] = ACTIONS(5358),
    [anon_sym_LT] = ACTIONS(5360),
    [anon_sym_EQ_EQ] = ACTIONS(5358),
    [anon_sym_BANG_EQ] = ACTIONS(5358),
    [anon_sym_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE] = ACTIONS(5360),
    [anon_sym_LT_LT] = ACTIONS(5360),
    [anon_sym_GT_GT] = ACTIONS(5360),
    [anon_sym_STAR] = ACTIONS(4758),
    [anon_sym_SLASH] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4760),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5358),
    [anon_sym_or_return] = ACTIONS(5358),
    [anon_sym_or_continue] = ACTIONS(5358),
    [anon_sym_or_break] = ACTIONS(5358),
    [anon_sym_CARET] = ACTIONS(5360),
    [sym_uninitialized] = ACTIONS(5358),
    [sym_tag] = ACTIONS(5358),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5358),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1024] = {
    [ts_builtin_sym_end] = ACTIONS(5358),
    [anon_sym_LBRACE] = ACTIONS(5358),
    [anon_sym_RBRACE] = ACTIONS(5358),
    [anon_sym_COMMA] = ACTIONS(5358),
    [anon_sym_COLON_COLON] = ACTIONS(5358),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5358),
    [anon_sym_EQ] = ACTIONS(5360),
    [anon_sym_COLON] = ACTIONS(5360),
    [anon_sym_PIPE] = ACTIONS(5360),
    [anon_sym_COLON_EQ] = ACTIONS(5358),
    [anon_sym_LPAREN] = ACTIONS(5358),
    [anon_sym_PLUS_EQ] = ACTIONS(5358),
    [anon_sym_DASH_EQ] = ACTIONS(5358),
    [anon_sym_STAR_EQ] = ACTIONS(5358),
    [anon_sym_SLASH_EQ] = ACTIONS(5358),
    [anon_sym_PERCENT_EQ] = ACTIONS(5358),
    [anon_sym_AMP_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_CARET_EQ] = ACTIONS(5358),
    [anon_sym_LT_LT_EQ] = ACTIONS(5358),
    [anon_sym_GT_GT_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_if] = ACTIONS(5358),
    [anon_sym_SEMI] = ACTIONS(5358),
    [anon_sym_else] = ACTIONS(5358),
    [anon_sym_when] = ACTIONS(5358),
    [anon_sym_in] = ACTIONS(5358),
    [anon_sym_case] = ACTIONS(5358),
    [anon_sym_QMARK] = ACTIONS(5358),
    [anon_sym_PLUS] = ACTIONS(4736),
    [anon_sym_DASH] = ACTIONS(4736),
    [anon_sym_TILDE] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(4740),
    [anon_sym_PIPE_PIPE] = ACTIONS(5360),
    [anon_sym_or_else] = ACTIONS(5358),
    [anon_sym_AMP_AMP] = ACTIONS(5360),
    [anon_sym_GT] = ACTIONS(5360),
    [anon_sym_GT_EQ] = ACTIONS(5358),
    [anon_sym_LT_EQ] = ACTIONS(5358),
    [anon_sym_LT] = ACTIONS(5360),
    [anon_sym_EQ_EQ] = ACTIONS(5358),
    [anon_sym_BANG_EQ] = ACTIONS(5358),
    [anon_sym_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE] = ACTIONS(4754),
    [anon_sym_LT_LT] = ACTIONS(4756),
    [anon_sym_GT_GT] = ACTIONS(4756),
    [anon_sym_STAR] = ACTIONS(4758),
    [anon_sym_SLASH] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4760),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5358),
    [anon_sym_or_return] = ACTIONS(5358),
    [anon_sym_or_continue] = ACTIONS(5358),
    [anon_sym_or_break] = ACTIONS(5358),
    [anon_sym_CARET] = ACTIONS(5360),
    [sym_uninitialized] = ACTIONS(5358),
    [sym_tag] = ACTIONS(5358),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5358),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1025] = {
    [ts_builtin_sym_end] = ACTIONS(5358),
    [anon_sym_LBRACE] = ACTIONS(5358),
    [anon_sym_RBRACE] = ACTIONS(5358),
    [anon_sym_COMMA] = ACTIONS(5358),
    [anon_sym_COLON_COLON] = ACTIONS(5358),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5358),
    [anon_sym_EQ] = ACTIONS(5360),
    [anon_sym_COLON] = ACTIONS(5360),
    [anon_sym_PIPE] = ACTIONS(5360),
    [anon_sym_COLON_EQ] = ACTIONS(5358),
    [anon_sym_LPAREN] = ACTIONS(5358),
    [anon_sym_PLUS_EQ] = ACTIONS(5358),
    [anon_sym_DASH_EQ] = ACTIONS(5358),
    [anon_sym_STAR_EQ] = ACTIONS(5358),
    [anon_sym_SLASH_EQ] = ACTIONS(5358),
    [anon_sym_PERCENT_EQ] = ACTIONS(5358),
    [anon_sym_AMP_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_CARET_EQ] = ACTIONS(5358),
    [anon_sym_LT_LT_EQ] = ACTIONS(5358),
    [anon_sym_GT_GT_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_if] = ACTIONS(5358),
    [anon_sym_SEMI] = ACTIONS(5358),
    [anon_sym_else] = ACTIONS(5358),
    [anon_sym_when] = ACTIONS(5358),
    [anon_sym_in] = ACTIONS(5358),
    [anon_sym_case] = ACTIONS(5358),
    [anon_sym_QMARK] = ACTIONS(5358),
    [anon_sym_PLUS] = ACTIONS(4736),
    [anon_sym_DASH] = ACTIONS(4736),
    [anon_sym_TILDE] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(5360),
    [anon_sym_PIPE_PIPE] = ACTIONS(5360),
    [anon_sym_or_else] = ACTIONS(5358),
    [anon_sym_AMP_AMP] = ACTIONS(5360),
    [anon_sym_GT] = ACTIONS(5360),
    [anon_sym_GT_EQ] = ACTIONS(5358),
    [anon_sym_LT_EQ] = ACTIONS(5358),
    [anon_sym_LT] = ACTIONS(5360),
    [anon_sym_EQ_EQ] = ACTIONS(5358),
    [anon_sym_BANG_EQ] = ACTIONS(5358),
    [anon_sym_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE] = ACTIONS(4754),
    [anon_sym_LT_LT] = ACTIONS(4756),
    [anon_sym_GT_GT] = ACTIONS(4756),
    [anon_sym_STAR] = ACTIONS(4758),
    [anon_sym_SLASH] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4760),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5358),
    [anon_sym_or_return] = ACTIONS(5358),
    [anon_sym_or_continue] = ACTIONS(5358),
    [anon_sym_or_break] = ACTIONS(5358),
    [anon_sym_CARET] = ACTIONS(5360),
    [sym_uninitialized] = ACTIONS(5358),
    [sym_tag] = ACTIONS(5358),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5358),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1026] = {
    [ts_builtin_sym_end] = ACTIONS(5358),
    [anon_sym_LBRACE] = ACTIONS(5358),
    [anon_sym_RBRACE] = ACTIONS(5358),
    [anon_sym_COMMA] = ACTIONS(5358),
    [anon_sym_COLON_COLON] = ACTIONS(5358),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5358),
    [anon_sym_EQ] = ACTIONS(5360),
    [anon_sym_COLON] = ACTIONS(5360),
    [anon_sym_PIPE] = ACTIONS(4734),
    [anon_sym_COLON_EQ] = ACTIONS(5358),
    [anon_sym_LPAREN] = ACTIONS(5358),
    [anon_sym_PLUS_EQ] = ACTIONS(5358),
    [anon_sym_DASH_EQ] = ACTIONS(5358),
    [anon_sym_STAR_EQ] = ACTIONS(5358),
    [anon_sym_SLASH_EQ] = ACTIONS(5358),
    [anon_sym_PERCENT_EQ] = ACTIONS(5358),
    [anon_sym_AMP_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_CARET_EQ] = ACTIONS(5358),
    [anon_sym_LT_LT_EQ] = ACTIONS(5358),
    [anon_sym_GT_GT_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_if] = ACTIONS(5358),
    [anon_sym_SEMI] = ACTIONS(5358),
    [anon_sym_else] = ACTIONS(5358),
    [anon_sym_when] = ACTIONS(5358),
    [anon_sym_in] = ACTIONS(5358),
    [anon_sym_case] = ACTIONS(5358),
    [anon_sym_QMARK] = ACTIONS(5358),
    [anon_sym_PLUS] = ACTIONS(4736),
    [anon_sym_DASH] = ACTIONS(4736),
    [anon_sym_TILDE] = ACTIONS(4738),
    [anon_sym_AMP] = ACTIONS(4740),
    [anon_sym_PIPE_PIPE] = ACTIONS(5360),
    [anon_sym_or_else] = ACTIONS(5358),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_GT] = ACTIONS(4748),
    [anon_sym_GT_EQ] = ACTIONS(4750),
    [anon_sym_LT_EQ] = ACTIONS(4750),
    [anon_sym_LT] = ACTIONS(4748),
    [anon_sym_EQ_EQ] = ACTIONS(4752),
    [anon_sym_BANG_EQ] = ACTIONS(4752),
    [anon_sym_TILDE_EQ] = ACTIONS(4752),
    [anon_sym_AMP_TILDE] = ACTIONS(4754),
    [anon_sym_LT_LT] = ACTIONS(4756),
    [anon_sym_GT_GT] = ACTIONS(4756),
    [anon_sym_STAR] = ACTIONS(4758),
    [anon_sym_SLASH] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4760),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5358),
    [anon_sym_or_return] = ACTIONS(5358),
    [anon_sym_or_continue] = ACTIONS(5358),
    [anon_sym_or_break] = ACTIONS(5358),
    [anon_sym_CARET] = ACTIONS(5360),
    [sym_uninitialized] = ACTIONS(5358),
    [sym_tag] = ACTIONS(5358),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5358),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1027] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5478),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1028] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5480),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1029] = {
    [ts_builtin_sym_end] = ACTIONS(5482),
    [anon_sym_LBRACE] = ACTIONS(5482),
    [anon_sym_RBRACE] = ACTIONS(5482),
    [anon_sym_COMMA] = ACTIONS(5482),
    [anon_sym_COLON_COLON] = ACTIONS(5482),
    [anon_sym_DASH_GT] = ACTIONS(5482),
    [anon_sym_where] = ACTIONS(5482),
    [anon_sym_EQ] = ACTIONS(5484),
    [anon_sym_COLON] = ACTIONS(5484),
    [anon_sym_PIPE] = ACTIONS(5484),
    [anon_sym_COLON_EQ] = ACTIONS(5482),
    [anon_sym_LPAREN] = ACTIONS(3423),
    [anon_sym_PLUS_EQ] = ACTIONS(5482),
    [anon_sym_DASH_EQ] = ACTIONS(5482),
    [anon_sym_STAR_EQ] = ACTIONS(5482),
    [anon_sym_SLASH_EQ] = ACTIONS(5482),
    [anon_sym_PERCENT_EQ] = ACTIONS(5482),
    [anon_sym_AMP_EQ] = ACTIONS(5482),
    [anon_sym_PIPE_EQ] = ACTIONS(5482),
    [anon_sym_CARET_EQ] = ACTIONS(5482),
    [anon_sym_LT_LT_EQ] = ACTIONS(5482),
    [anon_sym_GT_GT_EQ] = ACTIONS(5482),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5482),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5482),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5482),
    [anon_sym_if] = ACTIONS(5482),
    [anon_sym_SEMI] = ACTIONS(5482),
    [anon_sym_else] = ACTIONS(5482),
    [anon_sym_when] = ACTIONS(5482),
    [anon_sym_in] = ACTIONS(5482),
    [anon_sym_case] = ACTIONS(5482),
    [anon_sym_QMARK] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_DASH] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5484),
    [anon_sym_AMP] = ACTIONS(5484),
    [anon_sym_PIPE_PIPE] = ACTIONS(5484),
    [anon_sym_or_else] = ACTIONS(5482),
    [anon_sym_AMP_AMP] = ACTIONS(5484),
    [anon_sym_GT] = ACTIONS(5484),
    [anon_sym_GT_EQ] = ACTIONS(5482),
    [anon_sym_LT_EQ] = ACTIONS(5482),
    [anon_sym_LT] = ACTIONS(5484),
    [anon_sym_EQ_EQ] = ACTIONS(5482),
    [anon_sym_BANG_EQ] = ACTIONS(5482),
    [anon_sym_TILDE_EQ] = ACTIONS(5482),
    [anon_sym_AMP_TILDE] = ACTIONS(5484),
    [anon_sym_LT_LT] = ACTIONS(5484),
    [anon_sym_GT_GT] = ACTIONS(5484),
    [anon_sym_STAR] = ACTIONS(5484),
    [anon_sym_SLASH] = ACTIONS(3425),
    [anon_sym_PERCENT] = ACTIONS(5484),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5482),
    [anon_sym_DOT] = ACTIONS(5484),
    [anon_sym_LBRACK] = ACTIONS(5482),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5482),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5482),
    [anon_sym_not_in] = ACTIONS(5482),
    [anon_sym_or_return] = ACTIONS(5482),
    [anon_sym_or_continue] = ACTIONS(5482),
    [anon_sym_or_break] = ACTIONS(5482),
    [anon_sym_CARET] = ACTIONS(5484),
    [sym_uninitialized] = ACTIONS(5482),
    [sym_tag] = ACTIONS(5482),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5482),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1030] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7629),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5442),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1031] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5486),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1032] = {
    [ts_builtin_sym_end] = ACTIONS(4185),
    [anon_sym_LBRACE] = ACTIONS(4185),
    [anon_sym_RBRACE] = ACTIONS(4185),
    [anon_sym_COMMA] = ACTIONS(4185),
    [anon_sym_COLON_COLON] = ACTIONS(4185),
    [anon_sym_DASH_GT] = ACTIONS(4185),
    [anon_sym_where] = ACTIONS(4185),
    [anon_sym_EQ] = ACTIONS(4187),
    [anon_sym_COLON] = ACTIONS(4187),
    [anon_sym_PIPE] = ACTIONS(4187),
    [anon_sym_COLON_EQ] = ACTIONS(4185),
    [anon_sym_LPAREN] = ACTIONS(4185),
    [anon_sym_PLUS_EQ] = ACTIONS(4185),
    [anon_sym_DASH_EQ] = ACTIONS(4185),
    [anon_sym_STAR_EQ] = ACTIONS(4185),
    [anon_sym_SLASH_EQ] = ACTIONS(4185),
    [anon_sym_PERCENT_EQ] = ACTIONS(4185),
    [anon_sym_AMP_EQ] = ACTIONS(4185),
    [anon_sym_PIPE_EQ] = ACTIONS(4185),
    [anon_sym_CARET_EQ] = ACTIONS(4185),
    [anon_sym_LT_LT_EQ] = ACTIONS(4185),
    [anon_sym_GT_GT_EQ] = ACTIONS(4185),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4185),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4185),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4185),
    [anon_sym_if] = ACTIONS(4185),
    [anon_sym_SEMI] = ACTIONS(4185),
    [anon_sym_else] = ACTIONS(4185),
    [anon_sym_when] = ACTIONS(4185),
    [anon_sym_in] = ACTIONS(4185),
    [anon_sym_case] = ACTIONS(4185),
    [anon_sym_QMARK] = ACTIONS(4185),
    [anon_sym_PLUS] = ACTIONS(4187),
    [anon_sym_DASH] = ACTIONS(4187),
    [anon_sym_TILDE] = ACTIONS(4187),
    [anon_sym_AMP] = ACTIONS(4187),
    [anon_sym_PIPE_PIPE] = ACTIONS(4187),
    [anon_sym_or_else] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4187),
    [anon_sym_GT] = ACTIONS(4187),
    [anon_sym_GT_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4185),
    [anon_sym_LT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4185),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_TILDE_EQ] = ACTIONS(4185),
    [anon_sym_AMP_TILDE] = ACTIONS(4187),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_STAR] = ACTIONS(4187),
    [anon_sym_SLASH] = ACTIONS(4187),
    [anon_sym_PERCENT] = ACTIONS(4187),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4185),
    [anon_sym_DOT] = ACTIONS(4187),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4185),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4185),
    [anon_sym_not_in] = ACTIONS(4185),
    [anon_sym_or_return] = ACTIONS(4185),
    [anon_sym_or_continue] = ACTIONS(4185),
    [anon_sym_or_break] = ACTIONS(4185),
    [anon_sym_CARET] = ACTIONS(4187),
    [sym_uninitialized] = ACTIONS(4185),
    [sym_tag] = ACTIONS(4185),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4185),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1033] = {
    [ts_builtin_sym_end] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(5488),
    [anon_sym_RBRACE] = ACTIONS(5488),
    [anon_sym_COMMA] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(5488),
    [anon_sym_DASH_GT] = ACTIONS(5488),
    [anon_sym_where] = ACTIONS(5488),
    [anon_sym_EQ] = ACTIONS(5490),
    [anon_sym_COLON] = ACTIONS(5490),
    [anon_sym_PIPE] = ACTIONS(5490),
    [anon_sym_COLON_EQ] = ACTIONS(5488),
    [anon_sym_LPAREN] = ACTIONS(5488),
    [anon_sym_PLUS_EQ] = ACTIONS(5488),
    [anon_sym_DASH_EQ] = ACTIONS(5488),
    [anon_sym_STAR_EQ] = ACTIONS(5488),
    [anon_sym_SLASH_EQ] = ACTIONS(5488),
    [anon_sym_PERCENT_EQ] = ACTIONS(5488),
    [anon_sym_AMP_EQ] = ACTIONS(5488),
    [anon_sym_PIPE_EQ] = ACTIONS(5488),
    [anon_sym_CARET_EQ] = ACTIONS(5488),
    [anon_sym_LT_LT_EQ] = ACTIONS(5488),
    [anon_sym_GT_GT_EQ] = ACTIONS(5488),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5488),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5488),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5488),
    [anon_sym_if] = ACTIONS(5488),
    [anon_sym_SEMI] = ACTIONS(5488),
    [anon_sym_else] = ACTIONS(5488),
    [anon_sym_when] = ACTIONS(5488),
    [anon_sym_in] = ACTIONS(5488),
    [anon_sym_case] = ACTIONS(5488),
    [anon_sym_QMARK] = ACTIONS(5488),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_DASH] = ACTIONS(5490),
    [anon_sym_TILDE] = ACTIONS(5490),
    [anon_sym_AMP] = ACTIONS(5490),
    [anon_sym_PIPE_PIPE] = ACTIONS(5490),
    [anon_sym_or_else] = ACTIONS(5488),
    [anon_sym_AMP_AMP] = ACTIONS(5490),
    [anon_sym_GT] = ACTIONS(5490),
    [anon_sym_GT_EQ] = ACTIONS(5488),
    [anon_sym_LT_EQ] = ACTIONS(5488),
    [anon_sym_LT] = ACTIONS(5490),
    [anon_sym_EQ_EQ] = ACTIONS(5488),
    [anon_sym_BANG_EQ] = ACTIONS(5488),
    [anon_sym_TILDE_EQ] = ACTIONS(5488),
    [anon_sym_AMP_TILDE] = ACTIONS(5490),
    [anon_sym_LT_LT] = ACTIONS(5490),
    [anon_sym_GT_GT] = ACTIONS(5490),
    [anon_sym_STAR] = ACTIONS(5490),
    [anon_sym_SLASH] = ACTIONS(5490),
    [anon_sym_PERCENT] = ACTIONS(5490),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5488),
    [anon_sym_DOT] = ACTIONS(5490),
    [anon_sym_LBRACK] = ACTIONS(5488),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5488),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5488),
    [anon_sym_not_in] = ACTIONS(5488),
    [anon_sym_or_return] = ACTIONS(5488),
    [anon_sym_or_continue] = ACTIONS(5488),
    [anon_sym_or_break] = ACTIONS(5488),
    [anon_sym_CARET] = ACTIONS(5490),
    [sym_uninitialized] = ACTIONS(5488),
    [sym_tag] = ACTIONS(5488),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5488),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1034] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5492),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1035] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8061),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5494),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1036] = {
    [ts_builtin_sym_end] = ACTIONS(5496),
    [anon_sym_LBRACE] = ACTIONS(5496),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_COMMA] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_where] = ACTIONS(5496),
    [anon_sym_EQ] = ACTIONS(5498),
    [anon_sym_COLON] = ACTIONS(5498),
    [anon_sym_PIPE] = ACTIONS(5498),
    [anon_sym_COLON_EQ] = ACTIONS(5496),
    [anon_sym_LPAREN] = ACTIONS(5496),
    [anon_sym_PLUS_EQ] = ACTIONS(5496),
    [anon_sym_DASH_EQ] = ACTIONS(5496),
    [anon_sym_STAR_EQ] = ACTIONS(5496),
    [anon_sym_SLASH_EQ] = ACTIONS(5496),
    [anon_sym_PERCENT_EQ] = ACTIONS(5496),
    [anon_sym_AMP_EQ] = ACTIONS(5496),
    [anon_sym_PIPE_EQ] = ACTIONS(5496),
    [anon_sym_CARET_EQ] = ACTIONS(5496),
    [anon_sym_LT_LT_EQ] = ACTIONS(5496),
    [anon_sym_GT_GT_EQ] = ACTIONS(5496),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5496),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5496),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5496),
    [anon_sym_if] = ACTIONS(5496),
    [anon_sym_SEMI] = ACTIONS(5496),
    [anon_sym_else] = ACTIONS(5496),
    [anon_sym_when] = ACTIONS(5496),
    [anon_sym_in] = ACTIONS(5496),
    [anon_sym_case] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5496),
    [anon_sym_PLUS] = ACTIONS(5498),
    [anon_sym_DASH] = ACTIONS(5498),
    [anon_sym_TILDE] = ACTIONS(5498),
    [anon_sym_AMP] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE] = ACTIONS(5498),
    [anon_sym_or_else] = ACTIONS(5496),
    [anon_sym_AMP_AMP] = ACTIONS(5498),
    [anon_sym_GT] = ACTIONS(5498),
    [anon_sym_GT_EQ] = ACTIONS(5496),
    [anon_sym_LT_EQ] = ACTIONS(5496),
    [anon_sym_LT] = ACTIONS(5498),
    [anon_sym_EQ_EQ] = ACTIONS(5496),
    [anon_sym_BANG_EQ] = ACTIONS(5496),
    [anon_sym_TILDE_EQ] = ACTIONS(5496),
    [anon_sym_AMP_TILDE] = ACTIONS(5498),
    [anon_sym_LT_LT] = ACTIONS(5498),
    [anon_sym_GT_GT] = ACTIONS(5498),
    [anon_sym_STAR] = ACTIONS(5498),
    [anon_sym_SLASH] = ACTIONS(5498),
    [anon_sym_PERCENT] = ACTIONS(5498),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5496),
    [anon_sym_DOT] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5496),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5496),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5496),
    [anon_sym_not_in] = ACTIONS(5496),
    [anon_sym_or_return] = ACTIONS(5496),
    [anon_sym_or_continue] = ACTIONS(5496),
    [anon_sym_or_break] = ACTIONS(5496),
    [anon_sym_CARET] = ACTIONS(5498),
    [sym_uninitialized] = ACTIONS(5496),
    [sym_tag] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5496),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1037] = {
    [ts_builtin_sym_end] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(4691),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [anon_sym_COMMA] = ACTIONS(4691),
    [anon_sym_COLON_COLON] = ACTIONS(4691),
    [anon_sym_DASH_GT] = ACTIONS(4691),
    [anon_sym_where] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_COLON] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_COLON_EQ] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_PLUS_EQ] = ACTIONS(4691),
    [anon_sym_DASH_EQ] = ACTIONS(4691),
    [anon_sym_STAR_EQ] = ACTIONS(4691),
    [anon_sym_SLASH_EQ] = ACTIONS(4691),
    [anon_sym_PERCENT_EQ] = ACTIONS(4691),
    [anon_sym_AMP_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_CARET_EQ] = ACTIONS(4691),
    [anon_sym_LT_LT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4691),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4691),
    [anon_sym_if] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_else] = ACTIONS(4691),
    [anon_sym_when] = ACTIONS(4691),
    [anon_sym_in] = ACTIONS(4691),
    [anon_sym_case] = ACTIONS(4691),
    [anon_sym_QMARK] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(4693),
    [anon_sym_AMP] = ACTIONS(4693),
    [anon_sym_PIPE_PIPE] = ACTIONS(4693),
    [anon_sym_or_else] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_GT_EQ] = ACTIONS(4691),
    [anon_sym_LT_EQ] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_EQ_EQ] = ACTIONS(4691),
    [anon_sym_BANG_EQ] = ACTIONS(4691),
    [anon_sym_TILDE_EQ] = ACTIONS(4691),
    [anon_sym_AMP_TILDE] = ACTIONS(4693),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(4693),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4693),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4691),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4691),
    [anon_sym_not_in] = ACTIONS(4691),
    [anon_sym_or_return] = ACTIONS(4691),
    [anon_sym_or_continue] = ACTIONS(4691),
    [anon_sym_or_break] = ACTIONS(4691),
    [anon_sym_CARET] = ACTIONS(4693),
    [sym_uninitialized] = ACTIONS(4691),
    [sym_tag] = ACTIONS(4691),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4691),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1038] = {
    [sym_expression] = STATE(6216),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9076),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1039] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5500),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1040] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5494),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1041] = {
    [ts_builtin_sym_end] = ACTIONS(5358),
    [anon_sym_LBRACE] = ACTIONS(5358),
    [anon_sym_RBRACE] = ACTIONS(5358),
    [anon_sym_COMMA] = ACTIONS(5358),
    [anon_sym_COLON_COLON] = ACTIONS(5358),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5358),
    [anon_sym_EQ] = ACTIONS(5360),
    [anon_sym_COLON] = ACTIONS(5360),
    [anon_sym_PIPE] = ACTIONS(4734),
    [anon_sym_COLON_EQ] = ACTIONS(5358),
    [anon_sym_LPAREN] = ACTIONS(5358),
    [anon_sym_PLUS_EQ] = ACTIONS(5358),
    [anon_sym_DASH_EQ] = ACTIONS(5358),
    [anon_sym_STAR_EQ] = ACTIONS(5358),
    [anon_sym_SLASH_EQ] = ACTIONS(5358),
    [anon_sym_PERCENT_EQ] = ACTIONS(5358),
    [anon_sym_AMP_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_CARET_EQ] = ACTIONS(5358),
    [anon_sym_LT_LT_EQ] = ACTIONS(5358),
    [anon_sym_GT_GT_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_if] = ACTIONS(5358),
    [anon_sym_SEMI] = ACTIONS(5358),
    [anon_sym_else] = ACTIONS(5358),
    [anon_sym_when] = ACTIONS(5358),
    [anon_sym_in] = ACTIONS(5358),
    [anon_sym_case] = ACTIONS(5358),
    [anon_sym_QMARK] = ACTIONS(5358),
    [anon_sym_PLUS] = ACTIONS(4736),
    [anon_sym_DASH] = ACTIONS(4736),
    [anon_sym_TILDE] = ACTIONS(4738),
    [anon_sym_AMP] = ACTIONS(4740),
    [anon_sym_PIPE_PIPE] = ACTIONS(5360),
    [anon_sym_or_else] = ACTIONS(5358),
    [anon_sym_AMP_AMP] = ACTIONS(5360),
    [anon_sym_GT] = ACTIONS(4748),
    [anon_sym_GT_EQ] = ACTIONS(4750),
    [anon_sym_LT_EQ] = ACTIONS(4750),
    [anon_sym_LT] = ACTIONS(4748),
    [anon_sym_EQ_EQ] = ACTIONS(4752),
    [anon_sym_BANG_EQ] = ACTIONS(4752),
    [anon_sym_TILDE_EQ] = ACTIONS(4752),
    [anon_sym_AMP_TILDE] = ACTIONS(4754),
    [anon_sym_LT_LT] = ACTIONS(4756),
    [anon_sym_GT_GT] = ACTIONS(4756),
    [anon_sym_STAR] = ACTIONS(4758),
    [anon_sym_SLASH] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4760),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5358),
    [anon_sym_or_return] = ACTIONS(5358),
    [anon_sym_or_continue] = ACTIONS(5358),
    [anon_sym_or_break] = ACTIONS(5358),
    [anon_sym_CARET] = ACTIONS(5360),
    [sym_uninitialized] = ACTIONS(5358),
    [sym_tag] = ACTIONS(5358),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5358),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1042] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5502),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1043] = {
    [sym_expression] = STATE(6214),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(9076),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1044] = {
    [ts_builtin_sym_end] = ACTIONS(4667),
    [anon_sym_LBRACE] = ACTIONS(4667),
    [anon_sym_RBRACE] = ACTIONS(4667),
    [anon_sym_COMMA] = ACTIONS(4667),
    [anon_sym_COLON_COLON] = ACTIONS(4667),
    [anon_sym_DASH_GT] = ACTIONS(4667),
    [anon_sym_where] = ACTIONS(4667),
    [anon_sym_EQ] = ACTIONS(4669),
    [anon_sym_COLON] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4669),
    [anon_sym_COLON_EQ] = ACTIONS(4667),
    [anon_sym_LPAREN] = ACTIONS(4667),
    [anon_sym_PLUS_EQ] = ACTIONS(4667),
    [anon_sym_DASH_EQ] = ACTIONS(4667),
    [anon_sym_STAR_EQ] = ACTIONS(4667),
    [anon_sym_SLASH_EQ] = ACTIONS(4667),
    [anon_sym_PERCENT_EQ] = ACTIONS(4667),
    [anon_sym_AMP_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_CARET_EQ] = ACTIONS(4667),
    [anon_sym_LT_LT_EQ] = ACTIONS(4667),
    [anon_sym_GT_GT_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_if] = ACTIONS(4667),
    [anon_sym_SEMI] = ACTIONS(4667),
    [anon_sym_else] = ACTIONS(4667),
    [anon_sym_when] = ACTIONS(4667),
    [anon_sym_in] = ACTIONS(4667),
    [anon_sym_case] = ACTIONS(4667),
    [anon_sym_QMARK] = ACTIONS(4667),
    [anon_sym_PLUS] = ACTIONS(4669),
    [anon_sym_DASH] = ACTIONS(4669),
    [anon_sym_TILDE] = ACTIONS(4669),
    [anon_sym_AMP] = ACTIONS(4669),
    [anon_sym_PIPE_PIPE] = ACTIONS(4669),
    [anon_sym_or_else] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_GT] = ACTIONS(4669),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_LT_EQ] = ACTIONS(4667),
    [anon_sym_LT] = ACTIONS(4669),
    [anon_sym_EQ_EQ] = ACTIONS(4667),
    [anon_sym_BANG_EQ] = ACTIONS(4667),
    [anon_sym_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE] = ACTIONS(4669),
    [anon_sym_LT_LT] = ACTIONS(4669),
    [anon_sym_GT_GT] = ACTIONS(4669),
    [anon_sym_STAR] = ACTIONS(4669),
    [anon_sym_SLASH] = ACTIONS(4669),
    [anon_sym_PERCENT] = ACTIONS(4669),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4667),
    [anon_sym_DOT] = ACTIONS(4669),
    [anon_sym_LBRACK] = ACTIONS(4667),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4667),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4667),
    [anon_sym_not_in] = ACTIONS(4667),
    [anon_sym_or_return] = ACTIONS(4667),
    [anon_sym_or_continue] = ACTIONS(4667),
    [anon_sym_or_break] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [sym_uninitialized] = ACTIONS(4667),
    [sym_tag] = ACTIONS(4667),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4667),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1045] = {
    [ts_builtin_sym_end] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3671),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_DASH_GT] = ACTIONS(3671),
    [anon_sym_where] = ACTIONS(3671),
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_PLUS_EQ] = ACTIONS(3671),
    [anon_sym_DASH_EQ] = ACTIONS(3671),
    [anon_sym_STAR_EQ] = ACTIONS(3671),
    [anon_sym_SLASH_EQ] = ACTIONS(3671),
    [anon_sym_PERCENT_EQ] = ACTIONS(3671),
    [anon_sym_AMP_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_CARET_EQ] = ACTIONS(3671),
    [anon_sym_LT_LT_EQ] = ACTIONS(3671),
    [anon_sym_GT_GT_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_if] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_else] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3671),
    [anon_sym_case] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_or_else] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_GT] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3671),
    [anon_sym_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_SLASH] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3671),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3671),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3671),
    [anon_sym_not_in] = ACTIONS(3671),
    [anon_sym_or_return] = ACTIONS(3671),
    [anon_sym_or_continue] = ACTIONS(3671),
    [anon_sym_or_break] = ACTIONS(3671),
    [anon_sym_CARET] = ACTIONS(3675),
    [sym_uninitialized] = ACTIONS(3671),
    [sym_tag] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3671),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1046] = {
    [ts_builtin_sym_end] = ACTIONS(5358),
    [anon_sym_LBRACE] = ACTIONS(5358),
    [anon_sym_RBRACE] = ACTIONS(5358),
    [anon_sym_COMMA] = ACTIONS(5358),
    [anon_sym_COLON_COLON] = ACTIONS(5358),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5358),
    [anon_sym_EQ] = ACTIONS(5360),
    [anon_sym_COLON] = ACTIONS(5360),
    [anon_sym_PIPE] = ACTIONS(4734),
    [anon_sym_COLON_EQ] = ACTIONS(5358),
    [anon_sym_LPAREN] = ACTIONS(5358),
    [anon_sym_PLUS_EQ] = ACTIONS(5358),
    [anon_sym_DASH_EQ] = ACTIONS(5358),
    [anon_sym_STAR_EQ] = ACTIONS(5358),
    [anon_sym_SLASH_EQ] = ACTIONS(5358),
    [anon_sym_PERCENT_EQ] = ACTIONS(5358),
    [anon_sym_AMP_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_CARET_EQ] = ACTIONS(5358),
    [anon_sym_LT_LT_EQ] = ACTIONS(5358),
    [anon_sym_GT_GT_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_if] = ACTIONS(5358),
    [anon_sym_SEMI] = ACTIONS(5358),
    [anon_sym_else] = ACTIONS(5358),
    [anon_sym_when] = ACTIONS(5358),
    [anon_sym_in] = ACTIONS(5358),
    [anon_sym_case] = ACTIONS(5358),
    [anon_sym_QMARK] = ACTIONS(5358),
    [anon_sym_PLUS] = ACTIONS(4736),
    [anon_sym_DASH] = ACTIONS(4736),
    [anon_sym_TILDE] = ACTIONS(4738),
    [anon_sym_AMP] = ACTIONS(4740),
    [anon_sym_PIPE_PIPE] = ACTIONS(5360),
    [anon_sym_or_else] = ACTIONS(5358),
    [anon_sym_AMP_AMP] = ACTIONS(5360),
    [anon_sym_GT] = ACTIONS(5360),
    [anon_sym_GT_EQ] = ACTIONS(5358),
    [anon_sym_LT_EQ] = ACTIONS(5358),
    [anon_sym_LT] = ACTIONS(5360),
    [anon_sym_EQ_EQ] = ACTIONS(4752),
    [anon_sym_BANG_EQ] = ACTIONS(4752),
    [anon_sym_TILDE_EQ] = ACTIONS(4752),
    [anon_sym_AMP_TILDE] = ACTIONS(4754),
    [anon_sym_LT_LT] = ACTIONS(4756),
    [anon_sym_GT_GT] = ACTIONS(4756),
    [anon_sym_STAR] = ACTIONS(4758),
    [anon_sym_SLASH] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4760),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5358),
    [anon_sym_or_return] = ACTIONS(5358),
    [anon_sym_or_continue] = ACTIONS(5358),
    [anon_sym_or_break] = ACTIONS(5358),
    [anon_sym_CARET] = ACTIONS(5360),
    [sym_uninitialized] = ACTIONS(5358),
    [sym_tag] = ACTIONS(5358),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5358),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1047] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8030),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5502),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1048] = {
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(4023),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(4023),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(4023),
    [sym_tag] = ACTIONS(4023),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4023),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1049] = {
    [ts_builtin_sym_end] = ACTIONS(5358),
    [anon_sym_LBRACE] = ACTIONS(5358),
    [anon_sym_RBRACE] = ACTIONS(5358),
    [anon_sym_COMMA] = ACTIONS(5358),
    [anon_sym_COLON_COLON] = ACTIONS(5358),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5358),
    [anon_sym_EQ] = ACTIONS(5360),
    [anon_sym_COLON] = ACTIONS(5360),
    [anon_sym_PIPE] = ACTIONS(4734),
    [anon_sym_COLON_EQ] = ACTIONS(5358),
    [anon_sym_LPAREN] = ACTIONS(5358),
    [anon_sym_PLUS_EQ] = ACTIONS(5358),
    [anon_sym_DASH_EQ] = ACTIONS(5358),
    [anon_sym_STAR_EQ] = ACTIONS(5358),
    [anon_sym_SLASH_EQ] = ACTIONS(5358),
    [anon_sym_PERCENT_EQ] = ACTIONS(5358),
    [anon_sym_AMP_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_CARET_EQ] = ACTIONS(5358),
    [anon_sym_LT_LT_EQ] = ACTIONS(5358),
    [anon_sym_GT_GT_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_if] = ACTIONS(5358),
    [anon_sym_SEMI] = ACTIONS(5358),
    [anon_sym_else] = ACTIONS(5358),
    [anon_sym_when] = ACTIONS(5358),
    [anon_sym_in] = ACTIONS(5358),
    [anon_sym_case] = ACTIONS(5358),
    [anon_sym_QMARK] = ACTIONS(5358),
    [anon_sym_PLUS] = ACTIONS(4736),
    [anon_sym_DASH] = ACTIONS(4736),
    [anon_sym_TILDE] = ACTIONS(4738),
    [anon_sym_AMP] = ACTIONS(4740),
    [anon_sym_PIPE_PIPE] = ACTIONS(5360),
    [anon_sym_or_else] = ACTIONS(5358),
    [anon_sym_AMP_AMP] = ACTIONS(5360),
    [anon_sym_GT] = ACTIONS(5360),
    [anon_sym_GT_EQ] = ACTIONS(5358),
    [anon_sym_LT_EQ] = ACTIONS(5358),
    [anon_sym_LT] = ACTIONS(5360),
    [anon_sym_EQ_EQ] = ACTIONS(5358),
    [anon_sym_BANG_EQ] = ACTIONS(5358),
    [anon_sym_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE] = ACTIONS(4754),
    [anon_sym_LT_LT] = ACTIONS(4756),
    [anon_sym_GT_GT] = ACTIONS(4756),
    [anon_sym_STAR] = ACTIONS(4758),
    [anon_sym_SLASH] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4760),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5358),
    [anon_sym_or_return] = ACTIONS(5358),
    [anon_sym_or_continue] = ACTIONS(5358),
    [anon_sym_or_break] = ACTIONS(5358),
    [anon_sym_CARET] = ACTIONS(5360),
    [sym_uninitialized] = ACTIONS(5358),
    [sym_tag] = ACTIONS(5358),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5358),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1050] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7931),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5504),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1051] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8008),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5506),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1052] = {
    [sym_block] = STATE(2171),
    [ts_builtin_sym_end] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_DASH_GT] = ACTIONS(3671),
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_PLUS_EQ] = ACTIONS(3671),
    [anon_sym_DASH_EQ] = ACTIONS(3671),
    [anon_sym_STAR_EQ] = ACTIONS(3671),
    [anon_sym_SLASH_EQ] = ACTIONS(3671),
    [anon_sym_PERCENT_EQ] = ACTIONS(3671),
    [anon_sym_AMP_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_CARET_EQ] = ACTIONS(3671),
    [anon_sym_LT_LT_EQ] = ACTIONS(3671),
    [anon_sym_GT_GT_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_if] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_else] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3671),
    [anon_sym_case] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_or_else] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_GT] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3671),
    [anon_sym_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_SLASH] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3671),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3671),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3671),
    [anon_sym_not_in] = ACTIONS(3671),
    [anon_sym_or_return] = ACTIONS(3671),
    [anon_sym_or_continue] = ACTIONS(3671),
    [anon_sym_or_break] = ACTIONS(3671),
    [anon_sym_CARET] = ACTIONS(3675),
    [sym_uninitialized] = ACTIONS(4490),
    [sym_tag] = ACTIONS(4492),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3671),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1053] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5506),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1054] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5508),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1055] = {
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(4083),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(4083),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(4083),
    [sym_tag] = ACTIONS(4083),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4083),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1056] = {
    [sym_expression] = STATE(6195),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5512),
    [anon_sym_dynamic] = ACTIONS(5514),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1057] = {
    [sym_expression] = STATE(6350),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8745),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1058] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5516),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1059] = {
    [ts_builtin_sym_end] = ACTIONS(5358),
    [anon_sym_LBRACE] = ACTIONS(5358),
    [anon_sym_RBRACE] = ACTIONS(5358),
    [anon_sym_COMMA] = ACTIONS(5358),
    [anon_sym_COLON_COLON] = ACTIONS(5358),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5358),
    [anon_sym_EQ] = ACTIONS(5360),
    [anon_sym_COLON] = ACTIONS(5360),
    [anon_sym_PIPE] = ACTIONS(5360),
    [anon_sym_COLON_EQ] = ACTIONS(5358),
    [anon_sym_LPAREN] = ACTIONS(5358),
    [anon_sym_PLUS_EQ] = ACTIONS(5358),
    [anon_sym_DASH_EQ] = ACTIONS(5358),
    [anon_sym_STAR_EQ] = ACTIONS(5358),
    [anon_sym_SLASH_EQ] = ACTIONS(5358),
    [anon_sym_PERCENT_EQ] = ACTIONS(5358),
    [anon_sym_AMP_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_CARET_EQ] = ACTIONS(5358),
    [anon_sym_LT_LT_EQ] = ACTIONS(5358),
    [anon_sym_GT_GT_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_if] = ACTIONS(5358),
    [anon_sym_SEMI] = ACTIONS(5358),
    [anon_sym_else] = ACTIONS(5358),
    [anon_sym_when] = ACTIONS(5358),
    [anon_sym_in] = ACTIONS(5358),
    [anon_sym_case] = ACTIONS(5358),
    [anon_sym_QMARK] = ACTIONS(5358),
    [anon_sym_PLUS] = ACTIONS(4736),
    [anon_sym_DASH] = ACTIONS(4736),
    [anon_sym_TILDE] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(5360),
    [anon_sym_PIPE_PIPE] = ACTIONS(5360),
    [anon_sym_or_else] = ACTIONS(5358),
    [anon_sym_AMP_AMP] = ACTIONS(5360),
    [anon_sym_GT] = ACTIONS(5360),
    [anon_sym_GT_EQ] = ACTIONS(5358),
    [anon_sym_LT_EQ] = ACTIONS(5358),
    [anon_sym_LT] = ACTIONS(5360),
    [anon_sym_EQ_EQ] = ACTIONS(5358),
    [anon_sym_BANG_EQ] = ACTIONS(5358),
    [anon_sym_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE] = ACTIONS(5360),
    [anon_sym_LT_LT] = ACTIONS(4756),
    [anon_sym_GT_GT] = ACTIONS(4756),
    [anon_sym_STAR] = ACTIONS(4758),
    [anon_sym_SLASH] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4760),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5358),
    [anon_sym_or_return] = ACTIONS(5358),
    [anon_sym_or_continue] = ACTIONS(5358),
    [anon_sym_or_break] = ACTIONS(5358),
    [anon_sym_CARET] = ACTIONS(5360),
    [sym_uninitialized] = ACTIONS(5358),
    [sym_tag] = ACTIONS(5358),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5358),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1060] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7967),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5518),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1061] = {
    [ts_builtin_sym_end] = ACTIONS(5358),
    [anon_sym_LBRACE] = ACTIONS(5358),
    [anon_sym_RBRACE] = ACTIONS(5358),
    [anon_sym_COMMA] = ACTIONS(5358),
    [anon_sym_COLON_COLON] = ACTIONS(5358),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5358),
    [anon_sym_EQ] = ACTIONS(5360),
    [anon_sym_COLON] = ACTIONS(5360),
    [anon_sym_PIPE] = ACTIONS(5360),
    [anon_sym_COLON_EQ] = ACTIONS(5358),
    [anon_sym_LPAREN] = ACTIONS(5358),
    [anon_sym_PLUS_EQ] = ACTIONS(5358),
    [anon_sym_DASH_EQ] = ACTIONS(5358),
    [anon_sym_STAR_EQ] = ACTIONS(5358),
    [anon_sym_SLASH_EQ] = ACTIONS(5358),
    [anon_sym_PERCENT_EQ] = ACTIONS(5358),
    [anon_sym_AMP_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_CARET_EQ] = ACTIONS(5358),
    [anon_sym_LT_LT_EQ] = ACTIONS(5358),
    [anon_sym_GT_GT_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_if] = ACTIONS(5358),
    [anon_sym_SEMI] = ACTIONS(5358),
    [anon_sym_else] = ACTIONS(5358),
    [anon_sym_when] = ACTIONS(5358),
    [anon_sym_in] = ACTIONS(5358),
    [anon_sym_case] = ACTIONS(5358),
    [anon_sym_QMARK] = ACTIONS(5358),
    [anon_sym_PLUS] = ACTIONS(4736),
    [anon_sym_DASH] = ACTIONS(4736),
    [anon_sym_TILDE] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(5360),
    [anon_sym_PIPE_PIPE] = ACTIONS(5360),
    [anon_sym_or_else] = ACTIONS(5358),
    [anon_sym_AMP_AMP] = ACTIONS(5360),
    [anon_sym_GT] = ACTIONS(5360),
    [anon_sym_GT_EQ] = ACTIONS(5358),
    [anon_sym_LT_EQ] = ACTIONS(5358),
    [anon_sym_LT] = ACTIONS(5360),
    [anon_sym_EQ_EQ] = ACTIONS(5358),
    [anon_sym_BANG_EQ] = ACTIONS(5358),
    [anon_sym_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE] = ACTIONS(5360),
    [anon_sym_LT_LT] = ACTIONS(5360),
    [anon_sym_GT_GT] = ACTIONS(5360),
    [anon_sym_STAR] = ACTIONS(4758),
    [anon_sym_SLASH] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4760),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5358),
    [anon_sym_or_return] = ACTIONS(5358),
    [anon_sym_or_continue] = ACTIONS(5358),
    [anon_sym_or_break] = ACTIONS(5358),
    [anon_sym_CARET] = ACTIONS(5360),
    [sym_uninitialized] = ACTIONS(5358),
    [sym_tag] = ACTIONS(5358),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5358),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1062] = {
    [ts_builtin_sym_end] = ACTIONS(3781),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [anon_sym_where] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3785),
    [anon_sym_COLON] = ACTIONS(3785),
    [anon_sym_PIPE] = ACTIONS(3785),
    [anon_sym_COLON_EQ] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_else] = ACTIONS(3781),
    [anon_sym_when] = ACTIONS(3781),
    [anon_sym_in] = ACTIONS(3781),
    [anon_sym_case] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(3785),
    [anon_sym_PIPE_PIPE] = ACTIONS(3785),
    [anon_sym_or_else] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3785),
    [anon_sym_GT] = ACTIONS(3785),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3781),
    [anon_sym_LT] = ACTIONS(3785),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE] = ACTIONS(3785),
    [anon_sym_LT_LT] = ACTIONS(3785),
    [anon_sym_GT_GT] = ACTIONS(3785),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_SLASH] = ACTIONS(3785),
    [anon_sym_PERCENT] = ACTIONS(3785),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3781),
    [anon_sym_not_in] = ACTIONS(3781),
    [anon_sym_or_return] = ACTIONS(3781),
    [anon_sym_or_continue] = ACTIONS(3781),
    [anon_sym_or_break] = ACTIONS(3781),
    [anon_sym_CARET] = ACTIONS(3785),
    [sym_uninitialized] = ACTIONS(3781),
    [sym_tag] = ACTIONS(3781),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3781),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1063] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5520),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1064] = {
    [ts_builtin_sym_end] = ACTIONS(5522),
    [anon_sym_LBRACE] = ACTIONS(5522),
    [anon_sym_RBRACE] = ACTIONS(5522),
    [anon_sym_COMMA] = ACTIONS(5522),
    [anon_sym_COLON_COLON] = ACTIONS(5522),
    [anon_sym_DASH_GT] = ACTIONS(5522),
    [anon_sym_where] = ACTIONS(5522),
    [anon_sym_EQ] = ACTIONS(5524),
    [anon_sym_COLON] = ACTIONS(5524),
    [anon_sym_PIPE] = ACTIONS(5524),
    [anon_sym_COLON_EQ] = ACTIONS(5522),
    [anon_sym_LPAREN] = ACTIONS(5522),
    [anon_sym_PLUS_EQ] = ACTIONS(5522),
    [anon_sym_DASH_EQ] = ACTIONS(5522),
    [anon_sym_STAR_EQ] = ACTIONS(5522),
    [anon_sym_SLASH_EQ] = ACTIONS(5522),
    [anon_sym_PERCENT_EQ] = ACTIONS(5522),
    [anon_sym_AMP_EQ] = ACTIONS(5522),
    [anon_sym_PIPE_EQ] = ACTIONS(5522),
    [anon_sym_CARET_EQ] = ACTIONS(5522),
    [anon_sym_LT_LT_EQ] = ACTIONS(5522),
    [anon_sym_GT_GT_EQ] = ACTIONS(5522),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5522),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5522),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5522),
    [anon_sym_if] = ACTIONS(5522),
    [anon_sym_SEMI] = ACTIONS(5522),
    [anon_sym_else] = ACTIONS(5522),
    [anon_sym_when] = ACTIONS(5522),
    [anon_sym_in] = ACTIONS(5522),
    [anon_sym_case] = ACTIONS(5522),
    [anon_sym_QMARK] = ACTIONS(5522),
    [anon_sym_PLUS] = ACTIONS(5524),
    [anon_sym_DASH] = ACTIONS(5524),
    [anon_sym_TILDE] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5524),
    [anon_sym_PIPE_PIPE] = ACTIONS(5524),
    [anon_sym_or_else] = ACTIONS(5522),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_GT] = ACTIONS(5524),
    [anon_sym_GT_EQ] = ACTIONS(5522),
    [anon_sym_LT_EQ] = ACTIONS(5522),
    [anon_sym_LT] = ACTIONS(5524),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_EQ] = ACTIONS(5522),
    [anon_sym_TILDE_EQ] = ACTIONS(5522),
    [anon_sym_AMP_TILDE] = ACTIONS(5524),
    [anon_sym_LT_LT] = ACTIONS(5524),
    [anon_sym_GT_GT] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5524),
    [anon_sym_SLASH] = ACTIONS(5524),
    [anon_sym_PERCENT] = ACTIONS(5524),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5522),
    [anon_sym_DOT] = ACTIONS(5524),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5522),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5522),
    [anon_sym_not_in] = ACTIONS(5522),
    [anon_sym_or_return] = ACTIONS(5522),
    [anon_sym_or_continue] = ACTIONS(5522),
    [anon_sym_or_break] = ACTIONS(5522),
    [anon_sym_CARET] = ACTIONS(5524),
    [sym_uninitialized] = ACTIONS(5522),
    [sym_tag] = ACTIONS(5522),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5522),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1065] = {
    [ts_builtin_sym_end] = ACTIONS(5526),
    [anon_sym_LBRACE] = ACTIONS(5526),
    [anon_sym_RBRACE] = ACTIONS(5526),
    [anon_sym_COMMA] = ACTIONS(5526),
    [anon_sym_COLON_COLON] = ACTIONS(5526),
    [anon_sym_DASH_GT] = ACTIONS(5526),
    [anon_sym_where] = ACTIONS(5526),
    [anon_sym_EQ] = ACTIONS(5528),
    [anon_sym_COLON] = ACTIONS(5528),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_COLON_EQ] = ACTIONS(5526),
    [anon_sym_LPAREN] = ACTIONS(5526),
    [anon_sym_PLUS_EQ] = ACTIONS(5526),
    [anon_sym_DASH_EQ] = ACTIONS(5526),
    [anon_sym_STAR_EQ] = ACTIONS(5526),
    [anon_sym_SLASH_EQ] = ACTIONS(5526),
    [anon_sym_PERCENT_EQ] = ACTIONS(5526),
    [anon_sym_AMP_EQ] = ACTIONS(5526),
    [anon_sym_PIPE_EQ] = ACTIONS(5526),
    [anon_sym_CARET_EQ] = ACTIONS(5526),
    [anon_sym_LT_LT_EQ] = ACTIONS(5526),
    [anon_sym_GT_GT_EQ] = ACTIONS(5526),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5526),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5526),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5526),
    [anon_sym_if] = ACTIONS(5526),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_else] = ACTIONS(5526),
    [anon_sym_when] = ACTIONS(5526),
    [anon_sym_in] = ACTIONS(5526),
    [anon_sym_case] = ACTIONS(5526),
    [anon_sym_QMARK] = ACTIONS(5526),
    [anon_sym_PLUS] = ACTIONS(5528),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_TILDE] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5528),
    [anon_sym_PIPE_PIPE] = ACTIONS(5528),
    [anon_sym_or_else] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_GT] = ACTIONS(5528),
    [anon_sym_GT_EQ] = ACTIONS(5526),
    [anon_sym_LT_EQ] = ACTIONS(5526),
    [anon_sym_LT] = ACTIONS(5528),
    [anon_sym_EQ_EQ] = ACTIONS(5526),
    [anon_sym_BANG_EQ] = ACTIONS(5526),
    [anon_sym_TILDE_EQ] = ACTIONS(5526),
    [anon_sym_AMP_TILDE] = ACTIONS(5528),
    [anon_sym_LT_LT] = ACTIONS(5528),
    [anon_sym_GT_GT] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5528),
    [anon_sym_SLASH] = ACTIONS(5528),
    [anon_sym_PERCENT] = ACTIONS(5528),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5526),
    [anon_sym_DOT] = ACTIONS(5528),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5526),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5526),
    [anon_sym_not_in] = ACTIONS(5526),
    [anon_sym_or_return] = ACTIONS(5526),
    [anon_sym_or_continue] = ACTIONS(5526),
    [anon_sym_or_break] = ACTIONS(5526),
    [anon_sym_CARET] = ACTIONS(5528),
    [sym_uninitialized] = ACTIONS(5526),
    [sym_tag] = ACTIONS(5526),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5526),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1066] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7932),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5530),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1067] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5532),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1068] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7930),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5534),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1069] = {
    [ts_builtin_sym_end] = ACTIONS(5358),
    [anon_sym_LBRACE] = ACTIONS(5358),
    [anon_sym_RBRACE] = ACTIONS(5358),
    [anon_sym_COMMA] = ACTIONS(5358),
    [anon_sym_COLON_COLON] = ACTIONS(5358),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5358),
    [anon_sym_EQ] = ACTIONS(5360),
    [anon_sym_COLON] = ACTIONS(5360),
    [anon_sym_PIPE] = ACTIONS(5360),
    [anon_sym_COLON_EQ] = ACTIONS(5358),
    [anon_sym_LPAREN] = ACTIONS(5358),
    [anon_sym_PLUS_EQ] = ACTIONS(5358),
    [anon_sym_DASH_EQ] = ACTIONS(5358),
    [anon_sym_STAR_EQ] = ACTIONS(5358),
    [anon_sym_SLASH_EQ] = ACTIONS(5358),
    [anon_sym_PERCENT_EQ] = ACTIONS(5358),
    [anon_sym_AMP_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_CARET_EQ] = ACTIONS(5358),
    [anon_sym_LT_LT_EQ] = ACTIONS(5358),
    [anon_sym_GT_GT_EQ] = ACTIONS(5358),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_if] = ACTIONS(5358),
    [anon_sym_SEMI] = ACTIONS(5358),
    [anon_sym_else] = ACTIONS(5358),
    [anon_sym_when] = ACTIONS(5358),
    [anon_sym_in] = ACTIONS(5358),
    [anon_sym_case] = ACTIONS(5358),
    [anon_sym_QMARK] = ACTIONS(5358),
    [anon_sym_PLUS] = ACTIONS(5360),
    [anon_sym_DASH] = ACTIONS(5360),
    [anon_sym_TILDE] = ACTIONS(5360),
    [anon_sym_AMP] = ACTIONS(5360),
    [anon_sym_PIPE_PIPE] = ACTIONS(5360),
    [anon_sym_or_else] = ACTIONS(5358),
    [anon_sym_AMP_AMP] = ACTIONS(5360),
    [anon_sym_GT] = ACTIONS(5360),
    [anon_sym_GT_EQ] = ACTIONS(5358),
    [anon_sym_LT_EQ] = ACTIONS(5358),
    [anon_sym_LT] = ACTIONS(5360),
    [anon_sym_EQ_EQ] = ACTIONS(5358),
    [anon_sym_BANG_EQ] = ACTIONS(5358),
    [anon_sym_TILDE_EQ] = ACTIONS(5358),
    [anon_sym_AMP_TILDE] = ACTIONS(5360),
    [anon_sym_LT_LT] = ACTIONS(5360),
    [anon_sym_GT_GT] = ACTIONS(5360),
    [anon_sym_STAR] = ACTIONS(5360),
    [anon_sym_SLASH] = ACTIONS(5360),
    [anon_sym_PERCENT] = ACTIONS(5360),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5358),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5358),
    [anon_sym_or_return] = ACTIONS(5358),
    [anon_sym_or_continue] = ACTIONS(5358),
    [anon_sym_or_break] = ACTIONS(5358),
    [anon_sym_CARET] = ACTIONS(5360),
    [sym_uninitialized] = ACTIONS(5358),
    [sym_tag] = ACTIONS(5358),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5358),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1070] = {
    [ts_builtin_sym_end] = ACTIONS(5536),
    [anon_sym_LBRACE] = ACTIONS(5536),
    [anon_sym_RBRACE] = ACTIONS(5536),
    [anon_sym_COMMA] = ACTIONS(5536),
    [anon_sym_COLON_COLON] = ACTIONS(5536),
    [anon_sym_DASH_GT] = ACTIONS(5536),
    [anon_sym_where] = ACTIONS(5536),
    [anon_sym_EQ] = ACTIONS(5538),
    [anon_sym_COLON] = ACTIONS(5538),
    [anon_sym_PIPE] = ACTIONS(5538),
    [anon_sym_COLON_EQ] = ACTIONS(5536),
    [anon_sym_LPAREN] = ACTIONS(5536),
    [anon_sym_PLUS_EQ] = ACTIONS(5536),
    [anon_sym_DASH_EQ] = ACTIONS(5536),
    [anon_sym_STAR_EQ] = ACTIONS(5536),
    [anon_sym_SLASH_EQ] = ACTIONS(5536),
    [anon_sym_PERCENT_EQ] = ACTIONS(5536),
    [anon_sym_AMP_EQ] = ACTIONS(5536),
    [anon_sym_PIPE_EQ] = ACTIONS(5536),
    [anon_sym_CARET_EQ] = ACTIONS(5536),
    [anon_sym_LT_LT_EQ] = ACTIONS(5536),
    [anon_sym_GT_GT_EQ] = ACTIONS(5536),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5536),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5536),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5536),
    [anon_sym_if] = ACTIONS(5536),
    [anon_sym_SEMI] = ACTIONS(5536),
    [anon_sym_else] = ACTIONS(5536),
    [anon_sym_when] = ACTIONS(5536),
    [anon_sym_in] = ACTIONS(5536),
    [anon_sym_case] = ACTIONS(5536),
    [anon_sym_QMARK] = ACTIONS(5536),
    [anon_sym_PLUS] = ACTIONS(5538),
    [anon_sym_DASH] = ACTIONS(5538),
    [anon_sym_TILDE] = ACTIONS(5538),
    [anon_sym_AMP] = ACTIONS(5538),
    [anon_sym_PIPE_PIPE] = ACTIONS(5538),
    [anon_sym_or_else] = ACTIONS(5536),
    [anon_sym_AMP_AMP] = ACTIONS(5538),
    [anon_sym_GT] = ACTIONS(5538),
    [anon_sym_GT_EQ] = ACTIONS(5536),
    [anon_sym_LT_EQ] = ACTIONS(5536),
    [anon_sym_LT] = ACTIONS(5538),
    [anon_sym_EQ_EQ] = ACTIONS(5536),
    [anon_sym_BANG_EQ] = ACTIONS(5536),
    [anon_sym_TILDE_EQ] = ACTIONS(5536),
    [anon_sym_AMP_TILDE] = ACTIONS(5538),
    [anon_sym_LT_LT] = ACTIONS(5538),
    [anon_sym_GT_GT] = ACTIONS(5538),
    [anon_sym_STAR] = ACTIONS(5538),
    [anon_sym_SLASH] = ACTIONS(5538),
    [anon_sym_PERCENT] = ACTIONS(5538),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5536),
    [anon_sym_DOT] = ACTIONS(5538),
    [anon_sym_LBRACK] = ACTIONS(5536),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5536),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5536),
    [anon_sym_not_in] = ACTIONS(5536),
    [anon_sym_or_return] = ACTIONS(5536),
    [anon_sym_or_continue] = ACTIONS(5536),
    [anon_sym_or_break] = ACTIONS(5536),
    [anon_sym_CARET] = ACTIONS(5538),
    [sym_uninitialized] = ACTIONS(5536),
    [sym_tag] = ACTIONS(5536),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5536),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1071] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5540),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1072] = {
    [ts_builtin_sym_end] = ACTIONS(5542),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_RBRACE] = ACTIONS(5542),
    [anon_sym_COMMA] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_where] = ACTIONS(5542),
    [anon_sym_EQ] = ACTIONS(5544),
    [anon_sym_COLON] = ACTIONS(5544),
    [anon_sym_PIPE] = ACTIONS(5544),
    [anon_sym_COLON_EQ] = ACTIONS(5542),
    [anon_sym_LPAREN] = ACTIONS(5542),
    [anon_sym_PLUS_EQ] = ACTIONS(5542),
    [anon_sym_DASH_EQ] = ACTIONS(5542),
    [anon_sym_STAR_EQ] = ACTIONS(5542),
    [anon_sym_SLASH_EQ] = ACTIONS(5542),
    [anon_sym_PERCENT_EQ] = ACTIONS(5542),
    [anon_sym_AMP_EQ] = ACTIONS(5542),
    [anon_sym_PIPE_EQ] = ACTIONS(5542),
    [anon_sym_CARET_EQ] = ACTIONS(5542),
    [anon_sym_LT_LT_EQ] = ACTIONS(5542),
    [anon_sym_GT_GT_EQ] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5542),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5542),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5542),
    [anon_sym_if] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_else] = ACTIONS(5542),
    [anon_sym_when] = ACTIONS(5542),
    [anon_sym_in] = ACTIONS(5542),
    [anon_sym_case] = ACTIONS(5542),
    [anon_sym_QMARK] = ACTIONS(5542),
    [anon_sym_PLUS] = ACTIONS(5544),
    [anon_sym_DASH] = ACTIONS(5544),
    [anon_sym_TILDE] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5544),
    [anon_sym_PIPE_PIPE] = ACTIONS(5544),
    [anon_sym_or_else] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5544),
    [anon_sym_GT] = ACTIONS(5544),
    [anon_sym_GT_EQ] = ACTIONS(5542),
    [anon_sym_LT_EQ] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5544),
    [anon_sym_EQ_EQ] = ACTIONS(5542),
    [anon_sym_BANG_EQ] = ACTIONS(5542),
    [anon_sym_TILDE_EQ] = ACTIONS(5542),
    [anon_sym_AMP_TILDE] = ACTIONS(5544),
    [anon_sym_LT_LT] = ACTIONS(5544),
    [anon_sym_GT_GT] = ACTIONS(5544),
    [anon_sym_STAR] = ACTIONS(5544),
    [anon_sym_SLASH] = ACTIONS(5544),
    [anon_sym_PERCENT] = ACTIONS(5544),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5542),
    [anon_sym_DOT] = ACTIONS(5544),
    [anon_sym_LBRACK] = ACTIONS(5542),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5542),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5542),
    [anon_sym_not_in] = ACTIONS(5542),
    [anon_sym_or_return] = ACTIONS(5542),
    [anon_sym_or_continue] = ACTIONS(5542),
    [anon_sym_or_break] = ACTIONS(5542),
    [anon_sym_CARET] = ACTIONS(5544),
    [sym_uninitialized] = ACTIONS(5542),
    [sym_tag] = ACTIONS(5542),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5542),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1073] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5546),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1074] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5548),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1075] = {
    [ts_builtin_sym_end] = ACTIONS(5550),
    [anon_sym_LBRACE] = ACTIONS(5550),
    [anon_sym_RBRACE] = ACTIONS(5550),
    [anon_sym_COMMA] = ACTIONS(5550),
    [anon_sym_COLON_COLON] = ACTIONS(5550),
    [anon_sym_DASH_GT] = ACTIONS(5550),
    [anon_sym_where] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(5552),
    [anon_sym_COLON] = ACTIONS(5552),
    [anon_sym_PIPE] = ACTIONS(5552),
    [anon_sym_COLON_EQ] = ACTIONS(5550),
    [anon_sym_LPAREN] = ACTIONS(5550),
    [anon_sym_PLUS_EQ] = ACTIONS(5550),
    [anon_sym_DASH_EQ] = ACTIONS(5550),
    [anon_sym_STAR_EQ] = ACTIONS(5550),
    [anon_sym_SLASH_EQ] = ACTIONS(5550),
    [anon_sym_PERCENT_EQ] = ACTIONS(5550),
    [anon_sym_AMP_EQ] = ACTIONS(5550),
    [anon_sym_PIPE_EQ] = ACTIONS(5550),
    [anon_sym_CARET_EQ] = ACTIONS(5550),
    [anon_sym_LT_LT_EQ] = ACTIONS(5550),
    [anon_sym_GT_GT_EQ] = ACTIONS(5550),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5550),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5550),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5550),
    [anon_sym_if] = ACTIONS(5550),
    [anon_sym_SEMI] = ACTIONS(5550),
    [anon_sym_else] = ACTIONS(5550),
    [anon_sym_when] = ACTIONS(5550),
    [anon_sym_in] = ACTIONS(5550),
    [anon_sym_case] = ACTIONS(5550),
    [anon_sym_QMARK] = ACTIONS(5550),
    [anon_sym_PLUS] = ACTIONS(5552),
    [anon_sym_DASH] = ACTIONS(5552),
    [anon_sym_TILDE] = ACTIONS(5552),
    [anon_sym_AMP] = ACTIONS(5552),
    [anon_sym_PIPE_PIPE] = ACTIONS(5552),
    [anon_sym_or_else] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5550),
    [anon_sym_LT_EQ] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_EQ_EQ] = ACTIONS(5550),
    [anon_sym_BANG_EQ] = ACTIONS(5550),
    [anon_sym_TILDE_EQ] = ACTIONS(5550),
    [anon_sym_AMP_TILDE] = ACTIONS(5552),
    [anon_sym_LT_LT] = ACTIONS(5552),
    [anon_sym_GT_GT] = ACTIONS(5552),
    [anon_sym_STAR] = ACTIONS(5552),
    [anon_sym_SLASH] = ACTIONS(5552),
    [anon_sym_PERCENT] = ACTIONS(5552),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5550),
    [anon_sym_DOT] = ACTIONS(5552),
    [anon_sym_LBRACK] = ACTIONS(5550),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5550),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5550),
    [anon_sym_not_in] = ACTIONS(5550),
    [anon_sym_or_return] = ACTIONS(5550),
    [anon_sym_or_continue] = ACTIONS(5550),
    [anon_sym_or_break] = ACTIONS(5550),
    [anon_sym_CARET] = ACTIONS(5552),
    [sym_uninitialized] = ACTIONS(5550),
    [sym_tag] = ACTIONS(5550),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5550),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1076] = {
    [ts_builtin_sym_end] = ACTIONS(5554),
    [anon_sym_LBRACE] = ACTIONS(5554),
    [anon_sym_RBRACE] = ACTIONS(5554),
    [anon_sym_COMMA] = ACTIONS(5554),
    [anon_sym_COLON_COLON] = ACTIONS(5554),
    [anon_sym_DASH_GT] = ACTIONS(5554),
    [anon_sym_where] = ACTIONS(5554),
    [anon_sym_EQ] = ACTIONS(5556),
    [anon_sym_COLON] = ACTIONS(5556),
    [anon_sym_PIPE] = ACTIONS(5556),
    [anon_sym_COLON_EQ] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(5554),
    [anon_sym_PLUS_EQ] = ACTIONS(5554),
    [anon_sym_DASH_EQ] = ACTIONS(5554),
    [anon_sym_STAR_EQ] = ACTIONS(5554),
    [anon_sym_SLASH_EQ] = ACTIONS(5554),
    [anon_sym_PERCENT_EQ] = ACTIONS(5554),
    [anon_sym_AMP_EQ] = ACTIONS(5554),
    [anon_sym_PIPE_EQ] = ACTIONS(5554),
    [anon_sym_CARET_EQ] = ACTIONS(5554),
    [anon_sym_LT_LT_EQ] = ACTIONS(5554),
    [anon_sym_GT_GT_EQ] = ACTIONS(5554),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5554),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5554),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5554),
    [anon_sym_if] = ACTIONS(5554),
    [anon_sym_SEMI] = ACTIONS(5554),
    [anon_sym_else] = ACTIONS(5554),
    [anon_sym_when] = ACTIONS(5554),
    [anon_sym_in] = ACTIONS(5554),
    [anon_sym_case] = ACTIONS(5554),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_PLUS] = ACTIONS(5556),
    [anon_sym_DASH] = ACTIONS(5556),
    [anon_sym_TILDE] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(5556),
    [anon_sym_PIPE_PIPE] = ACTIONS(5556),
    [anon_sym_or_else] = ACTIONS(5554),
    [anon_sym_AMP_AMP] = ACTIONS(5556),
    [anon_sym_GT] = ACTIONS(5556),
    [anon_sym_GT_EQ] = ACTIONS(5554),
    [anon_sym_LT_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(5556),
    [anon_sym_EQ_EQ] = ACTIONS(5554),
    [anon_sym_BANG_EQ] = ACTIONS(5554),
    [anon_sym_TILDE_EQ] = ACTIONS(5554),
    [anon_sym_AMP_TILDE] = ACTIONS(5556),
    [anon_sym_LT_LT] = ACTIONS(5556),
    [anon_sym_GT_GT] = ACTIONS(5556),
    [anon_sym_STAR] = ACTIONS(5556),
    [anon_sym_SLASH] = ACTIONS(5556),
    [anon_sym_PERCENT] = ACTIONS(5556),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5554),
    [anon_sym_DOT] = ACTIONS(5556),
    [anon_sym_LBRACK] = ACTIONS(5554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5554),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5554),
    [anon_sym_not_in] = ACTIONS(5554),
    [anon_sym_or_return] = ACTIONS(5554),
    [anon_sym_or_continue] = ACTIONS(5554),
    [anon_sym_or_break] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(5556),
    [sym_uninitialized] = ACTIONS(5554),
    [sym_tag] = ACTIONS(5554),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5554),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1077] = {
    [ts_builtin_sym_end] = ACTIONS(5558),
    [anon_sym_LBRACE] = ACTIONS(5558),
    [anon_sym_RBRACE] = ACTIONS(5558),
    [anon_sym_COMMA] = ACTIONS(5558),
    [anon_sym_COLON_COLON] = ACTIONS(5558),
    [anon_sym_DASH_GT] = ACTIONS(5558),
    [anon_sym_where] = ACTIONS(5558),
    [anon_sym_EQ] = ACTIONS(5560),
    [anon_sym_COLON] = ACTIONS(5560),
    [anon_sym_PIPE] = ACTIONS(5560),
    [anon_sym_COLON_EQ] = ACTIONS(5558),
    [anon_sym_LPAREN] = ACTIONS(5558),
    [anon_sym_PLUS_EQ] = ACTIONS(5558),
    [anon_sym_DASH_EQ] = ACTIONS(5558),
    [anon_sym_STAR_EQ] = ACTIONS(5558),
    [anon_sym_SLASH_EQ] = ACTIONS(5558),
    [anon_sym_PERCENT_EQ] = ACTIONS(5558),
    [anon_sym_AMP_EQ] = ACTIONS(5558),
    [anon_sym_PIPE_EQ] = ACTIONS(5558),
    [anon_sym_CARET_EQ] = ACTIONS(5558),
    [anon_sym_LT_LT_EQ] = ACTIONS(5558),
    [anon_sym_GT_GT_EQ] = ACTIONS(5558),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5558),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5558),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5558),
    [anon_sym_if] = ACTIONS(5558),
    [anon_sym_SEMI] = ACTIONS(5558),
    [anon_sym_else] = ACTIONS(5558),
    [anon_sym_when] = ACTIONS(5558),
    [anon_sym_in] = ACTIONS(5558),
    [anon_sym_case] = ACTIONS(5558),
    [anon_sym_QMARK] = ACTIONS(5558),
    [anon_sym_PLUS] = ACTIONS(5560),
    [anon_sym_DASH] = ACTIONS(5560),
    [anon_sym_TILDE] = ACTIONS(5560),
    [anon_sym_AMP] = ACTIONS(5560),
    [anon_sym_PIPE_PIPE] = ACTIONS(5560),
    [anon_sym_or_else] = ACTIONS(5558),
    [anon_sym_AMP_AMP] = ACTIONS(5560),
    [anon_sym_GT] = ACTIONS(5560),
    [anon_sym_GT_EQ] = ACTIONS(5558),
    [anon_sym_LT_EQ] = ACTIONS(5558),
    [anon_sym_LT] = ACTIONS(5560),
    [anon_sym_EQ_EQ] = ACTIONS(5558),
    [anon_sym_BANG_EQ] = ACTIONS(5558),
    [anon_sym_TILDE_EQ] = ACTIONS(5558),
    [anon_sym_AMP_TILDE] = ACTIONS(5560),
    [anon_sym_LT_LT] = ACTIONS(5560),
    [anon_sym_GT_GT] = ACTIONS(5560),
    [anon_sym_STAR] = ACTIONS(5560),
    [anon_sym_SLASH] = ACTIONS(5560),
    [anon_sym_PERCENT] = ACTIONS(5560),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5558),
    [anon_sym_DOT] = ACTIONS(5560),
    [anon_sym_LBRACK] = ACTIONS(5558),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5558),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5558),
    [anon_sym_not_in] = ACTIONS(5558),
    [anon_sym_or_return] = ACTIONS(5558),
    [anon_sym_or_continue] = ACTIONS(5558),
    [anon_sym_or_break] = ACTIONS(5558),
    [anon_sym_CARET] = ACTIONS(5560),
    [sym_uninitialized] = ACTIONS(5558),
    [sym_tag] = ACTIONS(5558),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5558),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1078] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5562),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1079] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7870),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5564),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1080] = {
    [sym_procedure] = STATE(6880),
    [sym_expression] = STATE(4843),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(4641),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1081] = {
    [ts_builtin_sym_end] = ACTIONS(5566),
    [anon_sym_LBRACE] = ACTIONS(5566),
    [anon_sym_RBRACE] = ACTIONS(5566),
    [anon_sym_COMMA] = ACTIONS(5566),
    [anon_sym_COLON_COLON] = ACTIONS(5566),
    [anon_sym_DASH_GT] = ACTIONS(5566),
    [anon_sym_where] = ACTIONS(5566),
    [anon_sym_EQ] = ACTIONS(5568),
    [anon_sym_COLON] = ACTIONS(5568),
    [anon_sym_PIPE] = ACTIONS(5568),
    [anon_sym_COLON_EQ] = ACTIONS(5566),
    [anon_sym_LPAREN] = ACTIONS(5566),
    [anon_sym_PLUS_EQ] = ACTIONS(5566),
    [anon_sym_DASH_EQ] = ACTIONS(5566),
    [anon_sym_STAR_EQ] = ACTIONS(5566),
    [anon_sym_SLASH_EQ] = ACTIONS(5566),
    [anon_sym_PERCENT_EQ] = ACTIONS(5566),
    [anon_sym_AMP_EQ] = ACTIONS(5566),
    [anon_sym_PIPE_EQ] = ACTIONS(5566),
    [anon_sym_CARET_EQ] = ACTIONS(5566),
    [anon_sym_LT_LT_EQ] = ACTIONS(5566),
    [anon_sym_GT_GT_EQ] = ACTIONS(5566),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5566),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5566),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5566),
    [anon_sym_if] = ACTIONS(5566),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_else] = ACTIONS(5566),
    [anon_sym_when] = ACTIONS(5566),
    [anon_sym_in] = ACTIONS(5566),
    [anon_sym_case] = ACTIONS(5566),
    [anon_sym_QMARK] = ACTIONS(5566),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_DASH] = ACTIONS(5568),
    [anon_sym_TILDE] = ACTIONS(5568),
    [anon_sym_AMP] = ACTIONS(5568),
    [anon_sym_PIPE_PIPE] = ACTIONS(5568),
    [anon_sym_or_else] = ACTIONS(5566),
    [anon_sym_AMP_AMP] = ACTIONS(5568),
    [anon_sym_GT] = ACTIONS(5568),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_LT_EQ] = ACTIONS(5566),
    [anon_sym_LT] = ACTIONS(5568),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5566),
    [anon_sym_TILDE_EQ] = ACTIONS(5566),
    [anon_sym_AMP_TILDE] = ACTIONS(5568),
    [anon_sym_LT_LT] = ACTIONS(5568),
    [anon_sym_GT_GT] = ACTIONS(5568),
    [anon_sym_STAR] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5568),
    [anon_sym_PERCENT] = ACTIONS(5568),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5566),
    [anon_sym_DOT] = ACTIONS(5568),
    [anon_sym_LBRACK] = ACTIONS(5566),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5566),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5566),
    [anon_sym_not_in] = ACTIONS(5566),
    [anon_sym_or_return] = ACTIONS(5566),
    [anon_sym_or_continue] = ACTIONS(5566),
    [anon_sym_or_break] = ACTIONS(5566),
    [anon_sym_CARET] = ACTIONS(5568),
    [sym_uninitialized] = ACTIONS(5566),
    [sym_tag] = ACTIONS(5566),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5566),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1082] = {
    [ts_builtin_sym_end] = ACTIONS(5570),
    [anon_sym_LBRACE] = ACTIONS(5570),
    [anon_sym_RBRACE] = ACTIONS(5570),
    [anon_sym_COMMA] = ACTIONS(5570),
    [anon_sym_COLON_COLON] = ACTIONS(5570),
    [anon_sym_DASH_GT] = ACTIONS(5570),
    [anon_sym_where] = ACTIONS(5570),
    [anon_sym_EQ] = ACTIONS(5572),
    [anon_sym_COLON] = ACTIONS(5572),
    [anon_sym_PIPE] = ACTIONS(5572),
    [anon_sym_COLON_EQ] = ACTIONS(5570),
    [anon_sym_LPAREN] = ACTIONS(5570),
    [anon_sym_PLUS_EQ] = ACTIONS(5570),
    [anon_sym_DASH_EQ] = ACTIONS(5570),
    [anon_sym_STAR_EQ] = ACTIONS(5570),
    [anon_sym_SLASH_EQ] = ACTIONS(5570),
    [anon_sym_PERCENT_EQ] = ACTIONS(5570),
    [anon_sym_AMP_EQ] = ACTIONS(5570),
    [anon_sym_PIPE_EQ] = ACTIONS(5570),
    [anon_sym_CARET_EQ] = ACTIONS(5570),
    [anon_sym_LT_LT_EQ] = ACTIONS(5570),
    [anon_sym_GT_GT_EQ] = ACTIONS(5570),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5570),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5570),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5570),
    [anon_sym_if] = ACTIONS(5570),
    [anon_sym_SEMI] = ACTIONS(5570),
    [anon_sym_else] = ACTIONS(5570),
    [anon_sym_when] = ACTIONS(5570),
    [anon_sym_in] = ACTIONS(5570),
    [anon_sym_case] = ACTIONS(5570),
    [anon_sym_QMARK] = ACTIONS(5570),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_DASH] = ACTIONS(5572),
    [anon_sym_TILDE] = ACTIONS(5572),
    [anon_sym_AMP] = ACTIONS(5572),
    [anon_sym_PIPE_PIPE] = ACTIONS(5572),
    [anon_sym_or_else] = ACTIONS(5570),
    [anon_sym_AMP_AMP] = ACTIONS(5572),
    [anon_sym_GT] = ACTIONS(5572),
    [anon_sym_GT_EQ] = ACTIONS(5570),
    [anon_sym_LT_EQ] = ACTIONS(5570),
    [anon_sym_LT] = ACTIONS(5572),
    [anon_sym_EQ_EQ] = ACTIONS(5570),
    [anon_sym_BANG_EQ] = ACTIONS(5570),
    [anon_sym_TILDE_EQ] = ACTIONS(5570),
    [anon_sym_AMP_TILDE] = ACTIONS(5572),
    [anon_sym_LT_LT] = ACTIONS(5572),
    [anon_sym_GT_GT] = ACTIONS(5572),
    [anon_sym_STAR] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5572),
    [anon_sym_PERCENT] = ACTIONS(5572),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5570),
    [anon_sym_DOT] = ACTIONS(5572),
    [anon_sym_LBRACK] = ACTIONS(5570),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5570),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5570),
    [anon_sym_not_in] = ACTIONS(5570),
    [anon_sym_or_return] = ACTIONS(5570),
    [anon_sym_or_continue] = ACTIONS(5570),
    [anon_sym_or_break] = ACTIONS(5570),
    [anon_sym_CARET] = ACTIONS(5572),
    [sym_uninitialized] = ACTIONS(5570),
    [sym_tag] = ACTIONS(5570),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5570),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1083] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7709),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5574),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1084] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5564),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1085] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7786),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5576),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1086] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5578),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1087] = {
    [sym_block] = STATE(2335),
    [ts_builtin_sym_end] = ACTIONS(3781),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3785),
    [anon_sym_COLON] = ACTIONS(3785),
    [anon_sym_PIPE] = ACTIONS(3785),
    [anon_sym_COLON_EQ] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_else] = ACTIONS(3781),
    [anon_sym_when] = ACTIONS(3781),
    [anon_sym_in] = ACTIONS(3781),
    [anon_sym_case] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(3785),
    [anon_sym_PIPE_PIPE] = ACTIONS(3785),
    [anon_sym_or_else] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3785),
    [anon_sym_GT] = ACTIONS(3785),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3781),
    [anon_sym_LT] = ACTIONS(3785),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE] = ACTIONS(3785),
    [anon_sym_LT_LT] = ACTIONS(3785),
    [anon_sym_GT_GT] = ACTIONS(3785),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_SLASH] = ACTIONS(3785),
    [anon_sym_PERCENT] = ACTIONS(3785),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3781),
    [anon_sym_not_in] = ACTIONS(3781),
    [anon_sym_or_return] = ACTIONS(3781),
    [anon_sym_or_continue] = ACTIONS(3781),
    [anon_sym_or_break] = ACTIONS(3781),
    [anon_sym_CARET] = ACTIONS(3785),
    [sym_uninitialized] = ACTIONS(4293),
    [sym_tag] = ACTIONS(4295),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3781),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1088] = {
    [ts_builtin_sym_end] = ACTIONS(5580),
    [anon_sym_LBRACE] = ACTIONS(5580),
    [anon_sym_RBRACE] = ACTIONS(5580),
    [anon_sym_COMMA] = ACTIONS(5580),
    [anon_sym_COLON_COLON] = ACTIONS(5580),
    [anon_sym_DASH_GT] = ACTIONS(5580),
    [anon_sym_where] = ACTIONS(5580),
    [anon_sym_EQ] = ACTIONS(5582),
    [anon_sym_COLON] = ACTIONS(5582),
    [anon_sym_PIPE] = ACTIONS(5582),
    [anon_sym_COLON_EQ] = ACTIONS(5580),
    [anon_sym_LPAREN] = ACTIONS(5580),
    [anon_sym_PLUS_EQ] = ACTIONS(5580),
    [anon_sym_DASH_EQ] = ACTIONS(5580),
    [anon_sym_STAR_EQ] = ACTIONS(5580),
    [anon_sym_SLASH_EQ] = ACTIONS(5580),
    [anon_sym_PERCENT_EQ] = ACTIONS(5580),
    [anon_sym_AMP_EQ] = ACTIONS(5580),
    [anon_sym_PIPE_EQ] = ACTIONS(5580),
    [anon_sym_CARET_EQ] = ACTIONS(5580),
    [anon_sym_LT_LT_EQ] = ACTIONS(5580),
    [anon_sym_GT_GT_EQ] = ACTIONS(5580),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5580),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5580),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5580),
    [anon_sym_if] = ACTIONS(5580),
    [anon_sym_SEMI] = ACTIONS(5580),
    [anon_sym_else] = ACTIONS(5580),
    [anon_sym_when] = ACTIONS(5580),
    [anon_sym_in] = ACTIONS(5580),
    [anon_sym_case] = ACTIONS(5580),
    [anon_sym_QMARK] = ACTIONS(5580),
    [anon_sym_PLUS] = ACTIONS(5582),
    [anon_sym_DASH] = ACTIONS(5582),
    [anon_sym_TILDE] = ACTIONS(5582),
    [anon_sym_AMP] = ACTIONS(5582),
    [anon_sym_PIPE_PIPE] = ACTIONS(5582),
    [anon_sym_or_else] = ACTIONS(5580),
    [anon_sym_AMP_AMP] = ACTIONS(5582),
    [anon_sym_GT] = ACTIONS(5582),
    [anon_sym_GT_EQ] = ACTIONS(5580),
    [anon_sym_LT_EQ] = ACTIONS(5580),
    [anon_sym_LT] = ACTIONS(5582),
    [anon_sym_EQ_EQ] = ACTIONS(5580),
    [anon_sym_BANG_EQ] = ACTIONS(5580),
    [anon_sym_TILDE_EQ] = ACTIONS(5580),
    [anon_sym_AMP_TILDE] = ACTIONS(5582),
    [anon_sym_LT_LT] = ACTIONS(5582),
    [anon_sym_GT_GT] = ACTIONS(5582),
    [anon_sym_STAR] = ACTIONS(5582),
    [anon_sym_SLASH] = ACTIONS(5582),
    [anon_sym_PERCENT] = ACTIONS(5582),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5580),
    [anon_sym_DOT] = ACTIONS(5582),
    [anon_sym_LBRACK] = ACTIONS(5580),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5580),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5580),
    [anon_sym_not_in] = ACTIONS(5580),
    [anon_sym_or_return] = ACTIONS(5580),
    [anon_sym_or_continue] = ACTIONS(5580),
    [anon_sym_or_break] = ACTIONS(5580),
    [anon_sym_CARET] = ACTIONS(5582),
    [sym_uninitialized] = ACTIONS(5580),
    [sym_tag] = ACTIONS(5580),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5580),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1089] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5584),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1090] = {
    [ts_builtin_sym_end] = ACTIONS(5586),
    [anon_sym_LBRACE] = ACTIONS(5586),
    [anon_sym_RBRACE] = ACTIONS(5586),
    [anon_sym_COMMA] = ACTIONS(5586),
    [anon_sym_COLON_COLON] = ACTIONS(5586),
    [anon_sym_DASH_GT] = ACTIONS(5586),
    [anon_sym_where] = ACTIONS(5586),
    [anon_sym_EQ] = ACTIONS(5588),
    [anon_sym_COLON] = ACTIONS(5588),
    [anon_sym_PIPE] = ACTIONS(5588),
    [anon_sym_COLON_EQ] = ACTIONS(5586),
    [anon_sym_LPAREN] = ACTIONS(5586),
    [anon_sym_PLUS_EQ] = ACTIONS(5586),
    [anon_sym_DASH_EQ] = ACTIONS(5586),
    [anon_sym_STAR_EQ] = ACTIONS(5586),
    [anon_sym_SLASH_EQ] = ACTIONS(5586),
    [anon_sym_PERCENT_EQ] = ACTIONS(5586),
    [anon_sym_AMP_EQ] = ACTIONS(5586),
    [anon_sym_PIPE_EQ] = ACTIONS(5586),
    [anon_sym_CARET_EQ] = ACTIONS(5586),
    [anon_sym_LT_LT_EQ] = ACTIONS(5586),
    [anon_sym_GT_GT_EQ] = ACTIONS(5586),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5586),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5586),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5586),
    [anon_sym_if] = ACTIONS(5586),
    [anon_sym_SEMI] = ACTIONS(5586),
    [anon_sym_else] = ACTIONS(5586),
    [anon_sym_when] = ACTIONS(5586),
    [anon_sym_in] = ACTIONS(5586),
    [anon_sym_case] = ACTIONS(5586),
    [anon_sym_QMARK] = ACTIONS(5586),
    [anon_sym_PLUS] = ACTIONS(5588),
    [anon_sym_DASH] = ACTIONS(5588),
    [anon_sym_TILDE] = ACTIONS(5588),
    [anon_sym_AMP] = ACTIONS(5588),
    [anon_sym_PIPE_PIPE] = ACTIONS(5588),
    [anon_sym_or_else] = ACTIONS(5586),
    [anon_sym_AMP_AMP] = ACTIONS(5588),
    [anon_sym_GT] = ACTIONS(5588),
    [anon_sym_GT_EQ] = ACTIONS(5586),
    [anon_sym_LT_EQ] = ACTIONS(5586),
    [anon_sym_LT] = ACTIONS(5588),
    [anon_sym_EQ_EQ] = ACTIONS(5586),
    [anon_sym_BANG_EQ] = ACTIONS(5586),
    [anon_sym_TILDE_EQ] = ACTIONS(5586),
    [anon_sym_AMP_TILDE] = ACTIONS(5588),
    [anon_sym_LT_LT] = ACTIONS(5588),
    [anon_sym_GT_GT] = ACTIONS(5588),
    [anon_sym_STAR] = ACTIONS(5588),
    [anon_sym_SLASH] = ACTIONS(5588),
    [anon_sym_PERCENT] = ACTIONS(5588),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5586),
    [anon_sym_DOT] = ACTIONS(5588),
    [anon_sym_LBRACK] = ACTIONS(5586),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5586),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5586),
    [anon_sym_not_in] = ACTIONS(5586),
    [anon_sym_or_return] = ACTIONS(5586),
    [anon_sym_or_continue] = ACTIONS(5586),
    [anon_sym_or_break] = ACTIONS(5586),
    [anon_sym_CARET] = ACTIONS(5588),
    [sym_uninitialized] = ACTIONS(5586),
    [sym_tag] = ACTIONS(5586),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5586),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1091] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7821),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5578),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1092] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5590),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1093] = {
    [sym_block] = STATE(2373),
    [ts_builtin_sym_end] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_else] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(4201),
    [sym_tag] = ACTIONS(5592),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3415),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1094] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7790),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1095] = {
    [sym_block] = STATE(2170),
    [ts_builtin_sym_end] = ACTIONS(4667),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(4667),
    [anon_sym_COMMA] = ACTIONS(4667),
    [anon_sym_COLON_COLON] = ACTIONS(4667),
    [anon_sym_DASH_GT] = ACTIONS(4667),
    [anon_sym_EQ] = ACTIONS(4669),
    [anon_sym_COLON] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4669),
    [anon_sym_COLON_EQ] = ACTIONS(4667),
    [anon_sym_LPAREN] = ACTIONS(4667),
    [anon_sym_PLUS_EQ] = ACTIONS(4667),
    [anon_sym_DASH_EQ] = ACTIONS(4667),
    [anon_sym_STAR_EQ] = ACTIONS(4667),
    [anon_sym_SLASH_EQ] = ACTIONS(4667),
    [anon_sym_PERCENT_EQ] = ACTIONS(4667),
    [anon_sym_AMP_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_CARET_EQ] = ACTIONS(4667),
    [anon_sym_LT_LT_EQ] = ACTIONS(4667),
    [anon_sym_GT_GT_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_if] = ACTIONS(4667),
    [anon_sym_SEMI] = ACTIONS(4667),
    [anon_sym_else] = ACTIONS(4667),
    [anon_sym_when] = ACTIONS(4667),
    [anon_sym_in] = ACTIONS(4667),
    [anon_sym_case] = ACTIONS(4667),
    [anon_sym_QMARK] = ACTIONS(4667),
    [anon_sym_PLUS] = ACTIONS(4669),
    [anon_sym_DASH] = ACTIONS(4669),
    [anon_sym_TILDE] = ACTIONS(4669),
    [anon_sym_AMP] = ACTIONS(4669),
    [anon_sym_PIPE_PIPE] = ACTIONS(4669),
    [anon_sym_or_else] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_GT] = ACTIONS(4669),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_LT_EQ] = ACTIONS(4667),
    [anon_sym_LT] = ACTIONS(4669),
    [anon_sym_EQ_EQ] = ACTIONS(4667),
    [anon_sym_BANG_EQ] = ACTIONS(4667),
    [anon_sym_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE] = ACTIONS(4669),
    [anon_sym_LT_LT] = ACTIONS(4669),
    [anon_sym_GT_GT] = ACTIONS(4669),
    [anon_sym_STAR] = ACTIONS(4669),
    [anon_sym_SLASH] = ACTIONS(4669),
    [anon_sym_PERCENT] = ACTIONS(4669),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4667),
    [anon_sym_DOT] = ACTIONS(4669),
    [anon_sym_LBRACK] = ACTIONS(4667),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4667),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4667),
    [anon_sym_not_in] = ACTIONS(4667),
    [anon_sym_or_return] = ACTIONS(4667),
    [anon_sym_or_continue] = ACTIONS(4667),
    [anon_sym_or_break] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [sym_uninitialized] = ACTIONS(5596),
    [sym_tag] = ACTIONS(5598),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4667),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1096] = {
    [ts_builtin_sym_end] = ACTIONS(5600),
    [anon_sym_LBRACE] = ACTIONS(5600),
    [anon_sym_RBRACE] = ACTIONS(5600),
    [anon_sym_COMMA] = ACTIONS(5600),
    [anon_sym_COLON_COLON] = ACTIONS(5600),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5600),
    [anon_sym_EQ] = ACTIONS(5602),
    [anon_sym_COLON] = ACTIONS(5602),
    [anon_sym_PIPE] = ACTIONS(5602),
    [anon_sym_COLON_EQ] = ACTIONS(5600),
    [anon_sym_LPAREN] = ACTIONS(5600),
    [anon_sym_PLUS_EQ] = ACTIONS(5600),
    [anon_sym_DASH_EQ] = ACTIONS(5600),
    [anon_sym_STAR_EQ] = ACTIONS(5600),
    [anon_sym_SLASH_EQ] = ACTIONS(5600),
    [anon_sym_PERCENT_EQ] = ACTIONS(5600),
    [anon_sym_AMP_EQ] = ACTIONS(5600),
    [anon_sym_PIPE_EQ] = ACTIONS(5600),
    [anon_sym_CARET_EQ] = ACTIONS(5600),
    [anon_sym_LT_LT_EQ] = ACTIONS(5600),
    [anon_sym_GT_GT_EQ] = ACTIONS(5600),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5600),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5600),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5600),
    [anon_sym_if] = ACTIONS(5600),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_else] = ACTIONS(5600),
    [anon_sym_when] = ACTIONS(5600),
    [anon_sym_in] = ACTIONS(5600),
    [anon_sym_case] = ACTIONS(5600),
    [anon_sym_QMARK] = ACTIONS(5600),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_DASH] = ACTIONS(5602),
    [anon_sym_TILDE] = ACTIONS(5602),
    [anon_sym_AMP] = ACTIONS(5602),
    [anon_sym_PIPE_PIPE] = ACTIONS(5602),
    [anon_sym_or_else] = ACTIONS(5600),
    [anon_sym_AMP_AMP] = ACTIONS(5602),
    [anon_sym_GT] = ACTIONS(5602),
    [anon_sym_GT_EQ] = ACTIONS(5600),
    [anon_sym_LT_EQ] = ACTIONS(5600),
    [anon_sym_LT] = ACTIONS(5602),
    [anon_sym_EQ_EQ] = ACTIONS(5600),
    [anon_sym_BANG_EQ] = ACTIONS(5600),
    [anon_sym_TILDE_EQ] = ACTIONS(5600),
    [anon_sym_AMP_TILDE] = ACTIONS(5602),
    [anon_sym_LT_LT] = ACTIONS(5602),
    [anon_sym_GT_GT] = ACTIONS(5602),
    [anon_sym_STAR] = ACTIONS(5602),
    [anon_sym_SLASH] = ACTIONS(5602),
    [anon_sym_PERCENT] = ACTIONS(5602),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5600),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5600),
    [anon_sym_or_return] = ACTIONS(5600),
    [anon_sym_or_continue] = ACTIONS(5600),
    [anon_sym_or_break] = ACTIONS(5600),
    [anon_sym_CARET] = ACTIONS(5602),
    [sym_uninitialized] = ACTIONS(5600),
    [sym_tag] = ACTIONS(5600),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5600),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1097] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5604),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1098] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1099] = {
    [ts_builtin_sym_end] = ACTIONS(201),
    [anon_sym_LBRACE] = ACTIONS(201),
    [anon_sym_RBRACE] = ACTIONS(201),
    [anon_sym_COMMA] = ACTIONS(201),
    [anon_sym_COLON_COLON] = ACTIONS(201),
    [anon_sym_DASH_GT] = ACTIONS(201),
    [anon_sym_where] = ACTIONS(201),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(203),
    [anon_sym_PIPE] = ACTIONS(203),
    [anon_sym_COLON_EQ] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_PLUS_EQ] = ACTIONS(201),
    [anon_sym_DASH_EQ] = ACTIONS(201),
    [anon_sym_STAR_EQ] = ACTIONS(201),
    [anon_sym_SLASH_EQ] = ACTIONS(201),
    [anon_sym_PERCENT_EQ] = ACTIONS(201),
    [anon_sym_AMP_EQ] = ACTIONS(201),
    [anon_sym_PIPE_EQ] = ACTIONS(201),
    [anon_sym_CARET_EQ] = ACTIONS(201),
    [anon_sym_LT_LT_EQ] = ACTIONS(201),
    [anon_sym_GT_GT_EQ] = ACTIONS(201),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(201),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(201),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(201),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(201),
    [anon_sym_else] = ACTIONS(201),
    [anon_sym_when] = ACTIONS(201),
    [anon_sym_in] = ACTIONS(201),
    [anon_sym_case] = ACTIONS(201),
    [anon_sym_QMARK] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(203),
    [anon_sym_TILDE] = ACTIONS(203),
    [anon_sym_AMP] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(203),
    [anon_sym_or_else] = ACTIONS(201),
    [anon_sym_AMP_AMP] = ACTIONS(203),
    [anon_sym_GT] = ACTIONS(203),
    [anon_sym_GT_EQ] = ACTIONS(201),
    [anon_sym_LT_EQ] = ACTIONS(201),
    [anon_sym_LT] = ACTIONS(203),
    [anon_sym_EQ_EQ] = ACTIONS(201),
    [anon_sym_BANG_EQ] = ACTIONS(201),
    [anon_sym_TILDE_EQ] = ACTIONS(201),
    [anon_sym_AMP_TILDE] = ACTIONS(203),
    [anon_sym_LT_LT] = ACTIONS(203),
    [anon_sym_GT_GT] = ACTIONS(203),
    [anon_sym_STAR] = ACTIONS(203),
    [anon_sym_SLASH] = ACTIONS(203),
    [anon_sym_PERCENT] = ACTIONS(203),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(201),
    [anon_sym_DOT] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(201),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(201),
    [anon_sym_DOT_DOT_LT] = ACTIONS(201),
    [anon_sym_not_in] = ACTIONS(201),
    [anon_sym_or_return] = ACTIONS(201),
    [anon_sym_or_continue] = ACTIONS(201),
    [anon_sym_or_break] = ACTIONS(201),
    [anon_sym_CARET] = ACTIONS(203),
    [sym_uninitialized] = ACTIONS(201),
    [sym_tag] = ACTIONS(201),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(201),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1100] = {
    [ts_builtin_sym_end] = ACTIONS(5606),
    [anon_sym_LBRACE] = ACTIONS(5606),
    [anon_sym_RBRACE] = ACTIONS(5606),
    [anon_sym_COMMA] = ACTIONS(5606),
    [anon_sym_COLON_COLON] = ACTIONS(5606),
    [anon_sym_DASH_GT] = ACTIONS(5606),
    [anon_sym_where] = ACTIONS(5606),
    [anon_sym_EQ] = ACTIONS(5608),
    [anon_sym_COLON] = ACTIONS(5608),
    [anon_sym_PIPE] = ACTIONS(5608),
    [anon_sym_COLON_EQ] = ACTIONS(5606),
    [anon_sym_LPAREN] = ACTIONS(5606),
    [anon_sym_PLUS_EQ] = ACTIONS(5606),
    [anon_sym_DASH_EQ] = ACTIONS(5606),
    [anon_sym_STAR_EQ] = ACTIONS(5606),
    [anon_sym_SLASH_EQ] = ACTIONS(5606),
    [anon_sym_PERCENT_EQ] = ACTIONS(5606),
    [anon_sym_AMP_EQ] = ACTIONS(5606),
    [anon_sym_PIPE_EQ] = ACTIONS(5606),
    [anon_sym_CARET_EQ] = ACTIONS(5606),
    [anon_sym_LT_LT_EQ] = ACTIONS(5606),
    [anon_sym_GT_GT_EQ] = ACTIONS(5606),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5606),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5606),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5606),
    [anon_sym_if] = ACTIONS(5606),
    [anon_sym_SEMI] = ACTIONS(5606),
    [anon_sym_else] = ACTIONS(5606),
    [anon_sym_when] = ACTIONS(5606),
    [anon_sym_in] = ACTIONS(5606),
    [anon_sym_case] = ACTIONS(5606),
    [anon_sym_QMARK] = ACTIONS(5606),
    [anon_sym_PLUS] = ACTIONS(5608),
    [anon_sym_DASH] = ACTIONS(5608),
    [anon_sym_TILDE] = ACTIONS(5608),
    [anon_sym_AMP] = ACTIONS(5608),
    [anon_sym_PIPE_PIPE] = ACTIONS(5608),
    [anon_sym_or_else] = ACTIONS(5606),
    [anon_sym_AMP_AMP] = ACTIONS(5608),
    [anon_sym_GT] = ACTIONS(5608),
    [anon_sym_GT_EQ] = ACTIONS(5606),
    [anon_sym_LT_EQ] = ACTIONS(5606),
    [anon_sym_LT] = ACTIONS(5608),
    [anon_sym_EQ_EQ] = ACTIONS(5606),
    [anon_sym_BANG_EQ] = ACTIONS(5606),
    [anon_sym_TILDE_EQ] = ACTIONS(5606),
    [anon_sym_AMP_TILDE] = ACTIONS(5608),
    [anon_sym_LT_LT] = ACTIONS(5608),
    [anon_sym_GT_GT] = ACTIONS(5608),
    [anon_sym_STAR] = ACTIONS(5608),
    [anon_sym_SLASH] = ACTIONS(5608),
    [anon_sym_PERCENT] = ACTIONS(5608),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5606),
    [anon_sym_DOT] = ACTIONS(5608),
    [anon_sym_LBRACK] = ACTIONS(5606),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5606),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5606),
    [anon_sym_not_in] = ACTIONS(5606),
    [anon_sym_or_return] = ACTIONS(5606),
    [anon_sym_or_continue] = ACTIONS(5606),
    [anon_sym_or_break] = ACTIONS(5606),
    [anon_sym_CARET] = ACTIONS(5608),
    [sym_uninitialized] = ACTIONS(5606),
    [sym_tag] = ACTIONS(5606),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5606),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1101] = {
    [ts_builtin_sym_end] = ACTIONS(5610),
    [anon_sym_LBRACE] = ACTIONS(5610),
    [anon_sym_RBRACE] = ACTIONS(5610),
    [anon_sym_COMMA] = ACTIONS(5610),
    [anon_sym_COLON_COLON] = ACTIONS(5610),
    [anon_sym_DASH_GT] = ACTIONS(5610),
    [anon_sym_where] = ACTIONS(5610),
    [anon_sym_EQ] = ACTIONS(5612),
    [anon_sym_COLON] = ACTIONS(5612),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_COLON_EQ] = ACTIONS(5610),
    [anon_sym_LPAREN] = ACTIONS(5610),
    [anon_sym_PLUS_EQ] = ACTIONS(5610),
    [anon_sym_DASH_EQ] = ACTIONS(5610),
    [anon_sym_STAR_EQ] = ACTIONS(5610),
    [anon_sym_SLASH_EQ] = ACTIONS(5610),
    [anon_sym_PERCENT_EQ] = ACTIONS(5610),
    [anon_sym_AMP_EQ] = ACTIONS(5610),
    [anon_sym_PIPE_EQ] = ACTIONS(5610),
    [anon_sym_CARET_EQ] = ACTIONS(5610),
    [anon_sym_LT_LT_EQ] = ACTIONS(5610),
    [anon_sym_GT_GT_EQ] = ACTIONS(5610),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5610),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5610),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5610),
    [anon_sym_if] = ACTIONS(5610),
    [anon_sym_SEMI] = ACTIONS(5610),
    [anon_sym_else] = ACTIONS(5610),
    [anon_sym_when] = ACTIONS(5610),
    [anon_sym_in] = ACTIONS(5610),
    [anon_sym_case] = ACTIONS(5610),
    [anon_sym_QMARK] = ACTIONS(5610),
    [anon_sym_PLUS] = ACTIONS(5612),
    [anon_sym_DASH] = ACTIONS(5612),
    [anon_sym_TILDE] = ACTIONS(5612),
    [anon_sym_AMP] = ACTIONS(5612),
    [anon_sym_PIPE_PIPE] = ACTIONS(5612),
    [anon_sym_or_else] = ACTIONS(5610),
    [anon_sym_AMP_AMP] = ACTIONS(5612),
    [anon_sym_GT] = ACTIONS(5612),
    [anon_sym_GT_EQ] = ACTIONS(5610),
    [anon_sym_LT_EQ] = ACTIONS(5610),
    [anon_sym_LT] = ACTIONS(5612),
    [anon_sym_EQ_EQ] = ACTIONS(5610),
    [anon_sym_BANG_EQ] = ACTIONS(5610),
    [anon_sym_TILDE_EQ] = ACTIONS(5610),
    [anon_sym_AMP_TILDE] = ACTIONS(5612),
    [anon_sym_LT_LT] = ACTIONS(5612),
    [anon_sym_GT_GT] = ACTIONS(5612),
    [anon_sym_STAR] = ACTIONS(5612),
    [anon_sym_SLASH] = ACTIONS(5612),
    [anon_sym_PERCENT] = ACTIONS(5612),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(5612),
    [anon_sym_LBRACK] = ACTIONS(5610),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5610),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5610),
    [anon_sym_not_in] = ACTIONS(5610),
    [anon_sym_or_return] = ACTIONS(5610),
    [anon_sym_or_continue] = ACTIONS(5610),
    [anon_sym_or_break] = ACTIONS(5610),
    [anon_sym_CARET] = ACTIONS(5612),
    [sym_uninitialized] = ACTIONS(5610),
    [sym_tag] = ACTIONS(5610),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5610),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1102] = {
    [sym_block] = STATE(2404),
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(4087),
    [sym_tag] = ACTIONS(4089),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4083),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1103] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5614),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1104] = {
    [ts_builtin_sym_end] = ACTIONS(5616),
    [anon_sym_LBRACE] = ACTIONS(5616),
    [anon_sym_RBRACE] = ACTIONS(5616),
    [anon_sym_COMMA] = ACTIONS(5616),
    [anon_sym_COLON_COLON] = ACTIONS(5616),
    [anon_sym_DASH_GT] = ACTIONS(5616),
    [anon_sym_where] = ACTIONS(5616),
    [anon_sym_EQ] = ACTIONS(5618),
    [anon_sym_COLON] = ACTIONS(5618),
    [anon_sym_PIPE] = ACTIONS(5618),
    [anon_sym_COLON_EQ] = ACTIONS(5616),
    [anon_sym_LPAREN] = ACTIONS(5616),
    [anon_sym_PLUS_EQ] = ACTIONS(5616),
    [anon_sym_DASH_EQ] = ACTIONS(5616),
    [anon_sym_STAR_EQ] = ACTIONS(5616),
    [anon_sym_SLASH_EQ] = ACTIONS(5616),
    [anon_sym_PERCENT_EQ] = ACTIONS(5616),
    [anon_sym_AMP_EQ] = ACTIONS(5616),
    [anon_sym_PIPE_EQ] = ACTIONS(5616),
    [anon_sym_CARET_EQ] = ACTIONS(5616),
    [anon_sym_LT_LT_EQ] = ACTIONS(5616),
    [anon_sym_GT_GT_EQ] = ACTIONS(5616),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5616),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5616),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5616),
    [anon_sym_if] = ACTIONS(5616),
    [anon_sym_SEMI] = ACTIONS(5616),
    [anon_sym_else] = ACTIONS(5616),
    [anon_sym_when] = ACTIONS(5616),
    [anon_sym_in] = ACTIONS(5616),
    [anon_sym_case] = ACTIONS(5616),
    [anon_sym_QMARK] = ACTIONS(5616),
    [anon_sym_PLUS] = ACTIONS(5618),
    [anon_sym_DASH] = ACTIONS(5618),
    [anon_sym_TILDE] = ACTIONS(5618),
    [anon_sym_AMP] = ACTIONS(5618),
    [anon_sym_PIPE_PIPE] = ACTIONS(5618),
    [anon_sym_or_else] = ACTIONS(5616),
    [anon_sym_AMP_AMP] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_GT_EQ] = ACTIONS(5616),
    [anon_sym_LT_EQ] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_EQ_EQ] = ACTIONS(5616),
    [anon_sym_BANG_EQ] = ACTIONS(5616),
    [anon_sym_TILDE_EQ] = ACTIONS(5616),
    [anon_sym_AMP_TILDE] = ACTIONS(5618),
    [anon_sym_LT_LT] = ACTIONS(5618),
    [anon_sym_GT_GT] = ACTIONS(5618),
    [anon_sym_STAR] = ACTIONS(5618),
    [anon_sym_SLASH] = ACTIONS(5618),
    [anon_sym_PERCENT] = ACTIONS(5618),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5616),
    [anon_sym_DOT] = ACTIONS(5618),
    [anon_sym_LBRACK] = ACTIONS(5616),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5616),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5616),
    [anon_sym_not_in] = ACTIONS(5616),
    [anon_sym_or_return] = ACTIONS(5616),
    [anon_sym_or_continue] = ACTIONS(5616),
    [anon_sym_or_break] = ACTIONS(5616),
    [anon_sym_CARET] = ACTIONS(5618),
    [sym_uninitialized] = ACTIONS(5616),
    [sym_tag] = ACTIONS(5616),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5616),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1105] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7747),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5620),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1106] = {
    [sym_block] = STATE(2429),
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(4027),
    [sym_tag] = ACTIONS(4029),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4023),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1107] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7824),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5604),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1108] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5504),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1109] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7703),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5622),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1110] = {
    [ts_builtin_sym_end] = ACTIONS(5624),
    [anon_sym_LBRACE] = ACTIONS(5624),
    [anon_sym_RBRACE] = ACTIONS(5624),
    [anon_sym_COMMA] = ACTIONS(5624),
    [anon_sym_COLON_COLON] = ACTIONS(5624),
    [anon_sym_DASH_GT] = ACTIONS(5624),
    [anon_sym_where] = ACTIONS(5624),
    [anon_sym_EQ] = ACTIONS(5626),
    [anon_sym_COLON] = ACTIONS(5626),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_COLON_EQ] = ACTIONS(5624),
    [anon_sym_LPAREN] = ACTIONS(5624),
    [anon_sym_PLUS_EQ] = ACTIONS(5624),
    [anon_sym_DASH_EQ] = ACTIONS(5624),
    [anon_sym_STAR_EQ] = ACTIONS(5624),
    [anon_sym_SLASH_EQ] = ACTIONS(5624),
    [anon_sym_PERCENT_EQ] = ACTIONS(5624),
    [anon_sym_AMP_EQ] = ACTIONS(5624),
    [anon_sym_PIPE_EQ] = ACTIONS(5624),
    [anon_sym_CARET_EQ] = ACTIONS(5624),
    [anon_sym_LT_LT_EQ] = ACTIONS(5624),
    [anon_sym_GT_GT_EQ] = ACTIONS(5624),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5624),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5624),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5624),
    [anon_sym_if] = ACTIONS(5624),
    [anon_sym_SEMI] = ACTIONS(5624),
    [anon_sym_else] = ACTIONS(5624),
    [anon_sym_when] = ACTIONS(5624),
    [anon_sym_in] = ACTIONS(5624),
    [anon_sym_case] = ACTIONS(5624),
    [anon_sym_QMARK] = ACTIONS(5624),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_DASH] = ACTIONS(5626),
    [anon_sym_TILDE] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_or_else] = ACTIONS(5624),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_GT_EQ] = ACTIONS(5624),
    [anon_sym_LT_EQ] = ACTIONS(5624),
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_EQ_EQ] = ACTIONS(5624),
    [anon_sym_BANG_EQ] = ACTIONS(5624),
    [anon_sym_TILDE_EQ] = ACTIONS(5624),
    [anon_sym_AMP_TILDE] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5626),
    [anon_sym_GT_GT] = ACTIONS(5626),
    [anon_sym_STAR] = ACTIONS(5626),
    [anon_sym_SLASH] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5626),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5624),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_LBRACK] = ACTIONS(5624),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5624),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5624),
    [anon_sym_not_in] = ACTIONS(5624),
    [anon_sym_or_return] = ACTIONS(5624),
    [anon_sym_or_continue] = ACTIONS(5624),
    [anon_sym_or_break] = ACTIONS(5624),
    [anon_sym_CARET] = ACTIONS(5626),
    [sym_uninitialized] = ACTIONS(5624),
    [sym_tag] = ACTIONS(5624),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5624),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1111] = {
    [ts_builtin_sym_end] = ACTIONS(5628),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_COLON_COLON] = ACTIONS(5628),
    [anon_sym_DASH_GT] = ACTIONS(5628),
    [anon_sym_where] = ACTIONS(5628),
    [anon_sym_EQ] = ACTIONS(5630),
    [anon_sym_COLON] = ACTIONS(5630),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_COLON_EQ] = ACTIONS(5628),
    [anon_sym_LPAREN] = ACTIONS(5628),
    [anon_sym_PLUS_EQ] = ACTIONS(5628),
    [anon_sym_DASH_EQ] = ACTIONS(5628),
    [anon_sym_STAR_EQ] = ACTIONS(5628),
    [anon_sym_SLASH_EQ] = ACTIONS(5628),
    [anon_sym_PERCENT_EQ] = ACTIONS(5628),
    [anon_sym_AMP_EQ] = ACTIONS(5628),
    [anon_sym_PIPE_EQ] = ACTIONS(5628),
    [anon_sym_CARET_EQ] = ACTIONS(5628),
    [anon_sym_LT_LT_EQ] = ACTIONS(5628),
    [anon_sym_GT_GT_EQ] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5628),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5628),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5628),
    [anon_sym_if] = ACTIONS(5628),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_else] = ACTIONS(5628),
    [anon_sym_when] = ACTIONS(5628),
    [anon_sym_in] = ACTIONS(5628),
    [anon_sym_case] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_DASH] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(5630),
    [anon_sym_AMP] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE] = ACTIONS(5630),
    [anon_sym_or_else] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5630),
    [anon_sym_GT] = ACTIONS(5630),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5628),
    [anon_sym_LT] = ACTIONS(5630),
    [anon_sym_EQ_EQ] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_TILDE_EQ] = ACTIONS(5628),
    [anon_sym_AMP_TILDE] = ACTIONS(5630),
    [anon_sym_LT_LT] = ACTIONS(5630),
    [anon_sym_GT_GT] = ACTIONS(5630),
    [anon_sym_STAR] = ACTIONS(5630),
    [anon_sym_SLASH] = ACTIONS(5630),
    [anon_sym_PERCENT] = ACTIONS(5630),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5628),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5628),
    [anon_sym_not_in] = ACTIONS(5628),
    [anon_sym_or_return] = ACTIONS(5628),
    [anon_sym_or_continue] = ACTIONS(5628),
    [anon_sym_or_break] = ACTIONS(5628),
    [anon_sym_CARET] = ACTIONS(5630),
    [sym_uninitialized] = ACTIONS(5628),
    [sym_tag] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5628),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1112] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7861),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5632),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1113] = {
    [ts_builtin_sym_end] = ACTIONS(5634),
    [anon_sym_LBRACE] = ACTIONS(5634),
    [anon_sym_RBRACE] = ACTIONS(5634),
    [anon_sym_COMMA] = ACTIONS(5634),
    [anon_sym_COLON_COLON] = ACTIONS(5634),
    [anon_sym_DASH_GT] = ACTIONS(5634),
    [anon_sym_where] = ACTIONS(5634),
    [anon_sym_EQ] = ACTIONS(5636),
    [anon_sym_COLON] = ACTIONS(5636),
    [anon_sym_PIPE] = ACTIONS(5636),
    [anon_sym_COLON_EQ] = ACTIONS(5634),
    [anon_sym_LPAREN] = ACTIONS(5634),
    [anon_sym_PLUS_EQ] = ACTIONS(5634),
    [anon_sym_DASH_EQ] = ACTIONS(5634),
    [anon_sym_STAR_EQ] = ACTIONS(5634),
    [anon_sym_SLASH_EQ] = ACTIONS(5634),
    [anon_sym_PERCENT_EQ] = ACTIONS(5634),
    [anon_sym_AMP_EQ] = ACTIONS(5634),
    [anon_sym_PIPE_EQ] = ACTIONS(5634),
    [anon_sym_CARET_EQ] = ACTIONS(5634),
    [anon_sym_LT_LT_EQ] = ACTIONS(5634),
    [anon_sym_GT_GT_EQ] = ACTIONS(5634),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5634),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5634),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5634),
    [anon_sym_if] = ACTIONS(5634),
    [anon_sym_SEMI] = ACTIONS(5634),
    [anon_sym_else] = ACTIONS(5634),
    [anon_sym_when] = ACTIONS(5634),
    [anon_sym_in] = ACTIONS(5634),
    [anon_sym_case] = ACTIONS(5634),
    [anon_sym_QMARK] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_DASH] = ACTIONS(5636),
    [anon_sym_TILDE] = ACTIONS(5636),
    [anon_sym_AMP] = ACTIONS(5636),
    [anon_sym_PIPE_PIPE] = ACTIONS(5636),
    [anon_sym_or_else] = ACTIONS(5634),
    [anon_sym_AMP_AMP] = ACTIONS(5636),
    [anon_sym_GT] = ACTIONS(5636),
    [anon_sym_GT_EQ] = ACTIONS(5634),
    [anon_sym_LT_EQ] = ACTIONS(5634),
    [anon_sym_LT] = ACTIONS(5636),
    [anon_sym_EQ_EQ] = ACTIONS(5634),
    [anon_sym_BANG_EQ] = ACTIONS(5634),
    [anon_sym_TILDE_EQ] = ACTIONS(5634),
    [anon_sym_AMP_TILDE] = ACTIONS(5636),
    [anon_sym_LT_LT] = ACTIONS(5636),
    [anon_sym_GT_GT] = ACTIONS(5636),
    [anon_sym_STAR] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5636),
    [anon_sym_PERCENT] = ACTIONS(5636),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5634),
    [anon_sym_DOT] = ACTIONS(5636),
    [anon_sym_LBRACK] = ACTIONS(5634),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5634),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5634),
    [anon_sym_not_in] = ACTIONS(5634),
    [anon_sym_or_return] = ACTIONS(5634),
    [anon_sym_or_continue] = ACTIONS(5634),
    [anon_sym_or_break] = ACTIONS(5634),
    [anon_sym_CARET] = ACTIONS(5636),
    [sym_uninitialized] = ACTIONS(5634),
    [sym_tag] = ACTIONS(5634),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5634),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1114] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5638),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1115] = {
    [ts_builtin_sym_end] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(5640),
    [anon_sym_RBRACE] = ACTIONS(5640),
    [anon_sym_COMMA] = ACTIONS(5640),
    [anon_sym_COLON_COLON] = ACTIONS(5640),
    [anon_sym_DASH_GT] = ACTIONS(5640),
    [anon_sym_where] = ACTIONS(5640),
    [anon_sym_EQ] = ACTIONS(5642),
    [anon_sym_COLON] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5642),
    [anon_sym_COLON_EQ] = ACTIONS(5640),
    [anon_sym_LPAREN] = ACTIONS(5640),
    [anon_sym_PLUS_EQ] = ACTIONS(5640),
    [anon_sym_DASH_EQ] = ACTIONS(5640),
    [anon_sym_STAR_EQ] = ACTIONS(5640),
    [anon_sym_SLASH_EQ] = ACTIONS(5640),
    [anon_sym_PERCENT_EQ] = ACTIONS(5640),
    [anon_sym_AMP_EQ] = ACTIONS(5640),
    [anon_sym_PIPE_EQ] = ACTIONS(5640),
    [anon_sym_CARET_EQ] = ACTIONS(5640),
    [anon_sym_LT_LT_EQ] = ACTIONS(5640),
    [anon_sym_GT_GT_EQ] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5640),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5640),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5640),
    [anon_sym_if] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym_else] = ACTIONS(5640),
    [anon_sym_when] = ACTIONS(5640),
    [anon_sym_in] = ACTIONS(5640),
    [anon_sym_case] = ACTIONS(5640),
    [anon_sym_QMARK] = ACTIONS(5640),
    [anon_sym_PLUS] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5642),
    [anon_sym_TILDE] = ACTIONS(5642),
    [anon_sym_AMP] = ACTIONS(5642),
    [anon_sym_PIPE_PIPE] = ACTIONS(5642),
    [anon_sym_or_else] = ACTIONS(5640),
    [anon_sym_AMP_AMP] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5642),
    [anon_sym_GT_EQ] = ACTIONS(5640),
    [anon_sym_LT_EQ] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5642),
    [anon_sym_EQ_EQ] = ACTIONS(5640),
    [anon_sym_BANG_EQ] = ACTIONS(5640),
    [anon_sym_TILDE_EQ] = ACTIONS(5640),
    [anon_sym_AMP_TILDE] = ACTIONS(5642),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5642),
    [anon_sym_STAR] = ACTIONS(5642),
    [anon_sym_SLASH] = ACTIONS(5642),
    [anon_sym_PERCENT] = ACTIONS(5642),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5640),
    [anon_sym_DOT] = ACTIONS(5642),
    [anon_sym_LBRACK] = ACTIONS(5640),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5640),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5640),
    [anon_sym_not_in] = ACTIONS(5640),
    [anon_sym_or_return] = ACTIONS(5640),
    [anon_sym_or_continue] = ACTIONS(5640),
    [anon_sym_or_break] = ACTIONS(5640),
    [anon_sym_CARET] = ACTIONS(5642),
    [sym_uninitialized] = ACTIONS(5640),
    [sym_tag] = ACTIONS(5640),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5640),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1116] = {
    [ts_builtin_sym_end] = ACTIONS(5644),
    [anon_sym_LBRACE] = ACTIONS(5644),
    [anon_sym_RBRACE] = ACTIONS(5644),
    [anon_sym_COMMA] = ACTIONS(5644),
    [anon_sym_COLON_COLON] = ACTIONS(5644),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5644),
    [anon_sym_EQ] = ACTIONS(5646),
    [anon_sym_COLON] = ACTIONS(5646),
    [anon_sym_PIPE] = ACTIONS(5646),
    [anon_sym_COLON_EQ] = ACTIONS(5644),
    [anon_sym_LPAREN] = ACTIONS(5644),
    [anon_sym_PLUS_EQ] = ACTIONS(5644),
    [anon_sym_DASH_EQ] = ACTIONS(5644),
    [anon_sym_STAR_EQ] = ACTIONS(5644),
    [anon_sym_SLASH_EQ] = ACTIONS(5644),
    [anon_sym_PERCENT_EQ] = ACTIONS(5644),
    [anon_sym_AMP_EQ] = ACTIONS(5644),
    [anon_sym_PIPE_EQ] = ACTIONS(5644),
    [anon_sym_CARET_EQ] = ACTIONS(5644),
    [anon_sym_LT_LT_EQ] = ACTIONS(5644),
    [anon_sym_GT_GT_EQ] = ACTIONS(5644),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5644),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5644),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5644),
    [anon_sym_if] = ACTIONS(5644),
    [anon_sym_SEMI] = ACTIONS(5644),
    [anon_sym_else] = ACTIONS(5644),
    [anon_sym_when] = ACTIONS(5644),
    [anon_sym_in] = ACTIONS(5644),
    [anon_sym_case] = ACTIONS(5644),
    [anon_sym_QMARK] = ACTIONS(5644),
    [anon_sym_PLUS] = ACTIONS(5646),
    [anon_sym_DASH] = ACTIONS(5646),
    [anon_sym_TILDE] = ACTIONS(5646),
    [anon_sym_AMP] = ACTIONS(5646),
    [anon_sym_PIPE_PIPE] = ACTIONS(5646),
    [anon_sym_or_else] = ACTIONS(5644),
    [anon_sym_AMP_AMP] = ACTIONS(5646),
    [anon_sym_GT] = ACTIONS(5646),
    [anon_sym_GT_EQ] = ACTIONS(5644),
    [anon_sym_LT_EQ] = ACTIONS(5644),
    [anon_sym_LT] = ACTIONS(5646),
    [anon_sym_EQ_EQ] = ACTIONS(5644),
    [anon_sym_BANG_EQ] = ACTIONS(5644),
    [anon_sym_TILDE_EQ] = ACTIONS(5644),
    [anon_sym_AMP_TILDE] = ACTIONS(5646),
    [anon_sym_LT_LT] = ACTIONS(5646),
    [anon_sym_GT_GT] = ACTIONS(5646),
    [anon_sym_STAR] = ACTIONS(5646),
    [anon_sym_SLASH] = ACTIONS(5646),
    [anon_sym_PERCENT] = ACTIONS(5646),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5644),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5644),
    [anon_sym_or_return] = ACTIONS(5644),
    [anon_sym_or_continue] = ACTIONS(5644),
    [anon_sym_or_break] = ACTIONS(5644),
    [anon_sym_CARET] = ACTIONS(5646),
    [sym_uninitialized] = ACTIONS(5644),
    [sym_tag] = ACTIONS(5644),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5644),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1117] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5648),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1118] = {
    [ts_builtin_sym_end] = ACTIONS(5650),
    [anon_sym_LBRACE] = ACTIONS(5650),
    [anon_sym_RBRACE] = ACTIONS(5650),
    [anon_sym_COMMA] = ACTIONS(5650),
    [anon_sym_COLON_COLON] = ACTIONS(5650),
    [anon_sym_DASH_GT] = ACTIONS(5650),
    [anon_sym_where] = ACTIONS(5650),
    [anon_sym_EQ] = ACTIONS(5652),
    [anon_sym_COLON] = ACTIONS(5652),
    [anon_sym_PIPE] = ACTIONS(5652),
    [anon_sym_COLON_EQ] = ACTIONS(5650),
    [anon_sym_LPAREN] = ACTIONS(5650),
    [anon_sym_PLUS_EQ] = ACTIONS(5650),
    [anon_sym_DASH_EQ] = ACTIONS(5650),
    [anon_sym_STAR_EQ] = ACTIONS(5650),
    [anon_sym_SLASH_EQ] = ACTIONS(5650),
    [anon_sym_PERCENT_EQ] = ACTIONS(5650),
    [anon_sym_AMP_EQ] = ACTIONS(5650),
    [anon_sym_PIPE_EQ] = ACTIONS(5650),
    [anon_sym_CARET_EQ] = ACTIONS(5650),
    [anon_sym_LT_LT_EQ] = ACTIONS(5650),
    [anon_sym_GT_GT_EQ] = ACTIONS(5650),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5650),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5650),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5650),
    [anon_sym_if] = ACTIONS(5650),
    [anon_sym_SEMI] = ACTIONS(5650),
    [anon_sym_else] = ACTIONS(5650),
    [anon_sym_when] = ACTIONS(5650),
    [anon_sym_in] = ACTIONS(5650),
    [anon_sym_case] = ACTIONS(5650),
    [anon_sym_QMARK] = ACTIONS(5650),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_DASH] = ACTIONS(5652),
    [anon_sym_TILDE] = ACTIONS(5652),
    [anon_sym_AMP] = ACTIONS(5652),
    [anon_sym_PIPE_PIPE] = ACTIONS(5652),
    [anon_sym_or_else] = ACTIONS(5650),
    [anon_sym_AMP_AMP] = ACTIONS(5652),
    [anon_sym_GT] = ACTIONS(5652),
    [anon_sym_GT_EQ] = ACTIONS(5650),
    [anon_sym_LT_EQ] = ACTIONS(5650),
    [anon_sym_LT] = ACTIONS(5652),
    [anon_sym_EQ_EQ] = ACTIONS(5650),
    [anon_sym_BANG_EQ] = ACTIONS(5650),
    [anon_sym_TILDE_EQ] = ACTIONS(5650),
    [anon_sym_AMP_TILDE] = ACTIONS(5652),
    [anon_sym_LT_LT] = ACTIONS(5652),
    [anon_sym_GT_GT] = ACTIONS(5652),
    [anon_sym_STAR] = ACTIONS(5652),
    [anon_sym_SLASH] = ACTIONS(5652),
    [anon_sym_PERCENT] = ACTIONS(5652),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5650),
    [anon_sym_DOT] = ACTIONS(5652),
    [anon_sym_LBRACK] = ACTIONS(5650),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5650),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5650),
    [anon_sym_not_in] = ACTIONS(5650),
    [anon_sym_or_return] = ACTIONS(5650),
    [anon_sym_or_continue] = ACTIONS(5650),
    [anon_sym_or_break] = ACTIONS(5650),
    [anon_sym_CARET] = ACTIONS(5652),
    [sym_uninitialized] = ACTIONS(5650),
    [sym_tag] = ACTIONS(5650),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5650),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1119] = {
    [ts_builtin_sym_end] = ACTIONS(5654),
    [anon_sym_LBRACE] = ACTIONS(5654),
    [anon_sym_RBRACE] = ACTIONS(5654),
    [anon_sym_COMMA] = ACTIONS(5654),
    [anon_sym_COLON_COLON] = ACTIONS(5654),
    [anon_sym_DASH_GT] = ACTIONS(5654),
    [anon_sym_where] = ACTIONS(5654),
    [anon_sym_EQ] = ACTIONS(5656),
    [anon_sym_COLON] = ACTIONS(5656),
    [anon_sym_PIPE] = ACTIONS(5656),
    [anon_sym_COLON_EQ] = ACTIONS(5654),
    [anon_sym_LPAREN] = ACTIONS(5654),
    [anon_sym_PLUS_EQ] = ACTIONS(5654),
    [anon_sym_DASH_EQ] = ACTIONS(5654),
    [anon_sym_STAR_EQ] = ACTIONS(5654),
    [anon_sym_SLASH_EQ] = ACTIONS(5654),
    [anon_sym_PERCENT_EQ] = ACTIONS(5654),
    [anon_sym_AMP_EQ] = ACTIONS(5654),
    [anon_sym_PIPE_EQ] = ACTIONS(5654),
    [anon_sym_CARET_EQ] = ACTIONS(5654),
    [anon_sym_LT_LT_EQ] = ACTIONS(5654),
    [anon_sym_GT_GT_EQ] = ACTIONS(5654),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5654),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5654),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5654),
    [anon_sym_if] = ACTIONS(5654),
    [anon_sym_SEMI] = ACTIONS(5654),
    [anon_sym_else] = ACTIONS(5654),
    [anon_sym_when] = ACTIONS(5654),
    [anon_sym_in] = ACTIONS(5654),
    [anon_sym_case] = ACTIONS(5654),
    [anon_sym_QMARK] = ACTIONS(5654),
    [anon_sym_PLUS] = ACTIONS(5656),
    [anon_sym_DASH] = ACTIONS(5656),
    [anon_sym_TILDE] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5656),
    [anon_sym_PIPE_PIPE] = ACTIONS(5656),
    [anon_sym_or_else] = ACTIONS(5654),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_GT] = ACTIONS(5656),
    [anon_sym_GT_EQ] = ACTIONS(5654),
    [anon_sym_LT_EQ] = ACTIONS(5654),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_EQ_EQ] = ACTIONS(5654),
    [anon_sym_BANG_EQ] = ACTIONS(5654),
    [anon_sym_TILDE_EQ] = ACTIONS(5654),
    [anon_sym_AMP_TILDE] = ACTIONS(5656),
    [anon_sym_LT_LT] = ACTIONS(5656),
    [anon_sym_GT_GT] = ACTIONS(5656),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_SLASH] = ACTIONS(5656),
    [anon_sym_PERCENT] = ACTIONS(5656),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5654),
    [anon_sym_DOT] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5654),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5654),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5654),
    [anon_sym_not_in] = ACTIONS(5654),
    [anon_sym_or_return] = ACTIONS(5654),
    [anon_sym_or_continue] = ACTIONS(5654),
    [anon_sym_or_break] = ACTIONS(5654),
    [anon_sym_CARET] = ACTIONS(5656),
    [sym_uninitialized] = ACTIONS(5654),
    [sym_tag] = ACTIONS(5654),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5654),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1120] = {
    [ts_builtin_sym_end] = ACTIONS(5658),
    [anon_sym_LBRACE] = ACTIONS(5658),
    [anon_sym_RBRACE] = ACTIONS(5658),
    [anon_sym_COMMA] = ACTIONS(5658),
    [anon_sym_COLON_COLON] = ACTIONS(5658),
    [anon_sym_DASH_GT] = ACTIONS(5658),
    [anon_sym_where] = ACTIONS(5658),
    [anon_sym_EQ] = ACTIONS(5660),
    [anon_sym_COLON] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_COLON_EQ] = ACTIONS(5658),
    [anon_sym_LPAREN] = ACTIONS(5658),
    [anon_sym_PLUS_EQ] = ACTIONS(5658),
    [anon_sym_DASH_EQ] = ACTIONS(5658),
    [anon_sym_STAR_EQ] = ACTIONS(5658),
    [anon_sym_SLASH_EQ] = ACTIONS(5658),
    [anon_sym_PERCENT_EQ] = ACTIONS(5658),
    [anon_sym_AMP_EQ] = ACTIONS(5658),
    [anon_sym_PIPE_EQ] = ACTIONS(5658),
    [anon_sym_CARET_EQ] = ACTIONS(5658),
    [anon_sym_LT_LT_EQ] = ACTIONS(5658),
    [anon_sym_GT_GT_EQ] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5658),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5658),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5658),
    [anon_sym_if] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5658),
    [anon_sym_else] = ACTIONS(5658),
    [anon_sym_when] = ACTIONS(5658),
    [anon_sym_in] = ACTIONS(5658),
    [anon_sym_case] = ACTIONS(5658),
    [anon_sym_QMARK] = ACTIONS(5658),
    [anon_sym_PLUS] = ACTIONS(5660),
    [anon_sym_DASH] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(5660),
    [anon_sym_AMP] = ACTIONS(5660),
    [anon_sym_PIPE_PIPE] = ACTIONS(5660),
    [anon_sym_or_else] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_EQ] = ACTIONS(5658),
    [anon_sym_LT_EQ] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_EQ_EQ] = ACTIONS(5658),
    [anon_sym_BANG_EQ] = ACTIONS(5658),
    [anon_sym_TILDE_EQ] = ACTIONS(5658),
    [anon_sym_AMP_TILDE] = ACTIONS(5660),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5660),
    [anon_sym_STAR] = ACTIONS(5660),
    [anon_sym_SLASH] = ACTIONS(5660),
    [anon_sym_PERCENT] = ACTIONS(5660),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5658),
    [anon_sym_DOT] = ACTIONS(5660),
    [anon_sym_LBRACK] = ACTIONS(5658),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5658),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5658),
    [anon_sym_not_in] = ACTIONS(5658),
    [anon_sym_or_return] = ACTIONS(5658),
    [anon_sym_or_continue] = ACTIONS(5658),
    [anon_sym_or_break] = ACTIONS(5658),
    [anon_sym_CARET] = ACTIONS(5660),
    [sym_uninitialized] = ACTIONS(5658),
    [sym_tag] = ACTIONS(5658),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5658),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1121] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5662),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1122] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7618),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5664),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1123] = {
    [ts_builtin_sym_end] = ACTIONS(5666),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_RBRACE] = ACTIONS(5666),
    [anon_sym_COMMA] = ACTIONS(5666),
    [anon_sym_COLON_COLON] = ACTIONS(5666),
    [anon_sym_DASH_GT] = ACTIONS(5666),
    [anon_sym_where] = ACTIONS(5666),
    [anon_sym_EQ] = ACTIONS(5668),
    [anon_sym_COLON] = ACTIONS(5668),
    [anon_sym_PIPE] = ACTIONS(5668),
    [anon_sym_COLON_EQ] = ACTIONS(5666),
    [anon_sym_LPAREN] = ACTIONS(5666),
    [anon_sym_PLUS_EQ] = ACTIONS(5666),
    [anon_sym_DASH_EQ] = ACTIONS(5666),
    [anon_sym_STAR_EQ] = ACTIONS(5666),
    [anon_sym_SLASH_EQ] = ACTIONS(5666),
    [anon_sym_PERCENT_EQ] = ACTIONS(5666),
    [anon_sym_AMP_EQ] = ACTIONS(5666),
    [anon_sym_PIPE_EQ] = ACTIONS(5666),
    [anon_sym_CARET_EQ] = ACTIONS(5666),
    [anon_sym_LT_LT_EQ] = ACTIONS(5666),
    [anon_sym_GT_GT_EQ] = ACTIONS(5666),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5666),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5666),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5666),
    [anon_sym_if] = ACTIONS(5666),
    [anon_sym_SEMI] = ACTIONS(5666),
    [anon_sym_else] = ACTIONS(5666),
    [anon_sym_when] = ACTIONS(5666),
    [anon_sym_in] = ACTIONS(5666),
    [anon_sym_case] = ACTIONS(5666),
    [anon_sym_QMARK] = ACTIONS(5666),
    [anon_sym_PLUS] = ACTIONS(5668),
    [anon_sym_DASH] = ACTIONS(5668),
    [anon_sym_TILDE] = ACTIONS(5668),
    [anon_sym_AMP] = ACTIONS(5668),
    [anon_sym_PIPE_PIPE] = ACTIONS(5668),
    [anon_sym_or_else] = ACTIONS(5666),
    [anon_sym_AMP_AMP] = ACTIONS(5668),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_GT_EQ] = ACTIONS(5666),
    [anon_sym_LT_EQ] = ACTIONS(5666),
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_EQ_EQ] = ACTIONS(5666),
    [anon_sym_BANG_EQ] = ACTIONS(5666),
    [anon_sym_TILDE_EQ] = ACTIONS(5666),
    [anon_sym_AMP_TILDE] = ACTIONS(5668),
    [anon_sym_LT_LT] = ACTIONS(5668),
    [anon_sym_GT_GT] = ACTIONS(5668),
    [anon_sym_STAR] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5668),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5666),
    [anon_sym_DOT] = ACTIONS(5668),
    [anon_sym_LBRACK] = ACTIONS(5666),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5666),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5666),
    [anon_sym_not_in] = ACTIONS(5666),
    [anon_sym_or_return] = ACTIONS(5666),
    [anon_sym_or_continue] = ACTIONS(5666),
    [anon_sym_or_break] = ACTIONS(5666),
    [anon_sym_CARET] = ACTIONS(5668),
    [sym_uninitialized] = ACTIONS(5666),
    [sym_tag] = ACTIONS(5666),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5666),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1124] = {
    [sym_block] = STATE(2440),
    [ts_builtin_sym_end] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_DASH_GT] = ACTIONS(3671),
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_PLUS_EQ] = ACTIONS(3671),
    [anon_sym_DASH_EQ] = ACTIONS(3671),
    [anon_sym_STAR_EQ] = ACTIONS(3671),
    [anon_sym_SLASH_EQ] = ACTIONS(3671),
    [anon_sym_PERCENT_EQ] = ACTIONS(3671),
    [anon_sym_AMP_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_CARET_EQ] = ACTIONS(3671),
    [anon_sym_LT_LT_EQ] = ACTIONS(3671),
    [anon_sym_GT_GT_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_if] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_else] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3671),
    [anon_sym_case] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_or_else] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_GT] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3671),
    [anon_sym_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_SLASH] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3671),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3671),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3671),
    [anon_sym_not_in] = ACTIONS(3671),
    [anon_sym_or_return] = ACTIONS(3671),
    [anon_sym_or_continue] = ACTIONS(3671),
    [anon_sym_or_break] = ACTIONS(3671),
    [anon_sym_CARET] = ACTIONS(3675),
    [sym_uninitialized] = ACTIONS(3677),
    [sym_tag] = ACTIONS(3679),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3671),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1125] = {
    [ts_builtin_sym_end] = ACTIONS(5670),
    [anon_sym_LBRACE] = ACTIONS(5670),
    [anon_sym_RBRACE] = ACTIONS(5670),
    [anon_sym_COMMA] = ACTIONS(5670),
    [anon_sym_COLON_COLON] = ACTIONS(5670),
    [anon_sym_DASH_GT] = ACTIONS(5670),
    [anon_sym_where] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5672),
    [anon_sym_COLON] = ACTIONS(5672),
    [anon_sym_PIPE] = ACTIONS(5672),
    [anon_sym_COLON_EQ] = ACTIONS(5670),
    [anon_sym_LPAREN] = ACTIONS(5670),
    [anon_sym_PLUS_EQ] = ACTIONS(5670),
    [anon_sym_DASH_EQ] = ACTIONS(5670),
    [anon_sym_STAR_EQ] = ACTIONS(5670),
    [anon_sym_SLASH_EQ] = ACTIONS(5670),
    [anon_sym_PERCENT_EQ] = ACTIONS(5670),
    [anon_sym_AMP_EQ] = ACTIONS(5670),
    [anon_sym_PIPE_EQ] = ACTIONS(5670),
    [anon_sym_CARET_EQ] = ACTIONS(5670),
    [anon_sym_LT_LT_EQ] = ACTIONS(5670),
    [anon_sym_GT_GT_EQ] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5670),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5670),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5670),
    [anon_sym_if] = ACTIONS(5670),
    [anon_sym_SEMI] = ACTIONS(5670),
    [anon_sym_else] = ACTIONS(5670),
    [anon_sym_when] = ACTIONS(5670),
    [anon_sym_in] = ACTIONS(5670),
    [anon_sym_case] = ACTIONS(5670),
    [anon_sym_QMARK] = ACTIONS(5670),
    [anon_sym_PLUS] = ACTIONS(5672),
    [anon_sym_DASH] = ACTIONS(5672),
    [anon_sym_TILDE] = ACTIONS(5672),
    [anon_sym_AMP] = ACTIONS(5672),
    [anon_sym_PIPE_PIPE] = ACTIONS(5672),
    [anon_sym_or_else] = ACTIONS(5670),
    [anon_sym_AMP_AMP] = ACTIONS(5672),
    [anon_sym_GT] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5670),
    [anon_sym_LT] = ACTIONS(5672),
    [anon_sym_EQ_EQ] = ACTIONS(5670),
    [anon_sym_BANG_EQ] = ACTIONS(5670),
    [anon_sym_TILDE_EQ] = ACTIONS(5670),
    [anon_sym_AMP_TILDE] = ACTIONS(5672),
    [anon_sym_LT_LT] = ACTIONS(5672),
    [anon_sym_GT_GT] = ACTIONS(5672),
    [anon_sym_STAR] = ACTIONS(5672),
    [anon_sym_SLASH] = ACTIONS(5672),
    [anon_sym_PERCENT] = ACTIONS(5672),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5670),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5670),
    [anon_sym_not_in] = ACTIONS(5670),
    [anon_sym_or_return] = ACTIONS(5670),
    [anon_sym_or_continue] = ACTIONS(5670),
    [anon_sym_or_break] = ACTIONS(5670),
    [anon_sym_CARET] = ACTIONS(5672),
    [sym_uninitialized] = ACTIONS(5670),
    [sym_tag] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5670),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1126] = {
    [ts_builtin_sym_end] = ACTIONS(5674),
    [anon_sym_LBRACE] = ACTIONS(5674),
    [anon_sym_RBRACE] = ACTIONS(5674),
    [anon_sym_COMMA] = ACTIONS(5674),
    [anon_sym_COLON_COLON] = ACTIONS(5674),
    [anon_sym_DASH_GT] = ACTIONS(5674),
    [anon_sym_where] = ACTIONS(5674),
    [anon_sym_EQ] = ACTIONS(5676),
    [anon_sym_COLON] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_COLON_EQ] = ACTIONS(5674),
    [anon_sym_LPAREN] = ACTIONS(5674),
    [anon_sym_PLUS_EQ] = ACTIONS(5674),
    [anon_sym_DASH_EQ] = ACTIONS(5674),
    [anon_sym_STAR_EQ] = ACTIONS(5674),
    [anon_sym_SLASH_EQ] = ACTIONS(5674),
    [anon_sym_PERCENT_EQ] = ACTIONS(5674),
    [anon_sym_AMP_EQ] = ACTIONS(5674),
    [anon_sym_PIPE_EQ] = ACTIONS(5674),
    [anon_sym_CARET_EQ] = ACTIONS(5674),
    [anon_sym_LT_LT_EQ] = ACTIONS(5674),
    [anon_sym_GT_GT_EQ] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5674),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5674),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5674),
    [anon_sym_if] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5674),
    [anon_sym_else] = ACTIONS(5674),
    [anon_sym_when] = ACTIONS(5674),
    [anon_sym_in] = ACTIONS(5674),
    [anon_sym_case] = ACTIONS(5674),
    [anon_sym_QMARK] = ACTIONS(5674),
    [anon_sym_PLUS] = ACTIONS(5676),
    [anon_sym_DASH] = ACTIONS(5676),
    [anon_sym_TILDE] = ACTIONS(5676),
    [anon_sym_AMP] = ACTIONS(5676),
    [anon_sym_PIPE_PIPE] = ACTIONS(5676),
    [anon_sym_or_else] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5674),
    [anon_sym_LT_EQ] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_EQ_EQ] = ACTIONS(5674),
    [anon_sym_BANG_EQ] = ACTIONS(5674),
    [anon_sym_TILDE_EQ] = ACTIONS(5674),
    [anon_sym_AMP_TILDE] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5676),
    [anon_sym_STAR] = ACTIONS(5676),
    [anon_sym_SLASH] = ACTIONS(5676),
    [anon_sym_PERCENT] = ACTIONS(5676),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5674),
    [anon_sym_DOT] = ACTIONS(5676),
    [anon_sym_LBRACK] = ACTIONS(5674),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5674),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5674),
    [anon_sym_not_in] = ACTIONS(5674),
    [anon_sym_or_return] = ACTIONS(5674),
    [anon_sym_or_continue] = ACTIONS(5674),
    [anon_sym_or_break] = ACTIONS(5674),
    [anon_sym_CARET] = ACTIONS(5676),
    [sym_uninitialized] = ACTIONS(5674),
    [sym_tag] = ACTIONS(5674),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5674),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1127] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5632),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1128] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5664),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1129] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8213),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5500),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1130] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8361),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5678),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1131] = {
    [sym_block] = STATE(2447),
    [ts_builtin_sym_end] = ACTIONS(4667),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(4667),
    [anon_sym_COMMA] = ACTIONS(4667),
    [anon_sym_COLON_COLON] = ACTIONS(4667),
    [anon_sym_DASH_GT] = ACTIONS(4667),
    [anon_sym_EQ] = ACTIONS(4669),
    [anon_sym_COLON] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4669),
    [anon_sym_COLON_EQ] = ACTIONS(4667),
    [anon_sym_LPAREN] = ACTIONS(4667),
    [anon_sym_PLUS_EQ] = ACTIONS(4667),
    [anon_sym_DASH_EQ] = ACTIONS(4667),
    [anon_sym_STAR_EQ] = ACTIONS(4667),
    [anon_sym_SLASH_EQ] = ACTIONS(4667),
    [anon_sym_PERCENT_EQ] = ACTIONS(4667),
    [anon_sym_AMP_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_CARET_EQ] = ACTIONS(4667),
    [anon_sym_LT_LT_EQ] = ACTIONS(4667),
    [anon_sym_GT_GT_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_if] = ACTIONS(4667),
    [anon_sym_SEMI] = ACTIONS(4667),
    [anon_sym_else] = ACTIONS(4667),
    [anon_sym_when] = ACTIONS(4667),
    [anon_sym_in] = ACTIONS(4667),
    [anon_sym_case] = ACTIONS(4667),
    [anon_sym_QMARK] = ACTIONS(4667),
    [anon_sym_PLUS] = ACTIONS(4669),
    [anon_sym_DASH] = ACTIONS(4669),
    [anon_sym_TILDE] = ACTIONS(4669),
    [anon_sym_AMP] = ACTIONS(4669),
    [anon_sym_PIPE_PIPE] = ACTIONS(4669),
    [anon_sym_or_else] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_GT] = ACTIONS(4669),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_LT_EQ] = ACTIONS(4667),
    [anon_sym_LT] = ACTIONS(4669),
    [anon_sym_EQ_EQ] = ACTIONS(4667),
    [anon_sym_BANG_EQ] = ACTIONS(4667),
    [anon_sym_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE] = ACTIONS(4669),
    [anon_sym_LT_LT] = ACTIONS(4669),
    [anon_sym_GT_GT] = ACTIONS(4669),
    [anon_sym_STAR] = ACTIONS(4669),
    [anon_sym_SLASH] = ACTIONS(4669),
    [anon_sym_PERCENT] = ACTIONS(4669),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4667),
    [anon_sym_DOT] = ACTIONS(4669),
    [anon_sym_LBRACK] = ACTIONS(4667),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4667),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4667),
    [anon_sym_not_in] = ACTIONS(4667),
    [anon_sym_or_return] = ACTIONS(4667),
    [anon_sym_or_continue] = ACTIONS(4667),
    [anon_sym_or_break] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [sym_uninitialized] = ACTIONS(5680),
    [sym_tag] = ACTIONS(5682),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4667),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1132] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5684),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1133] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1134] = {
    [ts_builtin_sym_end] = ACTIONS(5688),
    [anon_sym_LBRACE] = ACTIONS(5688),
    [anon_sym_RBRACE] = ACTIONS(5688),
    [anon_sym_COMMA] = ACTIONS(5688),
    [anon_sym_COLON_COLON] = ACTIONS(5688),
    [anon_sym_DASH_GT] = ACTIONS(5688),
    [anon_sym_where] = ACTIONS(5688),
    [anon_sym_EQ] = ACTIONS(5690),
    [anon_sym_COLON] = ACTIONS(5690),
    [anon_sym_PIPE] = ACTIONS(5690),
    [anon_sym_COLON_EQ] = ACTIONS(5688),
    [anon_sym_LPAREN] = ACTIONS(5688),
    [anon_sym_PLUS_EQ] = ACTIONS(5688),
    [anon_sym_DASH_EQ] = ACTIONS(5688),
    [anon_sym_STAR_EQ] = ACTIONS(5688),
    [anon_sym_SLASH_EQ] = ACTIONS(5688),
    [anon_sym_PERCENT_EQ] = ACTIONS(5688),
    [anon_sym_AMP_EQ] = ACTIONS(5688),
    [anon_sym_PIPE_EQ] = ACTIONS(5688),
    [anon_sym_CARET_EQ] = ACTIONS(5688),
    [anon_sym_LT_LT_EQ] = ACTIONS(5688),
    [anon_sym_GT_GT_EQ] = ACTIONS(5688),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5688),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5688),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5688),
    [anon_sym_if] = ACTIONS(5688),
    [anon_sym_SEMI] = ACTIONS(5688),
    [anon_sym_else] = ACTIONS(5688),
    [anon_sym_when] = ACTIONS(5688),
    [anon_sym_in] = ACTIONS(5688),
    [anon_sym_case] = ACTIONS(5688),
    [anon_sym_QMARK] = ACTIONS(5688),
    [anon_sym_PLUS] = ACTIONS(5690),
    [anon_sym_DASH] = ACTIONS(5690),
    [anon_sym_TILDE] = ACTIONS(5690),
    [anon_sym_AMP] = ACTIONS(5690),
    [anon_sym_PIPE_PIPE] = ACTIONS(5690),
    [anon_sym_or_else] = ACTIONS(5688),
    [anon_sym_AMP_AMP] = ACTIONS(5690),
    [anon_sym_GT] = ACTIONS(5690),
    [anon_sym_GT_EQ] = ACTIONS(5688),
    [anon_sym_LT_EQ] = ACTIONS(5688),
    [anon_sym_LT] = ACTIONS(5690),
    [anon_sym_EQ_EQ] = ACTIONS(5688),
    [anon_sym_BANG_EQ] = ACTIONS(5688),
    [anon_sym_TILDE_EQ] = ACTIONS(5688),
    [anon_sym_AMP_TILDE] = ACTIONS(5690),
    [anon_sym_LT_LT] = ACTIONS(5690),
    [anon_sym_GT_GT] = ACTIONS(5690),
    [anon_sym_STAR] = ACTIONS(5690),
    [anon_sym_SLASH] = ACTIONS(5690),
    [anon_sym_PERCENT] = ACTIONS(5690),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5688),
    [anon_sym_DOT] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(5688),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5688),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5688),
    [anon_sym_not_in] = ACTIONS(5688),
    [anon_sym_or_return] = ACTIONS(5688),
    [anon_sym_or_continue] = ACTIONS(5688),
    [anon_sym_or_break] = ACTIONS(5688),
    [anon_sym_CARET] = ACTIONS(5690),
    [sym_uninitialized] = ACTIONS(5688),
    [sym_tag] = ACTIONS(5688),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5688),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1135] = {
    [ts_builtin_sym_end] = ACTIONS(5692),
    [anon_sym_LBRACE] = ACTIONS(5692),
    [anon_sym_RBRACE] = ACTIONS(5692),
    [anon_sym_COMMA] = ACTIONS(5692),
    [anon_sym_COLON_COLON] = ACTIONS(5692),
    [anon_sym_DASH_GT] = ACTIONS(5692),
    [anon_sym_where] = ACTIONS(5692),
    [anon_sym_EQ] = ACTIONS(5694),
    [anon_sym_COLON] = ACTIONS(5694),
    [anon_sym_PIPE] = ACTIONS(5694),
    [anon_sym_COLON_EQ] = ACTIONS(5692),
    [anon_sym_LPAREN] = ACTIONS(5692),
    [anon_sym_PLUS_EQ] = ACTIONS(5692),
    [anon_sym_DASH_EQ] = ACTIONS(5692),
    [anon_sym_STAR_EQ] = ACTIONS(5692),
    [anon_sym_SLASH_EQ] = ACTIONS(5692),
    [anon_sym_PERCENT_EQ] = ACTIONS(5692),
    [anon_sym_AMP_EQ] = ACTIONS(5692),
    [anon_sym_PIPE_EQ] = ACTIONS(5692),
    [anon_sym_CARET_EQ] = ACTIONS(5692),
    [anon_sym_LT_LT_EQ] = ACTIONS(5692),
    [anon_sym_GT_GT_EQ] = ACTIONS(5692),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5692),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5692),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5692),
    [anon_sym_if] = ACTIONS(5692),
    [anon_sym_SEMI] = ACTIONS(5692),
    [anon_sym_else] = ACTIONS(5692),
    [anon_sym_when] = ACTIONS(5692),
    [anon_sym_in] = ACTIONS(5692),
    [anon_sym_case] = ACTIONS(5692),
    [anon_sym_QMARK] = ACTIONS(5692),
    [anon_sym_PLUS] = ACTIONS(5694),
    [anon_sym_DASH] = ACTIONS(5694),
    [anon_sym_TILDE] = ACTIONS(5694),
    [anon_sym_AMP] = ACTIONS(5694),
    [anon_sym_PIPE_PIPE] = ACTIONS(5694),
    [anon_sym_or_else] = ACTIONS(5692),
    [anon_sym_AMP_AMP] = ACTIONS(5694),
    [anon_sym_GT] = ACTIONS(5694),
    [anon_sym_GT_EQ] = ACTIONS(5692),
    [anon_sym_LT_EQ] = ACTIONS(5692),
    [anon_sym_LT] = ACTIONS(5694),
    [anon_sym_EQ_EQ] = ACTIONS(5692),
    [anon_sym_BANG_EQ] = ACTIONS(5692),
    [anon_sym_TILDE_EQ] = ACTIONS(5692),
    [anon_sym_AMP_TILDE] = ACTIONS(5694),
    [anon_sym_LT_LT] = ACTIONS(5694),
    [anon_sym_GT_GT] = ACTIONS(5694),
    [anon_sym_STAR] = ACTIONS(5694),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5694),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5692),
    [anon_sym_DOT] = ACTIONS(5694),
    [anon_sym_LBRACK] = ACTIONS(5692),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5692),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5692),
    [anon_sym_not_in] = ACTIONS(5692),
    [anon_sym_or_return] = ACTIONS(5692),
    [anon_sym_or_continue] = ACTIONS(5692),
    [anon_sym_or_break] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5694),
    [sym_uninitialized] = ACTIONS(5692),
    [sym_tag] = ACTIONS(5692),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5692),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1136] = {
    [ts_builtin_sym_end] = ACTIONS(5696),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_RBRACE] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5696),
    [anon_sym_COLON_COLON] = ACTIONS(5696),
    [anon_sym_DASH_GT] = ACTIONS(5696),
    [anon_sym_where] = ACTIONS(5696),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_COLON] = ACTIONS(5698),
    [anon_sym_PIPE] = ACTIONS(5698),
    [anon_sym_COLON_EQ] = ACTIONS(5696),
    [anon_sym_LPAREN] = ACTIONS(5696),
    [anon_sym_PLUS_EQ] = ACTIONS(5696),
    [anon_sym_DASH_EQ] = ACTIONS(5696),
    [anon_sym_STAR_EQ] = ACTIONS(5696),
    [anon_sym_SLASH_EQ] = ACTIONS(5696),
    [anon_sym_PERCENT_EQ] = ACTIONS(5696),
    [anon_sym_AMP_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_CARET_EQ] = ACTIONS(5696),
    [anon_sym_LT_LT_EQ] = ACTIONS(5696),
    [anon_sym_GT_GT_EQ] = ACTIONS(5696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5696),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5696),
    [anon_sym_if] = ACTIONS(5696),
    [anon_sym_SEMI] = ACTIONS(5696),
    [anon_sym_else] = ACTIONS(5696),
    [anon_sym_when] = ACTIONS(5696),
    [anon_sym_in] = ACTIONS(5696),
    [anon_sym_case] = ACTIONS(5696),
    [anon_sym_QMARK] = ACTIONS(5696),
    [anon_sym_PLUS] = ACTIONS(5698),
    [anon_sym_DASH] = ACTIONS(5698),
    [anon_sym_TILDE] = ACTIONS(5698),
    [anon_sym_AMP] = ACTIONS(5698),
    [anon_sym_PIPE_PIPE] = ACTIONS(5698),
    [anon_sym_or_else] = ACTIONS(5696),
    [anon_sym_AMP_AMP] = ACTIONS(5698),
    [anon_sym_GT] = ACTIONS(5698),
    [anon_sym_GT_EQ] = ACTIONS(5696),
    [anon_sym_LT_EQ] = ACTIONS(5696),
    [anon_sym_LT] = ACTIONS(5698),
    [anon_sym_EQ_EQ] = ACTIONS(5696),
    [anon_sym_BANG_EQ] = ACTIONS(5696),
    [anon_sym_TILDE_EQ] = ACTIONS(5696),
    [anon_sym_AMP_TILDE] = ACTIONS(5698),
    [anon_sym_LT_LT] = ACTIONS(5698),
    [anon_sym_GT_GT] = ACTIONS(5698),
    [anon_sym_STAR] = ACTIONS(5698),
    [anon_sym_SLASH] = ACTIONS(5698),
    [anon_sym_PERCENT] = ACTIONS(5698),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(5698),
    [anon_sym_LBRACK] = ACTIONS(5696),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5696),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5696),
    [anon_sym_not_in] = ACTIONS(5696),
    [anon_sym_or_return] = ACTIONS(5696),
    [anon_sym_or_continue] = ACTIONS(5696),
    [anon_sym_or_break] = ACTIONS(5696),
    [anon_sym_CARET] = ACTIONS(5698),
    [sym_uninitialized] = ACTIONS(5696),
    [sym_tag] = ACTIONS(5696),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5696),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1137] = {
    [ts_builtin_sym_end] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(5700),
    [anon_sym_RBRACE] = ACTIONS(5700),
    [anon_sym_COMMA] = ACTIONS(5700),
    [anon_sym_COLON_COLON] = ACTIONS(5700),
    [anon_sym_DASH_GT] = ACTIONS(5700),
    [anon_sym_where] = ACTIONS(5700),
    [anon_sym_EQ] = ACTIONS(5702),
    [anon_sym_COLON] = ACTIONS(5702),
    [anon_sym_PIPE] = ACTIONS(5702),
    [anon_sym_COLON_EQ] = ACTIONS(5700),
    [anon_sym_LPAREN] = ACTIONS(5700),
    [anon_sym_PLUS_EQ] = ACTIONS(5700),
    [anon_sym_DASH_EQ] = ACTIONS(5700),
    [anon_sym_STAR_EQ] = ACTIONS(5700),
    [anon_sym_SLASH_EQ] = ACTIONS(5700),
    [anon_sym_PERCENT_EQ] = ACTIONS(5700),
    [anon_sym_AMP_EQ] = ACTIONS(5700),
    [anon_sym_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_CARET_EQ] = ACTIONS(5700),
    [anon_sym_LT_LT_EQ] = ACTIONS(5700),
    [anon_sym_GT_GT_EQ] = ACTIONS(5700),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5700),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5700),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5700),
    [anon_sym_if] = ACTIONS(5700),
    [anon_sym_SEMI] = ACTIONS(5700),
    [anon_sym_else] = ACTIONS(5700),
    [anon_sym_when] = ACTIONS(5700),
    [anon_sym_in] = ACTIONS(5700),
    [anon_sym_case] = ACTIONS(5700),
    [anon_sym_QMARK] = ACTIONS(5700),
    [anon_sym_PLUS] = ACTIONS(5702),
    [anon_sym_DASH] = ACTIONS(5702),
    [anon_sym_TILDE] = ACTIONS(5702),
    [anon_sym_AMP] = ACTIONS(5702),
    [anon_sym_PIPE_PIPE] = ACTIONS(5702),
    [anon_sym_or_else] = ACTIONS(5700),
    [anon_sym_AMP_AMP] = ACTIONS(5702),
    [anon_sym_GT] = ACTIONS(5702),
    [anon_sym_GT_EQ] = ACTIONS(5700),
    [anon_sym_LT_EQ] = ACTIONS(5700),
    [anon_sym_LT] = ACTIONS(5702),
    [anon_sym_EQ_EQ] = ACTIONS(5700),
    [anon_sym_BANG_EQ] = ACTIONS(5700),
    [anon_sym_TILDE_EQ] = ACTIONS(5700),
    [anon_sym_AMP_TILDE] = ACTIONS(5702),
    [anon_sym_LT_LT] = ACTIONS(5702),
    [anon_sym_GT_GT] = ACTIONS(5702),
    [anon_sym_STAR] = ACTIONS(5702),
    [anon_sym_SLASH] = ACTIONS(5702),
    [anon_sym_PERCENT] = ACTIONS(5702),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5700),
    [anon_sym_DOT] = ACTIONS(5702),
    [anon_sym_LBRACK] = ACTIONS(5700),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5700),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5700),
    [anon_sym_not_in] = ACTIONS(5700),
    [anon_sym_or_return] = ACTIONS(5700),
    [anon_sym_or_continue] = ACTIONS(5700),
    [anon_sym_or_break] = ACTIONS(5700),
    [anon_sym_CARET] = ACTIONS(5702),
    [sym_uninitialized] = ACTIONS(5700),
    [sym_tag] = ACTIONS(5700),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5700),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1138] = {
    [ts_builtin_sym_end] = ACTIONS(5692),
    [anon_sym_LBRACE] = ACTIONS(5692),
    [anon_sym_RBRACE] = ACTIONS(5692),
    [anon_sym_COMMA] = ACTIONS(5692),
    [anon_sym_COLON_COLON] = ACTIONS(5692),
    [anon_sym_DASH_GT] = ACTIONS(5692),
    [anon_sym_where] = ACTIONS(5692),
    [anon_sym_EQ] = ACTIONS(5694),
    [anon_sym_COLON] = ACTIONS(5694),
    [anon_sym_PIPE] = ACTIONS(5694),
    [anon_sym_COLON_EQ] = ACTIONS(5692),
    [anon_sym_LPAREN] = ACTIONS(5692),
    [anon_sym_PLUS_EQ] = ACTIONS(5692),
    [anon_sym_DASH_EQ] = ACTIONS(5692),
    [anon_sym_STAR_EQ] = ACTIONS(5692),
    [anon_sym_SLASH_EQ] = ACTIONS(5692),
    [anon_sym_PERCENT_EQ] = ACTIONS(5692),
    [anon_sym_AMP_EQ] = ACTIONS(5692),
    [anon_sym_PIPE_EQ] = ACTIONS(5692),
    [anon_sym_CARET_EQ] = ACTIONS(5692),
    [anon_sym_LT_LT_EQ] = ACTIONS(5692),
    [anon_sym_GT_GT_EQ] = ACTIONS(5692),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5692),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5692),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5692),
    [anon_sym_if] = ACTIONS(5692),
    [anon_sym_SEMI] = ACTIONS(5692),
    [anon_sym_else] = ACTIONS(5692),
    [anon_sym_when] = ACTIONS(5692),
    [anon_sym_in] = ACTIONS(5692),
    [anon_sym_case] = ACTIONS(5692),
    [anon_sym_QMARK] = ACTIONS(5692),
    [anon_sym_PLUS] = ACTIONS(5694),
    [anon_sym_DASH] = ACTIONS(5694),
    [anon_sym_TILDE] = ACTIONS(5694),
    [anon_sym_AMP] = ACTIONS(5694),
    [anon_sym_PIPE_PIPE] = ACTIONS(5694),
    [anon_sym_or_else] = ACTIONS(5692),
    [anon_sym_AMP_AMP] = ACTIONS(5694),
    [anon_sym_GT] = ACTIONS(5694),
    [anon_sym_GT_EQ] = ACTIONS(5692),
    [anon_sym_LT_EQ] = ACTIONS(5692),
    [anon_sym_LT] = ACTIONS(5694),
    [anon_sym_EQ_EQ] = ACTIONS(5692),
    [anon_sym_BANG_EQ] = ACTIONS(5692),
    [anon_sym_TILDE_EQ] = ACTIONS(5692),
    [anon_sym_AMP_TILDE] = ACTIONS(5694),
    [anon_sym_LT_LT] = ACTIONS(5694),
    [anon_sym_GT_GT] = ACTIONS(5694),
    [anon_sym_STAR] = ACTIONS(5694),
    [anon_sym_SLASH] = ACTIONS(5694),
    [anon_sym_PERCENT] = ACTIONS(5694),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5692),
    [anon_sym_DOT] = ACTIONS(5694),
    [anon_sym_LBRACK] = ACTIONS(5692),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5692),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5692),
    [anon_sym_not_in] = ACTIONS(5692),
    [anon_sym_or_return] = ACTIONS(5692),
    [anon_sym_or_continue] = ACTIONS(5692),
    [anon_sym_or_break] = ACTIONS(5692),
    [anon_sym_CARET] = ACTIONS(5694),
    [sym_uninitialized] = ACTIONS(5692),
    [sym_tag] = ACTIONS(5692),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5692),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1139] = {
    [ts_builtin_sym_end] = ACTIONS(5704),
    [anon_sym_LBRACE] = ACTIONS(5704),
    [anon_sym_RBRACE] = ACTIONS(5704),
    [anon_sym_COMMA] = ACTIONS(5704),
    [anon_sym_COLON_COLON] = ACTIONS(5704),
    [anon_sym_DASH_GT] = ACTIONS(5704),
    [anon_sym_where] = ACTIONS(5704),
    [anon_sym_EQ] = ACTIONS(5706),
    [anon_sym_COLON] = ACTIONS(5706),
    [anon_sym_PIPE] = ACTIONS(5706),
    [anon_sym_COLON_EQ] = ACTIONS(5704),
    [anon_sym_LPAREN] = ACTIONS(5704),
    [anon_sym_PLUS_EQ] = ACTIONS(5704),
    [anon_sym_DASH_EQ] = ACTIONS(5704),
    [anon_sym_STAR_EQ] = ACTIONS(5704),
    [anon_sym_SLASH_EQ] = ACTIONS(5704),
    [anon_sym_PERCENT_EQ] = ACTIONS(5704),
    [anon_sym_AMP_EQ] = ACTIONS(5704),
    [anon_sym_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_CARET_EQ] = ACTIONS(5704),
    [anon_sym_LT_LT_EQ] = ACTIONS(5704),
    [anon_sym_GT_GT_EQ] = ACTIONS(5704),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5704),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5704),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5704),
    [anon_sym_if] = ACTIONS(5704),
    [anon_sym_SEMI] = ACTIONS(5704),
    [anon_sym_else] = ACTIONS(5704),
    [anon_sym_when] = ACTIONS(5704),
    [anon_sym_in] = ACTIONS(5704),
    [anon_sym_case] = ACTIONS(5704),
    [anon_sym_QMARK] = ACTIONS(5704),
    [anon_sym_PLUS] = ACTIONS(5706),
    [anon_sym_DASH] = ACTIONS(5706),
    [anon_sym_TILDE] = ACTIONS(5706),
    [anon_sym_AMP] = ACTIONS(5706),
    [anon_sym_PIPE_PIPE] = ACTIONS(5706),
    [anon_sym_or_else] = ACTIONS(5704),
    [anon_sym_AMP_AMP] = ACTIONS(5706),
    [anon_sym_GT] = ACTIONS(5706),
    [anon_sym_GT_EQ] = ACTIONS(5704),
    [anon_sym_LT_EQ] = ACTIONS(5704),
    [anon_sym_LT] = ACTIONS(5706),
    [anon_sym_EQ_EQ] = ACTIONS(5704),
    [anon_sym_BANG_EQ] = ACTIONS(5704),
    [anon_sym_TILDE_EQ] = ACTIONS(5704),
    [anon_sym_AMP_TILDE] = ACTIONS(5706),
    [anon_sym_LT_LT] = ACTIONS(5706),
    [anon_sym_GT_GT] = ACTIONS(5706),
    [anon_sym_STAR] = ACTIONS(5706),
    [anon_sym_SLASH] = ACTIONS(5706),
    [anon_sym_PERCENT] = ACTIONS(5706),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(5706),
    [anon_sym_LBRACK] = ACTIONS(5704),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5704),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5704),
    [anon_sym_not_in] = ACTIONS(5704),
    [anon_sym_or_return] = ACTIONS(5704),
    [anon_sym_or_continue] = ACTIONS(5704),
    [anon_sym_or_break] = ACTIONS(5704),
    [anon_sym_CARET] = ACTIONS(5706),
    [sym_uninitialized] = ACTIONS(5704),
    [sym_tag] = ACTIONS(5704),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5704),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1140] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7728),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5684),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1141] = {
    [ts_builtin_sym_end] = ACTIONS(5708),
    [anon_sym_LBRACE] = ACTIONS(5708),
    [anon_sym_RBRACE] = ACTIONS(5708),
    [anon_sym_COMMA] = ACTIONS(5708),
    [anon_sym_COLON_COLON] = ACTIONS(5708),
    [anon_sym_DASH_GT] = ACTIONS(5708),
    [anon_sym_where] = ACTIONS(5708),
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_COLON] = ACTIONS(5710),
    [anon_sym_PIPE] = ACTIONS(5710),
    [anon_sym_COLON_EQ] = ACTIONS(5708),
    [anon_sym_LPAREN] = ACTIONS(5708),
    [anon_sym_PLUS_EQ] = ACTIONS(5708),
    [anon_sym_DASH_EQ] = ACTIONS(5708),
    [anon_sym_STAR_EQ] = ACTIONS(5708),
    [anon_sym_SLASH_EQ] = ACTIONS(5708),
    [anon_sym_PERCENT_EQ] = ACTIONS(5708),
    [anon_sym_AMP_EQ] = ACTIONS(5708),
    [anon_sym_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_CARET_EQ] = ACTIONS(5708),
    [anon_sym_LT_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT_GT_EQ] = ACTIONS(5708),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5708),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5708),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5708),
    [anon_sym_if] = ACTIONS(5708),
    [anon_sym_SEMI] = ACTIONS(5708),
    [anon_sym_else] = ACTIONS(5708),
    [anon_sym_when] = ACTIONS(5708),
    [anon_sym_in] = ACTIONS(5708),
    [anon_sym_case] = ACTIONS(5708),
    [anon_sym_QMARK] = ACTIONS(5708),
    [anon_sym_PLUS] = ACTIONS(5710),
    [anon_sym_DASH] = ACTIONS(5710),
    [anon_sym_TILDE] = ACTIONS(5710),
    [anon_sym_AMP] = ACTIONS(5710),
    [anon_sym_PIPE_PIPE] = ACTIONS(5710),
    [anon_sym_or_else] = ACTIONS(5708),
    [anon_sym_AMP_AMP] = ACTIONS(5710),
    [anon_sym_GT] = ACTIONS(5710),
    [anon_sym_GT_EQ] = ACTIONS(5708),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_LT] = ACTIONS(5710),
    [anon_sym_EQ_EQ] = ACTIONS(5708),
    [anon_sym_BANG_EQ] = ACTIONS(5708),
    [anon_sym_TILDE_EQ] = ACTIONS(5708),
    [anon_sym_AMP_TILDE] = ACTIONS(5710),
    [anon_sym_LT_LT] = ACTIONS(5710),
    [anon_sym_GT_GT] = ACTIONS(5710),
    [anon_sym_STAR] = ACTIONS(5710),
    [anon_sym_SLASH] = ACTIONS(5710),
    [anon_sym_PERCENT] = ACTIONS(5710),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5708),
    [anon_sym_DOT] = ACTIONS(5710),
    [anon_sym_LBRACK] = ACTIONS(5708),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5708),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5708),
    [anon_sym_not_in] = ACTIONS(5708),
    [anon_sym_or_return] = ACTIONS(5708),
    [anon_sym_or_continue] = ACTIONS(5708),
    [anon_sym_or_break] = ACTIONS(5708),
    [anon_sym_CARET] = ACTIONS(5710),
    [sym_uninitialized] = ACTIONS(5708),
    [sym_tag] = ACTIONS(5708),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5708),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1142] = {
    [ts_builtin_sym_end] = ACTIONS(5712),
    [anon_sym_LBRACE] = ACTIONS(5712),
    [anon_sym_RBRACE] = ACTIONS(5712),
    [anon_sym_COMMA] = ACTIONS(5712),
    [anon_sym_COLON_COLON] = ACTIONS(5712),
    [anon_sym_DASH_GT] = ACTIONS(5712),
    [anon_sym_where] = ACTIONS(5712),
    [anon_sym_EQ] = ACTIONS(5714),
    [anon_sym_COLON] = ACTIONS(5714),
    [anon_sym_PIPE] = ACTIONS(5714),
    [anon_sym_COLON_EQ] = ACTIONS(5712),
    [anon_sym_LPAREN] = ACTIONS(5712),
    [anon_sym_PLUS_EQ] = ACTIONS(5712),
    [anon_sym_DASH_EQ] = ACTIONS(5712),
    [anon_sym_STAR_EQ] = ACTIONS(5712),
    [anon_sym_SLASH_EQ] = ACTIONS(5712),
    [anon_sym_PERCENT_EQ] = ACTIONS(5712),
    [anon_sym_AMP_EQ] = ACTIONS(5712),
    [anon_sym_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_CARET_EQ] = ACTIONS(5712),
    [anon_sym_LT_LT_EQ] = ACTIONS(5712),
    [anon_sym_GT_GT_EQ] = ACTIONS(5712),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5712),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5712),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5712),
    [anon_sym_if] = ACTIONS(5712),
    [anon_sym_SEMI] = ACTIONS(5712),
    [anon_sym_else] = ACTIONS(5712),
    [anon_sym_when] = ACTIONS(5712),
    [anon_sym_in] = ACTIONS(5712),
    [anon_sym_case] = ACTIONS(5712),
    [anon_sym_QMARK] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5714),
    [anon_sym_DASH] = ACTIONS(5714),
    [anon_sym_TILDE] = ACTIONS(5714),
    [anon_sym_AMP] = ACTIONS(5714),
    [anon_sym_PIPE_PIPE] = ACTIONS(5714),
    [anon_sym_or_else] = ACTIONS(5712),
    [anon_sym_AMP_AMP] = ACTIONS(5714),
    [anon_sym_GT] = ACTIONS(5714),
    [anon_sym_GT_EQ] = ACTIONS(5712),
    [anon_sym_LT_EQ] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5714),
    [anon_sym_EQ_EQ] = ACTIONS(5712),
    [anon_sym_BANG_EQ] = ACTIONS(5712),
    [anon_sym_TILDE_EQ] = ACTIONS(5712),
    [anon_sym_AMP_TILDE] = ACTIONS(5714),
    [anon_sym_LT_LT] = ACTIONS(5714),
    [anon_sym_GT_GT] = ACTIONS(5714),
    [anon_sym_STAR] = ACTIONS(5714),
    [anon_sym_SLASH] = ACTIONS(5714),
    [anon_sym_PERCENT] = ACTIONS(5714),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5712),
    [anon_sym_DOT] = ACTIONS(5714),
    [anon_sym_LBRACK] = ACTIONS(5712),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5712),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5712),
    [anon_sym_not_in] = ACTIONS(5712),
    [anon_sym_or_return] = ACTIONS(5712),
    [anon_sym_or_continue] = ACTIONS(5712),
    [anon_sym_or_break] = ACTIONS(5712),
    [anon_sym_CARET] = ACTIONS(5714),
    [sym_uninitialized] = ACTIONS(5712),
    [sym_tag] = ACTIONS(5712),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5712),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1143] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7828),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5716),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1144] = {
    [ts_builtin_sym_end] = ACTIONS(5718),
    [anon_sym_LBRACE] = ACTIONS(5718),
    [anon_sym_RBRACE] = ACTIONS(5718),
    [anon_sym_COMMA] = ACTIONS(5718),
    [anon_sym_COLON_COLON] = ACTIONS(5718),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_COLON] = ACTIONS(5720),
    [anon_sym_PIPE] = ACTIONS(4734),
    [anon_sym_COLON_EQ] = ACTIONS(5718),
    [anon_sym_LPAREN] = ACTIONS(5718),
    [anon_sym_PLUS_EQ] = ACTIONS(5718),
    [anon_sym_DASH_EQ] = ACTIONS(5718),
    [anon_sym_STAR_EQ] = ACTIONS(5718),
    [anon_sym_SLASH_EQ] = ACTIONS(5718),
    [anon_sym_PERCENT_EQ] = ACTIONS(5718),
    [anon_sym_AMP_EQ] = ACTIONS(5718),
    [anon_sym_PIPE_EQ] = ACTIONS(5718),
    [anon_sym_CARET_EQ] = ACTIONS(5718),
    [anon_sym_LT_LT_EQ] = ACTIONS(5718),
    [anon_sym_GT_GT_EQ] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5718),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5718),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5718),
    [anon_sym_if] = ACTIONS(5718),
    [anon_sym_SEMI] = ACTIONS(5718),
    [anon_sym_else] = ACTIONS(5718),
    [anon_sym_when] = ACTIONS(5718),
    [anon_sym_in] = ACTIONS(5718),
    [anon_sym_case] = ACTIONS(5718),
    [anon_sym_QMARK] = ACTIONS(5718),
    [anon_sym_PLUS] = ACTIONS(4736),
    [anon_sym_DASH] = ACTIONS(4736),
    [anon_sym_TILDE] = ACTIONS(4738),
    [anon_sym_AMP] = ACTIONS(4740),
    [anon_sym_PIPE_PIPE] = ACTIONS(4742),
    [anon_sym_or_else] = ACTIONS(4744),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_GT] = ACTIONS(4748),
    [anon_sym_GT_EQ] = ACTIONS(4750),
    [anon_sym_LT_EQ] = ACTIONS(4750),
    [anon_sym_LT] = ACTIONS(4748),
    [anon_sym_EQ_EQ] = ACTIONS(4752),
    [anon_sym_BANG_EQ] = ACTIONS(4752),
    [anon_sym_TILDE_EQ] = ACTIONS(4752),
    [anon_sym_AMP_TILDE] = ACTIONS(4754),
    [anon_sym_LT_LT] = ACTIONS(4756),
    [anon_sym_GT_GT] = ACTIONS(4756),
    [anon_sym_STAR] = ACTIONS(4758),
    [anon_sym_SLASH] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4760),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5718),
    [anon_sym_or_return] = ACTIONS(4768),
    [anon_sym_or_continue] = ACTIONS(4770),
    [anon_sym_or_break] = ACTIONS(4772),
    [anon_sym_CARET] = ACTIONS(4774),
    [sym_uninitialized] = ACTIONS(5718),
    [sym_tag] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5718),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1145] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5716),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1146] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7904),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1147] = {
    [ts_builtin_sym_end] = ACTIONS(5722),
    [anon_sym_LBRACE] = ACTIONS(5722),
    [anon_sym_RBRACE] = ACTIONS(5722),
    [anon_sym_COMMA] = ACTIONS(5722),
    [anon_sym_COLON_COLON] = ACTIONS(5722),
    [anon_sym_DASH_GT] = ACTIONS(5722),
    [anon_sym_where] = ACTIONS(5722),
    [anon_sym_EQ] = ACTIONS(5724),
    [anon_sym_COLON] = ACTIONS(5724),
    [anon_sym_PIPE] = ACTIONS(5724),
    [anon_sym_COLON_EQ] = ACTIONS(5722),
    [anon_sym_LPAREN] = ACTIONS(5722),
    [anon_sym_PLUS_EQ] = ACTIONS(5722),
    [anon_sym_DASH_EQ] = ACTIONS(5722),
    [anon_sym_STAR_EQ] = ACTIONS(5722),
    [anon_sym_SLASH_EQ] = ACTIONS(5722),
    [anon_sym_PERCENT_EQ] = ACTIONS(5722),
    [anon_sym_AMP_EQ] = ACTIONS(5722),
    [anon_sym_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_CARET_EQ] = ACTIONS(5722),
    [anon_sym_LT_LT_EQ] = ACTIONS(5722),
    [anon_sym_GT_GT_EQ] = ACTIONS(5722),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5722),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5722),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5722),
    [anon_sym_if] = ACTIONS(5722),
    [anon_sym_SEMI] = ACTIONS(5722),
    [anon_sym_else] = ACTIONS(5722),
    [anon_sym_when] = ACTIONS(5722),
    [anon_sym_in] = ACTIONS(5722),
    [anon_sym_case] = ACTIONS(5722),
    [anon_sym_QMARK] = ACTIONS(5722),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_DASH] = ACTIONS(5724),
    [anon_sym_TILDE] = ACTIONS(5724),
    [anon_sym_AMP] = ACTIONS(5724),
    [anon_sym_PIPE_PIPE] = ACTIONS(5724),
    [anon_sym_or_else] = ACTIONS(5722),
    [anon_sym_AMP_AMP] = ACTIONS(5724),
    [anon_sym_GT] = ACTIONS(5724),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_LT_EQ] = ACTIONS(5722),
    [anon_sym_LT] = ACTIONS(5724),
    [anon_sym_EQ_EQ] = ACTIONS(5722),
    [anon_sym_BANG_EQ] = ACTIONS(5722),
    [anon_sym_TILDE_EQ] = ACTIONS(5722),
    [anon_sym_AMP_TILDE] = ACTIONS(5724),
    [anon_sym_LT_LT] = ACTIONS(5724),
    [anon_sym_GT_GT] = ACTIONS(5724),
    [anon_sym_STAR] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5724),
    [anon_sym_PERCENT] = ACTIONS(5724),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5722),
    [anon_sym_DOT] = ACTIONS(5724),
    [anon_sym_LBRACK] = ACTIONS(5722),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5722),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5722),
    [anon_sym_not_in] = ACTIONS(5722),
    [anon_sym_or_return] = ACTIONS(5722),
    [anon_sym_or_continue] = ACTIONS(5722),
    [anon_sym_or_break] = ACTIONS(5722),
    [anon_sym_CARET] = ACTIONS(5724),
    [sym_uninitialized] = ACTIONS(5722),
    [sym_tag] = ACTIONS(5722),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5722),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1148] = {
    [ts_builtin_sym_end] = ACTIONS(5726),
    [anon_sym_LBRACE] = ACTIONS(5726),
    [anon_sym_RBRACE] = ACTIONS(5726),
    [anon_sym_COMMA] = ACTIONS(5726),
    [anon_sym_COLON_COLON] = ACTIONS(5726),
    [anon_sym_DASH_GT] = ACTIONS(5726),
    [anon_sym_where] = ACTIONS(5726),
    [anon_sym_EQ] = ACTIONS(5728),
    [anon_sym_COLON] = ACTIONS(5728),
    [anon_sym_PIPE] = ACTIONS(5728),
    [anon_sym_COLON_EQ] = ACTIONS(5726),
    [anon_sym_LPAREN] = ACTIONS(5726),
    [anon_sym_PLUS_EQ] = ACTIONS(5726),
    [anon_sym_DASH_EQ] = ACTIONS(5726),
    [anon_sym_STAR_EQ] = ACTIONS(5726),
    [anon_sym_SLASH_EQ] = ACTIONS(5726),
    [anon_sym_PERCENT_EQ] = ACTIONS(5726),
    [anon_sym_AMP_EQ] = ACTIONS(5726),
    [anon_sym_PIPE_EQ] = ACTIONS(5726),
    [anon_sym_CARET_EQ] = ACTIONS(5726),
    [anon_sym_LT_LT_EQ] = ACTIONS(5726),
    [anon_sym_GT_GT_EQ] = ACTIONS(5726),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5726),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5726),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5726),
    [anon_sym_if] = ACTIONS(5726),
    [anon_sym_SEMI] = ACTIONS(5726),
    [anon_sym_else] = ACTIONS(5726),
    [anon_sym_when] = ACTIONS(5726),
    [anon_sym_in] = ACTIONS(5726),
    [anon_sym_case] = ACTIONS(5726),
    [anon_sym_QMARK] = ACTIONS(5726),
    [anon_sym_PLUS] = ACTIONS(5728),
    [anon_sym_DASH] = ACTIONS(5728),
    [anon_sym_TILDE] = ACTIONS(5728),
    [anon_sym_AMP] = ACTIONS(5728),
    [anon_sym_PIPE_PIPE] = ACTIONS(5728),
    [anon_sym_or_else] = ACTIONS(5726),
    [anon_sym_AMP_AMP] = ACTIONS(5728),
    [anon_sym_GT] = ACTIONS(5728),
    [anon_sym_GT_EQ] = ACTIONS(5726),
    [anon_sym_LT_EQ] = ACTIONS(5726),
    [anon_sym_LT] = ACTIONS(5728),
    [anon_sym_EQ_EQ] = ACTIONS(5726),
    [anon_sym_BANG_EQ] = ACTIONS(5726),
    [anon_sym_TILDE_EQ] = ACTIONS(5726),
    [anon_sym_AMP_TILDE] = ACTIONS(5728),
    [anon_sym_LT_LT] = ACTIONS(5728),
    [anon_sym_GT_GT] = ACTIONS(5728),
    [anon_sym_STAR] = ACTIONS(5728),
    [anon_sym_SLASH] = ACTIONS(5728),
    [anon_sym_PERCENT] = ACTIONS(5728),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5726),
    [anon_sym_DOT] = ACTIONS(5728),
    [anon_sym_LBRACK] = ACTIONS(5726),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5726),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5726),
    [anon_sym_not_in] = ACTIONS(5726),
    [anon_sym_or_return] = ACTIONS(5726),
    [anon_sym_or_continue] = ACTIONS(5726),
    [anon_sym_or_break] = ACTIONS(5726),
    [anon_sym_CARET] = ACTIONS(5728),
    [sym_uninitialized] = ACTIONS(5726),
    [sym_tag] = ACTIONS(5726),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5726),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1149] = {
    [ts_builtin_sym_end] = ACTIONS(5730),
    [anon_sym_LBRACE] = ACTIONS(5730),
    [anon_sym_RBRACE] = ACTIONS(5730),
    [anon_sym_COMMA] = ACTIONS(5730),
    [anon_sym_COLON_COLON] = ACTIONS(5730),
    [anon_sym_DASH_GT] = ACTIONS(5730),
    [anon_sym_where] = ACTIONS(5730),
    [anon_sym_EQ] = ACTIONS(5732),
    [anon_sym_COLON] = ACTIONS(5732),
    [anon_sym_PIPE] = ACTIONS(5732),
    [anon_sym_COLON_EQ] = ACTIONS(5730),
    [anon_sym_LPAREN] = ACTIONS(5730),
    [anon_sym_PLUS_EQ] = ACTIONS(5730),
    [anon_sym_DASH_EQ] = ACTIONS(5730),
    [anon_sym_STAR_EQ] = ACTIONS(5730),
    [anon_sym_SLASH_EQ] = ACTIONS(5730),
    [anon_sym_PERCENT_EQ] = ACTIONS(5730),
    [anon_sym_AMP_EQ] = ACTIONS(5730),
    [anon_sym_PIPE_EQ] = ACTIONS(5730),
    [anon_sym_CARET_EQ] = ACTIONS(5730),
    [anon_sym_LT_LT_EQ] = ACTIONS(5730),
    [anon_sym_GT_GT_EQ] = ACTIONS(5730),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5730),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5730),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5730),
    [anon_sym_if] = ACTIONS(5730),
    [anon_sym_SEMI] = ACTIONS(5730),
    [anon_sym_else] = ACTIONS(5730),
    [anon_sym_when] = ACTIONS(5730),
    [anon_sym_in] = ACTIONS(5730),
    [anon_sym_case] = ACTIONS(5730),
    [anon_sym_QMARK] = ACTIONS(5730),
    [anon_sym_PLUS] = ACTIONS(5732),
    [anon_sym_DASH] = ACTIONS(5732),
    [anon_sym_TILDE] = ACTIONS(5732),
    [anon_sym_AMP] = ACTIONS(5732),
    [anon_sym_PIPE_PIPE] = ACTIONS(5732),
    [anon_sym_or_else] = ACTIONS(5730),
    [anon_sym_AMP_AMP] = ACTIONS(5732),
    [anon_sym_GT] = ACTIONS(5732),
    [anon_sym_GT_EQ] = ACTIONS(5730),
    [anon_sym_LT_EQ] = ACTIONS(5730),
    [anon_sym_LT] = ACTIONS(5732),
    [anon_sym_EQ_EQ] = ACTIONS(5730),
    [anon_sym_BANG_EQ] = ACTIONS(5730),
    [anon_sym_TILDE_EQ] = ACTIONS(5730),
    [anon_sym_AMP_TILDE] = ACTIONS(5732),
    [anon_sym_LT_LT] = ACTIONS(5732),
    [anon_sym_GT_GT] = ACTIONS(5732),
    [anon_sym_STAR] = ACTIONS(5732),
    [anon_sym_SLASH] = ACTIONS(5732),
    [anon_sym_PERCENT] = ACTIONS(5732),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(5732),
    [anon_sym_LBRACK] = ACTIONS(5730),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5730),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5730),
    [anon_sym_not_in] = ACTIONS(5730),
    [anon_sym_or_return] = ACTIONS(5730),
    [anon_sym_or_continue] = ACTIONS(5730),
    [anon_sym_or_break] = ACTIONS(5730),
    [anon_sym_CARET] = ACTIONS(5732),
    [sym_uninitialized] = ACTIONS(5730),
    [sym_tag] = ACTIONS(5730),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5730),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1150] = {
    [ts_builtin_sym_end] = ACTIONS(5734),
    [anon_sym_LBRACE] = ACTIONS(5734),
    [anon_sym_RBRACE] = ACTIONS(5734),
    [anon_sym_COMMA] = ACTIONS(5734),
    [anon_sym_COLON_COLON] = ACTIONS(5734),
    [anon_sym_DASH_GT] = ACTIONS(5734),
    [anon_sym_where] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5736),
    [anon_sym_COLON] = ACTIONS(5736),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5734),
    [anon_sym_LPAREN] = ACTIONS(5734),
    [anon_sym_PLUS_EQ] = ACTIONS(5734),
    [anon_sym_DASH_EQ] = ACTIONS(5734),
    [anon_sym_STAR_EQ] = ACTIONS(5734),
    [anon_sym_SLASH_EQ] = ACTIONS(5734),
    [anon_sym_PERCENT_EQ] = ACTIONS(5734),
    [anon_sym_AMP_EQ] = ACTIONS(5734),
    [anon_sym_PIPE_EQ] = ACTIONS(5734),
    [anon_sym_CARET_EQ] = ACTIONS(5734),
    [anon_sym_LT_LT_EQ] = ACTIONS(5734),
    [anon_sym_GT_GT_EQ] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5734),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5734),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5734),
    [anon_sym_if] = ACTIONS(5734),
    [anon_sym_SEMI] = ACTIONS(5734),
    [anon_sym_else] = ACTIONS(5734),
    [anon_sym_when] = ACTIONS(5734),
    [anon_sym_in] = ACTIONS(5734),
    [anon_sym_case] = ACTIONS(5734),
    [anon_sym_QMARK] = ACTIONS(5734),
    [anon_sym_PLUS] = ACTIONS(5736),
    [anon_sym_DASH] = ACTIONS(5736),
    [anon_sym_TILDE] = ACTIONS(5736),
    [anon_sym_AMP] = ACTIONS(5736),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_or_else] = ACTIONS(5734),
    [anon_sym_AMP_AMP] = ACTIONS(5736),
    [anon_sym_GT] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_LT] = ACTIONS(5736),
    [anon_sym_EQ_EQ] = ACTIONS(5734),
    [anon_sym_BANG_EQ] = ACTIONS(5734),
    [anon_sym_TILDE_EQ] = ACTIONS(5734),
    [anon_sym_AMP_TILDE] = ACTIONS(5736),
    [anon_sym_LT_LT] = ACTIONS(5736),
    [anon_sym_GT_GT] = ACTIONS(5736),
    [anon_sym_STAR] = ACTIONS(5736),
    [anon_sym_SLASH] = ACTIONS(5736),
    [anon_sym_PERCENT] = ACTIONS(5736),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5734),
    [anon_sym_DOT] = ACTIONS(5736),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5734),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5734),
    [anon_sym_not_in] = ACTIONS(5734),
    [anon_sym_or_return] = ACTIONS(5734),
    [anon_sym_or_continue] = ACTIONS(5734),
    [anon_sym_or_break] = ACTIONS(5734),
    [anon_sym_CARET] = ACTIONS(5736),
    [sym_uninitialized] = ACTIONS(5734),
    [sym_tag] = ACTIONS(5734),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5734),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1151] = {
    [sym_expression] = STATE(6266),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5738),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5740),
    [anon_sym_dynamic] = ACTIONS(5742),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1152] = {
    [ts_builtin_sym_end] = ACTIONS(5734),
    [anon_sym_LBRACE] = ACTIONS(5734),
    [anon_sym_RBRACE] = ACTIONS(5734),
    [anon_sym_COMMA] = ACTIONS(5734),
    [anon_sym_COLON_COLON] = ACTIONS(5734),
    [anon_sym_DASH_GT] = ACTIONS(5734),
    [anon_sym_where] = ACTIONS(5734),
    [anon_sym_EQ] = ACTIONS(5736),
    [anon_sym_COLON] = ACTIONS(5736),
    [anon_sym_PIPE] = ACTIONS(5736),
    [anon_sym_COLON_EQ] = ACTIONS(5734),
    [anon_sym_LPAREN] = ACTIONS(5734),
    [anon_sym_PLUS_EQ] = ACTIONS(5734),
    [anon_sym_DASH_EQ] = ACTIONS(5734),
    [anon_sym_STAR_EQ] = ACTIONS(5734),
    [anon_sym_SLASH_EQ] = ACTIONS(5734),
    [anon_sym_PERCENT_EQ] = ACTIONS(5734),
    [anon_sym_AMP_EQ] = ACTIONS(5734),
    [anon_sym_PIPE_EQ] = ACTIONS(5734),
    [anon_sym_CARET_EQ] = ACTIONS(5734),
    [anon_sym_LT_LT_EQ] = ACTIONS(5734),
    [anon_sym_GT_GT_EQ] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5734),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5734),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5734),
    [anon_sym_if] = ACTIONS(5734),
    [anon_sym_SEMI] = ACTIONS(5734),
    [anon_sym_else] = ACTIONS(5734),
    [anon_sym_when] = ACTIONS(5734),
    [anon_sym_in] = ACTIONS(5734),
    [anon_sym_case] = ACTIONS(5734),
    [anon_sym_QMARK] = ACTIONS(5734),
    [anon_sym_PLUS] = ACTIONS(5736),
    [anon_sym_DASH] = ACTIONS(5736),
    [anon_sym_TILDE] = ACTIONS(5736),
    [anon_sym_AMP] = ACTIONS(5736),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_or_else] = ACTIONS(5734),
    [anon_sym_AMP_AMP] = ACTIONS(5736),
    [anon_sym_GT] = ACTIONS(5736),
    [anon_sym_GT_EQ] = ACTIONS(5734),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_LT] = ACTIONS(5736),
    [anon_sym_EQ_EQ] = ACTIONS(5734),
    [anon_sym_BANG_EQ] = ACTIONS(5734),
    [anon_sym_TILDE_EQ] = ACTIONS(5734),
    [anon_sym_AMP_TILDE] = ACTIONS(5736),
    [anon_sym_LT_LT] = ACTIONS(5736),
    [anon_sym_GT_GT] = ACTIONS(5736),
    [anon_sym_STAR] = ACTIONS(5736),
    [anon_sym_SLASH] = ACTIONS(5736),
    [anon_sym_PERCENT] = ACTIONS(5736),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5734),
    [anon_sym_DOT] = ACTIONS(5736),
    [anon_sym_LBRACK] = ACTIONS(5734),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5734),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5734),
    [anon_sym_not_in] = ACTIONS(5734),
    [anon_sym_or_return] = ACTIONS(5734),
    [anon_sym_or_continue] = ACTIONS(5734),
    [anon_sym_or_break] = ACTIONS(5734),
    [anon_sym_CARET] = ACTIONS(5736),
    [sym_uninitialized] = ACTIONS(5734),
    [sym_tag] = ACTIONS(5734),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5734),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1153] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5744),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1154] = {
    [ts_builtin_sym_end] = ACTIONS(5746),
    [anon_sym_LBRACE] = ACTIONS(5746),
    [anon_sym_RBRACE] = ACTIONS(5746),
    [anon_sym_COMMA] = ACTIONS(5746),
    [anon_sym_COLON_COLON] = ACTIONS(5746),
    [anon_sym_DASH_GT] = ACTIONS(5746),
    [anon_sym_where] = ACTIONS(5746),
    [anon_sym_EQ] = ACTIONS(5748),
    [anon_sym_COLON] = ACTIONS(5748),
    [anon_sym_PIPE] = ACTIONS(5748),
    [anon_sym_COLON_EQ] = ACTIONS(5746),
    [anon_sym_LPAREN] = ACTIONS(5746),
    [anon_sym_PLUS_EQ] = ACTIONS(5746),
    [anon_sym_DASH_EQ] = ACTIONS(5746),
    [anon_sym_STAR_EQ] = ACTIONS(5746),
    [anon_sym_SLASH_EQ] = ACTIONS(5746),
    [anon_sym_PERCENT_EQ] = ACTIONS(5746),
    [anon_sym_AMP_EQ] = ACTIONS(5746),
    [anon_sym_PIPE_EQ] = ACTIONS(5746),
    [anon_sym_CARET_EQ] = ACTIONS(5746),
    [anon_sym_LT_LT_EQ] = ACTIONS(5746),
    [anon_sym_GT_GT_EQ] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5746),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5746),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5746),
    [anon_sym_if] = ACTIONS(5746),
    [anon_sym_SEMI] = ACTIONS(5746),
    [anon_sym_else] = ACTIONS(5746),
    [anon_sym_when] = ACTIONS(5746),
    [anon_sym_in] = ACTIONS(5746),
    [anon_sym_case] = ACTIONS(5746),
    [anon_sym_QMARK] = ACTIONS(5746),
    [anon_sym_PLUS] = ACTIONS(5748),
    [anon_sym_DASH] = ACTIONS(5748),
    [anon_sym_TILDE] = ACTIONS(5748),
    [anon_sym_AMP] = ACTIONS(5748),
    [anon_sym_PIPE_PIPE] = ACTIONS(5748),
    [anon_sym_or_else] = ACTIONS(5746),
    [anon_sym_AMP_AMP] = ACTIONS(5748),
    [anon_sym_GT] = ACTIONS(5748),
    [anon_sym_GT_EQ] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_LT] = ACTIONS(5748),
    [anon_sym_EQ_EQ] = ACTIONS(5746),
    [anon_sym_BANG_EQ] = ACTIONS(5746),
    [anon_sym_TILDE_EQ] = ACTIONS(5746),
    [anon_sym_AMP_TILDE] = ACTIONS(5748),
    [anon_sym_LT_LT] = ACTIONS(5748),
    [anon_sym_GT_GT] = ACTIONS(5748),
    [anon_sym_STAR] = ACTIONS(5748),
    [anon_sym_SLASH] = ACTIONS(5748),
    [anon_sym_PERCENT] = ACTIONS(5748),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(5748),
    [anon_sym_LBRACK] = ACTIONS(5746),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5746),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5746),
    [anon_sym_not_in] = ACTIONS(5746),
    [anon_sym_or_return] = ACTIONS(5746),
    [anon_sym_or_continue] = ACTIONS(5746),
    [anon_sym_or_break] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(5748),
    [sym_uninitialized] = ACTIONS(5746),
    [sym_tag] = ACTIONS(5746),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5746),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1155] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8045),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1156] = {
    [sym_expression] = STATE(6281),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(3915),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(3919),
    [anon_sym_dynamic] = ACTIONS(3921),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1157] = {
    [ts_builtin_sym_end] = ACTIONS(5752),
    [anon_sym_LBRACE] = ACTIONS(5752),
    [anon_sym_RBRACE] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5752),
    [anon_sym_COLON_COLON] = ACTIONS(5752),
    [anon_sym_DASH_GT] = ACTIONS(5752),
    [anon_sym_where] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5754),
    [anon_sym_COLON] = ACTIONS(5754),
    [anon_sym_PIPE] = ACTIONS(5754),
    [anon_sym_COLON_EQ] = ACTIONS(5752),
    [anon_sym_LPAREN] = ACTIONS(5752),
    [anon_sym_PLUS_EQ] = ACTIONS(5752),
    [anon_sym_DASH_EQ] = ACTIONS(5752),
    [anon_sym_STAR_EQ] = ACTIONS(5752),
    [anon_sym_SLASH_EQ] = ACTIONS(5752),
    [anon_sym_PERCENT_EQ] = ACTIONS(5752),
    [anon_sym_AMP_EQ] = ACTIONS(5752),
    [anon_sym_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_CARET_EQ] = ACTIONS(5752),
    [anon_sym_LT_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT_GT_EQ] = ACTIONS(5752),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5752),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5752),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5752),
    [anon_sym_if] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5752),
    [anon_sym_else] = ACTIONS(5752),
    [anon_sym_when] = ACTIONS(5752),
    [anon_sym_in] = ACTIONS(5752),
    [anon_sym_case] = ACTIONS(5752),
    [anon_sym_QMARK] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5754),
    [anon_sym_DASH] = ACTIONS(5754),
    [anon_sym_TILDE] = ACTIONS(5754),
    [anon_sym_AMP] = ACTIONS(5754),
    [anon_sym_PIPE_PIPE] = ACTIONS(5754),
    [anon_sym_or_else] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5754),
    [anon_sym_GT] = ACTIONS(5754),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5754),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5752),
    [anon_sym_TILDE_EQ] = ACTIONS(5752),
    [anon_sym_AMP_TILDE] = ACTIONS(5754),
    [anon_sym_LT_LT] = ACTIONS(5754),
    [anon_sym_GT_GT] = ACTIONS(5754),
    [anon_sym_STAR] = ACTIONS(5754),
    [anon_sym_SLASH] = ACTIONS(5754),
    [anon_sym_PERCENT] = ACTIONS(5754),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5752),
    [anon_sym_DOT] = ACTIONS(5754),
    [anon_sym_LBRACK] = ACTIONS(5752),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5752),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5752),
    [anon_sym_not_in] = ACTIONS(5752),
    [anon_sym_or_return] = ACTIONS(5752),
    [anon_sym_or_continue] = ACTIONS(5752),
    [anon_sym_or_break] = ACTIONS(5752),
    [anon_sym_CARET] = ACTIONS(5754),
    [sym_uninitialized] = ACTIONS(5752),
    [sym_tag] = ACTIONS(5752),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5752),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1158] = {
    [ts_builtin_sym_end] = ACTIONS(5756),
    [anon_sym_LBRACE] = ACTIONS(5756),
    [anon_sym_RBRACE] = ACTIONS(5756),
    [anon_sym_COMMA] = ACTIONS(5756),
    [anon_sym_COLON_COLON] = ACTIONS(5756),
    [anon_sym_DASH_GT] = ACTIONS(5756),
    [anon_sym_where] = ACTIONS(5756),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_COLON] = ACTIONS(5758),
    [anon_sym_PIPE] = ACTIONS(5758),
    [anon_sym_COLON_EQ] = ACTIONS(5756),
    [anon_sym_LPAREN] = ACTIONS(5756),
    [anon_sym_PLUS_EQ] = ACTIONS(5756),
    [anon_sym_DASH_EQ] = ACTIONS(5756),
    [anon_sym_STAR_EQ] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_PERCENT_EQ] = ACTIONS(5756),
    [anon_sym_AMP_EQ] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_CARET_EQ] = ACTIONS(5756),
    [anon_sym_LT_LT_EQ] = ACTIONS(5756),
    [anon_sym_GT_GT_EQ] = ACTIONS(5756),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5756),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5756),
    [anon_sym_if] = ACTIONS(5756),
    [anon_sym_SEMI] = ACTIONS(5756),
    [anon_sym_else] = ACTIONS(5756),
    [anon_sym_when] = ACTIONS(5756),
    [anon_sym_in] = ACTIONS(5756),
    [anon_sym_case] = ACTIONS(5756),
    [anon_sym_QMARK] = ACTIONS(5756),
    [anon_sym_PLUS] = ACTIONS(5758),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_TILDE] = ACTIONS(5758),
    [anon_sym_AMP] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5758),
    [anon_sym_or_else] = ACTIONS(5756),
    [anon_sym_AMP_AMP] = ACTIONS(5758),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_LT_EQ] = ACTIONS(5756),
    [anon_sym_LT] = ACTIONS(5758),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5756),
    [anon_sym_TILDE_EQ] = ACTIONS(5756),
    [anon_sym_AMP_TILDE] = ACTIONS(5758),
    [anon_sym_LT_LT] = ACTIONS(5758),
    [anon_sym_GT_GT] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(5758),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_PERCENT] = ACTIONS(5758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5756),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_LBRACK] = ACTIONS(5756),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5756),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5756),
    [anon_sym_not_in] = ACTIONS(5756),
    [anon_sym_or_return] = ACTIONS(5756),
    [anon_sym_or_continue] = ACTIONS(5756),
    [anon_sym_or_break] = ACTIONS(5756),
    [anon_sym_CARET] = ACTIONS(5758),
    [sym_uninitialized] = ACTIONS(5756),
    [sym_tag] = ACTIONS(5756),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5756),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1159] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8191),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5760),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1160] = {
    [sym_expression] = STATE(6378),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8711),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1161] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8320),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5762),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1162] = {
    [ts_builtin_sym_end] = ACTIONS(5764),
    [anon_sym_LBRACE] = ACTIONS(5764),
    [anon_sym_RBRACE] = ACTIONS(5764),
    [anon_sym_COMMA] = ACTIONS(5764),
    [anon_sym_COLON_COLON] = ACTIONS(5764),
    [anon_sym_DASH_GT] = ACTIONS(5764),
    [anon_sym_where] = ACTIONS(5764),
    [anon_sym_EQ] = ACTIONS(5766),
    [anon_sym_COLON] = ACTIONS(5766),
    [anon_sym_PIPE] = ACTIONS(5766),
    [anon_sym_COLON_EQ] = ACTIONS(5764),
    [anon_sym_LPAREN] = ACTIONS(5764),
    [anon_sym_PLUS_EQ] = ACTIONS(5764),
    [anon_sym_DASH_EQ] = ACTIONS(5764),
    [anon_sym_STAR_EQ] = ACTIONS(5764),
    [anon_sym_SLASH_EQ] = ACTIONS(5764),
    [anon_sym_PERCENT_EQ] = ACTIONS(5764),
    [anon_sym_AMP_EQ] = ACTIONS(5764),
    [anon_sym_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_CARET_EQ] = ACTIONS(5764),
    [anon_sym_LT_LT_EQ] = ACTIONS(5764),
    [anon_sym_GT_GT_EQ] = ACTIONS(5764),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5764),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5764),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5764),
    [anon_sym_if] = ACTIONS(5764),
    [anon_sym_SEMI] = ACTIONS(5764),
    [anon_sym_else] = ACTIONS(5764),
    [anon_sym_when] = ACTIONS(5764),
    [anon_sym_in] = ACTIONS(5764),
    [anon_sym_case] = ACTIONS(5764),
    [anon_sym_QMARK] = ACTIONS(5764),
    [anon_sym_PLUS] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5766),
    [anon_sym_TILDE] = ACTIONS(5766),
    [anon_sym_AMP] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5766),
    [anon_sym_or_else] = ACTIONS(5764),
    [anon_sym_AMP_AMP] = ACTIONS(5766),
    [anon_sym_GT] = ACTIONS(5766),
    [anon_sym_GT_EQ] = ACTIONS(5764),
    [anon_sym_LT_EQ] = ACTIONS(5764),
    [anon_sym_LT] = ACTIONS(5766),
    [anon_sym_EQ_EQ] = ACTIONS(5764),
    [anon_sym_BANG_EQ] = ACTIONS(5764),
    [anon_sym_TILDE_EQ] = ACTIONS(5764),
    [anon_sym_AMP_TILDE] = ACTIONS(5766),
    [anon_sym_LT_LT] = ACTIONS(5766),
    [anon_sym_GT_GT] = ACTIONS(5766),
    [anon_sym_STAR] = ACTIONS(5766),
    [anon_sym_SLASH] = ACTIONS(5766),
    [anon_sym_PERCENT] = ACTIONS(5766),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5764),
    [anon_sym_DOT] = ACTIONS(5766),
    [anon_sym_LBRACK] = ACTIONS(5764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5764),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5764),
    [anon_sym_not_in] = ACTIONS(5764),
    [anon_sym_or_return] = ACTIONS(5764),
    [anon_sym_or_continue] = ACTIONS(5764),
    [anon_sym_or_break] = ACTIONS(5764),
    [anon_sym_CARET] = ACTIONS(5766),
    [sym_uninitialized] = ACTIONS(5764),
    [sym_tag] = ACTIONS(5764),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5764),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1163] = {
    [ts_builtin_sym_end] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(5768),
    [anon_sym_RBRACE] = ACTIONS(5768),
    [anon_sym_COMMA] = ACTIONS(5768),
    [anon_sym_COLON_COLON] = ACTIONS(5768),
    [anon_sym_DASH_GT] = ACTIONS(5768),
    [anon_sym_where] = ACTIONS(5768),
    [anon_sym_EQ] = ACTIONS(5770),
    [anon_sym_COLON] = ACTIONS(5770),
    [anon_sym_PIPE] = ACTIONS(5770),
    [anon_sym_COLON_EQ] = ACTIONS(5768),
    [anon_sym_LPAREN] = ACTIONS(5768),
    [anon_sym_PLUS_EQ] = ACTIONS(5768),
    [anon_sym_DASH_EQ] = ACTIONS(5768),
    [anon_sym_STAR_EQ] = ACTIONS(5768),
    [anon_sym_SLASH_EQ] = ACTIONS(5768),
    [anon_sym_PERCENT_EQ] = ACTIONS(5768),
    [anon_sym_AMP_EQ] = ACTIONS(5768),
    [anon_sym_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_CARET_EQ] = ACTIONS(5768),
    [anon_sym_LT_LT_EQ] = ACTIONS(5768),
    [anon_sym_GT_GT_EQ] = ACTIONS(5768),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5768),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5768),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5768),
    [anon_sym_if] = ACTIONS(5768),
    [anon_sym_SEMI] = ACTIONS(5768),
    [anon_sym_else] = ACTIONS(5768),
    [anon_sym_when] = ACTIONS(5768),
    [anon_sym_in] = ACTIONS(5768),
    [anon_sym_case] = ACTIONS(5768),
    [anon_sym_QMARK] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5770),
    [anon_sym_DASH] = ACTIONS(5770),
    [anon_sym_TILDE] = ACTIONS(5770),
    [anon_sym_AMP] = ACTIONS(5770),
    [anon_sym_PIPE_PIPE] = ACTIONS(5770),
    [anon_sym_or_else] = ACTIONS(5768),
    [anon_sym_AMP_AMP] = ACTIONS(5770),
    [anon_sym_GT] = ACTIONS(5770),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_LT_EQ] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5770),
    [anon_sym_EQ_EQ] = ACTIONS(5768),
    [anon_sym_BANG_EQ] = ACTIONS(5768),
    [anon_sym_TILDE_EQ] = ACTIONS(5768),
    [anon_sym_AMP_TILDE] = ACTIONS(5770),
    [anon_sym_LT_LT] = ACTIONS(5770),
    [anon_sym_GT_GT] = ACTIONS(5770),
    [anon_sym_STAR] = ACTIONS(5770),
    [anon_sym_SLASH] = ACTIONS(5770),
    [anon_sym_PERCENT] = ACTIONS(5770),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5768),
    [anon_sym_DOT] = ACTIONS(5770),
    [anon_sym_LBRACK] = ACTIONS(5768),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5768),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5768),
    [anon_sym_not_in] = ACTIONS(5768),
    [anon_sym_or_return] = ACTIONS(5768),
    [anon_sym_or_continue] = ACTIONS(5768),
    [anon_sym_or_break] = ACTIONS(5768),
    [anon_sym_CARET] = ACTIONS(5770),
    [sym_uninitialized] = ACTIONS(5768),
    [sym_tag] = ACTIONS(5768),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5768),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1164] = {
    [ts_builtin_sym_end] = ACTIONS(5772),
    [anon_sym_LBRACE] = ACTIONS(5772),
    [anon_sym_RBRACE] = ACTIONS(5772),
    [anon_sym_COMMA] = ACTIONS(5772),
    [anon_sym_COLON_COLON] = ACTIONS(5772),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5772),
    [anon_sym_EQ] = ACTIONS(5774),
    [anon_sym_COLON] = ACTIONS(5774),
    [anon_sym_PIPE] = ACTIONS(4734),
    [anon_sym_COLON_EQ] = ACTIONS(5772),
    [anon_sym_LPAREN] = ACTIONS(5772),
    [anon_sym_PLUS_EQ] = ACTIONS(5772),
    [anon_sym_DASH_EQ] = ACTIONS(5772),
    [anon_sym_STAR_EQ] = ACTIONS(5772),
    [anon_sym_SLASH_EQ] = ACTIONS(5772),
    [anon_sym_PERCENT_EQ] = ACTIONS(5772),
    [anon_sym_AMP_EQ] = ACTIONS(5772),
    [anon_sym_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_CARET_EQ] = ACTIONS(5772),
    [anon_sym_LT_LT_EQ] = ACTIONS(5772),
    [anon_sym_GT_GT_EQ] = ACTIONS(5772),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5772),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5772),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5772),
    [anon_sym_if] = ACTIONS(5772),
    [anon_sym_SEMI] = ACTIONS(5772),
    [anon_sym_else] = ACTIONS(5772),
    [anon_sym_when] = ACTIONS(5772),
    [anon_sym_in] = ACTIONS(5772),
    [anon_sym_case] = ACTIONS(5772),
    [anon_sym_QMARK] = ACTIONS(5772),
    [anon_sym_PLUS] = ACTIONS(4736),
    [anon_sym_DASH] = ACTIONS(4736),
    [anon_sym_TILDE] = ACTIONS(4738),
    [anon_sym_AMP] = ACTIONS(4740),
    [anon_sym_PIPE_PIPE] = ACTIONS(4742),
    [anon_sym_or_else] = ACTIONS(4744),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_GT] = ACTIONS(4748),
    [anon_sym_GT_EQ] = ACTIONS(4750),
    [anon_sym_LT_EQ] = ACTIONS(4750),
    [anon_sym_LT] = ACTIONS(4748),
    [anon_sym_EQ_EQ] = ACTIONS(4752),
    [anon_sym_BANG_EQ] = ACTIONS(4752),
    [anon_sym_TILDE_EQ] = ACTIONS(4752),
    [anon_sym_AMP_TILDE] = ACTIONS(4754),
    [anon_sym_LT_LT] = ACTIONS(4756),
    [anon_sym_GT_GT] = ACTIONS(4756),
    [anon_sym_STAR] = ACTIONS(4758),
    [anon_sym_SLASH] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4760),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5772),
    [anon_sym_or_return] = ACTIONS(4768),
    [anon_sym_or_continue] = ACTIONS(4770),
    [anon_sym_or_break] = ACTIONS(4772),
    [anon_sym_CARET] = ACTIONS(4774),
    [sym_uninitialized] = ACTIONS(5772),
    [sym_tag] = ACTIONS(5772),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5772),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1165] = {
    [ts_builtin_sym_end] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(5378),
    [anon_sym_RBRACE] = ACTIONS(5378),
    [anon_sym_COMMA] = ACTIONS(5378),
    [anon_sym_COLON_COLON] = ACTIONS(5378),
    [anon_sym_DASH_GT] = ACTIONS(5378),
    [anon_sym_where] = ACTIONS(5378),
    [anon_sym_EQ] = ACTIONS(5380),
    [anon_sym_COLON] = ACTIONS(5380),
    [anon_sym_PIPE] = ACTIONS(5380),
    [anon_sym_COLON_EQ] = ACTIONS(5378),
    [anon_sym_LPAREN] = ACTIONS(5378),
    [anon_sym_PLUS_EQ] = ACTIONS(5378),
    [anon_sym_DASH_EQ] = ACTIONS(5378),
    [anon_sym_STAR_EQ] = ACTIONS(5378),
    [anon_sym_SLASH_EQ] = ACTIONS(5378),
    [anon_sym_PERCENT_EQ] = ACTIONS(5378),
    [anon_sym_AMP_EQ] = ACTIONS(5378),
    [anon_sym_PIPE_EQ] = ACTIONS(5378),
    [anon_sym_CARET_EQ] = ACTIONS(5378),
    [anon_sym_LT_LT_EQ] = ACTIONS(5378),
    [anon_sym_GT_GT_EQ] = ACTIONS(5378),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5378),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5378),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5378),
    [anon_sym_if] = ACTIONS(5378),
    [anon_sym_SEMI] = ACTIONS(5378),
    [anon_sym_else] = ACTIONS(5378),
    [anon_sym_when] = ACTIONS(5378),
    [anon_sym_in] = ACTIONS(5378),
    [anon_sym_case] = ACTIONS(5378),
    [anon_sym_QMARK] = ACTIONS(5378),
    [anon_sym_PLUS] = ACTIONS(5380),
    [anon_sym_DASH] = ACTIONS(5380),
    [anon_sym_TILDE] = ACTIONS(5380),
    [anon_sym_AMP] = ACTIONS(5380),
    [anon_sym_PIPE_PIPE] = ACTIONS(5380),
    [anon_sym_or_else] = ACTIONS(5378),
    [anon_sym_AMP_AMP] = ACTIONS(5380),
    [anon_sym_GT] = ACTIONS(5380),
    [anon_sym_GT_EQ] = ACTIONS(5378),
    [anon_sym_LT_EQ] = ACTIONS(5378),
    [anon_sym_LT] = ACTIONS(5380),
    [anon_sym_EQ_EQ] = ACTIONS(5378),
    [anon_sym_BANG_EQ] = ACTIONS(5378),
    [anon_sym_TILDE_EQ] = ACTIONS(5378),
    [anon_sym_AMP_TILDE] = ACTIONS(5380),
    [anon_sym_LT_LT] = ACTIONS(5380),
    [anon_sym_GT_GT] = ACTIONS(5380),
    [anon_sym_STAR] = ACTIONS(5380),
    [anon_sym_SLASH] = ACTIONS(5380),
    [anon_sym_PERCENT] = ACTIONS(5380),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5378),
    [anon_sym_DOT] = ACTIONS(5380),
    [anon_sym_LBRACK] = ACTIONS(5378),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5378),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5378),
    [anon_sym_not_in] = ACTIONS(5378),
    [anon_sym_or_return] = ACTIONS(5378),
    [anon_sym_or_continue] = ACTIONS(5378),
    [anon_sym_or_break] = ACTIONS(5378),
    [anon_sym_CARET] = ACTIONS(5380),
    [sym_uninitialized] = ACTIONS(5378),
    [sym_tag] = ACTIONS(5378),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5378),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1166] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5776),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1167] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5778),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1168] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5780),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1169] = {
    [ts_builtin_sym_end] = ACTIONS(5782),
    [anon_sym_LBRACE] = ACTIONS(5782),
    [anon_sym_RBRACE] = ACTIONS(5782),
    [anon_sym_COMMA] = ACTIONS(5782),
    [anon_sym_COLON_COLON] = ACTIONS(5782),
    [anon_sym_DASH_GT] = ACTIONS(5782),
    [anon_sym_where] = ACTIONS(5782),
    [anon_sym_EQ] = ACTIONS(5784),
    [anon_sym_COLON] = ACTIONS(5784),
    [anon_sym_PIPE] = ACTIONS(5784),
    [anon_sym_COLON_EQ] = ACTIONS(5782),
    [anon_sym_LPAREN] = ACTIONS(5782),
    [anon_sym_PLUS_EQ] = ACTIONS(5782),
    [anon_sym_DASH_EQ] = ACTIONS(5782),
    [anon_sym_STAR_EQ] = ACTIONS(5782),
    [anon_sym_SLASH_EQ] = ACTIONS(5782),
    [anon_sym_PERCENT_EQ] = ACTIONS(5782),
    [anon_sym_AMP_EQ] = ACTIONS(5782),
    [anon_sym_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_CARET_EQ] = ACTIONS(5782),
    [anon_sym_LT_LT_EQ] = ACTIONS(5782),
    [anon_sym_GT_GT_EQ] = ACTIONS(5782),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5782),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5782),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5782),
    [anon_sym_if] = ACTIONS(5782),
    [anon_sym_SEMI] = ACTIONS(5782),
    [anon_sym_else] = ACTIONS(5782),
    [anon_sym_when] = ACTIONS(5782),
    [anon_sym_in] = ACTIONS(5782),
    [anon_sym_case] = ACTIONS(5782),
    [anon_sym_QMARK] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5784),
    [anon_sym_DASH] = ACTIONS(5784),
    [anon_sym_TILDE] = ACTIONS(5784),
    [anon_sym_AMP] = ACTIONS(5784),
    [anon_sym_PIPE_PIPE] = ACTIONS(5784),
    [anon_sym_or_else] = ACTIONS(5782),
    [anon_sym_AMP_AMP] = ACTIONS(5784),
    [anon_sym_GT] = ACTIONS(5784),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_LT_EQ] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5784),
    [anon_sym_EQ_EQ] = ACTIONS(5782),
    [anon_sym_BANG_EQ] = ACTIONS(5782),
    [anon_sym_TILDE_EQ] = ACTIONS(5782),
    [anon_sym_AMP_TILDE] = ACTIONS(5784),
    [anon_sym_LT_LT] = ACTIONS(5784),
    [anon_sym_GT_GT] = ACTIONS(5784),
    [anon_sym_STAR] = ACTIONS(5784),
    [anon_sym_SLASH] = ACTIONS(5784),
    [anon_sym_PERCENT] = ACTIONS(5784),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5782),
    [anon_sym_DOT] = ACTIONS(5784),
    [anon_sym_LBRACK] = ACTIONS(5782),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5782),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5782),
    [anon_sym_not_in] = ACTIONS(5782),
    [anon_sym_or_return] = ACTIONS(5782),
    [anon_sym_or_continue] = ACTIONS(5782),
    [anon_sym_or_break] = ACTIONS(5782),
    [anon_sym_CARET] = ACTIONS(5784),
    [sym_uninitialized] = ACTIONS(5782),
    [sym_tag] = ACTIONS(5782),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5782),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1170] = {
    [ts_builtin_sym_end] = ACTIONS(5718),
    [anon_sym_LBRACE] = ACTIONS(5718),
    [anon_sym_RBRACE] = ACTIONS(5718),
    [anon_sym_COMMA] = ACTIONS(5718),
    [anon_sym_COLON_COLON] = ACTIONS(5718),
    [anon_sym_DASH_GT] = ACTIONS(4730),
    [anon_sym_where] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_COLON] = ACTIONS(5720),
    [anon_sym_PIPE] = ACTIONS(4734),
    [anon_sym_COLON_EQ] = ACTIONS(5718),
    [anon_sym_LPAREN] = ACTIONS(5718),
    [anon_sym_PLUS_EQ] = ACTIONS(5718),
    [anon_sym_DASH_EQ] = ACTIONS(5718),
    [anon_sym_STAR_EQ] = ACTIONS(5718),
    [anon_sym_SLASH_EQ] = ACTIONS(5718),
    [anon_sym_PERCENT_EQ] = ACTIONS(5718),
    [anon_sym_AMP_EQ] = ACTIONS(5718),
    [anon_sym_PIPE_EQ] = ACTIONS(5718),
    [anon_sym_CARET_EQ] = ACTIONS(5718),
    [anon_sym_LT_LT_EQ] = ACTIONS(5718),
    [anon_sym_GT_GT_EQ] = ACTIONS(5718),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5718),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5718),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5718),
    [anon_sym_if] = ACTIONS(5718),
    [anon_sym_SEMI] = ACTIONS(5718),
    [anon_sym_else] = ACTIONS(5718),
    [anon_sym_when] = ACTIONS(5718),
    [anon_sym_in] = ACTIONS(5718),
    [anon_sym_case] = ACTIONS(5718),
    [anon_sym_QMARK] = ACTIONS(5718),
    [anon_sym_PLUS] = ACTIONS(4736),
    [anon_sym_DASH] = ACTIONS(4736),
    [anon_sym_TILDE] = ACTIONS(4738),
    [anon_sym_AMP] = ACTIONS(4740),
    [anon_sym_PIPE_PIPE] = ACTIONS(4742),
    [anon_sym_or_else] = ACTIONS(4744),
    [anon_sym_AMP_AMP] = ACTIONS(4746),
    [anon_sym_GT] = ACTIONS(4748),
    [anon_sym_GT_EQ] = ACTIONS(4750),
    [anon_sym_LT_EQ] = ACTIONS(4750),
    [anon_sym_LT] = ACTIONS(4748),
    [anon_sym_EQ_EQ] = ACTIONS(4752),
    [anon_sym_BANG_EQ] = ACTIONS(4752),
    [anon_sym_TILDE_EQ] = ACTIONS(4752),
    [anon_sym_AMP_TILDE] = ACTIONS(4754),
    [anon_sym_LT_LT] = ACTIONS(4756),
    [anon_sym_GT_GT] = ACTIONS(4756),
    [anon_sym_STAR] = ACTIONS(4758),
    [anon_sym_SLASH] = ACTIONS(4758),
    [anon_sym_PERCENT] = ACTIONS(4758),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4760),
    [anon_sym_DOT] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4766),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4766),
    [anon_sym_not_in] = ACTIONS(5718),
    [anon_sym_or_return] = ACTIONS(5718),
    [anon_sym_or_continue] = ACTIONS(5718),
    [anon_sym_or_break] = ACTIONS(5718),
    [anon_sym_CARET] = ACTIONS(5720),
    [sym_uninitialized] = ACTIONS(5718),
    [sym_tag] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5718),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1171] = {
    [sym_expression] = STATE(6332),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5788),
    [anon_sym_dynamic] = ACTIONS(5790),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1172] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5792),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1173] = {
    [sym_expression] = STATE(6326),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8677),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1174] = {
    [sym_procedure] = STATE(7281),
    [sym_expression] = STATE(5745),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_proc] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1175] = {
    [sym_expression] = STATE(6352),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4257),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4261),
    [anon_sym_dynamic] = ACTIONS(4263),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1176] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5794),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1177] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7874),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5796),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1178] = {
    [sym_expression] = STATE(6353),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5798),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5800),
    [anon_sym_dynamic] = ACTIONS(5802),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1179] = {
    [sym_expression] = STATE(6360),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(5804),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(5806),
    [anon_sym_dynamic] = ACTIONS(5808),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1180] = {
    [sym_expression] = STATE(6361),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8658),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1181] = {
    [sym_expression] = STATE(6448),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8683),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1182] = {
    [ts_builtin_sym_end] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_COLON_COLON] = ACTIONS(5810),
    [anon_sym_DASH_GT] = ACTIONS(5810),
    [anon_sym_where] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5812),
    [anon_sym_COLON] = ACTIONS(5812),
    [anon_sym_PIPE] = ACTIONS(5812),
    [anon_sym_COLON_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_PLUS_EQ] = ACTIONS(5810),
    [anon_sym_DASH_EQ] = ACTIONS(5810),
    [anon_sym_STAR_EQ] = ACTIONS(5810),
    [anon_sym_SLASH_EQ] = ACTIONS(5810),
    [anon_sym_PERCENT_EQ] = ACTIONS(5810),
    [anon_sym_AMP_EQ] = ACTIONS(5810),
    [anon_sym_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_CARET_EQ] = ACTIONS(5810),
    [anon_sym_LT_LT_EQ] = ACTIONS(5810),
    [anon_sym_GT_GT_EQ] = ACTIONS(5810),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5810),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5810),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5810),
    [anon_sym_if] = ACTIONS(5810),
    [anon_sym_SEMI] = ACTIONS(5810),
    [anon_sym_else] = ACTIONS(5810),
    [anon_sym_when] = ACTIONS(5810),
    [anon_sym_in] = ACTIONS(5810),
    [anon_sym_case] = ACTIONS(5810),
    [anon_sym_QMARK] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5812),
    [anon_sym_DASH] = ACTIONS(5812),
    [anon_sym_TILDE] = ACTIONS(5812),
    [anon_sym_AMP] = ACTIONS(5812),
    [anon_sym_PIPE_PIPE] = ACTIONS(5812),
    [anon_sym_or_else] = ACTIONS(5810),
    [anon_sym_AMP_AMP] = ACTIONS(5812),
    [anon_sym_GT] = ACTIONS(5812),
    [anon_sym_GT_EQ] = ACTIONS(5810),
    [anon_sym_LT_EQ] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5812),
    [anon_sym_EQ_EQ] = ACTIONS(5810),
    [anon_sym_BANG_EQ] = ACTIONS(5810),
    [anon_sym_TILDE_EQ] = ACTIONS(5810),
    [anon_sym_AMP_TILDE] = ACTIONS(5812),
    [anon_sym_LT_LT] = ACTIONS(5812),
    [anon_sym_GT_GT] = ACTIONS(5812),
    [anon_sym_STAR] = ACTIONS(5812),
    [anon_sym_SLASH] = ACTIONS(5812),
    [anon_sym_PERCENT] = ACTIONS(5812),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5810),
    [anon_sym_DOT] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5810),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5810),
    [anon_sym_not_in] = ACTIONS(5810),
    [anon_sym_or_return] = ACTIONS(5810),
    [anon_sym_or_continue] = ACTIONS(5810),
    [anon_sym_or_break] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5812),
    [sym_uninitialized] = ACTIONS(5810),
    [sym_tag] = ACTIONS(5810),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5810),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1183] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5796),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1184] = {
    [sym_expression] = STATE(6388),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8659),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1185] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5814),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1186] = {
    [sym_expression] = STATE(6440),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8668),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1187] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5816),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1188] = {
    [sym_expression] = STATE(6453),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8701),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1189] = {
    [sym_expression] = STATE(6452),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8720),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1190] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5818),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1191] = {
    [ts_builtin_sym_end] = ACTIONS(5820),
    [anon_sym_LBRACE] = ACTIONS(5820),
    [anon_sym_RBRACE] = ACTIONS(5820),
    [anon_sym_COMMA] = ACTIONS(5820),
    [anon_sym_COLON_COLON] = ACTIONS(5820),
    [anon_sym_DASH_GT] = ACTIONS(5820),
    [anon_sym_where] = ACTIONS(5820),
    [anon_sym_EQ] = ACTIONS(5822),
    [anon_sym_COLON] = ACTIONS(5822),
    [anon_sym_PIPE] = ACTIONS(5822),
    [anon_sym_COLON_EQ] = ACTIONS(5820),
    [anon_sym_LPAREN] = ACTIONS(5820),
    [anon_sym_PLUS_EQ] = ACTIONS(5820),
    [anon_sym_DASH_EQ] = ACTIONS(5820),
    [anon_sym_STAR_EQ] = ACTIONS(5820),
    [anon_sym_SLASH_EQ] = ACTIONS(5820),
    [anon_sym_PERCENT_EQ] = ACTIONS(5820),
    [anon_sym_AMP_EQ] = ACTIONS(5820),
    [anon_sym_PIPE_EQ] = ACTIONS(5820),
    [anon_sym_CARET_EQ] = ACTIONS(5820),
    [anon_sym_LT_LT_EQ] = ACTIONS(5820),
    [anon_sym_GT_GT_EQ] = ACTIONS(5820),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5820),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5820),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5820),
    [anon_sym_if] = ACTIONS(5820),
    [anon_sym_SEMI] = ACTIONS(5820),
    [anon_sym_else] = ACTIONS(5820),
    [anon_sym_when] = ACTIONS(5820),
    [anon_sym_in] = ACTIONS(5820),
    [anon_sym_case] = ACTIONS(5820),
    [anon_sym_QMARK] = ACTIONS(5820),
    [anon_sym_PLUS] = ACTIONS(5822),
    [anon_sym_DASH] = ACTIONS(5822),
    [anon_sym_TILDE] = ACTIONS(5822),
    [anon_sym_AMP] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_or_else] = ACTIONS(5820),
    [anon_sym_AMP_AMP] = ACTIONS(5822),
    [anon_sym_GT] = ACTIONS(5822),
    [anon_sym_GT_EQ] = ACTIONS(5820),
    [anon_sym_LT_EQ] = ACTIONS(5820),
    [anon_sym_LT] = ACTIONS(5822),
    [anon_sym_EQ_EQ] = ACTIONS(5820),
    [anon_sym_BANG_EQ] = ACTIONS(5820),
    [anon_sym_TILDE_EQ] = ACTIONS(5820),
    [anon_sym_AMP_TILDE] = ACTIONS(5822),
    [anon_sym_LT_LT] = ACTIONS(5822),
    [anon_sym_GT_GT] = ACTIONS(5822),
    [anon_sym_STAR] = ACTIONS(5822),
    [anon_sym_SLASH] = ACTIONS(5822),
    [anon_sym_PERCENT] = ACTIONS(5822),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5820),
    [anon_sym_DOT] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5820),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5820),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5820),
    [anon_sym_not_in] = ACTIONS(5820),
    [anon_sym_or_return] = ACTIONS(5820),
    [anon_sym_or_continue] = ACTIONS(5820),
    [anon_sym_or_break] = ACTIONS(5820),
    [anon_sym_CARET] = ACTIONS(5822),
    [sym_uninitialized] = ACTIONS(5820),
    [sym_tag] = ACTIONS(5820),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5820),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1192] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7960),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5814),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1193] = {
    [ts_builtin_sym_end] = ACTIONS(5824),
    [anon_sym_LBRACE] = ACTIONS(5824),
    [anon_sym_RBRACE] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5824),
    [anon_sym_COLON_COLON] = ACTIONS(5824),
    [anon_sym_DASH_GT] = ACTIONS(5824),
    [anon_sym_where] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5826),
    [anon_sym_COLON] = ACTIONS(5826),
    [anon_sym_PIPE] = ACTIONS(5826),
    [anon_sym_COLON_EQ] = ACTIONS(5824),
    [anon_sym_LPAREN] = ACTIONS(5824),
    [anon_sym_PLUS_EQ] = ACTIONS(5824),
    [anon_sym_DASH_EQ] = ACTIONS(5824),
    [anon_sym_STAR_EQ] = ACTIONS(5824),
    [anon_sym_SLASH_EQ] = ACTIONS(5824),
    [anon_sym_PERCENT_EQ] = ACTIONS(5824),
    [anon_sym_AMP_EQ] = ACTIONS(5824),
    [anon_sym_PIPE_EQ] = ACTIONS(5824),
    [anon_sym_CARET_EQ] = ACTIONS(5824),
    [anon_sym_LT_LT_EQ] = ACTIONS(5824),
    [anon_sym_GT_GT_EQ] = ACTIONS(5824),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5824),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5824),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5824),
    [anon_sym_if] = ACTIONS(5824),
    [anon_sym_SEMI] = ACTIONS(5824),
    [anon_sym_else] = ACTIONS(5824),
    [anon_sym_when] = ACTIONS(5824),
    [anon_sym_in] = ACTIONS(5824),
    [anon_sym_case] = ACTIONS(5824),
    [anon_sym_QMARK] = ACTIONS(5824),
    [anon_sym_PLUS] = ACTIONS(5826),
    [anon_sym_DASH] = ACTIONS(5826),
    [anon_sym_TILDE] = ACTIONS(5826),
    [anon_sym_AMP] = ACTIONS(5826),
    [anon_sym_PIPE_PIPE] = ACTIONS(5826),
    [anon_sym_or_else] = ACTIONS(5824),
    [anon_sym_AMP_AMP] = ACTIONS(5826),
    [anon_sym_GT] = ACTIONS(5826),
    [anon_sym_GT_EQ] = ACTIONS(5824),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5826),
    [anon_sym_EQ_EQ] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(5824),
    [anon_sym_TILDE_EQ] = ACTIONS(5824),
    [anon_sym_AMP_TILDE] = ACTIONS(5826),
    [anon_sym_LT_LT] = ACTIONS(5826),
    [anon_sym_GT_GT] = ACTIONS(5826),
    [anon_sym_STAR] = ACTIONS(5826),
    [anon_sym_SLASH] = ACTIONS(5826),
    [anon_sym_PERCENT] = ACTIONS(5826),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5824),
    [anon_sym_DOT] = ACTIONS(5826),
    [anon_sym_LBRACK] = ACTIONS(5824),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5824),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5824),
    [anon_sym_not_in] = ACTIONS(5824),
    [anon_sym_or_return] = ACTIONS(5824),
    [anon_sym_or_continue] = ACTIONS(5824),
    [anon_sym_or_break] = ACTIONS(5824),
    [anon_sym_CARET] = ACTIONS(5826),
    [sym_uninitialized] = ACTIONS(5824),
    [sym_tag] = ACTIONS(5824),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5824),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1194] = {
    [sym_expression] = STATE(6431),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8758),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1195] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8234),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5828),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1196] = {
    [sym_expression] = STATE(6190),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(4309),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(4313),
    [anon_sym_dynamic] = ACTIONS(4315),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1197] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5828),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1198] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5830),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1199] = {
    [sym_expression] = STATE(6417),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8796),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1200] = {
    [sym_expression] = STATE(6406),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8811),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1201] = {
    [sym_expression] = STATE(6397),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8823),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1202] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5832),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1203] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5834),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1204] = {
    [sym_expression] = STATE(6370),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8777),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1205] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8339),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5836),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1206] = {
    [sym_expression] = STATE(6356),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8739),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1207] = {
    [sym_expression] = STATE(6340),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8833),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1208] = {
    [sym_expression] = STATE(6327),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8843),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1209] = {
    [sym_expression] = STATE(6318),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8849),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1210] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8274),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5838),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1211] = {
    [ts_builtin_sym_end] = ACTIONS(5840),
    [anon_sym_LBRACE] = ACTIONS(5840),
    [anon_sym_RBRACE] = ACTIONS(5840),
    [anon_sym_COMMA] = ACTIONS(5840),
    [anon_sym_COLON_COLON] = ACTIONS(5840),
    [anon_sym_DASH_GT] = ACTIONS(5840),
    [anon_sym_where] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5842),
    [anon_sym_COLON] = ACTIONS(5842),
    [anon_sym_PIPE] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5840),
    [anon_sym_LPAREN] = ACTIONS(5840),
    [anon_sym_PLUS_EQ] = ACTIONS(5840),
    [anon_sym_DASH_EQ] = ACTIONS(5840),
    [anon_sym_STAR_EQ] = ACTIONS(5840),
    [anon_sym_SLASH_EQ] = ACTIONS(5840),
    [anon_sym_PERCENT_EQ] = ACTIONS(5840),
    [anon_sym_AMP_EQ] = ACTIONS(5840),
    [anon_sym_PIPE_EQ] = ACTIONS(5840),
    [anon_sym_CARET_EQ] = ACTIONS(5840),
    [anon_sym_LT_LT_EQ] = ACTIONS(5840),
    [anon_sym_GT_GT_EQ] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5840),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5840),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5840),
    [anon_sym_if] = ACTIONS(5840),
    [anon_sym_SEMI] = ACTIONS(5840),
    [anon_sym_else] = ACTIONS(5840),
    [anon_sym_when] = ACTIONS(5840),
    [anon_sym_in] = ACTIONS(5840),
    [anon_sym_case] = ACTIONS(5840),
    [anon_sym_QMARK] = ACTIONS(5840),
    [anon_sym_PLUS] = ACTIONS(5842),
    [anon_sym_DASH] = ACTIONS(5842),
    [anon_sym_TILDE] = ACTIONS(5842),
    [anon_sym_AMP] = ACTIONS(5842),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_or_else] = ACTIONS(5840),
    [anon_sym_AMP_AMP] = ACTIONS(5842),
    [anon_sym_GT] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_LT] = ACTIONS(5842),
    [anon_sym_EQ_EQ] = ACTIONS(5840),
    [anon_sym_BANG_EQ] = ACTIONS(5840),
    [anon_sym_TILDE_EQ] = ACTIONS(5840),
    [anon_sym_AMP_TILDE] = ACTIONS(5842),
    [anon_sym_LT_LT] = ACTIONS(5842),
    [anon_sym_GT_GT] = ACTIONS(5842),
    [anon_sym_STAR] = ACTIONS(5842),
    [anon_sym_SLASH] = ACTIONS(5842),
    [anon_sym_PERCENT] = ACTIONS(5842),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5840),
    [anon_sym_DOT] = ACTIONS(5842),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5840),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5840),
    [anon_sym_not_in] = ACTIONS(5840),
    [anon_sym_or_return] = ACTIONS(5840),
    [anon_sym_or_continue] = ACTIONS(5840),
    [anon_sym_or_break] = ACTIONS(5840),
    [anon_sym_CARET] = ACTIONS(5842),
    [sym_uninitialized] = ACTIONS(5840),
    [sym_tag] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5840),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1212] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7970),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5844),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1213] = {
    [ts_builtin_sym_end] = ACTIONS(5840),
    [anon_sym_LBRACE] = ACTIONS(5840),
    [anon_sym_RBRACE] = ACTIONS(5840),
    [anon_sym_COMMA] = ACTIONS(5840),
    [anon_sym_COLON_COLON] = ACTIONS(5840),
    [anon_sym_DASH_GT] = ACTIONS(5840),
    [anon_sym_where] = ACTIONS(5840),
    [anon_sym_EQ] = ACTIONS(5842),
    [anon_sym_COLON] = ACTIONS(5842),
    [anon_sym_PIPE] = ACTIONS(5842),
    [anon_sym_COLON_EQ] = ACTIONS(5840),
    [anon_sym_LPAREN] = ACTIONS(5840),
    [anon_sym_PLUS_EQ] = ACTIONS(5840),
    [anon_sym_DASH_EQ] = ACTIONS(5840),
    [anon_sym_STAR_EQ] = ACTIONS(5840),
    [anon_sym_SLASH_EQ] = ACTIONS(5840),
    [anon_sym_PERCENT_EQ] = ACTIONS(5840),
    [anon_sym_AMP_EQ] = ACTIONS(5840),
    [anon_sym_PIPE_EQ] = ACTIONS(5840),
    [anon_sym_CARET_EQ] = ACTIONS(5840),
    [anon_sym_LT_LT_EQ] = ACTIONS(5840),
    [anon_sym_GT_GT_EQ] = ACTIONS(5840),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5840),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5840),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5840),
    [anon_sym_if] = ACTIONS(5840),
    [anon_sym_SEMI] = ACTIONS(5840),
    [anon_sym_else] = ACTIONS(5840),
    [anon_sym_when] = ACTIONS(5840),
    [anon_sym_in] = ACTIONS(5840),
    [anon_sym_case] = ACTIONS(5840),
    [anon_sym_QMARK] = ACTIONS(5840),
    [anon_sym_PLUS] = ACTIONS(5842),
    [anon_sym_DASH] = ACTIONS(5842),
    [anon_sym_TILDE] = ACTIONS(5842),
    [anon_sym_AMP] = ACTIONS(5842),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_or_else] = ACTIONS(5840),
    [anon_sym_AMP_AMP] = ACTIONS(5842),
    [anon_sym_GT] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5840),
    [anon_sym_LT_EQ] = ACTIONS(5840),
    [anon_sym_LT] = ACTIONS(5842),
    [anon_sym_EQ_EQ] = ACTIONS(5840),
    [anon_sym_BANG_EQ] = ACTIONS(5840),
    [anon_sym_TILDE_EQ] = ACTIONS(5840),
    [anon_sym_AMP_TILDE] = ACTIONS(5842),
    [anon_sym_LT_LT] = ACTIONS(5842),
    [anon_sym_GT_GT] = ACTIONS(5842),
    [anon_sym_STAR] = ACTIONS(5842),
    [anon_sym_SLASH] = ACTIONS(5842),
    [anon_sym_PERCENT] = ACTIONS(5842),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5840),
    [anon_sym_DOT] = ACTIONS(5842),
    [anon_sym_LBRACK] = ACTIONS(5840),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5840),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5840),
    [anon_sym_not_in] = ACTIONS(5840),
    [anon_sym_or_return] = ACTIONS(5840),
    [anon_sym_or_continue] = ACTIONS(5840),
    [anon_sym_or_break] = ACTIONS(5840),
    [anon_sym_CARET] = ACTIONS(5842),
    [sym_uninitialized] = ACTIONS(5840),
    [sym_tag] = ACTIONS(5840),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5840),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1214] = {
    [ts_builtin_sym_end] = ACTIONS(5846),
    [anon_sym_LBRACE] = ACTIONS(5846),
    [anon_sym_RBRACE] = ACTIONS(5846),
    [anon_sym_COMMA] = ACTIONS(5846),
    [anon_sym_COLON_COLON] = ACTIONS(5846),
    [anon_sym_DASH_GT] = ACTIONS(5846),
    [anon_sym_where] = ACTIONS(5846),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_COLON] = ACTIONS(5848),
    [anon_sym_PIPE] = ACTIONS(5848),
    [anon_sym_COLON_EQ] = ACTIONS(5846),
    [anon_sym_LPAREN] = ACTIONS(5846),
    [anon_sym_PLUS_EQ] = ACTIONS(5846),
    [anon_sym_DASH_EQ] = ACTIONS(5846),
    [anon_sym_STAR_EQ] = ACTIONS(5846),
    [anon_sym_SLASH_EQ] = ACTIONS(5846),
    [anon_sym_PERCENT_EQ] = ACTIONS(5846),
    [anon_sym_AMP_EQ] = ACTIONS(5846),
    [anon_sym_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_CARET_EQ] = ACTIONS(5846),
    [anon_sym_LT_LT_EQ] = ACTIONS(5846),
    [anon_sym_GT_GT_EQ] = ACTIONS(5846),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5846),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5846),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5846),
    [anon_sym_if] = ACTIONS(5846),
    [anon_sym_SEMI] = ACTIONS(5846),
    [anon_sym_else] = ACTIONS(5846),
    [anon_sym_when] = ACTIONS(5846),
    [anon_sym_in] = ACTIONS(5846),
    [anon_sym_case] = ACTIONS(5846),
    [anon_sym_QMARK] = ACTIONS(5846),
    [anon_sym_PLUS] = ACTIONS(5848),
    [anon_sym_DASH] = ACTIONS(5848),
    [anon_sym_TILDE] = ACTIONS(5848),
    [anon_sym_AMP] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5848),
    [anon_sym_or_else] = ACTIONS(5846),
    [anon_sym_AMP_AMP] = ACTIONS(5848),
    [anon_sym_GT] = ACTIONS(5848),
    [anon_sym_GT_EQ] = ACTIONS(5846),
    [anon_sym_LT_EQ] = ACTIONS(5846),
    [anon_sym_LT] = ACTIONS(5848),
    [anon_sym_EQ_EQ] = ACTIONS(5846),
    [anon_sym_BANG_EQ] = ACTIONS(5846),
    [anon_sym_TILDE_EQ] = ACTIONS(5846),
    [anon_sym_AMP_TILDE] = ACTIONS(5848),
    [anon_sym_LT_LT] = ACTIONS(5848),
    [anon_sym_GT_GT] = ACTIONS(5848),
    [anon_sym_STAR] = ACTIONS(5848),
    [anon_sym_SLASH] = ACTIONS(5848),
    [anon_sym_PERCENT] = ACTIONS(5848),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5846),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_LBRACK] = ACTIONS(5846),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5846),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5846),
    [anon_sym_not_in] = ACTIONS(5846),
    [anon_sym_or_return] = ACTIONS(5846),
    [anon_sym_or_continue] = ACTIONS(5846),
    [anon_sym_or_break] = ACTIONS(5846),
    [anon_sym_CARET] = ACTIONS(5848),
    [sym_uninitialized] = ACTIONS(5846),
    [sym_tag] = ACTIONS(5846),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5846),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1215] = {
    [ts_builtin_sym_end] = ACTIONS(5850),
    [anon_sym_LBRACE] = ACTIONS(5850),
    [anon_sym_RBRACE] = ACTIONS(5850),
    [anon_sym_COMMA] = ACTIONS(5850),
    [anon_sym_COLON_COLON] = ACTIONS(5850),
    [anon_sym_DASH_GT] = ACTIONS(5850),
    [anon_sym_where] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5852),
    [anon_sym_COLON] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5850),
    [anon_sym_LPAREN] = ACTIONS(5850),
    [anon_sym_PLUS_EQ] = ACTIONS(5850),
    [anon_sym_DASH_EQ] = ACTIONS(5850),
    [anon_sym_STAR_EQ] = ACTIONS(5850),
    [anon_sym_SLASH_EQ] = ACTIONS(5850),
    [anon_sym_PERCENT_EQ] = ACTIONS(5850),
    [anon_sym_AMP_EQ] = ACTIONS(5850),
    [anon_sym_PIPE_EQ] = ACTIONS(5850),
    [anon_sym_CARET_EQ] = ACTIONS(5850),
    [anon_sym_LT_LT_EQ] = ACTIONS(5850),
    [anon_sym_GT_GT_EQ] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5850),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5850),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5850),
    [anon_sym_if] = ACTIONS(5850),
    [anon_sym_SEMI] = ACTIONS(5850),
    [anon_sym_else] = ACTIONS(5850),
    [anon_sym_when] = ACTIONS(5850),
    [anon_sym_in] = ACTIONS(5850),
    [anon_sym_case] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(5850),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_DASH] = ACTIONS(5852),
    [anon_sym_TILDE] = ACTIONS(5852),
    [anon_sym_AMP] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_or_else] = ACTIONS(5850),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_GT] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_LT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5850),
    [anon_sym_BANG_EQ] = ACTIONS(5850),
    [anon_sym_TILDE_EQ] = ACTIONS(5850),
    [anon_sym_AMP_TILDE] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_STAR] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(5852),
    [anon_sym_PERCENT] = ACTIONS(5852),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5850),
    [anon_sym_DOT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5850),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5850),
    [anon_sym_not_in] = ACTIONS(5850),
    [anon_sym_or_return] = ACTIONS(5850),
    [anon_sym_or_continue] = ACTIONS(5850),
    [anon_sym_or_break] = ACTIONS(5850),
    [anon_sym_CARET] = ACTIONS(5852),
    [sym_uninitialized] = ACTIONS(5850),
    [sym_tag] = ACTIONS(5850),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5850),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1216] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5854),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1217] = {
    [ts_builtin_sym_end] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_COLON_COLON] = ACTIONS(5856),
    [anon_sym_DASH_GT] = ACTIONS(5856),
    [anon_sym_where] = ACTIONS(5856),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_COLON] = ACTIONS(5858),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_COLON_EQ] = ACTIONS(5856),
    [anon_sym_LPAREN] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_when] = ACTIONS(5856),
    [anon_sym_in] = ACTIONS(5856),
    [anon_sym_case] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_DASH] = ACTIONS(5858),
    [anon_sym_TILDE] = ACTIONS(5858),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_or_else] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5856),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5856),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_TILDE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_TILDE] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_STAR] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5856),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5856),
    [anon_sym_not_in] = ACTIONS(5856),
    [anon_sym_or_return] = ACTIONS(5856),
    [anon_sym_or_continue] = ACTIONS(5856),
    [anon_sym_or_break] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [sym_uninitialized] = ACTIONS(5856),
    [sym_tag] = ACTIONS(5856),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5856),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1218] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(7984),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1219] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5862),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1220] = {
    [sym_expression] = STATE(6315),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8853),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1221] = {
    [sym_expression] = STATE(6308),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8857),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1222] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5864),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1223] = {
    [sym_expression] = STATE(6305),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8865),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1224] = {
    [sym_expression] = STATE(6148),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8936),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1225] = {
    [sym_expression] = STATE(6011),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8470),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1226] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8202),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5866),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1227] = {
    [sym_expression] = STATE(6304),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8869),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1228] = {
    [sym_expression] = STATE(6299),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8873),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1229] = {
    [sym_expression] = STATE(6297),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8861),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1230] = {
    [ts_builtin_sym_end] = ACTIONS(5850),
    [anon_sym_LBRACE] = ACTIONS(5850),
    [anon_sym_RBRACE] = ACTIONS(5850),
    [anon_sym_COMMA] = ACTIONS(5850),
    [anon_sym_COLON_COLON] = ACTIONS(5850),
    [anon_sym_DASH_GT] = ACTIONS(5850),
    [anon_sym_where] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5852),
    [anon_sym_COLON] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5852),
    [anon_sym_COLON_EQ] = ACTIONS(5850),
    [anon_sym_LPAREN] = ACTIONS(5850),
    [anon_sym_PLUS_EQ] = ACTIONS(5850),
    [anon_sym_DASH_EQ] = ACTIONS(5850),
    [anon_sym_STAR_EQ] = ACTIONS(5850),
    [anon_sym_SLASH_EQ] = ACTIONS(5850),
    [anon_sym_PERCENT_EQ] = ACTIONS(5850),
    [anon_sym_AMP_EQ] = ACTIONS(5850),
    [anon_sym_PIPE_EQ] = ACTIONS(5850),
    [anon_sym_CARET_EQ] = ACTIONS(5850),
    [anon_sym_LT_LT_EQ] = ACTIONS(5850),
    [anon_sym_GT_GT_EQ] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5850),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5850),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5850),
    [anon_sym_if] = ACTIONS(5850),
    [anon_sym_SEMI] = ACTIONS(5850),
    [anon_sym_else] = ACTIONS(5850),
    [anon_sym_when] = ACTIONS(5850),
    [anon_sym_in] = ACTIONS(5850),
    [anon_sym_case] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(5850),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_DASH] = ACTIONS(5852),
    [anon_sym_TILDE] = ACTIONS(5852),
    [anon_sym_AMP] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_or_else] = ACTIONS(5850),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_GT] = ACTIONS(5852),
    [anon_sym_GT_EQ] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5850),
    [anon_sym_LT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5850),
    [anon_sym_BANG_EQ] = ACTIONS(5850),
    [anon_sym_TILDE_EQ] = ACTIONS(5850),
    [anon_sym_AMP_TILDE] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_STAR] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(5852),
    [anon_sym_PERCENT] = ACTIONS(5852),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5850),
    [anon_sym_DOT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5850),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5850),
    [anon_sym_not_in] = ACTIONS(5850),
    [anon_sym_or_return] = ACTIONS(5850),
    [anon_sym_or_continue] = ACTIONS(5850),
    [anon_sym_or_break] = ACTIONS(5850),
    [anon_sym_CARET] = ACTIONS(5852),
    [sym_uninitialized] = ACTIONS(5850),
    [sym_tag] = ACTIONS(5850),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5850),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1231] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5866),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1232] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8260),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5834),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1233] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5868),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1234] = {
    [sym_expression] = STATE(6293),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8877),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1235] = {
    [sym_expression] = STATE(6291),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8881),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1236] = {
    [sym_expression] = STATE(6286),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8887),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1237] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5870),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1238] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8159),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5868),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1239] = {
    [sym_expression] = STATE(6283),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8884),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1240] = {
    [ts_builtin_sym_end] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(5872),
    [anon_sym_RBRACE] = ACTIONS(5872),
    [anon_sym_COMMA] = ACTIONS(5872),
    [anon_sym_COLON_COLON] = ACTIONS(5872),
    [anon_sym_DASH_GT] = ACTIONS(5872),
    [anon_sym_where] = ACTIONS(5872),
    [anon_sym_EQ] = ACTIONS(5874),
    [anon_sym_COLON] = ACTIONS(5874),
    [anon_sym_PIPE] = ACTIONS(5874),
    [anon_sym_COLON_EQ] = ACTIONS(5872),
    [anon_sym_LPAREN] = ACTIONS(5872),
    [anon_sym_PLUS_EQ] = ACTIONS(5872),
    [anon_sym_DASH_EQ] = ACTIONS(5872),
    [anon_sym_STAR_EQ] = ACTIONS(5872),
    [anon_sym_SLASH_EQ] = ACTIONS(5872),
    [anon_sym_PERCENT_EQ] = ACTIONS(5872),
    [anon_sym_AMP_EQ] = ACTIONS(5872),
    [anon_sym_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_CARET_EQ] = ACTIONS(5872),
    [anon_sym_LT_LT_EQ] = ACTIONS(5872),
    [anon_sym_GT_GT_EQ] = ACTIONS(5872),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5872),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5872),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5872),
    [anon_sym_if] = ACTIONS(5872),
    [anon_sym_SEMI] = ACTIONS(5872),
    [anon_sym_else] = ACTIONS(5872),
    [anon_sym_when] = ACTIONS(5872),
    [anon_sym_in] = ACTIONS(5872),
    [anon_sym_case] = ACTIONS(5872),
    [anon_sym_QMARK] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5874),
    [anon_sym_DASH] = ACTIONS(5874),
    [anon_sym_TILDE] = ACTIONS(5874),
    [anon_sym_AMP] = ACTIONS(5874),
    [anon_sym_PIPE_PIPE] = ACTIONS(5874),
    [anon_sym_or_else] = ACTIONS(5872),
    [anon_sym_AMP_AMP] = ACTIONS(5874),
    [anon_sym_GT] = ACTIONS(5874),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_LT_EQ] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5874),
    [anon_sym_EQ_EQ] = ACTIONS(5872),
    [anon_sym_BANG_EQ] = ACTIONS(5872),
    [anon_sym_TILDE_EQ] = ACTIONS(5872),
    [anon_sym_AMP_TILDE] = ACTIONS(5874),
    [anon_sym_LT_LT] = ACTIONS(5874),
    [anon_sym_GT_GT] = ACTIONS(5874),
    [anon_sym_STAR] = ACTIONS(5874),
    [anon_sym_SLASH] = ACTIONS(5874),
    [anon_sym_PERCENT] = ACTIONS(5874),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5872),
    [anon_sym_DOT] = ACTIONS(5874),
    [anon_sym_LBRACK] = ACTIONS(5872),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5872),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5872),
    [anon_sym_not_in] = ACTIONS(5872),
    [anon_sym_or_return] = ACTIONS(5872),
    [anon_sym_or_continue] = ACTIONS(5872),
    [anon_sym_or_break] = ACTIONS(5872),
    [anon_sym_CARET] = ACTIONS(5874),
    [sym_uninitialized] = ACTIONS(5872),
    [sym_tag] = ACTIONS(5872),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5872),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1241] = {
    [sym_expression] = STATE(6282),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8890),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1242] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8071),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5876),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1243] = {
    [ts_builtin_sym_end] = ACTIONS(5878),
    [anon_sym_LBRACE] = ACTIONS(5878),
    [anon_sym_RBRACE] = ACTIONS(5878),
    [anon_sym_COMMA] = ACTIONS(5878),
    [anon_sym_COLON_COLON] = ACTIONS(5878),
    [anon_sym_DASH_GT] = ACTIONS(5878),
    [anon_sym_where] = ACTIONS(5878),
    [anon_sym_EQ] = ACTIONS(5880),
    [anon_sym_COLON] = ACTIONS(5880),
    [anon_sym_PIPE] = ACTIONS(5880),
    [anon_sym_COLON_EQ] = ACTIONS(5878),
    [anon_sym_LPAREN] = ACTIONS(5878),
    [anon_sym_PLUS_EQ] = ACTIONS(5878),
    [anon_sym_DASH_EQ] = ACTIONS(5878),
    [anon_sym_STAR_EQ] = ACTIONS(5878),
    [anon_sym_SLASH_EQ] = ACTIONS(5878),
    [anon_sym_PERCENT_EQ] = ACTIONS(5878),
    [anon_sym_AMP_EQ] = ACTIONS(5878),
    [anon_sym_PIPE_EQ] = ACTIONS(5878),
    [anon_sym_CARET_EQ] = ACTIONS(5878),
    [anon_sym_LT_LT_EQ] = ACTIONS(5878),
    [anon_sym_GT_GT_EQ] = ACTIONS(5878),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5878),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5878),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5878),
    [anon_sym_if] = ACTIONS(5878),
    [anon_sym_SEMI] = ACTIONS(5878),
    [anon_sym_else] = ACTIONS(5878),
    [anon_sym_when] = ACTIONS(5878),
    [anon_sym_in] = ACTIONS(5878),
    [anon_sym_case] = ACTIONS(5878),
    [anon_sym_QMARK] = ACTIONS(5878),
    [anon_sym_PLUS] = ACTIONS(5880),
    [anon_sym_DASH] = ACTIONS(5880),
    [anon_sym_TILDE] = ACTIONS(5880),
    [anon_sym_AMP] = ACTIONS(5880),
    [anon_sym_PIPE_PIPE] = ACTIONS(5880),
    [anon_sym_or_else] = ACTIONS(5878),
    [anon_sym_AMP_AMP] = ACTIONS(5880),
    [anon_sym_GT] = ACTIONS(5880),
    [anon_sym_GT_EQ] = ACTIONS(5878),
    [anon_sym_LT_EQ] = ACTIONS(5878),
    [anon_sym_LT] = ACTIONS(5880),
    [anon_sym_EQ_EQ] = ACTIONS(5878),
    [anon_sym_BANG_EQ] = ACTIONS(5878),
    [anon_sym_TILDE_EQ] = ACTIONS(5878),
    [anon_sym_AMP_TILDE] = ACTIONS(5880),
    [anon_sym_LT_LT] = ACTIONS(5880),
    [anon_sym_GT_GT] = ACTIONS(5880),
    [anon_sym_STAR] = ACTIONS(5880),
    [anon_sym_SLASH] = ACTIONS(5880),
    [anon_sym_PERCENT] = ACTIONS(5880),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5878),
    [anon_sym_DOT] = ACTIONS(5880),
    [anon_sym_LBRACK] = ACTIONS(5878),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5878),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5878),
    [anon_sym_not_in] = ACTIONS(5878),
    [anon_sym_or_return] = ACTIONS(5878),
    [anon_sym_or_continue] = ACTIONS(5878),
    [anon_sym_or_break] = ACTIONS(5878),
    [anon_sym_CARET] = ACTIONS(5880),
    [sym_uninitialized] = ACTIONS(5878),
    [sym_tag] = ACTIONS(5878),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5878),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1244] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5876),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1245] = {
    [ts_builtin_sym_end] = ACTIONS(5882),
    [anon_sym_LBRACE] = ACTIONS(5882),
    [anon_sym_RBRACE] = ACTIONS(5882),
    [anon_sym_COMMA] = ACTIONS(5882),
    [anon_sym_COLON_COLON] = ACTIONS(5882),
    [anon_sym_DASH_GT] = ACTIONS(5882),
    [anon_sym_where] = ACTIONS(5882),
    [anon_sym_EQ] = ACTIONS(5884),
    [anon_sym_COLON] = ACTIONS(5884),
    [anon_sym_PIPE] = ACTIONS(5884),
    [anon_sym_COLON_EQ] = ACTIONS(5882),
    [anon_sym_LPAREN] = ACTIONS(5882),
    [anon_sym_PLUS_EQ] = ACTIONS(5882),
    [anon_sym_DASH_EQ] = ACTIONS(5882),
    [anon_sym_STAR_EQ] = ACTIONS(5882),
    [anon_sym_SLASH_EQ] = ACTIONS(5882),
    [anon_sym_PERCENT_EQ] = ACTIONS(5882),
    [anon_sym_AMP_EQ] = ACTIONS(5882),
    [anon_sym_PIPE_EQ] = ACTIONS(5882),
    [anon_sym_CARET_EQ] = ACTIONS(5882),
    [anon_sym_LT_LT_EQ] = ACTIONS(5882),
    [anon_sym_GT_GT_EQ] = ACTIONS(5882),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5882),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5882),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5882),
    [anon_sym_if] = ACTIONS(5882),
    [anon_sym_SEMI] = ACTIONS(5882),
    [anon_sym_else] = ACTIONS(5882),
    [anon_sym_when] = ACTIONS(5882),
    [anon_sym_in] = ACTIONS(5882),
    [anon_sym_case] = ACTIONS(5882),
    [anon_sym_QMARK] = ACTIONS(5882),
    [anon_sym_PLUS] = ACTIONS(5884),
    [anon_sym_DASH] = ACTIONS(5884),
    [anon_sym_TILDE] = ACTIONS(5884),
    [anon_sym_AMP] = ACTIONS(5884),
    [anon_sym_PIPE_PIPE] = ACTIONS(5884),
    [anon_sym_or_else] = ACTIONS(5882),
    [anon_sym_AMP_AMP] = ACTIONS(5884),
    [anon_sym_GT] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5882),
    [anon_sym_LT_EQ] = ACTIONS(5882),
    [anon_sym_LT] = ACTIONS(5884),
    [anon_sym_EQ_EQ] = ACTIONS(5882),
    [anon_sym_BANG_EQ] = ACTIONS(5882),
    [anon_sym_TILDE_EQ] = ACTIONS(5882),
    [anon_sym_AMP_TILDE] = ACTIONS(5884),
    [anon_sym_LT_LT] = ACTIONS(5884),
    [anon_sym_GT_GT] = ACTIONS(5884),
    [anon_sym_STAR] = ACTIONS(5884),
    [anon_sym_SLASH] = ACTIONS(5884),
    [anon_sym_PERCENT] = ACTIONS(5884),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5882),
    [anon_sym_DOT] = ACTIONS(5884),
    [anon_sym_LBRACK] = ACTIONS(5882),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5882),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5882),
    [anon_sym_not_in] = ACTIONS(5882),
    [anon_sym_or_return] = ACTIONS(5882),
    [anon_sym_or_continue] = ACTIONS(5882),
    [anon_sym_or_break] = ACTIONS(5882),
    [anon_sym_CARET] = ACTIONS(5884),
    [sym_uninitialized] = ACTIONS(5882),
    [sym_tag] = ACTIONS(5882),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5882),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1246] = {
    [sym_expression] = STATE(6111),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8920),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1247] = {
    [sym_expression] = STATE(6118),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_constant_type] = STATE(8910),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_DOLLAR] = ACTIONS(4784),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1248] = {
    [sym_expression] = STATE(6054),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(5886),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1249] = {
    [sym_expression] = STATE(6166),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(5888),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1250] = {
    [sym_expression] = STATE(6103),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(5890),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1251] = {
    [sym_expression] = STATE(5908),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5892),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1252] = {
    [sym_expression] = STATE(6433),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5894),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1253] = {
    [sym_expression] = STATE(5959),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5896),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1254] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5898),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1255] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5900),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1256] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5902),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1257] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5904),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1258] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5906),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1259] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5908),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1260] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5910),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1261] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5912),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1262] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5914),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1263] = {
    [sym_expression] = STATE(6260),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(5916),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1264] = {
    [sym_expression] = STATE(6193),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(5918),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1265] = {
    [sym_expression] = STATE(6369),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(5920),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1266] = {
    [sym_expression] = STATE(5890),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5922),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1267] = {
    [sym_expression] = STATE(5894),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5924),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1268] = {
    [sym_expression] = STATE(6421),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5926),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1269] = {
    [sym_expression] = STATE(5891),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5928),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1270] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5930),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1271] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5932),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1272] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5934),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1273] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5936),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1274] = {
    [sym_expression] = STATE(6254),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(5938),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1275] = {
    [sym_expression] = STATE(6307),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(5940),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1276] = {
    [sym_expression] = STATE(5895),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5942),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1277] = {
    [sym_block] = STATE(2453),
    [ts_builtin_sym_end] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [anon_sym_COMMA] = ACTIONS(4691),
    [anon_sym_COLON_COLON] = ACTIONS(4691),
    [anon_sym_DASH_GT] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_COLON] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_COLON_EQ] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_PLUS_EQ] = ACTIONS(4691),
    [anon_sym_DASH_EQ] = ACTIONS(4691),
    [anon_sym_STAR_EQ] = ACTIONS(4691),
    [anon_sym_SLASH_EQ] = ACTIONS(4691),
    [anon_sym_PERCENT_EQ] = ACTIONS(4691),
    [anon_sym_AMP_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_CARET_EQ] = ACTIONS(4691),
    [anon_sym_LT_LT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4691),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4691),
    [anon_sym_if] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_else] = ACTIONS(4691),
    [anon_sym_when] = ACTIONS(4691),
    [anon_sym_in] = ACTIONS(4691),
    [anon_sym_case] = ACTIONS(4691),
    [anon_sym_QMARK] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(4693),
    [anon_sym_AMP] = ACTIONS(4693),
    [anon_sym_PIPE_PIPE] = ACTIONS(4693),
    [anon_sym_or_else] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_GT_EQ] = ACTIONS(4691),
    [anon_sym_LT_EQ] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_EQ_EQ] = ACTIONS(4691),
    [anon_sym_BANG_EQ] = ACTIONS(4691),
    [anon_sym_TILDE_EQ] = ACTIONS(4691),
    [anon_sym_AMP_TILDE] = ACTIONS(4693),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(4693),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4693),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4691),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4691),
    [anon_sym_not_in] = ACTIONS(4691),
    [anon_sym_or_return] = ACTIONS(4691),
    [anon_sym_or_continue] = ACTIONS(4691),
    [anon_sym_or_break] = ACTIONS(4691),
    [anon_sym_CARET] = ACTIONS(4693),
    [sym_uninitialized] = ACTIONS(5944),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4691),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1278] = {
    [sym_expression] = STATE(6461),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5946),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1279] = {
    [sym_expression] = STATE(6078),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(5948),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1280] = {
    [sym_block] = STATE(2447),
    [ts_builtin_sym_end] = ACTIONS(4667),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(4667),
    [anon_sym_COMMA] = ACTIONS(4667),
    [anon_sym_COLON_COLON] = ACTIONS(4667),
    [anon_sym_DASH_GT] = ACTIONS(4667),
    [anon_sym_EQ] = ACTIONS(4669),
    [anon_sym_COLON] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4669),
    [anon_sym_COLON_EQ] = ACTIONS(4667),
    [anon_sym_LPAREN] = ACTIONS(4667),
    [anon_sym_PLUS_EQ] = ACTIONS(4667),
    [anon_sym_DASH_EQ] = ACTIONS(4667),
    [anon_sym_STAR_EQ] = ACTIONS(4667),
    [anon_sym_SLASH_EQ] = ACTIONS(4667),
    [anon_sym_PERCENT_EQ] = ACTIONS(4667),
    [anon_sym_AMP_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_CARET_EQ] = ACTIONS(4667),
    [anon_sym_LT_LT_EQ] = ACTIONS(4667),
    [anon_sym_GT_GT_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_if] = ACTIONS(4667),
    [anon_sym_SEMI] = ACTIONS(4667),
    [anon_sym_else] = ACTIONS(4667),
    [anon_sym_when] = ACTIONS(4667),
    [anon_sym_in] = ACTIONS(4667),
    [anon_sym_case] = ACTIONS(4667),
    [anon_sym_QMARK] = ACTIONS(4667),
    [anon_sym_PLUS] = ACTIONS(4669),
    [anon_sym_DASH] = ACTIONS(4669),
    [anon_sym_TILDE] = ACTIONS(4669),
    [anon_sym_AMP] = ACTIONS(4669),
    [anon_sym_PIPE_PIPE] = ACTIONS(4669),
    [anon_sym_or_else] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_GT] = ACTIONS(4669),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_LT_EQ] = ACTIONS(4667),
    [anon_sym_LT] = ACTIONS(4669),
    [anon_sym_EQ_EQ] = ACTIONS(4667),
    [anon_sym_BANG_EQ] = ACTIONS(4667),
    [anon_sym_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE] = ACTIONS(4669),
    [anon_sym_LT_LT] = ACTIONS(4669),
    [anon_sym_GT_GT] = ACTIONS(4669),
    [anon_sym_STAR] = ACTIONS(4669),
    [anon_sym_SLASH] = ACTIONS(4669),
    [anon_sym_PERCENT] = ACTIONS(4669),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4667),
    [anon_sym_DOT] = ACTIONS(4669),
    [anon_sym_LBRACK] = ACTIONS(4667),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4667),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4667),
    [anon_sym_not_in] = ACTIONS(4667),
    [anon_sym_or_return] = ACTIONS(4667),
    [anon_sym_or_continue] = ACTIONS(4667),
    [anon_sym_or_break] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [sym_uninitialized] = ACTIONS(5680),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4667),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1281] = {
    [sym_expression] = STATE(6407),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1282] = {
    [sym_expression] = STATE(5937),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5952),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1283] = {
    [sym_block] = STATE(2440),
    [ts_builtin_sym_end] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_DASH_GT] = ACTIONS(3671),
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_PLUS_EQ] = ACTIONS(3671),
    [anon_sym_DASH_EQ] = ACTIONS(3671),
    [anon_sym_STAR_EQ] = ACTIONS(3671),
    [anon_sym_SLASH_EQ] = ACTIONS(3671),
    [anon_sym_PERCENT_EQ] = ACTIONS(3671),
    [anon_sym_AMP_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_CARET_EQ] = ACTIONS(3671),
    [anon_sym_LT_LT_EQ] = ACTIONS(3671),
    [anon_sym_GT_GT_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_if] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_else] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3671),
    [anon_sym_case] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_or_else] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_GT] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3671),
    [anon_sym_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_SLASH] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3671),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3671),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3671),
    [anon_sym_not_in] = ACTIONS(3671),
    [anon_sym_or_return] = ACTIONS(3671),
    [anon_sym_or_continue] = ACTIONS(3671),
    [anon_sym_or_break] = ACTIONS(3671),
    [anon_sym_CARET] = ACTIONS(3675),
    [sym_uninitialized] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3671),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1284] = {
    [sym_expression] = STATE(5874),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5954),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1285] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5956),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1286] = {
    [sym_expression] = STATE(5951),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5958),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1287] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5960),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1288] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5962),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1289] = {
    [sym_expression] = STATE(6252),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(5964),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1290] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1291] = {
    [sym_block] = STATE(2429),
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(4027),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4023),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1292] = {
    [sym_block] = STATE(2404),
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(4087),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4083),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1293] = {
    [sym_expression] = STATE(6238),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(5968),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1294] = {
    [aux_sym_field_type_repeat1] = STATE(1315),
    [ts_builtin_sym_end] = ACTIONS(4185),
    [anon_sym_LBRACE] = ACTIONS(4185),
    [anon_sym_RBRACE] = ACTIONS(4185),
    [anon_sym_COMMA] = ACTIONS(4185),
    [anon_sym_COLON_COLON] = ACTIONS(4185),
    [anon_sym_DASH_GT] = ACTIONS(4185),
    [anon_sym_EQ] = ACTIONS(4187),
    [anon_sym_COLON] = ACTIONS(4187),
    [anon_sym_PIPE] = ACTIONS(4187),
    [anon_sym_COLON_EQ] = ACTIONS(4185),
    [anon_sym_LPAREN] = ACTIONS(4185),
    [anon_sym_PLUS_EQ] = ACTIONS(4185),
    [anon_sym_DASH_EQ] = ACTIONS(4185),
    [anon_sym_STAR_EQ] = ACTIONS(4185),
    [anon_sym_SLASH_EQ] = ACTIONS(4185),
    [anon_sym_PERCENT_EQ] = ACTIONS(4185),
    [anon_sym_AMP_EQ] = ACTIONS(4185),
    [anon_sym_PIPE_EQ] = ACTIONS(4185),
    [anon_sym_CARET_EQ] = ACTIONS(4185),
    [anon_sym_LT_LT_EQ] = ACTIONS(4185),
    [anon_sym_GT_GT_EQ] = ACTIONS(4185),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4185),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4185),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4185),
    [anon_sym_if] = ACTIONS(4185),
    [anon_sym_SEMI] = ACTIONS(4185),
    [anon_sym_else] = ACTIONS(4185),
    [anon_sym_when] = ACTIONS(4185),
    [anon_sym_in] = ACTIONS(4185),
    [anon_sym_case] = ACTIONS(4185),
    [anon_sym_QMARK] = ACTIONS(4185),
    [anon_sym_PLUS] = ACTIONS(4187),
    [anon_sym_DASH] = ACTIONS(4187),
    [anon_sym_TILDE] = ACTIONS(4187),
    [anon_sym_AMP] = ACTIONS(4187),
    [anon_sym_PIPE_PIPE] = ACTIONS(4187),
    [anon_sym_or_else] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4187),
    [anon_sym_GT] = ACTIONS(4187),
    [anon_sym_GT_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4185),
    [anon_sym_LT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4185),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_TILDE_EQ] = ACTIONS(4185),
    [anon_sym_AMP_TILDE] = ACTIONS(4187),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_STAR] = ACTIONS(4187),
    [anon_sym_SLASH] = ACTIONS(4187),
    [anon_sym_PERCENT] = ACTIONS(4187),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4185),
    [anon_sym_DOT] = ACTIONS(4187),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4185),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4185),
    [anon_sym_not_in] = ACTIONS(4185),
    [anon_sym_or_return] = ACTIONS(4185),
    [anon_sym_or_continue] = ACTIONS(4185),
    [anon_sym_or_break] = ACTIONS(4185),
    [anon_sym_CARET] = ACTIONS(4187),
    [anon_sym_DOT2] = ACTIONS(5970),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4185),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1295] = {
    [sym_expression] = STATE(6312),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(5972),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1296] = {
    [sym_block] = STATE(2169),
    [ts_builtin_sym_end] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [anon_sym_COMMA] = ACTIONS(4691),
    [anon_sym_COLON_COLON] = ACTIONS(4691),
    [anon_sym_DASH_GT] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_COLON] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_COLON_EQ] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_PLUS_EQ] = ACTIONS(4691),
    [anon_sym_DASH_EQ] = ACTIONS(4691),
    [anon_sym_STAR_EQ] = ACTIONS(4691),
    [anon_sym_SLASH_EQ] = ACTIONS(4691),
    [anon_sym_PERCENT_EQ] = ACTIONS(4691),
    [anon_sym_AMP_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_CARET_EQ] = ACTIONS(4691),
    [anon_sym_LT_LT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4691),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4691),
    [anon_sym_if] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_else] = ACTIONS(4691),
    [anon_sym_when] = ACTIONS(4691),
    [anon_sym_in] = ACTIONS(4691),
    [anon_sym_case] = ACTIONS(4691),
    [anon_sym_QMARK] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(4693),
    [anon_sym_AMP] = ACTIONS(4693),
    [anon_sym_PIPE_PIPE] = ACTIONS(4693),
    [anon_sym_or_else] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_GT_EQ] = ACTIONS(4691),
    [anon_sym_LT_EQ] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_EQ_EQ] = ACTIONS(4691),
    [anon_sym_BANG_EQ] = ACTIONS(4691),
    [anon_sym_TILDE_EQ] = ACTIONS(4691),
    [anon_sym_AMP_TILDE] = ACTIONS(4693),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(4693),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4693),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4691),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4691),
    [anon_sym_not_in] = ACTIONS(4691),
    [anon_sym_or_return] = ACTIONS(4691),
    [anon_sym_or_continue] = ACTIONS(4691),
    [anon_sym_or_break] = ACTIONS(4691),
    [anon_sym_CARET] = ACTIONS(4693),
    [sym_uninitialized] = ACTIONS(5974),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4691),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1297] = {
    [sym_expression] = STATE(6178),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(5976),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1298] = {
    [sym_expression] = STATE(5968),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5978),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1299] = {
    [sym_block] = STATE(2373),
    [ts_builtin_sym_end] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_else] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(4201),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3415),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1300] = {
    [sym_block] = STATE(2170),
    [ts_builtin_sym_end] = ACTIONS(4667),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(4667),
    [anon_sym_COMMA] = ACTIONS(4667),
    [anon_sym_COLON_COLON] = ACTIONS(4667),
    [anon_sym_DASH_GT] = ACTIONS(4667),
    [anon_sym_EQ] = ACTIONS(4669),
    [anon_sym_COLON] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4669),
    [anon_sym_COLON_EQ] = ACTIONS(4667),
    [anon_sym_LPAREN] = ACTIONS(4667),
    [anon_sym_PLUS_EQ] = ACTIONS(4667),
    [anon_sym_DASH_EQ] = ACTIONS(4667),
    [anon_sym_STAR_EQ] = ACTIONS(4667),
    [anon_sym_SLASH_EQ] = ACTIONS(4667),
    [anon_sym_PERCENT_EQ] = ACTIONS(4667),
    [anon_sym_AMP_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_CARET_EQ] = ACTIONS(4667),
    [anon_sym_LT_LT_EQ] = ACTIONS(4667),
    [anon_sym_GT_GT_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_if] = ACTIONS(4667),
    [anon_sym_SEMI] = ACTIONS(4667),
    [anon_sym_else] = ACTIONS(4667),
    [anon_sym_when] = ACTIONS(4667),
    [anon_sym_in] = ACTIONS(4667),
    [anon_sym_case] = ACTIONS(4667),
    [anon_sym_QMARK] = ACTIONS(4667),
    [anon_sym_PLUS] = ACTIONS(4669),
    [anon_sym_DASH] = ACTIONS(4669),
    [anon_sym_TILDE] = ACTIONS(4669),
    [anon_sym_AMP] = ACTIONS(4669),
    [anon_sym_PIPE_PIPE] = ACTIONS(4669),
    [anon_sym_or_else] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_GT] = ACTIONS(4669),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_LT_EQ] = ACTIONS(4667),
    [anon_sym_LT] = ACTIONS(4669),
    [anon_sym_EQ_EQ] = ACTIONS(4667),
    [anon_sym_BANG_EQ] = ACTIONS(4667),
    [anon_sym_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE] = ACTIONS(4669),
    [anon_sym_LT_LT] = ACTIONS(4669),
    [anon_sym_GT_GT] = ACTIONS(4669),
    [anon_sym_STAR] = ACTIONS(4669),
    [anon_sym_SLASH] = ACTIONS(4669),
    [anon_sym_PERCENT] = ACTIONS(4669),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4667),
    [anon_sym_DOT] = ACTIONS(4669),
    [anon_sym_LBRACK] = ACTIONS(4667),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4667),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4667),
    [anon_sym_not_in] = ACTIONS(4667),
    [anon_sym_or_return] = ACTIONS(4667),
    [anon_sym_or_continue] = ACTIONS(4667),
    [anon_sym_or_break] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [sym_uninitialized] = ACTIONS(5596),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4667),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1301] = {
    [sym_expression] = STATE(6398),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5980),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1302] = {
    [sym_block] = STATE(2335),
    [ts_builtin_sym_end] = ACTIONS(3781),
    [anon_sym_LBRACE] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3785),
    [anon_sym_COLON] = ACTIONS(3785),
    [anon_sym_PIPE] = ACTIONS(3785),
    [anon_sym_COLON_EQ] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_else] = ACTIONS(3781),
    [anon_sym_when] = ACTIONS(3781),
    [anon_sym_in] = ACTIONS(3781),
    [anon_sym_case] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(3785),
    [anon_sym_PIPE_PIPE] = ACTIONS(3785),
    [anon_sym_or_else] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3785),
    [anon_sym_GT] = ACTIONS(3785),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3781),
    [anon_sym_LT] = ACTIONS(3785),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE] = ACTIONS(3785),
    [anon_sym_LT_LT] = ACTIONS(3785),
    [anon_sym_GT_GT] = ACTIONS(3785),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_SLASH] = ACTIONS(3785),
    [anon_sym_PERCENT] = ACTIONS(3785),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3781),
    [anon_sym_not_in] = ACTIONS(3781),
    [anon_sym_or_return] = ACTIONS(3781),
    [anon_sym_or_continue] = ACTIONS(3781),
    [anon_sym_or_break] = ACTIONS(3781),
    [anon_sym_CARET] = ACTIONS(3785),
    [sym_uninitialized] = ACTIONS(4293),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3781),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1303] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5982),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1304] = {
    [sym_expression] = STATE(5905),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5984),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1305] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5986),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1306] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5988),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1307] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5990),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1308] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5992),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1309] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5994),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1310] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5996),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1311] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(5998),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1312] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6000),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1313] = {
    [sym_expression] = STATE(5947),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(6002),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1314] = {
    [sym_expression] = STATE(5862),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6004),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1315] = {
    [aux_sym_field_type_repeat1] = STATE(1316),
    [ts_builtin_sym_end] = ACTIONS(4494),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_RBRACE] = ACTIONS(4494),
    [anon_sym_COMMA] = ACTIONS(4494),
    [anon_sym_COLON_COLON] = ACTIONS(4494),
    [anon_sym_DASH_GT] = ACTIONS(4494),
    [anon_sym_EQ] = ACTIONS(4496),
    [anon_sym_COLON] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4496),
    [anon_sym_COLON_EQ] = ACTIONS(4494),
    [anon_sym_LPAREN] = ACTIONS(4494),
    [anon_sym_PLUS_EQ] = ACTIONS(4494),
    [anon_sym_DASH_EQ] = ACTIONS(4494),
    [anon_sym_STAR_EQ] = ACTIONS(4494),
    [anon_sym_SLASH_EQ] = ACTIONS(4494),
    [anon_sym_PERCENT_EQ] = ACTIONS(4494),
    [anon_sym_AMP_EQ] = ACTIONS(4494),
    [anon_sym_PIPE_EQ] = ACTIONS(4494),
    [anon_sym_CARET_EQ] = ACTIONS(4494),
    [anon_sym_LT_LT_EQ] = ACTIONS(4494),
    [anon_sym_GT_GT_EQ] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4494),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4494),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4494),
    [anon_sym_if] = ACTIONS(4494),
    [anon_sym_SEMI] = ACTIONS(4494),
    [anon_sym_else] = ACTIONS(4494),
    [anon_sym_when] = ACTIONS(4494),
    [anon_sym_in] = ACTIONS(4494),
    [anon_sym_case] = ACTIONS(4494),
    [anon_sym_QMARK] = ACTIONS(4494),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_DASH] = ACTIONS(4496),
    [anon_sym_TILDE] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(4496),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_or_else] = ACTIONS(4494),
    [anon_sym_AMP_AMP] = ACTIONS(4496),
    [anon_sym_GT] = ACTIONS(4496),
    [anon_sym_GT_EQ] = ACTIONS(4494),
    [anon_sym_LT_EQ] = ACTIONS(4494),
    [anon_sym_LT] = ACTIONS(4496),
    [anon_sym_EQ_EQ] = ACTIONS(4494),
    [anon_sym_BANG_EQ] = ACTIONS(4494),
    [anon_sym_TILDE_EQ] = ACTIONS(4494),
    [anon_sym_AMP_TILDE] = ACTIONS(4496),
    [anon_sym_LT_LT] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4496),
    [anon_sym_STAR] = ACTIONS(4496),
    [anon_sym_SLASH] = ACTIONS(4496),
    [anon_sym_PERCENT] = ACTIONS(4496),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4494),
    [anon_sym_DOT] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4494),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4494),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4494),
    [anon_sym_not_in] = ACTIONS(4494),
    [anon_sym_or_return] = ACTIONS(4494),
    [anon_sym_or_continue] = ACTIONS(4494),
    [anon_sym_or_break] = ACTIONS(4494),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_DOT2] = ACTIONS(5970),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4494),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1316] = {
    [aux_sym_field_type_repeat1] = STATE(1316),
    [ts_builtin_sym_end] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_COLON_COLON] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_EQ] = ACTIONS(4455),
    [anon_sym_COLON] = ACTIONS(4455),
    [anon_sym_PIPE] = ACTIONS(4455),
    [anon_sym_COLON_EQ] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_PLUS_EQ] = ACTIONS(4453),
    [anon_sym_DASH_EQ] = ACTIONS(4453),
    [anon_sym_STAR_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_PERCENT_EQ] = ACTIONS(4453),
    [anon_sym_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_CARET_EQ] = ACTIONS(4453),
    [anon_sym_LT_LT_EQ] = ACTIONS(4453),
    [anon_sym_GT_GT_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4453),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4453),
    [anon_sym_if] = ACTIONS(4453),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_else] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_in] = ACTIONS(4453),
    [anon_sym_case] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4455),
    [anon_sym_DASH] = ACTIONS(4455),
    [anon_sym_TILDE] = ACTIONS(4455),
    [anon_sym_AMP] = ACTIONS(4455),
    [anon_sym_PIPE_PIPE] = ACTIONS(4455),
    [anon_sym_or_else] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4455),
    [anon_sym_GT] = ACTIONS(4455),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4455),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_TILDE_EQ] = ACTIONS(4453),
    [anon_sym_AMP_TILDE] = ACTIONS(4455),
    [anon_sym_LT_LT] = ACTIONS(4455),
    [anon_sym_GT_GT] = ACTIONS(4455),
    [anon_sym_STAR] = ACTIONS(4455),
    [anon_sym_SLASH] = ACTIONS(4455),
    [anon_sym_PERCENT] = ACTIONS(4455),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4455),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4453),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4453),
    [anon_sym_not_in] = ACTIONS(4453),
    [anon_sym_or_return] = ACTIONS(4453),
    [anon_sym_or_continue] = ACTIONS(4453),
    [anon_sym_or_break] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4455),
    [anon_sym_DOT2] = ACTIONS(6006),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4453),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1317] = {
    [sym_block] = STATE(2171),
    [ts_builtin_sym_end] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_DASH_GT] = ACTIONS(3671),
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_PLUS_EQ] = ACTIONS(3671),
    [anon_sym_DASH_EQ] = ACTIONS(3671),
    [anon_sym_STAR_EQ] = ACTIONS(3671),
    [anon_sym_SLASH_EQ] = ACTIONS(3671),
    [anon_sym_PERCENT_EQ] = ACTIONS(3671),
    [anon_sym_AMP_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_CARET_EQ] = ACTIONS(3671),
    [anon_sym_LT_LT_EQ] = ACTIONS(3671),
    [anon_sym_GT_GT_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_if] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_else] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3671),
    [anon_sym_case] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_or_else] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_GT] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3671),
    [anon_sym_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_SLASH] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3671),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3671),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3671),
    [anon_sym_not_in] = ACTIONS(3671),
    [anon_sym_or_return] = ACTIONS(3671),
    [anon_sym_or_continue] = ACTIONS(3671),
    [anon_sym_or_break] = ACTIONS(3671),
    [anon_sym_CARET] = ACTIONS(3675),
    [sym_uninitialized] = ACTIONS(4490),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3671),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1318] = {
    [sym_expression] = STATE(6114),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(6009),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1319] = {
    [sym_expression] = STATE(6144),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(6011),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1320] = {
    [sym_expression] = STATE(5944),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6013),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1321] = {
    [sym_block] = STATE(2172),
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(4373),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4023),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1322] = {
    [sym_expression] = STATE(6372),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6015),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1323] = {
    [sym_expression] = STATE(5982),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6017),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1324] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6019),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1325] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6021),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1326] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6023),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1327] = {
    [sym_expression] = STATE(6443),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6025),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1328] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6027),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1329] = {
    [sym_expression] = STATE(6265),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(6029),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1330] = {
    [sym_expression] = STATE(6295),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(6031),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1331] = {
    [sym_expression] = STATE(5926),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6033),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1332] = {
    [sym_expression] = STATE(6357),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6035),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1333] = {
    [sym_expression] = STATE(5917),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6037),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1334] = {
    [sym_block] = STATE(2175),
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4083),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1335] = {
    [sym_expression] = STATE(5876),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6039),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1336] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6041),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1337] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6043),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1338] = {
    [sym_expression] = STATE(6374),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(6045),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1339] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6047),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1340] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1341] = {
    [sym_expression] = STATE(5903),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6051),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1342] = {
    [sym_expression] = STATE(6412),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(6053),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1343] = {
    [sym_expression] = STATE(6309),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(6055),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1344] = {
    [sym_expression] = STATE(6442),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(6057),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1345] = {
    [sym_expression] = STATE(5865),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6059),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1346] = {
    [sym_expression] = STATE(6437),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(6061),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1347] = {
    [sym_expression] = STATE(6342),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6063),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1348] = {
    [sym_expression] = STATE(5963),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_struct_field] = STATE(8413),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1349] = {
    [sym_expression] = STATE(5863),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6065),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1350] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6067),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1351] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6069),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1352] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6071),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1353] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6073),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1354] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6075),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1355] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6077),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1356] = {
    [sym_block] = STATE(2176),
    [ts_builtin_sym_end] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_else] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(3427),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3415),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1357] = {
    [sym_expression] = STATE(6385),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1358] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6081),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1359] = {
    [sym_expression] = STATE(6355),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(6083),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1360] = {
    [sym_expression] = STATE(5906),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6085),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1361] = {
    [sym_block] = STATE(2178),
    [ts_builtin_sym_end] = ACTIONS(3781),
    [anon_sym_LBRACE] = ACTIONS(3417),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3785),
    [anon_sym_COLON] = ACTIONS(3785),
    [anon_sym_PIPE] = ACTIONS(3785),
    [anon_sym_COLON_EQ] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_else] = ACTIONS(3781),
    [anon_sym_when] = ACTIONS(3781),
    [anon_sym_in] = ACTIONS(3781),
    [anon_sym_case] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(3785),
    [anon_sym_PIPE_PIPE] = ACTIONS(3785),
    [anon_sym_or_else] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3785),
    [anon_sym_GT] = ACTIONS(3785),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3781),
    [anon_sym_LT] = ACTIONS(3785),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE] = ACTIONS(3785),
    [anon_sym_LT_LT] = ACTIONS(3785),
    [anon_sym_GT_GT] = ACTIONS(3785),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_SLASH] = ACTIONS(3785),
    [anon_sym_PERCENT] = ACTIONS(3785),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3781),
    [anon_sym_not_in] = ACTIONS(3781),
    [anon_sym_or_return] = ACTIONS(3781),
    [anon_sym_or_continue] = ACTIONS(3781),
    [anon_sym_or_break] = ACTIONS(3781),
    [anon_sym_CARET] = ACTIONS(3785),
    [sym_uninitialized] = ACTIONS(3787),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3781),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1362] = {
    [sym_expression] = STATE(6328),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1363] = {
    [sym_expression] = STATE(5920),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6089),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1364] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6091),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1365] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6093),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1366] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6095),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1367] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6097),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1368] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6099),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1369] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6101),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1370] = {
    [sym_expression] = STATE(5858),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6103),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1371] = {
    [sym_expression] = STATE(5881),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(6105),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1372] = {
    [sym_expression] = STATE(6173),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6107),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1373] = {
    [sym_expression] = STATE(5892),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(6109),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1374] = {
    [sym_expression] = STATE(5879),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(6111),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1375] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6113),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1376] = {
    [sym_expression] = STATE(5964),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(6115),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1377] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6117),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1378] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6119),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1379] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6121),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1380] = {
    [sym_expression] = STATE(5948),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6123),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1381] = {
    [sym_expression] = STATE(5978),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(6125),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1382] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6127),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1383] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6129),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1384] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6131),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1385] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6133),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1386] = {
    [sym_expression] = STATE(5877),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(6135),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1387] = {
    [sym_expression] = STATE(5967),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(6137),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1388] = {
    [sym_expression] = STATE(5929),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(6139),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1389] = {
    [sym_expression] = STATE(5919),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6141),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1390] = {
    [sym_expression] = STATE(6045),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6143),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1391] = {
    [sym_expression] = STATE(5939),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6145),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1392] = {
    [sym_expression] = STATE(5885),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(6147),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1393] = {
    [sym_expression] = STATE(6268),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(6149),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1394] = {
    [sym_expression] = STATE(6348),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_RBRACK] = ACTIONS(6151),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1395] = {
    [sym_expression] = STATE(5957),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(6153),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1396] = {
    [sym_expression] = STATE(6436),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_RBRACE] = ACTIONS(6155),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1397] = {
    [sym_expression] = STATE(5973),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(6157),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1398] = {
    [sym_expression] = STATE(5949),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_COLON] = ACTIONS(6159),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1399] = {
    [sym_expression] = STATE(6292),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1400] = {
    [sym_expression] = STATE(4613),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1401] = {
    [sym_block] = STATE(2497),
    [sym_where_clause] = STATE(2117),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_do] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(6165),
    [sym_tag] = ACTIONS(6167),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1402] = {
    [sym_expression] = STATE(5869),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1403] = {
    [sym_block] = STATE(2497),
    [sym_where_clause] = STATE(2117),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(6169),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_do] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(6171),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(6165),
    [sym_tag] = ACTIONS(6167),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1404] = {
    [sym_block] = STATE(2491),
    [sym_where_clause] = STATE(2118),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(6173),
    [sym_tag] = ACTIONS(6175),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1405] = {
    [sym_block] = STATE(2491),
    [sym_where_clause] = STATE(2118),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(6169),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(6171),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(6173),
    [sym_tag] = ACTIONS(6175),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1406] = {
    [sym_block] = STATE(2612),
    [sym_where_clause] = STATE(2255),
    [anon_sym_LBRACE] = ACTIONS(6177),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(6169),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_do] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(6171),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(6179),
    [sym_tag] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1407] = {
    [sym_block] = STATE(2612),
    [sym_where_clause] = STATE(2255),
    [anon_sym_LBRACE] = ACTIONS(6177),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_do] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(6179),
    [sym_tag] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1408] = {
    [sym_expression] = STATE(6390),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1409] = {
    [sym_expression] = STATE(6043),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1410] = {
    [sym_block] = STATE(2612),
    [sym_where_clause] = STATE(2255),
    [anon_sym_LBRACE] = ACTIONS(6177),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_do] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(6179),
    [sym_tag] = ACTIONS(6183),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1411] = {
    [sym_block] = STATE(2483),
    [sym_where_clause] = STATE(2120),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(6185),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(3785),
    [anon_sym_COLON] = ACTIONS(3785),
    [anon_sym_PIPE] = ACTIONS(3785),
    [anon_sym_COLON_EQ] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_when] = ACTIONS(3781),
    [anon_sym_in] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(3785),
    [anon_sym_PIPE_PIPE] = ACTIONS(3785),
    [anon_sym_or_else] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3785),
    [anon_sym_GT] = ACTIONS(3785),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3781),
    [anon_sym_LT] = ACTIONS(3785),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE] = ACTIONS(3785),
    [anon_sym_LT_LT] = ACTIONS(3785),
    [anon_sym_GT_GT] = ACTIONS(3785),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_SLASH] = ACTIONS(3785),
    [anon_sym_PERCENT] = ACTIONS(3785),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3781),
    [anon_sym_not_in] = ACTIONS(3781),
    [anon_sym_or_return] = ACTIONS(3781),
    [anon_sym_or_continue] = ACTIONS(3781),
    [anon_sym_or_break] = ACTIONS(3781),
    [anon_sym_CARET] = ACTIONS(3785),
    [sym_uninitialized] = ACTIONS(6187),
    [sym_tag] = ACTIONS(6189),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1412] = {
    [sym_block] = STATE(2478),
    [sym_where_clause] = STATE(2107),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(4113),
    [anon_sym_COLON_COLON] = ACTIONS(4113),
    [anon_sym_DASH_GT] = ACTIONS(6191),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(4117),
    [anon_sym_COLON] = ACTIONS(4117),
    [anon_sym_PIPE] = ACTIONS(4117),
    [anon_sym_COLON_EQ] = ACTIONS(4113),
    [anon_sym_LPAREN] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4113),
    [anon_sym_DASH_EQ] = ACTIONS(4113),
    [anon_sym_STAR_EQ] = ACTIONS(4113),
    [anon_sym_SLASH_EQ] = ACTIONS(4113),
    [anon_sym_PERCENT_EQ] = ACTIONS(4113),
    [anon_sym_AMP_EQ] = ACTIONS(4113),
    [anon_sym_PIPE_EQ] = ACTIONS(4113),
    [anon_sym_CARET_EQ] = ACTIONS(4113),
    [anon_sym_LT_LT_EQ] = ACTIONS(4113),
    [anon_sym_GT_GT_EQ] = ACTIONS(4113),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4113),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4113),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4113),
    [anon_sym_if] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_do] = ACTIONS(4113),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_in] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4117),
    [anon_sym_DASH] = ACTIONS(4117),
    [anon_sym_TILDE] = ACTIONS(4117),
    [anon_sym_AMP] = ACTIONS(4117),
    [anon_sym_PIPE_PIPE] = ACTIONS(4117),
    [anon_sym_or_else] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4117),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4113),
    [anon_sym_TILDE_EQ] = ACTIONS(4113),
    [anon_sym_AMP_TILDE] = ACTIONS(4117),
    [anon_sym_LT_LT] = ACTIONS(4117),
    [anon_sym_GT_GT] = ACTIONS(4117),
    [anon_sym_STAR] = ACTIONS(4117),
    [anon_sym_SLASH] = ACTIONS(4117),
    [anon_sym_PERCENT] = ACTIONS(4117),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(4117),
    [anon_sym_LBRACK] = ACTIONS(4113),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4113),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4113),
    [anon_sym_not_in] = ACTIONS(4113),
    [anon_sym_or_return] = ACTIONS(4113),
    [anon_sym_or_continue] = ACTIONS(4113),
    [anon_sym_or_break] = ACTIONS(4113),
    [anon_sym_CARET] = ACTIONS(4117),
    [sym_uninitialized] = ACTIONS(6193),
    [sym_tag] = ACTIONS(6195),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1413] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(5817),
    [sym_unary_expression] = STATE(5817),
    [sym_binary_expression] = STATE(5817),
    [sym_ternary_expression] = STATE(5817),
    [sym_call_expression] = STATE(2197),
    [sym_selector_call_expression] = STATE(5817),
    [sym_member_expression] = STATE(5817),
    [sym_index_expression] = STATE(5817),
    [sym_slice_expression] = STATE(5817),
    [sym_range_expression] = STATE(5817),
    [sym_cast_expression] = STATE(5817),
    [sym_in_expression] = STATE(5817),
    [sym_variadic_expression] = STATE(5817),
    [sym_parenthesized_expression] = STATE(5817),
    [sym_or_return_expression] = STATE(5817),
    [sym_or_continue_expression] = STATE(5817),
    [sym_or_break_expression] = STATE(5817),
    [sym_address] = STATE(5817),
    [sym_map_type] = STATE(5817),
    [sym_matrix_type] = STATE(5817),
    [sym_distinct_type] = STATE(5817),
    [sym_literal] = STATE(5817),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(6197),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(6199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1414] = {
    [sym_expression] = STATE(2969),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1415] = {
    [sym_expression] = STATE(6387),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1416] = {
    [sym_block] = STATE(2618),
    [sym_where_clause] = STATE(2196),
    [anon_sym_LBRACE] = ACTIONS(6177),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_do] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(6203),
    [sym_tag] = ACTIONS(6205),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1417] = {
    [sym_expression] = STATE(5997),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1418] = {
    [sym_expression] = STATE(6032),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1419] = {
    [sym_block] = STATE(2618),
    [sym_where_clause] = STATE(2196),
    [anon_sym_LBRACE] = ACTIONS(6177),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_do] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(6203),
    [sym_tag] = ACTIONS(6207),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1420] = {
    [sym_block] = STATE(2618),
    [sym_where_clause] = STATE(2196),
    [anon_sym_LBRACE] = ACTIONS(6177),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(6169),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_do] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(6171),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(6203),
    [sym_tag] = ACTIONS(6207),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1421] = {
    [sym_expression] = STATE(6062),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1422] = {
    [sym_block] = STATE(2597),
    [sym_where_clause] = STATE(2271),
    [anon_sym_LBRACE] = ACTIONS(6177),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_DASH_GT] = ACTIONS(3671),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_PLUS_EQ] = ACTIONS(3671),
    [anon_sym_DASH_EQ] = ACTIONS(3671),
    [anon_sym_STAR_EQ] = ACTIONS(3671),
    [anon_sym_SLASH_EQ] = ACTIONS(3671),
    [anon_sym_PERCENT_EQ] = ACTIONS(3671),
    [anon_sym_AMP_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_CARET_EQ] = ACTIONS(3671),
    [anon_sym_LT_LT_EQ] = ACTIONS(3671),
    [anon_sym_GT_GT_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_if] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_do] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_or_else] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_GT] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3671),
    [anon_sym_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_SLASH] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3671),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3671),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3671),
    [anon_sym_not_in] = ACTIONS(3671),
    [anon_sym_or_return] = ACTIONS(3671),
    [anon_sym_or_continue] = ACTIONS(3671),
    [anon_sym_or_break] = ACTIONS(3671),
    [anon_sym_CARET] = ACTIONS(3675),
    [sym_uninitialized] = ACTIONS(6209),
    [sym_tag] = ACTIONS(6211),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1423] = {
    [sym_block] = STATE(2506),
    [sym_where_clause] = STATE(2111),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_DASH_GT] = ACTIONS(3671),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_PLUS_EQ] = ACTIONS(3671),
    [anon_sym_DASH_EQ] = ACTIONS(3671),
    [anon_sym_STAR_EQ] = ACTIONS(3671),
    [anon_sym_SLASH_EQ] = ACTIONS(3671),
    [anon_sym_PERCENT_EQ] = ACTIONS(3671),
    [anon_sym_AMP_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_CARET_EQ] = ACTIONS(3671),
    [anon_sym_LT_LT_EQ] = ACTIONS(3671),
    [anon_sym_GT_GT_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_if] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_do] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_or_else] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_GT] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3671),
    [anon_sym_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_SLASH] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3671),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3671),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3671),
    [anon_sym_not_in] = ACTIONS(3671),
    [anon_sym_or_return] = ACTIONS(3671),
    [anon_sym_or_continue] = ACTIONS(3671),
    [anon_sym_or_break] = ACTIONS(3671),
    [anon_sym_CARET] = ACTIONS(3675),
    [sym_uninitialized] = ACTIONS(6213),
    [sym_tag] = ACTIONS(6215),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1424] = {
    [sym_expression] = STATE(6377),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1425] = {
    [sym_expression] = STATE(2828),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1426] = {
    [sym_block] = STATE(2503),
    [sym_where_clause] = STATE(2115),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_do] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(6217),
    [sym_tag] = ACTIONS(6219),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1427] = {
    [sym_block] = STATE(2503),
    [sym_where_clause] = STATE(2115),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_do] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(6217),
    [sym_tag] = ACTIONS(6221),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1428] = {
    [sym_block] = STATE(2503),
    [sym_where_clause] = STATE(2115),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(6169),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_do] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(6171),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(6217),
    [sym_tag] = ACTIONS(6221),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1429] = {
    [sym_expression] = STATE(2829),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1430] = {
    [sym_block] = STATE(2497),
    [sym_where_clause] = STATE(2117),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_do] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(6165),
    [sym_tag] = ACTIONS(6223),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1431] = {
    [sym_expression] = STATE(5998),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1432] = {
    [sym_expression] = STATE(5995),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1433] = {
    [sym_expression] = STATE(3219),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1434] = {
    [sym_expression] = STATE(5988),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1435] = {
    [sym_expression] = STATE(5884),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1436] = {
    [sym_expression] = STATE(5936),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1437] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(5805),
    [sym_unary_expression] = STATE(5805),
    [sym_binary_expression] = STATE(5805),
    [sym_ternary_expression] = STATE(5805),
    [sym_call_expression] = STATE(2675),
    [sym_selector_call_expression] = STATE(5805),
    [sym_member_expression] = STATE(5805),
    [sym_index_expression] = STATE(5805),
    [sym_slice_expression] = STATE(5805),
    [sym_range_expression] = STATE(5805),
    [sym_cast_expression] = STATE(5805),
    [sym_in_expression] = STATE(5805),
    [sym_variadic_expression] = STATE(5805),
    [sym_parenthesized_expression] = STATE(5805),
    [sym_or_return_expression] = STATE(5805),
    [sym_or_continue_expression] = STATE(5805),
    [sym_or_break_expression] = STATE(5805),
    [sym_address] = STATE(5805),
    [sym_map_type] = STATE(5805),
    [sym_matrix_type] = STATE(5805),
    [sym_distinct_type] = STATE(5805),
    [sym_literal] = STATE(5805),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(6225),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(6227),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1438] = {
    [sym_expression] = STATE(4724),
    [sym__expression_no_tag] = STATE(4610),
    [sym_unary_expression] = STATE(4610),
    [sym_binary_expression] = STATE(4610),
    [sym_ternary_expression] = STATE(4610),
    [sym_call_expression] = STATE(4610),
    [sym_selector_call_expression] = STATE(4610),
    [sym_member_expression] = STATE(4610),
    [sym_index_expression] = STATE(4610),
    [sym_slice_expression] = STATE(4610),
    [sym_range_expression] = STATE(4610),
    [sym_cast_expression] = STATE(4610),
    [sym_in_expression] = STATE(4610),
    [sym_variadic_expression] = STATE(4610),
    [sym_parenthesized_expression] = STATE(4610),
    [sym_or_return_expression] = STATE(4610),
    [sym_or_continue_expression] = STATE(4610),
    [sym_or_break_expression] = STATE(4610),
    [sym_address] = STATE(4610),
    [sym_map_type] = STATE(4610),
    [sym_matrix_type] = STATE(4610),
    [sym_distinct_type] = STATE(4610),
    [sym_literal] = STATE(4610),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(6229),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1439] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(5835),
    [sym_unary_expression] = STATE(5835),
    [sym_binary_expression] = STATE(5835),
    [sym_ternary_expression] = STATE(5835),
    [sym_call_expression] = STATE(3138),
    [sym_selector_call_expression] = STATE(5835),
    [sym_member_expression] = STATE(5835),
    [sym_index_expression] = STATE(5835),
    [sym_slice_expression] = STATE(5835),
    [sym_range_expression] = STATE(5835),
    [sym_cast_expression] = STATE(5835),
    [sym_in_expression] = STATE(5835),
    [sym_variadic_expression] = STATE(5835),
    [sym_parenthesized_expression] = STATE(5835),
    [sym_or_return_expression] = STATE(5835),
    [sym_or_continue_expression] = STATE(5835),
    [sym_or_break_expression] = STATE(5835),
    [sym_address] = STATE(5835),
    [sym_map_type] = STATE(5835),
    [sym_matrix_type] = STATE(5835),
    [sym_distinct_type] = STATE(5835),
    [sym_literal] = STATE(5835),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(6231),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(6233),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1440] = {
    [sym_expression] = STATE(4359),
    [sym__expression_no_tag] = STATE(4610),
    [sym_unary_expression] = STATE(4610),
    [sym_binary_expression] = STATE(4610),
    [sym_ternary_expression] = STATE(4610),
    [sym_call_expression] = STATE(4610),
    [sym_selector_call_expression] = STATE(4610),
    [sym_member_expression] = STATE(4610),
    [sym_index_expression] = STATE(4610),
    [sym_slice_expression] = STATE(4610),
    [sym_range_expression] = STATE(4610),
    [sym_cast_expression] = STATE(4610),
    [sym_in_expression] = STATE(4610),
    [sym_variadic_expression] = STATE(4610),
    [sym_parenthesized_expression] = STATE(4610),
    [sym_or_return_expression] = STATE(4610),
    [sym_or_continue_expression] = STATE(4610),
    [sym_or_break_expression] = STATE(4610),
    [sym_address] = STATE(4610),
    [sym_map_type] = STATE(4610),
    [sym_matrix_type] = STATE(4610),
    [sym_distinct_type] = STATE(4610),
    [sym_literal] = STATE(4610),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(6229),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1441] = {
    [sym_expression] = STATE(5990),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1442] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(5812),
    [sym_unary_expression] = STATE(5812),
    [sym_binary_expression] = STATE(5812),
    [sym_ternary_expression] = STATE(5812),
    [sym_call_expression] = STATE(4493),
    [sym_selector_call_expression] = STATE(5812),
    [sym_member_expression] = STATE(5812),
    [sym_index_expression] = STATE(5812),
    [sym_slice_expression] = STATE(5812),
    [sym_range_expression] = STATE(5812),
    [sym_cast_expression] = STATE(5812),
    [sym_in_expression] = STATE(5812),
    [sym_variadic_expression] = STATE(5812),
    [sym_parenthesized_expression] = STATE(5812),
    [sym_or_return_expression] = STATE(5812),
    [sym_or_continue_expression] = STATE(5812),
    [sym_or_break_expression] = STATE(5812),
    [sym_address] = STATE(5812),
    [sym_map_type] = STATE(5812),
    [sym_matrix_type] = STATE(5812),
    [sym_distinct_type] = STATE(5812),
    [sym_literal] = STATE(5812),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(6237),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1443] = {
    [sym_expression] = STATE(5880),
    [sym__expression_no_tag] = STATE(5195),
    [sym_unary_expression] = STATE(5195),
    [sym_binary_expression] = STATE(5195),
    [sym_ternary_expression] = STATE(5195),
    [sym_call_expression] = STATE(5195),
    [sym_selector_call_expression] = STATE(5195),
    [sym_member_expression] = STATE(5195),
    [sym_index_expression] = STATE(5195),
    [sym_slice_expression] = STATE(5195),
    [sym_range_expression] = STATE(5195),
    [sym_cast_expression] = STATE(5195),
    [sym_in_expression] = STATE(5195),
    [sym_variadic_expression] = STATE(5195),
    [sym_parenthesized_expression] = STATE(5195),
    [sym_or_return_expression] = STATE(5195),
    [sym_or_continue_expression] = STATE(5195),
    [sym_or_break_expression] = STATE(5195),
    [sym_address] = STATE(5195),
    [sym_map_type] = STATE(5195),
    [sym_matrix_type] = STATE(5195),
    [sym_distinct_type] = STATE(5195),
    [sym_literal] = STATE(5195),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1444] = {
    [sym_expression] = STATE(3891),
    [sym__expression_no_tag] = STATE(3480),
    [sym_unary_expression] = STATE(3480),
    [sym_binary_expression] = STATE(3480),
    [sym_ternary_expression] = STATE(3480),
    [sym_call_expression] = STATE(3480),
    [sym_selector_call_expression] = STATE(3480),
    [sym_member_expression] = STATE(3480),
    [sym_index_expression] = STATE(3480),
    [sym_slice_expression] = STATE(3480),
    [sym_range_expression] = STATE(3480),
    [sym_cast_expression] = STATE(3480),
    [sym_in_expression] = STATE(3480),
    [sym_variadic_expression] = STATE(3480),
    [sym_parenthesized_expression] = STATE(3480),
    [sym_or_return_expression] = STATE(3480),
    [sym_or_continue_expression] = STATE(3480),
    [sym_or_break_expression] = STATE(3480),
    [sym_address] = STATE(3480),
    [sym_map_type] = STATE(3480),
    [sym_matrix_type] = STATE(3480),
    [sym_distinct_type] = STATE(3480),
    [sym_literal] = STATE(3480),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(6241),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1445] = {
    [sym_expression] = STATE(4032),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1446] = {
    [sym_expression] = STATE(4033),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1447] = {
    [sym_expression] = STATE(4034),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1448] = {
    [sym_expression] = STATE(4036),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1449] = {
    [sym_expression] = STATE(5969),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1450] = {
    [sym_expression] = STATE(4015),
    [sym__expression_no_tag] = STATE(3480),
    [sym_unary_expression] = STATE(3480),
    [sym_binary_expression] = STATE(3480),
    [sym_ternary_expression] = STATE(3480),
    [sym_call_expression] = STATE(3480),
    [sym_selector_call_expression] = STATE(3480),
    [sym_member_expression] = STATE(3480),
    [sym_index_expression] = STATE(3480),
    [sym_slice_expression] = STATE(3480),
    [sym_range_expression] = STATE(3480),
    [sym_cast_expression] = STATE(3480),
    [sym_in_expression] = STATE(3480),
    [sym_variadic_expression] = STATE(3480),
    [sym_parenthesized_expression] = STATE(3480),
    [sym_or_return_expression] = STATE(3480),
    [sym_or_continue_expression] = STATE(3480),
    [sym_or_break_expression] = STATE(3480),
    [sym_address] = STATE(3480),
    [sym_map_type] = STATE(3480),
    [sym_matrix_type] = STATE(3480),
    [sym_distinct_type] = STATE(3480),
    [sym_literal] = STATE(3480),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(6241),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1451] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(5829),
    [sym_unary_expression] = STATE(5829),
    [sym_binary_expression] = STATE(5829),
    [sym_ternary_expression] = STATE(5829),
    [sym_call_expression] = STATE(2791),
    [sym_selector_call_expression] = STATE(5829),
    [sym_member_expression] = STATE(5829),
    [sym_index_expression] = STATE(5829),
    [sym_slice_expression] = STATE(5829),
    [sym_range_expression] = STATE(5829),
    [sym_cast_expression] = STATE(5829),
    [sym_in_expression] = STATE(5829),
    [sym_variadic_expression] = STATE(5829),
    [sym_parenthesized_expression] = STATE(5829),
    [sym_or_return_expression] = STATE(5829),
    [sym_or_continue_expression] = STATE(5829),
    [sym_or_break_expression] = STATE(5829),
    [sym_address] = STATE(5829),
    [sym_map_type] = STATE(5829),
    [sym_matrix_type] = STATE(5829),
    [sym_distinct_type] = STATE(5829),
    [sym_literal] = STATE(5829),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(6245),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(6247),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1452] = {
    [sym_expression] = STATE(5872),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1453] = {
    [sym_expression] = STATE(3742),
    [sym__expression_no_tag] = STATE(3476),
    [sym_unary_expression] = STATE(3476),
    [sym_binary_expression] = STATE(3476),
    [sym_ternary_expression] = STATE(3476),
    [sym_call_expression] = STATE(3476),
    [sym_selector_call_expression] = STATE(3476),
    [sym_member_expression] = STATE(3476),
    [sym_index_expression] = STATE(3476),
    [sym_slice_expression] = STATE(3476),
    [sym_range_expression] = STATE(3476),
    [sym_cast_expression] = STATE(3476),
    [sym_in_expression] = STATE(3476),
    [sym_variadic_expression] = STATE(3476),
    [sym_parenthesized_expression] = STATE(3476),
    [sym_or_return_expression] = STATE(3476),
    [sym_or_continue_expression] = STATE(3476),
    [sym_or_break_expression] = STATE(3476),
    [sym_address] = STATE(3476),
    [sym_map_type] = STATE(3476),
    [sym_matrix_type] = STATE(3476),
    [sym_distinct_type] = STATE(3476),
    [sym_literal] = STATE(3476),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(6249),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1454] = {
    [sym_expression] = STATE(3932),
    [sym__expression_no_tag] = STATE(3476),
    [sym_unary_expression] = STATE(3476),
    [sym_binary_expression] = STATE(3476),
    [sym_ternary_expression] = STATE(3476),
    [sym_call_expression] = STATE(3476),
    [sym_selector_call_expression] = STATE(3476),
    [sym_member_expression] = STATE(3476),
    [sym_index_expression] = STATE(3476),
    [sym_slice_expression] = STATE(3476),
    [sym_range_expression] = STATE(3476),
    [sym_cast_expression] = STATE(3476),
    [sym_in_expression] = STATE(3476),
    [sym_variadic_expression] = STATE(3476),
    [sym_parenthesized_expression] = STATE(3476),
    [sym_or_return_expression] = STATE(3476),
    [sym_or_continue_expression] = STATE(3476),
    [sym_or_break_expression] = STATE(3476),
    [sym_address] = STATE(3476),
    [sym_map_type] = STATE(3476),
    [sym_matrix_type] = STATE(3476),
    [sym_distinct_type] = STATE(3476),
    [sym_literal] = STATE(3476),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(6249),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1455] = {
    [sym_expression] = STATE(6013),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1456] = {
    [sym_expression] = STATE(6248),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1457] = {
    [sym_expression] = STATE(5956),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1458] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(5793),
    [sym_unary_expression] = STATE(5793),
    [sym_binary_expression] = STATE(5793),
    [sym_ternary_expression] = STATE(5793),
    [sym_call_expression] = STATE(4707),
    [sym_selector_call_expression] = STATE(5793),
    [sym_member_expression] = STATE(5793),
    [sym_index_expression] = STATE(5793),
    [sym_slice_expression] = STATE(5793),
    [sym_range_expression] = STATE(5793),
    [sym_cast_expression] = STATE(5793),
    [sym_in_expression] = STATE(5793),
    [sym_variadic_expression] = STATE(5793),
    [sym_parenthesized_expression] = STATE(5793),
    [sym_or_return_expression] = STATE(5793),
    [sym_or_continue_expression] = STATE(5793),
    [sym_or_break_expression] = STATE(5793),
    [sym_address] = STATE(5793),
    [sym_map_type] = STATE(5793),
    [sym_matrix_type] = STATE(5793),
    [sym_distinct_type] = STATE(5793),
    [sym_literal] = STATE(5793),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(6253),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(6255),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1459] = {
    [sym_expression] = STATE(2830),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1460] = {
    [sym_expression] = STATE(2831),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1461] = {
    [sym_expression] = STATE(2784),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1462] = {
    [sym_expression] = STATE(5811),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1463] = {
    [sym_expression] = STATE(711),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1464] = {
    [sym_expression] = STATE(5979),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1465] = {
    [sym_expression] = STATE(2780),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1466] = {
    [sym_expression] = STATE(2772),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1467] = {
    [sym_expression] = STATE(2778),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1468] = {
    [sym_expression] = STATE(2860),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1469] = {
    [sym_expression] = STATE(2759),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1470] = {
    [sym_expression] = STATE(2760),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1471] = {
    [sym_expression] = STATE(3450),
    [sym__expression_no_tag] = STATE(2777),
    [sym_unary_expression] = STATE(2777),
    [sym_binary_expression] = STATE(2777),
    [sym_ternary_expression] = STATE(2777),
    [sym_call_expression] = STATE(2777),
    [sym_selector_call_expression] = STATE(2777),
    [sym_member_expression] = STATE(2777),
    [sym_index_expression] = STATE(2777),
    [sym_slice_expression] = STATE(2777),
    [sym_range_expression] = STATE(2777),
    [sym_cast_expression] = STATE(2777),
    [sym_in_expression] = STATE(2777),
    [sym_variadic_expression] = STATE(2777),
    [sym_parenthesized_expression] = STATE(2777),
    [sym_or_return_expression] = STATE(2777),
    [sym_or_continue_expression] = STATE(2777),
    [sym_or_break_expression] = STATE(2777),
    [sym_address] = STATE(2777),
    [sym_map_type] = STATE(2777),
    [sym_matrix_type] = STATE(2777),
    [sym_distinct_type] = STATE(2777),
    [sym_literal] = STATE(2777),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1472] = {
    [sym_expression] = STATE(4140),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1473] = {
    [sym_expression] = STATE(4149),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1474] = {
    [sym_expression] = STATE(4162),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1475] = {
    [sym_expression] = STATE(4165),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1476] = {
    [sym_expression] = STATE(4044),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1477] = {
    [sym_expression] = STATE(4160),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1478] = {
    [sym_expression] = STATE(4159),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1479] = {
    [sym_expression] = STATE(4156),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1480] = {
    [sym_expression] = STATE(4155),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1481] = {
    [sym_expression] = STATE(4154),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1482] = {
    [sym_expression] = STATE(4148),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1483] = {
    [sym_expression] = STATE(4147),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1484] = {
    [sym_expression] = STATE(4146),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1485] = {
    [sym_expression] = STATE(4137),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1486] = {
    [sym_expression] = STATE(2761),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1487] = {
    [sym_expression] = STATE(2762),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1488] = {
    [sym_expression] = STATE(3636),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1489] = {
    [sym_expression] = STATE(2763),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1490] = {
    [sym_expression] = STATE(2764),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1491] = {
    [sym_expression] = STATE(2765),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1492] = {
    [sym_expression] = STATE(2766),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1493] = {
    [sym_expression] = STATE(2767),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1494] = {
    [sym_block] = STATE(2605),
    [sym_where_clause] = STATE(2245),
    [anon_sym_LBRACE] = ACTIONS(6177),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(6261),
    [sym_tag] = ACTIONS(6263),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1495] = {
    [sym_block] = STATE(2605),
    [sym_where_clause] = STATE(2245),
    [anon_sym_LBRACE] = ACTIONS(6177),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(6169),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(6171),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(6261),
    [sym_tag] = ACTIONS(6263),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1496] = {
    [sym_expression] = STATE(724),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1497] = {
    [aux_sym_field_type_repeat1] = STATE(1706),
    [anon_sym_LBRACE] = ACTIONS(4185),
    [anon_sym_COMMA] = ACTIONS(4185),
    [anon_sym_COLON_COLON] = ACTIONS(4185),
    [anon_sym_DASH_GT] = ACTIONS(4185),
    [anon_sym_where] = ACTIONS(4185),
    [anon_sym_EQ] = ACTIONS(4187),
    [anon_sym_COLON] = ACTIONS(6265),
    [anon_sym_PIPE] = ACTIONS(4187),
    [anon_sym_COLON_EQ] = ACTIONS(4185),
    [anon_sym_LPAREN] = ACTIONS(4185),
    [anon_sym_PLUS_EQ] = ACTIONS(4185),
    [anon_sym_DASH_EQ] = ACTIONS(4185),
    [anon_sym_STAR_EQ] = ACTIONS(4185),
    [anon_sym_SLASH_EQ] = ACTIONS(4185),
    [anon_sym_PERCENT_EQ] = ACTIONS(4185),
    [anon_sym_AMP_EQ] = ACTIONS(4185),
    [anon_sym_PIPE_EQ] = ACTIONS(4185),
    [anon_sym_CARET_EQ] = ACTIONS(4185),
    [anon_sym_LT_LT_EQ] = ACTIONS(4185),
    [anon_sym_GT_GT_EQ] = ACTIONS(4185),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4185),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4185),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4185),
    [anon_sym_if] = ACTIONS(4185),
    [anon_sym_SEMI] = ACTIONS(4185),
    [anon_sym_do] = ACTIONS(4185),
    [anon_sym_when] = ACTIONS(4185),
    [anon_sym_in] = ACTIONS(4185),
    [anon_sym_QMARK] = ACTIONS(4185),
    [anon_sym_PLUS] = ACTIONS(4187),
    [anon_sym_DASH] = ACTIONS(4187),
    [anon_sym_TILDE] = ACTIONS(4187),
    [anon_sym_AMP] = ACTIONS(4187),
    [anon_sym_PIPE_PIPE] = ACTIONS(4187),
    [anon_sym_or_else] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4187),
    [anon_sym_GT] = ACTIONS(4187),
    [anon_sym_GT_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4185),
    [anon_sym_LT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4185),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_TILDE_EQ] = ACTIONS(4185),
    [anon_sym_AMP_TILDE] = ACTIONS(4187),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_STAR] = ACTIONS(4187),
    [anon_sym_SLASH] = ACTIONS(4187),
    [anon_sym_PERCENT] = ACTIONS(4187),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4185),
    [anon_sym_DOT] = ACTIONS(4187),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4185),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4185),
    [anon_sym_not_in] = ACTIONS(4185),
    [anon_sym_or_return] = ACTIONS(4185),
    [anon_sym_or_continue] = ACTIONS(4185),
    [anon_sym_or_break] = ACTIONS(4185),
    [anon_sym_CARET] = ACTIONS(4187),
    [anon_sym_DOT2] = ACTIONS(6267),
    [sym_uninitialized] = ACTIONS(4185),
    [sym_tag] = ACTIONS(4185),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1498] = {
    [sym_expression] = STATE(6191),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1499] = {
    [sym_expression] = STATE(4549),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1500] = {
    [sym_expression] = STATE(5961),
    [sym__expression_no_tag] = STATE(5195),
    [sym_unary_expression] = STATE(5195),
    [sym_binary_expression] = STATE(5195),
    [sym_ternary_expression] = STATE(5195),
    [sym_call_expression] = STATE(5195),
    [sym_selector_call_expression] = STATE(5195),
    [sym_member_expression] = STATE(5195),
    [sym_index_expression] = STATE(5195),
    [sym_slice_expression] = STATE(5195),
    [sym_range_expression] = STATE(5195),
    [sym_cast_expression] = STATE(5195),
    [sym_in_expression] = STATE(5195),
    [sym_variadic_expression] = STATE(5195),
    [sym_parenthesized_expression] = STATE(5195),
    [sym_or_return_expression] = STATE(5195),
    [sym_or_continue_expression] = STATE(5195),
    [sym_or_break_expression] = STATE(5195),
    [sym_address] = STATE(5195),
    [sym_map_type] = STATE(5195),
    [sym_matrix_type] = STATE(5195),
    [sym_distinct_type] = STATE(5195),
    [sym_literal] = STATE(5195),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1501] = {
    [sym_expression] = STATE(4505),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1502] = {
    [sym_expression] = STATE(6366),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1503] = {
    [sym_expression] = STATE(6008),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1504] = {
    [sym_expression] = STATE(2797),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1505] = {
    [sym_expression] = STATE(2816),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1506] = {
    [sym_expression] = STATE(2817),
    [sym__expression_no_tag] = STATE(2841),
    [sym_unary_expression] = STATE(2841),
    [sym_binary_expression] = STATE(2841),
    [sym_ternary_expression] = STATE(2841),
    [sym_call_expression] = STATE(2841),
    [sym_selector_call_expression] = STATE(2841),
    [sym_member_expression] = STATE(2841),
    [sym_index_expression] = STATE(2841),
    [sym_slice_expression] = STATE(2841),
    [sym_range_expression] = STATE(2841),
    [sym_cast_expression] = STATE(2841),
    [sym_in_expression] = STATE(2841),
    [sym_variadic_expression] = STATE(2841),
    [sym_parenthesized_expression] = STATE(2841),
    [sym_or_return_expression] = STATE(2841),
    [sym_or_continue_expression] = STATE(2841),
    [sym_or_break_expression] = STATE(2841),
    [sym_address] = STATE(2841),
    [sym_map_type] = STATE(2841),
    [sym_matrix_type] = STATE(2841),
    [sym_distinct_type] = STATE(2841),
    [sym_literal] = STATE(2841),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1507] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(5845),
    [sym_unary_expression] = STATE(5845),
    [sym_binary_expression] = STATE(5845),
    [sym_ternary_expression] = STATE(5845),
    [sym_call_expression] = STATE(3263),
    [sym_selector_call_expression] = STATE(5845),
    [sym_member_expression] = STATE(5845),
    [sym_index_expression] = STATE(5845),
    [sym_slice_expression] = STATE(5845),
    [sym_range_expression] = STATE(5845),
    [sym_cast_expression] = STATE(5845),
    [sym_in_expression] = STATE(5845),
    [sym_variadic_expression] = STATE(5845),
    [sym_parenthesized_expression] = STATE(5845),
    [sym_or_return_expression] = STATE(5845),
    [sym_or_continue_expression] = STATE(5845),
    [sym_or_break_expression] = STATE(5845),
    [sym_address] = STATE(5845),
    [sym_map_type] = STATE(5845),
    [sym_matrix_type] = STATE(5845),
    [sym_distinct_type] = STATE(5845),
    [sym_literal] = STATE(5845),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(6269),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(6271),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1508] = {
    [sym_expression] = STATE(4839),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1509] = {
    [sym_expression] = STATE(2121),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [1510] = {
    [sym_expression] = STATE(2451),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [1511] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(5851),
    [sym_unary_expression] = STATE(5851),
    [sym_binary_expression] = STATE(5851),
    [sym_ternary_expression] = STATE(5851),
    [sym_call_expression] = STATE(3486),
    [sym_selector_call_expression] = STATE(5851),
    [sym_member_expression] = STATE(5851),
    [sym_index_expression] = STATE(5851),
    [sym_slice_expression] = STATE(5851),
    [sym_range_expression] = STATE(5851),
    [sym_cast_expression] = STATE(5851),
    [sym_in_expression] = STATE(5851),
    [sym_variadic_expression] = STATE(5851),
    [sym_parenthesized_expression] = STATE(5851),
    [sym_or_return_expression] = STATE(5851),
    [sym_or_continue_expression] = STATE(5851),
    [sym_or_break_expression] = STATE(5851),
    [sym_address] = STATE(5851),
    [sym_map_type] = STATE(5851),
    [sym_matrix_type] = STATE(5851),
    [sym_distinct_type] = STATE(5851),
    [sym_literal] = STATE(5851),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(6277),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(6279),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1512] = {
    [sym_expression] = STATE(3382),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1513] = {
    [sym_expression] = STATE(5996),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1514] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(5834),
    [sym_unary_expression] = STATE(5834),
    [sym_binary_expression] = STATE(5834),
    [sym_ternary_expression] = STATE(5834),
    [sym_call_expression] = STATE(4290),
    [sym_selector_call_expression] = STATE(5834),
    [sym_member_expression] = STATE(5834),
    [sym_index_expression] = STATE(5834),
    [sym_slice_expression] = STATE(5834),
    [sym_range_expression] = STATE(5834),
    [sym_cast_expression] = STATE(5834),
    [sym_in_expression] = STATE(5834),
    [sym_variadic_expression] = STATE(5834),
    [sym_parenthesized_expression] = STATE(5834),
    [sym_or_return_expression] = STATE(5834),
    [sym_or_continue_expression] = STATE(5834),
    [sym_or_break_expression] = STATE(5834),
    [sym_address] = STATE(5834),
    [sym_map_type] = STATE(5834),
    [sym_matrix_type] = STATE(5834),
    [sym_distinct_type] = STATE(5834),
    [sym_literal] = STATE(5834),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(6283),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1515] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(5846),
    [sym_unary_expression] = STATE(5846),
    [sym_binary_expression] = STATE(5846),
    [sym_ternary_expression] = STATE(5846),
    [sym_call_expression] = STATE(973),
    [sym_selector_call_expression] = STATE(5846),
    [sym_member_expression] = STATE(5846),
    [sym_index_expression] = STATE(5846),
    [sym_slice_expression] = STATE(5846),
    [sym_range_expression] = STATE(5846),
    [sym_cast_expression] = STATE(5846),
    [sym_in_expression] = STATE(5846),
    [sym_variadic_expression] = STATE(5846),
    [sym_parenthesized_expression] = STATE(5846),
    [sym_or_return_expression] = STATE(5846),
    [sym_or_continue_expression] = STATE(5846),
    [sym_or_break_expression] = STATE(5846),
    [sym_address] = STATE(5846),
    [sym_map_type] = STATE(5846),
    [sym_matrix_type] = STATE(5846),
    [sym_distinct_type] = STATE(5846),
    [sym_literal] = STATE(5846),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(6285),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(6287),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1516] = {
    [sym_expression] = STATE(6040),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1517] = {
    [sym_expression] = STATE(4618),
    [sym__expression_no_tag] = STATE(4320),
    [sym_unary_expression] = STATE(4320),
    [sym_binary_expression] = STATE(4320),
    [sym_ternary_expression] = STATE(4320),
    [sym_call_expression] = STATE(4320),
    [sym_selector_call_expression] = STATE(4320),
    [sym_member_expression] = STATE(4320),
    [sym_index_expression] = STATE(4320),
    [sym_slice_expression] = STATE(4320),
    [sym_range_expression] = STATE(4320),
    [sym_cast_expression] = STATE(4320),
    [sym_in_expression] = STATE(4320),
    [sym_variadic_expression] = STATE(4320),
    [sym_parenthesized_expression] = STATE(4320),
    [sym_or_return_expression] = STATE(4320),
    [sym_or_continue_expression] = STATE(4320),
    [sym_or_break_expression] = STATE(4320),
    [sym_address] = STATE(4320),
    [sym_map_type] = STATE(4320),
    [sym_matrix_type] = STATE(4320),
    [sym_distinct_type] = STATE(4320),
    [sym_literal] = STATE(4320),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(6289),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1518] = {
    [sym_expression] = STATE(4669),
    [sym__expression_no_tag] = STATE(4320),
    [sym_unary_expression] = STATE(4320),
    [sym_binary_expression] = STATE(4320),
    [sym_ternary_expression] = STATE(4320),
    [sym_call_expression] = STATE(4320),
    [sym_selector_call_expression] = STATE(4320),
    [sym_member_expression] = STATE(4320),
    [sym_index_expression] = STATE(4320),
    [sym_slice_expression] = STATE(4320),
    [sym_range_expression] = STATE(4320),
    [sym_cast_expression] = STATE(4320),
    [sym_in_expression] = STATE(4320),
    [sym_variadic_expression] = STATE(4320),
    [sym_parenthesized_expression] = STATE(4320),
    [sym_or_return_expression] = STATE(4320),
    [sym_or_continue_expression] = STATE(4320),
    [sym_or_break_expression] = STATE(4320),
    [sym_address] = STATE(4320),
    [sym_map_type] = STATE(4320),
    [sym_matrix_type] = STATE(4320),
    [sym_distinct_type] = STATE(4320),
    [sym_literal] = STATE(4320),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(6289),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1519] = {
    [sym_expression] = STATE(5946),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1520] = {
    [sym_expression] = STATE(4151),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1521] = {
    [sym_expression] = STATE(4150),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1522] = {
    [sym_expression] = STATE(4417),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1523] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(5841),
    [sym_unary_expression] = STATE(5841),
    [sym_binary_expression] = STATE(5841),
    [sym_ternary_expression] = STATE(5841),
    [sym_call_expression] = STATE(2264),
    [sym_selector_call_expression] = STATE(5841),
    [sym_member_expression] = STATE(5841),
    [sym_index_expression] = STATE(5841),
    [sym_slice_expression] = STATE(5841),
    [sym_range_expression] = STATE(5841),
    [sym_cast_expression] = STATE(5841),
    [sym_in_expression] = STATE(5841),
    [sym_variadic_expression] = STATE(5841),
    [sym_parenthesized_expression] = STATE(5841),
    [sym_or_return_expression] = STATE(5841),
    [sym_or_continue_expression] = STATE(5841),
    [sym_or_break_expression] = STATE(5841),
    [sym_address] = STATE(5841),
    [sym_map_type] = STATE(5841),
    [sym_matrix_type] = STATE(5841),
    [sym_distinct_type] = STATE(5841),
    [sym_literal] = STATE(5841),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(6295),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1524] = {
    [sym_expression] = STATE(4020),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1525] = {
    [sym_expression] = STATE(5843),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1526] = {
    [sym_expression] = STATE(4263),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1527] = {
    [sym_expression] = STATE(5893),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1528] = {
    [sym_expression] = STATE(5882),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1529] = {
    [sym_expression] = STATE(4834),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1530] = {
    [sym_expression] = STATE(6042),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1531] = {
    [sym_expression] = STATE(3349),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1532] = {
    [sym_expression] = STATE(4359),
    [sym__expression_no_tag] = STATE(3827),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_ternary_expression] = STATE(3827),
    [sym_call_expression] = STATE(3827),
    [sym_selector_call_expression] = STATE(3827),
    [sym_member_expression] = STATE(3827),
    [sym_index_expression] = STATE(3827),
    [sym_slice_expression] = STATE(3827),
    [sym_range_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_in_expression] = STATE(3827),
    [sym_variadic_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3827),
    [sym_or_return_expression] = STATE(3827),
    [sym_or_continue_expression] = STATE(3827),
    [sym_or_break_expression] = STATE(3827),
    [sym_address] = STATE(3827),
    [sym_map_type] = STATE(3827),
    [sym_matrix_type] = STATE(3827),
    [sym_distinct_type] = STATE(3827),
    [sym_literal] = STATE(3827),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(6297),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1533] = {
    [sym_expression] = STATE(3555),
    [sym__expression_no_tag] = STATE(2777),
    [sym_unary_expression] = STATE(2777),
    [sym_binary_expression] = STATE(2777),
    [sym_ternary_expression] = STATE(2777),
    [sym_call_expression] = STATE(2777),
    [sym_selector_call_expression] = STATE(2777),
    [sym_member_expression] = STATE(2777),
    [sym_index_expression] = STATE(2777),
    [sym_slice_expression] = STATE(2777),
    [sym_range_expression] = STATE(2777),
    [sym_cast_expression] = STATE(2777),
    [sym_in_expression] = STATE(2777),
    [sym_variadic_expression] = STATE(2777),
    [sym_parenthesized_expression] = STATE(2777),
    [sym_or_return_expression] = STATE(2777),
    [sym_or_continue_expression] = STATE(2777),
    [sym_or_break_expression] = STATE(2777),
    [sym_address] = STATE(2777),
    [sym_map_type] = STATE(2777),
    [sym_matrix_type] = STATE(2777),
    [sym_distinct_type] = STATE(2777),
    [sym_literal] = STATE(2777),
    [sym_struct] = STATE(2808),
    [sym_map] = STATE(2792),
    [sym_bit_set] = STATE(2792),
    [sym_matrix] = STATE(2792),
    [sym_string] = STATE(2792),
    [sym__string_literal] = STATE(2818),
    [sym__raw_string_literal] = STATE(2818),
    [sym_character] = STATE(2792),
    [sym_boolean] = STATE(2792),
    [sym_nil] = STATE(2792),
    [sym_field_identifier] = STATE(8627),
    [sym_identifier] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_QMARK] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3019),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_cast] = ACTIONS(347),
    [anon_sym_transmute] = ACTIONS(347),
    [anon_sym_auto_cast] = ACTIONS(349),
    [anon_sym_DOT_DOT] = ACTIONS(3021),
    [anon_sym_map] = ACTIONS(353),
    [anon_sym_bit_set] = ACTIONS(355),
    [anon_sym_matrix] = ACTIONS(357),
    [anon_sym_distinct] = ACTIONS(359),
    [sym_number] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(369),
    [anon_sym_false] = ACTIONS(369),
    [anon_sym_nil] = ACTIONS(371),
    [sym_uninitialized] = ACTIONS(361),
    [sym_tag] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(361),
    [sym_block_comment] = ACTIONS(3),
  },
  [1534] = {
    [sym_expression] = STATE(6413),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1535] = {
    [sym_expression] = STATE(6395),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1536] = {
    [sym_expression] = STATE(5902),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1537] = {
    [sym_expression] = STATE(3111),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1538] = {
    [sym_expression] = STATE(5807),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(6299),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1539] = {
    [sym_expression] = STATE(5933),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1540] = {
    [sym_expression] = STATE(6273),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1541] = {
    [sym_expression] = STATE(5940),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1542] = {
    [sym_expression] = STATE(5941),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1543] = {
    [sym_expression] = STATE(5853),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1544] = {
    [sym_expression] = STATE(6015),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1545] = {
    [sym_expression] = STATE(6290),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1546] = {
    [sym_expression] = STATE(3923),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1547] = {
    [sym_expression] = STATE(6208),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1548] = {
    [sym_expression] = STATE(6205),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1549] = {
    [sym_block] = STATE(2567),
    [sym_where_clause] = STATE(2323),
    [anon_sym_LBRACE] = ACTIONS(6177),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(6301),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(3785),
    [anon_sym_COLON] = ACTIONS(3785),
    [anon_sym_PIPE] = ACTIONS(3785),
    [anon_sym_COLON_EQ] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_when] = ACTIONS(3781),
    [anon_sym_in] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(3785),
    [anon_sym_PIPE_PIPE] = ACTIONS(3785),
    [anon_sym_or_else] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3785),
    [anon_sym_GT] = ACTIONS(3785),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3781),
    [anon_sym_LT] = ACTIONS(3785),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE] = ACTIONS(3785),
    [anon_sym_LT_LT] = ACTIONS(3785),
    [anon_sym_GT_GT] = ACTIONS(3785),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_SLASH] = ACTIONS(3785),
    [anon_sym_PERCENT] = ACTIONS(3785),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3781),
    [anon_sym_not_in] = ACTIONS(3781),
    [anon_sym_or_return] = ACTIONS(3781),
    [anon_sym_or_continue] = ACTIONS(3781),
    [anon_sym_or_break] = ACTIONS(3781),
    [anon_sym_CARET] = ACTIONS(3785),
    [sym_uninitialized] = ACTIONS(6303),
    [sym_tag] = ACTIONS(6305),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1550] = {
    [sym_expression] = STATE(5977),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1551] = {
    [sym_expression] = STATE(6168),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1552] = {
    [sym_expression] = STATE(5918),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1553] = {
    [sym_expression] = STATE(5887),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1554] = {
    [sym_expression] = STATE(5888),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1555] = {
    [sym_expression] = STATE(6231),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1556] = {
    [sym_expression] = STATE(6237),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1557] = {
    [sym_expression] = STATE(3346),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1558] = {
    [sym_expression] = STATE(3114),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1559] = {
    [sym_expression] = STATE(3320),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1560] = {
    [sym_expression] = STATE(3292),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1561] = {
    [sym_expression] = STATE(5868),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1562] = {
    [sym_expression] = STATE(5907),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1563] = {
    [sym_expression] = STATE(6371),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1564] = {
    [sym_expression] = STATE(3969),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1565] = {
    [sym_expression] = STATE(3970),
    [sym__expression_no_tag] = STATE(4008),
    [sym_unary_expression] = STATE(4008),
    [sym_binary_expression] = STATE(4008),
    [sym_ternary_expression] = STATE(4008),
    [sym_call_expression] = STATE(4008),
    [sym_selector_call_expression] = STATE(4008),
    [sym_member_expression] = STATE(4008),
    [sym_index_expression] = STATE(4008),
    [sym_slice_expression] = STATE(4008),
    [sym_range_expression] = STATE(4008),
    [sym_cast_expression] = STATE(4008),
    [sym_in_expression] = STATE(4008),
    [sym_variadic_expression] = STATE(4008),
    [sym_parenthesized_expression] = STATE(4008),
    [sym_or_return_expression] = STATE(4008),
    [sym_or_continue_expression] = STATE(4008),
    [sym_or_break_expression] = STATE(4008),
    [sym_address] = STATE(4008),
    [sym_map_type] = STATE(4008),
    [sym_matrix_type] = STATE(4008),
    [sym_distinct_type] = STATE(4008),
    [sym_literal] = STATE(4008),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1566] = {
    [sym_expression] = STATE(5873),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1567] = {
    [sym_expression] = STATE(5870),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1568] = {
    [sym_expression] = STATE(5931),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1569] = {
    [sym_expression] = STATE(6354),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(6307),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1570] = {
    [sym_expression] = STATE(6399),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1571] = {
    [sym_expression] = STATE(6396),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1572] = {
    [sym_expression] = STATE(6027),
    [sym__expression_no_tag] = STATE(5195),
    [sym_unary_expression] = STATE(5195),
    [sym_binary_expression] = STATE(5195),
    [sym_ternary_expression] = STATE(5195),
    [sym_call_expression] = STATE(5195),
    [sym_selector_call_expression] = STATE(5195),
    [sym_member_expression] = STATE(5195),
    [sym_index_expression] = STATE(5195),
    [sym_slice_expression] = STATE(5195),
    [sym_range_expression] = STATE(5195),
    [sym_cast_expression] = STATE(5195),
    [sym_in_expression] = STATE(5195),
    [sym_variadic_expression] = STATE(5195),
    [sym_parenthesized_expression] = STATE(5195),
    [sym_or_return_expression] = STATE(5195),
    [sym_or_continue_expression] = STATE(5195),
    [sym_or_break_expression] = STATE(5195),
    [sym_address] = STATE(5195),
    [sym_map_type] = STATE(5195),
    [sym_matrix_type] = STATE(5195),
    [sym_distinct_type] = STATE(5195),
    [sym_literal] = STATE(5195),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1573] = {
    [sym_expression] = STATE(3318),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1574] = {
    [sym_expression] = STATE(5942),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1575] = {
    [sym_expression] = STATE(5871),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1576] = {
    [sym_expression] = STATE(6253),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1577] = {
    [sym_expression] = STATE(3113),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1578] = {
    [sym_expression] = STATE(5787),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1579] = {
    [sym_expression] = STATE(5952),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1580] = {
    [sym_expression] = STATE(5958),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1581] = {
    [sym_expression] = STATE(5972),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1582] = {
    [sym_expression] = STATE(6158),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1583] = {
    [sym_expression] = STATE(6154),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1584] = {
    [sym_expression] = STATE(3322),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1585] = {
    [sym_expression] = STATE(5883),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1586] = {
    [sym_expression] = STATE(6180),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1587] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4136),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1588] = {
    [sym_expression] = STATE(5910),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1589] = {
    [sym_expression] = STATE(5935),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1590] = {
    [sym_expression] = STATE(5965),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1591] = {
    [sym_expression] = STATE(6218),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1592] = {
    [sym_expression] = STATE(6219),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1593] = {
    [sym_expression] = STATE(3339),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1594] = {
    [sym_expression] = STATE(5911),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1595] = {
    [sym_expression] = STATE(6368),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1596] = {
    [sym_expression] = STATE(5950),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1597] = {
    [sym_expression] = STATE(5896),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1598] = {
    [sym_expression] = STATE(5898),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1599] = {
    [sym_expression] = STATE(6151),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1600] = {
    [sym_expression] = STATE(6142),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1601] = {
    [sym_expression] = STATE(3271),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1602] = {
    [sym_expression] = STATE(5960),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1603] = {
    [sym_expression] = STATE(6287),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1604] = {
    [sym_expression] = STATE(5889),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1605] = {
    [sym_expression] = STATE(5886),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1606] = {
    [sym_expression] = STATE(5855),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1607] = {
    [sym_expression] = STATE(5875),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1608] = {
    [sym_expression] = STATE(5704),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1609] = {
    [sym_expression] = STATE(4847),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1610] = {
    [sym_expression] = STATE(6296),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1611] = {
    [sym_expression] = STATE(3167),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1612] = {
    [sym_expression] = STATE(3185),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1613] = {
    [sym_expression] = STATE(5984),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1614] = {
    [sym_expression] = STATE(6179),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1615] = {
    [sym_expression] = STATE(5962),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1616] = {
    [sym_expression] = STATE(5975),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1617] = {
    [sym_expression] = STATE(5901),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1618] = {
    [sym_expression] = STATE(6082),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1619] = {
    [sym_expression] = STATE(6083),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1620] = {
    [sym_expression] = STATE(3187),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1621] = {
    [sym_expression] = STATE(5930),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1622] = {
    [sym_expression] = STATE(5938),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1623] = {
    [sym_expression] = STATE(6143),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1624] = {
    [sym_expression] = STATE(5945),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1625] = {
    [sym_expression] = STATE(5955),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1626] = {
    [sym_expression] = STATE(5985),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1627] = {
    [sym_expression] = STATE(3198),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1628] = {
    [sym_expression] = STATE(6233),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1629] = {
    [sym_expression] = STATE(6234),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1630] = {
    [sym_expression] = STATE(3207),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1631] = {
    [sym_expression] = STATE(5934),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1632] = {
    [sym_expression] = STATE(6294),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1633] = {
    [sym_expression] = STATE(5925),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1634] = {
    [sym_expression] = STATE(5922),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1635] = {
    [sym_expression] = STATE(5916),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1636] = {
    [sym_expression] = STATE(6382),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1637] = {
    [sym_expression] = STATE(5943),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1638] = {
    [sym_expression] = STATE(6383),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1639] = {
    [sym_expression] = STATE(3269),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1640] = {
    [sym_expression] = STATE(5867),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1641] = {
    [sym_expression] = STATE(6441),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1642] = {
    [sym_expression] = STATE(5864),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1643] = {
    [sym_expression] = STATE(5861),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1644] = {
    [sym_expression] = STATE(5859),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1645] = {
    [sym_expression] = STATE(6405),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1646] = {
    [sym_expression] = STATE(6404),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1647] = {
    [sym_expression] = STATE(3270),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1648] = {
    [sym_expression] = STATE(6024),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1649] = {
    [sym_expression] = STATE(2973),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1650] = {
    [sym_expression] = STATE(5900),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1651] = {
    [sym_expression] = STATE(2974),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1652] = {
    [sym_expression] = STATE(6363),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1653] = {
    [sym_expression] = STATE(4043),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1654] = {
    [sym_expression] = STATE(5904),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1655] = {
    [sym_expression] = STATE(4039),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1656] = {
    [sym_expression] = STATE(3306),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1657] = {
    [sym_expression] = STATE(3308),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1658] = {
    [sym_expression] = STATE(6359),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1659] = {
    [sym_expression] = STATE(3315),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1660] = {
    [sym_expression] = STATE(3363),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1661] = {
    [sym_expression] = STATE(3364),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1662] = {
    [sym_expression] = STATE(3366),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1663] = {
    [sym_expression] = STATE(5909),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1664] = {
    [sym_expression] = STATE(3367),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1665] = {
    [sym_expression] = STATE(3262),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1666] = {
    [sym_expression] = STATE(5914),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1667] = {
    [sym_expression] = STATE(6026),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1668] = {
    [sym_expression] = STATE(3261),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1669] = {
    [sym_block] = STATE(2589),
    [sym_where_clause] = STATE(2359),
    [anon_sym_LBRACE] = ACTIONS(6177),
    [anon_sym_COMMA] = ACTIONS(4113),
    [anon_sym_COLON_COLON] = ACTIONS(4113),
    [anon_sym_DASH_GT] = ACTIONS(6309),
    [anon_sym_where] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(4117),
    [anon_sym_COLON] = ACTIONS(4117),
    [anon_sym_PIPE] = ACTIONS(4117),
    [anon_sym_COLON_EQ] = ACTIONS(4113),
    [anon_sym_LPAREN] = ACTIONS(4113),
    [anon_sym_PLUS_EQ] = ACTIONS(4113),
    [anon_sym_DASH_EQ] = ACTIONS(4113),
    [anon_sym_STAR_EQ] = ACTIONS(4113),
    [anon_sym_SLASH_EQ] = ACTIONS(4113),
    [anon_sym_PERCENT_EQ] = ACTIONS(4113),
    [anon_sym_AMP_EQ] = ACTIONS(4113),
    [anon_sym_PIPE_EQ] = ACTIONS(4113),
    [anon_sym_CARET_EQ] = ACTIONS(4113),
    [anon_sym_LT_LT_EQ] = ACTIONS(4113),
    [anon_sym_GT_GT_EQ] = ACTIONS(4113),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4113),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4113),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4113),
    [anon_sym_if] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_do] = ACTIONS(4113),
    [anon_sym_when] = ACTIONS(4113),
    [anon_sym_in] = ACTIONS(4113),
    [anon_sym_QMARK] = ACTIONS(4113),
    [anon_sym_PLUS] = ACTIONS(4117),
    [anon_sym_DASH] = ACTIONS(4117),
    [anon_sym_TILDE] = ACTIONS(4117),
    [anon_sym_AMP] = ACTIONS(4117),
    [anon_sym_PIPE_PIPE] = ACTIONS(4117),
    [anon_sym_or_else] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4117),
    [anon_sym_GT] = ACTIONS(4117),
    [anon_sym_GT_EQ] = ACTIONS(4113),
    [anon_sym_LT_EQ] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4117),
    [anon_sym_EQ_EQ] = ACTIONS(4113),
    [anon_sym_BANG_EQ] = ACTIONS(4113),
    [anon_sym_TILDE_EQ] = ACTIONS(4113),
    [anon_sym_AMP_TILDE] = ACTIONS(4117),
    [anon_sym_LT_LT] = ACTIONS(4117),
    [anon_sym_GT_GT] = ACTIONS(4117),
    [anon_sym_STAR] = ACTIONS(4117),
    [anon_sym_SLASH] = ACTIONS(4117),
    [anon_sym_PERCENT] = ACTIONS(4117),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4113),
    [anon_sym_DOT] = ACTIONS(4117),
    [anon_sym_LBRACK] = ACTIONS(4113),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4113),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4113),
    [anon_sym_not_in] = ACTIONS(4113),
    [anon_sym_or_return] = ACTIONS(4113),
    [anon_sym_or_continue] = ACTIONS(4113),
    [anon_sym_or_break] = ACTIONS(4113),
    [anon_sym_CARET] = ACTIONS(4117),
    [sym_uninitialized] = ACTIONS(6311),
    [sym_tag] = ACTIONS(6313),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1670] = {
    [sym_expression] = STATE(3229),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1671] = {
    [sym_expression] = STATE(3284),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1672] = {
    [sym_expression] = STATE(3149),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1673] = {
    [sym_expression] = STATE(6393),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1674] = {
    [sym_expression] = STATE(3150),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1675] = {
    [sym_expression] = STATE(3151),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1676] = {
    [sym_expression] = STATE(4453),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1677] = {
    [sym_expression] = STATE(4454),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1678] = {
    [sym_expression] = STATE(4455),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1679] = {
    [sym_expression] = STATE(4457),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1680] = {
    [sym_expression] = STATE(4459),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1681] = {
    [sym_expression] = STATE(5921),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1682] = {
    [sym_expression] = STATE(4461),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1683] = {
    [sym_expression] = STATE(4462),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1684] = {
    [sym_expression] = STATE(4463),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1685] = {
    [sym_expression] = STATE(4466),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1686] = {
    [sym_expression] = STATE(4468),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1687] = {
    [sym_expression] = STATE(4471),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1688] = {
    [sym_expression] = STATE(4480),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1689] = {
    [sym_expression] = STATE(4484),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1690] = {
    [sym_expression] = STATE(4492),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1691] = {
    [sym_expression] = STATE(3152),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1692] = {
    [sym_expression] = STATE(3153),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1693] = {
    [sym_expression] = STATE(3154),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1694] = {
    [sym_expression] = STATE(5953),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1695] = {
    [sym_expression] = STATE(3155),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1696] = {
    [sym_expression] = STATE(3156),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1697] = {
    [sym_expression] = STATE(5923),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1698] = {
    [aux_sym_field_type_repeat1] = STATE(1698),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_COLON_COLON] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_where] = ACTIONS(4453),
    [anon_sym_EQ] = ACTIONS(4455),
    [anon_sym_COLON] = ACTIONS(4455),
    [anon_sym_PIPE] = ACTIONS(4455),
    [anon_sym_COLON_EQ] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_PLUS_EQ] = ACTIONS(4453),
    [anon_sym_DASH_EQ] = ACTIONS(4453),
    [anon_sym_STAR_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_PERCENT_EQ] = ACTIONS(4453),
    [anon_sym_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_CARET_EQ] = ACTIONS(4453),
    [anon_sym_LT_LT_EQ] = ACTIONS(4453),
    [anon_sym_GT_GT_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4453),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4453),
    [anon_sym_if] = ACTIONS(4453),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_do] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_in] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4455),
    [anon_sym_DASH] = ACTIONS(4455),
    [anon_sym_TILDE] = ACTIONS(4455),
    [anon_sym_AMP] = ACTIONS(4455),
    [anon_sym_PIPE_PIPE] = ACTIONS(4455),
    [anon_sym_or_else] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4455),
    [anon_sym_GT] = ACTIONS(4455),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4455),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_TILDE_EQ] = ACTIONS(4453),
    [anon_sym_AMP_TILDE] = ACTIONS(4455),
    [anon_sym_LT_LT] = ACTIONS(4455),
    [anon_sym_GT_GT] = ACTIONS(4455),
    [anon_sym_STAR] = ACTIONS(4455),
    [anon_sym_SLASH] = ACTIONS(4455),
    [anon_sym_PERCENT] = ACTIONS(4455),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4455),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4453),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4453),
    [anon_sym_not_in] = ACTIONS(4453),
    [anon_sym_or_return] = ACTIONS(4453),
    [anon_sym_or_continue] = ACTIONS(4453),
    [anon_sym_or_break] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4455),
    [anon_sym_DOT2] = ACTIONS(6315),
    [sym_uninitialized] = ACTIONS(4453),
    [sym_tag] = ACTIONS(4453),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1699] = {
    [sym_expression] = STATE(3157),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1700] = {
    [sym_expression] = STATE(3158),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1701] = {
    [sym_expression] = STATE(6109),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1702] = {
    [sym_expression] = STATE(5954),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1703] = {
    [sym_expression] = STATE(5989),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1704] = {
    [sym_expression] = STATE(6077),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1705] = {
    [sym_expression] = STATE(6058),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1706] = {
    [aux_sym_field_type_repeat1] = STATE(1698),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_COMMA] = ACTIONS(4494),
    [anon_sym_COLON_COLON] = ACTIONS(4494),
    [anon_sym_DASH_GT] = ACTIONS(4494),
    [anon_sym_where] = ACTIONS(4494),
    [anon_sym_EQ] = ACTIONS(4496),
    [anon_sym_COLON] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4496),
    [anon_sym_COLON_EQ] = ACTIONS(4494),
    [anon_sym_LPAREN] = ACTIONS(4494),
    [anon_sym_PLUS_EQ] = ACTIONS(4494),
    [anon_sym_DASH_EQ] = ACTIONS(4494),
    [anon_sym_STAR_EQ] = ACTIONS(4494),
    [anon_sym_SLASH_EQ] = ACTIONS(4494),
    [anon_sym_PERCENT_EQ] = ACTIONS(4494),
    [anon_sym_AMP_EQ] = ACTIONS(4494),
    [anon_sym_PIPE_EQ] = ACTIONS(4494),
    [anon_sym_CARET_EQ] = ACTIONS(4494),
    [anon_sym_LT_LT_EQ] = ACTIONS(4494),
    [anon_sym_GT_GT_EQ] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4494),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4494),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4494),
    [anon_sym_if] = ACTIONS(4494),
    [anon_sym_SEMI] = ACTIONS(4494),
    [anon_sym_do] = ACTIONS(4494),
    [anon_sym_when] = ACTIONS(4494),
    [anon_sym_in] = ACTIONS(4494),
    [anon_sym_QMARK] = ACTIONS(4494),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_DASH] = ACTIONS(4496),
    [anon_sym_TILDE] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(4496),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_or_else] = ACTIONS(4494),
    [anon_sym_AMP_AMP] = ACTIONS(4496),
    [anon_sym_GT] = ACTIONS(4496),
    [anon_sym_GT_EQ] = ACTIONS(4494),
    [anon_sym_LT_EQ] = ACTIONS(4494),
    [anon_sym_LT] = ACTIONS(4496),
    [anon_sym_EQ_EQ] = ACTIONS(4494),
    [anon_sym_BANG_EQ] = ACTIONS(4494),
    [anon_sym_TILDE_EQ] = ACTIONS(4494),
    [anon_sym_AMP_TILDE] = ACTIONS(4496),
    [anon_sym_LT_LT] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4496),
    [anon_sym_STAR] = ACTIONS(4496),
    [anon_sym_SLASH] = ACTIONS(4496),
    [anon_sym_PERCENT] = ACTIONS(4496),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4494),
    [anon_sym_DOT] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4494),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4494),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4494),
    [anon_sym_not_in] = ACTIONS(4494),
    [anon_sym_or_return] = ACTIONS(4494),
    [anon_sym_or_continue] = ACTIONS(4494),
    [anon_sym_or_break] = ACTIONS(4494),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_DOT2] = ACTIONS(6267),
    [sym_uninitialized] = ACTIONS(4494),
    [sym_tag] = ACTIONS(4494),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1707] = {
    [sym_expression] = STATE(3179),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1708] = {
    [sym_expression] = STATE(6070),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1709] = {
    [sym_expression] = STATE(3196),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1710] = {
    [sym_expression] = STATE(3197),
    [sym__expression_no_tag] = STATE(3296),
    [sym_unary_expression] = STATE(3296),
    [sym_binary_expression] = STATE(3296),
    [sym_ternary_expression] = STATE(3296),
    [sym_call_expression] = STATE(3296),
    [sym_selector_call_expression] = STATE(3296),
    [sym_member_expression] = STATE(3296),
    [sym_index_expression] = STATE(3296),
    [sym_slice_expression] = STATE(3296),
    [sym_range_expression] = STATE(3296),
    [sym_cast_expression] = STATE(3296),
    [sym_in_expression] = STATE(3296),
    [sym_variadic_expression] = STATE(3296),
    [sym_parenthesized_expression] = STATE(3296),
    [sym_or_return_expression] = STATE(3296),
    [sym_or_continue_expression] = STATE(3296),
    [sym_or_break_expression] = STATE(3296),
    [sym_address] = STATE(3296),
    [sym_map_type] = STATE(3296),
    [sym_matrix_type] = STATE(3296),
    [sym_distinct_type] = STATE(3296),
    [sym_literal] = STATE(3296),
    [sym_struct] = STATE(3358),
    [sym_map] = STATE(3352),
    [sym_bit_set] = STATE(3352),
    [sym_matrix] = STATE(3352),
    [sym_string] = STATE(3352),
    [sym__string_literal] = STATE(3359),
    [sym__raw_string_literal] = STATE(3359),
    [sym_character] = STATE(3352),
    [sym_boolean] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_field_identifier] = STATE(8600),
    [sym_identifier] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_LPAREN] = ACTIONS(555),
    [anon_sym_QMARK] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_cast] = ACTIONS(567),
    [anon_sym_transmute] = ACTIONS(567),
    [anon_sym_auto_cast] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(6243),
    [anon_sym_map] = ACTIONS(573),
    [anon_sym_bit_set] = ACTIONS(575),
    [anon_sym_matrix] = ACTIONS(577),
    [anon_sym_distinct] = ACTIONS(579),
    [sym_number] = ACTIONS(581),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_SQUOTE] = ACTIONS(587),
    [anon_sym_true] = ACTIONS(589),
    [anon_sym_false] = ACTIONS(589),
    [anon_sym_nil] = ACTIONS(591),
    [sym_uninitialized] = ACTIONS(581),
    [sym_tag] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(581),
    [sym_block_comment] = ACTIONS(3),
  },
  [1711] = {
    [aux_sym_field_type_repeat1] = STATE(1706),
    [anon_sym_LBRACE] = ACTIONS(4185),
    [anon_sym_COMMA] = ACTIONS(4185),
    [anon_sym_COLON_COLON] = ACTIONS(4185),
    [anon_sym_DASH_GT] = ACTIONS(4185),
    [anon_sym_where] = ACTIONS(4185),
    [anon_sym_EQ] = ACTIONS(4187),
    [anon_sym_COLON] = ACTIONS(4187),
    [anon_sym_PIPE] = ACTIONS(4187),
    [anon_sym_COLON_EQ] = ACTIONS(4185),
    [anon_sym_LPAREN] = ACTIONS(4185),
    [anon_sym_PLUS_EQ] = ACTIONS(4185),
    [anon_sym_DASH_EQ] = ACTIONS(4185),
    [anon_sym_STAR_EQ] = ACTIONS(4185),
    [anon_sym_SLASH_EQ] = ACTIONS(4185),
    [anon_sym_PERCENT_EQ] = ACTIONS(4185),
    [anon_sym_AMP_EQ] = ACTIONS(4185),
    [anon_sym_PIPE_EQ] = ACTIONS(4185),
    [anon_sym_CARET_EQ] = ACTIONS(4185),
    [anon_sym_LT_LT_EQ] = ACTIONS(4185),
    [anon_sym_GT_GT_EQ] = ACTIONS(4185),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4185),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4185),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4185),
    [anon_sym_if] = ACTIONS(4185),
    [anon_sym_SEMI] = ACTIONS(4185),
    [anon_sym_do] = ACTIONS(4185),
    [anon_sym_when] = ACTIONS(4185),
    [anon_sym_in] = ACTIONS(4185),
    [anon_sym_QMARK] = ACTIONS(4185),
    [anon_sym_PLUS] = ACTIONS(4187),
    [anon_sym_DASH] = ACTIONS(4187),
    [anon_sym_TILDE] = ACTIONS(4187),
    [anon_sym_AMP] = ACTIONS(4187),
    [anon_sym_PIPE_PIPE] = ACTIONS(4187),
    [anon_sym_or_else] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4187),
    [anon_sym_GT] = ACTIONS(4187),
    [anon_sym_GT_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4185),
    [anon_sym_LT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4185),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_TILDE_EQ] = ACTIONS(4185),
    [anon_sym_AMP_TILDE] = ACTIONS(4187),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_STAR] = ACTIONS(4187),
    [anon_sym_SLASH] = ACTIONS(4187),
    [anon_sym_PERCENT] = ACTIONS(4187),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4185),
    [anon_sym_DOT] = ACTIONS(4187),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4185),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4185),
    [anon_sym_not_in] = ACTIONS(4185),
    [anon_sym_or_return] = ACTIONS(4185),
    [anon_sym_or_continue] = ACTIONS(4185),
    [anon_sym_or_break] = ACTIONS(4185),
    [anon_sym_CARET] = ACTIONS(4187),
    [anon_sym_DOT2] = ACTIONS(6267),
    [sym_uninitialized] = ACTIONS(4185),
    [sym_tag] = ACTIONS(4185),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1712] = {
    [sym_expression] = STATE(6079),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1713] = {
    [sym_expression] = STATE(6189),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1714] = {
    [sym_expression] = STATE(5980),
    [sym__expression_no_tag] = STATE(5195),
    [sym_unary_expression] = STATE(5195),
    [sym_binary_expression] = STATE(5195),
    [sym_ternary_expression] = STATE(5195),
    [sym_call_expression] = STATE(5195),
    [sym_selector_call_expression] = STATE(5195),
    [sym_member_expression] = STATE(5195),
    [sym_index_expression] = STATE(5195),
    [sym_slice_expression] = STATE(5195),
    [sym_range_expression] = STATE(5195),
    [sym_cast_expression] = STATE(5195),
    [sym_in_expression] = STATE(5195),
    [sym_variadic_expression] = STATE(5195),
    [sym_parenthesized_expression] = STATE(5195),
    [sym_or_return_expression] = STATE(5195),
    [sym_or_continue_expression] = STATE(5195),
    [sym_or_break_expression] = STATE(5195),
    [sym_address] = STATE(5195),
    [sym_map_type] = STATE(5195),
    [sym_matrix_type] = STATE(5195),
    [sym_distinct_type] = STATE(5195),
    [sym_literal] = STATE(5195),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(6318),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1715] = {
    [sym_expression] = STATE(3597),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1716] = {
    [sym_expression] = STATE(4566),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1717] = {
    [sym_expression] = STATE(5966),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1718] = {
    [sym_expression] = STATE(5970),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1719] = {
    [sym_expression] = STATE(4515),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1720] = {
    [sym_expression] = STATE(5981),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1721] = {
    [sym_expression] = STATE(5983),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1722] = {
    [sym_expression] = STATE(4552),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1723] = {
    [sym_expression] = STATE(4848),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1724] = {
    [sym_expression] = STATE(5974),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1725] = {
    [sym_expression] = STATE(4798),
    [sym__expression_no_tag] = STATE(4524),
    [sym_unary_expression] = STATE(4524),
    [sym_binary_expression] = STATE(4524),
    [sym_ternary_expression] = STATE(4524),
    [sym_call_expression] = STATE(4524),
    [sym_selector_call_expression] = STATE(4524),
    [sym_member_expression] = STATE(4524),
    [sym_index_expression] = STATE(4524),
    [sym_slice_expression] = STATE(4524),
    [sym_range_expression] = STATE(4524),
    [sym_cast_expression] = STATE(4524),
    [sym_in_expression] = STATE(4524),
    [sym_variadic_expression] = STATE(4524),
    [sym_parenthesized_expression] = STATE(4524),
    [sym_or_return_expression] = STATE(4524),
    [sym_or_continue_expression] = STATE(4524),
    [sym_or_break_expression] = STATE(4524),
    [sym_address] = STATE(4524),
    [sym_map_type] = STATE(4524),
    [sym_matrix_type] = STATE(4524),
    [sym_distinct_type] = STATE(4524),
    [sym_literal] = STATE(4524),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(6320),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1726] = {
    [sym_expression] = STATE(4551),
    [sym__expression_no_tag] = STATE(4540),
    [sym_unary_expression] = STATE(4540),
    [sym_binary_expression] = STATE(4540),
    [sym_ternary_expression] = STATE(4540),
    [sym_call_expression] = STATE(4540),
    [sym_selector_call_expression] = STATE(4540),
    [sym_member_expression] = STATE(4540),
    [sym_index_expression] = STATE(4540),
    [sym_slice_expression] = STATE(4540),
    [sym_range_expression] = STATE(4540),
    [sym_cast_expression] = STATE(4540),
    [sym_in_expression] = STATE(4540),
    [sym_variadic_expression] = STATE(4540),
    [sym_parenthesized_expression] = STATE(4540),
    [sym_or_return_expression] = STATE(4540),
    [sym_or_continue_expression] = STATE(4540),
    [sym_or_break_expression] = STATE(4540),
    [sym_address] = STATE(4540),
    [sym_map_type] = STATE(4540),
    [sym_matrix_type] = STATE(4540),
    [sym_distinct_type] = STATE(4540),
    [sym_literal] = STATE(4540),
    [sym_struct] = STATE(4545),
    [sym_map] = STATE(4483),
    [sym_bit_set] = STATE(4483),
    [sym_matrix] = STATE(4483),
    [sym_string] = STATE(4483),
    [sym__string_literal] = STATE(4548),
    [sym__raw_string_literal] = STATE(4548),
    [sym_character] = STATE(4483),
    [sym_boolean] = STATE(4483),
    [sym_nil] = STATE(4483),
    [sym_field_identifier] = STATE(8637),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(731),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(737),
    [anon_sym_cast] = ACTIONS(739),
    [anon_sym_transmute] = ACTIONS(739),
    [anon_sym_auto_cast] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(2927),
    [anon_sym_map] = ACTIONS(745),
    [anon_sym_bit_set] = ACTIONS(747),
    [anon_sym_matrix] = ACTIONS(749),
    [anon_sym_distinct] = ACTIONS(751),
    [sym_number] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_BQUOTE] = ACTIONS(757),
    [anon_sym_SQUOTE] = ACTIONS(759),
    [anon_sym_true] = ACTIONS(761),
    [anon_sym_false] = ACTIONS(761),
    [anon_sym_nil] = ACTIONS(763),
    [sym_uninitialized] = ACTIONS(753),
    [sym_tag] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(753),
    [sym_block_comment] = ACTIONS(3),
  },
  [1727] = {
    [sym_expression] = STATE(6458),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(6324),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1728] = {
    [sym_expression] = STATE(3596),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1729] = {
    [sym_expression] = STATE(2683),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1730] = {
    [sym_expression] = STATE(3595),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1731] = {
    [sym_expression] = STATE(3591),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1732] = {
    [sym_expression] = STATE(3485),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1733] = {
    [sym_expression] = STATE(3484),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1734] = {
    [sym_expression] = STATE(3482),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1735] = {
    [sym_expression] = STATE(3481),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1736] = {
    [sym_expression] = STATE(5804),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1737] = {
    [sym_expression] = STATE(3479),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1738] = {
    [sym_expression] = STATE(3478),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1739] = {
    [sym_expression] = STATE(5857),
    [sym__expression_no_tag] = STATE(5195),
    [sym_unary_expression] = STATE(5195),
    [sym_binary_expression] = STATE(5195),
    [sym_ternary_expression] = STATE(5195),
    [sym_call_expression] = STATE(5195),
    [sym_selector_call_expression] = STATE(5195),
    [sym_member_expression] = STATE(5195),
    [sym_index_expression] = STATE(5195),
    [sym_slice_expression] = STATE(5195),
    [sym_range_expression] = STATE(5195),
    [sym_cast_expression] = STATE(5195),
    [sym_in_expression] = STATE(5195),
    [sym_variadic_expression] = STATE(5195),
    [sym_parenthesized_expression] = STATE(5195),
    [sym_or_return_expression] = STATE(5195),
    [sym_or_continue_expression] = STATE(5195),
    [sym_or_break_expression] = STATE(5195),
    [sym_address] = STATE(5195),
    [sym_map_type] = STATE(5195),
    [sym_matrix_type] = STATE(5195),
    [sym_distinct_type] = STATE(5195),
    [sym_literal] = STATE(5195),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(6326),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1740] = {
    [sym_expression] = STATE(3999),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1741] = {
    [sym_expression] = STATE(3477),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1742] = {
    [sym_expression] = STATE(3474),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1743] = {
    [sym_expression] = STATE(3456),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1744] = {
    [sym_expression] = STATE(4700),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1745] = {
    [sym_expression] = STATE(4659),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1746] = {
    [sym_expression] = STATE(4704),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1747] = {
    [sym_expression] = STATE(4706),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1748] = {
    [sym_expression] = STATE(3998),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1749] = {
    [sym_expression] = STATE(6428),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1750] = {
    [sym_expression] = STATE(5737),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1751] = {
    [sym_expression] = STATE(4837),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1752] = {
    [sym_expression] = STATE(2632),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1753] = {
    [sym_expression] = STATE(4150),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1754] = {
    [sym_expression] = STATE(4595),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1755] = {
    [sym_expression] = STATE(4039),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1756] = {
    [sym_expression] = STATE(5185),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1757] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(5800),
    [sym_unary_expression] = STATE(5800),
    [sym_binary_expression] = STATE(5800),
    [sym_ternary_expression] = STATE(5800),
    [sym_call_expression] = STATE(3939),
    [sym_selector_call_expression] = STATE(5800),
    [sym_member_expression] = STATE(5800),
    [sym_index_expression] = STATE(5800),
    [sym_slice_expression] = STATE(5800),
    [sym_range_expression] = STATE(5800),
    [sym_cast_expression] = STATE(5800),
    [sym_in_expression] = STATE(5800),
    [sym_variadic_expression] = STATE(5800),
    [sym_parenthesized_expression] = STATE(5800),
    [sym_or_return_expression] = STATE(5800),
    [sym_or_continue_expression] = STATE(5800),
    [sym_or_break_expression] = STATE(5800),
    [sym_address] = STATE(5800),
    [sym_map_type] = STATE(5800),
    [sym_matrix_type] = STATE(5800),
    [sym_distinct_type] = STATE(5800),
    [sym_literal] = STATE(5800),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(6328),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(6330),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1758] = {
    [sym_expression] = STATE(4622),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1759] = {
    [sym_expression] = STATE(4619),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1760] = {
    [sym_expression] = STATE(4620),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1761] = {
    [sym_expression] = STATE(4578),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1762] = {
    [sym_expression] = STATE(4611),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1763] = {
    [sym_expression] = STATE(4609),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1764] = {
    [sym_expression] = STATE(4606),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1765] = {
    [sym_expression] = STATE(4605),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1766] = {
    [sym_expression] = STATE(4602),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1767] = {
    [sym_expression] = STATE(4601),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1768] = {
    [sym_expression] = STATE(4600),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1769] = {
    [sym_expression] = STATE(4886),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1770] = {
    [sym_expression] = STATE(4676),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1771] = {
    [sym_expression] = STATE(4769),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1772] = {
    [sym_expression] = STATE(4666),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1773] = {
    [sym_expression] = STATE(4663),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1774] = {
    [sym_expression] = STATE(4662),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1775] = {
    [sym_expression] = STATE(4660),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1776] = {
    [sym_expression] = STATE(4658),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1777] = {
    [sym_expression] = STATE(4657),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1778] = {
    [sym_expression] = STATE(4656),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1779] = {
    [sym_expression] = STATE(4646),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1780] = {
    [sym_expression] = STATE(4643),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1781] = {
    [sym_expression] = STATE(4634),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1782] = {
    [sym_expression] = STATE(4632),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1783] = {
    [sym_expression] = STATE(4627),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1784] = {
    [sym_expression] = STATE(4599),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1785] = {
    [sym_expression] = STATE(4073),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1786] = {
    [sym_expression] = STATE(4075),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1787] = {
    [sym_expression] = STATE(3473),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1788] = {
    [sym_expression] = STATE(4710),
    [sym__expression_no_tag] = STATE(4524),
    [sym_unary_expression] = STATE(4524),
    [sym_binary_expression] = STATE(4524),
    [sym_ternary_expression] = STATE(4524),
    [sym_call_expression] = STATE(4524),
    [sym_selector_call_expression] = STATE(4524),
    [sym_member_expression] = STATE(4524),
    [sym_index_expression] = STATE(4524),
    [sym_slice_expression] = STATE(4524),
    [sym_range_expression] = STATE(4524),
    [sym_cast_expression] = STATE(4524),
    [sym_in_expression] = STATE(4524),
    [sym_variadic_expression] = STATE(4524),
    [sym_parenthesized_expression] = STATE(4524),
    [sym_or_return_expression] = STATE(4524),
    [sym_or_continue_expression] = STATE(4524),
    [sym_or_break_expression] = STATE(4524),
    [sym_address] = STATE(4524),
    [sym_map_type] = STATE(4524),
    [sym_matrix_type] = STATE(4524),
    [sym_distinct_type] = STATE(4524),
    [sym_literal] = STATE(4524),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(6320),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1789] = {
    [sym_expression] = STATE(4591),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1790] = {
    [sym_expression] = STATE(4590),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1791] = {
    [sym_expression] = STATE(4589),
    [sym__expression_no_tag] = STATE(4583),
    [sym_unary_expression] = STATE(4583),
    [sym_binary_expression] = STATE(4583),
    [sym_ternary_expression] = STATE(4583),
    [sym_call_expression] = STATE(4583),
    [sym_selector_call_expression] = STATE(4583),
    [sym_member_expression] = STATE(4583),
    [sym_index_expression] = STATE(4583),
    [sym_slice_expression] = STATE(4583),
    [sym_range_expression] = STATE(4583),
    [sym_cast_expression] = STATE(4583),
    [sym_in_expression] = STATE(4583),
    [sym_variadic_expression] = STATE(4583),
    [sym_parenthesized_expression] = STATE(4583),
    [sym_or_return_expression] = STATE(4583),
    [sym_or_continue_expression] = STATE(4583),
    [sym_or_break_expression] = STATE(4583),
    [sym_address] = STATE(4583),
    [sym_map_type] = STATE(4583),
    [sym_matrix_type] = STATE(4583),
    [sym_distinct_type] = STATE(4583),
    [sym_literal] = STATE(4583),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(937),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1792] = {
    [sym_expression] = STATE(5924),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1793] = {
    [sym_expression] = STATE(5209),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1794] = {
    [sym_expression] = STATE(6249),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1795] = {
    [sym_expression] = STATE(6004),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1796] = {
    [sym_expression] = STATE(4633),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1797] = {
    [sym_expression] = STATE(3472),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1798] = {
    [sym_expression] = STATE(4033),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1799] = {
    [sym_expression] = STATE(4717),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1800] = {
    [sym_expression] = STATE(4036),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1801] = {
    [sym_expression] = STATE(4727),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1802] = {
    [sym_expression] = STATE(4728),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1803] = {
    [sym_expression] = STATE(3471),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1804] = {
    [sym_expression] = STATE(4729),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1805] = {
    [sym_expression] = STATE(4730),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1806] = {
    [sym_expression] = STATE(4731),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1807] = {
    [sym_expression] = STATE(4732),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1808] = {
    [sym_expression] = STATE(4733),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1809] = {
    [sym_expression] = STATE(4738),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1810] = {
    [sym_expression] = STATE(4740),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1811] = {
    [sym_expression] = STATE(3470),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1812] = {
    [sym_expression] = STATE(3469),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1813] = {
    [sym_expression] = STATE(4741),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1814] = {
    [sym_expression] = STATE(6250),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1815] = {
    [sym_expression] = STATE(4742),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1816] = {
    [sym_expression] = STATE(6251),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1817] = {
    [sym_expression] = STATE(4745),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1818] = {
    [sym_expression] = STATE(6306),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1819] = {
    [sym_expression] = STATE(6310),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1820] = {
    [sym_expression] = STATE(4146),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1821] = {
    [sym_expression] = STATE(3538),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1822] = {
    [sym_expression] = STATE(6316),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1823] = {
    [sym_expression] = STATE(6321),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1824] = {
    [sym_expression] = STATE(6333),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1825] = {
    [sym_expression] = STATE(4137),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1826] = {
    [sym_expression] = STATE(3504),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1827] = {
    [sym_expression] = STATE(3927),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1828] = {
    [sym_expression] = STATE(3525),
    [sym__expression_no_tag] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_selector_call_expression] = STATE(3517),
    [sym_member_expression] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_slice_expression] = STATE(3517),
    [sym_range_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_in_expression] = STATE(3517),
    [sym_variadic_expression] = STATE(3517),
    [sym_parenthesized_expression] = STATE(3517),
    [sym_or_return_expression] = STATE(3517),
    [sym_or_continue_expression] = STATE(3517),
    [sym_or_break_expression] = STATE(3517),
    [sym_address] = STATE(3517),
    [sym_map_type] = STATE(3517),
    [sym_matrix_type] = STATE(3517),
    [sym_distinct_type] = STATE(3517),
    [sym_literal] = STATE(3517),
    [sym_struct] = STATE(3603),
    [sym_map] = STATE(3626),
    [sym_bit_set] = STATE(3626),
    [sym_matrix] = STATE(3626),
    [sym_string] = STATE(3626),
    [sym__string_literal] = STATE(3602),
    [sym__raw_string_literal] = STATE(3602),
    [sym_character] = STATE(3626),
    [sym_boolean] = STATE(3626),
    [sym_nil] = STATE(3626),
    [sym_field_identifier] = STATE(8588),
    [sym_identifier] = ACTIONS(665),
    [anon_sym_LBRACE] = ACTIONS(701),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(705),
    [anon_sym_PLUS] = ACTIONS(707),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_AMP] = ACTIONS(707),
    [anon_sym_DOT] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [anon_sym_cast] = ACTIONS(669),
    [anon_sym_transmute] = ACTIONS(669),
    [anon_sym_auto_cast] = ACTIONS(671),
    [anon_sym_DOT_DOT] = ACTIONS(6251),
    [anon_sym_map] = ACTIONS(675),
    [anon_sym_bit_set] = ACTIONS(677),
    [anon_sym_matrix] = ACTIONS(679),
    [anon_sym_distinct] = ACTIONS(681),
    [sym_number] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(685),
    [anon_sym_BQUOTE] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [anon_sym_true] = ACTIONS(691),
    [anon_sym_false] = ACTIONS(691),
    [anon_sym_nil] = ACTIONS(693),
    [sym_uninitialized] = ACTIONS(683),
    [sym_tag] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(683),
    [sym_block_comment] = ACTIONS(3),
  },
  [1829] = {
    [sym_expression] = STATE(6336),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1830] = {
    [sym_expression] = STATE(5791),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1831] = {
    [sym_expression] = STATE(6344),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1832] = {
    [sym_expression] = STATE(6346),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1833] = {
    [sym_expression] = STATE(4750),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1834] = {
    [sym_expression] = STATE(4752),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1835] = {
    [sym_expression] = STATE(6358),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1836] = {
    [sym_expression] = STATE(4753),
    [sym__expression_no_tag] = STATE(4765),
    [sym_unary_expression] = STATE(4765),
    [sym_binary_expression] = STATE(4765),
    [sym_ternary_expression] = STATE(4765),
    [sym_call_expression] = STATE(4765),
    [sym_selector_call_expression] = STATE(4765),
    [sym_member_expression] = STATE(4765),
    [sym_index_expression] = STATE(4765),
    [sym_slice_expression] = STATE(4765),
    [sym_range_expression] = STATE(4765),
    [sym_cast_expression] = STATE(4765),
    [sym_in_expression] = STATE(4765),
    [sym_variadic_expression] = STATE(4765),
    [sym_parenthesized_expression] = STATE(4765),
    [sym_or_return_expression] = STATE(4765),
    [sym_or_continue_expression] = STATE(4765),
    [sym_or_break_expression] = STATE(4765),
    [sym_address] = STATE(4765),
    [sym_map_type] = STATE(4765),
    [sym_matrix_type] = STATE(4765),
    [sym_distinct_type] = STATE(4765),
    [sym_literal] = STATE(4765),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1837] = {
    [sym_expression] = STATE(6364),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1838] = {
    [sym_expression] = STATE(5103),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1839] = {
    [sym_expression] = STATE(6375),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1840] = {
    [sym_expression] = STATE(4650),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1841] = {
    [sym_expression] = STATE(6384),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1842] = {
    [sym_expression] = STATE(826),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1843] = {
    [aux_sym_struct_type_repeat2] = STATE(1843),
    [ts_builtin_sym_end] = ACTIONS(4618),
    [anon_sym_LBRACE] = ACTIONS(6332),
    [anon_sym_RBRACE] = ACTIONS(4618),
    [anon_sym_COMMA] = ACTIONS(4618),
    [anon_sym_COLON_COLON] = ACTIONS(4618),
    [anon_sym_DASH_GT] = ACTIONS(4618),
    [anon_sym_EQ] = ACTIONS(4623),
    [anon_sym_COLON] = ACTIONS(4623),
    [anon_sym_PIPE] = ACTIONS(4623),
    [anon_sym_COLON_EQ] = ACTIONS(4618),
    [anon_sym_LPAREN] = ACTIONS(4618),
    [anon_sym_PLUS_EQ] = ACTIONS(4618),
    [anon_sym_DASH_EQ] = ACTIONS(4618),
    [anon_sym_STAR_EQ] = ACTIONS(4618),
    [anon_sym_SLASH_EQ] = ACTIONS(4618),
    [anon_sym_PERCENT_EQ] = ACTIONS(4618),
    [anon_sym_AMP_EQ] = ACTIONS(4618),
    [anon_sym_PIPE_EQ] = ACTIONS(4618),
    [anon_sym_CARET_EQ] = ACTIONS(4618),
    [anon_sym_LT_LT_EQ] = ACTIONS(4618),
    [anon_sym_GT_GT_EQ] = ACTIONS(4618),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4618),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4618),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4618),
    [anon_sym_if] = ACTIONS(4618),
    [anon_sym_SEMI] = ACTIONS(4618),
    [anon_sym_else] = ACTIONS(4618),
    [anon_sym_when] = ACTIONS(4618),
    [anon_sym_in] = ACTIONS(4618),
    [anon_sym_case] = ACTIONS(4618),
    [anon_sym_QMARK] = ACTIONS(4618),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_DASH] = ACTIONS(4623),
    [anon_sym_TILDE] = ACTIONS(4623),
    [anon_sym_AMP] = ACTIONS(4623),
    [anon_sym_PIPE_PIPE] = ACTIONS(4623),
    [anon_sym_or_else] = ACTIONS(4618),
    [anon_sym_AMP_AMP] = ACTIONS(4623),
    [anon_sym_GT] = ACTIONS(4623),
    [anon_sym_GT_EQ] = ACTIONS(4618),
    [anon_sym_LT_EQ] = ACTIONS(4618),
    [anon_sym_LT] = ACTIONS(4623),
    [anon_sym_EQ_EQ] = ACTIONS(4618),
    [anon_sym_BANG_EQ] = ACTIONS(4618),
    [anon_sym_TILDE_EQ] = ACTIONS(4618),
    [anon_sym_AMP_TILDE] = ACTIONS(4623),
    [anon_sym_LT_LT] = ACTIONS(4623),
    [anon_sym_GT_GT] = ACTIONS(4623),
    [anon_sym_STAR] = ACTIONS(4623),
    [anon_sym_SLASH] = ACTIONS(4623),
    [anon_sym_PERCENT] = ACTIONS(4623),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4618),
    [anon_sym_DOT] = ACTIONS(4623),
    [anon_sym_LBRACK] = ACTIONS(4618),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4618),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4618),
    [anon_sym_not_in] = ACTIONS(4618),
    [anon_sym_or_return] = ACTIONS(4618),
    [anon_sym_or_continue] = ACTIONS(4618),
    [anon_sym_or_break] = ACTIONS(4618),
    [anon_sym_CARET] = ACTIONS(4623),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4618),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1844] = {
    [sym_expression] = STATE(875),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1845] = {
    [aux_sym_struct_type_repeat2] = STATE(1843),
    [ts_builtin_sym_end] = ACTIONS(4566),
    [anon_sym_LBRACE] = ACTIONS(4566),
    [anon_sym_RBRACE] = ACTIONS(4566),
    [anon_sym_COMMA] = ACTIONS(4566),
    [anon_sym_COLON_COLON] = ACTIONS(4566),
    [anon_sym_DASH_GT] = ACTIONS(4566),
    [anon_sym_EQ] = ACTIONS(4568),
    [anon_sym_COLON] = ACTIONS(4568),
    [anon_sym_PIPE] = ACTIONS(4568),
    [anon_sym_COLON_EQ] = ACTIONS(4566),
    [anon_sym_LPAREN] = ACTIONS(4566),
    [anon_sym_PLUS_EQ] = ACTIONS(4566),
    [anon_sym_DASH_EQ] = ACTIONS(4566),
    [anon_sym_STAR_EQ] = ACTIONS(4566),
    [anon_sym_SLASH_EQ] = ACTIONS(4566),
    [anon_sym_PERCENT_EQ] = ACTIONS(4566),
    [anon_sym_AMP_EQ] = ACTIONS(4566),
    [anon_sym_PIPE_EQ] = ACTIONS(4566),
    [anon_sym_CARET_EQ] = ACTIONS(4566),
    [anon_sym_LT_LT_EQ] = ACTIONS(4566),
    [anon_sym_GT_GT_EQ] = ACTIONS(4566),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4566),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4566),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4566),
    [anon_sym_if] = ACTIONS(4566),
    [anon_sym_SEMI] = ACTIONS(4566),
    [anon_sym_else] = ACTIONS(4566),
    [anon_sym_when] = ACTIONS(4566),
    [anon_sym_in] = ACTIONS(4566),
    [anon_sym_case] = ACTIONS(4566),
    [anon_sym_QMARK] = ACTIONS(4566),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_DASH] = ACTIONS(4568),
    [anon_sym_TILDE] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [anon_sym_or_else] = ACTIONS(4566),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_GT] = ACTIONS(4568),
    [anon_sym_GT_EQ] = ACTIONS(4566),
    [anon_sym_LT_EQ] = ACTIONS(4566),
    [anon_sym_LT] = ACTIONS(4568),
    [anon_sym_EQ_EQ] = ACTIONS(4566),
    [anon_sym_BANG_EQ] = ACTIONS(4566),
    [anon_sym_TILDE_EQ] = ACTIONS(4566),
    [anon_sym_AMP_TILDE] = ACTIONS(4568),
    [anon_sym_LT_LT] = ACTIONS(4568),
    [anon_sym_GT_GT] = ACTIONS(4568),
    [anon_sym_STAR] = ACTIONS(4568),
    [anon_sym_SLASH] = ACTIONS(4568),
    [anon_sym_PERCENT] = ACTIONS(4568),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4566),
    [anon_sym_DOT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4566),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4566),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4566),
    [anon_sym_not_in] = ACTIONS(4566),
    [anon_sym_or_return] = ACTIONS(4566),
    [anon_sym_or_continue] = ACTIONS(4566),
    [anon_sym_or_break] = ACTIONS(4566),
    [anon_sym_CARET] = ACTIONS(4568),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4566),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1846] = {
    [sym_expression] = STATE(4659),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1847] = {
    [sym_expression] = STATE(5100),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1848] = {
    [sym_expression] = STATE(4706),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1849] = {
    [sym_expression] = STATE(4382),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1850] = {
    [sym_expression] = STATE(4383),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1851] = {
    [sym_expression] = STATE(879),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1852] = {
    [sym_expression] = STATE(2659),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1853] = {
    [ts_builtin_sym_end] = ACTIONS(4453),
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_COLON_COLON] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_EQ] = ACTIONS(4455),
    [anon_sym_COLON] = ACTIONS(4455),
    [anon_sym_PIPE] = ACTIONS(4455),
    [anon_sym_COLON_EQ] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_PLUS_EQ] = ACTIONS(4453),
    [anon_sym_DASH_EQ] = ACTIONS(4453),
    [anon_sym_STAR_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_PERCENT_EQ] = ACTIONS(4453),
    [anon_sym_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_CARET_EQ] = ACTIONS(4453),
    [anon_sym_LT_LT_EQ] = ACTIONS(4453),
    [anon_sym_GT_GT_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4453),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4453),
    [anon_sym_if] = ACTIONS(4453),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_else] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_in] = ACTIONS(4453),
    [anon_sym_case] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4455),
    [anon_sym_DASH] = ACTIONS(4455),
    [anon_sym_TILDE] = ACTIONS(4455),
    [anon_sym_AMP] = ACTIONS(4455),
    [anon_sym_PIPE_PIPE] = ACTIONS(4455),
    [anon_sym_or_else] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4455),
    [anon_sym_GT] = ACTIONS(4455),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4455),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_TILDE_EQ] = ACTIONS(4453),
    [anon_sym_AMP_TILDE] = ACTIONS(4455),
    [anon_sym_LT_LT] = ACTIONS(4455),
    [anon_sym_GT_GT] = ACTIONS(4455),
    [anon_sym_STAR] = ACTIONS(4455),
    [anon_sym_SLASH] = ACTIONS(4455),
    [anon_sym_PERCENT] = ACTIONS(4455),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4455),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4453),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4453),
    [anon_sym_not_in] = ACTIONS(4453),
    [anon_sym_or_return] = ACTIONS(4453),
    [anon_sym_or_continue] = ACTIONS(4453),
    [anon_sym_or_break] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4455),
    [anon_sym_DOT2] = ACTIONS(4455),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4453),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1854] = {
    [sym_expression] = STATE(4648),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1855] = {
    [sym_expression] = STATE(4674),
    [sym__expression_no_tag] = STATE(4744),
    [sym_unary_expression] = STATE(4744),
    [sym_binary_expression] = STATE(4744),
    [sym_ternary_expression] = STATE(4744),
    [sym_call_expression] = STATE(4744),
    [sym_selector_call_expression] = STATE(4744),
    [sym_member_expression] = STATE(4744),
    [sym_index_expression] = STATE(4744),
    [sym_slice_expression] = STATE(4744),
    [sym_range_expression] = STATE(4744),
    [sym_cast_expression] = STATE(4744),
    [sym_in_expression] = STATE(4744),
    [sym_variadic_expression] = STATE(4744),
    [sym_parenthesized_expression] = STATE(4744),
    [sym_or_return_expression] = STATE(4744),
    [sym_or_continue_expression] = STATE(4744),
    [sym_or_break_expression] = STATE(4744),
    [sym_address] = STATE(4744),
    [sym_map_type] = STATE(4744),
    [sym_matrix_type] = STATE(4744),
    [sym_distinct_type] = STATE(4744),
    [sym_literal] = STATE(4744),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1856] = {
    [sym_expression] = STATE(5170),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1857] = {
    [sym_expression] = STATE(882),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1858] = {
    [aux_sym_struct_type_repeat2] = STATE(1843),
    [ts_builtin_sym_end] = ACTIONS(4546),
    [anon_sym_LBRACE] = ACTIONS(4546),
    [anon_sym_RBRACE] = ACTIONS(4546),
    [anon_sym_COMMA] = ACTIONS(4546),
    [anon_sym_COLON_COLON] = ACTIONS(4546),
    [anon_sym_DASH_GT] = ACTIONS(4546),
    [anon_sym_EQ] = ACTIONS(4548),
    [anon_sym_COLON] = ACTIONS(4548),
    [anon_sym_PIPE] = ACTIONS(4548),
    [anon_sym_COLON_EQ] = ACTIONS(4546),
    [anon_sym_LPAREN] = ACTIONS(4546),
    [anon_sym_PLUS_EQ] = ACTIONS(4546),
    [anon_sym_DASH_EQ] = ACTIONS(4546),
    [anon_sym_STAR_EQ] = ACTIONS(4546),
    [anon_sym_SLASH_EQ] = ACTIONS(4546),
    [anon_sym_PERCENT_EQ] = ACTIONS(4546),
    [anon_sym_AMP_EQ] = ACTIONS(4546),
    [anon_sym_PIPE_EQ] = ACTIONS(4546),
    [anon_sym_CARET_EQ] = ACTIONS(4546),
    [anon_sym_LT_LT_EQ] = ACTIONS(4546),
    [anon_sym_GT_GT_EQ] = ACTIONS(4546),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4546),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4546),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4546),
    [anon_sym_if] = ACTIONS(4546),
    [anon_sym_SEMI] = ACTIONS(4546),
    [anon_sym_else] = ACTIONS(4546),
    [anon_sym_when] = ACTIONS(4546),
    [anon_sym_in] = ACTIONS(4546),
    [anon_sym_case] = ACTIONS(4546),
    [anon_sym_QMARK] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(4548),
    [anon_sym_DASH] = ACTIONS(4548),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_AMP] = ACTIONS(4548),
    [anon_sym_PIPE_PIPE] = ACTIONS(4548),
    [anon_sym_or_else] = ACTIONS(4546),
    [anon_sym_AMP_AMP] = ACTIONS(4548),
    [anon_sym_GT] = ACTIONS(4548),
    [anon_sym_GT_EQ] = ACTIONS(4546),
    [anon_sym_LT_EQ] = ACTIONS(4546),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_EQ_EQ] = ACTIONS(4546),
    [anon_sym_BANG_EQ] = ACTIONS(4546),
    [anon_sym_TILDE_EQ] = ACTIONS(4546),
    [anon_sym_AMP_TILDE] = ACTIONS(4548),
    [anon_sym_LT_LT] = ACTIONS(4548),
    [anon_sym_GT_GT] = ACTIONS(4548),
    [anon_sym_STAR] = ACTIONS(4548),
    [anon_sym_SLASH] = ACTIONS(4548),
    [anon_sym_PERCENT] = ACTIONS(4548),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4546),
    [anon_sym_DOT] = ACTIONS(4548),
    [anon_sym_LBRACK] = ACTIONS(4546),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4546),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4546),
    [anon_sym_not_in] = ACTIONS(4546),
    [anon_sym_or_return] = ACTIONS(4546),
    [anon_sym_or_continue] = ACTIONS(4546),
    [anon_sym_or_break] = ACTIONS(4546),
    [anon_sym_CARET] = ACTIONS(4548),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4546),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1859] = {
    [sym_expression] = STATE(5814),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1860] = {
    [sym_expression] = STATE(4392),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1861] = {
    [sym_expression] = STATE(5212),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1862] = {
    [sym_expression] = STATE(5217),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1863] = {
    [sym_expression] = STATE(5220),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1864] = {
    [sym_expression] = STATE(6400),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1865] = {
    [sym_expression] = STATE(4294),
    [sym__expression_no_tag] = STATE(3827),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_ternary_expression] = STATE(3827),
    [sym_call_expression] = STATE(3827),
    [sym_selector_call_expression] = STATE(3827),
    [sym_member_expression] = STATE(3827),
    [sym_index_expression] = STATE(3827),
    [sym_slice_expression] = STATE(3827),
    [sym_range_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_in_expression] = STATE(3827),
    [sym_variadic_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3827),
    [sym_or_return_expression] = STATE(3827),
    [sym_or_continue_expression] = STATE(3827),
    [sym_or_break_expression] = STATE(3827),
    [sym_address] = STATE(3827),
    [sym_map_type] = STATE(3827),
    [sym_matrix_type] = STATE(3827),
    [sym_distinct_type] = STATE(3827),
    [sym_literal] = STATE(3827),
    [sym_struct] = STATE(3357),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_QMARK] = ACTIONS(6297),
    [anon_sym_PLUS] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(523),
    [anon_sym_transmute] = ACTIONS(523),
    [anon_sym_auto_cast] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(6201),
    [anon_sym_map] = ACTIONS(529),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(533),
    [anon_sym_distinct] = ACTIONS(535),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [1866] = {
    [sym_expression] = STATE(6402),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1867] = {
    [sym_expression] = STATE(6408),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1868] = {
    [sym_expression] = STATE(5221),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1869] = {
    [aux_sym_struct_type_repeat2] = STATE(1843),
    [ts_builtin_sym_end] = ACTIONS(4534),
    [anon_sym_LBRACE] = ACTIONS(4534),
    [anon_sym_RBRACE] = ACTIONS(4534),
    [anon_sym_COMMA] = ACTIONS(4534),
    [anon_sym_COLON_COLON] = ACTIONS(4534),
    [anon_sym_DASH_GT] = ACTIONS(4534),
    [anon_sym_EQ] = ACTIONS(4536),
    [anon_sym_COLON] = ACTIONS(4536),
    [anon_sym_PIPE] = ACTIONS(4536),
    [anon_sym_COLON_EQ] = ACTIONS(4534),
    [anon_sym_LPAREN] = ACTIONS(4534),
    [anon_sym_PLUS_EQ] = ACTIONS(4534),
    [anon_sym_DASH_EQ] = ACTIONS(4534),
    [anon_sym_STAR_EQ] = ACTIONS(4534),
    [anon_sym_SLASH_EQ] = ACTIONS(4534),
    [anon_sym_PERCENT_EQ] = ACTIONS(4534),
    [anon_sym_AMP_EQ] = ACTIONS(4534),
    [anon_sym_PIPE_EQ] = ACTIONS(4534),
    [anon_sym_CARET_EQ] = ACTIONS(4534),
    [anon_sym_LT_LT_EQ] = ACTIONS(4534),
    [anon_sym_GT_GT_EQ] = ACTIONS(4534),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4534),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4534),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4534),
    [anon_sym_if] = ACTIONS(4534),
    [anon_sym_SEMI] = ACTIONS(4534),
    [anon_sym_else] = ACTIONS(4534),
    [anon_sym_when] = ACTIONS(4534),
    [anon_sym_in] = ACTIONS(4534),
    [anon_sym_case] = ACTIONS(4534),
    [anon_sym_QMARK] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4536),
    [anon_sym_DASH] = ACTIONS(4536),
    [anon_sym_TILDE] = ACTIONS(4536),
    [anon_sym_AMP] = ACTIONS(4536),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_or_else] = ACTIONS(4534),
    [anon_sym_AMP_AMP] = ACTIONS(4536),
    [anon_sym_GT] = ACTIONS(4536),
    [anon_sym_GT_EQ] = ACTIONS(4534),
    [anon_sym_LT_EQ] = ACTIONS(4534),
    [anon_sym_LT] = ACTIONS(4536),
    [anon_sym_EQ_EQ] = ACTIONS(4534),
    [anon_sym_BANG_EQ] = ACTIONS(4534),
    [anon_sym_TILDE_EQ] = ACTIONS(4534),
    [anon_sym_AMP_TILDE] = ACTIONS(4536),
    [anon_sym_LT_LT] = ACTIONS(4536),
    [anon_sym_GT_GT] = ACTIONS(4536),
    [anon_sym_STAR] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(4536),
    [anon_sym_PERCENT] = ACTIONS(4536),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4534),
    [anon_sym_DOT] = ACTIONS(4536),
    [anon_sym_LBRACK] = ACTIONS(4534),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4534),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4534),
    [anon_sym_not_in] = ACTIONS(4534),
    [anon_sym_or_return] = ACTIONS(4534),
    [anon_sym_or_continue] = ACTIONS(4534),
    [anon_sym_or_break] = ACTIONS(4534),
    [anon_sym_CARET] = ACTIONS(4536),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4534),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1870] = {
    [sym_expression] = STATE(5222),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1871] = {
    [sym_expression] = STATE(5228),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1872] = {
    [sym_expression] = STATE(6411),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1873] = {
    [sym_expression] = STATE(6423),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1874] = {
    [sym_expression] = STATE(4176),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1875] = {
    [sym_expression] = STATE(4184),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1876] = {
    [sym_expression] = STATE(4205),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1877] = {
    [sym_expression] = STATE(4207),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1878] = {
    [sym_expression] = STATE(4217),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1879] = {
    [sym_expression] = STATE(4238),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1880] = {
    [sym_expression] = STATE(4241),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1881] = {
    [sym_expression] = STATE(5238),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1882] = {
    [sym_expression] = STATE(4242),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1883] = {
    [sym_expression] = STATE(4243),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1884] = {
    [sym_expression] = STATE(4244),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1885] = {
    [sym_expression] = STATE(4250),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1886] = {
    [sym_expression] = STATE(4252),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1887] = {
    [sym_expression] = STATE(4257),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1888] = {
    [sym_expression] = STATE(4206),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1889] = {
    [sym_expression] = STATE(6426),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1890] = {
    [sym_expression] = STATE(6194),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1891] = {
    [sym_expression] = STATE(6438),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1892] = {
    [sym_expression] = STATE(5239),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1893] = {
    [sym_expression] = STATE(5240),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1894] = {
    [sym_expression] = STATE(4360),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1895] = {
    [sym_expression] = STATE(4389),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1896] = {
    [sym_expression] = STATE(4287),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1897] = {
    [sym_expression] = STATE(4286),
    [sym__expression_no_tag] = STATE(4328),
    [sym_unary_expression] = STATE(4328),
    [sym_binary_expression] = STATE(4328),
    [sym_ternary_expression] = STATE(4328),
    [sym_call_expression] = STATE(4328),
    [sym_selector_call_expression] = STATE(4328),
    [sym_member_expression] = STATE(4328),
    [sym_index_expression] = STATE(4328),
    [sym_slice_expression] = STATE(4328),
    [sym_range_expression] = STATE(4328),
    [sym_cast_expression] = STATE(4328),
    [sym_in_expression] = STATE(4328),
    [sym_variadic_expression] = STATE(4328),
    [sym_parenthesized_expression] = STATE(4328),
    [sym_or_return_expression] = STATE(4328),
    [sym_or_continue_expression] = STATE(4328),
    [sym_or_break_expression] = STATE(4328),
    [sym_address] = STATE(4328),
    [sym_map_type] = STATE(4328),
    [sym_matrix_type] = STATE(4328),
    [sym_distinct_type] = STATE(4328),
    [sym_literal] = STATE(4328),
    [sym_struct] = STATE(4275),
    [sym_map] = STATE(4227),
    [sym_bit_set] = STATE(4227),
    [sym_matrix] = STATE(4227),
    [sym_string] = STATE(4227),
    [sym__string_literal] = STATE(4279),
    [sym__raw_string_literal] = STATE(4279),
    [sym_character] = STATE(4227),
    [sym_boolean] = STATE(4227),
    [sym_nil] = STATE(4227),
    [sym_field_identifier] = STATE(8552),
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_cast] = ACTIONS(1271),
    [anon_sym_transmute] = ACTIONS(1271),
    [anon_sym_auto_cast] = ACTIONS(1273),
    [anon_sym_DOT_DOT] = ACTIONS(6291),
    [anon_sym_map] = ACTIONS(1277),
    [anon_sym_bit_set] = ACTIONS(1279),
    [anon_sym_matrix] = ACTIONS(1281),
    [anon_sym_distinct] = ACTIONS(1283),
    [sym_number] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1289),
    [anon_sym_false] = ACTIONS(1289),
    [anon_sym_nil] = ACTIONS(1291),
    [sym_uninitialized] = ACTIONS(1285),
    [sym_tag] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [1898] = {
    [sym_expression] = STATE(6446),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1899] = {
    [sym_expression] = STATE(6156),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1900] = {
    [sym_expression] = STATE(6447),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1901] = {
    [sym_expression] = STATE(6459),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1902] = {
    [sym_expression] = STATE(6460),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1903] = {
    [sym_expression] = STATE(974),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1904] = {
    [sym_expression] = STATE(997),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1905] = {
    [sym_expression] = STATE(1023),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1906] = {
    [sym_expression] = STATE(1024),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1907] = {
    [sym_expression] = STATE(1025),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1908] = {
    [sym_expression] = STATE(1026),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1909] = {
    [sym_expression] = STATE(1041),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1910] = {
    [sym_expression] = STATE(6435),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1911] = {
    [sym_expression] = STATE(1046),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1912] = {
    [sym_expression] = STATE(1049),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1913] = {
    [sym_expression] = STATE(1059),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1914] = {
    [sym_expression] = STATE(1061),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1915] = {
    [sym_expression] = STATE(1069),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1916] = {
    [sym_expression] = STATE(5248),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1917] = {
    [sym_expression] = STATE(1070),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1918] = {
    [sym_expression] = STATE(1077),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1919] = {
    [sym_expression] = STATE(6429),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1920] = {
    [sym_expression] = STATE(6102),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1921] = {
    [sym_expression] = STATE(6104),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1922] = {
    [sym_expression] = STATE(5932),
    [sym__expression_no_tag] = STATE(5195),
    [sym_unary_expression] = STATE(5195),
    [sym_binary_expression] = STATE(5195),
    [sym_ternary_expression] = STATE(5195),
    [sym_call_expression] = STATE(5195),
    [sym_selector_call_expression] = STATE(5195),
    [sym_member_expression] = STATE(5195),
    [sym_index_expression] = STATE(5195),
    [sym_slice_expression] = STATE(5195),
    [sym_range_expression] = STATE(5195),
    [sym_cast_expression] = STATE(5195),
    [sym_in_expression] = STATE(5195),
    [sym_variadic_expression] = STATE(5195),
    [sym_parenthesized_expression] = STATE(5195),
    [sym_or_return_expression] = STATE(5195),
    [sym_or_continue_expression] = STATE(5195),
    [sym_or_break_expression] = STATE(5195),
    [sym_address] = STATE(5195),
    [sym_map_type] = STATE(5195),
    [sym_matrix_type] = STATE(5195),
    [sym_distinct_type] = STATE(5195),
    [sym_literal] = STATE(5195),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(6335),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1923] = {
    [sym_expression] = STATE(2366),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1924] = {
    [sym_expression] = STATE(2365),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1925] = {
    [sym_expression] = STATE(6416),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1926] = {
    [sym_expression] = STATE(2322),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1927] = {
    [sym_expression] = STATE(5674),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1928] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(5816),
    [sym_unary_expression] = STATE(5816),
    [sym_binary_expression] = STATE(5816),
    [sym_ternary_expression] = STATE(5816),
    [sym_call_expression] = STATE(3939),
    [sym_selector_call_expression] = STATE(5816),
    [sym_member_expression] = STATE(5816),
    [sym_index_expression] = STATE(5816),
    [sym_slice_expression] = STATE(5816),
    [sym_range_expression] = STATE(5816),
    [sym_cast_expression] = STATE(5816),
    [sym_in_expression] = STATE(5816),
    [sym_variadic_expression] = STATE(5816),
    [sym_parenthesized_expression] = STATE(5816),
    [sym_or_return_expression] = STATE(5816),
    [sym_or_continue_expression] = STATE(5816),
    [sym_or_break_expression] = STATE(5816),
    [sym_address] = STATE(5816),
    [sym_map_type] = STATE(5816),
    [sym_matrix_type] = STATE(5816),
    [sym_distinct_type] = STATE(5816),
    [sym_literal] = STATE(5816),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(6337),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(61),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1929] = {
    [sym_expression] = STATE(3940),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1930] = {
    [sym_expression] = STATE(3941),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1931] = {
    [sym_expression] = STATE(3947),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1932] = {
    [sym_expression] = STATE(3978),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1933] = {
    [sym_expression] = STATE(3980),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1934] = {
    [sym_expression] = STATE(4127),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1935] = {
    [sym_expression] = STATE(3983),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1936] = {
    [sym_expression] = STATE(3986),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1937] = {
    [sym_expression] = STATE(3987),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1938] = {
    [sym_expression] = STATE(4632),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1939] = {
    [sym_expression] = STATE(3988),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1940] = {
    [sym_expression] = STATE(4627),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1941] = {
    [sym_expression] = STATE(3990),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1942] = {
    [sym_expression] = STATE(4064),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1943] = {
    [sym_expression] = STATE(4073),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1944] = {
    [sym_expression] = STATE(4075),
    [sym__expression_no_tag] = STATE(4056),
    [sym_unary_expression] = STATE(4056),
    [sym_binary_expression] = STATE(4056),
    [sym_ternary_expression] = STATE(4056),
    [sym_call_expression] = STATE(4056),
    [sym_selector_call_expression] = STATE(4056),
    [sym_member_expression] = STATE(4056),
    [sym_index_expression] = STATE(4056),
    [sym_slice_expression] = STATE(4056),
    [sym_range_expression] = STATE(4056),
    [sym_cast_expression] = STATE(4056),
    [sym_in_expression] = STATE(4056),
    [sym_variadic_expression] = STATE(4056),
    [sym_parenthesized_expression] = STATE(4056),
    [sym_or_return_expression] = STATE(4056),
    [sym_or_continue_expression] = STATE(4056),
    [sym_or_break_expression] = STATE(4056),
    [sym_address] = STATE(4056),
    [sym_map_type] = STATE(4056),
    [sym_matrix_type] = STATE(4056),
    [sym_distinct_type] = STATE(4056),
    [sym_literal] = STATE(4056),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1945] = {
    [sym_expression] = STATE(2756),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1946] = {
    [sym_expression] = STATE(2745),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1947] = {
    [sym_expression] = STATE(6239),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1948] = {
    [sym_expression] = STATE(2728),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1949] = {
    [sym_expression] = STATE(5254),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1950] = {
    [sym_expression] = STATE(1116),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1951] = {
    [sym_expression] = STATE(4954),
    [sym__expression_no_tag] = STATE(4580),
    [sym_unary_expression] = STATE(4580),
    [sym_binary_expression] = STATE(4580),
    [sym_ternary_expression] = STATE(4580),
    [sym_call_expression] = STATE(4580),
    [sym_selector_call_expression] = STATE(4580),
    [sym_member_expression] = STATE(4580),
    [sym_index_expression] = STATE(4580),
    [sym_slice_expression] = STATE(4580),
    [sym_range_expression] = STATE(4580),
    [sym_cast_expression] = STATE(4580),
    [sym_in_expression] = STATE(4580),
    [sym_variadic_expression] = STATE(4580),
    [sym_parenthesized_expression] = STATE(4580),
    [sym_or_return_expression] = STATE(4580),
    [sym_or_continue_expression] = STATE(4580),
    [sym_or_break_expression] = STATE(4580),
    [sym_address] = STATE(4580),
    [sym_map_type] = STATE(4580),
    [sym_matrix_type] = STATE(4580),
    [sym_distinct_type] = STATE(4580),
    [sym_literal] = STATE(4580),
    [sym_struct] = STATE(4037),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_QMARK] = ACTIONS(6339),
    [anon_sym_PLUS] = ACTIONS(27),
    [anon_sym_DASH] = ACTIONS(29),
    [anon_sym_TILDE] = ACTIONS(27),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_AMP] = ACTIONS(27),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(35),
    [anon_sym_transmute] = ACTIONS(35),
    [anon_sym_auto_cast] = ACTIONS(37),
    [anon_sym_DOT_DOT] = ACTIONS(39),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [1952] = {
    [sym_expression] = STATE(5255),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1953] = {
    [sym_expression] = STATE(1144),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1954] = {
    [sym_expression] = STATE(2339),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [1955] = {
    [sym_expression] = STATE(2338),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [1956] = {
    [sym_expression] = STATE(1170),
    [sym__expression_no_tag] = STATE(834),
    [sym_unary_expression] = STATE(834),
    [sym_binary_expression] = STATE(834),
    [sym_ternary_expression] = STATE(834),
    [sym_call_expression] = STATE(834),
    [sym_selector_call_expression] = STATE(834),
    [sym_member_expression] = STATE(834),
    [sym_index_expression] = STATE(834),
    [sym_slice_expression] = STATE(834),
    [sym_range_expression] = STATE(834),
    [sym_cast_expression] = STATE(834),
    [sym_in_expression] = STATE(834),
    [sym_variadic_expression] = STATE(834),
    [sym_parenthesized_expression] = STATE(834),
    [sym_or_return_expression] = STATE(834),
    [sym_or_continue_expression] = STATE(834),
    [sym_or_break_expression] = STATE(834),
    [sym_address] = STATE(834),
    [sym_map_type] = STATE(834),
    [sym_matrix_type] = STATE(834),
    [sym_distinct_type] = STATE(834),
    [sym_literal] = STATE(834),
    [sym_struct] = STATE(810),
    [sym_map] = STATE(792),
    [sym_bit_set] = STATE(792),
    [sym_matrix] = STATE(792),
    [sym_string] = STATE(792),
    [sym__string_literal] = STATE(816),
    [sym__raw_string_literal] = STATE(816),
    [sym_character] = STATE(792),
    [sym_boolean] = STATE(792),
    [sym_nil] = STATE(792),
    [sym_field_identifier] = STATE(8575),
    [sym_identifier] = ACTIONS(131),
    [anon_sym_LBRACE] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(6257),
    [anon_sym_BANG] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_cast] = ACTIONS(137),
    [anon_sym_transmute] = ACTIONS(137),
    [anon_sym_auto_cast] = ACTIONS(139),
    [anon_sym_DOT_DOT] = ACTIONS(6259),
    [anon_sym_map] = ACTIONS(143),
    [anon_sym_bit_set] = ACTIONS(145),
    [anon_sym_matrix] = ACTIONS(147),
    [anon_sym_distinct] = ACTIONS(149),
    [sym_number] = ACTIONS(151),
    [anon_sym_DQUOTE] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(159),
    [anon_sym_false] = ACTIONS(159),
    [anon_sym_nil] = ACTIONS(161),
    [sym_uninitialized] = ACTIONS(151),
    [sym_tag] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(151),
    [sym_block_comment] = ACTIONS(3),
  },
  [1957] = {
    [sym_expression] = STATE(2400),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1958] = {
    [sym_expression] = STATE(2399),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1959] = {
    [sym_expression] = STATE(2329),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1960] = {
    [sym_expression] = STATE(5211),
    [sym__expression_no_tag] = STATE(5267),
    [sym_unary_expression] = STATE(5267),
    [sym_binary_expression] = STATE(5267),
    [sym_ternary_expression] = STATE(5267),
    [sym_call_expression] = STATE(5267),
    [sym_selector_call_expression] = STATE(5267),
    [sym_member_expression] = STATE(5267),
    [sym_index_expression] = STATE(5267),
    [sym_slice_expression] = STATE(5267),
    [sym_range_expression] = STATE(5267),
    [sym_cast_expression] = STATE(5267),
    [sym_in_expression] = STATE(5267),
    [sym_variadic_expression] = STATE(5267),
    [sym_parenthesized_expression] = STATE(5267),
    [sym_or_return_expression] = STATE(5267),
    [sym_or_continue_expression] = STATE(5267),
    [sym_or_break_expression] = STATE(5267),
    [sym_address] = STATE(5267),
    [sym_map_type] = STATE(5267),
    [sym_matrix_type] = STATE(5267),
    [sym_distinct_type] = STATE(5267),
    [sym_literal] = STATE(5267),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(1477),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [1961] = {
    [sym_expression] = STATE(2316),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [1962] = {
    [sym_expression] = STATE(2328),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1963] = {
    [sym_expression] = STATE(2326),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1964] = {
    [sym_expression] = STATE(2648),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1965] = {
    [sym_expression] = STATE(2319),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1966] = {
    [sym_expression] = STATE(2317),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1967] = {
    [sym_expression] = STATE(2314),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1968] = {
    [sym_expression] = STATE(2313),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1969] = {
    [sym_expression] = STATE(2312),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1970] = {
    [sym_expression] = STATE(2305),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1971] = {
    [sym_expression] = STATE(2304),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1972] = {
    [sym_expression] = STATE(2303),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1973] = {
    [sym_expression] = STATE(2300),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1974] = {
    [sym_expression] = STATE(2243),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1975] = {
    [sym_expression] = STATE(2279),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1976] = {
    [sym_expression] = STATE(2247),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1977] = {
    [sym_expression] = STATE(2275),
    [sym__expression_no_tag] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_selector_call_expression] = STATE(2227),
    [sym_member_expression] = STATE(2227),
    [sym_index_expression] = STATE(2227),
    [sym_slice_expression] = STATE(2227),
    [sym_range_expression] = STATE(2227),
    [sym_cast_expression] = STATE(2227),
    [sym_in_expression] = STATE(2227),
    [sym_variadic_expression] = STATE(2227),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_or_return_expression] = STATE(2227),
    [sym_or_continue_expression] = STATE(2227),
    [sym_or_break_expression] = STATE(2227),
    [sym_address] = STATE(2227),
    [sym_map_type] = STATE(2227),
    [sym_matrix_type] = STATE(2227),
    [sym_distinct_type] = STATE(2227),
    [sym_literal] = STATE(2227),
    [sym_struct] = STATE(2468),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(197),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(185),
    [anon_sym_transmute] = ACTIONS(185),
    [anon_sym_auto_cast] = ACTIONS(187),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1978] = {
    [sym_expression] = STATE(6125),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1979] = {
    [sym_expression] = STATE(6110),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [1980] = {
    [sym_expression] = STATE(2692),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1981] = {
    [sym_expression] = STATE(2691),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1982] = {
    [sym_expression] = STATE(2723),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1983] = {
    [sym_expression] = STATE(2731),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1984] = {
    [sym_expression] = STATE(2732),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1985] = {
    [sym_expression] = STATE(2734),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1986] = {
    [sym_expression] = STATE(2735),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1987] = {
    [sym_expression] = STATE(2691),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1988] = {
    [sym_expression] = STATE(2651),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1989] = {
    [sym_expression] = STATE(2736),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1990] = {
    [sym_expression] = STATE(2737),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1991] = {
    [sym_expression] = STATE(2529),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1992] = {
    [sym_expression] = STATE(2247),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1993] = {
    [sym_expression] = STATE(2521),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1994] = {
    [sym_expression] = STATE(2243),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [1995] = {
    [sym_expression] = STATE(2738),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1996] = {
    [sym_expression] = STATE(2739),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1997] = {
    [sym_expression] = STATE(2740),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [1998] = {
    [aux_sym_field_identifier_repeat1] = STATE(7482),
    [ts_builtin_sym_end] = ACTIONS(4600),
    [anon_sym_LBRACE] = ACTIONS(6341),
    [anon_sym_RBRACE] = ACTIONS(4600),
    [anon_sym_COMMA] = ACTIONS(4600),
    [anon_sym_COLON_COLON] = ACTIONS(4600),
    [anon_sym_DASH_GT] = ACTIONS(4600),
    [anon_sym_EQ] = ACTIONS(4605),
    [anon_sym_COLON] = ACTIONS(4605),
    [anon_sym_PIPE] = ACTIONS(4605),
    [anon_sym_COLON_EQ] = ACTIONS(4600),
    [anon_sym_LPAREN] = ACTIONS(6343),
    [anon_sym_PLUS_EQ] = ACTIONS(4600),
    [anon_sym_DASH_EQ] = ACTIONS(4600),
    [anon_sym_STAR_EQ] = ACTIONS(4600),
    [anon_sym_SLASH_EQ] = ACTIONS(4600),
    [anon_sym_PERCENT_EQ] = ACTIONS(4600),
    [anon_sym_AMP_EQ] = ACTIONS(4600),
    [anon_sym_PIPE_EQ] = ACTIONS(4600),
    [anon_sym_CARET_EQ] = ACTIONS(4600),
    [anon_sym_LT_LT_EQ] = ACTIONS(4600),
    [anon_sym_GT_GT_EQ] = ACTIONS(4600),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4600),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4600),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4600),
    [anon_sym_if] = ACTIONS(4600),
    [anon_sym_SEMI] = ACTIONS(4600),
    [anon_sym_else] = ACTIONS(4600),
    [anon_sym_when] = ACTIONS(4600),
    [anon_sym_in] = ACTIONS(4600),
    [anon_sym_case] = ACTIONS(4600),
    [anon_sym_QMARK] = ACTIONS(4600),
    [anon_sym_PLUS] = ACTIONS(4605),
    [anon_sym_DASH] = ACTIONS(4605),
    [anon_sym_TILDE] = ACTIONS(4605),
    [anon_sym_AMP] = ACTIONS(4605),
    [anon_sym_PIPE_PIPE] = ACTIONS(4605),
    [anon_sym_or_else] = ACTIONS(4600),
    [anon_sym_AMP_AMP] = ACTIONS(4605),
    [anon_sym_GT] = ACTIONS(4605),
    [anon_sym_GT_EQ] = ACTIONS(4600),
    [anon_sym_LT_EQ] = ACTIONS(4600),
    [anon_sym_LT] = ACTIONS(4605),
    [anon_sym_EQ_EQ] = ACTIONS(4600),
    [anon_sym_BANG_EQ] = ACTIONS(4600),
    [anon_sym_TILDE_EQ] = ACTIONS(4600),
    [anon_sym_AMP_TILDE] = ACTIONS(4605),
    [anon_sym_LT_LT] = ACTIONS(4605),
    [anon_sym_GT_GT] = ACTIONS(4605),
    [anon_sym_STAR] = ACTIONS(4605),
    [anon_sym_SLASH] = ACTIONS(4605),
    [anon_sym_PERCENT] = ACTIONS(4605),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4600),
    [anon_sym_DOT] = ACTIONS(4605),
    [anon_sym_LBRACK] = ACTIONS(4600),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4600),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4600),
    [anon_sym_not_in] = ACTIONS(4600),
    [anon_sym_or_return] = ACTIONS(4600),
    [anon_sym_or_continue] = ACTIONS(4600),
    [anon_sym_or_break] = ACTIONS(4600),
    [anon_sym_CARET] = ACTIONS(4605),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4600),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1999] = {
    [sym_expression] = STATE(2743),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2000] = {
    [sym_expression] = STATE(2744),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2001] = {
    [sym_expression] = STATE(2661),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2002] = {
    [sym_expression] = STATE(6325),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [2003] = {
    [sym_expression] = STATE(6324),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [2004] = {
    [sym_expression] = STATE(6300),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [2005] = {
    [sym_expression] = STATE(6298),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [2006] = {
    [sym_expression] = STATE(6278),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [2007] = {
    [sym_expression] = STATE(6276),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [2008] = {
    [sym_expression] = STATE(6264),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [2009] = {
    [sym_expression] = STATE(6262),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [2010] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(5809),
    [sym_unary_expression] = STATE(5809),
    [sym_binary_expression] = STATE(5809),
    [sym_ternary_expression] = STATE(5809),
    [sym_call_expression] = STATE(2675),
    [sym_selector_call_expression] = STATE(5809),
    [sym_member_expression] = STATE(5809),
    [sym_index_expression] = STATE(5809),
    [sym_slice_expression] = STATE(5809),
    [sym_range_expression] = STATE(5809),
    [sym_cast_expression] = STATE(5809),
    [sym_in_expression] = STATE(5809),
    [sym_variadic_expression] = STATE(5809),
    [sym_parenthesized_expression] = STATE(5809),
    [sym_or_return_expression] = STATE(5809),
    [sym_or_continue_expression] = STATE(5809),
    [sym_or_break_expression] = STATE(5809),
    [sym_address] = STATE(5809),
    [sym_map_type] = STATE(5809),
    [sym_matrix_type] = STATE(5809),
    [sym_distinct_type] = STATE(5809),
    [sym_literal] = STATE(5809),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(6346),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(6348),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [2011] = {
    [sym_expression] = STATE(4536),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2012] = {
    [aux_sym_field_type_repeat1] = STATE(2047),
    [ts_builtin_sym_end] = ACTIONS(4185),
    [anon_sym_RBRACE] = ACTIONS(4185),
    [anon_sym_COMMA] = ACTIONS(4185),
    [anon_sym_COLON_COLON] = ACTIONS(4185),
    [anon_sym_DASH_GT] = ACTIONS(4185),
    [anon_sym_EQ] = ACTIONS(4187),
    [anon_sym_COLON] = ACTIONS(4187),
    [anon_sym_PIPE] = ACTIONS(4187),
    [anon_sym_COLON_EQ] = ACTIONS(4185),
    [anon_sym_LPAREN] = ACTIONS(4185),
    [anon_sym_PLUS_EQ] = ACTIONS(4185),
    [anon_sym_DASH_EQ] = ACTIONS(4185),
    [anon_sym_STAR_EQ] = ACTIONS(4185),
    [anon_sym_SLASH_EQ] = ACTIONS(4185),
    [anon_sym_PERCENT_EQ] = ACTIONS(4185),
    [anon_sym_AMP_EQ] = ACTIONS(4185),
    [anon_sym_PIPE_EQ] = ACTIONS(4185),
    [anon_sym_CARET_EQ] = ACTIONS(4185),
    [anon_sym_LT_LT_EQ] = ACTIONS(4185),
    [anon_sym_GT_GT_EQ] = ACTIONS(4185),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4185),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4185),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4185),
    [anon_sym_if] = ACTIONS(4185),
    [anon_sym_SEMI] = ACTIONS(4185),
    [anon_sym_else] = ACTIONS(4185),
    [anon_sym_when] = ACTIONS(4185),
    [anon_sym_in] = ACTIONS(4185),
    [anon_sym_case] = ACTIONS(4185),
    [anon_sym_QMARK] = ACTIONS(4185),
    [anon_sym_PLUS] = ACTIONS(4187),
    [anon_sym_DASH] = ACTIONS(4187),
    [anon_sym_TILDE] = ACTIONS(4187),
    [anon_sym_AMP] = ACTIONS(4187),
    [anon_sym_PIPE_PIPE] = ACTIONS(4187),
    [anon_sym_or_else] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4187),
    [anon_sym_GT] = ACTIONS(4187),
    [anon_sym_GT_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4185),
    [anon_sym_LT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4185),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_TILDE_EQ] = ACTIONS(4185),
    [anon_sym_AMP_TILDE] = ACTIONS(4187),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_STAR] = ACTIONS(4187),
    [anon_sym_SLASH] = ACTIONS(4187),
    [anon_sym_PERCENT] = ACTIONS(4187),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4185),
    [anon_sym_DOT] = ACTIONS(4187),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4185),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4185),
    [anon_sym_not_in] = ACTIONS(4185),
    [anon_sym_or_return] = ACTIONS(4185),
    [anon_sym_or_continue] = ACTIONS(4185),
    [anon_sym_or_break] = ACTIONS(4185),
    [anon_sym_CARET] = ACTIONS(4187),
    [anon_sym_DOT2] = ACTIONS(6350),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4185),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2013] = {
    [sym_expression] = STATE(6240),
    [sym__expression_no_tag] = STATE(4099),
    [sym_unary_expression] = STATE(4099),
    [sym_binary_expression] = STATE(4099),
    [sym_ternary_expression] = STATE(4099),
    [sym_call_expression] = STATE(4099),
    [sym_selector_call_expression] = STATE(4099),
    [sym_member_expression] = STATE(4099),
    [sym_index_expression] = STATE(4099),
    [sym_slice_expression] = STATE(4099),
    [sym_range_expression] = STATE(4099),
    [sym_cast_expression] = STATE(4099),
    [sym_in_expression] = STATE(4099),
    [sym_variadic_expression] = STATE(4099),
    [sym_parenthesized_expression] = STATE(4099),
    [sym_or_return_expression] = STATE(4099),
    [sym_or_continue_expression] = STATE(4099),
    [sym_or_break_expression] = STATE(4099),
    [sym_address] = STATE(4099),
    [sym_map_type] = STATE(4099),
    [sym_matrix_type] = STATE(4099),
    [sym_distinct_type] = STATE(4099),
    [sym_literal] = STATE(4099),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [2014] = {
    [sym_expression] = STATE(4293),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2015] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(5802),
    [sym_unary_expression] = STATE(5802),
    [sym_binary_expression] = STATE(5802),
    [sym_ternary_expression] = STATE(5802),
    [sym_call_expression] = STATE(4707),
    [sym_selector_call_expression] = STATE(5802),
    [sym_member_expression] = STATE(5802),
    [sym_index_expression] = STATE(5802),
    [sym_slice_expression] = STATE(5802),
    [sym_range_expression] = STATE(5802),
    [sym_cast_expression] = STATE(5802),
    [sym_in_expression] = STATE(5802),
    [sym_variadic_expression] = STATE(5802),
    [sym_parenthesized_expression] = STATE(5802),
    [sym_or_return_expression] = STATE(5802),
    [sym_or_continue_expression] = STATE(5802),
    [sym_or_break_expression] = STATE(5802),
    [sym_address] = STATE(5802),
    [sym_map_type] = STATE(5802),
    [sym_matrix_type] = STATE(5802),
    [sym_distinct_type] = STATE(5802),
    [sym_literal] = STATE(5802),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(6352),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(6354),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [2016] = {
    [sym_expression] = STATE(5854),
    [sym__expression_no_tag] = STATE(4748),
    [sym_unary_expression] = STATE(4748),
    [sym_binary_expression] = STATE(4748),
    [sym_ternary_expression] = STATE(4748),
    [sym_call_expression] = STATE(4748),
    [sym_selector_call_expression] = STATE(4748),
    [sym_member_expression] = STATE(4748),
    [sym_index_expression] = STATE(4748),
    [sym_slice_expression] = STATE(4748),
    [sym_range_expression] = STATE(4748),
    [sym_cast_expression] = STATE(4748),
    [sym_in_expression] = STATE(4748),
    [sym_variadic_expression] = STATE(4748),
    [sym_parenthesized_expression] = STATE(4748),
    [sym_or_return_expression] = STATE(4748),
    [sym_or_continue_expression] = STATE(4748),
    [sym_or_break_expression] = STATE(4748),
    [sym_address] = STATE(4748),
    [sym_map_type] = STATE(4748),
    [sym_matrix_type] = STATE(4748),
    [sym_distinct_type] = STATE(4748),
    [sym_literal] = STATE(4748),
    [sym_struct] = STATE(4692),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_QMARK] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1149),
    [anon_sym_TILDE] = ACTIONS(1147),
    [anon_sym_BANG] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(1155),
    [anon_sym_transmute] = ACTIONS(1155),
    [anon_sym_auto_cast] = ACTIONS(1157),
    [anon_sym_DOT_DOT] = ACTIONS(3379),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [2017] = {
    [sym_expression] = STATE(2523),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [2018] = {
    [sym_expression] = STATE(2544),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [2019] = {
    [sym_expression] = STATE(2549),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [2020] = {
    [sym_expression] = STATE(2535),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [2021] = {
    [sym_expression] = STATE(2531),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [2022] = {
    [sym_expression] = STATE(2545),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [2023] = {
    [sym_expression] = STATE(2542),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [2024] = {
    [sym_expression] = STATE(2524),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [2025] = {
    [sym_expression] = STATE(2538),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [2026] = {
    [sym_expression] = STATE(2534),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [2027] = {
    [sym_expression] = STATE(2533),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [2028] = {
    [sym_expression] = STATE(2532),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [2029] = {
    [sym_expression] = STATE(2399),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [2030] = {
    [sym_expression] = STATE(2400),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [2031] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(5838),
    [sym_unary_expression] = STATE(5838),
    [sym_binary_expression] = STATE(5838),
    [sym_ternary_expression] = STATE(5838),
    [sym_call_expression] = STATE(4136),
    [sym_selector_call_expression] = STATE(5838),
    [sym_member_expression] = STATE(5838),
    [sym_index_expression] = STATE(5838),
    [sym_slice_expression] = STATE(5838),
    [sym_range_expression] = STATE(5838),
    [sym_cast_expression] = STATE(5838),
    [sym_in_expression] = STATE(5838),
    [sym_variadic_expression] = STATE(5838),
    [sym_parenthesized_expression] = STATE(5838),
    [sym_or_return_expression] = STATE(5838),
    [sym_or_continue_expression] = STATE(5838),
    [sym_or_break_expression] = STATE(5838),
    [sym_address] = STATE(5838),
    [sym_map_type] = STATE(5838),
    [sym_matrix_type] = STATE(5838),
    [sym_distinct_type] = STATE(5838),
    [sym_literal] = STATE(5838),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(6356),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [2032] = {
    [sym_expression] = STATE(2661),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2033] = {
    [sym_expression] = STATE(2694),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2034] = {
    [sym_expression] = STATE(2746),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2035] = {
    [sym_expression] = STATE(2659),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2036] = {
    [sym_expression] = STATE(2747),
    [sym__expression_no_tag] = STATE(2727),
    [sym_unary_expression] = STATE(2727),
    [sym_binary_expression] = STATE(2727),
    [sym_ternary_expression] = STATE(2727),
    [sym_call_expression] = STATE(2727),
    [sym_selector_call_expression] = STATE(2727),
    [sym_member_expression] = STATE(2727),
    [sym_index_expression] = STATE(2727),
    [sym_slice_expression] = STATE(2727),
    [sym_range_expression] = STATE(2727),
    [sym_cast_expression] = STATE(2727),
    [sym_in_expression] = STATE(2727),
    [sym_variadic_expression] = STATE(2727),
    [sym_parenthesized_expression] = STATE(2727),
    [sym_or_return_expression] = STATE(2727),
    [sym_or_continue_expression] = STATE(2727),
    [sym_or_break_expression] = STATE(2727),
    [sym_address] = STATE(2727),
    [sym_map_type] = STATE(2727),
    [sym_matrix_type] = STATE(2727),
    [sym_distinct_type] = STATE(2727),
    [sym_literal] = STATE(2727),
    [sym_struct] = STATE(2748),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_QMARK] = ACTIONS(305),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(2987),
    [anon_sym_BANG] = ACTIONS(2987),
    [anon_sym_AMP] = ACTIONS(2987),
    [anon_sym_DOT] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(295),
    [anon_sym_transmute] = ACTIONS(295),
    [anon_sym_auto_cast] = ACTIONS(297),
    [anon_sym_DOT_DOT] = ACTIONS(2989),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2037] = {
    [sym_expression] = STATE(2690),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2038] = {
    [sym_expression] = STATE(2289),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2039] = {
    [sym_expression] = STATE(4559),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2040] = {
    [sym_expression] = STATE(2641),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2041] = {
    [aux_sym_struct_type_repeat2] = STATE(1843),
    [ts_builtin_sym_end] = ACTIONS(4534),
    [anon_sym_LBRACE] = ACTIONS(6358),
    [anon_sym_RBRACE] = ACTIONS(4534),
    [anon_sym_COMMA] = ACTIONS(4534),
    [anon_sym_COLON_COLON] = ACTIONS(4534),
    [anon_sym_DASH_GT] = ACTIONS(4534),
    [anon_sym_EQ] = ACTIONS(4536),
    [anon_sym_COLON] = ACTIONS(4536),
    [anon_sym_PIPE] = ACTIONS(4536),
    [anon_sym_COLON_EQ] = ACTIONS(4534),
    [anon_sym_LPAREN] = ACTIONS(4534),
    [anon_sym_PLUS_EQ] = ACTIONS(4534),
    [anon_sym_DASH_EQ] = ACTIONS(4534),
    [anon_sym_STAR_EQ] = ACTIONS(4534),
    [anon_sym_SLASH_EQ] = ACTIONS(4534),
    [anon_sym_PERCENT_EQ] = ACTIONS(4534),
    [anon_sym_AMP_EQ] = ACTIONS(4534),
    [anon_sym_PIPE_EQ] = ACTIONS(4534),
    [anon_sym_CARET_EQ] = ACTIONS(4534),
    [anon_sym_LT_LT_EQ] = ACTIONS(4534),
    [anon_sym_GT_GT_EQ] = ACTIONS(4534),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4534),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4534),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4534),
    [anon_sym_if] = ACTIONS(4534),
    [anon_sym_SEMI] = ACTIONS(4534),
    [anon_sym_else] = ACTIONS(4534),
    [anon_sym_when] = ACTIONS(4534),
    [anon_sym_in] = ACTIONS(4534),
    [anon_sym_case] = ACTIONS(4534),
    [anon_sym_QMARK] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4536),
    [anon_sym_DASH] = ACTIONS(4536),
    [anon_sym_TILDE] = ACTIONS(4536),
    [anon_sym_AMP] = ACTIONS(4536),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_or_else] = ACTIONS(4534),
    [anon_sym_AMP_AMP] = ACTIONS(4536),
    [anon_sym_GT] = ACTIONS(4536),
    [anon_sym_GT_EQ] = ACTIONS(4534),
    [anon_sym_LT_EQ] = ACTIONS(4534),
    [anon_sym_LT] = ACTIONS(4536),
    [anon_sym_EQ_EQ] = ACTIONS(4534),
    [anon_sym_BANG_EQ] = ACTIONS(4534),
    [anon_sym_TILDE_EQ] = ACTIONS(4534),
    [anon_sym_AMP_TILDE] = ACTIONS(4536),
    [anon_sym_LT_LT] = ACTIONS(4536),
    [anon_sym_GT_GT] = ACTIONS(4536),
    [anon_sym_STAR] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(4536),
    [anon_sym_PERCENT] = ACTIONS(4536),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4534),
    [anon_sym_DOT] = ACTIONS(4536),
    [anon_sym_LBRACK] = ACTIONS(4534),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4534),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4534),
    [anon_sym_not_in] = ACTIONS(4534),
    [anon_sym_or_return] = ACTIONS(4534),
    [anon_sym_or_continue] = ACTIONS(4534),
    [anon_sym_or_break] = ACTIONS(4534),
    [anon_sym_CARET] = ACTIONS(4536),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4534),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2042] = {
    [sym_expression] = STATE(4562),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2043] = {
    [sym_expression] = STATE(4563),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2044] = {
    [sym_expression] = STATE(4846),
    [sym__expression_no_tag] = STATE(4596),
    [sym_unary_expression] = STATE(4596),
    [sym_binary_expression] = STATE(4596),
    [sym_ternary_expression] = STATE(4596),
    [sym_call_expression] = STATE(4596),
    [sym_selector_call_expression] = STATE(4596),
    [sym_member_expression] = STATE(4596),
    [sym_index_expression] = STATE(4596),
    [sym_slice_expression] = STATE(4596),
    [sym_range_expression] = STATE(4596),
    [sym_cast_expression] = STATE(4596),
    [sym_in_expression] = STATE(4596),
    [sym_variadic_expression] = STATE(4596),
    [sym_parenthesized_expression] = STATE(4596),
    [sym_or_return_expression] = STATE(4596),
    [sym_or_continue_expression] = STATE(4596),
    [sym_or_break_expression] = STATE(4596),
    [sym_address] = STATE(4596),
    [sym_map_type] = STATE(4596),
    [sym_matrix_type] = STATE(4596),
    [sym_distinct_type] = STATE(4596),
    [sym_literal] = STATE(4596),
    [sym_struct] = STATE(4621),
    [sym_map] = STATE(4062),
    [sym_bit_set] = STATE(4062),
    [sym_matrix] = STATE(4062),
    [sym_string] = STATE(4062),
    [sym__string_literal] = STATE(4038),
    [sym__raw_string_literal] = STATE(4038),
    [sym_character] = STATE(4062),
    [sym_boolean] = STATE(4062),
    [sym_nil] = STATE(4062),
    [sym_field_identifier] = STATE(8540),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_QMARK] = ACTIONS(603),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_cast] = ACTIONS(609),
    [anon_sym_transmute] = ACTIONS(609),
    [anon_sym_auto_cast] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(2903),
    [anon_sym_map] = ACTIONS(41),
    [anon_sym_bit_set] = ACTIONS(43),
    [anon_sym_matrix] = ACTIONS(45),
    [anon_sym_distinct] = ACTIONS(47),
    [sym_number] = ACTIONS(49),
    [anon_sym_DQUOTE] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(55),
    [anon_sym_true] = ACTIONS(57),
    [anon_sym_false] = ACTIONS(57),
    [anon_sym_nil] = ACTIONS(59),
    [sym_uninitialized] = ACTIONS(49),
    [sym_tag] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(49),
    [sym_block_comment] = ACTIONS(3),
  },
  [2045] = {
    [sym_expression] = STATE(2974),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2046] = {
    [sym_expression] = STATE(2973),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2047] = {
    [aux_sym_field_type_repeat1] = STATE(2090),
    [ts_builtin_sym_end] = ACTIONS(4494),
    [anon_sym_RBRACE] = ACTIONS(4494),
    [anon_sym_COMMA] = ACTIONS(4494),
    [anon_sym_COLON_COLON] = ACTIONS(4494),
    [anon_sym_DASH_GT] = ACTIONS(4494),
    [anon_sym_EQ] = ACTIONS(4496),
    [anon_sym_COLON] = ACTIONS(4496),
    [anon_sym_PIPE] = ACTIONS(4496),
    [anon_sym_COLON_EQ] = ACTIONS(4494),
    [anon_sym_LPAREN] = ACTIONS(4494),
    [anon_sym_PLUS_EQ] = ACTIONS(4494),
    [anon_sym_DASH_EQ] = ACTIONS(4494),
    [anon_sym_STAR_EQ] = ACTIONS(4494),
    [anon_sym_SLASH_EQ] = ACTIONS(4494),
    [anon_sym_PERCENT_EQ] = ACTIONS(4494),
    [anon_sym_AMP_EQ] = ACTIONS(4494),
    [anon_sym_PIPE_EQ] = ACTIONS(4494),
    [anon_sym_CARET_EQ] = ACTIONS(4494),
    [anon_sym_LT_LT_EQ] = ACTIONS(4494),
    [anon_sym_GT_GT_EQ] = ACTIONS(4494),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4494),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4494),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4494),
    [anon_sym_if] = ACTIONS(4494),
    [anon_sym_SEMI] = ACTIONS(4494),
    [anon_sym_else] = ACTIONS(4494),
    [anon_sym_when] = ACTIONS(4494),
    [anon_sym_in] = ACTIONS(4494),
    [anon_sym_case] = ACTIONS(4494),
    [anon_sym_QMARK] = ACTIONS(4494),
    [anon_sym_PLUS] = ACTIONS(4496),
    [anon_sym_DASH] = ACTIONS(4496),
    [anon_sym_TILDE] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(4496),
    [anon_sym_PIPE_PIPE] = ACTIONS(4496),
    [anon_sym_or_else] = ACTIONS(4494),
    [anon_sym_AMP_AMP] = ACTIONS(4496),
    [anon_sym_GT] = ACTIONS(4496),
    [anon_sym_GT_EQ] = ACTIONS(4494),
    [anon_sym_LT_EQ] = ACTIONS(4494),
    [anon_sym_LT] = ACTIONS(4496),
    [anon_sym_EQ_EQ] = ACTIONS(4494),
    [anon_sym_BANG_EQ] = ACTIONS(4494),
    [anon_sym_TILDE_EQ] = ACTIONS(4494),
    [anon_sym_AMP_TILDE] = ACTIONS(4496),
    [anon_sym_LT_LT] = ACTIONS(4496),
    [anon_sym_GT_GT] = ACTIONS(4496),
    [anon_sym_STAR] = ACTIONS(4496),
    [anon_sym_SLASH] = ACTIONS(4496),
    [anon_sym_PERCENT] = ACTIONS(4496),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4494),
    [anon_sym_DOT] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4494),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4494),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4494),
    [anon_sym_not_in] = ACTIONS(4494),
    [anon_sym_or_return] = ACTIONS(4494),
    [anon_sym_or_continue] = ACTIONS(4494),
    [anon_sym_or_break] = ACTIONS(4494),
    [anon_sym_CARET] = ACTIONS(4496),
    [anon_sym_DOT2] = ACTIONS(6350),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4494),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2048] = {
    [sym_expression] = STATE(2288),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2049] = {
    [sym_expression] = STATE(4575),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2050] = {
    [sym_expression] = STATE(4576),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2051] = {
    [sym_expression] = STATE(4569),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2052] = {
    [sym_expression] = STATE(4568),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2053] = {
    [sym_expression] = STATE(2286),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2054] = {
    [sym_expression] = STATE(4567),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2055] = {
    [sym_expression] = STATE(4565),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2056] = {
    [sym_expression] = STATE(4564),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2057] = {
    [sym_expression] = STATE(4557),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2058] = {
    [sym_expression] = STATE(4534),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2059] = {
    [sym_expression] = STATE(2441),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2060] = {
    [sym_expression] = STATE(4533),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2061] = {
    [sym_expression] = STATE(2455),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2062] = {
    [sym_expression] = STATE(4526),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2063] = {
    [sym_expression] = STATE(4525),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2064] = {
    [sym_expression] = STATE(2351),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2065] = {
    [sym_expression] = STATE(5866),
    [sym__expression_no_tag] = STATE(5195),
    [sym_unary_expression] = STATE(5195),
    [sym_binary_expression] = STATE(5195),
    [sym_ternary_expression] = STATE(5195),
    [sym_call_expression] = STATE(5195),
    [sym_selector_call_expression] = STATE(5195),
    [sym_member_expression] = STATE(5195),
    [sym_index_expression] = STATE(5195),
    [sym_slice_expression] = STATE(5195),
    [sym_range_expression] = STATE(5195),
    [sym_cast_expression] = STATE(5195),
    [sym_in_expression] = STATE(5195),
    [sym_variadic_expression] = STATE(5195),
    [sym_parenthesized_expression] = STATE(5195),
    [sym_or_return_expression] = STATE(5195),
    [sym_or_continue_expression] = STATE(5195),
    [sym_or_break_expression] = STATE(5195),
    [sym_address] = STATE(5195),
    [sym_map_type] = STATE(5195),
    [sym_matrix_type] = STATE(5195),
    [sym_distinct_type] = STATE(5195),
    [sym_literal] = STATE(5195),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(6360),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [2066] = {
    [sym_expression] = STATE(5729),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(6299),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [2067] = {
    [sym_expression] = STATE(3114),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2068] = {
    [sym_expression] = STATE(2267),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2069] = {
    [sym_expression] = STATE(4491),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2070] = {
    [sym_expression] = STATE(6006),
    [sym__expression_no_tag] = STATE(5195),
    [sym_unary_expression] = STATE(5195),
    [sym_binary_expression] = STATE(5195),
    [sym_ternary_expression] = STATE(5195),
    [sym_call_expression] = STATE(5195),
    [sym_selector_call_expression] = STATE(5195),
    [sym_member_expression] = STATE(5195),
    [sym_index_expression] = STATE(5195),
    [sym_slice_expression] = STATE(5195),
    [sym_range_expression] = STATE(5195),
    [sym_cast_expression] = STATE(5195),
    [sym_in_expression] = STATE(5195),
    [sym_variadic_expression] = STATE(5195),
    [sym_parenthesized_expression] = STATE(5195),
    [sym_or_return_expression] = STATE(5195),
    [sym_or_continue_expression] = STATE(5195),
    [sym_or_break_expression] = STATE(5195),
    [sym_address] = STATE(5195),
    [sym_map_type] = STATE(5195),
    [sym_matrix_type] = STATE(5195),
    [sym_distinct_type] = STATE(5195),
    [sym_literal] = STATE(5195),
    [sym_struct] = STATE(5104),
    [sym_map] = STATE(4685),
    [sym_bit_set] = STATE(4685),
    [sym_matrix] = STATE(4685),
    [sym_string] = STATE(4685),
    [sym__string_literal] = STATE(4694),
    [sym__raw_string_literal] = STATE(4694),
    [sym_character] = STATE(4685),
    [sym_boolean] = STATE(4685),
    [sym_nil] = STATE(4685),
    [sym_field_identifier] = STATE(8599),
    [sym_identifier] = ACTIONS(309),
    [anon_sym_LBRACE] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_QMARK] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1153),
    [anon_sym_cast] = ACTIONS(313),
    [anon_sym_transmute] = ACTIONS(313),
    [anon_sym_auto_cast] = ACTIONS(315),
    [anon_sym_DOT_DOT] = ACTIONS(6239),
    [anon_sym_map] = ACTIONS(319),
    [anon_sym_bit_set] = ACTIONS(321),
    [anon_sym_matrix] = ACTIONS(323),
    [anon_sym_distinct] = ACTIONS(325),
    [sym_number] = ACTIONS(327),
    [anon_sym_DQUOTE] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [anon_sym_SQUOTE] = ACTIONS(333),
    [anon_sym_true] = ACTIONS(335),
    [anon_sym_false] = ACTIONS(335),
    [anon_sym_nil] = ACTIONS(337),
    [sym_uninitialized] = ACTIONS(327),
    [sym_tag] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(327),
    [sym_block_comment] = ACTIONS(3),
  },
  [2071] = {
    [sym_expression] = STATE(2285),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2072] = {
    [sym_expression] = STATE(3111),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2073] = {
    [sym_expression] = STATE(2284),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2074] = {
    [sym_expression] = STATE(2283),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2075] = {
    [sym_expression] = STATE(2662),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2076] = {
    [sym_expression] = STATE(2646),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2077] = {
    [sym_expression] = STATE(2280),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2078] = {
    [sym_expression] = STATE(2640),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2079] = {
    [sym_expression] = STATE(2638),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2080] = {
    [sym_expression] = STATE(2274),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2081] = {
    [sym_expression] = STATE(4490),
    [sym__expression_no_tag] = STATE(2980),
    [sym_unary_expression] = STATE(2980),
    [sym_binary_expression] = STATE(2980),
    [sym_ternary_expression] = STATE(2980),
    [sym_call_expression] = STATE(2980),
    [sym_selector_call_expression] = STATE(2980),
    [sym_member_expression] = STATE(2980),
    [sym_index_expression] = STATE(2980),
    [sym_slice_expression] = STATE(2980),
    [sym_range_expression] = STATE(2980),
    [sym_cast_expression] = STATE(2980),
    [sym_in_expression] = STATE(2980),
    [sym_variadic_expression] = STATE(2980),
    [sym_parenthesized_expression] = STATE(2980),
    [sym_or_return_expression] = STATE(2980),
    [sym_or_continue_expression] = STATE(2980),
    [sym_or_break_expression] = STATE(2980),
    [sym_address] = STATE(2980),
    [sym_map_type] = STATE(2980),
    [sym_matrix_type] = STATE(2980),
    [sym_distinct_type] = STATE(2980),
    [sym_literal] = STATE(2980),
    [sym_struct] = STATE(4488),
    [sym_map] = STATE(3096),
    [sym_bit_set] = STATE(3096),
    [sym_matrix] = STATE(3096),
    [sym_string] = STATE(3096),
    [sym__string_literal] = STATE(3109),
    [sym__raw_string_literal] = STATE(3109),
    [sym_character] = STATE(3096),
    [sym_boolean] = STATE(3096),
    [sym_nil] = STATE(3096),
    [sym_field_identifier] = STATE(8614),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(513),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_TILDE] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(521),
    [anon_sym_cast] = ACTIONS(1237),
    [anon_sym_transmute] = ACTIONS(1237),
    [anon_sym_auto_cast] = ACTIONS(1239),
    [anon_sym_DOT_DOT] = ACTIONS(6322),
    [anon_sym_map] = ACTIONS(1243),
    [anon_sym_bit_set] = ACTIONS(531),
    [anon_sym_matrix] = ACTIONS(1245),
    [anon_sym_distinct] = ACTIONS(1247),
    [sym_number] = ACTIONS(537),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(541),
    [anon_sym_SQUOTE] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(545),
    [anon_sym_false] = ACTIONS(545),
    [anon_sym_nil] = ACTIONS(547),
    [sym_uninitialized] = ACTIONS(537),
    [sym_tag] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(537),
    [sym_block_comment] = ACTIONS(3),
  },
  [2082] = {
    [sym_expression] = STATE(2540),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [2083] = {
    [sym_expression] = STATE(2634),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2084] = {
    [aux_sym_struct_type_repeat2] = STATE(1843),
    [ts_builtin_sym_end] = ACTIONS(4546),
    [anon_sym_LBRACE] = ACTIONS(6358),
    [anon_sym_RBRACE] = ACTIONS(4546),
    [anon_sym_COMMA] = ACTIONS(4546),
    [anon_sym_COLON_COLON] = ACTIONS(4546),
    [anon_sym_DASH_GT] = ACTIONS(4546),
    [anon_sym_EQ] = ACTIONS(4548),
    [anon_sym_COLON] = ACTIONS(4548),
    [anon_sym_PIPE] = ACTIONS(4548),
    [anon_sym_COLON_EQ] = ACTIONS(4546),
    [anon_sym_LPAREN] = ACTIONS(4546),
    [anon_sym_PLUS_EQ] = ACTIONS(4546),
    [anon_sym_DASH_EQ] = ACTIONS(4546),
    [anon_sym_STAR_EQ] = ACTIONS(4546),
    [anon_sym_SLASH_EQ] = ACTIONS(4546),
    [anon_sym_PERCENT_EQ] = ACTIONS(4546),
    [anon_sym_AMP_EQ] = ACTIONS(4546),
    [anon_sym_PIPE_EQ] = ACTIONS(4546),
    [anon_sym_CARET_EQ] = ACTIONS(4546),
    [anon_sym_LT_LT_EQ] = ACTIONS(4546),
    [anon_sym_GT_GT_EQ] = ACTIONS(4546),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4546),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4546),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4546),
    [anon_sym_if] = ACTIONS(4546),
    [anon_sym_SEMI] = ACTIONS(4546),
    [anon_sym_else] = ACTIONS(4546),
    [anon_sym_when] = ACTIONS(4546),
    [anon_sym_in] = ACTIONS(4546),
    [anon_sym_case] = ACTIONS(4546),
    [anon_sym_QMARK] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(4548),
    [anon_sym_DASH] = ACTIONS(4548),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_AMP] = ACTIONS(4548),
    [anon_sym_PIPE_PIPE] = ACTIONS(4548),
    [anon_sym_or_else] = ACTIONS(4546),
    [anon_sym_AMP_AMP] = ACTIONS(4548),
    [anon_sym_GT] = ACTIONS(4548),
    [anon_sym_GT_EQ] = ACTIONS(4546),
    [anon_sym_LT_EQ] = ACTIONS(4546),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_EQ_EQ] = ACTIONS(4546),
    [anon_sym_BANG_EQ] = ACTIONS(4546),
    [anon_sym_TILDE_EQ] = ACTIONS(4546),
    [anon_sym_AMP_TILDE] = ACTIONS(4548),
    [anon_sym_LT_LT] = ACTIONS(4548),
    [anon_sym_GT_GT] = ACTIONS(4548),
    [anon_sym_STAR] = ACTIONS(4548),
    [anon_sym_SLASH] = ACTIONS(4548),
    [anon_sym_PERCENT] = ACTIONS(4548),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4546),
    [anon_sym_DOT] = ACTIONS(4548),
    [anon_sym_LBRACK] = ACTIONS(4546),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4546),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4546),
    [anon_sym_not_in] = ACTIONS(4546),
    [anon_sym_or_return] = ACTIONS(4546),
    [anon_sym_or_continue] = ACTIONS(4546),
    [anon_sym_or_break] = ACTIONS(4546),
    [anon_sym_CARET] = ACTIONS(4548),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4546),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2085] = {
    [sym_expression] = STATE(2628),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2086] = {
    [sym_expression] = STATE(5822),
    [sym__expression_no_tag] = STATE(4664),
    [sym_unary_expression] = STATE(4664),
    [sym_binary_expression] = STATE(4664),
    [sym_ternary_expression] = STATE(4664),
    [sym_call_expression] = STATE(4664),
    [sym_selector_call_expression] = STATE(4664),
    [sym_member_expression] = STATE(4664),
    [sym_index_expression] = STATE(4664),
    [sym_slice_expression] = STATE(4664),
    [sym_range_expression] = STATE(4664),
    [sym_cast_expression] = STATE(4664),
    [sym_in_expression] = STATE(4664),
    [sym_variadic_expression] = STATE(4664),
    [sym_parenthesized_expression] = STATE(4664),
    [sym_or_return_expression] = STATE(4664),
    [sym_or_continue_expression] = STATE(4664),
    [sym_or_break_expression] = STATE(4664),
    [sym_address] = STATE(4664),
    [sym_map_type] = STATE(4664),
    [sym_matrix_type] = STATE(4664),
    [sym_distinct_type] = STATE(4664),
    [sym_literal] = STATE(4664),
    [sym_struct] = STATE(4629),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_QMARK] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1034),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(1034),
    [anon_sym_BANG] = ACTIONS(1034),
    [anon_sym_AMP] = ACTIONS(1034),
    [anon_sym_DOT] = ACTIONS(1036),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(1001),
    [anon_sym_transmute] = ACTIONS(1001),
    [anon_sym_auto_cast] = ACTIONS(1003),
    [anon_sym_DOT_DOT] = ACTIONS(4649),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(4651),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [2087] = {
    [sym_expression] = STATE(2633),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2088] = {
    [sym_expression] = STATE(2273),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2089] = {
    [sym_expression] = STATE(2692),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2090] = {
    [aux_sym_field_type_repeat1] = STATE(2090),
    [ts_builtin_sym_end] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_COLON_COLON] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_EQ] = ACTIONS(4455),
    [anon_sym_COLON] = ACTIONS(4455),
    [anon_sym_PIPE] = ACTIONS(4455),
    [anon_sym_COLON_EQ] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_PLUS_EQ] = ACTIONS(4453),
    [anon_sym_DASH_EQ] = ACTIONS(4453),
    [anon_sym_STAR_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_PERCENT_EQ] = ACTIONS(4453),
    [anon_sym_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_CARET_EQ] = ACTIONS(4453),
    [anon_sym_LT_LT_EQ] = ACTIONS(4453),
    [anon_sym_GT_GT_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4453),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4453),
    [anon_sym_if] = ACTIONS(4453),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_else] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_in] = ACTIONS(4453),
    [anon_sym_case] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4455),
    [anon_sym_DASH] = ACTIONS(4455),
    [anon_sym_TILDE] = ACTIONS(4455),
    [anon_sym_AMP] = ACTIONS(4455),
    [anon_sym_PIPE_PIPE] = ACTIONS(4455),
    [anon_sym_or_else] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4455),
    [anon_sym_GT] = ACTIONS(4455),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4455),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_TILDE_EQ] = ACTIONS(4453),
    [anon_sym_AMP_TILDE] = ACTIONS(4455),
    [anon_sym_LT_LT] = ACTIONS(4455),
    [anon_sym_GT_GT] = ACTIONS(4455),
    [anon_sym_STAR] = ACTIONS(4455),
    [anon_sym_SLASH] = ACTIONS(4455),
    [anon_sym_PERCENT] = ACTIONS(4455),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4455),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4453),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4453),
    [anon_sym_not_in] = ACTIONS(4453),
    [anon_sym_or_return] = ACTIONS(4453),
    [anon_sym_or_continue] = ACTIONS(4453),
    [anon_sym_or_break] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4455),
    [anon_sym_DOT2] = ACTIONS(6362),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4453),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2091] = {
    [sym_expression] = STATE(6467),
    [sym__expression_no_tag] = STATE(5849),
    [sym_unary_expression] = STATE(5849),
    [sym_binary_expression] = STATE(5849),
    [sym_ternary_expression] = STATE(5849),
    [sym_call_expression] = STATE(2197),
    [sym_selector_call_expression] = STATE(5849),
    [sym_member_expression] = STATE(5849),
    [sym_index_expression] = STATE(5849),
    [sym_slice_expression] = STATE(5849),
    [sym_range_expression] = STATE(5849),
    [sym_cast_expression] = STATE(5849),
    [sym_in_expression] = STATE(5849),
    [sym_variadic_expression] = STATE(5849),
    [sym_parenthesized_expression] = STATE(5849),
    [sym_or_return_expression] = STATE(5849),
    [sym_or_continue_expression] = STATE(5849),
    [sym_or_break_expression] = STATE(5849),
    [sym_address] = STATE(5849),
    [sym_map_type] = STATE(5849),
    [sym_matrix_type] = STATE(5849),
    [sym_distinct_type] = STATE(5849),
    [sym_literal] = STATE(5849),
    [sym_struct] = STATE(4021),
    [sym_map] = STATE(4011),
    [sym_bit_set] = STATE(4011),
    [sym_matrix] = STATE(4011),
    [sym_string] = STATE(4011),
    [sym__string_literal] = STATE(4022),
    [sym__raw_string_literal] = STATE(4022),
    [sym_character] = STATE(4011),
    [sym_boolean] = STATE(4011),
    [sym_nil] = STATE(4011),
    [sym_field_identifier] = STATE(8536),
    [sym_identifier] = ACTIONS(621),
    [anon_sym_LBRACE] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_QMARK] = ACTIONS(6365),
    [anon_sym_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_AMP] = ACTIONS(629),
    [anon_sym_DOT] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(635),
    [anon_sym_cast] = ACTIONS(637),
    [anon_sym_transmute] = ACTIONS(637),
    [anon_sym_auto_cast] = ACTIONS(639),
    [anon_sym_DOT_DOT] = ACTIONS(2941),
    [anon_sym_map] = ACTIONS(643),
    [anon_sym_bit_set] = ACTIONS(645),
    [anon_sym_matrix] = ACTIONS(647),
    [anon_sym_distinct] = ACTIONS(649),
    [sym_number] = ACTIONS(651),
    [anon_sym_DQUOTE] = ACTIONS(653),
    [anon_sym_BQUOTE] = ACTIONS(655),
    [anon_sym_SQUOTE] = ACTIONS(657),
    [anon_sym_true] = ACTIONS(659),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_nil] = ACTIONS(661),
    [sym_uninitialized] = ACTIONS(651),
    [sym_tag] = ACTIONS(6367),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(651),
    [sym_block_comment] = ACTIONS(3),
  },
  [2092] = {
    [aux_sym_struct_type_repeat2] = STATE(1843),
    [ts_builtin_sym_end] = ACTIONS(4566),
    [anon_sym_LBRACE] = ACTIONS(6358),
    [anon_sym_RBRACE] = ACTIONS(4566),
    [anon_sym_COMMA] = ACTIONS(4566),
    [anon_sym_COLON_COLON] = ACTIONS(4566),
    [anon_sym_DASH_GT] = ACTIONS(4566),
    [anon_sym_EQ] = ACTIONS(4568),
    [anon_sym_COLON] = ACTIONS(4568),
    [anon_sym_PIPE] = ACTIONS(4568),
    [anon_sym_COLON_EQ] = ACTIONS(4566),
    [anon_sym_LPAREN] = ACTIONS(4566),
    [anon_sym_PLUS_EQ] = ACTIONS(4566),
    [anon_sym_DASH_EQ] = ACTIONS(4566),
    [anon_sym_STAR_EQ] = ACTIONS(4566),
    [anon_sym_SLASH_EQ] = ACTIONS(4566),
    [anon_sym_PERCENT_EQ] = ACTIONS(4566),
    [anon_sym_AMP_EQ] = ACTIONS(4566),
    [anon_sym_PIPE_EQ] = ACTIONS(4566),
    [anon_sym_CARET_EQ] = ACTIONS(4566),
    [anon_sym_LT_LT_EQ] = ACTIONS(4566),
    [anon_sym_GT_GT_EQ] = ACTIONS(4566),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4566),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4566),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4566),
    [anon_sym_if] = ACTIONS(4566),
    [anon_sym_SEMI] = ACTIONS(4566),
    [anon_sym_else] = ACTIONS(4566),
    [anon_sym_when] = ACTIONS(4566),
    [anon_sym_in] = ACTIONS(4566),
    [anon_sym_case] = ACTIONS(4566),
    [anon_sym_QMARK] = ACTIONS(4566),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_DASH] = ACTIONS(4568),
    [anon_sym_TILDE] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [anon_sym_or_else] = ACTIONS(4566),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_GT] = ACTIONS(4568),
    [anon_sym_GT_EQ] = ACTIONS(4566),
    [anon_sym_LT_EQ] = ACTIONS(4566),
    [anon_sym_LT] = ACTIONS(4568),
    [anon_sym_EQ_EQ] = ACTIONS(4566),
    [anon_sym_BANG_EQ] = ACTIONS(4566),
    [anon_sym_TILDE_EQ] = ACTIONS(4566),
    [anon_sym_AMP_TILDE] = ACTIONS(4568),
    [anon_sym_LT_LT] = ACTIONS(4568),
    [anon_sym_GT_GT] = ACTIONS(4568),
    [anon_sym_STAR] = ACTIONS(4568),
    [anon_sym_SLASH] = ACTIONS(4568),
    [anon_sym_PERCENT] = ACTIONS(4568),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4566),
    [anon_sym_DOT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4566),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4566),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4566),
    [anon_sym_not_in] = ACTIONS(4566),
    [anon_sym_or_return] = ACTIONS(4566),
    [anon_sym_or_continue] = ACTIONS(4566),
    [anon_sym_or_break] = ACTIONS(4566),
    [anon_sym_CARET] = ACTIONS(4568),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4566),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2093] = {
    [sym_expression] = STATE(2272),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2094] = {
    [sym_expression] = STATE(2639),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2095] = {
    [sym_expression] = STATE(2636),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2096] = {
    [sym_expression] = STATE(2555),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [2097] = {
    [sym_expression] = STATE(2522),
    [sym__expression_no_tag] = STATE(2559),
    [sym_unary_expression] = STATE(2559),
    [sym_binary_expression] = STATE(2559),
    [sym_ternary_expression] = STATE(2559),
    [sym_call_expression] = STATE(2559),
    [sym_selector_call_expression] = STATE(2559),
    [sym_member_expression] = STATE(2559),
    [sym_index_expression] = STATE(2559),
    [sym_slice_expression] = STATE(2559),
    [sym_range_expression] = STATE(2559),
    [sym_cast_expression] = STATE(2559),
    [sym_in_expression] = STATE(2559),
    [sym_variadic_expression] = STATE(2559),
    [sym_parenthesized_expression] = STATE(2559),
    [sym_or_return_expression] = STATE(2559),
    [sym_or_continue_expression] = STATE(2559),
    [sym_or_break_expression] = STATE(2559),
    [sym_address] = STATE(2559),
    [sym_map_type] = STATE(2559),
    [sym_matrix_type] = STATE(2559),
    [sym_distinct_type] = STATE(2559),
    [sym_literal] = STATE(2559),
    [sym_struct] = STATE(2530),
    [sym_map] = STATE(2258),
    [sym_bit_set] = STATE(2258),
    [sym_matrix] = STATE(2258),
    [sym_string] = STATE(2258),
    [sym__string_literal] = STATE(2253),
    [sym__raw_string_literal] = STATE(2253),
    [sym_character] = STATE(2258),
    [sym_boolean] = STATE(2258),
    [sym_nil] = STATE(2258),
    [sym_field_identifier] = STATE(8623),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACE] = ACTIONS(181),
    [anon_sym_LPAREN] = ACTIONS(205),
    [anon_sym_QMARK] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DOT] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_cast] = ACTIONS(101),
    [anon_sym_transmute] = ACTIONS(101),
    [anon_sym_auto_cast] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(389),
    [anon_sym_map] = ACTIONS(107),
    [anon_sym_bit_set] = ACTIONS(109),
    [anon_sym_matrix] = ACTIONS(111),
    [anon_sym_distinct] = ACTIONS(113),
    [sym_number] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [anon_sym_SQUOTE] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(123),
    [anon_sym_false] = ACTIONS(123),
    [anon_sym_nil] = ACTIONS(125),
    [sym_uninitialized] = ACTIONS(115),
    [sym_tag] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
  },
  [2098] = {
    [sym_expression] = STATE(2268),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2099] = {
    [sym_expression] = STATE(2270),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2100] = {
    [sym_expression] = STATE(2637),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2101] = {
    [sym_expression] = STATE(2269),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2102] = {
    [sym_expression] = STATE(2635),
    [sym__expression_no_tag] = STATE(2664),
    [sym_unary_expression] = STATE(2664),
    [sym_binary_expression] = STATE(2664),
    [sym_ternary_expression] = STATE(2664),
    [sym_call_expression] = STATE(2664),
    [sym_selector_call_expression] = STATE(2664),
    [sym_member_expression] = STATE(2664),
    [sym_index_expression] = STATE(2664),
    [sym_slice_expression] = STATE(2664),
    [sym_range_expression] = STATE(2664),
    [sym_cast_expression] = STATE(2664),
    [sym_in_expression] = STATE(2664),
    [sym_variadic_expression] = STATE(2664),
    [sym_parenthesized_expression] = STATE(2664),
    [sym_or_return_expression] = STATE(2664),
    [sym_or_continue_expression] = STATE(2664),
    [sym_or_break_expression] = STATE(2664),
    [sym_address] = STATE(2664),
    [sym_map_type] = STATE(2664),
    [sym_matrix_type] = STATE(2664),
    [sym_distinct_type] = STATE(2664),
    [sym_literal] = STATE(2664),
    [sym_struct] = STATE(2647),
    [sym_map] = STATE(2652),
    [sym_bit_set] = STATE(2652),
    [sym_matrix] = STATE(2652),
    [sym_string] = STATE(2652),
    [sym__string_literal] = STATE(2656),
    [sym__raw_string_literal] = STATE(2656),
    [sym_character] = STATE(2652),
    [sym_boolean] = STATE(2652),
    [sym_nil] = STATE(2652),
    [sym_field_identifier] = STATE(8647),
    [sym_identifier] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(283),
    [anon_sym_LPAREN] = ACTIONS(285),
    [anon_sym_QMARK] = ACTIONS(287),
    [anon_sym_PLUS] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(2883),
    [anon_sym_BANG] = ACTIONS(2883),
    [anon_sym_AMP] = ACTIONS(2883),
    [anon_sym_DOT] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(291),
    [anon_sym_cast] = ACTIONS(255),
    [anon_sym_transmute] = ACTIONS(255),
    [anon_sym_auto_cast] = ACTIONS(257),
    [anon_sym_DOT_DOT] = ACTIONS(2885),
    [anon_sym_map] = ACTIONS(261),
    [anon_sym_bit_set] = ACTIONS(263),
    [anon_sym_matrix] = ACTIONS(265),
    [anon_sym_distinct] = ACTIONS(267),
    [sym_number] = ACTIONS(269),
    [anon_sym_DQUOTE] = ACTIONS(271),
    [anon_sym_BQUOTE] = ACTIONS(273),
    [anon_sym_SQUOTE] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(277),
    [anon_sym_false] = ACTIONS(277),
    [anon_sym_nil] = ACTIONS(279),
    [sym_uninitialized] = ACTIONS(269),
    [sym_tag] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [2103] = {
    [sym_expression] = STATE(2265),
    [sym__expression_no_tag] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_selector_call_expression] = STATE(2416),
    [sym_member_expression] = STATE(2416),
    [sym_index_expression] = STATE(2416),
    [sym_slice_expression] = STATE(2416),
    [sym_range_expression] = STATE(2416),
    [sym_cast_expression] = STATE(2416),
    [sym_in_expression] = STATE(2416),
    [sym_variadic_expression] = STATE(2416),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_or_return_expression] = STATE(2416),
    [sym_or_continue_expression] = STATE(2416),
    [sym_or_break_expression] = STATE(2416),
    [sym_address] = STATE(2416),
    [sym_map_type] = STATE(2416),
    [sym_matrix_type] = STATE(2416),
    [sym_distinct_type] = STATE(2416),
    [sym_literal] = STATE(2416),
    [sym_struct] = STATE(2428),
    [sym_map] = STATE(2287),
    [sym_bit_set] = STATE(2287),
    [sym_matrix] = STATE(2287),
    [sym_string] = STATE(2287),
    [sym__string_literal] = STATE(2434),
    [sym__raw_string_literal] = STATE(2434),
    [sym_character] = STATE(2287),
    [sym_boolean] = STATE(2287),
    [sym_nil] = STATE(2287),
    [sym_field_identifier] = STATE(8566),
    [sym_identifier] = ACTIONS(209),
    [anon_sym_LBRACE] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_QMARK] = ACTIONS(243),
    [anon_sym_PLUS] = ACTIONS(6273),
    [anon_sym_DASH] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6273),
    [anon_sym_AMP] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_LBRACK] = ACTIONS(247),
    [anon_sym_cast] = ACTIONS(213),
    [anon_sym_transmute] = ACTIONS(213),
    [anon_sym_auto_cast] = ACTIONS(215),
    [anon_sym_DOT_DOT] = ACTIONS(6275),
    [anon_sym_map] = ACTIONS(219),
    [anon_sym_bit_set] = ACTIONS(221),
    [anon_sym_matrix] = ACTIONS(223),
    [anon_sym_distinct] = ACTIONS(225),
    [sym_number] = ACTIONS(227),
    [anon_sym_DQUOTE] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(233),
    [anon_sym_true] = ACTIONS(235),
    [anon_sym_false] = ACTIONS(235),
    [anon_sym_nil] = ACTIONS(237),
    [sym_uninitialized] = ACTIONS(227),
    [sym_tag] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_float] = ACTIONS(227),
    [sym_block_comment] = ACTIONS(3),
  },
  [2104] = {
    [ts_builtin_sym_end] = ACTIONS(5550),
    [anon_sym_LBRACE] = ACTIONS(5550),
    [anon_sym_RBRACE] = ACTIONS(5550),
    [anon_sym_COMMA] = ACTIONS(5550),
    [anon_sym_COLON_COLON] = ACTIONS(5550),
    [anon_sym_DASH_GT] = ACTIONS(5550),
    [anon_sym_EQ] = ACTIONS(5552),
    [anon_sym_COLON] = ACTIONS(5552),
    [anon_sym_PIPE] = ACTIONS(5552),
    [anon_sym_COLON_EQ] = ACTIONS(5550),
    [anon_sym_LPAREN] = ACTIONS(5550),
    [anon_sym_PLUS_EQ] = ACTIONS(5550),
    [anon_sym_DASH_EQ] = ACTIONS(5550),
    [anon_sym_STAR_EQ] = ACTIONS(5550),
    [anon_sym_SLASH_EQ] = ACTIONS(5550),
    [anon_sym_PERCENT_EQ] = ACTIONS(5550),
    [anon_sym_AMP_EQ] = ACTIONS(5550),
    [anon_sym_PIPE_EQ] = ACTIONS(5550),
    [anon_sym_CARET_EQ] = ACTIONS(5550),
    [anon_sym_LT_LT_EQ] = ACTIONS(5550),
    [anon_sym_GT_GT_EQ] = ACTIONS(5550),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5550),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5550),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5550),
    [anon_sym_if] = ACTIONS(5550),
    [anon_sym_SEMI] = ACTIONS(5550),
    [anon_sym_else] = ACTIONS(5550),
    [anon_sym_when] = ACTIONS(5550),
    [anon_sym_in] = ACTIONS(5550),
    [anon_sym_case] = ACTIONS(5550),
    [anon_sym_QMARK] = ACTIONS(5550),
    [anon_sym_PLUS] = ACTIONS(5552),
    [anon_sym_DASH] = ACTIONS(5552),
    [anon_sym_TILDE] = ACTIONS(5552),
    [anon_sym_AMP] = ACTIONS(5552),
    [anon_sym_PIPE_PIPE] = ACTIONS(5552),
    [anon_sym_or_else] = ACTIONS(5550),
    [anon_sym_AMP_AMP] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5550),
    [anon_sym_LT_EQ] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_EQ_EQ] = ACTIONS(5550),
    [anon_sym_BANG_EQ] = ACTIONS(5550),
    [anon_sym_TILDE_EQ] = ACTIONS(5550),
    [anon_sym_AMP_TILDE] = ACTIONS(5552),
    [anon_sym_LT_LT] = ACTIONS(5552),
    [anon_sym_GT_GT] = ACTIONS(5552),
    [anon_sym_STAR] = ACTIONS(5552),
    [anon_sym_SLASH] = ACTIONS(5552),
    [anon_sym_PERCENT] = ACTIONS(5552),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5550),
    [anon_sym_DOT] = ACTIONS(5552),
    [anon_sym_LBRACK] = ACTIONS(5550),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5550),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5550),
    [anon_sym_not_in] = ACTIONS(5550),
    [anon_sym_or_return] = ACTIONS(5550),
    [anon_sym_or_continue] = ACTIONS(5550),
    [anon_sym_or_break] = ACTIONS(5550),
    [anon_sym_CARET] = ACTIONS(5552),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5550),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2105] = {
    [ts_builtin_sym_end] = ACTIONS(4697),
    [sym_identifier] = ACTIONS(6369),
    [anon_sym_RBRACE] = ACTIONS(4697),
    [anon_sym_COMMA] = ACTIONS(4697),
    [anon_sym_COLON_COLON] = ACTIONS(4697),
    [anon_sym_DASH_GT] = ACTIONS(4697),
    [anon_sym_EQ] = ACTIONS(4701),
    [anon_sym_COLON] = ACTIONS(4701),
    [anon_sym_PIPE] = ACTIONS(4701),
    [anon_sym_COLON_EQ] = ACTIONS(4697),
    [anon_sym_LPAREN] = ACTIONS(4697),
    [anon_sym_PLUS_EQ] = ACTIONS(4697),
    [anon_sym_DASH_EQ] = ACTIONS(4697),
    [anon_sym_STAR_EQ] = ACTIONS(4697),
    [anon_sym_SLASH_EQ] = ACTIONS(4697),
    [anon_sym_PERCENT_EQ] = ACTIONS(4697),
    [anon_sym_AMP_EQ] = ACTIONS(4697),
    [anon_sym_PIPE_EQ] = ACTIONS(4697),
    [anon_sym_CARET_EQ] = ACTIONS(4697),
    [anon_sym_LT_LT_EQ] = ACTIONS(4697),
    [anon_sym_GT_GT_EQ] = ACTIONS(4697),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4697),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4697),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4697),
    [anon_sym_if] = ACTIONS(4701),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_else] = ACTIONS(4701),
    [anon_sym_when] = ACTIONS(4701),
    [anon_sym_in] = ACTIONS(4701),
    [anon_sym_case] = ACTIONS(4701),
    [anon_sym_QMARK] = ACTIONS(4697),
    [anon_sym_PLUS] = ACTIONS(4701),
    [anon_sym_DASH] = ACTIONS(4701),
    [anon_sym_TILDE] = ACTIONS(4701),
    [anon_sym_AMP] = ACTIONS(4701),
    [anon_sym_PIPE_PIPE] = ACTIONS(4701),
    [anon_sym_or_else] = ACTIONS(4701),
    [anon_sym_AMP_AMP] = ACTIONS(4701),
    [anon_sym_GT] = ACTIONS(4701),
    [anon_sym_GT_EQ] = ACTIONS(4697),
    [anon_sym_LT_EQ] = ACTIONS(4697),
    [anon_sym_LT] = ACTIONS(4701),
    [anon_sym_EQ_EQ] = ACTIONS(4697),
    [anon_sym_BANG_EQ] = ACTIONS(4697),
    [anon_sym_TILDE_EQ] = ACTIONS(4697),
    [anon_sym_AMP_TILDE] = ACTIONS(4701),
    [anon_sym_LT_LT] = ACTIONS(4701),
    [anon_sym_GT_GT] = ACTIONS(4701),
    [anon_sym_STAR] = ACTIONS(4701),
    [anon_sym_SLASH] = ACTIONS(4701),
    [anon_sym_PERCENT] = ACTIONS(4701),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4697),
    [anon_sym_DOT] = ACTIONS(4701),
    [anon_sym_LBRACK] = ACTIONS(4697),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4697),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4697),
    [anon_sym_not_in] = ACTIONS(4701),
    [anon_sym_or_return] = ACTIONS(4701),
    [anon_sym_or_continue] = ACTIONS(4701),
    [anon_sym_or_break] = ACTIONS(4701),
    [anon_sym_CARET] = ACTIONS(4701),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4697),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2106] = {
    [sym_block] = STATE(2491),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(3415),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(6173),
    [sym_tag] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2107] = {
    [sym_block] = STATE(2483),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [anon_sym_where] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3785),
    [anon_sym_COLON] = ACTIONS(3785),
    [anon_sym_PIPE] = ACTIONS(3785),
    [anon_sym_COLON_EQ] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_when] = ACTIONS(3781),
    [anon_sym_in] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(3785),
    [anon_sym_PIPE_PIPE] = ACTIONS(3785),
    [anon_sym_or_else] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3785),
    [anon_sym_GT] = ACTIONS(3785),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3781),
    [anon_sym_LT] = ACTIONS(3785),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE] = ACTIONS(3785),
    [anon_sym_LT_LT] = ACTIONS(3785),
    [anon_sym_GT_GT] = ACTIONS(3785),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_SLASH] = ACTIONS(3785),
    [anon_sym_PERCENT] = ACTIONS(3785),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3781),
    [anon_sym_not_in] = ACTIONS(3781),
    [anon_sym_or_return] = ACTIONS(3781),
    [anon_sym_or_continue] = ACTIONS(3781),
    [anon_sym_or_break] = ACTIONS(3781),
    [anon_sym_CARET] = ACTIONS(3785),
    [sym_uninitialized] = ACTIONS(6187),
    [sym_tag] = ACTIONS(6189),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2108] = {
    [sym_block] = STATE(2483),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [anon_sym_where] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3785),
    [anon_sym_COLON] = ACTIONS(3785),
    [anon_sym_PIPE] = ACTIONS(3785),
    [anon_sym_COLON_EQ] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_do] = ACTIONS(3781),
    [anon_sym_when] = ACTIONS(3781),
    [anon_sym_in] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(3785),
    [anon_sym_PIPE_PIPE] = ACTIONS(3785),
    [anon_sym_or_else] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3785),
    [anon_sym_GT] = ACTIONS(3785),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3781),
    [anon_sym_LT] = ACTIONS(3785),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE] = ACTIONS(3785),
    [anon_sym_LT_LT] = ACTIONS(3785),
    [anon_sym_GT_GT] = ACTIONS(3785),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_SLASH] = ACTIONS(3785),
    [anon_sym_PERCENT] = ACTIONS(3785),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3781),
    [anon_sym_not_in] = ACTIONS(3781),
    [anon_sym_or_return] = ACTIONS(3781),
    [anon_sym_or_continue] = ACTIONS(3781),
    [anon_sym_or_break] = ACTIONS(3781),
    [anon_sym_CARET] = ACTIONS(3785),
    [sym_uninitialized] = ACTIONS(6187),
    [sym_tag] = ACTIONS(3781),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2109] = {
    [sym_block] = STATE(2460),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(4691),
    [anon_sym_COLON_COLON] = ACTIONS(4691),
    [anon_sym_DASH_GT] = ACTIONS(4691),
    [anon_sym_where] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_COLON] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_COLON_EQ] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_PLUS_EQ] = ACTIONS(4691),
    [anon_sym_DASH_EQ] = ACTIONS(4691),
    [anon_sym_STAR_EQ] = ACTIONS(4691),
    [anon_sym_SLASH_EQ] = ACTIONS(4691),
    [anon_sym_PERCENT_EQ] = ACTIONS(4691),
    [anon_sym_AMP_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_CARET_EQ] = ACTIONS(4691),
    [anon_sym_LT_LT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4691),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4691),
    [anon_sym_if] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_do] = ACTIONS(4691),
    [anon_sym_when] = ACTIONS(4691),
    [anon_sym_in] = ACTIONS(4691),
    [anon_sym_QMARK] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(4693),
    [anon_sym_AMP] = ACTIONS(4693),
    [anon_sym_PIPE_PIPE] = ACTIONS(4693),
    [anon_sym_or_else] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_GT_EQ] = ACTIONS(4691),
    [anon_sym_LT_EQ] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_EQ_EQ] = ACTIONS(4691),
    [anon_sym_BANG_EQ] = ACTIONS(4691),
    [anon_sym_TILDE_EQ] = ACTIONS(4691),
    [anon_sym_AMP_TILDE] = ACTIONS(4693),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(4693),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4693),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4691),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4691),
    [anon_sym_not_in] = ACTIONS(4691),
    [anon_sym_or_return] = ACTIONS(4691),
    [anon_sym_or_continue] = ACTIONS(4691),
    [anon_sym_or_break] = ACTIONS(4691),
    [anon_sym_CARET] = ACTIONS(4693),
    [sym_uninitialized] = ACTIONS(6371),
    [sym_tag] = ACTIONS(4691),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2110] = {
    [aux_sym_where_clause_repeat1] = STATE(2110),
    [anon_sym_LBRACE] = ACTIONS(4717),
    [anon_sym_COMMA] = ACTIONS(6373),
    [anon_sym_COLON_COLON] = ACTIONS(4717),
    [anon_sym_DASH_GT] = ACTIONS(4717),
    [anon_sym_where] = ACTIONS(4717),
    [anon_sym_EQ] = ACTIONS(4722),
    [anon_sym_COLON] = ACTIONS(4722),
    [anon_sym_PIPE] = ACTIONS(4722),
    [anon_sym_COLON_EQ] = ACTIONS(4717),
    [anon_sym_LPAREN] = ACTIONS(4717),
    [anon_sym_PLUS_EQ] = ACTIONS(4717),
    [anon_sym_DASH_EQ] = ACTIONS(4717),
    [anon_sym_STAR_EQ] = ACTIONS(4717),
    [anon_sym_SLASH_EQ] = ACTIONS(4717),
    [anon_sym_PERCENT_EQ] = ACTIONS(4717),
    [anon_sym_AMP_EQ] = ACTIONS(4717),
    [anon_sym_PIPE_EQ] = ACTIONS(4717),
    [anon_sym_CARET_EQ] = ACTIONS(4717),
    [anon_sym_LT_LT_EQ] = ACTIONS(4717),
    [anon_sym_GT_GT_EQ] = ACTIONS(4717),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4717),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4717),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4717),
    [anon_sym_if] = ACTIONS(4717),
    [anon_sym_SEMI] = ACTIONS(4717),
    [anon_sym_do] = ACTIONS(4717),
    [anon_sym_when] = ACTIONS(4717),
    [anon_sym_in] = ACTIONS(4717),
    [anon_sym_QMARK] = ACTIONS(4717),
    [anon_sym_PLUS] = ACTIONS(4722),
    [anon_sym_DASH] = ACTIONS(4722),
    [anon_sym_TILDE] = ACTIONS(4722),
    [anon_sym_AMP] = ACTIONS(4722),
    [anon_sym_PIPE_PIPE] = ACTIONS(4722),
    [anon_sym_or_else] = ACTIONS(4717),
    [anon_sym_AMP_AMP] = ACTIONS(4722),
    [anon_sym_GT] = ACTIONS(4722),
    [anon_sym_GT_EQ] = ACTIONS(4717),
    [anon_sym_LT_EQ] = ACTIONS(4717),
    [anon_sym_LT] = ACTIONS(4722),
    [anon_sym_EQ_EQ] = ACTIONS(4717),
    [anon_sym_BANG_EQ] = ACTIONS(4717),
    [anon_sym_TILDE_EQ] = ACTIONS(4717),
    [anon_sym_AMP_TILDE] = ACTIONS(4722),
    [anon_sym_LT_LT] = ACTIONS(4722),
    [anon_sym_GT_GT] = ACTIONS(4722),
    [anon_sym_STAR] = ACTIONS(4722),
    [anon_sym_SLASH] = ACTIONS(4722),
    [anon_sym_PERCENT] = ACTIONS(4722),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4717),
    [anon_sym_DOT] = ACTIONS(4722),
    [anon_sym_LBRACK] = ACTIONS(4717),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4717),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4717),
    [anon_sym_not_in] = ACTIONS(4717),
    [anon_sym_or_return] = ACTIONS(4717),
    [anon_sym_or_continue] = ACTIONS(4717),
    [anon_sym_or_break] = ACTIONS(4717),
    [anon_sym_CARET] = ACTIONS(4722),
    [sym_uninitialized] = ACTIONS(4717),
    [sym_tag] = ACTIONS(4717),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2111] = {
    [sym_block] = STATE(2498),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(4667),
    [anon_sym_COLON_COLON] = ACTIONS(4667),
    [anon_sym_DASH_GT] = ACTIONS(4667),
    [anon_sym_where] = ACTIONS(4667),
    [anon_sym_EQ] = ACTIONS(4669),
    [anon_sym_COLON] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4669),
    [anon_sym_COLON_EQ] = ACTIONS(4667),
    [anon_sym_LPAREN] = ACTIONS(4667),
    [anon_sym_PLUS_EQ] = ACTIONS(4667),
    [anon_sym_DASH_EQ] = ACTIONS(4667),
    [anon_sym_STAR_EQ] = ACTIONS(4667),
    [anon_sym_SLASH_EQ] = ACTIONS(4667),
    [anon_sym_PERCENT_EQ] = ACTIONS(4667),
    [anon_sym_AMP_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_CARET_EQ] = ACTIONS(4667),
    [anon_sym_LT_LT_EQ] = ACTIONS(4667),
    [anon_sym_GT_GT_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_if] = ACTIONS(4667),
    [anon_sym_SEMI] = ACTIONS(4667),
    [anon_sym_do] = ACTIONS(4667),
    [anon_sym_when] = ACTIONS(4667),
    [anon_sym_in] = ACTIONS(4667),
    [anon_sym_QMARK] = ACTIONS(4667),
    [anon_sym_PLUS] = ACTIONS(4669),
    [anon_sym_DASH] = ACTIONS(4669),
    [anon_sym_TILDE] = ACTIONS(4669),
    [anon_sym_AMP] = ACTIONS(4669),
    [anon_sym_PIPE_PIPE] = ACTIONS(4669),
    [anon_sym_or_else] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_GT] = ACTIONS(4669),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_LT_EQ] = ACTIONS(4667),
    [anon_sym_LT] = ACTIONS(4669),
    [anon_sym_EQ_EQ] = ACTIONS(4667),
    [anon_sym_BANG_EQ] = ACTIONS(4667),
    [anon_sym_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE] = ACTIONS(4669),
    [anon_sym_LT_LT] = ACTIONS(4669),
    [anon_sym_GT_GT] = ACTIONS(4669),
    [anon_sym_STAR] = ACTIONS(4669),
    [anon_sym_SLASH] = ACTIONS(4669),
    [anon_sym_PERCENT] = ACTIONS(4669),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4667),
    [anon_sym_DOT] = ACTIONS(4669),
    [anon_sym_LBRACK] = ACTIONS(4667),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4667),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4667),
    [anon_sym_not_in] = ACTIONS(4667),
    [anon_sym_or_return] = ACTIONS(4667),
    [anon_sym_or_continue] = ACTIONS(4667),
    [anon_sym_or_break] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [sym_uninitialized] = ACTIONS(6376),
    [sym_tag] = ACTIONS(6378),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2112] = {
    [aux_sym_where_clause_repeat1] = STATE(2110),
    [anon_sym_LBRACE] = ACTIONS(4661),
    [anon_sym_COMMA] = ACTIONS(6380),
    [anon_sym_COLON_COLON] = ACTIONS(4661),
    [anon_sym_DASH_GT] = ACTIONS(4661),
    [anon_sym_where] = ACTIONS(4661),
    [anon_sym_EQ] = ACTIONS(4665),
    [anon_sym_COLON] = ACTIONS(4665),
    [anon_sym_PIPE] = ACTIONS(4665),
    [anon_sym_COLON_EQ] = ACTIONS(4661),
    [anon_sym_LPAREN] = ACTIONS(4661),
    [anon_sym_PLUS_EQ] = ACTIONS(4661),
    [anon_sym_DASH_EQ] = ACTIONS(4661),
    [anon_sym_STAR_EQ] = ACTIONS(4661),
    [anon_sym_SLASH_EQ] = ACTIONS(4661),
    [anon_sym_PERCENT_EQ] = ACTIONS(4661),
    [anon_sym_AMP_EQ] = ACTIONS(4661),
    [anon_sym_PIPE_EQ] = ACTIONS(4661),
    [anon_sym_CARET_EQ] = ACTIONS(4661),
    [anon_sym_LT_LT_EQ] = ACTIONS(4661),
    [anon_sym_GT_GT_EQ] = ACTIONS(4661),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4661),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4661),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4661),
    [anon_sym_if] = ACTIONS(4661),
    [anon_sym_SEMI] = ACTIONS(4661),
    [anon_sym_do] = ACTIONS(4661),
    [anon_sym_when] = ACTIONS(4661),
    [anon_sym_in] = ACTIONS(4661),
    [anon_sym_QMARK] = ACTIONS(4661),
    [anon_sym_PLUS] = ACTIONS(4665),
    [anon_sym_DASH] = ACTIONS(4665),
    [anon_sym_TILDE] = ACTIONS(4665),
    [anon_sym_AMP] = ACTIONS(4665),
    [anon_sym_PIPE_PIPE] = ACTIONS(4665),
    [anon_sym_or_else] = ACTIONS(4661),
    [anon_sym_AMP_AMP] = ACTIONS(4665),
    [anon_sym_GT] = ACTIONS(4665),
    [anon_sym_GT_EQ] = ACTIONS(4661),
    [anon_sym_LT_EQ] = ACTIONS(4661),
    [anon_sym_LT] = ACTIONS(4665),
    [anon_sym_EQ_EQ] = ACTIONS(4661),
    [anon_sym_BANG_EQ] = ACTIONS(4661),
    [anon_sym_TILDE_EQ] = ACTIONS(4661),
    [anon_sym_AMP_TILDE] = ACTIONS(4665),
    [anon_sym_LT_LT] = ACTIONS(4665),
    [anon_sym_GT_GT] = ACTIONS(4665),
    [anon_sym_STAR] = ACTIONS(4665),
    [anon_sym_SLASH] = ACTIONS(4665),
    [anon_sym_PERCENT] = ACTIONS(4665),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4661),
    [anon_sym_DOT] = ACTIONS(4665),
    [anon_sym_LBRACK] = ACTIONS(4661),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4661),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4661),
    [anon_sym_not_in] = ACTIONS(4661),
    [anon_sym_or_return] = ACTIONS(4661),
    [anon_sym_or_continue] = ACTIONS(4661),
    [anon_sym_or_break] = ACTIONS(4661),
    [anon_sym_CARET] = ACTIONS(4665),
    [sym_uninitialized] = ACTIONS(4661),
    [sym_tag] = ACTIONS(4661),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2113] = {
    [sym_block] = STATE(2498),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(4667),
    [anon_sym_COLON_COLON] = ACTIONS(4667),
    [anon_sym_DASH_GT] = ACTIONS(4667),
    [anon_sym_where] = ACTIONS(4667),
    [anon_sym_EQ] = ACTIONS(4669),
    [anon_sym_COLON] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4669),
    [anon_sym_COLON_EQ] = ACTIONS(4667),
    [anon_sym_LPAREN] = ACTIONS(4667),
    [anon_sym_PLUS_EQ] = ACTIONS(4667),
    [anon_sym_DASH_EQ] = ACTIONS(4667),
    [anon_sym_STAR_EQ] = ACTIONS(4667),
    [anon_sym_SLASH_EQ] = ACTIONS(4667),
    [anon_sym_PERCENT_EQ] = ACTIONS(4667),
    [anon_sym_AMP_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_CARET_EQ] = ACTIONS(4667),
    [anon_sym_LT_LT_EQ] = ACTIONS(4667),
    [anon_sym_GT_GT_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_if] = ACTIONS(4667),
    [anon_sym_SEMI] = ACTIONS(4667),
    [anon_sym_do] = ACTIONS(4667),
    [anon_sym_when] = ACTIONS(4667),
    [anon_sym_in] = ACTIONS(4667),
    [anon_sym_QMARK] = ACTIONS(4667),
    [anon_sym_PLUS] = ACTIONS(4669),
    [anon_sym_DASH] = ACTIONS(4669),
    [anon_sym_TILDE] = ACTIONS(4669),
    [anon_sym_AMP] = ACTIONS(4669),
    [anon_sym_PIPE_PIPE] = ACTIONS(4669),
    [anon_sym_or_else] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_GT] = ACTIONS(4669),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_LT_EQ] = ACTIONS(4667),
    [anon_sym_LT] = ACTIONS(4669),
    [anon_sym_EQ_EQ] = ACTIONS(4667),
    [anon_sym_BANG_EQ] = ACTIONS(4667),
    [anon_sym_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE] = ACTIONS(4669),
    [anon_sym_LT_LT] = ACTIONS(4669),
    [anon_sym_GT_GT] = ACTIONS(4669),
    [anon_sym_STAR] = ACTIONS(4669),
    [anon_sym_SLASH] = ACTIONS(4669),
    [anon_sym_PERCENT] = ACTIONS(4669),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4667),
    [anon_sym_DOT] = ACTIONS(4669),
    [anon_sym_LBRACK] = ACTIONS(4667),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4667),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4667),
    [anon_sym_not_in] = ACTIONS(4667),
    [anon_sym_or_return] = ACTIONS(4667),
    [anon_sym_or_continue] = ACTIONS(4667),
    [anon_sym_or_break] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [sym_uninitialized] = ACTIONS(6376),
    [sym_tag] = ACTIONS(4667),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2114] = {
    [sym_block] = STATE(2506),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_DASH_GT] = ACTIONS(3671),
    [anon_sym_where] = ACTIONS(3671),
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_PLUS_EQ] = ACTIONS(3671),
    [anon_sym_DASH_EQ] = ACTIONS(3671),
    [anon_sym_STAR_EQ] = ACTIONS(3671),
    [anon_sym_SLASH_EQ] = ACTIONS(3671),
    [anon_sym_PERCENT_EQ] = ACTIONS(3671),
    [anon_sym_AMP_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_CARET_EQ] = ACTIONS(3671),
    [anon_sym_LT_LT_EQ] = ACTIONS(3671),
    [anon_sym_GT_GT_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_if] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_do] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_or_else] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_GT] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3671),
    [anon_sym_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_SLASH] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3671),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3671),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3671),
    [anon_sym_not_in] = ACTIONS(3671),
    [anon_sym_or_return] = ACTIONS(3671),
    [anon_sym_or_continue] = ACTIONS(3671),
    [anon_sym_or_break] = ACTIONS(3671),
    [anon_sym_CARET] = ACTIONS(3675),
    [sym_uninitialized] = ACTIONS(6213),
    [sym_tag] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2115] = {
    [sym_block] = STATE(2506),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_DASH_GT] = ACTIONS(3671),
    [anon_sym_where] = ACTIONS(3671),
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_PLUS_EQ] = ACTIONS(3671),
    [anon_sym_DASH_EQ] = ACTIONS(3671),
    [anon_sym_STAR_EQ] = ACTIONS(3671),
    [anon_sym_SLASH_EQ] = ACTIONS(3671),
    [anon_sym_PERCENT_EQ] = ACTIONS(3671),
    [anon_sym_AMP_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_CARET_EQ] = ACTIONS(3671),
    [anon_sym_LT_LT_EQ] = ACTIONS(3671),
    [anon_sym_GT_GT_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_if] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_do] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_or_else] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_GT] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3671),
    [anon_sym_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_SLASH] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3671),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3671),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3671),
    [anon_sym_not_in] = ACTIONS(3671),
    [anon_sym_or_return] = ACTIONS(3671),
    [anon_sym_or_continue] = ACTIONS(3671),
    [anon_sym_or_break] = ACTIONS(3671),
    [anon_sym_CARET] = ACTIONS(3675),
    [sym_uninitialized] = ACTIONS(6213),
    [sym_tag] = ACTIONS(6215),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2116] = {
    [sym_block] = STATE(2503),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(4023),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_do] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(6217),
    [sym_tag] = ACTIONS(4023),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2117] = {
    [sym_block] = STATE(2503),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_where] = ACTIONS(4023),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_do] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_uninitialized] = ACTIONS(6217),
    [sym_tag] = ACTIONS(6219),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2118] = {
    [sym_block] = STATE(2497),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(4083),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_do] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(6165),
    [sym_tag] = ACTIONS(6223),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2119] = {
    [ts_builtin_sym_end] = ACTIONS(5554),
    [anon_sym_LBRACE] = ACTIONS(4988),
    [anon_sym_RBRACE] = ACTIONS(5554),
    [anon_sym_COMMA] = ACTIONS(4988),
    [anon_sym_DASH_GT] = ACTIONS(4988),
    [anon_sym_EQ] = ACTIONS(4990),
    [anon_sym_COLON] = ACTIONS(4990),
    [anon_sym_PIPE] = ACTIONS(4990),
    [anon_sym_COLON_EQ] = ACTIONS(4988),
    [anon_sym_LPAREN] = ACTIONS(4988),
    [anon_sym_PLUS_EQ] = ACTIONS(4988),
    [anon_sym_DASH_EQ] = ACTIONS(4988),
    [anon_sym_STAR_EQ] = ACTIONS(4988),
    [anon_sym_SLASH_EQ] = ACTIONS(4988),
    [anon_sym_PERCENT_EQ] = ACTIONS(4988),
    [anon_sym_AMP_EQ] = ACTIONS(4988),
    [anon_sym_PIPE_EQ] = ACTIONS(4988),
    [anon_sym_CARET_EQ] = ACTIONS(4988),
    [anon_sym_LT_LT_EQ] = ACTIONS(4988),
    [anon_sym_GT_GT_EQ] = ACTIONS(4988),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4988),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4988),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4988),
    [anon_sym_if] = ACTIONS(4988),
    [anon_sym_SEMI] = ACTIONS(5554),
    [anon_sym_do] = ACTIONS(4988),
    [anon_sym_else] = ACTIONS(5554),
    [anon_sym_when] = ACTIONS(4988),
    [anon_sym_in] = ACTIONS(4988),
    [anon_sym_case] = ACTIONS(5554),
    [anon_sym_QMARK] = ACTIONS(4988),
    [anon_sym_PLUS] = ACTIONS(4990),
    [anon_sym_DASH] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4990),
    [anon_sym_AMP] = ACTIONS(4990),
    [anon_sym_PIPE_PIPE] = ACTIONS(4990),
    [anon_sym_or_else] = ACTIONS(4988),
    [anon_sym_AMP_AMP] = ACTIONS(4990),
    [anon_sym_GT] = ACTIONS(4990),
    [anon_sym_GT_EQ] = ACTIONS(4988),
    [anon_sym_LT_EQ] = ACTIONS(4988),
    [anon_sym_LT] = ACTIONS(4990),
    [anon_sym_EQ_EQ] = ACTIONS(4988),
    [anon_sym_BANG_EQ] = ACTIONS(4988),
    [anon_sym_TILDE_EQ] = ACTIONS(4988),
    [anon_sym_AMP_TILDE] = ACTIONS(4990),
    [anon_sym_LT_LT] = ACTIONS(4990),
    [anon_sym_GT_GT] = ACTIONS(4990),
    [anon_sym_STAR] = ACTIONS(4990),
    [anon_sym_SLASH] = ACTIONS(4990),
    [anon_sym_PERCENT] = ACTIONS(4990),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4988),
    [anon_sym_DOT] = ACTIONS(4990),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4988),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4988),
    [anon_sym_not_in] = ACTIONS(4988),
    [anon_sym_or_return] = ACTIONS(4988),
    [anon_sym_or_continue] = ACTIONS(4988),
    [anon_sym_or_break] = ACTIONS(4988),
    [anon_sym_CARET] = ACTIONS(4990),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5554),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2120] = {
    [sym_block] = STATE(2491),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_where] = ACTIONS(3415),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_do] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_uninitialized] = ACTIONS(6173),
    [sym_tag] = ACTIONS(6382),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2121] = {
    [aux_sym_where_clause_repeat1] = STATE(2112),
    [anon_sym_LBRACE] = ACTIONS(4728),
    [anon_sym_COMMA] = ACTIONS(6380),
    [anon_sym_COLON_COLON] = ACTIONS(4728),
    [anon_sym_DASH_GT] = ACTIONS(6384),
    [anon_sym_where] = ACTIONS(4728),
    [anon_sym_EQ] = ACTIONS(4732),
    [anon_sym_COLON] = ACTIONS(4732),
    [anon_sym_PIPE] = ACTIONS(6386),
    [anon_sym_COLON_EQ] = ACTIONS(4728),
    [anon_sym_LPAREN] = ACTIONS(4728),
    [anon_sym_PLUS_EQ] = ACTIONS(4728),
    [anon_sym_DASH_EQ] = ACTIONS(4728),
    [anon_sym_STAR_EQ] = ACTIONS(4728),
    [anon_sym_SLASH_EQ] = ACTIONS(4728),
    [anon_sym_PERCENT_EQ] = ACTIONS(4728),
    [anon_sym_AMP_EQ] = ACTIONS(4728),
    [anon_sym_PIPE_EQ] = ACTIONS(4728),
    [anon_sym_CARET_EQ] = ACTIONS(4728),
    [anon_sym_LT_LT_EQ] = ACTIONS(4728),
    [anon_sym_GT_GT_EQ] = ACTIONS(4728),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4728),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4728),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4728),
    [anon_sym_if] = ACTIONS(4728),
    [anon_sym_SEMI] = ACTIONS(4728),
    [anon_sym_do] = ACTIONS(4728),
    [anon_sym_when] = ACTIONS(4728),
    [anon_sym_in] = ACTIONS(4728),
    [anon_sym_QMARK] = ACTIONS(4728),
    [anon_sym_PLUS] = ACTIONS(6388),
    [anon_sym_DASH] = ACTIONS(6388),
    [anon_sym_TILDE] = ACTIONS(6390),
    [anon_sym_AMP] = ACTIONS(6392),
    [anon_sym_PIPE_PIPE] = ACTIONS(6394),
    [anon_sym_or_else] = ACTIONS(6396),
    [anon_sym_AMP_AMP] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6400),
    [anon_sym_GT_EQ] = ACTIONS(6402),
    [anon_sym_LT_EQ] = ACTIONS(6402),
    [anon_sym_LT] = ACTIONS(6400),
    [anon_sym_EQ_EQ] = ACTIONS(6404),
    [anon_sym_BANG_EQ] = ACTIONS(6404),
    [anon_sym_TILDE_EQ] = ACTIONS(6404),
    [anon_sym_AMP_TILDE] = ACTIONS(6406),
    [anon_sym_LT_LT] = ACTIONS(6408),
    [anon_sym_GT_GT] = ACTIONS(6408),
    [anon_sym_STAR] = ACTIONS(6410),
    [anon_sym_SLASH] = ACTIONS(6410),
    [anon_sym_PERCENT] = ACTIONS(6410),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(6412),
    [anon_sym_DOT] = ACTIONS(6414),
    [anon_sym_LBRACK] = ACTIONS(6416),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(6418),
    [anon_sym_DOT_DOT_LT] = ACTIONS(6418),
    [anon_sym_not_in] = ACTIONS(4728),
    [anon_sym_or_return] = ACTIONS(6420),
    [anon_sym_or_continue] = ACTIONS(6422),
    [anon_sym_or_break] = ACTIONS(6424),
    [anon_sym_CARET] = ACTIONS(6426),
    [sym_uninitialized] = ACTIONS(4728),
    [sym_tag] = ACTIONS(4728),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2122] = {
    [aux_sym_struct_type_repeat2] = STATE(2179),
    [anon_sym_LBRACE] = ACTIONS(4566),
    [anon_sym_COMMA] = ACTIONS(4566),
    [anon_sym_COLON_COLON] = ACTIONS(4566),
    [anon_sym_DASH_GT] = ACTIONS(4566),
    [anon_sym_where] = ACTIONS(4566),
    [anon_sym_EQ] = ACTIONS(4568),
    [anon_sym_COLON] = ACTIONS(4568),
    [anon_sym_PIPE] = ACTIONS(4568),
    [anon_sym_COLON_EQ] = ACTIONS(4566),
    [anon_sym_LPAREN] = ACTIONS(4566),
    [anon_sym_PLUS_EQ] = ACTIONS(4566),
    [anon_sym_DASH_EQ] = ACTIONS(4566),
    [anon_sym_STAR_EQ] = ACTIONS(4566),
    [anon_sym_SLASH_EQ] = ACTIONS(4566),
    [anon_sym_PERCENT_EQ] = ACTIONS(4566),
    [anon_sym_AMP_EQ] = ACTIONS(4566),
    [anon_sym_PIPE_EQ] = ACTIONS(4566),
    [anon_sym_CARET_EQ] = ACTIONS(4566),
    [anon_sym_LT_LT_EQ] = ACTIONS(4566),
    [anon_sym_GT_GT_EQ] = ACTIONS(4566),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4566),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4566),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4566),
    [anon_sym_if] = ACTIONS(4566),
    [anon_sym_SEMI] = ACTIONS(4566),
    [anon_sym_do] = ACTIONS(4566),
    [anon_sym_when] = ACTIONS(4566),
    [anon_sym_in] = ACTIONS(4566),
    [anon_sym_QMARK] = ACTIONS(4566),
    [anon_sym_PLUS] = ACTIONS(4568),
    [anon_sym_DASH] = ACTIONS(4568),
    [anon_sym_TILDE] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4568),
    [anon_sym_PIPE_PIPE] = ACTIONS(4568),
    [anon_sym_or_else] = ACTIONS(4566),
    [anon_sym_AMP_AMP] = ACTIONS(4568),
    [anon_sym_GT] = ACTIONS(4568),
    [anon_sym_GT_EQ] = ACTIONS(4566),
    [anon_sym_LT_EQ] = ACTIONS(4566),
    [anon_sym_LT] = ACTIONS(4568),
    [anon_sym_EQ_EQ] = ACTIONS(4566),
    [anon_sym_BANG_EQ] = ACTIONS(4566),
    [anon_sym_TILDE_EQ] = ACTIONS(4566),
    [anon_sym_AMP_TILDE] = ACTIONS(4568),
    [anon_sym_LT_LT] = ACTIONS(4568),
    [anon_sym_GT_GT] = ACTIONS(4568),
    [anon_sym_STAR] = ACTIONS(4568),
    [anon_sym_SLASH] = ACTIONS(4568),
    [anon_sym_PERCENT] = ACTIONS(4568),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4566),
    [anon_sym_DOT] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4566),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4566),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4566),
    [anon_sym_not_in] = ACTIONS(4566),
    [anon_sym_or_return] = ACTIONS(4566),
    [anon_sym_or_continue] = ACTIONS(4566),
    [anon_sym_or_break] = ACTIONS(4566),
    [anon_sym_CARET] = ACTIONS(4568),
    [sym_uninitialized] = ACTIONS(4566),
    [sym_tag] = ACTIONS(4566),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2123] = {
    [anon_sym_LBRACE] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_COLON_COLON] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_where] = ACTIONS(4453),
    [anon_sym_EQ] = ACTIONS(4455),
    [anon_sym_COLON] = ACTIONS(4455),
    [anon_sym_PIPE] = ACTIONS(4455),
    [anon_sym_COLON_EQ] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_PLUS_EQ] = ACTIONS(4453),
    [anon_sym_DASH_EQ] = ACTIONS(4453),
    [anon_sym_STAR_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_PERCENT_EQ] = ACTIONS(4453),
    [anon_sym_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_CARET_EQ] = ACTIONS(4453),
    [anon_sym_LT_LT_EQ] = ACTIONS(4453),
    [anon_sym_GT_GT_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4453),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4453),
    [anon_sym_if] = ACTIONS(4453),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_do] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_in] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4455),
    [anon_sym_DASH] = ACTIONS(4455),
    [anon_sym_TILDE] = ACTIONS(4455),
    [anon_sym_AMP] = ACTIONS(4455),
    [anon_sym_PIPE_PIPE] = ACTIONS(4455),
    [anon_sym_or_else] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4455),
    [anon_sym_GT] = ACTIONS(4455),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4455),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_TILDE_EQ] = ACTIONS(4453),
    [anon_sym_AMP_TILDE] = ACTIONS(4455),
    [anon_sym_LT_LT] = ACTIONS(4455),
    [anon_sym_GT_GT] = ACTIONS(4455),
    [anon_sym_STAR] = ACTIONS(4455),
    [anon_sym_SLASH] = ACTIONS(4455),
    [anon_sym_PERCENT] = ACTIONS(4455),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4455),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4453),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4453),
    [anon_sym_not_in] = ACTIONS(4453),
    [anon_sym_or_return] = ACTIONS(4453),
    [anon_sym_or_continue] = ACTIONS(4453),
    [anon_sym_or_break] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4455),
    [anon_sym_DOT2] = ACTIONS(4455),
    [sym_uninitialized] = ACTIONS(4453),
    [sym_tag] = ACTIONS(4453),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2124] = {
    [aux_sym_struct_type_repeat2] = STATE(2179),
    [anon_sym_LBRACE] = ACTIONS(4546),
    [anon_sym_COMMA] = ACTIONS(4546),
    [anon_sym_COLON_COLON] = ACTIONS(4546),
    [anon_sym_DASH_GT] = ACTIONS(4546),
    [anon_sym_where] = ACTIONS(4546),
    [anon_sym_EQ] = ACTIONS(4548),
    [anon_sym_COLON] = ACTIONS(4548),
    [anon_sym_PIPE] = ACTIONS(4548),
    [anon_sym_COLON_EQ] = ACTIONS(4546),
    [anon_sym_LPAREN] = ACTIONS(4546),
    [anon_sym_PLUS_EQ] = ACTIONS(4546),
    [anon_sym_DASH_EQ] = ACTIONS(4546),
    [anon_sym_STAR_EQ] = ACTIONS(4546),
    [anon_sym_SLASH_EQ] = ACTIONS(4546),
    [anon_sym_PERCENT_EQ] = ACTIONS(4546),
    [anon_sym_AMP_EQ] = ACTIONS(4546),
    [anon_sym_PIPE_EQ] = ACTIONS(4546),
    [anon_sym_CARET_EQ] = ACTIONS(4546),
    [anon_sym_LT_LT_EQ] = ACTIONS(4546),
    [anon_sym_GT_GT_EQ] = ACTIONS(4546),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4546),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4546),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4546),
    [anon_sym_if] = ACTIONS(4546),
    [anon_sym_SEMI] = ACTIONS(4546),
    [anon_sym_do] = ACTIONS(4546),
    [anon_sym_when] = ACTIONS(4546),
    [anon_sym_in] = ACTIONS(4546),
    [anon_sym_QMARK] = ACTIONS(4546),
    [anon_sym_PLUS] = ACTIONS(4548),
    [anon_sym_DASH] = ACTIONS(4548),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_AMP] = ACTIONS(4548),
    [anon_sym_PIPE_PIPE] = ACTIONS(4548),
    [anon_sym_or_else] = ACTIONS(4546),
    [anon_sym_AMP_AMP] = ACTIONS(4548),
    [anon_sym_GT] = ACTIONS(4548),
    [anon_sym_GT_EQ] = ACTIONS(4546),
    [anon_sym_LT_EQ] = ACTIONS(4546),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_EQ_EQ] = ACTIONS(4546),
    [anon_sym_BANG_EQ] = ACTIONS(4546),
    [anon_sym_TILDE_EQ] = ACTIONS(4546),
    [anon_sym_AMP_TILDE] = ACTIONS(4548),
    [anon_sym_LT_LT] = ACTIONS(4548),
    [anon_sym_GT_GT] = ACTIONS(4548),
    [anon_sym_STAR] = ACTIONS(4548),
    [anon_sym_SLASH] = ACTIONS(4548),
    [anon_sym_PERCENT] = ACTIONS(4548),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4546),
    [anon_sym_DOT] = ACTIONS(4548),
    [anon_sym_LBRACK] = ACTIONS(4546),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4546),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4546),
    [anon_sym_not_in] = ACTIONS(4546),
    [anon_sym_or_return] = ACTIONS(4546),
    [anon_sym_or_continue] = ACTIONS(4546),
    [anon_sym_or_break] = ACTIONS(4546),
    [anon_sym_CARET] = ACTIONS(4548),
    [sym_uninitialized] = ACTIONS(4546),
    [sym_tag] = ACTIONS(4546),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2125] = {
    [aux_sym_struct_type_repeat2] = STATE(2179),
    [anon_sym_LBRACE] = ACTIONS(4534),
    [anon_sym_COMMA] = ACTIONS(4534),
    [anon_sym_COLON_COLON] = ACTIONS(4534),
    [anon_sym_DASH_GT] = ACTIONS(4534),
    [anon_sym_where] = ACTIONS(4534),
    [anon_sym_EQ] = ACTIONS(4536),
    [anon_sym_COLON] = ACTIONS(4536),
    [anon_sym_PIPE] = ACTIONS(4536),
    [anon_sym_COLON_EQ] = ACTIONS(4534),
    [anon_sym_LPAREN] = ACTIONS(4534),
    [anon_sym_PLUS_EQ] = ACTIONS(4534),
    [anon_sym_DASH_EQ] = ACTIONS(4534),
    [anon_sym_STAR_EQ] = ACTIONS(4534),
    [anon_sym_SLASH_EQ] = ACTIONS(4534),
    [anon_sym_PERCENT_EQ] = ACTIONS(4534),
    [anon_sym_AMP_EQ] = ACTIONS(4534),
    [anon_sym_PIPE_EQ] = ACTIONS(4534),
    [anon_sym_CARET_EQ] = ACTIONS(4534),
    [anon_sym_LT_LT_EQ] = ACTIONS(4534),
    [anon_sym_GT_GT_EQ] = ACTIONS(4534),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4534),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4534),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4534),
    [anon_sym_if] = ACTIONS(4534),
    [anon_sym_SEMI] = ACTIONS(4534),
    [anon_sym_do] = ACTIONS(4534),
    [anon_sym_when] = ACTIONS(4534),
    [anon_sym_in] = ACTIONS(4534),
    [anon_sym_QMARK] = ACTIONS(4534),
    [anon_sym_PLUS] = ACTIONS(4536),
    [anon_sym_DASH] = ACTIONS(4536),
    [anon_sym_TILDE] = ACTIONS(4536),
    [anon_sym_AMP] = ACTIONS(4536),
    [anon_sym_PIPE_PIPE] = ACTIONS(4536),
    [anon_sym_or_else] = ACTIONS(4534),
    [anon_sym_AMP_AMP] = ACTIONS(4536),
    [anon_sym_GT] = ACTIONS(4536),
    [anon_sym_GT_EQ] = ACTIONS(4534),
    [anon_sym_LT_EQ] = ACTIONS(4534),
    [anon_sym_LT] = ACTIONS(4536),
    [anon_sym_EQ_EQ] = ACTIONS(4534),
    [anon_sym_BANG_EQ] = ACTIONS(4534),
    [anon_sym_TILDE_EQ] = ACTIONS(4534),
    [anon_sym_AMP_TILDE] = ACTIONS(4536),
    [anon_sym_LT_LT] = ACTIONS(4536),
    [anon_sym_GT_GT] = ACTIONS(4536),
    [anon_sym_STAR] = ACTIONS(4536),
    [anon_sym_SLASH] = ACTIONS(4536),
    [anon_sym_PERCENT] = ACTIONS(4536),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4534),
    [anon_sym_DOT] = ACTIONS(4536),
    [anon_sym_LBRACK] = ACTIONS(4534),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4534),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4534),
    [anon_sym_not_in] = ACTIONS(4534),
    [anon_sym_or_return] = ACTIONS(4534),
    [anon_sym_or_continue] = ACTIONS(4534),
    [anon_sym_or_break] = ACTIONS(4534),
    [anon_sym_CARET] = ACTIONS(4536),
    [sym_uninitialized] = ACTIONS(4534),
    [sym_tag] = ACTIONS(4534),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2126] = {
    [ts_builtin_sym_end] = ACTIONS(5132),
    [anon_sym_LBRACE] = ACTIONS(5132),
    [anon_sym_RBRACE] = ACTIONS(5132),
    [anon_sym_COMMA] = ACTIONS(5132),
    [anon_sym_COLON_COLON] = ACTIONS(5132),
    [anon_sym_DASH_GT] = ACTIONS(5132),
    [anon_sym_EQ] = ACTIONS(5135),
    [anon_sym_COLON] = ACTIONS(5135),
    [anon_sym_PIPE] = ACTIONS(5135),
    [anon_sym_COLON_EQ] = ACTIONS(5132),
    [anon_sym_LPAREN] = ACTIONS(5132),
    [anon_sym_PLUS_EQ] = ACTIONS(5132),
    [anon_sym_DASH_EQ] = ACTIONS(5132),
    [anon_sym_STAR_EQ] = ACTIONS(5132),
    [anon_sym_SLASH_EQ] = ACTIONS(5132),
    [anon_sym_PERCENT_EQ] = ACTIONS(5132),
    [anon_sym_AMP_EQ] = ACTIONS(5132),
    [anon_sym_PIPE_EQ] = ACTIONS(5132),
    [anon_sym_CARET_EQ] = ACTIONS(5132),
    [anon_sym_LT_LT_EQ] = ACTIONS(5132),
    [anon_sym_GT_GT_EQ] = ACTIONS(5132),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5132),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5132),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5132),
    [anon_sym_if] = ACTIONS(5132),
    [anon_sym_SEMI] = ACTIONS(5132),
    [anon_sym_else] = ACTIONS(5132),
    [anon_sym_when] = ACTIONS(5132),
    [anon_sym_in] = ACTIONS(5132),
    [anon_sym_case] = ACTIONS(5132),
    [anon_sym_QMARK] = ACTIONS(5132),
    [anon_sym_PLUS] = ACTIONS(5135),
    [anon_sym_DASH] = ACTIONS(5135),
    [anon_sym_TILDE] = ACTIONS(5135),
    [anon_sym_AMP] = ACTIONS(5135),
    [anon_sym_PIPE_PIPE] = ACTIONS(5135),
    [anon_sym_or_else] = ACTIONS(5132),
    [anon_sym_AMP_AMP] = ACTIONS(5135),
    [anon_sym_GT] = ACTIONS(5135),
    [anon_sym_GT_EQ] = ACTIONS(5132),
    [anon_sym_LT_EQ] = ACTIONS(5132),
    [anon_sym_LT] = ACTIONS(5135),
    [anon_sym_EQ_EQ] = ACTIONS(5132),
    [anon_sym_BANG_EQ] = ACTIONS(5132),
    [anon_sym_TILDE_EQ] = ACTIONS(5132),
    [anon_sym_AMP_TILDE] = ACTIONS(5135),
    [anon_sym_LT_LT] = ACTIONS(5135),
    [anon_sym_GT_GT] = ACTIONS(5135),
    [anon_sym_STAR] = ACTIONS(5135),
    [anon_sym_SLASH] = ACTIONS(5135),
    [anon_sym_PERCENT] = ACTIONS(5135),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5132),
    [anon_sym_DOT] = ACTIONS(5135),
    [anon_sym_LBRACK] = ACTIONS(5132),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5132),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5132),
    [anon_sym_not_in] = ACTIONS(5132),
    [anon_sym_or_return] = ACTIONS(5132),
    [anon_sym_or_continue] = ACTIONS(5132),
    [anon_sym_or_break] = ACTIONS(5132),
    [anon_sym_CARET] = ACTIONS(5135),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5132),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2127] = {
    [ts_builtin_sym_end] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_COLON_COLON] = ACTIONS(891),
    [anon_sym_DASH_GT] = ACTIONS(891),
    [anon_sym_EQ] = ACTIONS(894),
    [anon_sym_COLON] = ACTIONS(894),
    [anon_sym_PIPE] = ACTIONS(894),
    [anon_sym_COLON_EQ] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(891),
    [anon_sym_PLUS_EQ] = ACTIONS(891),
    [anon_sym_DASH_EQ] = ACTIONS(891),
    [anon_sym_STAR_EQ] = ACTIONS(891),
    [anon_sym_SLASH_EQ] = ACTIONS(891),
    [anon_sym_PERCENT_EQ] = ACTIONS(891),
    [anon_sym_AMP_EQ] = ACTIONS(891),
    [anon_sym_PIPE_EQ] = ACTIONS(891),
    [anon_sym_CARET_EQ] = ACTIONS(891),
    [anon_sym_LT_LT_EQ] = ACTIONS(891),
    [anon_sym_GT_GT_EQ] = ACTIONS(891),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(891),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(891),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(891),
    [anon_sym_when] = ACTIONS(891),
    [anon_sym_in] = ACTIONS(891),
    [anon_sym_case] = ACTIONS(891),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(894),
    [anon_sym_DASH] = ACTIONS(894),
    [anon_sym_TILDE] = ACTIONS(894),
    [anon_sym_AMP] = ACTIONS(894),
    [anon_sym_PIPE_PIPE] = ACTIONS(894),
    [anon_sym_or_else] = ACTIONS(891),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT] = ACTIONS(894),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(894),
    [anon_sym_EQ_EQ] = ACTIONS(891),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_TILDE_EQ] = ACTIONS(891),
    [anon_sym_AMP_TILDE] = ACTIONS(894),
    [anon_sym_LT_LT] = ACTIONS(894),
    [anon_sym_GT_GT] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(894),
    [anon_sym_SLASH] = ACTIONS(894),
    [anon_sym_PERCENT] = ACTIONS(894),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(891),
    [anon_sym_DOT_DOT_LT] = ACTIONS(891),
    [anon_sym_not_in] = ACTIONS(891),
    [anon_sym_or_return] = ACTIONS(891),
    [anon_sym_or_continue] = ACTIONS(891),
    [anon_sym_or_break] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(894),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(891),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2128] = {
    [ts_builtin_sym_end] = ACTIONS(913),
    [anon_sym_LBRACE] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(913),
    [anon_sym_COLON_COLON] = ACTIONS(913),
    [anon_sym_DASH_GT] = ACTIONS(913),
    [anon_sym_EQ] = ACTIONS(915),
    [anon_sym_COLON] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(915),
    [anon_sym_COLON_EQ] = ACTIONS(913),
    [anon_sym_LPAREN] = ACTIONS(913),
    [anon_sym_PLUS_EQ] = ACTIONS(913),
    [anon_sym_DASH_EQ] = ACTIONS(913),
    [anon_sym_STAR_EQ] = ACTIONS(913),
    [anon_sym_SLASH_EQ] = ACTIONS(913),
    [anon_sym_PERCENT_EQ] = ACTIONS(913),
    [anon_sym_AMP_EQ] = ACTIONS(913),
    [anon_sym_PIPE_EQ] = ACTIONS(913),
    [anon_sym_CARET_EQ] = ACTIONS(913),
    [anon_sym_LT_LT_EQ] = ACTIONS(913),
    [anon_sym_GT_GT_EQ] = ACTIONS(913),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(913),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(913),
    [anon_sym_if] = ACTIONS(913),
    [anon_sym_SEMI] = ACTIONS(913),
    [anon_sym_else] = ACTIONS(913),
    [anon_sym_when] = ACTIONS(913),
    [anon_sym_in] = ACTIONS(913),
    [anon_sym_case] = ACTIONS(913),
    [anon_sym_QMARK] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(915),
    [anon_sym_TILDE] = ACTIONS(915),
    [anon_sym_AMP] = ACTIONS(915),
    [anon_sym_PIPE_PIPE] = ACTIONS(915),
    [anon_sym_or_else] = ACTIONS(913),
    [anon_sym_AMP_AMP] = ACTIONS(915),
    [anon_sym_GT] = ACTIONS(915),
    [anon_sym_GT_EQ] = ACTIONS(913),
    [anon_sym_LT_EQ] = ACTIONS(913),
    [anon_sym_LT] = ACTIONS(915),
    [anon_sym_EQ_EQ] = ACTIONS(913),
    [anon_sym_BANG_EQ] = ACTIONS(913),
    [anon_sym_TILDE_EQ] = ACTIONS(913),
    [anon_sym_AMP_TILDE] = ACTIONS(915),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_STAR] = ACTIONS(915),
    [anon_sym_SLASH] = ACTIONS(915),
    [anon_sym_PERCENT] = ACTIONS(915),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(913),
    [anon_sym_DOT] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(913),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(913),
    [anon_sym_DOT_DOT_LT] = ACTIONS(913),
    [anon_sym_not_in] = ACTIONS(913),
    [anon_sym_or_return] = ACTIONS(913),
    [anon_sym_or_continue] = ACTIONS(913),
    [anon_sym_or_break] = ACTIONS(913),
    [anon_sym_CARET] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(913),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2129] = {
    [ts_builtin_sym_end] = ACTIONS(815),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(815),
    [anon_sym_COLON_COLON] = ACTIONS(815),
    [anon_sym_DASH_GT] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(818),
    [anon_sym_COLON] = ACTIONS(818),
    [anon_sym_PIPE] = ACTIONS(818),
    [anon_sym_COLON_EQ] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(815),
    [anon_sym_PLUS_EQ] = ACTIONS(815),
    [anon_sym_DASH_EQ] = ACTIONS(815),
    [anon_sym_STAR_EQ] = ACTIONS(815),
    [anon_sym_SLASH_EQ] = ACTIONS(815),
    [anon_sym_PERCENT_EQ] = ACTIONS(815),
    [anon_sym_AMP_EQ] = ACTIONS(815),
    [anon_sym_PIPE_EQ] = ACTIONS(815),
    [anon_sym_CARET_EQ] = ACTIONS(815),
    [anon_sym_LT_LT_EQ] = ACTIONS(815),
    [anon_sym_GT_GT_EQ] = ACTIONS(815),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(815),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_else] = ACTIONS(815),
    [anon_sym_when] = ACTIONS(815),
    [anon_sym_in] = ACTIONS(815),
    [anon_sym_case] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(818),
    [anon_sym_DASH] = ACTIONS(818),
    [anon_sym_TILDE] = ACTIONS(818),
    [anon_sym_AMP] = ACTIONS(818),
    [anon_sym_PIPE_PIPE] = ACTIONS(818),
    [anon_sym_or_else] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_EQ] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_TILDE_EQ] = ACTIONS(815),
    [anon_sym_AMP_TILDE] = ACTIONS(818),
    [anon_sym_LT_LT] = ACTIONS(818),
    [anon_sym_GT_GT] = ACTIONS(818),
    [anon_sym_STAR] = ACTIONS(818),
    [anon_sym_SLASH] = ACTIONS(818),
    [anon_sym_PERCENT] = ACTIONS(818),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(818),
    [anon_sym_LBRACK] = ACTIONS(815),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(815),
    [anon_sym_DOT_DOT_LT] = ACTIONS(815),
    [anon_sym_not_in] = ACTIONS(815),
    [anon_sym_or_return] = ACTIONS(815),
    [anon_sym_or_continue] = ACTIONS(815),
    [anon_sym_or_break] = ACTIONS(815),
    [anon_sym_CARET] = ACTIONS(818),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(815),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2130] = {
    [ts_builtin_sym_end] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(859),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(859),
    [anon_sym_COLON_COLON] = ACTIONS(859),
    [anon_sym_DASH_GT] = ACTIONS(859),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_COLON_EQ] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_PLUS_EQ] = ACTIONS(859),
    [anon_sym_DASH_EQ] = ACTIONS(859),
    [anon_sym_STAR_EQ] = ACTIONS(859),
    [anon_sym_SLASH_EQ] = ACTIONS(859),
    [anon_sym_PERCENT_EQ] = ACTIONS(859),
    [anon_sym_AMP_EQ] = ACTIONS(859),
    [anon_sym_PIPE_EQ] = ACTIONS(859),
    [anon_sym_CARET_EQ] = ACTIONS(859),
    [anon_sym_LT_LT_EQ] = ACTIONS(859),
    [anon_sym_GT_GT_EQ] = ACTIONS(859),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(859),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(859),
    [anon_sym_else] = ACTIONS(859),
    [anon_sym_when] = ACTIONS(859),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_case] = ACTIONS(859),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(861),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_or_else] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_TILDE_EQ] = ACTIONS(859),
    [anon_sym_AMP_TILDE] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_STAR] = ACTIONS(861),
    [anon_sym_SLASH] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(859),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(859),
    [anon_sym_DOT_DOT_LT] = ACTIONS(859),
    [anon_sym_not_in] = ACTIONS(859),
    [anon_sym_or_return] = ACTIONS(859),
    [anon_sym_or_continue] = ACTIONS(859),
    [anon_sym_or_break] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(859),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2131] = {
    [ts_builtin_sym_end] = ACTIONS(5058),
    [anon_sym_LBRACE] = ACTIONS(5058),
    [anon_sym_RBRACE] = ACTIONS(5058),
    [anon_sym_COMMA] = ACTIONS(5058),
    [anon_sym_COLON_COLON] = ACTIONS(5058),
    [anon_sym_DASH_GT] = ACTIONS(5058),
    [anon_sym_EQ] = ACTIONS(5060),
    [anon_sym_COLON] = ACTIONS(5060),
    [anon_sym_PIPE] = ACTIONS(5060),
    [anon_sym_COLON_EQ] = ACTIONS(5058),
    [anon_sym_LPAREN] = ACTIONS(5058),
    [anon_sym_PLUS_EQ] = ACTIONS(5058),
    [anon_sym_DASH_EQ] = ACTIONS(5058),
    [anon_sym_STAR_EQ] = ACTIONS(5058),
    [anon_sym_SLASH_EQ] = ACTIONS(5058),
    [anon_sym_PERCENT_EQ] = ACTIONS(5058),
    [anon_sym_AMP_EQ] = ACTIONS(5058),
    [anon_sym_PIPE_EQ] = ACTIONS(5058),
    [anon_sym_CARET_EQ] = ACTIONS(5058),
    [anon_sym_LT_LT_EQ] = ACTIONS(5058),
    [anon_sym_GT_GT_EQ] = ACTIONS(5058),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5058),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5058),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5058),
    [anon_sym_if] = ACTIONS(5058),
    [anon_sym_SEMI] = ACTIONS(5058),
    [anon_sym_else] = ACTIONS(5058),
    [anon_sym_when] = ACTIONS(5058),
    [anon_sym_in] = ACTIONS(5058),
    [anon_sym_case] = ACTIONS(5058),
    [anon_sym_QMARK] = ACTIONS(5058),
    [anon_sym_PLUS] = ACTIONS(5060),
    [anon_sym_DASH] = ACTIONS(5060),
    [anon_sym_TILDE] = ACTIONS(5060),
    [anon_sym_AMP] = ACTIONS(5060),
    [anon_sym_PIPE_PIPE] = ACTIONS(5060),
    [anon_sym_or_else] = ACTIONS(5058),
    [anon_sym_AMP_AMP] = ACTIONS(5060),
    [anon_sym_GT] = ACTIONS(5060),
    [anon_sym_GT_EQ] = ACTIONS(5058),
    [anon_sym_LT_EQ] = ACTIONS(5058),
    [anon_sym_LT] = ACTIONS(5060),
    [anon_sym_EQ_EQ] = ACTIONS(5058),
    [anon_sym_BANG_EQ] = ACTIONS(5058),
    [anon_sym_TILDE_EQ] = ACTIONS(5058),
    [anon_sym_AMP_TILDE] = ACTIONS(5060),
    [anon_sym_LT_LT] = ACTIONS(5060),
    [anon_sym_GT_GT] = ACTIONS(5060),
    [anon_sym_STAR] = ACTIONS(5060),
    [anon_sym_SLASH] = ACTIONS(5060),
    [anon_sym_PERCENT] = ACTIONS(5060),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5058),
    [anon_sym_DOT] = ACTIONS(5060),
    [anon_sym_LBRACK] = ACTIONS(5058),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5058),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5058),
    [anon_sym_not_in] = ACTIONS(5058),
    [anon_sym_or_return] = ACTIONS(5058),
    [anon_sym_or_continue] = ACTIONS(5058),
    [anon_sym_or_break] = ACTIONS(5058),
    [anon_sym_CARET] = ACTIONS(5060),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5058),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2132] = {
    [ts_builtin_sym_end] = ACTIONS(5244),
    [anon_sym_LBRACE] = ACTIONS(5244),
    [anon_sym_RBRACE] = ACTIONS(5244),
    [anon_sym_COMMA] = ACTIONS(5244),
    [anon_sym_COLON_COLON] = ACTIONS(5244),
    [anon_sym_DASH_GT] = ACTIONS(5244),
    [anon_sym_EQ] = ACTIONS(5246),
    [anon_sym_COLON] = ACTIONS(5246),
    [anon_sym_PIPE] = ACTIONS(5246),
    [anon_sym_COLON_EQ] = ACTIONS(5244),
    [anon_sym_LPAREN] = ACTIONS(5244),
    [anon_sym_PLUS_EQ] = ACTIONS(5244),
    [anon_sym_DASH_EQ] = ACTIONS(5244),
    [anon_sym_STAR_EQ] = ACTIONS(5244),
    [anon_sym_SLASH_EQ] = ACTIONS(5244),
    [anon_sym_PERCENT_EQ] = ACTIONS(5244),
    [anon_sym_AMP_EQ] = ACTIONS(5244),
    [anon_sym_PIPE_EQ] = ACTIONS(5244),
    [anon_sym_CARET_EQ] = ACTIONS(5244),
    [anon_sym_LT_LT_EQ] = ACTIONS(5244),
    [anon_sym_GT_GT_EQ] = ACTIONS(5244),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5244),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5244),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5244),
    [anon_sym_if] = ACTIONS(5244),
    [anon_sym_SEMI] = ACTIONS(5244),
    [anon_sym_else] = ACTIONS(5244),
    [anon_sym_when] = ACTIONS(5244),
    [anon_sym_in] = ACTIONS(5244),
    [anon_sym_case] = ACTIONS(5244),
    [anon_sym_QMARK] = ACTIONS(5244),
    [anon_sym_PLUS] = ACTIONS(5246),
    [anon_sym_DASH] = ACTIONS(5246),
    [anon_sym_TILDE] = ACTIONS(5246),
    [anon_sym_AMP] = ACTIONS(5246),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_or_else] = ACTIONS(5244),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_GT] = ACTIONS(5246),
    [anon_sym_GT_EQ] = ACTIONS(5244),
    [anon_sym_LT_EQ] = ACTIONS(5244),
    [anon_sym_LT] = ACTIONS(5246),
    [anon_sym_EQ_EQ] = ACTIONS(5244),
    [anon_sym_BANG_EQ] = ACTIONS(5244),
    [anon_sym_TILDE_EQ] = ACTIONS(5244),
    [anon_sym_AMP_TILDE] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5246),
    [anon_sym_GT_GT] = ACTIONS(5246),
    [anon_sym_STAR] = ACTIONS(5246),
    [anon_sym_SLASH] = ACTIONS(5246),
    [anon_sym_PERCENT] = ACTIONS(5246),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5244),
    [anon_sym_DOT] = ACTIONS(5246),
    [anon_sym_LBRACK] = ACTIONS(5244),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5244),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5244),
    [anon_sym_not_in] = ACTIONS(5244),
    [anon_sym_or_return] = ACTIONS(5244),
    [anon_sym_or_continue] = ACTIONS(5244),
    [anon_sym_or_break] = ACTIONS(5244),
    [anon_sym_CARET] = ACTIONS(5246),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5244),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2133] = {
    [ts_builtin_sym_end] = ACTIONS(5274),
    [anon_sym_LBRACE] = ACTIONS(5274),
    [anon_sym_RBRACE] = ACTIONS(5274),
    [anon_sym_COMMA] = ACTIONS(5274),
    [anon_sym_COLON_COLON] = ACTIONS(5274),
    [anon_sym_DASH_GT] = ACTIONS(5274),
    [anon_sym_EQ] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(5276),
    [anon_sym_PIPE] = ACTIONS(5276),
    [anon_sym_COLON_EQ] = ACTIONS(5274),
    [anon_sym_LPAREN] = ACTIONS(5274),
    [anon_sym_PLUS_EQ] = ACTIONS(5274),
    [anon_sym_DASH_EQ] = ACTIONS(5274),
    [anon_sym_STAR_EQ] = ACTIONS(5274),
    [anon_sym_SLASH_EQ] = ACTIONS(5274),
    [anon_sym_PERCENT_EQ] = ACTIONS(5274),
    [anon_sym_AMP_EQ] = ACTIONS(5274),
    [anon_sym_PIPE_EQ] = ACTIONS(5274),
    [anon_sym_CARET_EQ] = ACTIONS(5274),
    [anon_sym_LT_LT_EQ] = ACTIONS(5274),
    [anon_sym_GT_GT_EQ] = ACTIONS(5274),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5274),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5274),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5274),
    [anon_sym_if] = ACTIONS(5274),
    [anon_sym_SEMI] = ACTIONS(5274),
    [anon_sym_else] = ACTIONS(5274),
    [anon_sym_when] = ACTIONS(5274),
    [anon_sym_in] = ACTIONS(5274),
    [anon_sym_case] = ACTIONS(5274),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_PLUS] = ACTIONS(5276),
    [anon_sym_DASH] = ACTIONS(5276),
    [anon_sym_TILDE] = ACTIONS(5276),
    [anon_sym_AMP] = ACTIONS(5276),
    [anon_sym_PIPE_PIPE] = ACTIONS(5276),
    [anon_sym_or_else] = ACTIONS(5274),
    [anon_sym_AMP_AMP] = ACTIONS(5276),
    [anon_sym_GT] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5274),
    [anon_sym_LT_EQ] = ACTIONS(5274),
    [anon_sym_LT] = ACTIONS(5276),
    [anon_sym_EQ_EQ] = ACTIONS(5274),
    [anon_sym_BANG_EQ] = ACTIONS(5274),
    [anon_sym_TILDE_EQ] = ACTIONS(5274),
    [anon_sym_AMP_TILDE] = ACTIONS(5276),
    [anon_sym_LT_LT] = ACTIONS(5276),
    [anon_sym_GT_GT] = ACTIONS(5276),
    [anon_sym_STAR] = ACTIONS(5276),
    [anon_sym_SLASH] = ACTIONS(5276),
    [anon_sym_PERCENT] = ACTIONS(5276),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5274),
    [anon_sym_DOT] = ACTIONS(5276),
    [anon_sym_LBRACK] = ACTIONS(5274),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5274),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5274),
    [anon_sym_not_in] = ACTIONS(5274),
    [anon_sym_or_return] = ACTIONS(5274),
    [anon_sym_or_continue] = ACTIONS(5274),
    [anon_sym_or_break] = ACTIONS(5274),
    [anon_sym_CARET] = ACTIONS(5276),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5274),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2134] = {
    [ts_builtin_sym_end] = ACTIONS(5522),
    [anon_sym_LBRACE] = ACTIONS(5522),
    [anon_sym_RBRACE] = ACTIONS(5522),
    [anon_sym_COMMA] = ACTIONS(5522),
    [anon_sym_COLON_COLON] = ACTIONS(5522),
    [anon_sym_DASH_GT] = ACTIONS(5522),
    [anon_sym_EQ] = ACTIONS(5524),
    [anon_sym_COLON] = ACTIONS(5524),
    [anon_sym_PIPE] = ACTIONS(5524),
    [anon_sym_COLON_EQ] = ACTIONS(5522),
    [anon_sym_LPAREN] = ACTIONS(5522),
    [anon_sym_PLUS_EQ] = ACTIONS(5522),
    [anon_sym_DASH_EQ] = ACTIONS(5522),
    [anon_sym_STAR_EQ] = ACTIONS(5522),
    [anon_sym_SLASH_EQ] = ACTIONS(5522),
    [anon_sym_PERCENT_EQ] = ACTIONS(5522),
    [anon_sym_AMP_EQ] = ACTIONS(5522),
    [anon_sym_PIPE_EQ] = ACTIONS(5522),
    [anon_sym_CARET_EQ] = ACTIONS(5522),
    [anon_sym_LT_LT_EQ] = ACTIONS(5522),
    [anon_sym_GT_GT_EQ] = ACTIONS(5522),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5522),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5522),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5522),
    [anon_sym_if] = ACTIONS(5522),
    [anon_sym_SEMI] = ACTIONS(5522),
    [anon_sym_else] = ACTIONS(5522),
    [anon_sym_when] = ACTIONS(5522),
    [anon_sym_in] = ACTIONS(5522),
    [anon_sym_case] = ACTIONS(5522),
    [anon_sym_QMARK] = ACTIONS(5522),
    [anon_sym_PLUS] = ACTIONS(5524),
    [anon_sym_DASH] = ACTIONS(5524),
    [anon_sym_TILDE] = ACTIONS(5524),
    [anon_sym_AMP] = ACTIONS(5524),
    [anon_sym_PIPE_PIPE] = ACTIONS(5524),
    [anon_sym_or_else] = ACTIONS(5522),
    [anon_sym_AMP_AMP] = ACTIONS(5524),
    [anon_sym_GT] = ACTIONS(5524),
    [anon_sym_GT_EQ] = ACTIONS(5522),
    [anon_sym_LT_EQ] = ACTIONS(5522),
    [anon_sym_LT] = ACTIONS(5524),
    [anon_sym_EQ_EQ] = ACTIONS(5522),
    [anon_sym_BANG_EQ] = ACTIONS(5522),
    [anon_sym_TILDE_EQ] = ACTIONS(5522),
    [anon_sym_AMP_TILDE] = ACTIONS(5524),
    [anon_sym_LT_LT] = ACTIONS(5524),
    [anon_sym_GT_GT] = ACTIONS(5524),
    [anon_sym_STAR] = ACTIONS(5524),
    [anon_sym_SLASH] = ACTIONS(5524),
    [anon_sym_PERCENT] = ACTIONS(5524),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5522),
    [anon_sym_DOT] = ACTIONS(5524),
    [anon_sym_LBRACK] = ACTIONS(5522),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5522),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5522),
    [anon_sym_not_in] = ACTIONS(5522),
    [anon_sym_or_return] = ACTIONS(5522),
    [anon_sym_or_continue] = ACTIONS(5522),
    [anon_sym_or_break] = ACTIONS(5522),
    [anon_sym_CARET] = ACTIONS(5524),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5522),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2135] = {
    [ts_builtin_sym_end] = ACTIONS(4453),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_COLON_COLON] = ACTIONS(4453),
    [anon_sym_DASH_GT] = ACTIONS(4453),
    [anon_sym_EQ] = ACTIONS(4455),
    [anon_sym_COLON] = ACTIONS(4455),
    [anon_sym_PIPE] = ACTIONS(4455),
    [anon_sym_COLON_EQ] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_PLUS_EQ] = ACTIONS(4453),
    [anon_sym_DASH_EQ] = ACTIONS(4453),
    [anon_sym_STAR_EQ] = ACTIONS(4453),
    [anon_sym_SLASH_EQ] = ACTIONS(4453),
    [anon_sym_PERCENT_EQ] = ACTIONS(4453),
    [anon_sym_AMP_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_CARET_EQ] = ACTIONS(4453),
    [anon_sym_LT_LT_EQ] = ACTIONS(4453),
    [anon_sym_GT_GT_EQ] = ACTIONS(4453),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4453),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4453),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4453),
    [anon_sym_if] = ACTIONS(4453),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_else] = ACTIONS(4453),
    [anon_sym_when] = ACTIONS(4453),
    [anon_sym_in] = ACTIONS(4453),
    [anon_sym_case] = ACTIONS(4453),
    [anon_sym_QMARK] = ACTIONS(4453),
    [anon_sym_PLUS] = ACTIONS(4455),
    [anon_sym_DASH] = ACTIONS(4455),
    [anon_sym_TILDE] = ACTIONS(4455),
    [anon_sym_AMP] = ACTIONS(4455),
    [anon_sym_PIPE_PIPE] = ACTIONS(4455),
    [anon_sym_or_else] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(4455),
    [anon_sym_GT] = ACTIONS(4455),
    [anon_sym_GT_EQ] = ACTIONS(4453),
    [anon_sym_LT_EQ] = ACTIONS(4453),
    [anon_sym_LT] = ACTIONS(4455),
    [anon_sym_EQ_EQ] = ACTIONS(4453),
    [anon_sym_BANG_EQ] = ACTIONS(4453),
    [anon_sym_TILDE_EQ] = ACTIONS(4453),
    [anon_sym_AMP_TILDE] = ACTIONS(4455),
    [anon_sym_LT_LT] = ACTIONS(4455),
    [anon_sym_GT_GT] = ACTIONS(4455),
    [anon_sym_STAR] = ACTIONS(4455),
    [anon_sym_SLASH] = ACTIONS(4455),
    [anon_sym_PERCENT] = ACTIONS(4455),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4453),
    [anon_sym_DOT] = ACTIONS(4455),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4453),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4453),
    [anon_sym_not_in] = ACTIONS(4453),
    [anon_sym_or_return] = ACTIONS(4453),
    [anon_sym_or_continue] = ACTIONS(4453),
    [anon_sym_or_break] = ACTIONS(4453),
    [anon_sym_CARET] = ACTIONS(4455),
    [anon_sym_DOT2] = ACTIONS(4455),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4453),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2136] = {
    [ts_builtin_sym_end] = ACTIONS(5278),
    [anon_sym_LBRACE] = ACTIONS(5278),
    [anon_sym_RBRACE] = ACTIONS(5278),
    [anon_sym_COMMA] = ACTIONS(5278),
    [anon_sym_COLON_COLON] = ACTIONS(5278),
    [anon_sym_DASH_GT] = ACTIONS(5278),
    [anon_sym_EQ] = ACTIONS(5280),
    [anon_sym_COLON] = ACTIONS(5280),
    [anon_sym_PIPE] = ACTIONS(5280),
    [anon_sym_COLON_EQ] = ACTIONS(5278),
    [anon_sym_LPAREN] = ACTIONS(5278),
    [anon_sym_PLUS_EQ] = ACTIONS(5278),
    [anon_sym_DASH_EQ] = ACTIONS(5278),
    [anon_sym_STAR_EQ] = ACTIONS(5278),
    [anon_sym_SLASH_EQ] = ACTIONS(5278),
    [anon_sym_PERCENT_EQ] = ACTIONS(5278),
    [anon_sym_AMP_EQ] = ACTIONS(5278),
    [anon_sym_PIPE_EQ] = ACTIONS(5278),
    [anon_sym_CARET_EQ] = ACTIONS(5278),
    [anon_sym_LT_LT_EQ] = ACTIONS(5278),
    [anon_sym_GT_GT_EQ] = ACTIONS(5278),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5278),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5278),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5278),
    [anon_sym_if] = ACTIONS(5278),
    [anon_sym_SEMI] = ACTIONS(5278),
    [anon_sym_else] = ACTIONS(5278),
    [anon_sym_when] = ACTIONS(5278),
    [anon_sym_in] = ACTIONS(5278),
    [anon_sym_case] = ACTIONS(5278),
    [anon_sym_QMARK] = ACTIONS(5278),
    [anon_sym_PLUS] = ACTIONS(5280),
    [anon_sym_DASH] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [anon_sym_AMP] = ACTIONS(5280),
    [anon_sym_PIPE_PIPE] = ACTIONS(5280),
    [anon_sym_or_else] = ACTIONS(5278),
    [anon_sym_AMP_AMP] = ACTIONS(5280),
    [anon_sym_GT] = ACTIONS(5280),
    [anon_sym_GT_EQ] = ACTIONS(5278),
    [anon_sym_LT_EQ] = ACTIONS(5278),
    [anon_sym_LT] = ACTIONS(5280),
    [anon_sym_EQ_EQ] = ACTIONS(5278),
    [anon_sym_BANG_EQ] = ACTIONS(5278),
    [anon_sym_TILDE_EQ] = ACTIONS(5278),
    [anon_sym_AMP_TILDE] = ACTIONS(5280),
    [anon_sym_LT_LT] = ACTIONS(5280),
    [anon_sym_GT_GT] = ACTIONS(5280),
    [anon_sym_STAR] = ACTIONS(5280),
    [anon_sym_SLASH] = ACTIONS(5280),
    [anon_sym_PERCENT] = ACTIONS(5280),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5278),
    [anon_sym_DOT] = ACTIONS(5280),
    [anon_sym_LBRACK] = ACTIONS(5278),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5278),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5278),
    [anon_sym_not_in] = ACTIONS(5278),
    [anon_sym_or_return] = ACTIONS(5278),
    [anon_sym_or_continue] = ACTIONS(5278),
    [anon_sym_or_break] = ACTIONS(5278),
    [anon_sym_CARET] = ACTIONS(5280),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5278),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2137] = {
    [ts_builtin_sym_end] = ACTIONS(5332),
    [anon_sym_LBRACE] = ACTIONS(5332),
    [anon_sym_RBRACE] = ACTIONS(5332),
    [anon_sym_COMMA] = ACTIONS(5332),
    [anon_sym_COLON_COLON] = ACTIONS(5332),
    [anon_sym_DASH_GT] = ACTIONS(5332),
    [anon_sym_EQ] = ACTIONS(5334),
    [anon_sym_COLON] = ACTIONS(5334),
    [anon_sym_PIPE] = ACTIONS(5334),
    [anon_sym_COLON_EQ] = ACTIONS(5332),
    [anon_sym_LPAREN] = ACTIONS(5332),
    [anon_sym_PLUS_EQ] = ACTIONS(5332),
    [anon_sym_DASH_EQ] = ACTIONS(5332),
    [anon_sym_STAR_EQ] = ACTIONS(5332),
    [anon_sym_SLASH_EQ] = ACTIONS(5332),
    [anon_sym_PERCENT_EQ] = ACTIONS(5332),
    [anon_sym_AMP_EQ] = ACTIONS(5332),
    [anon_sym_PIPE_EQ] = ACTIONS(5332),
    [anon_sym_CARET_EQ] = ACTIONS(5332),
    [anon_sym_LT_LT_EQ] = ACTIONS(5332),
    [anon_sym_GT_GT_EQ] = ACTIONS(5332),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5332),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5332),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5332),
    [anon_sym_if] = ACTIONS(5332),
    [anon_sym_SEMI] = ACTIONS(5332),
    [anon_sym_else] = ACTIONS(5332),
    [anon_sym_when] = ACTIONS(5332),
    [anon_sym_in] = ACTIONS(5332),
    [anon_sym_case] = ACTIONS(5332),
    [anon_sym_QMARK] = ACTIONS(5332),
    [anon_sym_PLUS] = ACTIONS(5334),
    [anon_sym_DASH] = ACTIONS(5334),
    [anon_sym_TILDE] = ACTIONS(5334),
    [anon_sym_AMP] = ACTIONS(5334),
    [anon_sym_PIPE_PIPE] = ACTIONS(5334),
    [anon_sym_or_else] = ACTIONS(5332),
    [anon_sym_AMP_AMP] = ACTIONS(5334),
    [anon_sym_GT] = ACTIONS(5334),
    [anon_sym_GT_EQ] = ACTIONS(5332),
    [anon_sym_LT_EQ] = ACTIONS(5332),
    [anon_sym_LT] = ACTIONS(5334),
    [anon_sym_EQ_EQ] = ACTIONS(5332),
    [anon_sym_BANG_EQ] = ACTIONS(5332),
    [anon_sym_TILDE_EQ] = ACTIONS(5332),
    [anon_sym_AMP_TILDE] = ACTIONS(5334),
    [anon_sym_LT_LT] = ACTIONS(5334),
    [anon_sym_GT_GT] = ACTIONS(5334),
    [anon_sym_STAR] = ACTIONS(5334),
    [anon_sym_SLASH] = ACTIONS(5334),
    [anon_sym_PERCENT] = ACTIONS(5334),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5332),
    [anon_sym_DOT] = ACTIONS(5334),
    [anon_sym_LBRACK] = ACTIONS(5332),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5332),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5332),
    [anon_sym_not_in] = ACTIONS(5332),
    [anon_sym_or_return] = ACTIONS(5332),
    [anon_sym_or_continue] = ACTIONS(5332),
    [anon_sym_or_break] = ACTIONS(5332),
    [anon_sym_CARET] = ACTIONS(5334),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5332),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2138] = {
    [ts_builtin_sym_end] = ACTIONS(5336),
    [anon_sym_LBRACE] = ACTIONS(5336),
    [anon_sym_RBRACE] = ACTIONS(5336),
    [anon_sym_COMMA] = ACTIONS(5336),
    [anon_sym_COLON_COLON] = ACTIONS(5336),
    [anon_sym_DASH_GT] = ACTIONS(5336),
    [anon_sym_EQ] = ACTIONS(5338),
    [anon_sym_COLON] = ACTIONS(5338),
    [anon_sym_PIPE] = ACTIONS(5338),
    [anon_sym_COLON_EQ] = ACTIONS(5336),
    [anon_sym_LPAREN] = ACTIONS(5336),
    [anon_sym_PLUS_EQ] = ACTIONS(5336),
    [anon_sym_DASH_EQ] = ACTIONS(5336),
    [anon_sym_STAR_EQ] = ACTIONS(5336),
    [anon_sym_SLASH_EQ] = ACTIONS(5336),
    [anon_sym_PERCENT_EQ] = ACTIONS(5336),
    [anon_sym_AMP_EQ] = ACTIONS(5336),
    [anon_sym_PIPE_EQ] = ACTIONS(5336),
    [anon_sym_CARET_EQ] = ACTIONS(5336),
    [anon_sym_LT_LT_EQ] = ACTIONS(5336),
    [anon_sym_GT_GT_EQ] = ACTIONS(5336),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5336),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5336),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5336),
    [anon_sym_if] = ACTIONS(5336),
    [anon_sym_SEMI] = ACTIONS(5336),
    [anon_sym_else] = ACTIONS(5336),
    [anon_sym_when] = ACTIONS(5336),
    [anon_sym_in] = ACTIONS(5336),
    [anon_sym_case] = ACTIONS(5336),
    [anon_sym_QMARK] = ACTIONS(5336),
    [anon_sym_PLUS] = ACTIONS(5338),
    [anon_sym_DASH] = ACTIONS(5338),
    [anon_sym_TILDE] = ACTIONS(5338),
    [anon_sym_AMP] = ACTIONS(5338),
    [anon_sym_PIPE_PIPE] = ACTIONS(5338),
    [anon_sym_or_else] = ACTIONS(5336),
    [anon_sym_AMP_AMP] = ACTIONS(5338),
    [anon_sym_GT] = ACTIONS(5338),
    [anon_sym_GT_EQ] = ACTIONS(5336),
    [anon_sym_LT_EQ] = ACTIONS(5336),
    [anon_sym_LT] = ACTIONS(5338),
    [anon_sym_EQ_EQ] = ACTIONS(5336),
    [anon_sym_BANG_EQ] = ACTIONS(5336),
    [anon_sym_TILDE_EQ] = ACTIONS(5336),
    [anon_sym_AMP_TILDE] = ACTIONS(5338),
    [anon_sym_LT_LT] = ACTIONS(5338),
    [anon_sym_GT_GT] = ACTIONS(5338),
    [anon_sym_STAR] = ACTIONS(5338),
    [anon_sym_SLASH] = ACTIONS(5338),
    [anon_sym_PERCENT] = ACTIONS(5338),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5336),
    [anon_sym_DOT] = ACTIONS(5338),
    [anon_sym_LBRACK] = ACTIONS(5336),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5336),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5336),
    [anon_sym_not_in] = ACTIONS(5336),
    [anon_sym_or_return] = ACTIONS(5336),
    [anon_sym_or_continue] = ACTIONS(5336),
    [anon_sym_or_break] = ACTIONS(5336),
    [anon_sym_CARET] = ACTIONS(5338),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5336),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2139] = {
    [ts_builtin_sym_end] = ACTIONS(5340),
    [anon_sym_LBRACE] = ACTIONS(5340),
    [anon_sym_RBRACE] = ACTIONS(5340),
    [anon_sym_COMMA] = ACTIONS(5340),
    [anon_sym_COLON_COLON] = ACTIONS(5340),
    [anon_sym_DASH_GT] = ACTIONS(5340),
    [anon_sym_EQ] = ACTIONS(5342),
    [anon_sym_COLON] = ACTIONS(5342),
    [anon_sym_PIPE] = ACTIONS(5342),
    [anon_sym_COLON_EQ] = ACTIONS(5340),
    [anon_sym_LPAREN] = ACTIONS(5340),
    [anon_sym_PLUS_EQ] = ACTIONS(5340),
    [anon_sym_DASH_EQ] = ACTIONS(5340),
    [anon_sym_STAR_EQ] = ACTIONS(5340),
    [anon_sym_SLASH_EQ] = ACTIONS(5340),
    [anon_sym_PERCENT_EQ] = ACTIONS(5340),
    [anon_sym_AMP_EQ] = ACTIONS(5340),
    [anon_sym_PIPE_EQ] = ACTIONS(5340),
    [anon_sym_CARET_EQ] = ACTIONS(5340),
    [anon_sym_LT_LT_EQ] = ACTIONS(5340),
    [anon_sym_GT_GT_EQ] = ACTIONS(5340),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5340),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5340),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5340),
    [anon_sym_if] = ACTIONS(5340),
    [anon_sym_SEMI] = ACTIONS(5340),
    [anon_sym_else] = ACTIONS(5340),
    [anon_sym_when] = ACTIONS(5340),
    [anon_sym_in] = ACTIONS(5340),
    [anon_sym_case] = ACTIONS(5340),
    [anon_sym_QMARK] = ACTIONS(5340),
    [anon_sym_PLUS] = ACTIONS(5342),
    [anon_sym_DASH] = ACTIONS(5342),
    [anon_sym_TILDE] = ACTIONS(5342),
    [anon_sym_AMP] = ACTIONS(5342),
    [anon_sym_PIPE_PIPE] = ACTIONS(5342),
    [anon_sym_or_else] = ACTIONS(5340),
    [anon_sym_AMP_AMP] = ACTIONS(5342),
    [anon_sym_GT] = ACTIONS(5342),
    [anon_sym_GT_EQ] = ACTIONS(5340),
    [anon_sym_LT_EQ] = ACTIONS(5340),
    [anon_sym_LT] = ACTIONS(5342),
    [anon_sym_EQ_EQ] = ACTIONS(5340),
    [anon_sym_BANG_EQ] = ACTIONS(5340),
    [anon_sym_TILDE_EQ] = ACTIONS(5340),
    [anon_sym_AMP_TILDE] = ACTIONS(5342),
    [anon_sym_LT_LT] = ACTIONS(5342),
    [anon_sym_GT_GT] = ACTIONS(5342),
    [anon_sym_STAR] = ACTIONS(5342),
    [anon_sym_SLASH] = ACTIONS(5342),
    [anon_sym_PERCENT] = ACTIONS(5342),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5340),
    [anon_sym_DOT] = ACTIONS(5342),
    [anon_sym_LBRACK] = ACTIONS(5340),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5340),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5340),
    [anon_sym_not_in] = ACTIONS(5340),
    [anon_sym_or_return] = ACTIONS(5340),
    [anon_sym_or_continue] = ACTIONS(5340),
    [anon_sym_or_break] = ACTIONS(5340),
    [anon_sym_CARET] = ACTIONS(5342),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5340),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2140] = {
    [ts_builtin_sym_end] = ACTIONS(5344),
    [anon_sym_LBRACE] = ACTIONS(5344),
    [anon_sym_RBRACE] = ACTIONS(5344),
    [anon_sym_COMMA] = ACTIONS(5344),
    [anon_sym_COLON_COLON] = ACTIONS(5344),
    [anon_sym_DASH_GT] = ACTIONS(5344),
    [anon_sym_EQ] = ACTIONS(5346),
    [anon_sym_COLON] = ACTIONS(5346),
    [anon_sym_PIPE] = ACTIONS(5346),
    [anon_sym_COLON_EQ] = ACTIONS(5344),
    [anon_sym_LPAREN] = ACTIONS(5344),
    [anon_sym_PLUS_EQ] = ACTIONS(5344),
    [anon_sym_DASH_EQ] = ACTIONS(5344),
    [anon_sym_STAR_EQ] = ACTIONS(5344),
    [anon_sym_SLASH_EQ] = ACTIONS(5344),
    [anon_sym_PERCENT_EQ] = ACTIONS(5344),
    [anon_sym_AMP_EQ] = ACTIONS(5344),
    [anon_sym_PIPE_EQ] = ACTIONS(5344),
    [anon_sym_CARET_EQ] = ACTIONS(5344),
    [anon_sym_LT_LT_EQ] = ACTIONS(5344),
    [anon_sym_GT_GT_EQ] = ACTIONS(5344),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5344),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5344),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5344),
    [anon_sym_if] = ACTIONS(5344),
    [anon_sym_SEMI] = ACTIONS(5344),
    [anon_sym_else] = ACTIONS(5344),
    [anon_sym_when] = ACTIONS(5344),
    [anon_sym_in] = ACTIONS(5344),
    [anon_sym_case] = ACTIONS(5344),
    [anon_sym_QMARK] = ACTIONS(5344),
    [anon_sym_PLUS] = ACTIONS(5346),
    [anon_sym_DASH] = ACTIONS(5346),
    [anon_sym_TILDE] = ACTIONS(5346),
    [anon_sym_AMP] = ACTIONS(5346),
    [anon_sym_PIPE_PIPE] = ACTIONS(5346),
    [anon_sym_or_else] = ACTIONS(5344),
    [anon_sym_AMP_AMP] = ACTIONS(5346),
    [anon_sym_GT] = ACTIONS(5346),
    [anon_sym_GT_EQ] = ACTIONS(5344),
    [anon_sym_LT_EQ] = ACTIONS(5344),
    [anon_sym_LT] = ACTIONS(5346),
    [anon_sym_EQ_EQ] = ACTIONS(5344),
    [anon_sym_BANG_EQ] = ACTIONS(5344),
    [anon_sym_TILDE_EQ] = ACTIONS(5344),
    [anon_sym_AMP_TILDE] = ACTIONS(5346),
    [anon_sym_LT_LT] = ACTIONS(5346),
    [anon_sym_GT_GT] = ACTIONS(5346),
    [anon_sym_STAR] = ACTIONS(5346),
    [anon_sym_SLASH] = ACTIONS(5346),
    [anon_sym_PERCENT] = ACTIONS(5346),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5344),
    [anon_sym_DOT] = ACTIONS(5346),
    [anon_sym_LBRACK] = ACTIONS(5344),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5344),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5344),
    [anon_sym_not_in] = ACTIONS(5344),
    [anon_sym_or_return] = ACTIONS(5344),
    [anon_sym_or_continue] = ACTIONS(5344),
    [anon_sym_or_break] = ACTIONS(5344),
    [anon_sym_CARET] = ACTIONS(5346),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5344),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2141] = {
    [ts_builtin_sym_end] = ACTIONS(5366),
    [anon_sym_LBRACE] = ACTIONS(5366),
    [anon_sym_RBRACE] = ACTIONS(5366),
    [anon_sym_COMMA] = ACTIONS(5366),
    [anon_sym_COLON_COLON] = ACTIONS(5366),
    [anon_sym_DASH_GT] = ACTIONS(5366),
    [anon_sym_EQ] = ACTIONS(5368),
    [anon_sym_COLON] = ACTIONS(5368),
    [anon_sym_PIPE] = ACTIONS(5368),
    [anon_sym_COLON_EQ] = ACTIONS(5366),
    [anon_sym_LPAREN] = ACTIONS(5366),
    [anon_sym_PLUS_EQ] = ACTIONS(5366),
    [anon_sym_DASH_EQ] = ACTIONS(5366),
    [anon_sym_STAR_EQ] = ACTIONS(5366),
    [anon_sym_SLASH_EQ] = ACTIONS(5366),
    [anon_sym_PERCENT_EQ] = ACTIONS(5366),
    [anon_sym_AMP_EQ] = ACTIONS(5366),
    [anon_sym_PIPE_EQ] = ACTIONS(5366),
    [anon_sym_CARET_EQ] = ACTIONS(5366),
    [anon_sym_LT_LT_EQ] = ACTIONS(5366),
    [anon_sym_GT_GT_EQ] = ACTIONS(5366),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5366),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5366),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5366),
    [anon_sym_if] = ACTIONS(5366),
    [anon_sym_SEMI] = ACTIONS(5366),
    [anon_sym_else] = ACTIONS(5366),
    [anon_sym_when] = ACTIONS(5366),
    [anon_sym_in] = ACTIONS(5366),
    [anon_sym_case] = ACTIONS(5366),
    [anon_sym_QMARK] = ACTIONS(5366),
    [anon_sym_PLUS] = ACTIONS(5368),
    [anon_sym_DASH] = ACTIONS(5368),
    [anon_sym_TILDE] = ACTIONS(5368),
    [anon_sym_AMP] = ACTIONS(5368),
    [anon_sym_PIPE_PIPE] = ACTIONS(5368),
    [anon_sym_or_else] = ACTIONS(5366),
    [anon_sym_AMP_AMP] = ACTIONS(5368),
    [anon_sym_GT] = ACTIONS(5368),
    [anon_sym_GT_EQ] = ACTIONS(5366),
    [anon_sym_LT_EQ] = ACTIONS(5366),
    [anon_sym_LT] = ACTIONS(5368),
    [anon_sym_EQ_EQ] = ACTIONS(5366),
    [anon_sym_BANG_EQ] = ACTIONS(5366),
    [anon_sym_TILDE_EQ] = ACTIONS(5366),
    [anon_sym_AMP_TILDE] = ACTIONS(5368),
    [anon_sym_LT_LT] = ACTIONS(5368),
    [anon_sym_GT_GT] = ACTIONS(5368),
    [anon_sym_STAR] = ACTIONS(5368),
    [anon_sym_SLASH] = ACTIONS(5368),
    [anon_sym_PERCENT] = ACTIONS(5368),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5366),
    [anon_sym_DOT] = ACTIONS(5368),
    [anon_sym_LBRACK] = ACTIONS(5366),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5366),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5366),
    [anon_sym_not_in] = ACTIONS(5366),
    [anon_sym_or_return] = ACTIONS(5366),
    [anon_sym_or_continue] = ACTIONS(5366),
    [anon_sym_or_break] = ACTIONS(5366),
    [anon_sym_CARET] = ACTIONS(5368),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5366),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2142] = {
    [ts_builtin_sym_end] = ACTIONS(5370),
    [anon_sym_LBRACE] = ACTIONS(5370),
    [anon_sym_RBRACE] = ACTIONS(5370),
    [anon_sym_COMMA] = ACTIONS(5370),
    [anon_sym_COLON_COLON] = ACTIONS(5370),
    [anon_sym_DASH_GT] = ACTIONS(5370),
    [anon_sym_EQ] = ACTIONS(5372),
    [anon_sym_COLON] = ACTIONS(5372),
    [anon_sym_PIPE] = ACTIONS(5372),
    [anon_sym_COLON_EQ] = ACTIONS(5370),
    [anon_sym_LPAREN] = ACTIONS(5370),
    [anon_sym_PLUS_EQ] = ACTIONS(5370),
    [anon_sym_DASH_EQ] = ACTIONS(5370),
    [anon_sym_STAR_EQ] = ACTIONS(5370),
    [anon_sym_SLASH_EQ] = ACTIONS(5370),
    [anon_sym_PERCENT_EQ] = ACTIONS(5370),
    [anon_sym_AMP_EQ] = ACTIONS(5370),
    [anon_sym_PIPE_EQ] = ACTIONS(5370),
    [anon_sym_CARET_EQ] = ACTIONS(5370),
    [anon_sym_LT_LT_EQ] = ACTIONS(5370),
    [anon_sym_GT_GT_EQ] = ACTIONS(5370),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5370),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5370),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5370),
    [anon_sym_if] = ACTIONS(5370),
    [anon_sym_SEMI] = ACTIONS(5370),
    [anon_sym_else] = ACTIONS(5370),
    [anon_sym_when] = ACTIONS(5370),
    [anon_sym_in] = ACTIONS(5370),
    [anon_sym_case] = ACTIONS(5370),
    [anon_sym_QMARK] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_DASH] = ACTIONS(5372),
    [anon_sym_TILDE] = ACTIONS(5372),
    [anon_sym_AMP] = ACTIONS(5372),
    [anon_sym_PIPE_PIPE] = ACTIONS(5372),
    [anon_sym_or_else] = ACTIONS(5370),
    [anon_sym_AMP_AMP] = ACTIONS(5372),
    [anon_sym_GT] = ACTIONS(5372),
    [anon_sym_GT_EQ] = ACTIONS(5370),
    [anon_sym_LT_EQ] = ACTIONS(5370),
    [anon_sym_LT] = ACTIONS(5372),
    [anon_sym_EQ_EQ] = ACTIONS(5370),
    [anon_sym_BANG_EQ] = ACTIONS(5370),
    [anon_sym_TILDE_EQ] = ACTIONS(5370),
    [anon_sym_AMP_TILDE] = ACTIONS(5372),
    [anon_sym_LT_LT] = ACTIONS(5372),
    [anon_sym_GT_GT] = ACTIONS(5372),
    [anon_sym_STAR] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5372),
    [anon_sym_PERCENT] = ACTIONS(5372),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5370),
    [anon_sym_DOT] = ACTIONS(5372),
    [anon_sym_LBRACK] = ACTIONS(5370),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5370),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5370),
    [anon_sym_not_in] = ACTIONS(5370),
    [anon_sym_or_return] = ACTIONS(5370),
    [anon_sym_or_continue] = ACTIONS(5370),
    [anon_sym_or_break] = ACTIONS(5370),
    [anon_sym_CARET] = ACTIONS(5372),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5370),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2143] = {
    [ts_builtin_sym_end] = ACTIONS(5374),
    [anon_sym_LBRACE] = ACTIONS(5374),
    [anon_sym_RBRACE] = ACTIONS(5374),
    [anon_sym_COMMA] = ACTIONS(5374),
    [anon_sym_COLON_COLON] = ACTIONS(5374),
    [anon_sym_DASH_GT] = ACTIONS(5374),
    [anon_sym_EQ] = ACTIONS(5376),
    [anon_sym_COLON] = ACTIONS(5376),
    [anon_sym_PIPE] = ACTIONS(5376),
    [anon_sym_COLON_EQ] = ACTIONS(5374),
    [anon_sym_LPAREN] = ACTIONS(5374),
    [anon_sym_PLUS_EQ] = ACTIONS(5374),
    [anon_sym_DASH_EQ] = ACTIONS(5374),
    [anon_sym_STAR_EQ] = ACTIONS(5374),
    [anon_sym_SLASH_EQ] = ACTIONS(5374),
    [anon_sym_PERCENT_EQ] = ACTIONS(5374),
    [anon_sym_AMP_EQ] = ACTIONS(5374),
    [anon_sym_PIPE_EQ] = ACTIONS(5374),
    [anon_sym_CARET_EQ] = ACTIONS(5374),
    [anon_sym_LT_LT_EQ] = ACTIONS(5374),
    [anon_sym_GT_GT_EQ] = ACTIONS(5374),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5374),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5374),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5374),
    [anon_sym_if] = ACTIONS(5374),
    [anon_sym_SEMI] = ACTIONS(5374),
    [anon_sym_else] = ACTIONS(5374),
    [anon_sym_when] = ACTIONS(5374),
    [anon_sym_in] = ACTIONS(5374),
    [anon_sym_case] = ACTIONS(5374),
    [anon_sym_QMARK] = ACTIONS(5374),
    [anon_sym_PLUS] = ACTIONS(5376),
    [anon_sym_DASH] = ACTIONS(5376),
    [anon_sym_TILDE] = ACTIONS(5376),
    [anon_sym_AMP] = ACTIONS(5376),
    [anon_sym_PIPE_PIPE] = ACTIONS(5376),
    [anon_sym_or_else] = ACTIONS(5374),
    [anon_sym_AMP_AMP] = ACTIONS(5376),
    [anon_sym_GT] = ACTIONS(5376),
    [anon_sym_GT_EQ] = ACTIONS(5374),
    [anon_sym_LT_EQ] = ACTIONS(5374),
    [anon_sym_LT] = ACTIONS(5376),
    [anon_sym_EQ_EQ] = ACTIONS(5374),
    [anon_sym_BANG_EQ] = ACTIONS(5374),
    [anon_sym_TILDE_EQ] = ACTIONS(5374),
    [anon_sym_AMP_TILDE] = ACTIONS(5376),
    [anon_sym_LT_LT] = ACTIONS(5376),
    [anon_sym_GT_GT] = ACTIONS(5376),
    [anon_sym_STAR] = ACTIONS(5376),
    [anon_sym_SLASH] = ACTIONS(5376),
    [anon_sym_PERCENT] = ACTIONS(5376),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5374),
    [anon_sym_DOT] = ACTIONS(5376),
    [anon_sym_LBRACK] = ACTIONS(5374),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5374),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5374),
    [anon_sym_not_in] = ACTIONS(5374),
    [anon_sym_or_return] = ACTIONS(5374),
    [anon_sym_or_continue] = ACTIONS(5374),
    [anon_sym_or_break] = ACTIONS(5374),
    [anon_sym_CARET] = ACTIONS(5376),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5374),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2144] = {
    [ts_builtin_sym_end] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(5378),
    [anon_sym_RBRACE] = ACTIONS(5378),
    [anon_sym_COMMA] = ACTIONS(5378),
    [anon_sym_COLON_COLON] = ACTIONS(5378),
    [anon_sym_DASH_GT] = ACTIONS(5378),
    [anon_sym_EQ] = ACTIONS(5380),
    [anon_sym_COLON] = ACTIONS(5380),
    [anon_sym_PIPE] = ACTIONS(5380),
    [anon_sym_COLON_EQ] = ACTIONS(5378),
    [anon_sym_LPAREN] = ACTIONS(5378),
    [anon_sym_PLUS_EQ] = ACTIONS(5378),
    [anon_sym_DASH_EQ] = ACTIONS(5378),
    [anon_sym_STAR_EQ] = ACTIONS(5378),
    [anon_sym_SLASH_EQ] = ACTIONS(5378),
    [anon_sym_PERCENT_EQ] = ACTIONS(5378),
    [anon_sym_AMP_EQ] = ACTIONS(5378),
    [anon_sym_PIPE_EQ] = ACTIONS(5378),
    [anon_sym_CARET_EQ] = ACTIONS(5378),
    [anon_sym_LT_LT_EQ] = ACTIONS(5378),
    [anon_sym_GT_GT_EQ] = ACTIONS(5378),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5378),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5378),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5378),
    [anon_sym_if] = ACTIONS(5378),
    [anon_sym_SEMI] = ACTIONS(5378),
    [anon_sym_else] = ACTIONS(5378),
    [anon_sym_when] = ACTIONS(5378),
    [anon_sym_in] = ACTIONS(5378),
    [anon_sym_case] = ACTIONS(5378),
    [anon_sym_QMARK] = ACTIONS(5378),
    [anon_sym_PLUS] = ACTIONS(5380),
    [anon_sym_DASH] = ACTIONS(5380),
    [anon_sym_TILDE] = ACTIONS(5380),
    [anon_sym_AMP] = ACTIONS(5380),
    [anon_sym_PIPE_PIPE] = ACTIONS(5380),
    [anon_sym_or_else] = ACTIONS(5378),
    [anon_sym_AMP_AMP] = ACTIONS(5380),
    [anon_sym_GT] = ACTIONS(5380),
    [anon_sym_GT_EQ] = ACTIONS(5378),
    [anon_sym_LT_EQ] = ACTIONS(5378),
    [anon_sym_LT] = ACTIONS(5380),
    [anon_sym_EQ_EQ] = ACTIONS(5378),
    [anon_sym_BANG_EQ] = ACTIONS(5378),
    [anon_sym_TILDE_EQ] = ACTIONS(5378),
    [anon_sym_AMP_TILDE] = ACTIONS(5380),
    [anon_sym_LT_LT] = ACTIONS(5380),
    [anon_sym_GT_GT] = ACTIONS(5380),
    [anon_sym_STAR] = ACTIONS(5380),
    [anon_sym_SLASH] = ACTIONS(5380),
    [anon_sym_PERCENT] = ACTIONS(5380),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5378),
    [anon_sym_DOT] = ACTIONS(5380),
    [anon_sym_LBRACK] = ACTIONS(5378),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5378),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5378),
    [anon_sym_not_in] = ACTIONS(5378),
    [anon_sym_or_return] = ACTIONS(5378),
    [anon_sym_or_continue] = ACTIONS(5378),
    [anon_sym_or_break] = ACTIONS(5378),
    [anon_sym_CARET] = ACTIONS(5380),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5378),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2145] = {
    [ts_builtin_sym_end] = ACTIONS(5396),
    [anon_sym_LBRACE] = ACTIONS(5396),
    [anon_sym_RBRACE] = ACTIONS(5396),
    [anon_sym_COMMA] = ACTIONS(5396),
    [anon_sym_COLON_COLON] = ACTIONS(5396),
    [anon_sym_DASH_GT] = ACTIONS(5396),
    [anon_sym_EQ] = ACTIONS(5398),
    [anon_sym_COLON] = ACTIONS(5398),
    [anon_sym_PIPE] = ACTIONS(5398),
    [anon_sym_COLON_EQ] = ACTIONS(5396),
    [anon_sym_LPAREN] = ACTIONS(5396),
    [anon_sym_PLUS_EQ] = ACTIONS(5396),
    [anon_sym_DASH_EQ] = ACTIONS(5396),
    [anon_sym_STAR_EQ] = ACTIONS(5396),
    [anon_sym_SLASH_EQ] = ACTIONS(5396),
    [anon_sym_PERCENT_EQ] = ACTIONS(5396),
    [anon_sym_AMP_EQ] = ACTIONS(5396),
    [anon_sym_PIPE_EQ] = ACTIONS(5396),
    [anon_sym_CARET_EQ] = ACTIONS(5396),
    [anon_sym_LT_LT_EQ] = ACTIONS(5396),
    [anon_sym_GT_GT_EQ] = ACTIONS(5396),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5396),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5396),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5396),
    [anon_sym_if] = ACTIONS(5396),
    [anon_sym_SEMI] = ACTIONS(5396),
    [anon_sym_else] = ACTIONS(5396),
    [anon_sym_when] = ACTIONS(5396),
    [anon_sym_in] = ACTIONS(5396),
    [anon_sym_case] = ACTIONS(5396),
    [anon_sym_QMARK] = ACTIONS(5396),
    [anon_sym_PLUS] = ACTIONS(5398),
    [anon_sym_DASH] = ACTIONS(5398),
    [anon_sym_TILDE] = ACTIONS(5398),
    [anon_sym_AMP] = ACTIONS(5398),
    [anon_sym_PIPE_PIPE] = ACTIONS(5398),
    [anon_sym_or_else] = ACTIONS(5396),
    [anon_sym_AMP_AMP] = ACTIONS(5398),
    [anon_sym_GT] = ACTIONS(5398),
    [anon_sym_GT_EQ] = ACTIONS(5396),
    [anon_sym_LT_EQ] = ACTIONS(5396),
    [anon_sym_LT] = ACTIONS(5398),
    [anon_sym_EQ_EQ] = ACTIONS(5396),
    [anon_sym_BANG_EQ] = ACTIONS(5396),
    [anon_sym_TILDE_EQ] = ACTIONS(5396),
    [anon_sym_AMP_TILDE] = ACTIONS(5398),
    [anon_sym_LT_LT] = ACTIONS(5398),
    [anon_sym_GT_GT] = ACTIONS(5398),
    [anon_sym_STAR] = ACTIONS(5398),
    [anon_sym_SLASH] = ACTIONS(5398),
    [anon_sym_PERCENT] = ACTIONS(5398),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5396),
    [anon_sym_DOT] = ACTIONS(5398),
    [anon_sym_LBRACK] = ACTIONS(5396),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5396),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5396),
    [anon_sym_not_in] = ACTIONS(5396),
    [anon_sym_or_return] = ACTIONS(5396),
    [anon_sym_or_continue] = ACTIONS(5396),
    [anon_sym_or_break] = ACTIONS(5396),
    [anon_sym_CARET] = ACTIONS(5398),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5396),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2146] = {
    [ts_builtin_sym_end] = ACTIONS(4800),
    [anon_sym_LBRACE] = ACTIONS(4800),
    [anon_sym_RBRACE] = ACTIONS(4800),
    [anon_sym_COMMA] = ACTIONS(4800),
    [anon_sym_COLON_COLON] = ACTIONS(4800),
    [anon_sym_DASH_GT] = ACTIONS(4800),
    [anon_sym_EQ] = ACTIONS(4804),
    [anon_sym_COLON] = ACTIONS(4804),
    [anon_sym_PIPE] = ACTIONS(4804),
    [anon_sym_COLON_EQ] = ACTIONS(4800),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_PLUS_EQ] = ACTIONS(4800),
    [anon_sym_DASH_EQ] = ACTIONS(4800),
    [anon_sym_STAR_EQ] = ACTIONS(4800),
    [anon_sym_SLASH_EQ] = ACTIONS(4800),
    [anon_sym_PERCENT_EQ] = ACTIONS(4800),
    [anon_sym_AMP_EQ] = ACTIONS(4800),
    [anon_sym_PIPE_EQ] = ACTIONS(4800),
    [anon_sym_CARET_EQ] = ACTIONS(4800),
    [anon_sym_LT_LT_EQ] = ACTIONS(4800),
    [anon_sym_GT_GT_EQ] = ACTIONS(4800),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4800),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4800),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4800),
    [anon_sym_if] = ACTIONS(4800),
    [anon_sym_SEMI] = ACTIONS(4800),
    [anon_sym_else] = ACTIONS(4800),
    [anon_sym_when] = ACTIONS(4800),
    [anon_sym_in] = ACTIONS(4800),
    [anon_sym_case] = ACTIONS(4800),
    [anon_sym_QMARK] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4804),
    [anon_sym_DASH] = ACTIONS(4804),
    [anon_sym_TILDE] = ACTIONS(4804),
    [anon_sym_AMP] = ACTIONS(4804),
    [anon_sym_PIPE_PIPE] = ACTIONS(4804),
    [anon_sym_or_else] = ACTIONS(4800),
    [anon_sym_AMP_AMP] = ACTIONS(4804),
    [anon_sym_GT] = ACTIONS(4804),
    [anon_sym_GT_EQ] = ACTIONS(4800),
    [anon_sym_LT_EQ] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4804),
    [anon_sym_EQ_EQ] = ACTIONS(4800),
    [anon_sym_BANG_EQ] = ACTIONS(4800),
    [anon_sym_TILDE_EQ] = ACTIONS(4800),
    [anon_sym_AMP_TILDE] = ACTIONS(4804),
    [anon_sym_LT_LT] = ACTIONS(4804),
    [anon_sym_GT_GT] = ACTIONS(4804),
    [anon_sym_STAR] = ACTIONS(4804),
    [anon_sym_SLASH] = ACTIONS(6430),
    [anon_sym_PERCENT] = ACTIONS(4804),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4800),
    [anon_sym_DOT] = ACTIONS(4804),
    [anon_sym_LBRACK] = ACTIONS(4800),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4800),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4800),
    [anon_sym_not_in] = ACTIONS(4800),
    [anon_sym_or_return] = ACTIONS(4800),
    [anon_sym_or_continue] = ACTIONS(4800),
    [anon_sym_or_break] = ACTIONS(4800),
    [anon_sym_CARET] = ACTIONS(4804),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4800),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2147] = {
    [ts_builtin_sym_end] = ACTIONS(5400),
    [anon_sym_LBRACE] = ACTIONS(5400),
    [anon_sym_RBRACE] = ACTIONS(5400),
    [anon_sym_COMMA] = ACTIONS(5400),
    [anon_sym_COLON_COLON] = ACTIONS(5400),
    [anon_sym_DASH_GT] = ACTIONS(5400),
    [anon_sym_EQ] = ACTIONS(5402),
    [anon_sym_COLON] = ACTIONS(5402),
    [anon_sym_PIPE] = ACTIONS(5402),
    [anon_sym_COLON_EQ] = ACTIONS(5400),
    [anon_sym_LPAREN] = ACTIONS(5400),
    [anon_sym_PLUS_EQ] = ACTIONS(5400),
    [anon_sym_DASH_EQ] = ACTIONS(5400),
    [anon_sym_STAR_EQ] = ACTIONS(5400),
    [anon_sym_SLASH_EQ] = ACTIONS(5400),
    [anon_sym_PERCENT_EQ] = ACTIONS(5400),
    [anon_sym_AMP_EQ] = ACTIONS(5400),
    [anon_sym_PIPE_EQ] = ACTIONS(5400),
    [anon_sym_CARET_EQ] = ACTIONS(5400),
    [anon_sym_LT_LT_EQ] = ACTIONS(5400),
    [anon_sym_GT_GT_EQ] = ACTIONS(5400),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5400),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5400),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5400),
    [anon_sym_if] = ACTIONS(5400),
    [anon_sym_SEMI] = ACTIONS(5400),
    [anon_sym_else] = ACTIONS(5400),
    [anon_sym_when] = ACTIONS(5400),
    [anon_sym_in] = ACTIONS(5400),
    [anon_sym_case] = ACTIONS(5400),
    [anon_sym_QMARK] = ACTIONS(5400),
    [anon_sym_PLUS] = ACTIONS(5402),
    [anon_sym_DASH] = ACTIONS(5402),
    [anon_sym_TILDE] = ACTIONS(5402),
    [anon_sym_AMP] = ACTIONS(5402),
    [anon_sym_PIPE_PIPE] = ACTIONS(5402),
    [anon_sym_or_else] = ACTIONS(5400),
    [anon_sym_AMP_AMP] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(5402),
    [anon_sym_GT_EQ] = ACTIONS(5400),
    [anon_sym_LT_EQ] = ACTIONS(5400),
    [anon_sym_LT] = ACTIONS(5402),
    [anon_sym_EQ_EQ] = ACTIONS(5400),
    [anon_sym_BANG_EQ] = ACTIONS(5400),
    [anon_sym_TILDE_EQ] = ACTIONS(5400),
    [anon_sym_AMP_TILDE] = ACTIONS(5402),
    [anon_sym_LT_LT] = ACTIONS(5402),
    [anon_sym_GT_GT] = ACTIONS(5402),
    [anon_sym_STAR] = ACTIONS(5402),
    [anon_sym_SLASH] = ACTIONS(5402),
    [anon_sym_PERCENT] = ACTIONS(5402),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5400),
    [anon_sym_DOT] = ACTIONS(5402),
    [anon_sym_LBRACK] = ACTIONS(5400),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5400),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5400),
    [anon_sym_not_in] = ACTIONS(5400),
    [anon_sym_or_return] = ACTIONS(5400),
    [anon_sym_or_continue] = ACTIONS(5400),
    [anon_sym_or_break] = ACTIONS(5400),
    [anon_sym_CARET] = ACTIONS(5402),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5400),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2148] = {
    [aux_sym_field_identifier_repeat1] = STATE(7482),
    [anon_sym_LBRACE] = ACTIONS(6432),
    [anon_sym_COMMA] = ACTIONS(4600),
    [anon_sym_COLON_COLON] = ACTIONS(4600),
    [anon_sym_DASH_GT] = ACTIONS(4600),
    [anon_sym_where] = ACTIONS(4600),
    [anon_sym_EQ] = ACTIONS(4605),
    [anon_sym_COLON] = ACTIONS(4605),
    [anon_sym_PIPE] = ACTIONS(4605),
    [anon_sym_COLON_EQ] = ACTIONS(4600),
    [anon_sym_LPAREN] = ACTIONS(6435),
    [anon_sym_PLUS_EQ] = ACTIONS(4600),
    [anon_sym_DASH_EQ] = ACTIONS(4600),
    [anon_sym_STAR_EQ] = ACTIONS(4600),
    [anon_sym_SLASH_EQ] = ACTIONS(4600),
    [anon_sym_PERCENT_EQ] = ACTIONS(4600),
    [anon_sym_AMP_EQ] = ACTIONS(4600),
    [anon_sym_PIPE_EQ] = ACTIONS(4600),
    [anon_sym_CARET_EQ] = ACTIONS(4600),
    [anon_sym_LT_LT_EQ] = ACTIONS(4600),
    [anon_sym_GT_GT_EQ] = ACTIONS(4600),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4600),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4600),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4600),
    [anon_sym_if] = ACTIONS(4600),
    [anon_sym_SEMI] = ACTIONS(4600),
    [anon_sym_do] = ACTIONS(4600),
    [anon_sym_when] = ACTIONS(4600),
    [anon_sym_in] = ACTIONS(4600),
    [anon_sym_QMARK] = ACTIONS(4600),
    [anon_sym_PLUS] = ACTIONS(4605),
    [anon_sym_DASH] = ACTIONS(4605),
    [anon_sym_TILDE] = ACTIONS(4605),
    [anon_sym_AMP] = ACTIONS(4605),
    [anon_sym_PIPE_PIPE] = ACTIONS(4605),
    [anon_sym_or_else] = ACTIONS(4600),
    [anon_sym_AMP_AMP] = ACTIONS(4605),
    [anon_sym_GT] = ACTIONS(4605),
    [anon_sym_GT_EQ] = ACTIONS(4600),
    [anon_sym_LT_EQ] = ACTIONS(4600),
    [anon_sym_LT] = ACTIONS(4605),
    [anon_sym_EQ_EQ] = ACTIONS(4600),
    [anon_sym_BANG_EQ] = ACTIONS(4600),
    [anon_sym_TILDE_EQ] = ACTIONS(4600),
    [anon_sym_AMP_TILDE] = ACTIONS(4605),
    [anon_sym_LT_LT] = ACTIONS(4605),
    [anon_sym_GT_GT] = ACTIONS(4605),
    [anon_sym_STAR] = ACTIONS(4605),
    [anon_sym_SLASH] = ACTIONS(4605),
    [anon_sym_PERCENT] = ACTIONS(4605),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4600),
    [anon_sym_DOT] = ACTIONS(4605),
    [anon_sym_LBRACK] = ACTIONS(4600),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4600),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4600),
    [anon_sym_not_in] = ACTIONS(4600),
    [anon_sym_or_return] = ACTIONS(4600),
    [anon_sym_or_continue] = ACTIONS(4600),
    [anon_sym_or_break] = ACTIONS(4600),
    [anon_sym_CARET] = ACTIONS(4605),
    [sym_uninitialized] = ACTIONS(4600),
    [sym_tag] = ACTIONS(4600),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2149] = {
    [ts_builtin_sym_end] = ACTIONS(5408),
    [anon_sym_LBRACE] = ACTIONS(5408),
    [anon_sym_RBRACE] = ACTIONS(5408),
    [anon_sym_COMMA] = ACTIONS(5408),
    [anon_sym_COLON_COLON] = ACTIONS(5408),
    [anon_sym_DASH_GT] = ACTIONS(5408),
    [anon_sym_EQ] = ACTIONS(5410),
    [anon_sym_COLON] = ACTIONS(5410),
    [anon_sym_PIPE] = ACTIONS(5410),
    [anon_sym_COLON_EQ] = ACTIONS(5408),
    [anon_sym_LPAREN] = ACTIONS(5408),
    [anon_sym_PLUS_EQ] = ACTIONS(5408),
    [anon_sym_DASH_EQ] = ACTIONS(5408),
    [anon_sym_STAR_EQ] = ACTIONS(5408),
    [anon_sym_SLASH_EQ] = ACTIONS(5408),
    [anon_sym_PERCENT_EQ] = ACTIONS(5408),
    [anon_sym_AMP_EQ] = ACTIONS(5408),
    [anon_sym_PIPE_EQ] = ACTIONS(5408),
    [anon_sym_CARET_EQ] = ACTIONS(5408),
    [anon_sym_LT_LT_EQ] = ACTIONS(5408),
    [anon_sym_GT_GT_EQ] = ACTIONS(5408),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5408),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5408),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5408),
    [anon_sym_if] = ACTIONS(5408),
    [anon_sym_SEMI] = ACTIONS(5408),
    [anon_sym_else] = ACTIONS(5408),
    [anon_sym_when] = ACTIONS(5408),
    [anon_sym_in] = ACTIONS(5408),
    [anon_sym_case] = ACTIONS(5408),
    [anon_sym_QMARK] = ACTIONS(5408),
    [anon_sym_PLUS] = ACTIONS(5410),
    [anon_sym_DASH] = ACTIONS(5410),
    [anon_sym_TILDE] = ACTIONS(5410),
    [anon_sym_AMP] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE] = ACTIONS(5410),
    [anon_sym_or_else] = ACTIONS(5408),
    [anon_sym_AMP_AMP] = ACTIONS(5410),
    [anon_sym_GT] = ACTIONS(5410),
    [anon_sym_GT_EQ] = ACTIONS(5408),
    [anon_sym_LT_EQ] = ACTIONS(5408),
    [anon_sym_LT] = ACTIONS(5410),
    [anon_sym_EQ_EQ] = ACTIONS(5408),
    [anon_sym_BANG_EQ] = ACTIONS(5408),
    [anon_sym_TILDE_EQ] = ACTIONS(5408),
    [anon_sym_AMP_TILDE] = ACTIONS(5410),
    [anon_sym_LT_LT] = ACTIONS(5410),
    [anon_sym_GT_GT] = ACTIONS(5410),
    [anon_sym_STAR] = ACTIONS(5410),
    [anon_sym_SLASH] = ACTIONS(5410),
    [anon_sym_PERCENT] = ACTIONS(5410),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5408),
    [anon_sym_DOT] = ACTIONS(5410),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5408),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5408),
    [anon_sym_not_in] = ACTIONS(5408),
    [anon_sym_or_return] = ACTIONS(5408),
    [anon_sym_or_continue] = ACTIONS(5408),
    [anon_sym_or_break] = ACTIONS(5408),
    [anon_sym_CARET] = ACTIONS(5410),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5408),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2150] = {
    [ts_builtin_sym_end] = ACTIONS(5412),
    [anon_sym_LBRACE] = ACTIONS(5412),
    [anon_sym_RBRACE] = ACTIONS(5412),
    [anon_sym_COMMA] = ACTIONS(5412),
    [anon_sym_COLON_COLON] = ACTIONS(5412),
    [anon_sym_DASH_GT] = ACTIONS(5412),
    [anon_sym_EQ] = ACTIONS(5414),
    [anon_sym_COLON] = ACTIONS(5414),
    [anon_sym_PIPE] = ACTIONS(5414),
    [anon_sym_COLON_EQ] = ACTIONS(5412),
    [anon_sym_LPAREN] = ACTIONS(5412),
    [anon_sym_PLUS_EQ] = ACTIONS(5412),
    [anon_sym_DASH_EQ] = ACTIONS(5412),
    [anon_sym_STAR_EQ] = ACTIONS(5412),
    [anon_sym_SLASH_EQ] = ACTIONS(5412),
    [anon_sym_PERCENT_EQ] = ACTIONS(5412),
    [anon_sym_AMP_EQ] = ACTIONS(5412),
    [anon_sym_PIPE_EQ] = ACTIONS(5412),
    [anon_sym_CARET_EQ] = ACTIONS(5412),
    [anon_sym_LT_LT_EQ] = ACTIONS(5412),
    [anon_sym_GT_GT_EQ] = ACTIONS(5412),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5412),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5412),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5412),
    [anon_sym_if] = ACTIONS(5412),
    [anon_sym_SEMI] = ACTIONS(5412),
    [anon_sym_else] = ACTIONS(5412),
    [anon_sym_when] = ACTIONS(5412),
    [anon_sym_in] = ACTIONS(5412),
    [anon_sym_case] = ACTIONS(5412),
    [anon_sym_QMARK] = ACTIONS(5412),
    [anon_sym_PLUS] = ACTIONS(5414),
    [anon_sym_DASH] = ACTIONS(5414),
    [anon_sym_TILDE] = ACTIONS(5414),
    [anon_sym_AMP] = ACTIONS(5414),
    [anon_sym_PIPE_PIPE] = ACTIONS(5414),
    [anon_sym_or_else] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5414),
    [anon_sym_GT] = ACTIONS(5414),
    [anon_sym_GT_EQ] = ACTIONS(5412),
    [anon_sym_LT_EQ] = ACTIONS(5412),
    [anon_sym_LT] = ACTIONS(5414),
    [anon_sym_EQ_EQ] = ACTIONS(5412),
    [anon_sym_BANG_EQ] = ACTIONS(5412),
    [anon_sym_TILDE_EQ] = ACTIONS(5412),
    [anon_sym_AMP_TILDE] = ACTIONS(5414),
    [anon_sym_LT_LT] = ACTIONS(5414),
    [anon_sym_GT_GT] = ACTIONS(5414),
    [anon_sym_STAR] = ACTIONS(5414),
    [anon_sym_SLASH] = ACTIONS(5414),
    [anon_sym_PERCENT] = ACTIONS(5414),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5412),
    [anon_sym_DOT] = ACTIONS(5414),
    [anon_sym_LBRACK] = ACTIONS(5412),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5412),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5412),
    [anon_sym_not_in] = ACTIONS(5412),
    [anon_sym_or_return] = ACTIONS(5412),
    [anon_sym_or_continue] = ACTIONS(5412),
    [anon_sym_or_break] = ACTIONS(5412),
    [anon_sym_CARET] = ACTIONS(5414),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5412),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2151] = {
    [ts_builtin_sym_end] = ACTIONS(5416),
    [anon_sym_LBRACE] = ACTIONS(5416),
    [anon_sym_RBRACE] = ACTIONS(5416),
    [anon_sym_COMMA] = ACTIONS(5416),
    [anon_sym_COLON_COLON] = ACTIONS(5416),
    [anon_sym_DASH_GT] = ACTIONS(5416),
    [anon_sym_EQ] = ACTIONS(5418),
    [anon_sym_COLON] = ACTIONS(5418),
    [anon_sym_PIPE] = ACTIONS(5418),
    [anon_sym_COLON_EQ] = ACTIONS(5416),
    [anon_sym_LPAREN] = ACTIONS(5416),
    [anon_sym_PLUS_EQ] = ACTIONS(5416),
    [anon_sym_DASH_EQ] = ACTIONS(5416),
    [anon_sym_STAR_EQ] = ACTIONS(5416),
    [anon_sym_SLASH_EQ] = ACTIONS(5416),
    [anon_sym_PERCENT_EQ] = ACTIONS(5416),
    [anon_sym_AMP_EQ] = ACTIONS(5416),
    [anon_sym_PIPE_EQ] = ACTIONS(5416),
    [anon_sym_CARET_EQ] = ACTIONS(5416),
    [anon_sym_LT_LT_EQ] = ACTIONS(5416),
    [anon_sym_GT_GT_EQ] = ACTIONS(5416),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5416),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5416),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5416),
    [anon_sym_if] = ACTIONS(5416),
    [anon_sym_SEMI] = ACTIONS(5416),
    [anon_sym_else] = ACTIONS(5416),
    [anon_sym_when] = ACTIONS(5416),
    [anon_sym_in] = ACTIONS(5416),
    [anon_sym_case] = ACTIONS(5416),
    [anon_sym_QMARK] = ACTIONS(5416),
    [anon_sym_PLUS] = ACTIONS(5418),
    [anon_sym_DASH] = ACTIONS(5418),
    [anon_sym_TILDE] = ACTIONS(5418),
    [anon_sym_AMP] = ACTIONS(5418),
    [anon_sym_PIPE_PIPE] = ACTIONS(5418),
    [anon_sym_or_else] = ACTIONS(5416),
    [anon_sym_AMP_AMP] = ACTIONS(5418),
    [anon_sym_GT] = ACTIONS(5418),
    [anon_sym_GT_EQ] = ACTIONS(5416),
    [anon_sym_LT_EQ] = ACTIONS(5416),
    [anon_sym_LT] = ACTIONS(5418),
    [anon_sym_EQ_EQ] = ACTIONS(5416),
    [anon_sym_BANG_EQ] = ACTIONS(5416),
    [anon_sym_TILDE_EQ] = ACTIONS(5416),
    [anon_sym_AMP_TILDE] = ACTIONS(5418),
    [anon_sym_LT_LT] = ACTIONS(5418),
    [anon_sym_GT_GT] = ACTIONS(5418),
    [anon_sym_STAR] = ACTIONS(5418),
    [anon_sym_SLASH] = ACTIONS(5418),
    [anon_sym_PERCENT] = ACTIONS(5418),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(5418),
    [anon_sym_LBRACK] = ACTIONS(5416),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5416),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5416),
    [anon_sym_not_in] = ACTIONS(5416),
    [anon_sym_or_return] = ACTIONS(5416),
    [anon_sym_or_continue] = ACTIONS(5416),
    [anon_sym_or_break] = ACTIONS(5416),
    [anon_sym_CARET] = ACTIONS(5418),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5416),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2152] = {
    [ts_builtin_sym_end] = ACTIONS(5428),
    [anon_sym_LBRACE] = ACTIONS(5428),
    [anon_sym_RBRACE] = ACTIONS(5428),
    [anon_sym_COMMA] = ACTIONS(5428),
    [anon_sym_COLON_COLON] = ACTIONS(5428),
    [anon_sym_DASH_GT] = ACTIONS(5428),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_COLON] = ACTIONS(5430),
    [anon_sym_PIPE] = ACTIONS(5430),
    [anon_sym_COLON_EQ] = ACTIONS(5428),
    [anon_sym_LPAREN] = ACTIONS(5428),
    [anon_sym_PLUS_EQ] = ACTIONS(5428),
    [anon_sym_DASH_EQ] = ACTIONS(5428),
    [anon_sym_STAR_EQ] = ACTIONS(5428),
    [anon_sym_SLASH_EQ] = ACTIONS(5428),
    [anon_sym_PERCENT_EQ] = ACTIONS(5428),
    [anon_sym_AMP_EQ] = ACTIONS(5428),
    [anon_sym_PIPE_EQ] = ACTIONS(5428),
    [anon_sym_CARET_EQ] = ACTIONS(5428),
    [anon_sym_LT_LT_EQ] = ACTIONS(5428),
    [anon_sym_GT_GT_EQ] = ACTIONS(5428),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5428),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5428),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5428),
    [anon_sym_if] = ACTIONS(5428),
    [anon_sym_SEMI] = ACTIONS(5428),
    [anon_sym_else] = ACTIONS(5428),
    [anon_sym_when] = ACTIONS(5428),
    [anon_sym_in] = ACTIONS(5428),
    [anon_sym_case] = ACTIONS(5428),
    [anon_sym_QMARK] = ACTIONS(5428),
    [anon_sym_PLUS] = ACTIONS(5430),
    [anon_sym_DASH] = ACTIONS(5430),
    [anon_sym_TILDE] = ACTIONS(5430),
    [anon_sym_AMP] = ACTIONS(5430),
    [anon_sym_PIPE_PIPE] = ACTIONS(5430),
    [anon_sym_or_else] = ACTIONS(5428),
    [anon_sym_AMP_AMP] = ACTIONS(5430),
    [anon_sym_GT] = ACTIONS(5430),
    [anon_sym_GT_EQ] = ACTIONS(5428),
    [anon_sym_LT_EQ] = ACTIONS(5428),
    [anon_sym_LT] = ACTIONS(5430),
    [anon_sym_EQ_EQ] = ACTIONS(5428),
    [anon_sym_BANG_EQ] = ACTIONS(5428),
    [anon_sym_TILDE_EQ] = ACTIONS(5428),
    [anon_sym_AMP_TILDE] = ACTIONS(5430),
    [anon_sym_LT_LT] = ACTIONS(5430),
    [anon_sym_GT_GT] = ACTIONS(5430),
    [anon_sym_STAR] = ACTIONS(5430),
    [anon_sym_SLASH] = ACTIONS(5430),
    [anon_sym_PERCENT] = ACTIONS(5430),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5428),
    [anon_sym_DOT] = ACTIONS(5430),
    [anon_sym_LBRACK] = ACTIONS(5428),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5428),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5428),
    [anon_sym_not_in] = ACTIONS(5428),
    [anon_sym_or_return] = ACTIONS(5428),
    [anon_sym_or_continue] = ACTIONS(5428),
    [anon_sym_or_break] = ACTIONS(5428),
    [anon_sym_CARET] = ACTIONS(5430),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5428),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2153] = {
    [sym_identifier] = ACTIONS(6438),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_where] = ACTIONS(71),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(6440),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_do] = ACTIONS(71),
    [anon_sym_when] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [sym_uninitialized] = ACTIONS(67),
    [sym_tag] = ACTIONS(67),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2154] = {
    [ts_builtin_sym_end] = ACTIONS(5432),
    [anon_sym_LBRACE] = ACTIONS(5432),
    [anon_sym_RBRACE] = ACTIONS(5432),
    [anon_sym_COMMA] = ACTIONS(5432),
    [anon_sym_COLON_COLON] = ACTIONS(5432),
    [anon_sym_DASH_GT] = ACTIONS(5432),
    [anon_sym_EQ] = ACTIONS(5434),
    [anon_sym_COLON] = ACTIONS(5434),
    [anon_sym_PIPE] = ACTIONS(5434),
    [anon_sym_COLON_EQ] = ACTIONS(5432),
    [anon_sym_LPAREN] = ACTIONS(5432),
    [anon_sym_PLUS_EQ] = ACTIONS(5432),
    [anon_sym_DASH_EQ] = ACTIONS(5432),
    [anon_sym_STAR_EQ] = ACTIONS(5432),
    [anon_sym_SLASH_EQ] = ACTIONS(5432),
    [anon_sym_PERCENT_EQ] = ACTIONS(5432),
    [anon_sym_AMP_EQ] = ACTIONS(5432),
    [anon_sym_PIPE_EQ] = ACTIONS(5432),
    [anon_sym_CARET_EQ] = ACTIONS(5432),
    [anon_sym_LT_LT_EQ] = ACTIONS(5432),
    [anon_sym_GT_GT_EQ] = ACTIONS(5432),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5432),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5432),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5432),
    [anon_sym_if] = ACTIONS(5432),
    [anon_sym_SEMI] = ACTIONS(5432),
    [anon_sym_else] = ACTIONS(5432),
    [anon_sym_when] = ACTIONS(5432),
    [anon_sym_in] = ACTIONS(5432),
    [anon_sym_case] = ACTIONS(5432),
    [anon_sym_QMARK] = ACTIONS(5432),
    [anon_sym_PLUS] = ACTIONS(5434),
    [anon_sym_DASH] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [anon_sym_AMP] = ACTIONS(5434),
    [anon_sym_PIPE_PIPE] = ACTIONS(5434),
    [anon_sym_or_else] = ACTIONS(5432),
    [anon_sym_AMP_AMP] = ACTIONS(5434),
    [anon_sym_GT] = ACTIONS(5434),
    [anon_sym_GT_EQ] = ACTIONS(5432),
    [anon_sym_LT_EQ] = ACTIONS(5432),
    [anon_sym_LT] = ACTIONS(5434),
    [anon_sym_EQ_EQ] = ACTIONS(5432),
    [anon_sym_BANG_EQ] = ACTIONS(5432),
    [anon_sym_TILDE_EQ] = ACTIONS(5432),
    [anon_sym_AMP_TILDE] = ACTIONS(5434),
    [anon_sym_LT_LT] = ACTIONS(5434),
    [anon_sym_GT_GT] = ACTIONS(5434),
    [anon_sym_STAR] = ACTIONS(5434),
    [anon_sym_SLASH] = ACTIONS(5434),
    [anon_sym_PERCENT] = ACTIONS(5434),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5432),
    [anon_sym_DOT] = ACTIONS(5434),
    [anon_sym_LBRACK] = ACTIONS(5432),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5432),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5432),
    [anon_sym_not_in] = ACTIONS(5432),
    [anon_sym_or_return] = ACTIONS(5432),
    [anon_sym_or_continue] = ACTIONS(5432),
    [anon_sym_or_break] = ACTIONS(5432),
    [anon_sym_CARET] = ACTIONS(5434),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5432),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2155] = {
    [ts_builtin_sym_end] = ACTIONS(4618),
    [anon_sym_LBRACE] = ACTIONS(4618),
    [anon_sym_RBRACE] = ACTIONS(4618),
    [anon_sym_COMMA] = ACTIONS(4618),
    [anon_sym_COLON_COLON] = ACTIONS(4618),
    [anon_sym_DASH_GT] = ACTIONS(4618),
    [anon_sym_EQ] = ACTIONS(4623),
    [anon_sym_COLON] = ACTIONS(4623),
    [anon_sym_PIPE] = ACTIONS(4623),
    [anon_sym_COLON_EQ] = ACTIONS(4618),
    [anon_sym_LPAREN] = ACTIONS(4618),
    [anon_sym_PLUS_EQ] = ACTIONS(4618),
    [anon_sym_DASH_EQ] = ACTIONS(4618),
    [anon_sym_STAR_EQ] = ACTIONS(4618),
    [anon_sym_SLASH_EQ] = ACTIONS(4618),
    [anon_sym_PERCENT_EQ] = ACTIONS(4618),
    [anon_sym_AMP_EQ] = ACTIONS(4618),
    [anon_sym_PIPE_EQ] = ACTIONS(4618),
    [anon_sym_CARET_EQ] = ACTIONS(4618),
    [anon_sym_LT_LT_EQ] = ACTIONS(4618),
    [anon_sym_GT_GT_EQ] = ACTIONS(4618),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4618),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4618),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4618),
    [anon_sym_if] = ACTIONS(4618),
    [anon_sym_SEMI] = ACTIONS(4618),
    [anon_sym_else] = ACTIONS(4618),
    [anon_sym_when] = ACTIONS(4618),
    [anon_sym_in] = ACTIONS(4618),
    [anon_sym_case] = ACTIONS(4618),
    [anon_sym_QMARK] = ACTIONS(4618),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_DASH] = ACTIONS(4623),
    [anon_sym_TILDE] = ACTIONS(4623),
    [anon_sym_AMP] = ACTIONS(4623),
    [anon_sym_PIPE_PIPE] = ACTIONS(4623),
    [anon_sym_or_else] = ACTIONS(4618),
    [anon_sym_AMP_AMP] = ACTIONS(4623),
    [anon_sym_GT] = ACTIONS(4623),
    [anon_sym_GT_EQ] = ACTIONS(4618),
    [anon_sym_LT_EQ] = ACTIONS(4618),
    [anon_sym_LT] = ACTIONS(4623),
    [anon_sym_EQ_EQ] = ACTIONS(4618),
    [anon_sym_BANG_EQ] = ACTIONS(4618),
    [anon_sym_TILDE_EQ] = ACTIONS(4618),
    [anon_sym_AMP_TILDE] = ACTIONS(4623),
    [anon_sym_LT_LT] = ACTIONS(4623),
    [anon_sym_GT_GT] = ACTIONS(4623),
    [anon_sym_STAR] = ACTIONS(4623),
    [anon_sym_SLASH] = ACTIONS(4623),
    [anon_sym_PERCENT] = ACTIONS(4623),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4618),
    [anon_sym_DOT] = ACTIONS(4623),
    [anon_sym_LBRACK] = ACTIONS(4618),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4618),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4618),
    [anon_sym_not_in] = ACTIONS(4618),
    [anon_sym_or_return] = ACTIONS(4618),
    [anon_sym_or_continue] = ACTIONS(4618),
    [anon_sym_or_break] = ACTIONS(4618),
    [anon_sym_CARET] = ACTIONS(4623),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4618),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2156] = {
    [ts_builtin_sym_end] = ACTIONS(5382),
    [anon_sym_LBRACE] = ACTIONS(5382),
    [anon_sym_RBRACE] = ACTIONS(5382),
    [anon_sym_COMMA] = ACTIONS(5382),
    [anon_sym_COLON_COLON] = ACTIONS(5382),
    [anon_sym_DASH_GT] = ACTIONS(5382),
    [anon_sym_EQ] = ACTIONS(5384),
    [anon_sym_COLON] = ACTIONS(5384),
    [anon_sym_PIPE] = ACTIONS(5384),
    [anon_sym_COLON_EQ] = ACTIONS(5382),
    [anon_sym_LPAREN] = ACTIONS(5382),
    [anon_sym_PLUS_EQ] = ACTIONS(5382),
    [anon_sym_DASH_EQ] = ACTIONS(5382),
    [anon_sym_STAR_EQ] = ACTIONS(5382),
    [anon_sym_SLASH_EQ] = ACTIONS(5382),
    [anon_sym_PERCENT_EQ] = ACTIONS(5382),
    [anon_sym_AMP_EQ] = ACTIONS(5382),
    [anon_sym_PIPE_EQ] = ACTIONS(5382),
    [anon_sym_CARET_EQ] = ACTIONS(5382),
    [anon_sym_LT_LT_EQ] = ACTIONS(5382),
    [anon_sym_GT_GT_EQ] = ACTIONS(5382),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5382),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5382),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5382),
    [anon_sym_if] = ACTIONS(5382),
    [anon_sym_SEMI] = ACTIONS(5382),
    [anon_sym_else] = ACTIONS(5382),
    [anon_sym_when] = ACTIONS(5382),
    [anon_sym_in] = ACTIONS(5382),
    [anon_sym_case] = ACTIONS(5382),
    [anon_sym_QMARK] = ACTIONS(5382),
    [anon_sym_PLUS] = ACTIONS(5384),
    [anon_sym_DASH] = ACTIONS(5384),
    [anon_sym_TILDE] = ACTIONS(5384),
    [anon_sym_AMP] = ACTIONS(5384),
    [anon_sym_PIPE_PIPE] = ACTIONS(5384),
    [anon_sym_or_else] = ACTIONS(5382),
    [anon_sym_AMP_AMP] = ACTIONS(5384),
    [anon_sym_GT] = ACTIONS(5384),
    [anon_sym_GT_EQ] = ACTIONS(5382),
    [anon_sym_LT_EQ] = ACTIONS(5382),
    [anon_sym_LT] = ACTIONS(5384),
    [anon_sym_EQ_EQ] = ACTIONS(5382),
    [anon_sym_BANG_EQ] = ACTIONS(5382),
    [anon_sym_TILDE_EQ] = ACTIONS(5382),
    [anon_sym_AMP_TILDE] = ACTIONS(5384),
    [anon_sym_LT_LT] = ACTIONS(5384),
    [anon_sym_GT_GT] = ACTIONS(5384),
    [anon_sym_STAR] = ACTIONS(5384),
    [anon_sym_SLASH] = ACTIONS(5384),
    [anon_sym_PERCENT] = ACTIONS(5384),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5382),
    [anon_sym_DOT] = ACTIONS(5384),
    [anon_sym_LBRACK] = ACTIONS(5382),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5382),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5382),
    [anon_sym_not_in] = ACTIONS(5382),
    [anon_sym_or_return] = ACTIONS(5382),
    [anon_sym_or_continue] = ACTIONS(5382),
    [anon_sym_or_break] = ACTIONS(5382),
    [anon_sym_CARET] = ACTIONS(5384),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5382),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2157] = {
    [ts_builtin_sym_end] = ACTIONS(5436),
    [anon_sym_LBRACE] = ACTIONS(5436),
    [anon_sym_RBRACE] = ACTIONS(5436),
    [anon_sym_COMMA] = ACTIONS(5436),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_DASH_GT] = ACTIONS(5436),
    [anon_sym_EQ] = ACTIONS(5438),
    [anon_sym_COLON] = ACTIONS(5438),
    [anon_sym_PIPE] = ACTIONS(5438),
    [anon_sym_COLON_EQ] = ACTIONS(5436),
    [anon_sym_LPAREN] = ACTIONS(5436),
    [anon_sym_PLUS_EQ] = ACTIONS(5436),
    [anon_sym_DASH_EQ] = ACTIONS(5436),
    [anon_sym_STAR_EQ] = ACTIONS(5436),
    [anon_sym_SLASH_EQ] = ACTIONS(5436),
    [anon_sym_PERCENT_EQ] = ACTIONS(5436),
    [anon_sym_AMP_EQ] = ACTIONS(5436),
    [anon_sym_PIPE_EQ] = ACTIONS(5436),
    [anon_sym_CARET_EQ] = ACTIONS(5436),
    [anon_sym_LT_LT_EQ] = ACTIONS(5436),
    [anon_sym_GT_GT_EQ] = ACTIONS(5436),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5436),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5436),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5436),
    [anon_sym_if] = ACTIONS(5436),
    [anon_sym_SEMI] = ACTIONS(5436),
    [anon_sym_else] = ACTIONS(5436),
    [anon_sym_when] = ACTIONS(5436),
    [anon_sym_in] = ACTIONS(5436),
    [anon_sym_case] = ACTIONS(5436),
    [anon_sym_QMARK] = ACTIONS(5436),
    [anon_sym_PLUS] = ACTIONS(5438),
    [anon_sym_DASH] = ACTIONS(5438),
    [anon_sym_TILDE] = ACTIONS(5438),
    [anon_sym_AMP] = ACTIONS(5438),
    [anon_sym_PIPE_PIPE] = ACTIONS(5438),
    [anon_sym_or_else] = ACTIONS(5436),
    [anon_sym_AMP_AMP] = ACTIONS(5438),
    [anon_sym_GT] = ACTIONS(5438),
    [anon_sym_GT_EQ] = ACTIONS(5436),
    [anon_sym_LT_EQ] = ACTIONS(5436),
    [anon_sym_LT] = ACTIONS(5438),
    [anon_sym_EQ_EQ] = ACTIONS(5436),
    [anon_sym_BANG_EQ] = ACTIONS(5436),
    [anon_sym_TILDE_EQ] = ACTIONS(5436),
    [anon_sym_AMP_TILDE] = ACTIONS(5438),
    [anon_sym_LT_LT] = ACTIONS(5438),
    [anon_sym_GT_GT] = ACTIONS(5438),
    [anon_sym_STAR] = ACTIONS(5438),
    [anon_sym_SLASH] = ACTIONS(5438),
    [anon_sym_PERCENT] = ACTIONS(5438),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5436),
    [anon_sym_DOT] = ACTIONS(5438),
    [anon_sym_LBRACK] = ACTIONS(5436),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5436),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5436),
    [anon_sym_not_in] = ACTIONS(5436),
    [anon_sym_or_return] = ACTIONS(5436),
    [anon_sym_or_continue] = ACTIONS(5436),
    [anon_sym_or_break] = ACTIONS(5436),
    [anon_sym_CARET] = ACTIONS(5438),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5436),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2158] = {
    [ts_builtin_sym_end] = ACTIONS(5444),
    [anon_sym_LBRACE] = ACTIONS(5444),
    [anon_sym_RBRACE] = ACTIONS(5444),
    [anon_sym_COMMA] = ACTIONS(5444),
    [anon_sym_COLON_COLON] = ACTIONS(5444),
    [anon_sym_DASH_GT] = ACTIONS(5444),
    [anon_sym_EQ] = ACTIONS(5446),
    [anon_sym_COLON] = ACTIONS(5446),
    [anon_sym_PIPE] = ACTIONS(5446),
    [anon_sym_COLON_EQ] = ACTIONS(5444),
    [anon_sym_LPAREN] = ACTIONS(5444),
    [anon_sym_PLUS_EQ] = ACTIONS(5444),
    [anon_sym_DASH_EQ] = ACTIONS(5444),
    [anon_sym_STAR_EQ] = ACTIONS(5444),
    [anon_sym_SLASH_EQ] = ACTIONS(5444),
    [anon_sym_PERCENT_EQ] = ACTIONS(5444),
    [anon_sym_AMP_EQ] = ACTIONS(5444),
    [anon_sym_PIPE_EQ] = ACTIONS(5444),
    [anon_sym_CARET_EQ] = ACTIONS(5444),
    [anon_sym_LT_LT_EQ] = ACTIONS(5444),
    [anon_sym_GT_GT_EQ] = ACTIONS(5444),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5444),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5444),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5444),
    [anon_sym_if] = ACTIONS(5444),
    [anon_sym_SEMI] = ACTIONS(5444),
    [anon_sym_else] = ACTIONS(5444),
    [anon_sym_when] = ACTIONS(5444),
    [anon_sym_in] = ACTIONS(5444),
    [anon_sym_case] = ACTIONS(5444),
    [anon_sym_QMARK] = ACTIONS(5444),
    [anon_sym_PLUS] = ACTIONS(5446),
    [anon_sym_DASH] = ACTIONS(5446),
    [anon_sym_TILDE] = ACTIONS(5446),
    [anon_sym_AMP] = ACTIONS(5446),
    [anon_sym_PIPE_PIPE] = ACTIONS(5446),
    [anon_sym_or_else] = ACTIONS(5444),
    [anon_sym_AMP_AMP] = ACTIONS(5446),
    [anon_sym_GT] = ACTIONS(5446),
    [anon_sym_GT_EQ] = ACTIONS(5444),
    [anon_sym_LT_EQ] = ACTIONS(5444),
    [anon_sym_LT] = ACTIONS(5446),
    [anon_sym_EQ_EQ] = ACTIONS(5444),
    [anon_sym_BANG_EQ] = ACTIONS(5444),
    [anon_sym_TILDE_EQ] = ACTIONS(5444),
    [anon_sym_AMP_TILDE] = ACTIONS(5446),
    [anon_sym_LT_LT] = ACTIONS(5446),
    [anon_sym_GT_GT] = ACTIONS(5446),
    [anon_sym_STAR] = ACTIONS(5446),
    [anon_sym_SLASH] = ACTIONS(5446),
    [anon_sym_PERCENT] = ACTIONS(5446),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5444),
    [anon_sym_DOT] = ACTIONS(5446),
    [anon_sym_LBRACK] = ACTIONS(5444),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5444),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5444),
    [anon_sym_not_in] = ACTIONS(5444),
    [anon_sym_or_return] = ACTIONS(5444),
    [anon_sym_or_continue] = ACTIONS(5444),
    [anon_sym_or_break] = ACTIONS(5444),
    [anon_sym_CARET] = ACTIONS(5446),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5444),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2159] = {
    [ts_builtin_sym_end] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(5448),
    [anon_sym_RBRACE] = ACTIONS(5448),
    [anon_sym_COMMA] = ACTIONS(5448),
    [anon_sym_COLON_COLON] = ACTIONS(5448),
    [anon_sym_DASH_GT] = ACTIONS(5448),
    [anon_sym_EQ] = ACTIONS(5450),
    [anon_sym_COLON] = ACTIONS(5450),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_COLON_EQ] = ACTIONS(5448),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_PLUS_EQ] = ACTIONS(5448),
    [anon_sym_DASH_EQ] = ACTIONS(5448),
    [anon_sym_STAR_EQ] = ACTIONS(5448),
    [anon_sym_SLASH_EQ] = ACTIONS(5448),
    [anon_sym_PERCENT_EQ] = ACTIONS(5448),
    [anon_sym_AMP_EQ] = ACTIONS(5448),
    [anon_sym_PIPE_EQ] = ACTIONS(5448),
    [anon_sym_CARET_EQ] = ACTIONS(5448),
    [anon_sym_LT_LT_EQ] = ACTIONS(5448),
    [anon_sym_GT_GT_EQ] = ACTIONS(5448),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5448),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5448),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5448),
    [anon_sym_if] = ACTIONS(5448),
    [anon_sym_SEMI] = ACTIONS(5448),
    [anon_sym_else] = ACTIONS(5448),
    [anon_sym_when] = ACTIONS(5448),
    [anon_sym_in] = ACTIONS(5448),
    [anon_sym_case] = ACTIONS(5448),
    [anon_sym_QMARK] = ACTIONS(5448),
    [anon_sym_PLUS] = ACTIONS(5450),
    [anon_sym_DASH] = ACTIONS(5450),
    [anon_sym_TILDE] = ACTIONS(5450),
    [anon_sym_AMP] = ACTIONS(5450),
    [anon_sym_PIPE_PIPE] = ACTIONS(5450),
    [anon_sym_or_else] = ACTIONS(5448),
    [anon_sym_AMP_AMP] = ACTIONS(5450),
    [anon_sym_GT] = ACTIONS(5450),
    [anon_sym_GT_EQ] = ACTIONS(5448),
    [anon_sym_LT_EQ] = ACTIONS(5448),
    [anon_sym_LT] = ACTIONS(5450),
    [anon_sym_EQ_EQ] = ACTIONS(5448),
    [anon_sym_BANG_EQ] = ACTIONS(5448),
    [anon_sym_TILDE_EQ] = ACTIONS(5448),
    [anon_sym_AMP_TILDE] = ACTIONS(5450),
    [anon_sym_LT_LT] = ACTIONS(5450),
    [anon_sym_GT_GT] = ACTIONS(5450),
    [anon_sym_STAR] = ACTIONS(5450),
    [anon_sym_SLASH] = ACTIONS(6430),
    [anon_sym_PERCENT] = ACTIONS(5450),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5448),
    [anon_sym_DOT] = ACTIONS(5450),
    [anon_sym_LBRACK] = ACTIONS(5448),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5448),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5448),
    [anon_sym_not_in] = ACTIONS(5448),
    [anon_sym_or_return] = ACTIONS(5448),
    [anon_sym_or_continue] = ACTIONS(5448),
    [anon_sym_or_break] = ACTIONS(5448),
    [anon_sym_CARET] = ACTIONS(5450),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5448),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2160] = {
    [ts_builtin_sym_end] = ACTIONS(5452),
    [anon_sym_LBRACE] = ACTIONS(5452),
    [anon_sym_RBRACE] = ACTIONS(5452),
    [anon_sym_COMMA] = ACTIONS(5452),
    [anon_sym_COLON_COLON] = ACTIONS(5452),
    [anon_sym_DASH_GT] = ACTIONS(5452),
    [anon_sym_EQ] = ACTIONS(5454),
    [anon_sym_COLON] = ACTIONS(5454),
    [anon_sym_PIPE] = ACTIONS(5454),
    [anon_sym_COLON_EQ] = ACTIONS(5452),
    [anon_sym_LPAREN] = ACTIONS(5452),
    [anon_sym_PLUS_EQ] = ACTIONS(5452),
    [anon_sym_DASH_EQ] = ACTIONS(5452),
    [anon_sym_STAR_EQ] = ACTIONS(5452),
    [anon_sym_SLASH_EQ] = ACTIONS(5452),
    [anon_sym_PERCENT_EQ] = ACTIONS(5452),
    [anon_sym_AMP_EQ] = ACTIONS(5452),
    [anon_sym_PIPE_EQ] = ACTIONS(5452),
    [anon_sym_CARET_EQ] = ACTIONS(5452),
    [anon_sym_LT_LT_EQ] = ACTIONS(5452),
    [anon_sym_GT_GT_EQ] = ACTIONS(5452),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5452),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5452),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5452),
    [anon_sym_if] = ACTIONS(5452),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym_else] = ACTIONS(5452),
    [anon_sym_when] = ACTIONS(5452),
    [anon_sym_in] = ACTIONS(5452),
    [anon_sym_case] = ACTIONS(5452),
    [anon_sym_QMARK] = ACTIONS(5452),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_DASH] = ACTIONS(5454),
    [anon_sym_TILDE] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_PIPE_PIPE] = ACTIONS(5454),
    [anon_sym_or_else] = ACTIONS(5452),
    [anon_sym_AMP_AMP] = ACTIONS(5454),
    [anon_sym_GT] = ACTIONS(5454),
    [anon_sym_GT_EQ] = ACTIONS(5452),
    [anon_sym_LT_EQ] = ACTIONS(5452),
    [anon_sym_LT] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5452),
    [anon_sym_BANG_EQ] = ACTIONS(5452),
    [anon_sym_TILDE_EQ] = ACTIONS(5452),
    [anon_sym_AMP_TILDE] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5454),
    [anon_sym_STAR] = ACTIONS(5454),
    [anon_sym_SLASH] = ACTIONS(5454),
    [anon_sym_PERCENT] = ACTIONS(5454),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5452),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_LBRACK] = ACTIONS(5452),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5452),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5452),
    [anon_sym_not_in] = ACTIONS(5452),
    [anon_sym_or_return] = ACTIONS(5452),
    [anon_sym_or_continue] = ACTIONS(5452),
    [anon_sym_or_break] = ACTIONS(5452),
    [anon_sym_CARET] = ACTIONS(5454),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5452),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2161] = {
    [ts_builtin_sym_end] = ACTIONS(5464),
    [anon_sym_LBRACE] = ACTIONS(5464),
    [anon_sym_RBRACE] = ACTIONS(5464),
    [anon_sym_COMMA] = ACTIONS(5464),
    [anon_sym_COLON_COLON] = ACTIONS(5464),
    [anon_sym_DASH_GT] = ACTIONS(5464),
    [anon_sym_EQ] = ACTIONS(5466),
    [anon_sym_COLON] = ACTIONS(5466),
    [anon_sym_PIPE] = ACTIONS(5466),
    [anon_sym_COLON_EQ] = ACTIONS(5464),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_PLUS_EQ] = ACTIONS(5464),
    [anon_sym_DASH_EQ] = ACTIONS(5464),
    [anon_sym_STAR_EQ] = ACTIONS(5464),
    [anon_sym_SLASH_EQ] = ACTIONS(5464),
    [anon_sym_PERCENT_EQ] = ACTIONS(5464),
    [anon_sym_AMP_EQ] = ACTIONS(5464),
    [anon_sym_PIPE_EQ] = ACTIONS(5464),
    [anon_sym_CARET_EQ] = ACTIONS(5464),
    [anon_sym_LT_LT_EQ] = ACTIONS(5464),
    [anon_sym_GT_GT_EQ] = ACTIONS(5464),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5464),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5464),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5464),
    [anon_sym_if] = ACTIONS(5464),
    [anon_sym_SEMI] = ACTIONS(5464),
    [anon_sym_else] = ACTIONS(5464),
    [anon_sym_when] = ACTIONS(5464),
    [anon_sym_in] = ACTIONS(5464),
    [anon_sym_case] = ACTIONS(5464),
    [anon_sym_QMARK] = ACTIONS(5464),
    [anon_sym_PLUS] = ACTIONS(5466),
    [anon_sym_DASH] = ACTIONS(5466),
    [anon_sym_TILDE] = ACTIONS(5466),
    [anon_sym_AMP] = ACTIONS(5466),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_or_else] = ACTIONS(5464),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_GT] = ACTIONS(5466),
    [anon_sym_GT_EQ] = ACTIONS(5464),
    [anon_sym_LT_EQ] = ACTIONS(5464),
    [anon_sym_LT] = ACTIONS(5466),
    [anon_sym_EQ_EQ] = ACTIONS(5464),
    [anon_sym_BANG_EQ] = ACTIONS(5464),
    [anon_sym_TILDE_EQ] = ACTIONS(5464),
    [anon_sym_AMP_TILDE] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5466),
    [anon_sym_GT_GT] = ACTIONS(5466),
    [anon_sym_STAR] = ACTIONS(5466),
    [anon_sym_SLASH] = ACTIONS(6430),
    [anon_sym_PERCENT] = ACTIONS(5466),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5464),
    [anon_sym_DOT] = ACTIONS(5466),
    [anon_sym_LBRACK] = ACTIONS(5464),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5464),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5464),
    [anon_sym_not_in] = ACTIONS(5464),
    [anon_sym_or_return] = ACTIONS(5464),
    [anon_sym_or_continue] = ACTIONS(5464),
    [anon_sym_or_break] = ACTIONS(5464),
    [anon_sym_CARET] = ACTIONS(5466),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5464),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2162] = {
    [ts_builtin_sym_end] = ACTIONS(5468),
    [anon_sym_LBRACE] = ACTIONS(5468),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [anon_sym_COMMA] = ACTIONS(5468),
    [anon_sym_COLON_COLON] = ACTIONS(5468),
    [anon_sym_DASH_GT] = ACTIONS(5468),
    [anon_sym_EQ] = ACTIONS(5470),
    [anon_sym_COLON] = ACTIONS(5470),
    [anon_sym_PIPE] = ACTIONS(5470),
    [anon_sym_COLON_EQ] = ACTIONS(5468),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_PLUS_EQ] = ACTIONS(5468),
    [anon_sym_DASH_EQ] = ACTIONS(5468),
    [anon_sym_STAR_EQ] = ACTIONS(5468),
    [anon_sym_SLASH_EQ] = ACTIONS(5468),
    [anon_sym_PERCENT_EQ] = ACTIONS(5468),
    [anon_sym_AMP_EQ] = ACTIONS(5468),
    [anon_sym_PIPE_EQ] = ACTIONS(5468),
    [anon_sym_CARET_EQ] = ACTIONS(5468),
    [anon_sym_LT_LT_EQ] = ACTIONS(5468),
    [anon_sym_GT_GT_EQ] = ACTIONS(5468),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5468),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5468),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5468),
    [anon_sym_if] = ACTIONS(5468),
    [anon_sym_SEMI] = ACTIONS(5468),
    [anon_sym_else] = ACTIONS(5468),
    [anon_sym_when] = ACTIONS(5468),
    [anon_sym_in] = ACTIONS(5468),
    [anon_sym_case] = ACTIONS(5468),
    [anon_sym_QMARK] = ACTIONS(5468),
    [anon_sym_PLUS] = ACTIONS(5470),
    [anon_sym_DASH] = ACTIONS(5470),
    [anon_sym_TILDE] = ACTIONS(5470),
    [anon_sym_AMP] = ACTIONS(5470),
    [anon_sym_PIPE_PIPE] = ACTIONS(5470),
    [anon_sym_or_else] = ACTIONS(5468),
    [anon_sym_AMP_AMP] = ACTIONS(5470),
    [anon_sym_GT] = ACTIONS(5470),
    [anon_sym_GT_EQ] = ACTIONS(5468),
    [anon_sym_LT_EQ] = ACTIONS(5468),
    [anon_sym_LT] = ACTIONS(5470),
    [anon_sym_EQ_EQ] = ACTIONS(5468),
    [anon_sym_BANG_EQ] = ACTIONS(5468),
    [anon_sym_TILDE_EQ] = ACTIONS(5468),
    [anon_sym_AMP_TILDE] = ACTIONS(5470),
    [anon_sym_LT_LT] = ACTIONS(5470),
    [anon_sym_GT_GT] = ACTIONS(5470),
    [anon_sym_STAR] = ACTIONS(5470),
    [anon_sym_SLASH] = ACTIONS(6430),
    [anon_sym_PERCENT] = ACTIONS(5470),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5468),
    [anon_sym_DOT] = ACTIONS(5470),
    [anon_sym_LBRACK] = ACTIONS(5468),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5468),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5468),
    [anon_sym_not_in] = ACTIONS(5468),
    [anon_sym_or_return] = ACTIONS(5468),
    [anon_sym_or_continue] = ACTIONS(5468),
    [anon_sym_or_break] = ACTIONS(5468),
    [anon_sym_CARET] = ACTIONS(5470),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5468),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2163] = {
    [ts_builtin_sym_end] = ACTIONS(5472),
    [anon_sym_LBRACE] = ACTIONS(5472),
    [anon_sym_RBRACE] = ACTIONS(5472),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_COLON_COLON] = ACTIONS(5472),
    [anon_sym_DASH_GT] = ACTIONS(5472),
    [anon_sym_EQ] = ACTIONS(5474),
    [anon_sym_COLON] = ACTIONS(5474),
    [anon_sym_PIPE] = ACTIONS(5474),
    [anon_sym_COLON_EQ] = ACTIONS(5472),
    [anon_sym_LPAREN] = ACTIONS(5472),
    [anon_sym_PLUS_EQ] = ACTIONS(5472),
    [anon_sym_DASH_EQ] = ACTIONS(5472),
    [anon_sym_STAR_EQ] = ACTIONS(5472),
    [anon_sym_SLASH_EQ] = ACTIONS(5472),
    [anon_sym_PERCENT_EQ] = ACTIONS(5472),
    [anon_sym_AMP_EQ] = ACTIONS(5472),
    [anon_sym_PIPE_EQ] = ACTIONS(5472),
    [anon_sym_CARET_EQ] = ACTIONS(5472),
    [anon_sym_LT_LT_EQ] = ACTIONS(5472),
    [anon_sym_GT_GT_EQ] = ACTIONS(5472),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5472),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5472),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5472),
    [anon_sym_if] = ACTIONS(5472),
    [anon_sym_SEMI] = ACTIONS(5472),
    [anon_sym_else] = ACTIONS(5472),
    [anon_sym_when] = ACTIONS(5472),
    [anon_sym_in] = ACTIONS(5472),
    [anon_sym_case] = ACTIONS(5472),
    [anon_sym_QMARK] = ACTIONS(5472),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_DASH] = ACTIONS(5474),
    [anon_sym_TILDE] = ACTIONS(5474),
    [anon_sym_AMP] = ACTIONS(5474),
    [anon_sym_PIPE_PIPE] = ACTIONS(5474),
    [anon_sym_or_else] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5474),
    [anon_sym_GT] = ACTIONS(5474),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5472),
    [anon_sym_LT] = ACTIONS(5474),
    [anon_sym_EQ_EQ] = ACTIONS(5472),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_TILDE_EQ] = ACTIONS(5472),
    [anon_sym_AMP_TILDE] = ACTIONS(5474),
    [anon_sym_LT_LT] = ACTIONS(5474),
    [anon_sym_GT_GT] = ACTIONS(5474),
    [anon_sym_STAR] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5474),
    [anon_sym_PERCENT] = ACTIONS(5474),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5472),
    [anon_sym_DOT] = ACTIONS(5474),
    [anon_sym_LBRACK] = ACTIONS(5472),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5472),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5472),
    [anon_sym_not_in] = ACTIONS(5472),
    [anon_sym_or_return] = ACTIONS(5472),
    [anon_sym_or_continue] = ACTIONS(5472),
    [anon_sym_or_break] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5474),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5472),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2164] = {
    [ts_builtin_sym_end] = ACTIONS(4800),
    [anon_sym_LBRACE] = ACTIONS(6442),
    [anon_sym_RBRACE] = ACTIONS(4800),
    [anon_sym_COMMA] = ACTIONS(4800),
    [anon_sym_COLON_COLON] = ACTIONS(4800),
    [anon_sym_DASH_GT] = ACTIONS(4800),
    [anon_sym_EQ] = ACTIONS(4804),
    [anon_sym_COLON] = ACTIONS(4804),
    [anon_sym_PIPE] = ACTIONS(4804),
    [anon_sym_COLON_EQ] = ACTIONS(4800),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_PLUS_EQ] = ACTIONS(4800),
    [anon_sym_DASH_EQ] = ACTIONS(4800),
    [anon_sym_STAR_EQ] = ACTIONS(4800),
    [anon_sym_SLASH_EQ] = ACTIONS(4800),
    [anon_sym_PERCENT_EQ] = ACTIONS(4800),
    [anon_sym_AMP_EQ] = ACTIONS(4800),
    [anon_sym_PIPE_EQ] = ACTIONS(4800),
    [anon_sym_CARET_EQ] = ACTIONS(4800),
    [anon_sym_LT_LT_EQ] = ACTIONS(4800),
    [anon_sym_GT_GT_EQ] = ACTIONS(4800),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4800),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4800),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4800),
    [anon_sym_if] = ACTIONS(4800),
    [anon_sym_SEMI] = ACTIONS(4800),
    [anon_sym_else] = ACTIONS(4800),
    [anon_sym_when] = ACTIONS(4800),
    [anon_sym_in] = ACTIONS(4800),
    [anon_sym_case] = ACTIONS(4800),
    [anon_sym_QMARK] = ACTIONS(4800),
    [anon_sym_PLUS] = ACTIONS(4804),
    [anon_sym_DASH] = ACTIONS(4804),
    [anon_sym_TILDE] = ACTIONS(4804),
    [anon_sym_AMP] = ACTIONS(4804),
    [anon_sym_PIPE_PIPE] = ACTIONS(4804),
    [anon_sym_or_else] = ACTIONS(4800),
    [anon_sym_AMP_AMP] = ACTIONS(4804),
    [anon_sym_GT] = ACTIONS(4804),
    [anon_sym_GT_EQ] = ACTIONS(4800),
    [anon_sym_LT_EQ] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4804),
    [anon_sym_EQ_EQ] = ACTIONS(4800),
    [anon_sym_BANG_EQ] = ACTIONS(4800),
    [anon_sym_TILDE_EQ] = ACTIONS(4800),
    [anon_sym_AMP_TILDE] = ACTIONS(4804),
    [anon_sym_LT_LT] = ACTIONS(4804),
    [anon_sym_GT_GT] = ACTIONS(4804),
    [anon_sym_STAR] = ACTIONS(4804),
    [anon_sym_SLASH] = ACTIONS(6430),
    [anon_sym_PERCENT] = ACTIONS(4804),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4800),
    [anon_sym_DOT] = ACTIONS(4804),
    [anon_sym_LBRACK] = ACTIONS(4800),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4800),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4800),
    [anon_sym_not_in] = ACTIONS(4800),
    [anon_sym_or_return] = ACTIONS(4800),
    [anon_sym_or_continue] = ACTIONS(4800),
    [anon_sym_or_break] = ACTIONS(4800),
    [anon_sym_CARET] = ACTIONS(4804),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4800),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2165] = {
    [ts_builtin_sym_end] = ACTIONS(4856),
    [anon_sym_LBRACE] = ACTIONS(4856),
    [anon_sym_RBRACE] = ACTIONS(4856),
    [anon_sym_COMMA] = ACTIONS(4856),
    [anon_sym_COLON_COLON] = ACTIONS(4856),
    [anon_sym_DASH_GT] = ACTIONS(4856),
    [anon_sym_EQ] = ACTIONS(4858),
    [anon_sym_COLON] = ACTIONS(4858),
    [anon_sym_PIPE] = ACTIONS(4858),
    [anon_sym_COLON_EQ] = ACTIONS(4856),
    [anon_sym_LPAREN] = ACTIONS(4856),
    [anon_sym_PLUS_EQ] = ACTIONS(4856),
    [anon_sym_DASH_EQ] = ACTIONS(4856),
    [anon_sym_STAR_EQ] = ACTIONS(4856),
    [anon_sym_SLASH_EQ] = ACTIONS(4856),
    [anon_sym_PERCENT_EQ] = ACTIONS(4856),
    [anon_sym_AMP_EQ] = ACTIONS(4856),
    [anon_sym_PIPE_EQ] = ACTIONS(4856),
    [anon_sym_CARET_EQ] = ACTIONS(4856),
    [anon_sym_LT_LT_EQ] = ACTIONS(4856),
    [anon_sym_GT_GT_EQ] = ACTIONS(4856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4856),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4856),
    [anon_sym_if] = ACTIONS(4856),
    [anon_sym_SEMI] = ACTIONS(4856),
    [anon_sym_else] = ACTIONS(4856),
    [anon_sym_when] = ACTIONS(4856),
    [anon_sym_in] = ACTIONS(4856),
    [anon_sym_case] = ACTIONS(4856),
    [anon_sym_QMARK] = ACTIONS(4856),
    [anon_sym_PLUS] = ACTIONS(4858),
    [anon_sym_DASH] = ACTIONS(4858),
    [anon_sym_TILDE] = ACTIONS(4858),
    [anon_sym_AMP] = ACTIONS(4858),
    [anon_sym_PIPE_PIPE] = ACTIONS(4858),
    [anon_sym_or_else] = ACTIONS(4856),
    [anon_sym_AMP_AMP] = ACTIONS(4858),
    [anon_sym_GT] = ACTIONS(4858),
    [anon_sym_GT_EQ] = ACTIONS(4856),
    [anon_sym_LT_EQ] = ACTIONS(4856),
    [anon_sym_LT] = ACTIONS(4858),
    [anon_sym_EQ_EQ] = ACTIONS(4856),
    [anon_sym_BANG_EQ] = ACTIONS(4856),
    [anon_sym_TILDE_EQ] = ACTIONS(4856),
    [anon_sym_AMP_TILDE] = ACTIONS(4858),
    [anon_sym_LT_LT] = ACTIONS(4858),
    [anon_sym_GT_GT] = ACTIONS(4858),
    [anon_sym_STAR] = ACTIONS(4858),
    [anon_sym_SLASH] = ACTIONS(4858),
    [anon_sym_PERCENT] = ACTIONS(4858),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4856),
    [anon_sym_DOT] = ACTIONS(4858),
    [anon_sym_LBRACK] = ACTIONS(4856),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4856),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4856),
    [anon_sym_not_in] = ACTIONS(4856),
    [anon_sym_or_return] = ACTIONS(4856),
    [anon_sym_or_continue] = ACTIONS(4856),
    [anon_sym_or_break] = ACTIONS(4856),
    [anon_sym_CARET] = ACTIONS(4858),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4856),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2166] = {
    [ts_builtin_sym_end] = ACTIONS(5482),
    [anon_sym_LBRACE] = ACTIONS(5482),
    [anon_sym_RBRACE] = ACTIONS(5482),
    [anon_sym_COMMA] = ACTIONS(5482),
    [anon_sym_COLON_COLON] = ACTIONS(5482),
    [anon_sym_DASH_GT] = ACTIONS(5482),
    [anon_sym_EQ] = ACTIONS(5484),
    [anon_sym_COLON] = ACTIONS(5484),
    [anon_sym_PIPE] = ACTIONS(5484),
    [anon_sym_COLON_EQ] = ACTIONS(5482),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_PLUS_EQ] = ACTIONS(5482),
    [anon_sym_DASH_EQ] = ACTIONS(5482),
    [anon_sym_STAR_EQ] = ACTIONS(5482),
    [anon_sym_SLASH_EQ] = ACTIONS(5482),
    [anon_sym_PERCENT_EQ] = ACTIONS(5482),
    [anon_sym_AMP_EQ] = ACTIONS(5482),
    [anon_sym_PIPE_EQ] = ACTIONS(5482),
    [anon_sym_CARET_EQ] = ACTIONS(5482),
    [anon_sym_LT_LT_EQ] = ACTIONS(5482),
    [anon_sym_GT_GT_EQ] = ACTIONS(5482),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5482),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5482),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5482),
    [anon_sym_if] = ACTIONS(5482),
    [anon_sym_SEMI] = ACTIONS(5482),
    [anon_sym_else] = ACTIONS(5482),
    [anon_sym_when] = ACTIONS(5482),
    [anon_sym_in] = ACTIONS(5482),
    [anon_sym_case] = ACTIONS(5482),
    [anon_sym_QMARK] = ACTIONS(5482),
    [anon_sym_PLUS] = ACTIONS(5484),
    [anon_sym_DASH] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5484),
    [anon_sym_AMP] = ACTIONS(5484),
    [anon_sym_PIPE_PIPE] = ACTIONS(5484),
    [anon_sym_or_else] = ACTIONS(5482),
    [anon_sym_AMP_AMP] = ACTIONS(5484),
    [anon_sym_GT] = ACTIONS(5484),
    [anon_sym_GT_EQ] = ACTIONS(5482),
    [anon_sym_LT_EQ] = ACTIONS(5482),
    [anon_sym_LT] = ACTIONS(5484),
    [anon_sym_EQ_EQ] = ACTIONS(5482),
    [anon_sym_BANG_EQ] = ACTIONS(5482),
    [anon_sym_TILDE_EQ] = ACTIONS(5482),
    [anon_sym_AMP_TILDE] = ACTIONS(5484),
    [anon_sym_LT_LT] = ACTIONS(5484),
    [anon_sym_GT_GT] = ACTIONS(5484),
    [anon_sym_STAR] = ACTIONS(5484),
    [anon_sym_SLASH] = ACTIONS(6430),
    [anon_sym_PERCENT] = ACTIONS(5484),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5482),
    [anon_sym_DOT] = ACTIONS(5484),
    [anon_sym_LBRACK] = ACTIONS(5482),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5482),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5482),
    [anon_sym_not_in] = ACTIONS(5482),
    [anon_sym_or_return] = ACTIONS(5482),
    [anon_sym_or_continue] = ACTIONS(5482),
    [anon_sym_or_break] = ACTIONS(5482),
    [anon_sym_CARET] = ACTIONS(5484),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5482),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2167] = {
    [ts_builtin_sym_end] = ACTIONS(4185),
    [anon_sym_LBRACE] = ACTIONS(4185),
    [anon_sym_RBRACE] = ACTIONS(4185),
    [anon_sym_COMMA] = ACTIONS(4185),
    [anon_sym_COLON_COLON] = ACTIONS(4185),
    [anon_sym_DASH_GT] = ACTIONS(4185),
    [anon_sym_EQ] = ACTIONS(4187),
    [anon_sym_COLON] = ACTIONS(4187),
    [anon_sym_PIPE] = ACTIONS(4187),
    [anon_sym_COLON_EQ] = ACTIONS(4185),
    [anon_sym_LPAREN] = ACTIONS(4185),
    [anon_sym_PLUS_EQ] = ACTIONS(4185),
    [anon_sym_DASH_EQ] = ACTIONS(4185),
    [anon_sym_STAR_EQ] = ACTIONS(4185),
    [anon_sym_SLASH_EQ] = ACTIONS(4185),
    [anon_sym_PERCENT_EQ] = ACTIONS(4185),
    [anon_sym_AMP_EQ] = ACTIONS(4185),
    [anon_sym_PIPE_EQ] = ACTIONS(4185),
    [anon_sym_CARET_EQ] = ACTIONS(4185),
    [anon_sym_LT_LT_EQ] = ACTIONS(4185),
    [anon_sym_GT_GT_EQ] = ACTIONS(4185),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4185),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4185),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4185),
    [anon_sym_if] = ACTIONS(4185),
    [anon_sym_SEMI] = ACTIONS(4185),
    [anon_sym_else] = ACTIONS(4185),
    [anon_sym_when] = ACTIONS(4185),
    [anon_sym_in] = ACTIONS(4185),
    [anon_sym_case] = ACTIONS(4185),
    [anon_sym_QMARK] = ACTIONS(4185),
    [anon_sym_PLUS] = ACTIONS(4187),
    [anon_sym_DASH] = ACTIONS(4187),
    [anon_sym_TILDE] = ACTIONS(4187),
    [anon_sym_AMP] = ACTIONS(4187),
    [anon_sym_PIPE_PIPE] = ACTIONS(4187),
    [anon_sym_or_else] = ACTIONS(4185),
    [anon_sym_AMP_AMP] = ACTIONS(4187),
    [anon_sym_GT] = ACTIONS(4187),
    [anon_sym_GT_EQ] = ACTIONS(4185),
    [anon_sym_LT_EQ] = ACTIONS(4185),
    [anon_sym_LT] = ACTIONS(4187),
    [anon_sym_EQ_EQ] = ACTIONS(4185),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_TILDE_EQ] = ACTIONS(4185),
    [anon_sym_AMP_TILDE] = ACTIONS(4187),
    [anon_sym_LT_LT] = ACTIONS(4187),
    [anon_sym_GT_GT] = ACTIONS(4187),
    [anon_sym_STAR] = ACTIONS(4187),
    [anon_sym_SLASH] = ACTIONS(4187),
    [anon_sym_PERCENT] = ACTIONS(4187),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4185),
    [anon_sym_DOT] = ACTIONS(4187),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4185),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4185),
    [anon_sym_not_in] = ACTIONS(4185),
    [anon_sym_or_return] = ACTIONS(4185),
    [anon_sym_or_continue] = ACTIONS(4185),
    [anon_sym_or_break] = ACTIONS(4185),
    [anon_sym_CARET] = ACTIONS(4187),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4185),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2168] = {
    [ts_builtin_sym_end] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(5488),
    [anon_sym_RBRACE] = ACTIONS(5488),
    [anon_sym_COMMA] = ACTIONS(5488),
    [anon_sym_COLON_COLON] = ACTIONS(5488),
    [anon_sym_DASH_GT] = ACTIONS(5488),
    [anon_sym_EQ] = ACTIONS(5490),
    [anon_sym_COLON] = ACTIONS(5490),
    [anon_sym_PIPE] = ACTIONS(5490),
    [anon_sym_COLON_EQ] = ACTIONS(5488),
    [anon_sym_LPAREN] = ACTIONS(5488),
    [anon_sym_PLUS_EQ] = ACTIONS(5488),
    [anon_sym_DASH_EQ] = ACTIONS(5488),
    [anon_sym_STAR_EQ] = ACTIONS(5488),
    [anon_sym_SLASH_EQ] = ACTIONS(5488),
    [anon_sym_PERCENT_EQ] = ACTIONS(5488),
    [anon_sym_AMP_EQ] = ACTIONS(5488),
    [anon_sym_PIPE_EQ] = ACTIONS(5488),
    [anon_sym_CARET_EQ] = ACTIONS(5488),
    [anon_sym_LT_LT_EQ] = ACTIONS(5488),
    [anon_sym_GT_GT_EQ] = ACTIONS(5488),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5488),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5488),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5488),
    [anon_sym_if] = ACTIONS(5488),
    [anon_sym_SEMI] = ACTIONS(5488),
    [anon_sym_else] = ACTIONS(5488),
    [anon_sym_when] = ACTIONS(5488),
    [anon_sym_in] = ACTIONS(5488),
    [anon_sym_case] = ACTIONS(5488),
    [anon_sym_QMARK] = ACTIONS(5488),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_DASH] = ACTIONS(5490),
    [anon_sym_TILDE] = ACTIONS(5490),
    [anon_sym_AMP] = ACTIONS(5490),
    [anon_sym_PIPE_PIPE] = ACTIONS(5490),
    [anon_sym_or_else] = ACTIONS(5488),
    [anon_sym_AMP_AMP] = ACTIONS(5490),
    [anon_sym_GT] = ACTIONS(5490),
    [anon_sym_GT_EQ] = ACTIONS(5488),
    [anon_sym_LT_EQ] = ACTIONS(5488),
    [anon_sym_LT] = ACTIONS(5490),
    [anon_sym_EQ_EQ] = ACTIONS(5488),
    [anon_sym_BANG_EQ] = ACTIONS(5488),
    [anon_sym_TILDE_EQ] = ACTIONS(5488),
    [anon_sym_AMP_TILDE] = ACTIONS(5490),
    [anon_sym_LT_LT] = ACTIONS(5490),
    [anon_sym_GT_GT] = ACTIONS(5490),
    [anon_sym_STAR] = ACTIONS(5490),
    [anon_sym_SLASH] = ACTIONS(5490),
    [anon_sym_PERCENT] = ACTIONS(5490),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5488),
    [anon_sym_DOT] = ACTIONS(5490),
    [anon_sym_LBRACK] = ACTIONS(5488),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5488),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5488),
    [anon_sym_not_in] = ACTIONS(5488),
    [anon_sym_or_return] = ACTIONS(5488),
    [anon_sym_or_continue] = ACTIONS(5488),
    [anon_sym_or_break] = ACTIONS(5488),
    [anon_sym_CARET] = ACTIONS(5490),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5488),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2169] = {
    [ts_builtin_sym_end] = ACTIONS(5496),
    [anon_sym_LBRACE] = ACTIONS(5496),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_COMMA] = ACTIONS(5496),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [anon_sym_DASH_GT] = ACTIONS(5496),
    [anon_sym_EQ] = ACTIONS(5498),
    [anon_sym_COLON] = ACTIONS(5498),
    [anon_sym_PIPE] = ACTIONS(5498),
    [anon_sym_COLON_EQ] = ACTIONS(5496),
    [anon_sym_LPAREN] = ACTIONS(5496),
    [anon_sym_PLUS_EQ] = ACTIONS(5496),
    [anon_sym_DASH_EQ] = ACTIONS(5496),
    [anon_sym_STAR_EQ] = ACTIONS(5496),
    [anon_sym_SLASH_EQ] = ACTIONS(5496),
    [anon_sym_PERCENT_EQ] = ACTIONS(5496),
    [anon_sym_AMP_EQ] = ACTIONS(5496),
    [anon_sym_PIPE_EQ] = ACTIONS(5496),
    [anon_sym_CARET_EQ] = ACTIONS(5496),
    [anon_sym_LT_LT_EQ] = ACTIONS(5496),
    [anon_sym_GT_GT_EQ] = ACTIONS(5496),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5496),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5496),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5496),
    [anon_sym_if] = ACTIONS(5496),
    [anon_sym_SEMI] = ACTIONS(5496),
    [anon_sym_else] = ACTIONS(5496),
    [anon_sym_when] = ACTIONS(5496),
    [anon_sym_in] = ACTIONS(5496),
    [anon_sym_case] = ACTIONS(5496),
    [anon_sym_QMARK] = ACTIONS(5496),
    [anon_sym_PLUS] = ACTIONS(5498),
    [anon_sym_DASH] = ACTIONS(5498),
    [anon_sym_TILDE] = ACTIONS(5498),
    [anon_sym_AMP] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE] = ACTIONS(5498),
    [anon_sym_or_else] = ACTIONS(5496),
    [anon_sym_AMP_AMP] = ACTIONS(5498),
    [anon_sym_GT] = ACTIONS(5498),
    [anon_sym_GT_EQ] = ACTIONS(5496),
    [anon_sym_LT_EQ] = ACTIONS(5496),
    [anon_sym_LT] = ACTIONS(5498),
    [anon_sym_EQ_EQ] = ACTIONS(5496),
    [anon_sym_BANG_EQ] = ACTIONS(5496),
    [anon_sym_TILDE_EQ] = ACTIONS(5496),
    [anon_sym_AMP_TILDE] = ACTIONS(5498),
    [anon_sym_LT_LT] = ACTIONS(5498),
    [anon_sym_GT_GT] = ACTIONS(5498),
    [anon_sym_STAR] = ACTIONS(5498),
    [anon_sym_SLASH] = ACTIONS(5498),
    [anon_sym_PERCENT] = ACTIONS(5498),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5496),
    [anon_sym_DOT] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5496),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5496),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5496),
    [anon_sym_not_in] = ACTIONS(5496),
    [anon_sym_or_return] = ACTIONS(5496),
    [anon_sym_or_continue] = ACTIONS(5496),
    [anon_sym_or_break] = ACTIONS(5496),
    [anon_sym_CARET] = ACTIONS(5498),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5496),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2170] = {
    [ts_builtin_sym_end] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(4691),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [anon_sym_COMMA] = ACTIONS(4691),
    [anon_sym_COLON_COLON] = ACTIONS(4691),
    [anon_sym_DASH_GT] = ACTIONS(4691),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_COLON] = ACTIONS(4693),
    [anon_sym_PIPE] = ACTIONS(4693),
    [anon_sym_COLON_EQ] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_PLUS_EQ] = ACTIONS(4691),
    [anon_sym_DASH_EQ] = ACTIONS(4691),
    [anon_sym_STAR_EQ] = ACTIONS(4691),
    [anon_sym_SLASH_EQ] = ACTIONS(4691),
    [anon_sym_PERCENT_EQ] = ACTIONS(4691),
    [anon_sym_AMP_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_CARET_EQ] = ACTIONS(4691),
    [anon_sym_LT_LT_EQ] = ACTIONS(4691),
    [anon_sym_GT_GT_EQ] = ACTIONS(4691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4691),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4691),
    [anon_sym_if] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_else] = ACTIONS(4691),
    [anon_sym_when] = ACTIONS(4691),
    [anon_sym_in] = ACTIONS(4691),
    [anon_sym_case] = ACTIONS(4691),
    [anon_sym_QMARK] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4693),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_TILDE] = ACTIONS(4693),
    [anon_sym_AMP] = ACTIONS(4693),
    [anon_sym_PIPE_PIPE] = ACTIONS(4693),
    [anon_sym_or_else] = ACTIONS(4691),
    [anon_sym_AMP_AMP] = ACTIONS(4693),
    [anon_sym_GT] = ACTIONS(4693),
    [anon_sym_GT_EQ] = ACTIONS(4691),
    [anon_sym_LT_EQ] = ACTIONS(4691),
    [anon_sym_LT] = ACTIONS(4693),
    [anon_sym_EQ_EQ] = ACTIONS(4691),
    [anon_sym_BANG_EQ] = ACTIONS(4691),
    [anon_sym_TILDE_EQ] = ACTIONS(4691),
    [anon_sym_AMP_TILDE] = ACTIONS(4693),
    [anon_sym_LT_LT] = ACTIONS(4693),
    [anon_sym_GT_GT] = ACTIONS(4693),
    [anon_sym_STAR] = ACTIONS(4693),
    [anon_sym_SLASH] = ACTIONS(4693),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4693),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4691),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4691),
    [anon_sym_not_in] = ACTIONS(4691),
    [anon_sym_or_return] = ACTIONS(4691),
    [anon_sym_or_continue] = ACTIONS(4691),
    [anon_sym_or_break] = ACTIONS(4691),
    [anon_sym_CARET] = ACTIONS(4693),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4691),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2171] = {
    [ts_builtin_sym_end] = ACTIONS(4667),
    [anon_sym_LBRACE] = ACTIONS(4667),
    [anon_sym_RBRACE] = ACTIONS(4667),
    [anon_sym_COMMA] = ACTIONS(4667),
    [anon_sym_COLON_COLON] = ACTIONS(4667),
    [anon_sym_DASH_GT] = ACTIONS(4667),
    [anon_sym_EQ] = ACTIONS(4669),
    [anon_sym_COLON] = ACTIONS(4669),
    [anon_sym_PIPE] = ACTIONS(4669),
    [anon_sym_COLON_EQ] = ACTIONS(4667),
    [anon_sym_LPAREN] = ACTIONS(4667),
    [anon_sym_PLUS_EQ] = ACTIONS(4667),
    [anon_sym_DASH_EQ] = ACTIONS(4667),
    [anon_sym_STAR_EQ] = ACTIONS(4667),
    [anon_sym_SLASH_EQ] = ACTIONS(4667),
    [anon_sym_PERCENT_EQ] = ACTIONS(4667),
    [anon_sym_AMP_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_CARET_EQ] = ACTIONS(4667),
    [anon_sym_LT_LT_EQ] = ACTIONS(4667),
    [anon_sym_GT_GT_EQ] = ACTIONS(4667),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_if] = ACTIONS(4667),
    [anon_sym_SEMI] = ACTIONS(4667),
    [anon_sym_else] = ACTIONS(4667),
    [anon_sym_when] = ACTIONS(4667),
    [anon_sym_in] = ACTIONS(4667),
    [anon_sym_case] = ACTIONS(4667),
    [anon_sym_QMARK] = ACTIONS(4667),
    [anon_sym_PLUS] = ACTIONS(4669),
    [anon_sym_DASH] = ACTIONS(4669),
    [anon_sym_TILDE] = ACTIONS(4669),
    [anon_sym_AMP] = ACTIONS(4669),
    [anon_sym_PIPE_PIPE] = ACTIONS(4669),
    [anon_sym_or_else] = ACTIONS(4667),
    [anon_sym_AMP_AMP] = ACTIONS(4669),
    [anon_sym_GT] = ACTIONS(4669),
    [anon_sym_GT_EQ] = ACTIONS(4667),
    [anon_sym_LT_EQ] = ACTIONS(4667),
    [anon_sym_LT] = ACTIONS(4669),
    [anon_sym_EQ_EQ] = ACTIONS(4667),
    [anon_sym_BANG_EQ] = ACTIONS(4667),
    [anon_sym_TILDE_EQ] = ACTIONS(4667),
    [anon_sym_AMP_TILDE] = ACTIONS(4669),
    [anon_sym_LT_LT] = ACTIONS(4669),
    [anon_sym_GT_GT] = ACTIONS(4669),
    [anon_sym_STAR] = ACTIONS(4669),
    [anon_sym_SLASH] = ACTIONS(4669),
    [anon_sym_PERCENT] = ACTIONS(4669),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4667),
    [anon_sym_DOT] = ACTIONS(4669),
    [anon_sym_LBRACK] = ACTIONS(4667),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4667),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4667),
    [anon_sym_not_in] = ACTIONS(4667),
    [anon_sym_or_return] = ACTIONS(4667),
    [anon_sym_or_continue] = ACTIONS(4667),
    [anon_sym_or_break] = ACTIONS(4667),
    [anon_sym_CARET] = ACTIONS(4669),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4667),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2172] = {
    [ts_builtin_sym_end] = ACTIONS(3671),
    [anon_sym_LBRACE] = ACTIONS(3671),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_COMMA] = ACTIONS(3671),
    [anon_sym_COLON_COLON] = ACTIONS(3671),
    [anon_sym_DASH_GT] = ACTIONS(3671),
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [anon_sym_PIPE] = ACTIONS(3675),
    [anon_sym_COLON_EQ] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(3671),
    [anon_sym_PLUS_EQ] = ACTIONS(3671),
    [anon_sym_DASH_EQ] = ACTIONS(3671),
    [anon_sym_STAR_EQ] = ACTIONS(3671),
    [anon_sym_SLASH_EQ] = ACTIONS(3671),
    [anon_sym_PERCENT_EQ] = ACTIONS(3671),
    [anon_sym_AMP_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_CARET_EQ] = ACTIONS(3671),
    [anon_sym_LT_LT_EQ] = ACTIONS(3671),
    [anon_sym_GT_GT_EQ] = ACTIONS(3671),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_if] = ACTIONS(3671),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_else] = ACTIONS(3671),
    [anon_sym_when] = ACTIONS(3671),
    [anon_sym_in] = ACTIONS(3671),
    [anon_sym_case] = ACTIONS(3671),
    [anon_sym_QMARK] = ACTIONS(3671),
    [anon_sym_PLUS] = ACTIONS(3675),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_TILDE] = ACTIONS(3675),
    [anon_sym_AMP] = ACTIONS(3675),
    [anon_sym_PIPE_PIPE] = ACTIONS(3675),
    [anon_sym_or_else] = ACTIONS(3671),
    [anon_sym_AMP_AMP] = ACTIONS(3675),
    [anon_sym_GT] = ACTIONS(3675),
    [anon_sym_GT_EQ] = ACTIONS(3671),
    [anon_sym_LT_EQ] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(3675),
    [anon_sym_EQ_EQ] = ACTIONS(3671),
    [anon_sym_BANG_EQ] = ACTIONS(3671),
    [anon_sym_TILDE_EQ] = ACTIONS(3671),
    [anon_sym_AMP_TILDE] = ACTIONS(3675),
    [anon_sym_LT_LT] = ACTIONS(3675),
    [anon_sym_GT_GT] = ACTIONS(3675),
    [anon_sym_STAR] = ACTIONS(3675),
    [anon_sym_SLASH] = ACTIONS(3675),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3671),
    [anon_sym_DOT] = ACTIONS(3675),
    [anon_sym_LBRACK] = ACTIONS(3671),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3671),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3671),
    [anon_sym_not_in] = ACTIONS(3671),
    [anon_sym_or_return] = ACTIONS(3671),
    [anon_sym_or_continue] = ACTIONS(3671),
    [anon_sym_or_break] = ACTIONS(3671),
    [anon_sym_CARET] = ACTIONS(3675),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3671),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2173] = {
    [ts_builtin_sym_end] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_COLON_COLON] = ACTIONS(767),
    [anon_sym_DASH_GT] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_COLON] = ACTIONS(773),
    [anon_sym_PIPE] = ACTIONS(773),
    [anon_sym_COLON_EQ] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_PLUS_EQ] = ACTIONS(767),
    [anon_sym_DASH_EQ] = ACTIONS(767),
    [anon_sym_STAR_EQ] = ACTIONS(767),
    [anon_sym_SLASH_EQ] = ACTIONS(767),
    [anon_sym_PERCENT_EQ] = ACTIONS(767),
    [anon_sym_AMP_EQ] = ACTIONS(767),
    [anon_sym_PIPE_EQ] = ACTIONS(767),
    [anon_sym_CARET_EQ] = ACTIONS(767),
    [anon_sym_LT_LT_EQ] = ACTIONS(767),
    [anon_sym_GT_GT_EQ] = ACTIONS(767),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(767),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(767),
    [anon_sym_if] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_else] = ACTIONS(767),
    [anon_sym_when] = ACTIONS(767),
    [anon_sym_in] = ACTIONS(767),
    [anon_sym_case] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_TILDE] = ACTIONS(773),
    [anon_sym_AMP] = ACTIONS(773),
    [anon_sym_PIPE_PIPE] = ACTIONS(773),
    [anon_sym_or_else] = ACTIONS(767),
    [anon_sym_AMP_AMP] = ACTIONS(773),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_GT_EQ] = ACTIONS(767),
    [anon_sym_LT_EQ] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_EQ_EQ] = ACTIONS(767),
    [anon_sym_BANG_EQ] = ACTIONS(767),
    [anon_sym_TILDE_EQ] = ACTIONS(767),
    [anon_sym_AMP_TILDE] = ACTIONS(773),
    [anon_sym_LT_LT] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(773),
    [anon_sym_STAR] = ACTIONS(773),
    [anon_sym_SLASH] = ACTIONS(773),
    [anon_sym_PERCENT] = ACTIONS(773),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(773),
    [anon_sym_LBRACK] = ACTIONS(767),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(767),
    [anon_sym_DOT_DOT_LT] = ACTIONS(767),
    [anon_sym_not_in] = ACTIONS(767),
    [anon_sym_or_return] = ACTIONS(767),
    [anon_sym_or_continue] = ACTIONS(767),
    [anon_sym_or_break] = ACTIONS(767),
    [anon_sym_CARET] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(767),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2174] = {
    [ts_builtin_sym_end] = ACTIONS(5554),
    [anon_sym_LBRACE] = ACTIONS(5554),
    [anon_sym_RBRACE] = ACTIONS(5554),
    [anon_sym_COMMA] = ACTIONS(5554),
    [anon_sym_COLON_COLON] = ACTIONS(5554),
    [anon_sym_DASH_GT] = ACTIONS(5554),
    [anon_sym_EQ] = ACTIONS(5556),
    [anon_sym_COLON] = ACTIONS(5556),
    [anon_sym_PIPE] = ACTIONS(5556),
    [anon_sym_COLON_EQ] = ACTIONS(5554),
    [anon_sym_LPAREN] = ACTIONS(5554),
    [anon_sym_PLUS_EQ] = ACTIONS(5554),
    [anon_sym_DASH_EQ] = ACTIONS(5554),
    [anon_sym_STAR_EQ] = ACTIONS(5554),
    [anon_sym_SLASH_EQ] = ACTIONS(5554),
    [anon_sym_PERCENT_EQ] = ACTIONS(5554),
    [anon_sym_AMP_EQ] = ACTIONS(5554),
    [anon_sym_PIPE_EQ] = ACTIONS(5554),
    [anon_sym_CARET_EQ] = ACTIONS(5554),
    [anon_sym_LT_LT_EQ] = ACTIONS(5554),
    [anon_sym_GT_GT_EQ] = ACTIONS(5554),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5554),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5554),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5554),
    [anon_sym_if] = ACTIONS(5554),
    [anon_sym_SEMI] = ACTIONS(5554),
    [anon_sym_else] = ACTIONS(5554),
    [anon_sym_when] = ACTIONS(5554),
    [anon_sym_in] = ACTIONS(5554),
    [anon_sym_case] = ACTIONS(5554),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_PLUS] = ACTIONS(5556),
    [anon_sym_DASH] = ACTIONS(5556),
    [anon_sym_TILDE] = ACTIONS(5556),
    [anon_sym_AMP] = ACTIONS(5556),
    [anon_sym_PIPE_PIPE] = ACTIONS(5556),
    [anon_sym_or_else] = ACTIONS(5554),
    [anon_sym_AMP_AMP] = ACTIONS(5556),
    [anon_sym_GT] = ACTIONS(5556),
    [anon_sym_GT_EQ] = ACTIONS(5554),
    [anon_sym_LT_EQ] = ACTIONS(5554),
    [anon_sym_LT] = ACTIONS(5556),
    [anon_sym_EQ_EQ] = ACTIONS(5554),
    [anon_sym_BANG_EQ] = ACTIONS(5554),
    [anon_sym_TILDE_EQ] = ACTIONS(5554),
    [anon_sym_AMP_TILDE] = ACTIONS(5556),
    [anon_sym_LT_LT] = ACTIONS(5556),
    [anon_sym_GT_GT] = ACTIONS(5556),
    [anon_sym_STAR] = ACTIONS(5556),
    [anon_sym_SLASH] = ACTIONS(5556),
    [anon_sym_PERCENT] = ACTIONS(5556),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5554),
    [anon_sym_DOT] = ACTIONS(5556),
    [anon_sym_LBRACK] = ACTIONS(5554),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5554),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5554),
    [anon_sym_not_in] = ACTIONS(5554),
    [anon_sym_or_return] = ACTIONS(5554),
    [anon_sym_or_continue] = ACTIONS(5554),
    [anon_sym_or_break] = ACTIONS(5554),
    [anon_sym_CARET] = ACTIONS(5556),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5554),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2175] = {
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_LBRACE] = ACTIONS(4023),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_COLON_COLON] = ACTIONS(4023),
    [anon_sym_DASH_GT] = ACTIONS(4023),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [anon_sym_PIPE] = ACTIONS(4025),
    [anon_sym_COLON_EQ] = ACTIONS(4023),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [anon_sym_PLUS_EQ] = ACTIONS(4023),
    [anon_sym_DASH_EQ] = ACTIONS(4023),
    [anon_sym_STAR_EQ] = ACTIONS(4023),
    [anon_sym_SLASH_EQ] = ACTIONS(4023),
    [anon_sym_PERCENT_EQ] = ACTIONS(4023),
    [anon_sym_AMP_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_CARET_EQ] = ACTIONS(4023),
    [anon_sym_LT_LT_EQ] = ACTIONS(4023),
    [anon_sym_GT_GT_EQ] = ACTIONS(4023),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4023),
    [anon_sym_when] = ACTIONS(4023),
    [anon_sym_in] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4023),
    [anon_sym_QMARK] = ACTIONS(4023),
    [anon_sym_PLUS] = ACTIONS(4025),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_TILDE] = ACTIONS(4025),
    [anon_sym_AMP] = ACTIONS(4025),
    [anon_sym_PIPE_PIPE] = ACTIONS(4025),
    [anon_sym_or_else] = ACTIONS(4023),
    [anon_sym_AMP_AMP] = ACTIONS(4025),
    [anon_sym_GT] = ACTIONS(4025),
    [anon_sym_GT_EQ] = ACTIONS(4023),
    [anon_sym_LT_EQ] = ACTIONS(4023),
    [anon_sym_LT] = ACTIONS(4025),
    [anon_sym_EQ_EQ] = ACTIONS(4023),
    [anon_sym_BANG_EQ] = ACTIONS(4023),
    [anon_sym_TILDE_EQ] = ACTIONS(4023),
    [anon_sym_AMP_TILDE] = ACTIONS(4025),
    [anon_sym_LT_LT] = ACTIONS(4025),
    [anon_sym_GT_GT] = ACTIONS(4025),
    [anon_sym_STAR] = ACTIONS(4025),
    [anon_sym_SLASH] = ACTIONS(4025),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4023),
    [anon_sym_DOT] = ACTIONS(4025),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4023),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4023),
    [anon_sym_not_in] = ACTIONS(4023),
    [anon_sym_or_return] = ACTIONS(4023),
    [anon_sym_or_continue] = ACTIONS(4023),
    [anon_sym_or_break] = ACTIONS(4023),
    [anon_sym_CARET] = ACTIONS(4025),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4023),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2176] = {
    [ts_builtin_sym_end] = ACTIONS(4083),
    [anon_sym_LBRACE] = ACTIONS(4083),
    [anon_sym_RBRACE] = ACTIONS(4083),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_else] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(4083),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2177] = {
    [sym_block] = STATE(2497),
    [anon_sym_LBRACE] = ACTIONS(6161),
    [anon_sym_COMMA] = ACTIONS(4083),
    [anon_sym_COLON_COLON] = ACTIONS(4083),
    [anon_sym_DASH_GT] = ACTIONS(4083),
    [anon_sym_where] = ACTIONS(4083),
    [anon_sym_EQ] = ACTIONS(4085),
    [anon_sym_COLON] = ACTIONS(4085),
    [anon_sym_PIPE] = ACTIONS(4085),
    [anon_sym_COLON_EQ] = ACTIONS(4083),
    [anon_sym_LPAREN] = ACTIONS(4083),
    [anon_sym_PLUS_EQ] = ACTIONS(4083),
    [anon_sym_DASH_EQ] = ACTIONS(4083),
    [anon_sym_STAR_EQ] = ACTIONS(4083),
    [anon_sym_SLASH_EQ] = ACTIONS(4083),
    [anon_sym_PERCENT_EQ] = ACTIONS(4083),
    [anon_sym_AMP_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_CARET_EQ] = ACTIONS(4083),
    [anon_sym_LT_LT_EQ] = ACTIONS(4083),
    [anon_sym_GT_GT_EQ] = ACTIONS(4083),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_SEMI] = ACTIONS(4083),
    [anon_sym_do] = ACTIONS(4083),
    [anon_sym_when] = ACTIONS(4083),
    [anon_sym_in] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_AMP] = ACTIONS(4085),
    [anon_sym_PIPE_PIPE] = ACTIONS(4085),
    [anon_sym_or_else] = ACTIONS(4083),
    [anon_sym_AMP_AMP] = ACTIONS(4085),
    [anon_sym_GT] = ACTIONS(4085),
    [anon_sym_GT_EQ] = ACTIONS(4083),
    [anon_sym_LT_EQ] = ACTIONS(4083),
    [anon_sym_LT] = ACTIONS(4085),
    [anon_sym_EQ_EQ] = ACTIONS(4083),
    [anon_sym_BANG_EQ] = ACTIONS(4083),
    [anon_sym_TILDE_EQ] = ACTIONS(4083),
    [anon_sym_AMP_TILDE] = ACTIONS(4085),
    [anon_sym_LT_LT] = ACTIONS(4085),
    [anon_sym_GT_GT] = ACTIONS(4085),
    [anon_sym_STAR] = ACTIONS(4085),
    [anon_sym_SLASH] = ACTIONS(4085),
    [anon_sym_PERCENT] = ACTIONS(4085),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4083),
    [anon_sym_DOT] = ACTIONS(4085),
    [anon_sym_LBRACK] = ACTIONS(4083),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4083),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4083),
    [anon_sym_not_in] = ACTIONS(4083),
    [anon_sym_or_return] = ACTIONS(4083),
    [anon_sym_or_continue] = ACTIONS(4083),
    [anon_sym_or_break] = ACTIONS(4083),
    [anon_sym_CARET] = ACTIONS(4085),
    [sym_uninitialized] = ACTIONS(6165),
    [sym_tag] = ACTIONS(4083),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2178] = {
    [ts_builtin_sym_end] = ACTIONS(3415),
    [anon_sym_LBRACE] = ACTIONS(3415),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_COMMA] = ACTIONS(3415),
    [anon_sym_COLON_COLON] = ACTIONS(3415),
    [anon_sym_DASH_GT] = ACTIONS(3415),
    [anon_sym_EQ] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_COLON_EQ] = ACTIONS(3415),
    [anon_sym_LPAREN] = ACTIONS(3415),
    [anon_sym_PLUS_EQ] = ACTIONS(3415),
    [anon_sym_DASH_EQ] = ACTIONS(3415),
    [anon_sym_STAR_EQ] = ACTIONS(3415),
    [anon_sym_SLASH_EQ] = ACTIONS(3415),
    [anon_sym_PERCENT_EQ] = ACTIONS(3415),
    [anon_sym_AMP_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_CARET_EQ] = ACTIONS(3415),
    [anon_sym_LT_LT_EQ] = ACTIONS(3415),
    [anon_sym_GT_GT_EQ] = ACTIONS(3415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_if] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(3415),
    [anon_sym_else] = ACTIONS(3415),
    [anon_sym_when] = ACTIONS(3415),
    [anon_sym_in] = ACTIONS(3415),
    [anon_sym_case] = ACTIONS(3415),
    [anon_sym_QMARK] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_TILDE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_or_else] = ACTIONS(3415),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_GT] = ACTIONS(3421),
    [anon_sym_GT_EQ] = ACTIONS(3415),
    [anon_sym_LT_EQ] = ACTIONS(3415),
    [anon_sym_LT] = ACTIONS(3421),
    [anon_sym_EQ_EQ] = ACTIONS(3415),
    [anon_sym_BANG_EQ] = ACTIONS(3415),
    [anon_sym_TILDE_EQ] = ACTIONS(3415),
    [anon_sym_AMP_TILDE] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(3421),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_STAR] = ACTIONS(3421),
    [anon_sym_SLASH] = ACTIONS(3421),
    [anon_sym_PERCENT] = ACTIONS(3421),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3415),
    [anon_sym_DOT] = ACTIONS(3421),
    [anon_sym_LBRACK] = ACTIONS(3415),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3415),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3415),
    [anon_sym_not_in] = ACTIONS(3415),
    [anon_sym_or_return] = ACTIONS(3415),
    [anon_sym_or_continue] = ACTIONS(3415),
    [anon_sym_or_break] = ACTIONS(3415),
    [anon_sym_CARET] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3415),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2179] = {
    [aux_sym_struct_type_repeat2] = STATE(2179),
    [anon_sym_LBRACE] = ACTIONS(6444),
    [anon_sym_COMMA] = ACTIONS(4618),
    [anon_sym_COLON_COLON] = ACTIONS(4618),
    [anon_sym_DASH_GT] = ACTIONS(4618),
    [anon_sym_where] = ACTIONS(4618),
    [anon_sym_EQ] = ACTIONS(4623),
    [anon_sym_COLON] = ACTIONS(4623),
    [anon_sym_PIPE] = ACTIONS(4623),
    [anon_sym_COLON_EQ] = ACTIONS(4618),
    [anon_sym_LPAREN] = ACTIONS(4618),
    [anon_sym_PLUS_EQ] = ACTIONS(4618),
    [anon_sym_DASH_EQ] = ACTIONS(4618),
    [anon_sym_STAR_EQ] = ACTIONS(4618),
    [anon_sym_SLASH_EQ] = ACTIONS(4618),
    [anon_sym_PERCENT_EQ] = ACTIONS(4618),
    [anon_sym_AMP_EQ] = ACTIONS(4618),
    [anon_sym_PIPE_EQ] = ACTIONS(4618),
    [anon_sym_CARET_EQ] = ACTIONS(4618),
    [anon_sym_LT_LT_EQ] = ACTIONS(4618),
    [anon_sym_GT_GT_EQ] = ACTIONS(4618),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4618),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4618),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4618),
    [anon_sym_if] = ACTIONS(4618),
    [anon_sym_SEMI] = ACTIONS(4618),
    [anon_sym_do] = ACTIONS(4618),
    [anon_sym_when] = ACTIONS(4618),
    [anon_sym_in] = ACTIONS(4618),
    [anon_sym_QMARK] = ACTIONS(4618),
    [anon_sym_PLUS] = ACTIONS(4623),
    [anon_sym_DASH] = ACTIONS(4623),
    [anon_sym_TILDE] = ACTIONS(4623),
    [anon_sym_AMP] = ACTIONS(4623),
    [anon_sym_PIPE_PIPE] = ACTIONS(4623),
    [anon_sym_or_else] = ACTIONS(4618),
    [anon_sym_AMP_AMP] = ACTIONS(4623),
    [anon_sym_GT] = ACTIONS(4623),
    [anon_sym_GT_EQ] = ACTIONS(4618),
    [anon_sym_LT_EQ] = ACTIONS(4618),
    [anon_sym_LT] = ACTIONS(4623),
    [anon_sym_EQ_EQ] = ACTIONS(4618),
    [anon_sym_BANG_EQ] = ACTIONS(4618),
    [anon_sym_TILDE_EQ] = ACTIONS(4618),
    [anon_sym_AMP_TILDE] = ACTIONS(4623),
    [anon_sym_LT_LT] = ACTIONS(4623),
    [anon_sym_GT_GT] = ACTIONS(4623),
    [anon_sym_STAR] = ACTIONS(4623),
    [anon_sym_SLASH] = ACTIONS(4623),
    [anon_sym_PERCENT] = ACTIONS(4623),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4618),
    [anon_sym_DOT] = ACTIONS(4623),
    [anon_sym_LBRACK] = ACTIONS(4618),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4618),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4618),
    [anon_sym_not_in] = ACTIONS(4618),
    [anon_sym_or_return] = ACTIONS(4618),
    [anon_sym_or_continue] = ACTIONS(4618),
    [anon_sym_or_break] = ACTIONS(4618),
    [anon_sym_CARET] = ACTIONS(4623),
    [sym_uninitialized] = ACTIONS(4618),
    [sym_tag] = ACTIONS(4618),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2180] = {
    [ts_builtin_sym_end] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(6447),
    [anon_sym_RBRACE] = ACTIONS(5378),
    [anon_sym_COMMA] = ACTIONS(5378),
    [anon_sym_COLON_COLON] = ACTIONS(5378),
    [anon_sym_DASH_GT] = ACTIONS(5378),
    [anon_sym_EQ] = ACTIONS(5380),
    [anon_sym_COLON] = ACTIONS(5380),
    [anon_sym_PIPE] = ACTIONS(5380),
    [anon_sym_COLON_EQ] = ACTIONS(5378),
    [anon_sym_LPAREN] = ACTIONS(5378),
    [anon_sym_PLUS_EQ] = ACTIONS(5378),
    [anon_sym_DASH_EQ] = ACTIONS(5378),
    [anon_sym_STAR_EQ] = ACTIONS(5378),
    [anon_sym_SLASH_EQ] = ACTIONS(5378),
    [anon_sym_PERCENT_EQ] = ACTIONS(5378),
    [anon_sym_AMP_EQ] = ACTIONS(5378),
    [anon_sym_PIPE_EQ] = ACTIONS(5378),
    [anon_sym_CARET_EQ] = ACTIONS(5378),
    [anon_sym_LT_LT_EQ] = ACTIONS(5378),
    [anon_sym_GT_GT_EQ] = ACTIONS(5378),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5378),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5378),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5378),
    [anon_sym_if] = ACTIONS(5378),
    [anon_sym_SEMI] = ACTIONS(5378),
    [anon_sym_else] = ACTIONS(5378),
    [anon_sym_when] = ACTIONS(5378),
    [anon_sym_in] = ACTIONS(5378),
    [anon_sym_case] = ACTIONS(5378),
    [anon_sym_QMARK] = ACTIONS(5378),
    [anon_sym_PLUS] = ACTIONS(5380),
    [anon_sym_DASH] = ACTIONS(5380),
    [anon_sym_TILDE] = ACTIONS(5380),
    [anon_sym_AMP] = ACTIONS(5380),
    [anon_sym_PIPE_PIPE] = ACTIONS(5380),
    [anon_sym_or_else] = ACTIONS(5378),
    [anon_sym_AMP_AMP] = ACTIONS(5380),
    [anon_sym_GT] = ACTIONS(5380),
    [anon_sym_GT_EQ] = ACTIONS(5378),
    [anon_sym_LT_EQ] = ACTIONS(5378),
    [anon_sym_LT] = ACTIONS(5380),
    [anon_sym_EQ_EQ] = ACTIONS(5378),
    [anon_sym_BANG_EQ] = ACTIONS(5378),
    [anon_sym_TILDE_EQ] = ACTIONS(5378),
    [anon_sym_AMP_TILDE] = ACTIONS(5380),
    [anon_sym_LT_LT] = ACTIONS(5380),
    [anon_sym_GT_GT] = ACTIONS(5380),
    [anon_sym_STAR] = ACTIONS(5380),
    [anon_sym_SLASH] = ACTIONS(5380),
    [anon_sym_PERCENT] = ACTIONS(5380),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5378),
    [anon_sym_DOT] = ACTIONS(5380),
    [anon_sym_LBRACK] = ACTIONS(5378),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5378),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5378),
    [anon_sym_not_in] = ACTIONS(5378),
    [anon_sym_or_return] = ACTIONS(5378),
    [anon_sym_or_continue] = ACTIONS(5378),
    [anon_sym_or_break] = ACTIONS(5378),
    [anon_sym_CARET] = ACTIONS(5380),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5378),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2181] = {
    [ts_builtin_sym_end] = ACTIONS(5542),
    [anon_sym_LBRACE] = ACTIONS(5542),
    [anon_sym_RBRACE] = ACTIONS(5542),
    [anon_sym_COMMA] = ACTIONS(5542),
    [anon_sym_COLON_COLON] = ACTIONS(5542),
    [anon_sym_DASH_GT] = ACTIONS(5542),
    [anon_sym_EQ] = ACTIONS(5544),
    [anon_sym_COLON] = ACTIONS(5544),
    [anon_sym_PIPE] = ACTIONS(5544),
    [anon_sym_COLON_EQ] = ACTIONS(5542),
    [anon_sym_LPAREN] = ACTIONS(5542),
    [anon_sym_PLUS_EQ] = ACTIONS(5542),
    [anon_sym_DASH_EQ] = ACTIONS(5542),
    [anon_sym_STAR_EQ] = ACTIONS(5542),
    [anon_sym_SLASH_EQ] = ACTIONS(5542),
    [anon_sym_PERCENT_EQ] = ACTIONS(5542),
    [anon_sym_AMP_EQ] = ACTIONS(5542),
    [anon_sym_PIPE_EQ] = ACTIONS(5542),
    [anon_sym_CARET_EQ] = ACTIONS(5542),
    [anon_sym_LT_LT_EQ] = ACTIONS(5542),
    [anon_sym_GT_GT_EQ] = ACTIONS(5542),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5542),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5542),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5542),
    [anon_sym_if] = ACTIONS(5542),
    [anon_sym_SEMI] = ACTIONS(5542),
    [anon_sym_else] = ACTIONS(5542),
    [anon_sym_when] = ACTIONS(5542),
    [anon_sym_in] = ACTIONS(5542),
    [anon_sym_case] = ACTIONS(5542),
    [anon_sym_QMARK] = ACTIONS(5542),
    [anon_sym_PLUS] = ACTIONS(5544),
    [anon_sym_DASH] = ACTIONS(5544),
    [anon_sym_TILDE] = ACTIONS(5544),
    [anon_sym_AMP] = ACTIONS(5544),
    [anon_sym_PIPE_PIPE] = ACTIONS(5544),
    [anon_sym_or_else] = ACTIONS(5542),
    [anon_sym_AMP_AMP] = ACTIONS(5544),
    [anon_sym_GT] = ACTIONS(5544),
    [anon_sym_GT_EQ] = ACTIONS(5542),
    [anon_sym_LT_EQ] = ACTIONS(5542),
    [anon_sym_LT] = ACTIONS(5544),
    [anon_sym_EQ_EQ] = ACTIONS(5542),
    [anon_sym_BANG_EQ] = ACTIONS(5542),
    [anon_sym_TILDE_EQ] = ACTIONS(5542),
    [anon_sym_AMP_TILDE] = ACTIONS(5544),
    [anon_sym_LT_LT] = ACTIONS(5544),
    [anon_sym_GT_GT] = ACTIONS(5544),
    [anon_sym_STAR] = ACTIONS(5544),
    [anon_sym_SLASH] = ACTIONS(5544),
    [anon_sym_PERCENT] = ACTIONS(5544),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5542),
    [anon_sym_DOT] = ACTIONS(5544),
    [anon_sym_LBRACK] = ACTIONS(5542),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5542),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5542),
    [anon_sym_not_in] = ACTIONS(5542),
    [anon_sym_or_return] = ACTIONS(5542),
    [anon_sym_or_continue] = ACTIONS(5542),
    [anon_sym_or_break] = ACTIONS(5542),
    [anon_sym_CARET] = ACTIONS(5544),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5542),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2182] = {
    [ts_builtin_sym_end] = ACTIONS(3781),
    [anon_sym_LBRACE] = ACTIONS(3781),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_COMMA] = ACTIONS(3781),
    [anon_sym_COLON_COLON] = ACTIONS(3781),
    [anon_sym_DASH_GT] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(3785),
    [anon_sym_COLON] = ACTIONS(3785),
    [anon_sym_PIPE] = ACTIONS(3785),
    [anon_sym_COLON_EQ] = ACTIONS(3781),
    [anon_sym_LPAREN] = ACTIONS(3781),
    [anon_sym_PLUS_EQ] = ACTIONS(3781),
    [anon_sym_DASH_EQ] = ACTIONS(3781),
    [anon_sym_STAR_EQ] = ACTIONS(3781),
    [anon_sym_SLASH_EQ] = ACTIONS(3781),
    [anon_sym_PERCENT_EQ] = ACTIONS(3781),
    [anon_sym_AMP_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_CARET_EQ] = ACTIONS(3781),
    [anon_sym_LT_LT_EQ] = ACTIONS(3781),
    [anon_sym_GT_GT_EQ] = ACTIONS(3781),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_if] = ACTIONS(3781),
    [anon_sym_SEMI] = ACTIONS(3781),
    [anon_sym_else] = ACTIONS(3781),
    [anon_sym_when] = ACTIONS(3781),
    [anon_sym_in] = ACTIONS(3781),
    [anon_sym_case] = ACTIONS(3781),
    [anon_sym_QMARK] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(3785),
    [anon_sym_DASH] = ACTIONS(3785),
    [anon_sym_TILDE] = ACTIONS(3785),
    [anon_sym_AMP] = ACTIONS(3785),
    [anon_sym_PIPE_PIPE] = ACTIONS(3785),
    [anon_sym_or_else] = ACTIONS(3781),
    [anon_sym_AMP_AMP] = ACTIONS(3785),
    [anon_sym_GT] = ACTIONS(3785),
    [anon_sym_GT_EQ] = ACTIONS(3781),
    [anon_sym_LT_EQ] = ACTIONS(3781),
    [anon_sym_LT] = ACTIONS(3785),
    [anon_sym_EQ_EQ] = ACTIONS(3781),
    [anon_sym_BANG_EQ] = ACTIONS(3781),
    [anon_sym_TILDE_EQ] = ACTIONS(3781),
    [anon_sym_AMP_TILDE] = ACTIONS(3785),
    [anon_sym_LT_LT] = ACTIONS(3785),
    [anon_sym_GT_GT] = ACTIONS(3785),
    [anon_sym_STAR] = ACTIONS(3785),
    [anon_sym_SLASH] = ACTIONS(3785),
    [anon_sym_PERCENT] = ACTIONS(3785),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(3781),
    [anon_sym_DOT] = ACTIONS(3785),
    [anon_sym_LBRACK] = ACTIONS(3781),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(3781),
    [anon_sym_DOT_DOT_LT] = ACTIONS(3781),
    [anon_sym_not_in] = ACTIONS(3781),
    [anon_sym_or_return] = ACTIONS(3781),
    [anon_sym_or_continue] = ACTIONS(3781),
    [anon_sym_or_break] = ACTIONS(3781),
    [anon_sym_CARET] = ACTIONS(3785),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(3781),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2183] = {
    [ts_builtin_sym_end] = ACTIONS(5526),
    [anon_sym_LBRACE] = ACTIONS(5526),
    [anon_sym_RBRACE] = ACTIONS(5526),
    [anon_sym_COMMA] = ACTIONS(5526),
    [anon_sym_COLON_COLON] = ACTIONS(5526),
    [anon_sym_DASH_GT] = ACTIONS(5526),
    [anon_sym_EQ] = ACTIONS(5528),
    [anon_sym_COLON] = ACTIONS(5528),
    [anon_sym_PIPE] = ACTIONS(5528),
    [anon_sym_COLON_EQ] = ACTIONS(5526),
    [anon_sym_LPAREN] = ACTIONS(5526),
    [anon_sym_PLUS_EQ] = ACTIONS(5526),
    [anon_sym_DASH_EQ] = ACTIONS(5526),
    [anon_sym_STAR_EQ] = ACTIONS(5526),
    [anon_sym_SLASH_EQ] = ACTIONS(5526),
    [anon_sym_PERCENT_EQ] = ACTIONS(5526),
    [anon_sym_AMP_EQ] = ACTIONS(5526),
    [anon_sym_PIPE_EQ] = ACTIONS(5526),
    [anon_sym_CARET_EQ] = ACTIONS(5526),
    [anon_sym_LT_LT_EQ] = ACTIONS(5526),
    [anon_sym_GT_GT_EQ] = ACTIONS(5526),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5526),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5526),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(5526),
    [anon_sym_if] = ACTIONS(5526),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_else] = ACTIONS(5526),
    [anon_sym_when] = ACTIONS(5526),
    [anon_sym_in] = ACTIONS(5526),
    [anon_sym_case] = ACTIONS(5526),
    [anon_sym_QMARK] = ACTIONS(5526),
    [anon_sym_PLUS] = ACTIONS(5528),
    [anon_sym_DASH] = ACTIONS(5528),
    [anon_sym_TILDE] = ACTIONS(5528),
    [anon_sym_AMP] = ACTIONS(5528),
    [anon_sym_PIPE_PIPE] = ACTIONS(5528),
    [anon_sym_or_else] = ACTIONS(5526),
    [anon_sym_AMP_AMP] = ACTIONS(5528),
    [anon_sym_GT] = ACTIONS(5528),
    [anon_sym_GT_EQ] = ACTIONS(5526),
    [anon_sym_LT_EQ] = ACTIONS(5526),
    [anon_sym_LT] = ACTIONS(5528),
    [anon_sym_EQ_EQ] = ACTIONS(5526),
    [anon_sym_BANG_EQ] = ACTIONS(5526),
    [anon_sym_TILDE_EQ] = ACTIONS(5526),
    [anon_sym_AMP_TILDE] = ACTIONS(5528),
    [anon_sym_LT_LT] = ACTIONS(5528),
    [anon_sym_GT_GT] = ACTIONS(5528),
    [anon_sym_STAR] = ACTIONS(5528),
    [anon_sym_SLASH] = ACTIONS(5528),
    [anon_sym_PERCENT] = ACTIONS(5528),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(5526),
    [anon_sym_DOT] = ACTIONS(5528),
    [anon_sym_LBRACK] = ACTIONS(5526),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(5526),
    [anon_sym_DOT_DOT_LT] = ACTIONS(5526),
    [anon_sym_not_in] = ACTIONS(5526),
    [anon_sym_or_return] = ACTIONS(5526),
    [anon_sym_or_continue] = ACTIONS(5526),
    [anon_sym_or_break] = ACTIONS(5526),
    [anon_sym_CARET] = ACTIONS(5528),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(5526),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2184] = {
    [ts_builtin_sym_end] = ACTIONS(67),
    [sym_identifier] = ACTIONS(6449),
    [anon_sym_RBRACE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(67),
    [anon_sym_EQ] = ACTIONS(71),
    [anon_sym_COLON] = ACTIONS(71),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_COLON_EQ] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(6451),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [anon_sym_DASH_EQ] = ACTIONS(67),
    [anon_sym_STAR_EQ] = ACTIONS(67),
    [anon_sym_SLASH_EQ] = ACTIONS(67),
    [anon_sym_PERCENT_EQ] = ACTIONS(67),
    [anon_sym_AMP_EQ] = ACTIONS(67),
    [anon_sym_PIPE_EQ] = ACTIONS(67),
    [anon_sym_CARET_EQ] = ACTIONS(67),
    [anon_sym_LT_LT_EQ] = ACTIONS(67),
    [anon_sym_GT_GT_EQ] = ACTIONS(67),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(67),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(67),
    [anon_sym_if] = ACTIONS(71),
    [anon_sym_SEMI] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(71),
    [anon_sym_when] = ACTIONS(71),
    [anon_sym_in] = ACTIONS(71),
    [anon_sym_case] = ACTIONS(71),
    [anon_sym_QMARK] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_DASH] = ACTIONS(71),
    [anon_sym_TILDE] = ACTIONS(71),
    [anon_sym_AMP] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_or_else] = ACTIONS(71),
    [anon_sym_AMP_AMP] = ACTIONS(71),
    [anon_sym_GT] = ACTIONS(71),
    [anon_sym_GT_EQ] = ACTIONS(67),
    [anon_sym_LT_EQ] = ACTIONS(67),
    [anon_sym_LT] = ACTIONS(71),
    [anon_sym_EQ_EQ] = ACTIONS(67),
    [anon_sym_BANG_EQ] = ACTIONS(67),
    [anon_sym_TILDE_EQ] = ACTIONS(67),
    [anon_sym_AMP_TILDE] = ACTIONS(71),
    [anon_sym_LT_LT] = ACTIONS(71),
    [anon_sym_GT_GT] = ACTIONS(71),
    [anon_sym_STAR] = ACTIONS(71),
    [anon_sym_SLASH] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(71),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(67),
    [anon_sym_DOT] = ACTIONS(71),
    [anon_sym_LBRACK] = ACTIONS(67),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(67),
    [anon_sym_DOT_DOT_LT] = ACTIONS(67),
    [anon_sym_not_in] = ACTIONS(71),
    [anon_sym_or_return] = ACTIONS(71),
    [anon_sym_or_continue] = ACTIONS(71),
    [anon_sym_or_break] = ACTIONS(71),
    [anon_sym_CARET] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(67),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2185] = {
    [sym_identifier] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(4697),
    [anon_sym_COMMA] = ACTIONS(4697),
    [anon_sym_COLON_COLON] = ACTIONS(4697),
    [anon_sym_DASH_GT] = ACTIONS(4697),
    [anon_sym_where] = ACTIONS(4701),
    [anon_sym_EQ] = ACTIONS(4701),
    [anon_sym_COLON] = ACTIONS(4701),
    [anon_sym_PIPE] = ACTIONS(4701),
    [anon_sym_COLON_EQ] = ACTIONS(4697),
    [anon_sym_LPAREN] = ACTIONS(4697),
    [anon_sym_PLUS_EQ] = ACTIONS(4697),
    [anon_sym_DASH_EQ] = ACTIONS(4697),
    [anon_sym_STAR_EQ] = ACTIONS(4697),
    [anon_sym_SLASH_EQ] = ACTIONS(4697),
    [anon_sym_PERCENT_EQ] = ACTIONS(4697),
    [anon_sym_AMP_EQ] = ACTIONS(4697),
    [anon_sym_PIPE_EQ] = ACTIONS(4697),
    [anon_sym_CARET_EQ] = ACTIONS(4697),
    [anon_sym_LT_LT_EQ] = ACTIONS(4697),
    [anon_sym_GT_GT_EQ] = ACTIONS(4697),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4697),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4697),
    [anon_sym_AMP_TILDE_EQ] = ACTIONS(4697),
    [anon_sym_if] = ACTIONS(4701),
    [anon_sym_SEMI] = ACTIONS(4697),
    [anon_sym_do] = ACTIONS(4701),
    [anon_sym_when] = ACTIONS(4701),
    [anon_sym_in] = ACTIONS(4701),
    [anon_sym_QMARK] = ACTIONS(4697),
    [anon_sym_PLUS] = ACTIONS(4701),
    [anon_sym_DASH] = ACTIONS(4701),
    [anon_sym_TILDE] = ACTIONS(4701),
    [anon_sym_AMP] = ACTIONS(4701),
    [anon_sym_PIPE_PIPE] = ACTIONS(4701),
    [anon_sym_or_else] = ACTIONS(4701),
    [anon_sym_AMP_AMP] = ACTIONS(4701),
    [anon_sym_GT] = ACTIONS(4701),
    [anon_sym_GT_EQ] = ACTIONS(4697),
    [anon_sym_LT_EQ] = ACTIONS(4697),
    [anon_sym_LT] = ACTIONS(4701),
    [anon_sym_EQ_EQ] = ACTIONS(4697),
    [anon_sym_BANG_EQ] = ACTIONS(4697),
    [anon_sym_TILDE_EQ] = ACTIONS(4697),
    [anon_sym_AMP_TILDE] = ACTIONS(4701),
    [anon_sym_LT_LT] = ACTIONS(4701),
    [anon_sym_GT_GT] = ACTIONS(4701),
    [anon_sym_STAR] = ACTIONS(4701),
    [anon_sym_SLASH] = ACTIONS(4701),
    [anon_sym_PERCENT] = ACTIONS(4701),
    [anon_sym_PERCENT_PERCENT] = ACTIONS(4697),
    [anon_sym_DOT] = ACTIONS(4701),
    [anon_sym_LBRACK] = ACTIONS(4697),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(4697),
    [anon_sym_DOT_DOT_LT] = ACTIONS(4697),
    [anon_sym_not_in] = ACTIONS(4701),
    [anon_sym_or_return] = ACTIONS(4701),
    [anon_sym_or_continue] = ACTIONS(4701),
    [anon_sym_or_break] = ACTIONS(4701),
    [anon_sym_CARET] = ACTIONS(4701),
    [sym_uninitialized] = ACTIONS(4697),
    [sym_tag] = ACTIONS(4697),
    [sym_comment] = ACTIONS(3),
    [sym__backslash] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7296), 1,
      sym_type,
    STATE(8288), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [131] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5884), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5882), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [202] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5758), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5756), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [273] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5754), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5752), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [344] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5748), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5746), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [415] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5734), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [486] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5734), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [557] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5636), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5634), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [628] = 6,
    ACTIONS(6341), 1,
      anon_sym_LBRACE,
    ACTIONS(6477), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4600), 39,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [705] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5158), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5156), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [776] = 7,
    ACTIONS(6177), 1,
      anon_sym_LBRACE,
    ACTIONS(6179), 1,
      sym_uninitialized,
    ACTIONS(6183), 1,
      sym_tag,
    STATE(2612), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4023), 38,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [855] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5356), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5354), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [926] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5350), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5348), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [997] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5272), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5270), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [1068] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5732), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5730), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [1139] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5728), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5726), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [1210] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5346), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5344), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [1281] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5342), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5340), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [1352] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5724), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5722), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [1423] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5706), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5704), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [1494] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5714), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5712), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [1565] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5268), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5266), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [1636] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5258), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5256), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [1707] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4185), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [1778] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5458), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5456), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [1849] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5702), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5700), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [1920] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5338), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5336), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [1991] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5698), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5696), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [2062] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5246), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5244), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [2133] = 5,
    ACTIONS(6479), 1,
      anon_sym_LPAREN,
    ACTIONS(6481), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5470), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5468), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [2208] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5690), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5688), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [2279] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5676), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5674), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [2350] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5334), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5332), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [2421] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5668), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5666), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [2492] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5474), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5472), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [2563] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5660), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5658), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [2634] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5656), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5654), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [2705] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5280), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5278), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [2776] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5652), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5650), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [2847] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5642), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5640), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [2918] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5276), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5274), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [2989] = 4,
    ACTIONS(6451), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(67), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [3062] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5218), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5216), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [3133] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5170), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5168), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [3204] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5206), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5204), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [3275] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5202), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5200), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [3346] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5170), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5168), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [3417] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5154), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5152), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [3488] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5384), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5382), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [3559] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5158), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5156), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [3630] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5154), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5152), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [3701] = 5,
    ACTIONS(6479), 1,
      anon_sym_LPAREN,
    ACTIONS(6481), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5484), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5482), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [3776] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5368), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5366), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [3847] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5524), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5522), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [3918] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5758), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5756), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [3989] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(913), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [4060] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5490), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5488), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [4131] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5112), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5110), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [4202] = 5,
    ACTIONS(6479), 1,
      anon_sym_LPAREN,
    ACTIONS(6481), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5466), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5464), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [4277] = 7,
    ACTIONS(6177), 1,
      anon_sym_LBRACE,
    ACTIONS(6203), 1,
      sym_uninitialized,
    ACTIONS(6205), 1,
      sym_tag,
    STATE(2618), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4083), 38,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [4356] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5446), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5444), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [4427] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5096), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5094), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [4498] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5438), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5436), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [4569] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(201), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [4640] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5434), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5432), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [4711] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5202), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5200), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [4782] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5206), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5204), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [4853] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4972), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4970), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [4924] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5608), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5606), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [4995] = 7,
    ACTIONS(6177), 1,
      anon_sym_LBRACE,
    ACTIONS(6209), 1,
      sym_uninitialized,
    ACTIONS(6211), 1,
      sym_tag,
    STATE(2597), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3671), 38,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [5074] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4950), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4948), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [5145] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4928), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4926), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [5216] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4920), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [5287] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5218), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5216), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [5358] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5258), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5256), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [5429] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5268), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5266), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [5500] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5272), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5270), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [5571] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5350), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5348), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [5642] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5356), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5354), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [5713] = 14,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6390), 1,
      anon_sym_TILDE,
    ACTIONS(6392), 1,
      anon_sym_AMP,
    ACTIONS(6406), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6412), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6408), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6410), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 37,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [5806] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7302), 1,
      sym_type,
    STATE(8177), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [5937] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5112), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5110), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [6008] = 26,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6386), 1,
      anon_sym_PIPE,
    ACTIONS(6390), 1,
      anon_sym_TILDE,
    ACTIONS(6392), 1,
      anon_sym_AMP,
    ACTIONS(6394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6396), 1,
      anon_sym_or_else,
    ACTIONS(6398), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6406), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6412), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6420), 1,
      anon_sym_or_return,
    ACTIONS(6422), 1,
      anon_sym_or_continue,
    ACTIONS(6424), 1,
      anon_sym_or_break,
    ACTIONS(6426), 1,
      anon_sym_CARET,
    ACTIONS(5422), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6400), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6402), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6408), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6483), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6404), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6410), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_QMARK,
      sym_uninitialized,
      sym_tag,
  [6125] = 9,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6412), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6410), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 15,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_CARET,
    ACTIONS(5358), 37,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [6208] = 13,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6392), 1,
      anon_sym_AMP,
    ACTIONS(6406), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6412), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6408), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6410), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 37,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [6299] = 7,
    ACTIONS(6177), 1,
      anon_sym_LBRACE,
    ACTIONS(6485), 1,
      sym_uninitialized,
    ACTIONS(6487), 1,
      sym_tag,
    STATE(2594), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4667), 38,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [6378] = 12,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6406), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6412), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6408), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6410), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 37,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [6467] = 19,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6386), 1,
      anon_sym_PIPE,
    ACTIONS(6390), 1,
      anon_sym_TILDE,
    ACTIONS(6392), 1,
      anon_sym_AMP,
    ACTIONS(6398), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6406), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6412), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6400), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6402), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6408), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6404), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6410), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5358), 32,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [6570] = 18,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6386), 1,
      anon_sym_PIPE,
    ACTIONS(6390), 1,
      anon_sym_TILDE,
    ACTIONS(6392), 1,
      anon_sym_AMP,
    ACTIONS(6406), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6412), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6400), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6402), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6408), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6404), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6410), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
    ACTIONS(5358), 32,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [6671] = 7,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(4992), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [6750] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5430), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5428), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [6821] = 9,
    ACTIONS(6163), 1,
      anon_sym_where,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6499), 1,
      sym_uninitialized,
    ACTIONS(6501), 1,
      sym_tag,
    STATE(2546), 1,
      sym_where_clause,
    STATE(2779), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3671), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [6904] = 9,
    ACTIONS(6163), 1,
      anon_sym_where,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6503), 1,
      sym_uninitialized,
    ACTIONS(6505), 1,
      sym_tag,
    STATE(2547), 1,
      sym_where_clause,
    STATE(2866), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4023), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [6987] = 7,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5098), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [7066] = 16,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6386), 1,
      anon_sym_PIPE,
    ACTIONS(6390), 1,
      anon_sym_TILDE,
    ACTIONS(6392), 1,
      anon_sym_AMP,
    ACTIONS(6406), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6412), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6408), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6404), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6410), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 34,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [7163] = 9,
    ACTIONS(6163), 1,
      anon_sym_where,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6503), 1,
      sym_uninitialized,
    ACTIONS(6507), 1,
      sym_tag,
    STATE(2547), 1,
      sym_where_clause,
    STATE(2866), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4023), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [7246] = 11,
    ACTIONS(6163), 1,
      anon_sym_where,
    ACTIONS(6169), 1,
      anon_sym_LPAREN,
    ACTIONS(6171), 1,
      anon_sym_SLASH,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6503), 1,
      sym_uninitialized,
    ACTIONS(6507), 1,
      sym_tag,
    STATE(2547), 1,
      sym_where_clause,
    STATE(2866), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4023), 35,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [7333] = 15,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6386), 1,
      anon_sym_PIPE,
    ACTIONS(6390), 1,
      anon_sym_TILDE,
    ACTIONS(6392), 1,
      anon_sym_AMP,
    ACTIONS(6406), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6412), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6408), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6410), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 37,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [7428] = 11,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6412), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6408), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6410), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_CARET,
    ACTIONS(5358), 37,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [7515] = 10,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6412), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6410), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_CARET,
    ACTIONS(5358), 37,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [7600] = 7,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5358), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [7679] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4920), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [7750] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5538), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5536), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [7821] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5560), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5558), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [7892] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5572), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5570), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [7963] = 25,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6386), 1,
      anon_sym_PIPE,
    ACTIONS(6390), 1,
      anon_sym_TILDE,
    ACTIONS(6392), 1,
      anon_sym_AMP,
    ACTIONS(6394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6396), 1,
      anon_sym_or_else,
    ACTIONS(6398), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6406), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6412), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6420), 1,
      anon_sym_or_return,
    ACTIONS(6422), 1,
      anon_sym_or_continue,
    ACTIONS(6424), 1,
      anon_sym_or_break,
    ACTIONS(6426), 1,
      anon_sym_CARET,
    ACTIONS(5774), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6400), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6402), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6408), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6404), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6410), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5772), 28,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
      sym_uninitialized,
      sym_tag,
  [8078] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5588), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5586), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [8149] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5372), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5370), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [8220] = 7,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5600), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [8299] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(201), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [8370] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4858), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4856), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [8441] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5610), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [8512] = 9,
    ACTIONS(6163), 1,
      anon_sym_where,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6509), 1,
      sym_uninitialized,
    ACTIONS(6511), 1,
      sym_tag,
    STATE(2548), 1,
      sym_where_clause,
    STATE(2890), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4083), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [8595] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5376), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5374), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [8666] = 14,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6515), 1,
      anon_sym_TILDE,
    ACTIONS(6517), 1,
      anon_sym_AMP,
    ACTIONS(6519), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6525), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6521), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6523), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [8759] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5626), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5624), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [8830] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5630), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5628), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [8901] = 26,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6515), 1,
      anon_sym_TILDE,
    ACTIONS(6517), 1,
      anon_sym_AMP,
    ACTIONS(6519), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6525), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6527), 1,
      anon_sym_PIPE,
    ACTIONS(6531), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6533), 1,
      anon_sym_or_else,
    ACTIONS(6535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6543), 1,
      anon_sym_or_return,
    ACTIONS(6545), 1,
      anon_sym_or_continue,
    ACTIONS(6547), 1,
      anon_sym_or_break,
    ACTIONS(6549), 1,
      anon_sym_CARET,
    ACTIONS(5422), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6521), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6529), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(6537), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6523), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6541), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5420), 26,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_case,
      anon_sym_QMARK,
  [9018] = 9,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6525), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6523), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 15,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_CARET,
    ACTIONS(5358), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [9101] = 13,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6517), 1,
      anon_sym_AMP,
    ACTIONS(6519), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6525), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6521), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6523), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [9192] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5636), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5634), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [9263] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5378), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [9334] = 9,
    ACTIONS(6163), 1,
      anon_sym_where,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6509), 1,
      sym_uninitialized,
    ACTIONS(6551), 1,
      sym_tag,
    STATE(2548), 1,
      sym_where_clause,
    STATE(2890), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4083), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [9417] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4623), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4618), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [9488] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5784), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5782), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [9559] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3781), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [9630] = 12,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6519), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6525), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6521), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6523), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [9719] = 19,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6515), 1,
      anon_sym_TILDE,
    ACTIONS(6517), 1,
      anon_sym_AMP,
    ACTIONS(6519), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6525), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6527), 1,
      anon_sym_PIPE,
    ACTIONS(6535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6521), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6537), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6523), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6541), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5360), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5358), 32,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [9822] = 18,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6515), 1,
      anon_sym_TILDE,
    ACTIONS(6517), 1,
      anon_sym_AMP,
    ACTIONS(6519), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6525), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6527), 1,
      anon_sym_PIPE,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6521), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6537), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6523), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6541), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5360), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
    ACTIONS(5358), 32,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [9923] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5858), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5856), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [9994] = 7,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5644), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [10073] = 16,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6515), 1,
      anon_sym_TILDE,
    ACTIONS(6517), 1,
      anon_sym_AMP,
    ACTIONS(6519), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6525), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6527), 1,
      anon_sym_PIPE,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6521), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6523), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6541), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 34,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [10170] = 11,
    ACTIONS(6163), 1,
      anon_sym_where,
    ACTIONS(6169), 1,
      anon_sym_LPAREN,
    ACTIONS(6171), 1,
      anon_sym_SLASH,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6509), 1,
      sym_uninitialized,
    ACTIONS(6551), 1,
      sym_tag,
    STATE(2548), 1,
      sym_where_clause,
    STATE(2890), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4083), 35,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [10257] = 15,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6515), 1,
      anon_sym_TILDE,
    ACTIONS(6517), 1,
      anon_sym_AMP,
    ACTIONS(6519), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6525), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6527), 1,
      anon_sym_PIPE,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6521), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6523), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [10352] = 9,
    ACTIONS(6163), 1,
      anon_sym_where,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6553), 1,
      sym_uninitialized,
    ACTIONS(6555), 1,
      sym_tag,
    STATE(2550), 1,
      sym_where_clause,
    STATE(2894), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3415), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [10435] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5672), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5670), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [10506] = 7,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5644), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [10585] = 7,
    ACTIONS(6177), 1,
      anon_sym_LBRACE,
    ACTIONS(6261), 1,
      sym_uninitialized,
    ACTIONS(6557), 1,
      sym_tag,
    STATE(2605), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3415), 38,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [10664] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5582), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5580), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [10735] = 11,
    ACTIONS(6163), 1,
      anon_sym_where,
    ACTIONS(6169), 1,
      anon_sym_LPAREN,
    ACTIONS(6171), 1,
      anon_sym_SLASH,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6553), 1,
      sym_uninitialized,
    ACTIONS(6555), 1,
      sym_tag,
    STATE(2550), 1,
      sym_where_clause,
    STATE(2894), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3415), 35,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [10822] = 11,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6525), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6521), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6523), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_CARET,
    ACTIONS(5358), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [10909] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5610), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [10980] = 10,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6525), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6523), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_CARET,
    ACTIONS(5358), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [11065] = 7,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5358), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [11144] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5692), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [11215] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5692), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [11286] = 25,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6515), 1,
      anon_sym_TILDE,
    ACTIONS(6517), 1,
      anon_sym_AMP,
    ACTIONS(6519), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6525), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6527), 1,
      anon_sym_PIPE,
    ACTIONS(6531), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6533), 1,
      anon_sym_or_else,
    ACTIONS(6535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6543), 1,
      anon_sym_or_return,
    ACTIONS(6545), 1,
      anon_sym_or_continue,
    ACTIONS(6547), 1,
      anon_sym_or_break,
    ACTIONS(6549), 1,
      anon_sym_CARET,
    ACTIONS(5774), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6521), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6537), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6523), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6541), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5772), 28,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
  [11401] = 10,
    ACTIONS(6163), 1,
      anon_sym_where,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6559), 1,
      anon_sym_DASH_GT,
    ACTIONS(6561), 1,
      sym_uninitialized,
    ACTIONS(6563), 1,
      sym_tag,
    STATE(2560), 1,
      sym_where_clause,
    STATE(2901), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3781), 35,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [11486] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5710), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5708), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [11557] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3415), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [11628] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5766), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5764), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [11699] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5770), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5768), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [11770] = 25,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6386), 1,
      anon_sym_PIPE,
    ACTIONS(6390), 1,
      anon_sym_TILDE,
    ACTIONS(6392), 1,
      anon_sym_AMP,
    ACTIONS(6394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6396), 1,
      anon_sym_or_else,
    ACTIONS(6398), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6406), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6412), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6420), 1,
      anon_sym_or_return,
    ACTIONS(6422), 1,
      anon_sym_or_continue,
    ACTIONS(6424), 1,
      anon_sym_or_break,
    ACTIONS(6426), 1,
      anon_sym_CARET,
    ACTIONS(5720), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6400), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6402), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6408), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6404), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6410), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5718), 28,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
      sym_uninitialized,
      sym_tag,
  [11885] = 21,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6386), 1,
      anon_sym_PIPE,
    ACTIONS(6390), 1,
      anon_sym_TILDE,
    ACTIONS(6392), 1,
      anon_sym_AMP,
    ACTIONS(6394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6396), 1,
      anon_sym_or_else,
    ACTIONS(6398), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6406), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6412), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6400), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6402), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6408), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5720), 3,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_CARET,
    ACTIONS(6404), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6410), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5718), 31,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [11992] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5880), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5878), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [12063] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5812), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5810), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [12134] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5822), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5820), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [12205] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(859), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [12276] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5826), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5824), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [12347] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5840), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [12418] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5840), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [12489] = 10,
    ACTIONS(6163), 1,
      anon_sym_where,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_DASH_GT,
    ACTIONS(6567), 1,
      sym_uninitialized,
    ACTIONS(6569), 1,
      sym_tag,
    STATE(2526), 1,
      sym_where_clause,
    STATE(2897), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4117), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4113), 35,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [12574] = 6,
    ACTIONS(6169), 1,
      anon_sym_LPAREN,
    ACTIONS(6171), 1,
      anon_sym_SLASH,
    ACTIONS(6571), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5390), 17,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5386), 41,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [12651] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4864), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4862), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [12722] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5848), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5846), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [12793] = 7,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5098), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [12872] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5850), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [12943] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(815), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [13014] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5850), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [13085] = 7,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5600), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [13164] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7348), 1,
      sym_type,
    STATE(8255), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [13295] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5874), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5872), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [13366] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5884), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5882), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [13437] = 7,
    ACTIONS(6177), 1,
      anon_sym_LBRACE,
    ACTIONS(6303), 1,
      sym_uninitialized,
    ACTIONS(6305), 1,
      sym_tag,
    STATE(2567), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3781), 38,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [13516] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5880), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5878), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [13587] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5858), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5856), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [13658] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5784), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5782), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [13729] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7347), 1,
      sym_type,
    STATE(7784), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [13860] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5378), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [13931] = 25,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6515), 1,
      anon_sym_TILDE,
    ACTIONS(6517), 1,
      anon_sym_AMP,
    ACTIONS(6519), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6525), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6527), 1,
      anon_sym_PIPE,
    ACTIONS(6531), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6533), 1,
      anon_sym_or_else,
    ACTIONS(6535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6543), 1,
      anon_sym_or_return,
    ACTIONS(6545), 1,
      anon_sym_or_continue,
    ACTIONS(6547), 1,
      anon_sym_or_break,
    ACTIONS(6549), 1,
      anon_sym_CARET,
    ACTIONS(5720), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6521), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6537), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6523), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6541), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 28,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
  [14046] = 21,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6515), 1,
      anon_sym_TILDE,
    ACTIONS(6517), 1,
      anon_sym_AMP,
    ACTIONS(6519), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6525), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6527), 1,
      anon_sym_PIPE,
    ACTIONS(6531), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6533), 1,
      anon_sym_or_else,
    ACTIONS(6535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6521), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6537), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5720), 3,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_CARET,
    ACTIONS(6523), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6541), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 31,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [14153] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5734), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [14224] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5568), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5566), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [14295] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5754), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5752), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [14366] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5748), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5746), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [14437] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5734), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [14508] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5418), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5416), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [14579] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4083), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [14650] = 4,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5554), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
    ACTIONS(4990), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4988), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [14723] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5732), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5730), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [14794] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5728), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5726), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [14865] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5724), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5722), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [14936] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5706), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5704), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [15007] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5714), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5712), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [15078] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7370), 1,
      sym_type,
    STATE(7785), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [15209] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5458), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5456), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [15280] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5702), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5700), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [15351] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7242), 1,
      sym_type,
    STATE(8037), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [15482] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7317), 1,
      sym_type,
    STATE(8395), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [15613] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7290), 1,
      sym_type,
    STATE(7945), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [15744] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5618), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5616), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [15815] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5698), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5696), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [15886] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7333), 1,
      sym_type,
    STATE(7773), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [16017] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7287), 1,
      sym_type,
    STATE(7995), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [16148] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5690), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5688), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [16219] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5676), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5674), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [16290] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5668), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5666), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [16361] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7418), 1,
      sym_type,
    STATE(8509), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [16492] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5660), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5658), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [16563] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5656), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5654), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [16634] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5652), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5650), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [16705] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5642), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5640), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [16776] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7300), 1,
      sym_type,
    STATE(8163), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [16907] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5538), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5536), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [16978] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5560), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5558), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [17049] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5572), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5570), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [17120] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4928), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4926), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [17191] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4950), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4948), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [17262] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4023), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [17333] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7237), 1,
      sym_type,
    STATE(8040), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [17464] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5874), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5872), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [17535] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5850), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [17606] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5850), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [17677] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5848), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5846), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [17748] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5840), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [17819] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5840), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [17890] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5826), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5824), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [17961] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5398), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5396), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [18032] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(891), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [18103] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7249), 1,
      sym_type,
    STATE(8152), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [18234] = 4,
    ACTIONS(6440), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(67), 41,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [18307] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5135), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5132), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [18378] = 5,
    ACTIONS(6479), 1,
      anon_sym_LPAREN,
    ACTIONS(6481), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4800), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [18453] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5384), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5382), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [18524] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5135), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5132), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [18595] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5402), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5400), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [18666] = 6,
    ACTIONS(6169), 1,
      anon_sym_LPAREN,
    ACTIONS(6171), 1,
      anon_sym_SLASH,
    ACTIONS(6573), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4800), 40,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [18743] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5410), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5408), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [18814] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5414), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5412), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [18885] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5822), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5820), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [18956] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5812), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5810), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [19027] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(913), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [19098] = 5,
    ACTIONS(6577), 1,
      anon_sym_QMARK,
    ACTIONS(6575), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4920), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_in,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [19173] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3671), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [19244] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5588), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5586), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [19315] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(859), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [19386] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5060), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5058), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [19457] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(891), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [19528] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4972), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4970), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [19599] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(815), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [19670] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(767), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [19741] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5454), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5452), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [19812] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(767), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [19883] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4990), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4988), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [19954] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4667), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [20025] = 7,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(4992), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [20104] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5402), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5400), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [20175] = 7,
    ACTIONS(6451), 1,
      anon_sym_LPAREN,
    ACTIONS(6583), 1,
      anon_sym_QMARK,
    ACTIONS(6581), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6579), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
    ACTIONS(71), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(67), 32,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_in,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [20254] = 5,
    ACTIONS(6169), 1,
      anon_sym_LPAREN,
    ACTIONS(6171), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5484), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5482), 41,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [20329] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5630), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5628), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [20400] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5556), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5554), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [20471] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4691), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [20542] = 5,
    ACTIONS(6479), 1,
      anon_sym_LPAREN,
    ACTIONS(6481), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5450), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5448), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [20617] = 5,
    ACTIONS(6169), 1,
      anon_sym_LPAREN,
    ACTIONS(6171), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5466), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5464), 41,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [20692] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5552), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5550), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [20763] = 25,
    ACTIONS(6384), 1,
      anon_sym_DASH_GT,
    ACTIONS(6386), 1,
      anon_sym_PIPE,
    ACTIONS(6390), 1,
      anon_sym_TILDE,
    ACTIONS(6392), 1,
      anon_sym_AMP,
    ACTIONS(6394), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6396), 1,
      anon_sym_or_else,
    ACTIONS(6398), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6406), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6412), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6414), 1,
      anon_sym_DOT,
    ACTIONS(6416), 1,
      anon_sym_LBRACK,
    ACTIONS(6420), 1,
      anon_sym_or_return,
    ACTIONS(6422), 1,
      anon_sym_or_continue,
    ACTIONS(6424), 1,
      anon_sym_or_break,
    ACTIONS(6426), 1,
      anon_sym_CARET,
    ACTIONS(4722), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6388), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6400), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6402), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6408), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6418), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6404), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6410), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4717), 28,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
      sym_uninitialized,
      sym_tag,
  [20878] = 5,
    ACTIONS(6169), 1,
      anon_sym_LPAREN,
    ACTIONS(6171), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5450), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5448), 41,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [20953] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5498), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5496), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [21024] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5544), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5542), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [21095] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5096), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5094), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [21166] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5246), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5244), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [21237] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7261), 1,
      sym_type,
    STATE(8011), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [21368] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5528), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5526), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [21439] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5280), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5278), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [21510] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5498), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5496), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [21581] = 5,
    ACTIONS(6169), 1,
      anon_sym_LPAREN,
    ACTIONS(6171), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4800), 41,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [21656] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5770), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5768), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [21727] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7329), 1,
      sym_type,
    STATE(8265), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [21858] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7358), 1,
      sym_type,
    STATE(8318), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [21989] = 33,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6461), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6467), 1,
      anon_sym_map,
    ACTIONS(6469), 1,
      anon_sym_bit_set,
    ACTIONS(6471), 1,
      anon_sym_matrix,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7338), 1,
      sym_type,
    STATE(8372), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [22120] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5766), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5764), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [22191] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5524), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5522), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [22262] = 5,
    ACTIONS(6583), 1,
      anon_sym_QMARK,
    ACTIONS(6581), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4920), 39,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_in,
      anon_sym_case,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [22337] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5490), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5488), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [22408] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4185), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [22479] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4990), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4988), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [22550] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5556), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5554), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [22621] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5334), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5332), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [22692] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5710), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5708), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [22763] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5474), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5472), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [22834] = 5,
    ACTIONS(6169), 1,
      anon_sym_LPAREN,
    ACTIONS(6171), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5470), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5468), 41,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [22909] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5552), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5550), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [22980] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3781), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [23051] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5692), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [23122] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5454), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5452), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [23193] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5692), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [23264] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5544), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5542), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [23335] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3415), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [23406] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5672), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5670), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [23477] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5446), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5444), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [23548] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5438), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5436), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [23619] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5434), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5432), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [23690] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5430), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5428), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [23761] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5418), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5416), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [23832] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5528), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5526), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [23903] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4083), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [23974] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5626), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5624), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [24045] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5414), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5412), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [24116] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5410), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5408), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [24187] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5276), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5274), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [24258] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5398), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5396), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [24329] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4023), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [24400] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4691), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [24471] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5378), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [24542] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5376), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5374), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [24613] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5372), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5370), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [24684] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5368), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5366), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [24755] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3671), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [24826] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5346), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5344), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [24897] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5342), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5340), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [24968] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4667), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [25039] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5060), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5058), 42,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [25110] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5338), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5336), 42,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_uninitialized,
      sym_tag,
  [25181] = 6,
    ACTIONS(6177), 1,
      anon_sym_LBRACE,
    ACTIONS(6203), 1,
      sym_uninitialized,
    STATE(2618), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4083), 38,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [25257] = 5,
    ACTIONS(6585), 1,
      anon_sym_DOT2,
    STATE(2510), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4453), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [25331] = 6,
    ACTIONS(6177), 1,
      anon_sym_LBRACE,
    ACTIONS(6261), 1,
      sym_uninitialized,
    STATE(2605), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3415), 38,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [25407] = 5,
    ACTIONS(6588), 1,
      anon_sym_DOT2,
    STATE(2510), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4496), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4494), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [25481] = 6,
    ACTIONS(6177), 1,
      anon_sym_LBRACE,
    ACTIONS(6303), 1,
      sym_uninitialized,
    STATE(2567), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3781), 38,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [25557] = 4,
    ACTIONS(6590), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5610), 40,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [25629] = 6,
    ACTIONS(6177), 1,
      anon_sym_LBRACE,
    ACTIONS(6592), 1,
      sym_uninitialized,
    STATE(2562), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4691), 38,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [25705] = 5,
    ACTIONS(6588), 1,
      anon_sym_DOT2,
    STATE(2512), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4185), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [25779] = 6,
    ACTIONS(6177), 1,
      anon_sym_LBRACE,
    ACTIONS(6485), 1,
      sym_uninitialized,
    STATE(2594), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4667), 38,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [25855] = 6,
    ACTIONS(6177), 1,
      anon_sym_LBRACE,
    ACTIONS(6179), 1,
      sym_uninitialized,
    STATE(2612), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4023), 38,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [25931] = 5,
    ACTIONS(6449), 1,
      sym_identifier,
    ACTIONS(6594), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 28,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
    ACTIONS(67), 30,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
  [26005] = 6,
    ACTIONS(6177), 1,
      anon_sym_LBRACE,
    ACTIONS(6209), 1,
      sym_uninitialized,
    STATE(2597), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3671), 38,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [26081] = 7,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5098), 36,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [26158] = 21,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_TILDE,
    ACTIONS(6608), 1,
      anon_sym_AMP,
    ACTIONS(6610), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6612), 1,
      anon_sym_or_else,
    ACTIONS(6614), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6622), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6628), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6604), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6616), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6618), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6624), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5720), 3,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_CARET,
    ACTIONS(6620), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5718), 29,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [26263] = 14,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6606), 1,
      anon_sym_TILDE,
    ACTIONS(6608), 1,
      anon_sym_AMP,
    ACTIONS(6622), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6628), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6604), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6624), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 35,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [26354] = 16,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_TILDE,
    ACTIONS(6608), 1,
      anon_sym_AMP,
    ACTIONS(6622), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6628), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6604), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6624), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6620), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 32,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [26449] = 5,
    ACTIONS(6630), 1,
      anon_sym_LBRACE,
    STATE(2525), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4623), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4618), 38,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [26522] = 7,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6561), 1,
      sym_uninitialized,
    ACTIONS(6563), 1,
      sym_tag,
    STATE(2901), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3781), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [26599] = 7,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5600), 36,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [26676] = 25,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6543), 1,
      anon_sym_or_return,
    ACTIONS(6545), 1,
      anon_sym_or_continue,
    ACTIONS(6549), 1,
      anon_sym_CARET,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_TILDE,
    ACTIONS(6608), 1,
      anon_sym_AMP,
    ACTIONS(6610), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6612), 1,
      anon_sym_or_else,
    ACTIONS(6614), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6622), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6628), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6633), 1,
      anon_sym_or_break,
    ACTIONS(5774), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6604), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6616), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6618), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6624), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6620), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5772), 26,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
  [26789] = 7,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(4992), 36,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [26866] = 5,
    ACTIONS(6637), 1,
      anon_sym_QMARK,
    ACTIONS(6635), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4920), 37,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_case,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [26939] = 12,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6622), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6628), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6604), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6624), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 35,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [27026] = 7,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5358), 36,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [27103] = 10,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6628), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6604), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_CARET,
    ACTIONS(5358), 35,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [27186] = 11,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6628), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6604), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6624), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_CARET,
    ACTIONS(5358), 35,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [27271] = 13,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6608), 1,
      anon_sym_AMP,
    ACTIONS(6622), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6628), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6604), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6624), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 35,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [27360] = 4,
    STATE(2525), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4536), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4534), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [27431] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5840), 40,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [27500] = 15,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_TILDE,
    ACTIONS(6608), 1,
      anon_sym_AMP,
    ACTIONS(6622), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6628), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6604), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6624), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 35,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [27593] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(201), 40,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [27662] = 7,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5644), 36,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [27739] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5840), 40,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [27808] = 18,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_TILDE,
    ACTIONS(6608), 1,
      anon_sym_AMP,
    ACTIONS(6622), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6628), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6604), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6616), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6618), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6624), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6620), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
    ACTIONS(5358), 30,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [27907] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5840), 40,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [27976] = 26,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6543), 1,
      anon_sym_or_return,
    ACTIONS(6545), 1,
      anon_sym_or_continue,
    ACTIONS(6549), 1,
      anon_sym_CARET,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_TILDE,
    ACTIONS(6608), 1,
      anon_sym_AMP,
    ACTIONS(6610), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6612), 1,
      anon_sym_or_else,
    ACTIONS(6614), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6622), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6628), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6633), 1,
      anon_sym_or_break,
    ACTIONS(5422), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6604), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6616), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6618), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6624), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6639), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6620), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 24,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_case,
      anon_sym_QMARK,
  [28091] = 19,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_TILDE,
    ACTIONS(6608), 1,
      anon_sym_AMP,
    ACTIONS(6614), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6622), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6628), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6604), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6616), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6618), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6624), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6620), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5358), 30,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [28192] = 7,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6641), 1,
      sym_uninitialized,
    ACTIONS(6643), 1,
      sym_tag,
    STATE(2773), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4667), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [28269] = 7,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6499), 1,
      sym_uninitialized,
    ACTIONS(6501), 1,
      sym_tag,
    STATE(2779), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3671), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [28346] = 7,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6503), 1,
      sym_uninitialized,
    ACTIONS(6505), 1,
      sym_tag,
    STATE(2866), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4023), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [28423] = 9,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6628), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 15,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_CARET,
    ACTIONS(5358), 35,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [28504] = 7,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6509), 1,
      sym_uninitialized,
    ACTIONS(6511), 1,
      sym_tag,
    STATE(2890), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4083), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [28581] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5692), 40,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [28650] = 7,
    ACTIONS(6594), 1,
      anon_sym_LPAREN,
    ACTIONS(6637), 1,
      anon_sym_QMARK,
    ACTIONS(6635), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6579), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
    ACTIONS(71), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(67), 32,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_in,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [28727] = 4,
    STATE(2525), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4548), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4546), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [28798] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 20,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
      anon_sym_DOT2,
    ACTIONS(4453), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [28867] = 25,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6543), 1,
      anon_sym_or_return,
    ACTIONS(6545), 1,
      anon_sym_or_continue,
    ACTIONS(6549), 1,
      anon_sym_CARET,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_TILDE,
    ACTIONS(6608), 1,
      anon_sym_AMP,
    ACTIONS(6610), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6612), 1,
      anon_sym_or_else,
    ACTIONS(6614), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6622), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6628), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6633), 1,
      anon_sym_or_break,
    ACTIONS(5720), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6604), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6616), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6618), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6624), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6620), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5718), 26,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
  [28980] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5692), 40,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [29049] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5692), 40,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [29118] = 4,
    STATE(2525), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4568), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4566), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [29189] = 4,
    ACTIONS(6594), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(67), 39,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [29260] = 7,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6553), 1,
      sym_uninitialized,
    ACTIONS(6645), 1,
      sym_tag,
    STATE(2894), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3415), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [29337] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5060), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5058), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [29405] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5498), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5496), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [29473] = 6,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6553), 1,
      sym_uninitialized,
    STATE(2894), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3415), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [29547] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5384), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5382), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [29615] = 5,
    ACTIONS(6647), 1,
      anon_sym_LPAREN,
    ACTIONS(6649), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5450), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5448), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [29687] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5524), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5522), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [29755] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3415), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [29823] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5544), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5542), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [29891] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(859), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [29959] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5454), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5452), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [30027] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5446), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5444), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [30095] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5552), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5550), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [30163] = 6,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6509), 1,
      sym_uninitialized,
    STATE(2890), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4083), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [30237] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(767), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [30305] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(913), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [30373] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5438), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5436), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [30441] = 5,
    ACTIONS(6647), 1,
      anon_sym_LPAREN,
    ACTIONS(6649), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5466), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5464), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [30513] = 5,
    ACTIONS(6647), 1,
      anon_sym_LPAREN,
    ACTIONS(6649), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5470), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5468), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [30585] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5135), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5132), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [30653] = 6,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6503), 1,
      sym_uninitialized,
    STATE(2866), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4023), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [30727] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5474), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5472), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [30795] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5434), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5432), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [30863] = 6,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6499), 1,
      sym_uninitialized,
    STATE(2779), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3671), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [30937] = 6,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6641), 1,
      sym_uninitialized,
    STATE(2773), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4667), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [31011] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5430), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5428), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [31079] = 6,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6651), 1,
      sym_uninitialized,
    STATE(2776), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4691), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [31153] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(815), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [31221] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5418), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5416), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [31289] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3781), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [31357] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5528), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5526), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [31425] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5414), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5412), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [31493] = 6,
    ACTIONS(6497), 1,
      anon_sym_LBRACE,
    ACTIONS(6561), 1,
      sym_uninitialized,
    STATE(2901), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3781), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [31567] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5410), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5408), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [31635] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4691), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [31703] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5556), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5554), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [31771] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5402), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5400), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [31839] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4667), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [31907] = 4,
    ACTIONS(6653), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4701), 28,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
    ACTIONS(4697), 29,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
  [31977] = 5,
    ACTIONS(6647), 1,
      anon_sym_LPAREN,
    ACTIONS(6649), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4800), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [32049] = 5,
    ACTIONS(6655), 1,
      sym_identifier,
    ACTIONS(6657), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(67), 28,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(71), 28,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [32121] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5398), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5396), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [32189] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5378), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [32257] = 5,
    ACTIONS(6647), 1,
      anon_sym_LPAREN,
    ACTIONS(6649), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5484), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5482), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [32329] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5376), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5374), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [32397] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4083), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [32465] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5372), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5370), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [32533] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4185), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [32601] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5368), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5366), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [32669] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5490), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5488), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [32737] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4623), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4618), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [32805] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4858), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4856), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [32873] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3671), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [32941] = 6,
    ACTIONS(6659), 1,
      anon_sym_LBRACE,
    ACTIONS(6662), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4600), 36,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [33015] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5346), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5344), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [33083] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5342), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5340), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [33151] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5338), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5336), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [33219] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5334), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5332), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [33287] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4023), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [33355] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5280), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5278), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [33423] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(891), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [33491] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5246), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5244), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [33559] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5276), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5274), 39,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [33627] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5626), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5624), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [33694] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5268), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5266), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [33761] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5822), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5820), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [33828] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5826), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5824), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [33895] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5840), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [33962] = 25,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6667), 1,
      anon_sym_PIPE,
    ACTIONS(6671), 1,
      anon_sym_TILDE,
    ACTIONS(6673), 1,
      anon_sym_AMP,
    ACTIONS(6675), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6677), 1,
      anon_sym_or_else,
    ACTIONS(6679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6687), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6701), 1,
      anon_sym_or_return,
    ACTIONS(6703), 1,
      anon_sym_or_continue,
    ACTIONS(6705), 1,
      anon_sym_or_break,
    ACTIONS(6707), 1,
      anon_sym_CARET,
    ACTIONS(5720), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6681), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6683), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5718), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
  [34073] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4990), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4988), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [34140] = 7,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5600), 34,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [34215] = 25,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6667), 1,
      anon_sym_PIPE,
    ACTIONS(6671), 1,
      anon_sym_TILDE,
    ACTIONS(6673), 1,
      anon_sym_AMP,
    ACTIONS(6675), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6677), 1,
      anon_sym_or_else,
    ACTIONS(6679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6687), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6701), 1,
      anon_sym_or_return,
    ACTIONS(6703), 1,
      anon_sym_or_continue,
    ACTIONS(6705), 1,
      anon_sym_or_break,
    ACTIONS(6707), 1,
      anon_sym_CARET,
    ACTIONS(5774), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6681), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6683), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5772), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
  [34326] = 11,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_CARET,
    ACTIONS(5358), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [34409] = 7,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5644), 34,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [34484] = 21,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6667), 1,
      anon_sym_PIPE,
    ACTIONS(6671), 1,
      anon_sym_TILDE,
    ACTIONS(6673), 1,
      anon_sym_AMP,
    ACTIONS(6675), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6677), 1,
      anon_sym_or_else,
    ACTIONS(6679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6687), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6681), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6683), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5720), 3,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_CARET,
    ACTIONS(6685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5718), 27,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [34587] = 15,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6667), 1,
      anon_sym_PIPE,
    ACTIONS(6671), 1,
      anon_sym_TILDE,
    ACTIONS(6673), 1,
      anon_sym_AMP,
    ACTIONS(6687), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [34678] = 7,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5358), 34,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [34753] = 16,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6667), 1,
      anon_sym_PIPE,
    ACTIONS(6671), 1,
      anon_sym_TILDE,
    ACTIONS(6673), 1,
      anon_sym_AMP,
    ACTIONS(6687), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 30,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [34846] = 18,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6667), 1,
      anon_sym_PIPE,
    ACTIONS(6671), 1,
      anon_sym_TILDE,
    ACTIONS(6673), 1,
      anon_sym_AMP,
    ACTIONS(6687), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6681), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6683), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
    ACTIONS(5358), 28,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [34943] = 10,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_CARET,
    ACTIONS(5358), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [35024] = 19,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6667), 1,
      anon_sym_PIPE,
    ACTIONS(6671), 1,
      anon_sym_TILDE,
    ACTIONS(6673), 1,
      anon_sym_AMP,
    ACTIONS(6679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6687), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6681), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6683), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5358), 28,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [35123] = 9,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 15,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_CARET,
    ACTIONS(5358), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [35202] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5610), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [35269] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5840), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [35336] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5848), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5846), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [35403] = 6,
    ACTIONS(6647), 1,
      anon_sym_LPAREN,
    ACTIONS(6649), 1,
      anon_sym_SLASH,
    ACTIONS(6709), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4800), 36,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [35476] = 12,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6687), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [35561] = 5,
    ACTIONS(6713), 1,
      anon_sym_QMARK,
    ACTIONS(6711), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4920), 35,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_in,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [35632] = 7,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(4992), 34,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [35707] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5850), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [35774] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5850), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [35841] = 7,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5098), 34,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [35916] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4920), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [35983] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4928), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4926), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [36050] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4950), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4948), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [36117] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5874), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5872), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [36184] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4972), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4970), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [36251] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5812), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5810), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [36318] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5884), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5882), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [36385] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5096), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5094), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [36452] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5770), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5768), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [36519] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5112), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5110), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [36586] = 13,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6673), 1,
      anon_sym_AMP,
    ACTIONS(6687), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [36673] = 6,
    ACTIONS(6657), 1,
      anon_sym_LPAREN,
    ACTIONS(6713), 1,
      anon_sym_QMARK,
    ACTIONS(6711), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(67), 34,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_in,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [36746] = 4,
    ACTIONS(6657), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(67), 37,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [36815] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5154), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5152), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [36882] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5158), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5156), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [36949] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5170), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5168), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [37016] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5202), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5200), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [37083] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5206), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5204), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [37150] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5218), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5216), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [37217] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5258), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5256), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [37284] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5710), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5708), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [37351] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5272), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5270), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [37418] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5350), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5348), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [37485] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5356), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5354), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [37552] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5880), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5878), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [37619] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5784), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5782), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [37686] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5378), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [37753] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5758), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5756), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [37820] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5652), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5650), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [37887] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5642), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5640), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [37954] = 5,
    ACTIONS(6715), 1,
      anon_sym_LBRACE,
    STATE(2525), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4568), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4566), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [38025] = 27,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6667), 1,
      anon_sym_PIPE,
    ACTIONS(6671), 1,
      anon_sym_TILDE,
    ACTIONS(6673), 1,
      anon_sym_AMP,
    ACTIONS(6675), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6677), 1,
      anon_sym_or_else,
    ACTIONS(6679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6687), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6701), 1,
      anon_sym_or_return,
    ACTIONS(6703), 1,
      anon_sym_or_continue,
    ACTIONS(6705), 1,
      anon_sym_or_break,
    ACTIONS(6707), 1,
      anon_sym_CARET,
    ACTIONS(5422), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6681), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6683), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6717), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(6719), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 20,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_QMARK,
  [38140] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5754), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5752), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [38207] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5748), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5746), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [38274] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5734), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [38341] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5734), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [38408] = 5,
    ACTIONS(6721), 1,
      anon_sym_DOT2,
    STATE(2688), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4453), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [38479] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5766), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5764), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [38546] = 26,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6667), 1,
      anon_sym_PIPE,
    ACTIONS(6671), 1,
      anon_sym_TILDE,
    ACTIONS(6673), 1,
      anon_sym_AMP,
    ACTIONS(6675), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6677), 1,
      anon_sym_or_else,
    ACTIONS(6679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6687), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6701), 1,
      anon_sym_or_return,
    ACTIONS(6703), 1,
      anon_sym_or_continue,
    ACTIONS(6705), 1,
      anon_sym_or_break,
    ACTIONS(6707), 1,
      anon_sym_CARET,
    ACTIONS(5422), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6681), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6683), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6719), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_QMARK,
  [38659] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5538), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5536), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [38726] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5560), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5558), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [38793] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5572), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5570), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [38860] = 14,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6671), 1,
      anon_sym_TILDE,
    ACTIONS(6673), 1,
      anon_sym_AMP,
    ACTIONS(6687), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [38949] = 5,
    ACTIONS(6655), 1,
      sym_identifier,
    ACTIONS(6724), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(67), 27,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_QMARK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(71), 28,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [39020] = 6,
    ACTIONS(6726), 1,
      anon_sym_LBRACE,
    ACTIONS(6728), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4600), 35,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [39093] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5728), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5726), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [39160] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5656), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5654), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [39227] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5660), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5658), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [39294] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5668), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5666), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [39361] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5676), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5674), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [39428] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5690), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5688), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [39495] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5698), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5696), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [39562] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5702), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5700), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [39629] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5588), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5586), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [39696] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(201), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [39763] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5630), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5628), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [39830] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5636), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5634), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [39897] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5458), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5456), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [39964] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5714), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5712), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [40031] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5706), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5704), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [40098] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5724), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5722), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [40165] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5858), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5856), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [40232] = 5,
    ACTIONS(6715), 1,
      anon_sym_LBRACE,
    STATE(2525), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4536), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4534), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [40303] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5732), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5730), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [40370] = 5,
    ACTIONS(6731), 1,
      anon_sym_DOT2,
    STATE(2717), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4185), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [40441] = 5,
    ACTIONS(6731), 1,
      anon_sym_DOT2,
    STATE(2688), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4496), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4494), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [40512] = 5,
    ACTIONS(6715), 1,
      anon_sym_LBRACE,
    STATE(2525), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4548), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4546), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [40583] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5672), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5670), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [40650] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5692), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [40717] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5692), 38,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [40784] = 6,
    ACTIONS(6647), 1,
      anon_sym_LPAREN,
    ACTIONS(6649), 1,
      anon_sym_SLASH,
    ACTIONS(6733), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4800), 35,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [40856] = 7,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5358), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [40930] = 5,
    ACTIONS(6741), 1,
      sym_identifier,
    ACTIONS(6743), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(67), 27,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_QMARK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(71), 27,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [41000] = 6,
    ACTIONS(6724), 1,
      anon_sym_LPAREN,
    ACTIONS(6747), 1,
      anon_sym_QMARK,
    ACTIONS(6745), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(67), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_do,
      anon_sym_in,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [41072] = 25,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6701), 1,
      anon_sym_or_return,
    ACTIONS(6703), 1,
      anon_sym_or_continue,
    ACTIONS(6707), 1,
      anon_sym_CARET,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6749), 1,
      anon_sym_PIPE,
    ACTIONS(6753), 1,
      anon_sym_TILDE,
    ACTIONS(6755), 1,
      anon_sym_AMP,
    ACTIONS(6757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6759), 1,
      anon_sym_or_else,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6769), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6775), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6777), 1,
      anon_sym_or_break,
    ACTIONS(5774), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6751), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6763), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6765), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6771), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6767), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6773), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5772), 23,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
  [41182] = 4,
    ACTIONS(6724), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(67), 36,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [41250] = 7,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5644), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [41324] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5840), 37,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [41390] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 20,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
      anon_sym_DOT2,
    ACTIONS(4453), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [41456] = 10,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6775), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6751), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6773), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_CARET,
    ACTIONS(5358), 32,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [41536] = 11,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6775), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6751), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6771), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6773), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_CARET,
    ACTIONS(5358), 32,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [41618] = 4,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4701), 27,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
    ACTIONS(4697), 28,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_QMARK,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
  [41686] = 15,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6749), 1,
      anon_sym_PIPE,
    ACTIONS(6753), 1,
      anon_sym_TILDE,
    ACTIONS(6755), 1,
      anon_sym_AMP,
    ACTIONS(6769), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6775), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6751), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6771), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6773), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 32,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [41776] = 16,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6749), 1,
      anon_sym_PIPE,
    ACTIONS(6753), 1,
      anon_sym_TILDE,
    ACTIONS(6755), 1,
      anon_sym_AMP,
    ACTIONS(6769), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6775), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6751), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6771), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6767), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6773), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 29,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [41868] = 18,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6749), 1,
      anon_sym_PIPE,
    ACTIONS(6753), 1,
      anon_sym_TILDE,
    ACTIONS(6755), 1,
      anon_sym_AMP,
    ACTIONS(6769), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6775), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6751), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6763), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6765), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6771), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6767), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6773), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
    ACTIONS(5358), 27,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [41964] = 19,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6749), 1,
      anon_sym_PIPE,
    ACTIONS(6753), 1,
      anon_sym_TILDE,
    ACTIONS(6755), 1,
      anon_sym_AMP,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6769), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6775), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6751), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6763), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6765), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6771), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6767), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6773), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5358), 27,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [42062] = 12,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6769), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6775), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6751), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6771), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6773), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 32,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [42146] = 13,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6755), 1,
      anon_sym_AMP,
    ACTIONS(6769), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6775), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6751), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6771), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6773), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 32,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [42232] = 9,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6775), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6773), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 15,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_CARET,
    ACTIONS(5358), 32,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [42310] = 4,
    ACTIONS(6781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5378), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [42378] = 7,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5600), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [42452] = 26,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6701), 1,
      anon_sym_or_return,
    ACTIONS(6703), 1,
      anon_sym_or_continue,
    ACTIONS(6707), 1,
      anon_sym_CARET,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6749), 1,
      anon_sym_PIPE,
    ACTIONS(6753), 1,
      anon_sym_TILDE,
    ACTIONS(6755), 1,
      anon_sym_AMP,
    ACTIONS(6757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6759), 1,
      anon_sym_or_else,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6769), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6775), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6777), 1,
      anon_sym_or_break,
    ACTIONS(5422), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6751), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6763), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6765), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6771), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6783), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6767), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6773), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_QMARK,
  [42564] = 14,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6753), 1,
      anon_sym_TILDE,
    ACTIONS(6755), 1,
      anon_sym_AMP,
    ACTIONS(6769), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6775), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6751), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6771), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6773), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 32,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [42652] = 25,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6701), 1,
      anon_sym_or_return,
    ACTIONS(6703), 1,
      anon_sym_or_continue,
    ACTIONS(6707), 1,
      anon_sym_CARET,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6749), 1,
      anon_sym_PIPE,
    ACTIONS(6753), 1,
      anon_sym_TILDE,
    ACTIONS(6755), 1,
      anon_sym_AMP,
    ACTIONS(6757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6759), 1,
      anon_sym_or_else,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6769), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6775), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6777), 1,
      anon_sym_or_break,
    ACTIONS(5720), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6751), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6763), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6765), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6771), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6767), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6773), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5718), 23,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
  [42762] = 7,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5098), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [42836] = 7,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(4992), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [42910] = 5,
    ACTIONS(6747), 1,
      anon_sym_QMARK,
    ACTIONS(6745), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4920), 34,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_do,
      anon_sym_in,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [42980] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(201), 37,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [43046] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5610), 37,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [43112] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5692), 37,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [43178] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5692), 37,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [43244] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5692), 37,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [43310] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5840), 37,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [43376] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5840), 37,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [43442] = 21,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6749), 1,
      anon_sym_PIPE,
    ACTIONS(6753), 1,
      anon_sym_TILDE,
    ACTIONS(6755), 1,
      anon_sym_AMP,
    ACTIONS(6757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6759), 1,
      anon_sym_or_else,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6769), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6775), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6751), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6763), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6765), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6771), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5720), 3,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_CARET,
    ACTIONS(6767), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6773), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5718), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [43544] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5636), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5634), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [43609] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5728), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5726), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [43674] = 19,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6787), 1,
      anon_sym_PIPE,
    ACTIONS(6791), 1,
      anon_sym_TILDE,
    ACTIONS(6793), 1,
      anon_sym_AMP,
    ACTIONS(6795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6803), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6809), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6797), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6799), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6805), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6801), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6807), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(5358), 26,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [43771] = 18,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6787), 1,
      anon_sym_PIPE,
    ACTIONS(6791), 1,
      anon_sym_TILDE,
    ACTIONS(6793), 1,
      anon_sym_AMP,
    ACTIONS(6803), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6809), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6797), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6799), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6805), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6801), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6807), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
    ACTIONS(5358), 26,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [43866] = 16,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6787), 1,
      anon_sym_PIPE,
    ACTIONS(6791), 1,
      anon_sym_TILDE,
    ACTIONS(6793), 1,
      anon_sym_AMP,
    ACTIONS(6803), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6809), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6805), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6801), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6807), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 28,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [43957] = 15,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6787), 1,
      anon_sym_PIPE,
    ACTIONS(6791), 1,
      anon_sym_TILDE,
    ACTIONS(6793), 1,
      anon_sym_AMP,
    ACTIONS(6803), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6809), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6805), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6807), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 31,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [44046] = 11,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6809), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6805), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6807), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_CARET,
    ACTIONS(5358), 31,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [44127] = 10,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6809), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6807), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_CARET,
    ACTIONS(5358), 31,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [44206] = 7,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5358), 32,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [44279] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5538), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5536), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [44344] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5560), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5558), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [44409] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5572), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5570), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [44474] = 25,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6787), 1,
      anon_sym_PIPE,
    ACTIONS(6791), 1,
      anon_sym_TILDE,
    ACTIONS(6793), 1,
      anon_sym_AMP,
    ACTIONS(6795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6803), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6809), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6819), 1,
      anon_sym_or_else,
    ACTIONS(6821), 1,
      anon_sym_or_return,
    ACTIONS(6823), 1,
      anon_sym_or_continue,
    ACTIONS(6825), 1,
      anon_sym_or_break,
    ACTIONS(6827), 1,
      anon_sym_CARET,
    ACTIONS(5774), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6797), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6799), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6805), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6801), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6807), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5772), 22,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
  [44583] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5588), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5586), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [44648] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5060), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5058), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [44713] = 9,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6809), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6807), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 15,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_CARET,
    ACTIONS(5358), 31,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [44790] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4691), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [44855] = 7,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5600), 32,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [44928] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(913), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [44993] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5498), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5496), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [45058] = 6,
    ACTIONS(6743), 1,
      anon_sym_LPAREN,
    ACTIONS(6831), 1,
      anon_sym_QMARK,
    ACTIONS(6829), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(67), 32,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_in,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [45129] = 13,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6793), 1,
      anon_sym_AMP,
    ACTIONS(6803), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6809), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6805), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6807), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 31,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [45214] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4667), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [45279] = 26,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6787), 1,
      anon_sym_PIPE,
    ACTIONS(6791), 1,
      anon_sym_TILDE,
    ACTIONS(6793), 1,
      anon_sym_AMP,
    ACTIONS(6795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6803), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6809), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6819), 1,
      anon_sym_or_else,
    ACTIONS(6821), 1,
      anon_sym_or_return,
    ACTIONS(6823), 1,
      anon_sym_or_continue,
    ACTIONS(6825), 1,
      anon_sym_or_break,
    ACTIONS(6827), 1,
      anon_sym_CARET,
    ACTIONS(5422), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6797), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6799), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6805), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6833), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6801), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6807), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5420), 20,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_QMARK,
  [45390] = 35,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6667), 1,
      anon_sym_PIPE,
    ACTIONS(6671), 1,
      anon_sym_TILDE,
    ACTIONS(6673), 1,
      anon_sym_AMP,
    ACTIONS(6675), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6677), 1,
      anon_sym_or_else,
    ACTIONS(6679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6687), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6701), 1,
      anon_sym_or_return,
    ACTIONS(6703), 1,
      anon_sym_or_continue,
    ACTIONS(6705), 1,
      anon_sym_or_break,
    ACTIONS(6707), 1,
      anon_sym_CARET,
    ACTIONS(6719), 1,
      anon_sym_not_in,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6837), 1,
      anon_sym_COMMA,
    ACTIONS(6839), 1,
      anon_sym_EQ,
    ACTIONS(6841), 1,
      anon_sym_COLON,
    ACTIONS(6843), 1,
      anon_sym_COLON_EQ,
    ACTIONS(6847), 1,
      anon_sym_SEMI,
    ACTIONS(6849), 1,
      anon_sym_do,
    ACTIONS(6851), 1,
      anon_sym_in,
    STATE(6494), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    STATE(7067), 1,
      sym_block,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6681), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6683), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6845), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
  [45519] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5135), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5132), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [45584] = 5,
    ACTIONS(6853), 1,
      anon_sym_DOT2,
    STATE(2783), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4453), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [45653] = 14,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6791), 1,
      anon_sym_TILDE,
    ACTIONS(6793), 1,
      anon_sym_AMP,
    ACTIONS(6803), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6809), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6805), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6807), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 31,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [45740] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(201), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [45805] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5610), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [45870] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5626), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5624), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [45935] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5630), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5628), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [46000] = 35,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6667), 1,
      anon_sym_PIPE,
    ACTIONS(6671), 1,
      anon_sym_TILDE,
    ACTIONS(6673), 1,
      anon_sym_AMP,
    ACTIONS(6675), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6677), 1,
      anon_sym_or_else,
    ACTIONS(6679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6687), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6701), 1,
      anon_sym_or_return,
    ACTIONS(6703), 1,
      anon_sym_or_continue,
    ACTIONS(6705), 1,
      anon_sym_or_break,
    ACTIONS(6707), 1,
      anon_sym_CARET,
    ACTIONS(6719), 1,
      anon_sym_not_in,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6837), 1,
      anon_sym_COMMA,
    ACTIONS(6839), 1,
      anon_sym_EQ,
    ACTIONS(6841), 1,
      anon_sym_COLON,
    ACTIONS(6843), 1,
      anon_sym_COLON_EQ,
    ACTIONS(6851), 1,
      anon_sym_in,
    ACTIONS(6856), 1,
      anon_sym_SEMI,
    ACTIONS(6858), 1,
      anon_sym_do,
    STATE(6494), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    STATE(7067), 1,
      sym_block,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6681), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6683), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6845), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
  [46129] = 5,
    ACTIONS(6860), 1,
      anon_sym_DOT2,
    STATE(2801), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4185), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [46198] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5356), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5354), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [46263] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4920), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [46328] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5350), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5348), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [46393] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4928), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4926), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [46458] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5272), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5270), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [46523] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5268), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5266), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [46588] = 7,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5644), 32,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [46661] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5258), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5256), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [46726] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4950), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4948), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [46791] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5490), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5488), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [46856] = 5,
    ACTIONS(6860), 1,
      anon_sym_DOT2,
    STATE(2783), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4496), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4494), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [46925] = 7,
    ACTIONS(6449), 1,
      sym_identifier,
    ACTIONS(6594), 1,
      anon_sym_LPAREN,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    STATE(7083), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 25,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
    ACTIONS(67), 26,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
  [46998] = 5,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5466), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5464), 35,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [47067] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5276), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5274), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [47132] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5280), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5278), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [47197] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5334), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5332), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [47262] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4185), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [47327] = 5,
    ACTIONS(6831), 1,
      anon_sym_QMARK,
    ACTIONS(6829), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4920), 33,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_in,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [47396] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5338), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5336), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [47461] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5672), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5670), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [47526] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5692), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [47591] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5692), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [47656] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5710), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5708), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [47721] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5766), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5764), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [47786] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5770), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5768), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [47851] = 25,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6787), 1,
      anon_sym_PIPE,
    ACTIONS(6791), 1,
      anon_sym_TILDE,
    ACTIONS(6793), 1,
      anon_sym_AMP,
    ACTIONS(6795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6803), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6809), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6819), 1,
      anon_sym_or_else,
    ACTIONS(6821), 1,
      anon_sym_or_return,
    ACTIONS(6823), 1,
      anon_sym_or_continue,
    ACTIONS(6825), 1,
      anon_sym_or_break,
    ACTIONS(6827), 1,
      anon_sym_CARET,
    ACTIONS(5720), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6797), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6799), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6805), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6801), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6807), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5718), 22,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
  [47960] = 21,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6787), 1,
      anon_sym_PIPE,
    ACTIONS(6791), 1,
      anon_sym_TILDE,
    ACTIONS(6793), 1,
      anon_sym_AMP,
    ACTIONS(6795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6803), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6809), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6819), 1,
      anon_sym_or_else,
    ACTIONS(6789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6797), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6799), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6805), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5720), 3,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_CARET,
    ACTIONS(6801), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6807), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5718), 25,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [48061] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4972), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4970), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [48126] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5342), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5340), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [48191] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4990), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4988), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [48256] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5346), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5344), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [48321] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5812), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5810), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [48386] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5822), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5820), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [48451] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(767), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [48516] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5368), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5366), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [48581] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5372), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5370), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [48646] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5376), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5374), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [48711] = 7,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(4992), 32,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [48784] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5096), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5094), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [48849] = 7,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
    ACTIONS(5098), 32,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [48922] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5112), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5110), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [48987] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5826), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5824), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [49052] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5840), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [49117] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5840), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [49182] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5848), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5846), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [49247] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5850), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [49312] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5850), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [49377] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5874), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5872), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [49442] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5884), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5882), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [49507] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5398), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5396), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [49572] = 4,
    ACTIONS(6743), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(67), 35,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [49639] = 5,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5484), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5482), 35,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [49708] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5880), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5878), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [49773] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5858), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5856), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [49838] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5784), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5782), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [49903] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(859), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [49968] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5378), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [50033] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(891), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [50098] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5154), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5152), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [50163] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5158), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5156), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [50228] = 5,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4800), 35,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [50297] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5524), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5522), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [50362] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5758), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5756), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [50427] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5754), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5752), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [50492] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5748), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5746), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [50557] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5734), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [50622] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5734), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [50687] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5402), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5400), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [50752] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5732), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5730), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [50817] = 12,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6803), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6809), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6805), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6807), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5360), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_CARET,
    ACTIONS(5358), 31,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [50900] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5410), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5408), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [50965] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5414), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5412), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [51030] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5724), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5722), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [51095] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5706), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5704), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [51160] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5714), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5712), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [51225] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3671), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [51290] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5458), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5456), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [51355] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5702), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5700), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [51420] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5418), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5416), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [51485] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5698), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5696), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [51550] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(815), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [51615] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5690), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5688), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [51680] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5676), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5674), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [51745] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5218), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5216), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [51810] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5668), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5666), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [51875] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5430), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5428), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [51940] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5660), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5658), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [52005] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5656), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5654), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [52070] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5434), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5432), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [52135] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5652), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5650), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [52200] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5642), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5640), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [52265] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5438), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5436), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [52330] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5446), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5444), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [52395] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5384), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5382), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [52460] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5556), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5554), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [52525] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5552), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5550), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [52590] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5246), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5244), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [52655] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5206), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5204), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [52720] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5202), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5200), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [52785] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4023), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [52850] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5474), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5472), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [52915] = 5,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5450), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5448), 35,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [52984] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5170), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5168), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [53049] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(4083), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [53114] = 7,
    ACTIONS(6449), 1,
      sym_identifier,
    ACTIONS(6451), 1,
      anon_sym_LPAREN,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    STATE(7083), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 25,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
    ACTIONS(67), 26,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
  [53187] = 5,
    ACTIONS(6862), 1,
      anon_sym_LPAREN,
    ACTIONS(6864), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5470), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5468), 35,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [53256] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3781), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [53321] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5454), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5452), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [53386] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5528), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5526), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [53451] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5544), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(5542), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [53516] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_CARET,
    ACTIONS(3415), 36,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_or_else,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
  [53581] = 5,
    ACTIONS(6866), 1,
      anon_sym_DOT2,
    STATE(2944), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [53649] = 9,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(6872), 1,
      sym_uninitialized,
    ACTIONS(6874), 1,
      sym_tag,
    STATE(2994), 1,
      sym_where_clause,
    STATE(3235), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [53725] = 9,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6880), 1,
      sym_uninitialized,
    ACTIONS(6882), 1,
      sym_tag,
    STATE(3168), 1,
      sym_where_clause,
    STATE(3668), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [53801] = 6,
    ACTIONS(6866), 1,
      anon_sym_DOT2,
    ACTIONS(6884), 1,
      anon_sym_COLON,
    STATE(2944), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [53871] = 6,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      sym_uninitialized,
    STATE(3072), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4083), 28,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_tag,
  [53941] = 10,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6890), 1,
      anon_sym_DASH_GT,
    ACTIONS(6892), 1,
      sym_uninitialized,
    ACTIONS(6894), 1,
      sym_tag,
    STATE(3295), 1,
      sym_where_clause,
    STATE(3667), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4117), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4113), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [54019] = 6,
    ACTIONS(6860), 1,
      anon_sym_DOT2,
    ACTIONS(6896), 1,
      anon_sym_COLON,
    STATE(2801), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 41,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [54089] = 9,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6880), 1,
      sym_uninitialized,
    ACTIONS(6898), 1,
      sym_tag,
    STATE(3168), 1,
      sym_where_clause,
    STATE(3668), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [54165] = 11,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6880), 1,
      sym_uninitialized,
    ACTIONS(6898), 1,
      sym_tag,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    STATE(3168), 1,
      sym_where_clause,
    STATE(3668), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [54245] = 6,
    ACTIONS(6904), 1,
      anon_sym_LBRACE,
    ACTIONS(6907), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4600), 28,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [54315] = 11,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6910), 1,
      sym_uninitialized,
    ACTIONS(6912), 1,
      sym_tag,
    STATE(3294), 1,
      sym_where_clause,
    STATE(3709), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [54395] = 9,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6910), 1,
      sym_uninitialized,
    ACTIONS(6912), 1,
      sym_tag,
    STATE(3294), 1,
      sym_where_clause,
    STATE(3709), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [54471] = 9,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6910), 1,
      sym_uninitialized,
    ACTIONS(6914), 1,
      sym_tag,
    STATE(3294), 1,
      sym_where_clause,
    STATE(3709), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [54547] = 9,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6916), 1,
      sym_uninitialized,
    ACTIONS(6918), 1,
      sym_tag,
    STATE(3200), 1,
      sym_where_clause,
    STATE(3661), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [54623] = 11,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6916), 1,
      sym_uninitialized,
    ACTIONS(6918), 1,
      sym_tag,
    STATE(3200), 1,
      sym_where_clause,
    STATE(3661), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [54703] = 7,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6920), 1,
      sym_uninitialized,
    ACTIONS(6922), 1,
      sym_tag,
    STATE(3055), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3415), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [54775] = 6,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6920), 1,
      sym_uninitialized,
    STATE(3055), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3415), 28,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_tag,
  [54845] = 5,
    ACTIONS(6924), 1,
      anon_sym_LBRACE,
    STATE(2919), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4623), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4618), 29,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [54913] = 4,
    STATE(2919), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4536), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4534), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [54979] = 7,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      sym_uninitialized,
    ACTIONS(6929), 1,
      sym_tag,
    STATE(3081), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4023), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [55051] = 7,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6931), 1,
      sym_uninitialized,
    ACTIONS(6933), 1,
      sym_tag,
    STATE(3018), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3781), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [55123] = 6,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      sym_uninitialized,
    STATE(3081), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4023), 28,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_tag,
  [55193] = 9,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(6935), 1,
      sym_uninitialized,
    ACTIONS(6937), 1,
      sym_tag,
    STATE(2990), 1,
      sym_where_clause,
    STATE(3243), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [55269] = 6,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6931), 1,
      sym_uninitialized,
    STATE(3018), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3781), 28,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_tag,
  [55339] = 9,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6939), 1,
      sym_uninitialized,
    ACTIONS(6941), 1,
      sym_tag,
    STATE(3348), 1,
      sym_where_clause,
    STATE(3707), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [55415] = 7,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6943), 1,
      sym_uninitialized,
    ACTIONS(6945), 1,
      sym_tag,
    STATE(3085), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3671), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [55487] = 6,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6943), 1,
      sym_uninitialized,
    STATE(3085), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3671), 28,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_tag,
  [55557] = 6,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6947), 1,
      sym_uninitialized,
    STATE(3088), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4667), 28,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_tag,
  [55627] = 7,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6947), 1,
      sym_uninitialized,
    ACTIONS(6949), 1,
      sym_tag,
    STATE(3088), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4667), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [55699] = 10,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(6951), 1,
      anon_sym_DASH_GT,
    ACTIONS(6953), 1,
      sym_uninitialized,
    ACTIONS(6955), 1,
      sym_tag,
    STATE(3019), 1,
      sym_where_clause,
    STATE(3176), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [55777] = 7,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      sym_uninitialized,
    ACTIONS(6957), 1,
      sym_tag,
    STATE(3072), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4083), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [55849] = 10,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6959), 1,
      anon_sym_DASH_GT,
    ACTIONS(6961), 1,
      sym_uninitialized,
    ACTIONS(6963), 1,
      sym_tag,
    STATE(3273), 1,
      sym_where_clause,
    STATE(3656), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [55927] = 6,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6965), 1,
      sym_uninitialized,
    STATE(3090), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4691), 28,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_tag,
  [55997] = 33,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6701), 1,
      anon_sym_or_return,
    ACTIONS(6703), 1,
      anon_sym_or_continue,
    ACTIONS(6707), 1,
      anon_sym_CARET,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6749), 1,
      anon_sym_PIPE,
    ACTIONS(6753), 1,
      anon_sym_TILDE,
    ACTIONS(6755), 1,
      anon_sym_AMP,
    ACTIONS(6757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6759), 1,
      anon_sym_or_else,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6769), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6775), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6777), 1,
      anon_sym_or_break,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6839), 1,
      anon_sym_EQ,
    ACTIONS(6841), 1,
      anon_sym_COLON,
    ACTIONS(6843), 1,
      anon_sym_COLON_EQ,
    ACTIONS(6967), 1,
      anon_sym_COMMA,
    ACTIONS(6969), 1,
      anon_sym_do,
    STATE(6501), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    STATE(6836), 1,
      sym_block,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6751), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6763), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6765), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6771), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6783), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6767), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6773), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6845), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
  [56121] = 4,
    STATE(2919), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4568), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4566), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [56187] = 10,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(6971), 1,
      anon_sym_DASH_GT,
    ACTIONS(6973), 1,
      sym_uninitialized,
    ACTIONS(6975), 1,
      sym_tag,
    STATE(3040), 1,
      sym_where_clause,
    STATE(3162), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4117), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4113), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [56265] = 11,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6979), 1,
      anon_sym_SLASH,
    ACTIONS(6981), 1,
      sym_uninitialized,
    ACTIONS(6983), 1,
      sym_tag,
    STATE(3014), 1,
      sym_where_clause,
    STATE(3199), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [56345] = 9,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(6981), 1,
      sym_uninitialized,
    ACTIONS(6983), 1,
      sym_tag,
    STATE(3014), 1,
      sym_where_clause,
    STATE(3199), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [56421] = 33,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6667), 1,
      anon_sym_PIPE,
    ACTIONS(6671), 1,
      anon_sym_TILDE,
    ACTIONS(6673), 1,
      anon_sym_AMP,
    ACTIONS(6675), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6677), 1,
      anon_sym_or_else,
    ACTIONS(6679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6687), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6701), 1,
      anon_sym_or_return,
    ACTIONS(6703), 1,
      anon_sym_or_continue,
    ACTIONS(6705), 1,
      anon_sym_or_break,
    ACTIONS(6707), 1,
      anon_sym_CARET,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6967), 1,
      anon_sym_COMMA,
    ACTIONS(6985), 1,
      anon_sym_EQ,
    ACTIONS(6987), 1,
      anon_sym_COLON_EQ,
    ACTIONS(6991), 1,
      anon_sym_SEMI,
    ACTIONS(6993), 1,
      anon_sym_do,
    STATE(6532), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    STATE(7176), 1,
      sym_block,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6681), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6683), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6719), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6989), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
  [56545] = 5,
    ACTIONS(6995), 1,
      anon_sym_DOT2,
    STATE(2941), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4453), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [56613] = 10,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6998), 1,
      anon_sym_DASH_GT,
    ACTIONS(7000), 1,
      sym_uninitialized,
    ACTIONS(7002), 1,
      sym_tag,
    STATE(2922), 1,
      sym_where_clause,
    STATE(3038), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4117), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4113), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [56691] = 10,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6931), 1,
      sym_uninitialized,
    ACTIONS(6933), 1,
      sym_tag,
    ACTIONS(7004), 1,
      anon_sym_DASH_GT,
    STATE(2917), 1,
      sym_where_clause,
    STATE(3018), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [56769] = 5,
    ACTIONS(6866), 1,
      anon_sym_DOT2,
    STATE(2941), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4496), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4494), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [56837] = 11,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6979), 1,
      anon_sym_SLASH,
    ACTIONS(7006), 1,
      sym_uninitialized,
    ACTIONS(7008), 1,
      sym_tag,
    STATE(2998), 1,
      sym_where_clause,
    STATE(3218), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [56917] = 33,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6701), 1,
      anon_sym_or_return,
    ACTIONS(6703), 1,
      anon_sym_or_continue,
    ACTIONS(6707), 1,
      anon_sym_CARET,
    ACTIONS(6735), 1,
      anon_sym_DASH_GT,
    ACTIONS(6737), 1,
      anon_sym_DOT,
    ACTIONS(6749), 1,
      anon_sym_PIPE,
    ACTIONS(6753), 1,
      anon_sym_TILDE,
    ACTIONS(6755), 1,
      anon_sym_AMP,
    ACTIONS(6757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6759), 1,
      anon_sym_or_else,
    ACTIONS(6761), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6769), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6775), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6777), 1,
      anon_sym_or_break,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6839), 1,
      anon_sym_EQ,
    ACTIONS(6841), 1,
      anon_sym_COLON,
    ACTIONS(6843), 1,
      anon_sym_COLON_EQ,
    ACTIONS(6967), 1,
      anon_sym_COMMA,
    ACTIONS(7010), 1,
      anon_sym_do,
    STATE(6501), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    STATE(6904), 1,
      sym_block,
    ACTIONS(6739), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6751), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6763), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6765), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6771), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6783), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6767), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6773), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6845), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
  [57041] = 9,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7006), 1,
      sym_uninitialized,
    ACTIONS(7008), 1,
      sym_tag,
    STATE(2998), 1,
      sym_where_clause,
    STATE(3218), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [57117] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 24,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_DOT2,
      sym_identifier,
    ACTIONS(4453), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [57181] = 9,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7006), 1,
      sym_uninitialized,
    ACTIONS(7012), 1,
      sym_tag,
    STATE(2998), 1,
      sym_where_clause,
    STATE(3218), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [57257] = 33,
    ACTIONS(6665), 1,
      anon_sym_DASH_GT,
    ACTIONS(6667), 1,
      anon_sym_PIPE,
    ACTIONS(6671), 1,
      anon_sym_TILDE,
    ACTIONS(6673), 1,
      anon_sym_AMP,
    ACTIONS(6675), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6677), 1,
      anon_sym_or_else,
    ACTIONS(6679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6687), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6693), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6695), 1,
      anon_sym_DOT,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6701), 1,
      anon_sym_or_return,
    ACTIONS(6703), 1,
      anon_sym_or_continue,
    ACTIONS(6705), 1,
      anon_sym_or_break,
    ACTIONS(6707), 1,
      anon_sym_CARET,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6967), 1,
      anon_sym_COMMA,
    ACTIONS(6985), 1,
      anon_sym_EQ,
    ACTIONS(6987), 1,
      anon_sym_COLON_EQ,
    ACTIONS(7014), 1,
      anon_sym_SEMI,
    ACTIONS(7016), 1,
      anon_sym_do,
    STATE(6532), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    STATE(7176), 1,
      sym_block,
    ACTIONS(6669), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6681), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6683), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6689), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6699), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6719), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6685), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6691), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6989), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
  [57381] = 4,
    STATE(2919), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4548), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4546), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [57447] = 11,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(6872), 1,
      sym_uninitialized,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6979), 1,
      anon_sym_SLASH,
    ACTIONS(7018), 1,
      sym_tag,
    STATE(2994), 1,
      sym_where_clause,
    STATE(3235), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [57527] = 9,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(6872), 1,
      sym_uninitialized,
    ACTIONS(7018), 1,
      sym_tag,
    STATE(2994), 1,
      sym_where_clause,
    STATE(3235), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [57603] = 11,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6920), 1,
      sym_uninitialized,
    ACTIONS(7020), 1,
      sym_tag,
    STATE(2932), 1,
      sym_where_clause,
    STATE(3055), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [57683] = 9,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6920), 1,
      sym_uninitialized,
    ACTIONS(7020), 1,
      sym_tag,
    STATE(2932), 1,
      sym_where_clause,
    STATE(3055), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [57759] = 11,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      sym_uninitialized,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(7022), 1,
      sym_tag,
    STATE(2921), 1,
      sym_where_clause,
    STATE(3072), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [57839] = 9,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      sym_uninitialized,
    ACTIONS(7022), 1,
      sym_tag,
    STATE(2921), 1,
      sym_where_clause,
    STATE(3072), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [57915] = 9,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      sym_uninitialized,
    ACTIONS(6957), 1,
      sym_tag,
    STATE(2921), 1,
      sym_where_clause,
    STATE(3072), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [57991] = 11,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(6927), 1,
      sym_uninitialized,
    ACTIONS(7024), 1,
      sym_tag,
    STATE(2927), 1,
      sym_where_clause,
    STATE(3081), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [58071] = 9,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      sym_uninitialized,
    ACTIONS(7024), 1,
      sym_tag,
    STATE(2927), 1,
      sym_where_clause,
    STATE(3081), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [58147] = 9,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      sym_uninitialized,
    ACTIONS(6929), 1,
      sym_tag,
    STATE(2927), 1,
      sym_where_clause,
    STATE(3081), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [58223] = 9,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6943), 1,
      sym_uninitialized,
    ACTIONS(6945), 1,
      sym_tag,
    STATE(2930), 1,
      sym_where_clause,
    STATE(3085), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [58299] = 11,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7028), 1,
      sym_uninitialized,
    ACTIONS(7030), 1,
      sym_tag,
    STATE(3175), 1,
      sym_where_clause,
    STATE(3888), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 35,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [58378] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(913), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [58441] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5618), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5616), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [58504] = 10,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7032), 1,
      anon_sym_DASH_GT,
    ACTIONS(7034), 1,
      sym_uninitialized,
    ACTIONS(7036), 1,
      sym_tag,
    STATE(3301), 1,
      sym_where_clause,
    STATE(3756), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4117), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4113), 35,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [58581] = 10,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7038), 1,
      anon_sym_DASH_GT,
    ACTIONS(7040), 1,
      sym_uninitialized,
    ACTIONS(7042), 1,
      sym_tag,
    STATE(3298), 1,
      sym_where_clause,
    STATE(3720), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 35,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [58658] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5608), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5606), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [58721] = 27,
    ACTIONS(7044), 1,
      anon_sym_COMMA,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7048), 1,
      anon_sym_PIPE,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7054), 1,
      anon_sym_TILDE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7068), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7082), 1,
      anon_sym_or_return,
    ACTIONS(7084), 1,
      anon_sym_or_continue,
    ACTIONS(7086), 1,
      anon_sym_or_break,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    STATE(2971), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(4732), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7058), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7062), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7064), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7066), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4728), 18,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_not_in,
      sym_uninitialized,
      sym_tag,
  [58832] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5528), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5526), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [58895] = 5,
    ACTIONS(7044), 1,
      anon_sym_COMMA,
    STATE(2972), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4665), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4661), 40,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [58962] = 5,
    ACTIONS(7090), 1,
      anon_sym_COMMA,
    STATE(2972), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4722), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4717), 40,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [59029] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5538), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5536), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [59092] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5560), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5558), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [59155] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5572), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5570), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [59218] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5582), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5580), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [59281] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5588), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5586), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [59344] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5524), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5522), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [59407] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5490), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5488), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [59470] = 4,
    ACTIONS(7093), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(67), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [59535] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(767), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [59598] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4185), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [59661] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4858), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4856), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [59724] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(201), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [59787] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5610), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [59850] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5626), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5624), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [59913] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5630), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5628), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [59976] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5636), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5634), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [60039] = 6,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(7095), 1,
      sym_uninitialized,
    STATE(3253), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4691), 39,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_tag,
  [60108] = 7,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(7097), 1,
      sym_uninitialized,
    ACTIONS(7099), 1,
      sym_tag,
    STATE(3248), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [60179] = 6,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(7097), 1,
      sym_uninitialized,
    STATE(3248), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 39,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_tag,
  [60248] = 6,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6935), 1,
      sym_uninitialized,
    STATE(3243), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 39,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_tag,
  [60317] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5544), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5542), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [60380] = 7,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6935), 1,
      sym_uninitialized,
    ACTIONS(6937), 1,
      sym_tag,
    STATE(3243), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [60451] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5474), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5472), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [60514] = 10,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7101), 1,
      anon_sym_DASH_GT,
    ACTIONS(7103), 1,
      sym_uninitialized,
    ACTIONS(7105), 1,
      sym_tag,
    STATE(3351), 1,
      sym_where_clause,
    STATE(3821), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4117), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4113), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [60591] = 6,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6872), 1,
      sym_uninitialized,
    STATE(3235), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 39,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_tag,
  [60660] = 7,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6872), 1,
      sym_uninitialized,
    ACTIONS(6874), 1,
      sym_tag,
    STATE(3235), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [60731] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(815), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [60794] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5672), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5670), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [60857] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5692), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [60920] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5692), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [60983] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5710), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5708), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [61046] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5766), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5764), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [61109] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5770), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5768), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [61172] = 5,
    ACTIONS(7107), 1,
      anon_sym_LBRACE,
    STATE(3006), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4623), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4618), 40,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [61239] = 9,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7110), 1,
      sym_uninitialized,
    ACTIONS(7112), 1,
      sym_tag,
    STATE(3303), 1,
      sym_where_clause,
    STATE(3889), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [61314] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4864), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4862), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [61377] = 5,
    ACTIONS(7114), 1,
      anon_sym_COMMA,
    STATE(3009), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4722), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4717), 40,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [61444] = 9,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7117), 1,
      sym_uninitialized,
    ACTIONS(7119), 1,
      sym_tag,
    STATE(3316), 1,
      sym_where_clause,
    STATE(3884), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [61519] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5454), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5452), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [61582] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5812), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5810), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [61645] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5822), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5820), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [61708] = 7,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(7006), 1,
      sym_uninitialized,
    ACTIONS(7012), 1,
      sym_tag,
    STATE(3218), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [61779] = 9,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7117), 1,
      sym_uninitialized,
    ACTIONS(7121), 1,
      sym_tag,
    STATE(3316), 1,
      sym_where_clause,
    STATE(3884), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [61854] = 11,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6979), 1,
      anon_sym_SLASH,
    ACTIONS(7117), 1,
      sym_uninitialized,
    ACTIONS(7121), 1,
      sym_tag,
    STATE(3316), 1,
      sym_where_clause,
    STATE(3884), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [61933] = 6,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(7006), 1,
      sym_uninitialized,
    STATE(3218), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 39,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_tag,
  [62002] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3415), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [62065] = 7,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6981), 1,
      sym_uninitialized,
    ACTIONS(7123), 1,
      sym_tag,
    STATE(3199), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [62136] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(891), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [62199] = 6,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6981), 1,
      sym_uninitialized,
    STATE(3199), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 39,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_tag,
  [62268] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5826), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5824), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [62331] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5840), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [62394] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5840), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [62457] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5848), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5846), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [62520] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5850), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [62583] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5850), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [62646] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5874), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5872), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [62709] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5884), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5882), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [62772] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5384), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5382), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [62835] = 32,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6543), 1,
      anon_sym_or_return,
    ACTIONS(6545), 1,
      anon_sym_or_continue,
    ACTIONS(6549), 1,
      anon_sym_CARET,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_TILDE,
    ACTIONS(6608), 1,
      anon_sym_AMP,
    ACTIONS(6610), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6612), 1,
      anon_sym_or_else,
    ACTIONS(6614), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6622), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6628), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6633), 1,
      anon_sym_or_break,
    ACTIONS(6967), 1,
      anon_sym_COMMA,
    ACTIONS(7125), 1,
      anon_sym_RBRACE,
    ACTIONS(7127), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7129), 1,
      anon_sym_EQ,
    ACTIONS(7131), 1,
      anon_sym_COLON,
    ACTIONS(7133), 1,
      anon_sym_COLON_EQ,
    STATE(6493), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6604), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6616), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6618), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6624), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6639), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6620), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7135), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
  [62956] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5446), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5444), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [63019] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5880), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5878), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [63082] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5858), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5856), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [63145] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5784), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5782), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [63208] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5378), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [63271] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5378), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [63334] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3781), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [63397] = 9,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7137), 1,
      sym_uninitialized,
    ACTIONS(7139), 1,
      sym_tag,
    STATE(3354), 1,
      sym_where_clause,
    STATE(3860), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [63472] = 7,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6953), 1,
      sym_uninitialized,
    ACTIONS(6955), 1,
      sym_tag,
    STATE(3176), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [63543] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5434), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5432), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [63606] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5758), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5756), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [63669] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5754), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5752), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [63732] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5748), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5746), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [63795] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5734), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [63858] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5734), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [63921] = 6,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6953), 1,
      sym_uninitialized,
    STATE(3176), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 39,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_tag,
  [63990] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5732), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5730), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [64053] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5728), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5726), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [64116] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5430), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5428), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [64179] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5418), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5416), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [64242] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5724), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5722), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [64305] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5706), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5704), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [64368] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5714), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5712), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [64431] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4083), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [64494] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5458), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5456), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [64557] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5702), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5700), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [64620] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5414), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5412), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [64683] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5698), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5696), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [64746] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5410), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5408), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [64809] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5690), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5688), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [64872] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5676), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5674), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [64935] = 9,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7143), 1,
      sym_uninitialized,
    ACTIONS(7145), 1,
      sym_tag,
    STATE(3443), 1,
      sym_where_clause,
    STATE(3807), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [65010] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5668), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5666), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [65073] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5402), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5400), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [65136] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5660), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5658), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [65199] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5656), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5654), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [65262] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5398), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5396), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [65325] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5652), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5650), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [65388] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5642), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5640), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [65451] = 9,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      sym_uninitialized,
    ACTIONS(7149), 1,
      sym_tag,
    STATE(3425), 1,
      sym_where_clause,
    STATE(3804), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [65526] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4023), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [65589] = 9,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      sym_uninitialized,
    ACTIONS(7151), 1,
      sym_tag,
    STATE(3425), 1,
      sym_where_clause,
    STATE(3804), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [65664] = 11,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6979), 1,
      anon_sym_SLASH,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      sym_uninitialized,
    ACTIONS(7151), 1,
      sym_tag,
    STATE(3425), 1,
      sym_where_clause,
    STATE(3804), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [65743] = 5,
    ACTIONS(7153), 1,
      anon_sym_COMMA,
    STATE(3009), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4665), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4661), 40,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [65810] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5376), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5374), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [65873] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5372), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5370), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [65936] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5368), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5366), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [65999] = 5,
    ACTIONS(7155), 1,
      sym_identifier,
    ACTIONS(7157), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 22,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 29,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [66066] = 6,
    ACTIONS(7159), 1,
      anon_sym_LBRACE,
    ACTIONS(7162), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 39,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [66135] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3671), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [66198] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5346), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5344), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [66261] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5342), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5340), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [66324] = 9,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7165), 1,
      sym_uninitialized,
    ACTIONS(7167), 1,
      sym_tag,
    STATE(3414), 1,
      sym_where_clause,
    STATE(3798), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [66399] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4667), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [66462] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5338), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5336), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [66525] = 9,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7169), 1,
      sym_uninitialized,
    ACTIONS(7171), 1,
      sym_tag,
    STATE(3321), 1,
      sym_where_clause,
    STATE(3876), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [66600] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4691), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [66663] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5334), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5332), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [66726] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5498), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5496), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [66789] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5280), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5278), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [66852] = 9,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7169), 1,
      sym_uninitialized,
    ACTIONS(7173), 1,
      sym_tag,
    STATE(3321), 1,
      sym_where_clause,
    STATE(3876), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [66927] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5268), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5266), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [66990] = 9,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7165), 1,
      sym_uninitialized,
    ACTIONS(7175), 1,
      sym_tag,
    STATE(3414), 1,
      sym_where_clause,
    STATE(3798), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [67065] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5438), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5436), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [67128] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4920), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [67191] = 11,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6979), 1,
      anon_sym_SLASH,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7165), 1,
      sym_uninitialized,
    ACTIONS(7175), 1,
      sym_tag,
    STATE(3414), 1,
      sym_where_clause,
    STATE(3798), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [67270] = 9,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7177), 1,
      sym_uninitialized,
    ACTIONS(7179), 1,
      sym_tag,
    STATE(3407), 1,
      sym_where_clause,
    STATE(3809), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [67345] = 11,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6979), 1,
      anon_sym_SLASH,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7177), 1,
      sym_uninitialized,
    ACTIONS(7179), 1,
      sym_tag,
    STATE(3407), 1,
      sym_where_clause,
    STATE(3809), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [67424] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5556), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5554), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [67487] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4623), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4618), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [67550] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5552), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5550), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [67613] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4928), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4926), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [67676] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4950), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4948), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [67739] = 10,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7181), 1,
      anon_sym_DASH_GT,
    ACTIONS(7183), 1,
      sym_uninitialized,
    ACTIONS(7185), 1,
      sym_tag,
    STATE(3439), 1,
      sym_where_clause,
    STATE(3768), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [67816] = 10,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7187), 1,
      anon_sym_DASH_GT,
    ACTIONS(7189), 1,
      sym_uninitialized,
    ACTIONS(7191), 1,
      sym_tag,
    STATE(3375), 1,
      sym_where_clause,
    STATE(3764), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4117), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4113), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [67893] = 11,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6979), 1,
      anon_sym_SLASH,
    ACTIONS(7169), 1,
      sym_uninitialized,
    ACTIONS(7173), 1,
      sym_tag,
    STATE(3321), 1,
      sym_where_clause,
    STATE(3876), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [67972] = 5,
    ACTIONS(7093), 1,
      anon_sym_LPAREN,
    ACTIONS(7193), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 22,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [68039] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4972), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4970), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [68102] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4990), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4988), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [68165] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5096), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5094), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [68228] = 4,
    ACTIONS(7195), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4701), 22,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(4697), 30,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [68293] = 27,
    ACTIONS(7153), 1,
      anon_sym_COMMA,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7199), 1,
      anon_sym_PIPE,
    ACTIONS(7201), 1,
      anon_sym_PLUS,
    ACTIONS(7203), 1,
      anon_sym_DASH,
    ACTIONS(7205), 1,
      anon_sym_TILDE,
    ACTIONS(7207), 1,
      anon_sym_AMP,
    ACTIONS(7211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7219), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7233), 1,
      anon_sym_or_return,
    ACTIONS(7235), 1,
      anon_sym_or_continue,
    ACTIONS(7237), 1,
      anon_sym_or_break,
    ACTIONS(7239), 1,
      anon_sym_CARET,
    STATE(3075), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(4732), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7221), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7217), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4728), 18,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
      sym_uninitialized,
      sym_tag,
  [68404] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5112), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5110), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [68467] = 11,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6979), 1,
      anon_sym_SLASH,
    ACTIONS(7137), 1,
      sym_uninitialized,
    ACTIONS(7139), 1,
      sym_tag,
    STATE(3354), 1,
      sym_where_clause,
    STATE(3860), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [68546] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5276), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5274), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [68609] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5060), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5058), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [68672] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5154), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5152), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [68735] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5158), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5156), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [68798] = 4,
    STATE(3006), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4536), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4534), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [68863] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5568), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5566), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [68926] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5170), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5168), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [68989] = 4,
    ACTIONS(7241), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4701), 22,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(4697), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [69054] = 9,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7243), 1,
      sym_uninitialized,
    ACTIONS(7245), 1,
      sym_tag,
    STATE(3293), 1,
      sym_where_clause,
    STATE(3773), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [69129] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5202), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5200), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [69192] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5206), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5204), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [69255] = 6,
    ACTIONS(7247), 1,
      anon_sym_COLON,
    ACTIONS(7249), 1,
      anon_sym_DOT2,
    STATE(3178), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [69324] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5218), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5216), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [69387] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5246), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5244), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [69450] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5258), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5256), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [69513] = 11,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7251), 1,
      sym_uninitialized,
    ACTIONS(7253), 1,
      sym_tag,
    STATE(3181), 1,
      sym_where_clause,
    STATE(3833), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 35,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [69592] = 9,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7251), 1,
      sym_uninitialized,
    ACTIONS(7253), 1,
      sym_tag,
    STATE(3181), 1,
      sym_where_clause,
    STATE(3833), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [69667] = 11,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_uninitialized,
    ACTIONS(7257), 1,
      sym_tag,
    STATE(3165), 1,
      sym_where_clause,
    STATE(3909), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 35,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [69746] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5135), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5132), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [69809] = 9,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_uninitialized,
    ACTIONS(7257), 1,
      sym_tag,
    STATE(3165), 1,
      sym_where_clause,
    STATE(3909), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [69884] = 9,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7028), 1,
      sym_uninitialized,
    ACTIONS(7259), 1,
      sym_tag,
    STATE(3175), 1,
      sym_where_clause,
    STATE(3888), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [69959] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_DOT2,
    ACTIONS(4453), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [70022] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5356), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5354), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [70085] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5272), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5270), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [70148] = 10,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6870), 1,
      anon_sym_where,
    ACTIONS(7261), 1,
      anon_sym_DASH_GT,
    ACTIONS(7263), 1,
      sym_uninitialized,
    ACTIONS(7265), 1,
      sym_tag,
    STATE(3147), 1,
      sym_where_clause,
    STATE(3832), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [70225] = 9,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7028), 1,
      sym_uninitialized,
    ACTIONS(7030), 1,
      sym_tag,
    STATE(3175), 1,
      sym_where_clause,
    STATE(3888), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [70300] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5350), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5348), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [70363] = 9,
    ACTIONS(6878), 1,
      anon_sym_where,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_uninitialized,
    ACTIONS(7267), 1,
      sym_tag,
    STATE(3165), 1,
      sym_where_clause,
    STATE(3909), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [70438] = 4,
    STATE(3006), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4548), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4546), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [70503] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 23,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(859), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [70566] = 4,
    STATE(3006), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4568), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4566), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [70631] = 7,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7137), 1,
      sym_uninitialized,
    ACTIONS(7269), 1,
      sym_tag,
    STATE(3860), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [70701] = 9,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7275), 1,
      sym_uninitialized,
    ACTIONS(7277), 1,
      sym_tag,
    STATE(3372), 1,
      sym_where_clause,
    STATE(3609), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [70775] = 13,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7201), 1,
      anon_sym_PLUS,
    ACTIONS(7203), 1,
      anon_sym_DASH,
    ACTIONS(7219), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7221), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 31,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [70857] = 20,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7199), 1,
      anon_sym_PIPE,
    ACTIONS(7201), 1,
      anon_sym_PLUS,
    ACTIONS(7203), 1,
      anon_sym_DASH,
    ACTIONS(7205), 1,
      anon_sym_TILDE,
    ACTIONS(7207), 1,
      anon_sym_AMP,
    ACTIONS(7211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7219), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(5360), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7221), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7217), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 25,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [70953] = 19,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7199), 1,
      anon_sym_PIPE,
    ACTIONS(7201), 1,
      anon_sym_PLUS,
    ACTIONS(7203), 1,
      anon_sym_DASH,
    ACTIONS(7205), 1,
      anon_sym_TILDE,
    ACTIONS(7207), 1,
      anon_sym_AMP,
    ACTIONS(7219), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(5360), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7221), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7217), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 26,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [71047] = 17,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7199), 1,
      anon_sym_PIPE,
    ACTIONS(7201), 1,
      anon_sym_PLUS,
    ACTIONS(7203), 1,
      anon_sym_DASH,
    ACTIONS(7205), 1,
      anon_sym_TILDE,
    ACTIONS(7207), 1,
      anon_sym_AMP,
    ACTIONS(7219), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7221), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7217), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5360), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 28,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [71137] = 16,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7199), 1,
      anon_sym_PIPE,
    ACTIONS(7201), 1,
      anon_sym_PLUS,
    ACTIONS(7203), 1,
      anon_sym_DASH,
    ACTIONS(7205), 1,
      anon_sym_TILDE,
    ACTIONS(7207), 1,
      anon_sym_AMP,
    ACTIONS(7219), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7221), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 31,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [71225] = 12,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7201), 1,
      anon_sym_PLUS,
    ACTIONS(7203), 1,
      anon_sym_DASH,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7221), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 32,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [71305] = 11,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7201), 1,
      anon_sym_PLUS,
    ACTIONS(7203), 1,
      anon_sym_DASH,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 34,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [71383] = 7,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5358), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [71453] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5538), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5536), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [71515] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5560), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5558), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [71577] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5572), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5570), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [71639] = 25,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7199), 1,
      anon_sym_PIPE,
    ACTIONS(7201), 1,
      anon_sym_PLUS,
    ACTIONS(7203), 1,
      anon_sym_DASH,
    ACTIONS(7205), 1,
      anon_sym_TILDE,
    ACTIONS(7207), 1,
      anon_sym_AMP,
    ACTIONS(7211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7219), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7233), 1,
      anon_sym_or_return,
    ACTIONS(7235), 1,
      anon_sym_or_continue,
    ACTIONS(7237), 1,
      anon_sym_or_break,
    ACTIONS(7239), 1,
      anon_sym_CARET,
    ACTIONS(5774), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7221), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7217), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5772), 19,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
      sym_uninitialized,
      sym_tag,
  [71745] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5588), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5586), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [71807] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [71869] = 7,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5600), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [71939] = 5,
    ACTIONS(7279), 1,
      anon_sym_DOT2,
    STATE(3164), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4453), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [72005] = 7,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7028), 1,
      sym_uninitialized,
    ACTIONS(7259), 1,
      sym_tag,
    STATE(3888), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4023), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [72075] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5454), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5452), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [72137] = 20,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7048), 1,
      anon_sym_PIPE,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7054), 1,
      anon_sym_TILDE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7068), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(5360), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7062), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7064), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7066), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 25,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [72233] = 7,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6910), 1,
      sym_uninitialized,
    ACTIONS(6914), 1,
      sym_tag,
    STATE(3709), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [72303] = 5,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6979), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5450), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5448), 40,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [72369] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(201), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [72431] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5610), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [72493] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5626), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5624), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [72555] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5630), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5628), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [72617] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5636), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5634), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [72679] = 7,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7243), 1,
      sym_uninitialized,
    ACTIONS(7245), 1,
      sym_tag,
    STATE(3773), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3671), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [72749] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [72811] = 31,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6543), 1,
      anon_sym_or_return,
    ACTIONS(6545), 1,
      anon_sym_or_continue,
    ACTIONS(6549), 1,
      anon_sym_CARET,
    ACTIONS(6596), 1,
      anon_sym_DASH_GT,
    ACTIONS(6598), 1,
      anon_sym_DOT,
    ACTIONS(6602), 1,
      anon_sym_PIPE,
    ACTIONS(6606), 1,
      anon_sym_TILDE,
    ACTIONS(6608), 1,
      anon_sym_AMP,
    ACTIONS(6610), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6612), 1,
      anon_sym_or_else,
    ACTIONS(6614), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6622), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6628), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6633), 1,
      anon_sym_or_break,
    ACTIONS(6967), 1,
      anon_sym_COMMA,
    ACTIONS(7127), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7131), 1,
      anon_sym_COLON,
    ACTIONS(7133), 1,
      anon_sym_COLON_EQ,
    ACTIONS(7282), 1,
      anon_sym_EQ,
    STATE(6493), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(6600), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6604), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6616), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6618), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6624), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6639), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6620), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7135), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
  [72929] = 5,
    ACTIONS(7249), 1,
      anon_sym_DOT2,
    STATE(3164), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4496), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4494), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [72995] = 7,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5644), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [73065] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4864), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4862), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [73127] = 7,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_uninitialized,
    ACTIONS(7267), 1,
      sym_tag,
    STATE(3909), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4083), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [73197] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5446), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5444), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [73259] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5438), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5436), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [73321] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5434), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5432), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [73383] = 19,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7048), 1,
      anon_sym_PIPE,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7054), 1,
      anon_sym_TILDE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7068), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(5360), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7062), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7064), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7066), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 26,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [73477] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5430), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5428), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [73539] = 17,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7048), 1,
      anon_sym_PIPE,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7054), 1,
      anon_sym_TILDE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7068), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7066), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5360), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 28,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [73629] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(815), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [73691] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5418), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5416), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [73753] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5672), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5670), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [73815] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [73877] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [73939] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5710), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5708), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [74001] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5766), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5764), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [74063] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5770), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5768), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [74125] = 25,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7199), 1,
      anon_sym_PIPE,
    ACTIONS(7201), 1,
      anon_sym_PLUS,
    ACTIONS(7203), 1,
      anon_sym_DASH,
    ACTIONS(7205), 1,
      anon_sym_TILDE,
    ACTIONS(7207), 1,
      anon_sym_AMP,
    ACTIONS(7211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7219), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7233), 1,
      anon_sym_or_return,
    ACTIONS(7235), 1,
      anon_sym_or_continue,
    ACTIONS(7237), 1,
      anon_sym_or_break,
    ACTIONS(7239), 1,
      anon_sym_CARET,
    ACTIONS(5720), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7221), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7217), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 19,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
      sym_uninitialized,
      sym_tag,
  [74231] = 21,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7199), 1,
      anon_sym_PIPE,
    ACTIONS(7201), 1,
      anon_sym_PLUS,
    ACTIONS(7203), 1,
      anon_sym_DASH,
    ACTIONS(7205), 1,
      anon_sym_TILDE,
    ACTIONS(7207), 1,
      anon_sym_AMP,
    ACTIONS(7211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7219), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(5720), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7221), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7217), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 23,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [74329] = 16,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7048), 1,
      anon_sym_PIPE,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7054), 1,
      anon_sym_TILDE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7068), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [74417] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [74479] = 7,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6880), 1,
      sym_uninitialized,
    ACTIONS(6882), 1,
      sym_tag,
    STATE(3668), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [74549] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5812), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5810), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [74611] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5822), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5820), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [74673] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5414), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5412), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [74735] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5410), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5408), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [74797] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5402), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5400), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [74859] = 5,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6979), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 40,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [74925] = 12,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 32,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [75005] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(891), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [75067] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5398), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5396), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [75129] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5826), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5824), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [75191] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [75253] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [75315] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5848), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5846), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [75377] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5850), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [75439] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5850), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [75501] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5874), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5872), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [75563] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5884), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5882), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [75625] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [75687] = 25,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7048), 1,
      anon_sym_PIPE,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7054), 1,
      anon_sym_TILDE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7068), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7082), 1,
      anon_sym_or_return,
    ACTIONS(7084), 1,
      anon_sym_or_continue,
    ACTIONS(7086), 1,
      anon_sym_or_break,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(4722), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7058), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7062), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7064), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7066), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4717), 19,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_not_in,
      sym_uninitialized,
      sym_tag,
  [75793] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5384), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5382), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [75855] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5880), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5878), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [75917] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5858), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5856), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [75979] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5784), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5782), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [76041] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5378), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [76103] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5218), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5216), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [76165] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5376), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5374), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [76227] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5372), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5370), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [76289] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5368), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5366), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [76351] = 9,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 35,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [76425] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5758), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5756), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [76487] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5754), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5752), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [76549] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5748), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5746), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [76611] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5734), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [76673] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5734), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [76735] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [76797] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5732), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5730), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [76859] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5728), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5726), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [76921] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5346), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5344), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [76983] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5342), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5340), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [77045] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5724), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5722), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [77107] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5706), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5704), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [77169] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5714), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5712), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [77231] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [77293] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5458), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5456), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [77355] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5702), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5700), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [77417] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5338), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5336), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [77479] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5698), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5696), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [77541] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4691), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [77603] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5690), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5688), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [77665] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5676), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5674), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [77727] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5334), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5332), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [77789] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5668), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5666), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [77851] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5498), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5496), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [77913] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5660), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5658), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [77975] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5656), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5654), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [78037] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5280), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5278), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [78099] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5652), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5650), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [78161] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5642), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5640), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [78223] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5276), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5274), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [78285] = 5,
    ACTIONS(7249), 1,
      anon_sym_DOT2,
    STATE(3178), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [78351] = 26,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7199), 1,
      anon_sym_PIPE,
    ACTIONS(7201), 1,
      anon_sym_PLUS,
    ACTIONS(7203), 1,
      anon_sym_DASH,
    ACTIONS(7205), 1,
      anon_sym_TILDE,
    ACTIONS(7207), 1,
      anon_sym_AMP,
    ACTIONS(7211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7219), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7233), 1,
      anon_sym_or_return,
    ACTIONS(7235), 1,
      anon_sym_or_continue,
    ACTIONS(7237), 1,
      anon_sym_or_break,
    ACTIONS(7239), 1,
      anon_sym_CARET,
    ACTIONS(5422), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7221), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7284), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7217), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5420), 17,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_case,
      anon_sym_QMARK,
      sym_uninitialized,
      sym_tag,
  [78459] = 15,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7201), 1,
      anon_sym_PLUS,
    ACTIONS(7203), 1,
      anon_sym_DASH,
    ACTIONS(7205), 1,
      anon_sym_TILDE,
    ACTIONS(7207), 1,
      anon_sym_AMP,
    ACTIONS(7219), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7221), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 31,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [78545] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5356), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5354), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [78607] = 5,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5450), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5448), 40,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [78673] = 6,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6979), 1,
      anon_sym_SLASH,
    ACTIONS(7286), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5390), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5386), 40,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [78741] = 5,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 40,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [78807] = 5,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5484), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5482), 40,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [78873] = 5,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5466), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5464), 40,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [78939] = 11,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 34,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [79017] = 7,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5358), 37,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [79087] = 13,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7068), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [79169] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5350), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5348), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [79231] = 7,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6916), 1,
      sym_uninitialized,
    ACTIONS(7288), 1,
      sym_tag,
    STATE(3661), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [79301] = 10,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7290), 1,
      anon_sym_DASH_GT,
    ACTIONS(7292), 1,
      sym_uninitialized,
    ACTIONS(7294), 1,
      sym_tag,
    STATE(3397), 1,
      sym_where_clause,
    STATE(3526), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4117), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4113), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [79377] = 10,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7296), 1,
      anon_sym_DASH_GT,
    ACTIONS(7298), 1,
      sym_uninitialized,
    ACTIONS(7300), 1,
      sym_tag,
    STATE(3444), 1,
      sym_where_clause,
    STATE(3547), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [79453] = 11,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7304), 1,
      anon_sym_SLASH,
    ACTIONS(7306), 1,
      sym_uninitialized,
    ACTIONS(7308), 1,
      sym_tag,
    STATE(3448), 1,
      sym_where_clause,
    STATE(3572), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [79531] = 9,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7306), 1,
      sym_uninitialized,
    ACTIONS(7308), 1,
      sym_tag,
    STATE(3448), 1,
      sym_where_clause,
    STATE(3572), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [79605] = 11,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7304), 1,
      anon_sym_SLASH,
    ACTIONS(7310), 1,
      sym_uninitialized,
    ACTIONS(7312), 1,
      sym_tag,
    STATE(3454), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [79683] = 9,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7310), 1,
      sym_uninitialized,
    ACTIONS(7312), 1,
      sym_tag,
    STATE(3454), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [79757] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5272), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5270), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [79819] = 31,
    ACTIONS(6489), 1,
      anon_sym_DASH_GT,
    ACTIONS(6491), 1,
      anon_sym_DOT,
    ACTIONS(6493), 1,
      anon_sym_LBRACK,
    ACTIONS(6515), 1,
      anon_sym_TILDE,
    ACTIONS(6517), 1,
      anon_sym_AMP,
    ACTIONS(6519), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6525), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6527), 1,
      anon_sym_PIPE,
    ACTIONS(6531), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6533), 1,
      anon_sym_or_else,
    ACTIONS(6535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6543), 1,
      anon_sym_or_return,
    ACTIONS(6545), 1,
      anon_sym_or_continue,
    ACTIONS(6547), 1,
      anon_sym_or_break,
    ACTIONS(6549), 1,
      anon_sym_CARET,
    ACTIONS(6967), 1,
      anon_sym_COMMA,
    ACTIONS(7127), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7133), 1,
      anon_sym_COLON_EQ,
    ACTIONS(7282), 1,
      anon_sym_EQ,
    ACTIONS(7314), 1,
      anon_sym_COLON,
    STATE(6493), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(6495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6513), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6521), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6529), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(6537), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6539), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6523), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6541), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(7135), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
  [79937] = 5,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6979), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5484), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5482), 40,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [80003] = 11,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7275), 1,
      sym_uninitialized,
    ACTIONS(7277), 1,
      sym_tag,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7304), 1,
      anon_sym_SLASH,
    STATE(3372), 1,
      sym_where_clause,
    STATE(3609), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [80081] = 14,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7201), 1,
      anon_sym_PLUS,
    ACTIONS(7203), 1,
      anon_sym_DASH,
    ACTIONS(7207), 1,
      anon_sym_AMP,
    ACTIONS(7219), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7221), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 31,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [80165] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(913), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [80227] = 9,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7275), 1,
      sym_uninitialized,
    ACTIONS(7316), 1,
      sym_tag,
    STATE(3372), 1,
      sym_where_clause,
    STATE(3609), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [80301] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5268), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5266), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [80363] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5258), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5256), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [80425] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5556), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5554), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [80487] = 9,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7318), 1,
      sym_uninitialized,
    ACTIONS(7320), 1,
      sym_tag,
    STATE(3446), 1,
      sym_where_clause,
    STATE(3617), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [80561] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5582), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5580), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [80623] = 15,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7054), 1,
      anon_sym_TILDE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7068), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [80709] = 7,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7322), 1,
      sym_uninitialized,
    ACTIONS(7324), 1,
      sym_tag,
    STATE(3719), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4667), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [80779] = 7,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6939), 1,
      sym_uninitialized,
    ACTIONS(6941), 1,
      sym_tag,
    STATE(3707), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [80849] = 7,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6961), 1,
      sym_uninitialized,
    ACTIONS(6963), 1,
      sym_tag,
    STATE(3656), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [80919] = 4,
    ACTIONS(7157), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 40,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [80983] = 5,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6979), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5470), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5468), 40,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [81049] = 7,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7251), 1,
      sym_uninitialized,
    ACTIONS(7326), 1,
      sym_tag,
    STATE(3833), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3415), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [81119] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(859), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [81181] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5552), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5550), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [81243] = 7,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7040), 1,
      sym_uninitialized,
    ACTIONS(7042), 1,
      sym_tag,
    STATE(3720), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3781), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [81313] = 7,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5600), 37,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [81383] = 7,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7328), 1,
      sym_uninitialized,
    ACTIONS(7330), 1,
      sym_tag,
    STATE(3897), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [81453] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5544), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5542), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [81515] = 6,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(7332), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 39,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [81583] = 7,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5644), 37,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [81653] = 6,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(7334), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5390), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5386), 40,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [81721] = 25,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7048), 1,
      anon_sym_PIPE,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7054), 1,
      anon_sym_TILDE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7068), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7082), 1,
      anon_sym_or_return,
    ACTIONS(7084), 1,
      anon_sym_or_continue,
    ACTIONS(7086), 1,
      anon_sym_or_break,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(5720), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7058), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7062), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7064), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7066), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 19,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_not_in,
      sym_uninitialized,
      sym_tag,
  [81827] = 9,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7310), 1,
      sym_uninitialized,
    ACTIONS(7336), 1,
      sym_tag,
    STATE(3454), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [81901] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5060), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5058), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [81963] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5474), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5472), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [82025] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5246), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5244), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [82087] = 5,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6979), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5466), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5464), 40,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [82153] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4623), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4618), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [82215] = 21,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7048), 1,
      anon_sym_PIPE,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7054), 1,
      anon_sym_TILDE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7068), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(5720), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7058), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7062), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7064), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7066), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [82313] = 7,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7110), 1,
      sym_uninitialized,
    ACTIONS(7112), 1,
      sym_tag,
    STATE(3889), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [82383] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5528), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5526), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [82445] = 26,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7048), 1,
      anon_sym_PIPE,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7054), 1,
      anon_sym_TILDE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7068), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7082), 1,
      anon_sym_or_return,
    ACTIONS(7084), 1,
      anon_sym_or_continue,
    ACTIONS(7086), 1,
      anon_sym_or_break,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(5422), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7058), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7062), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7064), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7338), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7066), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5420), 17,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      sym_uninitialized,
      sym_tag,
  [82553] = 5,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6902), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5470), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5468), 40,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [82619] = 25,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7199), 1,
      anon_sym_PIPE,
    ACTIONS(7201), 1,
      anon_sym_PLUS,
    ACTIONS(7203), 1,
      anon_sym_DASH,
    ACTIONS(7205), 1,
      anon_sym_TILDE,
    ACTIONS(7207), 1,
      anon_sym_AMP,
    ACTIONS(7211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7219), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7233), 1,
      anon_sym_or_return,
    ACTIONS(7235), 1,
      anon_sym_or_continue,
    ACTIONS(7237), 1,
      anon_sym_or_break,
    ACTIONS(7239), 1,
      anon_sym_CARET,
    ACTIONS(4722), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7221), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7217), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4717), 19,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
      sym_uninitialized,
      sym_tag,
  [82725] = 7,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7117), 1,
      sym_uninitialized,
    ACTIONS(7119), 1,
      sym_tag,
    STATE(3884), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [82795] = 9,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 35,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [82869] = 6,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6979), 1,
      anon_sym_SLASH,
    ACTIONS(7340), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 39,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [82937] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5618), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5616), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [82999] = 24,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1779), 1,
      anon_sym_LPAREN,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(7360), 1,
      sym_tag,
    STATE(3188), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(840), 4,
      anon_sym_where,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(837), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      sym_uninitialized,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [83103] = 24,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(7364), 1,
      sym_tag,
    STATE(3208), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 4,
      anon_sym_where,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(815), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      sym_uninitialized,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [83207] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4858), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4856), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [83269] = 24,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(7368), 1,
      sym_tag,
    STATE(3347), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(877), 4,
      anon_sym_where,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(875), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      sym_uninitialized,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [83373] = 24,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1795), 1,
      anon_sym_LPAREN,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(7371), 1,
      sym_tag,
    STATE(3343), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 4,
      anon_sym_where,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(891), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      sym_uninitialized,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [83477] = 24,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1961), 1,
      anon_sym_LPAREN,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(7393), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3590), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(877), 4,
      anon_sym_where,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(875), 9,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
      sym_uninitialized,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [83581] = 24,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1725), 1,
      anon_sym_LPAREN,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(7396), 1,
      sym_tag,
    STATE(3299), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 4,
      anon_sym_where,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(767), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      sym_uninitialized,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [83685] = 24,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1931), 1,
      anon_sym_LPAREN,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(7399), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3574), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(840), 4,
      anon_sym_where,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(837), 9,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
      sym_uninitialized,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [83789] = 24,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1883), 1,
      anon_sym_LPAREN,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(7403), 1,
      sym_tag,
    STATE(3285), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 4,
      anon_sym_where,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(859), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      sym_uninitialized,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [83893] = 25,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7048), 1,
      anon_sym_PIPE,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7054), 1,
      anon_sym_TILDE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7068), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7082), 1,
      anon_sym_or_return,
    ACTIONS(7084), 1,
      anon_sym_or_continue,
    ACTIONS(7086), 1,
      anon_sym_or_break,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(5774), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7058), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7062), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7064), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7066), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5772), 19,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_not_in,
      sym_uninitialized,
      sym_tag,
  [83999] = 24,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(2062), 1,
      anon_sym_LPAREN,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(7406), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3558), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 4,
      anon_sym_where,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(815), 9,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
      sym_uninitialized,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [84103] = 24,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(2087), 1,
      anon_sym_LPAREN,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(7410), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3537), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 4,
      anon_sym_where,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(767), 9,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
      sym_uninitialized,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [84207] = 24,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(2099), 1,
      anon_sym_LPAREN,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(7413), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3533), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 4,
      anon_sym_where,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(859), 9,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
      sym_uninitialized,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [84311] = 24,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1907), 1,
      anon_sym_LPAREN,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(7416), 1,
      sym_tag,
    STATE(3220), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 4,
      anon_sym_where,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(913), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      sym_uninitialized,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [84415] = 14,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7068), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 31,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [84499] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5154), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5152), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [84561] = 24,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(2046), 1,
      anon_sym_LPAREN,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(7419), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3524), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 4,
      anon_sym_where,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(891), 9,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
      sym_uninitialized,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [84665] = 24,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(2120), 1,
      anon_sym_LPAREN,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(7423), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3573), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 4,
      anon_sym_where,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(913), 9,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
      sym_uninitialized,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [84769] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5135), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5132), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [84831] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5206), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5204), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [84893] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5202), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5200), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [84955] = 7,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5098), 37,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [85025] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(767), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [85087] = 7,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(7426), 1,
      sym_uninitialized,
    ACTIONS(7428), 1,
      sym_tag,
    STATE(3700), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [85157] = 7,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4992), 37,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [85227] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5170), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5168), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [85289] = 7,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7263), 1,
      sym_uninitialized,
    ACTIONS(7265), 1,
      sym_tag,
    STATE(3832), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [85359] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [85421] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5378), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [85483] = 7,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7169), 1,
      sym_uninitialized,
    ACTIONS(7171), 1,
      sym_tag,
    STATE(3876), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [85553] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4928), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4926), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [85615] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4950), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4948), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [85677] = 5,
    ACTIONS(7432), 1,
      anon_sym_QMARK,
    ACTIONS(7430), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [85743] = 5,
    ACTIONS(7436), 1,
      anon_sym_QMARK,
    ACTIONS(7434), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_in,
      anon_sym_case,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [85809] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4972), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4970), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [85871] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4990), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4988), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [85933] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5608), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5606), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [85995] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5524), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5522), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [86057] = 7,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4992), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [86127] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5096), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5094), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [86189] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5568), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5566), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [86251] = 7,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5098), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [86321] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5112), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5110), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [86383] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5490), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5488), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [86445] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [86507] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5158), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5156), 41,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [86569] = 9,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7440), 1,
      sym_uninitialized,
    ACTIONS(7442), 1,
      sym_tag,
    STATE(3669), 1,
      sym_where_clause,
    STATE(4535), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [86642] = 7,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7318), 1,
      sym_uninitialized,
    ACTIONS(7320), 1,
      sym_tag,
    STATE(3617), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [86711] = 4,
    STATE(3377), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4548), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4546), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [86774] = 24,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1751), 1,
      anon_sym_LPAREN,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(7462), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3145), 1,
      sym_type,
    ACTIONS(773), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(767), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [86877] = 7,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7183), 1,
      sym_uninitialized,
    ACTIONS(7185), 1,
      sym_tag,
    STATE(3768), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [86946] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 11,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_DOT2,
    ACTIONS(4453), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [87007] = 5,
    ACTIONS(7465), 1,
      anon_sym_LBRACE,
    STATE(3377), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4623), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4618), 39,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [87072] = 6,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6910), 1,
      sym_uninitialized,
    STATE(3709), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [87139] = 24,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1895), 1,
      anon_sym_LPAREN,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(7468), 1,
      sym_tag,
    STATE(2964), 1,
      sym_type,
    STATE(2978), 1,
      sym_procedure,
    ACTIONS(861), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(859), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [87242] = 6,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7243), 1,
      sym_uninitialized,
    STATE(3773), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3671), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [87309] = 4,
    STATE(3377), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4568), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4566), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [87372] = 27,
    ACTIONS(4732), 1,
      anon_sym_EQ,
    ACTIONS(7471), 1,
      anon_sym_COMMA,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_PLUS,
    ACTIONS(7479), 1,
      anon_sym_DASH,
    ACTIONS(7481), 1,
      anon_sym_TILDE,
    ACTIONS(7483), 1,
      anon_sym_AMP,
    ACTIONS(7487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7495), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7509), 1,
      anon_sym_or_return,
    ACTIONS(7511), 1,
      anon_sym_or_continue,
    ACTIONS(7513), 1,
      anon_sym_or_break,
    ACTIONS(7515), 1,
      anon_sym_CARET,
    STATE(3398), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(7485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7489), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7491), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4728), 17,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
      sym_uninitialized,
      sym_tag,
  [87481] = 4,
    STATE(3377), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4536), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4534), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [87544] = 9,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7519), 1,
      sym_uninitialized,
    ACTIONS(7521), 1,
      sym_tag,
    STATE(3674), 1,
      sym_where_clause,
    STATE(4289), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [87617] = 6,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7169), 1,
      sym_uninitialized,
    STATE(3876), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [87684] = 6,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_uninitialized,
    STATE(3909), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4083), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [87751] = 24,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1827), 1,
      anon_sym_LPAREN,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(7523), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3134), 1,
      sym_type,
    ACTIONS(894), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(891), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [87854] = 10,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7527), 1,
      anon_sym_DASH_GT,
    ACTIONS(7529), 1,
      sym_uninitialized,
    ACTIONS(7531), 1,
      sym_tag,
    STATE(3663), 1,
      sym_where_clause,
    STATE(4503), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4117), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4113), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [87929] = 6,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6880), 1,
      sym_uninitialized,
    STATE(3668), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [87996] = 6,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7263), 1,
      sym_uninitialized,
    STATE(3832), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [88063] = 6,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(7533), 1,
      sym_uninitialized,
    STATE(3694), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4691), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [88130] = 10,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7535), 1,
      anon_sym_DASH_GT,
    ACTIONS(7537), 1,
      sym_uninitialized,
    ACTIONS(7539), 1,
      sym_tag,
    STATE(3654), 1,
      sym_where_clause,
    STATE(4506), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [88205] = 11,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7304), 1,
      anon_sym_SLASH,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7541), 1,
      sym_uninitialized,
    ACTIONS(7543), 1,
      sym_tag,
    STATE(3639), 1,
      sym_where_clause,
    STATE(4514), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [88282] = 9,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7541), 1,
      sym_uninitialized,
    ACTIONS(7543), 1,
      sym_tag,
    STATE(3639), 1,
      sym_where_clause,
    STATE(4514), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [88355] = 11,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7304), 1,
      anon_sym_SLASH,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7440), 1,
      sym_uninitialized,
    ACTIONS(7545), 1,
      sym_tag,
    STATE(3669), 1,
      sym_where_clause,
    STATE(4535), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [88432] = 9,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7440), 1,
      sym_uninitialized,
    ACTIONS(7545), 1,
      sym_tag,
    STATE(3669), 1,
      sym_where_clause,
    STATE(4535), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [88505] = 7,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7298), 1,
      sym_uninitialized,
    ACTIONS(7300), 1,
      sym_tag,
    STATE(3547), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [88574] = 5,
    ACTIONS(7471), 1,
      anon_sym_COMMA,
    STATE(3402), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4665), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4661), 39,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [88639] = 11,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7304), 1,
      anon_sym_SLASH,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7547), 1,
      sym_uninitialized,
    ACTIONS(7549), 1,
      sym_tag,
    STATE(3715), 1,
      sym_where_clause,
    STATE(4434), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [88716] = 9,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7547), 1,
      sym_uninitialized,
    ACTIONS(7549), 1,
      sym_tag,
    STATE(3715), 1,
      sym_where_clause,
    STATE(4434), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [88789] = 9,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7547), 1,
      sym_uninitialized,
    ACTIONS(7551), 1,
      sym_tag,
    STATE(3715), 1,
      sym_where_clause,
    STATE(4434), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [88862] = 5,
    ACTIONS(7553), 1,
      anon_sym_COMMA,
    STATE(3402), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4722), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4717), 39,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [88927] = 9,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7556), 1,
      sym_uninitialized,
    ACTIONS(7558), 1,
      sym_tag,
    STATE(3705), 1,
      sym_where_clause,
    STATE(4512), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [89000] = 5,
    ACTIONS(7560), 1,
      sym_identifier,
    ACTIONS(7562), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 21,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 28,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [89065] = 6,
    ACTIONS(7564), 1,
      anon_sym_LBRACE,
    ACTIONS(7567), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 38,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [89132] = 6,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6916), 1,
      sym_uninitialized,
    STATE(3661), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [89199] = 7,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7165), 1,
      sym_uninitialized,
    ACTIONS(7167), 1,
      sym_tag,
    STATE(3798), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [89268] = 5,
    ACTIONS(7570), 1,
      anon_sym_DOT2,
    STATE(3408), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4453), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [89333] = 6,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7028), 1,
      sym_uninitialized,
    STATE(3888), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4023), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [89400] = 6,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7322), 1,
      sym_uninitialized,
    STATE(3719), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4667), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [89467] = 6,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7573), 1,
      sym_uninitialized,
    STATE(3732), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4691), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [89534] = 24,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1811), 1,
      anon_sym_LPAREN,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(7575), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3020), 1,
      sym_type,
    ACTIONS(818), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(815), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [89637] = 6,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6961), 1,
      sym_uninitialized,
    STATE(3656), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [89704] = 7,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      sym_uninitialized,
    ACTIONS(7149), 1,
      sym_tag,
    STATE(3804), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [89773] = 5,
    ACTIONS(7579), 1,
      anon_sym_DOT2,
    STATE(3408), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4496), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4494), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [89838] = 5,
    ACTIONS(7581), 1,
      anon_sym_LBRACE,
    STATE(3416), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4623), 22,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4618), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [89903] = 6,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7040), 1,
      sym_uninitialized,
    STATE(3720), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3781), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [89970] = 6,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7251), 1,
      sym_uninitialized,
    STATE(3833), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3415), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [90037] = 4,
    ACTIONS(7584), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4701), 21,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(4697), 29,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [90100] = 9,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7586), 1,
      sym_uninitialized,
    ACTIONS(7588), 1,
      sym_tag,
    STATE(3714), 1,
      sym_where_clause,
    STATE(4291), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [90173] = 24,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1855), 1,
      anon_sym_LPAREN,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(7590), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(2999), 1,
      sym_type,
    ACTIONS(840), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(837), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [90276] = 6,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(7426), 1,
      sym_uninitialized,
    STATE(3700), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [90343] = 24,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1843), 1,
      anon_sym_LPAREN,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(7594), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3030), 1,
      sym_type,
    ACTIONS(915), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(913), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [90446] = 5,
    ACTIONS(7579), 1,
      anon_sym_DOT2,
    STATE(3415), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [90511] = 7,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7143), 1,
      sym_uninitialized,
    ACTIONS(7145), 1,
      sym_tag,
    STATE(3807), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [90580] = 9,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7586), 1,
      sym_uninitialized,
    ACTIONS(7597), 1,
      sym_tag,
    STATE(3714), 1,
      sym_where_clause,
    STATE(4291), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [90653] = 11,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7304), 1,
      anon_sym_SLASH,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7586), 1,
      sym_uninitialized,
    ACTIONS(7597), 1,
      sym_tag,
    STATE(3714), 1,
      sym_where_clause,
    STATE(4291), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [90730] = 6,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7599), 1,
      sym_uninitialized,
    STATE(3900), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4691), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [90797] = 9,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7601), 1,
      sym_uninitialized,
    ACTIONS(7603), 1,
      sym_tag,
    STATE(3655), 1,
      sym_where_clause,
    STATE(4296), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [90870] = 9,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7601), 1,
      sym_uninitialized,
    ACTIONS(7605), 1,
      sym_tag,
    STATE(3655), 1,
      sym_where_clause,
    STATE(4296), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [90943] = 11,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7304), 1,
      anon_sym_SLASH,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7601), 1,
      sym_uninitialized,
    ACTIONS(7605), 1,
      sym_tag,
    STATE(3655), 1,
      sym_where_clause,
    STATE(4296), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [91020] = 9,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7607), 1,
      sym_uninitialized,
    ACTIONS(7609), 1,
      sym_tag,
    STATE(3695), 1,
      sym_where_clause,
    STATE(4301), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [91093] = 11,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7304), 1,
      anon_sym_SLASH,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7607), 1,
      sym_uninitialized,
    ACTIONS(7609), 1,
      sym_tag,
    STATE(3695), 1,
      sym_where_clause,
    STATE(4301), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [91170] = 6,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7328), 1,
      sym_uninitialized,
    STATE(3897), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [91237] = 10,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7611), 1,
      anon_sym_DASH_GT,
    ACTIONS(7613), 1,
      sym_uninitialized,
    ACTIONS(7615), 1,
      sym_tag,
    STATE(3697), 1,
      sym_where_clause,
    STATE(4306), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [91312] = 6,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7137), 1,
      sym_uninitialized,
    STATE(3860), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [91379] = 10,
    ACTIONS(7273), 1,
      anon_sym_where,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7617), 1,
      anon_sym_DASH_GT,
    ACTIONS(7619), 1,
      sym_uninitialized,
    ACTIONS(7621), 1,
      sym_tag,
    STATE(3698), 1,
      sym_where_clause,
    STATE(4310), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4117), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4113), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [91454] = 6,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7306), 1,
      sym_uninitialized,
    STATE(3572), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 38,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_tag,
  [91521] = 7,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7177), 1,
      sym_uninitialized,
    ACTIONS(7623), 1,
      sym_tag,
    STATE(3809), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [91590] = 6,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7318), 1,
      sym_uninitialized,
    STATE(3617), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 38,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_tag,
  [91657] = 6,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7625), 1,
      sym_uninitialized,
    STATE(3622), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 38,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_tag,
  [91724] = 24,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1687), 1,
      anon_sym_LPAREN,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(7627), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(2981), 1,
      sym_type,
    ACTIONS(877), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(875), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [91827] = 7,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7630), 1,
      sym_uninitialized,
    ACTIONS(7632), 1,
      sym_tag,
    STATE(3810), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [91896] = 7,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7306), 1,
      sym_uninitialized,
    ACTIONS(7634), 1,
      sym_tag,
    STATE(3572), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [91965] = 6,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7310), 1,
      sym_uninitialized,
    STATE(3592), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 38,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_tag,
  [92032] = 7,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7625), 1,
      sym_uninitialized,
    ACTIONS(7636), 1,
      sym_tag,
    STATE(3622), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [92101] = 6,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7298), 1,
      sym_uninitialized,
    STATE(3547), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 38,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_tag,
  [92168] = 7,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7310), 1,
      sym_uninitialized,
    ACTIONS(7336), 1,
      sym_tag,
    STATE(3592), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [92237] = 6,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7638), 1,
      sym_uninitialized,
    STATE(3627), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4691), 38,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_tag,
  [92304] = 26,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6787), 1,
      anon_sym_PIPE,
    ACTIONS(6791), 1,
      anon_sym_TILDE,
    ACTIONS(6793), 1,
      anon_sym_AMP,
    ACTIONS(6795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6803), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6809), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6819), 1,
      anon_sym_or_else,
    ACTIONS(6821), 1,
      anon_sym_or_return,
    ACTIONS(6823), 1,
      anon_sym_or_continue,
    ACTIONS(6825), 1,
      anon_sym_or_break,
    ACTIONS(6827), 1,
      anon_sym_CARET,
    ACTIONS(6789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6797), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6799), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6805), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6833), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(7642), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6801), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6807), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7640), 16,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
  [92411] = 6,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6939), 1,
      sym_uninitialized,
    STATE(3707), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 37,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [92478] = 6,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7110), 1,
      sym_uninitialized,
    STATE(3889), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [92545] = 6,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7117), 1,
      sym_uninitialized,
    STATE(3884), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [92612] = 7,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7275), 1,
      sym_uninitialized,
    ACTIONS(7316), 1,
      sym_tag,
    STATE(3609), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [92681] = 6,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7275), 1,
      sym_uninitialized,
    STATE(3609), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 38,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_tag,
  [92748] = 16,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_PLUS,
    ACTIONS(7479), 1,
      anon_sym_DASH,
    ACTIONS(7481), 1,
      anon_sym_TILDE,
    ACTIONS(7483), 1,
      anon_sym_AMP,
    ACTIONS(7495), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 30,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [92834] = 5,
    ACTIONS(7644), 1,
      anon_sym_DOT2,
    STATE(3522), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4496), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4494), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [92898] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5668), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5666), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [92958] = 6,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7177), 1,
      sym_uninitialized,
    STATE(3809), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [93024] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5660), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5658), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [93084] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5656), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5654), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [93144] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5652), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5650), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [93204] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5642), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5640), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [93264] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5672), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5670), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [93324] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5552), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5550), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [93384] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5588), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5586), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [93444] = 25,
    ACTIONS(5774), 1,
      anon_sym_EQ,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_PLUS,
    ACTIONS(7479), 1,
      anon_sym_DASH,
    ACTIONS(7481), 1,
      anon_sym_TILDE,
    ACTIONS(7483), 1,
      anon_sym_AMP,
    ACTIONS(7487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7495), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7509), 1,
      anon_sym_or_return,
    ACTIONS(7511), 1,
      anon_sym_or_continue,
    ACTIONS(7513), 1,
      anon_sym_or_break,
    ACTIONS(7515), 1,
      anon_sym_CARET,
    ACTIONS(7485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7489), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7491), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5772), 18,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
      sym_uninitialized,
      sym_tag,
  [93548] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5572), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5570), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [93608] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5560), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5558), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [93668] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5538), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5536), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [93728] = 7,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5358), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [93796] = 11,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7477), 1,
      anon_sym_PLUS,
    ACTIONS(7479), 1,
      anon_sym_DASH,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 33,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [93872] = 12,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7477), 1,
      anon_sym_PLUS,
    ACTIONS(7479), 1,
      anon_sym_DASH,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 31,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [93950] = 17,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_PLUS,
    ACTIONS(7479), 1,
      anon_sym_DASH,
    ACTIONS(7481), 1,
      anon_sym_TILDE,
    ACTIONS(7483), 1,
      anon_sym_AMP,
    ACTIONS(7495), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 27,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [94038] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5524), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5522), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [94098] = 6,
    ACTIONS(7562), 1,
      anon_sym_LPAREN,
    ACTIONS(7648), 1,
      anon_sym_QMARK,
    ACTIONS(7646), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_in,
      anon_sym_case,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [94164] = 19,
    ACTIONS(5360), 1,
      anon_sym_EQ,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_PLUS,
    ACTIONS(7479), 1,
      anon_sym_DASH,
    ACTIONS(7481), 1,
      anon_sym_TILDE,
    ACTIONS(7483), 1,
      anon_sym_AMP,
    ACTIONS(7495), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7489), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7491), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 25,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [94256] = 20,
    ACTIONS(5360), 1,
      anon_sym_EQ,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_PLUS,
    ACTIONS(7479), 1,
      anon_sym_DASH,
    ACTIONS(7481), 1,
      anon_sym_TILDE,
    ACTIONS(7483), 1,
      anon_sym_AMP,
    ACTIONS(7487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7495), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7489), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7491), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 24,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [94350] = 13,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7477), 1,
      anon_sym_PLUS,
    ACTIONS(7479), 1,
      anon_sym_DASH,
    ACTIONS(7495), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 30,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [94430] = 6,
    ACTIONS(7157), 1,
      anon_sym_LPAREN,
    ACTIONS(7436), 1,
      anon_sym_QMARK,
    ACTIONS(7434), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_in,
      anon_sym_case,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [94496] = 14,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7477), 1,
      anon_sym_PLUS,
    ACTIONS(7479), 1,
      anon_sym_DASH,
    ACTIONS(7483), 1,
      anon_sym_AMP,
    ACTIONS(7495), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 5,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 30,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [94578] = 9,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 34,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [94650] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [94710] = 26,
    ACTIONS(5422), 1,
      anon_sym_EQ,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_PLUS,
    ACTIONS(7479), 1,
      anon_sym_DASH,
    ACTIONS(7481), 1,
      anon_sym_TILDE,
    ACTIONS(7483), 1,
      anon_sym_AMP,
    ACTIONS(7487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7495), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7509), 1,
      anon_sym_or_return,
    ACTIONS(7511), 1,
      anon_sym_or_continue,
    ACTIONS(7513), 1,
      anon_sym_or_break,
    ACTIONS(7515), 1,
      anon_sym_CARET,
    ACTIONS(7485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7489), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7491), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7650), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5420), 16,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_case,
      anon_sym_QMARK,
      sym_uninitialized,
      sym_tag,
  [94816] = 15,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7477), 1,
      anon_sym_PLUS,
    ACTIONS(7479), 1,
      anon_sym_DASH,
    ACTIONS(7481), 1,
      anon_sym_TILDE,
    ACTIONS(7483), 1,
      anon_sym_AMP,
    ACTIONS(7495), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 4,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 30,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [94900] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5356), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5354), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [94960] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5350), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5348), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [95020] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5272), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5270), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [95080] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5268), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5266), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [95140] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5258), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5256), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [95200] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4623), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4618), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [95260] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [95320] = 5,
    ACTIONS(7652), 1,
      anon_sym_LBRACE,
    STATE(3493), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4623), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4618), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [95384] = 5,
    ACTIONS(7655), 1,
      anon_sym_LBRACE,
    STATE(3493), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4548), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4546), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [95448] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5710), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5708), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [95508] = 5,
    ACTIONS(7657), 1,
      anon_sym_DOT2,
    STATE(3529), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4496), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4494), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [95572] = 5,
    ACTIONS(7659), 1,
      anon_sym_LBRACE,
    STATE(3416), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4536), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4534), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [95636] = 5,
    ACTIONS(7657), 1,
      anon_sym_DOT2,
    STATE(3496), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4185), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [95700] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5454), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5452), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [95760] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5766), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5764), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [95820] = 6,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7304), 1,
      anon_sym_SLASH,
    ACTIONS(7661), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 38,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [95886] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5218), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5216), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [95946] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5770), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5768), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [96006] = 25,
    ACTIONS(5720), 1,
      anon_sym_EQ,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_PLUS,
    ACTIONS(7479), 1,
      anon_sym_DASH,
    ACTIONS(7481), 1,
      anon_sym_TILDE,
    ACTIONS(7483), 1,
      anon_sym_AMP,
    ACTIONS(7487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7495), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7509), 1,
      anon_sym_or_return,
    ACTIONS(7511), 1,
      anon_sym_or_continue,
    ACTIONS(7513), 1,
      anon_sym_or_break,
    ACTIONS(7515), 1,
      anon_sym_CARET,
    ACTIONS(7485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7489), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7491), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 18,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
      sym_uninitialized,
      sym_tag,
  [96110] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5676), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5674), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [96170] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5556), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5554), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [96230] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5690), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5688), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [96290] = 5,
    ACTIONS(7663), 1,
      anon_sym_DOT2,
    STATE(3615), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4496), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4494), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [96354] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5446), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5444), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [96414] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5438), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5436), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [96474] = 7,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5600), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [96542] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5698), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5696), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [96602] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5206), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5204), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [96662] = 6,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7143), 1,
      sym_uninitialized,
    STATE(3807), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [96728] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5702), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5700), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [96788] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5458), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5456), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [96848] = 4,
    ACTIONS(7562), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 39,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [96910] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5434), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5432), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [96970] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5714), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5712), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [97030] = 5,
    ACTIONS(7644), 1,
      anon_sym_DOT2,
    STATE(3457), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [97094] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5706), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5704), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [97154] = 5,
    ACTIONS(7665), 1,
      anon_sym_DOT2,
    STATE(3522), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4453), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [97218] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5430), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5428), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [97278] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5135), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5132), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [97338] = 21,
    ACTIONS(5720), 1,
      anon_sym_EQ,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_PLUS,
    ACTIONS(7479), 1,
      anon_sym_DASH,
    ACTIONS(7481), 1,
      anon_sym_TILDE,
    ACTIONS(7483), 1,
      anon_sym_AMP,
    ACTIONS(7487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7495), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7489), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7491), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 22,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [97434] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [97494] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5724), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5722), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [97554] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5418), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5416), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [97614] = 5,
    ACTIONS(7668), 1,
      anon_sym_DOT2,
    STATE(3529), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4453), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [97678] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5474), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5472), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [97738] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5528), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5526), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [97798] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5728), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5726), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [97858] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(913), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [97918] = 6,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7183), 1,
      sym_uninitialized,
    STATE(3768), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [97984] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5732), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5730), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [98044] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4858), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4856), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [98104] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(859), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [98164] = 7,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5644), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [98232] = 5,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7304), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5484), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5482), 39,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [98296] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4864), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4862), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [98356] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5202), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5200), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [98416] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5734), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [98476] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5372), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5370), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [98536] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5414), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5412), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [98596] = 6,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7671), 1,
      sym_uninitialized,
    STATE(3813), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4691), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [98662] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5410), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5408), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [98722] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [98782] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5402), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5400), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [98842] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5734), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [98902] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5170), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5168), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [98962] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5748), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5746), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [99022] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5812), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5810), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [99082] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5754), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5752), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [99142] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5758), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5756), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [99202] = 26,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6787), 1,
      anon_sym_PIPE,
    ACTIONS(6791), 1,
      anon_sym_TILDE,
    ACTIONS(6793), 1,
      anon_sym_AMP,
    ACTIONS(6795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6803), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6809), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6819), 1,
      anon_sym_or_else,
    ACTIONS(6821), 1,
      anon_sym_or_return,
    ACTIONS(6823), 1,
      anon_sym_or_continue,
    ACTIONS(6825), 1,
      anon_sym_or_break,
    ACTIONS(6827), 1,
      anon_sym_CARET,
    ACTIONS(6833), 1,
      anon_sym_not_in,
    ACTIONS(6789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6797), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6799), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6805), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7642), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6801), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6807), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7640), 16,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_in,
  [99308] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5060), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5058), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [99368] = 6,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      sym_uninitialized,
    STATE(3804), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [99434] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(891), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [99494] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5398), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5396), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [99554] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(201), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [99614] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5568), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5566), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [99674] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5618), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5616), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [99734] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5610), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [99794] = 5,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7304), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5470), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5468), 39,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [99858] = 5,
    ACTIONS(7655), 1,
      anon_sym_LBRACE,
    STATE(3493), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4568), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4566), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [99922] = 29,
    ACTIONS(6785), 1,
      anon_sym_DASH_GT,
    ACTIONS(6787), 1,
      anon_sym_PIPE,
    ACTIONS(6791), 1,
      anon_sym_TILDE,
    ACTIONS(6793), 1,
      anon_sym_AMP,
    ACTIONS(6795), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6803), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(6809), 1,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(6811), 1,
      anon_sym_DOT,
    ACTIONS(6813), 1,
      anon_sym_LBRACK,
    ACTIONS(6817), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6819), 1,
      anon_sym_or_else,
    ACTIONS(6821), 1,
      anon_sym_or_return,
    ACTIONS(6823), 1,
      anon_sym_or_continue,
    ACTIONS(6825), 1,
      anon_sym_or_break,
    ACTIONS(6827), 1,
      anon_sym_CARET,
    ACTIONS(6967), 1,
      anon_sym_COMMA,
    ACTIONS(6985), 1,
      anon_sym_EQ,
    ACTIONS(6987), 1,
      anon_sym_COLON_EQ,
    STATE(6532), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(6789), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6797), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6799), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6805), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6815), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(6833), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6801), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(6807), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6989), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
  [100034] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4623), 22,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4618), 28,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [100094] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5378), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [100154] = 5,
    ACTIONS(7659), 1,
      anon_sym_LBRACE,
    STATE(3416), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4548), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4546), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [100218] = 5,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7304), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5466), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5464), 39,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [100282] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5822), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5820), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [100342] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [100402] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5384), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5382), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [100462] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(815), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [100522] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5158), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5156), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [100582] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5154), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5152), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [100642] = 4,
    STATE(3416), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4548), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4546), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [100704] = 5,
    ACTIONS(7659), 1,
      anon_sym_LBRACE,
    STATE(3416), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4568), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4566), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [100768] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5544), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5542), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [100828] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_DOT2,
    ACTIONS(4453), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [100888] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5784), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5782), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [100948] = 6,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7304), 1,
      anon_sym_SLASH,
    ACTIONS(7673), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5390), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5386), 39,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [101014] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5858), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5856), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [101074] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5880), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5878), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [101134] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5636), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5634), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [101194] = 4,
    STATE(3416), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4536), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4534), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [101256] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5378), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [101316] = 6,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7630), 1,
      sym_uninitialized,
    STATE(3810), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [101382] = 5,
    ACTIONS(7663), 1,
      anon_sym_DOT2,
    STATE(3508), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [101446] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(767), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [101506] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5112), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5110), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [101566] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [101626] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5582), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5580), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [101686] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5376), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5374), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [101746] = 7,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5098), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [101814] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5096), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5094), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [101874] = 7,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4992), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [101942] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4990), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4988), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [102002] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [102062] = 5,
    ACTIONS(7655), 1,
      anon_sym_LBRACE,
    STATE(3493), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4536), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4534), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [102126] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5246), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5244), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [102186] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4972), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4970), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [102246] = 5,
    ACTIONS(7648), 1,
      anon_sym_QMARK,
    ACTIONS(7646), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_in,
      anon_sym_case,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [102310] = 5,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7304), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 39,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [102374] = 4,
    STATE(3416), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4568), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4566), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [102436] = 5,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7304), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5450), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5448), 39,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [102500] = 6,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7165), 1,
      sym_uninitialized,
    STATE(3798), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [102566] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5626), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5624), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [102626] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [102686] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4950), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4948), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [102746] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5368), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5366), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [102806] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5490), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5488), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [102866] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4928), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4926), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [102926] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5346), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5344), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [102986] = 5,
    ACTIONS(7675), 1,
      anon_sym_DOT2,
    STATE(3615), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4453), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [103050] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5884), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5882), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [103110] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [103170] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5874), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5872), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [103230] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5850), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [103290] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4858), 22,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4856), 28,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [103350] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5850), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [103410] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4691), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [103470] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5342), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5340), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [103530] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5338), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5336), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [103590] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5848), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5846), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [103650] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [103710] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5498), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5496), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [103770] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [103830] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [103890] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5826), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5824), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [103950] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5334), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5332), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [104010] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5608), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5606), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [104070] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5630), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5628), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [104130] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5276), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5274), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [104190] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5280), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5278), 40,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [104250] = 25,
    ACTIONS(4722), 1,
      anon_sym_EQ,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_PLUS,
    ACTIONS(7479), 1,
      anon_sym_DASH,
    ACTIONS(7481), 1,
      anon_sym_TILDE,
    ACTIONS(7483), 1,
      anon_sym_AMP,
    ACTIONS(7487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7495), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7509), 1,
      anon_sym_or_return,
    ACTIONS(7511), 1,
      anon_sym_or_continue,
    ACTIONS(7513), 1,
      anon_sym_or_break,
    ACTIONS(7515), 1,
      anon_sym_CARET,
    ACTIONS(7485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7489), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7491), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4717), 18,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
      sym_uninitialized,
      sym_tag,
  [104354] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5384), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5382), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [104413] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5378), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [104472] = 7,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7440), 1,
      sym_uninitialized,
    ACTIONS(7442), 1,
      sym_tag,
    STATE(4535), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [104539] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5418), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5416), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [104598] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5414), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5412), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [104657] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5410), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5408), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [104716] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5402), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5400), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [104775] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(913), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [104834] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(815), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [104893] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5430), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5428), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [104952] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5434), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5432), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [105011] = 5,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(7680), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 37,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [105074] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(891), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [105133] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5398), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5396), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [105192] = 24,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(2371), 1,
      anon_sym_LPAREN,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    STATE(3766), 1,
      sym_procedure,
    STATE(3851), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 3,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(815), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [105293] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5438), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5436), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [105352] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5276), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5274), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [105411] = 7,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7541), 1,
      sym_uninitialized,
    ACTIONS(7700), 1,
      sym_tag,
    STATE(4514), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [105478] = 7,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7586), 1,
      sym_uninitialized,
    ACTIONS(7588), 1,
      sym_tag,
    STATE(4291), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [105545] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [105604] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5544), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5542), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [105663] = 5,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(7680), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5450), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5448), 37,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [105726] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(859), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [105785] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(767), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [105844] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [105903] = 4,
    STATE(3493), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4536), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4534), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [105964] = 7,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7537), 1,
      sym_uninitialized,
    ACTIONS(7539), 1,
      sym_tag,
    STATE(4506), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [106031] = 6,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    ACTIONS(7704), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 35,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [106096] = 24,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(2431), 1,
      anon_sym_LPAREN,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    STATE(3729), 1,
      sym_type,
    STATE(3766), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(840), 3,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(837), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [106197] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4858), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4856), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [106256] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [106315] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [106374] = 7,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7547), 1,
      sym_uninitialized,
    ACTIONS(7551), 1,
      sym_tag,
    STATE(4434), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [106441] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5552), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5550), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [106500] = 5,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(7680), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5466), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5464), 37,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [106563] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5246), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5244), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [106622] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5060), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5058), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [106681] = 7,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7707), 1,
      sym_uninitialized,
    ACTIONS(7709), 1,
      sym_tag,
    STATE(4288), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [106748] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5446), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5444), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [106807] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5528), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5526), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [106866] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5454), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5452), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [106925] = 5,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(7680), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5470), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5468), 37,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [106988] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5474), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5472), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [107047] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5556), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5554), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [107106] = 4,
    STATE(3493), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4548), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4546), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [107167] = 5,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(7680), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5484), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5482), 37,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [107230] = 24,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(2341), 1,
      anon_sym_LPAREN,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    STATE(3766), 1,
      sym_procedure,
    STATE(3811), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 3,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(913), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [107331] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5376), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5374), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [107390] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5372), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5370), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [107449] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [107508] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5368), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5366), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [107567] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 22,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_DOT2,
      sym_identifier,
    ACTIONS(4453), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [107626] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5490), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5488), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [107685] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5524), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5522), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [107744] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5280), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5278), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [107803] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5135), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5132), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [107862] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 11,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_DOT2,
    ACTIONS(4453), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [107921] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5498), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5496), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [107980] = 7,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7601), 1,
      sym_uninitialized,
    ACTIONS(7603), 1,
      sym_tag,
    STATE(4296), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [108047] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5334), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5332), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [108106] = 7,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7607), 1,
      sym_uninitialized,
    ACTIONS(7711), 1,
      sym_tag,
    STATE(4301), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [108173] = 7,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7613), 1,
      sym_uninitialized,
    ACTIONS(7615), 1,
      sym_tag,
    STATE(4306), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [108240] = 24,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    STATE(3754), 1,
      sym_type,
    STATE(3766), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(877), 3,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(875), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [108341] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4691), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [108400] = 24,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(2413), 1,
      anon_sym_LPAREN,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    STATE(3766), 1,
      sym_procedure,
    STATE(3862), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 3,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(859), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [108501] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5338), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5336), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [108560] = 6,
    ACTIONS(7713), 1,
      anon_sym_COLON,
    ACTIONS(7715), 1,
      anon_sym_DOT2,
    STATE(3892), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [108625] = 4,
    STATE(3493), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4568), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4566), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [108686] = 7,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7717), 1,
      sym_uninitialized,
    ACTIONS(7719), 1,
      sym_tag,
    STATE(4547), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [108753] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4623), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4618), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [108812] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [108871] = 24,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2304), 1,
      anon_sym_LPAREN,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    STATE(3766), 1,
      sym_procedure,
    STATE(3839), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 3,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(767), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [108972] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [109031] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_DOT2,
    ACTIONS(4453), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [109090] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5342), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5340), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [109149] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5346), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5344), 38,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [109208] = 24,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(2350), 1,
      anon_sym_LPAREN,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    STATE(3766), 1,
      sym_procedure,
    STATE(3866), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 3,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(891), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [109309] = 7,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7519), 1,
      sym_uninitialized,
    ACTIONS(7521), 1,
      sym_tag,
    STATE(4289), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [109376] = 7,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7556), 1,
      sym_uninitialized,
    ACTIONS(7558), 1,
      sym_tag,
    STATE(4512), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [109443] = 6,
    ACTIONS(7721), 1,
      anon_sym_LBRACE,
    ACTIONS(7723), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [109508] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5135), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5132), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [109566] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5378), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [109624] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4691), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [109682] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3415), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [109740] = 6,
    ACTIONS(7726), 1,
      anon_sym_LBRACE,
    ACTIONS(7728), 1,
      anon_sym_LPAREN,
    ACTIONS(7730), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [109804] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5446), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5444), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [109862] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5438), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5436), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [109920] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5556), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5554), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [109978] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5434), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5432), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [110036] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5334), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5332), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [110094] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5430), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5428), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [110152] = 6,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7717), 1,
      sym_uninitialized,
    STATE(4547), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [110216] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(815), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [110274] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5418), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5416), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [110332] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5544), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5542), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [110390] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5498), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5496), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [110448] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5280), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5278), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [110506] = 6,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7732), 1,
      sym_uninitialized,
    STATE(4285), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4691), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [110570] = 6,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7707), 1,
      sym_uninitialized,
    STATE(4288), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [110634] = 6,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7519), 1,
      sym_uninitialized,
    STATE(4289), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [110698] = 6,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7734), 1,
      sym_uninitialized,
    STATE(4481), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4691), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [110762] = 6,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7586), 1,
      sym_uninitialized,
    STATE(4291), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [110826] = 6,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7601), 1,
      sym_uninitialized,
    STATE(4296), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [110890] = 6,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7607), 1,
      sym_uninitialized,
    STATE(4301), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [110954] = 6,
    ACTIONS(7517), 1,
      anon_sym_LBRACE,
    ACTIONS(7613), 1,
      sym_uninitialized,
    STATE(4306), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [111018] = 28,
    ACTIONS(4732), 1,
      anon_sym_EQ,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_PLUS,
    ACTIONS(7479), 1,
      anon_sym_DASH,
    ACTIONS(7481), 1,
      anon_sym_TILDE,
    ACTIONS(7483), 1,
      anon_sym_AMP,
    ACTIONS(7487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7495), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7509), 1,
      anon_sym_or_return,
    ACTIONS(7511), 1,
      anon_sym_or_continue,
    ACTIONS(7513), 1,
      anon_sym_or_break,
    ACTIONS(7515), 1,
      anon_sym_CARET,
    ACTIONS(7736), 1,
      anon_sym_COMMA,
    STATE(6582), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(7485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7489), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7491), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7650), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4728), 12,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [111126] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5556), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5554), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [111184] = 24,
    ACTIONS(840), 1,
      anon_sym_SLASH,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2280), 1,
      anon_sym_LPAREN,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3846), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(837), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [111284] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5544), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5542), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [111342] = 24,
    ACTIONS(818), 1,
      anon_sym_SLASH,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2329), 1,
      anon_sym_LPAREN,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3871), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(815), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [111442] = 4,
    ACTIONS(7744), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4701), 20,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(4697), 27,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [111502] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5528), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5526), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [111560] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5384), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5382), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [111618] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5552), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5550), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [111676] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5276), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5274), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [111734] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5490), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5488), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [111792] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [111850] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(767), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [111908] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5454), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5452), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [111966] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3781), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [112024] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5528), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5526), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [112082] = 6,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7547), 1,
      sym_uninitialized,
    STATE(4434), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [112146] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5338), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5336), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [112204] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5474), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5472), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [112262] = 5,
    ACTIONS(7728), 1,
      anon_sym_LPAREN,
    ACTIONS(7730), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5470), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5468), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [112324] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5552), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5550), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [112382] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5372), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5370), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [112440] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [112498] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5524), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5522), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [112556] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5524), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5522), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [112614] = 5,
    ACTIONS(7728), 1,
      anon_sym_LPAREN,
    ACTIONS(7730), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5450), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5448), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [112676] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [112734] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5490), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5488), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [112792] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5446), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5444), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [112850] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5438), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5436), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [112908] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4185), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [112966] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4667), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [113024] = 24,
    ACTIONS(773), 1,
      anon_sym_SLASH,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2383), 1,
      anon_sym_LPAREN,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3863), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(767), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [113124] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5434), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5432), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [113182] = 4,
    ACTIONS(7746), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4701), 20,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(4697), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [113242] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5556), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5554), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [113300] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5060), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5058), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [113358] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5430), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5428), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [113416] = 24,
    ACTIONS(861), 1,
      anon_sym_SLASH,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2255), 1,
      anon_sym_LPAREN,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3803), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(859), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [113516] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5474), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5472), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [113574] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5246), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5244), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [113632] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5418), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5416), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [113690] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5135), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5132), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [113748] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5454), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5452), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [113806] = 9,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7750), 1,
      anon_sym_where,
    ACTIONS(7752), 1,
      sym_uninitialized,
    ACTIONS(7754), 1,
      sym_tag,
    STATE(4071), 1,
      sym_where_clause,
    STATE(4224), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 32,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [113876] = 9,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7750), 1,
      anon_sym_where,
    ACTIONS(7756), 1,
      sym_uninitialized,
    ACTIONS(7758), 1,
      sym_tag,
    STATE(4081), 1,
      sym_where_clause,
    STATE(4228), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 32,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [113946] = 9,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7750), 1,
      anon_sym_where,
    ACTIONS(7756), 1,
      sym_uninitialized,
    ACTIONS(7760), 1,
      sym_tag,
    STATE(4081), 1,
      sym_where_clause,
    STATE(4228), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 32,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [114016] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5414), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5412), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [114074] = 11,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7750), 1,
      anon_sym_where,
    ACTIONS(7756), 1,
      sym_uninitialized,
    ACTIONS(7760), 1,
      sym_tag,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(7764), 1,
      anon_sym_SLASH,
    STATE(4081), 1,
      sym_where_clause,
    STATE(4228), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 31,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [114148] = 9,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7750), 1,
      anon_sym_where,
    ACTIONS(7766), 1,
      sym_uninitialized,
    ACTIONS(7768), 1,
      sym_tag,
    STATE(4088), 1,
      sym_where_clause,
    STATE(4237), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 32,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [114218] = 9,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7750), 1,
      anon_sym_where,
    ACTIONS(7766), 1,
      sym_uninitialized,
    ACTIONS(7770), 1,
      sym_tag,
    STATE(4088), 1,
      sym_where_clause,
    STATE(4237), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 32,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [114288] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5410), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5408), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [114346] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5402), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5400), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [114404] = 5,
    ACTIONS(7728), 1,
      anon_sym_LPAREN,
    ACTIONS(7730), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [114466] = 24,
    ACTIONS(894), 1,
      anon_sym_SLASH,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2401), 1,
      anon_sym_LPAREN,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3717), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(891), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [114566] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5398), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5396), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [114624] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [114682] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5376), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5374), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [114740] = 11,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7750), 1,
      anon_sym_where,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(7764), 1,
      anon_sym_SLASH,
    ACTIONS(7766), 1,
      sym_uninitialized,
    ACTIONS(7770), 1,
      sym_tag,
    STATE(4088), 1,
      sym_where_clause,
    STATE(4237), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 31,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [114814] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5372), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5370), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [114872] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5368), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5366), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [114930] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(913), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [114988] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [115046] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5346), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5344), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [115104] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5342), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5340), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [115162] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [115220] = 6,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7440), 1,
      sym_uninitialized,
    STATE(4535), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [115284] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [115342] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4691), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [115400] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5384), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5382), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [115458] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5334), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5332), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [115516] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5498), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5496), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [115574] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5280), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5278), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [115632] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5276), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5274), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [115690] = 9,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7750), 1,
      anon_sym_where,
    ACTIONS(7772), 1,
      sym_uninitialized,
    ACTIONS(7774), 1,
      sym_tag,
    STATE(4091), 1,
      sym_where_clause,
    STATE(4249), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 32,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [115760] = 11,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7750), 1,
      anon_sym_where,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(7764), 1,
      anon_sym_SLASH,
    ACTIONS(7772), 1,
      sym_uninitialized,
    ACTIONS(7774), 1,
      sym_tag,
    STATE(4091), 1,
      sym_where_clause,
    STATE(4249), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 31,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [115834] = 5,
    ACTIONS(7728), 1,
      anon_sym_LPAREN,
    ACTIONS(7730), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5484), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5482), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [115896] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5552), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5550), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [115954] = 10,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7750), 1,
      anon_sym_where,
    ACTIONS(7776), 1,
      anon_sym_DASH_GT,
    ACTIONS(7778), 1,
      sym_uninitialized,
    ACTIONS(7780), 1,
      sym_tag,
    STATE(4102), 1,
      sym_where_clause,
    STATE(4264), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 31,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [116026] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [116084] = 10,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7750), 1,
      anon_sym_where,
    ACTIONS(7782), 1,
      anon_sym_DASH_GT,
    ACTIONS(7784), 1,
      sym_uninitialized,
    ACTIONS(7786), 1,
      sym_tag,
    STATE(4112), 1,
      sym_where_clause,
    STATE(4268), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4117), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4113), 31,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [116156] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5246), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5244), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [116214] = 5,
    ACTIONS(7728), 1,
      anon_sym_LPAREN,
    ACTIONS(7730), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5466), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5464), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [116276] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5338), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5336), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [116334] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(767), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [116392] = 6,
    ACTIONS(7093), 1,
      anon_sym_LPAREN,
    ACTIONS(7432), 1,
      anon_sym_QMARK,
    ACTIONS(7430), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 34,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [116456] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5454), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5452), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [116514] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(767), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [116572] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5378), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [116630] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5544), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5542), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [116688] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [116746] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4083), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [116804] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5060), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5058), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [116862] = 5,
    ACTIONS(7788), 1,
      sym_identifier,
    ACTIONS(7790), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 20,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [116924] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5414), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5412), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [116982] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5410), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5408), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [117040] = 6,
    ACTIONS(6860), 1,
      anon_sym_DOT2,
    ACTIONS(7792), 1,
      anon_sym_COLON,
    STATE(2801), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 20,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4185), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [117104] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(859), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [117162] = 6,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(7680), 1,
      anon_sym_SLASH,
    ACTIONS(7794), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 35,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [117226] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5446), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5444), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [117284] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5438), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5436), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [117342] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5342), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5340), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [117400] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5434), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5432), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [117458] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5430), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5428), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [117516] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(815), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [117574] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5418), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5416), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [117632] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5346), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5344), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [117690] = 24,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2665), 1,
      anon_sym_LPAREN,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(7814), 1,
      sym_tag,
    STATE(4281), 1,
      sym_procedure,
    STATE(4282), 1,
      sym_type,
    ACTIONS(894), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(891), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [117790] = 24,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2653), 1,
      anon_sym_LPAREN,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(7818), 1,
      sym_tag,
    STATE(4235), 1,
      sym_type,
    STATE(4281), 1,
      sym_procedure,
    ACTIONS(915), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(913), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [117890] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(891), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [117948] = 24,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2629), 1,
      anon_sym_LPAREN,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(7821), 1,
      sym_tag,
    STATE(4277), 1,
      sym_type,
    STATE(4281), 1,
      sym_procedure,
    ACTIONS(861), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(859), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [118048] = 24,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2641), 1,
      anon_sym_LPAREN,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(7824), 1,
      sym_tag,
    STATE(4274), 1,
      sym_type,
    STATE(4281), 1,
      sym_procedure,
    ACTIONS(773), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(767), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [118148] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5402), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5400), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [118206] = 24,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2681), 1,
      anon_sym_LPAREN,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(7827), 1,
      sym_tag,
    STATE(4247), 1,
      sym_type,
    STATE(4281), 1,
      sym_procedure,
    ACTIONS(818), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(815), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [118306] = 24,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2751), 1,
      anon_sym_LPAREN,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(7831), 1,
      sym_tag,
    STATE(4236), 1,
      sym_type,
    STATE(4281), 1,
      sym_procedure,
    ACTIONS(840), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(837), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [118406] = 24,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2594), 1,
      anon_sym_LPAREN,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(7835), 1,
      sym_tag,
    STATE(4221), 1,
      sym_type,
    STATE(4281), 1,
      sym_procedure,
    ACTIONS(877), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(875), 7,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [118506] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5528), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5526), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [118564] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(859), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [118622] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [118680] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(913), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [118738] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(913), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [118796] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(859), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [118854] = 24,
    ACTIONS(915), 1,
      anon_sym_SLASH,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2392), 1,
      anon_sym_LPAREN,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3878), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(913), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [118954] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5398), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5396), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [119012] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5135), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5132), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [119070] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5414), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5412), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [119128] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5368), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5366), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [119186] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5410), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5408), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [119244] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5402), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5400), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [119302] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(891), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [119360] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5398), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5396), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [119418] = 24,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(2189), 1,
      anon_sym_LPAREN,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    STATE(3343), 1,
      sym_type,
    STATE(3765), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 3,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(891), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [119518] = 24,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(2210), 1,
      anon_sym_LPAREN,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    STATE(3208), 1,
      sym_type,
    STATE(3765), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 3,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(815), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [119618] = 24,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(2231), 1,
      anon_sym_LPAREN,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    STATE(3188), 1,
      sym_type,
    STATE(3765), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(840), 3,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(837), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [119718] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [119776] = 6,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7556), 1,
      sym_uninitialized,
    STATE(4512), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [119840] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5384), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5382), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [119898] = 4,
    ACTIONS(7858), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5378), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [119958] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5378), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [120016] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5376), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5374), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [120074] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5372), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5370), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [120132] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5368), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5366), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [120190] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [120248] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5346), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5344), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [120306] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5342), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5340), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [120364] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5524), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5522), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [120422] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3671), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [120480] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [120538] = 5,
    ACTIONS(7860), 1,
      anon_sym_DOT2,
    STATE(3890), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4453), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [120600] = 28,
    ACTIONS(4732), 1,
      anon_sym_EQ,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7199), 1,
      anon_sym_PIPE,
    ACTIONS(7201), 1,
      anon_sym_PLUS,
    ACTIONS(7203), 1,
      anon_sym_DASH,
    ACTIONS(7205), 1,
      anon_sym_TILDE,
    ACTIONS(7207), 1,
      anon_sym_AMP,
    ACTIONS(7211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7219), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7233), 1,
      anon_sym_or_return,
    ACTIONS(7235), 1,
      anon_sym_or_continue,
    ACTIONS(7237), 1,
      anon_sym_or_break,
    ACTIONS(7239), 1,
      anon_sym_CARET,
    ACTIONS(7863), 1,
      anon_sym_COMMA,
    STATE(6573), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(7209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7221), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7284), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7217), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4728), 12,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [120708] = 5,
    ACTIONS(7715), 1,
      anon_sym_DOT2,
    STATE(3890), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4496), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4494), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [120770] = 5,
    ACTIONS(7715), 1,
      anon_sym_DOT2,
    STATE(3892), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [120832] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5338), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5336), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [120890] = 6,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7541), 1,
      sym_uninitialized,
    STATE(4514), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [120954] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5246), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5244), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [121012] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4691), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [121070] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5334), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5332), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [121128] = 24,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(2180), 1,
      anon_sym_LPAREN,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    STATE(3765), 1,
      sym_procedure,
    STATE(3861), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 3,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(859), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [121228] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5498), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5496), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [121286] = 5,
    ACTIONS(7865), 1,
      anon_sym_DOT2,
    STATE(3901), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4453), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [121348] = 24,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2153), 1,
      anon_sym_LPAREN,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    STATE(3765), 1,
      sym_procedure,
    STATE(3859), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 3,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(767), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [121448] = 5,
    ACTIONS(7868), 1,
      anon_sym_DOT2,
    STATE(3901), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4496), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4494), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [121510] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5280), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5278), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [121568] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5276), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5274), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [121626] = 5,
    ACTIONS(7870), 1,
      sym_identifier,
    ACTIONS(7872), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 20,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 26,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [121688] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5060), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5058), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [121746] = 24,
    ACTIONS(877), 1,
      anon_sym_SLASH,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2362), 1,
      anon_sym_LPAREN,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3829), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(875), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [121846] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 21,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4023), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [121904] = 24,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(2201), 1,
      anon_sym_LPAREN,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    STATE(3765), 1,
      sym_procedure,
    STATE(3826), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(877), 3,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(875), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [122004] = 5,
    ACTIONS(7868), 1,
      anon_sym_DOT2,
    STATE(3903), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [122066] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5490), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5488), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [122124] = 4,
    ACTIONS(7874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5378), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [122184] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5376), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5374), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [122242] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(815), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [122300] = 24,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    STATE(3749), 1,
      sym_type,
    STATE(3765), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 3,
      anon_sym_else,
      anon_sym_case,
      anon_sym_SLASH,
    ACTIONS(913), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [122400] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(891), 38,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [122458] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5474), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5472), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [122516] = 6,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7537), 1,
      sym_uninitialized,
    STATE(4506), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [122580] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [122638] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5218), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5216), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [122695] = 5,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(7878), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5484), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5482), 35,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [122756] = 7,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5644), 32,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [122821] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5690), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5688), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [122878] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4928), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4926), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [122935] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5676), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5674), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [122992] = 7,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5644), 33,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [123057] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5206), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5204), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [123114] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5784), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5782), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [123171] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5668), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5666), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [123228] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5812), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5810), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [123285] = 26,
    ACTIONS(4722), 1,
      anon_sym_EQ,
    ACTIONS(7473), 1,
      anon_sym_DASH_GT,
    ACTIONS(7475), 1,
      anon_sym_PIPE,
    ACTIONS(7477), 1,
      anon_sym_PLUS,
    ACTIONS(7479), 1,
      anon_sym_DASH,
    ACTIONS(7481), 1,
      anon_sym_TILDE,
    ACTIONS(7483), 1,
      anon_sym_AMP,
    ACTIONS(7487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7495), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7503), 1,
      anon_sym_DOT,
    ACTIONS(7505), 1,
      anon_sym_LBRACK,
    ACTIONS(7509), 1,
      anon_sym_or_return,
    ACTIONS(7511), 1,
      anon_sym_or_continue,
    ACTIONS(7513), 1,
      anon_sym_or_break,
    ACTIONS(7515), 1,
      anon_sym_CARET,
    ACTIONS(7485), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7489), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7491), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7497), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7499), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7501), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7507), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7650), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4717), 13,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [123388] = 5,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(7898), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [123449] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5714), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5712), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [123506] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5706), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5704), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [123563] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5724), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5722), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [123620] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5748), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5746), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [123677] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5350), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5348), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [123734] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5356), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5354), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [123791] = 15,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_PLUS,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_TILDE,
    ACTIONS(7906), 1,
      anon_sym_AMP,
    ACTIONS(7908), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7912), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7914), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 4,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 27,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [123872] = 26,
    ACTIONS(5422), 1,
      anon_sym_COLON,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_PLUS,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_TILDE,
    ACTIONS(7906), 1,
      anon_sym_AMP,
    ACTIONS(7908), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7934), 1,
      anon_sym_or_break,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7912), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7914), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7918), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(7920), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7924), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7926), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7928), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5420), 13,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_case,
      anon_sym_QMARK,
  [123975] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5672), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5670), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [124032] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5858), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5856), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [124089] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [124146] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5880), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5878), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [124203] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [124260] = 9,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7912), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7914), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 7,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 31,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [124329] = 5,
    ACTIONS(7938), 1,
      anon_sym_COMMA,
    STATE(3953), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4665), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4661), 35,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [124390] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5672), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5670), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [124447] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [124504] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [124561] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5710), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5708), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [124618] = 5,
    ACTIONS(7940), 1,
      anon_sym_COMMA,
    STATE(3953), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4722), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4717), 35,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [124679] = 9,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6943), 1,
      sym_uninitialized,
    ACTIONS(6945), 1,
      sym_tag,
    ACTIONS(7943), 1,
      anon_sym_where,
    STATE(2930), 1,
      sym_where_clause,
    STATE(3085), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 19,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3671), 22,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [124748] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5710), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5708), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [124805] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5754), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5752), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [124862] = 9,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      sym_uninitialized,
    ACTIONS(6929), 1,
      sym_tag,
    ACTIONS(7943), 1,
      anon_sym_where,
    STATE(2927), 1,
      sym_where_clause,
    STATE(3081), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 19,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4023), 22,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [124931] = 9,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      sym_uninitialized,
    ACTIONS(7943), 1,
      anon_sym_where,
    ACTIONS(7945), 1,
      sym_tag,
    STATE(2927), 1,
      sym_where_clause,
    STATE(3081), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 19,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4023), 22,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [125000] = 11,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6927), 1,
      sym_uninitialized,
    ACTIONS(7943), 1,
      anon_sym_where,
    ACTIONS(7945), 1,
      sym_tag,
    ACTIONS(7947), 1,
      anon_sym_SLASH,
    STATE(2927), 1,
      sym_where_clause,
    STATE(3081), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 18,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4023), 21,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [125073] = 9,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      sym_uninitialized,
    ACTIONS(6957), 1,
      sym_tag,
    ACTIONS(7943), 1,
      anon_sym_where,
    STATE(2921), 1,
      sym_where_clause,
    STATE(3072), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 19,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4083), 22,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [125142] = 4,
    ACTIONS(7949), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4701), 19,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(4697), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [125201] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5660), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5658), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [125258] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5656), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5654), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [125315] = 4,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7951), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
    ACTIONS(4990), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4988), 31,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [125374] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5636), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5634), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [125431] = 9,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      sym_uninitialized,
    ACTIONS(7943), 1,
      anon_sym_where,
    ACTIONS(7953), 1,
      sym_tag,
    STATE(2921), 1,
      sym_where_clause,
    STATE(3072), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 19,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4083), 22,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [125500] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5766), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5764), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [125557] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5770), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5768), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [125614] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(5720), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_not_in,
  [125715] = 21,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(5720), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 18,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [125808] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5630), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5628), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [125865] = 11,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      sym_uninitialized,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(7943), 1,
      anon_sym_where,
    ACTIONS(7947), 1,
      anon_sym_SLASH,
    ACTIONS(7953), 1,
      sym_tag,
    STATE(2921), 1,
      sym_where_clause,
    STATE(3072), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 18,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4083), 21,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [125938] = 9,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6920), 1,
      sym_uninitialized,
    ACTIONS(7943), 1,
      anon_sym_where,
    ACTIONS(7991), 1,
      sym_tag,
    STATE(2932), 1,
      sym_where_clause,
    STATE(3055), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 19,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3415), 22,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [126007] = 11,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6920), 1,
      sym_uninitialized,
    ACTIONS(7943), 1,
      anon_sym_where,
    ACTIONS(7947), 1,
      anon_sym_SLASH,
    ACTIONS(7991), 1,
      sym_tag,
    STATE(2932), 1,
      sym_where_clause,
    STATE(3055), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 18,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3415), 21,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [126080] = 5,
    ACTIONS(7993), 1,
      anon_sym_LBRACE,
    STATE(4065), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4568), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4566), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [126141] = 10,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6931), 1,
      sym_uninitialized,
    ACTIONS(6933), 1,
      sym_tag,
    ACTIONS(7943), 1,
      anon_sym_where,
    ACTIONS(7995), 1,
      anon_sym_DASH_GT,
    STATE(2917), 1,
      sym_where_clause,
    STATE(3018), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 19,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(3781), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [126212] = 10,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(7000), 1,
      sym_uninitialized,
    ACTIONS(7002), 1,
      sym_tag,
    ACTIONS(7943), 1,
      anon_sym_where,
    ACTIONS(7997), 1,
      anon_sym_DASH_GT,
    STATE(2922), 1,
      sym_where_clause,
    STATE(3038), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4117), 19,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4113), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [126283] = 14,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_PLUS,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7906), 1,
      anon_sym_AMP,
    ACTIONS(7908), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7912), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7914), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 5,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 27,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [126362] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5202), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5200), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [126419] = 13,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_PLUS,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7908), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7912), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7914), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 27,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [126496] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5636), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5634), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [126553] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5630), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5628), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [126610] = 19,
    ACTIONS(5360), 1,
      anon_sym_COLON,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_PLUS,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_TILDE,
    ACTIONS(7906), 1,
      anon_sym_AMP,
    ACTIONS(7908), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7912), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7914), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7924), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7926), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7928), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 22,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [126699] = 5,
    ACTIONS(7999), 1,
      anon_sym_DOT2,
    STATE(3984), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4453), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [126760] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5626), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5624), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [126817] = 17,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_PLUS,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_TILDE,
    ACTIONS(7906), 1,
      anon_sym_AMP,
    ACTIONS(7908), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7912), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7914), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 3,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7928), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 24,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [126902] = 16,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_PLUS,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_TILDE,
    ACTIONS(7906), 1,
      anon_sym_AMP,
    ACTIONS(7908), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7912), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7914), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 3,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 27,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [126985] = 12,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_PLUS,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7912), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7914), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 28,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [127060] = 5,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(7898), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5484), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5482), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [127121] = 11,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_PLUS,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7912), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7914), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 30,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [127194] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5758), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5756), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [127251] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5626), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5624), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [127308] = 27,
    ACTIONS(81), 1,
      anon_sym_switch,
    ACTIONS(493), 1,
      anon_sym_if,
    ACTIONS(495), 1,
      anon_sym_for,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(8004), 1,
      sym_tag,
    STATE(3766), 1,
      sym_procedure,
    STATE(6769), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7117), 4,
      sym_block,
      sym_if_statement,
      sym_for_statement,
      sym_switch_statement,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [127413] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5812), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5810), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [127470] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5766), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5764), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [127527] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5770), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5768), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [127584] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5822), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5820), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [127641] = 25,
    ACTIONS(5720), 1,
      anon_sym_COLON,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_PLUS,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_TILDE,
    ACTIONS(7906), 1,
      anon_sym_AMP,
    ACTIONS(7908), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7934), 1,
      anon_sym_or_break,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7912), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7914), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7920), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7924), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7926), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7928), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 15,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
  [127742] = 21,
    ACTIONS(5720), 1,
      anon_sym_COLON,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_PLUS,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_TILDE,
    ACTIONS(7906), 1,
      anon_sym_AMP,
    ACTIONS(7908), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7912), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7914), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7920), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7924), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7926), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7928), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 19,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [127835] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5652), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5650), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [127892] = 5,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(7878), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 35,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [127953] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5642), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5640), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [128010] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5826), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5824), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [128067] = 5,
    ACTIONS(7993), 1,
      anon_sym_LBRACE,
    STATE(4065), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4548), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4546), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [128128] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5610), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [128185] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(201), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [128242] = 5,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(7898), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5450), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5448), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [128303] = 4,
    ACTIONS(7790), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 35,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [128362] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5158), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5156), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [128419] = 7,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5600), 33,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [128484] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [128541] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5698), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5696), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [128598] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5170), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5168), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [128655] = 24,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1843), 1,
      anon_sym_LPAREN,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8022), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3030), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 3,
      anon_sym_where,
      anon_sym_when,
      anon_sym_SLASH,
    ACTIONS(913), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [128754] = 26,
    ACTIONS(4722), 1,
      anon_sym_EQ,
    ACTIONS(7197), 1,
      anon_sym_DASH_GT,
    ACTIONS(7199), 1,
      anon_sym_PIPE,
    ACTIONS(7201), 1,
      anon_sym_PLUS,
    ACTIONS(7203), 1,
      anon_sym_DASH,
    ACTIONS(7205), 1,
      anon_sym_TILDE,
    ACTIONS(7207), 1,
      anon_sym_AMP,
    ACTIONS(7211), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7219), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7227), 1,
      anon_sym_DOT,
    ACTIONS(7229), 1,
      anon_sym_LBRACK,
    ACTIONS(7233), 1,
      anon_sym_or_return,
    ACTIONS(7235), 1,
      anon_sym_or_continue,
    ACTIONS(7237), 1,
      anon_sym_or_break,
    ACTIONS(7239), 1,
      anon_sym_CARET,
    ACTIONS(7209), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7213), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7215), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7221), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7223), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7225), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7231), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7284), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7217), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4717), 13,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [128857] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4928), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4926), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [128914] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4950), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4948), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [128971] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5826), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5824), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [129028] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5218), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5216), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [129085] = 27,
    ACTIONS(4732), 1,
      anon_sym_EQ,
    ACTIONS(7938), 1,
      anon_sym_COMMA,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8027), 1,
      anon_sym_PIPE,
    ACTIONS(8029), 1,
      anon_sym_PLUS,
    ACTIONS(8031), 1,
      anon_sym_DASH,
    ACTIONS(8033), 1,
      anon_sym_TILDE,
    ACTIONS(8035), 1,
      anon_sym_AMP,
    ACTIONS(8039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8047), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8061), 1,
      anon_sym_or_return,
    ACTIONS(8063), 1,
      anon_sym_or_continue,
    ACTIONS(8065), 1,
      anon_sym_or_break,
    ACTIONS(8067), 1,
      anon_sym_CARET,
    STATE(3948), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(8037), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8041), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8043), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8045), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4728), 13,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [129190] = 5,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 33,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [129251] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4972), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4970), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [129308] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4990), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4988), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [129365] = 24,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1827), 1,
      anon_sym_LPAREN,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8073), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3134), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 3,
      anon_sym_where,
      anon_sym_when,
      anon_sym_SLASH,
    ACTIONS(891), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [129464] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [129521] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [129578] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5702), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5700), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [129635] = 27,
    ACTIONS(75), 1,
      anon_sym_if,
    ACTIONS(79), 1,
      anon_sym_for,
    ACTIONS(81), 1,
      anon_sym_switch,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(8004), 1,
      sym_tag,
    STATE(3766), 1,
      sym_procedure,
    STATE(6769), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7117), 4,
      sym_block,
      sym_if_statement,
      sym_for_statement,
      sym_switch_statement,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [129740] = 5,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(7898), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5470), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5468), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [129801] = 24,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1895), 1,
      anon_sym_LPAREN,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8077), 1,
      sym_tag,
    STATE(2964), 1,
      sym_type,
    STATE(2978), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 3,
      anon_sym_where,
      anon_sym_when,
      anon_sym_SLASH,
    ACTIONS(859), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [129900] = 5,
    ACTIONS(8080), 1,
      anon_sym_LBRACE,
    STATE(4031), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4623), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4618), 35,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [129961] = 7,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4992), 32,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [130026] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5096), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5094), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [130083] = 7,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5098), 32,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [130148] = 6,
    ACTIONS(8083), 1,
      anon_sym_LBRACE,
    ACTIONS(8085), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [130211] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5112), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5110), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [130268] = 5,
    ACTIONS(8089), 1,
      anon_sym_QMARK,
    ACTIONS(8087), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 34,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_in,
      anon_sym_case,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [130329] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4972), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4970), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [130386] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5112), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5110), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [130443] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5458), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5456), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [130500] = 24,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1751), 1,
      anon_sym_LPAREN,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8091), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3145), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 3,
      anon_sym_where,
      anon_sym_when,
      anon_sym_SLASH,
    ACTIONS(767), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [130599] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5848), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5846), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [130656] = 7,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5098), 33,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [130721] = 13,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [130798] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5154), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5152), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [130855] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5158), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5156), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [130912] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5170), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5168), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [130969] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5850), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [131026] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5202), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5200), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [131083] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5206), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5204), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [131140] = 6,
    ACTIONS(8083), 1,
      anon_sym_LBRACE,
    ACTIONS(8094), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [131203] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5610), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [131260] = 24,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1811), 1,
      anon_sym_LPAREN,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8097), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3020), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 3,
      anon_sym_where,
      anon_sym_when,
      anon_sym_SLASH,
    ACTIONS(815), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [131359] = 24,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1855), 1,
      anon_sym_LPAREN,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8101), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(2999), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(840), 3,
      anon_sym_where,
      anon_sym_when,
      anon_sym_SLASH,
    ACTIONS(837), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [131458] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(201), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [131515] = 4,
    ACTIONS(7872), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [131574] = 5,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(7878), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5470), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5468), 35,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [131635] = 5,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(7878), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5450), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5448), 35,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [131696] = 5,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(7878), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5466), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5464), 35,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [131757] = 24,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1687), 1,
      anon_sym_LPAREN,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8105), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(2981), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(877), 3,
      anon_sym_where,
      anon_sym_when,
      anon_sym_SLASH,
    ACTIONS(875), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [131856] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5258), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5256), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [131913] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [131970] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5268), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5266), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [132027] = 7,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5358), 33,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [132092] = 5,
    ACTIONS(8108), 1,
      anon_sym_LBRACE,
    STATE(4065), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4623), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4618), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [132153] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5874), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5872), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [132210] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5884), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5882), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [132267] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5874), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5872), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [132324] = 7,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5600), 32,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [132389] = 6,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(8111), 1,
      sym_uninitialized,
    STATE(4216), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4691), 34,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_tag,
  [132452] = 7,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(8113), 1,
      sym_uninitialized,
    ACTIONS(8115), 1,
      sym_tag,
    STATE(4222), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 33,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [132517] = 6,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(8113), 1,
      sym_uninitialized,
    STATE(4222), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 34,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_tag,
  [132580] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5538), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5536), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [132637] = 4,
    STATE(4065), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4536), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4534), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [132696] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5560), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5558), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [132753] = 6,
    ACTIONS(8117), 1,
      anon_sym_LBRACE,
    ACTIONS(8120), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 34,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [132816] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5642), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5640), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [132873] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5652), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5650), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [132930] = 5,
    ACTIONS(8123), 1,
      sym_identifier,
    ACTIONS(8125), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 19,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 26,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [132991] = 6,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7752), 1,
      sym_uninitialized,
    STATE(4224), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 34,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_tag,
  [133054] = 7,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7752), 1,
      sym_uninitialized,
    ACTIONS(7754), 1,
      sym_tag,
    STATE(4224), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 33,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [133119] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5656), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5654), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [133176] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4990), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4988), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [133233] = 6,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7756), 1,
      sym_uninitialized,
    STATE(4228), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 34,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_tag,
  [133296] = 4,
    STATE(4065), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4548), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4546), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [133355] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [133412] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5660), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5658), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [133469] = 7,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7756), 1,
      sym_uninitialized,
    ACTIONS(7758), 1,
      sym_tag,
    STATE(4228), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 33,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [133534] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 10,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_DOT2,
    ACTIONS(4453), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [133591] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [133648] = 7,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7766), 1,
      sym_uninitialized,
    ACTIONS(7768), 1,
      sym_tag,
    STATE(4237), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 33,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [133713] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5668), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5666), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [133770] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5850), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [133827] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5848), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5846), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [133884] = 6,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7766), 1,
      sym_uninitialized,
    STATE(4237), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 34,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_tag,
  [133947] = 4,
    STATE(4065), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4568), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4566), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [134006] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5272), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5270), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [134063] = 5,
    ACTIONS(8127), 1,
      anon_sym_DOT2,
    STATE(4116), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [134124] = 6,
    ACTIONS(7790), 1,
      anon_sym_LPAREN,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 32,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [134187] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5850), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [134244] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5850), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [134301] = 7,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7772), 1,
      sym_uninitialized,
    ACTIONS(8129), 1,
      sym_tag,
    STATE(4249), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 33,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [134366] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5676), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5674), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [134423] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5880), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5878), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [134480] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5690), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5688), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [134537] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5858), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5856), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [134594] = 6,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7772), 1,
      sym_uninitialized,
    STATE(4249), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 34,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_tag,
  [134657] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5154), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5152), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [134714] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5784), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5782), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [134771] = 5,
    ACTIONS(7993), 1,
      anon_sym_LBRACE,
    STATE(4065), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4536), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4534), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [134832] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4950), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4948), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [134889] = 7,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7778), 1,
      sym_uninitialized,
    ACTIONS(7780), 1,
      sym_tag,
    STATE(4264), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 33,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [134954] = 6,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7778), 1,
      sym_uninitialized,
    STATE(4264), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 34,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_tag,
  [135017] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5698), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5696), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [135074] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5734), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [135131] = 5,
    ACTIONS(8127), 1,
      anon_sym_DOT2,
    STATE(3984), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4496), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4494), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [135192] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5758), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5756), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [135249] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5754), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5752), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [135306] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5748), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5746), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [135363] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5734), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [135420] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5734), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [135477] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5728), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5726), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [135534] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5734), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [135591] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5572), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5570), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [135648] = 25,
    ACTIONS(5774), 1,
      anon_sym_COLON,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_PLUS,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_TILDE,
    ACTIONS(7906), 1,
      anon_sym_AMP,
    ACTIONS(7908), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7934), 1,
      anon_sym_or_break,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7912), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7914), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7920), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7924), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7926), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7928), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5772), 15,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
  [135749] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5732), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5730), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [135806] = 20,
    ACTIONS(5360), 1,
      anon_sym_COLON,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_PLUS,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_TILDE,
    ACTIONS(7906), 1,
      anon_sym_AMP,
    ACTIONS(7908), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7912), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7914), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7924), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7926), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7928), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 21,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [135897] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5588), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5586), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [135954] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5588), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5586), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [136011] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5272), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5270), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [136068] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(5774), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5772), 14,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_not_in,
  [136169] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5572), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5570), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [136226] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5732), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5730), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [136283] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5350), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5348), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [136340] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5728), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5726), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [136397] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5356), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5354), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [136454] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5560), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5558), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [136511] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5724), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5722), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [136568] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5706), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5704), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [136625] = 15,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [136706] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5702), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5700), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [136763] = 4,
    STATE(4031), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4536), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4534), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [136822] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5714), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5712), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [136879] = 5,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(7898), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5466), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5464), 36,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [136940] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5458), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5456), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [136997] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5538), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5536), 36,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [137054] = 7,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5358), 32,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [137119] = 11,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 29,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [137192] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(5422), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5420), 12,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_QMARK,
      anon_sym_RBRACK,
  [137295] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5096), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5094), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [137352] = 7,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 9,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4992), 33,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [137417] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5884), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5882), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [137474] = 4,
    STATE(4031), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4548), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4546), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [137533] = 12,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 27,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [137608] = 16,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [137691] = 17,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5360), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 23,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [137776] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 11,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_DOT2,
    ACTIONS(4453), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [137833] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5822), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5820), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [137890] = 19,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(5360), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 21,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [137979] = 20,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(5360), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 20,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [138070] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5258), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5256), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [138127] = 9,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 30,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [138196] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5268), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5266), 37,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [138253] = 4,
    STATE(4031), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4568), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4566), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [138312] = 14,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 26,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_RBRACK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [138391] = 25,
    ACTIONS(5774), 1,
      anon_sym_EQ,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8027), 1,
      anon_sym_PIPE,
    ACTIONS(8029), 1,
      anon_sym_PLUS,
    ACTIONS(8031), 1,
      anon_sym_DASH,
    ACTIONS(8033), 1,
      anon_sym_TILDE,
    ACTIONS(8035), 1,
      anon_sym_AMP,
    ACTIONS(8039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8047), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8061), 1,
      anon_sym_or_return,
    ACTIONS(8063), 1,
      anon_sym_or_continue,
    ACTIONS(8065), 1,
      anon_sym_or_break,
    ACTIONS(8067), 1,
      anon_sym_CARET,
    ACTIONS(8037), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8041), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8043), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8045), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5772), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [138491] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4858), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4856), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [138547] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5572), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5570), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [138603] = 24,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    STATE(3765), 1,
      sym_procedure,
    STATE(6761), 1,
      sym_type,
    ACTIONS(818), 2,
      anon_sym_else,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(815), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [138701] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5446), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5444), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [138757] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5438), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5436), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [138813] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5434), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5432), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [138869] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5430), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5428), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [138925] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(815), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [138981] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5418), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5416), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [139037] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5560), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5558), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [139093] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5414), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5412), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [139149] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5410), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5408), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [139205] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5402), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5400), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [139261] = 5,
    ACTIONS(8135), 1,
      anon_sym_LPAREN,
    ACTIONS(8137), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [139321] = 6,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(7764), 1,
      anon_sym_SLASH,
    ACTIONS(8139), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5390), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5386), 35,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [139383] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(891), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [139439] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5398), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5396), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [139495] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5538), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5536), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [139551] = 6,
    ACTIONS(8135), 1,
      anon_sym_LPAREN,
    ACTIONS(8137), 1,
      anon_sym_SLASH,
    ACTIONS(8141), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [139613] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5378), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [139669] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5376), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5374), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [139725] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5372), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5370), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [139781] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5368), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5366), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [139837] = 5,
    ACTIONS(8135), 1,
      anon_sym_LPAREN,
    ACTIONS(8137), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5450), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5448), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [139897] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5588), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5586), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [139953] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5346), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5344), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [140009] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5342), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5340), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [140065] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(767), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [140121] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5338), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5336), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [140177] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5454), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5452), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [140233] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5334), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5332), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [140289] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5552), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5550), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [140345] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5280), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5278), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [140401] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5276), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5274), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [140457] = 5,
    ACTIONS(8135), 1,
      anon_sym_LPAREN,
    ACTIONS(8137), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5466), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5464), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [140517] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5246), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5244), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [140573] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5474), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5472), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [140629] = 5,
    ACTIONS(8135), 1,
      anon_sym_LPAREN,
    ACTIONS(8137), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5484), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5482), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [140689] = 7,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5358), 32,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [140753] = 15,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8029), 1,
      anon_sym_PLUS,
    ACTIONS(8031), 1,
      anon_sym_DASH,
    ACTIONS(8033), 1,
      anon_sym_TILDE,
    ACTIONS(8035), 1,
      anon_sym_AMP,
    ACTIONS(8047), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 4,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 26,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [140833] = 11,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8029), 1,
      anon_sym_PLUS,
    ACTIONS(8031), 1,
      anon_sym_DASH,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 29,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [140905] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5060), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5058), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [140961] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [141017] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5490), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5488), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [141073] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5582), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5580), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [141129] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5276), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5274), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [141185] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5246), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5244), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [141241] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5280), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5278), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [141297] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5608), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5606), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [141353] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5498), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5496), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [141409] = 12,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8029), 1,
      anon_sym_PLUS,
    ACTIONS(8031), 1,
      anon_sym_DASH,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 27,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [141483] = 6,
    ACTIONS(7721), 1,
      anon_sym_LBRACE,
    ACTIONS(8143), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 34,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [141545] = 24,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    STATE(3766), 1,
      sym_procedure,
    STATE(6831), 1,
      sym_type,
    ACTIONS(894), 2,
      anon_sym_else,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(891), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [141643] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5334), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5332), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [141699] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(767), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [141755] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4691), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [141811] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5338), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5336), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [141867] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [141923] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5342), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5340), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [141979] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5346), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5344), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [142035] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [142091] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [142147] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(859), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [142203] = 7,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5600), 32,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [142267] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5368), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5366), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [142323] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5372), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5370), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [142379] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5376), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5374), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [142435] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5378), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [142491] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5384), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5382), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [142547] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(815), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [142603] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [142659] = 16,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8027), 1,
      anon_sym_PIPE,
    ACTIONS(8029), 1,
      anon_sym_PLUS,
    ACTIONS(8031), 1,
      anon_sym_DASH,
    ACTIONS(8033), 1,
      anon_sym_TILDE,
    ACTIONS(8035), 1,
      anon_sym_AMP,
    ACTIONS(8047), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 26,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [142741] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5398), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5396), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [142797] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(913), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [142853] = 17,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8027), 1,
      anon_sym_PIPE,
    ACTIONS(8029), 1,
      anon_sym_PLUS,
    ACTIONS(8031), 1,
      anon_sym_DASH,
    ACTIONS(8033), 1,
      anon_sym_TILDE,
    ACTIONS(8035), 1,
      anon_sym_AMP,
    ACTIONS(8047), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8045), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 23,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [142937] = 19,
    ACTIONS(5360), 1,
      anon_sym_EQ,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8027), 1,
      anon_sym_PIPE,
    ACTIONS(8029), 1,
      anon_sym_PLUS,
    ACTIONS(8031), 1,
      anon_sym_DASH,
    ACTIONS(8033), 1,
      anon_sym_TILDE,
    ACTIONS(8035), 1,
      anon_sym_AMP,
    ACTIONS(8047), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8043), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8045), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 21,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [143025] = 20,
    ACTIONS(5360), 1,
      anon_sym_EQ,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8027), 1,
      anon_sym_PIPE,
    ACTIONS(8029), 1,
      anon_sym_PLUS,
    ACTIONS(8031), 1,
      anon_sym_DASH,
    ACTIONS(8033), 1,
      anon_sym_TILDE,
    ACTIONS(8035), 1,
      anon_sym_AMP,
    ACTIONS(8039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8047), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8041), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8043), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8045), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 20,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [143115] = 13,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8029), 1,
      anon_sym_PLUS,
    ACTIONS(8031), 1,
      anon_sym_DASH,
    ACTIONS(8047), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 26,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [143191] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5402), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5400), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [143247] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5410), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5408), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [143303] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(891), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [143359] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5414), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5412), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [143415] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [143471] = 14,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8029), 1,
      anon_sym_PLUS,
    ACTIONS(8031), 1,
      anon_sym_DASH,
    ACTIONS(8035), 1,
      anon_sym_AMP,
    ACTIONS(8047), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 5,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 26,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [143549] = 4,
    ACTIONS(8145), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4701), 19,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(4697), 26,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [143607] = 9,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 30,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [143675] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5418), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5416), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [143731] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5430), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5428), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [143787] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5135), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5132), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [143843] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4928), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4926), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [143899] = 26,
    ACTIONS(5422), 1,
      anon_sym_EQ,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8027), 1,
      anon_sym_PIPE,
    ACTIONS(8029), 1,
      anon_sym_PLUS,
    ACTIONS(8031), 1,
      anon_sym_DASH,
    ACTIONS(8033), 1,
      anon_sym_TILDE,
    ACTIONS(8035), 1,
      anon_sym_AMP,
    ACTIONS(8039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8047), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8061), 1,
      anon_sym_or_return,
    ACTIONS(8063), 1,
      anon_sym_or_continue,
    ACTIONS(8065), 1,
      anon_sym_or_break,
    ACTIONS(8067), 1,
      anon_sym_CARET,
    ACTIONS(8037), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8041), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8043), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8147), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8045), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5420), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_QMARK,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [144001] = 24,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    STATE(3766), 1,
      sym_procedure,
    STATE(6813), 1,
      sym_type,
    ACTIONS(915), 2,
      anon_sym_else,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(913), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [144099] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4950), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4948), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [144155] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5434), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5432), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [144211] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5438), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5436), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [144267] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5446), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5444), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [144323] = 25,
    ACTIONS(4722), 1,
      anon_sym_EQ,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8027), 1,
      anon_sym_PIPE,
    ACTIONS(8029), 1,
      anon_sym_PLUS,
    ACTIONS(8031), 1,
      anon_sym_DASH,
    ACTIONS(8033), 1,
      anon_sym_TILDE,
    ACTIONS(8035), 1,
      anon_sym_AMP,
    ACTIONS(8039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8047), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8061), 1,
      anon_sym_or_return,
    ACTIONS(8063), 1,
      anon_sym_or_continue,
    ACTIONS(8065), 1,
      anon_sym_or_break,
    ACTIONS(8067), 1,
      anon_sym_CARET,
    ACTIONS(8037), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8041), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8043), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8045), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4717), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [144423] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [144479] = 24,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    STATE(3765), 1,
      sym_procedure,
    STATE(6760), 1,
      sym_type,
    ACTIONS(877), 2,
      anon_sym_else,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(875), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [144577] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5454), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5452), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [144633] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5060), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5058), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [144689] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [144745] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(201), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [144801] = 24,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    STATE(3765), 1,
      sym_procedure,
    STATE(6773), 1,
      sym_type,
    ACTIONS(773), 2,
      anon_sym_else,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(767), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [144899] = 5,
    ACTIONS(8135), 1,
      anon_sym_LPAREN,
    ACTIONS(8137), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5470), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5468), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [144959] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5474), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5472), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [145015] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5610), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [145071] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(859), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [145127] = 5,
    ACTIONS(8151), 1,
      anon_sym_QMARK,
    ACTIONS(8149), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 33,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [145187] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [145243] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(913), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [145299] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5490), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5488), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [145355] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4972), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4970), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [145411] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4990), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4988), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [145467] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5524), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5522), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [145523] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5135), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5132), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [145579] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5626), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5624), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [145635] = 24,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    STATE(3766), 1,
      sym_procedure,
    STATE(6828), 1,
      sym_type,
    ACTIONS(773), 2,
      anon_sym_else,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(767), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [145733] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5498), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5496), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [145789] = 7,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4992), 32,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [145853] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5096), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5094), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [145909] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4691), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [145965] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [146021] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5356), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5354), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [146077] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [146133] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4623), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4618), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [146189] = 28,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(8153), 1,
      anon_sym_COMMA,
    ACTIONS(8155), 1,
      anon_sym_PIPE,
    ACTIONS(8157), 1,
      anon_sym_PLUS,
    ACTIONS(8159), 1,
      anon_sym_DASH,
    ACTIONS(8161), 1,
      anon_sym_TILDE,
    ACTIONS(8163), 1,
      anon_sym_AMP,
    ACTIONS(8165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8167), 1,
      anon_sym_or_else,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8189), 1,
      anon_sym_or_return,
    ACTIONS(8191), 1,
      anon_sym_or_continue,
    ACTIONS(8193), 1,
      anon_sym_or_break,
    STATE(4380), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(8171), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8173), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8179), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8175), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4728), 6,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym_uninitialized,
      sym_tag,
    ACTIONS(4732), 7,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_not_in,
      sym_identifier,
  [146295] = 28,
    ACTIONS(4732), 1,
      anon_sym_EQ,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7048), 1,
      anon_sym_PIPE,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7054), 1,
      anon_sym_TILDE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7068), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7082), 1,
      anon_sym_or_return,
    ACTIONS(7084), 1,
      anon_sym_or_continue,
    ACTIONS(7086), 1,
      anon_sym_or_break,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(8195), 1,
      anon_sym_COMMA,
    STATE(6585), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(7058), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7062), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7064), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7338), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7066), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4728), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      sym_uninitialized,
      sym_tag,
  [146401] = 4,
    ACTIONS(8197), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5610), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [146459] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [146515] = 5,
    ACTIONS(8199), 1,
      sym_identifier,
    ACTIONS(8201), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 19,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 25,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [146575] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5618), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5616), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [146631] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5568), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5566), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [146687] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4858), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4856), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [146743] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [146799] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5528), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5526), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [146855] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5350), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5348), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [146911] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4623), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4618), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [146967] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5630), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5628), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [147023] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [147079] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5544), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5542), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [147135] = 6,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(7764), 1,
      anon_sym_SLASH,
    ACTIONS(8203), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 34,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [147197] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5272), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5270), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [147253] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [147309] = 5,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(7764), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5470), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5468), 35,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [147369] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5552), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5550), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [147425] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5268), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5266), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [147481] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5556), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5554), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [147537] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5258), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5256), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [147593] = 5,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(7764), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5484), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5482), 35,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [147653] = 5,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(7764), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5466), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5464), 35,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [147713] = 5,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(7764), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5450), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5448), 35,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [147773] = 5,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(7764), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 35,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [147833] = 6,
    ACTIONS(8125), 1,
      anon_sym_LPAREN,
    ACTIONS(8151), 1,
      anon_sym_QMARK,
    ACTIONS(8149), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 32,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [147895] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5636), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5634), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [147951] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5524), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5522), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [148007] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5642), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5640), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [148063] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5652), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5650), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [148119] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5656), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5654), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [148175] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5660), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5658), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [148231] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5668), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5666), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [148287] = 4,
    ACTIONS(8125), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 35,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [148345] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4455), 10,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_DOT2,
    ACTIONS(4453), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [148401] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5218), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5216), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [148457] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5676), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5674), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [148513] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5690), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5688), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [148569] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5698), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5696), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [148625] = 24,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    STATE(3766), 1,
      sym_procedure,
    STATE(6830), 1,
      sym_type,
    ACTIONS(861), 2,
      anon_sym_else,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(859), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [148723] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5702), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5700), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [148779] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5458), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5456), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [148835] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5714), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5712), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [148891] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5706), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5704), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [148947] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5724), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5722), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [149003] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5556), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5554), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [149059] = 24,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    STATE(3765), 1,
      sym_procedure,
    STATE(6767), 1,
      sym_type,
    ACTIONS(840), 2,
      anon_sym_else,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(837), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [149157] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5728), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5726), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [149213] = 24,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1687), 1,
      anon_sym_LPAREN,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(2789), 1,
      sym_identifier,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8221), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(2981), 1,
      sym_type,
    ACTIONS(877), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(875), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [149311] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5732), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5730), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [149367] = 24,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1855), 1,
      anon_sym_LPAREN,
    ACTIONS(2857), 1,
      sym_identifier,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8224), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(2999), 1,
      sym_type,
    ACTIONS(840), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(837), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [149465] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5734), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [149521] = 24,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1811), 1,
      anon_sym_LPAREN,
    ACTIONS(2817), 1,
      sym_identifier,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8228), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3020), 1,
      sym_type,
    ACTIONS(818), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(815), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [149619] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5734), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [149675] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5748), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5746), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [149731] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5206), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5204), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [149787] = 24,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1751), 1,
      anon_sym_LPAREN,
    ACTIONS(2767), 1,
      sym_identifier,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8232), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3145), 1,
      sym_type,
    ACTIONS(773), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(767), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [149885] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5202), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5200), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [149941] = 24,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1895), 1,
      anon_sym_LPAREN,
    ACTIONS(2845), 1,
      sym_identifier,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8235), 1,
      sym_tag,
    STATE(2964), 1,
      sym_type,
    STATE(2978), 1,
      sym_procedure,
    ACTIONS(861), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(859), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [150039] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5754), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5752), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [150095] = 24,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1843), 1,
      anon_sym_LPAREN,
    ACTIONS(2833), 1,
      sym_identifier,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8238), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3030), 1,
      sym_type,
    ACTIONS(915), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(913), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [150193] = 24,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1827), 1,
      anon_sym_LPAREN,
    ACTIONS(2801), 1,
      sym_identifier,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8241), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3134), 1,
      sym_type,
    ACTIONS(894), 2,
      anon_sym_where,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(891), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [150291] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5758), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5756), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [150347] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5170), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5168), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [150403] = 26,
    ACTIONS(4722), 1,
      anon_sym_EQ,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7048), 1,
      anon_sym_PIPE,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7054), 1,
      anon_sym_TILDE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7068), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7082), 1,
      anon_sym_or_return,
    ACTIONS(7084), 1,
      anon_sym_or_continue,
    ACTIONS(7086), 1,
      anon_sym_or_break,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(7058), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7062), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7064), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7338), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7066), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4717), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_RBRACK,
      sym_uninitialized,
      sym_tag,
  [150505] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5112), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5110), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [150561] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5378), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [150617] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5784), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5782), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [150673] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5858), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5856), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [150729] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5880), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5878), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [150785] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5384), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5382), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [150841] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5884), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5882), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [150897] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5874), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5872), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [150953] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5850), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [151009] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5850), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [151065] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5848), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5846), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [151121] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [151177] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [151233] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5544), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5542), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [151289] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5826), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5824), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [151345] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4864), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4862), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [151401] = 4,
    ACTIONS(8245), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5378), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [151459] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5822), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5820), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [151515] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5812), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5810), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [151571] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5528), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5526), 37,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [151627] = 5,
    ACTIONS(8153), 1,
      anon_sym_COMMA,
    STATE(4381), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4665), 20,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4661), 24,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [151687] = 5,
    ACTIONS(8247), 1,
      anon_sym_COMMA,
    STATE(4381), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4722), 20,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4717), 24,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [151747] = 21,
    ACTIONS(5720), 1,
      anon_sym_EQ,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8027), 1,
      anon_sym_PIPE,
    ACTIONS(8029), 1,
      anon_sym_PLUS,
    ACTIONS(8031), 1,
      anon_sym_DASH,
    ACTIONS(8033), 1,
      anon_sym_TILDE,
    ACTIONS(8035), 1,
      anon_sym_AMP,
    ACTIONS(8039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8047), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8037), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8041), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8043), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8045), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 18,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [151839] = 25,
    ACTIONS(5720), 1,
      anon_sym_EQ,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8027), 1,
      anon_sym_PIPE,
    ACTIONS(8029), 1,
      anon_sym_PLUS,
    ACTIONS(8031), 1,
      anon_sym_DASH,
    ACTIONS(8033), 1,
      anon_sym_TILDE,
    ACTIONS(8035), 1,
      anon_sym_AMP,
    ACTIONS(8039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8047), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8061), 1,
      anon_sym_or_return,
    ACTIONS(8063), 1,
      anon_sym_or_continue,
    ACTIONS(8065), 1,
      anon_sym_or_break,
    ACTIONS(8067), 1,
      anon_sym_CARET,
    ACTIONS(8037), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8041), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8043), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8045), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 14,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [151939] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5770), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5768), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [151995] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5766), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5764), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [152051] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5710), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5708), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [152107] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [152163] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [152219] = 7,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5098), 32,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [152283] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5672), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5670), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [152339] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5154), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5152), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [152395] = 7,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5644), 32,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [152459] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5158), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5156), 36,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [152515] = 5,
    ACTIONS(8250), 1,
      anon_sym_LPAREN,
    ACTIONS(8252), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [152574] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5544), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5542), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [152629] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5656), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5654), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [152684] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5280), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5278), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [152739] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5652), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5650), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [152794] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5668), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5666), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [152849] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5660), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5658), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [152904] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5766), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5764), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [152959] = 4,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5554), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
    ACTIONS(4990), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4988), 30,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [153016] = 5,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(7947), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5470), 19,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5468), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [153075] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5276), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5274), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [153130] = 6,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(7334), 1,
      anon_sym_EQ,
    ACTIONS(7947), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5390), 18,
      anon_sym_where,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5386), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [153191] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5710), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5708), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [153246] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [153301] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [153356] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5672), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5670), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [153411] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5418), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5416), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [153466] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5430), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5428), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [153521] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5434), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5432), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [153576] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5636), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5634), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [153631] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [153686] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5438), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5436), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [153741] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5446), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5444), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [153796] = 7,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5644), 32,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [153859] = 24,
    ACTIONS(861), 1,
      anon_sym_SLASH,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2078), 1,
      anon_sym_LPAREN,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    STATE(3644), 1,
      sym_type,
    STATE(3690), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(859), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [153956] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5626), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5624), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [154011] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5826), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5824), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [154066] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5398), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5396), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [154121] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5630), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5628), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [154176] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5246), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5244), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [154231] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5642), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5640), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [154286] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5402), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5400), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [154341] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5410), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5408), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [154396] = 24,
    ACTIONS(773), 1,
      anon_sym_SLASH,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2025), 1,
      anon_sym_LPAREN,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    STATE(3659), 1,
      sym_type,
    STATE(3690), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(767), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [154493] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(773), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(767), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [154548] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5610), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [154603] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(201), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [154658] = 5,
    ACTIONS(8250), 1,
      anon_sym_LPAREN,
    ACTIONS(8252), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5450), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5448), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [154717] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(818), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(815), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [154772] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5850), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [154827] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3675), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3671), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [154882] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [154937] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(894), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(891), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [154992] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5454), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5452), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [155047] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5414), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5412), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [155102] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5258), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5256), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [155157] = 6,
    ACTIONS(8201), 1,
      anon_sym_LPAREN,
    ACTIONS(8284), 1,
      anon_sym_QMARK,
    ACTIONS(8282), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 32,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_in,
      anon_sym_case,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [155218] = 7,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5600), 32,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [155281] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [155336] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5880), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5878), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [155391] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5524), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5522), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [155446] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5690), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5688), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [155501] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5588), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5586), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [155556] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5858), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5856), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [155611] = 24,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8286), 1,
      anon_sym_PIPE,
    ACTIONS(8288), 1,
      anon_sym_PLUS,
    ACTIONS(8290), 1,
      anon_sym_DASH,
    ACTIONS(8292), 1,
      anon_sym_TILDE,
    ACTIONS(8294), 1,
      anon_sym_AMP,
    ACTIONS(8298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8306), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8314), 1,
      anon_sym_or_return,
    ACTIONS(8316), 1,
      anon_sym_or_continue,
    ACTIONS(8318), 1,
      anon_sym_or_break,
    ACTIONS(8320), 1,
      anon_sym_CARET,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8296), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8300), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8302), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8308), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8310), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8312), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8304), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5772), 14,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
  [155708] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5572), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5570), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [155763] = 5,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(7947), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5466), 19,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5464), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [155822] = 5,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(7947), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5484), 19,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5482), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [155881] = 5,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(7947), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 19,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4800), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [155940] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5560), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5558), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [155995] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5538), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5536), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [156050] = 7,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5358), 32,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [156113] = 5,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(7947), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5450), 19,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5448), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [156172] = 11,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8288), 1,
      anon_sym_PLUS,
    ACTIONS(8290), 1,
      anon_sym_DASH,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8310), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8312), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 5,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 29,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [156243] = 5,
    ACTIONS(7870), 1,
      sym_identifier,
    ACTIONS(8322), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 19,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 24,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [156302] = 12,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8288), 1,
      anon_sym_PLUS,
    ACTIONS(8290), 1,
      anon_sym_DASH,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8308), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8310), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8312), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 5,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 27,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [156375] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5784), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5782), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [156430] = 16,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8286), 1,
      anon_sym_PIPE,
    ACTIONS(8288), 1,
      anon_sym_PLUS,
    ACTIONS(8290), 1,
      anon_sym_DASH,
    ACTIONS(8292), 1,
      anon_sym_TILDE,
    ACTIONS(8294), 1,
      anon_sym_AMP,
    ACTIONS(8306), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(5360), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8308), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8310), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8312), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5358), 26,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [156511] = 17,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8286), 1,
      anon_sym_PIPE,
    ACTIONS(8288), 1,
      anon_sym_PLUS,
    ACTIONS(8290), 1,
      anon_sym_DASH,
    ACTIONS(8292), 1,
      anon_sym_TILDE,
    ACTIONS(8294), 1,
      anon_sym_AMP,
    ACTIONS(8306), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(5360), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8308), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8310), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8312), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8304), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 23,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [156594] = 18,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8286), 1,
      anon_sym_PIPE,
    ACTIONS(8288), 1,
      anon_sym_PLUS,
    ACTIONS(8290), 1,
      anon_sym_DASH,
    ACTIONS(8292), 1,
      anon_sym_TILDE,
    ACTIONS(8294), 1,
      anon_sym_AMP,
    ACTIONS(8306), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8300), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8302), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8308), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8310), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8312), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8304), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 21,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [156679] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5378), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [156734] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5376), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5374), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [156789] = 19,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8286), 1,
      anon_sym_PIPE,
    ACTIONS(8288), 1,
      anon_sym_PLUS,
    ACTIONS(8290), 1,
      anon_sym_DASH,
    ACTIONS(8292), 1,
      anon_sym_TILDE,
    ACTIONS(8294), 1,
      anon_sym_AMP,
    ACTIONS(8298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8306), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8300), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8302), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8308), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8310), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8312), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8304), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 20,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [156876] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5372), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5370), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [156931] = 13,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8288), 1,
      anon_sym_PLUS,
    ACTIONS(8290), 1,
      anon_sym_DASH,
    ACTIONS(8306), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8308), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8310), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8312), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 5,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 26,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [157006] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5368), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5366), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [157061] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5758), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5756), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [157116] = 14,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8288), 1,
      anon_sym_PLUS,
    ACTIONS(8290), 1,
      anon_sym_DASH,
    ACTIONS(8294), 1,
      anon_sym_AMP,
    ACTIONS(8306), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8308), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8310), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8312), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 4,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 26,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [157193] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5754), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5752), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [157248] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5748), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5746), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [157303] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5850), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [157358] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5734), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [157413] = 24,
    ACTIONS(877), 1,
      anon_sym_SLASH,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2111), 1,
      anon_sym_LPAREN,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    STATE(3660), 1,
      sym_type,
    STATE(3690), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(875), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [157510] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5874), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5872), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [157565] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5334), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5332), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [157620] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5676), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5674), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [157675] = 9,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8310), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8312), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 30,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [157742] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5498), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5496), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [157797] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5060), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5058), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [157852] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [157907] = 25,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8286), 1,
      anon_sym_PIPE,
    ACTIONS(8288), 1,
      anon_sym_PLUS,
    ACTIONS(8290), 1,
      anon_sym_DASH,
    ACTIONS(8292), 1,
      anon_sym_TILDE,
    ACTIONS(8294), 1,
      anon_sym_AMP,
    ACTIONS(8298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8306), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8314), 1,
      anon_sym_or_return,
    ACTIONS(8316), 1,
      anon_sym_or_continue,
    ACTIONS(8318), 1,
      anon_sym_or_break,
    ACTIONS(8320), 1,
      anon_sym_CARET,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8296), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8300), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8302), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8308), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8310), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8312), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8324), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8304), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5420), 12,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_case,
      anon_sym_QMARK,
  [158006] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5822), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5820), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [158061] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5734), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [158116] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5556), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5554), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [158171] = 5,
    ACTIONS(8328), 1,
      anon_sym_QMARK,
    ACTIONS(8326), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 18,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4920), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [158230] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4990), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4988), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [158285] = 7,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 19,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4992), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [158348] = 7,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 19,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5098), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [158411] = 15,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8288), 1,
      anon_sym_PLUS,
    ACTIONS(8290), 1,
      anon_sym_DASH,
    ACTIONS(8292), 1,
      anon_sym_TILDE,
    ACTIONS(8294), 1,
      anon_sym_AMP,
    ACTIONS(8306), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8308), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8310), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8312), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 26,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [158490] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5356), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5354), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [158545] = 24,
    ACTIONS(840), 1,
      anon_sym_SLASH,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2034), 1,
      anon_sym_LPAREN,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    STATE(3645), 1,
      sym_type,
    STATE(3690), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(837), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [158642] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5350), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5348), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [158697] = 4,
    ACTIONS(8330), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5610), 35,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [158754] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5272), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5270), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [158809] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5812), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5810), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [158864] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5268), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5266), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [158919] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(861), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(859), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [158974] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5770), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5768), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [159029] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5552), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5550), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [159084] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3785), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3781), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [159139] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5732), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5730), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [159194] = 24,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8286), 1,
      anon_sym_PIPE,
    ACTIONS(8288), 1,
      anon_sym_PLUS,
    ACTIONS(8290), 1,
      anon_sym_DASH,
    ACTIONS(8292), 1,
      anon_sym_TILDE,
    ACTIONS(8294), 1,
      anon_sym_AMP,
    ACTIONS(8298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8306), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8314), 1,
      anon_sym_or_return,
    ACTIONS(8316), 1,
      anon_sym_or_continue,
    ACTIONS(8318), 1,
      anon_sym_or_break,
    ACTIONS(8320), 1,
      anon_sym_CARET,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8296), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8300), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8302), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8308), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8310), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8312), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8304), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 14,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
  [159291] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3421), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3415), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [159346] = 24,
    ACTIONS(818), 1,
      anon_sym_SLASH,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(1985), 1,
      anon_sym_LPAREN,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    STATE(3649), 1,
      sym_type,
    STATE(3690), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(815), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [159443] = 6,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(7332), 1,
      anon_sym_LBRACE,
    ACTIONS(7947), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 19,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(4800), 23,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [159504] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(915), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(913), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [159559] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5884), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5882), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [159614] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5848), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5846), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [159669] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4669), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4667), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [159724] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5528), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5526), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [159779] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4085), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4083), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [159834] = 7,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5098), 32,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [159897] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5384), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5382), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [159952] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [160007] = 24,
    ACTIONS(915), 1,
      anon_sym_SLASH,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2132), 1,
      anon_sym_LPAREN,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    STATE(3637), 1,
      sym_type,
    STATE(3690), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(913), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [160104] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4928), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4926), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [160159] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4950), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4948), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [160214] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(201), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [160269] = 24,
    ACTIONS(894), 1,
      anon_sym_SLASH,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2013), 1,
      anon_sym_LPAREN,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    STATE(3690), 1,
      sym_procedure,
    STATE(3692), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(891), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [160366] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5728), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5726), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [160421] = 6,
    ACTIONS(7093), 1,
      anon_sym_LPAREN,
    ACTIONS(8328), 1,
      anon_sym_QMARK,
    ACTIONS(8326), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 18,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(67), 23,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [160482] = 15,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(8157), 1,
      anon_sym_PLUS,
    ACTIONS(8159), 1,
      anon_sym_DASH,
    ACTIONS(8161), 1,
      anon_sym_TILDE,
    ACTIONS(8163), 1,
      anon_sym_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8179), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 14,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5358), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [160561] = 27,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(8155), 1,
      anon_sym_PIPE,
    ACTIONS(8157), 1,
      anon_sym_PLUS,
    ACTIONS(8159), 1,
      anon_sym_DASH,
    ACTIONS(8161), 1,
      anon_sym_TILDE,
    ACTIONS(8163), 1,
      anon_sym_AMP,
    ACTIONS(8165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8167), 1,
      anon_sym_or_else,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8189), 1,
      anon_sym_or_return,
    ACTIONS(8191), 1,
      anon_sym_or_continue,
    ACTIONS(8193), 1,
      anon_sym_or_break,
    ACTIONS(8171), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8173), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8179), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8332), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8175), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5422), 5,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_when,
      sym_identifier,
    ACTIONS(5420), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym_uninitialized,
      sym_tag,
  [160664] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5346), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5344), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [160719] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5135), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5132), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [160774] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5342), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5340), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [160829] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [160884] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [160939] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5724), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5722), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [160994] = 9,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 17,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5358), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [161061] = 14,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(8157), 1,
      anon_sym_PLUS,
    ACTIONS(8159), 1,
      anon_sym_DASH,
    ACTIONS(8163), 1,
      anon_sym_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8179), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5358), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
    ACTIONS(5360), 15,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_TILDE,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
  [161138] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4025), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4023), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [161193] = 26,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(8155), 1,
      anon_sym_PIPE,
    ACTIONS(8157), 1,
      anon_sym_PLUS,
    ACTIONS(8159), 1,
      anon_sym_DASH,
    ACTIONS(8161), 1,
      anon_sym_TILDE,
    ACTIONS(8163), 1,
      anon_sym_AMP,
    ACTIONS(8165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8167), 1,
      anon_sym_or_else,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8189), 1,
      anon_sym_or_return,
    ACTIONS(8191), 1,
      anon_sym_or_continue,
    ACTIONS(8193), 1,
      anon_sym_or_break,
    ACTIONS(8171), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8173), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8179), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8175), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4717), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym_uninitialized,
      sym_tag,
    ACTIONS(4722), 7,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_not_in,
      sym_identifier,
  [161294] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5706), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5704), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [161349] = 5,
    ACTIONS(8250), 1,
      anon_sym_LPAREN,
    ACTIONS(8252), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5466), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5464), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [161408] = 5,
    ACTIONS(8250), 1,
      anon_sym_LPAREN,
    ACTIONS(8252), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5470), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5468), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [161467] = 4,
    ACTIONS(8201), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [161524] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [161579] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5474), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5472), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [161634] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5218), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5216), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [161689] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5714), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5712), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [161744] = 5,
    ACTIONS(8284), 1,
      anon_sym_QMARK,
    ACTIONS(8282), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 33,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_in,
      anon_sym_case,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [161803] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5206), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5204), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [161858] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4693), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4691), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [161913] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4972), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4970), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [161968] = 20,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8286), 1,
      anon_sym_PIPE,
    ACTIONS(8288), 1,
      anon_sym_PLUS,
    ACTIONS(8290), 1,
      anon_sym_DASH,
    ACTIONS(8292), 1,
      anon_sym_TILDE,
    ACTIONS(8294), 1,
      anon_sym_AMP,
    ACTIONS(8298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8306), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8296), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8300), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8302), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8308), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8310), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8312), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8304), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 18,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [162057] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5202), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5200), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [162112] = 7,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4992), 32,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [162175] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5096), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5094), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [162230] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5170), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5168), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [162285] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [162340] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5158), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5156), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [162395] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5154), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5152), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [162450] = 13,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(8157), 1,
      anon_sym_PLUS,
    ACTIONS(8159), 1,
      anon_sym_DASH,
    ACTIONS(8177), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8179), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5358), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
    ACTIONS(5360), 16,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
  [162525] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5458), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5456), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [162580] = 22,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(8155), 1,
      anon_sym_PIPE,
    ACTIONS(8157), 1,
      anon_sym_PLUS,
    ACTIONS(8159), 1,
      anon_sym_DASH,
    ACTIONS(8161), 1,
      anon_sym_TILDE,
    ACTIONS(8163), 1,
      anon_sym_AMP,
    ACTIONS(8165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8167), 1,
      anon_sym_or_else,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8171), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8173), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8179), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8175), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
    ACTIONS(5720), 10,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
  [162673] = 5,
    ACTIONS(8250), 1,
      anon_sym_LPAREN,
    ACTIONS(8252), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5484), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5482), 35,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [162732] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5702), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5700), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [162787] = 26,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(8155), 1,
      anon_sym_PIPE,
    ACTIONS(8157), 1,
      anon_sym_PLUS,
    ACTIONS(8159), 1,
      anon_sym_DASH,
    ACTIONS(8161), 1,
      anon_sym_TILDE,
    ACTIONS(8163), 1,
      anon_sym_AMP,
    ACTIONS(8165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8167), 1,
      anon_sym_or_else,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8189), 1,
      anon_sym_or_return,
    ACTIONS(8191), 1,
      anon_sym_or_continue,
    ACTIONS(8193), 1,
      anon_sym_or_break,
    ACTIONS(8171), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8173), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8179), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8175), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym_uninitialized,
      sym_tag,
    ACTIONS(5720), 7,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_not_in,
      sym_identifier,
  [162888] = 7,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 19,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5644), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [162951] = 20,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(8155), 1,
      anon_sym_PIPE,
    ACTIONS(8157), 1,
      anon_sym_PLUS,
    ACTIONS(8159), 1,
      anon_sym_DASH,
    ACTIONS(8161), 1,
      anon_sym_TILDE,
    ACTIONS(8163), 1,
      anon_sym_AMP,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8171), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8173), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8179), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8175), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
    ACTIONS(5360), 11,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
  [163040] = 19,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(8155), 1,
      anon_sym_PIPE,
    ACTIONS(8157), 1,
      anon_sym_PLUS,
    ACTIONS(8159), 1,
      anon_sym_DASH,
    ACTIONS(8161), 1,
      anon_sym_TILDE,
    ACTIONS(8163), 1,
      anon_sym_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8171), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8173), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8179), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8175), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
    ACTIONS(5360), 11,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
  [163127] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5112), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5110), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [163182] = 17,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(8155), 1,
      anon_sym_PIPE,
    ACTIONS(8157), 1,
      anon_sym_PLUS,
    ACTIONS(8159), 1,
      anon_sym_DASH,
    ACTIONS(8161), 1,
      anon_sym_TILDE,
    ACTIONS(8163), 1,
      anon_sym_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8179), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8175), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
    ACTIONS(5360), 13,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
  [163265] = 16,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(8155), 1,
      anon_sym_PIPE,
    ACTIONS(8157), 1,
      anon_sym_PLUS,
    ACTIONS(8159), 1,
      anon_sym_DASH,
    ACTIONS(8161), 1,
      anon_sym_TILDE,
    ACTIONS(8163), 1,
      anon_sym_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8179), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 13,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5358), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [163346] = 12,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(8157), 1,
      anon_sym_PLUS,
    ACTIONS(8159), 1,
      anon_sym_DASH,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8179), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5358), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
    ACTIONS(5360), 16,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
  [163419] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4185), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [163474] = 7,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 19,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5600), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [163537] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5490), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5488), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [163592] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5338), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5336), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [163647] = 26,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(8155), 1,
      anon_sym_PIPE,
    ACTIONS(8157), 1,
      anon_sym_PLUS,
    ACTIONS(8159), 1,
      anon_sym_DASH,
    ACTIONS(8161), 1,
      anon_sym_TILDE,
    ACTIONS(8163), 1,
      anon_sym_AMP,
    ACTIONS(8165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8167), 1,
      anon_sym_or_else,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8189), 1,
      anon_sym_or_return,
    ACTIONS(8191), 1,
      anon_sym_or_continue,
    ACTIONS(8193), 1,
      anon_sym_or_break,
    ACTIONS(8171), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8173), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8179), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8175), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5772), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym_uninitialized,
      sym_tag,
    ACTIONS(5774), 7,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_not_in,
      sym_identifier,
  [163748] = 7,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 19,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5358), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [163811] = 11,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(8157), 1,
      anon_sym_PLUS,
    ACTIONS(8159), 1,
      anon_sym_DASH,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 16,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      sym_identifier,
    ACTIONS(5358), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [163882] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5698), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5696), 36,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [163937] = 14,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 4,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 25,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [164013] = 5,
    ACTIONS(7788), 1,
      sym_identifier,
    ACTIONS(8354), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 23,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [164071] = 6,
    ACTIONS(7872), 1,
      anon_sym_LPAREN,
    ACTIONS(8089), 1,
      anon_sym_QMARK,
    ACTIONS(8087), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 31,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_in,
      anon_sym_case,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [164131] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 35,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [164185] = 5,
    ACTIONS(8356), 1,
      sym_identifier,
    ACTIONS(8358), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 19,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 23,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [164243] = 4,
    ACTIONS(8322), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 34,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [164299] = 24,
    ACTIONS(894), 1,
      anon_sym_SLASH,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8372), 1,
      anon_sym_LPAREN,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    STATE(7068), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(891), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [164395] = 24,
    ACTIONS(877), 1,
      anon_sym_SLASH,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(8398), 1,
      anon_sym_LPAREN,
    STATE(6972), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(875), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [164491] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 35,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [164545] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(201), 35,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [164599] = 4,
    ACTIONS(8401), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4701), 19,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(4697), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [164655] = 20,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 17,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [164743] = 24,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 13,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
  [164839] = 7,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5644), 31,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [164901] = 7,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5600), 31,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [164963] = 24,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5772), 13,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_not_in,
  [165059] = 24,
    ACTIONS(773), 1,
      anon_sym_SLASH,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(8419), 1,
      anon_sym_LPAREN,
    STATE(7049), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(767), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [165155] = 7,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5098), 31,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [165217] = 6,
    ACTIONS(8322), 1,
      anon_sym_LPAREN,
    ACTIONS(8424), 1,
      anon_sym_QMARK,
    ACTIONS(8422), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 31,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_in,
      anon_sym_case,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [165277] = 24,
    ACTIONS(861), 1,
      anon_sym_SLASH,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(8426), 1,
      anon_sym_LPAREN,
    STATE(7081), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(859), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [165373] = 4,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8429), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
    ACTIONS(4990), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4988), 29,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [165429] = 7,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5358), 31,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [165491] = 11,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 5,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 28,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [165561] = 12,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 5,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 26,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [165633] = 16,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(5360), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5358), 25,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [165713] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 35,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [165767] = 6,
    ACTIONS(8431), 1,
      anon_sym_LBRACE,
    ACTIONS(8434), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 31,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [165827] = 17,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(5360), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 22,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [165909] = 18,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 20,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [165993] = 4,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8437), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
    ACTIONS(4990), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4988), 29,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [166049] = 24,
    ACTIONS(818), 1,
      anon_sym_SLASH,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(8439), 1,
      anon_sym_LPAREN,
    STATE(6936), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(815), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [166145] = 19,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 19,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [166231] = 6,
    ACTIONS(7093), 1,
      anon_sym_LPAREN,
    ACTIONS(7430), 1,
      anon_sym_if,
    ACTIONS(7432), 1,
      anon_sym_QMARK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 31,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_when,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
      sym_uninitialized,
      sym_tag,
  [166291] = 13,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 5,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 25,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [166365] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 35,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [166419] = 7,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4992), 31,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [166481] = 24,
    ACTIONS(840), 1,
      anon_sym_SLASH,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(8443), 1,
      anon_sym_LPAREN,
    STATE(6962), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(837), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [166577] = 24,
    ACTIONS(915), 1,
      anon_sym_SLASH,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(8447), 1,
      anon_sym_LPAREN,
    STATE(7047), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(913), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [166673] = 7,
    ACTIONS(7872), 1,
      anon_sym_LPAREN,
    ACTIONS(8089), 1,
      anon_sym_QMARK,
    ACTIONS(8087), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8450), 3,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(71), 10,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 27,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [166735] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 35,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [166789] = 28,
    ACTIONS(4732), 1,
      anon_sym_EQ,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8027), 1,
      anon_sym_PIPE,
    ACTIONS(8029), 1,
      anon_sym_PLUS,
    ACTIONS(8031), 1,
      anon_sym_DASH,
    ACTIONS(8033), 1,
      anon_sym_TILDE,
    ACTIONS(8035), 1,
      anon_sym_AMP,
    ACTIONS(8039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8047), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8061), 1,
      anon_sym_or_return,
    ACTIONS(8063), 1,
      anon_sym_or_continue,
    ACTIONS(8065), 1,
      anon_sym_or_break,
    ACTIONS(8067), 1,
      anon_sym_CARET,
    ACTIONS(8452), 1,
      anon_sym_COMMA,
    STATE(6689), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(8037), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8041), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8043), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8147), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8045), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4728), 8,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [166893] = 25,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5420), 11,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_case,
      anon_sym_QMARK,
  [166991] = 9,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 29,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [167057] = 5,
    ACTIONS(8424), 1,
      anon_sym_QMARK,
    ACTIONS(8422), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 32,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_in,
      anon_sym_case,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [167115] = 15,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 25,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [167193] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 35,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_when,
      anon_sym_in,
      anon_sym_case,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [167247] = 4,
    ACTIONS(8456), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5610), 32,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [167303] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 32,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [167356] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5734), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [167409] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5560), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5558), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [167462] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5702), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5700), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [167515] = 5,
    ACTIONS(8460), 1,
      anon_sym_QMARK,
    ACTIONS(8458), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 29,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [167572] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5770), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5768), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [167625] = 24,
    ACTIONS(877), 1,
      anon_sym_SLASH,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2362), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8462), 1,
      sym_identifier,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    STATE(3829), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(875), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [167720] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5538), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5536), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [167773] = 7,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4992), 28,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [167834] = 7,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5358), 29,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [167895] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5758), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5756), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [167948] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5698), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5696), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [168001] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5690), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5688), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [168054] = 9,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    ACTIONS(7704), 1,
      anon_sym_LPAREN,
    ACTIONS(8497), 1,
      anon_sym_COMMA,
    ACTIONS(8500), 1,
      anon_sym_RPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    STATE(7717), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 27,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [168119] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5812), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5810), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [168172] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5676), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5674), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [168225] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5822), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5820), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [168278] = 9,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    ACTIONS(7704), 1,
      anon_sym_LPAREN,
    ACTIONS(8497), 1,
      anon_sym_COMMA,
    ACTIONS(8503), 1,
      anon_sym_RPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    STATE(8162), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 27,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [168343] = 11,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [168412] = 9,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    ACTIONS(7704), 1,
      anon_sym_LPAREN,
    ACTIONS(8497), 1,
      anon_sym_COMMA,
    ACTIONS(8514), 1,
      anon_sym_RPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    STATE(7600), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 27,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [168477] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5668), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5666), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [168530] = 12,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [168601] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5660), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5658), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [168654] = 25,
    ACTIONS(5720), 1,
      anon_sym_EQ,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
  [168751] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5656), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5654), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [168804] = 7,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5644), 29,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [168865] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5652), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5650), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [168918] = 24,
    ACTIONS(894), 1,
      anon_sym_SLASH,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2401), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    ACTIONS(8545), 1,
      sym_identifier,
    STATE(3717), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(891), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [169013] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 32,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [169066] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(201), 32,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [169119] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 32,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [169172] = 16,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 23,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [169251] = 17,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 3,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [169332] = 19,
    ACTIONS(5360), 1,
      anon_sym_EQ,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [169417] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5096), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5094), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [169470] = 20,
    ACTIONS(5360), 1,
      anon_sym_EQ,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 17,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [169557] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5642), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5640), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [169610] = 13,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 23,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [169683] = 14,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 5,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 23,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [169758] = 6,
    ACTIONS(8354), 1,
      anon_sym_LPAREN,
    ACTIONS(8460), 1,
      anon_sym_QMARK,
    ACTIONS(8458), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 28,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_SEMI,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [169817] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(6945), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(913), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [169910] = 9,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 27,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [169975] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5826), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5824), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [170028] = 24,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2329), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    STATE(3871), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(815), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(818), 2,
      anon_sym_when,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [170123] = 26,
    ACTIONS(4722), 1,
      anon_sym_EQ,
    ACTIONS(8025), 1,
      anon_sym_DASH_GT,
    ACTIONS(8027), 1,
      anon_sym_PIPE,
    ACTIONS(8029), 1,
      anon_sym_PLUS,
    ACTIONS(8031), 1,
      anon_sym_DASH,
    ACTIONS(8033), 1,
      anon_sym_TILDE,
    ACTIONS(8035), 1,
      anon_sym_AMP,
    ACTIONS(8039), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8047), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8055), 1,
      anon_sym_DOT,
    ACTIONS(8057), 1,
      anon_sym_LBRACK,
    ACTIONS(8061), 1,
      anon_sym_or_return,
    ACTIONS(8063), 1,
      anon_sym_or_continue,
    ACTIONS(8065), 1,
      anon_sym_or_break,
    ACTIONS(8067), 1,
      anon_sym_CARET,
    ACTIONS(8037), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8041), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8043), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8049), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8051), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8053), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8059), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8147), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8045), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4717), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [170222] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [170275] = 24,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2280), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    STATE(3846), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(837), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(840), 2,
      anon_sym_when,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [170370] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [170423] = 24,
    ACTIONS(818), 1,
      anon_sym_SLASH,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2329), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    ACTIONS(8567), 1,
      sym_identifier,
    STATE(3871), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(815), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [170518] = 21,
    ACTIONS(5720), 1,
      anon_sym_EQ,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [170607] = 24,
    ACTIONS(773), 1,
      anon_sym_SLASH,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2383), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    ACTIONS(8571), 1,
      sym_identifier,
    STATE(3863), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(767), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [170702] = 15,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 4,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 23,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [170779] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5458), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5456), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [170832] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5754), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5752), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [170885] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5636), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5634), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [170938] = 24,
    ACTIONS(840), 1,
      anon_sym_SLASH,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2280), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    ACTIONS(8574), 1,
      sym_identifier,
    STATE(3846), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(837), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [171033] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(201), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [171086] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5630), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5628), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [171139] = 25,
    ACTIONS(5774), 1,
      anon_sym_EQ,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5772), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
  [171236] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5626), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5624), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [171289] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [171342] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4928), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4926), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [171395] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5848), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5846), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [171448] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4950), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4948), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [171501] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5588), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5586), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [171554] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 32,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [171607] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 32,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [171660] = 5,
    ACTIONS(8580), 1,
      anon_sym_QMARK,
    ACTIONS(8578), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 30,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [171717] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5766), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5764), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [171770] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4972), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4970), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [171823] = 24,
    ACTIONS(915), 1,
      anon_sym_SLASH,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2392), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    ACTIONS(8582), 1,
      sym_identifier,
    STATE(3878), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(913), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [171918] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4990), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4988), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [171971] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5748), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5746), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [172024] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5572), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5570), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [172077] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5850), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [172130] = 7,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4992), 29,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [172191] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5380), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5378), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [172244] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5874), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5872), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [172297] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5610), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [172350] = 7,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5098), 29,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [172411] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5884), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5882), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [172464] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5112), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5110), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [172517] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5356), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5354), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [172570] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5784), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5782), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [172623] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5858), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5856), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [172676] = 29,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(8155), 1,
      anon_sym_PIPE,
    ACTIONS(8157), 1,
      anon_sym_PLUS,
    ACTIONS(8159), 1,
      anon_sym_DASH,
    ACTIONS(8161), 1,
      anon_sym_TILDE,
    ACTIONS(8163), 1,
      anon_sym_AMP,
    ACTIONS(8165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8167), 1,
      anon_sym_or_else,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8189), 1,
      anon_sym_or_return,
    ACTIONS(8191), 1,
      anon_sym_or_continue,
    ACTIONS(8193), 1,
      anon_sym_or_break,
    ACTIONS(8585), 1,
      anon_sym_COMMA,
    STATE(6738), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(8171), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8173), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8179), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8332), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4732), 3,
      anon_sym_where,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(8175), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4728), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uninitialized,
      sym_tag,
  [172781] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5736), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5734), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [172834] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 32,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [172887] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5350), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5348), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [172940] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5880), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5878), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [172993] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5272), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5270), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [173046] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5714), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5712), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [173099] = 7,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5098), 28,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [173160] = 24,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2401), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    STATE(3717), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(891), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(894), 2,
      anon_sym_when,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [173255] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5706), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5704), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [173308] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5268), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5266), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [173361] = 9,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    ACTIONS(7704), 1,
      anon_sym_LPAREN,
    ACTIONS(8497), 1,
      anon_sym_COMMA,
    ACTIONS(8587), 1,
      anon_sym_RPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    STATE(7802), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 27,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [173426] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [173479] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [173532] = 28,
    ACTIONS(4732), 1,
      anon_sym_EQ,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7048), 1,
      anon_sym_PIPE,
    ACTIONS(7050), 1,
      anon_sym_PLUS,
    ACTIONS(7052), 1,
      anon_sym_DASH,
    ACTIONS(7054), 1,
      anon_sym_TILDE,
    ACTIONS(7056), 1,
      anon_sym_AMP,
    ACTIONS(7060), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7068), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7076), 1,
      anon_sym_DOT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7082), 1,
      anon_sym_or_return,
    ACTIONS(7084), 1,
      anon_sym_or_continue,
    ACTIONS(7086), 1,
      anon_sym_or_break,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(8590), 1,
      anon_sym_COMMA,
    STATE(6751), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(7058), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7062), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7064), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7072), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7074), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7080), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7338), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7066), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4728), 7,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
      sym_uninitialized,
      sym_tag,
  [173635] = 9,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    ACTIONS(7704), 1,
      anon_sym_LPAREN,
    ACTIONS(8497), 1,
      anon_sym_COMMA,
    ACTIONS(8592), 1,
      anon_sym_RPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    STATE(8132), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 27,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [173700] = 6,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(7680), 1,
      anon_sym_SLASH,
    ACTIONS(8595), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4804), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4800), 31,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [173759] = 15,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 22,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [173836] = 26,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(5422), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5420), 8,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_QMARK,
  [173935] = 9,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 26,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [174000] = 14,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 22,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [174075] = 13,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 22,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [174148] = 20,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5360), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 16,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [174235] = 19,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(5360), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 17,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [174320] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5158), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5156), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [174373] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5170), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5168), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [174426] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5724), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5722), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [174479] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5202), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5200), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [174532] = 17,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5360), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 19,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [174613] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5728), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5726), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [174666] = 16,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 22,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [174745] = 12,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 23,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [174816] = 11,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 25,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [174885] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5206), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5204), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [174938] = 4,
    ACTIONS(8358), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 32,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [174993] = 7,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5358), 28,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [175054] = 25,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(5774), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5772), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
  [175151] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5852), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5850), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [175204] = 6,
    ACTIONS(8358), 1,
      anon_sym_LPAREN,
    ACTIONS(8580), 1,
      anon_sym_QMARK,
    ACTIONS(8578), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 29,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [175263] = 7,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5600), 28,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [175324] = 7,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5644), 28,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [175385] = 7,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 9,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5600), 29,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [175446] = 25,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(5720), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 10,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
  [175543] = 21,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5720), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 14,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [175632] = 24,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2392), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    STATE(3878), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(913), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(915), 2,
      anon_sym_when,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [175727] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5258), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5256), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [175780] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7179), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(767), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [175873] = 23,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(6915), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(767), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [175966] = 23,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(6924), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(875), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [176059] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5672), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5670), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [176112] = 24,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2255), 1,
      anon_sym_LPAREN,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    STATE(3803), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(859), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(861), 2,
      anon_sym_when,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [176207] = 24,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2362), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    STATE(3829), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(875), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(877), 2,
      anon_sym_when,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [176302] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5218), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5216), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [176355] = 24,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2383), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    STATE(3863), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(767), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(773), 2,
      anon_sym_when,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [176450] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5154), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5152), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [176503] = 4,
    ACTIONS(8354), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 31,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [176558] = 6,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    ACTIONS(8631), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 30,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [176617] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7169), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(859), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [176710] = 24,
    ACTIONS(861), 1,
      anon_sym_SLASH,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2255), 1,
      anon_sym_LPAREN,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    ACTIONS(8633), 1,
      sym_identifier,
    STATE(3803), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(859), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [176805] = 26,
    ACTIONS(5422), 1,
      anon_sym_EQ,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5420), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_QMARK,
  [176904] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5710), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5708), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [176957] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5732), 10,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5730), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [177010] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8640), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [177104] = 24,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8642), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7146), 1,
      sym_type,
    STATE(8085), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [177198] = 24,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8644), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(6949), 1,
      sym_type,
    STATE(8327), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [177292] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8646), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [177386] = 24,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8648), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7040), 1,
      sym_type,
    STATE(7918), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [177480] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8650), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [177574] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8652), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [177668] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8654), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [177762] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8656), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [177856] = 24,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8658), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7078), 1,
      sym_type,
    STATE(8229), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [177950] = 23,
    ACTIONS(773), 1,
      anon_sym_SLASH,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    STATE(3690), 1,
      sym_procedure,
    STATE(7374), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(767), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [178042] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8660), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [178136] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8662), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [178230] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8664), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [178324] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8666), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [178418] = 24,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8668), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7062), 1,
      sym_type,
    STATE(7956), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [178512] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8670), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [178606] = 24,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8672), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7168), 1,
      sym_type,
    STATE(8279), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [178700] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8674), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [178794] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8676), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [178888] = 24,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8678), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7054), 1,
      sym_type,
    STATE(7700), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [178982] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8680), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [179076] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8682), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [179170] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8684), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [179264] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8686), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [179358] = 28,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8286), 1,
      anon_sym_PIPE,
    ACTIONS(8288), 1,
      anon_sym_PLUS,
    ACTIONS(8290), 1,
      anon_sym_DASH,
    ACTIONS(8292), 1,
      anon_sym_TILDE,
    ACTIONS(8294), 1,
      anon_sym_AMP,
    ACTIONS(8298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8306), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8314), 1,
      anon_sym_or_return,
    ACTIONS(8316), 1,
      anon_sym_or_continue,
    ACTIONS(8318), 1,
      anon_sym_or_break,
    ACTIONS(8320), 1,
      anon_sym_CARET,
    ACTIONS(8688), 1,
      anon_sym_COMMA,
    ACTIONS(8690), 1,
      sym__nl_comma,
    STATE(6812), 1,
      aux_sym_return_statement_repeat1,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8296), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8300), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8302), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8308), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8310), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8312), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8324), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8304), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(2953), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [179460] = 27,
    ACTIONS(7046), 1,
      anon_sym_DASH_GT,
    ACTIONS(7078), 1,
      anon_sym_LBRACK,
    ACTIONS(7088), 1,
      anon_sym_CARET,
    ACTIONS(8155), 1,
      anon_sym_PIPE,
    ACTIONS(8157), 1,
      anon_sym_PLUS,
    ACTIONS(8159), 1,
      anon_sym_DASH,
    ACTIONS(8161), 1,
      anon_sym_TILDE,
    ACTIONS(8163), 1,
      anon_sym_AMP,
    ACTIONS(8165), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8167), 1,
      anon_sym_or_else,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8177), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8185), 1,
      anon_sym_DOT,
    ACTIONS(8189), 1,
      anon_sym_or_return,
    ACTIONS(8191), 1,
      anon_sym_or_continue,
    ACTIONS(8193), 1,
      anon_sym_or_break,
    ACTIONS(8171), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8173), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8179), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8181), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8183), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8187), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8332), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4722), 3,
      anon_sym_where,
      anon_sym_EQ,
      sym_identifier,
    ACTIONS(8175), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(4717), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uninitialized,
      sym_tag,
  [179560] = 24,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8692), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7079), 1,
      sym_type,
    STATE(8187), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [179654] = 24,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8694), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7030), 1,
      sym_type,
    STATE(7594), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [179748] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7233), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(875), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [179840] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8696), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [179934] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8698), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [180028] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8700), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [180122] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8702), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [180216] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8704), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [180310] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8706), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [180404] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7324), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(815), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [180496] = 23,
    ACTIONS(877), 1,
      anon_sym_SLASH,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    STATE(3690), 1,
      sym_procedure,
    STATE(7311), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(875), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [180588] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8708), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [180682] = 24,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8710), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7153), 1,
      sym_type,
    STATE(8249), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [180776] = 24,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8712), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7194), 1,
      sym_type,
    STATE(7963), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [180870] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8714), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [180964] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8716), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [181058] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8718), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [181152] = 24,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8720), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(6968), 1,
      sym_type,
    STATE(7742), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [181246] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8722), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [181340] = 24,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8724), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(6970), 1,
      sym_type,
    STATE(8334), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [181434] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8726), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [181528] = 24,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8728), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7183), 1,
      sym_type,
    STATE(7794), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [181622] = 28,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8286), 1,
      anon_sym_PIPE,
    ACTIONS(8288), 1,
      anon_sym_PLUS,
    ACTIONS(8290), 1,
      anon_sym_DASH,
    ACTIONS(8292), 1,
      anon_sym_TILDE,
    ACTIONS(8294), 1,
      anon_sym_AMP,
    ACTIONS(8298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8306), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8314), 1,
      anon_sym_or_return,
    ACTIONS(8316), 1,
      anon_sym_or_continue,
    ACTIONS(8318), 1,
      anon_sym_or_break,
    ACTIONS(8320), 1,
      anon_sym_CARET,
    ACTIONS(8690), 1,
      sym__nl_comma,
    ACTIONS(8730), 1,
      anon_sym_COMMA,
    STATE(6838), 1,
      aux_sym_return_statement_repeat1,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8296), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8300), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8302), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8308), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8310), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8312), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8324), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8304), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(717), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [181724] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8732), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [181818] = 24,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8734), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7177), 1,
      sym_type,
    STATE(7831), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [181912] = 24,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8736), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(6976), 1,
      sym_type,
    STATE(8337), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [182006] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8738), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [182100] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8740), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [182194] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8742), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [182288] = 6,
    ACTIONS(7870), 1,
      sym_identifier,
    ACTIONS(8322), 1,
      anon_sym_LPAREN,
    ACTIONS(8744), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 17,
      anon_sym_PIPE,
      anon_sym_else,
      anon_sym_in,
      anon_sym_case,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 22,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_SEMI,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [182346] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7226), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(891), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [182438] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7221), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(837), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [182530] = 24,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8746), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [182624] = 24,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(8638), 1,
      sym_identifier,
    ACTIONS(8748), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(6984), 1,
      sym_type,
    STATE(8117), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [182718] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8752), 1,
      anon_sym_COMMA,
    STATE(6884), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8750), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [182817] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8756), 1,
      anon_sym_COMMA,
    STATE(6893), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8754), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [182916] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6886), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8758), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [183015] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6872), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8762), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [183114] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8756), 1,
      anon_sym_COMMA,
    STATE(6883), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8764), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [183213] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8752), 1,
      anon_sym_COMMA,
    STATE(6892), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8766), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [183312] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8756), 1,
      anon_sym_COMMA,
    STATE(6855), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8768), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [183411] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8752), 1,
      anon_sym_COMMA,
    STATE(6859), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8770), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [183510] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6871), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8772), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [183609] = 25,
    ACTIONS(8254), 1,
      anon_sym_DASH_GT,
    ACTIONS(8256), 1,
      anon_sym_DOT,
    ACTIONS(8258), 1,
      anon_sym_LBRACK,
    ACTIONS(8286), 1,
      anon_sym_PIPE,
    ACTIONS(8288), 1,
      anon_sym_PLUS,
    ACTIONS(8290), 1,
      anon_sym_DASH,
    ACTIONS(8292), 1,
      anon_sym_TILDE,
    ACTIONS(8294), 1,
      anon_sym_AMP,
    ACTIONS(8298), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8306), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8314), 1,
      anon_sym_or_return,
    ACTIONS(8316), 1,
      anon_sym_or_continue,
    ACTIONS(8318), 1,
      anon_sym_or_break,
    ACTIONS(8320), 1,
      anon_sym_CARET,
    ACTIONS(8260), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8296), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8300), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8302), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8308), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8310), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8312), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8324), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8304), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8774), 8,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [183704] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6905), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8776), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [183803] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6906), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8778), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [183902] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8752), 1,
      anon_sym_COMMA,
    STATE(6857), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8780), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [184001] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8756), 1,
      anon_sym_COMMA,
    STATE(6907), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8782), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [184100] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8756), 1,
      anon_sym_COMMA,
    STATE(6862), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8784), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [184199] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8756), 1,
      anon_sym_COMMA,
    STATE(6903), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8786), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [184298] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8638), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_procedure,
    STATE(7446), 1,
      sym_type,
    STATE(8572), 2,
      sym_named_type,
      sym_default_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [184389] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8788), 1,
      sym_identifier,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8792), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6554), 1,
      sym_named_type,
    STATE(6574), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [184479] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8794), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [184569] = 23,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8796), 1,
      sym_identifier,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8800), 1,
      anon_sym_LBRACK,
    ACTIONS(8802), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6503), 1,
      sym_named_type,
    STATE(6521), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [184659] = 23,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8804), 1,
      sym_identifier,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8808), 1,
      anon_sym_LBRACK,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8812), 1,
      sym_tag,
    STATE(3278), 1,
      sym_type,
    STATE(3279), 1,
      sym_named_type,
    STATE(3475), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [184749] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8814), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [184839] = 23,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8796), 1,
      sym_identifier,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8800), 1,
      anon_sym_LBRACK,
    ACTIONS(8802), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6528), 1,
      sym_type,
    STATE(6544), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [184929] = 23,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(8816), 1,
      sym_identifier,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8820), 1,
      anon_sym_LBRACK,
    ACTIONS(8822), 1,
      sym_tag,
    STATE(4281), 1,
      sym_procedure,
    STATE(6682), 1,
      sym_named_type,
    STATE(6707), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [185019] = 23,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8826), 1,
      anon_sym_LBRACK,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8830), 1,
      sym_tag,
    STATE(2963), 1,
      sym_type,
    STATE(2978), 1,
      sym_procedure,
    STATE(3141), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [185109] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8832), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [185199] = 5,
    ACTIONS(8356), 1,
      sym_identifier,
    ACTIONS(8834), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 18,
      anon_sym_PIPE,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 20,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [185253] = 23,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8804), 1,
      sym_identifier,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8808), 1,
      anon_sym_LBRACK,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8836), 1,
      sym_tag,
    STATE(3276), 1,
      sym_type,
    STATE(3277), 1,
      sym_named_type,
    STATE(3475), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [185343] = 23,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8826), 1,
      anon_sym_LBRACK,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8830), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3133), 1,
      sym_type,
    STATE(3135), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [185433] = 23,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8838), 1,
      sym_identifier,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8844), 1,
      anon_sym_LBRACK,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8848), 1,
      sym_tag,
    STATE(2320), 1,
      sym_named_type,
    STATE(2325), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [185523] = 23,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8850), 1,
      anon_sym_LBRACK,
    ACTIONS(8852), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3133), 1,
      sym_type,
    STATE(3135), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [185613] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8854), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [185703] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8856), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [185793] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8858), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [185883] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8860), 1,
      sym_identifier,
    ACTIONS(8862), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6754), 1,
      sym_named_type,
    STATE(6755), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [185973] = 23,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8850), 1,
      anon_sym_LBRACK,
    ACTIONS(8864), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3131), 1,
      sym_type,
    STATE(3132), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [186063] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8860), 1,
      sym_identifier,
    ACTIONS(8866), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6749), 1,
      sym_named_type,
    STATE(6750), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [186153] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8860), 1,
      sym_identifier,
    ACTIONS(8868), 1,
      anon_sym_LBRACK,
    ACTIONS(8870), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6749), 1,
      sym_named_type,
    STATE(6750), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [186243] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8860), 1,
      sym_identifier,
    ACTIONS(8868), 1,
      anon_sym_LBRACK,
    ACTIONS(8870), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6744), 1,
      sym_named_type,
    STATE(6746), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [186333] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8872), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [186423] = 23,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8874), 1,
      sym_identifier,
    ACTIONS(8876), 1,
      anon_sym_LBRACK,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8880), 1,
      sym_tag,
    STATE(2938), 1,
      sym_type,
    STATE(2939), 1,
      sym_named_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [186513] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8882), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [186603] = 23,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8838), 1,
      sym_identifier,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8844), 1,
      anon_sym_LBRACK,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8884), 1,
      sym_tag,
    STATE(1419), 1,
      sym_named_type,
    STATE(1420), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [186693] = 23,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8838), 1,
      sym_identifier,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8886), 1,
      anon_sym_LBRACK,
    ACTIONS(8888), 1,
      sym_tag,
    STATE(1419), 1,
      sym_named_type,
    STATE(1420), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [186783] = 23,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8804), 1,
      sym_identifier,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8890), 1,
      anon_sym_LBRACK,
    ACTIONS(8892), 1,
      sym_tag,
    STATE(3395), 1,
      sym_type,
    STATE(3396), 1,
      sym_named_type,
    STATE(3475), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [186873] = 23,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8804), 1,
      sym_identifier,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8808), 1,
      anon_sym_LBRACK,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8894), 1,
      sym_tag,
    STATE(3395), 1,
      sym_type,
    STATE(3396), 1,
      sym_named_type,
    STATE(3475), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [186963] = 23,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8796), 1,
      sym_identifier,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8800), 1,
      anon_sym_LBRACK,
    ACTIONS(8802), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6586), 1,
      sym_named_type,
    STATE(6603), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [187053] = 23,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8838), 1,
      sym_identifier,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8886), 1,
      anon_sym_LBRACK,
    ACTIONS(8888), 1,
      sym_tag,
    STATE(1401), 1,
      sym_named_type,
    STATE(1403), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [187143] = 23,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8804), 1,
      sym_identifier,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8808), 1,
      anon_sym_LBRACK,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8896), 1,
      sym_tag,
    STATE(3393), 1,
      sym_type,
    STATE(3394), 1,
      sym_named_type,
    STATE(3475), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [187233] = 23,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8804), 1,
      sym_identifier,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8890), 1,
      anon_sym_LBRACK,
    ACTIONS(8892), 1,
      sym_tag,
    STATE(3426), 1,
      sym_named_type,
    STATE(3427), 1,
      sym_type,
    STATE(3475), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [187323] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8788), 1,
      sym_identifier,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8898), 1,
      anon_sym_LBRACK,
    ACTIONS(8900), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6561), 1,
      sym_named_type,
    STATE(6563), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [187413] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8902), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [187503] = 23,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(8816), 1,
      sym_identifier,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8820), 1,
      anon_sym_LBRACK,
    ACTIONS(8822), 1,
      sym_tag,
    STATE(4281), 1,
      sym_procedure,
    STATE(6636), 1,
      sym_named_type,
    STATE(6638), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [187593] = 25,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(7640), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [187687] = 23,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8874), 1,
      sym_identifier,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8904), 1,
      anon_sym_LBRACK,
    ACTIONS(8906), 1,
      sym_tag,
    STATE(3015), 1,
      sym_named_type,
    STATE(3016), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [187777] = 23,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8796), 1,
      sym_identifier,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8908), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6535), 1,
      sym_named_type,
    STATE(6538), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [187867] = 23,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(8816), 1,
      sym_identifier,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8820), 1,
      anon_sym_LBRACK,
    ACTIONS(8822), 1,
      sym_tag,
    STATE(4281), 1,
      sym_procedure,
    STATE(6709), 1,
      sym_named_type,
    STATE(6714), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [187957] = 23,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8838), 1,
      sym_identifier,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8844), 1,
      anon_sym_LBRACK,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8910), 1,
      sym_tag,
    STATE(1401), 1,
      sym_named_type,
    STATE(1403), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [188047] = 23,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(8816), 1,
      sym_identifier,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8912), 1,
      sym_tag,
    STATE(4281), 1,
      sym_procedure,
    STATE(6709), 1,
      sym_named_type,
    STATE(6714), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [188137] = 23,
    ACTIONS(1283), 1,
      anon_sym_distinct,
    ACTIONS(2584), 1,
      anon_sym_proc,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2597), 1,
      anon_sym_DOLLAR,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2611), 1,
      anon_sym_map,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2615), 1,
      anon_sym_matrix,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8914), 1,
      sym_identifier,
    ACTIONS(8916), 1,
      anon_sym_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_CARET,
    ACTIONS(8920), 1,
      sym_tag,
    STATE(3788), 1,
      sym_named_type,
    STATE(3790), 1,
      sym_type,
    STATE(4281), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [188227] = 23,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8922), 1,
      sym_identifier,
    ACTIONS(8924), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(6513), 1,
      sym_named_type,
    STATE(6523), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [188317] = 23,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8926), 1,
      sym_identifier,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8932), 1,
      anon_sym_LBRACK,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(8936), 1,
      sym_tag,
    STATE(636), 1,
      sym_named_type,
    STATE(642), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [188407] = 23,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8922), 1,
      sym_identifier,
    ACTIONS(8938), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(6531), 1,
      sym_type,
    STATE(6534), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [188497] = 23,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8922), 1,
      sym_identifier,
    ACTIONS(8940), 1,
      anon_sym_LBRACK,
    ACTIONS(8942), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(6531), 1,
      sym_type,
    STATE(6534), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [188587] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8788), 1,
      sym_identifier,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8944), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6557), 1,
      sym_named_type,
    STATE(6558), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [188677] = 23,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8874), 1,
      sym_identifier,
    ACTIONS(8876), 1,
      anon_sym_LBRACK,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8946), 1,
      sym_tag,
    STATE(3039), 1,
      sym_named_type,
    STATE(3115), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [188767] = 23,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8826), 1,
      anon_sym_LBRACK,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8830), 1,
      sym_tag,
    STATE(2909), 1,
      sym_named_type,
    STATE(2910), 1,
      sym_type,
    STATE(2978), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [188857] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8788), 1,
      sym_identifier,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8898), 1,
      anon_sym_LBRACK,
    ACTIONS(8900), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6554), 1,
      sym_named_type,
    STATE(6574), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [188947] = 23,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8796), 1,
      sym_identifier,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8948), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6596), 1,
      sym_type,
    STATE(6598), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [189037] = 23,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8922), 1,
      sym_identifier,
    ACTIONS(8950), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(6577), 1,
      sym_type,
    STATE(6609), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [189127] = 23,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8804), 1,
      sym_identifier,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8890), 1,
      anon_sym_LBRACK,
    ACTIONS(8892), 1,
      sym_tag,
    STATE(3148), 1,
      sym_named_type,
    STATE(3283), 1,
      sym_type,
    STATE(3475), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [189217] = 23,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8838), 1,
      sym_identifier,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8886), 1,
      anon_sym_LBRACK,
    ACTIONS(8888), 1,
      sym_tag,
    STATE(2308), 1,
      sym_named_type,
    STATE(2318), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [189307] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8788), 1,
      sym_identifier,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8898), 1,
      anon_sym_LBRACK,
    ACTIONS(8900), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6569), 1,
      sym_type,
    STATE(6579), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [189397] = 23,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8796), 1,
      sym_identifier,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8800), 1,
      anon_sym_LBRACK,
    ACTIONS(8802), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6526), 1,
      sym_type,
    STATE(6529), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [189487] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8952), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [189577] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8954), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7306), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [189667] = 25,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8956), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [189761] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8958), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [189851] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8960), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7321), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [189941] = 23,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8796), 1,
      sym_identifier,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8962), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6503), 1,
      sym_named_type,
    STATE(6521), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [190031] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8964), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [190121] = 23,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8874), 1,
      sym_identifier,
    ACTIONS(8876), 1,
      anon_sym_LBRACK,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8966), 1,
      sym_tag,
    STATE(3098), 1,
      sym_named_type,
    STATE(3099), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [190211] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8968), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [190301] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8970), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [190391] = 23,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8804), 1,
      sym_identifier,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8890), 1,
      anon_sym_LBRACK,
    ACTIONS(8892), 1,
      sym_tag,
    STATE(3278), 1,
      sym_type,
    STATE(3279), 1,
      sym_named_type,
    STATE(3475), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [190481] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8972), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [190571] = 23,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8926), 1,
      sym_identifier,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8932), 1,
      anon_sym_LBRACK,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(8974), 1,
      sym_tag,
    STATE(534), 1,
      sym_type,
    STATE(625), 1,
      sym_named_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [190661] = 23,
    ACTIONS(1283), 1,
      anon_sym_distinct,
    ACTIONS(2584), 1,
      anon_sym_proc,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2597), 1,
      anon_sym_DOLLAR,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2611), 1,
      anon_sym_map,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2615), 1,
      anon_sym_matrix,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8914), 1,
      sym_identifier,
    ACTIONS(8918), 1,
      anon_sym_CARET,
    ACTIONS(8976), 1,
      anon_sym_LBRACK,
    ACTIONS(8978), 1,
      sym_tag,
    STATE(3816), 1,
      sym_named_type,
    STATE(3817), 1,
      sym_type,
    STATE(4281), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [190751] = 23,
    ACTIONS(1283), 1,
      anon_sym_distinct,
    ACTIONS(2584), 1,
      anon_sym_proc,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2597), 1,
      anon_sym_DOLLAR,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2611), 1,
      anon_sym_map,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2615), 1,
      anon_sym_matrix,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8914), 1,
      sym_identifier,
    ACTIONS(8918), 1,
      anon_sym_CARET,
    ACTIONS(8976), 1,
      anon_sym_LBRACK,
    ACTIONS(8980), 1,
      sym_tag,
    STATE(3792), 1,
      sym_named_type,
    STATE(3800), 1,
      sym_type,
    STATE(4281), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [190841] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8982), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [190931] = 23,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8874), 1,
      sym_identifier,
    ACTIONS(8876), 1,
      anon_sym_LBRACK,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8984), 1,
      sym_tag,
    STATE(3094), 1,
      sym_named_type,
    STATE(3097), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [191021] = 23,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8874), 1,
      sym_identifier,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8904), 1,
      anon_sym_LBRACK,
    ACTIONS(8906), 1,
      sym_tag,
    STATE(2952), 1,
      sym_type,
    STATE(2953), 1,
      sym_named_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [191111] = 23,
    ACTIONS(1283), 1,
      anon_sym_distinct,
    ACTIONS(2584), 1,
      anon_sym_proc,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2597), 1,
      anon_sym_DOLLAR,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2611), 1,
      anon_sym_map,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2615), 1,
      anon_sym_matrix,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8914), 1,
      sym_identifier,
    ACTIONS(8916), 1,
      anon_sym_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_CARET,
    ACTIONS(8920), 1,
      sym_tag,
    STATE(3792), 1,
      sym_named_type,
    STATE(3800), 1,
      sym_type,
    STATE(4281), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [191201] = 23,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    ACTIONS(8986), 1,
      anon_sym_LBRACE,
    STATE(3690), 1,
      sym_procedure,
    STATE(8095), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [191291] = 23,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8874), 1,
      sym_identifier,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8904), 1,
      anon_sym_LBRACK,
    ACTIONS(8906), 1,
      sym_tag,
    STATE(3094), 1,
      sym_named_type,
    STATE(3097), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [191381] = 23,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8926), 1,
      sym_identifier,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8932), 1,
      anon_sym_LBRACK,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(8988), 1,
      sym_tag,
    STATE(629), 1,
      sym_type,
    STATE(635), 1,
      sym_named_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [191471] = 23,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8850), 1,
      anon_sym_LBRACK,
    ACTIONS(8990), 1,
      sym_tag,
    STATE(2954), 1,
      sym_type,
    STATE(2955), 1,
      sym_named_type,
    STATE(2978), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [191561] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8992), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [191651] = 23,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8922), 1,
      sym_identifier,
    ACTIONS(8940), 1,
      anon_sym_LBRACK,
    ACTIONS(8942), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(6572), 1,
      sym_type,
    STATE(6613), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [191741] = 25,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8994), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [191835] = 6,
    ACTIONS(8431), 1,
      anon_sym_LBRACE,
    ACTIONS(8996), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [191891] = 23,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8926), 1,
      sym_identifier,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(8998), 1,
      anon_sym_LBRACK,
    ACTIONS(9000), 1,
      sym_tag,
    STATE(629), 1,
      sym_type,
    STATE(635), 1,
      sym_named_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [191981] = 23,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8838), 1,
      sym_identifier,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8886), 1,
      anon_sym_LBRACK,
    ACTIONS(8888), 1,
      sym_tag,
    STATE(1406), 1,
      sym_type,
    STATE(1407), 1,
      sym_named_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [192071] = 23,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8796), 1,
      sym_identifier,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(9002), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6517), 1,
      sym_named_type,
    STATE(6518), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [192161] = 23,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8850), 1,
      anon_sym_LBRACK,
    ACTIONS(9004), 1,
      sym_tag,
    STATE(2956), 1,
      sym_type,
    STATE(2957), 1,
      sym_named_type,
    STATE(2978), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [192251] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9006), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [192341] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9008), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [192431] = 23,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8926), 1,
      sym_identifier,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(8998), 1,
      anon_sym_LBRACK,
    ACTIONS(9000), 1,
      sym_tag,
    STATE(596), 1,
      sym_named_type,
    STATE(597), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [192521] = 23,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8796), 1,
      sym_identifier,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8800), 1,
      anon_sym_LBRACK,
    ACTIONS(8802), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6517), 1,
      sym_named_type,
    STATE(6518), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [192611] = 23,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8922), 1,
      sym_identifier,
    ACTIONS(9010), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(6572), 1,
      sym_type,
    STATE(6613), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [192701] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8954), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [192791] = 23,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8826), 1,
      anon_sym_LBRACK,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8830), 1,
      sym_tag,
    STATE(2956), 1,
      sym_type,
    STATE(2957), 1,
      sym_named_type,
    STATE(2978), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [192881] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9012), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [192971] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9014), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [193061] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9016), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [193151] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9018), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [193241] = 23,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8838), 1,
      sym_identifier,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8844), 1,
      anon_sym_LBRACK,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(9020), 1,
      sym_tag,
    STATE(2308), 1,
      sym_named_type,
    STATE(2318), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [193331] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9022), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [193421] = 23,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8826), 1,
      anon_sym_LBRACK,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8830), 1,
      sym_tag,
    STATE(2959), 1,
      sym_type,
    STATE(2960), 1,
      sym_named_type,
    STATE(2978), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [193511] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9024), 1,
      sym_identifier,
    ACTIONS(9026), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6691), 1,
      sym_type,
    STATE(6701), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [193601] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9028), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [193691] = 26,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_PLUS,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_TILDE,
    ACTIONS(7906), 1,
      anon_sym_AMP,
    ACTIONS(7908), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7934), 1,
      anon_sym_or_break,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(9032), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7912), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7914), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7918), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(7920), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7924), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7926), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7928), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(9030), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [193787] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9034), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [193877] = 23,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    ACTIONS(9036), 1,
      anon_sym_LBRACE,
    STATE(3690), 1,
      sym_procedure,
    STATE(8003), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [193967] = 23,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8838), 1,
      sym_identifier,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8844), 1,
      anon_sym_LBRACK,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(9038), 1,
      sym_tag,
    STATE(1404), 1,
      sym_named_type,
    STATE(1405), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [194057] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8788), 1,
      sym_identifier,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8898), 1,
      anon_sym_LBRACK,
    ACTIONS(8900), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6708), 1,
      sym_named_type,
    STATE(6712), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [194147] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9040), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [194237] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8788), 1,
      sym_identifier,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8898), 1,
      anon_sym_LBRACK,
    ACTIONS(8900), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6698), 1,
      sym_named_type,
    STATE(6703), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [194327] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9024), 1,
      sym_identifier,
    ACTIONS(9042), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6692), 1,
      sym_type,
    STATE(6695), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [194417] = 23,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(8816), 1,
      sym_identifier,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(9044), 1,
      sym_tag,
    STATE(4281), 1,
      sym_procedure,
    STATE(6722), 1,
      sym_named_type,
    STATE(6729), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [194507] = 23,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8804), 1,
      sym_identifier,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8890), 1,
      anon_sym_LBRACK,
    ACTIONS(8892), 1,
      sym_tag,
    STATE(3399), 1,
      sym_type,
    STATE(3400), 1,
      sym_named_type,
    STATE(3475), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [194597] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9024), 1,
      sym_identifier,
    ACTIONS(9046), 1,
      anon_sym_LBRACK,
    ACTIONS(9048), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6692), 1,
      sym_type,
    STATE(6695), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [194687] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9024), 1,
      sym_identifier,
    ACTIONS(9046), 1,
      anon_sym_LBRACK,
    ACTIONS(9048), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6716), 1,
      sym_named_type,
    STATE(6717), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [194777] = 23,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8804), 1,
      sym_identifier,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8890), 1,
      anon_sym_LBRACK,
    ACTIONS(8892), 1,
      sym_tag,
    STATE(3430), 1,
      sym_named_type,
    STATE(3431), 1,
      sym_type,
    STATE(3475), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [194867] = 23,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    ACTIONS(9050), 1,
      anon_sym_LBRACE,
    STATE(3690), 1,
      sym_procedure,
    STATE(8356), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [194957] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8788), 1,
      sym_identifier,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9052), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6698), 1,
      sym_named_type,
    STATE(6703), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [195047] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9054), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [195137] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9056), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [195227] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8788), 1,
      sym_identifier,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9058), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6559), 1,
      sym_named_type,
    STATE(6562), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [195317] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9060), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [195407] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8860), 1,
      sym_identifier,
    ACTIONS(9062), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6686), 1,
      sym_type,
    STATE(6697), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [195497] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9064), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7266), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [195587] = 23,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8850), 1,
      anon_sym_LBRACK,
    ACTIONS(9066), 1,
      sym_tag,
    STATE(2915), 1,
      sym_named_type,
    STATE(2916), 1,
      sym_type,
    STATE(2978), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [195677] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8860), 1,
      sym_identifier,
    ACTIONS(9068), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6696), 1,
      sym_type,
    STATE(6706), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [195767] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8860), 1,
      sym_identifier,
    ACTIONS(8868), 1,
      anon_sym_LBRACK,
    ACTIONS(8870), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6696), 1,
      sym_type,
    STATE(6706), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [195857] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(8968), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7213), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [195947] = 23,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8922), 1,
      sym_identifier,
    ACTIONS(8940), 1,
      anon_sym_LBRACK,
    ACTIONS(8942), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(6567), 1,
      sym_type,
    STATE(6611), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [196037] = 23,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8804), 1,
      sym_identifier,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8808), 1,
      anon_sym_LBRACK,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(9070), 1,
      sym_tag,
    STATE(3430), 1,
      sym_named_type,
    STATE(3431), 1,
      sym_type,
    STATE(3475), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [196127] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8860), 1,
      sym_identifier,
    ACTIONS(8868), 1,
      anon_sym_LBRACK,
    ACTIONS(8870), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6700), 1,
      sym_named_type,
    STATE(6705), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [196217] = 23,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8926), 1,
      sym_identifier,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(8998), 1,
      anon_sym_LBRACK,
    ACTIONS(9000), 1,
      sym_tag,
    STATE(604), 1,
      sym_named_type,
    STATE(606), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [196307] = 23,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8926), 1,
      sym_identifier,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8932), 1,
      anon_sym_LBRACK,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(9072), 1,
      sym_tag,
    STATE(604), 1,
      sym_named_type,
    STATE(606), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [196397] = 23,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8796), 1,
      sym_identifier,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8800), 1,
      anon_sym_LBRACK,
    ACTIONS(8802), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6599), 1,
      sym_type,
    STATE(6601), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [196487] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9074), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [196577] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9024), 1,
      sym_identifier,
    ACTIONS(9076), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6720), 1,
      sym_named_type,
    STATE(6731), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [196667] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9078), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [196757] = 23,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8804), 1,
      sym_identifier,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8808), 1,
      anon_sym_LBRACK,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(9080), 1,
      sym_tag,
    STATE(3432), 1,
      sym_named_type,
    STATE(3433), 1,
      sym_type,
    STATE(3475), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [196847] = 23,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8796), 1,
      sym_identifier,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(9082), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6599), 1,
      sym_type,
    STATE(6601), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [196937] = 31,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6839), 1,
      anon_sym_EQ,
    ACTIONS(6843), 1,
      anon_sym_COLON_EQ,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    ACTIONS(9086), 1,
      anon_sym_do,
    STATE(7208), 1,
      sym_block,
    STATE(7519), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [197043] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8788), 1,
      sym_identifier,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9088), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6681), 1,
      sym_named_type,
    STATE(6694), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [197133] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9024), 1,
      sym_identifier,
    ACTIONS(9090), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6723), 1,
      sym_named_type,
    STATE(6732), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [197223] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9024), 1,
      sym_identifier,
    ACTIONS(9046), 1,
      anon_sym_LBRACK,
    ACTIONS(9048), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6723), 1,
      sym_named_type,
    STATE(6732), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [197313] = 6,
    ACTIONS(8431), 1,
      anon_sym_LBRACE,
    ACTIONS(9092), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [197369] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9094), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [197459] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9024), 1,
      sym_identifier,
    ACTIONS(9046), 1,
      anon_sym_LBRACK,
    ACTIONS(9048), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6725), 1,
      sym_named_type,
    STATE(6733), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [197549] = 23,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8926), 1,
      sym_identifier,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(8998), 1,
      anon_sym_LBRACK,
    ACTIONS(9000), 1,
      sym_tag,
    STATE(648), 1,
      sym_type,
    STATE(652), 1,
      sym_named_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [197639] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9096), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [197729] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9098), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [197819] = 23,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8850), 1,
      anon_sym_LBRACK,
    ACTIONS(9100), 1,
      sym_tag,
    STATE(2909), 1,
      sym_named_type,
    STATE(2910), 1,
      sym_type,
    STATE(2978), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [197909] = 23,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8926), 1,
      sym_identifier,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(8998), 1,
      anon_sym_LBRACK,
    ACTIONS(9000), 1,
      sym_tag,
    STATE(623), 1,
      sym_named_type,
    STATE(634), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [197999] = 23,
    ACTIONS(1247), 1,
      anon_sym_distinct,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(2770), 1,
      anon_sym_proc,
    ACTIONS(2772), 1,
      anon_sym_DOLLAR,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2782), 1,
      anon_sym_map,
    ACTIONS(2784), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9102), 1,
      sym_identifier,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9106), 1,
      anon_sym_CARET,
    ACTIONS(9108), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3973), 1,
      sym_named_type,
    STATE(3974), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [198089] = 23,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8838), 1,
      sym_identifier,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8886), 1,
      anon_sym_LBRACK,
    ACTIONS(8888), 1,
      sym_tag,
    STATE(2281), 1,
      sym_named_type,
    STATE(2282), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [198179] = 23,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8874), 1,
      sym_identifier,
    ACTIONS(8876), 1,
      anon_sym_LBRACK,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(9110), 1,
      sym_tag,
    STATE(3092), 1,
      sym_named_type,
    STATE(3107), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [198269] = 23,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8926), 1,
      sym_identifier,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8932), 1,
      anon_sym_LBRACK,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(9112), 1,
      sym_tag,
    STATE(623), 1,
      sym_named_type,
    STATE(634), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [198359] = 23,
    ACTIONS(1247), 1,
      anon_sym_distinct,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(2770), 1,
      anon_sym_proc,
    ACTIONS(2772), 1,
      anon_sym_DOLLAR,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2782), 1,
      anon_sym_map,
    ACTIONS(2784), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9102), 1,
      sym_identifier,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9106), 1,
      anon_sym_CARET,
    ACTIONS(9114), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3966), 1,
      sym_named_type,
    STATE(3972), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [198449] = 23,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8926), 1,
      sym_identifier,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8932), 1,
      anon_sym_LBRACK,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(9116), 1,
      sym_tag,
    STATE(620), 1,
      sym_named_type,
    STATE(622), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [198539] = 23,
    ACTIONS(1247), 1,
      anon_sym_distinct,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(2770), 1,
      anon_sym_proc,
    ACTIONS(2772), 1,
      anon_sym_DOLLAR,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2782), 1,
      anon_sym_map,
    ACTIONS(2784), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9102), 1,
      sym_identifier,
    ACTIONS(9106), 1,
      anon_sym_CARET,
    ACTIONS(9118), 1,
      anon_sym_LBRACK,
    ACTIONS(9120), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3966), 1,
      sym_named_type,
    STATE(3972), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [198629] = 23,
    ACTIONS(1247), 1,
      anon_sym_distinct,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(2770), 1,
      anon_sym_proc,
    ACTIONS(2772), 1,
      anon_sym_DOLLAR,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2782), 1,
      anon_sym_map,
    ACTIONS(2784), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9102), 1,
      sym_identifier,
    ACTIONS(9106), 1,
      anon_sym_CARET,
    ACTIONS(9118), 1,
      anon_sym_LBRACK,
    ACTIONS(9120), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3958), 1,
      sym_named_type,
    STATE(3959), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [198719] = 23,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8838), 1,
      sym_identifier,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8886), 1,
      anon_sym_LBRACK,
    ACTIONS(8888), 1,
      sym_tag,
    STATE(1427), 1,
      sym_named_type,
    STATE(1428), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [198809] = 23,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8926), 1,
      sym_identifier,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(8998), 1,
      anon_sym_LBRACK,
    ACTIONS(9000), 1,
      sym_tag,
    STATE(616), 1,
      sym_named_type,
    STATE(619), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [198899] = 23,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(8816), 1,
      sym_identifier,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8820), 1,
      anon_sym_LBRACK,
    ACTIONS(8822), 1,
      sym_tag,
    STATE(4281), 1,
      sym_procedure,
    STATE(6646), 1,
      sym_named_type,
    STATE(6676), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [198989] = 23,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(8816), 1,
      sym_identifier,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(9122), 1,
      sym_tag,
    STATE(4281), 1,
      sym_procedure,
    STATE(6646), 1,
      sym_named_type,
    STATE(6676), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [199079] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9124), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [199169] = 23,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8922), 1,
      sym_identifier,
    ACTIONS(8940), 1,
      anon_sym_LBRACK,
    ACTIONS(8942), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(6512), 1,
      sym_type,
    STATE(6553), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [199259] = 23,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8796), 1,
      sym_identifier,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(9126), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6509), 1,
      sym_type,
    STATE(6510), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [199349] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8788), 1,
      sym_identifier,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9128), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6570), 1,
      sym_type,
    STATE(6578), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [199439] = 23,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8874), 1,
      sym_identifier,
    ACTIONS(8876), 1,
      anon_sym_LBRACK,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(9130), 1,
      sym_tag,
    STATE(2945), 1,
      sym_type,
    STATE(2947), 1,
      sym_named_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [199529] = 23,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8874), 1,
      sym_identifier,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8904), 1,
      anon_sym_LBRACK,
    ACTIONS(8906), 1,
      sym_tag,
    STATE(2945), 1,
      sym_type,
    STATE(2947), 1,
      sym_named_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [199619] = 23,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(8816), 1,
      sym_identifier,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(9132), 1,
      sym_tag,
    STATE(4281), 1,
      sym_procedure,
    STATE(6668), 1,
      sym_type,
    STATE(6673), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [199709] = 23,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8874), 1,
      sym_identifier,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8904), 1,
      anon_sym_LBRACK,
    ACTIONS(8906), 1,
      sym_tag,
    STATE(3073), 1,
      sym_named_type,
    STATE(3074), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [199799] = 23,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8824), 1,
      sym_identifier,
    ACTIONS(8826), 1,
      anon_sym_LBRACK,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8830), 1,
      sym_tag,
    STATE(2912), 1,
      sym_type,
    STATE(2913), 1,
      sym_named_type,
    STATE(2978), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [199889] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9134), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [199979] = 23,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8788), 1,
      sym_identifier,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8898), 1,
      anon_sym_LBRACK,
    ACTIONS(8900), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6570), 1,
      sym_type,
    STATE(6578), 1,
      sym_named_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [200069] = 23,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8874), 1,
      sym_identifier,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8904), 1,
      anon_sym_LBRACK,
    ACTIONS(8906), 1,
      sym_tag,
    STATE(3092), 1,
      sym_named_type,
    STATE(3107), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [200159] = 23,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8838), 1,
      sym_identifier,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8844), 1,
      anon_sym_LBRACK,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(9136), 1,
      sym_tag,
    STATE(1494), 1,
      sym_named_type,
    STATE(1495), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [200249] = 23,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9138), 1,
      anon_sym_RBRACE,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [200339] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8366), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [200426] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(9140), 1,
      sym_tag,
    STATE(3766), 1,
      sym_procedure,
    STATE(6739), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [200513] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7985), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [200600] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7288), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [200687] = 22,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1181), 1,
      sym_identifier,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8886), 1,
      anon_sym_LBRACK,
    ACTIONS(8888), 1,
      sym_tag,
    STATE(2449), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [200774] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8092), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [200861] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8295), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [200948] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8064), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [201035] = 22,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8942), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(6593), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [201122] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    ACTIONS(9142), 1,
      anon_sym_LBRACK,
    STATE(3887), 1,
      sym_procedure,
    STATE(7076), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [201209] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7816), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [201296] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7245), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [201383] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(3907), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [201470] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8402), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [201557] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7797), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [201644] = 22,
    ACTIONS(2443), 1,
      sym_identifier,
    ACTIONS(2445), 1,
      anon_sym_proc,
    ACTIONS(2447), 1,
      anon_sym_struct,
    ACTIONS(2449), 1,
      anon_sym_enum,
    ACTIONS(2451), 1,
      anon_sym_union,
    ACTIONS(2453), 1,
      anon_sym_bit_field,
    ACTIONS(2458), 1,
      anon_sym_DOLLAR,
    ACTIONS(2465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2470), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2472), 1,
      anon_sym_map,
    ACTIONS(2474), 1,
      anon_sym_bit_set,
    ACTIONS(2476), 1,
      anon_sym_matrix,
    ACTIONS(2478), 1,
      anon_sym_distinct,
    ACTIONS(2480), 1,
      sym_tag,
    ACTIONS(9144), 1,
      anon_sym_LPAREN,
    ACTIONS(9146), 1,
      anon_sym_BANG,
    ACTIONS(9148), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_CARET,
    STATE(4234), 1,
      sym_type,
    STATE(4322), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4276), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [201731] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8104), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [201818] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7651), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [201905] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9154), 1,
      sym_tag,
    STATE(6832), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [201992] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7621), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [202079] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8400), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [202166] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7292), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [202253] = 22,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8830), 1,
      sym_tag,
    ACTIONS(8850), 1,
      anon_sym_LBRACK,
    STATE(2978), 1,
      sym_procedure,
    STATE(3036), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [202340] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2143), 1,
      anon_sym_proc,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2156), 1,
      anon_sym_DOLLAR,
    ACTIONS(2163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2170), 1,
      anon_sym_map,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(2174), 1,
      anon_sym_matrix,
    ACTIONS(2176), 1,
      anon_sym_distinct,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    ACTIONS(9156), 1,
      anon_sym_LBRACK,
    ACTIONS(9158), 1,
      anon_sym_CARET,
    ACTIONS(9160), 1,
      sym_tag,
    STATE(3765), 1,
      sym_procedure,
    STATE(3818), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [202427] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7813), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [202514] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7241), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [202601] = 22,
    ACTIONS(113), 1,
      anon_sym_distinct,
    ACTIONS(1059), 1,
      sym_identifier,
    ACTIONS(1061), 1,
      anon_sym_proc,
    ACTIONS(1063), 1,
      anon_sym_struct,
    ACTIONS(1065), 1,
      anon_sym_enum,
    ACTIONS(1067), 1,
      anon_sym_union,
    ACTIONS(1069), 1,
      anon_sym_bit_field,
    ACTIONS(1075), 1,
      anon_sym_DOLLAR,
    ACTIONS(1083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1089), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1091), 1,
      anon_sym_map,
    ACTIONS(1093), 1,
      anon_sym_bit_set,
    ACTIONS(1095), 1,
      anon_sym_matrix,
    ACTIONS(9162), 1,
      anon_sym_LPAREN,
    ACTIONS(9164), 1,
      anon_sym_BANG,
    ACTIONS(9166), 1,
      anon_sym_LBRACK,
    ACTIONS(9168), 1,
      anon_sym_CARET,
    ACTIONS(9170), 1,
      sym_tag,
    STATE(2237), 1,
      sym_type,
    STATE(2239), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [202688] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(9172), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7203), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [202775] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7757), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [202862] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(8042), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [202949] = 22,
    ACTIONS(113), 1,
      anon_sym_distinct,
    ACTIONS(1059), 1,
      sym_identifier,
    ACTIONS(1061), 1,
      anon_sym_proc,
    ACTIONS(1063), 1,
      anon_sym_struct,
    ACTIONS(1065), 1,
      anon_sym_enum,
    ACTIONS(1067), 1,
      anon_sym_union,
    ACTIONS(1069), 1,
      anon_sym_bit_field,
    ACTIONS(1075), 1,
      anon_sym_DOLLAR,
    ACTIONS(1083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1089), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1091), 1,
      anon_sym_map,
    ACTIONS(1093), 1,
      anon_sym_bit_set,
    ACTIONS(1095), 1,
      anon_sym_matrix,
    ACTIONS(1097), 1,
      sym_tag,
    ACTIONS(9162), 1,
      anon_sym_LPAREN,
    ACTIONS(9164), 1,
      anon_sym_BANG,
    ACTIONS(9166), 1,
      anon_sym_LBRACK,
    ACTIONS(9168), 1,
      anon_sym_CARET,
    STATE(2239), 1,
      sym_procedure,
    STATE(2507), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [203036] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8286), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [203123] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    STATE(7043), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [203210] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8246), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [203297] = 22,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8904), 1,
      anon_sym_LBRACK,
    ACTIONS(8906), 1,
      sym_tag,
    STATE(3313), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [203384] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7336), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [203471] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7535), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [203558] = 22,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8876), 1,
      anon_sym_LBRACK,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8906), 1,
      sym_tag,
    STATE(3297), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [203645] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7696), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [203732] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8351), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [203819] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8346), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [203906] = 22,
    ACTIONS(267), 1,
      anon_sym_distinct,
    ACTIONS(1375), 1,
      sym_identifier,
    ACTIONS(1377), 1,
      anon_sym_proc,
    ACTIONS(1379), 1,
      anon_sym_struct,
    ACTIONS(1381), 1,
      anon_sym_enum,
    ACTIONS(1383), 1,
      anon_sym_union,
    ACTIONS(1385), 1,
      anon_sym_bit_field,
    ACTIONS(1391), 1,
      anon_sym_DOLLAR,
    ACTIONS(1399), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1407), 1,
      anon_sym_map,
    ACTIONS(1409), 1,
      anon_sym_bit_set,
    ACTIONS(1411), 1,
      anon_sym_matrix,
    ACTIONS(1413), 1,
      sym_tag,
    ACTIONS(9174), 1,
      anon_sym_LPAREN,
    ACTIONS(9176), 1,
      anon_sym_BANG,
    ACTIONS(9178), 1,
      anon_sym_LBRACK,
    ACTIONS(9180), 1,
      anon_sym_CARET,
    STATE(2566), 1,
      sym_procedure,
    STATE(2645), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2607), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [203993] = 22,
    ACTIONS(47), 1,
      anon_sym_distinct,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2294), 1,
      anon_sym_proc,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2307), 1,
      anon_sym_DOLLAR,
    ACTIONS(2314), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2321), 1,
      anon_sym_map,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(2325), 1,
      anon_sym_matrix,
    ACTIONS(2327), 1,
      sym_tag,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(9182), 1,
      anon_sym_LBRACK,
    ACTIONS(9184), 1,
      anon_sym_CARET,
    STATE(3766), 1,
      sym_procedure,
    STATE(3933), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [204080] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8335), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [204167] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7769), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [204254] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7316), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [204341] = 22,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8942), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(6592), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [204428] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9186), 1,
      anon_sym_LBRACK,
    STATE(6843), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [204515] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7362), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [204602] = 22,
    ACTIONS(113), 1,
      anon_sym_distinct,
    ACTIONS(1059), 1,
      sym_identifier,
    ACTIONS(1061), 1,
      anon_sym_proc,
    ACTIONS(1063), 1,
      anon_sym_struct,
    ACTIONS(1065), 1,
      anon_sym_enum,
    ACTIONS(1067), 1,
      anon_sym_union,
    ACTIONS(1069), 1,
      anon_sym_bit_field,
    ACTIONS(1075), 1,
      anon_sym_DOLLAR,
    ACTIONS(1083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1089), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1091), 1,
      anon_sym_map,
    ACTIONS(1093), 1,
      anon_sym_bit_set,
    ACTIONS(1095), 1,
      anon_sym_matrix,
    ACTIONS(1097), 1,
      sym_tag,
    ACTIONS(9162), 1,
      anon_sym_LPAREN,
    ACTIONS(9164), 1,
      anon_sym_BANG,
    ACTIONS(9166), 1,
      anon_sym_LBRACK,
    ACTIONS(9168), 1,
      anon_sym_CARET,
    STATE(2214), 1,
      sym_type,
    STATE(2239), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [204689] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8154), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [204776] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8115), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [204863] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9188), 1,
      sym_tag,
    STATE(6843), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [204950] = 22,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(769), 1,
      sym_identifier,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8932), 1,
      anon_sym_LBRACK,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      sym_tag,
    STATE(727), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [205037] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8300), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [205124] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8057), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [205211] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7666), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [205298] = 22,
    ACTIONS(113), 1,
      anon_sym_distinct,
    ACTIONS(1059), 1,
      sym_identifier,
    ACTIONS(1061), 1,
      anon_sym_proc,
    ACTIONS(1063), 1,
      anon_sym_struct,
    ACTIONS(1065), 1,
      anon_sym_enum,
    ACTIONS(1067), 1,
      anon_sym_union,
    ACTIONS(1069), 1,
      anon_sym_bit_field,
    ACTIONS(1075), 1,
      anon_sym_DOLLAR,
    ACTIONS(1083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1089), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1091), 1,
      anon_sym_map,
    ACTIONS(1093), 1,
      anon_sym_bit_set,
    ACTIONS(1095), 1,
      anon_sym_matrix,
    ACTIONS(1097), 1,
      sym_tag,
    ACTIONS(9162), 1,
      anon_sym_LPAREN,
    ACTIONS(9164), 1,
      anon_sym_BANG,
    ACTIONS(9168), 1,
      anon_sym_CARET,
    ACTIONS(9190), 1,
      anon_sym_LBRACK,
    STATE(2239), 1,
      sym_procedure,
    STATE(2244), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [205385] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8036), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [205472] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7332), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [205559] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7807), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [205646] = 22,
    ACTIONS(113), 1,
      anon_sym_distinct,
    ACTIONS(1059), 1,
      sym_identifier,
    ACTIONS(1061), 1,
      anon_sym_proc,
    ACTIONS(1063), 1,
      anon_sym_struct,
    ACTIONS(1065), 1,
      anon_sym_enum,
    ACTIONS(1067), 1,
      anon_sym_union,
    ACTIONS(1069), 1,
      anon_sym_bit_field,
    ACTIONS(1075), 1,
      anon_sym_DOLLAR,
    ACTIONS(1083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1089), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1091), 1,
      anon_sym_map,
    ACTIONS(1093), 1,
      anon_sym_bit_set,
    ACTIONS(1095), 1,
      anon_sym_matrix,
    ACTIONS(1097), 1,
      sym_tag,
    ACTIONS(9162), 1,
      anon_sym_LPAREN,
    ACTIONS(9164), 1,
      anon_sym_BANG,
    ACTIONS(9166), 1,
      anon_sym_LBRACK,
    ACTIONS(9168), 1,
      anon_sym_CARET,
    STATE(2239), 1,
      sym_procedure,
    STATE(2448), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [205733] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9186), 1,
      anon_sym_LBRACK,
    STATE(6818), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [205820] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8230), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [205907] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8227), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [205994] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8094), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [206081] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(8244), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [206168] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7972), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [206255] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7282), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [206342] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7954), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [206429] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(8004), 1,
      sym_tag,
    STATE(3766), 1,
      sym_procedure,
    STATE(6919), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [206516] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7912), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [206603] = 7,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5100), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5098), 26,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [206660] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8264), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [206747] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7862), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [206834] = 7,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4994), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(4992), 26,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [206891] = 5,
    ACTIONS(9200), 1,
      anon_sym_QMARK,
    ACTIONS(9198), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4922), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4920), 27,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_do,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [206944] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7839), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [207031] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8378), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [207118] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7789), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [207205] = 22,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8942), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3601), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [207292] = 22,
    ACTIONS(113), 1,
      anon_sym_distinct,
    ACTIONS(1059), 1,
      sym_identifier,
    ACTIONS(1061), 1,
      anon_sym_proc,
    ACTIONS(1063), 1,
      anon_sym_struct,
    ACTIONS(1065), 1,
      anon_sym_enum,
    ACTIONS(1067), 1,
      anon_sym_union,
    ACTIONS(1069), 1,
      anon_sym_bit_field,
    ACTIONS(1075), 1,
      anon_sym_DOLLAR,
    ACTIONS(1083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1089), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1091), 1,
      anon_sym_map,
    ACTIONS(1093), 1,
      anon_sym_bit_set,
    ACTIONS(1095), 1,
      anon_sym_matrix,
    ACTIONS(1097), 1,
      sym_tag,
    ACTIONS(9162), 1,
      anon_sym_LPAREN,
    ACTIONS(9164), 1,
      anon_sym_BANG,
    ACTIONS(9166), 1,
      anon_sym_LBRACK,
    ACTIONS(9168), 1,
      anon_sym_CARET,
    STATE(2239), 1,
      sym_procedure,
    STATE(2307), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [207379] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    STATE(3766), 1,
      sym_procedure,
    STATE(6779), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [207466] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8384), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [207553] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7345), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [207640] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7385), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [207727] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8325), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [207814] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7693), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [207901] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8270), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [207988] = 22,
    ACTIONS(325), 1,
      anon_sym_distinct,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1975), 1,
      anon_sym_proc,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(1989), 1,
      anon_sym_DOLLAR,
    ACTIONS(1997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2005), 1,
      anon_sym_map,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2009), 1,
      anon_sym_matrix,
    ACTIONS(2011), 1,
      sym_tag,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    ACTIONS(9202), 1,
      anon_sym_LBRACK,
    ACTIONS(9204), 1,
      anon_sym_CARET,
    STATE(3638), 1,
      sym_type,
    STATE(3690), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [208075] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7740), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [208162] = 22,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8876), 1,
      anon_sym_LBRACK,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8906), 1,
      sym_tag,
    STATE(3224), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [208249] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(9206), 1,
      anon_sym_LBRACK,
    STATE(3766), 1,
      sym_procedure,
    STATE(6790), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [208336] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7614), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [208423] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9208), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7265), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [208510] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7681), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [208597] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8203), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [208684] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7597), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [208771] = 22,
    ACTIONS(113), 1,
      anon_sym_distinct,
    ACTIONS(1059), 1,
      sym_identifier,
    ACTIONS(1061), 1,
      anon_sym_proc,
    ACTIONS(1063), 1,
      anon_sym_struct,
    ACTIONS(1065), 1,
      anon_sym_enum,
    ACTIONS(1067), 1,
      anon_sym_union,
    ACTIONS(1069), 1,
      anon_sym_bit_field,
    ACTIONS(1075), 1,
      anon_sym_DOLLAR,
    ACTIONS(1083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1089), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1091), 1,
      anon_sym_map,
    ACTIONS(1093), 1,
      anon_sym_bit_set,
    ACTIONS(1095), 1,
      anon_sym_matrix,
    ACTIONS(1097), 1,
      sym_tag,
    ACTIONS(9162), 1,
      anon_sym_LPAREN,
    ACTIONS(9164), 1,
      anon_sym_BANG,
    ACTIONS(9166), 1,
      anon_sym_LBRACK,
    ACTIONS(9168), 1,
      anon_sym_CARET,
    STATE(2239), 1,
      sym_procedure,
    STATE(2418), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [208858] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7777), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [208945] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8024), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [209032] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7275), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [209119] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8102), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [209206] = 22,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(941), 1,
      anon_sym_proc,
    ACTIONS(943), 1,
      anon_sym_struct,
    ACTIONS(945), 1,
      anon_sym_enum,
    ACTIONS(947), 1,
      anon_sym_union,
    ACTIONS(949), 1,
      anon_sym_bit_field,
    ACTIONS(954), 1,
      anon_sym_DOLLAR,
    ACTIONS(961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(966), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(968), 1,
      anon_sym_map,
    ACTIONS(970), 1,
      anon_sym_bit_set,
    ACTIONS(972), 1,
      anon_sym_matrix,
    ACTIONS(974), 1,
      anon_sym_distinct,
    ACTIONS(976), 1,
      sym_tag,
    ACTIONS(9210), 1,
      anon_sym_LPAREN,
    ACTIONS(9212), 1,
      anon_sym_BANG,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9216), 1,
      anon_sym_CARET,
    STATE(2132), 1,
      sym_type,
    STATE(2134), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2167), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [209293] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7749), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [209380] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8900), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3129), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [209467] = 22,
    ACTIONS(2443), 1,
      sym_identifier,
    ACTIONS(2445), 1,
      anon_sym_proc,
    ACTIONS(2447), 1,
      anon_sym_struct,
    ACTIONS(2449), 1,
      anon_sym_enum,
    ACTIONS(2451), 1,
      anon_sym_union,
    ACTIONS(2453), 1,
      anon_sym_bit_field,
    ACTIONS(2458), 1,
      anon_sym_DOLLAR,
    ACTIONS(2465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2470), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2472), 1,
      anon_sym_map,
    ACTIONS(2474), 1,
      anon_sym_bit_set,
    ACTIONS(2476), 1,
      anon_sym_matrix,
    ACTIONS(2478), 1,
      anon_sym_distinct,
    ACTIONS(2480), 1,
      sym_tag,
    ACTIONS(9144), 1,
      anon_sym_LPAREN,
    ACTIONS(9146), 1,
      anon_sym_BANG,
    ACTIONS(9150), 1,
      anon_sym_CARET,
    ACTIONS(9218), 1,
      anon_sym_LBRACK,
    STATE(4201), 1,
      sym_type,
    STATE(4322), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4276), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [209554] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7876), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [209641] = 22,
    ACTIONS(359), 1,
      anon_sym_distinct,
    ACTIONS(1483), 1,
      sym_identifier,
    ACTIONS(1485), 1,
      anon_sym_proc,
    ACTIONS(1487), 1,
      anon_sym_struct,
    ACTIONS(1489), 1,
      anon_sym_enum,
    ACTIONS(1491), 1,
      anon_sym_union,
    ACTIONS(1493), 1,
      anon_sym_bit_field,
    ACTIONS(1498), 1,
      anon_sym_DOLLAR,
    ACTIONS(1505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1510), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1512), 1,
      anon_sym_map,
    ACTIONS(1514), 1,
      anon_sym_bit_set,
    ACTIONS(1516), 1,
      anon_sym_matrix,
    ACTIONS(1518), 1,
      sym_tag,
    ACTIONS(9220), 1,
      anon_sym_LPAREN,
    ACTIONS(9222), 1,
      anon_sym_BANG,
    ACTIONS(9224), 1,
      anon_sym_LBRACK,
    ACTIONS(9226), 1,
      anon_sym_CARET,
    STATE(2803), 1,
      sym_type,
    STATE(2852), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2807), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [209728] = 22,
    ACTIONS(751), 1,
      anon_sym_distinct,
    ACTIONS(2545), 1,
      sym_identifier,
    ACTIONS(2547), 1,
      anon_sym_proc,
    ACTIONS(2549), 1,
      anon_sym_struct,
    ACTIONS(2551), 1,
      anon_sym_enum,
    ACTIONS(2553), 1,
      anon_sym_union,
    ACTIONS(2555), 1,
      anon_sym_bit_field,
    ACTIONS(2560), 1,
      anon_sym_DOLLAR,
    ACTIONS(2567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2572), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2574), 1,
      anon_sym_map,
    ACTIONS(2576), 1,
      anon_sym_bit_set,
    ACTIONS(2578), 1,
      anon_sym_matrix,
    ACTIONS(2580), 1,
      sym_tag,
    ACTIONS(9228), 1,
      anon_sym_LPAREN,
    ACTIONS(9230), 1,
      anon_sym_BANG,
    ACTIONS(9232), 1,
      anon_sym_LBRACK,
    ACTIONS(9234), 1,
      anon_sym_CARET,
    STATE(4394), 1,
      sym_type,
    STATE(4444), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4570), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [209815] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7654), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [209902] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    STATE(3766), 1,
      sym_procedure,
    STATE(6835), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [209989] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7656), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [210076] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7661), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [210163] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8900), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6620), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [210250] = 22,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(941), 1,
      anon_sym_proc,
    ACTIONS(943), 1,
      anon_sym_struct,
    ACTIONS(945), 1,
      anon_sym_enum,
    ACTIONS(947), 1,
      anon_sym_union,
    ACTIONS(949), 1,
      anon_sym_bit_field,
    ACTIONS(954), 1,
      anon_sym_DOLLAR,
    ACTIONS(961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(966), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(968), 1,
      anon_sym_map,
    ACTIONS(970), 1,
      anon_sym_bit_set,
    ACTIONS(972), 1,
      anon_sym_matrix,
    ACTIONS(974), 1,
      anon_sym_distinct,
    ACTIONS(976), 1,
      sym_tag,
    ACTIONS(9210), 1,
      anon_sym_LPAREN,
    ACTIONS(9212), 1,
      anon_sym_BANG,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9216), 1,
      anon_sym_CARET,
    STATE(2134), 1,
      sym_procedure,
    STATE(2180), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2167), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [210337] = 22,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8822), 1,
      sym_tag,
    STATE(4186), 1,
      sym_type,
    STATE(4281), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [210424] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7767), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [210511] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7664), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [210598] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7331), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [210685] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8900), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6617), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [210772] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7975), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [210859] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8312), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [210946] = 22,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8876), 1,
      anon_sym_LBRACK,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(9236), 1,
      sym_tag,
    STATE(3282), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [211033] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7974), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [211120] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(9238), 1,
      sym_tag,
    STATE(3766), 1,
      sym_procedure,
    STATE(6781), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [211207] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8200), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [211294] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    STATE(7069), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [211381] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(9206), 1,
      anon_sym_LBRACK,
    STATE(3766), 1,
      sym_procedure,
    STATE(6781), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [211468] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9240), 1,
      sym_tag,
    STATE(6842), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [211555] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8176), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [211642] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    STATE(3766), 1,
      sym_procedure,
    STATE(6789), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [211729] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7771), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [211816] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9186), 1,
      anon_sym_LBRACK,
    STATE(6842), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [211903] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7955), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [211990] = 22,
    ACTIONS(267), 1,
      anon_sym_distinct,
    ACTIONS(1375), 1,
      sym_identifier,
    ACTIONS(1377), 1,
      anon_sym_proc,
    ACTIONS(1379), 1,
      anon_sym_struct,
    ACTIONS(1381), 1,
      anon_sym_enum,
    ACTIONS(1383), 1,
      anon_sym_union,
    ACTIONS(1385), 1,
      anon_sym_bit_field,
    ACTIONS(1391), 1,
      anon_sym_DOLLAR,
    ACTIONS(1399), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1407), 1,
      anon_sym_map,
    ACTIONS(1409), 1,
      anon_sym_bit_set,
    ACTIONS(1411), 1,
      anon_sym_matrix,
    ACTIONS(1413), 1,
      sym_tag,
    ACTIONS(9174), 1,
      anon_sym_LPAREN,
    ACTIONS(9176), 1,
      anon_sym_BANG,
    ACTIONS(9178), 1,
      anon_sym_LBRACK,
    ACTIONS(9180), 1,
      anon_sym_CARET,
    STATE(2561), 1,
      sym_type,
    STATE(2566), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2607), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [212077] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7952), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [212164] = 22,
    ACTIONS(359), 1,
      anon_sym_distinct,
    ACTIONS(1483), 1,
      sym_identifier,
    ACTIONS(1485), 1,
      anon_sym_proc,
    ACTIONS(1487), 1,
      anon_sym_struct,
    ACTIONS(1489), 1,
      anon_sym_enum,
    ACTIONS(1491), 1,
      anon_sym_union,
    ACTIONS(1493), 1,
      anon_sym_bit_field,
    ACTIONS(1498), 1,
      anon_sym_DOLLAR,
    ACTIONS(1505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1510), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1512), 1,
      anon_sym_map,
    ACTIONS(1514), 1,
      anon_sym_bit_set,
    ACTIONS(1516), 1,
      anon_sym_matrix,
    ACTIONS(1518), 1,
      sym_tag,
    ACTIONS(9220), 1,
      anon_sym_LPAREN,
    ACTIONS(9222), 1,
      anon_sym_BANG,
    ACTIONS(9226), 1,
      anon_sym_CARET,
    ACTIONS(9242), 1,
      anon_sym_LBRACK,
    STATE(2847), 1,
      sym_type,
    STATE(2852), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2807), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [212251] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7844), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [212338] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7238), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [212425] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7950), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [212512] = 22,
    ACTIONS(325), 1,
      anon_sym_distinct,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1975), 1,
      anon_sym_proc,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(1989), 1,
      anon_sym_DOLLAR,
    ACTIONS(1997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2005), 1,
      anon_sym_map,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2009), 1,
      anon_sym_matrix,
    ACTIONS(2011), 1,
      sym_tag,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    ACTIONS(9202), 1,
      anon_sym_LBRACK,
    ACTIONS(9204), 1,
      anon_sym_CARET,
    STATE(3648), 1,
      sym_type,
    STATE(3690), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [212599] = 25,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9274), 1,
      anon_sym_or_break,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9246), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(9256), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5420), 6,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_QMARK,
  [212692] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8247), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [212779] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    STATE(3765), 1,
      sym_procedure,
    STATE(6774), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [212866] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7896), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [212953] = 22,
    ACTIONS(267), 1,
      anon_sym_distinct,
    ACTIONS(1375), 1,
      sym_identifier,
    ACTIONS(1377), 1,
      anon_sym_proc,
    ACTIONS(1379), 1,
      anon_sym_struct,
    ACTIONS(1381), 1,
      anon_sym_enum,
    ACTIONS(1383), 1,
      anon_sym_union,
    ACTIONS(1385), 1,
      anon_sym_bit_field,
    ACTIONS(1391), 1,
      anon_sym_DOLLAR,
    ACTIONS(1399), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1407), 1,
      anon_sym_map,
    ACTIONS(1409), 1,
      anon_sym_bit_set,
    ACTIONS(1411), 1,
      anon_sym_matrix,
    ACTIONS(1413), 1,
      sym_tag,
    ACTIONS(9174), 1,
      anon_sym_LPAREN,
    ACTIONS(9176), 1,
      anon_sym_BANG,
    ACTIONS(9178), 1,
      anon_sym_LBRACK,
    ACTIONS(9180), 1,
      anon_sym_CARET,
    STATE(2566), 1,
      sym_procedure,
    STATE(2621), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2607), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [213040] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7923), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [213127] = 22,
    ACTIONS(325), 1,
      anon_sym_distinct,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1975), 1,
      anon_sym_proc,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(1989), 1,
      anon_sym_DOLLAR,
    ACTIONS(1997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2005), 1,
      anon_sym_map,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2009), 1,
      anon_sym_matrix,
    ACTIONS(2011), 1,
      sym_tag,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    ACTIONS(9202), 1,
      anon_sym_LBRACK,
    ACTIONS(9204), 1,
      anon_sym_CARET,
    STATE(3690), 1,
      sym_procedure,
    STATE(4701), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [213214] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2143), 1,
      anon_sym_proc,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2156), 1,
      anon_sym_DOLLAR,
    ACTIONS(2163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2170), 1,
      anon_sym_map,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(2174), 1,
      anon_sym_matrix,
    ACTIONS(2176), 1,
      anon_sym_distinct,
    ACTIONS(2178), 1,
      sym_tag,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    ACTIONS(9156), 1,
      anon_sym_LBRACK,
    ACTIONS(9158), 1,
      anon_sym_CARET,
    STATE(3765), 1,
      sym_procedure,
    STATE(3823), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [213301] = 22,
    ACTIONS(267), 1,
      anon_sym_distinct,
    ACTIONS(1375), 1,
      sym_identifier,
    ACTIONS(1377), 1,
      anon_sym_proc,
    ACTIONS(1379), 1,
      anon_sym_struct,
    ACTIONS(1381), 1,
      anon_sym_enum,
    ACTIONS(1383), 1,
      anon_sym_union,
    ACTIONS(1385), 1,
      anon_sym_bit_field,
    ACTIONS(1391), 1,
      anon_sym_DOLLAR,
    ACTIONS(1399), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1407), 1,
      anon_sym_map,
    ACTIONS(1409), 1,
      anon_sym_bit_set,
    ACTIONS(1411), 1,
      anon_sym_matrix,
    ACTIONS(1413), 1,
      sym_tag,
    ACTIONS(9174), 1,
      anon_sym_LPAREN,
    ACTIONS(9176), 1,
      anon_sym_BANG,
    ACTIONS(9180), 1,
      anon_sym_CARET,
    ACTIONS(9276), 1,
      anon_sym_LBRACK,
    STATE(2566), 1,
      sym_procedure,
    STATE(2577), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2607), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [213388] = 22,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8942), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(6602), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [213475] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7943), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [213562] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8898), 1,
      anon_sym_LBRACK,
    ACTIONS(8900), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6623), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [213649] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7829), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [213736] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7380), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [213823] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7698), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [213910] = 26,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(7642), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(7640), 4,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_SEMI,
  [214005] = 22,
    ACTIONS(1247), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(2770), 1,
      anon_sym_proc,
    ACTIONS(2772), 1,
      anon_sym_DOLLAR,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2782), 1,
      anon_sym_map,
    ACTIONS(2784), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9106), 1,
      anon_sym_CARET,
    ACTIONS(9278), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(4451), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [214092] = 22,
    ACTIONS(1247), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(2770), 1,
      anon_sym_proc,
    ACTIONS(2772), 1,
      anon_sym_DOLLAR,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2782), 1,
      anon_sym_map,
    ACTIONS(2784), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9106), 1,
      anon_sym_CARET,
    ACTIONS(9120), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(4403), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [214179] = 22,
    ACTIONS(1247), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(2770), 1,
      anon_sym_proc,
    ACTIONS(2772), 1,
      anon_sym_DOLLAR,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2782), 1,
      anon_sym_map,
    ACTIONS(2784), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9106), 1,
      anon_sym_CARET,
    ACTIONS(9120), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(4405), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [214266] = 22,
    ACTIONS(1247), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(2770), 1,
      anon_sym_proc,
    ACTIONS(2772), 1,
      anon_sym_DOLLAR,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2782), 1,
      anon_sym_map,
    ACTIONS(2784), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9106), 1,
      anon_sym_CARET,
    ACTIONS(9120), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3037), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [214353] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7668), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [214440] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7939), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [214527] = 22,
    ACTIONS(1247), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(2770), 1,
      anon_sym_proc,
    ACTIONS(2772), 1,
      anon_sym_DOLLAR,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2782), 1,
      anon_sym_map,
    ACTIONS(2784), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9106), 1,
      anon_sym_CARET,
    ACTIONS(9118), 1,
      anon_sym_LBRACK,
    ACTIONS(9120), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(4450), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [214614] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7315), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [214701] = 22,
    ACTIONS(1247), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(2770), 1,
      anon_sym_proc,
    ACTIONS(2772), 1,
      anon_sym_DOLLAR,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2782), 1,
      anon_sym_map,
    ACTIONS(2784), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9106), 1,
      anon_sym_CARET,
    ACTIONS(9120), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(4452), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [214788] = 6,
    ACTIONS(8834), 1,
      anon_sym_LPAREN,
    ACTIONS(9200), 1,
      anon_sym_QMARK,
    ACTIONS(9198), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 26,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_do,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [214843] = 22,
    ACTIONS(1247), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(2770), 1,
      anon_sym_proc,
    ACTIONS(2772), 1,
      anon_sym_DOLLAR,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2782), 1,
      anon_sym_map,
    ACTIONS(2784), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9106), 1,
      anon_sym_CARET,
    ACTIONS(9120), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(4456), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [214930] = 22,
    ACTIONS(1247), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(2770), 1,
      anon_sym_proc,
    ACTIONS(2772), 1,
      anon_sym_DOLLAR,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2782), 1,
      anon_sym_map,
    ACTIONS(2784), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9106), 1,
      anon_sym_CARET,
    ACTIONS(9120), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3129), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [215017] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2143), 1,
      anon_sym_proc,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2156), 1,
      anon_sym_DOLLAR,
    ACTIONS(2163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2170), 1,
      anon_sym_map,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(2174), 1,
      anon_sym_matrix,
    ACTIONS(2176), 1,
      anon_sym_distinct,
    ACTIONS(2178), 1,
      sym_tag,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    ACTIONS(9156), 1,
      anon_sym_LBRACK,
    ACTIONS(9158), 1,
      anon_sym_CARET,
    STATE(3721), 1,
      sym_type,
    STATE(3765), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [215104] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7478), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [215191] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7640), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [215278] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9186), 1,
      anon_sym_LBRACK,
    STATE(7094), 1,
      sym_procedure,
    STATE(7189), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [215365] = 22,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8942), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3587), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [215452] = 22,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(941), 1,
      anon_sym_proc,
    ACTIONS(943), 1,
      anon_sym_struct,
    ACTIONS(945), 1,
      anon_sym_enum,
    ACTIONS(947), 1,
      anon_sym_union,
    ACTIONS(949), 1,
      anon_sym_bit_field,
    ACTIONS(954), 1,
      anon_sym_DOLLAR,
    ACTIONS(961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(966), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(968), 1,
      anon_sym_map,
    ACTIONS(970), 1,
      anon_sym_bit_set,
    ACTIONS(972), 1,
      anon_sym_matrix,
    ACTIONS(974), 1,
      anon_sym_distinct,
    ACTIONS(976), 1,
      sym_tag,
    ACTIONS(9210), 1,
      anon_sym_LPAREN,
    ACTIONS(9212), 1,
      anon_sym_BANG,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9216), 1,
      anon_sym_CARET,
    STATE(2134), 1,
      sym_procedure,
    STATE(2159), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2167), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [215539] = 22,
    ACTIONS(267), 1,
      anon_sym_distinct,
    ACTIONS(1375), 1,
      sym_identifier,
    ACTIONS(1377), 1,
      anon_sym_proc,
    ACTIONS(1379), 1,
      anon_sym_struct,
    ACTIONS(1381), 1,
      anon_sym_enum,
    ACTIONS(1383), 1,
      anon_sym_union,
    ACTIONS(1385), 1,
      anon_sym_bit_field,
    ACTIONS(1391), 1,
      anon_sym_DOLLAR,
    ACTIONS(1399), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1407), 1,
      anon_sym_map,
    ACTIONS(1409), 1,
      anon_sym_bit_set,
    ACTIONS(1411), 1,
      anon_sym_matrix,
    ACTIONS(9174), 1,
      anon_sym_LPAREN,
    ACTIONS(9176), 1,
      anon_sym_BANG,
    ACTIONS(9178), 1,
      anon_sym_LBRACK,
    ACTIONS(9180), 1,
      anon_sym_CARET,
    ACTIONS(9280), 1,
      sym_tag,
    STATE(2566), 1,
      sym_procedure,
    STATE(2603), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2607), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [215626] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7678), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [215713] = 22,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1181), 1,
      sym_identifier,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8844), 1,
      anon_sym_LBRACK,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8888), 1,
      sym_tag,
    STATE(2422), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [215800] = 22,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8808), 1,
      anon_sym_LBRACK,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8892), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3501), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [215887] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7792), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [215974] = 15,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 20,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [216047] = 22,
    ACTIONS(325), 1,
      anon_sym_distinct,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1975), 1,
      anon_sym_proc,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(1989), 1,
      anon_sym_DOLLAR,
    ACTIONS(1997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2005), 1,
      anon_sym_map,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2009), 1,
      anon_sym_matrix,
    ACTIONS(2011), 1,
      sym_tag,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    ACTIONS(9202), 1,
      anon_sym_LBRACK,
    ACTIONS(9204), 1,
      anon_sym_CARET,
    STATE(3673), 1,
      sym_type,
    STATE(3690), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [216134] = 20,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9256), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 12,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [216217] = 9,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 6,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 24,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [216278] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8301), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [216365] = 22,
    ACTIONS(267), 1,
      anon_sym_distinct,
    ACTIONS(1375), 1,
      sym_identifier,
    ACTIONS(1377), 1,
      anon_sym_proc,
    ACTIONS(1379), 1,
      anon_sym_struct,
    ACTIONS(1381), 1,
      anon_sym_enum,
    ACTIONS(1383), 1,
      anon_sym_union,
    ACTIONS(1385), 1,
      anon_sym_bit_field,
    ACTIONS(1391), 1,
      anon_sym_DOLLAR,
    ACTIONS(1399), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1407), 1,
      anon_sym_map,
    ACTIONS(1409), 1,
      anon_sym_bit_set,
    ACTIONS(1411), 1,
      anon_sym_matrix,
    ACTIONS(1413), 1,
      sym_tag,
    ACTIONS(9174), 1,
      anon_sym_LPAREN,
    ACTIONS(9176), 1,
      anon_sym_BANG,
    ACTIONS(9178), 1,
      anon_sym_LBRACK,
    ACTIONS(9180), 1,
      anon_sym_CARET,
    STATE(2565), 1,
      sym_type,
    STATE(2566), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2607), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [216452] = 22,
    ACTIONS(267), 1,
      anon_sym_distinct,
    ACTIONS(1375), 1,
      sym_identifier,
    ACTIONS(1377), 1,
      anon_sym_proc,
    ACTIONS(1379), 1,
      anon_sym_struct,
    ACTIONS(1381), 1,
      anon_sym_enum,
    ACTIONS(1383), 1,
      anon_sym_union,
    ACTIONS(1385), 1,
      anon_sym_bit_field,
    ACTIONS(1391), 1,
      anon_sym_DOLLAR,
    ACTIONS(1399), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1407), 1,
      anon_sym_map,
    ACTIONS(1409), 1,
      anon_sym_bit_set,
    ACTIONS(1411), 1,
      anon_sym_matrix,
    ACTIONS(1413), 1,
      sym_tag,
    ACTIONS(9174), 1,
      anon_sym_LPAREN,
    ACTIONS(9176), 1,
      anon_sym_BANG,
    ACTIONS(9178), 1,
      anon_sym_LBRACK,
    ACTIONS(9180), 1,
      anon_sym_CARET,
    STATE(2566), 1,
      sym_procedure,
    STATE(2578), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2607), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [216539] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [216626] = 14,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 4,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 20,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [216697] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7942), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [216784] = 22,
    ACTIONS(47), 1,
      anon_sym_distinct,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2294), 1,
      anon_sym_proc,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2307), 1,
      anon_sym_DOLLAR,
    ACTIONS(2314), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2321), 1,
      anon_sym_map,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(2325), 1,
      anon_sym_matrix,
    ACTIONS(2327), 1,
      sym_tag,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(9184), 1,
      anon_sym_CARET,
    ACTIONS(9282), 1,
      anon_sym_LBRACK,
    STATE(3766), 1,
      sym_procedure,
    STATE(4144), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [216871] = 13,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 5,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 20,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [216940] = 19,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [217021] = 18,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 15,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [217100] = 22,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8876), 1,
      anon_sym_LBRACK,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8906), 1,
      sym_tag,
    STATE(3265), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [217187] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9284), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6768), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [217274] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9048), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6776), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [217361] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9048), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6777), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [217448] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7330), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [217535] = 17,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(5360), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5358), 17,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [217612] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7565), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [217699] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7199), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [217786] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(9286), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7196), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [217873] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9048), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3037), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [217960] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9046), 1,
      anon_sym_LBRACK,
    ACTIONS(9048), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6764), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [218047] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9048), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6770), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [218134] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9048), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6772), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [218221] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7697), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [218308] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9048), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3129), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [218395] = 16,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(5360), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5358), 20,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [218470] = 12,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 5,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 21,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [218537] = 11,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 5,
      anon_sym_PIPE,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(5358), 23,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [218602] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    STATE(3880), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [218689] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7341), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [218776] = 22,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(941), 1,
      anon_sym_proc,
    ACTIONS(943), 1,
      anon_sym_struct,
    ACTIONS(945), 1,
      anon_sym_enum,
    ACTIONS(947), 1,
      anon_sym_union,
    ACTIONS(949), 1,
      anon_sym_bit_field,
    ACTIONS(954), 1,
      anon_sym_DOLLAR,
    ACTIONS(961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(966), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(968), 1,
      anon_sym_map,
    ACTIONS(970), 1,
      anon_sym_bit_set,
    ACTIONS(972), 1,
      anon_sym_matrix,
    ACTIONS(974), 1,
      anon_sym_distinct,
    ACTIONS(976), 1,
      sym_tag,
    ACTIONS(9210), 1,
      anon_sym_LPAREN,
    ACTIONS(9212), 1,
      anon_sym_BANG,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9216), 1,
      anon_sym_CARET,
    STATE(2134), 1,
      sym_procedure,
    STATE(2164), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2167), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [218863] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7052), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [218950] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7048), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [219037] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    ACTIONS(9142), 1,
      anon_sym_LBRACK,
    STATE(3887), 1,
      sym_procedure,
    STATE(7200), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [219124] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    STATE(3782), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [219211] = 7,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5360), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5358), 26,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [219268] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8147), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [219355] = 24,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9274), 1,
      anon_sym_or_break,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9256), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5772), 8,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
  [219446] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8171), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [219533] = 22,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8808), 1,
      anon_sym_LBRACK,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8892), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3568), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [219620] = 7,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5602), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5600), 26,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [219677] = 7,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5646), 8,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5644), 26,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [219734] = 24,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9274), 1,
      anon_sym_or_break,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9256), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(5718), 8,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_not_in,
  [219825] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8868), 1,
      anon_sym_LBRACK,
    ACTIONS(8870), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6771), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [219912] = 22,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(941), 1,
      anon_sym_proc,
    ACTIONS(943), 1,
      anon_sym_struct,
    ACTIONS(945), 1,
      anon_sym_enum,
    ACTIONS(947), 1,
      anon_sym_union,
    ACTIONS(949), 1,
      anon_sym_bit_field,
    ACTIONS(954), 1,
      anon_sym_DOLLAR,
    ACTIONS(961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(966), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(968), 1,
      anon_sym_map,
    ACTIONS(970), 1,
      anon_sym_bit_set,
    ACTIONS(972), 1,
      anon_sym_matrix,
    ACTIONS(974), 1,
      anon_sym_distinct,
    ACTIONS(976), 1,
      sym_tag,
    ACTIONS(9210), 1,
      anon_sym_LPAREN,
    ACTIONS(9212), 1,
      anon_sym_BANG,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9216), 1,
      anon_sym_CARET,
    STATE(2134), 1,
      sym_procedure,
    STATE(2146), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2167), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [219999] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7877), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [220086] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7352), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [220173] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9288), 1,
      sym_tag,
    STATE(6848), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [220260] = 22,
    ACTIONS(2443), 1,
      sym_identifier,
    ACTIONS(2445), 1,
      anon_sym_proc,
    ACTIONS(2447), 1,
      anon_sym_struct,
    ACTIONS(2449), 1,
      anon_sym_enum,
    ACTIONS(2451), 1,
      anon_sym_union,
    ACTIONS(2453), 1,
      anon_sym_bit_field,
    ACTIONS(2458), 1,
      anon_sym_DOLLAR,
    ACTIONS(2465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2470), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2472), 1,
      anon_sym_map,
    ACTIONS(2474), 1,
      anon_sym_bit_set,
    ACTIONS(2476), 1,
      anon_sym_matrix,
    ACTIONS(2478), 1,
      anon_sym_distinct,
    ACTIONS(2480), 1,
      sym_tag,
    ACTIONS(9144), 1,
      anon_sym_LPAREN,
    ACTIONS(9146), 1,
      anon_sym_BANG,
    ACTIONS(9148), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_CARET,
    STATE(4185), 1,
      sym_type,
    STATE(4322), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4276), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [220347] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8208), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [220434] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8345), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [220521] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9186), 1,
      anon_sym_LBRACK,
    STATE(6848), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [220608] = 22,
    ACTIONS(1283), 1,
      anon_sym_distinct,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2584), 1,
      anon_sym_proc,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2597), 1,
      anon_sym_DOLLAR,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2611), 1,
      anon_sym_map,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2615), 1,
      anon_sym_matrix,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8918), 1,
      anon_sym_CARET,
    ACTIONS(8920), 1,
      sym_tag,
    ACTIONS(8976), 1,
      anon_sym_LBRACK,
    STATE(4281), 1,
      sym_procedure,
    STATE(4311), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [220695] = 22,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(769), 1,
      sym_identifier,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8932), 1,
      anon_sym_LBRACK,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      sym_tag,
    STATE(984), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [220782] = 4,
    ACTIONS(8834), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 29,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [220833] = 22,
    ACTIONS(1283), 1,
      anon_sym_distinct,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2584), 1,
      anon_sym_proc,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2597), 1,
      anon_sym_DOLLAR,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2611), 1,
      anon_sym_map,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2615), 1,
      anon_sym_matrix,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8918), 1,
      anon_sym_CARET,
    ACTIONS(8976), 1,
      anon_sym_LBRACK,
    ACTIONS(9290), 1,
      sym_tag,
    STATE(4281), 1,
      sym_procedure,
    STATE(4316), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [220920] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7319), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [221007] = 30,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    ACTIONS(9292), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9294), 1,
      anon_sym_EQ,
    ACTIONS(9296), 1,
      anon_sym_COLON,
    ACTIONS(9298), 1,
      anon_sym_COLON_EQ,
    STATE(7105), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [221110] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7671), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [221197] = 22,
    ACTIONS(47), 1,
      anon_sym_distinct,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2294), 1,
      anon_sym_proc,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2307), 1,
      anon_sym_DOLLAR,
    ACTIONS(2314), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2321), 1,
      anon_sym_map,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(2325), 1,
      anon_sym_matrix,
    ACTIONS(2327), 1,
      sym_tag,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(9182), 1,
      anon_sym_LBRACK,
    ACTIONS(9184), 1,
      anon_sym_CARET,
    STATE(3766), 1,
      sym_procedure,
    STATE(3896), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [221284] = 22,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8808), 1,
      anon_sym_LBRACK,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8892), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3564), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [221371] = 22,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8808), 1,
      anon_sym_LBRACK,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(9300), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3539), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [221458] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2143), 1,
      anon_sym_proc,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2156), 1,
      anon_sym_DOLLAR,
    ACTIONS(2163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2170), 1,
      anon_sym_map,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(2174), 1,
      anon_sym_matrix,
    ACTIONS(2176), 1,
      anon_sym_distinct,
    ACTIONS(2178), 1,
      sym_tag,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    ACTIONS(9156), 1,
      anon_sym_LBRACK,
    ACTIONS(9158), 1,
      anon_sym_CARET,
    STATE(3765), 1,
      sym_procedure,
    STATE(3767), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [221545] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7628), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [221632] = 22,
    ACTIONS(325), 1,
      anon_sym_distinct,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1975), 1,
      anon_sym_proc,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(1989), 1,
      anon_sym_DOLLAR,
    ACTIONS(1997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2005), 1,
      anon_sym_map,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2009), 1,
      anon_sym_matrix,
    ACTIONS(2011), 1,
      sym_tag,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    ACTIONS(9202), 1,
      anon_sym_LBRACK,
    ACTIONS(9204), 1,
      anon_sym_CARET,
    STATE(3678), 1,
      sym_type,
    STATE(3690), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [221719] = 22,
    ACTIONS(1283), 1,
      anon_sym_distinct,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2584), 1,
      anon_sym_proc,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2597), 1,
      anon_sym_DOLLAR,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2611), 1,
      anon_sym_map,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2615), 1,
      anon_sym_matrix,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8916), 1,
      anon_sym_LBRACK,
    ACTIONS(8918), 1,
      anon_sym_CARET,
    ACTIONS(8920), 1,
      sym_tag,
    STATE(4281), 1,
      sym_procedure,
    STATE(4317), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [221806] = 22,
    ACTIONS(1283), 1,
      anon_sym_distinct,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2584), 1,
      anon_sym_proc,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2597), 1,
      anon_sym_DOLLAR,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2611), 1,
      anon_sym_map,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2615), 1,
      anon_sym_matrix,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8918), 1,
      anon_sym_CARET,
    ACTIONS(8920), 1,
      sym_tag,
    ACTIONS(8976), 1,
      anon_sym_LBRACK,
    STATE(4186), 1,
      sym_type,
    STATE(4281), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [221893] = 22,
    ACTIONS(1247), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(2770), 1,
      anon_sym_proc,
    ACTIONS(2772), 1,
      anon_sym_DOLLAR,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2782), 1,
      anon_sym_map,
    ACTIONS(2784), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9106), 1,
      anon_sym_CARET,
    ACTIONS(9120), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3036), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [221980] = 22,
    ACTIONS(47), 1,
      anon_sym_distinct,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2294), 1,
      anon_sym_proc,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2307), 1,
      anon_sym_DOLLAR,
    ACTIONS(2314), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2321), 1,
      anon_sym_map,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(2325), 1,
      anon_sym_matrix,
    ACTIONS(2327), 1,
      sym_tag,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(9182), 1,
      anon_sym_LBRACK,
    ACTIONS(9184), 1,
      anon_sym_CARET,
    STATE(3766), 1,
      sym_procedure,
    STATE(4029), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [222067] = 22,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8850), 1,
      anon_sym_LBRACK,
    ACTIONS(9302), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3267), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [222154] = 22,
    ACTIONS(1283), 1,
      anon_sym_distinct,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2584), 1,
      anon_sym_proc,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2597), 1,
      anon_sym_DOLLAR,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2611), 1,
      anon_sym_map,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2615), 1,
      anon_sym_matrix,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8918), 1,
      anon_sym_CARET,
    ACTIONS(8920), 1,
      sym_tag,
    ACTIONS(8976), 1,
      anon_sym_LBRACK,
    STATE(4181), 1,
      sym_type,
    STATE(4281), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [222241] = 22,
    ACTIONS(649), 1,
      anon_sym_distinct,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2245), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2258), 1,
      anon_sym_DOLLAR,
    ACTIONS(2265), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2272), 1,
      anon_sym_map,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2276), 1,
      anon_sym_matrix,
    ACTIONS(2278), 1,
      sym_tag,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(9304), 1,
      anon_sym_LBRACK,
    ACTIONS(9306), 1,
      anon_sym_CARET,
    STATE(3887), 1,
      sym_procedure,
    STATE(3907), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [222328] = 22,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8830), 1,
      sym_tag,
    ACTIONS(8850), 1,
      anon_sym_LBRACK,
    STATE(2978), 1,
      sym_procedure,
    STATE(3319), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [222415] = 22,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8820), 1,
      anon_sym_LBRACK,
    ACTIONS(8822), 1,
      sym_tag,
    STATE(4281), 1,
      sym_procedure,
    STATE(6745), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [222502] = 22,
    ACTIONS(1247), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(2770), 1,
      anon_sym_proc,
    ACTIONS(2772), 1,
      anon_sym_DOLLAR,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2782), 1,
      anon_sym_map,
    ACTIONS(2784), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9106), 1,
      anon_sym_CARET,
    ACTIONS(9120), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(4508), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [222589] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7996), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [222676] = 22,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8890), 1,
      anon_sym_LBRACK,
    ACTIONS(8892), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3570), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [222763] = 22,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8808), 1,
      anon_sym_LBRACK,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8892), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3587), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [222850] = 22,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8808), 1,
      anon_sym_LBRACK,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8892), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3582), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [222937] = 22,
    ACTIONS(649), 1,
      anon_sym_distinct,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2245), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2258), 1,
      anon_sym_DOLLAR,
    ACTIONS(2265), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2272), 1,
      anon_sym_map,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2276), 1,
      anon_sym_matrix,
    ACTIONS(2278), 1,
      sym_tag,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(9304), 1,
      anon_sym_LBRACK,
    ACTIONS(9306), 1,
      anon_sym_CARET,
    STATE(3782), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [223024] = 22,
    ACTIONS(325), 1,
      anon_sym_distinct,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1975), 1,
      anon_sym_proc,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(1989), 1,
      anon_sym_DOLLAR,
    ACTIONS(1997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2005), 1,
      anon_sym_map,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2009), 1,
      anon_sym_matrix,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    ACTIONS(9202), 1,
      anon_sym_LBRACK,
    ACTIONS(9204), 1,
      anon_sym_CARET,
    ACTIONS(9308), 1,
      sym_tag,
    STATE(3682), 1,
      sym_type,
    STATE(3690), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [223111] = 22,
    ACTIONS(267), 1,
      anon_sym_distinct,
    ACTIONS(1375), 1,
      sym_identifier,
    ACTIONS(1377), 1,
      anon_sym_proc,
    ACTIONS(1379), 1,
      anon_sym_struct,
    ACTIONS(1381), 1,
      anon_sym_enum,
    ACTIONS(1383), 1,
      anon_sym_union,
    ACTIONS(1385), 1,
      anon_sym_bit_field,
    ACTIONS(1391), 1,
      anon_sym_DOLLAR,
    ACTIONS(1399), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1407), 1,
      anon_sym_map,
    ACTIONS(1409), 1,
      anon_sym_bit_set,
    ACTIONS(1411), 1,
      anon_sym_matrix,
    ACTIONS(1413), 1,
      sym_tag,
    ACTIONS(9174), 1,
      anon_sym_LPAREN,
    ACTIONS(9176), 1,
      anon_sym_BANG,
    ACTIONS(9178), 1,
      anon_sym_LBRACK,
    ACTIONS(9180), 1,
      anon_sym_CARET,
    STATE(2566), 1,
      sym_procedure,
    STATE(2722), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2607), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [223198] = 22,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8800), 1,
      anon_sym_LBRACK,
    ACTIONS(8802), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6588), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [223285] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    ACTIONS(9310), 1,
      sym_tag,
    STATE(3765), 1,
      sym_procedure,
    STATE(6792), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [223372] = 22,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8822), 1,
      sym_tag,
    STATE(4281), 1,
      sym_procedure,
    STATE(6756), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [223459] = 22,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8822), 1,
      sym_tag,
    STATE(4281), 1,
      sym_procedure,
    STATE(6753), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [223546] = 22,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8822), 1,
      sym_tag,
    STATE(4213), 1,
      sym_type,
    STATE(4281), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [223633] = 22,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8802), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6583), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [223720] = 22,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8876), 1,
      anon_sym_LBRACK,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8906), 1,
      sym_tag,
    STATE(3353), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [223807] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2143), 1,
      anon_sym_proc,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2156), 1,
      anon_sym_DOLLAR,
    ACTIONS(2163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2170), 1,
      anon_sym_map,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(2174), 1,
      anon_sym_matrix,
    ACTIONS(2176), 1,
      anon_sym_distinct,
    ACTIONS(2178), 1,
      sym_tag,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    ACTIONS(9158), 1,
      anon_sym_CARET,
    ACTIONS(9312), 1,
      anon_sym_LBRACK,
    STATE(3765), 1,
      sym_procedure,
    STATE(3824), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [223894] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(6913), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [223981] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    ACTIONS(9314), 1,
      sym_tag,
    STATE(3690), 1,
      sym_procedure,
    STATE(6911), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [224068] = 22,
    ACTIONS(1283), 1,
      anon_sym_distinct,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2584), 1,
      anon_sym_proc,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2597), 1,
      anon_sym_DOLLAR,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2611), 1,
      anon_sym_map,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2615), 1,
      anon_sym_matrix,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8918), 1,
      anon_sym_CARET,
    ACTIONS(8920), 1,
      sym_tag,
    ACTIONS(8976), 1,
      anon_sym_LBRACK,
    STATE(4281), 1,
      sym_procedure,
    STATE(4319), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [224155] = 22,
    ACTIONS(649), 1,
      anon_sym_distinct,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2245), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2258), 1,
      anon_sym_DOLLAR,
    ACTIONS(2265), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2272), 1,
      anon_sym_map,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2276), 1,
      anon_sym_matrix,
    ACTIONS(2278), 1,
      sym_tag,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(9306), 1,
      anon_sym_CARET,
    ACTIONS(9316), 1,
      anon_sym_LBRACK,
    STATE(3887), 1,
      sym_procedure,
    STATE(4059), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [224242] = 22,
    ACTIONS(1283), 1,
      anon_sym_distinct,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2584), 1,
      anon_sym_proc,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2597), 1,
      anon_sym_DOLLAR,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2611), 1,
      anon_sym_map,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2615), 1,
      anon_sym_matrix,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8918), 1,
      anon_sym_CARET,
    ACTIONS(8920), 1,
      sym_tag,
    ACTIONS(8976), 1,
      anon_sym_LBRACK,
    STATE(4281), 1,
      sym_procedure,
    STATE(4318), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [224329] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2143), 1,
      anon_sym_proc,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2156), 1,
      anon_sym_DOLLAR,
    ACTIONS(2163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2170), 1,
      anon_sym_map,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(2174), 1,
      anon_sym_matrix,
    ACTIONS(2176), 1,
      anon_sym_distinct,
    ACTIONS(2178), 1,
      sym_tag,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    ACTIONS(9156), 1,
      anon_sym_LBRACK,
    ACTIONS(9158), 1,
      anon_sym_CARET,
    STATE(3765), 1,
      sym_procedure,
    STATE(3795), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [224416] = 22,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(769), 1,
      sym_identifier,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8932), 1,
      anon_sym_LBRACK,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      sym_tag,
    STATE(938), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [224503] = 22,
    ACTIONS(1283), 1,
      anon_sym_distinct,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2584), 1,
      anon_sym_proc,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2597), 1,
      anon_sym_DOLLAR,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2611), 1,
      anon_sym_map,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2615), 1,
      anon_sym_matrix,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8918), 1,
      anon_sym_CARET,
    ACTIONS(8920), 1,
      sym_tag,
    ACTIONS(8976), 1,
      anon_sym_LBRACK,
    STATE(4213), 1,
      sym_type,
    STATE(4281), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [224590] = 22,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8802), 1,
      sym_tag,
    STATE(3353), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [224677] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    ACTIONS(9318), 1,
      anon_sym_LBRACK,
    STATE(3765), 1,
      sym_procedure,
    STATE(6758), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [224764] = 22,
    ACTIONS(649), 1,
      anon_sym_distinct,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2245), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2258), 1,
      anon_sym_DOLLAR,
    ACTIONS(2265), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2272), 1,
      anon_sym_map,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2276), 1,
      anon_sym_matrix,
    ACTIONS(2278), 1,
      sym_tag,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(9304), 1,
      anon_sym_LBRACK,
    ACTIONS(9306), 1,
      anon_sym_CARET,
    STATE(3887), 1,
      sym_procedure,
    STATE(4058), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [224851] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(9320), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7025), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [224938] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8870), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3129), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [225025] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    ACTIONS(9142), 1,
      anon_sym_LBRACK,
    STATE(3887), 1,
      sym_procedure,
    STATE(7025), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [225112] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8870), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6794), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [225199] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8870), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6793), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [225286] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8900), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3037), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [225373] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9322), 1,
      anon_sym_LBRACK,
    STATE(3887), 1,
      sym_procedure,
    STATE(7299), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [225460] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9324), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7299), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [225547] = 22,
    ACTIONS(325), 1,
      anon_sym_distinct,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1975), 1,
      anon_sym_proc,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(1989), 1,
      anon_sym_DOLLAR,
    ACTIONS(1997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2005), 1,
      anon_sym_map,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2009), 1,
      anon_sym_matrix,
    ACTIONS(2011), 1,
      sym_tag,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    ACTIONS(9202), 1,
      anon_sym_LBRACK,
    ACTIONS(9204), 1,
      anon_sym_CARET,
    STATE(3690), 1,
      sym_procedure,
    STATE(3879), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [225634] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(9326), 1,
      sym_tag,
    STATE(3766), 1,
      sym_procedure,
    STATE(6775), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [225721] = 22,
    ACTIONS(751), 1,
      anon_sym_distinct,
    ACTIONS(2545), 1,
      sym_identifier,
    ACTIONS(2547), 1,
      anon_sym_proc,
    ACTIONS(2549), 1,
      anon_sym_struct,
    ACTIONS(2551), 1,
      anon_sym_enum,
    ACTIONS(2553), 1,
      anon_sym_union,
    ACTIONS(2555), 1,
      anon_sym_bit_field,
    ACTIONS(2560), 1,
      anon_sym_DOLLAR,
    ACTIONS(2567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2572), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2574), 1,
      anon_sym_map,
    ACTIONS(2576), 1,
      anon_sym_bit_set,
    ACTIONS(2578), 1,
      anon_sym_matrix,
    ACTIONS(2580), 1,
      sym_tag,
    ACTIONS(9228), 1,
      anon_sym_LPAREN,
    ACTIONS(9230), 1,
      anon_sym_BANG,
    ACTIONS(9232), 1,
      anon_sym_LBRACK,
    ACTIONS(9234), 1,
      anon_sym_CARET,
    STATE(4431), 1,
      sym_type,
    STATE(4444), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4570), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [225808] = 22,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8876), 1,
      anon_sym_LBRACK,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8906), 1,
      sym_tag,
    STATE(3312), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [225895] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7263), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [225982] = 22,
    ACTIONS(751), 1,
      anon_sym_distinct,
    ACTIONS(2545), 1,
      sym_identifier,
    ACTIONS(2547), 1,
      anon_sym_proc,
    ACTIONS(2549), 1,
      anon_sym_struct,
    ACTIONS(2551), 1,
      anon_sym_enum,
    ACTIONS(2553), 1,
      anon_sym_union,
    ACTIONS(2555), 1,
      anon_sym_bit_field,
    ACTIONS(2560), 1,
      anon_sym_DOLLAR,
    ACTIONS(2567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2572), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2574), 1,
      anon_sym_map,
    ACTIONS(2576), 1,
      anon_sym_bit_set,
    ACTIONS(2578), 1,
      anon_sym_matrix,
    ACTIONS(2580), 1,
      sym_tag,
    ACTIONS(9228), 1,
      anon_sym_LPAREN,
    ACTIONS(9230), 1,
      anon_sym_BANG,
    ACTIONS(9234), 1,
      anon_sym_CARET,
    ACTIONS(9328), 1,
      anon_sym_LBRACK,
    STATE(4444), 1,
      sym_procedure,
    STATE(4538), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4570), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [226069] = 22,
    ACTIONS(751), 1,
      anon_sym_distinct,
    ACTIONS(2545), 1,
      sym_identifier,
    ACTIONS(2547), 1,
      anon_sym_proc,
    ACTIONS(2549), 1,
      anon_sym_struct,
    ACTIONS(2551), 1,
      anon_sym_enum,
    ACTIONS(2553), 1,
      anon_sym_union,
    ACTIONS(2555), 1,
      anon_sym_bit_field,
    ACTIONS(2560), 1,
      anon_sym_DOLLAR,
    ACTIONS(2567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2572), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2574), 1,
      anon_sym_map,
    ACTIONS(2576), 1,
      anon_sym_bit_set,
    ACTIONS(2578), 1,
      anon_sym_matrix,
    ACTIONS(2580), 1,
      sym_tag,
    ACTIONS(9228), 1,
      anon_sym_LPAREN,
    ACTIONS(9230), 1,
      anon_sym_BANG,
    ACTIONS(9232), 1,
      anon_sym_LBRACK,
    ACTIONS(9234), 1,
      anon_sym_CARET,
    STATE(4423), 1,
      sym_type,
    STATE(4444), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4570), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [226156] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7674), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [226243] = 22,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8876), 1,
      anon_sym_LBRACK,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8906), 1,
      sym_tag,
    STATE(3169), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [226330] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8870), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3037), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [226417] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(203), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(201), 30,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [226466] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5612), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5610), 30,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [226515] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7679), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [226602] = 22,
    ACTIONS(267), 1,
      anon_sym_distinct,
    ACTIONS(1375), 1,
      sym_identifier,
    ACTIONS(1377), 1,
      anon_sym_proc,
    ACTIONS(1379), 1,
      anon_sym_struct,
    ACTIONS(1381), 1,
      anon_sym_enum,
    ACTIONS(1383), 1,
      anon_sym_union,
    ACTIONS(1385), 1,
      anon_sym_bit_field,
    ACTIONS(1391), 1,
      anon_sym_DOLLAR,
    ACTIONS(1399), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1407), 1,
      anon_sym_map,
    ACTIONS(1409), 1,
      anon_sym_bit_set,
    ACTIONS(1411), 1,
      anon_sym_matrix,
    ACTIONS(1413), 1,
      sym_tag,
    ACTIONS(9174), 1,
      anon_sym_LPAREN,
    ACTIONS(9176), 1,
      anon_sym_BANG,
    ACTIONS(9178), 1,
      anon_sym_LBRACK,
    ACTIONS(9180), 1,
      anon_sym_CARET,
    STATE(2566), 1,
      sym_procedure,
    STATE(2678), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2607), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [226689] = 22,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8876), 1,
      anon_sym_LBRACK,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8906), 1,
      sym_tag,
    STATE(3206), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [226776] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7682), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [226863] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    STATE(3718), 1,
      sym_type,
    STATE(3766), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [226950] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(3907), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [227037] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9322), 1,
      anon_sym_LBRACK,
    STATE(3887), 1,
      sym_procedure,
    STATE(7224), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [227124] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(3879), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [227211] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9330), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7224), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [227298] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2143), 1,
      anon_sym_proc,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2156), 1,
      anon_sym_DOLLAR,
    ACTIONS(2163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2170), 1,
      anon_sym_map,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(2174), 1,
      anon_sym_matrix,
    ACTIONS(2176), 1,
      anon_sym_distinct,
    ACTIONS(2178), 1,
      sym_tag,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    ACTIONS(9156), 1,
      anon_sym_LBRACK,
    ACTIONS(9158), 1,
      anon_sym_CARET,
    STATE(3765), 1,
      sym_procedure,
    STATE(3830), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [227385] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8870), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6759), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [227472] = 22,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8830), 1,
      sym_tag,
    ACTIONS(8850), 1,
      anon_sym_LBRACK,
    STATE(2978), 1,
      sym_procedure,
    STATE(3307), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [227559] = 22,
    ACTIONS(325), 1,
      anon_sym_distinct,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1975), 1,
      anon_sym_proc,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(1989), 1,
      anon_sym_DOLLAR,
    ACTIONS(1997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2005), 1,
      anon_sym_map,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2009), 1,
      anon_sym_matrix,
    ACTIONS(2011), 1,
      sym_tag,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    ACTIONS(9202), 1,
      anon_sym_LBRACK,
    ACTIONS(9204), 1,
      anon_sym_CARET,
    STATE(3690), 1,
      sym_procedure,
    STATE(4726), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [227646] = 22,
    ACTIONS(751), 1,
      anon_sym_distinct,
    ACTIONS(2545), 1,
      sym_identifier,
    ACTIONS(2547), 1,
      anon_sym_proc,
    ACTIONS(2549), 1,
      anon_sym_struct,
    ACTIONS(2551), 1,
      anon_sym_enum,
    ACTIONS(2553), 1,
      anon_sym_union,
    ACTIONS(2555), 1,
      anon_sym_bit_field,
    ACTIONS(2560), 1,
      anon_sym_DOLLAR,
    ACTIONS(2567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2572), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2574), 1,
      anon_sym_map,
    ACTIONS(2576), 1,
      anon_sym_bit_set,
    ACTIONS(2578), 1,
      anon_sym_matrix,
    ACTIONS(2580), 1,
      sym_tag,
    ACTIONS(9228), 1,
      anon_sym_LPAREN,
    ACTIONS(9230), 1,
      anon_sym_BANG,
    ACTIONS(9232), 1,
      anon_sym_LBRACK,
    ACTIONS(9234), 1,
      anon_sym_CARET,
    STATE(4444), 1,
      sym_procedure,
    STATE(4482), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4570), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [227733] = 22,
    ACTIONS(325), 1,
      anon_sym_distinct,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1975), 1,
      anon_sym_proc,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(1989), 1,
      anon_sym_DOLLAR,
    ACTIONS(1997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2005), 1,
      anon_sym_map,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2009), 1,
      anon_sym_matrix,
    ACTIONS(2011), 1,
      sym_tag,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    ACTIONS(9202), 1,
      anon_sym_LBRACK,
    ACTIONS(9204), 1,
      anon_sym_CARET,
    STATE(3658), 1,
      sym_type,
    STATE(3690), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [227820] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(9332), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7057), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [227907] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(6765), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [227994] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9334), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(6762), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [228081] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7907), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [228168] = 22,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8808), 1,
      anon_sym_LBRACK,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8892), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3604), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [228255] = 22,
    ACTIONS(359), 1,
      anon_sym_distinct,
    ACTIONS(1483), 1,
      sym_identifier,
    ACTIONS(1485), 1,
      anon_sym_proc,
    ACTIONS(1487), 1,
      anon_sym_struct,
    ACTIONS(1489), 1,
      anon_sym_enum,
    ACTIONS(1491), 1,
      anon_sym_union,
    ACTIONS(1493), 1,
      anon_sym_bit_field,
    ACTIONS(1498), 1,
      anon_sym_DOLLAR,
    ACTIONS(1505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1510), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1512), 1,
      anon_sym_map,
    ACTIONS(1514), 1,
      anon_sym_bit_set,
    ACTIONS(1516), 1,
      anon_sym_matrix,
    ACTIONS(1518), 1,
      sym_tag,
    ACTIONS(9220), 1,
      anon_sym_LPAREN,
    ACTIONS(9222), 1,
      anon_sym_BANG,
    ACTIONS(9226), 1,
      anon_sym_CARET,
    ACTIONS(9242), 1,
      anon_sym_LBRACK,
    STATE(2852), 1,
      sym_procedure,
    STATE(2896), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2807), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [228342] = 22,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8808), 1,
      anon_sym_LBRACK,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8892), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3606), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [228429] = 22,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8808), 1,
      anon_sym_LBRACK,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8892), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3601), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [228516] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    STATE(3765), 1,
      sym_procedure,
    STATE(3830), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [228603] = 22,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8802), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6591), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [228690] = 22,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8802), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6595), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [228777] = 22,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8802), 1,
      sym_tag,
    STATE(3312), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [228864] = 22,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8830), 1,
      sym_tag,
    ACTIONS(8850), 1,
      anon_sym_LBRACK,
    STATE(2978), 1,
      sym_procedure,
    STATE(3037), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [228951] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    STATE(3765), 1,
      sym_procedure,
    STATE(6786), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [229038] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    STATE(3765), 1,
      sym_procedure,
    STATE(6785), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [229125] = 22,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(769), 1,
      sym_identifier,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8932), 1,
      anon_sym_LBRACK,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      sym_tag,
    STATE(1013), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [229212] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    STATE(3766), 1,
      sym_procedure,
    STATE(6737), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [229299] = 22,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8826), 1,
      anon_sym_LBRACK,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8830), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3268), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [229386] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    STATE(3765), 1,
      sym_procedure,
    STATE(3823), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [229473] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 30,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [229522] = 22,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8830), 1,
      sym_tag,
    ACTIONS(8850), 1,
      anon_sym_LBRACK,
    STATE(2978), 1,
      sym_procedure,
    STATE(3266), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [229609] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 30,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [229658] = 22,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8830), 1,
      sym_tag,
    ACTIONS(8850), 1,
      anon_sym_LBRACK,
    STATE(2978), 1,
      sym_procedure,
    STATE(3264), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [229745] = 22,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8830), 1,
      sym_tag,
    ACTIONS(8850), 1,
      anon_sym_LBRACK,
    STATE(2978), 1,
      sym_procedure,
    STATE(3129), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [229832] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(8377), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [229919] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7677), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [230006] = 22,
    ACTIONS(359), 1,
      anon_sym_distinct,
    ACTIONS(1483), 1,
      sym_identifier,
    ACTIONS(1485), 1,
      anon_sym_proc,
    ACTIONS(1487), 1,
      anon_sym_struct,
    ACTIONS(1489), 1,
      anon_sym_enum,
    ACTIONS(1491), 1,
      anon_sym_union,
    ACTIONS(1493), 1,
      anon_sym_bit_field,
    ACTIONS(1498), 1,
      anon_sym_DOLLAR,
    ACTIONS(1505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1510), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1512), 1,
      anon_sym_map,
    ACTIONS(1514), 1,
      anon_sym_bit_set,
    ACTIONS(1516), 1,
      anon_sym_matrix,
    ACTIONS(1518), 1,
      sym_tag,
    ACTIONS(9220), 1,
      anon_sym_LPAREN,
    ACTIONS(9222), 1,
      anon_sym_BANG,
    ACTIONS(9226), 1,
      anon_sym_CARET,
    ACTIONS(9242), 1,
      anon_sym_LBRACK,
    STATE(2852), 1,
      sym_procedure,
    STATE(2887), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2807), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [230093] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7692), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [230180] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8870), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6791), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [230267] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5842), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5840), 30,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [230316] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7691), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [230403] = 22,
    ACTIONS(1283), 1,
      anon_sym_distinct,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2584), 1,
      anon_sym_proc,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2597), 1,
      anon_sym_DOLLAR,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2611), 1,
      anon_sym_map,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2615), 1,
      anon_sym_matrix,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8918), 1,
      anon_sym_CARET,
    ACTIONS(8920), 1,
      sym_tag,
    ACTIONS(8976), 1,
      anon_sym_LBRACK,
    STATE(4281), 1,
      sym_procedure,
    STATE(4308), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [230490] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9336), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6783), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [230577] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8093), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [230664] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2143), 1,
      anon_sym_proc,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2156), 1,
      anon_sym_DOLLAR,
    ACTIONS(2163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2170), 1,
      anon_sym_map,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(2174), 1,
      anon_sym_matrix,
    ACTIONS(2176), 1,
      anon_sym_distinct,
    ACTIONS(2178), 1,
      sym_tag,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    ACTIONS(9156), 1,
      anon_sym_LBRACK,
    ACTIONS(9158), 1,
      anon_sym_CARET,
    STATE(3761), 1,
      sym_type,
    STATE(3765), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [230751] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3638), 1,
      sym_type,
    STATE(3690), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [230838] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7653), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [230925] = 22,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(769), 1,
      sym_identifier,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8932), 1,
      anon_sym_LBRACK,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      sym_tag,
    STATE(989), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [231012] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7836), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [231099] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    STATE(3766), 1,
      sym_procedure,
    STATE(3778), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [231186] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    ACTIONS(9142), 1,
      anon_sym_LBRACK,
    STATE(3887), 1,
      sym_procedure,
    STATE(7173), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [231273] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(6925), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [231360] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8006), 1,
      anon_sym_proc,
    ACTIONS(8008), 1,
      anon_sym_DOLLAR,
    ACTIONS(8010), 1,
      anon_sym_LBRACK,
    ACTIONS(8012), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8014), 1,
      anon_sym_CARET,
    ACTIONS(8016), 1,
      anon_sym_map,
    ACTIONS(8018), 1,
      anon_sym_matrix,
    ACTIONS(8020), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8870), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3117), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [231447] = 22,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8940), 1,
      anon_sym_LBRACK,
    ACTIONS(8942), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(6590), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [231534] = 22,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(941), 1,
      anon_sym_proc,
    ACTIONS(943), 1,
      anon_sym_struct,
    ACTIONS(945), 1,
      anon_sym_enum,
    ACTIONS(947), 1,
      anon_sym_union,
    ACTIONS(949), 1,
      anon_sym_bit_field,
    ACTIONS(954), 1,
      anon_sym_DOLLAR,
    ACTIONS(961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(966), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(968), 1,
      anon_sym_map,
    ACTIONS(970), 1,
      anon_sym_bit_set,
    ACTIONS(972), 1,
      anon_sym_matrix,
    ACTIONS(974), 1,
      anon_sym_distinct,
    ACTIONS(976), 1,
      sym_tag,
    ACTIONS(9210), 1,
      anon_sym_LPAREN,
    ACTIONS(9212), 1,
      anon_sym_BANG,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9216), 1,
      anon_sym_CARET,
    STATE(2134), 1,
      sym_procedure,
    STATE(2144), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2167), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [231621] = 22,
    ACTIONS(325), 1,
      anon_sym_distinct,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1975), 1,
      anon_sym_proc,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(1989), 1,
      anon_sym_DOLLAR,
    ACTIONS(1997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2005), 1,
      anon_sym_map,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2009), 1,
      anon_sym_matrix,
    ACTIONS(2011), 1,
      sym_tag,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    ACTIONS(9204), 1,
      anon_sym_CARET,
    ACTIONS(9338), 1,
      anon_sym_LBRACK,
    STATE(3671), 1,
      sym_type,
    STATE(3690), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [231708] = 22,
    ACTIONS(751), 1,
      anon_sym_distinct,
    ACTIONS(2545), 1,
      sym_identifier,
    ACTIONS(2547), 1,
      anon_sym_proc,
    ACTIONS(2549), 1,
      anon_sym_struct,
    ACTIONS(2551), 1,
      anon_sym_enum,
    ACTIONS(2553), 1,
      anon_sym_union,
    ACTIONS(2555), 1,
      anon_sym_bit_field,
    ACTIONS(2560), 1,
      anon_sym_DOLLAR,
    ACTIONS(2567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2572), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2574), 1,
      anon_sym_map,
    ACTIONS(2576), 1,
      anon_sym_bit_set,
    ACTIONS(2578), 1,
      anon_sym_matrix,
    ACTIONS(9228), 1,
      anon_sym_LPAREN,
    ACTIONS(9230), 1,
      anon_sym_BANG,
    ACTIONS(9232), 1,
      anon_sym_LBRACK,
    ACTIONS(9234), 1,
      anon_sym_CARET,
    ACTIONS(9340), 1,
      sym_tag,
    STATE(4444), 1,
      sym_procedure,
    STATE(4560), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4570), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [231795] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9342), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6618), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [231882] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(9344), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7173), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [231969] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(6923), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [232056] = 22,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1181), 1,
      sym_identifier,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8844), 1,
      anon_sym_LBRACK,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8888), 1,
      sym_tag,
    STATE(2467), 1,
      sym_procedure,
    STATE(2499), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [232143] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    ACTIONS(9346), 1,
      anon_sym_LBRACK,
    STATE(3690), 1,
      sym_procedure,
    STATE(6914), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [232230] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3673), 1,
      sym_type,
    STATE(3690), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [232317] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3672), 1,
      sym_type,
    STATE(3690), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [232404] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7695), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [232491] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8282), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [232578] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(9206), 1,
      anon_sym_LBRACK,
    STATE(3766), 1,
      sym_procedure,
    STATE(6775), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [232665] = 22,
    ACTIONS(751), 1,
      anon_sym_distinct,
    ACTIONS(2545), 1,
      sym_identifier,
    ACTIONS(2547), 1,
      anon_sym_proc,
    ACTIONS(2549), 1,
      anon_sym_struct,
    ACTIONS(2551), 1,
      anon_sym_enum,
    ACTIONS(2553), 1,
      anon_sym_union,
    ACTIONS(2555), 1,
      anon_sym_bit_field,
    ACTIONS(2560), 1,
      anon_sym_DOLLAR,
    ACTIONS(2567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2572), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2574), 1,
      anon_sym_map,
    ACTIONS(2576), 1,
      anon_sym_bit_set,
    ACTIONS(2578), 1,
      anon_sym_matrix,
    ACTIONS(2580), 1,
      sym_tag,
    ACTIONS(9228), 1,
      anon_sym_LPAREN,
    ACTIONS(9230), 1,
      anon_sym_BANG,
    ACTIONS(9232), 1,
      anon_sym_LBRACK,
    ACTIONS(9234), 1,
      anon_sym_CARET,
    STATE(4444), 1,
      sym_procedure,
    STATE(4539), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4570), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [232752] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3880), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [232839] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    STATE(3782), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [232926] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(6763), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [233013] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    ACTIONS(9348), 1,
      anon_sym_LBRACK,
    STATE(3887), 1,
      sym_procedure,
    STATE(7217), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [233100] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(6795), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [233187] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9322), 1,
      anon_sym_LBRACK,
    STATE(3887), 1,
      sym_procedure,
    STATE(6766), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [233274] = 22,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(769), 1,
      sym_identifier,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(8998), 1,
      anon_sym_LBRACK,
    ACTIONS(9000), 1,
      sym_tag,
    STATE(1019), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [233361] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3782), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [233448] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8360), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [233535] = 22,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(769), 1,
      sym_identifier,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8932), 1,
      anon_sym_LBRACK,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      sym_tag,
    STATE(1064), 1,
      sym_procedure,
    STATE(1165), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [233622] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7259), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [233709] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8341), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [233796] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7258), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [233883] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    STATE(3880), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [233970] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(9350), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7219), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [234057] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    ACTIONS(9142), 1,
      anon_sym_LBRACK,
    STATE(3887), 1,
      sym_procedure,
    STATE(7057), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [234144] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8900), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6614), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [234231] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8549), 1,
      anon_sym_proc,
    ACTIONS(8551), 1,
      anon_sym_DOLLAR,
    ACTIONS(8553), 1,
      anon_sym_LBRACK,
    ACTIONS(8555), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8557), 1,
      anon_sym_CARET,
    ACTIONS(8559), 1,
      anon_sym_map,
    ACTIONS(8561), 1,
      anon_sym_matrix,
    ACTIONS(8563), 1,
      anon_sym_distinct,
    ACTIONS(8565), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7218), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [234318] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8256), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [234405] = 22,
    ACTIONS(325), 1,
      anon_sym_distinct,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1975), 1,
      anon_sym_proc,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(1989), 1,
      anon_sym_DOLLAR,
    ACTIONS(1997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2005), 1,
      anon_sym_map,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2009), 1,
      anon_sym_matrix,
    ACTIONS(2011), 1,
      sym_tag,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    ACTIONS(9202), 1,
      anon_sym_LBRACK,
    ACTIONS(9204), 1,
      anon_sym_CARET,
    STATE(3690), 1,
      sym_procedure,
    STATE(3840), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [234492] = 22,
    ACTIONS(325), 1,
      anon_sym_distinct,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1975), 1,
      anon_sym_proc,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(1989), 1,
      anon_sym_DOLLAR,
    ACTIONS(1997), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2005), 1,
      anon_sym_map,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(2009), 1,
      anon_sym_matrix,
    ACTIONS(2011), 1,
      sym_tag,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    ACTIONS(9202), 1,
      anon_sym_LBRACK,
    ACTIONS(9204), 1,
      anon_sym_CARET,
    STATE(3672), 1,
      sym_type,
    STATE(3690), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [234579] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7987), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [234666] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7256), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [234753] = 22,
    ACTIONS(751), 1,
      anon_sym_distinct,
    ACTIONS(2545), 1,
      sym_identifier,
    ACTIONS(2547), 1,
      anon_sym_proc,
    ACTIONS(2549), 1,
      anon_sym_struct,
    ACTIONS(2551), 1,
      anon_sym_enum,
    ACTIONS(2553), 1,
      anon_sym_union,
    ACTIONS(2555), 1,
      anon_sym_bit_field,
    ACTIONS(2560), 1,
      anon_sym_DOLLAR,
    ACTIONS(2567), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2572), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2574), 1,
      anon_sym_map,
    ACTIONS(2576), 1,
      anon_sym_bit_set,
    ACTIONS(2578), 1,
      anon_sym_matrix,
    ACTIONS(2580), 1,
      sym_tag,
    ACTIONS(9228), 1,
      anon_sym_LPAREN,
    ACTIONS(9230), 1,
      anon_sym_BANG,
    ACTIONS(9232), 1,
      anon_sym_LBRACK,
    ACTIONS(9234), 1,
      anon_sym_CARET,
    STATE(4444), 1,
      sym_procedure,
    STATE(4464), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4570), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [234840] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7983), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [234927] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8087), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [235014] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7962), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [235101] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7699), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [235188] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    STATE(3766), 1,
      sym_procedure,
    STATE(6741), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [235275] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7738), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [235362] = 22,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1181), 1,
      sym_identifier,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8844), 1,
      anon_sym_LBRACK,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8888), 1,
      sym_tag,
    STATE(2456), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [235449] = 22,
    ACTIONS(359), 1,
      anon_sym_distinct,
    ACTIONS(1483), 1,
      sym_identifier,
    ACTIONS(1485), 1,
      anon_sym_proc,
    ACTIONS(1487), 1,
      anon_sym_struct,
    ACTIONS(1489), 1,
      anon_sym_enum,
    ACTIONS(1491), 1,
      anon_sym_union,
    ACTIONS(1493), 1,
      anon_sym_bit_field,
    ACTIONS(1498), 1,
      anon_sym_DOLLAR,
    ACTIONS(1505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1510), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1512), 1,
      anon_sym_map,
    ACTIONS(1514), 1,
      anon_sym_bit_set,
    ACTIONS(1516), 1,
      anon_sym_matrix,
    ACTIONS(1518), 1,
      sym_tag,
    ACTIONS(9220), 1,
      anon_sym_LPAREN,
    ACTIONS(9222), 1,
      anon_sym_BANG,
    ACTIONS(9226), 1,
      anon_sym_CARET,
    ACTIONS(9242), 1,
      anon_sym_LBRACK,
    STATE(2852), 1,
      sym_procedure,
    STATE(2892), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2807), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [235536] = 22,
    ACTIONS(113), 1,
      anon_sym_distinct,
    ACTIONS(1059), 1,
      sym_identifier,
    ACTIONS(1061), 1,
      anon_sym_proc,
    ACTIONS(1063), 1,
      anon_sym_struct,
    ACTIONS(1065), 1,
      anon_sym_enum,
    ACTIONS(1067), 1,
      anon_sym_union,
    ACTIONS(1069), 1,
      anon_sym_bit_field,
    ACTIONS(1075), 1,
      anon_sym_DOLLAR,
    ACTIONS(1083), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1089), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1091), 1,
      anon_sym_map,
    ACTIONS(1093), 1,
      anon_sym_bit_set,
    ACTIONS(1095), 1,
      anon_sym_matrix,
    ACTIONS(1097), 1,
      sym_tag,
    ACTIONS(9162), 1,
      anon_sym_LPAREN,
    ACTIONS(9164), 1,
      anon_sym_BANG,
    ACTIONS(9166), 1,
      anon_sym_LBRACK,
    ACTIONS(9168), 1,
      anon_sym_CARET,
    STATE(2215), 1,
      sym_type,
    STATE(2239), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [235623] = 22,
    ACTIONS(47), 1,
      anon_sym_distinct,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2294), 1,
      anon_sym_proc,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2307), 1,
      anon_sym_DOLLAR,
    ACTIONS(2314), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2321), 1,
      anon_sym_map,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(2325), 1,
      anon_sym_matrix,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(9182), 1,
      anon_sym_LBRACK,
    ACTIONS(9184), 1,
      anon_sym_CARET,
    ACTIONS(9352), 1,
      sym_tag,
    STATE(3766), 1,
      sym_procedure,
    STATE(3989), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [235710] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9354), 1,
      sym_tag,
    STATE(6940), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [235797] = 22,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1181), 1,
      sym_identifier,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8844), 1,
      anon_sym_LBRACK,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8888), 1,
      sym_tag,
    STATE(2452), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [235884] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8900), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3117), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [235971] = 22,
    ACTIONS(1283), 1,
      anon_sym_distinct,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2584), 1,
      anon_sym_proc,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2597), 1,
      anon_sym_DOLLAR,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2611), 1,
      anon_sym_map,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2615), 1,
      anon_sym_matrix,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8918), 1,
      anon_sym_CARET,
    ACTIONS(8920), 1,
      sym_tag,
    ACTIONS(8976), 1,
      anon_sym_LBRACK,
    STATE(4267), 1,
      sym_type,
    STATE(4281), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [236058] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8196), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [236145] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(8083), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [236232] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    STATE(7094), 1,
      sym_procedure,
    STATE(7190), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [236319] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8393), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [236406] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8210), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [236493] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7865), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [236580] = 22,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8830), 1,
      sym_tag,
    ACTIONS(8850), 1,
      anon_sym_LBRACK,
    STATE(2978), 1,
      sym_procedure,
    STATE(3305), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [236667] = 22,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1181), 1,
      sym_identifier,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8844), 1,
      anon_sym_LBRACK,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8888), 1,
      sym_tag,
    STATE(2461), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [236754] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    STATE(3766), 1,
      sym_procedure,
    STATE(6778), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [236841] = 22,
    ACTIONS(1247), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(2770), 1,
      anon_sym_proc,
    ACTIONS(2772), 1,
      anon_sym_DOLLAR,
    ACTIONS(2777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2782), 1,
      anon_sym_map,
    ACTIONS(2784), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9104), 1,
      anon_sym_LBRACK,
    ACTIONS(9106), 1,
      anon_sym_CARET,
    ACTIONS(9120), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3117), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [236928] = 22,
    ACTIONS(2443), 1,
      sym_identifier,
    ACTIONS(2445), 1,
      anon_sym_proc,
    ACTIONS(2447), 1,
      anon_sym_struct,
    ACTIONS(2449), 1,
      anon_sym_enum,
    ACTIONS(2451), 1,
      anon_sym_union,
    ACTIONS(2453), 1,
      anon_sym_bit_field,
    ACTIONS(2458), 1,
      anon_sym_DOLLAR,
    ACTIONS(2465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2470), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2472), 1,
      anon_sym_map,
    ACTIONS(2474), 1,
      anon_sym_bit_set,
    ACTIONS(2476), 1,
      anon_sym_matrix,
    ACTIONS(2478), 1,
      anon_sym_distinct,
    ACTIONS(2480), 1,
      sym_tag,
    ACTIONS(9144), 1,
      anon_sym_LPAREN,
    ACTIONS(9146), 1,
      anon_sym_BANG,
    ACTIONS(9148), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_CARET,
    STATE(4202), 1,
      sym_type,
    STATE(4322), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4276), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [237015] = 22,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1181), 1,
      sym_identifier,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8844), 1,
      anon_sym_LBRACK,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8888), 1,
      sym_tag,
    STATE(2348), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [237102] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(8090), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [237189] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    ACTIONS(9142), 1,
      anon_sym_LBRACK,
    STATE(3887), 1,
      sym_procedure,
    STATE(7125), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [237276] = 22,
    ACTIONS(2443), 1,
      sym_identifier,
    ACTIONS(2445), 1,
      anon_sym_proc,
    ACTIONS(2447), 1,
      anon_sym_struct,
    ACTIONS(2449), 1,
      anon_sym_enum,
    ACTIONS(2451), 1,
      anon_sym_union,
    ACTIONS(2453), 1,
      anon_sym_bit_field,
    ACTIONS(2458), 1,
      anon_sym_DOLLAR,
    ACTIONS(2465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2470), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2472), 1,
      anon_sym_map,
    ACTIONS(2474), 1,
      anon_sym_bit_set,
    ACTIONS(2476), 1,
      anon_sym_matrix,
    ACTIONS(2478), 1,
      anon_sym_distinct,
    ACTIONS(2480), 1,
      sym_tag,
    ACTIONS(9144), 1,
      anon_sym_LPAREN,
    ACTIONS(9146), 1,
      anon_sym_BANG,
    ACTIONS(9148), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_CARET,
    STATE(4190), 1,
      sym_type,
    STATE(4322), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4276), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [237363] = 22,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1181), 1,
      sym_identifier,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8844), 1,
      anon_sym_LBRACK,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8888), 1,
      sym_tag,
    STATE(2364), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [237450] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8080), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [237537] = 22,
    ACTIONS(267), 1,
      anon_sym_distinct,
    ACTIONS(1375), 1,
      sym_identifier,
    ACTIONS(1377), 1,
      anon_sym_proc,
    ACTIONS(1379), 1,
      anon_sym_struct,
    ACTIONS(1381), 1,
      anon_sym_enum,
    ACTIONS(1383), 1,
      anon_sym_union,
    ACTIONS(1385), 1,
      anon_sym_bit_field,
    ACTIONS(1391), 1,
      anon_sym_DOLLAR,
    ACTIONS(1399), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1407), 1,
      anon_sym_map,
    ACTIONS(1409), 1,
      anon_sym_bit_set,
    ACTIONS(1411), 1,
      anon_sym_matrix,
    ACTIONS(1413), 1,
      sym_tag,
    ACTIONS(9174), 1,
      anon_sym_LPAREN,
    ACTIONS(9176), 1,
      anon_sym_BANG,
    ACTIONS(9178), 1,
      anon_sym_LBRACK,
    ACTIONS(9180), 1,
      anon_sym_CARET,
    STATE(2566), 1,
      sym_procedure,
    STATE(2599), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2607), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [237624] = 22,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8822), 1,
      sym_tag,
    STATE(4267), 1,
      sym_type,
    STATE(4281), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [237711] = 22,
    ACTIONS(2443), 1,
      sym_identifier,
    ACTIONS(2445), 1,
      anon_sym_proc,
    ACTIONS(2447), 1,
      anon_sym_struct,
    ACTIONS(2449), 1,
      anon_sym_enum,
    ACTIONS(2451), 1,
      anon_sym_union,
    ACTIONS(2453), 1,
      anon_sym_bit_field,
    ACTIONS(2458), 1,
      anon_sym_DOLLAR,
    ACTIONS(2465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2470), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2472), 1,
      anon_sym_map,
    ACTIONS(2474), 1,
      anon_sym_bit_set,
    ACTIONS(2476), 1,
      anon_sym_matrix,
    ACTIONS(2478), 1,
      anon_sym_distinct,
    ACTIONS(2480), 1,
      sym_tag,
    ACTIONS(9144), 1,
      anon_sym_LPAREN,
    ACTIONS(9146), 1,
      anon_sym_BANG,
    ACTIONS(9148), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_CARET,
    STATE(4180), 1,
      sym_type,
    STATE(4322), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4276), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [237798] = 22,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(9356), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6584), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [237885] = 22,
    ACTIONS(47), 1,
      anon_sym_distinct,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2294), 1,
      anon_sym_proc,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2307), 1,
      anon_sym_DOLLAR,
    ACTIONS(2314), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2321), 1,
      anon_sym_map,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(2325), 1,
      anon_sym_matrix,
    ACTIONS(2327), 1,
      sym_tag,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(9182), 1,
      anon_sym_LBRACK,
    ACTIONS(9184), 1,
      anon_sym_CARET,
    STATE(3766), 1,
      sym_procedure,
    STATE(4007), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [237972] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2143), 1,
      anon_sym_proc,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2156), 1,
      anon_sym_DOLLAR,
    ACTIONS(2163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2170), 1,
      anon_sym_map,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(2174), 1,
      anon_sym_matrix,
    ACTIONS(2176), 1,
      anon_sym_distinct,
    ACTIONS(2178), 1,
      sym_tag,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    ACTIONS(9156), 1,
      anon_sym_LBRACK,
    ACTIONS(9158), 1,
      anon_sym_CARET,
    STATE(3765), 1,
      sym_procedure,
    STATE(3834), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [238059] = 22,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8802), 1,
      sym_tag,
    STATE(3362), 1,
      sym_procedure,
    STATE(6589), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [238146] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2143), 1,
      anon_sym_proc,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2156), 1,
      anon_sym_DOLLAR,
    ACTIONS(2163), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2170), 1,
      anon_sym_map,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(2174), 1,
      anon_sym_matrix,
    ACTIONS(2176), 1,
      anon_sym_distinct,
    ACTIONS(2178), 1,
      sym_tag,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    ACTIONS(9156), 1,
      anon_sym_LBRACK,
    ACTIONS(9158), 1,
      anon_sym_CARET,
    STATE(3765), 1,
      sym_procedure,
    STATE(3913), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [238233] = 22,
    ACTIONS(47), 1,
      anon_sym_distinct,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2294), 1,
      anon_sym_proc,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2307), 1,
      anon_sym_DOLLAR,
    ACTIONS(2314), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2321), 1,
      anon_sym_map,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(2325), 1,
      anon_sym_matrix,
    ACTIONS(2327), 1,
      sym_tag,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(9182), 1,
      anon_sym_LBRACK,
    ACTIONS(9184), 1,
      anon_sym_CARET,
    STATE(3718), 1,
      sym_type,
    STATE(3766), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [238320] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9358), 1,
      sym_tag,
    STATE(6808), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [238407] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8205), 1,
      anon_sym_proc,
    ACTIONS(8207), 1,
      anon_sym_DOLLAR,
    ACTIONS(8209), 1,
      anon_sym_LBRACK,
    ACTIONS(8211), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8213), 1,
      anon_sym_CARET,
    ACTIONS(8215), 1,
      anon_sym_map,
    ACTIONS(8217), 1,
      anon_sym_matrix,
    ACTIONS(8219), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(9048), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(3117), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [238494] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    STATE(7094), 1,
      sym_procedure,
    STATE(7122), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [238581] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8233), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [238668] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7977), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [238755] = 22,
    ACTIONS(267), 1,
      anon_sym_distinct,
    ACTIONS(1375), 1,
      sym_identifier,
    ACTIONS(1377), 1,
      anon_sym_proc,
    ACTIONS(1379), 1,
      anon_sym_struct,
    ACTIONS(1381), 1,
      anon_sym_enum,
    ACTIONS(1383), 1,
      anon_sym_union,
    ACTIONS(1385), 1,
      anon_sym_bit_field,
    ACTIONS(1391), 1,
      anon_sym_DOLLAR,
    ACTIONS(1399), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1407), 1,
      anon_sym_map,
    ACTIONS(1409), 1,
      anon_sym_bit_set,
    ACTIONS(1411), 1,
      anon_sym_matrix,
    ACTIONS(1413), 1,
      sym_tag,
    ACTIONS(9174), 1,
      anon_sym_LPAREN,
    ACTIONS(9176), 1,
      anon_sym_BANG,
    ACTIONS(9178), 1,
      anon_sym_LBRACK,
    ACTIONS(9180), 1,
      anon_sym_CARET,
    STATE(2566), 1,
      sym_procedure,
    STATE(2741), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2607), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [238842] = 6,
    ACTIONS(7788), 1,
      sym_identifier,
    ACTIONS(7790), 1,
      anon_sym_LPAREN,
    ACTIONS(9360), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 16,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 20,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [238897] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9362), 1,
      sym_tag,
    STATE(6802), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [238984] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(6939), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [239071] = 22,
    ACTIONS(2443), 1,
      sym_identifier,
    ACTIONS(2445), 1,
      anon_sym_proc,
    ACTIONS(2447), 1,
      anon_sym_struct,
    ACTIONS(2449), 1,
      anon_sym_enum,
    ACTIONS(2451), 1,
      anon_sym_union,
    ACTIONS(2453), 1,
      anon_sym_bit_field,
    ACTIONS(2458), 1,
      anon_sym_DOLLAR,
    ACTIONS(2465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2470), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2472), 1,
      anon_sym_map,
    ACTIONS(2474), 1,
      anon_sym_bit_set,
    ACTIONS(2476), 1,
      anon_sym_matrix,
    ACTIONS(2478), 1,
      anon_sym_distinct,
    ACTIONS(2480), 1,
      sym_tag,
    ACTIONS(9144), 1,
      anon_sym_LPAREN,
    ACTIONS(9146), 1,
      anon_sym_BANG,
    ACTIONS(9148), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_CARET,
    STATE(4208), 1,
      sym_type,
    STATE(4322), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4276), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [239158] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7641), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [239245] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8103), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [239332] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8113), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [239419] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7928), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [239506] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7957), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [239593] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7935), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [239680] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7927), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [239767] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    STATE(3766), 1,
      sym_procedure,
    STATE(6780), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [239854] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7926), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [239941] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7897), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [240028] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9186), 1,
      anon_sym_LBRACK,
    STATE(6802), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [240115] = 22,
    ACTIONS(681), 1,
      anon_sym_distinct,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1921), 1,
      anon_sym_proc,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1935), 1,
      anon_sym_DOLLAR,
    ACTIONS(1943), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1951), 1,
      anon_sym_map,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(1955), 1,
      anon_sym_matrix,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8808), 1,
      anon_sym_LBRACK,
    ACTIONS(8810), 1,
      anon_sym_CARET,
    ACTIONS(8892), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3556), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [240202] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7889), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [240289] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7888), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [240376] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7856), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [240463] = 22,
    ACTIONS(1283), 1,
      anon_sym_distinct,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2584), 1,
      anon_sym_proc,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2597), 1,
      anon_sym_DOLLAR,
    ACTIONS(2604), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2611), 1,
      anon_sym_map,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(2615), 1,
      anon_sym_matrix,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8918), 1,
      anon_sym_CARET,
    ACTIONS(8920), 1,
      sym_tag,
    ACTIONS(8976), 1,
      anon_sym_LBRACK,
    STATE(4281), 1,
      sym_procedure,
    STATE(4361), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [240550] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8317), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [240637] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8305), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [240724] = 22,
    ACTIONS(267), 1,
      anon_sym_distinct,
    ACTIONS(1375), 1,
      sym_identifier,
    ACTIONS(1377), 1,
      anon_sym_proc,
    ACTIONS(1379), 1,
      anon_sym_struct,
    ACTIONS(1381), 1,
      anon_sym_enum,
    ACTIONS(1383), 1,
      anon_sym_union,
    ACTIONS(1385), 1,
      anon_sym_bit_field,
    ACTIONS(1391), 1,
      anon_sym_DOLLAR,
    ACTIONS(1399), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1405), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1407), 1,
      anon_sym_map,
    ACTIONS(1409), 1,
      anon_sym_bit_set,
    ACTIONS(1411), 1,
      anon_sym_matrix,
    ACTIONS(1413), 1,
      sym_tag,
    ACTIONS(9174), 1,
      anon_sym_LPAREN,
    ACTIONS(9176), 1,
      anon_sym_BANG,
    ACTIONS(9178), 1,
      anon_sym_LBRACK,
    ACTIONS(9180), 1,
      anon_sym_CARET,
    STATE(2566), 1,
      sym_procedure,
    STATE(2602), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2607), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [240811] = 22,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(9364), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(6594), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [240898] = 22,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1181), 1,
      sym_identifier,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8844), 1,
      anon_sym_LBRACK,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8888), 1,
      sym_tag,
    STATE(2432), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [240985] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8276), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [241072] = 22,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8876), 1,
      anon_sym_LBRACK,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8906), 1,
      sym_tag,
    STATE(3310), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [241159] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7847), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [241246] = 22,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8942), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(6600), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [241333] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7846), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [241420] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7307), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [241507] = 22,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(769), 1,
      sym_identifier,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8932), 1,
      anon_sym_LBRACK,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      sym_tag,
    STATE(860), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [241594] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9186), 1,
      anon_sym_LBRACK,
    STATE(6841), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [241681] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8266), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [241768] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8253), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [241855] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7814), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [241942] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    STATE(6975), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [242029] = 22,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(941), 1,
      anon_sym_proc,
    ACTIONS(943), 1,
      anon_sym_struct,
    ACTIONS(945), 1,
      anon_sym_enum,
    ACTIONS(947), 1,
      anon_sym_union,
    ACTIONS(949), 1,
      anon_sym_bit_field,
    ACTIONS(954), 1,
      anon_sym_DOLLAR,
    ACTIONS(961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(966), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(968), 1,
      anon_sym_map,
    ACTIONS(970), 1,
      anon_sym_bit_set,
    ACTIONS(972), 1,
      anon_sym_matrix,
    ACTIONS(974), 1,
      anon_sym_distinct,
    ACTIONS(976), 1,
      sym_tag,
    ACTIONS(9210), 1,
      anon_sym_LPAREN,
    ACTIONS(9212), 1,
      anon_sym_BANG,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9216), 1,
      anon_sym_CARET,
    STATE(2131), 1,
      sym_type,
    STATE(2134), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2167), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [242116] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 30,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [242165] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(9326), 1,
      sym_tag,
    STATE(3766), 1,
      sym_procedure,
    STATE(6931), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [242252] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    STATE(3766), 1,
      sym_procedure,
    STATE(6752), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [242339] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7805), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [242426] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7804), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [242513] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7772), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [242600] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8156), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [242687] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9366), 1,
      sym_tag,
    STATE(6847), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [242774] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(8086), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [242861] = 22,
    ACTIONS(2443), 1,
      sym_identifier,
    ACTIONS(2445), 1,
      anon_sym_proc,
    ACTIONS(2447), 1,
      anon_sym_struct,
    ACTIONS(2449), 1,
      anon_sym_enum,
    ACTIONS(2451), 1,
      anon_sym_union,
    ACTIONS(2453), 1,
      anon_sym_bit_field,
    ACTIONS(2458), 1,
      anon_sym_DOLLAR,
    ACTIONS(2465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2470), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2472), 1,
      anon_sym_map,
    ACTIONS(2474), 1,
      anon_sym_bit_set,
    ACTIONS(2476), 1,
      anon_sym_matrix,
    ACTIONS(2478), 1,
      anon_sym_distinct,
    ACTIONS(2480), 1,
      sym_tag,
    ACTIONS(9144), 1,
      anon_sym_LPAREN,
    ACTIONS(9146), 1,
      anon_sym_BANG,
    ACTIONS(9148), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_CARET,
    STATE(4322), 1,
      sym_procedure,
    STATE(4376), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4276), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [242948] = 22,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(941), 1,
      anon_sym_proc,
    ACTIONS(943), 1,
      anon_sym_struct,
    ACTIONS(945), 1,
      anon_sym_enum,
    ACTIONS(947), 1,
      anon_sym_union,
    ACTIONS(949), 1,
      anon_sym_bit_field,
    ACTIONS(954), 1,
      anon_sym_DOLLAR,
    ACTIONS(961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(966), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(968), 1,
      anon_sym_map,
    ACTIONS(970), 1,
      anon_sym_bit_set,
    ACTIONS(972), 1,
      anon_sym_matrix,
    ACTIONS(974), 1,
      anon_sym_distinct,
    ACTIONS(9210), 1,
      anon_sym_LPAREN,
    ACTIONS(9212), 1,
      anon_sym_BANG,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9216), 1,
      anon_sym_CARET,
    ACTIONS(9368), 1,
      sym_tag,
    STATE(2134), 1,
      sym_procedure,
    STATE(2166), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2167), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [243035] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7746), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [243122] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7745), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [243209] = 22,
    ACTIONS(1919), 1,
      sym_identifier,
    ACTIONS(1923), 1,
      anon_sym_struct,
    ACTIONS(1925), 1,
      anon_sym_enum,
    ACTIONS(1927), 1,
      anon_sym_union,
    ACTIONS(1929), 1,
      anon_sym_bit_field,
    ACTIONS(1949), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1953), 1,
      anon_sym_bit_set,
    ACTIONS(7375), 1,
      anon_sym_proc,
    ACTIONS(7377), 1,
      anon_sym_DOLLAR,
    ACTIONS(7379), 1,
      anon_sym_BANG,
    ACTIONS(7381), 1,
      anon_sym_LBRACK,
    ACTIONS(7383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7385), 1,
      anon_sym_CARET,
    ACTIONS(7387), 1,
      anon_sym_map,
    ACTIONS(7389), 1,
      anon_sym_matrix,
    ACTIONS(7391), 1,
      anon_sym_distinct,
    ACTIONS(8806), 1,
      anon_sym_LPAREN,
    ACTIONS(8942), 1,
      sym_tag,
    STATE(3475), 1,
      sym_procedure,
    STATE(3556), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3599), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [243296] = 22,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_struct,
    ACTIONS(2147), 1,
      anon_sym_enum,
    ACTIONS(2149), 1,
      anon_sym_union,
    ACTIONS(2151), 1,
      anon_sym_bit_field,
    ACTIONS(2168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2172), 1,
      anon_sym_bit_set,
    ACTIONS(7838), 1,
      anon_sym_proc,
    ACTIONS(7840), 1,
      anon_sym_DOLLAR,
    ACTIONS(7842), 1,
      anon_sym_BANG,
    ACTIONS(7844), 1,
      anon_sym_LBRACK,
    ACTIONS(7846), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7848), 1,
      anon_sym_CARET,
    ACTIONS(7850), 1,
      anon_sym_map,
    ACTIONS(7852), 1,
      anon_sym_matrix,
    ACTIONS(7854), 1,
      anon_sym_distinct,
    ACTIONS(7856), 1,
      sym_tag,
    ACTIONS(8133), 1,
      anon_sym_LPAREN,
    STATE(3765), 1,
      sym_procedure,
    STATE(3834), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3753), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [243383] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7971), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [243470] = 22,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(941), 1,
      anon_sym_proc,
    ACTIONS(943), 1,
      anon_sym_struct,
    ACTIONS(945), 1,
      anon_sym_enum,
    ACTIONS(947), 1,
      anon_sym_union,
    ACTIONS(949), 1,
      anon_sym_bit_field,
    ACTIONS(954), 1,
      anon_sym_DOLLAR,
    ACTIONS(961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(966), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(968), 1,
      anon_sym_map,
    ACTIONS(970), 1,
      anon_sym_bit_set,
    ACTIONS(972), 1,
      anon_sym_matrix,
    ACTIONS(974), 1,
      anon_sym_distinct,
    ACTIONS(976), 1,
      sym_tag,
    ACTIONS(9210), 1,
      anon_sym_LPAREN,
    ACTIONS(9212), 1,
      anon_sym_BANG,
    ACTIONS(9214), 1,
      anon_sym_LBRACK,
    ACTIONS(9216), 1,
      anon_sym_CARET,
    STATE(2134), 1,
      sym_procedure,
    STATE(2162), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2167), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [243557] = 5,
    ACTIONS(7870), 1,
      sym_identifier,
    ACTIONS(7872), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 16,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 21,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DASH_GT,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [243610] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    ACTIONS(9186), 1,
      anon_sym_LBRACK,
    STATE(6847), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [243697] = 22,
    ACTIONS(649), 1,
      anon_sym_distinct,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2245), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2258), 1,
      anon_sym_DOLLAR,
    ACTIONS(2265), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2272), 1,
      anon_sym_map,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2276), 1,
      anon_sym_matrix,
    ACTIONS(2278), 1,
      sym_tag,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(9304), 1,
      anon_sym_LBRACK,
    ACTIONS(9306), 1,
      anon_sym_CARET,
    STATE(3880), 1,
      sym_type,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [243784] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7958), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [243871] = 22,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(7342), 1,
      anon_sym_proc,
    ACTIONS(7344), 1,
      anon_sym_DOLLAR,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(7348), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7352), 1,
      anon_sym_CARET,
    ACTIONS(7354), 1,
      anon_sym_map,
    ACTIONS(7356), 1,
      anon_sym_matrix,
    ACTIONS(7358), 1,
      anon_sym_distinct,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8802), 1,
      sym_tag,
    STATE(3310), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [243958] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7624), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [244045] = 22,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8822), 1,
      sym_tag,
    STATE(4281), 1,
      sym_procedure,
    STATE(6740), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [244132] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7737), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [244219] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7716), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [244306] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 30,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [244355] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7941), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [244442] = 22,
    ACTIONS(359), 1,
      anon_sym_distinct,
    ACTIONS(1483), 1,
      sym_identifier,
    ACTIONS(1485), 1,
      anon_sym_proc,
    ACTIONS(1487), 1,
      anon_sym_struct,
    ACTIONS(1489), 1,
      anon_sym_enum,
    ACTIONS(1491), 1,
      anon_sym_union,
    ACTIONS(1493), 1,
      anon_sym_bit_field,
    ACTIONS(1498), 1,
      anon_sym_DOLLAR,
    ACTIONS(1505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1510), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1512), 1,
      anon_sym_map,
    ACTIONS(1514), 1,
      anon_sym_bit_set,
    ACTIONS(1516), 1,
      anon_sym_matrix,
    ACTIONS(1518), 1,
      sym_tag,
    ACTIONS(9220), 1,
      anon_sym_LPAREN,
    ACTIONS(9222), 1,
      anon_sym_BANG,
    ACTIONS(9226), 1,
      anon_sym_CARET,
    ACTIONS(9242), 1,
      anon_sym_LBRACK,
    STATE(2851), 1,
      sym_type,
    STATE(2852), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2807), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [244529] = 22,
    ACTIONS(579), 1,
      anon_sym_distinct,
    ACTIONS(1713), 1,
      sym_identifier,
    ACTIONS(1715), 1,
      anon_sym_proc,
    ACTIONS(1717), 1,
      anon_sym_struct,
    ACTIONS(1719), 1,
      anon_sym_enum,
    ACTIONS(1721), 1,
      anon_sym_union,
    ACTIONS(1723), 1,
      anon_sym_bit_field,
    ACTIONS(1728), 1,
      anon_sym_DOLLAR,
    ACTIONS(1735), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1740), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1742), 1,
      anon_sym_map,
    ACTIONS(1744), 1,
      anon_sym_bit_set,
    ACTIONS(1746), 1,
      anon_sym_matrix,
    ACTIONS(7346), 1,
      anon_sym_BANG,
    ACTIONS(8798), 1,
      anon_sym_LPAREN,
    ACTIONS(8876), 1,
      anon_sym_LBRACK,
    ACTIONS(8878), 1,
      anon_sym_CARET,
    ACTIONS(8906), 1,
      sym_tag,
    STATE(3323), 1,
      sym_type,
    STATE(3362), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3369), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [244616] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7715), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [244703] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7763), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [244790] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7669), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [244877] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7667), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [244964] = 22,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(8822), 1,
      sym_tag,
    STATE(4281), 1,
      sym_procedure,
    STATE(6736), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [245051] = 22,
    ACTIONS(8360), 1,
      sym_identifier,
    ACTIONS(8362), 1,
      anon_sym_proc,
    ACTIONS(8364), 1,
      anon_sym_struct,
    ACTIONS(8366), 1,
      anon_sym_enum,
    ACTIONS(8368), 1,
      anon_sym_union,
    ACTIONS(8370), 1,
      anon_sym_bit_field,
    ACTIONS(8376), 1,
      anon_sym_DOLLAR,
    ACTIONS(8378), 1,
      anon_sym_BANG,
    ACTIONS(8380), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8384), 1,
      anon_sym_CARET,
    ACTIONS(8386), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8388), 1,
      anon_sym_map,
    ACTIONS(8390), 1,
      anon_sym_bit_set,
    ACTIONS(8392), 1,
      anon_sym_matrix,
    ACTIONS(8394), 1,
      anon_sym_distinct,
    ACTIONS(8396), 1,
      sym_tag,
    ACTIONS(9152), 1,
      anon_sym_LPAREN,
    STATE(7053), 1,
      sym_type,
    STATE(7094), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7164), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [245138] = 22,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2586), 1,
      anon_sym_struct,
    ACTIONS(2588), 1,
      anon_sym_enum,
    ACTIONS(2590), 1,
      anon_sym_union,
    ACTIONS(2592), 1,
      anon_sym_bit_field,
    ACTIONS(2609), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2613), 1,
      anon_sym_bit_set,
    ACTIONS(7796), 1,
      anon_sym_proc,
    ACTIONS(7798), 1,
      anon_sym_DOLLAR,
    ACTIONS(7800), 1,
      anon_sym_BANG,
    ACTIONS(7802), 1,
      anon_sym_LBRACK,
    ACTIONS(7804), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7806), 1,
      anon_sym_CARET,
    ACTIONS(7808), 1,
      anon_sym_map,
    ACTIONS(7810), 1,
      anon_sym_matrix,
    ACTIONS(7812), 1,
      anon_sym_distinct,
    ACTIONS(8818), 1,
      anon_sym_LPAREN,
    ACTIONS(9370), 1,
      sym_tag,
    STATE(4281), 1,
      sym_procedure,
    STATE(6735), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4209), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [245225] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5694), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(5692), 30,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_do,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [245274] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7762), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [245361] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7730), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [245448] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7721), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [245535] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7720), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [245622] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7706), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [245709] = 22,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(769), 1,
      sym_identifier,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8932), 1,
      anon_sym_LBRACK,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(9372), 1,
      sym_tag,
    STATE(1029), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [245796] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7968), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [245883] = 22,
    ACTIONS(2443), 1,
      sym_identifier,
    ACTIONS(2445), 1,
      anon_sym_proc,
    ACTIONS(2447), 1,
      anon_sym_struct,
    ACTIONS(2449), 1,
      anon_sym_enum,
    ACTIONS(2451), 1,
      anon_sym_union,
    ACTIONS(2453), 1,
      anon_sym_bit_field,
    ACTIONS(2458), 1,
      anon_sym_DOLLAR,
    ACTIONS(2465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2470), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2472), 1,
      anon_sym_map,
    ACTIONS(2474), 1,
      anon_sym_bit_set,
    ACTIONS(2476), 1,
      anon_sym_matrix,
    ACTIONS(2478), 1,
      anon_sym_distinct,
    ACTIONS(2480), 1,
      sym_tag,
    ACTIONS(9144), 1,
      anon_sym_LPAREN,
    ACTIONS(9146), 1,
      anon_sym_BANG,
    ACTIONS(9148), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_CARET,
    STATE(4271), 1,
      sym_type,
    STATE(4322), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4276), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [245970] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(8481), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(3907), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [246057] = 22,
    ACTIONS(2443), 1,
      sym_identifier,
    ACTIONS(2445), 1,
      anon_sym_proc,
    ACTIONS(2447), 1,
      anon_sym_struct,
    ACTIONS(2449), 1,
      anon_sym_enum,
    ACTIONS(2451), 1,
      anon_sym_union,
    ACTIONS(2453), 1,
      anon_sym_bit_field,
    ACTIONS(2458), 1,
      anon_sym_DOLLAR,
    ACTIONS(2465), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2470), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2472), 1,
      anon_sym_map,
    ACTIONS(2474), 1,
      anon_sym_bit_set,
    ACTIONS(2476), 1,
      anon_sym_matrix,
    ACTIONS(2478), 1,
      anon_sym_distinct,
    ACTIONS(9144), 1,
      anon_sym_LPAREN,
    ACTIONS(9146), 1,
      anon_sym_BANG,
    ACTIONS(9148), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_CARET,
    ACTIONS(9374), 1,
      sym_tag,
    STATE(4204), 1,
      sym_type,
    STATE(4322), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(4276), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [246144] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7662), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [246231] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7705), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [246318] = 22,
    ACTIONS(535), 1,
      anon_sym_distinct,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1677), 1,
      anon_sym_proc,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1690), 1,
      anon_sym_DOLLAR,
    ACTIONS(1697), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1704), 1,
      anon_sym_map,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(1708), 1,
      anon_sym_matrix,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8828), 1,
      anon_sym_CARET,
    ACTIONS(8830), 1,
      sym_tag,
    ACTIONS(8850), 1,
      anon_sym_LBRACK,
    STATE(2978), 1,
      sym_procedure,
    STATE(3117), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [246405] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7649), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [246492] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7685), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [246579] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(8240), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [246666] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7690), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [246753] = 22,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(769), 1,
      sym_identifier,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8932), 1,
      anon_sym_LBRACK,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      sym_tag,
    STATE(1020), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [246840] = 22,
    ACTIONS(939), 1,
      sym_identifier,
    ACTIONS(941), 1,
      anon_sym_proc,
    ACTIONS(943), 1,
      anon_sym_struct,
    ACTIONS(945), 1,
      anon_sym_enum,
    ACTIONS(947), 1,
      anon_sym_union,
    ACTIONS(949), 1,
      anon_sym_bit_field,
    ACTIONS(954), 1,
      anon_sym_DOLLAR,
    ACTIONS(961), 1,
      anon_sym_DOT_DOT,
    ACTIONS(966), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(968), 1,
      anon_sym_map,
    ACTIONS(970), 1,
      anon_sym_bit_set,
    ACTIONS(972), 1,
      anon_sym_matrix,
    ACTIONS(974), 1,
      anon_sym_distinct,
    ACTIONS(976), 1,
      sym_tag,
    ACTIONS(9210), 1,
      anon_sym_LPAREN,
    ACTIONS(9212), 1,
      anon_sym_BANG,
    ACTIONS(9216), 1,
      anon_sym_CARET,
    ACTIONS(9376), 1,
      anon_sym_LBRACK,
    STATE(2134), 1,
      sym_procedure,
    STATE(2161), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2167), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [246927] = 22,
    ACTIONS(149), 1,
      anon_sym_distinct,
    ACTIONS(769), 1,
      sym_identifier,
    ACTIONS(771), 1,
      anon_sym_proc,
    ACTIONS(775), 1,
      anon_sym_struct,
    ACTIONS(777), 1,
      anon_sym_enum,
    ACTIONS(779), 1,
      anon_sym_union,
    ACTIONS(781), 1,
      anon_sym_bit_field,
    ACTIONS(786), 1,
      anon_sym_DOLLAR,
    ACTIONS(793), 1,
      anon_sym_DOT_DOT,
    ACTIONS(798), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(800), 1,
      anon_sym_map,
    ACTIONS(802), 1,
      anon_sym_bit_set,
    ACTIONS(804), 1,
      anon_sym_matrix,
    ACTIONS(8928), 1,
      anon_sym_LPAREN,
    ACTIONS(8930), 1,
      anon_sym_BANG,
    ACTIONS(8932), 1,
      anon_sym_LBRACK,
    ACTIONS(8934), 1,
      anon_sym_CARET,
    ACTIONS(9000), 1,
      sym_tag,
    STATE(982), 1,
      sym_type,
    STATE(1064), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(1032), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [247014] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7608), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [247101] = 22,
    ACTIONS(359), 1,
      anon_sym_distinct,
    ACTIONS(1483), 1,
      sym_identifier,
    ACTIONS(1485), 1,
      anon_sym_proc,
    ACTIONS(1487), 1,
      anon_sym_struct,
    ACTIONS(1489), 1,
      anon_sym_enum,
    ACTIONS(1491), 1,
      anon_sym_union,
    ACTIONS(1493), 1,
      anon_sym_bit_field,
    ACTIONS(1498), 1,
      anon_sym_DOLLAR,
    ACTIONS(1505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1510), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1512), 1,
      anon_sym_map,
    ACTIONS(1514), 1,
      anon_sym_bit_set,
    ACTIONS(1516), 1,
      anon_sym_matrix,
    ACTIONS(9220), 1,
      anon_sym_LPAREN,
    ACTIONS(9222), 1,
      anon_sym_BANG,
    ACTIONS(9226), 1,
      anon_sym_CARET,
    ACTIONS(9242), 1,
      anon_sym_LBRACK,
    ACTIONS(9378), 1,
      sym_tag,
    STATE(2842), 1,
      sym_type,
    STATE(2852), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2807), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [247188] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7676), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [247275] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7609), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [247362] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    ACTIONS(9322), 1,
      anon_sym_LBRACK,
    STATE(3887), 1,
      sym_procedure,
    STATE(7247), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [247449] = 22,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(8465), 1,
      anon_sym_proc,
    ACTIONS(8467), 1,
      anon_sym_DOLLAR,
    ACTIONS(8469), 1,
      anon_sym_LBRACK,
    ACTIONS(8471), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8473), 1,
      anon_sym_CARET,
    ACTIONS(8475), 1,
      anon_sym_map,
    ACTIONS(8477), 1,
      anon_sym_matrix,
    ACTIONS(8479), 1,
      anon_sym_distinct,
    ACTIONS(9380), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(7125), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [247536] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7951), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [247623] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    STATE(3766), 1,
      sym_procedure,
    STATE(6846), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [247710] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7675), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [247797] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7615), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [247884] = 22,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1181), 1,
      sym_identifier,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8844), 1,
      anon_sym_LBRACK,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(8888), 1,
      sym_tag,
    STATE(2467), 1,
      sym_procedure,
    STATE(2476), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [247971] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(9206), 1,
      anon_sym_LBRACK,
    STATE(3766), 1,
      sym_procedure,
    STATE(6742), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [248058] = 22,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1679), 1,
      anon_sym_struct,
    ACTIONS(1681), 1,
      anon_sym_enum,
    ACTIONS(1683), 1,
      anon_sym_union,
    ACTIONS(1685), 1,
      anon_sym_bit_field,
    ACTIONS(1702), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1706), 1,
      anon_sym_bit_set,
    ACTIONS(7444), 1,
      anon_sym_proc,
    ACTIONS(7446), 1,
      anon_sym_DOLLAR,
    ACTIONS(7448), 1,
      anon_sym_BANG,
    ACTIONS(7450), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7454), 1,
      anon_sym_CARET,
    ACTIONS(7456), 1,
      anon_sym_map,
    ACTIONS(7458), 1,
      anon_sym_matrix,
    ACTIONS(7460), 1,
      anon_sym_distinct,
    ACTIONS(8790), 1,
      anon_sym_LPAREN,
    ACTIONS(8900), 1,
      sym_tag,
    STATE(2978), 1,
      sym_procedure,
    STATE(6616), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2982), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [248145] = 22,
    ACTIONS(597), 1,
      anon_sym_proc,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(7682), 1,
      anon_sym_DOLLAR,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(7686), 1,
      anon_sym_LBRACK,
    ACTIONS(7688), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7690), 1,
      anon_sym_CARET,
    ACTIONS(7692), 1,
      anon_sym_map,
    ACTIONS(7694), 1,
      anon_sym_matrix,
    ACTIONS(7696), 1,
      anon_sym_distinct,
    ACTIONS(7698), 1,
      sym_tag,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    STATE(3766), 1,
      sym_procedure,
    STATE(3896), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [248232] = 22,
    ACTIONS(359), 1,
      anon_sym_distinct,
    ACTIONS(1483), 1,
      sym_identifier,
    ACTIONS(1485), 1,
      anon_sym_proc,
    ACTIONS(1487), 1,
      anon_sym_struct,
    ACTIONS(1489), 1,
      anon_sym_enum,
    ACTIONS(1491), 1,
      anon_sym_union,
    ACTIONS(1493), 1,
      anon_sym_bit_field,
    ACTIONS(1498), 1,
      anon_sym_DOLLAR,
    ACTIONS(1505), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1510), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1512), 1,
      anon_sym_map,
    ACTIONS(1514), 1,
      anon_sym_bit_set,
    ACTIONS(1516), 1,
      anon_sym_matrix,
    ACTIONS(1518), 1,
      sym_tag,
    ACTIONS(9220), 1,
      anon_sym_LPAREN,
    ACTIONS(9222), 1,
      anon_sym_BANG,
    ACTIONS(9226), 1,
      anon_sym_CARET,
    ACTIONS(9242), 1,
      anon_sym_LBRACK,
    STATE(2771), 1,
      sym_type,
    STATE(2852), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2807), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [248319] = 22,
    ACTIONS(649), 1,
      anon_sym_distinct,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2245), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2258), 1,
      anon_sym_DOLLAR,
    ACTIONS(2265), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2272), 1,
      anon_sym_map,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2276), 1,
      anon_sym_matrix,
    ACTIONS(2278), 1,
      sym_tag,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(9304), 1,
      anon_sym_LBRACK,
    ACTIONS(9306), 1,
      anon_sym_CARET,
    STATE(3887), 1,
      sym_procedure,
    STATE(4057), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [248406] = 22,
    ACTIONS(225), 1,
      anon_sym_distinct,
    ACTIONS(1181), 1,
      sym_identifier,
    ACTIONS(1183), 1,
      anon_sym_proc,
    ACTIONS(1185), 1,
      anon_sym_struct,
    ACTIONS(1187), 1,
      anon_sym_enum,
    ACTIONS(1189), 1,
      anon_sym_union,
    ACTIONS(1191), 1,
      anon_sym_bit_field,
    ACTIONS(1197), 1,
      anon_sym_DOLLAR,
    ACTIONS(1205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1211), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1213), 1,
      anon_sym_map,
    ACTIONS(1215), 1,
      anon_sym_bit_set,
    ACTIONS(1217), 1,
      anon_sym_matrix,
    ACTIONS(8840), 1,
      anon_sym_LPAREN,
    ACTIONS(8842), 1,
      anon_sym_BANG,
    ACTIONS(8844), 1,
      anon_sym_LBRACK,
    ACTIONS(8846), 1,
      anon_sym_CARET,
    ACTIONS(9382), 1,
      sym_tag,
    STATE(2444), 1,
      sym_type,
    STATE(2467), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(2470), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [248493] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7625), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [248580] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7626), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [248667] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7635), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [248754] = 22,
    ACTIONS(47), 1,
      anon_sym_distinct,
    ACTIONS(2292), 1,
      sym_identifier,
    ACTIONS(2294), 1,
      anon_sym_proc,
    ACTIONS(2296), 1,
      anon_sym_struct,
    ACTIONS(2298), 1,
      anon_sym_enum,
    ACTIONS(2300), 1,
      anon_sym_union,
    ACTIONS(2302), 1,
      anon_sym_bit_field,
    ACTIONS(2307), 1,
      anon_sym_DOLLAR,
    ACTIONS(2314), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2319), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2321), 1,
      anon_sym_map,
    ACTIONS(2323), 1,
      anon_sym_bit_set,
    ACTIONS(2325), 1,
      anon_sym_matrix,
    ACTIONS(2327), 1,
      sym_tag,
    ACTIONS(7684), 1,
      anon_sym_BANG,
    ACTIONS(8002), 1,
      anon_sym_LPAREN,
    ACTIONS(9182), 1,
      anon_sym_LBRACK,
    ACTIONS(9184), 1,
      anon_sym_CARET,
    STATE(3766), 1,
      sym_procedure,
    STATE(3778), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3920), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [248841] = 22,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(4784), 1,
      anon_sym_DOLLAR,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(6463), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6465), 1,
      anon_sym_CARET,
    ACTIONS(6473), 1,
      anon_sym_distinct,
    ACTIONS(6475), 1,
      sym_tag,
    ACTIONS(7738), 1,
      anon_sym_LBRACK,
    ACTIONS(7740), 1,
      anon_sym_map,
    ACTIONS(7742), 1,
      anon_sym_matrix,
    STATE(3887), 1,
      sym_procedure,
    STATE(7636), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [248928] = 22,
    ACTIONS(649), 1,
      anon_sym_distinct,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2245), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2258), 1,
      anon_sym_DOLLAR,
    ACTIONS(2265), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2272), 1,
      anon_sym_map,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2276), 1,
      anon_sym_matrix,
    ACTIONS(2278), 1,
      sym_tag,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(9304), 1,
      anon_sym_LBRACK,
    ACTIONS(9306), 1,
      anon_sym_CARET,
    STATE(3887), 1,
      sym_procedure,
    STATE(4001), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [249015] = 22,
    ACTIONS(649), 1,
      anon_sym_distinct,
    ACTIONS(2243), 1,
      sym_identifier,
    ACTIONS(2245), 1,
      anon_sym_proc,
    ACTIONS(2247), 1,
      anon_sym_struct,
    ACTIONS(2249), 1,
      anon_sym_enum,
    ACTIONS(2251), 1,
      anon_sym_union,
    ACTIONS(2253), 1,
      anon_sym_bit_field,
    ACTIONS(2258), 1,
      anon_sym_DOLLAR,
    ACTIONS(2265), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2270), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2272), 1,
      anon_sym_map,
    ACTIONS(2274), 1,
      anon_sym_bit_set,
    ACTIONS(2276), 1,
      anon_sym_matrix,
    ACTIONS(6457), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      anon_sym_BANG,
    ACTIONS(9304), 1,
      anon_sym_LBRACK,
    ACTIONS(9306), 1,
      anon_sym_CARET,
    ACTIONS(9384), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(3922), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3772), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [249102] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7659), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [249189] = 22,
    ACTIONS(1973), 1,
      sym_identifier,
    ACTIONS(1977), 1,
      anon_sym_struct,
    ACTIONS(1979), 1,
      anon_sym_enum,
    ACTIONS(1981), 1,
      anon_sym_union,
    ACTIONS(1983), 1,
      anon_sym_bit_field,
    ACTIONS(2003), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2007), 1,
      anon_sym_bit_set,
    ACTIONS(8262), 1,
      anon_sym_proc,
    ACTIONS(8264), 1,
      anon_sym_DOLLAR,
    ACTIONS(8266), 1,
      anon_sym_BANG,
    ACTIONS(8268), 1,
      anon_sym_LBRACK,
    ACTIONS(8270), 1,
      anon_sym_DOT_DOT,
    ACTIONS(8272), 1,
      anon_sym_CARET,
    ACTIONS(8274), 1,
      anon_sym_map,
    ACTIONS(8276), 1,
      anon_sym_matrix,
    ACTIONS(8278), 1,
      anon_sym_distinct,
    ACTIONS(8280), 1,
      sym_tag,
    ACTIONS(8629), 1,
      anon_sym_LPAREN,
    STATE(3690), 1,
      sym_procedure,
    STATE(7660), 1,
      sym_type,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(3686), 19,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_map_type,
      sym_union_type,
      sym_bit_set_type,
      sym_matrix_type,
      sym_field_type,
      sym_tuple_type,
      sym_struct_type,
      sym_enum_type,
      sym_bit_field_type,
      sym_constant_type,
      sym_specialized_type,
      sym__procedure_type,
      sym_distinct_type,
      sym_empty_type,
      sym_polymorphic_type,
      sym_conditional_type,
  [249276] = 4,
    ACTIONS(9386), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [249326] = 4,
    ACTIONS(9388), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [249376] = 4,
    ACTIONS(9391), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [249426] = 4,
    ACTIONS(9393), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [249476] = 4,
    ACTIONS(9395), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [249526] = 4,
    ACTIONS(4057), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [249576] = 4,
    ACTIONS(3455), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [249626] = 4,
    ACTIONS(9397), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [249676] = 4,
    ACTIONS(4367), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [249726] = 4,
    ACTIONS(3565), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [249776] = 4,
    ACTIONS(9399), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [249826] = 4,
    ACTIONS(9401), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [249876] = 4,
    ACTIONS(9403), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [249926] = 4,
    ACTIONS(9405), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [249976] = 4,
    ACTIONS(9407), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250026] = 4,
    ACTIONS(9409), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250076] = 4,
    ACTIONS(3505), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250126] = 4,
    ACTIONS(9411), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250176] = 4,
    ACTIONS(9413), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250226] = 4,
    ACTIONS(9415), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250276] = 4,
    ACTIONS(9417), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250326] = 4,
    ACTIONS(9419), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250376] = 4,
    ACTIONS(9421), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250426] = 4,
    ACTIONS(9423), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250476] = 4,
    ACTIONS(9425), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250526] = 4,
    ACTIONS(3545), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250576] = 4,
    ACTIONS(9427), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250626] = 4,
    ACTIONS(9429), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250676] = 4,
    ACTIONS(9431), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250726] = 4,
    ACTIONS(9433), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250776] = 4,
    ACTIONS(9435), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250826] = 4,
    ACTIONS(4245), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250876] = 4,
    ACTIONS(9437), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250926] = 4,
    ACTIONS(3615), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [250976] = 4,
    ACTIONS(4137), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251026] = 4,
    ACTIONS(3685), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251076] = 4,
    ACTIONS(9439), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251126] = 4,
    ACTIONS(9441), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251176] = 4,
    ACTIONS(9443), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251226] = 4,
    ACTIONS(9445), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251276] = 4,
    ACTIONS(9447), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251326] = 4,
    ACTIONS(3465), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251376] = 4,
    ACTIONS(9449), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251426] = 4,
    ACTIONS(9451), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251476] = 29,
    ACTIONS(7127), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7888), 1,
      anon_sym_DASH_GT,
    ACTIONS(7890), 1,
      anon_sym_DOT,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7900), 1,
      anon_sym_PLUS,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_TILDE,
    ACTIONS(7906), 1,
      anon_sym_AMP,
    ACTIONS(7908), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7922), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7934), 1,
      anon_sym_or_break,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(9455), 1,
      anon_sym_COLON,
    ACTIONS(9457), 1,
      anon_sym_COLON_EQ,
    STATE(7305), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7894), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7910), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7912), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7914), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7918), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(7920), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7924), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7926), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7928), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [251576] = 4,
    ACTIONS(9459), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251626] = 4,
    ACTIONS(9461), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251676] = 4,
    ACTIONS(9463), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251726] = 4,
    ACTIONS(9465), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251776] = 4,
    ACTIONS(9467), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251826] = 4,
    ACTIONS(9469), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251876] = 4,
    ACTIONS(9471), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251926] = 4,
    ACTIONS(3725), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [251976] = 4,
    ACTIONS(9473), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252026] = 4,
    ACTIONS(9475), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252076] = 4,
    ACTIONS(9477), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252126] = 4,
    ACTIONS(9479), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252176] = 4,
    ACTIONS(9481), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252226] = 4,
    ACTIONS(9483), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252276] = 4,
    ACTIONS(9485), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252326] = 4,
    ACTIONS(4502), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252376] = 4,
    ACTIONS(9487), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252426] = 4,
    ACTIONS(3765), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252476] = 4,
    ACTIONS(9489), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252526] = 4,
    ACTIONS(9491), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252576] = 4,
    ACTIONS(9493), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252626] = 4,
    ACTIONS(9495), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252676] = 4,
    ACTIONS(3825), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252726] = 4,
    ACTIONS(9497), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252776] = 4,
    ACTIONS(9499), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252826] = 4,
    ACTIONS(9501), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252876] = 4,
    ACTIONS(9503), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252926] = 4,
    ACTIONS(9505), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [252976] = 4,
    ACTIONS(9508), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253026] = 4,
    ACTIONS(9510), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253076] = 26,
    ACTIONS(7642), 1,
      anon_sym_COLON,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(7640), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
  [253170] = 4,
    ACTIONS(9513), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253220] = 4,
    ACTIONS(9515), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253270] = 4,
    ACTIONS(9517), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253320] = 4,
    ACTIONS(3655), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253370] = 4,
    ACTIONS(9519), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253420] = 4,
    ACTIONS(9521), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253470] = 4,
    ACTIONS(9523), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253520] = 4,
    ACTIONS(9525), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253570] = 4,
    ACTIONS(9527), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253620] = 4,
    ACTIONS(9529), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253670] = 4,
    ACTIONS(3885), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253720] = 4,
    ACTIONS(9531), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253770] = 4,
    ACTIONS(9534), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253820] = 4,
    ACTIONS(9536), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253870] = 4,
    ACTIONS(9538), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253920] = 4,
    ACTIONS(9540), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [253970] = 4,
    ACTIONS(9542), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [254020] = 4,
    ACTIONS(9544), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [254070] = 4,
    ACTIONS(9546), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [254120] = 29,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9292), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(9548), 1,
      anon_sym_COLON,
    ACTIONS(9550), 1,
      anon_sym_COLON_EQ,
    STATE(7227), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [254220] = 4,
    ACTIONS(3735), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [254270] = 4,
    ACTIONS(9552), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [254320] = 4,
    ACTIONS(9554), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [254370] = 4,
    ACTIONS(3967), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [254420] = 4,
    ACTIONS(9556), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [254470] = 4,
    ACTIONS(9559), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [254520] = 4,
    ACTIONS(9561), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [254570] = 4,
    ACTIONS(9563), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [254620] = 4,
    ACTIONS(9565), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [254670] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8756), 1,
      anon_sym_COMMA,
    STATE(6862), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(9567), 3,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [254766] = 4,
    ACTIONS(9569), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [254816] = 4,
    ACTIONS(4007), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [254866] = 4,
    ACTIONS(9571), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [254916] = 4,
    ACTIONS(9573), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [254966] = 4,
    ACTIONS(9575), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [255016] = 4,
    ACTIONS(9577), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [255066] = 29,
    ACTIONS(7133), 1,
      anon_sym_COLON_EQ,
    ACTIONS(7282), 1,
      anon_sym_EQ,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    ACTIONS(9580), 1,
      anon_sym_LBRACE,
    STATE(7546), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [255166] = 4,
    ACTIONS(9582), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [255216] = 4,
    ACTIONS(9584), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [255266] = 4,
    ACTIONS(9586), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [255316] = 4,
    ACTIONS(4097), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [255366] = 4,
    ACTIONS(9588), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [255416] = 4,
    ACTIONS(9590), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [255466] = 4,
    ACTIONS(9592), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [255516] = 4,
    ACTIONS(9594), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [255566] = 4,
    ACTIONS(9596), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [255616] = 4,
    ACTIONS(9598), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [255666] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(9600), 1,
      anon_sym_COMMA,
    STATE(7244), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3387), 3,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [255762] = 4,
    ACTIONS(4411), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [255812] = 4,
    ACTIONS(9602), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [255862] = 4,
    ACTIONS(9604), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [255912] = 4,
    ACTIONS(9606), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [255962] = 4,
    ACTIONS(9609), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [256012] = 4,
    ACTIONS(9611), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [256062] = 29,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    ACTIONS(9613), 1,
      anon_sym_EQ,
    ACTIONS(9615), 1,
      anon_sym_COLON,
    ACTIONS(9617), 1,
      anon_sym_COLON_EQ,
    STATE(7225), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [256162] = 4,
    ACTIONS(9619), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [256212] = 4,
    ACTIONS(9621), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [256262] = 4,
    ACTIONS(4484), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [256312] = 4,
    ACTIONS(9623), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [256362] = 4,
    ACTIONS(9625), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [256412] = 4,
    ACTIONS(9627), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [256462] = 4,
    ACTIONS(9629), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [256512] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8756), 1,
      anon_sym_COMMA,
    STATE(6883), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(9631), 3,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [256608] = 4,
    ACTIONS(9633), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [256658] = 4,
    ACTIONS(9635), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [256708] = 4,
    ACTIONS(9638), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [256758] = 4,
    ACTIONS(9640), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [256808] = 4,
    ACTIONS(9642), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [256858] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(9646), 1,
      anon_sym_COMMA,
    STATE(7269), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(9644), 3,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [256954] = 4,
    ACTIONS(3907), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [257004] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(9648), 1,
      anon_sym_COMMA,
    STATE(7381), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3385), 3,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [257100] = 27,
    ACTIONS(7892), 1,
      anon_sym_LBRACK,
    ACTIONS(7930), 1,
      anon_sym_or_return,
    ACTIONS(7932), 1,
      anon_sym_or_continue,
    ACTIONS(7936), 1,
      anon_sym_CARET,
    ACTIONS(8334), 1,
      anon_sym_DASH_GT,
    ACTIONS(8336), 1,
      anon_sym_PLUS,
    ACTIONS(8338), 1,
      anon_sym_DASH,
    ACTIONS(8340), 1,
      anon_sym_AMP,
    ACTIONS(8342), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8350), 1,
      anon_sym_DOT,
    ACTIONS(8403), 1,
      anon_sym_PIPE,
    ACTIONS(8405), 1,
      anon_sym_TILDE,
    ACTIONS(8409), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8417), 1,
      anon_sym_or_break,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6905), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8344), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8346), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8348), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8352), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8407), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8411), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8413), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8454), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8415), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(8776), 3,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [257196] = 4,
    ACTIONS(4259), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [257246] = 4,
    ACTIONS(9650), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [257296] = 4,
    ACTIONS(9652), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [257346] = 4,
    ACTIONS(9654), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [257396] = 4,
    ACTIONS(9656), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [257446] = 4,
    ACTIONS(9658), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [257496] = 4,
    ACTIONS(9660), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [257546] = 4,
    ACTIONS(9663), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [257596] = 4,
    ACTIONS(3987), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [257646] = 4,
    ACTIONS(3845), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [257696] = 4,
    ACTIONS(9665), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [257746] = 4,
    ACTIONS(9667), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [257796] = 4,
    ACTIONS(9669), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [257846] = 4,
    ACTIONS(3917), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [257896] = 4,
    ACTIONS(9671), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [257946] = 4,
    ACTIONS(9674), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [257996] = 4,
    ACTIONS(9676), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258046] = 4,
    ACTIONS(9678), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258096] = 29,
    ACTIONS(7133), 1,
      anon_sym_COLON_EQ,
    ACTIONS(7282), 1,
      anon_sym_EQ,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    ACTIONS(9680), 1,
      anon_sym_LBRACE,
    STATE(7546), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [258196] = 4,
    ACTIONS(9682), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258246] = 4,
    ACTIONS(4311), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258296] = 4,
    ACTIONS(9684), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258346] = 4,
    ACTIONS(9687), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258396] = 4,
    ACTIONS(9689), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258446] = 4,
    ACTIONS(9691), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258496] = 4,
    ACTIONS(3937), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258546] = 4,
    ACTIONS(9693), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258596] = 4,
    ACTIONS(9695), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258646] = 4,
    ACTIONS(9697), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258696] = 4,
    ACTIONS(9699), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258746] = 4,
    ACTIONS(9701), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258796] = 4,
    ACTIONS(9703), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258846] = 4,
    ACTIONS(9705), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258896] = 4,
    ACTIONS(9707), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258946] = 4,
    ACTIONS(4357), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [258996] = 4,
    ACTIONS(9710), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [259046] = 4,
    ACTIONS(9713), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [259096] = 4,
    ACTIONS(9715), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [259146] = 4,
    ACTIONS(9717), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4605), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(4600), 28,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_when,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [259196] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9719), 1,
      anon_sym_COMMA,
    ACTIONS(9721), 1,
      anon_sym_EQ,
    ACTIONS(9723), 1,
      anon_sym_RPAREN,
    STATE(7596), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [259293] = 27,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9727), 1,
      anon_sym_COMMA,
    STATE(7393), 1,
      aux_sym__simple_assignment_statement_repeat1,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(9725), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [259388] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9729), 1,
      anon_sym_COMMA,
    ACTIONS(9731), 1,
      anon_sym_EQ,
    ACTIONS(9733), 1,
      anon_sym_RPAREN,
    STATE(8000), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [259485] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9735), 1,
      anon_sym_COMMA,
    ACTIONS(9737), 1,
      anon_sym_EQ,
    ACTIONS(9739), 1,
      anon_sym_RPAREN,
    STATE(8292), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [259582] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9741), 1,
      anon_sym_COMMA,
    ACTIONS(9743), 1,
      anon_sym_EQ,
    ACTIONS(9745), 1,
      anon_sym_RPAREN,
    STATE(8289), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [259679] = 27,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9747), 1,
      anon_sym_COMMA,
    STATE(7442), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8782), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [259774] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9749), 1,
      anon_sym_COMMA,
    ACTIONS(9751), 1,
      anon_sym_EQ,
    ACTIONS(9753), 1,
      anon_sym_RPAREN,
    STATE(7793), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [259871] = 6,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8358), 1,
      anon_sym_LPAREN,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 24,
      anon_sym_DASH_GT,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [259924] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9755), 1,
      anon_sym_COMMA,
    ACTIONS(9757), 1,
      anon_sym_EQ,
    ACTIONS(9759), 1,
      anon_sym_RPAREN,
    STATE(7711), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [260021] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9761), 1,
      anon_sym_COMMA,
    ACTIONS(9763), 1,
      anon_sym_EQ,
    ACTIONS(9765), 1,
      anon_sym_RPAREN,
    STATE(7851), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [260118] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9767), 1,
      anon_sym_COMMA,
    ACTIONS(9769), 1,
      anon_sym_EQ,
    ACTIONS(9771), 1,
      anon_sym_RPAREN,
    STATE(8023), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [260215] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9741), 1,
      anon_sym_COMMA,
    ACTIONS(9743), 1,
      anon_sym_EQ,
    ACTIONS(9745), 1,
      anon_sym_RPAREN,
    STATE(8135), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [260312] = 28,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    ACTIONS(9773), 1,
      anon_sym_EQ,
    ACTIONS(9775), 1,
      anon_sym_COLON_EQ,
    STATE(7484), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [260409] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9777), 1,
      anon_sym_COMMA,
    ACTIONS(9779), 1,
      anon_sym_EQ,
    ACTIONS(9781), 1,
      anon_sym_RPAREN,
    STATE(8369), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [260506] = 6,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8322), 1,
      anon_sym_LPAREN,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 24,
      anon_sym_DASH_GT,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [260559] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9735), 1,
      anon_sym_COMMA,
    ACTIONS(9737), 1,
      anon_sym_EQ,
    ACTIONS(9783), 1,
      anon_sym_RPAREN,
    STATE(8164), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [260656] = 6,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8834), 1,
      anon_sym_LPAREN,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 24,
      anon_sym_DASH_GT,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [260709] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(9787), 1,
      anon_sym_EQ,
    ACTIONS(9789), 1,
      anon_sym_RPAREN,
    STATE(7809), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [260806] = 28,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    ACTIONS(9791), 1,
      anon_sym_EQ,
    ACTIONS(9793), 1,
      anon_sym_COLON_EQ,
    STATE(7577), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [260903] = 6,
    ACTIONS(6724), 1,
      anon_sym_LPAREN,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 24,
      anon_sym_DASH_GT,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [260956] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9795), 1,
      anon_sym_COMMA,
    ACTIONS(9797), 1,
      anon_sym_EQ,
    ACTIONS(9799), 1,
      anon_sym_RPAREN,
    STATE(8206), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [261053] = 28,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    ACTIONS(9613), 1,
      anon_sym_EQ,
    ACTIONS(9617), 1,
      anon_sym_COLON_EQ,
    STATE(7493), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [261150] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9801), 1,
      anon_sym_COMMA,
    ACTIONS(9803), 1,
      anon_sym_EQ,
    ACTIONS(9805), 1,
      anon_sym_RPAREN,
    STATE(7761), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [261247] = 6,
    ACTIONS(6657), 1,
      anon_sym_LPAREN,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 24,
      anon_sym_DASH_GT,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [261300] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9807), 1,
      anon_sym_COMMA,
    ACTIONS(9809), 1,
      anon_sym_EQ,
    ACTIONS(9811), 1,
      anon_sym_RPAREN,
    STATE(8232), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [261397] = 27,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9727), 1,
      anon_sym_COMMA,
    STATE(7439), 1,
      aux_sym__simple_assignment_statement_repeat1,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(9813), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [261492] = 6,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8201), 1,
      anon_sym_LPAREN,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 24,
      anon_sym_DASH_GT,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [261545] = 28,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9815), 1,
      anon_sym_SEMI,
    ACTIONS(9817), 1,
      anon_sym_do,
    STATE(7156), 1,
      sym_block,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [261642] = 27,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9747), 1,
      anon_sym_COMMA,
    STATE(7459), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8786), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [261737] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9749), 1,
      anon_sym_COMMA,
    ACTIONS(9751), 1,
      anon_sym_EQ,
    ACTIONS(9819), 1,
      anon_sym_RPAREN,
    STATE(8222), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [261834] = 6,
    ACTIONS(7872), 1,
      anon_sym_LPAREN,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 24,
      anon_sym_DASH_GT,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [261887] = 6,
    ACTIONS(6594), 1,
      anon_sym_LPAREN,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 24,
      anon_sym_DASH_GT,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [261940] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9821), 1,
      anon_sym_COMMA,
    ACTIONS(9823), 1,
      anon_sym_EQ,
    ACTIONS(9825), 1,
      anon_sym_RPAREN,
    STATE(8026), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [262037] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9827), 1,
      anon_sym_COMMA,
    ACTIONS(9829), 1,
      anon_sym_EQ,
    ACTIONS(9831), 1,
      anon_sym_RPAREN,
    STATE(8241), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [262134] = 28,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    ACTIONS(9833), 1,
      anon_sym_EQ,
    ACTIONS(9835), 1,
      anon_sym_COLON_EQ,
    STATE(7520), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [262231] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9837), 1,
      anon_sym_COMMA,
    ACTIONS(9839), 1,
      anon_sym_EQ,
    ACTIONS(9841), 1,
      anon_sym_RPAREN,
    STATE(8122), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [262328] = 28,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    ACTIONS(9294), 1,
      anon_sym_EQ,
    ACTIONS(9298), 1,
      anon_sym_COLON_EQ,
    STATE(7573), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [262425] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(9845), 1,
      anon_sym_EQ,
    ACTIONS(9847), 1,
      anon_sym_RPAREN,
    STATE(7778), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [262522] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9741), 1,
      anon_sym_COMMA,
    ACTIONS(9743), 1,
      anon_sym_EQ,
    ACTIONS(9849), 1,
      anon_sym_RPAREN,
    STATE(8289), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [262619] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9851), 1,
      anon_sym_COMMA,
    ACTIONS(9853), 1,
      anon_sym_EQ,
    ACTIONS(9855), 1,
      anon_sym_RPAREN,
    STATE(8028), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [262716] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9857), 1,
      anon_sym_COMMA,
    ACTIONS(9859), 1,
      anon_sym_EQ,
    ACTIONS(9861), 1,
      anon_sym_RPAREN,
    STATE(7826), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [262813] = 28,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9863), 1,
      anon_sym_SEMI,
    ACTIONS(9865), 1,
      anon_sym_do,
    STATE(7156), 1,
      sym_block,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [262910] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9767), 1,
      anon_sym_COMMA,
    ACTIONS(9769), 1,
      anon_sym_EQ,
    ACTIONS(9867), 1,
      anon_sym_RPAREN,
    STATE(8023), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [263007] = 6,
    ACTIONS(6743), 1,
      anon_sym_LPAREN,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 24,
      anon_sym_DASH_GT,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [263060] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9755), 1,
      anon_sym_COMMA,
    ACTIONS(9757), 1,
      anon_sym_EQ,
    ACTIONS(9869), 1,
      anon_sym_RPAREN,
    STATE(8044), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [263157] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9871), 1,
      anon_sym_COMMA,
    ACTIONS(9873), 1,
      anon_sym_EQ,
    ACTIONS(9875), 1,
      anon_sym_RPAREN,
    STATE(7815), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [263254] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9735), 1,
      anon_sym_COMMA,
    ACTIONS(9737), 1,
      anon_sym_EQ,
    ACTIONS(9739), 1,
      anon_sym_RPAREN,
    STATE(8164), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [263351] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9877), 1,
      anon_sym_COMMA,
    ACTIONS(9879), 1,
      anon_sym_EQ,
    ACTIONS(9881), 1,
      anon_sym_RPAREN,
    STATE(7739), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [263448] = 6,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8125), 1,
      anon_sym_LPAREN,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 24,
      anon_sym_DASH_GT,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [263501] = 6,
    ACTIONS(7093), 1,
      anon_sym_LPAREN,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 24,
      anon_sym_DASH_GT,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [263554] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9857), 1,
      anon_sym_COMMA,
    ACTIONS(9859), 1,
      anon_sym_EQ,
    ACTIONS(9883), 1,
      anon_sym_RPAREN,
    STATE(7826), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [263651] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9885), 1,
      anon_sym_COMMA,
    ACTIONS(9887), 1,
      anon_sym_EQ,
    ACTIONS(9889), 1,
      anon_sym_RPAREN,
    STATE(7993), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [263748] = 6,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8354), 1,
      anon_sym_LPAREN,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 24,
      anon_sym_DASH_GT,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [263801] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9767), 1,
      anon_sym_COMMA,
    ACTIONS(9769), 1,
      anon_sym_EQ,
    ACTIONS(9867), 1,
      anon_sym_RPAREN,
    STATE(7859), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [263898] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9891), 1,
      anon_sym_COMMA,
    ACTIONS(9893), 1,
      anon_sym_EQ,
    ACTIONS(9895), 1,
      anon_sym_RPAREN,
    STATE(8109), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [263995] = 6,
    ACTIONS(6440), 1,
      anon_sym_LPAREN,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 24,
      anon_sym_DASH_GT,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [264048] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9897), 1,
      anon_sym_COMMA,
    ACTIONS(9899), 1,
      anon_sym_EQ,
    ACTIONS(9901), 1,
      anon_sym_RPAREN,
    STATE(7921), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [264145] = 27,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9727), 1,
      anon_sym_COMMA,
    STATE(7570), 1,
      aux_sym__simple_assignment_statement_repeat1,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(9903), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [264240] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9749), 1,
      anon_sym_COMMA,
    ACTIONS(9751), 1,
      anon_sym_EQ,
    ACTIONS(9819), 1,
      anon_sym_RPAREN,
    STATE(7793), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [264337] = 6,
    ACTIONS(7157), 1,
      anon_sym_LPAREN,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 24,
      anon_sym_DASH_GT,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [264390] = 6,
    ACTIONS(4590), 1,
      anon_sym_LPAREN,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 24,
      anon_sym_DASH_GT,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [264443] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9857), 1,
      anon_sym_COMMA,
    ACTIONS(9859), 1,
      anon_sym_EQ,
    ACTIONS(9883), 1,
      anon_sym_RPAREN,
    STATE(7819), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [264540] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9905), 1,
      anon_sym_COMMA,
    ACTIONS(9907), 1,
      anon_sym_EQ,
    ACTIONS(9909), 1,
      anon_sym_RPAREN,
    STATE(7946), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [264637] = 6,
    ACTIONS(6451), 1,
      anon_sym_LPAREN,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 24,
      anon_sym_DASH_GT,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [264690] = 28,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9911), 1,
      anon_sym_COMMA,
    ACTIONS(9913), 1,
      anon_sym_EQ,
    ACTIONS(9915), 1,
      anon_sym_RPAREN,
    STATE(8172), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [264787] = 6,
    ACTIONS(7562), 1,
      anon_sym_LPAREN,
    ACTIONS(8071), 1,
      anon_sym_QMARK,
    ACTIONS(8069), 2,
      anon_sym_if,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(67), 24,
      anon_sym_DASH_GT,
      anon_sym_in,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
      anon_sym_CARET,
  [264840] = 27,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9274), 1,
      anon_sym_or_break,
    ACTIONS(9917), 1,
      anon_sym_do,
    STATE(6887), 1,
      sym_block,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9246), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(9256), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [264934] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9919), 1,
      anon_sym_RBRACE,
    ACTIONS(9921), 1,
      anon_sym_COMMA,
    STATE(8398), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [265028] = 25,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7640), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [265118] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9923), 1,
      anon_sym_COMMA,
    ACTIONS(9925), 1,
      anon_sym_RPAREN,
    STATE(7616), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [265212] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9927), 1,
      anon_sym_COMMA,
    ACTIONS(9929), 1,
      anon_sym_COLON,
    STATE(8350), 1,
      aux_sym_switch_case_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [265306] = 27,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9274), 1,
      anon_sym_or_break,
    ACTIONS(9931), 1,
      anon_sym_do,
    STATE(6899), 1,
      sym_block,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9246), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(9256), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [265400] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(9933), 1,
      anon_sym_RBRACE,
    STATE(8059), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [265494] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9935), 1,
      anon_sym_RBRACE,
    ACTIONS(9937), 1,
      anon_sym_COMMA,
    STATE(7708), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [265588] = 27,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9274), 1,
      anon_sym_or_break,
    ACTIONS(9939), 1,
      anon_sym_do,
    STATE(6852), 1,
      sym_block,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9246), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(9256), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [265682] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9941), 1,
      anon_sym_COMMA,
    ACTIONS(9943), 1,
      anon_sym_RPAREN,
    STATE(7672), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [265776] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9945), 1,
      anon_sym_RBRACE,
    ACTIONS(9947), 1,
      anon_sym_COMMA,
    STATE(7611), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [265870] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9949), 1,
      anon_sym_RBRACE,
    ACTIONS(9951), 1,
      anon_sym_COMMA,
    STATE(7707), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [265964] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9953), 1,
      anon_sym_RBRACE,
    ACTIONS(9955), 1,
      anon_sym_COMMA,
    STATE(7644), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [266058] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(9957), 1,
      anon_sym_RBRACE,
    STATE(7633), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [266152] = 27,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9274), 1,
      anon_sym_or_break,
    ACTIONS(9959), 1,
      anon_sym_do,
    STATE(6877), 1,
      sym_block,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9246), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(9256), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [266246] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9961), 1,
      anon_sym_COMMA,
    ACTIONS(9963), 1,
      anon_sym_RPAREN,
    STATE(7623), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [266340] = 27,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(8764), 1,
      anon_sym_SEMI,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    STATE(8207), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [266434] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9965), 1,
      anon_sym_RBRACE,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    STATE(8182), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [266528] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9969), 1,
      anon_sym_COMMA,
    ACTIONS(9971), 1,
      anon_sym_RPAREN,
    STATE(7630), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [266622] = 27,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(8786), 1,
      anon_sym_SEMI,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    STATE(8261), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [266716] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9973), 1,
      anon_sym_RBRACE,
    ACTIONS(9975), 1,
      anon_sym_COMMA,
    STATE(7998), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [266810] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9977), 1,
      anon_sym_RBRACE,
    ACTIONS(9979), 1,
      anon_sym_COMMA,
    STATE(7643), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [266904] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9981), 1,
      anon_sym_RBRACE,
    ACTIONS(9983), 1,
      anon_sym_COMMA,
    STATE(7639), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [266998] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9985), 1,
      anon_sym_RBRACE,
    ACTIONS(9987), 1,
      anon_sym_COMMA,
    STATE(7645), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [267092] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(9989), 1,
      anon_sym_RBRACE,
    STATE(7647), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [267186] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9991), 1,
      anon_sym_COMMA,
    ACTIONS(9993), 1,
      anon_sym_COLON,
    ACTIONS(9995), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [267280] = 27,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(8778), 1,
      anon_sym_SEMI,
    ACTIONS(9997), 1,
      anon_sym_COMMA,
    STATE(8238), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [267374] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9999), 1,
      anon_sym_COMMA,
    ACTIONS(10001), 1,
      anon_sym_COLON,
    ACTIONS(10003), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [267468] = 27,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9274), 1,
      anon_sym_or_break,
    ACTIONS(10005), 1,
      anon_sym_do,
    STATE(7114), 1,
      sym_block,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9246), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(9256), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [267562] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10007), 1,
      anon_sym_COMMA,
    ACTIONS(10009), 1,
      anon_sym_COLON,
    ACTIONS(10011), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [267656] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10013), 1,
      anon_sym_COMMA,
    ACTIONS(10015), 1,
      anon_sym_RPAREN,
    STATE(8146), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [267750] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10017), 1,
      anon_sym_COMMA,
    ACTIONS(10019), 1,
      anon_sym_RPAREN,
    STATE(8180), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [267844] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10021), 1,
      anon_sym_RBRACE,
    ACTIONS(10023), 1,
      anon_sym_COMMA,
    STATE(8105), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [267938] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10025), 1,
      anon_sym_COMMA,
    ACTIONS(10027), 1,
      anon_sym_COLON,
    ACTIONS(10029), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [268032] = 27,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(8784), 1,
      anon_sym_SEMI,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    STATE(8382), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [268126] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10031), 1,
      anon_sym_RBRACE,
    ACTIONS(10033), 1,
      anon_sym_COMMA,
    STATE(7748), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [268220] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10035), 1,
      anon_sym_RBRACE,
    ACTIONS(10037), 1,
      anon_sym_COMMA,
    STATE(8106), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [268314] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10039), 1,
      anon_sym_RBRACE,
    ACTIONS(10041), 1,
      anon_sym_COMMA,
    STATE(7610), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [268408] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(10043), 1,
      anon_sym_RBRACE,
    STATE(7607), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [268502] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10045), 1,
      anon_sym_RBRACE,
    ACTIONS(10047), 1,
      anon_sym_COMMA,
    STATE(8380), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [268596] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10049), 1,
      anon_sym_COMMA,
    ACTIONS(10051), 1,
      anon_sym_COLON,
    ACTIONS(10053), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [268690] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10055), 1,
      anon_sym_RBRACE,
    ACTIONS(10057), 1,
      anon_sym_COMMA,
    STATE(7878), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [268784] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10059), 1,
      anon_sym_RBRACE,
    ACTIONS(10061), 1,
      anon_sym_COMMA,
    STATE(7969), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [268878] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(10063), 1,
      anon_sym_RBRACE,
    STATE(7604), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [268972] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10065), 1,
      anon_sym_COMMA,
    ACTIONS(10067), 1,
      anon_sym_RPAREN,
    STATE(7854), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [269066] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10069), 1,
      anon_sym_RBRACE,
    ACTIONS(10071), 1,
      anon_sym_COMMA,
    STATE(8114), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [269160] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10073), 1,
      anon_sym_RBRACE,
    ACTIONS(10075), 1,
      anon_sym_COMMA,
    STATE(8336), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [269254] = 27,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(8772), 1,
      anon_sym_SEMI,
    ACTIONS(9997), 1,
      anon_sym_COMMA,
    STATE(8331), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [269348] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10077), 1,
      anon_sym_COMMA,
    ACTIONS(10079), 1,
      anon_sym_RPAREN,
    STATE(8075), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [269442] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10081), 1,
      anon_sym_RBRACE,
    ACTIONS(10083), 1,
      anon_sym_COMMA,
    STATE(7919), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [269536] = 27,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(8782), 1,
      anon_sym_SEMI,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    STATE(8004), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [269630] = 27,
    ACTIONS(6141), 1,
      anon_sym_RBRACE,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10085), 1,
      anon_sym_COMMA,
    STATE(7899), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [269724] = 27,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(8754), 1,
      anon_sym_SEMI,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    STATE(8294), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [269818] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10087), 1,
      anon_sym_RBRACE,
    ACTIONS(10089), 1,
      anon_sym_COMMA,
    STATE(7909), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [269912] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(10091), 1,
      anon_sym_RBRACE,
    STATE(8078), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [270006] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10093), 1,
      anon_sym_COMMA,
    ACTIONS(10095), 1,
      anon_sym_RPAREN,
    STATE(7670), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [270100] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(10097), 1,
      anon_sym_RBRACE,
    STATE(8192), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [270194] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10099), 1,
      anon_sym_RBRACE,
    ACTIONS(10101), 1,
      anon_sym_COMMA,
    STATE(8082), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [270288] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10103), 1,
      anon_sym_RBRACE,
    ACTIONS(10105), 1,
      anon_sym_COMMA,
    STATE(8198), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [270382] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10107), 1,
      anon_sym_COMMA,
    ACTIONS(10109), 1,
      anon_sym_RPAREN,
    STATE(7833), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [270476] = 27,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(8762), 1,
      anon_sym_SEMI,
    ACTIONS(9997), 1,
      anon_sym_COMMA,
    STATE(8242), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [270570] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(1589), 18,
      sym_float,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT,
      sym_number,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_SQUOTE,
      sym_uninitialized,
      sym_tag,
    ACTIONS(10111), 18,
      anon_sym_package,
      anon_sym_foreign,
      anon_sym_import,
      anon_sym_using,
      anon_sym_when,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_cast,
      anon_sym_transmute,
      anon_sym_auto_cast,
      anon_sym_map,
      anon_sym_bit_set,
      anon_sym_matrix,
      anon_sym_distinct,
      anon_sym_true,
      anon_sym_false,
      anon_sym_nil,
      sym_identifier,
  [270616] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10113), 1,
      anon_sym_COMMA,
    ACTIONS(10115), 1,
      anon_sym_RPAREN,
    STATE(8101), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [270710] = 27,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(8776), 1,
      anon_sym_SEMI,
    ACTIONS(9997), 1,
      anon_sym_COMMA,
    STATE(7979), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [270804] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10117), 1,
      anon_sym_RBRACE,
    ACTIONS(10119), 1,
      anon_sym_COMMA,
    STATE(8333), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [270898] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10121), 1,
      anon_sym_RBRACE,
    ACTIONS(10123), 1,
      anon_sym_COMMA,
    STATE(8322), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [270992] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10125), 1,
      anon_sym_RBRACE,
    ACTIONS(10127), 1,
      anon_sym_COMMA,
    STATE(8148), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [271086] = 27,
    ACTIONS(6081), 1,
      anon_sym_RBRACE,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10129), 1,
      anon_sym_COMMA,
    STATE(7864), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [271180] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10131), 1,
      anon_sym_RBRACE,
    ACTIONS(10133), 1,
      anon_sym_COMMA,
    STATE(8173), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [271274] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10135), 1,
      anon_sym_RBRACE,
    ACTIONS(10137), 1,
      anon_sym_COMMA,
    STATE(8174), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [271368] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10139), 1,
      anon_sym_COMMA,
    ACTIONS(10141), 1,
      anon_sym_RPAREN,
    STATE(8298), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [271462] = 27,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(8768), 1,
      anon_sym_SEMI,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    STATE(8204), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [271556] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10143), 1,
      anon_sym_COMMA,
    ACTIONS(10145), 1,
      anon_sym_RPAREN,
    STATE(8394), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [271650] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10147), 1,
      anon_sym_RBRACE,
    ACTIONS(10149), 1,
      anon_sym_COMMA,
    STATE(8277), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [271744] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(10151), 1,
      anon_sym_RBRACE,
    STATE(8272), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [271838] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10155), 1,
      anon_sym_EQ,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(10153), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [271930] = 27,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(8758), 1,
      anon_sym_SEMI,
    ACTIONS(9997), 1,
      anon_sym_COMMA,
    STATE(8278), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [272024] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10157), 1,
      anon_sym_COMMA,
    ACTIONS(10159), 1,
      anon_sym_COLON,
    ACTIONS(10161), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [272118] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10163), 1,
      anon_sym_COMMA,
    ACTIONS(10165), 1,
      anon_sym_RPAREN,
    STATE(7924), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [272212] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10167), 1,
      anon_sym_RBRACE,
    ACTIONS(10169), 1,
      anon_sym_COMMA,
    STATE(7602), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [272306] = 27,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9274), 1,
      anon_sym_or_break,
    ACTIONS(10171), 1,
      anon_sym_do,
    STATE(6814), 1,
      sym_block,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9246), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(9256), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [272400] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10173), 1,
      anon_sym_COMMA,
    ACTIONS(10175), 1,
      anon_sym_RPAREN,
    STATE(8343), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [272494] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10177), 1,
      anon_sym_COMMA,
    ACTIONS(10179), 1,
      anon_sym_RPAREN,
    STATE(8263), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [272588] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10181), 1,
      anon_sym_COMMA,
    ACTIONS(10183), 1,
      anon_sym_RPAREN,
    STATE(8201), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [272682] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10185), 1,
      anon_sym_RBRACE,
    ACTIONS(10187), 1,
      anon_sym_COMMA,
    STATE(8070), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [272776] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(10189), 1,
      anon_sym_RBRACE,
    STATE(8150), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [272870] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10191), 1,
      anon_sym_COMMA,
    ACTIONS(10193), 1,
      anon_sym_RPAREN,
    STATE(8041), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [272964] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(10195), 1,
      anon_sym_RBRACE,
    STATE(8388), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [273058] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10197), 1,
      anon_sym_RBRACE,
    ACTIONS(10199), 1,
      anon_sym_COMMA,
    STATE(8357), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [273152] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10201), 1,
      anon_sym_COMMA,
    ACTIONS(10203), 1,
      anon_sym_RPAREN,
    STATE(8364), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [273246] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10205), 1,
      anon_sym_COMMA,
    ACTIONS(10207), 1,
      anon_sym_RPAREN,
    STATE(7868), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [273340] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10209), 1,
      anon_sym_RBRACE,
    ACTIONS(10211), 1,
      anon_sym_COMMA,
    STATE(7997), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [273434] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(10213), 1,
      anon_sym_RBRACE,
    STATE(8050), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [273528] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10215), 1,
      anon_sym_RBRACE,
    ACTIONS(10217), 1,
      anon_sym_COMMA,
    STATE(8052), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [273622] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10219), 1,
      anon_sym_RBRACE,
    ACTIONS(10221), 1,
      anon_sym_COMMA,
    STATE(7872), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [273716] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10223), 1,
      anon_sym_COMMA,
    ACTIONS(10225), 1,
      anon_sym_COLON,
    ACTIONS(10227), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [273810] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10229), 1,
      anon_sym_RBRACE,
    ACTIONS(10231), 1,
      anon_sym_COMMA,
    STATE(8396), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [273904] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10233), 1,
      anon_sym_COMMA,
    ACTIONS(10235), 1,
      anon_sym_COLON,
    ACTIONS(10237), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [273998] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10239), 1,
      anon_sym_COMMA,
    ACTIONS(10241), 1,
      anon_sym_RPAREN,
    STATE(7869), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [274092] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(10243), 1,
      anon_sym_RBRACE,
    STATE(7883), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [274186] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10245), 1,
      anon_sym_RBRACE,
    ACTIONS(10247), 1,
      anon_sym_COMMA,
    STATE(7891), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [274280] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10249), 1,
      anon_sym_RBRACE,
    ACTIONS(10251), 1,
      anon_sym_COMMA,
    STATE(8401), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [274374] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10253), 1,
      anon_sym_RBRACE,
    ACTIONS(10255), 1,
      anon_sym_COMMA,
    STATE(8397), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [274468] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10257), 1,
      anon_sym_COMMA,
    ACTIONS(10259), 1,
      anon_sym_RPAREN,
    STATE(8060), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [274562] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10261), 1,
      anon_sym_RBRACE,
    ACTIONS(10263), 1,
      anon_sym_COMMA,
    STATE(7880), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [274656] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10265), 1,
      anon_sym_COMMA,
    ACTIONS(10267), 1,
      anon_sym_COLON,
    ACTIONS(10269), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [274750] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10271), 1,
      anon_sym_COMMA,
    ACTIONS(10273), 1,
      anon_sym_RPAREN,
    STATE(7902), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [274844] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10275), 1,
      anon_sym_RBRACE,
    ACTIONS(10277), 1,
      anon_sym_COMMA,
    STATE(8248), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [274938] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10279), 1,
      anon_sym_COMMA,
    ACTIONS(10281), 1,
      anon_sym_RPAREN,
    STATE(7744), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [275032] = 27,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9274), 1,
      anon_sym_or_break,
    ACTIONS(10283), 1,
      anon_sym_do,
    STATE(7073), 1,
      sym_block,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9246), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(9256), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [275126] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10285), 1,
      anon_sym_RBRACE,
    ACTIONS(10287), 1,
      anon_sym_COMMA,
    STATE(7857), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [275220] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10289), 1,
      anon_sym_EQ,
    ACTIONS(7125), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [275312] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10291), 1,
      anon_sym_COMMA,
    ACTIONS(10293), 1,
      anon_sym_COLON,
    ACTIONS(10295), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [275406] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10297), 1,
      anon_sym_RBRACE,
    ACTIONS(10299), 1,
      anon_sym_COMMA,
    STATE(8252), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [275500] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10301), 1,
      anon_sym_RBRACE,
    ACTIONS(10303), 1,
      anon_sym_COMMA,
    STATE(8348), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [275594] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10305), 1,
      anon_sym_COMMA,
    ACTIONS(10307), 1,
      anon_sym_COLON,
    ACTIONS(10309), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [275688] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(10311), 1,
      anon_sym_RBRACE,
    STATE(7853), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [275782] = 27,
    ACTIONS(4728), 1,
      anon_sym_LBRACE,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(10313), 1,
      anon_sym_COMMA,
    STATE(8307), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [275876] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10315), 1,
      anon_sym_RBRACE,
    ACTIONS(10317), 1,
      anon_sym_COMMA,
    STATE(8342), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [275970] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10319), 1,
      anon_sym_RBRACE,
    ACTIONS(10321), 1,
      anon_sym_COMMA,
    STATE(7915), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [276064] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10323), 1,
      anon_sym_RBRACE,
    ACTIONS(10325), 1,
      anon_sym_COMMA,
    STATE(7922), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [276158] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10327), 1,
      anon_sym_COMMA,
    ACTIONS(10329), 1,
      anon_sym_COLON,
    ACTIONS(10331), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [276252] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10333), 1,
      anon_sym_RBRACE,
    ACTIONS(10335), 1,
      anon_sym_COMMA,
    STATE(8220), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [276346] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10337), 1,
      anon_sym_RBRACE,
    ACTIONS(10339), 1,
      anon_sym_COMMA,
    STATE(8228), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [276440] = 27,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9274), 1,
      anon_sym_or_break,
    ACTIONS(10341), 1,
      anon_sym_do,
    STATE(6806), 1,
      sym_block,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9246), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(9256), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [276534] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10343), 1,
      anon_sym_COMMA,
    ACTIONS(10345), 1,
      anon_sym_RPAREN,
    STATE(8167), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [276628] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10347), 1,
      anon_sym_COMMA,
    ACTIONS(10349), 1,
      anon_sym_COLON,
    ACTIONS(10351), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [276722] = 25,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
    ACTIONS(10353), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_do,
  [276812] = 27,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9274), 1,
      anon_sym_or_break,
    ACTIONS(10355), 1,
      anon_sym_do,
    STATE(6811), 1,
      sym_block,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9246), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(9256), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [276906] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10357), 1,
      anon_sym_RBRACE,
    ACTIONS(10359), 1,
      anon_sym_COMMA,
    STATE(8296), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [277000] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10361), 1,
      anon_sym_RBRACE,
    ACTIONS(10363), 1,
      anon_sym_COMMA,
    STATE(8074), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [277094] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10365), 1,
      anon_sym_RBRACE,
    ACTIONS(10367), 1,
      anon_sym_COMMA,
    STATE(8290), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [277188] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10369), 1,
      anon_sym_COMMA,
    ACTIONS(10371), 1,
      anon_sym_RPAREN,
    STATE(7841), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [277282] = 27,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10373), 1,
      anon_sym_RBRACE,
    ACTIONS(10375), 1,
      anon_sym_COMMA,
    STATE(8076), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [277376] = 27,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9274), 1,
      anon_sym_or_break,
    ACTIONS(10377), 1,
      anon_sym_do,
    STATE(6803), 1,
      sym_block,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9246), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(9256), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [277470] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10379), 1,
      anon_sym_SEMI,
    ACTIONS(10381), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [277561] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(10383), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [277650] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(10385), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [277739] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(10387), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [277828] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10389), 1,
      anon_sym_SEMI,
    ACTIONS(10391), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [277919] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10393), 1,
      anon_sym_SEMI,
    ACTIONS(10395), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [278010] = 5,
    ACTIONS(6449), 1,
      sym_identifier,
    ACTIONS(6451), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 15,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 18,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [278059] = 5,
    ACTIONS(7560), 1,
      sym_identifier,
    ACTIONS(7562), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 15,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 18,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [278108] = 25,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(4717), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [278197] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(10397), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [278286] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(10399), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [278375] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(10401), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [278464] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10403), 1,
      anon_sym_SEMI,
    ACTIONS(10405), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [278555] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10407), 1,
      anon_sym_SEMI,
    ACTIONS(10409), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [278646] = 5,
    ACTIONS(7155), 1,
      sym_identifier,
    ACTIONS(7157), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 15,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 18,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [278695] = 5,
    ACTIONS(4588), 1,
      sym_identifier,
    ACTIONS(4590), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 15,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 18,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [278744] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(10411), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [278833] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(10413), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [278922] = 5,
    ACTIONS(19), 1,
      anon_sym_AT,
    STATE(6012), 2,
      sym_attribute,
      aux_sym_attributes_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(10415), 16,
      anon_sym_foreign,
      anon_sym_import,
      anon_sym_using,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_cast,
      anon_sym_transmute,
      anon_sym_auto_cast,
      anon_sym_map,
      anon_sym_bit_set,
      anon_sym_matrix,
      anon_sym_distinct,
      anon_sym_true,
      anon_sym_false,
      anon_sym_nil,
      sym_identifier,
    ACTIONS(10417), 16,
      sym_float,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT,
      sym_number,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_SQUOTE,
      sym_uninitialized,
      sym_tag,
  [278971] = 25,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9274), 1,
      anon_sym_or_break,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9246), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(9256), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10419), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [279060] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10421), 1,
      anon_sym_SEMI,
    ACTIONS(10423), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [279151] = 26,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    STATE(6833), 1,
      sym_block,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [279242] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10425), 1,
      anon_sym_SEMI,
    ACTIONS(10427), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [279333] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10429), 1,
      anon_sym_SEMI,
    ACTIONS(10431), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [279424] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10433), 1,
      anon_sym_SEMI,
    ACTIONS(10435), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [279515] = 5,
    ACTIONS(10441), 1,
      anon_sym_AT,
    STATE(6012), 2,
      sym_attribute,
      aux_sym_attributes_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(10437), 16,
      anon_sym_foreign,
      anon_sym_import,
      anon_sym_using,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_cast,
      anon_sym_transmute,
      anon_sym_auto_cast,
      anon_sym_map,
      anon_sym_bit_set,
      anon_sym_matrix,
      anon_sym_distinct,
      anon_sym_true,
      anon_sym_false,
      anon_sym_nil,
      sym_identifier,
    ACTIONS(10439), 16,
      sym_float,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT,
      sym_number,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_SQUOTE,
      sym_uninitialized,
      sym_tag,
  [279564] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(10444), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [279653] = 5,
    ACTIONS(6438), 1,
      sym_identifier,
    ACTIONS(6440), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 15,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 18,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [279702] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(10446), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [279791] = 5,
    ACTIONS(7093), 1,
      anon_sym_LPAREN,
    ACTIONS(7193), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 15,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 18,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [279840] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10448), 1,
      anon_sym_SEMI,
    ACTIONS(10450), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [279931] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(10452), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [280020] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10454), 1,
      anon_sym_SEMI,
    ACTIONS(10456), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [280111] = 5,
    ACTIONS(6741), 1,
      sym_identifier,
    ACTIONS(6743), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 15,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 18,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [280160] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10458), 1,
      anon_sym_SEMI,
    ACTIONS(10460), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [280251] = 5,
    ACTIONS(8356), 1,
      sym_identifier,
    ACTIONS(8358), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 15,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 18,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [280300] = 5,
    ACTIONS(8123), 1,
      sym_identifier,
    ACTIONS(8125), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 15,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 18,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [280349] = 26,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    STATE(7042), 1,
      sym_block,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [280440] = 5,
    ACTIONS(8356), 1,
      sym_identifier,
    ACTIONS(8834), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 15,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 18,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [280489] = 26,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    STATE(6865), 1,
      sym_block,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [280580] = 25,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(9192), 1,
      anon_sym_DASH_GT,
    ACTIONS(9194), 1,
      anon_sym_DOT,
    ACTIONS(9244), 1,
      anon_sym_PIPE,
    ACTIONS(9248), 1,
      anon_sym_PLUS,
    ACTIONS(9250), 1,
      anon_sym_DASH,
    ACTIONS(9252), 1,
      anon_sym_TILDE,
    ACTIONS(9254), 1,
      anon_sym_AMP,
    ACTIONS(9258), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9266), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(9274), 1,
      anon_sym_or_break,
    ACTIONS(9196), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(9246), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(9256), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(9260), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9262), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9268), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9270), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(9272), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10462), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9264), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [280669] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10454), 1,
      anon_sym_SEMI,
    ACTIONS(10464), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [280760] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10466), 1,
      anon_sym_SEMI,
    ACTIONS(10468), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [280851] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10470), 1,
      anon_sym_SEMI,
    ACTIONS(10472), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [280942] = 5,
    ACTIONS(8199), 1,
      sym_identifier,
    ACTIONS(8201), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 15,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 18,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [280991] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(10474), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [281080] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10476), 1,
      anon_sym_SEMI,
    ACTIONS(10478), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [281171] = 5,
    ACTIONS(7870), 1,
      sym_identifier,
    ACTIONS(8322), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 15,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 18,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [281220] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10433), 1,
      anon_sym_SEMI,
    ACTIONS(10480), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [281311] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10482), 1,
      anon_sym_SEMI,
    ACTIONS(10484), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [281402] = 26,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10486), 1,
      anon_sym_SEMI,
    ACTIONS(10488), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [281493] = 25,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(8483), 1,
      anon_sym_DASH_GT,
    ACTIONS(8485), 1,
      anon_sym_DOT,
    ACTIONS(8597), 1,
      anon_sym_PLUS,
    ACTIONS(8599), 1,
      anon_sym_DASH,
    ACTIONS(8601), 1,
      anon_sym_TILDE,
    ACTIONS(8603), 1,
      anon_sym_AMP,
    ACTIONS(8605), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8613), 1,
      anon_sym_PIPE,
    ACTIONS(8619), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8627), 1,
      anon_sym_or_break,
    ACTIONS(8487), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8607), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8609), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8611), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8615), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(8617), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8621), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8623), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8956), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8625), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [281582] = 5,
    ACTIONS(6655), 1,
      sym_identifier,
    ACTIONS(6657), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 15,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 18,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [281631] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(10490), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [281720] = 5,
    ACTIONS(6449), 1,
      sym_identifier,
    ACTIONS(6594), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 15,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 18,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [281769] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(10492), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [281858] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(10494), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [281947] = 5,
    ACTIONS(6655), 1,
      sym_identifier,
    ACTIONS(6724), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(71), 15,
      anon_sym_PIPE,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_AMP,
      anon_sym_or_else,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
      anon_sym_not_in,
      anon_sym_or_return,
      anon_sym_or_continue,
      anon_sym_or_break,
    ACTIONS(67), 18,
      anon_sym_DASH_GT,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AMP_TILDE,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
      anon_sym_CARET,
  [281996] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10496), 1,
      anon_sym_EQ,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [282084] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10498), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [282172] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9563), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [282260] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9561), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [282348] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9559), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [282436] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9602), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [282524] = 25,
    ACTIONS(3967), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [282612] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10500), 1,
      anon_sym_RPAREN,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [282700] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10502), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [282788] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10504), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [282876] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9552), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [282964] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9546), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [283052] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9540), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [283140] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10506), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [283228] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9538), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [283316] = 25,
    ACTIONS(3885), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [283404] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9663), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [283492] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10508), 1,
      anon_sym_EQ,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [283580] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9527), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [283668] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9529), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [283756] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10510), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [283844] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9523), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [283932] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9521), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [284020] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9519), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [284108] = 25,
    ACTIONS(3655), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [284196] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10512), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [284284] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10514), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [284372] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9517), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [284460] = 25,
    ACTIONS(3987), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [284548] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10516), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [284636] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10518), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [284724] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9513), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [284812] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10520), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [284900] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10522), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [284988] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10524), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [285076] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9508), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [285164] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9565), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [285252] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10526), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [285340] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10528), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [285428] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9569), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [285516] = 25,
    ACTIONS(4007), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [285604] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9497), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [285692] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9501), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [285780] = 25,
    ACTIONS(3825), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [285868] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10530), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [285956] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10532), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [286044] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9695), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [286132] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9495), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [286220] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9619), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [286308] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9493), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [286396] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9491), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [286484] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9489), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [286572] = 25,
    ACTIONS(3765), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [286660] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9571), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [286748] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9485), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [286836] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10534), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [286924] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9575), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [287012] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10536), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [287100] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10538), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [287188] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10540), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [287276] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9697), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [287364] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9483), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [287452] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9477), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [287540] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9473), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [287628] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10542), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [287716] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10544), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [287804] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10546), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [287892] = 25,
    ACTIONS(3725), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [287980] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9582), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [288068] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10548), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [288156] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9471), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [288244] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9467), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [288332] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9465), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [288420] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10550), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [288508] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9459), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [288596] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9586), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [288684] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9715), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [288772] = 25,
    ACTIONS(4097), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [288860] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10552), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [288948] = 25,
    ACTIONS(3465), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [289036] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10554), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [289124] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10556), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [289212] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9447), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [289300] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9445), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [289388] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9441), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [289476] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9588), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [289564] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10558), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [289652] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9594), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [289740] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9439), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [289828] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9705), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [289916] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9598), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [290004] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9386), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [290092] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10560), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [290180] = 25,
    ACTIONS(3615), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [290268] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9693), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [290356] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9437), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [290444] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9650), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [290532] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10562), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [290620] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10564), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [290708] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10566), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [290796] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9435), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [290884] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9431), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [290972] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9429), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [291060] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10568), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [291148] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9421), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [291236] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10570), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [291324] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10572), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [291412] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9611), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [291500] = 25,
    ACTIONS(3545), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [291588] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10574), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [291676] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9425), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [291764] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10576), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [291852] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9419), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [291940] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10578), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [292028] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9417), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [292116] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9415), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [292204] = 25,
    ACTIONS(3505), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [292292] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10580), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [292380] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10582), 1,
      anon_sym_RPAREN,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [292468] = 25,
    ACTIONS(4484), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [292556] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10584), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [292644] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10586), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [292732] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10588), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [292820] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10590), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [292908] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10592), 1,
      anon_sym_RPAREN,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [292996] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9401), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [293084] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9409), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [293172] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9717), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [293260] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10594), 1,
      anon_sym_EQ,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [293348] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9682), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [293436] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10596), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [293524] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10598), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [293612] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9405), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [293700] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10600), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [293788] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10602), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [293876] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10604), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [293964] = 25,
    ACTIONS(4311), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [294052] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9403), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [294140] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10606), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [294228] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10608), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [294316] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9687), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [294404] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9399), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [294492] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10610), 1,
      anon_sym_RPAREN,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [294580] = 25,
    ACTIONS(3455), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [294668] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10612), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [294756] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9703), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [294844] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9032), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [294932] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10614), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [295020] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10616), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [295108] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10618), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [295196] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9397), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [295284] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9713), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [295372] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10620), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [295460] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9554), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [295548] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10622), 1,
      anon_sym_RPAREN,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [295636] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9393), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [295724] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9701), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [295812] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10624), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [295900] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10626), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [295988] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9391), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [296076] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10628), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [296164] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10630), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [296252] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9604), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [296340] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10632), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [296428] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10634), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [296516] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_RPAREN,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [296604] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9395), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [296692] = 25,
    ACTIONS(3937), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [296780] = 25,
    ACTIONS(4057), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [296868] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10638), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [296956] = 25,
    ACTIONS(3565), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [297044] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10640), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [297132] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10642), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [297220] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10644), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [297308] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10646), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [297396] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10648), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [297484] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9689), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [297572] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10650), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [297660] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9544), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [297748] = 25,
    ACTIONS(3845), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [297836] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9413), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [297924] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10652), 1,
      anon_sym_RPAREN,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [298012] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10654), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [298100] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9609), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [298188] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9423), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [298276] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9427), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [298364] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10656), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [298452] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9503), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [298540] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10658), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [298628] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10660), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [298716] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9433), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [298804] = 25,
    ACTIONS(3685), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [298892] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10662), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [298980] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10664), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [299068] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10666), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [299156] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10668), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [299244] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9443), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [299332] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9658), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [299420] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10670), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [299508] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10672), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [299596] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9487), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [299684] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9451), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [299772] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9411), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [299860] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10674), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [299948] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10676), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [300036] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10678), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [300124] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10680), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [300212] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10682), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [300300] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10684), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [300388] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10686), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [300476] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9461), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [300564] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9652), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [300652] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9449), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [300740] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9676), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [300828] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9481), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [300916] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10688), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [301004] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9469), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [301092] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10690), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [301180] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9463), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [301268] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10692), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [301356] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10694), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [301444] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9674), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [301532] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9475), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [301620] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10696), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [301708] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9479), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [301796] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10698), 1,
      anon_sym_RPAREN,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [301884] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10700), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [301972] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9642), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [302060] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10702), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [302148] = 25,
    ACTIONS(3917), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [302236] = 25,
    ACTIONS(4502), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [302324] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10704), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [302412] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10706), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [302500] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10708), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [302588] = 25,
    ACTIONS(4367), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [302676] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10710), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [302764] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9669), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [302852] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10712), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [302940] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10714), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [303028] = 25,
    ACTIONS(3907), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [303116] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9633), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [303204] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10716), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [303292] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10718), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [303380] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10720), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [303468] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10722), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [303556] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10724), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [303644] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10726), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [303732] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10728), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [303820] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10730), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [303908] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10732), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [303996] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10734), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [304084] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10736), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [304172] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10738), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [304260] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10740), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [304348] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10742), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [304436] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10744), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [304524] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9678), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [304612] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9499), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [304700] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10746), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [304788] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10748), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [304876] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10750), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [304964] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10752), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [305052] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10754), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [305140] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10756), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [305228] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10758), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [305316] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10760), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [305404] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9667), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [305492] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10762), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [305580] = 25,
    ACTIONS(4245), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [305668] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10764), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [305756] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10766), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [305844] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10768), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [305932] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10770), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [306020] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10772), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [306108] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9665), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [306196] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10774), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [306284] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10776), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [306372] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10778), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [306460] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9656), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [306548] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10780), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [306636] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10782), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [306724] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10784), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [306812] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10786), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [306900] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10788), 1,
      anon_sym_EQ,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [306988] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10790), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [307076] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10792), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [307164] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10794), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [307252] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9654), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [307340] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10796), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [307428] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10798), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [307516] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10800), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [307604] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10802), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [307692] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9691), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [307780] = 25,
    ACTIONS(4259), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [307868] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10804), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [307956] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10806), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [308044] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9640), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [308132] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10808), 1,
      anon_sym_EQ,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [308220] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10810), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [308308] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10812), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [308396] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10814), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [308484] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10816), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [308572] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9590), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [308660] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10818), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [308748] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10820), 1,
      anon_sym_RPAREN,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [308836] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10822), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [308924] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9699), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [309012] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9638), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [309100] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9629), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [309188] = 25,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(10824), 1,
      anon_sym_LBRACE,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [309276] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10826), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [309364] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10828), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [309452] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10830), 1,
      anon_sym_EQ,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [309540] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10832), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [309628] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10834), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [309716] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9627), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [309804] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10836), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [309892] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10838), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [309980] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10840), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [310068] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10842), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [310156] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9515), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [310244] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10844), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [310332] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9623), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [310420] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10846), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [310508] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10848), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [310596] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10850), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [310684] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10852), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [310772] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10854), 1,
      anon_sym_EQ,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [310860] = 25,
    ACTIONS(4411), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [310948] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10856), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [311036] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10858), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [311124] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10860), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [311212] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10862), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [311300] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10864), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [311388] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10866), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [311476] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9525), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [311564] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10868), 1,
      anon_sym_RPAREN,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [311652] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10870), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [311740] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10872), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [311828] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10874), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [311916] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10876), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [312004] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9621), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [312092] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10878), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [312180] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10880), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [312268] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9536), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [312356] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10882), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [312444] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9596), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [312532] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10884), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [312620] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10886), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [312708] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9542), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [312796] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10888), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [312884] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10890), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [312972] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10892), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [313060] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10894), 1,
      anon_sym_EQ,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [313148] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10896), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [313236] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10898), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [313324] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10900), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [313412] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10902), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [313500] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9592), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [313588] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10904), 1,
      anon_sym_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [313676] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10906), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [313764] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10908), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [313852] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10910), 1,
      anon_sym_EQ,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [313940] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10912), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [314028] = 25,
    ACTIONS(4357), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [314116] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10914), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [314204] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10916), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [314292] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10918), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [314380] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10920), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [314468] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10922), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [314556] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10924), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [314644] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10926), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [314732] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10928), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [314820] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9625), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [314908] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9584), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [314996] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10930), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [315084] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10932), 1,
      anon_sym_EQ,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [315172] = 25,
    ACTIONS(3735), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [315260] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10934), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [315348] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10936), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [315436] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10938), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [315524] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10940), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [315612] = 25,
    ACTIONS(4137), 1,
      anon_sym_RBRACK,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [315700] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10942), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [315788] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10944), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [315876] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10946), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [315964] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10948), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [316052] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9573), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [316140] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10950), 1,
      anon_sym_EQ,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [316228] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10952), 1,
      anon_sym_RPAREN,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [316316] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10954), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [316404] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10956), 1,
      anon_sym_EQ,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [316492] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10958), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [316580] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10960), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [316668] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10962), 1,
      anon_sym_RPAREN,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [316756] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10964), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [316844] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10966), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [316932] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10968), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [317020] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10970), 1,
      anon_sym_EQ,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [317108] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10972), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [317196] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10974), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [317284] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10976), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [317372] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10978), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [317460] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10980), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [317548] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10982), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [317636] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9534), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [317724] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10984), 1,
      anon_sym_RPAREN,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [317812] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10986), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [317900] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10988), 1,
      anon_sym_COMMA,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [317988] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(9407), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [318076] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10990), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [318164] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10992), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [318252] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10994), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [318340] = 25,
    ACTIONS(8489), 1,
      anon_sym_DASH_GT,
    ACTIONS(8491), 1,
      anon_sym_DOT,
    ACTIONS(8493), 1,
      anon_sym_LBRACK,
    ACTIONS(8506), 1,
      anon_sym_PLUS,
    ACTIONS(8508), 1,
      anon_sym_DASH,
    ACTIONS(8519), 1,
      anon_sym_PIPE,
    ACTIONS(8521), 1,
      anon_sym_TILDE,
    ACTIONS(8523), 1,
      anon_sym_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8535), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(8537), 1,
      anon_sym_or_return,
    ACTIONS(8539), 1,
      anon_sym_or_continue,
    ACTIONS(8541), 1,
      anon_sym_or_break,
    ACTIONS(8543), 1,
      anon_sym_CARET,
    ACTIONS(10996), 1,
      anon_sym_LBRACE,
    ACTIONS(8495), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(8510), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8517), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8525), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(8529), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(8531), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(8636), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8533), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [318428] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(10998), 1,
      anon_sym_else,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [318516] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(11000), 1,
      anon_sym_RBRACK,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [318604] = 25,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(11002), 1,
      anon_sym_EQ,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [318692] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11004), 16,
      anon_sym_foreign,
      anon_sym_import,
      anon_sym_using,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_cast,
      anon_sym_transmute,
      anon_sym_auto_cast,
      anon_sym_map,
      anon_sym_bit_set,
      anon_sym_matrix,
      anon_sym_distinct,
      anon_sym_true,
      anon_sym_false,
      anon_sym_nil,
      sym_identifier,
    ACTIONS(11006), 17,
      sym_float,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT,
      sym_number,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_SQUOTE,
      sym_uninitialized,
      sym_tag,
  [318735] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11008), 16,
      anon_sym_foreign,
      anon_sym_import,
      anon_sym_using,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_cast,
      anon_sym_transmute,
      anon_sym_auto_cast,
      anon_sym_map,
      anon_sym_bit_set,
      anon_sym_matrix,
      anon_sym_distinct,
      anon_sym_true,
      anon_sym_false,
      anon_sym_nil,
      sym_identifier,
    ACTIONS(11010), 17,
      sym_float,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT,
      sym_number,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_SQUOTE,
      sym_uninitialized,
      sym_tag,
  [318778] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11012), 16,
      anon_sym_foreign,
      anon_sym_import,
      anon_sym_using,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_cast,
      anon_sym_transmute,
      anon_sym_auto_cast,
      anon_sym_map,
      anon_sym_bit_set,
      anon_sym_matrix,
      anon_sym_distinct,
      anon_sym_true,
      anon_sym_false,
      anon_sym_nil,
      sym_identifier,
    ACTIONS(11014), 17,
      sym_float,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT,
      sym_number,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_SQUOTE,
      sym_uninitialized,
      sym_tag,
  [318821] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11016), 16,
      anon_sym_foreign,
      anon_sym_import,
      anon_sym_using,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_cast,
      anon_sym_transmute,
      anon_sym_auto_cast,
      anon_sym_map,
      anon_sym_bit_set,
      anon_sym_matrix,
      anon_sym_distinct,
      anon_sym_true,
      anon_sym_false,
      anon_sym_nil,
      sym_identifier,
    ACTIONS(11018), 17,
      sym_float,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT,
      sym_number,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_SQUOTE,
      sym_uninitialized,
      sym_tag,
  [318864] = 3,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11020), 16,
      anon_sym_foreign,
      anon_sym_import,
      anon_sym_using,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_cast,
      anon_sym_transmute,
      anon_sym_auto_cast,
      anon_sym_map,
      anon_sym_bit_set,
      anon_sym_matrix,
      anon_sym_distinct,
      anon_sym_true,
      anon_sym_false,
      anon_sym_nil,
      sym_identifier,
    ACTIONS(11022), 17,
      sym_float,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_TILDE,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT,
      sym_number,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_SQUOTE,
      sym_uninitialized,
      sym_tag,
  [318907] = 24,
    ACTIONS(7880), 1,
      anon_sym_DASH_GT,
    ACTIONS(7882), 1,
      anon_sym_DOT,
    ACTIONS(7884), 1,
      anon_sym_LBRACK,
    ACTIONS(7955), 1,
      anon_sym_PIPE,
    ACTIONS(7957), 1,
      anon_sym_PLUS,
    ACTIONS(7959), 1,
      anon_sym_DASH,
    ACTIONS(7961), 1,
      anon_sym_TILDE,
    ACTIONS(7963), 1,
      anon_sym_AMP,
    ACTIONS(7967), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7975), 1,
      anon_sym_AMP_TILDE,
    ACTIONS(7983), 1,
      anon_sym_or_return,
    ACTIONS(7985), 1,
      anon_sym_or_continue,
    ACTIONS(7987), 1,
      anon_sym_or_break,
    ACTIONS(7989), 1,
      anon_sym_CARET,
    ACTIONS(7886), 2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_DOT_DOT_LT,
    ACTIONS(7965), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or_else,
    ACTIONS(7969), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7971), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7977), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7979), 2,
      anon_sym_STAR,
      anon_sym_PERCENT_PERCENT,
    ACTIONS(7981), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8131), 2,
      anon_sym_in,
      anon_sym_not_in,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7973), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_TILDE_EQ,
  [318992] = 17,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(635), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_bit_set,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(11024), 1,
      sym_identifier,
    ACTIONS(11026), 1,
      anon_sym_map,
    ACTIONS(11028), 1,
      anon_sym_matrix,
    STATE(8066), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [319057] = 17,
    ACTIONS(677), 1,
      anon_sym_bit_set,
    ACTIONS(685), 1,
      anon_sym_DQUOTE,
    ACTIONS(687), 1,
      anon_sym_BQUOTE,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(693), 1,
      anon_sym_nil,
    ACTIONS(701), 1,
      anon_sym_LBRACE,
    ACTIONS(711), 1,
      anon_sym_LBRACK,
    ACTIONS(11030), 1,
      sym_identifier,
    ACTIONS(11032), 1,
      anon_sym_map,
    ACTIONS(11034), 1,
      anon_sym_matrix,
    STATE(3540), 1,
      sym_literal,
    STATE(8588), 1,
      sym_field_identifier,
    ACTIONS(691), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3602), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(683), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(3626), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [319122] = 17,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(635), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_bit_set,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(11024), 1,
      sym_identifier,
    ACTIONS(11026), 1,
      anon_sym_map,
    ACTIONS(11028), 1,
      anon_sym_matrix,
    STATE(8536), 1,
      sym_field_identifier,
    STATE(8543), 1,
      sym_literal,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [319187] = 17,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(635), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_bit_set,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(11024), 1,
      sym_identifier,
    ACTIONS(11026), 1,
      anon_sym_map,
    ACTIONS(11028), 1,
      anon_sym_matrix,
    STATE(7619), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [319252] = 17,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(635), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_bit_set,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(11026), 1,
      anon_sym_map,
    ACTIONS(11028), 1,
      anon_sym_matrix,
    ACTIONS(11036), 1,
      sym_identifier,
    STATE(7994), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [319317] = 17,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(635), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_bit_set,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(11024), 1,
      sym_identifier,
    ACTIONS(11026), 1,
      anon_sym_map,
    ACTIONS(11028), 1,
      anon_sym_matrix,
    STATE(7798), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [319382] = 17,
    ACTIONS(145), 1,
      anon_sym_bit_set,
    ACTIONS(153), 1,
      anon_sym_DQUOTE,
    ACTIONS(155), 1,
      anon_sym_BQUOTE,
    ACTIONS(157), 1,
      anon_sym_SQUOTE,
    ACTIONS(161), 1,
      anon_sym_nil,
    ACTIONS(165), 1,
      anon_sym_LBRACE,
    ACTIONS(175), 1,
      anon_sym_LBRACK,
    ACTIONS(11038), 1,
      sym_identifier,
    ACTIONS(11040), 1,
      anon_sym_map,
    ACTIONS(11042), 1,
      anon_sym_matrix,
    STATE(762), 1,
      sym_literal,
    STATE(8575), 1,
      sym_field_identifier,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(816), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(151), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(792), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [319447] = 17,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(635), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_bit_set,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(11024), 1,
      sym_identifier,
    ACTIONS(11026), 1,
      anon_sym_map,
    ACTIONS(11028), 1,
      anon_sym_matrix,
    STATE(8140), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [319512] = 17,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(635), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_bit_set,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(11024), 1,
      sym_identifier,
    ACTIONS(11026), 1,
      anon_sym_map,
    ACTIONS(11028), 1,
      anon_sym_matrix,
    STATE(8316), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [319577] = 17,
    ACTIONS(1279), 1,
      anon_sym_bit_set,
    ACTIONS(1287), 1,
      anon_sym_SQUOTE,
    ACTIONS(1291), 1,
      anon_sym_nil,
    ACTIONS(1293), 1,
      anon_sym_LBRACE,
    ACTIONS(1303), 1,
      anon_sym_LBRACK,
    ACTIONS(1305), 1,
      anon_sym_DQUOTE,
    ACTIONS(1307), 1,
      anon_sym_BQUOTE,
    ACTIONS(11044), 1,
      sym_identifier,
    ACTIONS(11046), 1,
      anon_sym_map,
    ACTIONS(11048), 1,
      anon_sym_matrix,
    STATE(4375), 1,
      sym_literal,
    STATE(8552), 1,
      sym_field_identifier,
    ACTIONS(1289), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4279), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(1285), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4227), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [319642] = 17,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(635), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_bit_set,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(11024), 1,
      sym_identifier,
    ACTIONS(11026), 1,
      anon_sym_map,
    ACTIONS(11028), 1,
      anon_sym_matrix,
    STATE(8215), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [319707] = 17,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(635), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_bit_set,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(11024), 1,
      sym_identifier,
    ACTIONS(11026), 1,
      anon_sym_map,
    ACTIONS(11028), 1,
      anon_sym_matrix,
    STATE(7788), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [319772] = 17,
    ACTIONS(553), 1,
      anon_sym_LBRACE,
    ACTIONS(565), 1,
      anon_sym_LBRACK,
    ACTIONS(575), 1,
      anon_sym_bit_set,
    ACTIONS(583), 1,
      anon_sym_DQUOTE,
    ACTIONS(585), 1,
      anon_sym_BQUOTE,
    ACTIONS(587), 1,
      anon_sym_SQUOTE,
    ACTIONS(591), 1,
      anon_sym_nil,
    ACTIONS(11050), 1,
      sym_identifier,
    ACTIONS(11052), 1,
      anon_sym_map,
    ACTIONS(11054), 1,
      anon_sym_matrix,
    STATE(3180), 1,
      sym_literal,
    STATE(8600), 1,
      sym_field_identifier,
    ACTIONS(589), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3359), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(581), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(3352), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [319837] = 17,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(635), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_bit_set,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(11024), 1,
      sym_identifier,
    ACTIONS(11026), 1,
      anon_sym_map,
    ACTIONS(11028), 1,
      anon_sym_matrix,
    STATE(7686), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [319902] = 17,
    ACTIONS(221), 1,
      anon_sym_bit_set,
    ACTIONS(229), 1,
      anon_sym_DQUOTE,
    ACTIONS(231), 1,
      anon_sym_BQUOTE,
    ACTIONS(233), 1,
      anon_sym_SQUOTE,
    ACTIONS(237), 1,
      anon_sym_nil,
    ACTIONS(239), 1,
      anon_sym_LBRACE,
    ACTIONS(247), 1,
      anon_sym_LBRACK,
    ACTIONS(11056), 1,
      sym_identifier,
    ACTIONS(11058), 1,
      anon_sym_map,
    ACTIONS(11060), 1,
      anon_sym_matrix,
    STATE(2349), 1,
      sym_literal,
    STATE(8566), 1,
      sym_field_identifier,
    ACTIONS(235), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(2434), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(227), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(2287), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [319967] = 17,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(635), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_bit_set,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(11024), 1,
      sym_identifier,
    ACTIONS(11026), 1,
      anon_sym_map,
    ACTIONS(11028), 1,
      anon_sym_matrix,
    STATE(8363), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [320032] = 17,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(635), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_bit_set,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(11024), 1,
      sym_identifier,
    ACTIONS(11026), 1,
      anon_sym_map,
    ACTIONS(11028), 1,
      anon_sym_matrix,
    STATE(8130), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [320097] = 17,
    ACTIONS(509), 1,
      anon_sym_LBRACE,
    ACTIONS(521), 1,
      anon_sym_LBRACK,
    ACTIONS(531), 1,
      anon_sym_bit_set,
    ACTIONS(539), 1,
      anon_sym_DQUOTE,
    ACTIONS(541), 1,
      anon_sym_BQUOTE,
    ACTIONS(543), 1,
      anon_sym_SQUOTE,
    ACTIONS(547), 1,
      anon_sym_nil,
    ACTIONS(11062), 1,
      sym_identifier,
    ACTIONS(11064), 1,
      anon_sym_map,
    ACTIONS(11066), 1,
      anon_sym_matrix,
    STATE(3008), 1,
      sym_literal,
    STATE(8614), 1,
      sym_field_identifier,
    ACTIONS(545), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3109), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(537), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(3096), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [320162] = 17,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(635), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_bit_set,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(11024), 1,
      sym_identifier,
    ACTIONS(11026), 1,
      anon_sym_map,
    ACTIONS(11028), 1,
      anon_sym_matrix,
    STATE(8459), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [320227] = 17,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(635), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_bit_set,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(11024), 1,
      sym_identifier,
    ACTIONS(11026), 1,
      anon_sym_map,
    ACTIONS(11028), 1,
      anon_sym_matrix,
    STATE(7895), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [320292] = 17,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(635), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_bit_set,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(11026), 1,
      anon_sym_map,
    ACTIONS(11028), 1,
      anon_sym_matrix,
    ACTIONS(11068), 1,
      sym_identifier,
    STATE(8466), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [320357] = 17,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(635), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_bit_set,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(11024), 1,
      sym_identifier,
    ACTIONS(11026), 1,
      anon_sym_map,
    ACTIONS(11028), 1,
      anon_sym_matrix,
    STATE(8158), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [320422] = 17,
    ACTIONS(623), 1,
      anon_sym_LBRACE,
    ACTIONS(635), 1,
      anon_sym_LBRACK,
    ACTIONS(645), 1,
      anon_sym_bit_set,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(657), 1,
      anon_sym_SQUOTE,
    ACTIONS(661), 1,
      anon_sym_nil,
    ACTIONS(11024), 1,
      sym_identifier,
    ACTIONS(11026), 1,
      anon_sym_map,
    ACTIONS(11028), 1,
      anon_sym_matrix,
    STATE(7634), 1,
      sym_literal,
    STATE(8536), 1,
      sym_field_identifier,
    ACTIONS(659), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(651), 3,
      sym_float,
      sym_number,
      sym_uninitialized,
    STATE(4011), 8,
      sym_struct,
      sym_map,
      sym_bit_set,
      sym_matrix,
      sym_string,
      sym_character,
      sym_boolean,
      sym_nil,
  [320487] = 5,
    ACTIONS(7642), 1,
      anon_sym_COLON,
    ACTIONS(11070), 1,
      anon_sym_COMMA,
    STATE(6491), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7640), 16,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
      anon_sym_in,
  [320520] = 5,
    ACTIONS(7642), 1,
      anon_sym_COLON,
    ACTIONS(11073), 1,
      anon_sym_COMMA,
    STATE(6492), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7640), 16,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
  [320553] = 7,
    ACTIONS(6967), 1,
      anon_sym_COMMA,
    ACTIONS(9296), 1,
      anon_sym_COLON,
    ACTIONS(11076), 1,
      anon_sym_COLON_COLON,
    STATE(6492), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(9298), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11078), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
  [320590] = 7,
    ACTIONS(6837), 1,
      anon_sym_COMMA,
    ACTIONS(9615), 1,
      anon_sym_COLON,
    ACTIONS(11082), 1,
      anon_sym_in,
    STATE(6491), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(9617), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11080), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
  [320627] = 10,
    ACTIONS(3785), 1,
      anon_sym_SLASH,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6953), 1,
      sym_uninitialized,
    ACTIONS(6955), 1,
      sym_tag,
    ACTIONS(11084), 1,
      anon_sym_DASH_GT,
    ACTIONS(11086), 1,
      anon_sym_where,
    STATE(3019), 1,
      sym_where_clause,
    STATE(3176), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3781), 10,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [320669] = 6,
    ACTIONS(4187), 1,
      anon_sym_SLASH,
    ACTIONS(11088), 1,
      anon_sym_COLON,
    ACTIONS(11090), 1,
      anon_sym_DOT2,
    STATE(3178), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4185), 14,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [320703] = 10,
    ACTIONS(3785), 1,
      anon_sym_SLASH,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7298), 1,
      sym_uninitialized,
    ACTIONS(7300), 1,
      sym_tag,
    ACTIONS(11092), 1,
      anon_sym_DASH_GT,
    ACTIONS(11094), 1,
      anon_sym_where,
    STATE(3444), 1,
      sym_where_clause,
    STATE(3547), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3781), 10,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [320745] = 10,
    ACTIONS(3785), 1,
      anon_sym_SLASH,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7263), 1,
      sym_uninitialized,
    ACTIONS(7265), 1,
      sym_tag,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11096), 1,
      anon_sym_DASH_GT,
    STATE(3147), 1,
      sym_where_clause,
    STATE(3832), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3781), 10,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [320787] = 10,
    ACTIONS(4117), 1,
      anon_sym_SLASH,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7292), 1,
      sym_uninitialized,
    ACTIONS(7294), 1,
      sym_tag,
    ACTIONS(11094), 1,
      anon_sym_where,
    ACTIONS(11098), 1,
      anon_sym_DASH_GT,
    STATE(3397), 1,
      sym_where_clause,
    STATE(3526), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4113), 10,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [320829] = 10,
    ACTIONS(4117), 1,
      anon_sym_SLASH,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6973), 1,
      sym_uninitialized,
    ACTIONS(6975), 1,
      sym_tag,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11100), 1,
      anon_sym_DASH_GT,
    STATE(3040), 1,
      sym_where_clause,
    STATE(3162), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4113), 10,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [320871] = 6,
    ACTIONS(6967), 1,
      anon_sym_COMMA,
    ACTIONS(9615), 1,
      anon_sym_COLON,
    STATE(6492), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(9617), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11080), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
  [320905] = 10,
    ACTIONS(4117), 1,
      anon_sym_SLASH,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7103), 1,
      sym_uninitialized,
    ACTIONS(7105), 1,
      sym_tag,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11102), 1,
      anon_sym_DASH_GT,
    STATE(3351), 1,
      sym_where_clause,
    STATE(3821), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4113), 10,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [320947] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(7006), 1,
      sym_uninitialized,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11104), 1,
      sym_tag,
    STATE(2998), 1,
      sym_where_clause,
    STATE(3218), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 10,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [320986] = 6,
    ACTIONS(4187), 1,
      anon_sym_SLASH,
    ACTIONS(11106), 1,
      anon_sym_COLON,
    ACTIONS(11108), 1,
      anon_sym_DOT2,
    STATE(2944), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4185), 13,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [321019] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11114), 1,
      anon_sym_RPAREN,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(8313), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [321066] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    ACTIONS(11124), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(8542), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [321113] = 10,
    ACTIONS(3785), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7040), 1,
      sym_uninitialized,
    ACTIONS(7042), 1,
      sym_tag,
    ACTIONS(11126), 1,
      anon_sym_DASH_GT,
    ACTIONS(11128), 1,
      anon_sym_where,
    STATE(3298), 1,
      sym_where_clause,
    STATE(3720), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3781), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [321154] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    ACTIONS(11130), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(8542), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [321201] = 10,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(6981), 1,
      sym_uninitialized,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11132), 1,
      anon_sym_SLASH,
    ACTIONS(11134), 1,
      sym_tag,
    STATE(3014), 1,
      sym_where_clause,
    STATE(3199), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [321242] = 9,
    ACTIONS(3421), 1,
      anon_sym_SLASH,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6981), 1,
      sym_uninitialized,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11134), 1,
      sym_tag,
    STATE(3014), 1,
      sym_where_clause,
    STATE(3199), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 10,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [321281] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7169), 1,
      sym_uninitialized,
    ACTIONS(7171), 1,
      sym_tag,
    ACTIONS(11086), 1,
      anon_sym_where,
    STATE(3321), 1,
      sym_where_clause,
    STATE(3876), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 10,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [321320] = 10,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7275), 1,
      sym_uninitialized,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(11094), 1,
      anon_sym_where,
    ACTIONS(11136), 1,
      anon_sym_SLASH,
    ACTIONS(11138), 1,
      sym_tag,
    STATE(3372), 1,
      sym_where_clause,
    STATE(3609), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 9,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [321361] = 9,
    ACTIONS(3421), 1,
      anon_sym_SLASH,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7306), 1,
      sym_uninitialized,
    ACTIONS(11094), 1,
      anon_sym_where,
    ACTIONS(11140), 1,
      sym_tag,
    STATE(3448), 1,
      sym_where_clause,
    STATE(3572), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 10,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [321400] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    ACTIONS(11142), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(8542), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [321447] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    ACTIONS(11144), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(8542), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [321494] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    ACTIONS(11146), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7992), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [321541] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7169), 1,
      sym_uninitialized,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11148), 1,
      sym_tag,
    STATE(3321), 1,
      sym_where_clause,
    STATE(3876), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 10,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [321580] = 10,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(7169), 1,
      sym_uninitialized,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11132), 1,
      anon_sym_SLASH,
    ACTIONS(11148), 1,
      sym_tag,
    STATE(3321), 1,
      sym_where_clause,
    STATE(3876), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [321621] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    ACTIONS(11150), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(8542), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [321668] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    ACTIONS(11152), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(8542), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [321715] = 10,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(7006), 1,
      sym_uninitialized,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11104), 1,
      sym_tag,
    ACTIONS(11132), 1,
      anon_sym_SLASH,
    STATE(2998), 1,
      sym_where_clause,
    STATE(3218), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [321756] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    ACTIONS(11154), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(8542), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [321803] = 10,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7306), 1,
      sym_uninitialized,
    ACTIONS(11094), 1,
      anon_sym_where,
    ACTIONS(11136), 1,
      anon_sym_SLASH,
    ACTIONS(11140), 1,
      sym_tag,
    STATE(3448), 1,
      sym_where_clause,
    STATE(3572), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 9,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [321844] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7275), 1,
      sym_uninitialized,
    ACTIONS(7316), 1,
      sym_tag,
    ACTIONS(11094), 1,
      anon_sym_where,
    STATE(3372), 1,
      sym_where_clause,
    STATE(3609), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 10,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [321883] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(7006), 1,
      sym_uninitialized,
    ACTIONS(7012), 1,
      sym_tag,
    ACTIONS(11086), 1,
      anon_sym_where,
    STATE(2998), 1,
      sym_where_clause,
    STATE(3218), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 10,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [321922] = 10,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6872), 1,
      sym_uninitialized,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11132), 1,
      anon_sym_SLASH,
    ACTIONS(11156), 1,
      sym_tag,
    STATE(2994), 1,
      sym_where_clause,
    STATE(3235), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [321963] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    ACTIONS(11158), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7724), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [322010] = 10,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(7117), 1,
      sym_uninitialized,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11132), 1,
      anon_sym_SLASH,
    ACTIONS(11160), 1,
      sym_tag,
    STATE(3316), 1,
      sym_where_clause,
    STATE(3884), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [322051] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6872), 1,
      sym_uninitialized,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11156), 1,
      sym_tag,
    STATE(2994), 1,
      sym_where_clause,
    STATE(3235), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 10,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [322090] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7117), 1,
      sym_uninitialized,
    ACTIONS(7119), 1,
      sym_tag,
    ACTIONS(11086), 1,
      anon_sym_where,
    STATE(3316), 1,
      sym_where_clause,
    STATE(3884), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 10,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [322129] = 10,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7310), 1,
      sym_uninitialized,
    ACTIONS(11094), 1,
      anon_sym_where,
    ACTIONS(11136), 1,
      anon_sym_SLASH,
    ACTIONS(11162), 1,
      sym_tag,
    STATE(3454), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 9,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [322170] = 5,
    ACTIONS(6967), 1,
      anon_sym_COMMA,
    STATE(6492), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(9793), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11164), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_AMP_TILDE_EQ,
  [322201] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    ACTIONS(11166), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(8542), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [322248] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7310), 1,
      sym_uninitialized,
    ACTIONS(11094), 1,
      anon_sym_where,
    ACTIONS(11162), 1,
      sym_tag,
    STATE(3454), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 10,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [322287] = 9,
    ACTIONS(3421), 1,
      anon_sym_SLASH,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7137), 1,
      sym_uninitialized,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11168), 1,
      sym_tag,
    STATE(3354), 1,
      sym_where_clause,
    STATE(3860), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 10,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [322326] = 9,
    ACTIONS(3675), 1,
      anon_sym_SLASH,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7318), 1,
      sym_uninitialized,
    ACTIONS(7320), 1,
      sym_tag,
    ACTIONS(11094), 1,
      anon_sym_where,
    STATE(3446), 1,
      sym_where_clause,
    STATE(3617), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3671), 10,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [322365] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    ACTIONS(11170), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7914), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [322412] = 10,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(7137), 1,
      sym_uninitialized,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11132), 1,
      anon_sym_SLASH,
    ACTIONS(11168), 1,
      sym_tag,
    STATE(3354), 1,
      sym_where_clause,
    STATE(3860), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [322453] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7310), 1,
      sym_uninitialized,
    ACTIONS(7336), 1,
      sym_tag,
    ACTIONS(11094), 1,
      anon_sym_where,
    STATE(3454), 1,
      sym_where_clause,
    STATE(3592), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 10,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [322492] = 9,
    ACTIONS(3675), 1,
      anon_sym_SLASH,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7110), 1,
      sym_uninitialized,
    ACTIONS(7112), 1,
      sym_tag,
    ACTIONS(11086), 1,
      anon_sym_where,
    STATE(3303), 1,
      sym_where_clause,
    STATE(3889), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3671), 10,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [322531] = 10,
    ACTIONS(3785), 1,
      anon_sym_SLASH,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6931), 1,
      sym_uninitialized,
    ACTIONS(6933), 1,
      sym_tag,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11172), 1,
      anon_sym_DASH_GT,
    STATE(2917), 1,
      sym_where_clause,
    STATE(3018), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3781), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [322572] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    ACTIONS(11174), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(8542), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [322619] = 10,
    ACTIONS(4117), 1,
      anon_sym_SLASH,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(7000), 1,
      sym_uninitialized,
    ACTIONS(7002), 1,
      sym_tag,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11176), 1,
      anon_sym_DASH_GT,
    STATE(2922), 1,
      sym_where_clause,
    STATE(3038), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4113), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [322660] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(7117), 1,
      sym_uninitialized,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11160), 1,
      sym_tag,
    STATE(3316), 1,
      sym_where_clause,
    STATE(3884), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 10,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [322699] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6872), 1,
      sym_uninitialized,
    ACTIONS(6874), 1,
      sym_tag,
    ACTIONS(11086), 1,
      anon_sym_where,
    STATE(2994), 1,
      sym_where_clause,
    STATE(3235), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 10,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [322738] = 9,
    ACTIONS(3675), 1,
      anon_sym_SLASH,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6935), 1,
      sym_uninitialized,
    ACTIONS(6937), 1,
      sym_tag,
    ACTIONS(11086), 1,
      anon_sym_where,
    STATE(2990), 1,
      sym_where_clause,
    STATE(3243), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3671), 10,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [322777] = 10,
    ACTIONS(4117), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7034), 1,
      sym_uninitialized,
    ACTIONS(7036), 1,
      sym_tag,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11178), 1,
      anon_sym_DASH_GT,
    STATE(3301), 1,
      sym_where_clause,
    STATE(3756), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4113), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [322818] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    ACTIONS(11180), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(8542), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [322865] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    ACTIONS(11182), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(8542), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [322912] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    ACTIONS(11184), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(8285), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [322959] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    ACTIONS(11186), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(8542), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [323006] = 13,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    ACTIONS(11188), 1,
      anon_sym_RPAREN,
    STATE(3887), 1,
      sym_procedure,
    STATE(7871), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [323053] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(7271), 1,
      anon_sym_LBRACE,
    ACTIONS(7275), 1,
      sym_uninitialized,
    ACTIONS(11094), 1,
      anon_sym_where,
    ACTIONS(11138), 1,
      sym_tag,
    STATE(3372), 1,
      sym_where_clause,
    STATE(3609), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 10,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [323092] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      sym_uninitialized,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11190), 1,
      sym_tag,
    STATE(2921), 1,
      sym_where_clause,
    STATE(3072), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [323130] = 9,
    ACTIONS(3675), 1,
      anon_sym_SLASH,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6943), 1,
      sym_uninitialized,
    ACTIONS(6945), 1,
      sym_tag,
    ACTIONS(11128), 1,
      anon_sym_where,
    STATE(2930), 1,
      sym_where_clause,
    STATE(3085), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3671), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [323168] = 9,
    ACTIONS(3675), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7243), 1,
      sym_uninitialized,
    ACTIONS(7245), 1,
      sym_tag,
    ACTIONS(11128), 1,
      anon_sym_where,
    STATE(3293), 1,
      sym_where_clause,
    STATE(3773), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3671), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [323206] = 9,
    ACTIONS(3421), 1,
      anon_sym_SLASH,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6920), 1,
      sym_uninitialized,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11192), 1,
      sym_tag,
    STATE(2932), 1,
      sym_where_clause,
    STATE(3055), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [323244] = 10,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6920), 1,
      sym_uninitialized,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11192), 1,
      sym_tag,
    ACTIONS(11194), 1,
      anon_sym_SLASH,
    STATE(2932), 1,
      sym_where_clause,
    STATE(3055), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [323284] = 9,
    ACTIONS(3421), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7251), 1,
      sym_uninitialized,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11196), 1,
      sym_tag,
    STATE(3181), 1,
      sym_where_clause,
    STATE(3833), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [323322] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7028), 1,
      sym_uninitialized,
    ACTIONS(7259), 1,
      sym_tag,
    ACTIONS(11128), 1,
      anon_sym_where,
    STATE(3175), 1,
      sym_where_clause,
    STATE(3888), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [323360] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7028), 1,
      sym_uninitialized,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11198), 1,
      sym_tag,
    STATE(3175), 1,
      sym_where_clause,
    STATE(3888), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [323398] = 10,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7251), 1,
      sym_uninitialized,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11194), 1,
      anon_sym_SLASH,
    ACTIONS(11196), 1,
      sym_tag,
    STATE(3181), 1,
      sym_where_clause,
    STATE(3833), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [323438] = 10,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7028), 1,
      sym_uninitialized,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11194), 1,
      anon_sym_SLASH,
    ACTIONS(11198), 1,
      sym_tag,
    STATE(3175), 1,
      sym_where_clause,
    STATE(3888), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [323478] = 5,
    ACTIONS(4722), 1,
      anon_sym_SLASH,
    ACTIONS(11200), 1,
      anon_sym_COMMA,
    STATE(6564), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4717), 13,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [323508] = 6,
    ACTIONS(4187), 1,
      anon_sym_SLASH,
    ACTIONS(11203), 1,
      anon_sym_COLON,
    ACTIONS(11205), 1,
      anon_sym_DOT2,
    STATE(2801), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4185), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      sym_uninitialized,
      sym_tag,
  [323540] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      sym_uninitialized,
    ACTIONS(6929), 1,
      sym_tag,
    ACTIONS(11128), 1,
      anon_sym_where,
    STATE(2927), 1,
      sym_where_clause,
    STATE(3081), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [323578] = 10,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7547), 1,
      sym_uninitialized,
    ACTIONS(11094), 1,
      anon_sym_where,
    ACTIONS(11136), 1,
      anon_sym_SLASH,
    ACTIONS(11207), 1,
      sym_tag,
    STATE(3715), 1,
      sym_where_clause,
    STATE(4434), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 8,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [323618] = 12,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11110), 1,
      sym_identifier,
    ACTIONS(11112), 1,
      anon_sym_using,
    ACTIONS(11116), 1,
      anon_sym_DOLLAR,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11122), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    STATE(8542), 2,
      sym_parameter,
      sym_default_parameter,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7433), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [323662] = 10,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6927), 1,
      sym_uninitialized,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11194), 1,
      anon_sym_SLASH,
    ACTIONS(11209), 1,
      sym_tag,
    STATE(2927), 1,
      sym_where_clause,
    STATE(3081), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [323702] = 10,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_uninitialized,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11194), 1,
      anon_sym_SLASH,
    ACTIONS(11211), 1,
      sym_tag,
    STATE(3165), 1,
      sym_where_clause,
    STATE(3909), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [323742] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      sym_uninitialized,
    ACTIONS(6957), 1,
      sym_tag,
    ACTIONS(11128), 1,
      anon_sym_where,
    STATE(2921), 1,
      sym_where_clause,
    STATE(3072), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [323780] = 10,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7440), 1,
      sym_uninitialized,
    ACTIONS(11094), 1,
      anon_sym_where,
    ACTIONS(11136), 1,
      anon_sym_SLASH,
    ACTIONS(11213), 1,
      sym_tag,
    STATE(3669), 1,
      sym_where_clause,
    STATE(4535), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 8,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [323820] = 5,
    ACTIONS(4665), 1,
      anon_sym_SLASH,
    ACTIONS(7863), 1,
      anon_sym_COMMA,
    STATE(6564), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4661), 13,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [323850] = 10,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      sym_uninitialized,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11190), 1,
      sym_tag,
    ACTIONS(11194), 1,
      anon_sym_SLASH,
    STATE(2921), 1,
      sym_where_clause,
    STATE(3072), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [323890] = 10,
    ACTIONS(3785), 1,
      anon_sym_SLASH,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7183), 1,
      sym_uninitialized,
    ACTIONS(7185), 1,
      sym_tag,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11215), 1,
      anon_sym_DASH_GT,
    STATE(3439), 1,
      sym_where_clause,
    STATE(3768), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3781), 8,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [323930] = 10,
    ACTIONS(4117), 1,
      anon_sym_SLASH,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7189), 1,
      sym_uninitialized,
    ACTIONS(7191), 1,
      sym_tag,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11217), 1,
      anon_sym_DASH_GT,
    STATE(3375), 1,
      sym_where_clause,
    STATE(3764), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4113), 8,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [323970] = 10,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7541), 1,
      sym_uninitialized,
    ACTIONS(11094), 1,
      anon_sym_where,
    ACTIONS(11136), 1,
      anon_sym_SLASH,
    ACTIONS(11219), 1,
      sym_tag,
    STATE(3639), 1,
      sym_where_clause,
    STATE(4514), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 8,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [324010] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_uninitialized,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11211), 1,
      sym_tag,
    STATE(3165), 1,
      sym_where_clause,
    STATE(3909), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [324048] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      sym_uninitialized,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11209), 1,
      sym_tag,
    STATE(2927), 1,
      sym_where_clause,
    STATE(3081), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [324086] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_uninitialized,
    ACTIONS(7267), 1,
      sym_tag,
    ACTIONS(11128), 1,
      anon_sym_where,
    STATE(3165), 1,
      sym_where_clause,
    STATE(3909), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 9,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [324124] = 5,
    ACTIONS(4722), 1,
      anon_sym_SLASH,
    ACTIONS(11221), 1,
      anon_sym_COMMA,
    STATE(6581), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4717), 13,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [324154] = 5,
    ACTIONS(4665), 1,
      anon_sym_SLASH,
    ACTIONS(7736), 1,
      anon_sym_COMMA,
    STATE(6581), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4661), 13,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [324184] = 5,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(11132), 1,
      anon_sym_SLASH,
    ACTIONS(11224), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5386), 12,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [324213] = 4,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(11132), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5482), 13,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [324240] = 5,
    ACTIONS(4665), 1,
      anon_sym_SLASH,
    ACTIONS(8195), 1,
      anon_sym_COMMA,
    STATE(6597), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4661), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      sym_uninitialized,
      sym_tag,
  [324269] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      sym_uninitialized,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11226), 1,
      sym_tag,
    STATE(3425), 1,
      sym_where_clause,
    STATE(3804), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 8,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [324306] = 9,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7537), 1,
      sym_uninitialized,
    ACTIONS(7539), 1,
      sym_tag,
    ACTIONS(11094), 1,
      anon_sym_where,
    ACTIONS(11228), 1,
      anon_sym_DASH_GT,
    STATE(3654), 1,
      sym_where_clause,
    STATE(4506), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3781), 8,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [324343] = 4,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(11132), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5464), 13,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [324370] = 4,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(11132), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5468), 13,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [324397] = 4,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(11136), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5464), 13,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [324424] = 4,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(11132), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4800), 13,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [324451] = 5,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(11136), 1,
      anon_sym_SLASH,
    ACTIONS(11230), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5386), 12,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [324480] = 4,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(11136), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5448), 13,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [324507] = 4,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(11136), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5482), 13,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [324534] = 4,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(11132), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5448), 13,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [324561] = 10,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7177), 1,
      sym_uninitialized,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11132), 1,
      anon_sym_SLASH,
    ACTIONS(11232), 1,
      sym_tag,
    STATE(3407), 1,
      sym_where_clause,
    STATE(3809), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [324600] = 5,
    ACTIONS(4722), 1,
      anon_sym_SLASH,
    ACTIONS(11234), 1,
      anon_sym_COMMA,
    STATE(6597), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4717), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      sym_uninitialized,
      sym_tag,
  [324629] = 9,
    ACTIONS(3421), 1,
      anon_sym_SLASH,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7177), 1,
      sym_uninitialized,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11232), 1,
      sym_tag,
    STATE(3407), 1,
      sym_where_clause,
    STATE(3809), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 8,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [324666] = 10,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7165), 1,
      sym_uninitialized,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11132), 1,
      anon_sym_SLASH,
    ACTIONS(11237), 1,
      sym_tag,
    STATE(3414), 1,
      sym_where_clause,
    STATE(3798), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [324705] = 4,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(11136), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5468), 13,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [324732] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7165), 1,
      sym_uninitialized,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11237), 1,
      sym_tag,
    STATE(3414), 1,
      sym_where_clause,
    STATE(3798), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 8,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [324769] = 4,
    ACTIONS(7302), 1,
      anon_sym_LPAREN,
    ACTIONS(11136), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4800), 13,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
      sym_uninitialized,
      sym_tag,
  [324796] = 10,
    ACTIONS(6977), 1,
      anon_sym_LPAREN,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      sym_uninitialized,
    ACTIONS(11086), 1,
      anon_sym_where,
    ACTIONS(11132), 1,
      anon_sym_SLASH,
    ACTIONS(11226), 1,
      sym_tag,
    STATE(3425), 1,
      sym_where_clause,
    STATE(3804), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [324835] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7165), 1,
      sym_uninitialized,
    ACTIONS(7167), 1,
      sym_tag,
    ACTIONS(11086), 1,
      anon_sym_where,
    STATE(3414), 1,
      sym_where_clause,
    STATE(3798), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 8,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [324872] = 9,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7529), 1,
      sym_uninitialized,
    ACTIONS(7531), 1,
      sym_tag,
    ACTIONS(11094), 1,
      anon_sym_where,
    ACTIONS(11239), 1,
      anon_sym_DASH_GT,
    STATE(3663), 1,
      sym_where_clause,
    STATE(4503), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4113), 8,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [324909] = 9,
    ACTIONS(3675), 1,
      anon_sym_SLASH,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7143), 1,
      sym_uninitialized,
    ACTIONS(7145), 1,
      sym_tag,
    ACTIONS(11086), 1,
      anon_sym_where,
    STATE(3443), 1,
      sym_where_clause,
    STATE(3807), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3671), 8,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [324946] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(7141), 1,
      anon_sym_LBRACE,
    ACTIONS(7147), 1,
      sym_uninitialized,
    ACTIONS(7149), 1,
      sym_tag,
    ACTIONS(11086), 1,
      anon_sym_where,
    STATE(3425), 1,
      sym_where_clause,
    STATE(3804), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 8,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [324983] = 10,
    ACTIONS(4117), 1,
      anon_sym_SLASH,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7784), 1,
      sym_uninitialized,
    ACTIONS(7786), 1,
      sym_tag,
    ACTIONS(11241), 1,
      anon_sym_DASH_GT,
    ACTIONS(11243), 1,
      anon_sym_where,
    STATE(4112), 1,
      sym_where_clause,
    STATE(4268), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4113), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [325021] = 8,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7541), 1,
      sym_uninitialized,
    ACTIONS(11094), 1,
      anon_sym_where,
    ACTIONS(11219), 1,
      sym_tag,
    STATE(3639), 1,
      sym_where_clause,
    STATE(4514), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 8,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [325055] = 8,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7547), 1,
      sym_uninitialized,
    ACTIONS(7551), 1,
      sym_tag,
    ACTIONS(11094), 1,
      anon_sym_where,
    STATE(3715), 1,
      sym_where_clause,
    STATE(4434), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 8,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [325089] = 8,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7547), 1,
      sym_uninitialized,
    ACTIONS(11094), 1,
      anon_sym_where,
    ACTIONS(11207), 1,
      sym_tag,
    STATE(3715), 1,
      sym_where_clause,
    STATE(4434), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 8,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [325123] = 8,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7440), 1,
      sym_uninitialized,
    ACTIONS(7442), 1,
      sym_tag,
    ACTIONS(11094), 1,
      anon_sym_where,
    STATE(3669), 1,
      sym_where_clause,
    STATE(4535), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 8,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [325157] = 8,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7440), 1,
      sym_uninitialized,
    ACTIONS(11094), 1,
      anon_sym_where,
    ACTIONS(11213), 1,
      sym_tag,
    STATE(3669), 1,
      sym_where_clause,
    STATE(4535), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 8,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [325191] = 5,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11194), 1,
      anon_sym_SLASH,
    ACTIONS(11245), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5386), 11,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      sym_uninitialized,
      sym_tag,
  [325219] = 11,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11247), 1,
      sym_identifier,
    ACTIONS(11249), 1,
      anon_sym_using,
    ACTIONS(11251), 1,
      anon_sym_DOLLAR,
    ACTIONS(11253), 1,
      anon_sym_LBRACK,
    ACTIONS(11255), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7566), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [325259] = 4,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11194), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5468), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      sym_uninitialized,
      sym_tag,
  [325285] = 4,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11194), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4800), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      sym_uninitialized,
      sym_tag,
  [325311] = 4,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11194), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5482), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      sym_uninitialized,
      sym_tag,
  [325337] = 6,
    ACTIONS(11257), 1,
      anon_sym_LBRACE,
    ACTIONS(11261), 1,
      anon_sym_LPAREN,
    STATE(6502), 1,
      sym_parameters,
    STATE(8565), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [325367] = 4,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11194), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5448), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      sym_uninitialized,
      sym_tag,
  [325393] = 10,
    ACTIONS(3785), 1,
      anon_sym_SLASH,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7778), 1,
      sym_uninitialized,
    ACTIONS(7780), 1,
      sym_tag,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11263), 1,
      anon_sym_DASH_GT,
    STATE(4102), 1,
      sym_where_clause,
    STATE(4264), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3781), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [325431] = 6,
    ACTIONS(4187), 1,
      anon_sym_SLASH,
    ACTIONS(11265), 1,
      anon_sym_COLON,
    ACTIONS(11267), 1,
      anon_sym_DOT2,
    STATE(3892), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4185), 10,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [325461] = 4,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11194), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5464), 12,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      sym_uninitialized,
      sym_tag,
  [325487] = 6,
    ACTIONS(11261), 1,
      anon_sym_LPAREN,
    ACTIONS(11269), 1,
      anon_sym_LBRACE,
    STATE(6502), 1,
      sym_parameters,
    STATE(8565), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [325517] = 8,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    ACTIONS(7556), 1,
      sym_uninitialized,
    ACTIONS(7558), 1,
      sym_tag,
    ACTIONS(11094), 1,
      anon_sym_where,
    STATE(3705), 1,
      sym_where_clause,
    STATE(4512), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3671), 8,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [325551] = 10,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(7000), 1,
      sym_uninitialized,
    ACTIONS(7002), 1,
      sym_tag,
    ACTIONS(11271), 1,
      anon_sym_DASH_GT,
    ACTIONS(11273), 1,
      anon_sym_where,
    STATE(2922), 1,
      sym_where_clause,
    STATE(3038), 1,
      sym_block,
    ACTIONS(4117), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4113), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [325588] = 5,
    ACTIONS(11261), 1,
      anon_sym_LPAREN,
    STATE(6576), 1,
      sym_parameters,
    STATE(8495), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [325615] = 5,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(6670), 1,
      sym_parameters,
    STATE(8602), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [325642] = 5,
    ACTIONS(11277), 1,
      anon_sym_LPAREN,
    STATE(2347), 1,
      sym_parameters,
    STATE(8608), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [325669] = 5,
    ACTIONS(11279), 1,
      anon_sym_LPAREN,
    STATE(6605), 1,
      sym_parameters,
    STATE(8424), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [325696] = 5,
    ACTIONS(11281), 1,
      anon_sym_LPAREN,
    STATE(3822), 1,
      sym_parameters,
    STATE(8592), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [325723] = 10,
    ACTIONS(3785), 1,
      anon_sym_SLASH,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11285), 1,
      anon_sym_DASH_GT,
    ACTIONS(11287), 1,
      sym_uninitialized,
    ACTIONS(11289), 1,
      sym_tag,
    STATE(6796), 1,
      sym_where_clause,
    STATE(6983), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3781), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [325760] = 9,
    ACTIONS(3675), 1,
      anon_sym_SLASH,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7752), 1,
      sym_uninitialized,
    ACTIONS(7754), 1,
      sym_tag,
    ACTIONS(11243), 1,
      anon_sym_where,
    STATE(4071), 1,
      sym_where_clause,
    STATE(4224), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3671), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [325795] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7756), 1,
      sym_uninitialized,
    ACTIONS(7758), 1,
      sym_tag,
    ACTIONS(11243), 1,
      anon_sym_where,
    STATE(4081), 1,
      sym_where_clause,
    STATE(4228), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [325830] = 5,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(6543), 1,
      sym_parameters,
    STATE(8626), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [325857] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7756), 1,
      sym_uninitialized,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11291), 1,
      sym_tag,
    STATE(4081), 1,
      sym_where_clause,
    STATE(4228), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [325892] = 5,
    ACTIONS(11293), 1,
      anon_sym_LPAREN,
    STATE(667), 1,
      sym_parameters,
    STATE(8462), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [325919] = 10,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7756), 1,
      sym_uninitialized,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11291), 1,
      sym_tag,
    ACTIONS(11295), 1,
      anon_sym_SLASH,
    STATE(4081), 1,
      sym_where_clause,
    STATE(4228), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [325956] = 5,
    ACTIONS(11261), 1,
      anon_sym_LPAREN,
    STATE(2996), 1,
      sym_parameters,
    STATE(8620), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [325983] = 5,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(2966), 1,
      sym_parameters,
    STATE(8488), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326010] = 5,
    ACTIONS(11261), 1,
      anon_sym_LPAREN,
    STATE(3106), 1,
      sym_parameters,
    STATE(8546), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326037] = 5,
    ACTIONS(11279), 1,
      anon_sym_LPAREN,
    STATE(3274), 1,
      sym_parameters,
    STATE(8591), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326064] = 10,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6931), 1,
      sym_uninitialized,
    ACTIONS(6933), 1,
      sym_tag,
    ACTIONS(11273), 1,
      anon_sym_where,
    ACTIONS(11297), 1,
      anon_sym_DASH_GT,
    STATE(2917), 1,
      sym_where_clause,
    STATE(3018), 1,
      sym_block,
    ACTIONS(3785), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3781), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [326101] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7766), 1,
      sym_uninitialized,
    ACTIONS(7768), 1,
      sym_tag,
    ACTIONS(11243), 1,
      anon_sym_where,
    STATE(4088), 1,
      sym_where_clause,
    STATE(4237), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [326136] = 5,
    ACTIONS(11261), 1,
      anon_sym_LPAREN,
    STATE(6502), 1,
      sym_parameters,
    STATE(8565), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326163] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7766), 1,
      sym_uninitialized,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11299), 1,
      sym_tag,
    STATE(4088), 1,
      sym_where_clause,
    STATE(4237), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [326198] = 10,
    ACTIONS(3785), 1,
      anon_sym_SLASH,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6961), 1,
      sym_uninitialized,
    ACTIONS(6963), 1,
      sym_tag,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11301), 1,
      anon_sym_DASH_GT,
    STATE(3273), 1,
      sym_where_clause,
    STATE(3656), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3781), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [326235] = 5,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(6626), 1,
      sym_parameters,
    STATE(8549), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326262] = 5,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(6653), 1,
      sym_parameters,
    STATE(8479), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326289] = 5,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(2907), 1,
      sym_parameters,
    STATE(8537), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326316] = 5,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(3977), 1,
      sym_parameters,
    STATE(8556), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326343] = 5,
    ACTIONS(11281), 1,
      anon_sym_LPAREN,
    STATE(6663), 1,
      sym_parameters,
    STATE(8544), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326370] = 10,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7034), 1,
      sym_uninitialized,
    ACTIONS(7036), 1,
      sym_tag,
    ACTIONS(11273), 1,
      anon_sym_where,
    ACTIONS(11303), 1,
      anon_sym_DASH_GT,
    STATE(3301), 1,
      sym_where_clause,
    STATE(3756), 1,
      sym_block,
    ACTIONS(4117), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4113), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [326407] = 10,
    ACTIONS(3785), 1,
      anon_sym_SLASH,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6931), 1,
      sym_uninitialized,
    ACTIONS(6933), 1,
      sym_tag,
    ACTIONS(11305), 1,
      anon_sym_DASH_GT,
    ACTIONS(11307), 1,
      anon_sym_where,
    STATE(2917), 1,
      sym_where_clause,
    STATE(3018), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3781), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
  [326444] = 5,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(6677), 1,
      sym_parameters,
    STATE(8636), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326471] = 5,
    ACTIONS(11261), 1,
      anon_sym_LPAREN,
    STATE(6500), 1,
      sym_parameters,
    STATE(8492), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326498] = 6,
    ACTIONS(4187), 1,
      anon_sym_SLASH,
    ACTIONS(11205), 1,
      anon_sym_DOT2,
    ACTIONS(11309), 1,
      anon_sym_COLON,
    STATE(2801), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4185), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
      sym_uninitialized,
      sym_tag,
  [326527] = 5,
    ACTIONS(11277), 1,
      anon_sym_LPAREN,
    STATE(1669), 1,
      sym_parameters,
    STATE(8618), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326554] = 5,
    ACTIONS(11279), 1,
      anon_sym_LPAREN,
    STATE(3437), 1,
      sym_parameters,
    STATE(8429), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326581] = 5,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(6684), 1,
      sym_parameters,
    STATE(8578), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326608] = 5,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(2942), 1,
      sym_parameters,
    STATE(8645), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326635] = 10,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11255), 1,
      sym_tag,
    ACTIONS(11311), 1,
      sym_identifier,
    ACTIONS(11313), 1,
      anon_sym_DOLLAR,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7411), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [326672] = 10,
    ACTIONS(4117), 1,
      anon_sym_SLASH,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11315), 1,
      anon_sym_DASH_GT,
    ACTIONS(11317), 1,
      sym_uninitialized,
    ACTIONS(11319), 1,
      sym_tag,
    STATE(6788), 1,
      sym_where_clause,
    STATE(7064), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4113), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [326709] = 10,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11255), 1,
      sym_tag,
    ACTIONS(11321), 1,
      sym_identifier,
    ACTIONS(11323), 1,
      anon_sym_DOLLAR,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7948), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [326746] = 6,
    ACTIONS(11205), 1,
      anon_sym_DOT2,
    ACTIONS(11325), 1,
      anon_sym_COLON,
    STATE(2801), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4187), 3,
      anon_sym_where,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4185), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uninitialized,
      sym_tag,
  [326775] = 5,
    ACTIONS(11279), 1,
      anon_sym_LPAREN,
    STATE(3388), 1,
      sym_parameters,
    STATE(8581), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326802] = 10,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11251), 1,
      anon_sym_DOLLAR,
    ACTIONS(11255), 1,
      sym_tag,
    ACTIONS(11327), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7566), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [326839] = 10,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(7772), 1,
      sym_uninitialized,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11295), 1,
      anon_sym_SLASH,
    ACTIONS(11329), 1,
      sym_tag,
    STATE(4091), 1,
      sym_where_clause,
    STATE(4249), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [326876] = 5,
    ACTIONS(11281), 1,
      anon_sym_LPAREN,
    STATE(6608), 1,
      sym_parameters,
    STATE(8442), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326903] = 10,
    ACTIONS(4117), 1,
      anon_sym_SLASH,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6892), 1,
      sym_uninitialized,
    ACTIONS(6894), 1,
      sym_tag,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11331), 1,
      anon_sym_DASH_GT,
    STATE(3295), 1,
      sym_where_clause,
    STATE(3667), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4113), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [326940] = 5,
    ACTIONS(11261), 1,
      anon_sym_LPAREN,
    STATE(2937), 1,
      sym_parameters,
    STATE(8418), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326967] = 5,
    ACTIONS(11293), 1,
      anon_sym_LPAREN,
    STATE(608), 1,
      sym_parameters,
    STATE(8589), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [326994] = 9,
    ACTIONS(3421), 1,
      anon_sym_SLASH,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7772), 1,
      sym_uninitialized,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11329), 1,
      sym_tag,
    STATE(4091), 1,
      sym_where_clause,
    STATE(4249), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [327029] = 5,
    ACTIONS(11293), 1,
      anon_sym_LPAREN,
    STATE(643), 1,
      sym_parameters,
    STATE(8545), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [327056] = 10,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7040), 1,
      sym_uninitialized,
    ACTIONS(7042), 1,
      sym_tag,
    ACTIONS(11273), 1,
      anon_sym_where,
    ACTIONS(11333), 1,
      anon_sym_DASH_GT,
    STATE(3298), 1,
      sym_where_clause,
    STATE(3720), 1,
      sym_block,
    ACTIONS(3785), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3781), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [327093] = 10,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(7766), 1,
      sym_uninitialized,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11295), 1,
      anon_sym_SLASH,
    ACTIONS(11299), 1,
      sym_tag,
    STATE(4088), 1,
      sym_where_clause,
    STATE(4237), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [327130] = 10,
    ACTIONS(4117), 1,
      anon_sym_SLASH,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(7000), 1,
      sym_uninitialized,
    ACTIONS(7002), 1,
      sym_tag,
    ACTIONS(11307), 1,
      anon_sym_where,
    ACTIONS(11335), 1,
      anon_sym_DASH_GT,
    STATE(2922), 1,
      sym_where_clause,
    STATE(3038), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4113), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
  [327167] = 5,
    ACTIONS(11279), 1,
      anon_sym_LPAREN,
    STATE(6499), 1,
      sym_parameters,
    STATE(8443), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [327194] = 5,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(6547), 1,
      sym_parameters,
    STATE(8514), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [327221] = 5,
    ACTIONS(11277), 1,
      anon_sym_LPAREN,
    STATE(1412), 1,
      sym_parameters,
    STATE(8411), 1,
      sym_calling_convention,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11259), 10,
      anon_sym_DQUOTEodin_DQUOTE,
      anon_sym_DQUOTEcontextless_DQUOTE,
      anon_sym_DQUOTEstdcall_DQUOTE,
      anon_sym_DQUOTEstd_DQUOTE,
      anon_sym_DQUOTEcdecl_DQUOTE,
      anon_sym_DQUOTEc_DQUOTE,
      anon_sym_DQUOTEfastcall_DQUOTE,
      anon_sym_DQUOTEfast_DQUOTE,
      anon_sym_DQUOTEnone_DQUOTE,
      anon_sym_DQUOTEsystem_DQUOTE,
  [327248] = 9,
    ACTIONS(3421), 1,
      anon_sym_SLASH,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6916), 1,
      sym_uninitialized,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11337), 1,
      sym_tag,
    STATE(3200), 1,
      sym_where_clause,
    STATE(3661), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [327282] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11339), 1,
      sym_uninitialized,
    ACTIONS(11341), 1,
      sym_tag,
    STATE(6797), 1,
      sym_where_clause,
    STATE(6958), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [327316] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11343), 1,
      sym_uninitialized,
    ACTIONS(11345), 1,
      sym_tag,
    STATE(6782), 1,
      sym_where_clause,
    STATE(6977), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [327350] = 10,
    ACTIONS(4117), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7034), 1,
      sym_uninitialized,
    ACTIONS(7036), 1,
      sym_tag,
    ACTIONS(11307), 1,
      anon_sym_where,
    ACTIONS(11347), 1,
      anon_sym_DASH_GT,
    STATE(3301), 1,
      sym_where_clause,
    STATE(3756), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4113), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
  [327386] = 9,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7243), 1,
      sym_uninitialized,
    ACTIONS(7245), 1,
      sym_tag,
    ACTIONS(11273), 1,
      anon_sym_where,
    STATE(3293), 1,
      sym_where_clause,
    STATE(3773), 1,
      sym_block,
    ACTIONS(3675), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3671), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [327420] = 10,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6920), 1,
      sym_uninitialized,
    ACTIONS(11307), 1,
      anon_sym_where,
    ACTIONS(11349), 1,
      anon_sym_SLASH,
    ACTIONS(11351), 1,
      sym_tag,
    STATE(2932), 1,
      sym_where_clause,
    STATE(3055), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_when,
  [327456] = 9,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11255), 1,
      sym_tag,
    ACTIONS(11353), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7455), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [327490] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6880), 1,
      sym_uninitialized,
    ACTIONS(6882), 1,
      sym_tag,
    ACTIONS(11128), 1,
      anon_sym_where,
    STATE(3168), 1,
      sym_where_clause,
    STATE(3668), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [327524] = 5,
    ACTIONS(4665), 1,
      anon_sym_SLASH,
    ACTIONS(8452), 1,
      anon_sym_COMMA,
    STATE(6721), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4661), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [327550] = 9,
    ACTIONS(3675), 1,
      anon_sym_SLASH,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11355), 1,
      sym_uninitialized,
    ACTIONS(11357), 1,
      sym_tag,
    STATE(6787), 1,
      sym_where_clause,
    STATE(6964), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3671), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [327584] = 11,
    ACTIONS(3421), 1,
      sym_identifier,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7251), 1,
      sym_uninitialized,
    ACTIONS(11273), 1,
      anon_sym_where,
    ACTIONS(11359), 1,
      anon_sym_SLASH,
    ACTIONS(11361), 1,
      sym_tag,
    STATE(3181), 1,
      sym_where_clause,
    STATE(3833), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [327622] = 11,
    ACTIONS(4085), 1,
      sym_identifier,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_uninitialized,
    ACTIONS(11273), 1,
      anon_sym_where,
    ACTIONS(11359), 1,
      anon_sym_SLASH,
    ACTIONS(11363), 1,
      sym_tag,
    STATE(3165), 1,
      sym_where_clause,
    STATE(3909), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [327660] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      sym_uninitialized,
    ACTIONS(6929), 1,
      sym_tag,
    ACTIONS(11307), 1,
      anon_sym_where,
    STATE(2927), 1,
      sym_where_clause,
    STATE(3081), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
  [327694] = 10,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6916), 1,
      sym_uninitialized,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11194), 1,
      anon_sym_SLASH,
    ACTIONS(11337), 1,
      sym_tag,
    STATE(3200), 1,
      sym_where_clause,
    STATE(3661), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [327730] = 9,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_uninitialized,
    ACTIONS(11273), 1,
      anon_sym_where,
    ACTIONS(11363), 1,
      sym_tag,
    STATE(3165), 1,
      sym_where_clause,
    STATE(3909), 1,
      sym_block,
    ACTIONS(4085), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [327764] = 10,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      sym_uninitialized,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11307), 1,
      anon_sym_where,
    ACTIONS(11349), 1,
      anon_sym_SLASH,
    ACTIONS(11365), 1,
      sym_tag,
    STATE(2921), 1,
      sym_where_clause,
    STATE(3072), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_when,
  [327800] = 9,
    ACTIONS(3421), 1,
      anon_sym_SLASH,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6920), 1,
      sym_uninitialized,
    ACTIONS(11307), 1,
      anon_sym_where,
    ACTIONS(11351), 1,
      sym_tag,
    STATE(2932), 1,
      sym_where_clause,
    STATE(3055), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
  [327834] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6880), 1,
      sym_uninitialized,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11367), 1,
      sym_tag,
    STATE(3168), 1,
      sym_where_clause,
    STATE(3668), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [327868] = 10,
    ACTIONS(3785), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7040), 1,
      sym_uninitialized,
    ACTIONS(7042), 1,
      sym_tag,
    ACTIONS(11307), 1,
      anon_sym_where,
    ACTIONS(11369), 1,
      anon_sym_DASH_GT,
    STATE(3298), 1,
      sym_where_clause,
    STATE(3720), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3781), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
  [327904] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      sym_uninitialized,
    ACTIONS(11307), 1,
      anon_sym_where,
    ACTIONS(11371), 1,
      sym_tag,
    STATE(2927), 1,
      sym_where_clause,
    STATE(3081), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
  [327938] = 9,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7251), 1,
      sym_uninitialized,
    ACTIONS(11273), 1,
      anon_sym_where,
    ACTIONS(11361), 1,
      sym_tag,
    STATE(3181), 1,
      sym_where_clause,
    STATE(3833), 1,
      sym_block,
    ACTIONS(3421), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [327972] = 9,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_uninitialized,
    ACTIONS(7267), 1,
      sym_tag,
    ACTIONS(11273), 1,
      anon_sym_where,
    STATE(3165), 1,
      sym_where_clause,
    STATE(3909), 1,
      sym_block,
    ACTIONS(4085), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [328006] = 10,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6880), 1,
      sym_uninitialized,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11194), 1,
      anon_sym_SLASH,
    ACTIONS(11367), 1,
      sym_tag,
    STATE(3168), 1,
      sym_where_clause,
    STATE(3668), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [328042] = 9,
    ACTIONS(3675), 1,
      anon_sym_SLASH,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6939), 1,
      sym_uninitialized,
    ACTIONS(6941), 1,
      sym_tag,
    ACTIONS(11128), 1,
      anon_sym_where,
    STATE(3348), 1,
      sym_where_clause,
    STATE(3707), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3671), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [328076] = 10,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6927), 1,
      sym_uninitialized,
    ACTIONS(11307), 1,
      anon_sym_where,
    ACTIONS(11349), 1,
      anon_sym_SLASH,
    ACTIONS(11371), 1,
      sym_tag,
    STATE(2927), 1,
      sym_where_clause,
    STATE(3081), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_when,
  [328112] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      sym_uninitialized,
    ACTIONS(11307), 1,
      anon_sym_where,
    ACTIONS(11365), 1,
      sym_tag,
    STATE(2921), 1,
      sym_where_clause,
    STATE(3072), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
  [328146] = 10,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11295), 1,
      anon_sym_SLASH,
    ACTIONS(11339), 1,
      sym_uninitialized,
    ACTIONS(11341), 1,
      sym_tag,
    STATE(6797), 1,
      sym_where_clause,
    STATE(6958), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [328182] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6910), 1,
      sym_uninitialized,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11373), 1,
      sym_tag,
    STATE(3294), 1,
      sym_where_clause,
    STATE(3709), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [328216] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11343), 1,
      sym_uninitialized,
    ACTIONS(11375), 1,
      sym_tag,
    STATE(6782), 1,
      sym_where_clause,
    STATE(6977), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [328250] = 9,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7028), 1,
      sym_uninitialized,
    ACTIONS(7259), 1,
      sym_tag,
    ACTIONS(11273), 1,
      anon_sym_where,
    STATE(3175), 1,
      sym_where_clause,
    STATE(3888), 1,
      sym_block,
    ACTIONS(4025), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [328284] = 9,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11255), 1,
      sym_tag,
    ACTIONS(11377), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(8134), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [328318] = 10,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6910), 1,
      sym_uninitialized,
    ACTIONS(11128), 1,
      anon_sym_where,
    ACTIONS(11194), 1,
      anon_sym_SLASH,
    ACTIONS(11373), 1,
      sym_tag,
    STATE(3294), 1,
      sym_where_clause,
    STATE(3709), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [328354] = 9,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11247), 1,
      sym_identifier,
    ACTIONS(11255), 1,
      sym_tag,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7566), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [328388] = 10,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11295), 1,
      anon_sym_SLASH,
    ACTIONS(11343), 1,
      sym_uninitialized,
    ACTIONS(11375), 1,
      sym_tag,
    STATE(6782), 1,
      sym_where_clause,
    STATE(6977), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [328424] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11339), 1,
      sym_uninitialized,
    ACTIONS(11379), 1,
      sym_tag,
    STATE(6797), 1,
      sym_where_clause,
    STATE(6958), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [328458] = 9,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7028), 1,
      sym_uninitialized,
    ACTIONS(11273), 1,
      anon_sym_where,
    ACTIONS(11381), 1,
      sym_tag,
    STATE(3175), 1,
      sym_where_clause,
    STATE(3888), 1,
      sym_block,
    ACTIONS(4025), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [328492] = 11,
    ACTIONS(4025), 1,
      sym_identifier,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7028), 1,
      sym_uninitialized,
    ACTIONS(11273), 1,
      anon_sym_where,
    ACTIONS(11359), 1,
      anon_sym_SLASH,
    ACTIONS(11381), 1,
      sym_tag,
    STATE(3175), 1,
      sym_where_clause,
    STATE(3888), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [328530] = 9,
    ACTIONS(3675), 1,
      anon_sym_SLASH,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6943), 1,
      sym_uninitialized,
    ACTIONS(6945), 1,
      sym_tag,
    ACTIONS(11307), 1,
      anon_sym_where,
    STATE(2930), 1,
      sym_where_clause,
    STATE(3085), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3671), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
  [328564] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      sym_uninitialized,
    ACTIONS(6957), 1,
      sym_tag,
    ACTIONS(11307), 1,
      anon_sym_where,
    STATE(2921), 1,
      sym_where_clause,
    STATE(3072), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
  [328598] = 9,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6920), 1,
      sym_uninitialized,
    ACTIONS(11273), 1,
      anon_sym_where,
    ACTIONS(11383), 1,
      sym_tag,
    STATE(2932), 1,
      sym_where_clause,
    STATE(3055), 1,
      sym_block,
    ACTIONS(3421), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [328632] = 5,
    ACTIONS(4722), 1,
      anon_sym_SLASH,
    ACTIONS(11385), 1,
      anon_sym_COMMA,
    STATE(6721), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4717), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [328658] = 9,
    ACTIONS(3421), 1,
      anon_sym_SLASH,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11388), 1,
      sym_uninitialized,
    ACTIONS(11390), 1,
      sym_tag,
    STATE(6784), 1,
      sym_where_clause,
    STATE(6980), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [328692] = 9,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      sym_uninitialized,
    ACTIONS(11273), 1,
      anon_sym_where,
    ACTIONS(11392), 1,
      sym_tag,
    STATE(2921), 1,
      sym_where_clause,
    STATE(3072), 1,
      sym_block,
    ACTIONS(4085), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [328726] = 9,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      sym_uninitialized,
    ACTIONS(6957), 1,
      sym_tag,
    ACTIONS(11273), 1,
      anon_sym_where,
    STATE(2921), 1,
      sym_where_clause,
    STATE(3072), 1,
      sym_block,
    ACTIONS(4085), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [328760] = 9,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      sym_uninitialized,
    ACTIONS(11273), 1,
      anon_sym_where,
    ACTIONS(11394), 1,
      sym_tag,
    STATE(2927), 1,
      sym_where_clause,
    STATE(3081), 1,
      sym_block,
    ACTIONS(4025), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [328794] = 9,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6927), 1,
      sym_uninitialized,
    ACTIONS(6929), 1,
      sym_tag,
    ACTIONS(11273), 1,
      anon_sym_where,
    STATE(2927), 1,
      sym_where_clause,
    STATE(3081), 1,
      sym_block,
    ACTIONS(4025), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [328828] = 9,
    ACTIONS(1373), 1,
      anon_sym_proc,
    ACTIONS(2943), 1,
      anon_sym_CARET,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    ACTIONS(11120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11255), 1,
      sym_tag,
    ACTIONS(11311), 1,
      sym_identifier,
    STATE(3887), 1,
      sym_procedure,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    STATE(7411), 5,
      sym_pointer_type,
      sym_variadic_type,
      sym_array_type,
      sym_field_type,
      sym__procedure_type,
  [328862] = 9,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6943), 1,
      sym_uninitialized,
    ACTIONS(6945), 1,
      sym_tag,
    ACTIONS(11273), 1,
      anon_sym_where,
    STATE(2930), 1,
      sym_where_clause,
    STATE(3085), 1,
      sym_block,
    ACTIONS(3675), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3671), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [328896] = 10,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(11243), 1,
      anon_sym_where,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11295), 1,
      anon_sym_SLASH,
    ACTIONS(11388), 1,
      sym_uninitialized,
    ACTIONS(11390), 1,
      sym_tag,
    STATE(6784), 1,
      sym_where_clause,
    STATE(6980), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [328932] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(6876), 1,
      anon_sym_LBRACE,
    ACTIONS(6910), 1,
      sym_uninitialized,
    ACTIONS(6914), 1,
      sym_tag,
    ACTIONS(11128), 1,
      anon_sym_where,
    STATE(3294), 1,
      sym_where_clause,
    STATE(3709), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [328966] = 11,
    ACTIONS(3421), 1,
      sym_identifier,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6920), 1,
      sym_uninitialized,
    ACTIONS(11273), 1,
      anon_sym_where,
    ACTIONS(11359), 1,
      anon_sym_SLASH,
    ACTIONS(11383), 1,
      sym_tag,
    STATE(2932), 1,
      sym_where_clause,
    STATE(3055), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [329004] = 11,
    ACTIONS(4085), 1,
      sym_identifier,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6888), 1,
      sym_uninitialized,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11273), 1,
      anon_sym_where,
    ACTIONS(11359), 1,
      anon_sym_SLASH,
    ACTIONS(11392), 1,
      sym_tag,
    STATE(2921), 1,
      sym_where_clause,
    STATE(3072), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [329042] = 11,
    ACTIONS(4025), 1,
      sym_identifier,
    ACTIONS(6886), 1,
      anon_sym_LBRACE,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(6927), 1,
      sym_uninitialized,
    ACTIONS(11273), 1,
      anon_sym_where,
    ACTIONS(11359), 1,
      anon_sym_SLASH,
    ACTIONS(11394), 1,
      sym_tag,
    STATE(2927), 1,
      sym_where_clause,
    STATE(3081), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
  [329080] = 9,
    ACTIONS(3675), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7243), 1,
      sym_uninitialized,
    ACTIONS(7245), 1,
      sym_tag,
    ACTIONS(11307), 1,
      anon_sym_where,
    STATE(3293), 1,
      sym_where_clause,
    STATE(3773), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3671), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
  [329113] = 4,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(11295), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5482), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [329136] = 4,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(11295), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5468), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [329159] = 4,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4800), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [329182] = 5,
    ACTIONS(8585), 1,
      anon_sym_COMMA,
    STATE(6747), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4665), 3,
      anon_sym_where,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4661), 6,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uninitialized,
      sym_tag,
  [329207] = 4,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5482), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [329230] = 5,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(11295), 1,
      anon_sym_SLASH,
    ACTIONS(11398), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5386), 8,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [329255] = 4,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5468), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [329278] = 4,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5464), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [329301] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7028), 1,
      sym_uninitialized,
    ACTIONS(7259), 1,
      sym_tag,
    ACTIONS(11307), 1,
      anon_sym_where,
    STATE(3175), 1,
      sym_where_clause,
    STATE(3888), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
  [329334] = 9,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7028), 1,
      sym_uninitialized,
    ACTIONS(11307), 1,
      anon_sym_where,
    ACTIONS(11400), 1,
      sym_tag,
    STATE(3175), 1,
      sym_where_clause,
    STATE(3888), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
  [329367] = 4,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(11295), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5464), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [329390] = 10,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7028), 1,
      sym_uninitialized,
    ACTIONS(11307), 1,
      anon_sym_where,
    ACTIONS(11349), 1,
      anon_sym_SLASH,
    ACTIONS(11400), 1,
      sym_tag,
    STATE(3175), 1,
      sym_where_clause,
    STATE(3888), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_when,
  [329425] = 5,
    ACTIONS(11402), 1,
      anon_sym_COMMA,
    STATE(6747), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4722), 3,
      anon_sym_where,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(4717), 6,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uninitialized,
      sym_tag,
  [329450] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_uninitialized,
    ACTIONS(7267), 1,
      sym_tag,
    ACTIONS(11307), 1,
      anon_sym_where,
    STATE(3165), 1,
      sym_where_clause,
    STATE(3909), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
  [329483] = 9,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_uninitialized,
    ACTIONS(11307), 1,
      anon_sym_where,
    ACTIONS(11405), 1,
      sym_tag,
    STATE(3165), 1,
      sym_where_clause,
    STATE(3909), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
  [329516] = 10,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_uninitialized,
    ACTIONS(11307), 1,
      anon_sym_where,
    ACTIONS(11349), 1,
      anon_sym_SLASH,
    ACTIONS(11405), 1,
      sym_tag,
    STATE(3165), 1,
      sym_where_clause,
    STATE(3909), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_when,
  [329551] = 5,
    ACTIONS(4665), 1,
      anon_sym_SLASH,
    ACTIONS(8590), 1,
      anon_sym_COMMA,
    STATE(6757), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4661), 8,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
      sym_uninitialized,
      sym_tag,
  [329576] = 4,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5448), 9,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [329599] = 4,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(11295), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5448), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [329622] = 9,
    ACTIONS(3421), 1,
      anon_sym_SLASH,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7251), 1,
      sym_uninitialized,
    ACTIONS(11307), 1,
      anon_sym_where,
    ACTIONS(11407), 1,
      sym_tag,
    STATE(3181), 1,
      sym_where_clause,
    STATE(3833), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
  [329655] = 10,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(7026), 1,
      anon_sym_LBRACE,
    ACTIONS(7251), 1,
      sym_uninitialized,
    ACTIONS(11307), 1,
      anon_sym_where,
    ACTIONS(11349), 1,
      anon_sym_SLASH,
    ACTIONS(11407), 1,
      sym_tag,
    STATE(3181), 1,
      sym_where_clause,
    STATE(3833), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_when,
  [329690] = 4,
    ACTIONS(7762), 1,
      anon_sym_LPAREN,
    ACTIONS(11295), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4800), 9,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym_uninitialized,
      sym_tag,
  [329713] = 5,
    ACTIONS(4722), 1,
      anon_sym_SLASH,
    ACTIONS(11409), 1,
      anon_sym_COMMA,
    STATE(6757), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4717), 8,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
      sym_uninitialized,
      sym_tag,
  [329738] = 4,
    ACTIONS(7728), 1,
      anon_sym_LPAREN,
    ACTIONS(11412), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5464), 8,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [329760] = 5,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11245), 1,
      anon_sym_EQ,
    ACTIONS(11349), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5386), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_RPAREN,
      anon_sym_when,
      sym_uninitialized,
      sym_tag,
  [329784] = 5,
    ACTIONS(7728), 1,
      anon_sym_LPAREN,
    ACTIONS(8330), 1,
      anon_sym_LBRACE,
    ACTIONS(11412), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(767), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [329808] = 5,
    ACTIONS(7728), 1,
      anon_sym_LPAREN,
    ACTIONS(11412), 1,
      anon_sym_SLASH,
    ACTIONS(11414), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(891), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [329832] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5482), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [329854] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4800), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [329876] = 5,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11359), 1,
      anon_sym_SLASH,
    ACTIONS(5466), 2,
      anon_sym_where,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5464), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
      sym_tag,
  [329900] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5468), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [329922] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5464), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [329944] = 5,
    ACTIONS(7728), 1,
      anon_sym_LPAREN,
    ACTIONS(8330), 1,
      anon_sym_LBRACE,
    ACTIONS(11412), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(815), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [329968] = 5,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11359), 1,
      anon_sym_SLASH,
    ACTIONS(5484), 2,
      anon_sym_where,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5482), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
      sym_tag,
  [329992] = 5,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    ACTIONS(11420), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11418), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [330016] = 5,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11359), 1,
      anon_sym_SLASH,
    ACTIONS(4804), 2,
      anon_sym_where,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4800), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
      sym_tag,
  [330040] = 4,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11349), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5464), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_when,
      sym_uninitialized,
      sym_tag,
  [330062] = 5,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11359), 1,
      anon_sym_SLASH,
    ACTIONS(5450), 2,
      anon_sym_where,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5448), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
      sym_tag,
  [330086] = 5,
    ACTIONS(7728), 1,
      anon_sym_LPAREN,
    ACTIONS(11412), 1,
      anon_sym_SLASH,
    ACTIONS(11414), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(859), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [330110] = 4,
    ACTIONS(7728), 1,
      anon_sym_LPAREN,
    ACTIONS(11412), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5468), 8,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [330132] = 5,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    ACTIONS(11424), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11422), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [330156] = 5,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11359), 1,
      anon_sym_SLASH,
    ACTIONS(5470), 2,
      anon_sym_where,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5468), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_uninitialized,
      sym_tag,
  [330180] = 6,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11245), 1,
      anon_sym_EQ,
    ACTIONS(11359), 1,
      anon_sym_SLASH,
    ACTIONS(5390), 2,
      anon_sym_where,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5386), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym_uninitialized,
      sym_tag,
  [330206] = 6,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(8752), 1,
      anon_sym_COMMA,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    STATE(6884), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8750), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [330232] = 6,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(8752), 1,
      anon_sym_COMMA,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    STATE(6892), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8766), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [330258] = 6,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(8752), 1,
      anon_sym_COMMA,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    STATE(6849), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11426), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [330284] = 5,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    ACTIONS(11428), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8764), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [330308] = 7,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11339), 1,
      sym_uninitialized,
    ACTIONS(11379), 1,
      sym_tag,
    STATE(6958), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [330336] = 4,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11349), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5482), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_when,
      sym_uninitialized,
      sym_tag,
  [330358] = 7,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11343), 1,
      sym_uninitialized,
    ACTIONS(11345), 1,
      sym_tag,
    STATE(6977), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [330386] = 4,
    ACTIONS(7728), 1,
      anon_sym_LPAREN,
    ACTIONS(11412), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5448), 8,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [330408] = 4,
    ACTIONS(7728), 1,
      anon_sym_LPAREN,
    ACTIONS(11412), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4800), 8,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [330430] = 7,
    ACTIONS(4669), 1,
      anon_sym_SLASH,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11430), 1,
      sym_uninitialized,
    ACTIONS(11432), 1,
      sym_tag,
    STATE(6933), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4667), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [330458] = 7,
    ACTIONS(3785), 1,
      anon_sym_SLASH,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11287), 1,
      sym_uninitialized,
    ACTIONS(11289), 1,
      sym_tag,
    STATE(6983), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3781), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [330486] = 6,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(8752), 1,
      anon_sym_COMMA,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    STATE(6859), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8770), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [330512] = 5,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    ACTIONS(11434), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8784), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [330536] = 4,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11349), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5468), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_when,
      sym_uninitialized,
      sym_tag,
  [330558] = 4,
    ACTIONS(7728), 1,
      anon_sym_LPAREN,
    ACTIONS(11412), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5482), 8,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [330580] = 4,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11349), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4800), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_when,
      sym_uninitialized,
      sym_tag,
  [330602] = 4,
    ACTIONS(6900), 1,
      anon_sym_LPAREN,
    ACTIONS(11349), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5448), 8,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_when,
      sym_uninitialized,
      sym_tag,
  [330624] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5448), 8,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [330646] = 7,
    ACTIONS(3421), 1,
      anon_sym_SLASH,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11388), 1,
      sym_uninitialized,
    ACTIONS(11436), 1,
      sym_tag,
    STATE(6980), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [330674] = 7,
    ACTIONS(3675), 1,
      anon_sym_SLASH,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11355), 1,
      sym_uninitialized,
    ACTIONS(11357), 1,
      sym_tag,
    STATE(6964), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3671), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [330702] = 6,
    ACTIONS(3785), 1,
      anon_sym_SLASH,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11287), 1,
      sym_uninitialized,
    STATE(6983), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3781), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [330727] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7060), 1,
      sym_else_clause,
    STATE(6815), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11438), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [330750] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7082), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11442), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [330773] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7088), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11444), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [330796] = 8,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11448), 1,
      anon_sym_LPAREN,
    ACTIONS(11450), 1,
      anon_sym_SLASH,
    STATE(8458), 1,
      sym_string,
    ACTIONS(11446), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [330825] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7139), 1,
      sym_else_clause,
    STATE(6823), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11452), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [330848] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7160), 1,
      sym_else_clause,
    STATE(6825), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11454), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [330871] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7174), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11456), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [330894] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(6955), 1,
      sym_else_clause,
    STATE(6800), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11458), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [330917] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7086), 1,
      sym_else_clause,
    STATE(6801), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11460), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [330940] = 8,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11448), 1,
      anon_sym_LPAREN,
    ACTIONS(11450), 1,
      anon_sym_SLASH,
    STATE(8490), 1,
      sym_string,
    ACTIONS(11462), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [330969] = 6,
    ACTIONS(4669), 1,
      anon_sym_SLASH,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11430), 1,
      sym_uninitialized,
    STATE(6933), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4667), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [330994] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7141), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11464), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [331017] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7158), 1,
      sym_else_clause,
    STATE(6805), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11466), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [331040] = 5,
    ACTIONS(8690), 1,
      sym__nl_comma,
    ACTIONS(11468), 1,
      anon_sym_COMMA,
    STATE(6816), 1,
      aux_sym_return_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(2969), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [331063] = 4,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5382), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [331084] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7205), 1,
      sym_else_clause,
    STATE(6810), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11470), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [331107] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7155), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11472), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [331130] = 4,
    STATE(6816), 1,
      aux_sym_return_statement_repeat1,
    ACTIONS(11474), 2,
      sym__nl_comma,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8774), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [331151] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7145), 1,
      sym_else_clause,
    STATE(6826), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11477), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [331174] = 8,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11448), 1,
      anon_sym_LPAREN,
    ACTIONS(11450), 1,
      anon_sym_SLASH,
    STATE(8467), 1,
      sym_string,
    ACTIONS(11479), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [331203] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7185), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11481), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [331226] = 7,
    ACTIONS(4187), 1,
      anon_sym_SLASH,
    ACTIONS(11483), 1,
      anon_sym_COLON,
    ACTIONS(11485), 1,
      anon_sym_COLON_EQ,
    ACTIONS(11487), 1,
      anon_sym_DOT2,
    STATE(3496), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4185), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_when,
  [331253] = 6,
    ACTIONS(3421), 1,
      anon_sym_SLASH,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11388), 1,
      sym_uninitialized,
    STATE(6980), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [331278] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7132), 1,
      sym_else_clause,
    STATE(6819), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11489), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [331301] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7123), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11491), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [331324] = 6,
    ACTIONS(3675), 1,
      anon_sym_SLASH,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11355), 1,
      sym_uninitialized,
    STATE(6964), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3671), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [331349] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7113), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11493), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [331372] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7121), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11495), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [331395] = 9,
    ACTIONS(4187), 1,
      anon_sym_SLASH,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    ACTIONS(11487), 1,
      anon_sym_DOT2,
    ACTIONS(11497), 1,
      anon_sym_LPAREN,
    ACTIONS(11499), 1,
      anon_sym_DOT,
    STATE(3496), 1,
      aux_sym_field_type_repeat1,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(4185), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [331426] = 4,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(859), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [331447] = 6,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11339), 1,
      sym_uninitialized,
    STATE(6958), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [331472] = 4,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(913), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [331493] = 4,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5132), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [331514] = 8,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11448), 1,
      anon_sym_LPAREN,
    ACTIONS(11450), 1,
      anon_sym_SLASH,
    STATE(8521), 1,
      sym_string,
    ACTIONS(11501), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [331543] = 5,
    ACTIONS(11505), 1,
      anon_sym_else,
    STATE(6937), 1,
      sym_else_clause,
    STATE(6837), 2,
      sym_else_when_clause,
      aux_sym_when_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11503), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [331566] = 5,
    ACTIONS(8690), 1,
      sym__nl_comma,
    ACTIONS(8730), 1,
      anon_sym_COMMA,
    STATE(6838), 1,
      aux_sym_return_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(717), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [331589] = 4,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11507), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [331610] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(7204), 1,
      sym_else_clause,
    STATE(6845), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11509), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [331633] = 5,
    ACTIONS(11505), 1,
      anon_sym_else,
    STATE(7140), 1,
      sym_else_clause,
    STATE(6864), 2,
      sym_else_when_clause,
      aux_sym_when_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11511), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [331656] = 5,
    ACTIONS(8688), 1,
      anon_sym_COMMA,
    ACTIONS(8690), 1,
      sym__nl_comma,
    STATE(6816), 1,
      aux_sym_return_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(2953), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [331679] = 6,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11343), 1,
      sym_uninitialized,
    STATE(6977), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [331704] = 5,
    ACTIONS(8688), 1,
      anon_sym_COMMA,
    ACTIONS(8690), 1,
      sym__nl_comma,
    STATE(6812), 1,
      aux_sym_return_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(2953), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [331727] = 8,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11448), 1,
      anon_sym_LPAREN,
    ACTIONS(11450), 1,
      anon_sym_SLASH,
    STATE(8538), 1,
      sym_string,
    ACTIONS(11513), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [331756] = 8,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11448), 1,
      anon_sym_LPAREN,
    ACTIONS(11450), 1,
      anon_sym_SLASH,
    STATE(8502), 1,
      sym_string,
    ACTIONS(11515), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [331785] = 8,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11448), 1,
      anon_sym_LPAREN,
    ACTIONS(11450), 1,
      anon_sym_SLASH,
    STATE(8634), 1,
      sym_string,
    ACTIONS(11517), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [331814] = 6,
    ACTIONS(4693), 1,
      anon_sym_SLASH,
    ACTIONS(11283), 1,
      anon_sym_LBRACE,
    ACTIONS(11519), 1,
      sym_uninitialized,
    STATE(7119), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4691), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [331839] = 5,
    ACTIONS(11440), 1,
      anon_sym_else,
    STATE(6998), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11521), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [331862] = 4,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5058), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [331883] = 8,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11448), 1,
      anon_sym_LPAREN,
    ACTIONS(11450), 1,
      anon_sym_SLASH,
    STATE(8481), 1,
      sym_string,
    ACTIONS(11523), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [331912] = 8,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11448), 1,
      anon_sym_LPAREN,
    ACTIONS(11450), 1,
      anon_sym_SLASH,
    STATE(8613), 1,
      sym_string,
    ACTIONS(11525), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [331941] = 4,
    ACTIONS(8752), 1,
      anon_sym_COMMA,
    STATE(6866), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11527), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [331961] = 4,
    ACTIONS(8752), 1,
      anon_sym_COMMA,
    STATE(6884), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8750), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [331981] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7123), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11491), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332003] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7139), 1,
      sym_else_clause,
    STATE(6851), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11452), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332025] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(6998), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11521), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332047] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7174), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11456), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332069] = 4,
    ACTIONS(8756), 1,
      anon_sym_COMMA,
    STATE(6874), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11531), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332089] = 5,
    ACTIONS(11533), 1,
      anon_sym_else,
    STATE(7140), 1,
      sym_else_clause,
    STATE(6864), 2,
      sym_else_when_clause,
      aux_sym_when_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11511), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332111] = 4,
    ACTIONS(8752), 1,
      anon_sym_COMMA,
    STATE(6866), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8750), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332131] = 5,
    ACTIONS(4496), 1,
      anon_sym_SLASH,
    ACTIONS(11535), 1,
      anon_sym_DOT2,
    STATE(6873), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4494), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [332153] = 4,
    ACTIONS(8752), 1,
      anon_sym_COMMA,
    STATE(6866), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8766), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332173] = 5,
    ACTIONS(4187), 1,
      anon_sym_SLASH,
    ACTIONS(11535), 1,
      anon_sym_DOT2,
    STATE(6858), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4185), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [332195] = 4,
    ACTIONS(11539), 1,
      anon_sym_else,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11537), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332215] = 4,
    ACTIONS(8756), 1,
      anon_sym_COMMA,
    STATE(6874), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8754), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332235] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7060), 1,
      sym_else_clause,
    STATE(6878), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11438), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332257] = 4,
    ACTIONS(11544), 1,
      anon_sym_else,
    STATE(6864), 2,
      sym_else_when_clause,
      aux_sym_when_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11542), 5,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332277] = 5,
    ACTIONS(11533), 1,
      anon_sym_else,
    STATE(6937), 1,
      sym_else_clause,
    STATE(6856), 2,
      sym_else_when_clause,
      aux_sym_when_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11503), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332299] = 4,
    ACTIONS(11547), 1,
      anon_sym_COMMA,
    STATE(6866), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8994), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332319] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7185), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11481), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332341] = 5,
    ACTIONS(4548), 1,
      anon_sym_SLASH,
    ACTIONS(11550), 1,
      anon_sym_LBRACE,
    STATE(4031), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4546), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [332363] = 3,
    ACTIONS(11552), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5428), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332381] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7121), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11495), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332403] = 4,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6882), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8762), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332423] = 4,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6882), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8758), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332443] = 5,
    ACTIONS(4455), 1,
      anon_sym_SLASH,
    ACTIONS(11554), 1,
      anon_sym_DOT2,
    STATE(6873), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4453), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [332465] = 4,
    ACTIONS(11557), 1,
      anon_sym_COMMA,
    STATE(6874), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7640), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332485] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7082), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11442), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332507] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7088), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11444), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332529] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7205), 1,
      sym_else_clause,
    STATE(6891), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11470), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332551] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7155), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11472), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332573] = 4,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6872), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8762), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332593] = 4,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6905), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8776), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332613] = 4,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6906), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8778), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332633] = 4,
    ACTIONS(11560), 1,
      anon_sym_COMMA,
    STATE(6882), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8956), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332653] = 4,
    ACTIONS(8756), 1,
      anon_sym_COMMA,
    STATE(6874), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8784), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332673] = 4,
    ACTIONS(8752), 1,
      anon_sym_COMMA,
    STATE(6866), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8770), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332693] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7113), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11493), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332715] = 4,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6882), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11563), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332735] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(6955), 1,
      sym_else_clause,
    STATE(6875), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11458), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332757] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7132), 1,
      sym_else_clause,
    STATE(6867), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11489), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332779] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7086), 1,
      sym_else_clause,
    STATE(6876), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11460), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332801] = 4,
    ACTIONS(8752), 1,
      anon_sym_COMMA,
    STATE(6859), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8770), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332821] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7141), 1,
      sym_else_clause,
    STATE(6861), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11464), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [332843] = 4,
    ACTIONS(8752), 1,
      anon_sym_COMMA,
    STATE(6866), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11426), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332863] = 4,
    ACTIONS(8756), 1,
      anon_sym_COMMA,
    STATE(6874), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8768), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332883] = 4,
    ACTIONS(8752), 1,
      anon_sym_COMMA,
    STATE(6857), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8780), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332903] = 5,
    ACTIONS(4536), 1,
      anon_sym_SLASH,
    ACTIONS(11550), 1,
      anon_sym_LBRACE,
    STATE(4031), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4534), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [332925] = 4,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6871), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8772), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332945] = 4,
    ACTIONS(8752), 1,
      anon_sym_COMMA,
    STATE(6892), 1,
      aux_sym_const_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8766), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [332965] = 5,
    ACTIONS(4568), 1,
      anon_sym_SLASH,
    ACTIONS(11550), 1,
      anon_sym_LBRACE,
    STATE(4031), 1,
      aux_sym_struct_type_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4566), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [332987] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7158), 1,
      sym_else_clause,
    STATE(6854), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11466), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [333009] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8774), 8,
      sym__newline,
      sym__nl_comma,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [333025] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7160), 1,
      sym_else_clause,
    STATE(6885), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11454), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [333047] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7145), 1,
      sym_else_clause,
    STATE(6870), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11477), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [333069] = 4,
    ACTIONS(8756), 1,
      anon_sym_COMMA,
    STATE(6874), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11565), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [333089] = 5,
    ACTIONS(11529), 1,
      anon_sym_else,
    STATE(7204), 1,
      sym_else_clause,
    STATE(6853), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11509), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [333111] = 4,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6882), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8778), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [333131] = 4,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6882), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8772), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [333151] = 4,
    ACTIONS(8756), 1,
      anon_sym_COMMA,
    STATE(6874), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8786), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [333171] = 4,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6886), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8758), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [333191] = 7,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_BQUOTE,
    ACTIONS(11567), 1,
      sym_identifier,
    ACTIONS(11569), 1,
      anon_sym_LBRACE,
    STATE(6946), 1,
      sym_string,
    STATE(4038), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [333216] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8994), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [333231] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5482), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [333250] = 8,
    ACTIONS(11487), 1,
      anon_sym_DOT2,
    ACTIONS(11573), 1,
      anon_sym_COMMA,
    ACTIONS(11575), 1,
      anon_sym_COLON,
    ACTIONS(11577), 1,
      anon_sym_COLON_EQ,
    ACTIONS(11579), 1,
      anon_sym_RPAREN,
    STATE(3496), 1,
      aux_sym_field_type_repeat1,
    STATE(7580), 1,
      aux_sym_parameter_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [333277] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5468), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [333296] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5464), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [333315] = 5,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(11581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(859), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [333336] = 7,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_BQUOTE,
    ACTIONS(11583), 1,
      sym_identifier,
    ACTIONS(11585), 1,
      anon_sym_LBRACE,
    STATE(6961), 1,
      sym_string,
    STATE(4038), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [333361] = 8,
    ACTIONS(11587), 1,
      anon_sym_LBRACE,
    ACTIONS(11589), 1,
      anon_sym_where,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11593), 1,
      sym_tag,
    STATE(7271), 1,
      aux_sym_struct_declaration_repeat1,
    STATE(7272), 1,
      sym_polymorphic_parameters,
    STATE(8941), 1,
      sym_where_clause,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [333388] = 8,
    ACTIONS(11487), 1,
      anon_sym_DOT2,
    ACTIONS(11573), 1,
      anon_sym_COMMA,
    ACTIONS(11595), 1,
      anon_sym_COLON,
    ACTIONS(11597), 1,
      anon_sym_COLON_EQ,
    ACTIONS(11599), 1,
      anon_sym_RPAREN,
    STATE(3496), 1,
      aux_sym_field_type_repeat1,
    STATE(7389), 1,
      aux_sym_parameter_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [333415] = 6,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    ACTIONS(11420), 1,
      anon_sym_EQ,
    ACTIONS(11601), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11418), 3,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [333438] = 8,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    ACTIONS(11497), 1,
      anon_sym_LPAREN,
    ACTIONS(11603), 1,
      anon_sym_COMMA,
    ACTIONS(11605), 1,
      anon_sym_RPAREN,
    ACTIONS(11607), 1,
      anon_sym_DOT,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    STATE(7751), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [333465] = 3,
    ACTIONS(4455), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4453), 6,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT2,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [333482] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8956), 7,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [333497] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5448), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [333516] = 5,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(8456), 1,
      anon_sym_LBRACE,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(767), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [333537] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4800), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [333556] = 4,
    ACTIONS(11611), 1,
      sym_identifier,
    ACTIONS(11613), 2,
      anon_sym_else,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11609), 4,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [333575] = 5,
    ACTIONS(7642), 1,
      anon_sym_COLON,
    ACTIONS(11615), 1,
      anon_sym_COMMA,
    STATE(6927), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7640), 4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_SEMI,
  [333596] = 8,
    ACTIONS(11589), 1,
      anon_sym_where,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11593), 1,
      sym_tag,
    ACTIONS(11618), 1,
      anon_sym_LBRACE,
    STATE(7372), 1,
      sym_polymorphic_parameters,
    STATE(7373), 1,
      aux_sym_struct_declaration_repeat1,
    STATE(9151), 1,
      sym_where_clause,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [333623] = 7,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_BQUOTE,
    ACTIONS(11620), 1,
      sym_identifier,
    ACTIONS(11622), 1,
      anon_sym_LBRACE,
    STATE(7085), 1,
      sym_string,
    STATE(4038), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [333648] = 4,
    ACTIONS(11626), 1,
      sym_identifier,
    ACTIONS(11628), 2,
      anon_sym_else,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11624), 4,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [333667] = 6,
    ACTIONS(7896), 1,
      anon_sym_LPAREN,
    ACTIONS(11396), 1,
      anon_sym_SLASH,
    ACTIONS(11424), 1,
      anon_sym_EQ,
    ACTIONS(11630), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11422), 3,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [333690] = 3,
    ACTIONS(5398), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5396), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [333706] = 3,
    ACTIONS(4693), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4691), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [333722] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11632), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [333736] = 3,
    ACTIONS(5490), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5488), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [333752] = 3,
    ACTIONS(894), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(891), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [333768] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11511), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [333782] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11634), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [333796] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5058), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [333814] = 4,
    ACTIONS(11448), 1,
      anon_sym_LPAREN,
    ACTIONS(11450), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5482), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [333832] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11636), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [333846] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11638), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [333860] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11640), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [333874] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11642), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [333888] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5382), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [333906] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11644), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [333920] = 6,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_BQUOTE,
    ACTIONS(11646), 1,
      anon_sym_LBRACE,
    STATE(6966), 1,
      sym_string,
    STATE(4038), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [333942] = 6,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11648), 1,
      anon_sym_RBRACE,
    STATE(8403), 1,
      sym_string,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [333964] = 7,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11650), 1,
      anon_sym_COMMA,
    ACTIONS(11652), 1,
      anon_sym_RPAREN,
    ACTIONS(11654), 1,
      anon_sym_when,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    STATE(8381), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [333988] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11658), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334002] = 7,
    ACTIONS(11550), 1,
      anon_sym_LBRACE,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(4142), 1,
      aux_sym_struct_type_repeat2,
    STATE(7386), 1,
      sym_polymorphic_parameters,
    STATE(7398), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334026] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11662), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334040] = 7,
    ACTIONS(11550), 1,
      anon_sym_LBRACE,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(6895), 1,
      aux_sym_struct_type_repeat2,
    STATE(7423), 1,
      sym_polymorphic_parameters,
    STATE(7425), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334064] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6579), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334078] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11442), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334092] = 5,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11664), 2,
      anon_sym_RBRACE,
      anon_sym_case,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334112] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11668), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334126] = 3,
    ACTIONS(3675), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3671), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [334142] = 3,
    ACTIONS(5334), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5332), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [334158] = 6,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11670), 1,
      anon_sym_RBRACE,
    STATE(8403), 1,
      sym_string,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334180] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11672), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334194] = 3,
    ACTIONS(818), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(815), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [334210] = 3,
    ACTIONS(5402), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5400), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [334226] = 3,
    ACTIONS(4669), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4667), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [334242] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11674), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334256] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11676), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334270] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11678), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334284] = 7,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(11680), 1,
      anon_sym_COMMA,
    ACTIONS(11682), 1,
      anon_sym_RPAREN,
    ACTIONS(11684), 1,
      anon_sym_when,
    STATE(7768), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334308] = 5,
    STATE(40), 1,
      sym__separator,
    STATE(7104), 1,
      aux_sym_block_repeat1,
    ACTIONS(11664), 2,
      anon_sym_RBRACE,
      anon_sym_case,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334328] = 7,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(11686), 1,
      anon_sym_COMMA,
    ACTIONS(11688), 1,
      anon_sym_RPAREN,
    ACTIONS(11690), 1,
      anon_sym_when,
    STATE(8302), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334352] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11692), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334366] = 3,
    ACTIONS(773), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(767), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [334382] = 5,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11664), 2,
      anon_sym_RBRACE,
      anon_sym_case,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334402] = 6,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11694), 1,
      anon_sym_RBRACE,
    STATE(8403), 1,
      sym_string,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334424] = 3,
    ACTIONS(5246), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5244), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [334440] = 7,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(11696), 1,
      anon_sym_COMMA,
    ACTIONS(11698), 1,
      anon_sym_RPAREN,
    ACTIONS(11700), 1,
      anon_sym_when,
    STATE(8326), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334464] = 3,
    ACTIONS(4025), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4023), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [334480] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11702), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334494] = 7,
    ACTIONS(11487), 1,
      anon_sym_DOT2,
    ACTIONS(11573), 1,
      anon_sym_COMMA,
    ACTIONS(11704), 1,
      anon_sym_COLON,
    ACTIONS(11706), 1,
      anon_sym_RPAREN,
    STATE(3496), 1,
      aux_sym_field_type_repeat1,
    STATE(7498), 1,
      aux_sym_parameter_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334518] = 3,
    ACTIONS(4085), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4083), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [334534] = 3,
    ACTIONS(5434), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5432), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [334550] = 7,
    ACTIONS(7993), 1,
      anon_sym_LBRACE,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(4074), 1,
      aux_sym_struct_type_repeat2,
    STATE(7413), 1,
      aux_sym_struct_type_repeat1,
    STATE(7414), 1,
      sym_polymorphic_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334574] = 3,
    ACTIONS(3421), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3415), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [334590] = 7,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(11708), 1,
      anon_sym_COMMA,
    ACTIONS(11710), 1,
      anon_sym_RPAREN,
    ACTIONS(11712), 1,
      anon_sym_when,
    STATE(8144), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334614] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11714), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334628] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11716), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334642] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11718), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334656] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11720), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334670] = 5,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(11722), 2,
      anon_sym_RBRACE,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334690] = 7,
    ACTIONS(7659), 1,
      anon_sym_LBRACE,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(3586), 1,
      aux_sym_struct_type_repeat2,
    STATE(7421), 1,
      aux_sym_struct_type_repeat1,
    STATE(7427), 1,
      sym_polymorphic_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334714] = 5,
    STATE(40), 1,
      sym__separator,
    STATE(7108), 1,
      aux_sym_block_repeat1,
    ACTIONS(11664), 2,
      anon_sym_RBRACE,
      anon_sym_case,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334734] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11724), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334748] = 5,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(11726), 2,
      anon_sym_RBRACE,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334768] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11728), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334782] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11730), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334796] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11732), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334810] = 5,
    STATE(40), 1,
      sym__separator,
    STATE(7037), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(11722), 2,
      anon_sym_RBRACE,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334830] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11734), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334844] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11736), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334858] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11738), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334872] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11740), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334886] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11742), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334900] = 6,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11744), 1,
      anon_sym_RBRACE,
    STATE(8403), 1,
      sym_string,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [334922] = 3,
    ACTIONS(5276), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5274), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [334938] = 3,
    ACTIONS(5280), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5278), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [334954] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11746), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334968] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11748), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [334982] = 6,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11750), 1,
      anon_sym_RBRACE,
    STATE(8403), 1,
      sym_string,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335004] = 3,
    ACTIONS(5338), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5336), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [335020] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11752), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335034] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11754), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335048] = 3,
    ACTIONS(5342), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5340), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [335064] = 6,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_BQUOTE,
    ACTIONS(11756), 1,
      anon_sym_LBRACE,
    STATE(6965), 1,
      sym_string,
    STATE(4038), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335086] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11758), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335100] = 3,
    ACTIONS(5346), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5344), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [335116] = 7,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(11760), 1,
      anon_sym_LBRACE,
    STATE(3120), 1,
      aux_sym_struct_type_repeat2,
    STATE(7403), 1,
      aux_sym_struct_type_repeat1,
    STATE(7405), 1,
      sym_polymorphic_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335140] = 6,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11762), 1,
      anon_sym_RBRACE,
    STATE(8403), 1,
      sym_string,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335162] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11764), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335176] = 5,
    STATE(40), 1,
      sym__separator,
    STATE(6956), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(11766), 2,
      anon_sym_RBRACE,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335196] = 3,
    ACTIONS(5368), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5366), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [335212] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11768), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335226] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11770), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335240] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11772), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335254] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11774), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335268] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11776), 1,
      sym_identifier,
    ACTIONS(11778), 1,
      anon_sym_EQ,
    ACTIONS(11780), 1,
      anon_sym_SLASH,
    ACTIONS(10401), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335290] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11782), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335304] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11784), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335318] = 5,
    STATE(40), 1,
      sym__separator,
    STATE(6973), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(11766), 2,
      anon_sym_RBRACE,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335338] = 5,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(11786), 2,
      anon_sym_RBRACE,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335358] = 7,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(11788), 1,
      anon_sym_COMMA,
    ACTIONS(11790), 1,
      anon_sym_RPAREN,
    ACTIONS(11792), 1,
      anon_sym_when,
    STATE(8379), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335382] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11794), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335396] = 3,
    ACTIONS(5372), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5370), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [335412] = 5,
    STATE(40), 1,
      sym__separator,
    STATE(6993), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(11786), 2,
      anon_sym_RBRACE,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335432] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11796), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335446] = 3,
    ACTIONS(5376), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5374), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [335462] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11798), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335476] = 5,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(11800), 2,
      anon_sym_RBRACE,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335496] = 6,
    ACTIONS(51), 1,
      anon_sym_DQUOTE,
    ACTIONS(53), 1,
      anon_sym_BQUOTE,
    ACTIONS(11802), 1,
      anon_sym_LBRACE,
    STATE(7050), 1,
      sym_string,
    STATE(4038), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335518] = 7,
    ACTIONS(11487), 1,
      anon_sym_DOT2,
    ACTIONS(11573), 1,
      anon_sym_COMMA,
    ACTIONS(11804), 1,
      anon_sym_COLON,
    ACTIONS(11806), 1,
      anon_sym_RPAREN,
    STATE(3496), 1,
      aux_sym_field_type_repeat1,
    STATE(7586), 1,
      aux_sym_parameter_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335542] = 7,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(11808), 1,
      anon_sym_COMMA,
    ACTIONS(11810), 1,
      anon_sym_RPAREN,
    ACTIONS(11812), 1,
      anon_sym_when,
    STATE(7849), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335566] = 7,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(11814), 1,
      anon_sym_LBRACE,
    STATE(2125), 1,
      aux_sym_struct_type_repeat2,
    STATE(7463), 1,
      aux_sym_struct_type_repeat1,
    STATE(7464), 1,
      sym_polymorphic_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335590] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11816), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335604] = 3,
    ACTIONS(5380), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5378), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [335620] = 5,
    ACTIONS(7642), 1,
      anon_sym_COLON,
    ACTIONS(11818), 1,
      anon_sym_COMMA,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(7640), 3,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
  [335640] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11821), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335654] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11823), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335668] = 3,
    ACTIONS(5384), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5382), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [335684] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11780), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5448), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_identifier,
  [335702] = 3,
    ACTIONS(861), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(859), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [335718] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11825), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335732] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11827), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335746] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11780), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4800), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_identifier,
  [335764] = 3,
    ACTIONS(5060), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5058), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [335780] = 7,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(11829), 1,
      anon_sym_COMMA,
    ACTIONS(11831), 1,
      anon_sym_RPAREN,
    ACTIONS(11833), 1,
      anon_sym_when,
    STATE(7760), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335804] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11835), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335818] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11837), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335832] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11780), 1,
      anon_sym_SLASH,
    ACTIONS(11839), 1,
      sym_identifier,
    ACTIONS(11841), 1,
      anon_sym_EQ,
    ACTIONS(11806), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335854] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11843), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335868] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11845), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335882] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11472), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335896] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11847), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335910] = 7,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(11849), 1,
      anon_sym_COMMA,
    ACTIONS(11851), 1,
      anon_sym_RPAREN,
    ACTIONS(11853), 1,
      anon_sym_when,
    STATE(7981), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335934] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11855), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [335948] = 3,
    ACTIONS(3785), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3781), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [335964] = 7,
    ACTIONS(7655), 1,
      anon_sym_LBRACE,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(3662), 1,
      aux_sym_struct_type_repeat2,
    STATE(7387), 1,
      aux_sym_struct_type_repeat1,
    STATE(7397), 1,
      sym_polymorphic_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [335988] = 3,
    ACTIONS(5544), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5542), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [336004] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11857), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336018] = 3,
    ACTIONS(5135), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5132), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [336034] = 4,
    ACTIONS(11448), 1,
      anon_sym_LPAREN,
    ACTIONS(11450), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4800), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [336052] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11859), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336066] = 5,
    STATE(40), 1,
      sym__separator,
    STATE(7029), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(11861), 2,
      anon_sym_RBRACE,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [336086] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11863), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336100] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11865), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336114] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11867), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336128] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11869), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336142] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11780), 1,
      anon_sym_SLASH,
    ACTIONS(11871), 1,
      sym_identifier,
    ACTIONS(11873), 1,
      anon_sym_EQ,
    ACTIONS(10494), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [336164] = 3,
    ACTIONS(5410), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5408), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [336180] = 7,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(11875), 1,
      anon_sym_COMMA,
    ACTIONS(11877), 1,
      anon_sym_RPAREN,
    ACTIONS(11879), 1,
      anon_sym_when,
    STATE(8259), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [336204] = 7,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(11881), 1,
      anon_sym_COMMA,
    ACTIONS(11883), 1,
      anon_sym_RPAREN,
    ACTIONS(11885), 1,
      anon_sym_when,
    STATE(8138), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [336228] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11887), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336242] = 3,
    ACTIONS(915), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(913), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [336258] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11889), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336272] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11891), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336286] = 3,
    ACTIONS(5414), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5412), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [336302] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11893), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336316] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11444), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336330] = 7,
    ACTIONS(7993), 1,
      anon_sym_LBRACE,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(4110), 1,
      aux_sym_struct_type_repeat2,
    STATE(7584), 1,
      aux_sym_struct_type_repeat1,
    STATE(7591), 1,
      sym_polymorphic_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [336354] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11895), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336368] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11897), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336382] = 3,
    ACTIONS(5418), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5416), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [336398] = 3,
    ACTIONS(5430), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5428), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [336414] = 7,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(11899), 1,
      anon_sym_LBRACE,
    STATE(669), 1,
      aux_sym_struct_type_repeat2,
    STATE(7500), 1,
      aux_sym_struct_type_repeat1,
    STATE(7501), 1,
      sym_polymorphic_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [336438] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11901), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336452] = 3,
    ACTIONS(5524), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5522), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [336468] = 6,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    ACTIONS(11497), 1,
      anon_sym_LPAREN,
    ACTIONS(11607), 1,
      anon_sym_DOT,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(11903), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [336490] = 7,
    ACTIONS(6715), 1,
      anon_sym_LBRACE,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(2714), 1,
      aux_sym_struct_type_repeat2,
    STATE(7529), 1,
      aux_sym_struct_type_repeat1,
    STATE(7531), 1,
      sym_polymorphic_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [336514] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11905), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336528] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11907), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336542] = 6,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11909), 1,
      anon_sym_RBRACE,
    STATE(8403), 1,
      sym_string,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [336564] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11911), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336578] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11913), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336592] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11915), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336606] = 3,
    ACTIONS(5438), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5436), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [336622] = 5,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(11917), 2,
      anon_sym_RBRACE,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [336642] = 6,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    ACTIONS(11919), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11921), 1,
      anon_sym_COLON,
    STATE(6927), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(9835), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [336664] = 3,
    ACTIONS(5446), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5444), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [336680] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11923), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336694] = 5,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(11917), 2,
      anon_sym_RBRACE,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [336714] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11925), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336728] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11927), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336742] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11929), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336756] = 5,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11931), 2,
      anon_sym_RBRACE,
      anon_sym_case,
    ACTIONS(11933), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [336776] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11936), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336790] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11938), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336804] = 3,
    ACTIONS(5528), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5526), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [336820] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11940), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336834] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11942), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336848] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11944), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336862] = 3,
    ACTIONS(5498), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5496), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [336878] = 7,
    ACTIONS(7655), 1,
      anon_sym_LBRACE,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(3600), 1,
      aux_sym_struct_type_repeat2,
    STATE(7429), 1,
      sym_polymorphic_parameters,
    STATE(7436), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [336902] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11946), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336916] = 4,
    ACTIONS(11448), 1,
      anon_sym_LPAREN,
    ACTIONS(11450), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5448), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [336934] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11948), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [336948] = 3,
    ACTIONS(5556), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5554), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [336964] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11780), 1,
      anon_sym_SLASH,
    ACTIONS(11950), 1,
      sym_identifier,
    ACTIONS(11952), 1,
      anon_sym_EQ,
    ACTIONS(10444), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [336986] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11954), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337000] = 6,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11956), 1,
      anon_sym_RBRACE,
    STATE(8403), 1,
      sym_string,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [337022] = 6,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11958), 1,
      anon_sym_RBRACE,
    STATE(8403), 1,
      sym_string,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [337044] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11960), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337058] = 7,
    ACTIONS(6715), 1,
      anon_sym_LBRACE,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(2536), 1,
      aux_sym_struct_type_repeat2,
    STATE(7485), 1,
      aux_sym_struct_type_repeat1,
    STATE(7486), 1,
      sym_polymorphic_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [337082] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11962), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337096] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11481), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337110] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11964), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337124] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11966), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337138] = 3,
    ACTIONS(5454), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5452), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [337154] = 7,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(11968), 1,
      anon_sym_LBRACE,
    STATE(3383), 1,
      aux_sym_struct_type_repeat2,
    STATE(7530), 1,
      aux_sym_struct_type_repeat1,
    STATE(7534), 1,
      sym_polymorphic_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [337178] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11970), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337192] = 6,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    ACTIONS(11972), 1,
      anon_sym_RBRACE,
    STATE(8403), 1,
      sym_string,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [337214] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11491), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337228] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11974), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337242] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11976), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337256] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11978), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337270] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11980), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337284] = 5,
    STATE(40), 1,
      sym__separator,
    STATE(6989), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(11982), 2,
      anon_sym_RBRACE,
      anon_sym_case,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [337304] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11495), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337318] = 7,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(11984), 1,
      anon_sym_COMMA,
    ACTIONS(11986), 1,
      anon_sym_RPAREN,
    ACTIONS(11988), 1,
      anon_sym_when,
    STATE(7978), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [337342] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11990), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337356] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11992), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337370] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11994), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337384] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11996), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337398] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11998), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337412] = 3,
    ACTIONS(5552), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5550), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [337428] = 7,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(12000), 1,
      anon_sym_COMMA,
    ACTIONS(12002), 1,
      anon_sym_RPAREN,
    ACTIONS(12004), 1,
      anon_sym_when,
    STATE(8111), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [337452] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12006), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337466] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12008), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337480] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12010), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337494] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12012), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337508] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11456), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337522] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12014), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337536] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11493), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337550] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12016), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337564] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12018), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337578] = 7,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(12020), 1,
      anon_sym_LBRACE,
    STATE(2920), 1,
      aux_sym_struct_type_repeat2,
    STATE(7417), 1,
      sym_polymorphic_parameters,
    STATE(7419), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [337602] = 3,
    ACTIONS(4187), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4185), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [337618] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12022), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337632] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12024), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337646] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12026), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337660] = 7,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(12028), 1,
      anon_sym_COMMA,
    ACTIONS(12030), 1,
      anon_sym_RPAREN,
    ACTIONS(12032), 1,
      anon_sym_when,
    STATE(8271), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [337684] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(913), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [337702] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12034), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337716] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12036), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337730] = 7,
    ACTIONS(11487), 1,
      anon_sym_DOT2,
    ACTIONS(11573), 1,
      anon_sym_COMMA,
    ACTIONS(11599), 1,
      anon_sym_RPAREN,
    ACTIONS(12038), 1,
      anon_sym_COLON,
    STATE(3496), 1,
      aux_sym_field_type_repeat1,
    STATE(7389), 1,
      aux_sym_parameter_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [337754] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11780), 1,
      anon_sym_SLASH,
    ACTIONS(12040), 1,
      sym_identifier,
    ACTIONS(12042), 1,
      anon_sym_EQ,
    ACTIONS(10490), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [337776] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12044), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337790] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12046), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337804] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12048), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337818] = 7,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(12050), 1,
      anon_sym_COMMA,
    ACTIONS(12052), 1,
      anon_sym_RPAREN,
    ACTIONS(12054), 1,
      anon_sym_when,
    STATE(7910), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [337842] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12056), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337856] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(859), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [337874] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12058), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337888] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12060), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337902] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12062), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337916] = 7,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(12064), 1,
      anon_sym_COMMA,
    ACTIONS(12066), 1,
      anon_sym_RPAREN,
    ACTIONS(12068), 1,
      anon_sym_when,
    STATE(7986), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [337940] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12070), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337954] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12072), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [337968] = 7,
    ACTIONS(6358), 1,
      anon_sym_LBRACE,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(1869), 1,
      aux_sym_struct_type_repeat2,
    STATE(7572), 1,
      aux_sym_struct_type_repeat1,
    STATE(7576), 1,
      sym_polymorphic_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [337992] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12074), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [338006] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12076), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [338020] = 4,
    ACTIONS(11448), 1,
      anon_sym_LPAREN,
    ACTIONS(11450), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5464), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [338038] = 4,
    ACTIONS(11448), 1,
      anon_sym_LPAREN,
    ACTIONS(11450), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5468), 4,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [338056] = 7,
    ACTIONS(6358), 1,
      anon_sym_LBRACE,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(2041), 1,
      aux_sym_struct_type_repeat2,
    STATE(7542), 1,
      aux_sym_struct_type_repeat1,
    STATE(7545), 1,
      sym_polymorphic_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338080] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12078), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [338094] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12080), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [338108] = 7,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(12082), 1,
      anon_sym_COMMA,
    ACTIONS(12084), 1,
      anon_sym_RPAREN,
    ACTIONS(12086), 1,
      anon_sym_when,
    STATE(8022), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338132] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12088), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [338146] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11780), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5482), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_identifier,
  [338164] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12090), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [338178] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12092), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [338192] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11780), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5468), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_identifier,
  [338210] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11780), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5464), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RPAREN,
      sym_identifier,
  [338228] = 3,
    ACTIONS(5474), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5472), 5,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
  [338244] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12094), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [338258] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11780), 1,
      anon_sym_SLASH,
    ACTIONS(12096), 1,
      sym_identifier,
    ACTIONS(12098), 1,
      anon_sym_EQ,
    ACTIONS(11706), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338280] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11521), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [338294] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11464), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [338308] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12100), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [338322] = 7,
    ACTIONS(7659), 1,
      anon_sym_LBRACE,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(3497), 1,
      aux_sym_struct_type_repeat2,
    STATE(7581), 1,
      aux_sym_struct_type_repeat1,
    STATE(7587), 1,
      sym_polymorphic_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338346] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12102), 6,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_case,
  [338360] = 5,
    ACTIONS(12104), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338379] = 4,
    ACTIONS(9600), 1,
      anon_sym_COMMA,
    STATE(7244), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3387), 3,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [338396] = 5,
    ACTIONS(12106), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7314), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338415] = 4,
    ACTIONS(11487), 1,
      anon_sym_DOT2,
    STATE(3496), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12108), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [338432] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(8954), 1,
      anon_sym_RBRACE,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12110), 1,
      anon_sym_COMMA,
    STATE(8188), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338453] = 5,
    ACTIONS(12112), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7230), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338472] = 5,
    ACTIONS(12114), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7246), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338491] = 6,
    ACTIONS(12116), 1,
      sym_identifier,
    ACTIONS(12118), 1,
      anon_sym_RBRACE,
    ACTIONS(12120), 1,
      anon_sym_using,
    STATE(8237), 1,
      sym_struct_member,
    STATE(8763), 1,
      sym__struct_members,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338512] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5464), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_when,
  [338529] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5468), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_when,
  [338546] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5482), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_when,
  [338563] = 6,
    ACTIONS(12122), 1,
      sym_identifier,
    ACTIONS(12124), 1,
      anon_sym_RBRACE,
    ACTIONS(12126), 1,
      anon_sym_using,
    ACTIONS(12128), 1,
      sym_tag,
    STATE(8612), 1,
      sym_field,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338584] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(815), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [338601] = 6,
    ACTIONS(12122), 1,
      sym_identifier,
    ACTIONS(12126), 1,
      anon_sym_using,
    ACTIONS(12128), 1,
      sym_tag,
    ACTIONS(12130), 1,
      anon_sym_RBRACE,
    STATE(8205), 1,
      sym_field,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338622] = 5,
    ACTIONS(12132), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7235), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338641] = 5,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(8764), 1,
      anon_sym_SEMI,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12134), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338660] = 5,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    ACTIONS(12136), 1,
      anon_sym_COLON,
    STATE(6927), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(9775), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338679] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5132), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [338696] = 6,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(11919), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11921), 1,
      anon_sym_COLON,
    ACTIONS(12138), 1,
      anon_sym_COLON_EQ,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338717] = 6,
    ACTIONS(12122), 1,
      sym_identifier,
    ACTIONS(12126), 1,
      anon_sym_using,
    ACTIONS(12128), 1,
      sym_tag,
    ACTIONS(12130), 1,
      anon_sym_RBRACE,
    STATE(8612), 1,
      sym_field,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338738] = 5,
    ACTIONS(12140), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7254), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338757] = 5,
    ACTIONS(12140), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338776] = 5,
    ACTIONS(12142), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338795] = 5,
    ACTIONS(12144), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7253), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338814] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(767), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [338831] = 6,
    ACTIONS(12122), 1,
      sym_identifier,
    ACTIONS(12126), 1,
      anon_sym_using,
    ACTIONS(12128), 1,
      sym_tag,
    ACTIONS(12146), 1,
      anon_sym_RBRACE,
    STATE(8612), 1,
      sym_field,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338852] = 5,
    ACTIONS(12144), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338871] = 6,
    ACTIONS(12122), 1,
      sym_identifier,
    ACTIONS(12126), 1,
      anon_sym_using,
    ACTIONS(12128), 1,
      sym_tag,
    ACTIONS(12148), 1,
      anon_sym_RBRACE,
    STATE(8612), 1,
      sym_field,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338892] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12152), 1,
      anon_sym_RPAREN,
    STATE(7743), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338913] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12154), 1,
      anon_sym_RBRACE,
    ACTIONS(12156), 1,
      anon_sym_COMMA,
    STATE(8084), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338934] = 5,
    ACTIONS(12158), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7277), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338953] = 5,
    ACTIONS(12160), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338972] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12162), 1,
      anon_sym_RBRACE,
    ACTIONS(12164), 1,
      anon_sym_COMMA,
    STATE(7752), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [338993] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12166), 1,
      anon_sym_RPAREN,
    STATE(8098), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339014] = 5,
    ACTIONS(12168), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339033] = 4,
    ACTIONS(12170), 1,
      anon_sym_COMMA,
    STATE(6882), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3383), 3,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [339050] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12172), 1,
      anon_sym_RBRACE,
    ACTIONS(12174), 1,
      anon_sym_COMMA,
    STATE(7991), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339071] = 5,
    ACTIONS(12158), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339090] = 5,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(8784), 1,
      anon_sym_SEMI,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12176), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339109] = 6,
    ACTIONS(12116), 1,
      sym_identifier,
    ACTIONS(12120), 1,
      anon_sym_using,
    ACTIONS(12178), 1,
      anon_sym_RBRACE,
    STATE(8237), 1,
      sym_struct_member,
    STATE(9101), 1,
      sym__struct_members,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339130] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12180), 1,
      anon_sym_RPAREN,
    STATE(8006), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339151] = 4,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6905), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8776), 3,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [339168] = 4,
    ACTIONS(5430), 1,
      anon_sym_SLASH,
    ACTIONS(12182), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5428), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [339185] = 5,
    ACTIONS(12184), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339204] = 5,
    ACTIONS(12186), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339223] = 5,
    ACTIONS(12188), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339242] = 5,
    ACTIONS(12184), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7231), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339261] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12190), 1,
      anon_sym_RBRACE,
    ACTIONS(12192), 1,
      anon_sym_COMMA,
    STATE(8155), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339282] = 5,
    ACTIONS(12194), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7268), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339301] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(4800), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_when,
  [339318] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11656), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5448), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_when,
  [339335] = 6,
    ACTIONS(12116), 1,
      sym_identifier,
    ACTIONS(12120), 1,
      anon_sym_using,
    ACTIONS(12196), 1,
      anon_sym_RBRACE,
    STATE(8237), 1,
      sym_struct_member,
    STATE(9024), 1,
      sym__struct_members,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339356] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12198), 1,
      anon_sym_RPAREN,
    STATE(8197), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339377] = 5,
    ACTIONS(12200), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7252), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339396] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(5244), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [339413] = 6,
    ACTIONS(12122), 1,
      sym_identifier,
    ACTIONS(12126), 1,
      anon_sym_using,
    ACTIONS(12128), 1,
      sym_tag,
    ACTIONS(12202), 1,
      anon_sym_RBRACE,
    STATE(8612), 1,
      sym_field,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339434] = 5,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(11418), 1,
      anon_sym_SEMI,
    ACTIONS(12204), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339453] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(8968), 1,
      anon_sym_RBRACE,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12206), 1,
      anon_sym_COMMA,
    STATE(7820), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339474] = 5,
    ACTIONS(12208), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7294), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339493] = 5,
    ACTIONS(12208), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339512] = 4,
    ACTIONS(9648), 1,
      anon_sym_COMMA,
    STATE(6882), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3385), 3,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [339529] = 6,
    ACTIONS(11589), 1,
      anon_sym_where,
    ACTIONS(11593), 1,
      sym_tag,
    ACTIONS(12210), 1,
      anon_sym_LBRACE,
    STATE(7453), 1,
      aux_sym_struct_declaration_repeat1,
    STATE(9116), 1,
      sym_where_clause,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339550] = 6,
    ACTIONS(11589), 1,
      anon_sym_where,
    ACTIONS(11593), 1,
      sym_tag,
    ACTIONS(11618), 1,
      anon_sym_LBRACE,
    STATE(7453), 1,
      aux_sym_struct_declaration_repeat1,
    STATE(9151), 1,
      sym_where_clause,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339571] = 6,
    ACTIONS(11589), 1,
      anon_sym_where,
    ACTIONS(11593), 1,
      sym_tag,
    ACTIONS(11618), 1,
      anon_sym_LBRACE,
    STATE(7373), 1,
      aux_sym_struct_declaration_repeat1,
    STATE(9151), 1,
      sym_where_clause,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339592] = 5,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    STATE(8047), 1,
      sym_string,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339611] = 6,
    ACTIONS(12122), 1,
      sym_identifier,
    ACTIONS(12124), 1,
      anon_sym_RBRACE,
    ACTIONS(12126), 1,
      anon_sym_using,
    ACTIONS(12128), 1,
      sym_tag,
    STATE(7842), 1,
      sym_field,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339632] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12212), 1,
      anon_sym_RBRACE,
    ACTIONS(12214), 1,
      anon_sym_COMMA,
    STATE(7783), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339653] = 5,
    ACTIONS(12216), 1,
      sym_identifier,
    ACTIONS(12220), 1,
      anon_sym_where,
    ACTIONS(12222), 1,
      sym_number,
    ACTIONS(12218), 2,
      anon_sym_LBRACE,
      sym_tag,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339672] = 5,
    ACTIONS(12224), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339691] = 5,
    ACTIONS(12226), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7293), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339710] = 4,
    ACTIONS(9646), 1,
      anon_sym_COMMA,
    STATE(7269), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(9644), 3,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [339727] = 6,
    ACTIONS(12122), 1,
      sym_identifier,
    ACTIONS(12126), 1,
      anon_sym_using,
    ACTIONS(12128), 1,
      sym_tag,
    ACTIONS(12228), 1,
      anon_sym_RBRACE,
    STATE(7726), 1,
      sym_field,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339748] = 4,
    ACTIONS(9648), 1,
      anon_sym_COMMA,
    STATE(7381), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3385), 3,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [339765] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12230), 1,
      anon_sym_RBRACE,
    ACTIONS(12232), 1,
      anon_sym_COMMA,
    STATE(8014), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339786] = 5,
    ACTIONS(12234), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7286), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339805] = 5,
    ACTIONS(12236), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7326), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339824] = 5,
    ACTIONS(12238), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7297), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339843] = 5,
    ACTIONS(12238), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339862] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12240), 1,
      anon_sym_RPAREN,
    STATE(8015), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339883] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12242), 1,
      anon_sym_RBRACE,
    ACTIONS(12244), 1,
      anon_sym_COMMA,
    STATE(8344), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339904] = 5,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    STATE(7799), 1,
      sym_string,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339923] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12246), 1,
      anon_sym_RPAREN,
    STATE(7782), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339944] = 5,
    ACTIONS(12248), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339963] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12250), 1,
      anon_sym_COMMA,
    ACTIONS(12252), 1,
      anon_sym_RPAREN,
    STATE(8009), 1,
      aux_sym_polymorphic_parameters_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [339984] = 5,
    ACTIONS(12254), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340003] = 5,
    ACTIONS(12256), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340022] = 6,
    ACTIONS(12116), 1,
      sym_identifier,
    ACTIONS(12120), 1,
      anon_sym_using,
    ACTIONS(12258), 1,
      anon_sym_RBRACE,
    STATE(8237), 1,
      sym_struct_member,
    STATE(9202), 1,
      sym__struct_members,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340043] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12260), 1,
      anon_sym_RPAREN,
    STATE(8391), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340064] = 5,
    ACTIONS(12262), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340083] = 5,
    ACTIONS(12264), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340102] = 5,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(11422), 1,
      anon_sym_SEMI,
    ACTIONS(12266), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340121] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12268), 1,
      anon_sym_RPAREN,
    STATE(8195), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340142] = 5,
    ACTIONS(12270), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340161] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12272), 1,
      anon_sym_RPAREN,
    STATE(7832), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340182] = 5,
    ACTIONS(12274), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7360), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340201] = 5,
    ACTIONS(12270), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7240), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340220] = 6,
    ACTIONS(9296), 1,
      anon_sym_COLON,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(9550), 1,
      anon_sym_COLON_EQ,
    ACTIONS(11076), 1,
      anon_sym_COLON_COLON,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340241] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(9018), 1,
      anon_sym_RBRACE,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12276), 1,
      anon_sym_COMMA,
    STATE(7622), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340262] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12250), 1,
      anon_sym_COMMA,
    ACTIONS(12278), 1,
      anon_sym_RPAREN,
    STATE(8399), 1,
      aux_sym_polymorphic_parameters_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340283] = 5,
    ACTIONS(12280), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7371), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340302] = 5,
    ACTIONS(12282), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340321] = 5,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    STATE(8330), 1,
      sym_string,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340340] = 4,
    ACTIONS(773), 1,
      anon_sym_SLASH,
    ACTIONS(8456), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(767), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [340357] = 6,
    ACTIONS(12122), 1,
      sym_identifier,
    ACTIONS(12126), 1,
      anon_sym_using,
    ACTIONS(12128), 1,
      sym_tag,
    ACTIONS(12284), 1,
      anon_sym_RBRACE,
    STATE(7612), 1,
      sym_field,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340378] = 5,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    STATE(8323), 1,
      sym_string,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340397] = 5,
    ACTIONS(12274), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340416] = 5,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12286), 1,
      anon_sym_EQ,
    ACTIONS(5386), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340435] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12288), 1,
      anon_sym_RBRACE,
    ACTIONS(12290), 1,
      anon_sym_COMMA,
    STATE(8184), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340456] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12292), 1,
      anon_sym_RPAREN,
    STATE(7796), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340477] = 6,
    ACTIONS(12122), 1,
      sym_identifier,
    ACTIONS(12126), 1,
      anon_sym_using,
    ACTIONS(12128), 1,
      sym_tag,
    ACTIONS(12284), 1,
      anon_sym_RBRACE,
    STATE(8612), 1,
      sym_field,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340498] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12294), 1,
      anon_sym_RBRACE,
    ACTIONS(12296), 1,
      anon_sym_COMMA,
    STATE(7875), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340519] = 5,
    ACTIONS(12298), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7327), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340538] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(9064), 1,
      anon_sym_RBRACE,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12300), 1,
      anon_sym_COMMA,
    STATE(7735), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340559] = 6,
    ACTIONS(12116), 1,
      sym_identifier,
    ACTIONS(12120), 1,
      anon_sym_using,
    ACTIONS(12302), 1,
      anon_sym_RBRACE,
    STATE(8237), 1,
      sym_struct_member,
    STATE(9007), 1,
      sym__struct_members,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340580] = 5,
    ACTIONS(12304), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7356), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340599] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(891), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [340616] = 5,
    ACTIONS(12306), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340635] = 5,
    ACTIONS(12304), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340654] = 5,
    ACTIONS(12308), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340673] = 5,
    ACTIONS(12310), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340692] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12312), 1,
      anon_sym_RPAREN,
    STATE(8245), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340713] = 5,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(7794), 1,
      anon_sym_LBRACE,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(4800), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340732] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12314), 1,
      anon_sym_RBRACE,
    ACTIONS(12316), 1,
      anon_sym_COMMA,
    STATE(8185), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340753] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12318), 1,
      anon_sym_RBRACE,
    ACTIONS(12320), 1,
      anon_sym_COMMA,
    STATE(8250), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340774] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12322), 1,
      anon_sym_RPAREN,
    STATE(7936), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340795] = 5,
    ACTIONS(12306), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7291), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340814] = 5,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    STATE(8403), 1,
      sym_string,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340833] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12324), 1,
      anon_sym_RBRACE,
    ACTIONS(12326), 1,
      anon_sym_COMMA,
    STATE(8365), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340854] = 4,
    ACTIONS(11487), 1,
      anon_sym_DOT2,
    STATE(3496), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12328), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [340871] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12330), 1,
      anon_sym_RPAREN,
    STATE(8358), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340892] = 5,
    ACTIONS(12332), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340911] = 5,
    ACTIONS(12332), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7328), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340930] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12250), 1,
      anon_sym_COMMA,
    ACTIONS(12334), 1,
      anon_sym_RPAREN,
    STATE(7704), 1,
      aux_sym_polymorphic_parameters_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340951] = 5,
    ACTIONS(12226), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340970] = 5,
    ACTIONS(12308), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7209), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [340989] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12336), 1,
      anon_sym_RBRACE,
    ACTIONS(12338), 1,
      anon_sym_COMMA,
    STATE(7759), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341010] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12340), 1,
      anon_sym_RBRACE,
    ACTIONS(12342), 1,
      anon_sym_COMMA,
    STATE(7806), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341031] = 5,
    ACTIONS(12344), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7339), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341050] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12346), 1,
      anon_sym_RPAREN,
    STATE(7753), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341071] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12348), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341092] = 5,
    ACTIONS(12350), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7342), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341111] = 5,
    ACTIONS(12352), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341130] = 5,
    ACTIONS(12352), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7309), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341149] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12354), 1,
      anon_sym_RBRACE,
    ACTIONS(12356), 1,
      anon_sym_COMMA,
    STATE(8254), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341170] = 5,
    ACTIONS(12358), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341189] = 5,
    ACTIONS(12358), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7298), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341208] = 6,
    ACTIONS(12116), 1,
      sym_identifier,
    ACTIONS(12120), 1,
      anon_sym_using,
    ACTIONS(12360), 1,
      anon_sym_RBRACE,
    STATE(8237), 1,
      sym_struct_member,
    STATE(8780), 1,
      sym__struct_members,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341229] = 5,
    ACTIONS(12362), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341248] = 5,
    ACTIONS(12364), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341267] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12366), 1,
      anon_sym_RPAREN,
    STATE(8304), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341288] = 5,
    ACTIONS(12368), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7301), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341307] = 5,
    ACTIONS(12370), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341326] = 5,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    STATE(8160), 1,
      sym_string,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341345] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12372), 1,
      anon_sym_RBRACE,
    ACTIONS(12374), 1,
      anon_sym_COMMA,
    STATE(8310), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341366] = 6,
    ACTIONS(12116), 1,
      sym_identifier,
    ACTIONS(12120), 1,
      anon_sym_using,
    ACTIONS(12376), 1,
      anon_sym_RBRACE,
    STATE(8237), 1,
      sym_struct_member,
    STATE(8855), 1,
      sym__struct_members,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341387] = 5,
    ACTIONS(12378), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7325), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341406] = 5,
    ACTIONS(12380), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341425] = 5,
    ACTIONS(12380), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7357), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341444] = 6,
    ACTIONS(12122), 1,
      sym_identifier,
    ACTIONS(12126), 1,
      anon_sym_using,
    ACTIONS(12128), 1,
      sym_tag,
    ACTIONS(12382), 1,
      anon_sym_RBRACE,
    STATE(8096), 1,
      sym_field,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341465] = 5,
    ACTIONS(653), 1,
      anon_sym_DQUOTE,
    ACTIONS(655), 1,
      anon_sym_BQUOTE,
    STATE(8018), 1,
      sym_string,
    STATE(4022), 2,
      sym__string_literal,
      sym__raw_string_literal,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341484] = 6,
    ACTIONS(12116), 1,
      sym_identifier,
    ACTIONS(12120), 1,
      anon_sym_using,
    ACTIONS(12384), 1,
      anon_sym_RBRACE,
    STATE(8237), 1,
      sym_struct_member,
    STATE(9074), 1,
      sym__struct_members,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341505] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12386), 1,
      anon_sym_RPAREN,
    STATE(7843), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341526] = 5,
    ACTIONS(12388), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7112), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341545] = 6,
    ACTIONS(11589), 1,
      anon_sym_where,
    ACTIONS(11593), 1,
      sym_tag,
    ACTIONS(12390), 1,
      anon_sym_LBRACE,
    STATE(7270), 1,
      aux_sym_struct_declaration_repeat1,
    STATE(8725), 1,
      sym_where_clause,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341566] = 6,
    ACTIONS(11589), 1,
      anon_sym_where,
    ACTIONS(11593), 1,
      sym_tag,
    ACTIONS(12390), 1,
      anon_sym_LBRACE,
    STATE(7453), 1,
      aux_sym_struct_declaration_repeat1,
    STATE(8725), 1,
      sym_where_clause,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341587] = 4,
    ACTIONS(861), 1,
      anon_sym_SLASH,
    ACTIONS(11581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(859), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [341604] = 6,
    ACTIONS(12116), 1,
      sym_identifier,
    ACTIONS(12120), 1,
      anon_sym_using,
    ACTIONS(12392), 1,
      anon_sym_RBRACE,
    STATE(8237), 1,
      sym_struct_member,
    STATE(9177), 1,
      sym__struct_members,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341625] = 5,
    ACTIONS(12388), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7243), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341644] = 6,
    ACTIONS(12116), 1,
      sym_identifier,
    ACTIONS(12120), 1,
      anon_sym_using,
    ACTIONS(12394), 1,
      anon_sym_RBRACE,
    STATE(8237), 1,
      sym_struct_member,
    STATE(8917), 1,
      sym__struct_members,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341665] = 5,
    ACTIONS(12396), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7365), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341684] = 5,
    ACTIONS(12398), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7350), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341703] = 6,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12400), 1,
      anon_sym_RBRACE,
    ACTIONS(12402), 1,
      anon_sym_COMMA,
    STATE(7837), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341724] = 4,
    ACTIONS(9600), 1,
      anon_sym_COMMA,
    STATE(6882), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(3387), 3,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [341741] = 6,
    ACTIONS(12116), 1,
      sym_identifier,
    ACTIONS(12120), 1,
      anon_sym_using,
    ACTIONS(12404), 1,
      anon_sym_RBRACE,
    STATE(8237), 1,
      sym_struct_member,
    STATE(8814), 1,
      sym__struct_members,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341762] = 5,
    ACTIONS(12406), 1,
      anon_sym_RBRACE,
    STATE(40), 1,
      sym__separator,
    STATE(7353), 1,
      aux_sym_block_repeat1,
    ACTIONS(11666), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341781] = 5,
    ACTIONS(9911), 1,
      anon_sym_COMMA,
    ACTIONS(9915), 1,
      anon_sym_RPAREN,
    ACTIONS(12408), 1,
      anon_sym_EQ,
    STATE(8169), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341799] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12410), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341815] = 5,
    ACTIONS(11550), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(4153), 1,
      aux_sym_struct_type_repeat2,
    STATE(7450), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341833] = 5,
    ACTIONS(7655), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(3681), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341851] = 5,
    ACTIONS(12412), 1,
      anon_sym_DQUOTE,
    ACTIONS(12416), 1,
      sym_comment,
    STATE(7431), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12414), 2,
      sym_string_content,
      sym_escape_sequence,
  [341869] = 5,
    ACTIONS(11573), 1,
      anon_sym_COMMA,
    ACTIONS(11704), 1,
      anon_sym_COLON,
    ACTIONS(11706), 1,
      anon_sym_RPAREN,
    STATE(7588), 1,
      aux_sym_parameter_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341887] = 5,
    ACTIONS(9741), 1,
      anon_sym_COMMA,
    ACTIONS(9745), 1,
      anon_sym_RPAREN,
    ACTIONS(12418), 1,
      anon_sym_EQ,
    STATE(8293), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341905] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12420), 1,
      anon_sym_DQUOTE,
    STATE(7409), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12422), 2,
      sym_string_content,
      sym_escape_sequence,
  [341923] = 5,
    ACTIONS(9761), 1,
      anon_sym_COMMA,
    ACTIONS(9765), 1,
      anon_sym_RPAREN,
    ACTIONS(12424), 1,
      anon_sym_EQ,
    STATE(7850), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341941] = 4,
    ACTIONS(9727), 1,
      anon_sym_COMMA,
    STATE(7564), 1,
      aux_sym__simple_assignment_statement_repeat1,
    ACTIONS(9903), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341957] = 5,
    ACTIONS(12426), 1,
      anon_sym_RBRACE,
    ACTIONS(12428), 1,
      anon_sym_COMMA,
    ACTIONS(12430), 1,
      anon_sym_EQ,
    STATE(8314), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341975] = 5,
    ACTIONS(7993), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(4096), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [341993] = 5,
    ACTIONS(9755), 1,
      anon_sym_COMMA,
    ACTIONS(9759), 1,
      anon_sym_RPAREN,
    ACTIONS(12432), 1,
      anon_sym_EQ,
    STATE(8125), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342011] = 5,
    ACTIONS(7655), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(3681), 1,
      aux_sym_struct_type_repeat2,
    STATE(7495), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342029] = 5,
    ACTIONS(11550), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(4153), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342047] = 5,
    ACTIONS(9877), 1,
      anon_sym_COMMA,
    ACTIONS(9881), 1,
      anon_sym_RPAREN,
    ACTIONS(12434), 1,
      anon_sym_EQ,
    STATE(7741), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342065] = 5,
    ACTIONS(6358), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(2092), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342083] = 5,
    ACTIONS(12436), 1,
      anon_sym_RBRACE,
    ACTIONS(12438), 1,
      anon_sym_COMMA,
    ACTIONS(12440), 1,
      anon_sym_EQ,
    STATE(7801), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342101] = 4,
    ACTIONS(1587), 1,
      ts_builtin_sym_end,
    STATE(5913), 1,
      sym__separator,
    ACTIONS(12442), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342117] = 5,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(11760), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342135] = 5,
    ACTIONS(12444), 1,
      anon_sym_RBRACE,
    ACTIONS(12446), 1,
      anon_sym_COMMA,
    ACTIONS(12448), 1,
      anon_sym_EQ,
    STATE(8166), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342153] = 5,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(11760), 1,
      anon_sym_LBRACE,
    STATE(3144), 1,
      aux_sym_struct_type_repeat2,
    STATE(7408), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342171] = 5,
    ACTIONS(9767), 1,
      anon_sym_COMMA,
    ACTIONS(9867), 1,
      anon_sym_RPAREN,
    ACTIONS(12450), 1,
      anon_sym_EQ,
    STATE(7858), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342189] = 5,
    ACTIONS(7659), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(3605), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342207] = 5,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(11760), 1,
      anon_sym_LBRACE,
    STATE(3146), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342225] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12452), 1,
      anon_sym_DQUOTE,
    STATE(7508), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12454), 2,
      sym_string_content,
      sym_escape_sequence,
  [342243] = 5,
    ACTIONS(9749), 1,
      anon_sym_COMMA,
    ACTIONS(9819), 1,
      anon_sym_RPAREN,
    ACTIONS(12456), 1,
      anon_sym_EQ,
    STATE(7867), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342261] = 5,
    ACTIONS(11573), 1,
      anon_sym_COMMA,
    ACTIONS(11704), 1,
      anon_sym_COLON,
    ACTIONS(11706), 1,
      anon_sym_RPAREN,
    STATE(7498), 1,
      aux_sym_parameter_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342279] = 5,
    ACTIONS(12458), 1,
      anon_sym_RBRACE,
    ACTIONS(12460), 1,
      anon_sym_COMMA,
    ACTIONS(12462), 1,
      anon_sym_EQ,
    STATE(7765), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342297] = 5,
    ACTIONS(7993), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(4085), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342315] = 5,
    ACTIONS(7993), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(4085), 1,
      aux_sym_struct_type_repeat2,
    STATE(7395), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342333] = 5,
    ACTIONS(9827), 1,
      anon_sym_COMMA,
    ACTIONS(9831), 1,
      anon_sym_RPAREN,
    ACTIONS(12464), 1,
      anon_sym_EQ,
    STATE(8243), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342351] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(6579), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [342363] = 5,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(12020), 1,
      anon_sym_LBRACE,
    STATE(2951), 1,
      aux_sym_struct_type_repeat2,
    STATE(7444), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342381] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12466), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342397] = 5,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(12020), 1,
      anon_sym_LBRACE,
    STATE(2951), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342415] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12468), 1,
      anon_sym_DQUOTE,
    STATE(7508), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12454), 2,
      sym_string_content,
      sym_escape_sequence,
  [342433] = 5,
    ACTIONS(7659), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(3577), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342451] = 5,
    ACTIONS(12470), 1,
      anon_sym_RBRACE,
    ACTIONS(12472), 1,
      anon_sym_COMMA,
    ACTIONS(12474), 1,
      anon_sym_EQ,
    STATE(7835), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342469] = 5,
    ACTIONS(11550), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(6868), 1,
      aux_sym_struct_type_repeat2,
    STATE(7469), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342487] = 5,
    ACTIONS(9767), 1,
      anon_sym_COMMA,
    ACTIONS(12450), 1,
      anon_sym_EQ,
    ACTIONS(12476), 1,
      anon_sym_RPAREN,
    STATE(7852), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342505] = 5,
    ACTIONS(11550), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(6868), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342523] = 5,
    ACTIONS(6715), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(2558), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342541] = 5,
    ACTIONS(7659), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(3577), 1,
      aux_sym_struct_type_repeat2,
    STATE(7407), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342559] = 5,
    ACTIONS(9741), 1,
      anon_sym_COMMA,
    ACTIONS(9745), 1,
      anon_sym_RPAREN,
    ACTIONS(12418), 1,
      anon_sym_EQ,
    STATE(8293), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342577] = 5,
    ACTIONS(7655), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(3494), 1,
      aux_sym_struct_type_repeat2,
    STATE(7434), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342595] = 5,
    ACTIONS(9767), 1,
      anon_sym_COMMA,
    ACTIONS(9867), 1,
      anon_sym_RPAREN,
    ACTIONS(12450), 1,
      anon_sym_EQ,
    STATE(8021), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342613] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12478), 1,
      anon_sym_DQUOTE,
    STATE(7508), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12454), 2,
      sym_string_content,
      sym_escape_sequence,
  [342631] = 5,
    ACTIONS(9777), 1,
      anon_sym_COMMA,
    ACTIONS(9781), 1,
      anon_sym_RPAREN,
    ACTIONS(12480), 1,
      anon_sym_EQ,
    STATE(8375), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342649] = 5,
    ACTIONS(11573), 1,
      anon_sym_COMMA,
    ACTIONS(11579), 1,
      anon_sym_RPAREN,
    ACTIONS(12482), 1,
      anon_sym_COLON,
    STATE(7580), 1,
      aux_sym_parameter_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342667] = 5,
    ACTIONS(7655), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(3565), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342685] = 4,
    ACTIONS(12484), 1,
      anon_sym_RBRACE,
    ACTIONS(12486), 1,
      anon_sym_case,
    STATE(7488), 2,
      sym_switch_case,
      aux_sym_switch_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342701] = 5,
    ACTIONS(7655), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(3494), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342719] = 5,
    ACTIONS(12488), 1,
      anon_sym_RBRACE,
    ACTIONS(12490), 1,
      anon_sym_COMMA,
    ACTIONS(12492), 1,
      anon_sym_EQ,
    STATE(8258), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342737] = 5,
    ACTIONS(9749), 1,
      anon_sym_COMMA,
    ACTIONS(12456), 1,
      anon_sym_EQ,
    ACTIONS(12494), 1,
      anon_sym_RPAREN,
    STATE(8226), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342755] = 4,
    ACTIONS(9727), 1,
      anon_sym_COMMA,
    STATE(7564), 1,
      aux_sym__simple_assignment_statement_repeat1,
    ACTIONS(12496), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342771] = 5,
    ACTIONS(9905), 1,
      anon_sym_COMMA,
    ACTIONS(9909), 1,
      anon_sym_RPAREN,
    ACTIONS(12498), 1,
      anon_sym_EQ,
    STATE(7976), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342789] = 5,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(12500), 1,
      anon_sym_do,
    ACTIONS(12502), 1,
      anon_sym_when,
    STATE(7175), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342807] = 4,
    ACTIONS(9747), 1,
      anon_sym_COMMA,
    STATE(7481), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(8786), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342823] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12504), 1,
      anon_sym_DQUOTE,
    STATE(7516), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12506), 2,
      sym_string_content,
      sym_escape_sequence,
  [342841] = 5,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(12020), 1,
      anon_sym_LBRACE,
    STATE(2936), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342859] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12508), 1,
      anon_sym_DQUOTE,
    STATE(7448), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12510), 2,
      sym_string_content,
      sym_escape_sequence,
  [342877] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12512), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342893] = 5,
    ACTIONS(12514), 1,
      anon_sym_RBRACE,
    ACTIONS(12516), 1,
      anon_sym_COMMA,
    ACTIONS(12518), 1,
      anon_sym_EQ,
    STATE(8367), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342911] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12520), 1,
      anon_sym_DQUOTE,
    STATE(7508), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12454), 2,
      sym_string_content,
      sym_escape_sequence,
  [342929] = 5,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(11814), 1,
      anon_sym_LBRACE,
    STATE(2122), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342947] = 5,
    ACTIONS(11550), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(4164), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342965] = 5,
    ACTIONS(12522), 1,
      anon_sym_RBRACE,
    ACTIONS(12524), 1,
      anon_sym_COMMA,
    ACTIONS(12526), 1,
      anon_sym_EQ,
    STATE(8212), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [342983] = 5,
    ACTIONS(12528), 1,
      anon_sym_RBRACE,
    ACTIONS(12530), 1,
      anon_sym_COMMA,
    ACTIONS(12532), 1,
      anon_sym_EQ,
    STATE(8257), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343001] = 4,
    ACTIONS(12536), 1,
      sym_tag,
    STATE(7453), 1,
      aux_sym_struct_declaration_repeat1,
    ACTIONS(12534), 2,
      anon_sym_LBRACE,
      anon_sym_where,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343017] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12539), 1,
      anon_sym_DQUOTE,
    STATE(7420), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12541), 2,
      sym_string_content,
      sym_escape_sequence,
  [343035] = 5,
    ACTIONS(11573), 1,
      anon_sym_COMMA,
    ACTIONS(11804), 1,
      anon_sym_COLON,
    ACTIONS(11806), 1,
      anon_sym_RPAREN,
    STATE(7586), 1,
      aux_sym_parameter_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343053] = 5,
    ACTIONS(10219), 1,
      anon_sym_RBRACE,
    ACTIONS(10221), 1,
      anon_sym_COMMA,
    ACTIONS(12543), 1,
      anon_sym_EQ,
    STATE(7872), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343071] = 5,
    ACTIONS(9891), 1,
      anon_sym_COMMA,
    ACTIONS(9895), 1,
      anon_sym_RPAREN,
    ACTIONS(12545), 1,
      anon_sym_EQ,
    STATE(7999), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343089] = 5,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(12502), 1,
      anon_sym_when,
    ACTIONS(12547), 1,
      anon_sym_do,
    STATE(7175), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343107] = 4,
    ACTIONS(9747), 1,
      anon_sym_COMMA,
    STATE(7481), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(11565), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343123] = 5,
    ACTIONS(12549), 1,
      anon_sym_RBRACE,
    ACTIONS(12551), 1,
      anon_sym_COMMA,
    ACTIONS(12553), 1,
      anon_sym_EQ,
    STATE(7766), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343141] = 5,
    ACTIONS(11607), 1,
      anon_sym_DOT,
    ACTIONS(12555), 1,
      anon_sym_LBRACE,
    ACTIONS(12557), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343159] = 5,
    ACTIONS(9871), 1,
      anon_sym_COMMA,
    ACTIONS(9875), 1,
      anon_sym_RPAREN,
    ACTIONS(12559), 1,
      anon_sym_EQ,
    STATE(7812), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343177] = 5,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(11814), 1,
      anon_sym_LBRACE,
    STATE(2124), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343195] = 5,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(11814), 1,
      anon_sym_LBRACE,
    STATE(2124), 1,
      aux_sym_struct_type_repeat2,
    STATE(7449), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343213] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12561), 1,
      anon_sym_DQUOTE,
    STATE(7548), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12563), 2,
      sym_string_content,
      sym_escape_sequence,
  [343231] = 4,
    ACTIONS(12486), 1,
      anon_sym_case,
    ACTIONS(12565), 1,
      anon_sym_RBRACE,
    STATE(7575), 2,
      sym_switch_case,
      aux_sym_switch_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343247] = 5,
    ACTIONS(12567), 1,
      anon_sym_RBRACE,
    ACTIONS(12569), 1,
      anon_sym_COMMA,
    ACTIONS(12571), 1,
      anon_sym_EQ,
    STATE(7884), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343265] = 5,
    ACTIONS(9755), 1,
      anon_sym_COMMA,
    ACTIONS(9759), 1,
      anon_sym_RPAREN,
    ACTIONS(12432), 1,
      anon_sym_EQ,
    STATE(7712), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343283] = 5,
    ACTIONS(11550), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(6898), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343301] = 5,
    ACTIONS(4645), 1,
      anon_sym_import,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(12573), 1,
      sym_identifier,
    STATE(7026), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343319] = 5,
    ACTIONS(12575), 1,
      anon_sym_RBRACE,
    ACTIONS(12577), 1,
      anon_sym_COMMA,
    ACTIONS(12579), 1,
      anon_sym_EQ,
    STATE(8183), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343337] = 5,
    ACTIONS(11603), 1,
      anon_sym_COMMA,
    ACTIONS(12581), 1,
      anon_sym_EQ,
    ACTIONS(12583), 1,
      anon_sym_RPAREN,
    STATE(8291), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343355] = 5,
    ACTIONS(9885), 1,
      anon_sym_COMMA,
    ACTIONS(9889), 1,
      anon_sym_RPAREN,
    ACTIONS(12585), 1,
      anon_sym_EQ,
    STATE(8016), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343373] = 5,
    ACTIONS(9735), 1,
      anon_sym_COMMA,
    ACTIONS(9739), 1,
      anon_sym_RPAREN,
    ACTIONS(12587), 1,
      anon_sym_EQ,
    STATE(8275), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343391] = 5,
    ACTIONS(11607), 1,
      anon_sym_DOT,
    ACTIONS(12589), 1,
      anon_sym_LBRACE,
    ACTIONS(12591), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343409] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12593), 1,
      anon_sym_DQUOTE,
    STATE(7508), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12454), 2,
      sym_string_content,
      sym_escape_sequence,
  [343427] = 5,
    ACTIONS(9897), 1,
      anon_sym_COMMA,
    ACTIONS(9901), 1,
      anon_sym_RPAREN,
    ACTIONS(12595), 1,
      anon_sym_EQ,
    STATE(7920), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343445] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12597), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343461] = 4,
    ACTIONS(12599), 1,
      ts_builtin_sym_end,
    STATE(5913), 1,
      sym__separator,
    ACTIONS(12442), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343477] = 5,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(12547), 1,
      anon_sym_do,
    ACTIONS(12601), 1,
      anon_sym_if,
    STATE(7175), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343495] = 4,
    ACTIONS(12603), 1,
      anon_sym_COMMA,
    STATE(7481), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(7640), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343511] = 4,
    ACTIONS(11607), 1,
      anon_sym_DOT,
    STATE(7593), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(12606), 2,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343527] = 5,
    ACTIONS(9795), 1,
      anon_sym_COMMA,
    ACTIONS(9799), 1,
      anon_sym_RPAREN,
    ACTIONS(12608), 1,
      anon_sym_EQ,
    STATE(8199), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343545] = 4,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    STATE(6927), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(12610), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343561] = 5,
    ACTIONS(6715), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(2553), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343579] = 5,
    ACTIONS(6715), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(2553), 1,
      aux_sym_struct_type_repeat2,
    STATE(7426), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343597] = 5,
    ACTIONS(9785), 1,
      anon_sym_COMMA,
    ACTIONS(9789), 1,
      anon_sym_RPAREN,
    ACTIONS(12612), 1,
      anon_sym_EQ,
    STATE(7810), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343615] = 4,
    ACTIONS(12486), 1,
      anon_sym_case,
    ACTIONS(12614), 1,
      anon_sym_RBRACE,
    STATE(7575), 2,
      sym_switch_case,
      aux_sym_switch_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343631] = 5,
    ACTIONS(9755), 1,
      anon_sym_COMMA,
    ACTIONS(12432), 1,
      anon_sym_EQ,
    ACTIONS(12616), 1,
      anon_sym_RPAREN,
    STATE(7723), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343649] = 5,
    ACTIONS(9821), 1,
      anon_sym_COMMA,
    ACTIONS(9825), 1,
      anon_sym_RPAREN,
    ACTIONS(12618), 1,
      anon_sym_EQ,
    STATE(8025), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343667] = 5,
    ACTIONS(12620), 1,
      anon_sym_RBRACE,
    ACTIONS(12622), 1,
      anon_sym_COMMA,
    ACTIONS(12624), 1,
      anon_sym_EQ,
    STATE(8338), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343685] = 5,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(11899), 1,
      anon_sym_LBRACE,
    STATE(675), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343703] = 4,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    STATE(6927), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(9775), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343719] = 5,
    ACTIONS(12116), 1,
      sym_identifier,
    ACTIONS(12120), 1,
      anon_sym_using,
    ACTIONS(12626), 1,
      anon_sym_RBRACE,
    STATE(8497), 1,
      sym_struct_member,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343737] = 5,
    ACTIONS(7655), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(3704), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343755] = 5,
    ACTIONS(9857), 1,
      anon_sym_COMMA,
    ACTIONS(9883), 1,
      anon_sym_RPAREN,
    ACTIONS(12628), 1,
      anon_sym_EQ,
    STATE(7827), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343773] = 5,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(12630), 1,
      anon_sym_LBRACE,
    ACTIONS(12632), 1,
      sym_tag,
    STATE(8595), 1,
      sym_polymorphic_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343791] = 5,
    ACTIONS(11573), 1,
      anon_sym_COMMA,
    ACTIONS(11804), 1,
      anon_sym_COLON,
    ACTIONS(11806), 1,
      anon_sym_RPAREN,
    STATE(7588), 1,
      aux_sym_parameter_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343809] = 4,
    ACTIONS(12486), 1,
      anon_sym_case,
    ACTIONS(12634), 1,
      anon_sym_RBRACE,
    STATE(7575), 2,
      sym_switch_case,
      aux_sym_switch_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343825] = 5,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(11899), 1,
      anon_sym_LBRACE,
    STATE(671), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343843] = 5,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(11899), 1,
      anon_sym_LBRACE,
    STATE(671), 1,
      aux_sym_struct_type_repeat2,
    STATE(7492), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343861] = 5,
    ACTIONS(9857), 1,
      anon_sym_COMMA,
    ACTIONS(9883), 1,
      anon_sym_RPAREN,
    ACTIONS(12628), 1,
      anon_sym_EQ,
    STATE(7658), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343879] = 5,
    ACTIONS(12636), 1,
      anon_sym_RBRACE,
    ACTIONS(12638), 1,
      anon_sym_COMMA,
    ACTIONS(12640), 1,
      anon_sym_EQ,
    STATE(7803), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343897] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12642), 1,
      anon_sym_DQUOTE,
    STATE(7476), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12644), 2,
      sym_string_content,
      sym_escape_sequence,
  [343915] = 5,
    ACTIONS(9735), 1,
      anon_sym_COMMA,
    ACTIONS(9739), 1,
      anon_sym_RPAREN,
    ACTIONS(12587), 1,
      anon_sym_EQ,
    STATE(8165), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343933] = 5,
    ACTIONS(10055), 1,
      anon_sym_RBRACE,
    ACTIONS(10057), 1,
      anon_sym_COMMA,
    ACTIONS(12646), 1,
      anon_sym_EQ,
    STATE(7878), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343951] = 5,
    ACTIONS(12648), 1,
      anon_sym_RBRACE,
    ACTIONS(12650), 1,
      anon_sym_COMMA,
    ACTIONS(12652), 1,
      anon_sym_EQ,
    STATE(8013), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [343969] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12654), 1,
      anon_sym_DQUOTE,
    STATE(7508), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12656), 2,
      sym_string_content,
      sym_escape_sequence,
  [343987] = 5,
    ACTIONS(12122), 1,
      sym_identifier,
    ACTIONS(12126), 1,
      anon_sym_using,
    ACTIONS(12128), 1,
      sym_tag,
    STATE(8612), 1,
      sym_field,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344005] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12659), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [344017] = 5,
    ACTIONS(6715), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(2682), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344035] = 4,
    ACTIONS(12486), 1,
      anon_sym_case,
    ACTIONS(12661), 1,
      anon_sym_RBRACE,
    STATE(7499), 2,
      sym_switch_case,
      aux_sym_switch_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344051] = 5,
    ACTIONS(9735), 1,
      anon_sym_COMMA,
    ACTIONS(12587), 1,
      anon_sym_EQ,
    ACTIONS(12663), 1,
      anon_sym_RPAREN,
    STATE(8267), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344069] = 5,
    ACTIONS(9749), 1,
      anon_sym_COMMA,
    ACTIONS(9819), 1,
      anon_sym_RPAREN,
    ACTIONS(12456), 1,
      anon_sym_EQ,
    STATE(7867), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344087] = 5,
    ACTIONS(12116), 1,
      sym_identifier,
    ACTIONS(12120), 1,
      anon_sym_using,
    ACTIONS(12665), 1,
      anon_sym_RBRACE,
    STATE(8497), 1,
      sym_struct_member,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344105] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12667), 1,
      anon_sym_DQUOTE,
    STATE(7508), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12454), 2,
      sym_string_content,
      sym_escape_sequence,
  [344123] = 4,
    ACTIONS(12486), 1,
      anon_sym_case,
    ACTIONS(12669), 1,
      anon_sym_RBRACE,
    STATE(7575), 2,
      sym_switch_case,
      aux_sym_switch_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344139] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12671), 1,
      anon_sym_DQUOTE,
    STATE(7508), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12454), 2,
      sym_string_content,
      sym_escape_sequence,
  [344157] = 4,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    STATE(6927), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(9617), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344173] = 4,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    STATE(6927), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(12673), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344189] = 5,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    ACTIONS(11497), 1,
      anon_sym_LPAREN,
    ACTIONS(11607), 1,
      anon_sym_DOT,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344207] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12675), 1,
      anon_sym_DQUOTE,
    STATE(7508), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12454), 2,
      sym_string_content,
      sym_escape_sequence,
  [344225] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12677), 1,
      anon_sym_DQUOTE,
    STATE(7524), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12679), 2,
      sym_string_content,
      sym_escape_sequence,
  [344243] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12681), 1,
      anon_sym_DQUOTE,
    STATE(7508), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12454), 2,
      sym_string_content,
      sym_escape_sequence,
  [344261] = 5,
    ACTIONS(9735), 1,
      anon_sym_COMMA,
    ACTIONS(9739), 1,
      anon_sym_RPAREN,
    ACTIONS(12587), 1,
      anon_sym_EQ,
    STATE(8165), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344279] = 5,
    ACTIONS(9807), 1,
      anon_sym_COMMA,
    ACTIONS(9811), 1,
      anon_sym_RPAREN,
    ACTIONS(12683), 1,
      anon_sym_EQ,
    STATE(8221), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344297] = 5,
    ACTIONS(9741), 1,
      anon_sym_COMMA,
    ACTIONS(9745), 1,
      anon_sym_RPAREN,
    ACTIONS(12418), 1,
      anon_sym_EQ,
    STATE(8038), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344315] = 5,
    ACTIONS(11607), 1,
      anon_sym_DOT,
    ACTIONS(12685), 1,
      anon_sym_LBRACE,
    ACTIONS(12687), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344333] = 5,
    ACTIONS(6715), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(2718), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344351] = 5,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(11968), 1,
      anon_sym_LBRACE,
    STATE(3373), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344369] = 5,
    ACTIONS(6715), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(2718), 1,
      aux_sym_struct_type_repeat2,
    STATE(7511), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344387] = 5,
    ACTIONS(9729), 1,
      anon_sym_COMMA,
    ACTIONS(9733), 1,
      anon_sym_RPAREN,
    ACTIONS(12689), 1,
      anon_sym_EQ,
    STATE(7937), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344405] = 4,
    ACTIONS(12486), 1,
      anon_sym_case,
    ACTIONS(12691), 1,
      anon_sym_RBRACE,
    STATE(7575), 2,
      sym_switch_case,
      aux_sym_switch_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344421] = 5,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(11968), 1,
      anon_sym_LBRACE,
    STATE(3373), 1,
      aux_sym_struct_type_repeat2,
    STATE(7549), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344439] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12693), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344455] = 4,
    ACTIONS(12486), 1,
      anon_sym_case,
    ACTIONS(12695), 1,
      anon_sym_RBRACE,
    STATE(7539), 2,
      sym_switch_case,
      aux_sym_switch_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344471] = 5,
    ACTIONS(12697), 1,
      anon_sym_RBRACE,
    ACTIONS(12699), 1,
      anon_sym_COMMA,
    ACTIONS(12701), 1,
      anon_sym_EQ,
    STATE(8153), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344489] = 5,
    ACTIONS(7659), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(3578), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344507] = 4,
    ACTIONS(12486), 1,
      anon_sym_case,
    ACTIONS(12703), 1,
      anon_sym_RBRACE,
    STATE(7575), 2,
      sym_switch_case,
      aux_sym_switch_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344523] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12705), 1,
      anon_sym_DQUOTE,
    STATE(7559), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12707), 2,
      sym_string_content,
      sym_escape_sequence,
  [344541] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12709), 1,
      anon_sym_DQUOTE,
    STATE(7518), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12711), 2,
      sym_string_content,
      sym_escape_sequence,
  [344559] = 5,
    ACTIONS(6358), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(2084), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344577] = 5,
    ACTIONS(11607), 1,
      anon_sym_DOT,
    ACTIONS(12713), 1,
      anon_sym_LBRACE,
    ACTIONS(12715), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344595] = 5,
    ACTIONS(9851), 1,
      anon_sym_COMMA,
    ACTIONS(9855), 1,
      anon_sym_RPAREN,
    ACTIONS(12717), 1,
      anon_sym_EQ,
    STATE(8017), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344613] = 5,
    ACTIONS(6358), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(2084), 1,
      aux_sym_struct_type_repeat2,
    STATE(7400), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344631] = 4,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    STATE(6927), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(9298), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344647] = 5,
    ACTIONS(9741), 1,
      anon_sym_COMMA,
    ACTIONS(12418), 1,
      anon_sym_EQ,
    ACTIONS(12719), 1,
      anon_sym_RPAREN,
    STATE(8129), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344665] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12721), 1,
      anon_sym_DQUOTE,
    STATE(7508), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12454), 2,
      sym_string_content,
      sym_escape_sequence,
  [344683] = 5,
    ACTIONS(11660), 1,
      sym_tag,
    ACTIONS(11968), 1,
      anon_sym_LBRACE,
    STATE(3381), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344701] = 5,
    ACTIONS(9837), 1,
      anon_sym_COMMA,
    ACTIONS(9841), 1,
      anon_sym_RPAREN,
    ACTIONS(12723), 1,
      anon_sym_EQ,
    STATE(8118), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344719] = 5,
    ACTIONS(11591), 1,
      anon_sym_LPAREN,
    ACTIONS(12725), 1,
      anon_sym_LBRACE,
    ACTIONS(12727), 1,
      sym_tag,
    STATE(8500), 1,
      sym_polymorphic_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344737] = 5,
    ACTIONS(12729), 1,
      anon_sym_RBRACE,
    ACTIONS(12731), 1,
      anon_sym_COMMA,
    ACTIONS(12733), 1,
      anon_sym_EQ,
    STATE(7758), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344755] = 5,
    ACTIONS(9857), 1,
      anon_sym_COMMA,
    ACTIONS(9883), 1,
      anon_sym_RPAREN,
    ACTIONS(12628), 1,
      anon_sym_EQ,
    STATE(7827), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344773] = 5,
    ACTIONS(12735), 1,
      anon_sym_RBRACE,
    ACTIONS(12737), 1,
      anon_sym_COMMA,
    ACTIONS(12739), 1,
      anon_sym_EQ,
    STATE(7990), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344791] = 5,
    ACTIONS(6358), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(1845), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344809] = 5,
    ACTIONS(9857), 1,
      anon_sym_COMMA,
    ACTIONS(12628), 1,
      anon_sym_EQ,
    ACTIONS(12741), 1,
      anon_sym_RPAREN,
    STATE(7657), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344827] = 5,
    ACTIONS(9801), 1,
      anon_sym_COMMA,
    ACTIONS(9805), 1,
      anon_sym_RPAREN,
    ACTIONS(12743), 1,
      anon_sym_EQ,
    STATE(7764), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344845] = 5,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(12745), 1,
      sym_identifier,
    ACTIONS(12747), 1,
      anon_sym_import,
    STATE(6944), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344863] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12749), 1,
      anon_sym_DQUOTE,
    STATE(7508), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12454), 2,
      sym_string_content,
      sym_escape_sequence,
  [344881] = 5,
    ACTIONS(12751), 1,
      anon_sym_RBRACE,
    ACTIONS(12753), 1,
      anon_sym_COMMA,
    ACTIONS(12755), 1,
      anon_sym_EQ,
    STATE(8079), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344899] = 5,
    ACTIONS(7993), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(3975), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344917] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(11931), 4,
      sym__newline,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_case,
  [344929] = 5,
    ACTIONS(9719), 1,
      anon_sym_COMMA,
    ACTIONS(9723), 1,
      anon_sym_RPAREN,
    ACTIONS(12757), 1,
      anon_sym_EQ,
    STATE(8121), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344947] = 4,
    ACTIONS(12759), 1,
      anon_sym_COMMA,
    STATE(7564), 1,
      aux_sym__simple_assignment_statement_repeat1,
    ACTIONS(10353), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344963] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12762), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344979] = 5,
    ACTIONS(11573), 1,
      anon_sym_COMMA,
    ACTIONS(11599), 1,
      anon_sym_RPAREN,
    ACTIONS(12038), 1,
      anon_sym_COLON,
    STATE(7389), 1,
      aux_sym_parameter_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [344997] = 5,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(9847), 1,
      anon_sym_RPAREN,
    ACTIONS(12764), 1,
      anon_sym_EQ,
    STATE(7775), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345015] = 5,
    ACTIONS(9767), 1,
      anon_sym_COMMA,
    ACTIONS(9867), 1,
      anon_sym_RPAREN,
    ACTIONS(12450), 1,
      anon_sym_EQ,
    STATE(8021), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345033] = 5,
    ACTIONS(9749), 1,
      anon_sym_COMMA,
    ACTIONS(9819), 1,
      anon_sym_RPAREN,
    ACTIONS(12456), 1,
      anon_sym_EQ,
    STATE(8223), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345051] = 4,
    ACTIONS(9727), 1,
      anon_sym_COMMA,
    STATE(7564), 1,
      aux_sym__simple_assignment_statement_repeat1,
    ACTIONS(9813), 2,
      anon_sym_LBRACE,
      anon_sym_do,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345067] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12766), 1,
      anon_sym_DQUOTE,
    STATE(7522), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12768), 2,
      sym_string_content,
      sym_escape_sequence,
  [345085] = 5,
    ACTIONS(6358), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(1858), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345103] = 4,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    STATE(6927), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(9835), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345119] = 4,
    ACTIONS(12486), 1,
      anon_sym_case,
    ACTIONS(12770), 1,
      anon_sym_RBRACE,
    STATE(7466), 2,
      sym_switch_case,
      aux_sym_switch_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345135] = 4,
    ACTIONS(12772), 1,
      anon_sym_RBRACE,
    ACTIONS(12774), 1,
      anon_sym_case,
    STATE(7575), 2,
      sym_switch_case,
      aux_sym_switch_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345151] = 5,
    ACTIONS(6358), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(1858), 1,
      aux_sym_struct_type_repeat2,
    STATE(7555), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345169] = 4,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    STATE(6927), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(12777), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345185] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12779), 1,
      anon_sym_DQUOTE,
    STATE(7582), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12781), 2,
      sym_string_content,
      sym_escape_sequence,
  [345203] = 5,
    ACTIONS(11607), 1,
      anon_sym_DOT,
    ACTIONS(12783), 1,
      anon_sym_LBRACE,
    ACTIONS(12785), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345221] = 5,
    ACTIONS(11573), 1,
      anon_sym_COMMA,
    ACTIONS(11599), 1,
      anon_sym_RPAREN,
    ACTIONS(12038), 1,
      anon_sym_COLON,
    STATE(7588), 1,
      aux_sym_parameter_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345239] = 5,
    ACTIONS(7659), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(3569), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345257] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12787), 1,
      anon_sym_DQUOTE,
    STATE(7508), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12454), 2,
      sym_string_content,
      sym_escape_sequence,
  [345275] = 5,
    ACTIONS(11607), 1,
      anon_sym_DOT,
    ACTIONS(12789), 1,
      anon_sym_LBRACE,
    ACTIONS(12791), 1,
      anon_sym_LPAREN,
    STATE(7482), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345293] = 5,
    ACTIONS(7993), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(4004), 1,
      aux_sym_struct_type_repeat2,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345311] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12793), 1,
      anon_sym_DQUOTE,
    STATE(7508), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12454), 2,
      sym_string_content,
      sym_escape_sequence,
  [345329] = 5,
    ACTIONS(10490), 1,
      anon_sym_RPAREN,
    ACTIONS(11573), 1,
      anon_sym_COMMA,
    ACTIONS(12795), 1,
      anon_sym_COLON,
    STATE(7588), 1,
      aux_sym_parameter_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345347] = 5,
    ACTIONS(7659), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(3569), 1,
      aux_sym_struct_type_repeat2,
    STATE(7538), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345365] = 4,
    ACTIONS(12797), 1,
      anon_sym_COMMA,
    STATE(7588), 1,
      aux_sym_parameter_repeat1,
    ACTIONS(12108), 2,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345381] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12800), 1,
      anon_sym_DQUOTE,
    STATE(7585), 1,
      aux_sym__string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
    ACTIONS(12802), 2,
      sym_string_content,
      sym_escape_sequence,
  [345399] = 4,
    ACTIONS(12486), 1,
      anon_sym_case,
    ACTIONS(12804), 1,
      anon_sym_RBRACE,
    STATE(7575), 2,
      sym_switch_case,
      aux_sym_switch_statement_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345415] = 5,
    ACTIONS(7993), 1,
      anon_sym_LBRACE,
    ACTIONS(11660), 1,
      sym_tag,
    STATE(4004), 1,
      aux_sym_struct_type_repeat2,
    STATE(7561), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345433] = 5,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(12500), 1,
      anon_sym_do,
    ACTIONS(12601), 1,
      anon_sym_if,
    STATE(7175), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345451] = 4,
    ACTIONS(12808), 1,
      anon_sym_DOT,
    STATE(7593), 1,
      aux_sym_field_identifier_repeat1,
    ACTIONS(12806), 2,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345467] = 4,
    ACTIONS(11788), 1,
      anon_sym_COMMA,
    ACTIONS(11790), 1,
      anon_sym_RPAREN,
    STATE(8379), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345482] = 4,
    ACTIONS(5744), 1,
      anon_sym_RBRACE,
    ACTIONS(12811), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345497] = 4,
    ACTIONS(12813), 1,
      anon_sym_COMMA,
    ACTIONS(12815), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345512] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12817), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345527] = 4,
    ACTIONS(12148), 1,
      anon_sym_RBRACE,
    ACTIONS(12819), 1,
      anon_sym_COMMA,
    STATE(7718), 1,
      aux_sym_struct_declaration_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345542] = 4,
    ACTIONS(5662), 1,
      anon_sym_RBRACE,
    ACTIONS(12821), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345557] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(12825), 1,
      anon_sym_RPAREN,
    STATE(7800), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345572] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(12827), 1,
      anon_sym_RPAREN,
    STATE(7600), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345587] = 4,
    ACTIONS(12829), 1,
      anon_sym_RBRACE,
    ACTIONS(12831), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345602] = 4,
    ACTIONS(5230), 1,
      anon_sym_RBRACE,
    ACTIONS(12833), 1,
      anon_sym_COMMA,
    STATE(7627), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345617] = 4,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(12835), 1,
      anon_sym_RBRACE,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345632] = 4,
    ACTIONS(5230), 1,
      anon_sym_RBRACE,
    ACTIONS(12833), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345647] = 4,
    ACTIONS(9927), 1,
      anon_sym_COMMA,
    ACTIONS(9929), 1,
      anon_sym_COLON,
    STATE(8383), 1,
      aux_sym_switch_case_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345662] = 4,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(12837), 1,
      anon_sym_RBRACE,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345677] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12839), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345692] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12841), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345707] = 4,
    ACTIONS(12843), 1,
      anon_sym_RBRACE,
    ACTIONS(12845), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345722] = 4,
    ACTIONS(5996), 1,
      anon_sym_RBRACE,
    ACTIONS(12847), 1,
      anon_sym_COMMA,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345737] = 4,
    ACTIONS(12148), 1,
      anon_sym_RBRACE,
    ACTIONS(12819), 1,
      anon_sym_COMMA,
    STATE(8010), 1,
      aux_sym_struct_declaration_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345752] = 4,
    ACTIONS(5998), 1,
      anon_sym_RBRACE,
    ACTIONS(12849), 1,
      anon_sym_COMMA,
    STATE(8055), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345767] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345782] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12853), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345797] = 4,
    ACTIONS(12855), 1,
      anon_sym_COMMA,
    ACTIONS(12857), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345812] = 4,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(12859), 1,
      anon_sym_do,
    STATE(7151), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345827] = 4,
    ACTIONS(5662), 1,
      anon_sym_RBRACE,
    ACTIONS(12821), 1,
      anon_sym_COMMA,
    STATE(7631), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345842] = 4,
    ACTIONS(12861), 1,
      anon_sym_RBRACE,
    ACTIONS(12863), 1,
      anon_sym_COMMA,
    STATE(7613), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345857] = 4,
    ACTIONS(5520), 1,
      anon_sym_RBRACE,
    ACTIONS(12865), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345872] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12867), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345887] = 4,
    ACTIONS(8858), 1,
      anon_sym_RBRACE,
    ACTIONS(12869), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345902] = 4,
    ACTIONS(12871), 1,
      anon_sym_COMMA,
    ACTIONS(12873), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345917] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12875), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345932] = 4,
    ACTIONS(4802), 1,
      anon_sym_LBRACE,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345947] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12877), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345962] = 4,
    ACTIONS(5228), 1,
      anon_sym_RBRACE,
    ACTIONS(12879), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345977] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12881), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [345992] = 4,
    ACTIONS(5508), 1,
      anon_sym_RBRACE,
    ACTIONS(12883), 1,
      anon_sym_COMMA,
    STATE(7620), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346007] = 4,
    ACTIONS(12885), 1,
      anon_sym_COMMA,
    ACTIONS(12887), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346022] = 4,
    ACTIONS(5648), 1,
      anon_sym_RBRACE,
    ACTIONS(12889), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346037] = 4,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(12891), 1,
      anon_sym_do,
    STATE(7181), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346052] = 4,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(12893), 1,
      anon_sym_RBRACE,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346067] = 4,
    ACTIONS(12895), 1,
      anon_sym_RBRACE,
    ACTIONS(12897), 1,
      anon_sym_COMMA,
    STATE(7637), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346082] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(8197), 1,
      anon_sym_LBRACE,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346097] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12899), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346112] = 4,
    ACTIONS(5956), 1,
      anon_sym_RBRACE,
    ACTIONS(12901), 1,
      anon_sym_COMMA,
    STATE(8055), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346127] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(12903), 1,
      anon_sym_RPAREN,
    STATE(7800), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346142] = 4,
    ACTIONS(5960), 1,
      anon_sym_RBRACE,
    ACTIONS(12905), 1,
      anon_sym_COMMA,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346157] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12907), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346172] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12909), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346187] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(12911), 1,
      anon_sym_RPAREN,
    STATE(7638), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346202] = 4,
    ACTIONS(12913), 1,
      anon_sym_RBRACE,
    ACTIONS(12915), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346217] = 4,
    ACTIONS(12917), 1,
      anon_sym_RBRACE,
    ACTIONS(12919), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346232] = 4,
    ACTIONS(12921), 1,
      anon_sym_RBRACE,
    ACTIONS(12923), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346247] = 4,
    ACTIONS(5574), 1,
      anon_sym_RBRACE,
    ACTIONS(12925), 1,
      anon_sym_COMMA,
    STATE(7688), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346262] = 4,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(12927), 1,
      anon_sym_RBRACE,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346277] = 4,
    ACTIONS(5508), 1,
      anon_sym_RBRACE,
    ACTIONS(12883), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346292] = 4,
    ACTIONS(7661), 1,
      anon_sym_LBRACE,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346307] = 3,
    ACTIONS(11952), 1,
      anon_sym_EQ,
    ACTIONS(10444), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346320] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12929), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346335] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12931), 1,
      anon_sym_BQUOTE,
    ACTIONS(12933), 1,
      sym__raw_string_content,
    STATE(7673), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [346352] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12935), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346367] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12937), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346382] = 4,
    ACTIONS(5794), 1,
      anon_sym_RBRACE,
    ACTIONS(12939), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346397] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12941), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346412] = 4,
    ACTIONS(12943), 1,
      anon_sym_COMMA,
    ACTIONS(12945), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346427] = 4,
    ACTIONS(12947), 1,
      anon_sym_COMMA,
    ACTIONS(12949), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346442] = 4,
    ACTIONS(6573), 1,
      anon_sym_LBRACE,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346457] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12951), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346472] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12953), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346487] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12955), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346502] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12957), 1,
      anon_sym_BQUOTE,
    ACTIONS(12959), 1,
      sym__raw_string_content,
    STATE(8308), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [346519] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12961), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346534] = 4,
    ACTIONS(4806), 1,
      anon_sym_RBRACE,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346549] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12965), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346564] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12967), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346579] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12969), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346594] = 4,
    ACTIONS(6590), 1,
      anon_sym_LBRACE,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346609] = 4,
    ACTIONS(12971), 1,
      anon_sym_COMMA,
    ACTIONS(12973), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346624] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12975), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346639] = 4,
    ACTIONS(12977), 1,
      anon_sym_COMMA,
    ACTIONS(12979), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346654] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12959), 1,
      sym__raw_string_content,
    ACTIONS(12981), 1,
      anon_sym_BQUOTE,
    STATE(8308), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [346671] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12983), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346686] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12985), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346701] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12987), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346716] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12989), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346731] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12991), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346746] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12993), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346761] = 4,
    ACTIONS(5228), 1,
      anon_sym_RBRACE,
    ACTIONS(12879), 1,
      anon_sym_COMMA,
    STATE(7683), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346776] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(12995), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346791] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(12997), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346806] = 4,
    ACTIONS(5220), 1,
      anon_sym_RBRACE,
    ACTIONS(12999), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346821] = 4,
    ACTIONS(13001), 1,
      anon_sym_COMMA,
    ACTIONS(13003), 1,
      anon_sym_COLON,
    STATE(8280), 1,
      aux_sym_polymorphic_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346836] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13005), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346851] = 4,
    ACTIONS(13007), 1,
      anon_sym_RBRACE,
    ACTIONS(13009), 1,
      anon_sym_COMMA,
    STATE(7687), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346866] = 4,
    ACTIONS(6069), 1,
      anon_sym_RBRACE,
    ACTIONS(13011), 1,
      anon_sym_COMMA,
    STATE(8055), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346881] = 4,
    ACTIONS(5584), 1,
      anon_sym_RBRACE,
    ACTIONS(13013), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346896] = 4,
    ACTIONS(5442), 1,
      anon_sym_RBRACE,
    ACTIONS(13015), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346911] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13017), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346926] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13019), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346941] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13021), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346956] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13023), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346971] = 4,
    ACTIONS(5442), 1,
      anon_sym_RBRACE,
    ACTIONS(13015), 1,
      anon_sym_COMMA,
    STATE(7648), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [346986] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13025), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347001] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13027), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347016] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13029), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347031] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347046] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13033), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347061] = 4,
    ACTIONS(11829), 1,
      anon_sym_COMMA,
    ACTIONS(11831), 1,
      anon_sym_RPAREN,
    STATE(7760), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347076] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(13035), 1,
      anon_sym_BQUOTE,
    ACTIONS(13037), 1,
      sym__raw_string_content,
    STATE(7719), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [347093] = 4,
    ACTIONS(13001), 1,
      anon_sym_COMMA,
    ACTIONS(13003), 1,
      anon_sym_COLON,
    STATE(7989), 1,
      aux_sym_polymorphic_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347108] = 4,
    ACTIONS(5620), 1,
      anon_sym_RBRACE,
    ACTIONS(13039), 1,
      anon_sym_COMMA,
    STATE(7733), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347123] = 4,
    ACTIONS(12250), 1,
      anon_sym_COMMA,
    ACTIONS(13041), 1,
      anon_sym_RPAREN,
    STATE(8340), 1,
      aux_sym_polymorphic_parameters_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347138] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(8203), 1,
      anon_sym_LBRACE,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347153] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13043), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347168] = 4,
    ACTIONS(6071), 1,
      anon_sym_RBRACE,
    ACTIONS(13045), 1,
      anon_sym_COMMA,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347183] = 4,
    ACTIONS(13047), 1,
      anon_sym_RBRACE,
    ACTIONS(13049), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347198] = 4,
    ACTIONS(5584), 1,
      anon_sym_RBRACE,
    ACTIONS(13013), 1,
      anon_sym_COMMA,
    STATE(7808), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347213] = 4,
    ACTIONS(4776), 1,
      anon_sym_RBRACE,
    ACTIONS(13051), 1,
      anon_sym_COMMA,
    STATE(7665), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347228] = 4,
    ACTIONS(13053), 1,
      anon_sym_COMMA,
    ACTIONS(13055), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347243] = 4,
    ACTIONS(13057), 1,
      anon_sym_COMMA,
    ACTIONS(13059), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347258] = 4,
    ACTIONS(5664), 1,
      anon_sym_RBRACE,
    ACTIONS(13061), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347273] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(13063), 3,
      anon_sym_LBRACE,
      anon_sym_where,
      sym_tag,
  [347284] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13065), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347299] = 4,
    ACTIONS(7340), 1,
      anon_sym_LBRACE,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347314] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(13067), 1,
      anon_sym_RPAREN,
    STATE(7800), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347329] = 4,
    ACTIONS(13069), 1,
      anon_sym_RBRACE,
    ACTIONS(13071), 1,
      anon_sym_COMMA,
    STATE(7718), 1,
      aux_sym_struct_declaration_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347344] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12959), 1,
      sym__raw_string_content,
    ACTIONS(13074), 1,
      anon_sym_BQUOTE,
    STATE(8308), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [347361] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13076), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347376] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13078), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347391] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(13080), 1,
      anon_sym_RPAREN,
    STATE(7717), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347406] = 4,
    ACTIONS(13082), 1,
      anon_sym_COMMA,
    ACTIONS(13084), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347421] = 4,
    ACTIONS(13086), 1,
      anon_sym_COMMA,
    ACTIONS(13088), 1,
      anon_sym_RPAREN,
    STATE(7818), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347436] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12534), 3,
      anon_sym_LBRACE,
      anon_sym_where,
      sym_tag,
  [347447] = 4,
    ACTIONS(12382), 1,
      anon_sym_RBRACE,
    ACTIONS(13090), 1,
      anon_sym_COMMA,
    STATE(7776), 1,
      aux_sym_struct_declaration_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347462] = 4,
    ACTIONS(13092), 1,
      anon_sym_COMMA,
    ACTIONS(13095), 1,
      anon_sym_COLON,
    STATE(7727), 1,
      aux_sym_field_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347477] = 4,
    ACTIONS(5664), 1,
      anon_sym_RBRACE,
    ACTIONS(13061), 1,
      anon_sym_COMMA,
    STATE(7599), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347492] = 4,
    ACTIONS(13097), 1,
      anon_sym_COMMA,
    ACTIONS(13099), 1,
      anon_sym_COLON,
    STATE(7781), 1,
      aux_sym_field_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347507] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13101), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347522] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(13103), 1,
      anon_sym_BQUOTE,
    ACTIONS(13105), 1,
      sym__raw_string_content,
    STATE(7982), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [347539] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(13107), 1,
      anon_sym_BQUOTE,
    ACTIONS(13109), 1,
      sym__raw_string_content,
    STATE(7663), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [347556] = 4,
    ACTIONS(5614), 1,
      anon_sym_RBRACE,
    ACTIONS(13111), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347571] = 4,
    ACTIONS(11750), 1,
      anon_sym_RBRACE,
    ACTIONS(13113), 1,
      anon_sym_COMMA,
    STATE(8012), 1,
      aux_sym_import_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347586] = 4,
    ACTIONS(8968), 1,
      anon_sym_RBRACE,
    ACTIONS(12206), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347601] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(13115), 1,
      anon_sym_BQUOTE,
    ACTIONS(13117), 1,
      sym__raw_string_content,
    STATE(7770), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [347618] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13119), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347633] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13121), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347648] = 4,
    ACTIONS(13123), 1,
      anon_sym_COMMA,
    ACTIONS(13125), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347663] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13127), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347678] = 4,
    ACTIONS(13129), 1,
      anon_sym_COMMA,
    ACTIONS(13131), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347693] = 4,
    ACTIONS(11680), 1,
      anon_sym_COMMA,
    ACTIONS(11682), 1,
      anon_sym_RPAREN,
    STATE(7768), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347708] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(13133), 1,
      anon_sym_RPAREN,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347723] = 4,
    ACTIONS(13135), 1,
      anon_sym_COMMA,
    ACTIONS(13137), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347738] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13139), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347753] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13141), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347768] = 4,
    ACTIONS(5614), 1,
      anon_sym_RBRACE,
    ACTIONS(13111), 1,
      anon_sym_COMMA,
    STATE(7779), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347783] = 4,
    ACTIONS(13143), 1,
      anon_sym_RBRACE,
    ACTIONS(13145), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347798] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13147), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347813] = 4,
    ACTIONS(5186), 1,
      anon_sym_RBRACE,
    ACTIONS(13149), 1,
      anon_sym_COMMA,
    STATE(7791), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347828] = 4,
    ACTIONS(11603), 1,
      anon_sym_COMMA,
    ACTIONS(13151), 1,
      anon_sym_RPAREN,
    STATE(7988), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347843] = 4,
    ACTIONS(8952), 1,
      anon_sym_RBRACE,
    ACTIONS(13153), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347858] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(13155), 1,
      anon_sym_RPAREN,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347873] = 4,
    ACTIONS(13097), 1,
      anon_sym_COMMA,
    ACTIONS(13157), 1,
      anon_sym_COLON,
    STATE(8161), 1,
      aux_sym_field_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347888] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(8450), 3,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [347899] = 4,
    ACTIONS(13097), 1,
      anon_sym_COMMA,
    ACTIONS(13157), 1,
      anon_sym_COLON,
    STATE(7727), 1,
      aux_sym_field_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347914] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13159), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347929] = 4,
    ACTIONS(13161), 1,
      anon_sym_RBRACE,
    ACTIONS(13163), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347944] = 4,
    ACTIONS(9054), 1,
      anon_sym_RBRACE,
    ACTIONS(13165), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347959] = 4,
    ACTIONS(8708), 1,
      anon_sym_RPAREN,
    ACTIONS(13167), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347974] = 4,
    ACTIONS(13169), 1,
      anon_sym_COMMA,
    ACTIONS(13171), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [347989] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13173), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348004] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13175), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348019] = 4,
    ACTIONS(13177), 1,
      anon_sym_COMMA,
    ACTIONS(13179), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348034] = 4,
    ACTIONS(13181), 1,
      anon_sym_RBRACE,
    ACTIONS(13183), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348049] = 4,
    ACTIONS(12488), 1,
      anon_sym_RBRACE,
    ACTIONS(12490), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348064] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13185), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348079] = 4,
    ACTIONS(8680), 1,
      anon_sym_RPAREN,
    ACTIONS(13187), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348094] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13189), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348109] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12959), 1,
      sym__raw_string_content,
    ACTIONS(13191), 1,
      anon_sym_BQUOTE,
    STATE(8308), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [348126] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13193), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348141] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13195), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348156] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12322), 1,
      anon_sym_RPAREN,
    STATE(7936), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348171] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(13197), 1,
      anon_sym_RPAREN,
    STATE(8132), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348186] = 4,
    ACTIONS(13199), 1,
      anon_sym_COMMA,
    ACTIONS(13201), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348201] = 4,
    ACTIONS(12124), 1,
      anon_sym_RBRACE,
    ACTIONS(13203), 1,
      anon_sym_COMMA,
    STATE(7718), 1,
      aux_sym_struct_declaration_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348216] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13205), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348231] = 4,
    ACTIONS(13207), 1,
      anon_sym_COMMA,
    ACTIONS(13209), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348246] = 4,
    ACTIONS(5594), 1,
      anon_sym_RBRACE,
    ACTIONS(13211), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348261] = 4,
    ACTIONS(5362), 1,
      anon_sym_RBRACE,
    ACTIONS(13213), 1,
      anon_sym_COMMA,
    STATE(7689), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348276] = 4,
    ACTIONS(13097), 1,
      anon_sym_COMMA,
    ACTIONS(13215), 1,
      anon_sym_COLON,
    STATE(7727), 1,
      aux_sym_field_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348291] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(13217), 1,
      anon_sym_RPAREN,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348306] = 4,
    ACTIONS(8814), 1,
      anon_sym_RBRACE,
    ACTIONS(13219), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348321] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12346), 1,
      anon_sym_RPAREN,
    STATE(7753), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348336] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12386), 1,
      anon_sym_RPAREN,
    STATE(7843), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348351] = 4,
    ACTIONS(5196), 1,
      anon_sym_RBRACE,
    ACTIONS(13221), 1,
      anon_sym_COMMA,
    STATE(8027), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348366] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(13223), 3,
      sym__newline,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [348377] = 4,
    ACTIONS(13225), 1,
      anon_sym_RBRACE,
    ACTIONS(13227), 1,
      anon_sym_COMMA,
    STATE(7959), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348392] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13229), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348407] = 4,
    ACTIONS(5578), 1,
      anon_sym_RBRACE,
    ACTIONS(13231), 1,
      anon_sym_COMMA,
    STATE(7823), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348422] = 4,
    ACTIONS(5184), 1,
      anon_sym_RBRACE,
    ACTIONS(13233), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348437] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13235), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348452] = 4,
    ACTIONS(13237), 1,
      anon_sym_COMMA,
    ACTIONS(13239), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348467] = 4,
    ACTIONS(12064), 1,
      anon_sym_COMMA,
    ACTIONS(12066), 1,
      anon_sym_RPAREN,
    STATE(7986), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348482] = 4,
    ACTIONS(11186), 1,
      anon_sym_RPAREN,
    ACTIONS(13241), 1,
      anon_sym_COMMA,
    STATE(7965), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348497] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(13243), 1,
      anon_sym_RPAREN,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348512] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13245), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348527] = 4,
    ACTIONS(13247), 1,
      anon_sym_RBRACE,
    ACTIONS(13249), 1,
      anon_sym_COMMA,
    STATE(7911), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348542] = 4,
    ACTIONS(11956), 1,
      anon_sym_RBRACE,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
    STATE(8170), 1,
      aux_sym_import_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348557] = 4,
    ACTIONS(13253), 1,
      anon_sym_COMMA,
    ACTIONS(13256), 1,
      anon_sym_RPAREN,
    STATE(7800), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348572] = 4,
    ACTIONS(13258), 1,
      anon_sym_RBRACE,
    ACTIONS(13260), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348587] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(13262), 1,
      anon_sym_RPAREN,
    STATE(7800), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348602] = 4,
    ACTIONS(13264), 1,
      anon_sym_RBRACE,
    ACTIONS(13266), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348617] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13268), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348632] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13270), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348647] = 4,
    ACTIONS(8854), 1,
      anon_sym_RBRACE,
    ACTIONS(13272), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348662] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13274), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348677] = 4,
    ACTIONS(5604), 1,
      anon_sym_RBRACE,
    ACTIONS(13276), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348692] = 4,
    ACTIONS(13278), 1,
      anon_sym_COMMA,
    ACTIONS(13280), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348707] = 4,
    ACTIONS(13282), 1,
      anon_sym_COMMA,
    ACTIONS(13284), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348722] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(13286), 1,
      anon_sym_RPAREN,
    STATE(7802), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348737] = 4,
    ACTIONS(13288), 1,
      anon_sym_COMMA,
    ACTIONS(13290), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348752] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13292), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348767] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13294), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348782] = 4,
    ACTIONS(13296), 1,
      anon_sym_COMMA,
    ACTIONS(13298), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348797] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13300), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348812] = 4,
    ACTIONS(13302), 1,
      anon_sym_COMMA,
    ACTIONS(13305), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348827] = 4,
    ACTIONS(11182), 1,
      anon_sym_RPAREN,
    ACTIONS(13307), 1,
      anon_sym_COMMA,
    STATE(7965), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348842] = 4,
    ACTIONS(13309), 1,
      anon_sym_COMMA,
    ACTIONS(13311), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348857] = 4,
    ACTIONS(8954), 1,
      anon_sym_RBRACE,
    ACTIONS(12110), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348872] = 4,
    ACTIONS(5564), 1,
      anon_sym_RBRACE,
    ACTIONS(13313), 1,
      anon_sym_COMMA,
    STATE(7848), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348887] = 4,
    ACTIONS(5290), 1,
      anon_sym_RBRACE,
    ACTIONS(13315), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348902] = 4,
    ACTIONS(5564), 1,
      anon_sym_RBRACE,
    ACTIONS(13313), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348917] = 4,
    ACTIONS(5632), 1,
      anon_sym_RBRACE,
    ACTIONS(13317), 1,
      anon_sym_COMMA,
    STATE(7863), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348932] = 3,
    ACTIONS(13319), 1,
      anon_sym_EQ,
    ACTIONS(10153), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348945] = 4,
    ACTIONS(13321), 1,
      anon_sym_COMMA,
    ACTIONS(13323), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348960] = 4,
    ACTIONS(13325), 1,
      anon_sym_COMMA,
    ACTIONS(13327), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348975] = 4,
    ACTIONS(5684), 1,
      anon_sym_RBRACE,
    ACTIONS(13329), 1,
      anon_sym_COMMA,
    STATE(7713), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [348990] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13331), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349005] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(13333), 1,
      anon_sym_RPAREN,
    STATE(7834), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349020] = 4,
    ACTIONS(12050), 1,
      anon_sym_COMMA,
    ACTIONS(12052), 1,
      anon_sym_RPAREN,
    STATE(7910), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349035] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(13335), 1,
      anon_sym_RPAREN,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349050] = 4,
    ACTIONS(13337), 1,
      anon_sym_COMMA,
    ACTIONS(13339), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349065] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(13341), 1,
      anon_sym_RPAREN,
    STATE(7800), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349080] = 4,
    ACTIONS(13343), 1,
      anon_sym_RBRACE,
    ACTIONS(13345), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349095] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13347), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349110] = 4,
    ACTIONS(8902), 1,
      anon_sym_RBRACE,
    ACTIONS(13349), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349125] = 4,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(13351), 1,
      anon_sym_do,
    STATE(7142), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349140] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13353), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349155] = 4,
    ACTIONS(5248), 1,
      anon_sym_RBRACE,
    ACTIONS(13355), 1,
      anon_sym_COMMA,
    STATE(7605), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349170] = 4,
    ACTIONS(13357), 1,
      anon_sym_COMMA,
    ACTIONS(13359), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349185] = 4,
    ACTIONS(12130), 1,
      anon_sym_RBRACE,
    ACTIONS(13361), 1,
      anon_sym_COMMA,
    STATE(8209), 1,
      aux_sym_struct_declaration_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349200] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(13363), 1,
      anon_sym_RPAREN,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349215] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13365), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349230] = 4,
    ACTIONS(12130), 1,
      anon_sym_RBRACE,
    ACTIONS(13361), 1,
      anon_sym_COMMA,
    STATE(7718), 1,
      aux_sym_struct_declaration_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349245] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13367), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349260] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13369), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349275] = 4,
    ACTIONS(5562), 1,
      anon_sym_RBRACE,
    ACTIONS(13371), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349290] = 4,
    ACTIONS(8666), 1,
      anon_sym_RPAREN,
    ACTIONS(13373), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349305] = 4,
    ACTIONS(13375), 1,
      anon_sym_COMMA,
    ACTIONS(13377), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349320] = 4,
    ACTIONS(13379), 1,
      anon_sym_COMMA,
    ACTIONS(13381), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349335] = 4,
    ACTIONS(13383), 1,
      anon_sym_COMMA,
    ACTIONS(13385), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349350] = 4,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(13387), 1,
      anon_sym_RBRACE,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349365] = 4,
    ACTIONS(13389), 1,
      anon_sym_COMMA,
    ACTIONS(13391), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349380] = 4,
    ACTIONS(12512), 1,
      anon_sym_RPAREN,
    ACTIONS(13393), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349395] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13396), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349410] = 4,
    ACTIONS(13398), 1,
      anon_sym_RBRACE,
    ACTIONS(13400), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349425] = 4,
    ACTIONS(13402), 1,
      anon_sym_COMMA,
    ACTIONS(13404), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349440] = 4,
    ACTIONS(13406), 1,
      anon_sym_COMMA,
    ACTIONS(13408), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349455] = 4,
    ACTIONS(8956), 1,
      anon_sym_SEMI,
    ACTIONS(13410), 1,
      anon_sym_COMMA,
    STATE(7860), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349470] = 4,
    ACTIONS(5686), 1,
      anon_sym_RBRACE,
    ACTIONS(13413), 1,
      anon_sym_COMMA,
    STATE(7882), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349485] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13415), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349500] = 4,
    ACTIONS(5686), 1,
      anon_sym_RBRACE,
    ACTIONS(13413), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349515] = 4,
    ACTIONS(5982), 1,
      anon_sym_RBRACE,
    ACTIONS(13417), 1,
      anon_sym_COMMA,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349530] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(7794), 1,
      anon_sym_LBRACE,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349545] = 4,
    ACTIONS(8778), 1,
      anon_sym_SEMI,
    ACTIONS(9997), 1,
      anon_sym_COMMA,
    STATE(8238), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349560] = 4,
    ACTIONS(13419), 1,
      anon_sym_COMMA,
    ACTIONS(13421), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349575] = 4,
    ACTIONS(13423), 1,
      anon_sym_COMMA,
    ACTIONS(13425), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349590] = 4,
    ACTIONS(13427), 1,
      anon_sym_COMMA,
    ACTIONS(13429), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349605] = 4,
    ACTIONS(5562), 1,
      anon_sym_RBRACE,
    ACTIONS(13371), 1,
      anon_sym_COMMA,
    STATE(7890), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349620] = 4,
    ACTIONS(13431), 1,
      anon_sym_COMMA,
    ACTIONS(13433), 1,
      anon_sym_RPAREN,
    STATE(7795), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349635] = 4,
    ACTIONS(10261), 1,
      anon_sym_RBRACE,
    ACTIONS(10263), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349650] = 4,
    ACTIONS(13435), 1,
      sym_identifier,
    ACTIONS(13437), 1,
      anon_sym_using,
    ACTIONS(13439), 1,
      sym_tag,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349665] = 4,
    ACTIONS(5794), 1,
      anon_sym_RBRACE,
    ACTIONS(12939), 1,
      anon_sym_COMMA,
    STATE(8123), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349680] = 4,
    ACTIONS(9074), 1,
      anon_sym_RBRACE,
    ACTIONS(13441), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349695] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13443), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349710] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13445), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349725] = 4,
    ACTIONS(10219), 1,
      anon_sym_RBRACE,
    ACTIONS(10221), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349740] = 4,
    ACTIONS(4806), 1,
      anon_sym_RBRACE,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    STATE(8043), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349755] = 4,
    ACTIONS(10185), 1,
      anon_sym_RBRACE,
    ACTIONS(10187), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349770] = 4,
    ACTIONS(11972), 1,
      anon_sym_RBRACE,
    ACTIONS(13447), 1,
      anon_sym_COMMA,
    STATE(8012), 1,
      aux_sym_import_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349785] = 4,
    ACTIONS(5778), 1,
      anon_sym_RBRACE,
    ACTIONS(13449), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349800] = 4,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(13451), 1,
      anon_sym_RBRACE,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349815] = 4,
    ACTIONS(13453), 1,
      anon_sym_RBRACE,
    ACTIONS(13455), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349830] = 4,
    ACTIONS(5282), 1,
      anon_sym_RBRACE,
    ACTIONS(13457), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349845] = 4,
    ACTIONS(5184), 1,
      anon_sym_RBRACE,
    ACTIONS(13233), 1,
      anon_sym_COMMA,
    STATE(7944), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349860] = 4,
    ACTIONS(13097), 1,
      anon_sym_COMMA,
    ACTIONS(13215), 1,
      anon_sym_COLON,
    STATE(7756), 1,
      aux_sym_field_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349875] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13459), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349890] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13461), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349905] = 4,
    ACTIONS(5548), 1,
      anon_sym_RBRACE,
    ACTIONS(13463), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349920] = 4,
    ACTIONS(13465), 1,
      anon_sym_RBRACE,
    ACTIONS(13467), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349935] = 3,
    ACTIONS(11778), 1,
      anon_sym_EQ,
    ACTIONS(10401), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349948] = 4,
    ACTIONS(5240), 1,
      anon_sym_RBRACE,
    ACTIONS(13469), 1,
      anon_sym_COMMA,
    STATE(7822), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349963] = 4,
    ACTIONS(13001), 1,
      anon_sym_COMMA,
    ACTIONS(13471), 1,
      anon_sym_COLON,
    STATE(8280), 1,
      aux_sym_polymorphic_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349978] = 4,
    ACTIONS(13473), 1,
      anon_sym_RBRACE,
    ACTIONS(13475), 1,
      anon_sym_COMMA,
    STATE(7898), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [349993] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13477), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350008] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13479), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350023] = 4,
    ACTIONS(5986), 1,
      anon_sym_RBRACE,
    ACTIONS(13481), 1,
      anon_sym_COMMA,
    STATE(8055), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350038] = 4,
    ACTIONS(6081), 1,
      anon_sym_RBRACE,
    ACTIONS(10129), 1,
      anon_sym_COMMA,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350053] = 4,
    ACTIONS(13001), 1,
      anon_sym_COMMA,
    ACTIONS(13471), 1,
      anon_sym_COLON,
    STATE(8124), 1,
      aux_sym_polymorphic_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350068] = 4,
    ACTIONS(12626), 1,
      anon_sym_RBRACE,
    ACTIONS(13483), 1,
      anon_sym_COMMA,
    STATE(8120), 1,
      aux_sym__struct_members_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350083] = 4,
    ACTIONS(13485), 1,
      anon_sym_COMMA,
    ACTIONS(13487), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350098] = 4,
    ACTIONS(5480), 1,
      anon_sym_RBRACE,
    ACTIONS(13489), 1,
      anon_sym_COMMA,
    STATE(8283), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350113] = 4,
    ACTIONS(5778), 1,
      anon_sym_RBRACE,
    ACTIONS(13449), 1,
      anon_sym_COMMA,
    STATE(7908), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350128] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(13491), 1,
      anon_sym_RPAREN,
    STATE(7916), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350143] = 4,
    ACTIONS(13493), 1,
      anon_sym_COMMA,
    ACTIONS(13495), 1,
      anon_sym_COLON,
    STATE(8089), 1,
      aux_sym_struct_member_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350158] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13497), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350173] = 4,
    ACTIONS(5818), 1,
      anon_sym_RBRACE,
    ACTIONS(13499), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350188] = 4,
    ACTIONS(5988), 1,
      anon_sym_RBRACE,
    ACTIONS(13501), 1,
      anon_sym_COMMA,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350203] = 4,
    ACTIONS(8732), 1,
      anon_sym_RPAREN,
    ACTIONS(13503), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350218] = 4,
    ACTIONS(5914), 1,
      anon_sym_RBRACE,
    ACTIONS(13505), 1,
      anon_sym_COMMA,
    STATE(8055), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350233] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13507), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350248] = 4,
    ACTIONS(13493), 1,
      anon_sym_COMMA,
    ACTIONS(13495), 1,
      anon_sym_COLON,
    STATE(8058), 1,
      aux_sym_struct_member_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350263] = 4,
    ACTIONS(13509), 1,
      anon_sym_COMMA,
    ACTIONS(13511), 1,
      anon_sym_RPAREN,
    STATE(8116), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350278] = 4,
    ACTIONS(5912), 1,
      anon_sym_RBRACE,
    ACTIONS(13513), 1,
      anon_sym_COMMA,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350293] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(13515), 1,
      anon_sym_RPAREN,
    STATE(7800), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350308] = 3,
    ACTIONS(12042), 1,
      anon_sym_EQ,
    ACTIONS(10490), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350321] = 4,
    ACTIONS(11808), 1,
      anon_sym_COMMA,
    ACTIONS(11810), 1,
      anon_sym_RPAREN,
    STATE(7849), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350336] = 4,
    ACTIONS(13517), 1,
      anon_sym_RBRACE,
    ACTIONS(13519), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350351] = 4,
    ACTIONS(13521), 1,
      anon_sym_COMMA,
    ACTIONS(13523), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350366] = 4,
    ACTIONS(13525), 1,
      anon_sym_COMMA,
    ACTIONS(13527), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350381] = 4,
    ACTIONS(13529), 1,
      anon_sym_RBRACE,
    ACTIONS(13531), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350396] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13533), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350411] = 4,
    ACTIONS(13535), 1,
      anon_sym_COMMA,
    ACTIONS(13537), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350426] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(13539), 1,
      anon_sym_BQUOTE,
    ACTIONS(13541), 1,
      sym__raw_string_content,
    STATE(7940), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [350443] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13543), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350458] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13545), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350473] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13547), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350488] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(13549), 1,
      anon_sym_BQUOTE,
    ACTIONS(13551), 1,
      sym__raw_string_content,
    STATE(7934), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [350505] = 4,
    ACTIONS(5860), 1,
      anon_sym_RBRACE,
    ACTIONS(13553), 1,
      anon_sym_COMMA,
    STATE(7938), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350520] = 4,
    ACTIONS(4908), 1,
      anon_sym_RBRACE,
    ACTIONS(13555), 1,
      anon_sym_COMMA,
    STATE(8034), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350535] = 4,
    ACTIONS(5518), 1,
      anon_sym_RBRACE,
    ACTIONS(13557), 1,
      anon_sym_COMMA,
    STATE(7947), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350550] = 4,
    ACTIONS(5716), 1,
      anon_sym_RBRACE,
    ACTIONS(13559), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350565] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12959), 1,
      sym__raw_string_content,
    ACTIONS(13561), 1,
      anon_sym_BQUOTE,
    STATE(8308), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [350582] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13563), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350597] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(13565), 1,
      anon_sym_RPAREN,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350612] = 4,
    ACTIONS(13567), 1,
      anon_sym_COMMA,
    ACTIONS(13569), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350627] = 4,
    ACTIONS(5870), 1,
      anon_sym_RBRACE,
    ACTIONS(13571), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350642] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13573), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350657] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12959), 1,
      sym__raw_string_content,
    ACTIONS(13575), 1,
      anon_sym_BQUOTE,
    STATE(8308), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [350674] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13577), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350689] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13579), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350704] = 4,
    ACTIONS(7332), 1,
      anon_sym_LBRACE,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350719] = 4,
    ACTIONS(5166), 1,
      anon_sym_RBRACE,
    ACTIONS(13581), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350734] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12246), 1,
      anon_sym_RPAREN,
    STATE(7782), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350749] = 4,
    ACTIONS(13583), 1,
      anon_sym_COMMA,
    ACTIONS(13585), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350764] = 4,
    ACTIONS(5516), 1,
      anon_sym_RBRACE,
    ACTIONS(13587), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350779] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12108), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [350790] = 4,
    ACTIONS(5796), 1,
      anon_sym_RBRACE,
    ACTIONS(13589), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350805] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13591), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350820] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13593), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350835] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13595), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350850] = 4,
    ACTIONS(5240), 1,
      anon_sym_RBRACE,
    ACTIONS(13469), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350865] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13597), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350880] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(11581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350895] = 4,
    ACTIONS(11849), 1,
      anon_sym_COMMA,
    ACTIONS(11851), 1,
      anon_sym_RPAREN,
    STATE(7981), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350910] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13599), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350925] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13601), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350940] = 4,
    ACTIONS(6067), 1,
      anon_sym_RBRACE,
    ACTIONS(13603), 1,
      anon_sym_COMMA,
    STATE(8055), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350955] = 4,
    ACTIONS(5796), 1,
      anon_sym_RBRACE,
    ACTIONS(13589), 1,
      anon_sym_COMMA,
    STATE(7655), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [350970] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12959), 1,
      sym__raw_string_content,
    ACTIONS(13605), 1,
      anon_sym_BQUOTE,
    STATE(8308), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [350987] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13607), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351002] = 4,
    ACTIONS(12082), 1,
      anon_sym_COMMA,
    ACTIONS(12084), 1,
      anon_sym_RPAREN,
    STATE(8022), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351017] = 4,
    ACTIONS(5144), 1,
      anon_sym_RBRACE,
    ACTIONS(13609), 1,
      anon_sym_COMMA,
    STATE(8051), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351032] = 4,
    ACTIONS(13611), 1,
      anon_sym_COMMA,
    ACTIONS(13614), 1,
      anon_sym_RPAREN,
    STATE(7965), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351047] = 4,
    ACTIONS(11130), 1,
      anon_sym_RPAREN,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
    STATE(7965), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351062] = 4,
    ACTIONS(5516), 1,
      anon_sym_RBRACE,
    ACTIONS(13587), 1,
      anon_sym_COMMA,
    STATE(8001), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351077] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13618), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351092] = 4,
    ACTIONS(6073), 1,
      anon_sym_RBRACE,
    ACTIONS(13620), 1,
      anon_sym_COMMA,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351107] = 4,
    ACTIONS(5238), 1,
      anon_sym_RBRACE,
    ACTIONS(13622), 1,
      anon_sym_COMMA,
    STATE(7953), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351122] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13624), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351137] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13626), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351152] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(13628), 1,
      anon_sym_BQUOTE,
    ACTIONS(13630), 1,
      sym__raw_string_content,
    STATE(7961), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [351169] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13632), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351184] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(8456), 1,
      anon_sym_LBRACE,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351199] = 4,
    ACTIONS(13634), 1,
      anon_sym_COMMA,
    ACTIONS(13636), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351214] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13638), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351229] = 4,
    ACTIONS(8698), 1,
      anon_sym_RPAREN,
    ACTIONS(13640), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351244] = 4,
    ACTIONS(8778), 1,
      anon_sym_SEMI,
    ACTIONS(9997), 1,
      anon_sym_COMMA,
    STATE(7860), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351259] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(13642), 3,
      anon_sym_LBRACE,
      anon_sym_where,
      sym_tag,
  [351270] = 4,
    ACTIONS(8676), 1,
      anon_sym_RPAREN,
    ACTIONS(13644), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351285] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12959), 1,
      sym__raw_string_content,
    ACTIONS(13646), 1,
      anon_sym_BQUOTE,
    STATE(8308), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [351302] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13648), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351317] = 4,
    ACTIONS(5870), 1,
      anon_sym_RBRACE,
    ACTIONS(13571), 1,
      anon_sym_COMMA,
    STATE(8046), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351332] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13650), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351347] = 4,
    ACTIONS(8652), 1,
      anon_sym_RPAREN,
    ACTIONS(13652), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351362] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13654), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351377] = 4,
    ACTIONS(13656), 1,
      anon_sym_COMMA,
    ACTIONS(13659), 1,
      anon_sym_RPAREN,
    STATE(7988), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351392] = 4,
    ACTIONS(13001), 1,
      anon_sym_COMMA,
    ACTIONS(13661), 1,
      anon_sym_COLON,
    STATE(8280), 1,
      aux_sym_polymorphic_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351407] = 4,
    ACTIONS(13663), 1,
      anon_sym_RBRACE,
    ACTIONS(13665), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351422] = 4,
    ACTIONS(9014), 1,
      anon_sym_RBRACE,
    ACTIONS(13667), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351437] = 4,
    ACTIONS(13669), 1,
      anon_sym_COMMA,
    ACTIONS(13671), 1,
      anon_sym_RPAREN,
    STATE(8054), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351452] = 4,
    ACTIONS(13673), 1,
      anon_sym_COMMA,
    ACTIONS(13675), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351467] = 4,
    ACTIONS(11603), 1,
      anon_sym_COMMA,
    ACTIONS(11605), 1,
      anon_sym_RPAREN,
    STATE(7751), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351482] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12240), 1,
      anon_sym_RPAREN,
    STATE(8015), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351497] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13677), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351512] = 4,
    ACTIONS(13679), 1,
      anon_sym_RBRACE,
    ACTIONS(13681), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351527] = 4,
    ACTIONS(13683), 1,
      anon_sym_RBRACE,
    ACTIONS(13685), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351542] = 4,
    ACTIONS(13687), 1,
      anon_sym_COMMA,
    ACTIONS(13689), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351557] = 4,
    ACTIONS(13691), 1,
      anon_sym_COMMA,
    ACTIONS(13693), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351572] = 4,
    ACTIONS(5506), 1,
      anon_sym_RBRACE,
    ACTIONS(13695), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351587] = 3,
    ACTIONS(13697), 1,
      anon_sym_EQ,
    ACTIONS(13659), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351600] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(9050), 1,
      anon_sym_LBRACE,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351615] = 4,
    ACTIONS(8786), 1,
      anon_sym_SEMI,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    STATE(6927), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351630] = 4,
    ACTIONS(11694), 1,
      anon_sym_RBRACE,
    ACTIONS(13699), 1,
      anon_sym_COMMA,
    STATE(8012), 1,
      aux_sym_import_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351645] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(13701), 1,
      anon_sym_RPAREN,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351660] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12959), 1,
      sym__raw_string_content,
    ACTIONS(13703), 1,
      anon_sym_BQUOTE,
    STATE(8308), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [351677] = 4,
    ACTIONS(5502), 1,
      anon_sym_RBRACE,
    ACTIONS(13705), 1,
      anon_sym_COMMA,
    STATE(8032), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351692] = 4,
    ACTIONS(12250), 1,
      anon_sym_COMMA,
    ACTIONS(12278), 1,
      anon_sym_RPAREN,
    STATE(8340), 1,
      aux_sym_polymorphic_parameters_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351707] = 4,
    ACTIONS(12146), 1,
      anon_sym_RBRACE,
    ACTIONS(13707), 1,
      anon_sym_COMMA,
    STATE(7718), 1,
      aux_sym_struct_declaration_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351722] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12198), 1,
      anon_sym_RPAREN,
    STATE(8197), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351737] = 4,
    ACTIONS(13709), 1,
      anon_sym_RBRACE,
    ACTIONS(13711), 1,
      anon_sym_COMMA,
    STATE(8012), 1,
      aux_sym_import_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351752] = 4,
    ACTIONS(13714), 1,
      anon_sym_RBRACE,
    ACTIONS(13716), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351767] = 4,
    ACTIONS(9138), 1,
      anon_sym_RBRACE,
    ACTIONS(13718), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351782] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(13720), 1,
      anon_sym_RPAREN,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351797] = 4,
    ACTIONS(13722), 1,
      anon_sym_COMMA,
    ACTIONS(13724), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351812] = 4,
    ACTIONS(13726), 1,
      anon_sym_COMMA,
    ACTIONS(13728), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351827] = 4,
    ACTIONS(13730), 1,
      anon_sym_RBRACE,
    ACTIONS(13732), 1,
      anon_sym_COMMA,
    STATE(7734), 1,
      aux_sym_import_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351842] = 4,
    ACTIONS(11956), 1,
      anon_sym_RBRACE,
    ACTIONS(13251), 1,
      anon_sym_COMMA,
    STATE(8012), 1,
      aux_sym_import_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351857] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(13734), 3,
      anon_sym_LBRACE,
      anon_sym_where,
      sym_tag,
  [351868] = 4,
    ACTIONS(13736), 1,
      anon_sym_COMMA,
    ACTIONS(13738), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351883] = 4,
    ACTIONS(8726), 1,
      anon_sym_RPAREN,
    ACTIONS(13740), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351898] = 4,
    ACTIONS(13742), 1,
      anon_sym_COMMA,
    ACTIONS(13744), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351913] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13746), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351928] = 4,
    ACTIONS(13748), 1,
      anon_sym_COMMA,
    ACTIONS(13750), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351943] = 4,
    ACTIONS(13752), 1,
      anon_sym_COMMA,
    ACTIONS(13754), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351958] = 4,
    ACTIONS(5590), 1,
      anon_sym_RBRACE,
    ACTIONS(13756), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351973] = 4,
    ACTIONS(13758), 1,
      anon_sym_COMMA,
    ACTIONS(13760), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [351988] = 4,
    ACTIONS(4980), 1,
      anon_sym_RBRACE,
    ACTIONS(13762), 1,
      anon_sym_COMMA,
    STATE(8069), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352003] = 4,
    ACTIONS(5494), 1,
      anon_sym_RBRACE,
    ACTIONS(13764), 1,
      anon_sym_COMMA,
    STATE(8049), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352018] = 4,
    ACTIONS(12116), 1,
      sym_identifier,
    ACTIONS(12120), 1,
      anon_sym_using,
    STATE(8497), 1,
      sym_struct_member,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352033] = 4,
    ACTIONS(5494), 1,
      anon_sym_RBRACE,
    ACTIONS(13764), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352048] = 4,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(13766), 1,
      anon_sym_do,
    STATE(7195), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352063] = 4,
    ACTIONS(4980), 1,
      anon_sym_RBRACE,
    ACTIONS(13762), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352078] = 4,
    ACTIONS(5124), 1,
      anon_sym_RBRACE,
    ACTIONS(13768), 1,
      anon_sym_COMMA,
    STATE(8077), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352093] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13770), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352108] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12166), 1,
      anon_sym_RPAREN,
    STATE(8098), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352123] = 4,
    ACTIONS(13772), 1,
      anon_sym_COMMA,
    ACTIONS(13774), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352138] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12806), 3,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
  [352149] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12152), 1,
      anon_sym_RPAREN,
    STATE(7743), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352164] = 4,
    ACTIONS(13776), 1,
      anon_sym_COMMA,
    ACTIONS(13778), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352179] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(7858), 1,
      anon_sym_LBRACE,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352194] = 4,
    ACTIONS(4822), 1,
      anon_sym_RBRACE,
    ACTIONS(13780), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352209] = 4,
    ACTIONS(13782), 1,
      anon_sym_COMMA,
    ACTIONS(13784), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352224] = 4,
    ACTIONS(5744), 1,
      anon_sym_RBRACE,
    ACTIONS(12811), 1,
      anon_sym_COMMA,
    STATE(7933), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352239] = 4,
    ACTIONS(5876), 1,
      anon_sym_RBRACE,
    ACTIONS(13786), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352254] = 4,
    ACTIONS(13788), 1,
      anon_sym_RBRACE,
    ACTIONS(13790), 1,
      anon_sym_COMMA,
    STATE(8324), 1,
      aux_sym_import_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352269] = 3,
    ACTIONS(11873), 1,
      anon_sym_EQ,
    ACTIONS(10494), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352282] = 4,
    ACTIONS(5492), 1,
      anon_sym_RBRACE,
    ACTIONS(13792), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352297] = 4,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(13794), 1,
      anon_sym_RBRACE,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352312] = 4,
    ACTIONS(5124), 1,
      anon_sym_RBRACE,
    ACTIONS(13768), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352327] = 4,
    ACTIONS(13796), 1,
      anon_sym_RBRACE,
    ACTIONS(13798), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352342] = 4,
    ACTIONS(5590), 1,
      anon_sym_RBRACE,
    ACTIONS(13756), 1,
      anon_sym_COMMA,
    STATE(8157), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352357] = 4,
    ACTIONS(11180), 1,
      anon_sym_RPAREN,
    ACTIONS(13800), 1,
      anon_sym_COMMA,
    STATE(7965), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352372] = 4,
    ACTIONS(13802), 1,
      anon_sym_RBRACE,
    ACTIONS(13804), 1,
      anon_sym_COMMA,
    STATE(8055), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352387] = 3,
    STATE(1569), 1,
      sym__separator,
    ACTIONS(13807), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352400] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13809), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352415] = 4,
    ACTIONS(13493), 1,
      anon_sym_COMMA,
    ACTIONS(13811), 1,
      anon_sym_COLON,
    STATE(8089), 1,
      aux_sym_struct_member_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352430] = 4,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(13813), 1,
      anon_sym_RBRACE,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352445] = 4,
    ACTIONS(13815), 1,
      anon_sym_COMMA,
    ACTIONS(13817), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352460] = 4,
    ACTIONS(5492), 1,
      anon_sym_RBRACE,
    ACTIONS(13792), 1,
      anon_sym_COMMA,
    STATE(8065), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352475] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(13819), 1,
      anon_sym_RPAREN,
    STATE(8073), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352490] = 4,
    ACTIONS(13821), 1,
      anon_sym_COMMA,
    ACTIONS(13824), 1,
      anon_sym_COLON,
    STATE(8063), 1,
      aux_sym_switch_case_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352505] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13826), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352520] = 4,
    ACTIONS(5486), 1,
      anon_sym_RBRACE,
    ACTIONS(13828), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352535] = 4,
    ACTIONS(13830), 1,
      anon_sym_RBRACE,
    ACTIONS(13832), 1,
      anon_sym_COMMA,
    STATE(8072), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352550] = 4,
    ACTIONS(13834), 1,
      anon_sym_RBRACE,
    ACTIONS(13836), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352565] = 4,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(13839), 1,
      anon_sym_do,
    STATE(7178), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352580] = 4,
    ACTIONS(5480), 1,
      anon_sym_RBRACE,
    ACTIONS(13489), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352595] = 4,
    ACTIONS(13841), 1,
      anon_sym_RBRACE,
    ACTIONS(13843), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352610] = 4,
    ACTIONS(5868), 1,
      anon_sym_RBRACE,
    ACTIONS(13845), 1,
      anon_sym_COMMA,
    STATE(8133), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352625] = 4,
    ACTIONS(6019), 1,
      anon_sym_RBRACE,
    ACTIONS(13847), 1,
      anon_sym_COMMA,
    STATE(8055), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352640] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(13849), 1,
      anon_sym_RPAREN,
    STATE(7800), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352655] = 4,
    ACTIONS(6021), 1,
      anon_sym_RBRACE,
    ACTIONS(13851), 1,
      anon_sym_COMMA,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352670] = 4,
    ACTIONS(13853), 1,
      anon_sym_COMMA,
    ACTIONS(13855), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352685] = 4,
    ACTIONS(13857), 1,
      anon_sym_RBRACE,
    ACTIONS(13859), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352700] = 4,
    ACTIONS(5122), 1,
      anon_sym_RBRACE,
    ACTIONS(13861), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352715] = 4,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(13863), 1,
      anon_sym_RBRACE,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352730] = 4,
    ACTIONS(13865), 1,
      anon_sym_RBRACE,
    ACTIONS(13867), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352745] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13869), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352760] = 4,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(13871), 1,
      anon_sym_do,
    STATE(7142), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352775] = 4,
    ACTIONS(13873), 1,
      anon_sym_RBRACE,
    ACTIONS(13875), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352790] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(8330), 1,
      anon_sym_LBRACE,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352805] = 4,
    ACTIONS(8992), 1,
      anon_sym_RBRACE,
    ACTIONS(13877), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352820] = 4,
    ACTIONS(11984), 1,
      anon_sym_COMMA,
    ACTIONS(11986), 1,
      anon_sym_RPAREN,
    STATE(7978), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352835] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13879), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352850] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13881), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352865] = 4,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(13883), 1,
      anon_sym_do,
    STATE(6988), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352880] = 4,
    ACTIONS(13885), 1,
      anon_sym_COMMA,
    ACTIONS(13888), 1,
      anon_sym_COLON,
    STATE(8089), 1,
      aux_sym_struct_member_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352895] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(13890), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352910] = 4,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(13892), 1,
      anon_sym_do,
    STATE(7195), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352925] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13894), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352940] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13896), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352955] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13898), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352970] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(9036), 1,
      anon_sym_LBRACE,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [352985] = 4,
    ACTIONS(12124), 1,
      anon_sym_RBRACE,
    ACTIONS(13203), 1,
      anon_sym_COMMA,
    STATE(7845), 1,
      aux_sym_struct_declaration_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353000] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(13900), 1,
      anon_sym_BQUOTE,
    ACTIONS(13902), 1,
      sym__raw_string_content,
    STATE(8136), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [353017] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(13904), 1,
      anon_sym_RPAREN,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353032] = 4,
    ACTIONS(5462), 1,
      anon_sym_RBRACE,
    ACTIONS(13906), 1,
      anon_sym_COMMA,
    STATE(8110), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353047] = 4,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(13908), 1,
      anon_sym_do,
    STATE(7151), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353062] = 4,
    ACTIONS(13910), 1,
      anon_sym_COMMA,
    ACTIONS(13912), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353077] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13914), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353092] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13916), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353107] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13918), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353122] = 4,
    ACTIONS(9965), 1,
      anon_sym_RBRACE,
    ACTIONS(9967), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353137] = 4,
    ACTIONS(13920), 1,
      anon_sym_RBRACE,
    ACTIONS(13922), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353152] = 4,
    ACTIONS(5122), 1,
      anon_sym_RBRACE,
    ACTIONS(13861), 1,
      anon_sym_COMMA,
    STATE(8112), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353167] = 4,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(13924), 1,
      anon_sym_do,
    STATE(7181), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353182] = 4,
    ACTIONS(13926), 1,
      anon_sym_COMMA,
    ACTIONS(13928), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353197] = 4,
    ACTIONS(5460), 1,
      anon_sym_RBRACE,
    ACTIONS(13930), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353212] = 4,
    ACTIONS(8714), 1,
      anon_sym_RPAREN,
    ACTIONS(13932), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353227] = 4,
    ACTIONS(5114), 1,
      anon_sym_RBRACE,
    ACTIONS(13934), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353242] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13936), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353257] = 4,
    ACTIONS(6131), 1,
      anon_sym_RBRACE,
    ACTIONS(13938), 1,
      anon_sym_COMMA,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353272] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(13940), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353287] = 4,
    ACTIONS(11166), 1,
      anon_sym_RPAREN,
    ACTIONS(13942), 1,
      anon_sym_COMMA,
    STATE(7965), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353302] = 4,
    ACTIONS(11708), 1,
      anon_sym_COMMA,
    ACTIONS(11710), 1,
      anon_sym_RPAREN,
    STATE(8144), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353317] = 4,
    ACTIONS(13944), 1,
      anon_sym_COMMA,
    ACTIONS(13946), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353332] = 4,
    ACTIONS(6133), 1,
      anon_sym_RBRACE,
    ACTIONS(13948), 1,
      anon_sym_COMMA,
    STATE(8055), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353347] = 4,
    ACTIONS(13950), 1,
      anon_sym_RBRACE,
    ACTIONS(13952), 1,
      anon_sym_COMMA,
    STATE(8120), 1,
      aux_sym__struct_members_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353362] = 4,
    ACTIONS(13955), 1,
      anon_sym_COMMA,
    ACTIONS(13957), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353377] = 4,
    ACTIONS(13959), 1,
      anon_sym_COMMA,
    ACTIONS(13961), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353392] = 4,
    ACTIONS(5792), 1,
      anon_sym_RBRACE,
    ACTIONS(13963), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353407] = 4,
    ACTIONS(13001), 1,
      anon_sym_COMMA,
    ACTIONS(13965), 1,
      anon_sym_COLON,
    STATE(8280), 1,
      aux_sym_polymorphic_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353422] = 4,
    ACTIONS(13967), 1,
      anon_sym_COMMA,
    ACTIONS(13969), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353437] = 3,
    ACTIONS(13973), 1,
      sym_number,
    ACTIONS(13971), 2,
      anon_sym_LBRACE,
      sym_tag,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353450] = 4,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(13975), 1,
      anon_sym_do,
    STATE(7178), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353465] = 3,
    ACTIONS(11841), 1,
      anon_sym_EQ,
    ACTIONS(11806), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353478] = 4,
    ACTIONS(13977), 1,
      anon_sym_COMMA,
    ACTIONS(13979), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353493] = 4,
    ACTIONS(13981), 1,
      anon_sym_RBRACE,
    ACTIONS(13983), 1,
      anon_sym_COMMA,
    STATE(8168), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353508] = 4,
    ACTIONS(5460), 1,
      anon_sym_RBRACE,
    ACTIONS(13930), 1,
      anon_sym_COMMA,
    STATE(8178), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353523] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(13985), 1,
      anon_sym_RPAREN,
    STATE(7800), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353538] = 4,
    ACTIONS(5866), 1,
      anon_sym_RBRACE,
    ACTIONS(13987), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353553] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(12328), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [353564] = 4,
    ACTIONS(13989), 1,
      anon_sym_COMMA,
    ACTIONS(13991), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353579] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12959), 1,
      sym__raw_string_content,
    ACTIONS(13993), 1,
      anon_sym_BQUOTE,
    STATE(8308), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [353596] = 4,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(13995), 1,
      anon_sym_do,
    STATE(7061), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353611] = 4,
    ACTIONS(8674), 1,
      anon_sym_RPAREN,
    ACTIONS(13997), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353626] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(13999), 1,
      anon_sym_RPAREN,
    STATE(8162), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353641] = 4,
    ACTIONS(14001), 1,
      anon_sym_RBRACE,
    ACTIONS(14003), 1,
      anon_sym_COMMA,
    STATE(8119), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353656] = 4,
    ACTIONS(4872), 1,
      anon_sym_RBRACE,
    ACTIONS(14005), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353671] = 3,
    ACTIONS(14007), 1,
      anon_sym_EQ,
    ACTIONS(10474), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353684] = 4,
    ACTIONS(8776), 1,
      anon_sym_SEMI,
    ACTIONS(9997), 1,
      anon_sym_COMMA,
    STATE(7979), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353699] = 4,
    ACTIONS(8704), 1,
      anon_sym_RPAREN,
    ACTIONS(14009), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353714] = 4,
    ACTIONS(4840), 1,
      anon_sym_RBRACE,
    ACTIONS(14011), 1,
      anon_sym_COMMA,
    STATE(8141), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353729] = 4,
    ACTIONS(14013), 1,
      anon_sym_COMMA,
    ACTIONS(14015), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353744] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14017), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353759] = 4,
    ACTIONS(14019), 1,
      anon_sym_RBRACE,
    ACTIONS(14021), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353774] = 4,
    ACTIONS(4838), 1,
      anon_sym_RBRACE,
    ACTIONS(14023), 1,
      anon_sym_COMMA,
    STATE(8315), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353789] = 4,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(14025), 1,
      anon_sym_RBRACE,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353804] = 4,
    ACTIONS(4840), 1,
      anon_sym_RBRACE,
    ACTIONS(14011), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353819] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12180), 1,
      anon_sym_RPAREN,
    STATE(8006), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353834] = 4,
    ACTIONS(14027), 1,
      anon_sym_RBRACE,
    ACTIONS(14029), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353849] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14031), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353864] = 4,
    ACTIONS(9008), 1,
      anon_sym_RBRACE,
    ACTIONS(14033), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353879] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14035), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353894] = 4,
    ACTIONS(5504), 1,
      anon_sym_RBRACE,
    ACTIONS(14037), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353909] = 4,
    ACTIONS(14039), 1,
      anon_sym_RBRACE,
    ACTIONS(14041), 1,
      anon_sym_COMMA,
    STATE(8387), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353924] = 4,
    ACTIONS(5866), 1,
      anon_sym_RBRACE,
    ACTIONS(13987), 1,
      anon_sym_COMMA,
    STATE(8190), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353939] = 4,
    ACTIONS(14043), 1,
      anon_sym_RBRACE,
    ACTIONS(14045), 1,
      anon_sym_COMMA,
    STATE(7881), 1,
      aux_sym_import_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353954] = 4,
    ACTIONS(13097), 1,
      anon_sym_COMMA,
    ACTIONS(14047), 1,
      anon_sym_COLON,
    STATE(7727), 1,
      aux_sym_field_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353969] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(14049), 1,
      anon_sym_RPAREN,
    STATE(7800), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353984] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12268), 1,
      anon_sym_RPAREN,
    STATE(8195), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [353999] = 4,
    ACTIONS(14051), 1,
      anon_sym_COMMA,
    ACTIONS(14053), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354014] = 4,
    ACTIONS(14055), 1,
      anon_sym_COMMA,
    ACTIONS(14057), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354029] = 4,
    ACTIONS(14059), 1,
      anon_sym_RBRACE,
    ACTIONS(14061), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354044] = 4,
    ACTIONS(14063), 1,
      anon_sym_COMMA,
    ACTIONS(14065), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354059] = 4,
    ACTIONS(6091), 1,
      anon_sym_RBRACE,
    ACTIONS(14067), 1,
      anon_sym_COMMA,
    STATE(8055), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354074] = 4,
    ACTIONS(14069), 1,
      anon_sym_COMMA,
    ACTIONS(14071), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354089] = 4,
    ACTIONS(11762), 1,
      anon_sym_RBRACE,
    ACTIONS(14073), 1,
      anon_sym_COMMA,
    STATE(8012), 1,
      aux_sym_import_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354104] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14075), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354119] = 4,
    ACTIONS(14077), 1,
      anon_sym_COMMA,
    ACTIONS(14079), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354134] = 4,
    ACTIONS(6095), 1,
      anon_sym_RBRACE,
    ACTIONS(14081), 1,
      anon_sym_COMMA,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354149] = 4,
    ACTIONS(14083), 1,
      anon_sym_RBRACE,
    ACTIONS(14085), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354164] = 3,
    ACTIONS(14089), 1,
      anon_sym_EQ,
    ACTIONS(14087), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354177] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14091), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354192] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12272), 1,
      anon_sym_RPAREN,
    STATE(7832), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354207] = 4,
    ACTIONS(5440), 1,
      anon_sym_RBRACE,
    ACTIONS(14093), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354222] = 4,
    ACTIONS(5426), 1,
      anon_sym_RBRACE,
    ACTIONS(14095), 1,
      anon_sym_COMMA,
    STATE(8224), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354237] = 4,
    ACTIONS(14097), 1,
      anon_sym_COMMA,
    ACTIONS(14099), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354252] = 4,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(14101), 1,
      anon_sym_do,
    STATE(6988), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354267] = 4,
    ACTIONS(14103), 1,
      anon_sym_RBRACE,
    ACTIONS(14105), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354282] = 4,
    ACTIONS(14107), 1,
      anon_sym_RBRACE,
    ACTIONS(14109), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354297] = 4,
    ACTIONS(8856), 1,
      anon_sym_RBRACE,
    ACTIONS(14111), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354312] = 4,
    ACTIONS(9124), 1,
      anon_sym_RBRACE,
    ACTIONS(14113), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354327] = 4,
    ACTIONS(14087), 1,
      anon_sym_RBRACE,
    ACTIONS(14115), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354342] = 4,
    ACTIONS(11881), 1,
      anon_sym_COMMA,
    ACTIONS(11883), 1,
      anon_sym_RPAREN,
    STATE(8138), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354357] = 4,
    ACTIONS(9018), 1,
      anon_sym_RBRACE,
    ACTIONS(12276), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354372] = 4,
    ACTIONS(8758), 1,
      anon_sym_SEMI,
    ACTIONS(9997), 1,
      anon_sym_COMMA,
    STATE(8278), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354387] = 4,
    ACTIONS(5864), 1,
      anon_sym_RBRACE,
    ACTIONS(14118), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354402] = 4,
    ACTIONS(5750), 1,
      anon_sym_RBRACE,
    ACTIONS(14120), 1,
      anon_sym_COMMA,
    STATE(7595), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354417] = 4,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(14122), 1,
      anon_sym_RBRACE,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354432] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14124), 1,
      anon_sym_BQUOTE,
    ACTIONS(14126), 1,
      sym__raw_string_content,
    STATE(8007), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [354449] = 4,
    ACTIONS(4820), 1,
      anon_sym_RBRACE,
    ACTIONS(14128), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354464] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(14130), 1,
      anon_sym_RPAREN,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354479] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14132), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354494] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(14134), 1,
      anon_sym_RPAREN,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354509] = 4,
    ACTIONS(14136), 1,
      anon_sym_RBRACE,
    ACTIONS(14138), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354524] = 4,
    ACTIONS(14140), 1,
      anon_sym_COMMA,
    ACTIONS(14142), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354539] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14144), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354554] = 4,
    ACTIONS(14146), 1,
      anon_sym_COMMA,
    ACTIONS(14148), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354569] = 4,
    ACTIONS(5864), 1,
      anon_sym_RBRACE,
    ACTIONS(14118), 1,
      anon_sym_COMMA,
    STATE(8214), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354584] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14150), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354599] = 4,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    ACTIONS(11531), 1,
      anon_sym_SEMI,
    STATE(6927), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354614] = 4,
    ACTIONS(12284), 1,
      anon_sym_RBRACE,
    ACTIONS(14152), 1,
      anon_sym_COMMA,
    STATE(7598), 1,
      aux_sym_struct_declaration_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354629] = 4,
    ACTIONS(14154), 1,
      anon_sym_COMMA,
    ACTIONS(14156), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354644] = 4,
    ACTIONS(8784), 1,
      anon_sym_SEMI,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    STATE(6927), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354659] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14158), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354674] = 4,
    ACTIONS(12284), 1,
      anon_sym_RBRACE,
    ACTIONS(14152), 1,
      anon_sym_COMMA,
    STATE(7718), 1,
      aux_sym_struct_declaration_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354689] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14160), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354704] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(14162), 1,
      anon_sym_RPAREN,
    STATE(8219), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354719] = 4,
    ACTIONS(14164), 1,
      anon_sym_RBRACE,
    ACTIONS(14166), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354734] = 4,
    ACTIONS(4820), 1,
      anon_sym_RBRACE,
    ACTIONS(14128), 1,
      anon_sym_COMMA,
    STATE(8151), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354749] = 4,
    ACTIONS(5862), 1,
      anon_sym_RBRACE,
    ACTIONS(14168), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354764] = 4,
    ACTIONS(14170), 1,
      anon_sym_RBRACE,
    ACTIONS(14172), 1,
      anon_sym_COMMA,
    STATE(8218), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354779] = 4,
    ACTIONS(12597), 1,
      anon_sym_RBRACE,
    ACTIONS(14174), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354794] = 4,
    ACTIONS(5406), 1,
      anon_sym_RBRACE,
    ACTIONS(14177), 1,
      anon_sym_COMMA,
    STATE(8268), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354809] = 4,
    ACTIONS(5900), 1,
      anon_sym_RBRACE,
    ACTIONS(14179), 1,
      anon_sym_COMMA,
    STATE(8055), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354824] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(14181), 1,
      anon_sym_RPAREN,
    STATE(7800), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354839] = 4,
    ACTIONS(14183), 1,
      anon_sym_RBRACE,
    ACTIONS(14185), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354854] = 4,
    ACTIONS(14187), 1,
      anon_sym_COMMA,
    ACTIONS(14189), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354869] = 4,
    ACTIONS(14191), 1,
      anon_sym_COMMA,
    ACTIONS(14193), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354884] = 4,
    ACTIONS(14195), 1,
      anon_sym_COMMA,
    ACTIONS(14197), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354899] = 4,
    ACTIONS(5406), 1,
      anon_sym_RBRACE,
    ACTIONS(14177), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354914] = 4,
    ACTIONS(5316), 1,
      anon_sym_RBRACE,
    ACTIONS(14199), 1,
      anon_sym_COMMA,
    STATE(7885), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354929] = 4,
    ACTIONS(14201), 1,
      anon_sym_COMMA,
    ACTIONS(14203), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354944] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14205), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354959] = 4,
    ACTIONS(14207), 1,
      anon_sym_RBRACE,
    ACTIONS(14209), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354974] = 4,
    ACTIONS(11875), 1,
      anon_sym_COMMA,
    ACTIONS(11877), 1,
      anon_sym_RPAREN,
    STATE(8259), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [354989] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14211), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355004] = 4,
    ACTIONS(14213), 1,
      anon_sym_LBRACE,
    ACTIONS(14215), 1,
      sym_tag,
    STATE(8231), 1,
      aux_sym_struct_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355019] = 4,
    ACTIONS(14218), 1,
      anon_sym_COMMA,
    ACTIONS(14220), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355034] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14222), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355049] = 4,
    ACTIONS(5814), 1,
      anon_sym_RBRACE,
    ACTIONS(14224), 1,
      anon_sym_COMMA,
    STATE(7949), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355064] = 4,
    ACTIONS(13001), 1,
      anon_sym_COMMA,
    ACTIONS(14226), 1,
      anon_sym_COLON,
    STATE(7894), 1,
      aux_sym_polymorphic_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355079] = 4,
    ACTIONS(8772), 1,
      anon_sym_SEMI,
    ACTIONS(9997), 1,
      anon_sym_COMMA,
    STATE(8331), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355094] = 4,
    ACTIONS(14228), 1,
      anon_sym_RBRACE,
    ACTIONS(14230), 1,
      anon_sym_COMMA,
    STATE(7901), 1,
      aux_sym__struct_members_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355109] = 4,
    ACTIONS(8772), 1,
      anon_sym_SEMI,
    ACTIONS(9997), 1,
      anon_sym_COMMA,
    STATE(7860), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355124] = 4,
    ACTIONS(13493), 1,
      anon_sym_COMMA,
    ACTIONS(14232), 1,
      anon_sym_COLON,
    STATE(7906), 1,
      aux_sym_struct_member_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355139] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(14234), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355154] = 4,
    ACTIONS(14236), 1,
      anon_sym_COMMA,
    ACTIONS(14238), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355169] = 4,
    ACTIONS(8758), 1,
      anon_sym_SEMI,
    ACTIONS(9997), 1,
      anon_sym_COMMA,
    STATE(7860), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355184] = 4,
    ACTIONS(14240), 1,
      anon_sym_COMMA,
    ACTIONS(14242), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355199] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11414), 1,
      anon_sym_LBRACE,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355214] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(14244), 1,
      anon_sym_RPAREN,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355229] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14246), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355244] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14248), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355259] = 4,
    ACTIONS(5902), 1,
      anon_sym_RBRACE,
    ACTIONS(14250), 1,
      anon_sym_COMMA,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355274] = 4,
    ACTIONS(12000), 1,
      anon_sym_COMMA,
    ACTIONS(12002), 1,
      anon_sym_RPAREN,
    STATE(8111), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355289] = 4,
    ACTIONS(9040), 1,
      anon_sym_RBRACE,
    ACTIONS(14252), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355304] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(14254), 1,
      anon_sym_RPAREN,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355319] = 4,
    ACTIONS(14256), 1,
      anon_sym_RBRACE,
    ACTIONS(14258), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355334] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14260), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355349] = 4,
    ACTIONS(8958), 1,
      anon_sym_RBRACE,
    ACTIONS(14262), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355364] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12348), 1,
      anon_sym_RPAREN,
    STATE(8251), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355379] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14264), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355394] = 4,
    ACTIONS(14266), 1,
      anon_sym_RBRACE,
    ACTIONS(14268), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355409] = 4,
    ACTIONS(10055), 1,
      anon_sym_RBRACE,
    ACTIONS(10057), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355424] = 4,
    ACTIONS(8660), 1,
      anon_sym_RPAREN,
    ACTIONS(14270), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355439] = 4,
    ACTIONS(5500), 1,
      anon_sym_RBRACE,
    ACTIONS(14272), 1,
      anon_sym_COMMA,
    STATE(8194), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355454] = 4,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    ACTIONS(11565), 1,
      anon_sym_SEMI,
    STATE(6927), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355469] = 3,
    STATE(5913), 1,
      sym__separator,
    ACTIONS(12442), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355482] = 4,
    ACTIONS(14274), 1,
      anon_sym_COMMA,
    ACTIONS(14276), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355497] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14278), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355512] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12312), 1,
      anon_sym_RPAREN,
    STATE(8245), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355527] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14280), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355542] = 4,
    ACTIONS(14282), 1,
      anon_sym_COMMA,
    ACTIONS(14284), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355557] = 4,
    ACTIONS(5404), 1,
      anon_sym_RBRACE,
    ACTIONS(14286), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355572] = 4,
    ACTIONS(11154), 1,
      anon_sym_RPAREN,
    ACTIONS(14288), 1,
      anon_sym_COMMA,
    STATE(7965), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355587] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14290), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355602] = 4,
    ACTIONS(8656), 1,
      anon_sym_RPAREN,
    ACTIONS(14292), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355617] = 4,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(14294), 1,
      anon_sym_RBRACE,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355632] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14296), 1,
      anon_sym_BQUOTE,
    ACTIONS(14298), 1,
      sym__raw_string_content,
    STATE(8284), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [355649] = 4,
    ACTIONS(5836), 1,
      anon_sym_RBRACE,
    ACTIONS(14300), 1,
      anon_sym_COMMA,
    STATE(8287), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355664] = 4,
    ACTIONS(14302), 1,
      anon_sym_COMMA,
    ACTIONS(14304), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355679] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14306), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355694] = 4,
    ACTIONS(14308), 1,
      anon_sym_RBRACE,
    ACTIONS(14310), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355709] = 4,
    ACTIONS(9997), 1,
      anon_sym_COMMA,
    ACTIONS(11563), 1,
      anon_sym_SEMI,
    STATE(7860), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355724] = 4,
    ACTIONS(12028), 1,
      anon_sym_COMMA,
    ACTIONS(12030), 1,
      anon_sym_RPAREN,
    STATE(8271), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355739] = 4,
    ACTIONS(14312), 1,
      anon_sym_COMMA,
    ACTIONS(14315), 1,
      anon_sym_COLON,
    STATE(8280), 1,
      aux_sym_polymorphic_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355754] = 4,
    ACTIONS(5834), 1,
      anon_sym_RBRACE,
    ACTIONS(14317), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355769] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14319), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355784] = 4,
    ACTIONS(5816), 1,
      anon_sym_RBRACE,
    ACTIONS(14321), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355799] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12959), 1,
      sym__raw_string_content,
    ACTIONS(14323), 1,
      anon_sym_BQUOTE,
    STATE(8308), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [355816] = 4,
    ACTIONS(14325), 1,
      anon_sym_COMMA,
    ACTIONS(14327), 1,
      anon_sym_RPAREN,
    STATE(7966), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355831] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14329), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355846] = 4,
    ACTIONS(5832), 1,
      anon_sym_RBRACE,
    ACTIONS(14331), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355861] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12260), 1,
      anon_sym_RPAREN,
    STATE(8391), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355876] = 4,
    ACTIONS(14333), 1,
      anon_sym_COMMA,
    ACTIONS(14335), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355891] = 4,
    ACTIONS(14337), 1,
      anon_sym_RBRACE,
    ACTIONS(14339), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355906] = 4,
    ACTIONS(11603), 1,
      anon_sym_COMMA,
    ACTIONS(14341), 1,
      anon_sym_RPAREN,
    STATE(7988), 1,
      aux_sym_attribute_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355921] = 4,
    ACTIONS(14343), 1,
      anon_sym_COMMA,
    ACTIONS(14345), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355936] = 4,
    ACTIONS(14347), 1,
      anon_sym_COMMA,
    ACTIONS(14349), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355951] = 4,
    ACTIONS(8768), 1,
      anon_sym_SEMI,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    STATE(6927), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355966] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14351), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355981] = 4,
    ACTIONS(14353), 1,
      anon_sym_RBRACE,
    ACTIONS(14355), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [355996] = 4,
    ACTIONS(5316), 1,
      anon_sym_RBRACE,
    ACTIONS(14199), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356011] = 4,
    ACTIONS(14357), 1,
      anon_sym_COMMA,
    ACTIONS(14359), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356026] = 2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
    ACTIONS(14361), 3,
      anon_sym_LBRACE,
      anon_sym_where,
      sym_tag,
  [356037] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14363), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356052] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14365), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356067] = 4,
    ACTIONS(8670), 1,
      anon_sym_RPAREN,
    ACTIONS(14367), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356082] = 4,
    ACTIONS(5828), 1,
      anon_sym_RBRACE,
    ACTIONS(14369), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356097] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(14371), 1,
      anon_sym_RPAREN,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356112] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14373), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356127] = 4,
    ACTIONS(5404), 1,
      anon_sym_RBRACE,
    ACTIONS(14286), 1,
      anon_sym_COMMA,
    STATE(8311), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356142] = 4,
    ACTIONS(4661), 1,
      anon_sym_LBRACE,
    ACTIONS(10313), 1,
      anon_sym_COMMA,
    STATE(8347), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356157] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14375), 1,
      anon_sym_BQUOTE,
    ACTIONS(14377), 1,
      sym__raw_string_content,
    STATE(8308), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [356174] = 4,
    ACTIONS(4848), 1,
      anon_sym_RBRACE,
    ACTIONS(14380), 1,
      anon_sym_COMMA,
    STATE(8349), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356189] = 4,
    ACTIONS(8794), 1,
      anon_sym_RBRACE,
    ACTIONS(14382), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356204] = 4,
    ACTIONS(5394), 1,
      anon_sym_RBRACE,
    ACTIONS(14384), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356219] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14386), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356234] = 4,
    ACTIONS(14388), 1,
      anon_sym_COMMA,
    ACTIONS(14390), 1,
      anon_sym_RPAREN,
    STATE(8269), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356249] = 4,
    ACTIONS(14392), 1,
      anon_sym_RBRACE,
    ACTIONS(14394), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356264] = 4,
    ACTIONS(4848), 1,
      anon_sym_RBRACE,
    ACTIONS(14380), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356279] = 4,
    ACTIONS(14396), 1,
      anon_sym_RBRACE,
    ACTIONS(14398), 1,
      anon_sym_COMMA,
    STATE(8319), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356294] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14400), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356309] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12366), 1,
      anon_sym_RPAREN,
    STATE(8304), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356324] = 4,
    ACTIONS(6041), 1,
      anon_sym_RBRACE,
    ACTIONS(14402), 1,
      anon_sym_COMMA,
    STATE(8055), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356339] = 4,
    ACTIONS(5776), 1,
      anon_sym_RBRACE,
    ACTIONS(14404), 1,
      anon_sym_COMMA,
    STATE(8281), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356354] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(14406), 1,
      anon_sym_RPAREN,
    STATE(8332), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356369] = 4,
    ACTIONS(6043), 1,
      anon_sym_RBRACE,
    ACTIONS(14408), 1,
      anon_sym_COMMA,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356384] = 4,
    ACTIONS(14410), 1,
      anon_sym_RBRACE,
    ACTIONS(14412), 1,
      anon_sym_COMMA,
    STATE(8005), 1,
      aux_sym_import_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356399] = 4,
    ACTIONS(11670), 1,
      anon_sym_RBRACE,
    ACTIONS(14414), 1,
      anon_sym_COMMA,
    STATE(8012), 1,
      aux_sym_import_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356414] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14416), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356429] = 4,
    ACTIONS(8650), 1,
      anon_sym_RPAREN,
    ACTIONS(14418), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356444] = 4,
    ACTIONS(11650), 1,
      anon_sym_COMMA,
    ACTIONS(11652), 1,
      anon_sym_RPAREN,
    STATE(8381), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356459] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(14420), 1,
      anon_sym_RPAREN,
    STATE(7800), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356474] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(14422), 1,
      anon_sym_RPAREN,
    STATE(8328), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356489] = 4,
    ACTIONS(11670), 1,
      anon_sym_RBRACE,
    ACTIONS(14414), 1,
      anon_sym_COMMA,
    STATE(8019), 1,
      aux_sym_import_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356504] = 4,
    ACTIONS(8762), 1,
      anon_sym_SEMI,
    ACTIONS(9997), 1,
      anon_sym_COMMA,
    STATE(7860), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356519] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(14424), 1,
      anon_sym_RPAREN,
    STATE(7800), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356534] = 4,
    ACTIONS(14426), 1,
      anon_sym_RBRACE,
    ACTIONS(14428), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356549] = 4,
    ACTIONS(11686), 1,
      anon_sym_COMMA,
    ACTIONS(11688), 1,
      anon_sym_RPAREN,
    STATE(8302), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356564] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14430), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356579] = 4,
    ACTIONS(14432), 1,
      anon_sym_RBRACE,
    ACTIONS(14434), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356594] = 4,
    ACTIONS(11696), 1,
      anon_sym_COMMA,
    ACTIONS(11698), 1,
      anon_sym_RPAREN,
    STATE(8326), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356609] = 4,
    ACTIONS(14436), 1,
      anon_sym_RBRACE,
    ACTIONS(14438), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356624] = 4,
    ACTIONS(5832), 1,
      anon_sym_RBRACE,
    ACTIONS(14331), 1,
      anon_sym_COMMA,
    STATE(8303), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356639] = 4,
    ACTIONS(14440), 1,
      anon_sym_COMMA,
    ACTIONS(14443), 1,
      anon_sym_RPAREN,
    STATE(8340), 1,
      aux_sym_polymorphic_parameters_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356654] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14445), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356669] = 4,
    ACTIONS(14447), 1,
      anon_sym_RBRACE,
    ACTIONS(14449), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356684] = 4,
    ACTIONS(14451), 1,
      anon_sym_COMMA,
    ACTIONS(14453), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356699] = 4,
    ACTIONS(9096), 1,
      anon_sym_RBRACE,
    ACTIONS(14455), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356714] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14457), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356729] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14459), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356744] = 4,
    ACTIONS(4717), 1,
      anon_sym_LBRACE,
    ACTIONS(14461), 1,
      anon_sym_COMMA,
    STATE(8347), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356759] = 4,
    ACTIONS(14464), 1,
      anon_sym_RBRACE,
    ACTIONS(14466), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356774] = 4,
    ACTIONS(4892), 1,
      anon_sym_RBRACE,
    ACTIONS(14468), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356789] = 4,
    ACTIONS(9927), 1,
      anon_sym_COMMA,
    ACTIONS(14470), 1,
      anon_sym_COLON,
    STATE(8063), 1,
      aux_sym_switch_case_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356804] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14472), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356819] = 4,
    ACTIONS(5776), 1,
      anon_sym_RBRACE,
    ACTIONS(14404), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356834] = 4,
    ACTIONS(8762), 1,
      anon_sym_SEMI,
    ACTIONS(9997), 1,
      anon_sym_COMMA,
    STATE(8242), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356849] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12959), 1,
      sym__raw_string_content,
    ACTIONS(14474), 1,
      anon_sym_BQUOTE,
    STATE(8308), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [356866] = 4,
    ACTIONS(13001), 1,
      anon_sym_COMMA,
    ACTIONS(14476), 1,
      anon_sym_COLON,
    STATE(7684), 1,
      aux_sym_polymorphic_parameters_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356881] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(14478), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356896] = 4,
    ACTIONS(14480), 1,
      anon_sym_RBRACE,
    ACTIONS(14482), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356911] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(14484), 1,
      anon_sym_RPAREN,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356926] = 3,
    STATE(1727), 1,
      sym__separator,
    ACTIONS(14486), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356939] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14488), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356954] = 4,
    ACTIONS(5762), 1,
      anon_sym_RBRACE,
    ACTIONS(14490), 1,
      anon_sym_COMMA,
    STATE(8352), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [356969] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14492), 1,
      anon_sym_BQUOTE,
    ACTIONS(14494), 1,
      sym__raw_string_content,
    STATE(8354), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [356986] = 4,
    ACTIONS(14496), 1,
      anon_sym_RBRACE,
    ACTIONS(14498), 1,
      anon_sym_COMMA,
    STATE(8392), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357001] = 4,
    ACTIONS(14500), 1,
      anon_sym_COMMA,
    ACTIONS(14502), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357016] = 4,
    ACTIONS(8872), 1,
      anon_sym_RBRACE,
    ACTIONS(14504), 1,
      anon_sym_COMMA,
    STATE(8216), 1,
      aux_sym_union_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357031] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14506), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357046] = 4,
    ACTIONS(14508), 1,
      anon_sym_RBRACE,
    ACTIONS(14510), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357061] = 4,
    ACTIONS(4892), 1,
      anon_sym_RBRACE,
    ACTIONS(14468), 1,
      anon_sym_COMMA,
    STATE(8386), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357076] = 4,
    ACTIONS(14512), 1,
      anon_sym_COMMA,
    ACTIONS(14514), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357091] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14516), 1,
      anon_sym_BQUOTE,
    ACTIONS(14518), 1,
      sym__raw_string_content,
    STATE(8389), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [357108] = 4,
    ACTIONS(5324), 1,
      anon_sym_RBRACE,
    ACTIONS(14520), 1,
      anon_sym_COMMA,
    STATE(8297), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357123] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12330), 1,
      anon_sym_RPAREN,
    STATE(8358), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357138] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(14522), 1,
      anon_sym_RPAREN,
    STATE(7800), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357153] = 4,
    ACTIONS(12823), 1,
      anon_sym_COMMA,
    ACTIONS(14524), 1,
      anon_sym_RPAREN,
    STATE(8373), 1,
      aux_sym_struct_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357168] = 4,
    ACTIONS(14526), 1,
      anon_sym_COMMA,
    ACTIONS(14528), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357183] = 4,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    ACTIONS(14530), 1,
      anon_sym_do,
    STATE(7061), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357198] = 4,
    ACTIONS(7678), 1,
      anon_sym_LPAREN,
    ACTIONS(11571), 1,
      anon_sym_SLASH,
    ACTIONS(14532), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357213] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14534), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357228] = 4,
    ACTIONS(8716), 1,
      anon_sym_RPAREN,
    ACTIONS(14536), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357243] = 4,
    ACTIONS(5932), 1,
      anon_sym_RBRACE,
    ACTIONS(14538), 1,
      anon_sym_COMMA,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357258] = 4,
    ACTIONS(8702), 1,
      anon_sym_RPAREN,
    ACTIONS(14540), 1,
      anon_sym_COMMA,
    STATE(7855), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357273] = 4,
    ACTIONS(8754), 1,
      anon_sym_SEMI,
    ACTIONS(9084), 1,
      anon_sym_COMMA,
    STATE(6927), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357288] = 4,
    ACTIONS(9927), 1,
      anon_sym_COMMA,
    ACTIONS(14542), 1,
      anon_sym_COLON,
    STATE(8063), 1,
      aux_sym_switch_case_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357303] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14544), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357318] = 4,
    ACTIONS(14546), 1,
      anon_sym_RBRACE,
    ACTIONS(14548), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357333] = 4,
    ACTIONS(4918), 1,
      anon_sym_RBRACE,
    ACTIONS(14551), 1,
      anon_sym_COMMA,
    STATE(8385), 1,
      aux_sym_struct_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357348] = 4,
    ACTIONS(5930), 1,
      anon_sym_RBRACE,
    ACTIONS(14553), 1,
      anon_sym_COMMA,
    STATE(8055), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357363] = 4,
    ACTIONS(9453), 1,
      anon_sym_COMMA,
    ACTIONS(14555), 1,
      anon_sym_RBRACE,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357378] = 5,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(12959), 1,
      sym__raw_string_content,
    ACTIONS(14557), 1,
      anon_sym_BQUOTE,
    STATE(8308), 1,
      aux_sym__raw_string_literal_repeat1,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [357395] = 4,
    ACTIONS(12466), 1,
      anon_sym_RPAREN,
    ACTIONS(14559), 1,
      anon_sym_COMMA,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357410] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(14562), 1,
      anon_sym_RPAREN,
    STATE(8390), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357425] = 4,
    ACTIONS(6121), 1,
      anon_sym_RBRACE,
    ACTIONS(14564), 1,
      anon_sym_COMMA,
    STATE(8055), 1,
      aux_sym_map_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357440] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14566), 1,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357455] = 4,
    ACTIONS(14568), 1,
      anon_sym_COMMA,
    ACTIONS(14570), 1,
      anon_sym_RPAREN,
    STATE(7817), 1,
      aux_sym_call_expression_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357470] = 4,
    ACTIONS(12150), 1,
      anon_sym_COMMA,
    ACTIONS(12292), 1,
      anon_sym_RPAREN,
    STATE(7796), 1,
      aux_sym_polymorphic_type_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357485] = 4,
    ACTIONS(6119), 1,
      anon_sym_RBRACE,
    ACTIONS(14572), 1,
      anon_sym_COMMA,
    STATE(7044), 1,
      aux_sym_overloaded_procedure_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357500] = 4,
    ACTIONS(14574), 1,
      anon_sym_RBRACE,
    ACTIONS(14576), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357515] = 4,
    ACTIONS(14578), 1,
      anon_sym_RBRACE,
    ACTIONS(14580), 1,
      anon_sym_COMMA,
    STATE(8067), 1,
      aux_sym_bit_field_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357530] = 4,
    ACTIONS(12250), 1,
      anon_sym_COMMA,
    ACTIONS(12334), 1,
      anon_sym_RPAREN,
    STATE(8340), 1,
      aux_sym_polymorphic_parameters_repeat2,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357545] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14582), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357560] = 4,
    ACTIONS(14584), 1,
      anon_sym_RBRACE,
    ACTIONS(14586), 1,
      anon_sym_COMMA,
    STATE(8186), 1,
      aux_sym_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357575] = 4,
    ACTIONS(7876), 1,
      anon_sym_LPAREN,
    ACTIONS(11416), 1,
      anon_sym_SLASH,
    ACTIONS(14588), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357590] = 2,
    ACTIONS(13709), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357600] = 3,
    ACTIONS(10425), 1,
      anon_sym_SEMI,
    ACTIONS(10427), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357612] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14592), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357624] = 3,
    ACTIONS(14574), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357636] = 3,
    ACTIONS(14578), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357648] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14594), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357660] = 3,
    ACTIONS(10407), 1,
      anon_sym_SEMI,
    ACTIONS(10409), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357672] = 3,
    ACTIONS(10249), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357684] = 3,
    ACTIONS(11277), 1,
      anon_sym_LPAREN,
    STATE(1411), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357696] = 2,
    ACTIONS(10411), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357706] = 2,
    ACTIONS(14546), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357716] = 3,
    ACTIONS(14598), 1,
      sym_identifier,
    ACTIONS(14600), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357728] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14602), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357740] = 3,
    ACTIONS(10403), 1,
      anon_sym_SEMI,
    ACTIONS(10405), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357752] = 3,
    ACTIONS(14508), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357764] = 3,
    ACTIONS(11261), 1,
      anon_sym_LPAREN,
    STATE(2931), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357776] = 3,
    ACTIONS(14432), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357788] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14604), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357800] = 3,
    ACTIONS(14480), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357812] = 3,
    ACTIONS(10301), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357824] = 3,
    ACTIONS(14464), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357836] = 3,
    ACTIONS(11279), 1,
      anon_sym_LPAREN,
    STATE(6587), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357848] = 3,
    ACTIONS(14606), 1,
      sym_identifier,
    ACTIONS(14608), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357860] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14610), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357872] = 3,
    ACTIONS(14447), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357884] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14612), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357896] = 3,
    ACTIONS(11279), 1,
      anon_sym_LPAREN,
    STATE(3435), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357908] = 3,
    ACTIONS(14436), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357920] = 3,
    ACTIONS(10197), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357932] = 3,
    ACTIONS(14426), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357944] = 3,
    ACTIONS(10393), 1,
      anon_sym_SEMI,
    ACTIONS(10395), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357956] = 3,
    ACTIONS(14392), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357968] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14614), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357980] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14616), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [357992] = 3,
    ACTIONS(10357), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358004] = 3,
    ACTIONS(10389), 1,
      anon_sym_SEMI,
    ACTIONS(10391), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358016] = 3,
    ACTIONS(14353), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358028] = 3,
    ACTIONS(14337), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358040] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14618), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358052] = 3,
    ACTIONS(11281), 1,
      anon_sym_LPAREN,
    STATE(6621), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358064] = 3,
    ACTIONS(11279), 1,
      anon_sym_LPAREN,
    STATE(6497), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358076] = 3,
    ACTIONS(10448), 1,
      anon_sym_SEMI,
    ACTIONS(10450), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358088] = 3,
    ACTIONS(14308), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358100] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14620), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358112] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14622), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358124] = 3,
    ACTIONS(10055), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358136] = 3,
    ACTIONS(14266), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358148] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14624), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358160] = 3,
    ACTIONS(14626), 1,
      sym_identifier,
    ACTIONS(14628), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358172] = 3,
    ACTIONS(14059), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358184] = 3,
    ACTIONS(14256), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358196] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14630), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358208] = 3,
    ACTIONS(10147), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358220] = 2,
    ACTIONS(14213), 2,
      anon_sym_LBRACE,
      sym_tag,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358230] = 3,
    ACTIONS(10337), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358242] = 2,
    ACTIONS(11525), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358252] = 2,
    ACTIONS(14632), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358262] = 3,
    ACTIONS(14207), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358274] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14634), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358286] = 3,
    ACTIONS(11293), 1,
      anon_sym_LPAREN,
    STATE(655), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358298] = 3,
    ACTIONS(14183), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358310] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14636), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358322] = 3,
    ACTIONS(14164), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358334] = 2,
    ACTIONS(11903), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358344] = 2,
    ACTIONS(14638), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358354] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14640), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358366] = 3,
    ACTIONS(14136), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358378] = 3,
    ACTIONS(10433), 1,
      anon_sym_SEMI,
    ACTIONS(10435), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358390] = 3,
    ACTIONS(10209), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358402] = 3,
    ACTIONS(14107), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358414] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14642), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358426] = 3,
    ACTIONS(10125), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358438] = 3,
    ACTIONS(14083), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358450] = 3,
    ACTIONS(10103), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358462] = 3,
    ACTIONS(14103), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358474] = 3,
    ACTIONS(10379), 1,
      anon_sym_SEMI,
    ACTIONS(10381), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358486] = 3,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(6675), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358498] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14644), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358510] = 2,
    ACTIONS(11515), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358520] = 2,
    ACTIONS(14646), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358530] = 3,
    ACTIONS(13714), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358542] = 2,
    ACTIONS(14315), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358552] = 3,
    ACTIONS(14648), 1,
      sym_identifier,
    ACTIONS(14650), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358564] = 3,
    ACTIONS(14019), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358576] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14652), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358588] = 3,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(2967), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358600] = 3,
    ACTIONS(14654), 1,
      sym_identifier,
    ACTIONS(14656), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358612] = 2,
    ACTIONS(11517), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358622] = 3,
    ACTIONS(13920), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358634] = 3,
    ACTIONS(11261), 1,
      anon_sym_LPAREN,
    STATE(6495), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358646] = 3,
    ACTIONS(14658), 1,
      sym_identifier,
    ACTIONS(14660), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358658] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14662), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358670] = 3,
    ACTIONS(11261), 1,
      anon_sym_LPAREN,
    STATE(6575), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358682] = 3,
    ACTIONS(9965), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358694] = 2,
    ACTIONS(13950), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358704] = 3,
    ACTIONS(14664), 1,
      sym_identifier,
    ACTIONS(14666), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358716] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14668), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358728] = 3,
    ACTIONS(12630), 1,
      anon_sym_LBRACE,
    ACTIONS(12632), 1,
      sym_tag,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358740] = 3,
    ACTIONS(10185), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358752] = 2,
    ACTIONS(11479), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358762] = 3,
    ACTIONS(13873), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358774] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14670), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358786] = 3,
    ACTIONS(13865), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358798] = 3,
    ACTIONS(10482), 1,
      anon_sym_SEMI,
    ACTIONS(10484), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358810] = 3,
    ACTIONS(10219), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358822] = 3,
    ACTIONS(13857), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358834] = 2,
    ACTIONS(12466), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358844] = 2,
    ACTIONS(13888), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358854] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14672), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358866] = 3,
    ACTIONS(10099), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358878] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14674), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358890] = 3,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(6507), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358902] = 3,
    ACTIONS(13796), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358914] = 2,
    ACTIONS(10452), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358924] = 3,
    ACTIONS(13841), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358936] = 3,
    ACTIONS(14676), 1,
      sym_identifier,
    ACTIONS(14678), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358948] = 2,
    ACTIONS(14680), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358958] = 3,
    ACTIONS(10215), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358970] = 2,
    ACTIONS(11446), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358980] = 3,
    ACTIONS(10476), 1,
      anon_sym_SEMI,
    ACTIONS(10478), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [358992] = 3,
    ACTIONS(14584), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359004] = 3,
    ACTIONS(14682), 1,
      sym_identifier,
    ACTIONS(14684), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359016] = 2,
    ACTIONS(14686), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359026] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14688), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359038] = 3,
    ACTIONS(14027), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359050] = 3,
    ACTIONS(13679), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359062] = 3,
    ACTIONS(14690), 1,
      sym_identifier,
    ACTIONS(14692), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359074] = 3,
    ACTIONS(12549), 1,
      anon_sym_RBRACE,
    ACTIONS(14694), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359086] = 3,
    ACTIONS(13683), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359098] = 3,
    ACTIONS(10454), 1,
      anon_sym_SEMI,
    ACTIONS(10464), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359110] = 3,
    ACTIONS(10470), 1,
      anon_sym_SEMI,
    ACTIONS(10472), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359122] = 3,
    ACTIONS(14696), 1,
      sym_identifier,
    ACTIONS(14698), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359134] = 4,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14700), 1,
      aux_sym_character_token1,
    ACTIONS(14702), 1,
      sym_escape_sequence,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [359148] = 3,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    ACTIONS(11497), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359160] = 3,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(2933), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359172] = 2,
    ACTIONS(14704), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359182] = 3,
    ACTIONS(13663), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359194] = 3,
    ACTIONS(7721), 1,
      anon_sym_LBRACE,
    ACTIONS(14706), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359206] = 3,
    ACTIONS(10486), 1,
      anon_sym_SEMI,
    ACTIONS(10488), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359218] = 2,
    ACTIONS(13614), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359228] = 2,
    ACTIONS(4862), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359238] = 3,
    ACTIONS(11281), 1,
      anon_sym_LPAREN,
    STATE(6632), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359250] = 3,
    ACTIONS(11293), 1,
      anon_sym_LPAREN,
    STATE(637), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359262] = 3,
    ACTIONS(11261), 1,
      anon_sym_LPAREN,
    STATE(3105), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359274] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14708), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359286] = 3,
    ACTIONS(13529), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359298] = 3,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(6643), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359310] = 3,
    ACTIONS(13517), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359322] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14710), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359334] = 3,
    ACTIONS(12589), 1,
      anon_sym_LBRACE,
    ACTIONS(12591), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359346] = 2,
    ACTIONS(8956), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359356] = 4,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14712), 1,
      aux_sym_character_token1,
    ACTIONS(14714), 1,
      sym_escape_sequence,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [359370] = 3,
    ACTIONS(10466), 1,
      anon_sym_SEMI,
    ACTIONS(10468), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359382] = 3,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(3976), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359394] = 3,
    ACTIONS(14716), 1,
      sym_identifier,
    ACTIONS(14718), 1,
      anon_sym_using,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359406] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14720), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359418] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14722), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359430] = 3,
    ACTIONS(10031), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359442] = 3,
    ACTIONS(14724), 1,
      sym_identifier,
    ACTIONS(14726), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359454] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14728), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359466] = 3,
    ACTIONS(13465), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359478] = 3,
    ACTIONS(13453), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359490] = 3,
    ACTIONS(11261), 1,
      anon_sym_LPAREN,
    STATE(6498), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359502] = 3,
    ACTIONS(12685), 1,
      anon_sym_LBRACE,
    ACTIONS(12687), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359514] = 4,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14730), 1,
      aux_sym_character_token1,
    ACTIONS(14732), 1,
      sym_escape_sequence,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [359528] = 3,
    ACTIONS(10055), 1,
      anon_sym_RBRACE,
    ACTIONS(14734), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359540] = 3,
    ACTIONS(14736), 1,
      sym_identifier,
    ACTIONS(14738), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359552] = 3,
    ACTIONS(10261), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359564] = 3,
    ACTIONS(10245), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359576] = 2,
    ACTIONS(12512), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359586] = 3,
    ACTIONS(13398), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359598] = 3,
    ACTIONS(10429), 1,
      anon_sym_SEMI,
    ACTIONS(10431), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359610] = 3,
    ACTIONS(12783), 1,
      anon_sym_LBRACE,
    ACTIONS(12785), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359622] = 3,
    ACTIONS(13161), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359634] = 3,
    ACTIONS(14740), 1,
      sym_identifier,
    ACTIONS(14742), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359646] = 3,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(6699), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359658] = 4,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14744), 1,
      aux_sym_character_token1,
    ACTIONS(14746), 1,
      sym_escape_sequence,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [359672] = 3,
    ACTIONS(13343), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359684] = 3,
    ACTIONS(11279), 1,
      anon_sym_LPAREN,
    STATE(3392), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359696] = 3,
    ACTIONS(10285), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359708] = 3,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    STATE(7014), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359720] = 3,
    ACTIONS(13264), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359732] = 2,
    ACTIONS(13256), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359742] = 3,
    ACTIONS(13258), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359754] = 3,
    ACTIONS(6835), 1,
      anon_sym_LBRACE,
    STATE(6944), 1,
      sym_block,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359766] = 3,
    ACTIONS(12713), 1,
      anon_sym_LBRACE,
    ACTIONS(12715), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359778] = 3,
    ACTIONS(11293), 1,
      anon_sym_LPAREN,
    STATE(570), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359790] = 4,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14748), 1,
      aux_sym_character_token1,
    ACTIONS(14750), 1,
      sym_escape_sequence,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [359804] = 3,
    ACTIONS(11279), 1,
      anon_sym_LPAREN,
    STATE(3275), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359816] = 3,
    ACTIONS(11281), 1,
      anon_sym_LPAREN,
    STATE(3820), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359828] = 3,
    ACTIONS(10458), 1,
      anon_sym_SEMI,
    ACTIONS(10460), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359840] = 3,
    ACTIONS(12488), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359852] = 3,
    ACTIONS(14752), 1,
      anon_sym_LBRACE,
    ACTIONS(14754), 1,
      sym_tag,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359864] = 3,
    ACTIONS(10421), 1,
      anon_sym_SEMI,
    ACTIONS(10423), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359876] = 3,
    ACTIONS(13181), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359888] = 4,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14756), 1,
      aux_sym_character_token1,
    ACTIONS(14758), 1,
      sym_escape_sequence,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [359902] = 3,
    ACTIONS(14760), 1,
      anon_sym_LBRACE,
    ACTIONS(14762), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359914] = 3,
    ACTIONS(12555), 1,
      anon_sym_LBRACE,
    ACTIONS(12557), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359926] = 4,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14764), 1,
      aux_sym_character_token1,
    ACTIONS(14766), 1,
      sym_escape_sequence,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [359940] = 3,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(6647), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359952] = 3,
    ACTIONS(14768), 1,
      sym_identifier,
    ACTIONS(14770), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359964] = 3,
    ACTIONS(12488), 1,
      anon_sym_RBRACE,
    ACTIONS(14772), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359976] = 3,
    ACTIONS(14774), 1,
      sym_identifier,
    ACTIONS(14776), 1,
      anon_sym_using,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [359988] = 3,
    ACTIONS(14778), 1,
      sym_identifier,
    ACTIONS(14780), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360000] = 2,
    ACTIONS(13095), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360010] = 3,
    ACTIONS(11277), 1,
      anon_sym_LPAREN,
    STATE(2333), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360022] = 4,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14782), 1,
      aux_sym_character_token1,
    ACTIONS(14784), 1,
      sym_escape_sequence,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [360036] = 3,
    ACTIONS(14786), 1,
      sym_identifier,
    ACTIONS(14788), 1,
      anon_sym_using,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360048] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14790), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360060] = 2,
    ACTIONS(13069), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360070] = 2,
    ACTIONS(11513), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360080] = 3,
    ACTIONS(12789), 1,
      anon_sym_LBRACE,
    ACTIONS(12791), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360092] = 4,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14792), 1,
      aux_sym_character_token1,
    ACTIONS(14794), 1,
      sym_escape_sequence,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [360106] = 3,
    ACTIONS(13047), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360118] = 3,
    ACTIONS(14796), 1,
      sym_identifier,
    ACTIONS(14798), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360130] = 3,
    ACTIONS(11277), 1,
      anon_sym_LPAREN,
    STATE(1549), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360142] = 3,
    ACTIONS(14800), 1,
      sym_identifier,
    ACTIONS(14802), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360154] = 3,
    ACTIONS(11261), 1,
      anon_sym_LPAREN,
    STATE(3140), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360166] = 4,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14804), 1,
      aux_sym_character_token1,
    ACTIONS(14806), 1,
      sym_escape_sequence,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [360180] = 3,
    ACTIONS(10039), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360192] = 3,
    ACTIONS(6341), 1,
      anon_sym_LBRACE,
    ACTIONS(14808), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360204] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14810), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360216] = 3,
    ACTIONS(9977), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360228] = 3,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(6541), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360240] = 3,
    ACTIONS(6726), 1,
      anon_sym_LBRACE,
    ACTIONS(14812), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360252] = 3,
    ACTIONS(14814), 1,
      sym_identifier,
    ACTIONS(14816), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360264] = 4,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14818), 1,
      aux_sym_character_token1,
    ACTIONS(14820), 1,
      sym_escape_sequence,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [360278] = 2,
    ACTIONS(14822), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360288] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14824), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360300] = 3,
    ACTIONS(12913), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360312] = 3,
    ACTIONS(12921), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360324] = 2,
    ACTIONS(11523), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360334] = 3,
    ACTIONS(12917), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360346] = 3,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(6654), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360358] = 3,
    ACTIONS(8083), 1,
      anon_sym_LBRACE,
    ACTIONS(14826), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360370] = 4,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14828), 1,
      aux_sym_character_token1,
    ACTIONS(14830), 1,
      sym_escape_sequence,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [360384] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14832), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360396] = 3,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(14834), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360408] = 3,
    ACTIONS(12843), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360420] = 3,
    ACTIONS(14836), 1,
      sym_identifier,
    ACTIONS(14838), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360432] = 3,
    ACTIONS(9953), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360444] = 3,
    ACTIONS(13143), 1,
      anon_sym_RBRACE,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360456] = 3,
    ACTIONS(11275), 1,
      anon_sym_LPAREN,
    STATE(2943), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360468] = 3,
    ACTIONS(12829), 1,
      anon_sym_RBRACE,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360480] = 3,
    ACTIONS(14840), 1,
      anon_sym_LBRACE,
    ACTIONS(14842), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360492] = 4,
    ACTIONS(12416), 1,
      sym_comment,
    ACTIONS(14844), 1,
      aux_sym_character_token1,
    ACTIONS(14846), 1,
      sym_escape_sequence,
    ACTIONS(3), 2,
      sym__backslash,
      sym_block_comment,
  [360506] = 3,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(14848), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360518] = 2,
    ACTIONS(3917), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360527] = 2,
    ACTIONS(14850), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360536] = 2,
    ACTIONS(14852), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360545] = 2,
    ACTIONS(14854), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360554] = 2,
    ACTIONS(14856), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360563] = 2,
    ACTIONS(14858), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360572] = 2,
    ACTIONS(14860), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360581] = 2,
    ACTIONS(14862), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360590] = 2,
    ACTIONS(10836), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360599] = 2,
    ACTIONS(10880), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360608] = 2,
    ACTIONS(14864), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360617] = 2,
    ACTIONS(14866), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360626] = 2,
    ACTIONS(14868), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360635] = 2,
    ACTIONS(14870), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360644] = 2,
    ACTIONS(14872), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360653] = 2,
    ACTIONS(14874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360662] = 2,
    ACTIONS(9407), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360671] = 2,
    ACTIONS(14876), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360680] = 2,
    ACTIONS(10964), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360689] = 2,
    ACTIONS(14878), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360698] = 2,
    ACTIONS(9573), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360707] = 2,
    ACTIONS(14880), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360716] = 2,
    ACTIONS(14882), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360725] = 2,
    ACTIONS(14884), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360734] = 2,
    ACTIONS(14886), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360743] = 2,
    ACTIONS(14888), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360752] = 2,
    ACTIONS(14890), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360761] = 2,
    ACTIONS(10784), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360770] = 2,
    ACTIONS(14892), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360779] = 2,
    ACTIONS(14894), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360788] = 2,
    ACTIONS(10534), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360797] = 2,
    ACTIONS(14896), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360806] = 2,
    ACTIONS(14898), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360815] = 2,
    ACTIONS(10980), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360824] = 2,
    ACTIONS(4137), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360833] = 2,
    ACTIONS(10936), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360842] = 2,
    ACTIONS(14900), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360851] = 2,
    ACTIONS(14902), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360860] = 2,
    ACTIONS(14904), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360869] = 2,
    ACTIONS(9584), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360878] = 2,
    ACTIONS(14906), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360887] = 2,
    ACTIONS(14908), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360896] = 2,
    ACTIONS(3735), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360905] = 2,
    ACTIONS(14910), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360914] = 2,
    ACTIONS(14912), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360923] = 2,
    ACTIONS(14914), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360932] = 2,
    ACTIONS(14916), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360941] = 2,
    ACTIONS(14918), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360950] = 2,
    ACTIONS(14920), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360959] = 2,
    ACTIONS(14922), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360968] = 2,
    ACTIONS(14924), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360977] = 2,
    ACTIONS(10988), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360986] = 2,
    ACTIONS(8330), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [360995] = 2,
    ACTIONS(14926), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361004] = 2,
    ACTIONS(9542), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361013] = 2,
    ACTIONS(9536), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361022] = 2,
    ACTIONS(14928), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361031] = 2,
    ACTIONS(9621), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361040] = 2,
    ACTIONS(9525), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361049] = 2,
    ACTIONS(14930), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361058] = 2,
    ACTIONS(10860), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361067] = 2,
    ACTIONS(10864), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361076] = 2,
    ACTIONS(14932), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361085] = 2,
    ACTIONS(14934), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361094] = 2,
    ACTIONS(14936), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361103] = 2,
    ACTIONS(14938), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361112] = 2,
    ACTIONS(9623), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361121] = 2,
    ACTIONS(9515), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361130] = 2,
    ACTIONS(9627), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361139] = 2,
    ACTIONS(9592), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361148] = 2,
    ACTIONS(10986), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361157] = 2,
    ACTIONS(9629), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361166] = 2,
    ACTIONS(9638), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361175] = 2,
    ACTIONS(14940), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361184] = 2,
    ACTIONS(9640), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361193] = 2,
    ACTIONS(12210), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361202] = 2,
    ACTIONS(4259), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361211] = 2,
    ACTIONS(9654), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361220] = 2,
    ACTIONS(14942), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361229] = 2,
    ACTIONS(9609), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361238] = 2,
    ACTIONS(9656), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361247] = 2,
    ACTIONS(14944), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361256] = 2,
    ACTIONS(14946), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361265] = 2,
    ACTIONS(14948), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361274] = 2,
    ACTIONS(14950), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361283] = 2,
    ACTIONS(9665), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361292] = 2,
    ACTIONS(9596), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361301] = 2,
    ACTIONS(10764), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361310] = 2,
    ACTIONS(9667), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361319] = 2,
    ACTIONS(10828), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361328] = 2,
    ACTIONS(9499), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361337] = 2,
    ACTIONS(14952), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361346] = 2,
    ACTIONS(14954), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361355] = 2,
    ACTIONS(9669), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361364] = 2,
    ACTIONS(14956), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361373] = 2,
    ACTIONS(10710), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361382] = 2,
    ACTIONS(4411), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361391] = 2,
    ACTIONS(14958), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361400] = 2,
    ACTIONS(4502), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361409] = 2,
    ACTIONS(14960), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361418] = 2,
    ACTIONS(14962), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361427] = 2,
    ACTIONS(14964), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361436] = 2,
    ACTIONS(14966), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361445] = 2,
    ACTIONS(14968), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361454] = 2,
    ACTIONS(9479), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361463] = 2,
    ACTIONS(9475), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361472] = 2,
    ACTIONS(14970), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361481] = 2,
    ACTIONS(9674), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361490] = 2,
    ACTIONS(10948), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361499] = 2,
    ACTIONS(9469), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361508] = 2,
    ACTIONS(14972), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361517] = 2,
    ACTIONS(9461), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361526] = 2,
    ACTIONS(10498), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361535] = 2,
    ACTIONS(14974), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361544] = 2,
    ACTIONS(9451), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361553] = 2,
    ACTIONS(14976), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361562] = 2,
    ACTIONS(14978), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361571] = 2,
    ACTIONS(9443), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361580] = 2,
    ACTIONS(12601), 1,
      anon_sym_if,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361589] = 2,
    ACTIONS(14980), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361598] = 2,
    ACTIONS(14982), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361607] = 2,
    ACTIONS(14984), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361616] = 2,
    ACTIONS(14986), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361625] = 2,
    ACTIONS(3685), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361634] = 2,
    ACTIONS(14988), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361643] = 2,
    ACTIONS(14990), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361652] = 2,
    ACTIONS(14992), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361661] = 2,
    ACTIONS(10850), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361670] = 2,
    ACTIONS(9433), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361679] = 2,
    ACTIONS(14994), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361688] = 2,
    ACTIONS(14996), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361697] = 2,
    ACTIONS(9427), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361706] = 2,
    ACTIONS(9423), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361715] = 2,
    ACTIONS(10624), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361724] = 2,
    ACTIONS(14998), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361733] = 2,
    ACTIONS(15000), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361742] = 2,
    ACTIONS(9413), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361751] = 2,
    ACTIONS(15002), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361760] = 2,
    ACTIONS(15004), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361769] = 2,
    ACTIONS(15006), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361778] = 2,
    ACTIONS(15008), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361787] = 2,
    ACTIONS(15010), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361796] = 2,
    ACTIONS(15012), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361805] = 2,
    ACTIONS(9689), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361814] = 2,
    ACTIONS(3565), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361823] = 2,
    ACTIONS(15014), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361832] = 2,
    ACTIONS(10928), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361841] = 2,
    ACTIONS(3937), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361850] = 2,
    ACTIONS(15016), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361859] = 2,
    ACTIONS(4057), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361868] = 2,
    ACTIONS(9395), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361877] = 2,
    ACTIONS(15018), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361886] = 2,
    ACTIONS(9604), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361895] = 2,
    ACTIONS(9391), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361904] = 2,
    ACTIONS(15020), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361913] = 2,
    ACTIONS(15022), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361922] = 2,
    ACTIONS(15024), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361931] = 2,
    ACTIONS(15026), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361940] = 2,
    ACTIONS(15028), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361949] = 2,
    ACTIONS(15030), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361958] = 2,
    ACTIONS(9658), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361967] = 2,
    ACTIONS(10908), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361976] = 2,
    ACTIONS(15032), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361985] = 2,
    ACTIONS(9701), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [361994] = 2,
    ACTIONS(15034), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362003] = 2,
    ACTIONS(9393), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362012] = 2,
    ACTIONS(15036), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362021] = 2,
    ACTIONS(9713), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362030] = 2,
    ACTIONS(15038), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362039] = 2,
    ACTIONS(15040), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362048] = 2,
    ACTIONS(15042), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362057] = 2,
    ACTIONS(15044), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362066] = 2,
    ACTIONS(10654), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362075] = 2,
    ACTIONS(10892), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362084] = 2,
    ACTIONS(15046), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362093] = 2,
    ACTIONS(15048), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362102] = 2,
    ACTIONS(9703), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362111] = 2,
    ACTIONS(3455), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362120] = 2,
    ACTIONS(15050), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362129] = 2,
    ACTIONS(15052), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362138] = 2,
    ACTIONS(15054), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362147] = 2,
    ACTIONS(15056), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362156] = 2,
    ACTIONS(15058), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362165] = 2,
    ACTIONS(10806), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362174] = 2,
    ACTIONS(15060), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362183] = 2,
    ACTIONS(9399), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362192] = 2,
    ACTIONS(9687), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362201] = 2,
    ACTIONS(9403), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362210] = 2,
    ACTIONS(15062), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362219] = 2,
    ACTIONS(15064), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362228] = 2,
    ACTIONS(15066), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362237] = 2,
    ACTIONS(15068), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362246] = 2,
    ACTIONS(15070), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362255] = 2,
    ACTIONS(10786), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362264] = 2,
    ACTIONS(9405), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362273] = 2,
    ACTIONS(10598), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362282] = 2,
    ACTIONS(10596), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362291] = 2,
    ACTIONS(9682), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362300] = 2,
    ACTIONS(15072), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362309] = 2,
    ACTIONS(10772), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362318] = 2,
    ACTIONS(9409), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362327] = 2,
    ACTIONS(11552), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362336] = 2,
    ACTIONS(15074), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362345] = 2,
    ACTIONS(10766), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362354] = 2,
    ACTIONS(9493), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362363] = 2,
    ACTIONS(15076), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362372] = 2,
    ACTIONS(15078), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362381] = 2,
    ACTIONS(10756), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362390] = 2,
    ACTIONS(15080), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362399] = 2,
    ACTIONS(15082), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362408] = 2,
    ACTIONS(15084), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362417] = 2,
    ACTIONS(10738), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362426] = 2,
    ACTIONS(15086), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362435] = 2,
    ACTIONS(3505), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362444] = 2,
    ACTIONS(15088), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362453] = 2,
    ACTIONS(10750), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362462] = 2,
    ACTIONS(9415), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362471] = 2,
    ACTIONS(9417), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362480] = 2,
    ACTIONS(15090), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362489] = 2,
    ACTIONS(10748), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362498] = 2,
    ACTIONS(9419), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362507] = 2,
    ACTIONS(9425), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362516] = 2,
    ACTIONS(15092), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362525] = 2,
    ACTIONS(10742), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362534] = 2,
    ACTIONS(3545), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362543] = 2,
    ACTIONS(9633), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362552] = 2,
    ACTIONS(15094), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362561] = 2,
    ACTIONS(10730), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362570] = 2,
    ACTIONS(3907), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362579] = 2,
    ACTIONS(9429), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362588] = 2,
    ACTIONS(15096), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362597] = 2,
    ACTIONS(10726), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362606] = 2,
    ACTIONS(9650), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362615] = 2,
    ACTIONS(15098), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362624] = 2,
    ACTIONS(10714), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362633] = 2,
    ACTIONS(9431), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362642] = 2,
    ACTIONS(15100), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362651] = 2,
    ACTIONS(10716), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362660] = 2,
    ACTIONS(9435), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362669] = 2,
    ACTIONS(15102), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362678] = 2,
    ACTIONS(10712), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362687] = 2,
    ACTIONS(9437), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362696] = 2,
    ACTIONS(15104), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362705] = 2,
    ACTIONS(3615), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362714] = 2,
    ACTIONS(15106), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362723] = 2,
    ACTIONS(9439), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362732] = 2,
    ACTIONS(10706), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362741] = 2,
    ACTIONS(10700), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362750] = 2,
    ACTIONS(9441), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362759] = 2,
    ACTIONS(9642), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362768] = 2,
    ACTIONS(15108), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362777] = 2,
    ACTIONS(9445), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362786] = 2,
    ACTIONS(15110), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362795] = 2,
    ACTIONS(15112), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362804] = 2,
    ACTIONS(9447), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362813] = 2,
    ACTIONS(3465), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362822] = 2,
    ACTIONS(9459), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362831] = 2,
    ACTIONS(9465), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362840] = 2,
    ACTIONS(15114), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362849] = 2,
    ACTIONS(9467), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362858] = 2,
    ACTIONS(10550), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362867] = 2,
    ACTIONS(15116), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362876] = 2,
    ACTIONS(9652), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362885] = 2,
    ACTIONS(9471), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362894] = 2,
    ACTIONS(14590), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362903] = 2,
    ACTIONS(15118), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362912] = 2,
    ACTIONS(3725), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362921] = 2,
    ACTIONS(15120), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362930] = 2,
    ACTIONS(15122), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362939] = 2,
    ACTIONS(15124), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362948] = 2,
    ACTIONS(10606), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362957] = 2,
    ACTIONS(9473), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362966] = 2,
    ACTIONS(9477), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362975] = 2,
    ACTIONS(15126), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362984] = 2,
    ACTIONS(9483), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [362993] = 2,
    ACTIONS(3845), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363002] = 2,
    ACTIONS(9485), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363011] = 2,
    ACTIONS(15128), 1,
      anon_sym_enum,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363020] = 2,
    ACTIONS(15130), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363029] = 2,
    ACTIONS(3765), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363038] = 2,
    ACTIONS(9489), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363047] = 2,
    ACTIONS(9491), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363056] = 2,
    ACTIONS(15132), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363065] = 2,
    ACTIONS(15134), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363074] = 2,
    ACTIONS(15136), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363083] = 2,
    ACTIONS(15138), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363092] = 2,
    ACTIONS(10568), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363101] = 2,
    ACTIONS(15140), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363110] = 2,
    ACTIONS(15142), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363119] = 2,
    ACTIONS(9495), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363128] = 2,
    ACTIONS(15144), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363137] = 2,
    ACTIONS(11618), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363146] = 2,
    ACTIONS(15146), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363155] = 2,
    ACTIONS(3825), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363164] = 2,
    ACTIONS(12630), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363173] = 2,
    ACTIONS(15148), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363182] = 2,
    ACTIONS(9497), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363191] = 2,
    ACTIONS(15150), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363200] = 2,
    ACTIONS(9501), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363209] = 2,
    ACTIONS(9508), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363218] = 2,
    ACTIONS(9513), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363227] = 2,
    ACTIONS(4311), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363236] = 2,
    ACTIONS(15152), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363245] = 2,
    ACTIONS(9517), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363254] = 2,
    ACTIONS(10514), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363263] = 2,
    ACTIONS(15154), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363272] = 2,
    ACTIONS(3655), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363281] = 2,
    ACTIONS(9519), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363290] = 2,
    ACTIONS(15156), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363299] = 2,
    ACTIONS(9521), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363308] = 2,
    ACTIONS(9523), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363317] = 2,
    ACTIONS(15158), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363326] = 2,
    ACTIONS(15160), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363335] = 2,
    ACTIONS(15162), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363344] = 2,
    ACTIONS(9527), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363353] = 2,
    ACTIONS(9401), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363362] = 2,
    ACTIONS(9529), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363371] = 2,
    ACTIONS(15164), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363380] = 2,
    ACTIONS(15166), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363389] = 2,
    ACTIONS(15168), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363398] = 2,
    ACTIONS(3885), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363407] = 2,
    ACTIONS(15170), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363416] = 2,
    ACTIONS(9538), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363425] = 2,
    ACTIONS(15172), 1,
      anon_sym_enum,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363434] = 2,
    ACTIONS(15174), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363443] = 2,
    ACTIONS(9540), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363452] = 2,
    ACTIONS(9546), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363461] = 2,
    ACTIONS(9552), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363470] = 2,
    ACTIONS(15176), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363479] = 2,
    ACTIONS(3967), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363488] = 2,
    ACTIONS(9559), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363497] = 2,
    ACTIONS(15178), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363506] = 2,
    ACTIONS(9563), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363515] = 2,
    ACTIONS(9565), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363524] = 2,
    ACTIONS(15180), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363533] = 2,
    ACTIONS(11414), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363542] = 2,
    ACTIONS(9569), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363551] = 2,
    ACTIONS(4007), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363560] = 2,
    ACTIONS(15182), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363569] = 2,
    ACTIONS(9571), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363578] = 2,
    ACTIONS(9575), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363587] = 2,
    ACTIONS(9582), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363596] = 2,
    ACTIONS(9586), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363605] = 2,
    ACTIONS(12502), 1,
      anon_sym_when,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363614] = 2,
    ACTIONS(9705), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363623] = 2,
    ACTIONS(4097), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363632] = 2,
    ACTIONS(15184), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363641] = 2,
    ACTIONS(15186), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363650] = 2,
    ACTIONS(10556), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363659] = 2,
    ACTIONS(9561), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363668] = 2,
    ACTIONS(9588), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363677] = 2,
    ACTIONS(15188), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363686] = 2,
    ACTIONS(9715), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363695] = 2,
    ACTIONS(9717), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363704] = 2,
    ACTIONS(9594), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363713] = 2,
    ACTIONS(9598), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363722] = 2,
    ACTIONS(9602), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363731] = 2,
    ACTIONS(15190), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363740] = 2,
    ACTIONS(15192), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363749] = 2,
    ACTIONS(15194), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363758] = 2,
    ACTIONS(9386), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363767] = 2,
    ACTIONS(15196), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363776] = 2,
    ACTIONS(15198), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363785] = 2,
    ACTIONS(15200), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363794] = 2,
    ACTIONS(9697), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363803] = 2,
    ACTIONS(9693), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363812] = 2,
    ACTIONS(9421), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363821] = 2,
    ACTIONS(9611), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363830] = 2,
    ACTIONS(15202), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363839] = 2,
    ACTIONS(15204), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363848] = 2,
    ACTIONS(15206), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363857] = 2,
    ACTIONS(15208), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363866] = 2,
    ACTIONS(15210), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363875] = 2,
    ACTIONS(15212), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363884] = 2,
    ACTIONS(15214), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363893] = 2,
    ACTIONS(10532), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363902] = 2,
    ACTIONS(14596), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363911] = 2,
    ACTIONS(9695), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363920] = 2,
    ACTIONS(15216), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363929] = 2,
    ACTIONS(15218), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363938] = 2,
    ACTIONS(15220), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363947] = 2,
    ACTIONS(15222), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363956] = 2,
    ACTIONS(15224), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363965] = 2,
    ACTIONS(4484), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363974] = 2,
    ACTIONS(8456), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363983] = 2,
    ACTIONS(15226), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [363992] = 2,
    ACTIONS(15228), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364001] = 2,
    ACTIONS(10516), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364010] = 2,
    ACTIONS(15230), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364019] = 2,
    ACTIONS(15232), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364028] = 2,
    ACTIONS(15234), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364037] = 2,
    ACTIONS(15236), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364046] = 2,
    ACTIONS(15238), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364055] = 2,
    ACTIONS(3987), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364064] = 2,
    ACTIONS(15240), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364073] = 2,
    ACTIONS(9663), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364082] = 2,
    ACTIONS(15242), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364091] = 2,
    ACTIONS(15244), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364100] = 2,
    ACTIONS(15246), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364109] = 2,
    ACTIONS(10510), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364118] = 2,
    ACTIONS(15248), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364127] = 2,
    ACTIONS(12182), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364136] = 2,
    ACTIONS(11581), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364145] = 2,
    ACTIONS(15250), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364154] = 2,
    ACTIONS(10518), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364163] = 2,
    ACTIONS(15252), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364172] = 2,
    ACTIONS(15254), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364181] = 2,
    ACTIONS(15256), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364190] = 2,
    ACTIONS(13563), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364199] = 2,
    ACTIONS(15258), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364208] = 2,
    ACTIONS(9397), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364217] = 2,
    ACTIONS(10502), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364226] = 2,
    ACTIONS(15260), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364235] = 2,
    ACTIONS(15262), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364244] = 2,
    ACTIONS(15264), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364253] = 2,
    ACTIONS(15266), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364262] = 2,
    ACTIONS(15268), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364271] = 2,
    ACTIONS(13543), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364280] = 2,
    ACTIONS(15270), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364289] = 2,
    ACTIONS(15272), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364298] = 2,
    ACTIONS(15274), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364307] = 2,
    ACTIONS(15276), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364316] = 2,
    ACTIONS(15278), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364325] = 2,
    ACTIONS(10530), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364334] = 2,
    ACTIONS(15280), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364343] = 2,
    ACTIONS(9619), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364352] = 2,
    ACTIONS(10640), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364361] = 2,
    ACTIONS(15282), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364370] = 2,
    ACTIONS(15284), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364379] = 2,
    ACTIONS(4367), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364388] = 2,
    ACTIONS(15286), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364397] = 2,
    ACTIONS(15288), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364406] = 2,
    ACTIONS(13479), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364415] = 2,
    ACTIONS(15290), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364424] = 2,
    ACTIONS(15292), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364433] = 2,
    ACTIONS(10552), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364442] = 2,
    ACTIONS(13459), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364451] = 2,
    ACTIONS(15294), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364460] = 2,
    ACTIONS(15296), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364469] = 2,
    ACTIONS(15298), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364478] = 2,
    ACTIONS(10558), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364487] = 2,
    ACTIONS(15300), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364496] = 2,
    ACTIONS(15302), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364505] = 2,
    ACTIONS(15304), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364514] = 2,
    ACTIONS(15306), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364523] = 2,
    ACTIONS(10560), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364532] = 2,
    ACTIONS(10670), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364541] = 2,
    ACTIONS(9411), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364550] = 2,
    ACTIONS(13396), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364559] = 2,
    ACTIONS(15308), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364568] = 2,
    ACTIONS(15310), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364577] = 2,
    ACTIONS(15312), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364586] = 2,
    ACTIONS(13367), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364595] = 2,
    ACTIONS(15314), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364604] = 2,
    ACTIONS(15316), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364613] = 2,
    ACTIONS(10580), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364622] = 2,
    ACTIONS(15318), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364631] = 2,
    ACTIONS(15320), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364640] = 2,
    ACTIONS(9449), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364649] = 2,
    ACTIONS(15322), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364658] = 2,
    ACTIONS(9676), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364667] = 2,
    ACTIONS(15324), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364676] = 2,
    ACTIONS(9463), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364685] = 2,
    ACTIONS(15326), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364694] = 2,
    ACTIONS(10720), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364703] = 2,
    ACTIONS(10588), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364712] = 2,
    ACTIONS(15328), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364721] = 2,
    ACTIONS(15330), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364730] = 2,
    ACTIONS(10746), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364739] = 2,
    ACTIONS(15332), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364748] = 2,
    ACTIONS(9678), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364757] = 2,
    ACTIONS(13294), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364766] = 2,
    ACTIONS(15334), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364775] = 2,
    ACTIONS(15336), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364784] = 2,
    ACTIONS(15338), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364793] = 2,
    ACTIONS(10620), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364802] = 2,
    ACTIONS(10634), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364811] = 2,
    ACTIONS(15340), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364820] = 2,
    ACTIONS(9554), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364829] = 2,
    ACTIONS(15342), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364838] = 2,
    ACTIONS(10774), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364847] = 2,
    ACTIONS(13268), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364856] = 2,
    ACTIONS(15344), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364865] = 2,
    ACTIONS(15346), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364874] = 2,
    ACTIONS(15348), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364883] = 2,
    ACTIONS(10648), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364892] = 2,
    ACTIONS(15350), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364901] = 2,
    ACTIONS(10642), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364910] = 2,
    ACTIONS(15352), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364919] = 2,
    ACTIONS(15354), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364928] = 2,
    ACTIONS(15356), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364937] = 2,
    ACTIONS(10792), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364946] = 2,
    ACTIONS(15358), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364955] = 2,
    ACTIONS(15360), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364964] = 2,
    ACTIONS(15362), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364973] = 2,
    ACTIONS(9534), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364982] = 2,
    ACTIONS(9544), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [364991] = 2,
    ACTIONS(15364), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365000] = 2,
    ACTIONS(15366), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365009] = 2,
    ACTIONS(15368), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365018] = 2,
    ACTIONS(9503), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365027] = 2,
    ACTIONS(12390), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365036] = 2,
    ACTIONS(15370), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365045] = 2,
    ACTIONS(10790), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365054] = 2,
    ACTIONS(9691), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365063] = 2,
    ACTIONS(15372), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365072] = 2,
    ACTIONS(13195), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365081] = 2,
    ACTIONS(14752), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365090] = 2,
    ACTIONS(15374), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365099] = 2,
    ACTIONS(15376), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365108] = 2,
    ACTIONS(15378), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365117] = 2,
    ACTIONS(15380), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365126] = 2,
    ACTIONS(15382), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365135] = 2,
    ACTIONS(15384), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365144] = 2,
    ACTIONS(15386), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365153] = 2,
    ACTIONS(15388), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365162] = 2,
    ACTIONS(15390), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365171] = 2,
    ACTIONS(15392), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365180] = 2,
    ACTIONS(15394), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365189] = 2,
    ACTIONS(15396), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365198] = 2,
    ACTIONS(9487), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365207] = 2,
    ACTIONS(15398), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365216] = 2,
    ACTIONS(15400), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365225] = 2,
    ACTIONS(15402), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365234] = 2,
    ACTIONS(15404), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365243] = 2,
    ACTIONS(10804), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365252] = 2,
    ACTIONS(13173), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365261] = 2,
    ACTIONS(15406), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365270] = 2,
    ACTIONS(10810), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365279] = 2,
    ACTIONS(15408), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365288] = 2,
    ACTIONS(9481), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365297] = 2,
    ACTIONS(15410), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365306] = 2,
    ACTIONS(15412), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365315] = 2,
    ACTIONS(9590), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365324] = 2,
    ACTIONS(15414), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365333] = 2,
    ACTIONS(15416), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365342] = 2,
    ACTIONS(15418), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365351] = 2,
    ACTIONS(15420), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365360] = 2,
    ACTIONS(15422), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365369] = 2,
    ACTIONS(15424), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365378] = 2,
    ACTIONS(15426), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365387] = 2,
    ACTIONS(15428), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365396] = 2,
    ACTIONS(13076), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365405] = 2,
    ACTIONS(15430), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365414] = 2,
    ACTIONS(15432), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365423] = 2,
    ACTIONS(15434), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365432] = 2,
    ACTIONS(15436), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365441] = 2,
    ACTIONS(4245), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365450] = 2,
    ACTIONS(15438), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365459] = 2,
    ACTIONS(15440), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365468] = 2,
    ACTIONS(15442), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365477] = 2,
    ACTIONS(15444), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365486] = 2,
    ACTIONS(15446), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365495] = 2,
    ACTIONS(13141), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365504] = 2,
    ACTIONS(15448), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365513] = 2,
    ACTIONS(15450), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365522] = 2,
    ACTIONS(15452), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365531] = 2,
    ACTIONS(9699), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365540] = 2,
    ACTIONS(13101), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365549] = 2,
    ACTIONS(15454), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365558] = 2,
    ACTIONS(15456), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365567] = 2,
    ACTIONS(15458), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365576] = 2,
    ACTIONS(15460), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365585] = 2,
    ACTIONS(15462), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365594] = 2,
    ACTIONS(15464), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365603] = 2,
    ACTIONS(15466), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365612] = 2,
    ACTIONS(15468), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365621] = 2,
    ACTIONS(15470), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365630] = 2,
    ACTIONS(15472), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365639] = 2,
    ACTIONS(15474), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365648] = 2,
    ACTIONS(15476), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365657] = 2,
    ACTIONS(15478), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365666] = 2,
    ACTIONS(15480), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365675] = 2,
    ACTIONS(15482), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365684] = 2,
    ACTIONS(15484), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365693] = 2,
    ACTIONS(15486), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365702] = 2,
    ACTIONS(15488), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365711] = 2,
    ACTIONS(15490), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365720] = 2,
    ACTIONS(15492), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365729] = 2,
    ACTIONS(15494), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365738] = 2,
    ACTIONS(15496), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365747] = 2,
    ACTIONS(15498), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365756] = 2,
    ACTIONS(15500), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365765] = 2,
    ACTIONS(15502), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365774] = 2,
    ACTIONS(15504), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365783] = 2,
    ACTIONS(15506), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365792] = 2,
    ACTIONS(15508), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365801] = 2,
    ACTIONS(15510), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365810] = 2,
    ACTIONS(15512), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365819] = 2,
    ACTIONS(15514), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365828] = 2,
    ACTIONS(13119), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365837] = 2,
    ACTIONS(10994), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365846] = 2,
    ACTIONS(15516), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365855] = 2,
    ACTIONS(15518), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365864] = 2,
    ACTIONS(15520), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365873] = 2,
    ACTIONS(15522), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365882] = 2,
    ACTIONS(15524), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365891] = 2,
    ACTIONS(15526), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365900] = 2,
    ACTIONS(15528), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365909] = 2,
    ACTIONS(15530), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365918] = 2,
    ACTIONS(9360), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365927] = 2,
    ACTIONS(15532), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365936] = 2,
    ACTIONS(15534), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365945] = 2,
    ACTIONS(15536), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365954] = 2,
    ACTIONS(15538), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365963] = 2,
    ACTIONS(15540), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365972] = 2,
    ACTIONS(15542), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365981] = 2,
    ACTIONS(15544), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365990] = 2,
    ACTIONS(15546), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [365999] = 2,
    ACTIONS(15548), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366008] = 2,
    ACTIONS(15550), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366017] = 2,
    ACTIONS(15552), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366026] = 2,
    ACTIONS(15554), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366035] = 2,
    ACTIONS(15556), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366044] = 2,
    ACTIONS(15558), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366053] = 2,
    ACTIONS(15560), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366062] = 2,
    ACTIONS(15562), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366071] = 2,
    ACTIONS(15564), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366080] = 2,
    ACTIONS(15566), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366089] = 2,
    ACTIONS(15568), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366098] = 2,
    ACTIONS(15570), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366107] = 2,
    ACTIONS(15572), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366116] = 2,
    ACTIONS(15574), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366125] = 2,
    ACTIONS(15576), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366134] = 2,
    ACTIONS(4357), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366143] = 2,
    ACTIONS(15578), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366152] = 2,
    ACTIONS(15580), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366161] = 2,
    ACTIONS(15582), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366170] = 2,
    ACTIONS(10924), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366179] = 2,
    ACTIONS(9625), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366188] = 2,
    ACTIONS(13005), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366197] = 2,
    ACTIONS(10930), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366206] = 2,
    ACTIONS(15584), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366215] = 2,
    ACTIONS(12985), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366224] = 2,
    ACTIONS(15586), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366233] = 2,
    ACTIONS(15588), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366242] = 2,
    ACTIONS(15590), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366251] = 2,
    ACTIONS(15592), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366260] = 2,
    ACTIONS(15594), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366269] = 2,
    ACTIONS(15596), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366278] = 2,
    ACTIONS(15598), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366287] = 2,
    ACTIONS(15600), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366296] = 2,
    ACTIONS(10798), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366305] = 2,
    ACTIONS(15602), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366314] = 2,
    ACTIONS(12955), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366323] = 2,
    ACTIONS(6590), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366332] = 2,
    ACTIONS(15604), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366341] = 2,
    ACTIONS(15606), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366350] = 2,
    ACTIONS(15608), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366359] = 2,
    ACTIONS(15610), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366368] = 2,
    ACTIONS(12909), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366377] = 2,
    ACTIONS(15612), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366386] = 2,
    ACTIONS(15614), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366395] = 2,
    ACTIONS(15616), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366404] = 2,
    ACTIONS(8197), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366413] = 2,
    ACTIONS(15618), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366422] = 2,
    ACTIONS(15620), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366431] = 2,
    ACTIONS(15622), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366440] = 2,
    ACTIONS(15624), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366449] = 2,
    ACTIONS(15626), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366458] = 2,
    ACTIONS(15628), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366467] = 2,
    ACTIONS(12853), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366476] = 2,
    ACTIONS(15630), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366485] = 2,
    ACTIONS(12839), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366494] = 2,
    ACTIONS(15632), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366503] = 2,
    ACTIONS(15634), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366512] = 2,
    ACTIONS(15636), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
  [366521] = 2,
    ACTIONS(15638), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym__backslash,
      sym_block_comment,
      sym_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2186)] = 0,
  [SMALL_STATE(2187)] = 131,
  [SMALL_STATE(2188)] = 202,
  [SMALL_STATE(2189)] = 273,
  [SMALL_STATE(2190)] = 344,
  [SMALL_STATE(2191)] = 415,
  [SMALL_STATE(2192)] = 486,
  [SMALL_STATE(2193)] = 557,
  [SMALL_STATE(2194)] = 628,
  [SMALL_STATE(2195)] = 705,
  [SMALL_STATE(2196)] = 776,
  [SMALL_STATE(2197)] = 855,
  [SMALL_STATE(2198)] = 926,
  [SMALL_STATE(2199)] = 997,
  [SMALL_STATE(2200)] = 1068,
  [SMALL_STATE(2201)] = 1139,
  [SMALL_STATE(2202)] = 1210,
  [SMALL_STATE(2203)] = 1281,
  [SMALL_STATE(2204)] = 1352,
  [SMALL_STATE(2205)] = 1423,
  [SMALL_STATE(2206)] = 1494,
  [SMALL_STATE(2207)] = 1565,
  [SMALL_STATE(2208)] = 1636,
  [SMALL_STATE(2209)] = 1707,
  [SMALL_STATE(2210)] = 1778,
  [SMALL_STATE(2211)] = 1849,
  [SMALL_STATE(2212)] = 1920,
  [SMALL_STATE(2213)] = 1991,
  [SMALL_STATE(2214)] = 2062,
  [SMALL_STATE(2215)] = 2133,
  [SMALL_STATE(2216)] = 2208,
  [SMALL_STATE(2217)] = 2279,
  [SMALL_STATE(2218)] = 2350,
  [SMALL_STATE(2219)] = 2421,
  [SMALL_STATE(2220)] = 2492,
  [SMALL_STATE(2221)] = 2563,
  [SMALL_STATE(2222)] = 2634,
  [SMALL_STATE(2223)] = 2705,
  [SMALL_STATE(2224)] = 2776,
  [SMALL_STATE(2225)] = 2847,
  [SMALL_STATE(2226)] = 2918,
  [SMALL_STATE(2227)] = 2989,
  [SMALL_STATE(2228)] = 3062,
  [SMALL_STATE(2229)] = 3133,
  [SMALL_STATE(2230)] = 3204,
  [SMALL_STATE(2231)] = 3275,
  [SMALL_STATE(2232)] = 3346,
  [SMALL_STATE(2233)] = 3417,
  [SMALL_STATE(2234)] = 3488,
  [SMALL_STATE(2235)] = 3559,
  [SMALL_STATE(2236)] = 3630,
  [SMALL_STATE(2237)] = 3701,
  [SMALL_STATE(2238)] = 3776,
  [SMALL_STATE(2239)] = 3847,
  [SMALL_STATE(2240)] = 3918,
  [SMALL_STATE(2241)] = 3989,
  [SMALL_STATE(2242)] = 4060,
  [SMALL_STATE(2243)] = 4131,
  [SMALL_STATE(2244)] = 4202,
  [SMALL_STATE(2245)] = 4277,
  [SMALL_STATE(2246)] = 4356,
  [SMALL_STATE(2247)] = 4427,
  [SMALL_STATE(2248)] = 4498,
  [SMALL_STATE(2249)] = 4569,
  [SMALL_STATE(2250)] = 4640,
  [SMALL_STATE(2251)] = 4711,
  [SMALL_STATE(2252)] = 4782,
  [SMALL_STATE(2253)] = 4853,
  [SMALL_STATE(2254)] = 4924,
  [SMALL_STATE(2255)] = 4995,
  [SMALL_STATE(2256)] = 5074,
  [SMALL_STATE(2257)] = 5145,
  [SMALL_STATE(2258)] = 5216,
  [SMALL_STATE(2259)] = 5287,
  [SMALL_STATE(2260)] = 5358,
  [SMALL_STATE(2261)] = 5429,
  [SMALL_STATE(2262)] = 5500,
  [SMALL_STATE(2263)] = 5571,
  [SMALL_STATE(2264)] = 5642,
  [SMALL_STATE(2265)] = 5713,
  [SMALL_STATE(2266)] = 5806,
  [SMALL_STATE(2267)] = 5937,
  [SMALL_STATE(2268)] = 6008,
  [SMALL_STATE(2269)] = 6125,
  [SMALL_STATE(2270)] = 6208,
  [SMALL_STATE(2271)] = 6299,
  [SMALL_STATE(2272)] = 6378,
  [SMALL_STATE(2273)] = 6467,
  [SMALL_STATE(2274)] = 6570,
  [SMALL_STATE(2275)] = 6671,
  [SMALL_STATE(2276)] = 6750,
  [SMALL_STATE(2277)] = 6821,
  [SMALL_STATE(2278)] = 6904,
  [SMALL_STATE(2279)] = 6987,
  [SMALL_STATE(2280)] = 7066,
  [SMALL_STATE(2281)] = 7163,
  [SMALL_STATE(2282)] = 7246,
  [SMALL_STATE(2283)] = 7333,
  [SMALL_STATE(2284)] = 7428,
  [SMALL_STATE(2285)] = 7515,
  [SMALL_STATE(2286)] = 7600,
  [SMALL_STATE(2287)] = 7679,
  [SMALL_STATE(2288)] = 7750,
  [SMALL_STATE(2289)] = 7821,
  [SMALL_STATE(2290)] = 7892,
  [SMALL_STATE(2291)] = 7963,
  [SMALL_STATE(2292)] = 8078,
  [SMALL_STATE(2293)] = 8149,
  [SMALL_STATE(2294)] = 8220,
  [SMALL_STATE(2295)] = 8299,
  [SMALL_STATE(2296)] = 8370,
  [SMALL_STATE(2297)] = 8441,
  [SMALL_STATE(2298)] = 8512,
  [SMALL_STATE(2299)] = 8595,
  [SMALL_STATE(2300)] = 8666,
  [SMALL_STATE(2301)] = 8759,
  [SMALL_STATE(2302)] = 8830,
  [SMALL_STATE(2303)] = 8901,
  [SMALL_STATE(2304)] = 9018,
  [SMALL_STATE(2305)] = 9101,
  [SMALL_STATE(2306)] = 9192,
  [SMALL_STATE(2307)] = 9263,
  [SMALL_STATE(2308)] = 9334,
  [SMALL_STATE(2309)] = 9417,
  [SMALL_STATE(2310)] = 9488,
  [SMALL_STATE(2311)] = 9559,
  [SMALL_STATE(2312)] = 9630,
  [SMALL_STATE(2313)] = 9719,
  [SMALL_STATE(2314)] = 9822,
  [SMALL_STATE(2315)] = 9923,
  [SMALL_STATE(2316)] = 9994,
  [SMALL_STATE(2317)] = 10073,
  [SMALL_STATE(2318)] = 10170,
  [SMALL_STATE(2319)] = 10257,
  [SMALL_STATE(2320)] = 10352,
  [SMALL_STATE(2321)] = 10435,
  [SMALL_STATE(2322)] = 10506,
  [SMALL_STATE(2323)] = 10585,
  [SMALL_STATE(2324)] = 10664,
  [SMALL_STATE(2325)] = 10735,
  [SMALL_STATE(2326)] = 10822,
  [SMALL_STATE(2327)] = 10909,
  [SMALL_STATE(2328)] = 10980,
  [SMALL_STATE(2329)] = 11065,
  [SMALL_STATE(2330)] = 11144,
  [SMALL_STATE(2331)] = 11215,
  [SMALL_STATE(2332)] = 11286,
  [SMALL_STATE(2333)] = 11401,
  [SMALL_STATE(2334)] = 11486,
  [SMALL_STATE(2335)] = 11557,
  [SMALL_STATE(2336)] = 11628,
  [SMALL_STATE(2337)] = 11699,
  [SMALL_STATE(2338)] = 11770,
  [SMALL_STATE(2339)] = 11885,
  [SMALL_STATE(2340)] = 11992,
  [SMALL_STATE(2341)] = 12063,
  [SMALL_STATE(2342)] = 12134,
  [SMALL_STATE(2343)] = 12205,
  [SMALL_STATE(2344)] = 12276,
  [SMALL_STATE(2345)] = 12347,
  [SMALL_STATE(2346)] = 12418,
  [SMALL_STATE(2347)] = 12489,
  [SMALL_STATE(2348)] = 12574,
  [SMALL_STATE(2349)] = 12651,
  [SMALL_STATE(2350)] = 12722,
  [SMALL_STATE(2351)] = 12793,
  [SMALL_STATE(2352)] = 12872,
  [SMALL_STATE(2353)] = 12943,
  [SMALL_STATE(2354)] = 13014,
  [SMALL_STATE(2355)] = 13085,
  [SMALL_STATE(2356)] = 13164,
  [SMALL_STATE(2357)] = 13295,
  [SMALL_STATE(2358)] = 13366,
  [SMALL_STATE(2359)] = 13437,
  [SMALL_STATE(2360)] = 13516,
  [SMALL_STATE(2361)] = 13587,
  [SMALL_STATE(2362)] = 13658,
  [SMALL_STATE(2363)] = 13729,
  [SMALL_STATE(2364)] = 13860,
  [SMALL_STATE(2365)] = 13931,
  [SMALL_STATE(2366)] = 14046,
  [SMALL_STATE(2367)] = 14153,
  [SMALL_STATE(2368)] = 14224,
  [SMALL_STATE(2369)] = 14295,
  [SMALL_STATE(2370)] = 14366,
  [SMALL_STATE(2371)] = 14437,
  [SMALL_STATE(2372)] = 14508,
  [SMALL_STATE(2373)] = 14579,
  [SMALL_STATE(2374)] = 14650,
  [SMALL_STATE(2375)] = 14723,
  [SMALL_STATE(2376)] = 14794,
  [SMALL_STATE(2377)] = 14865,
  [SMALL_STATE(2378)] = 14936,
  [SMALL_STATE(2379)] = 15007,
  [SMALL_STATE(2380)] = 15078,
  [SMALL_STATE(2381)] = 15209,
  [SMALL_STATE(2382)] = 15280,
  [SMALL_STATE(2383)] = 15351,
  [SMALL_STATE(2384)] = 15482,
  [SMALL_STATE(2385)] = 15613,
  [SMALL_STATE(2386)] = 15744,
  [SMALL_STATE(2387)] = 15815,
  [SMALL_STATE(2388)] = 15886,
  [SMALL_STATE(2389)] = 16017,
  [SMALL_STATE(2390)] = 16148,
  [SMALL_STATE(2391)] = 16219,
  [SMALL_STATE(2392)] = 16290,
  [SMALL_STATE(2393)] = 16361,
  [SMALL_STATE(2394)] = 16492,
  [SMALL_STATE(2395)] = 16563,
  [SMALL_STATE(2396)] = 16634,
  [SMALL_STATE(2397)] = 16705,
  [SMALL_STATE(2398)] = 16776,
  [SMALL_STATE(2399)] = 16907,
  [SMALL_STATE(2400)] = 16978,
  [SMALL_STATE(2401)] = 17049,
  [SMALL_STATE(2402)] = 17120,
  [SMALL_STATE(2403)] = 17191,
  [SMALL_STATE(2404)] = 17262,
  [SMALL_STATE(2405)] = 17333,
  [SMALL_STATE(2406)] = 17464,
  [SMALL_STATE(2407)] = 17535,
  [SMALL_STATE(2408)] = 17606,
  [SMALL_STATE(2409)] = 17677,
  [SMALL_STATE(2410)] = 17748,
  [SMALL_STATE(2411)] = 17819,
  [SMALL_STATE(2412)] = 17890,
  [SMALL_STATE(2413)] = 17961,
  [SMALL_STATE(2414)] = 18032,
  [SMALL_STATE(2415)] = 18103,
  [SMALL_STATE(2416)] = 18234,
  [SMALL_STATE(2417)] = 18307,
  [SMALL_STATE(2418)] = 18378,
  [SMALL_STATE(2419)] = 18453,
  [SMALL_STATE(2420)] = 18524,
  [SMALL_STATE(2421)] = 18595,
  [SMALL_STATE(2422)] = 18666,
  [SMALL_STATE(2423)] = 18743,
  [SMALL_STATE(2424)] = 18814,
  [SMALL_STATE(2425)] = 18885,
  [SMALL_STATE(2426)] = 18956,
  [SMALL_STATE(2427)] = 19027,
  [SMALL_STATE(2428)] = 19098,
  [SMALL_STATE(2429)] = 19173,
  [SMALL_STATE(2430)] = 19244,
  [SMALL_STATE(2431)] = 19315,
  [SMALL_STATE(2432)] = 19386,
  [SMALL_STATE(2433)] = 19457,
  [SMALL_STATE(2434)] = 19528,
  [SMALL_STATE(2435)] = 19599,
  [SMALL_STATE(2436)] = 19670,
  [SMALL_STATE(2437)] = 19741,
  [SMALL_STATE(2438)] = 19812,
  [SMALL_STATE(2439)] = 19883,
  [SMALL_STATE(2440)] = 19954,
  [SMALL_STATE(2441)] = 20025,
  [SMALL_STATE(2442)] = 20104,
  [SMALL_STATE(2443)] = 20175,
  [SMALL_STATE(2444)] = 20254,
  [SMALL_STATE(2445)] = 20329,
  [SMALL_STATE(2446)] = 20400,
  [SMALL_STATE(2447)] = 20471,
  [SMALL_STATE(2448)] = 20542,
  [SMALL_STATE(2449)] = 20617,
  [SMALL_STATE(2450)] = 20692,
  [SMALL_STATE(2451)] = 20763,
  [SMALL_STATE(2452)] = 20878,
  [SMALL_STATE(2453)] = 20953,
  [SMALL_STATE(2454)] = 21024,
  [SMALL_STATE(2455)] = 21095,
  [SMALL_STATE(2456)] = 21166,
  [SMALL_STATE(2457)] = 21237,
  [SMALL_STATE(2458)] = 21368,
  [SMALL_STATE(2459)] = 21439,
  [SMALL_STATE(2460)] = 21510,
  [SMALL_STATE(2461)] = 21581,
  [SMALL_STATE(2462)] = 21656,
  [SMALL_STATE(2463)] = 21727,
  [SMALL_STATE(2464)] = 21858,
  [SMALL_STATE(2465)] = 21989,
  [SMALL_STATE(2466)] = 22120,
  [SMALL_STATE(2467)] = 22191,
  [SMALL_STATE(2468)] = 22262,
  [SMALL_STATE(2469)] = 22337,
  [SMALL_STATE(2470)] = 22408,
  [SMALL_STATE(2471)] = 22479,
  [SMALL_STATE(2472)] = 22550,
  [SMALL_STATE(2473)] = 22621,
  [SMALL_STATE(2474)] = 22692,
  [SMALL_STATE(2475)] = 22763,
  [SMALL_STATE(2476)] = 22834,
  [SMALL_STATE(2477)] = 22909,
  [SMALL_STATE(2478)] = 22980,
  [SMALL_STATE(2479)] = 23051,
  [SMALL_STATE(2480)] = 23122,
  [SMALL_STATE(2481)] = 23193,
  [SMALL_STATE(2482)] = 23264,
  [SMALL_STATE(2483)] = 23335,
  [SMALL_STATE(2484)] = 23406,
  [SMALL_STATE(2485)] = 23477,
  [SMALL_STATE(2486)] = 23548,
  [SMALL_STATE(2487)] = 23619,
  [SMALL_STATE(2488)] = 23690,
  [SMALL_STATE(2489)] = 23761,
  [SMALL_STATE(2490)] = 23832,
  [SMALL_STATE(2491)] = 23903,
  [SMALL_STATE(2492)] = 23974,
  [SMALL_STATE(2493)] = 24045,
  [SMALL_STATE(2494)] = 24116,
  [SMALL_STATE(2495)] = 24187,
  [SMALL_STATE(2496)] = 24258,
  [SMALL_STATE(2497)] = 24329,
  [SMALL_STATE(2498)] = 24400,
  [SMALL_STATE(2499)] = 24471,
  [SMALL_STATE(2500)] = 24542,
  [SMALL_STATE(2501)] = 24613,
  [SMALL_STATE(2502)] = 24684,
  [SMALL_STATE(2503)] = 24755,
  [SMALL_STATE(2504)] = 24826,
  [SMALL_STATE(2505)] = 24897,
  [SMALL_STATE(2506)] = 24968,
  [SMALL_STATE(2507)] = 25039,
  [SMALL_STATE(2508)] = 25110,
  [SMALL_STATE(2509)] = 25181,
  [SMALL_STATE(2510)] = 25257,
  [SMALL_STATE(2511)] = 25331,
  [SMALL_STATE(2512)] = 25407,
  [SMALL_STATE(2513)] = 25481,
  [SMALL_STATE(2514)] = 25557,
  [SMALL_STATE(2515)] = 25629,
  [SMALL_STATE(2516)] = 25705,
  [SMALL_STATE(2517)] = 25779,
  [SMALL_STATE(2518)] = 25855,
  [SMALL_STATE(2519)] = 25931,
  [SMALL_STATE(2520)] = 26005,
  [SMALL_STATE(2521)] = 26081,
  [SMALL_STATE(2522)] = 26158,
  [SMALL_STATE(2523)] = 26263,
  [SMALL_STATE(2524)] = 26354,
  [SMALL_STATE(2525)] = 26449,
  [SMALL_STATE(2526)] = 26522,
  [SMALL_STATE(2527)] = 26599,
  [SMALL_STATE(2528)] = 26676,
  [SMALL_STATE(2529)] = 26789,
  [SMALL_STATE(2530)] = 26866,
  [SMALL_STATE(2531)] = 26939,
  [SMALL_STATE(2532)] = 27026,
  [SMALL_STATE(2533)] = 27103,
  [SMALL_STATE(2534)] = 27186,
  [SMALL_STATE(2535)] = 27271,
  [SMALL_STATE(2536)] = 27360,
  [SMALL_STATE(2537)] = 27431,
  [SMALL_STATE(2538)] = 27500,
  [SMALL_STATE(2539)] = 27593,
  [SMALL_STATE(2540)] = 27662,
  [SMALL_STATE(2541)] = 27739,
  [SMALL_STATE(2542)] = 27808,
  [SMALL_STATE(2543)] = 27907,
  [SMALL_STATE(2544)] = 27976,
  [SMALL_STATE(2545)] = 28091,
  [SMALL_STATE(2546)] = 28192,
  [SMALL_STATE(2547)] = 28269,
  [SMALL_STATE(2548)] = 28346,
  [SMALL_STATE(2549)] = 28423,
  [SMALL_STATE(2550)] = 28504,
  [SMALL_STATE(2551)] = 28581,
  [SMALL_STATE(2552)] = 28650,
  [SMALL_STATE(2553)] = 28727,
  [SMALL_STATE(2554)] = 28798,
  [SMALL_STATE(2555)] = 28867,
  [SMALL_STATE(2556)] = 28980,
  [SMALL_STATE(2557)] = 29049,
  [SMALL_STATE(2558)] = 29118,
  [SMALL_STATE(2559)] = 29189,
  [SMALL_STATE(2560)] = 29260,
  [SMALL_STATE(2561)] = 29337,
  [SMALL_STATE(2562)] = 29405,
  [SMALL_STATE(2563)] = 29473,
  [SMALL_STATE(2564)] = 29547,
  [SMALL_STATE(2565)] = 29615,
  [SMALL_STATE(2566)] = 29687,
  [SMALL_STATE(2567)] = 29755,
  [SMALL_STATE(2568)] = 29823,
  [SMALL_STATE(2569)] = 29891,
  [SMALL_STATE(2570)] = 29959,
  [SMALL_STATE(2571)] = 30027,
  [SMALL_STATE(2572)] = 30095,
  [SMALL_STATE(2573)] = 30163,
  [SMALL_STATE(2574)] = 30237,
  [SMALL_STATE(2575)] = 30305,
  [SMALL_STATE(2576)] = 30373,
  [SMALL_STATE(2577)] = 30441,
  [SMALL_STATE(2578)] = 30513,
  [SMALL_STATE(2579)] = 30585,
  [SMALL_STATE(2580)] = 30653,
  [SMALL_STATE(2581)] = 30727,
  [SMALL_STATE(2582)] = 30795,
  [SMALL_STATE(2583)] = 30863,
  [SMALL_STATE(2584)] = 30937,
  [SMALL_STATE(2585)] = 31011,
  [SMALL_STATE(2586)] = 31079,
  [SMALL_STATE(2587)] = 31153,
  [SMALL_STATE(2588)] = 31221,
  [SMALL_STATE(2589)] = 31289,
  [SMALL_STATE(2590)] = 31357,
  [SMALL_STATE(2591)] = 31425,
  [SMALL_STATE(2592)] = 31493,
  [SMALL_STATE(2593)] = 31567,
  [SMALL_STATE(2594)] = 31635,
  [SMALL_STATE(2595)] = 31703,
  [SMALL_STATE(2596)] = 31771,
  [SMALL_STATE(2597)] = 31839,
  [SMALL_STATE(2598)] = 31907,
  [SMALL_STATE(2599)] = 31977,
  [SMALL_STATE(2600)] = 32049,
  [SMALL_STATE(2601)] = 32121,
  [SMALL_STATE(2602)] = 32189,
  [SMALL_STATE(2603)] = 32257,
  [SMALL_STATE(2604)] = 32329,
  [SMALL_STATE(2605)] = 32397,
  [SMALL_STATE(2606)] = 32465,
  [SMALL_STATE(2607)] = 32533,
  [SMALL_STATE(2608)] = 32601,
  [SMALL_STATE(2609)] = 32669,
  [SMALL_STATE(2610)] = 32737,
  [SMALL_STATE(2611)] = 32805,
  [SMALL_STATE(2612)] = 32873,
  [SMALL_STATE(2613)] = 32941,
  [SMALL_STATE(2614)] = 33015,
  [SMALL_STATE(2615)] = 33083,
  [SMALL_STATE(2616)] = 33151,
  [SMALL_STATE(2617)] = 33219,
  [SMALL_STATE(2618)] = 33287,
  [SMALL_STATE(2619)] = 33355,
  [SMALL_STATE(2620)] = 33423,
  [SMALL_STATE(2621)] = 33491,
  [SMALL_STATE(2622)] = 33559,
  [SMALL_STATE(2623)] = 33627,
  [SMALL_STATE(2624)] = 33694,
  [SMALL_STATE(2625)] = 33761,
  [SMALL_STATE(2626)] = 33828,
  [SMALL_STATE(2627)] = 33895,
  [SMALL_STATE(2628)] = 33962,
  [SMALL_STATE(2629)] = 34073,
  [SMALL_STATE(2630)] = 34140,
  [SMALL_STATE(2631)] = 34215,
  [SMALL_STATE(2632)] = 34326,
  [SMALL_STATE(2633)] = 34409,
  [SMALL_STATE(2634)] = 34484,
  [SMALL_STATE(2635)] = 34587,
  [SMALL_STATE(2636)] = 34678,
  [SMALL_STATE(2637)] = 34753,
  [SMALL_STATE(2638)] = 34846,
  [SMALL_STATE(2639)] = 34943,
  [SMALL_STATE(2640)] = 35024,
  [SMALL_STATE(2641)] = 35123,
  [SMALL_STATE(2642)] = 35202,
  [SMALL_STATE(2643)] = 35269,
  [SMALL_STATE(2644)] = 35336,
  [SMALL_STATE(2645)] = 35403,
  [SMALL_STATE(2646)] = 35476,
  [SMALL_STATE(2647)] = 35561,
  [SMALL_STATE(2648)] = 35632,
  [SMALL_STATE(2649)] = 35707,
  [SMALL_STATE(2650)] = 35774,
  [SMALL_STATE(2651)] = 35841,
  [SMALL_STATE(2652)] = 35916,
  [SMALL_STATE(2653)] = 35983,
  [SMALL_STATE(2654)] = 36050,
  [SMALL_STATE(2655)] = 36117,
  [SMALL_STATE(2656)] = 36184,
  [SMALL_STATE(2657)] = 36251,
  [SMALL_STATE(2658)] = 36318,
  [SMALL_STATE(2659)] = 36385,
  [SMALL_STATE(2660)] = 36452,
  [SMALL_STATE(2661)] = 36519,
  [SMALL_STATE(2662)] = 36586,
  [SMALL_STATE(2663)] = 36673,
  [SMALL_STATE(2664)] = 36746,
  [SMALL_STATE(2665)] = 36815,
  [SMALL_STATE(2666)] = 36882,
  [SMALL_STATE(2667)] = 36949,
  [SMALL_STATE(2668)] = 37016,
  [SMALL_STATE(2669)] = 37083,
  [SMALL_STATE(2670)] = 37150,
  [SMALL_STATE(2671)] = 37217,
  [SMALL_STATE(2672)] = 37284,
  [SMALL_STATE(2673)] = 37351,
  [SMALL_STATE(2674)] = 37418,
  [SMALL_STATE(2675)] = 37485,
  [SMALL_STATE(2676)] = 37552,
  [SMALL_STATE(2677)] = 37619,
  [SMALL_STATE(2678)] = 37686,
  [SMALL_STATE(2679)] = 37753,
  [SMALL_STATE(2680)] = 37820,
  [SMALL_STATE(2681)] = 37887,
  [SMALL_STATE(2682)] = 37954,
  [SMALL_STATE(2683)] = 38025,
  [SMALL_STATE(2684)] = 38140,
  [SMALL_STATE(2685)] = 38207,
  [SMALL_STATE(2686)] = 38274,
  [SMALL_STATE(2687)] = 38341,
  [SMALL_STATE(2688)] = 38408,
  [SMALL_STATE(2689)] = 38479,
  [SMALL_STATE(2690)] = 38546,
  [SMALL_STATE(2691)] = 38659,
  [SMALL_STATE(2692)] = 38726,
  [SMALL_STATE(2693)] = 38793,
  [SMALL_STATE(2694)] = 38860,
  [SMALL_STATE(2695)] = 38949,
  [SMALL_STATE(2696)] = 39020,
  [SMALL_STATE(2697)] = 39093,
  [SMALL_STATE(2698)] = 39160,
  [SMALL_STATE(2699)] = 39227,
  [SMALL_STATE(2700)] = 39294,
  [SMALL_STATE(2701)] = 39361,
  [SMALL_STATE(2702)] = 39428,
  [SMALL_STATE(2703)] = 39495,
  [SMALL_STATE(2704)] = 39562,
  [SMALL_STATE(2705)] = 39629,
  [SMALL_STATE(2706)] = 39696,
  [SMALL_STATE(2707)] = 39763,
  [SMALL_STATE(2708)] = 39830,
  [SMALL_STATE(2709)] = 39897,
  [SMALL_STATE(2710)] = 39964,
  [SMALL_STATE(2711)] = 40031,
  [SMALL_STATE(2712)] = 40098,
  [SMALL_STATE(2713)] = 40165,
  [SMALL_STATE(2714)] = 40232,
  [SMALL_STATE(2715)] = 40303,
  [SMALL_STATE(2716)] = 40370,
  [SMALL_STATE(2717)] = 40441,
  [SMALL_STATE(2718)] = 40512,
  [SMALL_STATE(2719)] = 40583,
  [SMALL_STATE(2720)] = 40650,
  [SMALL_STATE(2721)] = 40717,
  [SMALL_STATE(2722)] = 40784,
  [SMALL_STATE(2723)] = 40856,
  [SMALL_STATE(2724)] = 40930,
  [SMALL_STATE(2725)] = 41000,
  [SMALL_STATE(2726)] = 41072,
  [SMALL_STATE(2727)] = 41182,
  [SMALL_STATE(2728)] = 41250,
  [SMALL_STATE(2729)] = 41324,
  [SMALL_STATE(2730)] = 41390,
  [SMALL_STATE(2731)] = 41456,
  [SMALL_STATE(2732)] = 41536,
  [SMALL_STATE(2733)] = 41618,
  [SMALL_STATE(2734)] = 41686,
  [SMALL_STATE(2735)] = 41776,
  [SMALL_STATE(2736)] = 41868,
  [SMALL_STATE(2737)] = 41964,
  [SMALL_STATE(2738)] = 42062,
  [SMALL_STATE(2739)] = 42146,
  [SMALL_STATE(2740)] = 42232,
  [SMALL_STATE(2741)] = 42310,
  [SMALL_STATE(2742)] = 42378,
  [SMALL_STATE(2743)] = 42452,
  [SMALL_STATE(2744)] = 42564,
  [SMALL_STATE(2745)] = 42652,
  [SMALL_STATE(2746)] = 42762,
  [SMALL_STATE(2747)] = 42836,
  [SMALL_STATE(2748)] = 42910,
  [SMALL_STATE(2749)] = 42980,
  [SMALL_STATE(2750)] = 43046,
  [SMALL_STATE(2751)] = 43112,
  [SMALL_STATE(2752)] = 43178,
  [SMALL_STATE(2753)] = 43244,
  [SMALL_STATE(2754)] = 43310,
  [SMALL_STATE(2755)] = 43376,
  [SMALL_STATE(2756)] = 43442,
  [SMALL_STATE(2757)] = 43544,
  [SMALL_STATE(2758)] = 43609,
  [SMALL_STATE(2759)] = 43674,
  [SMALL_STATE(2760)] = 43771,
  [SMALL_STATE(2761)] = 43866,
  [SMALL_STATE(2762)] = 43957,
  [SMALL_STATE(2763)] = 44046,
  [SMALL_STATE(2764)] = 44127,
  [SMALL_STATE(2765)] = 44206,
  [SMALL_STATE(2766)] = 44279,
  [SMALL_STATE(2767)] = 44344,
  [SMALL_STATE(2768)] = 44409,
  [SMALL_STATE(2769)] = 44474,
  [SMALL_STATE(2770)] = 44583,
  [SMALL_STATE(2771)] = 44648,
  [SMALL_STATE(2772)] = 44713,
  [SMALL_STATE(2773)] = 44790,
  [SMALL_STATE(2774)] = 44855,
  [SMALL_STATE(2775)] = 44928,
  [SMALL_STATE(2776)] = 44993,
  [SMALL_STATE(2777)] = 45058,
  [SMALL_STATE(2778)] = 45129,
  [SMALL_STATE(2779)] = 45214,
  [SMALL_STATE(2780)] = 45279,
  [SMALL_STATE(2781)] = 45390,
  [SMALL_STATE(2782)] = 45519,
  [SMALL_STATE(2783)] = 45584,
  [SMALL_STATE(2784)] = 45653,
  [SMALL_STATE(2785)] = 45740,
  [SMALL_STATE(2786)] = 45805,
  [SMALL_STATE(2787)] = 45870,
  [SMALL_STATE(2788)] = 45935,
  [SMALL_STATE(2789)] = 46000,
  [SMALL_STATE(2790)] = 46129,
  [SMALL_STATE(2791)] = 46198,
  [SMALL_STATE(2792)] = 46263,
  [SMALL_STATE(2793)] = 46328,
  [SMALL_STATE(2794)] = 46393,
  [SMALL_STATE(2795)] = 46458,
  [SMALL_STATE(2796)] = 46523,
  [SMALL_STATE(2797)] = 46588,
  [SMALL_STATE(2798)] = 46661,
  [SMALL_STATE(2799)] = 46726,
  [SMALL_STATE(2800)] = 46791,
  [SMALL_STATE(2801)] = 46856,
  [SMALL_STATE(2802)] = 46925,
  [SMALL_STATE(2803)] = 46998,
  [SMALL_STATE(2804)] = 47067,
  [SMALL_STATE(2805)] = 47132,
  [SMALL_STATE(2806)] = 47197,
  [SMALL_STATE(2807)] = 47262,
  [SMALL_STATE(2808)] = 47327,
  [SMALL_STATE(2809)] = 47396,
  [SMALL_STATE(2810)] = 47461,
  [SMALL_STATE(2811)] = 47526,
  [SMALL_STATE(2812)] = 47591,
  [SMALL_STATE(2813)] = 47656,
  [SMALL_STATE(2814)] = 47721,
  [SMALL_STATE(2815)] = 47786,
  [SMALL_STATE(2816)] = 47851,
  [SMALL_STATE(2817)] = 47960,
  [SMALL_STATE(2818)] = 48061,
  [SMALL_STATE(2819)] = 48126,
  [SMALL_STATE(2820)] = 48191,
  [SMALL_STATE(2821)] = 48256,
  [SMALL_STATE(2822)] = 48321,
  [SMALL_STATE(2823)] = 48386,
  [SMALL_STATE(2824)] = 48451,
  [SMALL_STATE(2825)] = 48516,
  [SMALL_STATE(2826)] = 48581,
  [SMALL_STATE(2827)] = 48646,
  [SMALL_STATE(2828)] = 48711,
  [SMALL_STATE(2829)] = 48784,
  [SMALL_STATE(2830)] = 48849,
  [SMALL_STATE(2831)] = 48922,
  [SMALL_STATE(2832)] = 48987,
  [SMALL_STATE(2833)] = 49052,
  [SMALL_STATE(2834)] = 49117,
  [SMALL_STATE(2835)] = 49182,
  [SMALL_STATE(2836)] = 49247,
  [SMALL_STATE(2837)] = 49312,
  [SMALL_STATE(2838)] = 49377,
  [SMALL_STATE(2839)] = 49442,
  [SMALL_STATE(2840)] = 49507,
  [SMALL_STATE(2841)] = 49572,
  [SMALL_STATE(2842)] = 49639,
  [SMALL_STATE(2843)] = 49708,
  [SMALL_STATE(2844)] = 49773,
  [SMALL_STATE(2845)] = 49838,
  [SMALL_STATE(2846)] = 49903,
  [SMALL_STATE(2847)] = 49968,
  [SMALL_STATE(2848)] = 50033,
  [SMALL_STATE(2849)] = 50098,
  [SMALL_STATE(2850)] = 50163,
  [SMALL_STATE(2851)] = 50228,
  [SMALL_STATE(2852)] = 50297,
  [SMALL_STATE(2853)] = 50362,
  [SMALL_STATE(2854)] = 50427,
  [SMALL_STATE(2855)] = 50492,
  [SMALL_STATE(2856)] = 50557,
  [SMALL_STATE(2857)] = 50622,
  [SMALL_STATE(2858)] = 50687,
  [SMALL_STATE(2859)] = 50752,
  [SMALL_STATE(2860)] = 50817,
  [SMALL_STATE(2861)] = 50900,
  [SMALL_STATE(2862)] = 50965,
  [SMALL_STATE(2863)] = 51030,
  [SMALL_STATE(2864)] = 51095,
  [SMALL_STATE(2865)] = 51160,
  [SMALL_STATE(2866)] = 51225,
  [SMALL_STATE(2867)] = 51290,
  [SMALL_STATE(2868)] = 51355,
  [SMALL_STATE(2869)] = 51420,
  [SMALL_STATE(2870)] = 51485,
  [SMALL_STATE(2871)] = 51550,
  [SMALL_STATE(2872)] = 51615,
  [SMALL_STATE(2873)] = 51680,
  [SMALL_STATE(2874)] = 51745,
  [SMALL_STATE(2875)] = 51810,
  [SMALL_STATE(2876)] = 51875,
  [SMALL_STATE(2877)] = 51940,
  [SMALL_STATE(2878)] = 52005,
  [SMALL_STATE(2879)] = 52070,
  [SMALL_STATE(2880)] = 52135,
  [SMALL_STATE(2881)] = 52200,
  [SMALL_STATE(2882)] = 52265,
  [SMALL_STATE(2883)] = 52330,
  [SMALL_STATE(2884)] = 52395,
  [SMALL_STATE(2885)] = 52460,
  [SMALL_STATE(2886)] = 52525,
  [SMALL_STATE(2887)] = 52590,
  [SMALL_STATE(2888)] = 52655,
  [SMALL_STATE(2889)] = 52720,
  [SMALL_STATE(2890)] = 52785,
  [SMALL_STATE(2891)] = 52850,
  [SMALL_STATE(2892)] = 52915,
  [SMALL_STATE(2893)] = 52984,
  [SMALL_STATE(2894)] = 53049,
  [SMALL_STATE(2895)] = 53114,
  [SMALL_STATE(2896)] = 53187,
  [SMALL_STATE(2897)] = 53256,
  [SMALL_STATE(2898)] = 53321,
  [SMALL_STATE(2899)] = 53386,
  [SMALL_STATE(2900)] = 53451,
  [SMALL_STATE(2901)] = 53516,
  [SMALL_STATE(2902)] = 53581,
  [SMALL_STATE(2903)] = 53649,
  [SMALL_STATE(2904)] = 53725,
  [SMALL_STATE(2905)] = 53801,
  [SMALL_STATE(2906)] = 53871,
  [SMALL_STATE(2907)] = 53941,
  [SMALL_STATE(2908)] = 54019,
  [SMALL_STATE(2909)] = 54089,
  [SMALL_STATE(2910)] = 54165,
  [SMALL_STATE(2911)] = 54245,
  [SMALL_STATE(2912)] = 54315,
  [SMALL_STATE(2913)] = 54395,
  [SMALL_STATE(2914)] = 54471,
  [SMALL_STATE(2915)] = 54547,
  [SMALL_STATE(2916)] = 54623,
  [SMALL_STATE(2917)] = 54703,
  [SMALL_STATE(2918)] = 54775,
  [SMALL_STATE(2919)] = 54845,
  [SMALL_STATE(2920)] = 54913,
  [SMALL_STATE(2921)] = 54979,
  [SMALL_STATE(2922)] = 55051,
  [SMALL_STATE(2923)] = 55123,
  [SMALL_STATE(2924)] = 55193,
  [SMALL_STATE(2925)] = 55269,
  [SMALL_STATE(2926)] = 55339,
  [SMALL_STATE(2927)] = 55415,
  [SMALL_STATE(2928)] = 55487,
  [SMALL_STATE(2929)] = 55557,
  [SMALL_STATE(2930)] = 55627,
  [SMALL_STATE(2931)] = 55699,
  [SMALL_STATE(2932)] = 55777,
  [SMALL_STATE(2933)] = 55849,
  [SMALL_STATE(2934)] = 55927,
  [SMALL_STATE(2935)] = 55997,
  [SMALL_STATE(2936)] = 56121,
  [SMALL_STATE(2937)] = 56187,
  [SMALL_STATE(2938)] = 56265,
  [SMALL_STATE(2939)] = 56345,
  [SMALL_STATE(2940)] = 56421,
  [SMALL_STATE(2941)] = 56545,
  [SMALL_STATE(2942)] = 56613,
  [SMALL_STATE(2943)] = 56691,
  [SMALL_STATE(2944)] = 56769,
  [SMALL_STATE(2945)] = 56837,
  [SMALL_STATE(2946)] = 56917,
  [SMALL_STATE(2947)] = 57041,
  [SMALL_STATE(2948)] = 57117,
  [SMALL_STATE(2949)] = 57181,
  [SMALL_STATE(2950)] = 57257,
  [SMALL_STATE(2951)] = 57381,
  [SMALL_STATE(2952)] = 57447,
  [SMALL_STATE(2953)] = 57527,
  [SMALL_STATE(2954)] = 57603,
  [SMALL_STATE(2955)] = 57683,
  [SMALL_STATE(2956)] = 57759,
  [SMALL_STATE(2957)] = 57839,
  [SMALL_STATE(2958)] = 57915,
  [SMALL_STATE(2959)] = 57991,
  [SMALL_STATE(2960)] = 58071,
  [SMALL_STATE(2961)] = 58147,
  [SMALL_STATE(2962)] = 58223,
  [SMALL_STATE(2963)] = 58299,
  [SMALL_STATE(2964)] = 58378,
  [SMALL_STATE(2965)] = 58441,
  [SMALL_STATE(2966)] = 58504,
  [SMALL_STATE(2967)] = 58581,
  [SMALL_STATE(2968)] = 58658,
  [SMALL_STATE(2969)] = 58721,
  [SMALL_STATE(2970)] = 58832,
  [SMALL_STATE(2971)] = 58895,
  [SMALL_STATE(2972)] = 58962,
  [SMALL_STATE(2973)] = 59029,
  [SMALL_STATE(2974)] = 59092,
  [SMALL_STATE(2975)] = 59155,
  [SMALL_STATE(2976)] = 59218,
  [SMALL_STATE(2977)] = 59281,
  [SMALL_STATE(2978)] = 59344,
  [SMALL_STATE(2979)] = 59407,
  [SMALL_STATE(2980)] = 59470,
  [SMALL_STATE(2981)] = 59535,
  [SMALL_STATE(2982)] = 59598,
  [SMALL_STATE(2983)] = 59661,
  [SMALL_STATE(2984)] = 59724,
  [SMALL_STATE(2985)] = 59787,
  [SMALL_STATE(2986)] = 59850,
  [SMALL_STATE(2987)] = 59913,
  [SMALL_STATE(2988)] = 59976,
  [SMALL_STATE(2989)] = 60039,
  [SMALL_STATE(2990)] = 60108,
  [SMALL_STATE(2991)] = 60179,
  [SMALL_STATE(2992)] = 60248,
  [SMALL_STATE(2993)] = 60317,
  [SMALL_STATE(2994)] = 60380,
  [SMALL_STATE(2995)] = 60451,
  [SMALL_STATE(2996)] = 60514,
  [SMALL_STATE(2997)] = 60591,
  [SMALL_STATE(2998)] = 60660,
  [SMALL_STATE(2999)] = 60731,
  [SMALL_STATE(3000)] = 60794,
  [SMALL_STATE(3001)] = 60857,
  [SMALL_STATE(3002)] = 60920,
  [SMALL_STATE(3003)] = 60983,
  [SMALL_STATE(3004)] = 61046,
  [SMALL_STATE(3005)] = 61109,
  [SMALL_STATE(3006)] = 61172,
  [SMALL_STATE(3007)] = 61239,
  [SMALL_STATE(3008)] = 61314,
  [SMALL_STATE(3009)] = 61377,
  [SMALL_STATE(3010)] = 61444,
  [SMALL_STATE(3011)] = 61519,
  [SMALL_STATE(3012)] = 61582,
  [SMALL_STATE(3013)] = 61645,
  [SMALL_STATE(3014)] = 61708,
  [SMALL_STATE(3015)] = 61779,
  [SMALL_STATE(3016)] = 61854,
  [SMALL_STATE(3017)] = 61933,
  [SMALL_STATE(3018)] = 62002,
  [SMALL_STATE(3019)] = 62065,
  [SMALL_STATE(3020)] = 62136,
  [SMALL_STATE(3021)] = 62199,
  [SMALL_STATE(3022)] = 62268,
  [SMALL_STATE(3023)] = 62331,
  [SMALL_STATE(3024)] = 62394,
  [SMALL_STATE(3025)] = 62457,
  [SMALL_STATE(3026)] = 62520,
  [SMALL_STATE(3027)] = 62583,
  [SMALL_STATE(3028)] = 62646,
  [SMALL_STATE(3029)] = 62709,
  [SMALL_STATE(3030)] = 62772,
  [SMALL_STATE(3031)] = 62835,
  [SMALL_STATE(3032)] = 62956,
  [SMALL_STATE(3033)] = 63019,
  [SMALL_STATE(3034)] = 63082,
  [SMALL_STATE(3035)] = 63145,
  [SMALL_STATE(3036)] = 63208,
  [SMALL_STATE(3037)] = 63271,
  [SMALL_STATE(3038)] = 63334,
  [SMALL_STATE(3039)] = 63397,
  [SMALL_STATE(3040)] = 63472,
  [SMALL_STATE(3041)] = 63543,
  [SMALL_STATE(3042)] = 63606,
  [SMALL_STATE(3043)] = 63669,
  [SMALL_STATE(3044)] = 63732,
  [SMALL_STATE(3045)] = 63795,
  [SMALL_STATE(3046)] = 63858,
  [SMALL_STATE(3047)] = 63921,
  [SMALL_STATE(3048)] = 63990,
  [SMALL_STATE(3049)] = 64053,
  [SMALL_STATE(3050)] = 64116,
  [SMALL_STATE(3051)] = 64179,
  [SMALL_STATE(3052)] = 64242,
  [SMALL_STATE(3053)] = 64305,
  [SMALL_STATE(3054)] = 64368,
  [SMALL_STATE(3055)] = 64431,
  [SMALL_STATE(3056)] = 64494,
  [SMALL_STATE(3057)] = 64557,
  [SMALL_STATE(3058)] = 64620,
  [SMALL_STATE(3059)] = 64683,
  [SMALL_STATE(3060)] = 64746,
  [SMALL_STATE(3061)] = 64809,
  [SMALL_STATE(3062)] = 64872,
  [SMALL_STATE(3063)] = 64935,
  [SMALL_STATE(3064)] = 65010,
  [SMALL_STATE(3065)] = 65073,
  [SMALL_STATE(3066)] = 65136,
  [SMALL_STATE(3067)] = 65199,
  [SMALL_STATE(3068)] = 65262,
  [SMALL_STATE(3069)] = 65325,
  [SMALL_STATE(3070)] = 65388,
  [SMALL_STATE(3071)] = 65451,
  [SMALL_STATE(3072)] = 65526,
  [SMALL_STATE(3073)] = 65589,
  [SMALL_STATE(3074)] = 65664,
  [SMALL_STATE(3075)] = 65743,
  [SMALL_STATE(3076)] = 65810,
  [SMALL_STATE(3077)] = 65873,
  [SMALL_STATE(3078)] = 65936,
  [SMALL_STATE(3079)] = 65999,
  [SMALL_STATE(3080)] = 66066,
  [SMALL_STATE(3081)] = 66135,
  [SMALL_STATE(3082)] = 66198,
  [SMALL_STATE(3083)] = 66261,
  [SMALL_STATE(3084)] = 66324,
  [SMALL_STATE(3085)] = 66399,
  [SMALL_STATE(3086)] = 66462,
  [SMALL_STATE(3087)] = 66525,
  [SMALL_STATE(3088)] = 66600,
  [SMALL_STATE(3089)] = 66663,
  [SMALL_STATE(3090)] = 66726,
  [SMALL_STATE(3091)] = 66789,
  [SMALL_STATE(3092)] = 66852,
  [SMALL_STATE(3093)] = 66927,
  [SMALL_STATE(3094)] = 66990,
  [SMALL_STATE(3095)] = 67065,
  [SMALL_STATE(3096)] = 67128,
  [SMALL_STATE(3097)] = 67191,
  [SMALL_STATE(3098)] = 67270,
  [SMALL_STATE(3099)] = 67345,
  [SMALL_STATE(3100)] = 67424,
  [SMALL_STATE(3101)] = 67487,
  [SMALL_STATE(3102)] = 67550,
  [SMALL_STATE(3103)] = 67613,
  [SMALL_STATE(3104)] = 67676,
  [SMALL_STATE(3105)] = 67739,
  [SMALL_STATE(3106)] = 67816,
  [SMALL_STATE(3107)] = 67893,
  [SMALL_STATE(3108)] = 67972,
  [SMALL_STATE(3109)] = 68039,
  [SMALL_STATE(3110)] = 68102,
  [SMALL_STATE(3111)] = 68165,
  [SMALL_STATE(3112)] = 68228,
  [SMALL_STATE(3113)] = 68293,
  [SMALL_STATE(3114)] = 68404,
  [SMALL_STATE(3115)] = 68467,
  [SMALL_STATE(3116)] = 68546,
  [SMALL_STATE(3117)] = 68609,
  [SMALL_STATE(3118)] = 68672,
  [SMALL_STATE(3119)] = 68735,
  [SMALL_STATE(3120)] = 68798,
  [SMALL_STATE(3121)] = 68863,
  [SMALL_STATE(3122)] = 68926,
  [SMALL_STATE(3123)] = 68989,
  [SMALL_STATE(3124)] = 69054,
  [SMALL_STATE(3125)] = 69129,
  [SMALL_STATE(3126)] = 69192,
  [SMALL_STATE(3127)] = 69255,
  [SMALL_STATE(3128)] = 69324,
  [SMALL_STATE(3129)] = 69387,
  [SMALL_STATE(3130)] = 69450,
  [SMALL_STATE(3131)] = 69513,
  [SMALL_STATE(3132)] = 69592,
  [SMALL_STATE(3133)] = 69667,
  [SMALL_STATE(3134)] = 69746,
  [SMALL_STATE(3135)] = 69809,
  [SMALL_STATE(3136)] = 69884,
  [SMALL_STATE(3137)] = 69959,
  [SMALL_STATE(3138)] = 70022,
  [SMALL_STATE(3139)] = 70085,
  [SMALL_STATE(3140)] = 70148,
  [SMALL_STATE(3141)] = 70225,
  [SMALL_STATE(3142)] = 70300,
  [SMALL_STATE(3143)] = 70363,
  [SMALL_STATE(3144)] = 70438,
  [SMALL_STATE(3145)] = 70503,
  [SMALL_STATE(3146)] = 70566,
  [SMALL_STATE(3147)] = 70631,
  [SMALL_STATE(3148)] = 70701,
  [SMALL_STATE(3149)] = 70775,
  [SMALL_STATE(3150)] = 70857,
  [SMALL_STATE(3151)] = 70953,
  [SMALL_STATE(3152)] = 71047,
  [SMALL_STATE(3153)] = 71137,
  [SMALL_STATE(3154)] = 71225,
  [SMALL_STATE(3155)] = 71305,
  [SMALL_STATE(3156)] = 71383,
  [SMALL_STATE(3157)] = 71453,
  [SMALL_STATE(3158)] = 71515,
  [SMALL_STATE(3159)] = 71577,
  [SMALL_STATE(3160)] = 71639,
  [SMALL_STATE(3161)] = 71745,
  [SMALL_STATE(3162)] = 71807,
  [SMALL_STATE(3163)] = 71869,
  [SMALL_STATE(3164)] = 71939,
  [SMALL_STATE(3165)] = 72005,
  [SMALL_STATE(3166)] = 72075,
  [SMALL_STATE(3167)] = 72137,
  [SMALL_STATE(3168)] = 72233,
  [SMALL_STATE(3169)] = 72303,
  [SMALL_STATE(3170)] = 72369,
  [SMALL_STATE(3171)] = 72431,
  [SMALL_STATE(3172)] = 72493,
  [SMALL_STATE(3173)] = 72555,
  [SMALL_STATE(3174)] = 72617,
  [SMALL_STATE(3175)] = 72679,
  [SMALL_STATE(3176)] = 72749,
  [SMALL_STATE(3177)] = 72811,
  [SMALL_STATE(3178)] = 72929,
  [SMALL_STATE(3179)] = 72995,
  [SMALL_STATE(3180)] = 73065,
  [SMALL_STATE(3181)] = 73127,
  [SMALL_STATE(3182)] = 73197,
  [SMALL_STATE(3183)] = 73259,
  [SMALL_STATE(3184)] = 73321,
  [SMALL_STATE(3185)] = 73383,
  [SMALL_STATE(3186)] = 73477,
  [SMALL_STATE(3187)] = 73539,
  [SMALL_STATE(3188)] = 73629,
  [SMALL_STATE(3189)] = 73691,
  [SMALL_STATE(3190)] = 73753,
  [SMALL_STATE(3191)] = 73815,
  [SMALL_STATE(3192)] = 73877,
  [SMALL_STATE(3193)] = 73939,
  [SMALL_STATE(3194)] = 74001,
  [SMALL_STATE(3195)] = 74063,
  [SMALL_STATE(3196)] = 74125,
  [SMALL_STATE(3197)] = 74231,
  [SMALL_STATE(3198)] = 74329,
  [SMALL_STATE(3199)] = 74417,
  [SMALL_STATE(3200)] = 74479,
  [SMALL_STATE(3201)] = 74549,
  [SMALL_STATE(3202)] = 74611,
  [SMALL_STATE(3203)] = 74673,
  [SMALL_STATE(3204)] = 74735,
  [SMALL_STATE(3205)] = 74797,
  [SMALL_STATE(3206)] = 74859,
  [SMALL_STATE(3207)] = 74925,
  [SMALL_STATE(3208)] = 75005,
  [SMALL_STATE(3209)] = 75067,
  [SMALL_STATE(3210)] = 75129,
  [SMALL_STATE(3211)] = 75191,
  [SMALL_STATE(3212)] = 75253,
  [SMALL_STATE(3213)] = 75315,
  [SMALL_STATE(3214)] = 75377,
  [SMALL_STATE(3215)] = 75439,
  [SMALL_STATE(3216)] = 75501,
  [SMALL_STATE(3217)] = 75563,
  [SMALL_STATE(3218)] = 75625,
  [SMALL_STATE(3219)] = 75687,
  [SMALL_STATE(3220)] = 75793,
  [SMALL_STATE(3221)] = 75855,
  [SMALL_STATE(3222)] = 75917,
  [SMALL_STATE(3223)] = 75979,
  [SMALL_STATE(3224)] = 76041,
  [SMALL_STATE(3225)] = 76103,
  [SMALL_STATE(3226)] = 76165,
  [SMALL_STATE(3227)] = 76227,
  [SMALL_STATE(3228)] = 76289,
  [SMALL_STATE(3229)] = 76351,
  [SMALL_STATE(3230)] = 76425,
  [SMALL_STATE(3231)] = 76487,
  [SMALL_STATE(3232)] = 76549,
  [SMALL_STATE(3233)] = 76611,
  [SMALL_STATE(3234)] = 76673,
  [SMALL_STATE(3235)] = 76735,
  [SMALL_STATE(3236)] = 76797,
  [SMALL_STATE(3237)] = 76859,
  [SMALL_STATE(3238)] = 76921,
  [SMALL_STATE(3239)] = 76983,
  [SMALL_STATE(3240)] = 77045,
  [SMALL_STATE(3241)] = 77107,
  [SMALL_STATE(3242)] = 77169,
  [SMALL_STATE(3243)] = 77231,
  [SMALL_STATE(3244)] = 77293,
  [SMALL_STATE(3245)] = 77355,
  [SMALL_STATE(3246)] = 77417,
  [SMALL_STATE(3247)] = 77479,
  [SMALL_STATE(3248)] = 77541,
  [SMALL_STATE(3249)] = 77603,
  [SMALL_STATE(3250)] = 77665,
  [SMALL_STATE(3251)] = 77727,
  [SMALL_STATE(3252)] = 77789,
  [SMALL_STATE(3253)] = 77851,
  [SMALL_STATE(3254)] = 77913,
  [SMALL_STATE(3255)] = 77975,
  [SMALL_STATE(3256)] = 78037,
  [SMALL_STATE(3257)] = 78099,
  [SMALL_STATE(3258)] = 78161,
  [SMALL_STATE(3259)] = 78223,
  [SMALL_STATE(3260)] = 78285,
  [SMALL_STATE(3261)] = 78351,
  [SMALL_STATE(3262)] = 78459,
  [SMALL_STATE(3263)] = 78545,
  [SMALL_STATE(3264)] = 78607,
  [SMALL_STATE(3265)] = 78673,
  [SMALL_STATE(3266)] = 78741,
  [SMALL_STATE(3267)] = 78807,
  [SMALL_STATE(3268)] = 78873,
  [SMALL_STATE(3269)] = 78939,
  [SMALL_STATE(3270)] = 79017,
  [SMALL_STATE(3271)] = 79087,
  [SMALL_STATE(3272)] = 79169,
  [SMALL_STATE(3273)] = 79231,
  [SMALL_STATE(3274)] = 79301,
  [SMALL_STATE(3275)] = 79377,
  [SMALL_STATE(3276)] = 79453,
  [SMALL_STATE(3277)] = 79531,
  [SMALL_STATE(3278)] = 79605,
  [SMALL_STATE(3279)] = 79683,
  [SMALL_STATE(3280)] = 79757,
  [SMALL_STATE(3281)] = 79819,
  [SMALL_STATE(3282)] = 79937,
  [SMALL_STATE(3283)] = 80003,
  [SMALL_STATE(3284)] = 80081,
  [SMALL_STATE(3285)] = 80165,
  [SMALL_STATE(3286)] = 80227,
  [SMALL_STATE(3287)] = 80301,
  [SMALL_STATE(3288)] = 80363,
  [SMALL_STATE(3289)] = 80425,
  [SMALL_STATE(3290)] = 80487,
  [SMALL_STATE(3291)] = 80561,
  [SMALL_STATE(3292)] = 80623,
  [SMALL_STATE(3293)] = 80709,
  [SMALL_STATE(3294)] = 80779,
  [SMALL_STATE(3295)] = 80849,
  [SMALL_STATE(3296)] = 80919,
  [SMALL_STATE(3297)] = 80983,
  [SMALL_STATE(3298)] = 81049,
  [SMALL_STATE(3299)] = 81119,
  [SMALL_STATE(3300)] = 81181,
  [SMALL_STATE(3301)] = 81243,
  [SMALL_STATE(3302)] = 81313,
  [SMALL_STATE(3303)] = 81383,
  [SMALL_STATE(3304)] = 81453,
  [SMALL_STATE(3305)] = 81515,
  [SMALL_STATE(3306)] = 81583,
  [SMALL_STATE(3307)] = 81653,
  [SMALL_STATE(3308)] = 81721,
  [SMALL_STATE(3309)] = 81827,
  [SMALL_STATE(3310)] = 81901,
  [SMALL_STATE(3311)] = 81963,
  [SMALL_STATE(3312)] = 82025,
  [SMALL_STATE(3313)] = 82087,
  [SMALL_STATE(3314)] = 82153,
  [SMALL_STATE(3315)] = 82215,
  [SMALL_STATE(3316)] = 82313,
  [SMALL_STATE(3317)] = 82383,
  [SMALL_STATE(3318)] = 82445,
  [SMALL_STATE(3319)] = 82553,
  [SMALL_STATE(3320)] = 82619,
  [SMALL_STATE(3321)] = 82725,
  [SMALL_STATE(3322)] = 82795,
  [SMALL_STATE(3323)] = 82869,
  [SMALL_STATE(3324)] = 82937,
  [SMALL_STATE(3325)] = 82999,
  [SMALL_STATE(3326)] = 83103,
  [SMALL_STATE(3327)] = 83207,
  [SMALL_STATE(3328)] = 83269,
  [SMALL_STATE(3329)] = 83373,
  [SMALL_STATE(3330)] = 83477,
  [SMALL_STATE(3331)] = 83581,
  [SMALL_STATE(3332)] = 83685,
  [SMALL_STATE(3333)] = 83789,
  [SMALL_STATE(3334)] = 83893,
  [SMALL_STATE(3335)] = 83999,
  [SMALL_STATE(3336)] = 84103,
  [SMALL_STATE(3337)] = 84207,
  [SMALL_STATE(3338)] = 84311,
  [SMALL_STATE(3339)] = 84415,
  [SMALL_STATE(3340)] = 84499,
  [SMALL_STATE(3341)] = 84561,
  [SMALL_STATE(3342)] = 84665,
  [SMALL_STATE(3343)] = 84769,
  [SMALL_STATE(3344)] = 84831,
  [SMALL_STATE(3345)] = 84893,
  [SMALL_STATE(3346)] = 84955,
  [SMALL_STATE(3347)] = 85025,
  [SMALL_STATE(3348)] = 85087,
  [SMALL_STATE(3349)] = 85157,
  [SMALL_STATE(3350)] = 85227,
  [SMALL_STATE(3351)] = 85289,
  [SMALL_STATE(3352)] = 85359,
  [SMALL_STATE(3353)] = 85421,
  [SMALL_STATE(3354)] = 85483,
  [SMALL_STATE(3355)] = 85553,
  [SMALL_STATE(3356)] = 85615,
  [SMALL_STATE(3357)] = 85677,
  [SMALL_STATE(3358)] = 85743,
  [SMALL_STATE(3359)] = 85809,
  [SMALL_STATE(3360)] = 85871,
  [SMALL_STATE(3361)] = 85933,
  [SMALL_STATE(3362)] = 85995,
  [SMALL_STATE(3363)] = 86057,
  [SMALL_STATE(3364)] = 86127,
  [SMALL_STATE(3365)] = 86189,
  [SMALL_STATE(3366)] = 86251,
  [SMALL_STATE(3367)] = 86321,
  [SMALL_STATE(3368)] = 86383,
  [SMALL_STATE(3369)] = 86445,
  [SMALL_STATE(3370)] = 86507,
  [SMALL_STATE(3371)] = 86569,
  [SMALL_STATE(3372)] = 86642,
  [SMALL_STATE(3373)] = 86711,
  [SMALL_STATE(3374)] = 86774,
  [SMALL_STATE(3375)] = 86877,
  [SMALL_STATE(3376)] = 86946,
  [SMALL_STATE(3377)] = 87007,
  [SMALL_STATE(3378)] = 87072,
  [SMALL_STATE(3379)] = 87139,
  [SMALL_STATE(3380)] = 87242,
  [SMALL_STATE(3381)] = 87309,
  [SMALL_STATE(3382)] = 87372,
  [SMALL_STATE(3383)] = 87481,
  [SMALL_STATE(3384)] = 87544,
  [SMALL_STATE(3385)] = 87617,
  [SMALL_STATE(3386)] = 87684,
  [SMALL_STATE(3387)] = 87751,
  [SMALL_STATE(3388)] = 87854,
  [SMALL_STATE(3389)] = 87929,
  [SMALL_STATE(3390)] = 87996,
  [SMALL_STATE(3391)] = 88063,
  [SMALL_STATE(3392)] = 88130,
  [SMALL_STATE(3393)] = 88205,
  [SMALL_STATE(3394)] = 88282,
  [SMALL_STATE(3395)] = 88355,
  [SMALL_STATE(3396)] = 88432,
  [SMALL_STATE(3397)] = 88505,
  [SMALL_STATE(3398)] = 88574,
  [SMALL_STATE(3399)] = 88639,
  [SMALL_STATE(3400)] = 88716,
  [SMALL_STATE(3401)] = 88789,
  [SMALL_STATE(3402)] = 88862,
  [SMALL_STATE(3403)] = 88927,
  [SMALL_STATE(3404)] = 89000,
  [SMALL_STATE(3405)] = 89065,
  [SMALL_STATE(3406)] = 89132,
  [SMALL_STATE(3407)] = 89199,
  [SMALL_STATE(3408)] = 89268,
  [SMALL_STATE(3409)] = 89333,
  [SMALL_STATE(3410)] = 89400,
  [SMALL_STATE(3411)] = 89467,
  [SMALL_STATE(3412)] = 89534,
  [SMALL_STATE(3413)] = 89637,
  [SMALL_STATE(3414)] = 89704,
  [SMALL_STATE(3415)] = 89773,
  [SMALL_STATE(3416)] = 89838,
  [SMALL_STATE(3417)] = 89903,
  [SMALL_STATE(3418)] = 89970,
  [SMALL_STATE(3419)] = 90037,
  [SMALL_STATE(3420)] = 90100,
  [SMALL_STATE(3421)] = 90173,
  [SMALL_STATE(3422)] = 90276,
  [SMALL_STATE(3423)] = 90343,
  [SMALL_STATE(3424)] = 90446,
  [SMALL_STATE(3425)] = 90511,
  [SMALL_STATE(3426)] = 90580,
  [SMALL_STATE(3427)] = 90653,
  [SMALL_STATE(3428)] = 90730,
  [SMALL_STATE(3429)] = 90797,
  [SMALL_STATE(3430)] = 90870,
  [SMALL_STATE(3431)] = 90943,
  [SMALL_STATE(3432)] = 91020,
  [SMALL_STATE(3433)] = 91093,
  [SMALL_STATE(3434)] = 91170,
  [SMALL_STATE(3435)] = 91237,
  [SMALL_STATE(3436)] = 91312,
  [SMALL_STATE(3437)] = 91379,
  [SMALL_STATE(3438)] = 91454,
  [SMALL_STATE(3439)] = 91521,
  [SMALL_STATE(3440)] = 91590,
  [SMALL_STATE(3441)] = 91657,
  [SMALL_STATE(3442)] = 91724,
  [SMALL_STATE(3443)] = 91827,
  [SMALL_STATE(3444)] = 91896,
  [SMALL_STATE(3445)] = 91965,
  [SMALL_STATE(3446)] = 92032,
  [SMALL_STATE(3447)] = 92101,
  [SMALL_STATE(3448)] = 92168,
  [SMALL_STATE(3449)] = 92237,
  [SMALL_STATE(3450)] = 92304,
  [SMALL_STATE(3451)] = 92411,
  [SMALL_STATE(3452)] = 92478,
  [SMALL_STATE(3453)] = 92545,
  [SMALL_STATE(3454)] = 92612,
  [SMALL_STATE(3455)] = 92681,
  [SMALL_STATE(3456)] = 92748,
  [SMALL_STATE(3457)] = 92834,
  [SMALL_STATE(3458)] = 92898,
  [SMALL_STATE(3459)] = 92958,
  [SMALL_STATE(3460)] = 93024,
  [SMALL_STATE(3461)] = 93084,
  [SMALL_STATE(3462)] = 93144,
  [SMALL_STATE(3463)] = 93204,
  [SMALL_STATE(3464)] = 93264,
  [SMALL_STATE(3465)] = 93324,
  [SMALL_STATE(3466)] = 93384,
  [SMALL_STATE(3467)] = 93444,
  [SMALL_STATE(3468)] = 93548,
  [SMALL_STATE(3469)] = 93608,
  [SMALL_STATE(3470)] = 93668,
  [SMALL_STATE(3471)] = 93728,
  [SMALL_STATE(3472)] = 93796,
  [SMALL_STATE(3473)] = 93872,
  [SMALL_STATE(3474)] = 93950,
  [SMALL_STATE(3475)] = 94038,
  [SMALL_STATE(3476)] = 94098,
  [SMALL_STATE(3477)] = 94164,
  [SMALL_STATE(3478)] = 94256,
  [SMALL_STATE(3479)] = 94350,
  [SMALL_STATE(3480)] = 94430,
  [SMALL_STATE(3481)] = 94496,
  [SMALL_STATE(3482)] = 94578,
  [SMALL_STATE(3483)] = 94650,
  [SMALL_STATE(3484)] = 94710,
  [SMALL_STATE(3485)] = 94816,
  [SMALL_STATE(3486)] = 94900,
  [SMALL_STATE(3487)] = 94960,
  [SMALL_STATE(3488)] = 95020,
  [SMALL_STATE(3489)] = 95080,
  [SMALL_STATE(3490)] = 95140,
  [SMALL_STATE(3491)] = 95200,
  [SMALL_STATE(3492)] = 95260,
  [SMALL_STATE(3493)] = 95320,
  [SMALL_STATE(3494)] = 95384,
  [SMALL_STATE(3495)] = 95448,
  [SMALL_STATE(3496)] = 95508,
  [SMALL_STATE(3497)] = 95572,
  [SMALL_STATE(3498)] = 95636,
  [SMALL_STATE(3499)] = 95700,
  [SMALL_STATE(3500)] = 95760,
  [SMALL_STATE(3501)] = 95820,
  [SMALL_STATE(3502)] = 95886,
  [SMALL_STATE(3503)] = 95946,
  [SMALL_STATE(3504)] = 96006,
  [SMALL_STATE(3505)] = 96110,
  [SMALL_STATE(3506)] = 96170,
  [SMALL_STATE(3507)] = 96230,
  [SMALL_STATE(3508)] = 96290,
  [SMALL_STATE(3509)] = 96354,
  [SMALL_STATE(3510)] = 96414,
  [SMALL_STATE(3511)] = 96474,
  [SMALL_STATE(3512)] = 96542,
  [SMALL_STATE(3513)] = 96602,
  [SMALL_STATE(3514)] = 96662,
  [SMALL_STATE(3515)] = 96728,
  [SMALL_STATE(3516)] = 96788,
  [SMALL_STATE(3517)] = 96848,
  [SMALL_STATE(3518)] = 96910,
  [SMALL_STATE(3519)] = 96970,
  [SMALL_STATE(3520)] = 97030,
  [SMALL_STATE(3521)] = 97094,
  [SMALL_STATE(3522)] = 97154,
  [SMALL_STATE(3523)] = 97218,
  [SMALL_STATE(3524)] = 97278,
  [SMALL_STATE(3525)] = 97338,
  [SMALL_STATE(3526)] = 97434,
  [SMALL_STATE(3527)] = 97494,
  [SMALL_STATE(3528)] = 97554,
  [SMALL_STATE(3529)] = 97614,
  [SMALL_STATE(3530)] = 97678,
  [SMALL_STATE(3531)] = 97738,
  [SMALL_STATE(3532)] = 97798,
  [SMALL_STATE(3533)] = 97858,
  [SMALL_STATE(3534)] = 97918,
  [SMALL_STATE(3535)] = 97984,
  [SMALL_STATE(3536)] = 98044,
  [SMALL_STATE(3537)] = 98104,
  [SMALL_STATE(3538)] = 98164,
  [SMALL_STATE(3539)] = 98232,
  [SMALL_STATE(3540)] = 98296,
  [SMALL_STATE(3541)] = 98356,
  [SMALL_STATE(3542)] = 98416,
  [SMALL_STATE(3543)] = 98476,
  [SMALL_STATE(3544)] = 98536,
  [SMALL_STATE(3545)] = 98596,
  [SMALL_STATE(3546)] = 98662,
  [SMALL_STATE(3547)] = 98722,
  [SMALL_STATE(3548)] = 98782,
  [SMALL_STATE(3549)] = 98842,
  [SMALL_STATE(3550)] = 98902,
  [SMALL_STATE(3551)] = 98962,
  [SMALL_STATE(3552)] = 99022,
  [SMALL_STATE(3553)] = 99082,
  [SMALL_STATE(3554)] = 99142,
  [SMALL_STATE(3555)] = 99202,
  [SMALL_STATE(3556)] = 99308,
  [SMALL_STATE(3557)] = 99368,
  [SMALL_STATE(3558)] = 99434,
  [SMALL_STATE(3559)] = 99494,
  [SMALL_STATE(3560)] = 99554,
  [SMALL_STATE(3561)] = 99614,
  [SMALL_STATE(3562)] = 99674,
  [SMALL_STATE(3563)] = 99734,
  [SMALL_STATE(3564)] = 99794,
  [SMALL_STATE(3565)] = 99858,
  [SMALL_STATE(3566)] = 99922,
  [SMALL_STATE(3567)] = 100034,
  [SMALL_STATE(3568)] = 100094,
  [SMALL_STATE(3569)] = 100154,
  [SMALL_STATE(3570)] = 100218,
  [SMALL_STATE(3571)] = 100282,
  [SMALL_STATE(3572)] = 100342,
  [SMALL_STATE(3573)] = 100402,
  [SMALL_STATE(3574)] = 100462,
  [SMALL_STATE(3575)] = 100522,
  [SMALL_STATE(3576)] = 100582,
  [SMALL_STATE(3577)] = 100642,
  [SMALL_STATE(3578)] = 100704,
  [SMALL_STATE(3579)] = 100768,
  [SMALL_STATE(3580)] = 100828,
  [SMALL_STATE(3581)] = 100888,
  [SMALL_STATE(3582)] = 100948,
  [SMALL_STATE(3583)] = 101014,
  [SMALL_STATE(3584)] = 101074,
  [SMALL_STATE(3585)] = 101134,
  [SMALL_STATE(3586)] = 101194,
  [SMALL_STATE(3587)] = 101256,
  [SMALL_STATE(3588)] = 101316,
  [SMALL_STATE(3589)] = 101382,
  [SMALL_STATE(3590)] = 101446,
  [SMALL_STATE(3591)] = 101506,
  [SMALL_STATE(3592)] = 101566,
  [SMALL_STATE(3593)] = 101626,
  [SMALL_STATE(3594)] = 101686,
  [SMALL_STATE(3595)] = 101746,
  [SMALL_STATE(3596)] = 101814,
  [SMALL_STATE(3597)] = 101874,
  [SMALL_STATE(3598)] = 101942,
  [SMALL_STATE(3599)] = 102002,
  [SMALL_STATE(3600)] = 102062,
  [SMALL_STATE(3601)] = 102126,
  [SMALL_STATE(3602)] = 102186,
  [SMALL_STATE(3603)] = 102246,
  [SMALL_STATE(3604)] = 102310,
  [SMALL_STATE(3605)] = 102374,
  [SMALL_STATE(3606)] = 102436,
  [SMALL_STATE(3607)] = 102500,
  [SMALL_STATE(3608)] = 102566,
  [SMALL_STATE(3609)] = 102626,
  [SMALL_STATE(3610)] = 102686,
  [SMALL_STATE(3611)] = 102746,
  [SMALL_STATE(3612)] = 102806,
  [SMALL_STATE(3613)] = 102866,
  [SMALL_STATE(3614)] = 102926,
  [SMALL_STATE(3615)] = 102986,
  [SMALL_STATE(3616)] = 103050,
  [SMALL_STATE(3617)] = 103110,
  [SMALL_STATE(3618)] = 103170,
  [SMALL_STATE(3619)] = 103230,
  [SMALL_STATE(3620)] = 103290,
  [SMALL_STATE(3621)] = 103350,
  [SMALL_STATE(3622)] = 103410,
  [SMALL_STATE(3623)] = 103470,
  [SMALL_STATE(3624)] = 103530,
  [SMALL_STATE(3625)] = 103590,
  [SMALL_STATE(3626)] = 103650,
  [SMALL_STATE(3627)] = 103710,
  [SMALL_STATE(3628)] = 103770,
  [SMALL_STATE(3629)] = 103830,
  [SMALL_STATE(3630)] = 103890,
  [SMALL_STATE(3631)] = 103950,
  [SMALL_STATE(3632)] = 104010,
  [SMALL_STATE(3633)] = 104070,
  [SMALL_STATE(3634)] = 104130,
  [SMALL_STATE(3635)] = 104190,
  [SMALL_STATE(3636)] = 104250,
  [SMALL_STATE(3637)] = 104354,
  [SMALL_STATE(3638)] = 104413,
  [SMALL_STATE(3639)] = 104472,
  [SMALL_STATE(3640)] = 104539,
  [SMALL_STATE(3641)] = 104598,
  [SMALL_STATE(3642)] = 104657,
  [SMALL_STATE(3643)] = 104716,
  [SMALL_STATE(3644)] = 104775,
  [SMALL_STATE(3645)] = 104834,
  [SMALL_STATE(3646)] = 104893,
  [SMALL_STATE(3647)] = 104952,
  [SMALL_STATE(3648)] = 105011,
  [SMALL_STATE(3649)] = 105074,
  [SMALL_STATE(3650)] = 105133,
  [SMALL_STATE(3651)] = 105192,
  [SMALL_STATE(3652)] = 105293,
  [SMALL_STATE(3653)] = 105352,
  [SMALL_STATE(3654)] = 105411,
  [SMALL_STATE(3655)] = 105478,
  [SMALL_STATE(3656)] = 105545,
  [SMALL_STATE(3657)] = 105604,
  [SMALL_STATE(3658)] = 105663,
  [SMALL_STATE(3659)] = 105726,
  [SMALL_STATE(3660)] = 105785,
  [SMALL_STATE(3661)] = 105844,
  [SMALL_STATE(3662)] = 105903,
  [SMALL_STATE(3663)] = 105964,
  [SMALL_STATE(3664)] = 106031,
  [SMALL_STATE(3665)] = 106096,
  [SMALL_STATE(3666)] = 106197,
  [SMALL_STATE(3667)] = 106256,
  [SMALL_STATE(3668)] = 106315,
  [SMALL_STATE(3669)] = 106374,
  [SMALL_STATE(3670)] = 106441,
  [SMALL_STATE(3671)] = 106500,
  [SMALL_STATE(3672)] = 106563,
  [SMALL_STATE(3673)] = 106622,
  [SMALL_STATE(3674)] = 106681,
  [SMALL_STATE(3675)] = 106748,
  [SMALL_STATE(3676)] = 106807,
  [SMALL_STATE(3677)] = 106866,
  [SMALL_STATE(3678)] = 106925,
  [SMALL_STATE(3679)] = 106988,
  [SMALL_STATE(3680)] = 107047,
  [SMALL_STATE(3681)] = 107106,
  [SMALL_STATE(3682)] = 107167,
  [SMALL_STATE(3683)] = 107230,
  [SMALL_STATE(3684)] = 107331,
  [SMALL_STATE(3685)] = 107390,
  [SMALL_STATE(3686)] = 107449,
  [SMALL_STATE(3687)] = 107508,
  [SMALL_STATE(3688)] = 107567,
  [SMALL_STATE(3689)] = 107626,
  [SMALL_STATE(3690)] = 107685,
  [SMALL_STATE(3691)] = 107744,
  [SMALL_STATE(3692)] = 107803,
  [SMALL_STATE(3693)] = 107862,
  [SMALL_STATE(3694)] = 107921,
  [SMALL_STATE(3695)] = 107980,
  [SMALL_STATE(3696)] = 108047,
  [SMALL_STATE(3697)] = 108106,
  [SMALL_STATE(3698)] = 108173,
  [SMALL_STATE(3699)] = 108240,
  [SMALL_STATE(3700)] = 108341,
  [SMALL_STATE(3701)] = 108400,
  [SMALL_STATE(3702)] = 108501,
  [SMALL_STATE(3703)] = 108560,
  [SMALL_STATE(3704)] = 108625,
  [SMALL_STATE(3705)] = 108686,
  [SMALL_STATE(3706)] = 108753,
  [SMALL_STATE(3707)] = 108812,
  [SMALL_STATE(3708)] = 108871,
  [SMALL_STATE(3709)] = 108972,
  [SMALL_STATE(3710)] = 109031,
  [SMALL_STATE(3711)] = 109090,
  [SMALL_STATE(3712)] = 109149,
  [SMALL_STATE(3713)] = 109208,
  [SMALL_STATE(3714)] = 109309,
  [SMALL_STATE(3715)] = 109376,
  [SMALL_STATE(3716)] = 109443,
  [SMALL_STATE(3717)] = 109508,
  [SMALL_STATE(3718)] = 109566,
  [SMALL_STATE(3719)] = 109624,
  [SMALL_STATE(3720)] = 109682,
  [SMALL_STATE(3721)] = 109740,
  [SMALL_STATE(3722)] = 109804,
  [SMALL_STATE(3723)] = 109862,
  [SMALL_STATE(3724)] = 109920,
  [SMALL_STATE(3725)] = 109978,
  [SMALL_STATE(3726)] = 110036,
  [SMALL_STATE(3727)] = 110094,
  [SMALL_STATE(3728)] = 110152,
  [SMALL_STATE(3729)] = 110216,
  [SMALL_STATE(3730)] = 110274,
  [SMALL_STATE(3731)] = 110332,
  [SMALL_STATE(3732)] = 110390,
  [SMALL_STATE(3733)] = 110448,
  [SMALL_STATE(3734)] = 110506,
  [SMALL_STATE(3735)] = 110570,
  [SMALL_STATE(3736)] = 110634,
  [SMALL_STATE(3737)] = 110698,
  [SMALL_STATE(3738)] = 110762,
  [SMALL_STATE(3739)] = 110826,
  [SMALL_STATE(3740)] = 110890,
  [SMALL_STATE(3741)] = 110954,
  [SMALL_STATE(3742)] = 111018,
  [SMALL_STATE(3743)] = 111126,
  [SMALL_STATE(3744)] = 111184,
  [SMALL_STATE(3745)] = 111284,
  [SMALL_STATE(3746)] = 111342,
  [SMALL_STATE(3747)] = 111442,
  [SMALL_STATE(3748)] = 111502,
  [SMALL_STATE(3749)] = 111560,
  [SMALL_STATE(3750)] = 111618,
  [SMALL_STATE(3751)] = 111676,
  [SMALL_STATE(3752)] = 111734,
  [SMALL_STATE(3753)] = 111792,
  [SMALL_STATE(3754)] = 111850,
  [SMALL_STATE(3755)] = 111908,
  [SMALL_STATE(3756)] = 111966,
  [SMALL_STATE(3757)] = 112024,
  [SMALL_STATE(3758)] = 112082,
  [SMALL_STATE(3759)] = 112146,
  [SMALL_STATE(3760)] = 112204,
  [SMALL_STATE(3761)] = 112262,
  [SMALL_STATE(3762)] = 112324,
  [SMALL_STATE(3763)] = 112382,
  [SMALL_STATE(3764)] = 112440,
  [SMALL_STATE(3765)] = 112498,
  [SMALL_STATE(3766)] = 112556,
  [SMALL_STATE(3767)] = 112614,
  [SMALL_STATE(3768)] = 112676,
  [SMALL_STATE(3769)] = 112734,
  [SMALL_STATE(3770)] = 112792,
  [SMALL_STATE(3771)] = 112850,
  [SMALL_STATE(3772)] = 112908,
  [SMALL_STATE(3773)] = 112966,
  [SMALL_STATE(3774)] = 113024,
  [SMALL_STATE(3775)] = 113124,
  [SMALL_STATE(3776)] = 113182,
  [SMALL_STATE(3777)] = 113242,
  [SMALL_STATE(3778)] = 113300,
  [SMALL_STATE(3779)] = 113358,
  [SMALL_STATE(3780)] = 113416,
  [SMALL_STATE(3781)] = 113516,
  [SMALL_STATE(3782)] = 113574,
  [SMALL_STATE(3783)] = 113632,
  [SMALL_STATE(3784)] = 113690,
  [SMALL_STATE(3785)] = 113748,
  [SMALL_STATE(3786)] = 113806,
  [SMALL_STATE(3787)] = 113876,
  [SMALL_STATE(3788)] = 113946,
  [SMALL_STATE(3789)] = 114016,
  [SMALL_STATE(3790)] = 114074,
  [SMALL_STATE(3791)] = 114148,
  [SMALL_STATE(3792)] = 114218,
  [SMALL_STATE(3793)] = 114288,
  [SMALL_STATE(3794)] = 114346,
  [SMALL_STATE(3795)] = 114404,
  [SMALL_STATE(3796)] = 114466,
  [SMALL_STATE(3797)] = 114566,
  [SMALL_STATE(3798)] = 114624,
  [SMALL_STATE(3799)] = 114682,
  [SMALL_STATE(3800)] = 114740,
  [SMALL_STATE(3801)] = 114814,
  [SMALL_STATE(3802)] = 114872,
  [SMALL_STATE(3803)] = 114930,
  [SMALL_STATE(3804)] = 114988,
  [SMALL_STATE(3805)] = 115046,
  [SMALL_STATE(3806)] = 115104,
  [SMALL_STATE(3807)] = 115162,
  [SMALL_STATE(3808)] = 115220,
  [SMALL_STATE(3809)] = 115284,
  [SMALL_STATE(3810)] = 115342,
  [SMALL_STATE(3811)] = 115400,
  [SMALL_STATE(3812)] = 115458,
  [SMALL_STATE(3813)] = 115516,
  [SMALL_STATE(3814)] = 115574,
  [SMALL_STATE(3815)] = 115632,
  [SMALL_STATE(3816)] = 115690,
  [SMALL_STATE(3817)] = 115760,
  [SMALL_STATE(3818)] = 115834,
  [SMALL_STATE(3819)] = 115896,
  [SMALL_STATE(3820)] = 115954,
  [SMALL_STATE(3821)] = 116026,
  [SMALL_STATE(3822)] = 116084,
  [SMALL_STATE(3823)] = 116156,
  [SMALL_STATE(3824)] = 116214,
  [SMALL_STATE(3825)] = 116276,
  [SMALL_STATE(3826)] = 116334,
  [SMALL_STATE(3827)] = 116392,
  [SMALL_STATE(3828)] = 116456,
  [SMALL_STATE(3829)] = 116514,
  [SMALL_STATE(3830)] = 116572,
  [SMALL_STATE(3831)] = 116630,
  [SMALL_STATE(3832)] = 116688,
  [SMALL_STATE(3833)] = 116746,
  [SMALL_STATE(3834)] = 116804,
  [SMALL_STATE(3835)] = 116862,
  [SMALL_STATE(3836)] = 116924,
  [SMALL_STATE(3837)] = 116982,
  [SMALL_STATE(3838)] = 117040,
  [SMALL_STATE(3839)] = 117104,
  [SMALL_STATE(3840)] = 117162,
  [SMALL_STATE(3841)] = 117226,
  [SMALL_STATE(3842)] = 117284,
  [SMALL_STATE(3843)] = 117342,
  [SMALL_STATE(3844)] = 117400,
  [SMALL_STATE(3845)] = 117458,
  [SMALL_STATE(3846)] = 117516,
  [SMALL_STATE(3847)] = 117574,
  [SMALL_STATE(3848)] = 117632,
  [SMALL_STATE(3849)] = 117690,
  [SMALL_STATE(3850)] = 117790,
  [SMALL_STATE(3851)] = 117890,
  [SMALL_STATE(3852)] = 117948,
  [SMALL_STATE(3853)] = 118048,
  [SMALL_STATE(3854)] = 118148,
  [SMALL_STATE(3855)] = 118206,
  [SMALL_STATE(3856)] = 118306,
  [SMALL_STATE(3857)] = 118406,
  [SMALL_STATE(3858)] = 118506,
  [SMALL_STATE(3859)] = 118564,
  [SMALL_STATE(3860)] = 118622,
  [SMALL_STATE(3861)] = 118680,
  [SMALL_STATE(3862)] = 118738,
  [SMALL_STATE(3863)] = 118796,
  [SMALL_STATE(3864)] = 118854,
  [SMALL_STATE(3865)] = 118954,
  [SMALL_STATE(3866)] = 119012,
  [SMALL_STATE(3867)] = 119070,
  [SMALL_STATE(3868)] = 119128,
  [SMALL_STATE(3869)] = 119186,
  [SMALL_STATE(3870)] = 119244,
  [SMALL_STATE(3871)] = 119302,
  [SMALL_STATE(3872)] = 119360,
  [SMALL_STATE(3873)] = 119418,
  [SMALL_STATE(3874)] = 119518,
  [SMALL_STATE(3875)] = 119618,
  [SMALL_STATE(3876)] = 119718,
  [SMALL_STATE(3877)] = 119776,
  [SMALL_STATE(3878)] = 119840,
  [SMALL_STATE(3879)] = 119898,
  [SMALL_STATE(3880)] = 119958,
  [SMALL_STATE(3881)] = 120016,
  [SMALL_STATE(3882)] = 120074,
  [SMALL_STATE(3883)] = 120132,
  [SMALL_STATE(3884)] = 120190,
  [SMALL_STATE(3885)] = 120248,
  [SMALL_STATE(3886)] = 120306,
  [SMALL_STATE(3887)] = 120364,
  [SMALL_STATE(3888)] = 120422,
  [SMALL_STATE(3889)] = 120480,
  [SMALL_STATE(3890)] = 120538,
  [SMALL_STATE(3891)] = 120600,
  [SMALL_STATE(3892)] = 120708,
  [SMALL_STATE(3893)] = 120770,
  [SMALL_STATE(3894)] = 120832,
  [SMALL_STATE(3895)] = 120890,
  [SMALL_STATE(3896)] = 120954,
  [SMALL_STATE(3897)] = 121012,
  [SMALL_STATE(3898)] = 121070,
  [SMALL_STATE(3899)] = 121128,
  [SMALL_STATE(3900)] = 121228,
  [SMALL_STATE(3901)] = 121286,
  [SMALL_STATE(3902)] = 121348,
  [SMALL_STATE(3903)] = 121448,
  [SMALL_STATE(3904)] = 121510,
  [SMALL_STATE(3905)] = 121568,
  [SMALL_STATE(3906)] = 121626,
  [SMALL_STATE(3907)] = 121688,
  [SMALL_STATE(3908)] = 121746,
  [SMALL_STATE(3909)] = 121846,
  [SMALL_STATE(3910)] = 121904,
  [SMALL_STATE(3911)] = 122004,
  [SMALL_STATE(3912)] = 122066,
  [SMALL_STATE(3913)] = 122124,
  [SMALL_STATE(3914)] = 122184,
  [SMALL_STATE(3915)] = 122242,
  [SMALL_STATE(3916)] = 122300,
  [SMALL_STATE(3917)] = 122400,
  [SMALL_STATE(3918)] = 122458,
  [SMALL_STATE(3919)] = 122516,
  [SMALL_STATE(3920)] = 122580,
  [SMALL_STATE(3921)] = 122638,
  [SMALL_STATE(3922)] = 122695,
  [SMALL_STATE(3923)] = 122756,
  [SMALL_STATE(3924)] = 122821,
  [SMALL_STATE(3925)] = 122878,
  [SMALL_STATE(3926)] = 122935,
  [SMALL_STATE(3927)] = 122992,
  [SMALL_STATE(3928)] = 123057,
  [SMALL_STATE(3929)] = 123114,
  [SMALL_STATE(3930)] = 123171,
  [SMALL_STATE(3931)] = 123228,
  [SMALL_STATE(3932)] = 123285,
  [SMALL_STATE(3933)] = 123388,
  [SMALL_STATE(3934)] = 123449,
  [SMALL_STATE(3935)] = 123506,
  [SMALL_STATE(3936)] = 123563,
  [SMALL_STATE(3937)] = 123620,
  [SMALL_STATE(3938)] = 123677,
  [SMALL_STATE(3939)] = 123734,
  [SMALL_STATE(3940)] = 123791,
  [SMALL_STATE(3941)] = 123872,
  [SMALL_STATE(3942)] = 123975,
  [SMALL_STATE(3943)] = 124032,
  [SMALL_STATE(3944)] = 124089,
  [SMALL_STATE(3945)] = 124146,
  [SMALL_STATE(3946)] = 124203,
  [SMALL_STATE(3947)] = 124260,
  [SMALL_STATE(3948)] = 124329,
  [SMALL_STATE(3949)] = 124390,
  [SMALL_STATE(3950)] = 124447,
  [SMALL_STATE(3951)] = 124504,
  [SMALL_STATE(3952)] = 124561,
  [SMALL_STATE(3953)] = 124618,
  [SMALL_STATE(3954)] = 124679,
  [SMALL_STATE(3955)] = 124748,
  [SMALL_STATE(3956)] = 124805,
  [SMALL_STATE(3957)] = 124862,
  [SMALL_STATE(3958)] = 124931,
  [SMALL_STATE(3959)] = 125000,
  [SMALL_STATE(3960)] = 125073,
  [SMALL_STATE(3961)] = 125142,
  [SMALL_STATE(3962)] = 125201,
  [SMALL_STATE(3963)] = 125258,
  [SMALL_STATE(3964)] = 125315,
  [SMALL_STATE(3965)] = 125374,
  [SMALL_STATE(3966)] = 125431,
  [SMALL_STATE(3967)] = 125500,
  [SMALL_STATE(3968)] = 125557,
  [SMALL_STATE(3969)] = 125614,
  [SMALL_STATE(3970)] = 125715,
  [SMALL_STATE(3971)] = 125808,
  [SMALL_STATE(3972)] = 125865,
  [SMALL_STATE(3973)] = 125938,
  [SMALL_STATE(3974)] = 126007,
  [SMALL_STATE(3975)] = 126080,
  [SMALL_STATE(3976)] = 126141,
  [SMALL_STATE(3977)] = 126212,
  [SMALL_STATE(3978)] = 126283,
  [SMALL_STATE(3979)] = 126362,
  [SMALL_STATE(3980)] = 126419,
  [SMALL_STATE(3981)] = 126496,
  [SMALL_STATE(3982)] = 126553,
  [SMALL_STATE(3983)] = 126610,
  [SMALL_STATE(3984)] = 126699,
  [SMALL_STATE(3985)] = 126760,
  [SMALL_STATE(3986)] = 126817,
  [SMALL_STATE(3987)] = 126902,
  [SMALL_STATE(3988)] = 126985,
  [SMALL_STATE(3989)] = 127060,
  [SMALL_STATE(3990)] = 127121,
  [SMALL_STATE(3991)] = 127194,
  [SMALL_STATE(3992)] = 127251,
  [SMALL_STATE(3993)] = 127308,
  [SMALL_STATE(3994)] = 127413,
  [SMALL_STATE(3995)] = 127470,
  [SMALL_STATE(3996)] = 127527,
  [SMALL_STATE(3997)] = 127584,
  [SMALL_STATE(3998)] = 127641,
  [SMALL_STATE(3999)] = 127742,
  [SMALL_STATE(4000)] = 127835,
  [SMALL_STATE(4001)] = 127892,
  [SMALL_STATE(4002)] = 127953,
  [SMALL_STATE(4003)] = 128010,
  [SMALL_STATE(4004)] = 128067,
  [SMALL_STATE(4005)] = 128128,
  [SMALL_STATE(4006)] = 128185,
  [SMALL_STATE(4007)] = 128242,
  [SMALL_STATE(4008)] = 128303,
  [SMALL_STATE(4009)] = 128362,
  [SMALL_STATE(4010)] = 128419,
  [SMALL_STATE(4011)] = 128484,
  [SMALL_STATE(4012)] = 128541,
  [SMALL_STATE(4013)] = 128598,
  [SMALL_STATE(4014)] = 128655,
  [SMALL_STATE(4015)] = 128754,
  [SMALL_STATE(4016)] = 128857,
  [SMALL_STATE(4017)] = 128914,
  [SMALL_STATE(4018)] = 128971,
  [SMALL_STATE(4019)] = 129028,
  [SMALL_STATE(4020)] = 129085,
  [SMALL_STATE(4021)] = 129190,
  [SMALL_STATE(4022)] = 129251,
  [SMALL_STATE(4023)] = 129308,
  [SMALL_STATE(4024)] = 129365,
  [SMALL_STATE(4025)] = 129464,
  [SMALL_STATE(4026)] = 129521,
  [SMALL_STATE(4027)] = 129578,
  [SMALL_STATE(4028)] = 129635,
  [SMALL_STATE(4029)] = 129740,
  [SMALL_STATE(4030)] = 129801,
  [SMALL_STATE(4031)] = 129900,
  [SMALL_STATE(4032)] = 129961,
  [SMALL_STATE(4033)] = 130026,
  [SMALL_STATE(4034)] = 130083,
  [SMALL_STATE(4035)] = 130148,
  [SMALL_STATE(4036)] = 130211,
  [SMALL_STATE(4037)] = 130268,
  [SMALL_STATE(4038)] = 130329,
  [SMALL_STATE(4039)] = 130386,
  [SMALL_STATE(4040)] = 130443,
  [SMALL_STATE(4041)] = 130500,
  [SMALL_STATE(4042)] = 130599,
  [SMALL_STATE(4043)] = 130656,
  [SMALL_STATE(4044)] = 130721,
  [SMALL_STATE(4045)] = 130798,
  [SMALL_STATE(4046)] = 130855,
  [SMALL_STATE(4047)] = 130912,
  [SMALL_STATE(4048)] = 130969,
  [SMALL_STATE(4049)] = 131026,
  [SMALL_STATE(4050)] = 131083,
  [SMALL_STATE(4051)] = 131140,
  [SMALL_STATE(4052)] = 131203,
  [SMALL_STATE(4053)] = 131260,
  [SMALL_STATE(4054)] = 131359,
  [SMALL_STATE(4055)] = 131458,
  [SMALL_STATE(4056)] = 131515,
  [SMALL_STATE(4057)] = 131574,
  [SMALL_STATE(4058)] = 131635,
  [SMALL_STATE(4059)] = 131696,
  [SMALL_STATE(4060)] = 131757,
  [SMALL_STATE(4061)] = 131856,
  [SMALL_STATE(4062)] = 131913,
  [SMALL_STATE(4063)] = 131970,
  [SMALL_STATE(4064)] = 132027,
  [SMALL_STATE(4065)] = 132092,
  [SMALL_STATE(4066)] = 132153,
  [SMALL_STATE(4067)] = 132210,
  [SMALL_STATE(4068)] = 132267,
  [SMALL_STATE(4069)] = 132324,
  [SMALL_STATE(4070)] = 132389,
  [SMALL_STATE(4071)] = 132452,
  [SMALL_STATE(4072)] = 132517,
  [SMALL_STATE(4073)] = 132580,
  [SMALL_STATE(4074)] = 132637,
  [SMALL_STATE(4075)] = 132696,
  [SMALL_STATE(4076)] = 132753,
  [SMALL_STATE(4077)] = 132816,
  [SMALL_STATE(4078)] = 132873,
  [SMALL_STATE(4079)] = 132930,
  [SMALL_STATE(4080)] = 132991,
  [SMALL_STATE(4081)] = 133054,
  [SMALL_STATE(4082)] = 133119,
  [SMALL_STATE(4083)] = 133176,
  [SMALL_STATE(4084)] = 133233,
  [SMALL_STATE(4085)] = 133296,
  [SMALL_STATE(4086)] = 133355,
  [SMALL_STATE(4087)] = 133412,
  [SMALL_STATE(4088)] = 133469,
  [SMALL_STATE(4089)] = 133534,
  [SMALL_STATE(4090)] = 133591,
  [SMALL_STATE(4091)] = 133648,
  [SMALL_STATE(4092)] = 133713,
  [SMALL_STATE(4093)] = 133770,
  [SMALL_STATE(4094)] = 133827,
  [SMALL_STATE(4095)] = 133884,
  [SMALL_STATE(4096)] = 133947,
  [SMALL_STATE(4097)] = 134006,
  [SMALL_STATE(4098)] = 134063,
  [SMALL_STATE(4099)] = 134124,
  [SMALL_STATE(4100)] = 134187,
  [SMALL_STATE(4101)] = 134244,
  [SMALL_STATE(4102)] = 134301,
  [SMALL_STATE(4103)] = 134366,
  [SMALL_STATE(4104)] = 134423,
  [SMALL_STATE(4105)] = 134480,
  [SMALL_STATE(4106)] = 134537,
  [SMALL_STATE(4107)] = 134594,
  [SMALL_STATE(4108)] = 134657,
  [SMALL_STATE(4109)] = 134714,
  [SMALL_STATE(4110)] = 134771,
  [SMALL_STATE(4111)] = 134832,
  [SMALL_STATE(4112)] = 134889,
  [SMALL_STATE(4113)] = 134954,
  [SMALL_STATE(4114)] = 135017,
  [SMALL_STATE(4115)] = 135074,
  [SMALL_STATE(4116)] = 135131,
  [SMALL_STATE(4117)] = 135192,
  [SMALL_STATE(4118)] = 135249,
  [SMALL_STATE(4119)] = 135306,
  [SMALL_STATE(4120)] = 135363,
  [SMALL_STATE(4121)] = 135420,
  [SMALL_STATE(4122)] = 135477,
  [SMALL_STATE(4123)] = 135534,
  [SMALL_STATE(4124)] = 135591,
  [SMALL_STATE(4125)] = 135648,
  [SMALL_STATE(4126)] = 135749,
  [SMALL_STATE(4127)] = 135806,
  [SMALL_STATE(4128)] = 135897,
  [SMALL_STATE(4129)] = 135954,
  [SMALL_STATE(4130)] = 136011,
  [SMALL_STATE(4131)] = 136068,
  [SMALL_STATE(4132)] = 136169,
  [SMALL_STATE(4133)] = 136226,
  [SMALL_STATE(4134)] = 136283,
  [SMALL_STATE(4135)] = 136340,
  [SMALL_STATE(4136)] = 136397,
  [SMALL_STATE(4137)] = 136454,
  [SMALL_STATE(4138)] = 136511,
  [SMALL_STATE(4139)] = 136568,
  [SMALL_STATE(4140)] = 136625,
  [SMALL_STATE(4141)] = 136706,
  [SMALL_STATE(4142)] = 136763,
  [SMALL_STATE(4143)] = 136822,
  [SMALL_STATE(4144)] = 136879,
  [SMALL_STATE(4145)] = 136940,
  [SMALL_STATE(4146)] = 136997,
  [SMALL_STATE(4147)] = 137054,
  [SMALL_STATE(4148)] = 137119,
  [SMALL_STATE(4149)] = 137192,
  [SMALL_STATE(4150)] = 137295,
  [SMALL_STATE(4151)] = 137352,
  [SMALL_STATE(4152)] = 137417,
  [SMALL_STATE(4153)] = 137474,
  [SMALL_STATE(4154)] = 137533,
  [SMALL_STATE(4155)] = 137608,
  [SMALL_STATE(4156)] = 137691,
  [SMALL_STATE(4157)] = 137776,
  [SMALL_STATE(4158)] = 137833,
  [SMALL_STATE(4159)] = 137890,
  [SMALL_STATE(4160)] = 137979,
  [SMALL_STATE(4161)] = 138070,
  [SMALL_STATE(4162)] = 138127,
  [SMALL_STATE(4163)] = 138196,
  [SMALL_STATE(4164)] = 138253,
  [SMALL_STATE(4165)] = 138312,
  [SMALL_STATE(4166)] = 138391,
  [SMALL_STATE(4167)] = 138491,
  [SMALL_STATE(4168)] = 138547,
  [SMALL_STATE(4169)] = 138603,
  [SMALL_STATE(4170)] = 138701,
  [SMALL_STATE(4171)] = 138757,
  [SMALL_STATE(4172)] = 138813,
  [SMALL_STATE(4173)] = 138869,
  [SMALL_STATE(4174)] = 138925,
  [SMALL_STATE(4175)] = 138981,
  [SMALL_STATE(4176)] = 139037,
  [SMALL_STATE(4177)] = 139093,
  [SMALL_STATE(4178)] = 139149,
  [SMALL_STATE(4179)] = 139205,
  [SMALL_STATE(4180)] = 139261,
  [SMALL_STATE(4181)] = 139321,
  [SMALL_STATE(4182)] = 139383,
  [SMALL_STATE(4183)] = 139439,
  [SMALL_STATE(4184)] = 139495,
  [SMALL_STATE(4185)] = 139551,
  [SMALL_STATE(4186)] = 139613,
  [SMALL_STATE(4187)] = 139669,
  [SMALL_STATE(4188)] = 139725,
  [SMALL_STATE(4189)] = 139781,
  [SMALL_STATE(4190)] = 139837,
  [SMALL_STATE(4191)] = 139897,
  [SMALL_STATE(4192)] = 139953,
  [SMALL_STATE(4193)] = 140009,
  [SMALL_STATE(4194)] = 140065,
  [SMALL_STATE(4195)] = 140121,
  [SMALL_STATE(4196)] = 140177,
  [SMALL_STATE(4197)] = 140233,
  [SMALL_STATE(4198)] = 140289,
  [SMALL_STATE(4199)] = 140345,
  [SMALL_STATE(4200)] = 140401,
  [SMALL_STATE(4201)] = 140457,
  [SMALL_STATE(4202)] = 140517,
  [SMALL_STATE(4203)] = 140573,
  [SMALL_STATE(4204)] = 140629,
  [SMALL_STATE(4205)] = 140689,
  [SMALL_STATE(4206)] = 140753,
  [SMALL_STATE(4207)] = 140833,
  [SMALL_STATE(4208)] = 140905,
  [SMALL_STATE(4209)] = 140961,
  [SMALL_STATE(4210)] = 141017,
  [SMALL_STATE(4211)] = 141073,
  [SMALL_STATE(4212)] = 141129,
  [SMALL_STATE(4213)] = 141185,
  [SMALL_STATE(4214)] = 141241,
  [SMALL_STATE(4215)] = 141297,
  [SMALL_STATE(4216)] = 141353,
  [SMALL_STATE(4217)] = 141409,
  [SMALL_STATE(4218)] = 141483,
  [SMALL_STATE(4219)] = 141545,
  [SMALL_STATE(4220)] = 141643,
  [SMALL_STATE(4221)] = 141699,
  [SMALL_STATE(4222)] = 141755,
  [SMALL_STATE(4223)] = 141811,
  [SMALL_STATE(4224)] = 141867,
  [SMALL_STATE(4225)] = 141923,
  [SMALL_STATE(4226)] = 141979,
  [SMALL_STATE(4227)] = 142035,
  [SMALL_STATE(4228)] = 142091,
  [SMALL_STATE(4229)] = 142147,
  [SMALL_STATE(4230)] = 142203,
  [SMALL_STATE(4231)] = 142267,
  [SMALL_STATE(4232)] = 142323,
  [SMALL_STATE(4233)] = 142379,
  [SMALL_STATE(4234)] = 142435,
  [SMALL_STATE(4235)] = 142491,
  [SMALL_STATE(4236)] = 142547,
  [SMALL_STATE(4237)] = 142603,
  [SMALL_STATE(4238)] = 142659,
  [SMALL_STATE(4239)] = 142741,
  [SMALL_STATE(4240)] = 142797,
  [SMALL_STATE(4241)] = 142853,
  [SMALL_STATE(4242)] = 142937,
  [SMALL_STATE(4243)] = 143025,
  [SMALL_STATE(4244)] = 143115,
  [SMALL_STATE(4245)] = 143191,
  [SMALL_STATE(4246)] = 143247,
  [SMALL_STATE(4247)] = 143303,
  [SMALL_STATE(4248)] = 143359,
  [SMALL_STATE(4249)] = 143415,
  [SMALL_STATE(4250)] = 143471,
  [SMALL_STATE(4251)] = 143549,
  [SMALL_STATE(4252)] = 143607,
  [SMALL_STATE(4253)] = 143675,
  [SMALL_STATE(4254)] = 143731,
  [SMALL_STATE(4255)] = 143787,
  [SMALL_STATE(4256)] = 143843,
  [SMALL_STATE(4257)] = 143899,
  [SMALL_STATE(4258)] = 144001,
  [SMALL_STATE(4259)] = 144099,
  [SMALL_STATE(4260)] = 144155,
  [SMALL_STATE(4261)] = 144211,
  [SMALL_STATE(4262)] = 144267,
  [SMALL_STATE(4263)] = 144323,
  [SMALL_STATE(4264)] = 144423,
  [SMALL_STATE(4265)] = 144479,
  [SMALL_STATE(4266)] = 144577,
  [SMALL_STATE(4267)] = 144633,
  [SMALL_STATE(4268)] = 144689,
  [SMALL_STATE(4269)] = 144745,
  [SMALL_STATE(4270)] = 144801,
  [SMALL_STATE(4271)] = 144899,
  [SMALL_STATE(4272)] = 144959,
  [SMALL_STATE(4273)] = 145015,
  [SMALL_STATE(4274)] = 145071,
  [SMALL_STATE(4275)] = 145127,
  [SMALL_STATE(4276)] = 145187,
  [SMALL_STATE(4277)] = 145243,
  [SMALL_STATE(4278)] = 145299,
  [SMALL_STATE(4279)] = 145355,
  [SMALL_STATE(4280)] = 145411,
  [SMALL_STATE(4281)] = 145467,
  [SMALL_STATE(4282)] = 145523,
  [SMALL_STATE(4283)] = 145579,
  [SMALL_STATE(4284)] = 145635,
  [SMALL_STATE(4285)] = 145733,
  [SMALL_STATE(4286)] = 145789,
  [SMALL_STATE(4287)] = 145853,
  [SMALL_STATE(4288)] = 145909,
  [SMALL_STATE(4289)] = 145965,
  [SMALL_STATE(4290)] = 146021,
  [SMALL_STATE(4291)] = 146077,
  [SMALL_STATE(4292)] = 146133,
  [SMALL_STATE(4293)] = 146189,
  [SMALL_STATE(4294)] = 146295,
  [SMALL_STATE(4295)] = 146401,
  [SMALL_STATE(4296)] = 146459,
  [SMALL_STATE(4297)] = 146515,
  [SMALL_STATE(4298)] = 146575,
  [SMALL_STATE(4299)] = 146631,
  [SMALL_STATE(4300)] = 146687,
  [SMALL_STATE(4301)] = 146743,
  [SMALL_STATE(4302)] = 146799,
  [SMALL_STATE(4303)] = 146855,
  [SMALL_STATE(4304)] = 146911,
  [SMALL_STATE(4305)] = 146967,
  [SMALL_STATE(4306)] = 147023,
  [SMALL_STATE(4307)] = 147079,
  [SMALL_STATE(4308)] = 147135,
  [SMALL_STATE(4309)] = 147197,
  [SMALL_STATE(4310)] = 147253,
  [SMALL_STATE(4311)] = 147309,
  [SMALL_STATE(4312)] = 147369,
  [SMALL_STATE(4313)] = 147425,
  [SMALL_STATE(4314)] = 147481,
  [SMALL_STATE(4315)] = 147537,
  [SMALL_STATE(4316)] = 147593,
  [SMALL_STATE(4317)] = 147653,
  [SMALL_STATE(4318)] = 147713,
  [SMALL_STATE(4319)] = 147773,
  [SMALL_STATE(4320)] = 147833,
  [SMALL_STATE(4321)] = 147895,
  [SMALL_STATE(4322)] = 147951,
  [SMALL_STATE(4323)] = 148007,
  [SMALL_STATE(4324)] = 148063,
  [SMALL_STATE(4325)] = 148119,
  [SMALL_STATE(4326)] = 148175,
  [SMALL_STATE(4327)] = 148231,
  [SMALL_STATE(4328)] = 148287,
  [SMALL_STATE(4329)] = 148345,
  [SMALL_STATE(4330)] = 148401,
  [SMALL_STATE(4331)] = 148457,
  [SMALL_STATE(4332)] = 148513,
  [SMALL_STATE(4333)] = 148569,
  [SMALL_STATE(4334)] = 148625,
  [SMALL_STATE(4335)] = 148723,
  [SMALL_STATE(4336)] = 148779,
  [SMALL_STATE(4337)] = 148835,
  [SMALL_STATE(4338)] = 148891,
  [SMALL_STATE(4339)] = 148947,
  [SMALL_STATE(4340)] = 149003,
  [SMALL_STATE(4341)] = 149059,
  [SMALL_STATE(4342)] = 149157,
  [SMALL_STATE(4343)] = 149213,
  [SMALL_STATE(4344)] = 149311,
  [SMALL_STATE(4345)] = 149367,
  [SMALL_STATE(4346)] = 149465,
  [SMALL_STATE(4347)] = 149521,
  [SMALL_STATE(4348)] = 149619,
  [SMALL_STATE(4349)] = 149675,
  [SMALL_STATE(4350)] = 149731,
  [SMALL_STATE(4351)] = 149787,
  [SMALL_STATE(4352)] = 149885,
  [SMALL_STATE(4353)] = 149941,
  [SMALL_STATE(4354)] = 150039,
  [SMALL_STATE(4355)] = 150095,
  [SMALL_STATE(4356)] = 150193,
  [SMALL_STATE(4357)] = 150291,
  [SMALL_STATE(4358)] = 150347,
  [SMALL_STATE(4359)] = 150403,
  [SMALL_STATE(4360)] = 150505,
  [SMALL_STATE(4361)] = 150561,
  [SMALL_STATE(4362)] = 150617,
  [SMALL_STATE(4363)] = 150673,
  [SMALL_STATE(4364)] = 150729,
  [SMALL_STATE(4365)] = 150785,
  [SMALL_STATE(4366)] = 150841,
  [SMALL_STATE(4367)] = 150897,
  [SMALL_STATE(4368)] = 150953,
  [SMALL_STATE(4369)] = 151009,
  [SMALL_STATE(4370)] = 151065,
  [SMALL_STATE(4371)] = 151121,
  [SMALL_STATE(4372)] = 151177,
  [SMALL_STATE(4373)] = 151233,
  [SMALL_STATE(4374)] = 151289,
  [SMALL_STATE(4375)] = 151345,
  [SMALL_STATE(4376)] = 151401,
  [SMALL_STATE(4377)] = 151459,
  [SMALL_STATE(4378)] = 151515,
  [SMALL_STATE(4379)] = 151571,
  [SMALL_STATE(4380)] = 151627,
  [SMALL_STATE(4381)] = 151687,
  [SMALL_STATE(4382)] = 151747,
  [SMALL_STATE(4383)] = 151839,
  [SMALL_STATE(4384)] = 151939,
  [SMALL_STATE(4385)] = 151995,
  [SMALL_STATE(4386)] = 152051,
  [SMALL_STATE(4387)] = 152107,
  [SMALL_STATE(4388)] = 152163,
  [SMALL_STATE(4389)] = 152219,
  [SMALL_STATE(4390)] = 152283,
  [SMALL_STATE(4391)] = 152339,
  [SMALL_STATE(4392)] = 152395,
  [SMALL_STATE(4393)] = 152459,
  [SMALL_STATE(4394)] = 152515,
  [SMALL_STATE(4395)] = 152574,
  [SMALL_STATE(4396)] = 152629,
  [SMALL_STATE(4397)] = 152684,
  [SMALL_STATE(4398)] = 152739,
  [SMALL_STATE(4399)] = 152794,
  [SMALL_STATE(4400)] = 152849,
  [SMALL_STATE(4401)] = 152904,
  [SMALL_STATE(4402)] = 152959,
  [SMALL_STATE(4403)] = 153016,
  [SMALL_STATE(4404)] = 153075,
  [SMALL_STATE(4405)] = 153130,
  [SMALL_STATE(4406)] = 153191,
  [SMALL_STATE(4407)] = 153246,
  [SMALL_STATE(4408)] = 153301,
  [SMALL_STATE(4409)] = 153356,
  [SMALL_STATE(4410)] = 153411,
  [SMALL_STATE(4411)] = 153466,
  [SMALL_STATE(4412)] = 153521,
  [SMALL_STATE(4413)] = 153576,
  [SMALL_STATE(4414)] = 153631,
  [SMALL_STATE(4415)] = 153686,
  [SMALL_STATE(4416)] = 153741,
  [SMALL_STATE(4417)] = 153796,
  [SMALL_STATE(4418)] = 153859,
  [SMALL_STATE(4419)] = 153956,
  [SMALL_STATE(4420)] = 154011,
  [SMALL_STATE(4421)] = 154066,
  [SMALL_STATE(4422)] = 154121,
  [SMALL_STATE(4423)] = 154176,
  [SMALL_STATE(4424)] = 154231,
  [SMALL_STATE(4425)] = 154286,
  [SMALL_STATE(4426)] = 154341,
  [SMALL_STATE(4427)] = 154396,
  [SMALL_STATE(4428)] = 154493,
  [SMALL_STATE(4429)] = 154548,
  [SMALL_STATE(4430)] = 154603,
  [SMALL_STATE(4431)] = 154658,
  [SMALL_STATE(4432)] = 154717,
  [SMALL_STATE(4433)] = 154772,
  [SMALL_STATE(4434)] = 154827,
  [SMALL_STATE(4435)] = 154882,
  [SMALL_STATE(4436)] = 154937,
  [SMALL_STATE(4437)] = 154992,
  [SMALL_STATE(4438)] = 155047,
  [SMALL_STATE(4439)] = 155102,
  [SMALL_STATE(4440)] = 155157,
  [SMALL_STATE(4441)] = 155218,
  [SMALL_STATE(4442)] = 155281,
  [SMALL_STATE(4443)] = 155336,
  [SMALL_STATE(4444)] = 155391,
  [SMALL_STATE(4445)] = 155446,
  [SMALL_STATE(4446)] = 155501,
  [SMALL_STATE(4447)] = 155556,
  [SMALL_STATE(4448)] = 155611,
  [SMALL_STATE(4449)] = 155708,
  [SMALL_STATE(4450)] = 155763,
  [SMALL_STATE(4451)] = 155822,
  [SMALL_STATE(4452)] = 155881,
  [SMALL_STATE(4453)] = 155940,
  [SMALL_STATE(4454)] = 155995,
  [SMALL_STATE(4455)] = 156050,
  [SMALL_STATE(4456)] = 156113,
  [SMALL_STATE(4457)] = 156172,
  [SMALL_STATE(4458)] = 156243,
  [SMALL_STATE(4459)] = 156302,
  [SMALL_STATE(4460)] = 156375,
  [SMALL_STATE(4461)] = 156430,
  [SMALL_STATE(4462)] = 156511,
  [SMALL_STATE(4463)] = 156594,
  [SMALL_STATE(4464)] = 156679,
  [SMALL_STATE(4465)] = 156734,
  [SMALL_STATE(4466)] = 156789,
  [SMALL_STATE(4467)] = 156876,
  [SMALL_STATE(4468)] = 156931,
  [SMALL_STATE(4469)] = 157006,
  [SMALL_STATE(4470)] = 157061,
  [SMALL_STATE(4471)] = 157116,
  [SMALL_STATE(4472)] = 157193,
  [SMALL_STATE(4473)] = 157248,
  [SMALL_STATE(4474)] = 157303,
  [SMALL_STATE(4475)] = 157358,
  [SMALL_STATE(4476)] = 157413,
  [SMALL_STATE(4477)] = 157510,
  [SMALL_STATE(4478)] = 157565,
  [SMALL_STATE(4479)] = 157620,
  [SMALL_STATE(4480)] = 157675,
  [SMALL_STATE(4481)] = 157742,
  [SMALL_STATE(4482)] = 157797,
  [SMALL_STATE(4483)] = 157852,
  [SMALL_STATE(4484)] = 157907,
  [SMALL_STATE(4485)] = 158006,
  [SMALL_STATE(4486)] = 158061,
  [SMALL_STATE(4487)] = 158116,
  [SMALL_STATE(4488)] = 158171,
  [SMALL_STATE(4489)] = 158230,
  [SMALL_STATE(4490)] = 158285,
  [SMALL_STATE(4491)] = 158348,
  [SMALL_STATE(4492)] = 158411,
  [SMALL_STATE(4493)] = 158490,
  [SMALL_STATE(4494)] = 158545,
  [SMALL_STATE(4495)] = 158642,
  [SMALL_STATE(4496)] = 158697,
  [SMALL_STATE(4497)] = 158754,
  [SMALL_STATE(4498)] = 158809,
  [SMALL_STATE(4499)] = 158864,
  [SMALL_STATE(4500)] = 158919,
  [SMALL_STATE(4501)] = 158974,
  [SMALL_STATE(4502)] = 159029,
  [SMALL_STATE(4503)] = 159084,
  [SMALL_STATE(4504)] = 159139,
  [SMALL_STATE(4505)] = 159194,
  [SMALL_STATE(4506)] = 159291,
  [SMALL_STATE(4507)] = 159346,
  [SMALL_STATE(4508)] = 159443,
  [SMALL_STATE(4509)] = 159504,
  [SMALL_STATE(4510)] = 159559,
  [SMALL_STATE(4511)] = 159614,
  [SMALL_STATE(4512)] = 159669,
  [SMALL_STATE(4513)] = 159724,
  [SMALL_STATE(4514)] = 159779,
  [SMALL_STATE(4515)] = 159834,
  [SMALL_STATE(4516)] = 159897,
  [SMALL_STATE(4517)] = 159952,
  [SMALL_STATE(4518)] = 160007,
  [SMALL_STATE(4519)] = 160104,
  [SMALL_STATE(4520)] = 160159,
  [SMALL_STATE(4521)] = 160214,
  [SMALL_STATE(4522)] = 160269,
  [SMALL_STATE(4523)] = 160366,
  [SMALL_STATE(4524)] = 160421,
  [SMALL_STATE(4525)] = 160482,
  [SMALL_STATE(4526)] = 160561,
  [SMALL_STATE(4527)] = 160664,
  [SMALL_STATE(4528)] = 160719,
  [SMALL_STATE(4529)] = 160774,
  [SMALL_STATE(4530)] = 160829,
  [SMALL_STATE(4531)] = 160884,
  [SMALL_STATE(4532)] = 160939,
  [SMALL_STATE(4533)] = 160994,
  [SMALL_STATE(4534)] = 161061,
  [SMALL_STATE(4535)] = 161138,
  [SMALL_STATE(4536)] = 161193,
  [SMALL_STATE(4537)] = 161294,
  [SMALL_STATE(4538)] = 161349,
  [SMALL_STATE(4539)] = 161408,
  [SMALL_STATE(4540)] = 161467,
  [SMALL_STATE(4541)] = 161524,
  [SMALL_STATE(4542)] = 161579,
  [SMALL_STATE(4543)] = 161634,
  [SMALL_STATE(4544)] = 161689,
  [SMALL_STATE(4545)] = 161744,
  [SMALL_STATE(4546)] = 161803,
  [SMALL_STATE(4547)] = 161858,
  [SMALL_STATE(4548)] = 161913,
  [SMALL_STATE(4549)] = 161968,
  [SMALL_STATE(4550)] = 162057,
  [SMALL_STATE(4551)] = 162112,
  [SMALL_STATE(4552)] = 162175,
  [SMALL_STATE(4553)] = 162230,
  [SMALL_STATE(4554)] = 162285,
  [SMALL_STATE(4555)] = 162340,
  [SMALL_STATE(4556)] = 162395,
  [SMALL_STATE(4557)] = 162450,
  [SMALL_STATE(4558)] = 162525,
  [SMALL_STATE(4559)] = 162580,
  [SMALL_STATE(4560)] = 162673,
  [SMALL_STATE(4561)] = 162732,
  [SMALL_STATE(4562)] = 162787,
  [SMALL_STATE(4563)] = 162888,
  [SMALL_STATE(4564)] = 162951,
  [SMALL_STATE(4565)] = 163040,
  [SMALL_STATE(4566)] = 163127,
  [SMALL_STATE(4567)] = 163182,
  [SMALL_STATE(4568)] = 163265,
  [SMALL_STATE(4569)] = 163346,
  [SMALL_STATE(4570)] = 163419,
  [SMALL_STATE(4571)] = 163474,
  [SMALL_STATE(4572)] = 163537,
  [SMALL_STATE(4573)] = 163592,
  [SMALL_STATE(4574)] = 163647,
  [SMALL_STATE(4575)] = 163748,
  [SMALL_STATE(4576)] = 163811,
  [SMALL_STATE(4577)] = 163882,
  [SMALL_STATE(4578)] = 163937,
  [SMALL_STATE(4579)] = 164013,
  [SMALL_STATE(4580)] = 164071,
  [SMALL_STATE(4581)] = 164131,
  [SMALL_STATE(4582)] = 164185,
  [SMALL_STATE(4583)] = 164243,
  [SMALL_STATE(4584)] = 164299,
  [SMALL_STATE(4585)] = 164395,
  [SMALL_STATE(4586)] = 164491,
  [SMALL_STATE(4587)] = 164545,
  [SMALL_STATE(4588)] = 164599,
  [SMALL_STATE(4589)] = 164655,
  [SMALL_STATE(4590)] = 164743,
  [SMALL_STATE(4591)] = 164839,
  [SMALL_STATE(4592)] = 164901,
  [SMALL_STATE(4593)] = 164963,
  [SMALL_STATE(4594)] = 165059,
  [SMALL_STATE(4595)] = 165155,
  [SMALL_STATE(4596)] = 165217,
  [SMALL_STATE(4597)] = 165277,
  [SMALL_STATE(4598)] = 165373,
  [SMALL_STATE(4599)] = 165429,
  [SMALL_STATE(4600)] = 165491,
  [SMALL_STATE(4601)] = 165561,
  [SMALL_STATE(4602)] = 165633,
  [SMALL_STATE(4603)] = 165713,
  [SMALL_STATE(4604)] = 165767,
  [SMALL_STATE(4605)] = 165827,
  [SMALL_STATE(4606)] = 165909,
  [SMALL_STATE(4607)] = 165993,
  [SMALL_STATE(4608)] = 166049,
  [SMALL_STATE(4609)] = 166145,
  [SMALL_STATE(4610)] = 166231,
  [SMALL_STATE(4611)] = 166291,
  [SMALL_STATE(4612)] = 166365,
  [SMALL_STATE(4613)] = 166419,
  [SMALL_STATE(4614)] = 166481,
  [SMALL_STATE(4615)] = 166577,
  [SMALL_STATE(4616)] = 166673,
  [SMALL_STATE(4617)] = 166735,
  [SMALL_STATE(4618)] = 166789,
  [SMALL_STATE(4619)] = 166893,
  [SMALL_STATE(4620)] = 166991,
  [SMALL_STATE(4621)] = 167057,
  [SMALL_STATE(4622)] = 167115,
  [SMALL_STATE(4623)] = 167193,
  [SMALL_STATE(4624)] = 167247,
  [SMALL_STATE(4625)] = 167303,
  [SMALL_STATE(4626)] = 167356,
  [SMALL_STATE(4627)] = 167409,
  [SMALL_STATE(4628)] = 167462,
  [SMALL_STATE(4629)] = 167515,
  [SMALL_STATE(4630)] = 167572,
  [SMALL_STATE(4631)] = 167625,
  [SMALL_STATE(4632)] = 167720,
  [SMALL_STATE(4633)] = 167773,
  [SMALL_STATE(4634)] = 167834,
  [SMALL_STATE(4635)] = 167895,
  [SMALL_STATE(4636)] = 167948,
  [SMALL_STATE(4637)] = 168001,
  [SMALL_STATE(4638)] = 168054,
  [SMALL_STATE(4639)] = 168119,
  [SMALL_STATE(4640)] = 168172,
  [SMALL_STATE(4641)] = 168225,
  [SMALL_STATE(4642)] = 168278,
  [SMALL_STATE(4643)] = 168343,
  [SMALL_STATE(4644)] = 168412,
  [SMALL_STATE(4645)] = 168477,
  [SMALL_STATE(4646)] = 168530,
  [SMALL_STATE(4647)] = 168601,
  [SMALL_STATE(4648)] = 168654,
  [SMALL_STATE(4649)] = 168751,
  [SMALL_STATE(4650)] = 168804,
  [SMALL_STATE(4651)] = 168865,
  [SMALL_STATE(4652)] = 168918,
  [SMALL_STATE(4653)] = 169013,
  [SMALL_STATE(4654)] = 169066,
  [SMALL_STATE(4655)] = 169119,
  [SMALL_STATE(4656)] = 169172,
  [SMALL_STATE(4657)] = 169251,
  [SMALL_STATE(4658)] = 169332,
  [SMALL_STATE(4659)] = 169417,
  [SMALL_STATE(4660)] = 169470,
  [SMALL_STATE(4661)] = 169557,
  [SMALL_STATE(4662)] = 169610,
  [SMALL_STATE(4663)] = 169683,
  [SMALL_STATE(4664)] = 169758,
  [SMALL_STATE(4665)] = 169817,
  [SMALL_STATE(4666)] = 169910,
  [SMALL_STATE(4667)] = 169975,
  [SMALL_STATE(4668)] = 170028,
  [SMALL_STATE(4669)] = 170123,
  [SMALL_STATE(4670)] = 170222,
  [SMALL_STATE(4671)] = 170275,
  [SMALL_STATE(4672)] = 170370,
  [SMALL_STATE(4673)] = 170423,
  [SMALL_STATE(4674)] = 170518,
  [SMALL_STATE(4675)] = 170607,
  [SMALL_STATE(4676)] = 170702,
  [SMALL_STATE(4677)] = 170779,
  [SMALL_STATE(4678)] = 170832,
  [SMALL_STATE(4679)] = 170885,
  [SMALL_STATE(4680)] = 170938,
  [SMALL_STATE(4681)] = 171033,
  [SMALL_STATE(4682)] = 171086,
  [SMALL_STATE(4683)] = 171139,
  [SMALL_STATE(4684)] = 171236,
  [SMALL_STATE(4685)] = 171289,
  [SMALL_STATE(4686)] = 171342,
  [SMALL_STATE(4687)] = 171395,
  [SMALL_STATE(4688)] = 171448,
  [SMALL_STATE(4689)] = 171501,
  [SMALL_STATE(4690)] = 171554,
  [SMALL_STATE(4691)] = 171607,
  [SMALL_STATE(4692)] = 171660,
  [SMALL_STATE(4693)] = 171717,
  [SMALL_STATE(4694)] = 171770,
  [SMALL_STATE(4695)] = 171823,
  [SMALL_STATE(4696)] = 171918,
  [SMALL_STATE(4697)] = 171971,
  [SMALL_STATE(4698)] = 172024,
  [SMALL_STATE(4699)] = 172077,
  [SMALL_STATE(4700)] = 172130,
  [SMALL_STATE(4701)] = 172191,
  [SMALL_STATE(4702)] = 172244,
  [SMALL_STATE(4703)] = 172297,
  [SMALL_STATE(4704)] = 172350,
  [SMALL_STATE(4705)] = 172411,
  [SMALL_STATE(4706)] = 172464,
  [SMALL_STATE(4707)] = 172517,
  [SMALL_STATE(4708)] = 172570,
  [SMALL_STATE(4709)] = 172623,
  [SMALL_STATE(4710)] = 172676,
  [SMALL_STATE(4711)] = 172781,
  [SMALL_STATE(4712)] = 172834,
  [SMALL_STATE(4713)] = 172887,
  [SMALL_STATE(4714)] = 172940,
  [SMALL_STATE(4715)] = 172993,
  [SMALL_STATE(4716)] = 173046,
  [SMALL_STATE(4717)] = 173099,
  [SMALL_STATE(4718)] = 173160,
  [SMALL_STATE(4719)] = 173255,
  [SMALL_STATE(4720)] = 173308,
  [SMALL_STATE(4721)] = 173361,
  [SMALL_STATE(4722)] = 173426,
  [SMALL_STATE(4723)] = 173479,
  [SMALL_STATE(4724)] = 173532,
  [SMALL_STATE(4725)] = 173635,
  [SMALL_STATE(4726)] = 173700,
  [SMALL_STATE(4727)] = 173759,
  [SMALL_STATE(4728)] = 173836,
  [SMALL_STATE(4729)] = 173935,
  [SMALL_STATE(4730)] = 174000,
  [SMALL_STATE(4731)] = 174075,
  [SMALL_STATE(4732)] = 174148,
  [SMALL_STATE(4733)] = 174235,
  [SMALL_STATE(4734)] = 174320,
  [SMALL_STATE(4735)] = 174373,
  [SMALL_STATE(4736)] = 174426,
  [SMALL_STATE(4737)] = 174479,
  [SMALL_STATE(4738)] = 174532,
  [SMALL_STATE(4739)] = 174613,
  [SMALL_STATE(4740)] = 174666,
  [SMALL_STATE(4741)] = 174745,
  [SMALL_STATE(4742)] = 174816,
  [SMALL_STATE(4743)] = 174885,
  [SMALL_STATE(4744)] = 174938,
  [SMALL_STATE(4745)] = 174993,
  [SMALL_STATE(4746)] = 175054,
  [SMALL_STATE(4747)] = 175151,
  [SMALL_STATE(4748)] = 175204,
  [SMALL_STATE(4749)] = 175263,
  [SMALL_STATE(4750)] = 175324,
  [SMALL_STATE(4751)] = 175385,
  [SMALL_STATE(4752)] = 175446,
  [SMALL_STATE(4753)] = 175543,
  [SMALL_STATE(4754)] = 175632,
  [SMALL_STATE(4755)] = 175727,
  [SMALL_STATE(4756)] = 175780,
  [SMALL_STATE(4757)] = 175873,
  [SMALL_STATE(4758)] = 175966,
  [SMALL_STATE(4759)] = 176059,
  [SMALL_STATE(4760)] = 176112,
  [SMALL_STATE(4761)] = 176207,
  [SMALL_STATE(4762)] = 176302,
  [SMALL_STATE(4763)] = 176355,
  [SMALL_STATE(4764)] = 176450,
  [SMALL_STATE(4765)] = 176503,
  [SMALL_STATE(4766)] = 176558,
  [SMALL_STATE(4767)] = 176617,
  [SMALL_STATE(4768)] = 176710,
  [SMALL_STATE(4769)] = 176805,
  [SMALL_STATE(4770)] = 176904,
  [SMALL_STATE(4771)] = 176957,
  [SMALL_STATE(4772)] = 177010,
  [SMALL_STATE(4773)] = 177104,
  [SMALL_STATE(4774)] = 177198,
  [SMALL_STATE(4775)] = 177292,
  [SMALL_STATE(4776)] = 177386,
  [SMALL_STATE(4777)] = 177480,
  [SMALL_STATE(4778)] = 177574,
  [SMALL_STATE(4779)] = 177668,
  [SMALL_STATE(4780)] = 177762,
  [SMALL_STATE(4781)] = 177856,
  [SMALL_STATE(4782)] = 177950,
  [SMALL_STATE(4783)] = 178042,
  [SMALL_STATE(4784)] = 178136,
  [SMALL_STATE(4785)] = 178230,
  [SMALL_STATE(4786)] = 178324,
  [SMALL_STATE(4787)] = 178418,
  [SMALL_STATE(4788)] = 178512,
  [SMALL_STATE(4789)] = 178606,
  [SMALL_STATE(4790)] = 178700,
  [SMALL_STATE(4791)] = 178794,
  [SMALL_STATE(4792)] = 178888,
  [SMALL_STATE(4793)] = 178982,
  [SMALL_STATE(4794)] = 179076,
  [SMALL_STATE(4795)] = 179170,
  [SMALL_STATE(4796)] = 179264,
  [SMALL_STATE(4797)] = 179358,
  [SMALL_STATE(4798)] = 179460,
  [SMALL_STATE(4799)] = 179560,
  [SMALL_STATE(4800)] = 179654,
  [SMALL_STATE(4801)] = 179748,
  [SMALL_STATE(4802)] = 179840,
  [SMALL_STATE(4803)] = 179934,
  [SMALL_STATE(4804)] = 180028,
  [SMALL_STATE(4805)] = 180122,
  [SMALL_STATE(4806)] = 180216,
  [SMALL_STATE(4807)] = 180310,
  [SMALL_STATE(4808)] = 180404,
  [SMALL_STATE(4809)] = 180496,
  [SMALL_STATE(4810)] = 180588,
  [SMALL_STATE(4811)] = 180682,
  [SMALL_STATE(4812)] = 180776,
  [SMALL_STATE(4813)] = 180870,
  [SMALL_STATE(4814)] = 180964,
  [SMALL_STATE(4815)] = 181058,
  [SMALL_STATE(4816)] = 181152,
  [SMALL_STATE(4817)] = 181246,
  [SMALL_STATE(4818)] = 181340,
  [SMALL_STATE(4819)] = 181434,
  [SMALL_STATE(4820)] = 181528,
  [SMALL_STATE(4821)] = 181622,
  [SMALL_STATE(4822)] = 181724,
  [SMALL_STATE(4823)] = 181818,
  [SMALL_STATE(4824)] = 181912,
  [SMALL_STATE(4825)] = 182006,
  [SMALL_STATE(4826)] = 182100,
  [SMALL_STATE(4827)] = 182194,
  [SMALL_STATE(4828)] = 182288,
  [SMALL_STATE(4829)] = 182346,
  [SMALL_STATE(4830)] = 182438,
  [SMALL_STATE(4831)] = 182530,
  [SMALL_STATE(4832)] = 182624,
  [SMALL_STATE(4833)] = 182718,
  [SMALL_STATE(4834)] = 182817,
  [SMALL_STATE(4835)] = 182916,
  [SMALL_STATE(4836)] = 183015,
  [SMALL_STATE(4837)] = 183114,
  [SMALL_STATE(4838)] = 183213,
  [SMALL_STATE(4839)] = 183312,
  [SMALL_STATE(4840)] = 183411,
  [SMALL_STATE(4841)] = 183510,
  [SMALL_STATE(4842)] = 183609,
  [SMALL_STATE(4843)] = 183704,
  [SMALL_STATE(4844)] = 183803,
  [SMALL_STATE(4845)] = 183902,
  [SMALL_STATE(4846)] = 184001,
  [SMALL_STATE(4847)] = 184100,
  [SMALL_STATE(4848)] = 184199,
  [SMALL_STATE(4849)] = 184298,
  [SMALL_STATE(4850)] = 184389,
  [SMALL_STATE(4851)] = 184479,
  [SMALL_STATE(4852)] = 184569,
  [SMALL_STATE(4853)] = 184659,
  [SMALL_STATE(4854)] = 184749,
  [SMALL_STATE(4855)] = 184839,
  [SMALL_STATE(4856)] = 184929,
  [SMALL_STATE(4857)] = 185019,
  [SMALL_STATE(4858)] = 185109,
  [SMALL_STATE(4859)] = 185199,
  [SMALL_STATE(4860)] = 185253,
  [SMALL_STATE(4861)] = 185343,
  [SMALL_STATE(4862)] = 185433,
  [SMALL_STATE(4863)] = 185523,
  [SMALL_STATE(4864)] = 185613,
  [SMALL_STATE(4865)] = 185703,
  [SMALL_STATE(4866)] = 185793,
  [SMALL_STATE(4867)] = 185883,
  [SMALL_STATE(4868)] = 185973,
  [SMALL_STATE(4869)] = 186063,
  [SMALL_STATE(4870)] = 186153,
  [SMALL_STATE(4871)] = 186243,
  [SMALL_STATE(4872)] = 186333,
  [SMALL_STATE(4873)] = 186423,
  [SMALL_STATE(4874)] = 186513,
  [SMALL_STATE(4875)] = 186603,
  [SMALL_STATE(4876)] = 186693,
  [SMALL_STATE(4877)] = 186783,
  [SMALL_STATE(4878)] = 186873,
  [SMALL_STATE(4879)] = 186963,
  [SMALL_STATE(4880)] = 187053,
  [SMALL_STATE(4881)] = 187143,
  [SMALL_STATE(4882)] = 187233,
  [SMALL_STATE(4883)] = 187323,
  [SMALL_STATE(4884)] = 187413,
  [SMALL_STATE(4885)] = 187503,
  [SMALL_STATE(4886)] = 187593,
  [SMALL_STATE(4887)] = 187687,
  [SMALL_STATE(4888)] = 187777,
  [SMALL_STATE(4889)] = 187867,
  [SMALL_STATE(4890)] = 187957,
  [SMALL_STATE(4891)] = 188047,
  [SMALL_STATE(4892)] = 188137,
  [SMALL_STATE(4893)] = 188227,
  [SMALL_STATE(4894)] = 188317,
  [SMALL_STATE(4895)] = 188407,
  [SMALL_STATE(4896)] = 188497,
  [SMALL_STATE(4897)] = 188587,
  [SMALL_STATE(4898)] = 188677,
  [SMALL_STATE(4899)] = 188767,
  [SMALL_STATE(4900)] = 188857,
  [SMALL_STATE(4901)] = 188947,
  [SMALL_STATE(4902)] = 189037,
  [SMALL_STATE(4903)] = 189127,
  [SMALL_STATE(4904)] = 189217,
  [SMALL_STATE(4905)] = 189307,
  [SMALL_STATE(4906)] = 189397,
  [SMALL_STATE(4907)] = 189487,
  [SMALL_STATE(4908)] = 189577,
  [SMALL_STATE(4909)] = 189667,
  [SMALL_STATE(4910)] = 189761,
  [SMALL_STATE(4911)] = 189851,
  [SMALL_STATE(4912)] = 189941,
  [SMALL_STATE(4913)] = 190031,
  [SMALL_STATE(4914)] = 190121,
  [SMALL_STATE(4915)] = 190211,
  [SMALL_STATE(4916)] = 190301,
  [SMALL_STATE(4917)] = 190391,
  [SMALL_STATE(4918)] = 190481,
  [SMALL_STATE(4919)] = 190571,
  [SMALL_STATE(4920)] = 190661,
  [SMALL_STATE(4921)] = 190751,
  [SMALL_STATE(4922)] = 190841,
  [SMALL_STATE(4923)] = 190931,
  [SMALL_STATE(4924)] = 191021,
  [SMALL_STATE(4925)] = 191111,
  [SMALL_STATE(4926)] = 191201,
  [SMALL_STATE(4927)] = 191291,
  [SMALL_STATE(4928)] = 191381,
  [SMALL_STATE(4929)] = 191471,
  [SMALL_STATE(4930)] = 191561,
  [SMALL_STATE(4931)] = 191651,
  [SMALL_STATE(4932)] = 191741,
  [SMALL_STATE(4933)] = 191835,
  [SMALL_STATE(4934)] = 191891,
  [SMALL_STATE(4935)] = 191981,
  [SMALL_STATE(4936)] = 192071,
  [SMALL_STATE(4937)] = 192161,
  [SMALL_STATE(4938)] = 192251,
  [SMALL_STATE(4939)] = 192341,
  [SMALL_STATE(4940)] = 192431,
  [SMALL_STATE(4941)] = 192521,
  [SMALL_STATE(4942)] = 192611,
  [SMALL_STATE(4943)] = 192701,
  [SMALL_STATE(4944)] = 192791,
  [SMALL_STATE(4945)] = 192881,
  [SMALL_STATE(4946)] = 192971,
  [SMALL_STATE(4947)] = 193061,
  [SMALL_STATE(4948)] = 193151,
  [SMALL_STATE(4949)] = 193241,
  [SMALL_STATE(4950)] = 193331,
  [SMALL_STATE(4951)] = 193421,
  [SMALL_STATE(4952)] = 193511,
  [SMALL_STATE(4953)] = 193601,
  [SMALL_STATE(4954)] = 193691,
  [SMALL_STATE(4955)] = 193787,
  [SMALL_STATE(4956)] = 193877,
  [SMALL_STATE(4957)] = 193967,
  [SMALL_STATE(4958)] = 194057,
  [SMALL_STATE(4959)] = 194147,
  [SMALL_STATE(4960)] = 194237,
  [SMALL_STATE(4961)] = 194327,
  [SMALL_STATE(4962)] = 194417,
  [SMALL_STATE(4963)] = 194507,
  [SMALL_STATE(4964)] = 194597,
  [SMALL_STATE(4965)] = 194687,
  [SMALL_STATE(4966)] = 194777,
  [SMALL_STATE(4967)] = 194867,
  [SMALL_STATE(4968)] = 194957,
  [SMALL_STATE(4969)] = 195047,
  [SMALL_STATE(4970)] = 195137,
  [SMALL_STATE(4971)] = 195227,
  [SMALL_STATE(4972)] = 195317,
  [SMALL_STATE(4973)] = 195407,
  [SMALL_STATE(4974)] = 195497,
  [SMALL_STATE(4975)] = 195587,
  [SMALL_STATE(4976)] = 195677,
  [SMALL_STATE(4977)] = 195767,
  [SMALL_STATE(4978)] = 195857,
  [SMALL_STATE(4979)] = 195947,
  [SMALL_STATE(4980)] = 196037,
  [SMALL_STATE(4981)] = 196127,
  [SMALL_STATE(4982)] = 196217,
  [SMALL_STATE(4983)] = 196307,
  [SMALL_STATE(4984)] = 196397,
  [SMALL_STATE(4985)] = 196487,
  [SMALL_STATE(4986)] = 196577,
  [SMALL_STATE(4987)] = 196667,
  [SMALL_STATE(4988)] = 196757,
  [SMALL_STATE(4989)] = 196847,
  [SMALL_STATE(4990)] = 196937,
  [SMALL_STATE(4991)] = 197043,
  [SMALL_STATE(4992)] = 197133,
  [SMALL_STATE(4993)] = 197223,
  [SMALL_STATE(4994)] = 197313,
  [SMALL_STATE(4995)] = 197369,
  [SMALL_STATE(4996)] = 197459,
  [SMALL_STATE(4997)] = 197549,
  [SMALL_STATE(4998)] = 197639,
  [SMALL_STATE(4999)] = 197729,
  [SMALL_STATE(5000)] = 197819,
  [SMALL_STATE(5001)] = 197909,
  [SMALL_STATE(5002)] = 197999,
  [SMALL_STATE(5003)] = 198089,
  [SMALL_STATE(5004)] = 198179,
  [SMALL_STATE(5005)] = 198269,
  [SMALL_STATE(5006)] = 198359,
  [SMALL_STATE(5007)] = 198449,
  [SMALL_STATE(5008)] = 198539,
  [SMALL_STATE(5009)] = 198629,
  [SMALL_STATE(5010)] = 198719,
  [SMALL_STATE(5011)] = 198809,
  [SMALL_STATE(5012)] = 198899,
  [SMALL_STATE(5013)] = 198989,
  [SMALL_STATE(5014)] = 199079,
  [SMALL_STATE(5015)] = 199169,
  [SMALL_STATE(5016)] = 199259,
  [SMALL_STATE(5017)] = 199349,
  [SMALL_STATE(5018)] = 199439,
  [SMALL_STATE(5019)] = 199529,
  [SMALL_STATE(5020)] = 199619,
  [SMALL_STATE(5021)] = 199709,
  [SMALL_STATE(5022)] = 199799,
  [SMALL_STATE(5023)] = 199889,
  [SMALL_STATE(5024)] = 199979,
  [SMALL_STATE(5025)] = 200069,
  [SMALL_STATE(5026)] = 200159,
  [SMALL_STATE(5027)] = 200249,
  [SMALL_STATE(5028)] = 200339,
  [SMALL_STATE(5029)] = 200426,
  [SMALL_STATE(5030)] = 200513,
  [SMALL_STATE(5031)] = 200600,
  [SMALL_STATE(5032)] = 200687,
  [SMALL_STATE(5033)] = 200774,
  [SMALL_STATE(5034)] = 200861,
  [SMALL_STATE(5035)] = 200948,
  [SMALL_STATE(5036)] = 201035,
  [SMALL_STATE(5037)] = 201122,
  [SMALL_STATE(5038)] = 201209,
  [SMALL_STATE(5039)] = 201296,
  [SMALL_STATE(5040)] = 201383,
  [SMALL_STATE(5041)] = 201470,
  [SMALL_STATE(5042)] = 201557,
  [SMALL_STATE(5043)] = 201644,
  [SMALL_STATE(5044)] = 201731,
  [SMALL_STATE(5045)] = 201818,
  [SMALL_STATE(5046)] = 201905,
  [SMALL_STATE(5047)] = 201992,
  [SMALL_STATE(5048)] = 202079,
  [SMALL_STATE(5049)] = 202166,
  [SMALL_STATE(5050)] = 202253,
  [SMALL_STATE(5051)] = 202340,
  [SMALL_STATE(5052)] = 202427,
  [SMALL_STATE(5053)] = 202514,
  [SMALL_STATE(5054)] = 202601,
  [SMALL_STATE(5055)] = 202688,
  [SMALL_STATE(5056)] = 202775,
  [SMALL_STATE(5057)] = 202862,
  [SMALL_STATE(5058)] = 202949,
  [SMALL_STATE(5059)] = 203036,
  [SMALL_STATE(5060)] = 203123,
  [SMALL_STATE(5061)] = 203210,
  [SMALL_STATE(5062)] = 203297,
  [SMALL_STATE(5063)] = 203384,
  [SMALL_STATE(5064)] = 203471,
  [SMALL_STATE(5065)] = 203558,
  [SMALL_STATE(5066)] = 203645,
  [SMALL_STATE(5067)] = 203732,
  [SMALL_STATE(5068)] = 203819,
  [SMALL_STATE(5069)] = 203906,
  [SMALL_STATE(5070)] = 203993,
  [SMALL_STATE(5071)] = 204080,
  [SMALL_STATE(5072)] = 204167,
  [SMALL_STATE(5073)] = 204254,
  [SMALL_STATE(5074)] = 204341,
  [SMALL_STATE(5075)] = 204428,
  [SMALL_STATE(5076)] = 204515,
  [SMALL_STATE(5077)] = 204602,
  [SMALL_STATE(5078)] = 204689,
  [SMALL_STATE(5079)] = 204776,
  [SMALL_STATE(5080)] = 204863,
  [SMALL_STATE(5081)] = 204950,
  [SMALL_STATE(5082)] = 205037,
  [SMALL_STATE(5083)] = 205124,
  [SMALL_STATE(5084)] = 205211,
  [SMALL_STATE(5085)] = 205298,
  [SMALL_STATE(5086)] = 205385,
  [SMALL_STATE(5087)] = 205472,
  [SMALL_STATE(5088)] = 205559,
  [SMALL_STATE(5089)] = 205646,
  [SMALL_STATE(5090)] = 205733,
  [SMALL_STATE(5091)] = 205820,
  [SMALL_STATE(5092)] = 205907,
  [SMALL_STATE(5093)] = 205994,
  [SMALL_STATE(5094)] = 206081,
  [SMALL_STATE(5095)] = 206168,
  [SMALL_STATE(5096)] = 206255,
  [SMALL_STATE(5097)] = 206342,
  [SMALL_STATE(5098)] = 206429,
  [SMALL_STATE(5099)] = 206516,
  [SMALL_STATE(5100)] = 206603,
  [SMALL_STATE(5101)] = 206660,
  [SMALL_STATE(5102)] = 206747,
  [SMALL_STATE(5103)] = 206834,
  [SMALL_STATE(5104)] = 206891,
  [SMALL_STATE(5105)] = 206944,
  [SMALL_STATE(5106)] = 207031,
  [SMALL_STATE(5107)] = 207118,
  [SMALL_STATE(5108)] = 207205,
  [SMALL_STATE(5109)] = 207292,
  [SMALL_STATE(5110)] = 207379,
  [SMALL_STATE(5111)] = 207466,
  [SMALL_STATE(5112)] = 207553,
  [SMALL_STATE(5113)] = 207640,
  [SMALL_STATE(5114)] = 207727,
  [SMALL_STATE(5115)] = 207814,
  [SMALL_STATE(5116)] = 207901,
  [SMALL_STATE(5117)] = 207988,
  [SMALL_STATE(5118)] = 208075,
  [SMALL_STATE(5119)] = 208162,
  [SMALL_STATE(5120)] = 208249,
  [SMALL_STATE(5121)] = 208336,
  [SMALL_STATE(5122)] = 208423,
  [SMALL_STATE(5123)] = 208510,
  [SMALL_STATE(5124)] = 208597,
  [SMALL_STATE(5125)] = 208684,
  [SMALL_STATE(5126)] = 208771,
  [SMALL_STATE(5127)] = 208858,
  [SMALL_STATE(5128)] = 208945,
  [SMALL_STATE(5129)] = 209032,
  [SMALL_STATE(5130)] = 209119,
  [SMALL_STATE(5131)] = 209206,
  [SMALL_STATE(5132)] = 209293,
  [SMALL_STATE(5133)] = 209380,
  [SMALL_STATE(5134)] = 209467,
  [SMALL_STATE(5135)] = 209554,
  [SMALL_STATE(5136)] = 209641,
  [SMALL_STATE(5137)] = 209728,
  [SMALL_STATE(5138)] = 209815,
  [SMALL_STATE(5139)] = 209902,
  [SMALL_STATE(5140)] = 209989,
  [SMALL_STATE(5141)] = 210076,
  [SMALL_STATE(5142)] = 210163,
  [SMALL_STATE(5143)] = 210250,
  [SMALL_STATE(5144)] = 210337,
  [SMALL_STATE(5145)] = 210424,
  [SMALL_STATE(5146)] = 210511,
  [SMALL_STATE(5147)] = 210598,
  [SMALL_STATE(5148)] = 210685,
  [SMALL_STATE(5149)] = 210772,
  [SMALL_STATE(5150)] = 210859,
  [SMALL_STATE(5151)] = 210946,
  [SMALL_STATE(5152)] = 211033,
  [SMALL_STATE(5153)] = 211120,
  [SMALL_STATE(5154)] = 211207,
  [SMALL_STATE(5155)] = 211294,
  [SMALL_STATE(5156)] = 211381,
  [SMALL_STATE(5157)] = 211468,
  [SMALL_STATE(5158)] = 211555,
  [SMALL_STATE(5159)] = 211642,
  [SMALL_STATE(5160)] = 211729,
  [SMALL_STATE(5161)] = 211816,
  [SMALL_STATE(5162)] = 211903,
  [SMALL_STATE(5163)] = 211990,
  [SMALL_STATE(5164)] = 212077,
  [SMALL_STATE(5165)] = 212164,
  [SMALL_STATE(5166)] = 212251,
  [SMALL_STATE(5167)] = 212338,
  [SMALL_STATE(5168)] = 212425,
  [SMALL_STATE(5169)] = 212512,
  [SMALL_STATE(5170)] = 212599,
  [SMALL_STATE(5171)] = 212692,
  [SMALL_STATE(5172)] = 212779,
  [SMALL_STATE(5173)] = 212866,
  [SMALL_STATE(5174)] = 212953,
  [SMALL_STATE(5175)] = 213040,
  [SMALL_STATE(5176)] = 213127,
  [SMALL_STATE(5177)] = 213214,
  [SMALL_STATE(5178)] = 213301,
  [SMALL_STATE(5179)] = 213388,
  [SMALL_STATE(5180)] = 213475,
  [SMALL_STATE(5181)] = 213562,
  [SMALL_STATE(5182)] = 213649,
  [SMALL_STATE(5183)] = 213736,
  [SMALL_STATE(5184)] = 213823,
  [SMALL_STATE(5185)] = 213910,
  [SMALL_STATE(5186)] = 214005,
  [SMALL_STATE(5187)] = 214092,
  [SMALL_STATE(5188)] = 214179,
  [SMALL_STATE(5189)] = 214266,
  [SMALL_STATE(5190)] = 214353,
  [SMALL_STATE(5191)] = 214440,
  [SMALL_STATE(5192)] = 214527,
  [SMALL_STATE(5193)] = 214614,
  [SMALL_STATE(5194)] = 214701,
  [SMALL_STATE(5195)] = 214788,
  [SMALL_STATE(5196)] = 214843,
  [SMALL_STATE(5197)] = 214930,
  [SMALL_STATE(5198)] = 215017,
  [SMALL_STATE(5199)] = 215104,
  [SMALL_STATE(5200)] = 215191,
  [SMALL_STATE(5201)] = 215278,
  [SMALL_STATE(5202)] = 215365,
  [SMALL_STATE(5203)] = 215452,
  [SMALL_STATE(5204)] = 215539,
  [SMALL_STATE(5205)] = 215626,
  [SMALL_STATE(5206)] = 215713,
  [SMALL_STATE(5207)] = 215800,
  [SMALL_STATE(5208)] = 215887,
  [SMALL_STATE(5209)] = 215974,
  [SMALL_STATE(5210)] = 216047,
  [SMALL_STATE(5211)] = 216134,
  [SMALL_STATE(5212)] = 216217,
  [SMALL_STATE(5213)] = 216278,
  [SMALL_STATE(5214)] = 216365,
  [SMALL_STATE(5215)] = 216452,
  [SMALL_STATE(5216)] = 216539,
  [SMALL_STATE(5217)] = 216626,
  [SMALL_STATE(5218)] = 216697,
  [SMALL_STATE(5219)] = 216784,
  [SMALL_STATE(5220)] = 216871,
  [SMALL_STATE(5221)] = 216940,
  [SMALL_STATE(5222)] = 217021,
  [SMALL_STATE(5223)] = 217100,
  [SMALL_STATE(5224)] = 217187,
  [SMALL_STATE(5225)] = 217274,
  [SMALL_STATE(5226)] = 217361,
  [SMALL_STATE(5227)] = 217448,
  [SMALL_STATE(5228)] = 217535,
  [SMALL_STATE(5229)] = 217612,
  [SMALL_STATE(5230)] = 217699,
  [SMALL_STATE(5231)] = 217786,
  [SMALL_STATE(5232)] = 217873,
  [SMALL_STATE(5233)] = 217960,
  [SMALL_STATE(5234)] = 218047,
  [SMALL_STATE(5235)] = 218134,
  [SMALL_STATE(5236)] = 218221,
  [SMALL_STATE(5237)] = 218308,
  [SMALL_STATE(5238)] = 218395,
  [SMALL_STATE(5239)] = 218470,
  [SMALL_STATE(5240)] = 218537,
  [SMALL_STATE(5241)] = 218602,
  [SMALL_STATE(5242)] = 218689,
  [SMALL_STATE(5243)] = 218776,
  [SMALL_STATE(5244)] = 218863,
  [SMALL_STATE(5245)] = 218950,
  [SMALL_STATE(5246)] = 219037,
  [SMALL_STATE(5247)] = 219124,
  [SMALL_STATE(5248)] = 219211,
  [SMALL_STATE(5249)] = 219268,
  [SMALL_STATE(5250)] = 219355,
  [SMALL_STATE(5251)] = 219446,
  [SMALL_STATE(5252)] = 219533,
  [SMALL_STATE(5253)] = 219620,
  [SMALL_STATE(5254)] = 219677,
  [SMALL_STATE(5255)] = 219734,
  [SMALL_STATE(5256)] = 219825,
  [SMALL_STATE(5257)] = 219912,
  [SMALL_STATE(5258)] = 219999,
  [SMALL_STATE(5259)] = 220086,
  [SMALL_STATE(5260)] = 220173,
  [SMALL_STATE(5261)] = 220260,
  [SMALL_STATE(5262)] = 220347,
  [SMALL_STATE(5263)] = 220434,
  [SMALL_STATE(5264)] = 220521,
  [SMALL_STATE(5265)] = 220608,
  [SMALL_STATE(5266)] = 220695,
  [SMALL_STATE(5267)] = 220782,
  [SMALL_STATE(5268)] = 220833,
  [SMALL_STATE(5269)] = 220920,
  [SMALL_STATE(5270)] = 221007,
  [SMALL_STATE(5271)] = 221110,
  [SMALL_STATE(5272)] = 221197,
  [SMALL_STATE(5273)] = 221284,
  [SMALL_STATE(5274)] = 221371,
  [SMALL_STATE(5275)] = 221458,
  [SMALL_STATE(5276)] = 221545,
  [SMALL_STATE(5277)] = 221632,
  [SMALL_STATE(5278)] = 221719,
  [SMALL_STATE(5279)] = 221806,
  [SMALL_STATE(5280)] = 221893,
  [SMALL_STATE(5281)] = 221980,
  [SMALL_STATE(5282)] = 222067,
  [SMALL_STATE(5283)] = 222154,
  [SMALL_STATE(5284)] = 222241,
  [SMALL_STATE(5285)] = 222328,
  [SMALL_STATE(5286)] = 222415,
  [SMALL_STATE(5287)] = 222502,
  [SMALL_STATE(5288)] = 222589,
  [SMALL_STATE(5289)] = 222676,
  [SMALL_STATE(5290)] = 222763,
  [SMALL_STATE(5291)] = 222850,
  [SMALL_STATE(5292)] = 222937,
  [SMALL_STATE(5293)] = 223024,
  [SMALL_STATE(5294)] = 223111,
  [SMALL_STATE(5295)] = 223198,
  [SMALL_STATE(5296)] = 223285,
  [SMALL_STATE(5297)] = 223372,
  [SMALL_STATE(5298)] = 223459,
  [SMALL_STATE(5299)] = 223546,
  [SMALL_STATE(5300)] = 223633,
  [SMALL_STATE(5301)] = 223720,
  [SMALL_STATE(5302)] = 223807,
  [SMALL_STATE(5303)] = 223894,
  [SMALL_STATE(5304)] = 223981,
  [SMALL_STATE(5305)] = 224068,
  [SMALL_STATE(5306)] = 224155,
  [SMALL_STATE(5307)] = 224242,
  [SMALL_STATE(5308)] = 224329,
  [SMALL_STATE(5309)] = 224416,
  [SMALL_STATE(5310)] = 224503,
  [SMALL_STATE(5311)] = 224590,
  [SMALL_STATE(5312)] = 224677,
  [SMALL_STATE(5313)] = 224764,
  [SMALL_STATE(5314)] = 224851,
  [SMALL_STATE(5315)] = 224938,
  [SMALL_STATE(5316)] = 225025,
  [SMALL_STATE(5317)] = 225112,
  [SMALL_STATE(5318)] = 225199,
  [SMALL_STATE(5319)] = 225286,
  [SMALL_STATE(5320)] = 225373,
  [SMALL_STATE(5321)] = 225460,
  [SMALL_STATE(5322)] = 225547,
  [SMALL_STATE(5323)] = 225634,
  [SMALL_STATE(5324)] = 225721,
  [SMALL_STATE(5325)] = 225808,
  [SMALL_STATE(5326)] = 225895,
  [SMALL_STATE(5327)] = 225982,
  [SMALL_STATE(5328)] = 226069,
  [SMALL_STATE(5329)] = 226156,
  [SMALL_STATE(5330)] = 226243,
  [SMALL_STATE(5331)] = 226330,
  [SMALL_STATE(5332)] = 226417,
  [SMALL_STATE(5333)] = 226466,
  [SMALL_STATE(5334)] = 226515,
  [SMALL_STATE(5335)] = 226602,
  [SMALL_STATE(5336)] = 226689,
  [SMALL_STATE(5337)] = 226776,
  [SMALL_STATE(5338)] = 226863,
  [SMALL_STATE(5339)] = 226950,
  [SMALL_STATE(5340)] = 227037,
  [SMALL_STATE(5341)] = 227124,
  [SMALL_STATE(5342)] = 227211,
  [SMALL_STATE(5343)] = 227298,
  [SMALL_STATE(5344)] = 227385,
  [SMALL_STATE(5345)] = 227472,
  [SMALL_STATE(5346)] = 227559,
  [SMALL_STATE(5347)] = 227646,
  [SMALL_STATE(5348)] = 227733,
  [SMALL_STATE(5349)] = 227820,
  [SMALL_STATE(5350)] = 227907,
  [SMALL_STATE(5351)] = 227994,
  [SMALL_STATE(5352)] = 228081,
  [SMALL_STATE(5353)] = 228168,
  [SMALL_STATE(5354)] = 228255,
  [SMALL_STATE(5355)] = 228342,
  [SMALL_STATE(5356)] = 228429,
  [SMALL_STATE(5357)] = 228516,
  [SMALL_STATE(5358)] = 228603,
  [SMALL_STATE(5359)] = 228690,
  [SMALL_STATE(5360)] = 228777,
  [SMALL_STATE(5361)] = 228864,
  [SMALL_STATE(5362)] = 228951,
  [SMALL_STATE(5363)] = 229038,
  [SMALL_STATE(5364)] = 229125,
  [SMALL_STATE(5365)] = 229212,
  [SMALL_STATE(5366)] = 229299,
  [SMALL_STATE(5367)] = 229386,
  [SMALL_STATE(5368)] = 229473,
  [SMALL_STATE(5369)] = 229522,
  [SMALL_STATE(5370)] = 229609,
  [SMALL_STATE(5371)] = 229658,
  [SMALL_STATE(5372)] = 229745,
  [SMALL_STATE(5373)] = 229832,
  [SMALL_STATE(5374)] = 229919,
  [SMALL_STATE(5375)] = 230006,
  [SMALL_STATE(5376)] = 230093,
  [SMALL_STATE(5377)] = 230180,
  [SMALL_STATE(5378)] = 230267,
  [SMALL_STATE(5379)] = 230316,
  [SMALL_STATE(5380)] = 230403,
  [SMALL_STATE(5381)] = 230490,
  [SMALL_STATE(5382)] = 230577,
  [SMALL_STATE(5383)] = 230664,
  [SMALL_STATE(5384)] = 230751,
  [SMALL_STATE(5385)] = 230838,
  [SMALL_STATE(5386)] = 230925,
  [SMALL_STATE(5387)] = 231012,
  [SMALL_STATE(5388)] = 231099,
  [SMALL_STATE(5389)] = 231186,
  [SMALL_STATE(5390)] = 231273,
  [SMALL_STATE(5391)] = 231360,
  [SMALL_STATE(5392)] = 231447,
  [SMALL_STATE(5393)] = 231534,
  [SMALL_STATE(5394)] = 231621,
  [SMALL_STATE(5395)] = 231708,
  [SMALL_STATE(5396)] = 231795,
  [SMALL_STATE(5397)] = 231882,
  [SMALL_STATE(5398)] = 231969,
  [SMALL_STATE(5399)] = 232056,
  [SMALL_STATE(5400)] = 232143,
  [SMALL_STATE(5401)] = 232230,
  [SMALL_STATE(5402)] = 232317,
  [SMALL_STATE(5403)] = 232404,
  [SMALL_STATE(5404)] = 232491,
  [SMALL_STATE(5405)] = 232578,
  [SMALL_STATE(5406)] = 232665,
  [SMALL_STATE(5407)] = 232752,
  [SMALL_STATE(5408)] = 232839,
  [SMALL_STATE(5409)] = 232926,
  [SMALL_STATE(5410)] = 233013,
  [SMALL_STATE(5411)] = 233100,
  [SMALL_STATE(5412)] = 233187,
  [SMALL_STATE(5413)] = 233274,
  [SMALL_STATE(5414)] = 233361,
  [SMALL_STATE(5415)] = 233448,
  [SMALL_STATE(5416)] = 233535,
  [SMALL_STATE(5417)] = 233622,
  [SMALL_STATE(5418)] = 233709,
  [SMALL_STATE(5419)] = 233796,
  [SMALL_STATE(5420)] = 233883,
  [SMALL_STATE(5421)] = 233970,
  [SMALL_STATE(5422)] = 234057,
  [SMALL_STATE(5423)] = 234144,
  [SMALL_STATE(5424)] = 234231,
  [SMALL_STATE(5425)] = 234318,
  [SMALL_STATE(5426)] = 234405,
  [SMALL_STATE(5427)] = 234492,
  [SMALL_STATE(5428)] = 234579,
  [SMALL_STATE(5429)] = 234666,
  [SMALL_STATE(5430)] = 234753,
  [SMALL_STATE(5431)] = 234840,
  [SMALL_STATE(5432)] = 234927,
  [SMALL_STATE(5433)] = 235014,
  [SMALL_STATE(5434)] = 235101,
  [SMALL_STATE(5435)] = 235188,
  [SMALL_STATE(5436)] = 235275,
  [SMALL_STATE(5437)] = 235362,
  [SMALL_STATE(5438)] = 235449,
  [SMALL_STATE(5439)] = 235536,
  [SMALL_STATE(5440)] = 235623,
  [SMALL_STATE(5441)] = 235710,
  [SMALL_STATE(5442)] = 235797,
  [SMALL_STATE(5443)] = 235884,
  [SMALL_STATE(5444)] = 235971,
  [SMALL_STATE(5445)] = 236058,
  [SMALL_STATE(5446)] = 236145,
  [SMALL_STATE(5447)] = 236232,
  [SMALL_STATE(5448)] = 236319,
  [SMALL_STATE(5449)] = 236406,
  [SMALL_STATE(5450)] = 236493,
  [SMALL_STATE(5451)] = 236580,
  [SMALL_STATE(5452)] = 236667,
  [SMALL_STATE(5453)] = 236754,
  [SMALL_STATE(5454)] = 236841,
  [SMALL_STATE(5455)] = 236928,
  [SMALL_STATE(5456)] = 237015,
  [SMALL_STATE(5457)] = 237102,
  [SMALL_STATE(5458)] = 237189,
  [SMALL_STATE(5459)] = 237276,
  [SMALL_STATE(5460)] = 237363,
  [SMALL_STATE(5461)] = 237450,
  [SMALL_STATE(5462)] = 237537,
  [SMALL_STATE(5463)] = 237624,
  [SMALL_STATE(5464)] = 237711,
  [SMALL_STATE(5465)] = 237798,
  [SMALL_STATE(5466)] = 237885,
  [SMALL_STATE(5467)] = 237972,
  [SMALL_STATE(5468)] = 238059,
  [SMALL_STATE(5469)] = 238146,
  [SMALL_STATE(5470)] = 238233,
  [SMALL_STATE(5471)] = 238320,
  [SMALL_STATE(5472)] = 238407,
  [SMALL_STATE(5473)] = 238494,
  [SMALL_STATE(5474)] = 238581,
  [SMALL_STATE(5475)] = 238668,
  [SMALL_STATE(5476)] = 238755,
  [SMALL_STATE(5477)] = 238842,
  [SMALL_STATE(5478)] = 238897,
  [SMALL_STATE(5479)] = 238984,
  [SMALL_STATE(5480)] = 239071,
  [SMALL_STATE(5481)] = 239158,
  [SMALL_STATE(5482)] = 239245,
  [SMALL_STATE(5483)] = 239332,
  [SMALL_STATE(5484)] = 239419,
  [SMALL_STATE(5485)] = 239506,
  [SMALL_STATE(5486)] = 239593,
  [SMALL_STATE(5487)] = 239680,
  [SMALL_STATE(5488)] = 239767,
  [SMALL_STATE(5489)] = 239854,
  [SMALL_STATE(5490)] = 239941,
  [SMALL_STATE(5491)] = 240028,
  [SMALL_STATE(5492)] = 240115,
  [SMALL_STATE(5493)] = 240202,
  [SMALL_STATE(5494)] = 240289,
  [SMALL_STATE(5495)] = 240376,
  [SMALL_STATE(5496)] = 240463,
  [SMALL_STATE(5497)] = 240550,
  [SMALL_STATE(5498)] = 240637,
  [SMALL_STATE(5499)] = 240724,
  [SMALL_STATE(5500)] = 240811,
  [SMALL_STATE(5501)] = 240898,
  [SMALL_STATE(5502)] = 240985,
  [SMALL_STATE(5503)] = 241072,
  [SMALL_STATE(5504)] = 241159,
  [SMALL_STATE(5505)] = 241246,
  [SMALL_STATE(5506)] = 241333,
  [SMALL_STATE(5507)] = 241420,
  [SMALL_STATE(5508)] = 241507,
  [SMALL_STATE(5509)] = 241594,
  [SMALL_STATE(5510)] = 241681,
  [SMALL_STATE(5511)] = 241768,
  [SMALL_STATE(5512)] = 241855,
  [SMALL_STATE(5513)] = 241942,
  [SMALL_STATE(5514)] = 242029,
  [SMALL_STATE(5515)] = 242116,
  [SMALL_STATE(5516)] = 242165,
  [SMALL_STATE(5517)] = 242252,
  [SMALL_STATE(5518)] = 242339,
  [SMALL_STATE(5519)] = 242426,
  [SMALL_STATE(5520)] = 242513,
  [SMALL_STATE(5521)] = 242600,
  [SMALL_STATE(5522)] = 242687,
  [SMALL_STATE(5523)] = 242774,
  [SMALL_STATE(5524)] = 242861,
  [SMALL_STATE(5525)] = 242948,
  [SMALL_STATE(5526)] = 243035,
  [SMALL_STATE(5527)] = 243122,
  [SMALL_STATE(5528)] = 243209,
  [SMALL_STATE(5529)] = 243296,
  [SMALL_STATE(5530)] = 243383,
  [SMALL_STATE(5531)] = 243470,
  [SMALL_STATE(5532)] = 243557,
  [SMALL_STATE(5533)] = 243610,
  [SMALL_STATE(5534)] = 243697,
  [SMALL_STATE(5535)] = 243784,
  [SMALL_STATE(5536)] = 243871,
  [SMALL_STATE(5537)] = 243958,
  [SMALL_STATE(5538)] = 244045,
  [SMALL_STATE(5539)] = 244132,
  [SMALL_STATE(5540)] = 244219,
  [SMALL_STATE(5541)] = 244306,
  [SMALL_STATE(5542)] = 244355,
  [SMALL_STATE(5543)] = 244442,
  [SMALL_STATE(5544)] = 244529,
  [SMALL_STATE(5545)] = 244616,
  [SMALL_STATE(5546)] = 244703,
  [SMALL_STATE(5547)] = 244790,
  [SMALL_STATE(5548)] = 244877,
  [SMALL_STATE(5549)] = 244964,
  [SMALL_STATE(5550)] = 245051,
  [SMALL_STATE(5551)] = 245138,
  [SMALL_STATE(5552)] = 245225,
  [SMALL_STATE(5553)] = 245274,
  [SMALL_STATE(5554)] = 245361,
  [SMALL_STATE(5555)] = 245448,
  [SMALL_STATE(5556)] = 245535,
  [SMALL_STATE(5557)] = 245622,
  [SMALL_STATE(5558)] = 245709,
  [SMALL_STATE(5559)] = 245796,
  [SMALL_STATE(5560)] = 245883,
  [SMALL_STATE(5561)] = 245970,
  [SMALL_STATE(5562)] = 246057,
  [SMALL_STATE(5563)] = 246144,
  [SMALL_STATE(5564)] = 246231,
  [SMALL_STATE(5565)] = 246318,
  [SMALL_STATE(5566)] = 246405,
  [SMALL_STATE(5567)] = 246492,
  [SMALL_STATE(5568)] = 246579,
  [SMALL_STATE(5569)] = 246666,
  [SMALL_STATE(5570)] = 246753,
  [SMALL_STATE(5571)] = 246840,
  [SMALL_STATE(5572)] = 246927,
  [SMALL_STATE(5573)] = 247014,
  [SMALL_STATE(5574)] = 247101,
  [SMALL_STATE(5575)] = 247188,
  [SMALL_STATE(5576)] = 247275,
  [SMALL_STATE(5577)] = 247362,
  [SMALL_STATE(5578)] = 247449,
  [SMALL_STATE(5579)] = 247536,
  [SMALL_STATE(5580)] = 247623,
  [SMALL_STATE(5581)] = 247710,
  [SMALL_STATE(5582)] = 247797,
  [SMALL_STATE(5583)] = 247884,
  [SMALL_STATE(5584)] = 247971,
  [SMALL_STATE(5585)] = 248058,
  [SMALL_STATE(5586)] = 248145,
  [SMALL_STATE(5587)] = 248232,
  [SMALL_STATE(5588)] = 248319,
  [SMALL_STATE(5589)] = 248406,
  [SMALL_STATE(5590)] = 248493,
  [SMALL_STATE(5591)] = 248580,
  [SMALL_STATE(5592)] = 248667,
  [SMALL_STATE(5593)] = 248754,
  [SMALL_STATE(5594)] = 248841,
  [SMALL_STATE(5595)] = 248928,
  [SMALL_STATE(5596)] = 249015,
  [SMALL_STATE(5597)] = 249102,
  [SMALL_STATE(5598)] = 249189,
  [SMALL_STATE(5599)] = 249276,
  [SMALL_STATE(5600)] = 249326,
  [SMALL_STATE(5601)] = 249376,
  [SMALL_STATE(5602)] = 249426,
  [SMALL_STATE(5603)] = 249476,
  [SMALL_STATE(5604)] = 249526,
  [SMALL_STATE(5605)] = 249576,
  [SMALL_STATE(5606)] = 249626,
  [SMALL_STATE(5607)] = 249676,
  [SMALL_STATE(5608)] = 249726,
  [SMALL_STATE(5609)] = 249776,
  [SMALL_STATE(5610)] = 249826,
  [SMALL_STATE(5611)] = 249876,
  [SMALL_STATE(5612)] = 249926,
  [SMALL_STATE(5613)] = 249976,
  [SMALL_STATE(5614)] = 250026,
  [SMALL_STATE(5615)] = 250076,
  [SMALL_STATE(5616)] = 250126,
  [SMALL_STATE(5617)] = 250176,
  [SMALL_STATE(5618)] = 250226,
  [SMALL_STATE(5619)] = 250276,
  [SMALL_STATE(5620)] = 250326,
  [SMALL_STATE(5621)] = 250376,
  [SMALL_STATE(5622)] = 250426,
  [SMALL_STATE(5623)] = 250476,
  [SMALL_STATE(5624)] = 250526,
  [SMALL_STATE(5625)] = 250576,
  [SMALL_STATE(5626)] = 250626,
  [SMALL_STATE(5627)] = 250676,
  [SMALL_STATE(5628)] = 250726,
  [SMALL_STATE(5629)] = 250776,
  [SMALL_STATE(5630)] = 250826,
  [SMALL_STATE(5631)] = 250876,
  [SMALL_STATE(5632)] = 250926,
  [SMALL_STATE(5633)] = 250976,
  [SMALL_STATE(5634)] = 251026,
  [SMALL_STATE(5635)] = 251076,
  [SMALL_STATE(5636)] = 251126,
  [SMALL_STATE(5637)] = 251176,
  [SMALL_STATE(5638)] = 251226,
  [SMALL_STATE(5639)] = 251276,
  [SMALL_STATE(5640)] = 251326,
  [SMALL_STATE(5641)] = 251376,
  [SMALL_STATE(5642)] = 251426,
  [SMALL_STATE(5643)] = 251476,
  [SMALL_STATE(5644)] = 251576,
  [SMALL_STATE(5645)] = 251626,
  [SMALL_STATE(5646)] = 251676,
  [SMALL_STATE(5647)] = 251726,
  [SMALL_STATE(5648)] = 251776,
  [SMALL_STATE(5649)] = 251826,
  [SMALL_STATE(5650)] = 251876,
  [SMALL_STATE(5651)] = 251926,
  [SMALL_STATE(5652)] = 251976,
  [SMALL_STATE(5653)] = 252026,
  [SMALL_STATE(5654)] = 252076,
  [SMALL_STATE(5655)] = 252126,
  [SMALL_STATE(5656)] = 252176,
  [SMALL_STATE(5657)] = 252226,
  [SMALL_STATE(5658)] = 252276,
  [SMALL_STATE(5659)] = 252326,
  [SMALL_STATE(5660)] = 252376,
  [SMALL_STATE(5661)] = 252426,
  [SMALL_STATE(5662)] = 252476,
  [SMALL_STATE(5663)] = 252526,
  [SMALL_STATE(5664)] = 252576,
  [SMALL_STATE(5665)] = 252626,
  [SMALL_STATE(5666)] = 252676,
  [SMALL_STATE(5667)] = 252726,
  [SMALL_STATE(5668)] = 252776,
  [SMALL_STATE(5669)] = 252826,
  [SMALL_STATE(5670)] = 252876,
  [SMALL_STATE(5671)] = 252926,
  [SMALL_STATE(5672)] = 252976,
  [SMALL_STATE(5673)] = 253026,
  [SMALL_STATE(5674)] = 253076,
  [SMALL_STATE(5675)] = 253170,
  [SMALL_STATE(5676)] = 253220,
  [SMALL_STATE(5677)] = 253270,
  [SMALL_STATE(5678)] = 253320,
  [SMALL_STATE(5679)] = 253370,
  [SMALL_STATE(5680)] = 253420,
  [SMALL_STATE(5681)] = 253470,
  [SMALL_STATE(5682)] = 253520,
  [SMALL_STATE(5683)] = 253570,
  [SMALL_STATE(5684)] = 253620,
  [SMALL_STATE(5685)] = 253670,
  [SMALL_STATE(5686)] = 253720,
  [SMALL_STATE(5687)] = 253770,
  [SMALL_STATE(5688)] = 253820,
  [SMALL_STATE(5689)] = 253870,
  [SMALL_STATE(5690)] = 253920,
  [SMALL_STATE(5691)] = 253970,
  [SMALL_STATE(5692)] = 254020,
  [SMALL_STATE(5693)] = 254070,
  [SMALL_STATE(5694)] = 254120,
  [SMALL_STATE(5695)] = 254220,
  [SMALL_STATE(5696)] = 254270,
  [SMALL_STATE(5697)] = 254320,
  [SMALL_STATE(5698)] = 254370,
  [SMALL_STATE(5699)] = 254420,
  [SMALL_STATE(5700)] = 254470,
  [SMALL_STATE(5701)] = 254520,
  [SMALL_STATE(5702)] = 254570,
  [SMALL_STATE(5703)] = 254620,
  [SMALL_STATE(5704)] = 254670,
  [SMALL_STATE(5705)] = 254766,
  [SMALL_STATE(5706)] = 254816,
  [SMALL_STATE(5707)] = 254866,
  [SMALL_STATE(5708)] = 254916,
  [SMALL_STATE(5709)] = 254966,
  [SMALL_STATE(5710)] = 255016,
  [SMALL_STATE(5711)] = 255066,
  [SMALL_STATE(5712)] = 255166,
  [SMALL_STATE(5713)] = 255216,
  [SMALL_STATE(5714)] = 255266,
  [SMALL_STATE(5715)] = 255316,
  [SMALL_STATE(5716)] = 255366,
  [SMALL_STATE(5717)] = 255416,
  [SMALL_STATE(5718)] = 255466,
  [SMALL_STATE(5719)] = 255516,
  [SMALL_STATE(5720)] = 255566,
  [SMALL_STATE(5721)] = 255616,
  [SMALL_STATE(5722)] = 255666,
  [SMALL_STATE(5723)] = 255762,
  [SMALL_STATE(5724)] = 255812,
  [SMALL_STATE(5725)] = 255862,
  [SMALL_STATE(5726)] = 255912,
  [SMALL_STATE(5727)] = 255962,
  [SMALL_STATE(5728)] = 256012,
  [SMALL_STATE(5729)] = 256062,
  [SMALL_STATE(5730)] = 256162,
  [SMALL_STATE(5731)] = 256212,
  [SMALL_STATE(5732)] = 256262,
  [SMALL_STATE(5733)] = 256312,
  [SMALL_STATE(5734)] = 256362,
  [SMALL_STATE(5735)] = 256412,
  [SMALL_STATE(5736)] = 256462,
  [SMALL_STATE(5737)] = 256512,
  [SMALL_STATE(5738)] = 256608,
  [SMALL_STATE(5739)] = 256658,
  [SMALL_STATE(5740)] = 256708,
  [SMALL_STATE(5741)] = 256758,
  [SMALL_STATE(5742)] = 256808,
  [SMALL_STATE(5743)] = 256858,
  [SMALL_STATE(5744)] = 256954,
  [SMALL_STATE(5745)] = 257004,
  [SMALL_STATE(5746)] = 257100,
  [SMALL_STATE(5747)] = 257196,
  [SMALL_STATE(5748)] = 257246,
  [SMALL_STATE(5749)] = 257296,
  [SMALL_STATE(5750)] = 257346,
  [SMALL_STATE(5751)] = 257396,
  [SMALL_STATE(5752)] = 257446,
  [SMALL_STATE(5753)] = 257496,
  [SMALL_STATE(5754)] = 257546,
  [SMALL_STATE(5755)] = 257596,
  [SMALL_STATE(5756)] = 257646,
  [SMALL_STATE(5757)] = 257696,
  [SMALL_STATE(5758)] = 257746,
  [SMALL_STATE(5759)] = 257796,
  [SMALL_STATE(5760)] = 257846,
  [SMALL_STATE(5761)] = 257896,
  [SMALL_STATE(5762)] = 257946,
  [SMALL_STATE(5763)] = 257996,
  [SMALL_STATE(5764)] = 258046,
  [SMALL_STATE(5765)] = 258096,
  [SMALL_STATE(5766)] = 258196,
  [SMALL_STATE(5767)] = 258246,
  [SMALL_STATE(5768)] = 258296,
  [SMALL_STATE(5769)] = 258346,
  [SMALL_STATE(5770)] = 258396,
  [SMALL_STATE(5771)] = 258446,
  [SMALL_STATE(5772)] = 258496,
  [SMALL_STATE(5773)] = 258546,
  [SMALL_STATE(5774)] = 258596,
  [SMALL_STATE(5775)] = 258646,
  [SMALL_STATE(5776)] = 258696,
  [SMALL_STATE(5777)] = 258746,
  [SMALL_STATE(5778)] = 258796,
  [SMALL_STATE(5779)] = 258846,
  [SMALL_STATE(5780)] = 258896,
  [SMALL_STATE(5781)] = 258946,
  [SMALL_STATE(5782)] = 258996,
  [SMALL_STATE(5783)] = 259046,
  [SMALL_STATE(5784)] = 259096,
  [SMALL_STATE(5785)] = 259146,
  [SMALL_STATE(5786)] = 259196,
  [SMALL_STATE(5787)] = 259293,
  [SMALL_STATE(5788)] = 259388,
  [SMALL_STATE(5789)] = 259485,
  [SMALL_STATE(5790)] = 259582,
  [SMALL_STATE(5791)] = 259679,
  [SMALL_STATE(5792)] = 259774,
  [SMALL_STATE(5793)] = 259871,
  [SMALL_STATE(5794)] = 259924,
  [SMALL_STATE(5795)] = 260021,
  [SMALL_STATE(5796)] = 260118,
  [SMALL_STATE(5797)] = 260215,
  [SMALL_STATE(5798)] = 260312,
  [SMALL_STATE(5799)] = 260409,
  [SMALL_STATE(5800)] = 260506,
  [SMALL_STATE(5801)] = 260559,
  [SMALL_STATE(5802)] = 260656,
  [SMALL_STATE(5803)] = 260709,
  [SMALL_STATE(5804)] = 260806,
  [SMALL_STATE(5805)] = 260903,
  [SMALL_STATE(5806)] = 260956,
  [SMALL_STATE(5807)] = 261053,
  [SMALL_STATE(5808)] = 261150,
  [SMALL_STATE(5809)] = 261247,
  [SMALL_STATE(5810)] = 261300,
  [SMALL_STATE(5811)] = 261397,
  [SMALL_STATE(5812)] = 261492,
  [SMALL_STATE(5813)] = 261545,
  [SMALL_STATE(5814)] = 261642,
  [SMALL_STATE(5815)] = 261737,
  [SMALL_STATE(5816)] = 261834,
  [SMALL_STATE(5817)] = 261887,
  [SMALL_STATE(5818)] = 261940,
  [SMALL_STATE(5819)] = 262037,
  [SMALL_STATE(5820)] = 262134,
  [SMALL_STATE(5821)] = 262231,
  [SMALL_STATE(5822)] = 262328,
  [SMALL_STATE(5823)] = 262425,
  [SMALL_STATE(5824)] = 262522,
  [SMALL_STATE(5825)] = 262619,
  [SMALL_STATE(5826)] = 262716,
  [SMALL_STATE(5827)] = 262813,
  [SMALL_STATE(5828)] = 262910,
  [SMALL_STATE(5829)] = 263007,
  [SMALL_STATE(5830)] = 263060,
  [SMALL_STATE(5831)] = 263157,
  [SMALL_STATE(5832)] = 263254,
  [SMALL_STATE(5833)] = 263351,
  [SMALL_STATE(5834)] = 263448,
  [SMALL_STATE(5835)] = 263501,
  [SMALL_STATE(5836)] = 263554,
  [SMALL_STATE(5837)] = 263651,
  [SMALL_STATE(5838)] = 263748,
  [SMALL_STATE(5839)] = 263801,
  [SMALL_STATE(5840)] = 263898,
  [SMALL_STATE(5841)] = 263995,
  [SMALL_STATE(5842)] = 264048,
  [SMALL_STATE(5843)] = 264145,
  [SMALL_STATE(5844)] = 264240,
  [SMALL_STATE(5845)] = 264337,
  [SMALL_STATE(5846)] = 264390,
  [SMALL_STATE(5847)] = 264443,
  [SMALL_STATE(5848)] = 264540,
  [SMALL_STATE(5849)] = 264637,
  [SMALL_STATE(5850)] = 264690,
  [SMALL_STATE(5851)] = 264787,
  [SMALL_STATE(5852)] = 264840,
  [SMALL_STATE(5853)] = 264934,
  [SMALL_STATE(5854)] = 265028,
  [SMALL_STATE(5855)] = 265118,
  [SMALL_STATE(5856)] = 265212,
  [SMALL_STATE(5857)] = 265306,
  [SMALL_STATE(5858)] = 265400,
  [SMALL_STATE(5859)] = 265494,
  [SMALL_STATE(5860)] = 265588,
  [SMALL_STATE(5861)] = 265682,
  [SMALL_STATE(5862)] = 265776,
  [SMALL_STATE(5863)] = 265870,
  [SMALL_STATE(5864)] = 265964,
  [SMALL_STATE(5865)] = 266058,
  [SMALL_STATE(5866)] = 266152,
  [SMALL_STATE(5867)] = 266246,
  [SMALL_STATE(5868)] = 266340,
  [SMALL_STATE(5869)] = 266434,
  [SMALL_STATE(5870)] = 266528,
  [SMALL_STATE(5871)] = 266622,
  [SMALL_STATE(5872)] = 266716,
  [SMALL_STATE(5873)] = 266810,
  [SMALL_STATE(5874)] = 266904,
  [SMALL_STATE(5875)] = 266998,
  [SMALL_STATE(5876)] = 267092,
  [SMALL_STATE(5877)] = 267186,
  [SMALL_STATE(5878)] = 267280,
  [SMALL_STATE(5879)] = 267374,
  [SMALL_STATE(5880)] = 267468,
  [SMALL_STATE(5881)] = 267562,
  [SMALL_STATE(5882)] = 267656,
  [SMALL_STATE(5883)] = 267750,
  [SMALL_STATE(5884)] = 267844,
  [SMALL_STATE(5885)] = 267938,
  [SMALL_STATE(5886)] = 268032,
  [SMALL_STATE(5887)] = 268126,
  [SMALL_STATE(5888)] = 268220,
  [SMALL_STATE(5889)] = 268314,
  [SMALL_STATE(5890)] = 268408,
  [SMALL_STATE(5891)] = 268502,
  [SMALL_STATE(5892)] = 268596,
  [SMALL_STATE(5893)] = 268690,
  [SMALL_STATE(5894)] = 268784,
  [SMALL_STATE(5895)] = 268878,
  [SMALL_STATE(5896)] = 268972,
  [SMALL_STATE(5897)] = 269066,
  [SMALL_STATE(5898)] = 269160,
  [SMALL_STATE(5899)] = 269254,
  [SMALL_STATE(5900)] = 269348,
  [SMALL_STATE(5901)] = 269442,
  [SMALL_STATE(5902)] = 269536,
  [SMALL_STATE(5903)] = 269630,
  [SMALL_STATE(5904)] = 269724,
  [SMALL_STATE(5905)] = 269818,
  [SMALL_STATE(5906)] = 269912,
  [SMALL_STATE(5907)] = 270006,
  [SMALL_STATE(5908)] = 270100,
  [SMALL_STATE(5909)] = 270194,
  [SMALL_STATE(5910)] = 270288,
  [SMALL_STATE(5911)] = 270382,
  [SMALL_STATE(5912)] = 270476,
  [SMALL_STATE(5913)] = 270570,
  [SMALL_STATE(5914)] = 270616,
  [SMALL_STATE(5915)] = 270710,
  [SMALL_STATE(5916)] = 270804,
  [SMALL_STATE(5917)] = 270898,
  [SMALL_STATE(5918)] = 270992,
  [SMALL_STATE(5919)] = 271086,
  [SMALL_STATE(5920)] = 271180,
  [SMALL_STATE(5921)] = 271274,
  [SMALL_STATE(5922)] = 271368,
  [SMALL_STATE(5923)] = 271462,
  [SMALL_STATE(5924)] = 271556,
  [SMALL_STATE(5925)] = 271650,
  [SMALL_STATE(5926)] = 271744,
  [SMALL_STATE(5927)] = 271838,
  [SMALL_STATE(5928)] = 271930,
  [SMALL_STATE(5929)] = 272024,
  [SMALL_STATE(5930)] = 272118,
  [SMALL_STATE(5931)] = 272212,
  [SMALL_STATE(5932)] = 272306,
  [SMALL_STATE(5933)] = 272400,
  [SMALL_STATE(5934)] = 272494,
  [SMALL_STATE(5935)] = 272588,
  [SMALL_STATE(5936)] = 272682,
  [SMALL_STATE(5937)] = 272776,
  [SMALL_STATE(5938)] = 272870,
  [SMALL_STATE(5939)] = 272964,
  [SMALL_STATE(5940)] = 273058,
  [SMALL_STATE(5941)] = 273152,
  [SMALL_STATE(5942)] = 273246,
  [SMALL_STATE(5943)] = 273340,
  [SMALL_STATE(5944)] = 273434,
  [SMALL_STATE(5945)] = 273528,
  [SMALL_STATE(5946)] = 273622,
  [SMALL_STATE(5947)] = 273716,
  [SMALL_STATE(5948)] = 273810,
  [SMALL_STATE(5949)] = 273904,
  [SMALL_STATE(5950)] = 273998,
  [SMALL_STATE(5951)] = 274092,
  [SMALL_STATE(5952)] = 274186,
  [SMALL_STATE(5953)] = 274280,
  [SMALL_STATE(5954)] = 274374,
  [SMALL_STATE(5955)] = 274468,
  [SMALL_STATE(5956)] = 274562,
  [SMALL_STATE(5957)] = 274656,
  [SMALL_STATE(5958)] = 274750,
  [SMALL_STATE(5959)] = 274844,
  [SMALL_STATE(5960)] = 274938,
  [SMALL_STATE(5961)] = 275032,
  [SMALL_STATE(5962)] = 275126,
  [SMALL_STATE(5963)] = 275220,
  [SMALL_STATE(5964)] = 275312,
  [SMALL_STATE(5965)] = 275406,
  [SMALL_STATE(5966)] = 275500,
  [SMALL_STATE(5967)] = 275594,
  [SMALL_STATE(5968)] = 275688,
  [SMALL_STATE(5969)] = 275782,
  [SMALL_STATE(5970)] = 275876,
  [SMALL_STATE(5971)] = 275970,
  [SMALL_STATE(5972)] = 276064,
  [SMALL_STATE(5973)] = 276158,
  [SMALL_STATE(5974)] = 276252,
  [SMALL_STATE(5975)] = 276346,
  [SMALL_STATE(5976)] = 276440,
  [SMALL_STATE(5977)] = 276534,
  [SMALL_STATE(5978)] = 276628,
  [SMALL_STATE(5979)] = 276722,
  [SMALL_STATE(5980)] = 276812,
  [SMALL_STATE(5981)] = 276906,
  [SMALL_STATE(5982)] = 277000,
  [SMALL_STATE(5983)] = 277094,
  [SMALL_STATE(5984)] = 277188,
  [SMALL_STATE(5985)] = 277282,
  [SMALL_STATE(5986)] = 277376,
  [SMALL_STATE(5987)] = 277470,
  [SMALL_STATE(5988)] = 277561,
  [SMALL_STATE(5989)] = 277650,
  [SMALL_STATE(5990)] = 277739,
  [SMALL_STATE(5991)] = 277828,
  [SMALL_STATE(5992)] = 277919,
  [SMALL_STATE(5993)] = 278010,
  [SMALL_STATE(5994)] = 278059,
  [SMALL_STATE(5995)] = 278108,
  [SMALL_STATE(5996)] = 278197,
  [SMALL_STATE(5997)] = 278286,
  [SMALL_STATE(5998)] = 278375,
  [SMALL_STATE(5999)] = 278464,
  [SMALL_STATE(6000)] = 278555,
  [SMALL_STATE(6001)] = 278646,
  [SMALL_STATE(6002)] = 278695,
  [SMALL_STATE(6003)] = 278744,
  [SMALL_STATE(6004)] = 278833,
  [SMALL_STATE(6005)] = 278922,
  [SMALL_STATE(6006)] = 278971,
  [SMALL_STATE(6007)] = 279060,
  [SMALL_STATE(6008)] = 279151,
  [SMALL_STATE(6009)] = 279242,
  [SMALL_STATE(6010)] = 279333,
  [SMALL_STATE(6011)] = 279424,
  [SMALL_STATE(6012)] = 279515,
  [SMALL_STATE(6013)] = 279564,
  [SMALL_STATE(6014)] = 279653,
  [SMALL_STATE(6015)] = 279702,
  [SMALL_STATE(6016)] = 279791,
  [SMALL_STATE(6017)] = 279840,
  [SMALL_STATE(6018)] = 279931,
  [SMALL_STATE(6019)] = 280020,
  [SMALL_STATE(6020)] = 280111,
  [SMALL_STATE(6021)] = 280160,
  [SMALL_STATE(6022)] = 280251,
  [SMALL_STATE(6023)] = 280300,
  [SMALL_STATE(6024)] = 280349,
  [SMALL_STATE(6025)] = 280440,
  [SMALL_STATE(6026)] = 280489,
  [SMALL_STATE(6027)] = 280580,
  [SMALL_STATE(6028)] = 280669,
  [SMALL_STATE(6029)] = 280760,
  [SMALL_STATE(6030)] = 280851,
  [SMALL_STATE(6031)] = 280942,
  [SMALL_STATE(6032)] = 280991,
  [SMALL_STATE(6033)] = 281080,
  [SMALL_STATE(6034)] = 281171,
  [SMALL_STATE(6035)] = 281220,
  [SMALL_STATE(6036)] = 281311,
  [SMALL_STATE(6037)] = 281402,
  [SMALL_STATE(6038)] = 281493,
  [SMALL_STATE(6039)] = 281582,
  [SMALL_STATE(6040)] = 281631,
  [SMALL_STATE(6041)] = 281720,
  [SMALL_STATE(6042)] = 281769,
  [SMALL_STATE(6043)] = 281858,
  [SMALL_STATE(6044)] = 281947,
  [SMALL_STATE(6045)] = 281996,
  [SMALL_STATE(6046)] = 282084,
  [SMALL_STATE(6047)] = 282172,
  [SMALL_STATE(6048)] = 282260,
  [SMALL_STATE(6049)] = 282348,
  [SMALL_STATE(6050)] = 282436,
  [SMALL_STATE(6051)] = 282524,
  [SMALL_STATE(6052)] = 282612,
  [SMALL_STATE(6053)] = 282700,
  [SMALL_STATE(6054)] = 282788,
  [SMALL_STATE(6055)] = 282876,
  [SMALL_STATE(6056)] = 282964,
  [SMALL_STATE(6057)] = 283052,
  [SMALL_STATE(6058)] = 283140,
  [SMALL_STATE(6059)] = 283228,
  [SMALL_STATE(6060)] = 283316,
  [SMALL_STATE(6061)] = 283404,
  [SMALL_STATE(6062)] = 283492,
  [SMALL_STATE(6063)] = 283580,
  [SMALL_STATE(6064)] = 283668,
  [SMALL_STATE(6065)] = 283756,
  [SMALL_STATE(6066)] = 283844,
  [SMALL_STATE(6067)] = 283932,
  [SMALL_STATE(6068)] = 284020,
  [SMALL_STATE(6069)] = 284108,
  [SMALL_STATE(6070)] = 284196,
  [SMALL_STATE(6071)] = 284284,
  [SMALL_STATE(6072)] = 284372,
  [SMALL_STATE(6073)] = 284460,
  [SMALL_STATE(6074)] = 284548,
  [SMALL_STATE(6075)] = 284636,
  [SMALL_STATE(6076)] = 284724,
  [SMALL_STATE(6077)] = 284812,
  [SMALL_STATE(6078)] = 284900,
  [SMALL_STATE(6079)] = 284988,
  [SMALL_STATE(6080)] = 285076,
  [SMALL_STATE(6081)] = 285164,
  [SMALL_STATE(6082)] = 285252,
  [SMALL_STATE(6083)] = 285340,
  [SMALL_STATE(6084)] = 285428,
  [SMALL_STATE(6085)] = 285516,
  [SMALL_STATE(6086)] = 285604,
  [SMALL_STATE(6087)] = 285692,
  [SMALL_STATE(6088)] = 285780,
  [SMALL_STATE(6089)] = 285868,
  [SMALL_STATE(6090)] = 285956,
  [SMALL_STATE(6091)] = 286044,
  [SMALL_STATE(6092)] = 286132,
  [SMALL_STATE(6093)] = 286220,
  [SMALL_STATE(6094)] = 286308,
  [SMALL_STATE(6095)] = 286396,
  [SMALL_STATE(6096)] = 286484,
  [SMALL_STATE(6097)] = 286572,
  [SMALL_STATE(6098)] = 286660,
  [SMALL_STATE(6099)] = 286748,
  [SMALL_STATE(6100)] = 286836,
  [SMALL_STATE(6101)] = 286924,
  [SMALL_STATE(6102)] = 287012,
  [SMALL_STATE(6103)] = 287100,
  [SMALL_STATE(6104)] = 287188,
  [SMALL_STATE(6105)] = 287276,
  [SMALL_STATE(6106)] = 287364,
  [SMALL_STATE(6107)] = 287452,
  [SMALL_STATE(6108)] = 287540,
  [SMALL_STATE(6109)] = 287628,
  [SMALL_STATE(6110)] = 287716,
  [SMALL_STATE(6111)] = 287804,
  [SMALL_STATE(6112)] = 287892,
  [SMALL_STATE(6113)] = 287980,
  [SMALL_STATE(6114)] = 288068,
  [SMALL_STATE(6115)] = 288156,
  [SMALL_STATE(6116)] = 288244,
  [SMALL_STATE(6117)] = 288332,
  [SMALL_STATE(6118)] = 288420,
  [SMALL_STATE(6119)] = 288508,
  [SMALL_STATE(6120)] = 288596,
  [SMALL_STATE(6121)] = 288684,
  [SMALL_STATE(6122)] = 288772,
  [SMALL_STATE(6123)] = 288860,
  [SMALL_STATE(6124)] = 288948,
  [SMALL_STATE(6125)] = 289036,
  [SMALL_STATE(6126)] = 289124,
  [SMALL_STATE(6127)] = 289212,
  [SMALL_STATE(6128)] = 289300,
  [SMALL_STATE(6129)] = 289388,
  [SMALL_STATE(6130)] = 289476,
  [SMALL_STATE(6131)] = 289564,
  [SMALL_STATE(6132)] = 289652,
  [SMALL_STATE(6133)] = 289740,
  [SMALL_STATE(6134)] = 289828,
  [SMALL_STATE(6135)] = 289916,
  [SMALL_STATE(6136)] = 290004,
  [SMALL_STATE(6137)] = 290092,
  [SMALL_STATE(6138)] = 290180,
  [SMALL_STATE(6139)] = 290268,
  [SMALL_STATE(6140)] = 290356,
  [SMALL_STATE(6141)] = 290444,
  [SMALL_STATE(6142)] = 290532,
  [SMALL_STATE(6143)] = 290620,
  [SMALL_STATE(6144)] = 290708,
  [SMALL_STATE(6145)] = 290796,
  [SMALL_STATE(6146)] = 290884,
  [SMALL_STATE(6147)] = 290972,
  [SMALL_STATE(6148)] = 291060,
  [SMALL_STATE(6149)] = 291148,
  [SMALL_STATE(6150)] = 291236,
  [SMALL_STATE(6151)] = 291324,
  [SMALL_STATE(6152)] = 291412,
  [SMALL_STATE(6153)] = 291500,
  [SMALL_STATE(6154)] = 291588,
  [SMALL_STATE(6155)] = 291676,
  [SMALL_STATE(6156)] = 291764,
  [SMALL_STATE(6157)] = 291852,
  [SMALL_STATE(6158)] = 291940,
  [SMALL_STATE(6159)] = 292028,
  [SMALL_STATE(6160)] = 292116,
  [SMALL_STATE(6161)] = 292204,
  [SMALL_STATE(6162)] = 292292,
  [SMALL_STATE(6163)] = 292380,
  [SMALL_STATE(6164)] = 292468,
  [SMALL_STATE(6165)] = 292556,
  [SMALL_STATE(6166)] = 292644,
  [SMALL_STATE(6167)] = 292732,
  [SMALL_STATE(6168)] = 292820,
  [SMALL_STATE(6169)] = 292908,
  [SMALL_STATE(6170)] = 292996,
  [SMALL_STATE(6171)] = 293084,
  [SMALL_STATE(6172)] = 293172,
  [SMALL_STATE(6173)] = 293260,
  [SMALL_STATE(6174)] = 293348,
  [SMALL_STATE(6175)] = 293436,
  [SMALL_STATE(6176)] = 293524,
  [SMALL_STATE(6177)] = 293612,
  [SMALL_STATE(6178)] = 293700,
  [SMALL_STATE(6179)] = 293788,
  [SMALL_STATE(6180)] = 293876,
  [SMALL_STATE(6181)] = 293964,
  [SMALL_STATE(6182)] = 294052,
  [SMALL_STATE(6183)] = 294140,
  [SMALL_STATE(6184)] = 294228,
  [SMALL_STATE(6185)] = 294316,
  [SMALL_STATE(6186)] = 294404,
  [SMALL_STATE(6187)] = 294492,
  [SMALL_STATE(6188)] = 294580,
  [SMALL_STATE(6189)] = 294668,
  [SMALL_STATE(6190)] = 294756,
  [SMALL_STATE(6191)] = 294844,
  [SMALL_STATE(6192)] = 294932,
  [SMALL_STATE(6193)] = 295020,
  [SMALL_STATE(6194)] = 295108,
  [SMALL_STATE(6195)] = 295196,
  [SMALL_STATE(6196)] = 295284,
  [SMALL_STATE(6197)] = 295372,
  [SMALL_STATE(6198)] = 295460,
  [SMALL_STATE(6199)] = 295548,
  [SMALL_STATE(6200)] = 295636,
  [SMALL_STATE(6201)] = 295724,
  [SMALL_STATE(6202)] = 295812,
  [SMALL_STATE(6203)] = 295900,
  [SMALL_STATE(6204)] = 295988,
  [SMALL_STATE(6205)] = 296076,
  [SMALL_STATE(6206)] = 296164,
  [SMALL_STATE(6207)] = 296252,
  [SMALL_STATE(6208)] = 296340,
  [SMALL_STATE(6209)] = 296428,
  [SMALL_STATE(6210)] = 296516,
  [SMALL_STATE(6211)] = 296604,
  [SMALL_STATE(6212)] = 296692,
  [SMALL_STATE(6213)] = 296780,
  [SMALL_STATE(6214)] = 296868,
  [SMALL_STATE(6215)] = 296956,
  [SMALL_STATE(6216)] = 297044,
  [SMALL_STATE(6217)] = 297132,
  [SMALL_STATE(6218)] = 297220,
  [SMALL_STATE(6219)] = 297308,
  [SMALL_STATE(6220)] = 297396,
  [SMALL_STATE(6221)] = 297484,
  [SMALL_STATE(6222)] = 297572,
  [SMALL_STATE(6223)] = 297660,
  [SMALL_STATE(6224)] = 297748,
  [SMALL_STATE(6225)] = 297836,
  [SMALL_STATE(6226)] = 297924,
  [SMALL_STATE(6227)] = 298012,
  [SMALL_STATE(6228)] = 298100,
  [SMALL_STATE(6229)] = 298188,
  [SMALL_STATE(6230)] = 298276,
  [SMALL_STATE(6231)] = 298364,
  [SMALL_STATE(6232)] = 298452,
  [SMALL_STATE(6233)] = 298540,
  [SMALL_STATE(6234)] = 298628,
  [SMALL_STATE(6235)] = 298716,
  [SMALL_STATE(6236)] = 298804,
  [SMALL_STATE(6237)] = 298892,
  [SMALL_STATE(6238)] = 298980,
  [SMALL_STATE(6239)] = 299068,
  [SMALL_STATE(6240)] = 299156,
  [SMALL_STATE(6241)] = 299244,
  [SMALL_STATE(6242)] = 299332,
  [SMALL_STATE(6243)] = 299420,
  [SMALL_STATE(6244)] = 299508,
  [SMALL_STATE(6245)] = 299596,
  [SMALL_STATE(6246)] = 299684,
  [SMALL_STATE(6247)] = 299772,
  [SMALL_STATE(6248)] = 299860,
  [SMALL_STATE(6249)] = 299948,
  [SMALL_STATE(6250)] = 300036,
  [SMALL_STATE(6251)] = 300124,
  [SMALL_STATE(6252)] = 300212,
  [SMALL_STATE(6253)] = 300300,
  [SMALL_STATE(6254)] = 300388,
  [SMALL_STATE(6255)] = 300476,
  [SMALL_STATE(6256)] = 300564,
  [SMALL_STATE(6257)] = 300652,
  [SMALL_STATE(6258)] = 300740,
  [SMALL_STATE(6259)] = 300828,
  [SMALL_STATE(6260)] = 300916,
  [SMALL_STATE(6261)] = 301004,
  [SMALL_STATE(6262)] = 301092,
  [SMALL_STATE(6263)] = 301180,
  [SMALL_STATE(6264)] = 301268,
  [SMALL_STATE(6265)] = 301356,
  [SMALL_STATE(6266)] = 301444,
  [SMALL_STATE(6267)] = 301532,
  [SMALL_STATE(6268)] = 301620,
  [SMALL_STATE(6269)] = 301708,
  [SMALL_STATE(6270)] = 301796,
  [SMALL_STATE(6271)] = 301884,
  [SMALL_STATE(6272)] = 301972,
  [SMALL_STATE(6273)] = 302060,
  [SMALL_STATE(6274)] = 302148,
  [SMALL_STATE(6275)] = 302236,
  [SMALL_STATE(6276)] = 302324,
  [SMALL_STATE(6277)] = 302412,
  [SMALL_STATE(6278)] = 302500,
  [SMALL_STATE(6279)] = 302588,
  [SMALL_STATE(6280)] = 302676,
  [SMALL_STATE(6281)] = 302764,
  [SMALL_STATE(6282)] = 302852,
  [SMALL_STATE(6283)] = 302940,
  [SMALL_STATE(6284)] = 303028,
  [SMALL_STATE(6285)] = 303116,
  [SMALL_STATE(6286)] = 303204,
  [SMALL_STATE(6287)] = 303292,
  [SMALL_STATE(6288)] = 303380,
  [SMALL_STATE(6289)] = 303468,
  [SMALL_STATE(6290)] = 303556,
  [SMALL_STATE(6291)] = 303644,
  [SMALL_STATE(6292)] = 303732,
  [SMALL_STATE(6293)] = 303820,
  [SMALL_STATE(6294)] = 303908,
  [SMALL_STATE(6295)] = 303996,
  [SMALL_STATE(6296)] = 304084,
  [SMALL_STATE(6297)] = 304172,
  [SMALL_STATE(6298)] = 304260,
  [SMALL_STATE(6299)] = 304348,
  [SMALL_STATE(6300)] = 304436,
  [SMALL_STATE(6301)] = 304524,
  [SMALL_STATE(6302)] = 304612,
  [SMALL_STATE(6303)] = 304700,
  [SMALL_STATE(6304)] = 304788,
  [SMALL_STATE(6305)] = 304876,
  [SMALL_STATE(6306)] = 304964,
  [SMALL_STATE(6307)] = 305052,
  [SMALL_STATE(6308)] = 305140,
  [SMALL_STATE(6309)] = 305228,
  [SMALL_STATE(6310)] = 305316,
  [SMALL_STATE(6311)] = 305404,
  [SMALL_STATE(6312)] = 305492,
  [SMALL_STATE(6313)] = 305580,
  [SMALL_STATE(6314)] = 305668,
  [SMALL_STATE(6315)] = 305756,
  [SMALL_STATE(6316)] = 305844,
  [SMALL_STATE(6317)] = 305932,
  [SMALL_STATE(6318)] = 306020,
  [SMALL_STATE(6319)] = 306108,
  [SMALL_STATE(6320)] = 306196,
  [SMALL_STATE(6321)] = 306284,
  [SMALL_STATE(6322)] = 306372,
  [SMALL_STATE(6323)] = 306460,
  [SMALL_STATE(6324)] = 306548,
  [SMALL_STATE(6325)] = 306636,
  [SMALL_STATE(6326)] = 306724,
  [SMALL_STATE(6327)] = 306812,
  [SMALL_STATE(6328)] = 306900,
  [SMALL_STATE(6329)] = 306988,
  [SMALL_STATE(6330)] = 307076,
  [SMALL_STATE(6331)] = 307164,
  [SMALL_STATE(6332)] = 307252,
  [SMALL_STATE(6333)] = 307340,
  [SMALL_STATE(6334)] = 307428,
  [SMALL_STATE(6335)] = 307516,
  [SMALL_STATE(6336)] = 307604,
  [SMALL_STATE(6337)] = 307692,
  [SMALL_STATE(6338)] = 307780,
  [SMALL_STATE(6339)] = 307868,
  [SMALL_STATE(6340)] = 307956,
  [SMALL_STATE(6341)] = 308044,
  [SMALL_STATE(6342)] = 308132,
  [SMALL_STATE(6343)] = 308220,
  [SMALL_STATE(6344)] = 308308,
  [SMALL_STATE(6345)] = 308396,
  [SMALL_STATE(6346)] = 308484,
  [SMALL_STATE(6347)] = 308572,
  [SMALL_STATE(6348)] = 308660,
  [SMALL_STATE(6349)] = 308748,
  [SMALL_STATE(6350)] = 308836,
  [SMALL_STATE(6351)] = 308924,
  [SMALL_STATE(6352)] = 309012,
  [SMALL_STATE(6353)] = 309100,
  [SMALL_STATE(6354)] = 309188,
  [SMALL_STATE(6355)] = 309276,
  [SMALL_STATE(6356)] = 309364,
  [SMALL_STATE(6357)] = 309452,
  [SMALL_STATE(6358)] = 309540,
  [SMALL_STATE(6359)] = 309628,
  [SMALL_STATE(6360)] = 309716,
  [SMALL_STATE(6361)] = 309804,
  [SMALL_STATE(6362)] = 309892,
  [SMALL_STATE(6363)] = 309980,
  [SMALL_STATE(6364)] = 310068,
  [SMALL_STATE(6365)] = 310156,
  [SMALL_STATE(6366)] = 310244,
  [SMALL_STATE(6367)] = 310332,
  [SMALL_STATE(6368)] = 310420,
  [SMALL_STATE(6369)] = 310508,
  [SMALL_STATE(6370)] = 310596,
  [SMALL_STATE(6371)] = 310684,
  [SMALL_STATE(6372)] = 310772,
  [SMALL_STATE(6373)] = 310860,
  [SMALL_STATE(6374)] = 310948,
  [SMALL_STATE(6375)] = 311036,
  [SMALL_STATE(6376)] = 311124,
  [SMALL_STATE(6377)] = 311212,
  [SMALL_STATE(6378)] = 311300,
  [SMALL_STATE(6379)] = 311388,
  [SMALL_STATE(6380)] = 311476,
  [SMALL_STATE(6381)] = 311564,
  [SMALL_STATE(6382)] = 311652,
  [SMALL_STATE(6383)] = 311740,
  [SMALL_STATE(6384)] = 311828,
  [SMALL_STATE(6385)] = 311916,
  [SMALL_STATE(6386)] = 312004,
  [SMALL_STATE(6387)] = 312092,
  [SMALL_STATE(6388)] = 312180,
  [SMALL_STATE(6389)] = 312268,
  [SMALL_STATE(6390)] = 312356,
  [SMALL_STATE(6391)] = 312444,
  [SMALL_STATE(6392)] = 312532,
  [SMALL_STATE(6393)] = 312620,
  [SMALL_STATE(6394)] = 312708,
  [SMALL_STATE(6395)] = 312796,
  [SMALL_STATE(6396)] = 312884,
  [SMALL_STATE(6397)] = 312972,
  [SMALL_STATE(6398)] = 313060,
  [SMALL_STATE(6399)] = 313148,
  [SMALL_STATE(6400)] = 313236,
  [SMALL_STATE(6401)] = 313324,
  [SMALL_STATE(6402)] = 313412,
  [SMALL_STATE(6403)] = 313500,
  [SMALL_STATE(6404)] = 313588,
  [SMALL_STATE(6405)] = 313676,
  [SMALL_STATE(6406)] = 313764,
  [SMALL_STATE(6407)] = 313852,
  [SMALL_STATE(6408)] = 313940,
  [SMALL_STATE(6409)] = 314028,
  [SMALL_STATE(6410)] = 314116,
  [SMALL_STATE(6411)] = 314204,
  [SMALL_STATE(6412)] = 314292,
  [SMALL_STATE(6413)] = 314380,
  [SMALL_STATE(6414)] = 314468,
  [SMALL_STATE(6415)] = 314556,
  [SMALL_STATE(6416)] = 314644,
  [SMALL_STATE(6417)] = 314732,
  [SMALL_STATE(6418)] = 314820,
  [SMALL_STATE(6419)] = 314908,
  [SMALL_STATE(6420)] = 314996,
  [SMALL_STATE(6421)] = 315084,
  [SMALL_STATE(6422)] = 315172,
  [SMALL_STATE(6423)] = 315260,
  [SMALL_STATE(6424)] = 315348,
  [SMALL_STATE(6425)] = 315436,
  [SMALL_STATE(6426)] = 315524,
  [SMALL_STATE(6427)] = 315612,
  [SMALL_STATE(6428)] = 315700,
  [SMALL_STATE(6429)] = 315788,
  [SMALL_STATE(6430)] = 315876,
  [SMALL_STATE(6431)] = 315964,
  [SMALL_STATE(6432)] = 316052,
  [SMALL_STATE(6433)] = 316140,
  [SMALL_STATE(6434)] = 316228,
  [SMALL_STATE(6435)] = 316316,
  [SMALL_STATE(6436)] = 316404,
  [SMALL_STATE(6437)] = 316492,
  [SMALL_STATE(6438)] = 316580,
  [SMALL_STATE(6439)] = 316668,
  [SMALL_STATE(6440)] = 316756,
  [SMALL_STATE(6441)] = 316844,
  [SMALL_STATE(6442)] = 316932,
  [SMALL_STATE(6443)] = 317020,
  [SMALL_STATE(6444)] = 317108,
  [SMALL_STATE(6445)] = 317196,
  [SMALL_STATE(6446)] = 317284,
  [SMALL_STATE(6447)] = 317372,
  [SMALL_STATE(6448)] = 317460,
  [SMALL_STATE(6449)] = 317548,
  [SMALL_STATE(6450)] = 317636,
  [SMALL_STATE(6451)] = 317724,
  [SMALL_STATE(6452)] = 317812,
  [SMALL_STATE(6453)] = 317900,
  [SMALL_STATE(6454)] = 317988,
  [SMALL_STATE(6455)] = 318076,
  [SMALL_STATE(6456)] = 318164,
  [SMALL_STATE(6457)] = 318252,
  [SMALL_STATE(6458)] = 318340,
  [SMALL_STATE(6459)] = 318428,
  [SMALL_STATE(6460)] = 318516,
  [SMALL_STATE(6461)] = 318604,
  [SMALL_STATE(6462)] = 318692,
  [SMALL_STATE(6463)] = 318735,
  [SMALL_STATE(6464)] = 318778,
  [SMALL_STATE(6465)] = 318821,
  [SMALL_STATE(6466)] = 318864,
  [SMALL_STATE(6467)] = 318907,
  [SMALL_STATE(6468)] = 318992,
  [SMALL_STATE(6469)] = 319057,
  [SMALL_STATE(6470)] = 319122,
  [SMALL_STATE(6471)] = 319187,
  [SMALL_STATE(6472)] = 319252,
  [SMALL_STATE(6473)] = 319317,
  [SMALL_STATE(6474)] = 319382,
  [SMALL_STATE(6475)] = 319447,
  [SMALL_STATE(6476)] = 319512,
  [SMALL_STATE(6477)] = 319577,
  [SMALL_STATE(6478)] = 319642,
  [SMALL_STATE(6479)] = 319707,
  [SMALL_STATE(6480)] = 319772,
  [SMALL_STATE(6481)] = 319837,
  [SMALL_STATE(6482)] = 319902,
  [SMALL_STATE(6483)] = 319967,
  [SMALL_STATE(6484)] = 320032,
  [SMALL_STATE(6485)] = 320097,
  [SMALL_STATE(6486)] = 320162,
  [SMALL_STATE(6487)] = 320227,
  [SMALL_STATE(6488)] = 320292,
  [SMALL_STATE(6489)] = 320357,
  [SMALL_STATE(6490)] = 320422,
  [SMALL_STATE(6491)] = 320487,
  [SMALL_STATE(6492)] = 320520,
  [SMALL_STATE(6493)] = 320553,
  [SMALL_STATE(6494)] = 320590,
  [SMALL_STATE(6495)] = 320627,
  [SMALL_STATE(6496)] = 320669,
  [SMALL_STATE(6497)] = 320703,
  [SMALL_STATE(6498)] = 320745,
  [SMALL_STATE(6499)] = 320787,
  [SMALL_STATE(6500)] = 320829,
  [SMALL_STATE(6501)] = 320871,
  [SMALL_STATE(6502)] = 320905,
  [SMALL_STATE(6503)] = 320947,
  [SMALL_STATE(6504)] = 320986,
  [SMALL_STATE(6505)] = 321019,
  [SMALL_STATE(6506)] = 321066,
  [SMALL_STATE(6507)] = 321113,
  [SMALL_STATE(6508)] = 321154,
  [SMALL_STATE(6509)] = 321201,
  [SMALL_STATE(6510)] = 321242,
  [SMALL_STATE(6511)] = 321281,
  [SMALL_STATE(6512)] = 321320,
  [SMALL_STATE(6513)] = 321361,
  [SMALL_STATE(6514)] = 321400,
  [SMALL_STATE(6515)] = 321447,
  [SMALL_STATE(6516)] = 321494,
  [SMALL_STATE(6517)] = 321541,
  [SMALL_STATE(6518)] = 321580,
  [SMALL_STATE(6519)] = 321621,
  [SMALL_STATE(6520)] = 321668,
  [SMALL_STATE(6521)] = 321715,
  [SMALL_STATE(6522)] = 321756,
  [SMALL_STATE(6523)] = 321803,
  [SMALL_STATE(6524)] = 321844,
  [SMALL_STATE(6525)] = 321883,
  [SMALL_STATE(6526)] = 321922,
  [SMALL_STATE(6527)] = 321963,
  [SMALL_STATE(6528)] = 322010,
  [SMALL_STATE(6529)] = 322051,
  [SMALL_STATE(6530)] = 322090,
  [SMALL_STATE(6531)] = 322129,
  [SMALL_STATE(6532)] = 322170,
  [SMALL_STATE(6533)] = 322201,
  [SMALL_STATE(6534)] = 322248,
  [SMALL_STATE(6535)] = 322287,
  [SMALL_STATE(6536)] = 322326,
  [SMALL_STATE(6537)] = 322365,
  [SMALL_STATE(6538)] = 322412,
  [SMALL_STATE(6539)] = 322453,
  [SMALL_STATE(6540)] = 322492,
  [SMALL_STATE(6541)] = 322531,
  [SMALL_STATE(6542)] = 322572,
  [SMALL_STATE(6543)] = 322619,
  [SMALL_STATE(6544)] = 322660,
  [SMALL_STATE(6545)] = 322699,
  [SMALL_STATE(6546)] = 322738,
  [SMALL_STATE(6547)] = 322777,
  [SMALL_STATE(6548)] = 322818,
  [SMALL_STATE(6549)] = 322865,
  [SMALL_STATE(6550)] = 322912,
  [SMALL_STATE(6551)] = 322959,
  [SMALL_STATE(6552)] = 323006,
  [SMALL_STATE(6553)] = 323053,
  [SMALL_STATE(6554)] = 323092,
  [SMALL_STATE(6555)] = 323130,
  [SMALL_STATE(6556)] = 323168,
  [SMALL_STATE(6557)] = 323206,
  [SMALL_STATE(6558)] = 323244,
  [SMALL_STATE(6559)] = 323284,
  [SMALL_STATE(6560)] = 323322,
  [SMALL_STATE(6561)] = 323360,
  [SMALL_STATE(6562)] = 323398,
  [SMALL_STATE(6563)] = 323438,
  [SMALL_STATE(6564)] = 323478,
  [SMALL_STATE(6565)] = 323508,
  [SMALL_STATE(6566)] = 323540,
  [SMALL_STATE(6567)] = 323578,
  [SMALL_STATE(6568)] = 323618,
  [SMALL_STATE(6569)] = 323662,
  [SMALL_STATE(6570)] = 323702,
  [SMALL_STATE(6571)] = 323742,
  [SMALL_STATE(6572)] = 323780,
  [SMALL_STATE(6573)] = 323820,
  [SMALL_STATE(6574)] = 323850,
  [SMALL_STATE(6575)] = 323890,
  [SMALL_STATE(6576)] = 323930,
  [SMALL_STATE(6577)] = 323970,
  [SMALL_STATE(6578)] = 324010,
  [SMALL_STATE(6579)] = 324048,
  [SMALL_STATE(6580)] = 324086,
  [SMALL_STATE(6581)] = 324124,
  [SMALL_STATE(6582)] = 324154,
  [SMALL_STATE(6583)] = 324184,
  [SMALL_STATE(6584)] = 324213,
  [SMALL_STATE(6585)] = 324240,
  [SMALL_STATE(6586)] = 324269,
  [SMALL_STATE(6587)] = 324306,
  [SMALL_STATE(6588)] = 324343,
  [SMALL_STATE(6589)] = 324370,
  [SMALL_STATE(6590)] = 324397,
  [SMALL_STATE(6591)] = 324424,
  [SMALL_STATE(6592)] = 324451,
  [SMALL_STATE(6593)] = 324480,
  [SMALL_STATE(6594)] = 324507,
  [SMALL_STATE(6595)] = 324534,
  [SMALL_STATE(6596)] = 324561,
  [SMALL_STATE(6597)] = 324600,
  [SMALL_STATE(6598)] = 324629,
  [SMALL_STATE(6599)] = 324666,
  [SMALL_STATE(6600)] = 324705,
  [SMALL_STATE(6601)] = 324732,
  [SMALL_STATE(6602)] = 324769,
  [SMALL_STATE(6603)] = 324796,
  [SMALL_STATE(6604)] = 324835,
  [SMALL_STATE(6605)] = 324872,
  [SMALL_STATE(6606)] = 324909,
  [SMALL_STATE(6607)] = 324946,
  [SMALL_STATE(6608)] = 324983,
  [SMALL_STATE(6609)] = 325021,
  [SMALL_STATE(6610)] = 325055,
  [SMALL_STATE(6611)] = 325089,
  [SMALL_STATE(6612)] = 325123,
  [SMALL_STATE(6613)] = 325157,
  [SMALL_STATE(6614)] = 325191,
  [SMALL_STATE(6615)] = 325219,
  [SMALL_STATE(6616)] = 325259,
  [SMALL_STATE(6617)] = 325285,
  [SMALL_STATE(6618)] = 325311,
  [SMALL_STATE(6619)] = 325337,
  [SMALL_STATE(6620)] = 325367,
  [SMALL_STATE(6621)] = 325393,
  [SMALL_STATE(6622)] = 325431,
  [SMALL_STATE(6623)] = 325461,
  [SMALL_STATE(6624)] = 325487,
  [SMALL_STATE(6625)] = 325517,
  [SMALL_STATE(6626)] = 325551,
  [SMALL_STATE(6627)] = 325588,
  [SMALL_STATE(6628)] = 325615,
  [SMALL_STATE(6629)] = 325642,
  [SMALL_STATE(6630)] = 325669,
  [SMALL_STATE(6631)] = 325696,
  [SMALL_STATE(6632)] = 325723,
  [SMALL_STATE(6633)] = 325760,
  [SMALL_STATE(6634)] = 325795,
  [SMALL_STATE(6635)] = 325830,
  [SMALL_STATE(6636)] = 325857,
  [SMALL_STATE(6637)] = 325892,
  [SMALL_STATE(6638)] = 325919,
  [SMALL_STATE(6639)] = 325956,
  [SMALL_STATE(6640)] = 325983,
  [SMALL_STATE(6641)] = 326010,
  [SMALL_STATE(6642)] = 326037,
  [SMALL_STATE(6643)] = 326064,
  [SMALL_STATE(6644)] = 326101,
  [SMALL_STATE(6645)] = 326136,
  [SMALL_STATE(6646)] = 326163,
  [SMALL_STATE(6647)] = 326198,
  [SMALL_STATE(6648)] = 326235,
  [SMALL_STATE(6649)] = 326262,
  [SMALL_STATE(6650)] = 326289,
  [SMALL_STATE(6651)] = 326316,
  [SMALL_STATE(6652)] = 326343,
  [SMALL_STATE(6653)] = 326370,
  [SMALL_STATE(6654)] = 326407,
  [SMALL_STATE(6655)] = 326444,
  [SMALL_STATE(6656)] = 326471,
  [SMALL_STATE(6657)] = 326498,
  [SMALL_STATE(6658)] = 326527,
  [SMALL_STATE(6659)] = 326554,
  [SMALL_STATE(6660)] = 326581,
  [SMALL_STATE(6661)] = 326608,
  [SMALL_STATE(6662)] = 326635,
  [SMALL_STATE(6663)] = 326672,
  [SMALL_STATE(6664)] = 326709,
  [SMALL_STATE(6665)] = 326746,
  [SMALL_STATE(6666)] = 326775,
  [SMALL_STATE(6667)] = 326802,
  [SMALL_STATE(6668)] = 326839,
  [SMALL_STATE(6669)] = 326876,
  [SMALL_STATE(6670)] = 326903,
  [SMALL_STATE(6671)] = 326940,
  [SMALL_STATE(6672)] = 326967,
  [SMALL_STATE(6673)] = 326994,
  [SMALL_STATE(6674)] = 327029,
  [SMALL_STATE(6675)] = 327056,
  [SMALL_STATE(6676)] = 327093,
  [SMALL_STATE(6677)] = 327130,
  [SMALL_STATE(6678)] = 327167,
  [SMALL_STATE(6679)] = 327194,
  [SMALL_STATE(6680)] = 327221,
  [SMALL_STATE(6681)] = 327248,
  [SMALL_STATE(6682)] = 327282,
  [SMALL_STATE(6683)] = 327316,
  [SMALL_STATE(6684)] = 327350,
  [SMALL_STATE(6685)] = 327386,
  [SMALL_STATE(6686)] = 327420,
  [SMALL_STATE(6687)] = 327456,
  [SMALL_STATE(6688)] = 327490,
  [SMALL_STATE(6689)] = 327524,
  [SMALL_STATE(6690)] = 327550,
  [SMALL_STATE(6691)] = 327584,
  [SMALL_STATE(6692)] = 327622,
  [SMALL_STATE(6693)] = 327660,
  [SMALL_STATE(6694)] = 327694,
  [SMALL_STATE(6695)] = 327730,
  [SMALL_STATE(6696)] = 327764,
  [SMALL_STATE(6697)] = 327800,
  [SMALL_STATE(6698)] = 327834,
  [SMALL_STATE(6699)] = 327868,
  [SMALL_STATE(6700)] = 327904,
  [SMALL_STATE(6701)] = 327938,
  [SMALL_STATE(6702)] = 327972,
  [SMALL_STATE(6703)] = 328006,
  [SMALL_STATE(6704)] = 328042,
  [SMALL_STATE(6705)] = 328076,
  [SMALL_STATE(6706)] = 328112,
  [SMALL_STATE(6707)] = 328146,
  [SMALL_STATE(6708)] = 328182,
  [SMALL_STATE(6709)] = 328216,
  [SMALL_STATE(6710)] = 328250,
  [SMALL_STATE(6711)] = 328284,
  [SMALL_STATE(6712)] = 328318,
  [SMALL_STATE(6713)] = 328354,
  [SMALL_STATE(6714)] = 328388,
  [SMALL_STATE(6715)] = 328424,
  [SMALL_STATE(6716)] = 328458,
  [SMALL_STATE(6717)] = 328492,
  [SMALL_STATE(6718)] = 328530,
  [SMALL_STATE(6719)] = 328564,
  [SMALL_STATE(6720)] = 328598,
  [SMALL_STATE(6721)] = 328632,
  [SMALL_STATE(6722)] = 328658,
  [SMALL_STATE(6723)] = 328692,
  [SMALL_STATE(6724)] = 328726,
  [SMALL_STATE(6725)] = 328760,
  [SMALL_STATE(6726)] = 328794,
  [SMALL_STATE(6727)] = 328828,
  [SMALL_STATE(6728)] = 328862,
  [SMALL_STATE(6729)] = 328896,
  [SMALL_STATE(6730)] = 328932,
  [SMALL_STATE(6731)] = 328966,
  [SMALL_STATE(6732)] = 329004,
  [SMALL_STATE(6733)] = 329042,
  [SMALL_STATE(6734)] = 329080,
  [SMALL_STATE(6735)] = 329113,
  [SMALL_STATE(6736)] = 329136,
  [SMALL_STATE(6737)] = 329159,
  [SMALL_STATE(6738)] = 329182,
  [SMALL_STATE(6739)] = 329207,
  [SMALL_STATE(6740)] = 329230,
  [SMALL_STATE(6741)] = 329255,
  [SMALL_STATE(6742)] = 329278,
  [SMALL_STATE(6743)] = 329301,
  [SMALL_STATE(6744)] = 329334,
  [SMALL_STATE(6745)] = 329367,
  [SMALL_STATE(6746)] = 329390,
  [SMALL_STATE(6747)] = 329425,
  [SMALL_STATE(6748)] = 329450,
  [SMALL_STATE(6749)] = 329483,
  [SMALL_STATE(6750)] = 329516,
  [SMALL_STATE(6751)] = 329551,
  [SMALL_STATE(6752)] = 329576,
  [SMALL_STATE(6753)] = 329599,
  [SMALL_STATE(6754)] = 329622,
  [SMALL_STATE(6755)] = 329655,
  [SMALL_STATE(6756)] = 329690,
  [SMALL_STATE(6757)] = 329713,
  [SMALL_STATE(6758)] = 329738,
  [SMALL_STATE(6759)] = 329760,
  [SMALL_STATE(6760)] = 329784,
  [SMALL_STATE(6761)] = 329808,
  [SMALL_STATE(6762)] = 329832,
  [SMALL_STATE(6763)] = 329854,
  [SMALL_STATE(6764)] = 329876,
  [SMALL_STATE(6765)] = 329900,
  [SMALL_STATE(6766)] = 329922,
  [SMALL_STATE(6767)] = 329944,
  [SMALL_STATE(6768)] = 329968,
  [SMALL_STATE(6769)] = 329992,
  [SMALL_STATE(6770)] = 330016,
  [SMALL_STATE(6771)] = 330040,
  [SMALL_STATE(6772)] = 330062,
  [SMALL_STATE(6773)] = 330086,
  [SMALL_STATE(6774)] = 330110,
  [SMALL_STATE(6775)] = 330132,
  [SMALL_STATE(6776)] = 330156,
  [SMALL_STATE(6777)] = 330180,
  [SMALL_STATE(6778)] = 330206,
  [SMALL_STATE(6779)] = 330232,
  [SMALL_STATE(6780)] = 330258,
  [SMALL_STATE(6781)] = 330284,
  [SMALL_STATE(6782)] = 330308,
  [SMALL_STATE(6783)] = 330336,
  [SMALL_STATE(6784)] = 330358,
  [SMALL_STATE(6785)] = 330386,
  [SMALL_STATE(6786)] = 330408,
  [SMALL_STATE(6787)] = 330430,
  [SMALL_STATE(6788)] = 330458,
  [SMALL_STATE(6789)] = 330486,
  [SMALL_STATE(6790)] = 330512,
  [SMALL_STATE(6791)] = 330536,
  [SMALL_STATE(6792)] = 330558,
  [SMALL_STATE(6793)] = 330580,
  [SMALL_STATE(6794)] = 330602,
  [SMALL_STATE(6795)] = 330624,
  [SMALL_STATE(6796)] = 330646,
  [SMALL_STATE(6797)] = 330674,
  [SMALL_STATE(6798)] = 330702,
  [SMALL_STATE(6799)] = 330727,
  [SMALL_STATE(6800)] = 330750,
  [SMALL_STATE(6801)] = 330773,
  [SMALL_STATE(6802)] = 330796,
  [SMALL_STATE(6803)] = 330825,
  [SMALL_STATE(6804)] = 330848,
  [SMALL_STATE(6805)] = 330871,
  [SMALL_STATE(6806)] = 330894,
  [SMALL_STATE(6807)] = 330917,
  [SMALL_STATE(6808)] = 330940,
  [SMALL_STATE(6809)] = 330969,
  [SMALL_STATE(6810)] = 330994,
  [SMALL_STATE(6811)] = 331017,
  [SMALL_STATE(6812)] = 331040,
  [SMALL_STATE(6813)] = 331063,
  [SMALL_STATE(6814)] = 331084,
  [SMALL_STATE(6815)] = 331107,
  [SMALL_STATE(6816)] = 331130,
  [SMALL_STATE(6817)] = 331151,
  [SMALL_STATE(6818)] = 331174,
  [SMALL_STATE(6819)] = 331203,
  [SMALL_STATE(6820)] = 331226,
  [SMALL_STATE(6821)] = 331253,
  [SMALL_STATE(6822)] = 331278,
  [SMALL_STATE(6823)] = 331301,
  [SMALL_STATE(6824)] = 331324,
  [SMALL_STATE(6825)] = 331349,
  [SMALL_STATE(6826)] = 331372,
  [SMALL_STATE(6827)] = 331395,
  [SMALL_STATE(6828)] = 331426,
  [SMALL_STATE(6829)] = 331447,
  [SMALL_STATE(6830)] = 331472,
  [SMALL_STATE(6831)] = 331493,
  [SMALL_STATE(6832)] = 331514,
  [SMALL_STATE(6833)] = 331543,
  [SMALL_STATE(6834)] = 331566,
  [SMALL_STATE(6835)] = 331589,
  [SMALL_STATE(6836)] = 331610,
  [SMALL_STATE(6837)] = 331633,
  [SMALL_STATE(6838)] = 331656,
  [SMALL_STATE(6839)] = 331679,
  [SMALL_STATE(6840)] = 331704,
  [SMALL_STATE(6841)] = 331727,
  [SMALL_STATE(6842)] = 331756,
  [SMALL_STATE(6843)] = 331785,
  [SMALL_STATE(6844)] = 331814,
  [SMALL_STATE(6845)] = 331839,
  [SMALL_STATE(6846)] = 331862,
  [SMALL_STATE(6847)] = 331883,
  [SMALL_STATE(6848)] = 331912,
  [SMALL_STATE(6849)] = 331941,
  [SMALL_STATE(6850)] = 331961,
  [SMALL_STATE(6851)] = 331981,
  [SMALL_STATE(6852)] = 332003,
  [SMALL_STATE(6853)] = 332025,
  [SMALL_STATE(6854)] = 332047,
  [SMALL_STATE(6855)] = 332069,
  [SMALL_STATE(6856)] = 332089,
  [SMALL_STATE(6857)] = 332111,
  [SMALL_STATE(6858)] = 332131,
  [SMALL_STATE(6859)] = 332153,
  [SMALL_STATE(6860)] = 332173,
  [SMALL_STATE(6861)] = 332195,
  [SMALL_STATE(6862)] = 332215,
  [SMALL_STATE(6863)] = 332235,
  [SMALL_STATE(6864)] = 332257,
  [SMALL_STATE(6865)] = 332277,
  [SMALL_STATE(6866)] = 332299,
  [SMALL_STATE(6867)] = 332319,
  [SMALL_STATE(6868)] = 332341,
  [SMALL_STATE(6869)] = 332363,
  [SMALL_STATE(6870)] = 332381,
  [SMALL_STATE(6871)] = 332403,
  [SMALL_STATE(6872)] = 332423,
  [SMALL_STATE(6873)] = 332443,
  [SMALL_STATE(6874)] = 332465,
  [SMALL_STATE(6875)] = 332485,
  [SMALL_STATE(6876)] = 332507,
  [SMALL_STATE(6877)] = 332529,
  [SMALL_STATE(6878)] = 332551,
  [SMALL_STATE(6879)] = 332573,
  [SMALL_STATE(6880)] = 332593,
  [SMALL_STATE(6881)] = 332613,
  [SMALL_STATE(6882)] = 332633,
  [SMALL_STATE(6883)] = 332653,
  [SMALL_STATE(6884)] = 332673,
  [SMALL_STATE(6885)] = 332693,
  [SMALL_STATE(6886)] = 332715,
  [SMALL_STATE(6887)] = 332735,
  [SMALL_STATE(6888)] = 332757,
  [SMALL_STATE(6889)] = 332779,
  [SMALL_STATE(6890)] = 332801,
  [SMALL_STATE(6891)] = 332821,
  [SMALL_STATE(6892)] = 332843,
  [SMALL_STATE(6893)] = 332863,
  [SMALL_STATE(6894)] = 332883,
  [SMALL_STATE(6895)] = 332903,
  [SMALL_STATE(6896)] = 332925,
  [SMALL_STATE(6897)] = 332945,
  [SMALL_STATE(6898)] = 332965,
  [SMALL_STATE(6899)] = 332987,
  [SMALL_STATE(6900)] = 333009,
  [SMALL_STATE(6901)] = 333025,
  [SMALL_STATE(6902)] = 333047,
  [SMALL_STATE(6903)] = 333069,
  [SMALL_STATE(6904)] = 333089,
  [SMALL_STATE(6905)] = 333111,
  [SMALL_STATE(6906)] = 333131,
  [SMALL_STATE(6907)] = 333151,
  [SMALL_STATE(6908)] = 333171,
  [SMALL_STATE(6909)] = 333191,
  [SMALL_STATE(6910)] = 333216,
  [SMALL_STATE(6911)] = 333231,
  [SMALL_STATE(6912)] = 333250,
  [SMALL_STATE(6913)] = 333277,
  [SMALL_STATE(6914)] = 333296,
  [SMALL_STATE(6915)] = 333315,
  [SMALL_STATE(6916)] = 333336,
  [SMALL_STATE(6917)] = 333361,
  [SMALL_STATE(6918)] = 333388,
  [SMALL_STATE(6919)] = 333415,
  [SMALL_STATE(6920)] = 333438,
  [SMALL_STATE(6921)] = 333465,
  [SMALL_STATE(6922)] = 333482,
  [SMALL_STATE(6923)] = 333497,
  [SMALL_STATE(6924)] = 333516,
  [SMALL_STATE(6925)] = 333537,
  [SMALL_STATE(6926)] = 333556,
  [SMALL_STATE(6927)] = 333575,
  [SMALL_STATE(6928)] = 333596,
  [SMALL_STATE(6929)] = 333623,
  [SMALL_STATE(6930)] = 333648,
  [SMALL_STATE(6931)] = 333667,
  [SMALL_STATE(6932)] = 333690,
  [SMALL_STATE(6933)] = 333706,
  [SMALL_STATE(6934)] = 333722,
  [SMALL_STATE(6935)] = 333736,
  [SMALL_STATE(6936)] = 333752,
  [SMALL_STATE(6937)] = 333768,
  [SMALL_STATE(6938)] = 333782,
  [SMALL_STATE(6939)] = 333796,
  [SMALL_STATE(6940)] = 333814,
  [SMALL_STATE(6941)] = 333832,
  [SMALL_STATE(6942)] = 333846,
  [SMALL_STATE(6943)] = 333860,
  [SMALL_STATE(6944)] = 333874,
  [SMALL_STATE(6945)] = 333888,
  [SMALL_STATE(6946)] = 333906,
  [SMALL_STATE(6947)] = 333920,
  [SMALL_STATE(6948)] = 333942,
  [SMALL_STATE(6949)] = 333964,
  [SMALL_STATE(6950)] = 333988,
  [SMALL_STATE(6951)] = 334002,
  [SMALL_STATE(6952)] = 334026,
  [SMALL_STATE(6953)] = 334040,
  [SMALL_STATE(6954)] = 334064,
  [SMALL_STATE(6955)] = 334078,
  [SMALL_STATE(6956)] = 334092,
  [SMALL_STATE(6957)] = 334112,
  [SMALL_STATE(6958)] = 334126,
  [SMALL_STATE(6959)] = 334142,
  [SMALL_STATE(6960)] = 334158,
  [SMALL_STATE(6961)] = 334180,
  [SMALL_STATE(6962)] = 334194,
  [SMALL_STATE(6963)] = 334210,
  [SMALL_STATE(6964)] = 334226,
  [SMALL_STATE(6965)] = 334242,
  [SMALL_STATE(6966)] = 334256,
  [SMALL_STATE(6967)] = 334270,
  [SMALL_STATE(6968)] = 334284,
  [SMALL_STATE(6969)] = 334308,
  [SMALL_STATE(6970)] = 334328,
  [SMALL_STATE(6971)] = 334352,
  [SMALL_STATE(6972)] = 334366,
  [SMALL_STATE(6973)] = 334382,
  [SMALL_STATE(6974)] = 334402,
  [SMALL_STATE(6975)] = 334424,
  [SMALL_STATE(6976)] = 334440,
  [SMALL_STATE(6977)] = 334464,
  [SMALL_STATE(6978)] = 334480,
  [SMALL_STATE(6979)] = 334494,
  [SMALL_STATE(6980)] = 334518,
  [SMALL_STATE(6981)] = 334534,
  [SMALL_STATE(6982)] = 334550,
  [SMALL_STATE(6983)] = 334574,
  [SMALL_STATE(6984)] = 334590,
  [SMALL_STATE(6985)] = 334614,
  [SMALL_STATE(6986)] = 334628,
  [SMALL_STATE(6987)] = 334642,
  [SMALL_STATE(6988)] = 334656,
  [SMALL_STATE(6989)] = 334670,
  [SMALL_STATE(6990)] = 334690,
  [SMALL_STATE(6991)] = 334714,
  [SMALL_STATE(6992)] = 334734,
  [SMALL_STATE(6993)] = 334748,
  [SMALL_STATE(6994)] = 334768,
  [SMALL_STATE(6995)] = 334782,
  [SMALL_STATE(6996)] = 334796,
  [SMALL_STATE(6997)] = 334810,
  [SMALL_STATE(6998)] = 334830,
  [SMALL_STATE(6999)] = 334844,
  [SMALL_STATE(7000)] = 334858,
  [SMALL_STATE(7001)] = 334872,
  [SMALL_STATE(7002)] = 334886,
  [SMALL_STATE(7003)] = 334900,
  [SMALL_STATE(7004)] = 334922,
  [SMALL_STATE(7005)] = 334938,
  [SMALL_STATE(7006)] = 334954,
  [SMALL_STATE(7007)] = 334968,
  [SMALL_STATE(7008)] = 334982,
  [SMALL_STATE(7009)] = 335004,
  [SMALL_STATE(7010)] = 335020,
  [SMALL_STATE(7011)] = 335034,
  [SMALL_STATE(7012)] = 335048,
  [SMALL_STATE(7013)] = 335064,
  [SMALL_STATE(7014)] = 335086,
  [SMALL_STATE(7015)] = 335100,
  [SMALL_STATE(7016)] = 335116,
  [SMALL_STATE(7017)] = 335140,
  [SMALL_STATE(7018)] = 335162,
  [SMALL_STATE(7019)] = 335176,
  [SMALL_STATE(7020)] = 335196,
  [SMALL_STATE(7021)] = 335212,
  [SMALL_STATE(7022)] = 335226,
  [SMALL_STATE(7023)] = 335240,
  [SMALL_STATE(7024)] = 335254,
  [SMALL_STATE(7025)] = 335268,
  [SMALL_STATE(7026)] = 335290,
  [SMALL_STATE(7027)] = 335304,
  [SMALL_STATE(7028)] = 335318,
  [SMALL_STATE(7029)] = 335338,
  [SMALL_STATE(7030)] = 335358,
  [SMALL_STATE(7031)] = 335382,
  [SMALL_STATE(7032)] = 335396,
  [SMALL_STATE(7033)] = 335412,
  [SMALL_STATE(7034)] = 335432,
  [SMALL_STATE(7035)] = 335446,
  [SMALL_STATE(7036)] = 335462,
  [SMALL_STATE(7037)] = 335476,
  [SMALL_STATE(7038)] = 335496,
  [SMALL_STATE(7039)] = 335518,
  [SMALL_STATE(7040)] = 335542,
  [SMALL_STATE(7041)] = 335566,
  [SMALL_STATE(7042)] = 335590,
  [SMALL_STATE(7043)] = 335604,
  [SMALL_STATE(7044)] = 335620,
  [SMALL_STATE(7045)] = 335640,
  [SMALL_STATE(7046)] = 335654,
  [SMALL_STATE(7047)] = 335668,
  [SMALL_STATE(7048)] = 335684,
  [SMALL_STATE(7049)] = 335702,
  [SMALL_STATE(7050)] = 335718,
  [SMALL_STATE(7051)] = 335732,
  [SMALL_STATE(7052)] = 335746,
  [SMALL_STATE(7053)] = 335764,
  [SMALL_STATE(7054)] = 335780,
  [SMALL_STATE(7055)] = 335804,
  [SMALL_STATE(7056)] = 335818,
  [SMALL_STATE(7057)] = 335832,
  [SMALL_STATE(7058)] = 335854,
  [SMALL_STATE(7059)] = 335868,
  [SMALL_STATE(7060)] = 335882,
  [SMALL_STATE(7061)] = 335896,
  [SMALL_STATE(7062)] = 335910,
  [SMALL_STATE(7063)] = 335934,
  [SMALL_STATE(7064)] = 335948,
  [SMALL_STATE(7065)] = 335964,
  [SMALL_STATE(7066)] = 335988,
  [SMALL_STATE(7067)] = 336004,
  [SMALL_STATE(7068)] = 336018,
  [SMALL_STATE(7069)] = 336034,
  [SMALL_STATE(7070)] = 336052,
  [SMALL_STATE(7071)] = 336066,
  [SMALL_STATE(7072)] = 336086,
  [SMALL_STATE(7073)] = 336100,
  [SMALL_STATE(7074)] = 336114,
  [SMALL_STATE(7075)] = 336128,
  [SMALL_STATE(7076)] = 336142,
  [SMALL_STATE(7077)] = 336164,
  [SMALL_STATE(7078)] = 336180,
  [SMALL_STATE(7079)] = 336204,
  [SMALL_STATE(7080)] = 336228,
  [SMALL_STATE(7081)] = 336242,
  [SMALL_STATE(7082)] = 336258,
  [SMALL_STATE(7083)] = 336272,
  [SMALL_STATE(7084)] = 336286,
  [SMALL_STATE(7085)] = 336302,
  [SMALL_STATE(7086)] = 336316,
  [SMALL_STATE(7087)] = 336330,
  [SMALL_STATE(7088)] = 336354,
  [SMALL_STATE(7089)] = 336368,
  [SMALL_STATE(7090)] = 336382,
  [SMALL_STATE(7091)] = 336398,
  [SMALL_STATE(7092)] = 336414,
  [SMALL_STATE(7093)] = 336438,
  [SMALL_STATE(7094)] = 336452,
  [SMALL_STATE(7095)] = 336468,
  [SMALL_STATE(7096)] = 336490,
  [SMALL_STATE(7097)] = 336514,
  [SMALL_STATE(7098)] = 336528,
  [SMALL_STATE(7099)] = 336542,
  [SMALL_STATE(7100)] = 336564,
  [SMALL_STATE(7101)] = 336578,
  [SMALL_STATE(7102)] = 336592,
  [SMALL_STATE(7103)] = 336606,
  [SMALL_STATE(7104)] = 336622,
  [SMALL_STATE(7105)] = 336642,
  [SMALL_STATE(7106)] = 336664,
  [SMALL_STATE(7107)] = 336680,
  [SMALL_STATE(7108)] = 336694,
  [SMALL_STATE(7109)] = 336714,
  [SMALL_STATE(7110)] = 336728,
  [SMALL_STATE(7111)] = 336742,
  [SMALL_STATE(7112)] = 336756,
  [SMALL_STATE(7113)] = 336776,
  [SMALL_STATE(7114)] = 336790,
  [SMALL_STATE(7115)] = 336804,
  [SMALL_STATE(7116)] = 336820,
  [SMALL_STATE(7117)] = 336834,
  [SMALL_STATE(7118)] = 336848,
  [SMALL_STATE(7119)] = 336862,
  [SMALL_STATE(7120)] = 336878,
  [SMALL_STATE(7121)] = 336902,
  [SMALL_STATE(7122)] = 336916,
  [SMALL_STATE(7123)] = 336934,
  [SMALL_STATE(7124)] = 336948,
  [SMALL_STATE(7125)] = 336964,
  [SMALL_STATE(7126)] = 336986,
  [SMALL_STATE(7127)] = 337000,
  [SMALL_STATE(7128)] = 337022,
  [SMALL_STATE(7129)] = 337044,
  [SMALL_STATE(7130)] = 337058,
  [SMALL_STATE(7131)] = 337082,
  [SMALL_STATE(7132)] = 337096,
  [SMALL_STATE(7133)] = 337110,
  [SMALL_STATE(7134)] = 337124,
  [SMALL_STATE(7135)] = 337138,
  [SMALL_STATE(7136)] = 337154,
  [SMALL_STATE(7137)] = 337178,
  [SMALL_STATE(7138)] = 337192,
  [SMALL_STATE(7139)] = 337214,
  [SMALL_STATE(7140)] = 337228,
  [SMALL_STATE(7141)] = 337242,
  [SMALL_STATE(7142)] = 337256,
  [SMALL_STATE(7143)] = 337270,
  [SMALL_STATE(7144)] = 337284,
  [SMALL_STATE(7145)] = 337304,
  [SMALL_STATE(7146)] = 337318,
  [SMALL_STATE(7147)] = 337342,
  [SMALL_STATE(7148)] = 337356,
  [SMALL_STATE(7149)] = 337370,
  [SMALL_STATE(7150)] = 337384,
  [SMALL_STATE(7151)] = 337398,
  [SMALL_STATE(7152)] = 337412,
  [SMALL_STATE(7153)] = 337428,
  [SMALL_STATE(7154)] = 337452,
  [SMALL_STATE(7155)] = 337466,
  [SMALL_STATE(7156)] = 337480,
  [SMALL_STATE(7157)] = 337494,
  [SMALL_STATE(7158)] = 337508,
  [SMALL_STATE(7159)] = 337522,
  [SMALL_STATE(7160)] = 337536,
  [SMALL_STATE(7161)] = 337550,
  [SMALL_STATE(7162)] = 337564,
  [SMALL_STATE(7163)] = 337578,
  [SMALL_STATE(7164)] = 337602,
  [SMALL_STATE(7165)] = 337618,
  [SMALL_STATE(7166)] = 337632,
  [SMALL_STATE(7167)] = 337646,
  [SMALL_STATE(7168)] = 337660,
  [SMALL_STATE(7169)] = 337684,
  [SMALL_STATE(7170)] = 337702,
  [SMALL_STATE(7171)] = 337716,
  [SMALL_STATE(7172)] = 337730,
  [SMALL_STATE(7173)] = 337754,
  [SMALL_STATE(7174)] = 337776,
  [SMALL_STATE(7175)] = 337790,
  [SMALL_STATE(7176)] = 337804,
  [SMALL_STATE(7177)] = 337818,
  [SMALL_STATE(7178)] = 337842,
  [SMALL_STATE(7179)] = 337856,
  [SMALL_STATE(7180)] = 337874,
  [SMALL_STATE(7181)] = 337888,
  [SMALL_STATE(7182)] = 337902,
  [SMALL_STATE(7183)] = 337916,
  [SMALL_STATE(7184)] = 337940,
  [SMALL_STATE(7185)] = 337954,
  [SMALL_STATE(7186)] = 337968,
  [SMALL_STATE(7187)] = 337992,
  [SMALL_STATE(7188)] = 338006,
  [SMALL_STATE(7189)] = 338020,
  [SMALL_STATE(7190)] = 338038,
  [SMALL_STATE(7191)] = 338056,
  [SMALL_STATE(7192)] = 338080,
  [SMALL_STATE(7193)] = 338094,
  [SMALL_STATE(7194)] = 338108,
  [SMALL_STATE(7195)] = 338132,
  [SMALL_STATE(7196)] = 338146,
  [SMALL_STATE(7197)] = 338164,
  [SMALL_STATE(7198)] = 338178,
  [SMALL_STATE(7199)] = 338192,
  [SMALL_STATE(7200)] = 338210,
  [SMALL_STATE(7201)] = 338228,
  [SMALL_STATE(7202)] = 338244,
  [SMALL_STATE(7203)] = 338258,
  [SMALL_STATE(7204)] = 338280,
  [SMALL_STATE(7205)] = 338294,
  [SMALL_STATE(7206)] = 338308,
  [SMALL_STATE(7207)] = 338322,
  [SMALL_STATE(7208)] = 338346,
  [SMALL_STATE(7209)] = 338360,
  [SMALL_STATE(7210)] = 338379,
  [SMALL_STATE(7211)] = 338396,
  [SMALL_STATE(7212)] = 338415,
  [SMALL_STATE(7213)] = 338432,
  [SMALL_STATE(7214)] = 338453,
  [SMALL_STATE(7215)] = 338472,
  [SMALL_STATE(7216)] = 338491,
  [SMALL_STATE(7217)] = 338512,
  [SMALL_STATE(7218)] = 338529,
  [SMALL_STATE(7219)] = 338546,
  [SMALL_STATE(7220)] = 338563,
  [SMALL_STATE(7221)] = 338584,
  [SMALL_STATE(7222)] = 338601,
  [SMALL_STATE(7223)] = 338622,
  [SMALL_STATE(7224)] = 338641,
  [SMALL_STATE(7225)] = 338660,
  [SMALL_STATE(7226)] = 338679,
  [SMALL_STATE(7227)] = 338696,
  [SMALL_STATE(7228)] = 338717,
  [SMALL_STATE(7229)] = 338738,
  [SMALL_STATE(7230)] = 338757,
  [SMALL_STATE(7231)] = 338776,
  [SMALL_STATE(7232)] = 338795,
  [SMALL_STATE(7233)] = 338814,
  [SMALL_STATE(7234)] = 338831,
  [SMALL_STATE(7235)] = 338852,
  [SMALL_STATE(7236)] = 338871,
  [SMALL_STATE(7237)] = 338892,
  [SMALL_STATE(7238)] = 338913,
  [SMALL_STATE(7239)] = 338934,
  [SMALL_STATE(7240)] = 338953,
  [SMALL_STATE(7241)] = 338972,
  [SMALL_STATE(7242)] = 338993,
  [SMALL_STATE(7243)] = 339014,
  [SMALL_STATE(7244)] = 339033,
  [SMALL_STATE(7245)] = 339050,
  [SMALL_STATE(7246)] = 339071,
  [SMALL_STATE(7247)] = 339090,
  [SMALL_STATE(7248)] = 339109,
  [SMALL_STATE(7249)] = 339130,
  [SMALL_STATE(7250)] = 339151,
  [SMALL_STATE(7251)] = 339168,
  [SMALL_STATE(7252)] = 339185,
  [SMALL_STATE(7253)] = 339204,
  [SMALL_STATE(7254)] = 339223,
  [SMALL_STATE(7255)] = 339242,
  [SMALL_STATE(7256)] = 339261,
  [SMALL_STATE(7257)] = 339282,
  [SMALL_STATE(7258)] = 339301,
  [SMALL_STATE(7259)] = 339318,
  [SMALL_STATE(7260)] = 339335,
  [SMALL_STATE(7261)] = 339356,
  [SMALL_STATE(7262)] = 339377,
  [SMALL_STATE(7263)] = 339396,
  [SMALL_STATE(7264)] = 339413,
  [SMALL_STATE(7265)] = 339434,
  [SMALL_STATE(7266)] = 339453,
  [SMALL_STATE(7267)] = 339474,
  [SMALL_STATE(7268)] = 339493,
  [SMALL_STATE(7269)] = 339512,
  [SMALL_STATE(7270)] = 339529,
  [SMALL_STATE(7271)] = 339550,
  [SMALL_STATE(7272)] = 339571,
  [SMALL_STATE(7273)] = 339592,
  [SMALL_STATE(7274)] = 339611,
  [SMALL_STATE(7275)] = 339632,
  [SMALL_STATE(7276)] = 339653,
  [SMALL_STATE(7277)] = 339672,
  [SMALL_STATE(7278)] = 339691,
  [SMALL_STATE(7279)] = 339710,
  [SMALL_STATE(7280)] = 339727,
  [SMALL_STATE(7281)] = 339748,
  [SMALL_STATE(7282)] = 339765,
  [SMALL_STATE(7283)] = 339786,
  [SMALL_STATE(7284)] = 339805,
  [SMALL_STATE(7285)] = 339824,
  [SMALL_STATE(7286)] = 339843,
  [SMALL_STATE(7287)] = 339862,
  [SMALL_STATE(7288)] = 339883,
  [SMALL_STATE(7289)] = 339904,
  [SMALL_STATE(7290)] = 339923,
  [SMALL_STATE(7291)] = 339944,
  [SMALL_STATE(7292)] = 339963,
  [SMALL_STATE(7293)] = 339984,
  [SMALL_STATE(7294)] = 340003,
  [SMALL_STATE(7295)] = 340022,
  [SMALL_STATE(7296)] = 340043,
  [SMALL_STATE(7297)] = 340064,
  [SMALL_STATE(7298)] = 340083,
  [SMALL_STATE(7299)] = 340102,
  [SMALL_STATE(7300)] = 340121,
  [SMALL_STATE(7301)] = 340142,
  [SMALL_STATE(7302)] = 340161,
  [SMALL_STATE(7303)] = 340182,
  [SMALL_STATE(7304)] = 340201,
  [SMALL_STATE(7305)] = 340220,
  [SMALL_STATE(7306)] = 340241,
  [SMALL_STATE(7307)] = 340262,
  [SMALL_STATE(7308)] = 340283,
  [SMALL_STATE(7309)] = 340302,
  [SMALL_STATE(7310)] = 340321,
  [SMALL_STATE(7311)] = 340340,
  [SMALL_STATE(7312)] = 340357,
  [SMALL_STATE(7313)] = 340378,
  [SMALL_STATE(7314)] = 340397,
  [SMALL_STATE(7315)] = 340416,
  [SMALL_STATE(7316)] = 340435,
  [SMALL_STATE(7317)] = 340456,
  [SMALL_STATE(7318)] = 340477,
  [SMALL_STATE(7319)] = 340498,
  [SMALL_STATE(7320)] = 340519,
  [SMALL_STATE(7321)] = 340538,
  [SMALL_STATE(7322)] = 340559,
  [SMALL_STATE(7323)] = 340580,
  [SMALL_STATE(7324)] = 340599,
  [SMALL_STATE(7325)] = 340616,
  [SMALL_STATE(7326)] = 340635,
  [SMALL_STATE(7327)] = 340654,
  [SMALL_STATE(7328)] = 340673,
  [SMALL_STATE(7329)] = 340692,
  [SMALL_STATE(7330)] = 340713,
  [SMALL_STATE(7331)] = 340732,
  [SMALL_STATE(7332)] = 340753,
  [SMALL_STATE(7333)] = 340774,
  [SMALL_STATE(7334)] = 340795,
  [SMALL_STATE(7335)] = 340814,
  [SMALL_STATE(7336)] = 340833,
  [SMALL_STATE(7337)] = 340854,
  [SMALL_STATE(7338)] = 340871,
  [SMALL_STATE(7339)] = 340892,
  [SMALL_STATE(7340)] = 340911,
  [SMALL_STATE(7341)] = 340930,
  [SMALL_STATE(7342)] = 340951,
  [SMALL_STATE(7343)] = 340970,
  [SMALL_STATE(7344)] = 340989,
  [SMALL_STATE(7345)] = 341010,
  [SMALL_STATE(7346)] = 341031,
  [SMALL_STATE(7347)] = 341050,
  [SMALL_STATE(7348)] = 341071,
  [SMALL_STATE(7349)] = 341092,
  [SMALL_STATE(7350)] = 341111,
  [SMALL_STATE(7351)] = 341130,
  [SMALL_STATE(7352)] = 341149,
  [SMALL_STATE(7353)] = 341170,
  [SMALL_STATE(7354)] = 341189,
  [SMALL_STATE(7355)] = 341208,
  [SMALL_STATE(7356)] = 341229,
  [SMALL_STATE(7357)] = 341248,
  [SMALL_STATE(7358)] = 341267,
  [SMALL_STATE(7359)] = 341288,
  [SMALL_STATE(7360)] = 341307,
  [SMALL_STATE(7361)] = 341326,
  [SMALL_STATE(7362)] = 341345,
  [SMALL_STATE(7363)] = 341366,
  [SMALL_STATE(7364)] = 341387,
  [SMALL_STATE(7365)] = 341406,
  [SMALL_STATE(7366)] = 341425,
  [SMALL_STATE(7367)] = 341444,
  [SMALL_STATE(7368)] = 341465,
  [SMALL_STATE(7369)] = 341484,
  [SMALL_STATE(7370)] = 341505,
  [SMALL_STATE(7371)] = 341526,
  [SMALL_STATE(7372)] = 341545,
  [SMALL_STATE(7373)] = 341566,
  [SMALL_STATE(7374)] = 341587,
  [SMALL_STATE(7375)] = 341604,
  [SMALL_STATE(7376)] = 341625,
  [SMALL_STATE(7377)] = 341644,
  [SMALL_STATE(7378)] = 341665,
  [SMALL_STATE(7379)] = 341684,
  [SMALL_STATE(7380)] = 341703,
  [SMALL_STATE(7381)] = 341724,
  [SMALL_STATE(7382)] = 341741,
  [SMALL_STATE(7383)] = 341762,
  [SMALL_STATE(7384)] = 341781,
  [SMALL_STATE(7385)] = 341799,
  [SMALL_STATE(7386)] = 341815,
  [SMALL_STATE(7387)] = 341833,
  [SMALL_STATE(7388)] = 341851,
  [SMALL_STATE(7389)] = 341869,
  [SMALL_STATE(7390)] = 341887,
  [SMALL_STATE(7391)] = 341905,
  [SMALL_STATE(7392)] = 341923,
  [SMALL_STATE(7393)] = 341941,
  [SMALL_STATE(7394)] = 341957,
  [SMALL_STATE(7395)] = 341975,
  [SMALL_STATE(7396)] = 341993,
  [SMALL_STATE(7397)] = 342011,
  [SMALL_STATE(7398)] = 342029,
  [SMALL_STATE(7399)] = 342047,
  [SMALL_STATE(7400)] = 342065,
  [SMALL_STATE(7401)] = 342083,
  [SMALL_STATE(7402)] = 342101,
  [SMALL_STATE(7403)] = 342117,
  [SMALL_STATE(7404)] = 342135,
  [SMALL_STATE(7405)] = 342153,
  [SMALL_STATE(7406)] = 342171,
  [SMALL_STATE(7407)] = 342189,
  [SMALL_STATE(7408)] = 342207,
  [SMALL_STATE(7409)] = 342225,
  [SMALL_STATE(7410)] = 342243,
  [SMALL_STATE(7411)] = 342261,
  [SMALL_STATE(7412)] = 342279,
  [SMALL_STATE(7413)] = 342297,
  [SMALL_STATE(7414)] = 342315,
  [SMALL_STATE(7415)] = 342333,
  [SMALL_STATE(7416)] = 342351,
  [SMALL_STATE(7417)] = 342363,
  [SMALL_STATE(7418)] = 342381,
  [SMALL_STATE(7419)] = 342397,
  [SMALL_STATE(7420)] = 342415,
  [SMALL_STATE(7421)] = 342433,
  [SMALL_STATE(7422)] = 342451,
  [SMALL_STATE(7423)] = 342469,
  [SMALL_STATE(7424)] = 342487,
  [SMALL_STATE(7425)] = 342505,
  [SMALL_STATE(7426)] = 342523,
  [SMALL_STATE(7427)] = 342541,
  [SMALL_STATE(7428)] = 342559,
  [SMALL_STATE(7429)] = 342577,
  [SMALL_STATE(7430)] = 342595,
  [SMALL_STATE(7431)] = 342613,
  [SMALL_STATE(7432)] = 342631,
  [SMALL_STATE(7433)] = 342649,
  [SMALL_STATE(7434)] = 342667,
  [SMALL_STATE(7435)] = 342685,
  [SMALL_STATE(7436)] = 342701,
  [SMALL_STATE(7437)] = 342719,
  [SMALL_STATE(7438)] = 342737,
  [SMALL_STATE(7439)] = 342755,
  [SMALL_STATE(7440)] = 342771,
  [SMALL_STATE(7441)] = 342789,
  [SMALL_STATE(7442)] = 342807,
  [SMALL_STATE(7443)] = 342823,
  [SMALL_STATE(7444)] = 342841,
  [SMALL_STATE(7445)] = 342859,
  [SMALL_STATE(7446)] = 342877,
  [SMALL_STATE(7447)] = 342893,
  [SMALL_STATE(7448)] = 342911,
  [SMALL_STATE(7449)] = 342929,
  [SMALL_STATE(7450)] = 342947,
  [SMALL_STATE(7451)] = 342965,
  [SMALL_STATE(7452)] = 342983,
  [SMALL_STATE(7453)] = 343001,
  [SMALL_STATE(7454)] = 343017,
  [SMALL_STATE(7455)] = 343035,
  [SMALL_STATE(7456)] = 343053,
  [SMALL_STATE(7457)] = 343071,
  [SMALL_STATE(7458)] = 343089,
  [SMALL_STATE(7459)] = 343107,
  [SMALL_STATE(7460)] = 343123,
  [SMALL_STATE(7461)] = 343141,
  [SMALL_STATE(7462)] = 343159,
  [SMALL_STATE(7463)] = 343177,
  [SMALL_STATE(7464)] = 343195,
  [SMALL_STATE(7465)] = 343213,
  [SMALL_STATE(7466)] = 343231,
  [SMALL_STATE(7467)] = 343247,
  [SMALL_STATE(7468)] = 343265,
  [SMALL_STATE(7469)] = 343283,
  [SMALL_STATE(7470)] = 343301,
  [SMALL_STATE(7471)] = 343319,
  [SMALL_STATE(7472)] = 343337,
  [SMALL_STATE(7473)] = 343355,
  [SMALL_STATE(7474)] = 343373,
  [SMALL_STATE(7475)] = 343391,
  [SMALL_STATE(7476)] = 343409,
  [SMALL_STATE(7477)] = 343427,
  [SMALL_STATE(7478)] = 343445,
  [SMALL_STATE(7479)] = 343461,
  [SMALL_STATE(7480)] = 343477,
  [SMALL_STATE(7481)] = 343495,
  [SMALL_STATE(7482)] = 343511,
  [SMALL_STATE(7483)] = 343527,
  [SMALL_STATE(7484)] = 343545,
  [SMALL_STATE(7485)] = 343561,
  [SMALL_STATE(7486)] = 343579,
  [SMALL_STATE(7487)] = 343597,
  [SMALL_STATE(7488)] = 343615,
  [SMALL_STATE(7489)] = 343631,
  [SMALL_STATE(7490)] = 343649,
  [SMALL_STATE(7491)] = 343667,
  [SMALL_STATE(7492)] = 343685,
  [SMALL_STATE(7493)] = 343703,
  [SMALL_STATE(7494)] = 343719,
  [SMALL_STATE(7495)] = 343737,
  [SMALL_STATE(7496)] = 343755,
  [SMALL_STATE(7497)] = 343773,
  [SMALL_STATE(7498)] = 343791,
  [SMALL_STATE(7499)] = 343809,
  [SMALL_STATE(7500)] = 343825,
  [SMALL_STATE(7501)] = 343843,
  [SMALL_STATE(7502)] = 343861,
  [SMALL_STATE(7503)] = 343879,
  [SMALL_STATE(7504)] = 343897,
  [SMALL_STATE(7505)] = 343915,
  [SMALL_STATE(7506)] = 343933,
  [SMALL_STATE(7507)] = 343951,
  [SMALL_STATE(7508)] = 343969,
  [SMALL_STATE(7509)] = 343987,
  [SMALL_STATE(7510)] = 344005,
  [SMALL_STATE(7511)] = 344017,
  [SMALL_STATE(7512)] = 344035,
  [SMALL_STATE(7513)] = 344051,
  [SMALL_STATE(7514)] = 344069,
  [SMALL_STATE(7515)] = 344087,
  [SMALL_STATE(7516)] = 344105,
  [SMALL_STATE(7517)] = 344123,
  [SMALL_STATE(7518)] = 344139,
  [SMALL_STATE(7519)] = 344157,
  [SMALL_STATE(7520)] = 344173,
  [SMALL_STATE(7521)] = 344189,
  [SMALL_STATE(7522)] = 344207,
  [SMALL_STATE(7523)] = 344225,
  [SMALL_STATE(7524)] = 344243,
  [SMALL_STATE(7525)] = 344261,
  [SMALL_STATE(7526)] = 344279,
  [SMALL_STATE(7527)] = 344297,
  [SMALL_STATE(7528)] = 344315,
  [SMALL_STATE(7529)] = 344333,
  [SMALL_STATE(7530)] = 344351,
  [SMALL_STATE(7531)] = 344369,
  [SMALL_STATE(7532)] = 344387,
  [SMALL_STATE(7533)] = 344405,
  [SMALL_STATE(7534)] = 344421,
  [SMALL_STATE(7535)] = 344439,
  [SMALL_STATE(7536)] = 344455,
  [SMALL_STATE(7537)] = 344471,
  [SMALL_STATE(7538)] = 344489,
  [SMALL_STATE(7539)] = 344507,
  [SMALL_STATE(7540)] = 344523,
  [SMALL_STATE(7541)] = 344541,
  [SMALL_STATE(7542)] = 344559,
  [SMALL_STATE(7543)] = 344577,
  [SMALL_STATE(7544)] = 344595,
  [SMALL_STATE(7545)] = 344613,
  [SMALL_STATE(7546)] = 344631,
  [SMALL_STATE(7547)] = 344647,
  [SMALL_STATE(7548)] = 344665,
  [SMALL_STATE(7549)] = 344683,
  [SMALL_STATE(7550)] = 344701,
  [SMALL_STATE(7551)] = 344719,
  [SMALL_STATE(7552)] = 344737,
  [SMALL_STATE(7553)] = 344755,
  [SMALL_STATE(7554)] = 344773,
  [SMALL_STATE(7555)] = 344791,
  [SMALL_STATE(7556)] = 344809,
  [SMALL_STATE(7557)] = 344827,
  [SMALL_STATE(7558)] = 344845,
  [SMALL_STATE(7559)] = 344863,
  [SMALL_STATE(7560)] = 344881,
  [SMALL_STATE(7561)] = 344899,
  [SMALL_STATE(7562)] = 344917,
  [SMALL_STATE(7563)] = 344929,
  [SMALL_STATE(7564)] = 344947,
  [SMALL_STATE(7565)] = 344963,
  [SMALL_STATE(7566)] = 344979,
  [SMALL_STATE(7567)] = 344997,
  [SMALL_STATE(7568)] = 345015,
  [SMALL_STATE(7569)] = 345033,
  [SMALL_STATE(7570)] = 345051,
  [SMALL_STATE(7571)] = 345067,
  [SMALL_STATE(7572)] = 345085,
  [SMALL_STATE(7573)] = 345103,
  [SMALL_STATE(7574)] = 345119,
  [SMALL_STATE(7575)] = 345135,
  [SMALL_STATE(7576)] = 345151,
  [SMALL_STATE(7577)] = 345169,
  [SMALL_STATE(7578)] = 345185,
  [SMALL_STATE(7579)] = 345203,
  [SMALL_STATE(7580)] = 345221,
  [SMALL_STATE(7581)] = 345239,
  [SMALL_STATE(7582)] = 345257,
  [SMALL_STATE(7583)] = 345275,
  [SMALL_STATE(7584)] = 345293,
  [SMALL_STATE(7585)] = 345311,
  [SMALL_STATE(7586)] = 345329,
  [SMALL_STATE(7587)] = 345347,
  [SMALL_STATE(7588)] = 345365,
  [SMALL_STATE(7589)] = 345381,
  [SMALL_STATE(7590)] = 345399,
  [SMALL_STATE(7591)] = 345415,
  [SMALL_STATE(7592)] = 345433,
  [SMALL_STATE(7593)] = 345451,
  [SMALL_STATE(7594)] = 345467,
  [SMALL_STATE(7595)] = 345482,
  [SMALL_STATE(7596)] = 345497,
  [SMALL_STATE(7597)] = 345512,
  [SMALL_STATE(7598)] = 345527,
  [SMALL_STATE(7599)] = 345542,
  [SMALL_STATE(7600)] = 345557,
  [SMALL_STATE(7601)] = 345572,
  [SMALL_STATE(7602)] = 345587,
  [SMALL_STATE(7603)] = 345602,
  [SMALL_STATE(7604)] = 345617,
  [SMALL_STATE(7605)] = 345632,
  [SMALL_STATE(7606)] = 345647,
  [SMALL_STATE(7607)] = 345662,
  [SMALL_STATE(7608)] = 345677,
  [SMALL_STATE(7609)] = 345692,
  [SMALL_STATE(7610)] = 345707,
  [SMALL_STATE(7611)] = 345722,
  [SMALL_STATE(7612)] = 345737,
  [SMALL_STATE(7613)] = 345752,
  [SMALL_STATE(7614)] = 345767,
  [SMALL_STATE(7615)] = 345782,
  [SMALL_STATE(7616)] = 345797,
  [SMALL_STATE(7617)] = 345812,
  [SMALL_STATE(7618)] = 345827,
  [SMALL_STATE(7619)] = 345842,
  [SMALL_STATE(7620)] = 345857,
  [SMALL_STATE(7621)] = 345872,
  [SMALL_STATE(7622)] = 345887,
  [SMALL_STATE(7623)] = 345902,
  [SMALL_STATE(7624)] = 345917,
  [SMALL_STATE(7625)] = 345932,
  [SMALL_STATE(7626)] = 345947,
  [SMALL_STATE(7627)] = 345962,
  [SMALL_STATE(7628)] = 345977,
  [SMALL_STATE(7629)] = 345992,
  [SMALL_STATE(7630)] = 346007,
  [SMALL_STATE(7631)] = 346022,
  [SMALL_STATE(7632)] = 346037,
  [SMALL_STATE(7633)] = 346052,
  [SMALL_STATE(7634)] = 346067,
  [SMALL_STATE(7635)] = 346082,
  [SMALL_STATE(7636)] = 346097,
  [SMALL_STATE(7637)] = 346112,
  [SMALL_STATE(7638)] = 346127,
  [SMALL_STATE(7639)] = 346142,
  [SMALL_STATE(7640)] = 346157,
  [SMALL_STATE(7641)] = 346172,
  [SMALL_STATE(7642)] = 346187,
  [SMALL_STATE(7643)] = 346202,
  [SMALL_STATE(7644)] = 346217,
  [SMALL_STATE(7645)] = 346232,
  [SMALL_STATE(7646)] = 346247,
  [SMALL_STATE(7647)] = 346262,
  [SMALL_STATE(7648)] = 346277,
  [SMALL_STATE(7649)] = 346292,
  [SMALL_STATE(7650)] = 346307,
  [SMALL_STATE(7651)] = 346320,
  [SMALL_STATE(7652)] = 346335,
  [SMALL_STATE(7653)] = 346352,
  [SMALL_STATE(7654)] = 346367,
  [SMALL_STATE(7655)] = 346382,
  [SMALL_STATE(7656)] = 346397,
  [SMALL_STATE(7657)] = 346412,
  [SMALL_STATE(7658)] = 346427,
  [SMALL_STATE(7659)] = 346442,
  [SMALL_STATE(7660)] = 346457,
  [SMALL_STATE(7661)] = 346472,
  [SMALL_STATE(7662)] = 346487,
  [SMALL_STATE(7663)] = 346502,
  [SMALL_STATE(7664)] = 346519,
  [SMALL_STATE(7665)] = 346534,
  [SMALL_STATE(7666)] = 346549,
  [SMALL_STATE(7667)] = 346564,
  [SMALL_STATE(7668)] = 346579,
  [SMALL_STATE(7669)] = 346594,
  [SMALL_STATE(7670)] = 346609,
  [SMALL_STATE(7671)] = 346624,
  [SMALL_STATE(7672)] = 346639,
  [SMALL_STATE(7673)] = 346654,
  [SMALL_STATE(7674)] = 346671,
  [SMALL_STATE(7675)] = 346686,
  [SMALL_STATE(7676)] = 346701,
  [SMALL_STATE(7677)] = 346716,
  [SMALL_STATE(7678)] = 346731,
  [SMALL_STATE(7679)] = 346746,
  [SMALL_STATE(7680)] = 346761,
  [SMALL_STATE(7681)] = 346776,
  [SMALL_STATE(7682)] = 346791,
  [SMALL_STATE(7683)] = 346806,
  [SMALL_STATE(7684)] = 346821,
  [SMALL_STATE(7685)] = 346836,
  [SMALL_STATE(7686)] = 346851,
  [SMALL_STATE(7687)] = 346866,
  [SMALL_STATE(7688)] = 346881,
  [SMALL_STATE(7689)] = 346896,
  [SMALL_STATE(7690)] = 346911,
  [SMALL_STATE(7691)] = 346926,
  [SMALL_STATE(7692)] = 346941,
  [SMALL_STATE(7693)] = 346956,
  [SMALL_STATE(7694)] = 346971,
  [SMALL_STATE(7695)] = 346986,
  [SMALL_STATE(7696)] = 347001,
  [SMALL_STATE(7697)] = 347016,
  [SMALL_STATE(7698)] = 347031,
  [SMALL_STATE(7699)] = 347046,
  [SMALL_STATE(7700)] = 347061,
  [SMALL_STATE(7701)] = 347076,
  [SMALL_STATE(7702)] = 347093,
  [SMALL_STATE(7703)] = 347108,
  [SMALL_STATE(7704)] = 347123,
  [SMALL_STATE(7705)] = 347138,
  [SMALL_STATE(7706)] = 347153,
  [SMALL_STATE(7707)] = 347168,
  [SMALL_STATE(7708)] = 347183,
  [SMALL_STATE(7709)] = 347198,
  [SMALL_STATE(7710)] = 347213,
  [SMALL_STATE(7711)] = 347228,
  [SMALL_STATE(7712)] = 347243,
  [SMALL_STATE(7713)] = 347258,
  [SMALL_STATE(7714)] = 347273,
  [SMALL_STATE(7715)] = 347284,
  [SMALL_STATE(7716)] = 347299,
  [SMALL_STATE(7717)] = 347314,
  [SMALL_STATE(7718)] = 347329,
  [SMALL_STATE(7719)] = 347344,
  [SMALL_STATE(7720)] = 347361,
  [SMALL_STATE(7721)] = 347376,
  [SMALL_STATE(7722)] = 347391,
  [SMALL_STATE(7723)] = 347406,
  [SMALL_STATE(7724)] = 347421,
  [SMALL_STATE(7725)] = 347436,
  [SMALL_STATE(7726)] = 347447,
  [SMALL_STATE(7727)] = 347462,
  [SMALL_STATE(7728)] = 347477,
  [SMALL_STATE(7729)] = 347492,
  [SMALL_STATE(7730)] = 347507,
  [SMALL_STATE(7731)] = 347522,
  [SMALL_STATE(7732)] = 347539,
  [SMALL_STATE(7733)] = 347556,
  [SMALL_STATE(7734)] = 347571,
  [SMALL_STATE(7735)] = 347586,
  [SMALL_STATE(7736)] = 347601,
  [SMALL_STATE(7737)] = 347618,
  [SMALL_STATE(7738)] = 347633,
  [SMALL_STATE(7739)] = 347648,
  [SMALL_STATE(7740)] = 347663,
  [SMALL_STATE(7741)] = 347678,
  [SMALL_STATE(7742)] = 347693,
  [SMALL_STATE(7743)] = 347708,
  [SMALL_STATE(7744)] = 347723,
  [SMALL_STATE(7745)] = 347738,
  [SMALL_STATE(7746)] = 347753,
  [SMALL_STATE(7747)] = 347768,
  [SMALL_STATE(7748)] = 347783,
  [SMALL_STATE(7749)] = 347798,
  [SMALL_STATE(7750)] = 347813,
  [SMALL_STATE(7751)] = 347828,
  [SMALL_STATE(7752)] = 347843,
  [SMALL_STATE(7753)] = 347858,
  [SMALL_STATE(7754)] = 347873,
  [SMALL_STATE(7755)] = 347888,
  [SMALL_STATE(7756)] = 347899,
  [SMALL_STATE(7757)] = 347914,
  [SMALL_STATE(7758)] = 347929,
  [SMALL_STATE(7759)] = 347944,
  [SMALL_STATE(7760)] = 347959,
  [SMALL_STATE(7761)] = 347974,
  [SMALL_STATE(7762)] = 347989,
  [SMALL_STATE(7763)] = 348004,
  [SMALL_STATE(7764)] = 348019,
  [SMALL_STATE(7765)] = 348034,
  [SMALL_STATE(7766)] = 348049,
  [SMALL_STATE(7767)] = 348064,
  [SMALL_STATE(7768)] = 348079,
  [SMALL_STATE(7769)] = 348094,
  [SMALL_STATE(7770)] = 348109,
  [SMALL_STATE(7771)] = 348126,
  [SMALL_STATE(7772)] = 348141,
  [SMALL_STATE(7773)] = 348156,
  [SMALL_STATE(7774)] = 348171,
  [SMALL_STATE(7775)] = 348186,
  [SMALL_STATE(7776)] = 348201,
  [SMALL_STATE(7777)] = 348216,
  [SMALL_STATE(7778)] = 348231,
  [SMALL_STATE(7779)] = 348246,
  [SMALL_STATE(7780)] = 348261,
  [SMALL_STATE(7781)] = 348276,
  [SMALL_STATE(7782)] = 348291,
  [SMALL_STATE(7783)] = 348306,
  [SMALL_STATE(7784)] = 348321,
  [SMALL_STATE(7785)] = 348336,
  [SMALL_STATE(7786)] = 348351,
  [SMALL_STATE(7787)] = 348366,
  [SMALL_STATE(7788)] = 348377,
  [SMALL_STATE(7789)] = 348392,
  [SMALL_STATE(7790)] = 348407,
  [SMALL_STATE(7791)] = 348422,
  [SMALL_STATE(7792)] = 348437,
  [SMALL_STATE(7793)] = 348452,
  [SMALL_STATE(7794)] = 348467,
  [SMALL_STATE(7795)] = 348482,
  [SMALL_STATE(7796)] = 348497,
  [SMALL_STATE(7797)] = 348512,
  [SMALL_STATE(7798)] = 348527,
  [SMALL_STATE(7799)] = 348542,
  [SMALL_STATE(7800)] = 348557,
  [SMALL_STATE(7801)] = 348572,
  [SMALL_STATE(7802)] = 348587,
  [SMALL_STATE(7803)] = 348602,
  [SMALL_STATE(7804)] = 348617,
  [SMALL_STATE(7805)] = 348632,
  [SMALL_STATE(7806)] = 348647,
  [SMALL_STATE(7807)] = 348662,
  [SMALL_STATE(7808)] = 348677,
  [SMALL_STATE(7809)] = 348692,
  [SMALL_STATE(7810)] = 348707,
  [SMALL_STATE(7811)] = 348722,
  [SMALL_STATE(7812)] = 348737,
  [SMALL_STATE(7813)] = 348752,
  [SMALL_STATE(7814)] = 348767,
  [SMALL_STATE(7815)] = 348782,
  [SMALL_STATE(7816)] = 348797,
  [SMALL_STATE(7817)] = 348812,
  [SMALL_STATE(7818)] = 348827,
  [SMALL_STATE(7819)] = 348842,
  [SMALL_STATE(7820)] = 348857,
  [SMALL_STATE(7821)] = 348872,
  [SMALL_STATE(7822)] = 348887,
  [SMALL_STATE(7823)] = 348902,
  [SMALL_STATE(7824)] = 348917,
  [SMALL_STATE(7825)] = 348932,
  [SMALL_STATE(7826)] = 348945,
  [SMALL_STATE(7827)] = 348960,
  [SMALL_STATE(7828)] = 348975,
  [SMALL_STATE(7829)] = 348990,
  [SMALL_STATE(7830)] = 349005,
  [SMALL_STATE(7831)] = 349020,
  [SMALL_STATE(7832)] = 349035,
  [SMALL_STATE(7833)] = 349050,
  [SMALL_STATE(7834)] = 349065,
  [SMALL_STATE(7835)] = 349080,
  [SMALL_STATE(7836)] = 349095,
  [SMALL_STATE(7837)] = 349110,
  [SMALL_STATE(7838)] = 349125,
  [SMALL_STATE(7839)] = 349140,
  [SMALL_STATE(7840)] = 349155,
  [SMALL_STATE(7841)] = 349170,
  [SMALL_STATE(7842)] = 349185,
  [SMALL_STATE(7843)] = 349200,
  [SMALL_STATE(7844)] = 349215,
  [SMALL_STATE(7845)] = 349230,
  [SMALL_STATE(7846)] = 349245,
  [SMALL_STATE(7847)] = 349260,
  [SMALL_STATE(7848)] = 349275,
  [SMALL_STATE(7849)] = 349290,
  [SMALL_STATE(7850)] = 349305,
  [SMALL_STATE(7851)] = 349320,
  [SMALL_STATE(7852)] = 349335,
  [SMALL_STATE(7853)] = 349350,
  [SMALL_STATE(7854)] = 349365,
  [SMALL_STATE(7855)] = 349380,
  [SMALL_STATE(7856)] = 349395,
  [SMALL_STATE(7857)] = 349410,
  [SMALL_STATE(7858)] = 349425,
  [SMALL_STATE(7859)] = 349440,
  [SMALL_STATE(7860)] = 349455,
  [SMALL_STATE(7861)] = 349470,
  [SMALL_STATE(7862)] = 349485,
  [SMALL_STATE(7863)] = 349500,
  [SMALL_STATE(7864)] = 349515,
  [SMALL_STATE(7865)] = 349530,
  [SMALL_STATE(7866)] = 349545,
  [SMALL_STATE(7867)] = 349560,
  [SMALL_STATE(7868)] = 349575,
  [SMALL_STATE(7869)] = 349590,
  [SMALL_STATE(7870)] = 349605,
  [SMALL_STATE(7871)] = 349620,
  [SMALL_STATE(7872)] = 349635,
  [SMALL_STATE(7873)] = 349650,
  [SMALL_STATE(7874)] = 349665,
  [SMALL_STATE(7875)] = 349680,
  [SMALL_STATE(7876)] = 349695,
  [SMALL_STATE(7877)] = 349710,
  [SMALL_STATE(7878)] = 349725,
  [SMALL_STATE(7879)] = 349740,
  [SMALL_STATE(7880)] = 349755,
  [SMALL_STATE(7881)] = 349770,
  [SMALL_STATE(7882)] = 349785,
  [SMALL_STATE(7883)] = 349800,
  [SMALL_STATE(7884)] = 349815,
  [SMALL_STATE(7885)] = 349830,
  [SMALL_STATE(7886)] = 349845,
  [SMALL_STATE(7887)] = 349860,
  [SMALL_STATE(7888)] = 349875,
  [SMALL_STATE(7889)] = 349890,
  [SMALL_STATE(7890)] = 349905,
  [SMALL_STATE(7891)] = 349920,
  [SMALL_STATE(7892)] = 349935,
  [SMALL_STATE(7893)] = 349948,
  [SMALL_STATE(7894)] = 349963,
  [SMALL_STATE(7895)] = 349978,
  [SMALL_STATE(7896)] = 349993,
  [SMALL_STATE(7897)] = 350008,
  [SMALL_STATE(7898)] = 350023,
  [SMALL_STATE(7899)] = 350038,
  [SMALL_STATE(7900)] = 350053,
  [SMALL_STATE(7901)] = 350068,
  [SMALL_STATE(7902)] = 350083,
  [SMALL_STATE(7903)] = 350098,
  [SMALL_STATE(7904)] = 350113,
  [SMALL_STATE(7905)] = 350128,
  [SMALL_STATE(7906)] = 350143,
  [SMALL_STATE(7907)] = 350158,
  [SMALL_STATE(7908)] = 350173,
  [SMALL_STATE(7909)] = 350188,
  [SMALL_STATE(7910)] = 350203,
  [SMALL_STATE(7911)] = 350218,
  [SMALL_STATE(7912)] = 350233,
  [SMALL_STATE(7913)] = 350248,
  [SMALL_STATE(7914)] = 350263,
  [SMALL_STATE(7915)] = 350278,
  [SMALL_STATE(7916)] = 350293,
  [SMALL_STATE(7917)] = 350308,
  [SMALL_STATE(7918)] = 350321,
  [SMALL_STATE(7919)] = 350336,
  [SMALL_STATE(7920)] = 350351,
  [SMALL_STATE(7921)] = 350366,
  [SMALL_STATE(7922)] = 350381,
  [SMALL_STATE(7923)] = 350396,
  [SMALL_STATE(7924)] = 350411,
  [SMALL_STATE(7925)] = 350426,
  [SMALL_STATE(7926)] = 350443,
  [SMALL_STATE(7927)] = 350458,
  [SMALL_STATE(7928)] = 350473,
  [SMALL_STATE(7929)] = 350488,
  [SMALL_STATE(7930)] = 350505,
  [SMALL_STATE(7931)] = 350520,
  [SMALL_STATE(7932)] = 350535,
  [SMALL_STATE(7933)] = 350550,
  [SMALL_STATE(7934)] = 350565,
  [SMALL_STATE(7935)] = 350582,
  [SMALL_STATE(7936)] = 350597,
  [SMALL_STATE(7937)] = 350612,
  [SMALL_STATE(7938)] = 350627,
  [SMALL_STATE(7939)] = 350642,
  [SMALL_STATE(7940)] = 350657,
  [SMALL_STATE(7941)] = 350674,
  [SMALL_STATE(7942)] = 350689,
  [SMALL_STATE(7943)] = 350704,
  [SMALL_STATE(7944)] = 350719,
  [SMALL_STATE(7945)] = 350734,
  [SMALL_STATE(7946)] = 350749,
  [SMALL_STATE(7947)] = 350764,
  [SMALL_STATE(7948)] = 350779,
  [SMALL_STATE(7949)] = 350790,
  [SMALL_STATE(7950)] = 350805,
  [SMALL_STATE(7951)] = 350820,
  [SMALL_STATE(7952)] = 350835,
  [SMALL_STATE(7953)] = 350850,
  [SMALL_STATE(7954)] = 350865,
  [SMALL_STATE(7955)] = 350880,
  [SMALL_STATE(7956)] = 350895,
  [SMALL_STATE(7957)] = 350910,
  [SMALL_STATE(7958)] = 350925,
  [SMALL_STATE(7959)] = 350940,
  [SMALL_STATE(7960)] = 350955,
  [SMALL_STATE(7961)] = 350970,
  [SMALL_STATE(7962)] = 350987,
  [SMALL_STATE(7963)] = 351002,
  [SMALL_STATE(7964)] = 351017,
  [SMALL_STATE(7965)] = 351032,
  [SMALL_STATE(7966)] = 351047,
  [SMALL_STATE(7967)] = 351062,
  [SMALL_STATE(7968)] = 351077,
  [SMALL_STATE(7969)] = 351092,
  [SMALL_STATE(7970)] = 351107,
  [SMALL_STATE(7971)] = 351122,
  [SMALL_STATE(7972)] = 351137,
  [SMALL_STATE(7973)] = 351152,
  [SMALL_STATE(7974)] = 351169,
  [SMALL_STATE(7975)] = 351184,
  [SMALL_STATE(7976)] = 351199,
  [SMALL_STATE(7977)] = 351214,
  [SMALL_STATE(7978)] = 351229,
  [SMALL_STATE(7979)] = 351244,
  [SMALL_STATE(7980)] = 351259,
  [SMALL_STATE(7981)] = 351270,
  [SMALL_STATE(7982)] = 351285,
  [SMALL_STATE(7983)] = 351302,
  [SMALL_STATE(7984)] = 351317,
  [SMALL_STATE(7985)] = 351332,
  [SMALL_STATE(7986)] = 351347,
  [SMALL_STATE(7987)] = 351362,
  [SMALL_STATE(7988)] = 351377,
  [SMALL_STATE(7989)] = 351392,
  [SMALL_STATE(7990)] = 351407,
  [SMALL_STATE(7991)] = 351422,
  [SMALL_STATE(7992)] = 351437,
  [SMALL_STATE(7993)] = 351452,
  [SMALL_STATE(7994)] = 351467,
  [SMALL_STATE(7995)] = 351482,
  [SMALL_STATE(7996)] = 351497,
  [SMALL_STATE(7997)] = 351512,
  [SMALL_STATE(7998)] = 351527,
  [SMALL_STATE(7999)] = 351542,
  [SMALL_STATE(8000)] = 351557,
  [SMALL_STATE(8001)] = 351572,
  [SMALL_STATE(8002)] = 351587,
  [SMALL_STATE(8003)] = 351600,
  [SMALL_STATE(8004)] = 351615,
  [SMALL_STATE(8005)] = 351630,
  [SMALL_STATE(8006)] = 351645,
  [SMALL_STATE(8007)] = 351660,
  [SMALL_STATE(8008)] = 351677,
  [SMALL_STATE(8009)] = 351692,
  [SMALL_STATE(8010)] = 351707,
  [SMALL_STATE(8011)] = 351722,
  [SMALL_STATE(8012)] = 351737,
  [SMALL_STATE(8013)] = 351752,
  [SMALL_STATE(8014)] = 351767,
  [SMALL_STATE(8015)] = 351782,
  [SMALL_STATE(8016)] = 351797,
  [SMALL_STATE(8017)] = 351812,
  [SMALL_STATE(8018)] = 351827,
  [SMALL_STATE(8019)] = 351842,
  [SMALL_STATE(8020)] = 351857,
  [SMALL_STATE(8021)] = 351868,
  [SMALL_STATE(8022)] = 351883,
  [SMALL_STATE(8023)] = 351898,
  [SMALL_STATE(8024)] = 351913,
  [SMALL_STATE(8025)] = 351928,
  [SMALL_STATE(8026)] = 351943,
  [SMALL_STATE(8027)] = 351958,
  [SMALL_STATE(8028)] = 351973,
  [SMALL_STATE(8029)] = 351988,
  [SMALL_STATE(8030)] = 352003,
  [SMALL_STATE(8031)] = 352018,
  [SMALL_STATE(8032)] = 352033,
  [SMALL_STATE(8033)] = 352048,
  [SMALL_STATE(8034)] = 352063,
  [SMALL_STATE(8035)] = 352078,
  [SMALL_STATE(8036)] = 352093,
  [SMALL_STATE(8037)] = 352108,
  [SMALL_STATE(8038)] = 352123,
  [SMALL_STATE(8039)] = 352138,
  [SMALL_STATE(8040)] = 352149,
  [SMALL_STATE(8041)] = 352164,
  [SMALL_STATE(8042)] = 352179,
  [SMALL_STATE(8043)] = 352194,
  [SMALL_STATE(8044)] = 352209,
  [SMALL_STATE(8045)] = 352224,
  [SMALL_STATE(8046)] = 352239,
  [SMALL_STATE(8047)] = 352254,
  [SMALL_STATE(8048)] = 352269,
  [SMALL_STATE(8049)] = 352282,
  [SMALL_STATE(8050)] = 352297,
  [SMALL_STATE(8051)] = 352312,
  [SMALL_STATE(8052)] = 352327,
  [SMALL_STATE(8053)] = 352342,
  [SMALL_STATE(8054)] = 352357,
  [SMALL_STATE(8055)] = 352372,
  [SMALL_STATE(8056)] = 352387,
  [SMALL_STATE(8057)] = 352400,
  [SMALL_STATE(8058)] = 352415,
  [SMALL_STATE(8059)] = 352430,
  [SMALL_STATE(8060)] = 352445,
  [SMALL_STATE(8061)] = 352460,
  [SMALL_STATE(8062)] = 352475,
  [SMALL_STATE(8063)] = 352490,
  [SMALL_STATE(8064)] = 352505,
  [SMALL_STATE(8065)] = 352520,
  [SMALL_STATE(8066)] = 352535,
  [SMALL_STATE(8067)] = 352550,
  [SMALL_STATE(8068)] = 352565,
  [SMALL_STATE(8069)] = 352580,
  [SMALL_STATE(8070)] = 352595,
  [SMALL_STATE(8071)] = 352610,
  [SMALL_STATE(8072)] = 352625,
  [SMALL_STATE(8073)] = 352640,
  [SMALL_STATE(8074)] = 352655,
  [SMALL_STATE(8075)] = 352670,
  [SMALL_STATE(8076)] = 352685,
  [SMALL_STATE(8077)] = 352700,
  [SMALL_STATE(8078)] = 352715,
  [SMALL_STATE(8079)] = 352730,
  [SMALL_STATE(8080)] = 352745,
  [SMALL_STATE(8081)] = 352760,
  [SMALL_STATE(8082)] = 352775,
  [SMALL_STATE(8083)] = 352790,
  [SMALL_STATE(8084)] = 352805,
  [SMALL_STATE(8085)] = 352820,
  [SMALL_STATE(8086)] = 352835,
  [SMALL_STATE(8087)] = 352850,
  [SMALL_STATE(8088)] = 352865,
  [SMALL_STATE(8089)] = 352880,
  [SMALL_STATE(8090)] = 352895,
  [SMALL_STATE(8091)] = 352910,
  [SMALL_STATE(8092)] = 352925,
  [SMALL_STATE(8093)] = 352940,
  [SMALL_STATE(8094)] = 352955,
  [SMALL_STATE(8095)] = 352970,
  [SMALL_STATE(8096)] = 352985,
  [SMALL_STATE(8097)] = 353000,
  [SMALL_STATE(8098)] = 353017,
  [SMALL_STATE(8099)] = 353032,
  [SMALL_STATE(8100)] = 353047,
  [SMALL_STATE(8101)] = 353062,
  [SMALL_STATE(8102)] = 353077,
  [SMALL_STATE(8103)] = 353092,
  [SMALL_STATE(8104)] = 353107,
  [SMALL_STATE(8105)] = 353122,
  [SMALL_STATE(8106)] = 353137,
  [SMALL_STATE(8107)] = 353152,
  [SMALL_STATE(8108)] = 353167,
  [SMALL_STATE(8109)] = 353182,
  [SMALL_STATE(8110)] = 353197,
  [SMALL_STATE(8111)] = 353212,
  [SMALL_STATE(8112)] = 353227,
  [SMALL_STATE(8113)] = 353242,
  [SMALL_STATE(8114)] = 353257,
  [SMALL_STATE(8115)] = 353272,
  [SMALL_STATE(8116)] = 353287,
  [SMALL_STATE(8117)] = 353302,
  [SMALL_STATE(8118)] = 353317,
  [SMALL_STATE(8119)] = 353332,
  [SMALL_STATE(8120)] = 353347,
  [SMALL_STATE(8121)] = 353362,
  [SMALL_STATE(8122)] = 353377,
  [SMALL_STATE(8123)] = 353392,
  [SMALL_STATE(8124)] = 353407,
  [SMALL_STATE(8125)] = 353422,
  [SMALL_STATE(8126)] = 353437,
  [SMALL_STATE(8127)] = 353450,
  [SMALL_STATE(8128)] = 353465,
  [SMALL_STATE(8129)] = 353478,
  [SMALL_STATE(8130)] = 353493,
  [SMALL_STATE(8131)] = 353508,
  [SMALL_STATE(8132)] = 353523,
  [SMALL_STATE(8133)] = 353538,
  [SMALL_STATE(8134)] = 353553,
  [SMALL_STATE(8135)] = 353564,
  [SMALL_STATE(8136)] = 353579,
  [SMALL_STATE(8137)] = 353596,
  [SMALL_STATE(8138)] = 353611,
  [SMALL_STATE(8139)] = 353626,
  [SMALL_STATE(8140)] = 353641,
  [SMALL_STATE(8141)] = 353656,
  [SMALL_STATE(8142)] = 353671,
  [SMALL_STATE(8143)] = 353684,
  [SMALL_STATE(8144)] = 353699,
  [SMALL_STATE(8145)] = 353714,
  [SMALL_STATE(8146)] = 353729,
  [SMALL_STATE(8147)] = 353744,
  [SMALL_STATE(8148)] = 353759,
  [SMALL_STATE(8149)] = 353774,
  [SMALL_STATE(8150)] = 353789,
  [SMALL_STATE(8151)] = 353804,
  [SMALL_STATE(8152)] = 353819,
  [SMALL_STATE(8153)] = 353834,
  [SMALL_STATE(8154)] = 353849,
  [SMALL_STATE(8155)] = 353864,
  [SMALL_STATE(8156)] = 353879,
  [SMALL_STATE(8157)] = 353894,
  [SMALL_STATE(8158)] = 353909,
  [SMALL_STATE(8159)] = 353924,
  [SMALL_STATE(8160)] = 353939,
  [SMALL_STATE(8161)] = 353954,
  [SMALL_STATE(8162)] = 353969,
  [SMALL_STATE(8163)] = 353984,
  [SMALL_STATE(8164)] = 353999,
  [SMALL_STATE(8165)] = 354014,
  [SMALL_STATE(8166)] = 354029,
  [SMALL_STATE(8167)] = 354044,
  [SMALL_STATE(8168)] = 354059,
  [SMALL_STATE(8169)] = 354074,
  [SMALL_STATE(8170)] = 354089,
  [SMALL_STATE(8171)] = 354104,
  [SMALL_STATE(8172)] = 354119,
  [SMALL_STATE(8173)] = 354134,
  [SMALL_STATE(8174)] = 354149,
  [SMALL_STATE(8175)] = 354164,
  [SMALL_STATE(8176)] = 354177,
  [SMALL_STATE(8177)] = 354192,
  [SMALL_STATE(8178)] = 354207,
  [SMALL_STATE(8179)] = 354222,
  [SMALL_STATE(8180)] = 354237,
  [SMALL_STATE(8181)] = 354252,
  [SMALL_STATE(8182)] = 354267,
  [SMALL_STATE(8183)] = 354282,
  [SMALL_STATE(8184)] = 354297,
  [SMALL_STATE(8185)] = 354312,
  [SMALL_STATE(8186)] = 354327,
  [SMALL_STATE(8187)] = 354342,
  [SMALL_STATE(8188)] = 354357,
  [SMALL_STATE(8189)] = 354372,
  [SMALL_STATE(8190)] = 354387,
  [SMALL_STATE(8191)] = 354402,
  [SMALL_STATE(8192)] = 354417,
  [SMALL_STATE(8193)] = 354432,
  [SMALL_STATE(8194)] = 354449,
  [SMALL_STATE(8195)] = 354464,
  [SMALL_STATE(8196)] = 354479,
  [SMALL_STATE(8197)] = 354494,
  [SMALL_STATE(8198)] = 354509,
  [SMALL_STATE(8199)] = 354524,
  [SMALL_STATE(8200)] = 354539,
  [SMALL_STATE(8201)] = 354554,
  [SMALL_STATE(8202)] = 354569,
  [SMALL_STATE(8203)] = 354584,
  [SMALL_STATE(8204)] = 354599,
  [SMALL_STATE(8205)] = 354614,
  [SMALL_STATE(8206)] = 354629,
  [SMALL_STATE(8207)] = 354644,
  [SMALL_STATE(8208)] = 354659,
  [SMALL_STATE(8209)] = 354674,
  [SMALL_STATE(8210)] = 354689,
  [SMALL_STATE(8211)] = 354704,
  [SMALL_STATE(8212)] = 354719,
  [SMALL_STATE(8213)] = 354734,
  [SMALL_STATE(8214)] = 354749,
  [SMALL_STATE(8215)] = 354764,
  [SMALL_STATE(8216)] = 354779,
  [SMALL_STATE(8217)] = 354794,
  [SMALL_STATE(8218)] = 354809,
  [SMALL_STATE(8219)] = 354824,
  [SMALL_STATE(8220)] = 354839,
  [SMALL_STATE(8221)] = 354854,
  [SMALL_STATE(8222)] = 354869,
  [SMALL_STATE(8223)] = 354884,
  [SMALL_STATE(8224)] = 354899,
  [SMALL_STATE(8225)] = 354914,
  [SMALL_STATE(8226)] = 354929,
  [SMALL_STATE(8227)] = 354944,
  [SMALL_STATE(8228)] = 354959,
  [SMALL_STATE(8229)] = 354974,
  [SMALL_STATE(8230)] = 354989,
  [SMALL_STATE(8231)] = 355004,
  [SMALL_STATE(8232)] = 355019,
  [SMALL_STATE(8233)] = 355034,
  [SMALL_STATE(8234)] = 355049,
  [SMALL_STATE(8235)] = 355064,
  [SMALL_STATE(8236)] = 355079,
  [SMALL_STATE(8237)] = 355094,
  [SMALL_STATE(8238)] = 355109,
  [SMALL_STATE(8239)] = 355124,
  [SMALL_STATE(8240)] = 355139,
  [SMALL_STATE(8241)] = 355154,
  [SMALL_STATE(8242)] = 355169,
  [SMALL_STATE(8243)] = 355184,
  [SMALL_STATE(8244)] = 355199,
  [SMALL_STATE(8245)] = 355214,
  [SMALL_STATE(8246)] = 355229,
  [SMALL_STATE(8247)] = 355244,
  [SMALL_STATE(8248)] = 355259,
  [SMALL_STATE(8249)] = 355274,
  [SMALL_STATE(8250)] = 355289,
  [SMALL_STATE(8251)] = 355304,
  [SMALL_STATE(8252)] = 355319,
  [SMALL_STATE(8253)] = 355334,
  [SMALL_STATE(8254)] = 355349,
  [SMALL_STATE(8255)] = 355364,
  [SMALL_STATE(8256)] = 355379,
  [SMALL_STATE(8257)] = 355394,
  [SMALL_STATE(8258)] = 355409,
  [SMALL_STATE(8259)] = 355424,
  [SMALL_STATE(8260)] = 355439,
  [SMALL_STATE(8261)] = 355454,
  [SMALL_STATE(8262)] = 355469,
  [SMALL_STATE(8263)] = 355482,
  [SMALL_STATE(8264)] = 355497,
  [SMALL_STATE(8265)] = 355512,
  [SMALL_STATE(8266)] = 355527,
  [SMALL_STATE(8267)] = 355542,
  [SMALL_STATE(8268)] = 355557,
  [SMALL_STATE(8269)] = 355572,
  [SMALL_STATE(8270)] = 355587,
  [SMALL_STATE(8271)] = 355602,
  [SMALL_STATE(8272)] = 355617,
  [SMALL_STATE(8273)] = 355632,
  [SMALL_STATE(8274)] = 355649,
  [SMALL_STATE(8275)] = 355664,
  [SMALL_STATE(8276)] = 355679,
  [SMALL_STATE(8277)] = 355694,
  [SMALL_STATE(8278)] = 355709,
  [SMALL_STATE(8279)] = 355724,
  [SMALL_STATE(8280)] = 355739,
  [SMALL_STATE(8281)] = 355754,
  [SMALL_STATE(8282)] = 355769,
  [SMALL_STATE(8283)] = 355784,
  [SMALL_STATE(8284)] = 355799,
  [SMALL_STATE(8285)] = 355816,
  [SMALL_STATE(8286)] = 355831,
  [SMALL_STATE(8287)] = 355846,
  [SMALL_STATE(8288)] = 355861,
  [SMALL_STATE(8289)] = 355876,
  [SMALL_STATE(8290)] = 355891,
  [SMALL_STATE(8291)] = 355906,
  [SMALL_STATE(8292)] = 355921,
  [SMALL_STATE(8293)] = 355936,
  [SMALL_STATE(8294)] = 355951,
  [SMALL_STATE(8295)] = 355966,
  [SMALL_STATE(8296)] = 355981,
  [SMALL_STATE(8297)] = 355996,
  [SMALL_STATE(8298)] = 356011,
  [SMALL_STATE(8299)] = 356026,
  [SMALL_STATE(8300)] = 356037,
  [SMALL_STATE(8301)] = 356052,
  [SMALL_STATE(8302)] = 356067,
  [SMALL_STATE(8303)] = 356082,
  [SMALL_STATE(8304)] = 356097,
  [SMALL_STATE(8305)] = 356112,
  [SMALL_STATE(8306)] = 356127,
  [SMALL_STATE(8307)] = 356142,
  [SMALL_STATE(8308)] = 356157,
  [SMALL_STATE(8309)] = 356174,
  [SMALL_STATE(8310)] = 356189,
  [SMALL_STATE(8311)] = 356204,
  [SMALL_STATE(8312)] = 356219,
  [SMALL_STATE(8313)] = 356234,
  [SMALL_STATE(8314)] = 356249,
  [SMALL_STATE(8315)] = 356264,
  [SMALL_STATE(8316)] = 356279,
  [SMALL_STATE(8317)] = 356294,
  [SMALL_STATE(8318)] = 356309,
  [SMALL_STATE(8319)] = 356324,
  [SMALL_STATE(8320)] = 356339,
  [SMALL_STATE(8321)] = 356354,
  [SMALL_STATE(8322)] = 356369,
  [SMALL_STATE(8323)] = 356384,
  [SMALL_STATE(8324)] = 356399,
  [SMALL_STATE(8325)] = 356414,
  [SMALL_STATE(8326)] = 356429,
  [SMALL_STATE(8327)] = 356444,
  [SMALL_STATE(8328)] = 356459,
  [SMALL_STATE(8329)] = 356474,
  [SMALL_STATE(8330)] = 356489,
  [SMALL_STATE(8331)] = 356504,
  [SMALL_STATE(8332)] = 356519,
  [SMALL_STATE(8333)] = 356534,
  [SMALL_STATE(8334)] = 356549,
  [SMALL_STATE(8335)] = 356564,
  [SMALL_STATE(8336)] = 356579,
  [SMALL_STATE(8337)] = 356594,
  [SMALL_STATE(8338)] = 356609,
  [SMALL_STATE(8339)] = 356624,
  [SMALL_STATE(8340)] = 356639,
  [SMALL_STATE(8341)] = 356654,
  [SMALL_STATE(8342)] = 356669,
  [SMALL_STATE(8343)] = 356684,
  [SMALL_STATE(8344)] = 356699,
  [SMALL_STATE(8345)] = 356714,
  [SMALL_STATE(8346)] = 356729,
  [SMALL_STATE(8347)] = 356744,
  [SMALL_STATE(8348)] = 356759,
  [SMALL_STATE(8349)] = 356774,
  [SMALL_STATE(8350)] = 356789,
  [SMALL_STATE(8351)] = 356804,
  [SMALL_STATE(8352)] = 356819,
  [SMALL_STATE(8353)] = 356834,
  [SMALL_STATE(8354)] = 356849,
  [SMALL_STATE(8355)] = 356866,
  [SMALL_STATE(8356)] = 356881,
  [SMALL_STATE(8357)] = 356896,
  [SMALL_STATE(8358)] = 356911,
  [SMALL_STATE(8359)] = 356926,
  [SMALL_STATE(8360)] = 356939,
  [SMALL_STATE(8361)] = 356954,
  [SMALL_STATE(8362)] = 356969,
  [SMALL_STATE(8363)] = 356986,
  [SMALL_STATE(8364)] = 357001,
  [SMALL_STATE(8365)] = 357016,
  [SMALL_STATE(8366)] = 357031,
  [SMALL_STATE(8367)] = 357046,
  [SMALL_STATE(8368)] = 357061,
  [SMALL_STATE(8369)] = 357076,
  [SMALL_STATE(8370)] = 357091,
  [SMALL_STATE(8371)] = 357108,
  [SMALL_STATE(8372)] = 357123,
  [SMALL_STATE(8373)] = 357138,
  [SMALL_STATE(8374)] = 357153,
  [SMALL_STATE(8375)] = 357168,
  [SMALL_STATE(8376)] = 357183,
  [SMALL_STATE(8377)] = 357198,
  [SMALL_STATE(8378)] = 357213,
  [SMALL_STATE(8379)] = 357228,
  [SMALL_STATE(8380)] = 357243,
  [SMALL_STATE(8381)] = 357258,
  [SMALL_STATE(8382)] = 357273,
  [SMALL_STATE(8383)] = 357288,
  [SMALL_STATE(8384)] = 357303,
  [SMALL_STATE(8385)] = 357318,
  [SMALL_STATE(8386)] = 357333,
  [SMALL_STATE(8387)] = 357348,
  [SMALL_STATE(8388)] = 357363,
  [SMALL_STATE(8389)] = 357378,
  [SMALL_STATE(8390)] = 357395,
  [SMALL_STATE(8391)] = 357410,
  [SMALL_STATE(8392)] = 357425,
  [SMALL_STATE(8393)] = 357440,
  [SMALL_STATE(8394)] = 357455,
  [SMALL_STATE(8395)] = 357470,
  [SMALL_STATE(8396)] = 357485,
  [SMALL_STATE(8397)] = 357500,
  [SMALL_STATE(8398)] = 357515,
  [SMALL_STATE(8399)] = 357530,
  [SMALL_STATE(8400)] = 357545,
  [SMALL_STATE(8401)] = 357560,
  [SMALL_STATE(8402)] = 357575,
  [SMALL_STATE(8403)] = 357590,
  [SMALL_STATE(8404)] = 357600,
  [SMALL_STATE(8405)] = 357612,
  [SMALL_STATE(8406)] = 357624,
  [SMALL_STATE(8407)] = 357636,
  [SMALL_STATE(8408)] = 357648,
  [SMALL_STATE(8409)] = 357660,
  [SMALL_STATE(8410)] = 357672,
  [SMALL_STATE(8411)] = 357684,
  [SMALL_STATE(8412)] = 357696,
  [SMALL_STATE(8413)] = 357706,
  [SMALL_STATE(8414)] = 357716,
  [SMALL_STATE(8415)] = 357728,
  [SMALL_STATE(8416)] = 357740,
  [SMALL_STATE(8417)] = 357752,
  [SMALL_STATE(8418)] = 357764,
  [SMALL_STATE(8419)] = 357776,
  [SMALL_STATE(8420)] = 357788,
  [SMALL_STATE(8421)] = 357800,
  [SMALL_STATE(8422)] = 357812,
  [SMALL_STATE(8423)] = 357824,
  [SMALL_STATE(8424)] = 357836,
  [SMALL_STATE(8425)] = 357848,
  [SMALL_STATE(8426)] = 357860,
  [SMALL_STATE(8427)] = 357872,
  [SMALL_STATE(8428)] = 357884,
  [SMALL_STATE(8429)] = 357896,
  [SMALL_STATE(8430)] = 357908,
  [SMALL_STATE(8431)] = 357920,
  [SMALL_STATE(8432)] = 357932,
  [SMALL_STATE(8433)] = 357944,
  [SMALL_STATE(8434)] = 357956,
  [SMALL_STATE(8435)] = 357968,
  [SMALL_STATE(8436)] = 357980,
  [SMALL_STATE(8437)] = 357992,
  [SMALL_STATE(8438)] = 358004,
  [SMALL_STATE(8439)] = 358016,
  [SMALL_STATE(8440)] = 358028,
  [SMALL_STATE(8441)] = 358040,
  [SMALL_STATE(8442)] = 358052,
  [SMALL_STATE(8443)] = 358064,
  [SMALL_STATE(8444)] = 358076,
  [SMALL_STATE(8445)] = 358088,
  [SMALL_STATE(8446)] = 358100,
  [SMALL_STATE(8447)] = 358112,
  [SMALL_STATE(8448)] = 358124,
  [SMALL_STATE(8449)] = 358136,
  [SMALL_STATE(8450)] = 358148,
  [SMALL_STATE(8451)] = 358160,
  [SMALL_STATE(8452)] = 358172,
  [SMALL_STATE(8453)] = 358184,
  [SMALL_STATE(8454)] = 358196,
  [SMALL_STATE(8455)] = 358208,
  [SMALL_STATE(8456)] = 358220,
  [SMALL_STATE(8457)] = 358230,
  [SMALL_STATE(8458)] = 358242,
  [SMALL_STATE(8459)] = 358252,
  [SMALL_STATE(8460)] = 358262,
  [SMALL_STATE(8461)] = 358274,
  [SMALL_STATE(8462)] = 358286,
  [SMALL_STATE(8463)] = 358298,
  [SMALL_STATE(8464)] = 358310,
  [SMALL_STATE(8465)] = 358322,
  [SMALL_STATE(8466)] = 358334,
  [SMALL_STATE(8467)] = 358344,
  [SMALL_STATE(8468)] = 358354,
  [SMALL_STATE(8469)] = 358366,
  [SMALL_STATE(8470)] = 358378,
  [SMALL_STATE(8471)] = 358390,
  [SMALL_STATE(8472)] = 358402,
  [SMALL_STATE(8473)] = 358414,
  [SMALL_STATE(8474)] = 358426,
  [SMALL_STATE(8475)] = 358438,
  [SMALL_STATE(8476)] = 358450,
  [SMALL_STATE(8477)] = 358462,
  [SMALL_STATE(8478)] = 358474,
  [SMALL_STATE(8479)] = 358486,
  [SMALL_STATE(8480)] = 358498,
  [SMALL_STATE(8481)] = 358510,
  [SMALL_STATE(8482)] = 358520,
  [SMALL_STATE(8483)] = 358530,
  [SMALL_STATE(8484)] = 358542,
  [SMALL_STATE(8485)] = 358552,
  [SMALL_STATE(8486)] = 358564,
  [SMALL_STATE(8487)] = 358576,
  [SMALL_STATE(8488)] = 358588,
  [SMALL_STATE(8489)] = 358600,
  [SMALL_STATE(8490)] = 358612,
  [SMALL_STATE(8491)] = 358622,
  [SMALL_STATE(8492)] = 358634,
  [SMALL_STATE(8493)] = 358646,
  [SMALL_STATE(8494)] = 358658,
  [SMALL_STATE(8495)] = 358670,
  [SMALL_STATE(8496)] = 358682,
  [SMALL_STATE(8497)] = 358694,
  [SMALL_STATE(8498)] = 358704,
  [SMALL_STATE(8499)] = 358716,
  [SMALL_STATE(8500)] = 358728,
  [SMALL_STATE(8501)] = 358740,
  [SMALL_STATE(8502)] = 358752,
  [SMALL_STATE(8503)] = 358762,
  [SMALL_STATE(8504)] = 358774,
  [SMALL_STATE(8505)] = 358786,
  [SMALL_STATE(8506)] = 358798,
  [SMALL_STATE(8507)] = 358810,
  [SMALL_STATE(8508)] = 358822,
  [SMALL_STATE(8509)] = 358834,
  [SMALL_STATE(8510)] = 358844,
  [SMALL_STATE(8511)] = 358854,
  [SMALL_STATE(8512)] = 358866,
  [SMALL_STATE(8513)] = 358878,
  [SMALL_STATE(8514)] = 358890,
  [SMALL_STATE(8515)] = 358902,
  [SMALL_STATE(8516)] = 358914,
  [SMALL_STATE(8517)] = 358924,
  [SMALL_STATE(8518)] = 358936,
  [SMALL_STATE(8519)] = 358948,
  [SMALL_STATE(8520)] = 358958,
  [SMALL_STATE(8521)] = 358970,
  [SMALL_STATE(8522)] = 358980,
  [SMALL_STATE(8523)] = 358992,
  [SMALL_STATE(8524)] = 359004,
  [SMALL_STATE(8525)] = 359016,
  [SMALL_STATE(8526)] = 359026,
  [SMALL_STATE(8527)] = 359038,
  [SMALL_STATE(8528)] = 359050,
  [SMALL_STATE(8529)] = 359062,
  [SMALL_STATE(8530)] = 359074,
  [SMALL_STATE(8531)] = 359086,
  [SMALL_STATE(8532)] = 359098,
  [SMALL_STATE(8533)] = 359110,
  [SMALL_STATE(8534)] = 359122,
  [SMALL_STATE(8535)] = 359134,
  [SMALL_STATE(8536)] = 359148,
  [SMALL_STATE(8537)] = 359160,
  [SMALL_STATE(8538)] = 359172,
  [SMALL_STATE(8539)] = 359182,
  [SMALL_STATE(8540)] = 359194,
  [SMALL_STATE(8541)] = 359206,
  [SMALL_STATE(8542)] = 359218,
  [SMALL_STATE(8543)] = 359228,
  [SMALL_STATE(8544)] = 359238,
  [SMALL_STATE(8545)] = 359250,
  [SMALL_STATE(8546)] = 359262,
  [SMALL_STATE(8547)] = 359274,
  [SMALL_STATE(8548)] = 359286,
  [SMALL_STATE(8549)] = 359298,
  [SMALL_STATE(8550)] = 359310,
  [SMALL_STATE(8551)] = 359322,
  [SMALL_STATE(8552)] = 359334,
  [SMALL_STATE(8553)] = 359346,
  [SMALL_STATE(8554)] = 359356,
  [SMALL_STATE(8555)] = 359370,
  [SMALL_STATE(8556)] = 359382,
  [SMALL_STATE(8557)] = 359394,
  [SMALL_STATE(8558)] = 359406,
  [SMALL_STATE(8559)] = 359418,
  [SMALL_STATE(8560)] = 359430,
  [SMALL_STATE(8561)] = 359442,
  [SMALL_STATE(8562)] = 359454,
  [SMALL_STATE(8563)] = 359466,
  [SMALL_STATE(8564)] = 359478,
  [SMALL_STATE(8565)] = 359490,
  [SMALL_STATE(8566)] = 359502,
  [SMALL_STATE(8567)] = 359514,
  [SMALL_STATE(8568)] = 359528,
  [SMALL_STATE(8569)] = 359540,
  [SMALL_STATE(8570)] = 359552,
  [SMALL_STATE(8571)] = 359564,
  [SMALL_STATE(8572)] = 359576,
  [SMALL_STATE(8573)] = 359586,
  [SMALL_STATE(8574)] = 359598,
  [SMALL_STATE(8575)] = 359610,
  [SMALL_STATE(8576)] = 359622,
  [SMALL_STATE(8577)] = 359634,
  [SMALL_STATE(8578)] = 359646,
  [SMALL_STATE(8579)] = 359658,
  [SMALL_STATE(8580)] = 359672,
  [SMALL_STATE(8581)] = 359684,
  [SMALL_STATE(8582)] = 359696,
  [SMALL_STATE(8583)] = 359708,
  [SMALL_STATE(8584)] = 359720,
  [SMALL_STATE(8585)] = 359732,
  [SMALL_STATE(8586)] = 359742,
  [SMALL_STATE(8587)] = 359754,
  [SMALL_STATE(8588)] = 359766,
  [SMALL_STATE(8589)] = 359778,
  [SMALL_STATE(8590)] = 359790,
  [SMALL_STATE(8591)] = 359804,
  [SMALL_STATE(8592)] = 359816,
  [SMALL_STATE(8593)] = 359828,
  [SMALL_STATE(8594)] = 359840,
  [SMALL_STATE(8595)] = 359852,
  [SMALL_STATE(8596)] = 359864,
  [SMALL_STATE(8597)] = 359876,
  [SMALL_STATE(8598)] = 359888,
  [SMALL_STATE(8599)] = 359902,
  [SMALL_STATE(8600)] = 359914,
  [SMALL_STATE(8601)] = 359926,
  [SMALL_STATE(8602)] = 359940,
  [SMALL_STATE(8603)] = 359952,
  [SMALL_STATE(8604)] = 359964,
  [SMALL_STATE(8605)] = 359976,
  [SMALL_STATE(8606)] = 359988,
  [SMALL_STATE(8607)] = 360000,
  [SMALL_STATE(8608)] = 360010,
  [SMALL_STATE(8609)] = 360022,
  [SMALL_STATE(8610)] = 360036,
  [SMALL_STATE(8611)] = 360048,
  [SMALL_STATE(8612)] = 360060,
  [SMALL_STATE(8613)] = 360070,
  [SMALL_STATE(8614)] = 360080,
  [SMALL_STATE(8615)] = 360092,
  [SMALL_STATE(8616)] = 360106,
  [SMALL_STATE(8617)] = 360118,
  [SMALL_STATE(8618)] = 360130,
  [SMALL_STATE(8619)] = 360142,
  [SMALL_STATE(8620)] = 360154,
  [SMALL_STATE(8621)] = 360166,
  [SMALL_STATE(8622)] = 360180,
  [SMALL_STATE(8623)] = 360192,
  [SMALL_STATE(8624)] = 360204,
  [SMALL_STATE(8625)] = 360216,
  [SMALL_STATE(8626)] = 360228,
  [SMALL_STATE(8627)] = 360240,
  [SMALL_STATE(8628)] = 360252,
  [SMALL_STATE(8629)] = 360264,
  [SMALL_STATE(8630)] = 360278,
  [SMALL_STATE(8631)] = 360288,
  [SMALL_STATE(8632)] = 360300,
  [SMALL_STATE(8633)] = 360312,
  [SMALL_STATE(8634)] = 360324,
  [SMALL_STATE(8635)] = 360334,
  [SMALL_STATE(8636)] = 360346,
  [SMALL_STATE(8637)] = 360358,
  [SMALL_STATE(8638)] = 360370,
  [SMALL_STATE(8639)] = 360384,
  [SMALL_STATE(8640)] = 360396,
  [SMALL_STATE(8641)] = 360408,
  [SMALL_STATE(8642)] = 360420,
  [SMALL_STATE(8643)] = 360432,
  [SMALL_STATE(8644)] = 360444,
  [SMALL_STATE(8645)] = 360456,
  [SMALL_STATE(8646)] = 360468,
  [SMALL_STATE(8647)] = 360480,
  [SMALL_STATE(8648)] = 360492,
  [SMALL_STATE(8649)] = 360506,
  [SMALL_STATE(8650)] = 360518,
  [SMALL_STATE(8651)] = 360527,
  [SMALL_STATE(8652)] = 360536,
  [SMALL_STATE(8653)] = 360545,
  [SMALL_STATE(8654)] = 360554,
  [SMALL_STATE(8655)] = 360563,
  [SMALL_STATE(8656)] = 360572,
  [SMALL_STATE(8657)] = 360581,
  [SMALL_STATE(8658)] = 360590,
  [SMALL_STATE(8659)] = 360599,
  [SMALL_STATE(8660)] = 360608,
  [SMALL_STATE(8661)] = 360617,
  [SMALL_STATE(8662)] = 360626,
  [SMALL_STATE(8663)] = 360635,
  [SMALL_STATE(8664)] = 360644,
  [SMALL_STATE(8665)] = 360653,
  [SMALL_STATE(8666)] = 360662,
  [SMALL_STATE(8667)] = 360671,
  [SMALL_STATE(8668)] = 360680,
  [SMALL_STATE(8669)] = 360689,
  [SMALL_STATE(8670)] = 360698,
  [SMALL_STATE(8671)] = 360707,
  [SMALL_STATE(8672)] = 360716,
  [SMALL_STATE(8673)] = 360725,
  [SMALL_STATE(8674)] = 360734,
  [SMALL_STATE(8675)] = 360743,
  [SMALL_STATE(8676)] = 360752,
  [SMALL_STATE(8677)] = 360761,
  [SMALL_STATE(8678)] = 360770,
  [SMALL_STATE(8679)] = 360779,
  [SMALL_STATE(8680)] = 360788,
  [SMALL_STATE(8681)] = 360797,
  [SMALL_STATE(8682)] = 360806,
  [SMALL_STATE(8683)] = 360815,
  [SMALL_STATE(8684)] = 360824,
  [SMALL_STATE(8685)] = 360833,
  [SMALL_STATE(8686)] = 360842,
  [SMALL_STATE(8687)] = 360851,
  [SMALL_STATE(8688)] = 360860,
  [SMALL_STATE(8689)] = 360869,
  [SMALL_STATE(8690)] = 360878,
  [SMALL_STATE(8691)] = 360887,
  [SMALL_STATE(8692)] = 360896,
  [SMALL_STATE(8693)] = 360905,
  [SMALL_STATE(8694)] = 360914,
  [SMALL_STATE(8695)] = 360923,
  [SMALL_STATE(8696)] = 360932,
  [SMALL_STATE(8697)] = 360941,
  [SMALL_STATE(8698)] = 360950,
  [SMALL_STATE(8699)] = 360959,
  [SMALL_STATE(8700)] = 360968,
  [SMALL_STATE(8701)] = 360977,
  [SMALL_STATE(8702)] = 360986,
  [SMALL_STATE(8703)] = 360995,
  [SMALL_STATE(8704)] = 361004,
  [SMALL_STATE(8705)] = 361013,
  [SMALL_STATE(8706)] = 361022,
  [SMALL_STATE(8707)] = 361031,
  [SMALL_STATE(8708)] = 361040,
  [SMALL_STATE(8709)] = 361049,
  [SMALL_STATE(8710)] = 361058,
  [SMALL_STATE(8711)] = 361067,
  [SMALL_STATE(8712)] = 361076,
  [SMALL_STATE(8713)] = 361085,
  [SMALL_STATE(8714)] = 361094,
  [SMALL_STATE(8715)] = 361103,
  [SMALL_STATE(8716)] = 361112,
  [SMALL_STATE(8717)] = 361121,
  [SMALL_STATE(8718)] = 361130,
  [SMALL_STATE(8719)] = 361139,
  [SMALL_STATE(8720)] = 361148,
  [SMALL_STATE(8721)] = 361157,
  [SMALL_STATE(8722)] = 361166,
  [SMALL_STATE(8723)] = 361175,
  [SMALL_STATE(8724)] = 361184,
  [SMALL_STATE(8725)] = 361193,
  [SMALL_STATE(8726)] = 361202,
  [SMALL_STATE(8727)] = 361211,
  [SMALL_STATE(8728)] = 361220,
  [SMALL_STATE(8729)] = 361229,
  [SMALL_STATE(8730)] = 361238,
  [SMALL_STATE(8731)] = 361247,
  [SMALL_STATE(8732)] = 361256,
  [SMALL_STATE(8733)] = 361265,
  [SMALL_STATE(8734)] = 361274,
  [SMALL_STATE(8735)] = 361283,
  [SMALL_STATE(8736)] = 361292,
  [SMALL_STATE(8737)] = 361301,
  [SMALL_STATE(8738)] = 361310,
  [SMALL_STATE(8739)] = 361319,
  [SMALL_STATE(8740)] = 361328,
  [SMALL_STATE(8741)] = 361337,
  [SMALL_STATE(8742)] = 361346,
  [SMALL_STATE(8743)] = 361355,
  [SMALL_STATE(8744)] = 361364,
  [SMALL_STATE(8745)] = 361373,
  [SMALL_STATE(8746)] = 361382,
  [SMALL_STATE(8747)] = 361391,
  [SMALL_STATE(8748)] = 361400,
  [SMALL_STATE(8749)] = 361409,
  [SMALL_STATE(8750)] = 361418,
  [SMALL_STATE(8751)] = 361427,
  [SMALL_STATE(8752)] = 361436,
  [SMALL_STATE(8753)] = 361445,
  [SMALL_STATE(8754)] = 361454,
  [SMALL_STATE(8755)] = 361463,
  [SMALL_STATE(8756)] = 361472,
  [SMALL_STATE(8757)] = 361481,
  [SMALL_STATE(8758)] = 361490,
  [SMALL_STATE(8759)] = 361499,
  [SMALL_STATE(8760)] = 361508,
  [SMALL_STATE(8761)] = 361517,
  [SMALL_STATE(8762)] = 361526,
  [SMALL_STATE(8763)] = 361535,
  [SMALL_STATE(8764)] = 361544,
  [SMALL_STATE(8765)] = 361553,
  [SMALL_STATE(8766)] = 361562,
  [SMALL_STATE(8767)] = 361571,
  [SMALL_STATE(8768)] = 361580,
  [SMALL_STATE(8769)] = 361589,
  [SMALL_STATE(8770)] = 361598,
  [SMALL_STATE(8771)] = 361607,
  [SMALL_STATE(8772)] = 361616,
  [SMALL_STATE(8773)] = 361625,
  [SMALL_STATE(8774)] = 361634,
  [SMALL_STATE(8775)] = 361643,
  [SMALL_STATE(8776)] = 361652,
  [SMALL_STATE(8777)] = 361661,
  [SMALL_STATE(8778)] = 361670,
  [SMALL_STATE(8779)] = 361679,
  [SMALL_STATE(8780)] = 361688,
  [SMALL_STATE(8781)] = 361697,
  [SMALL_STATE(8782)] = 361706,
  [SMALL_STATE(8783)] = 361715,
  [SMALL_STATE(8784)] = 361724,
  [SMALL_STATE(8785)] = 361733,
  [SMALL_STATE(8786)] = 361742,
  [SMALL_STATE(8787)] = 361751,
  [SMALL_STATE(8788)] = 361760,
  [SMALL_STATE(8789)] = 361769,
  [SMALL_STATE(8790)] = 361778,
  [SMALL_STATE(8791)] = 361787,
  [SMALL_STATE(8792)] = 361796,
  [SMALL_STATE(8793)] = 361805,
  [SMALL_STATE(8794)] = 361814,
  [SMALL_STATE(8795)] = 361823,
  [SMALL_STATE(8796)] = 361832,
  [SMALL_STATE(8797)] = 361841,
  [SMALL_STATE(8798)] = 361850,
  [SMALL_STATE(8799)] = 361859,
  [SMALL_STATE(8800)] = 361868,
  [SMALL_STATE(8801)] = 361877,
  [SMALL_STATE(8802)] = 361886,
  [SMALL_STATE(8803)] = 361895,
  [SMALL_STATE(8804)] = 361904,
  [SMALL_STATE(8805)] = 361913,
  [SMALL_STATE(8806)] = 361922,
  [SMALL_STATE(8807)] = 361931,
  [SMALL_STATE(8808)] = 361940,
  [SMALL_STATE(8809)] = 361949,
  [SMALL_STATE(8810)] = 361958,
  [SMALL_STATE(8811)] = 361967,
  [SMALL_STATE(8812)] = 361976,
  [SMALL_STATE(8813)] = 361985,
  [SMALL_STATE(8814)] = 361994,
  [SMALL_STATE(8815)] = 362003,
  [SMALL_STATE(8816)] = 362012,
  [SMALL_STATE(8817)] = 362021,
  [SMALL_STATE(8818)] = 362030,
  [SMALL_STATE(8819)] = 362039,
  [SMALL_STATE(8820)] = 362048,
  [SMALL_STATE(8821)] = 362057,
  [SMALL_STATE(8822)] = 362066,
  [SMALL_STATE(8823)] = 362075,
  [SMALL_STATE(8824)] = 362084,
  [SMALL_STATE(8825)] = 362093,
  [SMALL_STATE(8826)] = 362102,
  [SMALL_STATE(8827)] = 362111,
  [SMALL_STATE(8828)] = 362120,
  [SMALL_STATE(8829)] = 362129,
  [SMALL_STATE(8830)] = 362138,
  [SMALL_STATE(8831)] = 362147,
  [SMALL_STATE(8832)] = 362156,
  [SMALL_STATE(8833)] = 362165,
  [SMALL_STATE(8834)] = 362174,
  [SMALL_STATE(8835)] = 362183,
  [SMALL_STATE(8836)] = 362192,
  [SMALL_STATE(8837)] = 362201,
  [SMALL_STATE(8838)] = 362210,
  [SMALL_STATE(8839)] = 362219,
  [SMALL_STATE(8840)] = 362228,
  [SMALL_STATE(8841)] = 362237,
  [SMALL_STATE(8842)] = 362246,
  [SMALL_STATE(8843)] = 362255,
  [SMALL_STATE(8844)] = 362264,
  [SMALL_STATE(8845)] = 362273,
  [SMALL_STATE(8846)] = 362282,
  [SMALL_STATE(8847)] = 362291,
  [SMALL_STATE(8848)] = 362300,
  [SMALL_STATE(8849)] = 362309,
  [SMALL_STATE(8850)] = 362318,
  [SMALL_STATE(8851)] = 362327,
  [SMALL_STATE(8852)] = 362336,
  [SMALL_STATE(8853)] = 362345,
  [SMALL_STATE(8854)] = 362354,
  [SMALL_STATE(8855)] = 362363,
  [SMALL_STATE(8856)] = 362372,
  [SMALL_STATE(8857)] = 362381,
  [SMALL_STATE(8858)] = 362390,
  [SMALL_STATE(8859)] = 362399,
  [SMALL_STATE(8860)] = 362408,
  [SMALL_STATE(8861)] = 362417,
  [SMALL_STATE(8862)] = 362426,
  [SMALL_STATE(8863)] = 362435,
  [SMALL_STATE(8864)] = 362444,
  [SMALL_STATE(8865)] = 362453,
  [SMALL_STATE(8866)] = 362462,
  [SMALL_STATE(8867)] = 362471,
  [SMALL_STATE(8868)] = 362480,
  [SMALL_STATE(8869)] = 362489,
  [SMALL_STATE(8870)] = 362498,
  [SMALL_STATE(8871)] = 362507,
  [SMALL_STATE(8872)] = 362516,
  [SMALL_STATE(8873)] = 362525,
  [SMALL_STATE(8874)] = 362534,
  [SMALL_STATE(8875)] = 362543,
  [SMALL_STATE(8876)] = 362552,
  [SMALL_STATE(8877)] = 362561,
  [SMALL_STATE(8878)] = 362570,
  [SMALL_STATE(8879)] = 362579,
  [SMALL_STATE(8880)] = 362588,
  [SMALL_STATE(8881)] = 362597,
  [SMALL_STATE(8882)] = 362606,
  [SMALL_STATE(8883)] = 362615,
  [SMALL_STATE(8884)] = 362624,
  [SMALL_STATE(8885)] = 362633,
  [SMALL_STATE(8886)] = 362642,
  [SMALL_STATE(8887)] = 362651,
  [SMALL_STATE(8888)] = 362660,
  [SMALL_STATE(8889)] = 362669,
  [SMALL_STATE(8890)] = 362678,
  [SMALL_STATE(8891)] = 362687,
  [SMALL_STATE(8892)] = 362696,
  [SMALL_STATE(8893)] = 362705,
  [SMALL_STATE(8894)] = 362714,
  [SMALL_STATE(8895)] = 362723,
  [SMALL_STATE(8896)] = 362732,
  [SMALL_STATE(8897)] = 362741,
  [SMALL_STATE(8898)] = 362750,
  [SMALL_STATE(8899)] = 362759,
  [SMALL_STATE(8900)] = 362768,
  [SMALL_STATE(8901)] = 362777,
  [SMALL_STATE(8902)] = 362786,
  [SMALL_STATE(8903)] = 362795,
  [SMALL_STATE(8904)] = 362804,
  [SMALL_STATE(8905)] = 362813,
  [SMALL_STATE(8906)] = 362822,
  [SMALL_STATE(8907)] = 362831,
  [SMALL_STATE(8908)] = 362840,
  [SMALL_STATE(8909)] = 362849,
  [SMALL_STATE(8910)] = 362858,
  [SMALL_STATE(8911)] = 362867,
  [SMALL_STATE(8912)] = 362876,
  [SMALL_STATE(8913)] = 362885,
  [SMALL_STATE(8914)] = 362894,
  [SMALL_STATE(8915)] = 362903,
  [SMALL_STATE(8916)] = 362912,
  [SMALL_STATE(8917)] = 362921,
  [SMALL_STATE(8918)] = 362930,
  [SMALL_STATE(8919)] = 362939,
  [SMALL_STATE(8920)] = 362948,
  [SMALL_STATE(8921)] = 362957,
  [SMALL_STATE(8922)] = 362966,
  [SMALL_STATE(8923)] = 362975,
  [SMALL_STATE(8924)] = 362984,
  [SMALL_STATE(8925)] = 362993,
  [SMALL_STATE(8926)] = 363002,
  [SMALL_STATE(8927)] = 363011,
  [SMALL_STATE(8928)] = 363020,
  [SMALL_STATE(8929)] = 363029,
  [SMALL_STATE(8930)] = 363038,
  [SMALL_STATE(8931)] = 363047,
  [SMALL_STATE(8932)] = 363056,
  [SMALL_STATE(8933)] = 363065,
  [SMALL_STATE(8934)] = 363074,
  [SMALL_STATE(8935)] = 363083,
  [SMALL_STATE(8936)] = 363092,
  [SMALL_STATE(8937)] = 363101,
  [SMALL_STATE(8938)] = 363110,
  [SMALL_STATE(8939)] = 363119,
  [SMALL_STATE(8940)] = 363128,
  [SMALL_STATE(8941)] = 363137,
  [SMALL_STATE(8942)] = 363146,
  [SMALL_STATE(8943)] = 363155,
  [SMALL_STATE(8944)] = 363164,
  [SMALL_STATE(8945)] = 363173,
  [SMALL_STATE(8946)] = 363182,
  [SMALL_STATE(8947)] = 363191,
  [SMALL_STATE(8948)] = 363200,
  [SMALL_STATE(8949)] = 363209,
  [SMALL_STATE(8950)] = 363218,
  [SMALL_STATE(8951)] = 363227,
  [SMALL_STATE(8952)] = 363236,
  [SMALL_STATE(8953)] = 363245,
  [SMALL_STATE(8954)] = 363254,
  [SMALL_STATE(8955)] = 363263,
  [SMALL_STATE(8956)] = 363272,
  [SMALL_STATE(8957)] = 363281,
  [SMALL_STATE(8958)] = 363290,
  [SMALL_STATE(8959)] = 363299,
  [SMALL_STATE(8960)] = 363308,
  [SMALL_STATE(8961)] = 363317,
  [SMALL_STATE(8962)] = 363326,
  [SMALL_STATE(8963)] = 363335,
  [SMALL_STATE(8964)] = 363344,
  [SMALL_STATE(8965)] = 363353,
  [SMALL_STATE(8966)] = 363362,
  [SMALL_STATE(8967)] = 363371,
  [SMALL_STATE(8968)] = 363380,
  [SMALL_STATE(8969)] = 363389,
  [SMALL_STATE(8970)] = 363398,
  [SMALL_STATE(8971)] = 363407,
  [SMALL_STATE(8972)] = 363416,
  [SMALL_STATE(8973)] = 363425,
  [SMALL_STATE(8974)] = 363434,
  [SMALL_STATE(8975)] = 363443,
  [SMALL_STATE(8976)] = 363452,
  [SMALL_STATE(8977)] = 363461,
  [SMALL_STATE(8978)] = 363470,
  [SMALL_STATE(8979)] = 363479,
  [SMALL_STATE(8980)] = 363488,
  [SMALL_STATE(8981)] = 363497,
  [SMALL_STATE(8982)] = 363506,
  [SMALL_STATE(8983)] = 363515,
  [SMALL_STATE(8984)] = 363524,
  [SMALL_STATE(8985)] = 363533,
  [SMALL_STATE(8986)] = 363542,
  [SMALL_STATE(8987)] = 363551,
  [SMALL_STATE(8988)] = 363560,
  [SMALL_STATE(8989)] = 363569,
  [SMALL_STATE(8990)] = 363578,
  [SMALL_STATE(8991)] = 363587,
  [SMALL_STATE(8992)] = 363596,
  [SMALL_STATE(8993)] = 363605,
  [SMALL_STATE(8994)] = 363614,
  [SMALL_STATE(8995)] = 363623,
  [SMALL_STATE(8996)] = 363632,
  [SMALL_STATE(8997)] = 363641,
  [SMALL_STATE(8998)] = 363650,
  [SMALL_STATE(8999)] = 363659,
  [SMALL_STATE(9000)] = 363668,
  [SMALL_STATE(9001)] = 363677,
  [SMALL_STATE(9002)] = 363686,
  [SMALL_STATE(9003)] = 363695,
  [SMALL_STATE(9004)] = 363704,
  [SMALL_STATE(9005)] = 363713,
  [SMALL_STATE(9006)] = 363722,
  [SMALL_STATE(9007)] = 363731,
  [SMALL_STATE(9008)] = 363740,
  [SMALL_STATE(9009)] = 363749,
  [SMALL_STATE(9010)] = 363758,
  [SMALL_STATE(9011)] = 363767,
  [SMALL_STATE(9012)] = 363776,
  [SMALL_STATE(9013)] = 363785,
  [SMALL_STATE(9014)] = 363794,
  [SMALL_STATE(9015)] = 363803,
  [SMALL_STATE(9016)] = 363812,
  [SMALL_STATE(9017)] = 363821,
  [SMALL_STATE(9018)] = 363830,
  [SMALL_STATE(9019)] = 363839,
  [SMALL_STATE(9020)] = 363848,
  [SMALL_STATE(9021)] = 363857,
  [SMALL_STATE(9022)] = 363866,
  [SMALL_STATE(9023)] = 363875,
  [SMALL_STATE(9024)] = 363884,
  [SMALL_STATE(9025)] = 363893,
  [SMALL_STATE(9026)] = 363902,
  [SMALL_STATE(9027)] = 363911,
  [SMALL_STATE(9028)] = 363920,
  [SMALL_STATE(9029)] = 363929,
  [SMALL_STATE(9030)] = 363938,
  [SMALL_STATE(9031)] = 363947,
  [SMALL_STATE(9032)] = 363956,
  [SMALL_STATE(9033)] = 363965,
  [SMALL_STATE(9034)] = 363974,
  [SMALL_STATE(9035)] = 363983,
  [SMALL_STATE(9036)] = 363992,
  [SMALL_STATE(9037)] = 364001,
  [SMALL_STATE(9038)] = 364010,
  [SMALL_STATE(9039)] = 364019,
  [SMALL_STATE(9040)] = 364028,
  [SMALL_STATE(9041)] = 364037,
  [SMALL_STATE(9042)] = 364046,
  [SMALL_STATE(9043)] = 364055,
  [SMALL_STATE(9044)] = 364064,
  [SMALL_STATE(9045)] = 364073,
  [SMALL_STATE(9046)] = 364082,
  [SMALL_STATE(9047)] = 364091,
  [SMALL_STATE(9048)] = 364100,
  [SMALL_STATE(9049)] = 364109,
  [SMALL_STATE(9050)] = 364118,
  [SMALL_STATE(9051)] = 364127,
  [SMALL_STATE(9052)] = 364136,
  [SMALL_STATE(9053)] = 364145,
  [SMALL_STATE(9054)] = 364154,
  [SMALL_STATE(9055)] = 364163,
  [SMALL_STATE(9056)] = 364172,
  [SMALL_STATE(9057)] = 364181,
  [SMALL_STATE(9058)] = 364190,
  [SMALL_STATE(9059)] = 364199,
  [SMALL_STATE(9060)] = 364208,
  [SMALL_STATE(9061)] = 364217,
  [SMALL_STATE(9062)] = 364226,
  [SMALL_STATE(9063)] = 364235,
  [SMALL_STATE(9064)] = 364244,
  [SMALL_STATE(9065)] = 364253,
  [SMALL_STATE(9066)] = 364262,
  [SMALL_STATE(9067)] = 364271,
  [SMALL_STATE(9068)] = 364280,
  [SMALL_STATE(9069)] = 364289,
  [SMALL_STATE(9070)] = 364298,
  [SMALL_STATE(9071)] = 364307,
  [SMALL_STATE(9072)] = 364316,
  [SMALL_STATE(9073)] = 364325,
  [SMALL_STATE(9074)] = 364334,
  [SMALL_STATE(9075)] = 364343,
  [SMALL_STATE(9076)] = 364352,
  [SMALL_STATE(9077)] = 364361,
  [SMALL_STATE(9078)] = 364370,
  [SMALL_STATE(9079)] = 364379,
  [SMALL_STATE(9080)] = 364388,
  [SMALL_STATE(9081)] = 364397,
  [SMALL_STATE(9082)] = 364406,
  [SMALL_STATE(9083)] = 364415,
  [SMALL_STATE(9084)] = 364424,
  [SMALL_STATE(9085)] = 364433,
  [SMALL_STATE(9086)] = 364442,
  [SMALL_STATE(9087)] = 364451,
  [SMALL_STATE(9088)] = 364460,
  [SMALL_STATE(9089)] = 364469,
  [SMALL_STATE(9090)] = 364478,
  [SMALL_STATE(9091)] = 364487,
  [SMALL_STATE(9092)] = 364496,
  [SMALL_STATE(9093)] = 364505,
  [SMALL_STATE(9094)] = 364514,
  [SMALL_STATE(9095)] = 364523,
  [SMALL_STATE(9096)] = 364532,
  [SMALL_STATE(9097)] = 364541,
  [SMALL_STATE(9098)] = 364550,
  [SMALL_STATE(9099)] = 364559,
  [SMALL_STATE(9100)] = 364568,
  [SMALL_STATE(9101)] = 364577,
  [SMALL_STATE(9102)] = 364586,
  [SMALL_STATE(9103)] = 364595,
  [SMALL_STATE(9104)] = 364604,
  [SMALL_STATE(9105)] = 364613,
  [SMALL_STATE(9106)] = 364622,
  [SMALL_STATE(9107)] = 364631,
  [SMALL_STATE(9108)] = 364640,
  [SMALL_STATE(9109)] = 364649,
  [SMALL_STATE(9110)] = 364658,
  [SMALL_STATE(9111)] = 364667,
  [SMALL_STATE(9112)] = 364676,
  [SMALL_STATE(9113)] = 364685,
  [SMALL_STATE(9114)] = 364694,
  [SMALL_STATE(9115)] = 364703,
  [SMALL_STATE(9116)] = 364712,
  [SMALL_STATE(9117)] = 364721,
  [SMALL_STATE(9118)] = 364730,
  [SMALL_STATE(9119)] = 364739,
  [SMALL_STATE(9120)] = 364748,
  [SMALL_STATE(9121)] = 364757,
  [SMALL_STATE(9122)] = 364766,
  [SMALL_STATE(9123)] = 364775,
  [SMALL_STATE(9124)] = 364784,
  [SMALL_STATE(9125)] = 364793,
  [SMALL_STATE(9126)] = 364802,
  [SMALL_STATE(9127)] = 364811,
  [SMALL_STATE(9128)] = 364820,
  [SMALL_STATE(9129)] = 364829,
  [SMALL_STATE(9130)] = 364838,
  [SMALL_STATE(9131)] = 364847,
  [SMALL_STATE(9132)] = 364856,
  [SMALL_STATE(9133)] = 364865,
  [SMALL_STATE(9134)] = 364874,
  [SMALL_STATE(9135)] = 364883,
  [SMALL_STATE(9136)] = 364892,
  [SMALL_STATE(9137)] = 364901,
  [SMALL_STATE(9138)] = 364910,
  [SMALL_STATE(9139)] = 364919,
  [SMALL_STATE(9140)] = 364928,
  [SMALL_STATE(9141)] = 364937,
  [SMALL_STATE(9142)] = 364946,
  [SMALL_STATE(9143)] = 364955,
  [SMALL_STATE(9144)] = 364964,
  [SMALL_STATE(9145)] = 364973,
  [SMALL_STATE(9146)] = 364982,
  [SMALL_STATE(9147)] = 364991,
  [SMALL_STATE(9148)] = 365000,
  [SMALL_STATE(9149)] = 365009,
  [SMALL_STATE(9150)] = 365018,
  [SMALL_STATE(9151)] = 365027,
  [SMALL_STATE(9152)] = 365036,
  [SMALL_STATE(9153)] = 365045,
  [SMALL_STATE(9154)] = 365054,
  [SMALL_STATE(9155)] = 365063,
  [SMALL_STATE(9156)] = 365072,
  [SMALL_STATE(9157)] = 365081,
  [SMALL_STATE(9158)] = 365090,
  [SMALL_STATE(9159)] = 365099,
  [SMALL_STATE(9160)] = 365108,
  [SMALL_STATE(9161)] = 365117,
  [SMALL_STATE(9162)] = 365126,
  [SMALL_STATE(9163)] = 365135,
  [SMALL_STATE(9164)] = 365144,
  [SMALL_STATE(9165)] = 365153,
  [SMALL_STATE(9166)] = 365162,
  [SMALL_STATE(9167)] = 365171,
  [SMALL_STATE(9168)] = 365180,
  [SMALL_STATE(9169)] = 365189,
  [SMALL_STATE(9170)] = 365198,
  [SMALL_STATE(9171)] = 365207,
  [SMALL_STATE(9172)] = 365216,
  [SMALL_STATE(9173)] = 365225,
  [SMALL_STATE(9174)] = 365234,
  [SMALL_STATE(9175)] = 365243,
  [SMALL_STATE(9176)] = 365252,
  [SMALL_STATE(9177)] = 365261,
  [SMALL_STATE(9178)] = 365270,
  [SMALL_STATE(9179)] = 365279,
  [SMALL_STATE(9180)] = 365288,
  [SMALL_STATE(9181)] = 365297,
  [SMALL_STATE(9182)] = 365306,
  [SMALL_STATE(9183)] = 365315,
  [SMALL_STATE(9184)] = 365324,
  [SMALL_STATE(9185)] = 365333,
  [SMALL_STATE(9186)] = 365342,
  [SMALL_STATE(9187)] = 365351,
  [SMALL_STATE(9188)] = 365360,
  [SMALL_STATE(9189)] = 365369,
  [SMALL_STATE(9190)] = 365378,
  [SMALL_STATE(9191)] = 365387,
  [SMALL_STATE(9192)] = 365396,
  [SMALL_STATE(9193)] = 365405,
  [SMALL_STATE(9194)] = 365414,
  [SMALL_STATE(9195)] = 365423,
  [SMALL_STATE(9196)] = 365432,
  [SMALL_STATE(9197)] = 365441,
  [SMALL_STATE(9198)] = 365450,
  [SMALL_STATE(9199)] = 365459,
  [SMALL_STATE(9200)] = 365468,
  [SMALL_STATE(9201)] = 365477,
  [SMALL_STATE(9202)] = 365486,
  [SMALL_STATE(9203)] = 365495,
  [SMALL_STATE(9204)] = 365504,
  [SMALL_STATE(9205)] = 365513,
  [SMALL_STATE(9206)] = 365522,
  [SMALL_STATE(9207)] = 365531,
  [SMALL_STATE(9208)] = 365540,
  [SMALL_STATE(9209)] = 365549,
  [SMALL_STATE(9210)] = 365558,
  [SMALL_STATE(9211)] = 365567,
  [SMALL_STATE(9212)] = 365576,
  [SMALL_STATE(9213)] = 365585,
  [SMALL_STATE(9214)] = 365594,
  [SMALL_STATE(9215)] = 365603,
  [SMALL_STATE(9216)] = 365612,
  [SMALL_STATE(9217)] = 365621,
  [SMALL_STATE(9218)] = 365630,
  [SMALL_STATE(9219)] = 365639,
  [SMALL_STATE(9220)] = 365648,
  [SMALL_STATE(9221)] = 365657,
  [SMALL_STATE(9222)] = 365666,
  [SMALL_STATE(9223)] = 365675,
  [SMALL_STATE(9224)] = 365684,
  [SMALL_STATE(9225)] = 365693,
  [SMALL_STATE(9226)] = 365702,
  [SMALL_STATE(9227)] = 365711,
  [SMALL_STATE(9228)] = 365720,
  [SMALL_STATE(9229)] = 365729,
  [SMALL_STATE(9230)] = 365738,
  [SMALL_STATE(9231)] = 365747,
  [SMALL_STATE(9232)] = 365756,
  [SMALL_STATE(9233)] = 365765,
  [SMALL_STATE(9234)] = 365774,
  [SMALL_STATE(9235)] = 365783,
  [SMALL_STATE(9236)] = 365792,
  [SMALL_STATE(9237)] = 365801,
  [SMALL_STATE(9238)] = 365810,
  [SMALL_STATE(9239)] = 365819,
  [SMALL_STATE(9240)] = 365828,
  [SMALL_STATE(9241)] = 365837,
  [SMALL_STATE(9242)] = 365846,
  [SMALL_STATE(9243)] = 365855,
  [SMALL_STATE(9244)] = 365864,
  [SMALL_STATE(9245)] = 365873,
  [SMALL_STATE(9246)] = 365882,
  [SMALL_STATE(9247)] = 365891,
  [SMALL_STATE(9248)] = 365900,
  [SMALL_STATE(9249)] = 365909,
  [SMALL_STATE(9250)] = 365918,
  [SMALL_STATE(9251)] = 365927,
  [SMALL_STATE(9252)] = 365936,
  [SMALL_STATE(9253)] = 365945,
  [SMALL_STATE(9254)] = 365954,
  [SMALL_STATE(9255)] = 365963,
  [SMALL_STATE(9256)] = 365972,
  [SMALL_STATE(9257)] = 365981,
  [SMALL_STATE(9258)] = 365990,
  [SMALL_STATE(9259)] = 365999,
  [SMALL_STATE(9260)] = 366008,
  [SMALL_STATE(9261)] = 366017,
  [SMALL_STATE(9262)] = 366026,
  [SMALL_STATE(9263)] = 366035,
  [SMALL_STATE(9264)] = 366044,
  [SMALL_STATE(9265)] = 366053,
  [SMALL_STATE(9266)] = 366062,
  [SMALL_STATE(9267)] = 366071,
  [SMALL_STATE(9268)] = 366080,
  [SMALL_STATE(9269)] = 366089,
  [SMALL_STATE(9270)] = 366098,
  [SMALL_STATE(9271)] = 366107,
  [SMALL_STATE(9272)] = 366116,
  [SMALL_STATE(9273)] = 366125,
  [SMALL_STATE(9274)] = 366134,
  [SMALL_STATE(9275)] = 366143,
  [SMALL_STATE(9276)] = 366152,
  [SMALL_STATE(9277)] = 366161,
  [SMALL_STATE(9278)] = 366170,
  [SMALL_STATE(9279)] = 366179,
  [SMALL_STATE(9280)] = 366188,
  [SMALL_STATE(9281)] = 366197,
  [SMALL_STATE(9282)] = 366206,
  [SMALL_STATE(9283)] = 366215,
  [SMALL_STATE(9284)] = 366224,
  [SMALL_STATE(9285)] = 366233,
  [SMALL_STATE(9286)] = 366242,
  [SMALL_STATE(9287)] = 366251,
  [SMALL_STATE(9288)] = 366260,
  [SMALL_STATE(9289)] = 366269,
  [SMALL_STATE(9290)] = 366278,
  [SMALL_STATE(9291)] = 366287,
  [SMALL_STATE(9292)] = 366296,
  [SMALL_STATE(9293)] = 366305,
  [SMALL_STATE(9294)] = 366314,
  [SMALL_STATE(9295)] = 366323,
  [SMALL_STATE(9296)] = 366332,
  [SMALL_STATE(9297)] = 366341,
  [SMALL_STATE(9298)] = 366350,
  [SMALL_STATE(9299)] = 366359,
  [SMALL_STATE(9300)] = 366368,
  [SMALL_STATE(9301)] = 366377,
  [SMALL_STATE(9302)] = 366386,
  [SMALL_STATE(9303)] = 366395,
  [SMALL_STATE(9304)] = 366404,
  [SMALL_STATE(9305)] = 366413,
  [SMALL_STATE(9306)] = 366422,
  [SMALL_STATE(9307)] = 366431,
  [SMALL_STATE(9308)] = 366440,
  [SMALL_STATE(9309)] = 366449,
  [SMALL_STATE(9310)] = 366458,
  [SMALL_STATE(9311)] = 366467,
  [SMALL_STATE(9312)] = 366476,
  [SMALL_STATE(9313)] = 366485,
  [SMALL_STATE(9314)] = 366494,
  [SMALL_STATE(9315)] = 366503,
  [SMALL_STATE(9316)] = 366512,
  [SMALL_STATE(9317)] = 366521,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3716),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9285),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7470),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6929),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8619),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9277),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9275),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9273),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9243),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5440),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7443),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7731),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8609),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3925),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4111),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5532),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [67] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [71] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6926),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6930),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6954),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8679),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9035),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9194),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9195),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5054),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7578),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7973),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8621),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 3, 0, 0),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 3, 0, 0),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8804),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9123),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9223),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9227),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5558),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7391),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8097),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8579),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_or_break_expression, 2, 0, 0),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_or_break_expression, 2, 0, 0),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1998),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9021),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, 0, 9),
  [203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, 0, 9),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8816),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2064),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9133),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9226),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9230),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5589),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7523),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8370),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8567),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2402),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2403),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2613),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8662),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9047),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9199),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9200),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5204),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7541),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7652),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8648),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2653),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2654),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8664),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2034),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4604),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1838),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8709),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9023),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9189),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9190),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5293),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4685),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7388),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8362),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8598),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4686),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4688),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4859),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2696),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8728),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9083),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9209),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9215),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5574),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7454),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8273),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8629),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2794),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2799),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 1, 0, 0),
  [385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 1, 0, 0),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4994),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5195),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, 0, 29),
  [405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, 0, 29),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, 0, 56),
  [411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, 0, 56),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 2, 0, 0),
  [417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 2, 0, 0),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3743),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7124),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4314),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4487),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2911),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1531),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1537),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8747),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1558),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9093),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9214),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9218),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5282),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7504),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8193),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8615),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3103),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3104),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3080),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8766),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1664),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9103),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9217),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9221),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5151),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7445),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7701),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8601),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3355),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3356),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4218),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6645),
  [599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5159),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9238),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8706),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4828),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5110),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3664),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8942),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8892),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9171),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9172),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5596),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4011),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7571),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7732),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8535),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4016),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4017),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3405),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1715),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8785),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9113),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9220),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9224),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5274),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7465),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7925),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8590),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3613),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3610),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1655),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3906),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5488),
  [717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4035),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6630),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4440),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1722),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8669),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1719),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1716),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9059),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9204),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9205),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5395),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7540),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7929),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8638),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4519),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4520),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4297),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6637),
  [773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7092),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8806),
  [779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8807),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5141),
  [783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(4781),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5570),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(552),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5309),
  [795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(5508),
  [798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8864),
  [802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8809),
  [804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9162),
  [806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(8969),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4051),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4540),
  [815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0),
  [818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0),
  [821] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(4781),
  [825] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(552),
  [829] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(5508),
  [833] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(8969),
  [837] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0),
  [840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0),
  [843] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(4781),
  [847] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(552),
  [851] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(5508),
  [855] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(8969),
  [859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0),
  [861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0),
  [863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(4781),
  [866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(552),
  [869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(5508),
  [872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(8969),
  [875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0),
  [877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0),
  [879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(4781),
  [882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(552),
  [885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(5508),
  [888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(8969),
  [891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0),
  [894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0),
  [897] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(4781),
  [901] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(552),
  [905] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(5508),
  [909] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(8969),
  [913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0),
  [915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 5, 0, 0),
  [917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(4781),
  [920] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(552),
  [923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(5508),
  [926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(8969),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4458),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4583),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6672),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7186),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8788),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8789),
  [949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5146),
  [951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(4823),
  [954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5531),
  [956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2168),
  [958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(544),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5131),
  [963] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(5514),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8860),
  [970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8791),
  [972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9161),
  [974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5525),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9013),
  [978] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(4823),
  [982] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(544),
  [986] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(5514),
  [990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(4823),
  [993] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(544),
  [996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(5514),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1796),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8690),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4579),
  [1009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(4823),
  [1012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(544),
  [1015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(5514),
  [1018] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(4823),
  [1022] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(544),
  [1026] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(5514),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4765),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [1036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1798),
  [1038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(4823),
  [1041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(544),
  [1044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(5514),
  [1047] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(4823),
  [1051] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(544),
  [1055] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(5514),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6674),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7191),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8678),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8665),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5376),
  [1071] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(4776),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5439),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2242),
  [1079] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(668),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5077),
  [1085] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(5058),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8674),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8671),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9077),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9288),
  [1099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(4776),
  [1102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(668),
  [1105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(5058),
  [1108] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(4776),
  [1112] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(668),
  [1116] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(5058),
  [1120] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(4776),
  [1124] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(668),
  [1128] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(5058),
  [1132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(4776),
  [1135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(668),
  [1138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(5058),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1745),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8699),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4582),
  [1163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(4776),
  [1166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(668),
  [1169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(5058),
  [1172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(4776),
  [1175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(668),
  [1178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(5058),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6680),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7041),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8818),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8819),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5140),
  [1193] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(4800),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5583),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2469),
  [1201] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(555),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5437),
  [1207] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(5501),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8868),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8821),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9163),
  [1219] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(8961),
  [1223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(4800),
  [1226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(555),
  [1229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(5501),
  [1232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(8961),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2081),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8828),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9142),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9232),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5186),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [1255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(4800),
  [1258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(555),
  [1261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(5501),
  [1264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(8961),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4076),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1897),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8838),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1895),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1894),
  [1277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9147),
  [1279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9229),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9234),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5268),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4227),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8554),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4256),
  [1291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4259),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4328),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7589),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7736),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4079),
  [1311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(4800),
  [1314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(555),
  [1317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(5501),
  [1320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(8961),
  [1323] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(4800),
  [1327] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(555),
  [1331] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(5501),
  [1335] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(8961),
  [1339] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(4800),
  [1343] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(555),
  [1347] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(5501),
  [1351] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(8961),
  [1355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(4800),
  [1358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(555),
  [1361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(5501),
  [1364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(8961),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4766),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4664),
  [1373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6679),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2516),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6658),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7130),
  [1381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8656),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8657),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5569),
  [1387] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(4792),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5215),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2609),
  [1395] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(594),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5174),
  [1401] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(5163),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [1407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8695),
  [1409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8661),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9089),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9106),
  [1415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(4792),
  [1418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(594),
  [1421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(5163),
  [1424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(4792),
  [1427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(594),
  [1430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(5163),
  [1433] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(4792),
  [1437] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(594),
  [1441] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(5163),
  [1445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(4792),
  [1448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(594),
  [1451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(5163),
  [1454] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(4792),
  [1458] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(594),
  [1462] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(5163),
  [1466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(4792),
  [1469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(594),
  [1472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(5163),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5267),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2716),
  [1485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6629),
  [1487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7096),
  [1489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8731),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8732),
  [1493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5271),
  [1495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(4787),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5354),
  [1500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2800),
  [1502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(562),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5375),
  [1507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(5587),
  [1510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [1512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8820),
  [1514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8734),
  [1516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9149),
  [1518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8997),
  [1520] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(4787),
  [1524] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(562),
  [1528] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(5587),
  [1532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4933),
  [1534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [1536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(4787),
  [1539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(562),
  [1542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(5587),
  [1545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(4787),
  [1548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(562),
  [1551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(5587),
  [1554] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(4787),
  [1558] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(562),
  [1562] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(5587),
  [1566] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(4787),
  [1570] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(562),
  [1574] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(5587),
  [1578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(4787),
  [1581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(562),
  [1584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(5587),
  [1587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [1589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [1591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3716),
  [1594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1085),
  [1597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(9285),
  [1600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(7470),
  [1603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(6929),
  [1606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1498),
  [1609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(8619),
  [1612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(504),
  [1615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1503),
  [1618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4616),
  [1621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1520),
  [1624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1520),
  [1627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1521),
  [1630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(704),
  [1633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(9277),
  [1636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1653),
  [1639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1655),
  [1642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(9275),
  [1645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(9273),
  [1648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(9243),
  [1651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(5440),
  [1654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4062),
  [1657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(7443),
  [1660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(7731),
  [1663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(8609),
  [1666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3925),
  [1669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(4111),
  [1672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(5532),
  [1675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2790),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6661),
  [1679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7163),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8672),
  [1683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8673),
  [1685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5334),
  [1687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(4774),
  [1690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5285),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2979),
  [1694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(569),
  [1697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5372),
  [1699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(5565),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [1704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8808),
  [1706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8675),
  [1708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9144),
  [1710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(9031),
  [1713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2902),
  [1715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6671),
  [1717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7016),
  [1719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8712),
  [1721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8713),
  [1723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5329),
  [1725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(4816),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5065),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3368),
  [1732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(599),
  [1735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5325),
  [1737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(5503),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [1742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8771),
  [1744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8715),
  [1746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9129),
  [1748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(9050),
  [1751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(4774),
  [1754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(569),
  [1757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(5565),
  [1760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(9031),
  [1763] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(4816),
  [1767] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(599),
  [1771] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(5503),
  [1775] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(9050),
  [1779] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(4816),
  [1783] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(599),
  [1787] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(5503),
  [1791] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(9050),
  [1795] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(4816),
  [1799] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(599),
  [1803] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(5503),
  [1807] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(9050),
  [1811] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(4774),
  [1815] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(569),
  [1819] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(5565),
  [1823] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(9031),
  [1827] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(4774),
  [1831] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(569),
  [1835] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(5565),
  [1839] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(9031),
  [1843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(4774),
  [1846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(569),
  [1849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(5565),
  [1852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(9031),
  [1855] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(4774),
  [1859] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(569),
  [1863] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(5565),
  [1867] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(9031),
  [1871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(4816),
  [1874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(599),
  [1877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(5503),
  [1880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(9050),
  [1883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(4816),
  [1886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(599),
  [1889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(5503),
  [1892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(9050),
  [1895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(4774),
  [1898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(569),
  [1901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(5565),
  [1904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(9031),
  [1907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(4816),
  [1910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(599),
  [1913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(5503),
  [1916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(9050),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3260),
  [1921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6642),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7136),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8769),
  [1927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8770),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5084),
  [1931] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(4811),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5273),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3612),
  [1939] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(561),
  [1943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5356),
  [1945] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(5492),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8872),
  [1953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8772),
  [1955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9164),
  [1957] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(8958),
  [1961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(4811),
  [1964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(561),
  [1967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(5492),
  [1970] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(8958),
  [1973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3424),
  [1975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6650),
  [1977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6990),
  [1979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8691),
  [1981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8688),
  [1983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5403),
  [1985] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(4818),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5277),
  [1991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3689),
  [1993] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(585),
  [1997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5427),
  [1999] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(5210),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8676),
  [2007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8686),
  [2009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9041),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9315),
  [2013] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(4818),
  [2017] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(585),
  [2021] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(5210),
  [2025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(4818),
  [2028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(585),
  [2031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(5210),
  [2034] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(4818),
  [2038] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(585),
  [2042] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(5210),
  [2046] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(4811),
  [2050] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(561),
  [2054] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(5492),
  [2058] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(8958),
  [2062] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(4811),
  [2066] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(561),
  [2070] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(5492),
  [2074] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(8958),
  [2078] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(4818),
  [2081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(585),
  [2084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(5210),
  [2087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(4811),
  [2090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(561),
  [2093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(5492),
  [2096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(8958),
  [2099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(4811),
  [2102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(561),
  [2105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(5492),
  [2108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(8958),
  [2111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(4818),
  [2114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(585),
  [2117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(5210),
  [2120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(4811),
  [2123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(561),
  [2126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(5492),
  [2129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(8958),
  [2132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(4818),
  [2135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(585),
  [2138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(5210),
  [2141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3520),
  [2143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6641),
  [2145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7065),
  [2147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8693),
  [2149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8694),
  [2151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5374),
  [2153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(4773),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5383),
  [2158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3752),
  [2160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(632),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5177),
  [2165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(5467),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [2170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8752),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8696),
  [2174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9119),
  [2176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5051),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9182),
  [2180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(4773),
  [2183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(632),
  [2186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(5467),
  [2189] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(4773),
  [2193] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(632),
  [2197] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(5467),
  [2201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(4773),
  [2204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(632),
  [2207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(5467),
  [2210] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(4773),
  [2214] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(632),
  [2218] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(5467),
  [2222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(4773),
  [2225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(632),
  [2228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(5467),
  [2231] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(4773),
  [2235] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(632),
  [2239] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(5467),
  [2243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3498),
  [2245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6640),
  [2247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7207),
  [2249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8938),
  [2251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8937),
  [2253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5434),
  [2255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(4820),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5588),
  [2260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3769),
  [2262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(607),
  [2265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5292),
  [2267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(5284),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [2272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8935),
  [2274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8932),
  [2276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8903),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9289),
  [2280] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(4820),
  [2284] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(607),
  [2288] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(5284),
  [2292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3589),
  [2294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6639),
  [2296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7120),
  [2298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9070),
  [2300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9066),
  [2302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5373),
  [2304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(4799),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5281),
  [2309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3912),
  [2311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(609),
  [2314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5272),
  [2316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(5593),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [2321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9046),
  [2323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9042),
  [2325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9040),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9100),
  [2329] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(4820),
  [2333] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(607),
  [2337] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(5284),
  [2341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(4799),
  [2344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(609),
  [2347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(5593),
  [2350] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(4799),
  [2354] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(609),
  [2358] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(5593),
  [2362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(4820),
  [2365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(607),
  [2368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(5284),
  [2371] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(4799),
  [2375] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(609),
  [2379] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(5593),
  [2383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(4820),
  [2386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(607),
  [2389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(5284),
  [2392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(4820),
  [2395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(607),
  [2398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(5284),
  [2401] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(4820),
  [2405] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(607),
  [2409] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(5284),
  [2413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(4799),
  [2416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(609),
  [2419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(5593),
  [2422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(4799),
  [2425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(609),
  [2428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(5593),
  [2431] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(4799),
  [2435] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(609),
  [2439] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(5593),
  [2443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3911),
  [2445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6659),
  [2447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6982),
  [2449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8829),
  [2451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8830),
  [2453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5138),
  [2455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(4824),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5560),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4278),
  [2462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(567),
  [2465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5455),
  [2467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(5480),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4276),
  [2472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8876),
  [2474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8832),
  [2476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9165),
  [2478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5562),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8974),
  [2482] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(4824),
  [2486] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(567),
  [2490] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(5480),
  [2494] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(4824),
  [2498] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(567),
  [2502] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(5480),
  [2506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(4824),
  [2509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(567),
  [2512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(5480),
  [2515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(4824),
  [2518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(567),
  [2521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(5480),
  [2524] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(4824),
  [2528] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(567),
  [2532] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(5480),
  [2536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(4824),
  [2539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(567),
  [2542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(5480),
  [2545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4098),
  [2547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6666),
  [2549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7087),
  [2551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8651),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8652),
  [2555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5337),
  [2557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(4812),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5406),
  [2562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4572),
  [2564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(651),
  [2567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5328),
  [2569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(5347),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4570),
  [2574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8714),
  [2576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8654),
  [2578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9099),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9088),
  [2582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3893),
  [2584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6631),
  [2586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6951),
  [2588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8839),
  [2590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8840),
  [2592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5385),
  [2594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(4789),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5265),
  [2599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4210),
  [2601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(592),
  [2604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5310),
  [2606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(5444),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4209),
  [2611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8889),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8842),
  [2615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9169),
  [2617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(8945),
  [2620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(4812),
  [2623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(651),
  [2626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(5347),
  [2629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(4789),
  [2632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(592),
  [2635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(5444),
  [2638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(8945),
  [2641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(4789),
  [2644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(592),
  [2647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(5444),
  [2650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(8945),
  [2653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(4789),
  [2656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(592),
  [2659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(5444),
  [2662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(8945),
  [2665] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(4789),
  [2669] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(592),
  [2673] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(5444),
  [2677] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(8945),
  [2681] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(4789),
  [2685] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(592),
  [2689] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(5444),
  [2693] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(8945),
  [2697] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(4812),
  [2701] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(651),
  [2705] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(5347),
  [2709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(4812),
  [2712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(651),
  [2715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(5347),
  [2718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(4812),
  [2721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(651),
  [2724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(5347),
  [2727] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(4812),
  [2731] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(651),
  [2735] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(5347),
  [2739] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(4812),
  [2743] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(651),
  [2747] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(5347),
  [2751] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(4789),
  [2755] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(592),
  [2759] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(5444),
  [2763] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(8945),
  [2767] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(2790),
  [2770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6651),
  [2772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5187),
  [2774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(588),
  [2777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5197),
  [2779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(5454),
  [2782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8886),
  [2784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9168),
  [2786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(8947),
  [2789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(2790),
  [2792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(588),
  [2795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(5454),
  [2798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(8947),
  [2801] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(2790),
  [2805] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(588),
  [2809] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(5454),
  [2813] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(8947),
  [2817] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(2790),
  [2821] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(588),
  [2825] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(5454),
  [2829] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(8947),
  [2833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(2790),
  [2836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(588),
  [2839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(5454),
  [2842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(8947),
  [2845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(2790),
  [2848] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(588),
  [2851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(5454),
  [2854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(8947),
  [2857] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(2790),
  [2861] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(588),
  [2865] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(5454),
  [2869] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(8947),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [2877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [2879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [2889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [2891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6624),
  [2893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6928),
  [2895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4956),
  [2897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7497),
  [2899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5160),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5580),
  [2907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [2909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6619),
  [2911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6917),
  [2913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4926),
  [2915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7551),
  [2917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5457),
  [2919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5453),
  [2921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [2923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 5, 0, 0),
  [2925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 5, 0, 0),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [2929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1, 0, 0),
  [2931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 1, 0, 0),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4495),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4099),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5479),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5477),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [2949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [2953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [2955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [2965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4713),
  [2969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 4, 0, 0),
  [2971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 4, 0, 0),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4759),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4711),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4672),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4442),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [3015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [3029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4541),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4736),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3936),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [3079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4703),
  [3081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4005),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [3093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4026),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2810),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4636),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3464),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4052),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3628),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3554),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4577),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4537),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4532),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5368),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5370),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5378),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4475),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4486),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4470),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4511),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4435),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4120),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [3165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4721),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5333),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4409),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [3183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4121),
  [3189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [3193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4623),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [3201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [3203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [3205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [3207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4612),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [3213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [3219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [3221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [3223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [3225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [3231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [3239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [3241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [3243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [3245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [3247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4094),
  [3249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3059),
  [3253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [3255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4090),
  [3257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [3259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [3261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [3263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [3265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [3267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [3269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [3271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [3273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4653),
  [3277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [3279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [3281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4644),
  [3283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4295),
  [3285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [3287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4625),
  [3289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [3291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [3293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [3295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4638),
  [3297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [3299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [3301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2679),
  [3303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [3307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [3309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [3311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [3313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [3315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [3317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [3319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [3321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [3323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [3325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [3331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4303),
  [3333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4635),
  [3335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4273),
  [3337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4725),
  [3339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [3341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [3343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4642),
  [3345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4624),
  [3347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4115),
  [3349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [3351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4123),
  [3353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4372),
  [3355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [3357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4371),
  [3359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4370),
  [3361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [3363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4348),
  [3365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4346),
  [3367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4339),
  [3369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4338),
  [3371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4333),
  [3373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [3375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [3377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4748),
  [3379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [3381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [3383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 6, 0, 0),
  [3385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4, 0, 0),
  [3387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 5, 0, 0),
  [3389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 7, 0, 0),
  [3391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [3393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3964),
  [3395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [3397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4607),
  [3399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5139),
  [3401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [3403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [3407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5749),
  [3409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3421),
  [3411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8912),
  [3413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8912),
  [3415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 4, 0, 0),
  [3417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [3419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [3421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 4, 0, 0),
  [3423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [3425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5364),
  [3427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [3429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [3431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [3433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5781),
  [3435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4476),
  [3437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9274),
  [3439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9274),
  [3441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [3443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5624),
  [3445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8874),
  [3449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8874),
  [3451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [3453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5618),
  [3455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [3457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8866),
  [3459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8866),
  [3461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5652),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [3467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8921),
  [3469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8921),
  [3471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [3473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5627),
  [3475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [3477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8885),
  [3479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8885),
  [3481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [3483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5611),
  [3485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8837),
  [3489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8837),
  [3491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [3493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5632),
  [3495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [3497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8893),
  [3499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8893),
  [3501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [3503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5626),
  [3505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [3507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8879),
  [3509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8879),
  [3511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [3513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5636),
  [3515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [3517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8898),
  [3519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8898),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [3523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5640),
  [3525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [3527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8905),
  [3529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8905),
  [3531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [3533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5615),
  [3535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4585),
  [3537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8863),
  [3539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8863),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [3543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5635),
  [3545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [3547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8895),
  [3549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8895),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [3553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5647),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [3557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8907),
  [3559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8907),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5609),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8835),
  [3569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8835),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5688),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [3577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8705),
  [3579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8705),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [3583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5605),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [3587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8827),
  [3589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8827),
  [3591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5771),
  [3595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [3597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9154),
  [3599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9154),
  [3601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [3603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5651),
  [3605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8916),
  [3609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8916),
  [3611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5644),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [3617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8906),
  [3619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8906),
  [3621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [3623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5654),
  [3625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8922),
  [3629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8922),
  [3631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [3633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5661),
  [3635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [3637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8929),
  [3639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8929),
  [3641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [3643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5725),
  [3645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [3647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8802),
  [3649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8802),
  [3651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [3653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5689),
  [3655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [3657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8972),
  [3659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8972),
  [3661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5663),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [3667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8931),
  [3669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8931),
  [3671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 7, 0, 0),
  [3673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [3675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 7, 0, 0),
  [3677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [3679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [3681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [3683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5603),
  [3685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [3687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8800),
  [3689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8800),
  [3691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5666),
  [3695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [3697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8943),
  [3699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8943),
  [3701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [3703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5608),
  [3705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [3707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8794),
  [3709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8794),
  [3711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [3713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5625),
  [3715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8781),
  [3719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8781),
  [3721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [3723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5662),
  [3725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [3727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8930),
  [3729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8930),
  [3731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [3733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5653),
  [3735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [3737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8755),
  [3739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8755),
  [3741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [3743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5672),
  [3745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [3747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8949),
  [3749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8949),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5678),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [3757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8956),
  [3759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8956),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5667),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8946),
  [3769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8946),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5634),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8773),
  [3779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8773),
  [3781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 3, 0, 0),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4928),
  [3785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 3, 0, 0),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [3789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [3791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5680),
  [3795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [3797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8959),
  [3799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8959),
  [3801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5649),
  [3805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8759),
  [3809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8759),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [3813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5685),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4343),
  [3817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8970),
  [3819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8970),
  [3821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [3823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5679),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [3827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8957),
  [3829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8957),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5690),
  [3835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4345),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8975),
  [3839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8975),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5720),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8736),
  [3849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8736),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5659),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8748),
  [3859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8748),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [3863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5698),
  [3865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3857),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8979),
  [3869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8979),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [3873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5733),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8716),
  [3879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8716),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5700),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4351),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8980),
  [3889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8980),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5646),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9112),
  [3901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9112),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5731),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [3909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8707),
  [3911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8707),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5759),
  [3917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4763),
  [3919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8743),
  [3921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8743),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5607),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [3929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9079),
  [3931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9079),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [3935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5616),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9097),
  [3941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9097),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5701),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8999),
  [3951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8999),
  [3953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5706),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8987),
  [3961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8987),
  [3963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5707),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [3969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8989),
  [3971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8989),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [3975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5709),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [3979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8990),
  [3981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8990),
  [3983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5752),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8810),
  [3991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8810),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5715),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8995),
  [4001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8995),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5716),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9000),
  [4011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9000),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [4015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5630),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9197),
  [4021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9197),
  [4023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 6, 0, 0),
  [4025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 6, 0, 0),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5719),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9004),
  [4041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9004),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5695),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [4049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8692),
  [4051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8692),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [4055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5656),
  [4057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [4059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9180),
  [4061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9180),
  [4063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5770),
  [4067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4809),
  [4069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8793),
  [4071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8793),
  [4073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [4075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5660),
  [4077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9170),
  [4081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9170),
  [4083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 5, 0, 0),
  [4085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 5, 0, 0),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5773),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [4099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9015),
  [4101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9015),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5633),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8684),
  [4111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8684),
  [4113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 2, 0, 0),
  [4115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4919),
  [4117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 2, 0, 0),
  [4119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [4125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5744),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [4129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8878),
  [4131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8878),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5777),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8813),
  [4141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8813),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [4151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5613),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4265),
  [4155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8666),
  [4157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8666),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5751),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8730),
  [4167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8730),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5747),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [4175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8726),
  [4177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8726),
  [4179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [4185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [4187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 0),
  [4189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8749),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5741),
  [4195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4054),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8724),
  [4199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8724),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [4205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5619),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [4217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8867),
  [4219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8867),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5734),
  [4225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4341),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9279),
  [4229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9279),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5718),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8719),
  [4239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8719),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5774),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9027),
  [4249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9027),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5740),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [4261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8722),
  [4263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8722),
  [4265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5266),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5723),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8746),
  [4275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8746),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5732),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9033),
  [4285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9033),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4983),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5754),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4494),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9045),
  [4305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9045),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5778),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4756),
  [4313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8826),
  [4315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8826),
  [4317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [4319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [4321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5622),
  [4323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4284),
  [4325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8782),
  [4327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8782),
  [4329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5007),
  [4331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [4333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [4335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5772),
  [4337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8797),
  [4341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8797),
  [4343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5767),
  [4347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4801),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8951),
  [4351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8951),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5724),
  [4357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4427),
  [4359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9006),
  [4361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9006),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [4365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5776),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [4369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9207),
  [4371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9207),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [4375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [4377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [4379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5705),
  [4381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [4383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8986),
  [4385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8986),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5783),
  [4391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [4393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8817),
  [4395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8817),
  [4397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [4399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5755),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [4403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9043),
  [4405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9043),
  [4407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5691),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8704),
  [4415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8704),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5610),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4758),
  [4421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8965),
  [4423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8965),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5005),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [4429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5760),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4761),
  [4437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8650),
  [4439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8650),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [4443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5775),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9014),
  [4449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9014),
  [4451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [4453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0),
  [4455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0),
  [4457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8749),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5748),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8882),
  [4468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8882),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5637),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8767),
  [4478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8767),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5785),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9003),
  [4488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9003),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [4494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_type, 2, 0, 0),
  [4496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_type, 2, 0, 0),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5628),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8778),
  [4506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8778),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5756),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3442),
  [4514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8925),
  [4516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8925),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4894),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [4526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5604),
  [4528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8799),
  [4532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8799),
  [4534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_type, 2, 0, 0),
  [4536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_type, 2, 0, 0),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5673),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5494),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9125),
  [4544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9125),
  [4546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_type, 3, 0, 0),
  [4548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_type, 3, 0, 0),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5768),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5149),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8897),
  [4556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8897),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5726),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5489),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9135),
  [4564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9135),
  [4566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_type, 4, 0, 0),
  [4568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_type, 4, 0, 0),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5686),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5506),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9115),
  [4576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9115),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5699),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5519),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9105),
  [4584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9105),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [4588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9111),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [4592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5671),
  [4594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5553),
  [4596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9095),
  [4598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9095),
  [4600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0),
  [4602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(1018),
  [4605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_no_tag, 1, 0, 0),
  [4607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(8451),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5739),
  [4612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5556),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9085),
  [4616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9085),
  [4618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_type_repeat2, 2, 0, 0),
  [4620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_type_repeat2, 2, 0, 0), SHIFT_REPEAT(7260),
  [4623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_struct_type_repeat2, 2, 0, 0),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5753),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5581),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9073),
  [4631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9073),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5761),
  [4635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5592),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9061),
  [4639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9061),
  [4641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [4643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7558),
  [4645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6909),
  [4647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1925),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [4653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5780),
  [4655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5573),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9049),
  [4659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9049),
  [4661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 3, 0, 0),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [4665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_clause, 3, 0, 0),
  [4667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 8, 0, 0),
  [4669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 8, 0, 0),
  [4671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [4673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5782),
  [4675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5547),
  [4677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9037),
  [4679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9037),
  [4681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [4683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5710),
  [4685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5446),
  [4687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9090),
  [4689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9090),
  [4691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 9, 0, 0),
  [4693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 9, 0, 0),
  [4695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [4697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_or_continue_expression, 2, 0, 0),
  [4699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [4701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_or_continue_expression, 2, 0, 0),
  [4703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5600),
  [4705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5526),
  [4707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9025),
  [4709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9025),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [4713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [4715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [4717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0),
  [4719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1496),
  [4722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [4726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [4728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 2, 0, 0),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [4732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_clause, 2, 0, 0),
  [4734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1903),
  [4736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [4738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [4740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [4742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [4746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [4748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [4752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [4754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [4756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [4758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1915),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [4762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [4774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4050),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5730),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9075),
  [4782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9075),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5350),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5668),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8740),
  [4792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8740),
  [4794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5655),
  [4796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8754),
  [4798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8754),
  [4800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_type, 5, 0, 0),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [4804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_type, 5, 0, 0),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4129),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5669),
  [4810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8948),
  [4812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8948),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5684),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8966),
  [4818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8966),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4714),
  [4822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5763),
  [4826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9110),
  [4828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9110),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5764),
  [4832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9120),
  [4834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9120),
  [4836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [4838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [4840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4771),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5717),
  [4844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9183),
  [4846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9183),
  [4848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [4850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5687),
  [4852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9145),
  [4854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9145),
  [4856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_type_repeat2, 3, 0, 0),
  [4858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_struct_type_repeat2, 3, 0, 0),
  [4860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [4862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_type, 5, 0, 0),
  [4864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_type, 5, 0, 0),
  [4866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5670),
  [4868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9150),
  [4870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9150),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4677),
  [4874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5692),
  [4876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9146),
  [4878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9146),
  [4880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5766),
  [4882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8847),
  [4884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8847),
  [4886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5769),
  [4888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8836),
  [4890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8836),
  [4892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [4894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5697),
  [4896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9128),
  [4898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9128),
  [4900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5623),
  [4902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8871),
  [4904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8871),
  [4906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4645),
  [4908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3931),
  [4910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [4912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5784),
  [4914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9002),
  [4916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9002),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [4920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1, 0, 0),
  [4922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1, 0, 0),
  [4924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [4926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1, 0, 0),
  [4928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean, 1, 0, 0),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5758),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8738),
  [4934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8738),
  [4936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5757),
  [4938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8735),
  [4940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8735),
  [4942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5779),
  [4944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8994),
  [4946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8994),
  [4948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nil, 1, 0, 0),
  [4950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nil, 1, 0, 0),
  [4952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [4954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [4956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5742),
  [4960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8899),
  [4962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8899),
  [4964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5738),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8875),
  [4968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8875),
  [4970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 0),
  [4972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 0),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5713),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8689),
  [4978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8689),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5708),
  [4984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8670),
  [4986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8670),
  [4988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 2, 0, 0),
  [4990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 2, 0, 0),
  [4992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 2),
  [4994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 2),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5682),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8708),
  [5000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8708),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5676),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8717),
  [5006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8717),
  [5008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5645),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8761),
  [5014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8761),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5642),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8764),
  [5020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8764),
  [5022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5727),
  [5024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8729),
  [5026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8729),
  [5028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5617),
  [5030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8786),
  [5032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8786),
  [5034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5601),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8803),
  [5038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8803),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5602),
  [5042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8815),
  [5044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8815),
  [5046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5612),
  [5048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8844),
  [5050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8844),
  [5052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5614),
  [5054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8850),
  [5056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8850),
  [5058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 2, 0, 0),
  [5060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 2, 0, 0),
  [5062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5620),
  [5064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8870),
  [5066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8870),
  [5068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [5070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5629),
  [5072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8888),
  [5074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8888),
  [5076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5631),
  [5078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8891),
  [5080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8891),
  [5082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5638),
  [5084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8901),
  [5086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8901),
  [5088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5639),
  [5090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8904),
  [5092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8904),
  [5094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 2, 0, 0),
  [5096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 2, 0, 0),
  [5098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 2, 0, 0),
  [5100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 2, 0, 0),
  [5102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4327),
  [5104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5648),
  [5106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8909),
  [5108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8909),
  [5110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_expression, 2, 0, 0),
  [5112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variadic_expression, 2, 0, 0),
  [5114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5650),
  [5118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8913),
  [5120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8913),
  [5122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4344),
  [5124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4364),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5641),
  [5128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9108),
  [5130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9108),
  [5132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), REDUCE(sym_array_type, 6, 0, 0),
  [5135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 5, 0, 0), REDUCE(sym_array_type, 6, 0, 0),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5657),
  [5140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8924),
  [5142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8924),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4378),
  [5146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5658),
  [5148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8926),
  [5150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8926),
  [5152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal, 2, 0, 0),
  [5154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal, 2, 0, 0),
  [5156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal, 2, 0, 0),
  [5158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal, 2, 0, 0),
  [5160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5664),
  [5162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8854),
  [5164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8854),
  [5166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4321),
  [5168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_or_return_expression, 2, 0, 0),
  [5170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_or_return_expression, 2, 0, 0),
  [5172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5665),
  [5174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8939),
  [5176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8939),
  [5178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5675),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8950),
  [5182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8950),
  [5184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [5186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4350),
  [5188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5677),
  [5190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8953),
  [5192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8953),
  [5194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4280),
  [5196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [5198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [5200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_address, 2, 0, 0),
  [5202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_address, 2, 0, 0),
  [5204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 3, 0, 0),
  [5206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 3, 0, 0),
  [5208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5681),
  [5212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8960),
  [5214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8960),
  [5216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [5218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5683),
  [5224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8964),
  [5226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8964),
  [5228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [5230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [5232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5693),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8976),
  [5236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8976),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [5244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type, 2, 0, 0),
  [5246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variadic_type, 2, 0, 0),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5696),
  [5252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8977),
  [5254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8977),
  [5256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string_literal, 3, 0, 0),
  [5258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string_literal, 3, 0, 0),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5702),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8982),
  [5264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8982),
  [5266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__raw_string_literal, 3, 0, 0),
  [5268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__raw_string_literal, 3, 0, 0),
  [5270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character, 3, 0, 0),
  [5272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character, 3, 0, 0),
  [5274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit_field_type, 11, 0, 0),
  [5276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bit_field_type, 11, 0, 0),
  [5278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit_field_type, 10, 0, 0),
  [5280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bit_field_type, 10, 0, 0),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5703),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8983),
  [5288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8983),
  [5290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [5292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5712),
  [5294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8991),
  [5296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8991),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5714),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8992),
  [5302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8992),
  [5304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5721),
  [5306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9005),
  [5308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9005),
  [5310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5599),
  [5312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9010),
  [5314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9010),
  [5316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [5318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5621),
  [5320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9016),
  [5322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9016),
  [5324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [5326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5728),
  [5328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9017),
  [5330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9017),
  [5332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit_field_type, 9, 0, 0),
  [5334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bit_field_type, 9, 0, 0),
  [5336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_type, 8, 0, 0),
  [5338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_type, 8, 0, 0),
  [5340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_type, 7, 0, 0),
  [5342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_type, 7, 0, 0),
  [5344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_type, 7, 0, 0),
  [5346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_type, 7, 0, 0),
  [5348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, 0, 4),
  [5350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, 0, 4),
  [5352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [5354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selector_call_expression, 3, 0, 4),
  [5356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selector_call_expression, 3, 0, 4),
  [5358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 5),
  [5360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 5),
  [5362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [5364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [5366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit_set_type, 6, 0, 0),
  [5368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bit_set_type, 6, 0, 0),
  [5370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 6, 0, 0),
  [5372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 6, 0, 0),
  [5374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_type, 6, 0, 0),
  [5376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_type, 6, 0, 0),
  [5378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix_type, 7, 0, 0),
  [5380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix_type, 7, 0, 0),
  [5382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 6, 0, 0),
  [5384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 6, 0, 0),
  [5386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_type, 3, 0, 0),
  [5388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6474),
  [5390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_type, 3, 0, 0),
  [5392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [5396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_polymorphic_type, 5, 0, 0),
  [5398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_polymorphic_type, 5, 0, 0),
  [5400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5, 0, 0),
  [5402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5, 0, 0),
  [5404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [5406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [5408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 5, 0, 0),
  [5410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 5, 0, 0),
  [5412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_type, 5, 0, 0),
  [5414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_type, 5, 0, 0),
  [5416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_polymorphic_type, 4, 0, 0),
  [5418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_polymorphic_type, 4, 0, 0),
  [5420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_in_expression, 3, 0, 0),
  [5422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_in_expression, 3, 0, 0),
  [5424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [5428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit_set_type, 4, 0, 0),
  [5430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bit_set_type, 4, 0, 0),
  [5432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [5434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [5436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 4, 0, 0),
  [5438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 4, 0, 0),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [5442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [5444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_type, 4, 0, 0),
  [5446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_type, 4, 0, 0),
  [5448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_specialized_type, 3, 0, 0),
  [5450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_specialized_type, 3, 0, 0),
  [5452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [5454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [5456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 9, 0, 0),
  [5458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 9, 0, 0),
  [5460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [5464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_distinct_type, 3, 0, 0),
  [5466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_distinct_type, 3, 0, 0),
  [5468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_type, 2, 0, 0),
  [5470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_type, 2, 0, 0),
  [5472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2, 0, 0),
  [5474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2, 0, 0),
  [5476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [5478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [5480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4126),
  [5482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_distinct_type, 2, 0, 0),
  [5484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_distinct_type, 2, 0, 0),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [5488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_type, 1, 0, 0),
  [5490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_type, 1, 0, 0),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [5494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [5496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 10, 0, 0),
  [5498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 10, 0, 0),
  [5500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4639),
  [5502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [5504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [5508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [5510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5606),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9060),
  [5514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9060),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [5520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [5522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__procedure_type, 1, 0, 1),
  [5524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__procedure_type, 1, 0, 1),
  [5526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 5, 0, 0),
  [5528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 5, 0, 0),
  [5530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [5532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [5534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4489),
  [5536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 0, 0),
  [5538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 0, 0),
  [5540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [5542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 4, 0, 0),
  [5544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 4, 0, 0),
  [5546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3930),
  [5548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [5550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [5552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 0),
  [5554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [5556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [5558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 3, 0, 0),
  [5560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3, 0, 0),
  [5562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [5564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [5566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 0),
  [5568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2, 0, 0),
  [5570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_or_continue_expression, 3, 0, 6),
  [5572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_or_continue_expression, 3, 0, 6),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4083),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [5580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 0),
  [5582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, 0, 0),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [5586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 4, 0, 0),
  [5588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 4, 0, 0),
  [5590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4128),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [5596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [5600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, 0, 0),
  [5602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, 0, 0),
  [5604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [5606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, 0, 0),
  [5608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4, 0, 0),
  [5610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, 0, 10),
  [5612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, 0, 10),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [5616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 5, 0, 0),
  [5618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 5, 0, 0),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [5622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [5624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 4, 0, 0),
  [5626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 4, 0, 0),
  [5628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4, 0, 0),
  [5630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4, 0, 0),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [5634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 5, 0, 0),
  [5636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 5, 0, 0),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [5640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix, 12, 0, 0),
  [5642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix, 12, 0, 0),
  [5644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 5, 0, 0),
  [5646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 5, 0, 0),
  [5648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [5650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map, 12, 0, 0),
  [5652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map, 12, 0, 0),
  [5654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix, 11, 0, 0),
  [5656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix, 11, 0, 0),
  [5658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map, 11, 0, 0),
  [5660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map, 11, 0, 0),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [5666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 10, 0, 0),
  [5668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 10, 0, 0),
  [5670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 5, 0, 9),
  [5672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 5, 0, 9),
  [5674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix, 10, 0, 0),
  [5676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix, 10, 0, 0),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [5688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map, 10, 0, 0),
  [5690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map, 10, 0, 0),
  [5692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 5, 0, 15),
  [5694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 5, 0, 15),
  [5696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 9, 0, 60),
  [5698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 9, 0, 60),
  [5700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix, 9, 0, 0),
  [5702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix, 9, 0, 0),
  [5704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 8, 0, 17),
  [5706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 8, 0, 17),
  [5708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 5, 0, 17),
  [5710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 5, 0, 17),
  [5712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 8, 0, 60),
  [5714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 8, 0, 60),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [5718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, 0, 21),
  [5720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5, 0, 21),
  [5722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 8, 0, 45),
  [5724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 8, 0, 45),
  [5726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit_set, 8, 0, 0),
  [5728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bit_set, 8, 0, 0),
  [5730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 8, 0, 0),
  [5732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 8, 0, 0),
  [5734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 7, 0, 30),
  [5736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 7, 0, 30),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5762),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8757),
  [5742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8757),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [5746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 7, 0, 17),
  [5748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 7, 0, 17),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [5752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 7, 0, 45),
  [5754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 7, 0, 45),
  [5756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 7, 0, 9),
  [5758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 7, 0, 9),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4743),
  [5764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 5, 0, 19),
  [5766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 5, 0, 19),
  [5768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 5, 0, 20),
  [5770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 5, 0, 20),
  [5772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_or_break_expression, 3, 0, 0),
  [5774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_or_break_expression, 3, 0, 0),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4689),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [5780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [5782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit_set, 7, 0, 0),
  [5784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bit_set, 7, 0, 0),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5750),
  [5788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8727),
  [5790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8727),
  [5792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [5794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [5796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [5798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5736),
  [5800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8721),
  [5802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8721),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5735),
  [5806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8718),
  [5808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8718),
  [5810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 6, 0, 0),
  [5812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 6, 0, 0),
  [5814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [5816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4040),
  [5818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [5820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit_set, 6, 0, 0),
  [5822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bit_set, 6, 0, 0),
  [5824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 6, 0, 9),
  [5826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 6, 0, 9),
  [5828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4679),
  [5836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2888),
  [5838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [5840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 6, 0, 15),
  [5842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 6, 0, 15),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [5846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 6, 0, 17),
  [5848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 6, 0, 17),
  [5850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 6, 0, 30),
  [5852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 6, 0, 30),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4399),
  [5856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map, 7, 0, 0),
  [5858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map, 7, 0, 0),
  [5860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4546),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4558),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4498),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [5872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 6, 0, 0),
  [5874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 6, 0, 0),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4413),
  [5878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 7, 0, 0),
  [5880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 7, 0, 0),
  [5882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 6, 0, 31),
  [5884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 6, 0, 31),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4419),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4630),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4501),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4485),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4447),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4561),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7157),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4400),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4398),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4424),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4027),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2877),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2880),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [5942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [5948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4641),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2660),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [5970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8698),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [5976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [5980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [5982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6941),
  [5984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [5988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [5990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [5994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [5996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [5998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [6000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [6002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [6006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8698),
  [6009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [6011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [6013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [6019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [6021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [6023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [6025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [6027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [6029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [6031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [6033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [6035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [6037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [6039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [6041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [6043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [6045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [6047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [6049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [6051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7001),
  [6053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [6055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [6057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [6059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [6061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [6063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [6065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [6067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [6069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [6071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [6073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [6075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [6077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [6079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4283),
  [6081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7147),
  [6083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4384),
  [6085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4377),
  [6087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4363),
  [6089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [6091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4326),
  [6093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4000),
  [6095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [6097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4324),
  [6099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [6101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4323),
  [6103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [6105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [6107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [6109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [6111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [6113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4077),
  [6115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [6117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4078),
  [6119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [6121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [6123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4141),
  [6125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [6127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4661),
  [6129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4651),
  [6131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4649),
  [6133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [6137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [6139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [6141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7107),
  [6143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4106),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3997),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [6149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [6151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [6153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [6155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4709),
  [6157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [6163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [6165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [6169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [6171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5442),
  [6173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [6175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [6177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [6179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [6181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [6183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [6185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4890),
  [6187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [6189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [6191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4957),
  [6193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [6195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [6197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5817),
  [6199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6041),
  [6201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [6203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [6205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [6207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [6209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [6211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [6213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [6215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [6217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [6219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [6221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [6223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [6225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5805),
  [6227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6044),
  [6229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [6231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5835),
  [6233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6016),
  [6235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5812),
  [6237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6031),
  [6239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [6241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [6243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [6245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5829),
  [6247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6020),
  [6249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [6251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [6253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5793),
  [6255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6022),
  [6257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [6259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [6261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [6263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [6265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5456),
  [6267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8774),
  [6269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5845),
  [6271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6001),
  [6273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [6275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [6277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5851),
  [6279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5994),
  [6281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5834),
  [6283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6023),
  [6285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5846),
  [6287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6002),
  [6289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4320),
  [6291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [6293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5841),
  [6295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6014),
  [6297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3827),
  [6299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [6301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4875),
  [6303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [6305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [6307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [6309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5026),
  [6311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [6313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [6315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8774),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [6320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4524),
  [6322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [6324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5800),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6034),
  [6332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_type_repeat2, 2, 0, 0), SHIFT_REPEAT(7382),
  [6335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [6337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5816),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4580),
  [6341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [6343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(8606),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5809),
  [6348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6039),
  [6350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9081),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5802),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6025),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5838),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7382),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [6362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(9081),
  [6365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5849),
  [6367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5993),
  [6369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2401),
  [6371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [6373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1510),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [6386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [6388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [6390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [6392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [6394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [6398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2080),
  [6400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2077),
  [6402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [6404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [6406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2073),
  [6408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [6410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2053),
  [6412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [6414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [6416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [6418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [6420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [6422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [6426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2251),
  [6428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [6430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5203),
  [6432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(964),
  [6435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(8414),
  [6438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9091),
  [6440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [6442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [6444] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_type_repeat2, 2, 0, 0), SHIFT_REPEAT(7377),
  [6447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [6449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9316),
  [6451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [6453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2290),
  [6455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6827),
  [6457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4820),
  [6459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [6461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [6463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5414),
  [6465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5040),
  [6467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9071),
  [6469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9036),
  [6471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9210),
  [6473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5351),
  [6475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8963),
  [6477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [6479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [6481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5089),
  [6483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [6485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [6487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [6489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [6491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [6493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [6495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [6497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [6499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [6501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [6503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [6505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [6507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [6509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2890),
  [6511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [6513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1971),
  [6515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1970),
  [6517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1969),
  [6519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [6521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [6523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [6525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [6527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [6529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [6531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1968),
  [6533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [6535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1967),
  [6537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1966),
  [6539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [6541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [6543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [6545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [6547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [6549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2231),
  [6551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [6553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [6555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [6557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [6559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4949),
  [6561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [6563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [6565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4862),
  [6567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2897),
  [6569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [6571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6482),
  [6573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [6575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [6577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [6579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [6581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [6583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [6585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(9262),
  [6588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9262),
  [6590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [6592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [6594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [6596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [6598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2029),
  [6600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [6602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [6604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [6606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [6608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [6610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [6612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [6614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [6616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2024),
  [6618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [6620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [6622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [6624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [6626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [6628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [6630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_type_repeat2, 2, 0, 0), SHIFT_REPEAT(7248),
  [6633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [6635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [6637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [6639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [6643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [6647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [6649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5214),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [6653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2693),
  [6655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9286),
  [6657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [6659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(1083),
  [6662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(8628),
  [6665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [6667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [6669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2040),
  [6671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [6673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [6675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [6677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [6679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [6681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [6683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [6685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [6687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [6689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [6691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [6693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [6695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1987),
  [6697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [6699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [6701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [6703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [6705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [6707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2668),
  [6709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [6711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [6713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [6715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7248),
  [6717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_in_expression, 3, 0, 0),
  [6719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [6721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(9038),
  [6724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [6726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [6728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(8603),
  [6731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9038),
  [6733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [6737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [6739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [6741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9290),
  [6743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [6745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [6747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [6749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [6751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [6753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1996),
  [6755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1995),
  [6757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1990),
  [6759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [6761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [6763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [6765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [6767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [6769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [6771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1983),
  [6773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1982),
  [6775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [6777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [6779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2768),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [6783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [6787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [6789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [6791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1467),
  [6793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [6795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [6797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [6801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [6803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [6805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [6807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [6809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [6811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [6813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [6815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [6817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [6819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [6821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [6823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [6827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2889),
  [6829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [6831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [6833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [6835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [6837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [6839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [6841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5122),
  [6843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [6845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [6847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [6849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [6851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [6853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8798),
  [6856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [6860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8798),
  [6862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [6864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5438),
  [6866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9127),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [6878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [6880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3668),
  [6882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [6884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5223),
  [6886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [6888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [6890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4975),
  [6892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [6894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [6896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5345),
  [6898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [6900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [6902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5371),
  [6904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(1155),
  [6907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(8569),
  [6910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [6912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [6916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [6918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [6920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [6922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [6924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_type_repeat2, 2, 0, 0), SHIFT_REPEAT(7369),
  [6927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [6933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [6937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [6939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [6943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [6945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [6947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [6949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [6951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5018),
  [6953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [6955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5000),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3656),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [6965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [6967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4873),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [6975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [6979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5330),
  [6981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [6985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [6987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [6989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [6991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [6995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(9127),
  [6998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4929),
  [7000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [7002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [7004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4937),
  [7006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [7008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [7010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [7012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2997),
  [7014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [7016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [7018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [7020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [7022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [7024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [7026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [7028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [7030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [7032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4868),
  [7034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [7036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [7038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4863),
  [7040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [7042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3418),
  [7044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [7046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [7048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [7050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [7052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1584),
  [7054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1593),
  [7056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1601),
  [7058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [7060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [7062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [7064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [7066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [7068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [7070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [7072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [7074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1647),
  [7076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [7078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [7080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [7082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [7086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [7088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [7090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1433),
  [7093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [7095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [7097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [7099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4898),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3821),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [7107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_type_repeat2, 2, 0, 0), SHIFT_REPEAT(7355),
  [7110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [7112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [7114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1559),
  [7117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [7119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [7121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [7123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [7125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_field, 1, 0, 0),
  [7127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [7129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [7131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4028),
  [7133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [7137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [7139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [7141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [7143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [7145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3588),
  [7147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3804),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [7151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [7153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [7155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9185),
  [7157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [7159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(1105),
  [7162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(8529),
  [7165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3798),
  [7167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3557),
  [7169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3876),
  [7171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [7173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [7175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [7177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [7179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [7181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4923),
  [7183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3768),
  [7185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [7187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4914),
  [7189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [7191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3534),
  [7193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9259),
  [7195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3159),
  [7197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [7199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [7201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [7203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1670),
  [7205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1671),
  [7207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [7209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [7211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [7213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1691),
  [7215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [7217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [7219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [7221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [7223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [7225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1696),
  [7227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1699),
  [7229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [7231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [7233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [7235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [7237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [7239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [7241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2975),
  [7243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [7245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [7247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5291),
  [7249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8744),
  [7251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [7253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [7255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [7257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [7259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [7261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5004),
  [7263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [7265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [7267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [7269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [7275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [7279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8744),
  [7282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [7284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [7286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6480),
  [7288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [7290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4860),
  [7292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [7294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [7296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4853),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [7300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [7304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5355),
  [7306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [7308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [7310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [7312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3286),
  [7314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3993),
  [7316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [7318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [7320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3719),
  [7324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [7326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [7330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [7334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6485),
  [7336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [7338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [7340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [7342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6656),
  [7344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5468),
  [7346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [7348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [7350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5360),
  [7352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5536),
  [7354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8852),
  [7356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9159),
  [7358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5465),
  [7360] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(8981),
  [7364] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(8981),
  [7368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(8981),
  [7371] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(8981),
  [7375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6678),
  [7377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5505),
  [7379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [7381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [7383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5108),
  [7385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5528),
  [7387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8856),
  [7389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9160),
  [7391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5500),
  [7393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(8978),
  [7396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(8981),
  [7399] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(8978),
  [7403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(8981),
  [7406] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(8978),
  [7410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(8978),
  [7413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(8978),
  [7416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(8981),
  [7419] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(8978),
  [7423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(8978),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [7432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [7434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [7436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [7440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4535),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [7444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6635),
  [7446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5585),
  [7448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [7450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [7452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5133),
  [7454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5443),
  [7456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8733),
  [7458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9109),
  [7460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5396),
  [7462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(9072),
  [7465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_type_repeat2, 2, 0, 0), SHIFT_REPEAT(7375),
  [7468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(9072),
  [7471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [7473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [7475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1732),
  [7477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [7479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [7481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1735),
  [7483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1737),
  [7485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [7487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [7489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [7491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [7493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [7495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [7497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [7499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [7501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [7503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [7505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [7507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [7509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3550),
  [7511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [7513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [7515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3541),
  [7517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [7519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4289),
  [7521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3735),
  [7523] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(9072),
  [7527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4881),
  [7529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4503),
  [7531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [7533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [7535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4878),
  [7537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4506),
  [7539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [7541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4514),
  [7543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [7545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [7547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4434),
  [7549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3403),
  [7551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [7553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1488),
  [7556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4512),
  [7558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3728),
  [7560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9138),
  [7562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [7564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(1060),
  [7567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(8485),
  [7570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8801),
  [7573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3732),
  [7575] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(9072),
  [7579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8801),
  [7581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_type_repeat2, 2, 0, 0), SHIFT_REPEAT(7216),
  [7584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3468),
  [7586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4291),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3736),
  [7590] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(9072),
  [7594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(9072),
  [7597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [7599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [7601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4296),
  [7603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3738),
  [7605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [7607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4301),
  [7609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3429),
  [7611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4980),
  [7613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [7615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [7617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4988),
  [7619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4310),
  [7621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [7623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [7625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3622),
  [7627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(9072),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [7632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [7634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [7636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [7638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [7640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_overloaded_procedure_declaration_repeat1, 2, 0, 0),
  [7642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_overloaded_procedure_declaration_repeat1, 2, 0, 0),
  [7644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8962),
  [7646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [7648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [7650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [7652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_type_repeat2, 2, 0, 0), SHIFT_REPEAT(7363),
  [7655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7363),
  [7657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8697),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7216),
  [7661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [7663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8858),
  [7665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8962),
  [7668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8697),
  [7671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3813),
  [7673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6469),
  [7675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8858),
  [7678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [7680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5348),
  [7682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5435),
  [7684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [7686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [7688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5586),
  [7690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5388),
  [7692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8902),
  [7694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9174),
  [7696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5029),
  [7698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9308),
  [7700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [7702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [7704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(8493),
  [7707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4288),
  [7709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [7711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [7713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5283),
  [7715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8834),
  [7717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4547),
  [7719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3737),
  [7721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [7723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(8534),
  [7726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [7728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [7730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5275),
  [7732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4285),
  [7734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4481),
  [7736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [7738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [7740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8687),
  [7742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9029),
  [7744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4124),
  [7746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4132),
  [7748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [7750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [7752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4224),
  [7754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4072),
  [7756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4228),
  [7758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4080),
  [7760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3786),
  [7762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [7764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5307),
  [7766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4237),
  [7768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4084),
  [7770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [7772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4249),
  [7774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [7776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4921),
  [7778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4264),
  [7780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4107),
  [7782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4920),
  [7784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4268),
  [7786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [7788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8934),
  [7790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [7792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5188),
  [7794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [7796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6669),
  [7798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5549),
  [7800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4210),
  [7802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [7804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5299),
  [7806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5463),
  [7808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8883),
  [7810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9167),
  [7812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5551),
  [7814] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(8952),
  [7818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(8952),
  [7821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(8952),
  [7824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(8952),
  [7827] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(8952),
  [7831] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(8952),
  [7835] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(8952),
  [7838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6627),
  [7840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5172),
  [7842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3752),
  [7844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [7846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5367),
  [7848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5529),
  [7850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8790),
  [7852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9139),
  [7854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5296),
  [7856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9134),
  [7858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [7860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8834),
  [7863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [7865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8795),
  [7868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8795),
  [7870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9018),
  [7872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [7874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [7876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [7878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5313),
  [7880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [7882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [7884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [7886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [7888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [7890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1943),
  [7892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [7894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [7896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [7898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5466),
  [7900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [7902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1931),
  [7904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1932),
  [7906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1933),
  [7908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [7910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [7912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [7914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [7916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [7918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [7920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [7922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [7924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1936),
  [7926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [7928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [7930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4013),
  [7932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [7934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [7936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [7938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [7940] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1526),
  [7943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [7945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3954),
  [7947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5196),
  [7949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4168),
  [7951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 0),
  [7953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [7955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [7957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [7959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [7961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [7963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1476),
  [7965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [7967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [7969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [7971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [7973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [7975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [7977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [7979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [7981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [7983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [7985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [7987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [7989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4049),
  [7991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [7993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7295),
  [7995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5006),
  [7997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5002),
  [7999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(9022),
  [8002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4799),
  [8004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5405),
  [8006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6655),
  [8008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5377),
  [8010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [8012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5315),
  [8014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5391),
  [8016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8848),
  [8018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9158),
  [8020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5381),
  [8022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(8700),
  [8025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [8027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1888),
  [8029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [8031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1886),
  [8033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [8035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [8037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [8039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [8041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1880),
  [8043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [8045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [8047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [8049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [8051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [8053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [8055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [8057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [8059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [8061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4358),
  [8063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3961),
  [8065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4352),
  [8069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [8071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [8073] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(8700),
  [8077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(8700),
  [8080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_type_repeat2, 2, 0, 0), SHIFT_REPEAT(7322),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [8085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [8087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [8089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [8091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(8700),
  [8094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(8642),
  [8097] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(8700),
  [8101] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(8700),
  [8105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(8700),
  [8108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_type_repeat2, 2, 0, 0), SHIFT_REPEAT(7295),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4216),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4222),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4070),
  [8117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(912),
  [8120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(8425),
  [8123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9078),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [8127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9022),
  [8129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4095),
  [8131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4773),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [8137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5459),
  [8139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6477),
  [8141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [8143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [8145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4449),
  [8147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [8149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [8153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [8155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [8157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [8159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2060),
  [8161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [8163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [8167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [8169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [8171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [8173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [8175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [8177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [8179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [8181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [8183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [8185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [8187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [8189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3122),
  [8191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3123),
  [8193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [8195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [8197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [8199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9309),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [8203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [8205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6648),
  [8207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5225),
  [8209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [8211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5237),
  [8213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5472),
  [8215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8880),
  [8217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9166),
  [8219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5224),
  [8221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(8955),
  [8224] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(8955),
  [8228] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(8955),
  [8232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(8955),
  [8235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(8955),
  [8238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(8955),
  [8241] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(8955),
  [8245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [8247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(2011),
  [8250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [8252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5324),
  [8254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [8256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [8258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [8260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [8262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6628),
  [8264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5303),
  [8266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [8268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [8270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5402),
  [8272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5401),
  [8274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8660),
  [8276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9053),
  [8278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5304),
  [8280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9028),
  [8282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [8284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [8286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1690),
  [8288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [8290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [8292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [8294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [8296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [8298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [8300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [8302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [8304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [8306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [8308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [8310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [8312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [8314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4553),
  [8316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4251),
  [8318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [8320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [8322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [8324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [8326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [8330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [8332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2062),
  [8334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [8336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [8338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1760),
  [8340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [8342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [8344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [8346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [8348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1784),
  [8350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [8352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [8356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9186),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [8360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6860),
  [8362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6652),
  [8364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6953),
  [8366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8750),
  [8368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8751),
  [8370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5190),
  [8372] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(4832),
  [8376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5447),
  [8378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6935),
  [8380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [8382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5513),
  [8384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5550),
  [8386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7164),
  [8388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8841),
  [8390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8753),
  [8392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9155),
  [8394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5441),
  [8396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8984),
  [8398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(4832),
  [8401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4698),
  [8403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [8405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [8407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [8409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [8411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [8413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [8415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [8417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [8419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(4832),
  [8422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [8424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [8426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(4832),
  [8429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 5, 0, 44),
  [8431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(1161),
  [8434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(8577),
  [8437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 6, 0, 58),
  [8439] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(4832),
  [8443] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(4832),
  [8447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(4832),
  [8450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 0),
  [8452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [8454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [8456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [8458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [8460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [8462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0), SHIFT(3498),
  [8465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6649),
  [8467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5230),
  [8469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [8471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5247),
  [8473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5561),
  [8475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8831),
  [8477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9152),
  [8479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5231),
  [8481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8988),
  [8483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [8485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [8487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [8489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [8491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1782),
  [8493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [8495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [8497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(8915),
  [8500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(9294),
  [8503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(9052),
  [8506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [8508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1772),
  [8510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [8512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1781),
  [8514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(9300),
  [8517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [8519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [8521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [8523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [8525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [8527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [8529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [8531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [8533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [8535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [8537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4735),
  [8539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4588),
  [8541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [8543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4737),
  [8545] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0), REDUCE(sym_array_type, 5, 0, 0), SHIFT(3498),
  [8549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6660),
  [8551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5424),
  [8553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [8555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5408),
  [8557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5339),
  [8559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8653),
  [8561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9065),
  [8563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5421),
  [8565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8908),
  [8567] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0), REDUCE(sym_array_type, 4, 0, 0), SHIFT(3498),
  [8571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 3, 0, 0), SHIFT(3498),
  [8574] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_array_type, 2, 0, 0), REDUCE(sym_array_type, 3, 0, 0), SHIFT(3498),
  [8578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [8580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [8582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 5, 0, 0), SHIFT(3498),
  [8585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [8587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(9240),
  [8590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [8592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(8985),
  [8595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [8597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [8599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [8601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [8603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1806),
  [8605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [8607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [8609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [8611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [8613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [8615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [8617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [8619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [8621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [8623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [8625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [8627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [8629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4818),
  [8631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [8633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array_type, 4, 0, 0), SHIFT(3498),
  [8636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [8638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6820),
  [8640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [8642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3760),
  [8644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [8646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2858),
  [8648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [8650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4260),
  [8652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3844),
  [8654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [8656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4172),
  [8658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [8660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [8662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [8664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [8666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [8668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [8670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [8672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [8674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [8676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [8678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [8680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [8682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [8684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6963),
  [8686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [8688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [8690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [8692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [8694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [8696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [8698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [8700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [8702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [8704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6981),
  [8706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4179),
  [8708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [8710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3530),
  [8712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [8714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [8716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [8718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4425),
  [8720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [8722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4245),
  [8724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [8726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4412),
  [8728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [8730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [8732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [8734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [8736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4272),
  [8738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [8740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [8742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3794),
  [8744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [8746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [8748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7201),
  [8750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 4, 0, 0),
  [8752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [8754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 7, 0, 0),
  [8756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [8758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 7, 0, 0),
  [8760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [8762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 6, 0, 0),
  [8764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 5, 0, 0),
  [8766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 6, 0, 0),
  [8768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 8, 0, 0),
  [8770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 5, 0, 0),
  [8772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 5, 0, 0),
  [8774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_return_statement_repeat1, 2, 0, 0),
  [8776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 3, 0, 0),
  [8778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 4, 0, 0),
  [8780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 3, 0, 0),
  [8782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_statement, 3, 0, 0),
  [8784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 6, 0, 0),
  [8786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_statement, 4, 0, 0),
  [8788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6565),
  [8790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4774),
  [8792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4905),
  [8794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4246),
  [8796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6504),
  [8798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4816),
  [8800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [8802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8981),
  [8804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3127),
  [8806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4811),
  [8808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [8810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5492),
  [8812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4903),
  [8814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3793),
  [8816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6622),
  [8818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4789),
  [8820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [8822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8952),
  [8824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2908),
  [8826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [8828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5565),
  [8830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9031),
  [8832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [8834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [8836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4917),
  [8838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [8840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4800),
  [8842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [8844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [8846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5501),
  [8848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4904),
  [8850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [8852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4857),
  [8854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [8856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7077),
  [8858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7131),
  [8860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6657),
  [8862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [8864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4861),
  [8866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4871),
  [8868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [8870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8700),
  [8872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [8874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2905),
  [8876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [8878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5503),
  [8880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5019),
  [8882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [8884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4935),
  [8886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [8888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8961),
  [8890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [8892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8958),
  [8894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4963),
  [8896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4877),
  [8898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [8900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9072),
  [8902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [8904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [8906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9050),
  [8908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4941),
  [8910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5010),
  [8912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4856),
  [8914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3703),
  [8916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [8918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5444),
  [8920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8945),
  [8922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6496),
  [8924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4896),
  [8926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [8928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4781),
  [8930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [8932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [8934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5508),
  [8936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5001),
  [8938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5015),
  [8940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [8942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8978),
  [8944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4900),
  [8946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5025),
  [8948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4984),
  [8950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4931),
  [8952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [8954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6950),
  [8956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0),
  [8958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3642),
  [8960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7034),
  [8962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4906),
  [8964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3543),
  [8966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4927),
  [8968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7197),
  [8970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [8972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [8974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4934),
  [8976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [8978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4925),
  [8980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4892),
  [8982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [8984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5021),
  [8986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8498),
  [8988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4997),
  [8990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4944),
  [8992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [8994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_const_declaration_repeat1, 2, 0, 0),
  [8996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [8998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [9000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8969),
  [9002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4855),
  [9004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4951),
  [9006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4467),
  [9008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [9010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4979),
  [9012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3763),
  [9014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [9016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3801),
  [9018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7192),
  [9020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5003),
  [9022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [9024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6665),
  [9026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4964),
  [9028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4188),
  [9030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_statement, 2, 0, 0),
  [9032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8973),
  [9034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [9036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8530),
  [9038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4880),
  [9040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [9042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4965),
  [9044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4889),
  [9046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [9048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8955),
  [9050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8604),
  [9052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4958),
  [9054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [9056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [9058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5024),
  [9060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3882),
  [9062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4977),
  [9064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7118),
  [9066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4899),
  [9068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4981),
  [9070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4882),
  [9072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4940),
  [9074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [9076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4993),
  [9078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7032),
  [9080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4966),
  [9082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4879),
  [9084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [9086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [9088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4960),
  [9090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4996),
  [9092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [9094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7051),
  [9096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [9098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [9100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5022),
  [9102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3838),
  [9104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [9106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5454),
  [9108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5008),
  [9110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4887),
  [9112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5011),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5009),
  [9116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4982),
  [9118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [9120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8947),
  [9122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4885),
  [9124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [9126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4852),
  [9128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4883),
  [9130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4924),
  [9132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5012),
  [9134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [9136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4876),
  [9138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2861),
  [9140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5584),
  [9142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [9144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4824),
  [9146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4278),
  [9148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [9150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5480),
  [9152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4832),
  [9154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5491),
  [9156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [9158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5467),
  [9160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5302),
  [9162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4776),
  [9164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [9166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [9168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5058),
  [9170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [9172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5422),
  [9174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4792),
  [9176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [9178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [9180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5163),
  [9182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [9184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5593),
  [9186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [9188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5533),
  [9190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [9192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [9194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [9196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [9198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [9200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [9202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [9204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5210),
  [9206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [9208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5320),
  [9210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4823),
  [9212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [9214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [9216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5514),
  [9218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [9220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4787),
  [9222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [9224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [9226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5587),
  [9228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4812),
  [9230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4572),
  [9232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [9234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5347),
  [9236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5062),
  [9238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5120),
  [9240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5090),
  [9242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [9244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1793),
  [9246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [9248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [9250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [9252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [9254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [9256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [9258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [9260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1871),
  [9262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [9264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [9266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [9268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [9270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [9272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [9274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [9276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [9278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5192),
  [9280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5178),
  [9282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [9284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5233),
  [9286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5246),
  [9288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5509),
  [9290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5278),
  [9292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [9294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [9296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5323),
  [9298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [9300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5289),
  [9302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5366),
  [9304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [9306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5284),
  [9308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5394),
  [9310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5312),
  [9312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [9314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5400),
  [9316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [9318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [9320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5037),
  [9322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [9324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5340),
  [9326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5156),
  [9328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [9330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5577),
  [9332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [9334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5412),
  [9336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5256),
  [9338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [9340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5327),
  [9342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5181),
  [9344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5458),
  [9346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [9348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [9350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5410),
  [9352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5219),
  [9354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [9356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5295),
  [9358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5075),
  [9360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [9362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5264),
  [9364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5392),
  [9366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5161),
  [9368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5571),
  [9370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5286),
  [9372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5413),
  [9374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5134),
  [9376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [9378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5136),
  [9380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5316),
  [9382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5032),
  [9384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5306),
  [9386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [9388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(5539),
  [9391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [9393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4652),
  [9395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [9397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4665),
  [9399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [9401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4757),
  [9403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4608),
  [9405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [9407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4270),
  [9409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [9411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [9413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [9415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4768),
  [9417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [9419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [9421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [9423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4334),
  [9425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [9427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4673),
  [9429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [9431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3874),
  [9433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [9435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4695),
  [9437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [9439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [9441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [9443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [9445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [9447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3873),
  [9449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [9451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [9453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [9455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5098),
  [9457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [9459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [9461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [9463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [9465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [9467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [9469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [9471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [9473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [9475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [9477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [9479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [9481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [9483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [9485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [9487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [9489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [9491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [9493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [9495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [9497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [9499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4829),
  [9501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [9503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3796),
  [9505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(5520),
  [9508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [9510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(5490),
  [9513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [9515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [9517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [9519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [9521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [9523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [9525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [9527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [9529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [9531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(5495),
  [9534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [9536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [9538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [9540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4347),
  [9542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [9544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [9546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [9548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5516),
  [9550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [9552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [9554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4522),
  [9556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(5512),
  [9559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4353),
  [9561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3855),
  [9563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4355),
  [9565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4356),
  [9567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_type_declaration, 6, 0, 0),
  [9569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4808),
  [9571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [9573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [9575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [9577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(5094),
  [9580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7574),
  [9582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [9584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [9586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [9588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [9590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4219),
  [9592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [9594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [9596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [9598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [9600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [9602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4418),
  [9604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [9606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(5486),
  [9609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [9611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [9613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [9615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5321),
  [9617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [9619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4258),
  [9621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [9623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [9625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [9627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4014),
  [9629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [9631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_type_declaration, 5, 0, 0),
  [9633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [9635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(5554),
  [9638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [9640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4053),
  [9642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3916),
  [9644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, 0, 0),
  [9646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [9648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [9650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [9652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [9654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4718),
  [9656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4668),
  [9658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [9660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(5567),
  [9663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4507),
  [9665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [9667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [9669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4760),
  [9671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(5481),
  [9674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4754),
  [9676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [9678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [9680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7536),
  [9682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [9684] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(5162),
  [9687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [9689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4782),
  [9691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [9693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [9695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [9697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [9699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [9701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [9703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4767),
  [9705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [9707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(5582),
  [9710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression_no_tag, 1, 0, 0), SHIFT(5563),
  [9713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [9715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [9717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [9719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [9721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1643),
  [9723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [9725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_assignment_statement, 3, 0, 0),
  [9727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [9729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [9731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1602),
  [9733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [9735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [9737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [9739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [9741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [9743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [9745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4681),
  [9747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [9749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [9751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [9753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [9755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [9757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [9759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4430),
  [9761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [9763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [9765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [9767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [9769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [9771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4654),
  [9773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [9775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [9777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [9779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1594),
  [9781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [9783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [9785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [9787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [9789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [9791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [9793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [9795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [9797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1634),
  [9799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [9801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [9803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [9805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3003),
  [9807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [9809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1542),
  [9811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3952),
  [9813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_assignment_statement, 5, 0, 0),
  [9815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [9817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [9819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [9821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [9823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1625),
  [9825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [9827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [9829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1528),
  [9831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4770),
  [9833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [9835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [9837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [9839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [9841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4406),
  [9843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [9845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1613),
  [9847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [9849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5332),
  [9851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [9853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1666),
  [9855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [9857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [9859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1562),
  [9861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [9863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [9865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [9867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4055),
  [9869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4521),
  [9871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [9873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1596),
  [9875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3193),
  [9877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [9879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [9881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [9883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [9885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [9887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [9889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [9891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [9893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [9895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [9897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [9899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [9901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4269),
  [9903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_assignment_statement, 4, 0, 0),
  [9905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [9907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [9909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [9911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [9913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1631),
  [9915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [9917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [9919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [9921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8407),
  [9923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [9925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [9927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [9929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [9931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [9933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [9935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [9937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8616),
  [9939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [9941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [9943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [9945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [9947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [9949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [9951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [9953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3594),
  [9955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8635),
  [9957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [9959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [9961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [9963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [9965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6992),
  [9967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8477),
  [9969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [9971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [9973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3726),
  [9975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8531),
  [9977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [9979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8632),
  [9981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [9983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [9985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3812),
  [9987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8633),
  [9989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [9991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [9993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [9995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [9997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [9999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [10001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [10003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3982),
  [10005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [10007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [10009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [10011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4305),
  [10013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [10015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4697),
  [10017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [10019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [10021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6942),
  [10023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8496),
  [10025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [10027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [10029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [10031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [10033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8644),
  [10035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [10037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8491),
  [10039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3799),
  [10041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8641),
  [10043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [10045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2873),
  [10047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [10049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [10051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [10053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [10055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7137),
  [10057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8507),
  [10059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [10061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [10063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [10065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [10067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [10069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4640),
  [10071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [10073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [10075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8419),
  [10077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [10079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4374),
  [10081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [10083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8550),
  [10085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [10087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [10089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [10091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [10093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [10095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [10097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4460),
  [10099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [10101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8503),
  [10103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4465),
  [10105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8469),
  [10107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [10109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [10111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [10113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [10115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4349),
  [10117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6959),
  [10119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8432),
  [10121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [10123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [10125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [10127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8486),
  [10129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [10131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4331),
  [10133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [10135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [10137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8475),
  [10139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [10141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [10143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [10145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [10147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7035),
  [10149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8445),
  [10151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [10153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_call_expression_repeat1, 2, 0, 14),
  [10155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1530),
  [10157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [10159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [10161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [10163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [10165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3937),
  [10167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [10169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8646),
  [10171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [10173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [10175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [10177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [10179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [10181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [10183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [10185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7031),
  [10187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8517),
  [10189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4708),
  [10191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [10193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [10195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4109),
  [10197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [10199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8421),
  [10201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [10203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4119),
  [10205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [10207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [10209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [10211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8528),
  [10213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [10215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [10217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8515),
  [10219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6938),
  [10221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8570),
  [10223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [10225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [10227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [10229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4103),
  [10231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [10233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [10235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [10237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [10239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [10241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [10243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [10245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [10247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8563),
  [10249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [10251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8523),
  [10253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [10255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8406),
  [10257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [10259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3551),
  [10261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7198),
  [10263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8501),
  [10265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [10267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [10269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4422),
  [10271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [10273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [10275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4479),
  [10277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [10279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [10281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [10283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [10285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [10287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8573),
  [10289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [10291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [10293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [10295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [10297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4478),
  [10299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8453),
  [10301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [10303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8423),
  [10305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [10307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [10309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [10311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [10313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [10315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [10317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8427),
  [10319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [10321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [10323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [10325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8548),
  [10327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [10329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [10331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [10333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [10335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8463),
  [10337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [10339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8460),
  [10341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [10343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [10345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4667),
  [10347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [10349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [10351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4682),
  [10353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__simple_assignment_statement_repeat1, 2, 0, 0),
  [10355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [10357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4233),
  [10359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8439),
  [10361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [10363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [10365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [10367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8440),
  [10369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [10371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [10373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [10375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8508),
  [10377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [10379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5091),
  [10381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4173),
  [10383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 11, 0, 0),
  [10385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_parameter, 3, 0, 0),
  [10387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bit_field_declaration_repeat1, 6, 0, 0),
  [10389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5251),
  [10391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [10393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5082),
  [10395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [10397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_declaration_repeat1, 4, 0, 0),
  [10399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 10, 0, 0),
  [10401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 7, 0, 0),
  [10403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5067),
  [10405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [10407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5135),
  [10409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [10411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_field, 3, 0, 0),
  [10413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 3, 0, 0),
  [10415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributes, 1, 0, 0),
  [10417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributes, 1, 0, 0),
  [10419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_in_expression, 2, 0, 0),
  [10421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5105),
  [10423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [10425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5061),
  [10427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7091),
  [10429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5205),
  [10431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [10433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5071),
  [10435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [10437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0),
  [10439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0),
  [10441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributes_repeat1, 2, 0, 0), SHIFT_REPEAT(8619),
  [10444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 6, 0, 0),
  [10446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_parameter, 4, 0, 0),
  [10448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5041),
  [10450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [10452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_case_repeat1, 2, 0, 29),
  [10454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5418),
  [10456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7251),
  [10458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5175),
  [10460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [10462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_in_expression, 4, 0, 0),
  [10464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [10466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5035),
  [10468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [10470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5086),
  [10472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [10474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 9, 0, 0),
  [10476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [10478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [10480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6869),
  [10482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5047),
  [10484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [10486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5123),
  [10488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [10490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 5, 0, 0),
  [10492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_call_expression_repeat1, 4, 0, 14),
  [10494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 8, 0, 0),
  [10496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6483),
  [10498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5572),
  [10500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [10502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5481),
  [10504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [10506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5591),
  [10508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6486),
  [10510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5582),
  [10512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5568),
  [10514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5430),
  [10516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5563),
  [10518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5338),
  [10520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5598),
  [10522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [10524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5545),
  [10526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [10528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [10530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5567),
  [10532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5539),
  [10534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [10536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [10538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4510),
  [10540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [10542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5557),
  [10544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9051),
  [10546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [10548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [10550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [10552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5554),
  [10554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5415),
  [10556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5301),
  [10558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5094),
  [10560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5520),
  [10562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [10564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3618),
  [10566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3616),
  [10568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [10570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5496),
  [10572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [10574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [10576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5173),
  [10578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [10580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5512),
  [10582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [10584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5280),
  [10586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4705),
  [10588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5495),
  [10590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4702),
  [10592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [10594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6479),
  [10596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5117),
  [10598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5144),
  [10600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [10602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [10604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [10606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [10608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5322),
  [10610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [10612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5191),
  [10614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5460),
  [10616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [10618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8851),
  [10620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5490),
  [10622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [10624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5043),
  [10626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [10628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [10630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5050),
  [10632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [10634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5319),
  [10636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4543),
  [10638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5469),
  [10640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5470),
  [10642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [10644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [10646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [10648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5486),
  [10650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5416),
  [10652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4762),
  [10654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5399),
  [10656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [10658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [10660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [10662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [10664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [10666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [10668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [10670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5407),
  [10672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5252),
  [10674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5057),
  [10676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5579),
  [10678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [10680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [10682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [10684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [10686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [10688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [10690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [10692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [10694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [10696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4067),
  [10698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [10700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5162),
  [10702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [10704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [10706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5060),
  [10708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [10710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [10712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [10714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [10716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [10718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [10720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5499),
  [10722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5119),
  [10724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [10726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [10728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [10730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [10732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [10734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [10736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [10738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [10740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [10742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [10744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [10746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5384),
  [10748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [10750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [10752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [10754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [10756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [10758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [10760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5034),
  [10762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [10764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5534),
  [10766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [10768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5068),
  [10770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [10772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [10774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5361),
  [10776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5048),
  [10778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [10780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [10782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [10784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5331),
  [10786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [10788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6484),
  [10790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5357),
  [10792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5311),
  [10794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5335),
  [10796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5033),
  [10798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5290),
  [10800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [10802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9064),
  [10804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5109),
  [10806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [10808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6481),
  [10810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5279),
  [10812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5045),
  [10814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [10816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9084),
  [10818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [10820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [10822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5476),
  [10824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7435),
  [10826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4366),
  [10828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [10830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6476),
  [10832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5059),
  [10834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4367),
  [10836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [10838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [10840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [10842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9062),
  [10844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [10846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [10848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [10850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [10852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [10854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6468),
  [10856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [10858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5083),
  [10860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5393),
  [10862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [10864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5420),
  [10866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [10868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [10870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [10872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [10874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9124),
  [10876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [10878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [10880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [10882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [10884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5176),
  [10886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [10888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [10890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [10892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [10894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6487),
  [10896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [10898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [10900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [10902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9173),
  [10904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [10906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [10908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [10910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6490),
  [10912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5121),
  [10914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [10916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9239),
  [10918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [10920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [10922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5341),
  [10924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5241),
  [10926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8927),
  [10928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [10930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5232),
  [10932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6489),
  [10934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5132),
  [10936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5202),
  [10938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [10940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9282),
  [10942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4068),
  [10944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9212),
  [10946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [10948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [10950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6478),
  [10952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [10954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5249),
  [10956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6475),
  [10958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [10960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5154),
  [10962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4330),
  [10964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [10966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [10968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [10970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6471),
  [10972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [10974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [10976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9302),
  [10978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9312),
  [10980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [10982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [10984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3921),
  [10986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [10988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [10990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5143),
  [10992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5524),
  [10994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5189),
  [10996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7512),
  [10998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5200),
  [11000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9293),
  [11002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6473),
  [11004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 7, 0, 0),
  [11006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 7, 0, 0),
  [11008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 4, 0, 0),
  [11010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, 0, 0),
  [11012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 6, 0, 0),
  [11014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 6, 0, 0),
  [11016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 5, 0, 0),
  [11018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 5, 0, 0),
  [11020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 2, 0, 0),
  [11022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 0),
  [11024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7521),
  [11026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9008),
  [11028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9009),
  [11030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7543),
  [11032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9252),
  [11034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9301),
  [11036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6920),
  [11038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7579),
  [11040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9255),
  [11042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9303),
  [11044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7475),
  [11046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9261),
  [11048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9307),
  [11050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7461),
  [11052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9249),
  [11054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9299),
  [11056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7528),
  [11058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9258),
  [11060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9305),
  [11062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7583),
  [11064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9246),
  [11066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9297),
  [11068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7095),
  [11070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_overloaded_procedure_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(1533),
  [11073] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_overloaded_procedure_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(1471),
  [11076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [11078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [11080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [11082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [11084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4912),
  [11086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [11088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5074),
  [11090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8744),
  [11092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4895),
  [11094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [11096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4936),
  [11098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4893),
  [11100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5016),
  [11102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4888),
  [11104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6545),
  [11106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5300),
  [11108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9127),
  [11110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6912),
  [11112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6667),
  [11114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3561),
  [11116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6713),
  [11118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [11120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5326),
  [11122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6615),
  [11124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [11126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5017),
  [11128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [11130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [11132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5359),
  [11134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6525),
  [11136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5036),
  [11138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6536),
  [11140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6539),
  [11142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [11144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [11146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4299),
  [11148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6530),
  [11150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [11152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4298),
  [11154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [11156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6546),
  [11158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [11160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6540),
  [11162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6524),
  [11164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [11166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [11168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6511),
  [11170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [11172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4850),
  [11174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3562),
  [11176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4897),
  [11178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4971),
  [11180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4215),
  [11182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [11184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [11186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [11188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [11190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6566),
  [11192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6571),
  [11194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5142),
  [11196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6580),
  [11198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6556),
  [11200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1450),
  [11203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5423),
  [11205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8798),
  [11207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6625),
  [11209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [11211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6560),
  [11213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6610),
  [11215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4989),
  [11217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4901),
  [11219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6612),
  [11221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1454),
  [11224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6480),
  [11226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6606),
  [11228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4942),
  [11230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6469),
  [11232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6604),
  [11234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1532),
  [11237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6607),
  [11239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4902),
  [11241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5020),
  [11243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [11245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6485),
  [11247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7172),
  [11249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6662),
  [11251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6727),
  [11253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [11255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9250),
  [11257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [11259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8971),
  [11261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6537),
  [11263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5013),
  [11265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5538),
  [11267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8834),
  [11269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [11271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4986),
  [11273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1788),
  [11275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6550),
  [11277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6527),
  [11279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6505),
  [11281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6516),
  [11283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [11285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4891),
  [11287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6983),
  [11289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6821),
  [11291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6633),
  [11293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6552),
  [11295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5298),
  [11297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4992),
  [11299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6634),
  [11301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4968),
  [11303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4952),
  [11305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4976),
  [11307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [11309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5344),
  [11311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6979),
  [11313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6687),
  [11315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4962),
  [11317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7064),
  [11319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6798),
  [11321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7212),
  [11323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6711),
  [11325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5226),
  [11327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6918),
  [11329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6644),
  [11331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4991),
  [11333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4961),
  [11335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4973),
  [11337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6688),
  [11339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6958),
  [11341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6690),
  [11343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6977),
  [11345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6829),
  [11347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4867),
  [11349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5317),
  [11351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6719),
  [11353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7039),
  [11355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6964),
  [11357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6809),
  [11359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5235),
  [11361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6702),
  [11363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6710),
  [11365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6693),
  [11367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6730),
  [11369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4869),
  [11371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6718),
  [11373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6704),
  [11375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6715),
  [11377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7337),
  [11379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6824),
  [11381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6685),
  [11383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6724),
  [11385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1518),
  [11388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6980),
  [11390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6683),
  [11392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6726),
  [11394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6728),
  [11396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5517),
  [11398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6477),
  [11400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6734),
  [11402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1725),
  [11405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6743),
  [11407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6748),
  [11409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1440),
  [11412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5363),
  [11414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [11416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5411),
  [11418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 3, 0, 0),
  [11420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [11422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 4, 0, 0),
  [11424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [11426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 7, 0, 0),
  [11428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [11430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6933),
  [11432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6844),
  [11434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [11436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6839),
  [11438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 46),
  [11440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7480),
  [11442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 32),
  [11444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 33),
  [11446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_member, 4, 0, 0),
  [11448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [11450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5473),
  [11452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 47),
  [11454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 48),
  [11456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 34),
  [11458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 32),
  [11460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 33),
  [11462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 3, 0, 0),
  [11464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 22),
  [11466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 34),
  [11468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [11470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 22),
  [11472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 46),
  [11474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_return_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(712),
  [11477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 61),
  [11479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 7, 0, 0),
  [11481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 23),
  [11483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5193),
  [11485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [11487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8697),
  [11489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 23),
  [11491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 47),
  [11493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 48),
  [11495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 8, 0, 61),
  [11497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8493),
  [11499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9001),
  [11501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_member, 3, 0, 0),
  [11503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_statement, 3, 0, 0),
  [11505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7458),
  [11507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_const_declaration_repeat1, 3, 0, 0),
  [11509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 11),
  [11511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_statement, 4, 0, 0),
  [11513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_member, 6, 0, 0),
  [11515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 6, 0, 0),
  [11517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 4, 0, 0),
  [11519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7119),
  [11521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 11),
  [11523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 5, 0, 0),
  [11525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_member, 5, 0, 0),
  [11527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 8, 0, 0),
  [11529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7592),
  [11531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 9, 0, 0),
  [11533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7441),
  [11535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8923),
  [11537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 0),
  [11539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8768),
  [11542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_when_statement_repeat1, 2, 0, 0),
  [11544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_when_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8993),
  [11547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_const_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(530),
  [11550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7322),
  [11552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [11554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8923),
  [11557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_overloaded_procedure_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(1769),
  [11560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(766),
  [11563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 8, 0, 0),
  [11565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_statement, 5, 0, 0),
  [11567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6947),
  [11569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7310),
  [11571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5398),
  [11573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6664),
  [11575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5055),
  [11577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [11579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 0),
  [11581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [11583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7013),
  [11585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7289),
  [11587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7280),
  [11589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [11591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8489),
  [11593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7276),
  [11595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5349),
  [11597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [11599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 0),
  [11601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [11603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8812),
  [11605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6464),
  [11607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9001),
  [11609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1, 0, 0),
  [11611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6986),
  [11613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 1, 0, 0),
  [11615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_overloaded_procedure_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(1756),
  [11618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7367),
  [11620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7038),
  [11622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7273),
  [11624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1, 0, 0),
  [11626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6985),
  [11628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 1, 0, 0),
  [11630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [11632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 8, 0, 18),
  [11634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 9, 0, 0),
  [11636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_overloaded_procedure_declaration, 8, 0, 0),
  [11638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit_field_declaration, 11, 0, 0),
  [11640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 52),
  [11642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_block, 3, 0, 0),
  [11644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3, 0, 0),
  [11646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7368),
  [11648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7129),
  [11650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4805),
  [11652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [11654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [11656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5417),
  [11658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_declaration, 8, 0, 0),
  [11660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8126),
  [11662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 50),
  [11664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 6, 0, 56),
  [11666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [11668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 6, 0, 0),
  [11670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7126),
  [11672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 0),
  [11674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5, 0, 18),
  [11676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 8),
  [11678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 5, 0, 43),
  [11680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4793),
  [11682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [11684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [11686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4788),
  [11688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [11690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [11692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 7, 0, 59),
  [11694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7007),
  [11696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4777),
  [11698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4266),
  [11700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [11702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_declaration, 5, 0, 0),
  [11704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5397),
  [11706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 0),
  [11708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4806),
  [11710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7135),
  [11712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [11714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [11716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [11718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defer_statement, 2, 0, 0),
  [11720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 53),
  [11722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, 0, 0),
  [11724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit_field_declaration, 12, 0, 0),
  [11726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 6, 0, 29),
  [11728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit_field_declaration, 14, 0, 0),
  [11730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 67),
  [11732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 12, 0, 0),
  [11734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 11),
  [11736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 7, 0, 66),
  [11738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 6, 0, 0),
  [11740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_overloaded_procedure_declaration, 5, 0, 0),
  [11742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 2, 0, 7),
  [11744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7098),
  [11746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, 0, 0),
  [11748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 6, 0, 3),
  [11750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7101),
  [11752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 49),
  [11754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 6, 0, 8),
  [11756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7361),
  [11758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_block, 4, 0, 0),
  [11760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7355),
  [11762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7102),
  [11764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 7, 0, 58),
  [11766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 5, 0, 56),
  [11768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 12, 0, 0),
  [11770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_declaration, 4, 0, 0),
  [11772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit_field_declaration, 7, 0, 0),
  [11774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_clause, 7, 0, 69),
  [11776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8048),
  [11778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [11780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5245),
  [11782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_block, 2, 0, 0),
  [11784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, 0, 0),
  [11786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 5, 0, 29),
  [11788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4814),
  [11790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [11792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [11794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 11, 0, 0),
  [11796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_declaration, 5, 0, 0),
  [11798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 6, 0, 44),
  [11800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 5, 0, 0),
  [11802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7313),
  [11804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5578),
  [11806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, 0, 0),
  [11808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4786),
  [11810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [11812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [11814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7377),
  [11816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_when_clause, 4, 0, 0),
  [11818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_overloaded_procedure_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(1927),
  [11821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 6, 0, 43),
  [11823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 48),
  [11825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3, 0, 3),
  [11827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_declaration, 11, 0, 0),
  [11829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4810),
  [11831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [11833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [11835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 6, 0, 59),
  [11837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 11, 0, 0),
  [11839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7917),
  [11841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [11843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 13, 0, 0),
  [11845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_clause, 5, 0, 33),
  [11847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 3, 0, 12),
  [11849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4791),
  [11851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [11853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [11855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 3, 0, 13),
  [11857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 3, 0, 11),
  [11859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 8, 0, 66),
  [11861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, 0, 29),
  [11863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 63),
  [11865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_clause, 5, 0, 32),
  [11867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 64),
  [11869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 9, 0, 0),
  [11871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8142),
  [11873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [11875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4783),
  [11877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [11879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [11881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4790),
  [11883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [11885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [11887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 8, 0, 8),
  [11889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 32),
  [11891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tagged_block, 2, 0, 0),
  [11893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 2, 0, 0),
  [11895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 33),
  [11897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 55),
  [11899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7260),
  [11901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 62),
  [11903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 4, 0, 0),
  [11905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 7, 0, 0),
  [11907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 7, 0, 3),
  [11909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7080),
  [11911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit_field_declaration, 13, 0, 0),
  [11913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 7, 0, 8),
  [11915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 7, 0, 0),
  [11917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 7, 0, 56),
  [11919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [11921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5153),
  [11923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_overloaded_procedure_declaration, 6, 0, 0),
  [11925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, 0, 0),
  [11927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 54),
  [11929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 5, 0, 29),
  [11931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [11933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(40),
  [11936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 8, 0, 48),
  [11938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_clause, 6, 0, 68),
  [11940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_clause, 6, 0, 46),
  [11942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label_statement, 3, 0, 0),
  [11944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_declaration, 6, 0, 0),
  [11946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 9, 0, 61),
  [11948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 8, 0, 47),
  [11950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7892),
  [11952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [11954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5, 0, 0),
  [11956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6957),
  [11958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7148),
  [11960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 9, 0, 18),
  [11962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_declaration, 10, 0, 0),
  [11964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5, 0, 3),
  [11966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 7, 0, 18),
  [11968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7375),
  [11970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 8, 0, 0),
  [11972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6934),
  [11974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_statement, 5, 0, 0),
  [11976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 22),
  [11978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 65),
  [11980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 10, 0, 0),
  [11982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, 0, 0),
  [11984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4803),
  [11986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [11988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [11990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_overloaded_procedure_declaration, 7, 0, 0),
  [11992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 8, 0, 0),
  [11994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 3, 0, 12),
  [11996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 8, 0, 0),
  [11998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 42),
  [12000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4813),
  [12002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [12004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [12006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 41),
  [12008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 8, 0, 46),
  [12010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 34),
  [12012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_overloaded_procedure_declaration, 9, 0, 0),
  [12014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 39),
  [12016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 4, 0, 29),
  [12018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, 0, 0),
  [12020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7369),
  [12022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 4, 0, 27),
  [12024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure_declaration, 3, 0, 0),
  [12026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 38),
  [12028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4780),
  [12030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4196),
  [12032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [12034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 33),
  [12036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 37),
  [12038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5349),
  [12040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7650),
  [12042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [12044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 34),
  [12046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 7),
  [12048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 4, 0, 22),
  [12050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4822),
  [12052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [12054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [12056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 4, 0, 26),
  [12058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 4, 0, 0),
  [12060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 36),
  [12062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 35),
  [12064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [12066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [12068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [12070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 4, 0, 24),
  [12072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 23),
  [12074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 40),
  [12076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 4, 0, 25),
  [12078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_declaration, 9, 0, 0),
  [12080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bit_field_declaration, 6, 0, 0),
  [12082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4819),
  [12084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4437),
  [12086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [12088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 51),
  [12090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_declaration, 7, 0, 0),
  [12092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 10, 0, 0),
  [12094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 4, 0, 28),
  [12096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8128),
  [12098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [12100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 4, 0, 23),
  [12102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if_clause, 4, 0, 22),
  [12104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [12106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [12108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_repeat1, 2, 0, 0),
  [12110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4948),
  [12112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [12114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3819),
  [12116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8239),
  [12118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [12120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8805),
  [12122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7729),
  [12124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7162),
  [12126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9213),
  [12128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8610),
  [12130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7150),
  [12132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [12134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [12136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5342),
  [12138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [12140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [12142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [12144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [12146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7056),
  [12148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7143),
  [12150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [12152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [12154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [12156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4930),
  [12158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [12160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [12162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [12164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4907),
  [12166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [12168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [12170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [12172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [12174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4946),
  [12176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [12178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [12180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [12182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [12184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3579),
  [12186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [12188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [12190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [12192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4939),
  [12194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [12196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [12198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [12200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [12202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6996),
  [12204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [12206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4943),
  [12208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [12210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7222),
  [12212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [12214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [12216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7725),
  [12218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_declaration_repeat1, 1, 0, 0),
  [12220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_struct_declaration_repeat1, 1, 0, 0),
  [12222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7725),
  [12224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [12226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [12228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7006),
  [12230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2882),
  [12232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5027),
  [12234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [12236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [12238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [12240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2869),
  [12242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [12244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4998),
  [12246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3783),
  [12248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7115),
  [12250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8524),
  [12252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8020),
  [12254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [12256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [12258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [12260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [12262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [12264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [12266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [12268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7090),
  [12270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3745),
  [12272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3730),
  [12274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4395),
  [12276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4866),
  [12278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8299),
  [12280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3762),
  [12282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [12284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7075),
  [12286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6470),
  [12288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7103),
  [12290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4865),
  [12292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [12294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [12296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4985),
  [12298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [12300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4915),
  [12302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4304),
  [12304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [12306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7066),
  [12308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [12310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [12312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [12314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [12316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5014),
  [12318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4171),
  [12320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4959),
  [12322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [12324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [12326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4872),
  [12328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_repeat1, 3, 0, 0),
  [12330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [12332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4307),
  [12334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7714),
  [12336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [12338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4969),
  [12340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3183),
  [12342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4864),
  [12344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4312),
  [12346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [12348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3640),
  [12350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [12352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [12354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [12356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4910),
  [12358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [12360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3314),
  [12362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [12364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4379),
  [12366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [12368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [12370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4513),
  [12372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4261),
  [12374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4851),
  [12376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [12378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7152),
  [12380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4373),
  [12382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7109),
  [12384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [12386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [12388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3731),
  [12390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7274),
  [12392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [12394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [12396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4198),
  [12398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [12400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [12402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4884),
  [12404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [12406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [12408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [12410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_polymorphic_parameters_repeat2, 6, 0, 0),
  [12412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4764),
  [12414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7431),
  [12416] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [12418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [12420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [12422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7409),
  [12424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [12426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [12428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8434),
  [12430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [12432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [12434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [12436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [12438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8586),
  [12440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [12442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5913),
  [12444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [12446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8452),
  [12448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [12450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [12452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [12454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7508),
  [12456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [12458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [12460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8597),
  [12462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [12464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [12466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_polymorphic_type_repeat1, 2, 0, 0),
  [12468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2798),
  [12470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [12472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8580),
  [12474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [12476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [12478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4755),
  [12480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [12482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5055),
  [12484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6999),
  [12486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [12488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7097),
  [12490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8448),
  [12492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [12494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [12496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_assignment_statement, 6, 0, 0),
  [12498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [12500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [12502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [12504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4108),
  [12506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7516),
  [12508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3340),
  [12510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7448),
  [12512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0),
  [12514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [12516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8417),
  [12518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [12520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3288),
  [12522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [12524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8465),
  [12526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [12528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4170),
  [12530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8449),
  [12532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [12534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_declaration_repeat1, 2, 0, 0),
  [12536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(7276),
  [12539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2849),
  [12541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7420),
  [12543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [12545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [12547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [12549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7000),
  [12551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8594),
  [12553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [12555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [12557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8529),
  [12559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [12561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3576),
  [12563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7548),
  [12565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7045),
  [12567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [12569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8564),
  [12571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [12573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8587),
  [12575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7106),
  [12577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8472),
  [12579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [12581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6472),
  [12583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6463),
  [12585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [12587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [12589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [12591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8425),
  [12593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3130),
  [12595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [12597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_union_declaration_repeat1, 2, 0, 0),
  [12599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2, 0, 0),
  [12601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [12603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_overloaded_procedure_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(2016),
  [12606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_identifier, 2, 0, 0),
  [12608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [12610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [12612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [12614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7070),
  [12616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [12618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [12620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [12622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8430),
  [12624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [12626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_members, 2, 0, 0),
  [12628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [12630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4974),
  [12632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9157),
  [12634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6971),
  [12636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [12638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8584),
  [12640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [12642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3118),
  [12644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7476),
  [12646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [12648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [12650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8483),
  [12652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [12654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0),
  [12656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(7508),
  [12659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 3, 0, 0),
  [12661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7055),
  [12663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [12665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_members, 3, 0, 0),
  [12667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4161),
  [12669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7036),
  [12671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2671),
  [12673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [12675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4061),
  [12677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2233),
  [12679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7524),
  [12681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [12683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [12685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [12687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8414),
  [12689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [12691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7180),
  [12693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_polymorphic_parameters_repeat2, 5, 0, 0),
  [12695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7161),
  [12697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3841),
  [12699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8527),
  [12701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [12703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7111),
  [12705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4556),
  [12707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7559),
  [12709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2665),
  [12711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7518),
  [12713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [12715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8485),
  [12717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [12719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [12721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3490),
  [12723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [12725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4911),
  [12727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8944),
  [12729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [12731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8576),
  [12733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [12735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [12737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8539),
  [12739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [12741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [12743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [12745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8583),
  [12747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6916),
  [12749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4439),
  [12751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [12753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8505),
  [12755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [12757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [12759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simple_assignment_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1464),
  [12762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_polymorphic_parameters_repeat2, 4, 0, 0),
  [12764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [12766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4045),
  [12768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7522),
  [12770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6967),
  [12772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_statement_repeat1, 2, 0, 0),
  [12774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(581),
  [12777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [12779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2236),
  [12781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7582),
  [12783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [12785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8451),
  [12787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [12789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [12791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8569),
  [12793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4315),
  [12795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5314),
  [12797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_repeat1, 2, 0, 0), SHIFT_REPEAT(6664),
  [12800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4391),
  [12802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7585),
  [12804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7018),
  [12806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_identifier_repeat1, 2, 0, 0),
  [12808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_identifier_repeat1, 2, 0, 0), SHIFT_REPEAT(9001),
  [12811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [12813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [12815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [12817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5194),
  [12819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7234),
  [12821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [12823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8915),
  [12825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9296),
  [12827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9300),
  [12829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [12831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8649),
  [12833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [12835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [12837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [12839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [12841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5069),
  [12843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3805),
  [12845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8640),
  [12847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [12849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [12851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3806),
  [12853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [12855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [12857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [12859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [12861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [12863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [12865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [12867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3611),
  [12869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4995),
  [12871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [12873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [12875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [12877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [12879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [12881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [12883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [12885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [12887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [12889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [12891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [12893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [12895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [12897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [12899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5261),
  [12901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [12903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9310),
  [12905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [12907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [12909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [12911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9311),
  [12913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [12915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8639),
  [12917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [12919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8624),
  [12921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [12923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8631),
  [12925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [12927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [12929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [12931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2666),
  [12933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7673),
  [12935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9272),
  [12937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9271),
  [12939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [12941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9270),
  [12943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [12945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [12947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [12949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [12951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [12953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9269),
  [12955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [12957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4063),
  [12959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8308),
  [12961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9268),
  [12963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [12965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9267),
  [12967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5243),
  [12969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9266),
  [12971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [12973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [12975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9265),
  [12977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [12979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [12981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2624),
  [12983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9264),
  [12985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [12987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5227),
  [12989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9263),
  [12991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [12993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9260),
  [12995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3802),
  [12997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9257),
  [12999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [13001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8561),
  [13003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5064),
  [13005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [13007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [13009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [13011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [13013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [13015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [13017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9254),
  [13019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [13021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9251),
  [13023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5234),
  [13025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9248),
  [13027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5244),
  [13029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [13031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [13033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9245),
  [13035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3370),
  [13037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7719),
  [13039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [13041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7980),
  [13043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [13045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [13047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [13049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8611),
  [13051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [13053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [13055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4531),
  [13057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [13059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4530),
  [13061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [13063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_polymorphic_parameters, 7, 0, 0),
  [13065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [13067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9298),
  [13069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_declaration_repeat2, 2, 0, 0),
  [13071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_declaration_repeat2, 2, 0, 0), SHIFT_REPEAT(7509),
  [13074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3287),
  [13076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [13078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [13080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9294),
  [13082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [13084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [13086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6549),
  [13088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [13090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7220),
  [13092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_repeat1, 2, 0, 0), SHIFT_REPEAT(7873),
  [13095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_repeat1, 2, 0, 0),
  [13097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7873),
  [13099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5471),
  [13101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [13103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4009),
  [13105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7982),
  [13107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4046),
  [13109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7663),
  [13111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [13113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7099),
  [13115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4393),
  [13117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7770),
  [13119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [13121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [13123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [13125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [13127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [13129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [13131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [13133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [13135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [13137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [13139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5346),
  [13141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [13143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [13145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8551),
  [13147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [13149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [13151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6462),
  [13153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4913),
  [13155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [13157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5522),
  [13159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [13161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3544),
  [13163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8643),
  [13165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4916),
  [13167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4772),
  [13169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [13171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [13173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [13175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5451),
  [13177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [13179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [13181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [13183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8625),
  [13185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5462),
  [13187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4779),
  [13189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5336),
  [13191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4313),
  [13193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8518),
  [13195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [13197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8985),
  [13199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [13201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [13203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7228),
  [13205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5305),
  [13207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [13209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [13211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [13213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [13215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5080),
  [13217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3797),
  [13219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4947),
  [13221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [13223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 2, 0, 0),
  [13225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [13227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [13229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5353),
  [13231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [13233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [13235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [13237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [13239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [13241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6515),
  [13243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [13245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [13247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [13249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [13251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7017),
  [13253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, 0, 0), SHIFT_REPEAT(8915),
  [13256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, 0, 0),
  [13258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [13260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8582),
  [13262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9253),
  [13264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [13266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8622),
  [13268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [13270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5544),
  [13272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4950),
  [13274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5358),
  [13276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [13278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [13280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [13282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [13284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [13286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9240),
  [13288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [13290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [13292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5362),
  [13294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [13296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [13298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [13300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5369),
  [13302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_expression_repeat1, 2, 0, 16), SHIFT_REPEAT(500),
  [13305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_call_expression_repeat1, 2, 0, 16),
  [13307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6506),
  [13309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [13311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [13313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [13315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [13317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [13319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [13321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [13323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [13325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [13327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [13329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [13331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5390),
  [13333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9280),
  [13335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3865),
  [13337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [13339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [13341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9276),
  [13343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [13345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8571),
  [13347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [13349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4970),
  [13351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [13353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [13355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [13357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [13359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [13361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7318),
  [13363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [13365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5126),
  [13367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [13369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5207),
  [13371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [13373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4802),
  [13375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [13377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [13379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [13381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [13383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [13385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4712),
  [13387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [13389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [13391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2865),
  [13393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4849),
  [13396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [13398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [13400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8562),
  [13402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [13404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4691),
  [13406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [13408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4690),
  [13410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(806),
  [13413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [13415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [13417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [13419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [13421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [13423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [13425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [13427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [13429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [13431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6551),
  [13433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [13435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8607),
  [13437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9188),
  [13439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8605),
  [13441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4945),
  [13443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [13445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5409),
  [13447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6948),
  [13449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [13451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [13453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [13455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8471),
  [13457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [13459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [13461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5081),
  [13463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [13465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [13467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8559),
  [13469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [13471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5507),
  [13473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3249),
  [13475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [13477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [13479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [13481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [13483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7515),
  [13485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [13487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [13489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [13491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9208),
  [13493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8557),
  [13495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5478),
  [13497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5564),
  [13499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [13501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [13503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4804),
  [13505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [13507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5257),
  [13509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6533),
  [13511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [13513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [13515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9193),
  [13517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [13519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8547),
  [13521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [13523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4388),
  [13525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [13527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [13529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [13531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8558),
  [13533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [13535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [13537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [13539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3575),
  [13541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7940),
  [13543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [13545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5206),
  [13547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5597),
  [13549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4555),
  [13551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7934),
  [13553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [13555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [13557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [13559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [13561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4499),
  [13563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [13565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [13567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [13569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [13571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [13573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [13575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3489),
  [13577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5590),
  [13579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [13581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [13583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [13585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [13587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [13589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [13591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [13593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [13595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5365),
  [13597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [13599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5287),
  [13601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5566),
  [13603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [13605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2207),
  [13607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [13609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [13611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(6568),
  [13614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, 0, 0),
  [13616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6514),
  [13618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [13620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [13622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [13624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5540),
  [13626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5308),
  [13628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [13630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7961),
  [13632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5426),
  [13634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [13636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [13638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5380),
  [13640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4827),
  [13642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_polymorphic_parameters, 8, 0, 0),
  [13644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4775),
  [13646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4163),
  [13648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5419),
  [13650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5543),
  [13652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4825),
  [13654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5595),
  [13656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2, 0, 0), SHIFT_REPEAT(8812),
  [13659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_repeat1, 2, 0, 0),
  [13661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5113),
  [13663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [13665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8512),
  [13667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4999),
  [13669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6548),
  [13671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4211),
  [13673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [13675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [13677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [13679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [13681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8435),
  [13683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3733),
  [13685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8511),
  [13687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [13689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [13691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [13693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [13695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [13697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6488),
  [13699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7003),
  [13701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [13703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3093),
  [13705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [13707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7264),
  [13709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_declaration_repeat1, 2, 0, 0),
  [13711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(7335),
  [13714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [13716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8520),
  [13718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5023),
  [13720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [13722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [13724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [13726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [13728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4369),
  [13730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7011),
  [13732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7008),
  [13734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_polymorphic_parameters, 5, 0, 0),
  [13736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [13738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [13740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4815),
  [13742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [13744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [13746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5137),
  [13748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [13750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [13752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [13754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [13756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [13758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [13760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [13762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [13764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [13766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [13768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [13770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2825),
  [13772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [13774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5552),
  [13776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [13778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [13780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [13782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [13784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4407),
  [13786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [13788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6961),
  [13790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6960),
  [13792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [13794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [13796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [13798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8513),
  [13800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6520),
  [13802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_map_repeat1, 2, 0, 0),
  [13804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_repeat1, 2, 0, 0), SHIFT_REPEAT(1421),
  [13807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [13809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [13811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5260),
  [13813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [13815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [13817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3519),
  [13819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9156),
  [13821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_case_repeat1, 2, 0, 57), SHIFT_REPEAT(686),
  [13824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_case_repeat1, 2, 0, 57),
  [13826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [13828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [13830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [13832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [13834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bit_field_declaration_repeat1, 2, 0, 0),
  [13836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bit_field_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(8914),
  [13839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [13841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7021),
  [13843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8480),
  [13845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [13847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [13849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9148),
  [13851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [13853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [13855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [13857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [13859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8504),
  [13861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [13863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4342),
  [13865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4438),
  [13867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8476),
  [13869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [13871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [13873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [13875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8494),
  [13877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4938),
  [13879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5180),
  [13881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [13883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [13885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_member_repeat1, 2, 0, 0), SHIFT_REPEAT(8557),
  [13888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_member_repeat1, 2, 0, 0),
  [13890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8617),
  [13892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [13894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [13896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5198),
  [13898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5179),
  [13900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [13902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8136),
  [13904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4421),
  [13906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [13908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [13910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [13912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [13914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [13916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [13918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [13920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [13922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8499),
  [13924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [13926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [13928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [13930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [13932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4826),
  [13934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [13936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5318),
  [13938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [13940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [13942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6519),
  [13944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [13946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4433),
  [13948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [13950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__struct_members_repeat1, 2, 0, 0),
  [13952] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__struct_members_repeat1, 2, 0, 0), SHIFT_REPEAT(8031),
  [13955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [13957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [13959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [13961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [13963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [13965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5242),
  [13967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [13969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4408),
  [13971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_type_repeat1, 1, 0, 0),
  [13973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8456),
  [13975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [13977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [13979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5515),
  [13981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4332),
  [13983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [13985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9136),
  [13987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [13989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [13991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5541),
  [13993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [13995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [13997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4785),
  [13999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9052),
  [14001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4637),
  [14003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [14005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [14007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [14009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4795),
  [14011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [14013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [14015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4716),
  [14017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [14019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [14021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8487),
  [14023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [14025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4739),
  [14027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [14029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8431),
  [14031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5155),
  [14033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4972),
  [14035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [14037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [14039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [14041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [14043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7134),
  [14045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7138),
  [14047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5157),
  [14049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9056),
  [14051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [14053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [14055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [14057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3944),
  [14059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [14061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8474),
  [14063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [14065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4678),
  [14067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [14069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [14071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [14073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7128),
  [14075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3687),
  [14077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [14079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [14081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [14083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [14085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8473),
  [14087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_declaration_repeat1, 2, 0, 0),
  [14089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [14091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4469),
  [14093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [14095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [14097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [14099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4472),
  [14101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [14103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7100),
  [14105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8450),
  [14107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7084),
  [14109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8455),
  [14111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4987),
  [14113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4918),
  [14115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(9026),
  [14118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [14120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [14122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [14124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3119),
  [14126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8007),
  [14128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [14130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6932),
  [14132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [14134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [14136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [14138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8468),
  [14140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [14142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [14144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [14146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [14148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4544),
  [14150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [14152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7236),
  [14154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [14156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [14158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5450),
  [14160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5070),
  [14162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9121),
  [14164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [14166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8560),
  [14168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [14170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4445),
  [14172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [14174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(5199),
  [14177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [14179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [14181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9117),
  [14183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4199),
  [14185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8464),
  [14187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [14189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4048),
  [14191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [14193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [14195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [14197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [14199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [14201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [14203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [14205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4193),
  [14207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4192),
  [14209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8461),
  [14211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [14213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_type_repeat1, 2, 0, 0),
  [14215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8126),
  [14218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [14220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4093),
  [14222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [14224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [14226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5049),
  [14228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_members, 1, 0, 0),
  [14230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7494),
  [14232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5046),
  [14234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [14236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [14238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [14240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [14242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4747),
  [14244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [14246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7020),
  [14248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [14250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [14252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4953),
  [14254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [14256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [14258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8436),
  [14260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [14262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4874),
  [14264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [14266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [14268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8457),
  [14270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4794),
  [14272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [14274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [14276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [14278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5386),
  [14280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [14282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [14284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4603),
  [14286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [14288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6542),
  [14290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5297),
  [14292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4807),
  [14294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [14296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2850),
  [14298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8284),
  [14300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [14302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [14304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [14306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [14308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7015),
  [14310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8447),
  [14312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_polymorphic_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(8561),
  [14315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_polymorphic_parameters_repeat1, 2, 0, 0),
  [14317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [14319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [14321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [14323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2796),
  [14325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6508),
  [14327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [14329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7012),
  [14331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [14333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [14335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4722),
  [14337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4214),
  [14339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8441),
  [14341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6465),
  [14343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [14345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4586),
  [14347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [14349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [14351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [14353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [14355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8446),
  [14357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [14359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [14361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_polymorphic_parameters, 6, 0, 0),
  [14363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [14365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [14367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4831),
  [14369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [14371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [14373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [14375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__raw_string_literal_repeat1, 2, 0, 0),
  [14377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__raw_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(8308),
  [14380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [14382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4922),
  [14384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [14386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [14388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6522),
  [14390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [14392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4248),
  [14394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8437),
  [14396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [14398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [14400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [14402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [14404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [14406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9098),
  [14408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [14410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7133),
  [14412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6974),
  [14414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7127),
  [14416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5464),
  [14418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4817),
  [14420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9055),
  [14422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9058),
  [14424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9094),
  [14426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7005),
  [14428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8420),
  [14430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3868),
  [14432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [14434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8454),
  [14436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [14438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8410),
  [14440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_polymorphic_parameters_repeat2, 2, 0, 0), SHIFT_REPEAT(8524),
  [14443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_polymorphic_parameters_repeat2, 2, 0, 0),
  [14445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3883),
  [14447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [14449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8428),
  [14451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [14453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [14455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4955),
  [14457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [14459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [14461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1432),
  [14464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [14466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8426),
  [14468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [14470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [14472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [14474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4720),
  [14476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5229),
  [14478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8568),
  [14480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [14482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8415),
  [14484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [14486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [14488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [14490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [14492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4734),
  [14494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8354),
  [14496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4105),
  [14498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [14500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [14502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [14504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4858),
  [14506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [14508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [14510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8422),
  [14512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [14514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [14516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2195),
  [14518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8389),
  [14520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [14522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9080),
  [14524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9082),
  [14526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [14528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2811),
  [14530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [14532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8862),
  [14534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5452),
  [14536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4796),
  [14538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [14540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4784),
  [14542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [14544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5148),
  [14546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_repeat2, 2, 0, 0),
  [14548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat2, 2, 0, 0), SHIFT_REPEAT(1348),
  [14551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [14553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [14555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [14557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2261),
  [14559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_polymorphic_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2393),
  [14562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [14564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [14566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [14568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [14570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [14572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [14574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [14576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8408),
  [14578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [14580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8405),
  [14582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [14584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [14586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8526),
  [14588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [14590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8967),
  [14592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [14594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [14596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8175),
  [14598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8374),
  [14600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9086),
  [14602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [14604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7004),
  [14606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8329),
  [14608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9067),
  [14610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [14612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [14614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3759),
  [14616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4404),
  [14618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [14620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4223),
  [14622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7009),
  [14624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6994),
  [14626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8321),
  [14628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9102),
  [14630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [14632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_map_repeat1, 4, 0, 0),
  [14634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [14636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4200),
  [14638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 8, 0, 0),
  [14640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4573),
  [14642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [14644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7058),
  [14646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_repeat1, 3, 0, 0),
  [14648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8211),
  [14650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9131),
  [14652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [14654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8235),
  [14656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8859),
  [14658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8139),
  [14660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9034),
  [14662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [14664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7460),
  [14666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7027),
  [14668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [14670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [14672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3751),
  [14674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [14676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9140),
  [14678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7023),
  [14680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_member_repeat1, 3, 0, 0),
  [14682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8355),
  [14684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8784),
  [14686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_polymorphic_parameters_repeat1, 3, 0, 0),
  [14688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [14690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8062),
  [14692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9176),
  [14694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7437),
  [14696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7774),
  [14698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8702),
  [14700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8655),
  [14702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8655),
  [14704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_member, 7, 0, 0),
  [14706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8534),
  [14708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [14710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [14712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8682),
  [14714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8682),
  [14716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8510),
  [14718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8968),
  [14720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [14722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [14724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8484),
  [14726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8919),
  [14728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [14730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8765),
  [14732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8765),
  [14734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7456),
  [14736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7905),
  [14738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9192),
  [14740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7811),
  [14742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9203),
  [14744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8933),
  [14746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8933),
  [14748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9057),
  [14750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9057),
  [14752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4978),
  [14754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8723),
  [14756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8792),
  [14758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8792),
  [14760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [14762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8577),
  [14764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9242),
  [14766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9242),
  [14768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7830),
  [14770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9283),
  [14772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7506),
  [14774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8482),
  [14776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8928),
  [14778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7722),
  [14780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9295),
  [14782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9019),
  [14784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9019),
  [14786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7887),
  [14788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8703),
  [14790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [14792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8918),
  [14794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8918),
  [14796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8667),
  [14798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7193),
  [14800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6466),
  [14802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9122),
  [14804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9044),
  [14806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9044),
  [14808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8606),
  [14810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [14812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8603),
  [14814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7642),
  [14816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9313),
  [14818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8824),
  [14820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8824),
  [14822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_repeat1, 4, 0, 0),
  [14824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [14826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8642),
  [14828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9020),
  [14830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9020),
  [14832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [14834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3825),
  [14836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7601),
  [14838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9304),
  [14840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [14842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8628),
  [14844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9284),
  [14846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9284),
  [14848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [14850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9306),
  [14852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5167),
  [14854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5431),
  [14856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [14858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [14860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9314),
  [14862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5183),
  [14864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5182),
  [14866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [14868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5445),
  [14870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [14872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [14874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5216),
  [14876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5044),
  [14878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5168),
  [14880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [14882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9287),
  [14884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5147),
  [14886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5166),
  [14888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [14890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5213),
  [14892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9291),
  [14894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5218),
  [14896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [14898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4309),
  [14900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [14902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5258),
  [14904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5259),
  [14906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5404),
  [14908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9198),
  [14910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9247),
  [14912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5129),
  [14914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5145),
  [14916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [14918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3688),
  [14920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [14922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5263),
  [14924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [14926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7754),
  [14928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [14930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5425),
  [14932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9181),
  [14934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5112),
  [14936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5128),
  [14938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [14940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4908),
  [14942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [14944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9132),
  [14946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5096),
  [14948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5111),
  [14950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [14952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [14954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [14956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [14958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5130),
  [14960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [14962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9104),
  [14964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5073),
  [14966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [14968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [14970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [14972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [14974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [14976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [14978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [14980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9087),
  [14982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5053),
  [14984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5072),
  [14986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [14988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [14990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [14992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [14994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [14996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [14998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7702),
  [15000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5097),
  [15002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [15004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9069),
  [15006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5039),
  [15008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5052),
  [15010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [15012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4715),
  [15014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4089),
  [15016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [15018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [15020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5079),
  [15022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7913),
  [15024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9048),
  [15026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5031),
  [15028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5038),
  [15030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [15032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8002),
  [15034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [15036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5056),
  [15038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9030),
  [15040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5063),
  [15042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5030),
  [15044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [15046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [15048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [15050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5482),
  [15052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9012),
  [15054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5076),
  [15056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5066),
  [15058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [15060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4157),
  [15062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5042),
  [15064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8996),
  [15066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5087),
  [15068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5078),
  [15070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [15072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5483),
  [15074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5088),
  [15076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [15078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5093),
  [15080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [15082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7900),
  [15084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5099),
  [15086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9092),
  [15088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5101),
  [15090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5106),
  [15092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5107),
  [15094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5114),
  [15096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [15098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5116),
  [15100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5125),
  [15102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5127),
  [15104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5152),
  [15106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [15108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [15110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5164),
  [15112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [15114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [15116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7467),
  [15118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8585),
  [15120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [15122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [15124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8525),
  [15126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6921),
  [15128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4967),
  [15130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8630),
  [15132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [15134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [15136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [15138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5428),
  [15140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5429),
  [15142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9032),
  [15144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [15146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5436),
  [15148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [15150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [15152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [15154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [15156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [15158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [15160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [15162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [15164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5171),
  [15166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8519),
  [15168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [15170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_calling_convention, 1, 0, 0),
  [15172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4956),
  [15174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [15176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [15178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [15180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [15182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [15184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7452),
  [15186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [15188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8039),
  [15190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4300),
  [15192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5262),
  [15194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [15196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [15198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7394),
  [15200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [15202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [15204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4130),
  [15206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [15208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5288),
  [15210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4329),
  [15212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5527),
  [15214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [15216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [15218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [15220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7447),
  [15222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [15224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7537),
  [15226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5548),
  [15228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [15230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [15232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [15234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [15236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [15238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [15240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [15242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5449),
  [15244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5576),
  [15246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7491),
  [15248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [15250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [15252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [15254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [15256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [15258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5594),
  [15260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [15262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [15264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [15266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [15268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5269),
  [15270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [15272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7554),
  [15274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8911),
  [15276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5575),
  [15278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [15280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [15282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [15284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [15286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [15288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [15290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5555),
  [15292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [15294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7552),
  [15296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [15298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [15300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [15302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5559),
  [15304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5546),
  [15306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [15308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [15310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [15312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [15314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5518),
  [15316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7471),
  [15318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [15320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [15322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [15324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [15326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5504),
  [15328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7312),
  [15330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [15332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [15334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7472),
  [15336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5493),
  [15338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [15340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [15342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [15344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7507),
  [15346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5487),
  [15348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [15350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [15352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [15354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [15356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5537),
  [15358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5485),
  [15360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [15362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [15364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5475),
  [15366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [15368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [15370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [15372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [15374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [15376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [15378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [15380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [15382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [15384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [15386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [15388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [15390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [15392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [15394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [15396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [15398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [15400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [15402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [15404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [15406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3536),
  [15408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [15410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7401),
  [15412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [15414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5124),
  [15416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [15418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [15420] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [15422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8482),
  [15424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [15426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [15428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5208),
  [15430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [15432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [15434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [15436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5236),
  [15438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7404),
  [15440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [15442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [15444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [15446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4167),
  [15448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [15450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [15452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5379),
  [15454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [15456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [15458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5387),
  [15460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [15462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7887),
  [15464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [15466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [15468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5433),
  [15470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [15472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [15474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5461),
  [15476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [15478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [15480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5474),
  [15482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [15484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [15486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5448),
  [15488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [15490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [15492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5028),
  [15494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [15496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [15498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5497),
  [15500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [15502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5498),
  [15504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [15506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5502),
  [15508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5510),
  [15510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5511),
  [15512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5521),
  [15514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [15516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [15518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [15520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [15522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9184),
  [15524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5523),
  [15526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7503),
  [15528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9191),
  [15530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5530),
  [15532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9196),
  [15534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5535),
  [15536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [15538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9201),
  [15540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5542),
  [15542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [15544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9206),
  [15546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5484),
  [15548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [15550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9211),
  [15552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5352),
  [15554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [15556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9216),
  [15558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9219),
  [15560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9222),
  [15562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9225),
  [15564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9228),
  [15566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9231),
  [15568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9233),
  [15570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9235),
  [15572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9236),
  [15574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9237),
  [15576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [15578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5382),
  [15580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [15582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5432),
  [15584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [15586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [15588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7787),
  [15590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [15592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7451),
  [15594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [15596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [15598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [15600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7412),
  [15602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [15604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [15606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [15608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [15610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [15612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [15614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [15616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [15618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [15620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7560),
  [15622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [15624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [15626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [15628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [15630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [15632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7422),
  [15634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [15636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [15638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__newline = 0,
  ts_external_token__backslash = 1,
  ts_external_token__nl_comma = 2,
  ts_external_token_float = 3,
  ts_external_token_block_comment = 4,
  ts_external_token_LBRACE = 5,
  ts_external_token_DQUOTE = 6,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__backslash] = sym__backslash,
  [ts_external_token__nl_comma] = sym__nl_comma,
  [ts_external_token_float] = sym_float,
  [ts_external_token_block_comment] = sym_block_comment,
  [ts_external_token_LBRACE] = anon_sym_LBRACE,
  [ts_external_token_DQUOTE] = anon_sym_DQUOTE,
};

static const bool ts_external_scanner_states[12][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__backslash] = true,
    [ts_external_token__nl_comma] = true,
    [ts_external_token_float] = true,
    [ts_external_token_block_comment] = true,
    [ts_external_token_LBRACE] = true,
    [ts_external_token_DQUOTE] = true,
  },
  [2] = {
    [ts_external_token__backslash] = true,
    [ts_external_token_float] = true,
    [ts_external_token_block_comment] = true,
    [ts_external_token_LBRACE] = true,
    [ts_external_token_DQUOTE] = true,
  },
  [3] = {
    [ts_external_token__newline] = true,
    [ts_external_token__backslash] = true,
    [ts_external_token_float] = true,
    [ts_external_token_block_comment] = true,
    [ts_external_token_LBRACE] = true,
    [ts_external_token_DQUOTE] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token__backslash] = true,
    [ts_external_token_block_comment] = true,
    [ts_external_token_LBRACE] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
    [ts_external_token__backslash] = true,
    [ts_external_token_block_comment] = true,
  },
  [6] = {
    [ts_external_token__backslash] = true,
    [ts_external_token_block_comment] = true,
    [ts_external_token_LBRACE] = true,
  },
  [7] = {
    [ts_external_token__backslash] = true,
    [ts_external_token_block_comment] = true,
  },
  [8] = {
    [ts_external_token__newline] = true,
    [ts_external_token__backslash] = true,
    [ts_external_token__nl_comma] = true,
    [ts_external_token_block_comment] = true,
    [ts_external_token_LBRACE] = true,
  },
  [9] = {
    [ts_external_token__newline] = true,
    [ts_external_token__backslash] = true,
    [ts_external_token__nl_comma] = true,
    [ts_external_token_block_comment] = true,
  },
  [10] = {
    [ts_external_token__backslash] = true,
    [ts_external_token_block_comment] = true,
    [ts_external_token_LBRACE] = true,
    [ts_external_token_DQUOTE] = true,
  },
  [11] = {
    [ts_external_token__backslash] = true,
    [ts_external_token_block_comment] = true,
    [ts_external_token_DQUOTE] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_odin_external_scanner_create(void);
void tree_sitter_odin_external_scanner_destroy(void *);
bool tree_sitter_odin_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_odin_external_scanner_serialize(void *, char *);
void tree_sitter_odin_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_odin(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_odin_external_scanner_create,
      tree_sitter_odin_external_scanner_destroy,
      tree_sitter_odin_external_scanner_scan,
      tree_sitter_odin_external_scanner_serialize,
      tree_sitter_odin_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
